!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$ $Date$
!-----------------------------------------------------------------
!     #################
      MODULE MODD_SUB_MODEL_n
!     #################
!
USE MODD_ARGSLIST_ll, ONLY : LIST_ll, HALO2LIST_ll
!
USE MODD_PARAMETERS, ONLY: JPMODELMAX
IMPLICIT NONE

TYPE SUB_MODEL_t
  TYPE(LIST_ll), POINTER :: TZFIELDS_ll,TZLSFIELD_ll,TZFIELDM_ll
                       ! list of fields to update halo
  TYPE(HALO2LIST_ll), POINTER :: TZHALO2M_ll, TZLSHALO2_ll
                       ! list of fields for the halo updates (2nd layer)
  ! halo lists and updates for 4th order schemes
! list of fields to update halo at time t
  TYPE(LIST_ll), POINTER :: TZFIELDT_ll  ! for meteorological scalars
  TYPE(LIST_ll), POINTER :: TZFIELDMT_ll ! for momentum
  TYPE(LIST_ll), POINTER :: TZFIELDSC_ll  ! for tracer scalars
! list of fields for the halo updates (2nd layer) at time t
  TYPE(HALO2LIST_ll), POINTER :: TZHALO2T_ll
  TYPE(HALO2LIST_ll), POINTER :: TZHALO2MT_ll
  TYPE(HALO2LIST_ll), POINTER :: TZHALO2SC_ll
  INTEGER :: IOUT          ! numero of the OUTPUT FM-file
!JUAN TIMING VARIABLE
  REAL,DIMENSION(2)    :: XT_START
  REAL,DIMENSION(2)    :: XT_STORE,XT_BOUND,XT_GUESS
  REAL,DIMENSION(2)    :: XT_ADV,XT_SOURCES
  REAL,DIMENSION(2)    :: XT_DIFF,XT_RELAX,XT_PARAM,XT_SPECTRA
  REAL,DIMENSION(2)    :: XT_HALO,XT_RAD_BOUND,XT_PRESS
  REAL,DIMENSION(2)    :: XT_CLOUD,XT_STEP_SWA,XT_STEP_MISC
  REAL,DIMENSION(2)    :: XT_COUPL,XT_1WAY,XT_STEP_BUD
  REAL,DIMENSION(2)    :: XT_RAD,XT_DCONV,XT_GROUND
  REAL,DIMENSION(2)    :: XT_TURB,XT_2WAY
  REAL,DIMENSION(2)    :: XT_FORCING,XT_NUDGING,XT_CHEM
!JUAN
  REAL, DIMENSION(:,:,:), POINTER :: ZWT_ACT_NUC=>NULL()
                             ! Vertical motion used for ACTivation/NUCleation
  LOGICAL, DIMENSION(:,:), POINTER :: GMASKkids=>NULL() ! kids domains mask

  LOGICAL :: GCLOSE_OUT = .FALSE. ! conditional closure of the OUTPUT FM-file
END TYPE SUB_MODEL_t

TYPE(SUB_MODEL_t), DIMENSION(JPMODELMAX), TARGET, SAVE :: SUB_MODEL_MODEL

TYPE(LIST_ll), POINTER :: TZFIELDS_ll=>NULL(),TZLSFIELD_ll=>NULL(),TZFIELDM_ll=>NULL()
TYPE(LIST_ll), POINTER :: TZFIELDT_ll=>NULL(),TZFIELDMT_ll=>NULL(),TZFIELDSC_ll=>NULL()
TYPE(HALO2LIST_ll), POINTER :: TZHALO2M_ll=>NULL(), TZLSHALO2_ll=>NULL()
TYPE(HALO2LIST_ll), POINTER :: TZHALO2T_ll=>NULL(), TZHALO2MT_ll=>NULL(), TZHALO2SC_ll=>NULL()
INTEGER, POINTER :: IOUT=>NULL()
!JUAN
REAL,DIMENSION(:), POINTER :: XT_START=>NULL()
REAL,DIMENSION(:), POINTER :: XT_STORE=>NULL(),XT_BOUND=>NULL(),XT_GUESS=>NULL()
REAL,DIMENSION(:), POINTER :: XT_ADV=>NULL(),XT_SOURCES=>NULL()
REAL,DIMENSION(:), POINTER :: XT_DIFF=>NULL(),XT_RELAX=>NULL(),XT_PARAM=>NULL(),XT_SPECTRA=>NULL()
REAL,DIMENSION(:), POINTER :: XT_HALO=>NULL(),XT_RAD_BOUND=>NULL(),XT_PRESS=>NULL()
REAL,DIMENSION(:), POINTER :: XT_CLOUD=>NULL(),XT_STEP_SWA=>NULL(),XT_STEP_MISC=>NULL()
REAL,DIMENSION(:), POINTER :: XT_COUPL=>NULL(),XT_1WAY=>NULL(),XT_STEP_BUD=>NULL()
REAL,DIMENSION(:), POINTER :: XT_RAD=>NULL(),XT_DCONV=>NULL(),XT_GROUND=>NULL()
REAL,DIMENSION(:), POINTER :: XT_TURB=>NULL(),XT_2WAY=>NULL()
REAL,DIMENSION(:), POINTER :: XT_FORCING=>NULL(),XT_NUDGING=>NULL(),XT_CHEM=>NULL()
!JUAN
REAL, DIMENSION(:,:,:), POINTER :: ZWT_ACT_NUC=>NULL()
LOGICAL, DIMENSION(:,:), POINTER :: GMASKkids=>NULL()
LOGICAL, POINTER :: GCLOSE_OUT=>NULL()

CONTAINS

SUBROUTINE SUB_MODEL_GOTO_MODEL(KFROM, KTO)
INTEGER, INTENT(IN) :: KFROM, KTO
!
! Save current state for allocated arrays
SUB_MODEL_MODEL(KFROM)%TZFIELDS_ll=>TZFIELDS_ll
SUB_MODEL_MODEL(KFROM)%TZLSFIELD_ll=>TZLSFIELD_ll
SUB_MODEL_MODEL(KFROM)%TZFIELDM_ll=>TZFIELDM_ll
SUB_MODEL_MODEL(KFROM)%TZFIELDT_ll=>TZFIELDT_ll
SUB_MODEL_MODEL(KFROM)%TZFIELDMT_ll=>TZFIELDMT_ll
SUB_MODEL_MODEL(KFROM)%TZFIELDSC_ll=>TZFIELDSC_ll
SUB_MODEL_MODEL(KFROM)%TZHALO2M_ll=>TZHALO2M_ll
SUB_MODEL_MODEL(KFROM)%TZLSHALO2_ll=>TZLSHALO2_ll
SUB_MODEL_MODEL(KFROM)%TZHALO2T_ll=>TZHALO2T_ll
SUB_MODEL_MODEL(KFROM)%TZHALO2MT_ll=>TZHALO2MT_ll
SUB_MODEL_MODEL(KFROM)%TZHALO2SC_ll=>TZHALO2SC_ll
SUB_MODEL_MODEL(KFROM)%ZWT_ACT_NUC=>ZWT_ACT_NUC
SUB_MODEL_MODEL(KFROM)%GMASKkids=>GMASKkids  
!
! Current model is set to model KTO
TZFIELDS_ll=>SUB_MODEL_MODEL(KTO)%TZFIELDS_ll
TZLSFIELD_ll=>SUB_MODEL_MODEL(KTO)%TZLSFIELD_ll
TZFIELDM_ll=>SUB_MODEL_MODEL(KTO)%TZFIELDM_ll
TZFIELDT_ll=>SUB_MODEL_MODEL(KTO)%TZFIELDT_ll
TZFIELDMT_ll=>SUB_MODEL_MODEL(KTO)%TZFIELDMT_ll
TZFIELDSC_ll=>SUB_MODEL_MODEL(KTO)%TZFIELDSC_ll
TZHALO2M_ll=>SUB_MODEL_MODEL(KTO)%TZHALO2M_ll
TZLSHALO2_ll=>SUB_MODEL_MODEL(KTO)%TZLSHALO2_ll
TZHALO2T_ll=>SUB_MODEL_MODEL(KTO)%TZHALO2T_ll
TZHALO2MT_ll=>SUB_MODEL_MODEL(KTO)%TZHALO2MT_ll
TZHALO2SC_ll=>SUB_MODEL_MODEL(KTO)%TZHALO2SC_ll
IOUT=>SUB_MODEL_MODEL(KTO)%IOUT
!JUAN
XT_START=>SUB_MODEL_MODEL(KTO)%XT_START
XT_STORE=>SUB_MODEL_MODEL(KTO)%XT_STORE
XT_BOUND=>SUB_MODEL_MODEL(KTO)%XT_BOUND
XT_GUESS=>SUB_MODEL_MODEL(KTO)%XT_GUESS
XT_ADV=>SUB_MODEL_MODEL(KTO)%XT_ADV
XT_SOURCES=>SUB_MODEL_MODEL(KTO)%XT_SOURCES
XT_DIFF=>SUB_MODEL_MODEL(KTO)%XT_DIFF
XT_RELAX=>SUB_MODEL_MODEL(KTO)%XT_RELAX
XT_PARAM=>SUB_MODEL_MODEL(KTO)%XT_PARAM
XT_SPECTRA=>SUB_MODEL_MODEL(KTO)%XT_SPECTRA
XT_HALO=>SUB_MODEL_MODEL(KTO)%XT_HALO
XT_RAD_BOUND=>SUB_MODEL_MODEL(KTO)%XT_RAD_BOUND
XT_PRESS=>SUB_MODEL_MODEL(KTO)%XT_PRESS
XT_CLOUD=>SUB_MODEL_MODEL(KTO)%XT_CLOUD
XT_STEP_SWA=>SUB_MODEL_MODEL(KTO)%XT_STEP_SWA
XT_STEP_MISC=>SUB_MODEL_MODEL(KTO)%XT_STEP_MISC
XT_COUPL=>SUB_MODEL_MODEL(KTO)%XT_COUPL
XT_1WAY=>SUB_MODEL_MODEL(KTO)%XT_1WAY
XT_STEP_BUD=>SUB_MODEL_MODEL(KTO)%XT_STEP_BUD
XT_RAD=>SUB_MODEL_MODEL(KTO)%XT_RAD
XT_DCONV=>SUB_MODEL_MODEL(KTO)%XT_DCONV
XT_GROUND=>SUB_MODEL_MODEL(KTO)%XT_GROUND
XT_TURB=>SUB_MODEL_MODEL(KTO)%XT_TURB
XT_2WAY=>SUB_MODEL_MODEL(KTO)%XT_2WAY
XT_FORCING=>SUB_MODEL_MODEL(KTO)%XT_FORCING
XT_NUDGING=>SUB_MODEL_MODEL(KTO)%XT_NUDGING
XT_CHEM=>SUB_MODEL_MODEL(KTO)%XT_CHEM
!JUAN
ZWT_ACT_NUC=>SUB_MODEL_MODEL(KTO)%ZWT_ACT_NUC
GMASKkids=>SUB_MODEL_MODEL(KTO)%GMASKkids  
GCLOSE_OUT=>SUB_MODEL_MODEL(KTO)%GCLOSE_OUT

END SUBROUTINE SUB_MODEL_GOTO_MODEL

END MODULE MODD_SUB_MODEL_n
