!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
MODULE MODD_FOREFIRE_FORTRAN_API

	USE&
        ISO_C_BINDING, ONLY: C_INT, C_DOUBLE, C_CHAR, C_NULL_CHAR
	USE MODD_NSV, ONLY: NSV_FF
	IMPLICIT NONE
	
	CHARACTER(LEN=19, KIND=C_CHAR) 	:: sCoupling = C_CHAR_'couplingResolution'//C_NULL_CHAR
	CHARACTER(LEN=9, KIND=C_CHAR) 	:: sParallel = C_CHAR_'parallel'//C_NULL_CHAR
	CHARACTER(LEN=18, KIND=C_CHAR) 	:: sNumIte = C_CHAR_'numAtmoIterations'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sOutUpdate = C_CHAR_'outputsUpdate'//C_NULL_CHAR
	CHARACTER(LEN=15, KIND=C_CHAR) 	:: s3DFlow = C_CHAR_'3DOutputs.Flow'//C_NULL_CHAR
	CHARACTER(LEN=15, KIND=C_CHAR) 	:: s3DPhys = C_CHAR_'3DOutputs.Phys'//C_NULL_CHAR
	CHARACTER(LEN=15, KIND=C_CHAR)	:: s3DChem = C_CHAR_'3DOutputs.Chem'//C_NULL_CHAR
	CHARACTER(LEN=9, KIND=C_CHAR) 	:: sAltitude = C_CHAR_'altitude'//C_NULL_CHAR
	CHARACTER(LEN=6, KIND=C_CHAR) 	:: sZgrid = C_CHAR_'ZGRID'//C_NULL_CHAR
	CHARACTER(LEN=9, KIND=C_CHAR) 	:: sNumFNMax = C_CHAR_'numFNMax'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sMNHmult = C_CHAR_'mnhMultiplier'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sPosX = C_CHAR_'FireNodesPosX'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sPosY = C_CHAR_'FireNodesPosY'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sVelX = C_CHAR_'FireNodesVelX'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sVelY = C_CHAR_'FireNodesVelY'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sTime = C_CHAR_'FireNodesTime'//C_NULL_CHAR
	CHARACTER(LEN=14, KIND=C_CHAR) 	:: sId = C_CHAR_'FireNodesId'//C_NULL_CHAR
	CHARACTER(LEN=6, KIND=C_CHAR) 	:: sWindU = C_CHAR_'windU'//C_NULL_CHAR
	CHARACTER(LEN=6, KIND=C_CHAR) 	:: sWindV = C_CHAR_'windV'//C_NULL_CHAR
	CHARACTER(LEN=11, KIND=C_CHAR) 	:: sOutWindU = C_CHAR_'outerWindU'//C_NULL_CHAR
	CHARACTER(LEN=11, KIND=C_CHAR) 	:: sOutWindV = C_CHAR_'outerWindV'//C_NULL_CHAR
	CHARACTER(LEN=2, KIND=C_CHAR) 	:: sU = C_CHAR_'U'//C_NULL_CHAR
	CHARACTER(LEN=2, KIND=C_CHAR) 	:: sV = C_CHAR_'V'//C_NULL_CHAR
	CHARACTER(LEN=2, KIND=C_CHAR) 	:: sW = C_CHAR_'W'//C_NULL_CHAR
	CHARACTER(LEN=2, KIND=C_CHAR) 	:: sT = C_CHAR_'T'//C_NULL_CHAR
	CHARACTER(LEN=2, KIND=C_CHAR) 	:: sP = C_CHAR_'P'//C_NULL_CHAR
	CHARACTER(LEN=4, KIND=C_CHAR) 	:: sTKE = C_CHAR_'TKE'//C_NULL_CHAR
	CHARACTER(LEN=6, KIND=C_CHAR) 	:: sMoist = C_CHAR_'moist'//C_NULL_CHAR
	CHARACTER(LEN=9, KIND=C_CHAR) 	:: sHeatFlux = C_CHAR_'heatFlux'//C_NULL_CHAR
	CHARACTER(LEN=10, KIND=C_CHAR) 	:: sVaporFlux = C_CHAR_'vaporFlux'//C_NULL_CHAR
	CHARACTER(LEN=7, KIND=C_CHAR), DIMENSION(:), ALLOCATABLE 	:: sScalarVariables
	CHARACTER(LEN=7, KIND=C_CHAR), DIMENSION(:), ALLOCATABLE 	:: sChemicalVariables
 
	! INTERFACES FOR THE FUNCTIONS TO BE CALLED IN C !
	!------------------------------------------------!
	
   INTERFACE

    	SUBROUTINE MNH_TO_FF_INIT(T) BIND(C, NAME='MNHInit')
			IMPORT C_DOUBLE
    		REAL(C_DOUBLE), INTENT(IN) :: T
    	END SUBROUTINE MNH_TO_FF_INIT

    	SUBROUTINE MNH_TO_FF_CREATEDOMAIN(ID, YEAR, MONTH, DAY, TIME &
    			, LAT, LON, MDIMX, MESHX, MDIMY, MESHY, MDIMZ, SIZEIN, ZGRID, DT) BIND(C, NAME='MNHCreateDomain')
			IMPORT C_INT, C_DOUBLE
    		INTEGER(C_INT), INTENT(IN) :: ID
    		INTEGER(C_INT), INTENT(IN) :: YEAR, MONTH, DAY
    		REAL(C_DOUBLE), INTENT(IN) :: TIME
    		REAL(C_DOUBLE), INTENT(IN) :: LAT, LON
    		INTEGER(C_INT), INTENT(IN) :: MDIMX, MDIMY, MDIMZ
    		REAL(C_DOUBLE), DIMENSION(MDIMX), INTENT(IN) :: MESHX
    		REAL(C_DOUBLE), DIMENSION(MDIMY), INTENT(IN) :: MESHY
    		INTEGER(C_INT), INTENT(IN) :: SIZEIN
    		REAL(C_DOUBLE), DIMENSION(SIZEIN), INTENT(IN) :: ZGRID
    		REAL(C_DOUBLE), INTENT(IN) :: DT
    	END SUBROUTINE MNH_TO_FF_CREATEDOMAIN

    	SUBROUTINE MNH_TO_FF_CHECKLAYER(LAYERNAME) BIND(C, NAME='CheckLayer')
			IMPORT C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) 	:: LAYERNAME
    	END SUBROUTINE MNH_TO_FF_CHECKLAYER

    	SUBROUTINE MNH_TO_FF_STEP(DT) BIND(C, NAME='MNHStep')
			IMPORT C_DOUBLE
    		REAL(C_DOUBLE), INTENT(IN) :: DT
    	END SUBROUTINE MNH_TO_FF_STEP

    	SUBROUTINE MNH_TO_FF_GOTO(T) BIND(C, NAME='MNHGoTo')
			IMPORT C_DOUBLE
    		REAL(C_DOUBLE), INTENT(IN) :: T
    	END SUBROUTINE MNH_TO_FF_GOTO

    	SUBROUTINE MNH_TO_FF_EXECUTECOMMAND(COMMAND) BIND(C, NAME='Execute')
			IMPORT C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: COMMAND
    	END SUBROUTINE MNH_TO_FF_EXECUTECOMMAND

    	SUBROUTINE MNH_PUT_STRING(WORD) BIND(C, NAME='FFGetString')
     		IMPORT C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: WORD
    	END SUBROUTINE MNH_PUT_STRING

    	SUBROUTINE MNH_GET_STRING(WORD) BIND(C, NAME='FFPutString')
    		IMPORT C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: WORD
    	END SUBROUTINE MNH_GET_STRING

    	SUBROUTINE MNH_PUT_INT(MNAME, M) BIND(C, NAME='FFGetInt')
    		IMPORT C_INT, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		INTEGER(C_INT), INTENT(IN) :: M
    	END SUBROUTINE MNH_PUT_INT

    	SUBROUTINE MNH_GET_INT(MNAME, M) BIND(C, NAME='FFPutInt')
    		IMPORT C_INT, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		INTEGER(C_INT), INTENT(OUT) :: M
    	END SUBROUTINE MNH_GET_INT

    	SUBROUTINE MNH_PUT_INTARRAY(MNAME, M, CURTIME, SIZEIN, SIZEOUT) BIND(C, NAME='FFGetIntArray')
    		IMPORT C_INT, C_DOUBLE, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		REAL(C_DOUBLE), INTENT(IN) :: CURTIME
    		INTEGER(C_INT), INTENT(IN) :: SIZEIN, SIZEOUT
    		INTEGER(C_INT), DIMENSION(SIZEIN), INTENT(IN) :: M
    	END SUBROUTINE MNH_PUT_INTARRAY

    	SUBROUTINE MNH_GET_INTARRAY(MNAME, M, SIZEIN, SIZEOUT) BIND(C, NAME='FFPutIntArray')
    		IMPORT C_INT, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		INTEGER(C_INT), INTENT(IN) :: SIZEIN, SIZEOUT
    		INTEGER(C_INT), DIMENSION(SIZEIN), INTENT(OUT) :: M
    	END SUBROUTINE MNH_GET_INTARRAY

    	SUBROUTINE MNH_PUT_DOUBLE(MNAME, M) BIND(C, NAME='FFGetDouble')
    		IMPORT C_DOUBLE, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		REAL(C_DOUBLE), INTENT(IN) :: M
    	END SUBROUTINE MNH_PUT_DOUBLE

    	SUBROUTINE MNH_GET_DOUBLE(MNAME, M) BIND(C, NAME='FFPutDouble')
    		IMPORT C_DOUBLE, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		REAL(C_DOUBLE), INTENT(OUT) :: M
    	END SUBROUTINE MNH_GET_DOUBLE

    	SUBROUTINE MNH_PUT_DOUBLEARRAY(MNAME, CURTIME, M, SIZEIN, SIZEOUT) BIND(C, NAME='FFGetDoubleArray')
    		IMPORT C_INT, C_DOUBLE, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		REAL(C_DOUBLE), INTENT(IN) :: CURTIME
    		INTEGER(C_INT), INTENT(IN) :: SIZEIN, SIZEOUT
    		REAL(C_DOUBLE), DIMENSION(SIZEIN), INTENT(IN) :: M
    	END SUBROUTINE MNH_PUT_DOUBLEARRAY

    	SUBROUTINE MNH_DUMP_DOUBLEARRAY(NMODEL, IP, MNAME, CURTIME, M, SIZEIN, NI, NJ, NK, SIZEOUT) BIND(C, NAME='FFDumpDoubleArray')
    		IMPORT C_INT, C_DOUBLE, C_CHAR
     		INTEGER(C_INT), INTENT(IN) :: NMODEL, IP
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		REAL(C_DOUBLE), INTENT(IN) :: CURTIME
    		INTEGER(C_INT), INTENT(IN) :: SIZEIN, NI, NJ, NK, SIZEOUT
    		REAL(C_DOUBLE), DIMENSION(SIZEIN), INTENT(IN) :: M
    	END SUBROUTINE MNH_DUMP_DOUBLEARRAY

    	SUBROUTINE MNH_GET_DOUBLEARRAY(MNAME, M, SIZEIN, SIZEOUT) BIND(C, NAME='FFPutDoubleArray')
    		IMPORT C_INT, C_DOUBLE, C_CHAR
    		CHARACTER(KIND=C_CHAR), DIMENSION(*) :: MNAME
    		INTEGER(C_INT), INTENT(IN) :: SIZEIN, SIZEOUT
    		REAL(C_DOUBLE), DIMENSION(SIZEIN), INTENT(OUT) :: M
    	END SUBROUTINE MNH_GET_DOUBLEARRAY
    	
    	FUNCTION cast_char_to_c(NAME)
    		IMPORT C_CHAR, C_NULL_CHAR
			CHARACTER (LEN=6) :: NAME
  			CHARACTER(KIND=C_CHAR, LEN=7)	:: cast_char_to_c  
    	END FUNCTION cast_char_to_c

   END INTERFACE

END MODULE MODD_FOREFIRE_FORTRAN_API
    	
FUNCTION cast_char_to_c(NAME)
   USE&
        ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
	CHARACTER (LEN=6) :: NAME
  	CHARACTER(KIND=C_CHAR, LEN=7)	:: cast_char_to_c  
	cast_char_to_c = TRIM(NAME)//C_NULL_CHAR
END FUNCTION cast_char_to_c

