!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! MASDEV4_7 diag 2006/05/18 13:07:25
!-----------------------------------------------------------------
!    ########################
     MODULE MODI_INIT_NBMOD
!    ########################
!
INTERFACE
!
     SUBROUTINE INIT_NBMOD(KLEV,KGL,KCABS,KNG1,KUABS,KINIS,KENDS, &
                 KH2O,KCO2,KO3,KCNT,KN2O,KCH4,KCO,KC11,KC12,KCFC, &
                 KCONF,KCLOUD,KOVLP,OPVOIGT,OPTDEP)
!
INTEGER, INTENT(IN) :: KLEV
INTEGER, INTENT(OUT):: KGL                ! from inprof
INTEGER, INTENT(OUT):: KCABS
INTEGER, INTENT(OUT):: KNG1
INTEGER, INTENT(OUT):: KUABS
INTEGER, INTENT(OUT):: KINIS
INTEGER, INTENT(OUT):: KENDS
INTEGER, INTENT(OUT):: KH2O
INTEGER, INTENT(OUT):: KCO2
INTEGER, INTENT(OUT):: KO3
INTEGER, INTENT(OUT):: KCNT
INTEGER, INTENT(OUT):: KN2O
INTEGER, INTENT(OUT):: KCH4
INTEGER, INTENT(OUT):: KCO
INTEGER, INTENT(OUT):: KC11
INTEGER, INTENT(OUT):: KC12
INTEGER, INTENT(OUT):: KCFC
INTEGER, INTENT(OUT):: KCONF
INTEGER, INTENT(OUT):: KCLOUD
INTEGER, INTENT(OUT):: KOVLP
LOGICAL, INTENT(OUT):: OPVOIGT           ! from implic.h, initialized in inprof
LOGICAL, INTENT(OUT):: OPTDEP
!
END SUBROUTINE INIT_NBMOD
END INTERFACE
END MODULE MODI_INIT_NBMOD 
!    #########################################################################
     SUBROUTINE INIT_NBMOD(KLEV,KGL,KCABS,KNG1,KUABS,KINIS,KENDS, &
                           KH2O,KCO2,KO3,KCNT,KN2O,KCH4,KCO,KC11,KC12,KCFC, & 
                           KCONF,KCLOUD,KOVLP,OPVOIGT,OPTDEP)
!    #########################################################################
!
!!****  *INIT_NBMOD* 
!!
!!    PURPOSE
!!    -------
!!
!!      INITIALIZE RADIATIF TRANSFER DIAGNOSTIC CODE
!!      (ABSORPTION EFFECT, STANDARD MIXING RATIO, AND SPECTROSCOPIC VALUES)
!!
!!**  METHOD
!!    ------
!!
!!    EXTERNAL
!!    --------
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE 
!!    --------- 
!! 
!!    AUTHOR 
!!    ------
!!      J.-P. Chaboureau       *L.A.*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    29/03/00
!------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_RAD_TRANSF
!
IMPLICIT NONE 
!
!*       0.1   DECLARATIONS OF DUMMY ARGUMENTS :
!
INTEGER, INTENT(IN) :: KLEV
INTEGER, INTENT(OUT):: KGL                ! from inprof
INTEGER, INTENT(OUT):: KCABS
INTEGER, INTENT(OUT):: KNG1
INTEGER, INTENT(OUT):: KUABS
INTEGER, INTENT(OUT):: KINIS
INTEGER, INTENT(OUT):: KENDS
INTEGER, INTENT(OUT):: KH2O
INTEGER, INTENT(OUT):: KCO2
INTEGER, INTENT(OUT):: KO3
INTEGER, INTENT(OUT):: KCNT
INTEGER, INTENT(OUT):: KN2O
INTEGER, INTENT(OUT):: KCH4
INTEGER, INTENT(OUT):: KCO
INTEGER, INTENT(OUT):: KC11
INTEGER, INTENT(OUT):: KC12
INTEGER, INTENT(OUT):: KCFC
INTEGER, INTENT(OUT):: KCONF
INTEGER, INTENT(OUT):: KCLOUD
INTEGER, INTENT(OUT):: KOVLP
LOGICAL, INTENT(OUT):: OPVOIGT           ! from implic.h, initialized in inprof
LOGICAL, INTENT(OUT):: OPTDEP
!
!------------------------------------------------------------------
!
!*       1.    INITIALIZATION OF VARIABLES OF MODD_RAD_TRANSF
!              ----------------------------------------------
!
NULOUT=6
NULNAM=5
NIMP=5                                   ! from suconf
!
NABS=6                                   ! from suconf
NATM=5
NATMS=1
NSPWV=0
NTMP1=0
NTEMP=1
NCH2O=1
NCCO2=1
NCO3=1
NCHAN=4
NH2O=1
NCO2=1
NO3=1
NCNT=1
NN2O=1
NCH4=1
NCO=0
NC11=0
NC12=0
NCFC=0
NO2=0
!
X1CO2=353.E-06
XN2O=310.E-09
XCO =  8.E-06
XCH4=1.72E-06
XF11=280.E-12
XF12=484.E-12
XO2 = 0.20948
XTEMP= (/ 0.,  0., 0./)
XH2O = (/ 1.,  1., 1./)
X3CO2= (/ 1.,  1., 1./)
XO3  = (/ 1.,  1., 1./)
XXLIM= (/0., 769.23, 1020.41, 1315.79, 1851.85, 2820., 0., 0., 0., 0. /)
XCLIM= (/ 330., 1350. /)
!
N_INT=20                                 ! from sucoef
NA=8
XTREF =250.00
XTPOLY=250.00
!
XALPHA=1.68E-07                          ! from suspe
XAIRM =0.028970
XH2OM =0.018
XCO2M =0.044011
XO3M  =0.048
XN2OM =0.044013
XCOM  =0.028
XCH4M =0.016043
XO2M  =0.032
XF11M =0.1373686
XF12M =0.1209140
!
XWNUTOT(:,1) = (/ 769.23, 788.64/)
XPOLPLCKTOT(:,1,1) = (/ 0.392400E+01, 0.177900E+02, 0.230001E+02, &
                       -0.182793E-01,-0.892906E+01, 0.658478E+01 /) 
XPOLPLCKTOT(:,2,1) = (/0.392400E+01, 0.177900E+02, 0.230001E+02, &
                       -0.182793E-01,-0.892906E+01,0.658478E+01 /)
XRODWALTOT(:,1,1) = (/ 0.200769E+00, 0.609645E-01, 0.254352E-01, &
                      -0.102033E-03, 0.251244E-01,-0.103565E-03 /) !H2O
XRODWALTOT(:,2,1) = (/ 0.553928E-01, 0.104472E+01, 0.358632E-01, &
                      -0.119479E-03, 0.403243E-01,-0.139687E-03 /) !CO2
XRODWALTOT(:,3,1) = (/ 0.141104E+02, 0.437543E+01, 0.510263E-02, &
                      -0.254811E-04, 0.730161E-02,-0.310516E-04 /) !O3 
XRODWALTOT(:,4,1) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !N2O
XRODWALTOT(:,5,1) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CH4
XRODWALTOT(:,6,1) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,1) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,1) = (/ 0.487608E+02, 0.386348E+01,-0.138263E-02, &
                       0.386228E-06,-0.143483E-02,-0.246933E-05 /) !NO2
!
XWNUTOT(:,2)=(/ 788.64, 809.06/)
XPOLPLCKTOT(:,1,2) = (/0.396495E+01, 0.184123E+02, 0.247733E+02, &
                       0.949690E+00,-0.999295E+01, 0.667384E+01 /)
XPOLPLCKTOT(:,2,2) = (/0.396495E+01, 0.184123E+02, 0.247733E+02, &
                       0.949690E+00,-0.999295E+01, 0.667384E+01 /)
XRODWALTOT(:,1,2) = (/ 0.390479E+00, 0.726635E-01, 0.222998E-01, &
                      -0.551255E-04, 0.235290E-01, -0.679395E-04 /) !H2O
XRODWALTOT(:,2,2) = (/ 0.112088E+00, 0.662510E+00, 0.293458E-01, &
                      -0.124139E-03, 0.303647E-01, -0.112251E-03 /) !CO2
XRODWALTOT(:,3,2) = (/ 0.505017E+01, 0.350798E+01, 0.925382E-02, &
                      -0.413190E-04, 0.116637E-01, -0.481471E-04 /) !O3 
XRODWALTOT(:,4,2) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !N2O
XRODWALTOT(:,5,2) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !CH4
XRODWALTOT(:,6,2) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !CO 
XRODWALTOT(:,7,2) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !O2 
XRODWALTOT(:,8,2) = (/ 0.461173E+02, 0.448225E+01,-0.153289E-02, &
                      -0.175937E-05,-0.149553E-02, -0.235812E-05 /) !NO2
!
XWNUTOT(:,3)=(/ 809.06,  830.57/)
XPOLPLCKTOT(:,1,3) = (/0.399569E+01, 0.190197E+02, 0.266506E+02, &
                       0.212351E+01,-0.111056E+02, 0.663388E+01 /)
XPOLPLCKTOT(:,2,3) = (/0.399569E+01, 0.190197E+02, 0.266506E+02, &
                       0.212351E+01,-0.111056E+02, 0.663388E+01 /)
XRODWALTOT(:,1,3) = (/ 0.408792E-01, 0.783193E-01, 0.235484E-01, &
                      -0.311884E-04, 0.249747E-01, -0.680719E-04 /) !H2O
XRODWALTOT(:,2,3) = (/ 0.163584E-01, 0.459360E+00, 0.348547E-01, &
                      -0.143879E-03, 0.376337E-01, -0.154425E-03 /) !CO2
XRODWALTOT(:,3,3) = (/ 0.127605E+01, 0.260281E+01, 0.149560E-01, &
                      -0.647313E-04, 0.165561E-01, -0.713699E-04 /) !O3 
XRODWALTOT(:,4,3) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !N2O
XRODWALTOT(:,5,3) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !CH4
XRODWALTOT(:,6,3) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !CO 
XRODWALTOT(:,7,3) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !O2 
XRODWALTOT(:,8,3) = (/ 0.238144E+02, 0.320993E+01,-0.289280E-03, &
                      -0.749991E-05,-0.364082E-03, -0.992013E-05 /) !NO2
!
XWNUTOT(:,4)=(/ 830.57,  853.24/)
XPOLPLCKTOT(:,1,4) = (/ 0.401471E+01, 0.196038E+02, 0.286281E+02, &
                        0.353297E+01,-0.122494E+02, 0.642945E+01 /)
XPOLPLCKTOT(:,2,4) = (/0.401471E+01, 0.196038E+02, 0.286281E+02, &
                       0.353297E+01,-0.122494E+02, 0.642945E+01 /)
XRODWALTOT(:,1,4) = (/ 0.645043E-01, 0.703965E-01, 0.271341E-01, &
                      -0.720502E-04, 0.287413E-01, -0.778617E-04 /) !H2O
XRODWALTOT(:,2,4) = (/ 0.724855E-03, 0.791495E+00, 0.467523E-01, &
                      -0.188898E-03, 0.455516E-01, -0.189847E-03 /) !CO2
XRODWALTOT(:,3,4) = (/ 0.232344E+00, 0.174732E+01, 0.214028E-01, &
                      -0.925613E-04, 0.211463E-01, -0.950528E-04 /) !O3 
XRODWALTOT(:,4,4) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !N2O
XRODWALTOT(:,5,4) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CH4
XRODWALTOT(:,6,4) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,4) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,4) = (/ 0.163686E+02, 0.294428E+01, 0.116344E-02, &
                       -0.124385E-04, 0.141033E-02, -0.159599E-04 /)  !NO2
!
XWNUTOT(:,5)=(/ 853.24,  877.19/)
XPOLPLCKTOT(:,1,5) = (/ 0.402043E+01, 0.201551E+02, 0.306984E+02, &
                        0.520988E+01,-0.133999E+02, 0.602046E+01 /)
XPOLPLCKTOT(:,2,5) = (/0.402043E+01, 0.201551E+02, 0.306984E+02, &
                       0.520988E+01,-0.133999E+02, 0.602046E+01 /)
XRODWALTOT(:,1,5) = (/ 0.293835E-01, 0.454678E-01, 0.297944E-01, &
                       -0.877540E-04, 0.326717E-01, -0.112357E-03 /) !H2O
XRODWALTOT(:,2,5) = (/ 0.386196E-03, 0.118966E+01, 0.472935E-01, &
                       -0.181049E-03, 0.487123E-01, -0.193162E-03 /) !CO2
XRODWALTOT(:,3,5) = (/ 0.288215E-01, 0.118985E+01, 0.294629E-01, &
                       -0.124242E-03, 0.283526E-01, -0.126687E-03 /) !O3 
XRODWALTOT(:,4,5) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !N2O
XRODWALTOT(:,5,5) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CH4
XRODWALTOT(:,6,5) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,5) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,5) = (/ 0.926026E+01, 0.257385E+01, 0.357499E-02, &
                       -0.221648E-04, 0.397996E-02, -0.261001E-04 /)  !NO2
!
XWNUTOT(:,6)=(/ 877.19,  902.53/)
XPOLPLCKTOT(:,1,6) = (/0.401120E+01, 0.206622E+02, 0.328500E+02, &
                       0.718739E+01,-0.145236E+02, 0.536240E+01 /)
XPOLPLCKTOT(:,2,6) = (/0.401120E+01, 0.206622E+02, 0.328500E+02, &
                       0.718739E+01,-0.145236E+02, 0.536240E+01 /)
XRODWALTOT(:,1,6) = (/ 0.318181E-01, 0.673354E-01, 0.195266E-01, &
                       -0.314524E-04, 0.241265E-01, -0.631217E-04 /) !H2O
XRODWALTOT(:,2,6) = (/ 0.368562E-03, 0.725008E+00, 0.559061E-01, &
                       -0.217702E-03, 0.558300E-01, -0.230212E-03 /) !CO2
XRODWALTOT(:,3,6) = (/ 0.180412E-02, 0.608501E+00, 0.393905E-01, &
                       -0.170013E-03, 0.374315E-01, -0.170491E-03 /) !O3 
XRODWALTOT(:,4,6) = (/ 0.238746E-02, 0.197203E+00, 0.468355E-01, &
                       -0.195370E-03, 0.459034E-01, -0.198954E-03 /) !N2O
XRODWALTOT(:,5,6) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CH4
XRODWALTOT(:,6,6) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,6) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,6) = (/ 0.502599E+01, 0.290043E+01, 0.696802E-02, &
                       -0.355035E-04, 0.737473E-02, -0.403693E-04 /)  !NO2
!
XWNUTOT(:,7)=(/ 902.53,  929.37/)
XPOLPLCKTOT(:,1,7) = (/ 0.398532E+01, 0.211127E+02, 0.350666E+02, &
                       0.949899E+01,-0.155772E+02,0.440775E+01 /)
XPOLPLCKTOT(:,2,7) = (/0.398532E+01, 0.211127E+02, 0.350666E+02, &
                       0.949899E+01,-0.155772E+02, 0.440775E+01 /)
XRODWALTOT(:,1,7) = (/ 0.292854E-01, 0.551250E-01, 0.288486E-01, &
                       -0.754247E-04, 0.332109E-01, -0.958734E-04 /) !H2O
XRODWALTOT(:,2,7) = (/ 0.408879E-02, 0.569951E+00, 0.456568E-01, &
                       -0.187562E-03, 0.466674E-01, -0.193390E-03 /) !CO2
XRODWALTOT(:,3,7) = (/ 0.681755E-03, 0.424665E+00, 0.303781E-01, &
                       0.741379E-04, 0.344417E-01, -0.331142E-04 /) !O3 
XRODWALTOT(:,4,7) = (/ 0.556165E-01, 0.335957E+00, 0.312262E-01, &
                       -0.134791E-03, 0.289321E-01, -0.134105E-03 /) !N2O
XRODWALTOT(:,5,7) = (/ 0.288564E-08, 0.300122E-04, 0.219269E-01, &
                       -0.994579E-04, 0.191439E-01, -0.955436E-04 /) !CH4
XRODWALTOT(:,6,7) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,7) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00,  0.000000E+00 /) !O2 
XRODWALTOT(:,8,7) = (/ 0.171506E+01, 0.188122E+01, 0.102688E-01, &
                       -0.487724E-04, 0.106948E-01, -0.542174E-04 /)  !NO2
!
XWNUTOT(:,8)=(/ 929.37,  957.85/)
XPOLPLCKTOT(:,1,8) = (/ 0.394110E+01, 0.214923E+02, 0.373255E+02, &
                       0.121770E+02,-0.165048E+02, 0.310738E+01 /)
XPOLPLCKTOT(:,2,8) = (/ 0.394110E+01, 0.214923E+02, 0.373255E+02, &
                       0.121770E+02,-0.165048E+02, 0.310738E+01 /)
XRODWALTOT(:,1,8) = (/ 0.147504E-01, 0.512413E-01, 0.260966E-01, &
                       -0.823818E-04, 0.281907E-01, -0.785630E-04 /) !H2O
XRODWALTOT(:,2,8) = (/ 0.398920E-01, 0.324517E+00, 0.326351E-01, &
                       -0.135596E-03, 0.342024E-01, -0.135784E-03 /) !CO2
XRODWALTOT(:,3,8) = (/ 0.150916E+00, 0.123532E+02, 0.439655E-01, &
                       -0.126353E-03, 0.447502E-01, -0.161545E-03 /) !O3 
XRODWALTOT(:,4,8) = (/0.735129E-01, 0.422952E+00, 0.276124E-01, &
                       -0.124937E-03, 0.242856E-01, -0.118386E-03 /) !N2O
XRODWALTOT(:,5,8) = (/ 0.149751E-07, 0.839076E-04, 0.165635E-01, &
                       -0.764863E-04, 0.141571E-01, -0.748519E-04 /) !CH4
XRODWALTOT(:,6,8) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00,  0.000000E+00 /) !CO 
XRODWALTOT(:,7,8) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00,  0.000000E+00 /) !O2 
XRODWALTOT(:,8,8) = (/ 0.613853E+00, 0.199806E+01, 0.150515E-01, &
                       -0.677627E-04, 0.152962E-01, -0.742659E-04 /)  !NO2
!
XWNUTOT(:,9)=(/ 957.85,  988.14/)
XPOLPLCKTOT(:,1,9) = (/ 0.387689E+01, 0.217851E+02, 0.395967E+02, &
                       0.152502E+02,-0.172367E+02, 0.141384E+01 /)
XPOLPLCKTOT(:,2,9) = (/ 0.387689E+01, 0.217851E+02, 0.395967E+02, &
                       0.152502E+02,-0.172367E+02, 0.141384E+01 /)
XRODWALTOT(:,1,9) = (/ 0.959433E-02, 0.123921E+00, 0.296198E-01, &
                       -0.882463E-04, 0.296906E-01, -0.967569E-04 /) !H2O
XRODWALTOT(:,2,9) = (/ 0.413397E-01, 0.228771E+00, 0.320258E-01, &
                       -0.136741E-03, 0.302223E-01, -0.131037E-03 /) !CO2
XRODWALTOT(:,3,9) = (/ 0.190175E+02, 0.139876E+02, 0.260713E-01, &
                       -0.101879E-03, 0.288787E-01, -0.119325E-03 /) !O3 
XRODWALTOT(:,4,9) = (/ 0.221844E-01, 0.268988E+00, 0.360742E-01, &
                       -0.150108E-03, 0.355791E-01, -0.153099E-03 /) !N2O
XRODWALTOT(:,5,9) = (/ 0.865169E-07, 0.230231E-03, 0.200451E-01, &
                       -0.601584E-04, 0.184129E-01, -0.781152E-04 /) !CH4
XRODWALTOT(:,6,9) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,9) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,9) = (/ 0.134805E+00, 0.128554E+01, 0.205164E-01, &
                       -0.916427E-04, 0.200199E-01, -0.955424E-04 /) !NO2
!
XWNUTOT(:,10)=(/ 988.14, 1020.41/)
XPOLPLCKTOT(:,1,10) = (/ 0.379113E+01, 0.219740E+02, 0.418419E+02, &
                       0.187414E+02,-0.176885E+02, -0.714246E+00 /)
XPOLPLCKTOT(:,2,10) = (/0.379113E+01, 0.219740E+02, 0.418419E+02, &
                       0.187414E+02,-0.176885E+02, -0.714246E+00 /)
XRODWALTOT(:,1,10) = (/ 0.136055E-01, 0.879974E-01, 0.328756E-01, &
                       -0.110191E-03, 0.329436E-01, -0.109120E-03 /) !H2O
XRODWALTOT(:,2,10) = (/ 0.114489E-02, 0.179961E+00, 0.496010E-01, &
                       -0.201608E-03, 0.511059E-01, -0.205893E-03 /) !CO2
XRODWALTOT(:,3,10) = (/ 0.947394E+03, 0.836579E+01, 0.516993E-02, &
                       -0.220009E-04, 0.106979E-01, -0.368482E-04 /) !O3 
XRODWALTOT(:,4,10) = (/ 0.112503E-02, 0.146973E+00, 0.399089E-01, &
                       -0.169235E-03, 0.382658E-01, -0.170419E-03 /) !N2O
XRODWALTOT(:,5,10) = (/ 0.231240E-03, 0.712033E-01, 0.414900E-01, &
                       -0.177844E-03, 0.385980E-01, -0.173217E-03 /) !CH4
XRODWALTOT(:,6,10) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,10) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,10) = (/ 0.101922E-01, 0.254603E+00, 0.258194E-01, &
                       -0.116260E-03, 0.243364E-01, -0.115352E-03 /)  !NO2
!
XWNUTOT(:,11)=(/ 1315.79, 1360.54/)
XPOLPLCKTOT(:,1,11) = (/ 0.181748E+01, 0.139985E+02, 0.398816E+02, &
                       0.445858E+02, 0.103940E+01, -0.225774E+02 /)
XPOLPLCKTOT(:,2,11) = (/ 0.181748E+01, 0.139985E+02, 0.398816E+02, &
                       0.445858E+02, 0.103940E+01, -0.225774E+02 /)
XRODWALTOT(:,1,11) = (/ 0.222086E+02, 0.128085E+00, 0.176225E-01, &
                       -0.624280E-04, 0.176623E-01, -0.616214E-04 /) !H2O
XRODWALTOT(:,2,11) = (/ 0.190818E-04, 0.121494E-02,-0.613906E-04, &
                       -0.482732E-05,-0.498627E-03, -0.531711E-05 /) !CO2
XRODWALTOT(:,3,11) = (/ 0.957071E-02, 0.111780E+01, 0.301329E-02, &
                       -0.178154E-04, 0.937194E-03, -0.181262E-04 /) !O3 
XRODWALTOT(:,4,11) = (/ 0.389465E+02, 0.540008E+00, 0.174135E-01, &
                       -0.676439E-04, 0.226415E-01, -0.813163E-04 /) !N2O
XRODWALTOT(:,5,11) = (/ 0.152512E+04, 0.379150E+00,-0.136362E-02, &
                       -0.148968E-05, 0.712522E-03, 0.101688E-04 /) !CH4
XRODWALTOT(:,6,11) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,11) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,11) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !NO2
!
XWNUTOT(:,12)=(/ 1360.54, 1428.57/)
XPOLPLCKTOT(:,1,12) = (/0.226280E+01, 0.181510E+02, 0.546328E+02, &
                       0.671879E+02, 0.850090E+01, -0.343409E+02 /)
XPOLPLCKTOT(:,2,12) = (/ 0.226280E+01, 0.181510E+02, 0.546328E+02, &
                       0.671879E+02, 0.850090E+01, -0.343409E+02 /)
XRODWALTOT(:,1,12) = (/ 0.193521E+03, 0.120796E+00, 0.892003E-02, &
                       -0.377163E-04, 0.902967E-02, -0.367956E-04 /) !H2O
XRODWALTOT(:,2,12) = (/ 0.186459E-04, 0.222895E-02,-0.150007E-04, &
                       0.206933E-05, 0.161925E-02, -0.769398E-05 /) !CO2
XRODWALTOT(:,3,12) = (/ 0.163534E+00, 0.671068E+01, 0.846156E-02, &
                       -0.120108E-04, 0.641171E-02, -0.246557E-04 /) !O3 
XRODWALTOT(:,4,12) = (/ 0.990642E-02, 0.379910E+00, 0.268587E-01, &
                       -0.116097E-03, 0.244523E-01, -0.113899E-03 /) !N2O
XRODWALTOT(:,5,12) = (/ 0.982421E+02, 0.407392E+00, 0.111276E-01, &
                       -0.464811E-04, 0.122283E-01, -0.413232E-04 /) !CH4
XRODWALTOT(:,6,12) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,12) = (/ 0.464386E-08, 0.159456E-01, 0.200348E-01, &
                       -0.791254E-04, 0.182893E-01, -0.766941E-04 /) !O2 
XRODWALTOT(:,8,12) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !NO2
!
XWNUTOT(:,13)=(/1428.57, 1470.59/)
XPOLPLCKTOT(:,1,13) = (/ 0.114193E+01, 0.952682E+01, 0.302132E+02, &
                       0.405018E+02, 0.900178E+01, -0.204260E+02 /)
XPOLPLCKTOT(:,2,13) = (/ 0.114193E+01, 0.952682E+01, 0.302132E+02, &
                       0.405018E+02, 0.900178E+01, -0.204260E+02 /)
XRODWALTOT(:,1,13) = (/ 0.490035E+03, 0.117523E+00, 0.326820E-02, &
                       -0.168602E-04, 0.366619E-02, -0.137263E-04 /) !H2O
XRODWALTOT(:,2,13) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO2
XRODWALTOT(:,3,13) = (/ 0.297159E-01, 0.185026E+01, 0.411707E-02, &
                       0.988187E-05, 0.204633E-02, -0.580397E-05 /) !O3 
XRODWALTOT(:,4,13) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !N2O
XRODWALTOT(:,5,13) = (/ 0.116314E+02, 0.744705E+00, 0.543759E-02, &
                       -0.266725E-04, 0.650713E-02, -0.206052E-04 /) !CH4
XRODWALTOT(:,6,13) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,13) = (/ 0.106734E-06, 0.547312E-01, 0.103927E-01, &
                       -0.388165E-04, 0.901944E-02, -0.384907E-04 /) !O2 
XRODWALTOT(:,8,13) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !NO2
!
XWNUTOT(:,14)=(/1470.59, 1515.15/)
XPOLPLCKTOT(:,1,14) = (/ 0.103121E+01, 0.885945E+01, 0.292118E+02, &
                       0.416771E+02, 0.122648E+02, -0.204502E+02 /)
XPOLPLCKTOT(:,2,14) = (/ 0.103121E+01, 0.885945E+01, 0.292118E+02, &
                       0.416771E+02, 0.122648E+02, -0.204502E+02 /)
XRODWALTOT(:,1,14) = (/ 0.860486E+03, 0.190606E+00, 0.173459E-02, &
                       -0.790089E-05, 0.351853E-02, -0.879271E-05 /) !H2O
XRODWALTOT(:,2,14) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO2
XRODWALTOT(:,3,14) = (/ 0.348312E-02, 0.522472E+00, 0.521576E-02, &
                       -0.310305E-04, 0.261267E-02, -0.292445E-04 /) !O3 
XRODWALTOT(:,4,14) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !N2O
XRODWALTOT(:,5,14) = (/ 0.407950E+01, 0.439389E+00,-0.160317E-03, &
                       0.424244E-05, 0.705033E-02, 0.803718E-05 /) !CH4
XRODWALTOT(:,6,14) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,14) = (/ 0.243614E-06, 0.457569E-01, 0.439822E-02, &
                       -0.169445E-04, 0.246891E-02, -0.136249E-04 /) !O2 
XRODWALTOT(:,8,14) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                       0.000000E+00, 0.000000E+00, 0.000000E+00 /) !NO2
!
XWNUTOT(:,15)=(/1515.15, 1562.50/)
XPOLPLCKTOT(:,1,15) = (/ 0.921160E+00, 0.815716E+01, 0.279898E+02, &
                         0.424911E+02, 0.156577E+02, -0.199287E+02 /)
XPOLPLCKTOT(:,2,15) = (/ 0.921160E+00, 0.815716E+01, 0.279898E+02, &
                         0.424911E+02, 0.156577E+02, -0.199287E+02 /)
XRODWALTOT(:,1,15) = (/ 0.155925E+04, 0.258844E+00,-0.473667E-04, &
                       -0.407386E-05,-0.455513E-03, -0.249263E-05 /) !H2O
XRODWALTOT(:,2,15) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO2
XRODWALTOT(:,3,15) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O3 
XRODWALTOT(:,4,15) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !N2O
XRODWALTOT(:,5,15) = (/ 0.141761E+02, 0.120867E+01, 0.351116E-02, &
                       -0.866351E-05, 0.665431E-02, -0.107109E-04 /) !CH4
XRODWALTOT(:,6,15) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,15) = (/ 0.756875E-06, 0.273422E+00, 0.300292E-02, &
                       -0.637771E-05, 0.147515E-02, -0.506638E-05 /) !O2 
XRODWALTOT(:,8,15) = (/ 0.156897E+02, 0.432773E+01, 0.292508E-01, &
                       -0.119950E-03, 0.308107E-01, -0.129760E-03  /)!NO2
!
XWNUTOT(:,16)=(/1562.50, 1626.02/)
XPOLPLCKTOT(:,1,16) = (/ 0.999692E+00, 0.916829E+01, 0.329368E+02, &
                         0.536071E+02, 0.244112E+02, -0.232299E+02 /)
XPOLPLCKTOT(:,2,16) = (/ 0.999692E+00, 0.916829E+01, 0.329368E+02, &
                        0.536071E+02, 0.244112E+02, -0.232299E+02 /)
XRODWALTOT(:,1,16) = (/ 0.493316E+03, 0.773410E-01,-0.450440E-02, &
                        0.741564E-05,-0.421509E-02, 0.144101E-04 /) !H2O
XRODWALTOT(:,2,16) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO2
XRODWALTOT(:,3,16) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O3 
XRODWALTOT(:,4,16) = (/ 0.696366E-01, 0.785609E+00, 0.171836E-01, &
                       -0.595043E-04, 0.204353E-01, -0.859200E-04 /) !N2O
XRODWALTOT(:,5,16) = (/ 0.297900E+01, 0.456212E+00,-0.271749E-03, &
                        0.121558E-04, 0.768933E-02, 0.232073E-04 /) !CH4
XRODWALTOT(:,6,16) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,16) = (/ 0.531036E-06, 0.817889E-01, 0.200942E-02, &
                       -0.705484E-05,-0.230378E-03, -0.263468E-05 /) !O2 
XRODWALTOT(:,8,16) = (/ 0.811228E+04, 0.721051E+01,-0.559074E-03, &
                        0.158229E-05, 0.231325E-02, -0.712657E-05 /) !NO2
!
XWNUTOT(:,17)=(/1626.02, 1666.67/)
XPOLPLCKTOT(:,1,17) = (/ 0.521304E+00, 0.493961E+01, 0.185122E+02, &
                         0.320627E+02, 0.171860E+02, -0.125339E+02 /)
XPOLPLCKTOT(:,2,17) = (/ 0.521304E+00, 0.493961E+01, 0.185122E+02, &
                         0.320627E+02, 0.171860E+02, -0.125339E+02 /)
XRODWALTOT(:,1,17) = (/ 0.117437E+04, 0.142935E+00,-0.330091E-02, &
                        0.397702E-05,-0.472615E-02,  0.104387E-04 /) !H2O
XRODWALTOT(:,2,17) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00,  0.000000E+00 /) !CO2
XRODWALTOT(:,3,17) = (/ 0.319361E-01, 0.182790E+01, 0.259427E-01, &
                       -0.108735E-03, 0.256678E-01, -0.118382E-03 /) !O3 
XRODWALTOT(:,4,17) = (/ 0.519333E+00, 0.114791E+01, 0.134014E-01, &
                       -0.576919E-04, 0.135095E-01, -0.608208E-04 /)  !N2O
XRODWALTOT(:,5,17) = (/ 0.315814E+01, 0.725072E+00, 0.515998E-02, &
                       -0.225399E-04, 0.834658E-02, -0.151354E-04 /) !CH4
XRODWALTOT(:,6,17) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00,  0.000000E+00 /)  !CO 
XRODWALTOT(:,7,17) = (/ 0.273071E-06, 0.598451E-01, 0.840811E-02, &
                       -0.311892E-04, 0.686272E-02, -0.301112E-04 /)  !O2 
XRODWALTOT(:,8,17) = (/ 0.611553E+04, 0.324505E+01, 0.772788E-03, &
                       -0.542155E-05, 0.360106E-02, -0.111895E-04 /)  !NO2
!
XWNUTOT(:,18)=(/1666.67, 1724.14/)
XPOLPLCKTOT(:,1,18) = (/ 0.607412E+00, 0.592531E+01, 0.230570E+02, &
                         0.421626E+02, 0.257255E+02, -0.144575E+02 /)
XPOLPLCKTOT(:,2,18) = (/ 0.607412E+00, 0.592531E+01, 0.230570E+02, &
                         0.421626E+02, 0.257255E+02, -0.144575E+02 /)
XRODWALTOT(:,1,18) = (/ 0.120027E+04, 0.188756E+00,-0.996724E-03, &
                       -0.289376E-05,-0.143419E-02, 0.555044E-08 /) !H2O
XRODWALTOT(:,2,18) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO2
XRODWALTOT(:,3,18) = (/ 0.620966E+01, 0.488638E+01, 0.686694E-03, &
                       -0.905035E-06, 0.328594E-02, -0.161612E-04 /) !O3 
XRODWALTOT(:,4,18) = (/ 0.266456E-01, 0.431381E+00, 0.116423E-01, &
                       -0.419683E-04, 0.129651E-01, -0.575972E-04 /) !N2O
XRODWALTOT(:,5,18) = (/ 0.678835E+00, 0.132425E+01, 0.163507E-01, &
                       -0.551381E-04, 0.192357E-01, -0.755255E-04 /) !CH4
XRODWALTOT(:,6,18) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !CO 
XRODWALTOT(:,7,18) = (/ 0.245820E-07, 0.345152E-01, 0.181792E-01, &
                       -0.685089E-04, 0.172508E-01, -0.701670E-04 /) !O2 
XRODWALTOT(:,8,18) = (/ 0.967109E-01, 0.180670E+00, 0.310196E-02, &
                       -0.228284E-04, 0.171902E-02, -0.230479E-04 /) !NO2
!
XWNUTOT(:,19)=(/1724.14, 1785.71/)
XPOLPLCKTOT(:,1,19) = (/ 0.512490E+00, 0.517462E+01, 0.210463E+02, &
                         0.409653E+02, 0.286559E+02, -0.112447E+02 /)
XPOLPLCKTOT(:,2,19) = (/ 0.512490E+00, 0.517462E+01, 0.210463E+02, &
                         0.409653E+02, 0.286559E+02, -0.112447E+02 /)
XRODWALTOT(:,1,19) = (/ 0.564036E+03, 0.138925E+00, 0.198712E-02, &
                       -0.642361E-05, 0.230740E-02, -0.952008E-05 /) !H2O
XRODWALTOT(:,2,19) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !CO2
XRODWALTOT(:,3,19) = (/ 0.710199E+01, 0.747582E+01,-0.564196E-03, &
                       -0.832061E-06, 0.542320E-03, -0.631976E-05 /) !O3 
XRODWALTOT(:,4,19) = (/ 0.538125E+00, 0.123348E+01,-0.137871E-03, &
                       -0.568730E-06, 0.977760E-03, -0.871703E-05 /) !N2O
XRODWALTOT(:,5,19) = (/ 0.102755E+00, 0.153444E+01, 0.288395E-01, &
                       -0.121687E-03, 0.275203E-01, -0.124037E-03 /) !CH4 
XRODWALTOT(:,6,19) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !CO
XRODWALTOT(:,7,19) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !O2 
XRODWALTOT(:,8,19) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /)  !NO2
!
XWNUTOT(:,20)=(/1785.71, 1851.85/)
XPOLPLCKTOT(:,1,20) = (/ 0.424379E+00, 0.444061E+01, 0.189012E+02, &
                         0.391774E+02, 0.311426E+02, -0.739235E+01 /)
XPOLPLCKTOT(:,2,20) = (/ 0.424379E+00, 0.444061E+01, 0.189012E+02, &
                         0.391774E+02, 0.311426E+02, -0.739235E+01 /)
XRODWALTOT(:,1,20) = (/ 0.220410E+03, 0.102331E+00, 0.273863E-02, &
                       -0.715392E-05, 0.439171E-02, -0.106484E-04 /) !H2O
XRODWALTOT(:,2,20) = (/ 0.153383E-03, 0.155823E+00, 0.309717E-01, &
                       -0.125084E-03, 0.308922E-01, -0.133072E-03 /) !CO2
XRODWALTOT(:,3,20) = (/ 0.281594E+01, 0.496382E+01,-0.530112E-03,  &
                        0.143551E-05,-0.218796E-03, -0.260006E-05 /) !O3 
XRODWALTOT(:,4,20) = (/ 0.171402E+00, 0.265026E+00, 0.115092E-01, &
                       -0.441049E-04, 0.157790E-01, -0.599133E-04 /) !N2O
XRODWALTOT(:,5,20) = (/ 0.665328E-01, 0.566394E+00, 0.305926E-01, &
                       -0.131634E-03, 0.289307E-01, -0.131770E-03 /) !CH4
XRODWALTOT(:,6,20) = (/ 0.178384E-15, 0.250016E-05, 0.961034E-01, &
                       -0.302340E-03, 0.130589E+00, -0.341828E-03 /) !CO 
XRODWALTOT(:,7,20) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00, &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !O2 
XRODWALTOT(:,8,20) = (/ 0.000000E+00, 0.000000E+00, 0.000000E+00,  &
                        0.000000E+00, 0.000000E+00, 0.000000E+00 /) !NO2
!
XRT1=(/-0.577350269, 0.577350269/)       ! from sucoef
XWG1=(/ 1.000000000, 1.000000000/)
!
!------------------------------------------------------------------
!
!*       2.    INITIALIZATION OF DUMMY ARGUMENTS
!              ---------------------------------
!
OPTDEP=.TRUE.
OPVOIGT=.FALSE.
KH2O = NH2O
KCO2 = NCO2
KO3  = NO3
KCNT = NCNT
KN2O = NN2O
KCH4 = NCH4
KCO  = NCO
KC11 = NC11
KC12 = NC12
KCFC = NCFC
KOVLP=1
KCLOUD=1
KNG1  = 2
KGL   = KLEV*(KNG1 +1)
KCABS = NABS
KUABS = NABS*2
KINIS=1
KENDS=20
KCONF=1
!------------------------------------------------------------------
!
END SUBROUTINE INIT_NBMOD
