!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! MASDEV4_7 microph 2006/05/18 13:07:25
!-----------------------------------------------------------------
!     ###########################
      MODULE MODI_LIMA_READ_XKER_GWETH
!     ###########################
!
INTERFACE
      SUBROUTINE LIMA_READ_XKER_GWETH (KWETLBDAH,KWETLBDAG,KND,                   &
                    PALPHAH,PNUH,PALPHAG,PNUG,PEHG,PBG,PCH,PDH,PCG,PDG,      &
                    PWETLBDAH_MAX,PWETLBDAG_MAX,PWETLBDAH_MIN,PWETLBDAG_MIN, &
                    PFDINFTY,PKER_GWETH                                      )
!
INTEGER, INTENT(OUT) :: KND,KWETLBDAH,KWETLBDAG
REAL,    INTENT(OUT) :: PALPHAH
REAL,    INTENT(OUT) :: PNUH
REAL,    INTENT(OUT) :: PALPHAG
REAL,    INTENT(OUT) :: PNUG
REAL,    INTENT(OUT) :: PEHG
REAL,    INTENT(OUT) :: PBG
REAL,    INTENT(OUT) :: PCH
REAL,    INTENT(OUT) :: PDH
REAL,    INTENT(OUT) :: PCG
REAL,    INTENT(OUT) :: PDG
REAL,    INTENT(OUT) :: PWETLBDAH_MAX
REAL,    INTENT(OUT) :: PWETLBDAG_MAX
REAL,    INTENT(OUT) :: PWETLBDAH_MIN
REAL,    INTENT(OUT) :: PWETLBDAG_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_GWETH 
!
END SUBROUTINE LIMA_READ_XKER_GWETH
!
END INTERFACE
!
END MODULE MODI_LIMA_READ_XKER_GWETH
!     ########################################################################
      SUBROUTINE LIMA_READ_XKER_GWETH (KWETLBDAH,KWETLBDAG,KND,                   &
                    PALPHAH,PNUH,PALPHAG,PNUG,PEHG,PBG,PCH,PDH,PCG,PDG,      &
                    PWETLBDAH_MAX,PWETLBDAG_MAX,PWETLBDAH_MIN,PWETLBDAG_MIN, &
                    PFDINFTY,PKER_GWETH                                      )
!     ########################################################################
!
!!****  * * - initialize the kernels for the graupel-hail wet growth process
!!
!!    PURPOSE
!!    -------
!!      The purpose of this routine is to initialize the kernels PKER_GWETH
!!    prepared from a previous run of the routine INI_RAIN_ICE. The reading
!!    of the kernels is optional after checking for the dimensions of the
!!    arrays.
!!
!!**  METHOD
!!    ------
!!      
!!
!!    EXTERNAL
!!    --------
!!      None
!!     
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      None
!!
!!    REFERENCE
!!    ---------
!!      Book2 of documentation ( routine READ_XKER_GWETH )
!!
!!    AUTHOR
!!    ------
!!      J.-P. Pinty      * Laboratoire d'Aerologie*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    19/04/97
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!*       0.2   Declarations of local variables :
!
!  
INTEGER, INTENT(OUT) :: KND,KWETLBDAH,KWETLBDAG
REAL,    INTENT(OUT) :: PALPHAH
REAL,    INTENT(OUT) :: PNUH
REAL,    INTENT(OUT) :: PALPHAG
REAL,    INTENT(OUT) :: PNUG
REAL,    INTENT(OUT) :: PEHG
REAL,    INTENT(OUT) :: PBG
REAL,    INTENT(OUT) :: PCH
REAL,    INTENT(OUT) :: PDH
REAL,    INTENT(OUT) :: PCG
REAL,    INTENT(OUT) :: PDG
REAL,    INTENT(OUT) :: PWETLBDAH_MAX
REAL,    INTENT(OUT) :: PWETLBDAG_MAX
REAL,    INTENT(OUT) :: PWETLBDAH_MIN
REAL,    INTENT(OUT) :: PWETLBDAG_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_GWETH 
!
! ########################################################################
! #INSERT HERE THE OUTPUT OF INI_RAIN_ICE_HAIL IF THE KERNELS ARE UPDATED#
! ########################################################################
!
KND= 50
KWETLBDAH= 40
KWETLBDAG= 40
PALPHAH= 0.100000E+01
PNUH= 0.800000E+01
PALPHAG= 0.100000E+01
PNUG= 0.100000E+01
PEHG= 0.100000E+01
PBG= 0.280000E+01
PCH= 0.201000E+03
PDH= 0.640000E+00
PCG= 0.122000E+03
PDG= 0.660000E+00
PWETLBDAH_MAX= 0.100000E+08
PWETLBDAG_MAX= 0.100000E+08
PWETLBDAH_MIN= 0.100000E+04
PWETLBDAG_MIN= 0.100000E+04
PFDINFTY= 0.200000E+02
!
IF( PRESENT(PKER_GWETH) ) THEN
PKER_GWETH(  1,  1) =  0.662921E+01
PKER_GWETH(  1,  2) =  0.722485E+01
PKER_GWETH(  1,  3) =  0.772716E+01
PKER_GWETH(  1,  4) =  0.814872E+01
PKER_GWETH(  1,  5) =  0.850191E+01
PKER_GWETH(  1,  6) =  0.879773E+01
PKER_GWETH(  1,  7) =  0.904564E+01
PKER_GWETH(  1,  8) =  0.925363E+01
PKER_GWETH(  1,  9) =  0.942835E+01
PKER_GWETH(  1, 10) =  0.957535E+01
PKER_GWETH(  1, 11) =  0.969921E+01
PKER_GWETH(  1, 12) =  0.980373E+01
PKER_GWETH(  1, 13) =  0.989205E+01
PKER_GWETH(  1, 14) =  0.996677E+01
PKER_GWETH(  1, 15) =  0.100301E+02
PKER_GWETH(  1, 16) =  0.100837E+02
PKER_GWETH(  1, 17) =  0.101293E+02
PKER_GWETH(  1, 18) =  0.101679E+02
PKER_GWETH(  1, 19) =  0.102008E+02
PKER_GWETH(  1, 20) =  0.102288E+02
PKER_GWETH(  1, 21) =  0.102526E+02
PKER_GWETH(  1, 22) =  0.102728E+02
PKER_GWETH(  1, 23) =  0.102901E+02
PKER_GWETH(  1, 24) =  0.103048E+02
PKER_GWETH(  1, 25) =  0.103173E+02
PKER_GWETH(  1, 26) =  0.103280E+02
PKER_GWETH(  1, 27) =  0.103371E+02
PKER_GWETH(  1, 28) =  0.103449E+02
PKER_GWETH(  1, 29) =  0.103515E+02
PKER_GWETH(  1, 30) =  0.103572E+02
PKER_GWETH(  1, 31) =  0.103620E+02
PKER_GWETH(  1, 32) =  0.103661E+02
PKER_GWETH(  1, 33) =  0.103696E+02
PKER_GWETH(  1, 34) =  0.103727E+02
PKER_GWETH(  1, 35) =  0.103752E+02
PKER_GWETH(  1, 36) =  0.103774E+02
PKER_GWETH(  1, 37) =  0.103793E+02
PKER_GWETH(  1, 38) =  0.103809E+02
PKER_GWETH(  1, 39) =  0.103823E+02
PKER_GWETH(  1, 40) =  0.103835E+02
PKER_GWETH(  2,  1) =  0.511505E+01
PKER_GWETH(  2,  2) =  0.571264E+01
PKER_GWETH(  2,  3) =  0.622270E+01
PKER_GWETH(  2,  4) =  0.665279E+01
PKER_GWETH(  2,  5) =  0.701373E+01
PKER_GWETH(  2,  6) =  0.731613E+01
PKER_GWETH(  2,  7) =  0.756942E+01
PKER_GWETH(  2,  8) =  0.778168E+01
PKER_GWETH(  2,  9) =  0.795975E+01
PKER_GWETH(  2, 10) =  0.810934E+01
PKER_GWETH(  2, 11) =  0.823519E+01
PKER_GWETH(  2, 12) =  0.834123E+01
PKER_GWETH(  2, 13) =  0.843071E+01
PKER_GWETH(  2, 14) =  0.850631E+01
PKER_GWETH(  2, 15) =  0.857028E+01
PKER_GWETH(  2, 16) =  0.862446E+01
PKER_GWETH(  2, 17) =  0.867039E+01
PKER_GWETH(  2, 18) =  0.870937E+01
PKER_GWETH(  2, 19) =  0.874247E+01
PKER_GWETH(  2, 20) =  0.877061E+01
PKER_GWETH(  2, 21) =  0.879454E+01
PKER_GWETH(  2, 22) =  0.881490E+01
PKER_GWETH(  2, 23) =  0.883224E+01
PKER_GWETH(  2, 24) =  0.884700E+01
PKER_GWETH(  2, 25) =  0.885958E+01
PKER_GWETH(  2, 26) =  0.887030E+01
PKER_GWETH(  2, 27) =  0.887945E+01
PKER_GWETH(  2, 28) =  0.888725E+01
PKER_GWETH(  2, 29) =  0.889390E+01
PKER_GWETH(  2, 30) =  0.889958E+01
PKER_GWETH(  2, 31) =  0.890442E+01
PKER_GWETH(  2, 32) =  0.890856E+01
PKER_GWETH(  2, 33) =  0.891209E+01
PKER_GWETH(  2, 34) =  0.891511E+01
PKER_GWETH(  2, 35) =  0.891769E+01
PKER_GWETH(  2, 36) =  0.891989E+01
PKER_GWETH(  2, 37) =  0.892177E+01
PKER_GWETH(  2, 38) =  0.892338E+01
PKER_GWETH(  2, 39) =  0.892475E+01
PKER_GWETH(  2, 40) =  0.892593E+01
PKER_GWETH(  3,  1) =  0.382811E+01
PKER_GWETH(  3,  2) =  0.441084E+01
PKER_GWETH(  3,  3) =  0.492273E+01
PKER_GWETH(  3,  4) =  0.535949E+01
PKER_GWETH(  3,  5) =  0.572774E+01
PKER_GWETH(  3,  6) =  0.603679E+01
PKER_GWETH(  3,  7) =  0.629570E+01
PKER_GWETH(  3,  8) =  0.651257E+01
PKER_GWETH(  3,  9) =  0.669430E+01
PKER_GWETH(  3, 10) =  0.684676E+01
PKER_GWETH(  3, 11) =  0.697484E+01
PKER_GWETH(  3, 12) =  0.708258E+01
PKER_GWETH(  3, 13) =  0.717337E+01
PKER_GWETH(  3, 14) =  0.724997E+01
PKER_GWETH(  3, 15) =  0.731469E+01
PKER_GWETH(  3, 16) =  0.736945E+01
PKER_GWETH(  3, 17) =  0.741583E+01
PKER_GWETH(  3, 18) =  0.745515E+01
PKER_GWETH(  3, 19) =  0.748851E+01
PKER_GWETH(  3, 20) =  0.751685E+01
PKER_GWETH(  3, 21) =  0.754093E+01
PKER_GWETH(  3, 22) =  0.756141E+01
PKER_GWETH(  3, 23) =  0.757884E+01
PKER_GWETH(  3, 24) =  0.759368E+01
PKER_GWETH(  3, 25) =  0.760631E+01
PKER_GWETH(  3, 26) =  0.761708E+01
PKER_GWETH(  3, 27) =  0.762626E+01
PKER_GWETH(  3, 28) =  0.763408E+01
PKER_GWETH(  3, 29) =  0.764076E+01
PKER_GWETH(  3, 30) =  0.764645E+01
PKER_GWETH(  3, 31) =  0.765131E+01
PKER_GWETH(  3, 32) =  0.765546E+01
PKER_GWETH(  3, 33) =  0.765900E+01
PKER_GWETH(  3, 34) =  0.766202E+01
PKER_GWETH(  3, 35) =  0.766460E+01
PKER_GWETH(  3, 36) =  0.766681E+01
PKER_GWETH(  3, 37) =  0.766869E+01
PKER_GWETH(  3, 38) =  0.767030E+01
PKER_GWETH(  3, 39) =  0.767168E+01
PKER_GWETH(  3, 40) =  0.767285E+01
PKER_GWETH(  4,  1) =  0.276960E+01
PKER_GWETH(  4,  2) =  0.330386E+01
PKER_GWETH(  4,  3) =  0.380351E+01
PKER_GWETH(  4,  4) =  0.424198E+01
PKER_GWETH(  4,  5) =  0.461597E+01
PKER_GWETH(  4,  6) =  0.493128E+01
PKER_GWETH(  4,  7) =  0.519588E+01
PKER_GWETH(  4,  8) =  0.541757E+01
PKER_GWETH(  4,  9) =  0.560325E+01
PKER_GWETH(  4, 10) =  0.575886E+01
PKER_GWETH(  4, 11) =  0.588939E+01
PKER_GWETH(  4, 12) =  0.599904E+01
PKER_GWETH(  4, 13) =  0.609129E+01
PKER_GWETH(  4, 14) =  0.616901E+01
PKER_GWETH(  4, 15) =  0.623459E+01
PKER_GWETH(  4, 16) =  0.629000E+01
PKER_GWETH(  4, 17) =  0.633687E+01
PKER_GWETH(  4, 18) =  0.637657E+01
PKER_GWETH(  4, 19) =  0.641023E+01
PKER_GWETH(  4, 20) =  0.643879E+01
PKER_GWETH(  4, 21) =  0.646304E+01
PKER_GWETH(  4, 22) =  0.648366E+01
PKER_GWETH(  4, 23) =  0.650119E+01
PKER_GWETH(  4, 24) =  0.651610E+01
PKER_GWETH(  4, 25) =  0.652880E+01
PKER_GWETH(  4, 26) =  0.653962E+01
PKER_GWETH(  4, 27) =  0.654883E+01
PKER_GWETH(  4, 28) =  0.655669E+01
PKER_GWETH(  4, 29) =  0.656338E+01
PKER_GWETH(  4, 30) =  0.656910E+01
PKER_GWETH(  4, 31) =  0.657397E+01
PKER_GWETH(  4, 32) =  0.657813E+01
PKER_GWETH(  4, 33) =  0.658168E+01
PKER_GWETH(  4, 34) =  0.658471E+01
PKER_GWETH(  4, 35) =  0.658729E+01
PKER_GWETH(  4, 36) =  0.658950E+01
PKER_GWETH(  4, 37) =  0.659139E+01
PKER_GWETH(  4, 38) =  0.659300E+01
PKER_GWETH(  4, 39) =  0.659438E+01
PKER_GWETH(  4, 40) =  0.659556E+01
PKER_GWETH(  5,  1) =  0.195940E+01
PKER_GWETH(  5,  2) =  0.239226E+01
PKER_GWETH(  5,  3) =  0.285134E+01
PKER_GWETH(  5,  4) =  0.327973E+01
PKER_GWETH(  5,  5) =  0.365531E+01
PKER_GWETH(  5,  6) =  0.397556E+01
PKER_GWETH(  5,  7) =  0.424553E+01
PKER_GWETH(  5,  8) =  0.447209E+01
PKER_GWETH(  5,  9) =  0.466190E+01
PKER_GWETH(  5, 10) =  0.482088E+01
PKER_GWETH(  5, 11) =  0.495411E+01
PKER_GWETH(  5, 12) =  0.506587E+01
PKER_GWETH(  5, 13) =  0.515975E+01
PKER_GWETH(  5, 14) =  0.523873E+01
PKER_GWETH(  5, 15) =  0.530527E+01
PKER_GWETH(  5, 16) =  0.536141E+01
PKER_GWETH(  5, 17) =  0.540884E+01
PKER_GWETH(  5, 18) =  0.544897E+01
PKER_GWETH(  5, 19) =  0.548295E+01
PKER_GWETH(  5, 20) =  0.551176E+01
PKER_GWETH(  5, 21) =  0.553621E+01
PKER_GWETH(  5, 22) =  0.555697E+01
PKER_GWETH(  5, 23) =  0.557462E+01
PKER_GWETH(  5, 24) =  0.558962E+01
PKER_GWETH(  5, 25) =  0.560239E+01
PKER_GWETH(  5, 26) =  0.561326E+01
PKER_GWETH(  5, 27) =  0.562251E+01
PKER_GWETH(  5, 28) =  0.563040E+01
PKER_GWETH(  5, 29) =  0.563712E+01
PKER_GWETH(  5, 30) =  0.564285E+01
PKER_GWETH(  5, 31) =  0.564774E+01
PKER_GWETH(  5, 32) =  0.565191E+01
PKER_GWETH(  5, 33) =  0.565547E+01
PKER_GWETH(  5, 34) =  0.565851E+01
PKER_GWETH(  5, 35) =  0.566110E+01
PKER_GWETH(  5, 36) =  0.566331E+01
PKER_GWETH(  5, 37) =  0.566521E+01
PKER_GWETH(  5, 38) =  0.566682E+01
PKER_GWETH(  5, 39) =  0.566820E+01
PKER_GWETH(  5, 40) =  0.566938E+01
PKER_GWETH(  6,  1) =  0.142387E+01
PKER_GWETH(  6,  2) =  0.169262E+01
PKER_GWETH(  6,  3) =  0.206631E+01
PKER_GWETH(  6,  4) =  0.246074E+01
PKER_GWETH(  6,  5) =  0.282802E+01
PKER_GWETH(  6,  6) =  0.314972E+01
PKER_GWETH(  6,  7) =  0.342395E+01
PKER_GWETH(  6,  8) =  0.365511E+01
PKER_GWETH(  6,  9) =  0.384909E+01
PKER_GWETH(  6, 10) =  0.401161E+01
PKER_GWETH(  6, 11) =  0.414773E+01
PKER_GWETH(  6, 12) =  0.426180E+01
PKER_GWETH(  6, 13) =  0.435749E+01
PKER_GWETH(  6, 14) =  0.443787E+01
PKER_GWETH(  6, 15) =  0.450549E+01
PKER_GWETH(  6, 16) =  0.456245E+01
PKER_GWETH(  6, 17) =  0.461051E+01
PKER_GWETH(  6, 18) =  0.465112E+01
PKER_GWETH(  6, 19) =  0.468547E+01
PKER_GWETH(  6, 20) =  0.471456E+01
PKER_GWETH(  6, 21) =  0.473922E+01
PKER_GWETH(  6, 22) =  0.476015E+01
PKER_GWETH(  6, 23) =  0.477792E+01
PKER_GWETH(  6, 24) =  0.479302E+01
PKER_GWETH(  6, 25) =  0.480587E+01
PKER_GWETH(  6, 26) =  0.481679E+01
PKER_GWETH(  6, 27) =  0.482610E+01
PKER_GWETH(  6, 28) =  0.483402E+01
PKER_GWETH(  6, 29) =  0.484077E+01
PKER_GWETH(  6, 30) =  0.484652E+01
PKER_GWETH(  6, 31) =  0.485143E+01
PKER_GWETH(  6, 32) =  0.485561E+01
PKER_GWETH(  6, 33) =  0.485918E+01
PKER_GWETH(  6, 34) =  0.486223E+01
PKER_GWETH(  6, 35) =  0.486482E+01
PKER_GWETH(  6, 36) =  0.486704E+01
PKER_GWETH(  6, 37) =  0.486894E+01
PKER_GWETH(  6, 38) =  0.487056E+01
PKER_GWETH(  6, 39) =  0.487194E+01
PKER_GWETH(  6, 40) =  0.487312E+01
PKER_GWETH(  7,  1) =  0.116756E+01
PKER_GWETH(  7,  2) =  0.122777E+01
PKER_GWETH(  7,  3) =  0.146234E+01
PKER_GWETH(  7,  4) =  0.178473E+01
PKER_GWETH(  7,  5) =  0.212359E+01
PKER_GWETH(  7,  6) =  0.243847E+01
PKER_GWETH(  7,  7) =  0.271403E+01
PKER_GWETH(  7,  8) =  0.294885E+01
PKER_GWETH(  7,  9) =  0.314677E+01
PKER_GWETH(  7, 10) =  0.331286E+01
PKER_GWETH(  7, 11) =  0.345202E+01
PKER_GWETH(  7, 12) =  0.356856E+01
PKER_GWETH(  7, 13) =  0.366623E+01
PKER_GWETH(  7, 14) =  0.374816E+01
PKER_GWETH(  7, 15) =  0.381698E+01
PKER_GWETH(  7, 16) =  0.387486E+01
PKER_GWETH(  7, 17) =  0.392363E+01
PKER_GWETH(  7, 18) =  0.396478E+01
PKER_GWETH(  7, 19) =  0.399954E+01
PKER_GWETH(  7, 20) =  0.402895E+01
PKER_GWETH(  7, 21) =  0.405385E+01
PKER_GWETH(  7, 22) =  0.407496E+01
PKER_GWETH(  7, 23) =  0.409288E+01
PKER_GWETH(  7, 24) =  0.410809E+01
PKER_GWETH(  7, 25) =  0.412101E+01
PKER_GWETH(  7, 26) =  0.413201E+01
PKER_GWETH(  7, 27) =  0.414136E+01
PKER_GWETH(  7, 28) =  0.414932E+01
PKER_GWETH(  7, 29) =  0.415610E+01
PKER_GWETH(  7, 30) =  0.416188E+01
PKER_GWETH(  7, 31) =  0.416680E+01
PKER_GWETH(  7, 32) =  0.417100E+01
PKER_GWETH(  7, 33) =  0.417458E+01
PKER_GWETH(  7, 34) =  0.417764E+01
PKER_GWETH(  7, 35) =  0.418024E+01
PKER_GWETH(  7, 36) =  0.418247E+01
PKER_GWETH(  7, 37) =  0.418437E+01
PKER_GWETH(  7, 38) =  0.418599E+01
PKER_GWETH(  7, 39) =  0.418737E+01
PKER_GWETH(  7, 40) =  0.418855E+01
PKER_GWETH(  8,  1) =  0.115655E+01
PKER_GWETH(  8,  2) =  0.100208E+01
PKER_GWETH(  8,  3) =  0.105877E+01
PKER_GWETH(  8,  4) =  0.126349E+01
PKER_GWETH(  8,  5) =  0.154150E+01
PKER_GWETH(  8,  6) =  0.183260E+01
PKER_GWETH(  8,  7) =  0.210253E+01
PKER_GWETH(  8,  8) =  0.233857E+01
PKER_GWETH(  8,  9) =  0.253964E+01
PKER_GWETH(  8, 10) =  0.270911E+01
PKER_GWETH(  8, 11) =  0.285132E+01
PKER_GWETH(  8, 12) =  0.297046E+01
PKER_GWETH(  8, 13) =  0.307026E+01
PKER_GWETH(  8, 14) =  0.315388E+01
PKER_GWETH(  8, 15) =  0.322402E+01
PKER_GWETH(  8, 16) =  0.328294E+01
PKER_GWETH(  8, 17) =  0.333250E+01
PKER_GWETH(  8, 18) =  0.337426E+01
PKER_GWETH(  8, 19) =  0.340948E+01
PKER_GWETH(  8, 20) =  0.343924E+01
PKER_GWETH(  8, 21) =  0.346442E+01
PKER_GWETH(  8, 22) =  0.348573E+01
PKER_GWETH(  8, 23) =  0.350381E+01
PKER_GWETH(  8, 24) =  0.351914E+01
PKER_GWETH(  8, 25) =  0.353216E+01
PKER_GWETH(  8, 26) =  0.354322E+01
PKER_GWETH(  8, 27) =  0.355263E+01
PKER_GWETH(  8, 28) =  0.356064E+01
PKER_GWETH(  8, 29) =  0.356745E+01
PKER_GWETH(  8, 30) =  0.357325E+01
PKER_GWETH(  8, 31) =  0.357820E+01
PKER_GWETH(  8, 32) =  0.358241E+01
PKER_GWETH(  8, 33) =  0.358601E+01
PKER_GWETH(  8, 34) =  0.358907E+01
PKER_GWETH(  8, 35) =  0.359168E+01
PKER_GWETH(  8, 36) =  0.359391E+01
PKER_GWETH(  8, 37) =  0.359582E+01
PKER_GWETH(  8, 38) =  0.359744E+01
PKER_GWETH(  8, 39) =  0.359883E+01
PKER_GWETH(  8, 40) =  0.360002E+01
PKER_GWETH(  9,  1) =  0.132218E+01
PKER_GWETH(  9,  2) =  0.987527E+00
PKER_GWETH(  9,  3) =  0.860208E+00
PKER_GWETH(  9,  4) =  0.913110E+00
PKER_GWETH(  9,  5) =  0.109167E+01
PKER_GWETH(  9,  6) =  0.133139E+01
PKER_GWETH(  9,  7) =  0.158145E+01
PKER_GWETH(  9,  8) =  0.181284E+01
PKER_GWETH(  9,  9) =  0.201502E+01
PKER_GWETH(  9, 10) =  0.218719E+01
PKER_GWETH(  9, 11) =  0.233229E+01
PKER_GWETH(  9, 12) =  0.245406E+01
PKER_GWETH(  9, 13) =  0.255607E+01
PKER_GWETH(  9, 14) =  0.264152E+01
PKER_GWETH(  9, 15) =  0.271312E+01
PKER_GWETH(  9, 16) =  0.277318E+01
PKER_GWETH(  9, 17) =  0.282362E+01
PKER_GWETH(  9, 18) =  0.286605E+01
PKER_GWETH(  9, 19) =  0.290180E+01
PKER_GWETH(  9, 20) =  0.293196E+01
PKER_GWETH(  9, 21) =  0.295743E+01
PKER_GWETH(  9, 22) =  0.297898E+01
PKER_GWETH(  9, 23) =  0.299723E+01
PKER_GWETH(  9, 24) =  0.301270E+01
PKER_GWETH(  9, 25) =  0.302582E+01
PKER_GWETH(  9, 26) =  0.303697E+01
PKER_GWETH(  9, 27) =  0.304644E+01
PKER_GWETH(  9, 28) =  0.305449E+01
PKER_GWETH(  9, 29) =  0.306134E+01
PKER_GWETH(  9, 30) =  0.306718E+01
PKER_GWETH(  9, 31) =  0.307214E+01
PKER_GWETH(  9, 32) =  0.307638E+01
PKER_GWETH(  9, 33) =  0.307998E+01
PKER_GWETH(  9, 34) =  0.308306E+01
PKER_GWETH(  9, 35) =  0.308568E+01
PKER_GWETH(  9, 36) =  0.308792E+01
PKER_GWETH(  9, 37) =  0.308983E+01
PKER_GWETH(  9, 38) =  0.309145E+01
PKER_GWETH(  9, 39) =  0.309285E+01
PKER_GWETH(  9, 40) =  0.309403E+01
PKER_GWETH( 10,  1) =  0.158474E+01
PKER_GWETH( 10,  2) =  0.112606E+01
PKER_GWETH( 10,  3) =  0.843404E+00
PKER_GWETH( 10,  4) =  0.738516E+00
PKER_GWETH( 10,  5) =  0.787554E+00
PKER_GWETH( 10,  6) =  0.943174E+00
PKER_GWETH( 10,  7) =  0.114990E+01
PKER_GWETH( 10,  8) =  0.136468E+01
PKER_GWETH( 10,  9) =  0.156304E+01
PKER_GWETH( 10, 10) =  0.173621E+01
PKER_GWETH( 10, 11) =  0.188364E+01
PKER_GWETH( 10, 12) =  0.200788E+01
PKER_GWETH( 10, 13) =  0.211214E+01
PKER_GWETH( 10, 14) =  0.219948E+01
PKER_GWETH( 10, 15) =  0.227264E+01
PKER_GWETH( 10, 16) =  0.233395E+01
PKER_GWETH( 10, 17) =  0.238537E+01
PKER_GWETH( 10, 18) =  0.242856E+01
PKER_GWETH( 10, 19) =  0.246489E+01
PKER_GWETH( 10, 20) =  0.249549E+01
PKER_GWETH( 10, 21) =  0.252131E+01
PKER_GWETH( 10, 22) =  0.254312E+01
PKER_GWETH( 10, 23) =  0.256156E+01
PKER_GWETH( 10, 24) =  0.257719E+01
PKER_GWETH( 10, 25) =  0.259043E+01
PKER_GWETH( 10, 26) =  0.260166E+01
PKER_GWETH( 10, 27) =  0.261120E+01
PKER_GWETH( 10, 28) =  0.261931E+01
PKER_GWETH( 10, 29) =  0.262620E+01
PKER_GWETH( 10, 30) =  0.263207E+01
PKER_GWETH( 10, 31) =  0.263706E+01
PKER_GWETH( 10, 32) =  0.264131E+01
PKER_GWETH( 10, 33) =  0.264493E+01
PKER_GWETH( 10, 34) =  0.264802E+01
PKER_GWETH( 10, 35) =  0.265065E+01
PKER_GWETH( 10, 36) =  0.265289E+01
PKER_GWETH( 10, 37) =  0.265481E+01
PKER_GWETH( 10, 38) =  0.265644E+01
PKER_GWETH( 10, 39) =  0.265784E+01
PKER_GWETH( 10, 40) =  0.265903E+01
PKER_GWETH( 11,  1) =  0.187936E+01
PKER_GWETH( 11,  2) =  0.134925E+01
PKER_GWETH( 11,  3) =  0.959066E+00
PKER_GWETH( 11,  4) =  0.720467E+00
PKER_GWETH( 11,  5) =  0.634149E+00
PKER_GWETH( 11,  6) =  0.679336E+00
PKER_GWETH( 11,  7) =  0.814841E+00
PKER_GWETH( 11,  8) =  0.993130E+00
PKER_GWETH( 11,  9) =  0.117760E+01
PKER_GWETH( 11, 10) =  0.134764E+01
PKER_GWETH( 11, 11) =  0.149595E+01
PKER_GWETH( 11, 12) =  0.162219E+01
PKER_GWETH( 11, 13) =  0.172857E+01
PKER_GWETH( 11, 14) =  0.181784E+01
PKER_GWETH( 11, 15) =  0.189263E+01
PKER_GWETH( 11, 16) =  0.195527E+01
PKER_GWETH( 11, 17) =  0.200776E+01
PKER_GWETH( 11, 18) =  0.205179E+01
PKER_GWETH( 11, 19) =  0.208876E+01
PKER_GWETH( 11, 20) =  0.211987E+01
PKER_GWETH( 11, 21) =  0.214607E+01
PKER_GWETH( 11, 22) =  0.216817E+01
PKER_GWETH( 11, 23) =  0.218684E+01
PKER_GWETH( 11, 24) =  0.220263E+01
PKER_GWETH( 11, 25) =  0.221601E+01
PKER_GWETH( 11, 26) =  0.222734E+01
PKER_GWETH( 11, 27) =  0.223696E+01
PKER_GWETH( 11, 28) =  0.224512E+01
PKER_GWETH( 11, 29) =  0.225206E+01
PKER_GWETH( 11, 30) =  0.225796E+01
PKER_GWETH( 11, 31) =  0.226298E+01
PKER_GWETH( 11, 32) =  0.226725E+01
PKER_GWETH( 11, 33) =  0.227089E+01
PKER_GWETH( 11, 34) =  0.227399E+01
PKER_GWETH( 11, 35) =  0.227663E+01
PKER_GWETH( 11, 36) =  0.227889E+01
PKER_GWETH( 11, 37) =  0.228081E+01
PKER_GWETH( 11, 38) =  0.228245E+01
PKER_GWETH( 11, 39) =  0.228384E+01
PKER_GWETH( 11, 40) =  0.228504E+01
PKER_GWETH( 12,  1) =  0.216566E+01
PKER_GWETH( 12,  2) =  0.160109E+01
PKER_GWETH( 12,  3) =  0.114873E+01
PKER_GWETH( 12,  4) =  0.816878E+00
PKER_GWETH( 12,  5) =  0.615510E+00
PKER_GWETH( 12,  6) =  0.544612E+00
PKER_GWETH( 12,  7) =  0.586008E+00
PKER_GWETH( 12,  8) =  0.703936E+00
PKER_GWETH( 12,  9) =  0.857718E+00
PKER_GWETH( 12, 10) =  0.101614E+01
PKER_GWETH( 12, 11) =  0.116189E+01
PKER_GWETH( 12, 12) =  0.128892E+01
PKER_GWETH( 12, 13) =  0.139702E+01
PKER_GWETH( 12, 14) =  0.148811E+01
PKER_GWETH( 12, 15) =  0.156454E+01
PKER_GWETH( 12, 16) =  0.162858E+01
PKER_GWETH( 12, 17) =  0.168221E+01
PKER_GWETH( 12, 18) =  0.172715E+01
PKER_GWETH( 12, 19) =  0.176485E+01
PKER_GWETH( 12, 20) =  0.179651E+01
PKER_GWETH( 12, 21) =  0.182314E+01
PKER_GWETH( 12, 22) =  0.184557E+01
PKER_GWETH( 12, 23) =  0.186449E+01
PKER_GWETH( 12, 24) =  0.188048E+01
PKER_GWETH( 12, 25) =  0.189400E+01
PKER_GWETH( 12, 26) =  0.190544E+01
PKER_GWETH( 12, 27) =  0.191515E+01
PKER_GWETH( 12, 28) =  0.192338E+01
PKER_GWETH( 12, 29) =  0.193037E+01
PKER_GWETH( 12, 30) =  0.193631E+01
PKER_GWETH( 12, 31) =  0.194136E+01
PKER_GWETH( 12, 32) =  0.194565E+01
PKER_GWETH( 12, 33) =  0.194931E+01
PKER_GWETH( 12, 34) =  0.195242E+01
PKER_GWETH( 12, 35) =  0.195508E+01
PKER_GWETH( 12, 36) =  0.195734E+01
PKER_GWETH( 12, 37) =  0.195926E+01
PKER_GWETH( 12, 38) =  0.196091E+01
PKER_GWETH( 12, 39) =  0.196231E+01
PKER_GWETH( 12, 40) =  0.196351E+01
PKER_GWETH( 13,  1) =  0.242478E+01
PKER_GWETH( 13,  2) =  0.184651E+01
PKER_GWETH( 13,  3) =  0.136400E+01
PKER_GWETH( 13,  4) =  0.978003E+00
PKER_GWETH( 13,  5) =  0.695793E+00
PKER_GWETH( 13,  6) =  0.525848E+00
PKER_GWETH( 13,  7) =  0.467780E+00
PKER_GWETH( 13,  8) =  0.505573E+00
PKER_GWETH( 13,  9) =  0.608098E+00
PKER_GWETH( 13, 10) =  0.740757E+00
PKER_GWETH( 13, 11) =  0.876797E+00
PKER_GWETH( 13, 12) =  0.100173E+01
PKER_GWETH( 13, 13) =  0.111053E+01
PKER_GWETH( 13, 14) =  0.120309E+01
PKER_GWETH( 13, 15) =  0.128108E+01
PKER_GWETH( 13, 16) =  0.134653E+01
PKER_GWETH( 13, 17) =  0.140136E+01
PKER_GWETH( 13, 18) =  0.144728E+01
PKER_GWETH( 13, 19) =  0.148576E+01
PKER_GWETH( 13, 20) =  0.151804E+01
PKER_GWETH( 13, 21) =  0.154514E+01
PKER_GWETH( 13, 22) =  0.156794E+01
PKER_GWETH( 13, 23) =  0.158715E+01
PKER_GWETH( 13, 24) =  0.160335E+01
PKER_GWETH( 13, 25) =  0.161703E+01
PKER_GWETH( 13, 26) =  0.162860E+01
PKER_GWETH( 13, 27) =  0.163840E+01
PKER_GWETH( 13, 28) =  0.164671E+01
PKER_GWETH( 13, 29) =  0.165376E+01
PKER_GWETH( 13, 30) =  0.165974E+01
PKER_GWETH( 13, 31) =  0.166482E+01
PKER_GWETH( 13, 32) =  0.166914E+01
PKER_GWETH( 13, 33) =  0.167282E+01
PKER_GWETH( 13, 34) =  0.167595E+01
PKER_GWETH( 13, 35) =  0.167862E+01
PKER_GWETH( 13, 36) =  0.168089E+01
PKER_GWETH( 13, 37) =  0.168282E+01
PKER_GWETH( 13, 38) =  0.168447E+01
PKER_GWETH( 13, 39) =  0.168588E+01
PKER_GWETH( 13, 40) =  0.168708E+01
PKER_GWETH( 14,  1) =  0.265128E+01
PKER_GWETH( 14,  2) =  0.206894E+01
PKER_GWETH( 14,  3) =  0.157436E+01
PKER_GWETH( 14,  4) =  0.116200E+01
PKER_GWETH( 14,  5) =  0.832643E+00
PKER_GWETH( 14,  6) =  0.592653E+00
PKER_GWETH( 14,  7) =  0.449243E+00
PKER_GWETH( 14,  8) =  0.401845E+00
PKER_GWETH( 14,  9) =  0.436189E+00
PKER_GWETH( 14, 10) =  0.525318E+00
PKER_GWETH( 14, 11) =  0.639731E+00
PKER_GWETH( 14, 12) =  0.756546E+00
PKER_GWETH( 14, 13) =  0.863627E+00
PKER_GWETH( 14, 14) =  0.956814E+00
PKER_GWETH( 14, 15) =  0.103607E+01
PKER_GWETH( 14, 16) =  0.110285E+01
PKER_GWETH( 14, 17) =  0.115889E+01
PKER_GWETH( 14, 18) =  0.120583E+01
PKER_GWETH( 14, 19) =  0.124515E+01
PKER_GWETH( 14, 20) =  0.127810E+01
PKER_GWETH( 14, 21) =  0.130574E+01
PKER_GWETH( 14, 22) =  0.132895E+01
PKER_GWETH( 14, 23) =  0.134846E+01
PKER_GWETH( 14, 24) =  0.136491E+01
PKER_GWETH( 14, 25) =  0.137878E+01
PKER_GWETH( 14, 26) =  0.139049E+01
PKER_GWETH( 14, 27) =  0.140040E+01
PKER_GWETH( 14, 28) =  0.140879E+01
PKER_GWETH( 14, 29) =  0.141590E+01
PKER_GWETH( 14, 30) =  0.142193E+01
PKER_GWETH( 14, 31) =  0.142705E+01
PKER_GWETH( 14, 32) =  0.143140E+01
PKER_GWETH( 14, 33) =  0.143510E+01
PKER_GWETH( 14, 34) =  0.143825E+01
PKER_GWETH( 14, 35) =  0.144093E+01
PKER_GWETH( 14, 36) =  0.144321E+01
PKER_GWETH( 14, 37) =  0.144515E+01
PKER_GWETH( 14, 38) =  0.144681E+01
PKER_GWETH( 14, 39) =  0.144822E+01
PKER_GWETH( 14, 40) =  0.144942E+01
PKER_GWETH( 15,  1) =  0.284621E+01
PKER_GWETH( 15,  2) =  0.226351E+01
PKER_GWETH( 15,  3) =  0.176529E+01
PKER_GWETH( 15,  4) =  0.134229E+01
PKER_GWETH( 15,  5) =  0.989890E+00
PKER_GWETH( 15,  6) =  0.708881E+00
PKER_GWETH( 15,  7) =  0.504845E+00
PKER_GWETH( 15,  8) =  0.383795E+00
PKER_GWETH( 15,  9) =  0.345252E+00
PKER_GWETH( 15, 10) =  0.376367E+00
PKER_GWETH( 15, 11) =  0.453863E+00
PKER_GWETH( 15, 12) =  0.552469E+00
PKER_GWETH( 15, 13) =  0.652771E+00
PKER_GWETH( 15, 14) =  0.744550E+00
PKER_GWETH( 15, 15) =  0.824363E+00
PKER_GWETH( 15, 16) =  0.892231E+00
PKER_GWETH( 15, 17) =  0.949407E+00
PKER_GWETH( 15, 18) =  0.997387E+00
PKER_GWETH( 15, 19) =  0.103759E+01
PKER_GWETH( 15, 20) =  0.107125E+01
PKER_GWETH( 15, 21) =  0.109946E+01
PKER_GWETH( 15, 22) =  0.112312E+01
PKER_GWETH( 15, 23) =  0.114300E+01
PKER_GWETH( 15, 24) =  0.115971E+01
PKER_GWETH( 15, 25) =  0.117378E+01
PKER_GWETH( 15, 26) =  0.118566E+01
PKER_GWETH( 15, 27) =  0.119569E+01
PKER_GWETH( 15, 28) =  0.120417E+01
PKER_GWETH( 15, 29) =  0.121135E+01
PKER_GWETH( 15, 30) =  0.121743E+01
PKER_GWETH( 15, 31) =  0.122260E+01
PKER_GWETH( 15, 32) =  0.122698E+01
PKER_GWETH( 15, 33) =  0.123071E+01
PKER_GWETH( 15, 34) =  0.123387E+01
PKER_GWETH( 15, 35) =  0.123657E+01
PKER_GWETH( 15, 36) =  0.123886E+01
PKER_GWETH( 15, 37) =  0.124081E+01
PKER_GWETH( 15, 38) =  0.124247E+01
PKER_GWETH( 15, 39) =  0.124389E+01
PKER_GWETH( 15, 40) =  0.124510E+01
PKER_GWETH( 16,  1) =  0.301293E+01
PKER_GWETH( 16,  2) =  0.243100E+01
PKER_GWETH( 16,  3) =  0.193242E+01
PKER_GWETH( 16,  4) =  0.150618E+01
PKER_GWETH( 16,  5) =  0.114441E+01
PKER_GWETH( 16,  6) =  0.843236E+00
PKER_GWETH( 16,  7) =  0.603507E+00
PKER_GWETH( 16,  8) =  0.430078E+00
PKER_GWETH( 16,  9) =  0.327966E+00
PKER_GWETH( 16, 10) =  0.296680E+00
PKER_GWETH( 16, 11) =  0.324772E+00
PKER_GWETH( 16, 12) =  0.392150E+00
PKER_GWETH( 16, 13) =  0.477107E+00
PKER_GWETH( 16, 14) =  0.563219E+00
PKER_GWETH( 16, 15) =  0.641879E+00
PKER_GWETH( 16, 16) =  0.710236E+00
PKER_GWETH( 16, 17) =  0.768350E+00
PKER_GWETH( 16, 18) =  0.817307E+00
PKER_GWETH( 16, 19) =  0.858389E+00
PKER_GWETH( 16, 20) =  0.892809E+00
PKER_GWETH( 16, 21) =  0.921636E+00
PKER_GWETH( 16, 22) =  0.945790E+00
PKER_GWETH( 16, 23) =  0.966049E+00
PKER_GWETH( 16, 24) =  0.983062E+00
PKER_GWETH( 16, 25) =  0.997370E+00
PKER_GWETH( 16, 26) =  0.100942E+01
PKER_GWETH( 16, 27) =  0.101959E+01
PKER_GWETH( 16, 28) =  0.102817E+01
PKER_GWETH( 16, 29) =  0.103543E+01
PKER_GWETH( 16, 30) =  0.104158E+01
PKER_GWETH( 16, 31) =  0.104679E+01
PKER_GWETH( 16, 32) =  0.105121E+01
PKER_GWETH( 16, 33) =  0.105496E+01
PKER_GWETH( 16, 34) =  0.105815E+01
PKER_GWETH( 16, 35) =  0.106086E+01
PKER_GWETH( 16, 36) =  0.106317E+01
PKER_GWETH( 16, 37) =  0.106513E+01
PKER_GWETH( 16, 38) =  0.106680E+01
PKER_GWETH( 16, 39) =  0.106822E+01
PKER_GWETH( 16, 40) =  0.106944E+01
PKER_GWETH( 17,  1) =  0.315524E+01
PKER_GWETH( 17,  2) =  0.257428E+01
PKER_GWETH( 17,  3) =  0.207634E+01
PKER_GWETH( 17,  4) =  0.164974E+01
PKER_GWETH( 17,  5) =  0.128507E+01
PKER_GWETH( 17,  6) =  0.975670E+00
PKER_GWETH( 17,  7) =  0.718280E+00
PKER_GWETH( 17,  8) =  0.513786E+00
PKER_GWETH( 17,  9) =  0.366371E+00
PKER_GWETH( 17, 10) =  0.280370E+00
PKER_GWETH( 17, 11) =  0.254985E+00
PKER_GWETH( 17, 12) =  0.280264E+00
PKER_GWETH( 17, 13) =  0.338829E+00
PKER_GWETH( 17, 14) =  0.412012E+00
PKER_GWETH( 17, 15) =  0.485941E+00
PKER_GWETH( 17, 16) =  0.553357E+00
PKER_GWETH( 17, 17) =  0.611901E+00
PKER_GWETH( 17, 18) =  0.661663E+00
PKER_GWETH( 17, 19) =  0.703581E+00
PKER_GWETH( 17, 20) =  0.738757E+00
PKER_GWETH( 17, 21) =  0.768229E+00
PKER_GWETH( 17, 22) =  0.792912E+00
PKER_GWETH( 17, 23) =  0.813593E+00
PKER_GWETH( 17, 24) =  0.830939E+00
PKER_GWETH( 17, 25) =  0.845506E+00
PKER_GWETH( 17, 26) =  0.857756E+00
PKER_GWETH( 17, 27) =  0.868074E+00
PKER_GWETH( 17, 28) =  0.876776E+00
PKER_GWETH( 17, 29) =  0.884126E+00
PKER_GWETH( 17, 30) =  0.890342E+00
PKER_GWETH( 17, 31) =  0.895604E+00
PKER_GWETH( 17, 32) =  0.900064E+00
PKER_GWETH( 17, 33) =  0.903847E+00
PKER_GWETH( 17, 34) =  0.907059E+00
PKER_GWETH( 17, 35) =  0.909788E+00
PKER_GWETH( 17, 36) =  0.912108E+00
PKER_GWETH( 17, 37) =  0.914081E+00
PKER_GWETH( 17, 38) =  0.915761E+00
PKER_GWETH( 17, 39) =  0.917191E+00
PKER_GWETH( 17, 40) =  0.918409E+00
PKER_GWETH( 18,  1) =  0.327670E+01
PKER_GWETH( 18,  2) =  0.269659E+01
PKER_GWETH( 18,  3) =  0.219947E+01
PKER_GWETH( 18,  4) =  0.177340E+01
PKER_GWETH( 18,  5) =  0.140838E+01
PKER_GWETH( 18,  6) =  0.109640E+01
PKER_GWETH( 18,  7) =  0.831787E+00
PKER_GWETH( 18,  8) =  0.611835E+00
PKER_GWETH( 18,  9) =  0.437396E+00
PKER_GWETH( 18, 10) =  0.312131E+00
PKER_GWETH( 18, 11) =  0.239703E+00
PKER_GWETH( 18, 12) =  0.219181E+00
PKER_GWETH( 18, 13) =  0.241879E+00
PKER_GWETH( 18, 14) =  0.292751E+00
PKER_GWETH( 18, 15) =  0.355792E+00
PKER_GWETH( 18, 16) =  0.419256E+00
PKER_GWETH( 18, 17) =  0.477033E+00
PKER_GWETH( 18, 18) =  0.527174E+00
PKER_GWETH( 18, 19) =  0.569783E+00
PKER_GWETH( 18, 20) =  0.605675E+00
PKER_GWETH( 18, 21) =  0.635795E+00
PKER_GWETH( 18, 22) =  0.661029E+00
PKER_GWETH( 18, 23) =  0.682164E+00
PKER_GWETH( 18, 24) =  0.699872E+00
PKER_GWETH( 18, 25) =  0.714724E+00
PKER_GWETH( 18, 26) =  0.727195E+00
PKER_GWETH( 18, 27) =  0.737684E+00
PKER_GWETH( 18, 28) =  0.746517E+00
PKER_GWETH( 18, 29) =  0.753968E+00
PKER_GWETH( 18, 30) =  0.760260E+00
PKER_GWETH( 18, 31) =  0.765581E+00
PKER_GWETH( 18, 32) =  0.770086E+00
PKER_GWETH( 18, 33) =  0.773904E+00
PKER_GWETH( 18, 34) =  0.777142E+00
PKER_GWETH( 18, 35) =  0.779891E+00
PKER_GWETH( 18, 36) =  0.782227E+00
PKER_GWETH( 18, 37) =  0.784213E+00
PKER_GWETH( 18, 38) =  0.785902E+00
PKER_GWETH( 18, 39) =  0.787339E+00
PKER_GWETH( 18, 40) =  0.788563E+00
PKER_GWETH( 19,  1) =  0.338040E+01
PKER_GWETH( 19,  2) =  0.280098E+01
PKER_GWETH( 19,  3) =  0.230458E+01
PKER_GWETH( 19,  4) =  0.187921E+01
PKER_GWETH( 19,  5) =  0.151464E+01
PKER_GWETH( 19,  6) =  0.120232E+01
PKER_GWETH( 19,  7) =  0.935412E+00
PKER_GWETH( 19,  8) =  0.709100E+00
PKER_GWETH( 19,  9) =  0.521170E+00
PKER_GWETH( 19, 10) =  0.372366E+00
PKER_GWETH( 19, 11) =  0.265933E+00
PKER_GWETH( 19, 12) =  0.204940E+00
PKER_GWETH( 19, 13) =  0.188413E+00
PKER_GWETH( 19, 14) =  0.208761E+00
PKER_GWETH( 19, 15) =  0.252933E+00
PKER_GWETH( 19, 16) =  0.307238E+00
PKER_GWETH( 19, 17) =  0.361714E+00
PKER_GWETH( 19, 18) =  0.411229E+00
PKER_GWETH( 19, 19) =  0.454172E+00
PKER_GWETH( 19, 20) =  0.490657E+00
PKER_GWETH( 19, 21) =  0.521389E+00
PKER_GWETH( 19, 22) =  0.547179E+00
PKER_GWETH( 19, 23) =  0.568786E+00
PKER_GWETH( 19, 24) =  0.586882E+00
PKER_GWETH( 19, 25) =  0.602044E+00
PKER_GWETH( 19, 26) =  0.614761E+00
PKER_GWETH( 19, 27) =  0.625439E+00
PKER_GWETH( 19, 28) =  0.634419E+00
PKER_GWETH( 19, 29) =  0.641982E+00
PKER_GWETH( 19, 30) =  0.648360E+00
PKER_GWETH( 19, 31) =  0.653747E+00
PKER_GWETH( 19, 32) =  0.658302E+00
PKER_GWETH( 19, 33) =  0.662158E+00
PKER_GWETH( 19, 34) =  0.665426E+00
PKER_GWETH( 19, 35) =  0.668199E+00
PKER_GWETH( 19, 36) =  0.670552E+00
PKER_GWETH( 19, 37) =  0.672551E+00
PKER_GWETH( 19, 38) =  0.674251E+00
PKER_GWETH( 19, 39) =  0.675696E+00
PKER_GWETH( 19, 40) =  0.676927E+00
PKER_GWETH( 20,  1) =  0.346899E+01
PKER_GWETH( 20,  2) =  0.289011E+01
PKER_GWETH( 20,  3) =  0.239431E+01
PKER_GWETH( 20,  4) =  0.196955E+01
PKER_GWETH( 20,  5) =  0.160557E+01
PKER_GWETH( 20,  6) =  0.129362E+01
PKER_GWETH( 20,  7) =  0.102639E+01
PKER_GWETH( 20,  8) =  0.798045E+00
PKER_GWETH( 20,  9) =  0.604502E+00
PKER_GWETH( 20, 10) =  0.443925E+00
PKER_GWETH( 20, 11) =  0.317014E+00
PKER_GWETH( 20, 12) =  0.226583E+00
PKER_GWETH( 20, 13) =  0.175230E+00
PKER_GWETH( 20, 14) =  0.161988E+00
PKER_GWETH( 20, 15) =  0.180189E+00
PKER_GWETH( 20, 16) =  0.218528E+00
PKER_GWETH( 20, 17) =  0.265303E+00
PKER_GWETH( 20, 18) =  0.312063E+00
PKER_GWETH( 20, 19) =  0.354496E+00
PKER_GWETH( 20, 20) =  0.391273E+00
PKER_GWETH( 20, 21) =  0.422515E+00
PKER_GWETH( 20, 22) =  0.448829E+00
PKER_GWETH( 20, 23) =  0.470911E+00
PKER_GWETH( 20, 24) =  0.489412E+00
PKER_GWETH( 20, 25) =  0.504907E+00
PKER_GWETH( 20, 26) =  0.517890E+00
PKER_GWETH( 20, 27) =  0.528777E+00
PKER_GWETH( 20, 28) =  0.537920E+00
PKER_GWETH( 20, 29) =  0.545608E+00
PKER_GWETH( 20, 30) =  0.552083E+00
PKER_GWETH( 20, 31) =  0.557544E+00
PKER_GWETH( 20, 32) =  0.562156E+00
PKER_GWETH( 20, 33) =  0.566055E+00
PKER_GWETH( 20, 34) =  0.569357E+00
PKER_GWETH( 20, 35) =  0.572154E+00
PKER_GWETH( 20, 36) =  0.574527E+00
PKER_GWETH( 20, 37) =  0.576541E+00
PKER_GWETH( 20, 38) =  0.578253E+00
PKER_GWETH( 20, 39) =  0.579707E+00
PKER_GWETH( 20, 40) =  0.580945E+00
PKER_GWETH( 21,  1) =  0.354473E+01
PKER_GWETH( 21,  2) =  0.296625E+01
PKER_GWETH( 21,  3) =  0.247091E+01
PKER_GWETH( 21,  4) =  0.204667E+01
PKER_GWETH( 21,  5) =  0.168322E+01
PKER_GWETH( 21,  6) =  0.137177E+01
PKER_GWETH( 21,  7) =  0.110484E+01
PKER_GWETH( 21,  8) =  0.876190E+00
PKER_GWETH( 21,  9) =  0.680837E+00
PKER_GWETH( 21, 10) =  0.515324E+00
PKER_GWETH( 21, 11) =  0.378113E+00
PKER_GWETH( 21, 12) =  0.269896E+00
PKER_GWETH( 21, 13) =  0.193066E+00
PKER_GWETH( 21, 14) =  0.149847E+00
PKER_GWETH( 21, 15) =  0.139314E+00
PKER_GWETH( 21, 16) =  0.155539E+00
PKER_GWETH( 21, 17) =  0.188802E+00
PKER_GWETH( 21, 18) =  0.229088E+00
PKER_GWETH( 21, 19) =  0.269221E+00
PKER_GWETH( 21, 20) =  0.305584E+00
PKER_GWETH( 21, 21) =  0.337081E+00
PKER_GWETH( 21, 22) =  0.363833E+00
PKER_GWETH( 21, 23) =  0.386364E+00
PKER_GWETH( 21, 24) =  0.405272E+00
PKER_GWETH( 21, 25) =  0.421113E+00
PKER_GWETH( 21, 26) =  0.434381E+00
PKER_GWETH( 21, 27) =  0.445497E+00
PKER_GWETH( 21, 28) =  0.454819E+00
PKER_GWETH( 21, 29) =  0.462647E+00
PKER_GWETH( 21, 30) =  0.469230E+00
PKER_GWETH( 21, 31) =  0.474773E+00
PKER_GWETH( 21, 32) =  0.479448E+00
PKER_GWETH( 21, 33) =  0.483396E+00
PKER_GWETH( 21, 34) =  0.486735E+00
PKER_GWETH( 21, 35) =  0.489561E+00
PKER_GWETH( 21, 36) =  0.491955E+00
PKER_GWETH( 21, 37) =  0.493987E+00
PKER_GWETH( 21, 38) =  0.495711E+00
PKER_GWETH( 21, 39) =  0.497176E+00
PKER_GWETH( 21, 40) =  0.498421E+00
PKER_GWETH( 22,  1) =  0.360950E+01
PKER_GWETH( 22,  2) =  0.303135E+01
PKER_GWETH( 22,  3) =  0.253636E+01
PKER_GWETH( 22,  4) =  0.211251E+01
PKER_GWETH( 22,  5) =  0.174949E+01
PKER_GWETH( 22,  6) =  0.143850E+01
PKER_GWETH( 22,  7) =  0.117200E+01
PKER_GWETH( 22,  8) =  0.943598E+00
PKER_GWETH( 22,  9) =  0.747958E+00
PKER_GWETH( 22, 10) =  0.580832E+00
PKER_GWETH( 22, 11) =  0.439289E+00
PKER_GWETH( 22, 12) =  0.322049E+00
PKER_GWETH( 22, 13) =  0.229775E+00
PKER_GWETH( 22, 14) =  0.164515E+00
PKER_GWETH( 22, 15) =  0.128163E+00
PKER_GWETH( 22, 16) =  0.119816E+00
PKER_GWETH( 22, 17) =  0.134267E+00
PKER_GWETH( 22, 18) =  0.163121E+00
PKER_GWETH( 22, 19) =  0.197811E+00
PKER_GWETH( 22, 20) =  0.232255E+00
PKER_GWETH( 22, 21) =  0.263416E+00
PKER_GWETH( 22, 22) =  0.290391E+00
PKER_GWETH( 22, 23) =  0.313297E+00
PKER_GWETH( 22, 24) =  0.332590E+00
PKER_GWETH( 22, 25) =  0.348779E+00
PKER_GWETH( 22, 26) =  0.362344E+00
PKER_GWETH( 22, 27) =  0.373704E+00
PKER_GWETH( 22, 28) =  0.383222E+00
PKER_GWETH( 22, 29) =  0.391204E+00
PKER_GWETH( 22, 30) =  0.397906E+00
PKER_GWETH( 22, 31) =  0.403542E+00
PKER_GWETH( 22, 32) =  0.408288E+00
PKER_GWETH( 22, 33) =  0.412291E+00
PKER_GWETH( 22, 34) =  0.415671E+00
PKER_GWETH( 22, 35) =  0.418529E+00
PKER_GWETH( 22, 36) =  0.420948E+00
PKER_GWETH( 22, 37) =  0.422998E+00
PKER_GWETH( 22, 38) =  0.424737E+00
PKER_GWETH( 22, 39) =  0.426213E+00
PKER_GWETH( 22, 40) =  0.427466E+00
PKER_GWETH( 23,  1) =  0.366493E+01
PKER_GWETH( 23,  2) =  0.308702E+01
PKER_GWETH( 23,  3) =  0.259231E+01
PKER_GWETH( 23,  4) =  0.216876E+01
PKER_GWETH( 23,  5) =  0.180608E+01
PKER_GWETH( 23,  6) =  0.149546E+01
PKER_GWETH( 23,  7) =  0.122935E+01
PKER_GWETH( 23,  8) =  0.100131E+01
PKER_GWETH( 23,  9) =  0.805877E+00
PKER_GWETH( 23, 10) =  0.638482E+00
PKER_GWETH( 23, 11) =  0.495507E+00
PKER_GWETH( 23, 12) =  0.374461E+00
PKER_GWETH( 23, 13) =  0.274294E+00
PKER_GWETH( 23, 14) =  0.195610E+00
PKER_GWETH( 23, 15) =  0.140194E+00
PKER_GWETH( 23, 16) =  0.109633E+00
PKER_GWETH( 23, 17) =  0.103053E+00
PKER_GWETH( 23, 18) =  0.115911E+00
PKER_GWETH( 23, 19) =  0.140932E+00
PKER_GWETH( 23, 20) =  0.170802E+00
PKER_GWETH( 23, 21) =  0.200361E+00
PKER_GWETH( 23, 22) =  0.227063E+00
PKER_GWETH( 23, 23) =  0.250165E+00
PKER_GWETH( 23, 24) =  0.269779E+00
PKER_GWETH( 23, 25) =  0.286298E+00
PKER_GWETH( 23, 26) =  0.300160E+00
PKER_GWETH( 23, 27) =  0.311775E+00
PKER_GWETH( 23, 28) =  0.321502E+00
PKER_GWETH( 23, 29) =  0.329651E+00
PKER_GWETH( 23, 30) =  0.336486E+00
PKER_GWETH( 23, 31) =  0.342224E+00
PKER_GWETH( 23, 32) =  0.347050E+00
PKER_GWETH( 23, 33) =  0.351113E+00
PKER_GWETH( 23, 34) =  0.354540E+00
PKER_GWETH( 23, 35) =  0.357434E+00
PKER_GWETH( 23, 36) =  0.359880E+00
PKER_GWETH( 23, 37) =  0.361951E+00
PKER_GWETH( 23, 38) =  0.363706E+00
PKER_GWETH( 23, 39) =  0.365194E+00
PKER_GWETH( 23, 40) =  0.366458E+00
PKER_GWETH( 24,  1) =  0.371238E+01
PKER_GWETH( 24,  2) =  0.313467E+01
PKER_GWETH( 24,  3) =  0.264017E+01
PKER_GWETH( 24,  4) =  0.221685E+01
PKER_GWETH( 24,  5) =  0.185444E+01
PKER_GWETH( 24,  6) =  0.154410E+01
PKER_GWETH( 24,  7) =  0.127831E+01
PKER_GWETH( 24,  8) =  0.105060E+01
PKER_GWETH( 24,  9) =  0.855474E+00
PKER_GWETH( 24, 10) =  0.688249E+00
PKER_GWETH( 24, 11) =  0.545022E+00
PKER_GWETH( 24, 12) =  0.422707E+00
PKER_GWETH( 24, 13) =  0.319192E+00
PKER_GWETH( 24, 14) =  0.233616E+00
PKER_GWETH( 24, 15) =  0.166516E+00
PKER_GWETH( 24, 16) =  0.119479E+00
PKER_GWETH( 24, 17) =  0.937955E-01
PKER_GWETH( 24, 18) =  0.886577E-01
PKER_GWETH( 24, 19) =  0.100071E+00
PKER_GWETH( 24, 20) =  0.121762E+00
PKER_GWETH( 24, 21) =  0.147476E+00
PKER_GWETH( 24, 22) =  0.172842E+00
PKER_GWETH( 24, 23) =  0.195723E+00
PKER_GWETH( 24, 24) =  0.215508E+00
PKER_GWETH( 24, 25) =  0.232302E+00
PKER_GWETH( 24, 26) =  0.246447E+00
PKER_GWETH( 24, 27) =  0.258317E+00
PKER_GWETH( 24, 28) =  0.268262E+00
PKER_GWETH( 24, 29) =  0.276591E+00
PKER_GWETH( 24, 30) =  0.283569E+00
PKER_GWETH( 24, 31) =  0.289421E+00
PKER_GWETH( 24, 32) =  0.294334E+00
PKER_GWETH( 24, 33) =  0.298465E+00
PKER_GWETH( 24, 34) =  0.301944E+00
PKER_GWETH( 24, 35) =  0.304878E+00
PKER_GWETH( 24, 36) =  0.307355E+00
PKER_GWETH( 24, 37) =  0.309450E+00
PKER_GWETH( 24, 38) =  0.311223E+00
PKER_GWETH( 24, 39) =  0.312725E+00
PKER_GWETH( 24, 40) =  0.313999E+00
PKER_GWETH( 25,  1) =  0.375303E+01
PKER_GWETH( 25,  2) =  0.317546E+01
PKER_GWETH( 25,  3) =  0.268112E+01
PKER_GWETH( 25,  4) =  0.225799E+01
PKER_GWETH( 25,  5) =  0.189577E+01
PKER_GWETH( 25,  6) =  0.158566E+01
PKER_GWETH( 25,  7) =  0.132011E+01
PKER_GWETH( 25,  8) =  0.109268E+01
PKER_GWETH( 25,  9) =  0.897836E+00
PKER_GWETH( 25, 10) =  0.730871E+00
PKER_GWETH( 25, 11) =  0.587782E+00
PKER_GWETH( 25, 12) =  0.465234E+00
PKER_GWETH( 25, 13) =  0.360595E+00
PKER_GWETH( 25, 14) =  0.272075E+00
PKER_GWETH( 25, 15) =  0.198965E+00
PKER_GWETH( 25, 16) =  0.141750E+00
PKER_GWETH( 25, 17) =  0.101826E+00
PKER_GWETH( 25, 18) =  0.802566E-01
PKER_GWETH( 25, 19) =  0.762812E-01
PKER_GWETH( 25, 20) =  0.864000E-01
PKER_GWETH( 25, 21) =  0.105199E+00
PKER_GWETH( 25, 22) =  0.127333E+00
PKER_GWETH( 25, 23) =  0.149100E+00
PKER_GWETH( 25, 24) =  0.168706E+00
PKER_GWETH( 25, 25) =  0.185649E+00
PKER_GWETH( 25, 26) =  0.200030E+00
PKER_GWETH( 25, 27) =  0.212142E+00
PKER_GWETH( 25, 28) =  0.222305E+00
PKER_GWETH( 25, 29) =  0.230821E+00
PKER_GWETH( 25, 30) =  0.237952E+00
PKER_GWETH( 25, 31) =  0.243927E+00
PKER_GWETH( 25, 32) =  0.248938E+00
PKER_GWETH( 25, 33) =  0.253145E+00
PKER_GWETH( 25, 34) =  0.256682E+00
PKER_GWETH( 25, 35) =  0.259660E+00
PKER_GWETH( 25, 36) =  0.262172E+00
PKER_GWETH( 25, 37) =  0.264293E+00
PKER_GWETH( 25, 38) =  0.266086E+00
PKER_GWETH( 25, 39) =  0.267604E+00
PKER_GWETH( 25, 40) =  0.268890E+00
PKER_GWETH( 26,  1) =  0.378785E+01
PKER_GWETH( 26,  2) =  0.321039E+01
PKER_GWETH( 26,  3) =  0.271618E+01
PKER_GWETH( 26,  4) =  0.229319E+01
PKER_GWETH( 26,  5) =  0.193113E+01
PKER_GWETH( 26,  6) =  0.162119E+01
PKER_GWETH( 26,  7) =  0.135583E+01
PKER_GWETH( 26,  8) =  0.112861E+01
PKER_GWETH( 26,  9) =  0.934001E+00
PKER_GWETH( 26, 10) =  0.767278E+00
PKER_GWETH( 26, 11) =  0.624411E+00
PKER_GWETH( 26, 12) =  0.501975E+00
PKER_GWETH( 26, 13) =  0.397120E+00
PKER_GWETH( 26, 14) =  0.307602E+00
PKER_GWETH( 26, 15) =  0.231908E+00
PKER_GWETH( 26, 16) =  0.169451E+00
PKER_GWETH( 26, 17) =  0.120682E+00
PKER_GWETH( 26, 18) =  0.867919E-01
PKER_GWETH( 26, 19) =  0.686817E-01
PKER_GWETH( 26, 20) =  0.656399E-01
PKER_GWETH( 26, 21) =  0.746001E-01
PKER_GWETH( 26, 22) =  0.908895E-01
PKER_GWETH( 26, 23) =  0.109940E+00
PKER_GWETH( 26, 24) =  0.128616E+00
PKER_GWETH( 26, 25) =  0.145415E+00
PKER_GWETH( 26, 26) =  0.159926E+00
PKER_GWETH( 26, 27) =  0.172240E+00
PKER_GWETH( 26, 28) =  0.182610E+00
PKER_GWETH( 26, 29) =  0.191313E+00
PKER_GWETH( 26, 30) =  0.198604E+00
PKER_GWETH( 26, 31) =  0.204711E+00
PKER_GWETH( 26, 32) =  0.209827E+00
PKER_GWETH( 26, 33) =  0.214117E+00
PKER_GWETH( 26, 34) =  0.217719E+00
PKER_GWETH( 26, 35) =  0.220748E+00
PKER_GWETH( 26, 36) =  0.223298E+00
PKER_GWETH( 26, 37) =  0.225448E+00
PKER_GWETH( 26, 38) =  0.227264E+00
PKER_GWETH( 26, 39) =  0.228799E+00
PKER_GWETH( 26, 40) =  0.230098E+00
PKER_GWETH( 27,  1) =  0.381769E+01
PKER_GWETH( 27,  2) =  0.324032E+01
PKER_GWETH( 27,  3) =  0.274621E+01
PKER_GWETH( 27,  4) =  0.232333E+01
PKER_GWETH( 27,  5) =  0.196138E+01
PKER_GWETH( 27,  6) =  0.165158E+01
PKER_GWETH( 27,  7) =  0.138637E+01
PKER_GWETH( 27,  8) =  0.115931E+01
PKER_GWETH( 27,  9) =  0.964884E+00
PKER_GWETH( 27, 10) =  0.798361E+00
PKER_GWETH( 27, 11) =  0.655701E+00
PKER_GWETH( 27, 12) =  0.533453E+00
PKER_GWETH( 27, 13) =  0.428689E+00
PKER_GWETH( 27, 14) =  0.338973E+00
PKER_GWETH( 27, 15) =  0.262392E+00
PKER_GWETH( 27, 16) =  0.197665E+00
PKER_GWETH( 27, 17) =  0.144311E+00
PKER_GWETH( 27, 18) =  0.102745E+00
PKER_GWETH( 27, 19) =  0.739790E-01
PKER_GWETH( 27, 20) =  0.587853E-01
PKER_GWETH( 27, 21) =  0.564914E-01
PKER_GWETH( 27, 22) =  0.644148E-01
PKER_GWETH( 27, 23) =  0.785256E-01
PKER_GWETH( 27, 24) =  0.949195E-01
PKER_GWETH( 27, 25) =  0.110944E+00
PKER_GWETH( 27, 26) =  0.125338E+00
PKER_GWETH( 27, 27) =  0.137765E+00
PKER_GWETH( 27, 28) =  0.148309E+00
PKER_GWETH( 27, 29) =  0.157189E+00
PKER_GWETH( 27, 30) =  0.164640E+00
PKER_GWETH( 27, 31) =  0.170884E+00
PKER_GWETH( 27, 32) =  0.176113E+00
PKER_GWETH( 27, 33) =  0.180493E+00
PKER_GWETH( 27, 34) =  0.184167E+00
PKER_GWETH( 27, 35) =  0.187251E+00
PKER_GWETH( 27, 36) =  0.189844E+00
PKER_GWETH( 27, 37) =  0.192027E+00
PKER_GWETH( 27, 38) =  0.193868E+00
PKER_GWETH( 27, 39) =  0.195422E+00
PKER_GWETH( 27, 40) =  0.196736E+00
PKER_GWETH( 28,  1) =  0.384328E+01
PKER_GWETH( 28,  2) =  0.326598E+01
PKER_GWETH( 28,  3) =  0.277194E+01
PKER_GWETH( 28,  4) =  0.234914E+01
PKER_GWETH( 28,  5) =  0.198729E+01
PKER_GWETH( 28,  6) =  0.167758E+01
PKER_GWETH( 28,  7) =  0.141249E+01
PKER_GWETH( 28,  8) =  0.118556E+01
PKER_GWETH( 28,  9) =  0.991272E+00
PKER_GWETH( 28, 10) =  0.824905E+00
PKER_GWETH( 28, 11) =  0.682416E+00
PKER_GWETH( 28, 12) =  0.560344E+00
PKER_GWETH( 28, 13) =  0.455740E+00
PKER_GWETH( 28, 14) =  0.366097E+00
PKER_GWETH( 28, 15) =  0.289336E+00
PKER_GWETH( 28, 16) =  0.223823E+00
PKER_GWETH( 28, 17) =  0.168475E+00
PKER_GWETH( 28, 18) =  0.122898E+00
PKER_GWETH( 28, 19) =  0.874697E-01
PKER_GWETH( 28, 20) =  0.630639E-01
PKER_GWETH( 28, 21) =  0.503212E-01
PKER_GWETH( 28, 22) =  0.486243E-01
PKER_GWETH( 28, 23) =  0.556229E-01
PKER_GWETH( 28, 24) =  0.678429E-01
PKER_GWETH( 28, 25) =  0.819496E-01
PKER_GWETH( 28, 26) =  0.956978E-01
PKER_GWETH( 28, 27) =  0.108031E+00
PKER_GWETH( 28, 28) =  0.118673E+00
PKER_GWETH( 28, 29) =  0.127702E+00
PKER_GWETH( 28, 30) =  0.135305E+00
PKER_GWETH( 28, 31) =  0.141686E+00
PKER_GWETH( 28, 32) =  0.147032E+00
PKER_GWETH( 28, 33) =  0.151509E+00
PKER_GWETH( 28, 34) =  0.155260E+00
PKER_GWETH( 28, 35) =  0.158405E+00
PKER_GWETH( 28, 36) =  0.161046E+00
PKER_GWETH( 28, 37) =  0.163266E+00
PKER_GWETH( 28, 38) =  0.165135E+00
PKER_GWETH( 28, 39) =  0.166711E+00
PKER_GWETH( 28, 40) =  0.168042E+00
PKER_GWETH( 29,  1) =  0.386522E+01
PKER_GWETH( 29,  2) =  0.328797E+01
PKER_GWETH( 29,  3) =  0.279399E+01
PKER_GWETH( 29,  4) =  0.237126E+01
PKER_GWETH( 29,  5) =  0.200948E+01
PKER_GWETH( 29,  6) =  0.169985E+01
PKER_GWETH( 29,  7) =  0.143485E+01
PKER_GWETH( 29,  8) =  0.120801E+01
PKER_GWETH( 29,  9) =  0.101383E+01
PKER_GWETH( 29, 10) =  0.847587E+00
PKER_GWETH( 29, 11) =  0.705230E+00
PKER_GWETH( 29, 12) =  0.583305E+00
PKER_GWETH( 29, 13) =  0.478852E+00
PKER_GWETH( 29, 14) =  0.389344E+00
PKER_GWETH( 29, 15) =  0.312641E+00
PKER_GWETH( 29, 16) =  0.246962E+00
PKER_GWETH( 29, 17) =  0.190919E+00
PKER_GWETH( 29, 18) =  0.143591E+00
PKER_GWETH( 29, 19) =  0.104661E+00
PKER_GWETH( 29, 20) =  0.744639E-01
PKER_GWETH( 29, 21) =  0.537613E-01
PKER_GWETH( 29, 22) =  0.430826E-01
PKER_GWETH( 29, 23) =  0.418582E-01
PKER_GWETH( 29, 24) =  0.480333E-01
PKER_GWETH( 29, 25) =  0.586131E-01
PKER_GWETH( 29, 26) =  0.707504E-01
PKER_GWETH( 29, 27) =  0.825451E-01
PKER_GWETH( 29, 28) =  0.931120E-01
PKER_GWETH( 29, 29) =  0.102226E+00
PKER_GWETH( 29, 30) =  0.109957E+00
PKER_GWETH( 29, 31) =  0.116467E+00
PKER_GWETH( 29, 32) =  0.121931E+00
PKER_GWETH( 29, 33) =  0.126508E+00
PKER_GWETH( 29, 34) =  0.130342E+00
PKER_GWETH( 29, 35) =  0.133554E+00
PKER_GWETH( 29, 36) =  0.136247E+00
PKER_GWETH( 29, 37) =  0.138508E+00
PKER_GWETH( 29, 38) =  0.140409E+00
PKER_GWETH( 29, 39) =  0.142009E+00
PKER_GWETH( 29, 40) =  0.143358E+00
PKER_GWETH( 30,  1) =  0.388404E+01
PKER_GWETH( 30,  2) =  0.330683E+01
PKER_GWETH( 30,  3) =  0.281290E+01
PKER_GWETH( 30,  4) =  0.239021E+01
PKER_GWETH( 30,  5) =  0.202849E+01
PKER_GWETH( 30,  6) =  0.171892E+01
PKER_GWETH( 30,  7) =  0.145399E+01
PKER_GWETH( 30,  8) =  0.122723E+01
PKER_GWETH( 30,  9) =  0.103313E+01
PKER_GWETH( 30, 10) =  0.866978E+00
PKER_GWETH( 30, 11) =  0.724725E+00
PKER_GWETH( 30, 12) =  0.602915E+00
PKER_GWETH( 30, 13) =  0.498586E+00
PKER_GWETH( 30, 14) =  0.409208E+00
PKER_GWETH( 30, 15) =  0.332618E+00
PKER_GWETH( 30, 16) =  0.266986E+00
PKER_GWETH( 30, 17) =  0.210791E+00
PKER_GWETH( 30, 18) =  0.162848E+00
PKER_GWETH( 30, 19) =  0.122380E+00
PKER_GWETH( 30, 20) =  0.891272E-01
PKER_GWETH( 30, 21) =  0.633929E-01
PKER_GWETH( 30, 22) =  0.458362E-01
PKER_GWETH( 30, 23) =  0.368911E-01
PKER_GWETH( 30, 24) =  0.360374E-01
PKER_GWETH( 30, 25) =  0.414816E-01
PKER_GWETH( 30, 26) =  0.506386E-01
PKER_GWETH( 30, 27) =  0.610806E-01
PKER_GWETH( 30, 28) =  0.711985E-01
PKER_GWETH( 30, 29) =  0.802521E-01
PKER_GWETH( 30, 30) =  0.880569E-01
PKER_GWETH( 30, 31) =  0.946768E-01
PKER_GWETH( 30, 32) =  0.100251E+00
PKER_GWETH( 30, 33) =  0.104929E+00
PKER_GWETH( 30, 34) =  0.108849E+00
PKER_GWETH( 30, 35) =  0.112132E+00
PKER_GWETH( 30, 36) =  0.114882E+00
PKER_GWETH( 30, 37) =  0.117188E+00
PKER_GWETH( 30, 38) =  0.119124E+00
PKER_GWETH( 30, 39) =  0.120751E+00
PKER_GWETH( 30, 40) =  0.122121E+00
PKER_GWETH( 31,  1) =  0.390018E+01
PKER_GWETH( 31,  2) =  0.332301E+01
PKER_GWETH( 31,  3) =  0.282911E+01
PKER_GWETH( 31,  4) =  0.240646E+01
PKER_GWETH( 31,  5) =  0.204478E+01
PKER_GWETH( 31,  6) =  0.173527E+01
PKER_GWETH( 31,  7) =  0.147038E+01
PKER_GWETH( 31,  8) =  0.124368E+01
PKER_GWETH( 31,  9) =  0.104965E+01
PKER_GWETH( 31, 10) =  0.883566E+00
PKER_GWETH( 31, 11) =  0.741393E+00
PKER_GWETH( 31, 12) =  0.619671E+00
PKER_GWETH( 31, 13) =  0.515440E+00
PKER_GWETH( 31, 14) =  0.426169E+00
PKER_GWETH( 31, 15) =  0.349690E+00
PKER_GWETH( 31, 16) =  0.284154E+00
PKER_GWETH( 31, 17) =  0.227995E+00
PKER_GWETH( 31, 18) =  0.179915E+00
PKER_GWETH( 31, 19) =  0.138901E+00
PKER_GWETH( 31, 20) =  0.104299E+00
PKER_GWETH( 31, 21) =  0.758983E-01
PKER_GWETH( 31, 22) =  0.539690E-01
PKER_GWETH( 31, 23) =  0.390809E-01
PKER_GWETH( 31, 24) =  0.315930E-01
PKER_GWETH( 31, 25) =  0.310308E-01
PKER_GWETH( 31, 26) =  0.358252E-01
PKER_GWETH( 31, 27) =  0.437487E-01
PKER_GWETH( 31, 28) =  0.527309E-01
PKER_GWETH( 31, 29) =  0.614103E-01
PKER_GWETH( 31, 30) =  0.691670E-01
PKER_GWETH( 31, 31) =  0.758509E-01
PKER_GWETH( 31, 32) =  0.815193E-01
PKER_GWETH( 31, 33) =  0.862925E-01
PKER_GWETH( 31, 34) =  0.902983E-01
PKER_GWETH( 31, 35) =  0.936547E-01
PKER_GWETH( 31, 36) =  0.964655E-01
PKER_GWETH( 31, 37) =  0.988203E-01
PKER_GWETH( 31, 38) =  0.100795E+00
PKER_GWETH( 31, 39) =  0.102452E+00
PKER_GWETH( 31, 40) =  0.103846E+00
PKER_GWETH( 32,  1) =  0.391403E+01
PKER_GWETH( 32,  2) =  0.333689E+01
PKER_GWETH( 32,  3) =  0.284302E+01
PKER_GWETH( 32,  4) =  0.242040E+01
PKER_GWETH( 32,  5) =  0.205875E+01
PKER_GWETH( 32,  6) =  0.174927E+01
PKER_GWETH( 32,  7) =  0.148443E+01
PKER_GWETH( 32,  8) =  0.125777E+01
PKER_GWETH( 32,  9) =  0.106379E+01
PKER_GWETH( 32, 10) =  0.897764E+00
PKER_GWETH( 32, 11) =  0.755651E+00
PKER_GWETH( 32, 12) =  0.633997E+00
PKER_GWETH( 32, 13) =  0.529842E+00
PKER_GWETH( 32, 14) =  0.440655E+00
PKER_GWETH( 32, 15) =  0.364268E+00
PKER_GWETH( 32, 16) =  0.298826E+00
PKER_GWETH( 32, 17) =  0.242749E+00
PKER_GWETH( 32, 18) =  0.194696E+00
PKER_GWETH( 32, 19) =  0.153558E+00
PKER_GWETH( 32, 20) =  0.118474E+00
PKER_GWETH( 32, 21) =  0.888878E-01
PKER_GWETH( 32, 22) =  0.646314E-01
PKER_GWETH( 32, 23) =  0.459466E-01
PKER_GWETH( 32, 24) =  0.333243E-01
PKER_GWETH( 32, 25) =  0.270613E-01
PKER_GWETH( 32, 26) =  0.267227E-01
PKER_GWETH( 32, 27) =  0.309414E-01
PKER_GWETH( 32, 28) =  0.377959E-01
PKER_GWETH( 32, 29) =  0.455211E-01
PKER_GWETH( 32, 30) =  0.529666E-01
PKER_GWETH( 32, 31) =  0.596121E-01
PKER_GWETH( 32, 32) =  0.653361E-01
PKER_GWETH( 32, 33) =  0.701897E-01
PKER_GWETH( 32, 34) =  0.742768E-01
PKER_GWETH( 32, 35) =  0.777069E-01
PKER_GWETH( 32, 36) =  0.805809E-01
PKER_GWETH( 32, 37) =  0.829877E-01
PKER_GWETH( 32, 38) =  0.850040E-01
PKER_GWETH( 32, 39) =  0.866946E-01
PKER_GWETH( 32, 40) =  0.881139E-01
PKER_GWETH( 33,  1) =  0.392592E+01
PKER_GWETH( 33,  2) =  0.334880E+01
PKER_GWETH( 33,  3) =  0.285495E+01
PKER_GWETH( 33,  4) =  0.243235E+01
PKER_GWETH( 33,  5) =  0.207073E+01
PKER_GWETH( 33,  6) =  0.176128E+01
PKER_GWETH( 33,  7) =  0.149647E+01
PKER_GWETH( 33,  8) =  0.126985E+01
PKER_GWETH( 33,  9) =  0.107590E+01
PKER_GWETH( 33, 10) =  0.909920E+00
PKER_GWETH( 33, 11) =  0.767855E+00
PKER_GWETH( 33, 12) =  0.646253E+00
PKER_GWETH( 33, 13) =  0.542157E+00
PKER_GWETH( 33, 14) =  0.453034E+00
PKER_GWETH( 33, 15) =  0.376719E+00
PKER_GWETH( 33, 16) =  0.311356E+00
PKER_GWETH( 33, 17) =  0.255359E+00
PKER_GWETH( 33, 18) =  0.207375E+00
PKER_GWETH( 33, 19) =  0.166259E+00
PKER_GWETH( 33, 20) =  0.131060E+00
PKER_GWETH( 33, 21) =  0.101048E+00
PKER_GWETH( 33, 22) =  0.757518E-01
PKER_GWETH( 33, 23) =  0.550354E-01
PKER_GWETH( 33, 24) =  0.391173E-01
PKER_GWETH( 33, 25) =  0.284177E-01
PKER_GWETH( 33, 26) =  0.231819E-01
PKER_GWETH( 33, 27) =  0.230157E-01
PKER_GWETH( 33, 28) =  0.267246E-01
PKER_GWETH( 33, 29) =  0.326527E-01
PKER_GWETH( 33, 30) =  0.392968E-01
PKER_GWETH( 33, 31) =  0.456828E-01
PKER_GWETH( 33, 32) =  0.513763E-01
PKER_GWETH( 33, 33) =  0.562781E-01
PKER_GWETH( 33, 34) =  0.604341E-01
PKER_GWETH( 33, 35) =  0.639338E-01
PKER_GWETH( 33, 36) =  0.668709E-01
PKER_GWETH( 33, 37) =  0.693318E-01
PKER_GWETH( 33, 38) =  0.713927E-01
PKER_GWETH( 33, 39) =  0.731192E-01
PKER_GWETH( 33, 40) =  0.745668E-01
PKER_GWETH( 34,  1) =  0.393613E+01
PKER_GWETH( 34,  2) =  0.335902E+01
PKER_GWETH( 34,  3) =  0.286518E+01
PKER_GWETH( 34,  4) =  0.244261E+01
PKER_GWETH( 34,  5) =  0.208101E+01
PKER_GWETH( 34,  6) =  0.177158E+01
PKER_GWETH( 34,  7) =  0.150679E+01
PKER_GWETH( 34,  8) =  0.128020E+01
PKER_GWETH( 34,  9) =  0.108628E+01
PKER_GWETH( 34, 10) =  0.920332E+00
PKER_GWETH( 34, 11) =  0.778304E+00
PKER_GWETH( 34, 12) =  0.656742E+00
PKER_GWETH( 34, 13) =  0.552691E+00
PKER_GWETH( 34, 14) =  0.463618E+00
PKER_GWETH( 34, 15) =  0.387358E+00
PKER_GWETH( 34, 16) =  0.322057E+00
PKER_GWETH( 34, 17) =  0.266128E+00
PKER_GWETH( 34, 18) =  0.218213E+00
PKER_GWETH( 34, 19) =  0.177154E+00
PKER_GWETH( 34, 20) =  0.141973E+00
PKER_GWETH( 34, 21) =  0.111857E+00
PKER_GWETH( 34, 22) =  0.861834E-01
PKER_GWETH( 34, 23) =  0.645549E-01
PKER_GWETH( 34, 24) =  0.468637E-01
PKER_GWETH( 34, 25) =  0.333029E-01
PKER_GWETH( 34, 26) =  0.242359E-01
PKER_GWETH( 34, 27) =  0.198623E-01
PKER_GWETH( 34, 28) =  0.198248E-01
PKER_GWETH( 34, 29) =  0.230830E-01
PKER_GWETH( 34, 30) =  0.282089E-01
PKER_GWETH( 34, 31) =  0.339228E-01
PKER_GWETH( 34, 32) =  0.393998E-01
PKER_GWETH( 34, 33) =  0.442776E-01
PKER_GWETH( 34, 34) =  0.484753E-01
PKER_GWETH( 34, 35) =  0.520340E-01
PKER_GWETH( 34, 36) =  0.550307E-01
PKER_GWETH( 34, 37) =  0.575456E-01
PKER_GWETH( 34, 38) =  0.596528E-01
PKER_GWETH( 34, 39) =  0.614176E-01
PKER_GWETH( 34, 40) =  0.628959E-01
PKER_GWETH( 35,  1) =  0.394489E+01
PKER_GWETH( 35,  2) =  0.336779E+01
PKER_GWETH( 35,  3) =  0.287397E+01
PKER_GWETH( 35,  4) =  0.245141E+01
PKER_GWETH( 35,  5) =  0.208983E+01
PKER_GWETH( 35,  6) =  0.178041E+01
PKER_GWETH( 35,  7) =  0.151564E+01
PKER_GWETH( 35,  8) =  0.128907E+01
PKER_GWETH( 35,  9) =  0.109518E+01
PKER_GWETH( 35, 10) =  0.929255E+00
PKER_GWETH( 35, 11) =  0.787254E+00
PKER_GWETH( 35, 12) =  0.665724E+00
PKER_GWETH( 35, 13) =  0.561707E+00
PKER_GWETH( 35, 14) =  0.472673E+00
PKER_GWETH( 35, 15) =  0.396456E+00
PKER_GWETH( 35, 16) =  0.331202E+00
PKER_GWETH( 35, 17) =  0.275326E+00
PKER_GWETH( 35, 18) =  0.227468E+00
PKER_GWETH( 35, 19) =  0.186468E+00
PKER_GWETH( 35, 20) =  0.151336E+00
PKER_GWETH( 35, 21) =  0.121232E+00
PKER_GWETH( 35, 22) =  0.954658E-01
PKER_GWETH( 35, 23) =  0.735038E-01
PKER_GWETH( 35, 24) =  0.550122E-01
PKER_GWETH( 35, 25) =  0.399049E-01
PKER_GWETH( 35, 26) =  0.283536E-01
PKER_GWETH( 35, 27) =  0.206713E-01
PKER_GWETH( 35, 28) =  0.170206E-01
PKER_GWETH( 35, 29) =  0.170782E-01
PKER_GWETH( 35, 30) =  0.199378E-01
PKER_GWETH( 35, 31) =  0.243699E-01
PKER_GWETH( 35, 32) =  0.292827E-01
PKER_GWETH( 35, 33) =  0.339802E-01
PKER_GWETH( 35, 34) =  0.381591E-01
PKER_GWETH( 35, 35) =  0.417538E-01
PKER_GWETH( 35, 36) =  0.448011E-01
PKER_GWETH( 35, 37) =  0.473670E-01
PKER_GWETH( 35, 38) =  0.495205E-01
PKER_GWETH( 35, 39) =  0.513249E-01
PKER_GWETH( 35, 40) =  0.528360E-01
PKER_GWETH( 36,  1) =  0.395241E+01
PKER_GWETH( 36,  2) =  0.337532E+01
PKER_GWETH( 36,  3) =  0.288151E+01
PKER_GWETH( 36,  4) =  0.245896E+01
PKER_GWETH( 36,  5) =  0.209739E+01
PKER_GWETH( 36,  6) =  0.178799E+01
PKER_GWETH( 36,  7) =  0.152324E+01
PKER_GWETH( 36,  8) =  0.129668E+01
PKER_GWETH( 36,  9) =  0.110281E+01
PKER_GWETH( 36, 10) =  0.936903E+00
PKER_GWETH( 36, 11) =  0.794924E+00
PKER_GWETH( 36, 12) =  0.673418E+00
PKER_GWETH( 36, 13) =  0.569428E+00
PKER_GWETH( 36, 14) =  0.480423E+00
PKER_GWETH( 36, 15) =  0.404239E+00
PKER_GWETH( 36, 16) =  0.339022E+00
PKER_GWETH( 36, 17) =  0.283186E+00
PKER_GWETH( 36, 18) =  0.235374E+00
PKER_GWETH( 36, 19) =  0.194423E+00
PKER_GWETH( 36, 20) =  0.159341E+00
PKER_GWETH( 36, 21) =  0.129279E+00
PKER_GWETH( 36, 22) =  0.103521E+00
PKER_GWETH( 36, 23) =  0.814749E-01
PKER_GWETH( 36, 24) =  0.626882E-01
PKER_GWETH( 36, 25) =  0.468787E-01
PKER_GWETH( 36, 26) =  0.339780E-01
PKER_GWETH( 36, 27) =  0.241398E-01
PKER_GWETH( 36, 28) =  0.176327E-01
PKER_GWETH( 36, 29) =  0.145874E-01
PKER_GWETH( 36, 30) =  0.147147E-01
PKER_GWETH( 36, 31) =  0.172211E-01
PKER_GWETH( 36, 32) =  0.210528E-01
PKER_GWETH( 36, 33) =  0.252768E-01
PKER_GWETH( 36, 34) =  0.293056E-01
PKER_GWETH( 36, 35) =  0.328855E-01
PKER_GWETH( 36, 36) =  0.359639E-01
PKER_GWETH( 36, 37) =  0.385732E-01
PKER_GWETH( 36, 38) =  0.407703E-01
PKER_GWETH( 36, 39) =  0.426143E-01
PKER_GWETH( 36, 40) =  0.441594E-01
PKER_GWETH( 37,  1) =  0.395887E+01
PKER_GWETH( 37,  2) =  0.338179E+01
PKER_GWETH( 37,  3) =  0.288799E+01
PKER_GWETH( 37,  4) =  0.246545E+01
PKER_GWETH( 37,  5) =  0.210388E+01
PKER_GWETH( 37,  6) =  0.179450E+01
PKER_GWETH( 37,  7) =  0.152975E+01
PKER_GWETH( 37,  8) =  0.130321E+01
PKER_GWETH( 37,  9) =  0.110935E+01
PKER_GWETH( 37, 10) =  0.943460E+00
PKER_GWETH( 37, 11) =  0.801498E+00
PKER_GWETH( 37, 12) =  0.680011E+00
PKER_GWETH( 37, 13) =  0.576041E+00
PKER_GWETH( 37, 14) =  0.487060E+00
PKER_GWETH( 37, 15) =  0.410901E+00
PKER_GWETH( 37, 16) =  0.345712E+00
PKER_GWETH( 37, 17) =  0.289908E+00
PKER_GWETH( 37, 18) =  0.242130E+00
PKER_GWETH( 37, 19) =  0.201218E+00
PKER_GWETH( 37, 20) =  0.166178E+00
PKER_GWETH( 37, 21) =  0.136159E+00
PKER_GWETH( 37, 22) =  0.110436E+00
PKER_GWETH( 37, 23) =  0.883954E-01
PKER_GWETH( 37, 24) =  0.695332E-01
PKER_GWETH( 37, 25) =  0.534630E-01
PKER_GWETH( 37, 26) =  0.399468E-01
PKER_GWETH( 37, 27) =  0.289314E-01
PKER_GWETH( 37, 28) =  0.205525E-01
PKER_GWETH( 37, 29) =  0.150421E-01
PKER_GWETH( 37, 30) =  0.125040E-01
PKER_GWETH( 37, 31) =  0.126787E-01
PKER_GWETH( 37, 32) =  0.148743E-01
PKER_GWETH( 37, 33) =  0.181871E-01
PKER_GWETH( 37, 34) =  0.218185E-01
PKER_GWETH( 37, 35) =  0.252735E-01
PKER_GWETH( 37, 36) =  0.283403E-01
PKER_GWETH( 37, 37) =  0.309765E-01
PKER_GWETH( 37, 38) =  0.332107E-01
PKER_GWETH( 37, 39) =  0.350921E-01
PKER_GWETH( 37, 40) =  0.366711E-01
PKER_GWETH( 38,  1) =  0.396441E+01
PKER_GWETH( 38,  2) =  0.338734E+01
PKER_GWETH( 38,  3) =  0.289354E+01
PKER_GWETH( 38,  4) =  0.247101E+01
PKER_GWETH( 38,  5) =  0.210946E+01
PKER_GWETH( 38,  6) =  0.180008E+01
PKER_GWETH( 38,  7) =  0.153534E+01
PKER_GWETH( 38,  8) =  0.130881E+01
PKER_GWETH( 38,  9) =  0.111496E+01
PKER_GWETH( 38, 10) =  0.949083E+00
PKER_GWETH( 38, 11) =  0.807135E+00
PKER_GWETH( 38, 12) =  0.685662E+00
PKER_GWETH( 38, 13) =  0.581708E+00
PKER_GWETH( 38, 14) =  0.492744E+00
PKER_GWETH( 38, 15) =  0.416605E+00
PKER_GWETH( 38, 16) =  0.351438E+00
PKER_GWETH( 38, 17) =  0.295658E+00
PKER_GWETH( 38, 18) =  0.247908E+00
PKER_GWETH( 38, 19) =  0.207026E+00
PKER_GWETH( 38, 20) =  0.172018E+00
PKER_GWETH( 38, 21) =  0.142035E+00
PKER_GWETH( 38, 22) =  0.116348E+00
PKER_GWETH( 38, 23) =  0.943377E-01
PKER_GWETH( 38, 24) =  0.754790E-01
PKER_GWETH( 38, 25) =  0.593406E-01
PKER_GWETH( 38, 26) =  0.455943E-01
PKER_GWETH( 38, 27) =  0.340390E-01
PKER_GWETH( 38, 28) =  0.246337E-01
PKER_GWETH( 38, 29) =  0.174989E-01
PKER_GWETH( 38, 30) =  0.128332E-01
PKER_GWETH( 38, 31) =  0.107204E-01
PKER_GWETH( 38, 32) =  0.109262E-01
PKER_GWETH( 38, 33) =  0.128475E-01
PKER_GWETH( 38, 34) =  0.157112E-01
PKER_GWETH( 38, 35) =  0.188328E-01
PKER_GWETH( 38, 36) =  0.217958E-01
PKER_GWETH( 38, 37) =  0.244229E-01
PKER_GWETH( 38, 38) =  0.266804E-01
PKER_GWETH( 38, 39) =  0.285935E-01
PKER_GWETH( 38, 40) =  0.302045E-01
PKER_GWETH( 39,  1) =  0.396918E+01
PKER_GWETH( 39,  2) =  0.339211E+01
PKER_GWETH( 39,  3) =  0.289832E+01
PKER_GWETH( 39,  4) =  0.247579E+01
PKER_GWETH( 39,  5) =  0.211424E+01
PKER_GWETH( 39,  6) =  0.180487E+01
PKER_GWETH( 39,  7) =  0.154014E+01
PKER_GWETH( 39,  8) =  0.131362E+01
PKER_GWETH( 39,  9) =  0.111978E+01
PKER_GWETH( 39, 10) =  0.953907E+00
PKER_GWETH( 39, 11) =  0.811969E+00
PKER_GWETH( 39, 12) =  0.690507E+00
PKER_GWETH( 39, 13) =  0.586566E+00
PKER_GWETH( 39, 14) =  0.497616E+00
PKER_GWETH( 39, 15) =  0.421492E+00
PKER_GWETH( 39, 16) =  0.356342E+00
PKER_GWETH( 39, 17) =  0.300580E+00
PKER_GWETH( 39, 18) =  0.252850E+00
PKER_GWETH( 39, 19) =  0.211991E+00
PKER_GWETH( 39, 20) =  0.177010E+00
PKER_GWETH( 39, 21) =  0.147055E+00
PKER_GWETH( 39, 22) =  0.121399E+00
PKER_GWETH( 39, 23) =  0.994194E-01
PKER_GWETH( 39, 24) =  0.805856E-01
PKER_GWETH( 39, 25) =  0.644491E-01
PKER_GWETH( 39, 26) =  0.506413E-01
PKER_GWETH( 39, 27) =  0.388827E-01
PKER_GWETH( 39, 28) =  0.290042E-01
PKER_GWETH( 39, 29) =  0.209741E-01
PKER_GWETH( 39, 30) =  0.148991E-01
PKER_GWETH( 39, 31) =  0.109496E-01
PKER_GWETH( 39, 32) =  0.919163E-02
PKER_GWETH( 39, 33) =  0.941674E-02
PKER_GWETH( 39, 34) =  0.110979E-01
PKER_GWETH( 39, 35) =  0.135723E-01
PKER_GWETH( 39, 36) =  0.162554E-01
PKER_GWETH( 39, 37) =  0.187961E-01
PKER_GWETH( 39, 38) =  0.210466E-01
PKER_GWETH( 39, 39) =  0.229798E-01
PKER_GWETH( 39, 40) =  0.246180E-01
PKER_GWETH( 40,  1) =  0.397327E+01
PKER_GWETH( 40,  2) =  0.339620E+01
PKER_GWETH( 40,  3) =  0.290242E+01
PKER_GWETH( 40,  4) =  0.247989E+01
PKER_GWETH( 40,  5) =  0.211835E+01
PKER_GWETH( 40,  6) =  0.180898E+01
PKER_GWETH( 40,  7) =  0.154426E+01
PKER_GWETH( 40,  8) =  0.131774E+01
PKER_GWETH( 40,  9) =  0.112391E+01
PKER_GWETH( 40, 10) =  0.958046E+00
PKER_GWETH( 40, 11) =  0.816115E+00
PKER_GWETH( 40, 12) =  0.694662E+00
PKER_GWETH( 40, 13) =  0.590731E+00
PKER_GWETH( 40, 14) =  0.501791E+00
PKER_GWETH( 40, 15) =  0.425679E+00
PKER_GWETH( 40, 16) =  0.360542E+00
PKER_GWETH( 40, 17) =  0.304795E+00
PKER_GWETH( 40, 18) =  0.257081E+00
PKER_GWETH( 40, 19) =  0.216240E+00
PKER_GWETH( 40, 20) =  0.181278E+00
PKER_GWETH( 40, 21) =  0.151345E+00
PKER_GWETH( 40, 22) =  0.125714E+00
PKER_GWETH( 40, 23) =  0.103760E+00
PKER_GWETH( 40, 24) =  0.849530E-01
PKER_GWETH( 40, 25) =  0.688374E-01
PKER_GWETH( 40, 26) =  0.550302E-01
PKER_GWETH( 40, 27) =  0.432166E-01
PKER_GWETH( 40, 28) =  0.331585E-01
PKER_GWETH( 40, 29) =  0.247136E-01
PKER_GWETH( 40, 30) =  0.178579E-01
PKER_GWETH( 40, 31) =  0.126858E-01
PKER_GWETH( 40, 32) =  0.934299E-02
PKER_GWETH( 40, 33) =  0.788297E-02
PKER_GWETH( 40, 34) =  0.811672E-02
PKER_GWETH( 40, 35) =  0.958788E-02
PKER_GWETH( 40, 36) =  0.117243E-01
PKER_GWETH( 40, 37) =  0.140303E-01
PKER_GWETH( 40, 38) =  0.162089E-01
PKER_GWETH( 40, 39) =  0.181368E-01
PKER_GWETH( 40, 40) =  0.197923E-01
END IF
!
END SUBROUTINE LIMA_READ_XKER_GWETH
