!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!******************************************************************

! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : RBK90_Parameters.f90
! Time                 : Mon Apr 16 16:40:45 2007
! Working directory    : /home/pinjp/chimie_num/kpp/kpp-2.2.1.December2006/my-test-NumRec
! Equation file        : RBK90.kpp
! Output root filename : RBK90
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


MODULE MODD_RBK90_Parameters_n
USE MODD_PARAMETERS, ONLY: JPMODELMAX
IMPLICIT NONE
PUBLIC
!SAVE

TYPE RBK90_Parameters_t

! NSPEC - Number of chemical species
    INTEGER :: NSPEC
! NVAR - Number of Variable species
    INTEGER :: NVAR
! NVARACT - Number of Active species
    INTEGER :: NVARACT
! NFIX - Number of Fixed species
    INTEGER :: NFIX
! NREACT - Number of reactions
    INTEGER :: NREACT
! NVARST - Starting of variables in conc. vect.
    INTEGER :: NVARST
! NFIXST - Starting of fixed in conc. vect.
    INTEGER :: NFIXST
! NONZERO - Number of nonzero entries in Jacobian
    INTEGER :: NONZERO
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
    INTEGER :: LU_NONZERO
! CNVAR - (NVAR+1) Number of elements in compressed row format
    INTEGER :: CNVAR
! CNEQN - (NREACT+1) Number stoicm elements in compressed col format
    INTEGER :: CNEQN
! NHESS - Length of Sparse Hessian
    INTEGER :: NHESS
! NLOOKAT - Number of species to look at
    INTEGER :: NLOOKAT
! NMONITOR - Number of species to monitor
    INTEGER :: NMONITOR
! NMASS - Number of atoms to check mass balance
    INTEGER :: NMASS

! NJVRP - Length of sparse Jacobian JVRP
    INTEGER :: NJVRP

! NSTOICM - Length of Sparse Stoichiometric Matrix
    INTEGER :: NSTOICM

END TYPE RBK90_Parameters_t

TYPE(RBK90_Parameters_t), DIMENSION(JPMODELMAX), TARGET, SAVE :: RBK90_Parameters_MODEL

INTEGER, POINTER :: NSPEC=>NULL()
INTEGER, POINTER :: NVAR=>NULL()
INTEGER, POINTER :: NVARACT=>NULL()
INTEGER, POINTER :: NFIX=>NULL()
INTEGER, POINTER :: NREACT=>NULL()
INTEGER, POINTER :: NVARST=>NULL()
INTEGER, POINTER :: NFIXST=>NULL()
INTEGER, POINTER :: NONZERO=>NULL()
INTEGER, POINTER :: LU_NONZERO=>NULL()
INTEGER, POINTER :: CNVAR=>NULL()
INTEGER, POINTER :: CNEQN=>NULL()
INTEGER, POINTER :: NHESS=>NULL()
INTEGER, POINTER :: NLOOKAT=>NULL()
INTEGER, POINTER :: NMONITOR=>NULL()
INTEGER, POINTER :: NMASS=>NULL()
INTEGER, POINTER :: NJVRP=>NULL()
INTEGER, POINTER :: NSTOICM=>NULL()

CONTAINS

SUBROUTINE RBK90_Parameters_GOTO_MODEL(KFROM, KTO)
INTEGER, INTENT(IN) :: KFROM, KTO
!
! Save current state for allocated arrays
!
! Current model is set to model KTO
NSPEC=>RBK90_Parameters_MODEL(KTO)%NSPEC
NVAR=>RBK90_Parameters_MODEL(KTO)%NVAR
NVARACT=>RBK90_Parameters_MODEL(KTO)%NVARACT
NFIX=>RBK90_Parameters_MODEL(KTO)%NFIX
NREACT=>RBK90_Parameters_MODEL(KTO)%NREACT
NVARST=>RBK90_Parameters_MODEL(KTO)%NVARST
NFIXST=>RBK90_Parameters_MODEL(KTO)%NFIXST
NONZERO=>RBK90_Parameters_MODEL(KTO)%NONZERO
LU_NONZERO=>RBK90_Parameters_MODEL(KTO)%LU_NONZERO
CNVAR=>RBK90_Parameters_MODEL(KTO)%CNVAR
CNEQN=>RBK90_Parameters_MODEL(KTO)%CNEQN
NHESS=>RBK90_Parameters_MODEL(KTO)%NHESS
NLOOKAT=>RBK90_Parameters_MODEL(KTO)%NLOOKAT
NMONITOR=>RBK90_Parameters_MODEL(KTO)%NMONITOR
NMASS=>RBK90_Parameters_MODEL(KTO)%NMASS
NJVRP=>RBK90_Parameters_MODEL(KTO)%NJVRP
NSTOICM=>RBK90_Parameters_MODEL(KTO)%NSTOICM

END SUBROUTINE RBK90_Parameters_GOTO_MODEL

END MODULE MODD_RBK90_Parameters_n
