!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! MASDEV4_7 modd 2006/06/27 12:43:28
!-----------------------------------------------------------------
!!    ############################ 
      MODULE MODD_SUB_CH_FIELD_VALUE_n
!!    ############################ 
!
USE MODD_PARAMETERS, ONLY: JPMODELMAX
IMPLICIT NONE

TYPE SUB_CH_FIELD_VALUE_t
!
  LOGICAL :: GSFIRSTCALL = .TRUE.! flag to identify first call
  INTEGER :: ISPROF               ! # of norm-profiles
  INTEGER :: ISLEVEL              ! # of levels in norm-profiles
  INTEGER :: ISINIT               ! # of variable associations
  INTEGER :: ISASSO               ! # of variable associations
  REAL, DIMENSION(:,:), POINTER :: ZSNORMPROF=>NULL() ! norm-profiles
  REAL, DIMENSION(:)  , POINTER :: ZSZPROF=>NULL()    ! z-level for norm-profile
  CHARACTER(LEN=40), DIMENSION(:), POINTER :: YSASSONAME=>NULL() ! asso species
  INTEGER          , DIMENSION(:), POINTER :: ISASSOPROF=>NULL() ! profile index
  CHARACTER(LEN=40), DIMENSION(:), POINTER :: YSINITNAME=>NULL() ! init species
  REAL             , DIMENSION(:), POINTER :: ZSINITVAL=>NULL()  ! initial val.
                                                         ! in molec./cm3
END TYPE SUB_CH_FIELD_VALUE_t

TYPE(SUB_CH_FIELD_VALUE_t), DIMENSION(JPMODELMAX), TARGET, SAVE :: SUB_CH_FIELD_VALUE_MODEL

LOGICAL, POINTER :: GSFIRSTCALL=>NULL()
INTEGER, POINTER :: ISPROF=>NULL()
INTEGER, POINTER :: ISLEVEL=>NULL()
INTEGER, POINTER :: ISINIT=>NULL()
INTEGER, POINTER :: ISASSO=>NULL()
REAL, DIMENSION(:,:), POINTER :: ZSNORMPROF=>NULL()
REAL, DIMENSION(:)  , POINTER :: ZSZPROF=>NULL()
CHARACTER(LEN=40), DIMENSION(:), POINTER :: YSASSONAME=>NULL()
INTEGER          , DIMENSION(:), POINTER :: ISASSOPROF=>NULL()
CHARACTER(LEN=40), DIMENSION(:), POINTER :: YSINITNAME=>NULL()
REAL             , DIMENSION(:), POINTER :: ZSINITVAL=>NULL()

CONTAINS

SUBROUTINE SUB_CH_FIELD_VALUE_GOTO_MODEL(KFROM, KTO)
INTEGER, INTENT(IN) :: KFROM, KTO
!
! Save current state for allocated arrays
SUB_CH_FIELD_VALUE_MODEL(KFROM)%ZSNORMPROF=>ZSNORMPROF
SUB_CH_FIELD_VALUE_MODEL(KFROM)%ZSZPROF=>ZSZPROF
SUB_CH_FIELD_VALUE_MODEL(KFROM)%YSASSONAME=>YSASSONAME
SUB_CH_FIELD_VALUE_MODEL(KFROM)%ISASSOPROF=>ISASSOPROF
SUB_CH_FIELD_VALUE_MODEL(KFROM)%YSINITNAME=>YSINITNAME
SUB_CH_FIELD_VALUE_MODEL(KFROM)%ZSINITVAL=>ZSINITVAL
!
! Current model is set to model KTO
GSFIRSTCALL=>SUB_CH_FIELD_VALUE_MODEL(KTO)%GSFIRSTCALL
ISPROF=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ISPROF
ISLEVEL=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ISLEVEL
ISINIT=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ISINIT
ISASSO=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ISASSO
ZSNORMPROF=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ZSNORMPROF
ZSZPROF=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ZSZPROF
YSASSONAME=>SUB_CH_FIELD_VALUE_MODEL(KTO)%YSASSONAME
ISASSOPROF=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ISASSOPROF
YSINITNAME=>SUB_CH_FIELD_VALUE_MODEL(KTO)%YSINITNAME
ZSINITVAL=>SUB_CH_FIELD_VALUE_MODEL(KTO)%ZSINITVAL

END SUBROUTINE SUB_CH_FIELD_VALUE_GOTO_MODEL

END MODULE MODD_SUB_CH_FIELD_VALUE_n
