!MNH_LIC Copyright 1994-2019 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
! Modifications
!  P. Wautelet 08/02/2019: add missing NULL association for pointers
MODULE MODD_TIMEZ

  USE MODD_PARAMETERS, ONLY: JPMODELMAX

  TYPE SUB_TIMEZ_T
     REAL*8,DIMENSION(2) :: T_MAP_B_SX_YP2_ZP1  = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SX_YP2_ZP1_SXP2_Y_ZP1 = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SXP2_Y_ZP1_B  = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_B_SXP2_Y_ZP1  = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SXP2_Y_ZP1_SX_YP2_ZP1 = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SX_YP2_ZP1_B  = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SXP2_Y_ZP1_SXP2_YP1_Z = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SXP2_YP1_Z_SXP2_Y_ZP1  = 0.0
          
     REAL*8,DIMENSION(2) :: T_MAP_SXP1_YP2_Z_SX_YP2_ZP1 = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SXP2_Y_ZP1_SXP1_YP2_Z  = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SXP1_YP2_Z_SXP2_Y_ZP1  = 0.0
     REAL*8,DIMENSION(2) :: T_MAP_SX_YP2_ZP1_SXP1_YP2_Z  = 0.0
          
     REAL*8,DIMENSION(2) :: T_WRIT3D_RECV = 0.0
     REAL*8,DIMENSION(2) :: T_WRIT3D_SEND = 0.0
     REAL*8,DIMENSION(2) :: T_WRIT3D_WRIT = 0.0
     REAL*8,DIMENSION(2) :: T_WRIT3D_WAIT = 0.0
     REAL*8,DIMENSION(2) :: T_WRIT3D_ALL  = 0.0

     REAL*8,DIMENSION(2) :: T_WRIT2D_GATH = 0.0
     REAL*8,DIMENSION(2) :: T_WRIT2D_WRIT = 0.0
     REAL*8,DIMENSION(2) :: T_WRIT2D_ALL  = 0.0

     REAL*8,DIMENSION(2) :: T_READ3D_RECV = 0.0
     REAL*8,DIMENSION(2) :: T_READ3D_SEND = 0.0
     REAL*8,DIMENSION(2) :: T_READ3D_READ = 0.0
     REAL*8,DIMENSION(2) :: T_READ3D_WAIT = 0.0
     REAL*8,DIMENSION(2) :: T_READ3D_ALL  = 0.0
     
     REAL*8,DIMENSION(2) :: T_READ2D_SCAT = 0.0
     REAL*8,DIMENSION(2) :: T_READ2D_READ = 0.0
     REAL*8,DIMENSION(2) :: T_READ2D_ALL  = 0.0

     REAL*8,DIMENSION(2) :: T_READLB_RECV = 0.0
     REAL*8,DIMENSION(2) :: T_READLB_SEND = 0.0
     REAL*8,DIMENSION(2) :: T_READLB_READ = 0.0
     REAL*8,DIMENSION(2) :: T_READLB_WAIT = 0.0
     REAL*8,DIMENSION(2) :: T_READLB_ALL  = 0.0
     
 END TYPE SUB_TIMEZ_T

TYPE(SUB_TIMEZ_t), DIMENSION(JPMODELMAX), TARGET, SAVE :: SUB_TIMEZN

TYPE(SUB_TIMEZ_t), POINTER  :: TIMEZ => NULL()

CONTAINS

SUBROUTINE TIMEZ_GOTO_MODEL(KFROM, KTO)
INTEGER, INTENT(IN) :: KFROM, KTO

TIMEZ => SUB_TIMEZN(KTO)

END SUBROUTINE TIMEZ_GOTO_MODEL

END MODULE MODD_TIMEZ
