!MNH_LIC Copyright 1994-2018 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
MODULE MODE_TYPE_ZDIFFU

USE MODD_DYNZD

CONTAINS
SUBROUTINE INIT_TYPE_ZDIFFU_HALO2(PTYPE_ZDIFFU_HALO2,KSIZE_ZERO)
! Modifications:
!  Philippe 12/01/2018: renamed dimension variable NKMAX_ll->NKMAX_TMP_ll to prevent mix-up with modd_dimn
!
!
!*       0.    DECLARATIONS
!              ------------
USE MODD_PARAMETERS , ONLY : JPVEXT
USE MODD_DIM_ll     , ONLY : NKMAX_TMP_ll
!
IMPLICIT NONE
!
!
!*       0.1   declarations of arguments
!
TYPE (TYPE_ZDIFFU_HALO2) :: PTYPE_ZDIFFU_HALO2
INTEGER , OPTIONAL       :: KSIZE_ZERO ! init to size=0 if present 
!
!*       0.2   declarations of local variables
!
INTEGER                    :: IIB,IJB,IKB   ! Lower bounds of the physical 
                                            ! sub-domain in x,y and z directions
INTEGER                    :: IIE,IJE,IKE   ! Upper bounds of the physical
                                            ! sub-domain in x,y and z directions
INTEGER                    :: IIU,IJU,IKU   ! domain sizes
!
!*       0.    PROLOGUE
!              --------
!
IF (.NOT.PRESENT(KSIZE_ZERO)) THEN
! Init all array with halo2  size
CALL GET_INDICE_ll(IIB,IJB,IIE,IJE)
CALL GET_DIM_EXT_ll('B',IIU,IJU)
IKU = NKMAX_TMP_ll + 2*JPVEXT
!
! initialisation of data array
! 
ALLOCATE (PTYPE_ZDIFFU_HALO2%XZZ(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
PTYPE_ZDIFFU_HALO2%XZZ = 0.0
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIP1(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIP2(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIM1(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIM2(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJP1(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJP2(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJM1(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJM2(IIB-2:IIE+2,IJB-2:IJE+2,IKU))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XREDFACI(IIB-2:IIE+2,IJB-2:IJE+2))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XREDFACJ(IIB-2:IIE+2,IJB-2:IJE+2))

ALLOCATE(PTYPE_ZDIFFU_HALO2%NZDI(IIB-2:IIE+2,IJB-2:IJE+2))
ALLOCATE(PTYPE_ZDIFFU_HALO2%NZDJ(IIB-2:IIE+2,IJB-2:IJE+2))
!
ELSE
! init all array to "zero" size

ALLOCATE (PTYPE_ZDIFFU_HALO2%XZZ(0,0,0))
PTYPE_ZDIFFU_HALO2%XZZ = 0.0

ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIP1(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIP2(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIM1(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKIM2(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJP1(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJP2(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJM1(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XRKJM2(0,0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XREDFACI(0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%XREDFACJ(0,0))

ALLOCATE(PTYPE_ZDIFFU_HALO2%NZDI(0,0))
ALLOCATE(PTYPE_ZDIFFU_HALO2%NZDJ(0,0))
ENDIF
!
END SUBROUTINE INIT_TYPE_ZDIFFU_HALO2
END MODULE MODE_TYPE_ZDIFFU
