!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! MASDEV4_7 init 2006/05/18 13:07:25
!-----------------------------------------------------------------
!     ###########################
      MODULE MODI_READ_XKER_RDRYG
!     ###########################
!
INTERFACE
      SUBROUTINE READ_XKER_RDRYG (KDRYLBDAG,KDRYLBDAR,KND,                   &
                    PALPHAG,PNUG,PALPHAR,PNUR,PEGR,PBR,PCG,PDG,PCR,PDR,      &
                    PDRYLBDAG_MAX,PDRYLBDAR_MAX,PDRYLBDAG_MIN,PDRYLBDAR_MIN, &
                    PFDINFTY,PKER_RDRYG                                      )
!
INTEGER, INTENT(OUT) :: KND,KDRYLBDAG,KDRYLBDAR
REAL,    INTENT(OUT) :: PALPHAG
REAL,    INTENT(OUT) :: PNUG
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PEGR
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCG
REAL,    INTENT(OUT) :: PDG
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PDRYLBDAG_MAX
REAL,    INTENT(OUT) :: PDRYLBDAR_MAX
REAL,    INTENT(OUT) :: PDRYLBDAG_MIN
REAL,    INTENT(OUT) :: PDRYLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RDRYG 
!
END SUBROUTINE 
!
END INTERFACE
!
END MODULE MODI_READ_XKER_RDRYG
!     ########################################################################
      SUBROUTINE READ_XKER_RDRYG (KDRYLBDAG,KDRYLBDAR,KND,                   &
                    PALPHAG,PNUG,PALPHAR,PNUR,PEGR,PBR,PCG,PDG,PCR,PDR,      &
                    PDRYLBDAG_MAX,PDRYLBDAR_MAX,PDRYLBDAG_MIN,PDRYLBDAR_MIN, &
                    PFDINFTY,PKER_RDRYG                                      )
!     ########################################################################
!
!!****  * * - initialize the kernels for the snow-graupel dry growth process
!!
!!    PURPOSE
!!    -------
!!      The purpose of this routine is to initialize the kernels PKER_RDRYG
!!    prepared from a previous run of the routine INI_RAIN_ICE. The reading of
!!    the kernels is optional after checking for the dimensions of the arrays.
!!
!!**  METHOD
!!    ------
!!      
!!
!!    EXTERNAL
!!    --------
!!      None
!!     
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      None
!!
!!    REFERENCE
!!    ---------
!!      Book2 of documentation ( routine READ_XKER_RDRYG )
!!
!!    AUTHOR
!!    ------
!!      J.-P. Pinty      * Laboratoire d'Aerologie*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    09/04/96
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!*       0.2   Declarations of local variables :
!
!  
INTEGER, INTENT(OUT) :: KND,KDRYLBDAG,KDRYLBDAR
REAL,    INTENT(OUT) :: PALPHAG
REAL,    INTENT(OUT) :: PNUG
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PEGR
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCG
REAL,    INTENT(OUT) :: PDG
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PDRYLBDAG_MAX
REAL,    INTENT(OUT) :: PDRYLBDAR_MAX
REAL,    INTENT(OUT) :: PDRYLBDAG_MIN
REAL,    INTENT(OUT) :: PDRYLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RDRYG 
!
! ###################################################################
! #INSERT HERE THE OUTPUT OF INI_RAIN_ICE IF THE KERNELS ARE UPDATED#
! ###################################################################
!
KND= 50
KDRYLBDAG= 40
KDRYLBDAR= 40
PALPHAG= 0.100000E+01
PNUG= 0.100000E+01
PALPHAR= 0.100000E+01
PNUR= 0.100000E+01
PEGR= 0.100000E+01
PBR= 0.300000E+01
PCG= 0.124000E+03
PDG= 0.660000E+00
PCR= 0.842000E+03
PDR= 0.800000E+00
PDRYLBDAG_MAX= 0.100000E+08
PDRYLBDAR_MAX= 0.100000E+08
PDRYLBDAG_MIN= 0.100000E+04
PDRYLBDAR_MIN= 0.100000E+04
PFDINFTY= 0.200000E+02
!
IF( PRESENT(PKER_RDRYG) ) THEN
  PKER_RDRYG(  1,  1) =  0.113429E+02
  PKER_RDRYG(  1,  2) =  0.888532E+01
  PKER_RDRYG(  1,  3) =  0.684777E+01
  PKER_RDRYG(  1,  4) =  0.517128E+01
  PKER_RDRYG(  1,  5) =  0.381554E+01
  PKER_RDRYG(  1,  6) =  0.275614E+01
  PKER_RDRYG(  1,  7) =  0.197831E+01
  PKER_RDRYG(  1,  8) =  0.146495E+01
  PKER_RDRYG(  1,  9) =  0.118865E+01
  PKER_RDRYG(  1, 10) =  0.110504E+01
  PKER_RDRYG(  1, 11) =  0.115718E+01
  PKER_RDRYG(  1, 12) =  0.128948E+01
  PKER_RDRYG(  1, 13) =  0.145623E+01
  PKER_RDRYG(  1, 14) =  0.162671E+01
  PKER_RDRYG(  1, 15) =  0.178400E+01
  PKER_RDRYG(  1, 16) =  0.192135E+01
  PKER_RDRYG(  1, 17) =  0.203766E+01
  PKER_RDRYG(  1, 18) =  0.213454E+01
  PKER_RDRYG(  1, 19) =  0.221453E+01
  PKER_RDRYG(  1, 20) =  0.228027E+01
  PKER_RDRYG(  1, 21) =  0.233424E+01
  PKER_RDRYG(  1, 22) =  0.237855E+01
  PKER_RDRYG(  1, 23) =  0.241497E+01
  PKER_RDRYG(  1, 24) =  0.244492E+01
  PKER_RDRYG(  1, 25) =  0.246956E+01
  PKER_RDRYG(  1, 26) =  0.248985E+01
  PKER_RDRYG(  1, 27) =  0.250656E+01
  PKER_RDRYG(  1, 28) =  0.252033E+01
  PKER_RDRYG(  1, 29) =  0.253168E+01
  PKER_RDRYG(  1, 30) =  0.254104E+01
  PKER_RDRYG(  1, 31) =  0.254875E+01
  PKER_RDRYG(  1, 32) =  0.255512E+01
  PKER_RDRYG(  1, 33) =  0.256037E+01
  PKER_RDRYG(  1, 34) =  0.256470E+01
  PKER_RDRYG(  1, 35) =  0.256828E+01
  PKER_RDRYG(  1, 36) =  0.257123E+01
  PKER_RDRYG(  1, 37) =  0.257367E+01
  PKER_RDRYG(  1, 38) =  0.257568E+01
  PKER_RDRYG(  1, 39) =  0.257735E+01
  PKER_RDRYG(  1, 40) =  0.257872E+01
  PKER_RDRYG(  2,  1) =  0.117927E+02
  PKER_RDRYG(  2,  2) =  0.934446E+01
  PKER_RDRYG(  2,  3) =  0.730889E+01
  PKER_RDRYG(  2,  4) =  0.562152E+01
  PKER_RDRYG(  2,  5) =  0.423473E+01
  PKER_RDRYG(  2,  6) =  0.311610E+01
  PKER_RDRYG(  2,  7) =  0.224696E+01
  PKER_RDRYG(  2,  8) =  0.161553E+01
  PKER_RDRYG(  2,  9) =  0.120734E+01
  PKER_RDRYG(  2, 10) =  0.997308E+00
  PKER_RDRYG(  2, 11) =  0.945330E+00
  PKER_RDRYG(  2, 12) =  0.100270E+01
  PKER_RDRYG(  2, 13) =  0.112265E+01
  PKER_RDRYG(  2, 14) =  0.126742E+01
  PKER_RDRYG(  2, 15) =  0.141245E+01
  PKER_RDRYG(  2, 16) =  0.154497E+01
  PKER_RDRYG(  2, 17) =  0.165998E+01
  PKER_RDRYG(  2, 18) =  0.175705E+01
  PKER_RDRYG(  2, 19) =  0.183773E+01
  PKER_RDRYG(  2, 20) =  0.190425E+01
  PKER_RDRYG(  2, 21) =  0.195889E+01
  PKER_RDRYG(  2, 22) =  0.200372E+01
  PKER_RDRYG(  2, 23) =  0.204054E+01
  PKER_RDRYG(  2, 24) =  0.207079E+01
  PKER_RDRYG(  2, 25) =  0.209566E+01
  PKER_RDRYG(  2, 26) =  0.211612E+01
  PKER_RDRYG(  2, 27) =  0.213297E+01
  PKER_RDRYG(  2, 28) =  0.214684E+01
  PKER_RDRYG(  2, 29) =  0.215827E+01
  PKER_RDRYG(  2, 30) =  0.216769E+01
  PKER_RDRYG(  2, 31) =  0.217545E+01
  PKER_RDRYG(  2, 32) =  0.218186E+01
  PKER_RDRYG(  2, 33) =  0.218714E+01
  PKER_RDRYG(  2, 34) =  0.219150E+01
  PKER_RDRYG(  2, 35) =  0.219509E+01
  PKER_RDRYG(  2, 36) =  0.219806E+01
  PKER_RDRYG(  2, 37) =  0.220051E+01
  PKER_RDRYG(  2, 38) =  0.220253E+01
  PKER_RDRYG(  2, 39) =  0.220420E+01
  PKER_RDRYG(  2, 40) =  0.220558E+01
  PKER_RDRYG(  3,  1) =  0.121617E+02
  PKER_RDRYG(  3,  2) =  0.972447E+01
  PKER_RDRYG(  3,  3) =  0.769669E+01
  PKER_RDRYG(  3,  4) =  0.601068E+01
  PKER_RDRYG(  3,  5) =  0.461358E+01
  PKER_RDRYG(  3,  6) =  0.346650E+01
  PKER_RDRYG(  3,  7) =  0.254421E+01
  PKER_RDRYG(  3,  8) =  0.183189E+01
  PKER_RDRYG(  3,  9) =  0.131969E+01
  PKER_RDRYG(  3, 10) =  0.997188E+00
  PKER_RDRYG(  3, 11) =  0.839117E+00
  PKER_RDRYG(  3, 12) =  0.810553E+00
  PKER_RDRYG(  3, 13) =  0.869949E+00
  PKER_RDRYG(  3, 14) =  0.977509E+00
  PKER_RDRYG(  3, 15) =  0.110267E+01
  PKER_RDRYG(  3, 16) =  0.122591E+01
  PKER_RDRYG(  3, 17) =  0.133742E+01
  PKER_RDRYG(  3, 18) =  0.143367E+01
  PKER_RDRYG(  3, 19) =  0.151464E+01
  PKER_RDRYG(  3, 20) =  0.158182E+01
  PKER_RDRYG(  3, 21) =  0.163714E+01
  PKER_RDRYG(  3, 22) =  0.168256E+01
  PKER_RDRYG(  3, 23) =  0.171982E+01
  PKER_RDRYG(  3, 24) =  0.175040E+01
  PKER_RDRYG(  3, 25) =  0.177553E+01
  PKER_RDRYG(  3, 26) =  0.179619E+01
  PKER_RDRYG(  3, 27) =  0.181318E+01
  PKER_RDRYG(  3, 28) =  0.182717E+01
  PKER_RDRYG(  3, 29) =  0.183869E+01
  PKER_RDRYG(  3, 30) =  0.184817E+01
  PKER_RDRYG(  3, 31) =  0.185599E+01
  PKER_RDRYG(  3, 32) =  0.186244E+01
  PKER_RDRYG(  3, 33) =  0.186775E+01
  PKER_RDRYG(  3, 34) =  0.187213E+01
  PKER_RDRYG(  3, 35) =  0.187575E+01
  PKER_RDRYG(  3, 36) =  0.187873E+01
  PKER_RDRYG(  3, 37) =  0.188119E+01
  PKER_RDRYG(  3, 38) =  0.188322E+01
  PKER_RDRYG(  3, 39) =  0.188490E+01
  PKER_RDRYG(  3, 40) =  0.188628E+01
  PKER_RDRYG(  4,  1) =  0.124632E+02
  PKER_RDRYG(  4,  2) =  0.100363E+02
  PKER_RDRYG(  4,  3) =  0.801781E+01
  PKER_RDRYG(  4,  4) =  0.633828E+01
  PKER_RDRYG(  4,  5) =  0.494183E+01
  PKER_RDRYG(  4,  6) =  0.378510E+01
  PKER_RDRYG(  4,  7) =  0.283672E+01
  PKER_RDRYG(  4,  8) =  0.207666E+01
  PKER_RDRYG(  4,  9) =  0.149363E+01
  PKER_RDRYG(  4, 10) =  0.108052E+01
  PKER_RDRYG(  4, 11) =  0.825432E+00
  PKER_RDRYG(  4, 12) =  0.708049E+00
  PKER_RDRYG(  4, 13) =  0.696559E+00
  PKER_RDRYG(  4, 14) =  0.755465E+00
  PKER_RDRYG(  4, 15) =  0.851164E+00
  PKER_RDRYG(  4, 16) =  0.958922E+00
  PKER_RDRYG(  4, 17) =  0.106351E+01
  PKER_RDRYG(  4, 18) =  0.115725E+01
  PKER_RDRYG(  4, 19) =  0.123777E+01
  PKER_RDRYG(  4, 20) =  0.130532E+01
  PKER_RDRYG(  4, 21) =  0.136125E+01
  PKER_RDRYG(  4, 22) =  0.140726E+01
  PKER_RDRYG(  4, 23) =  0.144501E+01
  PKER_RDRYG(  4, 24) =  0.147597E+01
  PKER_RDRYG(  4, 25) =  0.150139E+01
  PKER_RDRYG(  4, 26) =  0.152226E+01
  PKER_RDRYG(  4, 27) =  0.153942E+01
  PKER_RDRYG(  4, 28) =  0.155353E+01
  PKER_RDRYG(  4, 29) =  0.156515E+01
  PKER_RDRYG(  4, 30) =  0.157471E+01
  PKER_RDRYG(  4, 31) =  0.158259E+01
  PKER_RDRYG(  4, 32) =  0.158908E+01
  PKER_RDRYG(  4, 33) =  0.159443E+01
  PKER_RDRYG(  4, 34) =  0.159884E+01
  PKER_RDRYG(  4, 35) =  0.160248E+01
  PKER_RDRYG(  4, 36) =  0.160548E+01
  PKER_RDRYG(  4, 37) =  0.160795E+01
  PKER_RDRYG(  4, 38) =  0.160999E+01
  PKER_RDRYG(  4, 39) =  0.161168E+01
  PKER_RDRYG(  4, 40) =  0.161307E+01
  PKER_RDRYG(  5,  1) =  0.127090E+02
  PKER_RDRYG(  5,  2) =  0.102910E+02
  PKER_RDRYG(  5,  3) =  0.828132E+01
  PKER_RDRYG(  5,  4) =  0.660967E+01
  PKER_RDRYG(  5,  5) =  0.521858E+01
  PKER_RDRYG(  5,  6) =  0.406200E+01
  PKER_RDRYG(  5,  7) =  0.310443E+01
  PKER_RDRYG(  5,  8) =  0.232064E+01
  PKER_RDRYG(  5,  9) =  0.169464E+01
  PKER_RDRYG(  5, 10) =  0.121813E+01
  PKER_RDRYG(  5, 11) =  0.885289E+00
  PKER_RDRYG(  5, 12) =  0.684884E+00
  PKER_RDRYG(  5, 13) =  0.598972E+00
  PKER_RDRYG(  5, 14) =  0.599848E+00
  PKER_RDRYG(  5, 15) =  0.656194E+00
  PKER_RDRYG(  5, 16) =  0.740930E+00
  PKER_RDRYG(  5, 17) =  0.833644E+00
  PKER_RDRYG(  5, 18) =  0.922189E+00
  PKER_RDRYG(  5, 19) =  0.100097E+01
  PKER_RDRYG(  5, 20) =  0.106830E+01
  PKER_RDRYG(  5, 21) =  0.112462E+01
  PKER_RDRYG(  5, 22) =  0.117119E+01
  PKER_RDRYG(  5, 23) =  0.120946E+01
  PKER_RDRYG(  5, 24) =  0.124084E+01
  PKER_RDRYG(  5, 25) =  0.126657E+01
  PKER_RDRYG(  5, 26) =  0.128769E+01
  PKER_RDRYG(  5, 27) =  0.130503E+01
  PKER_RDRYG(  5, 28) =  0.131929E+01
  PKER_RDRYG(  5, 29) =  0.133101E+01
  PKER_RDRYG(  5, 30) =  0.134066E+01
  PKER_RDRYG(  5, 31) =  0.134860E+01
  PKER_RDRYG(  5, 32) =  0.135514E+01
  PKER_RDRYG(  5, 33) =  0.136053E+01
  PKER_RDRYG(  5, 34) =  0.136497E+01
  PKER_RDRYG(  5, 35) =  0.136863E+01
  PKER_RDRYG(  5, 36) =  0.137165E+01
  PKER_RDRYG(  5, 37) =  0.137413E+01
  PKER_RDRYG(  5, 38) =  0.137619E+01
  PKER_RDRYG(  5, 39) =  0.137788E+01
  PKER_RDRYG(  5, 40) =  0.137928E+01
  PKER_RDRYG(  6,  1) =  0.129097E+02
  PKER_RDRYG(  6,  2) =  0.104988E+02
  PKER_RDRYG(  6,  3) =  0.849661E+01
  PKER_RDRYG(  6,  4) =  0.683241E+01
  PKER_RDRYG(  6,  5) =  0.544798E+01
  PKER_RDRYG(  6,  6) =  0.429580E+01
  PKER_RDRYG(  6,  7) =  0.333794E+01
  PKER_RDRYG(  6,  8) =  0.254535E+01
  PKER_RDRYG(  6,  9) =  0.189760E+01
  PKER_RDRYG(  6, 10) =  0.138256E+01
  PKER_RDRYG(  6, 11) =  0.993749E+00
  PKER_RDRYG(  6, 12) =  0.725579E+00
  PKER_RDRYG(  6, 13) =  0.569771E+00
  PKER_RDRYG(  6, 14) =  0.508215E+00
  PKER_RDRYG(  6, 15) =  0.517364E+00
  PKER_RDRYG(  6, 16) =  0.570603E+00
  PKER_RDRYG(  6, 17) =  0.645018E+00
  PKER_RDRYG(  6, 18) =  0.724433E+00
  PKER_RDRYG(  6, 19) =  0.799323E+00
  PKER_RDRYG(  6, 20) =  0.865437E+00
  PKER_RDRYG(  6, 21) =  0.921727E+00
  PKER_RDRYG(  6, 22) =  0.968693E+00
  PKER_RDRYG(  6, 23) =  0.100746E+01
  PKER_RDRYG(  6, 24) =  0.103929E+01
  PKER_RDRYG(  6, 25) =  0.106538E+01
  PKER_RDRYG(  6, 26) =  0.108677E+01
  PKER_RDRYG(  6, 27) =  0.110432E+01
  PKER_RDRYG(  6, 28) =  0.111873E+01
  PKER_RDRYG(  6, 29) =  0.113057E+01
  PKER_RDRYG(  6, 30) =  0.114031E+01
  PKER_RDRYG(  6, 31) =  0.114832E+01
  PKER_RDRYG(  6, 32) =  0.115492E+01
  PKER_RDRYG(  6, 33) =  0.116035E+01
  PKER_RDRYG(  6, 34) =  0.116482E+01
  PKER_RDRYG(  6, 35) =  0.116851E+01
  PKER_RDRYG(  6, 36) =  0.117155E+01
  PKER_RDRYG(  6, 37) =  0.117405E+01
  PKER_RDRYG(  6, 38) =  0.117612E+01
  PKER_RDRYG(  6, 39) =  0.117782E+01
  PKER_RDRYG(  6, 40) =  0.117923E+01
  PKER_RDRYG(  7,  1) =  0.130737E+02
  PKER_RDRYG(  7,  2) =  0.106684E+02
  PKER_RDRYG(  7,  3) =  0.867226E+01
  PKER_RDRYG(  7,  4) =  0.701442E+01
  PKER_RDRYG(  7,  5) =  0.563630E+01
  PKER_RDRYG(  7,  6) =  0.448972E+01
  PKER_RDRYG(  7,  7) =  0.353543E+01
  PKER_RDRYG(  7,  8) =  0.274218E+01
  PKER_RDRYG(  7,  9) =  0.208626E+01
  PKER_RDRYG(  7, 10) =  0.155134E+01
  PKER_RDRYG(  7, 11) =  0.112782E+01
  PKER_RDRYG(  7, 12) =  0.810984E+00
  PKER_RDRYG(  7, 13) =  0.596204E+00
  PKER_RDRYG(  7, 14) =  0.475108E+00
  PKER_RDRYG(  7, 15) =  0.432596E+00
  PKER_RDRYG(  7, 16) =  0.446915E+00
  PKER_RDRYG(  7, 17) =  0.496175E+00
  PKER_RDRYG(  7, 18) =  0.561308E+00
  PKER_RDRYG(  7, 19) =  0.629230E+00
  PKER_RDRYG(  7, 20) =  0.692507E+00
  PKER_RDRYG(  7, 21) =  0.747991E+00
  PKER_RDRYG(  7, 22) =  0.795023E+00
  PKER_RDRYG(  7, 23) =  0.834178E+00
  PKER_RDRYG(  7, 24) =  0.866452E+00
  PKER_RDRYG(  7, 25) =  0.892928E+00
  PKER_RDRYG(  7, 26) =  0.914619E+00
  PKER_RDRYG(  7, 27) =  0.932399E+00
  PKER_RDRYG(  7, 28) =  0.946986E+00
  PKER_RDRYG(  7, 29) =  0.958962E+00
  PKER_RDRYG(  7, 30) =  0.968803E+00
  PKER_RDRYG(  7, 31) =  0.976894E+00
  PKER_RDRYG(  7, 32) =  0.983549E+00
  PKER_RDRYG(  7, 33) =  0.989027E+00
  PKER_RDRYG(  7, 34) =  0.993537E+00
  PKER_RDRYG(  7, 35) =  0.997252E+00
  PKER_RDRYG(  7, 36) =  0.100031E+01
  PKER_RDRYG(  7, 37) =  0.100283E+01
  PKER_RDRYG(  7, 38) =  0.100491E+01
  PKER_RDRYG(  7, 39) =  0.100663E+01
  PKER_RDRYG(  7, 40) =  0.100804E+01
  PKER_RDRYG(  8,  1) =  0.132082E+02
  PKER_RDRYG(  8,  2) =  0.108071E+02
  PKER_RDRYG(  8,  3) =  0.881568E+01
  PKER_RDRYG(  8,  4) =  0.716294E+01
  PKER_RDRYG(  8,  5) =  0.579021E+01
  PKER_RDRYG(  8,  6) =  0.464898E+01
  PKER_RDRYG(  8,  7) =  0.369939E+01
  PKER_RDRYG(  8,  8) =  0.290901E+01
  PKER_RDRYG(  8,  9) =  0.225210E+01
  PKER_RDRYG(  8, 10) =  0.170938E+01
  PKER_RDRYG(  8, 11) =  0.126773E+01
  PKER_RDRYG(  8, 12) =  0.919865E+00
  PKER_RDRYG(  8, 13) =  0.661937E+00
  PKER_RDRYG(  8, 14) =  0.490415E+00
  PKER_RDRYG(  8, 15) =  0.397339E+00
  PKER_RDRYG(  8, 16) =  0.368774E+00
  PKER_RDRYG(  8, 17) =  0.386541E+00
  PKER_RDRYG(  8, 18) =  0.431586E+00
  PKER_RDRYG(  8, 19) =  0.488388E+00
  PKER_RDRYG(  8, 20) =  0.546326E+00
  PKER_RDRYG(  8, 21) =  0.599722E+00
  PKER_RDRYG(  8, 22) =  0.646234E+00
  PKER_RDRYG(  8, 23) =  0.685535E+00
  PKER_RDRYG(  8, 24) =  0.718173E+00
  PKER_RDRYG(  8, 25) =  0.745040E+00
  PKER_RDRYG(  8, 26) =  0.767064E+00
  PKER_RDRYG(  8, 27) =  0.785101E+00
  PKER_RDRYG(  8, 28) =  0.799883E+00
  PKER_RDRYG(  8, 29) =  0.812008E+00
  PKER_RDRYG(  8, 30) =  0.821962E+00
  PKER_RDRYG(  8, 31) =  0.830140E+00
  PKER_RDRYG(  8, 32) =  0.836862E+00
  PKER_RDRYG(  8, 33) =  0.842391E+00
  PKER_RDRYG(  8, 34) =  0.846941E+00
  PKER_RDRYG(  8, 35) =  0.850687E+00
  PKER_RDRYG(  8, 36) =  0.853771E+00
  PKER_RDRYG(  8, 37) =  0.856313E+00
  PKER_RDRYG(  8, 38) =  0.858406E+00
  PKER_RDRYG(  8, 39) =  0.860132E+00
  PKER_RDRYG(  8, 40) =  0.861555E+00
  PKER_RDRYG(  9,  1) =  0.133186E+02
  PKER_RDRYG(  9,  2) =  0.109208E+02
  PKER_RDRYG(  9,  3) =  0.893300E+01
  PKER_RDRYG(  9,  4) =  0.728424E+01
  PKER_RDRYG(  9,  5) =  0.591582E+01
  PKER_RDRYG(  9,  6) =  0.477915E+01
  PKER_RDRYG(  9,  7) =  0.383409E+01
  PKER_RDRYG(  9,  8) =  0.304764E+01
  PKER_RDRYG(  9,  9) =  0.239303E+01
  PKER_RDRYG(  9, 10) =  0.184909E+01
  PKER_RDRYG(  9, 11) =  0.140008E+01
  PKER_RDRYG(  9, 12) =  0.103570E+01
  PKER_RDRYG(  9, 13) =  0.750184E+00
  PKER_RDRYG(  9, 14) =  0.540583E+00
  PKER_RDRYG(  9, 15) =  0.404171E+00
  PKER_RDRYG(  9, 16) =  0.333201E+00
  PKER_RDRYG(  9, 17) =  0.315421E+00
  PKER_RDRYG(  9, 18) =  0.334832E+00
  PKER_RDRYG(  9, 19) =  0.375550E+00
  PKER_RDRYG(  9, 20) =  0.424785E+00
  PKER_RDRYG(  9, 21) =  0.474129E+00
  PKER_RDRYG(  9, 22) =  0.519143E+00
  PKER_RDRYG(  9, 23) =  0.558133E+00
  PKER_RDRYG(  9, 24) =  0.590954E+00
  PKER_RDRYG(  9, 25) =  0.618160E+00
  PKER_RDRYG(  9, 26) =  0.640526E+00
  PKER_RDRYG(  9, 27) =  0.658847E+00
  PKER_RDRYG(  9, 28) =  0.673848E+00
  PKER_RDRYG(  9, 29) =  0.686139E+00
  PKER_RDRYG(  9, 30) =  0.696219E+00
  PKER_RDRYG(  9, 31) =  0.704493E+00
  PKER_RDRYG(  9, 32) =  0.711289E+00
  PKER_RDRYG(  9, 33) =  0.716875E+00
  PKER_RDRYG(  9, 34) =  0.721469E+00
  PKER_RDRYG(  9, 35) =  0.725249E+00
  PKER_RDRYG(  9, 36) =  0.728360E+00
  PKER_RDRYG(  9, 37) =  0.730922E+00
  PKER_RDRYG(  9, 38) =  0.733032E+00
  PKER_RDRYG(  9, 39) =  0.734770E+00
  PKER_RDRYG(  9, 40) =  0.736203E+00
  PKER_RDRYG( 10,  1) =  0.134097E+02
  PKER_RDRYG( 10,  2) =  0.110143E+02
  PKER_RDRYG( 10,  3) =  0.902922E+01
  PKER_RDRYG( 10,  4) =  0.738349E+01
  PKER_RDRYG( 10,  5) =  0.601843E+01
  PKER_RDRYG( 10,  6) =  0.488542E+01
  PKER_RDRYG( 10,  7) =  0.394421E+01
  PKER_RDRYG( 10,  8) =  0.316159E+01
  PKER_RDRYG( 10,  9) =  0.251025E+01
  PKER_RDRYG( 10, 10) =  0.196809E+01
  PKER_RDRYG( 10, 11) =  0.151773E+01
  PKER_RDRYG( 10, 12) =  0.114640E+01
  PKER_RDRYG( 10, 13) =  0.845862E+00
  PKER_RDRYG( 10, 14) =  0.611819E+00
  PKER_RDRYG( 10, 15) =  0.442230E+00
  PKER_RDRYG( 10, 16) =  0.333761E+00
  PKER_RDRYG( 10, 17) =  0.280176E+00
  PKER_RDRYG( 10, 18) =  0.270205E+00
  PKER_RDRYG( 10, 19) =  0.290267E+00
  PKER_RDRYG( 10, 20) =  0.326785E+00
  PKER_RDRYG( 10, 21) =  0.369349E+00
  PKER_RDRYG( 10, 22) =  0.411304E+00
  PKER_RDRYG( 10, 23) =  0.449213E+00
  PKER_RDRYG( 10, 24) =  0.481873E+00
  PKER_RDRYG( 10, 25) =  0.509282E+00
  PKER_RDRYG( 10, 26) =  0.531958E+00
  PKER_RDRYG( 10, 27) =  0.550577E+00
  PKER_RDRYG( 10, 28) =  0.565820E+00
  PKER_RDRYG( 10, 29) =  0.578297E+00
  PKER_RDRYG( 10, 30) =  0.588518E+00
  PKER_RDRYG( 10, 31) =  0.596899E+00
  PKER_RDRYG( 10, 32) =  0.603778E+00
  PKER_RDRYG( 10, 33) =  0.609427E+00
  PKER_RDRYG( 10, 34) =  0.614069E+00
  PKER_RDRYG( 10, 35) =  0.617886E+00
  PKER_RDRYG( 10, 36) =  0.621027E+00
  PKER_RDRYG( 10, 37) =  0.623611E+00
  PKER_RDRYG( 10, 38) =  0.625739E+00
  PKER_RDRYG( 10, 39) =  0.627491E+00
  PKER_RDRYG( 10, 40) =  0.628935E+00
  PKER_RDRYG( 11,  1) =  0.134850E+02
  PKER_RDRYG( 11,  2) =  0.110914E+02
  PKER_RDRYG( 11,  3) =  0.910837E+01
  PKER_RDRYG( 11,  4) =  0.746493E+01
  PKER_RDRYG( 11,  5) =  0.610242E+01
  PKER_RDRYG( 11,  6) =  0.497224E+01
  PKER_RDRYG( 11,  7) =  0.403413E+01
  PKER_RDRYG( 11,  8) =  0.325477E+01
  PKER_RDRYG( 11,  9) =  0.260666E+01
  PKER_RDRYG( 11, 10) =  0.206723E+01
  PKER_RDRYG( 11, 11) =  0.161821E+01
  PKER_RDRYG( 11, 12) =  0.124536E+01
  PKER_RDRYG( 11, 13) =  0.938357E+00
  PKER_RDRYG( 11, 14) =  0.690647E+00
  PKER_RDRYG( 11, 15) =  0.499022E+00
  PKER_RDRYG( 11, 16) =  0.361814E+00
  PKER_RDRYG( 11, 17) =  0.276145E+00
  PKER_RDRYG( 11, 18) =  0.236136E+00
  PKER_RDRYG( 11, 19) =  0.232058E+00
  PKER_RDRYG( 11, 20) =  0.251803E+00
  PKER_RDRYG( 11, 21) =  0.284322E+00
  PKER_RDRYG( 11, 22) =  0.321029E+00
  PKER_RDRYG( 11, 23) =  0.356649E+00
  PKER_RDRYG( 11, 24) =  0.388551E+00
  PKER_RDRYG( 11, 25) =  0.415898E+00
  PKER_RDRYG( 11, 26) =  0.438783E+00
  PKER_RDRYG( 11, 27) =  0.457681E+00
  PKER_RDRYG( 11, 28) =  0.473182E+00
  PKER_RDRYG( 11, 29) =  0.485865E+00
  PKER_RDRYG( 11, 30) =  0.496243E+00
  PKER_RDRYG( 11, 31) =  0.504744E+00
  PKER_RDRYG( 11, 32) =  0.511714E+00
  PKER_RDRYG( 11, 33) =  0.517433E+00
  PKER_RDRYG( 11, 34) =  0.522129E+00
  PKER_RDRYG( 11, 35) =  0.525987E+00
  PKER_RDRYG( 11, 36) =  0.529160E+00
  PKER_RDRYG( 11, 37) =  0.531769E+00
  PKER_RDRYG( 11, 38) =  0.533916E+00
  PKER_RDRYG( 11, 39) =  0.535683E+00
  PKER_RDRYG( 11, 40) =  0.537138E+00
  PKER_RDRYG( 12,  1) =  0.135474E+02
  PKER_RDRYG( 12,  2) =  0.111552E+02
  PKER_RDRYG( 12,  3) =  0.917366E+01
  PKER_RDRYG( 12,  4) =  0.753194E+01
  PKER_RDRYG( 12,  5) =  0.617136E+01
  PKER_RDRYG( 12,  6) =  0.504334E+01
  PKER_RDRYG( 12,  7) =  0.410762E+01
  PKER_RDRYG( 12,  8) =  0.333087E+01
  PKER_RDRYG( 12,  9) =  0.268553E+01
  PKER_RDRYG( 12, 10) =  0.214881E+01
  PKER_RDRYG( 12, 11) =  0.170205E+01
  PKER_RDRYG( 12, 12) =  0.133020E+01
  PKER_RDRYG( 12, 13) =  0.102155E+01
  PKER_RDRYG( 12, 14) =  0.767749E+00
  PKER_RDRYG( 12, 15) =  0.563744E+00
  PKER_RDRYG( 12, 16) =  0.407094E+00
  PKER_RDRYG( 12, 17) =  0.296271E+00
  PKER_RDRYG( 12, 18) =  0.229046E+00
  PKER_RDRYG( 12, 19) =  0.199698E+00
  PKER_RDRYG( 12, 20) =  0.199640E+00
  PKER_RDRYG( 12, 21) =  0.218639E+00
  PKER_RDRYG( 12, 22) =  0.247374E+00
  PKER_RDRYG( 12, 23) =  0.278945E+00
  PKER_RDRYG( 12, 24) =  0.309121E+00
  PKER_RDRYG( 12, 25) =  0.335948E+00
  PKER_RDRYG( 12, 26) =  0.358842E+00
  PKER_RDRYG( 12, 27) =  0.377946E+00
  PKER_RDRYG( 12, 28) =  0.393696E+00
  PKER_RDRYG( 12, 29) =  0.406601E+00
  PKER_RDRYG( 12, 30) =  0.417155E+00
  PKER_RDRYG( 12, 31) =  0.425790E+00
  PKER_RDRYG( 12, 32) =  0.432861E+00
  PKER_RDRYG( 12, 33) =  0.438657E+00
  PKER_RDRYG( 12, 34) =  0.443413E+00
  PKER_RDRYG( 12, 35) =  0.447317E+00
  PKER_RDRYG( 12, 36) =  0.450524E+00
  PKER_RDRYG( 12, 37) =  0.453161E+00
  PKER_RDRYG( 12, 38) =  0.455329E+00
  PKER_RDRYG( 12, 39) =  0.457113E+00
  PKER_RDRYG( 12, 40) =  0.458581E+00
  PKER_RDRYG( 13,  1) =  0.135992E+02
  PKER_RDRYG( 13,  2) =  0.112081E+02
  PKER_RDRYG( 13,  3) =  0.922768E+01
  PKER_RDRYG( 13,  4) =  0.758724E+01
  PKER_RDRYG( 13,  5) =  0.622811E+01
  PKER_RDRYG( 13,  6) =  0.510171E+01
  PKER_RDRYG( 13,  7) =  0.416780E+01
  PKER_RDRYG( 13,  8) =  0.339309E+01
  PKER_RDRYG( 13,  9) =  0.274995E+01
  PKER_RDRYG( 13, 10) =  0.221557E+01
  PKER_RDRYG( 13, 11) =  0.177110E+01
  PKER_RDRYG( 13, 12) =  0.140110E+01
  PKER_RDRYG( 13, 13) =  0.109315E+01
  PKER_RDRYG( 13, 14) =  0.837695E+00
  PKER_RDRYG( 13, 15) =  0.628007E+00
  PKER_RDRYG( 13, 16) =  0.460064E+00
  PKER_RDRYG( 13, 17) =  0.332147E+00
  PKER_RDRYG( 13, 18) =  0.242993E+00
  PKER_RDRYG( 13, 19) =  0.190382E+00
  PKER_RDRYG( 13, 20) =  0.169340E+00
  PKER_RDRYG( 13, 21) =  0.172021E+00
  PKER_RDRYG( 13, 22) =  0.189920E+00
  PKER_RDRYG( 13, 23) =  0.215196E+00
  PKER_RDRYG( 13, 24) =  0.242255E+00
  PKER_RDRYG( 13, 25) =  0.267812E+00
  PKER_RDRYG( 13, 26) =  0.290361E+00
  PKER_RDRYG( 13, 27) =  0.309517E+00
  PKER_RDRYG( 13, 28) =  0.325465E+00
  PKER_RDRYG( 13, 29) =  0.338590E+00
  PKER_RDRYG( 13, 30) =  0.349335E+00
  PKER_RDRYG( 13, 31) =  0.358118E+00
  PKER_RDRYG( 13, 32) =  0.365303E+00
  PKER_RDRYG( 13, 33) =  0.371186E+00
  PKER_RDRYG( 13, 34) =  0.376007E+00
  PKER_RDRYG( 13, 35) =  0.379962E+00
  PKER_RDRYG( 13, 36) =  0.383208E+00
  PKER_RDRYG( 13, 37) =  0.385875E+00
  PKER_RDRYG( 13, 38) =  0.388066E+00
  PKER_RDRYG( 13, 39) =  0.389868E+00
  PKER_RDRYG( 13, 40) =  0.391351E+00
  PKER_RDRYG( 14,  1) =  0.136424E+02
  PKER_RDRYG( 14,  2) =  0.112520E+02
  PKER_RDRYG( 14,  3) =  0.927249E+01
  PKER_RDRYG( 14,  4) =  0.763302E+01
  PKER_RDRYG( 14,  5) =  0.627497E+01
  PKER_RDRYG( 14,  6) =  0.514978E+01
  PKER_RDRYG( 14,  7) =  0.421724E+01
  PKER_RDRYG( 14,  8) =  0.344405E+01
  PKER_RDRYG( 14,  9) =  0.280263E+01
  PKER_RDRYG( 14, 10) =  0.227012E+01
  PKER_RDRYG( 14, 11) =  0.182762E+01
  PKER_RDRYG( 14, 12) =  0.145954E+01
  PKER_RDRYG( 14, 13) =  0.115311E+01
  PKER_RDRYG( 14, 14) =  0.898099E+00
  PKER_RDRYG( 14, 15) =  0.686697E+00
  PKER_RDRYG( 14, 16) =  0.513492E+00
  PKER_RDRYG( 14, 17) =  0.375385E+00
  PKER_RDRYG( 14, 18) =  0.270975E+00
  PKER_RDRYG( 14, 19) =  0.199521E+00
  PKER_RDRYG( 14, 20) =  0.158655E+00
  PKER_RDRYG( 14, 21) =  0.143819E+00
  PKER_RDRYG( 14, 22) =  0.148448E+00
  PKER_RDRYG( 14, 23) =  0.165031E+00
  PKER_RDRYG( 14, 24) =  0.187175E+00
  PKER_RDRYG( 14, 25) =  0.210331E+00
  PKER_RDRYG( 14, 26) =  0.231936E+00
  PKER_RDRYG( 14, 27) =  0.250868E+00
  PKER_RDRYG( 14, 28) =  0.266895E+00
  PKER_RDRYG( 14, 29) =  0.280204E+00
  PKER_RDRYG( 14, 30) =  0.291143E+00
  PKER_RDRYG( 14, 31) =  0.300090E+00
  PKER_RDRYG( 14, 32) =  0.307401E+00
  PKER_RDRYG( 14, 33) =  0.313380E+00
  PKER_RDRYG( 14, 34) =  0.318275E+00
  PKER_RDRYG( 14, 35) =  0.322286E+00
  PKER_RDRYG( 14, 36) =  0.325575E+00
  PKER_RDRYG( 14, 37) =  0.328275E+00
  PKER_RDRYG( 14, 38) =  0.330492E+00
  PKER_RDRYG( 14, 39) =  0.332314E+00
  PKER_RDRYG( 14, 40) =  0.333811E+00
  PKER_RDRYG( 15,  1) =  0.136784E+02
  PKER_RDRYG( 15,  2) =  0.112886E+02
  PKER_RDRYG( 15,  3) =  0.930976E+01
  PKER_RDRYG( 15,  4) =  0.767102E+01
  PKER_RDRYG( 15,  5) =  0.631377E+01
  PKER_RDRYG( 15,  6) =  0.518948E+01
  PKER_RDRYG( 15,  7) =  0.425797E+01
  PKER_RDRYG( 15,  8) =  0.348593E+01
  PKER_RDRYG( 15,  9) =  0.284580E+01
  PKER_RDRYG( 15, 10) =  0.231474E+01
  PKER_RDRYG( 15, 11) =  0.187382E+01
  PKER_RDRYG( 15, 12) =  0.150740E+01
  PKER_RDRYG( 15, 13) =  0.120258E+01
  PKER_RDRYG( 15, 14) =  0.948799E+00
  PKER_RDRYG( 15, 15) =  0.737641E+00
  PKER_RDRYG( 15, 16) =  0.562720E+00
  PKER_RDRYG( 15, 17) =  0.419730E+00
  PKER_RDRYG( 15, 18) =  0.306247E+00
  PKER_RDRYG( 15, 19) =  0.221265E+00
  PKER_RDRYG( 15, 20) =  0.164088E+00
  PKER_RDRYG( 15, 21) =  0.132562E+00
  PKER_RDRYG( 15, 22) =  0.122598E+00
  PKER_RDRYG( 15, 23) =  0.128315E+00
  PKER_RDRYG( 15, 24) =  0.143469E+00
  PKER_RDRYG( 15, 25) =  0.162742E+00
  PKER_RDRYG( 15, 26) =  0.182528E+00
  PKER_RDRYG( 15, 27) =  0.200775E+00
  PKER_RDRYG( 15, 28) =  0.216671E+00
  PKER_RDRYG( 15, 29) =  0.230077E+00
  PKER_RDRYG( 15, 30) =  0.241184E+00
  PKER_RDRYG( 15, 31) =  0.250299E+00
  PKER_RDRYG( 15, 32) =  0.257750E+00
  PKER_RDRYG( 15, 33) =  0.263837E+00
  PKER_RDRYG( 15, 34) =  0.268813E+00
  PKER_RDRYG( 15, 35) =  0.272887E+00
  PKER_RDRYG( 15, 36) =  0.276224E+00
  PKER_RDRYG( 15, 37) =  0.278960E+00
  PKER_RDRYG( 15, 38) =  0.281205E+00
  PKER_RDRYG( 15, 39) =  0.283049E+00
  PKER_RDRYG( 15, 40) =  0.284564E+00
  PKER_RDRYG( 16,  1) =  0.137085E+02
  PKER_RDRYG( 16,  2) =  0.113192E+02
  PKER_RDRYG( 16,  3) =  0.934083E+01
  PKER_RDRYG( 16,  4) =  0.770263E+01
  PKER_RDRYG( 16,  5) =  0.634599E+01
  PKER_RDRYG( 16,  6) =  0.522238E+01
  PKER_RDRYG( 16,  7) =  0.429162E+01
  PKER_RDRYG( 16,  8) =  0.352045E+01
  PKER_RDRYG( 16,  9) =  0.288129E+01
  PKER_RDRYG( 16, 10) =  0.235131E+01
  PKER_RDRYG( 16, 11) =  0.191162E+01
  PKER_RDRYG( 16, 12) =  0.154654E+01
  PKER_RDRYG( 16, 13) =  0.124312E+01
  PKER_RDRYG( 16, 14) =  0.990681E+00
  PKER_RDRYG( 16, 15) =  0.780510E+00
  PKER_RDRYG( 16, 16) =  0.605678E+00
  PKER_RDRYG( 16, 17) =  0.460987E+00
  PKER_RDRYG( 16, 18) =  0.342972E+00
  PKER_RDRYG( 16, 19) =  0.249819E+00
  PKER_RDRYG( 16, 20) =  0.180844E+00
  PKER_RDRYG( 16, 21) =  0.135165E+00
  PKER_RDRYG( 16, 22) =  0.111031E+00
  PKER_RDRYG( 16, 23) =  0.104672E+00
  PKER_RDRYG( 16, 24) =  0.110998E+00
  PKER_RDRYG( 16, 25) =  0.124724E+00
  PKER_RDRYG( 16, 26) =  0.141478E+00
  PKER_RDRYG( 16, 27) =  0.158331E+00
  PKER_RDRYG( 16, 28) =  0.173737E+00
  PKER_RDRYG( 16, 29) =  0.187074E+00
  PKER_RDRYG( 16, 30) =  0.198283E+00
  PKER_RDRYG( 16, 31) =  0.207552E+00
  PKER_RDRYG( 16, 32) =  0.215149E+00
  PKER_RDRYG( 16, 33) =  0.221354E+00
  PKER_RDRYG( 16, 34) =  0.226422E+00
  PKER_RDRYG( 16, 35) =  0.230565E+00
  PKER_RDRYG( 16, 36) =  0.233955E+00
  PKER_RDRYG( 16, 37) =  0.236732E+00
  PKER_RDRYG( 16, 38) =  0.239008E+00
  PKER_RDRYG( 16, 39) =  0.240876E+00
  PKER_RDRYG( 16, 40) =  0.242409E+00
  PKER_RDRYG( 17,  1) =  0.137338E+02
  PKER_RDRYG( 17,  2) =  0.113448E+02
  PKER_RDRYG( 17,  3) =  0.936679E+01
  PKER_RDRYG( 17,  4) =  0.772900E+01
  PKER_RDRYG( 17,  5) =  0.637281E+01
  PKER_RDRYG( 17,  6) =  0.524971E+01
  PKER_RDRYG( 17,  7) =  0.431952E+01
  PKER_RDRYG( 17,  8) =  0.354898E+01
  PKER_RDRYG( 17,  9) =  0.291054E+01
  PKER_RDRYG( 17, 10) =  0.238139E+01
  PKER_RDRYG( 17, 11) =  0.194261E+01
  PKER_RDRYG( 17, 12) =  0.157857E+01
  PKER_RDRYG( 17, 13) =  0.127628E+01
  PKER_RDRYG( 17, 14) =  0.102502E+01
  PKER_RDRYG( 17, 15) =  0.815970E+00
  PKER_RDRYG( 17, 16) =  0.641917E+00
  PKER_RDRYG( 17, 17) =  0.497171E+00
  PKER_RDRYG( 17, 18) =  0.377507E+00
  PKER_RDRYG( 17, 19) =  0.280172E+00
  PKER_RDRYG( 17, 20) =  0.203787E+00
  PKER_RDRYG( 17, 21) =  0.147769E+00
  PKER_RDRYG( 17, 22) =  0.111528E+00
  PKER_RDRYG( 17, 23) =  0.932152E-01
  PKER_RDRYG( 17, 24) =  0.895799E-01
  PKER_RDRYG( 17, 25) =  0.961438E-01
  PKER_RDRYG( 17, 26) =  0.108454E+00
  PKER_RDRYG( 17, 27) =  0.122945E+00
  PKER_RDRYG( 17, 28) =  0.137295E+00
  PKER_RDRYG( 17, 29) =  0.150279E+00
  PKER_RDRYG( 17, 30) =  0.161465E+00
  PKER_RDRYG( 17, 31) =  0.170838E+00
  PKER_RDRYG( 17, 32) =  0.178572E+00
  PKER_RDRYG( 17, 33) =  0.184904E+00
  PKER_RDRYG( 17, 34) =  0.190073E+00
  PKER_RDRYG( 17, 35) =  0.194293E+00
  PKER_RDRYG( 17, 36) =  0.197742E+00
  PKER_RDRYG( 17, 37) =  0.200564E+00
  PKER_RDRYG( 17, 38) =  0.202875E+00
  PKER_RDRYG( 17, 39) =  0.204769E+00
  PKER_RDRYG( 17, 40) =  0.206323E+00
  PKER_RDRYG( 18,  1) =  0.137549E+02
  PKER_RDRYG( 18,  2) =  0.113662E+02
  PKER_RDRYG( 18,  3) =  0.938851E+01
  PKER_RDRYG( 18,  4) =  0.775103E+01
  PKER_RDRYG( 18,  5) =  0.639519E+01
  PKER_RDRYG( 18,  6) =  0.527247E+01
  PKER_RDRYG( 18,  7) =  0.434271E+01
  PKER_RDRYG( 18,  8) =  0.357264E+01
  PKER_RDRYG( 18,  9) =  0.293474E+01
  PKER_RDRYG( 18, 10) =  0.240619E+01
  PKER_RDRYG( 18, 11) =  0.196810E+01
  PKER_RDRYG( 18, 12) =  0.160484E+01
  PKER_RDRYG( 18, 13) =  0.130342E+01
  PKER_RDRYG( 18, 14) =  0.105312E+01
  PKER_RDRYG( 18, 15) =  0.845066E+00
  PKER_RDRYG( 18, 16) =  0.671939E+00
  PKER_RDRYG( 18, 17) =  0.527804E+00
  PKER_RDRYG( 18, 18) =  0.407977E+00
  PKER_RDRYG( 18, 19) =  0.309030E+00
  PKER_RDRYG( 18, 20) =  0.228800E+00
  PKER_RDRYG( 18, 21) =  0.166244E+00
  PKER_RDRYG( 18, 22) =  0.120903E+00
  PKER_RDRYG( 18, 23) =  0.922202E-01
  PKER_RDRYG( 18, 24) =  0.785293E-01
  PKER_RDRYG( 18, 25) =  0.768302E-01
  PKER_RDRYG( 18, 26) =  0.833242E-01
  PKER_RDRYG( 18, 27) =  0.942918E-01
  PKER_RDRYG( 18, 28) =  0.106809E+00
  PKER_RDRYG( 18, 29) =  0.119000E+00
  PKER_RDRYG( 18, 30) =  0.129941E+00
  PKER_RDRYG( 18, 31) =  0.139320E+00
  PKER_RDRYG( 18, 32) =  0.147155E+00
  PKER_RDRYG( 18, 33) =  0.153608E+00
  PKER_RDRYG( 18, 34) =  0.158885E+00
  PKER_RDRYG( 18, 35) =  0.163191E+00
  PKER_RDRYG( 18, 36) =  0.166706E+00
  PKER_RDRYG( 18, 37) =  0.169578E+00
  PKER_RDRYG( 18, 38) =  0.171928E+00
  PKER_RDRYG( 18, 39) =  0.173851E+00
  PKER_RDRYG( 18, 40) =  0.175428E+00
  PKER_RDRYG( 19,  1) =  0.137727E+02
  PKER_RDRYG( 19,  2) =  0.113842E+02
  PKER_RDRYG( 19,  3) =  0.940672E+01
  PKER_RDRYG( 19,  4) =  0.776948E+01
  PKER_RDRYG( 19,  5) =  0.641390E+01
  PKER_RDRYG( 19,  6) =  0.529147E+01
  PKER_RDRYG( 19,  7) =  0.436202E+01
  PKER_RDRYG( 19,  8) =  0.359232E+01
  PKER_RDRYG( 19,  9) =  0.295481E+01
  PKER_RDRYG( 19, 10) =  0.242671E+01
  PKER_RDRYG( 19, 11) =  0.198914E+01
  PKER_RDRYG( 19, 12) =  0.162645E+01
  PKER_RDRYG( 19, 13) =  0.132569E+01
  PKER_RDRYG( 19, 14) =  0.107613E+01
  PKER_RDRYG( 19, 15) =  0.868883E+00
  PKER_RDRYG( 19, 16) =  0.696595E+00
  PKER_RDRYG( 19, 17) =  0.553222E+00
  PKER_RDRYG( 19, 18) =  0.433861E+00
  PKER_RDRYG( 19, 19) =  0.334680E+00
  PKER_RDRYG( 19, 20) =  0.252894E+00
  PKER_RDRYG( 19, 21) =  0.186794E+00
  PKER_RDRYG( 19, 22) =  0.135613E+00
  PKER_RDRYG( 19, 23) =  0.990001E-01
  PKER_RDRYG( 19, 24) =  0.764111E-01
  PKER_RDRYG( 19, 25) =  0.663036E-01
  PKER_RDRYG( 19, 26) =  0.659987E-01
  PKER_RDRYG( 19, 27) =  0.722775E-01
  PKER_RDRYG( 19, 28) =  0.819918E-01
  PKER_RDRYG( 19, 29) =  0.927520E-01
  PKER_RDRYG( 19, 30) =  0.103099E+00
  PKER_RDRYG( 19, 31) =  0.112313E+00
  PKER_RDRYG( 19, 32) =  0.120174E+00
  PKER_RDRYG( 19, 33) =  0.126723E+00
  PKER_RDRYG( 19, 34) =  0.132108E+00
  PKER_RDRYG( 19, 35) =  0.136507E+00
  PKER_RDRYG( 19, 36) =  0.140095E+00
  PKER_RDRYG( 19, 37) =  0.143023E+00
  PKER_RDRYG( 19, 38) =  0.145415E+00
  PKER_RDRYG( 19, 39) =  0.147371E+00
  PKER_RDRYG( 19, 40) =  0.148972E+00
  PKER_RDRYG( 20,  1) =  0.137877E+02
  PKER_RDRYG( 20,  2) =  0.113993E+02
  PKER_RDRYG( 20,  3) =  0.942201E+01
  PKER_RDRYG( 20,  4) =  0.778496E+01
  PKER_RDRYG( 20,  5) =  0.642957E+01
  PKER_RDRYG( 20,  6) =  0.530736E+01
  PKER_RDRYG( 20,  7) =  0.437816E+01
  PKER_RDRYG( 20,  8) =  0.360871E+01
  PKER_RDRYG( 20,  9) =  0.297151E+01
  PKER_RDRYG( 20, 10) =  0.244375E+01
  PKER_RDRYG( 20, 11) =  0.200655E+01
  PKER_RDRYG( 20, 12) =  0.164429E+01
  PKER_RDRYG( 20, 13) =  0.134402E+01
  PKER_RDRYG( 20, 14) =  0.109502E+01
  PKER_RDRYG( 20, 15) =  0.888391E+00
  PKER_RDRYG( 20, 16) =  0.716785E+00
  PKER_RDRYG( 20, 17) =  0.574115E+00
  PKER_RDRYG( 20, 18) =  0.455384E+00
  PKER_RDRYG( 20, 19) =  0.356548E+00
  PKER_RDRYG( 20, 20) =  0.274459E+00
  PKER_RDRYG( 20, 21) =  0.206882E+00
  PKER_RDRYG( 20, 22) =  0.152466E+00
  PKER_RDRYG( 20, 23) =  0.110601E+00
  PKER_RDRYG( 20, 24) =  0.811506E-01
  PKER_RDRYG( 20, 25) =  0.634503E-01
  PKER_RDRYG( 20, 26) =  0.561009E-01
  PKER_RDRYG( 20, 27) =  0.568033E-01
  PKER_RDRYG( 20, 28) =  0.627284E-01
  PKER_RDRYG( 20, 29) =  0.712830E-01
  PKER_RDRYG( 20, 30) =  0.805234E-01
  PKER_RDRYG( 20, 31) =  0.892920E-01
  PKER_RDRYG( 20, 32) =  0.970435E-01
  PKER_RDRYG( 20, 33) =  0.103629E+00
  PKER_RDRYG( 20, 34) =  0.109103E+00
  PKER_RDRYG( 20, 35) =  0.113596E+00
  PKER_RDRYG( 20, 36) =  0.117263E+00
  PKER_RDRYG( 20, 37) =  0.120253E+00
  PKER_RDRYG( 20, 38) =  0.122692E+00
  PKER_RDRYG( 20, 39) =  0.124685E+00
  PKER_RDRYG( 20, 40) =  0.126314E+00
  PKER_RDRYG( 21,  1) =  0.138003E+02
  PKER_RDRYG( 21,  2) =  0.114121E+02
  PKER_RDRYG( 21,  3) =  0.943487E+01
  PKER_RDRYG( 21,  4) =  0.779796E+01
  PKER_RDRYG( 21,  5) =  0.644273E+01
  PKER_RDRYG( 21,  6) =  0.532068E+01
  PKER_RDRYG( 21,  7) =  0.439166E+01
  PKER_RDRYG( 21,  8) =  0.362242E+01
  PKER_RDRYG( 21,  9) =  0.298543E+01
  PKER_RDRYG( 21, 10) =  0.245792E+01
  PKER_RDRYG( 21, 11) =  0.202101E+01
  PKER_RDRYG( 21, 12) =  0.165907E+01
  PKER_RDRYG( 21, 13) =  0.135916E+01
  PKER_RDRYG( 21, 14) =  0.111057E+01
  PKER_RDRYG( 21, 15) =  0.904409E+00
  PKER_RDRYG( 21, 16) =  0.733329E+00
  PKER_RDRYG( 21, 17) =  0.591235E+00
  PKER_RDRYG( 21, 18) =  0.473092E+00
  PKER_RDRYG( 21, 19) =  0.374768E+00
  PKER_RDRYG( 21, 20) =  0.292928E+00
  PKER_RDRYG( 21, 21) =  0.224999E+00
  PKER_RDRYG( 21, 22) =  0.169182E+00
  PKER_RDRYG( 21, 23) =  0.124421E+00
  PKER_RDRYG( 21, 24) =  0.902987E-01
  PKER_RDRYG( 21, 25) =  0.666035E-01
  PKER_RDRYG( 21, 26) =  0.528135E-01
  PKER_RDRYG( 21, 27) =  0.476163E-01
  PKER_RDRYG( 21, 28) =  0.489721E-01
  PKER_RDRYG( 21, 29) =  0.544680E-01
  PKER_RDRYG( 21, 30) =  0.619547E-01
  PKER_RDRYG( 21, 31) =  0.698776E-01
  PKER_RDRYG( 21, 32) =  0.772992E-01
  PKER_RDRYG( 21, 33) =  0.838194E-01
  PKER_RDRYG( 21, 34) =  0.893378E-01
  PKER_RDRYG( 21, 35) =  0.939116E-01
  PKER_RDRYG( 21, 36) =  0.976604E-01
  PKER_RDRYG( 21, 37) =  0.100718E+00
  PKER_RDRYG( 21, 38) =  0.103210E+00
  PKER_RDRYG( 21, 39) =  0.105243E+00
  PKER_RDRYG( 21, 40) =  0.106903E+00
  PKER_RDRYG( 22,  1) =  0.138109E+02
  PKER_RDRYG( 22,  2) =  0.114228E+02
  PKER_RDRYG( 22,  3) =  0.944570E+01
  PKER_RDRYG( 22,  4) =  0.780889E+01
  PKER_RDRYG( 22,  5) =  0.645378E+01
  PKER_RDRYG( 22,  6) =  0.533186E+01
  PKER_RDRYG( 22,  7) =  0.440297E+01
  PKER_RDRYG( 22,  8) =  0.363389E+01
  PKER_RDRYG( 22,  9) =  0.299707E+01
  PKER_RDRYG( 22, 10) =  0.246974E+01
  PKER_RDRYG( 22, 11) =  0.203304E+01
  PKER_RDRYG( 22, 12) =  0.167134E+01
  PKER_RDRYG( 22, 13) =  0.137170E+01
  PKER_RDRYG( 22, 14) =  0.112341E+01
  PKER_RDRYG( 22, 15) =  0.917601E+00
  PKER_RDRYG( 22, 16) =  0.746917E+00
  PKER_RDRYG( 22, 17) =  0.605268E+00
  PKER_RDRYG( 22, 18) =  0.487610E+00
  PKER_RDRYG( 22, 19) =  0.389777E+00
  PKER_RDRYG( 22, 20) =  0.308353E+00
  PKER_RDRYG( 22, 21) =  0.240593E+00
  PKER_RDRYG( 22, 22) =  0.184395E+00
  PKER_RDRYG( 22, 23) =  0.138304E+00
  PKER_RDRYG( 22, 24) =  0.101518E+00
  PKER_RDRYG( 22, 25) =  0.737400E-01
  PKER_RDRYG( 22, 26) =  0.547362E-01
  PKER_RDRYG( 22, 27) =  0.440552E-01
  PKER_RDRYG( 22, 28) =  0.405040E-01
  PKER_RDRYG( 22, 29) =  0.422514E-01
  PKER_RDRYG( 22, 30) =  0.472981E-01
  PKER_RDRYG( 22, 31) =  0.538448E-01
  PKER_RDRYG( 22, 32) =  0.606126E-01
  PKER_RDRYG( 22, 33) =  0.668945E-01
  PKER_RDRYG( 22, 34) =  0.723746E-01
  PKER_RDRYG( 22, 35) =  0.769958E-01
  PKER_RDRYG( 22, 36) =  0.808177E-01
  PKER_RDRYG( 22, 37) =  0.839459E-01
  PKER_RDRYG( 22, 38) =  0.864957E-01
  PKER_RDRYG( 22, 39) =  0.885730E-01
  PKER_RDRYG( 22, 40) =  0.902671E-01
  PKER_RDRYG( 23,  1) =  0.138199E+02
  PKER_RDRYG( 23,  2) =  0.114318E+02
  PKER_RDRYG( 23,  3) =  0.945483E+01
  PKER_RDRYG( 23,  4) =  0.781810E+01
  PKER_RDRYG( 23,  5) =  0.646308E+01
  PKER_RDRYG( 23,  6) =  0.534126E+01
  PKER_RDRYG( 23,  7) =  0.441248E+01
  PKER_RDRYG( 23,  8) =  0.364351E+01
  PKER_RDRYG( 23,  9) =  0.300682E+01
  PKER_RDRYG( 23, 10) =  0.247963E+01
  PKER_RDRYG( 23, 11) =  0.204308E+01
  PKER_RDRYG( 23, 12) =  0.168156E+01
  PKER_RDRYG( 23, 13) =  0.138212E+01
  PKER_RDRYG( 23, 14) =  0.113405E+01
  PKER_RDRYG( 23, 15) =  0.928502E+00
  PKER_RDRYG( 23, 16) =  0.758112E+00
  PKER_RDRYG( 23, 17) =  0.616797E+00
  PKER_RDRYG( 23, 18) =  0.499515E+00
  PKER_RDRYG( 23, 19) =  0.402091E+00
  PKER_RDRYG( 23, 20) =  0.321077E+00
  PKER_RDRYG( 23, 21) =  0.253650E+00
  PKER_RDRYG( 23, 22) =  0.197550E+00
  PKER_RDRYG( 23, 23) =  0.151060E+00
  PKER_RDRYG( 23, 24) =  0.113025E+00
  PKER_RDRYG( 23, 25) =  0.828239E-01
  PKER_RDRYG( 23, 26) =  0.601986E-01
  PKER_RDRYG( 23, 27) =  0.450509E-01
  PKER_RDRYG( 23, 28) =  0.368416E-01
  PKER_RDRYG( 23, 29) =  0.345321E-01
  PKER_RDRYG( 23, 30) =  0.365251E-01
  PKER_RDRYG( 23, 31) =  0.410970E-01
  PKER_RDRYG( 23, 32) =  0.467824E-01
  PKER_RDRYG( 23, 33) =  0.525608E-01
  PKER_RDRYG( 23, 34) =  0.578657E-01
  PKER_RDRYG( 23, 35) =  0.624713E-01
  PKER_RDRYG( 23, 36) =  0.663413E-01
  PKER_RDRYG( 23, 37) =  0.695349E-01
  PKER_RDRYG( 23, 38) =  0.721454E-01
  PKER_RDRYG( 23, 39) =  0.742719E-01
  PKER_RDRYG( 23, 40) =  0.760039E-01
  PKER_RDRYG( 24,  1) =  0.138275E+02
  PKER_RDRYG( 24,  2) =  0.114395E+02
  PKER_RDRYG( 24,  3) =  0.946253E+01
  PKER_RDRYG( 24,  4) =  0.782587E+01
  PKER_RDRYG( 24,  5) =  0.647092E+01
  PKER_RDRYG( 24,  6) =  0.534917E+01
  PKER_RDRYG( 24,  7) =  0.442047E+01
  PKER_RDRYG( 24,  8) =  0.365159E+01
  PKER_RDRYG( 24,  9) =  0.301500E+01
  PKER_RDRYG( 24, 10) =  0.248792E+01
  PKER_RDRYG( 24, 11) =  0.205149E+01
  PKER_RDRYG( 24, 12) =  0.169009E+01
  PKER_RDRYG( 24, 13) =  0.139080E+01
  PKER_RDRYG( 24, 14) =  0.114290E+01
  PKER_RDRYG( 24, 15) =  0.937539E+00
  PKER_RDRYG( 24, 16) =  0.767365E+00
  PKER_RDRYG( 24, 17) =  0.626299E+00
  PKER_RDRYG( 24, 18) =  0.509299E+00
  PKER_RDRYG( 24, 19) =  0.412192E+00
  PKER_RDRYG( 24, 20) =  0.331522E+00
  PKER_RDRYG( 24, 21) =  0.264435E+00
  PKER_RDRYG( 24, 22) =  0.208600E+00
  PKER_RDRYG( 24, 23) =  0.162158E+00
  PKER_RDRYG( 24, 24) =  0.123712E+00
  PKER_RDRYG( 24, 25) =  0.923382E-01
  PKER_RDRYG( 24, 26) =  0.675660E-01
  PKER_RDRYG( 24, 27) =  0.492121E-01
  PKER_RDRYG( 24, 28) =  0.371392E-01
  PKER_RDRYG( 24, 29) =  0.309059E-01
  PKER_RDRYG( 24, 30) =  0.295040E-01
  PKER_RDRYG( 24, 31) =  0.315887E-01
  PKER_RDRYG( 24, 32) =  0.357033E-01
  PKER_RDRYG( 24, 33) =  0.406336E-01
  PKER_RDRYG( 24, 34) =  0.455581E-01
  PKER_RDRYG( 24, 35) =  0.500391E-01
  PKER_RDRYG( 24, 36) =  0.539067E-01
  PKER_RDRYG( 24, 37) =  0.571467E-01
  PKER_RDRYG( 24, 38) =  0.598152E-01
  PKER_RDRYG( 24, 39) =  0.619938E-01
  PKER_RDRYG( 24, 40) =  0.637676E-01
  PKER_RDRYG( 25,  1) =  0.138339E+02
  PKER_RDRYG( 25,  2) =  0.114460E+02
  PKER_RDRYG( 25,  3) =  0.946904E+01
  PKER_RDRYG( 25,  4) =  0.783243E+01
  PKER_RDRYG( 25,  5) =  0.647753E+01
  PKER_RDRYG( 25,  6) =  0.535584E+01
  PKER_RDRYG( 25,  7) =  0.442721E+01
  PKER_RDRYG( 25,  8) =  0.365839E+01
  PKER_RDRYG( 25,  9) =  0.302187E+01
  PKER_RDRYG( 25, 10) =  0.249487E+01
  PKER_RDRYG( 25, 11) =  0.205853E+01
  PKER_RDRYG( 25, 12) =  0.169723E+01
  PKER_RDRYG( 25, 13) =  0.139805E+01
  PKER_RDRYG( 25, 14) =  0.115028E+01
  PKER_RDRYG( 25, 15) =  0.945054E+00
  PKER_RDRYG( 25, 16) =  0.775040E+00
  PKER_RDRYG( 25, 17) =  0.634156E+00
  PKER_RDRYG( 25, 18) =  0.517365E+00
  PKER_RDRYG( 25, 19) =  0.420497E+00
  PKER_RDRYG( 25, 20) =  0.340095E+00
  PKER_RDRYG( 25, 21) =  0.273296E+00
  PKER_RDRYG( 25, 22) =  0.217743E+00
  PKER_RDRYG( 25, 23) =  0.171507E+00
  PKER_RDRYG( 25, 24) =  0.133065E+00
  PKER_RDRYG( 25, 25) =  0.101277E+00
  PKER_RDRYG( 25, 26) =  0.754131E-01
  PKER_RDRYG( 25, 27) =  0.551078E-01
  PKER_RDRYG( 25, 28) =  0.402423E-01
  PKER_RDRYG( 25, 29) =  0.306784E-01
  PKER_RDRYG( 25, 30) =  0.259723E-01
  PKER_RDRYG( 25, 31) =  0.252571E-01
  PKER_RDRYG( 25, 32) =  0.273487E-01
  PKER_RDRYG( 25, 33) =  0.310247E-01
  PKER_RDRYG( 25, 34) =  0.352825E-01
  PKER_RDRYG( 25, 35) =  0.394738E-01
  PKER_RDRYG( 25, 36) =  0.432539E-01
  PKER_RDRYG( 25, 37) =  0.465023E-01
  PKER_RDRYG( 25, 38) =  0.492145E-01
  PKER_RDRYG( 25, 39) =  0.514441E-01
  PKER_RDRYG( 25, 40) =  0.532625E-01
  PKER_RDRYG( 26,  1) =  0.138394E+02
  PKER_RDRYG( 26,  2) =  0.114514E+02
  PKER_RDRYG( 26,  3) =  0.947455E+01
  PKER_RDRYG( 26,  4) =  0.783798E+01
  PKER_RDRYG( 26,  5) =  0.648312E+01
  PKER_RDRYG( 26,  6) =  0.536147E+01
  PKER_RDRYG( 26,  7) =  0.443289E+01
  PKER_RDRYG( 26,  8) =  0.366412E+01
  PKER_RDRYG( 26,  9) =  0.302766E+01
  PKER_RDRYG( 26, 10) =  0.250072E+01
  PKER_RDRYG( 26, 11) =  0.206444E+01
  PKER_RDRYG( 26, 12) =  0.170322E+01
  PKER_RDRYG( 26, 13) =  0.140412E+01
  PKER_RDRYG( 26, 14) =  0.115644E+01
  PKER_RDRYG( 26, 15) =  0.951320E+00
  PKER_RDRYG( 26, 16) =  0.781424E+00
  PKER_RDRYG( 26, 17) =  0.640674E+00
  PKER_RDRYG( 26, 18) =  0.524038E+00
  PKER_RDRYG( 26, 19) =  0.427346E+00
  PKER_RDRYG( 26, 20) =  0.347145E+00
  PKER_RDRYG( 26, 21) =  0.280573E+00
  PKER_RDRYG( 26, 22) =  0.225261E+00
  PKER_RDRYG( 26, 23) =  0.179259E+00
  PKER_RDRYG( 26, 24) =  0.140975E+00
  PKER_RDRYG( 26, 25) =  0.109155E+00
  PKER_RDRYG( 26, 26) =  0.828827E-01
  PKER_RDRYG( 26, 27) =  0.615721E-01
  PKER_RDRYG( 26, 28) =  0.449413E-01
  PKER_RDRYG( 26, 29) =  0.329364E-01
  PKER_RDRYG( 26, 30) =  0.253888E-01
  PKER_RDRYG( 26, 31) =  0.218916E-01
  PKER_RDRYG( 26, 32) =  0.216696E-01
  PKER_RDRYG( 26, 33) =  0.236986E-01
  PKER_RDRYG( 26, 34) =  0.269569E-01
  PKER_RDRYG( 26, 35) =  0.306269E-01
  PKER_RDRYG( 26, 36) =  0.341888E-01
  PKER_RDRYG( 26, 37) =  0.373771E-01
  PKER_RDRYG( 26, 38) =  0.401030E-01
  PKER_RDRYG( 26, 39) =  0.423733E-01
  PKER_RDRYG( 26, 40) =  0.442362E-01
  PKER_RDRYG( 27,  1) =  0.138440E+02
  PKER_RDRYG( 27,  2) =  0.114560E+02
  PKER_RDRYG( 27,  3) =  0.947921E+01
  PKER_RDRYG( 27,  4) =  0.784267E+01
  PKER_RDRYG( 27,  5) =  0.648784E+01
  PKER_RDRYG( 27,  6) =  0.536623E+01
  PKER_RDRYG( 27,  7) =  0.443768E+01
  PKER_RDRYG( 27,  8) =  0.366895E+01
  PKER_RDRYG( 27,  9) =  0.303253E+01
  PKER_RDRYG( 27, 10) =  0.250564E+01
  PKER_RDRYG( 27, 11) =  0.206942E+01
  PKER_RDRYG( 27, 12) =  0.170825E+01
  PKER_RDRYG( 27, 13) =  0.140921E+01
  PKER_RDRYG( 27, 14) =  0.116160E+01
  PKER_RDRYG( 27, 15) =  0.956558E+00
  PKER_RDRYG( 27, 16) =  0.786749E+00
  PKER_RDRYG( 27, 17) =  0.646098E+00
  PKER_RDRYG( 27, 18) =  0.529575E+00
  PKER_RDRYG( 27, 19) =  0.433014E+00
  PKER_RDRYG( 27, 20) =  0.352962E+00
  PKER_RDRYG( 27, 21) =  0.286560E+00
  PKER_RDRYG( 27, 22) =  0.231439E+00
  PKER_RDRYG( 27, 23) =  0.185639E+00
  PKER_RDRYG( 27, 24) =  0.147545E+00
  PKER_RDRYG( 27, 25) =  0.115846E+00
  PKER_RDRYG( 27, 26) =  0.895139E-01
  PKER_RDRYG( 27, 27) =  0.678043E-01
  PKER_RDRYG( 27, 28) =  0.502589E-01
  PKER_RDRYG( 27, 29) =  0.366803E-01
  PKER_RDRYG( 27, 30) =  0.269840E-01
  PKER_RDRYG( 27, 31) =  0.210536E-01
  PKER_RDRYG( 27, 32) =  0.184920E-01
  PKER_RDRYG( 27, 33) =  0.186221E-01
  PKER_RDRYG( 27, 34) =  0.205486E-01
  PKER_RDRYG( 27, 35) =  0.234200E-01
  PKER_RDRYG( 27, 36) =  0.265772E-01
  PKER_RDRYG( 27, 37) =  0.296001E-01
  PKER_RDRYG( 27, 38) =  0.322869E-01
  PKER_RDRYG( 27, 39) =  0.345747E-01
  PKER_RDRYG( 27, 40) =  0.364748E-01
  PKER_RDRYG( 28,  1) =  0.138479E+02
  PKER_RDRYG( 28,  2) =  0.114600E+02
  PKER_RDRYG( 28,  3) =  0.948316E+01
  PKER_RDRYG( 28,  4) =  0.784664E+01
  PKER_RDRYG( 28,  5) =  0.649184E+01
  PKER_RDRYG( 28,  6) =  0.537025E+01
  PKER_RDRYG( 28,  7) =  0.444173E+01
  PKER_RDRYG( 28,  8) =  0.367304E+01
  PKER_RDRYG( 28,  9) =  0.303665E+01
  PKER_RDRYG( 28, 10) =  0.250979E+01
  PKER_RDRYG( 28, 11) =  0.207361E+01
  PKER_RDRYG( 28, 12) =  0.171248E+01
  PKER_RDRYG( 28, 13) =  0.141349E+01
  PKER_RDRYG( 28, 14) =  0.116593E+01
  PKER_RDRYG( 28, 15) =  0.960947E+00
  PKER_RDRYG( 28, 16) =  0.791203E+00
  PKER_RDRYG( 28, 17) =  0.650625E+00
  PKER_RDRYG( 28, 18) =  0.534185E+00
  PKER_RDRYG( 28, 19) =  0.437719E+00
  PKER_RDRYG( 28, 20) =  0.357777E+00
  PKER_RDRYG( 28, 21) =  0.291501E+00
  PKER_RDRYG( 28, 22) =  0.236523E+00
  PKER_RDRYG( 28, 23) =  0.190884E+00
  PKER_RDRYG( 28, 24) =  0.152959E+00
  PKER_RDRYG( 28, 25) =  0.121415E+00
  PKER_RDRYG( 28, 26) =  0.951696E-01
  PKER_RDRYG( 28, 27) =  0.733827E-01
  PKER_RDRYG( 28, 28) =  0.554501E-01
  PKER_RDRYG( 28, 29) =  0.410159E-01
  PKER_RDRYG( 28, 30) =  0.299322E-01
  PKER_RDRYG( 28, 31) =  0.221290E-01
  PKER_RDRYG( 28, 32) =  0.174911E-01
  PKER_RDRYG( 28, 33) =  0.156662E-01
  PKER_RDRYG( 28, 34) =  0.160216E-01
  PKER_RDRYG( 28, 35) =  0.178216E-01
  PKER_RDRYG( 28, 36) =  0.203456E-01
  PKER_RDRYG( 28, 37) =  0.230543E-01
  PKER_RDRYG( 28, 38) =  0.256182E-01
  PKER_RDRYG( 28, 39) =  0.278812E-01
  PKER_RDRYG( 28, 40) =  0.298004E-01
  PKER_RDRYG( 29,  1) =  0.138512E+02
  PKER_RDRYG( 29,  2) =  0.114633E+02
  PKER_RDRYG( 29,  3) =  0.948650E+01
  PKER_RDRYG( 29,  4) =  0.785000E+01
  PKER_RDRYG( 29,  5) =  0.649522E+01
  PKER_RDRYG( 29,  6) =  0.537366E+01
  PKER_RDRYG( 29,  7) =  0.444516E+01
  PKER_RDRYG( 29,  8) =  0.367649E+01
  PKER_RDRYG( 29,  9) =  0.304013E+01
  PKER_RDRYG( 29, 10) =  0.251330E+01
  PKER_RDRYG( 29, 11) =  0.207714E+01
  PKER_RDRYG( 29, 12) =  0.171605E+01
  PKER_RDRYG( 29, 13) =  0.141709E+01
  PKER_RDRYG( 29, 14) =  0.116957E+01
  PKER_RDRYG( 29, 15) =  0.964632E+00
  PKER_RDRYG( 29, 16) =  0.794935E+00
  PKER_RDRYG( 29, 17) =  0.654412E+00
  PKER_RDRYG( 29, 18) =  0.538034E+00
  PKER_RDRYG( 29, 19) =  0.441637E+00
  PKER_RDRYG( 29, 20) =  0.361775E+00
  PKER_RDRYG( 29, 21) =  0.295592E+00
  PKER_RDRYG( 29, 22) =  0.240721E+00
  PKER_RDRYG( 29, 23) =  0.195203E+00
  PKER_RDRYG( 29, 24) =  0.157413E+00
  PKER_RDRYG( 29, 25) =  0.126010E+00
  PKER_RDRYG( 29, 26) =  0.998897E-01
  PKER_RDRYG( 29, 27) =  0.781613E-01
  PKER_RDRYG( 29, 28) =  0.601349E-01
  PKER_RDRYG( 29, 29) =  0.453296E-01
  PKER_RDRYG( 29, 30) =  0.334668E-01
  PKER_RDRYG( 29, 31) =  0.244241E-01
  PKER_RDRYG( 29, 32) =  0.181733E-01
  PKER_RDRYG( 29, 33) =  0.145718E-01
  PKER_RDRYG( 29, 34) =  0.133001E-01
  PKER_RDRYG( 29, 35) =  0.138127E-01
  PKER_RDRYG( 29, 36) =  0.154662E-01
  PKER_RDRYG( 29, 37) =  0.176729E-01
  PKER_RDRYG( 29, 38) =  0.199915E-01
  PKER_RDRYG( 29, 39) =  0.221631E-01
  PKER_RDRYG( 29, 40) =  0.240688E-01
  PKER_RDRYG( 30,  1) =  0.138540E+02
  PKER_RDRYG( 30,  2) =  0.114661E+02
  PKER_RDRYG( 30,  3) =  0.948934E+01
  PKER_RDRYG( 30,  4) =  0.785286E+01
  PKER_RDRYG( 30,  5) =  0.649809E+01
  PKER_RDRYG( 30,  6) =  0.537654E+01
  PKER_RDRYG( 30,  7) =  0.444806E+01
  PKER_RDRYG( 30,  8) =  0.367941E+01
  PKER_RDRYG( 30,  9) =  0.304307E+01
  PKER_RDRYG( 30, 10) =  0.251626E+01
  PKER_RDRYG( 30, 11) =  0.208013E+01
  PKER_RDRYG( 30, 12) =  0.171906E+01
  PKER_RDRYG( 30, 13) =  0.142013E+01
  PKER_RDRYG( 30, 14) =  0.117264E+01
  PKER_RDRYG( 30, 15) =  0.967730E+00
  PKER_RDRYG( 30, 16) =  0.798070E+00
  PKER_RDRYG( 30, 17) =  0.657587E+00
  PKER_RDRYG( 30, 18) =  0.541254E+00
  PKER_RDRYG( 30, 19) =  0.444909E+00
  PKER_RDRYG( 30, 20) =  0.365106E+00
  PKER_RDRYG( 30, 21) =  0.298991E+00
  PKER_RDRYG( 30, 22) =  0.244198E+00
  PKER_RDRYG( 30, 23) =  0.198769E+00
  PKER_RDRYG( 30, 24) =  0.161082E+00
  PKER_RDRYG( 30, 25) =  0.129793E+00
  PKER_RDRYG( 30, 26) =  0.103790E+00
  PKER_RDRYG( 30, 27) =  0.821610E-01
  PKER_RDRYG( 30, 28) =  0.641734E-01
  PKER_RDRYG( 30, 29) =  0.492644E-01
  PKER_RDRYG( 30, 30) =  0.370449E-01
  PKER_RDRYG( 30, 31) =  0.273020E-01
  PKER_RDRYG( 30, 32) =  0.199464E-01
  PKER_RDRYG( 30, 33) =  0.149418E-01
  PKER_RDRYG( 30, 34) =  0.121711E-01
  PKER_RDRYG( 30, 35) =  0.113170E-01
  PKER_RDRYG( 30, 36) =  0.119183E-01
  PKER_RDRYG( 30, 37) =  0.134237E-01
  PKER_RDRYG( 30, 38) =  0.153458E-01
  PKER_RDRYG( 30, 39) =  0.173290E-01
  PKER_RDRYG( 30, 40) =  0.191677E-01
  PKER_RDRYG( 31,  1) =  0.138564E+02
  PKER_RDRYG( 31,  2) =  0.114685E+02
  PKER_RDRYG( 31,  3) =  0.949175E+01
  PKER_RDRYG( 31,  4) =  0.785528E+01
  PKER_RDRYG( 31,  5) =  0.650052E+01
  PKER_RDRYG( 31,  6) =  0.537899E+01
  PKER_RDRYG( 31,  7) =  0.445052E+01
  PKER_RDRYG( 31,  8) =  0.368188E+01
  PKER_RDRYG( 31,  9) =  0.304556E+01
  PKER_RDRYG( 31, 10) =  0.251877E+01
  PKER_RDRYG( 31, 11) =  0.208265E+01
  PKER_RDRYG( 31, 12) =  0.172160E+01
  PKER_RDRYG( 31, 13) =  0.142269E+01
  PKER_RDRYG( 31, 14) =  0.117522E+01
  PKER_RDRYG( 31, 15) =  0.970340E+00
  PKER_RDRYG( 31, 16) =  0.800707E+00
  PKER_RDRYG( 31, 17) =  0.660255E+00
  PKER_RDRYG( 31, 18) =  0.543956E+00
  PKER_RDRYG( 31, 19) =  0.447649E+00
  PKER_RDRYG( 31, 20) =  0.367889E+00
  PKER_RDRYG( 31, 21) =  0.301823E+00
  PKER_RDRYG( 31, 22) =  0.247087E+00
  PKER_RDRYG( 31, 23) =  0.201725E+00
  PKER_RDRYG( 31, 24) =  0.164114E+00
  PKER_RDRYG( 31, 25) =  0.132910E+00
  PKER_RDRYG( 31, 26) =  0.107003E+00
  PKER_RDRYG( 31, 27) =  0.854709E-01
  PKER_RDRYG( 31, 28) =  0.675620E-01
  PKER_RDRYG( 31, 29) =  0.526723E-01
  PKER_RDRYG( 31, 30) =  0.403428E-01
  PKER_RDRYG( 31, 31) =  0.302637E-01
  PKER_RDRYG( 31, 32) =  0.222653E-01
  PKER_RDRYG( 31, 33) =  0.162939E-01
  PKER_RDRYG( 31, 34) =  0.123058E-01
  PKER_RDRYG( 31, 35) =  0.101795E-01
  PKER_RDRYG( 31, 36) =  0.964983E-02
  PKER_RDRYG( 31, 37) =  0.102948E-01
  PKER_RDRYG( 31, 38) =  0.116552E-01
  PKER_RDRYG( 31, 39) =  0.133239E-01
  PKER_RDRYG( 31, 40) =  0.150165E-01
  PKER_RDRYG( 32,  1) =  0.138584E+02
  PKER_RDRYG( 32,  2) =  0.114706E+02
  PKER_RDRYG( 32,  3) =  0.949379E+01
  PKER_RDRYG( 32,  4) =  0.785733E+01
  PKER_RDRYG( 32,  5) =  0.650259E+01
  PKER_RDRYG( 32,  6) =  0.538106E+01
  PKER_RDRYG( 32,  7) =  0.445260E+01
  PKER_RDRYG( 32,  8) =  0.368398E+01
  PKER_RDRYG( 32,  9) =  0.304766E+01
  PKER_RDRYG( 32, 10) =  0.252089E+01
  PKER_RDRYG( 32, 11) =  0.208479E+01
  PKER_RDRYG( 32, 12) =  0.172375E+01
  PKER_RDRYG( 32, 13) =  0.142486E+01
  PKER_RDRYG( 32, 14) =  0.117741E+01
  PKER_RDRYG( 32, 15) =  0.972542E+00
  PKER_RDRYG( 32, 16) =  0.802930E+00
  PKER_RDRYG( 32, 17) =  0.662499E+00
  PKER_RDRYG( 32, 18) =  0.546226E+00
  PKER_RDRYG( 32, 19) =  0.449948E+00
  PKER_RDRYG( 32, 20) =  0.370220E+00
  PKER_RDRYG( 32, 21) =  0.304190E+00
  PKER_RDRYG( 32, 22) =  0.249496E+00
  PKER_RDRYG( 32, 23) =  0.204181E+00
  PKER_RDRYG( 32, 24) =  0.166626E+00
  PKER_RDRYG( 32, 25) =  0.135487E+00
  PKER_RDRYG( 32, 26) =  0.109652E+00
  PKER_RDRYG( 32, 27) =  0.882004E-01
  PKER_RDRYG( 32, 28) =  0.703714E-01
  PKER_RDRYG( 32, 29) =  0.555429E-01
  PKER_RDRYG( 32, 30) =  0.432184E-01
  PKER_RDRYG( 32, 31) =  0.330257E-01
  PKER_RDRYG( 32, 32) =  0.247158E-01
  PKER_RDRYG( 32, 33) =  0.181591E-01
  PKER_RDRYG( 32, 34) =  0.133191E-01
  PKER_RDRYG( 32, 35) =  0.101524E-01
  PKER_RDRYG( 32, 36) =  0.854593E-02
  PKER_RDRYG( 32, 37) =  0.824929E-02
  PKER_RDRYG( 32, 38) =  0.890385E-02
  PKER_RDRYG( 32, 39) =  0.101193E-01
  PKER_RDRYG( 32, 40) =  0.115645E-01
  PKER_RDRYG( 33,  1) =  0.138601E+02
  PKER_RDRYG( 33,  2) =  0.114723E+02
  PKER_RDRYG( 33,  3) =  0.949553E+01
  PKER_RDRYG( 33,  4) =  0.785908E+01
  PKER_RDRYG( 33,  5) =  0.650434E+01
  PKER_RDRYG( 33,  6) =  0.538282E+01
  PKER_RDRYG( 33,  7) =  0.445437E+01
  PKER_RDRYG( 33,  8) =  0.368576E+01
  PKER_RDRYG( 33,  9) =  0.304945E+01
  PKER_RDRYG( 33, 10) =  0.252268E+01
  PKER_RDRYG( 33, 11) =  0.208659E+01
  PKER_RDRYG( 33, 12) =  0.172557E+01
  PKER_RDRYG( 33, 13) =  0.142669E+01
  PKER_RDRYG( 33, 14) =  0.117925E+01
  PKER_RDRYG( 33, 15) =  0.974401E+00
  PKER_RDRYG( 33, 16) =  0.804805E+00
  PKER_RDRYG( 33, 17) =  0.664392E+00
  PKER_RDRYG( 33, 18) =  0.548137E+00
  PKER_RDRYG( 33, 19) =  0.451880E+00
  PKER_RDRYG( 33, 20) =  0.372176E+00
  PKER_RDRYG( 33, 21) =  0.306173E+00
  PKER_RDRYG( 33, 22) =  0.251510E+00
  PKER_RDRYG( 33, 23) =  0.206230E+00
  PKER_RDRYG( 33, 24) =  0.168715E+00
  PKER_RDRYG( 33, 25) =  0.137623E+00
  PKER_RDRYG( 33, 26) =  0.111843E+00
  PKER_RDRYG( 33, 27) =  0.904523E-01
  PKER_RDRYG( 33, 28) =  0.726902E-01
  PKER_RDRYG( 33, 29) =  0.579273E-01
  PKER_RDRYG( 33, 30) =  0.456499E-01
  PKER_RDRYG( 33, 31) =  0.354504E-01
  PKER_RDRYG( 33, 32) =  0.270255E-01
  PKER_RDRYG( 33, 33) =  0.201789E-01
  PKER_RDRYG( 33, 34) =  0.148159E-01
  PKER_RDRYG( 33, 35) =  0.108951E-01
  PKER_RDRYG( 33, 36) =  0.838982E-02
  PKER_RDRYG( 33, 37) =  0.718623E-02
  PKER_RDRYG( 33, 38) =  0.706271E-02
  PKER_RDRYG( 33, 39) =  0.770543E-02
  PKER_RDRYG( 33, 40) =  0.878717E-02
  PKER_RDRYG( 34,  1) =  0.138616E+02
  PKER_RDRYG( 34,  2) =  0.114738E+02
  PKER_RDRYG( 34,  3) =  0.949701E+01
  PKER_RDRYG( 34,  4) =  0.786056E+01
  PKER_RDRYG( 34,  5) =  0.650583E+01
  PKER_RDRYG( 34,  6) =  0.538432E+01
  PKER_RDRYG( 34,  7) =  0.445588E+01
  PKER_RDRYG( 34,  8) =  0.368726E+01
  PKER_RDRYG( 34,  9) =  0.305097E+01
  PKER_RDRYG( 34, 10) =  0.252421E+01
  PKER_RDRYG( 34, 11) =  0.208813E+01
  PKER_RDRYG( 34, 12) =  0.172711E+01
  PKER_RDRYG( 34, 13) =  0.142824E+01
  PKER_RDRYG( 34, 14) =  0.118081E+01
  PKER_RDRYG( 34, 15) =  0.975973E+00
  PKER_RDRYG( 34, 16) =  0.806389E+00
  PKER_RDRYG( 34, 17) =  0.665989E+00
  PKER_RDRYG( 34, 18) =  0.549748E+00
  PKER_RDRYG( 34, 19) =  0.453507E+00
  PKER_RDRYG( 34, 20) =  0.373821E+00
  PKER_RDRYG( 34, 21) =  0.307838E+00
  PKER_RDRYG( 34, 22) =  0.253197E+00
  PKER_RDRYG( 34, 23) =  0.207944E+00
  PKER_RDRYG( 34, 24) =  0.170458E+00
  PKER_RDRYG( 34, 25) =  0.139400E+00
  PKER_RDRYG( 34, 26) =  0.113659E+00
  PKER_RDRYG( 34, 27) =  0.923147E-01
  PKER_RDRYG( 34, 28) =  0.746045E-01
  PKER_RDRYG( 34, 29) =  0.598974E-01
  PKER_RDRYG( 34, 30) =  0.476733E-01
  PKER_RDRYG( 34, 31) =  0.375085E-01
  PKER_RDRYG( 34, 32) =  0.290687E-01
  PKER_RDRYG( 34, 33) =  0.221077E-01
  PKER_RDRYG( 34, 34) =  0.164706E-01
  PKER_RDRYG( 34, 35) =  0.120829E-01
  PKER_RDRYG( 34, 36) =  0.891924E-02
  PKER_RDRYG( 34, 37) =  0.694498E-02
  PKER_RDRYG( 34, 38) =  0.605978E-02
  PKER_RDRYG( 34, 39) =  0.605815E-02
  PKER_RDRYG( 34, 40) =  0.667329E-02
  PKER_RDRYG( 35,  1) =  0.138628E+02
  PKER_RDRYG( 35,  2) =  0.114750E+02
  PKER_RDRYG( 35,  3) =  0.949827E+01
  PKER_RDRYG( 35,  4) =  0.786182E+01
  PKER_RDRYG( 35,  5) =  0.650709E+01
  PKER_RDRYG( 35,  6) =  0.538559E+01
  PKER_RDRYG( 35,  7) =  0.445715E+01
  PKER_RDRYG( 35,  8) =  0.368855E+01
  PKER_RDRYG( 35,  9) =  0.305226E+01
  PKER_RDRYG( 35, 10) =  0.252550E+01
  PKER_RDRYG( 35, 11) =  0.208943E+01
  PKER_RDRYG( 35, 12) =  0.172842E+01
  PKER_RDRYG( 35, 13) =  0.142955E+01
  PKER_RDRYG( 35, 14) =  0.118213E+01
  PKER_RDRYG( 35, 15) =  0.977304E+00
  PKER_RDRYG( 35, 16) =  0.807728E+00
  PKER_RDRYG( 35, 17) =  0.667338E+00
  PKER_RDRYG( 35, 18) =  0.551109E+00
  PKER_RDRYG( 35, 19) =  0.454880E+00
  PKER_RDRYG( 35, 20) =  0.375207E+00
  PKER_RDRYG( 35, 21) =  0.309239E+00
  PKER_RDRYG( 35, 22) =  0.254615E+00
  PKER_RDRYG( 35, 23) =  0.209380E+00
  PKER_RDRYG( 35, 24) =  0.171916E+00
  PKER_RDRYG( 35, 25) =  0.140883E+00
  PKER_RDRYG( 35, 26) =  0.115171E+00
  PKER_RDRYG( 35, 27) =  0.938600E-01
  PKER_RDRYG( 35, 28) =  0.761883E-01
  PKER_RDRYG( 35, 29) =  0.615248E-01
  PKER_RDRYG( 35, 30) =  0.493472E-01
  PKER_RDRYG( 35, 31) =  0.392256E-01
  PKER_RDRYG( 35, 32) =  0.308103E-01
  PKER_RDRYG( 35, 33) =  0.238270E-01
  PKER_RDRYG( 35, 34) =  0.180779E-01
  PKER_RDRYG( 35, 35) =  0.134407E-01
  PKER_RDRYG( 35, 36) =  0.985642E-02
  PKER_RDRYG( 35, 37) =  0.730986E-02
  PKER_RDRYG( 35, 38) =  0.576437E-02
  PKER_RDRYG( 35, 39) =  0.512255E-02
  PKER_RDRYG( 35, 40) =  0.520497E-02
  PKER_RDRYG( 36,  1) =  0.138639E+02
  PKER_RDRYG( 36,  2) =  0.114761E+02
  PKER_RDRYG( 36,  3) =  0.949934E+01
  PKER_RDRYG( 36,  4) =  0.786289E+01
  PKER_RDRYG( 36,  5) =  0.650817E+01
  PKER_RDRYG( 36,  6) =  0.538667E+01
  PKER_RDRYG( 36,  7) =  0.445824E+01
  PKER_RDRYG( 36,  8) =  0.368964E+01
  PKER_RDRYG( 36,  9) =  0.305335E+01
  PKER_RDRYG( 36, 10) =  0.252660E+01
  PKER_RDRYG( 36, 11) =  0.209053E+01
  PKER_RDRYG( 36, 12) =  0.172953E+01
  PKER_RDRYG( 36, 13) =  0.143067E+01
  PKER_RDRYG( 36, 14) =  0.118326E+01
  PKER_RDRYG( 36, 15) =  0.978431E+00
  PKER_RDRYG( 36, 16) =  0.808862E+00
  PKER_RDRYG( 36, 17) =  0.668480E+00
  PKER_RDRYG( 36, 18) =  0.552259E+00
  PKER_RDRYG( 36, 19) =  0.456039E+00
  PKER_RDRYG( 36, 20) =  0.376376E+00
  PKER_RDRYG( 36, 21) =  0.310419E+00
  PKER_RDRYG( 36, 22) =  0.255807E+00
  PKER_RDRYG( 36, 23) =  0.210587E+00
  PKER_RDRYG( 36, 24) =  0.173139E+00
  PKER_RDRYG( 36, 25) =  0.142124E+00
  PKER_RDRYG( 36, 26) =  0.116433E+00
  PKER_RDRYG( 36, 27) =  0.951462E-01
  PKER_RDRYG( 36, 28) =  0.775028E-01
  PKER_RDRYG( 36, 29) =  0.628718E-01
  PKER_RDRYG( 36, 30) =  0.507309E-01
  PKER_RDRYG( 36, 31) =  0.406479E-01
  PKER_RDRYG( 36, 32) =  0.322672E-01
  PKER_RDRYG( 36, 33) =  0.253008E-01
  PKER_RDRYG( 36, 34) =  0.195243E-01
  PKER_RDRYG( 36, 35) =  0.147772E-01
  PKER_RDRYG( 36, 36) =  0.109648E-01
  PKER_RDRYG( 36, 37) =  0.804278E-02
  PKER_RDRYG( 36, 38) =  0.599708E-02
  PKER_RDRYG( 36, 39) =  0.479430E-02
  PKER_RDRYG( 36, 40) =  0.433950E-02
  PKER_RDRYG( 37,  1) =  0.138648E+02
  PKER_RDRYG( 37,  2) =  0.114770E+02
  PKER_RDRYG( 37,  3) =  0.950025E+01
  PKER_RDRYG( 37,  4) =  0.786381E+01
  PKER_RDRYG( 37,  5) =  0.650909E+01
  PKER_RDRYG( 37,  6) =  0.538759E+01
  PKER_RDRYG( 37,  7) =  0.445916E+01
  PKER_RDRYG( 37,  8) =  0.369056E+01
  PKER_RDRYG( 37,  9) =  0.305428E+01
  PKER_RDRYG( 37, 10) =  0.252753E+01
  PKER_RDRYG( 37, 11) =  0.209147E+01
  PKER_RDRYG( 37, 12) =  0.173047E+01
  PKER_RDRYG( 37, 13) =  0.143161E+01
  PKER_RDRYG( 37, 14) =  0.118421E+01
  PKER_RDRYG( 37, 15) =  0.979386E+00
  PKER_RDRYG( 37, 16) =  0.809823E+00
  PKER_RDRYG( 37, 17) =  0.669447E+00
  PKER_RDRYG( 37, 18) =  0.553232E+00
  PKER_RDRYG( 37, 19) =  0.457019E+00
  PKER_RDRYG( 37, 20) =  0.377364E+00
  PKER_RDRYG( 37, 21) =  0.311415E+00
  PKER_RDRYG( 37, 22) =  0.256813E+00
  PKER_RDRYG( 37, 23) =  0.211602E+00
  PKER_RDRYG( 37, 24) =  0.174166E+00
  PKER_RDRYG( 37, 25) =  0.143165E+00
  PKER_RDRYG( 37, 26) =  0.117489E+00
  PKER_RDRYG( 37, 27) =  0.962203E-01
  PKER_RDRYG( 37, 28) =  0.785973E-01
  PKER_RDRYG( 37, 29) =  0.639902E-01
  PKER_RDRYG( 37, 30) =  0.518768E-01
  PKER_RDRYG( 37, 31) =  0.418245E-01
  PKER_RDRYG( 37, 32) =  0.334758E-01
  PKER_RDRYG( 37, 33) =  0.265367E-01
  PKER_RDRYG( 37, 34) =  0.207701E-01
  PKER_RDRYG( 37, 35) =  0.159926E-01
  PKER_RDRYG( 37, 36) =  0.120751E-01
  PKER_RDRYG( 37, 37) =  0.894122E-02
  PKER_RDRYG( 37, 38) =  0.656445E-02
  PKER_RDRYG( 37, 39) =  0.492634E-02
  PKER_RDRYG( 37, 40) =  0.399357E-02
  PKER_RDRYG( 38,  1) =  0.138656E+02
  PKER_RDRYG( 38,  2) =  0.114778E+02
  PKER_RDRYG( 38,  3) =  0.950102E+01
  PKER_RDRYG( 38,  4) =  0.786459E+01
  PKER_RDRYG( 38,  5) =  0.650987E+01
  PKER_RDRYG( 38,  6) =  0.538837E+01
  PKER_RDRYG( 38,  7) =  0.445994E+01
  PKER_RDRYG( 38,  8) =  0.369135E+01
  PKER_RDRYG( 38,  9) =  0.305507E+01
  PKER_RDRYG( 38, 10) =  0.252833E+01
  PKER_RDRYG( 38, 11) =  0.209226E+01
  PKER_RDRYG( 38, 12) =  0.173127E+01
  PKER_RDRYG( 38, 13) =  0.143242E+01
  PKER_RDRYG( 38, 14) =  0.118501E+01
  PKER_RDRYG( 38, 15) =  0.980197E+00
  PKER_RDRYG( 38, 16) =  0.810638E+00
  PKER_RDRYG( 38, 17) =  0.670266E+00
  PKER_RDRYG( 38, 18) =  0.554056E+00
  PKER_RDRYG( 38, 19) =  0.457849E+00
  PKER_RDRYG( 38, 20) =  0.378199E+00
  PKER_RDRYG( 38, 21) =  0.312257E+00
  PKER_RDRYG( 38, 22) =  0.257661E+00
  PKER_RDRYG( 38, 23) =  0.212459E+00
  PKER_RDRYG( 38, 24) =  0.175032E+00
  PKER_RDRYG( 38, 25) =  0.144040E+00
  PKER_RDRYG( 38, 26) =  0.118376E+00
  PKER_RDRYG( 38, 27) =  0.971196E-01
  PKER_RDRYG( 38, 28) =  0.795116E-01
  PKER_RDRYG( 38, 29) =  0.649218E-01
  PKER_RDRYG( 38, 30) =  0.528285E-01
  PKER_RDRYG( 38, 31) =  0.427994E-01
  PKER_RDRYG( 38, 32) =  0.344764E-01
  PKER_RDRYG( 38, 33) =  0.275637E-01
  PKER_RDRYG( 38, 34) =  0.218184E-01
  PKER_RDRYG( 38, 35) =  0.170452E-01
  PKER_RDRYG( 38, 36) =  0.130949E-01
  PKER_RDRYG( 38, 37) =  0.986356E-02
  PKER_RDRYG( 38, 38) =  0.729306E-02
  PKER_RDRYG( 38, 39) =  0.536046E-02
  PKER_RDRYG( 38, 40) =  0.405286E-02
  PKER_RDRYG( 39,  1) =  0.138662E+02
  PKER_RDRYG( 39,  2) =  0.114784E+02
  PKER_RDRYG( 39,  3) =  0.950168E+01
  PKER_RDRYG( 39,  4) =  0.786525E+01
  PKER_RDRYG( 39,  5) =  0.651053E+01
  PKER_RDRYG( 39,  6) =  0.538904E+01
  PKER_RDRYG( 39,  7) =  0.446061E+01
  PKER_RDRYG( 39,  8) =  0.369202E+01
  PKER_RDRYG( 39,  9) =  0.305574E+01
  PKER_RDRYG( 39, 10) =  0.252900E+01
  PKER_RDRYG( 39, 11) =  0.209294E+01
  PKER_RDRYG( 39, 12) =  0.173195E+01
  PKER_RDRYG( 39, 13) =  0.143310E+01
  PKER_RDRYG( 39, 14) =  0.118570E+01
  PKER_RDRYG( 39, 15) =  0.980885E+00
  PKER_RDRYG( 39, 16) =  0.811330E+00
  PKER_RDRYG( 39, 17) =  0.670961E+00
  PKER_RDRYG( 39, 18) =  0.554755E+00
  PKER_RDRYG( 39, 19) =  0.458552E+00
  PKER_RDRYG( 39, 20) =  0.378906E+00
  PKER_RDRYG( 39, 21) =  0.312969E+00
  PKER_RDRYG( 39, 22) =  0.258379E+00
  PKER_RDRYG( 39, 23) =  0.213182E+00
  PKER_RDRYG( 39, 24) =  0.175762E+00
  PKER_RDRYG( 39, 25) =  0.144777E+00
  PKER_RDRYG( 39, 26) =  0.119121E+00
  PKER_RDRYG( 39, 27) =  0.978744E-01
  PKER_RDRYG( 39, 28) =  0.802773E-01
  PKER_RDRYG( 39, 29) =  0.657001E-01
  PKER_RDRYG( 39, 30) =  0.536215E-01
  PKER_RDRYG( 39, 31) =  0.436093E-01
  PKER_RDRYG( 39, 32) =  0.353058E-01
  PKER_RDRYG( 39, 33) =  0.284146E-01
  PKER_RDRYG( 39, 34) =  0.226909E-01
  PKER_RDRYG( 39, 35) =  0.179343E-01
  PKER_RDRYG( 39, 36) =  0.139841E-01
  PKER_RDRYG( 39, 37) =  0.107183E-01
  PKER_RDRYG( 39, 38) =  0.805446E-02
  PKER_RDRYG( 39, 39) =  0.594845E-02
  PKER_RDRYG( 39, 40) =  0.437943E-02
  PKER_RDRYG( 40,  1) =  0.138668E+02
  PKER_RDRYG( 40,  2) =  0.114790E+02
  PKER_RDRYG( 40,  3) =  0.950225E+01
  PKER_RDRYG( 40,  4) =  0.786581E+01
  PKER_RDRYG( 40,  5) =  0.651110E+01
  PKER_RDRYG( 40,  6) =  0.538960E+01
  PKER_RDRYG( 40,  7) =  0.446118E+01
  PKER_RDRYG( 40,  8) =  0.369259E+01
  PKER_RDRYG( 40,  9) =  0.305631E+01
  PKER_RDRYG( 40, 10) =  0.252958E+01
  PKER_RDRYG( 40, 11) =  0.209352E+01
  PKER_RDRYG( 40, 12) =  0.173253E+01
  PKER_RDRYG( 40, 13) =  0.143368E+01
  PKER_RDRYG( 40, 14) =  0.118628E+01
  PKER_RDRYG( 40, 15) =  0.981470E+00
  PKER_RDRYG( 40, 16) =  0.811917E+00
  PKER_RDRYG( 40, 17) =  0.671551E+00
  PKER_RDRYG( 40, 18) =  0.555348E+00
  PKER_RDRYG( 40, 19) =  0.459148E+00
  PKER_RDRYG( 40, 20) =  0.379506E+00
  PKER_RDRYG( 40, 21) =  0.313572E+00
  PKER_RDRYG( 40, 22) =  0.258986E+00
  PKER_RDRYG( 40, 23) =  0.213794E+00
  PKER_RDRYG( 40, 24) =  0.176378E+00
  PKER_RDRYG( 40, 25) =  0.145399E+00
  PKER_RDRYG( 40, 26) =  0.119749E+00
  PKER_RDRYG( 40, 27) =  0.985094E-01
  PKER_RDRYG( 40, 28) =  0.809202E-01
  PKER_RDRYG( 40, 29) =  0.663522E-01
  PKER_RDRYG( 40, 30) =  0.542842E-01
  PKER_RDRYG( 40, 31) =  0.442844E-01
  PKER_RDRYG( 40, 32) =  0.359952E-01
  PKER_RDRYG( 40, 33) =  0.291205E-01
  PKER_RDRYG( 40, 34) =  0.234148E-01
  PKER_RDRYG( 40, 35) =  0.186756E-01
  PKER_RDRYG( 40, 36) =  0.147376E-01
  PKER_RDRYG( 40, 37) =  0.114686E-01
  PKER_RDRYG( 40, 38) =  0.876977E-02
  PKER_RDRYG( 40, 39) =  0.657521E-02
  PKER_RDRYG( 40, 40) =  0.484891E-02
END IF
!
END SUBROUTINE READ_XKER_RDRYG
