!MNH_LIC Copyright 1994-2018 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!     ######spl
      MODULE MODI_READ_XKER_RWETH
!     ###########################
!
INTERFACE
      SUBROUTINE READ_XKER_RWETH (KWETLBDAH,KWETLBDAR,KND,                   &
                    PALPHAH,PNUH,PALPHAR,PNUR,PEHR,PBR,PCH,PDH,PCR,PDR,      &
                    PWETLBDAH_MAX,PWETLBDAR_MAX,PWETLBDAH_MIN,PWETLBDAR_MIN, &
                    PFDINFTY,PKER_RWETH                                      )
!
IMPLICIT NONE
INTEGER, INTENT(OUT) :: KND,KWETLBDAH,KWETLBDAR
REAL,    INTENT(OUT) :: PALPHAH
REAL,    INTENT(OUT) :: PNUH
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PEHR
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCH
REAL,    INTENT(OUT) :: PDH
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PWETLBDAH_MAX
REAL,    INTENT(OUT) :: PWETLBDAR_MAX
REAL,    INTENT(OUT) :: PWETLBDAH_MIN
REAL,    INTENT(OUT) :: PWETLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RWETH
!
END SUBROUTINE 
!
END INTERFACE
!
END MODULE MODI_READ_XKER_RWETH
!     ######spl
      SUBROUTINE READ_XKER_RWETH (KWETLBDAH,KWETLBDAR,KND,                   &
                    PALPHAH,PNUH,PALPHAR,PNUR,PEHR,PBR,PCH,PDH,PCR,PDR,      &
                    PWETLBDAH_MAX,PWETLBDAR_MAX,PWETLBDAH_MIN,PWETLBDAR_MIN, &
                    PFDINFTY,PKER_RWETH                                      )
!DEC$ OPTIMIZE:0
!     ########################################################################
!
!!****  * * - initialize the kernels for the rain-hail wet growth process
!!
!!    PURPOSE
!!    -------
!!      The purpose of this routine is to initialize the kernels PKER_RWETH
!!    prepared from a previous run of the routine INI_RAIN_ICE. The reading of
!!    the kernels is optional after checking for the dimensions of the arrays.
!!
!!**  METHOD
!!    ------
!!      
!!
!!    EXTERNAL
!!    --------
!!      None
!!     
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      None
!!
!!    REFERENCE
!!    ---------
!!      Book2 of documentation ( routine READ_XKER_RWETH )
!!
!!    AUTHOR
!!    ------
!!      S. Riette
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    6 Mar 2015
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!*       0.2   Declarations of local variables :
!
!  
IMPLICIT NONE
INTEGER, INTENT(OUT) :: KND,KWETLBDAH,KWETLBDAR
REAL,    INTENT(OUT) :: PALPHAH
REAL,    INTENT(OUT) :: PNUH
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PEHR
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCH
REAL,    INTENT(OUT) :: PDH
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PWETLBDAH_MAX
REAL,    INTENT(OUT) :: PWETLBDAR_MAX
REAL,    INTENT(OUT) :: PWETLBDAH_MIN
REAL,    INTENT(OUT) :: PWETLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RWETH
!
! ###################################################################
! #INSERT HERE THE OUTPUT OF INI_RAIN_ICE IF THE KERNELS ARE UPDATED#
! ###################################################################
!
KND= 50
KWETLBDAH= 40
KWETLBDAR= 40
PALPHAH= 0.100000E+01
PNUH= 0.800000E+01
PALPHAR= 0.100000E+01
PNUR= 0.100000E+01
PEHR= 0.100000E+01
PBR= 0.300000E+01
PCH= 0.207000E+03
PDH= 0.640000E+00
PCR= 0.842000E+03
PDR= 0.800000E+00
PWETLBDAH_MAX= 0.100000E+08
PWETLBDAR_MAX= 0.100000E+08
PWETLBDAH_MIN= 0.100000E+04
PWETLBDAR_MIN= 0.100000E+04
PFDINFTY= 0.200000E+02
!
IF( PRESENT(PKER_RWETH) ) THEN
  PKER_RWETH(  1,  1) =  0.402762E+01
  PKER_RWETH(  1,  2) =  0.360940E+01
  PKER_RWETH(  1,  3) =  0.394235E+01
  PKER_RWETH(  1,  4) =  0.470822E+01
  PKER_RWETH(  1,  5) =  0.561595E+01
  PKER_RWETH(  1,  6) =  0.648059E+01
  PKER_RWETH(  1,  7) =  0.722764E+01
  PKER_RWETH(  1,  8) =  0.784765E+01
  PKER_RWETH(  1,  9) =  0.835593E+01
  PKER_RWETH(  1, 10) =  0.877187E+01
  PKER_RWETH(  1, 11) =  0.911259E+01
  PKER_RWETH(  1, 12) =  0.939210E+01
  PKER_RWETH(  1, 13) =  0.962170E+01
  PKER_RWETH(  1, 14) =  0.981053E+01
  PKER_RWETH(  1, 15) =  0.996598E+01
  PKER_RWETH(  1, 16) =  0.100940E+02
  PKER_RWETH(  1, 17) =  0.101996E+02
  PKER_RWETH(  1, 18) =  0.102867E+02
  PKER_RWETH(  1, 19) =  0.103586E+02
  PKER_RWETH(  1, 20) =  0.104179E+02
  PKER_RWETH(  1, 21) =  0.104669E+02
  PKER_RWETH(  1, 22) =  0.105074E+02
  PKER_RWETH(  1, 23) =  0.105409E+02
  PKER_RWETH(  1, 24) =  0.105685E+02
  PKER_RWETH(  1, 25) =  0.105914E+02
  PKER_RWETH(  1, 26) =  0.106103E+02
  PKER_RWETH(  1, 27) =  0.106259E+02
  PKER_RWETH(  1, 28) =  0.106388E+02
  PKER_RWETH(  1, 29) =  0.106494E+02
  PKER_RWETH(  1, 30) =  0.106583E+02
  PKER_RWETH(  1, 31) =  0.106656E+02
  PKER_RWETH(  1, 32) =  0.106716E+02
  PKER_RWETH(  1, 33) =  0.106766E+02
  PKER_RWETH(  1, 34) =  0.106807E+02
  PKER_RWETH(  1, 35) =  0.106842E+02
  PKER_RWETH(  1, 36) =  0.106870E+02
  PKER_RWETH(  1, 37) =  0.106893E+02
  PKER_RWETH(  1, 38) =  0.106913E+02
  PKER_RWETH(  1, 39) =  0.106929E+02
  PKER_RWETH(  1, 40) =  0.106942E+02
  PKER_RWETH(  2,  1) =  0.438807E+01
  PKER_RWETH(  2,  2) =  0.333752E+01
  PKER_RWETH(  2,  3) =  0.311028E+01
  PKER_RWETH(  2,  4) =  0.348499E+01
  PKER_RWETH(  2,  5) =  0.418314E+01
  PKER_RWETH(  2,  6) =  0.496720E+01
  PKER_RWETH(  2,  7) =  0.569617E+01
  PKER_RWETH(  2,  8) =  0.631912E+01
  PKER_RWETH(  2,  9) =  0.683403E+01
  PKER_RWETH(  2, 10) =  0.725566E+01
  PKER_RWETH(  2, 11) =  0.760059E+01
  PKER_RWETH(  2, 12) =  0.788312E+01
  PKER_RWETH(  2, 13) =  0.811488E+01
  PKER_RWETH(  2, 14) =  0.830526E+01
  PKER_RWETH(  2, 15) =  0.846182E+01
  PKER_RWETH(  2, 16) =  0.859069E+01
  PKER_RWETH(  2, 17) =  0.869686E+01
  PKER_RWETH(  2, 18) =  0.878439E+01
  PKER_RWETH(  2, 19) =  0.885658E+01
  PKER_RWETH(  2, 20) =  0.891616E+01
  PKER_RWETH(  2, 21) =  0.896534E+01
  PKER_RWETH(  2, 22) =  0.900596E+01
  PKER_RWETH(  2, 23) =  0.903951E+01
  PKER_RWETH(  2, 24) =  0.906722E+01
  PKER_RWETH(  2, 25) =  0.909013E+01
  PKER_RWETH(  2, 26) =  0.910906E+01
  PKER_RWETH(  2, 27) =  0.912471E+01
  PKER_RWETH(  2, 28) =  0.913765E+01
  PKER_RWETH(  2, 29) =  0.914834E+01
  PKER_RWETH(  2, 30) =  0.915719E+01
  PKER_RWETH(  2, 31) =  0.916450E+01
  PKER_RWETH(  2, 32) =  0.917055E+01
  PKER_RWETH(  2, 33) =  0.917555E+01
  PKER_RWETH(  2, 34) =  0.917969E+01
  PKER_RWETH(  2, 35) =  0.918311E+01
  PKER_RWETH(  2, 36) =  0.918594E+01
  PKER_RWETH(  2, 37) =  0.918828E+01
  PKER_RWETH(  2, 38) =  0.919022E+01
  PKER_RWETH(  2, 39) =  0.919182E+01
  PKER_RWETH(  2, 40) =  0.919315E+01
  PKER_RWETH(  3,  1) =  0.511774E+01
  PKER_RWETH(  3,  2) =  0.355317E+01
  PKER_RWETH(  3,  3) =  0.278395E+01
  PKER_RWETH(  3,  4) =  0.269701E+01
  PKER_RWETH(  3,  5) =  0.308711E+01
  PKER_RWETH(  3,  6) =  0.371510E+01
  PKER_RWETH(  3,  7) =  0.438830E+01
  PKER_RWETH(  3,  8) =  0.500120E+01
  PKER_RWETH(  3,  9) =  0.552011E+01
  PKER_RWETH(  3, 10) =  0.594762E+01
  PKER_RWETH(  3, 11) =  0.629736E+01
  PKER_RWETH(  3, 12) =  0.658342E+01
  PKER_RWETH(  3, 13) =  0.681772E+01
  PKER_RWETH(  3, 14) =  0.700990E+01
  PKER_RWETH(  3, 15) =  0.716776E+01
  PKER_RWETH(  3, 16) =  0.729757E+01
  PKER_RWETH(  3, 17) =  0.740442E+01
  PKER_RWETH(  3, 18) =  0.749244E+01
  PKER_RWETH(  3, 19) =  0.756500E+01
  PKER_RWETH(  3, 20) =  0.762484E+01
  PKER_RWETH(  3, 21) =  0.767423E+01
  PKER_RWETH(  3, 22) =  0.771499E+01
  PKER_RWETH(  3, 23) =  0.774866E+01
  PKER_RWETH(  3, 24) =  0.777646E+01
  PKER_RWETH(  3, 25) =  0.779943E+01
  PKER_RWETH(  3, 26) =  0.781841E+01
  PKER_RWETH(  3, 27) =  0.783410E+01
  PKER_RWETH(  3, 28) =  0.784707E+01
  PKER_RWETH(  3, 29) =  0.785779E+01
  PKER_RWETH(  3, 30) =  0.786665E+01
  PKER_RWETH(  3, 31) =  0.787398E+01
  PKER_RWETH(  3, 32) =  0.788004E+01
  PKER_RWETH(  3, 33) =  0.788505E+01
  PKER_RWETH(  3, 34) =  0.788919E+01
  PKER_RWETH(  3, 35) =  0.789262E+01
  PKER_RWETH(  3, 36) =  0.789545E+01
  PKER_RWETH(  3, 37) =  0.789780E+01
  PKER_RWETH(  3, 38) =  0.789974E+01
  PKER_RWETH(  3, 39) =  0.790134E+01
  PKER_RWETH(  3, 40) =  0.790267E+01
  PKER_RWETH(  4,  1) =  0.603974E+01
  PKER_RWETH(  4,  2) =  0.410879E+01
  PKER_RWETH(  4,  3) =  0.288715E+01
  PKER_RWETH(  4,  4) =  0.233851E+01
  PKER_RWETH(  4,  5) =  0.235142E+01
  PKER_RWETH(  4,  6) =  0.273888E+01
  PKER_RWETH(  4,  7) =  0.329704E+01
  PKER_RWETH(  4,  8) =  0.387228E+01
  PKER_RWETH(  4,  9) =  0.438639E+01
  PKER_RWETH(  4, 10) =  0.481827E+01
  PKER_RWETH(  4, 11) =  0.517314E+01
  PKER_RWETH(  4, 12) =  0.546325E+01
  PKER_RWETH(  4, 13) =  0.570050E+01
  PKER_RWETH(  4, 14) =  0.589481E+01
  PKER_RWETH(  4, 15) =  0.605418E+01
  PKER_RWETH(  4, 16) =  0.618508E+01
  PKER_RWETH(  4, 17) =  0.629272E+01
  PKER_RWETH(  4, 18) =  0.638131E+01
  PKER_RWETH(  4, 19) =  0.645429E+01
  PKER_RWETH(  4, 20) =  0.651445E+01
  PKER_RWETH(  4, 21) =  0.656406E+01
  PKER_RWETH(  4, 22) =  0.660500E+01
  PKER_RWETH(  4, 23) =  0.663879E+01
  PKER_RWETH(  4, 24) =  0.666669E+01
  PKER_RWETH(  4, 25) =  0.668973E+01
  PKER_RWETH(  4, 26) =  0.670877E+01
  PKER_RWETH(  4, 27) =  0.672450E+01
  PKER_RWETH(  4, 28) =  0.673750E+01
  PKER_RWETH(  4, 29) =  0.674825E+01
  PKER_RWETH(  4, 30) =  0.675713E+01
  PKER_RWETH(  4, 31) =  0.676447E+01
  PKER_RWETH(  4, 32) =  0.677054E+01
  PKER_RWETH(  4, 33) =  0.677556E+01
  PKER_RWETH(  4, 34) =  0.677972E+01
  PKER_RWETH(  4, 35) =  0.678315E+01
  PKER_RWETH(  4, 36) =  0.678599E+01
  PKER_RWETH(  4, 37) =  0.678834E+01
  PKER_RWETH(  4, 38) =  0.679028E+01
  PKER_RWETH(  4, 39) =  0.679189E+01
  PKER_RWETH(  4, 40) =  0.679321E+01
  PKER_RWETH(  5,  1) =  0.701523E+01
  PKER_RWETH(  5,  2) =  0.485290E+01
  PKER_RWETH(  5,  3) =  0.330114E+01
  PKER_RWETH(  5,  4) =  0.235568E+01
  PKER_RWETH(  5,  5) =  0.197832E+01
  PKER_RWETH(  5,  6) =  0.205971E+01
  PKER_RWETH(  5,  7) =  0.243216E+01
  PKER_RWETH(  5,  8) =  0.292372E+01
  PKER_RWETH(  5,  9) =  0.341291E+01
  PKER_RWETH(  5, 10) =  0.384329E+01
  PKER_RWETH(  5, 11) =  0.420248E+01
  PKER_RWETH(  5, 12) =  0.449701E+01
  PKER_RWETH(  5, 13) =  0.473767E+01
  PKER_RWETH(  5, 14) =  0.493445E+01
  PKER_RWETH(  5, 15) =  0.509560E+01
  PKER_RWETH(  5, 16) =  0.522777E+01
  PKER_RWETH(  5, 17) =  0.533633E+01
  PKER_RWETH(  5, 18) =  0.542559E+01
  PKER_RWETH(  5, 19) =  0.549905E+01
  PKER_RWETH(  5, 20) =  0.555956E+01
  PKER_RWETH(  5, 21) =  0.560943E+01
  PKER_RWETH(  5, 22) =  0.565056E+01
  PKER_RWETH(  5, 23) =  0.568450E+01
  PKER_RWETH(  5, 24) =  0.571251E+01
  PKER_RWETH(  5, 25) =  0.573564E+01
  PKER_RWETH(  5, 26) =  0.575474E+01
  PKER_RWETH(  5, 27) =  0.577052E+01
  PKER_RWETH(  5, 28) =  0.578355E+01
  PKER_RWETH(  5, 29) =  0.579433E+01
  PKER_RWETH(  5, 30) =  0.580323E+01
  PKER_RWETH(  5, 31) =  0.581059E+01
  PKER_RWETH(  5, 32) =  0.581668E+01
  PKER_RWETH(  5, 33) =  0.582171E+01
  PKER_RWETH(  5, 34) =  0.582587E+01
  PKER_RWETH(  5, 35) =  0.582931E+01
  PKER_RWETH(  5, 36) =  0.583215E+01
  PKER_RWETH(  5, 37) =  0.583450E+01
  PKER_RWETH(  5, 38) =  0.583645E+01
  PKER_RWETH(  5, 39) =  0.583806E+01
  PKER_RWETH(  5, 40) =  0.583939E+01
  PKER_RWETH(  6,  1) =  0.795455E+01
  PKER_RWETH(  6,  2) =  0.566068E+01
  PKER_RWETH(  6,  3) =  0.389662E+01
  PKER_RWETH(  6,  4) =  0.265525E+01
  PKER_RWETH(  6,  5) =  0.193212E+01
  PKER_RWETH(  6,  6) =  0.168546E+01
  PKER_RWETH(  6,  7) =  0.181153E+01
  PKER_RWETH(  6,  8) =  0.216086E+01
  PKER_RWETH(  6,  9) =  0.259008E+01
  PKER_RWETH(  6, 10) =  0.300451E+01
  PKER_RWETH(  6, 11) =  0.336420E+01
  PKER_RWETH(  6, 12) =  0.366278E+01
  PKER_RWETH(  6, 13) =  0.390721E+01
  PKER_RWETH(  6, 14) =  0.410685E+01
  PKER_RWETH(  6, 15) =  0.427007E+01
  PKER_RWETH(  6, 16) =  0.440373E+01
  PKER_RWETH(  6, 17) =  0.451336E+01
  PKER_RWETH(  6, 18) =  0.460339E+01
  PKER_RWETH(  6, 19) =  0.467741E+01
  PKER_RWETH(  6, 20) =  0.473833E+01
  PKER_RWETH(  6, 21) =  0.478850E+01
  PKER_RWETH(  6, 22) =  0.482985E+01
  PKER_RWETH(  6, 23) =  0.486395E+01
  PKER_RWETH(  6, 24) =  0.489209E+01
  PKER_RWETH(  6, 25) =  0.491531E+01
  PKER_RWETH(  6, 26) =  0.493448E+01
  PKER_RWETH(  6, 27) =  0.495031E+01
  PKER_RWETH(  6, 28) =  0.496339E+01
  PKER_RWETH(  6, 29) =  0.497420E+01
  PKER_RWETH(  6, 30) =  0.498312E+01
  PKER_RWETH(  6, 31) =  0.499050E+01
  PKER_RWETH(  6, 32) =  0.499660E+01
  PKER_RWETH(  6, 33) =  0.500165E+01
  PKER_RWETH(  6, 34) =  0.500581E+01
  PKER_RWETH(  6, 35) =  0.500926E+01
  PKER_RWETH(  6, 36) =  0.501211E+01
  PKER_RWETH(  6, 37) =  0.501447E+01
  PKER_RWETH(  6, 38) =  0.501641E+01
  PKER_RWETH(  6, 39) =  0.501803E+01
  PKER_RWETH(  6, 40) =  0.501936E+01
  PKER_RWETH(  7,  1) =  0.881081E+01
  PKER_RWETH(  7,  2) =  0.644923E+01
  PKER_RWETH(  7,  3) =  0.456302E+01
  PKER_RWETH(  7,  4) =  0.312729E+01
  PKER_RWETH(  7,  5) =  0.213937E+01
  PKER_RWETH(  7,  6) =  0.159348E+01
  PKER_RWETH(  7,  7) =  0.144580E+01
  PKER_RWETH(  7,  8) =  0.159857E+01
  PKER_RWETH(  7,  9) =  0.191990E+01
  PKER_RWETH(  7, 10) =  0.229195E+01
  PKER_RWETH(  7, 11) =  0.264196E+01
  PKER_RWETH(  7, 12) =  0.294215E+01
  PKER_RWETH(  7, 13) =  0.319025E+01
  PKER_RWETH(  7, 14) =  0.339309E+01
  PKER_RWETH(  7, 15) =  0.355870E+01
  PKER_RWETH(  7, 16) =  0.369410E+01
  PKER_RWETH(  7, 17) =  0.380497E+01
  PKER_RWETH(  7, 18) =  0.389590E+01
  PKER_RWETH(  7, 19) =  0.397057E+01
  PKER_RWETH(  7, 20) =  0.403196E+01
  PKER_RWETH(  7, 21) =  0.408248E+01
  PKER_RWETH(  7, 22) =  0.412408E+01
  PKER_RWETH(  7, 23) =  0.415837E+01
  PKER_RWETH(  7, 24) =  0.418665E+01
  PKER_RWETH(  7, 25) =  0.420997E+01
  PKER_RWETH(  7, 26) =  0.422922E+01
  PKER_RWETH(  7, 27) =  0.424512E+01
  PKER_RWETH(  7, 28) =  0.425824E+01
  PKER_RWETH(  7, 29) =  0.426908E+01
  PKER_RWETH(  7, 30) =  0.427804E+01
  PKER_RWETH(  7, 31) =  0.428544E+01
  PKER_RWETH(  7, 32) =  0.429155E+01
  PKER_RWETH(  7, 33) =  0.429661E+01
  PKER_RWETH(  7, 34) =  0.430079E+01
  PKER_RWETH(  7, 35) =  0.430424E+01
  PKER_RWETH(  7, 36) =  0.430710E+01
  PKER_RWETH(  7, 37) =  0.430946E+01
  PKER_RWETH(  7, 38) =  0.431141E+01
  PKER_RWETH(  7, 39) =  0.431302E+01
  PKER_RWETH(  7, 40) =  0.431436E+01
  PKER_RWETH(  8,  1) =  0.956627E+01
  PKER_RWETH(  8,  2) =  0.717320E+01
  PKER_RWETH(  8,  3) =  0.522361E+01
  PKER_RWETH(  8,  4) =  0.367446E+01
  PKER_RWETH(  8,  5) =  0.250914E+01
  PKER_RWETH(  8,  6) =  0.172781E+01
  PKER_RWETH(  8,  7) =  0.132243E+01
  PKER_RWETH(  8,  8) =  0.124848E+01
  PKER_RWETH(  8,  9) =  0.141419E+01
  PKER_RWETH(  8, 10) =  0.170540E+01
  PKER_RWETH(  8, 11) =  0.202584E+01
  PKER_RWETH(  8, 12) =  0.232058E+01
  PKER_RWETH(  8, 13) =  0.257083E+01
  PKER_RWETH(  8, 14) =  0.277692E+01
  PKER_RWETH(  8, 15) =  0.294524E+01
  PKER_RWETH(  8, 16) =  0.308264E+01
  PKER_RWETH(  8, 17) =  0.319496E+01
  PKER_RWETH(  8, 18) =  0.328694E+01
  PKER_RWETH(  8, 19) =  0.336236E+01
  PKER_RWETH(  8, 20) =  0.342430E+01
  PKER_RWETH(  8, 21) =  0.347521E+01
  PKER_RWETH(  8, 22) =  0.351711E+01
  PKER_RWETH(  8, 23) =  0.355161E+01
  PKER_RWETH(  8, 24) =  0.358005E+01
  PKER_RWETH(  8, 25) =  0.360349E+01
  PKER_RWETH(  8, 26) =  0.362283E+01
  PKER_RWETH(  8, 27) =  0.363879E+01
  PKER_RWETH(  8, 28) =  0.365197E+01
  PKER_RWETH(  8, 29) =  0.366285E+01
  PKER_RWETH(  8, 30) =  0.367183E+01
  PKER_RWETH(  8, 31) =  0.367926E+01
  PKER_RWETH(  8, 32) =  0.368539E+01
  PKER_RWETH(  8, 33) =  0.369046E+01
  PKER_RWETH(  8, 34) =  0.369465E+01
  PKER_RWETH(  8, 35) =  0.369811E+01
  PKER_RWETH(  8, 36) =  0.370097E+01
  PKER_RWETH(  8, 37) =  0.370334E+01
  PKER_RWETH(  8, 38) =  0.370530E+01
  PKER_RWETH(  8, 39) =  0.370691E+01
  PKER_RWETH(  8, 40) =  0.370825E+01
  PKER_RWETH(  9,  1) =  0.102200E+02
  PKER_RWETH(  9,  2) =  0.781427E+01
  PKER_RWETH(  9,  3) =  0.583508E+01
  PKER_RWETH(  9,  4) =  0.422651E+01
  PKER_RWETH(  9,  5) =  0.295601E+01
  PKER_RWETH(  9,  6) =  0.201318E+01
  PKER_RWETH(  9,  7) =  0.139951E+01
  PKER_RWETH(  9,  8) =  0.110495E+01
  PKER_RWETH(  9,  9) =  0.108447E+01
  PKER_RWETH(  9, 10) =  0.125349E+01
  PKER_RWETH(  9, 11) =  0.151396E+01
  PKER_RWETH(  9, 12) =  0.178854E+01
  PKER_RWETH(  9, 13) =  0.203611E+01
  PKER_RWETH(  9, 14) =  0.224455E+01
  PKER_RWETH(  9, 15) =  0.241570E+01
  PKER_RWETH(  9, 16) =  0.255537E+01
  PKER_RWETH(  9, 17) =  0.266938E+01
  PKER_RWETH(  9, 18) =  0.276256E+01
  PKER_RWETH(  9, 19) =  0.283887E+01
  PKER_RWETH(  9, 20) =  0.290144E+01
  PKER_RWETH(  9, 21) =  0.295281E+01
  PKER_RWETH(  9, 22) =  0.299504E+01
  PKER_RWETH(  9, 23) =  0.302979E+01
  PKER_RWETH(  9, 24) =  0.305841E+01
  PKER_RWETH(  9, 25) =  0.308199E+01
  PKER_RWETH(  9, 26) =  0.310143E+01
  PKER_RWETH(  9, 27) =  0.311747E+01
  PKER_RWETH(  9, 28) =  0.313070E+01
  PKER_RWETH(  9, 29) =  0.314162E+01
  PKER_RWETH(  9, 30) =  0.315064E+01
  PKER_RWETH(  9, 31) =  0.315809E+01
  PKER_RWETH(  9, 32) =  0.316424E+01
  PKER_RWETH(  9, 33) =  0.316933E+01
  PKER_RWETH(  9, 34) =  0.317353E+01
  PKER_RWETH(  9, 35) =  0.317700E+01
  PKER_RWETH(  9, 36) =  0.317987E+01
  PKER_RWETH(  9, 37) =  0.318224E+01
  PKER_RWETH(  9, 38) =  0.318420E+01
  PKER_RWETH(  9, 39) =  0.318582E+01
  PKER_RWETH(  9, 40) =  0.318716E+01
  PKER_RWETH( 10,  1) =  0.107794E+02
  PKER_RWETH( 10,  2) =  0.837003E+01
  PKER_RWETH( 10,  3) =  0.637887E+01
  PKER_RWETH( 10,  4) =  0.474241E+01
  PKER_RWETH( 10,  5) =  0.341615E+01
  PKER_RWETH( 10,  6) =  0.237589E+01
  PKER_RWETH( 10,  7) =  0.161585E+01
  PKER_RWETH( 10,  8) =  0.113766E+01
  PKER_RWETH( 10,  9) =  0.929743E+00
  PKER_RWETH( 10, 10) =  0.946883E+00
  PKER_RWETH( 10, 11) =  0.111245E+01
  PKER_RWETH( 10, 12) =  0.134310E+01
  PKER_RWETH( 10, 13) =  0.157719E+01
  PKER_RWETH( 10, 14) =  0.178469E+01
  PKER_RWETH( 10, 15) =  0.195816E+01
  PKER_RWETH( 10, 16) =  0.210028E+01
  PKER_RWETH( 10, 17) =  0.221619E+01
  PKER_RWETH( 10, 18) =  0.231078E+01
  PKER_RWETH( 10, 19) =  0.238810E+01
  PKER_RWETH( 10, 20) =  0.245141E+01
  PKER_RWETH( 10, 21) =  0.250332E+01
  PKER_RWETH( 10, 22) =  0.254594E+01
  PKER_RWETH( 10, 23) =  0.258097E+01
  PKER_RWETH( 10, 24) =  0.260979E+01
  PKER_RWETH( 10, 25) =  0.263353E+01
  PKER_RWETH( 10, 26) =  0.265308E+01
  PKER_RWETH( 10, 27) =  0.266921E+01
  PKER_RWETH( 10, 28) =  0.268250E+01
  PKER_RWETH( 10, 29) =  0.269348E+01
  PKER_RWETH( 10, 30) =  0.270253E+01
  PKER_RWETH( 10, 31) =  0.271001E+01
  PKER_RWETH( 10, 32) =  0.271618E+01
  PKER_RWETH( 10, 33) =  0.272129E+01
  PKER_RWETH( 10, 34) =  0.272550E+01
  PKER_RWETH( 10, 35) =  0.272898E+01
  PKER_RWETH( 10, 36) =  0.273186E+01
  PKER_RWETH( 10, 37) =  0.273424E+01
  PKER_RWETH( 10, 38) =  0.273620E+01
  PKER_RWETH( 10, 39) =  0.273783E+01
  PKER_RWETH( 10, 40) =  0.273917E+01
  PKER_RWETH( 11,  1) =  0.112547E+02
  PKER_RWETH( 11,  2) =  0.884593E+01
  PKER_RWETH( 11,  3) =  0.685131E+01
  PKER_RWETH( 11,  4) =  0.520348E+01
  PKER_RWETH( 11,  5) =  0.385081E+01
  PKER_RWETH( 11,  6) =  0.275817E+01
  PKER_RWETH( 11,  7) =  0.190805E+01
  PKER_RWETH( 11,  8) =  0.129789E+01
  PKER_RWETH( 11,  9) =  0.929130E+00
  PKER_RWETH( 11, 10) =  0.787911E+00
  PKER_RWETH( 11, 11) =  0.830555E+00
  PKER_RWETH( 11, 12) =  0.988070E+00
  PKER_RWETH( 11, 13) =  0.119042E+01
  PKER_RWETH( 11, 14) =  0.138918E+01
  PKER_RWETH( 11, 15) =  0.156279E+01
  PKER_RWETH( 11, 16) =  0.170708E+01
  PKER_RWETH( 11, 17) =  0.182507E+01
  PKER_RWETH( 11, 18) =  0.192127E+01
  PKER_RWETH( 11, 19) =  0.199976E+01
  PKER_RWETH( 11, 20) =  0.206392E+01
  PKER_RWETH( 11, 21) =  0.211645E+01
  PKER_RWETH( 11, 22) =  0.215952E+01
  PKER_RWETH( 11, 23) =  0.219488E+01
  PKER_RWETH( 11, 24) =  0.222394E+01
  PKER_RWETH( 11, 25) =  0.224785E+01
  PKER_RWETH( 11, 26) =  0.226753E+01
  PKER_RWETH( 11, 27) =  0.228375E+01
  PKER_RWETH( 11, 28) =  0.229712E+01
  PKER_RWETH( 11, 29) =  0.230815E+01
  PKER_RWETH( 11, 30) =  0.231725E+01
  PKER_RWETH( 11, 31) =  0.232476E+01
  PKER_RWETH( 11, 32) =  0.233096E+01
  PKER_RWETH( 11, 33) =  0.233608E+01
  PKER_RWETH( 11, 34) =  0.234031E+01
  PKER_RWETH( 11, 35) =  0.234380E+01
  PKER_RWETH( 11, 36) =  0.234669E+01
  PKER_RWETH( 11, 37) =  0.234907E+01
  PKER_RWETH( 11, 38) =  0.235104E+01
  PKER_RWETH( 11, 39) =  0.235267E+01
  PKER_RWETH( 11, 40) =  0.235402E+01
  PKER_RWETH( 12,  1) =  0.116571E+02
  PKER_RWETH( 12,  2) =  0.925058E+01
  PKER_RWETH( 12,  3) =  0.725629E+01
  PKER_RWETH( 12,  4) =  0.560505E+01
  PKER_RWETH( 12,  5) =  0.424152E+01
  PKER_RWETH( 12,  6) =  0.312383E+01
  PKER_RWETH( 12,  7) =  0.222456E+01
  PKER_RWETH( 12,  8) =  0.153134E+01
  PKER_RWETH( 12,  9) =  0.104379E+01
  PKER_RWETH( 12, 10) =  0.762641E+00
  PKER_RWETH( 12, 11) =  0.672444E+00
  PKER_RWETH( 12, 12) =  0.731332E+00
  PKER_RWETH( 12, 13) =  0.877846E+00
  PKER_RWETH( 12, 14) =  0.105398E+01
  PKER_RWETH( 12, 15) =  0.122217E+01
  PKER_RWETH( 12, 16) =  0.136721E+01
  PKER_RWETH( 12, 17) =  0.148718E+01
  PKER_RWETH( 12, 18) =  0.158513E+01
  PKER_RWETH( 12, 19) =  0.166497E+01
  PKER_RWETH( 12, 20) =  0.173011E+01
  PKER_RWETH( 12, 21) =  0.178335E+01
  PKER_RWETH( 12, 22) =  0.182694E+01
  PKER_RWETH( 12, 23) =  0.186268E+01
  PKER_RWETH( 12, 24) =  0.189201E+01
  PKER_RWETH( 12, 25) =  0.191613E+01
  PKER_RWETH( 12, 26) =  0.193596E+01
  PKER_RWETH( 12, 27) =  0.195229E+01
  PKER_RWETH( 12, 28) =  0.196574E+01
  PKER_RWETH( 12, 29) =  0.197683E+01
  PKER_RWETH( 12, 30) =  0.198598E+01
  PKER_RWETH( 12, 31) =  0.199352E+01
  PKER_RWETH( 12, 32) =  0.199975E+01
  PKER_RWETH( 12, 33) =  0.200489E+01
  PKER_RWETH( 12, 34) =  0.200914E+01
  PKER_RWETH( 12, 35) =  0.201264E+01
  PKER_RWETH( 12, 36) =  0.201554E+01
  PKER_RWETH( 12, 37) =  0.201793E+01
  PKER_RWETH( 12, 38) =  0.201991E+01
  PKER_RWETH( 12, 39) =  0.202154E+01
  PKER_RWETH( 12, 40) =  0.202289E+01
  PKER_RWETH( 13,  1) =  0.119970E+02
  PKER_RWETH( 13,  2) =  0.959324E+01
  PKER_RWETH( 13,  3) =  0.760081E+01
  PKER_RWETH( 13,  4) =  0.594970E+01
  PKER_RWETH( 13,  5) =  0.458280E+01
  PKER_RWETH( 13,  6) =  0.345469E+01
  PKER_RWETH( 13,  7) =  0.253159E+01
  PKER_RWETH( 13,  8) =  0.179227E+01
  PKER_RWETH( 13,  9) =  0.122838E+01
  PKER_RWETH( 13, 10) =  0.841004E+00
  PKER_RWETH( 13, 11) =  0.629650E+00
  PKER_RWETH( 13, 12) =  0.577924E+00
  PKER_RWETH( 13, 13) =  0.645898E+00
  PKER_RWETH( 13, 14) =  0.779895E+00
  PKER_RWETH( 13, 15) =  0.932147E+00
  PKER_RWETH( 13, 16) =  0.107403E+01
  PKER_RWETH( 13, 17) =  0.119506E+01
  PKER_RWETH( 13, 18) =  0.129476E+01
  PKER_RWETH( 13, 19) =  0.137609E+01
  PKER_RWETH( 13, 20) =  0.144235E+01
  PKER_RWETH( 13, 21) =  0.149642E+01
  PKER_RWETH( 13, 22) =  0.154060E+01
  PKER_RWETH( 13, 23) =  0.157677E+01
  PKER_RWETH( 13, 24) =  0.160643E+01
  PKER_RWETH( 13, 25) =  0.163077E+01
  PKER_RWETH( 13, 26) =  0.165078E+01
  PKER_RWETH( 13, 27) =  0.166723E+01
  PKER_RWETH( 13, 28) =  0.168078E+01
  PKER_RWETH( 13, 29) =  0.169194E+01
  PKER_RWETH( 13, 30) =  0.170114E+01
  PKER_RWETH( 13, 31) =  0.170872E+01
  PKER_RWETH( 13, 32) =  0.171498E+01
  PKER_RWETH( 13, 33) =  0.172014E+01
  PKER_RWETH( 13, 34) =  0.172441E+01
  PKER_RWETH( 13, 35) =  0.172792E+01
  PKER_RWETH( 13, 36) =  0.173083E+01
  PKER_RWETH( 13, 37) =  0.173323E+01
  PKER_RWETH( 13, 38) =  0.173522E+01
  PKER_RWETH( 13, 39) =  0.173685E+01
  PKER_RWETH( 13, 40) =  0.173821E+01
  PKER_RWETH( 14,  1) =  0.122839E+02
  PKER_RWETH( 14,  2) =  0.988280E+01
  PKER_RWETH( 14,  3) =  0.789268E+01
  PKER_RWETH( 14,  4) =  0.624309E+01
  PKER_RWETH( 14,  5) =  0.487613E+01
  PKER_RWETH( 14,  6) =  0.374467E+01
  PKER_RWETH( 14,  7) =  0.281151E+01
  PKER_RWETH( 14,  8) =  0.204951E+01
  PKER_RWETH( 14,  9) =  0.144246E+01
  PKER_RWETH( 14, 10) =  0.985100E+00
  PKER_RWETH( 14, 11) =  0.679232E+00
  PKER_RWETH( 14, 12) =  0.523227E+00
  PKER_RWETH( 14, 13) =  0.499857E+00
  PKER_RWETH( 14, 14) =  0.571812E+00
  PKER_RWETH( 14, 15) =  0.692570E+00
  PKER_RWETH( 14, 16) =  0.823458E+00
  PKER_RWETH( 14, 17) =  0.942830E+00
  PKER_RWETH( 14, 18) =  0.104371E+01
  PKER_RWETH( 14, 19) =  0.112656E+01
  PKER_RWETH( 14, 20) =  0.119407E+01
  PKER_RWETH( 14, 21) =  0.124908E+01
  PKER_RWETH( 14, 22) =  0.129395E+01
  PKER_RWETH( 14, 23) =  0.133063E+01
  PKER_RWETH( 14, 24) =  0.136065E+01
  PKER_RWETH( 14, 25) =  0.138526E+01
  PKER_RWETH( 14, 26) =  0.140546E+01
  PKER_RWETH( 14, 27) =  0.142206E+01
  PKER_RWETH( 14, 28) =  0.143571E+01
  PKER_RWETH( 14, 29) =  0.144695E+01
  PKER_RWETH( 14, 30) =  0.145621E+01
  PKER_RWETH( 14, 31) =  0.146384E+01
  PKER_RWETH( 14, 32) =  0.147013E+01
  PKER_RWETH( 14, 33) =  0.147532E+01
  PKER_RWETH( 14, 34) =  0.147960E+01
  PKER_RWETH( 14, 35) =  0.148314E+01
  PKER_RWETH( 14, 36) =  0.148605E+01
  PKER_RWETH( 14, 37) =  0.148846E+01
  PKER_RWETH( 14, 38) =  0.149045E+01
  PKER_RWETH( 14, 39) =  0.149210E+01
  PKER_RWETH( 14, 40) =  0.149346E+01
  PKER_RWETH( 15,  1) =  0.125259E+02
  PKER_RWETH( 15,  2) =  0.101272E+02
  PKER_RWETH( 15,  3) =  0.813939E+01
  PKER_RWETH( 15,  4) =  0.649175E+01
  PKER_RWETH( 15,  5) =  0.512603E+01
  PKER_RWETH( 15,  6) =  0.399434E+01
  PKER_RWETH( 15,  7) =  0.305783E+01
  PKER_RWETH( 15,  8) =  0.228610E+01
  PKER_RWETH( 15,  9) =  0.165747E+01
  PKER_RWETH( 15, 10) =  0.115978E+01
  PKER_RWETH( 15, 11) =  0.790048E+00
  PKER_RWETH( 15, 12) =  0.550236E+00
  PKER_RWETH( 15, 13) =  0.437781E+00
  PKER_RWETH( 15, 14) =  0.434801E+00
  PKER_RWETH( 15, 15) =  0.507067E+00
  PKER_RWETH( 15, 16) =  0.614692E+00
  PKER_RWETH( 15, 17) =  0.726597E+00
  PKER_RWETH( 15, 18) =  0.826793E+00
  PKER_RWETH( 15, 19) =  0.910816E+00
  PKER_RWETH( 15, 20) =  0.979641E+00
  PKER_RWETH( 15, 21) =  0.103570E+01
  PKER_RWETH( 15, 22) =  0.108136E+01
  PKER_RWETH( 15, 23) =  0.111861E+01
  PKER_RWETH( 15, 24) =  0.114905E+01
  PKER_RWETH( 15, 25) =  0.117397E+01
  PKER_RWETH( 15, 26) =  0.119439E+01
  PKER_RWETH( 15, 27) =  0.121116E+01
  PKER_RWETH( 15, 28) =  0.122493E+01
  PKER_RWETH( 15, 29) =  0.123626E+01
  PKER_RWETH( 15, 30) =  0.124559E+01
  PKER_RWETH( 15, 31) =  0.125327E+01
  PKER_RWETH( 15, 32) =  0.125960E+01
  PKER_RWETH( 15, 33) =  0.126482E+01
  PKER_RWETH( 15, 34) =  0.126912E+01
  PKER_RWETH( 15, 35) =  0.127267E+01
  PKER_RWETH( 15, 36) =  0.127560E+01
  PKER_RWETH( 15, 37) =  0.127802E+01
  PKER_RWETH( 15, 38) =  0.128002E+01
  PKER_RWETH( 15, 39) =  0.128167E+01
  PKER_RWETH( 15, 40) =  0.128303E+01
  PKER_RWETH( 16,  1) =  0.127300E+02
  PKER_RWETH( 16,  2) =  0.103335E+02
  PKER_RWETH( 16,  3) =  0.834773E+01
  PKER_RWETH( 16,  4) =  0.670202E+01
  PKER_RWETH( 16,  5) =  0.533793E+01
  PKER_RWETH( 16,  6) =  0.420722E+01
  PKER_RWETH( 16,  7) =  0.327032E+01
  PKER_RWETH( 16,  8) =  0.249524E+01
  PKER_RWETH( 16,  9) =  0.185719E+01
  PKER_RWETH( 16, 10) =  0.133896E+01
  PKER_RWETH( 16, 11) =  0.931613E+00
  PKER_RWETH( 16, 12) =  0.633849E+00
  PKER_RWETH( 16, 13) =  0.447566E+00
  PKER_RWETH( 16, 14) =  0.368904E+00
  PKER_RWETH( 16, 15) =  0.380168E+00
  PKER_RWETH( 16, 16) =  0.450172E+00
  PKER_RWETH( 16, 17) =  0.545119E+00
  PKER_RWETH( 16, 18) =  0.640376E+00
  PKER_RWETH( 16, 19) =  0.724315E+00
  PKER_RWETH( 16, 20) =  0.794253E+00
  PKER_RWETH( 16, 21) =  0.851423E+00
  PKER_RWETH( 16, 22) =  0.897965E+00
  PKER_RWETH( 16, 23) =  0.935873E+00
  PKER_RWETH( 16, 24) =  0.966798E+00
  PKER_RWETH( 16, 25) =  0.992069E+00
  PKER_RWETH( 16, 26) =  0.101275E+01
  PKER_RWETH( 16, 27) =  0.102971E+01
  PKER_RWETH( 16, 28) =  0.104362E+01
  PKER_RWETH( 16, 29) =  0.105506E+01
  PKER_RWETH( 16, 30) =  0.106446E+01
  PKER_RWETH( 16, 31) =  0.107219E+01
  PKER_RWETH( 16, 32) =  0.107857E+01
  PKER_RWETH( 16, 33) =  0.108382E+01
  PKER_RWETH( 16, 34) =  0.108815E+01
  PKER_RWETH( 16, 35) =  0.109172E+01
  PKER_RWETH( 16, 36) =  0.109466E+01
  PKER_RWETH( 16, 37) =  0.109709E+01
  PKER_RWETH( 16, 38) =  0.109910E+01
  PKER_RWETH( 16, 39) =  0.110076E+01
  PKER_RWETH( 16, 40) =  0.110213E+01
  PKER_RWETH( 17,  1) =  0.129024E+02
  PKER_RWETH( 17,  2) =  0.105076E+02
  PKER_RWETH( 17,  3) =  0.852362E+01
  PKER_RWETH( 17,  4) =  0.687964E+01
  PKER_RWETH( 17,  5) =  0.551717E+01
  PKER_RWETH( 17,  6) =  0.438782E+01
  PKER_RWETH( 17,  7) =  0.345170E+01
  PKER_RWETH( 17,  8) =  0.267609E+01
  PKER_RWETH( 17,  9) =  0.203468E+01
  PKER_RWETH( 17, 10) =  0.150732E+01
  PKER_RWETH( 17, 11) =  0.108047E+01
  PKER_RWETH( 17, 12) =  0.747735E+00
  PKER_RWETH( 17, 13) =  0.508950E+00
  PKER_RWETH( 17, 14) =  0.365691E+00
  PKER_RWETH( 17, 15) =  0.313111E+00
  PKER_RWETH( 17, 16) =  0.333878E+00
  PKER_RWETH( 17, 17) =  0.399897E+00
  PKER_RWETH( 17, 18) =  0.482939E+00
  PKER_RWETH( 17, 19) =  0.563733E+00
  PKER_RWETH( 17, 20) =  0.633938E+00
  PKER_RWETH( 17, 21) =  0.692122E+00
  PKER_RWETH( 17, 22) =  0.739609E+00
  PKER_RWETH( 17, 23) =  0.778254E+00
  PKER_RWETH( 17, 24) =  0.809729E+00
  PKER_RWETH( 17, 25) =  0.835404E+00
  PKER_RWETH( 17, 26) =  0.856386E+00
  PKER_RWETH( 17, 27) =  0.873558E+00
  PKER_RWETH( 17, 28) =  0.887632E+00
  PKER_RWETH( 17, 29) =  0.899182E+00
  PKER_RWETH( 17, 30) =  0.908671E+00
  PKER_RWETH( 17, 31) =  0.916474E+00
  PKER_RWETH( 17, 32) =  0.922895E+00
  PKER_RWETH( 17, 33) =  0.928182E+00
  PKER_RWETH( 17, 34) =  0.932539E+00
  PKER_RWETH( 17, 35) =  0.936130E+00
  PKER_RWETH( 17, 36) =  0.939092E+00
  PKER_RWETH( 17, 37) =  0.941535E+00
  PKER_RWETH( 17, 38) =  0.943552E+00
  PKER_RWETH( 17, 39) =  0.945216E+00
  PKER_RWETH( 17, 40) =  0.946590E+00
  PKER_RWETH( 18,  1) =  0.130481E+02
  PKER_RWETH( 18,  2) =  0.106547E+02
  PKER_RWETH( 18,  3) =  0.867216E+01
  PKER_RWETH( 18,  4) =  0.702966E+01
  PKER_RWETH( 18,  5) =  0.566864E+01
  PKER_RWETH( 18,  6) =  0.454066E+01
  PKER_RWETH( 18,  7) =  0.360566E+01
  PKER_RWETH( 18,  8) =  0.283064E+01
  PKER_RWETH( 18,  9) =  0.218857E+01
  PKER_RWETH( 18, 10) =  0.165785E+01
  PKER_RWETH( 18, 11) =  0.122215E+01
  PKER_RWETH( 18, 12) =  0.870920E+00
  PKER_RWETH( 18, 13) =  0.599738E+00
  PKER_RWETH( 18, 14) =  0.409230E+00
  PKER_RWETH( 18, 15) =  0.300399E+00
  PKER_RWETH( 18, 16) =  0.267701E+00
  PKER_RWETH( 18, 17) =  0.294269E+00
  PKER_RWETH( 18, 18) =  0.355318E+00
  PKER_RWETH( 18, 19) =  0.427404E+00
  PKER_RWETH( 18, 20) =  0.495700E+00
  PKER_RWETH( 18, 21) =  0.554339E+00
  PKER_RWETH( 18, 22) =  0.602725E+00
  PKER_RWETH( 18, 23) =  0.642169E+00
  PKER_RWETH( 18, 24) =  0.674260E+00
  PKER_RWETH( 18, 25) =  0.700395E+00
  PKER_RWETH( 18, 26) =  0.721715E+00
  PKER_RWETH( 18, 27) =  0.739136E+00
  PKER_RWETH( 18, 28) =  0.753394E+00
  PKER_RWETH( 18, 29) =  0.765078E+00
  PKER_RWETH( 18, 30) =  0.774667E+00
  PKER_RWETH( 18, 31) =  0.782543E+00
  PKER_RWETH( 18, 32) =  0.789019E+00
  PKER_RWETH( 18, 33) =  0.794348E+00
  PKER_RWETH( 18, 34) =  0.798736E+00
  PKER_RWETH( 18, 35) =  0.802351E+00
  PKER_RWETH( 18, 36) =  0.805330E+00
  PKER_RWETH( 18, 37) =  0.807788E+00
  PKER_RWETH( 18, 38) =  0.809814E+00
  PKER_RWETH( 18, 39) =  0.811487E+00
  PKER_RWETH( 18, 40) =  0.812867E+00
  PKER_RWETH( 19,  1) =  0.131712E+02
  PKER_RWETH( 19,  2) =  0.107790E+02
  PKER_RWETH( 19,  3) =  0.879768E+01
  PKER_RWETH( 19,  4) =  0.715640E+01
  PKER_RWETH( 19,  5) =  0.579662E+01
  PKER_RWETH( 19,  6) =  0.466986E+01
  PKER_RWETH( 19,  7) =  0.373600E+01
  PKER_RWETH( 19,  8) =  0.296191E+01
  PKER_RWETH( 19,  9) =  0.232027E+01
  PKER_RWETH( 19, 10) =  0.178879E+01
  PKER_RWETH( 19, 11) =  0.134972E+01
  PKER_RWETH( 19, 12) =  0.989916E+00
  PKER_RWETH( 19, 13) =  0.701233E+00
  PKER_RWETH( 19, 14) =  0.480800E+00
  PKER_RWETH( 19, 15) =  0.329665E+00
  PKER_RWETH( 19, 16) =  0.248272E+00
  PKER_RWETH( 19, 17) =  0.230434E+00
  PKER_RWETH( 19, 18) =  0.260120E+00
  PKER_RWETH( 19, 19) =  0.315632E+00
  PKER_RWETH( 19, 20) =  0.377834E+00
  PKER_RWETH( 19, 21) =  0.435396E+00
  PKER_RWETH( 19, 22) =  0.484321E+00
  PKER_RWETH( 19, 23) =  0.524549E+00
  PKER_RWETH( 19, 24) =  0.557311E+00
  PKER_RWETH( 19, 25) =  0.583962E+00
  PKER_RWETH( 19, 26) =  0.605667E+00
  PKER_RWETH( 19, 27) =  0.623372E+00
  PKER_RWETH( 19, 28) =  0.637838E+00
  PKER_RWETH( 19, 29) =  0.649677E+00
  PKER_RWETH( 19, 30) =  0.659379E+00
  PKER_RWETH( 19, 31) =  0.667339E+00
  PKER_RWETH( 19, 32) =  0.673877E+00
  PKER_RWETH( 19, 33) =  0.679253E+00
  PKER_RWETH( 19, 34) =  0.683676E+00
  PKER_RWETH( 19, 35) =  0.687317E+00
  PKER_RWETH( 19, 36) =  0.690317E+00
  PKER_RWETH( 19, 37) =  0.692790E+00
  PKER_RWETH( 19, 38) =  0.694828E+00
  PKER_RWETH( 19, 39) =  0.696510E+00
  PKER_RWETH( 19, 40) =  0.697897E+00
  PKER_RWETH( 20,  1) =  0.132755E+02
  PKER_RWETH( 20,  2) =  0.108842E+02
  PKER_RWETH( 20,  3) =  0.890381E+01
  PKER_RWETH( 20,  4) =  0.726353E+01
  PKER_RWETH( 20,  5) =  0.590477E+01
  PKER_RWETH( 20,  6) =  0.477905E+01
  PKER_RWETH( 20,  7) =  0.384623E+01
  PKER_RWETH( 20,  8) =  0.307309E+01
  PKER_RWETH( 20,  9) =  0.243222E+01
  PKER_RWETH( 20, 10) =  0.190101E+01
  PKER_RWETH( 20, 11) =  0.146109E+01
  PKER_RWETH( 20, 12) =  0.109792E+01
  PKER_RWETH( 20, 13) =  0.800957E+00
  PKER_RWETH( 20, 14) =  0.564005E+00
  PKER_RWETH( 20, 15) =  0.385366E+00
  PKER_RWETH( 20, 16) =  0.266229E+00
  PKER_RWETH( 20, 17) =  0.206550E+00
  PKER_RWETH( 20, 18) =  0.199590E+00
  PKER_RWETH( 20, 19) =  0.230425E+00
  PKER_RWETH( 20, 20) =  0.280277E+00
  PKER_RWETH( 20, 21) =  0.333630E+00
  PKER_RWETH( 20, 22) =  0.382023E+00
  PKER_RWETH( 20, 23) =  0.422805E+00
  PKER_RWETH( 20, 24) =  0.456244E+00
  PKER_RWETH( 20, 25) =  0.483458E+00
  PKER_RWETH( 20, 26) =  0.505594E+00
  PKER_RWETH( 20, 27) =  0.523620E+00
  PKER_RWETH( 20, 28) =  0.538325E+00
  PKER_RWETH( 20, 29) =  0.550339E+00
  PKER_RWETH( 20, 30) =  0.560171E+00
  PKER_RWETH( 20, 31) =  0.568227E+00
  PKER_RWETH( 20, 32) =  0.574836E+00
  PKER_RWETH( 20, 33) =  0.580265E+00
  PKER_RWETH( 20, 34) =  0.584727E+00
  PKER_RWETH( 20, 35) =  0.588398E+00
  PKER_RWETH( 20, 36) =  0.591421E+00
  PKER_RWETH( 20, 37) =  0.593910E+00
  PKER_RWETH( 20, 38) =  0.595962E+00
  PKER_RWETH( 20, 39) =  0.597653E+00
  PKER_RWETH( 20, 40) =  0.599048E+00
  PKER_RWETH( 21,  1) =  0.133638E+02
  PKER_RWETH( 21,  2) =  0.109733E+02
  PKER_RWETH( 21,  3) =  0.899363E+01
  PKER_RWETH( 21,  4) =  0.735415E+01
  PKER_RWETH( 21,  5) =  0.599624E+01
  PKER_RWETH( 21,  6) =  0.487138E+01
  PKER_RWETH( 21,  7) =  0.393943E+01
  PKER_RWETH( 21,  8) =  0.316716E+01
  PKER_RWETH( 21,  9) =  0.252708E+01
  PKER_RWETH( 21, 10) =  0.199649E+01
  PKER_RWETH( 21, 11) =  0.155673E+01
  PKER_RWETH( 21, 12) =  0.119262E+01
  PKER_RWETH( 21, 13) =  0.892302E+00
  PKER_RWETH( 21, 14) =  0.647350E+00
  PKER_RWETH( 21, 15) =  0.453162E+00
  PKER_RWETH( 21, 16) =  0.308890E+00
  PKER_RWETH( 21, 17) =  0.215757E+00
  PKER_RWETH( 21, 18) =  0.173047E+00
  PKER_RWETH( 21, 19) =  0.173871E+00
  PKER_RWETH( 21, 20) =  0.204444E+00
  PKER_RWETH( 21, 21) =  0.248705E+00
  PKER_RWETH( 21, 22) =  0.294253E+00
  PKER_RWETH( 21, 23) =  0.334851E+00
  PKER_RWETH( 21, 24) =  0.368823E+00
  PKER_RWETH( 21, 25) =  0.396614E+00
  PKER_RWETH( 21, 26) =  0.419221E+00
  PKER_RWETH( 21, 27) =  0.437608E+00
  PKER_RWETH( 21, 28) =  0.452581E+00
  PKER_RWETH( 21, 29) =  0.464795E+00
  PKER_RWETH( 21, 30) =  0.474774E+00
  PKER_RWETH( 21, 31) =  0.482940E+00
  PKER_RWETH( 21, 32) =  0.489630E+00
  PKER_RWETH( 21, 33) =  0.495118E+00
  PKER_RWETH( 21, 34) =  0.499626E+00
  PKER_RWETH( 21, 35) =  0.503331E+00
  PKER_RWETH( 21, 36) =  0.506378E+00
  PKER_RWETH( 21, 37) =  0.508887E+00
  PKER_RWETH( 21, 38) =  0.510953E+00
  PKER_RWETH( 21, 39) =  0.512656E+00
  PKER_RWETH( 21, 40) =  0.514060E+00
  PKER_RWETH( 22,  1) =  0.134387E+02
  PKER_RWETH( 22,  2) =  0.110487E+02
  PKER_RWETH( 22,  3) =  0.906972E+01
  PKER_RWETH( 22,  4) =  0.743089E+01
  PKER_RWETH( 22,  5) =  0.607364E+01
  PKER_RWETH( 22,  6) =  0.494948E+01
  PKER_RWETH( 22,  7) =  0.401825E+01
  PKER_RWETH( 22,  8) =  0.324671E+01
  PKER_RWETH( 22,  9) =  0.260736E+01
  PKER_RWETH( 22, 10) =  0.207745E+01
  PKER_RWETH( 22, 11) =  0.163817E+01
  PKER_RWETH( 22, 12) =  0.127411E+01
  PKER_RWETH( 22, 13) =  0.972782E+00
  PKER_RWETH( 22, 14) =  0.724507E+00
  PKER_RWETH( 22, 15) =  0.522622E+00
  PKER_RWETH( 22, 16) =  0.363766E+00
  PKER_RWETH( 22, 17) =  0.247703E+00
  PKER_RWETH( 22, 18) =  0.175545E+00
  PKER_RWETH( 22, 19) =  0.146034E+00
  PKER_RWETH( 22, 20) =  0.152234E+00
  PKER_RWETH( 22, 21) =  0.181564E+00
  PKER_RWETH( 22, 22) =  0.220489E+00
  PKER_RWETH( 22, 23) =  0.259220E+00
  PKER_RWETH( 22, 24) =  0.293219E+00
  PKER_RWETH( 22, 25) =  0.321501E+00
  PKER_RWETH( 22, 26) =  0.344597E+00
  PKER_RWETH( 22, 27) =  0.363378E+00
  PKER_RWETH( 22, 28) =  0.378653E+00
  PKER_RWETH( 22, 29) =  0.391092E+00
  PKER_RWETH( 22, 30) =  0.401239E+00
  PKER_RWETH( 22, 31) =  0.409528E+00
  PKER_RWETH( 22, 32) =  0.416310E+00
  PKER_RWETH( 22, 33) =  0.421867E+00
  PKER_RWETH( 22, 34) =  0.426425E+00
  PKER_RWETH( 22, 35) =  0.430168E+00
  PKER_RWETH( 22, 36) =  0.433244E+00
  PKER_RWETH( 22, 37) =  0.435774E+00
  PKER_RWETH( 22, 38) =  0.437857E+00
  PKER_RWETH( 22, 39) =  0.439572E+00
  PKER_RWETH( 22, 40) =  0.440985E+00
  PKER_RWETH( 23,  1) =  0.135023E+02
  PKER_RWETH( 23,  2) =  0.111128E+02
  PKER_RWETH( 23,  3) =  0.913424E+01
  PKER_RWETH( 23,  4) =  0.749591E+01
  PKER_RWETH( 23,  5) =  0.613920E+01
  PKER_RWETH( 23,  6) =  0.501560E+01
  PKER_RWETH( 23,  7) =  0.408496E+01
  PKER_RWETH( 23,  8) =  0.331403E+01
  PKER_RWETH( 23,  9) =  0.267529E+01
  PKER_RWETH( 23, 10) =  0.214598E+01
  PKER_RWETH( 23, 11) =  0.170727E+01
  PKER_RWETH( 23, 12) =  0.134359E+01
  PKER_RWETH( 23, 13) =  0.104222E+01
  PKER_RWETH( 23, 14) =  0.792868E+00
  PKER_RWETH( 23, 15) =  0.587692E+00
  PKER_RWETH( 23, 16) =  0.421446E+00
  PKER_RWETH( 23, 17) =  0.291760E+00
  PKER_RWETH( 23, 18) =  0.198828E+00
  PKER_RWETH( 23, 19) =  0.143521E+00
  PKER_RWETH( 23, 20) =  0.124168E+00
  PKER_RWETH( 23, 21) =  0.133847E+00
  PKER_RWETH( 23, 22) =  0.161331E+00
  PKER_RWETH( 23, 23) =  0.195282E+00
  PKER_RWETH( 23, 24) =  0.228096E+00
  PKER_RWETH( 23, 25) =  0.256525E+00
  PKER_RWETH( 23, 26) =  0.280060E+00
  PKER_RWETH( 23, 27) =  0.299255E+00
  PKER_RWETH( 23, 28) =  0.314859E+00
  PKER_RWETH( 23, 29) =  0.327550E+00
  PKER_RWETH( 23, 30) =  0.337885E+00
  PKER_RWETH( 23, 31) =  0.346315E+00
  PKER_RWETH( 23, 32) =  0.353201E+00
  PKER_RWETH( 23, 33) =  0.358835E+00
  PKER_RWETH( 23, 34) =  0.363451E+00
  PKER_RWETH( 23, 35) =  0.367237E+00
  PKER_RWETH( 23, 36) =  0.370345E+00
  PKER_RWETH( 23, 37) =  0.372900E+00
  PKER_RWETH( 23, 38) =  0.375001E+00
  PKER_RWETH( 23, 39) =  0.376730E+00
  PKER_RWETH( 23, 40) =  0.378154E+00
  PKER_RWETH( 24,  1) =  0.135563E+02
  PKER_RWETH( 24,  2) =  0.111671E+02
  PKER_RWETH( 24,  3) =  0.918899E+01
  PKER_RWETH( 24,  4) =  0.755107E+01
  PKER_RWETH( 24,  5) =  0.619478E+01
  PKER_RWETH( 24,  6) =  0.507163E+01
  PKER_RWETH( 24,  7) =  0.414145E+01
  PKER_RWETH( 24,  8) =  0.337101E+01
  PKER_RWETH( 24,  9) =  0.273279E+01
  PKER_RWETH( 24, 10) =  0.220400E+01
  PKER_RWETH( 24, 11) =  0.176579E+01
  PKER_RWETH( 24, 12) =  0.140257E+01
  PKER_RWETH( 24, 13) =  0.110150E+01
  PKER_RWETH( 24, 14) =  0.852021E+00
  PKER_RWETH( 24, 15) =  0.645715E+00
  PKER_RWETH( 24, 16) =  0.476221E+00
  PKER_RWETH( 24, 17) =  0.339467E+00
  PKER_RWETH( 24, 18) =  0.233850E+00
  PKER_RWETH( 24, 19) =  0.159822E+00
  PKER_RWETH( 24, 20) =  0.118004E+00
  PKER_RWETH( 24, 21) =  0.106334E+00
  PKER_RWETH( 24, 22) =  0.118095E+00
  PKER_RWETH( 24, 23) =  0.143353E+00
  PKER_RWETH( 24, 24) =  0.172771E+00
  PKER_RWETH( 24, 25) =  0.200484E+00
  PKER_RWETH( 24, 26) =  0.224227E+00
  PKER_RWETH( 24, 27) =  0.243806E+00
  PKER_RWETH( 24, 28) =  0.259757E+00
  PKER_RWETH( 24, 29) =  0.272723E+00
  PKER_RWETH( 24, 30) =  0.283268E+00
  PKER_RWETH( 24, 31) =  0.291856E+00
  PKER_RWETH( 24, 32) =  0.298861E+00
  PKER_RWETH( 24, 33) =  0.304583E+00
  PKER_RWETH( 24, 34) =  0.309264E+00
  PKER_RWETH( 24, 35) =  0.313098E+00
  PKER_RWETH( 24, 36) =  0.316243E+00
  PKER_RWETH( 24, 37) =  0.318825E+00
  PKER_RWETH( 24, 38) =  0.320946E+00
  PKER_RWETH( 24, 39) =  0.322691E+00
  PKER_RWETH( 24, 40) =  0.324127E+00
  PKER_RWETH( 25,  1) =  0.136022E+02
  PKER_RWETH( 25,  2) =  0.112133E+02
  PKER_RWETH( 25,  3) =  0.923550E+01
  PKER_RWETH( 25,  4) =  0.759789E+01
  PKER_RWETH( 25,  5) =  0.624194E+01
  PKER_RWETH( 25,  6) =  0.511914E+01
  PKER_RWETH( 25,  7) =  0.418934E+01
  PKER_RWETH( 25,  8) =  0.341929E+01
  PKER_RWETH( 25,  9) =  0.278148E+01
  PKER_RWETH( 25, 10) =  0.225311E+01
  PKER_RWETH( 25, 11) =  0.181534E+01
  PKER_RWETH( 25, 12) =  0.145255E+01
  PKER_RWETH( 25, 13) =  0.115185E+01
  PKER_RWETH( 25, 14) =  0.902595E+00
  PKER_RWETH( 25, 15) =  0.696094E+00
  PKER_RWETH( 25, 16) =  0.525430E+00
  PKER_RWETH( 25, 17) =  0.385484E+00
  PKER_RWETH( 25, 18) =  0.273126E+00
  PKER_RWETH( 25, 19) =  0.187350E+00
  PKER_RWETH( 25, 20) =  0.128722E+00
  PKER_RWETH( 25, 21) =  0.976342E-01
  PKER_RWETH( 25, 22) =  0.916722E-01
  PKER_RWETH( 25, 23) =  0.104476E+00
  PKER_RWETH( 25, 24) =  0.127358E+00
  PKER_RWETH( 25, 25) =  0.152684E+00
  PKER_RWETH( 25, 26) =  0.176023E+00
  PKER_RWETH( 25, 27) =  0.195832E+00
  PKER_RWETH( 25, 28) =  0.212116E+00
  PKER_RWETH( 25, 29) =  0.225373E+00
  PKER_RWETH( 25, 30) =  0.236148E+00
  PKER_RWETH( 25, 31) =  0.244912E+00
  PKER_RWETH( 25, 32) =  0.252049E+00
  PKER_RWETH( 25, 33) =  0.257870E+00
  PKER_RWETH( 25, 34) =  0.262625E+00
  PKER_RWETH( 25, 35) =  0.266514E+00
  PKER_RWETH( 25, 36) =  0.269700E+00
  PKER_RWETH( 25, 37) =  0.272313E+00
  PKER_RWETH( 25, 38) =  0.274458E+00
  PKER_RWETH( 25, 39) =  0.276220E+00
  PKER_RWETH( 25, 40) =  0.277669E+00
  PKER_RWETH( 26,  1) =  0.136413E+02
  PKER_RWETH( 26,  2) =  0.112526E+02
  PKER_RWETH( 26,  3) =  0.927503E+01
  PKER_RWETH( 26,  4) =  0.763768E+01
  PKER_RWETH( 26,  5) =  0.628200E+01
  PKER_RWETH( 26,  6) =  0.515948E+01
  PKER_RWETH( 26,  7) =  0.422997E+01
  PKER_RWETH( 26,  8) =  0.346023E+01
  PKER_RWETH( 26,  9) =  0.282275E+01
  PKER_RWETH( 26, 10) =  0.229473E+01
  PKER_RWETH( 26, 11) =  0.185731E+01
  PKER_RWETH( 26, 12) =  0.149489E+01
  PKER_RWETH( 26, 13) =  0.119454E+01
  PKER_RWETH( 26, 14) =  0.945593E+00
  PKER_RWETH( 26, 15) =  0.739243E+00
  PKER_RWETH( 26, 16) =  0.568324E+00
  PKER_RWETH( 26, 17) =  0.427174E+00
  PKER_RWETH( 26, 18) =  0.311688E+00
  PKER_RWETH( 26, 19) =  0.219506E+00
  PKER_RWETH( 26, 20) =  0.150065E+00
  PKER_RWETH( 26, 21) =  0.103983E+00
  PKER_RWETH( 26, 22) =  0.813323E-01
  PKER_RWETH( 26, 23) =  0.795339E-01
  PKER_RWETH( 26, 24) =  0.926187E-01
  PKER_RWETH( 26, 25) =  0.113085E+00
  PKER_RWETH( 26, 26) =  0.134774E+00
  PKER_RWETH( 26, 27) =  0.154384E+00
  PKER_RWETH( 26, 28) =  0.170899E+00
  PKER_RWETH( 26, 29) =  0.184441E+00
  PKER_RWETH( 26, 30) =  0.195459E+00
  PKER_RWETH( 26, 31) =  0.204415E+00
  PKER_RWETH( 26, 32) =  0.211698E+00
  PKER_RWETH( 26, 33) =  0.217630E+00
  PKER_RWETH( 26, 34) =  0.222469E+00
  PKER_RWETH( 26, 35) =  0.226420E+00
  PKER_RWETH( 26, 36) =  0.229653E+00
  PKER_RWETH( 26, 37) =  0.232300E+00
  PKER_RWETH( 26, 38) =  0.234471E+00
  PKER_RWETH( 26, 39) =  0.236253E+00
  PKER_RWETH( 26, 40) =  0.237716E+00
  PKER_RWETH( 27,  1) =  0.136746E+02
  PKER_RWETH( 27,  2) =  0.112861E+02
  PKER_RWETH( 27,  3) =  0.930868E+01
  PKER_RWETH( 27,  4) =  0.767152E+01
  PKER_RWETH( 27,  5) =  0.631604E+01
  PKER_RWETH( 27,  6) =  0.519374E+01
  PKER_RWETH( 27,  7) =  0.426447E+01
  PKER_RWETH( 27,  8) =  0.349498E+01
  PKER_RWETH( 27,  9) =  0.285775E+01
  PKER_RWETH( 27, 10) =  0.233001E+01
  PKER_RWETH( 27, 11) =  0.189288E+01
  PKER_RWETH( 27, 12) =  0.153076E+01
  PKER_RWETH( 27, 13) =  0.123072E+01
  PKER_RWETH( 27, 14) =  0.982064E+00
  PKER_RWETH( 27, 15) =  0.775961E+00
  PKER_RWETH( 27, 16) =  0.605136E+00
  PKER_RWETH( 27, 17) =  0.463679E+00
  PKER_RWETH( 27, 18) =  0.346968E+00
  PKER_RWETH( 27, 19) =  0.251737E+00
  PKER_RWETH( 27, 20) =  0.176232E+00
  PKER_RWETH( 27, 21) =  0.120216E+00
  PKER_RWETH( 27, 22) =  0.842855E-01
  PKER_RWETH( 27, 23) =  0.682432E-01
  PKER_RWETH( 27, 24) =  0.693968E-01
  PKER_RWETH( 27, 25) =  0.822195E-01
  PKER_RWETH( 27, 26) =  0.100330E+00
  PKER_RWETH( 27, 27) =  0.118826E+00
  PKER_RWETH( 27, 28) =  0.135271E+00
  PKER_RWETH( 27, 29) =  0.149030E+00
  PKER_RWETH( 27, 30) =  0.160290E+00
  PKER_RWETH( 27, 31) =  0.169449E+00
  PKER_RWETH( 27, 32) =  0.176893E+00
  PKER_RWETH( 27, 33) =  0.182947E+00
  PKER_RWETH( 27, 34) =  0.187879E+00
  PKER_RWETH( 27, 35) =  0.191900E+00
  PKER_RWETH( 27, 36) =  0.195185E+00
  PKER_RWETH( 27, 37) =  0.197872E+00
  PKER_RWETH( 27, 38) =  0.200072E+00
  PKER_RWETH( 27, 39) =  0.201876E+00
  PKER_RWETH( 27, 40) =  0.203356E+00
  PKER_RWETH( 28,  1) =  0.137029E+02
  PKER_RWETH( 28,  2) =  0.113146E+02
  PKER_RWETH( 28,  3) =  0.933732E+01
  PKER_RWETH( 28,  4) =  0.770032E+01
  PKER_RWETH( 28,  5) =  0.634501E+01
  PKER_RWETH( 28,  6) =  0.522288E+01
  PKER_RWETH( 28,  7) =  0.429379E+01
  PKER_RWETH( 28,  8) =  0.352449E+01
  PKER_RWETH( 28,  9) =  0.288747E+01
  PKER_RWETH( 28, 10) =  0.235994E+01
  PKER_RWETH( 28, 11) =  0.192305E+01
  PKER_RWETH( 28, 12) =  0.156117E+01
  PKER_RWETH( 28, 13) =  0.126138E+01
  PKER_RWETH( 28, 14) =  0.101298E+01
  PKER_RWETH( 28, 15) =  0.807124E+00
  PKER_RWETH( 28, 16) =  0.636495E+00
  PKER_RWETH( 28, 17) =  0.495081E+00
  PKER_RWETH( 28, 18) =  0.378020E+00
  PKER_RWETH( 28, 19) =  0.281548E+00
  PKER_RWETH( 28, 20) =  0.203081E+00
  PKER_RWETH( 28, 21) =  0.141353E+00
  PKER_RWETH( 28, 22) =  0.963613E-01
  PKER_RWETH( 28, 23) =  0.686158E-01
  PKER_RWETH( 28, 24) =  0.577003E-01
  PKER_RWETH( 28, 25) =  0.608435E-01
  PKER_RWETH( 28, 26) =  0.730535E-01
  PKER_RWETH( 28, 27) =  0.889343E-01
  PKER_RWETH( 28, 28) =  0.104643E+00
  PKER_RWETH( 28, 29) =  0.118411E+00
  PKER_RWETH( 28, 30) =  0.129868E+00
  PKER_RWETH( 28, 31) =  0.139231E+00
  PKER_RWETH( 28, 32) =  0.146844E+00
  PKER_RWETH( 28, 33) =  0.153033E+00
  PKER_RWETH( 28, 34) =  0.158067E+00
  PKER_RWETH( 28, 35) =  0.162167E+00
  PKER_RWETH( 28, 36) =  0.165510E+00
  PKER_RWETH( 28, 37) =  0.168241E+00
  PKER_RWETH( 28, 38) =  0.170474E+00
  PKER_RWETH( 28, 39) =  0.172303E+00
  PKER_RWETH( 28, 40) =  0.173802E+00
  PKER_RWETH( 29,  1) =  0.137271E+02
  PKER_RWETH( 29,  2) =  0.113389E+02
  PKER_RWETH( 29,  3) =  0.936173E+01
  PKER_RWETH( 29,  4) =  0.772485E+01
  PKER_RWETH( 29,  5) =  0.636967E+01
  PKER_RWETH( 29,  6) =  0.524768E+01
  PKER_RWETH( 29,  7) =  0.431873E+01
  PKER_RWETH( 29,  8) =  0.354959E+01
  PKER_RWETH( 29,  9) =  0.291273E+01
  PKER_RWETH( 29, 10) =  0.238537E+01
  PKER_RWETH( 29, 11) =  0.194865E+01
  PKER_RWETH( 29, 12) =  0.158696E+01
  PKER_RWETH( 29, 13) =  0.128738E+01
  PKER_RWETH( 29, 14) =  0.103919E+01
  PKER_RWETH( 29, 15) =  0.833552E+00
  PKER_RWETH( 29, 16) =  0.663125E+00
  PKER_RWETH( 29, 17) =  0.521865E+00
  PKER_RWETH( 29, 18) =  0.404804E+00
  PKER_RWETH( 29, 19) =  0.307944E+00
  PKER_RWETH( 29, 20) =  0.228229E+00
  PKER_RWETH( 29, 21) =  0.163636E+00
  PKER_RWETH( 29, 22) =  0.113284E+00
  PKER_RWETH( 29, 23) =  0.773180E-01
  PKER_RWETH( 29, 24) =  0.561494E-01
  PKER_RWETH( 29, 25) =  0.491502E-01
  PKER_RWETH( 29, 26) =  0.535664E-01
  PKER_RWETH( 29, 27) =  0.649274E-01
  PKER_RWETH( 29, 28) =  0.787521E-01
  PKER_RWETH( 29, 29) =  0.920477E-01
  PKER_RWETH( 29, 30) =  0.103558E+00
  PKER_RWETH( 29, 31) =  0.113095E+00
  PKER_RWETH( 29, 32) =  0.120880E+00
  PKER_RWETH( 29, 33) =  0.127210E+00
  PKER_RWETH( 29, 34) =  0.132356E+00
  PKER_RWETH( 29, 35) =  0.136542E+00
  PKER_RWETH( 29, 36) =  0.139951E+00
  PKER_RWETH( 29, 37) =  0.142731E+00
  PKER_RWETH( 29, 38) =  0.145001E+00
  PKER_RWETH( 29, 39) =  0.146858E+00
  PKER_RWETH( 29, 40) =  0.148378E+00
  PKER_RWETH( 30,  1) =  0.137477E+02
  PKER_RWETH( 30,  2) =  0.113596E+02
  PKER_RWETH( 30,  3) =  0.938254E+01
  PKER_RWETH( 30,  4) =  0.774576E+01
  PKER_RWETH( 30,  5) =  0.639068E+01
  PKER_RWETH( 30,  6) =  0.526879E+01
  PKER_RWETH( 30,  7) =  0.433996E+01
  PKER_RWETH( 30,  8) =  0.357094E+01
  PKER_RWETH( 30,  9) =  0.293420E+01
  PKER_RWETH( 30, 10) =  0.240698E+01
  PKER_RWETH( 30, 11) =  0.197041E+01
  PKER_RWETH( 30, 12) =  0.160887E+01
  PKER_RWETH( 30, 13) =  0.130945E+01
  PKER_RWETH( 30, 14) =  0.106143E+01
  PKER_RWETH( 30, 15) =  0.855966E+00
  PKER_RWETH( 30, 16) =  0.685719E+00
  PKER_RWETH( 30, 17) =  0.544626E+00
  PKER_RWETH( 30, 18) =  0.427680E+00
  PKER_RWETH( 30, 19) =  0.330783E+00
  PKER_RWETH( 30, 20) =  0.250649E+00
  PKER_RWETH( 30, 21) =  0.184810E+00
  PKER_RWETH( 30, 22) =  0.131698E+00
  PKER_RWETH( 30, 23) =  0.907310E-01
  PKER_RWETH( 30, 24) =  0.621333E-01
  PKER_RWETH( 30, 25) =  0.462193E-01
  PKER_RWETH( 30, 26) =  0.421662E-01
  PKER_RWETH( 30, 27) =  0.473138E-01
  PKER_RWETH( 30, 28) =  0.577107E-01
  PKER_RWETH( 30, 29) =  0.696596E-01
  PKER_RWETH( 30, 30) =  0.808783E-01
  PKER_RWETH( 30, 31) =  0.904907E-01
  PKER_RWETH( 30, 32) =  0.984276E-01
  PKER_RWETH( 30, 33) =  0.104901E+00
  PKER_RWETH( 30, 34) =  0.110165E+00
  PKER_RWETH( 30, 35) =  0.114443E+00
  PKER_RWETH( 30, 36) =  0.117924E+00
  PKER_RWETH( 30, 37) =  0.120759E+00
  PKER_RWETH( 30, 38) =  0.123072E+00
  PKER_RWETH( 30, 39) =  0.124960E+00
  PKER_RWETH( 30, 40) =  0.126503E+00
  PKER_RWETH( 31,  1) =  0.137654E+02
  PKER_RWETH( 31,  2) =  0.113773E+02
  PKER_RWETH( 31,  3) =  0.940030E+01
  PKER_RWETH( 31,  4) =  0.776359E+01
  PKER_RWETH( 31,  5) =  0.640859E+01
  PKER_RWETH( 31,  6) =  0.528679E+01
  PKER_RWETH( 31,  7) =  0.435805E+01
  PKER_RWETH( 31,  8) =  0.358912E+01
  PKER_RWETH( 31,  9) =  0.295248E+01
  PKER_RWETH( 31, 10) =  0.242536E+01
  PKER_RWETH( 31, 11) =  0.198890E+01
  PKER_RWETH( 31, 12) =  0.162749E+01
  PKER_RWETH( 31, 13) =  0.132819E+01
  PKER_RWETH( 31, 14) =  0.108031E+01
  PKER_RWETH( 31, 15) =  0.874986E+00
  PKER_RWETH( 31, 16) =  0.704888E+00
  PKER_RWETH( 31, 17) =  0.563945E+00
  PKER_RWETH( 31, 18) =  0.447136E+00
  PKER_RWETH( 31, 19) =  0.350322E+00
  PKER_RWETH( 31, 20) =  0.270119E+00
  PKER_RWETH( 31, 21) =  0.203836E+00
  PKER_RWETH( 31, 22) =  0.149485E+00
  PKER_RWETH( 31, 23) =  0.105870E+00
  PKER_RWETH( 31, 24) =  0.726361E-01
  PKER_RWETH( 31, 25) =  0.500546E-01
  PKER_RWETH( 31, 26) =  0.382950E-01
  PKER_RWETH( 31, 27) =  0.364238E-01
  PKER_RWETH( 31, 28) =  0.419002E-01
  PKER_RWETH( 31, 29) =  0.512768E-01
  PKER_RWETH( 31, 30) =  0.615456E-01
  PKER_RWETH( 31, 31) =  0.709877E-01
  PKER_RWETH( 31, 32) =  0.790080E-01
  PKER_RWETH( 31, 33) =  0.856118E-01
  PKER_RWETH( 31, 34) =  0.909951E-01
  PKER_RWETH( 31, 35) =  0.953723E-01
  PKER_RWETH( 31, 36) =  0.989311E-01
  PKER_RWETH( 31, 37) =  0.101826E+00
  PKER_RWETH( 31, 38) =  0.104185E+00
  PKER_RWETH( 31, 39) =  0.106108E+00
  PKER_RWETH( 31, 40) =  0.107678E+00
  PKER_RWETH( 32,  1) =  0.137804E+02
  PKER_RWETH( 32,  2) =  0.113924E+02
  PKER_RWETH( 32,  3) =  0.941546E+01
  PKER_RWETH( 32,  4) =  0.777881E+01
  PKER_RWETH( 32,  5) =  0.642387E+01
  PKER_RWETH( 32,  6) =  0.530214E+01
  PKER_RWETH( 32,  7) =  0.437346E+01
  PKER_RWETH( 32,  8) =  0.360461E+01
  PKER_RWETH( 32,  9) =  0.296805E+01
  PKER_RWETH( 32, 10) =  0.244102E+01
  PKER_RWETH( 32, 11) =  0.200464E+01
  PKER_RWETH( 32, 12) =  0.164332E+01
  PKER_RWETH( 32, 13) =  0.134412E+01
  PKER_RWETH( 32, 14) =  0.109635E+01
  PKER_RWETH( 32, 15) =  0.891139E+00
  PKER_RWETH( 32, 16) =  0.721160E+00
  PKER_RWETH( 32, 17) =  0.580341E+00
  PKER_RWETH( 32, 18) =  0.463657E+00
  PKER_RWETH( 32, 19) =  0.366953E+00
  PKER_RWETH( 32, 20) =  0.286807E+00
  PKER_RWETH( 32, 21) =  0.220427E+00
  PKER_RWETH( 32, 22) =  0.165613E+00
  PKER_RWETH( 32, 23) =  0.120775E+00
  PKER_RWETH( 32, 24) =  0.850138E-01
  PKER_RWETH( 32, 25) =  0.581425E-01
  PKER_RWETH( 32, 26) =  0.404419E-01
  PKER_RWETH( 32, 27) =  0.319552E-01
  PKER_RWETH( 32, 28) =  0.316626E-01
  PKER_RWETH( 32, 29) =  0.371741E-01
  PKER_RWETH( 32, 30) =  0.455292E-01
  PKER_RWETH( 32, 31) =  0.543130E-01
  PKER_RWETH( 32, 32) =  0.622423E-01
  PKER_RWETH( 32, 33) =  0.689293E-01
  PKER_RWETH( 32, 34) =  0.744234E-01
  PKER_RWETH( 32, 35) =  0.789005E-01
  PKER_RWETH( 32, 36) =  0.825413E-01
  PKER_RWETH( 32, 37) =  0.855015E-01
  PKER_RWETH( 32, 38) =  0.879101E-01
  PKER_RWETH( 32, 39) =  0.898719E-01
  PKER_RWETH( 32, 40) =  0.914716E-01
  PKER_RWETH( 33,  1) =  0.137933E+02
  PKER_RWETH( 33,  2) =  0.114053E+02
  PKER_RWETH( 33,  3) =  0.942841E+01
  PKER_RWETH( 33,  4) =  0.779180E+01
  PKER_RWETH( 33,  5) =  0.643691E+01
  PKER_RWETH( 33,  6) =  0.531523E+01
  PKER_RWETH( 33,  7) =  0.438661E+01
  PKER_RWETH( 33,  8) =  0.361782E+01
  PKER_RWETH( 33,  9) =  0.298132E+01
  PKER_RWETH( 33, 10) =  0.245435E+01
  PKER_RWETH( 33, 11) =  0.201805E+01
  PKER_RWETH( 33, 12) =  0.165680E+01
  PKER_RWETH( 33, 13) =  0.135768E+01
  PKER_RWETH( 33, 14) =  0.110999E+01
  PKER_RWETH( 33, 15) =  0.904867E+00
  PKER_RWETH( 33, 16) =  0.734983E+00
  PKER_RWETH( 33, 17) =  0.594264E+00
  PKER_RWETH( 33, 18) =  0.477684E+00
  PKER_RWETH( 33, 19) =  0.381084E+00
  PKER_RWETH( 33, 20) =  0.301025E+00
  PKER_RWETH( 33, 21) =  0.234678E+00
  PKER_RWETH( 33, 22) =  0.179744E+00
  PKER_RWETH( 33, 23) =  0.134427E+00
  PKER_RWETH( 33, 24) =  0.974646E-01
  PKER_RWETH( 33, 25) =  0.681937E-01
  PKER_RWETH( 33, 26) =  0.465543E-01
  PKER_RWETH( 33, 27) =  0.328007E-01
  PKER_RWETH( 33, 28) =  0.268706E-01
  PKER_RWETH( 33, 29) =  0.276742E-01
  PKER_RWETH( 33, 30) =  0.330242E-01
  PKER_RWETH( 33, 31) =  0.403935E-01
  PKER_RWETH( 33, 32) =  0.478738E-01
  PKER_RWETH( 33, 33) =  0.545206E-01
  PKER_RWETH( 33, 34) =  0.600926E-01
  PKER_RWETH( 33, 35) =  0.646634E-01
  PKER_RWETH( 33, 36) =  0.683873E-01
  PKER_RWETH( 33, 37) =  0.714159E-01
  PKER_RWETH( 33, 38) =  0.738787E-01
  PKER_RWETH( 33, 39) =  0.758827E-01
  PKER_RWETH( 33, 40) =  0.775149E-01
  PKER_RWETH( 34,  1) =  0.138043E+02
  PKER_RWETH( 34,  2) =  0.114163E+02
  PKER_RWETH( 34,  3) =  0.943947E+01
  PKER_RWETH( 34,  4) =  0.780291E+01
  PKER_RWETH( 34,  5) =  0.644805E+01
  PKER_RWETH( 34,  6) =  0.532642E+01
  PKER_RWETH( 34,  7) =  0.439784E+01
  PKER_RWETH( 34,  8) =  0.362909E+01
  PKER_RWETH( 34,  9) =  0.299264E+01
  PKER_RWETH( 34, 10) =  0.246572E+01
  PKER_RWETH( 34, 11) =  0.202947E+01
  PKER_RWETH( 34, 12) =  0.166828E+01
  PKER_RWETH( 34, 13) =  0.136922E+01
  PKER_RWETH( 34, 14) =  0.112160E+01
  PKER_RWETH( 34, 15) =  0.916545E+00
  PKER_RWETH( 34, 16) =  0.746735E+00
  PKER_RWETH( 34, 17) =  0.606095E+00
  PKER_RWETH( 34, 18) =  0.489599E+00
  PKER_RWETH( 34, 19) =  0.393086E+00
  PKER_RWETH( 34, 20) =  0.313112E+00
  PKER_RWETH( 34, 21) =  0.246834E+00
  PKER_RWETH( 34, 22) =  0.191912E+00
  PKER_RWETH( 34, 23) =  0.146456E+00
  PKER_RWETH( 34, 24) =  0.109003E+00
  PKER_RWETH( 34, 25) =  0.785586E-01
  PKER_RWETH( 34, 26) =  0.546497E-01
  PKER_RWETH( 34, 27) =  0.373003E-01
  PKER_RWETH( 34, 28) =  0.267289E-01
  PKER_RWETH( 34, 29) =  0.227683E-01
  PKER_RWETH( 34, 30) =  0.243048E-01
  PKER_RWETH( 34, 31) =  0.293552E-01
  PKER_RWETH( 34, 32) =  0.358030E-01
  PKER_RWETH( 34, 33) =  0.421486E-01
  PKER_RWETH( 34, 34) =  0.477119E-01
  PKER_RWETH( 34, 35) =  0.523530E-01
  PKER_RWETH( 34, 36) =  0.561555E-01
  PKER_RWETH( 34, 37) =  0.592533E-01
  PKER_RWETH( 34, 38) =  0.617731E-01
  PKER_RWETH( 34, 39) =  0.638224E-01
  PKER_RWETH( 34, 40) =  0.654901E-01
  PKER_RWETH( 35,  1) =  0.138137E+02
  PKER_RWETH( 35,  2) =  0.114258E+02
  PKER_RWETH( 35,  3) =  0.944893E+01
  PKER_RWETH( 35,  4) =  0.781240E+01
  PKER_RWETH( 35,  5) =  0.645758E+01
  PKER_RWETH( 35,  6) =  0.533597E+01
  PKER_RWETH( 35,  7) =  0.440743E+01
  PKER_RWETH( 35,  8) =  0.363871E+01
  PKER_RWETH( 35,  9) =  0.300230E+01
  PKER_RWETH( 35, 10) =  0.247542E+01
  PKER_RWETH( 35, 11) =  0.203922E+01
  PKER_RWETH( 35, 12) =  0.167807E+01
  PKER_RWETH( 35, 13) =  0.137906E+01
  PKER_RWETH( 35, 14) =  0.113148E+01
  PKER_RWETH( 35, 15) =  0.926485E+00
  PKER_RWETH( 35, 16) =  0.756733E+00
  PKER_RWETH( 35, 17) =  0.616156E+00
  PKER_RWETH( 35, 18) =  0.499726E+00
  PKER_RWETH( 35, 19) =  0.403283E+00
  PKER_RWETH( 35, 20) =  0.323383E+00
  PKER_RWETH( 35, 21) =  0.257174E+00
  PKER_RWETH( 35, 22) =  0.202305E+00
  PKER_RWETH( 35, 23) =  0.156843E+00
  PKER_RWETH( 35, 24) =  0.119234E+00
  PKER_RWETH( 35, 25) =  0.882933E-01
  PKER_RWETH( 35, 26) =  0.632437E-01
  PKER_RWETH( 35, 27) =  0.437614E-01
  PKER_RWETH( 35, 28) =  0.299201E-01
  PKER_RWETH( 35, 29) =  0.219008E-01
  PKER_RWETH( 35, 30) =  0.194367E-01
  PKER_RWETH( 35, 31) =  0.214285E-01
  PKER_RWETH( 35, 32) =  0.261037E-01
  PKER_RWETH( 35, 33) =  0.317007E-01
  PKER_RWETH( 35, 34) =  0.370659E-01
  PKER_RWETH( 35, 35) =  0.417162E-01
  PKER_RWETH( 35, 36) =  0.455807E-01
  PKER_RWETH( 35, 37) =  0.487442E-01
  PKER_RWETH( 35, 38) =  0.513216E-01
  PKER_RWETH( 35, 39) =  0.534183E-01
  PKER_RWETH( 35, 40) =  0.551239E-01
  PKER_RWETH( 36,  1) =  0.138217E+02
  PKER_RWETH( 36,  2) =  0.114338E+02
  PKER_RWETH( 36,  3) =  0.945703E+01
  PKER_RWETH( 36,  4) =  0.782051E+01
  PKER_RWETH( 36,  5) =  0.646572E+01
  PKER_RWETH( 36,  6) =  0.534413E+01
  PKER_RWETH( 36,  7) =  0.441562E+01
  PKER_RWETH( 36,  8) =  0.364693E+01
  PKER_RWETH( 36,  9) =  0.301055E+01
  PKER_RWETH( 36, 10) =  0.248370E+01
  PKER_RWETH( 36, 11) =  0.204753E+01
  PKER_RWETH( 36, 12) =  0.168642E+01
  PKER_RWETH( 36, 13) =  0.138744E+01
  PKER_RWETH( 36, 14) =  0.113991E+01
  PKER_RWETH( 36, 15) =  0.934954E+00
  PKER_RWETH( 36, 16) =  0.765248E+00
  PKER_RWETH( 36, 17) =  0.624718E+00
  PKER_RWETH( 36, 18) =  0.508341E+00
  PKER_RWETH( 36, 19) =  0.411953E+00
  PKER_RWETH( 36, 20) =  0.332112E+00
  PKER_RWETH( 36, 21) =  0.265964E+00
  PKER_RWETH( 36, 22) =  0.211152E+00
  PKER_RWETH( 36, 23) =  0.165729E+00
  PKER_RWETH( 36, 24) =  0.128099E+00
  PKER_RWETH( 36, 25) =  0.969879E-01
  PKER_RWETH( 36, 26) =  0.714385E-01
  PKER_RWETH( 36, 27) =  0.508527E-01
  PKER_RWETH( 36, 28) =  0.350208E-01
  PKER_RWETH( 36, 29) =  0.240492E-01
  PKER_RWETH( 36, 30) =  0.180569E-01
  PKER_RWETH( 36, 31) =  0.167148E-01
  PKER_RWETH( 36, 32) =  0.189530E-01
  PKER_RWETH( 36, 33) =  0.232085E-01
  PKER_RWETH( 36, 34) =  0.280365E-01
  PKER_RWETH( 36, 35) =  0.325598E-01
  PKER_RWETH( 36, 36) =  0.364432E-01
  PKER_RWETH( 36, 37) =  0.396603E-01
  PKER_RWETH( 36, 38) =  0.422924E-01
  PKER_RWETH( 36, 39) =  0.444370E-01
  PKER_RWETH( 36, 40) =  0.461821E-01
  PKER_RWETH( 37,  1) =  0.138286E+02
  PKER_RWETH( 37,  2) =  0.114408E+02
  PKER_RWETH( 37,  3) =  0.946395E+01
  PKER_RWETH( 37,  4) =  0.782746E+01
  PKER_RWETH( 37,  5) =  0.647268E+01
  PKER_RWETH( 37,  6) =  0.535111E+01
  PKER_RWETH( 37,  7) =  0.442262E+01
  PKER_RWETH( 37,  8) =  0.365395E+01
  PKER_RWETH( 37,  9) =  0.301760E+01
  PKER_RWETH( 37, 10) =  0.249077E+01
  PKER_RWETH( 37, 11) =  0.205463E+01
  PKER_RWETH( 37, 12) =  0.169354E+01
  PKER_RWETH( 37, 13) =  0.139460E+01
  PKER_RWETH( 37, 14) =  0.114709E+01
  PKER_RWETH( 37, 15) =  0.942174E+00
  PKER_RWETH( 37, 16) =  0.772503E+00
  PKER_RWETH( 37, 17) =  0.632012E+00
  PKER_RWETH( 37, 18) =  0.515675E+00
  PKER_RWETH( 37, 19) =  0.419331E+00
  PKER_RWETH( 37, 20) =  0.339536E+00
  PKER_RWETH( 37, 21) =  0.273438E+00
  PKER_RWETH( 37, 22) =  0.218676E+00
  PKER_RWETH( 37, 23) =  0.173299E+00
  PKER_RWETH( 37, 24) =  0.135696E+00
  PKER_RWETH( 37, 25) =  0.104551E+00
  PKER_RWETH( 37, 26) =  0.788199E-01
  PKER_RWETH( 37, 27) =  0.577354E-01
  PKER_RWETH( 37, 28) =  0.408418E-01
  PKER_RWETH( 37, 29) =  0.280163E-01
  PKER_RWETH( 37, 30) =  0.193782E-01
  PKER_RWETH( 37, 31) =  0.149908E-01
  PKER_RWETH( 37, 32) =  0.144734E-01
  PKER_RWETH( 37, 33) =  0.168026E-01
  PKER_RWETH( 37, 34) =  0.206235E-01
  PKER_RWETH( 37, 35) =  0.247667E-01
  PKER_RWETH( 37, 36) =  0.285711E-01
  PKER_RWETH( 37, 37) =  0.318112E-01
  PKER_RWETH( 37, 38) =  0.344891E-01
  PKER_RWETH( 37, 39) =  0.366792E-01
  PKER_RWETH( 37, 40) =  0.384641E-01
  PKER_RWETH( 38,  1) =  0.138345E+02
  PKER_RWETH( 38,  2) =  0.114467E+02
  PKER_RWETH( 38,  3) =  0.946988E+01
  PKER_RWETH( 38,  4) =  0.783340E+01
  PKER_RWETH( 38,  5) =  0.647863E+01
  PKER_RWETH( 38,  6) =  0.535709E+01
  PKER_RWETH( 38,  7) =  0.442861E+01
  PKER_RWETH( 38,  8) =  0.365996E+01
  PKER_RWETH( 38,  9) =  0.302362E+01
  PKER_RWETH( 38, 10) =  0.249682E+01
  PKER_RWETH( 38, 11) =  0.206069E+01
  PKER_RWETH( 38, 12) =  0.169963E+01
  PKER_RWETH( 38, 13) =  0.140071E+01
  PKER_RWETH( 38, 14) =  0.115323E+01
  PKER_RWETH( 38, 15) =  0.948333E+00
  PKER_RWETH( 38, 16) =  0.778690E+00
  PKER_RWETH( 38, 17) =  0.638228E+00
  PKER_RWETH( 38, 18) =  0.521923E+00
  PKER_RWETH( 38, 19) =  0.425613E+00
  PKER_RWETH( 38, 20) =  0.345854E+00
  PKER_RWETH( 38, 21) =  0.279795E+00
  PKER_RWETH( 38, 22) =  0.225075E+00
  PKER_RWETH( 38, 23) =  0.179739E+00
  PKER_RWETH( 38, 24) =  0.142173E+00
  PKER_RWETH( 38, 25) =  0.111044E+00
  PKER_RWETH( 38, 26) =  0.852693E-01
  PKER_RWETH( 38, 27) =  0.639938E-01
  PKER_RWETH( 38, 28) =  0.466054E-01
  PKER_RWETH( 38, 29) =  0.327645E-01
  PKER_RWETH( 38, 30) =  0.224136E-01
  PKER_RWETH( 38, 31) =  0.156672E-01
  PKER_RWETH( 38, 32) =  0.125407E-01
  PKER_RWETH( 38, 33) =  0.126088E-01
  PKER_RWETH( 38, 34) =  0.149224E-01
  PKER_RWETH( 38, 35) =  0.183139E-01
  PKER_RWETH( 38, 36) =  0.218522E-01
  PKER_RWETH( 38, 37) =  0.250453E-01
  PKER_RWETH( 38, 38) =  0.277469E-01
  PKER_RWETH( 38, 39) =  0.299758E-01
  PKER_RWETH( 38, 40) =  0.317985E-01
  PKER_RWETH( 39,  1) =  0.138396E+02
  PKER_RWETH( 39,  2) =  0.114517E+02
  PKER_RWETH( 39,  3) =  0.947496E+01
  PKER_RWETH( 39,  4) =  0.783849E+01
  PKER_RWETH( 39,  5) =  0.648373E+01
  PKER_RWETH( 39,  6) =  0.536220E+01
  PKER_RWETH( 39,  7) =  0.443373E+01
  PKER_RWETH( 39,  8) =  0.366510E+01
  PKER_RWETH( 39,  9) =  0.302877E+01
  PKER_RWETH( 39, 10) =  0.250199E+01
  PKER_RWETH( 39, 11) =  0.206588E+01
  PKER_RWETH( 39, 12) =  0.170483E+01
  PKER_RWETH( 39, 13) =  0.140593E+01
  PKER_RWETH( 39, 14) =  0.115847E+01
  PKER_RWETH( 39, 15) =  0.953590E+00
  PKER_RWETH( 39, 16) =  0.783969E+00
  PKER_RWETH( 39, 17) =  0.643530E+00
  PKER_RWETH( 39, 18) =  0.527250E+00
  PKER_RWETH( 39, 19) =  0.430966E+00
  PKER_RWETH( 39, 20) =  0.351236E+00
  PKER_RWETH( 39, 21) =  0.285208E+00
  PKER_RWETH( 39, 22) =  0.230520E+00
  PKER_RWETH( 39, 23) =  0.185219E+00
  PKER_RWETH( 39, 24) =  0.147687E+00
  PKER_RWETH( 39, 25) =  0.116587E+00
  PKER_RWETH( 39, 26) =  0.908192E-01
  PKER_RWETH( 39, 27) =  0.694900E-01
  PKER_RWETH( 39, 28) =  0.519037E-01
  PKER_RWETH( 39, 29) =  0.375752E-01
  PKER_RWETH( 39, 30) =  0.262572E-01
  PKER_RWETH( 39, 31) =  0.179379E-01
  PKER_RWETH( 39, 32) =  0.127211E-01
  PKER_RWETH( 39, 33) =  0.105726E-01
  PKER_RWETH( 39, 34) =  0.110445E-01
  PKER_RWETH( 39, 35) =  0.132652E-01
  PKER_RWETH( 39, 36) =  0.162488E-01
  PKER_RWETH( 39, 37) =  0.192576E-01
  PKER_RWETH( 39, 38) =  0.219332E-01
  PKER_RWETH( 39, 39) =  0.241847E-01
  PKER_RWETH( 39, 40) =  0.260398E-01
  PKER_RWETH( 40,  1) =  0.138439E+02
  PKER_RWETH( 40,  2) =  0.114561E+02
  PKER_RWETH( 40,  3) =  0.947930E+01
  PKER_RWETH( 40,  4) =  0.784284E+01
  PKER_RWETH( 40,  5) =  0.648810E+01
  PKER_RWETH( 40,  6) =  0.536657E+01
  PKER_RWETH( 40,  7) =  0.443812E+01
  PKER_RWETH( 40,  8) =  0.366949E+01
  PKER_RWETH( 40,  9) =  0.303318E+01
  PKER_RWETH( 40, 10) =  0.250641E+01
  PKER_RWETH( 40, 11) =  0.207031E+01
  PKER_RWETH( 40, 12) =  0.170928E+01
  PKER_RWETH( 40, 13) =  0.141039E+01
  PKER_RWETH( 40, 14) =  0.116294E+01
  PKER_RWETH( 40, 15) =  0.958081E+00
  PKER_RWETH( 40, 16) =  0.788476E+00
  PKER_RWETH( 40, 17) =  0.648056E+00
  PKER_RWETH( 40, 18) =  0.531794E+00
  PKER_RWETH( 40, 19) =  0.435532E+00
  PKER_RWETH( 40, 20) =  0.355824E+00
  PKER_RWETH( 40, 21) =  0.289819E+00
  PKER_RWETH( 40, 22) =  0.235157E+00
  PKER_RWETH( 40, 23) =  0.189883E+00
  PKER_RWETH( 40, 24) =  0.152380E+00
  PKER_RWETH( 40, 25) =  0.121308E+00
  PKER_RWETH( 40, 26) =  0.955623E-01
  PKER_RWETH( 40, 27) =  0.742324E-01
  PKER_RWETH( 40, 28) =  0.565844E-01
  PKER_RWETH( 40, 29) =  0.420531E-01
  PKER_RWETH( 40, 30) =  0.302574E-01
  PKER_RWETH( 40, 31) =  0.210233E-01
  PKER_RWETH( 40, 32) =  0.143677E-01
  PKER_RWETH( 40, 33) =  0.103816E-01
  PKER_RWETH( 40, 34) =  0.898239E-02
  PKER_RWETH( 40, 35) =  0.971795E-02
  PKER_RWETH( 40, 36) =  0.118003E-01
  PKER_RWETH( 40, 37) =  0.144020E-01
  PKER_RWETH( 40, 38) =  0.169513E-01
  PKER_RWETH( 40, 39) =  0.191899E-01
  PKER_RWETH( 40, 40) =  0.210656E-01
END IF
!
END SUBROUTINE READ_XKER_RWETH
