!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$ $Date$
!-----------------------------------------------------------------
!-----------------------------------------------------------------
!     ########################## 
      SUBROUTINE SWITCH_SBG_LES_n
!     ##########################
!
!!****  *SWITCH_SBG_LESn* - moves LES subgrid quantities from modd_les
!!                          to modd_lesn or the contrary.
!!
!!    PURPOSE
!!    -------
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------ 
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!	   V. Masson   *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    June 14, 2002                
!!
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_LES
USE MODD_LES_n
USE MODD_CONF_n
USE MODD_NSV
!
USE MODI_SECOND_MNH
!
IMPLICIT NONE
!
REAL :: ZTIME1, ZTIME2
!-------------------------------------------------------------------------------
!
!*      7.4  interactions of resolved and subgrid quantities
!            -----------------------------------------------
!
CALL SECOND_MNH(ZTIME1)
!
IF (.NOT.   ALLOCATED (X_LES_RES_W_SBG_WThl) ) THEN
!                                                                           ______
  ALLOCATE(X_LES_RES_W_SBG_WThl        (NLES_K,NLES_TIMES,NLES_MASKS))!  <w'w'Thl'>
!                                                                        _____
  ALLOCATE(X_LES_RES_W_SBG_Thl2        (NLES_K,NLES_TIMES,NLES_MASKS))!  <w'Thl'2>
!                                                                              _____
  ALLOCATE(X_LES_RES_ddxa_U_SBG_UaU    (NLES_K,NLES_TIMES,NLES_MASKS))!  <du'/dxa ua'u'>
!                                                                              _____
  ALLOCATE(X_LES_RES_ddxa_V_SBG_UaV    (NLES_K,NLES_TIMES,NLES_MASKS))!  <dv'/dxa ua'v'>
!                                                                              _____
  ALLOCATE(X_LES_RES_ddxa_W_SBG_UaW    (NLES_K,NLES_TIMES,NLES_MASKS))!  <dw'/dxa ua'w'>
!                                                                              _______
  ALLOCATE(X_LES_RES_ddxa_W_SBG_UaThl  (NLES_K,NLES_TIMES,NLES_MASKS))!  <dw'/dxa ua'Thl'>
!                                                                                _____
  ALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaW  (NLES_K,NLES_TIMES,NLES_MASKS))!  <dThl'/dxa ua'w'>
!                                                                                  ___
  ALLOCATE(X_LES_RES_ddz_Thl_SBG_W2    (NLES_K,NLES_TIMES,NLES_MASKS))!  <dThl'/dz w'2>
!                                                                                _______
  ALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaThl(NLES_K,NLES_TIMES,NLES_MASKS))!  <dThl'/dxa ua'Thl'>
!
  IF (LUSERV) THEN
!                                                                          _____
    ALLOCATE(X_LES_RES_W_SBG_WRt         (NLES_K,NLES_TIMES,NLES_MASKS))!  <w'w'Rt'>
!                                                                           ____
    ALLOCATE(X_LES_RES_W_SBG_Rt2         (NLES_K,NLES_TIMES,NLES_MASKS))!  <w'Rt'2>
!                                                                          _______
    ALLOCATE(X_LES_RES_W_SBG_ThlRt       (NLES_K,NLES_TIMES,NLES_MASKS))!  <w'Thl'Rt'>
!                                                                                ______
    ALLOCATE(X_LES_RES_ddxa_W_SBG_UaRt   (NLES_K,NLES_TIMES,NLES_MASKS))!  <dw'/dxa ua'Rt'>
!                                                                                 _____
    ALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaW   (NLES_K,NLES_TIMES,NLES_MASKS))!  <dRt'/dxa ua'w'>
!                                                                                   ___
    ALLOCATE(X_LES_RES_ddz_Rt_SBG_W2     (NLES_K,NLES_TIMES,NLES_MASKS))!  <dRt'/dz w'2>
!                                                                                  ______
    ALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaRt (NLES_K,NLES_TIMES,NLES_MASKS))!  <dThl'/dxa ua'Rt'>
!                                                                                 _______
    ALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaThl (NLES_K,NLES_TIMES,NLES_MASKS))!  <dRt'/dxa ua'Thl'>
!                                                                                  ______
    ALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaRt  (NLES_K,NLES_TIMES,NLES_MASKS)) !  <dRt'/dxa ua'Rt'>
  ELSE
    ALLOCATE(X_LES_RES_W_SBG_WRt         (0,0,0))
    ALLOCATE(X_LES_RES_W_SBG_Rt2         (0,0,0))
    ALLOCATE(X_LES_RES_W_SBG_ThlRt       (0,0,0))
    ALLOCATE(X_LES_RES_ddxa_W_SBG_UaRt   (0,0,0))
    ALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaW   (0,0,0))
    ALLOCATE(X_LES_RES_ddz_Rt_SBG_W2     (0,0,0))
    ALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaRt (0,0,0))
    ALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaThl (0,0,0))
    ALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaRt  (0,0,0))
  END IF
!                                                                                   ______
ALLOCATE(X_LES_RES_ddxa_W_SBG_UaSv (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  !  <dw'/dxa ua'Sv'>
!                                                                                    _____
ALLOCATE(X_LES_RES_ddxa_Sv_SBG_UaW (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  !  <dSv'/dxa ua'w'>
!                                                                                    ___
ALLOCATE(X_LES_RES_ddz_Sv_SBG_W2   (NLES_K,NLES_TIMES,NLES_MASKS,NSV) ) !  <dSv'/dz w'2>
!                                                                                   ______
ALLOCATE(X_LES_RES_ddxa_Sv_SBG_UaSv(NLES_K,NLES_TIMES,NLES_MASKS,NSV))  !  <dSv'/dxa ua'Sv'>
!                                                                             _____
ALLOCATE(X_LES_RES_W_SBG_WSv       (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  !  <w'w'Sv'>
!                                                                             ____
ALLOCATE(X_LES_RES_W_SBG_Sv2       (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  !  <w'Sv'2>
!
!
  X_LES_RES_W_SBG_WThl         = XLES_RES_W_SBG_WThl
  X_LES_RES_W_SBG_Thl2         = XLES_RES_W_SBG_Thl2
  X_LES_RES_ddxa_U_SBG_UaU     = XLES_RES_ddxa_U_SBG_UaU
  X_LES_RES_ddxa_V_SBG_UaV     = XLES_RES_ddxa_V_SBG_UaV
  X_LES_RES_ddxa_W_SBG_UaW     = XLES_RES_ddxa_W_SBG_UaW
  X_LES_RES_ddxa_W_SBG_UaThl   = XLES_RES_ddxa_W_SBG_UaThl
  X_LES_RES_ddxa_Thl_SBG_UaW   = XLES_RES_ddxa_Thl_SBG_UaW
  X_LES_RES_ddz_Thl_SBG_W2     = XLES_RES_ddz_Thl_SBG_W2
  X_LES_RES_ddxa_Thl_SBG_UaThl = XLES_RES_ddxa_Thl_SBG_UaThl
  IF (LUSERV) THEN
    X_LES_RES_W_SBG_WRt        = XLES_RES_W_SBG_WRt
    X_LES_RES_W_SBG_Rt2        = XLES_RES_W_SBG_Rt2
    X_LES_RES_W_SBG_ThlRt      = XLES_RES_W_SBG_ThlRt
    X_LES_RES_ddxa_W_SBG_UaRt  = XLES_RES_ddxa_W_SBG_UaRt
    X_LES_RES_ddxa_Rt_SBG_UaW  = XLES_RES_ddxa_Rt_SBG_UaW
    X_LES_RES_ddz_Rt_SBG_W2    = XLES_RES_ddz_Rt_SBG_W2
    X_LES_RES_ddxa_Thl_SBG_UaRt= XLES_RES_ddxa_Thl_SBG_UaRt
    X_LES_RES_ddxa_Rt_SBG_UaThl= XLES_RES_ddxa_Rt_SBG_UaThl
    X_LES_RES_ddxa_Rt_SBG_UaRt = XLES_RES_ddxa_Rt_SBG_UaRt
  END IF
  IF (NSV>0) THEN
    X_LES_RES_ddxa_W_SBG_UaSv  = XLES_RES_ddxa_W_SBG_UaSv
    X_LES_RES_ddxa_Sv_SBG_UaW  = XLES_RES_ddxa_Sv_SBG_UaW
    X_LES_RES_ddz_Sv_SBG_W2    = XLES_RES_ddz_Sv_SBG_W2
    X_LES_RES_ddxa_Sv_SBG_UaSv = XLES_RES_ddxa_Sv_SBG_UaSv
    X_LES_RES_W_SBG_WSv        = XLES_RES_W_SBG_WSv
    X_LES_RES_W_SBG_Sv2        = XLES_RES_W_SBG_Sv2
  END IF
!
!
  ALLOCATE(X_LES_SUBGRID_U2    (NLES_K,NLES_TIMES,NLES_MASKS))     ! <u'2>
  ALLOCATE(X_LES_SUBGRID_V2    (NLES_K,NLES_TIMES,NLES_MASKS))     ! <v'2>
  ALLOCATE(X_LES_SUBGRID_W2    (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'2>
  ALLOCATE(X_LES_SUBGRID_Thl2  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Thl'2>
  ALLOCATE(X_LES_SUBGRID_UV    (NLES_K,NLES_TIMES,NLES_MASKS))     ! <u'v'>
  ALLOCATE(X_LES_SUBGRID_WU    (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'u'>
  ALLOCATE(X_LES_SUBGRID_WV    (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'v'>
  ALLOCATE(X_LES_SUBGRID_UThl  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <u'Thl'>
  ALLOCATE(X_LES_SUBGRID_VThl  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <v'Thl'>
  ALLOCATE(X_LES_SUBGRID_WThl  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'Thl'>
  ALLOCATE(X_LES_SUBGRID_WThv     (NLES_K,NLES_TIMES,NLES_MASKS))  ! <w'Thv'>
  ALLOCATE(X_LES_SUBGRID_ThlThv   (NLES_K,NLES_TIMES,NLES_MASKS))  ! <Thl'Thv'>
  ALLOCATE(X_LES_SUBGRID_W2Thl    (NLES_K,NLES_TIMES,NLES_MASKS))  ! <w'2Thl>
  ALLOCATE(X_LES_SUBGRID_WThl2    (NLES_K,NLES_TIMES,NLES_MASKS))  ! <w'Thl'2>
  ALLOCATE(X_LES_SUBGRID_DISS_Tke (NLES_K,NLES_TIMES,NLES_MASKS))  ! <epsilon>
  ALLOCATE(X_LES_SUBGRID_DISS_Thl2(NLES_K,NLES_TIMES,NLES_MASKS))  ! <epsilon_Thl2>
  ALLOCATE(X_LES_SUBGRID_WP       (NLES_K,NLES_TIMES,NLES_MASKS))  ! <w'p'>
  ALLOCATE(X_LES_SUBGRID_PHI3     (NLES_K,NLES_TIMES,NLES_MASKS))  !  phi3
  ALLOCATE(X_LES_SUBGRID_LMix     (NLES_K,NLES_TIMES,NLES_MASKS))  !  Lmix
  ALLOCATE(X_LES_SUBGRID_LDiss    (NLES_K,NLES_TIMES,NLES_MASKS))  !  Ldiss
  ALLOCATE(X_LES_SUBGRID_Km       (NLES_K,NLES_TIMES,NLES_MASKS))  !  Km
  ALLOCATE(X_LES_SUBGRID_Kh       (NLES_K,NLES_TIMES,NLES_MASKS))  !  Kh
  ALLOCATE(X_LES_SUBGRID_ThlPz    (NLES_K,NLES_TIMES,NLES_MASKS))  ! <Thl'dp'/dz>
  ALLOCATE(X_LES_SUBGRID_UTke  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <u'Tke>
  ALLOCATE(X_LES_SUBGRID_VTke  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <v'Tke>
  ALLOCATE(X_LES_SUBGRID_WTke  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'Tke>
  ALLOCATE(X_LES_SUBGRID_ddz_WTke  (NLES_K,NLES_TIMES,NLES_MASKS)) ! <dw'Tke/dz>

  ALLOCATE(X_LES_SUBGRID_THLUP_MF(NLES_K,NLES_TIMES,NLES_MASKS))  ! Thl of the Updraft
  ALLOCATE(X_LES_SUBGRID_RTUP_MF (NLES_K,NLES_TIMES,NLES_MASKS))  ! Rt of the Updraft
  ALLOCATE(X_LES_SUBGRID_RVUP_MF (NLES_K,NLES_TIMES,NLES_MASKS))  ! Rv of the Updraft
  ALLOCATE(X_LES_SUBGRID_RCUP_MF (NLES_K,NLES_TIMES,NLES_MASKS))  ! Rc of the Updraft
  ALLOCATE(X_LES_SUBGRID_RIUP_MF (NLES_K,NLES_TIMES,NLES_MASKS))  ! Ri of the Updraft
  ALLOCATE(X_LES_SUBGRID_WUP_MF  (NLES_K,NLES_TIMES,NLES_MASKS))  ! Thl of the Updraft
  ALLOCATE(X_LES_SUBGRID_MASSFLUX(NLES_K,NLES_TIMES,NLES_MASKS))  ! Mass Flux
  ALLOCATE(X_LES_SUBGRID_DETR    (NLES_K,NLES_TIMES,NLES_MASKS))  ! Detrainment
  ALLOCATE(X_LES_SUBGRID_ENTR    (NLES_K,NLES_TIMES,NLES_MASKS))  ! Entrainment
  ALLOCATE(X_LES_SUBGRID_FRACUP  (NLES_K,NLES_TIMES,NLES_MASKS))  ! Updraft Fraction 
  ALLOCATE(X_LES_SUBGRID_THVUP_MF(NLES_K,NLES_TIMES,NLES_MASKS))  ! Thv of the Updraft
  ALLOCATE(X_LES_SUBGRID_WTHLMF  (NLES_K,NLES_TIMES,NLES_MASKS))! Flux of thl   
  ALLOCATE(X_LES_SUBGRID_WRTMF   (NLES_K,NLES_TIMES,NLES_MASKS)) ! Flux of rt
  ALLOCATE(X_LES_SUBGRID_WTHVMF  (NLES_K,NLES_TIMES,NLES_MASKS)) ! Flux of thv 
  ALLOCATE(X_LES_SUBGRID_WUMF    (NLES_K,NLES_TIMES,NLES_MASKS))! Flux of u
  ALLOCATE(X_LES_SUBGRID_WVMF    (NLES_K,NLES_TIMES,NLES_MASKS))! Flux of v
  
  IF (LUSERV ) THEN
    ALLOCATE(X_LES_SUBGRID_Rt2   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Rt'2>
    ALLOCATE(X_LES_SUBGRID_ThlRt (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Thl'Rt'>
    ALLOCATE(X_LES_SUBGRID_URt   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <u'Rt'>
    ALLOCATE(X_LES_SUBGRID_VRt   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <v'Rt'>
    ALLOCATE(X_LES_SUBGRID_WRt   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'Rt'>
    ALLOCATE(X_LES_SUBGRID_RtThv (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Rt'Thv'>
    ALLOCATE(X_LES_SUBGRID_W2Rt  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'2Rt'>
    ALLOCATE(X_LES_SUBGRID_WThlRt(NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'Thl'Rt'>
    ALLOCATE(X_LES_SUBGRID_WRt2  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'Rt'2>
    ALLOCATE(X_LES_SUBGRID_DISS_Rt2 (NLES_K,NLES_TIMES,NLES_MASKS))  ! <epsilon_Rt2>
    ALLOCATE(X_LES_SUBGRID_DISS_ThlRt(NLES_K,NLES_TIMES,NLES_MASKS)) ! <epsilon_ThlRt>
    ALLOCATE(X_LES_SUBGRID_RtPz  (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Rt'dp'/dz>
    ALLOCATE(X_LES_SUBGRID_PSI3  (NLES_K,NLES_TIMES,NLES_MASKS))     !  psi3  
  ELSE
    ALLOCATE(X_LES_SUBGRID_Rt2   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_ThlRt (0,0,0))
    ALLOCATE(X_LES_SUBGRID_URt   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_VRt   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_WRt   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_RtThv (0,0,0))
    ALLOCATE(X_LES_SUBGRID_W2Rt  (0,0,0))
    ALLOCATE(X_LES_SUBGRID_WThlRt(0,0,0))
    ALLOCATE(X_LES_SUBGRID_WRt2  (0,0,0))
    ALLOCATE(X_LES_SUBGRID_DISS_Rt2 (0,0,0))
    ALLOCATE(X_LES_SUBGRID_DISS_ThlRt(0,0,0))
    ALLOCATE(X_LES_SUBGRID_RtPz  (0,0,0))
    ALLOCATE(X_LES_SUBGRID_PSI3  (0,0,0))    
  END IF
  IF (LUSERC ) THEN
    ALLOCATE(X_LES_SUBGRID_Rc2   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Rc'2>
    ALLOCATE(X_LES_SUBGRID_URc   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <u'Rc'>
    ALLOCATE(X_LES_SUBGRID_VRc   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <v'Rc'>
    ALLOCATE(X_LES_SUBGRID_WRc   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <w'Rc'>
  ELSE
    ALLOCATE(X_LES_SUBGRID_Rc2   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_URc   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_VRc   (0,0,0))
    ALLOCATE(X_LES_SUBGRID_WRc   (0,0,0))
  END IF
  IF (LUSERI ) THEN
    ALLOCATE(X_LES_SUBGRID_Ri2   (NLES_K,NLES_TIMES,NLES_MASKS))     ! <Ri'2>
  ELSE
    ALLOCATE(X_LES_SUBGRID_Ri2   (0,0,0))
  END IF
  IF (NSV>0  ) THEN
    ALLOCATE(X_LES_SUBGRID_USv   (NLES_K,NLES_TIMES,NLES_MASKS,NSV)) ! <u'Sv'>
    ALLOCATE(X_LES_SUBGRID_VSv   (NLES_K,NLES_TIMES,NLES_MASKS,NSV)) ! <v'Sv'>
    ALLOCATE(X_LES_SUBGRID_WSv   (NLES_K,NLES_TIMES,NLES_MASKS,NSV)) ! <w'Sv'>
    ALLOCATE(X_LES_SUBGRID_Sv2      (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  ! <Sv'2>
    ALLOCATE(X_LES_SUBGRID_SvThv    (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  ! <Sv'Thv'>
    ALLOCATE(X_LES_SUBGRID_W2Sv     (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  ! <w'2Sv'>
    ALLOCATE(X_LES_SUBGRID_WSv2     (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  ! <w'Sv'2>
    ALLOCATE(X_LES_SUBGRID_DISS_Sv2 (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  ! <epsilon_Sv2>
    ALLOCATE(X_LES_SUBGRID_SvPz     (NLES_K,NLES_TIMES,NLES_MASKS,NSV))  ! <Sv'dp'/dz>
  ELSE
    ALLOCATE(X_LES_SUBGRID_USv   (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_VSv   (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_WSv   (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_Sv2      (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_SvThv    (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_W2Sv     (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_WSv2     (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_DISS_Sv2 (0,0,0,0))
    ALLOCATE(X_LES_SUBGRID_SvPz     (0,0,0,0))
  END IF
!
  X_LES_SUBGRID_U2  = XLES_SUBGRID_U2 
  X_LES_SUBGRID_V2  = XLES_SUBGRID_V2 
  X_LES_SUBGRID_W2  = XLES_SUBGRID_W2 
  X_LES_SUBGRID_Thl2= XLES_SUBGRID_Thl2
  X_LES_SUBGRID_UV  = XLES_SUBGRID_UV 
  X_LES_SUBGRID_WU  = XLES_SUBGRID_WU
  X_LES_SUBGRID_WV  = XLES_SUBGRID_WV
  X_LES_SUBGRID_UThl= XLES_SUBGRID_UThl
  X_LES_SUBGRID_VThl= XLES_SUBGRID_VThl
  X_LES_SUBGRID_WThl= XLES_SUBGRID_WThl
  X_LES_SUBGRID_WThv     = XLES_SUBGRID_WThv
  X_LES_SUBGRID_ThlThv   = XLES_SUBGRID_ThlThv
  X_LES_SUBGRID_W2Thl    = XLES_SUBGRID_W2Thl
  X_LES_SUBGRID_WThl2    = XLES_SUBGRID_WThl2
  X_LES_SUBGRID_DISS_Tke = XLES_SUBGRID_DISS_Tke
  X_LES_SUBGRID_DISS_Thl2= XLES_SUBGRID_DISS_Thl2
  X_LES_SUBGRID_WP       = XLES_SUBGRID_WP
  X_LES_SUBGRID_PHI3     = XLES_SUBGRID_PHI3
  X_LES_SUBGRID_LMix     = XLES_SUBGRID_LMix
  X_LES_SUBGRID_LDiss    = XLES_SUBGRID_LDiss
  X_LES_SUBGRID_Km       = XLES_SUBGRID_Km
  X_LES_SUBGRID_Kh       = XLES_SUBGRID_Kh
  X_LES_SUBGRID_ThlPz    = XLES_SUBGRID_ThlPz
  X_LES_SUBGRID_UTke= XLES_SUBGRID_UTke
  X_LES_SUBGRID_VTke= XLES_SUBGRID_VTke
  X_LES_SUBGRID_WTke= XLES_SUBGRID_WTke
  X_LES_SUBGRID_ddz_WTke  =XLES_SUBGRID_ddz_WTke
  
  X_LES_SUBGRID_THLUP_MF = XLES_SUBGRID_THLUP_MF
  X_LES_SUBGRID_RTUP_MF = XLES_SUBGRID_RTUP_MF 
  X_LES_SUBGRID_RVUP_MF = XLES_SUBGRID_RVUP_MF 
  X_LES_SUBGRID_RCUP_MF = XLES_SUBGRID_RCUP_MF 
  X_LES_SUBGRID_RIUP_MF = XLES_SUBGRID_RIUP_MF 
  X_LES_SUBGRID_WUP_MF = XLES_SUBGRID_WUP_MF  
  X_LES_SUBGRID_MASSFLUX = XLES_SUBGRID_MASSFLUX
  X_LES_SUBGRID_DETR = XLES_SUBGRID_DETR    
  X_LES_SUBGRID_ENTR = XLES_SUBGRID_ENTR    
  X_LES_SUBGRID_FRACUP = XLES_SUBGRID_FRACUP   
  X_LES_SUBGRID_THVUP_MF = XLES_SUBGRID_THVUP_MF
  X_LES_SUBGRID_WTHLMF = XLES_SUBGRID_WTHLMF     
  X_LES_SUBGRID_WRTMF = XLES_SUBGRID_WRTMF   
  X_LES_SUBGRID_WTHVMF = XLES_SUBGRID_WTHVMF   
  X_LES_SUBGRID_WUMF = XLES_SUBGRID_WUMF    
  X_LES_SUBGRID_WVMF = XLES_SUBGRID_WVMF    

  IF (LUSERV ) THEN
    X_LES_SUBGRID_Rt2  = XLES_SUBGRID_Rt2
    X_LES_SUBGRID_ThlRt= XLES_SUBGRID_ThlRt
    X_LES_SUBGRID_URt  = XLES_SUBGRID_URt
    X_LES_SUBGRID_VRt  = XLES_SUBGRID_VRt
    X_LES_SUBGRID_WRt  = XLES_SUBGRID_WRt
    X_LES_SUBGRID_RtThv   = XLES_SUBGRID_RtThv
    X_LES_SUBGRID_W2Rt    = XLES_SUBGRID_W2Rt
    X_LES_SUBGRID_WThlRt  = XLES_SUBGRID_WThlRt
    X_LES_SUBGRID_WRt2    = XLES_SUBGRID_WRt2
    X_LES_SUBGRID_DISS_Rt2= XLES_SUBGRID_DISS_Rt2
    X_LES_SUBGRID_DISS_ThlRt= XLES_SUBGRID_DISS_ThlRt
    X_LES_SUBGRID_RtPz    = XLES_SUBGRID_RtPz
    X_LES_SUBGRID_PSI3    = XLES_SUBGRID_PSI3  
  END IF
  IF (LUSERC ) THEN
    X_LES_SUBGRID_Rc2 = XLES_SUBGRID_Rc2
    X_LES_SUBGRID_URc = XLES_SUBGRID_URc
    X_LES_SUBGRID_VRc = XLES_SUBGRID_VRc
    X_LES_SUBGRID_WRc = XLES_SUBGRID_WRc
  END IF
  IF (LUSERI ) THEN
    X_LES_SUBGRID_Ri2 = XLES_SUBGRID_Ri2
  END IF
  IF (NSV>0  ) THEN
    X_LES_SUBGRID_USv = XLES_SUBGRID_USv
    X_LES_SUBGRID_VSv = XLES_SUBGRID_VSv
    X_LES_SUBGRID_WSv = XLES_SUBGRID_WSv
    X_LES_SUBGRID_Sv2      = XLES_SUBGRID_Sv2 
    X_LES_SUBGRID_SvThv    = XLES_SUBGRID_SvThv
    X_LES_SUBGRID_W2Sv     = XLES_SUBGRID_W2Sv 
    X_LES_SUBGRID_WSv2     = XLES_SUBGRID_WSv2    
    X_LES_SUBGRID_DISS_Sv2 = XLES_SUBGRID_DISS_Sv2 
    X_LES_SUBGRID_SvPz     = XLES_SUBGRID_SvPz  
  END IF
!
!
  ALLOCATE(X_LES_UW0       (NLES_TIMES))
  ALLOCATE(X_LES_VW0       (NLES_TIMES))
  ALLOCATE(X_LES_USTAR     (NLES_TIMES))
  ALLOCATE(X_LES_Q0        (NLES_TIMES))
  ALLOCATE(X_LES_E0        (NLES_TIMES))
  ALLOCATE(X_LES_SV0       (NLES_TIMES,NSV))
!
  X_LES_UW0       = XLES_UW0
  X_LES_VW0       = XLES_VW0
  X_LES_USTAR     = XLES_USTAR
  X_LES_Q0        = XLES_Q0
  X_LES_E0        = XLES_E0
  IF (NSV>0) X_LES_SV0       = XLES_SV0

ELSE
!
  XLES_RES_W_SBG_WThl         = X_LES_RES_W_SBG_WThl
  XLES_RES_W_SBG_Thl2         = X_LES_RES_W_SBG_Thl2
  XLES_RES_ddxa_U_SBG_UaU     = X_LES_RES_ddxa_U_SBG_UaU
  XLES_RES_ddxa_V_SBG_UaV     = X_LES_RES_ddxa_V_SBG_UaV
  XLES_RES_ddxa_W_SBG_UaW     = X_LES_RES_ddxa_W_SBG_UaW
  XLES_RES_ddxa_W_SBG_UaThl   = X_LES_RES_ddxa_W_SBG_UaThl
  XLES_RES_ddxa_Thl_SBG_UaW   = X_LES_RES_ddxa_Thl_SBG_UaW
  XLES_RES_ddz_Thl_SBG_W2     = X_LES_RES_ddz_Thl_SBG_W2
  XLES_RES_ddxa_Thl_SBG_UaThl = X_LES_RES_ddxa_Thl_SBG_UaThl
  IF (LUSERV) THEN
    XLES_RES_W_SBG_WRt        = X_LES_RES_W_SBG_WRt
    XLES_RES_W_SBG_Rt2        = X_LES_RES_W_SBG_Rt2
    XLES_RES_W_SBG_ThlRt      = X_LES_RES_W_SBG_ThlRt
    XLES_RES_ddxa_W_SBG_UaRt  = X_LES_RES_ddxa_W_SBG_UaRt
    XLES_RES_ddxa_Rt_SBG_UaW  = X_LES_RES_ddxa_Rt_SBG_UaW
    XLES_RES_ddz_Rt_SBG_W2    = X_LES_RES_ddz_Rt_SBG_W2
    XLES_RES_ddxa_Thl_SBG_UaRt= X_LES_RES_ddxa_Thl_SBG_UaRt
    XLES_RES_ddxa_Rt_SBG_UaThl= X_LES_RES_ddxa_Rt_SBG_UaThl
    XLES_RES_ddxa_Rt_SBG_UaRt = X_LES_RES_ddxa_Rt_SBG_UaRt
  END IF
  IF (NSV>0) THEN
    XLES_RES_ddxa_W_SBG_UaSv  = X_LES_RES_ddxa_W_SBG_UaSv
    XLES_RES_ddxa_Sv_SBG_UaW  = X_LES_RES_ddxa_Sv_SBG_UaW
    XLES_RES_ddz_Sv_SBG_W2    = X_LES_RES_ddz_Sv_SBG_W2
    XLES_RES_ddxa_Sv_SBG_UaSv = X_LES_RES_ddxa_Sv_SBG_UaSv
    XLES_RES_W_SBG_WSv        = X_LES_RES_W_SBG_WSv
    XLES_RES_W_SBG_Sv2        = X_LES_RES_W_SBG_Sv2
  END IF
  XLES_SUBGRID_U2  = X_LES_SUBGRID_U2 
  XLES_SUBGRID_V2  = X_LES_SUBGRID_V2 
  XLES_SUBGRID_W2  = X_LES_SUBGRID_W2 
  XLES_SUBGRID_Thl2= X_LES_SUBGRID_Thl2
  XLES_SUBGRID_UV  = X_LES_SUBGRID_UV 
  XLES_SUBGRID_WU  = X_LES_SUBGRID_WU
  XLES_SUBGRID_WV  = X_LES_SUBGRID_WV
  XLES_SUBGRID_UThl= X_LES_SUBGRID_UThl
  XLES_SUBGRID_VThl= X_LES_SUBGRID_VThl
  XLES_SUBGRID_WThl= X_LES_SUBGRID_WThl
  XLES_SUBGRID_WThv     = X_LES_SUBGRID_WThv
  XLES_SUBGRID_ThlThv   = X_LES_SUBGRID_ThlThv
  XLES_SUBGRID_W2Thl    = X_LES_SUBGRID_W2Thl
  XLES_SUBGRID_WThl2    = X_LES_SUBGRID_WThl2
  XLES_SUBGRID_DISS_Tke = X_LES_SUBGRID_DISS_Tke
  XLES_SUBGRID_DISS_Thl2= X_LES_SUBGRID_DISS_Thl2
  XLES_SUBGRID_WP       = X_LES_SUBGRID_WP
  XLES_SUBGRID_PHI3     = X_LES_SUBGRID_PHI3
  XLES_SUBGRID_LMix     = X_LES_SUBGRID_LMix
  XLES_SUBGRID_LDiss    = X_LES_SUBGRID_LDiss
  XLES_SUBGRID_Km       = X_LES_SUBGRID_Km
  XLES_SUBGRID_Kh       = X_LES_SUBGRID_Kh
  XLES_SUBGRID_ThlPz    = X_LES_SUBGRID_ThlPz
  XLES_SUBGRID_UTke= X_LES_SUBGRID_UTke
  XLES_SUBGRID_VTke= X_LES_SUBGRID_VTke
  XLES_SUBGRID_WTke= X_LES_SUBGRID_WTke
  XLES_SUBGRID_ddz_WTke  =X_LES_SUBGRID_ddz_WTke

  XLES_SUBGRID_THLUP_MF = X_LES_SUBGRID_THLUP_MF
  XLES_SUBGRID_RTUP_MF = X_LES_SUBGRID_RTUP_MF 
  XLES_SUBGRID_RVUP_MF = X_LES_SUBGRID_RVUP_MF 
  XLES_SUBGRID_RCUP_MF = X_LES_SUBGRID_RCUP_MF 
  XLES_SUBGRID_RIUP_MF = X_LES_SUBGRID_RIUP_MF 
  XLES_SUBGRID_WUP_MF = X_LES_SUBGRID_WUP_MF  
  XLES_SUBGRID_MASSFLUX = X_LES_SUBGRID_MASSFLUX
  XLES_SUBGRID_DETR = X_LES_SUBGRID_DETR    
  XLES_SUBGRID_ENTR = X_LES_SUBGRID_ENTR    
  XLES_SUBGRID_FRACUP = X_LES_SUBGRID_FRACUP   
  XLES_SUBGRID_THVUP_MF = X_LES_SUBGRID_THVUP_MF
  XLES_SUBGRID_WTHLMF = X_LES_SUBGRID_WTHLMF     
  XLES_SUBGRID_WRTMF = X_LES_SUBGRID_WRTMF   
  XLES_SUBGRID_WTHVMF = X_LES_SUBGRID_WTHVMF   
  XLES_SUBGRID_WUMF = X_LES_SUBGRID_WUMF    
  XLES_SUBGRID_WVMF = X_LES_SUBGRID_WVMF    
  
  IF (LUSERV ) THEN
    XLES_SUBGRID_Rt2  = X_LES_SUBGRID_Rt2
    XLES_SUBGRID_ThlRt= X_LES_SUBGRID_ThlRt
    XLES_SUBGRID_URt  = X_LES_SUBGRID_URt
    XLES_SUBGRID_VRt  = X_LES_SUBGRID_VRt
    XLES_SUBGRID_WRt  = X_LES_SUBGRID_WRt
    XLES_SUBGRID_RtThv   = X_LES_SUBGRID_RtThv
    XLES_SUBGRID_W2Rt    = X_LES_SUBGRID_W2Rt
    XLES_SUBGRID_WThlRt  = X_LES_SUBGRID_WThlRt
    XLES_SUBGRID_WRt2    = X_LES_SUBGRID_WRt2
    XLES_SUBGRID_DISS_Rt2= X_LES_SUBGRID_DISS_Rt2
    XLES_SUBGRID_DISS_ThlRt= X_LES_SUBGRID_DISS_ThlRt
    XLES_SUBGRID_RtPz    = X_LES_SUBGRID_RtPz
    XLES_SUBGRID_PSI3    = X_LES_SUBGRID_PSI3
  END IF
  IF (LUSERC ) THEN
    XLES_SUBGRID_Rc2 = X_LES_SUBGRID_Rc2
    XLES_SUBGRID_URc = X_LES_SUBGRID_URc
    XLES_SUBGRID_VRc = X_LES_SUBGRID_VRc
    XLES_SUBGRID_WRc = X_LES_SUBGRID_WRc
  END IF
  IF (LUSERI ) THEN
    XLES_SUBGRID_Ri2 = X_LES_SUBGRID_Ri2
  END IF
  IF (NSV>0  ) THEN
    XLES_SUBGRID_USv = X_LES_SUBGRID_USv
    XLES_SUBGRID_VSv = X_LES_SUBGRID_VSv
    XLES_SUBGRID_WSv = X_LES_SUBGRID_WSv
    XLES_SUBGRID_Sv2      = X_LES_SUBGRID_Sv2 
    XLES_SUBGRID_SvThv    = X_LES_SUBGRID_SvThv
    XLES_SUBGRID_W2Sv     = X_LES_SUBGRID_W2Sv 
    XLES_SUBGRID_WSv2     = X_LES_SUBGRID_WSv2    
    XLES_SUBGRID_DISS_Sv2 = X_LES_SUBGRID_DISS_Sv2 
    XLES_SUBGRID_SvPz     = X_LES_SUBGRID_SvPz  
  END IF
  XLES_UW0       = X_LES_UW0
  XLES_VW0       = X_LES_VW0
  XLES_USTAR     = X_LES_USTAR
  XLES_Q0        = X_LES_Q0
  XLES_E0        = X_LES_E0
  IF (NSV>0) XLES_SV0       = X_LES_SV0
!
  DEALLOCATE(X_LES_RES_W_SBG_WThl        )
  DEALLOCATE(X_LES_RES_W_SBG_Thl2        )
  DEALLOCATE(X_LES_RES_ddxa_U_SBG_UaU    )
  DEALLOCATE(X_LES_RES_ddxa_V_SBG_UaV    )
  DEALLOCATE(X_LES_RES_ddxa_W_SBG_UaW    )
  DEALLOCATE(X_LES_RES_ddxa_W_SBG_UaThl  )
  DEALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaW  )
  DEALLOCATE(X_LES_RES_ddz_Thl_SBG_W2    )
  DEALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaThl)
  DEALLOCATE(X_LES_RES_W_SBG_WRt         )
  DEALLOCATE(X_LES_RES_W_SBG_Rt2         )
  DEALLOCATE(X_LES_RES_W_SBG_ThlRt       )
  DEALLOCATE(X_LES_RES_ddxa_W_SBG_UaRt   )
  DEALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaW   )
  DEALLOCATE(X_LES_RES_ddz_Rt_SBG_W2     )
  DEALLOCATE(X_LES_RES_ddxa_Thl_SBG_UaRt )
  DEALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaThl )
  DEALLOCATE(X_LES_RES_ddxa_Rt_SBG_UaRt  )
  DEALLOCATE(X_LES_RES_ddxa_W_SBG_UaSv   )
  DEALLOCATE(X_LES_RES_ddxa_Sv_SBG_UaW   )
  DEALLOCATE(X_LES_RES_ddz_Sv_SBG_W2     )
  DEALLOCATE(X_LES_RES_ddxa_Sv_SBG_UaSv  )
  DEALLOCATE(X_LES_RES_W_SBG_WSv         )
  DEALLOCATE(X_LES_RES_W_SBG_Sv2         )
!
  DEALLOCATE(X_LES_SUBGRID_U2    )
  DEALLOCATE(X_LES_SUBGRID_V2    )
  DEALLOCATE(X_LES_SUBGRID_W2    )
  DEALLOCATE(X_LES_SUBGRID_Thl2  )
  DEALLOCATE(X_LES_SUBGRID_UV    )
  DEALLOCATE(X_LES_SUBGRID_WU    )
  DEALLOCATE(X_LES_SUBGRID_WV    )
  DEALLOCATE(X_LES_SUBGRID_UThl  )
  DEALLOCATE(X_LES_SUBGRID_VThl  )
  DEALLOCATE(X_LES_SUBGRID_WThl  )
  DEALLOCATE(X_LES_SUBGRID_WThv     )
  DEALLOCATE(X_LES_SUBGRID_ThlThv   )
  DEALLOCATE(X_LES_SUBGRID_W2Thl    )
  DEALLOCATE(X_LES_SUBGRID_WThl2    )
  DEALLOCATE(X_LES_SUBGRID_DISS_Tke )
  DEALLOCATE(X_LES_SUBGRID_DISS_Thl2)
  DEALLOCATE(X_LES_SUBGRID_WP       )
  DEALLOCATE(X_LES_SUBGRID_PHI3     )
  DEALLOCATE(X_LES_SUBGRID_LMix     )
  DEALLOCATE(X_LES_SUBGRID_LDiss    )
  DEALLOCATE(X_LES_SUBGRID_Km       )
  DEALLOCATE(X_LES_SUBGRID_Kh       )
  DEALLOCATE(X_LES_SUBGRID_ThlPz    )
  DEALLOCATE(X_LES_SUBGRID_UTke  )
  DEALLOCATE(X_LES_SUBGRID_VTke  )
  DEALLOCATE(X_LES_SUBGRID_WTke  )
  DEALLOCATE(X_LES_SUBGRID_ddz_WTke  )

  DEALLOCATE(X_LES_SUBGRID_THLUP_MF)  
  DEALLOCATE(X_LES_SUBGRID_RTUP_MF )
  DEALLOCATE(X_LES_SUBGRID_RVUP_MF )
  DEALLOCATE(X_LES_SUBGRID_RCUP_MF )
  DEALLOCATE(X_LES_SUBGRID_RIUP_MF )
  DEALLOCATE(X_LES_SUBGRID_WUP_MF  )
  DEALLOCATE(X_LES_SUBGRID_MASSFLUX)
  DEALLOCATE(X_LES_SUBGRID_DETR    )
  DEALLOCATE(X_LES_SUBGRID_ENTR    )
  DEALLOCATE(X_LES_SUBGRID_FRACUP  )
  DEALLOCATE(X_LES_SUBGRID_THVUP_MF)
  DEALLOCATE(X_LES_SUBGRID_WTHLMF  )  
  DEALLOCATE(X_LES_SUBGRID_WRTMF   )
  DEALLOCATE(X_LES_SUBGRID_WTHVMF  )
  DEALLOCATE(X_LES_SUBGRID_WUMF    )
  DEALLOCATE(X_LES_SUBGRID_WVMF    )
  
  DEALLOCATE(X_LES_SUBGRID_Rt2   )
  DEALLOCATE(X_LES_SUBGRID_ThlRt )
  DEALLOCATE(X_LES_SUBGRID_URt   )
  DEALLOCATE(X_LES_SUBGRID_VRt   )
  DEALLOCATE(X_LES_SUBGRID_WRt   )
  DEALLOCATE(X_LES_SUBGRID_RtThv )
  DEALLOCATE(X_LES_SUBGRID_W2Rt  )
  DEALLOCATE(X_LES_SUBGRID_WThlRt)
  DEALLOCATE(X_LES_SUBGRID_WRt2  )
  DEALLOCATE(X_LES_SUBGRID_DISS_Rt2 )
  DEALLOCATE(X_LES_SUBGRID_DISS_ThlRt )
  DEALLOCATE(X_LES_SUBGRID_RtPz  )
  DEALLOCATE(X_LES_SUBGRID_PSI3  )
  DEALLOCATE(X_LES_SUBGRID_Rc2   )
  DEALLOCATE(X_LES_SUBGRID_URc   )
  DEALLOCATE(X_LES_SUBGRID_VRc   )
  DEALLOCATE(X_LES_SUBGRID_WRc   )
  DEALLOCATE(X_LES_SUBGRID_Ri2   )
  DEALLOCATE(X_LES_SUBGRID_USv   )
  DEALLOCATE(X_LES_SUBGRID_VSv   )
  DEALLOCATE(X_LES_SUBGRID_WSv   )
  DEALLOCATE(X_LES_SUBGRID_Sv2      )
  DEALLOCATE(X_LES_SUBGRID_SvThv    )
  DEALLOCATE(X_LES_SUBGRID_W2Sv     )
  DEALLOCATE(X_LES_SUBGRID_WSv2     )
  DEALLOCATE(X_LES_SUBGRID_DISS_Sv2 )
  DEALLOCATE(X_LES_SUBGRID_SvPz     )
  !
  DEALLOCATE(X_LES_UW0       )
  DEALLOCATE(X_LES_VW0       )
  DEALLOCATE(X_LES_USTAR     )
  DEALLOCATE(X_LES_Q0        )
  DEALLOCATE(X_LES_E0        )
  DEALLOCATE(X_LES_SV0       )
!
END IF
!
CALL SECOND_MNH(ZTIME2)
!
XTIME_LES = XTIME_LES + ZTIME2 - ZTIME1
!
END SUBROUTINE SWITCH_SBG_LES_n
