!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! ECMWF_RAD1_MODIF_IDRIS 2003/02/19 13:36:33
!-----------------------------------------------------------------
!OCL SCALAR
SUBROUTINE RRTM_KGB3_C

!     Originally by Eli J. Mlawer, Atmospheric & Environmental Research.
!     BAND 3:  500-630 cm-1 (low - H2O,CO2; high - H2O,CO2)
!     Reformatted for F90 by JJMorcrette, ECMWF

!     ------------------------------------------------------------------

!*    kindef: define default KIND macros
! --------------------------------------


USE PARKIND1, ONLY :&
 &JPIT, JPIS, JPIM, JPIB,&
 &JPRT, JPRS, JPRM, JPRB

















































! --------------------------------------


USE OYOERRTO3 , ONLY : KAO     ,KBO     ,SELFREFO   ,FRACREFAO  ,&
           &FRACREFBO  ,FORREFO    ,ABSN2OAO   ,ABSN2OBO
USE OYOERRTA3 , ONLY : ABSN2OA ,ABSN2OB  ,ETAREF    ,H2OREF     ,&
           &N2OREF     ,CO2REF     ,STRRAT

!     ------------------------------------------------------------------


IMPLICIT NONE

!!!JDJDJD
! Chargement du tableau KAO dans RRTM_KGB3_A
!CALL RRTM_KGB3_A
! Chargement du debut du tableau KBO dans RRTM_KGB3_B
!CALL RRTM_KGB3_B
! Chargement du reste dans RRTM_KGB3
!!!JDJDJD

!     The array KBO contains absorption coefs for each of the 16 g-intervals
!     for a range of pressure levels  < ~100mb, temperatures, and ratios
!     of H2O to CO2.  The first index in the array, JS, runs from 1 to 5, 
!     and corresponds to different H2O to CO2 ratios, as expressed through 
!     the binary species parameter eta, defined as eta = H2O/(H2O+RAT*CO2), 
!     where RAT is the ratio of the integrated line strength in the band 
!     of CO2 to that of H2O.  For instance, JS=1 refers to no H2O, 
!     JS = 2 corresponds to eta = 0.25, etc.  The second index, JT, which
!     runs from 1 to 5, corresponds to different temperatures.  More 
!     specifically, JT = 3 means that the data are for the corresponding 
!     reference temperature TREF for this  pressure level, JT = 2 refers 
!     to the TREF-15, JT = 1 is for TREF-30, JT = 4 is for TREF+15, and
!     JT = 5 is for TREF+30.  The third index, JP, runs from 13 to 59 and
!     refers to the corresponding pressure level in PREF (e.g. JP = 13 is
!     for a pressure of 95.5835 mb).  The fourth index, IG, goes from 1 to
!     16, and tells us which g-interval the absorption coefficients are for.

KBO( :, 1,13, 9) = (/&
&6.2749E-02_JPRB,7.2855E-02_JPRB,6.7478E-02_JPRB,5.3345E-02_JPRB,4.4699E-01_JPRB/)
KBO( :, 2,13, 9) = (/&
&8.6319E-02_JPRB,1.0135E-01_JPRB,9.4230E-02_JPRB,7.4640E-02_JPRB,4.8102E-01_JPRB/)
KBO( :, 3,13, 9) = (/&
&1.1531E-01_JPRB,1.3583E-01_JPRB,1.2671E-01_JPRB,1.0042E-01_JPRB,5.1621E-01_JPRB/)
KBO( :, 4,13, 9) = (/&
&1.4981E-01_JPRB,1.7650E-01_JPRB,1.6480E-01_JPRB,1.3078E-01_JPRB,5.5243E-01_JPRB/)
KBO( :, 5,13, 9) = (/&
&1.8970E-01_JPRB,2.2347E-01_JPRB,2.0865E-01_JPRB,1.6587E-01_JPRB,5.8937E-01_JPRB/)
KBO( :, 1,14, 9) = (/&
&5.7187E-02_JPRB,6.7301E-02_JPRB,6.2129E-02_JPRB,4.9110E-02_JPRB,3.7769E-01_JPRB/)
KBO( :, 2,14, 9) = (/&
&7.8466E-02_JPRB,9.3270E-02_JPRB,8.6445E-02_JPRB,6.8459E-02_JPRB,4.0753E-01_JPRB/)
KBO( :, 3,14, 9) = (/&
&1.0467E-01_JPRB,1.2476E-01_JPRB,1.1574E-01_JPRB,9.1819E-02_JPRB,4.3868E-01_JPRB/)
KBO( :, 4,14, 9) = (/&
&1.3581E-01_JPRB,1.6192E-01_JPRB,1.5034E-01_JPRB,1.1930E-01_JPRB,4.7064E-01_JPRB/)
KBO( :, 5,14, 9) = (/&
&1.7224E-01_JPRB,2.0464E-01_JPRB,1.9021E-01_JPRB,1.5110E-01_JPRB,5.0408E-01_JPRB/)
KBO( :, 1,15, 9) = (/&
&5.1721E-02_JPRB,6.1566E-02_JPRB,5.6680E-02_JPRB,4.4751E-02_JPRB,2.9568E-01_JPRB/)
KBO( :, 2,15, 9) = (/&
&7.0936E-02_JPRB,8.5115E-02_JPRB,7.8492E-02_JPRB,6.2182E-02_JPRB,3.2213E-01_JPRB/)
KBO( :, 3,15, 9) = (/&
&9.4515E-02_JPRB,1.1370E-01_JPRB,1.0486E-01_JPRB,8.3182E-02_JPRB,3.4986E-01_JPRB/)
KBO( :, 4,15, 9) = (/&
&1.2289E-01_JPRB,1.4728E-01_JPRB,1.3607E-01_JPRB,1.0790E-01_JPRB,3.7853E-01_JPRB/)
KBO( :, 5,15, 9) = (/&
&1.5637E-01_JPRB,1.8627E-01_JPRB,1.7195E-01_JPRB,1.3626E-01_JPRB,4.0894E-01_JPRB/)
KBO( :, 1,16, 9) = (/&
&4.6578E-02_JPRB,5.5911E-02_JPRB,5.1274E-02_JPRB,4.0416E-02_JPRB,2.2673E-01_JPRB/)
KBO( :, 2,16, 9) = (/&
&6.3866E-02_JPRB,7.7158E-02_JPRB,7.0810E-02_JPRB,5.5944E-02_JPRB,2.5071E-01_JPRB/)
KBO( :, 3,16, 9) = (/&
&8.5294E-02_JPRB,1.0285E-01_JPRB,9.4463E-02_JPRB,7.4731E-02_JPRB,2.7559E-01_JPRB/)
KBO( :, 4,16, 9) = (/&
&1.1126E-01_JPRB,1.3331E-01_JPRB,1.2237E-01_JPRB,9.6725E-02_JPRB,3.0207E-01_JPRB/)
KBO( :, 5,16, 9) = (/&
&1.4207E-01_JPRB,1.6889E-01_JPRB,1.5467E-01_JPRB,1.2182E-01_JPRB,3.3015E-01_JPRB/)
KBO( :, 1,17, 9) = (/&
&4.1900E-02_JPRB,5.0464E-02_JPRB,4.6053E-02_JPRB,3.6179E-02_JPRB,1.8226E-01_JPRB/)
KBO( :, 2,17, 9) = (/&
&5.7522E-02_JPRB,6.9444E-02_JPRB,6.3472E-02_JPRB,4.9973E-02_JPRB,2.0447E-01_JPRB/)
KBO( :, 3,17, 9) = (/&
&7.7026E-02_JPRB,9.2538E-02_JPRB,8.4551E-02_JPRB,6.6605E-02_JPRB,2.2810E-01_JPRB/)
KBO( :, 4,17, 9) = (/&
&1.0079E-01_JPRB,1.2017E-01_JPRB,1.0955E-01_JPRB,8.5985E-02_JPRB,2.5342E-01_JPRB/)
KBO( :, 5,17, 9) = (/&
&1.2927E-01_JPRB,1.5258E-01_JPRB,1.3846E-01_JPRB,1.0816E-01_JPRB,2.7946E-01_JPRB/)
KBO( :, 1,18, 9) = (/&
&3.7891E-02_JPRB,4.5454E-02_JPRB,4.1197E-02_JPRB,3.2260E-02_JPRB,1.5403E-01_JPRB/)
KBO( :, 2,18, 9) = (/&
&5.2057E-02_JPRB,6.2358E-02_JPRB,5.6644E-02_JPRB,4.4449E-02_JPRB,1.7502E-01_JPRB/)
KBO( :, 3,18, 9) = (/&
&6.9815E-02_JPRB,8.3160E-02_JPRB,7.5488E-02_JPRB,5.9051E-02_JPRB,1.9748E-01_JPRB/)
KBO( :, 4,18, 9) = (/&
&9.1668E-02_JPRB,1.0819E-01_JPRB,9.7824E-02_JPRB,7.6130E-02_JPRB,2.2105E-01_JPRB/)
KBO( :, 5,18, 9) = (/&
&1.1799E-01_JPRB,1.3770E-01_JPRB,1.2371E-01_JPRB,9.5780E-02_JPRB,2.4525E-01_JPRB/)
KBO( :, 1,19, 9) = (/&
&3.4441E-02_JPRB,4.0854E-02_JPRB,3.6785E-02_JPRB,2.8648E-02_JPRB,1.3592E-01_JPRB/)
KBO( :, 2,19, 9) = (/&
&4.7310E-02_JPRB,5.6014E-02_JPRB,5.0505E-02_JPRB,3.9333E-02_JPRB,1.5599E-01_JPRB/)
KBO( :, 3,19, 9) = (/&
&6.3559E-02_JPRB,7.4763E-02_JPRB,6.7291E-02_JPRB,5.2149E-02_JPRB,1.7738E-01_JPRB/)
KBO( :, 4,19, 9) = (/&
&8.3699E-02_JPRB,9.7466E-02_JPRB,8.7225E-02_JPRB,6.7250E-02_JPRB,1.9960E-01_JPRB/)
KBO( :, 5,19, 9) = (/&
&1.0809E-01_JPRB,1.2436E-01_JPRB,1.1051E-01_JPRB,8.4704E-02_JPRB,2.2240E-01_JPRB/)
KBO( :, 1,20, 9) = (/&
&3.1662E-02_JPRB,3.7011E-02_JPRB,3.3064E-02_JPRB,2.5535E-02_JPRB,1.2166E-01_JPRB/)
KBO( :, 2,20, 9) = (/&
&4.3462E-02_JPRB,5.0683E-02_JPRB,4.5312E-02_JPRB,3.4918E-02_JPRB,1.4050E-01_JPRB/)
KBO( :, 3,20, 9) = (/&
&5.8468E-02_JPRB,6.7693E-02_JPRB,6.0291E-02_JPRB,4.6251E-02_JPRB,1.6041E-01_JPRB/)
KBO( :, 4,20, 9) = (/&
&7.7082E-02_JPRB,8.8368E-02_JPRB,7.8218E-02_JPRB,5.9632E-02_JPRB,1.8092E-01_JPRB/)
KBO( :, 5,20, 9) = (/&
&9.9590E-02_JPRB,1.1296E-01_JPRB,9.9282E-02_JPRB,7.5236E-02_JPRB,2.0180E-01_JPRB/)
KBO( :, 1,21, 9) = (/&
&2.9197E-02_JPRB,3.3644E-02_JPRB,2.9800E-02_JPRB,2.2751E-02_JPRB,1.0840E-01_JPRB/)
KBO( :, 2,21, 9) = (/&
&4.0061E-02_JPRB,4.6022E-02_JPRB,4.0720E-02_JPRB,3.1025E-02_JPRB,1.2575E-01_JPRB/)
KBO( :, 3,21, 9) = (/&
&5.3879E-02_JPRB,6.1513E-02_JPRB,5.4145E-02_JPRB,4.1071E-02_JPRB,1.4377E-01_JPRB/)
KBO( :, 4,21, 9) = (/&
&7.1035E-02_JPRB,8.0368E-02_JPRB,7.0344E-02_JPRB,5.2993E-02_JPRB,1.6228E-01_JPRB/)
KBO( :, 5,21, 9) = (/&
&9.1717E-02_JPRB,1.0275E-01_JPRB,8.9495E-02_JPRB,6.6978E-02_JPRB,1.8109E-01_JPRB/)
KBO( :, 1,22, 9) = (/&
&2.7499E-02_JPRB,3.1251E-02_JPRB,2.7449E-02_JPRB,2.0717E-02_JPRB,9.5123E-02_JPRB/)
KBO( :, 2,22, 9) = (/&
&3.7657E-02_JPRB,4.2715E-02_JPRB,3.7381E-02_JPRB,2.8145E-02_JPRB,1.1043E-01_JPRB/)
KBO( :, 3,22, 9) = (/&
&5.0562E-02_JPRB,5.6977E-02_JPRB,4.9664E-02_JPRB,3.7184E-02_JPRB,1.2615E-01_JPRB/)
KBO( :, 4,22, 9) = (/&
&6.6397E-02_JPRB,7.4321E-02_JPRB,6.4486E-02_JPRB,4.7986E-02_JPRB,1.4210E-01_JPRB/)
KBO( :, 5,22, 9) = (/&
&8.5266E-02_JPRB,9.4958E-02_JPRB,8.2045E-02_JPRB,6.0712E-02_JPRB,1.5827E-01_JPRB/)
KBO( :, 1,23, 9) = (/&
&2.5951E-02_JPRB,2.9125E-02_JPRB,2.5330E-02_JPRB,1.8934E-02_JPRB,8.2353E-02_JPRB/)
KBO( :, 2,23, 9) = (/&
&3.5455E-02_JPRB,3.9694E-02_JPRB,3.4441E-02_JPRB,2.5641E-02_JPRB,9.5317E-02_JPRB/)
KBO( :, 3,23, 9) = (/&
&4.7331E-02_JPRB,5.2838E-02_JPRB,4.5688E-02_JPRB,3.3836E-02_JPRB,1.0857E-01_JPRB/)
KBO( :, 4,23, 9) = (/&
&6.1763E-02_JPRB,6.8758E-02_JPRB,5.9284E-02_JPRB,4.3652E-02_JPRB,1.2209E-01_JPRB/)
KBO( :, 5,23, 9) = (/&
&7.8933E-02_JPRB,8.7537E-02_JPRB,7.5364E-02_JPRB,5.5173E-02_JPRB,1.3590E-01_JPRB/)
KBO( :, 1,24, 9) = (/&
&2.4473E-02_JPRB,2.7169E-02_JPRB,2.3444E-02_JPRB,1.7363E-02_JPRB,6.9430E-02_JPRB/)
KBO( :, 2,24, 9) = (/&
&3.3250E-02_JPRB,3.6936E-02_JPRB,3.1810E-02_JPRB,2.3462E-02_JPRB,8.0157E-02_JPRB/)
KBO( :, 3,24, 9) = (/&
&4.4117E-02_JPRB,4.8975E-02_JPRB,4.2123E-02_JPRB,3.0921E-02_JPRB,9.1223E-02_JPRB/)
KBO( :, 4,24, 9) = (/&
&5.7285E-02_JPRB,6.3439E-02_JPRB,5.4524E-02_JPRB,3.9854E-02_JPRB,1.0266E-01_JPRB/)
KBO( :, 5,24, 9) = (/&
&7.2998E-02_JPRB,8.0524E-02_JPRB,6.9109E-02_JPRB,5.0332E-02_JPRB,1.1441E-01_JPRB/)
KBO( :, 1,25, 9) = (/&
&2.3088E-02_JPRB,2.5438E-02_JPRB,2.1801E-02_JPRB,1.6002E-02_JPRB,5.7837E-02_JPRB/)
KBO( :, 2,25, 9) = (/&
&3.1174E-02_JPRB,3.4396E-02_JPRB,2.9493E-02_JPRB,2.1569E-02_JPRB,6.6784E-02_JPRB/)
KBO( :, 3,25, 9) = (/&
&4.1147E-02_JPRB,4.5360E-02_JPRB,3.8891E-02_JPRB,2.8375E-02_JPRB,7.6101E-02_JPRB/)
KBO( :, 4,25, 9) = (/&
&5.3244E-02_JPRB,5.8521E-02_JPRB,5.0118E-02_JPRB,3.6473E-02_JPRB,8.5758E-02_JPRB/)
KBO( :, 5,25, 9) = (/&
&6.7659E-02_JPRB,7.4121E-02_JPRB,6.3317E-02_JPRB,4.5953E-02_JPRB,9.5693E-02_JPRB/)
KBO( :, 1,26, 9) = (/&
&2.1853E-02_JPRB,2.3928E-02_JPRB,2.0426E-02_JPRB,1.4853E-02_JPRB,4.8392E-02_JPRB/)
KBO( :, 2,26, 9) = (/&
&2.9360E-02_JPRB,3.2138E-02_JPRB,2.7449E-02_JPRB,1.9958E-02_JPRB,5.5916E-02_JPRB/)
KBO( :, 3,26, 9) = (/&
&3.8590E-02_JPRB,4.2170E-02_JPRB,3.5993E-02_JPRB,2.6138E-02_JPRB,6.3792E-02_JPRB/)
KBO( :, 4,26, 9) = (/&
&4.9775E-02_JPRB,5.4242E-02_JPRB,4.6206E-02_JPRB,3.3463E-02_JPRB,7.1975E-02_JPRB/)
KBO( :, 5,26, 9) = (/&
&6.3079E-02_JPRB,6.8549E-02_JPRB,5.8245E-02_JPRB,4.2044E-02_JPRB,8.0448E-02_JPRB/)
KBO( :, 1,27, 9) = (/&
&2.0589E-02_JPRB,2.2432E-02_JPRB,1.9091E-02_JPRB,1.3798E-02_JPRB,3.9711E-02_JPRB/)
KBO( :, 2,27, 9) = (/&
&2.7577E-02_JPRB,2.9992E-02_JPRB,2.5499E-02_JPRB,1.8441E-02_JPRB,4.5946E-02_JPRB/)
KBO( :, 3,27, 9) = (/&
&3.6163E-02_JPRB,3.9222E-02_JPRB,3.3292E-02_JPRB,2.4027E-02_JPRB,5.2514E-02_JPRB/)
KBO( :, 4,27, 9) = (/&
&4.6525E-02_JPRB,5.0331E-02_JPRB,4.2630E-02_JPRB,3.0669E-02_JPRB,5.9354E-02_JPRB/)
KBO( :, 5,27, 9) = (/&
&5.8822E-02_JPRB,6.3502E-02_JPRB,5.3650E-02_JPRB,3.8505E-02_JPRB,6.6468E-02_JPRB/)
KBO( :, 1,28, 9) = (/&
&1.9320E-02_JPRB,2.0975E-02_JPRB,1.7795E-02_JPRB,1.2791E-02_JPRB,3.1912E-02_JPRB/)
KBO( :, 2,28, 9) = (/&
&2.5855E-02_JPRB,2.7959E-02_JPRB,2.3678E-02_JPRB,1.7000E-02_JPRB,3.7011E-02_JPRB/)
KBO( :, 3,28, 9) = (/&
&3.3864E-02_JPRB,3.6500E-02_JPRB,3.0839E-02_JPRB,2.2082E-02_JPRB,4.2382E-02_JPRB/)
KBO( :, 4,28, 9) = (/&
&4.3478E-02_JPRB,4.6764E-02_JPRB,3.9410E-02_JPRB,2.8143E-02_JPRB,4.8009E-02_JPRB/)
KBO( :, 5,28, 9) = (/&
&5.4874E-02_JPRB,5.8907E-02_JPRB,4.9537E-02_JPRB,3.5320E-02_JPRB,5.3947E-02_JPRB/)
KBO( :, 1,29, 9) = (/&
&1.8123E-02_JPRB,1.9628E-02_JPRB,1.6597E-02_JPRB,1.1861E-02_JPRB,2.5423E-02_JPRB/)
KBO( :, 2,29, 9) = (/&
&2.4225E-02_JPRB,2.6121E-02_JPRB,2.2032E-02_JPRB,1.5699E-02_JPRB,2.9542E-02_JPRB/)
KBO( :, 3,29, 9) = (/&
&3.1700E-02_JPRB,3.4031E-02_JPRB,2.8639E-02_JPRB,2.0345E-02_JPRB,3.3911E-02_JPRB/)
KBO( :, 4,29, 9) = (/&
&4.0663E-02_JPRB,4.3529E-02_JPRB,3.6544E-02_JPRB,2.5917E-02_JPRB,3.8545E-02_JPRB/)
KBO( :, 5,29, 9) = (/&
&5.1268E-02_JPRB,5.4769E-02_JPRB,4.5895E-02_JPRB,3.2522E-02_JPRB,4.3488E-02_JPRB/)
KBO( :, 1,30, 9) = (/&
&1.6958E-02_JPRB,1.8364E-02_JPRB,1.5479E-02_JPRB,1.0998E-02_JPRB,1.9951E-02_JPRB/)
KBO( :, 2,30, 9) = (/&
&2.2671E-02_JPRB,2.4409E-02_JPRB,2.0518E-02_JPRB,1.4521E-02_JPRB,2.3241E-02_JPRB/)
KBO( :, 3,30, 9) = (/&
&2.9641E-02_JPRB,3.1772E-02_JPRB,2.6628E-02_JPRB,1.8795E-02_JPRB,2.6766E-02_JPRB/)
KBO( :, 4,30, 9) = (/&
&3.8012E-02_JPRB,4.0581E-02_JPRB,3.3943E-02_JPRB,2.3935E-02_JPRB,3.0561E-02_JPRB/)
KBO( :, 5,30, 9) = (/&
&4.7908E-02_JPRB,5.1031E-02_JPRB,4.2627E-02_JPRB,3.0033E-02_JPRB,3.4653E-02_JPRB/)
KBO( :, 1,31, 9) = (/&
&1.5875E-02_JPRB,1.7181E-02_JPRB,1.4459E-02_JPRB,1.0211E-02_JPRB,1.5400E-02_JPRB/)
KBO( :, 2,31, 9) = (/&
&2.1201E-02_JPRB,2.2826E-02_JPRB,1.9139E-02_JPRB,1.3463E-02_JPRB,1.8009E-02_JPRB/)
KBO( :, 3,31, 9) = (/&
&2.7703E-02_JPRB,2.9694E-02_JPRB,2.4816E-02_JPRB,1.7421E-02_JPRB,2.0837E-02_JPRB/)
KBO( :, 4,31, 9) = (/&
&3.5538E-02_JPRB,3.7926E-02_JPRB,3.1623E-02_JPRB,2.2179E-02_JPRB,2.3914E-02_JPRB/)
KBO( :, 5,31, 9) = (/&
&4.4824E-02_JPRB,4.7692E-02_JPRB,3.9738E-02_JPRB,2.7844E-02_JPRB,2.7277E-02_JPRB/)
KBO( :, 1,32, 9) = (/&
&1.4881E-02_JPRB,1.6116E-02_JPRB,1.3532E-02_JPRB,9.5127E-03_JPRB,1.1925E-02_JPRB/)
KBO( :, 2,32, 9) = (/&
&1.9865E-02_JPRB,2.1395E-02_JPRB,1.7905E-02_JPRB,1.2529E-02_JPRB,1.4004E-02_JPRB/)
KBO( :, 3,32, 9) = (/&
&2.5959E-02_JPRB,2.7823E-02_JPRB,2.3208E-02_JPRB,1.6206E-02_JPRB,1.6285E-02_JPRB/)
KBO( :, 4,32, 9) = (/&
&3.3313E-02_JPRB,3.5564E-02_JPRB,2.9600E-02_JPRB,2.0639E-02_JPRB,1.8807E-02_JPRB/)
KBO( :, 5,32, 9) = (/&
&4.2060E-02_JPRB,4.4782E-02_JPRB,3.7223E-02_JPRB,2.5926E-02_JPRB,2.1578E-02_JPRB/)
KBO( :, 1,33, 9) = (/&
&1.3967E-02_JPRB,1.5144E-02_JPRB,1.2690E-02_JPRB,8.8844E-03_JPRB,9.2074E-03_JPRB/)
KBO( :, 2,33, 9) = (/&
&1.8640E-02_JPRB,2.0097E-02_JPRB,1.6785E-02_JPRB,1.1705E-02_JPRB,1.0873E-02_JPRB/)
KBO( :, 3,33, 9) = (/&
&2.4387E-02_JPRB,2.6153E-02_JPRB,2.1778E-02_JPRB,1.5136E-02_JPRB,1.2726E-02_JPRB/)
KBO( :, 4,33, 9) = (/&
&3.1327E-02_JPRB,3.3471E-02_JPRB,2.7814E-02_JPRB,1.9292E-02_JPRB,1.4787E-02_JPRB/)
KBO( :, 5,33, 9) = (/&
&3.9572E-02_JPRB,4.2221E-02_JPRB,3.5044E-02_JPRB,2.4264E-02_JPRB,1.7080E-02_JPRB/)
KBO( :, 1,34, 9) = (/&
&1.3038E-02_JPRB,1.4154E-02_JPRB,1.1832E-02_JPRB,8.2492E-03_JPRB,7.3647E-03_JPRB/)
KBO( :, 2,34, 9) = (/&
&1.7420E-02_JPRB,1.8798E-02_JPRB,1.5659E-02_JPRB,1.0876E-02_JPRB,8.7412E-03_JPRB/)
KBO( :, 3,34, 9) = (/&
&2.2825E-02_JPRB,2.4500E-02_JPRB,2.0360E-02_JPRB,1.4089E-02_JPRB,1.0289E-02_JPRB/)
KBO( :, 4,34, 9) = (/&
&2.9360E-02_JPRB,3.1418E-02_JPRB,2.6065E-02_JPRB,1.7978E-02_JPRB,1.2027E-02_JPRB/)
KBO( :, 5,34, 9) = (/&
&3.7137E-02_JPRB,3.9713E-02_JPRB,3.2919E-02_JPRB,2.2661E-02_JPRB,1.3976E-02_JPRB/)
KBO( :, 1,35, 9) = (/&
&1.1851E-02_JPRB,1.2890E-02_JPRB,1.0761E-02_JPRB,7.4718E-03_JPRB,5.7550E-03_JPRB/)
KBO( :, 2,35, 9) = (/&
&1.5900E-02_JPRB,1.7182E-02_JPRB,1.4286E-02_JPRB,9.8834E-03_JPRB,6.8791E-03_JPRB/)
KBO( :, 3,35, 9) = (/&
&2.0897E-02_JPRB,2.2486E-02_JPRB,1.8648E-02_JPRB,1.2848E-02_JPRB,8.1522E-03_JPRB/)
KBO( :, 4,35, 9) = (/&
&2.6965E-02_JPRB,2.8940E-02_JPRB,2.3971E-02_JPRB,1.6457E-02_JPRB,9.5922E-03_JPRB/)
KBO( :, 5,35, 9) = (/&
&3.4238E-02_JPRB,3.6722E-02_JPRB,3.0385E-02_JPRB,2.0819E-02_JPRB,1.1216E-02_JPRB/)
KBO( :, 1,36, 9) = (/&
&1.0455E-02_JPRB,1.1397E-02_JPRB,9.5033E-03_JPRB,6.5755E-03_JPRB,4.3571E-03_JPRB/)
KBO( :, 2,36, 9) = (/&
&1.4117E-02_JPRB,1.5290E-02_JPRB,1.2699E-02_JPRB,8.7484E-03_JPRB,5.2508E-03_JPRB/)
KBO( :, 3,36, 9) = (/&
&1.8658E-02_JPRB,2.0138E-02_JPRB,1.6673E-02_JPRB,1.1439E-02_JPRB,6.2734E-03_JPRB/)
KBO( :, 4,36, 9) = (/&
&2.4204E-02_JPRB,2.6071E-02_JPRB,2.1551E-02_JPRB,1.4738E-02_JPRB,7.4336E-03_JPRB/)
KBO( :, 5,36, 9) = (/&
&3.0898E-02_JPRB,3.3263E-02_JPRB,2.7471E-02_JPRB,1.8745E-02_JPRB,8.7508E-03_JPRB/)
KBO( :, 1,37, 9) = (/&
&8.8498E-03_JPRB,9.6657E-03_JPRB,8.0482E-03_JPRB,5.5507E-03_JPRB,3.4394E-03_JPRB/)
KBO( :, 2,37, 9) = (/&
&1.2053E-02_JPRB,1.3088E-02_JPRB,1.0850E-02_JPRB,7.4463E-03_JPRB,4.1756E-03_JPRB/)
KBO( :, 3,37, 9) = (/&
&1.6053E-02_JPRB,1.7380E-02_JPRB,1.4373E-02_JPRB,9.8197E-03_JPRB,5.0255E-03_JPRB/)
KBO( :, 4,37, 9) = (/&
&2.0992E-02_JPRB,2.2697E-02_JPRB,1.8723E-02_JPRB,1.2754E-02_JPRB,5.9977E-03_JPRB/)
KBO( :, 5,37, 9) = (/&
&2.6999E-02_JPRB,2.9182E-02_JPRB,2.4048E-02_JPRB,1.6341E-02_JPRB,7.1081E-03_JPRB/)
KBO( :, 1,38, 9) = (/&
&7.4680E-03_JPRB,8.1793E-03_JPRB,6.8001E-03_JPRB,4.6741E-03_JPRB,2.7036E-03_JPRB/)
KBO( :, 2,38, 9) = (/&
&1.0268E-02_JPRB,1.1184E-02_JPRB,9.2546E-03_JPRB,6.3288E-03_JPRB,3.3094E-03_JPRB/)
KBO( :, 3,38, 9) = (/&
&1.3799E-02_JPRB,1.4987E-02_JPRB,1.2370E-02_JPRB,8.4204E-03_JPRB,4.0136E-03_JPRB/)
KBO( :, 4,38, 9) = (/&
&1.8189E-02_JPRB,1.9741E-02_JPRB,1.6260E-02_JPRB,1.1031E-02_JPRB,4.8267E-03_JPRB/)
KBO( :, 5,38, 9) = (/&
&2.3579E-02_JPRB,2.5605E-02_JPRB,2.1052E-02_JPRB,1.4244E-02_JPRB,5.7626E-03_JPRB/)
KBO( :, 1,39, 9) = (/&
&6.2942E-03_JPRB,6.9249E-03_JPRB,5.7460E-03_JPRB,3.9360E-03_JPRB,2.1044E-03_JPRB/)
KBO( :, 2,39, 9) = (/&
&8.7432E-03_JPRB,9.5663E-03_JPRB,7.9000E-03_JPRB,5.3823E-03_JPRB,2.5994E-03_JPRB/)
KBO( :, 3,39, 9) = (/&
&1.1864E-02_JPRB,1.2937E-02_JPRB,1.0660E-02_JPRB,7.2304E-03_JPRB,3.1792E-03_JPRB/)
KBO( :, 4,39, 9) = (/&
&1.5781E-02_JPRB,1.7197E-02_JPRB,1.4145E-02_JPRB,9.5554E-03_JPRB,3.8556E-03_JPRB/)
KBO( :, 5,39, 9) = (/&
&2.0624E-02_JPRB,2.2512E-02_JPRB,1.8470E-02_JPRB,1.2443E-02_JPRB,4.6381E-03_JPRB/)
KBO( :, 1,40, 9) = (/&
&5.1375E-03_JPRB,5.6803E-03_JPRB,4.7069E-03_JPRB,3.2115E-03_JPRB,1.6578E-03_JPRB/)
KBO( :, 2,40, 9) = (/&
&7.2291E-03_JPRB,7.9459E-03_JPRB,6.5495E-03_JPRB,4.4441E-03_JPRB,2.0666E-03_JPRB/)
KBO( :, 3,40, 9) = (/&
&9.9296E-03_JPRB,1.0871E-02_JPRB,8.9384E-03_JPRB,6.0392E-03_JPRB,2.5498E-03_JPRB/)
KBO( :, 4,40, 9) = (/&
&1.3354E-02_JPRB,1.4603E-02_JPRB,1.1989E-02_JPRB,8.0664E-03_JPRB,3.1172E-03_JPRB/)
KBO( :, 5,40, 9) = (/&
&1.7630E-02_JPRB,1.9320E-02_JPRB,1.5819E-02_JPRB,1.0610E-02_JPRB,3.7783E-03_JPRB/)
KBO( :, 1,41, 9) = (/&
&4.1669E-03_JPRB,4.6307E-03_JPRB,3.8311E-03_JPRB,2.6055E-03_JPRB,1.3022E-03_JPRB/)
KBO( :, 2,41, 9) = (/&
&5.9450E-03_JPRB,6.5654E-03_JPRB,5.4031E-03_JPRB,3.6497E-03_JPRB,1.6387E-03_JPRB/)
KBO( :, 3,41, 9) = (/&
&8.2702E-03_JPRB,9.0939E-03_JPRB,7.4627E-03_JPRB,5.0204E-03_JPRB,2.0406E-03_JPRB/)
KBO( :, 4,41, 9) = (/&
&1.1254E-02_JPRB,1.2358E-02_JPRB,1.0124E-02_JPRB,6.7836E-03_JPRB,2.5160E-03_JPRB/)
KBO( :, 5,41, 9) = (/&
&1.5021E-02_JPRB,1.6526E-02_JPRB,1.3505E-02_JPRB,9.0170E-03_JPRB,3.0745E-03_JPRB/)
KBO( :, 1,42, 9) = (/&
&3.3673E-03_JPRB,3.7618E-03_JPRB,3.1084E-03_JPRB,2.1093E-03_JPRB,1.0159E-03_JPRB/)
KBO( :, 2,42, 9) = (/&
&4.8758E-03_JPRB,5.4116E-03_JPRB,4.4469E-03_JPRB,2.9930E-03_JPRB,1.2910E-03_JPRB/)
KBO( :, 3,42, 9) = (/&
&6.8765E-03_JPRB,7.5957E-03_JPRB,6.2240E-03_JPRB,4.1675E-03_JPRB,1.6231E-03_JPRB/)
KBO( :, 4,42, 9) = (/&
&9.4703E-03_JPRB,1.0449E-02_JPRB,8.5426E-03_JPRB,5.6988E-03_JPRB,2.0195E-03_JPRB/)
KBO( :, 5,42, 9) = (/&
&1.2789E-02_JPRB,1.4133E-02_JPRB,1.1527E-02_JPRB,7.6610E-03_JPRB,2.4891E-03_JPRB/)
KBO( :, 1,43, 9) = (/&
&2.6545E-03_JPRB,2.9817E-03_JPRB,2.4611E-03_JPRB,1.6672E-03_JPRB,7.8914E-04_JPRB/)
KBO( :, 2,43, 9) = (/&
&3.9072E-03_JPRB,4.3601E-03_JPRB,3.5785E-03_JPRB,2.4026E-03_JPRB,1.0130E-03_JPRB/)
KBO( :, 3,43, 9) = (/&
&5.5970E-03_JPRB,6.2146E-03_JPRB,5.0833E-03_JPRB,3.3914E-03_JPRB,1.2871E-03_JPRB/)
KBO( :, 4,43, 9) = (/&
&7.8170E-03_JPRB,8.6680E-03_JPRB,7.0728E-03_JPRB,4.6984E-03_JPRB,1.6175E-03_JPRB/)
KBO( :, 5,43, 9) = (/&
&1.0695E-02_JPRB,1.1876E-02_JPRB,9.6670E-03_JPRB,6.3964E-03_JPRB,2.0136E-03_JPRB/)
KBO( :, 1,44, 9) = (/&
&2.0599E-03_JPRB,2.3264E-03_JPRB,1.9189E-03_JPRB,1.2982E-03_JPRB,6.1043E-04_JPRB/)
KBO( :, 2,44, 9) = (/&
&3.0865E-03_JPRB,3.4632E-03_JPRB,2.8398E-03_JPRB,1.9029E-03_JPRB,7.9160E-04_JPRB/)
KBO( :, 3,44, 9) = (/&
&4.4945E-03_JPRB,5.0200E-03_JPRB,4.1009E-03_JPRB,2.7282E-03_JPRB,1.0166E-03_JPRB/)
KBO( :, 4,44, 9) = (/&
&6.3771E-03_JPRB,7.1092E-03_JPRB,5.7918E-03_JPRB,3.8324E-03_JPRB,1.2916E-03_JPRB/)
KBO( :, 5,44, 9) = (/&
&8.8507E-03_JPRB,9.8816E-03_JPRB,8.0271E-03_JPRB,5.2885E-03_JPRB,1.6254E-03_JPRB/)
KBO( :, 1,45, 9) = (/&
&1.5883E-03_JPRB,1.8029E-03_JPRB,1.4862E-03_JPRB,1.0041E-03_JPRB,4.6915E-04_JPRB/)
KBO( :, 2,45, 9) = (/&
&2.4237E-03_JPRB,2.7348E-03_JPRB,2.2402E-03_JPRB,1.4983E-03_JPRB,6.1463E-04_JPRB/)
KBO( :, 3,45, 9) = (/&
&3.5915E-03_JPRB,4.0353E-03_JPRB,3.2920E-03_JPRB,2.1847E-03_JPRB,7.9813E-04_JPRB/)
KBO( :, 4,45, 9) = (/&
&5.1787E-03_JPRB,5.8074E-03_JPRB,4.7242E-03_JPRB,3.1158E-03_JPRB,1.0255E-03_JPRB/)
KBO( :, 5,45, 9) = (/&
&7.2977E-03_JPRB,8.1949E-03_JPRB,6.6455E-03_JPRB,4.3597E-03_JPRB,1.3052E-03_JPRB/)
KBO( :, 1,46, 9) = (/&
&1.2050E-03_JPRB,1.3752E-03_JPRB,1.1327E-03_JPRB,7.6415E-04_JPRB,3.5825E-04_JPRB/)
KBO( :, 2,46, 9) = (/&
&1.8745E-03_JPRB,2.1271E-03_JPRB,1.7406E-03_JPRB,1.1623E-03_JPRB,4.7455E-04_JPRB/)
KBO( :, 3,46, 9) = (/&
&2.8292E-03_JPRB,3.1990E-03_JPRB,2.6058E-03_JPRB,1.7261E-03_JPRB,6.2280E-04_JPRB/)
KBO( :, 4,46, 9) = (/&
&4.1523E-03_JPRB,4.6867E-03_JPRB,3.8068E-03_JPRB,2.5043E-03_JPRB,8.0997E-04_JPRB/)
KBO( :, 5,46, 9) = (/&
&5.9484E-03_JPRB,6.7211E-03_JPRB,5.4412E-03_JPRB,3.5566E-03_JPRB,1.0425E-03_JPRB/)
KBO( :, 1,47, 9) = (/&
&8.9059E-04_JPRB,1.0221E-03_JPRB,8.4076E-04_JPRB,5.6652E-04_JPRB,2.7270E-04_JPRB/)
KBO( :, 2,47, 9) = (/&
&1.4154E-03_JPRB,1.6142E-03_JPRB,1.3191E-03_JPRB,8.8003E-04_JPRB,3.6578E-04_JPRB/)
KBO( :, 3,47, 9) = (/&
&2.1790E-03_JPRB,2.4785E-03_JPRB,2.0162E-03_JPRB,1.3331E-03_JPRB,4.8487E-04_JPRB/)
KBO( :, 4,47, 9) = (/&
&3.2603E-03_JPRB,3.7035E-03_JPRB,3.0033E-03_JPRB,1.9711E-03_JPRB,6.3790E-04_JPRB/)
KBO( :, 5,47, 9) = (/&
&4.7543E-03_JPRB,5.4065E-03_JPRB,4.3698E-03_JPRB,2.8478E-03_JPRB,8.3079E-04_JPRB/)
KBO( :, 1,48, 9) = (/&
&6.5137E-04_JPRB,7.5160E-04_JPRB,6.1768E-04_JPRB,4.1559E-04_JPRB,2.0605E-04_JPRB/)
KBO( :, 2,48, 9) = (/&
&1.0584E-03_JPRB,1.2128E-03_JPRB,9.8996E-04_JPRB,6.6009E-04_JPRB,2.8014E-04_JPRB/)
KBO( :, 3,48, 9) = (/&
&1.6631E-03_JPRB,1.9026E-03_JPRB,1.5461E-03_JPRB,1.0205E-03_JPRB,3.7581E-04_JPRB/)
KBO( :, 4,48, 9) = (/&
&2.5384E-03_JPRB,2.9025E-03_JPRB,2.3504E-03_JPRB,1.5394E-03_JPRB,4.9967E-04_JPRB/)
KBO( :, 5,48, 9) = (/&
&3.7716E-03_JPRB,4.3191E-03_JPRB,3.4853E-03_JPRB,2.2659E-03_JPRB,6.5826E-04_JPRB/)
KBO( :, 1,49, 9) = (/&
&4.7074E-04_JPRB,5.4614E-04_JPRB,4.4842E-04_JPRB,3.0149E-04_JPRB,1.5387E-04_JPRB/)
KBO( :, 2,49, 9) = (/&
&7.8312E-04_JPRB,9.0147E-04_JPRB,7.3522E-04_JPRB,4.8971E-04_JPRB,2.1293E-04_JPRB/)
KBO( :, 3,49, 9) = (/&
&1.2566E-03_JPRB,1.4457E-03_JPRB,1.1738E-03_JPRB,7.7341E-04_JPRB,2.8949E-04_JPRB/)
KBO( :, 4,49, 9) = (/&
&1.9577E-03_JPRB,2.2532E-03_JPRB,1.8228E-03_JPRB,1.1917E-03_JPRB,3.8929E-04_JPRB/)
KBO( :, 5,49, 9) = (/&
&2.9665E-03_JPRB,3.4229E-03_JPRB,2.7586E-03_JPRB,1.7902E-03_JPRB,5.1846E-04_JPRB/)
KBO( :, 1,50, 9) = (/&
&3.4213E-04_JPRB,3.9935E-04_JPRB,3.2746E-04_JPRB,2.1988E-04_JPRB,1.1674E-04_JPRB/)
KBO( :, 2,50, 9) = (/&
&5.8343E-04_JPRB,6.7437E-04_JPRB,5.4936E-04_JPRB,3.6511E-04_JPRB,1.6480E-04_JPRB/)
KBO( :, 3,50, 9) = (/&
&9.5650E-04_JPRB,1.1046E-03_JPRB,8.9539E-04_JPRB,5.8873E-04_JPRB,2.2733E-04_JPRB/)
KBO( :, 4,50, 9) = (/&
&1.5196E-03_JPRB,1.7582E-03_JPRB,1.4207E-03_JPRB,9.2622E-04_JPRB,3.0916E-04_JPRB/)
KBO( :, 5,50, 9) = (/&
&2.3472E-03_JPRB,2.7261E-03_JPRB,2.1933E-03_JPRB,1.4203E-03_JPRB,4.1592E-04_JPRB/)
KBO( :, 1,51, 9) = (/&
&2.4775E-04_JPRB,2.9121E-04_JPRB,2.3870E-04_JPRB,1.5996E-04_JPRB,8.8877E-05_JPRB/)
KBO( :, 2,51, 9) = (/&
&4.3433E-04_JPRB,5.0395E-04_JPRB,4.0996E-04_JPRB,2.7183E-04_JPRB,1.2827E-04_JPRB/)
KBO( :, 3,51, 9) = (/&
&7.2809E-04_JPRB,8.4314E-04_JPRB,6.8222E-04_JPRB,4.4757E-04_JPRB,1.8017E-04_JPRB/)
KBO( :, 4,51, 9) = (/&
&1.1797E-03_JPRB,1.3708E-03_JPRB,1.1057E-03_JPRB,7.1871E-04_JPRB,2.4785E-04_JPRB/)
KBO( :, 5,51, 9) = (/&
&1.8569E-03_JPRB,2.1693E-03_JPRB,1.7420E-03_JPRB,1.1250E-03_JPRB,3.3679E-04_JPRB/)
KBO( :, 1,52, 9) = (/&
&1.7722E-04_JPRB,2.0977E-04_JPRB,1.7188E-04_JPRB,1.1517E-04_JPRB,6.6934E-05_JPRB/)
KBO( :, 2,52, 9) = (/&
&3.1988E-04_JPRB,3.7329E-04_JPRB,3.0314E-04_JPRB,2.0061E-04_JPRB,9.9021E-05_JPRB/)
KBO( :, 3,52, 9) = (/&
&5.4977E-04_JPRB,6.3853E-04_JPRB,5.1539E-04_JPRB,3.3762E-04_JPRB,1.4208E-04_JPRB/)
KBO( :, 4,52, 9) = (/&
&9.0908E-04_JPRB,1.0602E-03_JPRB,8.5370E-04_JPRB,5.5342E-04_JPRB,1.9834E-04_JPRB/)
KBO( :, 5,52, 9) = (/&
&1.4584E-03_JPRB,1.7130E-03_JPRB,1.3740E-03_JPRB,8.8469E-04_JPRB,2.7257E-04_JPRB/)
KBO( :, 1,53, 9) = (/&
&1.2486E-04_JPRB,1.4876E-04_JPRB,1.2192E-04_JPRB,8.1756E-05_JPRB,4.9810E-05_JPRB/)
KBO( :, 2,53, 9) = (/&
&2.3236E-04_JPRB,2.7326E-04_JPRB,2.2175E-04_JPRB,1.4647E-04_JPRB,7.5549E-05_JPRB/)
KBO( :, 3,53, 9) = (/&
&4.1092E-04_JPRB,4.7878E-04_JPRB,3.8566E-04_JPRB,2.5219E-04_JPRB,1.1108E-04_JPRB/)
KBO( :, 4,53, 9) = (/&
&6.9449E-04_JPRB,8.1233E-04_JPRB,6.5288E-04_JPRB,4.2235E-04_JPRB,1.5818E-04_JPRB/)
KBO( :, 5,53, 9) = (/&
&1.1362E-03_JPRB,1.3415E-03_JPRB,1.0746E-03_JPRB,6.9016E-04_JPRB,2.1993E-04_JPRB/)
KBO( :, 1,54, 9) = (/&
&8.9225E-05_JPRB,1.0698E-04_JPRB,8.7651E-05_JPRB,5.8813E-05_JPRB,3.8030E-05_JPRB/)
KBO( :, 2,54, 9) = (/&
&1.7137E-04_JPRB,2.0293E-04_JPRB,1.6456E-04_JPRB,1.0850E-04_JPRB,5.9001E-05_JPRB/)
KBO( :, 3,54, 9) = (/&
&3.1189E-04_JPRB,3.6460E-04_JPRB,2.9303E-04_JPRB,1.9101E-04_JPRB,8.8833E-05_JPRB/)
KBO( :, 4,54, 9) = (/&
&5.3932E-04_JPRB,6.3180E-04_JPRB,5.0597E-04_JPRB,3.2631E-04_JPRB,1.2913E-04_JPRB/)
KBO( :, 5,54, 9) = (/&
&8.9911E-04_JPRB,1.0637E-03_JPRB,8.5017E-04_JPRB,5.4403E-04_JPRB,1.8204E-04_JPRB/)
KBO( :, 1,55, 9) = (/&
&6.3909E-05_JPRB,7.7058E-05_JPRB,6.3103E-05_JPRB,4.2365E-05_JPRB,2.9408E-05_JPRB/)
KBO( :, 2,55, 9) = (/&
&1.2694E-04_JPRB,1.5118E-04_JPRB,1.2247E-04_JPRB,8.0640E-05_JPRB,4.6546E-05_JPRB/)
KBO( :, 3,55, 9) = (/&
&2.3779E-04_JPRB,2.7922E-04_JPRB,2.2392E-04_JPRB,1.4533E-04_JPRB,7.1755E-05_JPRB/)
KBO( :, 4,55, 9) = (/&
&4.2152E-04_JPRB,4.9417E-04_JPRB,3.9420E-04_JPRB,2.5317E-04_JPRB,1.0664E-04_JPRB/)
KBO( :, 5,55, 9) = (/&
&7.1633E-04_JPRB,8.4754E-04_JPRB,6.7522E-04_JPRB,4.3025E-04_JPRB,1.5287E-04_JPRB/)
KBO( :, 1,56, 9) = (/&
&4.5238E-05_JPRB,5.4873E-05_JPRB,4.4919E-05_JPRB,3.0179E-05_JPRB,2.2620E-05_JPRB/)
KBO( :, 2,56, 9) = (/&
&9.3046E-05_JPRB,1.1152E-04_JPRB,9.0251E-05_JPRB,5.9375E-05_JPRB,3.6523E-05_JPRB/)
KBO( :, 3,56, 9) = (/&
&1.7973E-04_JPRB,2.1224E-04_JPRB,1.6993E-04_JPRB,1.0998E-04_JPRB,5.7678E-05_JPRB/)
KBO( :, 4,56, 9) = (/&
&3.2753E-04_JPRB,3.8449E-04_JPRB,3.0571E-04_JPRB,1.9550E-04_JPRB,8.7776E-05_JPRB/)
KBO( :, 5,56, 9) = (/&
&5.6860E-04_JPRB,6.7252E-04_JPRB,5.3373E-04_JPRB,3.3864E-04_JPRB,1.2833E-04_JPRB/)
KBO( :, 1,57, 9) = (/&
&3.1565E-05_JPRB,3.8561E-05_JPRB,3.1572E-05_JPRB,2.1236E-05_JPRB,1.7319E-05_JPRB/)
KBO( :, 2,57, 9) = (/&
&6.7437E-05_JPRB,8.1368E-05_JPRB,6.5785E-05_JPRB,4.3278E-05_JPRB,2.8513E-05_JPRB/)
KBO( :, 3,57, 9) = (/&
&1.3453E-04_JPRB,1.5983E-04_JPRB,1.2788E-04_JPRB,8.2634E-05_JPRB,4.6105E-05_JPRB/)
KBO( :, 4,57, 9) = (/&
&2.5265E-04_JPRB,2.9731E-04_JPRB,2.3573E-04_JPRB,1.5020E-04_JPRB,7.1946E-05_JPRB/)
KBO( :, 5,57, 9) = (/&
&4.4894E-04_JPRB,5.3119E-04_JPRB,4.1979E-04_JPRB,2.6517E-04_JPRB,1.0766E-04_JPRB/)
KBO( :, 1,58, 9) = (/&
&2.2075E-05_JPRB,2.7134E-05_JPRB,2.2226E-05_JPRB,1.4971E-05_JPRB,1.3364E-05_JPRB/)
KBO( :, 2,58, 9) = (/&
&4.8978E-05_JPRB,5.9454E-05_JPRB,4.8051E-05_JPRB,3.1593E-05_JPRB,2.2406E-05_JPRB/)
KBO( :, 3,58, 9) = (/&
&1.0101E-04_JPRB,1.2083E-04_JPRB,9.6543E-05_JPRB,6.2301E-05_JPRB,3.7078E-05_JPRB/)
KBO( :, 4,58, 9) = (/&
&1.9559E-04_JPRB,2.3110E-04_JPRB,1.8274E-04_JPRB,1.1601E-04_JPRB,5.9357E-05_JPRB/)
KBO( :, 5,58, 9) = (/&
&3.5639E-04_JPRB,4.2210E-04_JPRB,3.3215E-04_JPRB,2.0879E-04_JPRB,9.0999E-05_JPRB/)
KBO( :, 1,59, 9) = (/&
&1.8162E-05_JPRB,2.2362E-05_JPRB,1.8260E-05_JPRB,1.2253E-05_JPRB,1.1708E-05_JPRB/)
KBO( :, 2,59, 9) = (/&
&4.1323E-05_JPRB,5.0285E-05_JPRB,4.0483E-05_JPRB,2.6494E-05_JPRB,1.9897E-05_JPRB/)
KBO( :, 3,59, 9) = (/&
&8.7123E-05_JPRB,1.0455E-04_JPRB,8.3213E-05_JPRB,5.3390E-05_JPRB,3.3400E-05_JPRB/)
KBO( :, 4,59, 9) = (/&
&1.7214E-04_JPRB,2.0391E-04_JPRB,1.6047E-04_JPRB,1.0123E-04_JPRB,5.4263E-05_JPRB/)
KBO( :, 5,59, 9) = (/&
&3.1897E-04_JPRB,3.7825E-04_JPRB,2.9606E-04_JPRB,1.8480E-04_JPRB,8.4393E-05_JPRB/)
KBO( :, 1,13,10) = (/&
&2.7341E-01_JPRB,2.7526E-01_JPRB,2.5183E-01_JPRB,1.9261E-01_JPRB,1.4210E+00_JPRB/)
KBO( :, 2,13,10) = (/&
&3.8641E-01_JPRB,3.8931E-01_JPRB,3.5500E-01_JPRB,2.7363E-01_JPRB,1.5250E+00_JPRB/)
KBO( :, 3,13,10) = (/&
&5.2101E-01_JPRB,5.2751E-01_JPRB,4.7841E-01_JPRB,3.7012E-01_JPRB,1.6242E+00_JPRB/)
KBO( :, 4,13,10) = (/&
&6.7807E-01_JPRB,6.8631E-01_JPRB,6.2447E-01_JPRB,4.8162E-01_JPRB,1.7236E+00_JPRB/)
KBO( :, 5,13,10) = (/&
&8.5732E-01_JPRB,8.6502E-01_JPRB,7.8632E-01_JPRB,6.0788E-01_JPRB,1.8353E+00_JPRB/)
KBO( :, 1,14,10) = (/&
&2.6100E-01_JPRB,2.7217E-01_JPRB,2.4857E-01_JPRB,1.9099E-01_JPRB,1.3096E+00_JPRB/)
KBO( :, 2,14,10) = (/&
&3.6662E-01_JPRB,3.8321E-01_JPRB,3.4838E-01_JPRB,2.6817E-01_JPRB,1.4048E+00_JPRB/)
KBO( :, 3,14,10) = (/&
&4.9302E-01_JPRB,5.1421E-01_JPRB,4.6962E-01_JPRB,3.6021E-01_JPRB,1.4986E+00_JPRB/)
KBO( :, 4,14,10) = (/&
&6.4068E-01_JPRB,6.6503E-01_JPRB,6.0806E-01_JPRB,4.6655E-01_JPRB,1.6008E+00_JPRB/)
KBO( :, 5,14,10) = (/&
&8.0594E-01_JPRB,8.3870E-01_JPRB,7.6286E-01_JPRB,5.8739E-01_JPRB,1.6996E+00_JPRB/)
KBO( :, 1,15,10) = (/&
&2.4538E-01_JPRB,2.6450E-01_JPRB,2.4065E-01_JPRB,1.8544E-01_JPRB,1.0991E+00_JPRB/)
KBO( :, 2,15,10) = (/&
&3.4290E-01_JPRB,3.6880E-01_JPRB,3.3714E-01_JPRB,2.5768E-01_JPRB,1.1807E+00_JPRB/)
KBO( :, 3,15,10) = (/&
&4.6008E-01_JPRB,4.9212E-01_JPRB,4.5111E-01_JPRB,3.4351E-01_JPRB,1.2655E+00_JPRB/)
KBO( :, 4,15,10) = (/&
&5.9510E-01_JPRB,6.3591E-01_JPRB,5.8042E-01_JPRB,4.4347E-01_JPRB,1.3538E+00_JPRB/)
KBO( :, 5,15,10) = (/&
&7.4431E-01_JPRB,7.9818E-01_JPRB,7.2810E-01_JPRB,5.5870E-01_JPRB,1.4415E+00_JPRB/)
KBO( :, 1,16,10) = (/&
&2.2814E-01_JPRB,2.5112E-01_JPRB,2.2894E-01_JPRB,1.7604E-01_JPRB,8.6918E-01_JPRB/)
KBO( :, 2,16,10) = (/&
&3.1740E-01_JPRB,3.4815E-01_JPRB,3.1813E-01_JPRB,2.4321E-01_JPRB,9.3794E-01_JPRB/)
KBO( :, 3,16,10) = (/&
&4.2406E-01_JPRB,4.6410E-01_JPRB,4.2260E-01_JPRB,3.2211E-01_JPRB,1.0122E+00_JPRB/)
KBO( :, 4,16,10) = (/&
&5.4520E-01_JPRB,5.9870E-01_JPRB,5.4328E-01_JPRB,4.1424E-01_JPRB,1.0849E+00_JPRB/)
KBO( :, 5,16,10) = (/&
&6.8053E-01_JPRB,7.4608E-01_JPRB,6.8074E-01_JPRB,5.2205E-01_JPRB,1.1616E+00_JPRB/)
KBO( :, 1,17,10) = (/&
&2.0942E-01_JPRB,2.3428E-01_JPRB,2.1300E-01_JPRB,1.6357E-01_JPRB,6.8856E-01_JPRB/)
KBO( :, 2,17,10) = (/&
&2.9028E-01_JPRB,3.2402E-01_JPRB,2.9334E-01_JPRB,2.2459E-01_JPRB,7.5316E-01_JPRB/)
KBO( :, 3,17,10) = (/&
&3.8521E-01_JPRB,4.3154E-01_JPRB,3.8848E-01_JPRB,2.9660E-01_JPRB,8.1712E-01_JPRB/)
KBO( :, 4,17,10) = (/&
&4.9386E-01_JPRB,5.5280E-01_JPRB,4.9908E-01_JPRB,3.8197E-01_JPRB,8.8331E-01_JPRB/)
KBO( :, 5,17,10) = (/&
&6.1488E-01_JPRB,6.8821E-01_JPRB,6.2452E-01_JPRB,4.7879E-01_JPRB,9.5857E-01_JPRB/)
KBO( :, 1,18,10) = (/&
&1.9063E-01_JPRB,2.1561E-01_JPRB,1.9503E-01_JPRB,1.4897E-01_JPRB,5.8262E-01_JPRB/)
KBO( :, 2,18,10) = (/&
&2.6234E-01_JPRB,2.9815E-01_JPRB,2.6727E-01_JPRB,2.0340E-01_JPRB,6.4437E-01_JPRB/)
KBO( :, 3,18,10) = (/&
&3.4666E-01_JPRB,3.9448E-01_JPRB,3.5278E-01_JPRB,2.6945E-01_JPRB,7.0773E-01_JPRB/)
KBO( :, 4,18,10) = (/&
&4.4310E-01_JPRB,5.0370E-01_JPRB,4.5197E-01_JPRB,3.4624E-01_JPRB,7.7610E-01_JPRB/)
KBO( :, 5,18,10) = (/&
&5.4979E-01_JPRB,6.2640E-01_JPRB,5.6607E-01_JPRB,4.3269E-01_JPRB,8.4498E-01_JPRB/)
KBO( :, 1,19,10) = (/&
&1.7161E-01_JPRB,1.9659E-01_JPRB,1.7592E-01_JPRB,1.3400E-01_JPRB,5.2315E-01_JPRB/)
KBO( :, 2,19,10) = (/&
&2.3489E-01_JPRB,2.7003E-01_JPRB,2.4068E-01_JPRB,1.8320E-01_JPRB,5.8488E-01_JPRB/)
KBO( :, 3,19,10) = (/&
&3.0942E-01_JPRB,3.5576E-01_JPRB,3.1712E-01_JPRB,2.4210E-01_JPRB,6.4789E-01_JPRB/)
KBO( :, 4,19,10) = (/&
&3.9389E-01_JPRB,4.5374E-01_JPRB,4.0629E-01_JPRB,3.0999E-01_JPRB,7.1351E-01_JPRB/)
KBO( :, 5,19,10) = (/&
&4.8891E-01_JPRB,5.6402E-01_JPRB,5.0679E-01_JPRB,3.8613E-01_JPRB,7.7670E-01_JPRB/)
KBO( :, 1,20,10) = (/&
&1.5436E-01_JPRB,1.7849E-01_JPRB,1.5835E-01_JPRB,1.2054E-01_JPRB,4.8122E-01_JPRB/)
KBO( :, 2,20,10) = (/&
&2.1037E-01_JPRB,2.4329E-01_JPRB,2.1594E-01_JPRB,1.6475E-01_JPRB,5.4083E-01_JPRB/)
KBO( :, 3,20,10) = (/&
&2.7588E-01_JPRB,3.1923E-01_JPRB,2.8475E-01_JPRB,2.1683E-01_JPRB,6.0229E-01_JPRB/)
KBO( :, 4,20,10) = (/&
&3.5179E-01_JPRB,4.0673E-01_JPRB,3.6356E-01_JPRB,2.7647E-01_JPRB,6.6389E-01_JPRB/)
KBO( :, 5,20,10) = (/&
&4.3944E-01_JPRB,5.0591E-01_JPRB,4.5161E-01_JPRB,3.4309E-01_JPRB,7.2588E-01_JPRB/)
KBO( :, 1,21,10) = (/&
&1.3931E-01_JPRB,1.6061E-01_JPRB,1.4210E-01_JPRB,1.0800E-01_JPRB,4.4082E-01_JPRB/)
KBO( :, 2,21,10) = (/&
&1.8903E-01_JPRB,2.1792E-01_JPRB,1.9361E-01_JPRB,1.4691E-01_JPRB,4.9685E-01_JPRB/)
KBO( :, 3,21,10) = (/&
&2.4836E-01_JPRB,2.8494E-01_JPRB,2.5423E-01_JPRB,1.9232E-01_JPRB,5.5604E-01_JPRB/)
KBO( :, 4,21,10) = (/&
&3.1855E-01_JPRB,3.6313E-01_JPRB,3.2325E-01_JPRB,2.4463E-01_JPRB,6.1543E-01_JPRB/)
KBO( :, 5,21,10) = (/&
&4.0034E-01_JPRB,4.5346E-01_JPRB,4.0071E-01_JPRB,3.0346E-01_JPRB,6.7562E-01_JPRB/)
KBO( :, 1,22,10) = (/&
&1.2853E-01_JPRB,1.4730E-01_JPRB,1.3012E-01_JPRB,9.8419E-02_JPRB,3.9506E-01_JPRB/)
KBO( :, 2,22,10) = (/&
&1.7432E-01_JPRB,1.9857E-01_JPRB,1.7621E-01_JPRB,1.3274E-01_JPRB,4.4910E-01_JPRB/)
KBO( :, 3,22,10) = (/&
&2.3012E-01_JPRB,2.5984E-01_JPRB,2.2960E-01_JPRB,1.7295E-01_JPRB,5.0505E-01_JPRB/)
KBO( :, 4,22,10) = (/&
&2.9716E-01_JPRB,3.3163E-01_JPRB,2.9126E-01_JPRB,2.1891E-01_JPRB,5.6304E-01_JPRB/)
KBO( :, 5,22,10) = (/&
&3.7733E-01_JPRB,4.1497E-01_JPRB,3.6137E-01_JPRB,2.7093E-01_JPRB,6.2241E-01_JPRB/)
KBO( :, 1,23,10) = (/&
&1.1881E-01_JPRB,1.3545E-01_JPRB,1.1944E-01_JPRB,8.9244E-02_JPRB,3.5223E-01_JPRB/)
KBO( :, 2,23,10) = (/&
&1.6173E-01_JPRB,1.8250E-01_JPRB,1.6019E-01_JPRB,1.1960E-01_JPRB,4.0380E-01_JPRB/)
KBO( :, 3,23,10) = (/&
&2.1531E-01_JPRB,2.3918E-01_JPRB,2.0828E-01_JPRB,1.5508E-01_JPRB,4.5685E-01_JPRB/)
KBO( :, 4,23,10) = (/&
&2.8111E-01_JPRB,3.0634E-01_JPRB,2.6433E-01_JPRB,1.9616E-01_JPRB,5.1050E-01_JPRB/)
KBO( :, 5,23,10) = (/&
&3.5862E-01_JPRB,3.8538E-01_JPRB,3.2913E-01_JPRB,2.4336E-01_JPRB,5.6512E-01_JPRB/)
KBO( :, 1,24,10) = (/&
&1.1051E-01_JPRB,1.2496E-01_JPRB,1.0957E-01_JPRB,8.1032E-02_JPRB,3.1062E-01_JPRB/)
KBO( :, 2,24,10) = (/&
&1.5172E-01_JPRB,1.6880E-01_JPRB,1.4660E-01_JPRB,1.0802E-01_JPRB,3.5601E-01_JPRB/)
KBO( :, 3,24,10) = (/&
&2.0376E-01_JPRB,2.2212E-01_JPRB,1.9093E-01_JPRB,1.3969E-01_JPRB,4.0151E-01_JPRB/)
KBO( :, 4,24,10) = (/&
&2.6595E-01_JPRB,2.8670E-01_JPRB,2.4290E-01_JPRB,1.7693E-01_JPRB,4.4655E-01_JPRB/)
KBO( :, 5,24,10) = (/&
&3.3711E-01_JPRB,3.6154E-01_JPRB,3.0421E-01_JPRB,2.2016E-01_JPRB,4.9307E-01_JPRB/)
KBO( :, 1,25,10) = (/&
&1.0420E-01_JPRB,1.1612E-01_JPRB,1.0071E-01_JPRB,7.3994E-02_JPRB,2.6769E-01_JPRB/)
KBO( :, 2,25,10) = (/&
&1.4379E-01_JPRB,1.5740E-01_JPRB,1.3501E-01_JPRB,9.8353E-02_JPRB,3.0486E-01_JPRB/)
KBO( :, 3,25,10) = (/&
&1.9217E-01_JPRB,2.0868E-01_JPRB,1.7650E-01_JPRB,1.2735E-01_JPRB,3.4236E-01_JPRB/)
KBO( :, 4,25,10) = (/&
&2.4870E-01_JPRB,2.6919E-01_JPRB,2.2634E-01_JPRB,1.6171E-01_JPRB,3.8148E-01_JPRB/)
KBO( :, 5,25,10) = (/&
&3.1377E-01_JPRB,3.3803E-01_JPRB,2.8442E-01_JPRB,2.0146E-01_JPRB,4.2272E-01_JPRB/)
KBO( :, 1,26,10) = (/&
&9.9675E-02_JPRB,1.0913E-01_JPRB,9.3389E-02_JPRB,6.8204E-02_JPRB,2.2702E-01_JPRB/)
KBO( :, 2,26,10) = (/&
&1.3608E-01_JPRB,1.4866E-01_JPRB,1.2587E-01_JPRB,9.0548E-02_JPRB,2.5831E-01_JPRB/)
KBO( :, 3,26,10) = (/&
&1.7987E-01_JPRB,1.9629E-01_JPRB,1.6531E-01_JPRB,1.1761E-01_JPRB,2.9077E-01_JPRB/)
KBO( :, 4,26,10) = (/&
&2.3141E-01_JPRB,2.5133E-01_JPRB,2.1184E-01_JPRB,1.5002E-01_JPRB,3.2521E-01_JPRB/)
KBO( :, 5,26,10) = (/&
&2.9168E-01_JPRB,3.1498E-01_JPRB,2.6568E-01_JPRB,1.8754E-01_JPRB,3.6164E-01_JPRB/)
KBO( :, 1,27,10) = (/&
&9.4961E-02_JPRB,1.0334E-01_JPRB,8.7374E-02_JPRB,6.3126E-02_JPRB,1.8683E-01_JPRB/)
KBO( :, 2,27,10) = (/&
&1.2783E-01_JPRB,1.3969E-01_JPRB,1.1790E-01_JPRB,8.4112E-02_JPRB,2.1332E-01_JPRB/)
KBO( :, 3,27,10) = (/&
&1.6762E-01_JPRB,1.8278E-01_JPRB,1.5442E-01_JPRB,1.0984E-01_JPRB,2.4142E-01_JPRB/)
KBO( :, 4,27,10) = (/&
&2.1518E-01_JPRB,2.3329E-01_JPRB,1.9719E-01_JPRB,1.3996E-01_JPRB,2.7159E-01_JPRB/)
KBO( :, 5,27,10) = (/&
&2.7088E-01_JPRB,2.9228E-01_JPRB,2.4666E-01_JPRB,1.7442E-01_JPRB,3.0352E-01_JPRB/)
KBO( :, 1,28,10) = (/&
&8.9894E-02_JPRB,9.7468E-02_JPRB,8.2177E-02_JPRB,5.8889E-02_JPRB,1.5060E-01_JPRB/)
KBO( :, 2,28,10) = (/&
&1.1988E-01_JPRB,1.3035E-01_JPRB,1.1000E-01_JPRB,7.8738E-02_JPRB,1.7287E-01_JPRB/)
KBO( :, 3,28,10) = (/&
&1.5649E-01_JPRB,1.6957E-01_JPRB,1.4329E-01_JPRB,1.0256E-01_JPRB,1.9707E-01_JPRB/)
KBO( :, 4,28,10) = (/&
&2.0046E-01_JPRB,2.1640E-01_JPRB,1.8266E-01_JPRB,1.3021E-01_JPRB,2.2305E-01_JPRB/)
KBO( :, 5,28,10) = (/&
&2.5209E-01_JPRB,2.7147E-01_JPRB,2.2856E-01_JPRB,1.6182E-01_JPRB,2.5048E-01_JPRB/)
KBO( :, 1,29,10) = (/&
&8.4975E-02_JPRB,9.1564E-02_JPRB,7.7119E-02_JPRB,5.5320E-02_JPRB,1.2031E-01_JPRB/)
KBO( :, 2,29,10) = (/&
&1.1279E-01_JPRB,1.2154E-01_JPRB,1.0248E-01_JPRB,7.3699E-02_JPRB,1.3921E-01_JPRB/)
KBO( :, 3,29,10) = (/&
&1.4673E-01_JPRB,1.5792E-01_JPRB,1.3309E-01_JPRB,9.5449E-02_JPRB,1.5984E-01_JPRB/)
KBO( :, 4,29,10) = (/&
&1.8741E-01_JPRB,2.0158E-01_JPRB,1.6951E-01_JPRB,1.2082E-01_JPRB,1.8203E-01_JPRB/)
KBO( :, 5,29,10) = (/&
&2.3506E-01_JPRB,2.5337E-01_JPRB,2.1224E-01_JPRB,1.5053E-01_JPRB,2.0549E-01_JPRB/)
KBO( :, 1,30,10) = (/&
&8.0540E-02_JPRB,8.5979E-02_JPRB,7.2248E-02_JPRB,5.1838E-02_JPRB,9.5257E-02_JPRB/)
KBO( :, 2,30,10) = (/&
&1.0659E-01_JPRB,1.1363E-01_JPRB,9.5542E-02_JPRB,6.8630E-02_JPRB,1.1116E-01_JPRB/)
KBO( :, 3,30,10) = (/&
&1.3811E-01_JPRB,1.4769E-01_JPRB,1.2398E-01_JPRB,8.8651E-02_JPRB,1.2851E-01_JPRB/)
KBO( :, 4,30,10) = (/&
&1.7576E-01_JPRB,1.8885E-01_JPRB,1.5795E-01_JPRB,1.1230E-01_JPRB,1.4704E-01_JPRB/)
KBO( :, 5,30,10) = (/&
&2.1968E-01_JPRB,2.3750E-01_JPRB,1.9778E-01_JPRB,1.4034E-01_JPRB,1.6746E-01_JPRB/)
KBO( :, 1,31,10) = (/&
&7.6568E-02_JPRB,8.1013E-02_JPRB,6.7877E-02_JPRB,4.8531E-02_JPRB,7.4566E-02_JPRB/)
KBO( :, 2,31,10) = (/&
&1.0109E-01_JPRB,1.0699E-01_JPRB,8.9628E-02_JPRB,6.3973E-02_JPRB,8.7642E-02_JPRB/)
KBO( :, 3,31,10) = (/&
&1.3062E-01_JPRB,1.3896E-01_JPRB,1.1618E-01_JPRB,8.2665E-02_JPRB,1.0209E-01_JPRB/)
KBO( :, 4,31,10) = (/&
&1.6550E-01_JPRB,1.7774E-01_JPRB,1.4814E-01_JPRB,1.0503E-01_JPRB,1.1802E-01_JPRB/)
KBO( :, 5,31,10) = (/&
&2.0675E-01_JPRB,2.2327E-01_JPRB,1.8555E-01_JPRB,1.3151E-01_JPRB,1.3544E-01_JPRB/)
KBO( :, 1,32,10) = (/&
&7.2888E-02_JPRB,7.6838E-02_JPRB,6.4126E-02_JPRB,4.5495E-02_JPRB,5.8817E-02_JPRB/)
KBO( :, 2,32,10) = (/&
&9.6267E-02_JPRB,1.0140E-01_JPRB,8.4579E-02_JPRB,5.9945E-02_JPRB,6.9773E-02_JPRB/)
KBO( :, 3,32,10) = (/&
&1.2398E-01_JPRB,1.3170E-01_JPRB,1.0960E-01_JPRB,7.7555E-02_JPRB,8.1997E-02_JPRB/)
KBO( :, 4,32,10) = (/&
&1.5682E-01_JPRB,1.6810E-01_JPRB,1.3960E-01_JPRB,9.8812E-02_JPRB,9.5528E-02_JPRB/)
KBO( :, 5,32,10) = (/&
&1.9594E-01_JPRB,2.1107E-01_JPRB,1.7505E-01_JPRB,1.2416E-01_JPRB,1.1090E-01_JPRB/)
KBO( :, 1,33,10) = (/&
&6.9635E-02_JPRB,7.3317E-02_JPRB,6.1010E-02_JPRB,4.2865E-02_JPRB,4.6660E-02_JPRB/)
KBO( :, 2,33,10) = (/&
&9.1701E-02_JPRB,9.6759E-02_JPRB,8.0326E-02_JPRB,5.6501E-02_JPRB,5.5833E-02_JPRB/)
KBO( :, 3,33,10) = (/&
&1.1801E-01_JPRB,1.2540E-01_JPRB,1.0406E-01_JPRB,7.3316E-02_JPRB,6.6138E-02_JPRB/)
KBO( :, 4,33,10) = (/&
&1.4953E-01_JPRB,1.5985E-01_JPRB,1.3238E-01_JPRB,9.3601E-02_JPRB,7.7808E-02_JPRB/)
KBO( :, 5,33,10) = (/&
&1.8727E-01_JPRB,2.0108E-01_JPRB,1.6621E-01_JPRB,1.1789E-01_JPRB,9.1029E-02_JPRB/)
KBO( :, 1,34,10) = (/&
&6.6051E-02_JPRB,6.9606E-02_JPRB,5.7793E-02_JPRB,4.0300E-02_JPRB,3.8390E-02_JPRB/)
KBO( :, 2,34,10) = (/&
&8.6850E-02_JPRB,9.2010E-02_JPRB,7.6104E-02_JPRB,5.3129E-02_JPRB,4.6300E-02_JPRB/)
KBO( :, 3,34,10) = (/&
&1.1190E-01_JPRB,1.1902E-01_JPRB,9.8376E-02_JPRB,6.9059E-02_JPRB,5.5243E-02_JPRB/)
KBO( :, 4,34,10) = (/&
&1.4227E-01_JPRB,1.5193E-01_JPRB,1.2534E-01_JPRB,8.8424E-02_JPRB,6.5503E-02_JPRB/)
KBO( :, 5,34,10) = (/&
&1.7893E-01_JPRB,1.9164E-01_JPRB,1.5780E-01_JPRB,1.1159E-01_JPRB,7.7108E-02_JPRB/)
KBO( :, 1,35,10) = (/&
&6.1061E-02_JPRB,6.4589E-02_JPRB,5.3472E-02_JPRB,3.7076E-02_JPRB,3.0936E-02_JPRB/)
KBO( :, 2,35,10) = (/&
&8.0413E-02_JPRB,8.5518E-02_JPRB,7.0631E-02_JPRB,4.9033E-02_JPRB,3.7630E-02_JPRB/)
KBO( :, 3,35,10) = (/&
&1.0418E-01_JPRB,1.1098E-01_JPRB,9.1376E-02_JPRB,6.3892E-02_JPRB,4.5348E-02_JPRB/)
KBO( :, 4,35,10) = (/&
&1.3326E-01_JPRB,1.4218E-01_JPRB,1.1684E-01_JPRB,8.2004E-02_JPRB,5.4177E-02_JPRB/)
KBO( :, 5,35,10) = (/&
&1.6818E-01_JPRB,1.8014E-01_JPRB,1.4791E-01_JPRB,1.0383E-01_JPRB,6.4352E-02_JPRB/)
KBO( :, 1,36,10) = (/&
&5.4859E-02_JPRB,5.8269E-02_JPRB,4.8182E-02_JPRB,3.3253E-02_JPRB,2.4204E-02_JPRB/)
KBO( :, 2,36,10) = (/&
&7.2626E-02_JPRB,7.7491E-02_JPRB,6.3949E-02_JPRB,4.4186E-02_JPRB,2.9747E-02_JPRB/)
KBO( :, 3,36,10) = (/&
&9.4867E-02_JPRB,1.0121E-01_JPRB,8.3126E-02_JPRB,5.7761E-02_JPRB,3.6183E-02_JPRB/)
KBO( :, 4,36,10) = (/&
&1.2215E-01_JPRB,1.3045E-01_JPRB,1.0693E-01_JPRB,7.4445E-02_JPRB,4.3693E-02_JPRB/)
KBO( :, 5,36,10) = (/&
&1.5514E-01_JPRB,1.6646E-01_JPRB,1.3613E-01_JPRB,9.4760E-02_JPRB,5.2444E-02_JPRB/)
KBO( :, 1,37,10) = (/&
&4.7230E-02_JPRB,5.0376E-02_JPRB,4.1606E-02_JPRB,2.8650E-02_JPRB,1.9576E-02_JPRB/)
KBO( :, 2,37,10) = (/&
&6.3162E-02_JPRB,6.7559E-02_JPRB,5.5737E-02_JPRB,3.8366E-02_JPRB,2.4307E-02_JPRB/)
KBO( :, 3,37,10) = (/&
&8.3382E-02_JPRB,8.9100E-02_JPRB,7.3096E-02_JPRB,5.0404E-02_JPRB,2.9845E-02_JPRB/)
KBO( :, 4,37,10) = (/&
&1.0831E-01_JPRB,1.1578E-01_JPRB,9.4747E-02_JPRB,6.5399E-02_JPRB,3.6334E-02_JPRB/)
KBO( :, 5,37,10) = (/&
&1.3872E-01_JPRB,1.4912E-01_JPRB,1.2153E-01_JPRB,8.3890E-02_JPRB,4.3970E-02_JPRB/)
KBO( :, 1,38,10) = (/&
&4.0594E-02_JPRB,4.3482E-02_JPRB,3.5882E-02_JPRB,2.4652E-02_JPRB,1.5796E-02_JPRB/)
KBO( :, 2,38,10) = (/&
&5.4893E-02_JPRB,5.8859E-02_JPRB,4.8535E-02_JPRB,3.3342E-02_JPRB,1.9838E-02_JPRB/)
KBO( :, 3,38,10) = (/&
&7.3270E-02_JPRB,7.8442E-02_JPRB,6.4299E-02_JPRB,4.4057E-02_JPRB,2.4587E-02_JPRB/)
KBO( :, 4,38,10) = (/&
&9.6131E-02_JPRB,1.0297E-01_JPRB,8.4062E-02_JPRB,5.7542E-02_JPRB,3.0194E-02_JPRB/)
KBO( :, 5,38,10) = (/&
&1.2425E-01_JPRB,1.3371E-01_JPRB,1.0871E-01_JPRB,7.4376E-02_JPRB,3.6826E-02_JPRB/)
KBO( :, 1,39,10) = (/&
&3.4960E-02_JPRB,3.7584E-02_JPRB,3.1001E-02_JPRB,2.1253E-02_JPRB,1.2659E-02_JPRB/)
KBO( :, 2,39,10) = (/&
&4.7796E-02_JPRB,5.1412E-02_JPRB,4.2333E-02_JPRB,2.9006E-02_JPRB,1.6073E-02_JPRB/)
KBO( :, 3,39,10) = (/&
&6.4510E-02_JPRB,6.9244E-02_JPRB,5.6690E-02_JPRB,3.8671E-02_JPRB,2.0130E-02_JPRB/)
KBO( :, 4,39,10) = (/&
&8.5561E-02_JPRB,9.1904E-02_JPRB,7.4800E-02_JPRB,5.0873E-02_JPRB,2.4941E-02_JPRB/)
KBO( :, 5,39,10) = (/&
&1.1163E-01_JPRB,1.2022E-01_JPRB,9.7628E-02_JPRB,6.6235E-02_JPRB,3.0668E-02_JPRB/)
KBO( :, 1,40,10) = (/&
&2.9268E-02_JPRB,3.1482E-02_JPRB,2.5935E-02_JPRB,1.7721E-02_JPRB,1.0217E-02_JPRB/)
KBO( :, 2,40,10) = (/&
&4.0459E-02_JPRB,4.3586E-02_JPRB,3.5852E-02_JPRB,2.4486E-02_JPRB,1.3110E-02_JPRB/)
KBO( :, 3,40,10) = (/&
&5.5229E-02_JPRB,5.9449E-02_JPRB,4.8588E-02_JPRB,3.3038E-02_JPRB,1.6586E-02_JPRB/)
KBO( :, 4,40,10) = (/&
&7.4117E-02_JPRB,7.9872E-02_JPRB,6.4885E-02_JPRB,4.3907E-02_JPRB,2.0725E-02_JPRB/)
KBO( :, 5,40,10) = (/&
&9.7865E-02_JPRB,1.0550E-01_JPRB,8.5568E-02_JPRB,5.7643E-02_JPRB,2.5662E-02_JPRB/)
KBO( :, 1,41,10) = (/&
&2.4397E-02_JPRB,2.6231E-02_JPRB,2.1586E-02_JPRB,1.4682E-02_JPRB,8.2353E-03_JPRB/)
KBO( :, 2,41,10) = (/&
&3.4139E-02_JPRB,3.6786E-02_JPRB,3.0230E-02_JPRB,2.0568E-02_JPRB,1.0674E-02_JPRB/)
KBO( :, 3,41,10) = (/&
&4.7106E-02_JPRB,5.0858E-02_JPRB,4.1459E-02_JPRB,2.8115E-02_JPRB,1.3635E-02_JPRB/)
KBO( :, 4,41,10) = (/&
&6.4000E-02_JPRB,6.9180E-02_JPRB,5.6062E-02_JPRB,3.7799E-02_JPRB,1.7204E-02_JPRB/)
KBO( :, 5,41,10) = (/&
&8.5517E-02_JPRB,9.2400E-02_JPRB,7.4782E-02_JPRB,5.0099E-02_JPRB,2.1450E-02_JPRB/)
KBO( :, 1,42,10) = (/&
&2.0268E-02_JPRB,2.1845E-02_JPRB,1.7956E-02_JPRB,1.2140E-02_JPRB,6.5991E-03_JPRB/)
KBO( :, 2,42,10) = (/&
&2.8789E-02_JPRB,3.1021E-02_JPRB,2.5467E-02_JPRB,1.7246E-02_JPRB,8.6477E-03_JPRB/)
KBO( :, 3,42,10) = (/&
&4.0194E-02_JPRB,4.3474E-02_JPRB,3.5363E-02_JPRB,2.3902E-02_JPRB,1.1154E-02_JPRB/)
KBO( :, 4,42,10) = (/&
&5.5258E-02_JPRB,5.9919E-02_JPRB,4.8429E-02_JPRB,3.2536E-02_JPRB,1.4210E-02_JPRB/)
KBO( :, 5,42,10) = (/&
&7.4696E-02_JPRB,8.0962E-02_JPRB,6.5393E-02_JPRB,4.3618E-02_JPRB,1.7849E-02_JPRB/)
KBO( :, 1,43,10) = (/&
&1.6426E-02_JPRB,1.7804E-02_JPRB,1.4613E-02_JPRB,9.8050E-03_JPRB,5.2617E-03_JPRB/)
KBO( :, 2,43,10) = (/&
&2.3747E-02_JPRB,2.5630E-02_JPRB,2.1011E-02_JPRB,1.4160E-02_JPRB,6.9847E-03_JPRB/)
KBO( :, 3,43,10) = (/&
&3.3653E-02_JPRB,3.6412E-02_JPRB,2.9592E-02_JPRB,1.9925E-02_JPRB,9.1040E-03_JPRB/)
KBO( :, 4,43,10) = (/&
&4.6868E-02_JPRB,5.0938E-02_JPRB,4.1108E-02_JPRB,2.7526E-02_JPRB,1.1710E-02_JPRB/)
KBO( :, 5,43,10) = (/&
&6.4129E-02_JPRB,6.9760E-02_JPRB,5.6238E-02_JPRB,3.7383E-02_JPRB,1.4823E-02_JPRB/)
KBO( :, 1,44,10) = (/&
&1.3100E-02_JPRB,1.4316E-02_JPRB,1.1742E-02_JPRB,7.8185E-03_JPRB,4.1731E-03_JPRB/)
KBO( :, 2,44,10) = (/&
&1.9306E-02_JPRB,2.0946E-02_JPRB,1.7130E-02_JPRB,1.1488E-02_JPRB,5.6253E-03_JPRB/)
KBO( :, 3,44,10) = (/&
&2.7839E-02_JPRB,3.0159E-02_JPRB,2.4497E-02_JPRB,1.6420E-02_JPRB,7.4177E-03_JPRB/)
KBO( :, 4,44,10) = (/&
&3.9351E-02_JPRB,4.2845E-02_JPRB,3.4542E-02_JPRB,2.3036E-02_JPRB,9.6323E-03_JPRB/)
KBO( :, 5,44,10) = (/&
&5.4545E-02_JPRB,5.9565E-02_JPRB,4.7916E-02_JPRB,3.1766E-02_JPRB,1.2297E-02_JPRB/)
KBO( :, 1,45,10) = (/&
&1.0365E-02_JPRB,1.1432E-02_JPRB,9.3767E-03_JPRB,6.2117E-03_JPRB,3.2839E-03_JPRB/)
KBO( :, 2,45,10) = (/&
&1.5589E-02_JPRB,1.7063E-02_JPRB,1.3930E-02_JPRB,9.2859E-03_JPRB,4.5005E-03_JPRB/)
KBO( :, 3,45,10) = (/&
&2.2910E-02_JPRB,2.4924E-02_JPRB,2.0227E-02_JPRB,1.3494E-02_JPRB,6.0165E-03_JPRB/)
KBO( :, 4,45,10) = (/&
&3.2938E-02_JPRB,3.5933E-02_JPRB,2.8944E-02_JPRB,1.9215E-02_JPRB,7.8901E-03_JPRB/)
KBO( :, 5,45,10) = (/&
&4.6288E-02_JPRB,5.0739E-02_JPRB,4.0755E-02_JPRB,2.6930E-02_JPRB,1.0163E-02_JPRB/)
KBO( :, 1,46,10) = (/&
&8.0611E-03_JPRB,8.9687E-03_JPRB,7.3616E-03_JPRB,4.8649E-03_JPRB,2.5630E-03_JPRB/)
KBO( :, 2,46,10) = (/&
&1.2384E-02_JPRB,1.3700E-02_JPRB,1.1187E-02_JPRB,7.4141E-03_JPRB,3.5736E-03_JPRB/)
KBO( :, 3,46,10) = (/&
&1.8589E-02_JPRB,2.0376E-02_JPRB,1.6514E-02_JPRB,1.0949E-02_JPRB,4.8546E-03_JPRB/)
KBO( :, 4,46,10) = (/&
&2.7228E-02_JPRB,2.9798E-02_JPRB,2.3986E-02_JPRB,1.5867E-02_JPRB,6.4395E-03_JPRB/)
KBO( :, 5,46,10) = (/&
&3.8907E-02_JPRB,4.2772E-02_JPRB,3.4328E-02_JPRB,2.2598E-02_JPRB,8.3793E-03_JPRB/)
KBO( :, 1,47,10) = (/&
&6.0942E-03_JPRB,6.8373E-03_JPRB,5.6151E-03_JPRB,3.7108E-03_JPRB,1.9874E-03_JPRB/)
KBO( :, 2,47,10) = (/&
&9.5830E-03_JPRB,1.0720E-02_JPRB,8.7687E-03_JPRB,5.7830E-03_JPRB,2.8149E-03_JPRB/)
KBO( :, 3,47,10) = (/&
&1.4719E-02_JPRB,1.6286E-02_JPRB,1.3206E-02_JPRB,8.7082E-03_JPRB,3.8989E-03_JPRB/)
KBO( :, 4,47,10) = (/&
&2.2034E-02_JPRB,2.4248E-02_JPRB,1.9496E-02_JPRB,1.2839E-02_JPRB,5.2464E-03_JPRB/)
KBO( :, 5,47,10) = (/&
&3.2068E-02_JPRB,3.5385E-02_JPRB,2.8366E-02_JPRB,1.8611E-02_JPRB,6.9087E-03_JPRB/)
KBO( :, 1,48,10) = (/&
&4.5510E-03_JPRB,5.1515E-03_JPRB,4.2286E-03_JPRB,2.7938E-03_JPRB,1.5324E-03_JPRB/)
KBO( :, 2,48,10) = (/&
&7.3293E-03_JPRB,8.3022E-03_JPRB,6.7958E-03_JPRB,4.4708E-03_JPRB,2.2018E-03_JPRB/)
KBO( :, 3,48,10) = (/&
&1.1532E-02_JPRB,1.2909E-02_JPRB,1.0485E-02_JPRB,6.8896E-03_JPRB,3.1032E-03_JPRB/)
KBO( :, 4,48,10) = (/&
&1.7669E-02_JPRB,1.9619E-02_JPRB,1.5768E-02_JPRB,1.0334E-02_JPRB,4.2526E-03_JPRB/)
KBO( :, 5,48,10) = (/&
&2.6263E-02_JPRB,2.9134E-02_JPRB,2.3325E-02_JPRB,1.5244E-02_JPRB,5.6768E-03_JPRB/)
KBO( :, 1,49,10) = (/&
&3.3560E-03_JPRB,3.8327E-03_JPRB,3.1391E-03_JPRB,2.0743E-03_JPRB,1.1802E-03_JPRB/)
KBO( :, 2,49,10) = (/&
&5.5342E-03_JPRB,6.3542E-03_JPRB,5.1981E-03_JPRB,3.4211E-03_JPRB,1.7096E-03_JPRB/)
KBO( :, 3,49,10) = (/&
&8.9294E-03_JPRB,1.0143E-02_JPRB,8.2468E-03_JPRB,5.4196E-03_JPRB,2.4470E-03_JPRB/)
KBO( :, 4,49,10) = (/&
&1.4024E-02_JPRB,1.5765E-02_JPRB,1.2684E-02_JPRB,8.2734E-03_JPRB,3.4129E-03_JPRB/)
KBO( :, 5,49,10) = (/&
&2.1352E-02_JPRB,2.3866E-02_JPRB,1.9075E-02_JPRB,1.2411E-02_JPRB,4.6279E-03_JPRB/)
KBO( :, 1,50,10) = (/&
&2.4929E-03_JPRB,2.8632E-03_JPRB,2.3379E-03_JPRB,1.5440E-03_JPRB,9.3225E-04_JPRB/)
KBO( :, 2,50,10) = (/&
&4.2029E-03_JPRB,4.8752E-03_JPRB,3.9805E-03_JPRB,2.6198E-03_JPRB,1.3576E-03_JPRB/)
KBO( :, 3,50,10) = (/&
&6.9325E-03_JPRB,7.9925E-03_JPRB,6.4974E-03_JPRB,4.2674E-03_JPRB,1.9613E-03_JPRB/)
KBO( :, 4,50,10) = (/&
&1.1158E-02_JPRB,1.2709E-02_JPRB,1.0229E-02_JPRB,6.6644E-03_JPRB,2.7832E-03_JPRB/)
KBO( :, 5,50,10) = (/&
&1.7403E-02_JPRB,1.9642E-02_JPRB,1.5691E-02_JPRB,1.0155E-02_JPRB,3.8333E-03_JPRB/)
KBO( :, 1,51,10) = (/&
&1.8532E-03_JPRB,2.1364E-03_JPRB,1.7376E-03_JPRB,1.1454E-03_JPRB,7.4878E-04_JPRB/)
KBO( :, 2,51,10) = (/&
&3.1888E-03_JPRB,3.7291E-03_JPRB,3.0357E-03_JPRB,1.9945E-03_JPRB,1.0922E-03_JPRB/)
KBO( :, 3,51,10) = (/&
&5.3638E-03_JPRB,6.2780E-03_JPRB,5.0968E-03_JPRB,3.3419E-03_JPRB,1.5858E-03_JPRB/)
KBO( :, 4,51,10) = (/&
&8.8501E-03_JPRB,1.0219E-02_JPRB,8.2277E-03_JPRB,5.3639E-03_JPRB,2.2832E-03_JPRB/)
KBO( :, 5,51,10) = (/&
&1.4149E-02_JPRB,1.6146E-02_JPRB,1.2912E-02_JPRB,8.3171E-03_JPRB,3.2000E-03_JPRB/)
KBO( :, 1,52,10) = (/&
&1.3628E-03_JPRB,1.5783E-03_JPRB,1.2808E-03_JPRB,8.4055E-04_JPRB,6.0012E-04_JPRB/)
KBO( :, 2,52,10) = (/&
&2.4017E-03_JPRB,2.8236E-03_JPRB,2.2905E-03_JPRB,1.5011E-03_JPRB,8.8126E-04_JPRB/)
KBO( :, 3,52,10) = (/&
&4.1169E-03_JPRB,4.8815E-03_JPRB,3.9607E-03_JPRB,2.5906E-03_JPRB,1.2847E-03_JPRB/)
KBO( :, 4,52,10) = (/&
&6.9536E-03_JPRB,8.1559E-03_JPRB,6.5664E-03_JPRB,4.2815E-03_JPRB,1.8638E-03_JPRB/)
KBO( :, 5,52,10) = (/&
&1.1409E-02_JPRB,1.3194E-02_JPRB,1.0553E-02_JPRB,6.7875E-03_JPRB,2.6534E-03_JPRB/)
KBO( :, 1,53,10) = (/&
&9.8606E-04_JPRB,1.1540E-03_JPRB,9.3384E-04_JPRB,6.1040E-04_JPRB,4.7709E-04_JPRB/)
KBO( :, 2,53,10) = (/&
&1.7920E-03_JPRB,2.1145E-03_JPRB,1.7063E-03_JPRB,1.1169E-03_JPRB,7.1312E-04_JPRB/)
KBO( :, 3,53,10) = (/&
&3.1294E-03_JPRB,3.7546E-03_JPRB,3.0421E-03_JPRB,1.9861E-03_JPRB,1.0419E-03_JPRB/)
KBO( :, 4,53,10) = (/&
&5.4059E-03_JPRB,6.4522E-03_JPRB,5.1921E-03_JPRB,3.3816E-03_JPRB,1.5130E-03_JPRB/)
KBO( :, 5,53,10) = (/&
&9.1118E-03_JPRB,1.0696E-02_JPRB,8.5534E-03_JPRB,5.5066E-03_JPRB,2.1843E-03_JPRB/)
KBO( :, 1,54,10) = (/&
&7.2513E-04_JPRB,8.5732E-04_JPRB,6.9183E-04_JPRB,4.5039E-04_JPRB,3.8769E-04_JPRB/)
KBO( :, 2,54,10) = (/&
&1.3639E-03_JPRB,1.6067E-03_JPRB,1.2902E-03_JPRB,8.3972E-04_JPRB,5.9341E-04_JPRB/)
KBO( :, 3,54,10) = (/&
&2.4214E-03_JPRB,2.9176E-03_JPRB,2.3545E-03_JPRB,1.5328E-03_JPRB,8.7214E-04_JPRB/)
KBO( :, 4,54,10) = (/&
&4.2490E-03_JPRB,5.1414E-03_JPRB,4.1362E-03_JPRB,2.6851E-03_JPRB,1.2710E-03_JPRB/)
KBO( :, 5,54,10) = (/&
&7.3277E-03_JPRB,8.7352E-03_JPRB,6.9866E-03_JPRB,4.4974E-03_JPRB,1.8463E-03_JPRB/)
KBO( :, 1,55,10) = (/&
&5.3536E-04_JPRB,6.3819E-04_JPRB,5.1429E-04_JPRB,3.3384E-04_JPRB,3.1787E-04_JPRB/)
KBO( :, 2,55,10) = (/&
&1.0434E-03_JPRB,1.2286E-03_JPRB,9.8197E-04_JPRB,6.3464E-04_JPRB,5.0051E-04_JPRB/)
KBO( :, 3,55,10) = (/&
&1.8896E-03_JPRB,2.2759E-03_JPRB,1.8255E-03_JPRB,1.1820E-03_JPRB,7.4689E-04_JPRB/)
KBO( :, 4,55,10) = (/&
&3.3543E-03_JPRB,4.1000E-03_JPRB,3.2922E-03_JPRB,2.1289E-03_JPRB,1.0910E-03_JPRB/)
KBO( :, 5,55,10) = (/&
&5.8957E-03_JPRB,7.1360E-03_JPRB,5.7072E-03_JPRB,3.6721E-03_JPRB,1.5883E-03_JPRB/)
KBO( :, 1,56,10) = (/&
&3.9041E-04_JPRB,4.6983E-04_JPRB,3.7827E-04_JPRB,2.4495E-04_JPRB,2.5822E-04_JPRB/)
KBO( :, 2,56,10) = (/&
&7.9041E-04_JPRB,9.3554E-04_JPRB,7.4444E-04_JPRB,4.7743E-04_JPRB,4.2098E-04_JPRB/)
KBO( :, 3,56,10) = (/&
&1.4711E-03_JPRB,1.7706E-03_JPRB,1.4085E-03_JPRB,9.0462E-04_JPRB,6.4135E-04_JPRB/)
KBO( :, 4,56,10) = (/&
&2.6410E-03_JPRB,3.2487E-03_JPRB,2.5994E-03_JPRB,1.6753E-03_JPRB,9.4189E-04_JPRB/)
KBO( :, 5,56,10) = (/&
&4.7180E-03_JPRB,5.7942E-03_JPRB,4.6339E-03_JPRB,2.9753E-03_JPRB,1.3744E-03_JPRB/)
KBO( :, 1,57,10) = (/&
&2.8112E-04_JPRB,3.4134E-04_JPRB,2.7460E-04_JPRB,1.7739E-04_JPRB,2.0810E-04_JPRB/)
KBO( :, 2,57,10) = (/&
&5.9233E-04_JPRB,7.0612E-04_JPRB,5.6036E-04_JPRB,3.5724E-04_JPRB,3.5218E-04_JPRB/)
KBO( :, 3,57,10) = (/&
&1.1404E-03_JPRB,1.3698E-03_JPRB,1.0818E-03_JPRB,6.8867E-04_JPRB,5.5095E-04_JPRB/)
KBO( :, 4,57,10) = (/&
&2.0756E-03_JPRB,2.5598E-03_JPRB,2.0389E-03_JPRB,1.3071E-03_JPRB,8.1947E-04_JPRB/)
KBO( :, 5,57,10) = (/&
&3.7565E-03_JPRB,4.6715E-03_JPRB,3.7372E-03_JPRB,2.3897E-03_JPRB,1.1970E-03_JPRB/)
KBO( :, 1,58,10) = (/&
&2.0287E-04_JPRB,2.4841E-04_JPRB,1.9950E-04_JPRB,1.2870E-04_JPRB,1.6873E-04_JPRB/)
KBO( :, 2,58,10) = (/&
&4.4472E-04_JPRB,5.3470E-04_JPRB,4.2292E-04_JPRB,2.6899E-04_JPRB,2.9556E-04_JPRB/)
KBO( :, 3,58,10) = (/&
&8.8909E-04_JPRB,1.0668E-03_JPRB,8.3669E-04_JPRB,5.2917E-04_JPRB,4.7698E-04_JPRB/)
KBO( :, 4,58,10) = (/&
&1.6472E-03_JPRB,2.0319E-03_JPRB,1.6079E-03_JPRB,1.0235E-03_JPRB,7.2222E-04_JPRB/)
KBO( :, 5,58,10) = (/&
&3.0142E-03_JPRB,3.7808E-03_JPRB,3.0200E-03_JPRB,1.9230E-03_JPRB,1.0578E-03_JPRB/)
KBO( :, 1,59,10) = (/&
&1.7264E-04_JPRB,2.1252E-04_JPRB,1.6979E-04_JPRB,1.0877E-04_JPRB,1.5535E-04_JPRB/)
KBO( :, 2,59,10) = (/&
&3.8844E-04_JPRB,4.6892E-04_JPRB,3.6892E-04_JPRB,2.3285E-04_JPRB,2.7770E-04_JPRB/)
KBO( :, 3,59,10) = (/&
&7.9313E-04_JPRB,9.5358E-04_JPRB,7.4242E-04_JPRB,4.6490E-04_JPRB,4.5611E-04_JPRB/)
KBO( :, 4,59,10) = (/&
&1.4888E-03_JPRB,1.8362E-03_JPRB,1.4437E-03_JPRB,9.0907E-04_JPRB,6.9878E-04_JPRB/)
KBO( :, 5,59,10) = (/&
&2.7412E-03_JPRB,3.4444E-03_JPRB,2.7403E-03_JPRB,1.7293E-03_JPRB,1.0280E-03_JPRB/)
KBO( :, 1,13,11) = (/&
&4.6582E-01_JPRB,4.3126E-01_JPRB,3.9148E-01_JPRB,2.9782E-01_JPRB,2.0038E+00_JPRB/)
KBO( :, 2,13,11) = (/&
&6.6015E-01_JPRB,6.1362E-01_JPRB,5.5564E-01_JPRB,4.1997E-01_JPRB,2.1506E+00_JPRB/)
KBO( :, 3,13,11) = (/&
&8.9186E-01_JPRB,8.3255E-01_JPRB,7.5032E-01_JPRB,5.6975E-01_JPRB,2.2970E+00_JPRB/)
KBO( :, 4,13,11) = (/&
&1.1586E+00_JPRB,1.0869E+00_JPRB,9.7359E-01_JPRB,7.4196E-01_JPRB,2.4271E+00_JPRB/)
KBO( :, 5,13,11) = (/&
&1.4563E+00_JPRB,1.3761E+00_JPRB,1.2287E+00_JPRB,9.3624E-01_JPRB,2.5537E+00_JPRB/)
KBO( :, 1,14,11) = (/&
&4.6622E-01_JPRB,4.4694E-01_JPRB,4.0621E-01_JPRB,3.0517E-01_JPRB,1.9239E+00_JPRB/)
KBO( :, 2,14,11) = (/&
&6.5626E-01_JPRB,6.3097E-01_JPRB,5.7029E-01_JPRB,4.3017E-01_JPRB,2.0659E+00_JPRB/)
KBO( :, 3,14,11) = (/&
&8.8153E-01_JPRB,8.5029E-01_JPRB,7.6391E-01_JPRB,5.8015E-01_JPRB,2.1968E+00_JPRB/)
KBO( :, 4,14,11) = (/&
&1.1396E+00_JPRB,1.1043E+00_JPRB,9.8836E-01_JPRB,7.5006E-01_JPRB,2.3180E+00_JPRB/)
KBO( :, 5,14,11) = (/&
&1.4290E+00_JPRB,1.3870E+00_JPRB,1.2407E+00_JPRB,9.4051E-01_JPRB,2.4548E+00_JPRB/)
KBO( :, 1,15,11) = (/&
&4.5814E-01_JPRB,4.5398E-01_JPRB,4.1054E-01_JPRB,3.0839E-01_JPRB,1.6835E+00_JPRB/)
KBO( :, 2,15,11) = (/&
&6.4005E-01_JPRB,6.3563E-01_JPRB,5.7202E-01_JPRB,4.3265E-01_JPRB,1.8044E+00_JPRB/)
KBO( :, 3,15,11) = (/&
&8.5481E-01_JPRB,8.5188E-01_JPRB,7.6325E-01_JPRB,5.7776E-01_JPRB,1.9216E+00_JPRB/)
KBO( :, 4,15,11) = (/&
&1.1011E+00_JPRB,1.0984E+00_JPRB,9.8470E-01_JPRB,7.4242E-01_JPRB,2.0480E+00_JPRB/)
KBO( :, 5,15,11) = (/&
&1.3789E+00_JPRB,1.3707E+00_JPRB,1.2263E+00_JPRB,9.2692E-01_JPRB,2.1662E+00_JPRB/)
KBO( :, 1,16,11) = (/&
&4.3936E-01_JPRB,4.5055E-01_JPRB,4.0610E-01_JPRB,3.0607E-01_JPRB,1.3891E+00_JPRB/)
KBO( :, 2,16,11) = (/&
&6.0980E-01_JPRB,6.2580E-01_JPRB,5.6205E-01_JPRB,4.2411E-01_JPRB,1.4937E+00_JPRB/)
KBO( :, 3,16,11) = (/&
&8.1051E-01_JPRB,8.3041E-01_JPRB,7.4762E-01_JPRB,5.6219E-01_JPRB,1.6024E+00_JPRB/)
KBO( :, 4,16,11) = (/&
&1.0423E+00_JPRB,1.0629E+00_JPRB,9.5636E-01_JPRB,7.1926E-01_JPRB,1.7074E+00_JPRB/)
KBO( :, 5,16,11) = (/&
&1.3012E+00_JPRB,1.3270E+00_JPRB,1.1867E+00_JPRB,8.9662E-01_JPRB,1.8065E+00_JPRB/)
KBO( :, 1,17,11) = (/&
&4.1226E-01_JPRB,4.3606E-01_JPRB,3.9203E-01_JPRB,2.9614E-01_JPRB,1.1476E+00_JPRB/)
KBO( :, 2,17,11) = (/&
&5.6889E-01_JPRB,6.0078E-01_JPRB,5.4100E-01_JPRB,4.0607E-01_JPRB,1.2378E+00_JPRB/)
KBO( :, 3,17,11) = (/&
&7.5475E-01_JPRB,7.9223E-01_JPRB,7.1421E-01_JPRB,5.3429E-01_JPRB,1.3294E+00_JPRB/)
KBO( :, 4,17,11) = (/&
&9.6747E-01_JPRB,1.0124E+00_JPRB,9.0807E-01_JPRB,6.8194E-01_JPRB,1.4124E+00_JPRB/)
KBO( :, 5,17,11) = (/&
&1.1994E+00_JPRB,1.2593E+00_JPRB,1.1261E+00_JPRB,8.5185E-01_JPRB,1.4955E+00_JPRB/)
KBO( :, 1,18,11) = (/&
&3.8064E-01_JPRB,4.1279E-01_JPRB,3.7089E-01_JPRB,2.7981E-01_JPRB,9.7150E-01_JPRB/)
KBO( :, 2,18,11) = (/&
&5.2358E-01_JPRB,5.6462E-01_JPRB,5.0829E-01_JPRB,3.8105E-01_JPRB,1.0549E+00_JPRB/)
KBO( :, 3,18,11) = (/&
&6.9263E-01_JPRB,7.4312E-01_JPRB,6.6621E-01_JPRB,4.9871E-01_JPRB,1.1339E+00_JPRB/)
KBO( :, 4,18,11) = (/&
&8.8229E-01_JPRB,9.4872E-01_JPRB,8.4607E-01_JPRB,6.3576E-01_JPRB,1.2109E+00_JPRB/)
KBO( :, 5,18,11) = (/&
&1.0918E+00_JPRB,1.1715E+00_JPRB,1.0485E+00_JPRB,7.9321E-01_JPRB,1.2966E+00_JPRB/)
KBO( :, 1,19,11) = (/&
&3.4707E-01_JPRB,3.8254E-01_JPRB,3.4362E-01_JPRB,2.5858E-01_JPRB,8.6524E-01_JPRB/)
KBO( :, 2,19,11) = (/&
&4.7624E-01_JPRB,5.2177E-01_JPRB,4.6660E-01_JPRB,3.5041E-01_JPRB,9.4567E-01_JPRB/)
KBO( :, 3,19,11) = (/&
&6.2671E-01_JPRB,6.8651E-01_JPRB,6.0965E-01_JPRB,4.5831E-01_JPRB,1.0244E+00_JPRB/)
KBO( :, 4,19,11) = (/&
&7.9653E-01_JPRB,8.7098E-01_JPRB,7.7442E-01_JPRB,5.8401E-01_JPRB,1.1073E+00_JPRB/)
KBO( :, 5,19,11) = (/&
&9.8427E-01_JPRB,1.0726E+00_JPRB,9.5997E-01_JPRB,7.2540E-01_JPRB,1.1966E+00_JPRB/)
KBO( :, 1,20,11) = (/&
&3.1567E-01_JPRB,3.5181E-01_JPRB,3.1444E-01_JPRB,2.3622E-01_JPRB,8.0158E-01_JPRB/)
KBO( :, 2,20,11) = (/&
&4.3131E-01_JPRB,4.7923E-01_JPRB,4.2436E-01_JPRB,3.1880E-01_JPRB,8.8081E-01_JPRB/)
KBO( :, 3,20,11) = (/&
&5.6512E-01_JPRB,6.2700E-01_JPRB,5.5312E-01_JPRB,4.1741E-01_JPRB,9.6113E-01_JPRB/)
KBO( :, 4,20,11) = (/&
&7.1661E-01_JPRB,7.9159E-01_JPRB,7.0178E-01_JPRB,5.3032E-01_JPRB,1.0489E+00_JPRB/)
KBO( :, 5,20,11) = (/&
&8.8236E-01_JPRB,9.7468E-01_JPRB,8.6952E-01_JPRB,6.5743E-01_JPRB,1.1372E+00_JPRB/)
KBO( :, 1,21,11) = (/&
&2.8592E-01_JPRB,3.2074E-01_JPRB,2.8394E-01_JPRB,2.1333E-01_JPRB,7.4290E-01_JPRB/)
KBO( :, 2,21,11) = (/&
&3.8826E-01_JPRB,4.3502E-01_JPRB,3.8223E-01_JPRB,2.8797E-01_JPRB,8.2178E-01_JPRB/)
KBO( :, 3,21,11) = (/&
&5.0741E-01_JPRB,5.6572E-01_JPRB,4.9792E-01_JPRB,3.7590E-01_JPRB,9.0519E-01_JPRB/)
KBO( :, 4,21,11) = (/&
&6.4058E-01_JPRB,7.1340E-01_JPRB,6.3080E-01_JPRB,4.7663E-01_JPRB,9.9225E-01_JPRB/)
KBO( :, 5,21,11) = (/&
&7.8811E-01_JPRB,8.7944E-01_JPRB,7.7953E-01_JPRB,5.8917E-01_JPRB,1.0812E+00_JPRB/)
KBO( :, 1,22,11) = (/&
&2.6349E-01_JPRB,2.9660E-01_JPRB,2.5964E-01_JPRB,1.9557E-01_JPRB,6.7570E-01_JPRB/)
KBO( :, 2,22,11) = (/&
&3.5527E-01_JPRB,3.9835E-01_JPRB,3.4850E-01_JPRB,2.6305E-01_JPRB,7.5224E-01_JPRB/)
KBO( :, 3,22,11) = (/&
&4.6050E-01_JPRB,5.1538E-01_JPRB,4.5315E-01_JPRB,3.4161E-01_JPRB,8.3620E-01_JPRB/)
KBO( :, 4,22,11) = (/&
&5.8034E-01_JPRB,6.4971E-01_JPRB,5.7124E-01_JPRB,4.3148E-01_JPRB,9.2191E-01_JPRB/)
KBO( :, 5,22,11) = (/&
&7.1598E-01_JPRB,7.9992E-01_JPRB,7.0387E-01_JPRB,5.3098E-01_JPRB,1.0108E+00_JPRB/)
KBO( :, 1,23,11) = (/&
&2.4294E-01_JPRB,2.7306E-01_JPRB,2.3732E-01_JPRB,1.7872E-01_JPRB,6.0705E-01_JPRB/)
KBO( :, 2,23,11) = (/&
&3.2497E-01_JPRB,3.6372E-01_JPRB,3.1788E-01_JPRB,2.3869E-01_JPRB,6.8421E-01_JPRB/)
KBO( :, 3,23,11) = (/&
&4.2067E-01_JPRB,4.6941E-01_JPRB,4.1072E-01_JPRB,3.0874E-01_JPRB,7.6600E-01_JPRB/)
KBO( :, 4,23,11) = (/&
&5.3164E-01_JPRB,5.9097E-01_JPRB,5.1614E-01_JPRB,3.8792E-01_JPRB,8.5300E-01_JPRB/)
KBO( :, 5,23,11) = (/&
&6.5861E-01_JPRB,7.2844E-01_JPRB,6.3392E-01_JPRB,4.7757E-01_JPRB,9.4241E-01_JPRB/)
KBO( :, 1,24,11) = (/&
&2.2482E-01_JPRB,2.5108E-01_JPRB,2.1802E-01_JPRB,1.6286E-01_JPRB,5.3854E-01_JPRB/)
KBO( :, 2,24,11) = (/&
&2.9997E-01_JPRB,3.3291E-01_JPRB,2.8985E-01_JPRB,2.1640E-01_JPRB,6.1678E-01_JPRB/)
KBO( :, 3,24,11) = (/&
&3.8949E-01_JPRB,4.2945E-01_JPRB,3.7259E-01_JPRB,2.7841E-01_JPRB,6.9947E-01_JPRB/)
KBO( :, 4,24,11) = (/&
&4.9475E-01_JPRB,5.4040E-01_JPRB,4.6781E-01_JPRB,3.4874E-01_JPRB,7.8678E-01_JPRB/)
KBO( :, 5,24,11) = (/&
&6.1688E-01_JPRB,6.6845E-01_JPRB,5.7526E-01_JPRB,4.2946E-01_JPRB,8.7638E-01_JPRB/)
KBO( :, 1,25,11) = (/&
&2.0867E-01_JPRB,2.3175E-01_JPRB,2.0085E-01_JPRB,1.4849E-01_JPRB,4.8336E-01_JPRB/)
KBO( :, 2,25,11) = (/&
&2.7944E-01_JPRB,3.0729E-01_JPRB,2.6487E-01_JPRB,1.9609E-01_JPRB,5.5823E-01_JPRB/)
KBO( :, 3,25,11) = (/&
&3.6506E-01_JPRB,3.9632E-01_JPRB,3.4020E-01_JPRB,2.5115E-01_JPRB,6.3661E-01_JPRB/)
KBO( :, 4,25,11) = (/&
&4.6727E-01_JPRB,5.0070E-01_JPRB,4.2731E-01_JPRB,3.1512E-01_JPRB,7.1582E-01_JPRB/)
KBO( :, 5,25,11) = (/&
&5.8636E-01_JPRB,6.2209E-01_JPRB,5.2796E-01_JPRB,3.8925E-01_JPRB,7.9834E-01_JPRB/)
KBO( :, 1,26,11) = (/&
&1.9587E-01_JPRB,2.1594E-01_JPRB,1.8576E-01_JPRB,1.3602E-01_JPRB,4.3426E-01_JPRB/)
KBO( :, 2,26,11) = (/&
&2.6382E-01_JPRB,2.8676E-01_JPRB,2.4459E-01_JPRB,1.7873E-01_JPRB,5.0085E-01_JPRB/)
KBO( :, 3,26,11) = (/&
&3.4692E-01_JPRB,3.7120E-01_JPRB,3.1465E-01_JPRB,2.2874E-01_JPRB,5.6934E-01_JPRB/)
KBO( :, 4,26,11) = (/&
&4.4520E-01_JPRB,4.7181E-01_JPRB,3.9637E-01_JPRB,2.8766E-01_JPRB,6.3969E-01_JPRB/)
KBO( :, 5,26,11) = (/&
&5.5605E-01_JPRB,5.8855E-01_JPRB,4.9195E-01_JPRB,3.5675E-01_JPRB,7.1476E-01_JPRB/)
KBO( :, 1,27,11) = (/&
&1.8539E-01_JPRB,2.0232E-01_JPRB,1.7242E-01_JPRB,1.2491E-01_JPRB,3.7468E-01_JPRB/)
KBO( :, 2,27,11) = (/&
&2.5096E-01_JPRB,2.6936E-01_JPRB,2.2766E-01_JPRB,1.6372E-01_JPRB,4.3134E-01_JPRB/)
KBO( :, 3,27,11) = (/&
&3.2985E-01_JPRB,3.5118E-01_JPRB,2.9380E-01_JPRB,2.1018E-01_JPRB,4.9024E-01_JPRB/)
KBO( :, 4,27,11) = (/&
&4.2050E-01_JPRB,4.4779E-01_JPRB,3.7245E-01_JPRB,2.6552E-01_JPRB,5.5373E-01_JPRB/)
KBO( :, 5,27,11) = (/&
&5.2353E-01_JPRB,5.5799E-01_JPRB,4.6451E-01_JPRB,3.2979E-01_JPRB,6.2244E-01_JPRB/)
KBO( :, 1,28,11) = (/&
&1.7670E-01_JPRB,1.9079E-01_JPRB,1.6081E-01_JPRB,1.1550E-01_JPRB,3.1173E-01_JPRB/)
KBO( :, 2,28,11) = (/&
&2.3816E-01_JPRB,2.5545E-01_JPRB,2.1349E-01_JPRB,1.5165E-01_JPRB,3.6015E-01_JPRB/)
KBO( :, 3,28,11) = (/&
&3.1046E-01_JPRB,3.3329E-01_JPRB,2.7692E-01_JPRB,1.9535E-01_JPRB,4.1203E-01_JPRB/)
KBO( :, 4,28,11) = (/&
&3.9421E-01_JPRB,4.2355E-01_JPRB,3.5226E-01_JPRB,2.4753E-01_JPRB,4.6881E-01_JPRB/)
KBO( :, 5,28,11) = (/&
&4.9113E-01_JPRB,5.2757E-01_JPRB,4.3988E-01_JPRB,3.0817E-01_JPRB,5.2989E-01_JPRB/)
KBO( :, 1,29,11) = (/&
&1.6843E-01_JPRB,1.8154E-01_JPRB,1.5154E-01_JPRB,1.0767E-01_JPRB,2.5441E-01_JPRB/)
KBO( :, 2,29,11) = (/&
&2.2466E-01_JPRB,2.4270E-01_JPRB,2.0190E-01_JPRB,1.4201E-01_JPRB,2.9556E-01_JPRB/)
KBO( :, 3,29,11) = (/&
&2.9126E-01_JPRB,3.1537E-01_JPRB,2.6232E-01_JPRB,1.8387E-01_JPRB,3.4113E-01_JPRB/)
KBO( :, 4,29,11) = (/&
&3.6983E-01_JPRB,4.0011E-01_JPRB,3.3340E-01_JPRB,2.3338E-01_JPRB,3.9100E-01_JPRB/)
KBO( :, 5,29,11) = (/&
&4.6101E-01_JPRB,4.9867E-01_JPRB,4.1663E-01_JPRB,2.9053E-01_JPRB,4.4464E-01_JPRB/)
KBO( :, 1,30,11) = (/&
&1.5959E-01_JPRB,1.7262E-01_JPRB,1.4374E-01_JPRB,1.0130E-01_JPRB,2.0471E-01_JPRB/)
KBO( :, 2,30,11) = (/&
&2.1115E-01_JPRB,2.2963E-01_JPRB,1.9116E-01_JPRB,1.3421E-01_JPRB,2.4020E-01_JPRB/)
KBO( :, 3,30,11) = (/&
&2.7360E-01_JPRB,2.9740E-01_JPRB,2.4795E-01_JPRB,1.7403E-01_JPRB,2.7968E-01_JPRB/)
KBO( :, 4,30,11) = (/&
&3.4764E-01_JPRB,3.7756E-01_JPRB,3.1549E-01_JPRB,2.2070E-01_JPRB,3.2281E-01_JPRB/)
KBO( :, 5,30,11) = (/&
&4.3440E-01_JPRB,4.7219E-01_JPRB,3.9465E-01_JPRB,2.7465E-01_JPRB,3.6896E-01_JPRB/)
KBO( :, 1,31,11) = (/&
&1.5091E-01_JPRB,1.6391E-01_JPRB,1.3645E-01_JPRB,9.6278E-02_JPRB,1.6289E-01_JPRB/)
KBO( :, 2,31,11) = (/&
&1.9931E-01_JPRB,2.1721E-01_JPRB,1.8079E-01_JPRB,1.2771E-01_JPRB,1.9309E-01_JPRB/)
KBO( :, 3,31,11) = (/&
&2.5821E-01_JPRB,2.8109E-01_JPRB,2.3449E-01_JPRB,1.6502E-01_JPRB,2.2676E-01_JPRB/)
KBO( :, 4,31,11) = (/&
&3.2875E-01_JPRB,3.5829E-01_JPRB,2.9898E-01_JPRB,2.0919E-01_JPRB,2.6370E-01_JPRB/)
KBO( :, 5,31,11) = (/&
&4.1157E-01_JPRB,4.5002E-01_JPRB,3.7499E-01_JPRB,2.6064E-01_JPRB,3.0365E-01_JPRB/)
KBO( :, 1,32,11) = (/&
&1.4350E-01_JPRB,1.5577E-01_JPRB,1.2948E-01_JPRB,9.1911E-02_JPRB,1.3126E-01_JPRB/)
KBO( :, 2,32,11) = (/&
&1.8927E-01_JPRB,2.0591E-01_JPRB,1.7137E-01_JPRB,1.2148E-01_JPRB,1.5712E-01_JPRB/)
KBO( :, 3,32,11) = (/&
&2.4542E-01_JPRB,2.6745E-01_JPRB,2.2265E-01_JPRB,1.5686E-01_JPRB,1.8606E-01_JPRB/)
KBO( :, 4,32,11) = (/&
&3.1299E-01_JPRB,3.4211E-01_JPRB,2.8464E-01_JPRB,1.9879E-01_JPRB,2.1776E-01_JPRB/)
KBO( :, 5,32,11) = (/&
&3.9189E-01_JPRB,4.3154E-01_JPRB,3.5784E-01_JPRB,2.4869E-01_JPRB,2.5261E-01_JPRB/)
KBO( :, 1,33,11) = (/&
&1.3727E-01_JPRB,1.4838E-01_JPRB,1.2325E-01_JPRB,8.7723E-02_JPRB,1.0656E-01_JPRB/)
KBO( :, 2,33,11) = (/&
&1.8110E-01_JPRB,1.9647E-01_JPRB,1.6322E-01_JPRB,1.1562E-01_JPRB,1.2867E-01_JPRB/)
KBO( :, 3,33,11) = (/&
&2.3493E-01_JPRB,2.5633E-01_JPRB,2.1260E-01_JPRB,1.4945E-01_JPRB,1.5344E-01_JPRB/)
KBO( :, 4,33,11) = (/&
&2.9930E-01_JPRB,3.2911E-01_JPRB,2.7241E-01_JPRB,1.8991E-01_JPRB,1.8112E-01_JPRB/)
KBO( :, 5,33,11) = (/&
&3.7491E-01_JPRB,4.1658E-01_JPRB,3.4340E-01_JPRB,2.3867E-01_JPRB,2.1188E-01_JPRB/)
KBO( :, 1,34,11) = (/&
&1.3092E-01_JPRB,1.4094E-01_JPRB,1.1667E-01_JPRB,8.2911E-02_JPRB,8.9471E-02_JPRB/)
KBO( :, 2,34,11) = (/&
&1.7283E-01_JPRB,1.8720E-01_JPRB,1.5498E-01_JPRB,1.0945E-01_JPRB,1.0879E-01_JPRB/)
KBO( :, 3,34,11) = (/&
&2.2423E-01_JPRB,2.4508E-01_JPRB,2.0247E-01_JPRB,1.4175E-01_JPRB,1.3067E-01_JPRB/)
KBO( :, 4,34,11) = (/&
&2.8568E-01_JPRB,3.1613E-01_JPRB,2.6022E-01_JPRB,1.8119E-01_JPRB,1.5551E-01_JPRB/)
KBO( :, 5,34,11) = (/&
&3.5836E-01_JPRB,4.0157E-01_JPRB,3.2942E-01_JPRB,2.2886E-01_JPRB,1.8335E-01_JPRB/)
KBO( :, 1,35,11) = (/&
&1.2228E-01_JPRB,1.3118E-01_JPRB,1.0815E-01_JPRB,7.6480E-02_JPRB,7.3770E-02_JPRB/)
KBO( :, 2,35,11) = (/&
&1.6172E-01_JPRB,1.7516E-01_JPRB,1.4419E-01_JPRB,1.0138E-01_JPRB,9.0532E-02_JPRB/)
KBO( :, 3,35,11) = (/&
&2.1005E-01_JPRB,2.3024E-01_JPRB,1.8936E-01_JPRB,1.3212E-01_JPRB,1.0977E-01_JPRB/)
KBO( :, 4,35,11) = (/&
&2.6823E-01_JPRB,2.9837E-01_JPRB,2.4450E-01_JPRB,1.7010E-01_JPRB,1.3152E-01_JPRB/)
KBO( :, 5,35,11) = (/&
&3.3803E-01_JPRB,3.8069E-01_JPRB,3.1151E-01_JPRB,2.1623E-01_JPRB,1.5639E-01_JPRB/)
KBO( :, 1,36,11) = (/&
&1.1127E-01_JPRB,1.1902E-01_JPRB,9.7790E-02_JPRB,6.8652E-02_JPRB,5.9294E-02_JPRB/)
KBO( :, 2,36,11) = (/&
&1.4779E-01_JPRB,1.5991E-01_JPRB,1.3100E-01_JPRB,9.1678E-02_JPRB,7.3428E-02_JPRB/)
KBO( :, 3,36,11) = (/&
&1.9248E-01_JPRB,2.1152E-01_JPRB,1.7310E-01_JPRB,1.2044E-01_JPRB,8.9931E-02_JPRB/)
KBO( :, 4,36,11) = (/&
&2.4698E-01_JPRB,2.7546E-01_JPRB,2.2513E-01_JPRB,1.5635E-01_JPRB,1.0865E-01_JPRB/)
KBO( :, 5,36,11) = (/&
&3.1312E-01_JPRB,3.5357E-01_JPRB,2.8900E-01_JPRB,2.0028E-01_JPRB,1.3007E-01_JPRB/)
KBO( :, 1,37,11) = (/&
&9.7171E-02_JPRB,1.0370E-01_JPRB,8.4930E-02_JPRB,5.9132E-02_JPRB,4.8800E-02_JPRB/)
KBO( :, 2,37,11) = (/&
&1.3022E-01_JPRB,1.4042E-01_JPRB,1.1467E-01_JPRB,7.9788E-02_JPRB,6.1101E-02_JPRB/)
KBO( :, 3,37,11) = (/&
&1.7053E-01_JPRB,1.8732E-01_JPRB,1.5267E-01_JPRB,1.0592E-01_JPRB,7.5549E-02_JPRB/)
KBO( :, 4,37,11) = (/&
&2.2021E-01_JPRB,2.4584E-01_JPRB,2.0025E-01_JPRB,1.3887E-01_JPRB,9.2123E-02_JPRB/)
KBO( :, 5,37,11) = (/&
&2.8142E-01_JPRB,3.1806E-01_JPRB,2.5954E-01_JPRB,1.7970E-01_JPRB,1.1114E-01_JPRB/)
KBO( :, 1,38,11) = (/&
&8.4750E-02_JPRB,9.0447E-02_JPRB,7.3862E-02_JPRB,5.1024E-02_JPRB,4.0120E-02_JPRB/)
KBO( :, 2,38,11) = (/&
&1.1472E-01_JPRB,1.2347E-01_JPRB,1.0053E-01_JPRB,6.9437E-02_JPRB,5.0776E-02_JPRB/)
KBO( :, 3,38,11) = (/&
&1.5136E-01_JPRB,1.6607E-01_JPRB,1.3499E-01_JPRB,9.3219E-02_JPRB,6.3385E-02_JPRB/)
KBO( :, 4,38,11) = (/&
&1.9680E-01_JPRB,2.1978E-01_JPRB,1.7847E-01_JPRB,1.2347E-01_JPRB,7.8006E-02_JPRB/)
KBO( :, 5,38,11) = (/&
&2.5341E-01_JPRB,2.8675E-01_JPRB,2.3338E-01_JPRB,1.6145E-01_JPRB,9.4840E-02_JPRB/)
KBO( :, 1,39,11) = (/&
&7.4011E-02_JPRB,7.9191E-02_JPRB,6.4478E-02_JPRB,4.4207E-02_JPRB,3.2805E-02_JPRB/)
KBO( :, 2,39,11) = (/&
&1.0122E-01_JPRB,1.0907E-01_JPRB,8.8541E-02_JPRB,6.0759E-02_JPRB,4.1971E-02_JPRB/)
KBO( :, 3,39,11) = (/&
&1.3478E-01_JPRB,1.4779E-01_JPRB,1.1992E-01_JPRB,8.2325E-02_JPRB,5.2901E-02_JPRB/)
KBO( :, 4,39,11) = (/&
&1.7660E-01_JPRB,1.9727E-01_JPRB,1.5986E-01_JPRB,1.1017E-01_JPRB,6.5730E-02_JPRB/)
KBO( :, 5,39,11) = (/&
&2.2909E-01_JPRB,2.5986E-01_JPRB,2.1074E-01_JPRB,1.4557E-01_JPRB,8.0505E-02_JPRB/)
KBO( :, 1,40,11) = (/&
&6.2473E-02_JPRB,6.7073E-02_JPRB,5.4566E-02_JPRB,3.7187E-02_JPRB,2.6885E-02_JPRB/)
KBO( :, 2,40,11) = (/&
&8.6606E-02_JPRB,9.3644E-02_JPRB,7.5801E-02_JPRB,5.1661E-02_JPRB,3.4836E-02_JPRB/)
KBO( :, 3,40,11) = (/&
&1.1680E-01_JPRB,1.2799E-01_JPRB,1.0372E-01_JPRB,7.0693E-02_JPRB,4.4368E-02_JPRB/)
KBO( :, 4,40,11) = (/&
&1.5470E-01_JPRB,1.7247E-01_JPRB,1.3960E-01_JPRB,9.5679E-02_JPRB,5.5687E-02_JPRB/)
KBO( :, 5,40,11) = (/&
&2.0237E-01_JPRB,2.2977E-01_JPRB,1.8573E-01_JPRB,1.2793E-01_JPRB,6.8850E-02_JPRB/)
KBO( :, 1,41,11) = (/&
&5.2446E-02_JPRB,5.6507E-02_JPRB,4.5959E-02_JPRB,3.1195E-02_JPRB,2.1948E-02_JPRB/)
KBO( :, 2,41,11) = (/&
&7.3701E-02_JPRB,8.0111E-02_JPRB,6.4714E-02_JPRB,4.3819E-02_JPRB,2.8834E-02_JPRB/)
KBO( :, 3,41,11) = (/&
&1.0076E-01_JPRB,1.1070E-01_JPRB,8.9512E-02_JPRB,6.0576E-02_JPRB,3.7158E-02_JPRB/)
KBO( :, 4,41,11) = (/&
&1.3508E-01_JPRB,1.5057E-01_JPRB,1.2175E-01_JPRB,8.2892E-02_JPRB,4.7100E-02_JPRB/)
KBO( :, 5,41,11) = (/&
&1.7854E-01_JPRB,2.0269E-01_JPRB,1.6356E-01_JPRB,1.1214E-01_JPRB,5.8823E-02_JPRB/)
KBO( :, 1,42,11) = (/&
&4.3993E-02_JPRB,4.7543E-02_JPRB,3.8628E-02_JPRB,2.6175E-02_JPRB,1.7822E-02_JPRB/)
KBO( :, 2,42,11) = (/&
&6.2618E-02_JPRB,6.8461E-02_JPRB,5.5301E-02_JPRB,3.7217E-02_JPRB,2.3728E-02_JPRB/)
KBO( :, 3,42,11) = (/&
&8.6814E-02_JPRB,9.5948E-02_JPRB,7.7328E-02_JPRB,5.2009E-02_JPRB,3.0953E-02_JPRB/)
KBO( :, 4,42,11) = (/&
&1.1793E-01_JPRB,1.3165E-01_JPRB,1.0635E-01_JPRB,7.1967E-02_JPRB,3.9679E-02_JPRB/)
KBO( :, 5,42,11) = (/&
&1.5767E-01_JPRB,1.7909E-01_JPRB,1.4430E-01_JPRB,9.8414E-02_JPRB,5.0031E-02_JPRB/)
KBO( :, 1,43,11) = (/&
&3.6051E-02_JPRB,3.9068E-02_JPRB,3.1700E-02_JPRB,2.1500E-02_JPRB,1.4336E-02_JPRB/)
KBO( :, 2,43,11) = (/&
&5.2131E-02_JPRB,5.7262E-02_JPRB,4.6240E-02_JPRB,3.1003E-02_JPRB,1.9367E-02_JPRB/)
KBO( :, 3,43,11) = (/&
&7.3341E-02_JPRB,8.1590E-02_JPRB,6.5706E-02_JPRB,4.3880E-02_JPRB,2.5604E-02_JPRB/)
KBO( :, 4,43,11) = (/&
&1.0113E-01_JPRB,1.1336E-01_JPRB,9.1355E-02_JPRB,6.1391E-02_JPRB,3.3210E-02_JPRB/)
KBO( :, 5,43,11) = (/&
&1.3704E-01_JPRB,1.5566E-01_JPRB,1.2530E-01_JPRB,8.4984E-02_JPRB,4.2357E-02_JPRB/)
KBO( :, 1,44,11) = (/&
&2.9153E-02_JPRB,3.1689E-02_JPRB,2.5651E-02_JPRB,1.7398E-02_JPRB,1.1452E-02_JPRB/)
KBO( :, 2,44,11) = (/&
&4.2894E-02_JPRB,4.7271E-02_JPRB,3.8161E-02_JPRB,2.5559E-02_JPRB,1.5702E-02_JPRB/)
KBO( :, 3,44,11) = (/&
&6.1316E-02_JPRB,6.8606E-02_JPRB,5.5241E-02_JPRB,3.6706E-02_JPRB,2.1051E-02_JPRB/)
KBO( :, 4,44,11) = (/&
&8.5809E-02_JPRB,9.6811E-02_JPRB,7.7867E-02_JPRB,5.1972E-02_JPRB,2.7643E-02_JPRB/)
KBO( :, 5,44,11) = (/&
&1.1804E-01_JPRB,1.3427E-01_JPRB,1.0805E-01_JPRB,7.2832E-02_JPRB,3.5698E-02_JPRB/)
KBO( :, 1,45,11) = (/&
&2.3474E-02_JPRB,2.5620E-02_JPRB,2.0683E-02_JPRB,1.3992E-02_JPRB,9.0872E-03_JPRB/)
KBO( :, 2,45,11) = (/&
&3.5168E-02_JPRB,3.8884E-02_JPRB,3.1357E-02_JPRB,2.0998E-02_JPRB,1.2650E-02_JPRB/)
KBO( :, 3,45,11) = (/&
&5.1125E-02_JPRB,5.7479E-02_JPRB,4.6268E-02_JPRB,3.0685E-02_JPRB,1.7188E-02_JPRB/)
KBO( :, 4,45,11) = (/&
&7.2642E-02_JPRB,8.2540E-02_JPRB,6.6385E-02_JPRB,4.3982E-02_JPRB,2.2878E-02_JPRB/)
KBO( :, 5,45,11) = (/&
&1.0141E-01_JPRB,1.1593E-01_JPRB,9.3129E-02_JPRB,6.2384E-02_JPRB,2.9912E-02_JPRB/)
KBO( :, 1,46,11) = (/&
&1.8622E-02_JPRB,2.0419E-02_JPRB,1.6446E-02_JPRB,1.1089E-02_JPRB,7.1508E-03_JPRB/)
KBO( :, 2,46,11) = (/&
&2.8465E-02_JPRB,3.1591E-02_JPRB,2.5425E-02_JPRB,1.7003E-02_JPRB,1.0100E-02_JPRB/)
KBO( :, 3,46,11) = (/&
&4.2115E-02_JPRB,4.7558E-02_JPRB,3.8296E-02_JPRB,2.5381E-02_JPRB,1.3928E-02_JPRB/)
KBO( :, 4,46,11) = (/&
&6.0884E-02_JPRB,6.9606E-02_JPRB,5.6000E-02_JPRB,3.6888E-02_JPRB,1.8798E-02_JPRB/)
KBO( :, 5,46,11) = (/&
&8.6271E-02_JPRB,9.9295E-02_JPRB,7.9645E-02_JPRB,5.2994E-02_JPRB,2.4873E-02_JPRB/)
KBO( :, 1,47,11) = (/&
&1.4376E-02_JPRB,1.5849E-02_JPRB,1.2756E-02_JPRB,8.5637E-03_JPRB,5.5846E-03_JPRB/)
KBO( :, 2,47,11) = (/&
&2.2523E-02_JPRB,2.5091E-02_JPRB,2.0133E-02_JPRB,1.3433E-02_JPRB,8.0135E-03_JPRB/)
KBO( :, 3,47,11) = (/&
&3.3987E-02_JPRB,3.8521E-02_JPRB,3.0971E-02_JPRB,2.0498E-02_JPRB,1.1217E-02_JPRB/)
KBO( :, 4,47,11) = (/&
&4.9995E-02_JPRB,5.7475E-02_JPRB,4.6271E-02_JPRB,3.0427E-02_JPRB,1.5354E-02_JPRB/)
KBO( :, 5,47,11) = (/&
&7.2095E-02_JPRB,8.3553E-02_JPRB,6.7099E-02_JPRB,4.4249E-02_JPRB,2.0567E-02_JPRB/)
KBO( :, 1,48,11) = (/&
&1.0948E-02_JPRB,1.2187E-02_JPRB,9.8197E-03_JPRB,6.5686E-03_JPRB,4.3309E-03_JPRB/)
KBO( :, 2,48,11) = (/&
&1.7678E-02_JPRB,1.9773E-02_JPRB,1.5847E-02_JPRB,1.0523E-02_JPRB,6.3196E-03_JPRB/)
KBO( :, 3,48,11) = (/&
&2.7272E-02_JPRB,3.1035E-02_JPRB,2.4886E-02_JPRB,1.6427E-02_JPRB,8.9753E-03_JPRB/)
KBO( :, 4,48,11) = (/&
&4.0847E-02_JPRB,4.7231E-02_JPRB,3.7989E-02_JPRB,2.4968E-02_JPRB,1.2435E-02_JPRB/)
KBO( :, 5,48,11) = (/&
&5.9943E-02_JPRB,6.9928E-02_JPRB,5.6261E-02_JPRB,3.6863E-02_JPRB,1.6884E-02_JPRB/)
KBO( :, 1,49,11) = (/&
&8.2227E-03_JPRB,9.2751E-03_JPRB,7.4918E-03_JPRB,4.9857E-03_JPRB,3.3179E-03_JPRB/)
KBO( :, 2,49,11) = (/&
&1.3710E-02_JPRB,1.5461E-02_JPRB,1.2382E-02_JPRB,8.1837E-03_JPRB,4.9416E-03_JPRB/)
KBO( :, 3,49,11) = (/&
&2.1752E-02_JPRB,2.4824E-02_JPRB,1.9870E-02_JPRB,1.3064E-02_JPRB,7.1199E-03_JPRB/)
KBO( :, 4,49,11) = (/&
&3.3202E-02_JPRB,3.8592E-02_JPRB,3.0992E-02_JPRB,2.0326E-02_JPRB,9.9895E-03_JPRB/)
KBO( :, 5,49,11) = (/&
&4.9564E-02_JPRB,5.8206E-02_JPRB,4.6898E-02_JPRB,3.0661E-02_JPRB,1.3734E-02_JPRB/)
KBO( :, 1,50,11) = (/&
&6.1915E-03_JPRB,7.0808E-03_JPRB,5.7341E-03_JPRB,3.7933E-03_JPRB,2.6014E-03_JPRB/)
KBO( :, 2,50,11) = (/&
&1.0634E-02_JPRB,1.2140E-02_JPRB,9.7185E-03_JPRB,6.3965E-03_JPRB,3.9374E-03_JPRB/)
KBO( :, 3,50,11) = (/&
&1.7391E-02_JPRB,1.9945E-02_JPRB,1.5955E-02_JPRB,1.0445E-02_JPRB,5.7678E-03_JPRB/)
KBO( :, 4,50,11) = (/&
&2.7125E-02_JPRB,3.1701E-02_JPRB,2.5413E-02_JPRB,1.6599E-02_JPRB,8.1975E-03_JPRB/)
KBO( :, 5,50,11) = (/&
&4.1193E-02_JPRB,4.8726E-02_JPRB,3.9234E-02_JPRB,2.5636E-02_JPRB,1.1392E-02_JPRB/)
KBO( :, 1,51,11) = (/&
&4.6415E-03_JPRB,5.3779E-03_JPRB,4.3645E-03_JPRB,2.8762E-03_JPRB,2.0670E-03_JPRB/)
KBO( :, 2,51,11) = (/&
&8.1982E-03_JPRB,9.4964E-03_JPRB,7.6128E-03_JPRB,4.9899E-03_JPRB,3.1638E-03_JPRB/)
KBO( :, 3,51,11) = (/&
&1.3839E-02_JPRB,1.6014E-02_JPRB,1.2808E-02_JPRB,8.3362E-03_JPRB,4.7173E-03_JPRB/)
KBO( :, 4,51,11) = (/&
&2.2155E-02_JPRB,2.6015E-02_JPRB,2.0833E-02_JPRB,1.3537E-02_JPRB,6.8071E-03_JPRB/)
KBO( :, 5,51,11) = (/&
&3.4266E-02_JPRB,4.0819E-02_JPRB,3.2809E-02_JPRB,2.1399E-02_JPRB,9.5494E-03_JPRB/)
KBO( :, 1,52,11) = (/&
&3.4450E-03_JPRB,4.0419E-03_JPRB,3.2822E-03_JPRB,2.1593E-03_JPRB,1.6475E-03_JPRB/)
KBO( :, 2,52,11) = (/&
&6.2508E-03_JPRB,7.3537E-03_JPRB,5.9181E-03_JPRB,3.8603E-03_JPRB,2.5371E-03_JPRB/)
KBO( :, 3,52,11) = (/&
&1.0900E-02_JPRB,1.2773E-02_JPRB,1.0216E-02_JPRB,6.6126E-03_JPRB,3.8348E-03_JPRB/)
KBO( :, 4,52,11) = (/&
&1.7975E-02_JPRB,2.1233E-02_JPRB,1.7001E-02_JPRB,1.0994E-02_JPRB,5.6303E-03_JPRB/)
KBO( :, 5,52,11) = (/&
&2.8375E-02_JPRB,3.4038E-02_JPRB,2.7332E-02_JPRB,1.7744E-02_JPRB,7.9843E-03_JPRB/)
KBO( :, 1,53,11) = (/&
&2.5331E-03_JPRB,3.0017E-03_JPRB,2.4368E-03_JPRB,1.5998E-03_JPRB,1.3193E-03_JPRB/)
KBO( :, 2,53,11) = (/&
&4.7088E-03_JPRB,5.6274E-03_JPRB,4.5483E-03_JPRB,2.9549E-03_JPRB,2.0294E-03_JPRB/)
KBO( :, 3,53,11) = (/&
&8.4774E-03_JPRB,1.0097E-02_JPRB,8.0775E-03_JPRB,5.2092E-03_JPRB,3.0959E-03_JPRB/)
KBO( :, 4,53,11) = (/&
&1.4441E-02_JPRB,1.7209E-02_JPRB,1.3780E-02_JPRB,8.8745E-03_JPRB,4.6172E-03_JPRB/)
KBO( :, 5,53,11) = (/&
&2.3385E-02_JPRB,2.8212E-02_JPRB,2.2650E-02_JPRB,1.4615E-02_JPRB,6.6511E-03_JPRB/)
KBO( :, 1,54,11) = (/&
&1.8954E-03_JPRB,2.2607E-03_JPRB,1.8278E-03_JPRB,1.1946E-03_JPRB,1.0985E-03_JPRB/)
KBO( :, 2,54,11) = (/&
&3.5862E-03_JPRB,4.3471E-03_JPRB,3.5189E-03_JPRB,2.2822E-03_JPRB,1.6895E-03_JPRB/)
KBO( :, 3,54,11) = (/&
&6.6312E-03_JPRB,8.0424E-03_JPRB,6.4523E-03_JPRB,4.1406E-03_JPRB,2.5940E-03_JPRB/)
KBO( :, 4,54,11) = (/&
&1.1671E-02_JPRB,1.4089E-02_JPRB,1.1281E-02_JPRB,7.2279E-03_JPRB,3.9122E-03_JPRB/)
KBO( :, 5,54,11) = (/&
&1.9432E-02_JPRB,2.3598E-02_JPRB,1.8940E-02_JPRB,1.2154E-02_JPRB,5.7337E-03_JPRB/)
KBO( :, 1,55,11) = (/&
&1.4290E-03_JPRB,1.7125E-03_JPRB,1.3776E-03_JPRB,8.9347E-04_JPRB,9.3784E-04_JPRB/)
KBO( :, 2,55,11) = (/&
&2.7457E-03_JPRB,3.3623E-03_JPRB,2.7182E-03_JPRB,1.7597E-03_JPRB,1.4453E-03_JPRB/)
KBO( :, 3,55,11) = (/&
&5.1874E-03_JPRB,6.3979E-03_JPRB,5.1511E-03_JPRB,3.2930E-03_JPRB,2.2221E-03_JPRB/)
KBO( :, 4,55,11) = (/&
&9.4226E-03_JPRB,1.1550E-02_JPRB,9.2557E-03_JPRB,5.8990E-03_JPRB,3.3851E-03_JPRB/)
KBO( :, 5,55,11) = (/&
&1.6150E-02_JPRB,1.9777E-02_JPRB,1.5877E-02_JPRB,1.0138E-02_JPRB,5.0396E-03_JPRB/)
KBO( :, 1,56,11) = (/&
&1.0680E-03_JPRB,1.2890E-03_JPRB,1.0316E-03_JPRB,6.6446E-04_JPRB,8.0430E-04_JPRB/)
KBO( :, 2,56,11) = (/&
&2.0978E-03_JPRB,2.5858E-03_JPRB,2.0823E-03_JPRB,1.3442E-03_JPRB,1.2456E-03_JPRB/)
KBO( :, 3,56,11) = (/&
&4.0301E-03_JPRB,5.0435E-03_JPRB,4.0770E-03_JPRB,2.5996E-03_JPRB,1.9142E-03_JPRB/)
KBO( :, 4,56,11) = (/&
&7.5402E-03_JPRB,9.4035E-03_JPRB,7.5479E-03_JPRB,4.7898E-03_JPRB,2.9393E-03_JPRB/)
KBO( :, 5,56,11) = (/&
&1.3330E-02_JPRB,1.6498E-02_JPRB,1.3248E-02_JPRB,8.4281E-03_JPRB,4.4305E-03_JPRB/)
KBO( :, 1,57,11) = (/&
&7.8801E-04_JPRB,9.6289E-04_JPRB,7.6691E-04_JPRB,4.9097E-04_JPRB,6.8859E-04_JPRB/)
KBO( :, 2,57,11) = (/&
&1.5966E-03_JPRB,1.9777E-03_JPRB,1.5840E-03_JPRB,1.0164E-03_JPRB,1.0803E-03_JPRB/)
KBO( :, 3,57,11) = (/&
&3.1118E-03_JPRB,3.9473E-03_JPRB,3.1938E-03_JPRB,2.0343E-03_JPRB,1.6622E-03_JPRB/)
KBO( :, 4,57,11) = (/&
&5.9752E-03_JPRB,7.5907E-03_JPRB,6.1119E-03_JPRB,3.8625E-03_JPRB,2.5583E-03_JPRB/)
KBO( :, 5,57,11) = (/&
&1.0909E-02_JPRB,1.3694E-02_JPRB,1.0990E-02_JPRB,6.9630E-03_JPRB,3.8987E-03_JPRB/)
KBO( :, 1,58,11) = (/&
&5.8173E-04_JPRB,7.2041E-04_JPRB,5.7279E-04_JPRB,3.6474E-04_JPRB,5.9355E-04_JPRB/)
KBO( :, 2,58,11) = (/&
&1.2258E-03_JPRB,1.5249E-03_JPRB,1.2145E-03_JPRB,7.7245E-04_JPRB,9.5456E-04_JPRB/)
KBO( :, 3,58,11) = (/&
&2.4241E-03_JPRB,3.1044E-03_JPRB,2.5087E-03_JPRB,1.5934E-03_JPRB,1.4697E-03_JPRB/)
KBO( :, 4,58,11) = (/&
&4.7512E-03_JPRB,6.1351E-03_JPRB,4.9587E-03_JPRB,3.1245E-03_JPRB,2.2636E-03_JPRB/)
KBO( :, 5,58,11) = (/&
&8.9451E-03_JPRB,1.1404E-02_JPRB,9.1570E-03_JPRB,5.7752E-03_JPRB,3.4844E-03_JPRB/)
KBO( :, 1,59,11) = (/&
&5.0522E-04_JPRB,6.3041E-04_JPRB,4.9923E-04_JPRB,3.1529E-04_JPRB,5.7581E-04_JPRB/)
KBO( :, 2,59,11) = (/&
&1.0885E-03_JPRB,1.3595E-03_JPRB,1.0775E-03_JPRB,6.7742E-04_JPRB,9.3929E-04_JPRB/)
KBO( :, 3,59,11) = (/&
&2.1758E-03_JPRB,2.7928E-03_JPRB,2.2487E-03_JPRB,1.4181E-03_JPRB,1.4518E-03_JPRB/)
KBO( :, 4,59,11) = (/&
&4.2933E-03_JPRB,5.5813E-03_JPRB,4.5166E-03_JPRB,2.8320E-03_JPRB,2.2456E-03_JPRB/)
KBO( :, 5,59,11) = (/&
&8.1802E-03_JPRB,1.0526E-02_JPRB,8.4597E-03_JPRB,5.3170E-03_JPRB,3.4840E-03_JPRB/)
KBO( :, 1,13,12) = (/&
&7.9228E-01_JPRB,6.7739E-01_JPRB,5.9851E-01_JPRB,4.7753E-01_JPRB,2.7637E+00_JPRB/)
KBO( :, 2,13,12) = (/&
&1.1298E+00_JPRB,9.7146E-01_JPRB,8.5148E-01_JPRB,6.6642E-01_JPRB,2.9701E+00_JPRB/)
KBO( :, 3,13,12) = (/&
&1.5315E+00_JPRB,1.3283E+00_JPRB,1.1586E+00_JPRB,8.9312E-01_JPRB,3.2188E+00_JPRB/)
KBO( :, 4,13,12) = (/&
&1.9944E+00_JPRB,1.7422E+00_JPRB,1.5174E+00_JPRB,1.1641E+00_JPRB,3.5302E+00_JPRB/)
KBO( :, 5,13,12) = (/&
&2.5089E+00_JPRB,2.2052E+00_JPRB,1.9170E+00_JPRB,1.4741E+00_JPRB,3.8622E+00_JPRB/)
KBO( :, 1,14,12) = (/&
&8.3949E-01_JPRB,7.3093E-01_JPRB,6.4746E-01_JPRB,4.9215E-01_JPRB,2.7289E+00_JPRB/)
KBO( :, 2,14,12) = (/&
&1.1838E+00_JPRB,1.0392E+00_JPRB,9.1530E-01_JPRB,6.8593E-01_JPRB,2.9374E+00_JPRB/)
KBO( :, 3,14,12) = (/&
&1.5936E+00_JPRB,1.4080E+00_JPRB,1.2362E+00_JPRB,9.1792E-01_JPRB,3.1661E+00_JPRB/)
KBO( :, 4,14,12) = (/&
&2.0618E+00_JPRB,1.8318E+00_JPRB,1.6006E+00_JPRB,1.1951E+00_JPRB,3.4133E+00_JPRB/)
KBO( :, 5,14,12) = (/&
&2.5782E+00_JPRB,2.3016E+00_JPRB,2.0067E+00_JPRB,1.5032E+00_JPRB,3.6330E+00_JPRB/)
KBO( :, 1,15,12) = (/&
&8.6850E-01_JPRB,7.7816E-01_JPRB,6.8988E-01_JPRB,5.1142E-01_JPRB,2.4839E+00_JPRB/)
KBO( :, 2,15,12) = (/&
&1.2152E+00_JPRB,1.0938E+00_JPRB,9.6727E-01_JPRB,7.1145E-01_JPRB,2.6794E+00_JPRB/)
KBO( :, 3,15,12) = (/&
&1.6231E+00_JPRB,1.4682E+00_JPRB,1.2912E+00_JPRB,9.5405E-01_JPRB,2.8636E+00_JPRB/)
KBO( :, 4,15,12) = (/&
&2.0833E+00_JPRB,1.8933E+00_JPRB,1.6562E+00_JPRB,1.2315E+00_JPRB,3.0203E+00_JPRB/)
KBO( :, 5,15,12) = (/&
&2.5907E+00_JPRB,2.3660E+00_JPRB,2.0692E+00_JPRB,1.5407E+00_JPRB,3.1955E+00_JPRB/)
KBO( :, 1,16,12) = (/&
&8.7903E-01_JPRB,8.1154E-01_JPRB,7.2017E-01_JPRB,5.2966E-01_JPRB,2.1487E+00_JPRB/)
KBO( :, 2,16,12) = (/&
&1.2196E+00_JPRB,1.1290E+00_JPRB,9.9867E-01_JPRB,7.3589E-01_JPRB,2.2979E+00_JPRB/)
KBO( :, 3,16,12) = (/&
&1.6158E+00_JPRB,1.5020E+00_JPRB,1.3215E+00_JPRB,9.8028E-01_JPRB,2.4332E+00_JPRB/)
KBO( :, 4,16,12) = (/&
&2.0608E+00_JPRB,1.9258E+00_JPRB,1.6884E+00_JPRB,1.2547E+00_JPRB,2.5777E+00_JPRB/)
KBO( :, 5,16,12) = (/&
&2.5444E+00_JPRB,2.3922E+00_JPRB,2.0979E+00_JPRB,1.5613E+00_JPRB,2.7073E+00_JPRB/)
KBO( :, 1,17,12) = (/&
&8.6797E-01_JPRB,8.2657E-01_JPRB,7.3338E-01_JPRB,5.3823E-01_JPRB,1.8450E+00_JPRB/)
KBO( :, 2,17,12) = (/&
&1.1929E+00_JPRB,1.1407E+00_JPRB,1.0074E+00_JPRB,7.4525E-01_JPRB,1.9691E+00_JPRB/)
KBO( :, 3,17,12) = (/&
&1.5694E+00_JPRB,1.5051E+00_JPRB,1.3270E+00_JPRB,9.8535E-01_JPRB,2.0903E+00_JPRB/)
KBO( :, 4,17,12) = (/&
&1.9886E+00_JPRB,1.9165E+00_JPRB,1.6896E+00_JPRB,1.2533E+00_JPRB,2.2071E+00_JPRB/)
KBO( :, 5,17,12) = (/&
&2.4525E+00_JPRB,2.3619E+00_JPRB,2.0849E+00_JPRB,1.5524E+00_JPRB,2.3229E+00_JPRB/)
KBO( :, 1,18,12) = (/&
&8.3385E-01_JPRB,8.2168E-01_JPRB,7.2749E-01_JPRB,5.3649E-01_JPRB,1.6234E+00_JPRB/)
KBO( :, 2,18,12) = (/&
&1.1389E+00_JPRB,1.1231E+00_JPRB,9.9306E-01_JPRB,7.3634E-01_JPRB,1.7307E+00_JPRB/)
KBO( :, 3,18,12) = (/&
&1.4887E+00_JPRB,1.4739E+00_JPRB,1.3034E+00_JPRB,9.6635E-01_JPRB,1.8435E+00_JPRB/)
KBO( :, 4,18,12) = (/&
&1.8815E+00_JPRB,1.8634E+00_JPRB,1.6522E+00_JPRB,1.2254E+00_JPRB,1.9484E+00_JPRB/)
KBO( :, 5,18,12) = (/&
&2.3106E+00_JPRB,2.2920E+00_JPRB,2.0285E+00_JPRB,1.5162E+00_JPRB,2.0551E+00_JPRB/)
KBO( :, 1,19,12) = (/&
&7.8530E-01_JPRB,7.9679E-01_JPRB,7.0528E-01_JPRB,5.2265E-01_JPRB,1.4533E+00_JPRB/)
KBO( :, 2,19,12) = (/&
&1.0644E+00_JPRB,1.0830E+00_JPRB,9.5920E-01_JPRB,7.1045E-01_JPRB,1.5651E+00_JPRB/)
KBO( :, 3,19,12) = (/&
&1.3856E+00_JPRB,1.4087E+00_JPRB,1.2542E+00_JPRB,9.2677E-01_JPRB,1.6748E+00_JPRB/)
KBO( :, 4,19,12) = (/&
&1.7452E+00_JPRB,1.7745E+00_JPRB,1.5782E+00_JPRB,1.1737E+00_JPRB,1.7839E+00_JPRB/)
KBO( :, 5,19,12) = (/&
&2.1398E+00_JPRB,2.1794E+00_JPRB,1.9373E+00_JPRB,1.4553E+00_JPRB,1.9023E+00_JPRB/)
KBO( :, 1,20,12) = (/&
&7.2778E-01_JPRB,7.6194E-01_JPRB,6.7390E-01_JPRB,5.0077E-01_JPRB,1.3617E+00_JPRB/)
KBO( :, 2,20,12) = (/&
&9.8068E-01_JPRB,1.0262E+00_JPRB,9.1245E-01_JPRB,6.7491E-01_JPRB,1.4807E+00_JPRB/)
KBO( :, 3,20,12) = (/&
&1.2722E+00_JPRB,1.3293E+00_JPRB,1.1831E+00_JPRB,8.7574E-01_JPRB,1.5966E+00_JPRB/)
KBO( :, 4,20,12) = (/&
&1.5991E+00_JPRB,1.6714E+00_JPRB,1.4853E+00_JPRB,1.1090E+00_JPRB,1.7163E+00_JPRB/)
KBO( :, 5,20,12) = (/&
&1.9535E+00_JPRB,2.0500E+00_JPRB,1.8231E+00_JPRB,1.3754E+00_JPRB,1.8494E+00_JPRB/)
KBO( :, 1,21,12) = (/&
&6.6504E-01_JPRB,7.1378E-01_JPRB,6.3305E-01_JPRB,4.7002E-01_JPRB,1.2946E+00_JPRB/)
KBO( :, 2,21,12) = (/&
&8.9278E-01_JPRB,9.5693E-01_JPRB,8.4967E-01_JPRB,6.2960E-01_JPRB,1.4170E+00_JPRB/)
KBO( :, 3,21,12) = (/&
&1.1553E+00_JPRB,1.2382E+00_JPRB,1.0968E+00_JPRB,8.1599E-01_JPRB,1.5400E+00_JPRB/)
KBO( :, 4,21,12) = (/&
&1.4482E+00_JPRB,1.5551E+00_JPRB,1.3761E+00_JPRB,1.0330E+00_JPRB,1.6737E+00_JPRB/)
KBO( :, 5,21,12) = (/&
&1.7635E+00_JPRB,1.8984E+00_JPRB,1.6920E+00_JPRB,1.2782E+00_JPRB,1.8148E+00_JPRB/)
KBO( :, 1,22,12) = (/&
&6.1409E-01_JPRB,6.7210E-01_JPRB,5.9517E-01_JPRB,4.4205E-01_JPRB,1.2140E+00_JPRB/)
KBO( :, 2,22,12) = (/&
&8.2009E-01_JPRB,8.9690E-01_JPRB,7.9134E-01_JPRB,5.8900E-01_JPRB,1.3388E+00_JPRB/)
KBO( :, 3,22,12) = (/&
&1.0573E+00_JPRB,1.1562E+00_JPRB,1.0170E+00_JPRB,7.6239E-01_JPRB,1.4674E+00_JPRB/)
KBO( :, 4,22,12) = (/&
&1.3173E+00_JPRB,1.4441E+00_JPRB,1.2773E+00_JPRB,9.6111E-01_JPRB,1.6103E+00_JPRB/)
KBO( :, 5,22,12) = (/&
&1.6008E+00_JPRB,1.7593E+00_JPRB,1.5714E+00_JPRB,1.1859E+00_JPRB,1.7554E+00_JPRB/)
KBO( :, 1,23,12) = (/&
&5.6489E-01_JPRB,6.2643E-01_JPRB,5.5181E-01_JPRB,4.1055E-01_JPRB,1.1296E+00_JPRB/)
KBO( :, 2,23,12) = (/&
&7.5136E-01_JPRB,8.3205E-01_JPRB,7.2882E-01_JPRB,5.4587E-01_JPRB,1.2556E+00_JPRB/)
KBO( :, 3,23,12) = (/&
&9.6147E-01_JPRB,1.0673E+00_JPRB,9.3622E-01_JPRB,7.0474E-01_JPRB,1.3939E+00_JPRB/)
KBO( :, 4,23,12) = (/&
&1.1945E+00_JPRB,1.3292E+00_JPRB,1.1758E+00_JPRB,8.8540E-01_JPRB,1.5380E+00_JPRB/)
KBO( :, 5,23,12) = (/&
&1.4498E+00_JPRB,1.6203E+00_JPRB,1.4443E+00_JPRB,1.0897E+00_JPRB,1.6879E+00_JPRB/)
KBO( :, 1,24,12) = (/&
&5.2019E-01_JPRB,5.8108E-01_JPRB,5.0714E-01_JPRB,3.7894E-01_JPRB,1.0335E+00_JPRB/)
KBO( :, 2,24,12) = (/&
&6.8678E-01_JPRB,7.6753E-01_JPRB,6.6836E-01_JPRB,5.0261E-01_JPRB,1.1623E+00_JPRB/)
KBO( :, 3,24,12) = (/&
&8.7490E-01_JPRB,9.8000E-01_JPRB,8.5888E-01_JPRB,6.4559E-01_JPRB,1.3047E+00_JPRB/)
KBO( :, 4,24,12) = (/&
&1.0855E+00_JPRB,1.2194E+00_JPRB,1.0757E+00_JPRB,8.1029E-01_JPRB,1.4513E+00_JPRB/)
KBO( :, 5,24,12) = (/&
&1.3195E+00_JPRB,1.4875E+00_JPRB,1.3176E+00_JPRB,9.9617E-01_JPRB,1.6042E+00_JPRB/)
KBO( :, 1,25,12) = (/&
&4.8125E-01_JPRB,5.3776E-01_JPRB,4.6543E-01_JPRB,3.4920E-01_JPRB,9.4296E-01_JPRB/)
KBO( :, 2,25,12) = (/&
&6.3062E-01_JPRB,7.0671E-01_JPRB,6.1374E-01_JPRB,4.6025E-01_JPRB,1.0786E+00_JPRB/)
KBO( :, 3,25,12) = (/&
&8.0138E-01_JPRB,8.9961E-01_JPRB,7.8690E-01_JPRB,5.8999E-01_JPRB,1.2219E+00_JPRB/)
KBO( :, 4,25,12) = (/&
&9.9501E-01_JPRB,1.1200E+00_JPRB,9.8131E-01_JPRB,7.3979E-01_JPRB,1.3746E+00_JPRB/)
KBO( :, 5,25,12) = (/&
&1.2133E+00_JPRB,1.3690E+00_JPRB,1.2002E+00_JPRB,9.0848E-01_JPRB,1.5310E+00_JPRB/)
KBO( :, 1,26,12) = (/&
&4.4718E-01_JPRB,5.0045E-01_JPRB,4.3026E-01_JPRB,3.2190E-01_JPRB,8.7401E-01_JPRB/)
KBO( :, 2,26,12) = (/&
&5.8377E-01_JPRB,6.5329E-01_JPRB,5.6669E-01_JPRB,4.2222E-01_JPRB,1.0132E+00_JPRB/)
KBO( :, 3,26,12) = (/&
&7.4225E-01_JPRB,8.3122E-01_JPRB,7.2142E-01_JPRB,5.4093E-01_JPRB,1.1599E+00_JPRB/)
KBO( :, 4,26,12) = (/&
&9.2576E-01_JPRB,1.0363E+00_JPRB,8.9875E-01_JPRB,6.7651E-01_JPRB,1.3150E+00_JPRB/)
KBO( :, 5,26,12) = (/&
&1.1359E+00_JPRB,1.2689E+00_JPRB,1.1003E+00_JPRB,8.3128E-01_JPRB,1.4725E+00_JPRB/)
KBO( :, 1,27,12) = (/&
&4.1742E-01_JPRB,4.6589E-01_JPRB,4.0014E-01_JPRB,2.9607E-01_JPRB,8.0311E-01_JPRB/)
KBO( :, 2,27,12) = (/&
&5.4534E-01_JPRB,6.0694E-01_JPRB,5.2254E-01_JPRB,3.8814E-01_JPRB,9.3748E-01_JPRB/)
KBO( :, 3,27,12) = (/&
&6.9705E-01_JPRB,7.7317E-01_JPRB,6.6432E-01_JPRB,4.9566E-01_JPRB,1.0808E+00_JPRB/)
KBO( :, 4,27,12) = (/&
&8.7421E-01_JPRB,9.6588E-01_JPRB,8.2816E-01_JPRB,6.1915E-01_JPRB,1.2270E+00_JPRB/)
KBO( :, 5,27,12) = (/&
&1.0783E+00_JPRB,1.1900E+00_JPRB,1.0151E+00_JPRB,7.6356E-01_JPRB,1.3781E+00_JPRB/)
KBO( :, 1,28,12) = (/&
&3.9237E-01_JPRB,4.3515E-01_JPRB,3.7248E-01_JPRB,2.7305E-01_JPRB,7.2280E-01_JPRB/)
KBO( :, 2,28,12) = (/&
&5.1563E-01_JPRB,5.6757E-01_JPRB,4.8403E-01_JPRB,3.5700E-01_JPRB,8.4677E-01_JPRB/)
KBO( :, 3,28,12) = (/&
&6.6308E-01_JPRB,7.2519E-01_JPRB,6.1590E-01_JPRB,4.5472E-01_JPRB,9.7710E-01_JPRB/)
KBO( :, 4,28,12) = (/&
&8.3646E-01_JPRB,9.1152E-01_JPRB,7.6997E-01_JPRB,5.6988E-01_JPRB,1.1096E+00_JPRB/)
KBO( :, 5,28,12) = (/&
&1.0359E+00_JPRB,1.1276E+00_JPRB,9.4962E-01_JPRB,7.0526E-01_JPRB,1.2485E+00_JPRB/)
KBO( :, 1,29,12) = (/&
&3.7279E-01_JPRB,4.1014E-01_JPRB,3.4774E-01_JPRB,2.5341E-01_JPRB,6.3269E-01_JPRB/)
KBO( :, 2,29,12) = (/&
&4.9283E-01_JPRB,5.3769E-01_JPRB,4.5233E-01_JPRB,3.3021E-01_JPRB,7.4294E-01_JPRB/)
KBO( :, 3,29,12) = (/&
&6.3731E-01_JPRB,6.8994E-01_JPRB,5.7780E-01_JPRB,4.2070E-01_JPRB,8.5678E-01_JPRB/)
KBO( :, 4,29,12) = (/&
&8.0637E-01_JPRB,8.7025E-01_JPRB,7.2644E-01_JPRB,5.2908E-01_JPRB,9.7595E-01_JPRB/)
KBO( :, 5,29,12) = (/&
&9.9943E-01_JPRB,1.0813E+00_JPRB,9.0128E-01_JPRB,6.5866E-01_JPRB,1.1019E+00_JPRB/)
KBO( :, 1,30,12) = (/&
&3.5722E-01_JPRB,3.9080E-01_JPRB,3.2710E-01_JPRB,2.3601E-01_JPRB,5.4037E-01_JPRB/)
KBO( :, 2,30,12) = (/&
&4.7448E-01_JPRB,5.1429E-01_JPRB,4.2783E-01_JPRB,3.0716E-01_JPRB,6.3503E-01_JPRB/)
KBO( :, 3,30,12) = (/&
&6.1439E-01_JPRB,6.6308E-01_JPRB,5.4920E-01_JPRB,3.9345E-01_JPRB,7.3381E-01_JPRB/)
KBO( :, 4,30,12) = (/&
&7.7644E-01_JPRB,8.4062E-01_JPRB,6.9350E-01_JPRB,4.9782E-01_JPRB,8.4010E-01_JPRB/)
KBO( :, 5,30,12) = (/&
&9.6226E-01_JPRB,1.0478E+00_JPRB,8.6468E-01_JPRB,6.2256E-01_JPRB,9.5398E-01_JPRB/)
KBO( :, 1,31,12) = (/&
&3.4498E-01_JPRB,3.7545E-01_JPRB,3.1150E-01_JPRB,2.2122E-01_JPRB,4.4905E-01_JPRB/)
KBO( :, 2,31,12) = (/&
&4.5820E-01_JPRB,4.9653E-01_JPRB,4.0983E-01_JPRB,2.8888E-01_JPRB,5.2917E-01_JPRB/)
KBO( :, 3,31,12) = (/&
&5.9170E-01_JPRB,6.4378E-01_JPRB,5.2810E-01_JPRB,3.7284E-01_JPRB,6.1590E-01_JPRB/)
KBO( :, 4,31,12) = (/&
&7.4787E-01_JPRB,8.1835E-01_JPRB,6.7064E-01_JPRB,4.7448E-01_JPRB,7.0953E-01_JPRB/)
KBO( :, 5,31,12) = (/&
&9.2776E-01_JPRB,1.0238E+00_JPRB,8.4020E-01_JPRB,5.9540E-01_JPRB,8.0850E-01_JPRB/)
KBO( :, 1,32,12) = (/&
&3.3387E-01_JPRB,3.6397E-01_JPRB,2.9979E-01_JPRB,2.0962E-01_JPRB,3.7307E-01_JPRB/)
KBO( :, 2,32,12) = (/&
&4.4163E-01_JPRB,4.8363E-01_JPRB,3.9607E-01_JPRB,2.7594E-01_JPRB,4.4216E-01_JPRB/)
KBO( :, 3,32,12) = (/&
&5.7015E-01_JPRB,6.2876E-01_JPRB,5.1363E-01_JPRB,3.5765E-01_JPRB,5.1788E-01_JPRB/)
KBO( :, 4,32,12) = (/&
&7.2141E-01_JPRB,8.0151E-01_JPRB,6.5517E-01_JPRB,4.5717E-01_JPRB,6.0016E-01_JPRB/)
KBO( :, 5,32,12) = (/&
&8.9922E-01_JPRB,1.0062E+00_JPRB,8.2407E-01_JPRB,5.7459E-01_JPRB,6.8536E-01_JPRB/)
KBO( :, 1,33,12) = (/&
&3.2293E-01_JPRB,3.5547E-01_JPRB,2.9093E-01_JPRB,2.0149E-01_JPRB,3.0917E-01_JPRB/)
KBO( :, 2,33,12) = (/&
&4.2627E-01_JPRB,4.7355E-01_JPRB,3.8619E-01_JPRB,2.6640E-01_JPRB,3.6920E-01_JPRB/)
KBO( :, 3,33,12) = (/&
&5.5058E-01_JPRB,6.1665E-01_JPRB,5.0346E-01_JPRB,3.4679E-01_JPRB,4.3505E-01_JPRB/)
KBO( :, 4,33,12) = (/&
&6.9980E-01_JPRB,7.8852E-01_JPRB,6.4475E-01_JPRB,4.4442E-01_JPRB,5.0488E-01_JPRB/)
KBO( :, 5,33,12) = (/&
&8.7592E-01_JPRB,9.9390E-01_JPRB,8.1496E-01_JPRB,5.6029E-01_JPRB,5.7746E-01_JPRB/)
KBO( :, 1,34,12) = (/&
&3.0940E-01_JPRB,3.4528E-01_JPRB,2.8156E-01_JPRB,1.9363E-01_JPRB,2.6611E-01_JPRB/)
KBO( :, 2,34,12) = (/&
&4.0894E-01_JPRB,4.6074E-01_JPRB,3.7565E-01_JPRB,2.5763E-01_JPRB,3.1938E-01_JPRB/)
KBO( :, 3,34,12) = (/&
&5.3041E-01_JPRB,6.0251E-01_JPRB,4.9185E-01_JPRB,3.3679E-01_JPRB,3.7762E-01_JPRB/)
KBO( :, 4,34,12) = (/&
&6.7786E-01_JPRB,7.7350E-01_JPRB,6.3399E-01_JPRB,4.3276E-01_JPRB,4.3880E-01_JPRB/)
KBO( :, 5,34,12) = (/&
&8.5216E-01_JPRB,9.8050E-01_JPRB,8.0443E-01_JPRB,5.4758E-01_JPRB,5.0384E-01_JPRB/)
KBO( :, 1,35,12) = (/&
&2.8939E-01_JPRB,3.2702E-01_JPRB,2.6622E-01_JPRB,1.8249E-01_JPRB,2.2426E-01_JPRB/)
KBO( :, 2,35,12) = (/&
&3.8432E-01_JPRB,4.3860E-01_JPRB,3.5768E-01_JPRB,2.4461E-01_JPRB,2.7044E-01_JPRB/)
KBO( :, 3,35,12) = (/&
&5.0227E-01_JPRB,5.7687E-01_JPRB,4.7133E-01_JPRB,3.2156E-01_JPRB,3.2047E-01_JPRB/)
KBO( :, 4,35,12) = (/&
&6.4522E-01_JPRB,7.4630E-01_JPRB,6.1202E-01_JPRB,4.1516E-01_JPRB,3.7356E-01_JPRB/)
KBO( :, 5,35,12) = (/&
&8.1623E-01_JPRB,9.5325E-01_JPRB,7.8163E-01_JPRB,5.2821E-01_JPRB,4.3272E-01_JPRB/)
KBO( :, 1,36,12) = (/&
&2.6330E-01_JPRB,3.0070E-01_JPRB,2.4442E-01_JPRB,1.6757E-01_JPRB,1.8310E-01_JPRB/)
KBO( :, 2,36,12) = (/&
&3.5255E-01_JPRB,4.0667E-01_JPRB,3.3144E-01_JPRB,2.2644E-01_JPRB,2.2200E-01_JPRB/)
KBO( :, 3,36,12) = (/&
&4.6468E-01_JPRB,5.3948E-01_JPRB,4.4110E-01_JPRB,3.0012E-01_JPRB,2.6412E-01_JPRB/)
KBO( :, 4,36,12) = (/&
&6.0155E-01_JPRB,7.0486E-01_JPRB,5.7783E-01_JPRB,3.9058E-01_JPRB,3.1002E-01_JPRB/)
KBO( :, 5,36,12) = (/&
&7.6703E-01_JPRB,9.0873E-01_JPRB,7.4457E-01_JPRB,5.0060E-01_JPRB,3.6395E-01_JPRB/)
KBO( :, 1,37,12) = (/&
&2.3001E-01_JPRB,2.6442E-01_JPRB,2.1459E-01_JPRB,1.4727E-01_JPRB,1.5536E-01_JPRB/)
KBO( :, 2,37,12) = (/&
&3.1096E-01_JPRB,3.6197E-01_JPRB,2.9461E-01_JPRB,2.0129E-01_JPRB,1.9004E-01_JPRB/)
KBO( :, 3,37,12) = (/&
&4.1431E-01_JPRB,4.8589E-01_JPRB,3.9700E-01_JPRB,2.7000E-01_JPRB,2.2800E-01_JPRB/)
KBO( :, 4,37,12) = (/&
&5.4226E-01_JPRB,6.4266E-01_JPRB,5.2665E-01_JPRB,3.5524E-01_JPRB,2.6910E-01_JPRB/)
KBO( :, 5,37,12) = (/&
&6.9841E-01_JPRB,8.3797E-01_JPRB,6.8663E-01_JPRB,4.5963E-01_JPRB,3.1774E-01_JPRB/)
KBO( :, 1,38,12) = (/&
&2.0134E-01_JPRB,2.3227E-01_JPRB,1.8814E-01_JPRB,1.2935E-01_JPRB,1.3137E-01_JPRB/)
KBO( :, 2,38,12) = (/&
&2.7468E-01_JPRB,3.2208E-01_JPRB,2.6174E-01_JPRB,1.7891E-01_JPRB,1.6217E-01_JPRB/)
KBO( :, 3,38,12) = (/&
&3.6956E-01_JPRB,4.3776E-01_JPRB,3.5733E-01_JPRB,2.4289E-01_JPRB,1.9623E-01_JPRB/)
KBO( :, 4,38,12) = (/&
&4.8896E-01_JPRB,5.8640E-01_JPRB,4.8002E-01_JPRB,3.2349E-01_JPRB,2.3300E-01_JPRB/)
KBO( :, 5,38,12) = (/&
&6.3666E-01_JPRB,7.7346E-01_JPRB,6.3380E-01_JPRB,4.2286E-01_JPRB,2.7663E-01_JPRB/)
KBO( :, 1,39,12) = (/&
&1.7697E-01_JPRB,2.0467E-01_JPRB,1.6540E-01_JPRB,1.1386E-01_JPRB,1.1007E-01_JPRB/)
KBO( :, 2,39,12) = (/&
&2.4368E-01_JPRB,2.8735E-01_JPRB,2.3319E-01_JPRB,1.5947E-01_JPRB,1.3719E-01_JPRB/)
KBO( :, 3,39,12) = (/&
&3.3092E-01_JPRB,3.9580E-01_JPRB,3.2268E-01_JPRB,2.1918E-01_JPRB,1.6720E-01_JPRB/)
KBO( :, 4,39,12) = (/&
&4.4249E-01_JPRB,5.3699E-01_JPRB,4.3914E-01_JPRB,2.9552E-01_JPRB,1.9987E-01_JPRB/)
KBO( :, 5,39,12) = (/&
&5.8226E-01_JPRB,7.1600E-01_JPRB,5.8709E-01_JPRB,3.9058E-01_JPRB,2.3879E-01_JPRB/)
KBO( :, 1,40,12) = (/&
&1.5084E-01_JPRB,1.7449E-01_JPRB,1.4045E-01_JPRB,9.6794E-02_JPRB,9.3392E-02_JPRB/)
KBO( :, 2,40,12) = (/&
&2.1010E-01_JPRB,2.4822E-01_JPRB,2.0097E-01_JPRB,1.3766E-01_JPRB,1.1767E-01_JPRB/)
KBO( :, 3,40,12) = (/&
&2.8835E-01_JPRB,3.4716E-01_JPRB,2.8248E-01_JPRB,1.9197E-01_JPRB,1.4495E-01_JPRB/)
KBO( :, 4,40,12) = (/&
&3.8988E-01_JPRB,4.7789E-01_JPRB,3.9037E-01_JPRB,2.6261E-01_JPRB,1.7468E-01_JPRB/)
KBO( :, 5,40,12) = (/&
&5.1945E-01_JPRB,6.4586E-01_JPRB,5.2903E-01_JPRB,3.5162E-01_JPRB,2.0975E-01_JPRB/)
KBO( :, 1,41,12) = (/&
&1.2817E-01_JPRB,1.4829E-01_JPRB,1.1887E-01_JPRB,8.1840E-02_JPRB,7.9057E-02_JPRB/)
KBO( :, 2,41,12) = (/&
&1.8060E-01_JPRB,2.1362E-01_JPRB,1.7247E-01_JPRB,1.1830E-01_JPRB,1.0081E-01_JPRB/)
KBO( :, 3,41,12) = (/&
&2.5080E-01_JPRB,3.0334E-01_JPRB,2.4634E-01_JPRB,1.6753E-01_JPRB,1.2548E-01_JPRB/)
KBO( :, 4,41,12) = (/&
&3.4280E-01_JPRB,4.2376E-01_JPRB,3.4586E-01_JPRB,2.3251E-01_JPRB,1.5256E-01_JPRB/)
KBO( :, 5,41,12) = (/&
&4.6230E-01_JPRB,5.8070E-01_JPRB,4.7518E-01_JPRB,3.1572E-01_JPRB,1.8431E-01_JPRB/)
KBO( :, 1,42,12) = (/&
&1.0893E-01_JPRB,1.2613E-01_JPRB,1.0083E-01_JPRB,6.9157E-02_JPRB,6.6394E-02_JPRB/)
KBO( :, 2,42,12) = (/&
&1.5547E-01_JPRB,1.8415E-01_JPRB,1.4803E-01_JPRB,1.0161E-01_JPRB,8.5777E-02_JPRB/)
KBO( :, 3,42,12) = (/&
&2.1846E-01_JPRB,2.6502E-01_JPRB,2.1486E-01_JPRB,1.4627E-01_JPRB,1.0794E-01_JPRB/)
KBO( :, 4,42,12) = (/&
&3.0198E-01_JPRB,3.7587E-01_JPRB,3.0638E-01_JPRB,2.0583E-01_JPRB,1.3247E-01_JPRB/)
KBO( :, 5,42,12) = (/&
&4.1199E-01_JPRB,5.2225E-01_JPRB,4.2709E-01_JPRB,2.8351E-01_JPRB,1.6111E-01_JPRB/)
KBO( :, 1,43,12) = (/&
&9.0638E-02_JPRB,1.0503E-01_JPRB,8.3795E-02_JPRB,5.7071E-02_JPRB,5.5354E-02_JPRB/)
KBO( :, 2,43,12) = (/&
&1.3131E-01_JPRB,1.5548E-01_JPRB,1.2458E-01_JPRB,8.5364E-02_JPRB,7.2576E-02_JPRB/)
KBO( :, 3,43,12) = (/&
&1.8681E-01_JPRB,2.2707E-01_JPRB,1.8347E-01_JPRB,1.2501E-01_JPRB,9.2538E-02_JPRB/)
KBO( :, 4,43,12) = (/&
&2.6160E-01_JPRB,3.2672E-01_JPRB,2.6595E-01_JPRB,1.7876E-01_JPRB,1.1500E-01_JPRB/)
KBO( :, 5,43,12) = (/&
&3.6120E-01_JPRB,4.6097E-01_JPRB,3.7669E-01_JPRB,2.4999E-01_JPRB,1.4075E-01_JPRB/)
KBO( :, 1,44,12) = (/&
&7.4518E-02_JPRB,8.6409E-02_JPRB,6.8952E-02_JPRB,4.6577E-02_JPRB,4.5787E-02_JPRB/)
KBO( :, 2,44,12) = (/&
&1.0975E-01_JPRB,1.2994E-01_JPRB,1.0385E-01_JPRB,7.0835E-02_JPRB,6.0976E-02_JPRB/)
KBO( :, 3,44,12) = (/&
&1.5828E-01_JPRB,1.9250E-01_JPRB,1.5506E-01_JPRB,1.0558E-01_JPRB,7.8936E-02_JPRB/)
KBO( :, 4,44,12) = (/&
&2.2471E-01_JPRB,2.8098E-01_JPRB,2.2821E-01_JPRB,1.5365E-01_JPRB,9.9460E-02_JPRB/)
KBO( :, 5,44,12) = (/&
&3.1406E-01_JPRB,4.0269E-01_JPRB,3.2871E-01_JPRB,2.1813E-01_JPRB,1.2276E-01_JPRB/)
KBO( :, 1,45,12) = (/&
&6.0927E-02_JPRB,7.0888E-02_JPRB,5.6604E-02_JPRB,3.8007E-02_JPRB,3.7451E-02_JPRB/)
KBO( :, 2,45,12) = (/&
&9.1562E-02_JPRB,1.0848E-01_JPRB,8.6563E-02_JPRB,5.8638E-02_JPRB,5.0739E-02_JPRB/)
KBO( :, 3,45,12) = (/&
&1.3401E-01_JPRB,1.6305E-01_JPRB,1.3093E-01_JPRB,8.8909E-02_JPRB,6.6645E-02_JPRB/)
KBO( :, 4,45,12) = (/&
&1.9278E-01_JPRB,2.4132E-01_JPRB,1.9538E-01_JPRB,1.3171E-01_JPRB,8.5195E-02_JPRB/)
KBO( :, 5,45,12) = (/&
&2.7301E-01_JPRB,3.5087E-01_JPRB,2.8599E-01_JPRB,1.8994E-01_JPRB,1.0627E-01_JPRB/)
KBO( :, 1,46,12) = (/&
&4.9049E-02_JPRB,5.7390E-02_JPRB,4.5841E-02_JPRB,3.0652E-02_JPRB,3.0244E-02_JPRB/)
KBO( :, 2,46,12) = (/&
&7.5395E-02_JPRB,8.9544E-02_JPRB,7.1479E-02_JPRB,4.8016E-02_JPRB,4.1812E-02_JPRB/)
KBO( :, 3,46,12) = (/&
&1.1243E-01_JPRB,1.3673E-01_JPRB,1.0940E-01_JPRB,7.3992E-02_JPRB,5.5802E-02_JPRB/)
KBO( :, 4,46,12) = (/&
&1.6385E-01_JPRB,2.0515E-01_JPRB,1.6554E-01_JPRB,1.1163E-01_JPRB,7.2384E-02_JPRB/)
KBO( :, 5,46,12) = (/&
&2.3535E-01_JPRB,3.0228E-01_JPRB,2.4596E-01_JPRB,1.6359E-01_JPRB,9.1350E-02_JPRB/)
KBO( :, 1,47,12) = (/&
&3.8455E-02_JPRB,4.5311E-02_JPRB,3.6191E-02_JPRB,2.4099E-02_JPRB,2.4180E-02_JPRB/)
KBO( :, 2,47,12) = (/&
&6.0543E-02_JPRB,7.2219E-02_JPRB,5.7752E-02_JPRB,3.8501E-02_JPRB,3.4153E-02_JPRB/)
KBO( :, 3,47,12) = (/&
&9.2469E-02_JPRB,1.1229E-01_JPRB,8.9649E-02_JPRB,6.0326E-02_JPRB,4.6448E-02_JPRB/)
KBO( :, 4,47,12) = (/&
&1.3689E-01_JPRB,1.7102E-01_JPRB,1.3750E-01_JPRB,9.2547E-02_JPRB,6.1214E-02_JPRB/)
KBO( :, 5,47,12) = (/&
&1.9927E-01_JPRB,2.5535E-01_JPRB,2.0704E-01_JPRB,1.3818E-01_JPRB,7.8425E-02_JPRB/)
KBO( :, 1,48,12) = (/&
&2.9907E-02_JPRB,3.5538E-02_JPRB,2.8349E-02_JPRB,1.8781E-02_JPRB,1.9054E-02_JPRB/)
KBO( :, 2,48,12) = (/&
&4.8228E-02_JPRB,5.7904E-02_JPRB,4.6345E-02_JPRB,3.0764E-02_JPRB,2.7466E-02_JPRB/)
KBO( :, 3,48,12) = (/&
&7.5470E-02_JPRB,9.1806E-02_JPRB,7.3317E-02_JPRB,4.8995E-02_JPRB,3.8151E-02_JPRB/)
KBO( :, 4,48,12) = (/&
&1.1406E-01_JPRB,1.4204E-01_JPRB,1.1383E-01_JPRB,7.6343E-02_JPRB,5.1172E-02_JPRB/)
KBO( :, 5,48,12) = (/&
&1.6822E-01_JPRB,2.1497E-01_JPRB,1.7372E-01_JPRB,1.1607E-01_JPRB,6.6629E-02_JPRB/)
KBO( :, 1,49,12) = (/&
&2.3084E-02_JPRB,2.7602E-02_JPRB,2.2043E-02_JPRB,1.4515E-02_JPRB,1.4700E-02_JPRB/)
KBO( :, 2,49,12) = (/&
&3.8134E-02_JPRB,4.6138E-02_JPRB,3.6932E-02_JPRB,2.4422E-02_JPRB,2.1696E-02_JPRB/)
KBO( :, 3,49,12) = (/&
&6.1053E-02_JPRB,7.4691E-02_JPRB,5.9743E-02_JPRB,3.9618E-02_JPRB,3.0784E-02_JPRB/)
KBO( :, 4,49,12) = (/&
&9.4624E-02_JPRB,1.1747E-01_JPRB,9.3906E-02_JPRB,6.2717E-02_JPRB,4.2057E-02_JPRB/)
KBO( :, 5,49,12) = (/&
&1.4162E-01_JPRB,1.8031E-01_JPRB,1.4520E-01_JPRB,9.6951E-02_JPRB,5.5665E-02_JPRB/)
KBO( :, 1,50,12) = (/&
&1.7880E-02_JPRB,2.1522E-02_JPRB,1.7193E-02_JPRB,1.1281E-02_JPRB,1.1563E-02_JPRB/)
KBO( :, 2,50,12) = (/&
&3.0304E-02_JPRB,3.6988E-02_JPRB,2.9594E-02_JPRB,1.9489E-02_JPRB,1.7511E-02_JPRB/)
KBO( :, 3,50,12) = (/&
&4.9620E-02_JPRB,6.1130E-02_JPRB,4.8990E-02_JPRB,3.2313E-02_JPRB,2.5345E-02_JPRB/)
KBO( :, 4,50,12) = (/&
&7.8794E-02_JPRB,9.7813E-02_JPRB,7.8198E-02_JPRB,5.1943E-02_JPRB,3.5298E-02_JPRB/)
KBO( :, 5,50,12) = (/&
&1.2010E-01_JPRB,1.5227E-01_JPRB,1.2229E-01_JPRB,8.1438E-02_JPRB,4.7462E-02_JPRB/)
KBO( :, 1,51,12) = (/&
&1.3778E-02_JPRB,1.6753E-02_JPRB,1.3366E-02_JPRB,8.7587E-03_JPRB,9.1691E-03_JPRB/)
KBO( :, 2,51,12) = (/&
&2.4068E-02_JPRB,2.9598E-02_JPRB,2.3720E-02_JPRB,1.5531E-02_JPRB,1.4241E-02_JPRB/)
KBO( :, 3,51,12) = (/&
&4.0319E-02_JPRB,5.0023E-02_JPRB,4.0146E-02_JPRB,2.6379E-02_JPRB,2.1041E-02_JPRB/)
KBO( :, 4,51,12) = (/&
&6.5444E-02_JPRB,8.1559E-02_JPRB,6.5274E-02_JPRB,4.3107E-02_JPRB,2.9808E-02_JPRB/)
KBO( :, 5,51,12) = (/&
&1.0193E-01_JPRB,1.2878E-01_JPRB,1.0316E-01_JPRB,6.8485E-02_JPRB,4.0764E-02_JPRB/)
KBO( :, 1,52,12) = (/&
&1.0503E-02_JPRB,1.2908E-02_JPRB,1.0296E-02_JPRB,6.7391E-03_JPRB,7.1632E-03_JPRB/)
KBO( :, 2,52,12) = (/&
&1.8963E-02_JPRB,2.3514E-02_JPRB,1.8863E-02_JPRB,1.2292E-02_JPRB,1.1416E-02_JPRB/)
KBO( :, 3,52,12) = (/&
&3.2574E-02_JPRB,4.0763E-02_JPRB,3.2692E-02_JPRB,2.1413E-02_JPRB,1.7232E-02_JPRB/)
KBO( :, 4,52,12) = (/&
&5.4015E-02_JPRB,6.7725E-02_JPRB,5.4297E-02_JPRB,3.5648E-02_JPRB,2.4880E-02_JPRB/)
KBO( :, 5,52,12) = (/&
&8.6142E-02_JPRB,1.0850E-01_JPRB,8.6783E-02_JPRB,5.7412E-02_JPRB,3.4604E-02_JPRB/)
KBO( :, 1,53,12) = (/&
&7.9034E-03_JPRB,9.8239E-03_JPRB,7.8369E-03_JPRB,5.1248E-03_JPRB,5.4843E-03_JPRB/)
KBO( :, 2,53,12) = (/&
&1.4792E-02_JPRB,1.8526E-02_JPRB,1.4847E-02_JPRB,9.6585E-03_JPRB,8.9798E-03_JPRB/)
KBO( :, 3,53,12) = (/&
&2.6145E-02_JPRB,3.2976E-02_JPRB,2.6454E-02_JPRB,1.7260E-02_JPRB,1.3880E-02_JPRB/)
KBO( :, 4,53,12) = (/&
&4.4324E-02_JPRB,5.5900E-02_JPRB,4.4894E-02_JPRB,2.9345E-02_JPRB,2.0450E-02_JPRB/)
KBO( :, 5,53,12) = (/&
&7.2259E-02_JPRB,9.1031E-02_JPRB,7.2836E-02_JPRB,4.7964E-02_JPRB,2.8899E-02_JPRB/)
KBO( :, 1,54,12) = (/&
&6.0030E-03_JPRB,7.5343E-03_JPRB,6.0206E-03_JPRB,3.9269E-03_JPRB,4.4374E-03_JPRB/)
KBO( :, 2,54,12) = (/&
&1.1626E-02_JPRB,1.4746E-02_JPRB,1.1801E-02_JPRB,7.6733E-03_JPRB,7.4644E-03_JPRB/)
KBO( :, 3,54,12) = (/&
&2.1204E-02_JPRB,2.6932E-02_JPRB,2.1639E-02_JPRB,1.4058E-02_JPRB,1.1820E-02_JPRB/)
KBO( :, 4,54,12) = (/&
&3.6734E-02_JPRB,4.6630E-02_JPRB,3.7473E-02_JPRB,2.4399E-02_JPRB,1.7746E-02_JPRB/)
KBO( :, 5,54,12) = (/&
&6.1048E-02_JPRB,7.7176E-02_JPRB,6.1839E-02_JPRB,4.0517E-02_JPRB,2.5474E-02_JPRB/)
KBO( :, 1,55,12) = (/&
&4.5630E-03_JPRB,5.7681E-03_JPRB,4.6205E-03_JPRB,3.0002E-03_JPRB,3.7045E-03_JPRB/)
KBO( :, 2,55,12) = (/&
&9.1273E-03_JPRB,1.1728E-02_JPRB,9.3956E-03_JPRB,6.0945E-03_JPRB,6.4077E-03_JPRB/)
KBO( :, 3,55,12) = (/&
&1.7191E-02_JPRB,2.2039E-02_JPRB,1.7711E-02_JPRB,1.1469E-02_JPRB,1.0390E-02_JPRB/)
KBO( :, 4,55,12) = (/&
&3.0517E-02_JPRB,3.9009E-02_JPRB,3.1321E-02_JPRB,2.0350E-02_JPRB,1.5909E-02_JPRB/)
KBO( :, 5,55,12) = (/&
&5.1680E-02_JPRB,6.5618E-02_JPRB,5.2649E-02_JPRB,3.4345E-02_JPRB,2.3231E-02_JPRB/)
KBO( :, 1,56,12) = (/&
&3.4429E-03_JPRB,4.3693E-03_JPRB,3.5102E-03_JPRB,2.2664E-03_JPRB,3.0972E-03_JPRB/)
KBO( :, 2,56,12) = (/&
&7.1067E-03_JPRB,9.2412E-03_JPRB,7.4106E-03_JPRB,4.8010E-03_JPRB,5.4938E-03_JPRB/)
KBO( :, 3,56,12) = (/&
&1.3838E-02_JPRB,1.7926E-02_JPRB,1.4393E-02_JPRB,9.3102E-03_JPRB,9.1167E-03_JPRB/)
KBO( :, 4,56,12) = (/&
&2.5226E-02_JPRB,3.2470E-02_JPRB,2.6067E-02_JPRB,1.6890E-02_JPRB,1.4253E-02_JPRB/)
KBO( :, 5,56,12) = (/&
&4.3555E-02_JPRB,5.5559E-02_JPRB,4.4639E-02_JPRB,2.9008E-02_JPRB,2.1194E-02_JPRB/)
KBO( :, 1,57,12) = (/&
&2.5835E-03_JPRB,3.2792E-03_JPRB,2.6340E-03_JPRB,1.6928E-03_JPRB,2.5979E-03_JPRB/)
KBO( :, 2,57,12) = (/&
&5.4818E-03_JPRB,7.2018E-03_JPRB,5.7860E-03_JPRB,3.7399E-03_JPRB,4.6938E-03_JPRB/)
KBO( :, 3,57,12) = (/&
&1.1045E-02_JPRB,1.4477E-02_JPRB,1.1615E-02_JPRB,7.5071E-03_JPRB,7.9880E-03_JPRB/)
KBO( :, 4,57,12) = (/&
&2.0734E-02_JPRB,2.6855E-02_JPRB,2.1584E-02_JPRB,1.3939E-02_JPRB,1.2771E-02_JPRB/)
KBO( :, 5,57,12) = (/&
&3.6531E-02_JPRB,4.6834E-02_JPRB,3.7641E-02_JPRB,2.4391E-02_JPRB,1.9328E-02_JPRB/)
KBO( :, 1,58,12) = (/&
&1.9554E-03_JPRB,2.4805E-03_JPRB,1.9815E-03_JPRB,1.2675E-03_JPRB,2.2311E-03_JPRB/)
KBO( :, 2,58,12) = (/&
&4.2406E-03_JPRB,5.6194E-03_JPRB,4.5251E-03_JPRB,2.9142E-03_JPRB,4.0751E-03_JPRB/)
KBO( :, 3,58,12) = (/&
&8.8253E-03_JPRB,1.1715E-02_JPRB,9.4049E-03_JPRB,6.0687E-03_JPRB,7.1082E-03_JPRB/)
KBO( :, 4,58,12) = (/&
&1.7081E-02_JPRB,2.2294E-02_JPRB,1.7921E-02_JPRB,1.1542E-02_JPRB,1.1601E-02_JPRB/)
KBO( :, 5,58,12) = (/&
&3.0768E-02_JPRB,3.9661E-02_JPRB,3.1853E-02_JPRB,2.0599E-02_JPRB,1.7860E-02_JPRB/)
KBO( :, 1,59,12) = (/&
&1.7311E-03_JPRB,2.1950E-03_JPRB,1.7464E-03_JPRB,1.1095E-03_JPRB,2.2810E-03_JPRB/)
KBO( :, 2,59,12) = (/&
&3.7867E-03_JPRB,5.0375E-03_JPRB,4.0622E-03_JPRB,2.6050E-03_JPRB,4.2229E-03_JPRB/)
KBO( :, 3,59,12) = (/&
&7.9927E-03_JPRB,1.0691E-02_JPRB,8.5872E-03_JPRB,5.5330E-03_JPRB,7.4637E-03_JPRB/)
KBO( :, 4,59,12) = (/&
&1.5706E-02_JPRB,2.0603E-02_JPRB,1.6559E-02_JPRB,1.0653E-02_JPRB,1.2338E-02_JPRB/)
KBO( :, 5,59,12) = (/&
&2.8614E-02_JPRB,3.6995E-02_JPRB,2.9703E-02_JPRB,1.9191E-02_JPRB,1.9178E-02_JPRB/)
KBO( :, 1,13,13) = (/&
&1.2852E+00_JPRB,1.0643E+00_JPRB,9.2423E-01_JPRB,7.7210E-01_JPRB,4.8560E+00_JPRB/)
KBO( :, 2,13,13) = (/&
&1.8300E+00_JPRB,1.5153E+00_JPRB,1.3056E+00_JPRB,1.0896E+00_JPRB,5.1762E+00_JPRB/)
KBO( :, 3,13,13) = (/&
&2.4898E+00_JPRB,2.0619E+00_JPRB,1.7781E+00_JPRB,1.4720E+00_JPRB,5.5995E+00_JPRB/)
KBO( :, 4,13,13) = (/&
&3.2580E+00_JPRB,2.7136E+00_JPRB,2.3379E+00_JPRB,1.9103E+00_JPRB,6.0006E+00_JPRB/)
KBO( :, 5,13,13) = (/&
&4.1344E+00_JPRB,3.4741E+00_JPRB,2.9826E+00_JPRB,2.3986E+00_JPRB,6.3254E+00_JPRB/)
KBO( :, 1,14,13) = (/&
&1.4353E+00_JPRB,1.1813E+00_JPRB,1.0097E+00_JPRB,8.1766E-01_JPRB,4.4364E+00_JPRB/)
KBO( :, 2,14,13) = (/&
&2.0320E+00_JPRB,1.6766E+00_JPRB,1.4217E+00_JPRB,1.1476E+00_JPRB,4.7777E+00_JPRB/)
KBO( :, 3,14,13) = (/&
&2.7397E+00_JPRB,2.2766E+00_JPRB,1.9164E+00_JPRB,1.5404E+00_JPRB,5.1956E+00_JPRB/)
KBO( :, 4,14,13) = (/&
&3.5525E+00_JPRB,2.9774E+00_JPRB,2.5038E+00_JPRB,1.9898E+00_JPRB,5.5579E+00_JPRB/)
KBO( :, 5,14,13) = (/&
&4.4583E+00_JPRB,3.7784E+00_JPRB,3.1767E+00_JPRB,2.5098E+00_JPRB,5.8954E+00_JPRB/)
KBO( :, 1,15,13) = (/&
&1.5785E+00_JPRB,1.3067E+00_JPRB,1.1097E+00_JPRB,8.6674E-01_JPRB,3.8492E+00_JPRB/)
KBO( :, 2,15,13) = (/&
&2.2125E+00_JPRB,1.8434E+00_JPRB,1.5563E+00_JPRB,1.2050E+00_JPRB,4.1968E+00_JPRB/)
KBO( :, 3,15,13) = (/&
&2.9595E+00_JPRB,2.4844E+00_JPRB,2.0889E+00_JPRB,1.6068E+00_JPRB,4.5453E+00_JPRB/)
KBO( :, 4,15,13) = (/&
&3.8045E+00_JPRB,3.2259E+00_JPRB,2.7088E+00_JPRB,2.0757E+00_JPRB,4.8945E+00_JPRB/)
KBO( :, 5,15,13) = (/&
&4.7324E+00_JPRB,4.0530E+00_JPRB,3.4024E+00_JPRB,2.6201E+00_JPRB,5.1308E+00_JPRB/)
KBO( :, 1,16,13) = (/&
&1.6990E+00_JPRB,1.4270E+00_JPRB,1.2197E+00_JPRB,9.1540E-01_JPRB,3.2967E+00_JPRB/)
KBO( :, 2,16,13) = (/&
&2.3632E+00_JPRB,1.9965E+00_JPRB,1.6991E+00_JPRB,1.2635E+00_JPRB,3.5992E+00_JPRB/)
KBO( :, 3,16,13) = (/&
&3.1332E+00_JPRB,2.6737E+00_JPRB,2.2662E+00_JPRB,1.6797E+00_JPRB,3.8825E+00_JPRB/)
KBO( :, 4,16,13) = (/&
&3.9954E+00_JPRB,3.4413E+00_JPRB,2.9150E+00_JPRB,2.1732E+00_JPRB,4.0955E+00_JPRB/)
KBO( :, 5,16,13) = (/&
&4.9441E+00_JPRB,4.2813E+00_JPRB,3.6296E+00_JPRB,2.7347E+00_JPRB,4.3356E+00_JPRB/)
KBO( :, 1,17,13) = (/&
&1.7867E+00_JPRB,1.5291E+00_JPRB,1.3172E+00_JPRB,9.6442E-01_JPRB,2.8946E+00_JPRB/)
KBO( :, 2,17,13) = (/&
&2.4630E+00_JPRB,2.1240E+00_JPRB,1.8197E+00_JPRB,1.3271E+00_JPRB,3.1209E+00_JPRB/)
KBO( :, 3,17,13) = (/&
&3.2412E+00_JPRB,2.8205E+00_JPRB,2.4120E+00_JPRB,1.7621E+00_JPRB,3.3231E+00_JPRB/)
KBO( :, 4,17,13) = (/&
&4.1129E+00_JPRB,3.6026E+00_JPRB,3.0785E+00_JPRB,2.2752E+00_JPRB,3.5467E+00_JPRB/)
KBO( :, 5,17,13) = (/&
&5.0518E+00_JPRB,4.4575E+00_JPRB,3.8174E+00_JPRB,2.8444E+00_JPRB,3.7869E+00_JPRB/)
KBO( :, 1,18,13) = (/&
&1.8395E+00_JPRB,1.6132E+00_JPRB,1.3961E+00_JPRB,1.0121E+00_JPRB,2.6255E+00_JPRB/)
KBO( :, 2,18,13) = (/&
&2.5106E+00_JPRB,2.2211E+00_JPRB,1.9179E+00_JPRB,1.3918E+00_JPRB,2.8074E+00_JPRB/)
KBO( :, 3,18,13) = (/&
&3.2840E+00_JPRB,2.9230E+00_JPRB,2.5216E+00_JPRB,1.8455E+00_JPRB,2.9886E+00_JPRB/)
KBO( :, 4,18,13) = (/&
&4.1398E+00_JPRB,3.7076E+00_JPRB,3.1995E+00_JPRB,2.3655E+00_JPRB,3.2033E+00_JPRB/)
KBO( :, 5,18,13) = (/&
&5.0652E+00_JPRB,4.5681E+00_JPRB,3.9586E+00_JPRB,2.9470E+00_JPRB,3.4431E+00_JPRB/)
KBO( :, 1,19,13) = (/&
&1.8429E+00_JPRB,1.6700E+00_JPRB,1.4536E+00_JPRB,1.0564E+00_JPRB,2.4577E+00_JPRB/)
KBO( :, 2,19,13) = (/&
&2.5022E+00_JPRB,2.2784E+00_JPRB,1.9833E+00_JPRB,1.4492E+00_JPRB,2.6093E+00_JPRB/)
KBO( :, 3,19,13) = (/&
&3.2520E+00_JPRB,2.9805E+00_JPRB,2.5894E+00_JPRB,1.9140E+00_JPRB,2.7860E+00_JPRB/)
KBO( :, 4,19,13) = (/&
&4.0807E+00_JPRB,3.7648E+00_JPRB,3.2792E+00_JPRB,2.4354E+00_JPRB,2.9804E+00_JPRB/)
KBO( :, 5,19,13) = (/&
&4.9680E+00_JPRB,4.6224E+00_JPRB,4.0395E+00_JPRB,3.0224E+00_JPRB,3.2175E+00_JPRB/)
KBO( :, 1,20,13) = (/&
&1.8228E+00_JPRB,1.7025E+00_JPRB,1.4928E+00_JPRB,1.0898E+00_JPRB,2.3654E+00_JPRB/)
KBO( :, 2,20,13) = (/&
&2.4538E+00_JPRB,2.3051E+00_JPRB,2.0204E+00_JPRB,1.4897E+00_JPRB,2.5217E+00_JPRB/)
KBO( :, 3,20,13) = (/&
&3.1699E+00_JPRB,2.9971E+00_JPRB,2.6320E+00_JPRB,1.9524E+00_JPRB,2.6999E+00_JPRB/)
KBO( :, 4,20,13) = (/&
&3.9554E+00_JPRB,3.7710E+00_JPRB,3.3175E+00_JPRB,2.4725E+00_JPRB,2.8911E+00_JPRB/)
KBO( :, 5,20,13) = (/&
&4.8063E+00_JPRB,4.6094E+00_JPRB,4.0741E+00_JPRB,3.0590E+00_JPRB,3.1232E+00_JPRB/)
KBO( :, 1,21,13) = (/&
&1.7623E+00_JPRB,1.7061E+00_JPRB,1.5006E+00_JPRB,1.1051E+00_JPRB,2.2987E+00_JPRB/)
KBO( :, 2,21,13) = (/&
&2.3568E+00_JPRB,2.2938E+00_JPRB,2.0241E+00_JPRB,1.5005E+00_JPRB,2.4810E+00_JPRB/)
KBO( :, 3,21,13) = (/&
&3.0264E+00_JPRB,2.9663E+00_JPRB,2.6252E+00_JPRB,1.9540E+00_JPRB,2.6709E+00_JPRB/)
KBO( :, 4,21,13) = (/&
&3.7661E+00_JPRB,3.7114E+00_JPRB,3.3017E+00_JPRB,2.4660E+00_JPRB,2.8739E+00_JPRB/)
KBO( :, 5,21,13) = (/&
&4.5709E+00_JPRB,4.5292E+00_JPRB,4.0353E+00_JPRB,3.0458E+00_JPRB,3.1122E+00_JPRB/)
KBO( :, 1,22,13) = (/&
&1.7051E+00_JPRB,1.7105E+00_JPRB,1.5137E+00_JPRB,1.1220E+00_JPRB,2.2215E+00_JPRB/)
KBO( :, 2,22,13) = (/&
&2.2594E+00_JPRB,2.2812E+00_JPRB,2.0265E+00_JPRB,1.5078E+00_JPRB,2.4273E+00_JPRB/)
KBO( :, 3,22,13) = (/&
&2.8843E+00_JPRB,2.9298E+00_JPRB,2.6159E+00_JPRB,1.9497E+00_JPRB,2.6344E+00_JPRB/)
KBO( :, 4,22,13) = (/&
&3.5784E+00_JPRB,3.6530E+00_JPRB,3.2699E+00_JPRB,2.4532E+00_JPRB,2.8571E+00_JPRB/)
KBO( :, 5,22,13) = (/&
&4.3282E+00_JPRB,4.4413E+00_JPRB,3.9817E+00_JPRB,3.0263E+00_JPRB,3.1138E+00_JPRB/)
KBO( :, 1,23,13) = (/&
&1.6227E+00_JPRB,1.6865E+00_JPRB,1.4987E+00_JPRB,1.1164E+00_JPRB,2.1516E+00_JPRB/)
KBO( :, 2,23,13) = (/&
&2.1334E+00_JPRB,2.2311E+00_JPRB,1.9947E+00_JPRB,1.4865E+00_JPRB,2.3714E+00_JPRB/)
KBO( :, 3,23,13) = (/&
&2.7130E+00_JPRB,2.8505E+00_JPRB,2.5601E+00_JPRB,1.9131E+00_JPRB,2.5957E+00_JPRB/)
KBO( :, 4,23,13) = (/&
&3.3545E+00_JPRB,3.5417E+00_JPRB,3.1845E+00_JPRB,2.4070E+00_JPRB,2.8423E+00_JPRB/)
KBO( :, 5,23,13) = (/&
&4.0511E+00_JPRB,4.2980E+00_JPRB,3.8824E+00_JPRB,2.9663E+00_JPRB,3.1097E+00_JPRB/)
KBO( :, 1,24,13) = (/&
&1.5221E+00_JPRB,1.6399E+00_JPRB,1.4631E+00_JPRB,1.0922E+00_JPRB,2.0557E+00_JPRB/)
KBO( :, 2,24,13) = (/&
&1.9909E+00_JPRB,2.1551E+00_JPRB,1.9333E+00_JPRB,1.4438E+00_JPRB,2.2893E+00_JPRB/)
KBO( :, 3,24,13) = (/&
&2.5227E+00_JPRB,2.7424E+00_JPRB,2.4670E+00_JPRB,1.8560E+00_JPRB,2.5308E+00_JPRB/)
KBO( :, 4,24,13) = (/&
&3.1132E+00_JPRB,3.3998E+00_JPRB,3.0690E+00_JPRB,2.3315E+00_JPRB,2.7959E+00_JPRB/)
KBO( :, 5,24,13) = (/&
&3.7625E+00_JPRB,4.1275E+00_JPRB,3.7502E+00_JPRB,2.8726E+00_JPRB,3.0711E+00_JPRB/)
KBO( :, 1,25,13) = (/&
&1.4164E+00_JPRB,1.5764E+00_JPRB,1.4120E+00_JPRB,1.0539E+00_JPRB,1.9710E+00_JPRB/)
KBO( :, 2,25,13) = (/&
&1.8451E+00_JPRB,2.0623E+00_JPRB,1.8523E+00_JPRB,1.3889E+00_JPRB,2.2117E+00_JPRB/)
KBO( :, 3,25,13) = (/&
&2.3323E+00_JPRB,2.6170E+00_JPRB,2.3560E+00_JPRB,1.7813E+00_JPRB,2.4702E+00_JPRB/)
KBO( :, 4,25,13) = (/&
&2.8785E+00_JPRB,3.2423E+00_JPRB,2.9353E+00_JPRB,2.2379E+00_JPRB,2.7415E+00_JPRB/)
KBO( :, 5,25,13) = (/&
&3.4748E+00_JPRB,3.9386E+00_JPRB,3.5958E+00_JPRB,2.7566E+00_JPRB,3.0246E+00_JPRB/)
KBO( :, 1,26,13) = (/&
&1.3174E+00_JPRB,1.5065E+00_JPRB,1.3505E+00_JPRB,1.0108E+00_JPRB,1.9092E+00_JPRB/)
KBO( :, 2,26,13) = (/&
&1.7100E+00_JPRB,1.9656E+00_JPRB,1.7614E+00_JPRB,1.3273E+00_JPRB,2.1568E+00_JPRB/)
KBO( :, 3,26,13) = (/&
&2.1599E+00_JPRB,2.4918E+00_JPRB,2.2424E+00_JPRB,1.7022E+00_JPRB,2.4251E+00_JPRB/)
KBO( :, 4,26,13) = (/&
&2.6619E+00_JPRB,3.0863E+00_JPRB,2.8007E+00_JPRB,2.1368E+00_JPRB,2.6974E+00_JPRB/)
KBO( :, 5,26,13) = (/&
&3.2164E+00_JPRB,3.7562E+00_JPRB,3.4382E+00_JPRB,2.6323E+00_JPRB,2.9897E+00_JPRB/)
KBO( :, 1,27,13) = (/&
&1.2227E+00_JPRB,1.4318E+00_JPRB,1.2776E+00_JPRB,9.6234E-01_JPRB,1.8084E+00_JPRB/)
KBO( :, 2,27,13) = (/&
&1.5845E+00_JPRB,1.8650E+00_JPRB,1.6669E+00_JPRB,1.2616E+00_JPRB,2.0606E+00_JPRB/)
KBO( :, 3,27,13) = (/&
&1.9986E+00_JPRB,2.3637E+00_JPRB,2.1255E+00_JPRB,1.6180E+00_JPRB,2.3235E+00_JPRB/)
KBO( :, 4,27,13) = (/&
&2.4670E+00_JPRB,2.9335E+00_JPRB,2.6606E+00_JPRB,2.0306E+00_JPRB,2.5979E+00_JPRB/)
KBO( :, 5,27,13) = (/&
&2.9836E+00_JPRB,3.5812E+00_JPRB,3.2799E+00_JPRB,2.5047E+00_JPRB,2.8940E+00_JPRB/)
KBO( :, 1,28,13) = (/&
&1.1382E+00_JPRB,1.3569E+00_JPRB,1.2047E+00_JPRB,9.1050E-01_JPRB,1.6756E+00_JPRB/)
KBO( :, 2,28,13) = (/&
&1.4731E+00_JPRB,1.7658E+00_JPRB,1.5747E+00_JPRB,1.1959E+00_JPRB,1.9259E+00_JPRB/)
KBO( :, 3,28,13) = (/&
&1.8595E+00_JPRB,2.2417E+00_JPRB,2.0136E+00_JPRB,1.5323E+00_JPRB,2.1797E+00_JPRB/)
KBO( :, 4,28,13) = (/&
&2.2933E+00_JPRB,2.7930E+00_JPRB,2.5304E+00_JPRB,1.9266E+00_JPRB,2.4581E+00_JPRB/)
KBO( :, 5,28,13) = (/&
&2.7792E+00_JPRB,3.4303E+00_JPRB,3.1288E+00_JPRB,2.3846E+00_JPRB,2.7569E+00_JPRB/)
KBO( :, 1,29,13) = (/&
&1.0690E+00_JPRB,1.2881E+00_JPRB,1.1394E+00_JPRB,8.6196E-01_JPRB,1.5316E+00_JPRB/)
KBO( :, 2,29,13) = (/&
&1.3833E+00_JPRB,1.6767E+00_JPRB,1.4909E+00_JPRB,1.1330E+00_JPRB,1.7636E+00_JPRB/)
KBO( :, 3,29,13) = (/&
&1.7418E+00_JPRB,2.1373E+00_JPRB,1.9152E+00_JPRB,1.4529E+00_JPRB,2.0079E+00_JPRB/)
KBO( :, 4,29,13) = (/&
&2.1520E+00_JPRB,2.6796E+00_JPRB,2.4158E+00_JPRB,1.8327E+00_JPRB,2.2752E+00_JPRB/)
KBO( :, 5,29,13) = (/&
&2.6198E+00_JPRB,3.3045E+00_JPRB,3.0000E+00_JPRB,2.2771E+00_JPRB,2.5616E+00_JPRB/)
KBO( :, 1,30,13) = (/&
&1.0127E+00_JPRB,1.2266E+00_JPRB,1.0797E+00_JPRB,8.1863E-01_JPRB,1.3724E+00_JPRB/)
KBO( :, 2,30,13) = (/&
&1.3069E+00_JPRB,1.6015E+00_JPRB,1.4185E+00_JPRB,1.0745E+00_JPRB,1.5829E+00_JPRB/)
KBO( :, 3,30,13) = (/&
&1.6487E+00_JPRB,2.0522E+00_JPRB,1.8302E+00_JPRB,1.3820E+00_JPRB,1.8153E+00_JPRB/)
KBO( :, 4,30,13) = (/&
&2.0473E+00_JPRB,2.5843E+00_JPRB,2.3209E+00_JPRB,1.7515E+00_JPRB,2.0659E+00_JPRB/)
KBO( :, 5,30,13) = (/&
&2.5092E+00_JPRB,3.2023E+00_JPRB,2.8969E+00_JPRB,2.1888E+00_JPRB,2.3374E+00_JPRB/)
KBO( :, 1,31,13) = (/&
&9.6510E-01_JPRB,1.1794E+00_JPRB,1.0308E+00_JPRB,7.7856E-01_JPRB,1.1918E+00_JPRB/)
KBO( :, 2,31,13) = (/&
&1.2477E+00_JPRB,1.5457E+00_JPRB,1.3619E+00_JPRB,1.0252E+00_JPRB,1.3817E+00_JPRB/)
KBO( :, 3,31,13) = (/&
&1.5837E+00_JPRB,1.9885E+00_JPRB,1.7652E+00_JPRB,1.3248E+00_JPRB,1.5914E+00_JPRB/)
KBO( :, 4,31,13) = (/&
&1.9797E+00_JPRB,2.5159E+00_JPRB,2.2496E+00_JPRB,1.6880E+00_JPRB,1.8169E+00_JPRB/)
KBO( :, 5,31,13) = (/&
&2.4397E+00_JPRB,3.1333E+00_JPRB,2.8243E+00_JPRB,2.1253E+00_JPRB,2.0691E+00_JPRB/)
KBO( :, 1,32,13) = (/&
&9.2809E-01_JPRB,1.1462E+00_JPRB,9.9628E-01_JPRB,7.4536E-01_JPRB,1.0320E+00_JPRB/)
KBO( :, 2,32,13) = (/&
&1.2071E+00_JPRB,1.5069E+00_JPRB,1.3205E+00_JPRB,9.8597E-01_JPRB,1.2033E+00_JPRB/)
KBO( :, 3,32,13) = (/&
&1.5432E+00_JPRB,1.9476E+00_JPRB,1.7191E+00_JPRB,1.2835E+00_JPRB,1.3897E+00_JPRB/)
KBO( :, 4,32,13) = (/&
&1.9406E+00_JPRB,2.4766E+00_JPRB,2.2038E+00_JPRB,1.6458E+00_JPRB,1.5971E+00_JPRB/)
KBO( :, 5,32,13) = (/&
&2.3994E+00_JPRB,3.0984E+00_JPRB,2.7844E+00_JPRB,2.0892E+00_JPRB,1.8364E+00_JPRB/)
KBO( :, 1,33,13) = (/&
&9.0452E-01_JPRB,1.1258E+00_JPRB,9.7321E-01_JPRB,7.2002E-01_JPRB,8.8562E-01_JPRB/)
KBO( :, 2,33,13) = (/&
&1.1846E+00_JPRB,1.4864E+00_JPRB,1.2941E+00_JPRB,9.5876E-01_JPRB,1.0371E+00_JPRB/)
KBO( :, 3,33,13) = (/&
&1.5214E+00_JPRB,1.9311E+00_JPRB,1.6937E+00_JPRB,1.2572E+00_JPRB,1.2046E+00_JPRB/)
KBO( :, 4,33,13) = (/&
&1.9196E+00_JPRB,2.4657E+00_JPRB,2.1858E+00_JPRB,1.6239E+00_JPRB,1.3977E+00_JPRB/)
KBO( :, 5,33,13) = (/&
&2.3836E+00_JPRB,3.1007E+00_JPRB,2.7768E+00_JPRB,2.0781E+00_JPRB,1.6273E+00_JPRB/)
KBO( :, 1,34,13) = (/&
&8.8467E-01_JPRB,1.1068E+00_JPRB,9.5054E-01_JPRB,6.9629E-01_JPRB,7.8494E-01_JPRB/)
KBO( :, 2,34,13) = (/&
&1.1642E+00_JPRB,1.4706E+00_JPRB,1.2717E+00_JPRB,9.3470E-01_JPRB,9.2138E-01_JPRB/)
KBO( :, 3,34,13) = (/&
&1.5015E+00_JPRB,1.9181E+00_JPRB,1.6758E+00_JPRB,1.2345E+00_JPRB,1.0773E+00_JPRB/)
KBO( :, 4,34,13) = (/&
&1.9018E+00_JPRB,2.4632E+00_JPRB,2.1759E+00_JPRB,1.6080E+00_JPRB,1.2614E+00_JPRB/)
KBO( :, 5,34,13) = (/&
&2.3740E+00_JPRB,3.1145E+00_JPRB,2.7821E+00_JPRB,2.0712E+00_JPRB,1.4792E+00_JPRB/)
KBO( :, 1,35,13) = (/&
&8.4955E-01_JPRB,1.0688E+00_JPRB,9.1231E-01_JPRB,6.6202E-01_JPRB,6.7824E-01_JPRB/)
KBO( :, 2,35,13) = (/&
&1.1250E+00_JPRB,1.4313E+00_JPRB,1.2303E+00_JPRB,8.9698E-01_JPRB,8.0193E-01_JPRB/)
KBO( :, 3,35,13) = (/&
&1.4599E+00_JPRB,1.8791E+00_JPRB,1.6347E+00_JPRB,1.1945E+00_JPRB,9.4771E-01_JPRB/)
KBO( :, 4,35,13) = (/&
&1.8617E+00_JPRB,2.4289E+00_JPRB,2.1382E+00_JPRB,1.5703E+00_JPRB,1.1239E+00_JPRB/)
KBO( :, 5,35,13) = (/&
&2.3371E+00_JPRB,3.0886E+00_JPRB,2.7503E+00_JPRB,2.0370E+00_JPRB,1.3258E+00_JPRB/)
KBO( :, 1,36,13) = (/&
&7.9554E-01_JPRB,1.0086E+00_JPRB,8.5573E-01_JPRB,6.1485E-01_JPRB,5.7027E-01_JPRB/)
KBO( :, 2,36,13) = (/&
&1.0642E+00_JPRB,1.3634E+00_JPRB,1.1652E+00_JPRB,8.4197E-01_JPRB,6.8378E-01_JPRB/)
KBO( :, 3,36,13) = (/&
&1.3924E+00_JPRB,1.8049E+00_JPRB,1.5634E+00_JPRB,1.1326E+00_JPRB,8.2218E-01_JPRB/)
KBO( :, 4,36,13) = (/&
&1.7900E+00_JPRB,2.3512E+00_JPRB,2.0607E+00_JPRB,1.5026E+00_JPRB,9.8859E-01_JPRB/)
KBO( :, 5,36,13) = (/&
&2.2630E+00_JPRB,3.0065E+00_JPRB,2.6687E+00_JPRB,1.9640E+00_JPRB,1.1762E+00_JPRB/)
KBO( :, 1,37,13) = (/&
&7.1417E-01_JPRB,9.1309E-01_JPRB,7.7089E-01_JPRB,5.4803E-01_JPRB,4.9622E-01_JPRB/)
KBO( :, 2,37,13) = (/&
&9.6913E-01_JPRB,1.2512E+00_JPRB,1.0630E+00_JPRB,7.6043E-01_JPRB,5.9797E-01_JPRB/)
KBO( :, 3,37,13) = (/&
&1.2840E+00_JPRB,1.6746E+00_JPRB,1.4416E+00_JPRB,1.0353E+00_JPRB,7.2233E-01_JPRB/)
KBO( :, 4,37,13) = (/&
&1.6678E+00_JPRB,2.2008E+00_JPRB,1.9187E+00_JPRB,1.3875E+00_JPRB,8.7304E-01_JPRB/)
KBO( :, 5,37,13) = (/&
&2.1271E+00_JPRB,2.8380E+00_JPRB,2.5062E+00_JPRB,1.8314E+00_JPRB,1.0444E+00_JPRB/)
KBO( :, 1,38,13) = (/&
&6.4094E-01_JPRB,8.2768E-01_JPRB,6.9645E-01_JPRB,4.8972E-01_JPRB,4.2782E-01_JPRB/)
KBO( :, 2,38,13) = (/&
&8.8268E-01_JPRB,1.1499E+00_JPRB,9.7252E-01_JPRB,6.8901E-01_JPRB,5.1817E-01_JPRB/)
KBO( :, 3,38,13) = (/&
&1.1854E+00_JPRB,1.5567E+00_JPRB,1.3326E+00_JPRB,9.4875E-01_JPRB,6.2911E-01_JPRB/)
KBO( :, 4,38,13) = (/&
&1.5548E+00_JPRB,2.0633E+00_JPRB,1.7903E+00_JPRB,1.2846E+00_JPRB,7.6404E-01_JPRB/)
KBO( :, 5,38,13) = (/&
&2.0005E+00_JPRB,2.6819E+00_JPRB,2.3577E+00_JPRB,1.7108E+00_JPRB,9.1910E-01_JPRB/)
KBO( :, 1,39,13) = (/&
&5.7700E-01_JPRB,7.5348E-01_JPRB,6.3234E-01_JPRB,4.4039E-01_JPRB,3.6316E-01_JPRB/)
KBO( :, 2,39,13) = (/&
&8.0617E-01_JPRB,1.0607E+00_JPRB,8.9464E-01_JPRB,6.2787E-01_JPRB,4.4256E-01_JPRB/)
KBO( :, 3,39,13) = (/&
&1.0971E+00_JPRB,1.4528E+00_JPRB,1.2371E+00_JPRB,8.7381E-01_JPRB,5.4063E-01_JPRB/)
KBO( :, 4,39,13) = (/&
&1.4539E+00_JPRB,1.9409E+00_JPRB,1.6768E+00_JPRB,1.1946E+00_JPRB,6.6034E-01_JPRB/)
KBO( :, 5,39,13) = (/&
&1.8880E+00_JPRB,2.5419E+00_JPRB,2.2244E+00_JPRB,1.6039E+00_JPRB,7.9890E-01_JPRB/)
KBO( :, 1,40,13) = (/&
&5.0186E-01_JPRB,6.6294E-01_JPRB,5.5500E-01_JPRB,3.8289E-01_JPRB,3.1769E-01_JPRB/)
KBO( :, 2,40,13) = (/&
&7.1323E-01_JPRB,9.4798E-01_JPRB,7.9752E-01_JPRB,5.5384E-01_JPRB,3.8877E-01_JPRB/)
KBO( :, 3,40,13) = (/&
&9.8586E-01_JPRB,1.3164E+00_JPRB,1.1157E+00_JPRB,7.8136E-01_JPRB,4.7618E-01_JPRB/)
KBO( :, 4,40,13) = (/&
&1.3258E+00_JPRB,1.7781E+00_JPRB,1.5269E+00_JPRB,1.0795E+00_JPRB,5.8462E-01_JPRB/)
KBO( :, 5,40,13) = (/&
&1.7397E+00_JPRB,2.3496E+00_JPRB,2.0447E+00_JPRB,1.4640E+00_JPRB,7.1183E-01_JPRB/)
KBO( :, 1,41,13) = (/&
&4.3380E-01_JPRB,5.8097E-01_JPRB,4.8476E-01_JPRB,3.3186E-01_JPRB,2.7762E-01_JPRB/)
KBO( :, 2,41,13) = (/&
&6.2819E-01_JPRB,8.4375E-01_JPRB,7.0798E-01_JPRB,4.8718E-01_JPRB,3.4151E-01_JPRB/)
KBO( :, 3,41,13) = (/&
&8.8231E-01_JPRB,1.1885E+00_JPRB,1.0030E+00_JPRB,6.9676E-01_JPRB,4.1944E-01_JPRB/)
KBO( :, 4,41,13) = (/&
&1.2044E+00_JPRB,1.6239E+00_JPRB,1.3862E+00_JPRB,9.7292E-01_JPRB,5.1737E-01_JPRB/)
KBO( :, 5,41,13) = (/&
&1.5976E+00_JPRB,2.1644E+00_JPRB,1.8733E+00_JPRB,1.3324E+00_JPRB,6.3382E-01_JPRB/)
KBO( :, 1,42,13) = (/&
&3.7449E-01_JPRB,5.0898E-01_JPRB,4.2337E-01_JPRB,2.8788E-01_JPRB,2.4070E-01_JPRB/)
KBO( :, 2,42,13) = (/&
&5.5270E-01_JPRB,7.5038E-01_JPRB,6.2836E-01_JPRB,4.2892E-01_JPRB,2.9753E-01_JPRB/)
KBO( :, 3,42,13) = (/&
&7.8906E-01_JPRB,1.0722E+00_JPRB,9.0203E-01_JPRB,6.2172E-01_JPRB,3.6699E-01_JPRB/)
KBO( :, 4,42,13) = (/&
&1.0928E+00_JPRB,1.4824E+00_JPRB,1.2591E+00_JPRB,8.7750E-01_JPRB,4.5486E-01_JPRB/)
KBO( :, 5,42,13) = (/&
&1.4670E+00_JPRB,1.9931E+00_JPRB,1.7165E+00_JPRB,1.2130E+00_JPRB,5.6051E-01_JPRB/)
KBO( :, 1,43,13) = (/&
&3.1535E-01_JPRB,4.3481E-01_JPRB,3.6057E-01_JPRB,2.4367E-01_JPRB,2.0825E-01_JPRB/)
KBO( :, 2,43,13) = (/&
&4.7503E-01_JPRB,6.5262E-01_JPRB,5.4494E-01_JPRB,3.6943E-01_JPRB,2.5841E-01_JPRB/)
KBO( :, 3,43,13) = (/&
&6.9119E-01_JPRB,9.4733E-01_JPRB,7.9475E-01_JPRB,5.4324E-01_JPRB,3.1952E-01_JPRB/)
KBO( :, 4,43,13) = (/&
&9.7283E-01_JPRB,1.3279E+00_JPRB,1.1223E+00_JPRB,7.7674E-01_JPRB,3.9652E-01_JPRB/)
KBO( :, 5,43,13) = (/&
&1.3243E+00_JPRB,1.8050E+00_JPRB,1.5450E+00_JPRB,1.0849E+00_JPRB,4.9087E-01_JPRB/)
KBO( :, 1,44,13) = (/&
&2.6174E-01_JPRB,3.6590E-01_JPRB,3.0263E-01_JPRB,2.0344E-01_JPRB,1.7938E-01_JPRB/)
KBO( :, 2,44,13) = (/&
&4.0277E-01_JPRB,5.6056E-01_JPRB,4.6662E-01_JPRB,3.1442E-01_JPRB,2.2338E-01_JPRB/)
KBO( :, 3,44,13) = (/&
&5.9777E-01_JPRB,8.2704E-01_JPRB,6.9190E-01_JPRB,4.6961E-01_JPRB,2.7697E-01_JPRB/)
KBO( :, 4,44,13) = (/&
&8.5584E-01_JPRB,1.1770E+00_JPRB,9.9059E-01_JPRB,6.8041E-01_JPRB,3.4323E-01_JPRB/)
KBO( :, 5,44,13) = (/&
&1.1839E+00_JPRB,1.6189E+00_JPRB,1.3779E+00_JPRB,9.6037E-01_JPRB,4.2597E-01_JPRB/)
KBO( :, 1,45,13) = (/&
&2.1651E-01_JPRB,3.0623E-01_JPRB,2.5303E-01_JPRB,1.6909E-01_JPRB,1.5286E-01_JPRB/)
KBO( :, 2,45,13) = (/&
&3.3998E-01_JPRB,4.7944E-01_JPRB,3.9799E-01_JPRB,2.6665E-01_JPRB,1.9138E-01_JPRB/)
KBO( :, 3,45,13) = (/&
&5.1505E-01_JPRB,7.1915E-01_JPRB,6.0047E-01_JPRB,4.0501E-01_JPRB,2.3804E-01_JPRB/)
KBO( :, 4,45,13) = (/&
&7.5069E-01_JPRB,1.0392E+00_JPRB,8.7233E-01_JPRB,5.9477E-01_JPRB,2.9472E-01_JPRB/)
KBO( :, 5,45,13) = (/&
&1.0546E+00_JPRB,1.4482E+00_JPRB,1.2265E+00_JPRB,8.4853E-01_JPRB,3.6589E-01_JPRB/)
KBO( :, 1,46,13) = (/&
&1.7663E-01_JPRB,2.5198E-01_JPRB,2.0821E-01_JPRB,1.3852E-01_JPRB,1.2920E-01_JPRB/)
KBO( :, 2,46,13) = (/&
&2.8312E-01_JPRB,4.0392E-01_JPRB,3.3454E-01_JPRB,2.2297E-01_JPRB,1.6315E-01_JPRB/)
KBO( :, 3,46,13) = (/&
&4.3787E-01_JPRB,6.1746E-01_JPRB,5.1421E-01_JPRB,3.4506E-01_JPRB,2.0329E-01_JPRB/)
KBO( :, 4,46,13) = (/&
&6.5040E-01_JPRB,9.0658E-01_JPRB,7.5889E-01_JPRB,5.1408E-01_JPRB,2.5188E-01_JPRB/)
KBO( :, 5,46,13) = (/&
&9.2878E-01_JPRB,1.2821E+00_JPRB,1.0808E+00_JPRB,7.4274E-01_JPRB,3.1240E-01_JPRB/)
KBO( :, 1,47,13) = (/&
&1.4044E-01_JPRB,2.0128E-01_JPRB,1.6621E-01_JPRB,1.1051E-01_JPRB,1.0897E-01_JPRB/)
KBO( :, 2,47,13) = (/&
&2.3004E-01_JPRB,3.3154E-01_JPRB,2.7419E-01_JPRB,1.8180E-01_JPRB,1.3962E-01_JPRB/)
KBO( :, 3,47,13) = (/&
&3.6325E-01_JPRB,5.1821E-01_JPRB,4.3034E-01_JPRB,2.8728E-01_JPRB,1.7431E-01_JPRB/)
KBO( :, 4,47,13) = (/&
&5.5117E-01_JPRB,7.7483E-01_JPRB,6.4673E-01_JPRB,4.3554E-01_JPRB,2.1654E-01_JPRB/)
KBO( :, 5,47,13) = (/&
&8.0200E-01_JPRB,1.1139E+00_JPRB,9.3561E-01_JPRB,6.3799E-01_JPRB,2.6782E-01_JPRB/)
KBO( :, 1,48,13) = (/&
&1.1101E-01_JPRB,1.5927E-01_JPRB,1.3139E-01_JPRB,8.7527E-02_JPRB,9.0201E-02_JPRB/)
KBO( :, 2,48,13) = (/&
&1.8567E-01_JPRB,2.6968E-01_JPRB,2.2270E-01_JPRB,1.4710E-01_JPRB,1.1764E-01_JPRB/)
KBO( :, 3,48,13) = (/&
&2.9933E-01_JPRB,4.3159E-01_JPRB,3.5753E-01_JPRB,2.3730E-01_JPRB,1.4811E-01_JPRB/)
KBO( :, 4,48,13) = (/&
&4.6369E-01_JPRB,6.5797E-01_JPRB,5.4789E-01_JPRB,3.6706E-01_JPRB,1.8402E-01_JPRB/)
KBO( :, 5,48,13) = (/&
&6.8807E-01_JPRB,9.6214E-01_JPRB,8.0577E-01_JPRB,5.4570E-01_JPRB,2.2761E-01_JPRB/)
KBO( :, 1,49,13) = (/&
&8.6952E-02_JPRB,1.2481E-01_JPRB,1.0270E-01_JPRB,6.8735E-02_JPRB,7.2916E-02_JPRB/)
KBO( :, 2,49,13) = (/&
&1.4886E-01_JPRB,2.1718E-01_JPRB,1.7934E-01_JPRB,1.1829E-01_JPRB,9.6830E-02_JPRB/)
KBO( :, 3,49,13) = (/&
&2.4507E-01_JPRB,3.5657E-01_JPRB,2.9496E-01_JPRB,1.9481E-01_JPRB,1.2384E-01_JPRB/)
KBO( :, 4,49,13) = (/&
&3.8722E-01_JPRB,5.5518E-01_JPRB,4.6109E-01_JPRB,3.0744E-01_JPRB,1.5413E-01_JPRB/)
KBO( :, 5,49,13) = (/&
&5.8631E-01_JPRB,8.2602E-01_JPRB,6.8968E-01_JPRB,4.6440E-01_JPRB,1.9058E-01_JPRB/)
KBO( :, 1,50,13) = (/&
&6.8423E-02_JPRB,9.8362E-02_JPRB,8.0813E-02_JPRB,5.4318E-02_JPRB,6.0640E-02_JPRB/)
KBO( :, 2,50,13) = (/&
&1.2024E-01_JPRB,1.7560E-01_JPRB,1.4487E-01_JPRB,9.5713E-02_JPRB,8.2094E-02_JPRB/)
KBO( :, 3,50,13) = (/&
&2.0188E-01_JPRB,2.9561E-01_JPRB,2.4418E-01_JPRB,1.6072E-01_JPRB,1.0662E-01_JPRB/)
KBO( :, 4,50,13) = (/&
&3.2485E-01_JPRB,4.7020E-01_JPRB,3.8945E-01_JPRB,2.5843E-01_JPRB,1.3377E-01_JPRB/)
KBO( :, 5,50,13) = (/&
&5.0116E-01_JPRB,7.1185E-01_JPRB,5.9284E-01_JPRB,3.9734E-01_JPRB,1.6547E-01_JPRB/)
KBO( :, 1,51,13) = (/&
&5.3728E-02_JPRB,7.7475E-02_JPRB,6.3575E-02_JPRB,4.2812E-02_JPRB,5.0933E-02_JPRB/)
KBO( :, 2,51,13) = (/&
&9.7035E-02_JPRB,1.4176E-01_JPRB,1.1670E-01_JPRB,7.7313E-02_JPRB,7.0361E-02_JPRB/)
KBO( :, 3,51,13) = (/&
&1.6618E-01_JPRB,2.4447E-01_JPRB,2.0180E-01_JPRB,1.3255E-01_JPRB,9.2830E-02_JPRB/)
KBO( :, 4,51,13) = (/&
&2.7241E-01_JPRB,3.9733E-01_JPRB,3.2861E-01_JPRB,2.1702E-01_JPRB,1.1799E-01_JPRB/)
KBO( :, 5,51,13) = (/&
&4.2784E-01_JPRB,6.1277E-01_JPRB,5.0908E-01_JPRB,3.3984E-01_JPRB,1.4641E-01_JPRB/)
KBO( :, 1,52,13) = (/&
&4.1802E-02_JPRB,6.0502E-02_JPRB,4.9697E-02_JPRB,3.3504E-02_JPRB,4.2023E-02_JPRB/)
KBO( :, 2,52,13) = (/&
&7.7722E-02_JPRB,1.1354E-01_JPRB,9.3251E-02_JPRB,6.2061E-02_JPRB,5.9351E-02_JPRB/)
KBO( :, 3,52,13) = (/&
&1.3608E-01_JPRB,2.0057E-01_JPRB,1.6557E-01_JPRB,1.0873E-01_JPRB,7.9645E-02_JPRB/)
KBO( :, 4,52,13) = (/&
&2.2730E-01_JPRB,3.3353E-01_JPRB,2.7571E-01_JPRB,1.8131E-01_JPRB,1.0280E-01_JPRB/)
KBO( :, 5,52,13) = (/&
&3.6299E-01_JPRB,5.2462E-01_JPRB,4.3487E-01_JPRB,2.8905E-01_JPRB,1.2859E-01_JPRB/)
KBO( :, 1,53,13) = (/&
&3.2183E-02_JPRB,4.6680E-02_JPRB,3.8481E-02_JPRB,2.6042E-02_JPRB,3.3756E-02_JPRB/)
KBO( :, 2,53,13) = (/&
&6.1728E-02_JPRB,9.0133E-02_JPRB,7.3973E-02_JPRB,4.9381E-02_JPRB,4.8993E-02_JPRB/)
KBO( :, 3,53,13) = (/&
&1.1077E-01_JPRB,1.6319E-01_JPRB,1.3454E-01_JPRB,8.8555E-02_JPRB,6.7056E-02_JPRB/)
KBO( :, 4,53,13) = (/&
&1.8844E-01_JPRB,2.7785E-01_JPRB,2.2936E-01_JPRB,1.5042E-01_JPRB,8.7934E-02_JPRB/)
KBO( :, 5,53,13) = (/&
&3.0619E-01_JPRB,4.4605E-01_JPRB,3.6897E-01_JPRB,2.4410E-01_JPRB,1.1120E-01_JPRB/)
KBO( :, 1,54,13) = (/&
&2.5047E-02_JPRB,3.6400E-02_JPRB,3.0153E-02_JPRB,2.0502E-02_JPRB,2.9038E-02_JPRB/)
KBO( :, 2,54,13) = (/&
&4.9509E-02_JPRB,7.2463E-02_JPRB,5.9428E-02_JPRB,3.9713E-02_JPRB,4.3296E-02_JPRB/)
KBO( :, 3,54,13) = (/&
&9.1047E-02_JPRB,1.3408E-01_JPRB,1.1032E-01_JPRB,7.2811E-02_JPRB,6.0352E-02_JPRB/)
KBO( :, 4,54,13) = (/&
&1.5773E-01_JPRB,2.3322E-01_JPRB,1.9256E-01_JPRB,1.2610E-01_JPRB,8.0247E-02_JPRB/)
KBO( :, 5,54,13) = (/&
&2.6064E-01_JPRB,3.8195E-01_JPRB,3.1567E-01_JPRB,2.0798E-01_JPRB,1.0268E-01_JPRB/)
KBO( :, 1,55,13) = (/&
&1.9531E-02_JPRB,2.8409E-02_JPRB,2.3654E-02_JPRB,1.6169E-02_JPRB,2.6016E-02_JPRB/)
KBO( :, 2,55,13) = (/&
&3.9731E-02_JPRB,5.8300E-02_JPRB,4.7864E-02_JPRB,3.2046E-02_JPRB,3.9891E-02_JPRB/)
KBO( :, 3,55,13) = (/&
&7.5011E-02_JPRB,1.1035E-01_JPRB,9.0609E-02_JPRB,6.0025E-02_JPRB,5.6691E-02_JPRB/)
KBO( :, 4,55,13) = (/&
&1.3239E-01_JPRB,1.9599E-01_JPRB,1.6178E-01_JPRB,1.0597E-01_JPRB,7.6430E-02_JPRB/)
KBO( :, 5,55,13) = (/&
&2.2232E-01_JPRB,3.2737E-01_JPRB,2.7053E-01_JPRB,1.7756E-01_JPRB,9.9052E-02_JPRB/)
KBO( :, 1,56,13) = (/&
&1.5085E-02_JPRB,2.1991E-02_JPRB,1.8385E-02_JPRB,1.2629E-02_JPRB,2.3210E-02_JPRB/)
KBO( :, 2,56,13) = (/&
&3.1640E-02_JPRB,4.6519E-02_JPRB,3.8293E-02_JPRB,2.5741E-02_JPRB,3.6554E-02_JPRB/)
KBO( :, 3,56,13) = (/&
&6.1401E-02_JPRB,9.0252E-02_JPRB,7.4044E-02_JPRB,4.9175E-02_JPRB,5.3168E-02_JPRB/)
KBO( :, 4,56,13) = (/&
&1.1069E-01_JPRB,1.6371E-01_JPRB,1.3502E-01_JPRB,8.8647E-02_JPRB,7.2863E-02_JPRB/)
KBO( :, 5,56,13) = (/&
&1.8882E-01_JPRB,2.7905E-01_JPRB,2.3042E-01_JPRB,1.5088E-01_JPRB,9.5532E-02_JPRB/)
KBO( :, 1,57,13) = (/&
&1.1497E-02_JPRB,1.6861E-02_JPRB,1.4167E-02_JPRB,9.7433E-03_JPRB,2.0535E-02_JPRB/)
KBO( :, 2,57,13) = (/&
&2.4982E-02_JPRB,3.6767E-02_JPRB,3.0405E-02_JPRB,2.0539E-02_JPRB,3.3381E-02_JPRB/)
KBO( :, 3,57,13) = (/&
&4.9863E-02_JPRB,7.3408E-02_JPRB,6.0172E-02_JPRB,4.0018E-02_JPRB,4.9853E-02_JPRB/)
KBO( :, 4,57,13) = (/&
&9.1973E-02_JPRB,1.3592E-01_JPRB,1.1188E-01_JPRB,7.3644E-02_JPRB,6.9368E-02_JPRB/)
KBO( :, 5,57,13) = (/&
&1.5956E-01_JPRB,2.3633E-01_JPRB,1.9520E-01_JPRB,1.2765E-01_JPRB,9.2143E-02_JPRB/)
KBO( :, 1,58,13) = (/&
&8.7557E-03_JPRB,1.2987E-02_JPRB,1.0957E-02_JPRB,7.5300E-03_JPRB,1.8437E-02_JPRB/)
KBO( :, 2,58,13) = (/&
&1.9822E-02_JPRB,2.9153E-02_JPRB,2.4235E-02_JPRB,1.6460E-02_JPRB,3.1052E-02_JPRB/)
KBO( :, 3,58,13) = (/&
&4.0615E-02_JPRB,5.9904E-02_JPRB,4.9134E-02_JPRB,3.2752E-02_JPRB,4.7553E-02_JPRB/)
KBO( :, 4,58,13) = (/&
&7.6749E-02_JPRB,1.1326E-01_JPRB,9.3033E-02_JPRB,6.1446E-02_JPRB,6.7327E-02_JPRB/)
KBO( :, 5,58,13) = (/&
&1.3538E-01_JPRB,2.0081E-01_JPRB,1.6583E-01_JPRB,1.0846E-01_JPRB,9.0540E-02_JPRB/)
KBO( :, 1,59,13) = (/&
&7.7834E-03_JPRB,1.1635E-02_JPRB,9.8237E-03_JPRB,6.7346E-03_JPRB,2.0567E-02_JPRB/)
KBO( :, 2,59,13) = (/&
&1.7968E-02_JPRB,2.6456E-02_JPRB,2.2028E-02_JPRB,1.4988E-02_JPRB,3.5300E-02_JPRB/)
KBO( :, 3,59,13) = (/&
&3.7275E-02_JPRB,5.5026E-02_JPRB,4.5163E-02_JPRB,3.0132E-02_JPRB,5.4587E-02_JPRB/)
KBO( :, 4,59,13) = (/&
&7.1187E-02_JPRB,1.0502E-01_JPRB,8.6201E-02_JPRB,5.6998E-02_JPRB,7.7965E-02_JPRB/)
KBO( :, 5,59,13) = (/&
&1.2652E-01_JPRB,1.8769E-01_JPRB,1.5496E-01_JPRB,1.0142E-01_JPRB,1.0516E-01_JPRB/)
KBO( :, 1,13,14) = (/&
&2.2524E+00_JPRB,1.8642E+00_JPRB,1.4613E+00_JPRB,1.4569E+00_JPRB,8.7601E+00_JPRB/)
KBO( :, 2,13,14) = (/&
&3.1331E+00_JPRB,2.6017E+00_JPRB,2.0765E+00_JPRB,2.1108E+00_JPRB,8.6837E+00_JPRB/)
KBO( :, 3,13,14) = (/&
&4.2161E+00_JPRB,3.4975E+00_JPRB,2.8332E+00_JPRB,2.9400E+00_JPRB,8.5967E+00_JPRB/)
KBO( :, 4,13,14) = (/&
&5.4742E+00_JPRB,4.5326E+00_JPRB,3.7176E+00_JPRB,3.9461E+00_JPRB,8.5509E+00_JPRB/)
KBO( :, 5,13,14) = (/&
&6.8794E+00_JPRB,5.6742E+00_JPRB,4.7180E+00_JPRB,5.1201E+00_JPRB,8.7332E+00_JPRB/)
KBO( :, 1,14,14) = (/&
&2.4300E+00_JPRB,2.0099E+00_JPRB,1.6039E+00_JPRB,1.5951E+00_JPRB,7.9998E+00_JPRB/)
KBO( :, 2,14,14) = (/&
&3.3671E+00_JPRB,2.7809E+00_JPRB,2.2722E+00_JPRB,2.2861E+00_JPRB,7.9399E+00_JPRB/)
KBO( :, 3,14,14) = (/&
&4.5098E+00_JPRB,3.7249E+00_JPRB,3.1058E+00_JPRB,3.1479E+00_JPRB,7.9396E+00_JPRB/)
KBO( :, 4,14,14) = (/&
&5.8479E+00_JPRB,4.8327E+00_JPRB,4.0848E+00_JPRB,4.1748E+00_JPRB,8.0204E+00_JPRB/)
KBO( :, 5,14,14) = (/&
&7.3485E+00_JPRB,6.0867E+00_JPRB,5.1845E+00_JPRB,5.3505E+00_JPRB,8.4765E+00_JPRB/)
KBO( :, 1,15,14) = (/&
&2.6568E+00_JPRB,2.1796E+00_JPRB,1.7854E+00_JPRB,1.7352E+00_JPRB,6.7060E+00_JPRB/)
KBO( :, 2,15,14) = (/&
&3.6822E+00_JPRB,3.0192E+00_JPRB,2.5118E+00_JPRB,2.4660E+00_JPRB,6.7632E+00_JPRB/)
KBO( :, 3,15,14) = (/&
&4.9145E+00_JPRB,4.0419E+00_JPRB,3.4197E+00_JPRB,3.3625E+00_JPRB,6.9344E+00_JPRB/)
KBO( :, 4,15,14) = (/&
&6.3536E+00_JPRB,5.2540E+00_JPRB,4.4910E+00_JPRB,4.4107E+00_JPRB,7.2734E+00_JPRB/)
KBO( :, 5,15,14) = (/&
&7.9751E+00_JPRB,6.6376E+00_JPRB,5.7127E+00_JPRB,5.6036E+00_JPRB,8.1653E+00_JPRB/)
KBO( :, 1,16,14) = (/&
&2.9427E+00_JPRB,2.4019E+00_JPRB,1.9918E+00_JPRB,1.8807E+00_JPRB,5.4890E+00_JPRB/)
KBO( :, 2,16,14) = (/&
&4.0755E+00_JPRB,3.3334E+00_JPRB,2.7941E+00_JPRB,2.6497E+00_JPRB,5.7267E+00_JPRB/)
KBO( :, 3,16,14) = (/&
&5.4183E+00_JPRB,4.4587E+00_JPRB,3.7848E+00_JPRB,3.5786E+00_JPRB,6.0751E+00_JPRB/)
KBO( :, 4,16,14) = (/&
&6.9849E+00_JPRB,5.7895E+00_JPRB,4.9533E+00_JPRB,4.6688E+00_JPRB,6.8712E+00_JPRB/)
KBO( :, 5,16,14) = (/&
&8.7453E+00_JPRB,7.3192E+00_JPRB,6.3031E+00_JPRB,5.9185E+00_JPRB,8.0451E+00_JPRB/)
KBO( :, 1,17,14) = (/&
&3.2750E+00_JPRB,2.6726E+00_JPRB,2.2378E+00_JPRB,2.0301E+00_JPRB,4.7640E+00_JPRB/)
KBO( :, 2,17,14) = (/&
&4.5330E+00_JPRB,3.7089E+00_JPRB,3.1283E+00_JPRB,2.8374E+00_JPRB,5.1281E+00_JPRB/)
KBO( :, 3,17,14) = (/&
&6.0126E+00_JPRB,4.9507E+00_JPRB,4.2109E+00_JPRB,3.8046E+00_JPRB,5.7513E+00_JPRB/)
KBO( :, 4,17,14) = (/&
&7.7135E+00_JPRB,6.4169E+00_JPRB,5.4921E+00_JPRB,4.9337E+00_JPRB,6.7135E+00_JPRB/)
KBO( :, 5,17,14) = (/&
&9.6338E+00_JPRB,8.1047E+00_JPRB,6.9599E+00_JPRB,6.2366E+00_JPRB,8.0058E+00_JPRB/)
KBO( :, 1,18,14) = (/&
&3.6472E+00_JPRB,2.9807E+00_JPRB,2.5189E+00_JPRB,2.1796E+00_JPRB,4.4334E+00_JPRB/)
KBO( :, 2,18,14) = (/&
&5.0323E+00_JPRB,4.1367E+00_JPRB,3.4979E+00_JPRB,3.0247E+00_JPRB,4.9096E+00_JPRB/)
KBO( :, 3,18,14) = (/&
&6.6454E+00_JPRB,5.5144E+00_JPRB,4.6858E+00_JPRB,4.0381E+00_JPRB,5.6608E+00_JPRB/)
KBO( :, 4,18,14) = (/&
&8.4890E+00_JPRB,7.1264E+00_JPRB,6.0803E+00_JPRB,5.2199E+00_JPRB,6.6925E+00_JPRB/)
KBO( :, 5,18,14) = (/&
&1.0542E+01_JPRB,8.9586E+00_JPRB,7.6601E+00_JPRB,6.5575E+00_JPRB,7.9988E+00_JPRB/)
KBO( :, 1,19,14) = (/&
&4.0274E+00_JPRB,3.3233E+00_JPRB,2.8227E+00_JPRB,2.3261E+00_JPRB,4.2975E+00_JPRB/)
KBO( :, 2,19,14) = (/&
&5.5204E+00_JPRB,4.5992E+00_JPRB,3.8961E+00_JPRB,3.2089E+00_JPRB,4.8408E+00_JPRB/)
KBO( :, 3,19,14) = (/&
&7.2641E+00_JPRB,6.1090E+00_JPRB,5.1847E+00_JPRB,4.2710E+00_JPRB,5.6348E+00_JPRB/)
KBO( :, 4,19,14) = (/&
&9.2241E+00_JPRB,7.8543E+00_JPRB,6.6837E+00_JPRB,5.5155E+00_JPRB,6.6912E+00_JPRB/)
KBO( :, 5,19,14) = (/&
&1.1403E+01_JPRB,9.8034E+00_JPRB,8.3820E+00_JPRB,6.9048E+00_JPRB,7.9670E+00_JPRB/)
KBO( :, 1,20,14) = (/&
&4.4042E+00_JPRB,3.6923E+00_JPRB,3.1564E+00_JPRB,2.5009E+00_JPRB,4.3386E+00_JPRB/)
KBO( :, 2,20,14) = (/&
&6.0056E+00_JPRB,5.0815E+00_JPRB,4.3305E+00_JPRB,3.4328E+00_JPRB,4.8920E+00_JPRB/)
KBO( :, 3,20,14) = (/&
&7.8551E+00_JPRB,6.7164E+00_JPRB,5.7136E+00_JPRB,4.5512E+00_JPRB,5.6658E+00_JPRB/)
KBO( :, 4,20,14) = (/&
&9.9239E+00_JPRB,8.5703E+00_JPRB,7.3215E+00_JPRB,5.8504E+00_JPRB,6.6818E+00_JPRB/)
KBO( :, 5,20,14) = (/&
&1.2197E+01_JPRB,1.0639E+01_JPRB,9.1299E+00_JPRB,7.3134E+00_JPRB,7.9255E+00_JPRB/)
KBO( :, 1,21,14) = (/&
&4.7479E+00_JPRB,4.0508E+00_JPRB,3.4983E+00_JPRB,2.6955E+00_JPRB,4.4010E+00_JPRB/)
KBO( :, 2,21,14) = (/&
&6.4355E+00_JPRB,5.5399E+00_JPRB,4.7678E+00_JPRB,3.6820E+00_JPRB,4.9446E+00_JPRB/)
KBO( :, 3,21,14) = (/&
&8.3663E+00_JPRB,7.2751E+00_JPRB,6.2518E+00_JPRB,4.8572E+00_JPRB,5.6757E+00_JPRB/)
KBO( :, 4,21,14) = (/&
&1.0512E+01_JPRB,9.2314E+00_JPRB,7.9526E+00_JPRB,6.2141E+00_JPRB,6.6288E+00_JPRB/)
KBO( :, 5,21,14) = (/&
&1.2856E+01_JPRB,1.1396E+01_JPRB,9.8659E+00_JPRB,7.7561E+00_JPRB,7.8277E+00_JPRB/)
KBO( :, 1,22,14) = (/&
&5.1420E+00_JPRB,4.4823E+00_JPRB,3.9096E+00_JPRB,2.9527E+00_JPRB,4.4013E+00_JPRB/)
KBO( :, 2,22,14) = (/&
&6.9006E+00_JPRB,6.0705E+00_JPRB,5.2806E+00_JPRB,4.0025E+00_JPRB,4.9528E+00_JPRB/)
KBO( :, 3,22,14) = (/&
&8.8983E+00_JPRB,7.9013E+00_JPRB,6.8678E+00_JPRB,5.2402E+00_JPRB,5.6748E+00_JPRB/)
KBO( :, 4,22,14) = (/&
&1.1116E+01_JPRB,9.9470E+00_JPRB,8.6698E+00_JPRB,6.6674E+00_JPRB,6.5994E+00_JPRB/)
KBO( :, 5,22,14) = (/&
&1.3502E+01_JPRB,1.2202E+01_JPRB,1.0686E+01_JPRB,8.2853E+00_JPRB,7.7517E+00_JPRB/)
KBO( :, 1,23,14) = (/&
&5.4713E+00_JPRB,4.8911E+00_JPRB,4.3072E+00_JPRB,3.2139E+00_JPRB,4.3813E+00_JPRB/)
KBO( :, 2,23,14) = (/&
&7.2751E+00_JPRB,6.5638E+00_JPRB,5.7664E+00_JPRB,4.3250E+00_JPRB,4.9555E+00_JPRB/)
KBO( :, 3,23,14) = (/&
&9.3230E+00_JPRB,8.4735E+00_JPRB,7.4455E+00_JPRB,5.6212E+00_JPRB,5.6783E+00_JPRB/)
KBO( :, 4,23,14) = (/&
&1.1564E+01_JPRB,1.0599E+01_JPRB,9.3428E+00_JPRB,7.1049E+00_JPRB,6.5825E+00_JPRB/)
KBO( :, 5,23,14) = (/&
&1.3974E+01_JPRB,1.2910E+01_JPRB,1.1439E+01_JPRB,8.7857E+00_JPRB,7.6865E+00_JPRB/)
KBO( :, 1,24,14) = (/&
&5.7350E+00_JPRB,5.2712E+00_JPRB,4.6801E+00_JPRB,3.4774E+00_JPRB,4.3078E+00_JPRB/)
KBO( :, 2,24,14) = (/&
&7.5695E+00_JPRB,7.0067E+00_JPRB,6.2189E+00_JPRB,4.6444E+00_JPRB,4.9097E+00_JPRB/)
KBO( :, 3,24,14) = (/&
&9.6279E+00_JPRB,8.9845E+00_JPRB,7.9822E+00_JPRB,5.9954E+00_JPRB,5.6514E+00_JPRB/)
KBO( :, 4,24,14) = (/&
&1.1878E+01_JPRB,1.1160E+01_JPRB,9.9533E+00_JPRB,7.5366E+00_JPRB,6.5532E+00_JPRB/)
KBO( :, 5,24,14) = (/&
&1.4285E+01_JPRB,1.3514E+01_JPRB,1.2126E+01_JPRB,9.2665E+00_JPRB,7.6715E+00_JPRB/)
KBO( :, 1,25,14) = (/&
&5.9267E+00_JPRB,5.6187E+00_JPRB,5.0280E+00_JPRB,3.7387E+00_JPRB,4.2972E+00_JPRB/)
KBO( :, 2,25,14) = (/&
&7.7642E+00_JPRB,7.4077E+00_JPRB,6.6347E+00_JPRB,4.9555E+00_JPRB,4.9309E+00_JPRB/)
KBO( :, 3,25,14) = (/&
&9.8187E+00_JPRB,9.4277E+00_JPRB,8.4720E+00_JPRB,6.3648E+00_JPRB,5.6934E+00_JPRB/)
KBO( :, 4,25,14) = (/&
&1.2059E+01_JPRB,1.1644E+01_JPRB,1.0515E+01_JPRB,7.9525E+00_JPRB,6.6186E+00_JPRB/)
KBO( :, 5,25,14) = (/&
&1.4463E+01_JPRB,1.4040E+01_JPRB,1.2752E+01_JPRB,9.7432E+00_JPRB,7.7714E+00_JPRB/)
KBO( :, 1,26,14) = (/&
&6.0673E+00_JPRB,5.9449E+00_JPRB,5.3655E+00_JPRB,4.0058E+00_JPRB,4.3684E+00_JPRB/)
KBO( :, 2,26,14) = (/&
&7.8884E+00_JPRB,7.7776E+00_JPRB,7.0359E+00_JPRB,5.2751E+00_JPRB,5.0446E+00_JPRB/)
KBO( :, 3,26,14) = (/&
&9.9238E+00_JPRB,9.8293E+00_JPRB,8.9381E+00_JPRB,6.7352E+00_JPRB,5.8349E+00_JPRB/)
KBO( :, 4,26,14) = (/&
&1.2150E+01_JPRB,1.2086E+01_JPRB,1.1047E+01_JPRB,8.3792E+00_JPRB,6.8011E+00_JPRB/)
KBO( :, 5,26,14) = (/&
&1.4535E+01_JPRB,1.4527E+01_JPRB,1.3353E+01_JPRB,1.0236E+01_JPRB,7.9789E+00_JPRB/)
KBO( :, 1,27,14) = (/&
&6.1343E+00_JPRB,6.2302E+00_JPRB,5.6763E+00_JPRB,4.2525E+00_JPRB,4.3799E+00_JPRB/)
KBO( :, 2,27,14) = (/&
&7.9331E+00_JPRB,8.0869E+00_JPRB,7.4032E+00_JPRB,5.5689E+00_JPRB,5.1012E+00_JPRB/)
KBO( :, 3,27,14) = (/&
&9.9492E+00_JPRB,1.0172E+01_JPRB,9.3622E+00_JPRB,7.0779E+00_JPRB,5.9411E+00_JPRB/)
KBO( :, 4,27,14) = (/&
&1.2151E+01_JPRB,1.2467E+01_JPRB,1.1529E+01_JPRB,8.7861E+00_JPRB,6.9495E+00_JPRB/)
KBO( :, 5,27,14) = (/&
&1.4529E+01_JPRB,1.4944E+01_JPRB,1.3914E+01_JPRB,1.0727E+01_JPRB,8.1417E+00_JPRB/)
KBO( :, 1,28,14) = (/&
&6.1453E+00_JPRB,6.4763E+00_JPRB,5.9637E+00_JPRB,4.4841E+00_JPRB,4.3357E+00_JPRB/)
KBO( :, 2,28,14) = (/&
&7.9217E+00_JPRB,8.3599E+00_JPRB,7.7430E+00_JPRB,5.8381E+00_JPRB,5.0957E+00_JPRB/)
KBO( :, 3,28,14) = (/&
&9.9089E+00_JPRB,1.0474E+01_JPRB,9.7521E+00_JPRB,7.4031E+00_JPRB,5.9939E+00_JPRB/)
KBO( :, 4,28,14) = (/&
&1.2103E+01_JPRB,1.2802E+01_JPRB,1.1983E+01_JPRB,9.1765E+00_JPRB,7.0380E+00_JPRB/)
KBO( :, 5,28,14) = (/&
&1.4484E+01_JPRB,1.5315E+01_JPRB,1.4450E+01_JPRB,1.1205E+01_JPRB,8.2560E+00_JPRB/)
KBO( :, 1,29,14) = (/&
&6.1344E+00_JPRB,6.7103E+00_JPRB,6.2468E+00_JPRB,4.7094E+00_JPRB,4.2060E+00_JPRB/)
KBO( :, 2,29,14) = (/&
&7.8873E+00_JPRB,8.6217E+00_JPRB,8.0781E+00_JPRB,6.1108E+00_JPRB,4.9771E+00_JPRB/)
KBO( :, 3,29,14) = (/&
&9.8658E+00_JPRB,1.0771E+01_JPRB,1.0146E+01_JPRB,7.7338E+00_JPRB,5.8851E+00_JPRB/)
KBO( :, 4,29,14) = (/&
&1.2059E+01_JPRB,1.3133E+01_JPRB,1.2445E+01_JPRB,9.5787E+00_JPRB,6.9308E+00_JPRB/)
KBO( :, 5,29,14) = (/&
&1.4440E+01_JPRB,1.5700E+01_JPRB,1.5002E+01_JPRB,1.1702E+01_JPRB,8.1658E+00_JPRB/)
KBO( :, 1,30,14) = (/&
&6.1074E+00_JPRB,6.9340E+00_JPRB,6.5266E+00_JPRB,4.9327E+00_JPRB,4.0096E+00_JPRB/)
KBO( :, 2,30,14) = (/&
&7.8501E+00_JPRB,8.8831E+00_JPRB,8.4088E+00_JPRB,6.3894E+00_JPRB,4.7868E+00_JPRB/)
KBO( :, 3,30,14) = (/&
&9.8321E+00_JPRB,1.1068E+01_JPRB,1.0541E+01_JPRB,8.0663E+00_JPRB,5.6845E+00_JPRB/)
KBO( :, 4,30,14) = (/&
&1.2029E+01_JPRB,1.3476E+01_JPRB,1.2917E+01_JPRB,9.9903E+00_JPRB,6.7312E+00_JPRB/)
KBO( :, 5,30,14) = (/&
&1.4419E+01_JPRB,1.6109E+01_JPRB,1.5573E+01_JPRB,1.2209E+01_JPRB,7.9754E+00_JPRB/)
KBO( :, 1,31,14) = (/&
&6.0986E+00_JPRB,7.1722E+00_JPRB,6.8200E+00_JPRB,5.1755E+00_JPRB,3.7163E+00_JPRB/)
KBO( :, 2,31,14) = (/&
&7.8450E+00_JPRB,9.1619E+00_JPRB,8.7620E+00_JPRB,6.6858E+00_JPRB,4.4619E+00_JPRB/)
KBO( :, 3,31,14) = (/&
&9.8340E+00_JPRB,1.1393E+01_JPRB,1.0969E+01_JPRB,8.4279E+00_JPRB,5.3316E+00_JPRB/)
KBO( :, 4,31,14) = (/&
&1.2043E+01_JPRB,1.3864E+01_JPRB,1.3429E+01_JPRB,1.0440E+01_JPRB,6.3686E+00_JPRB/)
KBO( :, 5,31,14) = (/&
&1.4461E+01_JPRB,1.6571E+01_JPRB,1.6185E+01_JPRB,1.2751E+01_JPRB,7.6315E+00_JPRB/)
KBO( :, 1,32,14) = (/&
&6.1266E+00_JPRB,7.4384E+00_JPRB,7.1350E+00_JPRB,5.4384E+00_JPRB,3.4364E+00_JPRB/)
KBO( :, 2,32,14) = (/&
&7.8843E+00_JPRB,9.4733E+00_JPRB,9.1481E+00_JPRB,7.0065E+00_JPRB,4.1508E+00_JPRB/)
KBO( :, 3,32,14) = (/&
&9.8908E+00_JPRB,1.1765E+01_JPRB,1.1436E+01_JPRB,8.8189E+00_JPRB,5.0057E+00_JPRB/)
KBO( :, 4,32,14) = (/&
&1.2132E+01_JPRB,1.4306E+01_JPRB,1.3989E+01_JPRB,1.0926E+01_JPRB,6.0480E+00_JPRB/)
KBO( :, 5,32,14) = (/&
&1.4591E+01_JPRB,1.7095E+01_JPRB,1.6845E+01_JPRB,1.3332E+01_JPRB,7.3373E+00_JPRB/)
KBO( :, 1,33,14) = (/&
&6.1928E+00_JPRB,7.7310E+00_JPRB,7.4804E+00_JPRB,5.7251E+00_JPRB,3.1571E+00_JPRB/)
KBO( :, 2,33,14) = (/&
&7.9747E+00_JPRB,9.8269E+00_JPRB,9.5731E+00_JPRB,7.3563E+00_JPRB,3.8547E+00_JPRB/)
KBO( :, 3,33,14) = (/&
&1.0016E+01_JPRB,1.2187E+01_JPRB,1.1940E+01_JPRB,9.2481E+00_JPRB,4.7049E+00_JPRB/)
KBO( :, 4,33,14) = (/&
&1.2296E+01_JPRB,1.4804E+01_JPRB,1.4590E+01_JPRB,1.1453E+01_JPRB,5.7736E+00_JPRB/)
KBO( :, 5,33,14) = (/&
&1.4813E+01_JPRB,1.7670E+01_JPRB,1.7552E+01_JPRB,1.3951E+01_JPRB,7.0995E+00_JPRB/)
KBO( :, 1,34,14) = (/&
&6.2424E+00_JPRB,7.9897E+00_JPRB,7.7910E+00_JPRB,5.9836E+00_JPRB,2.9611E+00_JPRB/)
KBO( :, 2,34,14) = (/&
&8.0550E+00_JPRB,1.0143E+01_JPRB,9.9528E+00_JPRB,7.6724E+00_JPRB,3.6568E+00_JPRB/)
KBO( :, 3,34,14) = (/&
&1.0129E+01_JPRB,1.2569E+01_JPRB,1.2399E+01_JPRB,9.6375E+00_JPRB,4.5137E+00_JPRB/)
KBO( :, 4,34,14) = (/&
&1.2455E+01_JPRB,1.5251E+01_JPRB,1.5135E+01_JPRB,1.1928E+01_JPRB,5.6067E+00_JPRB/)
KBO( :, 5,34,14) = (/&
&1.5024E+01_JPRB,1.8190E+01_JPRB,1.8193E+01_JPRB,1.4509E+01_JPRB,6.9726E+00_JPRB/)
KBO( :, 1,35,14) = (/&
&6.1783E+00_JPRB,8.0868E+00_JPRB,7.9354E+00_JPRB,6.1097E+00_JPRB,2.7386E+00_JPRB/)
KBO( :, 2,35,14) = (/&
&8.0021E+00_JPRB,1.0274E+01_JPRB,1.0143E+01_JPRB,7.8342E+00_JPRB,3.4231E+00_JPRB/)
KBO( :, 3,35,14) = (/&
&1.0093E+01_JPRB,1.2741E+01_JPRB,1.2638E+01_JPRB,9.8464E+00_JPRB,4.2817E+00_JPRB/)
KBO( :, 4,35,14) = (/&
&1.2448E+01_JPRB,1.5466E+01_JPRB,1.5430E+01_JPRB,1.2190E+01_JPRB,5.3838E+00_JPRB/)
KBO( :, 5,35,14) = (/&
&1.5050E+01_JPRB,1.8453E+01_JPRB,1.8553E+01_JPRB,1.4830E+01_JPRB,6.7795E+00_JPRB/)
KBO( :, 1,36,14) = (/&
&5.9739E+00_JPRB,7.9879E+00_JPRB,7.8762E+00_JPRB,6.0736E+00_JPRB,2.4966E+00_JPRB/)
KBO( :, 2,36,14) = (/&
&7.7837E+00_JPRB,1.0180E+01_JPRB,1.0097E+01_JPRB,7.8072E+00_JPRB,3.1606E+00_JPRB/)
KBO( :, 3,36,14) = (/&
&9.8723E+00_JPRB,1.2658E+01_JPRB,1.2607E+01_JPRB,9.8330E+00_JPRB,4.0029E+00_JPRB/)
KBO( :, 4,36,14) = (/&
&1.2229E+01_JPRB,1.5396E+01_JPRB,1.5418E+01_JPRB,1.2194E+01_JPRB,5.0917E+00_JPRB/)
KBO( :, 5,36,14) = (/&
&1.4834E+01_JPRB,1.8403E+01_JPRB,1.8570E+01_JPRB,1.4857E+01_JPRB,6.4863E+00_JPRB/)
KBO( :, 1,37,14) = (/&
&5.5612E+00_JPRB,7.6037E+00_JPRB,7.5217E+00_JPRB,5.8049E+00_JPRB,2.2433E+00_JPRB/)
KBO( :, 2,37,14) = (/&
&7.3179E+00_JPRB,9.7571E+00_JPRB,9.7063E+00_JPRB,7.5074E+00_JPRB,2.8646E+00_JPRB/)
KBO( :, 3,37,14) = (/&
&9.3602E+00_JPRB,1.2203E+01_JPRB,1.2188E+01_JPRB,9.5001E+00_JPRB,3.6608E+00_JPRB/)
KBO( :, 4,37,14) = (/&
&1.1681E+01_JPRB,1.4916E+01_JPRB,1.4967E+01_JPRB,1.1825E+01_JPRB,4.7005E+00_JPRB/)
KBO( :, 5,37,14) = (/&
&1.4259E+01_JPRB,1.7897E+01_JPRB,1.8089E+01_JPRB,1.4461E+01_JPRB,6.0475E+00_JPRB/)
KBO( :, 1,38,14) = (/&
&5.1796E+00_JPRB,7.2275E+00_JPRB,7.1681E+00_JPRB,5.5362E+00_JPRB,1.9985E+00_JPRB/)
KBO( :, 2,38,14) = (/&
&6.8825E+00_JPRB,9.3401E+00_JPRB,9.3116E+00_JPRB,7.2050E+00_JPRB,2.5786E+00_JPRB/)
KBO( :, 3,38,14) = (/&
&8.8770E+00_JPRB,1.1748E+01_JPRB,1.1759E+01_JPRB,9.1583E+00_JPRB,3.3304E+00_JPRB/)
KBO( :, 4,38,14) = (/&
&1.1161E+01_JPRB,1.4430E+01_JPRB,1.4508E+01_JPRB,1.1443E+01_JPRB,4.3225E+00_JPRB/)
KBO( :, 5,38,14) = (/&
&1.3706E+01_JPRB,1.7382E+01_JPRB,1.7591E+01_JPRB,1.4049E+01_JPRB,5.6183E+00_JPRB/)
KBO( :, 1,39,14) = (/&
&4.8363E+00_JPRB,6.8762E+00_JPRB,6.8344E+00_JPRB,5.2801E+00_JPRB,1.7623E+00_JPRB/)
KBO( :, 2,39,14) = (/&
&6.4874E+00_JPRB,8.9479E+00_JPRB,8.9339E+00_JPRB,6.9176E+00_JPRB,2.3035E+00_JPRB/)
KBO( :, 3,39,14) = (/&
&8.4367E+00_JPRB,1.1315E+01_JPRB,1.1346E+01_JPRB,8.8331E+00_JPRB,3.0157E+00_JPRB/)
KBO( :, 4,39,14) = (/&
&1.0680E+01_JPRB,1.3965E+01_JPRB,1.4062E+01_JPRB,1.1077E+01_JPRB,3.9619E+00_JPRB/)
KBO( :, 5,39,14) = (/&
&1.3190E+01_JPRB,1.6887E+01_JPRB,1.7105E+01_JPRB,1.3646E+01_JPRB,5.2103E+00_JPRB/)
KBO( :, 1,40,14) = (/&
&4.3793E+00_JPRB,6.3557E+00_JPRB,6.3258E+00_JPRB,4.8864E+00_JPRB,1.5658E+00_JPRB/)
KBO( :, 2,40,14) = (/&
&5.9498E+00_JPRB,8.3535E+00_JPRB,8.3464E+00_JPRB,6.4658E+00_JPRB,2.0604E+00_JPRB/)
KBO( :, 3,40,14) = (/&
&7.8232E+00_JPRB,1.0648E+01_JPRB,1.0689E+01_JPRB,8.3111E+00_JPRB,2.7192E+00_JPRB/)
KBO( :, 4,40,14) = (/&
&9.9941E+00_JPRB,1.3236E+01_JPRB,1.3338E+01_JPRB,1.0477E+01_JPRB,3.5936E+00_JPRB/)
KBO( :, 5,40,14) = (/&
&1.2441E+01_JPRB,1.6098E+01_JPRB,1.6304E+01_JPRB,1.2976E+01_JPRB,4.7608E+00_JPRB/)
KBO( :, 1,41,14) = (/&
&3.9456E+00_JPRB,5.8420E+00_JPRB,5.8231E+00_JPRB,4.4960E+00_JPRB,1.3889E+00_JPRB/)
KBO( :, 2,41,14) = (/&
&5.4322E+00_JPRB,7.7601E+00_JPRB,7.7597E+00_JPRB,6.0124E+00_JPRB,1.8377E+00_JPRB/)
KBO( :, 3,41,14) = (/&
&7.2229E+00_JPRB,9.9804E+00_JPRB,1.0024E+01_JPRB,7.7851E+00_JPRB,2.4432E+00_JPRB/)
KBO( :, 4,41,14) = (/&
&9.3151E+00_JPRB,1.2496E+01_JPRB,1.2598E+01_JPRB,9.8694E+00_JPRB,3.2503E+00_JPRB/)
KBO( :, 5,41,14) = (/&
&1.1696E+01_JPRB,1.5294E+01_JPRB,1.5489E+01_JPRB,1.2290E+01_JPRB,4.3315E+00_JPRB/)
KBO( :, 1,42,14) = (/&
&3.5496E+00_JPRB,5.3598E+00_JPRB,5.3497E+00_JPRB,4.1263E+00_JPRB,1.2230E+00_JPRB/)
KBO( :, 2,42,14) = (/&
&4.9552E+00_JPRB,7.1957E+00_JPRB,7.1981E+00_JPRB,5.5771E+00_JPRB,1.6308E+00_JPRB/)
KBO( :, 3,42,14) = (/&
&6.6624E+00_JPRB,9.3374E+00_JPRB,9.3819E+00_JPRB,7.2830E+00_JPRB,2.1850E+00_JPRB/)
KBO( :, 4,42,14) = (/&
&8.6755E+00_JPRB,1.1781E+01_JPRB,1.1882E+01_JPRB,9.2833E+00_JPRB,2.9295E+00_JPRB/)
KBO( :, 5,42,14) = (/&
&1.0984E+01_JPRB,1.4512E+01_JPRB,1.4694E+01_JPRB,1.1624E+01_JPRB,3.9287E+00_JPRB/)
KBO( :, 1,43,14) = (/&
&3.1237E+00_JPRB,4.8164E+00_JPRB,4.8129E+00_JPRB,3.7055E+00_JPRB,1.0597E+00_JPRB/)
KBO( :, 2,43,14) = (/&
&4.4310E+00_JPRB,6.5524E+00_JPRB,6.5555E+00_JPRB,5.0769E+00_JPRB,1.4220E+00_JPRB/)
KBO( :, 3,43,14) = (/&
&6.0363E+00_JPRB,8.5993E+00_JPRB,8.6369E+00_JPRB,6.7040E+00_JPRB,1.9190E+00_JPRB/)
KBO( :, 4,43,14) = (/&
&7.9515E+00_JPRB,1.0949E+01_JPRB,1.1041E+01_JPRB,8.6082E+00_JPRB,2.5937E+00_JPRB/)
KBO( :, 5,43,14) = (/&
&1.0170E+01_JPRB,1.3594E+01_JPRB,1.3761E+01_JPRB,1.0846E+01_JPRB,3.5024E+00_JPRB/)
KBO( :, 1,44,14) = (/&
&2.7094E+00_JPRB,4.2738E+00_JPRB,4.2715E+00_JPRB,3.2851E+00_JPRB,9.0642E-01_JPRB/)
KBO( :, 2,44,14) = (/&
&3.9148E+00_JPRB,5.9019E+00_JPRB,5.9083E+00_JPRB,4.5708E+00_JPRB,1.2238E+00_JPRB/)
KBO( :, 3,44,14) = (/&
&5.4146E+00_JPRB,7.8441E+00_JPRB,7.8762E+00_JPRB,6.1124E+00_JPRB,1.6632E+00_JPRB/)
KBO( :, 4,44,14) = (/&
&7.2212E+00_JPRB,1.0093E+01_JPRB,1.0172E+01_JPRB,7.9162E+00_JPRB,2.2685E+00_JPRB/)
KBO( :, 5,44,14) = (/&
&9.3383E+00_JPRB,1.2640E+01_JPRB,1.2790E+01_JPRB,1.0039E+01_JPRB,3.0877E+00_JPRB/)
KBO( :, 1,45,14) = (/&
&2.3381E+00_JPRB,3.7708E+00_JPRB,3.7687E+00_JPRB,2.8968E+00_JPRB,7.6661E-01_JPRB/)
KBO( :, 2,45,14) = (/&
&3.4439E+00_JPRB,5.2956E+00_JPRB,5.3039E+00_JPRB,4.0958E+00_JPRB,1.0405E+00_JPRB/)
KBO( :, 3,45,14) = (/&
&4.8375E+00_JPRB,7.1296E+00_JPRB,7.1547E+00_JPRB,5.5510E+00_JPRB,1.4289E+00_JPRB/)
KBO( :, 4,45,14) = (/&
&6.5366E+00_JPRB,9.2742E+00_JPRB,9.3409E+00_JPRB,7.2620E+00_JPRB,1.9684E+00_JPRB/)
KBO( :, 5,45,14) = (/&
&8.5492E+00_JPRB,1.1723E+01_JPRB,1.1855E+01_JPRB,9.2715E+00_JPRB,2.7076E+00_JPRB/)
KBO( :, 1,46,14) = (/&
&1.9868E+00_JPRB,3.2812E+00_JPRB,3.2800E+00_JPRB,2.5190E+00_JPRB,6.4180E-01_JPRB/)
KBO( :, 2,46,14) = (/&
&2.9896E+00_JPRB,4.6959E+00_JPRB,4.7028E+00_JPRB,3.6244E+00_JPRB,8.7338E-01_JPRB/)
KBO( :, 3,46,14) = (/&
&4.2743E+00_JPRB,6.4145E+00_JPRB,6.4351E+00_JPRB,4.9866E+00_JPRB,1.2115E+00_JPRB/)
KBO( :, 4,46,14) = (/&
&5.8592E+00_JPRB,8.4475E+00_JPRB,8.5037E+00_JPRB,6.6059E+00_JPRB,1.6869E+00_JPRB/)
KBO( :, 5,46,14) = (/&
&7.7565E+00_JPRB,1.0789E+01_JPRB,1.0900E+01_JPRB,8.5039E+00_JPRB,2.3466E+00_JPRB/)
KBO( :, 1,47,14) = (/&
&1.6439E+00_JPRB,2.7872E+00_JPRB,2.7853E+00_JPRB,2.1361E+00_JPRB,5.3608E-01_JPRB/)
KBO( :, 2,47,14) = (/&
&2.5332E+00_JPRB,4.0761E+00_JPRB,4.0808E+00_JPRB,3.1417E+00_JPRB,7.2689E-01_JPRB/)
KBO( :, 3,47,14) = (/&
&3.7004E+00_JPRB,5.6682E+00_JPRB,5.6872E+00_JPRB,4.4002E+00_JPRB,1.0142E+00_JPRB/)
KBO( :, 4,47,14) = (/&
&5.1603E+00_JPRB,7.5763E+00_JPRB,7.6194E+00_JPRB,5.9172E+00_JPRB,1.4236E+00_JPRB/)
KBO( :, 5,47,14) = (/&
&6.9294E+00_JPRB,9.7951E+00_JPRB,9.8846E+00_JPRB,7.6954E+00_JPRB,2.0006E+00_JPRB/)
KBO( :, 1,48,14) = (/&
&1.3454E+00_JPRB,2.3441E+00_JPRB,2.3435E+00_JPRB,1.7934E+00_JPRB,4.4332E-01_JPRB/)
KBO( :, 2,48,14) = (/&
&2.1289E+00_JPRB,3.5090E+00_JPRB,3.5130E+00_JPRB,2.7017E+00_JPRB,5.9906E-01_JPRB/)
KBO( :, 3,48,14) = (/&
&3.1810E+00_JPRB,4.9808E+00_JPRB,4.9955E+00_JPRB,3.8562E+00_JPRB,8.3681E-01_JPRB/)
KBO( :, 4,48,14) = (/&
&4.5168E+00_JPRB,6.7583E+00_JPRB,6.7897E+00_JPRB,5.2679E+00_JPRB,1.1898E+00_JPRB/)
KBO( :, 5,48,14) = (/&
&6.1589E+00_JPRB,8.8519E+00_JPRB,8.9240E+00_JPRB,6.9392E+00_JPRB,1.6894E+00_JPRB/)
KBO( :, 1,49,14) = (/&
&1.0880E+00_JPRB,1.9520E+00_JPRB,1.9492E+00_JPRB,1.4892E+00_JPRB,3.6205E-01_JPRB/)
KBO( :, 2,49,14) = (/&
&1.7730E+00_JPRB,2.9965E+00_JPRB,2.9993E+00_JPRB,2.3026E+00_JPRB,4.8696E-01_JPRB/)
KBO( :, 3,49,14) = (/&
&2.7108E+00_JPRB,4.3431E+00_JPRB,4.3550E+00_JPRB,3.3555E+00_JPRB,6.7993E-01_JPRB/)
KBO( :, 4,49,14) = (/&
&3.9297E+00_JPRB,5.9939E+00_JPRB,6.0205E+00_JPRB,4.6638E+00_JPRB,9.7892E-01_JPRB/)
KBO( :, 5,49,14) = (/&
&5.4456E+00_JPRB,7.9623E+00_JPRB,8.0197E+00_JPRB,6.2316E+00_JPRB,1.4097E+00_JPRB/)
KBO( :, 1,50,14) = (/&
&8.8117E-01_JPRB,1.6250E+00_JPRB,1.6221E+00_JPRB,1.2383E+00_JPRB,3.0851E-01_JPRB/)
KBO( :, 2,50,14) = (/&
&1.4792E+00_JPRB,2.5614E+00_JPRB,2.5640E+00_JPRB,1.9649E+00_JPRB,4.1033E-01_JPRB/)
KBO( :, 3,50,14) = (/&
&2.3153E+00_JPRB,3.7911E+00_JPRB,3.7998E+00_JPRB,2.9253E+00_JPRB,5.6911E-01_JPRB/)
KBO( :, 4,50,14) = (/&
&3.4255E+00_JPRB,5.3270E+00_JPRB,5.3498E+00_JPRB,4.1369E+00_JPRB,8.2028E-01_JPRB/)
KBO( :, 5,50,14) = (/&
&4.8249E+00_JPRB,7.1748E+00_JPRB,7.2189E+00_JPRB,5.6068E+00_JPRB,1.1946E+00_JPRB/)
KBO( :, 1,51,14) = (/&
&7.1056E-01_JPRB,1.3442E+00_JPRB,1.3433E+00_JPRB,1.0241E+00_JPRB,2.6969E-01_JPRB/)
KBO( :, 2,51,14) = (/&
&1.2285E+00_JPRB,2.1825E+00_JPRB,2.1836E+00_JPRB,1.6701E+00_JPRB,3.5352E-01_JPRB/)
KBO( :, 3,51,14) = (/&
&1.9719E+00_JPRB,3.3009E+00_JPRB,3.3075E+00_JPRB,2.5431E+00_JPRB,4.8463E-01_JPRB/)
KBO( :, 4,51,14) = (/&
&2.9787E+00_JPRB,4.7254E+00_JPRB,4.7429E+00_JPRB,3.6598E+00_JPRB,6.9430E-01_JPRB/)
KBO( :, 5,51,14) = (/&
&4.2688E+00_JPRB,6.4560E+00_JPRB,6.4905E+00_JPRB,5.0345E+00_JPRB,1.0186E+00_JPRB/)
KBO( :, 1,52,14) = (/&
&5.6673E-01_JPRB,1.0993E+00_JPRB,1.1002E+00_JPRB,8.3639E-01_JPRB,2.3587E-01_JPRB/)
KBO( :, 2,52,14) = (/&
&1.0109E+00_JPRB,1.8431E+00_JPRB,1.8420E+00_JPRB,1.4073E+00_JPRB,3.0435E-01_JPRB/)
KBO( :, 3,52,14) = (/&
&1.6672E+00_JPRB,2.8532E+00_JPRB,2.8589E+00_JPRB,2.1945E+00_JPRB,4.1172E-01_JPRB/)
KBO( :, 4,52,14) = (/&
&2.5718E+00_JPRB,4.1653E+00_JPRB,4.1785E+00_JPRB,3.2201E+00_JPRB,5.8484E-01_JPRB/)
KBO( :, 5,52,14) = (/&
&3.7560E+00_JPRB,5.7814E+00_JPRB,5.8111E+00_JPRB,4.5005E+00_JPRB,8.6103E-01_JPRB/)
KBO( :, 1,53,14) = (/&
&4.4695E-01_JPRB,8.8846E-01_JPRB,8.9001E-01_JPRB,6.7290E-01_JPRB,2.0456E-01_JPRB/)
KBO( :, 2,53,14) = (/&
&8.2293E-01_JPRB,1.5387E+00_JPRB,1.5377E+00_JPRB,1.1737E+00_JPRB,2.6214E-01_JPRB/)
KBO( :, 3,53,14) = (/&
&1.3961E+00_JPRB,2.4467E+00_JPRB,2.4512E+00_JPRB,1.8778E+00_JPRB,3.4832E-01_JPRB/)
KBO( :, 4,53,14) = (/&
&2.2042E+00_JPRB,3.6459E+00_JPRB,3.6556E+00_JPRB,2.8141E+00_JPRB,4.9014E-01_JPRB/)
KBO( :, 5,53,14) = (/&
&3.2850E+00_JPRB,5.1511E+00_JPRB,5.1749E+00_JPRB,4.0006E+00_JPRB,7.2139E-01_JPRB/)
KBO( :, 1,54,14) = (/&
&3.5542E-01_JPRB,7.2243E-01_JPRB,7.2402E-01_JPRB,5.4442E-01_JPRB,1.8822E-01_JPRB/)
KBO( :, 2,54,14) = (/&
&6.7476E-01_JPRB,1.2906E+00_JPRB,1.2914E+00_JPRB,9.8429E-01_JPRB,2.4211E-01_JPRB/)
KBO( :, 3,54,14) = (/&
&1.1767E+00_JPRB,2.1105E+00_JPRB,2.1120E+00_JPRB,1.6159E+00_JPRB,3.1436E-01_JPRB/)
KBO( :, 4,54,14) = (/&
&1.9014E+00_JPRB,3.2074E+00_JPRB,3.2160E+00_JPRB,2.4725E+00_JPRB,4.3384E-01_JPRB/)
KBO( :, 5,54,14) = (/&
&2.8871E+00_JPRB,4.6109E+00_JPRB,4.6302E+00_JPRB,3.5724E+00_JPRB,6.2978E-01_JPRB/)
KBO( :, 1,55,14) = (/&
&2.8206E-01_JPRB,5.8561E-01_JPRB,5.8631E-01_JPRB,4.3881E-01_JPRB,1.7956E-01_JPRB/)
KBO( :, 2,55,14) = (/&
&5.5285E-01_JPRB,1.0805E+00_JPRB,1.0824E+00_JPRB,8.2279E-01_JPRB,2.3170E-01_JPRB/)
KBO( :, 3,55,14) = (/&
&9.9080E-01_JPRB,1.8171E+00_JPRB,1.8174E+00_JPRB,1.3888E+00_JPRB,2.9651E-01_JPRB/)
KBO( :, 4,55,14) = (/&
&1.6397E+00_JPRB,2.8207E+00_JPRB,2.8269E+00_JPRB,2.1700E+00_JPRB,3.9927E-01_JPRB/)
KBO( :, 5,55,14) = (/&
&2.5364E+00_JPRB,4.1246E+00_JPRB,4.1390E+00_JPRB,3.1901E+00_JPRB,5.6676E-01_JPRB/)
KBO( :, 1,56,14) = (/&
&2.2149E-01_JPRB,4.6888E-01_JPRB,4.6793E-01_JPRB,3.4931E-01_JPRB,1.7153E-01_JPRB/)
KBO( :, 2,56,14) = (/&
&4.4941E-01_JPRB,8.9702E-01_JPRB,8.9917E-01_JPRB,6.8030E-01_JPRB,2.2216E-01_JPRB/)
KBO( :, 3,56,14) = (/&
&8.2764E-01_JPRB,1.5520E+00_JPRB,1.5517E+00_JPRB,1.1848E+00_JPRB,2.8403E-01_JPRB/)
KBO( :, 4,56,14) = (/&
&1.4044E+00_JPRB,2.4656E+00_JPRB,2.4713E+00_JPRB,1.8937E+00_JPRB,3.7249E-01_JPRB/)
KBO( :, 5,56,14) = (/&
&2.2168E+00_JPRB,3.6708E+00_JPRB,3.6827E+00_JPRB,2.8356E+00_JPRB,5.1654E-01_JPRB/)
KBO( :, 1,57,14) = (/&
&1.7214E-01_JPRB,3.7079E-01_JPRB,3.6824E-01_JPRB,2.7420E-01_JPRB,1.6338E-01_JPRB/)
KBO( :, 2,57,14) = (/&
&3.6172E-01_JPRB,7.3713E-01_JPRB,7.3924E-01_JPRB,5.5639E-01_JPRB,2.1373E-01_JPRB/)
KBO( :, 3,57,14) = (/&
&6.8570E-01_JPRB,1.3134E+00_JPRB,1.3148E+00_JPRB,1.0025E+00_JPRB,2.7456E-01_JPRB/)
KBO( :, 4,57,14) = (/&
&1.1942E+00_JPRB,2.1424E+00_JPRB,2.1454E+00_JPRB,1.6418E+00_JPRB,3.5310E-01_JPRB/)
KBO( :, 5,57,14) = (/&
&1.9264E+00_JPRB,3.2505E+00_JPRB,3.2602E+00_JPRB,2.5070E+00_JPRB,4.7752E-01_JPRB/)
KBO( :, 1,58,14) = (/&
&1.3445E-01_JPRB,2.9284E-01_JPRB,2.8903E-01_JPRB,2.1482E-01_JPRB,1.5774E-01_JPRB/)
KBO( :, 2,58,14) = (/&
&2.9137E-01_JPRB,6.0563E-01_JPRB,6.0668E-01_JPRB,4.5447E-01_JPRB,2.0929E-01_JPRB/)
KBO( :, 3,58,14) = (/&
&5.6904E-01_JPRB,1.1121E+00_JPRB,1.1143E+00_JPRB,8.4762E-01_JPRB,2.7004E-01_JPRB/)
KBO( :, 4,58,14) = (/&
&1.0164E+00_JPRB,1.8625E+00_JPRB,1.8634E+00_JPRB,1.4242E+00_JPRB,3.4514E-01_JPRB/)
KBO( :, 5,58,14) = (/&
&1.6772E+00_JPRB,2.8815E+00_JPRB,2.8885E+00_JPRB,2.2182E+00_JPRB,4.5564E-01_JPRB/)
KBO( :, 1,59,14) = (/&
&1.2131E-01_JPRB,2.6518E-01_JPRB,2.6089E-01_JPRB,1.9393E-01_JPRB,1.7441E-01_JPRB/)
KBO( :, 2,59,14) = (/&
&2.6626E-01_JPRB,5.5782E-01_JPRB,5.5852E-01_JPRB,4.1787E-01_JPRB,2.3461E-01_JPRB/)
KBO( :, 3,59,14) = (/&
&5.2659E-01_JPRB,1.0377E+00_JPRB,1.0403E+00_JPRB,7.9028E-01_JPRB,3.0633E-01_JPRB/)
KBO( :, 4,59,14) = (/&
&9.5064E-01_JPRB,1.7566E+00_JPRB,1.7573E+00_JPRB,1.3429E+00_JPRB,3.9674E-01_JPRB/)
KBO( :, 5,59,14) = (/&
&1.5830E+00_JPRB,2.7404E+00_JPRB,2.7474E+00_JPRB,2.1087E+00_JPRB,5.2021E-01_JPRB/)
KBO( :, 1,13,15) = (/&
&3.2244E+00_JPRB,2.5409E+00_JPRB,3.1328E+00_JPRB,4.6712E+00_JPRB,1.1048E+01_JPRB/)
KBO( :, 2,13,15) = (/&
&4.5398E+00_JPRB,3.6057E+00_JPRB,4.5237E+00_JPRB,6.7554E+00_JPRB,1.1523E+01_JPRB/)
KBO( :, 3,13,15) = (/&
&6.0837E+00_JPRB,4.8732E+00_JPRB,6.1887E+00_JPRB,9.2622E+00_JPRB,1.3154E+01_JPRB/)
KBO( :, 4,13,15) = (/&
&7.8628E+00_JPRB,6.3217E+00_JPRB,8.1422E+00_JPRB,1.2196E+01_JPRB,1.6296E+01_JPRB/)
KBO( :, 5,13,15) = (/&
&9.8525E+00_JPRB,7.9653E+00_JPRB,1.0472E+01_JPRB,1.5686E+01_JPRB,2.0959E+01_JPRB/)
KBO( :, 1,14,15) = (/&
&3.5755E+00_JPRB,2.8779E+00_JPRB,3.4519E+00_JPRB,5.1028E+00_JPRB,1.0373E+01_JPRB/)
KBO( :, 2,14,15) = (/&
&5.0524E+00_JPRB,4.1250E+00_JPRB,4.9883E+00_JPRB,7.3878E+00_JPRB,1.1513E+01_JPRB/)
KBO( :, 3,14,15) = (/&
&6.8346E+00_JPRB,5.5984E+00_JPRB,6.8212E+00_JPRB,1.0151E+01_JPRB,1.3855E+01_JPRB/)
KBO( :, 4,14,15) = (/&
&8.9000E+00_JPRB,7.2723E+00_JPRB,8.9537E+00_JPRB,1.3379E+01_JPRB,1.7871E+01_JPRB/)
KBO( :, 5,14,15) = (/&
&1.1265E+01_JPRB,9.1701E+00_JPRB,1.1497E+01_JPRB,1.7206E+01_JPRB,2.2981E+01_JPRB/)
KBO( :, 1,15,15) = (/&
&4.0824E+00_JPRB,3.3435E+00_JPRB,3.8164E+00_JPRB,5.5870E+00_JPRB,9.5637E+00_JPRB/)
KBO( :, 2,15,15) = (/&
&5.7577E+00_JPRB,4.7850E+00_JPRB,5.5076E+00_JPRB,8.0842E+00_JPRB,1.1461E+01_JPRB/)
KBO( :, 3,15,15) = (/&
&7.8213E+00_JPRB,6.5007E+00_JPRB,7.5362E+00_JPRB,1.1097E+01_JPRB,1.4826E+01_JPRB/)
KBO( :, 4,15,15) = (/&
&1.0256E+01_JPRB,8.4593E+00_JPRB,9.9114E+00_JPRB,1.4655E+01_JPRB,1.9572E+01_JPRB/)
KBO( :, 5,15,15) = (/&
&1.3032E+01_JPRB,1.0687E+01_JPRB,1.2684E+01_JPRB,1.8793E+01_JPRB,2.5099E+01_JPRB/)
KBO( :, 1,16,15) = (/&
&4.7372E+00_JPRB,3.9270E+00_JPRB,4.2463E+00_JPRB,6.1221E+00_JPRB,9.0976E+00_JPRB/)
KBO( :, 2,16,15) = (/&
&6.6436E+00_JPRB,5.5787E+00_JPRB,6.1045E+00_JPRB,8.8126E+00_JPRB,1.1843E+01_JPRB/)
KBO( :, 3,16,15) = (/&
&9.0517E+00_JPRB,7.5797E+00_JPRB,8.3542E+00_JPRB,1.2092E+01_JPRB,1.6147E+01_JPRB/)
KBO( :, 4,16,15) = (/&
&1.1879E+01_JPRB,9.9008E+00_JPRB,1.1023E+01_JPRB,1.5960E+01_JPRB,2.1309E+01_JPRB/)
KBO( :, 5,16,15) = (/&
&1.5093E+01_JPRB,1.2519E+01_JPRB,1.4078E+01_JPRB,2.0387E+01_JPRB,2.7221E+01_JPRB/)
KBO( :, 1,17,15) = (/&
&5.5197E+00_JPRB,4.6160E+00_JPRB,4.7418E+00_JPRB,6.6773E+00_JPRB,9.2205E+00_JPRB/)
KBO( :, 2,17,15) = (/&
&7.7119E+00_JPRB,6.5019E+00_JPRB,6.7774E+00_JPRB,9.5358E+00_JPRB,1.2727E+01_JPRB/)
KBO( :, 3,17,15) = (/&
&1.0467E+01_JPRB,8.8388E+00_JPRB,9.2742E+00_JPRB,1.3058E+01_JPRB,1.7430E+01_JPRB/)
KBO( :, 4,17,15) = (/&
&1.3720E+01_JPRB,1.1553E+01_JPRB,1.2244E+01_JPRB,1.7227E+01_JPRB,2.2998E+01_JPRB/)
KBO( :, 5,17,15) = (/&
&1.7413E+01_JPRB,1.4594E+01_JPRB,1.5673E+01_JPRB,2.2047E+01_JPRB,2.9433E+01_JPRB/)
KBO( :, 1,18,15) = (/&
&6.4274E+00_JPRB,5.4111E+00_JPRB,5.3034E+00_JPRB,7.2350E+00_JPRB,9.7622E+00_JPRB/)
KBO( :, 2,18,15) = (/&
&8.9573E+00_JPRB,7.5807E+00_JPRB,7.5479E+00_JPRB,1.0273E+01_JPRB,1.3710E+01_JPRB/)
KBO( :, 3,18,15) = (/&
&1.2111E+01_JPRB,1.0258E+01_JPRB,1.0321E+01_JPRB,1.4006E+01_JPRB,1.8696E+01_JPRB/)
KBO( :, 4,18,15) = (/&
&1.5845E+01_JPRB,1.3386E+01_JPRB,1.3622E+01_JPRB,1.8470E+01_JPRB,2.4650E+01_JPRB/)
KBO( :, 5,18,15) = (/&
&2.0084E+01_JPRB,1.6890E+01_JPRB,1.7434E+01_JPRB,2.3673E+01_JPRB,3.1599E+01_JPRB/)
KBO( :, 1,19,15) = (/&
&7.5164E+00_JPRB,6.3134E+00_JPRB,5.9395E+00_JPRB,7.8093E+00_JPRB,1.0475E+01_JPRB/)
KBO( :, 2,19,15) = (/&
&1.0441E+01_JPRB,8.8014E+00_JPRB,8.4278E+00_JPRB,1.1035E+01_JPRB,1.4729E+01_JPRB/)
KBO( :, 3,19,15) = (/&
&1.4043E+01_JPRB,1.1861E+01_JPRB,1.1513E+01_JPRB,1.4988E+01_JPRB,2.0004E+01_JPRB/)
KBO( :, 4,19,15) = (/&
&1.8322E+01_JPRB,1.5433E+01_JPRB,1.5177E+01_JPRB,1.9715E+01_JPRB,2.6318E+01_JPRB/)
KBO( :, 5,19,15) = (/&
&2.3146E+01_JPRB,1.9466E+01_JPRB,1.9384E+01_JPRB,2.5255E+01_JPRB,3.3709E+01_JPRB/)
KBO( :, 1,20,15) = (/&
&8.8455E+00_JPRB,7.4066E+00_JPRB,6.7186E+00_JPRB,8.4558E+00_JPRB,1.1343E+01_JPRB/)
KBO( :, 2,20,15) = (/&
&1.2219E+01_JPRB,1.0275E+01_JPRB,9.4871E+00_JPRB,1.1882E+01_JPRB,1.5858E+01_JPRB/)
KBO( :, 3,20,15) = (/&
&1.6346E+01_JPRB,1.3763E+01_JPRB,1.2931E+01_JPRB,1.6095E+01_JPRB,2.1479E+01_JPRB/)
KBO( :, 4,20,15) = (/&
&2.1206E+01_JPRB,1.7855E+01_JPRB,1.6990E+01_JPRB,2.1127E+01_JPRB,2.8198E+01_JPRB/)
KBO( :, 5,20,15) = (/&
&2.6661E+01_JPRB,2.2435E+01_JPRB,2.1640E+01_JPRB,2.6969E+01_JPRB,3.5995E+01_JPRB/)
KBO( :, 1,21,15) = (/&
&1.0378E+01_JPRB,8.6731E+00_JPRB,7.6340E+00_JPRB,9.1349E+00_JPRB,1.2281E+01_JPRB/)
KBO( :, 2,21,15) = (/&
&1.4246E+01_JPRB,1.1959E+01_JPRB,1.0712E+01_JPRB,1.2780E+01_JPRB,1.7040E+01_JPRB/)
KBO( :, 3,21,15) = (/&
&1.8940E+01_JPRB,1.5929E+01_JPRB,1.4528E+01_JPRB,1.7265E+01_JPRB,2.3018E+01_JPRB/)
KBO( :, 4,21,15) = (/&
&2.4416E+01_JPRB,2.0563E+01_JPRB,1.9019E+01_JPRB,2.2602E+01_JPRB,3.0124E+01_JPRB/)
KBO( :, 5,21,15) = (/&
&3.0523E+01_JPRB,2.5747E+01_JPRB,2.4135E+01_JPRB,2.8712E+01_JPRB,3.8248E+01_JPRB/)
KBO( :, 1,22,15) = (/&
&1.2355E+01_JPRB,1.0324E+01_JPRB,8.9103E+00_JPRB,1.0132E+01_JPRB,1.3532E+01_JPRB/)
KBO( :, 2,22,15) = (/&
&1.6827E+01_JPRB,1.4110E+01_JPRB,1.2397E+01_JPRB,1.4085E+01_JPRB,1.8635E+01_JPRB/)
KBO( :, 3,22,15) = (/&
&2.2180E+01_JPRB,1.8653E+01_JPRB,1.6659E+01_JPRB,1.8921E+01_JPRB,2.5003E+01_JPRB/)
KBO( :, 4,22,15) = (/&
&2.8311E+01_JPRB,2.3905E+01_JPRB,2.1641E+01_JPRB,2.4584E+01_JPRB,3.2472E+01_JPRB/)
KBO( :, 5,22,15) = (/&
&3.5149E+01_JPRB,2.9738E+01_JPRB,2.7250E+01_JPRB,3.1004E+01_JPRB,4.0987E+01_JPRB/)
KBO( :, 1,23,15) = (/&
&1.4605E+01_JPRB,1.2205E+01_JPRB,1.0445E+01_JPRB,1.1291E+01_JPRB,1.4871E+01_JPRB/)
KBO( :, 2,23,15) = (/&
&1.9716E+01_JPRB,1.6539E+01_JPRB,1.4376E+01_JPRB,1.5566E+01_JPRB,2.0310E+01_JPRB/)
KBO( :, 3,23,15) = (/&
&2.5726E+01_JPRB,2.1683E+01_JPRB,1.9115E+01_JPRB,2.0736E+01_JPRB,2.6995E+01_JPRB/)
KBO( :, 4,23,15) = (/&
&3.2572E+01_JPRB,2.7566E+01_JPRB,2.4581E+01_JPRB,2.6716E+01_JPRB,3.4786E+01_JPRB/)
KBO( :, 5,23,15) = (/&
&4.0123E+01_JPRB,3.4080E+01_JPRB,3.0686E+01_JPRB,3.3457E+01_JPRB,4.3686E+01_JPRB/)
KBO( :, 1,24,15) = (/&
&1.7134E+01_JPRB,1.4330E+01_JPRB,1.2237E+01_JPRB,1.2592E+01_JPRB,1.6241E+01_JPRB/)
KBO( :, 2,24,15) = (/&
&2.2882E+01_JPRB,1.9252E+01_JPRB,1.6642E+01_JPRB,1.7193E+01_JPRB,2.2035E+01_JPRB/)
KBO( :, 3,24,15) = (/&
&2.9584E+01_JPRB,2.5005E+01_JPRB,2.1866E+01_JPRB,2.2682E+01_JPRB,2.9023E+01_JPRB/)
KBO( :, 4,24,15) = (/&
&3.7130E+01_JPRB,3.1556E+01_JPRB,2.7836E+01_JPRB,2.8990E+01_JPRB,3.7154E+01_JPRB/)
KBO( :, 5,24,15) = (/&
&4.5388E+01_JPRB,3.8713E+01_JPRB,3.4446E+01_JPRB,3.6104E+01_JPRB,4.6377E+01_JPRB/)
KBO( :, 1,25,15) = (/&
&1.9927E+01_JPRB,1.6707E+01_JPRB,1.4288E+01_JPRB,1.4051E+01_JPRB,1.7699E+01_JPRB/)
KBO( :, 2,25,15) = (/&
&2.6343E+01_JPRB,2.2217E+01_JPRB,1.9188E+01_JPRB,1.8973E+01_JPRB,2.3814E+01_JPRB/)
KBO( :, 3,25,15) = (/&
&3.3724E+01_JPRB,2.8620E+01_JPRB,2.4897E+01_JPRB,2.4764E+01_JPRB,3.1106E+01_JPRB/)
KBO( :, 4,25,15) = (/&
&4.1952E+01_JPRB,3.5794E+01_JPRB,3.1378E+01_JPRB,3.1440E+01_JPRB,3.9572E+01_JPRB/)
KBO( :, 5,25,15) = (/&
&5.0891E+01_JPRB,4.3587E+01_JPRB,3.8479E+01_JPRB,3.8878E+01_JPRB,4.9030E+01_JPRB/)
KBO( :, 1,26,15) = (/&
&2.3026E+01_JPRB,1.9365E+01_JPRB,1.6616E+01_JPRB,1.5692E+01_JPRB,1.9320E+01_JPRB/)
KBO( :, 2,26,15) = (/&
&3.0129E+01_JPRB,2.5491E+01_JPRB,2.2032E+01_JPRB,2.0944E+01_JPRB,2.5726E+01_JPRB/)
KBO( :, 3,26,15) = (/&
&3.8188E+01_JPRB,3.2536E+01_JPRB,2.8266E+01_JPRB,2.7089E+01_JPRB,3.3354E+01_JPRB/)
KBO( :, 4,26,15) = (/&
&4.7076E+01_JPRB,4.0316E+01_JPRB,3.5238E+01_JPRB,3.4113E+01_JPRB,4.2106E+01_JPRB/)
KBO( :, 5,26,15) = (/&
&5.6691E+01_JPRB,4.8702E+01_JPRB,4.2828E+01_JPRB,4.1890E+01_JPRB,5.1865E+01_JPRB/)
KBO( :, 1,27,15) = (/&
&2.6319E+01_JPRB,2.2209E+01_JPRB,1.9103E+01_JPRB,1.7475E+01_JPRB,2.1047E+01_JPRB/)
KBO( :, 2,27,15) = (/&
&3.4077E+01_JPRB,2.8961E+01_JPRB,2.5047E+01_JPRB,2.3066E+01_JPRB,2.7740E+01_JPRB/)
KBO( :, 3,27,15) = (/&
&4.2766E+01_JPRB,3.6599E+01_JPRB,3.1799E+01_JPRB,2.9545E+01_JPRB,3.5624E+01_JPRB/)
KBO( :, 4,27,15) = (/&
&5.2311E+01_JPRB,4.4949E+01_JPRB,3.9254E+01_JPRB,3.6881E+01_JPRB,4.4625E+01_JPRB/)
KBO( :, 5,27,15) = (/&
&6.2535E+01_JPRB,5.3903E+01_JPRB,4.7276E+01_JPRB,4.4959E+01_JPRB,5.4744E+01_JPRB/)
KBO( :, 1,28,15) = (/&
&2.9739E+01_JPRB,2.5212E+01_JPRB,2.1725E+01_JPRB,1.9370E+01_JPRB,2.2823E+01_JPRB/)
KBO( :, 2,28,15) = (/&
&3.8111E+01_JPRB,3.2556E+01_JPRB,2.8178E+01_JPRB,2.5312E+01_JPRB,2.9805E+01_JPRB/)
KBO( :, 3,28,15) = (/&
&4.7442E+01_JPRB,4.0758E+01_JPRB,3.5447E+01_JPRB,3.2130E+01_JPRB,3.7952E+01_JPRB/)
KBO( :, 4,28,15) = (/&
&5.7581E+01_JPRB,4.9637E+01_JPRB,4.3359E+01_JPRB,3.9780E+01_JPRB,4.7241E+01_JPRB/)
KBO( :, 5,28,15) = (/&
&6.8350E+01_JPRB,5.9110E+01_JPRB,5.1790E+01_JPRB,4.8135E+01_JPRB,5.7711E+01_JPRB/)
KBO( :, 1,29,15) = (/&
&3.3289E+01_JPRB,2.8377E+01_JPRB,2.4485E+01_JPRB,2.1425E+01_JPRB,2.4625E+01_JPRB/)
KBO( :, 2,29,15) = (/&
&4.2270E+01_JPRB,3.6277E+01_JPRB,3.1445E+01_JPRB,2.7695E+01_JPRB,3.1898E+01_JPRB/)
KBO( :, 3,29,15) = (/&
&5.2200E+01_JPRB,4.5001E+01_JPRB,3.9165E+01_JPRB,3.4833E+01_JPRB,4.0336E+01_JPRB/)
KBO( :, 4,29,15) = (/&
&6.2884E+01_JPRB,5.4377E+01_JPRB,4.7526E+01_JPRB,4.2792E+01_JPRB,4.9976E+01_JPRB/)
KBO( :, 5,29,15) = (/&
&7.4157E+01_JPRB,6.4312E+01_JPRB,5.6343E+01_JPRB,5.1436E+01_JPRB,6.0842E+01_JPRB/)
KBO( :, 1,30,15) = (/&
&3.6922E+01_JPRB,3.1637E+01_JPRB,2.7336E+01_JPRB,2.3566E+01_JPRB,2.6436E+01_JPRB/)
KBO( :, 2,30,15) = (/&
&4.6484E+01_JPRB,4.0046E+01_JPRB,3.4764E+01_JPRB,3.0148E+01_JPRB,3.4000E+01_JPRB/)
KBO( :, 3,30,15) = (/&
&5.6941E+01_JPRB,4.9235E+01_JPRB,4.2907E+01_JPRB,3.7604E+01_JPRB,4.2767E+01_JPRB/)
KBO( :, 4,30,15) = (/&
&6.8119E+01_JPRB,5.9074E+01_JPRB,5.1660E+01_JPRB,4.5840E+01_JPRB,5.2778E+01_JPRB/)
KBO( :, 5,30,15) = (/&
&7.9816E+01_JPRB,6.9391E+01_JPRB,6.0797E+01_JPRB,5.4746E+01_JPRB,6.4070E+01_JPRB/)
KBO( :, 1,31,15) = (/&
&4.0648E+01_JPRB,3.4989E+01_JPRB,3.0276E+01_JPRB,2.5790E+01_JPRB,2.8253E+01_JPRB/)
KBO( :, 2,31,15) = (/&
&5.0739E+01_JPRB,4.3869E+01_JPRB,3.8136E+01_JPRB,3.2693E+01_JPRB,3.6176E+01_JPRB/)
KBO( :, 3,31,15) = (/&
&6.1698E+01_JPRB,5.3493E+01_JPRB,4.6669E+01_JPRB,4.0453E+01_JPRB,4.5327E+01_JPRB/)
KBO( :, 4,31,15) = (/&
&7.3307E+01_JPRB,6.3725E+01_JPRB,5.5765E+01_JPRB,4.8944E+01_JPRB,5.5745E+01_JPRB/)
KBO( :, 5,31,15) = (/&
&8.5379E+01_JPRB,7.4384E+01_JPRB,6.5189E+01_JPRB,5.8116E+01_JPRB,6.7439E+01_JPRB/)
KBO( :, 1,32,15) = (/&
&4.4430E+01_JPRB,3.8384E+01_JPRB,3.3279E+01_JPRB,2.8093E+01_JPRB,3.0198E+01_JPRB/)
KBO( :, 2,32,15) = (/&
&5.5010E+01_JPRB,4.7713E+01_JPRB,4.1521E+01_JPRB,3.5304E+01_JPRB,3.8486E+01_JPRB/)
KBO( :, 3,32,15) = (/&
&6.6406E+01_JPRB,5.7714E+01_JPRB,5.0403E+01_JPRB,4.3340E+01_JPRB,4.8019E+01_JPRB/)
KBO( :, 4,32,15) = (/&
&7.8394E+01_JPRB,6.8294E+01_JPRB,5.9802E+01_JPRB,5.2093E+01_JPRB,5.8861E+01_JPRB/)
KBO( :, 5,32,15) = (/&
&9.0789E+01_JPRB,7.9248E+01_JPRB,6.9496E+01_JPRB,6.1520E+01_JPRB,7.0971E+01_JPRB/)
KBO( :, 1,33,15) = (/&
&4.8242E+01_JPRB,4.1814E+01_JPRB,3.6311E+01_JPRB,3.0445E+01_JPRB,3.2261E+01_JPRB/)
KBO( :, 2,33,15) = (/&
&5.9259E+01_JPRB,5.1534E+01_JPRB,4.4898E+01_JPRB,3.7953E+01_JPRB,4.0933E+01_JPRB/)
KBO( :, 3,33,15) = (/&
&7.1044E+01_JPRB,6.1877E+01_JPRB,5.4099E+01_JPRB,4.6243E+01_JPRB,5.0861E+01_JPRB/)
KBO( :, 4,33,15) = (/&
&8.3385E+01_JPRB,7.2754E+01_JPRB,6.3738E+01_JPRB,5.5225E+01_JPRB,6.2072E+01_JPRB/)
KBO( :, 5,33,15) = (/&
&9.6014E+01_JPRB,8.3965E+01_JPRB,7.3665E+01_JPRB,6.4932E+01_JPRB,7.4660E+01_JPRB/)
KBO( :, 1,34,15) = (/&
&5.1672E+01_JPRB,4.4907E+01_JPRB,3.9052E+01_JPRB,3.2559E+01_JPRB,3.4150E+01_JPRB/)
KBO( :, 2,34,15) = (/&
&6.3066E+01_JPRB,5.4942E+01_JPRB,4.7932E+01_JPRB,4.0320E+01_JPRB,4.3137E+01_JPRB/)
KBO( :, 3,34,15) = (/&
&7.5181E+01_JPRB,6.5586E+01_JPRB,5.7376E+01_JPRB,4.8848E+01_JPRB,5.3416E+01_JPRB/)
KBO( :, 4,34,15) = (/&
&8.7786E+01_JPRB,7.6718E+01_JPRB,6.7237E+01_JPRB,5.8022E+01_JPRB,6.4986E+01_JPRB/)
KBO( :, 5,34,15) = (/&
&1.0062E+02_JPRB,8.8122E+01_JPRB,7.7322E+01_JPRB,6.7972E+01_JPRB,7.7968E+01_JPRB/)
KBO( :, 1,35,15) = (/&
&5.3974E+01_JPRB,4.7010E+01_JPRB,4.0914E+01_JPRB,3.3953E+01_JPRB,3.5284E+01_JPRB/)
KBO( :, 2,35,15) = (/&
&6.5632E+01_JPRB,5.7261E+01_JPRB,4.9986E+01_JPRB,4.1880E+01_JPRB,4.4477E+01_JPRB/)
KBO( :, 3,35,15) = (/&
&7.7983E+01_JPRB,6.8108E+01_JPRB,5.9607E+01_JPRB,5.0554E+01_JPRB,5.4966E+01_JPRB/)
KBO( :, 4,35,15) = (/&
&9.0774E+01_JPRB,7.9423E+01_JPRB,6.9615E+01_JPRB,5.9856E+01_JPRB,6.6747E+01_JPRB/)
KBO( :, 5,35,15) = (/&
&1.0376E+02_JPRB,9.0958E+01_JPRB,7.9827E+01_JPRB,6.9953E+01_JPRB,7.9975E+01_JPRB/)
KBO( :, 1,36,15) = (/&
&5.4952E+01_JPRB,4.7928E+01_JPRB,4.1728E+01_JPRB,3.4482E+01_JPRB,3.5497E+01_JPRB/)
KBO( :, 2,36,15) = (/&
&6.6748E+01_JPRB,5.8304E+01_JPRB,5.0900E+01_JPRB,4.2469E+01_JPRB,4.4743E+01_JPRB/)
KBO( :, 3,36,15) = (/&
&7.9237E+01_JPRB,6.9268E+01_JPRB,6.0630E+01_JPRB,5.1203E+01_JPRB,5.5299E+01_JPRB/)
KBO( :, 4,36,15) = (/&
&9.2160E+01_JPRB,8.0690E+01_JPRB,7.0740E+01_JPRB,6.0560E+01_JPRB,6.7150E+01_JPRB/)
KBO( :, 5,36,15) = (/&
&1.0527E+02_JPRB,9.2347E+01_JPRB,8.1033E+01_JPRB,7.0691E+01_JPRB,8.0445E+01_JPRB/)
KBO( :, 1,37,15) = (/&
&5.4077E+01_JPRB,4.7203E+01_JPRB,4.1090E+01_JPRB,3.3816E+01_JPRB,3.4402E+01_JPRB/)
KBO( :, 2,37,15) = (/&
&6.5871E+01_JPRB,5.7581E+01_JPRB,5.0256E+01_JPRB,4.1730E+01_JPRB,4.3504E+01_JPRB/)
KBO( :, 3,37,15) = (/&
&7.8394E+01_JPRB,6.8564E+01_JPRB,6.0003E+01_JPRB,5.0406E+01_JPRB,5.3919E+01_JPRB/)
KBO( :, 4,37,15) = (/&
&9.1373E+01_JPRB,8.0024E+01_JPRB,7.0155E+01_JPRB,5.9711E+01_JPRB,6.5630E+01_JPRB/)
KBO( :, 5,37,15) = (/&
&1.0457E+02_JPRB,9.1743E+01_JPRB,8.0502E+01_JPRB,6.9769E+01_JPRB,7.8764E+01_JPRB/)
KBO( :, 1,38,15) = (/&
&5.2998E+01_JPRB,4.6292E+01_JPRB,4.0284E+01_JPRB,3.3047E+01_JPRB,3.3256E+01_JPRB/)
KBO( :, 2,38,15) = (/&
&6.4758E+01_JPRB,5.6646E+01_JPRB,4.9430E+01_JPRB,4.0867E+01_JPRB,4.2193E+01_JPRB/)
KBO( :, 3,38,15) = (/&
&7.7286E+01_JPRB,6.7628E+01_JPRB,5.9170E+01_JPRB,4.9481E+01_JPRB,5.2447E+01_JPRB/)
KBO( :, 4,38,15) = (/&
&9.0295E+01_JPRB,7.9101E+01_JPRB,6.9339E+01_JPRB,5.8727E+01_JPRB,6.4002E+01_JPRB/)
KBO( :, 5,38,15) = (/&
&1.0355E+02_JPRB,9.0878E+01_JPRB,7.9733E+01_JPRB,6.8695E+01_JPRB,7.6964E+01_JPRB/)
KBO( :, 1,39,15) = (/&
&5.1838E+01_JPRB,4.5309E+01_JPRB,3.9414E+01_JPRB,3.2253E+01_JPRB,3.2133E+01_JPRB/)
KBO( :, 2,39,15) = (/&
&6.3550E+01_JPRB,5.5622E+01_JPRB,4.8527E+01_JPRB,3.9972E+01_JPRB,4.0905E+01_JPRB/)
KBO( :, 3,39,15) = (/&
&7.6056E+01_JPRB,6.6591E+01_JPRB,5.8243E+01_JPRB,4.8504E+01_JPRB,5.0987E+01_JPRB/)
KBO( :, 4,39,15) = (/&
&8.9075E+01_JPRB,7.8055E+01_JPRB,6.8422E+01_JPRB,5.7684E+01_JPRB,6.2386E+01_JPRB/)
KBO( :, 5,39,15) = (/&
&1.0239E+02_JPRB,8.9867E+01_JPRB,7.8837E+01_JPRB,6.7576E+01_JPRB,7.5172E+01_JPRB/)
KBO( :, 1,40,15) = (/&
&4.9471E+01_JPRB,4.3246E+01_JPRB,3.7591E+01_JPRB,3.0698E+01_JPRB,3.0218E+01_JPRB/)
KBO( :, 2,40,15) = (/&
&6.1032E+01_JPRB,5.3431E+01_JPRB,4.6594E+01_JPRB,3.8229E+01_JPRB,3.8702E+01_JPRB/)
KBO( :, 3,40,15) = (/&
&7.3417E+01_JPRB,6.4309E+01_JPRB,5.6223E+01_JPRB,4.6591E+01_JPRB,4.8455E+01_JPRB/)
KBO( :, 4,40,15) = (/&
&8.6398E+01_JPRB,7.5721E+01_JPRB,6.6340E+01_JPRB,5.5655E+01_JPRB,5.9567E+01_JPRB/)
KBO( :, 5,40,15) = (/&
&9.9725E+01_JPRB,8.7493E+01_JPRB,7.6754E+01_JPRB,6.5366E+01_JPRB,7.2010E+01_JPRB/)
KBO( :, 1,41,15) = (/&
&4.6940E+01_JPRB,4.1029E+01_JPRB,3.5646E+01_JPRB,2.9054E+01_JPRB,2.8252E+01_JPRB/)
KBO( :, 2,41,15) = (/&
&5.8303E+01_JPRB,5.1061E+01_JPRB,4.4488E+01_JPRB,3.6382E+01_JPRB,3.6429E+01_JPRB/)
KBO( :, 3,41,15) = (/&
&7.0545E+01_JPRB,6.1809E+01_JPRB,5.4014E+01_JPRB,4.4569E+01_JPRB,4.5866E+01_JPRB/)
KBO( :, 4,41,15) = (/&
&8.3446E+01_JPRB,7.3140E+01_JPRB,6.4053E+01_JPRB,5.3489E+01_JPRB,5.6653E+01_JPRB/)
KBO( :, 5,41,15) = (/&
&9.6762E+01_JPRB,8.4890E+01_JPRB,7.4453E+01_JPRB,6.3028E+01_JPRB,6.8762E+01_JPRB/)
KBO( :, 1,42,15) = (/&
&4.4400E+01_JPRB,3.8808E+01_JPRB,3.3695E+01_JPRB,2.7433E+01_JPRB,2.6367E+01_JPRB/)
KBO( :, 2,42,15) = (/&
&5.5548E+01_JPRB,4.8653E+01_JPRB,4.2370E+01_JPRB,3.4558E+01_JPRB,3.4231E+01_JPRB/)
KBO( :, 3,42,15) = (/&
&6.7639E+01_JPRB,5.9264E+01_JPRB,5.1765E+01_JPRB,4.2548E+01_JPRB,4.3345E+01_JPRB/)
KBO( :, 4,42,15) = (/&
&8.0422E+01_JPRB,7.0505E+01_JPRB,6.1708E+01_JPRB,5.1309E+01_JPRB,5.3802E+01_JPRB/)
KBO( :, 5,42,15) = (/&
&9.3690E+01_JPRB,8.2187E+01_JPRB,7.2071E+01_JPRB,6.0692E+01_JPRB,6.5582E+01_JPRB/)
KBO( :, 1,43,15) = (/&
&4.1299E+01_JPRB,3.6086E+01_JPRB,3.1303E+01_JPRB,2.5481E+01_JPRB,2.4168E+01_JPRB/)
KBO( :, 2,43,15) = (/&
&5.2146E+01_JPRB,4.5668E+01_JPRB,3.9733E+01_JPRB,3.2349E+01_JPRB,3.1657E+01_JPRB/)
KBO( :, 3,43,15) = (/&
&6.3997E+01_JPRB,5.6104E+01_JPRB,4.8948E+01_JPRB,4.0078E+01_JPRB,4.0382E+01_JPRB/)
KBO( :, 4,43,15) = (/&
&7.6621E+01_JPRB,6.7188E+01_JPRB,5.8773E+01_JPRB,4.8617E+01_JPRB,5.0407E+01_JPRB/)
KBO( :, 5,43,15) = (/&
&8.9810E+01_JPRB,7.8771E+01_JPRB,6.9043E+01_JPRB,5.7825E+01_JPRB,6.1798E+01_JPRB/)
KBO( :, 1,44,15) = (/&
&3.8013E+01_JPRB,3.3205E+01_JPRB,2.8794E+01_JPRB,2.3425E+01_JPRB,2.1911E+01_JPRB/)
KBO( :, 2,44,15) = (/&
&4.8506E+01_JPRB,4.2466E+01_JPRB,3.6916E+01_JPRB,3.0017E+01_JPRB,2.8999E+01_JPRB/)
KBO( :, 3,44,15) = (/&
&6.0070E+01_JPRB,5.2664E+01_JPRB,4.5908E+01_JPRB,3.7464E+01_JPRB,3.7309E+01_JPRB/)
KBO( :, 4,44,15) = (/&
&7.2479E+01_JPRB,6.3560E+01_JPRB,5.5564E+01_JPRB,4.5749E+01_JPRB,4.6877E+01_JPRB/)
KBO( :, 5,44,15) = (/&
&8.5539E+01_JPRB,7.5028E+01_JPRB,6.5726E+01_JPRB,5.4770E+01_JPRB,5.7838E+01_JPRB/)
KBO( :, 1,45,15) = (/&
&3.4808E+01_JPRB,3.0429E+01_JPRB,2.6372E+01_JPRB,2.1438E+01_JPRB,1.9764E+01_JPRB/)
KBO( :, 2,45,15) = (/&
&4.4949E+01_JPRB,3.9329E+01_JPRB,3.4164E+01_JPRB,2.7759E+01_JPRB,2.6477E+01_JPRB/)
KBO( :, 3,45,15) = (/&
&5.6198E+01_JPRB,4.9271E+01_JPRB,4.2916E+01_JPRB,3.4929E+01_JPRB,3.4365E+01_JPRB/)
KBO( :, 4,45,15) = (/&
&6.8372E+01_JPRB,5.9966E+01_JPRB,5.2371E+01_JPRB,4.2948E+01_JPRB,4.3515E+01_JPRB/)
KBO( :, 5,45,15) = (/&
&8.1258E+01_JPRB,7.1280E+01_JPRB,6.2402E+01_JPRB,5.1752E+01_JPRB,5.3999E+01_JPRB/)
KBO( :, 1,46,15) = (/&
&3.1505E+01_JPRB,2.7578E+01_JPRB,2.3887E+01_JPRB,1.9401E+01_JPRB,1.7612E+01_JPRB/)
KBO( :, 2,46,15) = (/&
&4.1254E+01_JPRB,3.6080E+01_JPRB,3.1312E+01_JPRB,2.5449E+01_JPRB,2.3941E+01_JPRB/)
KBO( :, 3,46,15) = (/&
&5.2137E+01_JPRB,4.5691E+01_JPRB,3.9762E+01_JPRB,3.2315E+01_JPRB,3.1392E+01_JPRB/)
KBO( :, 4,46,15) = (/&
&6.4023E+01_JPRB,5.6167E+01_JPRB,4.8996E+01_JPRB,4.0034E+01_JPRB,4.0089E+01_JPRB/)
KBO( :, 5,46,15) = (/&
&7.6702E+01_JPRB,6.7284E+01_JPRB,5.8863E+01_JPRB,4.8569E+01_JPRB,5.0083E+01_JPRB/)
KBO( :, 1,47,15) = (/&
&2.7961E+01_JPRB,2.4503E+01_JPRB,2.1248E+01_JPRB,1.7233E+01_JPRB,1.5367E+01_JPRB/)
KBO( :, 2,47,15) = (/&
&3.7265E+01_JPRB,3.2586E+01_JPRB,2.8263E+01_JPRB,2.2963E+01_JPRB,2.1269E+01_JPRB/)
KBO( :, 3,47,15) = (/&
&4.7706E+01_JPRB,4.1783E+01_JPRB,3.6327E+01_JPRB,2.9490E+01_JPRB,2.8246E+01_JPRB/)
KBO( :, 4,47,15) = (/&
&5.9232E+01_JPRB,5.1960E+01_JPRB,4.5284E+01_JPRB,3.6873E+01_JPRB,3.6445E+01_JPRB/)
KBO( :, 5,47,15) = (/&
&7.1624E+01_JPRB,6.2836E+01_JPRB,5.4930E+01_JPRB,4.5104E+01_JPRB,4.5902E+01_JPRB/)
KBO( :, 1,48,15) = (/&
&2.4583E+01_JPRB,2.1589E+01_JPRB,1.8762E+01_JPRB,1.5191E+01_JPRB,1.3292E+01_JPRB/)
KBO( :, 2,48,15) = (/&
&3.3426E+01_JPRB,2.9268E+01_JPRB,2.5357E+01_JPRB,2.0590E+01_JPRB,1.8769E+01_JPRB/)
KBO( :, 3,48,15) = (/&
&4.3425E+01_JPRB,3.8016E+01_JPRB,3.3009E+01_JPRB,2.6800E+01_JPRB,2.5307E+01_JPRB/)
KBO( :, 4,48,15) = (/&
&5.4549E+01_JPRB,4.7838E+01_JPRB,4.1652E+01_JPRB,3.3842E+01_JPRB,3.3001E+01_JPRB/)
KBO( :, 5,48,15) = (/&
&6.6636E+01_JPRB,5.8472E+01_JPRB,5.1042E+01_JPRB,4.1740E+01_JPRB,4.1948E+01_JPRB/)
KBO( :, 1,49,15) = (/&
&2.1421E+01_JPRB,1.8843E+01_JPRB,1.6440E+01_JPRB,1.3266E+01_JPRB,1.1366E+01_JPRB/)
KBO( :, 2,49,15) = (/&
&2.9765E+01_JPRB,2.6085E+01_JPRB,2.2608E+01_JPRB,1.8340E+01_JPRB,1.6436E+01_JPRB/)
KBO( :, 3,49,15) = (/&
&3.9312E+01_JPRB,3.4398E+01_JPRB,2.9848E+01_JPRB,2.4239E+01_JPRB,2.2553E+01_JPRB/)
KBO( :, 4,49,15) = (/&
&5.0006E+01_JPRB,4.3828E+01_JPRB,3.8123E+01_JPRB,3.0941E+01_JPRB,2.9764E+01_JPRB/)
KBO( :, 5,49,15) = (/&
&6.1741E+01_JPRB,5.4182E+01_JPRB,4.7244E+01_JPRB,3.8502E+01_JPRB,3.8207E+01_JPRB/)
KBO( :, 1,50,15) = (/&
&1.8647E+01_JPRB,1.6457E+01_JPRB,1.4418E+01_JPRB,1.1591E+01_JPRB,9.7268E+00_JPRB/)
KBO( :, 2,50,15) = (/&
&2.6492E+01_JPRB,2.3254E+01_JPRB,2.0184E+01_JPRB,1.6354E+01_JPRB,1.4411E+01_JPRB/)
KBO( :, 3,50,15) = (/&
&3.5615E+01_JPRB,3.1176E+01_JPRB,2.7033E+01_JPRB,2.1940E+01_JPRB,2.0122E+01_JPRB/)
KBO( :, 4,50,15) = (/&
&4.5887E+01_JPRB,4.0194E+01_JPRB,3.4925E+01_JPRB,2.8335E+01_JPRB,2.6904E+01_JPRB/)
KBO( :, 5,50,15) = (/&
&5.7262E+01_JPRB,5.0235E+01_JPRB,4.3773E+01_JPRB,3.5576E+01_JPRB,3.4879E+01_JPRB/)
KBO( :, 1,51,15) = (/&
&1.6143E+01_JPRB,1.4306E+01_JPRB,1.2586E+01_JPRB,1.0093E+01_JPRB,8.2870E+00_JPRB/)
KBO( :, 2,51,15) = (/&
&2.3475E+01_JPRB,2.0646E+01_JPRB,1.7965E+01_JPRB,1.4527E+01_JPRB,1.2580E+01_JPRB/)
KBO( :, 3,51,15) = (/&
&3.2173E+01_JPRB,2.8191E+01_JPRB,2.4427E+01_JPRB,1.9818E+01_JPRB,1.7912E+01_JPRB/)
KBO( :, 4,51,15) = (/&
&4.2029E+01_JPRB,3.6799E+01_JPRB,3.1946E+01_JPRB,2.5931E+01_JPRB,2.4302E+01_JPRB/)
KBO( :, 5,51,15) = (/&
&5.3021E+01_JPRB,4.6505E+01_JPRB,4.0477E+01_JPRB,3.2858E+01_JPRB,3.1825E+01_JPRB/)
KBO( :, 1,52,15) = (/&
&1.3849E+01_JPRB,1.2323E+01_JPRB,1.0901E+01_JPRB,8.7257E+00_JPRB,7.0030E+00_JPRB/)
KBO( :, 2,52,15) = (/&
&2.0656E+01_JPRB,1.8194E+01_JPRB,1.5897E+01_JPRB,1.2810E+01_JPRB,1.0879E+01_JPRB/)
KBO( :, 3,52,15) = (/&
&2.8881E+01_JPRB,2.5328E+01_JPRB,2.1965E+01_JPRB,1.7806E+01_JPRB,1.5846E+01_JPRB/)
KBO( :, 4,52,15) = (/&
&3.8328E+01_JPRB,3.3546E+01_JPRB,2.9106E+01_JPRB,2.3622E+01_JPRB,2.1850E+01_JPRB/)
KBO( :, 5,52,15) = (/&
&4.8918E+01_JPRB,4.2880E+01_JPRB,3.7289E+01_JPRB,3.0246E+01_JPRB,2.8936E+01_JPRB/)
KBO( :, 1,53,15) = (/&
&1.1740E+01_JPRB,1.0506E+01_JPRB,9.3420E+00_JPRB,7.4730E+00_JPRB,5.8524E+00_JPRB/)
KBO( :, 2,53,15) = (/&
&1.8002E+01_JPRB,1.5914E+01_JPRB,1.3956E+01_JPRB,1.1210E+01_JPRB,9.3278E+00_JPRB/)
KBO( :, 3,53,15) = (/&
&2.5731E+01_JPRB,2.2607E+01_JPRB,1.9634E+01_JPRB,1.5897E+01_JPRB,1.3918E+01_JPRB/)
KBO( :, 4,53,15) = (/&
&3.4758E+01_JPRB,3.0444E+01_JPRB,2.6393E+01_JPRB,2.1412E+01_JPRB,1.9532E+01_JPRB/)
KBO( :, 5,53,15) = (/&
&4.4940E+01_JPRB,3.9367E+01_JPRB,3.4201E+01_JPRB,2.7742E+01_JPRB,2.6213E+01_JPRB/)
KBO( :, 1,54,15) = (/&
&9.9823E+00_JPRB,8.9835E+00_JPRB,8.0433E+00_JPRB,6.4217E+00_JPRB,4.9233E+00_JPRB/)
KBO( :, 2,54,15) = (/&
&1.5743E+01_JPRB,1.3968E+01_JPRB,1.2300E+01_JPRB,9.8589E+00_JPRB,8.0425E+00_JPRB/)
KBO( :, 3,54,15) = (/&
&2.2999E+01_JPRB,2.0231E+01_JPRB,1.7622E+01_JPRB,1.4237E+01_JPRB,1.2265E+01_JPRB/)
KBO( :, 4,54,15) = (/&
&3.1619E+01_JPRB,2.7721E+01_JPRB,2.4021E+01_JPRB,1.9481E+01_JPRB,1.7533E+01_JPRB/)
KBO( :, 5,54,15) = (/&
&4.1422E+01_JPRB,3.6269E+01_JPRB,3.1486E+01_JPRB,2.5548E+01_JPRB,2.3860E+01_JPRB/)
KBO( :, 1,55,15) = (/&
&8.4600E+00_JPRB,7.6587E+00_JPRB,6.9105E+00_JPRB,5.5064E+00_JPRB,4.1393E+00_JPRB/)
KBO( :, 2,55,15) = (/&
&1.3741E+01_JPRB,1.2235E+01_JPRB,1.0828E+01_JPRB,8.6641E+00_JPRB,6.9310E+00_JPRB/)
KBO( :, 3,55,15) = (/&
&2.0525E+01_JPRB,1.8089E+01_JPRB,1.5809E+01_JPRB,1.2733E+01_JPRB,1.0785E+01_JPRB/)
KBO( :, 4,55,15) = (/&
&2.8733E+01_JPRB,2.5211E+01_JPRB,2.1862E+01_JPRB,1.7718E+01_JPRB,1.5733E+01_JPRB/)
KBO( :, 5,55,15) = (/&
&3.8167E+01_JPRB,3.3414E+01_JPRB,2.8994E+01_JPRB,2.3523E+01_JPRB,2.1717E+01_JPRB/)
KBO( :, 1,56,15) = (/&
&7.0942E+00_JPRB,6.4705E+00_JPRB,5.8843E+00_JPRB,4.6820E+00_JPRB,3.4600E+00_JPRB/)
KBO( :, 2,56,15) = (/&
&1.1888E+01_JPRB,1.0638E+01_JPRB,9.4563E+00_JPRB,7.5636E+00_JPRB,5.9306E+00_JPRB/)
KBO( :, 3,56,15) = (/&
&1.8195E+01_JPRB,1.6084E+01_JPRB,1.4104E+01_JPRB,1.1328E+01_JPRB,9.4258E+00_JPRB/)
KBO( :, 4,56,15) = (/&
&2.5965E+01_JPRB,2.2816E+01_JPRB,1.9813E+01_JPRB,1.6042E+01_JPRB,1.4044E+01_JPRB/)
KBO( :, 5,56,15) = (/&
&3.5031E+01_JPRB,3.0686E+01_JPRB,2.6607E+01_JPRB,2.1582E+01_JPRB,1.9682E+01_JPRB/)
KBO( :, 1,57,15) = (/&
&5.8809E+00_JPRB,5.4073E+00_JPRB,4.9520E+00_JPRB,3.9358E+00_JPRB,2.8765E+00_JPRB/)
KBO( :, 2,57,15) = (/&
&1.0188E+01_JPRB,9.1644E+00_JPRB,8.1997E+00_JPRB,6.5476E+00_JPRB,5.0356E+00_JPRB/)
KBO( :, 3,57,15) = (/&
&1.6011E+01_JPRB,1.4204E+01_JPRB,1.2504E+01_JPRB,1.0022E+01_JPRB,8.1887E+00_JPRB/)
KBO( :, 4,57,15) = (/&
&2.3331E+01_JPRB,2.0526E+01_JPRB,1.7871E+01_JPRB,1.4443E+01_JPRB,1.2452E+01_JPRB/)
KBO( :, 5,57,15) = (/&
&3.2013E+01_JPRB,2.8066E+01_JPRB,2.4321E+01_JPRB,1.9722E+01_JPRB,1.7763E+01_JPRB/)
KBO( :, 1,58,15) = (/&
&4.8592E+00_JPRB,4.5120E+00_JPRB,4.1533E+00_JPRB,3.3050E+00_JPRB,2.4069E+00_JPRB/)
KBO( :, 2,58,15) = (/&
&8.7235E+00_JPRB,7.8898E+00_JPRB,7.1098E+00_JPRB,5.6659E+00_JPRB,4.2880E+00_JPRB/)
KBO( :, 3,58,15) = (/&
&1.4093E+01_JPRB,1.2543E+01_JPRB,1.1091E+01_JPRB,8.8788E+00_JPRB,7.1312E+00_JPRB/)
KBO( :, 4,58,15) = (/&
&2.0969E+01_JPRB,1.8473E+01_JPRB,1.6137E+01_JPRB,1.3004E+01_JPRB,1.1037E+01_JPRB/)
KBO( :, 5,58,15) = (/&
&2.9256E+01_JPRB,2.5669E+01_JPRB,2.2254E+01_JPRB,1.8039E+01_JPRB,1.6041E+01_JPRB/)
KBO( :, 1,59,15) = (/&
&4.4860E+00_JPRB,4.1832E+00_JPRB,3.8589E+00_JPRB,3.0732E+00_JPRB,2.2588E+00_JPRB/)
KBO( :, 2,59,15) = (/&
&8.1764E+00_JPRB,7.4157E+00_JPRB,6.7019E+00_JPRB,5.3375E+00_JPRB,4.0381E+00_JPRB/)
KBO( :, 3,59,15) = (/&
&1.3363E+01_JPRB,1.1913E+01_JPRB,1.0553E+01_JPRB,8.4437E+00_JPRB,6.7583E+00_JPRB/)
KBO( :, 4,59,15) = (/&
&2.0059E+01_JPRB,1.7690E+01_JPRB,1.5474E+01_JPRB,1.2453E+01_JPRB,1.0517E+01_JPRB/)
KBO( :, 5,59,15) = (/&
&2.8188E+01_JPRB,2.4740E+01_JPRB,2.1460E+01_JPRB,1.7388E+01_JPRB,1.5382E+01_JPRB/)
KBO( :, 1,13,16) = (/&
&3.5240E+00_JPRB,3.4508E+00_JPRB,6.8957E+00_JPRB,1.0310E+01_JPRB,1.3810E+01_JPRB/)
KBO( :, 2,13,16) = (/&
&5.0188E+00_JPRB,4.8884E+00_JPRB,9.7668E+00_JPRB,1.4606E+01_JPRB,1.9563E+01_JPRB/)
KBO( :, 3,13,16) = (/&
&6.8636E+00_JPRB,6.9963E+00_JPRB,1.3983E+01_JPRB,2.0917E+01_JPRB,2.7996E+01_JPRB/)
KBO( :, 4,13,16) = (/&
&8.9983E+00_JPRB,9.9231E+00_JPRB,1.9821E+01_JPRB,2.9657E+01_JPRB,3.9702E+01_JPRB/)
KBO( :, 5,13,16) = (/&
&1.1391E+01_JPRB,1.3448E+01_JPRB,2.6873E+01_JPRB,4.0197E+01_JPRB,5.3821E+01_JPRB/)
KBO( :, 1,14,16) = (/&
&4.0865E+00_JPRB,4.2627E+00_JPRB,8.5157E+00_JPRB,1.2737E+01_JPRB,1.7061E+01_JPRB/)
KBO( :, 2,14,16) = (/&
&5.9152E+00_JPRB,5.9770E+00_JPRB,1.1941E+01_JPRB,1.7861E+01_JPRB,2.3919E+01_JPRB/)
KBO( :, 3,14,16) = (/&
&8.1116E+00_JPRB,8.4946E+00_JPRB,1.6974E+01_JPRB,2.5393E+01_JPRB,3.3994E+01_JPRB/)
KBO( :, 4,14,16) = (/&
&1.0667E+01_JPRB,1.1982E+01_JPRB,2.3941E+01_JPRB,3.5820E+01_JPRB,4.7947E+01_JPRB/)
KBO( :, 5,14,16) = (/&
&1.3570E+01_JPRB,1.6166E+01_JPRB,3.2293E+01_JPRB,4.8328E+01_JPRB,6.4679E+01_JPRB/)
KBO( :, 1,15,16) = (/&
&4.9205E+00_JPRB,5.2381E+00_JPRB,1.0467E+01_JPRB,1.5657E+01_JPRB,2.0962E+01_JPRB/)
KBO( :, 2,15,16) = (/&
&7.1107E+00_JPRB,7.3251E+00_JPRB,1.4636E+01_JPRB,2.1892E+01_JPRB,2.9314E+01_JPRB/)
KBO( :, 3,15,16) = (/&
&9.7657E+00_JPRB,1.0319E+01_JPRB,2.0625E+01_JPRB,3.0857E+01_JPRB,4.1307E+01_JPRB/)
KBO( :, 4,15,16) = (/&
&1.2863E+01_JPRB,1.4348E+01_JPRB,2.8667E+01_JPRB,4.2902E+01_JPRB,5.7415E+01_JPRB/)
KBO( :, 5,15,16) = (/&
&1.6377E+01_JPRB,1.9245E+01_JPRB,3.8440E+01_JPRB,5.7530E+01_JPRB,7.7014E+01_JPRB/)
KBO( :, 1,16,16) = (/&
&6.0019E+00_JPRB,6.3755E+00_JPRB,1.2742E+01_JPRB,1.9060E+01_JPRB,2.5511E+01_JPRB/)
KBO( :, 2,16,16) = (/&
&8.6719E+00_JPRB,8.9601E+00_JPRB,1.7905E+01_JPRB,2.6782E+01_JPRB,3.5858E+01_JPRB/)
KBO( :, 3,16,16) = (/&
&1.1897E+01_JPRB,1.2494E+01_JPRB,2.4965E+01_JPRB,3.7351E+01_JPRB,5.0005E+01_JPRB/)
KBO( :, 4,16,16) = (/&
&1.5664E+01_JPRB,1.7033E+01_JPRB,3.4039E+01_JPRB,5.0943E+01_JPRB,6.8160E+01_JPRB/)
KBO( :, 5,16,16) = (/&
&1.9931E+01_JPRB,2.2609E+01_JPRB,4.5144E+01_JPRB,6.7604E+01_JPRB,9.0384E+01_JPRB/)
KBO( :, 1,17,16) = (/&
&7.3859E+00_JPRB,7.7004E+00_JPRB,1.5389E+01_JPRB,2.3023E+01_JPRB,3.0816E+01_JPRB/)
KBO( :, 2,17,16) = (/&
&1.0640E+01_JPRB,1.0863E+01_JPRB,2.1706E+01_JPRB,3.2470E+01_JPRB,4.3467E+01_JPRB/)
KBO( :, 3,17,16) = (/&
&1.4563E+01_JPRB,1.4992E+01_JPRB,2.9958E+01_JPRB,4.4824E+01_JPRB,5.9991E+01_JPRB/)
KBO( :, 4,17,16) = (/&
&1.9138E+01_JPRB,2.0152E+01_JPRB,4.0219E+01_JPRB,6.0189E+01_JPRB,8.0517E+01_JPRB/)
KBO( :, 5,17,16) = (/&
&2.4286E+01_JPRB,2.6459E+01_JPRB,5.2448E+01_JPRB,7.8504E+01_JPRB,1.0501E+02_JPRB/)
KBO( :, 1,18,16) = (/&
&9.1226E+00_JPRB,9.2597E+00_JPRB,1.8491E+01_JPRB,2.7668E+01_JPRB,3.7034E+01_JPRB/)
KBO( :, 2,18,16) = (/&
&1.3090E+01_JPRB,1.3038E+01_JPRB,2.6008E+01_JPRB,3.8923E+01_JPRB,5.2083E+01_JPRB/)
KBO( :, 3,18,16) = (/&
&1.7870E+01_JPRB,1.7862E+01_JPRB,3.5545E+01_JPRB,5.3199E+01_JPRB,7.1167E+01_JPRB/)
KBO( :, 4,18,16) = (/&
&2.3384E+01_JPRB,2.3802E+01_JPRB,4.7105E+01_JPRB,7.0494E+01_JPRB,9.4316E+01_JPRB/)
KBO( :, 5,18,16) = (/&
&2.9603E+01_JPRB,3.0959E+01_JPRB,6.0617E+01_JPRB,9.0761E+01_JPRB,1.2137E+02_JPRB/)
KBO( :, 1,19,16) = (/&
&1.1267E+01_JPRB,1.1103E+01_JPRB,2.1975E+01_JPRB,3.2891E+01_JPRB,4.4000E+01_JPRB/)
KBO( :, 2,19,16) = (/&
&1.6108E+01_JPRB,1.5588E+01_JPRB,3.0737E+01_JPRB,4.5998E+01_JPRB,6.1538E+01_JPRB/)
KBO( :, 3,19,16) = (/&
&2.1880E+01_JPRB,2.1226E+01_JPRB,4.1603E+01_JPRB,6.2286E+01_JPRB,8.3284E+01_JPRB/)
KBO( :, 4,19,16) = (/&
&2.8546E+01_JPRB,2.8063E+01_JPRB,5.4555E+01_JPRB,8.1653E+01_JPRB,1.0920E+02_JPRB/)
KBO( :, 5,19,16) = (/&
&3.6015E+01_JPRB,3.6209E+01_JPRB,6.9418E+01_JPRB,1.0398E+02_JPRB,1.3897E+02_JPRB/)
KBO( :, 1,20,16) = (/&
&1.3993E+01_JPRB,1.3379E+01_JPRB,2.5920E+01_JPRB,3.8804E+01_JPRB,5.1896E+01_JPRB/)
KBO( :, 2,20,16) = (/&
&1.9857E+01_JPRB,1.8711E+01_JPRB,3.5970E+01_JPRB,5.3858E+01_JPRB,7.2020E+01_JPRB/)
KBO( :, 3,20,16) = (/&
&2.6849E+01_JPRB,2.5309E+01_JPRB,4.8236E+01_JPRB,7.2221E+01_JPRB,9.6564E+01_JPRB/)
KBO( :, 4,20,16) = (/&
&3.4854E+01_JPRB,3.3204E+01_JPRB,6.2605E+01_JPRB,9.3754E+01_JPRB,1.2532E+02_JPRB/)
KBO( :, 5,20,16) = (/&
&4.3828E+01_JPRB,4.2464E+01_JPRB,7.8932E+01_JPRB,1.1822E+02_JPRB,1.5801E+02_JPRB/)
KBO( :, 1,21,16) = (/&
&1.7315E+01_JPRB,1.6114E+01_JPRB,3.0129E+01_JPRB,4.5115E+01_JPRB,6.0314E+01_JPRB/)
KBO( :, 2,21,16) = (/&
&2.4393E+01_JPRB,2.2395E+01_JPRB,4.1483E+01_JPRB,6.2116E+01_JPRB,8.3040E+01_JPRB/)
KBO( :, 3,21,16) = (/&
&3.2776E+01_JPRB,3.0091E+01_JPRB,5.5119E+01_JPRB,8.2559E+01_JPRB,1.1033E+02_JPRB/)
KBO( :, 4,21,16) = (/&
&4.2294E+01_JPRB,3.9176E+01_JPRB,7.0924E+01_JPRB,1.0622E+02_JPRB,1.4195E+02_JPRB/)
KBO( :, 5,21,16) = (/&
&5.3038E+01_JPRB,4.9692E+01_JPRB,8.8908E+01_JPRB,1.3317E+02_JPRB,1.7794E+02_JPRB/)
KBO( :, 1,22,16) = (/&
&2.1825E+01_JPRB,1.9779E+01_JPRB,3.5248E+01_JPRB,5.2796E+01_JPRB,7.0550E+01_JPRB/)
KBO( :, 2,22,16) = (/&
&3.0396E+01_JPRB,2.7253E+01_JPRB,4.8033E+01_JPRB,7.1948E+01_JPRB,9.6125E+01_JPRB/)
KBO( :, 3,22,16) = (/&
&4.0380E+01_JPRB,3.6230E+01_JPRB,6.3173E+01_JPRB,9.4660E+01_JPRB,1.2648E+02_JPRB/)
KBO( :, 4,22,16) = (/&
&5.1797E+01_JPRB,4.6707E+01_JPRB,8.0766E+01_JPRB,1.2099E+02_JPRB,1.6165E+02_JPRB/)
KBO( :, 5,22,16) = (/&
&6.4540E+01_JPRB,5.8724E+01_JPRB,1.0071E+02_JPRB,1.5084E+02_JPRB,2.0156E+02_JPRB/)
KBO( :, 1,23,16) = (/&
&2.7320E+01_JPRB,2.4188E+01_JPRB,4.0693E+01_JPRB,6.0960E+01_JPRB,8.1453E+01_JPRB/)
KBO( :, 2,23,16) = (/&
&3.7558E+01_JPRB,3.2976E+01_JPRB,5.4970E+01_JPRB,8.2336E+01_JPRB,1.1003E+02_JPRB/)
KBO( :, 3,23,16) = (/&
&4.9408E+01_JPRB,4.3375E+01_JPRB,7.1816E+01_JPRB,1.0759E+02_JPRB,1.4373E+02_JPRB/)
KBO( :, 4,23,16) = (/&
&6.2874E+01_JPRB,5.5353E+01_JPRB,9.1309E+01_JPRB,1.3680E+02_JPRB,1.8276E+02_JPRB/)
KBO( :, 5,23,16) = (/&
&7.7698E+01_JPRB,6.8961E+01_JPRB,1.1333E+02_JPRB,1.6978E+02_JPRB,2.2679E+02_JPRB/)
KBO( :, 1,24,16) = (/&
&3.3869E+01_JPRB,2.9387E+01_JPRB,4.6648E+01_JPRB,6.9904E+01_JPRB,9.3367E+01_JPRB/)
KBO( :, 2,24,16) = (/&
&4.6006E+01_JPRB,3.9622E+01_JPRB,6.2515E+01_JPRB,9.3679E+01_JPRB,1.2511E+02_JPRB/)
KBO( :, 3,24,16) = (/&
&5.9946E+01_JPRB,5.1571E+01_JPRB,8.1209E+01_JPRB,1.2167E+02_JPRB,1.6250E+02_JPRB/)
KBO( :, 4,24,16) = (/&
&7.5539E+01_JPRB,6.5110E+01_JPRB,1.0265E+02_JPRB,1.5380E+02_JPRB,2.0542E+02_JPRB/)
KBO( :, 5,24,16) = (/&
&9.2477E+01_JPRB,8.0448E+01_JPRB,1.2660E+02_JPRB,1.8969E+02_JPRB,2.5333E+02_JPRB/)
KBO( :, 1,25,16) = (/&
&4.1599E+01_JPRB,3.5454E+01_JPRB,5.3146E+01_JPRB,7.9642E+01_JPRB,1.0635E+02_JPRB/)
KBO( :, 2,25,16) = (/&
&5.5782E+01_JPRB,4.7228E+01_JPRB,7.0740E+01_JPRB,1.0597E+02_JPRB,1.4155E+02_JPRB/)
KBO( :, 3,25,16) = (/&
&7.1943E+01_JPRB,6.0744E+01_JPRB,9.1338E+01_JPRB,1.3688E+02_JPRB,1.8276E+02_JPRB/)
KBO( :, 4,25,16) = (/&
&8.9735E+01_JPRB,7.6043E+01_JPRB,1.1460E+02_JPRB,1.7175E+02_JPRB,2.2932E+02_JPRB/)
KBO( :, 5,25,16) = (/&
&1.0881E+02_JPRB,9.3022E+01_JPRB,1.4062E+02_JPRB,2.1079E+02_JPRB,2.8133E+02_JPRB/)
KBO( :, 1,26,16) = (/&
&5.0633E+01_JPRB,4.2540E+01_JPRB,6.0521E+01_JPRB,9.0533E+01_JPRB,1.2089E+02_JPRB/)
KBO( :, 2,26,16) = (/&
&6.7031E+01_JPRB,5.5881E+01_JPRB,7.9837E+01_JPRB,1.1964E+02_JPRB,1.5974E+02_JPRB/)
KBO( :, 3,26,16) = (/&
&8.5449E+01_JPRB,7.1046E+01_JPRB,1.0219E+02_JPRB,1.5314E+02_JPRB,2.0448E+02_JPRB/)
KBO( :, 4,26,16) = (/&
&1.0550E+02_JPRB,8.8104E+01_JPRB,1.2741E+02_JPRB,1.9092E+02_JPRB,2.5490E+02_JPRB/)
KBO( :, 5,26,16) = (/&
&1.2662E+02_JPRB,1.0665E+02_JPRB,1.5535E+02_JPRB,2.3284E+02_JPRB,3.1085E+02_JPRB/)
KBO( :, 1,27,16) = (/&
&6.0760E+01_JPRB,5.0362E+01_JPRB,6.8627E+01_JPRB,1.0214E+02_JPRB,1.3635E+02_JPRB/)
KBO( :, 2,27,16) = (/&
&7.9372E+01_JPRB,6.5351E+01_JPRB,8.9496E+01_JPRB,1.3381E+02_JPRB,1.7862E+02_JPRB/)
KBO( :, 3,27,16) = (/&
&1.0007E+02_JPRB,8.2171E+01_JPRB,1.1350E+02_JPRB,1.7014E+02_JPRB,2.2709E+02_JPRB/)
KBO( :, 4,27,16) = (/&
&1.2219E+02_JPRB,1.0086E+02_JPRB,1.4060E+02_JPRB,2.1077E+02_JPRB,2.8135E+02_JPRB/)
KBO( :, 5,27,16) = (/&
&1.4517E+02_JPRB,1.2078E+02_JPRB,1.7031E+02_JPRB,2.5527E+02_JPRB,3.4078E+02_JPRB/)
KBO( :, 1,28,16) = (/&
&7.1850E+01_JPRB,5.8865E+01_JPRB,7.7249E+01_JPRB,1.1435E+02_JPRB,1.5263E+02_JPRB/)
KBO( :, 2,28,16) = (/&
&9.2653E+01_JPRB,7.5393E+01_JPRB,9.9671E+01_JPRB,1.4851E+02_JPRB,1.9822E+02_JPRB/)
KBO( :, 3,28,16) = (/&
&1.1541E+02_JPRB,9.3821E+01_JPRB,1.2515E+02_JPRB,1.8738E+02_JPRB,2.5009E+02_JPRB/)
KBO( :, 4,28,16) = (/&
&1.3940E+02_JPRB,1.1403E+02_JPRB,1.5381E+02_JPRB,2.3053E+02_JPRB,3.0770E+02_JPRB/)
KBO( :, 5,28,16) = (/&
&1.6406E+02_JPRB,1.3517E+02_JPRB,1.8510E+02_JPRB,2.7748E+02_JPRB,3.7030E+02_JPRB/)
KBO( :, 1,29,16) = (/&
&8.3876E+01_JPRB,6.7955E+01_JPRB,8.6536E+01_JPRB,1.2716E+02_JPRB,1.6971E+02_JPRB/)
KBO( :, 2,29,16) = (/&
&1.0671E+02_JPRB,8.6050E+01_JPRB,1.1035E+02_JPRB,1.6386E+02_JPRB,2.1869E+02_JPRB/)
KBO( :, 3,29,16) = (/&
&1.3128E+02_JPRB,1.0596E+02_JPRB,1.3736E+02_JPRB,2.0522E+02_JPRB,2.7387E+02_JPRB/)
KBO( :, 4,29,16) = (/&
&1.5691E+02_JPRB,1.2750E+02_JPRB,1.6737E+02_JPRB,2.5071E+02_JPRB,3.3454E+02_JPRB/)
KBO( :, 5,29,16) = (/&
&1.8307E+02_JPRB,1.4968E+02_JPRB,1.9986E+02_JPRB,2.9963E+02_JPRB,3.9981E+02_JPRB/)
KBO( :, 1,30,16) = (/&
&9.6402E+01_JPRB,7.7403E+01_JPRB,9.6100E+01_JPRB,1.4042E+02_JPRB,1.8733E+02_JPRB/)
KBO( :, 2,30,16) = (/&
&1.2111E+02_JPRB,9.6917E+01_JPRB,1.2129E+02_JPRB,1.7953E+02_JPRB,2.3957E+02_JPRB/)
KBO( :, 3,30,16) = (/&
&1.4725E+02_JPRB,1.1830E+02_JPRB,1.4967E+02_JPRB,2.2319E+02_JPRB,2.9778E+02_JPRB/)
KBO( :, 4,30,16) = (/&
&1.7435E+02_JPRB,1.4089E+02_JPRB,1.8090E+02_JPRB,2.7076E+02_JPRB,3.6126E+02_JPRB/)
KBO( :, 5,30,16) = (/&
&2.0174E+02_JPRB,1.6391E+02_JPRB,2.1447E+02_JPRB,3.2140E+02_JPRB,4.2881E+02_JPRB/)
KBO( :, 1,31,16) = (/&
&1.0938E+02_JPRB,8.7129E+01_JPRB,1.0605E+02_JPRB,1.5425E+02_JPRB,2.0576E+02_JPRB/)
KBO( :, 2,31,16) = (/&
&1.3571E+02_JPRB,1.0800E+02_JPRB,1.3247E+02_JPRB,1.9550E+02_JPRB,2.6086E+02_JPRB/)
KBO( :, 3,31,16) = (/&
&1.6324E+02_JPRB,1.3063E+02_JPRB,1.6212E+02_JPRB,2.4122E+02_JPRB,3.2182E+02_JPRB/)
KBO( :, 4,31,16) = (/&
&1.9162E+02_JPRB,1.5412E+02_JPRB,1.9447E+02_JPRB,2.9069E+02_JPRB,3.8783E+02_JPRB/)
KBO( :, 5,31,16) = (/&
&2.1989E+02_JPRB,1.7781E+02_JPRB,2.2900E+02_JPRB,3.4301E+02_JPRB,4.5761E+02_JPRB/)
KBO( :, 1,32,16) = (/&
&1.2256E+02_JPRB,9.7067E+01_JPRB,1.1617E+02_JPRB,1.6836E+02_JPRB,2.2461E+02_JPRB/)
KBO( :, 2,32,16) = (/&
&1.5030E+02_JPRB,1.1913E+02_JPRB,1.4393E+02_JPRB,2.1170E+02_JPRB,2.8241E+02_JPRB/)
KBO( :, 3,32,16) = (/&
&1.7905E+02_JPRB,1.4279E+02_JPRB,1.7463E+02_JPRB,2.5936E+02_JPRB,3.4601E+02_JPRB/)
KBO( :, 4,32,16) = (/&
&2.0835E+02_JPRB,1.6700E+02_JPRB,2.0791E+02_JPRB,3.1047E+02_JPRB,4.1404E+02_JPRB/)
KBO( :, 5,32,16) = (/&
&2.3734E+02_JPRB,1.9118E+02_JPRB,2.4327E+02_JPRB,3.6420E+02_JPRB,4.8584E+02_JPRB/)
KBO( :, 1,33,16) = (/&
&1.3570E+02_JPRB,1.0705E+02_JPRB,1.2638E+02_JPRB,1.8277E+02_JPRB,2.4379E+02_JPRB/)
KBO( :, 2,33,16) = (/&
&1.6469E+02_JPRB,1.3015E+02_JPRB,1.5530E+02_JPRB,2.2797E+02_JPRB,3.0408E+02_JPRB/)
KBO( :, 3,33,16) = (/&
&1.9448E+02_JPRB,1.5467E+02_JPRB,1.8707E+02_JPRB,2.7733E+02_JPRB,3.6994E+02_JPRB/)
KBO( :, 4,33,16) = (/&
&2.2436E+02_JPRB,1.7936E+02_JPRB,2.2122E+02_JPRB,3.2976E+02_JPRB,4.3991E+02_JPRB/)
KBO( :, 5,33,16) = (/&
&2.5393E+02_JPRB,2.0390E+02_JPRB,2.5728E+02_JPRB,3.8487E+02_JPRB,5.1330E+02_JPRB/)
KBO( :, 1,34,16) = (/&
&1.4769E+02_JPRB,1.1615E+02_JPRB,1.3561E+02_JPRB,1.9580E+02_JPRB,2.6115E+02_JPRB/)
KBO( :, 2,34,16) = (/&
&1.7765E+02_JPRB,1.4013E+02_JPRB,1.6546E+02_JPRB,2.4255E+02_JPRB,3.2352E+02_JPRB/)
KBO( :, 3,34,16) = (/&
&2.0819E+02_JPRB,1.6522E+02_JPRB,1.9808E+02_JPRB,2.9327E+02_JPRB,3.9114E+02_JPRB/)
KBO( :, 4,34,16) = (/&
&2.3855E+02_JPRB,1.9025E+02_JPRB,2.3293E+02_JPRB,3.4692E+02_JPRB,4.6270E+02_JPRB/)
KBO( :, 5,34,16) = (/&
&2.6850E+02_JPRB,2.1503E+02_JPRB,2.6955E+02_JPRB,4.0292E+02_JPRB,5.3742E+02_JPRB/)
KBO( :, 1,35,16) = (/&
&1.5643E+02_JPRB,1.2270E+02_JPRB,1.4190E+02_JPRB,2.0436E+02_JPRB,2.7254E+02_JPRB/)
KBO( :, 2,35,16) = (/&
&1.8713E+02_JPRB,1.4730E+02_JPRB,1.7243E+02_JPRB,2.5214E+02_JPRB,3.3629E+02_JPRB/)
KBO( :, 3,35,16) = (/&
&2.1819E+02_JPRB,1.7282E+02_JPRB,2.0562E+02_JPRB,3.0372E+02_JPRB,4.0506E+02_JPRB/)
KBO( :, 4,35,16) = (/&
&2.4895E+02_JPRB,1.9814E+02_JPRB,2.4081E+02_JPRB,3.5825E+02_JPRB,4.7775E+02_JPRB/)
KBO( :, 5,35,16) = (/&
&2.7917E+02_JPRB,2.2313E+02_JPRB,2.7780E+02_JPRB,4.1495E+02_JPRB,5.5336E+02_JPRB/)
KBO( :, 1,36,16) = (/&
&1.6128E+02_JPRB,1.2623E+02_JPRB,1.4470E+02_JPRB,2.0760E+02_JPRB,2.7682E+02_JPRB/)
KBO( :, 2,36,16) = (/&
&1.9250E+02_JPRB,1.5118E+02_JPRB,1.7553E+02_JPRB,2.5587E+02_JPRB,3.4124E+02_JPRB/)
KBO( :, 3,36,16) = (/&
&2.2400E+02_JPRB,1.7706E+02_JPRB,2.0894E+02_JPRB,3.0787E+02_JPRB,4.1050E+02_JPRB/)
KBO( :, 4,36,16) = (/&
&2.5511E+02_JPRB,2.0265E+02_JPRB,2.4435E+02_JPRB,3.6281E+02_JPRB,4.8383E+02_JPRB/)
KBO( :, 5,36,16) = (/&
&2.8566E+02_JPRB,2.2781E+02_JPRB,2.8144E+02_JPRB,4.1994E+02_JPRB,5.6005E+02_JPRB/)
KBO( :, 1,37,16) = (/&
&1.6074E+02_JPRB,1.2562E+02_JPRB,1.4270E+02_JPRB,2.0342E+02_JPRB,2.7131E+02_JPRB/)
KBO( :, 2,37,16) = (/&
&1.9235E+02_JPRB,1.5069E+02_JPRB,1.7337E+02_JPRB,2.5150E+02_JPRB,3.3544E+02_JPRB/)
KBO( :, 3,37,16) = (/&
&2.2422E+02_JPRB,1.7676E+02_JPRB,2.0661E+02_JPRB,3.0337E+02_JPRB,4.0456E+02_JPRB/)
KBO( :, 4,37,16) = (/&
&2.5568E+02_JPRB,2.0266E+02_JPRB,2.4193E+02_JPRB,3.5830E+02_JPRB,4.7782E+02_JPRB/)
KBO( :, 5,37,16) = (/&
&2.8661E+02_JPRB,2.2807E+02_JPRB,2.7894E+02_JPRB,4.1548E+02_JPRB,5.5411E+02_JPRB/)
KBO( :, 1,38,16) = (/&
&1.5931E+02_JPRB,1.2434E+02_JPRB,1.4021E+02_JPRB,1.9855E+02_JPRB,2.6480E+02_JPRB/)
KBO( :, 2,38,16) = (/&
&1.9120E+02_JPRB,1.4947E+02_JPRB,1.7064E+02_JPRB,2.4634E+02_JPRB,3.2849E+02_JPRB/)
KBO( :, 3,38,16) = (/&
&2.2336E+02_JPRB,1.7568E+02_JPRB,2.0368E+02_JPRB,2.9797E+02_JPRB,3.9734E+02_JPRB/)
KBO( :, 4,38,16) = (/&
&2.5520E+02_JPRB,2.0184E+02_JPRB,2.3879E+02_JPRB,3.5282E+02_JPRB,4.7045E+02_JPRB/)
KBO( :, 5,38,16) = (/&
&2.8646E+02_JPRB,2.2749E+02_JPRB,2.7570E+02_JPRB,4.0988E+02_JPRB,5.4664E+02_JPRB/)
KBO( :, 1,39,16) = (/&
&1.5737E+02_JPRB,1.2272E+02_JPRB,1.3752E+02_JPRB,1.9347E+02_JPRB,2.5800E+02_JPRB/)
KBO( :, 2,39,16) = (/&
&1.8947E+02_JPRB,1.4785E+02_JPRB,1.6766E+02_JPRB,2.4086E+02_JPRB,3.2118E+02_JPRB/)
KBO( :, 3,39,16) = (/&
&2.2190E+02_JPRB,1.7414E+02_JPRB,2.0048E+02_JPRB,2.9227E+02_JPRB,3.8976E+02_JPRB/)
KBO( :, 4,39,16) = (/&
&2.5401E+02_JPRB,2.0054E+02_JPRB,2.3540E+02_JPRB,3.4685E+02_JPRB,4.6257E+02_JPRB/)
KBO( :, 5,39,16) = (/&
&2.8557E+02_JPRB,2.2640E+02_JPRB,2.7220E+02_JPRB,4.0387E+02_JPRB,5.3853E+02_JPRB/)
KBO( :, 1,40,16) = (/&
&1.5173E+02_JPRB,1.1834E+02_JPRB,1.3170E+02_JPRB,1.8369E+02_JPRB,2.4496E+02_JPRB/)
KBO( :, 2,40,16) = (/&
&1.8387E+02_JPRB,1.4326E+02_JPRB,1.6126E+02_JPRB,2.3014E+02_JPRB,3.0690E+02_JPRB/)
KBO( :, 3,40,16) = (/&
&2.1654E+02_JPRB,1.6951E+02_JPRB,1.9355E+02_JPRB,2.8092E+02_JPRB,3.7460E+02_JPRB/)
KBO( :, 4,40,16) = (/&
&2.4896E+02_JPRB,1.9611E+02_JPRB,2.2806E+02_JPRB,3.3490E+02_JPRB,4.4658E+02_JPRB/)
KBO( :, 5,40,16) = (/&
&2.8081E+02_JPRB,2.2225E+02_JPRB,2.6459E+02_JPRB,3.9162E+02_JPRB,5.2225E+02_JPRB/)
KBO( :, 1,41,16) = (/&
&1.4531E+02_JPRB,1.1344E+02_JPRB,1.2539E+02_JPRB,1.7342E+02_JPRB,2.3126E+02_JPRB/)
KBO( :, 2,41,16) = (/&
&1.7739E+02_JPRB,1.3804E+02_JPRB,1.5439E+02_JPRB,2.1880E+02_JPRB,2.9176E+02_JPRB/)
KBO( :, 3,41,16) = (/&
&2.1022E+02_JPRB,1.6418E+02_JPRB,1.8612E+02_JPRB,2.6873E+02_JPRB,3.5832E+02_JPRB/)
KBO( :, 4,41,16) = (/&
&2.4292E+02_JPRB,1.9086E+02_JPRB,2.2015E+02_JPRB,3.2196E+02_JPRB,4.2934E+02_JPRB/)
KBO( :, 5,41,16) = (/&
&2.7507E+02_JPRB,2.1730E+02_JPRB,2.5630E+02_JPRB,3.7839E+02_JPRB,5.0449E+02_JPRB/)
KBO( :, 1,42,16) = (/&
&1.3859E+02_JPRB,1.0832E+02_JPRB,1.1902E+02_JPRB,1.6325E+02_JPRB,2.1769E+02_JPRB/)
KBO( :, 2,42,16) = (/&
&1.7052E+02_JPRB,1.3266E+02_JPRB,1.4745E+02_JPRB,2.0749E+02_JPRB,2.7665E+02_JPRB/)
KBO( :, 3,42,16) = (/&
&2.0342E+02_JPRB,1.5859E+02_JPRB,1.7863E+02_JPRB,2.5644E+02_JPRB,3.4199E+02_JPRB/)
KBO( :, 4,42,16) = (/&
&2.3635E+02_JPRB,1.8528E+02_JPRB,2.1215E+02_JPRB,3.0913E+02_JPRB,4.1213E+02_JPRB/)
KBO( :, 5,42,16) = (/&
&2.6880E+02_JPRB,2.1197E+02_JPRB,2.4778E+02_JPRB,3.6481E+02_JPRB,4.8644E+02_JPRB/)
KBO( :, 1,43,16) = (/&
&1.3001E+02_JPRB,1.0178E+02_JPRB,1.1123E+02_JPRB,1.5100E+02_JPRB,2.0132E+02_JPRB/)
KBO( :, 2,43,16) = (/&
&1.6156E+02_JPRB,1.2573E+02_JPRB,1.3894E+02_JPRB,1.9371E+02_JPRB,2.5828E+02_JPRB/)
KBO( :, 3,43,16) = (/&
&1.9443E+02_JPRB,1.5128E+02_JPRB,1.6930E+02_JPRB,2.4134E+02_JPRB,3.2182E+02_JPRB/)
KBO( :, 4,43,16) = (/&
&2.2750E+02_JPRB,1.7792E+02_JPRB,2.0213E+02_JPRB,2.9308E+02_JPRB,3.9078E+02_JPRB/)
KBO( :, 5,43,16) = (/&
&2.6025E+02_JPRB,2.0480E+02_JPRB,2.3724E+02_JPRB,3.4798E+02_JPRB,4.6403E+02_JPRB/)
KBO( :, 1,44,16) = (/&
&1.2064E+02_JPRB,9.4696E+01_JPRB,1.0291E+02_JPRB,1.3822E+02_JPRB,1.8432E+02_JPRB/)
KBO( :, 2,44,16) = (/&
&1.5164E+02_JPRB,1.1817E+02_JPRB,1.2980E+02_JPRB,1.7913E+02_JPRB,2.3893E+02_JPRB/)
KBO( :, 3,44,16) = (/&
&1.8428E+02_JPRB,1.4322E+02_JPRB,1.5930E+02_JPRB,2.2526E+02_JPRB,3.0036E+02_JPRB/)
KBO( :, 4,44,16) = (/&
&2.1753E+02_JPRB,1.6972E+02_JPRB,1.9139E+02_JPRB,2.7583E+02_JPRB,3.6782E+02_JPRB/)
KBO( :, 5,44,16) = (/&
&2.5049E+02_JPRB,1.9666E+02_JPRB,2.2579E+02_JPRB,3.2975E+02_JPRB,4.3968E+02_JPRB/)
KBO( :, 1,45,16) = (/&
&1.1151E+02_JPRB,8.7613E+01_JPRB,9.4790E+01_JPRB,1.2608E+02_JPRB,1.6812E+02_JPRB/)
KBO( :, 2,45,16) = (/&
&1.4164E+02_JPRB,1.1057E+02_JPRB,1.2077E+02_JPRB,1.6507E+02_JPRB,2.2006E+02_JPRB/)
KBO( :, 3,45,16) = (/&
&1.7396E+02_JPRB,1.3520E+02_JPRB,1.4945E+02_JPRB,2.0958E+02_JPRB,2.7946E+02_JPRB/)
KBO( :, 4,45,16) = (/&
&2.0722E+02_JPRB,1.6134E+02_JPRB,1.8077E+02_JPRB,2.5885E+02_JPRB,3.4509E+02_JPRB/)
KBO( :, 5,45,16) = (/&
&2.4041E+02_JPRB,1.8823E+02_JPRB,2.1441E+02_JPRB,3.1179E+02_JPRB,4.1569E+02_JPRB/)
KBO( :, 1,46,16) = (/&
&1.0202E+02_JPRB,8.0263E+01_JPRB,8.6456E+01_JPRB,1.1385E+02_JPRB,1.5183E+02_JPRB/)
KBO( :, 2,46,16) = (/&
&1.3102E+02_JPRB,1.0251E+02_JPRB,1.1143E+02_JPRB,1.5058E+02_JPRB,2.0077E+02_JPRB/)
KBO( :, 3,46,16) = (/&
&1.6284E+02_JPRB,1.2664E+02_JPRB,1.3922E+02_JPRB,1.9326E+02_JPRB,2.5769E+02_JPRB/)
KBO( :, 4,46,16) = (/&
&1.9593E+02_JPRB,1.5228E+02_JPRB,1.6961E+02_JPRB,2.4101E+02_JPRB,3.2127E+02_JPRB/)
KBO( :, 5,46,16) = (/&
&2.2932E+02_JPRB,1.7911E+02_JPRB,2.0249E+02_JPRB,2.9283E+02_JPRB,3.9038E+02_JPRB/)
KBO( :, 1,47,16) = (/&
&9.1833E+01_JPRB,7.2521E+01_JPRB,7.7492E+01_JPRB,1.0107E+02_JPRB,1.3478E+02_JPRB/)
KBO( :, 2,47,16) = (/&
&1.1935E+02_JPRB,9.3639E+01_JPRB,1.0124E+02_JPRB,1.3522E+02_JPRB,1.8034E+02_JPRB/)
KBO( :, 3,47,16) = (/&
&1.5031E+02_JPRB,1.1714E+02_JPRB,1.2800E+02_JPRB,1.7568E+02_JPRB,2.3430E+02_JPRB/)
KBO( :, 4,47,16) = (/&
&1.8310E+02_JPRB,1.4216E+02_JPRB,1.5736E+02_JPRB,2.2148E+02_JPRB,2.9535E+02_JPRB/)
KBO( :, 5,47,16) = (/&
&2.1655E+02_JPRB,1.6875E+02_JPRB,1.8931E+02_JPRB,2.7187E+02_JPRB,3.6261E+02_JPRB/)
KBO( :, 1,48,16) = (/&
&8.2434E+01_JPRB,6.5271E+01_JPRB,6.9082E+01_JPRB,8.9310E+01_JPRB,1.1908E+02_JPRB/)
KBO( :, 2,48,16) = (/&
&1.0815E+02_JPRB,8.4940E+01_JPRB,9.1497E+01_JPRB,1.2085E+02_JPRB,1.6117E+02_JPRB/)
KBO( :, 3,48,16) = (/&
&1.3796E+02_JPRB,1.0775E+02_JPRB,1.1715E+02_JPRB,1.5893E+02_JPRB,2.1191E+02_JPRB/)
KBO( :, 4,48,16) = (/&
&1.7024E+02_JPRB,1.3227E+02_JPRB,1.4550E+02_JPRB,2.0275E+02_JPRB,2.7033E+02_JPRB/)
KBO( :, 5,48,16) = (/&
&2.0361E+02_JPRB,1.5829E+02_JPRB,1.7646E+02_JPRB,2.5142E+02_JPRB,3.3526E+02_JPRB/)
KBO( :, 1,49,16) = (/&
&7.3591E+01_JPRB,5.8555E+01_JPRB,6.1217E+01_JPRB,7.8585E+01_JPRB,1.0478E+02_JPRB/)
KBO( :, 2,49,16) = (/&
&9.7468E+01_JPRB,7.6787E+01_JPRB,8.2199E+01_JPRB,1.0753E+02_JPRB,1.4337E+02_JPRB/)
KBO( :, 3,49,16) = (/&
&1.2589E+02_JPRB,9.8595E+01_JPRB,1.0664E+02_JPRB,1.4299E+02_JPRB,1.9063E+02_JPRB/)
KBO( :, 4,49,16) = (/&
&1.5743E+02_JPRB,1.2250E+02_JPRB,1.3397E+02_JPRB,1.8464E+02_JPRB,2.4618E+02_JPRB/)
KBO( :, 5,49,16) = (/&
&1.9052E+02_JPRB,1.4794E+02_JPRB,1.6391E+02_JPRB,2.3149E+02_JPRB,3.0868E+02_JPRB/)
KBO( :, 1,50,16) = (/&
&6.5961E+01_JPRB,5.2638E+01_JPRB,5.4393E+01_JPRB,6.9399E+01_JPRB,9.2534E+01_JPRB/)
KBO( :, 2,50,16) = (/&
&8.8116E+01_JPRB,6.9616E+01_JPRB,7.3948E+01_JPRB,9.5883E+01_JPRB,1.2784E+02_JPRB/)
KBO( :, 3,50,16) = (/&
&1.1495E+02_JPRB,9.0222E+01_JPRB,9.7185E+01_JPRB,1.2898E+02_JPRB,1.7197E+02_JPRB/)
KBO( :, 4,50,16) = (/&
&1.4556E+02_JPRB,1.1350E+02_JPRB,1.2350E+02_JPRB,1.6846E+02_JPRB,2.2453E+02_JPRB/)
KBO( :, 5,50,16) = (/&
&1.7823E+02_JPRB,1.3839E+02_JPRB,1.5245E+02_JPRB,2.1343E+02_JPRB,2.8458E+02_JPRB/)
KBO( :, 1,51,16) = (/&
&5.9119E+01_JPRB,4.7354E+01_JPRB,4.8344E+01_JPRB,6.1204E+01_JPRB,8.1604E+01_JPRB/)
KBO( :, 2,51,16) = (/&
&7.9680E+01_JPRB,6.3168E+01_JPRB,6.6452E+01_JPRB,8.5530E+01_JPRB,1.1410E+02_JPRB/)
KBO( :, 3,51,16) = (/&
&1.0482E+02_JPRB,8.2356E+01_JPRB,8.8430E+01_JPRB,1.1623E+02_JPRB,1.5497E+02_JPRB/)
KBO( :, 4,51,16) = (/&
&1.3427E+02_JPRB,1.0494E+02_JPRB,1.1368E+02_JPRB,1.5339E+02_JPRB,2.0454E+02_JPRB/)
KBO( :, 5,51,16) = (/&
&1.6639E+02_JPRB,1.2932E+02_JPRB,1.4173E+02_JPRB,1.9652E+02_JPRB,2.6202E+02_JPRB/)
KBO( :, 1,52,16) = (/&
&5.2745E+01_JPRB,4.2467E+01_JPRB,4.2754E+01_JPRB,5.3680E+01_JPRB,7.1576E+01_JPRB/)
KBO( :, 2,52,16) = (/&
&7.1747E+01_JPRB,5.7129E+01_JPRB,5.9424E+01_JPRB,7.6073E+01_JPRB,1.0142E+02_JPRB/)
KBO( :, 3,52,16) = (/&
&9.5200E+01_JPRB,7.5047E+01_JPRB,8.0071E+01_JPRB,1.0434E+02_JPRB,1.3911E+02_JPRB/)
KBO( :, 4,52,16) = (/&
&1.2328E+02_JPRB,9.6608E+01_JPRB,1.0420E+02_JPRB,1.3918E+02_JPRB,1.8556E+02_JPRB/)
KBO( :, 5,52,16) = (/&
&1.5465E+02_JPRB,1.2039E+02_JPRB,1.3128E+02_JPRB,1.8026E+02_JPRB,2.4037E+02_JPRB/)
KBO( :, 1,53,16) = (/&
&4.6931E+01_JPRB,3.7942E+01_JPRB,3.7717E+01_JPRB,4.6873E+01_JPRB,6.2479E+01_JPRB/)
KBO( :, 2,53,16) = (/&
&6.4426E+01_JPRB,5.1434E+01_JPRB,5.2934E+01_JPRB,6.7323E+01_JPRB,8.9766E+01_JPRB/)
KBO( :, 3,53,16) = (/&
&8.6242E+01_JPRB,6.8154E+01_JPRB,7.2147E+01_JPRB,9.3266E+01_JPRB,1.2436E+02_JPRB/)
KBO( :, 4,53,16) = (/&
&1.1270E+02_JPRB,8.8425E+01_JPRB,9.5072E+01_JPRB,1.2575E+02_JPRB,1.6767E+02_JPRB/)
KBO( :, 5,53,16) = (/&
&1.4306E+02_JPRB,1.1161E+02_JPRB,1.2116E+02_JPRB,1.6465E+02_JPRB,2.1957E+02_JPRB/)
KBO( :, 1,54,16) = (/&
&4.2077E+01_JPRB,3.4169E+01_JPRB,3.3488E+01_JPRB,4.1262E+01_JPRB,5.4902E+01_JPRB/)
KBO( :, 2,54,16) = (/&
&5.8190E+01_JPRB,4.6634E+01_JPRB,4.7441E+01_JPRB,5.9915E+01_JPRB,7.9878E+01_JPRB/)
KBO( :, 3,54,16) = (/&
&7.8514E+01_JPRB,6.2282E+01_JPRB,6.5328E+01_JPRB,8.3924E+01_JPRB,1.1190E+02_JPRB/)
KBO( :, 4,54,16) = (/&
&1.0342E+02_JPRB,8.1276E+01_JPRB,8.7086E+01_JPRB,1.1420E+02_JPRB,1.5227E+02_JPRB/)
KBO( :, 5,54,16) = (/&
&1.3269E+02_JPRB,1.0372E+02_JPRB,1.1219E+02_JPRB,1.5097E+02_JPRB,2.0130E+02_JPRB/)
KBO( :, 1,55,16) = (/&
&3.7797E+01_JPRB,3.0836E+01_JPRB,2.9805E+01_JPRB,3.6383E+01_JPRB,4.8271E+01_JPRB/)
KBO( :, 2,55,16) = (/&
&5.2583E+01_JPRB,4.2337E+01_JPRB,4.2558E+01_JPRB,5.3364E+01_JPRB,7.1129E+01_JPRB/)
KBO( :, 3,55,16) = (/&
&7.1538E+01_JPRB,5.6971E+01_JPRB,5.9162E+01_JPRB,7.5653E+01_JPRB,1.0088E+02_JPRB/)
KBO( :, 4,55,16) = (/&
&9.4943E+01_JPRB,7.4845E+01_JPRB,7.9765E+01_JPRB,1.0380E+02_JPRB,1.3840E+02_JPRB/)
KBO( :, 5,55,16) = (/&
&1.2300E+02_JPRB,9.6367E+01_JPRB,1.0384E+02_JPRB,1.3854E+02_JPRB,1.8472E+02_JPRB/)
KBO( :, 1,56,16) = (/&
&3.3873E+01_JPRB,2.7740E+01_JPRB,2.6480E+01_JPRB,3.1942E+01_JPRB,4.2208E+01_JPRB/)
KBO( :, 2,56,16) = (/&
&4.7453E+01_JPRB,3.8343E+01_JPRB,3.8125E+01_JPRB,4.7379E+01_JPRB,6.3148E+01_JPRB/)
KBO( :, 3,56,16) = (/&
&6.5091E+01_JPRB,5.1940E+01_JPRB,5.3452E+01_JPRB,6.7966E+01_JPRB,9.0627E+01_JPRB/)
KBO( :, 4,56,16) = (/&
&8.7046E+01_JPRB,6.8764E+01_JPRB,7.2784E+01_JPRB,9.4072E+01_JPRB,1.2543E+02_JPRB/)
KBO( :, 5,56,16) = (/&
&1.1365E+02_JPRB,8.9173E+01_JPRB,9.5823E+01_JPRB,1.2676E+02_JPRB,1.6901E+02_JPRB/)
KBO( :, 1,57,16) = (/&
&3.0269E+01_JPRB,2.4887E+01_JPRB,2.3522E+01_JPRB,2.7966E+01_JPRB,3.6672E+01_JPRB/)
KBO( :, 2,57,16) = (/&
&4.2742E+01_JPRB,3.4680E+01_JPRB,3.4029E+01_JPRB,4.1940E+01_JPRB,5.5826E+01_JPRB/)
KBO( :, 3,57,16) = (/&
&5.9049E+01_JPRB,4.7291E+01_JPRB,4.8146E+01_JPRB,6.0813E+01_JPRB,8.1079E+01_JPRB/)
KBO( :, 4,57,16) = (/&
&7.9588E+01_JPRB,6.3092E+01_JPRB,6.6213E+01_JPRB,8.5068E+01_JPRB,1.1341E+02_JPRB/)
KBO( :, 5,57,16) = (/&
&1.0467E+02_JPRB,8.2241E+01_JPRB,8.8127E+01_JPRB,1.1561E+02_JPRB,1.5417E+02_JPRB/)
KBO( :, 1,58,16) = (/&
&2.7181E+01_JPRB,2.2407E+01_JPRB,2.1043E+01_JPRB,2.4570E+01_JPRB,3.1903E+01_JPRB/)
KBO( :, 2,58,16) = (/&
&3.8607E+01_JPRB,3.1473E+01_JPRB,3.0470E+01_JPRB,3.7255E+01_JPRB,4.9462E+01_JPRB/)
KBO( :, 3,58,16) = (/&
&5.3661E+01_JPRB,4.3166E+01_JPRB,4.3454E+01_JPRB,5.4507E+01_JPRB,7.2688E+01_JPRB/)
KBO( :, 4,58,16) = (/&
&7.2881E+01_JPRB,5.7996E+01_JPRB,6.0310E+01_JPRB,7.7125E+01_JPRB,1.0284E+02_JPRB/)
KBO( :, 5,58,16) = (/&
&9.6586E+01_JPRB,7.6089E+01_JPRB,8.1135E+01_JPRB,1.0566E+02_JPRB,1.4091E+02_JPRB/)
KBO( :, 1,59,16) = (/&
&2.6031E+01_JPRB,2.1482E+01_JPRB,2.0126E+01_JPRB,2.3303E+01_JPRB,3.0129E+01_JPRB/)
KBO( :, 2,59,16) = (/&
&3.7063E+01_JPRB,3.0259E+01_JPRB,2.9150E+01_JPRB,3.5486E+01_JPRB,4.7064E+01_JPRB/)
KBO( :, 3,59,16) = (/&
&5.1630E+01_JPRB,4.1596E+01_JPRB,4.1690E+01_JPRB,5.2144E+01_JPRB,6.9539E+01_JPRB/)
KBO( :, 4,59,16) = (/&
&7.0350E+01_JPRB,5.6032E+01_JPRB,5.8043E+01_JPRB,7.4115E+01_JPRB,9.8842E+01_JPRB/)
KBO( :, 5,59,16) = (/&
&9.3474E+01_JPRB,7.3716E+01_JPRB,7.8416E+01_JPRB,1.0186E+02_JPRB,1.3581E+02_JPRB/)


!     The array SELFREFO contains the coefficient of the water vapor
!     self-continuum (including the energy term).  The first index
!     refers to temperature in 7.2 degree increments.  For instance,
!     JT = 1 refers to a temperature of 245.6, JT = 2 refers to 252.8,
!     etc.  The second index runs over the g-channel (1 to 16).

SELFREFO( :, 1) = (/&
&5.10286E-01_JPRB, 4.30424E-01_JPRB, 3.63061E-01_JPRB, 3.06241E-01_JPRB, 2.58313E-01_JPRB,&
&2.17886E-01_JPRB, 1.83786E-01_JPRB, 1.55023E-01_JPRB, 1.30761E-01_JPRB, 1.10297E-01_JPRB/)
SELFREFO( :, 2) = (/&
&4.96777E-01_JPRB, 4.30758E-01_JPRB, 3.73512E-01_JPRB, 3.23874E-01_JPRB, 2.80833E-01_JPRB,&
&2.43512E-01_JPRB, 2.11150E-01_JPRB, 1.83089E-01_JPRB, 1.58758E-01_JPRB, 1.37659E-01_JPRB/)
SELFREFO( :, 3) = (/&
&4.65595E-01_JPRB, 4.04778E-01_JPRB, 3.51905E-01_JPRB, 3.05939E-01_JPRB, 2.65976E-01_JPRB,&
&2.31234E-01_JPRB, 2.01030E-01_JPRB, 1.74771E-01_JPRB, 1.51942E-01_JPRB, 1.32095E-01_JPRB/)
SELFREFO( :, 4) = (/&
&4.34629E-01_JPRB, 3.86709E-01_JPRB, 3.44073E-01_JPRB, 3.06137E-01_JPRB, 2.72384E-01_JPRB,&
&2.42353E-01_JPRB, 2.15633E-01_JPRB, 1.91858E-01_JPRB, 1.70705E-01_JPRB, 1.51884E-01_JPRB/)
SELFREFO( :, 5) = (/&
&4.17625E-01_JPRB, 3.75442E-01_JPRB, 3.37519E-01_JPRB, 3.03427E-01_JPRB, 2.72778E-01_JPRB,&
&2.45225E-01_JPRB, 2.20456E-01_JPRB, 1.98188E-01_JPRB, 1.78169E-01_JPRB, 1.60173E-01_JPRB/)
SELFREFO( :, 6) = (/&
&3.97412E-01_JPRB, 3.61249E-01_JPRB, 3.28376E-01_JPRB, 2.98494E-01_JPRB, 2.71332E-01_JPRB,&
&2.46641E-01_JPRB, 2.24198E-01_JPRB, 2.03796E-01_JPRB, 1.85251E-01_JPRB, 1.68394E-01_JPRB/)
SELFREFO( :, 7) = (/&
&3.89795E-01_JPRB, 3.56178E-01_JPRB, 3.25460E-01_JPRB, 2.97391E-01_JPRB, 2.71743E-01_JPRB,&
&2.48307E-01_JPRB, 2.26892E-01_JPRB, 2.07324E-01_JPRB, 1.89444E-01_JPRB, 1.73105E-01_JPRB/)
SELFREFO( :, 8) = (/&
&3.79095E-01_JPRB, 3.46828E-01_JPRB, 3.17308E-01_JPRB, 2.90301E-01_JPRB, 2.65592E-01_JPRB,&
&2.42986E-01_JPRB, 2.22305E-01_JPRB, 2.03384E-01_JPRB, 1.86073E-01_JPRB, 1.70235E-01_JPRB/)
SELFREFO( :, 9) = (/&
&3.87086E-01_JPRB, 3.53988E-01_JPRB, 3.23720E-01_JPRB, 2.96040E-01_JPRB, 2.70727E-01_JPRB,&
&2.47578E-01_JPRB, 2.26409E-01_JPRB, 2.07050E-01_JPRB, 1.89346E-01_JPRB, 1.73156E-01_JPRB/)
SELFREFO( :,10) = (/&
&4.07529E-01_JPRB, 3.71284E-01_JPRB, 3.38263E-01_JPRB, 3.08179E-01_JPRB, 2.80770E-01_JPRB,&
&2.55799E-01_JPRB, 2.33049E-01_JPRB, 2.12322E-01_JPRB, 1.93438E-01_JPRB, 1.76234E-01_JPRB/)
SELFREFO( :,11) = (/&
&4.09315E-01_JPRB, 3.74420E-01_JPRB, 3.42500E-01_JPRB, 3.13302E-01_JPRB, 2.86592E-01_JPRB,&
&2.62160E-01_JPRB, 2.39811E-01_JPRB, 2.19367E-01_JPRB, 2.00665E-01_JPRB, 1.83558E-01_JPRB/)
SELFREFO( :,12) = (/&
&3.73996E-01_JPRB, 3.51462E-01_JPRB, 3.30286E-01_JPRB, 3.10385E-01_JPRB, 2.91684E-01_JPRB,&
&2.74109E-01_JPRB, 2.57593E-01_JPRB, 2.42072E-01_JPRB, 2.27487E-01_JPRB, 2.13780E-01_JPRB/)
SELFREFO( :,13) = (/&
&4.87965E-01_JPRB, 4.44525E-01_JPRB, 4.04952E-01_JPRB, 3.68902E-01_JPRB, 3.36061E-01_JPRB,&
&3.06144E-01_JPRB, 2.78891E-01_JPRB, 2.54063E-01_JPRB, 2.31446E-01_JPRB, 2.10842E-01_JPRB/)
SELFREFO( :,14) = (/&
&5.67999E-01_JPRB, 5.03336E-01_JPRB, 4.46034E-01_JPRB, 3.95256E-01_JPRB, 3.50259E-01_JPRB,&
&3.10384E-01_JPRB, 2.75048E-01_JPRB, 2.43736E-01_JPRB, 2.15988E-01_JPRB, 1.91399E-01_JPRB/)
SELFREFO( :,15) = (/&
&5.92492E-01_JPRB, 5.27072E-01_JPRB, 4.68874E-01_JPRB, 4.17103E-01_JPRB, 3.71048E-01_JPRB,&
&3.30079E-01_JPRB, 2.93633E-01_JPRB, 2.61211E-01_JPRB, 2.32369E-01_JPRB, 2.06712E-01_JPRB/)
SELFREFO( :,16) = (/&
&5.04176E-01_JPRB, 4.64845E-01_JPRB, 4.28582E-01_JPRB, 3.95148E-01_JPRB, 3.64322E-01_JPRB,&
&3.35901E-01_JPRB, 3.09697E-01_JPRB, 2.85538E-01_JPRB, 2.63263E-01_JPRB, 2.42725E-01_JPRB/)

FRACREFAO( :, 1) = (/&
!     From P = 1053.6 mb.
    &0.15116400_JPRB,0.14875700_JPRB,0.14232300_JPRB,0.13234501_JPRB,&
    &0.11881600_JPRB,0.10224100_JPRB,0.08345580_JPRB,0.06267490_JPRB,&
    &0.04250650_JPRB,0.00462650_JPRB,0.00382259_JPRB,0.00302600_JPRB,&
    &0.00222004_JPRB,0.00141397_JPRB,0.00053379_JPRB,0.00007421_JPRB/)
FRACREFAO( :, 2) = (/&
    &0.15266000_JPRB,0.14888400_JPRB,0.14195900_JPRB,0.13179500_JPRB,&
    &0.11842700_JPRB,0.10209000_JPRB,0.08336130_JPRB,0.06264370_JPRB,&
    &0.04247660_JPRB,0.00461946_JPRB,0.00381536_JPRB,0.00302601_JPRB,&
    &0.00222004_JPRB,0.00141397_JPRB,0.00053302_JPRB,0.00007498_JPRB/)
FRACREFAO( :, 3) = (/&
    &0.15282799_JPRB,0.14903000_JPRB,0.14192399_JPRB,0.13174300_JPRB,&
    &0.11835300_JPRB,0.10202700_JPRB,0.08329830_JPRB,0.06264830_JPRB,&
    &0.04246910_JPRB,0.00460242_JPRB,0.00381904_JPRB,0.00301573_JPRB,&
    &0.00222004_JPRB,0.00141397_JPRB,0.00053379_JPRB,0.00007421_JPRB/)
FRACREFAO( :, 4) = (/&
    &0.15298399_JPRB,0.14902800_JPRB,0.14193401_JPRB,0.13173500_JPRB,&
    &0.11833300_JPRB,0.10195800_JPRB,0.08324730_JPRB,0.06264770_JPRB,&
    &0.04246490_JPRB,0.00460489_JPRB,0.00381123_JPRB,0.00301893_JPRB,&
    &0.00221093_JPRB,0.00141397_JPRB,0.00053379_JPRB,0.00007421_JPRB/)
FRACREFAO( :, 5) = (/&
    &0.15307599_JPRB,0.14907201_JPRB,0.14198899_JPRB,0.13169800_JPRB,&
    &0.11827300_JPRB,0.10192300_JPRB,0.08321600_JPRB,0.06263490_JPRB,&
    &0.04245600_JPRB,0.00460846_JPRB,0.00380836_JPRB,0.00301663_JPRB,&
    &0.00221402_JPRB,0.00141167_JPRB,0.00052807_JPRB,0.00007376_JPRB/)
FRACREFAO( :, 6) = (/&
    &0.15311401_JPRB,0.14915401_JPRB,0.14207301_JPRB,0.13167299_JPRB,&
    &0.11819300_JPRB,0.10188900_JPRB,0.08318760_JPRB,0.06261960_JPRB,&
    &0.04243890_JPRB,0.00461584_JPRB,0.00380929_JPRB,0.00300815_JPRB,&
    &0.00221736_JPRB,0.00140588_JPRB,0.00052776_JPRB,0.00007376_JPRB/)
FRACREFAO( :, 7) = (/&
    &0.15316001_JPRB,0.14925499_JPRB,0.14213000_JPRB,0.13170999_JPRB,&
    &0.11807700_JPRB,0.10181400_JPRB,0.08317400_JPRB,0.06260300_JPRB,&
    &0.04242720_JPRB,0.00461520_JPRB,0.00381381_JPRB,0.00301285_JPRB,&
    &0.00220275_JPRB,0.00140371_JPRB,0.00052776_JPRB,0.00007376_JPRB/)
FRACREFAO( :, 8) = (/&
    &0.15321200_JPRB,0.14940999_JPRB,0.14222500_JPRB,0.13164200_JPRB,&
    &0.11798200_JPRB,0.10174500_JPRB,0.08317500_JPRB,0.06253640_JPRB,&
    &0.04243130_JPRB,0.00461724_JPRB,0.00381534_JPRB,0.00300320_JPRB,&
    &0.00220091_JPRB,0.00140364_JPRB,0.00052852_JPRB,0.00007300_JPRB/)
FRACREFAO( :, 9) = (/&
    &0.15312800_JPRB,0.14973100_JPRB,0.14234400_JPRB,0.13168900_JPRB,&
    &0.11795200_JPRB,0.10156100_JPRB,0.08302990_JPRB,0.06252240_JPRB,&
    &0.04240980_JPRB,0.00461035_JPRB,0.00381381_JPRB,0.00300176_JPRB,&
    &0.00220160_JPRB,0.00140284_JPRB,0.00052774_JPRB,0.00007376_JPRB/)
FRACREFAO( :,10) = (/&
    &0.15292500_JPRB,0.14978001_JPRB,0.14242400_JPRB,0.13172600_JPRB,&
    &0.11798800_JPRB,0.10156400_JPRB,0.08303050_JPRB,0.06251670_JPRB,&
    &0.04240970_JPRB,0.00461302_JPRB,0.00381452_JPRB,0.00300250_JPRB,&
    &0.00220126_JPRB,0.00140324_JPRB,0.00052850_JPRB,0.00007300_JPRB/)

FRACREFBO( :, 1) = (/&
!     From P = 64.1 mb.
    &0.16340201_JPRB,0.15607700_JPRB,0.14601400_JPRB,0.13182700_JPRB,&
    &0.11524700_JPRB,0.09666570_JPRB,0.07825360_JPRB,0.05849780_JPRB,&
    &0.03949650_JPRB,0.00427980_JPRB,0.00353719_JPRB,0.00279303_JPRB,&
    &0.00204788_JPRB,0.00130139_JPRB,0.00049055_JPRB,0.00006904_JPRB/)
FRACREFBO( :, 2) = (/&
    &0.15762900_JPRB,0.15494700_JPRB,0.14659800_JPRB,0.13267800_JPRB,&
    &0.11562700_JPRB,0.09838360_JPRB,0.07930420_JPRB,0.05962700_JPRB,&
    &0.04036360_JPRB,0.00438053_JPRB,0.00361463_JPRB,0.00285723_JPRB,&
    &0.00208345_JPRB,0.00132135_JPRB,0.00050528_JPRB,0.00008003_JPRB/)
FRACREFBO( :, 3) = (/&
    &0.15641500_JPRB,0.15394500_JPRB,0.14633600_JPRB,0.13180400_JPRB,&
    &0.11617100_JPRB,0.09924170_JPRB,0.08000510_JPRB,0.06021420_JPRB,&
    &0.04082730_JPRB,0.00441694_JPRB,0.00365364_JPRB,0.00287723_JPRB,&
    &0.00210914_JPRB,0.00135784_JPRB,0.00054651_JPRB,0.00008003_JPRB/)
FRACREFBO( :, 4) = (/&
    &0.15482700_JPRB,0.15286300_JPRB,0.14392500_JPRB,0.13244100_JPRB,&
    &0.11712000_JPRB,0.09994920_JPRB,0.08119200_JPRB,0.06104360_JPRB,&
    &0.04135600_JPRB,0.00446685_JPRB,0.00368377_JPRB,0.00290767_JPRB,&
    &0.00215445_JPRB,0.00142865_JPRB,0.00056142_JPRB,0.00008003_JPRB/)
FRACREFBO( :, 5) = (/&
    &0.15975100_JPRB,0.15653500_JPRB,0.14214399_JPRB,0.12892200_JPRB,&
    &0.11508400_JPRB,0.09906020_JPRB,0.08087940_JPRB,0.06078190_JPRB,&
    &0.04140530_JPRB,0.00452724_JPRB,0.00374558_JPRB,0.00295328_JPRB,&
    &0.00218509_JPRB,0.00138644_JPRB,0.00056018_JPRB,0.00008003_JPRB/)

!     -----------------------------------------------------------------
RETURN
END SUBROUTINE RRTM_KGB3_C
