!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! ECMWF_RAD1_MODIF_IDRIS 2003/02/19 13:36:33
!-----------------------------------------------------------------
!OCL SCALAR
SUBROUTINE RRTM_KGB4_C

!     Originally by Eli J. Mlawer, Atmospheric & Environmental Research.
!     BAND 4:  630-700 cm-1 (low - H2O,CO2; high - O3,CO2)
!     Reformatted for F90 by JJMorcrette, ECMWF

!     ------------------------------------------------------------------

!*    kindef: define default KIND macros
! --------------------------------------


USE PARKIND1, ONLY :&
 &JPIT, JPIS, JPIM, JPIB,&
 &JPRT, JPRS, JPRM, JPRB

















































! --------------------------------------


USE OYOERRTO4 , ONLY : KAO     ,KBO     ,SELFREFO   ,FRACREFAO  ,FRACREFBO
USE OYOERRTA4 , ONLY : STRRAT1   ,STRRAT2

!     ------------------------------------------------------------------


IMPLICIT NONE

!     The array KBO contains absorption coefs for each of the 16 g-intervals
!     for a range of pressure levels  < ~100mb, temperatures, and ratios
!     of O3 to CO2.  The first index in the array, JS, runs from 1 to 6, 
!     and corresponds to different O3 to CO2 ratios, as expressed through 
!     the binary species parameter eta, defined as eta = O3/(O3+RAT*H2O), 
!     where RAT is the ratio of the integrated line strength in the band 
!     of CO2 to that of O3.  For instance, JS=1 refers to no O3 (eta = 0) 
!     and JS = 5 corresponds to eta = 1.0.  The second index, JT, which
!     runs from 1 to 5, corresponds to different temperatures.  More 
!     specifically, JT = 3 means that the data are for the corresponding 
!     reference temperature TREF for this  pressure level, JT = 2 refers 
!     to the TREF-15, JT = 1 is for TREF-30, JT = 4 is for TREF+15, and
!     JT = 5 is for TREF+30.  The third index, JP, runs from 13 to 59 and
!     refers to the corresponding pressure level in PREF (e.g. JP = 13 is
!     for a pressure of 95.5835 mb).  The fourth index, IG, goes from 1 to
!     16, and tells us which g-interval the absorption coefficients are for.

KBO( :, 1,49, 9) = (/&
&1.7262E-02_JPRB,2.0889E-02_JPRB,3.4154E-01_JPRB,5.1353E-01_JPRB,6.3147E-01_JPRB,6.4035E-01_JPRB/)
KBO( :, 2,49, 9) = (/&
&2.1137E-02_JPRB,2.4489E-02_JPRB,4.0924E-01_JPRB,6.2397E-01_JPRB,7.7164E-01_JPRB,8.0268E-01_JPRB/)
KBO( :, 3,49, 9) = (/&
&2.5945E-02_JPRB,2.8963E-02_JPRB,4.7895E-01_JPRB,7.3764E-01_JPRB,9.1622E-01_JPRB,9.7159E-01_JPRB/)
KBO( :, 4,49, 9) = (/&
&3.1605E-02_JPRB,3.4269E-02_JPRB,5.4885E-01_JPRB,8.5174E-01_JPRB,1.0610E+00_JPRB,1.1442E+00_JPRB/)
KBO( :, 5,49, 9) = (/&
&3.8248E-02_JPRB,4.0534E-02_JPRB,6.1776E-01_JPRB,9.6350E-01_JPRB,1.2028E+00_JPRB,1.3168E+00_JPRB/)
KBO( :, 1,50, 9) = (/&
&1.4461E-02_JPRB,1.8256E-02_JPRB,3.1238E-01_JPRB,4.6845E-01_JPRB,5.7488E-01_JPRB,5.7744E-01_JPRB/)
KBO( :, 2,50, 9) = (/&
&1.7870E-02_JPRB,2.1439E-02_JPRB,3.7949E-01_JPRB,5.7732E-01_JPRB,7.1302E-01_JPRB,7.3703E-01_JPRB/)
KBO( :, 3,50, 9) = (/&
&2.2222E-02_JPRB,2.5490E-02_JPRB,4.4914E-01_JPRB,6.9079E-01_JPRB,8.5702E-01_JPRB,9.0516E-01_JPRB/)
KBO( :, 4,50, 9) = (/&
&2.7435E-02_JPRB,3.0361E-02_JPRB,5.1966E-01_JPRB,8.0553E-01_JPRB,1.0027E+00_JPRB,1.0781E+00_JPRB/)
KBO( :, 5,50, 9) = (/&
&3.3599E-02_JPRB,3.6150E-02_JPRB,5.8955E-01_JPRB,9.1897E-01_JPRB,1.1465E+00_JPRB,1.2529E+00_JPRB/)
KBO( :, 1,51, 9) = (/&
&1.2097E-02_JPRB,1.6003E-02_JPRB,2.8492E-01_JPRB,4.2603E-01_JPRB,5.2182E-01_JPRB,5.1816E-01_JPRB/)
KBO( :, 2,51, 9) = (/&
&1.5083E-02_JPRB,1.8829E-02_JPRB,3.5127E-01_JPRB,5.3304E-01_JPRB,6.5735E-01_JPRB,6.7429E-01_JPRB/)
KBO( :, 3,51, 9) = (/&
&1.8997E-02_JPRB,2.2488E-02_JPRB,4.2058E-01_JPRB,6.4583E-01_JPRB,8.0019E-01_JPRB,8.4077E-01_JPRB/)
KBO( :, 4,51, 9) = (/&
&2.3775E-02_JPRB,2.6948E-02_JPRB,4.9143E-01_JPRB,7.6084E-01_JPRB,9.4628E-01_JPRB,1.0134E+00_JPRB/)
KBO( :, 5,51, 9) = (/&
&2.9499E-02_JPRB,3.2304E-02_JPRB,5.6205E-01_JPRB,8.7547E-01_JPRB,1.0915E+00_JPRB,1.1895E+00_JPRB/)
KBO( :, 1,52, 9) = (/&
&1.0095E-02_JPRB,1.4050E-02_JPRB,2.5854E-01_JPRB,3.8529E-01_JPRB,4.7109E-01_JPRB,4.6197E-01_JPRB/)
KBO( :, 2,52, 9) = (/&
&1.2680E-02_JPRB,1.6562E-02_JPRB,3.2378E-01_JPRB,4.9000E-01_JPRB,6.0315E-01_JPRB,6.1385E-01_JPRB/)
KBO( :, 3,52, 9) = (/&
&1.6167E-02_JPRB,1.9851E-02_JPRB,3.9257E-01_JPRB,6.0150E-01_JPRB,7.4434E-01_JPRB,7.7805E-01_JPRB/)
KBO( :, 4,52, 9) = (/&
&2.0524E-02_JPRB,2.3923E-02_JPRB,4.6343E-01_JPRB,7.1644E-01_JPRB,8.9011E-01_JPRB,9.4994E-01_JPRB/)
KBO( :, 5,52, 9) = (/&
&2.5821E-02_JPRB,2.8872E-02_JPRB,5.3465E-01_JPRB,8.3183E-01_JPRB,1.0363E+00_JPRB,1.1268E+00_JPRB/)
KBO( :, 1,53, 9) = (/&
&8.3963E-03_JPRB,1.2343E-02_JPRB,2.3325E-01_JPRB,3.4626E-01_JPRB,4.2244E-01_JPRB,4.0883E-01_JPRB/)
KBO( :, 2,53, 9) = (/&
&1.0621E-02_JPRB,1.4581E-02_JPRB,2.9700E-01_JPRB,4.4811E-01_JPRB,5.5051E-01_JPRB,5.5572E-01_JPRB/)
KBO( :, 3,53, 9) = (/&
&1.3693E-02_JPRB,1.7537E-02_JPRB,3.6501E-01_JPRB,5.5778E-01_JPRB,6.8933E-01_JPRB,7.1705E-01_JPRB/)
KBO( :, 4,53, 9) = (/&
&1.7633E-02_JPRB,2.1242E-02_JPRB,4.3562E-01_JPRB,6.7222E-01_JPRB,8.3412E-01_JPRB,8.8780E-01_JPRB/)
KBO( :, 5,53, 9) = (/&
&2.2506E-02_JPRB,2.5791E-02_JPRB,5.0721E-01_JPRB,7.8803E-01_JPRB,9.8102E-01_JPRB,1.0650E+00_JPRB/)
KBO( :, 1,54, 9) = (/&
&7.0177E-03_JPRB,1.0894E-02_JPRB,2.1095E-01_JPRB,3.1199E-01_JPRB,3.7969E-01_JPRB,3.6085E-01_JPRB/)
KBO( :, 2,54, 9) = (/&
&8.9302E-03_JPRB,1.2918E-02_JPRB,2.7298E-01_JPRB,4.1066E-01_JPRB,5.0363E-01_JPRB,5.0181E-01_JPRB/)
KBO( :, 3,54, 9) = (/&
&1.1634E-02_JPRB,1.5589E-02_JPRB,3.4013E-01_JPRB,5.1838E-01_JPRB,6.3970E-01_JPRB,6.5930E-01_JPRB/)
KBO( :, 4,54, 9) = (/&
&1.5199E-02_JPRB,1.8979E-02_JPRB,4.1032E-01_JPRB,6.3200E-01_JPRB,7.8327E-01_JPRB,8.2770E-01_JPRB/)
KBO( :, 5,54, 9) = (/&
&1.9687E-02_JPRB,2.3177E-02_JPRB,4.8201E-01_JPRB,7.4784E-01_JPRB,9.3015E-01_JPRB,1.0034E+00_JPRB/)
KBO( :, 1,55, 9) = (/&
&5.8731E-03_JPRB,9.6286E-03_JPRB,1.9052E-01_JPRB,2.8063E-01_JPRB,3.4069E-01_JPRB,3.1655E-01_JPRB/)
KBO( :, 2,55, 9) = (/&
&7.5168E-03_JPRB,1.1480E-02_JPRB,2.5064E-01_JPRB,3.7586E-01_JPRB,4.6019E-01_JPRB,4.5069E-01_JPRB/)
KBO( :, 3,55, 9) = (/&
&9.8853E-03_JPRB,1.3900E-02_JPRB,3.1669E-01_JPRB,4.8140E-01_JPRB,5.9307E-01_JPRB,6.0350E-01_JPRB/)
KBO( :, 4,55, 9) = (/&
&1.3096E-02_JPRB,1.7018E-02_JPRB,3.8628E-01_JPRB,5.9371E-01_JPRB,7.3500E-01_JPRB,7.6887E-01_JPRB/)
KBO( :, 5,55, 9) = (/&
&1.7222E-02_JPRB,2.0899E-02_JPRB,4.5791E-01_JPRB,7.0935E-01_JPRB,8.8144E-01_JPRB,9.4215E-01_JPRB/)
KBO( :, 1,56, 9) = (/&
&4.9060E-03_JPRB,8.5039E-03_JPRB,1.7111E-01_JPRB,2.5106E-01_JPRB,3.0385E-01_JPRB,2.7511E-01_JPRB/)
KBO( :, 2,56, 9) = (/&
&6.3120E-03_JPRB,1.0201E-02_JPRB,2.2915E-01_JPRB,3.4243E-01_JPRB,4.1847E-01_JPRB,4.0215E-01_JPRB/)
KBO( :, 3,56, 9) = (/&
&8.3672E-03_JPRB,1.2401E-02_JPRB,2.9378E-01_JPRB,4.4537E-01_JPRB,5.4774E-01_JPRB,5.4959E-01_JPRB/)
KBO( :, 4,56, 9) = (/&
&1.1240E-02_JPRB,1.5268E-02_JPRB,3.6263E-01_JPRB,5.5595E-01_JPRB,6.8746E-01_JPRB,7.1138E-01_JPRB/)
KBO( :, 5,56, 9) = (/&
&1.5010E-02_JPRB,1.8851E-02_JPRB,4.3398E-01_JPRB,6.7113E-01_JPRB,8.3300E-01_JPRB,8.8217E-01_JPRB/)
KBO( :, 1,57, 9) = (/&
&4.0878E-03_JPRB,7.4982E-03_JPRB,1.5269E-01_JPRB,2.2324E-01_JPRB,2.6911E-01_JPRB,2.3696E-01_JPRB/)
KBO( :, 2,57, 9) = (/&
&5.2898E-03_JPRB,9.0610E-03_JPRB,2.0850E-01_JPRB,3.1039E-01_JPRB,3.7842E-01_JPRB,3.5615E-01_JPRB/)
KBO( :, 3,57, 9) = (/&
&7.0606E-03_JPRB,1.1069E-02_JPRB,2.7146E-01_JPRB,4.1021E-01_JPRB,5.0366E-01_JPRB,4.9745E-01_JPRB/)
KBO( :, 4,57, 9) = (/&
&9.6071E-03_JPRB,1.3700E-02_JPRB,3.3939E-01_JPRB,5.1887E-01_JPRB,6.4072E-01_JPRB,6.5511E-01_JPRB/)
KBO( :, 5,57, 9) = (/&
&1.3031E-02_JPRB,1.7013E-02_JPRB,4.1025E-01_JPRB,6.3316E-01_JPRB,7.8498E-01_JPRB,8.2331E-01_JPRB/)
KBO( :, 1,58, 9) = (/&
&3.4110E-03_JPRB,6.6187E-03_JPRB,1.3608E-01_JPRB,1.9844E-01_JPRB,2.3812E-01_JPRB,2.0347E-01_JPRB/)
KBO( :, 2,58, 9) = (/&
&4.4437E-03_JPRB,8.0723E-03_JPRB,1.8969E-01_JPRB,2.8123E-01_JPRB,3.4208E-01_JPRB,3.1439E-01_JPRB/)
KBO( :, 3,58, 9) = (/&
&5.9725E-03_JPRB,9.9123E-03_JPRB,2.5079E-01_JPRB,3.7777E-01_JPRB,4.6311E-01_JPRB,4.4931E-01_JPRB/)
KBO( :, 4,58, 9) = (/&
&8.2191E-03_JPRB,1.2333E-02_JPRB,3.1765E-01_JPRB,4.8433E-01_JPRB,5.9715E-01_JPRB,6.0236E-01_JPRB/)
KBO( :, 5,58, 9) = (/&
&1.1325E-02_JPRB,1.5419E-02_JPRB,3.8789E-01_JPRB,5.9740E-01_JPRB,7.3982E-01_JPRB,7.6757E-01_JPRB/)
KBO( :, 1,59, 9) = (/&
&2.9777E-03_JPRB,6.0559E-03_JPRB,1.2911E-01_JPRB,1.8831E-01_JPRB,2.2557E-01_JPRB,1.8804E-01_JPRB/)
KBO( :, 2,59, 9) = (/&
&3.9243E-03_JPRB,7.4586E-03_JPRB,1.8188E-01_JPRB,2.6942E-01_JPRB,3.2742E-01_JPRB,2.9431E-01_JPRB/)
KBO( :, 3,59, 9) = (/&
&5.3410E-03_JPRB,9.2341E-03_JPRB,2.4229E-01_JPRB,3.6461E-01_JPRB,4.4670E-01_JPRB,4.2516E-01_JPRB/)
KBO( :, 4,59, 9) = (/&
&7.4484E-03_JPRB,1.1574E-02_JPRB,3.0869E-01_JPRB,4.7031E-01_JPRB,5.7948E-01_JPRB,5.7493E-01_JPRB/)
KBO( :, 5,59, 9) = (/&
&1.0416E-02_JPRB,1.4573E-02_JPRB,3.7872E-01_JPRB,5.8281E-01_JPRB,7.2146E-01_JPRB,7.3756E-01_JPRB/)
KBO( :, 1,13,10) = (/&
&7.5289E+00_JPRB,7.5248E+00_JPRB,5.8020E+00_JPRB,4.2235E+00_JPRB,3.4788E+00_JPRB,3.3830E+00_JPRB/)
KBO( :, 2,13,10) = (/&
&7.5373E+00_JPRB,7.5331E+00_JPRB,5.7965E+00_JPRB,4.1949E+00_JPRB,3.4100E+00_JPRB,3.3091E+00_JPRB/)
KBO( :, 3,13,10) = (/&
&7.5342E+00_JPRB,7.5300E+00_JPRB,5.7907E+00_JPRB,4.1656E+00_JPRB,3.3402E+00_JPRB,3.2690E+00_JPRB/)
KBO( :, 4,13,10) = (/&
&7.4927E+00_JPRB,7.4886E+00_JPRB,5.7565E+00_JPRB,4.1206E+00_JPRB,3.2641E+00_JPRB,3.2567E+00_JPRB/)
KBO( :, 5,13,10) = (/&
&7.4212E+00_JPRB,7.4171E+00_JPRB,5.6978E+00_JPRB,4.0611E+00_JPRB,3.1856E+00_JPRB,3.2490E+00_JPRB/)
KBO( :, 1,14,10) = (/&
&7.4571E+00_JPRB,7.4529E+00_JPRB,5.7300E+00_JPRB,4.2516E+00_JPRB,3.6973E+00_JPRB,3.6249E+00_JPRB/)
KBO( :, 2,14,10) = (/&
&7.4407E+00_JPRB,7.4365E+00_JPRB,5.7211E+00_JPRB,4.2113E+00_JPRB,3.6244E+00_JPRB,3.5667E+00_JPRB/)
KBO( :, 3,14,10) = (/&
&7.3963E+00_JPRB,7.3922E+00_JPRB,5.6812E+00_JPRB,4.1556E+00_JPRB,3.5526E+00_JPRB,3.5115E+00_JPRB/)
KBO( :, 4,14,10) = (/&
&7.3296E+00_JPRB,7.3255E+00_JPRB,5.6249E+00_JPRB,4.0935E+00_JPRB,3.4766E+00_JPRB,3.4707E+00_JPRB/)
KBO( :, 5,14,10) = (/&
&7.2465E+00_JPRB,7.2425E+00_JPRB,5.5619E+00_JPRB,4.0245E+00_JPRB,3.4020E+00_JPRB,3.4493E+00_JPRB/)
KBO( :, 1,15,10) = (/&
&7.1911E+00_JPRB,7.1871E+00_JPRB,5.5280E+00_JPRB,4.2968E+00_JPRB,3.9627E+00_JPRB,3.9090E+00_JPRB/)
KBO( :, 2,15,10) = (/&
&7.1513E+00_JPRB,7.1474E+00_JPRB,5.4956E+00_JPRB,4.2289E+00_JPRB,3.8871E+00_JPRB,3.8400E+00_JPRB/)
KBO( :, 3,15,10) = (/&
&7.0923E+00_JPRB,7.0884E+00_JPRB,5.4464E+00_JPRB,4.1468E+00_JPRB,3.8062E+00_JPRB,3.7828E+00_JPRB/)
KBO( :, 4,15,10) = (/&
&6.9934E+00_JPRB,6.9895E+00_JPRB,5.3713E+00_JPRB,4.0638E+00_JPRB,3.7328E+00_JPRB,3.7290E+00_JPRB/)
KBO( :, 5,15,10) = (/&
&6.8864E+00_JPRB,6.8825E+00_JPRB,5.2899E+00_JPRB,3.9761E+00_JPRB,3.6483E+00_JPRB,3.6704E+00_JPRB/)
KBO( :, 1,16,10) = (/&
&6.7911E+00_JPRB,6.7873E+00_JPRB,5.2205E+00_JPRB,4.3199E+00_JPRB,4.2502E+00_JPRB,4.2466E+00_JPRB/)
KBO( :, 2,16,10) = (/&
&6.7263E+00_JPRB,6.7226E+00_JPRB,5.1711E+00_JPRB,4.2329E+00_JPRB,4.1599E+00_JPRB,4.1741E+00_JPRB/)
KBO( :, 3,16,10) = (/&
&6.6333E+00_JPRB,6.6296E+00_JPRB,5.0988E+00_JPRB,4.1448E+00_JPRB,4.0703E+00_JPRB,4.1094E+00_JPRB/)
KBO( :, 4,16,10) = (/&
&6.5280E+00_JPRB,6.5244E+00_JPRB,5.0198E+00_JPRB,4.0496E+00_JPRB,3.9801E+00_JPRB,4.0403E+00_JPRB/)
KBO( :, 5,16,10) = (/&
&6.4167E+00_JPRB,6.4131E+00_JPRB,4.9361E+00_JPRB,3.9499E+00_JPRB,3.8927E+00_JPRB,3.9614E+00_JPRB/)
KBO( :, 1,17,10) = (/&
&6.2531E+00_JPRB,6.2497E+00_JPRB,4.8286E+00_JPRB,4.3686E+00_JPRB,4.5172E+00_JPRB,4.6364E+00_JPRB/)
KBO( :, 2,17,10) = (/&
&6.1677E+00_JPRB,6.1643E+00_JPRB,4.7626E+00_JPRB,4.2792E+00_JPRB,4.4298E+00_JPRB,4.5601E+00_JPRB/)
KBO( :, 3,17,10) = (/&
&6.0747E+00_JPRB,6.0713E+00_JPRB,4.6908E+00_JPRB,4.1860E+00_JPRB,4.3428E+00_JPRB,4.4812E+00_JPRB/)
KBO( :, 4,17,10) = (/&
&5.9604E+00_JPRB,5.9571E+00_JPRB,4.6053E+00_JPRB,4.0899E+00_JPRB,4.2570E+00_JPRB,4.3935E+00_JPRB/)
KBO( :, 5,17,10) = (/&
&5.8291E+00_JPRB,5.8259E+00_JPRB,4.5089E+00_JPRB,3.9935E+00_JPRB,4.1733E+00_JPRB,4.3011E+00_JPRB/)
KBO( :, 1,18,10) = (/&
&5.6266E+00_JPRB,5.6236E+00_JPRB,4.4207E+00_JPRB,4.4989E+00_JPRB,4.8053E+00_JPRB,5.0247E+00_JPRB/)
KBO( :, 2,18,10) = (/&
&5.5427E+00_JPRB,5.5397E+00_JPRB,4.3512E+00_JPRB,4.4021E+00_JPRB,4.7226E+00_JPRB,4.9470E+00_JPRB/)
KBO( :, 3,18,10) = (/&
&5.4374E+00_JPRB,5.4345E+00_JPRB,4.2669E+00_JPRB,4.3054E+00_JPRB,4.6429E+00_JPRB,4.8548E+00_JPRB/)
KBO( :, 4,18,10) = (/&
&5.3118E+00_JPRB,5.3090E+00_JPRB,4.1727E+00_JPRB,4.2046E+00_JPRB,4.5567E+00_JPRB,4.7652E+00_JPRB/)
KBO( :, 5,18,10) = (/&
&5.1788E+00_JPRB,5.1760E+00_JPRB,4.0826E+00_JPRB,4.1045E+00_JPRB,4.4583E+00_JPRB,4.6766E+00_JPRB/)
KBO( :, 1,19,10) = (/&
&4.9892E+00_JPRB,4.9865E+00_JPRB,4.1022E+00_JPRB,4.6290E+00_JPRB,5.1554E+00_JPRB,5.3946E+00_JPRB/)
KBO( :, 2,19,10) = (/&
&4.8951E+00_JPRB,4.8924E+00_JPRB,4.0165E+00_JPRB,4.5273E+00_JPRB,5.0702E+00_JPRB,5.3073E+00_JPRB/)
KBO( :, 3,19,10) = (/&
&4.7798E+00_JPRB,4.7773E+00_JPRB,3.9238E+00_JPRB,4.4269E+00_JPRB,4.9753E+00_JPRB,5.2208E+00_JPRB/)
KBO( :, 4,19,10) = (/&
&4.6598E+00_JPRB,4.6573E+00_JPRB,3.8352E+00_JPRB,4.3303E+00_JPRB,4.8704E+00_JPRB,5.1400E+00_JPRB/)
KBO( :, 5,19,10) = (/&
&4.5508E+00_JPRB,4.5484E+00_JPRB,3.7462E+00_JPRB,4.2290E+00_JPRB,4.7590E+00_JPRB,5.0603E+00_JPRB/)
KBO( :, 1,20,10) = (/&
&4.3446E+00_JPRB,4.3423E+00_JPRB,3.8795E+00_JPRB,4.7522E+00_JPRB,5.5065E+00_JPRB,5.7535E+00_JPRB/)
KBO( :, 2,20,10) = (/&
&4.2431E+00_JPRB,4.2409E+00_JPRB,3.7927E+00_JPRB,4.6561E+00_JPRB,5.4004E+00_JPRB,5.6800E+00_JPRB/)
KBO( :, 3,20,10) = (/&
&4.1397E+00_JPRB,4.1376E+00_JPRB,3.7047E+00_JPRB,4.5585E+00_JPRB,5.2878E+00_JPRB,5.6033E+00_JPRB/)
KBO( :, 4,20,10) = (/&
&4.0481E+00_JPRB,4.0460E+00_JPRB,3.6150E+00_JPRB,4.4575E+00_JPRB,5.1721E+00_JPRB,5.5261E+00_JPRB/)
KBO( :, 5,20,10) = (/&
&3.9765E+00_JPRB,3.9744E+00_JPRB,3.5343E+00_JPRB,4.3595E+00_JPRB,5.0554E+00_JPRB,5.4406E+00_JPRB/)
KBO( :, 1,21,10) = (/&
&3.7211E+00_JPRB,3.7192E+00_JPRB,3.7613E+00_JPRB,4.9074E+00_JPRB,5.7827E+00_JPRB,6.1154E+00_JPRB/)
KBO( :, 2,21,10) = (/&
&3.6330E+00_JPRB,3.6312E+00_JPRB,3.6717E+00_JPRB,4.8116E+00_JPRB,5.6714E+00_JPRB,6.0506E+00_JPRB/)
KBO( :, 3,21,10) = (/&
&3.5589E+00_JPRB,3.5571E+00_JPRB,3.5807E+00_JPRB,4.7108E+00_JPRB,5.5635E+00_JPRB,5.9724E+00_JPRB/)
KBO( :, 4,21,10) = (/&
&3.5073E+00_JPRB,3.5055E+00_JPRB,3.5016E+00_JPRB,4.6097E+00_JPRB,5.4603E+00_JPRB,5.8886E+00_JPRB/)
KBO( :, 5,21,10) = (/&
&3.4691E+00_JPRB,3.4674E+00_JPRB,3.4364E+00_JPRB,4.5052E+00_JPRB,5.3541E+00_JPRB,5.8090E+00_JPRB/)
KBO( :, 1,22,10) = (/&
&3.1543E+00_JPRB,3.1527E+00_JPRB,3.6782E+00_JPRB,5.0447E+00_JPRB,6.0160E+00_JPRB,6.4253E+00_JPRB/)
KBO( :, 2,22,10) = (/&
&3.0969E+00_JPRB,3.0954E+00_JPRB,3.5898E+00_JPRB,4.9499E+00_JPRB,5.9206E+00_JPRB,6.3659E+00_JPRB/)
KBO( :, 3,22,10) = (/&
&3.0620E+00_JPRB,3.0605E+00_JPRB,3.5058E+00_JPRB,4.8486E+00_JPRB,5.8265E+00_JPRB,6.2989E+00_JPRB/)
KBO( :, 4,22,10) = (/&
&3.0425E+00_JPRB,3.0410E+00_JPRB,3.4395E+00_JPRB,4.7446E+00_JPRB,5.7289E+00_JPRB,6.2283E+00_JPRB/)
KBO( :, 5,22,10) = (/&
&3.0546E+00_JPRB,3.0532E+00_JPRB,3.3854E+00_JPRB,4.6358E+00_JPRB,5.6252E+00_JPRB,6.1603E+00_JPRB/)
KBO( :, 1,23,10) = (/&
&2.6854E+00_JPRB,2.6841E+00_JPRB,3.6308E+00_JPRB,5.1459E+00_JPRB,6.2399E+00_JPRB,6.6740E+00_JPRB/)
KBO( :, 2,23,10) = (/&
&2.6617E+00_JPRB,2.6604E+00_JPRB,3.5468E+00_JPRB,5.0540E+00_JPRB,6.1652E+00_JPRB,6.6315E+00_JPRB/)
KBO( :, 3,23,10) = (/&
&2.6584E+00_JPRB,2.6571E+00_JPRB,3.4703E+00_JPRB,4.9599E+00_JPRB,6.0780E+00_JPRB,6.5824E+00_JPRB/)
KBO( :, 4,23,10) = (/&
&2.6872E+00_JPRB,2.6859E+00_JPRB,3.4111E+00_JPRB,4.8587E+00_JPRB,5.9856E+00_JPRB,6.5287E+00_JPRB/)
KBO( :, 5,23,10) = (/&
&2.7417E+00_JPRB,2.7405E+00_JPRB,3.3560E+00_JPRB,4.7548E+00_JPRB,5.8884E+00_JPRB,6.4686E+00_JPRB/)
KBO( :, 1,24,10) = (/&
&2.3151E+00_JPRB,2.3140E+00_JPRB,3.5886E+00_JPRB,5.2274E+00_JPRB,6.4311E+00_JPRB,6.8789E+00_JPRB/)
KBO( :, 2,24,10) = (/&
&2.3230E+00_JPRB,2.3219E+00_JPRB,3.5113E+00_JPRB,5.1442E+00_JPRB,6.3705E+00_JPRB,6.8549E+00_JPRB/)
KBO( :, 3,24,10) = (/&
&2.3609E+00_JPRB,2.3598E+00_JPRB,3.4524E+00_JPRB,5.0514E+00_JPRB,6.2984E+00_JPRB,6.8163E+00_JPRB/)
KBO( :, 4,24,10) = (/&
&2.4175E+00_JPRB,2.4164E+00_JPRB,3.3989E+00_JPRB,4.9521E+00_JPRB,6.2181E+00_JPRB,6.7710E+00_JPRB/)
KBO( :, 5,24,10) = (/&
&2.4762E+00_JPRB,2.4752E+00_JPRB,3.3577E+00_JPRB,4.8533E+00_JPRB,6.1278E+00_JPRB,6.7244E+00_JPRB/)
KBO( :, 1,25,10) = (/&
&2.0244E+00_JPRB,2.0235E+00_JPRB,3.5269E+00_JPRB,5.2724E+00_JPRB,6.5740E+00_JPRB,7.0315E+00_JPRB/)
KBO( :, 2,25,10) = (/&
&2.0651E+00_JPRB,2.0643E+00_JPRB,3.4750E+00_JPRB,5.1965E+00_JPRB,6.5327E+00_JPRB,7.0283E+00_JPRB/)
KBO( :, 3,25,10) = (/&
&2.1229E+00_JPRB,2.1220E+00_JPRB,3.4316E+00_JPRB,5.1098E+00_JPRB,6.4777E+00_JPRB,7.0013E+00_JPRB/)
KBO( :, 4,25,10) = (/&
&2.1858E+00_JPRB,2.1849E+00_JPRB,3.3932E+00_JPRB,5.0189E+00_JPRB,6.4050E+00_JPRB,6.9699E+00_JPRB/)
KBO( :, 5,25,10) = (/&
&2.2519E+00_JPRB,2.2510E+00_JPRB,3.3680E+00_JPRB,4.9354E+00_JPRB,6.3143E+00_JPRB,6.9411E+00_JPRB/)
KBO( :, 1,26,10) = (/&
&1.8038E+00_JPRB,1.8031E+00_JPRB,3.4751E+00_JPRB,5.2741E+00_JPRB,6.6754E+00_JPRB,7.1367E+00_JPRB/)
KBO( :, 2,26,10) = (/&
&1.8584E+00_JPRB,1.8577E+00_JPRB,3.4421E+00_JPRB,5.2128E+00_JPRB,6.6468E+00_JPRB,7.1525E+00_JPRB/)
KBO( :, 3,26,10) = (/&
&1.9217E+00_JPRB,1.9209E+00_JPRB,3.4089E+00_JPRB,5.1445E+00_JPRB,6.6040E+00_JPRB,7.1457E+00_JPRB/)
KBO( :, 4,26,10) = (/&
&1.9824E+00_JPRB,1.9816E+00_JPRB,3.3919E+00_JPRB,5.0736E+00_JPRB,6.5398E+00_JPRB,7.1301E+00_JPRB/)
KBO( :, 5,26,10) = (/&
&2.0431E+00_JPRB,2.0423E+00_JPRB,3.3693E+00_JPRB,5.0098E+00_JPRB,6.4614E+00_JPRB,7.1116E+00_JPRB/)
KBO( :, 1,27,10) = (/&
&1.6205E+00_JPRB,1.6200E+00_JPRB,3.4312E+00_JPRB,5.2512E+00_JPRB,6.7302E+00_JPRB,7.1916E+00_JPRB/)
KBO( :, 2,27,10) = (/&
&1.6821E+00_JPRB,1.6815E+00_JPRB,3.4096E+00_JPRB,5.2107E+00_JPRB,6.7204E+00_JPRB,7.2341E+00_JPRB/)
KBO( :, 3,27,10) = (/&
&1.7393E+00_JPRB,1.7387E+00_JPRB,3.3986E+00_JPRB,5.1611E+00_JPRB,6.6901E+00_JPRB,7.2461E+00_JPRB/)
KBO( :, 4,27,10) = (/&
&1.7952E+00_JPRB,1.7945E+00_JPRB,3.3849E+00_JPRB,5.1118E+00_JPRB,6.6400E+00_JPRB,7.2521E+00_JPRB/)
KBO( :, 5,27,10) = (/&
&1.8467E+00_JPRB,1.8460E+00_JPRB,3.3678E+00_JPRB,5.0688E+00_JPRB,6.5750E+00_JPRB,7.2529E+00_JPRB/)
KBO( :, 1,28,10) = (/&
&1.4581E+00_JPRB,1.4577E+00_JPRB,3.3793E+00_JPRB,5.2151E+00_JPRB,6.7528E+00_JPRB,7.2099E+00_JPRB/)
KBO( :, 2,28,10) = (/&
&1.5130E+00_JPRB,1.5126E+00_JPRB,3.3785E+00_JPRB,5.1947E+00_JPRB,6.7653E+00_JPRB,7.2740E+00_JPRB/)
KBO( :, 3,28,10) = (/&
&1.5669E+00_JPRB,1.5664E+00_JPRB,3.3810E+00_JPRB,5.1664E+00_JPRB,6.7512E+00_JPRB,7.3192E+00_JPRB/)
KBO( :, 4,28,10) = (/&
&1.6172E+00_JPRB,1.6166E+00_JPRB,3.3732E+00_JPRB,5.1425E+00_JPRB,6.7177E+00_JPRB,7.3590E+00_JPRB/)
KBO( :, 5,28,10) = (/&
&1.6631E+00_JPRB,1.6625E+00_JPRB,3.3694E+00_JPRB,5.1109E+00_JPRB,6.6624E+00_JPRB,7.3782E+00_JPRB/)
KBO( :, 1,29,10) = (/&
&1.3022E+00_JPRB,1.3019E+00_JPRB,3.3270E+00_JPRB,5.1728E+00_JPRB,6.7559E+00_JPRB,7.2096E+00_JPRB/)
KBO( :, 2,29,10) = (/&
&1.3533E+00_JPRB,1.3529E+00_JPRB,3.3473E+00_JPRB,5.1723E+00_JPRB,6.7905E+00_JPRB,7.3069E+00_JPRB/)
KBO( :, 3,29,10) = (/&
&1.4031E+00_JPRB,1.4027E+00_JPRB,3.3571E+00_JPRB,5.1703E+00_JPRB,6.7965E+00_JPRB,7.3925E+00_JPRB/)
KBO( :, 4,29,10) = (/&
&1.4491E+00_JPRB,1.4487E+00_JPRB,3.3643E+00_JPRB,5.1652E+00_JPRB,6.7741E+00_JPRB,7.4637E+00_JPRB/)
KBO( :, 5,29,10) = (/&
&1.4926E+00_JPRB,1.4921E+00_JPRB,3.3697E+00_JPRB,5.1473E+00_JPRB,6.7261E+00_JPRB,7.4940E+00_JPRB/)
KBO( :, 1,30,10) = (/&
&1.1600E+00_JPRB,1.1597E+00_JPRB,3.2811E+00_JPRB,5.1242E+00_JPRB,6.7455E+00_JPRB,7.2055E+00_JPRB/)
KBO( :, 2,30,10) = (/&
&1.2064E+00_JPRB,1.2061E+00_JPRB,3.3125E+00_JPRB,5.1497E+00_JPRB,6.8027E+00_JPRB,7.3456E+00_JPRB/)
KBO( :, 3,30,10) = (/&
&1.2511E+00_JPRB,1.2508E+00_JPRB,3.3366E+00_JPRB,5.1707E+00_JPRB,6.8233E+00_JPRB,7.4712E+00_JPRB/)
KBO( :, 4,30,10) = (/&
&1.2939E+00_JPRB,1.2935E+00_JPRB,3.3556E+00_JPRB,5.1801E+00_JPRB,6.8143E+00_JPRB,7.5611E+00_JPRB/)
KBO( :, 5,30,10) = (/&
&1.3350E+00_JPRB,1.3346E+00_JPRB,3.3660E+00_JPRB,5.1735E+00_JPRB,6.7754E+00_JPRB,7.6031E+00_JPRB/)
KBO( :, 1,31,10) = (/&
&1.0335E+00_JPRB,1.0333E+00_JPRB,3.2413E+00_JPRB,5.0768E+00_JPRB,6.7328E+00_JPRB,7.2247E+00_JPRB/)
KBO( :, 2,31,10) = (/&
&1.0751E+00_JPRB,1.0749E+00_JPRB,3.2817E+00_JPRB,5.1294E+00_JPRB,6.8096E+00_JPRB,7.4118E+00_JPRB/)
KBO( :, 3,31,10) = (/&
&1.1154E+00_JPRB,1.1152E+00_JPRB,3.3173E+00_JPRB,5.1678E+00_JPRB,6.8467E+00_JPRB,7.5648E+00_JPRB/)
KBO( :, 4,31,10) = (/&
&1.1549E+00_JPRB,1.1546E+00_JPRB,3.3453E+00_JPRB,5.1899E+00_JPRB,6.8485E+00_JPRB,7.6626E+00_JPRB/)
KBO( :, 5,31,10) = (/&
&1.1976E+00_JPRB,1.1973E+00_JPRB,3.3597E+00_JPRB,5.1968E+00_JPRB,6.8174E+00_JPRB,7.7173E+00_JPRB/)
KBO( :, 1,32,10) = (/&
&9.2196E-01_JPRB,9.2184E-01_JPRB,3.2061E+00_JPRB,5.0420E+00_JPRB,6.7251E+00_JPRB,7.2717E+00_JPRB/)
KBO( :, 2,32,10) = (/&
&9.5916E-01_JPRB,9.5901E-01_JPRB,3.2581E+00_JPRB,5.1143E+00_JPRB,6.8187E+00_JPRB,7.4921E+00_JPRB/)
KBO( :, 3,32,10) = (/&
&9.9613E-01_JPRB,9.9593E-01_JPRB,3.3030E+00_JPRB,5.1678E+00_JPRB,6.8677E+00_JPRB,7.6515E+00_JPRB/)
KBO( :, 4,32,10) = (/&
&1.0359E+00_JPRB,1.0357E+00_JPRB,3.3356E+00_JPRB,5.2002E+00_JPRB,6.8779E+00_JPRB,7.7596E+00_JPRB/)
KBO( :, 5,32,10) = (/&
&1.0855E+00_JPRB,1.0851E+00_JPRB,3.3519E+00_JPRB,5.2172E+00_JPRB,6.8517E+00_JPRB,7.8246E+00_JPRB/)
KBO( :, 1,33,10) = (/&
&8.2444E-01_JPRB,8.2438E-01_JPRB,3.1786E+00_JPRB,5.0173E+00_JPRB,6.7243E+00_JPRB,7.3448E+00_JPRB/)
KBO( :, 2,33,10) = (/&
&8.5838E-01_JPRB,8.5826E-01_JPRB,3.2411E+00_JPRB,5.1061E+00_JPRB,6.8299E+00_JPRB,7.5783E+00_JPRB/)
KBO( :, 3,33,10) = (/&
&8.9425E-01_JPRB,8.9407E-01_JPRB,3.2909E+00_JPRB,5.1715E+00_JPRB,6.8889E+00_JPRB,7.7451E+00_JPRB/)
KBO( :, 4,33,10) = (/&
&9.3902E-01_JPRB,9.3875E-01_JPRB,3.3252E+00_JPRB,5.2146E+00_JPRB,6.9056E+00_JPRB,7.8681E+00_JPRB/)
KBO( :, 5,33,10) = (/&
&9.9963E-01_JPRB,9.9926E-01_JPRB,3.3429E+00_JPRB,5.2364E+00_JPRB,6.8820E+00_JPRB,7.9383E+00_JPRB/)
KBO( :, 1,34,10) = (/&
&7.3808E-01_JPRB,7.3807E-01_JPRB,3.1554E+00_JPRB,5.0005E+00_JPRB,6.7270E+00_JPRB,7.4193E+00_JPRB/)
KBO( :, 2,34,10) = (/&
&7.7041E-01_JPRB,7.7031E-01_JPRB,3.2245E+00_JPRB,5.1037E+00_JPRB,6.8428E+00_JPRB,7.6564E+00_JPRB/)
KBO( :, 3,34,10) = (/&
&8.0927E-01_JPRB,8.0908E-01_JPRB,3.2785E+00_JPRB,5.1786E+00_JPRB,6.9090E+00_JPRB,7.8421E+00_JPRB/)
KBO( :, 4,34,10) = (/&
&8.6226E-01_JPRB,8.6198E-01_JPRB,3.3161E+00_JPRB,5.2290E+00_JPRB,6.9264E+00_JPRB,7.9654E+00_JPRB/)
KBO( :, 5,34,10) = (/&
&9.3161E-01_JPRB,9.3129E-01_JPRB,3.3332E+00_JPRB,5.2535E+00_JPRB,6.9068E+00_JPRB,8.0359E+00_JPRB/)
KBO( :, 1,35,10) = (/&
&6.6091E-01_JPRB,6.6090E-01_JPRB,3.1297E+00_JPRB,4.9826E+00_JPRB,6.7231E+00_JPRB,7.4730E+00_JPRB/)
KBO( :, 2,35,10) = (/&
&6.9343E-01_JPRB,6.9337E-01_JPRB,3.2054E+00_JPRB,5.0985E+00_JPRB,6.8504E+00_JPRB,7.7289E+00_JPRB/)
KBO( :, 3,35,10) = (/&
&7.3707E-01_JPRB,7.3689E-01_JPRB,3.2647E+00_JPRB,5.1833E+00_JPRB,6.9233E+00_JPRB,7.9244E+00_JPRB/)
KBO( :, 4,35,10) = (/&
&7.9689E-01_JPRB,7.9665E-01_JPRB,3.3047E+00_JPRB,5.2421E+00_JPRB,6.9456E+00_JPRB,8.0506E+00_JPRB/)
KBO( :, 5,35,10) = (/&
&8.7135E-01_JPRB,8.7107E-01_JPRB,3.3248E+00_JPRB,5.2688E+00_JPRB,6.9299E+00_JPRB,8.1175E+00_JPRB/)
KBO( :, 1,36,10) = (/&
&5.9261E-01_JPRB,5.9263E-01_JPRB,3.0998E+00_JPRB,4.9572E+00_JPRB,6.7063E+00_JPRB,7.5006E+00_JPRB/)
KBO( :, 2,36,10) = (/&
&6.2616E-01_JPRB,6.2611E-01_JPRB,3.1830E+00_JPRB,5.0867E+00_JPRB,6.8489E+00_JPRB,7.7811E+00_JPRB/)
KBO( :, 3,36,10) = (/&
&6.7343E-01_JPRB,6.7330E-01_JPRB,3.2478E+00_JPRB,5.1832E+00_JPRB,6.9309E+00_JPRB,7.9826E+00_JPRB/)
KBO( :, 4,36,10) = (/&
&7.3660E-01_JPRB,7.3640E-01_JPRB,3.2928E+00_JPRB,5.2484E+00_JPRB,6.9611E+00_JPRB,8.1184E+00_JPRB/)
KBO( :, 5,36,10) = (/&
&8.1395E-01_JPRB,8.1372E-01_JPRB,3.3165E+00_JPRB,5.2807E+00_JPRB,6.9512E+00_JPRB,8.1925E+00_JPRB/)
KBO( :, 1,37,10) = (/&
&5.2989E-01_JPRB,5.2996E-01_JPRB,3.0580E+00_JPRB,4.9104E+00_JPRB,6.6637E+00_JPRB,7.4740E+00_JPRB/)
KBO( :, 2,37,10) = (/&
&5.6419E-01_JPRB,5.6414E-01_JPRB,3.1506E+00_JPRB,5.0576E+00_JPRB,6.8262E+00_JPRB,7.7836E+00_JPRB/)
KBO( :, 3,37,10) = (/&
&6.1196E-01_JPRB,6.1186E-01_JPRB,3.2232E+00_JPRB,5.1694E+00_JPRB,6.9254E+00_JPRB,8.0021E+00_JPRB/)
KBO( :, 4,37,10) = (/&
&6.7516E-01_JPRB,6.7503E-01_JPRB,3.2773E+00_JPRB,5.2468E+00_JPRB,6.9696E+00_JPRB,8.1546E+00_JPRB/)
KBO( :, 5,37,10) = (/&
&7.5242E-01_JPRB,7.5225E-01_JPRB,3.3077E+00_JPRB,5.2880E+00_JPRB,6.9712E+00_JPRB,8.2436E+00_JPRB/)
KBO( :, 1,38,10) = (/&
&4.7505E-01_JPRB,4.7513E-01_JPRB,3.0176E+00_JPRB,4.8628E+00_JPRB,6.6172E+00_JPRB,7.4494E+00_JPRB/)
KBO( :, 2,38,10) = (/&
&5.1071E-01_JPRB,5.1070E-01_JPRB,3.1197E+00_JPRB,5.0269E+00_JPRB,6.7975E+00_JPRB,7.7810E+00_JPRB/)
KBO( :, 3,38,10) = (/&
&5.5877E-01_JPRB,5.5872E-01_JPRB,3.2002E+00_JPRB,5.1526E+00_JPRB,6.9148E+00_JPRB,8.0180E+00_JPRB/)
KBO( :, 4,38,10) = (/&
&6.2123E-01_JPRB,6.2116E-01_JPRB,3.2619E+00_JPRB,5.2424E+00_JPRB,6.9725E+00_JPRB,8.1853E+00_JPRB/)
KBO( :, 5,38,10) = (/&
&6.9700E-01_JPRB,6.9689E-01_JPRB,3.2986E+00_JPRB,5.2927E+00_JPRB,6.9850E+00_JPRB,8.2945E+00_JPRB/)
KBO( :, 1,39,10) = (/&
&4.2667E-01_JPRB,4.2675E-01_JPRB,2.9792E+00_JPRB,4.8162E+00_JPRB,6.5678E+00_JPRB,7.4301E+00_JPRB/)
KBO( :, 2,39,10) = (/&
&4.6368E-01_JPRB,4.6371E-01_JPRB,3.0898E+00_JPRB,4.9949E+00_JPRB,6.7657E+00_JPRB,7.7791E+00_JPRB/)
KBO( :, 3,39,10) = (/&
&5.1271E-01_JPRB,5.1271E-01_JPRB,3.1789E+00_JPRB,5.1345E+00_JPRB,6.8995E+00_JPRB,8.0327E+00_JPRB/)
KBO( :, 4,39,10) = (/&
&5.7418E-01_JPRB,5.7416E-01_JPRB,3.2474E+00_JPRB,5.2350E+00_JPRB,6.9705E+00_JPRB,8.2154E+00_JPRB/)
KBO( :, 5,39,10) = (/&
&6.4813E-01_JPRB,6.4808E-01_JPRB,3.2906E+00_JPRB,5.2946E+00_JPRB,6.9954E+00_JPRB,8.3481E+00_JPRB/)
KBO( :, 1,40,10) = (/&
&3.8059E-01_JPRB,3.8066E-01_JPRB,2.9294E+00_JPRB,4.7482E+00_JPRB,6.4900E+00_JPRB,7.3413E+00_JPRB/)
KBO( :, 2,40,10) = (/&
&4.1764E-01_JPRB,4.1768E-01_JPRB,3.0517E+00_JPRB,4.9455E+00_JPRB,6.7137E+00_JPRB,7.7220E+00_JPRB/)
KBO( :, 3,40,10) = (/&
&4.6631E-01_JPRB,4.6635E-01_JPRB,3.1498E+00_JPRB,5.1004E+00_JPRB,6.8682E+00_JPRB,8.0003E+00_JPRB/)
KBO( :, 4,40,10) = (/&
&5.2644E-01_JPRB,5.2648E-01_JPRB,3.2265E+00_JPRB,5.2162E+00_JPRB,6.9603E+00_JPRB,8.2072E+00_JPRB/)
KBO( :, 5,40,10) = (/&
&5.9702E-01_JPRB,5.9703E-01_JPRB,3.2787E+00_JPRB,5.2882E+00_JPRB,7.0004E+00_JPRB,8.3571E+00_JPRB/)
KBO( :, 1,41,10) = (/&
&3.3906E-01_JPRB,3.3914E-01_JPRB,2.8764E+00_JPRB,4.6750E+00_JPRB,6.4031E+00_JPRB,7.2374E+00_JPRB/)
KBO( :, 2,41,10) = (/&
&3.7555E-01_JPRB,3.7562E-01_JPRB,3.0116E+00_JPRB,4.8899E+00_JPRB,6.6527E+00_JPRB,7.6510E+00_JPRB/)
KBO( :, 3,41,10) = (/&
&4.2374E-01_JPRB,4.2382E-01_JPRB,3.1192E+00_JPRB,5.0596E+00_JPRB,6.8298E+00_JPRB,7.9584E+00_JPRB/)
KBO( :, 4,41,10) = (/&
&4.8252E-01_JPRB,4.8261E-01_JPRB,3.2032E+00_JPRB,5.1909E+00_JPRB,6.9423E+00_JPRB,8.1883E+00_JPRB/)
KBO( :, 5,41,10) = (/&
&5.5055E-01_JPRB,5.5059E-01_JPRB,3.2647E+00_JPRB,5.2767E+00_JPRB,6.9993E+00_JPRB,8.3564E+00_JPRB/)
KBO( :, 1,42,10) = (/&
&3.0216E-01_JPRB,3.0227E-01_JPRB,2.8228E+00_JPRB,4.6001E+00_JPRB,6.3100E+00_JPRB,7.1283E+00_JPRB/)
KBO( :, 2,42,10) = (/&
&3.3749E-01_JPRB,3.3759E-01_JPRB,2.9700E+00_JPRB,4.8303E+00_JPRB,6.5864E+00_JPRB,7.5749E+00_JPRB/)
KBO( :, 3,42,10) = (/&
&3.8480E-01_JPRB,3.8492E-01_JPRB,3.0865E+00_JPRB,5.0162E+00_JPRB,6.7847E+00_JPRB,7.9100E+00_JPRB/)
KBO( :, 4,42,10) = (/&
&4.4288E-01_JPRB,4.4301E-01_JPRB,3.1790E+00_JPRB,5.1608E+00_JPRB,6.9184E+00_JPRB,8.1647E+00_JPRB/)
KBO( :, 5,42,10) = (/&
&5.0928E-01_JPRB,5.0935E-01_JPRB,3.2490E+00_JPRB,5.2607E+00_JPRB,6.9918E+00_JPRB,8.3533E+00_JPRB/)
KBO( :, 1,43,10) = (/&
&2.6768E-01_JPRB,2.6781E-01_JPRB,2.7595E+00_JPRB,4.5068E+00_JPRB,6.1924E+00_JPRB,6.9816E+00_JPRB/)
KBO( :, 2,43,10) = (/&
&3.0121E-01_JPRB,3.0134E-01_JPRB,2.9195E+00_JPRB,4.7538E+00_JPRB,6.4985E+00_JPRB,7.4658E+00_JPRB/)
KBO( :, 3,43,10) = (/&
&3.4636E-01_JPRB,3.4652E-01_JPRB,3.0475E+00_JPRB,4.9586E+00_JPRB,6.7250E+00_JPRB,7.8363E+00_JPRB/)
KBO( :, 4,43,10) = (/&
&4.0279E-01_JPRB,4.0294E-01_JPRB,3.1487E+00_JPRB,5.1186E+00_JPRB,6.8816E+00_JPRB,8.1193E+00_JPRB/)
KBO( :, 5,43,10) = (/&
&4.6775E-01_JPRB,4.6784E-01_JPRB,3.2281E+00_JPRB,5.2365E+00_JPRB,6.9765E+00_JPRB,8.3335E+00_JPRB/)
KBO( :, 1,44,10) = (/&
&2.3663E-01_JPRB,2.3679E-01_JPRB,2.6889E+00_JPRB,4.3996E+00_JPRB,6.0559E+00_JPRB,6.8135E+00_JPRB/)
KBO( :, 2,44,10) = (/&
&2.6748E-01_JPRB,2.6764E-01_JPRB,2.8618E+00_JPRB,4.6667E+00_JPRB,6.3943E+00_JPRB,7.3355E+00_JPRB/)
KBO( :, 3,44,10) = (/&
&3.1007E-01_JPRB,3.1028E-01_JPRB,3.0033E+00_JPRB,4.8904E+00_JPRB,6.6510E+00_JPRB,7.7469E+00_JPRB/)
KBO( :, 4,44,10) = (/&
&3.6426E-01_JPRB,3.6444E-01_JPRB,3.1143E+00_JPRB,5.0666E+00_JPRB,6.8341E+00_JPRB,8.0609E+00_JPRB/)
KBO( :, 5,44,10) = (/&
&4.2790E-01_JPRB,4.2800E-01_JPRB,3.2017E+00_JPRB,5.2027E+00_JPRB,6.9510E+00_JPRB,8.3005E+00_JPRB/)
KBO( :, 1,45,10) = (/&
&2.0943E-01_JPRB,2.0961E-01_JPRB,2.6149E+00_JPRB,4.2870E+00_JPRB,5.9088E+00_JPRB,6.6376E+00_JPRB/)
KBO( :, 2,45,10) = (/&
&2.3748E-01_JPRB,2.3768E-01_JPRB,2.7996E+00_JPRB,4.5739E+00_JPRB,6.2800E+00_JPRB,7.1981E+00_JPRB/)
KBO( :, 3,45,10) = (/&
&2.7717E-01_JPRB,2.7741E-01_JPRB,2.9545E+00_JPRB,4.8149E+00_JPRB,6.5679E+00_JPRB,7.6498E+00_JPRB/)
KBO( :, 4,45,10) = (/&
&3.2881E-01_JPRB,3.2900E-01_JPRB,3.0769E+00_JPRB,5.0100E+00_JPRB,6.7767E+00_JPRB,7.9956E+00_JPRB/)
KBO( :, 5,45,10) = (/&
&3.9089E-01_JPRB,3.9099E-01_JPRB,3.1729E+00_JPRB,5.1617E+00_JPRB,6.9184E+00_JPRB,8.2647E+00_JPRB/)
KBO( :, 1,46,10) = (/&
&1.8488E-01_JPRB,1.8509E-01_JPRB,2.5337E+00_JPRB,4.1619E+00_JPRB,5.7408E+00_JPRB,6.4343E+00_JPRB/)
KBO( :, 2,46,10) = (/&
&2.1029E-01_JPRB,2.1052E-01_JPRB,2.7308E+00_JPRB,4.4685E+00_JPRB,6.1476E+00_JPRB,7.0351E+00_JPRB/)
KBO( :, 3,46,10) = (/&
&2.4641E-01_JPRB,2.4669E-01_JPRB,2.8991E+00_JPRB,4.7282E+00_JPRB,6.4680E+00_JPRB,7.5299E+00_JPRB/)
KBO( :, 4,46,10) = (/&
&2.9502E-01_JPRB,2.9523E-01_JPRB,3.0336E+00_JPRB,4.9428E+00_JPRB,6.7064E+00_JPRB,7.9122E+00_JPRB/)
KBO( :, 5,46,10) = (/&
&3.5492E-01_JPRB,3.5504E-01_JPRB,3.1395E+00_JPRB,5.1108E+00_JPRB,6.8742E+00_JPRB,8.2122E+00_JPRB/)
KBO( :, 1,47,10) = (/&
&1.6240E-01_JPRB,1.6263E-01_JPRB,2.4388E+00_JPRB,4.0166E+00_JPRB,5.5397E+00_JPRB,6.1804E+00_JPRB/)
KBO( :, 2,47,10) = (/&
&1.8504E-01_JPRB,1.8532E-01_JPRB,2.6496E+00_JPRB,4.3442E+00_JPRB,5.9864E+00_JPRB,6.8265E+00_JPRB/)
KBO( :, 3,47,10) = (/&
&2.1735E-01_JPRB,2.1764E-01_JPRB,2.8316E+00_JPRB,4.6250E+00_JPRB,6.3441E+00_JPRB,7.3704E+00_JPRB/)
KBO( :, 4,47,10) = (/&
&2.6219E-01_JPRB,2.6243E-01_JPRB,2.9807E+00_JPRB,4.8597E+00_JPRB,6.6165E+00_JPRB,7.7948E+00_JPRB/)
KBO( :, 5,47,10) = (/&
&3.1904E-01_JPRB,3.1916E-01_JPRB,3.0987E+00_JPRB,5.0473E+00_JPRB,6.8132E+00_JPRB,8.1318E+00_JPRB/)
KBO( :, 1,48,10) = (/&
&1.4274E-01_JPRB,1.4309E-01_JPRB,2.3378E+00_JPRB,3.8621E+00_JPRB,5.3223E+00_JPRB,5.9129E+00_JPRB/)
KBO( :, 2,48,10) = (/&
&1.6289E-01_JPRB,1.6319E-01_JPRB,2.5631E+00_JPRB,4.2108E+00_JPRB,5.8103E+00_JPRB,6.6062E+00_JPRB/)
KBO( :, 3,48,10) = (/&
&1.9167E-01_JPRB,1.9198E-01_JPRB,2.7584E+00_JPRB,4.5133E+00_JPRB,6.2051E+00_JPRB,7.1967E+00_JPRB/)
KBO( :, 4,48,10) = (/&
&2.3239E-01_JPRB,2.3264E-01_JPRB,2.9226E+00_JPRB,4.7680E+00_JPRB,6.5135E+00_JPRB,7.6665E+00_JPRB/)
KBO( :, 5,48,10) = (/&
&2.8577E-01_JPRB,2.8592E-01_JPRB,3.0525E+00_JPRB,4.9759E+00_JPRB,6.7401E+00_JPRB,8.0423E+00_JPRB/)
KBO( :, 1,49,10) = (/&
&1.2506E-01_JPRB,1.2569E-01_JPRB,2.2315E+00_JPRB,3.6984E+00_JPRB,5.0916E+00_JPRB,5.6363E+00_JPRB/)
KBO( :, 2,49,10) = (/&
&1.4348E-01_JPRB,1.4383E-01_JPRB,2.4717E+00_JPRB,4.0691E+00_JPRB,5.6178E+00_JPRB,6.3745E+00_JPRB/)
KBO( :, 3,49,10) = (/&
&1.6900E-01_JPRB,1.6934E-01_JPRB,2.6802E+00_JPRB,4.3928E+00_JPRB,6.0515E+00_JPRB,7.0127E+00_JPRB/)
KBO( :, 4,49,10) = (/&
&2.0581E-01_JPRB,2.0606E-01_JPRB,2.8586E+00_JPRB,4.6682E+00_JPRB,6.3962E+00_JPRB,7.5292E+00_JPRB/)
KBO( :, 5,49,10) = (/&
&2.5518E-01_JPRB,2.5533E-01_JPRB,3.0025E+00_JPRB,4.8968E+00_JPRB,6.6558E+00_JPRB,7.9457E+00_JPRB/)
KBO( :, 1,50,10) = (/&
&1.0959E-01_JPRB,1.1070E-01_JPRB,2.1267E+00_JPRB,3.5368E+00_JPRB,4.8615E+00_JPRB,5.3538E+00_JPRB/)
KBO( :, 2,50,10) = (/&
&1.2689E-01_JPRB,1.2744E-01_JPRB,2.3809E+00_JPRB,3.9302E+00_JPRB,5.4235E+00_JPRB,6.1306E+00_JPRB/)
KBO( :, 3,50,10) = (/&
&1.4973E-01_JPRB,1.5009E-01_JPRB,2.6019E+00_JPRB,4.2725E+00_JPRB,5.8946E+00_JPRB,6.8112E+00_JPRB/)
KBO( :, 4,50,10) = (/&
&1.8304E-01_JPRB,1.8331E-01_JPRB,2.7927E+00_JPRB,4.5675E+00_JPRB,6.2731E+00_JPRB,7.3745E+00_JPRB/)
KBO( :, 5,50,10) = (/&
&2.2866E-01_JPRB,2.2882E-01_JPRB,2.9508E+00_JPRB,4.8146E+00_JPRB,6.5657E+00_JPRB,7.8282E+00_JPRB/)
KBO( :, 1,51,10) = (/&
&9.5768E-02_JPRB,9.7661E-02_JPRB,2.0216E+00_JPRB,3.3751E+00_JPRB,4.6268E+00_JPRB,5.0597E+00_JPRB/)
KBO( :, 2,51,10) = (/&
&1.1216E-01_JPRB,1.1307E-01_JPRB,2.2881E+00_JPRB,3.7875E+00_JPRB,5.2217E+00_JPRB,5.8744E+00_JPRB/)
KBO( :, 3,51,10) = (/&
&1.3299E-01_JPRB,1.3343E-01_JPRB,2.5219E+00_JPRB,4.1480E+00_JPRB,5.7284E+00_JPRB,6.5943E+00_JPRB/)
KBO( :, 4,51,10) = (/&
&1.6308E-01_JPRB,1.6337E-01_JPRB,2.7248E+00_JPRB,4.4626E+00_JPRB,6.1415E+00_JPRB,7.2033E+00_JPRB/)
KBO( :, 5,51,10) = (/&
&2.0524E-01_JPRB,2.0541E-01_JPRB,2.8961E+00_JPRB,4.7281E+00_JPRB,6.4666E+00_JPRB,7.6945E+00_JPRB/)
KBO( :, 1,52,10) = (/&
&8.3171E-02_JPRB,8.6221E-02_JPRB,1.9144E+00_JPRB,3.2076E+00_JPRB,4.3819E+00_JPRB,4.7580E+00_JPRB/)
KBO( :, 2,52,10) = (/&
&9.8912E-02_JPRB,1.0039E-01_JPRB,2.1906E+00_JPRB,3.6370E+00_JPRB,5.0088E+00_JPRB,5.6089E+00_JPRB/)
KBO( :, 3,52,10) = (/&
&1.1809E-01_JPRB,1.1874E-01_JPRB,2.4381E+00_JPRB,4.0185E+00_JPRB,5.5505E+00_JPRB,6.3684E+00_JPRB/)
KBO( :, 4,52,10) = (/&
&1.4539E-01_JPRB,1.4572E-01_JPRB,2.6526E+00_JPRB,4.3511E+00_JPRB,5.9980E+00_JPRB,7.0214E+00_JPRB/)
KBO( :, 5,52,10) = (/&
&1.8406E-01_JPRB,1.8425E-01_JPRB,2.8362E+00_JPRB,4.6354E+00_JPRB,6.3565E+00_JPRB,7.5532E+00_JPRB/)
KBO( :, 1,53,10) = (/&
&7.1760E-02_JPRB,7.6225E-02_JPRB,1.8049E+00_JPRB,3.0338E+00_JPRB,4.1285E+00_JPRB,4.4543E+00_JPRB/)
KBO( :, 2,53,10) = (/&
&8.6733E-02_JPRB,8.9133E-02_JPRB,2.0890E+00_JPRB,3.4808E+00_JPRB,4.7838E+00_JPRB,5.3384E+00_JPRB/)
KBO( :, 3,53,10) = (/&
&1.0470E-01_JPRB,1.0571E-01_JPRB,2.3496E+00_JPRB,3.8826E+00_JPRB,5.3593E+00_JPRB,6.1340E+00_JPRB/)
KBO( :, 4,53,10) = (/&
&1.2964E-01_JPRB,1.3004E-01_JPRB,2.5758E+00_JPRB,4.2328E+00_JPRB,5.8432E+00_JPRB,6.8310E+00_JPRB/)
KBO( :, 5,53,10) = (/&
&1.6486E-01_JPRB,1.6505E-01_JPRB,2.7718E+00_JPRB,4.5358E+00_JPRB,6.2341E+00_JPRB,7.4042E+00_JPRB/)
KBO( :, 1,54,10) = (/&
&6.1882E-02_JPRB,6.7940E-02_JPRB,1.7027E+00_JPRB,2.8705E+00_JPRB,3.8894E+00_JPRB,4.1460E+00_JPRB/)
KBO( :, 2,54,10) = (/&
&7.6155E-02_JPRB,7.9684E-02_JPRB,1.9930E+00_JPRB,3.3325E+00_JPRB,4.5678E+00_JPRB,5.0509E+00_JPRB/)
KBO( :, 3,54,10) = (/&
&9.3240E-02_JPRB,9.4826E-02_JPRB,2.2641E+00_JPRB,3.7513E+00_JPRB,5.1730E+00_JPRB,5.8771E+00_JPRB/)
KBO( :, 4,54,10) = (/&
&1.1632E-01_JPRB,1.1690E-01_JPRB,2.5020E+00_JPRB,4.1182E+00_JPRB,5.6892E+00_JPRB,6.6127E+00_JPRB/)
KBO( :, 5,54,10) = (/&
&1.4865E-01_JPRB,1.4887E-01_JPRB,2.7085E+00_JPRB,4.4384E+00_JPRB,6.1110E+00_JPRB,7.2268E+00_JPRB/)
KBO( :, 1,55,10) = (/&
&5.3143E-02_JPRB,6.0929E-02_JPRB,1.6034E+00_JPRB,2.7108E+00_JPRB,3.6519E+00_JPRB,3.8346E+00_JPRB/)
KBO( :, 2,55,10) = (/&
&6.6664E-02_JPRB,7.1549E-02_JPRB,1.8993E+00_JPRB,3.1854E+00_JPRB,4.3528E+00_JPRB,4.7449E+00_JPRB/)
KBO( :, 3,55,10) = (/&
&8.2988E-02_JPRB,8.5434E-02_JPRB,2.1781E+00_JPRB,3.6188E+00_JPRB,4.9850E+00_JPRB,5.6016E+00_JPRB/)
KBO( :, 4,55,10) = (/&
&1.0455E-01_JPRB,1.0541E-01_JPRB,2.4283E+00_JPRB,4.0035E+00_JPRB,5.5314E+00_JPRB,6.3670E+00_JPRB/)
KBO( :, 5,55,10) = (/&
&1.3450E-01_JPRB,1.3475E-01_JPRB,2.6447E+00_JPRB,4.3400E+00_JPRB,5.9837E+00_JPRB,7.0246E+00_JPRB/)
KBO( :, 1,56,10) = (/&
&4.5363E-02_JPRB,5.4761E-02_JPRB,1.5057E+00_JPRB,2.5465E+00_JPRB,3.4107E+00_JPRB,3.5270E+00_JPRB/)
KBO( :, 2,56,10) = (/&
&5.8005E-02_JPRB,6.4431E-02_JPRB,1.8040E+00_JPRB,3.0340E+00_JPRB,4.1322E+00_JPRB,4.4343E+00_JPRB/)
KBO( :, 3,56,10) = (/&
&7.3593E-02_JPRB,7.7144E-02_JPRB,2.0898E+00_JPRB,3.4823E+00_JPRB,4.7884E+00_JPRB,5.3173E+00_JPRB/)
KBO( :, 4,56,10) = (/&
&9.3887E-02_JPRB,9.5237E-02_JPRB,2.3510E+00_JPRB,3.8850E+00_JPRB,5.3647E+00_JPRB,6.1108E+00_JPRB/)
KBO( :, 5,56,10) = (/&
&1.2181E-01_JPRB,1.2219E-01_JPRB,2.5776E+00_JPRB,4.2361E+00_JPRB,5.8482E+00_JPRB,6.8081E+00_JPRB/)
KBO( :, 1,57,10) = (/&
&3.8484E-02_JPRB,4.9332E-02_JPRB,1.4087E+00_JPRB,2.3775E+00_JPRB,3.1673E+00_JPRB,3.2197E+00_JPRB/)
KBO( :, 2,57,10) = (/&
&5.0147E-02_JPRB,5.8221E-02_JPRB,1.7073E+00_JPRB,2.8793E+00_JPRB,3.9049E+00_JPRB,4.1273E+00_JPRB/)
KBO( :, 3,57,10) = (/&
&6.4931E-02_JPRB,6.9815E-02_JPRB,1.9987E+00_JPRB,3.3420E+00_JPRB,4.5839E+00_JPRB,5.0218E+00_JPRB/)
KBO( :, 4,57,10) = (/&
&8.4109E-02_JPRB,8.6186E-02_JPRB,2.2698E+00_JPRB,3.7606E+00_JPRB,5.1878E+00_JPRB,5.8449E+00_JPRB/)
KBO( :, 5,57,10) = (/&
&1.1023E-01_JPRB,1.1081E-01_JPRB,2.5075E+00_JPRB,4.1274E+00_JPRB,5.7022E+00_JPRB,6.5747E+00_JPRB/)
KBO( :, 1,58,10) = (/&
&3.2626E-02_JPRB,4.4633E-02_JPRB,1.3174E+00_JPRB,2.2156E+00_JPRB,2.9363E+00_JPRB,2.9278E+00_JPRB/)
KBO( :, 2,58,10) = (/&
&4.3298E-02_JPRB,5.2922E-02_JPRB,1.6144E+00_JPRB,2.7304E+00_JPRB,3.6831E+00_JPRB,3.8325E+00_JPRB/)
KBO( :, 3,58,10) = (/&
&5.7247E-02_JPRB,6.3597E-02_JPRB,1.9107E+00_JPRB,3.2043E+00_JPRB,4.3821E+00_JPRB,4.7236E+00_JPRB/)
KBO( :, 4,58,10) = (/&
&7.5473E-02_JPRB,7.8525E-02_JPRB,2.1894E+00_JPRB,3.6369E+00_JPRB,5.0121E+00_JPRB,5.5748E+00_JPRB/)
KBO( :, 5,58,10) = (/&
&1.0003E-01_JPRB,1.0093E-01_JPRB,2.4389E+00_JPRB,4.0197E+00_JPRB,5.5549E+00_JPRB,6.3325E+00_JPRB/)
KBO( :, 1,59,10) = (/&
&2.9072E-02_JPRB,4.1705E-02_JPRB,1.2802E+00_JPRB,2.1494E+00_JPRB,2.8421E+00_JPRB,2.7798E+00_JPRB/)
KBO( :, 2,59,10) = (/&
&3.9252E-02_JPRB,4.9835E-02_JPRB,1.5765E+00_JPRB,2.6680E+00_JPRB,3.5911E+00_JPRB,3.6659E+00_JPRB/)
KBO( :, 3,59,10) = (/&
&5.3000E-02_JPRB,6.0270E-02_JPRB,1.8744E+00_JPRB,3.1473E+00_JPRB,4.2993E+00_JPRB,4.5411E+00_JPRB/)
KBO( :, 4,59,10) = (/&
&7.1218E-02_JPRB,7.4859E-02_JPRB,2.1561E+00_JPRB,3.5852E+00_JPRB,4.9384E+00_JPRB,5.3790E+00_JPRB/)
KBO( :, 5,59,10) = (/&
&9.5581E-02_JPRB,9.6679E-02_JPRB,2.4098E+00_JPRB,3.9752E+00_JPRB,5.4931E+00_JPRB,6.1513E+00_JPRB/)
KBO( :, 1,13,11) = (/&
&1.0830E+01_JPRB,1.0824E+01_JPRB,8.2966E+00_JPRB,5.7775E+00_JPRB,4.2067E+00_JPRB,3.8416E+00_JPRB/)
KBO( :, 2,13,11) = (/&
&1.0842E+01_JPRB,1.0836E+01_JPRB,8.3048E+00_JPRB,5.7756E+00_JPRB,4.1117E+00_JPRB,3.7626E+00_JPRB/)
KBO( :, 3,13,11) = (/&
&1.0806E+01_JPRB,1.0800E+01_JPRB,8.2770E+00_JPRB,5.7524E+00_JPRB,4.0103E+00_JPRB,3.7005E+00_JPRB/)
KBO( :, 4,13,11) = (/&
&1.0724E+01_JPRB,1.0718E+01_JPRB,8.2112E+00_JPRB,5.7002E+00_JPRB,3.9058E+00_JPRB,3.6875E+00_JPRB/)
KBO( :, 5,13,11) = (/&
&1.0621E+01_JPRB,1.0615E+01_JPRB,8.1337E+00_JPRB,5.6465E+00_JPRB,3.8013E+00_JPRB,3.7028E+00_JPRB/)
KBO( :, 1,14,11) = (/&
&1.1181E+01_JPRB,1.1175E+01_JPRB,8.5568E+00_JPRB,5.9649E+00_JPRB,4.4522E+00_JPRB,4.2077E+00_JPRB/)
KBO( :, 2,14,11) = (/&
&1.1133E+01_JPRB,1.1127E+01_JPRB,8.5167E+00_JPRB,5.9323E+00_JPRB,4.3476E+00_JPRB,4.1247E+00_JPRB/)
KBO( :, 3,14,11) = (/&
&1.1053E+01_JPRB,1.1047E+01_JPRB,8.4570E+00_JPRB,5.8889E+00_JPRB,4.2415E+00_JPRB,4.0417E+00_JPRB/)
KBO( :, 4,14,11) = (/&
&1.0933E+01_JPRB,1.0927E+01_JPRB,8.3682E+00_JPRB,5.8252E+00_JPRB,4.1413E+00_JPRB,3.9695E+00_JPRB/)
KBO( :, 5,14,11) = (/&
&1.0780E+01_JPRB,1.0774E+01_JPRB,8.2481E+00_JPRB,5.7382E+00_JPRB,4.0362E+00_JPRB,3.9481E+00_JPRB/)
KBO( :, 1,15,11) = (/&
&1.1265E+01_JPRB,1.1259E+01_JPRB,8.6144E+00_JPRB,6.0504E+00_JPRB,4.7323E+00_JPRB,4.5971E+00_JPRB/)
KBO( :, 2,15,11) = (/&
&1.1162E+01_JPRB,1.1156E+01_JPRB,8.5378E+00_JPRB,5.9895E+00_JPRB,4.6323E+00_JPRB,4.4988E+00_JPRB/)
KBO( :, 3,15,11) = (/&
&1.1022E+01_JPRB,1.1015E+01_JPRB,8.4337E+00_JPRB,5.9199E+00_JPRB,4.5312E+00_JPRB,4.4142E+00_JPRB/)
KBO( :, 4,15,11) = (/&
&1.0880E+01_JPRB,1.0874E+01_JPRB,8.3234E+00_JPRB,5.8348E+00_JPRB,4.4237E+00_JPRB,4.3326E+00_JPRB/)
KBO( :, 5,15,11) = (/&
&1.0698E+01_JPRB,1.0692E+01_JPRB,8.1811E+00_JPRB,5.7294E+00_JPRB,4.3189E+00_JPRB,4.2569E+00_JPRB/)
KBO( :, 1,16,11) = (/&
&1.1047E+01_JPRB,1.1041E+01_JPRB,8.4566E+00_JPRB,6.0733E+00_JPRB,5.0987E+00_JPRB,4.9814E+00_JPRB/)
KBO( :, 2,16,11) = (/&
&1.0912E+01_JPRB,1.0905E+01_JPRB,8.3558E+00_JPRB,5.9956E+00_JPRB,4.9979E+00_JPRB,4.8884E+00_JPRB/)
KBO( :, 3,16,11) = (/&
&1.0758E+01_JPRB,1.0752E+01_JPRB,8.2381E+00_JPRB,5.8935E+00_JPRB,4.8881E+00_JPRB,4.7986E+00_JPRB/)
KBO( :, 4,16,11) = (/&
&1.0569E+01_JPRB,1.0563E+01_JPRB,8.0898E+00_JPRB,5.7760E+00_JPRB,4.7808E+00_JPRB,4.7200E+00_JPRB/)
KBO( :, 5,16,11) = (/&
&1.0363E+01_JPRB,1.0357E+01_JPRB,7.9324E+00_JPRB,5.6614E+00_JPRB,4.6746E+00_JPRB,4.6272E+00_JPRB/)
KBO( :, 1,17,11) = (/&
&1.0577E+01_JPRB,1.0572E+01_JPRB,8.1098E+00_JPRB,6.0991E+00_JPRB,5.5106E+00_JPRB,5.4165E+00_JPRB/)
KBO( :, 2,17,11) = (/&
&1.0411E+01_JPRB,1.0405E+01_JPRB,7.9835E+00_JPRB,5.9805E+00_JPRB,5.3996E+00_JPRB,5.3206E+00_JPRB/)
KBO( :, 3,17,11) = (/&
&1.0224E+01_JPRB,1.0219E+01_JPRB,7.8406E+00_JPRB,5.8520E+00_JPRB,5.2910E+00_JPRB,5.2289E+00_JPRB/)
KBO( :, 4,17,11) = (/&
&1.0028E+01_JPRB,1.0022E+01_JPRB,7.6890E+00_JPRB,5.7215E+00_JPRB,5.1803E+00_JPRB,5.1373E+00_JPRB/)
KBO( :, 5,17,11) = (/&
&9.8160E+00_JPRB,9.8105E+00_JPRB,7.5244E+00_JPRB,5.5839E+00_JPRB,5.0653E+00_JPRB,5.0432E+00_JPRB/)
KBO( :, 1,18,11) = (/&
&9.8986E+00_JPRB,9.8931E+00_JPRB,7.6044E+00_JPRB,6.1164E+00_JPRB,5.9534E+00_JPRB,5.9474E+00_JPRB/)
KBO( :, 2,18,11) = (/&
&9.7140E+00_JPRB,9.7086E+00_JPRB,7.4654E+00_JPRB,5.9795E+00_JPRB,5.8383E+00_JPRB,5.8411E+00_JPRB/)
KBO( :, 3,18,11) = (/&
&9.5273E+00_JPRB,9.5220E+00_JPRB,7.3210E+00_JPRB,5.8383E+00_JPRB,5.7189E+00_JPRB,5.7395E+00_JPRB/)
KBO( :, 4,18,11) = (/&
&9.3182E+00_JPRB,9.3130E+00_JPRB,7.1594E+00_JPRB,5.7006E+00_JPRB,5.6002E+00_JPRB,5.6385E+00_JPRB/)
KBO( :, 5,18,11) = (/&
&9.0984E+00_JPRB,9.0934E+00_JPRB,6.9901E+00_JPRB,5.5596E+00_JPRB,5.4784E+00_JPRB,5.5361E+00_JPRB/)
KBO( :, 1,19,11) = (/&
&9.0617E+00_JPRB,9.0567E+00_JPRB,6.9882E+00_JPRB,6.1944E+00_JPRB,6.4032E+00_JPRB,6.5506E+00_JPRB/)
KBO( :, 2,19,11) = (/&
&8.8807E+00_JPRB,8.8758E+00_JPRB,6.8508E+00_JPRB,6.0541E+00_JPRB,6.2790E+00_JPRB,6.4421E+00_JPRB/)
KBO( :, 3,19,11) = (/&
&8.6840E+00_JPRB,8.6793E+00_JPRB,6.6993E+00_JPRB,5.9155E+00_JPRB,6.1530E+00_JPRB,6.3302E+00_JPRB/)
KBO( :, 4,19,11) = (/&
&8.4690E+00_JPRB,8.4643E+00_JPRB,6.5346E+00_JPRB,5.7782E+00_JPRB,6.0205E+00_JPRB,6.1969E+00_JPRB/)
KBO( :, 5,19,11) = (/&
&8.2461E+00_JPRB,8.2415E+00_JPRB,6.3683E+00_JPRB,5.6418E+00_JPRB,5.8884E+00_JPRB,6.0738E+00_JPRB/)
KBO( :, 1,20,11) = (/&
&8.1338E+00_JPRB,8.1294E+00_JPRB,6.3787E+00_JPRB,6.3724E+00_JPRB,6.8676E+00_JPRB,7.1512E+00_JPRB/)
KBO( :, 2,20,11) = (/&
&7.9489E+00_JPRB,7.9446E+00_JPRB,6.2323E+00_JPRB,6.2367E+00_JPRB,6.7380E+00_JPRB,7.0235E+00_JPRB/)
KBO( :, 3,20,11) = (/&
&7.7484E+00_JPRB,7.7442E+00_JPRB,6.0747E+00_JPRB,6.0984E+00_JPRB,6.6037E+00_JPRB,6.8886E+00_JPRB/)
KBO( :, 4,20,11) = (/&
&7.5336E+00_JPRB,7.5295E+00_JPRB,5.9158E+00_JPRB,5.9585E+00_JPRB,6.4615E+00_JPRB,6.7483E+00_JPRB/)
KBO( :, 5,20,11) = (/&
&7.3192E+00_JPRB,7.3153E+00_JPRB,5.7540E+00_JPRB,5.8154E+00_JPRB,6.3114E+00_JPRB,6.6285E+00_JPRB/)
KBO( :, 1,21,11) = (/&
&7.1783E+00_JPRB,7.1745E+00_JPRB,5.8792E+00_JPRB,6.5789E+00_JPRB,7.3613E+00_JPRB,7.7022E+00_JPRB/)
KBO( :, 2,21,11) = (/&
&6.9919E+00_JPRB,6.9882E+00_JPRB,5.7299E+00_JPRB,6.4389E+00_JPRB,7.2225E+00_JPRB,7.5647E+00_JPRB/)
KBO( :, 3,21,11) = (/&
&6.7909E+00_JPRB,6.7873E+00_JPRB,5.5766E+00_JPRB,6.2973E+00_JPRB,7.0712E+00_JPRB,7.4405E+00_JPRB/)
KBO( :, 4,21,11) = (/&
&6.5939E+00_JPRB,6.5903E+00_JPRB,5.4217E+00_JPRB,6.1490E+00_JPRB,6.9129E+00_JPRB,7.3122E+00_JPRB/)
KBO( :, 5,21,11) = (/&
&6.4093E+00_JPRB,6.4059E+00_JPRB,5.2663E+00_JPRB,5.9963E+00_JPRB,6.7516E+00_JPRB,7.1970E+00_JPRB/)
KBO( :, 1,22,11) = (/&
&6.2177E+00_JPRB,6.2144E+00_JPRB,5.5479E+00_JPRB,6.7900E+00_JPRB,7.8374E+00_JPRB,8.2375E+00_JPRB/)
KBO( :, 2,22,11) = (/&
&6.0356E+00_JPRB,6.0324E+00_JPRB,5.3995E+00_JPRB,6.6451E+00_JPRB,7.6895E+00_JPRB,8.1166E+00_JPRB/)
KBO( :, 3,22,11) = (/&
&5.8596E+00_JPRB,5.8565E+00_JPRB,5.2499E+00_JPRB,6.4943E+00_JPRB,7.5342E+00_JPRB,8.0016E+00_JPRB/)
KBO( :, 4,22,11) = (/&
&5.7069E+00_JPRB,5.7039E+00_JPRB,5.1029E+00_JPRB,6.3342E+00_JPRB,7.3721E+00_JPRB,7.8779E+00_JPRB/)
KBO( :, 5,22,11) = (/&
&5.5907E+00_JPRB,5.5878E+00_JPRB,4.9677E+00_JPRB,6.1731E+00_JPRB,7.2068E+00_JPRB,7.7598E+00_JPRB/)
KBO( :, 1,23,11) = (/&
&5.3001E+00_JPRB,5.2974E+00_JPRB,5.3392E+00_JPRB,7.0212E+00_JPRB,8.2731E+00_JPRB,8.7769E+00_JPRB/)
KBO( :, 2,23,11) = (/&
&5.1465E+00_JPRB,5.1439E+00_JPRB,5.1959E+00_JPRB,6.8658E+00_JPRB,8.1318E+00_JPRB,8.6756E+00_JPRB/)
KBO( :, 3,23,11) = (/&
&5.0259E+00_JPRB,5.0234E+00_JPRB,5.0568E+00_JPRB,6.6964E+00_JPRB,7.9822E+00_JPRB,8.5635E+00_JPRB/)
KBO( :, 4,23,11) = (/&
&4.9408E+00_JPRB,4.9383E+00_JPRB,4.9256E+00_JPRB,6.5229E+00_JPRB,7.8283E+00_JPRB,8.4337E+00_JPRB/)
KBO( :, 5,23,11) = (/&
&4.8982E+00_JPRB,4.8957E+00_JPRB,4.8170E+00_JPRB,6.3467E+00_JPRB,7.6656E+00_JPRB,8.3117E+00_JPRB/)
KBO( :, 1,24,11) = (/&
&4.4810E+00_JPRB,4.4788E+00_JPRB,5.2117E+00_JPRB,7.2187E+00_JPRB,8.6894E+00_JPRB,9.2830E+00_JPRB/)
KBO( :, 2,24,11) = (/&
&4.3875E+00_JPRB,4.3854E+00_JPRB,5.0729E+00_JPRB,7.0552E+00_JPRB,8.5552E+00_JPRB,9.1952E+00_JPRB/)
KBO( :, 3,24,11) = (/&
&4.3298E+00_JPRB,4.3277E+00_JPRB,4.9395E+00_JPRB,6.8841E+00_JPRB,8.4129E+00_JPRB,9.0854E+00_JPRB/)
KBO( :, 4,24,11) = (/&
&4.3240E+00_JPRB,4.3219E+00_JPRB,4.8305E+00_JPRB,6.7106E+00_JPRB,8.2583E+00_JPRB,8.9534E+00_JPRB/)
KBO( :, 5,24,11) = (/&
&4.3568E+00_JPRB,4.3547E+00_JPRB,4.7450E+00_JPRB,6.5341E+00_JPRB,8.0917E+00_JPRB,8.8298E+00_JPRB/)
KBO( :, 1,25,11) = (/&
&3.8157E+00_JPRB,3.8139E+00_JPRB,5.1260E+00_JPRB,7.3753E+00_JPRB,9.0809E+00_JPRB,9.7303E+00_JPRB/)
KBO( :, 2,25,11) = (/&
&3.7828E+00_JPRB,3.7809E+00_JPRB,4.9881E+00_JPRB,7.2252E+00_JPRB,8.9546E+00_JPRB,9.6529E+00_JPRB/)
KBO( :, 3,25,11) = (/&
&3.7966E+00_JPRB,3.7948E+00_JPRB,4.8698E+00_JPRB,7.0694E+00_JPRB,8.8114E+00_JPRB,9.5492E+00_JPRB/)
KBO( :, 4,25,11) = (/&
&3.8447E+00_JPRB,3.8429E+00_JPRB,4.7808E+00_JPRB,6.9055E+00_JPRB,8.6548E+00_JPRB,9.4220E+00_JPRB/)
KBO( :, 5,25,11) = (/&
&3.9327E+00_JPRB,3.9309E+00_JPRB,4.7021E+00_JPRB,6.7298E+00_JPRB,8.4889E+00_JPRB,9.2936E+00_JPRB/)
KBO( :, 1,26,11) = (/&
&3.3036E+00_JPRB,3.3021E+00_JPRB,5.0575E+00_JPRB,7.5192E+00_JPRB,9.4189E+00_JPRB,1.0102E+01_JPRB/)
KBO( :, 2,26,11) = (/&
&3.3285E+00_JPRB,3.3270E+00_JPRB,4.9281E+00_JPRB,7.3849E+00_JPRB,9.3027E+00_JPRB,1.0041E+01_JPRB/)
KBO( :, 3,26,11) = (/&
&3.3889E+00_JPRB,3.3874E+00_JPRB,4.8326E+00_JPRB,7.2371E+00_JPRB,9.1673E+00_JPRB,9.9526E+00_JPRB/)
KBO( :, 4,26,11) = (/&
&3.4837E+00_JPRB,3.4822E+00_JPRB,4.7525E+00_JPRB,7.0754E+00_JPRB,9.0130E+00_JPRB,9.8334E+00_JPRB/)
KBO( :, 5,26,11) = (/&
&3.5869E+00_JPRB,3.5853E+00_JPRB,4.6879E+00_JPRB,6.9081E+00_JPRB,8.8429E+00_JPRB,9.7104E+00_JPRB/)
KBO( :, 1,27,11) = (/&
&2.9165E+00_JPRB,2.9152E+00_JPRB,4.9857E+00_JPRB,7.6560E+00_JPRB,9.7110E+00_JPRB,1.0421E+01_JPRB/)
KBO( :, 2,27,11) = (/&
&2.9834E+00_JPRB,2.9822E+00_JPRB,4.8877E+00_JPRB,7.5297E+00_JPRB,9.6106E+00_JPRB,1.0382E+01_JPRB/)
KBO( :, 3,27,11) = (/&
&3.0758E+00_JPRB,3.0745E+00_JPRB,4.8130E+00_JPRB,7.3870E+00_JPRB,9.4838E+00_JPRB,1.0306E+01_JPRB/)
KBO( :, 4,27,11) = (/&
&3.1796E+00_JPRB,3.1781E+00_JPRB,4.7485E+00_JPRB,7.2327E+00_JPRB,9.3303E+00_JPRB,1.0198E+01_JPRB/)
KBO( :, 5,27,11) = (/&
&3.2957E+00_JPRB,3.2941E+00_JPRB,4.7038E+00_JPRB,7.0683E+00_JPRB,9.1564E+00_JPRB,1.0089E+01_JPRB/)
KBO( :, 1,28,11) = (/&
&2.6155E+00_JPRB,2.6145E+00_JPRB,4.9275E+00_JPRB,7.7638E+00_JPRB,9.9551E+00_JPRB,1.0696E+01_JPRB/)
KBO( :, 2,28,11) = (/&
&2.7046E+00_JPRB,2.7035E+00_JPRB,4.8641E+00_JPRB,7.6476E+00_JPRB,9.8682E+00_JPRB,1.0682E+01_JPRB/)
KBO( :, 3,28,11) = (/&
&2.8078E+00_JPRB,2.8066E+00_JPRB,4.8086E+00_JPRB,7.5132E+00_JPRB,9.7479E+00_JPRB,1.0615E+01_JPRB/)
KBO( :, 4,28,11) = (/&
&2.9220E+00_JPRB,2.9207E+00_JPRB,4.7661E+00_JPRB,7.3606E+00_JPRB,9.5999E+00_JPRB,1.0521E+01_JPRB/)
KBO( :, 5,28,11) = (/&
&3.0419E+00_JPRB,3.0404E+00_JPRB,4.7235E+00_JPRB,7.2046E+00_JPRB,9.4195E+00_JPRB,1.0424E+01_JPRB/)
KBO( :, 1,29,11) = (/&
&2.3732E+00_JPRB,2.3723E+00_JPRB,4.8900E+00_JPRB,7.8375E+00_JPRB,1.0150E+01_JPRB,1.0951E+01_JPRB/)
KBO( :, 2,29,11) = (/&
&2.4712E+00_JPRB,2.4702E+00_JPRB,4.8481E+00_JPRB,7.7319E+00_JPRB,1.0078E+01_JPRB,1.0946E+01_JPRB/)
KBO( :, 3,29,11) = (/&
&2.5783E+00_JPRB,2.5771E+00_JPRB,4.8118E+00_JPRB,7.6037E+00_JPRB,9.9721E+00_JPRB,1.0893E+01_JPRB/)
KBO( :, 4,29,11) = (/&
&2.6902E+00_JPRB,2.6889E+00_JPRB,4.7850E+00_JPRB,7.4580E+00_JPRB,9.8268E+00_JPRB,1.0822E+01_JPRB/)
KBO( :, 5,29,11) = (/&
&2.8045E+00_JPRB,2.8032E+00_JPRB,4.7400E+00_JPRB,7.3154E+00_JPRB,9.6483E+00_JPRB,1.0741E+01_JPRB/)
KBO( :, 1,30,11) = (/&
&2.1658E+00_JPRB,2.1650E+00_JPRB,4.8677E+00_JPRB,7.8862E+00_JPRB,1.0317E+01_JPRB,1.1167E+01_JPRB/)
KBO( :, 2,30,11) = (/&
&2.2662E+00_JPRB,2.2652E+00_JPRB,4.8423E+00_JPRB,7.7911E+00_JPRB,1.0262E+01_JPRB,1.1177E+01_JPRB/)
KBO( :, 3,30,11) = (/&
&2.3698E+00_JPRB,2.3687E+00_JPRB,4.8249E+00_JPRB,7.6717E+00_JPRB,1.0162E+01_JPRB,1.1145E+01_JPRB/)
KBO( :, 4,30,11) = (/&
&2.4773E+00_JPRB,2.4761E+00_JPRB,4.7959E+00_JPRB,7.5389E+00_JPRB,1.0012E+01_JPRB,1.1105E+01_JPRB/)
KBO( :, 5,30,11) = (/&
&2.5877E+00_JPRB,2.5865E+00_JPRB,4.7569E+00_JPRB,7.4115E+00_JPRB,9.8340E+00_JPRB,1.1029E+01_JPRB/)
KBO( :, 1,31,11) = (/&
&1.9790E+00_JPRB,1.9782E+00_JPRB,4.8500E+00_JPRB,7.9143E+00_JPRB,1.0464E+01_JPRB,1.1366E+01_JPRB/)
KBO( :, 2,31,11) = (/&
&2.0776E+00_JPRB,2.0767E+00_JPRB,4.8427E+00_JPRB,7.8316E+00_JPRB,1.0417E+01_JPRB,1.1398E+01_JPRB/)
KBO( :, 3,31,11) = (/&
&2.1797E+00_JPRB,2.1787E+00_JPRB,4.8321E+00_JPRB,7.7240E+00_JPRB,1.0316E+01_JPRB,1.1410E+01_JPRB/)
KBO( :, 4,31,11) = (/&
&2.2842E+00_JPRB,2.2832E+00_JPRB,4.8021E+00_JPRB,7.6072E+00_JPRB,1.0171E+01_JPRB,1.1390E+01_JPRB/)
KBO( :, 5,31,11) = (/&
&2.3904E+00_JPRB,2.3893E+00_JPRB,4.7702E+00_JPRB,7.4874E+00_JPRB,9.9885E+00_JPRB,1.1305E+01_JPRB/)
KBO( :, 1,32,11) = (/&
&1.8065E+00_JPRB,1.8057E+00_JPRB,4.8337E+00_JPRB,7.9321E+00_JPRB,1.0594E+01_JPRB,1.1553E+01_JPRB/)
KBO( :, 2,32,11) = (/&
&1.9056E+00_JPRB,1.9048E+00_JPRB,4.8404E+00_JPRB,7.8602E+00_JPRB,1.0550E+01_JPRB,1.1632E+01_JPRB/)
KBO( :, 3,32,11) = (/&
&2.0071E+00_JPRB,2.0062E+00_JPRB,4.8291E+00_JPRB,7.7660E+00_JPRB,1.0447E+01_JPRB,1.1676E+01_JPRB/)
KBO( :, 4,32,11) = (/&
&2.1091E+00_JPRB,2.1082E+00_JPRB,4.8052E+00_JPRB,7.6656E+00_JPRB,1.0296E+01_JPRB,1.1648E+01_JPRB/)
KBO( :, 5,32,11) = (/&
&2.2144E+00_JPRB,2.2134E+00_JPRB,4.7806E+00_JPRB,7.5529E+00_JPRB,1.0105E+01_JPRB,1.1557E+01_JPRB/)
KBO( :, 1,33,11) = (/&
&1.6510E+00_JPRB,1.6503E+00_JPRB,4.8210E+00_JPRB,7.9482E+00_JPRB,1.0706E+01_JPRB,1.1767E+01_JPRB/)
KBO( :, 2,33,11) = (/&
&1.7494E+00_JPRB,1.7487E+00_JPRB,4.8343E+00_JPRB,7.8861E+00_JPRB,1.0658E+01_JPRB,1.1881E+01_JPRB/)
KBO( :, 3,33,11) = (/&
&1.8501E+00_JPRB,1.8493E+00_JPRB,4.8252E+00_JPRB,7.8076E+00_JPRB,1.0548E+01_JPRB,1.1918E+01_JPRB/)
KBO( :, 4,33,11) = (/&
&1.9524E+00_JPRB,1.9516E+00_JPRB,4.8101E+00_JPRB,7.7163E+00_JPRB,1.0391E+01_JPRB,1.1878E+01_JPRB/)
KBO( :, 5,33,11) = (/&
&2.0594E+00_JPRB,2.0586E+00_JPRB,4.7896E+00_JPRB,7.6047E+00_JPRB,1.0193E+01_JPRB,1.1783E+01_JPRB/)
KBO( :, 1,34,11) = (/&
&1.5098E+00_JPRB,1.5093E+00_JPRB,4.8119E+00_JPRB,7.9653E+00_JPRB,1.0798E+01_JPRB,1.1972E+01_JPRB/)
KBO( :, 2,34,11) = (/&
&1.6067E+00_JPRB,1.6061E+00_JPRB,4.8282E+00_JPRB,7.9164E+00_JPRB,1.0745E+01_JPRB,1.2091E+01_JPRB/)
KBO( :, 3,34,11) = (/&
&1.7068E+00_JPRB,1.7062E+00_JPRB,4.8254E+00_JPRB,7.8470E+00_JPRB,1.0632E+01_JPRB,1.2113E+01_JPRB/)
KBO( :, 4,34,11) = (/&
&1.8116E+00_JPRB,1.8109E+00_JPRB,4.8147E+00_JPRB,7.7622E+00_JPRB,1.0470E+01_JPRB,1.2073E+01_JPRB/)
KBO( :, 5,34,11) = (/&
&1.9232E+00_JPRB,1.9225E+00_JPRB,4.7977E+00_JPRB,7.6521E+00_JPRB,1.0264E+01_JPRB,1.1969E+01_JPRB/)
KBO( :, 1,35,11) = (/&
&1.3777E+00_JPRB,1.3773E+00_JPRB,4.8007E+00_JPRB,7.9865E+00_JPRB,1.0878E+01_JPRB,1.2152E+01_JPRB/)
KBO( :, 2,35,11) = (/&
&1.4720E+00_JPRB,1.4715E+00_JPRB,4.8220E+00_JPRB,7.9505E+00_JPRB,1.0824E+01_JPRB,1.2272E+01_JPRB/)
KBO( :, 3,35,11) = (/&
&1.5713E+00_JPRB,1.5708E+00_JPRB,4.8275E+00_JPRB,7.8907E+00_JPRB,1.0710E+01_JPRB,1.2296E+01_JPRB/)
KBO( :, 4,35,11) = (/&
&1.6790E+00_JPRB,1.6784E+00_JPRB,4.8220E+00_JPRB,7.8081E+00_JPRB,1.0547E+01_JPRB,1.2260E+01_JPRB/)
KBO( :, 5,35,11) = (/&
&1.7986E+00_JPRB,1.7980E+00_JPRB,4.8075E+00_JPRB,7.7002E+00_JPRB,1.0336E+01_JPRB,1.2159E+01_JPRB/)
KBO( :, 1,36,11) = (/&
&1.2514E+00_JPRB,1.2511E+00_JPRB,4.7868E+00_JPRB,8.0109E+00_JPRB,1.0946E+01_JPRB,1.2304E+01_JPRB/)
KBO( :, 2,36,11) = (/&
&1.3435E+00_JPRB,1.3431E+00_JPRB,4.8179E+00_JPRB,7.9877E+00_JPRB,1.0897E+01_JPRB,1.2427E+01_JPRB/)
KBO( :, 3,36,11) = (/&
&1.4435E+00_JPRB,1.4430E+00_JPRB,4.8314E+00_JPRB,7.9353E+00_JPRB,1.0788E+01_JPRB,1.2470E+01_JPRB/)
KBO( :, 4,36,11) = (/&
&1.5538E+00_JPRB,1.5533E+00_JPRB,4.8318E+00_JPRB,7.8582E+00_JPRB,1.0627E+01_JPRB,1.2438E+01_JPRB/)
KBO( :, 5,36,11) = (/&
&1.6810E+00_JPRB,1.6804E+00_JPRB,4.8203E+00_JPRB,7.7528E+00_JPRB,1.0416E+01_JPRB,1.2339E+01_JPRB/)
KBO( :, 1,37,11) = (/&
&1.1282E+00_JPRB,1.1280E+00_JPRB,4.7699E+00_JPRB,8.0315E+00_JPRB,1.1000E+01_JPRB,1.2396E+01_JPRB/)
KBO( :, 2,37,11) = (/&
&1.2167E+00_JPRB,1.2164E+00_JPRB,4.8125E+00_JPRB,8.0243E+00_JPRB,1.0970E+01_JPRB,1.2544E+01_JPRB/)
KBO( :, 3,37,11) = (/&
&1.3158E+00_JPRB,1.3155E+00_JPRB,4.8359E+00_JPRB,7.9814E+00_JPRB,1.0872E+01_JPRB,1.2615E+01_JPRB/)
KBO( :, 4,37,11) = (/&
&1.4284E+00_JPRB,1.4280E+00_JPRB,4.8417E+00_JPRB,7.9120E+00_JPRB,1.0722E+01_JPRB,1.2596E+01_JPRB/)
KBO( :, 5,37,11) = (/&
&1.5612E+00_JPRB,1.5606E+00_JPRB,4.8348E+00_JPRB,7.8131E+00_JPRB,1.0516E+01_JPRB,1.2504E+01_JPRB/)
KBO( :, 1,38,11) = (/&
&1.0204E+00_JPRB,1.0202E+00_JPRB,4.7523E+00_JPRB,8.0470E+00_JPRB,1.1041E+01_JPRB,1.2476E+01_JPRB/)
KBO( :, 2,38,11) = (/&
&1.1044E+00_JPRB,1.1042E+00_JPRB,4.8063E+00_JPRB,8.0526E+00_JPRB,1.1031E+01_JPRB,1.2656E+01_JPRB/)
KBO( :, 3,38,11) = (/&
&1.2026E+00_JPRB,1.2023E+00_JPRB,4.8389E+00_JPRB,8.0207E+00_JPRB,1.0945E+01_JPRB,1.2754E+01_JPRB/)
KBO( :, 4,38,11) = (/&
&1.3171E+00_JPRB,1.3167E+00_JPRB,4.8508E+00_JPRB,7.9583E+00_JPRB,1.0805E+01_JPRB,1.2746E+01_JPRB/)
KBO( :, 5,38,11) = (/&
&1.4551E+00_JPRB,1.4546E+00_JPRB,4.8486E+00_JPRB,7.8661E+00_JPRB,1.0608E+01_JPRB,1.2659E+01_JPRB/)
KBO( :, 1,39,11) = (/&
&9.2697E-01_JPRB,9.2690E-01_JPRB,4.7345E+00_JPRB,8.0529E+00_JPRB,1.1070E+01_JPRB,1.2554E+01_JPRB/)
KBO( :, 2,39,11) = (/&
&1.0083E+00_JPRB,1.0081E+00_JPRB,4.8007E+00_JPRB,8.0735E+00_JPRB,1.1079E+01_JPRB,1.2773E+01_JPRB/)
KBO( :, 3,39,11) = (/&
&1.1037E+00_JPRB,1.1035E+00_JPRB,4.8402E+00_JPRB,8.0520E+00_JPRB,1.1008E+01_JPRB,1.2893E+01_JPRB/)
KBO( :, 4,39,11) = (/&
&1.2204E+00_JPRB,1.2201E+00_JPRB,4.8590E+00_JPRB,7.9971E+00_JPRB,1.0876E+01_JPRB,1.2892E+01_JPRB/)
KBO( :, 5,39,11) = (/&
&1.3628E+00_JPRB,1.3623E+00_JPRB,4.8606E+00_JPRB,7.9113E+00_JPRB,1.0688E+01_JPRB,1.2810E+01_JPRB/)
KBO( :, 1,40,11) = (/&
&8.3758E-01_JPRB,8.3760E-01_JPRB,4.7063E+00_JPRB,8.0487E+00_JPRB,1.1082E+01_JPRB,1.2556E+01_JPRB/)
KBO( :, 2,40,11) = (/&
&9.1581E-01_JPRB,9.1577E-01_JPRB,4.7869E+00_JPRB,8.0879E+00_JPRB,1.1120E+01_JPRB,1.2816E+01_JPRB/)
KBO( :, 3,40,11) = (/&
&1.0079E+00_JPRB,1.0078E+00_JPRB,4.8371E+00_JPRB,8.0805E+00_JPRB,1.1070E+01_JPRB,1.2970E+01_JPRB/)
KBO( :, 4,40,11) = (/&
&1.1225E+00_JPRB,1.1222E+00_JPRB,4.8639E+00_JPRB,8.0357E+00_JPRB,1.0954E+01_JPRB,1.2989E+01_JPRB/)
KBO( :, 5,40,11) = (/&
&1.2665E+00_JPRB,1.2660E+00_JPRB,4.8714E+00_JPRB,7.9591E+00_JPRB,1.0779E+01_JPRB,1.2926E+01_JPRB/)
KBO( :, 1,41,11) = (/&
&7.5804E-01_JPRB,7.5812E-01_JPRB,4.6746E+00_JPRB,8.0347E+00_JPRB,1.1077E+01_JPRB,1.2530E+01_JPRB/)
KBO( :, 2,41,11) = (/&
&8.3424E-01_JPRB,8.3425E-01_JPRB,4.7690E+00_JPRB,8.0936E+00_JPRB,1.1147E+01_JPRB,1.2837E+01_JPRB/)
KBO( :, 3,41,11) = (/&
&9.2284E-01_JPRB,9.2272E-01_JPRB,4.8295E+00_JPRB,8.1031E+00_JPRB,1.1121E+01_JPRB,1.3026E+01_JPRB/)
KBO( :, 4,41,11) = (/&
&1.0345E+00_JPRB,1.0342E+00_JPRB,4.8660E+00_JPRB,8.0690E+00_JPRB,1.1022E+01_JPRB,1.3069E+01_JPRB/)
KBO( :, 5,41,11) = (/&
&1.1779E+00_JPRB,1.1775E+00_JPRB,4.8792E+00_JPRB,8.0025E+00_JPRB,1.0862E+01_JPRB,1.3028E+01_JPRB/)
KBO( :, 1,42,11) = (/&
&6.8836E-01_JPRB,6.8850E-01_JPRB,4.6395E+00_JPRB,8.0108E+00_JPRB,1.1057E+01_JPRB,1.2493E+01_JPRB/)
KBO( :, 2,42,11) = (/&
&7.6202E-01_JPRB,7.6208E-01_JPRB,4.7478E+00_JPRB,8.0915E+00_JPRB,1.1161E+01_JPRB,1.2847E+01_JPRB/)
KBO( :, 3,42,11) = (/&
&8.4897E-01_JPRB,8.4889E-01_JPRB,4.8194E+00_JPRB,8.1177E+00_JPRB,1.1160E+01_JPRB,1.3071E+01_JPRB/)
KBO( :, 4,42,11) = (/&
&9.5721E-01_JPRB,9.5697E-01_JPRB,4.8642E+00_JPRB,8.0964E+00_JPRB,1.1081E+01_JPRB,1.3142E+01_JPRB/)
KBO( :, 5,42,11) = (/&
&1.0979E+00_JPRB,1.0975E+00_JPRB,4.8838E+00_JPRB,8.0399E+00_JPRB,1.0937E+01_JPRB,1.3122E+01_JPRB/)
KBO( :, 1,43,11) = (/&
&6.2327E-01_JPRB,6.2346E-01_JPRB,4.5920E+00_JPRB,7.9682E+00_JPRB,1.1010E+01_JPRB,1.2410E+01_JPRB/)
KBO( :, 2,43,11) = (/&
&6.9363E-01_JPRB,6.9372E-01_JPRB,4.7172E+00_JPRB,8.0779E+00_JPRB,1.1157E+01_JPRB,1.2823E+01_JPRB/)
KBO( :, 3,43,11) = (/&
&7.7812E-01_JPRB,7.7808E-01_JPRB,4.8024E+00_JPRB,8.1237E+00_JPRB,1.1190E+01_JPRB,1.3092E+01_JPRB/)
KBO( :, 4,43,11) = (/&
&8.8257E-01_JPRB,8.8240E-01_JPRB,4.8564E+00_JPRB,8.1185E+00_JPRB,1.1134E+01_JPRB,1.3199E+01_JPRB/)
KBO( :, 5,43,11) = (/&
&1.0175E+00_JPRB,1.0172E+00_JPRB,4.8852E+00_JPRB,8.0748E+00_JPRB,1.1010E+01_JPRB,1.3208E+01_JPRB/)
KBO( :, 1,44,11) = (/&
&5.6319E-01_JPRB,5.6344E-01_JPRB,4.5362E+00_JPRB,7.9098E+00_JPRB,1.0942E+01_JPRB,1.2291E+01_JPRB/)
KBO( :, 2,44,11) = (/&
&6.3128E-01_JPRB,6.3143E-01_JPRB,4.6773E+00_JPRB,8.0513E+00_JPRB,1.1133E+01_JPRB,1.2773E+01_JPRB/)
KBO( :, 3,44,11) = (/&
&7.1290E-01_JPRB,7.1288E-01_JPRB,4.7788E+00_JPRB,8.1200E+00_JPRB,1.1206E+01_JPRB,1.3092E+01_JPRB/)
KBO( :, 4,44,11) = (/&
&8.1370E-01_JPRB,8.1356E-01_JPRB,4.8431E+00_JPRB,8.1349E+00_JPRB,1.1178E+01_JPRB,1.3245E+01_JPRB/)
KBO( :, 5,44,11) = (/&
&9.4155E-01_JPRB,9.4126E-01_JPRB,4.8828E+00_JPRB,8.1039E+00_JPRB,1.1076E+01_JPRB,1.3283E+01_JPRB/)
KBO( :, 1,45,11) = (/&
&5.0848E-01_JPRB,5.0877E-01_JPRB,4.4759E+00_JPRB,7.8396E+00_JPRB,1.0853E+01_JPRB,1.2157E+01_JPRB/)
KBO( :, 2,45,11) = (/&
&5.7558E-01_JPRB,5.7574E-01_JPRB,4.6321E+00_JPRB,8.0148E+00_JPRB,1.1090E+01_JPRB,1.2710E+01_JPRB/)
KBO( :, 3,45,11) = (/&
&6.5428E-01_JPRB,6.5431E-01_JPRB,4.7490E+00_JPRB,8.1075E+00_JPRB,1.1206E+01_JPRB,1.3081E+01_JPRB/)
KBO( :, 4,45,11) = (/&
&7.5171E-01_JPRB,7.5160E-01_JPRB,4.8272E+00_JPRB,8.1428E+00_JPRB,1.1211E+01_JPRB,1.3283E+01_JPRB/)
KBO( :, 5,45,11) = (/&
&8.7320E-01_JPRB,8.7295E-01_JPRB,4.8756E+00_JPRB,8.1271E+00_JPRB,1.1133E+01_JPRB,1.3354E+01_JPRB/)
KBO( :, 1,46,11) = (/&
&4.5749E-01_JPRB,4.5781E-01_JPRB,4.4050E+00_JPRB,7.7477E+00_JPRB,1.0733E+01_JPRB,1.1988E+01_JPRB/)
KBO( :, 2,46,11) = (/&
&5.2335E-01_JPRB,5.2354E-01_JPRB,4.5777E+00_JPRB,7.9624E+00_JPRB,1.1027E+01_JPRB,1.2622E+01_JPRB/)
KBO( :, 3,46,11) = (/&
&5.9972E-01_JPRB,5.9977E-01_JPRB,4.7113E+00_JPRB,8.0849E+00_JPRB,1.1188E+01_JPRB,1.3051E+01_JPRB/)
KBO( :, 4,46,11) = (/&
&6.9340E-01_JPRB,6.9332E-01_JPRB,4.8042E+00_JPRB,8.1402E+00_JPRB,1.1232E+01_JPRB,1.3309E+01_JPRB/)
KBO( :, 5,46,11) = (/&
&8.0900E-01_JPRB,8.0880E-01_JPRB,4.8629E+00_JPRB,8.1438E+00_JPRB,1.1182E+01_JPRB,1.3415E+01_JPRB/)
KBO( :, 1,47,11) = (/&
&4.0799E-01_JPRB,4.0834E-01_JPRB,4.3192E+00_JPRB,7.6262E+00_JPRB,1.0570E+01_JPRB,1.1748E+01_JPRB/)
KBO( :, 2,47,11) = (/&
&4.7291E-01_JPRB,4.7311E-01_JPRB,4.5111E+00_JPRB,7.8858E+00_JPRB,1.0930E+01_JPRB,1.2474E+01_JPRB/)
KBO( :, 3,47,11) = (/&
&5.4737E-01_JPRB,5.4746E-01_JPRB,4.6622E+00_JPRB,8.0462E+00_JPRB,1.1144E+01_JPRB,1.2972E+01_JPRB/)
KBO( :, 4,47,11) = (/&
&6.3579E-01_JPRB,6.3575E-01_JPRB,4.7722E+00_JPRB,8.1275E+00_JPRB,1.1235E+01_JPRB,1.3300E+01_JPRB/)
KBO( :, 5,47,11) = (/&
&7.4500E-01_JPRB,7.4486E-01_JPRB,4.8444E+00_JPRB,8.1534E+00_JPRB,1.1220E+01_JPRB,1.3455E+01_JPRB/)
KBO( :, 1,48,11) = (/&
&3.6234E-01_JPRB,3.6271E-01_JPRB,4.2229E+00_JPRB,7.4847E+00_JPRB,1.0381E+01_JPRB,1.1491E+01_JPRB/)
KBO( :, 2,48,11) = (/&
&4.2649E-01_JPRB,4.2672E-01_JPRB,4.4362E+00_JPRB,7.7928E+00_JPRB,1.0805E+01_JPRB,1.2307E+01_JPRB/)
KBO( :, 3,48,11) = (/&
&4.9899E-01_JPRB,4.9911E-01_JPRB,4.6047E+00_JPRB,7.9930E+00_JPRB,1.1077E+01_JPRB,1.2882E+01_JPRB/)
KBO( :, 4,48,11) = (/&
&5.8344E-01_JPRB,5.8343E-01_JPRB,4.7326E+00_JPRB,8.1042E+00_JPRB,1.1219E+01_JPRB,1.3280E+01_JPRB/)
KBO( :, 5,48,11) = (/&
&6.8655E-01_JPRB,6.8645E-01_JPRB,4.8209E+00_JPRB,8.1532E+00_JPRB,1.1244E+01_JPRB,1.3490E+01_JPRB/)
KBO( :, 1,49,11) = (/&
&3.2105E-01_JPRB,3.2141E-01_JPRB,4.1218E+00_JPRB,7.3215E+00_JPRB,1.0162E+01_JPRB,1.1223E+01_JPRB/)
KBO( :, 2,49,11) = (/&
&3.8263E-01_JPRB,3.8290E-01_JPRB,4.3538E+00_JPRB,7.6804E+00_JPRB,1.0654E+01_JPRB,1.2130E+01_JPRB/)
KBO( :, 3,49,11) = (/&
&4.5423E-01_JPRB,4.5438E-01_JPRB,4.5413E+00_JPRB,7.9230E+00_JPRB,1.0989E+01_JPRB,1.2791E+01_JPRB/)
KBO( :, 4,49,11) = (/&
&5.3583E-01_JPRB,5.3587E-01_JPRB,4.6861E+00_JPRB,8.0697E+00_JPRB,1.1180E+01_JPRB,1.3260E+01_JPRB/)
KBO( :, 5,49,11) = (/&
&6.3293E-01_JPRB,6.3285E-01_JPRB,4.7905E+00_JPRB,8.1418E+00_JPRB,1.1253E+01_JPRB,1.3527E+01_JPRB/)
KBO( :, 1,50,11) = (/&
&2.8508E-01_JPRB,2.8546E-01_JPRB,4.0216E+00_JPRB,7.1533E+00_JPRB,9.9242E+00_JPRB,1.0908E+01_JPRB/)
KBO( :, 2,50,11) = (/&
&3.4378E-01_JPRB,3.4406E-01_JPRB,4.2684E+00_JPRB,7.5560E+00_JPRB,1.0485E+01_JPRB,1.1896E+01_JPRB/)
KBO( :, 3,50,11) = (/&
&4.1407E-01_JPRB,4.1424E-01_JPRB,4.4746E+00_JPRB,7.8430E+00_JPRB,1.0882E+01_JPRB,1.2647E+01_JPRB/)
KBO( :, 4,50,11) = (/&
&4.9363E-01_JPRB,4.9370E-01_JPRB,4.6366E+00_JPRB,8.0253E+00_JPRB,1.1126E+01_JPRB,1.3186E+01_JPRB/)
KBO( :, 5,50,11) = (/&
&5.8619E-01_JPRB,5.8614E-01_JPRB,4.7566E+00_JPRB,8.1231E+00_JPRB,1.1244E+01_JPRB,1.3516E+01_JPRB/)
KBO( :, 1,51,11) = (/&
&2.5326E-01_JPRB,2.5365E-01_JPRB,3.9197E+00_JPRB,6.9713E+00_JPRB,9.6644E+00_JPRB,1.0563E+01_JPRB/)
KBO( :, 2,51,11) = (/&
&3.0874E-01_JPRB,3.0902E-01_JPRB,4.1778E+00_JPRB,7.4188E+00_JPRB,1.0300E+01_JPRB,1.1619E+01_JPRB/)
KBO( :, 3,51,11) = (/&
&3.7711E-01_JPRB,3.7728E-01_JPRB,4.4030E+00_JPRB,7.7505E+00_JPRB,1.0757E+01_JPRB,1.2466E+01_JPRB/)
KBO( :, 4,51,11) = (/&
&4.5549E-01_JPRB,4.5558E-01_JPRB,4.5816E+00_JPRB,7.9699E+00_JPRB,1.1056E+01_JPRB,1.3074E+01_JPRB/)
KBO( :, 5,51,11) = (/&
&5.4422E-01_JPRB,5.4419E-01_JPRB,4.7173E+00_JPRB,8.0963E+00_JPRB,1.1218E+01_JPRB,1.3472E+01_JPRB/)
KBO( :, 1,52,11) = (/&
&2.2461E-01_JPRB,2.2501E-01_JPRB,3.8110E+00_JPRB,6.7727E+00_JPRB,9.3780E+00_JPRB,1.0204E+01_JPRB/)
KBO( :, 2,52,11) = (/&
&2.7696E-01_JPRB,2.7724E-01_JPRB,4.0846E+00_JPRB,7.2661E+00_JPRB,1.0090E+01_JPRB,1.1325E+01_JPRB/)
KBO( :, 3,52,11) = (/&
&3.4251E-01_JPRB,3.4273E-01_JPRB,4.3258E+00_JPRB,7.6413E+00_JPRB,1.0608E+01_JPRB,1.2266E+01_JPRB/)
KBO( :, 4,52,11) = (/&
&4.1924E-01_JPRB,4.1934E-01_JPRB,4.5215E+00_JPRB,7.9004E+00_JPRB,1.0966E+01_JPRB,1.2948E+01_JPRB/)
KBO( :, 5,52,11) = (/&
&5.0516E-01_JPRB,5.0516E-01_JPRB,4.6729E+00_JPRB,8.0607E+00_JPRB,1.1176E+01_JPRB,1.3418E+01_JPRB/)
KBO( :, 1,53,11) = (/&
&1.9876E-01_JPRB,1.9925E-01_JPRB,3.6957E+00_JPRB,6.5526E+00_JPRB,9.0627E+00_JPRB,9.8215E+00_JPRB/)
KBO( :, 2,53,11) = (/&
&2.4812E-01_JPRB,2.4842E-01_JPRB,3.9863E+00_JPRB,7.0970E+00_JPRB,9.8501E+00_JPRB,1.1018E+01_JPRB/)
KBO( :, 3,53,11) = (/&
&3.1019E-01_JPRB,3.1042E-01_JPRB,4.2400E+00_JPRB,7.5167E+00_JPRB,1.0436E+01_JPRB,1.2052E+01_JPRB/)
KBO( :, 4,53,11) = (/&
&3.8453E-01_JPRB,3.8465E-01_JPRB,4.4543E+00_JPRB,7.8181E+00_JPRB,1.0855E+01_JPRB,1.2811E+01_JPRB/)
KBO( :, 5,53,11) = (/&
&4.6824E-01_JPRB,4.6827E-01_JPRB,4.6221E+00_JPRB,8.0127E+00_JPRB,1.1114E+01_JPRB,1.3357E+01_JPRB/)
KBO( :, 1,54,11) = (/&
&1.7658E-01_JPRB,1.7738E-01_JPRB,3.5830E+00_JPRB,6.3331E+00_JPRB,8.7501E+00_JPRB,9.3830E+00_JPRB/)
KBO( :, 2,54,11) = (/&
&2.2311E-01_JPRB,2.2343E-01_JPRB,3.8924E+00_JPRB,6.9272E+00_JPRB,9.6066E+00_JPRB,1.0637E+01_JPRB/)
KBO( :, 3,54,11) = (/&
&2.8225E-01_JPRB,2.8249E-01_JPRB,4.1567E+00_JPRB,7.3875E+00_JPRB,1.0262E+01_JPRB,1.1745E+01_JPRB/)
KBO( :, 4,54,11) = (/&
&3.5407E-01_JPRB,3.5420E-01_JPRB,4.3869E+00_JPRB,7.7293E+00_JPRB,1.0733E+01_JPRB,1.2587E+01_JPRB/)
KBO( :, 5,54,11) = (/&
&4.3599E-01_JPRB,4.3605E-01_JPRB,4.5705E+00_JPRB,7.9578E+00_JPRB,1.1045E+01_JPRB,1.3213E+01_JPRB/)
KBO( :, 1,55,11) = (/&
&1.5693E-01_JPRB,1.5821E-01_JPRB,3.4683E+00_JPRB,6.1089E+00_JPRB,8.4282E+00_JPRB,8.9090E+00_JPRB/)
KBO( :, 2,55,11) = (/&
&2.0085E-01_JPRB,2.0128E-01_JPRB,3.7963E+00_JPRB,6.7515E+00_JPRB,9.3517E+00_JPRB,1.0215E+01_JPRB/)
KBO( :, 3,55,11) = (/&
&2.5734E-01_JPRB,2.5756E-01_JPRB,4.0737E+00_JPRB,7.2511E+00_JPRB,1.0072E+01_JPRB,1.1362E+01_JPRB/)
KBO( :, 4,55,11) = (/&
&3.2630E-01_JPRB,3.2643E-01_JPRB,4.3183E+00_JPRB,7.6321E+00_JPRB,1.0598E+01_JPRB,1.2305E+01_JPRB/)
KBO( :, 5,55,11) = (/&
&4.0605E-01_JPRB,4.0612E-01_JPRB,4.5166E+00_JPRB,7.8950E+00_JPRB,1.0962E+01_JPRB,1.2994E+01_JPRB/)
KBO( :, 1,56,11) = (/&
&1.3887E-01_JPRB,1.4103E-01_JPRB,3.3452E+00_JPRB,5.8712E+00_JPRB,8.0833E+00_JPRB,8.4282E+00_JPRB/)
KBO( :, 2,56,11) = (/&
&1.8055E-01_JPRB,1.8122E-01_JPRB,3.6957E+00_JPRB,6.5591E+00_JPRB,9.0757E+00_JPRB,9.7805E+00_JPRB/)
KBO( :, 3,56,11) = (/&
&2.3436E-01_JPRB,2.3458E-01_JPRB,3.9878E+00_JPRB,7.1027E+00_JPRB,9.8624E+00_JPRB,1.0961E+01_JPRB/)
KBO( :, 4,56,11) = (/&
&2.9996E-01_JPRB,3.0009E-01_JPRB,4.2431E+00_JPRB,7.5221E+00_JPRB,1.0447E+01_JPRB,1.1989E+01_JPRB/)
KBO( :, 5,56,11) = (/&
&3.7712E-01_JPRB,3.7719E-01_JPRB,4.4577E+00_JPRB,7.8227E+00_JPRB,1.0864E+01_JPRB,1.2750E+01_JPRB/)
KBO( :, 1,57,11) = (/&
&1.2231E-01_JPRB,1.2572E-01_JPRB,3.2149E+00_JPRB,5.6195E+00_JPRB,7.7189E+00_JPRB,7.9409E+00_JPRB/)
KBO( :, 2,57,11) = (/&
&1.6188E-01_JPRB,1.6303E-01_JPRB,3.5895E+00_JPRB,6.3509E+00_JPRB,8.7789E+00_JPRB,9.3239E+00_JPRB/)
KBO( :, 3,57,11) = (/&
&2.1281E-01_JPRB,2.1309E-01_JPRB,3.8984E+00_JPRB,6.9426E+00_JPRB,9.6313E+00_JPRB,1.0551E+01_JPRB/)
KBO( :, 4,57,11) = (/&
&2.7533E-01_JPRB,2.7549E-01_JPRB,4.1635E+00_JPRB,7.3997E+00_JPRB,1.0280E+01_JPRB,1.1629E+01_JPRB/)
KBO( :, 5,57,11) = (/&
&3.4953E-01_JPRB,3.4962E-01_JPRB,4.3933E+00_JPRB,7.7390E+00_JPRB,1.0749E+01_JPRB,1.2483E+01_JPRB/)
KBO( :, 1,58,11) = (/&
&1.0753E-01_JPRB,1.1255E-01_JPRB,3.0845E+00_JPRB,5.3675E+00_JPRB,7.3519E+00_JPRB,7.4714E+00_JPRB/)
KBO( :, 2,58,11) = (/&
&1.4527E-01_JPRB,1.4713E-01_JPRB,3.4823E+00_JPRB,6.1407E+00_JPRB,8.4780E+00_JPRB,8.8781E+00_JPRB/)
KBO( :, 3,58,11) = (/&
&1.9346E-01_JPRB,1.9393E-01_JPRB,3.8086E+00_JPRB,6.7779E+00_JPRB,9.3926E+00_JPRB,1.0139E+01_JPRB/)
KBO( :, 4,58,11) = (/&
&2.5331E-01_JPRB,2.5345E-01_JPRB,4.0858E+00_JPRB,7.2725E+00_JPRB,1.0104E+01_JPRB,1.1238E+01_JPRB/)
KBO( :, 5,58,11) = (/&
&3.2441E-01_JPRB,3.2451E-01_JPRB,4.3290E+00_JPRB,7.6484E+00_JPRB,1.0623E+01_JPRB,1.2180E+01_JPRB/)
KBO( :, 1,59,11) = (/&
&9.9614E-02_JPRB,1.0577E-01_JPRB,3.0288E+00_JPRB,5.2610E+00_JPRB,7.1978E+00_JPRB,7.2394E+00_JPRB/)
KBO( :, 2,59,11) = (/&
&1.3736E-01_JPRB,1.3969E-01_JPRB,3.4366E+00_JPRB,6.0532E+00_JPRB,8.3509E+00_JPRB,8.6179E+00_JPRB/)
KBO( :, 3,59,11) = (/&
&1.8506E-01_JPRB,1.8566E-01_JPRB,3.7708E+00_JPRB,6.7076E+00_JPRB,9.2912E+00_JPRB,9.8422E+00_JPRB/)
KBO( :, 4,59,11) = (/&
&2.4408E-01_JPRB,2.4421E-01_JPRB,4.0531E+00_JPRB,7.2180E+00_JPRB,1.0029E+01_JPRB,1.0900E+01_JPRB/)
KBO( :, 5,59,11) = (/&
&3.1395E-01_JPRB,3.1406E-01_JPRB,4.3016E+00_JPRB,7.6085E+00_JPRB,1.0568E+01_JPRB,1.1809E+01_JPRB/)
KBO( :, 1,13,12) = (/&
&1.5071E+01_JPRB,1.5062E+01_JPRB,1.1553E+01_JPRB,8.0422E+00_JPRB,5.1775E+00_JPRB,4.4276E+00_JPRB/)
KBO( :, 2,13,12) = (/&
&1.5045E+01_JPRB,1.5037E+01_JPRB,1.1523E+01_JPRB,8.0068E+00_JPRB,5.0603E+00_JPRB,4.3468E+00_JPRB/)
KBO( :, 3,13,12) = (/&
&1.4932E+01_JPRB,1.4924E+01_JPRB,1.1428E+01_JPRB,7.9305E+00_JPRB,4.9434E+00_JPRB,4.2743E+00_JPRB/)
KBO( :, 4,13,12) = (/&
&1.4793E+01_JPRB,1.4785E+01_JPRB,1.1318E+01_JPRB,7.8509E+00_JPRB,4.8345E+00_JPRB,4.2338E+00_JPRB/)
KBO( :, 5,13,12) = (/&
&1.4616E+01_JPRB,1.4607E+01_JPRB,1.1172E+01_JPRB,7.7373E+00_JPRB,4.7181E+00_JPRB,4.2382E+00_JPRB/)
KBO( :, 1,14,12) = (/&
&1.6109E+01_JPRB,1.6100E+01_JPRB,1.2313E+01_JPRB,8.5158E+00_JPRB,5.5307E+00_JPRB,4.8392E+00_JPRB/)
KBO( :, 2,14,12) = (/&
&1.6026E+01_JPRB,1.6017E+01_JPRB,1.2244E+01_JPRB,8.4632E+00_JPRB,5.4108E+00_JPRB,4.7399E+00_JPRB/)
KBO( :, 3,14,12) = (/&
&1.5874E+01_JPRB,1.5865E+01_JPRB,1.2127E+01_JPRB,8.3786E+00_JPRB,5.2843E+00_JPRB,4.6480E+00_JPRB/)
KBO( :, 4,14,12) = (/&
&1.5690E+01_JPRB,1.5681E+01_JPRB,1.1982E+01_JPRB,8.2687E+00_JPRB,5.1442E+00_JPRB,4.5663E+00_JPRB/)
KBO( :, 5,14,12) = (/&
&1.5467E+01_JPRB,1.5458E+01_JPRB,1.1810E+01_JPRB,8.1473E+00_JPRB,5.0031E+00_JPRB,4.5067E+00_JPRB/)
KBO( :, 1,15,12) = (/&
&1.6950E+01_JPRB,1.6940E+01_JPRB,1.2936E+01_JPRB,8.9243E+00_JPRB,5.9139E+00_JPRB,5.3392E+00_JPRB/)
KBO( :, 2,15,12) = (/&
&1.6795E+01_JPRB,1.6786E+01_JPRB,1.2817E+01_JPRB,8.8403E+00_JPRB,5.7728E+00_JPRB,5.2173E+00_JPRB/)
KBO( :, 3,15,12) = (/&
&1.6618E+01_JPRB,1.6608E+01_JPRB,1.2675E+01_JPRB,8.7335E+00_JPRB,5.6294E+00_JPRB,5.1076E+00_JPRB/)
KBO( :, 4,15,12) = (/&
&1.6363E+01_JPRB,1.6354E+01_JPRB,1.2477E+01_JPRB,8.5926E+00_JPRB,5.4844E+00_JPRB,5.0174E+00_JPRB/)
KBO( :, 5,15,12) = (/&
&1.6071E+01_JPRB,1.6061E+01_JPRB,1.2263E+01_JPRB,8.4516E+00_JPRB,5.3505E+00_JPRB,4.9217E+00_JPRB/)
KBO( :, 1,16,12) = (/&
&1.7483E+01_JPRB,1.7473E+01_JPRB,1.3331E+01_JPRB,9.1930E+00_JPRB,6.3135E+00_JPRB,5.9094E+00_JPRB/)
KBO( :, 2,16,12) = (/&
&1.7265E+01_JPRB,1.7255E+01_JPRB,1.3158E+01_JPRB,9.0640E+00_JPRB,6.1752E+00_JPRB,5.7636E+00_JPRB/)
KBO( :, 3,16,12) = (/&
&1.7001E+01_JPRB,1.6992E+01_JPRB,1.2961E+01_JPRB,8.9272E+00_JPRB,6.0421E+00_JPRB,5.6420E+00_JPRB/)
KBO( :, 4,16,12) = (/&
&1.6715E+01_JPRB,1.6706E+01_JPRB,1.2750E+01_JPRB,8.7873E+00_JPRB,5.9067E+00_JPRB,5.5250E+00_JPRB/)
KBO( :, 5,16,12) = (/&
&1.6400E+01_JPRB,1.6391E+01_JPRB,1.2509E+01_JPRB,8.6238E+00_JPRB,5.7670E+00_JPRB,5.4408E+00_JPRB/)
KBO( :, 1,17,12) = (/&
&1.7611E+01_JPRB,1.7601E+01_JPRB,1.3423E+01_JPRB,9.2865E+00_JPRB,6.8286E+00_JPRB,6.5192E+00_JPRB/)
KBO( :, 2,17,12) = (/&
&1.7351E+01_JPRB,1.7341E+01_JPRB,1.3231E+01_JPRB,9.1506E+00_JPRB,6.6893E+00_JPRB,6.3748E+00_JPRB/)
KBO( :, 3,17,12) = (/&
&1.7056E+01_JPRB,1.7047E+01_JPRB,1.3013E+01_JPRB,9.0104E+00_JPRB,6.5437E+00_JPRB,6.2526E+00_JPRB/)
KBO( :, 4,17,12) = (/&
&1.6747E+01_JPRB,1.6738E+01_JPRB,1.2778E+01_JPRB,8.8490E+00_JPRB,6.3936E+00_JPRB,6.1321E+00_JPRB/)
KBO( :, 5,17,12) = (/&
&1.6425E+01_JPRB,1.6416E+01_JPRB,1.2531E+01_JPRB,8.6800E+00_JPRB,6.2394E+00_JPRB,6.0341E+00_JPRB/)
KBO( :, 1,18,12) = (/&
&1.7373E+01_JPRB,1.7363E+01_JPRB,1.3259E+01_JPRB,9.2987E+00_JPRB,7.4434E+00_JPRB,7.1986E+00_JPRB/)
KBO( :, 2,18,12) = (/&
&1.7075E+01_JPRB,1.7065E+01_JPRB,1.3035E+01_JPRB,9.1492E+00_JPRB,7.2871E+00_JPRB,7.0606E+00_JPRB/)
KBO( :, 3,18,12) = (/&
&1.6756E+01_JPRB,1.6747E+01_JPRB,1.2796E+01_JPRB,8.9869E+00_JPRB,7.1229E+00_JPRB,6.9365E+00_JPRB/)
KBO( :, 4,18,12) = (/&
&1.6448E+01_JPRB,1.6438E+01_JPRB,1.2559E+01_JPRB,8.8102E+00_JPRB,6.9614E+00_JPRB,6.7953E+00_JPRB/)
KBO( :, 5,18,12) = (/&
&1.6127E+01_JPRB,1.6118E+01_JPRB,1.2311E+01_JPRB,8.6284E+00_JPRB,6.8009E+00_JPRB,6.6712E+00_JPRB/)
KBO( :, 1,19,12) = (/&
&1.6746E+01_JPRB,1.6736E+01_JPRB,1.2803E+01_JPRB,9.3167E+00_JPRB,8.0934E+00_JPRB,7.9604E+00_JPRB/)
KBO( :, 2,19,12) = (/&
&1.6435E+01_JPRB,1.6426E+01_JPRB,1.2567E+01_JPRB,9.1426E+00_JPRB,7.9243E+00_JPRB,7.8083E+00_JPRB/)
KBO( :, 3,19,12) = (/&
&1.6123E+01_JPRB,1.6114E+01_JPRB,1.2329E+01_JPRB,8.9518E+00_JPRB,7.7527E+00_JPRB,7.6627E+00_JPRB/)
KBO( :, 4,19,12) = (/&
&1.5818E+01_JPRB,1.5809E+01_JPRB,1.2094E+01_JPRB,8.7559E+00_JPRB,7.5782E+00_JPRB,7.5080E+00_JPRB/)
KBO( :, 5,19,12) = (/&
&1.5498E+01_JPRB,1.5490E+01_JPRB,1.1845E+01_JPRB,8.5563E+00_JPRB,7.3997E+00_JPRB,7.3552E+00_JPRB/)
KBO( :, 1,20,12) = (/&
&1.5808E+01_JPRB,1.5799E+01_JPRB,1.2109E+01_JPRB,9.3560E+00_JPRB,8.7540E+00_JPRB,8.7978E+00_JPRB/)
KBO( :, 2,20,12) = (/&
&1.5503E+01_JPRB,1.5494E+01_JPRB,1.1873E+01_JPRB,9.1479E+00_JPRB,8.5752E+00_JPRB,8.6307E+00_JPRB/)
KBO( :, 3,20,12) = (/&
&1.5194E+01_JPRB,1.5185E+01_JPRB,1.1636E+01_JPRB,8.9392E+00_JPRB,8.3955E+00_JPRB,8.4731E+00_JPRB/)
KBO( :, 4,20,12) = (/&
&1.4894E+01_JPRB,1.4886E+01_JPRB,1.1403E+01_JPRB,8.7296E+00_JPRB,8.2170E+00_JPRB,8.2989E+00_JPRB/)
KBO( :, 5,20,12) = (/&
&1.4572E+01_JPRB,1.4563E+01_JPRB,1.1152E+01_JPRB,8.5115E+00_JPRB,8.0382E+00_JPRB,8.1214E+00_JPRB/)
KBO( :, 1,21,12) = (/&
&1.4618E+01_JPRB,1.4609E+01_JPRB,1.1224E+01_JPRB,9.4749E+00_JPRB,9.4674E+00_JPRB,9.7176E+00_JPRB/)
KBO( :, 2,21,12) = (/&
&1.4320E+01_JPRB,1.4312E+01_JPRB,1.0993E+01_JPRB,9.2613E+00_JPRB,9.2871E+00_JPRB,9.5392E+00_JPRB/)
KBO( :, 3,21,12) = (/&
&1.4030E+01_JPRB,1.4022E+01_JPRB,1.0770E+01_JPRB,9.0451E+00_JPRB,9.1076E+00_JPRB,9.3604E+00_JPRB/)
KBO( :, 4,21,12) = (/&
&1.3731E+01_JPRB,1.3724E+01_JPRB,1.0538E+01_JPRB,8.8193E+00_JPRB,8.9189E+00_JPRB,9.1661E+00_JPRB/)
KBO( :, 5,21,12) = (/&
&1.3412E+01_JPRB,1.3405E+01_JPRB,1.0288E+01_JPRB,8.5978E+00_JPRB,8.7269E+00_JPRB,8.9634E+00_JPRB/)
KBO( :, 1,22,12) = (/&
&1.3252E+01_JPRB,1.3245E+01_JPRB,1.0263E+01_JPRB,9.6884E+00_JPRB,1.0237E+01_JPRB,1.0659E+01_JPRB/)
KBO( :, 2,22,12) = (/&
&1.2974E+01_JPRB,1.2967E+01_JPRB,1.0045E+01_JPRB,9.4635E+00_JPRB,1.0051E+01_JPRB,1.0470E+01_JPRB/)
KBO( :, 3,22,12) = (/&
&1.2686E+01_JPRB,1.2679E+01_JPRB,9.8204E+00_JPRB,9.2336E+00_JPRB,9.8532E+00_JPRB,1.0276E+01_JPRB/)
KBO( :, 4,22,12) = (/&
&1.2392E+01_JPRB,1.2385E+01_JPRB,9.5853E+00_JPRB,9.0077E+00_JPRB,9.6460E+00_JPRB,1.0057E+01_JPRB/)
KBO( :, 5,22,12) = (/&
&1.2080E+01_JPRB,1.2073E+01_JPRB,9.3373E+00_JPRB,8.7763E+00_JPRB,9.4290E+00_JPRB,9.8257E+00_JPRB/)
KBO( :, 1,23,12) = (/&
&1.1802E+01_JPRB,1.1796E+01_JPRB,9.3955E+00_JPRB,9.9793E+00_JPRB,1.1071E+01_JPRB,1.1590E+01_JPRB/)
KBO( :, 2,23,12) = (/&
&1.1532E+01_JPRB,1.1526E+01_JPRB,9.1740E+00_JPRB,9.7510E+00_JPRB,1.0853E+01_JPRB,1.1387E+01_JPRB/)
KBO( :, 3,23,12) = (/&
&1.1254E+01_JPRB,1.1248E+01_JPRB,8.9457E+00_JPRB,9.5279E+00_JPRB,1.0621E+01_JPRB,1.1176E+01_JPRB/)
KBO( :, 4,23,12) = (/&
&1.0971E+01_JPRB,1.0965E+01_JPRB,8.7049E+00_JPRB,9.2947E+00_JPRB,1.0373E+01_JPRB,1.0939E+01_JPRB/)
KBO( :, 5,23,12) = (/&
&1.0694E+01_JPRB,1.0688E+01_JPRB,8.4691E+00_JPRB,9.0520E+00_JPRB,1.0118E+01_JPRB,1.0692E+01_JPRB/)
KBO( :, 1,24,12) = (/&
&1.0339E+01_JPRB,1.0334E+01_JPRB,8.7416E+00_JPRB,1.0311E+01_JPRB,1.1869E+01_JPRB,1.2496E+01_JPRB/)
KBO( :, 2,24,12) = (/&
&1.0079E+01_JPRB,1.0074E+01_JPRB,8.5118E+00_JPRB,1.0085E+01_JPRB,1.1623E+01_JPRB,1.2266E+01_JPRB/)
KBO( :, 3,24,12) = (/&
&9.8237E+00_JPRB,9.8183E+00_JPRB,8.2739E+00_JPRB,9.8502E+00_JPRB,1.1362E+01_JPRB,1.2041E+01_JPRB/)
KBO( :, 4,24,12) = (/&
&9.5837E+00_JPRB,9.5785E+00_JPRB,8.0352E+00_JPRB,9.6060E+00_JPRB,1.1087E+01_JPRB,1.1795E+01_JPRB/)
KBO( :, 5,24,12) = (/&
&9.4022E+00_JPRB,9.3971E+00_JPRB,7.8130E+00_JPRB,9.3488E+00_JPRB,1.0802E+01_JPRB,1.1530E+01_JPRB/)
KBO( :, 1,25,12) = (/&
&8.9159E+00_JPRB,8.9112E+00_JPRB,8.3253E+00_JPRB,1.0680E+01_JPRB,1.2624E+01_JPRB,1.3349E+01_JPRB/)
KBO( :, 2,25,12) = (/&
&8.6856E+00_JPRB,8.6810E+00_JPRB,8.0901E+00_JPRB,1.0434E+01_JPRB,1.2357E+01_JPRB,1.3117E+01_JPRB/)
KBO( :, 3,25,12) = (/&
&8.4955E+00_JPRB,8.4909E+00_JPRB,7.8520E+00_JPRB,1.0179E+01_JPRB,1.2070E+01_JPRB,1.2889E+01_JPRB/)
KBO( :, 4,25,12) = (/&
&8.3669E+00_JPRB,8.3624E+00_JPRB,7.6206E+00_JPRB,9.9074E+00_JPRB,1.1769E+01_JPRB,1.2627E+01_JPRB/)
KBO( :, 5,25,12) = (/&
&8.2951E+00_JPRB,8.2906E+00_JPRB,7.4263E+00_JPRB,9.6322E+00_JPRB,1.1459E+01_JPRB,1.2339E+01_JPRB/)
KBO( :, 1,26,12) = (/&
&7.5918E+00_JPRB,7.5878E+00_JPRB,8.0448E+00_JPRB,1.1047E+01_JPRB,1.3308E+01_JPRB,1.4181E+01_JPRB/)
KBO( :, 2,26,12) = (/&
&7.4417E+00_JPRB,7.4378E+00_JPRB,7.8118E+00_JPRB,1.0782E+01_JPRB,1.3032E+01_JPRB,1.3946E+01_JPRB/)
KBO( :, 3,26,12) = (/&
&7.3590E+00_JPRB,7.3551E+00_JPRB,7.5780E+00_JPRB,1.0497E+01_JPRB,1.2721E+01_JPRB,1.3696E+01_JPRB/)
KBO( :, 4,26,12) = (/&
&7.3502E+00_JPRB,7.3462E+00_JPRB,7.3714E+00_JPRB,1.0203E+01_JPRB,1.2399E+01_JPRB,1.3409E+01_JPRB/)
KBO( :, 5,26,12) = (/&
&7.4276E+00_JPRB,7.4236E+00_JPRB,7.2173E+00_JPRB,9.8998E+00_JPRB,1.2064E+01_JPRB,1.3105E+01_JPRB/)
KBO( :, 1,27,12) = (/&
&6.4683E+00_JPRB,6.4649E+00_JPRB,7.8812E+00_JPRB,1.1375E+01_JPRB,1.3927E+01_JPRB,1.4966E+01_JPRB/)
KBO( :, 2,27,12) = (/&
&6.4189E+00_JPRB,6.4156E+00_JPRB,7.6472E+00_JPRB,1.1088E+01_JPRB,1.3638E+01_JPRB,1.4716E+01_JPRB/)
KBO( :, 3,27,12) = (/&
&6.4591E+00_JPRB,6.4557E+00_JPRB,7.4245E+00_JPRB,1.0785E+01_JPRB,1.3326E+01_JPRB,1.4451E+01_JPRB/)
KBO( :, 4,27,12) = (/&
&6.5895E+00_JPRB,6.5861E+00_JPRB,7.2540E+00_JPRB,1.0466E+01_JPRB,1.2988E+01_JPRB,1.4141E+01_JPRB/)
KBO( :, 5,27,12) = (/&
&6.7673E+00_JPRB,6.7638E+00_JPRB,7.1253E+00_JPRB,1.0145E+01_JPRB,1.2630E+01_JPRB,1.3805E+01_JPRB/)
KBO( :, 1,28,12) = (/&
&5.5812E+00_JPRB,5.5783E+00_JPRB,7.7689E+00_JPRB,1.1658E+01_JPRB,1.4504E+01_JPRB,1.5676E+01_JPRB/)
KBO( :, 2,28,12) = (/&
&5.6494E+00_JPRB,5.6465E+00_JPRB,7.5324E+00_JPRB,1.1356E+01_JPRB,1.4208E+01_JPRB,1.5420E+01_JPRB/)
KBO( :, 3,28,12) = (/&
&5.8063E+00_JPRB,5.8033E+00_JPRB,7.3350E+00_JPRB,1.1035E+01_JPRB,1.3883E+01_JPRB,1.5136E+01_JPRB/)
KBO( :, 4,28,12) = (/&
&5.9982E+00_JPRB,5.9952E+00_JPRB,7.1895E+00_JPRB,1.0705E+01_JPRB,1.3523E+01_JPRB,1.4796E+01_JPRB/)
KBO( :, 5,28,12) = (/&
&6.2275E+00_JPRB,6.2243E+00_JPRB,7.0847E+00_JPRB,1.0363E+01_JPRB,1.3144E+01_JPRB,1.4440E+01_JPRB/)
KBO( :, 1,29,12) = (/&
&4.9263E+00_JPRB,4.9239E+00_JPRB,7.6738E+00_JPRB,1.1886E+01_JPRB,1.5034E+01_JPRB,1.6303E+01_JPRB/)
KBO( :, 2,29,12) = (/&
&5.0905E+00_JPRB,5.0880E+00_JPRB,7.4511E+00_JPRB,1.1577E+01_JPRB,1.4725E+01_JPRB,1.6056E+01_JPRB/)
KBO( :, 3,29,12) = (/&
&5.2910E+00_JPRB,5.2884E+00_JPRB,7.2824E+00_JPRB,1.1245E+01_JPRB,1.4371E+01_JPRB,1.5737E+01_JPRB/)
KBO( :, 4,29,12) = (/&
&5.5388E+00_JPRB,5.5361E+00_JPRB,7.1566E+00_JPRB,1.0903E+01_JPRB,1.3995E+01_JPRB,1.5373E+01_JPRB/)
KBO( :, 5,29,12) = (/&
&5.8140E+00_JPRB,5.8111E+00_JPRB,7.0642E+00_JPRB,1.0551E+01_JPRB,1.3590E+01_JPRB,1.5023E+01_JPRB/)
KBO( :, 1,30,12) = (/&
&4.4481E+00_JPRB,4.4460E+00_JPRB,7.5927E+00_JPRB,1.2072E+01_JPRB,1.5506E+01_JPRB,1.6872E+01_JPRB/)
KBO( :, 2,30,12) = (/&
&4.6495E+00_JPRB,4.6473E+00_JPRB,7.3991E+00_JPRB,1.1764E+01_JPRB,1.5173E+01_JPRB,1.6609E+01_JPRB/)
KBO( :, 3,30,12) = (/&
&4.9026E+00_JPRB,4.9003E+00_JPRB,7.2499E+00_JPRB,1.1426E+01_JPRB,1.4795E+01_JPRB,1.6261E+01_JPRB/)
KBO( :, 4,30,12) = (/&
&5.1748E+00_JPRB,5.1723E+00_JPRB,7.1402E+00_JPRB,1.1073E+01_JPRB,1.4399E+01_JPRB,1.5886E+01_JPRB/)
KBO( :, 5,30,12) = (/&
&5.4669E+00_JPRB,5.4641E+00_JPRB,7.0513E+00_JPRB,1.0712E+01_JPRB,1.3969E+01_JPRB,1.5546E+01_JPRB/)
KBO( :, 1,31,12) = (/&
&4.0826E+00_JPRB,4.0808E+00_JPRB,7.5248E+00_JPRB,1.2230E+01_JPRB,1.5909E+01_JPRB,1.7372E+01_JPRB/)
KBO( :, 2,31,12) = (/&
&4.3203E+00_JPRB,4.3184E+00_JPRB,7.3583E+00_JPRB,1.1921E+01_JPRB,1.5546E+01_JPRB,1.7073E+01_JPRB/)
KBO( :, 3,31,12) = (/&
&4.5820E+00_JPRB,4.5799E+00_JPRB,7.2311E+00_JPRB,1.1577E+01_JPRB,1.5153E+01_JPRB,1.6713E+01_JPRB/)
KBO( :, 4,31,12) = (/&
&4.8695E+00_JPRB,4.8672E+00_JPRB,7.1286E+00_JPRB,1.1212E+01_JPRB,1.4724E+01_JPRB,1.6381E+01_JPRB/)
KBO( :, 5,31,12) = (/&
&5.1816E+00_JPRB,5.1790E+00_JPRB,7.0469E+00_JPRB,1.0847E+01_JPRB,1.4274E+01_JPRB,1.6048E+01_JPRB/)
KBO( :, 1,32,12) = (/&
&3.7968E+00_JPRB,3.7952E+00_JPRB,7.4739E+00_JPRB,1.2361E+01_JPRB,1.6239E+01_JPRB,1.7800E+01_JPRB/)
KBO( :, 2,32,12) = (/&
&4.0447E+00_JPRB,4.0430E+00_JPRB,7.3338E+00_JPRB,1.2050E+01_JPRB,1.5855E+01_JPRB,1.7484E+01_JPRB/)
KBO( :, 3,32,12) = (/&
&4.3179E+00_JPRB,4.3159E+00_JPRB,7.2183E+00_JPRB,1.1702E+01_JPRB,1.5442E+01_JPRB,1.7161E+01_JPRB/)
KBO( :, 4,32,12) = (/&
&4.6213E+00_JPRB,4.6191E+00_JPRB,7.1240E+00_JPRB,1.1329E+01_JPRB,1.4991E+01_JPRB,1.6858E+01_JPRB/)
KBO( :, 5,32,12) = (/&
&4.9485E+00_JPRB,4.9460E+00_JPRB,7.0483E+00_JPRB,1.0954E+01_JPRB,1.4516E+01_JPRB,1.6491E+01_JPRB/)
KBO( :, 1,33,12) = (/&
&3.5568E+00_JPRB,3.5554E+00_JPRB,7.4337E+00_JPRB,1.2471E+01_JPRB,1.6507E+01_JPRB,1.8167E+01_JPRB/)
KBO( :, 2,33,12) = (/&
&3.8191E+00_JPRB,3.8174E+00_JPRB,7.3162E+00_JPRB,1.2150E+01_JPRB,1.6107E+01_JPRB,1.7878E+01_JPRB/)
KBO( :, 3,33,12) = (/&
&4.1081E+00_JPRB,4.1061E+00_JPRB,7.2154E+00_JPRB,1.1795E+01_JPRB,1.5670E+01_JPRB,1.7617E+01_JPRB/)
KBO( :, 4,33,12) = (/&
&4.4244E+00_JPRB,4.4223E+00_JPRB,7.1305E+00_JPRB,1.1413E+01_JPRB,1.5196E+01_JPRB,1.7282E+01_JPRB/)
KBO( :, 5,33,12) = (/&
&4.7677E+00_JPRB,4.7653E+00_JPRB,7.0542E+00_JPRB,1.1036E+01_JPRB,1.4698E+01_JPRB,1.6888E+01_JPRB/)
KBO( :, 1,34,12) = (/&
&3.3521E+00_JPRB,3.3507E+00_JPRB,7.4128E+00_JPRB,1.2559E+01_JPRB,1.6734E+01_JPRB,1.8506E+01_JPRB/)
KBO( :, 2,34,12) = (/&
&3.6291E+00_JPRB,3.6275E+00_JPRB,7.3128E+00_JPRB,1.2232E+01_JPRB,1.6317E+01_JPRB,1.8280E+01_JPRB/)
KBO( :, 3,34,12) = (/&
&3.9317E+00_JPRB,3.9298E+00_JPRB,7.2212E+00_JPRB,1.1872E+01_JPRB,1.5854E+01_JPRB,1.8005E+01_JPRB/)
KBO( :, 4,34,12) = (/&
&4.2593E+00_JPRB,4.2572E+00_JPRB,7.1423E+00_JPRB,1.1481E+01_JPRB,1.5360E+01_JPRB,1.7643E+01_JPRB/)
KBO( :, 5,34,12) = (/&
&4.6153E+00_JPRB,4.6130E+00_JPRB,7.0650E+00_JPRB,1.1105E+01_JPRB,1.4842E+01_JPRB,1.7226E+01_JPRB/)
KBO( :, 1,35,12) = (/&
&3.1598E+00_JPRB,3.1585E+00_JPRB,7.4142E+00_JPRB,1.2657E+01_JPRB,1.6945E+01_JPRB,1.8872E+01_JPRB/)
KBO( :, 2,35,12) = (/&
&3.4442E+00_JPRB,3.4427E+00_JPRB,7.3257E+00_JPRB,1.2327E+01_JPRB,1.6516E+01_JPRB,1.8673E+01_JPRB/)
KBO( :, 3,35,12) = (/&
&3.7587E+00_JPRB,3.7569E+00_JPRB,7.2409E+00_JPRB,1.1960E+01_JPRB,1.6036E+01_JPRB,1.8373E+01_JPRB/)
KBO( :, 4,35,12) = (/&
&4.0964E+00_JPRB,4.0944E+00_JPRB,7.1633E+00_JPRB,1.1567E+01_JPRB,1.5526E+01_JPRB,1.7979E+01_JPRB/)
KBO( :, 5,35,12) = (/&
&4.4686E+00_JPRB,4.4663E+00_JPRB,7.0860E+00_JPRB,1.1190E+01_JPRB,1.4992E+01_JPRB,1.7544E+01_JPRB/)
KBO( :, 1,36,12) = (/&
&2.9654E+00_JPRB,2.9641E+00_JPRB,7.4313E+00_JPRB,1.2766E+01_JPRB,1.7160E+01_JPRB,1.9227E+01_JPRB/)
KBO( :, 2,36,12) = (/&
&3.2570E+00_JPRB,3.2555E+00_JPRB,7.3495E+00_JPRB,1.2436E+01_JPRB,1.6723E+01_JPRB,1.9033E+01_JPRB/)
KBO( :, 3,36,12) = (/&
&3.5797E+00_JPRB,3.5780E+00_JPRB,7.2711E+00_JPRB,1.2069E+01_JPRB,1.6233E+01_JPRB,1.8715E+01_JPRB/)
KBO( :, 4,36,12) = (/&
&3.9316E+00_JPRB,3.9297E+00_JPRB,7.1919E+00_JPRB,1.1675E+01_JPRB,1.5711E+01_JPRB,1.8314E+01_JPRB/)
KBO( :, 5,36,12) = (/&
&4.3127E+00_JPRB,4.3105E+00_JPRB,7.1101E+00_JPRB,1.1293E+01_JPRB,1.5166E+01_JPRB,1.7865E+01_JPRB/)
KBO( :, 1,37,12) = (/&
&2.7533E+00_JPRB,2.7522E+00_JPRB,7.4577E+00_JPRB,1.2906E+01_JPRB,1.7405E+01_JPRB,1.9546E+01_JPRB/)
KBO( :, 2,37,12) = (/&
&3.0486E+00_JPRB,3.0472E+00_JPRB,7.3839E+00_JPRB,1.2582E+01_JPRB,1.6967E+01_JPRB,1.9367E+01_JPRB/)
KBO( :, 3,37,12) = (/&
&3.3772E+00_JPRB,3.3756E+00_JPRB,7.3093E+00_JPRB,1.2218E+01_JPRB,1.6476E+01_JPRB,1.9050E+01_JPRB/)
KBO( :, 4,37,12) = (/&
&3.7381E+00_JPRB,3.7362E+00_JPRB,7.2303E+00_JPRB,1.1826E+01_JPRB,1.5946E+01_JPRB,1.8659E+01_JPRB/)
KBO( :, 5,37,12) = (/&
&4.1246E+00_JPRB,4.1225E+00_JPRB,7.1455E+00_JPRB,1.1440E+01_JPRB,1.5395E+01_JPRB,1.8212E+01_JPRB/)
KBO( :, 1,38,12) = (/&
&2.5620E+00_JPRB,2.5610E+00_JPRB,7.4808E+00_JPRB,1.3030E+01_JPRB,1.7619E+01_JPRB,1.9841E+01_JPRB/)
KBO( :, 2,38,12) = (/&
&2.8608E+00_JPRB,2.8595E+00_JPRB,7.4174E+00_JPRB,1.2714E+01_JPRB,1.7188E+01_JPRB,1.9683E+01_JPRB/)
KBO( :, 3,38,12) = (/&
&3.1956E+00_JPRB,3.1942E+00_JPRB,7.3440E+00_JPRB,1.2353E+01_JPRB,1.6696E+01_JPRB,1.9369E+01_JPRB/)
KBO( :, 4,38,12) = (/&
&3.5649E+00_JPRB,3.5631E+00_JPRB,7.2670E+00_JPRB,1.1965E+01_JPRB,1.6163E+01_JPRB,1.8994E+01_JPRB/)
KBO( :, 5,38,12) = (/&
&3.9585E+00_JPRB,3.9565E+00_JPRB,7.1817E+00_JPRB,1.1573E+01_JPRB,1.5604E+01_JPRB,1.8550E+01_JPRB/)
KBO( :, 1,39,12) = (/&
&2.3896E+00_JPRB,2.3887E+00_JPRB,7.5031E+00_JPRB,1.3145E+01_JPRB,1.7806E+01_JPRB,2.0123E+01_JPRB/)
KBO( :, 2,39,12) = (/&
&2.6949E+00_JPRB,2.6937E+00_JPRB,7.4455E+00_JPRB,1.2830E+01_JPRB,1.7380E+01_JPRB,1.9979E+01_JPRB/)
KBO( :, 3,39,12) = (/&
&3.0362E+00_JPRB,3.0348E+00_JPRB,7.3756E+00_JPRB,1.2474E+01_JPRB,1.6890E+01_JPRB,1.9683E+01_JPRB/)
KBO( :, 4,39,12) = (/&
&3.4116E+00_JPRB,3.4099E+00_JPRB,7.3010E+00_JPRB,1.2089E+01_JPRB,1.6357E+01_JPRB,1.9331E+01_JPRB/)
KBO( :, 5,39,12) = (/&
&3.8125E+00_JPRB,3.8105E+00_JPRB,7.2161E+00_JPRB,1.1695E+01_JPRB,1.5793E+01_JPRB,1.8893E+01_JPRB/)
KBO( :, 1,40,12) = (/&
&2.2084E+00_JPRB,2.2076E+00_JPRB,7.5257E+00_JPRB,1.3272E+01_JPRB,1.8011E+01_JPRB,2.0327E+01_JPRB/)
KBO( :, 2,40,12) = (/&
&2.5142E+00_JPRB,2.5132E+00_JPRB,7.4776E+00_JPRB,1.2969E+01_JPRB,1.7599E+01_JPRB,2.0223E+01_JPRB/)
KBO( :, 3,40,12) = (/&
&2.8571E+00_JPRB,2.8558E+00_JPRB,7.4104E+00_JPRB,1.2622E+01_JPRB,1.7115E+01_JPRB,1.9951E+01_JPRB/)
KBO( :, 4,40,12) = (/&
&3.2355E+00_JPRB,3.2339E+00_JPRB,7.3412E+00_JPRB,1.2241E+01_JPRB,1.6586E+01_JPRB,1.9625E+01_JPRB/)
KBO( :, 5,40,12) = (/&
&3.6402E+00_JPRB,3.6383E+00_JPRB,7.2559E+00_JPRB,1.1846E+01_JPRB,1.6023E+01_JPRB,1.9193E+01_JPRB/)
KBO( :, 1,41,12) = (/&
&2.0392E+00_JPRB,2.0384E+00_JPRB,7.5497E+00_JPRB,1.3388E+01_JPRB,1.8196E+01_JPRB,2.0499E+01_JPRB/)
KBO( :, 2,41,12) = (/&
&2.3453E+00_JPRB,2.3444E+00_JPRB,7.5055E+00_JPRB,1.3103E+01_JPRB,1.7800E+01_JPRB,2.0441E+01_JPRB/)
KBO( :, 3,41,12) = (/&
&2.6889E+00_JPRB,2.6876E+00_JPRB,7.4442E+00_JPRB,1.2764E+01_JPRB,1.7330E+01_JPRB,2.0201E+01_JPRB/)
KBO( :, 4,41,12) = (/&
&3.0674E+00_JPRB,3.0659E+00_JPRB,7.3773E+00_JPRB,1.2388E+01_JPRB,1.6806E+01_JPRB,1.9901E+01_JPRB/)
KBO( :, 5,41,12) = (/&
&3.4739E+00_JPRB,3.4722E+00_JPRB,7.2932E+00_JPRB,1.1996E+01_JPRB,1.6248E+01_JPRB,1.9478E+01_JPRB/)
KBO( :, 1,42,12) = (/&
&1.8842E+00_JPRB,1.8835E+00_JPRB,7.5738E+00_JPRB,1.3492E+01_JPRB,1.8356E+01_JPRB,2.0651E+01_JPRB/)
KBO( :, 2,42,12) = (/&
&2.1916E+00_JPRB,2.1907E+00_JPRB,7.5284E+00_JPRB,1.3224E+01_JPRB,1.7982E+01_JPRB,2.0639E+01_JPRB/)
KBO( :, 3,42,12) = (/&
&2.5344E+00_JPRB,2.5332E+00_JPRB,7.4756E+00_JPRB,1.2895E+01_JPRB,1.7528E+01_JPRB,2.0438E+01_JPRB/)
KBO( :, 4,42,12) = (/&
&2.9115E+00_JPRB,2.9101E+00_JPRB,7.4107E+00_JPRB,1.2526E+01_JPRB,1.7014E+01_JPRB,2.0170E+01_JPRB/)
KBO( :, 5,42,12) = (/&
&3.3176E+00_JPRB,3.3160E+00_JPRB,7.3300E+00_JPRB,1.2138E+01_JPRB,1.6460E+01_JPRB,1.9759E+01_JPRB/)
KBO( :, 1,43,12) = (/&
&1.7267E+00_JPRB,1.7260E+00_JPRB,7.5950E+00_JPRB,1.3597E+01_JPRB,1.8513E+01_JPRB,2.0770E+01_JPRB/)
KBO( :, 2,43,12) = (/&
&2.0318E+00_JPRB,2.0310E+00_JPRB,7.5508E+00_JPRB,1.3350E+01_JPRB,1.8172E+01_JPRB,2.0815E+01_JPRB/)
KBO( :, 3,43,12) = (/&
&2.3711E+00_JPRB,2.3700E+00_JPRB,7.5067E+00_JPRB,1.3037E+01_JPRB,1.7739E+01_JPRB,2.0667E+01_JPRB/)
KBO( :, 4,43,12) = (/&
&2.7430E+00_JPRB,2.7417E+00_JPRB,7.4433E+00_JPRB,1.2679E+01_JPRB,1.7236E+01_JPRB,2.0434E+01_JPRB/)
KBO( :, 5,43,12) = (/&
&3.1470E+00_JPRB,3.1454E+00_JPRB,7.3686E+00_JPRB,1.2292E+01_JPRB,1.6691E+01_JPRB,2.0048E+01_JPRB/)
KBO( :, 1,44,12) = (/&
&1.5761E+00_JPRB,1.5756E+00_JPRB,7.6126E+00_JPRB,1.3691E+01_JPRB,1.8648E+01_JPRB,2.0862E+01_JPRB/)
KBO( :, 2,44,12) = (/&
&1.8753E+00_JPRB,1.8746E+00_JPRB,7.5725E+00_JPRB,1.3468E+01_JPRB,1.8351E+01_JPRB,2.0968E+01_JPRB/)
KBO( :, 3,44,12) = (/&
&2.2096E+00_JPRB,2.2086E+00_JPRB,7.5342E+00_JPRB,1.3177E+01_JPRB,1.7945E+01_JPRB,2.0887E+01_JPRB/)
KBO( :, 4,44,12) = (/&
&2.5754E+00_JPRB,2.5742E+00_JPRB,7.4767E+00_JPRB,1.2832E+01_JPRB,1.7460E+01_JPRB,2.0692E+01_JPRB/)
KBO( :, 5,44,12) = (/&
&2.9738E+00_JPRB,2.9723E+00_JPRB,7.4066E+00_JPRB,1.2450E+01_JPRB,1.6925E+01_JPRB,2.0342E+01_JPRB/)
KBO( :, 1,45,12) = (/&
&1.4392E+00_JPRB,1.4387E+00_JPRB,7.6289E+00_JPRB,1.3769E+01_JPRB,1.8760E+01_JPRB,2.0935E+01_JPRB/)
KBO( :, 2,45,12) = (/&
&1.7286E+00_JPRB,1.7279E+00_JPRB,7.5921E+00_JPRB,1.3574E+01_JPRB,1.8509E+01_JPRB,2.1105E+01_JPRB/)
KBO( :, 3,45,12) = (/&
&2.0581E+00_JPRB,2.0572E+00_JPRB,7.5558E+00_JPRB,1.3307E+01_JPRB,1.8131E+01_JPRB,2.1101E+01_JPRB/)
KBO( :, 4,45,12) = (/&
&2.4180E+00_JPRB,2.4169E+00_JPRB,7.5062E+00_JPRB,1.2976E+01_JPRB,1.7672E+01_JPRB,2.0953E+01_JPRB/)
KBO( :, 5,45,12) = (/&
&2.8084E+00_JPRB,2.8070E+00_JPRB,7.4420E+00_JPRB,1.2604E+01_JPRB,1.7149E+01_JPRB,2.0640E+01_JPRB/)
KBO( :, 1,46,12) = (/&
&1.3097E+00_JPRB,1.3093E+00_JPRB,7.6423E+00_JPRB,1.3829E+01_JPRB,1.8849E+01_JPRB,2.0974E+01_JPRB/)
KBO( :, 2,46,12) = (/&
&1.5854E+00_JPRB,1.5848E+00_JPRB,7.6098E+00_JPRB,1.3672E+01_JPRB,1.8651E+01_JPRB,2.1212E+01_JPRB/)
KBO( :, 3,46,12) = (/&
&1.9071E+00_JPRB,1.9063E+00_JPRB,7.5745E+00_JPRB,1.3430E+01_JPRB,1.8314E+01_JPRB,2.1300E+01_JPRB/)
KBO( :, 4,46,12) = (/&
&2.2598E+00_JPRB,2.2588E+00_JPRB,7.5350E+00_JPRB,1.3119E+01_JPRB,1.7880E+01_JPRB,2.1201E+01_JPRB/)
KBO( :, 5,46,12) = (/&
&2.6412E+00_JPRB,2.6399E+00_JPRB,7.4731E+00_JPRB,1.2761E+01_JPRB,1.7374E+01_JPRB,2.0932E+01_JPRB/)
KBO( :, 1,47,12) = (/&
&1.1830E+00_JPRB,1.1826E+00_JPRB,7.6481E+00_JPRB,1.3869E+01_JPRB,1.8908E+01_JPRB,2.0951E+01_JPRB/)
KBO( :, 2,47,12) = (/&
&1.4407E+00_JPRB,1.4402E+00_JPRB,7.6261E+00_JPRB,1.3765E+01_JPRB,1.8775E+01_JPRB,2.1251E+01_JPRB/)
KBO( :, 3,47,12) = (/&
&1.7493E+00_JPRB,1.7485E+00_JPRB,7.5928E+00_JPRB,1.3553E+01_JPRB,1.8492E+01_JPRB,2.1457E+01_JPRB/)
KBO( :, 4,47,12) = (/&
&2.0941E+00_JPRB,2.0931E+00_JPRB,7.5591E+00_JPRB,1.3267E+01_JPRB,1.8091E+01_JPRB,2.1416E+01_JPRB/)
KBO( :, 5,47,12) = (/&
&2.4666E+00_JPRB,2.4654E+00_JPRB,7.5056E+00_JPRB,1.2925E+01_JPRB,1.7610E+01_JPRB,2.1209E+01_JPRB/)
KBO( :, 1,48,12) = (/&
&1.0695E+00_JPRB,1.0692E+00_JPRB,7.6498E+00_JPRB,1.3881E+01_JPRB,1.8927E+01_JPRB,2.0896E+01_JPRB/)
KBO( :, 2,48,12) = (/&
&1.3081E+00_JPRB,1.3076E+00_JPRB,7.6404E+00_JPRB,1.3836E+01_JPRB,1.8873E+01_JPRB,2.1276E+01_JPRB/)
KBO( :, 3,48,12) = (/&
&1.6006E+00_JPRB,1.5999E+00_JPRB,7.6097E+00_JPRB,1.3659E+01_JPRB,1.8647E+01_JPRB,2.1600E+01_JPRB/)
KBO( :, 4,48,12) = (/&
&1.9354E+00_JPRB,1.9345E+00_JPRB,7.5773E+00_JPRB,1.3403E+01_JPRB,1.8286E+01_JPRB,2.1634E+01_JPRB/)
KBO( :, 5,48,12) = (/&
&2.2984E+00_JPRB,2.2973E+00_JPRB,7.5353E+00_JPRB,1.3082E+01_JPRB,1.7836E+01_JPRB,2.1486E+01_JPRB/)
KBO( :, 1,49,12) = (/&
&9.6483E-01_JPRB,9.6464E-01_JPRB,7.6392E+00_JPRB,1.3864E+01_JPRB,1.8901E+01_JPRB,2.0809E+01_JPRB/)
KBO( :, 2,49,12) = (/&
&1.1880E+00_JPRB,1.1876E+00_JPRB,7.6494E+00_JPRB,1.3882E+01_JPRB,1.8939E+01_JPRB,2.1303E+01_JPRB/)
KBO( :, 3,49,12) = (/&
&1.4610E+00_JPRB,1.4604E+00_JPRB,7.6246E+00_JPRB,1.3753E+01_JPRB,1.8773E+01_JPRB,2.1746E+01_JPRB/)
KBO( :, 4,49,12) = (/&
&1.7825E+00_JPRB,1.7817E+00_JPRB,7.5952E+00_JPRB,1.3527E+01_JPRB,1.8464E+01_JPRB,2.1864E+01_JPRB/)
KBO( :, 5,49,12) = (/&
&2.1366E+00_JPRB,2.1357E+00_JPRB,7.5591E+00_JPRB,1.3229E+01_JPRB,1.8046E+01_JPRB,2.1779E+01_JPRB/)
KBO( :, 1,50,12) = (/&
&8.7334E-01_JPRB,8.7321E-01_JPRB,7.6167E+00_JPRB,1.3816E+01_JPRB,1.8840E+01_JPRB,2.0653E+01_JPRB/)
KBO( :, 2,50,12) = (/&
&1.0849E+00_JPRB,1.0846E+00_JPRB,7.6499E+00_JPRB,1.3902E+01_JPRB,1.8966E+01_JPRB,2.1256E+01_JPRB/)
KBO( :, 3,50,12) = (/&
&1.3397E+00_JPRB,1.3393E+00_JPRB,7.6369E+00_JPRB,1.3826E+01_JPRB,1.8870E+01_JPRB,2.1793E+01_JPRB/)
KBO( :, 4,50,12) = (/&
&1.6451E+00_JPRB,1.6444E+00_JPRB,7.6078E+00_JPRB,1.3629E+01_JPRB,1.8612E+01_JPRB,2.2015E+01_JPRB/)
KBO( :, 5,50,12) = (/&
&1.9901E+00_JPRB,1.9893E+00_JPRB,7.5766E+00_JPRB,1.3357E+01_JPRB,1.8227E+01_JPRB,2.2000E+01_JPRB/)
KBO( :, 1,51,12) = (/&
&7.9109E-01_JPRB,7.9101E-01_JPRB,7.5808E+00_JPRB,1.3738E+01_JPRB,1.8738E+01_JPRB,2.0437E+01_JPRB/)
KBO( :, 2,51,12) = (/&
&9.9151E-01_JPRB,9.9125E-01_JPRB,7.6471E+00_JPRB,1.3897E+01_JPRB,1.8959E+01_JPRB,2.1160E+01_JPRB/)
KBO( :, 3,51,12) = (/&
&1.2299E+00_JPRB,1.2295E+00_JPRB,7.6471E+00_JPRB,1.3876E+01_JPRB,1.8940E+01_JPRB,2.1766E+01_JPRB/)
KBO( :, 4,51,12) = (/&
&1.5182E+00_JPRB,1.5176E+00_JPRB,7.6211E+00_JPRB,1.3717E+01_JPRB,1.8736E+01_JPRB,2.2115E+01_JPRB/)
KBO( :, 5,51,12) = (/&
&1.8518E+00_JPRB,1.8510E+00_JPRB,7.5920E+00_JPRB,1.3472E+01_JPRB,1.8393E+01_JPRB,2.2169E+01_JPRB/)
KBO( :, 1,52,12) = (/&
&7.1584E-01_JPRB,7.1581E-01_JPRB,7.5315E+00_JPRB,1.3629E+01_JPRB,1.8592E+01_JPRB,2.0184E+01_JPRB/)
KBO( :, 2,52,12) = (/&
&9.0437E-01_JPRB,9.0419E-01_JPRB,7.6323E+00_JPRB,1.3867E+01_JPRB,1.8918E+01_JPRB,2.1052E+01_JPRB/)
KBO( :, 3,52,12) = (/&
&1.1294E+00_JPRB,1.1290E+00_JPRB,7.6500E+00_JPRB,1.3907E+01_JPRB,1.8982E+01_JPRB,2.1738E+01_JPRB/)
KBO( :, 4,52,12) = (/&
&1.3999E+00_JPRB,1.3994E+00_JPRB,7.6316E+00_JPRB,1.3795E+01_JPRB,1.8838E+01_JPRB,2.2212E+01_JPRB/)
KBO( :, 5,52,12) = (/&
&1.7187E+00_JPRB,1.7179E+00_JPRB,7.6040E+00_JPRB,1.3576E+01_JPRB,1.8542E+01_JPRB,2.2347E+01_JPRB/)
KBO( :, 1,53,12) = (/&
&6.4519E-01_JPRB,6.4525E-01_JPRB,7.4665E+00_JPRB,1.3494E+01_JPRB,1.8401E+01_JPRB,1.9906E+01_JPRB/)
KBO( :, 2,53,12) = (/&
&8.2291E-01_JPRB,8.2276E-01_JPRB,7.6064E+00_JPRB,1.3809E+01_JPRB,1.8841E+01_JPRB,2.0928E+01_JPRB/)
KBO( :, 3,53,12) = (/&
&1.0366E+00_JPRB,1.0363E+00_JPRB,7.6500E+00_JPRB,1.3915E+01_JPRB,1.8993E+01_JPRB,2.1723E+01_JPRB/)
KBO( :, 4,53,12) = (/&
&1.2893E+00_JPRB,1.2888E+00_JPRB,7.6422E+00_JPRB,1.3856E+01_JPRB,1.8918E+01_JPRB,2.2328E+01_JPRB/)
KBO( :, 5,53,12) = (/&
&1.5912E+00_JPRB,1.5905E+00_JPRB,7.6165E+00_JPRB,1.3669E+01_JPRB,1.8674E+01_JPRB,2.2548E+01_JPRB/)
KBO( :, 1,54,12) = (/&
&5.8435E-01_JPRB,5.8444E-01_JPRB,7.3907E+00_JPRB,1.3327E+01_JPRB,1.8178E+01_JPRB,1.9515E+01_JPRB/)
KBO( :, 2,54,12) = (/&
&7.5368E-01_JPRB,7.5356E-01_JPRB,7.5705E+00_JPRB,1.3729E+01_JPRB,1.8734E+01_JPRB,2.0634E+01_JPRB/)
KBO( :, 3,54,12) = (/&
&9.5607E-01_JPRB,9.5580E-01_JPRB,7.6449E+00_JPRB,1.3905E+01_JPRB,1.8977E+01_JPRB,2.1497E+01_JPRB/)
KBO( :, 4,54,12) = (/&
&1.1937E+00_JPRB,1.1933E+00_JPRB,7.6499E+00_JPRB,1.3896E+01_JPRB,1.8973E+01_JPRB,2.2212E+01_JPRB/)
KBO( :, 5,54,12) = (/&
&1.4797E+00_JPRB,1.4791E+00_JPRB,7.6261E+00_JPRB,1.3745E+01_JPRB,1.8779E+01_JPRB,2.2527E+01_JPRB/)
KBO( :, 1,55,12) = (/&
&5.2854E-01_JPRB,5.2867E-01_JPRB,7.3044E+00_JPRB,1.3131E+01_JPRB,1.7924E+01_JPRB,1.9047E+01_JPRB/)
KBO( :, 2,55,12) = (/&
&6.9118E-01_JPRB,6.9109E-01_JPRB,7.5254E+00_JPRB,1.3628E+01_JPRB,1.8597E+01_JPRB,2.0249E+01_JPRB/)
KBO( :, 3,55,12) = (/&
&8.8293E-01_JPRB,8.8272E-01_JPRB,7.6307E+00_JPRB,1.3873E+01_JPRB,1.8933E+01_JPRB,2.1158E+01_JPRB/)
KBO( :, 4,55,12) = (/&
&1.1091E+00_JPRB,1.1087E+00_JPRB,7.6507E+00_JPRB,1.3919E+01_JPRB,1.9002E+01_JPRB,2.1900E+01_JPRB/)
KBO( :, 5,55,12) = (/&
&1.3791E+00_JPRB,1.3786E+00_JPRB,7.6348E+00_JPRB,1.3810E+01_JPRB,1.8863E+01_JPRB,2.2367E+01_JPRB/)
KBO( :, 1,56,12) = (/&
&4.7560E-01_JPRB,4.7583E-01_JPRB,7.2007E+00_JPRB,1.2908E+01_JPRB,1.7624E+01_JPRB,1.8559E+01_JPRB/)
KBO( :, 2,56,12) = (/&
&6.3205E-01_JPRB,6.3206E-01_JPRB,7.4679E+00_JPRB,1.3507E+01_JPRB,1.8426E+01_JPRB,1.9860E+01_JPRB/)
KBO( :, 3,56,12) = (/&
&8.1360E-01_JPRB,8.1344E-01_JPRB,7.6074E+00_JPRB,1.3821E+01_JPRB,1.8863E+01_JPRB,2.0825E+01_JPRB/)
KBO( :, 4,56,12) = (/&
&1.0301E+00_JPRB,1.0298E+00_JPRB,7.6506E+00_JPRB,1.3924E+01_JPRB,1.9011E+01_JPRB,2.1557E+01_JPRB/)
KBO( :, 5,56,12) = (/&
&1.2841E+00_JPRB,1.2836E+00_JPRB,7.6437E+00_JPRB,1.3864E+01_JPRB,1.8933E+01_JPRB,2.2162E+01_JPRB/)
KBO( :, 1,57,12) = (/&
&4.2603E-01_JPRB,4.2637E-01_JPRB,7.0800E+00_JPRB,1.2651E+01_JPRB,1.7279E+01_JPRB,1.8044E+01_JPRB/)
KBO( :, 2,57,12) = (/&
&5.7620E-01_JPRB,5.7623E-01_JPRB,7.3960E+00_JPRB,1.3349E+01_JPRB,1.8215E+01_JPRB,1.9448E+01_JPRB/)
KBO( :, 3,57,12) = (/&
&7.4950E-01_JPRB,7.4937E-01_JPRB,7.5736E+00_JPRB,1.3745E+01_JPRB,1.8761E+01_JPRB,2.0480E+01_JPRB/)
KBO( :, 4,57,12) = (/&
&9.5476E-01_JPRB,9.5448E-01_JPRB,7.6455E+00_JPRB,1.3913E+01_JPRB,1.8993E+01_JPRB,2.1239E+01_JPRB/)
KBO( :, 5,57,12) = (/&
&1.1947E+00_JPRB,1.1943E+00_JPRB,7.6507E+00_JPRB,1.3900E+01_JPRB,1.8982E+01_JPRB,2.1879E+01_JPRB/)
KBO( :, 1,58,12) = (/&
&3.8222E-01_JPRB,3.8258E-01_JPRB,6.9487E+00_JPRB,1.2376E+01_JPRB,1.6911E+01_JPRB,1.7525E+01_JPRB/)
KBO( :, 2,58,12) = (/&
&5.2528E-01_JPRB,5.2538E-01_JPRB,7.3177E+00_JPRB,1.3169E+01_JPRB,1.7977E+01_JPRB,1.9013E+01_JPRB/)
KBO( :, 3,58,12) = (/&
&6.9186E-01_JPRB,6.9176E-01_JPRB,7.5326E+00_JPRB,1.3651E+01_JPRB,1.8633E+01_JPRB,2.0139E+01_JPRB/)
KBO( :, 4,58,12) = (/&
&8.8662E-01_JPRB,8.8639E-01_JPRB,7.6334E+00_JPRB,1.3885E+01_JPRB,1.8953E+01_JPRB,2.0942E+01_JPRB/)
KBO( :, 5,58,12) = (/&
&1.1152E+00_JPRB,1.1149E+00_JPRB,7.6513E+00_JPRB,1.3923E+01_JPRB,1.9012E+01_JPRB,2.1525E+01_JPRB/)
KBO( :, 1,59,12) = (/&
&3.6401E-01_JPRB,3.6437E-01_JPRB,6.8886E+00_JPRB,1.2256E+01_JPRB,1.6751E+01_JPRB,1.7277E+01_JPRB/)
KBO( :, 2,59,12) = (/&
&5.0412E-01_JPRB,5.0423E-01_JPRB,7.2807E+00_JPRB,1.3088E+01_JPRB,1.7871E+01_JPRB,1.8767E+01_JPRB/)
KBO( :, 3,59,12) = (/&
&6.6841E-01_JPRB,6.6833E-01_JPRB,7.5138E+00_JPRB,1.3610E+01_JPRB,1.8575E+01_JPRB,1.9865E+01_JPRB/)
KBO( :, 4,59,12) = (/&
&8.5925E-01_JPRB,8.5905E-01_JPRB,7.6263E+00_JPRB,1.3870E+01_JPRB,1.8932E+01_JPRB,2.0637E+01_JPRB/)
KBO( :, 5,59,12) = (/&
&1.0843E+00_JPRB,1.0840E+00_JPRB,7.6509E+00_JPRB,1.3928E+01_JPRB,1.9019E+01_JPRB,2.1126E+01_JPRB/)
KBO( :, 1,13,13) = (/&
&2.1392E+01_JPRB,2.1380E+01_JPRB,1.6377E+01_JPRB,1.1373E+01_JPRB,6.6382E+00_JPRB,5.4072E+00_JPRB/)
KBO( :, 2,13,13) = (/&
&2.0984E+01_JPRB,2.0973E+01_JPRB,1.6065E+01_JPRB,1.1155E+01_JPRB,6.4809E+00_JPRB,5.2816E+00_JPRB/)
KBO( :, 3,13,13) = (/&
&2.0571E+01_JPRB,2.0560E+01_JPRB,1.5742E+01_JPRB,1.0918E+01_JPRB,6.3142E+00_JPRB,5.1399E+00_JPRB/)
KBO( :, 4,13,13) = (/&
&2.0116E+01_JPRB,2.0104E+01_JPRB,1.5385E+01_JPRB,1.0661E+01_JPRB,6.1353E+00_JPRB,5.0342E+00_JPRB/)
KBO( :, 5,13,13) = (/&
&1.9665E+01_JPRB,1.9654E+01_JPRB,1.5041E+01_JPRB,1.0410E+01_JPRB,5.9659E+00_JPRB,5.1046E+00_JPRB/)
KBO( :, 1,14,13) = (/&
&2.2611E+01_JPRB,2.2598E+01_JPRB,1.7286E+01_JPRB,1.1979E+01_JPRB,6.9848E+00_JPRB,5.8003E+00_JPRB/)
KBO( :, 2,14,13) = (/&
&2.2235E+01_JPRB,2.2222E+01_JPRB,1.6999E+01_JPRB,1.1763E+01_JPRB,6.8307E+00_JPRB,5.6143E+00_JPRB/)
KBO( :, 3,14,13) = (/&
&2.1845E+01_JPRB,2.1832E+01_JPRB,1.6684E+01_JPRB,1.1532E+01_JPRB,6.6725E+00_JPRB,5.4768E+00_JPRB/)
KBO( :, 4,14,13) = (/&
&2.1455E+01_JPRB,2.1442E+01_JPRB,1.6377E+01_JPRB,1.1313E+01_JPRB,6.5206E+00_JPRB,5.3624E+00_JPRB/)
KBO( :, 5,14,13) = (/&
&2.1081E+01_JPRB,2.1069E+01_JPRB,1.6078E+01_JPRB,1.1090E+01_JPRB,6.3823E+00_JPRB,5.2307E+00_JPRB/)
KBO( :, 1,15,13) = (/&
&2.4085E+01_JPRB,2.4071E+01_JPRB,1.8394E+01_JPRB,1.2709E+01_JPRB,7.4960E+00_JPRB,6.3317E+00_JPRB/)
KBO( :, 2,15,13) = (/&
&2.3744E+01_JPRB,2.3731E+01_JPRB,1.8118E+01_JPRB,1.2499E+01_JPRB,7.3422E+00_JPRB,6.1431E+00_JPRB/)
KBO( :, 3,15,13) = (/&
&2.3384E+01_JPRB,2.3371E+01_JPRB,1.7836E+01_JPRB,1.2301E+01_JPRB,7.1895E+00_JPRB,5.9905E+00_JPRB/)
KBO( :, 4,15,13) = (/&
&2.3079E+01_JPRB,2.3065E+01_JPRB,1.7598E+01_JPRB,1.2125E+01_JPRB,7.0485E+00_JPRB,5.8455E+00_JPRB/)
KBO( :, 5,15,13) = (/&
&2.2790E+01_JPRB,2.2777E+01_JPRB,1.7354E+01_JPRB,1.1938E+01_JPRB,6.8999E+00_JPRB,5.7410E+00_JPRB/)
KBO( :, 1,16,13) = (/&
&2.5695E+01_JPRB,2.5680E+01_JPRB,1.9581E+01_JPRB,1.3479E+01_JPRB,8.1349E+00_JPRB,7.0625E+00_JPRB/)
KBO( :, 2,16,13) = (/&
&2.5421E+01_JPRB,2.5406E+01_JPRB,1.9374E+01_JPRB,1.3336E+01_JPRB,7.9760E+00_JPRB,6.8886E+00_JPRB/)
KBO( :, 3,16,13) = (/&
&2.5170E+01_JPRB,2.5155E+01_JPRB,1.9169E+01_JPRB,1.3185E+01_JPRB,7.8208E+00_JPRB,6.7331E+00_JPRB/)
KBO( :, 4,16,13) = (/&
&2.4917E+01_JPRB,2.4902E+01_JPRB,1.8958E+01_JPRB,1.3021E+01_JPRB,7.6613E+00_JPRB,6.5695E+00_JPRB/)
KBO( :, 5,16,13) = (/&
&2.4671E+01_JPRB,2.4656E+01_JPRB,1.8755E+01_JPRB,1.2857E+01_JPRB,7.5038E+00_JPRB,6.4414E+00_JPRB/)
KBO( :, 1,17,13) = (/&
&2.7485E+01_JPRB,2.7469E+01_JPRB,2.0920E+01_JPRB,1.4359E+01_JPRB,8.8403E+00_JPRB,7.9625E+00_JPRB/)
KBO( :, 2,17,13) = (/&
&2.7261E+01_JPRB,2.7245E+01_JPRB,2.0734E+01_JPRB,1.4221E+01_JPRB,8.6752E+00_JPRB,7.7696E+00_JPRB/)
KBO( :, 3,17,13) = (/&
&2.7019E+01_JPRB,2.7003E+01_JPRB,2.0538E+01_JPRB,1.4067E+01_JPRB,8.5095E+00_JPRB,7.5869E+00_JPRB/)
KBO( :, 4,17,13) = (/&
&2.6774E+01_JPRB,2.6758E+01_JPRB,2.0340E+01_JPRB,1.3916E+01_JPRB,8.3433E+00_JPRB,7.4093E+00_JPRB/)
KBO( :, 5,17,13) = (/&
&2.6489E+01_JPRB,2.6473E+01_JPRB,2.0113E+01_JPRB,1.3747E+01_JPRB,8.1757E+00_JPRB,7.2580E+00_JPRB/)
KBO( :, 1,18,13) = (/&
&2.9073E+01_JPRB,2.9056E+01_JPRB,2.2090E+01_JPRB,1.5130E+01_JPRB,9.6108E+00_JPRB,8.9667E+00_JPRB/)
KBO( :, 2,18,13) = (/&
&2.8847E+01_JPRB,2.8830E+01_JPRB,2.1906E+01_JPRB,1.4984E+01_JPRB,9.4415E+00_JPRB,8.7341E+00_JPRB/)
KBO( :, 3,18,13) = (/&
&2.8614E+01_JPRB,2.8597E+01_JPRB,2.1721E+01_JPRB,1.4840E+01_JPRB,9.2727E+00_JPRB,8.5308E+00_JPRB/)
KBO( :, 4,18,13) = (/&
&2.8333E+01_JPRB,2.8317E+01_JPRB,2.1498E+01_JPRB,1.4677E+01_JPRB,9.0956E+00_JPRB,8.3322E+00_JPRB/)
KBO( :, 5,18,13) = (/&
&2.8019E+01_JPRB,2.8003E+01_JPRB,2.1254E+01_JPRB,1.4499E+01_JPRB,8.9142E+00_JPRB,8.1468E+00_JPRB/)
KBO( :, 1,19,13) = (/&
&3.0315E+01_JPRB,3.0297E+01_JPRB,2.3006E+01_JPRB,1.5724E+01_JPRB,1.0512E+01_JPRB,1.0019E+01_JPRB/)
KBO( :, 2,19,13) = (/&
&3.0061E+01_JPRB,3.0044E+01_JPRB,2.2808E+01_JPRB,1.5577E+01_JPRB,1.0342E+01_JPRB,9.7644E+00_JPRB/)
KBO( :, 3,19,13) = (/&
&2.9787E+01_JPRB,2.9769E+01_JPRB,2.2595E+01_JPRB,1.5419E+01_JPRB,1.0163E+01_JPRB,9.5327E+00_JPRB/)
KBO( :, 4,19,13) = (/&
&2.9464E+01_JPRB,2.9447E+01_JPRB,2.2343E+01_JPRB,1.5239E+01_JPRB,9.9795E+00_JPRB,9.3290E+00_JPRB/)
KBO( :, 5,19,13) = (/&
&2.9104E+01_JPRB,2.9087E+01_JPRB,2.2065E+01_JPRB,1.5039E+01_JPRB,9.7881E+00_JPRB,9.1292E+00_JPRB/)
KBO( :, 1,20,13) = (/&
&3.1036E+01_JPRB,3.1018E+01_JPRB,2.3548E+01_JPRB,1.6113E+01_JPRB,1.1579E+01_JPRB,1.1154E+01_JPRB/)
KBO( :, 2,20,13) = (/&
&3.0755E+01_JPRB,3.0737E+01_JPRB,2.3334E+01_JPRB,1.5957E+01_JPRB,1.1393E+01_JPRB,1.0893E+01_JPRB/)
KBO( :, 3,20,13) = (/&
&3.0452E+01_JPRB,3.0434E+01_JPRB,2.3095E+01_JPRB,1.5780E+01_JPRB,1.1192E+01_JPRB,1.0651E+01_JPRB/)
KBO( :, 4,20,13) = (/&
&3.0086E+01_JPRB,3.0068E+01_JPRB,2.2811E+01_JPRB,1.5577E+01_JPRB,1.0976E+01_JPRB,1.0441E+01_JPRB/)
KBO( :, 5,20,13) = (/&
&2.9696E+01_JPRB,2.9679E+01_JPRB,2.2510E+01_JPRB,1.5363E+01_JPRB,1.0748E+01_JPRB,1.0213E+01_JPRB/)
KBO( :, 1,21,13) = (/&
&3.1144E+01_JPRB,3.1126E+01_JPRB,2.3635E+01_JPRB,1.6360E+01_JPRB,1.2781E+01_JPRB,1.2415E+01_JPRB/)
KBO( :, 2,21,13) = (/&
&3.0844E+01_JPRB,3.0826E+01_JPRB,2.3403E+01_JPRB,1.6172E+01_JPRB,1.2549E+01_JPRB,1.2147E+01_JPRB/)
KBO( :, 3,21,13) = (/&
&3.0498E+01_JPRB,3.0480E+01_JPRB,2.3133E+01_JPRB,1.5960E+01_JPRB,1.2302E+01_JPRB,1.1885E+01_JPRB/)
KBO( :, 4,21,13) = (/&
&3.0111E+01_JPRB,3.0093E+01_JPRB,2.2836E+01_JPRB,1.5742E+01_JPRB,1.2041E+01_JPRB,1.1642E+01_JPRB/)
KBO( :, 5,21,13) = (/&
&2.9700E+01_JPRB,2.9683E+01_JPRB,2.2517E+01_JPRB,1.5496E+01_JPRB,1.1766E+01_JPRB,1.1381E+01_JPRB/)
KBO( :, 1,22,13) = (/&
&3.0579E+01_JPRB,3.0561E+01_JPRB,2.3219E+01_JPRB,1.6510E+01_JPRB,1.4016E+01_JPRB,1.3791E+01_JPRB/)
KBO( :, 2,22,13) = (/&
&3.0252E+01_JPRB,3.0234E+01_JPRB,2.2968E+01_JPRB,1.6283E+01_JPRB,1.3741E+01_JPRB,1.3488E+01_JPRB/)
KBO( :, 3,22,13) = (/&
&2.9906E+01_JPRB,2.9889E+01_JPRB,2.2700E+01_JPRB,1.6051E+01_JPRB,1.3445E+01_JPRB,1.3187E+01_JPRB/)
KBO( :, 4,22,13) = (/&
&2.9523E+01_JPRB,2.9506E+01_JPRB,2.2405E+01_JPRB,1.5794E+01_JPRB,1.3135E+01_JPRB,1.2905E+01_JPRB/)
KBO( :, 5,22,13) = (/&
&2.9116E+01_JPRB,2.9100E+01_JPRB,2.2090E+01_JPRB,1.5521E+01_JPRB,1.2819E+01_JPRB,1.2597E+01_JPRB/)
KBO( :, 1,23,13) = (/&
&2.9397E+01_JPRB,2.9380E+01_JPRB,2.2345E+01_JPRB,1.6640E+01_JPRB,1.5241E+01_JPRB,1.5271E+01_JPRB/)
KBO( :, 2,23,13) = (/&
&2.9096E+01_JPRB,2.9079E+01_JPRB,2.2113E+01_JPRB,1.6382E+01_JPRB,1.4921E+01_JPRB,1.4908E+01_JPRB/)
KBO( :, 3,23,13) = (/&
&2.8759E+01_JPRB,2.8742E+01_JPRB,2.1850E+01_JPRB,1.6098E+01_JPRB,1.4591E+01_JPRB,1.4553E+01_JPRB/)
KBO( :, 4,23,13) = (/&
&2.8405E+01_JPRB,2.8388E+01_JPRB,2.1576E+01_JPRB,1.5810E+01_JPRB,1.4244E+01_JPRB,1.4213E+01_JPRB/)
KBO( :, 5,23,13) = (/&
&2.8010E+01_JPRB,2.7994E+01_JPRB,2.1268E+01_JPRB,1.5508E+01_JPRB,1.3883E+01_JPRB,1.3842E+01_JPRB/)
KBO( :, 1,24,13) = (/&
&2.7736E+01_JPRB,2.7720E+01_JPRB,2.1114E+01_JPRB,1.6904E+01_JPRB,1.6493E+01_JPRB,1.6795E+01_JPRB/)
KBO( :, 2,24,13) = (/&
&2.7462E+01_JPRB,2.7446E+01_JPRB,2.0900E+01_JPRB,1.6582E+01_JPRB,1.6130E+01_JPRB,1.6394E+01_JPRB/)
KBO( :, 3,24,13) = (/&
&2.7151E+01_JPRB,2.7136E+01_JPRB,2.0660E+01_JPRB,1.6247E+01_JPRB,1.5745E+01_JPRB,1.5974E+01_JPRB/)
KBO( :, 4,24,13) = (/&
&2.6831E+01_JPRB,2.6816E+01_JPRB,2.0409E+01_JPRB,1.5908E+01_JPRB,1.5345E+01_JPRB,1.5569E+01_JPRB/)
KBO( :, 5,24,13) = (/&
&2.6459E+01_JPRB,2.6444E+01_JPRB,2.0122E+01_JPRB,1.5560E+01_JPRB,1.4934E+01_JPRB,1.5132E+01_JPRB/)
KBO( :, 1,25,13) = (/&
&2.5741E+01_JPRB,2.5726E+01_JPRB,1.9691E+01_JPRB,1.7263E+01_JPRB,1.7747E+01_JPRB,1.8359E+01_JPRB/)
KBO( :, 2,25,13) = (/&
&2.5497E+01_JPRB,2.5482E+01_JPRB,1.9486E+01_JPRB,1.6895E+01_JPRB,1.7326E+01_JPRB,1.7886E+01_JPRB/)
KBO( :, 3,25,13) = (/&
&2.5241E+01_JPRB,2.5227E+01_JPRB,1.9275E+01_JPRB,1.6517E+01_JPRB,1.6889E+01_JPRB,1.7399E+01_JPRB/)
KBO( :, 4,25,13) = (/&
&2.4941E+01_JPRB,2.4927E+01_JPRB,1.9033E+01_JPRB,1.6125E+01_JPRB,1.6436E+01_JPRB,1.6925E+01_JPRB/)
KBO( :, 5,25,13) = (/&
&2.4625E+01_JPRB,2.4611E+01_JPRB,1.8780E+01_JPRB,1.5723E+01_JPRB,1.5971E+01_JPRB,1.6420E+01_JPRB/)
KBO( :, 1,26,13) = (/&
&2.3543E+01_JPRB,2.3530E+01_JPRB,1.8282E+01_JPRB,1.7640E+01_JPRB,1.9000E+01_JPRB,1.9879E+01_JPRB/)
KBO( :, 2,26,13) = (/&
&2.3344E+01_JPRB,2.3330E+01_JPRB,1.8083E+01_JPRB,1.7232E+01_JPRB,1.8508E+01_JPRB,1.9336E+01_JPRB/)
KBO( :, 3,26,13) = (/&
&2.3131E+01_JPRB,2.3118E+01_JPRB,1.7881E+01_JPRB,1.6809E+01_JPRB,1.8012E+01_JPRB,1.8780E+01_JPRB/)
KBO( :, 4,26,13) = (/&
&2.2891E+01_JPRB,2.2878E+01_JPRB,1.7660E+01_JPRB,1.6381E+01_JPRB,1.7496E+01_JPRB,1.8235E+01_JPRB/)
KBO( :, 5,26,13) = (/&
&2.2635E+01_JPRB,2.2623E+01_JPRB,1.7424E+01_JPRB,1.5941E+01_JPRB,1.6965E+01_JPRB,1.7649E+01_JPRB/)
KBO( :, 1,27,13) = (/&
&2.1263E+01_JPRB,2.1251E+01_JPRB,1.6999E+01_JPRB,1.8073E+01_JPRB,2.0218E+01_JPRB,2.1326E+01_JPRB/)
KBO( :, 2,27,13) = (/&
&2.1130E+01_JPRB,2.1118E+01_JPRB,1.6805E+01_JPRB,1.7603E+01_JPRB,1.9655E+01_JPRB,2.0714E+01_JPRB/)
KBO( :, 3,27,13) = (/&
&2.0964E+01_JPRB,2.0953E+01_JPRB,1.6591E+01_JPRB,1.7141E+01_JPRB,1.9068E+01_JPRB,2.0084E+01_JPRB/)
KBO( :, 4,27,13) = (/&
&2.0811E+01_JPRB,2.0800E+01_JPRB,1.6383E+01_JPRB,1.6665E+01_JPRB,1.8477E+01_JPRB,1.9460E+01_JPRB/)
KBO( :, 5,27,13) = (/&
&2.0671E+01_JPRB,2.0659E+01_JPRB,1.6163E+01_JPRB,1.6182E+01_JPRB,1.7875E+01_JPRB,1.8801E+01_JPRB/)
KBO( :, 1,28,13) = (/&
&1.9006E+01_JPRB,1.8995E+01_JPRB,1.5933E+01_JPRB,1.8511E+01_JPRB,2.1355E+01_JPRB,2.2683E+01_JPRB/)
KBO( :, 2,28,13) = (/&
&1.8934E+01_JPRB,1.8923E+01_JPRB,1.5716E+01_JPRB,1.8009E+01_JPRB,2.0708E+01_JPRB,2.1993E+01_JPRB/)
KBO( :, 3,28,13) = (/&
&1.8875E+01_JPRB,1.8864E+01_JPRB,1.5505E+01_JPRB,1.7487E+01_JPRB,2.0041E+01_JPRB,2.1291E+01_JPRB/)
KBO( :, 4,28,13) = (/&
&1.8867E+01_JPRB,1.8856E+01_JPRB,1.5292E+01_JPRB,1.6969E+01_JPRB,1.9370E+01_JPRB,2.0578E+01_JPRB/)
KBO( :, 5,28,13) = (/&
&1.8926E+01_JPRB,1.8916E+01_JPRB,1.5114E+01_JPRB,1.6444E+01_JPRB,1.8700E+01_JPRB,1.9834E+01_JPRB/)
KBO( :, 1,29,13) = (/&
&1.6866E+01_JPRB,1.6856E+01_JPRB,1.5090E+01_JPRB,1.8932E+01_JPRB,2.2378E+01_JPRB,2.3900E+01_JPRB/)
KBO( :, 2,29,13) = (/&
&1.6895E+01_JPRB,1.6885E+01_JPRB,1.4848E+01_JPRB,1.8394E+01_JPRB,2.1642E+01_JPRB,2.3131E+01_JPRB/)
KBO( :, 3,29,13) = (/&
&1.7005E+01_JPRB,1.6996E+01_JPRB,1.4617E+01_JPRB,1.7836E+01_JPRB,2.0899E+01_JPRB,2.2368E+01_JPRB/)
KBO( :, 4,29,13) = (/&
&1.7186E+01_JPRB,1.7177E+01_JPRB,1.4419E+01_JPRB,1.7274E+01_JPRB,2.0148E+01_JPRB,2.1559E+01_JPRB/)
KBO( :, 5,29,13) = (/&
&1.7419E+01_JPRB,1.7409E+01_JPRB,1.4291E+01_JPRB,1.6708E+01_JPRB,1.9414E+01_JPRB,2.0739E+01_JPRB/)
KBO( :, 1,30,13) = (/&
&1.4953E+01_JPRB,1.4945E+01_JPRB,1.4448E+01_JPRB,1.9321E+01_JPRB,2.3266E+01_JPRB,2.4961E+01_JPRB/)
KBO( :, 2,30,13) = (/&
&1.5147E+01_JPRB,1.5138E+01_JPRB,1.4172E+01_JPRB,1.8728E+01_JPRB,2.2451E+01_JPRB,2.4136E+01_JPRB/)
KBO( :, 3,30,13) = (/&
&1.5423E+01_JPRB,1.5415E+01_JPRB,1.3932E+01_JPRB,1.8138E+01_JPRB,2.1636E+01_JPRB,2.3296E+01_JPRB/)
KBO( :, 4,30,13) = (/&
&1.5783E+01_JPRB,1.5774E+01_JPRB,1.3754E+01_JPRB,1.7532E+01_JPRB,2.0815E+01_JPRB,2.2402E+01_JPRB/)
KBO( :, 5,30,13) = (/&
&1.6221E+01_JPRB,1.6212E+01_JPRB,1.3682E+01_JPRB,1.6932E+01_JPRB,2.0014E+01_JPRB,2.1530E+01_JPRB/)
KBO( :, 1,31,13) = (/&
&1.3343E+01_JPRB,1.3335E+01_JPRB,1.3979E+01_JPRB,1.9651E+01_JPRB,2.4006E+01_JPRB,2.5869E+01_JPRB/)
KBO( :, 2,31,13) = (/&
&1.3698E+01_JPRB,1.3690E+01_JPRB,1.3675E+01_JPRB,1.9009E+01_JPRB,2.3133E+01_JPRB,2.5002E+01_JPRB/)
KBO( :, 3,31,13) = (/&
&1.4163E+01_JPRB,1.4155E+01_JPRB,1.3429E+01_JPRB,1.8375E+01_JPRB,2.2243E+01_JPRB,2.4068E+01_JPRB/)
KBO( :, 4,31,13) = (/&
&1.4712E+01_JPRB,1.4703E+01_JPRB,1.3295E+01_JPRB,1.7748E+01_JPRB,2.1362E+01_JPRB,2.3103E+01_JPRB/)
KBO( :, 5,31,13) = (/&
&1.5311E+01_JPRB,1.5303E+01_JPRB,1.3250E+01_JPRB,1.7114E+01_JPRB,2.0500E+01_JPRB,2.2261E+01_JPRB/)
KBO( :, 1,32,13) = (/&
&1.2052E+01_JPRB,1.2045E+01_JPRB,1.3628E+01_JPRB,1.9911E+01_JPRB,2.4618E+01_JPRB,2.6646E+01_JPRB/)
KBO( :, 2,32,13) = (/&
&1.2587E+01_JPRB,1.2580E+01_JPRB,1.3324E+01_JPRB,1.9233E+01_JPRB,2.3679E+01_JPRB,2.5689E+01_JPRB/)
KBO( :, 3,32,13) = (/&
&1.3218E+01_JPRB,1.3210E+01_JPRB,1.3094E+01_JPRB,1.8557E+01_JPRB,2.2722E+01_JPRB,2.4678E+01_JPRB/)
KBO( :, 4,32,13) = (/&
&1.3914E+01_JPRB,1.3907E+01_JPRB,1.2978E+01_JPRB,1.7906E+01_JPRB,2.1782E+01_JPRB,2.3743E+01_JPRB/)
KBO( :, 5,32,13) = (/&
&1.4655E+01_JPRB,1.4646E+01_JPRB,1.2957E+01_JPRB,1.7249E+01_JPRB,2.0874E+01_JPRB,2.2925E+01_JPRB/)
KBO( :, 1,33,13) = (/&
&1.1069E+01_JPRB,1.1063E+01_JPRB,1.3365E+01_JPRB,2.0106E+01_JPRB,2.5097E+01_JPRB,2.7267E+01_JPRB/)
KBO( :, 2,33,13) = (/&
&1.1756E+01_JPRB,1.1750E+01_JPRB,1.3070E+01_JPRB,1.9396E+01_JPRB,2.4095E+01_JPRB,2.6242E+01_JPRB/)
KBO( :, 3,33,13) = (/&
&1.2532E+01_JPRB,1.2525E+01_JPRB,1.2868E+01_JPRB,1.8687E+01_JPRB,2.3087E+01_JPRB,2.5240E+01_JPRB/)
KBO( :, 4,33,13) = (/&
&1.3360E+01_JPRB,1.3352E+01_JPRB,1.2765E+01_JPRB,1.8010E+01_JPRB,2.2099E+01_JPRB,2.4405E+01_JPRB/)
KBO( :, 5,33,13) = (/&
&1.4221E+01_JPRB,1.4213E+01_JPRB,1.2776E+01_JPRB,1.7337E+01_JPRB,2.1144E+01_JPRB,2.3571E+01_JPRB/)
KBO( :, 1,34,13) = (/&
&1.0330E+01_JPRB,1.0325E+01_JPRB,1.3170E+01_JPRB,2.0275E+01_JPRB,2.5492E+01_JPRB,2.7791E+01_JPRB/)
KBO( :, 2,34,13) = (/&
&1.1144E+01_JPRB,1.1137E+01_JPRB,1.2897E+01_JPRB,1.9532E+01_JPRB,2.4430E+01_JPRB,2.6740E+01_JPRB/)
KBO( :, 3,34,13) = (/&
&1.2039E+01_JPRB,1.2032E+01_JPRB,1.2723E+01_JPRB,1.8800E+01_JPRB,2.3383E+01_JPRB,2.5842E+01_JPRB/)
KBO( :, 4,34,13) = (/&
&1.2978E+01_JPRB,1.2971E+01_JPRB,1.2635E+01_JPRB,1.8099E+01_JPRB,2.2352E+01_JPRB,2.4982E+01_JPRB/)
KBO( :, 5,34,13) = (/&
&1.3934E+01_JPRB,1.3926E+01_JPRB,1.2668E+01_JPRB,1.7413E+01_JPRB,2.1361E+01_JPRB,2.4094E+01_JPRB/)
KBO( :, 1,35,13) = (/&
&9.7254E+00_JPRB,9.7201E+00_JPRB,1.3055E+01_JPRB,2.0467E+01_JPRB,2.5890E+01_JPRB,2.8316E+01_JPRB/)
KBO( :, 2,35,13) = (/&
&1.0642E+01_JPRB,1.0636E+01_JPRB,1.2799E+01_JPRB,1.9691E+01_JPRB,2.4776E+01_JPRB,2.7321E+01_JPRB/)
KBO( :, 3,35,13) = (/&
&1.1630E+01_JPRB,1.1624E+01_JPRB,1.2635E+01_JPRB,1.8939E+01_JPRB,2.3691E+01_JPRB,2.6463E+01_JPRB/)
KBO( :, 4,35,13) = (/&
&1.2660E+01_JPRB,1.2653E+01_JPRB,1.2560E+01_JPRB,1.8216E+01_JPRB,2.2621E+01_JPRB,2.5557E+01_JPRB/)
KBO( :, 5,35,13) = (/&
&1.3686E+01_JPRB,1.3678E+01_JPRB,1.2601E+01_JPRB,1.7514E+01_JPRB,2.1598E+01_JPRB,2.4647E+01_JPRB/)
KBO( :, 1,36,13) = (/&
&9.1824E+00_JPRB,9.1775E+00_JPRB,1.3014E+01_JPRB,2.0702E+01_JPRB,2.6319E+01_JPRB,2.8897E+01_JPRB/)
KBO( :, 2,36,13) = (/&
&1.0178E+01_JPRB,1.0173E+01_JPRB,1.2753E+01_JPRB,1.9897E+01_JPRB,2.5164E+01_JPRB,2.7977E+01_JPRB/)
KBO( :, 3,36,13) = (/&
&1.1240E+01_JPRB,1.1234E+01_JPRB,1.2589E+01_JPRB,1.9121E+01_JPRB,2.4043E+01_JPRB,2.7098E+01_JPRB/)
KBO( :, 4,36,13) = (/&
&1.2332E+01_JPRB,1.2325E+01_JPRB,1.2520E+01_JPRB,1.8377E+01_JPRB,2.2938E+01_JPRB,2.6162E+01_JPRB/)
KBO( :, 5,36,13) = (/&
&1.3423E+01_JPRB,1.3415E+01_JPRB,1.2563E+01_JPRB,1.7662E+01_JPRB,2.1883E+01_JPRB,2.5220E+01_JPRB/)
KBO( :, 1,37,13) = (/&
&8.6099E+00_JPRB,8.6053E+00_JPRB,1.3043E+01_JPRB,2.1019E+01_JPRB,2.6856E+01_JPRB,2.9568E+01_JPRB/)
KBO( :, 2,37,13) = (/&
&9.6546E+00_JPRB,9.6493E+00_JPRB,1.2762E+01_JPRB,2.0197E+01_JPRB,2.5667E+01_JPRB,2.8665E+01_JPRB/)
KBO( :, 3,37,13) = (/&
&1.0769E+01_JPRB,1.0763E+01_JPRB,1.2583E+01_JPRB,1.9394E+01_JPRB,2.4509E+01_JPRB,2.7775E+01_JPRB/)
KBO( :, 4,37,13) = (/&
&1.1910E+01_JPRB,1.1903E+01_JPRB,1.2502E+01_JPRB,1.8624E+01_JPRB,2.3371E+01_JPRB,2.6796E+01_JPRB/)
KBO( :, 5,37,13) = (/&
&1.3054E+01_JPRB,1.3047E+01_JPRB,1.2531E+01_JPRB,1.7890E+01_JPRB,2.2279E+01_JPRB,2.5830E+01_JPRB/)
KBO( :, 1,38,13) = (/&
&8.1124E+00_JPRB,8.1081E+00_JPRB,1.3090E+01_JPRB,2.1323E+01_JPRB,2.7354E+01_JPRB,3.0221E+01_JPRB/)
KBO( :, 2,38,13) = (/&
&9.1955E+00_JPRB,9.1905E+00_JPRB,1.2789E+01_JPRB,2.0480E+01_JPRB,2.6132E+01_JPRB,2.9338E+01_JPRB/)
KBO( :, 3,38,13) = (/&
&1.0346E+01_JPRB,1.0340E+01_JPRB,1.2594E+01_JPRB,1.9657E+01_JPRB,2.4940E+01_JPRB,2.8430E+01_JPRB/)
KBO( :, 4,38,13) = (/&
&1.1526E+01_JPRB,1.1520E+01_JPRB,1.2499E+01_JPRB,1.8864E+01_JPRB,2.3774E+01_JPRB,2.7417E+01_JPRB/)
KBO( :, 5,38,13) = (/&
&1.2710E+01_JPRB,1.2703E+01_JPRB,1.2513E+01_JPRB,1.8110E+01_JPRB,2.2651E+01_JPRB,2.6428E+01_JPRB/)
KBO( :, 1,39,13) = (/&
&7.6875E+00_JPRB,7.6835E+00_JPRB,1.3146E+01_JPRB,2.1600E+01_JPRB,2.7801E+01_JPRB,3.0872E+01_JPRB/)
KBO( :, 2,39,13) = (/&
&8.7929E+00_JPRB,8.7882E+00_JPRB,1.2830E+01_JPRB,2.0739E+01_JPRB,2.6556E+01_JPRB,3.0007E+01_JPRB/)
KBO( :, 3,39,13) = (/&
&9.9744E+00_JPRB,9.9689E+00_JPRB,1.2617E+01_JPRB,1.9901E+01_JPRB,2.5334E+01_JPRB,2.9071E+01_JPRB/)
KBO( :, 4,39,13) = (/&
&1.1184E+01_JPRB,1.1178E+01_JPRB,1.2503E+01_JPRB,1.9085E+01_JPRB,2.4144E+01_JPRB,2.8025E+01_JPRB/)
KBO( :, 5,39,13) = (/&
&1.2397E+01_JPRB,1.2390E+01_JPRB,1.2501E+01_JPRB,1.8314E+01_JPRB,2.2991E+01_JPRB,2.7022E+01_JPRB/)
KBO( :, 1,40,13) = (/&
&7.2073E+00_JPRB,7.2036E+00_JPRB,1.3244E+01_JPRB,2.1941E+01_JPRB,2.8335E+01_JPRB,3.1477E+01_JPRB/)
KBO( :, 2,40,13) = (/&
&8.3183E+00_JPRB,8.3138E+00_JPRB,1.2905E+01_JPRB,2.1071E+01_JPRB,2.7076E+01_JPRB,3.0598E+01_JPRB/)
KBO( :, 3,40,13) = (/&
&9.5140E+00_JPRB,9.5088E+00_JPRB,1.2663E+01_JPRB,2.0213E+01_JPRB,2.5823E+01_JPRB,2.9671E+01_JPRB/)
KBO( :, 4,40,13) = (/&
&1.0744E+01_JPRB,1.0738E+01_JPRB,1.2520E+01_JPRB,1.9377E+01_JPRB,2.4607E+01_JPRB,2.8610E+01_JPRB/)
KBO( :, 5,40,13) = (/&
&1.1983E+01_JPRB,1.1976E+01_JPRB,1.2493E+01_JPRB,1.8588E+01_JPRB,2.3425E+01_JPRB,2.7600E+01_JPRB/)
KBO( :, 1,41,13) = (/&
&6.7611E+00_JPRB,6.7576E+00_JPRB,1.3349E+01_JPRB,2.2280E+01_JPRB,2.8859E+01_JPRB,3.2049E+01_JPRB/)
KBO( :, 2,41,13) = (/&
&7.8674E+00_JPRB,7.8632E+00_JPRB,1.2993E+01_JPRB,2.1395E+01_JPRB,2.7586E+01_JPRB,3.1155E+01_JPRB/)
KBO( :, 3,41,13) = (/&
&9.0665E+00_JPRB,9.0616E+00_JPRB,1.2725E+01_JPRB,2.0522E+01_JPRB,2.6310E+01_JPRB,3.0246E+01_JPRB/)
KBO( :, 4,41,13) = (/&
&1.0311E+01_JPRB,1.0306E+01_JPRB,1.2549E+01_JPRB,1.9674E+01_JPRB,2.5066E+01_JPRB,2.9176E+01_JPRB/)
KBO( :, 5,41,13) = (/&
&1.1568E+01_JPRB,1.1562E+01_JPRB,1.2494E+01_JPRB,1.8859E+01_JPRB,2.3856E+01_JPRB,2.8161E+01_JPRB/)
KBO( :, 1,42,13) = (/&
&6.3548E+00_JPRB,6.3515E+00_JPRB,1.3456E+01_JPRB,2.2608E+01_JPRB,2.9366E+01_JPRB,3.2606E+01_JPRB/)
KBO( :, 2,42,13) = (/&
&7.4451E+00_JPRB,7.4412E+00_JPRB,1.3085E+01_JPRB,2.1711E+01_JPRB,2.8070E+01_JPRB,3.1692E+01_JPRB/)
KBO( :, 3,42,13) = (/&
&8.6411E+00_JPRB,8.6364E+00_JPRB,1.2793E+01_JPRB,2.0822E+01_JPRB,2.6779E+01_JPRB,3.0806E+01_JPRB/)
KBO( :, 4,42,13) = (/&
&9.8929E+00_JPRB,9.8874E+00_JPRB,1.2589E+01_JPRB,1.9962E+01_JPRB,2.5511E+01_JPRB,2.9730E+01_JPRB/)
KBO( :, 5,42,13) = (/&
&1.1166E+01_JPRB,1.1160E+01_JPRB,1.2501E+01_JPRB,1.9127E+01_JPRB,2.4277E+01_JPRB,2.8718E+01_JPRB/)
KBO( :, 1,43,13) = (/&
&5.9236E+00_JPRB,5.9206E+00_JPRB,1.3597E+01_JPRB,2.2980E+01_JPRB,2.9923E+01_JPRB,3.3179E+01_JPRB/)
KBO( :, 2,43,13) = (/&
&6.9885E+00_JPRB,6.9848E+00_JPRB,1.3206E+01_JPRB,2.2070E+01_JPRB,2.8607E+01_JPRB,3.2249E+01_JPRB/)
KBO( :, 3,43,13) = (/&
&8.1682E+00_JPRB,8.1638E+00_JPRB,1.2880E+01_JPRB,2.1165E+01_JPRB,2.7304E+01_JPRB,3.1388E+01_JPRB/)
KBO( :, 4,43,13) = (/&
&9.4211E+00_JPRB,9.4159E+00_JPRB,1.2650E+01_JPRB,2.0290E+01_JPRB,2.6012E+01_JPRB,3.0330E+01_JPRB/)
KBO( :, 5,43,13) = (/&
&1.0699E+01_JPRB,1.0693E+01_JPRB,1.2520E+01_JPRB,1.9438E+01_JPRB,2.4759E+01_JPRB,2.9317E+01_JPRB/)
KBO( :, 1,44,13) = (/&
&5.4998E+00_JPRB,5.4970E+00_JPRB,1.3748E+01_JPRB,2.3364E+01_JPRB,3.0492E+01_JPRB,3.3756E+01_JPRB/)
KBO( :, 2,44,13) = (/&
&6.5311E+00_JPRB,6.5277E+00_JPRB,1.3340E+01_JPRB,2.2442E+01_JPRB,2.9167E+01_JPRB,3.2820E+01_JPRB/)
KBO( :, 3,44,13) = (/&
&7.6857E+00_JPRB,7.6816E+00_JPRB,1.2985E+01_JPRB,2.1531E+01_JPRB,2.7848E+01_JPRB,3.1979E+01_JPRB/)
KBO( :, 4,44,13) = (/&
&8.9256E+00_JPRB,8.9207E+00_JPRB,1.2724E+01_JPRB,2.0635E+01_JPRB,2.6540E+01_JPRB,3.0955E+01_JPRB/)
KBO( :, 5,44,13) = (/&
&1.0209E+01_JPRB,1.0203E+01_JPRB,1.2556E+01_JPRB,1.9768E+01_JPRB,2.5264E+01_JPRB,2.9937E+01_JPRB/)
KBO( :, 1,45,13) = (/&
&5.1066E+00_JPRB,5.1040E+00_JPRB,1.3894E+01_JPRB,2.3735E+01_JPRB,3.1041E+01_JPRB,3.4324E+01_JPRB/)
KBO( :, 2,45,13) = (/&
&6.1015E+00_JPRB,6.0983E+00_JPRB,1.3484E+01_JPRB,2.2813E+01_JPRB,2.9715E+01_JPRB,3.3401E+01_JPRB/)
KBO( :, 3,45,13) = (/&
&7.2220E+00_JPRB,7.2182E+00_JPRB,1.3105E+01_JPRB,2.1889E+01_JPRB,2.8383E+01_JPRB,3.2574E+01_JPRB/)
KBO( :, 4,45,13) = (/&
&8.4438E+00_JPRB,8.4392E+00_JPRB,1.2807E+01_JPRB,2.0975E+01_JPRB,2.7061E+01_JPRB,3.1594E+01_JPRB/)
KBO( :, 5,45,13) = (/&
&9.7243E+00_JPRB,9.7189E+00_JPRB,1.2602E+01_JPRB,2.0098E+01_JPRB,2.5763E+01_JPRB,3.0584E+01_JPRB/)
KBO( :, 1,46,13) = (/&
&4.7235E+00_JPRB,4.7212E+00_JPRB,1.4046E+01_JPRB,2.4121E+01_JPRB,3.1588E+01_JPRB,3.4885E+01_JPRB/)
KBO( :, 2,46,13) = (/&
&5.6742E+00_JPRB,5.6713E+00_JPRB,1.3640E+01_JPRB,2.3201E+01_JPRB,3.0277E+01_JPRB,3.3993E+01_JPRB/)
KBO( :, 3,46,13) = (/&
&6.7562E+00_JPRB,6.7526E+00_JPRB,1.3243E+01_JPRB,2.2266E+01_JPRB,2.8936E+01_JPRB,3.3171E+01_JPRB/)
KBO( :, 4,46,13) = (/&
&7.9500E+00_JPRB,7.9457E+00_JPRB,1.2906E+01_JPRB,2.1341E+01_JPRB,2.7604E+01_JPRB,3.2255E+01_JPRB/)
KBO( :, 5,46,13) = (/&
&9.2204E+00_JPRB,9.2153E+00_JPRB,1.2671E+01_JPRB,2.0448E+01_JPRB,2.6287E+01_JPRB,3.1265E+01_JPRB/)
KBO( :, 1,47,13) = (/&
&4.3300E+00_JPRB,4.3280E+00_JPRB,1.4218E+01_JPRB,2.4532E+01_JPRB,3.2164E+01_JPRB,3.5437E+01_JPRB/)
KBO( :, 2,47,13) = (/&
&5.2306E+00_JPRB,5.2279E+00_JPRB,1.3812E+01_JPRB,2.3616E+01_JPRB,3.0887E+01_JPRB,3.4582E+01_JPRB/)
KBO( :, 3,47,13) = (/&
&6.2646E+00_JPRB,6.2614E+00_JPRB,1.3402E+01_JPRB,2.2678E+01_JPRB,2.9542E+01_JPRB,3.3739E+01_JPRB/)
KBO( :, 4,47,13) = (/&
&7.4192E+00_JPRB,7.4152E+00_JPRB,1.3037E+01_JPRB,2.1748E+01_JPRB,2.8196E+01_JPRB,3.2920E+01_JPRB/)
KBO( :, 5,47,13) = (/&
&8.6683E+00_JPRB,8.6636E+00_JPRB,1.2760E+01_JPRB,2.0830E+01_JPRB,2.6867E+01_JPRB,3.1949E+01_JPRB/)
KBO( :, 1,48,13) = (/&
&3.9563E+00_JPRB,3.9545E+00_JPRB,1.4390E+01_JPRB,2.4924E+01_JPRB,3.2712E+01_JPRB,3.5975E+01_JPRB/)
KBO( :, 2,48,13) = (/&
&4.8163E+00_JPRB,4.8139E+00_JPRB,1.3982E+01_JPRB,2.4022E+01_JPRB,3.1475E+01_JPRB,3.5176E+01_JPRB/)
KBO( :, 3,48,13) = (/&
&5.7995E+00_JPRB,5.7966E+00_JPRB,1.3571E+01_JPRB,2.3093E+01_JPRB,3.0140E+01_JPRB,3.4333E+01_JPRB/)
KBO( :, 4,48,13) = (/&
&6.9101E+00_JPRB,6.9064E+00_JPRB,1.3183E+01_JPRB,2.2151E+01_JPRB,2.8787E+01_JPRB,3.3609E+01_JPRB/)
KBO( :, 5,48,13) = (/&
&8.1290E+00_JPRB,8.1246E+00_JPRB,1.2862E+01_JPRB,2.1218E+01_JPRB,2.7446E+01_JPRB,3.2685E+01_JPRB/)
KBO( :, 1,49,13) = (/&
&3.6095E+00_JPRB,3.6078E+00_JPRB,1.4558E+01_JPRB,2.5296E+01_JPRB,3.3234E+01_JPRB,3.6504E+01_JPRB/)
KBO( :, 2,49,13) = (/&
&4.4271E+00_JPRB,4.4249E+00_JPRB,1.4150E+01_JPRB,2.4423E+01_JPRB,3.2036E+01_JPRB,3.5772E+01_JPRB/)
KBO( :, 3,49,13) = (/&
&5.3603E+00_JPRB,5.3576E+00_JPRB,1.3742E+01_JPRB,2.3500E+01_JPRB,3.0731E+01_JPRB,3.4966E+01_JPRB/)
KBO( :, 4,49,13) = (/&
&6.4234E+00_JPRB,6.4201E+00_JPRB,1.3335E+01_JPRB,2.2553E+01_JPRB,2.9376E+01_JPRB,3.4358E+01_JPRB/)
KBO( :, 5,49,13) = (/&
&7.6032E+00_JPRB,7.5991E+00_JPRB,1.2984E+01_JPRB,2.1616E+01_JPRB,2.8020E+01_JPRB,3.3502E+01_JPRB/)
KBO( :, 1,50,13) = (/&
&3.3075E+00_JPRB,3.3060E+00_JPRB,1.4713E+01_JPRB,2.5635E+01_JPRB,3.3698E+01_JPRB,3.6916E+01_JPRB/)
KBO( :, 2,50,13) = (/&
&4.0785E+00_JPRB,4.0766E+00_JPRB,1.4310E+01_JPRB,2.4788E+01_JPRB,3.2546E+01_JPRB,3.6251E+01_JPRB/)
KBO( :, 3,50,13) = (/&
&4.9697E+00_JPRB,4.9672E+00_JPRB,1.3904E+01_JPRB,2.3873E+01_JPRB,3.1275E+01_JPRB,3.5481E+01_JPRB/)
KBO( :, 4,50,13) = (/&
&5.9880E+00_JPRB,5.9849E+00_JPRB,1.3488E+01_JPRB,2.2931E+01_JPRB,2.9923E+01_JPRB,3.4946E+01_JPRB/)
KBO( :, 5,50,13) = (/&
&7.1253E+00_JPRB,7.1215E+00_JPRB,1.3112E+01_JPRB,2.1989E+01_JPRB,2.8565E+01_JPRB,3.4166E+01_JPRB/)
KBO( :, 1,51,13) = (/&
&3.0350E+00_JPRB,3.0337E+00_JPRB,1.4851E+01_JPRB,2.5935E+01_JPRB,3.4107E+01_JPRB,3.7237E+01_JPRB/)
KBO( :, 2,51,13) = (/&
&3.7587E+00_JPRB,3.7569E+00_JPRB,1.4465E+01_JPRB,2.5129E+01_JPRB,3.3019E+01_JPRB,3.6650E+01_JPRB/)
KBO( :, 3,51,13) = (/&
&4.6142E+00_JPRB,4.6119E+00_JPRB,1.4053E+01_JPRB,2.4233E+01_JPRB,3.1785E+01_JPRB,3.5945E+01_JPRB/)
KBO( :, 4,51,13) = (/&
&5.5848E+00_JPRB,5.5820E+00_JPRB,1.3644E+01_JPRB,2.3300E+01_JPRB,3.0450E+01_JPRB,3.5428E+01_JPRB/)
KBO( :, 5,51,13) = (/&
&6.6798E+00_JPRB,6.6762E+00_JPRB,1.3245E+01_JPRB,2.2350E+01_JPRB,2.9088E+01_JPRB,3.4747E+01_JPRB/)
KBO( :, 1,52,13) = (/&
&2.7825E+00_JPRB,2.7814E+00_JPRB,1.4975E+01_JPRB,2.6195E+01_JPRB,3.4492E+01_JPRB,3.7510E+01_JPRB/)
KBO( :, 2,52,13) = (/&
&3.4605E+00_JPRB,3.4589E+00_JPRB,1.4616E+01_JPRB,2.5455E+01_JPRB,3.3469E+01_JPRB,3.7042E+01_JPRB/)
KBO( :, 3,52,13) = (/&
&4.2744E+00_JPRB,4.2723E+00_JPRB,1.4207E+01_JPRB,2.4585E+01_JPRB,3.2279E+01_JPRB,3.6429E+01_JPRB/)
KBO( :, 4,52,13) = (/&
&5.1994E+00_JPRB,5.1968E+00_JPRB,1.3797E+01_JPRB,2.3661E+01_JPRB,3.0975E+01_JPRB,3.5933E+01_JPRB/)
KBO( :, 5,52,13) = (/&
&6.2531E+00_JPRB,6.2499E+00_JPRB,1.3386E+01_JPRB,2.2706E+01_JPRB,2.9608E+01_JPRB,3.5360E+01_JPRB/)
KBO( :, 1,53,13) = (/&
&2.5462E+00_JPRB,2.5451E+00_JPRB,1.5076E+01_JPRB,2.6414E+01_JPRB,3.4840E+01_JPRB,3.7769E+01_JPRB/)
KBO( :, 2,53,13) = (/&
&3.1815E+00_JPRB,3.1801E+00_JPRB,1.4759E+01_JPRB,2.5766E+01_JPRB,3.3894E+01_JPRB,3.7437E+01_JPRB/)
KBO( :, 3,53,13) = (/&
&3.9476E+00_JPRB,3.9457E+00_JPRB,1.4361E+01_JPRB,2.4924E+01_JPRB,3.2751E+01_JPRB,3.6936E+01_JPRB/)
KBO( :, 4,53,13) = (/&
&4.8360E+00_JPRB,4.8336E+00_JPRB,1.3950E+01_JPRB,2.4012E+01_JPRB,3.1482E+01_JPRB,3.6505E+01_JPRB/)
KBO( :, 5,53,13) = (/&
&5.8444E+00_JPRB,5.8414E+00_JPRB,1.3535E+01_JPRB,2.3068E+01_JPRB,3.0128E+01_JPRB,3.6046E+01_JPRB/)
KBO( :, 1,54,13) = (/&
&2.3476E+00_JPRB,2.3467E+00_JPRB,1.5163E+01_JPRB,2.6598E+01_JPRB,3.5117E+01_JPRB,3.7852E+01_JPRB/)
KBO( :, 2,54,13) = (/&
&2.9439E+00_JPRB,2.9426E+00_JPRB,1.4884E+01_JPRB,2.6029E+01_JPRB,3.4253E+01_JPRB,3.7637E+01_JPRB/)
KBO( :, 3,54,13) = (/&
&3.6641E+00_JPRB,3.6624E+00_JPRB,1.4503E+01_JPRB,2.5231E+01_JPRB,3.3172E+01_JPRB,3.7161E+01_JPRB/)
KBO( :, 4,54,13) = (/&
&4.5193E+00_JPRB,4.5171E+00_JPRB,1.4088E+01_JPRB,2.4334E+01_JPRB,3.1938E+01_JPRB,3.6656E+01_JPRB/)
KBO( :, 5,54,13) = (/&
&5.4838E+00_JPRB,5.4810E+00_JPRB,1.3677E+01_JPRB,2.3400E+01_JPRB,3.0603E+01_JPRB,3.6329E+01_JPRB/)
KBO( :, 1,55,13) = (/&
&2.1710E+00_JPRB,2.1701E+00_JPRB,1.5234E+01_JPRB,2.6747E+01_JPRB,3.5339E+01_JPRB,3.7885E+01_JPRB/)
KBO( :, 2,55,13) = (/&
&2.7278E+00_JPRB,2.7266E+00_JPRB,1.4989E+01_JPRB,2.6245E+01_JPRB,3.4579E+01_JPRB,3.7689E+01_JPRB/)
KBO( :, 3,55,13) = (/&
&3.4082E+00_JPRB,3.4067E+00_JPRB,1.4633E+01_JPRB,2.5510E+01_JPRB,3.3556E+01_JPRB,3.7242E+01_JPRB/)
KBO( :, 4,55,13) = (/&
&4.2238E+00_JPRB,4.2218E+00_JPRB,1.4223E+01_JPRB,2.4639E+01_JPRB,3.2363E+01_JPRB,3.6666E+01_JPRB/)
KBO( :, 5,55,13) = (/&
&5.1513E+00_JPRB,5.1487E+00_JPRB,1.3812E+01_JPRB,2.3712E+01_JPRB,3.1057E+01_JPRB,3.6276E+01_JPRB/)
KBO( :, 1,56,13) = (/&
&2.0079E+00_JPRB,2.0070E+00_JPRB,1.5283E+01_JPRB,2.6864E+01_JPRB,3.5527E+01_JPRB,3.7901E+01_JPRB/)
KBO( :, 2,56,13) = (/&
&2.5254E+00_JPRB,2.5243E+00_JPRB,1.5077E+01_JPRB,2.6433E+01_JPRB,3.4877E+01_JPRB,3.7697E+01_JPRB/)
KBO( :, 3,56,13) = (/&
&3.1684E+00_JPRB,3.1669E+00_JPRB,1.4757E+01_JPRB,2.5780E+01_JPRB,3.3923E+01_JPRB,3.7342E+01_JPRB/)
KBO( :, 4,56,13) = (/&
&3.9407E+00_JPRB,3.9388E+00_JPRB,1.4357E+01_JPRB,2.4934E+01_JPRB,3.2773E+01_JPRB,3.6769E+01_JPRB/)
KBO( :, 5,56,13) = (/&
&4.8364E+00_JPRB,4.8339E+00_JPRB,1.3945E+01_JPRB,2.4018E+01_JPRB,3.1497E+01_JPRB,3.6172E+01_JPRB/)
KBO( :, 1,57,13) = (/&
&1.8578E+00_JPRB,1.8569E+00_JPRB,1.5303E+01_JPRB,2.6949E+01_JPRB,3.5653E+01_JPRB,3.7877E+01_JPRB/)
KBO( :, 2,57,13) = (/&
&2.3391E+00_JPRB,2.3382E+00_JPRB,1.5160E+01_JPRB,2.6604E+01_JPRB,3.5134E+01_JPRB,3.7763E+01_JPRB/)
KBO( :, 3,57,13) = (/&
&2.9439E+00_JPRB,2.9426E+00_JPRB,1.4876E+01_JPRB,2.6028E+01_JPRB,3.4258E+01_JPRB,3.7439E+01_JPRB/)
KBO( :, 4,57,13) = (/&
&3.6722E+00_JPRB,3.6705E+00_JPRB,1.4492E+01_JPRB,2.5221E+01_JPRB,3.3167E+01_JPRB,3.6862E+01_JPRB/)
KBO( :, 5,57,13) = (/&
&4.5340E+00_JPRB,4.5318E+00_JPRB,1.4076E+01_JPRB,2.4322E+01_JPRB,3.1926E+01_JPRB,3.6169E+01_JPRB/)
KBO( :, 1,58,13) = (/&
&1.7257E+00_JPRB,1.7249E+00_JPRB,1.5300E+01_JPRB,2.6987E+01_JPRB,3.5715E+01_JPRB,3.7771E+01_JPRB/)
KBO( :, 2,58,13) = (/&
&2.1747E+00_JPRB,2.1738E+00_JPRB,1.5228E+01_JPRB,2.6747E+01_JPRB,3.5343E+01_JPRB,3.7835E+01_JPRB/)
KBO( :, 3,58,13) = (/&
&2.7413E+00_JPRB,2.7402E+00_JPRB,1.4977E+01_JPRB,2.6232E+01_JPRB,3.4563E+01_JPRB,3.7436E+01_JPRB/)
KBO( :, 4,58,13) = (/&
&3.4316E+00_JPRB,3.4300E+00_JPRB,1.4616E+01_JPRB,2.5484E+01_JPRB,3.3527E+01_JPRB,3.6930E+01_JPRB/)
KBO( :, 5,58,13) = (/&
&4.2563E+00_JPRB,4.2542E+00_JPRB,1.4203E+01_JPRB,2.4608E+01_JPRB,3.2326E+01_JPRB,3.6245E+01_JPRB/)
KBO( :, 1,59,13) = (/&
&1.6718E+00_JPRB,1.6710E+00_JPRB,1.5295E+01_JPRB,2.6993E+01_JPRB,3.5730E+01_JPRB,3.7608E+01_JPRB/)
KBO( :, 2,59,13) = (/&
&2.1089E+00_JPRB,2.1080E+00_JPRB,1.5254E+01_JPRB,2.6799E+01_JPRB,3.5425E+01_JPRB,3.7786E+01_JPRB/)
KBO( :, 3,59,13) = (/&
&2.6604E+00_JPRB,2.6594E+00_JPRB,1.5013E+01_JPRB,2.6309E+01_JPRB,3.4684E+01_JPRB,3.7341E+01_JPRB/)
KBO( :, 4,59,13) = (/&
&3.3364E+00_JPRB,3.3349E+00_JPRB,1.4664E+01_JPRB,2.5591E+01_JPRB,3.3675E+01_JPRB,3.6669E+01_JPRB/)
KBO( :, 5,59,13) = (/&
&4.1451E+00_JPRB,4.1431E+00_JPRB,1.4254E+01_JPRB,2.4723E+01_JPRB,3.2485E+01_JPRB,3.5871E+01_JPRB/)
KBO( :, 1,13,14) = (/&
&2.9867E+01_JPRB,2.9850E+01_JPRB,2.2813E+01_JPRB,1.5747E+01_JPRB,8.6461E+00_JPRB,6.6277E+00_JPRB/)
KBO( :, 2,13,14) = (/&
&2.8970E+01_JPRB,2.8953E+01_JPRB,2.2112E+01_JPRB,1.5258E+01_JPRB,8.4453E+00_JPRB,6.4752E+00_JPRB/)
KBO( :, 3,13,14) = (/&
&2.8231E+01_JPRB,2.8215E+01_JPRB,2.1546E+01_JPRB,1.4872E+01_JPRB,8.2664E+00_JPRB,6.3900E+00_JPRB/)
KBO( :, 4,13,14) = (/&
&2.7643E+01_JPRB,2.7627E+01_JPRB,2.1093E+01_JPRB,1.4551E+01_JPRB,8.1037E+00_JPRB,6.4058E+00_JPRB/)
KBO( :, 5,13,14) = (/&
&2.7121E+01_JPRB,2.7106E+01_JPRB,2.0679E+01_JPRB,1.4264E+01_JPRB,7.9370E+00_JPRB,6.4632E+00_JPRB/)
KBO( :, 1,14,14) = (/&
&3.1721E+01_JPRB,3.1703E+01_JPRB,2.4198E+01_JPRB,1.6672E+01_JPRB,9.2683E+00_JPRB,7.3049E+00_JPRB/)
KBO( :, 2,14,14) = (/&
&3.1076E+01_JPRB,3.1058E+01_JPRB,2.3689E+01_JPRB,1.6337E+01_JPRB,9.1193E+00_JPRB,7.0508E+00_JPRB/)
KBO( :, 3,14,14) = (/&
&3.0563E+01_JPRB,3.0546E+01_JPRB,2.3305E+01_JPRB,1.6071E+01_JPRB,8.9743E+00_JPRB,6.8812E+00_JPRB/)
KBO( :, 4,14,14) = (/&
&3.0148E+01_JPRB,3.0131E+01_JPRB,2.2977E+01_JPRB,1.5835E+01_JPRB,8.8320E+00_JPRB,6.7605E+00_JPRB/)
KBO( :, 5,14,14) = (/&
&2.9764E+01_JPRB,2.9747E+01_JPRB,2.2687E+01_JPRB,1.5631E+01_JPRB,8.6858E+00_JPRB,6.7365E+00_JPRB/)
KBO( :, 1,15,14) = (/&
&3.4331E+01_JPRB,3.4311E+01_JPRB,2.6139E+01_JPRB,1.7967E+01_JPRB,1.0028E+01_JPRB,8.1321E+00_JPRB/)
KBO( :, 2,15,14) = (/&
&3.3952E+01_JPRB,3.3933E+01_JPRB,2.5854E+01_JPRB,1.7780E+01_JPRB,9.9136E+00_JPRB,7.8472E+00_JPRB/)
KBO( :, 3,15,14) = (/&
&3.3650E+01_JPRB,3.3631E+01_JPRB,2.5615E+01_JPRB,1.7601E+01_JPRB,9.7954E+00_JPRB,7.6157E+00_JPRB/)
KBO( :, 4,15,14) = (/&
&3.3344E+01_JPRB,3.3325E+01_JPRB,2.5376E+01_JPRB,1.7433E+01_JPRB,9.6656E+00_JPRB,7.3952E+00_JPRB/)
KBO( :, 5,15,14) = (/&
&3.3055E+01_JPRB,3.3036E+01_JPRB,2.5149E+01_JPRB,1.7257E+01_JPRB,9.5339E+00_JPRB,7.2585E+00_JPRB/)
KBO( :, 1,16,14) = (/&
&3.7768E+01_JPRB,3.7746E+01_JPRB,2.8736E+01_JPRB,1.9717E+01_JPRB,1.0946E+01_JPRB,9.0577E+00_JPRB/)
KBO( :, 2,16,14) = (/&
&3.7568E+01_JPRB,3.7546E+01_JPRB,2.8561E+01_JPRB,1.9575E+01_JPRB,1.0848E+01_JPRB,8.7437E+00_JPRB/)
KBO( :, 3,16,14) = (/&
&3.7327E+01_JPRB,3.7305E+01_JPRB,2.8371E+01_JPRB,1.9439E+01_JPRB,1.0735E+01_JPRB,8.4668E+00_JPRB/)
KBO( :, 4,16,14) = (/&
&3.7089E+01_JPRB,3.7067E+01_JPRB,2.8181E+01_JPRB,1.9291E+01_JPRB,1.0617E+01_JPRB,8.2419E+00_JPRB/)
KBO( :, 5,16,14) = (/&
&3.6772E+01_JPRB,3.6751E+01_JPRB,2.7932E+01_JPRB,1.9114E+01_JPRB,1.0484E+01_JPRB,8.0316E+00_JPRB/)
KBO( :, 1,17,14) = (/&
&4.1800E+01_JPRB,4.1776E+01_JPRB,3.1755E+01_JPRB,2.1740E+01_JPRB,1.2078E+01_JPRB,1.0093E+01_JPRB/)
KBO( :, 2,17,14) = (/&
&4.1678E+01_JPRB,4.1653E+01_JPRB,3.1650E+01_JPRB,2.1659E+01_JPRB,1.1979E+01_JPRB,9.7654E+00_JPRB/)
KBO( :, 3,17,14) = (/&
&4.1542E+01_JPRB,4.1518E+01_JPRB,3.1528E+01_JPRB,2.1552E+01_JPRB,1.1863E+01_JPRB,9.4632E+00_JPRB/)
KBO( :, 4,17,14) = (/&
&4.1281E+01_JPRB,4.1257E+01_JPRB,3.1316E+01_JPRB,2.1389E+01_JPRB,1.1731E+01_JPRB,9.2257E+00_JPRB/)
KBO( :, 5,17,14) = (/&
&4.1001E+01_JPRB,4.0977E+01_JPRB,3.1090E+01_JPRB,2.1207E+01_JPRB,1.1579E+01_JPRB,8.9705E+00_JPRB/)
KBO( :, 1,18,14) = (/&
&4.6476E+01_JPRB,4.6449E+01_JPRB,3.5262E+01_JPRB,2.4079E+01_JPRB,1.3398E+01_JPRB,1.1310E+01_JPRB/)
KBO( :, 2,18,14) = (/&
&4.6434E+01_JPRB,4.6407E+01_JPRB,3.5219E+01_JPRB,2.4028E+01_JPRB,1.3279E+01_JPRB,1.0988E+01_JPRB/)
KBO( :, 3,18,14) = (/&
&4.6265E+01_JPRB,4.6238E+01_JPRB,3.5074E+01_JPRB,2.3903E+01_JPRB,1.3136E+01_JPRB,1.0670E+01_JPRB/)
KBO( :, 4,18,14) = (/&
&4.6056E+01_JPRB,4.6029E+01_JPRB,3.4898E+01_JPRB,2.3749E+01_JPRB,1.2970E+01_JPRB,1.0429E+01_JPRB/)
KBO( :, 5,18,14) = (/&
&4.5721E+01_JPRB,4.5694E+01_JPRB,3.4620E+01_JPRB,2.3533E+01_JPRB,1.2786E+01_JPRB,1.0167E+01_JPRB/)
KBO( :, 1,19,14) = (/&
&5.1627E+01_JPRB,5.1597E+01_JPRB,3.9121E+01_JPRB,2.6626E+01_JPRB,1.4901E+01_JPRB,1.2801E+01_JPRB/)
KBO( :, 2,19,14) = (/&
&5.1560E+01_JPRB,5.1530E+01_JPRB,3.9050E+01_JPRB,2.6558E+01_JPRB,1.4739E+01_JPRB,1.2472E+01_JPRB/)
KBO( :, 3,19,14) = (/&
&5.1413E+01_JPRB,5.1383E+01_JPRB,3.8915E+01_JPRB,2.6432E+01_JPRB,1.4553E+01_JPRB,1.2141E+01_JPRB/)
KBO( :, 4,19,14) = (/&
&5.1136E+01_JPRB,5.1106E+01_JPRB,3.8684E+01_JPRB,2.6245E+01_JPRB,1.4345E+01_JPRB,1.1879E+01_JPRB/)
KBO( :, 5,19,14) = (/&
&5.0773E+01_JPRB,5.0743E+01_JPRB,3.8384E+01_JPRB,2.6014E+01_JPRB,1.4118E+01_JPRB,1.1591E+01_JPRB/)
KBO( :, 1,20,14) = (/&
&5.6884E+01_JPRB,5.6851E+01_JPRB,4.3042E+01_JPRB,2.9216E+01_JPRB,1.6557E+01_JPRB,1.4595E+01_JPRB/)
KBO( :, 2,20,14) = (/&
&5.6797E+01_JPRB,5.6764E+01_JPRB,4.2946E+01_JPRB,2.9117E+01_JPRB,1.6341E+01_JPRB,1.4232E+01_JPRB/)
KBO( :, 3,20,14) = (/&
&5.6571E+01_JPRB,5.6538E+01_JPRB,4.2757E+01_JPRB,2.8963E+01_JPRB,1.6110E+01_JPRB,1.3871E+01_JPRB/)
KBO( :, 4,20,14) = (/&
&5.6241E+01_JPRB,5.6208E+01_JPRB,4.2485E+01_JPRB,2.8752E+01_JPRB,1.5861E+01_JPRB,1.3552E+01_JPRB/)
KBO( :, 5,20,14) = (/&
&5.5778E+01_JPRB,5.5746E+01_JPRB,4.2122E+01_JPRB,2.8488E+01_JPRB,1.5601E+01_JPRB,1.3221E+01_JPRB/)
KBO( :, 1,21,14) = (/&
&6.2117E+01_JPRB,6.2081E+01_JPRB,4.6932E+01_JPRB,3.1772E+01_JPRB,1.8332E+01_JPRB,1.6634E+01_JPRB/)
KBO( :, 2,21,14) = (/&
&6.1948E+01_JPRB,6.1912E+01_JPRB,4.6785E+01_JPRB,3.1648E+01_JPRB,1.8084E+01_JPRB,1.6213E+01_JPRB/)
KBO( :, 3,21,14) = (/&
&6.1644E+01_JPRB,6.1608E+01_JPRB,4.6541E+01_JPRB,3.1461E+01_JPRB,1.7808E+01_JPRB,1.5772E+01_JPRB/)
KBO( :, 4,21,14) = (/&
&6.1212E+01_JPRB,6.1176E+01_JPRB,4.6198E+01_JPRB,3.1208E+01_JPRB,1.7516E+01_JPRB,1.5375E+01_JPRB/)
KBO( :, 5,21,14) = (/&
&6.0660E+01_JPRB,6.0625E+01_JPRB,4.5764E+01_JPRB,3.0893E+01_JPRB,1.7197E+01_JPRB,1.4982E+01_JPRB/)
KBO( :, 1,22,14) = (/&
&6.7064E+01_JPRB,6.7024E+01_JPRB,5.0622E+01_JPRB,3.4206E+01_JPRB,2.0283E+01_JPRB,1.8773E+01_JPRB/)
KBO( :, 2,22,14) = (/&
&6.6814E+01_JPRB,6.6775E+01_JPRB,5.0411E+01_JPRB,3.4038E+01_JPRB,1.9964E+01_JPRB,1.8268E+01_JPRB/)
KBO( :, 3,22,14) = (/&
&6.6405E+01_JPRB,6.6365E+01_JPRB,5.0089E+01_JPRB,3.3800E+01_JPRB,1.9618E+01_JPRB,1.7753E+01_JPRB/)
KBO( :, 4,22,14) = (/&
&6.5854E+01_JPRB,6.5815E+01_JPRB,4.9659E+01_JPRB,3.3490E+01_JPRB,1.9247E+01_JPRB,1.7292E+01_JPRB/)
KBO( :, 5,22,14) = (/&
&6.5177E+01_JPRB,6.5139E+01_JPRB,4.9133E+01_JPRB,3.3115E+01_JPRB,1.8852E+01_JPRB,1.6841E+01_JPRB/)
KBO( :, 1,23,14) = (/&
&7.1524E+01_JPRB,7.1482E+01_JPRB,5.3943E+01_JPRB,3.6394E+01_JPRB,2.2409E+01_JPRB,2.1034E+01_JPRB/)
KBO( :, 2,23,14) = (/&
&7.1180E+01_JPRB,7.1138E+01_JPRB,5.3667E+01_JPRB,3.6188E+01_JPRB,2.2011E+01_JPRB,2.0463E+01_JPRB/)
KBO( :, 3,23,14) = (/&
&7.0675E+01_JPRB,7.0634E+01_JPRB,5.3273E+01_JPRB,3.5900E+01_JPRB,2.1570E+01_JPRB,1.9880E+01_JPRB/)
KBO( :, 4,23,14) = (/&
&7.0044E+01_JPRB,7.0003E+01_JPRB,5.2781E+01_JPRB,3.5547E+01_JPRB,2.1106E+01_JPRB,1.9340E+01_JPRB/)
KBO( :, 5,23,14) = (/&
&6.9258E+01_JPRB,6.9217E+01_JPRB,5.2177E+01_JPRB,3.5122E+01_JPRB,2.0624E+01_JPRB,1.8817E+01_JPRB/)
KBO( :, 1,24,14) = (/&
&7.5188E+01_JPRB,7.5144E+01_JPRB,5.6672E+01_JPRB,3.8194E+01_JPRB,2.4653E+01_JPRB,2.3438E+01_JPRB/)
KBO( :, 2,24,14) = (/&
&7.4771E+01_JPRB,7.4727E+01_JPRB,5.6346E+01_JPRB,3.7956E+01_JPRB,2.4153E+01_JPRB,2.2769E+01_JPRB/)
KBO( :, 3,24,14) = (/&
&7.4256E+01_JPRB,7.4212E+01_JPRB,5.5942E+01_JPRB,3.7664E+01_JPRB,2.3612E+01_JPRB,2.2098E+01_JPRB/)
KBO( :, 4,24,14) = (/&
&7.3533E+01_JPRB,7.3489E+01_JPRB,5.5386E+01_JPRB,3.7269E+01_JPRB,2.3047E+01_JPRB,2.1446E+01_JPRB/)
KBO( :, 5,24,14) = (/&
&7.2712E+01_JPRB,7.2669E+01_JPRB,5.4752E+01_JPRB,3.6822E+01_JPRB,2.2450E+01_JPRB,2.0823E+01_JPRB/)
KBO( :, 1,25,14) = (/&
&7.7905E+01_JPRB,7.7859E+01_JPRB,5.8695E+01_JPRB,3.9643E+01_JPRB,2.6946E+01_JPRB,2.5911E+01_JPRB/)
KBO( :, 2,25,14) = (/&
&7.7541E+01_JPRB,7.7495E+01_JPRB,5.8407E+01_JPRB,3.9379E+01_JPRB,2.6314E+01_JPRB,2.5120E+01_JPRB/)
KBO( :, 3,25,14) = (/&
&7.6964E+01_JPRB,7.6919E+01_JPRB,5.7957E+01_JPRB,3.9027E+01_JPRB,2.5656E+01_JPRB,2.4314E+01_JPRB/)
KBO( :, 4,25,14) = (/&
&7.6272E+01_JPRB,7.6227E+01_JPRB,5.7424E+01_JPRB,3.8630E+01_JPRB,2.4965E+01_JPRB,2.3534E+01_JPRB/)
KBO( :, 5,25,14) = (/&
&7.5432E+01_JPRB,7.5387E+01_JPRB,5.6779E+01_JPRB,3.8173E+01_JPRB,2.4252E+01_JPRB,2.2796E+01_JPRB/)
KBO( :, 1,26,14) = (/&
&7.9766E+01_JPRB,7.9719E+01_JPRB,6.0079E+01_JPRB,4.0881E+01_JPRB,2.9223E+01_JPRB,2.8381E+01_JPRB/)
KBO( :, 2,26,14) = (/&
&7.9434E+01_JPRB,7.9387E+01_JPRB,5.9813E+01_JPRB,4.0549E+01_JPRB,2.8445E+01_JPRB,2.7433E+01_JPRB/)
KBO( :, 3,26,14) = (/&
&7.8929E+01_JPRB,7.8882E+01_JPRB,5.9418E+01_JPRB,4.0176E+01_JPRB,2.7639E+01_JPRB,2.6466E+01_JPRB/)
KBO( :, 4,26,14) = (/&
&7.8299E+01_JPRB,7.8253E+01_JPRB,5.8927E+01_JPRB,3.9741E+01_JPRB,2.6813E+01_JPRB,2.5543E+01_JPRB/)
KBO( :, 5,26,14) = (/&
&7.7472E+01_JPRB,7.7426E+01_JPRB,5.8300E+01_JPRB,3.9244E+01_JPRB,2.5976E+01_JPRB,2.4671E+01_JPRB/)
KBO( :, 1,27,14) = (/&
&8.0841E+01_JPRB,8.0794E+01_JPRB,6.0873E+01_JPRB,4.1874E+01_JPRB,3.1425E+01_JPRB,3.0772E+01_JPRB/)
KBO( :, 2,27,14) = (/&
&8.0592E+01_JPRB,8.0544E+01_JPRB,6.0668E+01_JPRB,4.1525E+01_JPRB,3.0489E+01_JPRB,2.9641E+01_JPRB/)
KBO( :, 3,27,14) = (/&
&8.0232E+01_JPRB,8.0184E+01_JPRB,6.0383E+01_JPRB,4.1112E+01_JPRB,2.9523E+01_JPRB,2.8513E+01_JPRB/)
KBO( :, 4,27,14) = (/&
&7.9648E+01_JPRB,7.9600E+01_JPRB,5.9935E+01_JPRB,4.0653E+01_JPRB,2.8551E+01_JPRB,2.7444E+01_JPRB/)
KBO( :, 5,27,14) = (/&
&7.8924E+01_JPRB,7.8877E+01_JPRB,5.9378E+01_JPRB,4.0128E+01_JPRB,2.7582E+01_JPRB,2.6425E+01_JPRB/)
KBO( :, 1,28,14) = (/&
&8.1302E+01_JPRB,8.1254E+01_JPRB,6.1208E+01_JPRB,4.2732E+01_JPRB,3.3493E+01_JPRB,3.3014E+01_JPRB/)
KBO( :, 2,28,14) = (/&
&8.1246E+01_JPRB,8.1198E+01_JPRB,6.1149E+01_JPRB,4.2327E+01_JPRB,3.2380E+01_JPRB,3.1684E+01_JPRB/)
KBO( :, 3,28,14) = (/&
&8.0968E+01_JPRB,8.0920E+01_JPRB,6.0927E+01_JPRB,4.1887E+01_JPRB,3.1259E+01_JPRB,3.0389E+01_JPRB/)
KBO( :, 4,28,14) = (/&
&8.0565E+01_JPRB,8.0517E+01_JPRB,6.0611E+01_JPRB,4.1407E+01_JPRB,3.0143E+01_JPRB,2.9193E+01_JPRB/)
KBO( :, 5,28,14) = (/&
&7.9942E+01_JPRB,7.9894E+01_JPRB,6.0131E+01_JPRB,4.0878E+01_JPRB,2.9022E+01_JPRB,2.8027E+01_JPRB/)
KBO( :, 1,29,14) = (/&
&8.1307E+01_JPRB,8.1259E+01_JPRB,6.1205E+01_JPRB,4.3500E+01_JPRB,3.5359E+01_JPRB,3.5050E+01_JPRB/)
KBO( :, 2,29,14) = (/&
&8.1478E+01_JPRB,8.1430E+01_JPRB,6.1314E+01_JPRB,4.3042E+01_JPRB,3.4075E+01_JPRB,3.3533E+01_JPRB/)
KBO( :, 3,29,14) = (/&
&8.1374E+01_JPRB,8.1326E+01_JPRB,6.1221E+01_JPRB,4.2543E+01_JPRB,3.2801E+01_JPRB,3.2073E+01_JPRB/)
KBO( :, 4,29,14) = (/&
&8.1081E+01_JPRB,8.1032E+01_JPRB,6.0988E+01_JPRB,4.2019E+01_JPRB,3.1534E+01_JPRB,3.0765E+01_JPRB/)
KBO( :, 5,29,14) = (/&
&8.0577E+01_JPRB,8.0529E+01_JPRB,6.0599E+01_JPRB,4.1461E+01_JPRB,3.0285E+01_JPRB,2.9423E+01_JPRB/)
KBO( :, 1,30,14) = (/&
&8.1051E+01_JPRB,8.1003E+01_JPRB,6.1003E+01_JPRB,4.4185E+01_JPRB,3.7000E+01_JPRB,3.6850E+01_JPRB/)
KBO( :, 2,30,14) = (/&
&8.1462E+01_JPRB,8.1414E+01_JPRB,6.1293E+01_JPRB,4.3687E+01_JPRB,3.5552E+01_JPRB,3.5134E+01_JPRB/)
KBO( :, 3,30,14) = (/&
&8.1539E+01_JPRB,8.1490E+01_JPRB,6.1337E+01_JPRB,4.3125E+01_JPRB,3.4127E+01_JPRB,3.3561E+01_JPRB/)
KBO( :, 4,30,14) = (/&
&8.1391E+01_JPRB,8.1342E+01_JPRB,6.1214E+01_JPRB,4.2562E+01_JPRB,3.2726E+01_JPRB,3.2101E+01_JPRB/)
KBO( :, 5,30,14) = (/&
&8.0955E+01_JPRB,8.0906E+01_JPRB,6.0875E+01_JPRB,4.1945E+01_JPRB,3.1354E+01_JPRB,3.0606E+01_JPRB/)
KBO( :, 1,31,14) = (/&
&8.0671E+01_JPRB,8.0623E+01_JPRB,6.0709E+01_JPRB,4.4790E+01_JPRB,3.8398E+01_JPRB,3.8352E+01_JPRB/)
KBO( :, 2,31,14) = (/&
&8.1282E+01_JPRB,8.1234E+01_JPRB,6.1149E+01_JPRB,4.4230E+01_JPRB,3.6789E+01_JPRB,3.6501E+01_JPRB/)
KBO( :, 3,31,14) = (/&
&8.1574E+01_JPRB,8.1525E+01_JPRB,6.1354E+01_JPRB,4.3641E+01_JPRB,3.5216E+01_JPRB,3.4852E+01_JPRB/)
KBO( :, 4,31,14) = (/&
&8.1529E+01_JPRB,8.1481E+01_JPRB,6.1310E+01_JPRB,4.3014E+01_JPRB,3.3693E+01_JPRB,3.3201E+01_JPRB/)
KBO( :, 5,31,14) = (/&
&8.1189E+01_JPRB,8.1141E+01_JPRB,6.1044E+01_JPRB,4.2350E+01_JPRB,3.2213E+01_JPRB,3.1581E+01_JPRB/)
KBO( :, 1,32,14) = (/&
&8.0273E+01_JPRB,8.0225E+01_JPRB,6.0440E+01_JPRB,4.5305E+01_JPRB,3.9524E+01_JPRB,3.9577E+01_JPRB/)
KBO( :, 2,32,14) = (/&
&8.1061E+01_JPRB,8.1013E+01_JPRB,6.0977E+01_JPRB,4.4682E+01_JPRB,3.7774E+01_JPRB,3.7685E+01_JPRB/)
KBO( :, 3,32,14) = (/&
&8.1507E+01_JPRB,8.1459E+01_JPRB,6.1299E+01_JPRB,4.4057E+01_JPRB,3.6074E+01_JPRB,3.5862E+01_JPRB/)
KBO( :, 4,32,14) = (/&
&8.1572E+01_JPRB,8.1523E+01_JPRB,6.1336E+01_JPRB,4.3367E+01_JPRB,3.4447E+01_JPRB,3.4068E+01_JPRB/)
KBO( :, 5,32,14) = (/&
&8.1328E+01_JPRB,8.1279E+01_JPRB,6.1143E+01_JPRB,4.2670E+01_JPRB,3.2874E+01_JPRB,3.2515E+01_JPRB/)
KBO( :, 1,33,14) = (/&
&7.9947E+01_JPRB,7.9899E+01_JPRB,6.0245E+01_JPRB,4.5734E+01_JPRB,4.0389E+01_JPRB,4.0600E+01_JPRB/)
KBO( :, 2,33,14) = (/&
&8.0885E+01_JPRB,8.0836E+01_JPRB,6.0856E+01_JPRB,4.5062E+01_JPRB,3.8518E+01_JPRB,3.8594E+01_JPRB/)
KBO( :, 3,33,14) = (/&
&8.1444E+01_JPRB,8.1395E+01_JPRB,6.1246E+01_JPRB,4.4394E+01_JPRB,3.6721E+01_JPRB,3.6614E+01_JPRB/)
KBO( :, 4,33,14) = (/&
&8.1576E+01_JPRB,8.1528E+01_JPRB,6.1332E+01_JPRB,4.3653E+01_JPRB,3.5005E+01_JPRB,3.4830E+01_JPRB/)
KBO( :, 5,33,14) = (/&
&8.1383E+01_JPRB,8.1335E+01_JPRB,6.1178E+01_JPRB,4.2909E+01_JPRB,3.3354E+01_JPRB,3.3470E+01_JPRB/)
KBO( :, 1,34,14) = (/&
&7.9662E+01_JPRB,7.9614E+01_JPRB,6.0102E+01_JPRB,4.6098E+01_JPRB,4.1095E+01_JPRB,4.1483E+01_JPRB/)
KBO( :, 2,34,14) = (/&
&8.0738E+01_JPRB,8.0690E+01_JPRB,6.0775E+01_JPRB,4.5387E+01_JPRB,3.9122E+01_JPRB,3.9299E+01_JPRB/)
KBO( :, 3,34,14) = (/&
&8.1366E+01_JPRB,8.1318E+01_JPRB,6.1186E+01_JPRB,4.4659E+01_JPRB,3.7233E+01_JPRB,3.7257E+01_JPRB/)
KBO( :, 4,34,14) = (/&
&8.1568E+01_JPRB,8.1519E+01_JPRB,6.1321E+01_JPRB,4.3886E+01_JPRB,3.5446E+01_JPRB,3.5711E+01_JPRB/)
KBO( :, 5,34,14) = (/&
&8.1413E+01_JPRB,8.1365E+01_JPRB,6.1195E+01_JPRB,4.3093E+01_JPRB,3.3726E+01_JPRB,3.4415E+01_JPRB/)
KBO( :, 1,35,14) = (/&
&7.9337E+01_JPRB,7.9289E+01_JPRB,5.9949E+01_JPRB,4.6449E+01_JPRB,4.1796E+01_JPRB,4.2326E+01_JPRB/)
KBO( :, 2,35,14) = (/&
&8.0544E+01_JPRB,8.0496E+01_JPRB,6.0670E+01_JPRB,4.5697E+01_JPRB,3.9737E+01_JPRB,4.0033E+01_JPRB/)
KBO( :, 3,35,14) = (/&
&8.1258E+01_JPRB,8.1209E+01_JPRB,6.1112E+01_JPRB,4.4918E+01_JPRB,3.7765E+01_JPRB,3.8111E+01_JPRB/)
KBO( :, 4,35,14) = (/&
&8.1537E+01_JPRB,8.1488E+01_JPRB,6.1295E+01_JPRB,4.4118E+01_JPRB,3.5911E+01_JPRB,3.6760E+01_JPRB/)
KBO( :, 5,35,14) = (/&
&8.1445E+01_JPRB,8.1397E+01_JPRB,6.1217E+01_JPRB,4.3296E+01_JPRB,3.4131E+01_JPRB,3.5503E+01_JPRB/)
KBO( :, 1,36,14) = (/&
&7.8929E+01_JPRB,7.8882E+01_JPRB,5.9746E+01_JPRB,4.6822E+01_JPRB,4.2579E+01_JPRB,4.3271E+01_JPRB/)
KBO( :, 2,36,14) = (/&
&8.0271E+01_JPRB,8.0223E+01_JPRB,6.0527E+01_JPRB,4.6026E+01_JPRB,4.0432E+01_JPRB,4.0931E+01_JPRB/)
KBO( :, 3,36,14) = (/&
&8.1107E+01_JPRB,8.1058E+01_JPRB,6.1024E+01_JPRB,4.5215E+01_JPRB,3.8381E+01_JPRB,3.9211E+01_JPRB/)
KBO( :, 4,36,14) = (/&
&8.1508E+01_JPRB,8.1459E+01_JPRB,6.1272E+01_JPRB,4.4394E+01_JPRB,3.6464E+01_JPRB,3.7915E+01_JPRB/)
KBO( :, 5,36,14) = (/&
&8.1479E+01_JPRB,8.1431E+01_JPRB,6.1242E+01_JPRB,4.3542E+01_JPRB,3.4625E+01_JPRB,3.6634E+01_JPRB/)
KBO( :, 1,37,14) = (/&
&7.8277E+01_JPRB,7.8230E+01_JPRB,5.9419E+01_JPRB,4.7267E+01_JPRB,4.3580E+01_JPRB,4.4454E+01_JPRB/)
KBO( :, 2,37,14) = (/&
&7.9839E+01_JPRB,7.9792E+01_JPRB,6.0300E+01_JPRB,4.6427E+01_JPRB,4.1343E+01_JPRB,4.2071E+01_JPRB/)
KBO( :, 3,37,14) = (/&
&8.0875E+01_JPRB,8.0827E+01_JPRB,6.0897E+01_JPRB,4.5598E+01_JPRB,3.9207E+01_JPRB,4.0399E+01_JPRB/)
KBO( :, 4,37,14) = (/&
&8.1407E+01_JPRB,8.1359E+01_JPRB,6.1209E+01_JPRB,4.4745E+01_JPRB,3.7210E+01_JPRB,3.9084E+01_JPRB/)
KBO( :, 5,37,14) = (/&
&8.1511E+01_JPRB,8.1463E+01_JPRB,6.1267E+01_JPRB,4.3885E+01_JPRB,3.5313E+01_JPRB,3.7757E+01_JPRB/)
KBO( :, 1,38,14) = (/&
&7.7604E+01_JPRB,7.7558E+01_JPRB,5.9100E+01_JPRB,4.7673E+01_JPRB,4.4519E+01_JPRB,4.5590E+01_JPRB/)
KBO( :, 2,38,14) = (/&
&7.9387E+01_JPRB,7.9340E+01_JPRB,6.0071E+01_JPRB,4.6807E+01_JPRB,4.2192E+01_JPRB,4.3208E+01_JPRB/)
KBO( :, 3,38,14) = (/&
&8.0600E+01_JPRB,8.0552E+01_JPRB,6.0751E+01_JPRB,4.5947E+01_JPRB,3.9982E+01_JPRB,4.1623E+01_JPRB/)
KBO( :, 4,38,14) = (/&
&8.1297E+01_JPRB,8.1248E+01_JPRB,6.1150E+01_JPRB,4.5081E+01_JPRB,3.7909E+01_JPRB,4.0273E+01_JPRB/)
KBO( :, 5,38,14) = (/&
&8.1523E+01_JPRB,8.1474E+01_JPRB,6.1279E+01_JPRB,4.4207E+01_JPRB,3.5960E+01_JPRB,3.8923E+01_JPRB/)
KBO( :, 1,39,14) = (/&
&7.6924E+01_JPRB,7.6879E+01_JPRB,5.8785E+01_JPRB,4.8037E+01_JPRB,4.5384E+01_JPRB,4.6696E+01_JPRB/)
KBO( :, 2,39,14) = (/&
&7.8919E+01_JPRB,7.8872E+01_JPRB,5.9835E+01_JPRB,4.7151E+01_JPRB,4.2965E+01_JPRB,4.4375E+01_JPRB/)
KBO( :, 3,39,14) = (/&
&8.0301E+01_JPRB,8.0253E+01_JPRB,6.0596E+01_JPRB,4.6264E+01_JPRB,4.0694E+01_JPRB,4.2894E+01_JPRB/)
KBO( :, 4,39,14) = (/&
&8.1135E+01_JPRB,8.1087E+01_JPRB,6.1060E+01_JPRB,4.5380E+01_JPRB,3.8551E+01_JPRB,4.1533E+01_JPRB/)
KBO( :, 5,39,14) = (/&
&8.1498E+01_JPRB,8.1449E+01_JPRB,6.1268E+01_JPRB,4.4494E+01_JPRB,3.6550E+01_JPRB,4.0180E+01_JPRB/)
KBO( :, 1,40,14) = (/&
&7.6003E+01_JPRB,7.5957E+01_JPRB,5.8367E+01_JPRB,4.8484E+01_JPRB,4.6448E+01_JPRB,4.7942E+01_JPRB/)
KBO( :, 2,40,14) = (/&
&7.8250E+01_JPRB,7.8203E+01_JPRB,5.9505E+01_JPRB,4.7557E+01_JPRB,4.3937E+01_JPRB,4.5516E+01_JPRB/)
KBO( :, 3,40,14) = (/&
&7.9849E+01_JPRB,7.9801E+01_JPRB,6.0362E+01_JPRB,4.6641E+01_JPRB,4.1586E+01_JPRB,4.3950E+01_JPRB/)
KBO( :, 4,40,14) = (/&
&8.0899E+01_JPRB,8.0851E+01_JPRB,6.0936E+01_JPRB,4.5752E+01_JPRB,3.9370E+01_JPRB,4.2576E+01_JPRB/)
KBO( :, 5,40,14) = (/&
&8.1420E+01_JPRB,8.1371E+01_JPRB,6.1226E+01_JPRB,4.4847E+01_JPRB,3.7301E+01_JPRB,4.1187E+01_JPRB/)
KBO( :, 1,41,14) = (/&
&7.5005E+01_JPRB,7.4960E+01_JPRB,5.7923E+01_JPRB,4.8919E+01_JPRB,4.7504E+01_JPRB,4.9183E+01_JPRB/)
KBO( :, 2,41,14) = (/&
&7.7512E+01_JPRB,7.7466E+01_JPRB,5.9150E+01_JPRB,4.7955E+01_JPRB,4.4905E+01_JPRB,4.6631E+01_JPRB/)
KBO( :, 3,41,14) = (/&
&7.9348E+01_JPRB,7.9301E+01_JPRB,6.0108E+01_JPRB,4.7025E+01_JPRB,4.2473E+01_JPRB,4.4967E+01_JPRB/)
KBO( :, 4,41,14) = (/&
&8.0591E+01_JPRB,8.0543E+01_JPRB,6.0779E+01_JPRB,4.6109E+01_JPRB,4.0189E+01_JPRB,4.3586E+01_JPRB/)
KBO( :, 5,41,14) = (/&
&8.1296E+01_JPRB,8.1247E+01_JPRB,6.1167E+01_JPRB,4.5201E+01_JPRB,3.8056E+01_JPRB,4.2157E+01_JPRB/)
KBO( :, 1,42,14) = (/&
&7.3966E+01_JPRB,7.3922E+01_JPRB,5.7469E+01_JPRB,4.9337E+01_JPRB,4.8525E+01_JPRB,5.0393E+01_JPRB/)
KBO( :, 2,42,14) = (/&
&7.6721E+01_JPRB,7.6675E+01_JPRB,5.8783E+01_JPRB,4.8336E+01_JPRB,4.5846E+01_JPRB,4.7757E+01_JPRB/)
KBO( :, 3,42,14) = (/&
&7.8788E+01_JPRB,7.8741E+01_JPRB,5.9830E+01_JPRB,4.7390E+01_JPRB,4.3338E+01_JPRB,4.6001E+01_JPRB/)
KBO( :, 4,42,14) = (/&
&8.0252E+01_JPRB,8.0204E+01_JPRB,6.0610E+01_JPRB,4.6463E+01_JPRB,4.0990E+01_JPRB,4.4619E+01_JPRB/)
KBO( :, 5,42,14) = (/&
&8.1117E+01_JPRB,8.1069E+01_JPRB,6.1079E+01_JPRB,4.5535E+01_JPRB,3.8790E+01_JPRB,4.3153E+01_JPRB/)
KBO( :, 1,43,14) = (/&
&7.2705E+01_JPRB,7.2662E+01_JPRB,5.6918E+01_JPRB,4.9800E+01_JPRB,4.9669E+01_JPRB,5.1746E+01_JPRB/)
KBO( :, 2,43,14) = (/&
&7.5730E+01_JPRB,7.5685E+01_JPRB,5.8326E+01_JPRB,4.8759E+01_JPRB,4.6917E+01_JPRB,4.8987E+01_JPRB/)
KBO( :, 3,43,14) = (/&
&7.8083E+01_JPRB,7.8037E+01_JPRB,5.9488E+01_JPRB,4.7800E+01_JPRB,4.4326E+01_JPRB,4.7090E+01_JPRB/)
KBO( :, 4,43,14) = (/&
&7.9761E+01_JPRB,7.9714E+01_JPRB,6.0355E+01_JPRB,4.6841E+01_JPRB,4.1904E+01_JPRB,4.5691E+01_JPRB/)
KBO( :, 5,43,14) = (/&
&8.0847E+01_JPRB,8.0799E+01_JPRB,6.0937E+01_JPRB,4.5910E+01_JPRB,3.9634E+01_JPRB,4.4206E+01_JPRB/)
KBO( :, 1,44,14) = (/&
&7.1287E+01_JPRB,7.1245E+01_JPRB,5.6316E+01_JPRB,5.0292E+01_JPRB,5.0887E+01_JPRB,5.3170E+01_JPRB/)
KBO( :, 2,44,14) = (/&
&7.4599E+01_JPRB,7.4555E+01_JPRB,5.7821E+01_JPRB,4.9215E+01_JPRB,4.8047E+01_JPRB,5.0291E+01_JPRB/)
KBO( :, 3,44,14) = (/&
&7.7237E+01_JPRB,7.7191E+01_JPRB,5.9077E+01_JPRB,4.8209E+01_JPRB,4.5375E+01_JPRB,4.8245E+01_JPRB/)
KBO( :, 4,44,14) = (/&
&7.9186E+01_JPRB,7.9139E+01_JPRB,6.0066E+01_JPRB,4.7254E+01_JPRB,4.2877E+01_JPRB,4.6818E+01_JPRB/)
KBO( :, 5,44,14) = (/&
&8.0509E+01_JPRB,8.0461E+01_JPRB,6.0765E+01_JPRB,4.6310E+01_JPRB,4.0533E+01_JPRB,4.5323E+01_JPRB/)
KBO( :, 1,45,14) = (/&
&6.9761E+01_JPRB,6.9720E+01_JPRB,5.5680E+01_JPRB,5.0779E+01_JPRB,5.2112E+01_JPRB,5.4609E+01_JPRB/)
KBO( :, 2,45,14) = (/&
&7.3387E+01_JPRB,7.3344E+01_JPRB,5.7284E+01_JPRB,4.9658E+01_JPRB,4.9177E+01_JPRB,5.1651E+01_JPRB/)
KBO( :, 3,45,14) = (/&
&7.6302E+01_JPRB,7.6257E+01_JPRB,5.8639E+01_JPRB,4.8623E+01_JPRB,4.6419E+01_JPRB,4.9491E+01_JPRB/)
KBO( :, 4,45,14) = (/&
&7.8515E+01_JPRB,7.8468E+01_JPRB,5.9732E+01_JPRB,4.7651E+01_JPRB,4.3843E+01_JPRB,4.8016E+01_JPRB/)
KBO( :, 5,45,14) = (/&
&8.0070E+01_JPRB,8.0022E+01_JPRB,6.0538E+01_JPRB,4.6688E+01_JPRB,4.1436E+01_JPRB,4.6520E+01_JPRB/)
KBO( :, 1,46,14) = (/&
&6.8043E+01_JPRB,6.8003E+01_JPRB,5.4978E+01_JPRB,5.1296E+01_JPRB,5.3415E+01_JPRB,5.6131E+01_JPRB/)
KBO( :, 2,46,14) = (/&
&7.2020E+01_JPRB,7.1978E+01_JPRB,5.6693E+01_JPRB,5.0128E+01_JPRB,5.0366E+01_JPRB,5.3081E+01_JPRB/)
KBO( :, 3,46,14) = (/&
&7.5220E+01_JPRB,7.5175E+01_JPRB,5.8142E+01_JPRB,4.9054E+01_JPRB,4.7529E+01_JPRB,5.0825E+01_JPRB/)
KBO( :, 4,46,14) = (/&
&7.7714E+01_JPRB,7.7668E+01_JPRB,5.9339E+01_JPRB,4.8058E+01_JPRB,4.4874E+01_JPRB,4.9267E+01_JPRB/)
KBO( :, 5,46,14) = (/&
&7.9534E+01_JPRB,7.9486E+01_JPRB,6.0264E+01_JPRB,4.7084E+01_JPRB,4.2395E+01_JPRB,4.7792E+01_JPRB/)
KBO( :, 1,47,14) = (/&
&6.6054E+01_JPRB,6.6015E+01_JPRB,5.4183E+01_JPRB,5.1903E+01_JPRB,5.4894E+01_JPRB,5.7778E+01_JPRB/)
KBO( :, 2,47,14) = (/&
&7.0378E+01_JPRB,7.0336E+01_JPRB,5.5996E+01_JPRB,5.0654E+01_JPRB,5.1707E+01_JPRB,5.4608E+01_JPRB/)
KBO( :, 3,47,14) = (/&
&7.3908E+01_JPRB,7.3864E+01_JPRB,5.7556E+01_JPRB,4.9537E+01_JPRB,4.8774E+01_JPRB,5.2210E+01_JPRB/)
KBO( :, 4,47,14) = (/&
&7.6726E+01_JPRB,7.6681E+01_JPRB,5.8866E+01_JPRB,4.8503E+01_JPRB,4.6033E+01_JPRB,5.0483E+01_JPRB/)
KBO( :, 5,47,14) = (/&
&7.8817E+01_JPRB,7.8770E+01_JPRB,5.9899E+01_JPRB,4.7521E+01_JPRB,4.3467E+01_JPRB,4.9057E+01_JPRB/)
KBO( :, 1,48,14) = (/&
&6.3955E+01_JPRB,6.3917E+01_JPRB,5.3354E+01_JPRB,5.2548E+01_JPRB,5.6389E+01_JPRB,5.9437E+01_JPRB/)
KBO( :, 2,48,14) = (/&
&6.8594E+01_JPRB,6.8553E+01_JPRB,5.5256E+01_JPRB,5.1194E+01_JPRB,5.3073E+01_JPRB,5.6223E+01_JPRB/)
KBO( :, 3,48,14) = (/&
&7.2478E+01_JPRB,7.2435E+01_JPRB,5.6928E+01_JPRB,5.0025E+01_JPRB,5.0034E+01_JPRB,5.3708E+01_JPRB/)
KBO( :, 4,48,14) = (/&
&7.5613E+01_JPRB,7.5568E+01_JPRB,5.8350E+01_JPRB,4.8962E+01_JPRB,4.7206E+01_JPRB,5.1823E+01_JPRB/)
KBO( :, 5,48,14) = (/&
&7.8004E+01_JPRB,7.7958E+01_JPRB,5.9498E+01_JPRB,4.7959E+01_JPRB,4.4557E+01_JPRB,5.0435E+01_JPRB/)
KBO( :, 1,49,14) = (/&
&6.1733E+01_JPRB,6.1696E+01_JPRB,5.2490E+01_JPRB,5.3233E+01_JPRB,5.7911E+01_JPRB,6.1164E+01_JPRB/)
KBO( :, 2,49,14) = (/&
&6.6686E+01_JPRB,6.6647E+01_JPRB,5.4483E+01_JPRB,5.1761E+01_JPRB,5.4482E+01_JPRB,5.7948E+01_JPRB/)
KBO( :, 3,49,14) = (/&
&7.0933E+01_JPRB,7.0891E+01_JPRB,5.6270E+01_JPRB,5.0531E+01_JPRB,5.1319E+01_JPRB,5.5363E+01_JPRB/)
KBO( :, 4,49,14) = (/&
&7.4366E+01_JPRB,7.4322E+01_JPRB,5.7787E+01_JPRB,4.9421E+01_JPRB,4.8403E+01_JPRB,5.3357E+01_JPRB/)
KBO( :, 5,49,14) = (/&
&7.7078E+01_JPRB,7.7033E+01_JPRB,5.9049E+01_JPRB,4.8386E+01_JPRB,4.5673E+01_JPRB,5.2019E+01_JPRB/)
KBO( :, 1,50,14) = (/&
&5.9556E+01_JPRB,5.9521E+01_JPRB,5.1669E+01_JPRB,5.3919E+01_JPRB,5.9382E+01_JPRB,6.2781E+01_JPRB/)
KBO( :, 2,50,14) = (/&
&6.4814E+01_JPRB,6.4775E+01_JPRB,5.3744E+01_JPRB,5.2339E+01_JPRB,5.5844E+01_JPRB,5.9493E+01_JPRB/)
KBO( :, 3,50,14) = (/&
&6.9336E+01_JPRB,6.9295E+01_JPRB,5.5596E+01_JPRB,5.1013E+01_JPRB,5.2559E+01_JPRB,5.6778E+01_JPRB/)
KBO( :, 4,50,14) = (/&
&7.3091E+01_JPRB,7.3048E+01_JPRB,5.7225E+01_JPRB,4.9862E+01_JPRB,4.9551E+01_JPRB,5.4617E+01_JPRB/)
KBO( :, 5,50,14) = (/&
&7.6098E+01_JPRB,7.6053E+01_JPRB,5.8589E+01_JPRB,4.8799E+01_JPRB,4.6739E+01_JPRB,5.3303E+01_JPRB/)
KBO( :, 1,51,14) = (/&
&5.7367E+01_JPRB,5.7333E+01_JPRB,5.0871E+01_JPRB,5.4612E+01_JPRB,6.0840E+01_JPRB,6.4373E+01_JPRB/)
KBO( :, 2,51,14) = (/&
&6.2885E+01_JPRB,6.2848E+01_JPRB,5.2984E+01_JPRB,5.2932E+01_JPRB,5.7187E+01_JPRB,6.0966E+01_JPRB/)
KBO( :, 3,51,14) = (/&
&6.7687E+01_JPRB,6.7647E+01_JPRB,5.4925E+01_JPRB,5.1505E+01_JPRB,5.3793E+01_JPRB,5.8080E+01_JPRB/)
KBO( :, 4,51,14) = (/&
&7.1761E+01_JPRB,7.1718E+01_JPRB,5.6647E+01_JPRB,5.0300E+01_JPRB,5.0681E+01_JPRB,5.5789E+01_JPRB/)
KBO( :, 5,51,14) = (/&
&7.5046E+01_JPRB,7.5001E+01_JPRB,5.8108E+01_JPRB,4.9204E+01_JPRB,4.7793E+01_JPRB,5.4431E+01_JPRB/)
KBO( :, 1,52,14) = (/&
&5.5098E+01_JPRB,5.5065E+01_JPRB,5.0074E+01_JPRB,5.5358E+01_JPRB,6.2317E+01_JPRB,6.6056E+01_JPRB/)
KBO( :, 2,52,14) = (/&
&6.0852E+01_JPRB,6.0816E+01_JPRB,5.2195E+01_JPRB,5.3549E+01_JPRB,5.8551E+01_JPRB,6.2483E+01_JPRB/)
KBO( :, 3,52,14) = (/&
&6.5953E+01_JPRB,6.5914E+01_JPRB,5.4229E+01_JPRB,5.2028E+01_JPRB,5.5063E+01_JPRB,5.9490E+01_JPRB/)
KBO( :, 4,52,14) = (/&
&7.0320E+01_JPRB,7.0278E+01_JPRB,5.6036E+01_JPRB,5.0747E+01_JPRB,5.1835E+01_JPRB,5.7114E+01_JPRB/)
KBO( :, 5,52,14) = (/&
&7.3892E+01_JPRB,7.3848E+01_JPRB,5.7595E+01_JPRB,4.9618E+01_JPRB,4.8874E+01_JPRB,5.5672E+01_JPRB/)
KBO( :, 1,53,14) = (/&
&5.2721E+01_JPRB,5.2690E+01_JPRB,4.9263E+01_JPRB,5.6120E+01_JPRB,6.3814E+01_JPRB,6.7766E+01_JPRB/)
KBO( :, 2,53,14) = (/&
&5.8756E+01_JPRB,5.8721E+01_JPRB,5.1411E+01_JPRB,5.4211E+01_JPRB,5.9956E+01_JPRB,6.4072E+01_JPRB/)
KBO( :, 3,53,14) = (/&
&6.4126E+01_JPRB,6.4088E+01_JPRB,5.3502E+01_JPRB,5.2588E+01_JPRB,5.6365E+01_JPRB,6.1039E+01_JPRB/)
KBO( :, 4,53,14) = (/&
&6.8738E+01_JPRB,6.8697E+01_JPRB,5.5371E+01_JPRB,5.1205E+01_JPRB,5.3025E+01_JPRB,5.8602E+01_JPRB/)
KBO( :, 5,53,14) = (/&
&7.2636E+01_JPRB,7.2593E+01_JPRB,5.7041E+01_JPRB,5.0037E+01_JPRB,4.9973E+01_JPRB,5.7127E+01_JPRB/)
KBO( :, 1,54,14) = (/&
&5.0488E+01_JPRB,5.0458E+01_JPRB,4.8529E+01_JPRB,5.6862E+01_JPRB,6.5226E+01_JPRB,6.9287E+01_JPRB/)
KBO( :, 2,54,14) = (/&
&5.6752E+01_JPRB,5.6718E+01_JPRB,5.0683E+01_JPRB,5.4841E+01_JPRB,6.1279E+01_JPRB,6.5223E+01_JPRB/)
KBO( :, 3,54,14) = (/&
&6.2359E+01_JPRB,6.2322E+01_JPRB,5.2805E+01_JPRB,5.3124E+01_JPRB,5.7582E+01_JPRB,6.2132E+01_JPRB/)
KBO( :, 4,54,14) = (/&
&6.7239E+01_JPRB,6.7199E+01_JPRB,5.4766E+01_JPRB,5.1664E+01_JPRB,5.4149E+01_JPRB,5.9478E+01_JPRB/)
KBO( :, 5,54,14) = (/&
&7.1401E+01_JPRB,7.1358E+01_JPRB,5.6510E+01_JPRB,5.0433E+01_JPRB,5.0999E+01_JPRB,5.7575E+01_JPRB/)
KBO( :, 1,55,14) = (/&
&4.8301E+01_JPRB,4.8272E+01_JPRB,4.7833E+01_JPRB,5.7595E+01_JPRB,6.6585E+01_JPRB,7.0689E+01_JPRB/)
KBO( :, 2,55,14) = (/&
&5.4769E+01_JPRB,5.4736E+01_JPRB,4.9988E+01_JPRB,5.5495E+01_JPRB,6.2560E+01_JPRB,6.6385E+01_JPRB/)
KBO( :, 3,55,14) = (/&
&6.0573E+01_JPRB,6.0537E+01_JPRB,5.2112E+01_JPRB,5.3664E+01_JPRB,5.8770E+01_JPRB,6.2943E+01_JPRB/)
KBO( :, 4,55,14) = (/&
&6.5713E+01_JPRB,6.5674E+01_JPRB,5.4151E+01_JPRB,5.2119E+01_JPRB,5.5258E+01_JPRB,6.0010E+01_JPRB/)
KBO( :, 5,55,14) = (/&
&7.0126E+01_JPRB,7.0084E+01_JPRB,5.5970E+01_JPRB,5.0826E+01_JPRB,5.2008E+01_JPRB,5.7678E+01_JPRB/)
KBO( :, 1,56,14) = (/&
&4.6079E+01_JPRB,4.6051E+01_JPRB,4.7176E+01_JPRB,5.8356E+01_JPRB,6.7969E+01_JPRB,7.2050E+01_JPRB/)
KBO( :, 2,56,14) = (/&
&5.2701E+01_JPRB,5.2670E+01_JPRB,4.9282E+01_JPRB,5.6152E+01_JPRB,6.3857E+01_JPRB,6.7749E+01_JPRB/)
KBO( :, 3,56,14) = (/&
&5.8754E+01_JPRB,5.8720E+01_JPRB,5.1436E+01_JPRB,5.4239E+01_JPRB,5.9985E+01_JPRB,6.3792E+01_JPRB/)
KBO( :, 4,56,14) = (/&
&6.4130E+01_JPRB,6.4092E+01_JPRB,5.3523E+01_JPRB,5.2605E+01_JPRB,5.6386E+01_JPRB,6.0677E+01_JPRB/)
KBO( :, 5,56,14) = (/&
&6.8768E+01_JPRB,6.8727E+01_JPRB,5.5406E+01_JPRB,5.1229E+01_JPRB,5.3042E+01_JPRB,5.8111E+01_JPRB/)
KBO( :, 1,57,14) = (/&
&4.3796E+01_JPRB,4.3770E+01_JPRB,4.6545E+01_JPRB,5.9133E+01_JPRB,6.9380E+01_JPRB,7.3404E+01_JPRB/)
KBO( :, 2,57,14) = (/&
&5.0589E+01_JPRB,5.0559E+01_JPRB,4.8583E+01_JPRB,5.6850E+01_JPRB,6.5189E+01_JPRB,6.9103E+01_JPRB/)
KBO( :, 3,57,14) = (/&
&5.6860E+01_JPRB,5.6826E+01_JPRB,5.0745E+01_JPRB,5.4829E+01_JPRB,6.1234E+01_JPRB,6.4852E+01_JPRB/)
KBO( :, 4,57,14) = (/&
&6.2462E+01_JPRB,6.2424E+01_JPRB,5.2862E+01_JPRB,5.3112E+01_JPRB,5.7531E+01_JPRB,6.1451E+01_JPRB/)
KBO( :, 5,57,14) = (/&
&6.7340E+01_JPRB,6.7300E+01_JPRB,5.4823E+01_JPRB,5.1656E+01_JPRB,5.4098E+01_JPRB,5.8580E+01_JPRB/)
KBO( :, 1,58,14) = (/&
&4.1597E+01_JPRB,4.1573E+01_JPRB,4.5980E+01_JPRB,5.9890E+01_JPRB,7.0733E+01_JPRB,7.4721E+01_JPRB/)
KBO( :, 2,58,14) = (/&
&4.8541E+01_JPRB,4.8512E+01_JPRB,4.7924E+01_JPRB,5.7530E+01_JPRB,6.6457E+01_JPRB,7.0297E+01_JPRB/)
KBO( :, 3,58,14) = (/&
&5.5001E+01_JPRB,5.4968E+01_JPRB,5.0085E+01_JPRB,5.5434E+01_JPRB,6.2433E+01_JPRB,6.6096E+01_JPRB/)
KBO( :, 4,58,14) = (/&
&6.0796E+01_JPRB,6.0760E+01_JPRB,5.2213E+01_JPRB,5.3615E+01_JPRB,5.8644E+01_JPRB,6.2188E+01_JPRB/)
KBO( :, 5,58,14) = (/&
&6.5915E+01_JPRB,6.5876E+01_JPRB,5.4248E+01_JPRB,5.2078E+01_JPRB,5.5135E+01_JPRB,5.9028E+01_JPRB/)
KBO( :, 1,59,14) = (/&
&4.0694E+01_JPRB,4.0670E+01_JPRB,4.5769E+01_JPRB,6.0220E+01_JPRB,7.1303E+01_JPRB,7.5294E+01_JPRB/)
KBO( :, 2,59,14) = (/&
&4.7704E+01_JPRB,4.7676E+01_JPRB,4.7670E+01_JPRB,5.7820E+01_JPRB,6.6989E+01_JPRB,7.0669E+01_JPRB/)
KBO( :, 3,59,14) = (/&
&5.4223E+01_JPRB,5.4191E+01_JPRB,4.9817E+01_JPRB,5.5687E+01_JPRB,6.2924E+01_JPRB,6.6331E+01_JPRB/)
KBO( :, 4,59,14) = (/&
&6.0110E+01_JPRB,6.0074E+01_JPRB,5.1957E+01_JPRB,5.3831E+01_JPRB,5.9105E+01_JPRB,6.2224E+01_JPRB/)
KBO( :, 5,59,14) = (/&
&6.5318E+01_JPRB,6.5279E+01_JPRB,5.4011E+01_JPRB,5.2258E+01_JPRB,5.5565E+01_JPRB,5.8638E+01_JPRB/)
KBO( :, 1,13,15) = (/&
&3.6131E+01_JPRB,3.6111E+01_JPRB,2.7504E+01_JPRB,1.8893E+01_JPRB,1.0455E+01_JPRB,8.3589E+00_JPRB/)
KBO( :, 2,13,15) = (/&
&3.5587E+01_JPRB,3.5567E+01_JPRB,2.7173E+01_JPRB,1.8796E+01_JPRB,1.0430E+01_JPRB,8.1741E+00_JPRB/)
KBO( :, 3,13,15) = (/&
&3.5232E+01_JPRB,3.5212E+01_JPRB,2.6920E+01_JPRB,1.8645E+01_JPRB,1.0345E+01_JPRB,8.4671E+00_JPRB/)
KBO( :, 4,13,15) = (/&
&3.5001E+01_JPRB,3.4981E+01_JPRB,2.6729E+01_JPRB,1.8467E+01_JPRB,1.0232E+01_JPRB,9.0834E+00_JPRB/)
KBO( :, 5,13,15) = (/&
&3.4785E+01_JPRB,3.4765E+01_JPRB,2.6543E+01_JPRB,1.8302E+01_JPRB,1.0125E+01_JPRB,1.1028E+01_JPRB/)
KBO( :, 1,14,15) = (/&
&4.1079E+01_JPRB,4.1055E+01_JPRB,3.1300E+01_JPRB,2.1582E+01_JPRB,1.1853E+01_JPRB,9.3349E+00_JPRB/)
KBO( :, 2,14,15) = (/&
&4.0876E+01_JPRB,4.0852E+01_JPRB,3.1181E+01_JPRB,2.1527E+01_JPRB,1.1831E+01_JPRB,9.0870E+00_JPRB/)
KBO( :, 3,14,15) = (/&
&4.0794E+01_JPRB,4.0770E+01_JPRB,3.1110E+01_JPRB,2.1447E+01_JPRB,1.1767E+01_JPRB,9.0396E+00_JPRB/)
KBO( :, 4,14,15) = (/&
&4.0674E+01_JPRB,4.0650E+01_JPRB,3.1006E+01_JPRB,2.1331E+01_JPRB,1.1685E+01_JPRB,9.1026E+00_JPRB/)
KBO( :, 5,14,15) = (/&
&4.0556E+01_JPRB,4.0533E+01_JPRB,3.0850E+01_JPRB,2.1168E+01_JPRB,1.1577E+01_JPRB,9.5160E+00_JPRB/)
KBO( :, 1,15,15) = (/&
&4.7326E+01_JPRB,4.7299E+01_JPRB,3.6027E+01_JPRB,2.4785E+01_JPRB,1.3503E+01_JPRB,1.0407E+01_JPRB/)
KBO( :, 2,15,15) = (/&
&4.7413E+01_JPRB,4.7386E+01_JPRB,3.6106E+01_JPRB,2.4831E+01_JPRB,1.3509E+01_JPRB,1.0116E+01_JPRB/)
KBO( :, 3,15,15) = (/&
&4.7425E+01_JPRB,4.7398E+01_JPRB,3.6101E+01_JPRB,2.4790E+01_JPRB,1.3473E+01_JPRB,9.8259E+00_JPRB/)
KBO( :, 4,15,15) = (/&
&4.7432E+01_JPRB,4.7405E+01_JPRB,3.6056E+01_JPRB,2.4680E+01_JPRB,1.3388E+01_JPRB,9.8639E+00_JPRB/)
KBO( :, 5,15,15) = (/&
&4.7370E+01_JPRB,4.7342E+01_JPRB,3.5942E+01_JPRB,2.4552E+01_JPRB,1.3257E+01_JPRB,9.8173E+00_JPRB/)
KBO( :, 1,16,15) = (/&
&5.4875E+01_JPRB,5.4844E+01_JPRB,4.1702E+01_JPRB,2.8578E+01_JPRB,1.5437E+01_JPRB,1.1664E+01_JPRB/)
KBO( :, 2,16,15) = (/&
&5.5032E+01_JPRB,5.5000E+01_JPRB,4.1823E+01_JPRB,2.8656E+01_JPRB,1.5467E+01_JPRB,1.1353E+01_JPRB/)
KBO( :, 3,16,15) = (/&
&5.5199E+01_JPRB,5.5167E+01_JPRB,4.1916E+01_JPRB,2.8637E+01_JPRB,1.5432E+01_JPRB,1.1037E+01_JPRB/)
KBO( :, 4,16,15) = (/&
&5.5276E+01_JPRB,5.5244E+01_JPRB,4.1910E+01_JPRB,2.8561E+01_JPRB,1.5341E+01_JPRB,1.0976E+01_JPRB/)
KBO( :, 5,16,15) = (/&
&5.5278E+01_JPRB,5.5245E+01_JPRB,4.1857E+01_JPRB,2.8461E+01_JPRB,1.5222E+01_JPRB,1.0876E+01_JPRB/)
KBO( :, 1,17,15) = (/&
&6.3573E+01_JPRB,6.3536E+01_JPRB,4.8216E+01_JPRB,3.2905E+01_JPRB,1.7651E+01_JPRB,1.3317E+01_JPRB/)
KBO( :, 2,17,15) = (/&
&6.3845E+01_JPRB,6.3808E+01_JPRB,4.8400E+01_JPRB,3.2984E+01_JPRB,1.7690E+01_JPRB,1.2970E+01_JPRB/)
KBO( :, 3,17,15) = (/&
&6.4023E+01_JPRB,6.3985E+01_JPRB,4.8498E+01_JPRB,3.2989E+01_JPRB,1.7656E+01_JPRB,1.2620E+01_JPRB/)
KBO( :, 4,17,15) = (/&
&6.4166E+01_JPRB,6.4129E+01_JPRB,4.8557E+01_JPRB,3.2962E+01_JPRB,1.7567E+01_JPRB,1.2436E+01_JPRB/)
KBO( :, 5,17,15) = (/&
&6.4111E+01_JPRB,6.4073E+01_JPRB,4.8467E+01_JPRB,3.2855E+01_JPRB,1.7451E+01_JPRB,1.2281E+01_JPRB/)
KBO( :, 1,18,15) = (/&
&7.3440E+01_JPRB,7.3397E+01_JPRB,5.5592E+01_JPRB,3.7776E+01_JPRB,2.0119E+01_JPRB,1.5329E+01_JPRB/)
KBO( :, 2,18,15) = (/&
&7.3743E+01_JPRB,7.3700E+01_JPRB,5.5787E+01_JPRB,3.7865E+01_JPRB,2.0169E+01_JPRB,1.4924E+01_JPRB/)
KBO( :, 3,18,15) = (/&
&7.3962E+01_JPRB,7.3919E+01_JPRB,5.5904E+01_JPRB,3.7908E+01_JPRB,2.0135E+01_JPRB,1.4518E+01_JPRB/)
KBO( :, 4,18,15) = (/&
&7.3953E+01_JPRB,7.3909E+01_JPRB,5.5863E+01_JPRB,3.7855E+01_JPRB,2.0062E+01_JPRB,1.4197E+01_JPRB/)
KBO( :, 5,18,15) = (/&
&7.3825E+01_JPRB,7.3781E+01_JPRB,5.5741E+01_JPRB,3.7729E+01_JPRB,1.9926E+01_JPRB,1.3956E+01_JPRB/)
KBO( :, 1,19,15) = (/&
&8.4462E+01_JPRB,8.4413E+01_JPRB,6.3820E+01_JPRB,4.3253E+01_JPRB,2.2902E+01_JPRB,1.7600E+01_JPRB/)
KBO( :, 2,19,15) = (/&
&8.4860E+01_JPRB,8.4810E+01_JPRB,6.4094E+01_JPRB,4.3382E+01_JPRB,2.2923E+01_JPRB,1.7125E+01_JPRB/)
KBO( :, 3,19,15) = (/&
&8.4963E+01_JPRB,8.4913E+01_JPRB,6.4146E+01_JPRB,4.3401E+01_JPRB,2.2894E+01_JPRB,1.6619E+01_JPRB/)
KBO( :, 4,19,15) = (/&
&8.4919E+01_JPRB,8.4869E+01_JPRB,6.4089E+01_JPRB,4.3332E+01_JPRB,2.2791E+01_JPRB,1.6133E+01_JPRB/)
KBO( :, 5,19,15) = (/&
&8.4612E+01_JPRB,8.4563E+01_JPRB,6.3846E+01_JPRB,4.3142E+01_JPRB,2.2633E+01_JPRB,1.5830E+01_JPRB/)
KBO( :, 1,20,15) = (/&
&9.7043E+01_JPRB,9.6986E+01_JPRB,7.3234E+01_JPRB,4.9485E+01_JPRB,2.5962E+01_JPRB,2.0077E+01_JPRB/)
KBO( :, 2,20,15) = (/&
&9.7332E+01_JPRB,9.7275E+01_JPRB,7.3444E+01_JPRB,4.9611E+01_JPRB,2.5984E+01_JPRB,1.9505E+01_JPRB/)
KBO( :, 3,20,15) = (/&
&9.7370E+01_JPRB,9.7313E+01_JPRB,7.3448E+01_JPRB,4.9583E+01_JPRB,2.5915E+01_JPRB,1.8890E+01_JPRB/)
KBO( :, 4,20,15) = (/&
&9.7125E+01_JPRB,9.7068E+01_JPRB,7.3251E+01_JPRB,4.9424E+01_JPRB,2.5774E+01_JPRB,1.8285E+01_JPRB/)
KBO( :, 5,20,15) = (/&
&9.6643E+01_JPRB,9.6586E+01_JPRB,7.2853E+01_JPRB,4.9111E+01_JPRB,2.5548E+01_JPRB,1.7915E+01_JPRB/)
KBO( :, 1,21,15) = (/&
&1.1092E+02_JPRB,1.1085E+02_JPRB,8.3649E+01_JPRB,5.6418E+01_JPRB,2.9378E+01_JPRB,2.2812E+01_JPRB/)
KBO( :, 2,21,15) = (/&
&1.1109E+02_JPRB,1.1103E+02_JPRB,8.3756E+01_JPRB,5.6460E+01_JPRB,2.9344E+01_JPRB,2.2156E+01_JPRB/)
KBO( :, 3,21,15) = (/&
&1.1096E+02_JPRB,1.1089E+02_JPRB,8.3624E+01_JPRB,5.6337E+01_JPRB,2.9225E+01_JPRB,2.1484E+01_JPRB/)
KBO( :, 4,21,15) = (/&
&1.1048E+02_JPRB,1.1042E+02_JPRB,8.3238E+01_JPRB,5.6034E+01_JPRB,2.9000E+01_JPRB,2.0793E+01_JPRB/)
KBO( :, 5,21,15) = (/&
&1.0971E+02_JPRB,1.0964E+02_JPRB,8.2635E+01_JPRB,5.5599E+01_JPRB,2.8723E+01_JPRB,2.0338E+01_JPRB/)
KBO( :, 1,22,15) = (/&
&1.2596E+02_JPRB,1.2589E+02_JPRB,9.4893E+01_JPRB,6.3871E+01_JPRB,3.3059E+01_JPRB,2.5998E+01_JPRB/)
KBO( :, 2,22,15) = (/&
&1.2587E+02_JPRB,1.2580E+02_JPRB,9.4816E+01_JPRB,6.3793E+01_JPRB,3.2943E+01_JPRB,2.5227E+01_JPRB/)
KBO( :, 3,22,15) = (/&
&1.2541E+02_JPRB,1.2533E+02_JPRB,9.4434E+01_JPRB,6.3497E+01_JPRB,3.2730E+01_JPRB,2.4435E+01_JPRB/)
KBO( :, 4,22,15) = (/&
&1.2461E+02_JPRB,1.2453E+02_JPRB,9.3802E+01_JPRB,6.3040E+01_JPRB,3.2441E+01_JPRB,2.3619E+01_JPRB/)
KBO( :, 5,22,15) = (/&
&1.2345E+02_JPRB,1.2338E+02_JPRB,9.2915E+01_JPRB,6.2412E+01_JPRB,3.2063E+01_JPRB,2.3036E+01_JPRB/)
KBO( :, 1,23,15) = (/&
&1.4197E+02_JPRB,1.4188E+02_JPRB,1.0687E+02_JPRB,7.1809E+01_JPRB,3.7052E+01_JPRB,2.9587E+01_JPRB/)
KBO( :, 2,23,15) = (/&
&1.4145E+02_JPRB,1.4137E+02_JPRB,1.0646E+02_JPRB,7.1497E+01_JPRB,3.6788E+01_JPRB,2.8648E+01_JPRB/)
KBO( :, 3,23,15) = (/&
&1.4055E+02_JPRB,1.4047E+02_JPRB,1.0576E+02_JPRB,7.1003E+01_JPRB,3.6445E+01_JPRB,2.7684E+01_JPRB/)
KBO( :, 4,23,15) = (/&
&1.3924E+02_JPRB,1.3916E+02_JPRB,1.0475E+02_JPRB,7.0305E+01_JPRB,3.6030E+01_JPRB,2.6707E+01_JPRB/)
KBO( :, 5,23,15) = (/&
&1.3763E+02_JPRB,1.3754E+02_JPRB,1.0352E+02_JPRB,6.9448E+01_JPRB,3.5536E+01_JPRB,2.5941E+01_JPRB/)
KBO( :, 1,24,15) = (/&
&1.5875E+02_JPRB,1.5866E+02_JPRB,1.1943E+02_JPRB,8.0138E+01_JPRB,4.1339E+01_JPRB,3.3488E+01_JPRB/)
KBO( :, 2,24,15) = (/&
&1.5772E+02_JPRB,1.5762E+02_JPRB,1.1862E+02_JPRB,7.9566E+01_JPRB,4.0871E+01_JPRB,3.2326E+01_JPRB/)
KBO( :, 3,24,15) = (/&
&1.5618E+02_JPRB,1.5608E+02_JPRB,1.1744E+02_JPRB,7.8741E+01_JPRB,4.0347E+01_JPRB,3.1135E+01_JPRB/)
KBO( :, 4,24,15) = (/&
&1.5432E+02_JPRB,1.5423E+02_JPRB,1.1603E+02_JPRB,7.7772E+01_JPRB,3.9739E+01_JPRB,2.9970E+01_JPRB/)
KBO( :, 5,24,15) = (/&
&1.5201E+02_JPRB,1.5192E+02_JPRB,1.1428E+02_JPRB,7.6577E+01_JPRB,3.9078E+01_JPRB,2.8958E+01_JPRB/)
KBO( :, 1,25,15) = (/&
&1.7605E+02_JPRB,1.7595E+02_JPRB,1.3237E+02_JPRB,8.8710E+01_JPRB,4.5816E+01_JPRB,3.7592E+01_JPRB/)
KBO( :, 2,25,15) = (/&
&1.7422E+02_JPRB,1.7412E+02_JPRB,1.3097E+02_JPRB,8.7758E+01_JPRB,4.5131E+01_JPRB,3.6159E+01_JPRB/)
KBO( :, 3,25,15) = (/&
&1.7201E+02_JPRB,1.7191E+02_JPRB,1.2929E+02_JPRB,8.6602E+01_JPRB,4.4346E+01_JPRB,3.4734E+01_JPRB/)
KBO( :, 4,25,15) = (/&
&1.6938E+02_JPRB,1.6928E+02_JPRB,1.2730E+02_JPRB,8.5245E+01_JPRB,4.3518E+01_JPRB,3.3295E+01_JPRB/)
KBO( :, 5,25,15) = (/&
&1.6630E+02_JPRB,1.6620E+02_JPRB,1.2498E+02_JPRB,8.3665E+01_JPRB,4.2629E+01_JPRB,3.2020E+01_JPRB/)
KBO( :, 1,26,15) = (/&
&1.9312E+02_JPRB,1.9300E+02_JPRB,1.4513E+02_JPRB,9.7167E+01_JPRB,5.0350E+01_JPRB,4.1741E+01_JPRB/)
KBO( :, 2,26,15) = (/&
&1.9055E+02_JPRB,1.9044E+02_JPRB,1.4319E+02_JPRB,9.5848E+01_JPRB,4.9379E+01_JPRB,3.9996E+01_JPRB/)
KBO( :, 3,26,15) = (/&
&1.8750E+02_JPRB,1.8738E+02_JPRB,1.4088E+02_JPRB,9.4283E+01_JPRB,4.8328E+01_JPRB,3.8277E+01_JPRB/)
KBO( :, 4,26,15) = (/&
&1.8390E+02_JPRB,1.8379E+02_JPRB,1.3817E+02_JPRB,9.2456E+01_JPRB,4.7225E+01_JPRB,3.6567E+01_JPRB/)
KBO( :, 5,26,15) = (/&
&1.8004E+02_JPRB,1.7993E+02_JPRB,1.3525E+02_JPRB,9.0479E+01_JPRB,4.6075E+01_JPRB,3.5023E+01_JPRB/)
KBO( :, 1,27,15) = (/&
&2.0962E+02_JPRB,2.0950E+02_JPRB,1.5747E+02_JPRB,1.0535E+02_JPRB,5.4802E+01_JPRB,4.5812E+01_JPRB/)
KBO( :, 2,27,15) = (/&
&2.0617E+02_JPRB,2.0605E+02_JPRB,1.5487E+02_JPRB,1.0359E+02_JPRB,5.3500E+01_JPRB,4.3722E+01_JPRB/)
KBO( :, 3,27,15) = (/&
&2.0210E+02_JPRB,2.0198E+02_JPRB,1.5180E+02_JPRB,1.0153E+02_JPRB,5.2160E+01_JPRB,4.1668E+01_JPRB/)
KBO( :, 4,27,15) = (/&
&1.9765E+02_JPRB,1.9753E+02_JPRB,1.4844E+02_JPRB,9.9264E+01_JPRB,5.0764E+01_JPRB,3.9657E+01_JPRB/)
KBO( :, 5,27,15) = (/&
&1.9285E+02_JPRB,1.9273E+02_JPRB,1.4483E+02_JPRB,9.6837E+01_JPRB,4.9332E+01_JPRB,3.7870E+01_JPRB/)
KBO( :, 1,28,15) = (/&
&2.2504E+02_JPRB,2.2491E+02_JPRB,1.6900E+02_JPRB,1.1299E+02_JPRB,5.9023E+01_JPRB,4.9671E+01_JPRB/)
KBO( :, 2,28,15) = (/&
&2.2060E+02_JPRB,2.2047E+02_JPRB,1.6566E+02_JPRB,1.1075E+02_JPRB,5.7389E+01_JPRB,4.7215E+01_JPRB/)
KBO( :, 3,28,15) = (/&
&2.1560E+02_JPRB,2.1547E+02_JPRB,1.6190E+02_JPRB,1.0822E+02_JPRB,5.5706E+01_JPRB,4.4816E+01_JPRB/)
KBO( :, 4,28,15) = (/&
&2.1015E+02_JPRB,2.1002E+02_JPRB,1.5779E+02_JPRB,1.0547E+02_JPRB,5.4003E+01_JPRB,4.2483E+01_JPRB/)
KBO( :, 5,28,15) = (/&
&2.0436E+02_JPRB,2.0424E+02_JPRB,1.5344E+02_JPRB,1.0255E+02_JPRB,5.2316E+01_JPRB,4.0478E+01_JPRB/)
KBO( :, 1,29,15) = (/&
&2.3909E+02_JPRB,2.3895E+02_JPRB,1.7950E+02_JPRB,1.1994E+02_JPRB,6.2884E+01_JPRB,5.3166E+01_JPRB/)
KBO( :, 2,29,15) = (/&
&2.3356E+02_JPRB,2.3342E+02_JPRB,1.7535E+02_JPRB,1.1717E+02_JPRB,6.0903E+01_JPRB,5.0319E+01_JPRB/)
KBO( :, 3,29,15) = (/&
&2.2760E+02_JPRB,2.2747E+02_JPRB,1.7088E+02_JPRB,1.1417E+02_JPRB,5.8870E+01_JPRB,4.7588E+01_JPRB/)
KBO( :, 4,29,15) = (/&
&2.2117E+02_JPRB,2.2104E+02_JPRB,1.6604E+02_JPRB,1.1094E+02_JPRB,5.6871E+01_JPRB,4.4984E+01_JPRB/)
KBO( :, 5,29,15) = (/&
&2.1449E+02_JPRB,2.1436E+02_JPRB,1.6102E+02_JPRB,1.0757E+02_JPRB,5.4912E+01_JPRB,4.2890E+01_JPRB/)
KBO( :, 1,30,15) = (/&
&2.5146E+02_JPRB,2.5131E+02_JPRB,1.8876E+02_JPRB,1.2608E+02_JPRB,6.6304E+01_JPRB,5.6220E+01_JPRB/)
KBO( :, 2,30,15) = (/&
&2.4482E+02_JPRB,2.4467E+02_JPRB,1.8377E+02_JPRB,1.2275E+02_JPRB,6.3959E+01_JPRB,5.3007E+01_JPRB/)
KBO( :, 3,30,15) = (/&
&2.3792E+02_JPRB,2.3777E+02_JPRB,1.7859E+02_JPRB,1.1929E+02_JPRB,6.1625E+01_JPRB,4.9952E+01_JPRB/)
KBO( :, 4,30,15) = (/&
&2.3061E+02_JPRB,2.3047E+02_JPRB,1.7311E+02_JPRB,1.1562E+02_JPRB,5.9353E+01_JPRB,4.7238E+01_JPRB/)
KBO( :, 5,30,15) = (/&
&2.2308E+02_JPRB,2.2295E+02_JPRB,1.6746E+02_JPRB,1.1184E+02_JPRB,5.7116E+01_JPRB,4.4978E+01_JPRB/)
KBO( :, 1,31,15) = (/&
&2.6202E+02_JPRB,2.6186E+02_JPRB,1.9666E+02_JPRB,1.3132E+02_JPRB,6.9199E+01_JPRB,5.8789E+01_JPRB/)
KBO( :, 2,31,15) = (/&
&2.5437E+02_JPRB,2.5422E+02_JPRB,1.9092E+02_JPRB,1.2749E+02_JPRB,6.6513E+01_JPRB,5.5233E+01_JPRB/)
KBO( :, 3,31,15) = (/&
&2.4648E+02_JPRB,2.4634E+02_JPRB,1.8501E+02_JPRB,1.2354E+02_JPRB,6.3925E+01_JPRB,5.1946E+01_JPRB/)
KBO( :, 4,31,15) = (/&
&2.3838E+02_JPRB,2.3824E+02_JPRB,1.7892E+02_JPRB,1.1948E+02_JPRB,6.1400E+01_JPRB,4.9329E+01_JPRB/)
KBO( :, 5,31,15) = (/&
&2.3010E+02_JPRB,2.2996E+02_JPRB,1.7271E+02_JPRB,1.1532E+02_JPRB,5.8925E+01_JPRB,4.6712E+01_JPRB/)
KBO( :, 1,32,15) = (/&
&2.7074E+02_JPRB,2.7057E+02_JPRB,2.0319E+02_JPRB,1.3565E+02_JPRB,7.1571E+01_JPRB,6.0821E+01_JPRB/)
KBO( :, 2,32,15) = (/&
&2.6218E+02_JPRB,2.6203E+02_JPRB,1.9677E+02_JPRB,1.3137E+02_JPRB,6.8590E+01_JPRB,5.6967E+01_JPRB/)
KBO( :, 3,32,15) = (/&
&2.5343E+02_JPRB,2.5328E+02_JPRB,1.9020E+02_JPRB,1.2698E+02_JPRB,6.5765E+01_JPRB,5.3801E+01_JPRB/)
KBO( :, 4,32,15) = (/&
&2.4457E+02_JPRB,2.4443E+02_JPRB,1.8356E+02_JPRB,1.2255E+02_JPRB,6.3014E+01_JPRB,5.0945E+01_JPRB/)
KBO( :, 5,32,15) = (/&
&2.3559E+02_JPRB,2.3545E+02_JPRB,1.7681E+02_JPRB,1.1805E+02_JPRB,6.0339E+01_JPRB,4.8062E+01_JPRB/)
KBO( :, 1,33,15) = (/&
&2.7764E+02_JPRB,2.7748E+02_JPRB,2.0836E+02_JPRB,1.3907E+02_JPRB,7.3436E+01_JPRB,6.2345E+01_JPRB/)
KBO( :, 2,33,15) = (/&
&2.6829E+02_JPRB,2.6813E+02_JPRB,2.0135E+02_JPRB,1.3440E+02_JPRB,7.0216E+01_JPRB,5.8526E+01_JPRB/)
KBO( :, 3,33,15) = (/&
&2.5890E+02_JPRB,2.5874E+02_JPRB,1.9430E+02_JPRB,1.2970E+02_JPRB,6.7179E+01_JPRB,5.5377E+01_JPRB/)
KBO( :, 4,33,15) = (/&
&2.4933E+02_JPRB,2.4918E+02_JPRB,1.8712E+02_JPRB,1.2490E+02_JPRB,6.4220E+01_JPRB,5.2156E+01_JPRB/)
KBO( :, 5,33,15) = (/&
&2.3975E+02_JPRB,2.3960E+02_JPRB,1.7993E+02_JPRB,1.2011E+02_JPRB,6.1401E+01_JPRB,4.9280E+01_JPRB/)
KBO( :, 1,34,15) = (/&
&2.8330E+02_JPRB,2.8313E+02_JPRB,2.1259E+02_JPRB,1.4188E+02_JPRB,7.4943E+01_JPRB,6.3611E+01_JPRB/)
KBO( :, 2,34,15) = (/&
&2.7328E+02_JPRB,2.7312E+02_JPRB,2.0508E+02_JPRB,1.3687E+02_JPRB,7.1539E+01_JPRB,6.0040E+01_JPRB/)
KBO( :, 3,34,15) = (/&
&2.6322E+02_JPRB,2.6306E+02_JPRB,1.9753E+02_JPRB,1.3184E+02_JPRB,6.8302E+01_JPRB,5.6531E+01_JPRB/)
KBO( :, 4,34,15) = (/&
&2.5315E+02_JPRB,2.5300E+02_JPRB,1.8997E+02_JPRB,1.2680E+02_JPRB,6.5194E+01_JPRB,5.3134E+01_JPRB/)
KBO( :, 5,34,15) = (/&
&2.4305E+02_JPRB,2.4290E+02_JPRB,1.8239E+02_JPRB,1.2174E+02_JPRB,6.2238E+01_JPRB,5.0964E+01_JPRB/)
KBO( :, 1,35,15) = (/&
&2.8856E+02_JPRB,2.8838E+02_JPRB,2.1653E+02_JPRB,1.4450E+02_JPRB,7.6402E+01_JPRB,6.5174E+01_JPRB/)
KBO( :, 2,35,15) = (/&
&2.7804E+02_JPRB,2.7787E+02_JPRB,2.0864E+02_JPRB,1.3924E+02_JPRB,7.2828E+01_JPRB,6.1468E+01_JPRB/)
KBO( :, 3,35,15) = (/&
&2.6749E+02_JPRB,2.6733E+02_JPRB,2.0072E+02_JPRB,1.3396E+02_JPRB,6.9428E+01_JPRB,5.7687E+01_JPRB/)
KBO( :, 4,35,15) = (/&
&2.5691E+02_JPRB,2.5675E+02_JPRB,1.9278E+02_JPRB,1.2866E+02_JPRB,6.6172E+01_JPRB,5.4537E+01_JPRB/)
KBO( :, 5,35,15) = (/&
&2.4636E+02_JPRB,2.4621E+02_JPRB,1.8487E+02_JPRB,1.2339E+02_JPRB,6.3093E+01_JPRB,5.3102E+01_JPRB/)
KBO( :, 1,36,15) = (/&
&2.9394E+02_JPRB,2.9376E+02_JPRB,2.2055E+02_JPRB,1.4717E+02_JPRB,7.7976E+01_JPRB,6.6997E+01_JPRB/)
KBO( :, 2,36,15) = (/&
&2.8294E+02_JPRB,2.8277E+02_JPRB,2.1230E+02_JPRB,1.4167E+02_JPRB,7.4208E+01_JPRB,6.2977E+01_JPRB/)
KBO( :, 3,36,15) = (/&
&2.7194E+02_JPRB,2.7178E+02_JPRB,2.0405E+02_JPRB,1.3617E+02_JPRB,7.0657E+01_JPRB,5.9032E+01_JPRB/)
KBO( :, 4,36,15) = (/&
&2.6092E+02_JPRB,2.6077E+02_JPRB,1.9579E+02_JPRB,1.3066E+02_JPRB,6.7258E+01_JPRB,5.6406E+01_JPRB/)
KBO( :, 5,36,15) = (/&
&2.5003E+02_JPRB,2.4988E+02_JPRB,1.8762E+02_JPRB,1.2521E+02_JPRB,6.4068E+01_JPRB,5.5624E+01_JPRB/)
KBO( :, 1,37,15) = (/&
&3.0017E+02_JPRB,2.9999E+02_JPRB,2.2523E+02_JPRB,1.5028E+02_JPRB,7.9918E+01_JPRB,6.9171E+01_JPRB/)
KBO( :, 2,37,15) = (/&
&2.8870E+02_JPRB,2.8853E+02_JPRB,2.1662E+02_JPRB,1.4454E+02_JPRB,7.5932E+01_JPRB,6.4872E+01_JPRB/)
KBO( :, 3,37,15) = (/&
&2.7736E+02_JPRB,2.7719E+02_JPRB,2.0811E+02_JPRB,1.3887E+02_JPRB,7.2229E+01_JPRB,6.0792E+01_JPRB/)
KBO( :, 4,37,15) = (/&
&2.6599E+02_JPRB,2.6584E+02_JPRB,1.9958E+02_JPRB,1.3319E+02_JPRB,6.8687E+01_JPRB,5.8518E+01_JPRB/)
KBO( :, 5,37,15) = (/&
&2.5476E+02_JPRB,2.5461E+02_JPRB,1.9116E+02_JPRB,1.2757E+02_JPRB,6.5367E+01_JPRB,5.8059E+01_JPRB/)
KBO( :, 1,38,15) = (/&
&3.0587E+02_JPRB,3.0569E+02_JPRB,2.2949E+02_JPRB,1.5312E+02_JPRB,8.1725E+01_JPRB,7.1248E+01_JPRB/)
KBO( :, 2,38,15) = (/&
&2.9408E+02_JPRB,2.9390E+02_JPRB,2.2065E+02_JPRB,1.4722E+02_JPRB,7.7560E+01_JPRB,6.6691E+01_JPRB/)
KBO( :, 3,38,15) = (/&
&2.8234E+02_JPRB,2.8218E+02_JPRB,2.1184E+02_JPRB,1.4135E+02_JPRB,7.3693E+01_JPRB,6.2607E+01_JPRB/)
KBO( :, 4,38,15) = (/&
&2.7064E+02_JPRB,2.7048E+02_JPRB,2.0306E+02_JPRB,1.3550E+02_JPRB,7.0023E+01_JPRB,6.0914E+01_JPRB/)
KBO( :, 5,38,15) = (/&
&2.5911E+02_JPRB,2.5896E+02_JPRB,1.9442E+02_JPRB,1.2974E+02_JPRB,6.6580E+01_JPRB,6.0840E+01_JPRB/)
KBO( :, 1,39,15) = (/&
&3.1101E+02_JPRB,3.1082E+02_JPRB,2.3334E+02_JPRB,1.5567E+02_JPRB,8.3378E+01_JPRB,7.3218E+01_JPRB/)
KBO( :, 2,39,15) = (/&
&2.9887E+02_JPRB,2.9869E+02_JPRB,2.2423E+02_JPRB,1.4960E+02_JPRB,7.9045E+01_JPRB,6.8519E+01_JPRB/)
KBO( :, 3,39,15) = (/&
&2.8683E+02_JPRB,2.8666E+02_JPRB,2.1520E+02_JPRB,1.4359E+02_JPRB,7.5024E+01_JPRB,6.4735E+01_JPRB/)
KBO( :, 4,39,15) = (/&
&2.7487E+02_JPRB,2.7471E+02_JPRB,2.0623E+02_JPRB,1.3761E+02_JPRB,7.1242E+01_JPRB,6.3858E+01_JPRB/)
KBO( :, 5,39,15) = (/&
&2.6303E+02_JPRB,2.6287E+02_JPRB,1.9735E+02_JPRB,1.3169E+02_JPRB,6.7680E+01_JPRB,6.4377E+01_JPRB/)
KBO( :, 1,40,15) = (/&
&3.1694E+02_JPRB,3.1675E+02_JPRB,2.3777E+02_JPRB,1.5862E+02_JPRB,8.5396E+01_JPRB,7.5421E+01_JPRB/)
KBO( :, 2,40,15) = (/&
&3.0448E+02_JPRB,3.0430E+02_JPRB,2.2843E+02_JPRB,1.5240E+02_JPRB,8.0839E+01_JPRB,7.0612E+01_JPRB/)
KBO( :, 3,40,15) = (/&
&2.9221E+02_JPRB,2.9204E+02_JPRB,2.1923E+02_JPRB,1.4627E+02_JPRB,7.6677E+01_JPRB,6.6660E+01_JPRB/)
KBO( :, 4,40,15) = (/&
&2.8000E+02_JPRB,2.7983E+02_JPRB,2.1007E+02_JPRB,1.4017E+02_JPRB,7.2757E+01_JPRB,6.5710E+01_JPRB/)
KBO( :, 5,40,15) = (/&
&2.6789E+02_JPRB,2.6773E+02_JPRB,2.0099E+02_JPRB,1.3412E+02_JPRB,6.9075E+01_JPRB,6.6414E+01_JPRB/)
KBO( :, 1,41,15) = (/&
&3.2263E+02_JPRB,3.2244E+02_JPRB,2.4204E+02_JPRB,1.6146E+02_JPRB,8.7409E+01_JPRB,7.7606E+01_JPRB/)
KBO( :, 2,41,15) = (/&
&3.0995E+02_JPRB,3.0976E+02_JPRB,2.3253E+02_JPRB,1.5513E+02_JPRB,8.2644E+01_JPRB,7.2713E+01_JPRB/)
KBO( :, 3,41,15) = (/&
&2.9738E+02_JPRB,2.9720E+02_JPRB,2.2311E+02_JPRB,1.4885E+02_JPRB,7.8306E+01_JPRB,6.8571E+01_JPRB/)
KBO( :, 4,41,15) = (/&
&2.8499E+02_JPRB,2.8482E+02_JPRB,2.1382E+02_JPRB,1.4266E+02_JPRB,7.4270E+01_JPRB,6.7462E+01_JPRB/)
KBO( :, 5,41,15) = (/&
&2.7266E+02_JPRB,2.7250E+02_JPRB,2.0456E+02_JPRB,1.3649E+02_JPRB,7.0464E+01_JPRB,6.8326E+01_JPRB/)
KBO( :, 1,42,15) = (/&
&3.2806E+02_JPRB,3.2786E+02_JPRB,2.4610E+02_JPRB,1.6416E+02_JPRB,8.9382E+01_JPRB,7.9783E+01_JPRB/)
KBO( :, 2,42,15) = (/&
&3.1513E+02_JPRB,3.1494E+02_JPRB,2.3641E+02_JPRB,1.5771E+02_JPRB,8.4411E+01_JPRB,7.4828E+01_JPRB/)
KBO( :, 3,42,15) = (/&
&3.0236E+02_JPRB,3.0217E+02_JPRB,2.2683E+02_JPRB,1.5133E+02_JPRB,7.9899E+01_JPRB,7.0566E+01_JPRB/)
KBO( :, 4,42,15) = (/&
&2.8974E+02_JPRB,2.8956E+02_JPRB,2.1737E+02_JPRB,1.4502E+02_JPRB,7.5728E+01_JPRB,6.9377E+01_JPRB/)
KBO( :, 5,42,15) = (/&
&2.7725E+02_JPRB,2.7708E+02_JPRB,2.0800E+02_JPRB,1.3878E+02_JPRB,7.1813E+01_JPRB,7.0507E+01_JPRB/)
KBO( :, 1,43,15) = (/&
&3.3393E+02_JPRB,3.3373E+02_JPRB,2.5050E+02_JPRB,1.6709E+02_JPRB,9.1659E+01_JPRB,8.2181E+01_JPRB/)
KBO( :, 2,43,15) = (/&
&3.2087E+02_JPRB,3.2068E+02_JPRB,2.4071E+02_JPRB,1.6058E+02_JPRB,8.6435E+01_JPRB,7.7203E+01_JPRB/)
KBO( :, 3,43,15) = (/&
&3.0784E+02_JPRB,3.0766E+02_JPRB,2.3094E+02_JPRB,1.5407E+02_JPRB,8.1705E+01_JPRB,7.2734E+01_JPRB/)
KBO( :, 4,43,15) = (/&
&2.9498E+02_JPRB,2.9480E+02_JPRB,2.2130E+02_JPRB,1.4764E+02_JPRB,7.7383E+01_JPRB,7.1244E+01_JPRB/)
KBO( :, 5,43,15) = (/&
&2.8236E+02_JPRB,2.8219E+02_JPRB,2.1184E+02_JPRB,1.4134E+02_JPRB,7.3355E+01_JPRB,7.2525E+01_JPRB/)
KBO( :, 1,44,15) = (/&
&3.3993E+02_JPRB,3.3973E+02_JPRB,2.5500E+02_JPRB,1.7009E+02_JPRB,9.4079E+01_JPRB,8.4777E+01_JPRB/)
KBO( :, 2,44,15) = (/&
&3.2668E+02_JPRB,3.2648E+02_JPRB,2.4506E+02_JPRB,1.6347E+02_JPRB,8.8568E+01_JPRB,7.9722E+01_JPRB/)
KBO( :, 3,44,15) = (/&
&3.1350E+02_JPRB,3.1331E+02_JPRB,2.3519E+02_JPRB,1.5690E+02_JPRB,8.3629E+01_JPRB,7.5073E+01_JPRB/)
KBO( :, 4,44,15) = (/&
&3.0048E+02_JPRB,3.0030E+02_JPRB,2.2542E+02_JPRB,1.5039E+02_JPRB,7.9147E+01_JPRB,7.3210E+01_JPRB/)
KBO( :, 5,44,15) = (/&
&2.8768E+02_JPRB,2.8750E+02_JPRB,2.1582E+02_JPRB,1.4399E+02_JPRB,7.4989E+01_JPRB,7.4615E+01_JPRB/)
KBO( :, 1,45,15) = (/&
&3.4570E+02_JPRB,3.4549E+02_JPRB,2.5932E+02_JPRB,1.7296E+02_JPRB,9.6495E+01_JPRB,8.7516E+01_JPRB/)
KBO( :, 2,45,15) = (/&
&3.3235E+02_JPRB,3.3215E+02_JPRB,2.4931E+02_JPRB,1.6630E+02_JPRB,9.0736E+01_JPRB,8.2360E+01_JPRB/)
KBO( :, 3,45,15) = (/&
&3.1903E+02_JPRB,3.1884E+02_JPRB,2.3933E+02_JPRB,1.5965E+02_JPRB,8.5580E+01_JPRB,7.7592E+01_JPRB/)
KBO( :, 4,45,15) = (/&
&3.0583E+02_JPRB,3.0564E+02_JPRB,2.2943E+02_JPRB,1.5306E+02_JPRB,8.0904E+01_JPRB,7.5512E+01_JPRB/)
KBO( :, 5,45,15) = (/&
&2.9285E+02_JPRB,2.9267E+02_JPRB,2.1969E+02_JPRB,1.4657E+02_JPRB,7.6606E+01_JPRB,7.7136E+01_JPRB/)
KBO( :, 1,46,15) = (/&
&3.5162E+02_JPRB,3.5141E+02_JPRB,2.6376E+02_JPRB,1.7592E+02_JPRB,9.9116E+01_JPRB,9.0486E+01_JPRB/)
KBO( :, 2,46,15) = (/&
&3.3821E+02_JPRB,3.3800E+02_JPRB,2.5370E+02_JPRB,1.6922E+02_JPRB,9.3089E+01_JPRB,8.5193E+01_JPRB/)
KBO( :, 3,46,15) = (/&
&3.2475E+02_JPRB,3.2455E+02_JPRB,2.4361E+02_JPRB,1.6250E+02_JPRB,8.7670E+01_JPRB,8.0271E+01_JPRB/)
KBO( :, 4,46,15) = (/&
&3.1144E+02_JPRB,3.1126E+02_JPRB,2.3364E+02_JPRB,1.5586E+02_JPRB,8.2789E+01_JPRB,7.7967E+01_JPRB/)
KBO( :, 5,46,15) = (/&
&2.9826E+02_JPRB,2.9808E+02_JPRB,2.2376E+02_JPRB,1.4928E+02_JPRB,7.8339E+01_JPRB,7.9667E+01_JPRB/)
KBO( :, 1,47,15) = (/&
&3.5795E+02_JPRB,3.5773E+02_JPRB,2.6850E+02_JPRB,1.7907E+02_JPRB,1.0208E+02_JPRB,9.3825E+01_JPRB/)
KBO( :, 2,47,15) = (/&
&3.4453E+02_JPRB,3.4432E+02_JPRB,2.5844E+02_JPRB,1.7237E+02_JPRB,9.5731E+01_JPRB,8.8246E+01_JPRB/)
KBO( :, 3,47,15) = (/&
&3.3096E+02_JPRB,3.3076E+02_JPRB,2.4827E+02_JPRB,1.6560E+02_JPRB,9.0023E+01_JPRB,8.3072E+01_JPRB/)
KBO( :, 4,47,15) = (/&
&3.1751E+02_JPRB,3.1732E+02_JPRB,2.3819E+02_JPRB,1.5889E+02_JPRB,8.4913E+01_JPRB,8.0301E+01_JPRB/)
KBO( :, 5,47,15) = (/&
&3.0419E+02_JPRB,3.0401E+02_JPRB,2.2820E+02_JPRB,1.5224E+02_JPRB,8.0275E+01_JPRB,8.1585E+01_JPRB/)
KBO( :, 1,48,15) = (/&
&3.6405E+02_JPRB,3.6383E+02_JPRB,2.7307E+02_JPRB,1.8212E+02_JPRB,1.0516E+02_JPRB,9.7509E+01_JPRB/)
KBO( :, 2,48,15) = (/&
&3.5068E+02_JPRB,3.5047E+02_JPRB,2.6305E+02_JPRB,1.7544E+02_JPRB,9.8444E+01_JPRB,9.1443E+01_JPRB/)
KBO( :, 3,48,15) = (/&
&3.3709E+02_JPRB,3.3688E+02_JPRB,2.5286E+02_JPRB,1.6866E+02_JPRB,9.2465E+01_JPRB,8.6144E+01_JPRB/)
KBO( :, 4,48,15) = (/&
&3.2352E+02_JPRB,3.2332E+02_JPRB,2.4269E+02_JPRB,1.6188E+02_JPRB,8.7099E+01_JPRB,8.3145E+01_JPRB/)
KBO( :, 5,48,15) = (/&
&3.1006E+02_JPRB,3.0987E+02_JPRB,2.3260E+02_JPRB,1.5516E+02_JPRB,8.2249E+01_JPRB,8.4244E+01_JPRB/)
KBO( :, 1,49,15) = (/&
&3.7003E+02_JPRB,3.6981E+02_JPRB,2.7756E+02_JPRB,1.8510E+02_JPRB,1.0838E+02_JPRB,1.0148E+02_JPRB/)
KBO( :, 2,49,15) = (/&
&3.5675E+02_JPRB,3.5654E+02_JPRB,2.6761E+02_JPRB,1.7847E+02_JPRB,1.0127E+02_JPRB,9.4886E+01_JPRB/)
KBO( :, 3,49,15) = (/&
&3.4318E+02_JPRB,3.4298E+02_JPRB,2.5743E+02_JPRB,1.7170E+02_JPRB,9.5003E+01_JPRB,8.9591E+01_JPRB/)
KBO( :, 4,49,15) = (/&
&3.2947E+02_JPRB,3.2927E+02_JPRB,2.4715E+02_JPRB,1.6485E+02_JPRB,8.9342E+01_JPRB,8.6726E+01_JPRB/)
KBO( :, 5,49,15) = (/&
&3.1591E+02_JPRB,3.1572E+02_JPRB,2.3699E+02_JPRB,1.5809E+02_JPRB,8.4278E+01_JPRB,8.8051E+01_JPRB/)
KBO( :, 1,50,15) = (/&
&3.7556E+02_JPRB,3.7534E+02_JPRB,2.8170E+02_JPRB,1.8786E+02_JPRB,1.1154E+02_JPRB,1.0526E+02_JPRB/)
KBO( :, 2,50,15) = (/&
&3.6235E+02_JPRB,3.6213E+02_JPRB,2.7180E+02_JPRB,1.8127E+02_JPRB,1.0404E+02_JPRB,9.7933E+01_JPRB/)
KBO( :, 3,50,15) = (/&
&3.4884E+02_JPRB,3.4863E+02_JPRB,2.6167E+02_JPRB,1.7452E+02_JPRB,9.7449E+01_JPRB,9.2614E+01_JPRB/)
KBO( :, 4,50,15) = (/&
&3.3508E+02_JPRB,3.3488E+02_JPRB,2.5136E+02_JPRB,1.6766E+02_JPRB,9.1542E+01_JPRB,8.9470E+01_JPRB/)
KBO( :, 5,50,15) = (/&
&3.2141E+02_JPRB,3.2122E+02_JPRB,2.4111E+02_JPRB,1.6083E+02_JPRB,8.6254E+01_JPRB,9.0426E+01_JPRB/)
KBO( :, 1,51,15) = (/&
&3.8078E+02_JPRB,3.8056E+02_JPRB,2.8562E+02_JPRB,1.9055E+02_JPRB,1.1479E+02_JPRB,1.0898E+02_JPRB/)
KBO( :, 2,51,15) = (/&
&3.6766E+02_JPRB,3.6744E+02_JPRB,2.7578E+02_JPRB,1.8392E+02_JPRB,1.0684E+02_JPRB,1.0093E+02_JPRB/)
KBO( :, 3,51,15) = (/&
&3.5420E+02_JPRB,3.5398E+02_JPRB,2.6569E+02_JPRB,1.7719E+02_JPRB,9.9903E+01_JPRB,9.5407E+01_JPRB/)
KBO( :, 4,51,15) = (/&
&3.4048E+02_JPRB,3.4027E+02_JPRB,2.5540E+02_JPRB,1.7035E+02_JPRB,9.3766E+01_JPRB,9.1798E+01_JPRB/)
KBO( :, 5,51,15) = (/&
&3.2673E+02_JPRB,3.2653E+02_JPRB,2.4509E+02_JPRB,1.6348E+02_JPRB,8.8237E+01_JPRB,9.2138E+01_JPRB/)
KBO( :, 1,52,15) = (/&
&3.8584E+02_JPRB,3.8560E+02_JPRB,2.8941E+02_JPRB,1.9322E+02_JPRB,1.1816E+02_JPRB,1.1293E+02_JPRB/)
KBO( :, 2,52,15) = (/&
&3.7294E+02_JPRB,3.7271E+02_JPRB,2.7974E+02_JPRB,1.8654E+02_JPRB,1.0976E+02_JPRB,1.0425E+02_JPRB/)
KBO( :, 3,52,15) = (/&
&3.5951E+02_JPRB,3.5930E+02_JPRB,2.6967E+02_JPRB,1.7985E+02_JPRB,1.0246E+02_JPRB,9.8398E+01_JPRB/)
KBO( :, 4,52,15) = (/&
&3.4582E+02_JPRB,3.4561E+02_JPRB,2.5941E+02_JPRB,1.7301E+02_JPRB,9.6032E+01_JPRB,9.4572E+01_JPRB/)
KBO( :, 5,52,15) = (/&
&3.3204E+02_JPRB,3.3185E+02_JPRB,2.4908E+02_JPRB,1.6614E+02_JPRB,9.0266E+01_JPRB,9.4675E+01_JPRB/)
KBO( :, 1,53,15) = (/&
&3.9087E+02_JPRB,3.9063E+02_JPRB,2.9318E+02_JPRB,1.9599E+02_JPRB,1.2171E+02_JPRB,1.1718E+02_JPRB/)
KBO( :, 2,53,15) = (/&
&3.7802E+02_JPRB,3.7780E+02_JPRB,2.8355E+02_JPRB,1.8910E+02_JPRB,1.1281E+02_JPRB,1.0800E+02_JPRB/)
KBO( :, 3,53,15) = (/&
&3.6473E+02_JPRB,3.6451E+02_JPRB,2.7359E+02_JPRB,1.8245E+02_JPRB,1.0513E+02_JPRB,1.0177E+02_JPRB/)
KBO( :, 4,53,15) = (/&
&3.5112E+02_JPRB,3.5091E+02_JPRB,2.6338E+02_JPRB,1.7566E+02_JPRB,9.8387E+01_JPRB,9.7989E+01_JPRB/)
KBO( :, 5,53,15) = (/&
&3.3733E+02_JPRB,3.3713E+02_JPRB,2.5304E+02_JPRB,1.6878E+02_JPRB,9.2381E+01_JPRB,9.8180E+01_JPRB/)
KBO( :, 1,54,15) = (/&
&3.9531E+02_JPRB,3.9507E+02_JPRB,2.9651E+02_JPRB,1.9853E+02_JPRB,1.2515E+02_JPRB,1.2078E+02_JPRB/)
KBO( :, 2,54,15) = (/&
&3.8263E+02_JPRB,3.8240E+02_JPRB,2.8700E+02_JPRB,1.9150E+02_JPRB,1.1577E+02_JPRB,1.1118E+02_JPRB/)
KBO( :, 3,54,15) = (/&
&3.6948E+02_JPRB,3.6926E+02_JPRB,2.7715E+02_JPRB,1.8482E+02_JPRB,1.0769E+02_JPRB,1.0351E+02_JPRB/)
KBO( :, 4,54,15) = (/&
&3.5596E+02_JPRB,3.5575E+02_JPRB,2.6701E+02_JPRB,1.7807E+02_JPRB,1.0063E+02_JPRB,9.9143E+01_JPRB/)
KBO( :, 5,54,15) = (/&
&3.4214E+02_JPRB,3.4194E+02_JPRB,2.5665E+02_JPRB,1.7118E+02_JPRB,9.4395E+01_JPRB,9.8105E+01_JPRB/)
KBO( :, 1,55,15) = (/&
&3.9946E+02_JPRB,3.9922E+02_JPRB,2.9962E+02_JPRB,2.0102E+02_JPRB,1.2867E+02_JPRB,1.2425E+02_JPRB/)
KBO( :, 2,55,15) = (/&
&3.8700E+02_JPRB,3.8677E+02_JPRB,2.9028E+02_JPRB,1.9382E+02_JPRB,1.1872E+02_JPRB,1.1387E+02_JPRB/)
KBO( :, 3,55,15) = (/&
&3.7399E+02_JPRB,3.7376E+02_JPRB,2.8052E+02_JPRB,1.8707E+02_JPRB,1.1023E+02_JPRB,1.0518E+02_JPRB/)
KBO( :, 4,55,15) = (/&
&3.6056E+02_JPRB,3.6034E+02_JPRB,2.7046E+02_JPRB,1.8037E+02_JPRB,1.0287E+02_JPRB,9.9691E+01_JPRB/)
KBO( :, 5,55,15) = (/&
&3.4681E+02_JPRB,3.4660E+02_JPRB,2.6015E+02_JPRB,1.7350E+02_JPRB,9.6390E+01_JPRB,9.6621E+01_JPRB/)
KBO( :, 1,56,15) = (/&
&4.0345E+02_JPRB,4.0321E+02_JPRB,3.0261E+02_JPRB,2.0354E+02_JPRB,1.3232E+02_JPRB,1.2822E+02_JPRB/)
KBO( :, 2,56,15) = (/&
&3.9129E+02_JPRB,3.9105E+02_JPRB,2.9349E+02_JPRB,1.9619E+02_JPRB,1.2179E+02_JPRB,1.1677E+02_JPRB/)
KBO( :, 3,56,15) = (/&
&3.7839E+02_JPRB,3.7816E+02_JPRB,2.8382E+02_JPRB,1.8928E+02_JPRB,1.1288E+02_JPRB,1.0755E+02_JPRB/)
KBO( :, 4,56,15) = (/&
&3.6503E+02_JPRB,3.6481E+02_JPRB,2.7381E+02_JPRB,1.8260E+02_JPRB,1.0518E+02_JPRB,1.0056E+02_JPRB/)
KBO( :, 5,56,15) = (/&
&3.5139E+02_JPRB,3.5118E+02_JPRB,2.6358E+02_JPRB,1.7579E+02_JPRB,9.8426E+01_JPRB,9.5940E+01_JPRB/)
KBO( :, 1,57,15) = (/&
&4.0732E+02_JPRB,4.0708E+02_JPRB,3.0551E+02_JPRB,2.0612E+02_JPRB,1.3611E+02_JPRB,1.3253E+02_JPRB/)
KBO( :, 2,57,15) = (/&
&3.9551E+02_JPRB,3.9527E+02_JPRB,2.9666E+02_JPRB,1.9860E+02_JPRB,1.2505E+02_JPRB,1.2007E+02_JPRB/)
KBO( :, 3,57,15) = (/&
&3.8272E+02_JPRB,3.8249E+02_JPRB,2.8707E+02_JPRB,1.9154E+02_JPRB,1.1567E+02_JPRB,1.1005E+02_JPRB/)
KBO( :, 4,57,15) = (/&
&3.6944E+02_JPRB,3.6922E+02_JPRB,2.7712E+02_JPRB,1.8480E+02_JPRB,1.0758E+02_JPRB,1.0192E+02_JPRB/)
KBO( :, 5,57,15) = (/&
&3.5592E+02_JPRB,3.5571E+02_JPRB,2.6698E+02_JPRB,1.7805E+02_JPRB,1.0054E+02_JPRB,9.6453E+01_JPRB/)
KBO( :, 1,58,15) = (/&
&4.1059E+02_JPRB,4.1035E+02_JPRB,3.0796E+02_JPRB,2.0852E+02_JPRB,1.3980E+02_JPRB,1.3680E+02_JPRB/)
KBO( :, 2,58,15) = (/&
&3.9929E+02_JPRB,3.9905E+02_JPRB,2.9949E+02_JPRB,2.0087E+02_JPRB,1.2831E+02_JPRB,1.2369E+02_JPRB/)
KBO( :, 3,58,15) = (/&
&3.8677E+02_JPRB,3.8654E+02_JPRB,2.9010E+02_JPRB,1.9368E+02_JPRB,1.1842E+02_JPRB,1.1258E+02_JPRB/)
KBO( :, 4,58,15) = (/&
&3.7367E+02_JPRB,3.7345E+02_JPRB,2.8029E+02_JPRB,1.8691E+02_JPRB,1.0996E+02_JPRB,1.0363E+02_JPRB/)
KBO( :, 5,58,15) = (/&
&3.6017E+02_JPRB,3.5995E+02_JPRB,2.7016E+02_JPRB,1.8017E+02_JPRB,1.0261E+02_JPRB,9.7140E+01_JPRB/)
KBO( :, 1,59,15) = (/&
&4.1203E+02_JPRB,4.1178E+02_JPRB,3.0904E+02_JPRB,2.0958E+02_JPRB,1.4140E+02_JPRB,1.3865E+02_JPRB/)
KBO( :, 2,59,15) = (/&
&4.0086E+02_JPRB,4.0061E+02_JPRB,3.0066E+02_JPRB,2.0184E+02_JPRB,1.2968E+02_JPRB,1.2523E+02_JPRB/)
KBO( :, 3,59,15) = (/&
&3.8845E+02_JPRB,3.8822E+02_JPRB,2.9137E+02_JPRB,1.9459E+02_JPRB,1.1957E+02_JPRB,1.1363E+02_JPRB/)
KBO( :, 4,59,15) = (/&
&3.7538E+02_JPRB,3.7516E+02_JPRB,2.8157E+02_JPRB,1.8776E+02_JPRB,1.1095E+02_JPRB,1.0368E+02_JPRB/)
KBO( :, 5,59,15) = (/&
&3.6194E+02_JPRB,3.6172E+02_JPRB,2.7149E+02_JPRB,1.8106E+02_JPRB,1.0349E+02_JPRB,9.5485E+01_JPRB/)
KBO( :, 1,13,16) = (/&
&3.8689E+01_JPRB,3.8666E+01_JPRB,2.9260E+01_JPRB,2.0209E+01_JPRB,1.1782E+01_JPRB,1.0583E+01_JPRB/)
KBO( :, 2,13,16) = (/&
&3.8299E+01_JPRB,3.8276E+01_JPRB,2.8975E+01_JPRB,1.9748E+01_JPRB,1.1593E+01_JPRB,1.0462E+01_JPRB/)
KBO( :, 3,13,16) = (/&
&3.8145E+01_JPRB,3.8122E+01_JPRB,2.8865E+01_JPRB,1.9633E+01_JPRB,1.1641E+01_JPRB,1.2633E+01_JPRB/)
KBO( :, 4,13,16) = (/&
&3.7920E+01_JPRB,3.7898E+01_JPRB,2.8722E+01_JPRB,1.9787E+01_JPRB,1.1762E+01_JPRB,2.0692E+01_JPRB/)
KBO( :, 5,13,16) = (/&
&3.7770E+01_JPRB,3.7748E+01_JPRB,2.8670E+01_JPRB,1.9920E+01_JPRB,1.1827E+01_JPRB,3.1866E+01_JPRB/)
KBO( :, 1,14,16) = (/&
&4.5054E+01_JPRB,4.5027E+01_JPRB,3.4026E+01_JPRB,2.3071E+01_JPRB,1.3319E+01_JPRB,1.2073E+01_JPRB/)
KBO( :, 2,14,16) = (/&
&4.5133E+01_JPRB,4.5106E+01_JPRB,3.4091E+01_JPRB,2.3057E+01_JPRB,1.3364E+01_JPRB,1.1925E+01_JPRB/)
KBO( :, 3,14,16) = (/&
&4.5119E+01_JPRB,4.5092E+01_JPRB,3.4098E+01_JPRB,2.3216E+01_JPRB,1.3503E+01_JPRB,1.1702E+01_JPRB/)
KBO( :, 4,14,16) = (/&
&4.5115E+01_JPRB,4.5088E+01_JPRB,3.4119E+01_JPRB,2.3467E+01_JPRB,1.3637E+01_JPRB,1.5244E+01_JPRB/)
KBO( :, 5,14,16) = (/&
&4.5059E+01_JPRB,4.5033E+01_JPRB,3.4214E+01_JPRB,2.3627E+01_JPRB,1.3694E+01_JPRB,2.3098E+01_JPRB/)
KBO( :, 1,15,16) = (/&
&5.3422E+01_JPRB,5.3390E+01_JPRB,4.0289E+01_JPRB,2.7161E+01_JPRB,1.5356E+01_JPRB,1.3721E+01_JPRB/)
KBO( :, 2,15,16) = (/&
&5.3696E+01_JPRB,5.3664E+01_JPRB,4.0505E+01_JPRB,2.7340E+01_JPRB,1.5494E+01_JPRB,1.3518E+01_JPRB/)
KBO( :, 3,15,16) = (/&
&5.3925E+01_JPRB,5.3893E+01_JPRB,4.0694E+01_JPRB,2.7658E+01_JPRB,1.5638E+01_JPRB,1.3237E+01_JPRB/)
KBO( :, 4,15,16) = (/&
&5.4035E+01_JPRB,5.4003E+01_JPRB,4.0835E+01_JPRB,2.7959E+01_JPRB,1.5745E+01_JPRB,1.3582E+01_JPRB/)
KBO( :, 5,15,16) = (/&
&5.4075E+01_JPRB,5.4044E+01_JPRB,4.1021E+01_JPRB,2.8130E+01_JPRB,1.5788E+01_JPRB,1.7824E+01_JPRB/)
KBO( :, 1,16,16) = (/&
&6.3798E+01_JPRB,6.3761E+01_JPRB,4.8055E+01_JPRB,3.2321E+01_JPRB,1.7804E+01_JPRB,1.5476E+01_JPRB/)
KBO( :, 2,16,16) = (/&
&6.4371E+01_JPRB,6.4333E+01_JPRB,4.8500E+01_JPRB,3.2671E+01_JPRB,1.7962E+01_JPRB,1.5197E+01_JPRB/)
KBO( :, 3,16,16) = (/&
&6.4762E+01_JPRB,6.4724E+01_JPRB,4.8796E+01_JPRB,3.3069E+01_JPRB,1.8081E+01_JPRB,1.4836E+01_JPRB/)
KBO( :, 4,16,16) = (/&
&6.4916E+01_JPRB,6.4878E+01_JPRB,4.9055E+01_JPRB,3.3403E+01_JPRB,1.8207E+01_JPRB,1.4562E+01_JPRB/)
KBO( :, 5,16,16) = (/&
&6.5062E+01_JPRB,6.5024E+01_JPRB,4.9265E+01_JPRB,3.3568E+01_JPRB,1.8256E+01_JPRB,1.7370E+01_JPRB/)
KBO( :, 1,17,16) = (/&
&7.6610E+01_JPRB,7.6564E+01_JPRB,5.7652E+01_JPRB,3.8697E+01_JPRB,2.0672E+01_JPRB,1.7278E+01_JPRB/)
KBO( :, 2,17,16) = (/&
&7.7427E+01_JPRB,7.7381E+01_JPRB,5.8265E+01_JPRB,3.9185E+01_JPRB,2.0866E+01_JPRB,1.6909E+01_JPRB/)
KBO( :, 3,17,16) = (/&
&7.7882E+01_JPRB,7.7836E+01_JPRB,5.8659E+01_JPRB,3.9624E+01_JPRB,2.1079E+01_JPRB,1.6452E+01_JPRB/)
KBO( :, 4,17,16) = (/&
&7.8153E+01_JPRB,7.8107E+01_JPRB,5.8983E+01_JPRB,3.9939E+01_JPRB,2.1227E+01_JPRB,1.5935E+01_JPRB/)
KBO( :, 5,17,16) = (/&
&7.8285E+01_JPRB,7.8239E+01_JPRB,5.9159E+01_JPRB,4.0098E+01_JPRB,2.1284E+01_JPRB,1.7883E+01_JPRB/)
KBO( :, 1,18,16) = (/&
&9.2189E+01_JPRB,9.2134E+01_JPRB,6.9312E+01_JPRB,4.6439E+01_JPRB,2.4197E+01_JPRB,1.9120E+01_JPRB/)
KBO( :, 2,18,16) = (/&
&9.3127E+01_JPRB,9.3071E+01_JPRB,7.0021E+01_JPRB,4.7049E+01_JPRB,2.4478E+01_JPRB,1.8615E+01_JPRB/)
KBO( :, 3,18,16) = (/&
&9.3687E+01_JPRB,9.3631E+01_JPRB,7.0554E+01_JPRB,4.7512E+01_JPRB,2.4757E+01_JPRB,1.8049E+01_JPRB/)
KBO( :, 4,18,16) = (/&
&9.4033E+01_JPRB,9.3977E+01_JPRB,7.0871E+01_JPRB,4.7767E+01_JPRB,2.4905E+01_JPRB,1.7594E+01_JPRB/)
KBO( :, 5,18,16) = (/&
&9.4115E+01_JPRB,9.4059E+01_JPRB,7.0982E+01_JPRB,4.7909E+01_JPRB,2.4988E+01_JPRB,1.9077E+01_JPRB/)
KBO( :, 1,19,16) = (/&
&1.1088E+02_JPRB,1.1082E+02_JPRB,8.3307E+01_JPRB,5.5744E+01_JPRB,2.8599E+01_JPRB,2.1582E+01_JPRB/)
KBO( :, 2,19,16) = (/&
&1.1182E+02_JPRB,1.1175E+02_JPRB,8.4097E+01_JPRB,5.6442E+01_JPRB,2.8984E+01_JPRB,2.0983E+01_JPRB/)
KBO( :, 3,19,16) = (/&
&1.1254E+02_JPRB,1.1247E+02_JPRB,8.4694E+01_JPRB,5.6884E+01_JPRB,2.9231E+01_JPRB,2.0488E+01_JPRB/)
KBO( :, 4,19,16) = (/&
&1.1281E+02_JPRB,1.1274E+02_JPRB,8.4918E+01_JPRB,5.7062E+01_JPRB,2.9345E+01_JPRB,2.0019E+01_JPRB/)
KBO( :, 5,19,16) = (/&
&1.1284E+02_JPRB,1.1277E+02_JPRB,8.4969E+01_JPRB,5.7133E+01_JPRB,2.9423E+01_JPRB,2.0552E+01_JPRB/)
KBO( :, 1,20,16) = (/&
&1.3304E+02_JPRB,1.3296E+02_JPRB,9.9902E+01_JPRB,6.6832E+01_JPRB,3.3983E+01_JPRB,2.4788E+01_JPRB/)
KBO( :, 2,20,16) = (/&
&1.3397E+02_JPRB,1.3389E+02_JPRB,1.0072E+02_JPRB,6.7494E+01_JPRB,3.4377E+01_JPRB,2.4125E+01_JPRB/)
KBO( :, 3,20,16) = (/&
&1.3463E+02_JPRB,1.3455E+02_JPRB,1.0123E+02_JPRB,6.7864E+01_JPRB,3.4571E+01_JPRB,2.3603E+01_JPRB/)
KBO( :, 4,20,16) = (/&
&1.3476E+02_JPRB,1.3468E+02_JPRB,1.0135E+02_JPRB,6.7962E+01_JPRB,3.4649E+01_JPRB,2.3098E+01_JPRB/)
KBO( :, 5,20,16) = (/&
&1.3461E+02_JPRB,1.3453E+02_JPRB,1.0126E+02_JPRB,6.7912E+01_JPRB,3.4631E+01_JPRB,2.3014E+01_JPRB/)
KBO( :, 1,21,16) = (/&
&1.5902E+02_JPRB,1.5892E+02_JPRB,1.1942E+02_JPRB,7.9855E+01_JPRB,4.0380E+01_JPRB,2.8857E+01_JPRB/)
KBO( :, 2,21,16) = (/&
&1.5986E+02_JPRB,1.5976E+02_JPRB,1.2010E+02_JPRB,8.0360E+01_JPRB,4.0679E+01_JPRB,2.8064E+01_JPRB/)
KBO( :, 3,21,16) = (/&
&1.6009E+02_JPRB,1.5999E+02_JPRB,1.2030E+02_JPRB,8.0530E+01_JPRB,4.0801E+01_JPRB,2.7409E+01_JPRB/)
KBO( :, 4,21,16) = (/&
&1.6003E+02_JPRB,1.5993E+02_JPRB,1.2027E+02_JPRB,8.0522E+01_JPRB,4.0812E+01_JPRB,2.6783E+01_JPRB/)
KBO( :, 5,21,16) = (/&
&1.5940E+02_JPRB,1.5931E+02_JPRB,1.1980E+02_JPRB,8.0213E+01_JPRB,4.0653E+01_JPRB,2.6207E+01_JPRB/)
KBO( :, 1,22,16) = (/&
&1.8914E+02_JPRB,1.8903E+02_JPRB,1.4202E+02_JPRB,9.4911E+01_JPRB,4.7837E+01_JPRB,3.3682E+01_JPRB/)
KBO( :, 2,22,16) = (/&
&1.8942E+02_JPRB,1.8931E+02_JPRB,1.4225E+02_JPRB,9.5082E+01_JPRB,4.7944E+01_JPRB,3.2660E+01_JPRB/)
KBO( :, 3,22,16) = (/&
&1.8906E+02_JPRB,1.8895E+02_JPRB,1.4200E+02_JPRB,9.4945E+01_JPRB,4.7916E+01_JPRB,3.1774E+01_JPRB/)
KBO( :, 4,22,16) = (/&
&1.8832E+02_JPRB,1.8821E+02_JPRB,1.4146E+02_JPRB,9.4597E+01_JPRB,4.7752E+01_JPRB,3.0917E+01_JPRB/)
KBO( :, 5,22,16) = (/&
&1.8683E+02_JPRB,1.8672E+02_JPRB,1.4034E+02_JPRB,9.3850E+01_JPRB,4.7374E+01_JPRB,3.0042E+01_JPRB/)
KBO( :, 1,23,16) = (/&
&2.2303E+02_JPRB,2.2290E+02_JPRB,1.6742E+02_JPRB,1.1182E+02_JPRB,5.6236E+01_JPRB,3.9223E+01_JPRB/)
KBO( :, 2,23,16) = (/&
&2.2245E+02_JPRB,2.2232E+02_JPRB,1.6700E+02_JPRB,1.1156E+02_JPRB,5.6122E+01_JPRB,3.7879E+01_JPRB/)
KBO( :, 3,23,16) = (/&
&2.2122E+02_JPRB,2.2109E+02_JPRB,1.6608E+02_JPRB,1.1095E+02_JPRB,5.5829E+01_JPRB,3.6659E+01_JPRB/)
KBO( :, 4,23,16) = (/&
&2.1922E+02_JPRB,2.1909E+02_JPRB,1.6458E+02_JPRB,1.0995E+02_JPRB,5.5344E+01_JPRB,3.5458E+01_JPRB/)
KBO( :, 5,23,16) = (/&
&2.1646E+02_JPRB,2.1633E+02_JPRB,1.6251E+02_JPRB,1.0858E+02_JPRB,5.4654E+01_JPRB,3.4278E+01_JPRB/)
KBO( :, 1,24,16) = (/&
&2.6009E+02_JPRB,2.5994E+02_JPRB,1.9520E+02_JPRB,1.3031E+02_JPRB,6.5430E+01_JPRB,4.5390E+01_JPRB/)
KBO( :, 2,24,16) = (/&
&2.5840E+02_JPRB,2.5824E+02_JPRB,1.9393E+02_JPRB,1.2948E+02_JPRB,6.5031E+01_JPRB,4.3599E+01_JPRB/)
KBO( :, 3,24,16) = (/&
&2.5582E+02_JPRB,2.5567E+02_JPRB,1.9201E+02_JPRB,1.2820E+02_JPRB,6.4398E+01_JPRB,4.1930E+01_JPRB/)
KBO( :, 4,24,16) = (/&
&2.5214E+02_JPRB,2.5199E+02_JPRB,1.8925E+02_JPRB,1.2636E+02_JPRB,6.3477E+01_JPRB,4.0299E+01_JPRB/)
KBO( :, 5,24,16) = (/&
&2.4775E+02_JPRB,2.4761E+02_JPRB,1.8596E+02_JPRB,1.2416E+02_JPRB,6.2364E+01_JPRB,3.8770E+01_JPRB/)
KBO( :, 1,25,16) = (/&
&2.9961E+02_JPRB,2.9943E+02_JPRB,2.2482E+02_JPRB,1.5004E+02_JPRB,7.5282E+01_JPRB,5.1967E+01_JPRB/)
KBO( :, 2,25,16) = (/&
&2.9633E+02_JPRB,2.9616E+02_JPRB,2.2237E+02_JPRB,1.4840E+02_JPRB,7.4441E+01_JPRB,4.9689E+01_JPRB/)
KBO( :, 3,25,16) = (/&
&2.9175E+02_JPRB,2.9157E+02_JPRB,2.1893E+02_JPRB,1.4611E+02_JPRB,7.3302E+01_JPRB,4.7422E+01_JPRB/)
KBO( :, 4,25,16) = (/&
&2.8609E+02_JPRB,2.8592E+02_JPRB,2.1467E+02_JPRB,1.4326E+02_JPRB,7.1858E+01_JPRB,4.5354E+01_JPRB/)
KBO( :, 5,25,16) = (/&
&2.7979E+02_JPRB,2.7962E+02_JPRB,2.0995E+02_JPRB,1.4011E+02_JPRB,7.0273E+01_JPRB,4.3371E+01_JPRB/)
KBO( :, 1,26,16) = (/&
&3.4064E+02_JPRB,3.4044E+02_JPRB,2.5559E+02_JPRB,1.7054E+02_JPRB,8.5509E+01_JPRB,5.8664E+01_JPRB/)
KBO( :, 2,26,16) = (/&
&3.3479E+02_JPRB,3.3459E+02_JPRB,2.5118E+02_JPRB,1.6758E+02_JPRB,8.3998E+01_JPRB,5.5796E+01_JPRB/)
KBO( :, 3,26,16) = (/&
&3.2781E+02_JPRB,3.2761E+02_JPRB,2.4595E+02_JPRB,1.6410E+02_JPRB,8.2241E+01_JPRB,5.2997E+01_JPRB/)
KBO( :, 4,26,16) = (/&
&3.1991E+02_JPRB,3.1971E+02_JPRB,2.4002E+02_JPRB,1.6013E+02_JPRB,8.0246E+01_JPRB,5.0365E+01_JPRB/)
KBO( :, 5,26,16) = (/&
&3.1125E+02_JPRB,3.1106E+02_JPRB,2.3353E+02_JPRB,1.5580E+02_JPRB,7.8078E+01_JPRB,4.7882E+01_JPRB/)
KBO( :, 1,27,16) = (/&
&3.8151E+02_JPRB,3.8128E+02_JPRB,2.8624E+02_JPRB,1.9097E+02_JPRB,9.5695E+01_JPRB,6.5294E+01_JPRB/)
KBO( :, 2,27,16) = (/&
&3.7246E+02_JPRB,3.7224E+02_JPRB,2.7942E+02_JPRB,1.8640E+02_JPRB,9.3380E+01_JPRB,6.1731E+01_JPRB/)
KBO( :, 3,27,16) = (/&
&3.6293E+02_JPRB,3.6271E+02_JPRB,2.7227E+02_JPRB,1.8161E+02_JPRB,9.0959E+01_JPRB,5.8403E+01_JPRB/)
KBO( :, 4,27,16) = (/&
&3.5247E+02_JPRB,3.5226E+02_JPRB,2.6442E+02_JPRB,1.7637E+02_JPRB,8.8327E+01_JPRB,5.5221E+01_JPRB/)
KBO( :, 5,27,16) = (/&
&3.4112E+02_JPRB,3.4092E+02_JPRB,2.5591E+02_JPRB,1.7070E+02_JPRB,8.5490E+01_JPRB,5.2167E+01_JPRB/)
KBO( :, 1,28,16) = (/&
&4.2083E+02_JPRB,4.2057E+02_JPRB,3.1571E+02_JPRB,2.1058E+02_JPRB,1.0546E+02_JPRB,7.1596E+01_JPRB/)
KBO( :, 2,28,16) = (/&
&4.0846E+02_JPRB,4.0821E+02_JPRB,3.0641E+02_JPRB,2.0435E+02_JPRB,1.0232E+02_JPRB,6.7371E+01_JPRB/)
KBO( :, 3,28,16) = (/&
&3.9603E+02_JPRB,3.9579E+02_JPRB,2.9708E+02_JPRB,1.9813E+02_JPRB,9.9186E+01_JPRB,6.3413E+01_JPRB/)
KBO( :, 4,28,16) = (/&
&3.8255E+02_JPRB,3.8232E+02_JPRB,2.8697E+02_JPRB,1.9139E+02_JPRB,9.5812E+01_JPRB,5.9684E+01_JPRB/)
KBO( :, 5,28,16) = (/&
&3.6876E+02_JPRB,3.6854E+02_JPRB,2.7662E+02_JPRB,1.8449E+02_JPRB,9.2357E+01_JPRB,5.6128E+01_JPRB/)
KBO( :, 1,29,16) = (/&
&4.5696E+02_JPRB,4.5668E+02_JPRB,3.4279E+02_JPRB,2.2863E+02_JPRB,1.1447E+02_JPRB,7.7353E+01_JPRB/)
KBO( :, 2,29,16) = (/&
&4.4141E+02_JPRB,4.4115E+02_JPRB,3.3112E+02_JPRB,2.2083E+02_JPRB,1.1054E+02_JPRB,7.2448E+01_JPRB/)
KBO( :, 3,29,16) = (/&
&4.2589E+02_JPRB,4.2564E+02_JPRB,3.1947E+02_JPRB,2.1304E+02_JPRB,1.0662E+02_JPRB,6.7886E+01_JPRB/)
KBO( :, 4,29,16) = (/&
&4.0969E+02_JPRB,4.0945E+02_JPRB,3.0731E+02_JPRB,2.0494E+02_JPRB,1.0256E+02_JPRB,6.3607E+01_JPRB/)
KBO( :, 5,29,16) = (/&
&3.9310E+02_JPRB,3.9286E+02_JPRB,2.9486E+02_JPRB,1.9663E+02_JPRB,9.8402E+01_JPRB,5.9577E+01_JPRB/)
KBO( :, 1,30,16) = (/&
&4.8959E+02_JPRB,4.8930E+02_JPRB,3.6726E+02_JPRB,2.4492E+02_JPRB,1.2259E+02_JPRB,8.2395E+01_JPRB/)
KBO( :, 2,30,16) = (/&
&4.7092E+02_JPRB,4.7063E+02_JPRB,3.5324E+02_JPRB,2.3556E+02_JPRB,1.1788E+02_JPRB,7.6844E+01_JPRB/)
KBO( :, 3,30,16) = (/&
&4.5203E+02_JPRB,4.5176E+02_JPRB,3.3907E+02_JPRB,2.2611E+02_JPRB,1.1315E+02_JPRB,7.1734E+01_JPRB/)
KBO( :, 4,30,16) = (/&
&4.3310E+02_JPRB,4.3284E+02_JPRB,3.2486E+02_JPRB,2.1662E+02_JPRB,1.0839E+02_JPRB,6.6928E+01_JPRB/)
KBO( :, 5,30,16) = (/&
&4.1412E+02_JPRB,4.1387E+02_JPRB,3.1062E+02_JPRB,2.0713E+02_JPRB,1.0363E+02_JPRB,6.3289E+01_JPRB/)
KBO( :, 1,31,16) = (/&
&5.1786E+02_JPRB,5.1755E+02_JPRB,3.8845E+02_JPRB,2.5903E+02_JPRB,1.2962E+02_JPRB,8.6621E+01_JPRB/)
KBO( :, 2,31,16) = (/&
&4.9597E+02_JPRB,4.9567E+02_JPRB,3.7202E+02_JPRB,2.4806E+02_JPRB,1.2412E+02_JPRB,8.0470E+01_JPRB/)
KBO( :, 3,31,16) = (/&
&4.7405E+02_JPRB,4.7377E+02_JPRB,3.5558E+02_JPRB,2.3710E+02_JPRB,1.1862E+02_JPRB,7.4852E+01_JPRB/)
KBO( :, 4,31,16) = (/&
&4.5255E+02_JPRB,4.5228E+02_JPRB,3.3944E+02_JPRB,2.2633E+02_JPRB,1.1323E+02_JPRB,6.9726E+01_JPRB/)
KBO( :, 5,31,16) = (/&
&4.3142E+02_JPRB,4.3116E+02_JPRB,3.2359E+02_JPRB,2.1576E+02_JPRB,1.0794E+02_JPRB,6.8706E+01_JPRB/)
KBO( :, 1,32,16) = (/&
&5.4131E+02_JPRB,5.4099E+02_JPRB,4.0602E+02_JPRB,2.7073E+02_JPRB,1.3545E+02_JPRB,8.9958E+01_JPRB/)
KBO( :, 2,32,16) = (/&
&5.1653E+02_JPRB,5.1622E+02_JPRB,3.8743E+02_JPRB,2.5834E+02_JPRB,1.2924E+02_JPRB,8.3331E+01_JPRB/)
KBO( :, 3,32,16) = (/&
&4.9189E+02_JPRB,4.9160E+02_JPRB,3.6895E+02_JPRB,2.4600E+02_JPRB,1.2306E+02_JPRB,7.7256E+01_JPRB/)
KBO( :, 4,32,16) = (/&
&4.6812E+02_JPRB,4.6784E+02_JPRB,3.5111E+02_JPRB,2.3411E+02_JPRB,1.1710E+02_JPRB,7.4368E+01_JPRB/)
KBO( :, 5,32,16) = (/&
&4.4507E+02_JPRB,4.4480E+02_JPRB,3.3382E+02_JPRB,2.2258E+02_JPRB,1.1133E+02_JPRB,7.6072E+01_JPRB/)
KBO( :, 1,33,16) = (/&
&5.6013E+02_JPRB,5.5980E+02_JPRB,4.2013E+02_JPRB,2.8013E+02_JPRB,1.4013E+02_JPRB,9.2452E+01_JPRB/)
KBO( :, 2,33,16) = (/&
&5.3265E+02_JPRB,5.3233E+02_JPRB,3.9951E+02_JPRB,2.6638E+02_JPRB,1.3325E+02_JPRB,8.5421E+01_JPRB/)
KBO( :, 3,33,16) = (/&
&5.0565E+02_JPRB,5.0535E+02_JPRB,3.7926E+02_JPRB,2.5287E+02_JPRB,1.2648E+02_JPRB,8.0582E+01_JPRB/)
KBO( :, 4,33,16) = (/&
&4.8012E+02_JPRB,4.7983E+02_JPRB,3.6011E+02_JPRB,2.4010E+02_JPRB,1.2009E+02_JPRB,8.1630E+01_JPRB/)
KBO( :, 5,33,16) = (/&
&4.5545E+02_JPRB,4.5518E+02_JPRB,3.4161E+02_JPRB,2.2776E+02_JPRB,1.1392E+02_JPRB,8.6476E+01_JPRB/)
KBO( :, 1,34,16) = (/&
&5.7564E+02_JPRB,5.7530E+02_JPRB,4.3176E+02_JPRB,2.8787E+02_JPRB,1.4399E+02_JPRB,9.4439E+01_JPRB/)
KBO( :, 2,34,16) = (/&
&5.4576E+02_JPRB,5.4543E+02_JPRB,4.0934E+02_JPRB,2.7293E+02_JPRB,1.3651E+02_JPRB,8.7181E+01_JPRB/)
KBO( :, 3,34,16) = (/&
&5.1688E+02_JPRB,5.1657E+02_JPRB,3.8768E+02_JPRB,2.5848E+02_JPRB,1.2927E+02_JPRB,8.6122E+01_JPRB/)
KBO( :, 4,34,16) = (/&
&4.8984E+02_JPRB,4.8955E+02_JPRB,3.6740E+02_JPRB,2.4495E+02_JPRB,1.2251E+02_JPRB,9.0125E+01_JPRB/)
KBO( :, 5,34,16) = (/&
&4.6368E+02_JPRB,4.6340E+02_JPRB,3.4777E+02_JPRB,2.3187E+02_JPRB,1.1596E+02_JPRB,9.7964E+01_JPRB/)
KBO( :, 1,35,16) = (/&
&5.9022E+02_JPRB,5.8986E+02_JPRB,4.4268E+02_JPRB,2.9515E+02_JPRB,1.4762E+02_JPRB,9.6547E+01_JPRB/)
KBO( :, 2,35,16) = (/&
&5.5830E+02_JPRB,5.5796E+02_JPRB,4.1874E+02_JPRB,2.7919E+02_JPRB,1.3963E+02_JPRB,9.1112E+01_JPRB/)
KBO( :, 3,35,16) = (/&
&5.2772E+02_JPRB,5.2741E+02_JPRB,3.9581E+02_JPRB,2.6389E+02_JPRB,1.3198E+02_JPRB,9.3202E+01_JPRB/)
KBO( :, 4,35,16) = (/&
&4.9925E+02_JPRB,4.9895E+02_JPRB,3.7445E+02_JPRB,2.4965E+02_JPRB,1.2485E+02_JPRB,1.0012E+02_JPRB/)
KBO( :, 5,35,16) = (/&
&4.7190E+02_JPRB,4.7162E+02_JPRB,3.5394E+02_JPRB,2.3598E+02_JPRB,1.1801E+02_JPRB,1.1144E+02_JPRB/)
KBO( :, 1,36,16) = (/&
&6.0541E+02_JPRB,6.0504E+02_JPRB,4.5407E+02_JPRB,3.0274E+02_JPRB,1.5140E+02_JPRB,9.9056E+01_JPRB/)
KBO( :, 2,36,16) = (/&
&5.7172E+02_JPRB,5.7138E+02_JPRB,4.2880E+02_JPRB,2.8589E+02_JPRB,1.4298E+02_JPRB,9.6302E+01_JPRB/)
KBO( :, 3,36,16) = (/&
&5.3964E+02_JPRB,5.3931E+02_JPRB,4.0474E+02_JPRB,2.6984E+02_JPRB,1.3495E+02_JPRB,1.0085E+02_JPRB/)
KBO( :, 4,36,16) = (/&
&5.0967E+02_JPRB,5.0936E+02_JPRB,3.8226E+02_JPRB,2.5485E+02_JPRB,1.2745E+02_JPRB,1.1048E+02_JPRB/)
KBO( :, 5,36,16) = (/&
&4.8120E+02_JPRB,4.8091E+02_JPRB,3.6091E+02_JPRB,2.4062E+02_JPRB,1.2033E+02_JPRB,1.2766E+02_JPRB/)
KBO( :, 1,37,16) = (/&
&6.2365E+02_JPRB,6.2328E+02_JPRB,4.6775E+02_JPRB,3.1185E+02_JPRB,1.5596E+02_JPRB,1.0253E+02_JPRB/)
KBO( :, 2,37,16) = (/&
&5.8812E+02_JPRB,5.8777E+02_JPRB,4.4110E+02_JPRB,2.9409E+02_JPRB,1.4707E+02_JPRB,1.0086E+02_JPRB/)
KBO( :, 3,37,16) = (/&
&5.5432E+02_JPRB,5.5398E+02_JPRB,4.1575E+02_JPRB,2.7718E+02_JPRB,1.3861E+02_JPRB,1.0660E+02_JPRB/)
KBO( :, 4,37,16) = (/&
&5.2295E+02_JPRB,5.2264E+02_JPRB,3.9222E+02_JPRB,2.6149E+02_JPRB,1.3076E+02_JPRB,1.1783E+02_JPRB/)
KBO( :, 5,37,16) = (/&
&4.9325E+02_JPRB,4.9295E+02_JPRB,3.6994E+02_JPRB,2.4664E+02_JPRB,1.2334E+02_JPRB,1.3920E+02_JPRB/)
KBO( :, 1,38,16) = (/&
&6.4066E+02_JPRB,6.4028E+02_JPRB,4.8051E+02_JPRB,3.2036E+02_JPRB,1.6020E+02_JPRB,1.0610E+02_JPRB/)
KBO( :, 2,38,16) = (/&
&6.0334E+02_JPRB,6.0298E+02_JPRB,4.5252E+02_JPRB,3.0169E+02_JPRB,1.5087E+02_JPRB,1.0585E+02_JPRB/)
KBO( :, 3,38,16) = (/&
&5.6803E+02_JPRB,5.6769E+02_JPRB,4.2603E+02_JPRB,2.8403E+02_JPRB,1.4204E+02_JPRB,1.1325E+02_JPRB/)
KBO( :, 4,38,16) = (/&
&5.3536E+02_JPRB,5.3504E+02_JPRB,4.0152E+02_JPRB,2.6769E+02_JPRB,1.3386E+02_JPRB,1.2673E+02_JPRB/)
KBO( :, 5,38,16) = (/&
&5.0450E+02_JPRB,5.0419E+02_JPRB,3.7838E+02_JPRB,2.5226E+02_JPRB,1.2614E+02_JPRB,1.5384E+02_JPRB/)
KBO( :, 1,39,16) = (/&
&6.5607E+02_JPRB,6.5567E+02_JPRB,4.9206E+02_JPRB,3.2805E+02_JPRB,1.6405E+02_JPRB,1.1010E+02_JPRB/)
KBO( :, 2,39,16) = (/&
&6.1741E+02_JPRB,6.1704E+02_JPRB,4.6306E+02_JPRB,3.0872E+02_JPRB,1.5438E+02_JPRB,1.1190E+02_JPRB/)
KBO( :, 3,39,16) = (/&
&5.8064E+02_JPRB,5.8030E+02_JPRB,4.3549E+02_JPRB,2.9034E+02_JPRB,1.4519E+02_JPRB,1.2173E+02_JPRB/)
KBO( :, 4,39,16) = (/&
&5.4667E+02_JPRB,5.4634E+02_JPRB,4.1001E+02_JPRB,2.7335E+02_JPRB,1.3668E+02_JPRB,1.3901E+02_JPRB/)
KBO( :, 5,39,16) = (/&
&5.1480E+02_JPRB,5.1449E+02_JPRB,3.8610E+02_JPRB,2.5741E+02_JPRB,1.2872E+02_JPRB,1.7411E+02_JPRB/)
KBO( :, 1,40,16) = (/&
&6.7476E+02_JPRB,6.7436E+02_JPRB,5.0608E+02_JPRB,3.3740E+02_JPRB,1.6871E+02_JPRB,1.1362E+02_JPRB/)
KBO( :, 2,40,16) = (/&
&6.3434E+02_JPRB,6.3396E+02_JPRB,4.7576E+02_JPRB,3.1718E+02_JPRB,1.5861E+02_JPRB,1.1463E+02_JPRB/)
KBO( :, 3,40,16) = (/&
&5.9602E+02_JPRB,5.9566E+02_JPRB,4.4702E+02_JPRB,2.9802E+02_JPRB,1.4902E+02_JPRB,1.2450E+02_JPRB/)
KBO( :, 4,40,16) = (/&
&5.6052E+02_JPRB,5.6019E+02_JPRB,4.2040E+02_JPRB,2.8027E+02_JPRB,1.4015E+02_JPRB,1.4231E+02_JPRB/)
KBO( :, 5,40,16) = (/&
&5.2757E+02_JPRB,5.2726E+02_JPRB,3.9569E+02_JPRB,2.6380E+02_JPRB,1.3191E+02_JPRB,1.7853E+02_JPRB/)
KBO( :, 1,41,16) = (/&
&6.9313E+02_JPRB,6.9271E+02_JPRB,5.1985E+02_JPRB,3.4658E+02_JPRB,1.7330E+02_JPRB,1.1720E+02_JPRB/)
KBO( :, 2,41,16) = (/&
&6.5096E+02_JPRB,6.5057E+02_JPRB,4.8822E+02_JPRB,3.2549E+02_JPRB,1.6276E+02_JPRB,1.1702E+02_JPRB/)
KBO( :, 3,41,16) = (/&
&6.1137E+02_JPRB,6.1101E+02_JPRB,4.5853E+02_JPRB,3.0570E+02_JPRB,1.5286E+02_JPRB,1.2672E+02_JPRB/)
KBO( :, 4,41,16) = (/&
&5.7432E+02_JPRB,5.7398E+02_JPRB,4.3074E+02_JPRB,2.8717E+02_JPRB,1.4359E+02_JPRB,1.4478E+02_JPRB/)
KBO( :, 5,41,16) = (/&
&5.4017E+02_JPRB,5.3985E+02_JPRB,4.0513E+02_JPRB,2.7009E+02_JPRB,1.3505E+02_JPRB,1.8129E+02_JPRB/)
KBO( :, 1,42,16) = (/&
&7.1087E+02_JPRB,7.1044E+02_JPRB,5.3316E+02_JPRB,3.5544E+02_JPRB,1.7773E+02_JPRB,1.2104E+02_JPRB/)
KBO( :, 2,42,16) = (/&
&6.6722E+02_JPRB,6.6682E+02_JPRB,5.0042E+02_JPRB,3.3362E+02_JPRB,1.6682E+02_JPRB,1.1969E+02_JPRB/)
KBO( :, 3,42,16) = (/&
&6.2628E+02_JPRB,6.2590E+02_JPRB,4.6971E+02_JPRB,3.1315E+02_JPRB,1.5658E+02_JPRB,1.2937E+02_JPRB/)
KBO( :, 4,42,16) = (/&
&5.8799E+02_JPRB,5.8763E+02_JPRB,4.4099E+02_JPRB,2.9400E+02_JPRB,1.4701E+02_JPRB,1.4803E+02_JPRB/)
KBO( :, 5,42,16) = (/&
&5.5259E+02_JPRB,5.5226E+02_JPRB,4.1445E+02_JPRB,2.7630E+02_JPRB,1.3816E+02_JPRB,1.8567E+02_JPRB/)
KBO( :, 1,43,16) = (/&
&7.3062E+02_JPRB,7.3018E+02_JPRB,5.4797E+02_JPRB,3.6532E+02_JPRB,1.8267E+02_JPRB,1.2580E+02_JPRB/)
KBO( :, 2,43,16) = (/&
&6.8544E+02_JPRB,6.8503E+02_JPRB,5.1409E+02_JPRB,3.4273E+02_JPRB,1.7137E+02_JPRB,1.2199E+02_JPRB/)
KBO( :, 3,43,16) = (/&
&6.4317E+02_JPRB,6.4278E+02_JPRB,4.8238E+02_JPRB,3.2159E+02_JPRB,1.6080E+02_JPRB,1.3097E+02_JPRB/)
KBO( :, 4,43,16) = (/&
&6.0333E+02_JPRB,6.0297E+02_JPRB,4.5250E+02_JPRB,3.0167E+02_JPRB,1.5084E+02_JPRB,1.4959E+02_JPRB/)
KBO( :, 5,43,16) = (/&
&5.6660E+02_JPRB,5.6626E+02_JPRB,4.2495E+02_JPRB,2.8331E+02_JPRB,1.4166E+02_JPRB,1.8670E+02_JPRB/)
KBO( :, 1,44,16) = (/&
&7.5137E+02_JPRB,7.5091E+02_JPRB,5.6353E+02_JPRB,3.7569E+02_JPRB,1.8785E+02_JPRB,1.3103E+02_JPRB/)
KBO( :, 2,44,16) = (/&
&7.0468E+02_JPRB,7.0426E+02_JPRB,5.2852E+02_JPRB,3.5235E+02_JPRB,1.7618E+02_JPRB,1.2458E+02_JPRB/)
KBO( :, 3,44,16) = (/&
&6.6086E+02_JPRB,6.6046E+02_JPRB,4.9565E+02_JPRB,3.3044E+02_JPRB,1.6522E+02_JPRB,1.3258E+02_JPRB/)
KBO( :, 4,44,16) = (/&
&6.1971E+02_JPRB,6.1934E+02_JPRB,4.6479E+02_JPRB,3.0986E+02_JPRB,1.5494E+02_JPRB,1.5142E+02_JPRB/)
KBO( :, 5,44,16) = (/&
&5.8152E+02_JPRB,5.8117E+02_JPRB,4.3614E+02_JPRB,2.9077E+02_JPRB,1.4539E+02_JPRB,1.8803E+02_JPRB/)
KBO( :, 1,45,16) = (/&
&7.7242E+02_JPRB,7.7196E+02_JPRB,5.7932E+02_JPRB,3.8622E+02_JPRB,1.9312E+02_JPRB,1.3645E+02_JPRB/)
KBO( :, 2,45,16) = (/&
&7.2383E+02_JPRB,7.2339E+02_JPRB,5.4287E+02_JPRB,3.6192E+02_JPRB,1.8097E+02_JPRB,1.2782E+02_JPRB/)
KBO( :, 3,45,16) = (/&
&6.7845E+02_JPRB,6.7804E+02_JPRB,5.0884E+02_JPRB,3.3923E+02_JPRB,1.6962E+02_JPRB,1.3514E+02_JPRB/)
KBO( :, 4,45,16) = (/&
&6.3619E+02_JPRB,6.3581E+02_JPRB,4.7715E+02_JPRB,3.1810E+02_JPRB,1.5906E+02_JPRB,1.5528E+02_JPRB/)
KBO( :, 5,45,16) = (/&
&5.9654E+02_JPRB,5.9618E+02_JPRB,4.4741E+02_JPRB,2.9827E+02_JPRB,1.4914E+02_JPRB,1.9320E+02_JPRB/)
KBO( :, 1,46,16) = (/&
&7.9501E+02_JPRB,7.9453E+02_JPRB,5.9626E+02_JPRB,3.9751E+02_JPRB,1.9876E+02_JPRB,1.4240E+02_JPRB/)
KBO( :, 2,46,16) = (/&
&7.4406E+02_JPRB,7.4362E+02_JPRB,5.5805E+02_JPRB,3.7204E+02_JPRB,1.8602E+02_JPRB,1.3140E+02_JPRB/)
KBO( :, 3,46,16) = (/&
&6.9726E+02_JPRB,6.9684E+02_JPRB,5.2295E+02_JPRB,3.4863E+02_JPRB,1.7432E+02_JPRB,1.3799E+02_JPRB/)
KBO( :, 4,46,16) = (/&
&6.5358E+02_JPRB,6.5318E+02_JPRB,4.9018E+02_JPRB,3.2679E+02_JPRB,1.6340E+02_JPRB,1.5937E+02_JPRB/)
KBO( :, 5,46,16) = (/&
&6.1254E+02_JPRB,6.1218E+02_JPRB,4.5941E+02_JPRB,3.0628E+02_JPRB,1.5314E+02_JPRB,1.9924E+02_JPRB/)
KBO( :, 1,47,16) = (/&
&8.2010E+02_JPRB,8.1961E+02_JPRB,6.1508E+02_JPRB,4.1005E+02_JPRB,2.0503E+02_JPRB,1.4924E+02_JPRB/)
KBO( :, 2,47,16) = (/&
&7.6659E+02_JPRB,7.6613E+02_JPRB,5.7494E+02_JPRB,3.8330E+02_JPRB,1.9165E+02_JPRB,1.3525E+02_JPRB/)
KBO( :, 3,47,16) = (/&
&7.1831E+02_JPRB,7.1788E+02_JPRB,5.3873E+02_JPRB,3.5916E+02_JPRB,1.7958E+02_JPRB,1.3959E+02_JPRB/)
KBO( :, 4,47,16) = (/&
&6.7281E+02_JPRB,6.7241E+02_JPRB,5.0461E+02_JPRB,3.3641E+02_JPRB,1.6821E+02_JPRB,1.6058E+02_JPRB/)
KBO( :, 5,47,16) = (/&
&6.3054E+02_JPRB,6.3016E+02_JPRB,4.7291E+02_JPRB,3.1527E+02_JPRB,1.5764E+02_JPRB,2.0056E+02_JPRB/)
KBO( :, 1,48,16) = (/&
&8.4633E+02_JPRB,8.4583E+02_JPRB,6.3475E+02_JPRB,4.2317E+02_JPRB,2.1159E+02_JPRB,1.5645E+02_JPRB/)
KBO( :, 2,48,16) = (/&
&7.9016E+02_JPRB,7.8968E+02_JPRB,5.9262E+02_JPRB,3.9508E+02_JPRB,1.9755E+02_JPRB,1.4053E+02_JPRB/)
KBO( :, 3,48,16) = (/&
&7.3934E+02_JPRB,7.3890E+02_JPRB,5.5451E+02_JPRB,3.6967E+02_JPRB,1.8484E+02_JPRB,1.4309E+02_JPRB/)
KBO( :, 4,48,16) = (/&
&6.9255E+02_JPRB,6.9213E+02_JPRB,5.1941E+02_JPRB,3.4628E+02_JPRB,1.7314E+02_JPRB,1.6459E+02_JPRB/)
KBO( :, 5,48,16) = (/&
&6.4886E+02_JPRB,6.4847E+02_JPRB,4.8665E+02_JPRB,3.2443E+02_JPRB,1.6222E+02_JPRB,2.0658E+02_JPRB/)
KBO( :, 1,49,16) = (/&
&8.7303E+02_JPRB,8.7251E+02_JPRB,6.5477E+02_JPRB,4.3652E+02_JPRB,2.1826E+02_JPRB,1.6405E+02_JPRB/)
KBO( :, 2,49,16) = (/&
&8.1423E+02_JPRB,8.1374E+02_JPRB,6.1067E+02_JPRB,4.0712E+02_JPRB,2.0356E+02_JPRB,1.4757E+02_JPRB/)
KBO( :, 3,49,16) = (/&
&7.6096E+02_JPRB,7.6050E+02_JPRB,5.7072E+02_JPRB,3.8048E+02_JPRB,1.9025E+02_JPRB,1.4935E+02_JPRB/)
KBO( :, 4,49,16) = (/&
&7.1274E+02_JPRB,7.1231E+02_JPRB,5.3455E+02_JPRB,3.5637E+02_JPRB,1.7819E+02_JPRB,1.7305E+02_JPRB/)
KBO( :, 5,49,16) = (/&
&6.6745E+02_JPRB,6.6705E+02_JPRB,5.0059E+02_JPRB,3.3373E+02_JPRB,1.6687E+02_JPRB,2.2042E+02_JPRB/)
KBO( :, 1,50,16) = (/&
&8.9886E+02_JPRB,8.9832E+02_JPRB,6.7415E+02_JPRB,4.4943E+02_JPRB,2.2472E+02_JPRB,1.7154E+02_JPRB/)
KBO( :, 2,50,16) = (/&
&8.3744E+02_JPRB,8.3694E+02_JPRB,6.2808E+02_JPRB,4.1872E+02_JPRB,2.0936E+02_JPRB,1.5447E+02_JPRB/)
KBO( :, 3,50,16) = (/&
&7.8206E+02_JPRB,7.8159E+02_JPRB,5.8654E+02_JPRB,3.9103E+02_JPRB,1.9552E+02_JPRB,1.5292E+02_JPRB/)
KBO( :, 4,50,16) = (/&
&7.3184E+02_JPRB,7.3140E+02_JPRB,5.4888E+02_JPRB,3.6592E+02_JPRB,1.8296E+02_JPRB,1.7616E+02_JPRB/)
KBO( :, 5,50,16) = (/&
&6.8529E+02_JPRB,6.8488E+02_JPRB,5.1397E+02_JPRB,3.4265E+02_JPRB,1.7133E+02_JPRB,2.2472E+02_JPRB/)
KBO( :, 1,51,16) = (/&
&9.2454E+02_JPRB,9.2398E+02_JPRB,6.9341E+02_JPRB,4.6227E+02_JPRB,2.3114E+02_JPRB,1.7932E+02_JPRB/)
KBO( :, 2,51,16) = (/&
&8.6100E+02_JPRB,8.6049E+02_JPRB,6.4575E+02_JPRB,4.3050E+02_JPRB,2.1525E+02_JPRB,1.6117E+02_JPRB/)
KBO( :, 3,51,16) = (/&
&8.0315E+02_JPRB,8.0267E+02_JPRB,6.0236E+02_JPRB,4.0158E+02_JPRB,2.0079E+02_JPRB,1.5563E+02_JPRB/)
KBO( :, 4,51,16) = (/&
&7.5078E+02_JPRB,7.5033E+02_JPRB,5.6309E+02_JPRB,3.7539E+02_JPRB,1.8770E+02_JPRB,1.7663E+02_JPRB/)
KBO( :, 5,51,16) = (/&
&7.0300E+02_JPRB,7.0257E+02_JPRB,5.2725E+02_JPRB,3.5150E+02_JPRB,1.7575E+02_JPRB,2.2386E+02_JPRB/)
KBO( :, 1,52,16) = (/&
&9.5090E+02_JPRB,9.5033E+02_JPRB,7.1318E+02_JPRB,4.7545E+02_JPRB,2.3773E+02_JPRB,1.8754E+02_JPRB/)
KBO( :, 2,52,16) = (/&
&8.8502E+02_JPRB,8.8448E+02_JPRB,6.6376E+02_JPRB,4.4251E+02_JPRB,2.2126E+02_JPRB,1.6850E+02_JPRB/)
KBO( :, 3,52,16) = (/&
&8.2471E+02_JPRB,8.2421E+02_JPRB,6.1853E+02_JPRB,4.1235E+02_JPRB,2.0618E+02_JPRB,1.6061E+02_JPRB/)
KBO( :, 4,52,16) = (/&
&7.7013E+02_JPRB,7.6967E+02_JPRB,5.7760E+02_JPRB,3.8507E+02_JPRB,1.9253E+02_JPRB,1.8010E+02_JPRB/)
KBO( :, 5,52,16) = (/&
&7.2097E+02_JPRB,7.2053E+02_JPRB,5.4073E+02_JPRB,3.6048E+02_JPRB,1.8024E+02_JPRB,2.2809E+02_JPRB/)
KBO( :, 1,53,16) = (/&
&9.7788E+02_JPRB,9.7729E+02_JPRB,7.3341E+02_JPRB,4.8894E+02_JPRB,2.4447E+02_JPRB,1.9637E+02_JPRB/)
KBO( :, 2,53,16) = (/&
&9.0961E+02_JPRB,9.0906E+02_JPRB,6.8221E+02_JPRB,4.5481E+02_JPRB,2.2740E+02_JPRB,1.7681E+02_JPRB/)
KBO( :, 3,53,16) = (/&
&8.4702E+02_JPRB,8.4651E+02_JPRB,6.3527E+02_JPRB,4.2351E+02_JPRB,2.1176E+02_JPRB,1.6836E+02_JPRB/)
KBO( :, 4,53,16) = (/&
&7.9046E+02_JPRB,7.8999E+02_JPRB,5.9285E+02_JPRB,3.9523E+02_JPRB,1.9762E+02_JPRB,1.8837E+02_JPRB/)
KBO( :, 5,53,16) = (/&
&7.3936E+02_JPRB,7.3892E+02_JPRB,5.5452E+02_JPRB,3.6968E+02_JPRB,1.8484E+02_JPRB,2.4127E+02_JPRB/)
KBO( :, 1,54,16) = (/&
&1.0035E+03_JPRB,1.0029E+03_JPRB,7.5259E+02_JPRB,5.0173E+02_JPRB,2.5087E+02_JPRB,2.0491E+02_JPRB/)
KBO( :, 2,54,16) = (/&
&9.3285E+02_JPRB,9.3229E+02_JPRB,6.9964E+02_JPRB,4.6643E+02_JPRB,2.3321E+02_JPRB,1.8242E+02_JPRB/)
KBO( :, 3,54,16) = (/&
&8.6846E+02_JPRB,8.6794E+02_JPRB,6.5134E+02_JPRB,4.3423E+02_JPRB,2.1712E+02_JPRB,1.7066E+02_JPRB/)
KBO( :, 4,54,16) = (/&
&8.0960E+02_JPRB,8.0911E+02_JPRB,6.0720E+02_JPRB,4.0480E+02_JPRB,2.0240E+02_JPRB,1.8019E+02_JPRB/)
KBO( :, 5,54,16) = (/&
&7.5654E+02_JPRB,7.5608E+02_JPRB,5.6740E+02_JPRB,3.7827E+02_JPRB,1.8914E+02_JPRB,2.2258E+02_JPRB/)
KBO( :, 1,55,16) = (/&
&1.0290E+03_JPRB,1.0283E+03_JPRB,7.7171E+02_JPRB,5.1448E+02_JPRB,2.5724E+02_JPRB,2.1368E+02_JPRB/)
KBO( :, 2,55,16) = (/&
&9.5574E+02_JPRB,9.5517E+02_JPRB,7.1681E+02_JPRB,4.7787E+02_JPRB,2.3894E+02_JPRB,1.8874E+02_JPRB/)
KBO( :, 3,55,16) = (/&
&8.8926E+02_JPRB,8.8873E+02_JPRB,6.6695E+02_JPRB,4.4463E+02_JPRB,2.2232E+02_JPRB,1.7135E+02_JPRB/)
KBO( :, 4,55,16) = (/&
&8.2830E+02_JPRB,8.2781E+02_JPRB,6.2123E+02_JPRB,4.1415E+02_JPRB,2.0708E+02_JPRB,1.6723E+02_JPRB/)
KBO( :, 5,55,16) = (/&
&7.7332E+02_JPRB,7.7285E+02_JPRB,5.7999E+02_JPRB,3.8666E+02_JPRB,1.9333E+02_JPRB,1.9285E+02_JPRB/)
KBO( :, 1,56,16) = (/&
&1.0544E+03_JPRB,1.0538E+03_JPRB,7.9084E+02_JPRB,5.2722E+02_JPRB,2.6389E+02_JPRB,2.2294E+02_JPRB/)
KBO( :, 2,56,16) = (/&
&9.7928E+02_JPRB,9.7870E+02_JPRB,7.3446E+02_JPRB,4.8964E+02_JPRB,2.4482E+02_JPRB,1.9643E+02_JPRB/)
KBO( :, 3,56,16) = (/&
&9.1058E+02_JPRB,9.1004E+02_JPRB,6.8294E+02_JPRB,4.5529E+02_JPRB,2.2765E+02_JPRB,1.7473E+02_JPRB/)
KBO( :, 4,56,16) = (/&
&8.4774E+02_JPRB,8.4724E+02_JPRB,6.3581E+02_JPRB,4.2387E+02_JPRB,2.1194E+02_JPRB,1.6206E+02_JPRB/)
KBO( :, 5,56,16) = (/&
&7.9097E+02_JPRB,7.9049E+02_JPRB,5.9323E+02_JPRB,3.9548E+02_JPRB,1.9774E+02_JPRB,1.7273E+02_JPRB/)
KBO( :, 1,57,16) = (/&
&1.0813E+03_JPRB,1.0806E+03_JPRB,8.1095E+02_JPRB,5.4063E+02_JPRB,2.7119E+02_JPRB,2.3288E+02_JPRB/)
KBO( :, 2,57,16) = (/&
&1.0033E+03_JPRB,1.0027E+03_JPRB,7.5245E+02_JPRB,5.0163E+02_JPRB,2.5082E+02_JPRB,2.0449E+02_JPRB/)
KBO( :, 3,57,16) = (/&
&9.3233E+02_JPRB,9.3177E+02_JPRB,6.9925E+02_JPRB,4.6617E+02_JPRB,2.3308E+02_JPRB,1.8109E+02_JPRB/)
KBO( :, 4,57,16) = (/&
&8.6794E+02_JPRB,8.6742E+02_JPRB,6.5095E+02_JPRB,4.3397E+02_JPRB,2.1699E+02_JPRB,1.6333E+02_JPRB/)
KBO( :, 5,57,16) = (/&
&8.0892E+02_JPRB,8.0843E+02_JPRB,6.0669E+02_JPRB,4.0446E+02_JPRB,2.0223E+02_JPRB,1.5955E+02_JPRB/)
KBO( :, 1,58,16) = (/&
&1.1081E+03_JPRB,1.1074E+03_JPRB,8.3108E+02_JPRB,5.5405E+02_JPRB,2.7884E+02_JPRB,2.4302E+02_JPRB/)
KBO( :, 2,58,16) = (/&
&1.0267E+03_JPRB,1.0261E+03_JPRB,7.7004E+02_JPRB,5.1336E+02_JPRB,2.5668E+02_JPRB,2.1265E+02_JPRB/)
KBO( :, 3,58,16) = (/&
&9.5368E+02_JPRB,9.5311E+02_JPRB,7.1526E+02_JPRB,4.7684E+02_JPRB,2.3842E+02_JPRB,1.8786E+02_JPRB/)
KBO( :, 4,58,16) = (/&
&8.8727E+02_JPRB,8.8673E+02_JPRB,6.6545E+02_JPRB,4.4363E+02_JPRB,2.2182E+02_JPRB,1.6726E+02_JPRB/)
KBO( :, 5,58,16) = (/&
&8.2643E+02_JPRB,8.2594E+02_JPRB,6.1982E+02_JPRB,4.1322E+02_JPRB,2.0661E+02_JPRB,1.5255E+02_JPRB/)
KBO( :, 1,59,16) = (/&
&1.1197E+03_JPRB,1.1190E+03_JPRB,8.3976E+02_JPRB,5.5984E+02_JPRB,2.8216E+02_JPRB,2.4731E+02_JPRB/)
KBO( :, 2,59,16) = (/&
&1.0365E+03_JPRB,1.0359E+03_JPRB,7.7738E+02_JPRB,5.1826E+02_JPRB,2.5916E+02_JPRB,2.1609E+02_JPRB/)
KBO( :, 3,59,16) = (/&
&9.6265E+02_JPRB,9.6208E+02_JPRB,7.2199E+02_JPRB,4.8133E+02_JPRB,2.4066E+02_JPRB,1.9071E+02_JPRB/)
KBO( :, 4,59,16) = (/&
&8.9534E+02_JPRB,8.9480E+02_JPRB,6.7151E+02_JPRB,4.4767E+02_JPRB,2.2384E+02_JPRB,1.6963E+02_JPRB/)
KBO( :, 5,59,16) = (/&
&8.3369E+02_JPRB,8.3319E+02_JPRB,6.2527E+02_JPRB,4.1685E+02_JPRB,2.0842E+02_JPRB,1.5178E+02_JPRB/)


!     The array SELFREFO contains the coefficient of the water vapor
!     self-continuum (including the energy term).  The first index
!     refers to temperature in 7.2 degree increments.  For instance,
!     JT = 1 refers to a temperature of 245.6, JT = 2 refers to 252.8,
!     etc.  The second index runs over the g-channel (1 to 16).

SELFREFO( :, 1) = (/&
&2.62628E-01_JPRB, 2.29008E-01_JPRB, 1.99692E-01_JPRB, 1.74129E-01_JPRB, 1.51838E-01_JPRB,&
&1.32400E-01_JPRB, 1.15451E-01_JPRB, 1.00672E-01_JPRB, 8.77845E-02_JPRB, 7.65469E-02_JPRB/)
SELFREFO( :, 2) = (/&
&2.45051E-01_JPRB, 2.12961E-01_JPRB, 1.85073E-01_JPRB, 1.60837E-01_JPRB, 1.39775E-01_JPRB,&
&1.21471E-01_JPRB, 1.05564E-01_JPRB, 9.17397E-02_JPRB, 7.97260E-02_JPRB, 6.92856E-02_JPRB/)
SELFREFO( :, 3) = (/&
&2.42194E-01_JPRB, 2.09976E-01_JPRB, 1.82044E-01_JPRB, 1.57827E-01_JPRB, 1.36832E-01_JPRB,&
&1.18630E-01_JPRB, 1.02849E-01_JPRB, 8.91673E-02_JPRB, 7.73057E-02_JPRB, 6.70221E-02_JPRB/)
SELFREFO( :, 4) = (/&
&2.44485E-01_JPRB, 2.11926E-01_JPRB, 1.83702E-01_JPRB, 1.59237E-01_JPRB, 1.38030E-01_JPRB,&
&1.19648E-01_JPRB, 1.03714E-01_JPRB, 8.99014E-02_JPRB, 7.79286E-02_JPRB, 6.75503E-02_JPRB/)
SELFREFO( :, 5) = (/&
&2.43120E-01_JPRB, 2.10743E-01_JPRB, 1.82679E-01_JPRB, 1.58351E-01_JPRB, 1.37263E-01_JPRB,&
&1.18984E-01_JPRB, 1.03139E-01_JPRB, 8.94038E-02_JPRB, 7.74978E-02_JPRB, 6.71774E-02_JPRB/)
SELFREFO( :, 6) = (/&
&2.40558E-01_JPRB, 2.08922E-01_JPRB, 1.81446E-01_JPRB, 1.57583E-01_JPRB, 1.36859E-01_JPRB,&
&1.18860E-01_JPRB, 1.03229E-01_JPRB, 8.96529E-02_JPRB, 7.78624E-02_JPRB, 6.76225E-02_JPRB/)
SELFREFO( :, 7) = (/&
&2.42496E-01_JPRB, 2.10386E-01_JPRB, 1.82528E-01_JPRB, 1.58359E-01_JPRB, 1.37390E-01_JPRB,&
&1.19198E-01_JPRB, 1.03415E-01_JPRB, 8.97211E-02_JPRB, 7.78409E-02_JPRB, 6.75337E-02_JPRB/)
SELFREFO( :, 8) = (/&
&2.39781E-01_JPRB, 2.08227E-01_JPRB, 1.80825E-01_JPRB, 1.57029E-01_JPRB, 1.36365E-01_JPRB,&
&1.18419E-01_JPRB, 1.02836E-01_JPRB, 8.93030E-02_JPRB, 7.75510E-02_JPRB, 6.73456E-02_JPRB/)
SELFREFO( :, 9) = (/&
&2.38707E-01_JPRB, 2.07058E-01_JPRB, 1.79605E-01_JPRB, 1.55792E-01_JPRB, 1.35136E-01_JPRB,&
&1.17219E-01_JPRB, 1.01677E-01_JPRB, 8.81962E-02_JPRB, 7.65026E-02_JPRB, 6.63594E-02_JPRB/)
SELFREFO( :,10) = (/&
&2.29942E-01_JPRB, 2.00668E-01_JPRB, 1.75121E-01_JPRB, 1.52826E-01_JPRB, 1.33370E-01_JPRB,&
&1.16390E-01_JPRB, 1.01572E-01_JPRB, 8.86410E-02_JPRB, 7.73560E-02_JPRB, 6.75077E-02_JPRB/)
SELFREFO( :,11) = (/&
&2.39870E-01_JPRB, 2.08120E-01_JPRB, 1.80573E-01_JPRB, 1.56671E-01_JPRB, 1.35934E-01_JPRB,&
&1.17941E-01_JPRB, 1.02330E-01_JPRB, 8.87854E-02_JPRB, 7.70335E-02_JPRB, 6.68371E-02_JPRB/)
SELFREFO( :,12) = (/&
&2.40196E-01_JPRB, 2.08400E-01_JPRB, 1.80812E-01_JPRB, 1.56877E-01_JPRB, 1.36110E-01_JPRB,&
&1.18092E-01_JPRB, 1.02460E-01_JPRB, 8.88962E-02_JPRB, 7.71284E-02_JPRB, 6.69184E-02_JPRB/)
SELFREFO( :,13) = (/&
&2.40426E-01_JPRB, 2.08603E-01_JPRB, 1.80991E-01_JPRB, 1.57035E-01_JPRB, 1.36249E-01_JPRB,&
&1.18214E-01_JPRB, 1.02567E-01_JPRB, 8.89909E-02_JPRB, 7.72117E-02_JPRB, 6.69917E-02_JPRB/)
SELFREFO( :,14) = (/&
&2.40590E-01_JPRB, 2.08742E-01_JPRB, 1.81110E-01_JPRB, 1.57135E-01_JPRB, 1.36334E-01_JPRB,&
&1.18287E-01_JPRB, 1.02628E-01_JPRB, 8.90428E-02_JPRB, 7.72556E-02_JPRB, 6.70288E-02_JPRB/)
SELFREFO( :,15) = (/&
&2.40634E-01_JPRB, 2.08779E-01_JPRB, 1.81141E-01_JPRB, 1.57162E-01_JPRB, 1.36357E-01_JPRB,&
&1.18306E-01_JPRB, 1.02645E-01_JPRB, 8.90565E-02_JPRB, 7.72673E-02_JPRB, 6.70387E-02_JPRB/)
SELFREFO( :,16) = (/&
&2.40652E-01_JPRB, 2.08793E-01_JPRB, 1.81151E-01_JPRB, 1.57169E-01_JPRB, 1.36362E-01_JPRB,&
&1.18309E-01_JPRB, 1.02647E-01_JPRB, 8.90576E-02_JPRB, 7.72675E-02_JPRB, 6.70383E-02_JPRB/)

FRACREFAO( :, 1) = (/&
!     From P = 
    &0.15579100_JPRB,0.14918099_JPRB,0.14113800_JPRB,0.13127001_JPRB,&
    &0.11796300_JPRB,0.10174300_JPRB,0.08282370_JPRB,0.06238150_JPRB,&
    &0.04213440_JPRB,0.00458968_JPRB,0.00377949_JPRB,0.00298736_JPRB,&
    &0.00220743_JPRB,0.00140644_JPRB,0.00053024_JPRB,0.00007459_JPRB/)
FRACREFAO( :, 2) = (/&
    &0.15292799_JPRB,0.15004000_JPRB,0.14211500_JPRB,0.13176700_JPRB,&
    &0.11821100_JPRB,0.10186300_JPRB,0.08288040_JPRB,0.06241390_JPRB,&
    &0.04220720_JPRB,0.00459006_JPRB,0.00377919_JPRB,0.00298743_JPRB,&
    &0.00220743_JPRB,0.00140644_JPRB,0.00053024_JPRB,0.00007459_JPRB/)
FRACREFAO( :, 3) = (/&
    &0.14386199_JPRB,0.15125300_JPRB,0.14650001_JPRB,0.13377000_JPRB,&
    &0.11895900_JPRB,0.10229400_JPRB,0.08312110_JPRB,0.06239520_JPRB,&
    &0.04225560_JPRB,0.00459428_JPRB,0.00378865_JPRB,0.00298860_JPRB,&
    &0.00220743_JPRB,0.00140644_JPRB,0.00053024_JPRB,0.00007459_JPRB/)
FRACREFAO( :, 4) = (/&
    &0.14359100_JPRB,0.14561599_JPRB,0.14479300_JPRB,0.13740200_JPRB,&
    &0.12150100_JPRB,0.10315400_JPRB,0.08355480_JPRB,0.06247240_JPRB,&
    &0.04230980_JPRB,0.00459916_JPRB,0.00378373_JPRB,0.00300063_JPRB,&
    &0.00221111_JPRB,0.00140644_JPRB,0.00053024_JPRB,0.00007459_JPRB/)
FRACREFAO( :, 5) = (/&
    &0.14337599_JPRB,0.14451601_JPRB,0.14238000_JPRB,0.13520500_JPRB,&
    &0.12354200_JPRB,0.10581200_JPRB,0.08451810_JPRB,0.06262440_JPRB,&
    &0.04239590_JPRB,0.00460297_JPRB,0.00378701_JPRB,0.00300466_JPRB,&
    &0.00221899_JPRB,0.00141020_JPRB,0.00053024_JPRB,0.00007459_JPRB/)
FRACREFAO( :, 6) = (/&
    &0.14322001_JPRB,0.14397401_JPRB,0.14117201_JPRB,0.13401900_JPRB,&
    &0.12255500_JPRB,0.10774100_JPRB,0.08617650_JPRB,0.06296420_JPRB,&
    &0.04249590_JPRB,0.00463406_JPRB,0.00378241_JPRB,0.00302037_JPRB,&
    &0.00221583_JPRB,0.00141103_JPRB,0.00053814_JPRB,0.00007991_JPRB/)
FRACREFAO( :, 7) = (/&
    &0.14309500_JPRB,0.14364301_JPRB,0.14043900_JPRB,0.13348100_JPRB,&
    &0.12211600_JPRB,0.10684700_JPRB,0.08820590_JPRB,0.06374610_JPRB,&
    &0.04264730_JPRB,0.00464231_JPRB,0.00384022_JPRB,0.00303427_JPRB,&
    &0.00221825_JPRB,0.00140943_JPRB,0.00055564_JPRB,0.00007991_JPRB/)
FRACREFAO( :, 8) = (/&
    &0.15579100_JPRB,0.14918099_JPRB,0.14113800_JPRB,0.13127001_JPRB,&
    &0.11796300_JPRB,0.10174300_JPRB,0.08282370_JPRB,0.06238150_JPRB,&
    &0.04213440_JPRB,0.00458968_JPRB,0.00377949_JPRB,0.00298736_JPRB,&
    &0.00220743_JPRB,0.00140644_JPRB,0.00053024_JPRB,0.00007459_JPRB/)
FRACREFAO( :, 9) = (/&
    &0.15937001_JPRB,0.15159500_JPRB,0.14242800_JPRB,0.13078900_JPRB,&
    &0.11671300_JPRB,0.10035700_JPRB,0.08143450_JPRB,0.06093850_JPRB,&
    &0.04105320_JPRB,0.00446233_JPRB,0.00369844_JPRB,0.00293784_JPRB,&
    &0.00216425_JPRB,0.00143403_JPRB,0.00054571_JPRB,0.00007991_JPRB/)

FRACREFBO( :, 1) = (/&
!     From P = 1.17 mb.
    &0.15558299_JPRB,0.14930600_JPRB,0.14104301_JPRB,0.13124099_JPRB,&
    &0.11792900_JPRB,0.10159200_JPRB,0.08314130_JPRB,0.06240450_JPRB,&
    &0.04217020_JPRB,0.00459313_JPRB,0.00379798_JPRB,0.00299835_JPRB,&
    &0.00218950_JPRB,0.00140615_JPRB,0.00053010_JPRB,0.00007457_JPRB/)
FRACREFBO( :, 2) = (/&
    &0.15592700_JPRB,0.14918999_JPRB,0.14095700_JPRB,0.13115700_JPRB,&
    &0.11788900_JPRB,0.10158000_JPRB,0.08313780_JPRB,0.06240240_JPRB,&
    &0.04217000_JPRB,0.00459313_JPRB,0.00379798_JPRB,0.00299835_JPRB,&
    &0.00218950_JPRB,0.00140615_JPRB,0.00053010_JPRB,0.00007457_JPRB/)
FRACREFBO( :, 3) = (/&
    &0.15949000_JPRB,0.15014900_JPRB,0.14162201_JPRB,0.13080800_JPRB,&
    &0.11713500_JPRB,0.10057100_JPRB,0.08170080_JPRB,0.06128110_JPRB,&
    &0.04165600_JPRB,0.00459202_JPRB,0.00379835_JPRB,0.00299717_JPRB,&
    &0.00218958_JPRB,0.00140616_JPRB,0.00053010_JPRB,0.00007457_JPRB/)
FRACREFBO( :, 4) = (/&
    &0.15967900_JPRB,0.15038200_JPRB,0.14196999_JPRB,0.13074800_JPRB,&
    &0.11701700_JPRB,0.10053000_JPRB,0.08160790_JPRB,0.06122690_JPRB,&
    &0.04128310_JPRB,0.00456598_JPRB,0.00379486_JPRB,0.00299457_JPRB,&
    &0.00219016_JPRB,0.00140619_JPRB,0.00053011_JPRB,0.00007456_JPRB/)
FRACREFBO( :, 5) = (/&
    &0.15989800_JPRB,0.15057300_JPRB,0.14207700_JPRB,0.13068600_JPRB,&
    &0.11682900_JPRB,0.10053900_JPRB,0.08163610_JPRB,0.06121870_JPRB,&
    &0.04121690_JPRB,0.00449061_JPRB,0.00371235_JPRB,0.00294207_JPRB,&
    &0.00217778_JPRB,0.00139877_JPRB,0.00053011_JPRB,0.00007455_JPRB/)
FRACREFBO( :, 6) = (/&
    &0.15950100_JPRB,0.15112500_JPRB,0.14199100_JPRB,0.13071300_JPRB,&
    &0.11680800_JPRB,0.10054600_JPRB,0.08179050_JPRB,0.06120910_JPRB,&
    &0.04126050_JPRB,0.00444324_JPRB,0.00366843_JPRB,0.00289369_JPRB,&
    &0.00211550_JPRB,0.00134746_JPRB,0.00050874_JPRB,0.00007863_JPRB/)

!     -----------------------------------------------------------------
RETURN
END SUBROUTINE RRTM_KGB4_C
