!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! ECMWF_RAD1_MODIF_IDRIS 2003/02/19 13:36:34
!-----------------------------------------------------------------
!OCL SCALAR
SUBROUTINE RRTM_KGB5_A

!     Originally by Eli J. Mlawer, Atmospheric & Environmental Research.
!     BAND 5:  700-820 cm-1 (low - H2O,CO2; high - O3,CO2)
!     Reformatted for F90 by JJMorcrette, ECMWF

!     ------------------------------------------------------------------

!*    kindef: define default KIND macros
! --------------------------------------


USE PARKIND1, ONLY :&
 &JPIT, JPIS, JPIM, JPIB,&
 &JPRT, JPRS, JPRM, JPRB

















































! --------------------------------------


USE OYOERRTO5 , ONLY : KAO     ,KBO     ,SELFREFO   ,FRACREFAO  ,&
           &FRACREFBO, CCL4O
USE OYOERRTA5 , ONLY : STRRAT1   ,STRRAT2

!     ------------------------------------------------------------------


IMPLICIT NONE
CCL4O( :) = (/&
     &26.1407_JPRB,  53.9776_JPRB,  63.8085_JPRB,  36.1701_JPRB,&
     &15.4099_JPRB, 10.23116_JPRB,  4.82948_JPRB,  5.03836_JPRB,&
     &1.75558_JPRB,  0.0_JPRB       ,  0.0_JPRB       ,  0.0_JPRB       ,&
     & 0.0_JPRB       ,  0.0_JPRB       ,  0.0_JPRB       ,  0.0_JPRB        /)

STRRAT1 = 90.4894_JPRB
STRRAT2 = 0.900502_JPRB

!     ------------------------------------------------------------------

!     The array KAO contains absorption coefs for each of the 16 g-intervals
!     for a range of pressure levels > ~100mb, temperatures, and ratios
!     of water vapor to CO2.  The first index in the array, JS, runs
!     from 1 to 9 and corresponds to different water vapor to CO2 ratios,
!     as expressed through the binary species parameter eta, defined as
!     eta = h2o/(h20 + (rat) * co2), where rat is the ratio of the integrated
!     line strength in the band of co2 to that of h2o.  For instance,
!     JS=1 refers to dry air (eta = 0), JS = 9 corresponds to eta = 1.0.
!     The 2nd index in the array, JT, which runs from 1 to 5, corresponds 
!     to different temperatures.  More specifically, JT = 3 means that the 
!     data are for the reference temperature TREF for this  pressure 
!     level, JT = 2 refers to the temperature TREF-15, 
!     JT = 1 is for TREF-30, JT = 4 is for TREF+15, and JT = 5
!     is for TREF+30.  The third index, JP, runs from 1 to 13 and refers
!     to the reference pressure level (e.g. JP = 1 is for a
!     pressure of 1053.63 mb).  The fourth index, IG, goes from 1 to 16,
!     and tells us which g-interval the absorption coefficients are for.

KAO( :, 1, 1, 1) = (/&
&1.2281E-06_JPRB,7.3444E-06_JPRB,1.3802E-05_JPRB,2.1363E-05_JPRB,3.4026E-05_JPRB,5.1149E-05_JPRB,&
&7.6454E-05_JPRB,1.1492E-04_JPRB,5.1051E-05_JPRB/)
KAO( :, 2, 1, 1) = (/&
&1.6369E-06_JPRB,8.9617E-06_JPRB,1.6072E-05_JPRB,2.4135E-05_JPRB,3.4106E-05_JPRB,4.9214E-05_JPRB,&
&7.9048E-05_JPRB,1.3905E-04_JPRB,5.4063E-05_JPRB/)
KAO( :, 3, 1, 1) = (/&
&2.1611E-06_JPRB,1.1094E-05_JPRB,1.8726E-05_JPRB,2.7825E-05_JPRB,3.8281E-05_JPRB,5.1592E-05_JPRB,&
&7.6813E-05_JPRB,1.3616E-04_JPRB,6.0994E-05_JPRB/)
KAO( :, 4, 1, 1) = (/&
&2.8032E-06_JPRB,1.3911E-05_JPRB,2.1873E-05_JPRB,3.1872E-05_JPRB,4.3669E-05_JPRB,5.8650E-05_JPRB,&
&8.1107E-05_JPRB,1.3247E-04_JPRB,6.8413E-05_JPRB/)
KAO( :, 5, 1, 1) = (/&
&3.5749E-06_JPRB,1.7399E-05_JPRB,2.6270E-05_JPRB,3.5363E-05_JPRB,4.8470E-05_JPRB,6.5479E-05_JPRB,&
&9.0735E-05_JPRB,1.4099E-04_JPRB,5.7731E-05_JPRB/)
KAO( :, 1, 2, 1) = (/&
&9.2208E-07_JPRB,5.6661E-06_JPRB,1.0853E-05_JPRB,1.7695E-05_JPRB,2.8111E-05_JPRB,4.1811E-05_JPRB,&
&5.7766E-05_JPRB,8.8171E-05_JPRB,3.6499E-05_JPRB/)
KAO( :, 2, 2, 1) = (/&
&1.2339E-06_JPRB,6.8718E-06_JPRB,1.2450E-05_JPRB,1.9038E-05_JPRB,2.7428E-05_JPRB,4.2214E-05_JPRB,&
&6.5891E-05_JPRB,1.0808E-04_JPRB,3.9328E-05_JPRB/)
KAO( :, 3, 2, 1) = (/&
&1.6382E-06_JPRB,8.4733E-06_JPRB,1.4470E-05_JPRB,2.1567E-05_JPRB,3.0172E-05_JPRB,4.1842E-05_JPRB,&
&6.2761E-05_JPRB,1.1359E-04_JPRB,4.4926E-05_JPRB/)
KAO( :, 4, 2, 1) = (/&
&2.1437E-06_JPRB,1.0582E-05_JPRB,1.7090E-05_JPRB,2.4961E-05_JPRB,3.4319E-05_JPRB,4.6334E-05_JPRB,&
&6.4942E-05_JPRB,1.0880E-04_JPRB,4.8706E-05_JPRB/)
KAO( :, 5, 2, 1) = (/&
&2.7550E-06_JPRB,1.3307E-05_JPRB,2.0303E-05_JPRB,2.7768E-05_JPRB,3.8649E-05_JPRB,5.3069E-05_JPRB,&
&7.1656E-05_JPRB,1.1174E-04_JPRB,4.2264E-05_JPRB/)
KAO( :, 1, 3, 1) = (/&
&6.5681E-07_JPRB,4.2928E-06_JPRB,8.6206E-06_JPRB,1.4813E-05_JPRB,2.2795E-05_JPRB,3.0956E-05_JPRB,&
&4.2159E-05_JPRB,6.7143E-05_JPRB,2.4558E-05_JPRB/)
KAO( :, 2, 3, 1) = (/&
&8.8032E-07_JPRB,5.0858E-06_JPRB,9.4979E-06_JPRB,1.4908E-05_JPRB,2.3302E-05_JPRB,3.4761E-05_JPRB,&
&5.2810E-05_JPRB,7.8083E-05_JPRB,2.7352E-05_JPRB/)
KAO( :, 3, 3, 1) = (/&
&1.1757E-06_JPRB,6.2479E-06_JPRB,1.1007E-05_JPRB,1.6613E-05_JPRB,2.3543E-05_JPRB,3.3879E-05_JPRB,&
&5.3064E-05_JPRB,9.3905E-05_JPRB,3.1433E-05_JPRB/)
KAO( :, 4, 3, 1) = (/&
&1.5541E-06_JPRB,7.7549E-06_JPRB,1.2987E-05_JPRB,1.9178E-05_JPRB,2.6197E-05_JPRB,3.5750E-05_JPRB,&
&5.1915E-05_JPRB,9.2229E-05_JPRB,2.9423E-05_JPRB/)
KAO( :, 5, 3, 1) = (/&
&2.0193E-06_JPRB,9.7639E-06_JPRB,1.5167E-05_JPRB,2.2031E-05_JPRB,3.0010E-05_JPRB,4.0258E-05_JPRB,&
&5.5267E-05_JPRB,9.0112E-05_JPRB,2.9943E-05_JPRB/)
KAO( :, 1, 4, 1) = (/&
&4.6419E-07_JPRB,3.2238E-06_JPRB,7.0968E-06_JPRB,1.2172E-05_JPRB,1.6732E-05_JPRB,2.2369E-05_JPRB,&
&3.1463E-05_JPRB,5.3229E-05_JPRB,1.7381E-05_JPRB/)
KAO( :, 2, 4, 1) = (/&
&6.2245E-07_JPRB,3.7726E-06_JPRB,7.2766E-06_JPRB,1.2504E-05_JPRB,1.9255E-05_JPRB,2.8079E-05_JPRB,&
&3.7485E-05_JPRB,5.7403E-05_JPRB,1.9667E-05_JPRB/)
KAO( :, 3, 4, 1) = (/&
&8.3351E-07_JPRB,4.5653E-06_JPRB,8.3036E-06_JPRB,1.2777E-05_JPRB,1.8816E-05_JPRB,2.9030E-05_JPRB,&
&4.4417E-05_JPRB,7.0863E-05_JPRB,2.1895E-05_JPRB/)
KAO( :, 4, 4, 1) = (/&
&1.1087E-06_JPRB,5.6384E-06_JPRB,9.6405E-06_JPRB,1.4565E-05_JPRB,2.0321E-05_JPRB,2.8264E-05_JPRB,&
&4.3444E-05_JPRB,7.7444E-05_JPRB,2.1414E-05_JPRB/)
KAO( :, 5, 4, 1) = (/&
&1.4581E-06_JPRB,7.0726E-06_JPRB,1.1402E-05_JPRB,1.6579E-05_JPRB,2.3011E-05_JPRB,3.1009E-05_JPRB,&
&4.3245E-05_JPRB,7.3708E-05_JPRB,2.2863E-05_JPRB/)
KAO( :, 1, 5, 1) = (/&
&3.3427E-07_JPRB,2.5337E-06_JPRB,5.7680E-06_JPRB,8.9425E-06_JPRB,1.2242E-05_JPRB,1.6995E-05_JPRB,&
&2.4164E-05_JPRB,4.4230E-05_JPRB,1.3422E-05_JPRB/)
KAO( :, 2, 5, 1) = (/&
&4.4601E-07_JPRB,2.8401E-06_JPRB,5.8531E-06_JPRB,1.0220E-05_JPRB,1.5419E-05_JPRB,2.0153E-05_JPRB,&
&2.7336E-05_JPRB,4.3727E-05_JPRB,1.5115E-05_JPRB/)
KAO( :, 3, 5, 1) = (/&
&5.9812E-07_JPRB,3.3532E-06_JPRB,6.3191E-06_JPRB,1.0031E-05_JPRB,1.5953E-05_JPRB,2.3950E-05_JPRB,&
&3.4195E-05_JPRB,5.0601E-05_JPRB,1.6591E-05_JPRB/)
KAO( :, 4, 5, 1) = (/&
&7.9837E-07_JPRB,4.1280E-06_JPRB,7.3147E-06_JPRB,1.1079E-05_JPRB,1.5854E-05_JPRB,2.3810E-05_JPRB,&
&3.6514E-05_JPRB,6.2591E-05_JPRB,1.7658E-05_JPRB/)
KAO( :, 5, 5, 1) = (/&
&1.0575E-06_JPRB,5.1440E-06_JPRB,8.5910E-06_JPRB,1.2709E-05_JPRB,1.7592E-05_JPRB,2.4262E-05_JPRB,&
&3.5276E-05_JPRB,6.2368E-05_JPRB,1.9388E-05_JPRB/)
KAO( :, 1, 6, 1) = (/&
&2.4467E-07_JPRB,2.0115E-06_JPRB,4.4506E-06_JPRB,6.5328E-06_JPRB,9.2134E-06_JPRB,1.2867E-05_JPRB,&
&1.9266E-05_JPRB,3.4226E-05_JPRB,1.1020E-05_JPRB/)
KAO( :, 2, 6, 1) = (/&
&3.2244E-07_JPRB,2.1802E-06_JPRB,4.7859E-06_JPRB,8.3031E-06_JPRB,1.1024E-05_JPRB,1.4816E-05_JPRB,&
&2.0767E-05_JPRB,3.3867E-05_JPRB,1.2361E-05_JPRB/)
KAO( :, 3, 6, 1) = (/&
&4.3252E-07_JPRB,2.5034E-06_JPRB,4.8788E-06_JPRB,8.5188E-06_JPRB,1.3353E-05_JPRB,1.8353E-05_JPRB,&
&2.4440E-05_JPRB,3.7220E-05_JPRB,1.3756E-05_JPRB/)
KAO( :, 4, 6, 1) = (/&
&5.7866E-07_JPRB,3.0227E-06_JPRB,5.4901E-06_JPRB,8.5441E-06_JPRB,1.3294E-05_JPRB,1.9970E-05_JPRB,&
&3.0079E-05_JPRB,4.5487E-05_JPRB,1.5370E-05_JPRB/)
KAO( :, 5, 6, 1) = (/&
&7.6960E-07_JPRB,3.7504E-06_JPRB,6.3767E-06_JPRB,9.6311E-06_JPRB,1.3563E-05_JPRB,1.9464E-05_JPRB,&
&3.0023E-05_JPRB,5.3031E-05_JPRB,1.7349E-05_JPRB/)
KAO( :, 1, 7, 1) = (/&
&1.8363E-07_JPRB,1.6339E-06_JPRB,3.2365E-06_JPRB,4.8736E-06_JPRB,7.0565E-06_JPRB,1.0168E-05_JPRB,&
&1.5448E-05_JPRB,2.6119E-05_JPRB,9.9973E-06_JPRB/)
KAO( :, 2, 7, 1) = (/&
&2.3828E-07_JPRB,1.7045E-06_JPRB,3.9446E-06_JPRB,5.9885E-06_JPRB,8.1187E-06_JPRB,1.1164E-05_JPRB,&
&1.5910E-05_JPRB,2.7804E-05_JPRB,1.1252E-05_JPRB/)
KAO( :, 3, 7, 1) = (/&
&3.1712E-07_JPRB,1.8915E-06_JPRB,4.0133E-06_JPRB,6.9371E-06_JPRB,1.0184E-05_JPRB,1.3247E-05_JPRB,&
&1.8144E-05_JPRB,2.8687E-05_JPRB,1.2767E-05_JPRB/)
KAO( :, 4, 7, 1) = (/&
&4.2549E-07_JPRB,2.2415E-06_JPRB,4.2001E-06_JPRB,7.0066E-06_JPRB,1.0950E-05_JPRB,1.6323E-05_JPRB,&
&2.2218E-05_JPRB,3.2987E-05_JPRB,1.4591E-05_JPRB/)
KAO( :, 5, 7, 1) = (/&
&5.6782E-07_JPRB,2.7608E-06_JPRB,4.8541E-06_JPRB,7.3705E-06_JPRB,1.0748E-05_JPRB,1.6390E-05_JPRB,&
&2.5035E-05_JPRB,4.1583E-05_JPRB,1.6759E-05_JPRB/)
KAO( :, 1, 8, 1) = (/&
&1.4297E-07_JPRB,1.2986E-06_JPRB,2.4296E-06_JPRB,3.7740E-06_JPRB,5.5717E-06_JPRB,8.1007E-06_JPRB,&
&1.2269E-05_JPRB,2.0668E-05_JPRB,1.1224E-05_JPRB/)
KAO( :, 2, 8, 1) = (/&
&1.8237E-07_JPRB,1.3796E-06_JPRB,2.9841E-06_JPRB,4.4232E-06_JPRB,6.1625E-06_JPRB,8.6070E-06_JPRB,&
&1.2749E-05_JPRB,2.2374E-05_JPRB,1.3050E-05_JPRB/)
KAO( :, 3, 8, 1) = (/&
&2.3995E-07_JPRB,1.4828E-06_JPRB,3.2302E-06_JPRB,5.5721E-06_JPRB,7.4009E-06_JPRB,9.9584E-06_JPRB,&
&1.3793E-05_JPRB,2.2720E-05_JPRB,1.5037E-05_JPRB/)
KAO( :, 4, 8, 1) = (/&
&3.2109E-07_JPRB,1.7086E-06_JPRB,3.3052E-06_JPRB,5.7552E-06_JPRB,9.1163E-06_JPRB,1.2137E-05_JPRB,&
&1.6200E-05_JPRB,2.4932E-05_JPRB,1.7316E-05_JPRB/)
KAO( :, 5, 8, 1) = (/&
&4.2933E-07_JPRB,2.0665E-06_JPRB,3.6851E-06_JPRB,5.7093E-06_JPRB,9.1231E-06_JPRB,1.3616E-05_JPRB,&
&2.0240E-05_JPRB,2.9795E-05_JPRB,1.9811E-05_JPRB/)
KAO( :, 1, 9, 1) = (/&
&1.1391E-07_JPRB,9.6607E-07_JPRB,1.8596E-06_JPRB,2.9960E-06_JPRB,4.4278E-06_JPRB,6.4496E-06_JPRB,&
&9.3668E-06_JPRB,1.6296E-05_JPRB,2.3175E-05_JPRB/)
KAO( :, 2, 9, 1) = (/&
&1.4318E-07_JPRB,1.1432E-06_JPRB,2.1917E-06_JPRB,3.3465E-06_JPRB,4.7894E-06_JPRB,6.8583E-06_JPRB,&
&1.0124E-05_JPRB,1.7732E-05_JPRB,2.8424E-05_JPRB/)
KAO( :, 3, 9, 1) = (/&
&1.8594E-07_JPRB,1.1885E-06_JPRB,2.6962E-06_JPRB,4.0343E-06_JPRB,5.5351E-06_JPRB,7.5514E-06_JPRB,&
&1.0675E-05_JPRB,1.8150E-05_JPRB,3.4053E-05_JPRB/)
KAO( :, 4, 9, 1) = (/&
&2.4670E-07_JPRB,1.3380E-06_JPRB,2.7503E-06_JPRB,4.7549E-06_JPRB,6.8876E-06_JPRB,8.9087E-06_JPRB,&
&1.2295E-05_JPRB,1.9210E-05_JPRB,3.9839E-05_JPRB/)
KAO( :, 5, 9, 1) = (/&
&3.3010E-07_JPRB,1.5784E-06_JPRB,2.8513E-06_JPRB,4.8049E-06_JPRB,7.4827E-06_JPRB,1.1096E-05_JPRB,&
&1.4749E-05_JPRB,2.1955E-05_JPRB,4.5594E-05_JPRB/)
KAO( :, 1,10, 1) = (/&
&9.5530E-08_JPRB,7.6103E-07_JPRB,1.4822E-06_JPRB,2.4013E-06_JPRB,3.5241E-06_JPRB,5.0863E-06_JPRB,&
&7.7041E-06_JPRB,1.2423E-05_JPRB,8.9067E-05_JPRB/)
KAO( :, 2,10, 1) = (/&
&1.1882E-07_JPRB,9.2450E-07_JPRB,1.6979E-06_JPRB,2.6207E-06_JPRB,3.8503E-06_JPRB,5.4657E-06_JPRB,&
&7.9684E-06_JPRB,1.3651E-05_JPRB,1.1125E-04_JPRB/)
KAO( :, 3,10, 1) = (/&
&1.5289E-07_JPRB,9.7942E-07_JPRB,2.0846E-06_JPRB,3.0524E-06_JPRB,4.2640E-06_JPRB,5.9216E-06_JPRB,&
&8.6666E-06_JPRB,1.4411E-05_JPRB,1.3376E-04_JPRB/)
KAO( :, 4,10, 1) = (/&
&2.0094E-07_JPRB,1.0816E-06_JPRB,2.2331E-06_JPRB,3.8855E-06_JPRB,5.1239E-06_JPRB,6.8144E-06_JPRB,&
&9.5102E-06_JPRB,1.5396E-05_JPRB,1.5621E-04_JPRB/)
KAO( :, 5,10, 1) = (/&
&2.6711E-07_JPRB,1.2572E-06_JPRB,2.3283E-06_JPRB,3.9502E-06_JPRB,6.1703E-06_JPRB,8.4471E-06_JPRB,&
&1.1047E-05_JPRB,1.7057E-05_JPRB,1.7815E-04_JPRB/)
KAO( :, 1,11, 1) = (/&
&8.8479E-08_JPRB,6.5723E-07_JPRB,1.2585E-06_JPRB,2.0039E-06_JPRB,2.9121E-06_JPRB,4.1955E-06_JPRB,&
&6.2637E-06_JPRB,1.0419E-05_JPRB,1.7219E-04_JPRB/)
KAO( :, 2,11, 1) = (/&
&1.1103E-07_JPRB,7.9724E-07_JPRB,1.4388E-06_JPRB,2.1938E-06_JPRB,3.2099E-06_JPRB,4.5380E-06_JPRB,&
&6.5334E-06_JPRB,1.1529E-05_JPRB,2.1393E-04_JPRB/)
KAO( :, 3,11, 1) = (/&
&1.4325E-07_JPRB,8.5009E-07_JPRB,1.7790E-06_JPRB,2.5762E-06_JPRB,3.5853E-06_JPRB,4.9027E-06_JPRB,&
&7.2087E-06_JPRB,1.1783E-05_JPRB,2.5548E-04_JPRB/)
KAO( :, 4,11, 1) = (/&
&1.8796E-07_JPRB,9.4910E-07_JPRB,1.8794E-06_JPRB,3.2448E-06_JPRB,4.3096E-06_JPRB,5.7004E-06_JPRB,&
&7.8146E-06_JPRB,1.2759E-05_JPRB,2.9570E-04_JPRB/)
KAO( :, 5,11, 1) = (/&
&2.4830E-07_JPRB,1.0997E-06_JPRB,1.9987E-06_JPRB,3.2788E-06_JPRB,5.0983E-06_JPRB,7.0948E-06_JPRB,&
&9.2185E-06_JPRB,1.4157E-05_JPRB,3.3417E-04_JPRB/)
KAO( :, 1,12, 1) = (/&
&7.8411E-08_JPRB,5.6432E-07_JPRB,1.0564E-06_JPRB,1.6792E-06_JPRB,2.4262E-06_JPRB,3.3875E-06_JPRB,&
&5.1824E-06_JPRB,8.5930E-06_JPRB,2.1970E-04_JPRB/)
KAO( :, 2,12, 1) = (/&
&9.8958E-08_JPRB,6.8328E-07_JPRB,1.2215E-06_JPRB,1.8350E-06_JPRB,2.6716E-06_JPRB,3.7787E-06_JPRB,&
&5.3849E-06_JPRB,9.1860E-06_JPRB,2.7209E-04_JPRB/)
KAO( :, 3,12, 1) = (/&
&1.2797E-07_JPRB,7.2421E-07_JPRB,1.5209E-06_JPRB,2.1711E-06_JPRB,3.0040E-06_JPRB,4.0829E-06_JPRB,&
&6.0229E-06_JPRB,9.7068E-06_JPRB,3.2380E-04_JPRB/)
KAO( :, 4,12, 1) = (/&
&1.6772E-07_JPRB,8.1500E-07_JPRB,1.5843E-06_JPRB,2.7212E-06_JPRB,3.6141E-06_JPRB,4.7595E-06_JPRB,&
&6.4840E-06_JPRB,1.0629E-05_JPRB,3.7332E-04_JPRB/)
KAO( :, 5,12, 1) = (/&
&2.2081E-07_JPRB,9.4887E-07_JPRB,1.7061E-06_JPRB,2.7338E-06_JPRB,4.2409E-06_JPRB,5.9628E-06_JPRB,&
&7.7123E-06_JPRB,1.1668E-05_JPRB,4.2006E-04_JPRB/)
KAO( :, 1,13, 1) = (/&
&6.9984E-08_JPRB,4.8746E-07_JPRB,8.9934E-07_JPRB,1.4101E-06_JPRB,2.0188E-06_JPRB,2.7991E-06_JPRB,&
&4.1521E-06_JPRB,7.2727E-06_JPRB,2.2865E-04_JPRB/)
KAO( :, 2,13, 1) = (/&
&8.8821E-08_JPRB,5.8672E-07_JPRB,1.0421E-06_JPRB,1.5517E-06_JPRB,2.2340E-06_JPRB,3.1346E-06_JPRB,&
&4.4727E-06_JPRB,7.4604E-06_JPRB,2.8267E-04_JPRB/)
KAO( :, 3,13, 1) = (/&
&1.1504E-07_JPRB,6.2137E-07_JPRB,1.3015E-06_JPRB,1.8350E-06_JPRB,2.5305E-06_JPRB,3.4076E-06_JPRB,&
&4.9426E-06_JPRB,8.0265E-06_JPRB,3.3576E-04_JPRB/)
KAO( :, 4,13, 1) = (/&
&1.5036E-07_JPRB,7.0084E-07_JPRB,1.3483E-06_JPRB,2.2875E-06_JPRB,3.0337E-06_JPRB,3.9839E-06_JPRB,&
&5.4210E-06_JPRB,8.7755E-06_JPRB,3.8637E-04_JPRB/)
KAO( :, 5,13, 1) = (/&
&1.9712E-07_JPRB,8.1525E-07_JPRB,1.4451E-06_JPRB,2.3051E-06_JPRB,3.5032E-06_JPRB,5.0029E-06_JPRB,&
&6.4407E-06_JPRB,9.6564E-06_JPRB,4.3385E-04_JPRB/)
KAO( :, 1, 1, 2) = (/&
&3.7010E-06_JPRB,1.8091E-05_JPRB,2.8711E-05_JPRB,4.8863E-05_JPRB,7.2307E-05_JPRB,1.1413E-04_JPRB,&
&1.8771E-04_JPRB,3.6122E-04_JPRB,1.1281E-04_JPRB/)
KAO( :, 2, 1, 2) = (/&
&5.3266E-06_JPRB,2.4423E-05_JPRB,3.4269E-05_JPRB,4.7704E-05_JPRB,7.6078E-05_JPRB,1.1442E-04_JPRB,&
&1.6436E-04_JPRB,3.2838E-04_JPRB,8.7847E-05_JPRB/)
KAO( :, 3, 1, 2) = (/&
&7.5177E-06_JPRB,3.2854E-05_JPRB,4.4289E-05_JPRB,5.4913E-05_JPRB,7.2779E-05_JPRB,1.0814E-04_JPRB,&
&1.7906E-04_JPRB,2.8467E-04_JPRB,8.6883E-05_JPRB/)
KAO( :, 4, 1, 2) = (/&
&1.0391E-05_JPRB,4.3522E-05_JPRB,5.8544E-05_JPRB,6.9693E-05_JPRB,8.1288E-05_JPRB,1.0220E-04_JPRB,&
&1.5047E-04_JPRB,3.0285E-04_JPRB,9.1049E-05_JPRB/)
KAO( :, 5, 1, 2) = (/&
&1.4024E-05_JPRB,5.6758E-05_JPRB,7.6016E-05_JPRB,9.1662E-05_JPRB,1.0372E-04_JPRB,1.1700E-04_JPRB,&
&1.4991E-04_JPRB,2.3704E-04_JPRB,1.3000E-04_JPRB/)
KAO( :, 1, 2, 2) = (/&
&2.7903E-06_JPRB,1.3902E-05_JPRB,2.3771E-05_JPRB,3.9190E-05_JPRB,6.1137E-05_JPRB,9.7231E-05_JPRB,&
&1.5250E-04_JPRB,2.8746E-04_JPRB,7.5943E-05_JPRB/)
KAO( :, 2, 2, 2) = (/&
&4.0561E-06_JPRB,1.8720E-05_JPRB,2.7225E-05_JPRB,3.9741E-05_JPRB,6.4537E-05_JPRB,9.0899E-05_JPRB,&
&1.4609E-04_JPRB,2.7008E-04_JPRB,6.2612E-05_JPRB/)
KAO( :, 3, 2, 2) = (/&
&5.7887E-06_JPRB,2.5353E-05_JPRB,3.4446E-05_JPRB,4.3750E-05_JPRB,5.8352E-05_JPRB,9.7668E-05_JPRB,&
&1.4210E-04_JPRB,2.4211E-04_JPRB,6.1269E-05_JPRB/)
KAO( :, 4, 2, 2) = (/&
&8.0784E-06_JPRB,3.3950E-05_JPRB,4.5325E-05_JPRB,5.3921E-05_JPRB,6.4280E-05_JPRB,8.5665E-05_JPRB,&
&1.3688E-04_JPRB,2.4556E-04_JPRB,6.9568E-05_JPRB/)
KAO( :, 5, 2, 2) = (/&
&1.1019E-05_JPRB,4.4672E-05_JPRB,5.9575E-05_JPRB,7.1166E-05_JPRB,7.9595E-05_JPRB,9.1088E-05_JPRB,&
&1.2520E-04_JPRB,2.1802E-04_JPRB,9.5557E-05_JPRB/)
KAO( :, 1, 3, 2) = (/&
&1.9479E-06_JPRB,1.0095E-05_JPRB,1.9141E-05_JPRB,3.0705E-05_JPRB,5.2363E-05_JPRB,7.9991E-05_JPRB,&
&1.2823E-04_JPRB,2.3806E-04_JPRB,4.6992E-05_JPRB/)
KAO( :, 2, 3, 2) = (/&
&2.8509E-06_JPRB,1.3413E-05_JPRB,2.1137E-05_JPRB,3.4101E-05_JPRB,4.9706E-05_JPRB,7.8708E-05_JPRB,&
&1.2808E-04_JPRB,2.2769E-04_JPRB,4.2012E-05_JPRB/)
KAO( :, 3, 3, 2) = (/&
&4.1189E-06_JPRB,1.8265E-05_JPRB,2.5419E-05_JPRB,3.4683E-05_JPRB,5.2513E-05_JPRB,8.0240E-05_JPRB,&
&1.1481E-04_JPRB,2.1816E-04_JPRB,4.3174E-05_JPRB/)
KAO( :, 4, 3, 2) = (/&
&5.8233E-06_JPRB,2.4801E-05_JPRB,3.3200E-05_JPRB,4.0180E-05_JPRB,5.1786E-05_JPRB,7.2468E-05_JPRB,&
&1.2549E-04_JPRB,1.9856E-04_JPRB,5.6282E-05_JPRB/)
KAO( :, 5, 3, 2) = (/&
&8.0612E-06_JPRB,3.3094E-05_JPRB,4.4191E-05_JPRB,5.1801E-05_JPRB,5.9300E-05_JPRB,7.2075E-05_JPRB,&
&1.0386E-04_JPRB,2.0859E-04_JPRB,6.8039E-05_JPRB/)
KAO( :, 1, 4, 2) = (/&
&1.3432E-06_JPRB,7.4538E-06_JPRB,1.4964E-05_JPRB,2.5625E-05_JPRB,4.3243E-05_JPRB,6.6019E-05_JPRB,&
&1.0530E-04_JPRB,1.9952E-04_JPRB,3.1575E-05_JPRB/)
KAO( :, 2, 4, 2) = (/&
&1.9591E-06_JPRB,9.5155E-06_JPRB,1.6737E-05_JPRB,2.6791E-05_JPRB,4.2345E-05_JPRB,6.7439E-05_JPRB,&
&1.0271E-04_JPRB,1.8871E-04_JPRB,3.0704E-05_JPRB/)
KAO( :, 3, 4, 2) = (/&
&2.8537E-06_JPRB,1.2845E-05_JPRB,1.8934E-05_JPRB,2.8752E-05_JPRB,4.4199E-05_JPRB,6.2430E-05_JPRB,&
&1.0202E-04_JPRB,1.8062E-04_JPRB,3.4088E-05_JPRB/)
KAO( :, 4, 4, 2) = (/&
&4.0888E-06_JPRB,1.7612E-05_JPRB,2.3922E-05_JPRB,3.0749E-05_JPRB,4.2010E-05_JPRB,6.5728E-05_JPRB,&
&9.6566E-05_JPRB,1.7460E-04_JPRB,4.3387E-05_JPRB/)
KAO( :, 5, 4, 2) = (/&
&5.7388E-06_JPRB,2.3829E-05_JPRB,3.1758E-05_JPRB,3.7789E-05_JPRB,4.5312E-05_JPRB,5.9095E-05_JPRB,&
&1.0064E-04_JPRB,1.6850E-04_JPRB,5.1079E-05_JPRB/)
KAO( :, 1, 5, 2) = (/&
&9.4882E-07_JPRB,5.7155E-06_JPRB,1.1980E-05_JPRB,2.2295E-05_JPRB,3.5116E-05_JPRB,5.3339E-05_JPRB,&
&8.8729E-05_JPRB,1.5937E-04_JPRB,2.5456E-05_JPRB/)
KAO( :, 2, 5, 2) = (/&
&1.3669E-06_JPRB,6.8739E-06_JPRB,1.3459E-05_JPRB,2.1396E-05_JPRB,3.6297E-05_JPRB,5.4282E-05_JPRB,&
&8.6042E-05_JPRB,1.6025E-04_JPRB,2.6654E-05_JPRB/)
KAO( :, 3, 5, 2) = (/&
&1.9884E-06_JPRB,9.0859E-06_JPRB,1.4605E-05_JPRB,2.3671E-05_JPRB,3.4093E-05_JPRB,5.5324E-05_JPRB,&
&8.6463E-05_JPRB,1.5363E-04_JPRB,3.0684E-05_JPRB/)
KAO( :, 4, 5, 2) = (/&
&2.8701E-06_JPRB,1.2430E-05_JPRB,1.7294E-05_JPRB,2.4580E-05_JPRB,3.7203E-05_JPRB,5.3154E-05_JPRB,&
&8.1963E-05_JPRB,1.5281E-04_JPRB,3.6321E-05_JPRB/)
KAO( :, 5, 5, 2) = (/&
&4.0709E-06_JPRB,1.7029E-05_JPRB,2.2743E-05_JPRB,2.7902E-05_JPRB,3.6353E-05_JPRB,5.3115E-05_JPRB,&
&8.4864E-05_JPRB,1.3732E-04_JPRB,4.2547E-05_JPRB/)
KAO( :, 1, 6, 2) = (/&
&6.8988E-07_JPRB,4.4652E-06_JPRB,9.7580E-06_JPRB,1.7678E-05_JPRB,2.8332E-05_JPRB,4.4145E-05_JPRB,&
&7.0109E-05_JPRB,1.2493E-04_JPRB,2.3716E-05_JPRB/)
KAO( :, 2, 6, 2) = (/&
&9.7314E-07_JPRB,5.0974E-06_JPRB,1.0412E-05_JPRB,1.7485E-05_JPRB,2.9376E-05_JPRB,4.4804E-05_JPRB,&
&7.0122E-05_JPRB,1.3276E-04_JPRB,2.6375E-05_JPRB/)
KAO( :, 3, 6, 2) = (/&
&1.3972E-06_JPRB,6.4724E-06_JPRB,1.1564E-05_JPRB,1.8858E-05_JPRB,2.8568E-05_JPRB,4.7043E-05_JPRB,&
&7.0202E-05_JPRB,1.2748E-04_JPRB,3.0169E-05_JPRB/)
KAO( :, 4, 6, 2) = (/&
&2.0156E-06_JPRB,8.7063E-06_JPRB,1.3025E-05_JPRB,2.0355E-05_JPRB,3.0069E-05_JPRB,4.4240E-05_JPRB,&
&7.1336E-05_JPRB,1.2324E-04_JPRB,3.4994E-05_JPRB/)
KAO( :, 5, 6, 2) = (/&
&2.8756E-06_JPRB,1.1976E-05_JPRB,1.6242E-05_JPRB,2.1147E-05_JPRB,3.0629E-05_JPRB,4.5526E-05_JPRB,&
&6.5474E-05_JPRB,1.2130E-04_JPRB,4.0495E-05_JPRB/)
KAO( :, 1, 7, 2) = (/&
&5.2255E-07_JPRB,3.4411E-06_JPRB,7.7789E-06_JPRB,1.4395E-05_JPRB,2.2965E-05_JPRB,3.5662E-05_JPRB,&
&5.5652E-05_JPRB,9.9078E-05_JPRB,2.5677E-05_JPRB/)
KAO( :, 2, 7, 2) = (/&
&7.2172E-07_JPRB,4.0179E-06_JPRB,8.3376E-06_JPRB,1.4853E-05_JPRB,2.4331E-05_JPRB,3.6364E-05_JPRB,&
&5.7791E-05_JPRB,1.0563E-04_JPRB,2.9556E-05_JPRB/)
KAO( :, 3, 7, 2) = (/&
&1.0201E-06_JPRB,4.7217E-06_JPRB,9.3095E-06_JPRB,1.5083E-05_JPRB,2.5365E-05_JPRB,3.7347E-05_JPRB,&
&5.8190E-05_JPRB,1.0603E-04_JPRB,3.3998E-05_JPRB/)
KAO( :, 4, 7, 2) = (/&
&1.4537E-06_JPRB,6.1748E-06_JPRB,1.0020E-05_JPRB,1.6138E-05_JPRB,2.3962E-05_JPRB,3.7967E-05_JPRB,&
&5.8451E-05_JPRB,1.0372E-04_JPRB,3.9119E-05_JPRB/)
KAO( :, 5, 7, 2) = (/&
&2.0693E-06_JPRB,8.4363E-06_JPRB,1.1705E-05_JPRB,1.7001E-05_JPRB,2.5826E-05_JPRB,3.5527E-05_JPRB,&
&5.8296E-05_JPRB,1.0385E-04_JPRB,4.4936E-05_JPRB/)
KAO( :, 1, 8, 2) = (/&
&4.1700E-07_JPRB,2.7639E-06_JPRB,6.4938E-06_JPRB,1.1630E-05_JPRB,1.8371E-05_JPRB,2.7706E-05_JPRB,&
&4.4850E-05_JPRB,8.0696E-05_JPRB,3.5956E-05_JPRB/)
KAO( :, 2, 8, 2) = (/&
&5.6411E-07_JPRB,3.1556E-06_JPRB,6.9457E-06_JPRB,1.2120E-05_JPRB,1.9397E-05_JPRB,2.9581E-05_JPRB,&
&4.6513E-05_JPRB,8.4727E-05_JPRB,4.2511E-05_JPRB/)
KAO( :, 3, 8, 2) = (/&
&7.8647E-07_JPRB,3.6535E-06_JPRB,7.3255E-06_JPRB,1.2353E-05_JPRB,2.0079E-05_JPRB,3.0844E-05_JPRB,&
&4.7401E-05_JPRB,8.6525E-05_JPRB,4.9724E-05_JPRB/)
KAO( :, 4, 8, 2) = (/&
&1.1061E-06_JPRB,4.5424E-06_JPRB,7.9917E-06_JPRB,1.3185E-05_JPRB,1.9791E-05_JPRB,3.2038E-05_JPRB,&
&4.8054E-05_JPRB,8.5457E-05_JPRB,5.7233E-05_JPRB/)
KAO( :, 5, 8, 2) = (/&
&1.5569E-06_JPRB,6.0599E-06_JPRB,9.0209E-06_JPRB,1.3990E-05_JPRB,2.0815E-05_JPRB,3.0475E-05_JPRB,&
&4.9899E-05_JPRB,8.4659E-05_JPRB,6.5356E-05_JPRB/)
KAO( :, 1, 9, 2) = (/&
&3.4646E-07_JPRB,2.3339E-06_JPRB,5.2376E-06_JPRB,9.2182E-06_JPRB,1.4337E-05_JPRB,2.2490E-05_JPRB,&
&3.6396E-05_JPRB,6.1412E-05_JPRB,1.0490E-04_JPRB/)
KAO( :, 2, 9, 2) = (/&
&4.5919E-07_JPRB,2.4585E-06_JPRB,5.5676E-06_JPRB,9.8533E-06_JPRB,1.5559E-05_JPRB,2.3683E-05_JPRB,&
&3.6999E-05_JPRB,7.0677E-05_JPRB,1.2405E-04_JPRB/)
KAO( :, 3, 9, 2) = (/&
&6.2898E-07_JPRB,2.9262E-06_JPRB,5.8022E-06_JPRB,1.0344E-05_JPRB,1.6840E-05_JPRB,2.4691E-05_JPRB,&
&3.8818E-05_JPRB,7.0031E-05_JPRB,1.4290E-04_JPRB/)
KAO( :, 4, 9, 2) = (/&
&8.7625E-07_JPRB,3.4474E-06_JPRB,6.4904E-06_JPRB,1.0589E-05_JPRB,1.7378E-05_JPRB,2.5849E-05_JPRB,&
&3.9400E-05_JPRB,7.0716E-05_JPRB,1.6112E-04_JPRB/)
KAO( :, 5, 9, 2) = (/&
&1.2209E-06_JPRB,4.4922E-06_JPRB,7.0958E-06_JPRB,1.1298E-05_JPRB,1.6936E-05_JPRB,2.6020E-05_JPRB,&
&4.0325E-05_JPRB,7.2083E-05_JPRB,1.7893E-04_JPRB/)
KAO( :, 1,10, 2) = (/&
&3.1214E-07_JPRB,1.9536E-06_JPRB,4.2576E-06_JPRB,7.3396E-06_JPRB,1.1621E-05_JPRB,1.8021E-05_JPRB,&
&2.8013E-05_JPRB,4.7749E-05_JPRB,4.9962E-04_JPRB/)
KAO( :, 2,10, 2) = (/&
&4.0887E-07_JPRB,2.0598E-06_JPRB,4.7149E-06_JPRB,8.0606E-06_JPRB,1.2573E-05_JPRB,1.8809E-05_JPRB,&
&3.0275E-05_JPRB,5.6188E-05_JPRB,5.8548E-04_JPRB/)
KAO( :, 3,10, 2) = (/&
&5.5155E-07_JPRB,2.4175E-06_JPRB,4.9545E-06_JPRB,8.5941E-06_JPRB,1.3457E-05_JPRB,2.0204E-05_JPRB,&
&3.1138E-05_JPRB,5.6286E-05_JPRB,6.6291E-04_JPRB/)
KAO( :, 4,10, 2) = (/&
&7.5650E-07_JPRB,2.8298E-06_JPRB,5.3256E-06_JPRB,8.7402E-06_JPRB,1.3978E-05_JPRB,2.1601E-05_JPRB,&
&3.2082E-05_JPRB,5.7693E-05_JPRB,7.2972E-04_JPRB/)
KAO( :, 5,10, 2) = (/&
&1.0427E-06_JPRB,3.5400E-06_JPRB,5.8501E-06_JPRB,9.4137E-06_JPRB,1.4055E-05_JPRB,2.2092E-05_JPRB,&
&3.3371E-05_JPRB,5.7680E-05_JPRB,7.8611E-04_JPRB/)
KAO( :, 1,11, 2) = (/&
&3.2074E-07_JPRB,1.7276E-06_JPRB,3.6239E-06_JPRB,6.1854E-06_JPRB,9.6607E-06_JPRB,1.4993E-05_JPRB,&
&2.3443E-05_JPRB,4.1061E-05_JPRB,1.0142E-03_JPRB/)
KAO( :, 2,11, 2) = (/&
&4.2113E-07_JPRB,1.8116E-06_JPRB,4.1199E-06_JPRB,6.7716E-06_JPRB,1.0543E-05_JPRB,1.5526E-05_JPRB,&
&2.4849E-05_JPRB,4.5454E-05_JPRB,1.1742E-03_JPRB/)
KAO( :, 3,11, 2) = (/&
&5.6514E-07_JPRB,2.1552E-06_JPRB,4.2148E-06_JPRB,7.3585E-06_JPRB,1.1239E-05_JPRB,1.6846E-05_JPRB,&
&2.5655E-05_JPRB,4.5531E-05_JPRB,1.3139E-03_JPRB/)
KAO( :, 4,11, 2) = (/&
&7.6814E-07_JPRB,2.5322E-06_JPRB,4.6852E-06_JPRB,7.3538E-06_JPRB,1.1830E-05_JPRB,1.8155E-05_JPRB,&
&2.6824E-05_JPRB,4.7139E-05_JPRB,1.4305E-03_JPRB/)
KAO( :, 5,11, 2) = (/&
&1.0464E-06_JPRB,3.2313E-06_JPRB,5.0889E-06_JPRB,8.1260E-06_JPRB,1.1741E-05_JPRB,1.8567E-05_JPRB,&
&2.7673E-05_JPRB,4.7684E-05_JPRB,1.5261E-03_JPRB/)
KAO( :, 1,12, 2) = (/&
&3.0483E-07_JPRB,1.4986E-06_JPRB,3.1036E-06_JPRB,5.2551E-06_JPRB,7.9883E-06_JPRB,1.2411E-05_JPRB,&
&1.9208E-05_JPRB,3.3894E-05_JPRB,1.3243E-03_JPRB/)
KAO( :, 2,12, 2) = (/&
&4.0026E-07_JPRB,1.5746E-06_JPRB,3.5034E-06_JPRB,5.7409E-06_JPRB,8.9248E-06_JPRB,1.2928E-05_JPRB,&
&2.0014E-05_JPRB,3.7406E-05_JPRB,1.5202E-03_JPRB/)
KAO( :, 3,12, 2) = (/&
&5.3553E-07_JPRB,1.8879E-06_JPRB,3.5598E-06_JPRB,6.2204E-06_JPRB,9.4506E-06_JPRB,1.4131E-05_JPRB,&
&2.1193E-05_JPRB,3.7290E-05_JPRB,1.6892E-03_JPRB/)
KAO( :, 4,12, 2) = (/&
&7.2441E-07_JPRB,2.2261E-06_JPRB,4.0611E-06_JPRB,6.2008E-06_JPRB,9.9865E-06_JPRB,1.4941E-05_JPRB,&
&2.2423E-05_JPRB,3.8766E-05_JPRB,1.8301E-03_JPRB/)
KAO( :, 5,12, 2) = (/&
&9.8233E-07_JPRB,2.8782E-06_JPRB,4.3585E-06_JPRB,6.9707E-06_JPRB,9.7990E-06_JPRB,1.5463E-05_JPRB,&
&2.2949E-05_JPRB,3.9658E-05_JPRB,1.9441E-03_JPRB/)
KAO( :, 1,13, 2) = (/&
&2.9003E-07_JPRB,1.3003E-06_JPRB,2.6851E-06_JPRB,4.4901E-06_JPRB,6.6847E-06_JPRB,1.0336E-05_JPRB,&
&1.6084E-05_JPRB,2.8206E-05_JPRB,1.3971E-03_JPRB/)
KAO( :, 2,13, 2) = (/&
&3.7990E-07_JPRB,1.3887E-06_JPRB,2.9888E-06_JPRB,4.8895E-06_JPRB,7.4887E-06_JPRB,1.0848E-05_JPRB,&
&1.6497E-05_JPRB,3.0927E-05_JPRB,1.5951E-03_JPRB/)
KAO( :, 3,13, 2) = (/&
&5.0572E-07_JPRB,1.6533E-06_JPRB,3.0166E-06_JPRB,5.2825E-06_JPRB,8.0084E-06_JPRB,1.1877E-05_JPRB,&
&1.7766E-05_JPRB,3.0474E-05_JPRB,1.7653E-03_JPRB/)
KAO( :, 4,13, 2) = (/&
&6.7947E-07_JPRB,1.9700E-06_JPRB,3.4410E-06_JPRB,5.2325E-06_JPRB,8.4395E-06_JPRB,1.2460E-05_JPRB,&
&1.8625E-05_JPRB,3.2158E-05_JPRB,1.9067E-03_JPRB/)
KAO( :, 5,13, 2) = (/&
&9.1576E-07_JPRB,2.5777E-06_JPRB,3.7459E-06_JPRB,5.9026E-06_JPRB,8.2962E-06_JPRB,1.2772E-05_JPRB,&
&1.8972E-05_JPRB,3.2948E-05_JPRB,2.0202E-03_JPRB/)
KAO( :, 1, 1, 3) = (/&
&1.2955E-05_JPRB,5.0522E-05_JPRB,7.1945E-05_JPRB,8.6154E-05_JPRB,1.0208E-04_JPRB,1.2598E-04_JPRB,&
&1.9123E-04_JPRB,3.6418E-04_JPRB,1.3186E-04_JPRB/)
KAO( :, 2, 1, 3) = (/&
&1.9287E-05_JPRB,7.0010E-05_JPRB,9.9593E-05_JPRB,1.2286E-04_JPRB,1.3525E-04_JPRB,1.5548E-04_JPRB,&
&2.0918E-04_JPRB,3.4739E-04_JPRB,1.7322E-04_JPRB/)
KAO( :, 3, 1, 3) = (/&
&2.7759E-05_JPRB,9.4510E-05_JPRB,1.3259E-04_JPRB,1.6366E-04_JPRB,1.8879E-04_JPRB,2.0943E-04_JPRB,&
&2.3157E-04_JPRB,3.4811E-04_JPRB,1.6150E-04_JPRB/)
KAO( :, 4, 1, 3) = (/&
&3.8738E-05_JPRB,1.2422E-04_JPRB,1.7221E-04_JPRB,2.0992E-04_JPRB,2.4272E-04_JPRB,2.7453E-04_JPRB,&
&3.1488E-04_JPRB,3.8180E-04_JPRB,1.6247E-04_JPRB/)
KAO( :, 5, 1, 3) = (/&
&5.2551E-05_JPRB,1.5948E-04_JPRB,2.1800E-04_JPRB,2.6091E-04_JPRB,2.8985E-04_JPRB,3.1670E-04_JPRB,&
&3.5730E-04_JPRB,5.0275E-04_JPRB,1.6769E-04_JPRB/)
KAO( :, 1, 2, 3) = (/&
&1.0215E-05_JPRB,3.8380E-05_JPRB,5.3048E-05_JPRB,6.6381E-05_JPRB,7.9446E-05_JPRB,1.0242E-04_JPRB,&
&1.6771E-04_JPRB,3.2794E-04_JPRB,9.6316E-05_JPRB/)
KAO( :, 2, 2, 3) = (/&
&1.5451E-05_JPRB,5.4104E-05_JPRB,7.5600E-05_JPRB,9.3324E-05_JPRB,1.0289E-04_JPRB,1.2339E-04_JPRB,&
&1.5508E-04_JPRB,2.9561E-04_JPRB,1.1950E-04_JPRB/)
KAO( :, 3, 2, 3) = (/&
&2.2597E-05_JPRB,7.3963E-05_JPRB,1.0253E-04_JPRB,1.2549E-04_JPRB,1.4695E-04_JPRB,1.5501E-04_JPRB,&
&1.8766E-04_JPRB,2.7580E-04_JPRB,1.1963E-04_JPRB/)
KAO( :, 4, 2, 3) = (/&
&3.1981E-05_JPRB,9.8266E-05_JPRB,1.3455E-04_JPRB,1.6363E-04_JPRB,1.9057E-04_JPRB,2.1405E-04_JPRB,&
&2.4009E-04_JPRB,3.0871E-04_JPRB,1.1944E-04_JPRB/)
KAO( :, 5, 2, 3) = (/&
&4.3949E-05_JPRB,1.2724E-04_JPRB,1.7210E-04_JPRB,2.0576E-04_JPRB,2.2967E-04_JPRB,2.5641E-04_JPRB,&
&2.9387E-04_JPRB,3.8545E-04_JPRB,1.2834E-04_JPRB/)
KAO( :, 1, 3, 3) = (/&
&7.2365E-06_JPRB,2.6998E-05_JPRB,3.6477E-05_JPRB,4.7217E-05_JPRB,5.6642E-05_JPRB,8.7936E-05_JPRB,&
&1.4529E-04_JPRB,2.7769E-04_JPRB,6.9628E-05_JPRB/)
KAO( :, 2, 3, 3) = (/&
&1.1199E-05_JPRB,3.9041E-05_JPRB,5.3564E-05_JPRB,6.4272E-05_JPRB,7.6774E-05_JPRB,9.0855E-05_JPRB,&
&1.2382E-04_JPRB,2.6260E-04_JPRB,7.7539E-05_JPRB/)
KAO( :, 3, 3, 3) = (/&
&1.6746E-05_JPRB,5.4459E-05_JPRB,7.4537E-05_JPRB,8.9917E-05_JPRB,1.0355E-04_JPRB,1.1572E-04_JPRB,&
&1.4649E-04_JPRB,2.2179E-04_JPRB,7.9988E-05_JPRB/)
KAO( :, 4, 3, 3) = (/&
&2.4191E-05_JPRB,7.3480E-05_JPRB,9.9615E-05_JPRB,1.2140E-04_JPRB,1.3959E-04_JPRB,1.5714E-04_JPRB,&
&1.6549E-04_JPRB,2.4024E-04_JPRB,8.5666E-05_JPRB/)
KAO( :, 5, 3, 3) = (/&
&3.3870E-05_JPRB,9.6615E-05_JPRB,1.2939E-04_JPRB,1.5483E-04_JPRB,1.7605E-04_JPRB,2.0033E-04_JPRB,&
&2.2747E-04_JPRB,2.7100E-04_JPRB,9.7295E-05_JPRB/)
KAO( :, 1, 4, 3) = (/&
&4.9164E-06_JPRB,1.8370E-05_JPRB,2.4721E-05_JPRB,3.3121E-05_JPRB,4.7620E-05_JPRB,7.5266E-05_JPRB,&
&1.2052E-04_JPRB,2.1534E-04_JPRB,5.2534E-05_JPRB/)
KAO( :, 2, 4, 3) = (/&
&7.7659E-06_JPRB,2.7326E-05_JPRB,3.6365E-05_JPRB,4.5331E-05_JPRB,5.4377E-05_JPRB,7.0048E-05_JPRB,&
&1.1606E-04_JPRB,2.2356E-04_JPRB,5.6606E-05_JPRB/)
KAO( :, 3, 4, 3) = (/&
&1.1872E-05_JPRB,3.9091E-05_JPRB,5.2753E-05_JPRB,6.2810E-05_JPRB,7.2334E-05_JPRB,8.5510E-05_JPRB,&
&1.0655E-04_JPRB,2.0132E-04_JPRB,6.1013E-05_JPRB/)
KAO( :, 4, 4, 3) = (/&
&1.7537E-05_JPRB,5.3794E-05_JPRB,7.2225E-05_JPRB,8.6566E-05_JPRB,1.0009E-04_JPRB,1.0905E-04_JPRB,&
&1.2927E-04_JPRB,1.7979E-04_JPRB,6.7247E-05_JPRB/)
KAO( :, 5, 4, 3) = (/&
&2.5077E-05_JPRB,7.1949E-05_JPRB,9.5586E-05_JPRB,1.1422E-04_JPRB,1.3046E-04_JPRB,1.4874E-04_JPRB,&
&1.6151E-04_JPRB,2.1004E-04_JPRB,7.8070E-05_JPRB/)
KAO( :, 1, 5, 3) = (/&
&3.3274E-06_JPRB,1.2413E-05_JPRB,1.6893E-05_JPRB,2.5297E-05_JPRB,3.9702E-05_JPRB,6.2471E-05_JPRB,&
&9.4799E-05_JPRB,1.7379E-04_JPRB,4.3352E-05_JPRB/)
KAO( :, 2, 5, 3) = (/&
&5.3144E-06_JPRB,1.8924E-05_JPRB,2.4595E-05_JPRB,3.1378E-05_JPRB,3.9382E-05_JPRB,6.2226E-05_JPRB,&
&9.6051E-05_JPRB,1.8141E-04_JPRB,4.9071E-05_JPRB/)
KAO( :, 3, 5, 3) = (/&
&8.2729E-06_JPRB,2.7735E-05_JPRB,3.6853E-05_JPRB,4.3473E-05_JPRB,5.3077E-05_JPRB,6.0111E-05_JPRB,&
&8.8205E-05_JPRB,1.7170E-04_JPRB,5.3581E-05_JPRB/)
KAO( :, 4, 5, 3) = (/&
&1.2483E-05_JPRB,3.8936E-05_JPRB,5.1944E-05_JPRB,6.0771E-05_JPRB,7.0416E-05_JPRB,8.1406E-05_JPRB,&
&9.7912E-05_JPRB,1.4624E-04_JPRB,6.0502E-05_JPRB/)
KAO( :, 5, 5, 3) = (/&
&1.8234E-05_JPRB,5.2997E-05_JPRB,7.0214E-05_JPRB,8.3889E-05_JPRB,9.4583E-05_JPRB,1.0646E-04_JPRB,&
&1.1645E-04_JPRB,1.6664E-04_JPRB,6.9524E-05_JPRB/)
KAO( :, 1, 6, 3) = (/&
&2.2627E-06_JPRB,8.2256E-06_JPRB,1.2662E-05_JPRB,2.0881E-05_JPRB,3.2287E-05_JPRB,4.9842E-05_JPRB,&
&7.8514E-05_JPRB,1.5143E-04_JPRB,4.2185E-05_JPRB/)
KAO( :, 2, 6, 3) = (/&
&3.5902E-06_JPRB,1.2715E-05_JPRB,1.6777E-05_JPRB,2.2883E-05_JPRB,3.3890E-05_JPRB,5.0807E-05_JPRB,&
&8.0753E-05_JPRB,1.4463E-04_JPRB,4.8590E-05_JPRB/)
KAO( :, 3, 6, 3) = (/&
&5.6436E-06_JPRB,1.9109E-05_JPRB,2.4998E-05_JPRB,3.0305E-05_JPRB,3.7831E-05_JPRB,4.7255E-05_JPRB,&
&7.8945E-05_JPRB,1.4406E-04_JPRB,5.5296E-05_JPRB/)
KAO( :, 4, 6, 3) = (/&
&8.6680E-06_JPRB,2.7468E-05_JPRB,3.6416E-05_JPRB,4.2070E-05_JPRB,4.9055E-05_JPRB,5.8245E-05_JPRB,&
&7.2889E-05_JPRB,1.3759E-04_JPRB,6.2699E-05_JPRB/)
KAO( :, 5, 6, 3) = (/&
&1.2910E-05_JPRB,3.8070E-05_JPRB,5.0552E-05_JPRB,5.9531E-05_JPRB,6.5990E-05_JPRB,7.5485E-05_JPRB,&
&9.0151E-05_JPRB,1.2519E-04_JPRB,7.1158E-05_JPRB/)
KAO( :, 1, 7, 3) = (/&
&1.6260E-06_JPRB,5.6512E-06_JPRB,1.0534E-05_JPRB,1.6548E-05_JPRB,2.5722E-05_JPRB,3.9212E-05_JPRB,&
&6.5255E-05_JPRB,1.1642E-04_JPRB,4.8396E-05_JPRB/)
KAO( :, 2, 7, 3) = (/&
&2.4977E-06_JPRB,8.5111E-06_JPRB,1.1552E-05_JPRB,1.8620E-05_JPRB,2.6964E-05_JPRB,4.1086E-05_JPRB,&
&6.5326E-05_JPRB,1.2038E-04_JPRB,5.6755E-05_JPRB/)
KAO( :, 3, 7, 3) = (/&
&3.8937E-06_JPRB,1.3083E-05_JPRB,1.6837E-05_JPRB,2.1037E-05_JPRB,2.8103E-05_JPRB,4.1971E-05_JPRB,&
&6.4916E-05_JPRB,1.2035E-04_JPRB,6.5643E-05_JPRB/)
KAO( :, 4, 7, 3) = (/&
&6.0131E-06_JPRB,1.9182E-05_JPRB,2.5262E-05_JPRB,2.9578E-05_JPRB,3.5380E-05_JPRB,4.1824E-05_JPRB,&
&6.4389E-05_JPRB,1.1625E-04_JPRB,7.5112E-05_JPRB/)
KAO( :, 5, 7, 3) = (/&
&9.0775E-06_JPRB,2.7049E-05_JPRB,3.5910E-05_JPRB,4.1673E-05_JPRB,4.7430E-05_JPRB,5.6675E-05_JPRB,&
&6.4662E-05_JPRB,1.0376E-04_JPRB,8.5479E-05_JPRB/)
KAO( :, 1, 8, 3) = (/&
&1.2762E-06_JPRB,4.2855E-06_JPRB,8.2820E-06_JPRB,1.3051E-05_JPRB,1.9907E-05_JPRB,3.3971E-05_JPRB,&
&5.0446E-05_JPRB,8.6971E-05_JPRB,7.7745E-05_JPRB/)
KAO( :, 2, 8, 3) = (/&
&1.8844E-06_JPRB,5.9050E-06_JPRB,8.9489E-06_JPRB,1.4806E-05_JPRB,2.1839E-05_JPRB,3.2608E-05_JPRB,&
&5.2540E-05_JPRB,9.7610E-05_JPRB,8.9498E-05_JPRB/)
KAO( :, 3, 8, 3) = (/&
&2.8385E-06_JPRB,8.9737E-06_JPRB,1.1895E-05_JPRB,1.5870E-05_JPRB,2.4156E-05_JPRB,3.3906E-05_JPRB,&
&5.3605E-05_JPRB,9.6849E-05_JPRB,1.0287E-04_JPRB/)
KAO( :, 4, 8, 3) = (/&
&4.3106E-06_JPRB,1.3404E-05_JPRB,1.7498E-05_JPRB,2.1009E-05_JPRB,2.6036E-05_JPRB,3.4758E-05_JPRB,&
&5.4115E-05_JPRB,9.7671E-05_JPRB,1.1774E-04_JPRB/)
KAO( :, 5, 8, 3) = (/&
&6.4933E-06_JPRB,1.9198E-05_JPRB,2.5108E-05_JPRB,2.9532E-05_JPRB,3.3547E-05_JPRB,4.0870E-05_JPRB,&
&5.0672E-05_JPRB,9.4048E-05_JPRB,1.3326E-04_JPRB/)
KAO( :, 1, 9, 3) = (/&
&1.0706E-06_JPRB,3.3489E-06_JPRB,6.5283E-06_JPRB,1.0192E-05_JPRB,1.7278E-05_JPRB,2.6238E-05_JPRB,&
&3.9041E-05_JPRB,7.0346E-05_JPRB,2.7103E-04_JPRB/)
KAO( :, 2, 9, 3) = (/&
&1.5238E-06_JPRB,4.4647E-06_JPRB,7.4896E-06_JPRB,1.1805E-05_JPRB,1.7404E-05_JPRB,2.6241E-05_JPRB,&
&4.5076E-05_JPRB,7.3357E-05_JPRB,3.0478E-04_JPRB/)
KAO( :, 3, 9, 3) = (/&
&2.2245E-06_JPRB,6.3482E-06_JPRB,8.7814E-06_JPRB,1.3182E-05_JPRB,1.8649E-05_JPRB,2.8139E-05_JPRB,&
&4.2432E-05_JPRB,8.1918E-05_JPRB,3.3943E-04_JPRB/)
KAO( :, 4, 9, 3) = (/&
&3.2853E-06_JPRB,9.5377E-06_JPRB,1.2081E-05_JPRB,1.5048E-05_JPRB,2.0438E-05_JPRB,2.9250E-05_JPRB,&
&4.4492E-05_JPRB,8.0054E-05_JPRB,3.7569E-04_JPRB/)
KAO( :, 5, 9, 3) = (/&
&4.8340E-06_JPRB,1.3704E-05_JPRB,1.7727E-05_JPRB,2.0846E-05_JPRB,2.4389E-05_JPRB,3.0169E-05_JPRB,&
&4.5558E-05_JPRB,7.6780E-05_JPRB,4.1363E-04_JPRB/)
KAO( :, 1,10, 3) = (/&
&1.0087E-06_JPRB,2.8522E-06_JPRB,5.3847E-06_JPRB,8.7589E-06_JPRB,1.3656E-05_JPRB,2.0793E-05_JPRB,&
&3.0265E-05_JPRB,5.6466E-05_JPRB,1.4467E-03_JPRB/)
KAO( :, 2,10, 3) = (/&
&1.3893E-06_JPRB,3.6572E-06_JPRB,6.0381E-06_JPRB,9.5656E-06_JPRB,1.3744E-05_JPRB,2.2378E-05_JPRB,&
&3.6073E-05_JPRB,5.8999E-05_JPRB,1.6134E-03_JPRB/)
KAO( :, 3,10, 3) = (/&
&1.9601E-06_JPRB,4.9746E-06_JPRB,7.1675E-06_JPRB,1.0782E-05_JPRB,1.5548E-05_JPRB,2.2425E-05_JPRB,&
&3.4813E-05_JPRB,6.8188E-05_JPRB,1.7742E-03_JPRB/)
KAO( :, 4,10, 3) = (/&
&2.8046E-06_JPRB,7.3061E-06_JPRB,9.2760E-06_JPRB,1.2016E-05_JPRB,1.7674E-05_JPRB,2.3526E-05_JPRB,&
&3.6626E-05_JPRB,6.3451E-05_JPRB,1.9257E-03_JPRB/)
KAO( :, 5,10, 3) = (/&
&4.0204E-06_JPRB,1.0448E-05_JPRB,1.3168E-05_JPRB,1.5711E-05_JPRB,1.8780E-05_JPRB,2.5290E-05_JPRB,&
&3.7179E-05_JPRB,6.5468E-05_JPRB,2.0654E-03_JPRB/)
KAO( :, 1,11, 3) = (/&
&1.1167E-06_JPRB,2.7196E-06_JPRB,4.8414E-06_JPRB,7.5750E-06_JPRB,1.1619E-05_JPRB,1.6844E-05_JPRB,&
&2.5920E-05_JPRB,4.2497E-05_JPRB,3.0648E-03_JPRB/)
KAO( :, 2,11, 3) = (/&
&1.5177E-06_JPRB,3.5342E-06_JPRB,5.4336E-06_JPRB,8.4346E-06_JPRB,1.1729E-05_JPRB,1.8362E-05_JPRB,&
&2.9194E-05_JPRB,5.0129E-05_JPRB,3.3976E-03_JPRB/)
KAO( :, 3,11, 3) = (/&
&2.0984E-06_JPRB,4.8006E-06_JPRB,6.5451E-06_JPRB,9.5029E-06_JPRB,1.3465E-05_JPRB,1.9020E-05_JPRB,&
&2.8692E-05_JPRB,5.7928E-05_JPRB,3.7050E-03_JPRB/)
KAO( :, 4,11, 3) = (/&
&2.9335E-06_JPRB,6.8708E-06_JPRB,8.4101E-06_JPRB,1.0863E-05_JPRB,1.4762E-05_JPRB,2.0091E-05_JPRB,&
&3.0371E-05_JPRB,5.2028E-05_JPRB,3.9809E-03_JPRB/)
KAO( :, 5,11, 3) = (/&
&4.1000E-06_JPRB,9.6543E-06_JPRB,1.1857E-05_JPRB,1.3714E-05_JPRB,1.6526E-05_JPRB,2.1427E-05_JPRB,&
&3.1464E-05_JPRB,5.4245E-05_JPRB,4.2143E-03_JPRB/)
KAO( :, 1,12, 3) = (/&
&1.1265E-06_JPRB,2.5186E-06_JPRB,4.3674E-06_JPRB,6.5192E-06_JPRB,9.8193E-06_JPRB,1.4195E-05_JPRB,&
&2.1669E-05_JPRB,3.5591E-05_JPRB,4.1354E-03_JPRB/)
KAO( :, 2,12, 3) = (/&
&1.5273E-06_JPRB,3.2471E-06_JPRB,4.8453E-06_JPRB,7.4929E-06_JPRB,9.9333E-06_JPRB,1.5224E-05_JPRB,&
&2.4490E-05_JPRB,4.2520E-05_JPRB,4.5631E-03_JPRB/)
KAO( :, 3,12, 3) = (/&
&2.0931E-06_JPRB,4.4632E-06_JPRB,5.8990E-06_JPRB,8.1723E-06_JPRB,1.1637E-05_JPRB,1.5989E-05_JPRB,&
&2.3803E-05_JPRB,4.4958E-05_JPRB,4.9406E-03_JPRB/)
KAO( :, 4,12, 3) = (/&
&2.8927E-06_JPRB,6.3250E-06_JPRB,7.6186E-06_JPRB,9.4669E-06_JPRB,1.2563E-05_JPRB,1.7445E-05_JPRB,&
&2.5222E-05_JPRB,4.2668E-05_JPRB,5.2603E-03_JPRB/)
KAO( :, 5,12, 3) = (/&
&3.9848E-06_JPRB,8.7921E-06_JPRB,1.0605E-05_JPRB,1.2004E-05_JPRB,1.4341E-05_JPRB,1.8049E-05_JPRB,&
&2.6521E-05_JPRB,4.4754E-05_JPRB,5.5165E-03_JPRB/)
KAO( :, 1,13, 3) = (/&
&1.1328E-06_JPRB,2.3238E-06_JPRB,3.9430E-06_JPRB,5.6932E-06_JPRB,8.4038E-06_JPRB,1.1800E-05_JPRB,&
&1.7829E-05_JPRB,3.0820E-05_JPRB,4.4819E-03_JPRB/)
KAO( :, 2,13, 3) = (/&
&1.5311E-06_JPRB,3.0098E-06_JPRB,4.3521E-06_JPRB,6.6679E-06_JPRB,8.7081E-06_JPRB,1.2897E-05_JPRB,&
&1.9883E-05_JPRB,3.4493E-05_JPRB,4.9164E-03_JPRB/)
KAO( :, 3,13, 3) = (/&
&2.0853E-06_JPRB,4.1223E-06_JPRB,5.4114E-06_JPRB,7.2554E-06_JPRB,1.0229E-05_JPRB,1.3641E-05_JPRB,&
&1.9729E-05_JPRB,3.6438E-05_JPRB,5.2852E-03_JPRB/)
KAO( :, 4,13, 3) = (/&
&2.8506E-06_JPRB,5.8568E-06_JPRB,6.9938E-06_JPRB,8.4840E-06_JPRB,1.0942E-05_JPRB,1.5066E-05_JPRB,&
&2.1270E-05_JPRB,3.5313E-05_JPRB,5.5871E-03_JPRB/)
KAO( :, 5,13, 3) = (/&
&3.8711E-06_JPRB,8.0712E-06_JPRB,9.6159E-06_JPRB,1.0719E-05_JPRB,1.2561E-05_JPRB,1.5293E-05_JPRB,&
&2.2681E-05_JPRB,3.7058E-05_JPRB,5.8266E-03_JPRB/)
KAO( :, 1, 1, 4) = (/&
&7.4893E-05_JPRB,1.7660E-04_JPRB,2.0743E-04_JPRB,2.2345E-04_JPRB,2.5541E-04_JPRB,3.0113E-04_JPRB,&
&4.0065E-04_JPRB,5.1140E-04_JPRB,1.9420E-04_JPRB/)
KAO( :, 2, 1, 4) = (/&
&1.0396E-04_JPRB,2.3012E-04_JPRB,2.6622E-04_JPRB,2.8243E-04_JPRB,2.9424E-04_JPRB,3.3000E-04_JPRB,&
&4.1387E-04_JPRB,6.5618E-04_JPRB,1.7248E-04_JPRB/)
KAO( :, 3, 1, 4) = (/&
&1.3874E-04_JPRB,2.9171E-04_JPRB,3.3413E-04_JPRB,3.5198E-04_JPRB,3.5734E-04_JPRB,3.6401E-04_JPRB,&
&4.2489E-04_JPRB,6.4403E-04_JPRB,1.9641E-04_JPRB/)
KAO( :, 4, 1, 4) = (/&
&1.7941E-04_JPRB,3.6434E-04_JPRB,4.1317E-04_JPRB,4.3271E-04_JPRB,4.3728E-04_JPRB,4.3279E-04_JPRB,&
&4.4184E-04_JPRB,6.1293E-04_JPRB,2.4660E-04_JPRB/)
KAO( :, 5, 1, 4) = (/&
&2.2524E-04_JPRB,4.4700E-04_JPRB,5.0389E-04_JPRB,5.2899E-04_JPRB,5.4228E-04_JPRB,5.4473E-04_JPRB,&
&5.3368E-04_JPRB,5.6423E-04_JPRB,3.1492E-04_JPRB/)
KAO( :, 1, 2, 4) = (/&
&5.8910E-05_JPRB,1.3730E-04_JPRB,1.6111E-04_JPRB,1.7338E-04_JPRB,1.9974E-04_JPRB,2.3614E-04_JPRB,&
&3.1448E-04_JPRB,3.8866E-04_JPRB,1.4405E-04_JPRB/)
KAO( :, 2, 2, 4) = (/&
&8.3036E-05_JPRB,1.8135E-04_JPRB,2.0964E-04_JPRB,2.2070E-04_JPRB,2.3158E-04_JPRB,2.7057E-04_JPRB,&
&3.3372E-04_JPRB,5.4726E-04_JPRB,1.2817E-04_JPRB/)
KAO( :, 3, 2, 4) = (/&
&1.1213E-04_JPRB,2.3284E-04_JPRB,2.6662E-04_JPRB,2.8050E-04_JPRB,2.8374E-04_JPRB,2.9072E-04_JPRB,&
&3.5956E-04_JPRB,5.3062E-04_JPRB,1.4567E-04_JPRB/)
KAO( :, 4, 2, 4) = (/&
&1.4639E-04_JPRB,2.9331E-04_JPRB,3.3229E-04_JPRB,3.4773E-04_JPRB,3.4771E-04_JPRB,3.4598E-04_JPRB,&
&3.5609E-04_JPRB,5.3796E-04_JPRB,1.8917E-04_JPRB/)
KAO( :, 5, 2, 4) = (/&
&1.8573E-04_JPRB,3.6333E-04_JPRB,4.0899E-04_JPRB,4.2805E-04_JPRB,4.3596E-04_JPRB,4.3023E-04_JPRB,&
&4.2036E-04_JPRB,4.7310E-04_JPRB,2.4106E-04_JPRB/)
KAO( :, 1, 3, 4) = (/&
&4.2697E-05_JPRB,9.9737E-05_JPRB,1.1762E-04_JPRB,1.3175E-04_JPRB,1.5206E-04_JPRB,1.7738E-04_JPRB,&
&2.2461E-04_JPRB,3.0012E-04_JPRB,9.0760E-05_JPRB/)
KAO( :, 2, 3, 4) = (/&
&6.1628E-05_JPRB,1.3453E-04_JPRB,1.5553E-04_JPRB,1.6395E-04_JPRB,1.7863E-04_JPRB,2.1026E-04_JPRB,&
&2.6559E-04_JPRB,4.0665E-04_JPRB,9.5213E-05_JPRB/)
KAO( :, 3, 3, 4) = (/&
&8.5155E-05_JPRB,1.7580E-04_JPRB,2.0156E-04_JPRB,2.1203E-04_JPRB,2.1267E-04_JPRB,2.2935E-04_JPRB,&
&2.8279E-04_JPRB,4.3028E-04_JPRB,1.1265E-04_JPRB/)
KAO( :, 4, 3, 4) = (/&
&1.1317E-04_JPRB,2.2386E-04_JPRB,2.5438E-04_JPRB,2.6544E-04_JPRB,2.6602E-04_JPRB,2.6653E-04_JPRB,&
&2.9745E-04_JPRB,4.2745E-04_JPRB,1.4173E-04_JPRB/)
KAO( :, 5, 3, 4) = (/&
&1.4597E-04_JPRB,2.8045E-04_JPRB,3.1649E-04_JPRB,3.3077E-04_JPRB,3.3240E-04_JPRB,3.2175E-04_JPRB,&
&3.2192E-04_JPRB,4.1153E-04_JPRB,1.7765E-04_JPRB/)
KAO( :, 1, 4, 4) = (/&
&2.9896E-05_JPRB,7.0709E-05_JPRB,8.4360E-05_JPRB,9.7466E-05_JPRB,1.0874E-04_JPRB,1.3074E-04_JPRB,&
&1.6227E-04_JPRB,2.5464E-04_JPRB,6.8134E-05_JPRB/)
KAO( :, 2, 4, 4) = (/&
&4.4341E-05_JPRB,9.6962E-05_JPRB,1.1247E-04_JPRB,1.1929E-04_JPRB,1.3785E-04_JPRB,1.5834E-04_JPRB,&
&2.0071E-04_JPRB,2.9189E-04_JPRB,7.8206E-05_JPRB/)
KAO( :, 3, 4, 4) = (/&
&6.2914E-05_JPRB,1.2902E-04_JPRB,1.4817E-04_JPRB,1.5527E-04_JPRB,1.5849E-04_JPRB,1.8569E-04_JPRB,&
&2.2497E-04_JPRB,3.4124E-04_JPRB,9.0845E-05_JPRB/)
KAO( :, 4, 4, 4) = (/&
&8.5677E-05_JPRB,1.6689E-04_JPRB,1.9068E-04_JPRB,1.9916E-04_JPRB,1.9978E-04_JPRB,2.0155E-04_JPRB,&
&2.4936E-04_JPRB,3.5340E-04_JPRB,1.0988E-04_JPRB/)
KAO( :, 5, 4, 4) = (/&
&1.1242E-04_JPRB,2.1149E-04_JPRB,2.3915E-04_JPRB,2.5028E-04_JPRB,2.4989E-04_JPRB,2.4272E-04_JPRB,&
&2.4831E-04_JPRB,3.6709E-04_JPRB,1.3381E-04_JPRB/)
KAO( :, 1, 5, 4) = (/&
&2.0688E-05_JPRB,4.9203E-05_JPRB,5.9785E-05_JPRB,6.6990E-05_JPRB,7.8124E-05_JPRB,9.2624E-05_JPRB,&
&1.2472E-04_JPRB,2.0745E-04_JPRB,6.1812E-05_JPRB/)
KAO( :, 2, 5, 4) = (/&
&3.1637E-05_JPRB,6.9271E-05_JPRB,8.0604E-05_JPRB,9.0077E-05_JPRB,1.0181E-04_JPRB,1.1707E-04_JPRB,&
&1.4853E-04_JPRB,2.1722E-04_JPRB,7.1005E-05_JPRB/)
KAO( :, 3, 5, 4) = (/&
&4.6076E-05_JPRB,9.3625E-05_JPRB,1.0769E-04_JPRB,1.1334E-04_JPRB,1.2174E-04_JPRB,1.4414E-04_JPRB,&
&1.7668E-04_JPRB,2.5800E-04_JPRB,8.3094E-05_JPRB/)
KAO( :, 4, 5, 4) = (/&
&6.4341E-05_JPRB,1.2346E-04_JPRB,1.4103E-04_JPRB,1.4850E-04_JPRB,1.4693E-04_JPRB,1.5815E-04_JPRB,&
&1.9286E-04_JPRB,2.8817E-04_JPRB,9.6701E-05_JPRB/)
KAO( :, 5, 5, 4) = (/&
&8.6238E-05_JPRB,1.5868E-04_JPRB,1.7942E-04_JPRB,1.8707E-04_JPRB,1.8806E-04_JPRB,1.8319E-04_JPRB,&
&2.0554E-04_JPRB,2.8611E-04_JPRB,1.1287E-04_JPRB/)
KAO( :, 1, 6, 4) = (/&
&1.4006E-05_JPRB,3.3343E-05_JPRB,4.0079E-05_JPRB,4.5588E-05_JPRB,5.4107E-05_JPRB,6.6418E-05_JPRB,&
&1.0066E-04_JPRB,1.4196E-04_JPRB,6.6243E-05_JPRB/)
KAO( :, 2, 6, 4) = (/&
&2.2071E-05_JPRB,4.8614E-05_JPRB,5.7228E-05_JPRB,6.5093E-05_JPRB,7.1721E-05_JPRB,8.5635E-05_JPRB,&
&1.0856E-04_JPRB,1.8021E-04_JPRB,7.5554E-05_JPRB/)
KAO( :, 3, 6, 4) = (/&
&3.3040E-05_JPRB,6.6682E-05_JPRB,7.6698E-05_JPRB,8.2380E-05_JPRB,9.3552E-05_JPRB,1.0700E-04_JPRB,&
&1.3596E-04_JPRB,1.9405E-04_JPRB,8.6063E-05_JPRB/)
KAO( :, 4, 6, 4) = (/&
&4.7386E-05_JPRB,8.9793E-05_JPRB,1.0237E-04_JPRB,1.0759E-04_JPRB,1.0965E-04_JPRB,1.2726E-04_JPRB,&
&1.5398E-04_JPRB,2.2704E-04_JPRB,9.8696E-05_JPRB/)
KAO( :, 5, 6, 4) = (/&
&6.5121E-05_JPRB,1.1757E-04_JPRB,1.3268E-04_JPRB,1.3869E-04_JPRB,1.4006E-04_JPRB,1.3836E-04_JPRB,&
&1.7051E-04_JPRB,2.3669E-04_JPRB,1.1305E-04_JPRB/)
KAO( :, 1, 7, 4) = (/&
&9.5061E-06_JPRB,2.2311E-05_JPRB,2.6088E-05_JPRB,3.0162E-05_JPRB,3.7877E-05_JPRB,5.4505E-05_JPRB,&
&7.5227E-05_JPRB,1.1255E-04_JPRB,8.3483E-05_JPRB/)
KAO( :, 2, 7, 4) = (/&
&1.5323E-05_JPRB,3.3598E-05_JPRB,4.0386E-05_JPRB,4.3881E-05_JPRB,5.0583E-05_JPRB,6.2493E-05_JPRB,&
&8.2842E-05_JPRB,1.4322E-04_JPRB,9.4311E-05_JPRB/)
KAO( :, 3, 7, 4) = (/&
&2.3596E-05_JPRB,4.7494E-05_JPRB,5.4556E-05_JPRB,6.1372E-05_JPRB,6.7015E-05_JPRB,7.9350E-05_JPRB,&
&9.7496E-05_JPRB,1.4436E-04_JPRB,1.0703E-04_JPRB/)
KAO( :, 4, 7, 4) = (/&
&3.4570E-05_JPRB,6.4860E-05_JPRB,7.3694E-05_JPRB,7.7754E-05_JPRB,8.4695E-05_JPRB,9.7029E-05_JPRB,&
&1.1678E-04_JPRB,1.6858E-04_JPRB,1.2127E-04_JPRB/)
KAO( :, 5, 7, 4) = (/&
&4.8551E-05_JPRB,8.6609E-05_JPRB,9.7619E-05_JPRB,1.0164E-04_JPRB,1.0226E-04_JPRB,1.0885E-04_JPRB,&
&1.3405E-04_JPRB,1.9133E-04_JPRB,1.3656E-04_JPRB/)
KAO( :, 1, 8, 4) = (/&
&6.7311E-06_JPRB,1.4755E-05_JPRB,1.6935E-05_JPRB,2.1463E-05_JPRB,3.1231E-05_JPRB,4.0742E-05_JPRB,&
&5.6656E-05_JPRB,8.5927E-05_JPRB,1.5049E-04_JPRB/)
KAO( :, 2, 8, 4) = (/&
&1.0838E-05_JPRB,2.3183E-05_JPRB,2.7453E-05_JPRB,3.0553E-05_JPRB,3.5694E-05_JPRB,4.6374E-05_JPRB,&
&6.9419E-05_JPRB,1.0643E-04_JPRB,1.6866E-04_JPRB/)
KAO( :, 3, 8, 4) = (/&
&1.6914E-05_JPRB,3.3766E-05_JPRB,3.8989E-05_JPRB,4.4447E-05_JPRB,4.8070E-05_JPRB,5.7198E-05_JPRB,&
&7.1116E-05_JPRB,1.2478E-04_JPRB,1.8779E-04_JPRB/)
KAO( :, 4, 8, 4) = (/&
&2.5195E-05_JPRB,4.6972E-05_JPRB,5.3026E-05_JPRB,5.6927E-05_JPRB,6.4565E-05_JPRB,7.1923E-05_JPRB,&
&9.0751E-05_JPRB,1.2249E-04_JPRB,2.0805E-04_JPRB/)
KAO( :, 5, 8, 4) = (/&
&3.5942E-05_JPRB,6.3786E-05_JPRB,7.1729E-05_JPRB,7.3949E-05_JPRB,7.6446E-05_JPRB,8.8163E-05_JPRB,&
&1.0367E-04_JPRB,1.5461E-04_JPRB,2.3067E-04_JPRB/)
KAO( :, 1, 9, 4) = (/&
&5.1599E-06_JPRB,1.0081E-05_JPRB,1.1772E-05_JPRB,1.6698E-05_JPRB,2.2821E-05_JPRB,2.9936E-05_JPRB,&
&4.2105E-05_JPRB,6.2990E-05_JPRB,5.8733E-04_JPRB/)
KAO( :, 2, 9, 4) = (/&
&8.0231E-06_JPRB,1.6031E-05_JPRB,1.8581E-05_JPRB,2.0889E-05_JPRB,2.6202E-05_JPRB,3.8502E-05_JPRB,&
&5.1188E-05_JPRB,8.2231E-05_JPRB,6.4455E-04_JPRB/)
KAO( :, 3, 9, 4) = (/&
&1.2365E-05_JPRB,2.3962E-05_JPRB,2.7785E-05_JPRB,3.0574E-05_JPRB,3.4959E-05_JPRB,4.1433E-05_JPRB,&
&5.7939E-05_JPRB,9.7311E-05_JPRB,7.0196E-04_JPRB/)
KAO( :, 4, 9, 4) = (/&
&1.8494E-05_JPRB,3.4148E-05_JPRB,3.8522E-05_JPRB,4.2610E-05_JPRB,4.6125E-05_JPRB,5.4566E-05_JPRB,&
&6.5066E-05_JPRB,9.3543E-05_JPRB,7.5838E-04_JPRB/)
KAO( :, 5, 9, 4) = (/&
&2.6560E-05_JPRB,4.6839E-05_JPRB,5.2429E-05_JPRB,5.4183E-05_JPRB,5.9609E-05_JPRB,6.7149E-05_JPRB,&
&7.9436E-05_JPRB,1.1417E-04_JPRB,8.1247E-04_JPRB/)
KAO( :, 1,10, 4) = (/&
&4.5845E-06_JPRB,7.8051E-06_JPRB,9.3693E-06_JPRB,1.2991E-05_JPRB,1.7572E-05_JPRB,2.3437E-05_JPRB,&
&3.3813E-05_JPRB,4.9188E-05_JPRB,3.3674E-03_JPRB/)
KAO( :, 2,10, 4) = (/&
&6.8084E-06_JPRB,1.2034E-05_JPRB,1.3688E-05_JPRB,1.5733E-05_JPRB,2.1211E-05_JPRB,2.9098E-05_JPRB,&
&3.8545E-05_JPRB,6.3500E-05_JPRB,3.6391E-03_JPRB/)
KAO( :, 3,10, 4) = (/&
&1.0062E-05_JPRB,1.7982E-05_JPRB,2.0409E-05_JPRB,2.2663E-05_JPRB,2.5613E-05_JPRB,3.1784E-05_JPRB,&
&4.7385E-05_JPRB,7.3006E-05_JPRB,3.8993E-03_JPRB/)
KAO( :, 4,10, 4) = (/&
&1.4658E-05_JPRB,2.5727E-05_JPRB,2.8782E-05_JPRB,3.2310E-05_JPRB,3.4485E-05_JPRB,4.0752E-05_JPRB,&
&4.8720E-05_JPRB,8.2499E-05_JPRB,4.1490E-03_JPRB/)
KAO( :, 5,10, 4) = (/&
&2.0786E-05_JPRB,3.5657E-05_JPRB,3.9659E-05_JPRB,4.1123E-05_JPRB,4.6983E-05_JPRB,5.0556E-05_JPRB,&
&6.3521E-05_JPRB,8.4499E-05_JPRB,4.3775E-03_JPRB/)
KAO( :, 1,11, 4) = (/&
&5.0356E-06_JPRB,7.7353E-06_JPRB,8.8833E-06_JPRB,1.1452E-05_JPRB,1.5243E-05_JPRB,2.1044E-05_JPRB,&
&2.8338E-05_JPRB,4.9949E-05_JPRB,7.2577E-03_JPRB/)
KAO( :, 2,11, 4) = (/&
&7.2423E-06_JPRB,1.1514E-05_JPRB,1.2798E-05_JPRB,1.4086E-05_JPRB,1.8007E-05_JPRB,2.4558E-05_JPRB,&
&3.3851E-05_JPRB,5.2802E-05_JPRB,7.8158E-03_JPRB/)
KAO( :, 3,11, 4) = (/&
&1.0309E-05_JPRB,1.6653E-05_JPRB,1.8407E-05_JPRB,2.0089E-05_JPRB,2.2296E-05_JPRB,2.7018E-05_JPRB,&
&3.8586E-05_JPRB,6.0068E-05_JPRB,8.3354E-03_JPRB/)
KAO( :, 4,11, 4) = (/&
&1.4421E-05_JPRB,2.3379E-05_JPRB,2.5740E-05_JPRB,2.7750E-05_JPRB,3.0309E-05_JPRB,3.4851E-05_JPRB,&
&4.1245E-05_JPRB,6.8211E-05_JPRB,8.8296E-03_JPRB/)
KAO( :, 5,11, 4) = (/&
&1.9663E-05_JPRB,3.1842E-05_JPRB,3.4991E-05_JPRB,3.6140E-05_JPRB,3.9688E-05_JPRB,4.2983E-05_JPRB,&
&5.3776E-05_JPRB,6.9907E-05_JPRB,9.2688E-03_JPRB/)
KAO( :, 1,12, 4) = (/&
&5.1165E-06_JPRB,7.4029E-06_JPRB,8.1941E-06_JPRB,1.0138E-05_JPRB,1.3490E-05_JPRB,1.7256E-05_JPRB,&
&2.4419E-05_JPRB,4.0146E-05_JPRB,9.9448E-03_JPRB/)
KAO( :, 2,12, 4) = (/&
&7.2283E-06_JPRB,1.0802E-05_JPRB,1.1887E-05_JPRB,1.2642E-05_JPRB,1.5734E-05_JPRB,2.0542E-05_JPRB,&
&2.7886E-05_JPRB,4.3910E-05_JPRB,1.0705E-02_JPRB/)
KAO( :, 3,12, 4) = (/&
&1.0065E-05_JPRB,1.5284E-05_JPRB,1.6642E-05_JPRB,1.8157E-05_JPRB,1.9448E-05_JPRB,2.3207E-05_JPRB,&
&3.2168E-05_JPRB,5.3905E-05_JPRB,1.1409E-02_JPRB/)
KAO( :, 4,12, 4) = (/&
&1.3731E-05_JPRB,2.1142E-05_JPRB,2.2780E-05_JPRB,2.4378E-05_JPRB,2.6665E-05_JPRB,2.9738E-05_JPRB,&
&3.5163E-05_JPRB,5.5828E-05_JPRB,1.2051E-02_JPRB/)
KAO( :, 5,12, 4) = (/&
&1.8328E-05_JPRB,2.8382E-05_JPRB,3.0850E-05_JPRB,3.1430E-05_JPRB,3.3929E-05_JPRB,3.7016E-05_JPRB,&
&4.5266E-05_JPRB,5.8847E-05_JPRB,1.2603E-02_JPRB/)
KAO( :, 1,13, 4) = (/&
&5.1628E-06_JPRB,7.0476E-06_JPRB,7.6783E-06_JPRB,9.1901E-06_JPRB,1.1659E-05_JPRB,1.4990E-05_JPRB,&
&2.0746E-05_JPRB,3.1591E-05_JPRB,1.0979E-02_JPRB/)
KAO( :, 2,13, 4) = (/&
&7.1656E-06_JPRB,1.0090E-05_JPRB,1.0951E-05_JPRB,1.1562E-05_JPRB,1.3750E-05_JPRB,1.7398E-05_JPRB,&
&2.3701E-05_JPRB,3.7488E-05_JPRB,1.1813E-02_JPRB/)
KAO( :, 3,13, 4) = (/&
&9.7810E-06_JPRB,1.4159E-05_JPRB,1.5003E-05_JPRB,1.6207E-05_JPRB,1.7175E-05_JPRB,1.9965E-05_JPRB,&
&2.7079E-05_JPRB,4.3382E-05_JPRB,1.2578E-02_JPRB/)
KAO( :, 4,13, 4) = (/&
&1.3104E-05_JPRB,1.9253E-05_JPRB,2.0395E-05_JPRB,2.1436E-05_JPRB,2.3261E-05_JPRB,2.5640E-05_JPRB,&
&2.9895E-05_JPRB,4.6045E-05_JPRB,1.3231E-02_JPRB/)
KAO( :, 5,13, 4) = (/&
&1.7208E-05_JPRB,2.5546E-05_JPRB,2.7424E-05_JPRB,2.7535E-05_JPRB,2.9380E-05_JPRB,3.2546E-05_JPRB,&
&3.8040E-05_JPRB,4.9840E-05_JPRB,1.3742E-02_JPRB/)
KAO( :, 1, 1, 5) = (/&
&3.1090E-04_JPRB,4.1312E-04_JPRB,4.5176E-04_JPRB,4.6856E-04_JPRB,4.5586E-04_JPRB,4.3213E-04_JPRB,&
&4.5397E-04_JPRB,7.8015E-04_JPRB,2.0103E-04_JPRB/)
KAO( :, 2, 1, 5) = (/&
&3.8398E-04_JPRB,5.2122E-04_JPRB,5.7336E-04_JPRB,6.0217E-04_JPRB,6.0591E-04_JPRB,5.7511E-04_JPRB,&
&5.3422E-04_JPRB,6.1896E-04_JPRB,2.8351E-04_JPRB/)
KAO( :, 3, 1, 5) = (/&
&4.6534E-04_JPRB,6.4382E-04_JPRB,7.1301E-04_JPRB,7.5438E-04_JPRB,7.7134E-04_JPRB,7.6006E-04_JPRB,&
&7.0811E-04_JPRB,7.4234E-04_JPRB,3.7763E-04_JPRB/)
KAO( :, 4, 1, 5) = (/&
&5.5987E-04_JPRB,7.8442E-04_JPRB,8.7478E-04_JPRB,9.3078E-04_JPRB,9.6145E-04_JPRB,9.6632E-04_JPRB,&
&9.4057E-04_JPRB,8.7094E-04_JPRB,4.7321E-04_JPRB/)
KAO( :, 5, 1, 5) = (/&
&6.6579E-04_JPRB,9.4348E-04_JPRB,1.0594E-03_JPRB,1.1323E-03_JPRB,1.1769E-03_JPRB,1.1973E-03_JPRB,&
&1.1941E-03_JPRB,1.1720E-03_JPRB,5.8670E-04_JPRB/)
KAO( :, 1, 2, 5) = (/&
&2.4736E-04_JPRB,3.2724E-04_JPRB,3.5306E-04_JPRB,3.6178E-04_JPRB,3.4912E-04_JPRB,3.3979E-04_JPRB,&
&3.6882E-04_JPRB,6.4661E-04_JPRB,1.4637E-04_JPRB/)
KAO( :, 2, 2, 5) = (/&
&3.1002E-04_JPRB,4.1717E-04_JPRB,4.5359E-04_JPRB,4.7283E-04_JPRB,4.7168E-04_JPRB,4.4103E-04_JPRB,&
&4.4124E-04_JPRB,5.1519E-04_JPRB,2.1389E-04_JPRB/)
KAO( :, 3, 2, 5) = (/&
&3.8079E-04_JPRB,5.2107E-04_JPRB,5.7062E-04_JPRB,5.9973E-04_JPRB,6.0662E-04_JPRB,5.9325E-04_JPRB,&
&5.3745E-04_JPRB,5.8652E-04_JPRB,2.8633E-04_JPRB/)
KAO( :, 4, 2, 5) = (/&
&4.6210E-04_JPRB,6.4094E-04_JPRB,7.0763E-04_JPRB,7.4776E-04_JPRB,7.6652E-04_JPRB,7.5984E-04_JPRB,&
&7.3202E-04_JPRB,6.4140E-04_JPRB,3.5290E-04_JPRB/)
KAO( :, 5, 2, 5) = (/&
&5.5546E-04_JPRB,7.7925E-04_JPRB,8.6616E-04_JPRB,9.1863E-04_JPRB,9.4674E-04_JPRB,9.5490E-04_JPRB,&
&9.4094E-04_JPRB,9.1867E-04_JPRB,4.4201E-04_JPRB/)
KAO( :, 1, 3, 5) = (/&
&1.8639E-04_JPRB,2.4387E-04_JPRB,2.5915E-04_JPRB,2.5906E-04_JPRB,2.4918E-04_JPRB,2.5967E-04_JPRB,&
&3.1653E-04_JPRB,4.7580E-04_JPRB,1.1679E-04_JPRB/)
KAO( :, 2, 3, 5) = (/&
&2.3798E-04_JPRB,3.1564E-04_JPRB,3.3906E-04_JPRB,3.5000E-04_JPRB,3.4157E-04_JPRB,3.1943E-04_JPRB,&
&3.2743E-04_JPRB,4.5496E-04_JPRB,1.5856E-04_JPRB/)
KAO( :, 3, 3, 5) = (/&
&2.9733E-04_JPRB,4.0070E-04_JPRB,4.3349E-04_JPRB,4.5188E-04_JPRB,4.5270E-04_JPRB,4.3123E-04_JPRB,&
&3.9880E-04_JPRB,4.4081E-04_JPRB,2.0446E-04_JPRB/)
KAO( :, 4, 3, 5) = (/&
&3.6501E-04_JPRB,4.9946E-04_JPRB,5.4499E-04_JPRB,5.7170E-04_JPRB,5.7932E-04_JPRB,5.6633E-04_JPRB,&
&5.2704E-04_JPRB,5.1414E-04_JPRB,2.5539E-04_JPRB/)
KAO( :, 5, 3, 5) = (/&
&4.4410E-04_JPRB,6.1578E-04_JPRB,6.7619E-04_JPRB,7.1133E-04_JPRB,7.2738E-04_JPRB,7.2351E-04_JPRB,&
&7.0138E-04_JPRB,6.6673E-04_JPRB,3.2169E-04_JPRB/)
KAO( :, 1, 4, 5) = (/&
&1.3808E-04_JPRB,1.7775E-04_JPRB,1.8565E-04_JPRB,1.8174E-04_JPRB,1.8202E-04_JPRB,1.9738E-04_JPRB,&
&2.6854E-04_JPRB,3.3980E-04_JPRB,9.6622E-05_JPRB/)
KAO( :, 2, 4, 5) = (/&
&1.7835E-04_JPRB,2.3331E-04_JPRB,2.4753E-04_JPRB,2.5139E-04_JPRB,2.3877E-04_JPRB,2.3221E-04_JPRB,&
&2.5394E-04_JPRB,4.0618E-04_JPRB,1.2075E-04_JPRB/)
KAO( :, 3, 4, 5) = (/&
&2.2702E-04_JPRB,3.0170E-04_JPRB,3.2275E-04_JPRB,3.3261E-04_JPRB,3.2998E-04_JPRB,3.0635E-04_JPRB,&
&3.0422E-04_JPRB,3.7513E-04_JPRB,1.4994E-04_JPRB/)
KAO( :, 4, 4, 5) = (/&
&2.8327E-04_JPRB,3.8288E-04_JPRB,4.1191E-04_JPRB,4.2826E-04_JPRB,4.2837E-04_JPRB,4.1511E-04_JPRB,&
&3.7299E-04_JPRB,4.1488E-04_JPRB,1.8740E-04_JPRB/)
KAO( :, 5, 4, 5) = (/&
&3.4778E-04_JPRB,4.7798E-04_JPRB,5.1863E-04_JPRB,5.4065E-04_JPRB,5.4665E-04_JPRB,5.3624E-04_JPRB,&
&5.0550E-04_JPRB,4.5874E-04_JPRB,2.3509E-04_JPRB/)
KAO( :, 1, 5, 5) = (/&
&1.0090E-04_JPRB,1.2840E-04_JPRB,1.3222E-04_JPRB,1.3092E-04_JPRB,1.3649E-04_JPRB,1.6019E-04_JPRB,&
&2.1671E-04_JPRB,2.5303E-04_JPRB,9.1217E-05_JPRB/)
KAO( :, 2, 5, 5) = (/&
&1.3290E-04_JPRB,1.7161E-04_JPRB,1.7952E-04_JPRB,1.7693E-04_JPRB,1.6957E-04_JPRB,1.7378E-04_JPRB,&
&2.2031E-04_JPRB,3.2593E-04_JPRB,1.0460E-04_JPRB/)
KAO( :, 3, 5, 5) = (/&
&1.7169E-04_JPRB,2.2556E-04_JPRB,2.3842E-04_JPRB,2.4266E-04_JPRB,2.3387E-04_JPRB,2.1722E-04_JPRB,&
&2.2376E-04_JPRB,3.3249E-04_JPRB,1.2312E-04_JPRB/)
KAO( :, 4, 5, 5) = (/&
&2.1761E-04_JPRB,2.9095E-04_JPRB,3.1013E-04_JPRB,3.1776E-04_JPRB,3.1556E-04_JPRB,2.9734E-04_JPRB,&
&2.7621E-04_JPRB,3.0674E-04_JPRB,1.4846E-04_JPRB/)
KAO( :, 5, 5, 5) = (/&
&2.6974E-04_JPRB,3.6873E-04_JPRB,3.9640E-04_JPRB,4.0873E-04_JPRB,4.0796E-04_JPRB,3.9425E-04_JPRB,&
&3.6157E-04_JPRB,3.6174E-04_JPRB,1.8146E-04_JPRB/)
KAO( :, 1, 6, 5) = (/&
&7.2092E-05_JPRB,9.1048E-05_JPRB,9.3429E-05_JPRB,9.5226E-05_JPRB,1.0150E-04_JPRB,1.3173E-04_JPRB,&
&1.4984E-04_JPRB,1.9196E-04_JPRB,9.8397E-05_JPRB/)
KAO( :, 2, 6, 5) = (/&
&9.7448E-05_JPRB,1.2423E-04_JPRB,1.2792E-04_JPRB,1.2413E-04_JPRB,1.2424E-04_JPRB,1.3383E-04_JPRB,&
&1.7960E-04_JPRB,2.4434E-04_JPRB,1.1133E-04_JPRB/)
KAO( :, 3, 6, 5) = (/&
&1.2736E-04_JPRB,1.6584E-04_JPRB,1.7360E-04_JPRB,1.7200E-04_JPRB,1.6167E-04_JPRB,1.5892E-04_JPRB,&
&1.7153E-04_JPRB,2.8218E-04_JPRB,1.2781E-04_JPRB/)
KAO( :, 4, 6, 5) = (/&
&1.6376E-04_JPRB,2.1742E-04_JPRB,2.3003E-04_JPRB,2.3266E-04_JPRB,2.2686E-04_JPRB,2.0723E-04_JPRB,&
&2.0538E-04_JPRB,2.5489E-04_JPRB,1.4690E-04_JPRB/)
KAO( :, 5, 6, 5) = (/&
&2.0555E-04_JPRB,2.7960E-04_JPRB,2.9861E-04_JPRB,3.0501E-04_JPRB,3.0003E-04_JPRB,2.8746E-04_JPRB,&
&2.5983E-04_JPRB,2.8313E-04_JPRB,1.7007E-04_JPRB/)
KAO( :, 1, 7, 5) = (/&
&5.0915E-05_JPRB,6.4096E-05_JPRB,6.5839E-05_JPRB,7.0435E-05_JPRB,8.2474E-05_JPRB,1.0016E-04_JPRB,&
&1.1360E-04_JPRB,1.4590E-04_JPRB,1.4032E-04_JPRB/)
KAO( :, 2, 7, 5) = (/&
&7.0625E-05_JPRB,8.9097E-05_JPRB,9.0314E-05_JPRB,8.9429E-05_JPRB,9.3251E-05_JPRB,1.0724E-04_JPRB,&
&1.4912E-04_JPRB,1.8863E-04_JPRB,1.5518E-04_JPRB/)
KAO( :, 3, 7, 5) = (/&
&9.4098E-05_JPRB,1.2125E-04_JPRB,1.2537E-04_JPRB,1.2091E-04_JPRB,1.1603E-04_JPRB,1.1857E-04_JPRB,&
&1.4624E-04_JPRB,2.2506E-04_JPRB,1.7262E-04_JPRB/)
KAO( :, 4, 7, 5) = (/&
&1.2191E-04_JPRB,1.6102E-04_JPRB,1.6901E-04_JPRB,1.6848E-04_JPRB,1.5829E-04_JPRB,1.4830E-04_JPRB,&
&1.5156E-04_JPRB,2.2031E-04_JPRB,1.9339E-04_JPRB/)
KAO( :, 5, 7, 5) = (/&
&1.5529E-04_JPRB,2.0973E-04_JPRB,2.2297E-04_JPRB,2.2562E-04_JPRB,2.1894E-04_JPRB,2.0410E-04_JPRB,&
&1.8782E-04_JPRB,2.1024E-04_JPRB,2.1671E-04_JPRB/)
KAO( :, 1, 8, 5) = (/&
&3.6049E-05_JPRB,4.5291E-05_JPRB,4.7754E-05_JPRB,5.1919E-05_JPRB,6.1186E-05_JPRB,6.9190E-05_JPRB,&
&8.4378E-05_JPRB,1.1648E-04_JPRB,2.7572E-04_JPRB/)
KAO( :, 2, 8, 5) = (/&
&5.1045E-05_JPRB,6.3896E-05_JPRB,6.4272E-05_JPRB,6.5150E-05_JPRB,6.9954E-05_JPRB,8.8868E-05_JPRB,&
&1.0162E-04_JPRB,1.4598E-04_JPRB,3.0000E-04_JPRB/)
KAO( :, 3, 8, 5) = (/&
&6.9216E-05_JPRB,8.8252E-05_JPRB,9.0050E-05_JPRB,8.5873E-05_JPRB,8.5359E-05_JPRB,9.1693E-05_JPRB,&
&1.2432E-04_JPRB,1.5741E-04_JPRB,3.2619E-04_JPRB/)
KAO( :, 4, 8, 5) = (/&
&9.0719E-05_JPRB,1.1854E-04_JPRB,1.2391E-04_JPRB,1.2089E-04_JPRB,1.1160E-04_JPRB,1.0845E-04_JPRB,&
&1.1912E-04_JPRB,1.9063E-04_JPRB,3.5459E-04_JPRB/)
KAO( :, 5, 8, 5) = (/&
&1.1702E-04_JPRB,1.5606E-04_JPRB,1.6531E-04_JPRB,1.6622E-04_JPRB,1.5932E-04_JPRB,1.4248E-04_JPRB,&
&1.4183E-04_JPRB,1.7131E-04_JPRB,3.8497E-04_JPRB/)
KAO( :, 1, 9, 5) = (/&
&2.5866E-05_JPRB,3.2320E-05_JPRB,3.4576E-05_JPRB,3.8709E-05_JPRB,4.6229E-05_JPRB,5.2438E-05_JPRB,&
&6.5503E-05_JPRB,9.3730E-05_JPRB,1.1703E-03_JPRB/)
KAO( :, 2, 9, 5) = (/&
&3.7130E-05_JPRB,4.6042E-05_JPRB,4.6409E-05_JPRB,4.8783E-05_JPRB,5.6170E-05_JPRB,6.7762E-05_JPRB,&
&7.7225E-05_JPRB,1.1273E-04_JPRB,1.2364E-03_JPRB/)
KAO( :, 3, 9, 5) = (/&
&5.1057E-05_JPRB,6.4238E-05_JPRB,6.4747E-05_JPRB,6.3009E-05_JPRB,6.3858E-05_JPRB,7.4779E-05_JPRB,&
&9.9385E-05_JPRB,1.2137E-04_JPRB,1.3035E-03_JPRB/)
KAO( :, 4, 9, 5) = (/&
&6.7872E-05_JPRB,8.7074E-05_JPRB,9.0171E-05_JPRB,8.6365E-05_JPRB,8.1775E-05_JPRB,8.1150E-05_JPRB,&
&1.0091E-04_JPRB,1.5846E-04_JPRB,1.3706E-03_JPRB/)
KAO( :, 5, 9, 5) = (/&
&8.8212E-05_JPRB,1.1565E-04_JPRB,1.2170E-04_JPRB,1.2148E-04_JPRB,1.1255E-04_JPRB,1.0392E-04_JPRB,&
&1.0391E-04_JPRB,1.5035E-04_JPRB,1.4393E-03_JPRB/)
KAO( :, 1,10, 5) = (/&
&2.0052E-05_JPRB,2.4599E-05_JPRB,2.6224E-05_JPRB,2.9775E-05_JPRB,3.4377E-05_JPRB,3.9753E-05_JPRB,&
&5.1870E-05_JPRB,7.0614E-05_JPRB,6.9310E-03_JPRB/)
KAO( :, 2,10, 5) = (/&
&2.8642E-05_JPRB,3.5006E-05_JPRB,3.5601E-05_JPRB,3.7670E-05_JPRB,4.4192E-05_JPRB,5.0297E-05_JPRB,&
&6.0753E-05_JPRB,8.8409E-05_JPRB,7.2473E-03_JPRB/)
KAO( :, 3,10, 5) = (/&
&3.9509E-05_JPRB,4.8803E-05_JPRB,4.8668E-05_JPRB,4.7951E-05_JPRB,5.0708E-05_JPRB,6.1469E-05_JPRB,&
&7.4297E-05_JPRB,9.6176E-05_JPRB,7.5424E-03_JPRB/)
KAO( :, 4,10, 5) = (/&
&5.2822E-05_JPRB,6.6323E-05_JPRB,6.7918E-05_JPRB,6.3993E-05_JPRB,6.2062E-05_JPRB,6.4519E-05_JPRB,&
&8.5147E-05_JPRB,1.1230E-04_JPRB,7.8121E-03_JPRB/)
KAO( :, 5,10, 5) = (/&
&6.8969E-05_JPRB,8.8314E-05_JPRB,9.1957E-05_JPRB,9.0701E-05_JPRB,8.2062E-05_JPRB,7.8779E-05_JPRB,&
&8.1888E-05_JPRB,1.3051E-04_JPRB,8.0714E-03_JPRB/)
KAO( :, 1,11, 5) = (/&
&1.9311E-05_JPRB,2.2943E-05_JPRB,2.3712E-05_JPRB,2.6076E-05_JPRB,2.9763E-05_JPRB,3.4761E-05_JPRB,&
&4.2561E-05_JPRB,5.7624E-05_JPRB,1.5187E-02_JPRB/)
KAO( :, 2,11, 5) = (/&
&2.6757E-05_JPRB,3.2178E-05_JPRB,3.2098E-05_JPRB,3.3425E-05_JPRB,3.7561E-05_JPRB,4.3432E-05_JPRB,&
&5.1256E-05_JPRB,7.3332E-05_JPRB,1.5840E-02_JPRB/)
KAO( :, 3,11, 5) = (/&
&3.6196E-05_JPRB,4.4102E-05_JPRB,4.3948E-05_JPRB,4.2431E-05_JPRB,4.4099E-05_JPRB,5.1811E-05_JPRB,&
&6.2145E-05_JPRB,8.0656E-05_JPRB,1.6449E-02_JPRB/)
KAO( :, 4,11, 5) = (/&
&4.7882E-05_JPRB,5.9111E-05_JPRB,6.0086E-05_JPRB,5.7204E-05_JPRB,5.4371E-05_JPRB,5.5076E-05_JPRB,&
&7.0526E-05_JPRB,9.2945E-05_JPRB,1.6989E-02_JPRB/)
KAO( :, 5,11, 5) = (/&
&6.2068E-05_JPRB,7.8174E-05_JPRB,8.0859E-05_JPRB,7.9258E-05_JPRB,7.2738E-05_JPRB,6.8607E-05_JPRB,&
&6.8925E-05_JPRB,1.0616E-04_JPRB,1.7481E-02_JPRB/)
KAO( :, 1,12, 5) = (/&
&1.8157E-05_JPRB,2.1121E-05_JPRB,2.1509E-05_JPRB,2.2736E-05_JPRB,2.6145E-05_JPRB,3.0200E-05_JPRB,&
&3.7064E-05_JPRB,5.0458E-05_JPRB,2.1164E-02_JPRB/)
KAO( :, 2,12, 5) = (/&
&2.4750E-05_JPRB,2.9265E-05_JPRB,2.8640E-05_JPRB,2.9365E-05_JPRB,3.1815E-05_JPRB,3.7644E-05_JPRB,&
&4.4258E-05_JPRB,6.0893E-05_JPRB,2.2083E-02_JPRB/)
KAO( :, 3,12, 5) = (/&
&3.3051E-05_JPRB,3.9669E-05_JPRB,3.9323E-05_JPRB,3.7322E-05_JPRB,3.8330E-05_JPRB,4.3268E-05_JPRB,&
&5.2953E-05_JPRB,6.6459E-05_JPRB,2.2904E-02_JPRB/)
KAO( :, 4,12, 5) = (/&
&4.3268E-05_JPRB,5.2755E-05_JPRB,5.3305E-05_JPRB,5.0755E-05_JPRB,4.7183E-05_JPRB,4.7321E-05_JPRB,&
&5.8905E-05_JPRB,7.8211E-05_JPRB,2.3625E-02_JPRB/)
KAO( :, 5,12, 5) = (/&
&5.5712E-05_JPRB,6.9313E-05_JPRB,7.1134E-05_JPRB,6.9400E-05_JPRB,6.4153E-05_JPRB,5.9244E-05_JPRB,&
&5.8683E-05_JPRB,8.6772E-05_JPRB,2.4304E-02_JPRB/)
KAO( :, 1,13, 5) = (/&
&1.7179E-05_JPRB,1.9773E-05_JPRB,1.9599E-05_JPRB,2.0374E-05_JPRB,2.3480E-05_JPRB,2.5935E-05_JPRB,&
&3.2097E-05_JPRB,4.3807E-05_JPRB,2.3722E-02_JPRB/)
KAO( :, 2,13, 5) = (/&
&2.3195E-05_JPRB,2.7018E-05_JPRB,2.6155E-05_JPRB,2.6118E-05_JPRB,2.7654E-05_JPRB,3.2413E-05_JPRB,&
&3.6439E-05_JPRB,5.1480E-05_JPRB,2.4748E-02_JPRB/)
KAO( :, 3,13, 5) = (/&
&3.0612E-05_JPRB,3.6208E-05_JPRB,3.5603E-05_JPRB,3.3306E-05_JPRB,3.3238E-05_JPRB,3.6754E-05_JPRB,&
&4.5231E-05_JPRB,5.7370E-05_JPRB,2.5646E-02_JPRB/)
KAO( :, 4,13, 5) = (/&
&3.9626E-05_JPRB,4.7737E-05_JPRB,4.7941E-05_JPRB,4.5252E-05_JPRB,4.1653E-05_JPRB,4.0753E-05_JPRB,&
&4.9320E-05_JPRB,6.5660E-05_JPRB,2.6492E-02_JPRB/)
KAO( :, 5,13, 5) = (/&
&5.0622E-05_JPRB,6.2138E-05_JPRB,6.3203E-05_JPRB,6.1426E-05_JPRB,5.6252E-05_JPRB,5.1272E-05_JPRB,&
&5.0385E-05_JPRB,7.0865E-05_JPRB,2.7279E-02_JPRB/)
KAO( :, 1, 1, 6) = (/&
&7.6668E-04_JPRB,9.5698E-04_JPRB,1.0451E-03_JPRB,1.0706E-03_JPRB,1.0458E-03_JPRB,9.8544E-04_JPRB,&
&8.4925E-04_JPRB,7.0084E-04_JPRB,3.6790E-04_JPRB/)
KAO( :, 2, 1, 6) = (/&
&9.3715E-04_JPRB,1.2033E-03_JPRB,1.3264E-03_JPRB,1.3678E-03_JPRB,1.3579E-03_JPRB,1.2955E-03_JPRB,&
&1.2019E-03_JPRB,1.0530E-03_JPRB,4.9374E-04_JPRB/)
KAO( :, 3, 1, 6) = (/&
&1.1259E-03_JPRB,1.4892E-03_JPRB,1.6507E-03_JPRB,1.7086E-03_JPRB,1.7099E-03_JPRB,1.6660E-03_JPRB,&
&1.5468E-03_JPRB,1.3572E-03_JPRB,6.9469E-04_JPRB/)
KAO( :, 4, 1, 6) = (/&
&1.3346E-03_JPRB,1.8150E-03_JPRB,2.0125E-03_JPRB,2.0930E-03_JPRB,2.1054E-03_JPRB,2.0604E-03_JPRB,&
&1.9461E-03_JPRB,1.7694E-03_JPRB,9.3629E-04_JPRB/)
KAO( :, 5, 1, 6) = (/&
&1.5631E-03_JPRB,2.1751E-03_JPRB,2.4107E-03_JPRB,2.5177E-03_JPRB,2.5412E-03_JPRB,2.4997E-03_JPRB,&
&2.4003E-03_JPRB,2.2329E-03_JPRB,1.1943E-03_JPRB/)
KAO( :, 1, 2, 6) = (/&
&6.1736E-04_JPRB,7.7957E-04_JPRB,8.4495E-04_JPRB,8.5822E-04_JPRB,8.3168E-04_JPRB,7.6710E-04_JPRB,&
&6.8197E-04_JPRB,6.1117E-04_JPRB,2.7552E-04_JPRB/)
KAO( :, 2, 2, 6) = (/&
&7.6431E-04_JPRB,9.9047E-04_JPRB,1.0825E-03_JPRB,1.1059E-03_JPRB,1.0905E-03_JPRB,1.0282E-03_JPRB,&
&9.1763E-04_JPRB,8.3788E-04_JPRB,3.8116E-04_JPRB/)
KAO( :, 3, 2, 6) = (/&
&9.2906E-04_JPRB,1.2346E-03_JPRB,1.3561E-03_JPRB,1.3925E-03_JPRB,1.3898E-03_JPRB,1.3440E-03_JPRB,&
&1.2411E-03_JPRB,1.1007E-03_JPRB,5.2777E-04_JPRB/)
KAO( :, 4, 2, 6) = (/&
&1.1126E-03_JPRB,1.5138E-03_JPRB,1.6623E-03_JPRB,1.7166E-03_JPRB,1.7237E-03_JPRB,1.6799E-03_JPRB,&
&1.5813E-03_JPRB,1.4262E-03_JPRB,7.0852E-04_JPRB/)
KAO( :, 5, 2, 6) = (/&
&1.3161E-03_JPRB,1.8216E-03_JPRB,2.0023E-03_JPRB,2.0780E-03_JPRB,2.0918E-03_JPRB,2.0576E-03_JPRB,&
&1.9689E-03_JPRB,1.8083E-03_JPRB,9.0055E-04_JPRB/)
KAO( :, 1, 3, 6) = (/&
&4.6874E-04_JPRB,5.9508E-04_JPRB,6.3781E-04_JPRB,6.4117E-04_JPRB,6.1436E-04_JPRB,5.4822E-04_JPRB,&
&5.0421E-04_JPRB,5.3533E-04_JPRB,2.0334E-04_JPRB/)
KAO( :, 2, 3, 6) = (/&
&5.9055E-04_JPRB,7.6700E-04_JPRB,8.2890E-04_JPRB,8.3946E-04_JPRB,8.1795E-04_JPRB,7.6034E-04_JPRB,&
&6.7368E-04_JPRB,6.0816E-04_JPRB,2.8145E-04_JPRB/)
KAO( :, 3, 3, 6) = (/&
&7.2955E-04_JPRB,9.6821E-04_JPRB,1.0493E-03_JPRB,1.0696E-03_JPRB,1.0616E-03_JPRB,1.0150E-03_JPRB,&
&9.2112E-04_JPRB,8.3960E-04_JPRB,3.8605E-04_JPRB/)
KAO( :, 4, 3, 6) = (/&
&8.8621E-04_JPRB,1.1995E-03_JPRB,1.3001E-03_JPRB,1.3322E-03_JPRB,1.3333E-03_JPRB,1.2938E-03_JPRB,&
&1.2044E-03_JPRB,1.0885E-03_JPRB,5.0764E-04_JPRB/)
KAO( :, 5, 3, 6) = (/&
&1.0620E-03_JPRB,1.4561E-03_JPRB,1.5813E-03_JPRB,1.6291E-03_JPRB,1.6339E-03_JPRB,1.6065E-03_JPRB,&
&1.5265E-03_JPRB,1.3705E-03_JPRB,6.4701E-04_JPRB/)
KAO( :, 1, 4, 6) = (/&
&3.4631E-04_JPRB,4.3892E-04_JPRB,4.6539E-04_JPRB,4.6252E-04_JPRB,4.3395E-04_JPRB,3.8559E-04_JPRB,&
&3.5487E-04_JPRB,4.4831E-04_JPRB,1.5114E-04_JPRB/)
KAO( :, 2, 4, 6) = (/&
&4.4425E-04_JPRB,5.7553E-04_JPRB,6.1538E-04_JPRB,6.1883E-04_JPRB,5.9314E-04_JPRB,5.4165E-04_JPRB,&
&4.8640E-04_JPRB,4.4227E-04_JPRB,2.0515E-04_JPRB/)
KAO( :, 3, 4, 6) = (/&
&5.5883E-04_JPRB,7.3740E-04_JPRB,7.9031E-04_JPRB,7.9974E-04_JPRB,7.8639E-04_JPRB,7.3691E-04_JPRB,&
&6.4680E-04_JPRB,6.1866E-04_JPRB,2.7731E-04_JPRB/)
KAO( :, 4, 4, 6) = (/&
&6.8974E-04_JPRB,9.2537E-04_JPRB,9.9228E-04_JPRB,1.0098E-03_JPRB,1.0044E-03_JPRB,9.6650E-04_JPRB,&
&8.8358E-04_JPRB,7.6484E-04_JPRB,3.6266E-04_JPRB/)
KAO( :, 5, 4, 6) = (/&
&8.3990E-04_JPRB,1.1361E-03_JPRB,1.2201E-03_JPRB,1.2496E-03_JPRB,1.2472E-03_JPRB,1.2194E-03_JPRB,&
&1.1540E-03_JPRB,1.0325E-03_JPRB,4.6430E-04_JPRB/)
KAO( :, 1, 5, 6) = (/&
&2.5250E-04_JPRB,3.1808E-04_JPRB,3.3386E-04_JPRB,3.2714E-04_JPRB,3.0037E-04_JPRB,2.7399E-04_JPRB,&
&2.6791E-04_JPRB,3.5704E-04_JPRB,1.2908E-04_JPRB/)
KAO( :, 2, 5, 6) = (/&
&3.3043E-04_JPRB,4.2488E-04_JPRB,4.5012E-04_JPRB,4.4889E-04_JPRB,4.2554E-04_JPRB,3.8200E-04_JPRB,&
&3.3745E-04_JPRB,3.7310E-04_JPRB,1.6348E-04_JPRB/)
KAO( :, 3, 5, 6) = (/&
&4.2316E-04_JPRB,5.5338E-04_JPRB,5.8740E-04_JPRB,5.9160E-04_JPRB,5.7542E-04_JPRB,5.3101E-04_JPRB,&
&4.6257E-04_JPRB,4.4755E-04_JPRB,2.1057E-04_JPRB/)
KAO( :, 4, 5, 6) = (/&
&5.3209E-04_JPRB,7.0370E-04_JPRB,7.4784E-04_JPRB,7.5773E-04_JPRB,7.4773E-04_JPRB,7.1163E-04_JPRB,&
&6.4170E-04_JPRB,5.6009E-04_JPRB,2.6995E-04_JPRB/)
KAO( :, 5, 5, 6) = (/&
&6.5954E-04_JPRB,8.7577E-04_JPRB,9.3136E-04_JPRB,9.4956E-04_JPRB,9.4321E-04_JPRB,9.1424E-04_JPRB,&
&8.5021E-04_JPRB,7.6505E-04_JPRB,3.4403E-04_JPRB/)
KAO( :, 1, 6, 6) = (/&
&1.8041E-04_JPRB,2.2490E-04_JPRB,2.3336E-04_JPRB,2.2464E-04_JPRB,2.0963E-04_JPRB,1.9425E-04_JPRB,&
&2.2107E-04_JPRB,2.7984E-04_JPRB,1.4894E-04_JPRB/)
KAO( :, 2, 6, 6) = (/&
&2.4129E-04_JPRB,3.0664E-04_JPRB,3.2201E-04_JPRB,3.1753E-04_JPRB,2.9432E-04_JPRB,2.6424E-04_JPRB,&
&2.4608E-04_JPRB,3.2717E-04_JPRB,1.7150E-04_JPRB/)
KAO( :, 3, 6, 6) = (/&
&3.1506E-04_JPRB,4.0665E-04_JPRB,4.2823E-04_JPRB,4.2924E-04_JPRB,4.1092E-04_JPRB,3.7075E-04_JPRB,&
&3.2608E-04_JPRB,3.0715E-04_JPRB,1.9997E-04_JPRB/)
KAO( :, 4, 6, 6) = (/&
&4.0467E-04_JPRB,5.2530E-04_JPRB,5.5383E-04_JPRB,5.5842E-04_JPRB,5.4724E-04_JPRB,5.1243E-04_JPRB,&
&4.4254E-04_JPRB,3.9888E-04_JPRB,2.3767E-04_JPRB/)
KAO( :, 5, 6, 6) = (/&
&5.1106E-04_JPRB,6.6417E-04_JPRB,6.9974E-04_JPRB,7.0967E-04_JPRB,7.0212E-04_JPRB,6.7161E-04_JPRB,&
&6.0464E-04_JPRB,5.2589E-04_JPRB,2.8598E-04_JPRB/)
KAO( :, 1, 7, 6) = (/&
&1.2786E-04_JPRB,1.5741E-04_JPRB,1.6149E-04_JPRB,1.5385E-04_JPRB,1.4113E-04_JPRB,1.3717E-04_JPRB,&
&1.7921E-04_JPRB,2.1884E-04_JPRB,2.2335E-04_JPRB/)
KAO( :, 2, 7, 6) = (/&
&1.7476E-04_JPRB,2.1914E-04_JPRB,2.2777E-04_JPRB,2.2084E-04_JPRB,2.0229E-04_JPRB,1.8812E-04_JPRB,&
&1.8018E-04_JPRB,2.7538E-04_JPRB,2.4653E-04_JPRB/)
KAO( :, 3, 7, 6) = (/&
&2.3335E-04_JPRB,2.9589E-04_JPRB,3.0942E-04_JPRB,3.0765E-04_JPRB,2.8977E-04_JPRB,2.5625E-04_JPRB,&
&2.3275E-04_JPRB,2.5170E-04_JPRB,2.7339E-04_JPRB/)
KAO( :, 4, 7, 6) = (/&
&3.0583E-04_JPRB,3.8902E-04_JPRB,4.0709E-04_JPRB,4.0819E-04_JPRB,3.9588E-04_JPRB,3.6356E-04_JPRB,&
&3.1361E-04_JPRB,2.9658E-04_JPRB,3.0348E-04_JPRB/)
KAO( :, 5, 7, 6) = (/&
&3.9359E-04_JPRB,5.0084E-04_JPRB,5.2271E-04_JPRB,5.2613E-04_JPRB,5.1742E-04_JPRB,4.8862E-04_JPRB,&
&4.3693E-04_JPRB,3.8092E-04_JPRB,3.3962E-04_JPRB/)
KAO( :, 1, 8, 6) = (/&
&9.0775E-05_JPRB,1.1005E-04_JPRB,1.1099E-04_JPRB,1.0509E-04_JPRB,9.9650E-05_JPRB,1.1055E-04_JPRB,&
&1.4832E-04_JPRB,1.7530E-04_JPRB,4.7525E-04_JPRB/)
KAO( :, 2, 8, 6) = (/&
&1.2669E-04_JPRB,1.5629E-04_JPRB,1.6068E-04_JPRB,1.5361E-04_JPRB,1.4250E-04_JPRB,1.3452E-04_JPRB,&
&1.4933E-04_JPRB,2.0310E-04_JPRB,5.0480E-04_JPRB/)
KAO( :, 3, 8, 6) = (/&
&1.7285E-04_JPRB,2.1483E-04_JPRB,2.2274E-04_JPRB,2.1837E-04_JPRB,2.0107E-04_JPRB,1.8034E-04_JPRB,&
&1.6967E-04_JPRB,2.2418E-04_JPRB,5.3971E-04_JPRB/)
KAO( :, 4, 8, 6) = (/&
&2.3078E-04_JPRB,2.8784E-04_JPRB,2.9834E-04_JPRB,2.9682E-04_JPRB,2.8348E-04_JPRB,2.5378E-04_JPRB,&
&2.1967E-04_JPRB,2.1775E-04_JPRB,5.7949E-04_JPRB/)
KAO( :, 5, 8, 6) = (/&
&3.0207E-04_JPRB,3.7730E-04_JPRB,3.9003E-04_JPRB,3.8941E-04_JPRB,3.7851E-04_JPRB,3.5314E-04_JPRB,&
&3.0320E-04_JPRB,2.7345E-04_JPRB,6.2347E-04_JPRB/)
KAO( :, 1, 9, 6) = (/&
&6.4923E-05_JPRB,7.7301E-05_JPRB,7.6873E-05_JPRB,7.2507E-05_JPRB,7.2968E-05_JPRB,8.8916E-05_JPRB,&
&1.0626E-04_JPRB,1.3047E-04_JPRB,2.1479E-03_JPRB/)
KAO( :, 2, 9, 6) = (/&
&9.2060E-05_JPRB,1.1144E-04_JPRB,1.1301E-04_JPRB,1.0673E-04_JPRB,9.8741E-05_JPRB,9.7585E-05_JPRB,&
&1.2203E-04_JPRB,1.5315E-04_JPRB,2.2213E-03_JPRB/)
KAO( :, 3, 9, 6) = (/&
&1.2784E-04_JPRB,1.5591E-04_JPRB,1.5957E-04_JPRB,1.5395E-04_JPRB,1.4101E-04_JPRB,1.2937E-04_JPRB,&
&1.2902E-04_JPRB,1.8269E-04_JPRB,2.3004E-03_JPRB/)
KAO( :, 4, 9, 6) = (/&
&1.7362E-04_JPRB,2.1265E-04_JPRB,2.1819E-04_JPRB,2.1460E-04_JPRB,2.0088E-04_JPRB,1.7687E-04_JPRB,&
&1.6114E-04_JPRB,1.7045E-04_JPRB,2.3836E-03_JPRB/)
KAO( :, 5, 9, 6) = (/&
&2.3060E-04_JPRB,2.8346E-04_JPRB,2.9069E-04_JPRB,2.8691E-04_JPRB,2.7538E-04_JPRB,2.5192E-04_JPRB,&
&2.1567E-04_JPRB,2.0242E-04_JPRB,2.4645E-03_JPRB/)
KAO( :, 1,10, 6) = (/&
&4.9625E-05_JPRB,5.7572E-05_JPRB,5.6443E-05_JPRB,5.4999E-05_JPRB,5.9435E-05_JPRB,7.0786E-05_JPRB,&
&7.6295E-05_JPRB,1.0573E-04_JPRB,1.3224E-02_JPRB/)
KAO( :, 2,10, 6) = (/&
&7.0134E-05_JPRB,8.3014E-05_JPRB,8.2620E-05_JPRB,7.7969E-05_JPRB,7.3377E-05_JPRB,8.0016E-05_JPRB,&
&9.8395E-05_JPRB,1.2266E-04_JPRB,1.3476E-02_JPRB/)
KAO( :, 3,10, 6) = (/&
&9.7838E-05_JPRB,1.1716E-04_JPRB,1.1840E-04_JPRB,1.1257E-04_JPRB,1.0247E-04_JPRB,9.5389E-05_JPRB,&
&1.0384E-04_JPRB,1.4488E-04_JPRB,1.3733E-02_JPRB/)
KAO( :, 4,10, 6) = (/&
&1.3411E-04_JPRB,1.6175E-04_JPRB,1.6407E-04_JPRB,1.5918E-04_JPRB,1.4592E-04_JPRB,1.2914E-04_JPRB,&
&1.2234E-04_JPRB,1.5601E-04_JPRB,1.4015E-02_JPRB/)
KAO( :, 5,10, 6) = (/&
&1.7947E-04_JPRB,2.1813E-04_JPRB,2.2167E-04_JPRB,2.1661E-04_JPRB,2.0497E-04_JPRB,1.8308E-04_JPRB,&
&1.5705E-04_JPRB,1.5556E-04_JPRB,1.4285E-02_JPRB/)
KAO( :, 1,11, 6) = (/&
&4.6838E-05_JPRB,5.3188E-05_JPRB,5.1940E-05_JPRB,4.9560E-05_JPRB,5.2867E-05_JPRB,6.0471E-05_JPRB,&
&6.7131E-05_JPRB,8.9235E-05_JPRB,2.9682E-02_JPRB/)
KAO( :, 2,11, 6) = (/&
&6.4771E-05_JPRB,7.4879E-05_JPRB,7.3789E-05_JPRB,6.9085E-05_JPRB,6.5402E-05_JPRB,6.9078E-05_JPRB,&
&8.2402E-05_JPRB,9.7823E-05_JPRB,3.0214E-02_JPRB/)
KAO( :, 3,11, 6) = (/&
&8.8977E-05_JPRB,1.0443E-04_JPRB,1.0449E-04_JPRB,9.8837E-05_JPRB,8.9325E-05_JPRB,8.2564E-05_JPRB,&
&9.0256E-05_JPRB,1.2264E-04_JPRB,3.0751E-02_JPRB/)
KAO( :, 4,11, 6) = (/&
&1.2031E-04_JPRB,1.4341E-04_JPRB,1.4439E-04_JPRB,1.3909E-04_JPRB,1.2684E-04_JPRB,1.1148E-04_JPRB,&
&1.0343E-04_JPRB,1.2710E-04_JPRB,3.1294E-02_JPRB/)
KAO( :, 5,11, 6) = (/&
&1.5966E-04_JPRB,1.9217E-04_JPRB,1.9445E-04_JPRB,1.8922E-04_JPRB,1.7785E-04_JPRB,1.5826E-04_JPRB,&
&1.3426E-04_JPRB,1.3572E-04_JPRB,3.1828E-02_JPRB/)
KAO( :, 1,12, 6) = (/&
&4.4013E-05_JPRB,4.9051E-05_JPRB,4.7310E-05_JPRB,4.5083E-05_JPRB,4.5655E-05_JPRB,5.3046E-05_JPRB,&
&5.5846E-05_JPRB,7.3868E-05_JPRB,4.2262E-02_JPRB/)
KAO( :, 2,12, 6) = (/&
&5.9811E-05_JPRB,6.7905E-05_JPRB,6.6450E-05_JPRB,6.1482E-05_JPRB,5.7471E-05_JPRB,5.8427E-05_JPRB,&
&7.0235E-05_JPRB,8.1755E-05_JPRB,4.3100E-02_JPRB/)
KAO( :, 3,12, 6) = (/&
&8.0771E-05_JPRB,9.3483E-05_JPRB,9.2712E-05_JPRB,8.7290E-05_JPRB,7.8335E-05_JPRB,7.2055E-05_JPRB,&
&7.5619E-05_JPRB,1.0330E-04_JPRB,4.3963E-02_JPRB/)
KAO( :, 4,12, 6) = (/&
&1.0778E-04_JPRB,1.2684E-04_JPRB,1.2706E-04_JPRB,1.2188E-04_JPRB,1.1092E-04_JPRB,9.6993E-05_JPRB,&
&8.8534E-05_JPRB,1.0545E-04_JPRB,4.4781E-02_JPRB/)
KAO( :, 5,12, 6) = (/&
&1.4170E-04_JPRB,1.6874E-04_JPRB,1.7020E-04_JPRB,1.6546E-04_JPRB,1.5470E-04_JPRB,1.3786E-04_JPRB,&
&1.1554E-04_JPRB,1.1534E-04_JPRB,4.5542E-02_JPRB/)
KAO( :, 1,13, 6) = (/&
&4.2090E-05_JPRB,4.6101E-05_JPRB,4.3965E-05_JPRB,4.1016E-05_JPRB,4.0300E-05_JPRB,4.5499E-05_JPRB,&
&4.8852E-05_JPRB,6.1759E-05_JPRB,4.8346E-02_JPRB/)
KAO( :, 2,13, 6) = (/&
&5.6243E-05_JPRB,6.2753E-05_JPRB,6.0819E-05_JPRB,5.5713E-05_JPRB,5.1322E-05_JPRB,5.0494E-05_JPRB,&
&6.0604E-05_JPRB,6.8003E-05_JPRB,4.9462E-02_JPRB/)
KAO( :, 3,13, 6) = (/&
&7.4458E-05_JPRB,8.4643E-05_JPRB,8.3343E-05_JPRB,7.8251E-05_JPRB,6.9869E-05_JPRB,6.3030E-05_JPRB,&
&6.3206E-05_JPRB,8.7133E-05_JPRB,5.0553E-02_JPRB/)
KAO( :, 4,13, 6) = (/&
&9.7702E-05_JPRB,1.1298E-04_JPRB,1.1246E-04_JPRB,1.0753E-04_JPRB,9.7507E-05_JPRB,8.4857E-05_JPRB,&
&7.6788E-05_JPRB,8.6167E-05_JPRB,5.1568E-02_JPRB/)
KAO( :, 5,13, 6) = (/&
&1.2694E-04_JPRB,1.4871E-04_JPRB,1.4954E-04_JPRB,1.4480E-04_JPRB,1.3473E-04_JPRB,1.1941E-04_JPRB,&
&9.9413E-05_JPRB,9.9688E-05_JPRB,5.2519E-02_JPRB/)
KAO( :, 1, 1, 7) = (/&
&2.0564E-03_JPRB,2.2357E-03_JPRB,2.2921E-03_JPRB,2.2746E-03_JPRB,2.1808E-03_JPRB,2.0118E-03_JPRB,&
&1.7401E-03_JPRB,1.3032E-03_JPRB,9.5552E-04_JPRB/)
KAO( :, 2, 1, 7) = (/&
&2.5245E-03_JPRB,2.7780E-03_JPRB,2.8722E-03_JPRB,2.8575E-03_JPRB,2.7633E-03_JPRB,2.6046E-03_JPRB,&
&2.3222E-03_JPRB,1.8131E-03_JPRB,1.3540E-03_JPRB/)
KAO( :, 3, 1, 7) = (/&
&3.0325E-03_JPRB,3.3773E-03_JPRB,3.5284E-03_JPRB,3.5242E-03_JPRB,3.4302E-03_JPRB,3.2547E-03_JPRB,&
&2.9982E-03_JPRB,2.6610E-03_JPRB,1.7942E-03_JPRB/)
KAO( :, 4, 1, 7) = (/&
&3.5774E-03_JPRB,4.0328E-03_JPRB,4.2570E-03_JPRB,4.2786E-03_JPRB,4.1734E-03_JPRB,3.9880E-03_JPRB,&
&3.7418E-03_JPRB,3.6443E-03_JPRB,2.2977E-03_JPRB/)
KAO( :, 5, 1, 7) = (/&
&4.1551E-03_JPRB,4.7493E-03_JPRB,5.0612E-03_JPRB,5.1084E-03_JPRB,4.9896E-03_JPRB,4.7828E-03_JPRB,&
&4.5388E-03_JPRB,4.6729E-03_JPRB,2.8901E-03_JPRB/)
KAO( :, 1, 2, 7) = (/&
&1.7021E-03_JPRB,1.8729E-03_JPRB,1.9247E-03_JPRB,1.9078E-03_JPRB,1.8213E-03_JPRB,1.6737E-03_JPRB,&
&1.4152E-03_JPRB,1.0410E-03_JPRB,7.2465E-04_JPRB/)
KAO( :, 2, 2, 7) = (/&
&2.1085E-03_JPRB,2.3473E-03_JPRB,2.4306E-03_JPRB,2.4189E-03_JPRB,2.3372E-03_JPRB,2.1946E-03_JPRB,&
&1.9650E-03_JPRB,1.4507E-03_JPRB,1.0070E-03_JPRB/)
KAO( :, 3, 2, 7) = (/&
&2.5539E-03_JPRB,2.8790E-03_JPRB,3.0056E-03_JPRB,3.0096E-03_JPRB,2.9218E-03_JPRB,2.7596E-03_JPRB,&
&2.5256E-03_JPRB,2.1562E-03_JPRB,1.3358E-03_JPRB/)
KAO( :, 4, 2, 7) = (/&
&3.0381E-03_JPRB,3.4689E-03_JPRB,3.6518E-03_JPRB,3.6778E-03_JPRB,3.5757E-03_JPRB,3.4032E-03_JPRB,&
&3.1678E-03_JPRB,2.9648E-03_JPRB,1.7229E-03_JPRB/)
KAO( :, 5, 2, 7) = (/&
&3.5521E-03_JPRB,4.1214E-03_JPRB,4.3704E-03_JPRB,4.4118E-03_JPRB,4.3015E-03_JPRB,4.1082E-03_JPRB,&
&3.8609E-03_JPRB,3.8044E-03_JPRB,2.1852E-03_JPRB/)
KAO( :, 1, 3, 7) = (/&
&1.3207E-03_JPRB,1.4650E-03_JPRB,1.5081E-03_JPRB,1.4879E-03_JPRB,1.4138E-03_JPRB,1.2859E-03_JPRB,&
&1.0511E-03_JPRB,7.8811E-04_JPRB,5.1479E-04_JPRB/)
KAO( :, 2, 3, 7) = (/&
&1.6600E-03_JPRB,1.8649E-03_JPRB,1.9312E-03_JPRB,1.9179E-03_JPRB,1.8422E-03_JPRB,1.7178E-03_JPRB,&
&1.5069E-03_JPRB,1.1268E-03_JPRB,7.0924E-04_JPRB/)
KAO( :, 3, 3, 7) = (/&
&2.0389E-03_JPRB,2.3205E-03_JPRB,2.4185E-03_JPRB,2.4171E-03_JPRB,2.3339E-03_JPRB,2.1929E-03_JPRB,&
&1.9846E-03_JPRB,1.6361E-03_JPRB,9.4601E-04_JPRB/)
KAO( :, 4, 3, 7) = (/&
&2.4547E-03_JPRB,2.8320E-03_JPRB,2.9726E-03_JPRB,2.9883E-03_JPRB,2.8925E-03_JPRB,2.7393E-03_JPRB,&
&2.5305E-03_JPRB,2.2455E-03_JPRB,1.2306E-03_JPRB/)
KAO( :, 5, 3, 7) = (/&
&2.8997E-03_JPRB,3.4059E-03_JPRB,3.5906E-03_JPRB,3.6183E-03_JPRB,3.5177E-03_JPRB,3.3454E-03_JPRB,&
&3.1285E-03_JPRB,2.9519E-03_JPRB,1.5729E-03_JPRB/)
KAO( :, 1, 4, 7) = (/&
&9.9106E-04_JPRB,1.1077E-03_JPRB,1.1376E-03_JPRB,1.1157E-03_JPRB,1.0521E-03_JPRB,9.4148E-04_JPRB,&
&7.8510E-04_JPRB,5.6824E-04_JPRB,3.5975E-04_JPRB/)
KAO( :, 2, 4, 7) = (/&
&1.2690E-03_JPRB,1.4351E-03_JPRB,1.4835E-03_JPRB,1.4646E-03_JPRB,1.3997E-03_JPRB,1.2889E-03_JPRB,&
&1.0960E-03_JPRB,8.9289E-04_JPRB,4.9353E-04_JPRB/)
KAO( :, 3, 4, 7) = (/&
&1.5842E-03_JPRB,1.8142E-03_JPRB,1.8866E-03_JPRB,1.8780E-03_JPRB,1.8013E-03_JPRB,1.6820E-03_JPRB,&
&1.5023E-03_JPRB,1.1830E-03_JPRB,6.6203E-04_JPRB/)
KAO( :, 4, 4, 7) = (/&
&1.9340E-03_JPRB,2.2471E-03_JPRB,2.3499E-03_JPRB,2.3511E-03_JPRB,2.2648E-03_JPRB,2.1322E-03_JPRB,&
&1.9509E-03_JPRB,1.6764E-03_JPRB,8.7194E-04_JPRB/)
KAO( :, 5, 4, 7) = (/&
&2.3113E-03_JPRB,2.7351E-03_JPRB,2.8762E-03_JPRB,2.8805E-03_JPRB,2.7879E-03_JPRB,2.6395E-03_JPRB,&
&2.4567E-03_JPRB,2.2403E-03_JPRB,1.1262E-03_JPRB/)
KAO( :, 1, 5, 7) = (/&
&7.3127E-04_JPRB,8.2296E-04_JPRB,8.4087E-04_JPRB,8.1934E-04_JPRB,7.6237E-04_JPRB,6.6355E-04_JPRB,&
&5.7712E-04_JPRB,4.2586E-04_JPRB,2.6106E-04_JPRB/)
KAO( :, 2, 5, 7) = (/&
&9.5564E-04_JPRB,1.0866E-03_JPRB,1.1175E-03_JPRB,1.0975E-03_JPRB,1.0423E-03_JPRB,9.4115E-04_JPRB,&
&7.8089E-04_JPRB,7.0271E-04_JPRB,3.5186E-04_JPRB/)
KAO( :, 3, 5, 7) = (/&
&1.2139E-03_JPRB,1.3968E-03_JPRB,1.4447E-03_JPRB,1.4289E-03_JPRB,1.3656E-03_JPRB,1.2642E-03_JPRB,&
&1.1044E-03_JPRB,8.5519E-04_JPRB,4.7090E-04_JPRB/)
KAO( :, 4, 5, 7) = (/&
&1.5030E-03_JPRB,1.7556E-03_JPRB,1.8265E-03_JPRB,1.8139E-03_JPRB,1.7423E-03_JPRB,1.6256E-03_JPRB,&
&1.4668E-03_JPRB,1.2302E-03_JPRB,6.2262E-04_JPRB/)
KAO( :, 5, 5, 7) = (/&
&1.8204E-03_JPRB,2.1651E-03_JPRB,2.2625E-03_JPRB,2.2502E-03_JPRB,2.1716E-03_JPRB,2.0469E-03_JPRB,&
&1.8925E-03_JPRB,1.6626E-03_JPRB,8.1240E-04_JPRB/)
KAO( :, 1, 6, 7) = (/&
&5.2529E-04_JPRB,5.9432E-04_JPRB,6.0352E-04_JPRB,5.8305E-04_JPRB,5.3304E-04_JPRB,4.5328E-04_JPRB,&
&4.1878E-04_JPRB,3.5780E-04_JPRB,2.4217E-04_JPRB/)
KAO( :, 2, 6, 7) = (/&
&7.0212E-04_JPRB,8.0206E-04_JPRB,8.1885E-04_JPRB,8.0064E-04_JPRB,7.5267E-04_JPRB,6.6720E-04_JPRB,&
&5.4925E-04_JPRB,4.7137E-04_JPRB,2.9304E-04_JPRB/)
KAO( :, 3, 6, 7) = (/&
&9.0974E-04_JPRB,1.0505E-03_JPRB,1.0784E-03_JPRB,1.0608E-03_JPRB,1.0082E-03_JPRB,9.2191E-04_JPRB,&
&7.8184E-04_JPRB,6.5554E-04_JPRB,3.6650E-04_JPRB/)
KAO( :, 4, 6, 7) = (/&
&1.1453E-03_JPRB,1.3423E-03_JPRB,1.3852E-03_JPRB,1.3677E-03_JPRB,1.3077E-03_JPRB,1.2097E-03_JPRB,&
&1.0767E-03_JPRB,8.5645E-04_JPRB,4.6653E-04_JPRB/)
KAO( :, 5, 6, 7) = (/&
&1.4081E-03_JPRB,1.6785E-03_JPRB,1.7408E-03_JPRB,1.7212E-03_JPRB,1.6525E-03_JPRB,1.5502E-03_JPRB,&
&1.4183E-03_JPRB,1.2157E-03_JPRB,5.9973E-04_JPRB/)
KAO( :, 1, 7, 7) = (/&
&3.7120E-04_JPRB,4.2080E-04_JPRB,4.2477E-04_JPRB,4.0604E-04_JPRB,3.6355E-04_JPRB,3.1468E-04_JPRB,&
&2.7452E-04_JPRB,3.0003E-04_JPRB,3.4329E-04_JPRB/)
KAO( :, 2, 7, 7) = (/&
&5.0811E-04_JPRB,5.8113E-04_JPRB,5.8975E-04_JPRB,5.7433E-04_JPRB,5.3282E-04_JPRB,4.5716E-04_JPRB,&
&3.8591E-04_JPRB,3.1558E-04_JPRB,3.8021E-04_JPRB/)
KAO( :, 3, 7, 7) = (/&
&6.7189E-04_JPRB,7.7708E-04_JPRB,7.9243E-04_JPRB,7.7528E-04_JPRB,7.3224E-04_JPRB,6.5998E-04_JPRB,&
&5.4384E-04_JPRB,5.0808E-04_JPRB,4.2510E-04_JPRB/)
KAO( :, 4, 7, 7) = (/&
&8.6172E-04_JPRB,1.0111E-03_JPRB,1.0357E-03_JPRB,1.0171E-03_JPRB,9.6771E-04_JPRB,8.8863E-04_JPRB,&
&7.7053E-04_JPRB,5.9901E-04_JPRB,4.8327E-04_JPRB/)
KAO( :, 5, 7, 7) = (/&
&1.0762E-03_JPRB,1.2838E-03_JPRB,1.3208E-03_JPRB,1.3007E-03_JPRB,1.2428E-03_JPRB,1.1566E-03_JPRB,&
&1.0378E-03_JPRB,8.6101E-04_JPRB,5.6256E-04_JPRB/)
KAO( :, 1, 8, 7) = (/&
&2.6005E-04_JPRB,2.9445E-04_JPRB,2.9544E-04_JPRB,2.7954E-04_JPRB,2.4583E-04_JPRB,2.1647E-04_JPRB,&
&1.8002E-04_JPRB,2.3598E-04_JPRB,7.9092E-04_JPRB/)
KAO( :, 2, 8, 7) = (/&
&3.6459E-04_JPRB,4.1637E-04_JPRB,4.2010E-04_JPRB,4.0556E-04_JPRB,3.7047E-04_JPRB,3.0940E-04_JPRB,&
&2.7524E-04_JPRB,2.5435E-04_JPRB,8.3476E-04_JPRB/)
KAO( :, 3, 8, 7) = (/&
&4.9221E-04_JPRB,5.6877E-04_JPRB,5.7633E-04_JPRB,5.6089E-04_JPRB,5.2598E-04_JPRB,4.6466E-04_JPRB,&
&3.7776E-04_JPRB,3.4121E-04_JPRB,8.7965E-04_JPRB/)
KAO( :, 4, 8, 7) = (/&
&6.4351E-04_JPRB,7.5336E-04_JPRB,7.6684E-04_JPRB,7.4955E-04_JPRB,7.0992E-04_JPRB,6.4867E-04_JPRB,&
&5.4671E-04_JPRB,4.4943E-04_JPRB,9.3048E-04_JPRB/)
KAO( :, 5, 8, 7) = (/&
&8.1696E-04_JPRB,9.7167E-04_JPRB,9.9275E-04_JPRB,9.7485E-04_JPRB,9.2841E-04_JPRB,8.5440E-04_JPRB,&
&7.5642E-04_JPRB,5.9342E-04_JPRB,9.8996E-04_JPRB/)
KAO( :, 1, 9, 7) = (/&
&1.8087E-04_JPRB,2.0393E-04_JPRB,2.0319E-04_JPRB,1.8996E-04_JPRB,1.6599E-04_JPRB,1.4845E-04_JPRB,&
&1.4517E-04_JPRB,1.8943E-04_JPRB,3.7840E-03_JPRB/)
KAO( :, 2, 9, 7) = (/&
&2.5947E-04_JPRB,2.9518E-04_JPRB,2.9598E-04_JPRB,2.8323E-04_JPRB,2.5237E-04_JPRB,2.1334E-04_JPRB,&
&1.9297E-04_JPRB,2.0265E-04_JPRB,3.8746E-03_JPRB/)
KAO( :, 3, 9, 7) = (/&
&3.5788E-04_JPRB,4.1170E-04_JPRB,4.1507E-04_JPRB,4.0085E-04_JPRB,3.7117E-04_JPRB,3.1718E-04_JPRB,&
&2.6164E-04_JPRB,2.2715E-04_JPRB,3.9645E-03_JPRB/)
KAO( :, 4, 9, 7) = (/&
&4.7699E-04_JPRB,5.5569E-04_JPRB,5.6204E-04_JPRB,5.4699E-04_JPRB,5.1526E-04_JPRB,4.6408E-04_JPRB,&
&3.7784E-04_JPRB,3.4199E-04_JPRB,4.0560E-03_JPRB/)
KAO( :, 5, 9, 7) = (/&
&6.1621E-04_JPRB,7.2836E-04_JPRB,7.3953E-04_JPRB,7.2389E-04_JPRB,6.8675E-04_JPRB,6.2690E-04_JPRB,&
&5.4244E-04_JPRB,4.1506E-04_JPRB,4.1481E-03_JPRB/)
KAO( :, 1,10, 7) = (/&
&1.3094E-04_JPRB,1.4617E-04_JPRB,1.4409E-04_JPRB,1.3166E-04_JPRB,1.1671E-04_JPRB,1.0840E-04_JPRB,&
&1.1994E-04_JPRB,1.5334E-04_JPRB,2.4678E-02_JPRB/)
KAO( :, 2,10, 7) = (/&
&1.9036E-04_JPRB,2.1493E-04_JPRB,2.1399E-04_JPRB,2.0239E-04_JPRB,1.7779E-04_JPRB,1.5202E-04_JPRB,&
&1.3461E-04_JPRB,1.6391E-04_JPRB,2.4818E-02_JPRB/)
KAO( :, 3,10, 7) = (/&
&2.6670E-04_JPRB,3.0451E-04_JPRB,3.0518E-04_JPRB,2.9252E-04_JPRB,2.6713E-04_JPRB,2.2545E-04_JPRB,&
&1.9430E-04_JPRB,1.7654E-04_JPRB,2.4944E-02_JPRB/)
KAO( :, 4,10, 7) = (/&
&3.6077E-04_JPRB,4.1729E-04_JPRB,4.1982E-04_JPRB,4.0619E-04_JPRB,3.7979E-04_JPRB,3.3605E-04_JPRB,&
&2.6665E-04_JPRB,2.5064E-04_JPRB,2.5043E-02_JPRB/)
KAO( :, 5,10, 7) = (/&
&4.7368E-04_JPRB,5.5457E-04_JPRB,5.6006E-04_JPRB,5.4560E-04_JPRB,5.1520E-04_JPRB,4.6682E-04_JPRB,&
&3.9587E-04_JPRB,3.0490E-04_JPRB,2.5182E-02_JPRB/)
KAO( :, 1,11, 7) = (/&
&1.1672E-04_JPRB,1.2865E-04_JPRB,1.2575E-04_JPRB,1.1552E-04_JPRB,1.0159E-04_JPRB,9.2164E-05_JPRB,&
&9.9270E-05_JPRB,1.2653E-04_JPRB,5.7559E-02_JPRB/)
KAO( :, 2,11, 7) = (/&
&1.6732E-04_JPRB,1.8741E-04_JPRB,1.8550E-04_JPRB,1.7442E-04_JPRB,1.5354E-04_JPRB,1.3133E-04_JPRB,&
&1.1767E-04_JPRB,1.4329E-04_JPRB,5.7684E-02_JPRB/)
KAO( :, 3,11, 7) = (/&
&2.3276E-04_JPRB,2.6444E-04_JPRB,2.6342E-04_JPRB,2.5118E-04_JPRB,2.2884E-04_JPRB,1.9264E-04_JPRB,&
&1.6524E-04_JPRB,1.4558E-04_JPRB,5.7855E-02_JPRB/)
KAO( :, 4,11, 7) = (/&
&3.1443E-04_JPRB,3.6154E-04_JPRB,3.6203E-04_JPRB,3.4857E-04_JPRB,3.2499E-04_JPRB,2.8713E-04_JPRB,&
&2.2934E-04_JPRB,2.1182E-04_JPRB,5.7981E-02_JPRB/)
KAO( :, 5,11, 7) = (/&
&4.1392E-04_JPRB,4.8111E-04_JPRB,4.8318E-04_JPRB,4.6852E-04_JPRB,4.4073E-04_JPRB,3.9804E-04_JPRB,&
&3.3719E-04_JPRB,2.5664E-04_JPRB,5.8015E-02_JPRB/)
KAO( :, 1,12, 7) = (/&
&1.0495E-04_JPRB,1.1425E-04_JPRB,1.1065E-04_JPRB,1.0139E-04_JPRB,8.8702E-05_JPRB,8.0270E-05_JPRB,&
&8.3227E-05_JPRB,1.1035E-04_JPRB,8.4777E-02_JPRB/)
KAO( :, 2,12, 7) = (/&
&1.4811E-04_JPRB,1.6444E-04_JPRB,1.6133E-04_JPRB,1.5088E-04_JPRB,1.3304E-04_JPRB,1.1329E-04_JPRB,&
&1.0211E-04_JPRB,1.1814E-04_JPRB,8.5052E-02_JPRB/)
KAO( :, 3,12, 7) = (/&
&2.0461E-04_JPRB,2.3053E-04_JPRB,2.2799E-04_JPRB,2.1647E-04_JPRB,1.9655E-04_JPRB,1.6510E-04_JPRB,&
&1.3813E-04_JPRB,1.2052E-04_JPRB,8.5320E-02_JPRB/)
KAO( :, 4,12, 7) = (/&
&2.7614E-04_JPRB,3.1483E-04_JPRB,3.1311E-04_JPRB,3.0005E-04_JPRB,2.7866E-04_JPRB,2.4569E-04_JPRB,&
&1.9595E-04_JPRB,1.7650E-04_JPRB,8.5551E-02_JPRB/)
KAO( :, 5,12, 7) = (/&
&3.6369E-04_JPRB,4.1945E-04_JPRB,4.1876E-04_JPRB,4.0374E-04_JPRB,3.7792E-04_JPRB,3.3990E-04_JPRB,&
&2.8821E-04_JPRB,2.1660E-04_JPRB,8.5586E-02_JPRB/)
KAO( :, 1,13, 7) = (/&
&9.6451E-05_JPRB,1.0341E-04_JPRB,9.9264E-05_JPRB,9.0436E-05_JPRB,7.8283E-05_JPRB,7.1353E-05_JPRB,&
&7.0038E-05_JPRB,8.7127E-05_JPRB,1.0017E-01_JPRB/)
KAO( :, 2,13, 7) = (/&
&1.3353E-04_JPRB,1.4634E-04_JPRB,1.4212E-04_JPRB,1.3211E-04_JPRB,1.1628E-04_JPRB,9.7846E-05_JPRB,&
&8.8593E-05_JPRB,9.9520E-05_JPRB,1.0066E-01_JPRB/)
KAO( :, 3,13, 7) = (/&
&1.8247E-04_JPRB,2.0319E-04_JPRB,1.9922E-04_JPRB,1.8770E-04_JPRB,1.6984E-04_JPRB,1.4285E-04_JPRB,&
&1.1822E-04_JPRB,1.0096E-04_JPRB,1.0114E-01_JPRB/)
KAO( :, 4,13, 7) = (/&
&2.4463E-04_JPRB,2.7635E-04_JPRB,2.7262E-04_JPRB,2.5991E-04_JPRB,2.4023E-04_JPRB,2.1109E-04_JPRB,&
&1.6739E-04_JPRB,1.4711E-04_JPRB,1.0151E-01_JPRB/)
KAO( :, 5,13, 7) = (/&
&3.2023E-04_JPRB,3.6781E-04_JPRB,3.6463E-04_JPRB,3.4949E-04_JPRB,3.2644E-04_JPRB,2.9244E-04_JPRB,&
&2.4737E-04_JPRB,1.8188E-04_JPRB,1.0162E-01_JPRB/)
KAO( :, 1, 1, 8) = (/&
&4.4239E-03_JPRB,4.5519E-03_JPRB,4.5724E-03_JPRB,4.4178E-03_JPRB,4.2198E-03_JPRB,4.0058E-03_JPRB,&
&3.6615E-03_JPRB,3.0019E-03_JPRB,2.7752E-03_JPRB/)
KAO( :, 2, 1, 8) = (/&
&5.3797E-03_JPRB,5.6034E-03_JPRB,5.6810E-03_JPRB,5.5458E-03_JPRB,5.3768E-03_JPRB,5.2131E-03_JPRB,&
&5.0349E-03_JPRB,4.6587E-03_JPRB,3.8056E-03_JPRB/)
KAO( :, 3, 1, 8) = (/&
&6.4347E-03_JPRB,6.7859E-03_JPRB,6.9273E-03_JPRB,6.8482E-03_JPRB,6.7118E-03_JPRB,6.6177E-03_JPRB,&
&6.6013E-03_JPRB,6.5225E-03_JPRB,5.0401E-03_JPRB/)
KAO( :, 4, 1, 8) = (/&
&7.5645E-03_JPRB,8.0892E-03_JPRB,8.3352E-03_JPRB,8.3083E-03_JPRB,8.2560E-03_JPRB,8.2611E-03_JPRB,&
&8.3847E-03_JPRB,8.5252E-03_JPRB,6.4996E-03_JPRB/)
KAO( :, 5, 1, 8) = (/&
&8.7680E-03_JPRB,9.5130E-03_JPRB,9.8898E-03_JPRB,9.9473E-03_JPRB,1.0011E-02_JPRB,1.0143E-02_JPRB,&
&1.0425E-02_JPRB,1.0769E-02_JPRB,8.2076E-03_JPRB/)
KAO( :, 1, 2, 8) = (/&
&3.8956E-03_JPRB,4.0502E-03_JPRB,4.0603E-03_JPRB,3.9353E-03_JPRB,3.7465E-03_JPRB,3.4739E-03_JPRB,&
&3.0905E-03_JPRB,2.3943E-03_JPRB,2.1184E-03_JPRB/)
KAO( :, 2, 2, 8) = (/&
&4.7918E-03_JPRB,5.0484E-03_JPRB,5.0971E-03_JPRB,4.9960E-03_JPRB,4.7901E-03_JPRB,4.5311E-03_JPRB,&
&4.2459E-03_JPRB,3.8455E-03_JPRB,2.9268E-03_JPRB/)
KAO( :, 3, 2, 8) = (/&
&5.7854E-03_JPRB,6.1757E-03_JPRB,6.2838E-03_JPRB,6.2127E-03_JPRB,6.0071E-03_JPRB,5.7828E-03_JPRB,&
&5.6083E-03_JPRB,5.4427E-03_JPRB,3.9021E-03_JPRB/)
KAO( :, 4, 2, 8) = (/&
&6.8580E-03_JPRB,7.4217E-03_JPRB,7.6327E-03_JPRB,7.5901E-03_JPRB,7.4062E-03_JPRB,7.2358E-03_JPRB,&
&7.1625E-03_JPRB,7.2397E-03_JPRB,5.0676E-03_JPRB/)
KAO( :, 5, 2, 8) = (/&
&8.0102E-03_JPRB,8.7860E-03_JPRB,9.1257E-03_JPRB,9.1299E-03_JPRB,8.9977E-03_JPRB,8.9056E-03_JPRB,&
&8.9466E-03_JPRB,9.2132E-03_JPRB,6.4234E-03_JPRB/)
KAO( :, 1, 3, 8) = (/&
&3.2185E-03_JPRB,3.3667E-03_JPRB,3.3683E-03_JPRB,3.2709E-03_JPRB,3.1158E-03_JPRB,2.8506E-03_JPRB,&
&2.4272E-03_JPRB,1.7393E-03_JPRB,1.4905E-03_JPRB/)
KAO( :, 2, 3, 8) = (/&
&4.0272E-03_JPRB,4.2617E-03_JPRB,4.2966E-03_JPRB,4.2148E-03_JPRB,4.0495E-03_JPRB,3.7679E-03_JPRB,&
&3.4096E-03_JPRB,2.8817E-03_JPRB,2.0706E-03_JPRB/)
KAO( :, 3, 3, 8) = (/&
&4.9255E-03_JPRB,5.2838E-03_JPRB,5.3750E-03_JPRB,5.3109E-03_JPRB,5.1338E-03_JPRB,4.8398E-03_JPRB,&
&4.5501E-03_JPRB,4.1909E-03_JPRB,2.7937E-03_JPRB/)
KAO( :, 4, 3, 8) = (/&
&5.9079E-03_JPRB,6.4325E-03_JPRB,6.6107E-03_JPRB,6.5630E-03_JPRB,6.3820E-03_JPRB,6.0909E-03_JPRB,&
&5.8611E-03_JPRB,5.7562E-03_JPRB,3.6692E-03_JPRB/)
KAO( :, 5, 3, 8) = (/&
&6.9696E-03_JPRB,7.6975E-03_JPRB,7.9877E-03_JPRB,7.9811E-03_JPRB,7.8040E-03_JPRB,7.5290E-03_JPRB,&
&7.3615E-03_JPRB,7.4650E-03_JPRB,4.7053E-03_JPRB/)
KAO( :, 1, 4, 8) = (/&
&2.5545E-03_JPRB,2.6859E-03_JPRB,2.6880E-03_JPRB,2.6203E-03_JPRB,2.4823E-03_JPRB,2.2588E-03_JPRB,&
&1.8322E-03_JPRB,1.2713E-03_JPRB,1.0214E-03_JPRB/)
KAO( :, 2, 4, 8) = (/&
&3.2572E-03_JPRB,3.4677E-03_JPRB,3.4957E-03_JPRB,3.4378E-03_JPRB,3.2931E-03_JPRB,3.0601E-03_JPRB,&
&2.6717E-03_JPRB,2.0170E-03_JPRB,1.4352E-03_JPRB/)
KAO( :, 3, 4, 8) = (/&
&4.0447E-03_JPRB,4.3684E-03_JPRB,4.4456E-03_JPRB,4.3951E-03_JPRB,4.2405E-03_JPRB,3.9923E-03_JPRB,&
&3.6333E-03_JPRB,3.0944E-03_JPRB,1.9579E-03_JPRB/)
KAO( :, 4, 4, 8) = (/&
&4.9198E-03_JPRB,5.3921E-03_JPRB,5.5389E-03_JPRB,5.5062E-03_JPRB,5.3434E-03_JPRB,5.0807E-03_JPRB,&
&4.7402E-03_JPRB,4.4587E-03_JPRB,2.6028E-03_JPRB/)
KAO( :, 5, 4, 8) = (/&
&5.8819E-03_JPRB,6.5317E-03_JPRB,6.7822E-03_JPRB,6.7765E-03_JPRB,6.6162E-03_JPRB,6.3253E-03_JPRB,&
&5.9954E-03_JPRB,5.8840E-03_JPRB,3.3755E-03_JPRB/)
KAO( :, 1, 5, 8) = (/&
&1.9756E-03_JPRB,2.0856E-03_JPRB,2.0921E-03_JPRB,2.0392E-03_JPRB,1.9309E-03_JPRB,1.7377E-03_JPRB,&
&1.3394E-03_JPRB,9.1353E-04_JPRB,7.0438E-04_JPRB/)
KAO( :, 2, 5, 8) = (/&
&2.5687E-03_JPRB,2.7468E-03_JPRB,2.7774E-03_JPRB,2.7346E-03_JPRB,2.6141E-03_JPRB,2.4178E-03_JPRB,&
&2.0843E-03_JPRB,1.3471E-03_JPRB,9.9854E-04_JPRB/)
KAO( :, 3, 5, 8) = (/&
&3.2454E-03_JPRB,3.5226E-03_JPRB,3.5942E-03_JPRB,3.5589E-03_JPRB,3.4246E-03_JPRB,3.2139E-03_JPRB,&
&2.8968E-03_JPRB,2.2808E-03_JPRB,1.3756E-03_JPRB/)
KAO( :, 4, 5, 8) = (/&
&4.0078E-03_JPRB,4.4135E-03_JPRB,4.5464E-03_JPRB,4.5227E-03_JPRB,4.3801E-03_JPRB,4.1565E-03_JPRB,&
&3.8227E-03_JPRB,3.4129E-03_JPRB,1.8460E-03_JPRB/)
KAO( :, 5, 5, 8) = (/&
&4.8571E-03_JPRB,5.4208E-03_JPRB,5.6379E-03_JPRB,5.6316E-03_JPRB,5.4908E-03_JPRB,5.2408E-03_JPRB,&
&4.8842E-03_JPRB,4.5932E-03_JPRB,2.4240E-03_JPRB/)
KAO( :, 1, 6, 8) = (/&
&1.4751E-03_JPRB,1.5649E-03_JPRB,1.5698E-03_JPRB,1.5250E-03_JPRB,1.4367E-03_JPRB,1.2692E-03_JPRB,&
&9.2432E-04_JPRB,6.8601E-04_JPRB,5.0937E-04_JPRB/)
KAO( :, 2, 6, 8) = (/&
&1.9613E-03_JPRB,2.1071E-03_JPRB,2.1348E-03_JPRB,2.0943E-03_JPRB,1.9976E-03_JPRB,1.8330E-03_JPRB,&
&1.5334E-03_JPRB,9.4512E-04_JPRB,7.0634E-04_JPRB/)
KAO( :, 3, 6, 8) = (/&
&2.5283E-03_JPRB,2.7572E-03_JPRB,2.8184E-03_JPRB,2.7830E-03_JPRB,2.6756E-03_JPRB,2.5003E-03_JPRB,&
&2.2237E-03_JPRB,1.6320E-03_JPRB,9.7275E-04_JPRB/)
KAO( :, 4, 6, 8) = (/&
&3.1771E-03_JPRB,3.5120E-03_JPRB,3.6225E-03_JPRB,3.5959E-03_JPRB,3.4819E-03_JPRB,3.2887E-03_JPRB,&
&3.0155E-03_JPRB,2.5468E-03_JPRB,1.3152E-03_JPRB/)
KAO( :, 5, 6, 8) = (/&
&3.9082E-03_JPRB,4.3796E-03_JPRB,4.5491E-03_JPRB,4.5475E-03_JPRB,4.4280E-03_JPRB,4.2073E-03_JPRB,&
&3.9106E-03_JPRB,3.5240E-03_JPRB,1.7410E-03_JPRB/)
KAO( :, 1, 7, 8) = (/&
&1.0756E-03_JPRB,1.1457E-03_JPRB,1.1474E-03_JPRB,1.1092E-03_JPRB,1.0328E-03_JPRB,8.8328E-04_JPRB,&
&6.4847E-04_JPRB,4.9589E-04_JPRB,5.7093E-04_JPRB/)
KAO( :, 2, 7, 8) = (/&
&1.4649E-03_JPRB,1.5820E-03_JPRB,1.5990E-03_JPRB,1.5629E-03_JPRB,1.4809E-03_JPRB,1.3423E-03_JPRB,&
&1.0733E-03_JPRB,6.5945E-04_JPRB,6.7059E-04_JPRB/)
KAO( :, 3, 7, 8) = (/&
&1.9283E-03_JPRB,2.1130E-03_JPRB,2.1564E-03_JPRB,2.1214E-03_JPRB,2.0320E-03_JPRB,1.8875E-03_JPRB,&
&1.6475E-03_JPRB,1.0998E-03_JPRB,8.2028E-04_JPRB/)
KAO( :, 4, 7, 8) = (/&
&2.4693E-03_JPRB,2.7409E-03_JPRB,2.8220E-03_JPRB,2.7928E-03_JPRB,2.6936E-03_JPRB,2.5390E-03_JPRB,&
&2.3115E-03_JPRB,1.8751E-03_JPRB,1.0332E-03_JPRB/)
KAO( :, 5, 7, 8) = (/&
&3.0886E-03_JPRB,3.4749E-03_JPRB,3.5989E-03_JPRB,3.5853E-03_JPRB,3.4794E-03_JPRB,3.3014E-03_JPRB,&
&3.0555E-03_JPRB,2.6855E-03_JPRB,1.3202E-03_JPRB/)
KAO( :, 1, 8, 8) = (/&
&7.7013E-04_JPRB,8.2269E-04_JPRB,8.2096E-04_JPRB,7.8766E-04_JPRB,7.2051E-04_JPRB,5.9734E-04_JPRB,&
&4.5221E-04_JPRB,3.6815E-04_JPRB,1.2465E-03_JPRB/)
KAO( :, 2, 8, 8) = (/&
&1.0761E-03_JPRB,1.1666E-03_JPRB,1.1753E-03_JPRB,1.1418E-03_JPRB,1.0747E-03_JPRB,9.5486E-04_JPRB,&
&7.2722E-04_JPRB,4.9024E-04_JPRB,1.3265E-03_JPRB/)
KAO( :, 3, 8, 8) = (/&
&1.4486E-03_JPRB,1.5933E-03_JPRB,1.6206E-03_JPRB,1.5872E-03_JPRB,1.5112E-03_JPRB,1.3931E-03_JPRB,&
&1.1791E-03_JPRB,7.7032E-04_JPRB,1.4183E-03_JPRB/)
KAO( :, 4, 8, 8) = (/&
&1.8914E-03_JPRB,2.1096E-03_JPRB,2.1595E-03_JPRB,2.1285E-03_JPRB,2.0449E-03_JPRB,1.9150E-03_JPRB,&
&1.7248E-03_JPRB,1.3234E-03_JPRB,1.5297E-03_JPRB/)
KAO( :, 5, 8, 8) = (/&
&2.4078E-03_JPRB,2.7196E-03_JPRB,2.8008E-03_JPRB,2.7757E-03_JPRB,2.6827E-03_JPRB,2.5404E-03_JPRB,&
&2.3451E-03_JPRB,2.0264E-03_JPRB,1.6770E-03_JPRB/)
KAO( :, 1, 9, 8) = (/&
&5.4062E-04_JPRB,5.7894E-04_JPRB,5.7406E-04_JPRB,5.4447E-04_JPRB,4.8698E-04_JPRB,3.9028E-04_JPRB,&
&3.0735E-04_JPRB,2.8186E-04_JPRB,6.3377E-03_JPRB/)
KAO( :, 2, 9, 8) = (/&
&7.7655E-04_JPRB,8.4391E-04_JPRB,8.4599E-04_JPRB,8.1629E-04_JPRB,7.6016E-04_JPRB,6.5450E-04_JPRB,&
&4.7980E-04_JPRB,3.6416E-04_JPRB,6.4305E-03_JPRB/)
KAO( :, 3, 9, 8) = (/&
&1.0705E-03_JPRB,1.1799E-03_JPRB,1.1936E-03_JPRB,1.1638E-03_JPRB,1.1017E-03_JPRB,1.0023E-03_JPRB,&
&8.1517E-04_JPRB,5.4679E-04_JPRB,6.5495E-03_JPRB/)
KAO( :, 4, 9, 8) = (/&
&1.4270E-03_JPRB,1.5951E-03_JPRB,1.6232E-03_JPRB,1.5910E-03_JPRB,1.5219E-03_JPRB,1.4168E-03_JPRB,&
&1.2519E-03_JPRB,8.7875E-04_JPRB,6.6729E-03_JPRB/)
KAO( :, 5, 9, 8) = (/&
&1.8505E-03_JPRB,2.0950E-03_JPRB,2.1415E-03_JPRB,2.1108E-03_JPRB,2.0308E-03_JPRB,1.9153E-03_JPRB,&
&1.7561E-03_JPRB,1.4678E-03_JPRB,6.8190E-03_JPRB/)
KAO( :, 1,10, 8) = (/&
&3.8585E-04_JPRB,4.1375E-04_JPRB,4.0806E-04_JPRB,3.8295E-04_JPRB,3.3374E-04_JPRB,2.6302E-04_JPRB,&
&2.1519E-04_JPRB,2.1943E-04_JPRB,4.4307E-02_JPRB/)
KAO( :, 2,10, 8) = (/&
&5.6783E-04_JPRB,6.1776E-04_JPRB,6.1659E-04_JPRB,5.9118E-04_JPRB,5.4276E-04_JPRB,4.5386E-04_JPRB,&
&3.3714E-04_JPRB,2.8172E-04_JPRB,4.4039E-02_JPRB/)
KAO( :, 3,10, 8) = (/&
&7.9994E-04_JPRB,8.8269E-04_JPRB,8.8820E-04_JPRB,8.6201E-04_JPRB,8.1182E-04_JPRB,7.2562E-04_JPRB,&
&5.6386E-04_JPRB,3.8153E-04_JPRB,4.3887E-02_JPRB/)
KAO( :, 4,10, 8) = (/&
&1.0873E-03_JPRB,1.2167E-03_JPRB,1.2305E-03_JPRB,1.2016E-03_JPRB,1.1439E-03_JPRB,1.0569E-03_JPRB,&
&9.1489E-04_JPRB,6.0012E-04_JPRB,4.3695E-02_JPRB/)
KAO( :, 5,10, 8) = (/&
&1.4329E-03_JPRB,1.6260E-03_JPRB,1.6511E-03_JPRB,1.6186E-03_JPRB,1.5509E-03_JPRB,1.4549E-03_JPRB,&
&1.3198E-03_JPRB,1.0619E-03_JPRB,4.3454E-02_JPRB/)
KAO( :, 1,11, 8) = (/&
&3.3331E-04_JPRB,3.5859E-04_JPRB,3.5347E-04_JPRB,3.3213E-04_JPRB,2.8916E-04_JPRB,2.2877E-04_JPRB,&
&1.7900E-04_JPRB,1.9967E-04_JPRB,1.0878E-01_JPRB/)
KAO( :, 2,11, 8) = (/&
&4.9047E-04_JPRB,5.3552E-04_JPRB,5.3381E-04_JPRB,5.1299E-04_JPRB,4.7115E-04_JPRB,3.9388E-04_JPRB,&
&2.9080E-04_JPRB,2.3623E-04_JPRB,1.0793E-01_JPRB/)
KAO( :, 3,11, 8) = (/&
&6.9278E-04_JPRB,7.6757E-04_JPRB,7.7025E-04_JPRB,7.4755E-04_JPRB,7.0442E-04_JPRB,6.3244E-04_JPRB,&
&4.9501E-04_JPRB,3.3029E-04_JPRB,1.0687E-01_JPRB/)
KAO( :, 4,11, 8) = (/&
&9.4454E-04_JPRB,1.0621E-03_JPRB,1.0699E-03_JPRB,1.0431E-03_JPRB,9.9167E-04_JPRB,9.1658E-04_JPRB,&
&7.9795E-04_JPRB,5.4407E-04_JPRB,1.0586E-01_JPRB/)
KAO( :, 5,11, 8) = (/&
&1.2469E-03_JPRB,1.4253E-03_JPRB,1.4411E-03_JPRB,1.4083E-03_JPRB,1.3458E-03_JPRB,1.2607E-03_JPRB,&
&1.1470E-03_JPRB,9.3092E-04_JPRB,1.0499E-01_JPRB/)
KAO( :, 1,12, 8) = (/&
&2.8868E-04_JPRB,3.1016E-04_JPRB,3.0546E-04_JPRB,2.8704E-04_JPRB,2.5147E-04_JPRB,1.9676E-04_JPRB,&
&1.5529E-04_JPRB,1.6943E-04_JPRB,1.6800E-01_JPRB/)
KAO( :, 2,12, 8) = (/&
&4.2419E-04_JPRB,4.6341E-04_JPRB,4.6115E-04_JPRB,4.4308E-04_JPRB,4.0808E-04_JPRB,3.4351E-04_JPRB,&
&2.4857E-04_JPRB,1.9580E-04_JPRB,1.6656E-01_JPRB/)
KAO( :, 3,12, 8) = (/&
&6.0023E-04_JPRB,6.6617E-04_JPRB,6.6650E-04_JPRB,6.4587E-04_JPRB,6.0783E-04_JPRB,5.4736E-04_JPRB,&
&4.3585E-04_JPRB,2.8774E-04_JPRB,1.6485E-01_JPRB/)
KAO( :, 4,12, 8) = (/&
&8.1906E-04_JPRB,9.2524E-04_JPRB,9.2921E-04_JPRB,9.0286E-04_JPRB,8.5627E-04_JPRB,7.9080E-04_JPRB,&
&6.9052E-04_JPRB,4.8039E-04_JPRB,1.6324E-01_JPRB/)
KAO( :, 5,12, 8) = (/&
&1.0839E-03_JPRB,1.2432E-03_JPRB,1.2546E-03_JPRB,1.2224E-03_JPRB,1.1638E-03_JPRB,1.0874E-03_JPRB,&
&9.8876E-04_JPRB,8.1388E-04_JPRB,1.6195E-01_JPRB/)
KAO( :, 1,13, 8) = (/&
&2.5312E-04_JPRB,2.6982E-04_JPRB,2.6458E-04_JPRB,2.4857E-04_JPRB,2.1806E-04_JPRB,1.7081E-04_JPRB,&
&1.3117E-04_JPRB,1.3895E-04_JPRB,2.0739E-01_JPRB/)
KAO( :, 2,13, 8) = (/&
&3.6904E-04_JPRB,4.0143E-04_JPRB,3.9817E-04_JPRB,3.8186E-04_JPRB,3.5137E-04_JPRB,2.9757E-04_JPRB,&
&2.1658E-04_JPRB,1.6379E-04_JPRB,2.0586E-01_JPRB/)
KAO( :, 3,13, 8) = (/&
&5.2080E-04_JPRB,5.7811E-04_JPRB,5.7661E-04_JPRB,5.5693E-04_JPRB,5.2224E-04_JPRB,4.6985E-04_JPRB,&
&3.7580E-04_JPRB,2.4807E-04_JPRB,2.0409E-01_JPRB/)
KAO( :, 4,13, 8) = (/&
&7.1123E-04_JPRB,8.0344E-04_JPRB,8.0567E-04_JPRB,7.8029E-04_JPRB,7.3718E-04_JPRB,6.7848E-04_JPRB,&
&5.9304E-04_JPRB,4.2232E-04_JPRB,2.0245E-01_JPRB/)
KAO( :, 5,13, 8) = (/&
&9.4485E-04_JPRB,1.0811E-03_JPRB,1.0875E-03_JPRB,1.0578E-03_JPRB,1.0044E-03_JPRB,9.3443E-04_JPRB,&
&8.4723E-04_JPRB,7.0315E-04_JPRB,2.0129E-01_JPRB/)
KAO( :, 1, 1, 9) = (/&
&1.0292E-02_JPRB,1.0074E-02_JPRB,1.0433E-02_JPRB,1.0920E-02_JPRB,1.1239E-02_JPRB,1.1304E-02_JPRB,&
&1.1018E-02_JPRB,9.9412E-03_JPRB,1.0267E-02_JPRB/)
KAO( :, 2, 1, 9) = (/&
&1.2495E-02_JPRB,1.2453E-02_JPRB,1.3049E-02_JPRB,1.3792E-02_JPRB,1.4278E-02_JPRB,1.4496E-02_JPRB,&
&1.4236E-02_JPRB,1.3361E-02_JPRB,1.3925E-02_JPRB/)
KAO( :, 3, 1, 9) = (/&
&1.4859E-02_JPRB,1.5091E-02_JPRB,1.6017E-02_JPRB,1.7045E-02_JPRB,1.7806E-02_JPRB,1.8195E-02_JPRB,&
&1.7952E-02_JPRB,1.7365E-02_JPRB,1.8464E-02_JPRB/)
KAO( :, 4, 1, 9) = (/&
&1.7363E-02_JPRB,1.7942E-02_JPRB,1.9281E-02_JPRB,2.0718E-02_JPRB,2.1801E-02_JPRB,2.2424E-02_JPRB,&
&2.2300E-02_JPRB,2.2092E-02_JPRB,2.3948E-02_JPRB/)
KAO( :, 5, 1, 9) = (/&
&1.9984E-02_JPRB,2.1018E-02_JPRB,2.2868E-02_JPRB,2.4808E-02_JPRB,2.6324E-02_JPRB,2.7242E-02_JPRB,&
&2.7276E-02_JPRB,2.7701E-02_JPRB,3.0488E-02_JPRB/)
KAO( :, 1, 2, 9) = (/&
&9.5128E-03_JPRB,9.2867E-03_JPRB,9.5490E-03_JPRB,9.8633E-03_JPRB,1.0027E-02_JPRB,1.0058E-02_JPRB,&
&9.7636E-03_JPRB,8.7994E-03_JPRB,8.5570E-03_JPRB/)
KAO( :, 2, 2, 9) = (/&
&1.1668E-02_JPRB,1.1584E-02_JPRB,1.2077E-02_JPRB,1.2559E-02_JPRB,1.2920E-02_JPRB,1.3060E-02_JPRB,&
&1.2825E-02_JPRB,1.1983E-02_JPRB,1.1751E-02_JPRB/)
KAO( :, 3, 2, 9) = (/&
&1.4011E-02_JPRB,1.4151E-02_JPRB,1.4940E-02_JPRB,1.5660E-02_JPRB,1.6284E-02_JPRB,1.6579E-02_JPRB,&
&1.6367E-02_JPRB,1.5804E-02_JPRB,1.5742E-02_JPRB/)
KAO( :, 4, 2, 9) = (/&
&1.6508E-02_JPRB,1.6961E-02_JPRB,1.8102E-02_JPRB,1.9197E-02_JPRB,2.0137E-02_JPRB,2.0668E-02_JPRB,&
&2.0505E-02_JPRB,2.0318E-02_JPRB,2.0610E-02_JPRB/)
KAO( :, 5, 2, 9) = (/&
&1.9122E-02_JPRB,2.0006E-02_JPRB,2.1590E-02_JPRB,2.3174E-02_JPRB,2.4520E-02_JPRB,2.5288E-02_JPRB,&
&2.5261E-02_JPRB,2.5631E-02_JPRB,2.6467E-02_JPRB/)
KAO( :, 1, 3, 9) = (/&
&8.4316E-03_JPRB,8.1842E-03_JPRB,8.3414E-03_JPRB,8.4601E-03_JPRB,8.4527E-03_JPRB,8.3467E-03_JPRB,&
&8.0420E-03_JPRB,7.1142E-03_JPRB,6.5461E-03_JPRB/)
KAO( :, 2, 3, 9) = (/&
&1.0508E-02_JPRB,1.0365E-02_JPRB,1.0700E-02_JPRB,1.0941E-02_JPRB,1.1049E-02_JPRB,1.1031E-02_JPRB,&
&1.0751E-02_JPRB,9.9386E-03_JPRB,9.1449E-03_JPRB/)
KAO( :, 3, 3, 9) = (/&
&1.2785E-02_JPRB,1.2829E-02_JPRB,1.3389E-02_JPRB,1.3825E-02_JPRB,1.4105E-02_JPRB,1.4232E-02_JPRB,&
&1.3991E-02_JPRB,1.3420E-02_JPRB,1.2428E-02_JPRB/)
KAO( :, 4, 3, 9) = (/&
&1.5245E-02_JPRB,1.5545E-02_JPRB,1.6390E-02_JPRB,1.7132E-02_JPRB,1.7666E-02_JPRB,1.7977E-02_JPRB,&
&1.7716E-02_JPRB,1.7486E-02_JPRB,1.6472E-02_JPRB/)
KAO( :, 5, 3, 9) = (/&
&1.7859E-02_JPRB,1.8505E-02_JPRB,1.9736E-02_JPRB,2.0852E-02_JPRB,2.1757E-02_JPRB,2.2224E-02_JPRB,&
&2.2056E-02_JPRB,2.2280E-02_JPRB,2.1403E-02_JPRB/)
KAO( :, 1, 4, 9) = (/&
&7.3484E-03_JPRB,7.0902E-03_JPRB,7.1380E-03_JPRB,7.1024E-03_JPRB,6.9776E-03_JPRB,6.7400E-03_JPRB,&
&6.3521E-03_JPRB,5.4673E-03_JPRB,4.8295E-03_JPRB/)
KAO( :, 2, 4, 9) = (/&
&9.3310E-03_JPRB,9.1397E-03_JPRB,9.3159E-03_JPRB,9.3538E-03_JPRB,9.2681E-03_JPRB,9.0554E-03_JPRB,&
&8.7344E-03_JPRB,7.9076E-03_JPRB,6.8828E-03_JPRB/)
KAO( :, 3, 4, 9) = (/&
&1.1534E-02_JPRB,1.1475E-02_JPRB,1.1819E-02_JPRB,1.1988E-02_JPRB,1.2000E-02_JPRB,1.1864E-02_JPRB,&
&1.1575E-02_JPRB,1.0994E-02_JPRB,9.4901E-03_JPRB/)
KAO( :, 4, 4, 9) = (/&
&1.3943E-02_JPRB,1.4087E-02_JPRB,1.4649E-02_JPRB,1.5032E-02_JPRB,1.5214E-02_JPRB,1.5176E-02_JPRB,&
&1.4865E-02_JPRB,1.4524E-02_JPRB,1.2777E-02_JPRB/)
KAO( :, 5, 4, 9) = (/&
&1.6517E-02_JPRB,1.6976E-02_JPRB,1.7827E-02_JPRB,1.8519E-02_JPRB,1.8920E-02_JPRB,1.9000E-02_JPRB,&
&1.8720E-02_JPRB,1.8746E-02_JPRB,1.6804E-02_JPRB/)
KAO( :, 1, 5, 9) = (/&
&6.3624E-03_JPRB,6.1133E-03_JPRB,6.0634E-03_JPRB,5.9330E-03_JPRB,5.7181E-03_JPRB,5.4022E-03_JPRB,&
&4.9483E-03_JPRB,4.1022E-03_JPRB,3.4892E-03_JPRB/)
KAO( :, 2, 5, 9) = (/&
&8.2407E-03_JPRB,8.0303E-03_JPRB,8.0632E-03_JPRB,7.9504E-03_JPRB,7.7253E-03_JPRB,7.3962E-03_JPRB,&
&6.9698E-03_JPRB,6.1767E-03_JPRB,5.0748E-03_JPRB/)
KAO( :, 3, 5, 9) = (/&
&1.0363E-02_JPRB,1.0246E-02_JPRB,1.0387E-02_JPRB,1.0335E-02_JPRB,1.0149E-02_JPRB,9.8386E-03_JPRB,&
&9.4225E-03_JPRB,8.8118E-03_JPRB,7.1402E-03_JPRB/)
KAO( :, 4, 5, 9) = (/&
&1.2695E-02_JPRB,1.2755E-02_JPRB,1.3046E-02_JPRB,1.3138E-02_JPRB,1.3029E-02_JPRB,1.2750E-02_JPRB,&
&1.2327E-02_JPRB,1.1882E-02_JPRB,9.7414E-03_JPRB/)
KAO( :, 5, 5, 9) = (/&
&1.5221E-02_JPRB,1.5544E-02_JPRB,1.6067E-02_JPRB,1.6367E-02_JPRB,1.6363E-02_JPRB,1.6145E-02_JPRB,&
&1.5702E-02_JPRB,1.5530E-02_JPRB,1.2966E-02_JPRB/)
KAO( :, 1, 6, 9) = (/&
&5.3819E-03_JPRB,5.1682E-03_JPRB,5.0489E-03_JPRB,4.8682E-03_JPRB,4.6033E-03_JPRB,4.2570E-03_JPRB,&
&3.7892E-03_JPRB,2.8608E-03_JPRB,2.4512E-03_JPRB/)
KAO( :, 2, 6, 9) = (/&
&7.1280E-03_JPRB,6.9367E-03_JPRB,6.8489E-03_JPRB,6.6487E-03_JPRB,6.3384E-03_JPRB,5.9570E-03_JPRB,&
&5.4784E-03_JPRB,4.6646E-03_JPRB,3.6355E-03_JPRB/)
KAO( :, 3, 6, 9) = (/&
&9.1302E-03_JPRB,9.0145E-03_JPRB,8.9822E-03_JPRB,8.7868E-03_JPRB,8.4616E-03_JPRB,8.0561E-03_JPRB,&
&7.5662E-03_JPRB,6.8605E-03_JPRB,5.2018E-03_JPRB/)
KAO( :, 4, 6, 9) = (/&
&1.1358E-02_JPRB,1.1388E-02_JPRB,1.1456E-02_JPRB,1.1318E-02_JPRB,1.1012E-02_JPRB,1.0595E-02_JPRB,&
&1.0058E-02_JPRB,9.4902E-03_JPRB,7.2223E-03_JPRB/)
KAO( :, 5, 6, 9) = (/&
&1.3798E-02_JPRB,1.4041E-02_JPRB,1.4287E-02_JPRB,1.4257E-02_JPRB,1.3997E-02_JPRB,1.3586E-02_JPRB,&
&1.2991E-02_JPRB,1.2596E-02_JPRB,9.7278E-03_JPRB/)
KAO( :, 1, 7, 9) = (/&
&4.4201E-03_JPRB,4.2655E-03_JPRB,4.1450E-03_JPRB,3.9476E-03_JPRB,3.6722E-03_JPRB,3.3249E-03_JPRB,&
&2.8458E-03_JPRB,1.9671E-03_JPRB,1.7803E-03_JPRB/)
KAO( :, 2, 7, 9) = (/&
&5.9991E-03_JPRB,5.8588E-03_JPRB,5.7556E-03_JPRB,5.5028E-03_JPRB,5.1661E-03_JPRB,4.7702E-03_JPRB,&
&4.2756E-03_JPRB,3.4608E-03_JPRB,2.6084E-03_JPRB/)
KAO( :, 3, 7, 9) = (/&
&7.8395E-03_JPRB,7.7643E-03_JPRB,7.6944E-03_JPRB,7.4017E-03_JPRB,7.0170E-03_JPRB,6.5646E-03_JPRB,&
&6.0423E-03_JPRB,5.2630E-03_JPRB,3.7628E-03_JPRB/)
KAO( :, 4, 7, 9) = (/&
&9.9189E-03_JPRB,9.9815E-03_JPRB,9.9658E-03_JPRB,9.6723E-03_JPRB,9.2685E-03_JPRB,8.7611E-03_JPRB,&
&8.1722E-03_JPRB,7.4723E-03_JPRB,5.2872E-03_JPRB/)
KAO( :, 5, 7, 9) = (/&
&1.2224E-02_JPRB,1.2487E-02_JPRB,1.2587E-02_JPRB,1.2338E-02_JPRB,1.1918E-02_JPRB,1.1379E-02_JPRB,&
&1.0715E-02_JPRB,1.0101E-02_JPRB,7.2253E-03_JPRB/)
KAO( :, 1, 8, 9) = (/&
&3.5350E-03_JPRB,3.4325E-03_JPRB,3.3275E-03_JPRB,3.1605E-03_JPRB,2.8988E-03_JPRB,2.5686E-03_JPRB,&
&2.1091E-03_JPRB,1.2955E-03_JPRB,2.2677E-03_JPRB/)
KAO( :, 2, 8, 9) = (/&
&4.9245E-03_JPRB,4.8341E-03_JPRB,4.7376E-03_JPRB,4.5164E-03_JPRB,4.1844E-03_JPRB,3.7894E-03_JPRB,&
&3.3070E-03_JPRB,2.4762E-03_JPRB,2.6602E-03_JPRB/)
KAO( :, 3, 8, 9) = (/&
&6.5727E-03_JPRB,6.5413E-03_JPRB,6.4715E-03_JPRB,6.1921E-03_JPRB,5.7948E-03_JPRB,5.3290E-03_JPRB,&
&4.7963E-03_JPRB,4.0123E-03_JPRB,3.3053E-03_JPRB/)
KAO( :, 4, 8, 9) = (/&
&8.4673E-03_JPRB,8.5585E-03_JPRB,8.5340E-03_JPRB,8.2251E-03_JPRB,7.7660E-03_JPRB,7.2331E-03_JPRB,&
&6.6181E-03_JPRB,5.8537E-03_JPRB,4.2835E-03_JPRB/)
KAO( :, 5, 8, 9) = (/&
&1.0594E-02_JPRB,1.0877E-02_JPRB,1.0934E-02_JPRB,1.0630E-02_JPRB,1.0118E-02_JPRB,9.5083E-03_JPRB,&
&8.7956E-03_JPRB,8.0306E-03_JPRB,5.6393E-03_JPRB/)
KAO( :, 1, 9, 9) = (/&
&2.7403E-03_JPRB,2.6787E-03_JPRB,2.5973E-03_JPRB,2.4570E-03_JPRB,2.2443E-03_JPRB,1.9562E-03_JPRB,&
&1.5185E-03_JPRB,8.3616E-04_JPRB,1.0274E-02_JPRB/)
KAO( :, 2, 9, 9) = (/&
&3.9274E-03_JPRB,3.8796E-03_JPRB,3.7992E-03_JPRB,3.6140E-03_JPRB,3.3367E-03_JPRB,2.9763E-03_JPRB,&
&2.5173E-03_JPRB,1.7223E-03_JPRB,1.0390E-02_JPRB/)
KAO( :, 3, 9, 9) = (/&
&5.3634E-03_JPRB,5.3721E-03_JPRB,5.3082E-03_JPRB,5.0709E-03_JPRB,4.7250E-03_JPRB,4.2829E-03_JPRB,&
&3.7573E-03_JPRB,2.9940E-03_JPRB,1.0638E-02_JPRB/)
KAO( :, 4, 9, 9) = (/&
&7.0458E-03_JPRB,7.1640E-03_JPRB,7.1301E-03_JPRB,6.8617E-03_JPRB,6.4511E-03_JPRB,5.9118E-03_JPRB,&
&5.2974E-03_JPRB,4.5531E-03_JPRB,1.1091E-02_JPRB/)
KAO( :, 5, 9, 9) = (/&
&8.9617E-03_JPRB,9.2589E-03_JPRB,9.2849E-03_JPRB,9.0088E-03_JPRB,8.5345E-03_JPRB,7.8845E-03_JPRB,&
&7.1544E-03_JPRB,6.3553E-03_JPRB,1.1709E-02_JPRB/)
KAO( :, 1,10, 9) = (/&
&2.1319E-03_JPRB,2.1004E-03_JPRB,2.0372E-03_JPRB,1.9210E-03_JPRB,1.7497E-03_JPRB,1.5111E-03_JPRB,&
&1.1301E-03_JPRB,5.5756E-04_JPRB,7.5283E-02_JPRB/)
KAO( :, 2,10, 9) = (/&
&3.1363E-03_JPRB,3.1212E-03_JPRB,3.0574E-03_JPRB,2.9015E-03_JPRB,2.6722E-03_JPRB,2.3756E-03_JPRB,&
&1.9576E-03_JPRB,1.2195E-03_JPRB,7.4064E-02_JPRB/)
KAO( :, 3,10, 9) = (/&
&4.3731E-03_JPRB,4.4117E-03_JPRB,4.3602E-03_JPRB,4.1608E-03_JPRB,3.8669E-03_JPRB,3.4927E-03_JPRB,&
&3.0050E-03_JPRB,2.2902E-03_JPRB,7.3035E-02_JPRB/)
KAO( :, 4,10, 9) = (/&
&5.8455E-03_JPRB,5.9881E-03_JPRB,5.9565E-03_JPRB,5.7270E-03_JPRB,5.3754E-03_JPRB,4.9035E-03_JPRB,&
&4.3124E-03_JPRB,3.6091E-03_JPRB,7.2537E-02_JPRB/)
KAO( :, 5,10, 9) = (/&
&7.5468E-03_JPRB,7.8566E-03_JPRB,7.8695E-03_JPRB,7.6289E-03_JPRB,7.2133E-03_JPRB,6.6234E-03_JPRB,&
&5.9025E-03_JPRB,5.1322E-03_JPRB,7.2257E-02_JPRB/)
KAO( :, 1,11, 9) = (/&
&1.9745E-03_JPRB,1.9703E-03_JPRB,1.9199E-03_JPRB,1.8121E-03_JPRB,1.6559E-03_JPRB,1.4431E-03_JPRB,&
&1.1163E-03_JPRB,5.3500E-04_JPRB,1.9757E-01_JPRB/)
KAO( :, 2,11, 9) = (/&
&2.8999E-03_JPRB,2.9279E-03_JPRB,2.8819E-03_JPRB,2.7350E-03_JPRB,2.5277E-03_JPRB,2.2543E-03_JPRB,&
&1.8746E-03_JPRB,1.2124E-03_JPRB,1.9384E-01_JPRB/)
KAO( :, 3,11, 9) = (/&
&4.0444E-03_JPRB,4.1420E-03_JPRB,4.1037E-03_JPRB,3.9240E-03_JPRB,3.6578E-03_JPRB,3.3096E-03_JPRB,&
&2.8567E-03_JPRB,2.1998E-03_JPRB,1.9071E-01_JPRB/)
KAO( :, 4,11, 9) = (/&
&5.4085E-03_JPRB,5.6287E-03_JPRB,5.6077E-03_JPRB,5.4059E-03_JPRB,5.0834E-03_JPRB,4.6413E-03_JPRB,&
&4.0709E-03_JPRB,3.3776E-03_JPRB,1.8809E-01_JPRB/)
KAO( :, 5,11, 9) = (/&
&6.9941E-03_JPRB,7.3880E-03_JPRB,7.4108E-03_JPRB,7.2046E-03_JPRB,6.8126E-03_JPRB,6.2573E-03_JPRB,&
&5.5477E-03_JPRB,4.7861E-03_JPRB,1.8600E-01_JPRB/)
KAO( :, 1,12, 9) = (/&
&1.7996E-03_JPRB,1.8206E-03_JPRB,1.7805E-03_JPRB,1.6829E-03_JPRB,1.5433E-03_JPRB,1.3501E-03_JPRB,&
&1.0572E-03_JPRB,5.4808E-04_JPRB,3.2846E-01_JPRB/)
KAO( :, 2,12, 9) = (/&
&2.6426E-03_JPRB,2.7068E-03_JPRB,2.6687E-03_JPRB,2.5393E-03_JPRB,2.3520E-03_JPRB,2.1038E-03_JPRB,&
&1.7678E-03_JPRB,1.1889E-03_JPRB,3.2273E-01_JPRB/)
KAO( :, 3,12, 9) = (/&
&3.6853E-03_JPRB,3.8343E-03_JPRB,3.8028E-03_JPRB,3.6418E-03_JPRB,3.4031E-03_JPRB,3.0855E-03_JPRB,&
&2.6713E-03_JPRB,2.0755E-03_JPRB,3.1779E-01_JPRB/)
KAO( :, 4,12, 9) = (/&
&4.9356E-03_JPRB,5.2142E-03_JPRB,5.1981E-03_JPRB,5.0221E-03_JPRB,4.7252E-03_JPRB,4.3142E-03_JPRB,&
&3.7960E-03_JPRB,3.1444E-03_JPRB,3.1325E-01_JPRB/)
KAO( :, 5,12, 9) = (/&
&6.3947E-03_JPRB,6.8520E-03_JPRB,6.8760E-03_JPRB,6.6872E-03_JPRB,6.3222E-03_JPRB,5.8083E-03_JPRB,&
&5.1616E-03_JPRB,4.4214E-03_JPRB,3.0903E-01_JPRB/)
KAO( :, 1,13, 9) = (/&
&1.6151E-03_JPRB,1.6567E-03_JPRB,1.6234E-03_JPRB,1.5373E-03_JPRB,1.4124E-03_JPRB,1.2394E-03_JPRB,&
&9.8564E-04_JPRB,5.5616E-04_JPRB,4.3871E-01_JPRB/)
KAO( :, 2,13, 9) = (/&
&2.3710E-03_JPRB,2.4678E-03_JPRB,2.4327E-03_JPRB,2.3183E-03_JPRB,2.1495E-03_JPRB,1.9302E-03_JPRB,&
&1.6336E-03_JPRB,1.1398E-03_JPRB,4.3206E-01_JPRB/)
KAO( :, 3,13, 9) = (/&
&3.3121E-03_JPRB,3.4978E-03_JPRB,3.4669E-03_JPRB,3.3267E-03_JPRB,3.1113E-03_JPRB,2.8243E-03_JPRB,&
&2.4585E-03_JPRB,1.9402E-03_JPRB,4.2585E-01_JPRB/)
KAO( :, 4,13, 9) = (/&
&4.4457E-03_JPRB,4.7587E-03_JPRB,4.7468E-03_JPRB,4.5875E-03_JPRB,4.3110E-03_JPRB,3.9394E-03_JPRB,&
&3.4774E-03_JPRB,2.8993E-03_JPRB,4.1993E-01_JPRB/)
KAO( :, 5,13, 9) = (/&
&5.7689E-03_JPRB,6.2589E-03_JPRB,6.2951E-03_JPRB,6.1057E-03_JPRB,5.7619E-03_JPRB,5.2957E-03_JPRB,&
&4.7230E-03_JPRB,4.0528E-03_JPRB,4.1400E-01_JPRB/)
KAO( :, 1, 1,10) = (/&
&2.8341E-02_JPRB,2.4949E-02_JPRB,2.4794E-02_JPRB,2.3987E-02_JPRB,2.3812E-02_JPRB,2.2586E-02_JPRB,&
&2.0187E-02_JPRB,1.9376E-02_JPRB,2.5381E-02_JPRB/)
KAO( :, 2, 1,10) = (/&
&3.3991E-02_JPRB,3.0192E-02_JPRB,3.0574E-02_JPRB,3.0065E-02_JPRB,2.9840E-02_JPRB,2.8013E-02_JPRB,&
&2.5566E-02_JPRB,2.6044E-02_JPRB,3.3447E-02_JPRB/)
KAO( :, 3, 1,10) = (/&
&3.9910E-02_JPRB,3.6271E-02_JPRB,3.6774E-02_JPRB,3.6789E-02_JPRB,3.6160E-02_JPRB,3.4328E-02_JPRB,&
&3.2309E-02_JPRB,3.3900E-02_JPRB,4.2891E-02_JPRB/)
KAO( :, 4, 1,10) = (/&
&4.5950E-02_JPRB,4.3254E-02_JPRB,4.3515E-02_JPRB,4.3816E-02_JPRB,4.3274E-02_JPRB,4.0958E-02_JPRB,&
&3.9828E-02_JPRB,4.3039E-02_JPRB,5.4536E-02_JPRB/)
KAO( :, 5, 1,10) = (/&
&5.2074E-02_JPRB,5.0170E-02_JPRB,5.0735E-02_JPRB,5.1340E-02_JPRB,5.0699E-02_JPRB,4.7916E-02_JPRB,&
&4.9158E-02_JPRB,5.3574E-02_JPRB,6.8520E-02_JPRB/)
KAO( :, 1, 2,10) = (/&
&2.6184E-02_JPRB,2.3296E-02_JPRB,2.3226E-02_JPRB,2.2714E-02_JPRB,2.2514E-02_JPRB,2.1363E-02_JPRB,&
&1.9364E-02_JPRB,1.8250E-02_JPRB,2.2856E-02_JPRB/)
KAO( :, 2, 2,10) = (/&
&3.1743E-02_JPRB,2.8597E-02_JPRB,2.8854E-02_JPRB,2.8835E-02_JPRB,2.8199E-02_JPRB,2.7046E-02_JPRB,&
&2.4544E-02_JPRB,2.4456E-02_JPRB,3.0699E-02_JPRB/)
KAO( :, 3, 2,10) = (/&
&3.7600E-02_JPRB,3.4758E-02_JPRB,3.5112E-02_JPRB,3.5357E-02_JPRB,3.4504E-02_JPRB,3.3441E-02_JPRB,&
&3.1117E-02_JPRB,3.2055E-02_JPRB,4.0509E-02_JPRB/)
KAO( :, 4, 2,10) = (/&
&4.3772E-02_JPRB,4.1496E-02_JPRB,4.2012E-02_JPRB,4.2309E-02_JPRB,4.1696E-02_JPRB,3.9959E-02_JPRB,&
&3.8762E-02_JPRB,4.0415E-02_JPRB,5.2629E-02_JPRB/)
KAO( :, 5, 2,10) = (/&
&5.0069E-02_JPRB,4.8330E-02_JPRB,4.9427E-02_JPRB,4.9767E-02_JPRB,4.9310E-02_JPRB,4.7260E-02_JPRB,&
&4.8222E-02_JPRB,5.0586E-02_JPRB,6.6929E-02_JPRB/)
KAO( :, 1, 3,10) = (/&
&2.2843E-02_JPRB,2.0821E-02_JPRB,2.0350E-02_JPRB,2.0283E-02_JPRB,1.9897E-02_JPRB,1.9120E-02_JPRB,&
&1.7384E-02_JPRB,1.6170E-02_JPRB,1.8446E-02_JPRB/)
KAO( :, 2, 3,10) = (/&
&2.8199E-02_JPRB,2.6062E-02_JPRB,2.5776E-02_JPRB,2.5997E-02_JPRB,2.5440E-02_JPRB,2.4723E-02_JPRB,&
&2.2441E-02_JPRB,2.1717E-02_JPRB,2.5483E-02_JPRB/)
KAO( :, 3, 3,10) = (/&
&3.3953E-02_JPRB,3.1919E-02_JPRB,3.1941E-02_JPRB,3.2157E-02_JPRB,3.1747E-02_JPRB,3.0922E-02_JPRB,&
&2.8559E-02_JPRB,2.8709E-02_JPRB,3.4439E-02_JPRB/)
KAO( :, 4, 3,10) = (/&
&4.0002E-02_JPRB,3.8423E-02_JPRB,3.8902E-02_JPRB,3.8911E-02_JPRB,3.8820E-02_JPRB,3.7594E-02_JPRB,&
&3.6351E-02_JPRB,3.6718E-02_JPRB,4.5775E-02_JPRB/)
KAO( :, 5, 3,10) = (/&
&4.6219E-02_JPRB,4.5155E-02_JPRB,4.6197E-02_JPRB,4.6387E-02_JPRB,4.6153E-02_JPRB,4.5334E-02_JPRB,&
&4.5834E-02_JPRB,4.6534E-02_JPRB,5.9401E-02_JPRB/)
KAO( :, 1, 4,10) = (/&
&1.9312E-02_JPRB,1.7992E-02_JPRB,1.7480E-02_JPRB,1.7446E-02_JPRB,1.7111E-02_JPRB,1.6477E-02_JPRB,&
&1.5243E-02_JPRB,1.3399E-02_JPRB,1.4121E-02_JPRB/)
KAO( :, 2, 4,10) = (/&
&2.4344E-02_JPRB,2.2955E-02_JPRB,2.2617E-02_JPRB,2.2783E-02_JPRB,2.2496E-02_JPRB,2.1867E-02_JPRB,&
&1.9808E-02_JPRB,1.8936E-02_JPRB,1.9938E-02_JPRB/)
KAO( :, 3, 4,10) = (/&
&2.9801E-02_JPRB,2.8523E-02_JPRB,2.8566E-02_JPRB,2.8709E-02_JPRB,2.8682E-02_JPRB,2.7725E-02_JPRB,&
&2.5334E-02_JPRB,2.5284E-02_JPRB,2.7743E-02_JPRB/)
KAO( :, 4, 4,10) = (/&
&3.5620E-02_JPRB,3.4742E-02_JPRB,3.5299E-02_JPRB,3.5308E-02_JPRB,3.5457E-02_JPRB,3.4419E-02_JPRB,&
&3.2604E-02_JPRB,3.3013E-02_JPRB,3.7587E-02_JPRB/)
KAO( :, 5, 4,10) = (/&
&4.1887E-02_JPRB,4.1321E-02_JPRB,4.2274E-02_JPRB,4.2660E-02_JPRB,4.2937E-02_JPRB,4.2081E-02_JPRB,&
&4.1593E-02_JPRB,4.2622E-02_JPRB,4.9653E-02_JPRB/)
KAO( :, 1, 5,10) = (/&
&1.5962E-02_JPRB,1.5091E-02_JPRB,1.4926E-02_JPRB,1.4725E-02_JPRB,1.4471E-02_JPRB,1.4016E-02_JPRB,&
&1.2941E-02_JPRB,1.0781E-02_JPRB,1.0820E-02_JPRB/)
KAO( :, 2, 5,10) = (/&
&2.0561E-02_JPRB,1.9656E-02_JPRB,1.9606E-02_JPRB,1.9723E-02_JPRB,1.9597E-02_JPRB,1.8959E-02_JPRB,&
&1.7070E-02_JPRB,1.5994E-02_JPRB,1.5507E-02_JPRB/)
KAO( :, 3, 5,10) = (/&
&2.5675E-02_JPRB,2.4818E-02_JPRB,2.5196E-02_JPRB,2.5517E-02_JPRB,2.5439E-02_JPRB,2.4412E-02_JPRB,&
&2.1991E-02_JPRB,2.1552E-02_JPRB,2.1888E-02_JPRB/)
KAO( :, 4, 5,10) = (/&
&3.1284E-02_JPRB,3.0688E-02_JPRB,3.1452E-02_JPRB,3.1913E-02_JPRB,3.1938E-02_JPRB,3.0781E-02_JPRB,&
&2.8330E-02_JPRB,2.8796E-02_JPRB,3.0247E-02_JPRB/)
KAO( :, 5, 5,10) = (/&
&3.7244E-02_JPRB,3.7039E-02_JPRB,3.8113E-02_JPRB,3.9041E-02_JPRB,3.9409E-02_JPRB,3.8138E-02_JPRB,&
&3.6567E-02_JPRB,3.7730E-02_JPRB,4.0679E-02_JPRB/)
KAO( :, 1, 6,10) = (/&
&1.2975E-02_JPRB,1.2256E-02_JPRB,1.2340E-02_JPRB,1.2080E-02_JPRB,1.1895E-02_JPRB,1.1506E-02_JPRB,&
&1.0365E-02_JPRB,8.5383E-03_JPRB,8.0172E-03_JPRB/)
KAO( :, 2, 6,10) = (/&
&1.7187E-02_JPRB,1.6321E-02_JPRB,1.6561E-02_JPRB,1.6669E-02_JPRB,1.6611E-02_JPRB,1.5858E-02_JPRB,&
&1.4206E-02_JPRB,1.2638E-02_JPRB,1.1866E-02_JPRB/)
KAO( :, 3, 6,10) = (/&
&2.1950E-02_JPRB,2.1039E-02_JPRB,2.1721E-02_JPRB,2.2100E-02_JPRB,2.1989E-02_JPRB,2.0834E-02_JPRB,&
&1.8607E-02_JPRB,1.7648E-02_JPRB,1.7187E-02_JPRB/)
KAO( :, 4, 6,10) = (/&
&2.7221E-02_JPRB,2.6492E-02_JPRB,2.7582E-02_JPRB,2.8232E-02_JPRB,2.8034E-02_JPRB,2.6720E-02_JPRB,&
&2.4048E-02_JPRB,2.4099E-02_JPRB,2.3975E-02_JPRB/)
KAO( :, 5, 6,10) = (/&
&3.2966E-02_JPRB,3.2596E-02_JPRB,3.4013E-02_JPRB,3.5128E-02_JPRB,3.5174E-02_JPRB,3.3585E-02_JPRB,&
&3.0966E-02_JPRB,3.2147E-02_JPRB,3.2714E-02_JPRB/)
KAO( :, 1, 7,10) = (/&
&1.1003E-02_JPRB,1.0172E-02_JPRB,9.9689E-03_JPRB,9.7030E-03_JPRB,9.5816E-03_JPRB,9.1864E-03_JPRB,&
&8.3157E-03_JPRB,6.5477E-03_JPRB,5.8584E-03_JPRB/)
KAO( :, 2, 7,10) = (/&
&1.4954E-02_JPRB,1.3915E-02_JPRB,1.3705E-02_JPRB,1.3805E-02_JPRB,1.3711E-02_JPRB,1.2918E-02_JPRB,&
&1.1613E-02_JPRB,9.7524E-03_JPRB,8.8921E-03_JPRB/)
KAO( :, 3, 7,10) = (/&
&1.9525E-02_JPRB,1.8286E-02_JPRB,1.8359E-02_JPRB,1.8803E-02_JPRB,1.8505E-02_JPRB,1.7397E-02_JPRB,&
&1.5545E-02_JPRB,1.4074E-02_JPRB,1.3147E-02_JPRB/)
KAO( :, 4, 7,10) = (/&
&2.4765E-02_JPRB,2.3347E-02_JPRB,2.3852E-02_JPRB,2.4521E-02_JPRB,2.4046E-02_JPRB,2.2746E-02_JPRB,&
&2.0338E-02_JPRB,1.9593E-02_JPRB,1.8718E-02_JPRB/)
KAO( :, 5, 7,10) = (/&
&3.0444E-02_JPRB,2.9114E-02_JPRB,2.9981E-02_JPRB,3.1001E-02_JPRB,3.0659E-02_JPRB,2.9115E-02_JPRB,&
&2.6153E-02_JPRB,2.6663E-02_JPRB,2.5778E-02_JPRB/)
KAO( :, 1, 8,10) = (/&
&9.5903E-03_JPRB,8.7677E-03_JPRB,8.2751E-03_JPRB,7.7628E-03_JPRB,7.6194E-03_JPRB,7.2194E-03_JPRB,&
&6.4757E-03_JPRB,5.1626E-03_JPRB,4.5446E-03_JPRB/)
KAO( :, 2, 8,10) = (/&
&1.3386E-02_JPRB,1.2290E-02_JPRB,1.1661E-02_JPRB,1.1306E-02_JPRB,1.1055E-02_JPRB,1.0454E-02_JPRB,&
&9.3918E-03_JPRB,7.5740E-03_JPRB,6.6212E-03_JPRB/)
KAO( :, 3, 8,10) = (/&
&1.7895E-02_JPRB,1.6495E-02_JPRB,1.5871E-02_JPRB,1.5730E-02_JPRB,1.5237E-02_JPRB,1.4347E-02_JPRB,&
&1.2880E-02_JPRB,1.1121E-02_JPRB,9.9657E-03_JPRB/)
KAO( :, 4, 8,10) = (/&
&2.3088E-02_JPRB,2.1460E-02_JPRB,2.0931E-02_JPRB,2.0828E-02_JPRB,2.0243E-02_JPRB,1.9039E-02_JPRB,&
&1.7178E-02_JPRB,1.5707E-02_JPRB,1.4369E-02_JPRB/)
KAO( :, 5, 8,10) = (/&
&2.8768E-02_JPRB,2.7065E-02_JPRB,2.6736E-02_JPRB,2.6678E-02_JPRB,2.6248E-02_JPRB,2.4878E-02_JPRB,&
&2.2359E-02_JPRB,2.1798E-02_JPRB,1.9974E-02_JPRB/)
KAO( :, 1, 9,10) = (/&
&8.1489E-03_JPRB,7.4648E-03_JPRB,6.9804E-03_JPRB,6.4191E-03_JPRB,5.9636E-03_JPRB,5.4909E-03_JPRB,&
&4.8784E-03_JPRB,3.8347E-03_JPRB,1.5314E-02_JPRB/)
KAO( :, 2, 9,10) = (/&
&1.1712E-02_JPRB,1.0789E-02_JPRB,1.0109E-02_JPRB,9.4829E-03_JPRB,8.8584E-03_JPRB,8.2278E-03_JPRB,&
&7.3764E-03_JPRB,5.7877E-03_JPRB,1.6244E-02_JPRB/)
KAO( :, 3, 9,10) = (/&
&1.6046E-02_JPRB,1.4820E-02_JPRB,1.4055E-02_JPRB,1.3332E-02_JPRB,1.2456E-02_JPRB,1.1636E-02_JPRB,&
&1.0489E-02_JPRB,8.6873E-03_JPRB,1.7494E-02_JPRB/)
KAO( :, 4, 9,10) = (/&
&2.1066E-02_JPRB,1.9610E-02_JPRB,1.8931E-02_JPRB,1.7888E-02_JPRB,1.6756E-02_JPRB,1.5784E-02_JPRB,&
&1.4417E-02_JPRB,1.2557E-02_JPRB,1.9326E-02_JPRB/)
KAO( :, 5, 9,10) = (/&
&2.6667E-02_JPRB,2.5074E-02_JPRB,2.4522E-02_JPRB,2.3189E-02_JPRB,2.2008E-02_JPRB,2.0995E-02_JPRB,&
&1.9281E-02_JPRB,1.7791E-02_JPRB,2.1654E-02_JPRB/)
KAO( :, 1,10,10) = (/&
&6.9366E-03_JPRB,6.3789E-03_JPRB,5.9595E-03_JPRB,5.4852E-03_JPRB,4.9360E-03_JPRB,4.3201E-03_JPRB,&
&3.7060E-03_JPRB,2.8411E-03_JPRB,1.0865E-01_JPRB/)
KAO( :, 2,10,10) = (/&
&1.0236E-02_JPRB,9.4750E-03_JPRB,8.8501E-03_JPRB,8.3036E-03_JPRB,7.4880E-03_JPRB,6.6146E-03_JPRB,&
&5.8580E-03_JPRB,4.5793E-03_JPRB,1.0627E-01_JPRB/)
KAO( :, 3,10,10) = (/&
&1.4332E-02_JPRB,1.3324E-02_JPRB,1.2604E-02_JPRB,1.1845E-02_JPRB,1.0730E-02_JPRB,9.5741E-03_JPRB,&
&8.5876E-03_JPRB,7.0236E-03_JPRB,1.0490E-01_JPRB/)
KAO( :, 4,10,10) = (/&
&1.9120E-02_JPRB,1.7914E-02_JPRB,1.7311E-02_JPRB,1.6108E-02_JPRB,1.4592E-02_JPRB,1.3253E-02_JPRB,&
&1.2097E-02_JPRB,1.0165E-02_JPRB,1.0426E-01_JPRB/)
KAO( :, 5,10,10) = (/&
&2.4561E-02_JPRB,2.3221E-02_JPRB,2.2646E-02_JPRB,2.1122E-02_JPRB,1.9334E-02_JPRB,1.7961E-02_JPRB,&
&1.6559E-02_JPRB,1.4610E-02_JPRB,1.0510E-01_JPRB/)
KAO( :, 1,11,10) = (/&
&7.0237E-03_JPRB,6.5225E-03_JPRB,6.1043E-03_JPRB,5.6444E-03_JPRB,5.0633E-03_JPRB,4.3399E-03_JPRB,&
&3.5607E-03_JPRB,2.6850E-03_JPRB,2.8892E-01_JPRB/)
KAO( :, 2,11,10) = (/&
&1.0384E-02_JPRB,9.6831E-03_JPRB,9.0835E-03_JPRB,8.5192E-03_JPRB,7.6404E-03_JPRB,6.6528E-03_JPRB,&
&5.6514E-03_JPRB,4.5273E-03_JPRB,2.8169E-01_JPRB/)
KAO( :, 3,11,10) = (/&
&1.4456E-02_JPRB,1.3566E-02_JPRB,1.2997E-02_JPRB,1.2107E-02_JPRB,1.0901E-02_JPRB,9.5425E-03_JPRB,&
&8.2374E-03_JPRB,6.8400E-03_JPRB,2.7734E-01_JPRB/)
KAO( :, 4,11,10) = (/&
&1.9195E-02_JPRB,1.8156E-02_JPRB,1.7656E-02_JPRB,1.6419E-02_JPRB,1.4881E-02_JPRB,1.3205E-02_JPRB,&
&1.1741E-02_JPRB,9.9915E-03_JPRB,2.7331E-01_JPRB/)
KAO( :, 5,11,10) = (/&
&2.4521E-02_JPRB,2.3536E-02_JPRB,2.2979E-02_JPRB,2.1464E-02_JPRB,1.9799E-02_JPRB,1.7771E-02_JPRB,&
&1.6045E-02_JPRB,1.4047E-02_JPRB,2.7061E-01_JPRB/)
KAO( :, 1,12,10) = (/&
&6.9801E-03_JPRB,6.5414E-03_JPRB,6.1464E-03_JPRB,5.6988E-03_JPRB,5.0902E-03_JPRB,4.4198E-03_JPRB,&
&3.6370E-03_JPRB,2.5506E-03_JPRB,4.9609E-01_JPRB/)
KAO( :, 2,12,10) = (/&
&1.0252E-02_JPRB,9.6631E-03_JPRB,9.2104E-03_JPRB,8.5451E-03_JPRB,7.6724E-03_JPRB,6.7086E-03_JPRB,&
&5.5412E-03_JPRB,4.4277E-03_JPRB,4.8672E-01_JPRB/)
KAO( :, 3,12,10) = (/&
&1.4194E-02_JPRB,1.3473E-02_JPRB,1.3019E-02_JPRB,1.2130E-02_JPRB,1.0940E-02_JPRB,9.6059E-03_JPRB,&
&8.1091E-03_JPRB,6.7337E-03_JPRB,4.7779E-01_JPRB/)
KAO( :, 4,12,10) = (/&
&1.8764E-02_JPRB,1.7996E-02_JPRB,1.7549E-02_JPRB,1.6391E-02_JPRB,1.4970E-02_JPRB,1.3362E-02_JPRB,&
&1.1424E-02_JPRB,9.7371E-03_JPRB,4.7094E-01_JPRB/)
KAO( :, 5,12,10) = (/&
&2.3822E-02_JPRB,2.3255E-02_JPRB,2.2798E-02_JPRB,2.1487E-02_JPRB,1.9935E-02_JPRB,1.7893E-02_JPRB,&
&1.5477E-02_JPRB,1.3501E-02_JPRB,4.6404E-01_JPRB/)
KAO( :, 1,13,10) = (/&
&6.7570E-03_JPRB,6.3985E-03_JPRB,6.0648E-03_JPRB,5.6090E-03_JPRB,5.0372E-03_JPRB,4.3896E-03_JPRB,&
&3.5984E-03_JPRB,2.5612E-03_JPRB,7.0129E-01_JPRB/)
KAO( :, 2,13,10) = (/&
&9.8516E-03_JPRB,9.3610E-03_JPRB,9.0380E-03_JPRB,8.3857E-03_JPRB,7.5801E-03_JPRB,6.6037E-03_JPRB,&
&5.4660E-03_JPRB,4.1572E-03_JPRB,6.8624E-01_JPRB/)
KAO( :, 3,13,10) = (/&
&1.3565E-02_JPRB,1.3023E-02_JPRB,1.2697E-02_JPRB,1.1845E-02_JPRB,1.0771E-02_JPRB,9.5129E-03_JPRB,&
&8.0355E-03_JPRB,6.4068E-03_JPRB,6.7348E-01_JPRB/)
KAO( :, 4,13,10) = (/&
&1.7823E-02_JPRB,1.7451E-02_JPRB,1.7031E-02_JPRB,1.6025E-02_JPRB,1.4810E-02_JPRB,1.3226E-02_JPRB,&
&1.1248E-02_JPRB,9.2627E-03_JPRB,6.6252E-01_JPRB/)
KAO( :, 5,13,10) = (/&
&2.2635E-02_JPRB,2.2570E-02_JPRB,2.2029E-02_JPRB,2.1116E-02_JPRB,1.9648E-02_JPRB,1.7648E-02_JPRB,&
&1.5125E-02_JPRB,1.2814E-02_JPRB,6.5224E-01_JPRB/)
KAO( :, 1, 1,11) = (/&
&4.0423E-02_JPRB,3.5511E-02_JPRB,3.2385E-02_JPRB,3.1302E-02_JPRB,2.9329E-02_JPRB,2.7493E-02_JPRB,&
&2.5237E-02_JPRB,2.6262E-02_JPRB,3.3335E-02_JPRB/)
KAO( :, 2, 1,11) = (/&
&4.8068E-02_JPRB,4.2224E-02_JPRB,3.9790E-02_JPRB,3.8473E-02_JPRB,3.6916E-02_JPRB,3.3889E-02_JPRB,&
&3.2387E-02_JPRB,3.4784E-02_JPRB,4.3954E-02_JPRB/)
KAO( :, 3, 1,11) = (/&
&5.5962E-02_JPRB,4.9147E-02_JPRB,4.7932E-02_JPRB,4.6498E-02_JPRB,4.4808E-02_JPRB,4.0788E-02_JPRB,&
&4.1145E-02_JPRB,4.4752E-02_JPRB,5.6848E-02_JPRB/)
KAO( :, 4, 1,11) = (/&
&6.3927E-02_JPRB,5.6554E-02_JPRB,5.6496E-02_JPRB,5.5146E-02_JPRB,5.2972E-02_JPRB,4.9275E-02_JPRB,&
&5.2218E-02_JPRB,5.7028E-02_JPRB,7.1593E-02_JPRB/)
KAO( :, 5, 1,11) = (/&
&7.1900E-02_JPRB,6.5533E-02_JPRB,6.5482E-02_JPRB,6.4060E-02_JPRB,6.1054E-02_JPRB,5.9498E-02_JPRB,&
&6.4850E-02_JPRB,7.0769E-02_JPRB,8.8897E-02_JPRB/)
KAO( :, 1, 2,11) = (/&
&3.8292E-02_JPRB,3.3588E-02_JPRB,3.1358E-02_JPRB,2.9906E-02_JPRB,2.8447E-02_JPRB,2.6569E-02_JPRB,&
&2.3944E-02_JPRB,2.4132E-02_JPRB,3.1513E-02_JPRB/)
KAO( :, 2, 2,11) = (/&
&4.5994E-02_JPRB,4.0345E-02_JPRB,3.8650E-02_JPRB,3.7178E-02_JPRB,3.6077E-02_JPRB,3.2811E-02_JPRB,&
&3.1189E-02_JPRB,3.2232E-02_JPRB,4.1849E-02_JPRB/)
KAO( :, 3, 2,11) = (/&
&5.3984E-02_JPRB,4.7456E-02_JPRB,4.6641E-02_JPRB,4.5568E-02_JPRB,4.3973E-02_JPRB,3.9559E-02_JPRB,&
&3.9776E-02_JPRB,4.1895E-02_JPRB,5.4339E-02_JPRB/)
KAO( :, 4, 2,11) = (/&
&6.2153E-02_JPRB,5.5541E-02_JPRB,5.5147E-02_JPRB,5.4419E-02_JPRB,5.2145E-02_JPRB,4.8212E-02_JPRB,&
&5.0049E-02_JPRB,5.4211E-02_JPRB,6.8573E-02_JPRB/)
KAO( :, 5, 2,11) = (/&
&7.0498E-02_JPRB,6.4912E-02_JPRB,6.4005E-02_JPRB,6.3675E-02_JPRB,6.0340E-02_JPRB,5.8471E-02_JPRB,&
&6.1765E-02_JPRB,6.8106E-02_JPRB,8.5795E-02_JPRB/)
KAO( :, 1, 3,11) = (/&
&3.4351E-02_JPRB,3.0114E-02_JPRB,2.8690E-02_JPRB,2.7033E-02_JPRB,2.5922E-02_JPRB,2.4043E-02_JPRB,&
&2.1412E-02_JPRB,2.0519E-02_JPRB,2.7411E-02_JPRB/)
KAO( :, 2, 3,11) = (/&
&4.1940E-02_JPRB,3.6767E-02_JPRB,3.5782E-02_JPRB,3.4187E-02_JPRB,3.3188E-02_JPRB,3.0297E-02_JPRB,&
&2.8550E-02_JPRB,2.8551E-02_JPRB,3.7044E-02_JPRB/)
KAO( :, 3, 3,11) = (/&
&5.0028E-02_JPRB,4.4118E-02_JPRB,4.3712E-02_JPRB,4.2513E-02_JPRB,4.0818E-02_JPRB,3.7223E-02_JPRB,&
&3.6892E-02_JPRB,3.7585E-02_JPRB,4.9025E-02_JPRB/)
KAO( :, 4, 3,11) = (/&
&5.8382E-02_JPRB,5.2350E-02_JPRB,5.2192E-02_JPRB,5.1365E-02_JPRB,4.8840E-02_JPRB,4.5605E-02_JPRB,&
&4.6688E-02_JPRB,4.8795E-02_JPRB,6.3308E-02_JPRB/)
KAO( :, 5, 3,11) = (/&
&6.6855E-02_JPRB,6.1851E-02_JPRB,6.1319E-02_JPRB,6.0440E-02_JPRB,5.7553E-02_JPRB,5.5141E-02_JPRB,&
&5.7507E-02_JPRB,6.1726E-02_JPRB,8.0747E-02_JPRB/)
KAO( :, 1, 4,11) = (/&
&2.9914E-02_JPRB,2.6434E-02_JPRB,2.5229E-02_JPRB,2.3960E-02_JPRB,2.2872E-02_JPRB,2.1167E-02_JPRB,&
&1.8618E-02_JPRB,1.7654E-02_JPRB,2.2206E-02_JPRB/)
KAO( :, 2, 4,11) = (/&
&3.7311E-02_JPRB,3.2955E-02_JPRB,3.1987E-02_JPRB,3.0816E-02_JPRB,2.9746E-02_JPRB,2.7451E-02_JPRB,&
&2.5496E-02_JPRB,2.4816E-02_JPRB,3.0769E-02_JPRB/)
KAO( :, 3, 4,11) = (/&
&4.5214E-02_JPRB,4.0225E-02_JPRB,3.9665E-02_JPRB,3.8830E-02_JPRB,3.7073E-02_JPRB,3.4317E-02_JPRB,&
&3.3498E-02_JPRB,3.3259E-02_JPRB,4.1672E-02_JPRB/)
KAO( :, 4, 4,11) = (/&
&5.3522E-02_JPRB,4.8440E-02_JPRB,4.8077E-02_JPRB,4.7499E-02_JPRB,4.5060E-02_JPRB,4.2198E-02_JPRB,&
&4.2877E-02_JPRB,4.3659E-02_JPRB,5.5415E-02_JPRB/)
KAO( :, 5, 4,11) = (/&
&6.2112E-02_JPRB,5.7637E-02_JPRB,5.7355E-02_JPRB,5.6365E-02_JPRB,5.3831E-02_JPRB,5.1483E-02_JPRB,&
&5.3578E-02_JPRB,5.5548E-02_JPRB,7.2397E-02_JPRB/)
KAO( :, 1, 5,11) = (/&
&2.5525E-02_JPRB,2.2961E-02_JPRB,2.1743E-02_JPRB,2.1045E-02_JPRB,1.9762E-02_JPRB,1.8313E-02_JPRB,&
&1.6006E-02_JPRB,1.4928E-02_JPRB,1.7243E-02_JPRB/)
KAO( :, 2, 5,11) = (/&
&3.2562E-02_JPRB,2.9297E-02_JPRB,2.8118E-02_JPRB,2.7378E-02_JPRB,2.6219E-02_JPRB,2.4429E-02_JPRB,&
&2.2374E-02_JPRB,2.1608E-02_JPRB,2.4409E-02_JPRB/)
KAO( :, 3, 5,11) = (/&
&4.0237E-02_JPRB,3.6530E-02_JPRB,3.5529E-02_JPRB,3.4947E-02_JPRB,3.3507E-02_JPRB,3.1205E-02_JPRB,&
&2.9865E-02_JPRB,2.9668E-02_JPRB,3.3965E-02_JPRB/)
KAO( :, 4, 5,11) = (/&
&4.8489E-02_JPRB,4.4640E-02_JPRB,4.3882E-02_JPRB,4.3184E-02_JPRB,4.1466E-02_JPRB,3.8716E-02_JPRB,&
&3.8839E-02_JPRB,3.9053E-02_JPRB,4.6193E-02_JPRB/)
KAO( :, 5, 5,11) = (/&
&5.7075E-02_JPRB,5.3520E-02_JPRB,5.3151E-02_JPRB,5.1813E-02_JPRB,5.0143E-02_JPRB,4.7699E-02_JPRB,&
&4.9575E-02_JPRB,5.0287E-02_JPRB,6.1844E-02_JPRB/)
KAO( :, 1, 6,11) = (/&
&2.1185E-02_JPRB,1.9366E-02_JPRB,1.8345E-02_JPRB,1.7861E-02_JPRB,1.6696E-02_JPRB,1.5286E-02_JPRB,&
&1.3538E-02_JPRB,1.2110E-02_JPRB,1.3050E-02_JPRB/)
KAO( :, 2, 6,11) = (/&
&2.7736E-02_JPRB,2.5421E-02_JPRB,2.4344E-02_JPRB,2.3686E-02_JPRB,2.2632E-02_JPRB,2.1167E-02_JPRB,&
&1.8994E-02_JPRB,1.8327E-02_JPRB,1.8722E-02_JPRB/)
KAO( :, 3, 6,11) = (/&
&3.5098E-02_JPRB,3.2433E-02_JPRB,3.1346E-02_JPRB,3.0890E-02_JPRB,2.9717E-02_JPRB,2.7709E-02_JPRB,&
&2.5626E-02_JPRB,2.5639E-02_JPRB,2.6411E-02_JPRB/)
KAO( :, 4, 6,11) = (/&
&4.3033E-02_JPRB,4.0261E-02_JPRB,3.9466E-02_JPRB,3.8845E-02_JPRB,3.7545E-02_JPRB,3.4640E-02_JPRB,&
&3.3862E-02_JPRB,3.4287E-02_JPRB,3.6956E-02_JPRB/)
KAO( :, 5, 6,11) = (/&
&5.1415E-02_JPRB,4.8889E-02_JPRB,4.8524E-02_JPRB,4.7406E-02_JPRB,4.5977E-02_JPRB,4.3021E-02_JPRB,&
&4.4126E-02_JPRB,4.4906E-02_JPRB,5.0432E-02_JPRB/)
KAO( :, 1, 7,11) = (/&
&1.7209E-02_JPRB,1.5911E-02_JPRB,1.5312E-02_JPRB,1.4785E-02_JPRB,1.3788E-02_JPRB,1.2644E-02_JPRB,&
&1.1178E-02_JPRB,9.4262E-03_JPRB,9.6250E-03_JPRB/)
KAO( :, 2, 7,11) = (/&
&2.3204E-02_JPRB,2.1530E-02_JPRB,2.0850E-02_JPRB,2.0150E-02_JPRB,1.9195E-02_JPRB,1.8013E-02_JPRB,&
&1.5715E-02_JPRB,1.4967E-02_JPRB,1.4283E-02_JPRB/)
KAO( :, 3, 7,11) = (/&
&3.0021E-02_JPRB,2.8103E-02_JPRB,2.7384E-02_JPRB,2.6841E-02_JPRB,2.5917E-02_JPRB,2.4071E-02_JPRB,&
&2.1339E-02_JPRB,2.1364E-02_JPRB,2.0562E-02_JPRB/)
KAO( :, 4, 7,11) = (/&
&3.7516E-02_JPRB,3.5493E-02_JPRB,3.5022E-02_JPRB,3.4550E-02_JPRB,3.3425E-02_JPRB,3.0562E-02_JPRB,&
&2.8485E-02_JPRB,2.9108E-02_JPRB,2.9186E-02_JPRB/)
KAO( :, 5, 7,11) = (/&
&4.5622E-02_JPRB,4.3704E-02_JPRB,4.3641E-02_JPRB,4.3057E-02_JPRB,4.1664E-02_JPRB,3.8186E-02_JPRB,&
&3.7831E-02_JPRB,3.8897E-02_JPRB,4.0505E-02_JPRB/)
KAO( :, 1, 8,11) = (/&
&1.3818E-02_JPRB,1.2820E-02_JPRB,1.2555E-02_JPRB,1.2034E-02_JPRB,1.1176E-02_JPRB,1.0359E-02_JPRB,&
&9.1227E-03_JPRB,7.1909E-03_JPRB,7.1385E-03_JPRB/)
KAO( :, 2, 8,11) = (/&
&1.9199E-02_JPRB,1.7868E-02_JPRB,1.7585E-02_JPRB,1.6871E-02_JPRB,1.6078E-02_JPRB,1.5016E-02_JPRB,&
&1.2893E-02_JPRB,1.1875E-02_JPRB,1.0811E-02_JPRB/)
KAO( :, 3, 8,11) = (/&
&2.5464E-02_JPRB,2.3910E-02_JPRB,2.3566E-02_JPRB,2.3034E-02_JPRB,2.2314E-02_JPRB,2.0472E-02_JPRB,&
&1.7635E-02_JPRB,1.7256E-02_JPRB,1.5992E-02_JPRB/)
KAO( :, 4, 8,11) = (/&
&3.2551E-02_JPRB,3.0722E-02_JPRB,3.0704E-02_JPRB,3.0409E-02_JPRB,2.9339E-02_JPRB,2.6650E-02_JPRB,&
&2.3599E-02_JPRB,2.4044E-02_JPRB,2.3236E-02_JPRB/)
KAO( :, 5, 8,11) = (/&
&4.0250E-02_JPRB,3.8454E-02_JPRB,3.8842E-02_JPRB,3.8675E-02_JPRB,3.7147E-02_JPRB,3.3647E-02_JPRB,&
&3.1602E-02_JPRB,3.2839E-02_JPRB,3.2581E-02_JPRB/)
KAO( :, 1, 9,11) = (/&
&1.1316E-02_JPRB,1.0378E-02_JPRB,1.0058E-02_JPRB,9.5388E-03_JPRB,8.9583E-03_JPRB,8.3215E-03_JPRB,&
&7.2172E-03_JPRB,5.3794E-03_JPRB,1.8355E-02_JPRB/)
KAO( :, 2, 9,11) = (/&
&1.6231E-02_JPRB,1.4928E-02_JPRB,1.4498E-02_JPRB,1.3829E-02_JPRB,1.3241E-02_JPRB,1.2313E-02_JPRB,&
&1.0614E-02_JPRB,9.2668E-03_JPRB,1.9770E-02_JPRB/)
KAO( :, 3, 9,11) = (/&
&2.2130E-02_JPRB,2.0494E-02_JPRB,1.9903E-02_JPRB,1.9411E-02_JPRB,1.8773E-02_JPRB,1.7143E-02_JPRB,&
&1.4703E-02_JPRB,1.3790E-02_JPRB,2.1581E-02_JPRB/)
KAO( :, 4, 9,11) = (/&
&2.8872E-02_JPRB,2.6893E-02_JPRB,2.6410E-02_JPRB,2.6293E-02_JPRB,2.5184E-02_JPRB,2.2875E-02_JPRB,&
&1.9599E-02_JPRB,1.9453E-02_JPRB,2.4207E-02_JPRB/)
KAO( :, 5, 9,11) = (/&
&3.6434E-02_JPRB,3.4163E-02_JPRB,3.4039E-02_JPRB,3.4059E-02_JPRB,3.2485E-02_JPRB,2.9558E-02_JPRB,&
&2.6124E-02_JPRB,2.6908E-02_JPRB,2.8766E-02_JPRB/)
KAO( :, 1,10,11) = (/&
&9.7526E-03_JPRB,8.8471E-03_JPRB,8.4095E-03_JPRB,7.7992E-03_JPRB,7.2733E-03_JPRB,6.6861E-03_JPRB,&
&5.7804E-03_JPRB,4.0724E-03_JPRB,1.2763E-01_JPRB/)
KAO( :, 2,10,11) = (/&
&1.4441E-02_JPRB,1.3149E-02_JPRB,1.2436E-02_JPRB,1.1554E-02_JPRB,1.1049E-02_JPRB,1.0173E-02_JPRB,&
&8.7698E-03_JPRB,7.1450E-03_JPRB,1.2600E-01_JPRB/)
KAO( :, 3,10,11) = (/&
&2.0155E-02_JPRB,1.8437E-02_JPRB,1.7426E-02_JPRB,1.6603E-02_JPRB,1.5853E-02_JPRB,1.4561E-02_JPRB,&
&1.2511E-02_JPRB,1.1073E-02_JPRB,1.2528E-01_JPRB/)
KAO( :, 4,10,11) = (/&
&2.6846E-02_JPRB,2.4609E-02_JPRB,2.3486E-02_JPRB,2.2854E-02_JPRB,2.1623E-02_JPRB,1.9796E-02_JPRB,&
&1.6929E-02_JPRB,1.5991E-02_JPRB,1.2447E-01_JPRB/)
KAO( :, 5,10,11) = (/&
&3.4410E-02_JPRB,3.1744E-02_JPRB,3.0750E-02_JPRB,2.9972E-02_JPRB,2.8397E-02_JPRB,2.5966E-02_JPRB,&
&2.2616E-02_JPRB,2.2449E-02_JPRB,1.2610E-01_JPRB/)
KAO( :, 1,11,11) = (/&
&1.0324E-02_JPRB,9.3720E-03_JPRB,8.7252E-03_JPRB,7.9450E-03_JPRB,7.2482E-03_JPRB,6.5147E-03_JPRB,&
&5.6100E-03_JPRB,4.1662E-03_JPRB,3.4329E-01_JPRB/)
KAO( :, 2,11,11) = (/&
&1.5204E-02_JPRB,1.3885E-02_JPRB,1.2891E-02_JPRB,1.1869E-02_JPRB,1.0956E-02_JPRB,9.8826E-03_JPRB,&
&8.5703E-03_JPRB,6.8061E-03_JPRB,3.3565E-01_JPRB/)
KAO( :, 3,11,11) = (/&
&2.1115E-02_JPRB,1.9367E-02_JPRB,1.8058E-02_JPRB,1.6962E-02_JPRB,1.5612E-02_JPRB,1.4165E-02_JPRB,&
&1.2308E-02_JPRB,1.0528E-02_JPRB,3.2746E-01_JPRB/)
KAO( :, 4,11,11) = (/&
&2.8056E-02_JPRB,2.5869E-02_JPRB,2.4495E-02_JPRB,2.3019E-02_JPRB,2.1190E-02_JPRB,1.9340E-02_JPRB,&
&1.6909E-02_JPRB,1.5353E-02_JPRB,3.2105E-01_JPRB/)
KAO( :, 5,11,11) = (/&
&3.5830E-02_JPRB,3.3269E-02_JPRB,3.2053E-02_JPRB,3.0019E-02_JPRB,2.7764E-02_JPRB,2.5746E-02_JPRB,&
&2.2821E-02_JPRB,2.2018E-02_JPRB,3.1597E-01_JPRB/)
KAO( :, 1,12,11) = (/&
&1.0672E-02_JPRB,9.7549E-03_JPRB,9.0561E-03_JPRB,8.2466E-03_JPRB,7.3613E-03_JPRB,6.3875E-03_JPRB,&
&5.3947E-03_JPRB,4.0883E-03_JPRB,5.8394E-01_JPRB/)
KAO( :, 2,12,11) = (/&
&1.5642E-02_JPRB,1.4385E-02_JPRB,1.3307E-02_JPRB,1.2366E-02_JPRB,1.1058E-02_JPRB,9.6585E-03_JPRB,&
&8.3795E-03_JPRB,6.6353E-03_JPRB,5.6769E-01_JPRB/)
KAO( :, 3,12,11) = (/&
&2.1675E-02_JPRB,2.0001E-02_JPRB,1.8764E-02_JPRB,1.7488E-02_JPRB,1.5704E-02_JPRB,1.3828E-02_JPRB,&
&1.2045E-02_JPRB,1.0080E-02_JPRB,5.5255E-01_JPRB/)
KAO( :, 4,12,11) = (/&
&2.8647E-02_JPRB,2.6665E-02_JPRB,2.5514E-02_JPRB,2.3603E-02_JPRB,2.1257E-02_JPRB,1.8966E-02_JPRB,&
&1.6778E-02_JPRB,1.4837E-02_JPRB,5.4088E-01_JPRB/)
KAO( :, 5,12,11) = (/&
&3.6513E-02_JPRB,3.4282E-02_JPRB,3.3140E-02_JPRB,3.0751E-02_JPRB,2.7941E-02_JPRB,2.5430E-02_JPRB,&
&2.2803E-02_JPRB,2.1312E-02_JPRB,5.3155E-01_JPRB/)
KAO( :, 1,13,11) = (/&
&1.0760E-02_JPRB,9.9165E-03_JPRB,9.2107E-03_JPRB,8.4431E-03_JPRB,7.5043E-03_JPRB,6.4219E-03_JPRB,&
&5.3322E-03_JPRB,3.9942E-03_JPRB,8.0574E-01_JPRB/)
KAO( :, 2,13,11) = (/&
&1.5718E-02_JPRB,1.4579E-02_JPRB,1.3580E-02_JPRB,1.2603E-02_JPRB,1.1240E-02_JPRB,9.7118E-03_JPRB,&
&8.1489E-03_JPRB,6.5540E-03_JPRB,7.8546E-01_JPRB/)
KAO( :, 3,13,11) = (/&
&2.1709E-02_JPRB,2.0244E-02_JPRB,1.9196E-02_JPRB,1.7788E-02_JPRB,1.5932E-02_JPRB,1.3847E-02_JPRB,&
&1.1724E-02_JPRB,9.8122E-03_JPRB,7.6747E-01_JPRB/)
KAO( :, 4,13,11) = (/&
&2.8590E-02_JPRB,2.6855E-02_JPRB,2.5888E-02_JPRB,2.3974E-02_JPRB,2.1610E-02_JPRB,1.9031E-02_JPRB,&
&1.6481E-02_JPRB,1.4419E-02_JPRB,7.5290E-01_JPRB/)
KAO( :, 5,13,11) = (/&
&3.6243E-02_JPRB,3.4524E-02_JPRB,3.3518E-02_JPRB,3.1146E-02_JPRB,2.8589E-02_JPRB,2.5416E-02_JPRB,&
&2.2358E-02_JPRB,2.0400E-02_JPRB,7.4359E-01_JPRB/)
KAO( :, 1, 1,12) = (/&
&5.6231E-02_JPRB,4.9245E-02_JPRB,4.2437E-02_JPRB,3.9377E-02_JPRB,3.6183E-02_JPRB,3.2140E-02_JPRB,&
&3.2423E-02_JPRB,3.1523E-02_JPRB,4.6750E-02_JPRB/)
KAO( :, 2, 1,12) = (/&
&6.6148E-02_JPRB,5.7978E-02_JPRB,5.1041E-02_JPRB,4.8104E-02_JPRB,4.3912E-02_JPRB,4.1677E-02_JPRB,&
&4.3817E-02_JPRB,4.4437E-02_JPRB,6.2584E-02_JPRB/)
KAO( :, 3, 1,12) = (/&
&7.6244E-02_JPRB,6.6854E-02_JPRB,6.1488E-02_JPRB,5.7173E-02_JPRB,5.2540E-02_JPRB,5.2875E-02_JPRB,&
&5.7103E-02_JPRB,5.8708E-02_JPRB,8.0763E-02_JPRB/)
KAO( :, 4, 1,12) = (/&
&8.6310E-02_JPRB,7.5728E-02_JPRB,7.2130E-02_JPRB,6.6817E-02_JPRB,6.2530E-02_JPRB,6.5257E-02_JPRB,&
&7.2354E-02_JPRB,7.4823E-02_JPRB,1.0291E-01_JPRB/)
KAO( :, 5, 1,12) = (/&
&9.6172E-02_JPRB,8.4532E-02_JPRB,8.2586E-02_JPRB,7.6624E-02_JPRB,7.4096E-02_JPRB,7.9889E-02_JPRB,&
&9.0215E-02_JPRB,9.5892E-02_JPRB,1.2765E-01_JPRB/)
KAO( :, 1, 2,12) = (/&
&5.4471E-02_JPRB,4.7727E-02_JPRB,4.1337E-02_JPRB,3.9056E-02_JPRB,3.5201E-02_JPRB,3.1688E-02_JPRB,&
&3.1483E-02_JPRB,3.1390E-02_JPRB,4.4121E-02_JPRB/)
KAO( :, 2, 2,12) = (/&
&6.4761E-02_JPRB,5.6767E-02_JPRB,5.0472E-02_JPRB,4.7843E-02_JPRB,4.3316E-02_JPRB,4.1425E-02_JPRB,&
&4.2288E-02_JPRB,4.3887E-02_JPRB,5.9020E-02_JPRB/)
KAO( :, 3, 2,12) = (/&
&7.5278E-02_JPRB,6.6006E-02_JPRB,6.0892E-02_JPRB,5.7036E-02_JPRB,5.2510E-02_JPRB,5.2589E-02_JPRB,&
&5.4973E-02_JPRB,5.8082E-02_JPRB,7.6747E-02_JPRB/)
KAO( :, 4, 2,12) = (/&
&8.5814E-02_JPRB,7.5272E-02_JPRB,7.1653E-02_JPRB,6.6752E-02_JPRB,6.2771E-02_JPRB,6.5169E-02_JPRB,&
&7.0350E-02_JPRB,7.4345E-02_JPRB,9.8748E-02_JPRB/)
KAO( :, 5, 2,12) = (/&
&9.6214E-02_JPRB,8.4711E-02_JPRB,8.2534E-02_JPRB,7.6688E-02_JPRB,7.5320E-02_JPRB,7.9513E-02_JPRB,&
&8.8443E-02_JPRB,9.3326E-02_JPRB,1.2393E-01_JPRB/)
KAO( :, 1, 3,12) = (/&
&5.0240E-02_JPRB,4.4018E-02_JPRB,3.8537E-02_JPRB,3.6190E-02_JPRB,3.2727E-02_JPRB,2.9265E-02_JPRB,&
&2.8718E-02_JPRB,2.8539E-02_JPRB,3.8545E-02_JPRB/)
KAO( :, 2, 3,12) = (/&
&6.0700E-02_JPRB,5.3194E-02_JPRB,4.7696E-02_JPRB,4.4849E-02_JPRB,4.0923E-02_JPRB,3.8400E-02_JPRB,&
&3.8699E-02_JPRB,3.9635E-02_JPRB,5.2691E-02_JPRB/)
KAO( :, 3, 3,12) = (/&
&7.1446E-02_JPRB,6.2599E-02_JPRB,5.7763E-02_JPRB,5.4243E-02_JPRB,5.0207E-02_JPRB,4.9187E-02_JPRB,&
&5.0052E-02_JPRB,5.3471E-02_JPRB,6.9258E-02_JPRB/)
KAO( :, 4, 3,12) = (/&
&8.2289E-02_JPRB,7.2095E-02_JPRB,6.8416E-02_JPRB,6.4344E-02_JPRB,6.0447E-02_JPRB,6.1241E-02_JPRB,&
&6.3891E-02_JPRB,6.9264E-02_JPRB,8.9560E-02_JPRB/)
KAO( :, 5, 3,12) = (/&
&9.3052E-02_JPRB,8.1807E-02_JPRB,7.9129E-02_JPRB,7.4686E-02_JPRB,7.2461E-02_JPRB,7.5879E-02_JPRB,&
&8.1262E-02_JPRB,8.8197E-02_JPRB,1.1309E-01_JPRB/)
KAO( :, 1, 4,12) = (/&
&4.5028E-02_JPRB,3.9435E-02_JPRB,3.5334E-02_JPRB,3.2580E-02_JPRB,2.9727E-02_JPRB,2.6383E-02_JPRB,&
&2.5279E-02_JPRB,2.4249E-02_JPRB,3.2836E-02_JPRB/)
KAO( :, 2, 4,12) = (/&
&5.5340E-02_JPRB,4.8463E-02_JPRB,4.4234E-02_JPRB,4.0965E-02_JPRB,3.7511E-02_JPRB,3.4709E-02_JPRB,&
&3.4617E-02_JPRB,3.4578E-02_JPRB,4.5997E-02_JPRB/)
KAO( :, 3, 4,12) = (/&
&6.6183E-02_JPRB,5.7963E-02_JPRB,5.3924E-02_JPRB,5.0425E-02_JPRB,4.6576E-02_JPRB,4.4933E-02_JPRB,&
&4.5427E-02_JPRB,4.7054E-02_JPRB,6.1726E-02_JPRB/)
KAO( :, 4, 4,12) = (/&
&7.7283E-02_JPRB,6.7685E-02_JPRB,6.4408E-02_JPRB,6.0620E-02_JPRB,5.6689E-02_JPRB,5.6675E-02_JPRB,&
&5.7994E-02_JPRB,6.1679E-02_JPRB,8.0866E-02_JPRB/)
KAO( :, 5, 4,12) = (/&
&8.8418E-02_JPRB,7.8061E-02_JPRB,7.5140E-02_JPRB,7.1155E-02_JPRB,6.8119E-02_JPRB,7.0861E-02_JPRB,&
&7.3683E-02_JPRB,7.9503E-02_JPRB,1.0285E-01_JPRB/)
KAO( :, 1, 5,12) = (/&
&3.9662E-02_JPRB,3.4731E-02_JPRB,3.1644E-02_JPRB,2.8938E-02_JPRB,2.6745E-02_JPRB,2.3268E-02_JPRB,&
&2.1825E-02_JPRB,2.0476E-02_JPRB,2.7392E-02_JPRB/)
KAO( :, 2, 5,12) = (/&
&4.9795E-02_JPRB,4.3597E-02_JPRB,4.0424E-02_JPRB,3.7076E-02_JPRB,3.4194E-02_JPRB,3.1021E-02_JPRB,&
&3.0623E-02_JPRB,2.9562E-02_JPRB,3.9492E-02_JPRB/)
KAO( :, 3, 5,12) = (/&
&6.0584E-02_JPRB,5.3042E-02_JPRB,4.9894E-02_JPRB,4.6289E-02_JPRB,4.2817E-02_JPRB,4.0884E-02_JPRB,&
&4.1181E-02_JPRB,4.1314E-02_JPRB,5.4083E-02_JPRB/)
KAO( :, 4, 5,12) = (/&
&7.1810E-02_JPRB,6.2970E-02_JPRB,6.0288E-02_JPRB,5.6611E-02_JPRB,5.2417E-02_JPRB,5.2364E-02_JPRB,&
&5.3447E-02_JPRB,5.4733E-02_JPRB,7.1895E-02_JPRB/)
KAO( :, 5, 5,12) = (/&
&8.3191E-02_JPRB,7.3693E-02_JPRB,7.1136E-02_JPRB,6.7175E-02_JPRB,6.3303E-02_JPRB,6.5794E-02_JPRB,&
&6.8047E-02_JPRB,7.1167E-02_JPRB,9.3099E-02_JPRB/)
KAO( :, 1, 6,12) = (/&
&3.4073E-02_JPRB,2.9970E-02_JPRB,2.7448E-02_JPRB,2.5187E-02_JPRB,2.3238E-02_JPRB,2.0151E-02_JPRB,&
&1.8356E-02_JPRB,1.7087E-02_JPRB,2.1825E-02_JPRB/)
KAO( :, 2, 6,12) = (/&
&4.3805E-02_JPRB,3.8540E-02_JPRB,3.5809E-02_JPRB,3.2989E-02_JPRB,3.0183E-02_JPRB,2.7066E-02_JPRB,&
&2.6460E-02_JPRB,2.5241E-02_JPRB,3.2266E-02_JPRB/)
KAO( :, 3, 6,12) = (/&
&5.4408E-02_JPRB,4.7827E-02_JPRB,4.4959E-02_JPRB,4.1832E-02_JPRB,3.8412E-02_JPRB,3.6156E-02_JPRB,&
&3.6616E-02_JPRB,3.5630E-02_JPRB,4.5299E-02_JPRB/)
KAO( :, 4, 6,12) = (/&
&6.5566E-02_JPRB,5.7738E-02_JPRB,5.4996E-02_JPRB,5.1938E-02_JPRB,4.7753E-02_JPRB,4.7435E-02_JPRB,&
&4.8559E-02_JPRB,4.8244E-02_JPRB,6.1467E-02_JPRB/)
KAO( :, 5, 6,12) = (/&
&7.7055E-02_JPRB,6.8635E-02_JPRB,6.5830E-02_JPRB,6.2404E-02_JPRB,5.8371E-02_JPRB,6.0640E-02_JPRB,&
&6.2553E-02_JPRB,6.3410E-02_JPRB,8.1734E-02_JPRB/)
KAO( :, 1, 7,12) = (/&
&2.8703E-02_JPRB,2.5583E-02_JPRB,2.3276E-02_JPRB,2.1697E-02_JPRB,1.9747E-02_JPRB,1.7089E-02_JPRB,&
&1.5072E-02_JPRB,1.3835E-02_JPRB,1.6883E-02_JPRB/)
KAO( :, 2, 7,12) = (/&
&3.7935E-02_JPRB,3.3728E-02_JPRB,3.1173E-02_JPRB,2.9047E-02_JPRB,2.6304E-02_JPRB,2.3254E-02_JPRB,&
&2.2495E-02_JPRB,2.1233E-02_JPRB,2.5258E-02_JPRB/)
KAO( :, 3, 7,12) = (/&
&4.8109E-02_JPRB,4.2733E-02_JPRB,3.9875E-02_JPRB,3.7411E-02_JPRB,3.4221E-02_JPRB,3.1727E-02_JPRB,&
&3.2013E-02_JPRB,3.0954E-02_JPRB,3.6228E-02_JPRB/)
KAO( :, 4, 7,12) = (/&
&5.9015E-02_JPRB,5.2712E-02_JPRB,4.9724E-02_JPRB,4.7098E-02_JPRB,4.3201E-02_JPRB,4.2396E-02_JPRB,&
&4.3420E-02_JPRB,4.2821E-02_JPRB,5.0322E-02_JPRB/)
KAO( :, 5, 7,12) = (/&
&7.0562E-02_JPRB,6.3765E-02_JPRB,6.0647E-02_JPRB,5.7324E-02_JPRB,5.3581E-02_JPRB,5.4932E-02_JPRB,&
&5.6750E-02_JPRB,5.6861E-02_JPRB,6.8648E-02_JPRB/)
KAO( :, 1, 8,12) = (/&
&2.3797E-02_JPRB,2.1507E-02_JPRB,1.9481E-02_JPRB,1.8328E-02_JPRB,1.6567E-02_JPRB,1.4195E-02_JPRB,&
&1.2226E-02_JPRB,1.1084E-02_JPRB,1.2769E-02_JPRB/)
KAO( :, 2, 8,12) = (/&
&3.2290E-02_JPRB,2.9132E-02_JPRB,2.6787E-02_JPRB,2.5154E-02_JPRB,2.2698E-02_JPRB,1.9789E-02_JPRB,&
&1.8738E-02_JPRB,1.7668E-02_JPRB,1.9523E-02_JPRB/)
KAO( :, 3, 8,12) = (/&
&4.1971E-02_JPRB,3.7809E-02_JPRB,3.5153E-02_JPRB,3.3039E-02_JPRB,3.0227E-02_JPRB,2.7550E-02_JPRB,&
&2.7403E-02_JPRB,2.6633E-02_JPRB,2.8356E-02_JPRB/)
KAO( :, 4, 8,12) = (/&
&5.2643E-02_JPRB,4.7711E-02_JPRB,4.4776E-02_JPRB,4.2382E-02_JPRB,3.8941E-02_JPRB,3.7160E-02_JPRB,&
&3.7962E-02_JPRB,3.7660E-02_JPRB,4.0067E-02_JPRB/)
KAO( :, 5, 8,12) = (/&
&6.4120E-02_JPRB,5.8657E-02_JPRB,5.5707E-02_JPRB,5.2735E-02_JPRB,4.8989E-02_JPRB,4.8789E-02_JPRB,&
&5.0472E-02_JPRB,5.0598E-02_JPRB,5.5953E-02_JPRB/)
KAO( :, 1, 9,12) = (/&
&1.9250E-02_JPRB,1.7588E-02_JPRB,1.6042E-02_JPRB,1.5146E-02_JPRB,1.3631E-02_JPRB,1.1686E-02_JPRB,&
&9.9858E-03_JPRB,8.6677E-03_JPRB,2.1707E-02_JPRB/)
KAO( :, 2, 9,12) = (/&
&2.7012E-02_JPRB,2.4595E-02_JPRB,2.2809E-02_JPRB,2.1369E-02_JPRB,1.9226E-02_JPRB,1.6776E-02_JPRB,&
&1.5292E-02_JPRB,1.4425E-02_JPRB,2.4366E-02_JPRB/)
KAO( :, 3, 9,12) = (/&
&3.6057E-02_JPRB,3.2810E-02_JPRB,3.0756E-02_JPRB,2.8820E-02_JPRB,2.6287E-02_JPRB,2.3677E-02_JPRB,&
&2.2692E-02_JPRB,2.2334E-02_JPRB,2.7809E-02_JPRB/)
KAO( :, 4, 9,12) = (/&
&4.6276E-02_JPRB,4.2323E-02_JPRB,4.0041E-02_JPRB,3.7778E-02_JPRB,3.4895E-02_JPRB,3.2122E-02_JPRB,&
&3.2057E-02_JPRB,3.2163E-02_JPRB,3.3773E-02_JPRB/)
KAO( :, 5, 9,12) = (/&
&5.7287E-02_JPRB,5.2928E-02_JPRB,5.0545E-02_JPRB,4.8124E-02_JPRB,4.4442E-02_JPRB,4.2249E-02_JPRB,&
&4.3334E-02_JPRB,4.4067E-02_JPRB,4.5714E-02_JPRB/)
KAO( :, 1,10,12) = (/&
&1.5724E-02_JPRB,1.4480E-02_JPRB,1.3399E-02_JPRB,1.2607E-02_JPRB,1.1371E-02_JPRB,9.8756E-03_JPRB,&
&8.2202E-03_JPRB,7.0920E-03_JPRB,1.5327E-01_JPRB/)
KAO( :, 2,10,12) = (/&
&2.2742E-02_JPRB,2.0839E-02_JPRB,1.9648E-02_JPRB,1.8330E-02_JPRB,1.6472E-02_JPRB,1.4615E-02_JPRB,&
&1.2794E-02_JPRB,1.2185E-02_JPRB,1.5107E-01_JPRB/)
KAO( :, 3,10,12) = (/&
&3.1111E-02_JPRB,2.8526E-02_JPRB,2.7137E-02_JPRB,2.5313E-02_JPRB,2.3236E-02_JPRB,2.0664E-02_JPRB,&
&1.8952E-02_JPRB,1.8782E-02_JPRB,1.5057E-01_JPRB/)
KAO( :, 4,10,12) = (/&
&4.0637E-02_JPRB,3.7549E-02_JPRB,3.5922E-02_JPRB,3.3978E-02_JPRB,3.1652E-02_JPRB,2.8132E-02_JPRB,&
&2.7006E-02_JPRB,2.7319E-02_JPRB,1.5207E-01_JPRB/)
KAO( :, 5,10,12) = (/&
&5.1227E-02_JPRB,4.7699E-02_JPRB,4.6069E-02_JPRB,4.4170E-02_JPRB,4.0891E-02_JPRB,3.7225E-02_JPRB,&
&3.7060E-02_JPRB,3.8071E-02_JPRB,1.5409E-01_JPRB/)
KAO( :, 1,11,12) = (/&
&1.5555E-02_JPRB,1.4241E-02_JPRB,1.3404E-02_JPRB,1.2541E-02_JPRB,1.1360E-02_JPRB,1.0012E-02_JPRB,&
&8.3342E-03_JPRB,7.3523E-03_JPRB,4.1658E-01_JPRB/)
KAO( :, 2,11,12) = (/&
&2.2569E-02_JPRB,2.0619E-02_JPRB,1.9629E-02_JPRB,1.8217E-02_JPRB,1.6713E-02_JPRB,1.4923E-02_JPRB,&
&1.2799E-02_JPRB,1.2337E-02_JPRB,4.0531E-01_JPRB/)
KAO( :, 3,11,12) = (/&
&3.1003E-02_JPRB,2.8414E-02_JPRB,2.7101E-02_JPRB,2.5438E-02_JPRB,2.3803E-02_JPRB,2.0993E-02_JPRB,&
&1.8716E-02_JPRB,1.8686E-02_JPRB,3.9474E-01_JPRB/)
KAO( :, 4,11,12) = (/&
&4.0722E-02_JPRB,3.7543E-02_JPRB,3.5908E-02_JPRB,3.4570E-02_JPRB,3.2168E-02_JPRB,2.8356E-02_JPRB,&
&2.6227E-02_JPRB,2.6848E-02_JPRB,3.8831E-01_JPRB/)
KAO( :, 5,11,12) = (/&
&5.1560E-02_JPRB,4.7783E-02_JPRB,4.6376E-02_JPRB,4.5061E-02_JPRB,4.1670E-02_JPRB,3.7328E-02_JPRB,&
&3.5965E-02_JPRB,3.7251E-02_JPRB,3.8125E-01_JPRB/)
KAO( :, 1,12,12) = (/&
&1.5830E-02_JPRB,1.4387E-02_JPRB,1.3516E-02_JPRB,1.2418E-02_JPRB,1.1346E-02_JPRB,1.0079E-02_JPRB,&
&8.3729E-03_JPRB,7.3472E-03_JPRB,7.1942E-01_JPRB/)
KAO( :, 2,12,12) = (/&
&2.3055E-02_JPRB,2.0962E-02_JPRB,1.9738E-02_JPRB,1.8144E-02_JPRB,1.6929E-02_JPRB,1.5067E-02_JPRB,&
&1.2702E-02_JPRB,1.1955E-02_JPRB,6.9772E-01_JPRB/)
KAO( :, 3,12,12) = (/&
&3.1847E-02_JPRB,2.9081E-02_JPRB,2.7322E-02_JPRB,2.5612E-02_JPRB,2.3940E-02_JPRB,2.1303E-02_JPRB,&
&1.8481E-02_JPRB,1.8181E-02_JPRB,6.7687E-01_JPRB/)
KAO( :, 4,12,12) = (/&
&4.1961E-02_JPRB,3.8413E-02_JPRB,3.6388E-02_JPRB,3.4886E-02_JPRB,3.2236E-02_JPRB,2.8808E-02_JPRB,&
&2.5797E-02_JPRB,2.6077E-02_JPRB,6.5603E-01_JPRB/)
KAO( :, 5,12,12) = (/&
&5.3319E-02_JPRB,4.9117E-02_JPRB,4.7169E-02_JPRB,4.5236E-02_JPRB,4.1943E-02_JPRB,3.7873E-02_JPRB,&
&3.5355E-02_JPRB,3.6412E-02_JPRB,6.4190E-01_JPRB/)
KAO( :, 1,13,12) = (/&
&1.6495E-02_JPRB,1.4909E-02_JPRB,1.3825E-02_JPRB,1.2544E-02_JPRB,1.1340E-02_JPRB,9.9975E-03_JPRB,&
&8.3433E-03_JPRB,7.0546E-03_JPRB,9.9911E-01_JPRB/)
KAO( :, 2,13,12) = (/&
&2.4109E-02_JPRB,2.1885E-02_JPRB,2.0210E-02_JPRB,1.8488E-02_JPRB,1.6936E-02_JPRB,1.4953E-02_JPRB,&
&1.2660E-02_JPRB,1.1467E-02_JPRB,9.6984E-01_JPRB/)
KAO( :, 3,13,12) = (/&
&3.3220E-02_JPRB,3.0296E-02_JPRB,2.8083E-02_JPRB,2.6185E-02_JPRB,2.3860E-02_JPRB,2.1223E-02_JPRB,&
&1.8346E-02_JPRB,1.7437E-02_JPRB,9.3888E-01_JPRB/)
KAO( :, 4,13,12) = (/&
&4.3831E-02_JPRB,4.0158E-02_JPRB,3.7697E-02_JPRB,3.5285E-02_JPRB,3.2116E-02_JPRB,2.8881E-02_JPRB,&
&2.5602E-02_JPRB,2.5164E-02_JPRB,9.0808E-01_JPRB/)
KAO( :, 5,13,12) = (/&
&5.5677E-02_JPRB,5.1368E-02_JPRB,4.8923E-02_JPRB,4.5702E-02_JPRB,4.1832E-02_JPRB,3.8470E-02_JPRB,&
&3.5318E-02_JPRB,3.5646E-02_JPRB,8.8465E-01_JPRB/)
KAO( :, 1, 1,13) = (/&
&7.2506E-02_JPRB,6.3446E-02_JPRB,5.4408E-02_JPRB,4.7483E-02_JPRB,4.2382E-02_JPRB,4.1239E-02_JPRB,&
&4.3386E-02_JPRB,4.4074E-02_JPRB,6.4271E-02_JPRB/)
KAO( :, 2, 1,13) = (/&
&8.4465E-02_JPRB,7.3953E-02_JPRB,6.3427E-02_JPRB,5.6900E-02_JPRB,5.2376E-02_JPRB,5.3648E-02_JPRB,&
&5.8354E-02_JPRB,5.9101E-02_JPRB,8.6583E-02_JPRB/)
KAO( :, 3, 1,13) = (/&
&9.6444E-02_JPRB,8.4439E-02_JPRB,7.3063E-02_JPRB,6.7601E-02_JPRB,6.5429E-02_JPRB,6.9474E-02_JPRB,&
&7.7817E-02_JPRB,8.1204E-02_JPRB,1.1413E-01_JPRB/)
KAO( :, 4, 1,13) = (/&
&1.0833E-01_JPRB,9.4864E-02_JPRB,8.5278E-02_JPRB,7.9673E-02_JPRB,8.1089E-02_JPRB,9.1367E-02_JPRB,&
&1.0434E-01_JPRB,1.1177E-01_JPRB,1.4904E-01_JPRB/)
KAO( :, 5, 1,13) = (/&
&1.1980E-01_JPRB,1.0493E-01_JPRB,9.6406E-02_JPRB,9.4783E-02_JPRB,1.0132E-01_JPRB,1.1971E-01_JPRB,&
&1.3809E-01_JPRB,1.4964E-01_JPRB,1.9375E-01_JPRB/)
KAO( :, 1, 2,13) = (/&
&7.1478E-02_JPRB,6.2570E-02_JPRB,5.3664E-02_JPRB,4.6754E-02_JPRB,4.2681E-02_JPRB,4.1156E-02_JPRB,&
&4.2008E-02_JPRB,4.2483E-02_JPRB,6.2959E-02_JPRB/)
KAO( :, 2, 2,13) = (/&
&8.4247E-02_JPRB,7.3747E-02_JPRB,6.3249E-02_JPRB,5.6233E-02_JPRB,5.3534E-02_JPRB,5.3727E-02_JPRB,&
&5.7468E-02_JPRB,5.8178E-02_JPRB,8.6328E-02_JPRB/)
KAO( :, 3, 2,13) = (/&
&9.6812E-02_JPRB,8.4747E-02_JPRB,7.4116E-02_JPRB,6.7508E-02_JPRB,6.6781E-02_JPRB,6.9983E-02_JPRB,&
&7.6767E-02_JPRB,7.7852E-02_JPRB,1.1485E-01_JPRB/)
KAO( :, 4, 2,13) = (/&
&1.0887E-01_JPRB,9.5297E-02_JPRB,8.6108E-02_JPRB,8.0754E-02_JPRB,8.2919E-02_JPRB,8.8967E-02_JPRB,&
&1.0013E-01_JPRB,1.0496E-01_JPRB,1.4738E-01_JPRB/)
KAO( :, 5, 2,13) = (/&
&1.2040E-01_JPRB,1.0544E-01_JPRB,9.8262E-02_JPRB,9.7024E-02_JPRB,1.0128E-01_JPRB,1.1389E-01_JPRB,&
&1.3047E-01_JPRB,1.4126E-01_JPRB,1.8810E-01_JPRB/)
KAO( :, 1, 3,13) = (/&
&6.7428E-02_JPRB,5.9012E-02_JPRB,5.0600E-02_JPRB,4.4820E-02_JPRB,4.0284E-02_JPRB,3.8905E-02_JPRB,&
&3.8433E-02_JPRB,3.8221E-02_JPRB,5.7695E-02_JPRB/)
KAO( :, 2, 3,13) = (/&
&8.0097E-02_JPRB,7.0092E-02_JPRB,6.0231E-02_JPRB,5.4560E-02_JPRB,5.1238E-02_JPRB,5.1427E-02_JPRB,&
&5.2635E-02_JPRB,5.3599E-02_JPRB,7.9873E-02_JPRB/)
KAO( :, 3, 3,13) = (/&
&9.2835E-02_JPRB,8.1288E-02_JPRB,7.1303E-02_JPRB,6.5788E-02_JPRB,6.5168E-02_JPRB,6.7196E-02_JPRB,&
&7.1689E-02_JPRB,7.2641E-02_JPRB,1.0771E-01_JPRB/)
KAO( :, 4, 3,13) = (/&
&1.0559E-01_JPRB,9.2480E-02_JPRB,8.3299E-02_JPRB,7.8616E-02_JPRB,8.1678E-02_JPRB,8.5882E-02_JPRB,&
&9.4318E-02_JPRB,9.6259E-02_JPRB,1.4043E-01_JPRB/)
KAO( :, 5, 3,13) = (/&
&1.1824E-01_JPRB,1.0358E-01_JPRB,9.6455E-02_JPRB,9.5066E-02_JPRB,9.9972E-02_JPRB,1.0747E-01_JPRB,&
&1.2012E-01_JPRB,1.2676E-01_JPRB,1.7816E-01_JPRB/)
KAO( :, 1, 4,13) = (/&
&6.1574E-02_JPRB,5.3893E-02_JPRB,4.6221E-02_JPRB,4.1581E-02_JPRB,3.7011E-02_JPRB,3.6135E-02_JPRB,&
&3.5573E-02_JPRB,3.4371E-02_JPRB,5.0320E-02_JPRB/)
KAO( :, 2, 4,13) = (/&
&7.4469E-02_JPRB,6.5196E-02_JPRB,5.6073E-02_JPRB,5.1353E-02_JPRB,4.7821E-02_JPRB,4.7971E-02_JPRB,&
&4.8104E-02_JPRB,4.8151E-02_JPRB,7.0598E-02_JPRB/)
KAO( :, 3, 4,13) = (/&
&8.7893E-02_JPRB,7.6969E-02_JPRB,6.7380E-02_JPRB,6.2778E-02_JPRB,6.1745E-02_JPRB,6.3327E-02_JPRB,&
&6.5251E-02_JPRB,6.6605E-02_JPRB,9.6688E-02_JPRB/)
KAO( :, 4, 4,13) = (/&
&1.0128E-01_JPRB,8.8666E-02_JPRB,7.9558E-02_JPRB,7.6113E-02_JPRB,7.8711E-02_JPRB,8.2067E-02_JPRB,&
&8.7118E-02_JPRB,8.9685E-02_JPRB,1.2734E-01_JPRB/)
KAO( :, 5, 4,13) = (/&
&1.1397E-01_JPRB,9.9791E-02_JPRB,9.3095E-02_JPRB,9.2358E-02_JPRB,9.7817E-02_JPRB,1.0283E-01_JPRB,&
&1.1271E-01_JPRB,1.1615E-01_JPRB,1.6394E-01_JPRB/)
KAO( :, 1, 5,13) = (/&
&5.5644E-02_JPRB,4.8706E-02_JPRB,4.2042E-02_JPRB,3.7730E-02_JPRB,3.3816E-02_JPRB,3.3296E-02_JPRB,&
&3.2567E-02_JPRB,3.1307E-02_JPRB,4.2852E-02_JPRB/)
KAO( :, 2, 5,13) = (/&
&6.8700E-02_JPRB,6.0145E-02_JPRB,5.2078E-02_JPRB,4.7465E-02_JPRB,4.4257E-02_JPRB,4.4542E-02_JPRB,&
&4.3904E-02_JPRB,4.3555E-02_JPRB,6.1397E-02_JPRB/)
KAO( :, 3, 5,13) = (/&
&8.2079E-02_JPRB,7.1842E-02_JPRB,6.3336E-02_JPRB,5.8826E-02_JPRB,5.7771E-02_JPRB,5.9150E-02_JPRB,&
&5.9615E-02_JPRB,6.0276E-02_JPRB,8.5213E-02_JPRB/)
KAO( :, 4, 5,13) = (/&
&9.5395E-02_JPRB,8.3509E-02_JPRB,7.5491E-02_JPRB,7.2428E-02_JPRB,7.4615E-02_JPRB,7.7323E-02_JPRB,&
&7.9697E-02_JPRB,8.2375E-02_JPRB,1.1408E-01_JPRB/)
KAO( :, 5, 5,13) = (/&
&1.0879E-01_JPRB,9.5224E-02_JPRB,8.9008E-02_JPRB,8.9139E-02_JPRB,9.4277E-02_JPRB,9.8162E-02_JPRB,&
&1.0347E-01_JPRB,1.0938E-01_JPRB,1.4850E-01_JPRB/)
KAO( :, 1, 6,13) = (/&
&4.9166E-02_JPRB,4.3032E-02_JPRB,3.7697E-02_JPRB,3.3418E-02_JPRB,3.0271E-02_JPRB,2.9707E-02_JPRB,&
&2.8739E-02_JPRB,2.7107E-02_JPRB,3.5180E-02_JPRB/)
KAO( :, 2, 6,13) = (/&
&6.1802E-02_JPRB,5.4091E-02_JPRB,4.7585E-02_JPRB,4.2912E-02_JPRB,4.0335E-02_JPRB,4.0310E-02_JPRB,&
&3.9360E-02_JPRB,3.8194E-02_JPRB,5.1590E-02_JPRB/)
KAO( :, 3, 6,13) = (/&
&7.4933E-02_JPRB,6.5583E-02_JPRB,5.8743E-02_JPRB,5.3925E-02_JPRB,5.3041E-02_JPRB,5.4106E-02_JPRB,&
&5.3825E-02_JPRB,5.3725E-02_JPRB,7.3865E-02_JPRB/)
KAO( :, 4, 6,13) = (/&
&8.8794E-02_JPRB,7.7714E-02_JPRB,7.0892E-02_JPRB,6.7266E-02_JPRB,6.9411E-02_JPRB,7.1602E-02_JPRB,&
&7.2167E-02_JPRB,7.4198E-02_JPRB,1.0072E-01_JPRB/)
KAO( :, 5, 6,13) = (/&
&1.0284E-01_JPRB,9.0019E-02_JPRB,8.4346E-02_JPRB,8.3697E-02_JPRB,8.8853E-02_JPRB,9.1618E-02_JPRB,&
&9.4095E-02_JPRB,9.9493E-02_JPRB,1.3200E-01_JPRB/)
KAO( :, 1, 7,13) = (/&
&4.2481E-02_JPRB,3.7182E-02_JPRB,3.2941E-02_JPRB,2.9053E-02_JPRB,2.6729E-02_JPRB,2.5857E-02_JPRB,&
&2.4817E-02_JPRB,2.3036E-02_JPRB,2.8513E-02_JPRB/)
KAO( :, 2, 7,13) = (/&
&5.4646E-02_JPRB,4.7829E-02_JPRB,4.2493E-02_JPRB,3.8260E-02_JPRB,3.6179E-02_JPRB,3.5843E-02_JPRB,&
&3.4675E-02_JPRB,3.3090E-02_JPRB,4.3061E-02_JPRB/)
KAO( :, 3, 7,13) = (/&
&6.7949E-02_JPRB,5.9473E-02_JPRB,5.3629E-02_JPRB,4.8997E-02_JPRB,4.7960E-02_JPRB,4.8517E-02_JPRB,&
&4.7980E-02_JPRB,4.6686E-02_JPRB,6.3225E-02_JPRB/)
KAO( :, 4, 7,13) = (/&
&8.2011E-02_JPRB,7.1775E-02_JPRB,6.5638E-02_JPRB,6.1779E-02_JPRB,6.3457E-02_JPRB,6.4989E-02_JPRB,&
&6.5420E-02_JPRB,6.5338E-02_JPRB,8.8114E-02_JPRB/)
KAO( :, 5, 7,13) = (/&
&9.6121E-02_JPRB,8.4118E-02_JPRB,7.9080E-02_JPRB,7.7840E-02_JPRB,8.2099E-02_JPRB,8.4733E-02_JPRB,&
&8.6013E-02_JPRB,8.9165E-02_JPRB,1.1782E-01_JPRB/)
KAO( :, 1, 8,13) = (/&
&3.6137E-02_JPRB,3.1658E-02_JPRB,2.8232E-02_JPRB,2.4974E-02_JPRB,2.3118E-02_JPRB,2.2088E-02_JPRB,&
&2.1064E-02_JPRB,1.9376E-02_JPRB,2.2745E-02_JPRB/)
KAO( :, 2, 8,13) = (/&
&4.8016E-02_JPRB,4.2076E-02_JPRB,3.7504E-02_JPRB,3.3789E-02_JPRB,3.1931E-02_JPRB,3.1218E-02_JPRB,&
&3.0077E-02_JPRB,2.8144E-02_JPRB,3.5232E-02_JPRB/)
KAO( :, 3, 8,13) = (/&
&6.1205E-02_JPRB,5.3668E-02_JPRB,4.8373E-02_JPRB,4.4145E-02_JPRB,4.2766E-02_JPRB,4.3001E-02_JPRB,&
&4.2234E-02_JPRB,4.0332E-02_JPRB,5.3276E-02_JPRB/)
KAO( :, 4, 8,13) = (/&
&7.5025E-02_JPRB,6.5801E-02_JPRB,6.0176E-02_JPRB,5.6410E-02_JPRB,5.7125E-02_JPRB,5.8703E-02_JPRB,&
&5.8721E-02_JPRB,5.7394E-02_JPRB,7.6141E-02_JPRB/)
KAO( :, 5, 8,13) = (/&
&8.9588E-02_JPRB,7.8614E-02_JPRB,7.3265E-02_JPRB,7.1609E-02_JPRB,7.4944E-02_JPRB,7.7845E-02_JPRB,&
&7.8817E-02_JPRB,7.9234E-02_JPRB,1.0406E-01_JPRB/)
KAO( :, 1, 9,13) = (/&
&3.0354E-02_JPRB,2.6812E-02_JPRB,2.3806E-02_JPRB,2.1190E-02_JPRB,1.9445E-02_JPRB,1.8240E-02_JPRB,&
&1.7300E-02_JPRB,1.5970E-02_JPRB,2.7469E-02_JPRB/)
KAO( :, 2, 9,13) = (/&
&4.1683E-02_JPRB,3.6828E-02_JPRB,3.2679E-02_JPRB,2.9622E-02_JPRB,2.7586E-02_JPRB,2.6377E-02_JPRB,&
&2.5396E-02_JPRB,2.3781E-02_JPRB,3.1985E-02_JPRB/)
KAO( :, 3, 9,13) = (/&
&5.4431E-02_JPRB,4.8107E-02_JPRB,4.3192E-02_JPRB,3.9529E-02_JPRB,3.7624E-02_JPRB,3.7195E-02_JPRB,&
&3.6607E-02_JPRB,3.4524E-02_JPRB,4.4340E-02_JPRB/)
KAO( :, 4, 9,13) = (/&
&6.8321E-02_JPRB,6.0391E-02_JPRB,5.4610E-02_JPRB,5.1211E-02_JPRB,5.0615E-02_JPRB,5.1938E-02_JPRB,&
&5.2206E-02_JPRB,5.0002E-02_JPRB,6.4376E-02_JPRB/)
KAO( :, 5, 9,13) = (/&
&8.3382E-02_JPRB,7.3864E-02_JPRB,6.7608E-02_JPRB,6.5416E-02_JPRB,6.7796E-02_JPRB,7.0544E-02_JPRB,&
&7.1581E-02_JPRB,7.0367E-02_JPRB,8.9820E-02_JPRB/)
KAO( :, 1,10,13) = (/&
&2.5866E-02_JPRB,2.3096E-02_JPRB,2.0359E-02_JPRB,1.8244E-02_JPRB,1.6555E-02_JPRB,1.5241E-02_JPRB,&
&1.4537E-02_JPRB,1.3197E-02_JPRB,1.8207E-01_JPRB/)
KAO( :, 2,10,13) = (/&
&3.6597E-02_JPRB,3.2659E-02_JPRB,2.8899E-02_JPRB,2.6262E-02_JPRB,2.4046E-02_JPRB,2.2449E-02_JPRB,&
&2.1774E-02_JPRB,2.0251E-02_JPRB,1.8269E-01_JPRB/)
KAO( :, 3,10,13) = (/&
&4.8990E-02_JPRB,4.3688E-02_JPRB,3.9094E-02_JPRB,3.5827E-02_JPRB,3.3277E-02_JPRB,3.2592E-02_JPRB,&
&3.2234E-02_JPRB,3.0480E-02_JPRB,1.8337E-01_JPRB/)
KAO( :, 4,10,13) = (/&
&6.3031E-02_JPRB,5.6150E-02_JPRB,5.0614E-02_JPRB,4.7098E-02_JPRB,4.5295E-02_JPRB,4.6573E-02_JPRB,&
&4.6974E-02_JPRB,4.5107E-02_JPRB,1.8526E-01_JPRB/)
KAO( :, 5,10,13) = (/&
&7.8337E-02_JPRB,7.0036E-02_JPRB,6.3907E-02_JPRB,6.0875E-02_JPRB,6.1588E-02_JPRB,6.4404E-02_JPRB,&
&6.5574E-02_JPRB,6.4038E-02_JPRB,1.9009E-01_JPRB/)
KAO( :, 1,11,13) = (/&
&2.6170E-02_JPRB,2.3547E-02_JPRB,2.0835E-02_JPRB,1.8825E-02_JPRB,1.6889E-02_JPRB,1.5401E-02_JPRB,&
&1.4727E-02_JPRB,1.3614E-02_JPRB,5.0818E-01_JPRB/)
KAO( :, 2,11,13) = (/&
&3.7087E-02_JPRB,3.3315E-02_JPRB,2.9858E-02_JPRB,2.7151E-02_JPRB,2.4450E-02_JPRB,2.2833E-02_JPRB,&
&2.2404E-02_JPRB,2.1001E-02_JPRB,5.0103E-01_JPRB/)
KAO( :, 3,11,13) = (/&
&4.9963E-02_JPRB,4.4837E-02_JPRB,4.0625E-02_JPRB,3.7044E-02_JPRB,3.4135E-02_JPRB,3.3574E-02_JPRB,&
&3.3602E-02_JPRB,3.2090E-02_JPRB,4.9194E-01_JPRB/)
KAO( :, 4,11,13) = (/&
&6.4516E-02_JPRB,5.7977E-02_JPRB,5.3206E-02_JPRB,4.8937E-02_JPRB,4.7272E-02_JPRB,4.8448E-02_JPRB,&
&4.9192E-02_JPRB,4.7870E-02_JPRB,4.8323E-01_JPRB/)
KAO( :, 5,11,13) = (/&
&8.0357E-02_JPRB,7.2810E-02_JPRB,6.7423E-02_JPRB,6.3846E-02_JPRB,6.4063E-02_JPRB,6.6805E-02_JPRB,&
&6.8458E-02_JPRB,6.7693E-02_JPRB,4.8224E-01_JPRB/)
KAO( :, 1,12,13) = (/&
&2.6382E-02_JPRB,2.3869E-02_JPRB,2.1423E-02_JPRB,1.9530E-02_JPRB,1.7276E-02_JPRB,1.5597E-02_JPRB,&
&1.4852E-02_JPRB,1.3926E-02_JPRB,8.8613E-01_JPRB/)
KAO( :, 2,12,13) = (/&
&3.7554E-02_JPRB,3.3911E-02_JPRB,3.0989E-02_JPRB,2.8114E-02_JPRB,2.5051E-02_JPRB,2.3359E-02_JPRB,&
&2.2994E-02_JPRB,2.2005E-02_JPRB,8.7122E-01_JPRB/)
KAO( :, 3,12,13) = (/&
&5.0689E-02_JPRB,4.5835E-02_JPRB,4.2372E-02_JPRB,3.8639E-02_JPRB,3.5524E-02_JPRB,3.4470E-02_JPRB,&
&3.4752E-02_JPRB,3.3789E-02_JPRB,8.5297E-01_JPRB/)
KAO( :, 4,12,13) = (/&
&6.5611E-02_JPRB,5.9692E-02_JPRB,5.5677E-02_JPRB,5.1555E-02_JPRB,4.9587E-02_JPRB,4.9441E-02_JPRB,&
&5.0436E-02_JPRB,4.9926E-02_JPRB,8.3445E-01_JPRB/)
KAO( :, 5,12,13) = (/&
&8.2012E-02_JPRB,7.5239E-02_JPRB,7.1004E-02_JPRB,6.7701E-02_JPRB,6.6707E-02_JPRB,6.7915E-02_JPRB,&
&6.9915E-02_JPRB,7.0294E-02_JPRB,8.1920E-01_JPRB/)
KAO( :, 1,13,13) = (/&
&2.6411E-02_JPRB,2.4001E-02_JPRB,2.2003E-02_JPRB,2.0098E-02_JPRB,1.7783E-02_JPRB,1.5910E-02_JPRB,&
&1.4921E-02_JPRB,1.4266E-02_JPRB,1.2499E+00_JPRB/)
KAO( :, 2,13,13) = (/&
&3.7728E-02_JPRB,3.4235E-02_JPRB,3.1890E-02_JPRB,2.9069E-02_JPRB,2.6051E-02_JPRB,2.4137E-02_JPRB,&
&2.3431E-02_JPRB,2.2763E-02_JPRB,1.2233E+00_JPRB/)
KAO( :, 3,13,13) = (/&
&5.1168E-02_JPRB,4.6582E-02_JPRB,4.3725E-02_JPRB,4.0296E-02_JPRB,3.7356E-02_JPRB,3.5542E-02_JPRB,&
&3.5231E-02_JPRB,3.4850E-02_JPRB,1.1970E+00_JPRB/)
KAO( :, 4,13,13) = (/&
&6.6532E-02_JPRB,6.1023E-02_JPRB,5.7678E-02_JPRB,5.4658E-02_JPRB,5.1906E-02_JPRB,5.0202E-02_JPRB,&
&5.0477E-02_JPRB,5.0911E-02_JPRB,1.1702E+00_JPRB/)
KAO( :, 5,13,13) = (/&
&8.3713E-02_JPRB,7.7246E-02_JPRB,7.4186E-02_JPRB,7.1956E-02_JPRB,6.9311E-02_JPRB,6.8138E-02_JPRB,&
&6.9472E-02_JPRB,7.1080E-02_JPRB,1.1427E+00_JPRB/)
KAO( :, 1, 1,14) = (/&
&8.4406E-02_JPRB,7.3923E-02_JPRB,6.3390E-02_JPRB,5.3666E-02_JPRB,5.2956E-02_JPRB,5.5472E-02_JPRB,&
&6.0634E-02_JPRB,5.8813E-02_JPRB,9.2877E-02_JPRB/)
KAO( :, 2, 1,14) = (/&
&9.8373E-02_JPRB,8.6109E-02_JPRB,7.3836E-02_JPRB,6.7549E-02_JPRB,6.9431E-02_JPRB,7.7739E-02_JPRB,&
&8.6438E-02_JPRB,8.5388E-02_JPRB,1.3005E-01_JPRB/)
KAO( :, 3, 1,14) = (/&
&1.1220E-01_JPRB,9.8227E-02_JPRB,8.4237E-02_JPRB,8.6127E-02_JPRB,9.3558E-02_JPRB,1.1007E-01_JPRB,&
&1.2298E-01_JPRB,1.2120E-01_JPRB,1.8519E-01_JPRB/)
KAO( :, 4, 1,14) = (/&
&1.2589E-01_JPRB,1.1021E-01_JPRB,9.7341E-02_JPRB,1.0805E-01_JPRB,1.2702E-01_JPRB,1.5181E-01_JPRB,&
&1.6898E-01_JPRB,1.6664E-01_JPRB,2.5570E-01_JPRB/)
KAO( :, 5, 1,14) = (/&
&1.3898E-01_JPRB,1.2167E-01_JPRB,1.1790E-01_JPRB,1.3538E-01_JPRB,1.6936E-01_JPRB,2.0147E-01_JPRB,&
&2.2468E-01_JPRB,2.1901E-01_JPRB,3.4200E-01_JPRB/)
KAO( :, 1, 2,14) = (/&
&8.6965E-02_JPRB,7.6122E-02_JPRB,6.5271E-02_JPRB,5.5929E-02_JPRB,5.5266E-02_JPRB,5.6412E-02_JPRB,&
&6.1162E-02_JPRB,5.9084E-02_JPRB,9.4145E-02_JPRB/)
KAO( :, 2, 2,14) = (/&
&1.0214E-01_JPRB,8.9404E-02_JPRB,7.6670E-02_JPRB,7.1026E-02_JPRB,7.1152E-02_JPRB,7.6438E-02_JPRB,&
&8.4319E-02_JPRB,8.3198E-02_JPRB,1.2897E-01_JPRB/)
KAO( :, 3, 2,14) = (/&
&1.1758E-01_JPRB,1.0294E-01_JPRB,8.8300E-02_JPRB,9.0301E-02_JPRB,9.3552E-02_JPRB,1.0592E-01_JPRB,&
&1.1887E-01_JPRB,1.2017E-01_JPRB,1.7974E-01_JPRB/)
KAO( :, 4, 2,14) = (/&
&1.3321E-01_JPRB,1.1665E-01_JPRB,1.0423E-01_JPRB,1.1370E-01_JPRB,1.2505E-01_JPRB,1.4860E-01_JPRB,&
&1.6715E-01_JPRB,1.6784E-01_JPRB,2.5046E-01_JPRB/)
KAO( :, 5, 2,14) = (/&
&1.4865E-01_JPRB,1.3020E-01_JPRB,1.2666E-01_JPRB,1.3953E-01_JPRB,1.6682E-01_JPRB,2.0058E-01_JPRB,&
&2.2553E-01_JPRB,2.2565E-01_JPRB,3.3899E-01_JPRB/)
KAO( :, 1, 3,14) = (/&
&8.6079E-02_JPRB,7.5340E-02_JPRB,6.4607E-02_JPRB,5.5456E-02_JPRB,5.5272E-02_JPRB,5.5233E-02_JPRB,&
&5.8267E-02_JPRB,5.6783E-02_JPRB,8.9464E-02_JPRB/)
KAO( :, 2, 3,14) = (/&
&1.0304E-01_JPRB,9.0205E-02_JPRB,7.7348E-02_JPRB,7.0519E-02_JPRB,7.0862E-02_JPRB,7.2390E-02_JPRB,&
&7.8791E-02_JPRB,7.7229E-02_JPRB,1.2132E-01_JPRB/)
KAO( :, 3, 3,14) = (/&
&1.2050E-01_JPRB,1.0550E-01_JPRB,9.0628E-02_JPRB,8.9686E-02_JPRB,9.0578E-02_JPRB,9.7251E-02_JPRB,&
&1.0832E-01_JPRB,1.0857E-01_JPRB,1.6570E-01_JPRB/)
KAO( :, 4, 3,14) = (/&
&1.3798E-01_JPRB,1.2081E-01_JPRB,1.0757E-01_JPRB,1.1366E-01_JPRB,1.1771E-01_JPRB,1.3404E-01_JPRB,&
&1.5114E-01_JPRB,1.5446E-01_JPRB,2.2779E-01_JPRB/)
KAO( :, 5, 3,14) = (/&
&1.5527E-01_JPRB,1.3594E-01_JPRB,1.3049E-01_JPRB,1.4065E-01_JPRB,1.5498E-01_JPRB,1.8347E-01_JPRB,&
&2.0928E-01_JPRB,2.1357E-01_JPRB,3.1056E-01_JPRB/)
KAO( :, 1, 4,14) = (/&
&8.3658E-02_JPRB,7.3219E-02_JPRB,6.2782E-02_JPRB,5.4421E-02_JPRB,5.4252E-02_JPRB,5.2373E-02_JPRB,&
&5.2872E-02_JPRB,5.3249E-02_JPRB,8.1760E-02_JPRB/)
KAO( :, 2, 4,14) = (/&
&1.0179E-01_JPRB,8.9084E-02_JPRB,7.6372E-02_JPRB,6.9322E-02_JPRB,6.9646E-02_JPRB,6.9291E-02_JPRB,&
&7.2799E-02_JPRB,7.2370E-02_JPRB,1.1302E-01_JPRB/)
KAO( :, 3, 4,14) = (/&
&1.2055E-01_JPRB,1.0553E-01_JPRB,9.0925E-02_JPRB,8.8158E-02_JPRB,8.8997E-02_JPRB,9.0835E-02_JPRB,&
&9.8776E-02_JPRB,9.8752E-02_JPRB,1.5269E-01_JPRB/)
KAO( :, 4, 4,14) = (/&
&1.3976E-01_JPRB,1.2239E-01_JPRB,1.0872E-01_JPRB,1.1120E-01_JPRB,1.1304E-01_JPRB,1.2136E-01_JPRB,&
&1.3545E-01_JPRB,1.3720E-01_JPRB,2.0650E-01_JPRB/)
KAO( :, 5, 4,14) = (/&
&1.5964E-01_JPRB,1.3984E-01_JPRB,1.3154E-01_JPRB,1.3870E-01_JPRB,1.4428E-01_JPRB,1.6405E-01_JPRB,&
&1.8578E-01_JPRB,1.9371E-01_JPRB,2.7910E-01_JPRB/)
KAO( :, 1, 5,14) = (/&
&7.9613E-02_JPRB,6.9667E-02_JPRB,5.9735E-02_JPRB,5.2890E-02_JPRB,5.1672E-02_JPRB,4.9631E-02_JPRB,&
&4.7983E-02_JPRB,4.7891E-02_JPRB,7.3721E-02_JPRB/)
KAO( :, 2, 5,14) = (/&
&9.8444E-02_JPRB,8.6165E-02_JPRB,7.3879E-02_JPRB,6.8004E-02_JPRB,6.7906E-02_JPRB,6.5760E-02_JPRB,&
&6.6820E-02_JPRB,6.7095E-02_JPRB,1.0263E-01_JPRB/)
KAO( :, 3, 5,14) = (/&
&1.1874E-01_JPRB,1.0393E-01_JPRB,8.9653E-02_JPRB,8.6769E-02_JPRB,8.7048E-02_JPRB,8.6781E-02_JPRB,&
&9.1705E-02_JPRB,9.1503E-02_JPRB,1.4159E-01_JPRB/)
KAO( :, 4, 5,14) = (/&
&1.4009E-01_JPRB,1.2266E-01_JPRB,1.0834E-01_JPRB,1.0954E-01_JPRB,1.1083E-01_JPRB,1.1372E-01_JPRB,&
&1.2361E-01_JPRB,1.2496E-01_JPRB,1.9192E-01_JPRB/)
KAO( :, 5, 5,14) = (/&
&1.6191E-01_JPRB,1.4179E-01_JPRB,1.3132E-01_JPRB,1.3664E-01_JPRB,1.3962E-01_JPRB,1.5009E-01_JPRB,&
&1.6802E-01_JPRB,1.7246E-01_JPRB,2.5602E-01_JPRB/)
KAO( :, 1, 6,14) = (/&
&7.3321E-02_JPRB,6.4173E-02_JPRB,5.5115E-02_JPRB,5.0047E-02_JPRB,4.8003E-02_JPRB,4.5729E-02_JPRB,&
&4.3413E-02_JPRB,4.2157E-02_JPRB,6.5110E-02_JPRB/)
KAO( :, 2, 6,14) = (/&
&9.2952E-02_JPRB,8.1355E-02_JPRB,6.9976E-02_JPRB,6.5257E-02_JPRB,6.4561E-02_JPRB,6.2014E-02_JPRB,&
&6.0594E-02_JPRB,6.0655E-02_JPRB,9.1731E-02_JPRB/)
KAO( :, 3, 6,14) = (/&
&1.1439E-01_JPRB,1.0014E-01_JPRB,8.6575E-02_JPRB,8.3912E-02_JPRB,8.3786E-02_JPRB,8.2279E-02_JPRB,&
&8.3550E-02_JPRB,8.4201E-02_JPRB,1.2740E-01_JPRB/)
KAO( :, 4, 6,14) = (/&
&1.3703E-01_JPRB,1.1997E-01_JPRB,1.0601E-01_JPRB,1.0652E-01_JPRB,1.0715E-01_JPRB,1.0792E-01_JPRB,&
&1.1407E-01_JPRB,1.1447E-01_JPRB,1.7570E-01_JPRB/)
KAO( :, 5, 6,14) = (/&
&1.6047E-01_JPRB,1.4048E-01_JPRB,1.2948E-01_JPRB,1.3382E-01_JPRB,1.3571E-01_JPRB,1.4072E-01_JPRB,&
&1.5346E-01_JPRB,1.5557E-01_JPRB,2.3674E-01_JPRB/)
KAO( :, 1, 7,14) = (/&
&6.6096E-02_JPRB,5.7840E-02_JPRB,5.0291E-02_JPRB,4.6255E-02_JPRB,4.3749E-02_JPRB,4.1346E-02_JPRB,&
&3.9237E-02_JPRB,3.7187E-02_JPRB,5.6581E-02_JPRB/)
KAO( :, 2, 7,14) = (/&
&8.5997E-02_JPRB,7.5272E-02_JPRB,6.5564E-02_JPRB,6.1464E-02_JPRB,6.0084E-02_JPRB,5.7566E-02_JPRB,&
&5.5305E-02_JPRB,5.4415E-02_JPRB,8.1052E-02_JPRB/)
KAO( :, 3, 7,14) = (/&
&1.0792E-01_JPRB,9.4463E-02_JPRB,8.2746E-02_JPRB,8.0231E-02_JPRB,7.9656E-02_JPRB,7.7519E-02_JPRB,&
&7.6243E-02_JPRB,7.6636E-02_JPRB,1.1376E-01_JPRB/)
KAO( :, 4, 7,14) = (/&
&1.3147E-01_JPRB,1.1508E-01_JPRB,1.0289E-01_JPRB,1.0281E-01_JPRB,1.0321E-01_JPRB,1.0267E-01_JPRB,&
&1.0428E-01_JPRB,1.0618E-01_JPRB,1.5831E-01_JPRB/)
KAO( :, 5, 7,14) = (/&
&1.5658E-01_JPRB,1.3709E-01_JPRB,1.2648E-01_JPRB,1.2964E-01_JPRB,1.3186E-01_JPRB,1.3458E-01_JPRB,&
&1.4246E-01_JPRB,1.4352E-01_JPRB,2.1656E-01_JPRB/)
KAO( :, 1, 8,14) = (/&
&5.8400E-02_JPRB,5.1103E-02_JPRB,4.5168E-02_JPRB,4.1948E-02_JPRB,3.9253E-02_JPRB,3.7020E-02_JPRB,&
&3.5370E-02_JPRB,3.2290E-02_JPRB,4.8663E-02_JPRB/)
KAO( :, 2, 8,14) = (/&
&7.8005E-02_JPRB,6.8268E-02_JPRB,6.0453E-02_JPRB,5.7096E-02_JPRB,5.4905E-02_JPRB,5.3117E-02_JPRB,&
&5.0732E-02_JPRB,4.8891E-02_JPRB,7.1101E-02_JPRB/)
KAO( :, 3, 8,14) = (/&
&9.9991E-02_JPRB,8.7516E-02_JPRB,7.8019E-02_JPRB,7.5868E-02_JPRB,7.4621E-02_JPRB,7.2463E-02_JPRB,&
&7.0304E-02_JPRB,6.9569E-02_JPRB,1.0104E-01_JPRB/)
KAO( :, 4, 8,14) = (/&
&1.2410E-01_JPRB,1.0864E-01_JPRB,9.8489E-02_JPRB,9.8564E-02_JPRB,9.8094E-02_JPRB,9.6833E-02_JPRB,&
&9.6022E-02_JPRB,9.6830E-02_JPRB,1.4193E-01_JPRB/)
KAO( :, 5, 8,14) = (/&
&1.4968E-01_JPRB,1.3103E-01_JPRB,1.2227E-01_JPRB,1.2491E-01_JPRB,1.2710E-01_JPRB,1.2811E-01_JPRB,&
&1.3093E-01_JPRB,1.3351E-01_JPRB,1.9610E-01_JPRB/)
KAO( :, 1, 9,14) = (/&
&5.0397E-02_JPRB,4.4093E-02_JPRB,3.9683E-02_JPRB,3.6946E-02_JPRB,3.4574E-02_JPRB,3.2784E-02_JPRB,&
&3.1190E-02_JPRB,2.7785E-02_JPRB,4.2938E-02_JPRB/)
KAO( :, 2, 9,14) = (/&
&6.9192E-02_JPRB,6.0558E-02_JPRB,5.4594E-02_JPRB,5.1616E-02_JPRB,4.9513E-02_JPRB,4.8432E-02_JPRB,&
&4.6308E-02_JPRB,4.3232E-02_JPRB,6.1150E-02_JPRB/)
KAO( :, 3, 9,14) = (/&
&9.0684E-02_JPRB,7.9364E-02_JPRB,7.1928E-02_JPRB,7.0062E-02_JPRB,6.8840E-02_JPRB,6.7293E-02_JPRB,&
&6.5005E-02_JPRB,6.2608E-02_JPRB,8.8443E-02_JPRB/)
KAO( :, 4, 9,14) = (/&
&1.1460E-01_JPRB,1.0028E-01_JPRB,9.2569E-02_JPRB,9.2695E-02_JPRB,9.1960E-02_JPRB,9.0808E-02_JPRB,&
&8.8903E-02_JPRB,8.7875E-02_JPRB,1.2618E-01_JPRB/)
KAO( :, 5, 9,14) = (/&
&1.4029E-01_JPRB,1.2278E-01_JPRB,1.1658E-01_JPRB,1.1927E-01_JPRB,1.2033E-01_JPRB,1.2086E-01_JPRB,&
&1.2101E-01_JPRB,1.2214E-01_JPRB,1.7683E-01_JPRB/)
KAO( :, 1,10,14) = (/&
&4.3717E-02_JPRB,3.8278E-02_JPRB,3.5080E-02_JPRB,3.2701E-02_JPRB,3.0716E-02_JPRB,2.9342E-02_JPRB,&
&2.7684E-02_JPRB,2.4470E-02_JPRB,2.2009E-01_JPRB/)
KAO( :, 2,10,14) = (/&
&6.1476E-02_JPRB,5.3866E-02_JPRB,4.9319E-02_JPRB,4.6960E-02_JPRB,4.5259E-02_JPRB,4.4478E-02_JPRB,&
&4.2577E-02_JPRB,3.9251E-02_JPRB,2.1963E-01_JPRB/)
KAO( :, 3,10,14) = (/&
&8.2385E-02_JPRB,7.2234E-02_JPRB,6.6445E-02_JPRB,6.4962E-02_JPRB,6.4371E-02_JPRB,6.3180E-02_JPRB,&
&6.0931E-02_JPRB,5.7438E-02_JPRB,2.2242E-01_JPRB/)
KAO( :, 4,10,14) = (/&
&1.0599E-01_JPRB,9.3000E-02_JPRB,8.7065E-02_JPRB,8.7339E-02_JPRB,8.7286E-02_JPRB,8.6396E-02_JPRB,&
&8.4334E-02_JPRB,8.1297E-02_JPRB,2.2730E-01_JPRB/)
KAO( :, 5,10,14) = (/&
&1.3194E-01_JPRB,1.1580E-01_JPRB,1.1124E-01_JPRB,1.1411E-01_JPRB,1.1533E-01_JPRB,1.1612E-01_JPRB,&
&1.1515E-01_JPRB,1.1414E-01_JPRB,2.3906E-01_JPRB/)
KAO( :, 1,11,14) = (/&
&4.4414E-02_JPRB,3.9124E-02_JPRB,3.6276E-02_JPRB,3.4192E-02_JPRB,3.2709E-02_JPRB,3.1757E-02_JPRB,&
&3.0272E-02_JPRB,2.7274E-02_JPRB,6.0923E-01_JPRB/)
KAO( :, 2,11,14) = (/&
&6.2792E-02_JPRB,5.5349E-02_JPRB,5.1175E-02_JPRB,4.9442E-02_JPRB,4.8780E-02_JPRB,4.8068E-02_JPRB,&
&4.6106E-02_JPRB,4.2789E-02_JPRB,6.0862E-01_JPRB/)
KAO( :, 3,11,14) = (/&
&8.4498E-02_JPRB,7.4522E-02_JPRB,6.9553E-02_JPRB,6.8963E-02_JPRB,6.9106E-02_JPRB,6.8253E-02_JPRB,&
&6.6044E-02_JPRB,6.2338E-02_JPRB,6.0545E-01_JPRB/)
KAO( :, 4,11,14) = (/&
&1.0929E-01_JPRB,9.6406E-02_JPRB,9.1543E-02_JPRB,9.3189E-02_JPRB,9.3647E-02_JPRB,9.3574E-02_JPRB,&
&9.1735E-02_JPRB,8.8253E-02_JPRB,5.9922E-01_JPRB/)
KAO( :, 5,11,14) = (/&
&1.3686E-01_JPRB,1.2067E-01_JPRB,1.1766E-01_JPRB,1.2167E-01_JPRB,1.2456E-01_JPRB,1.2652E-01_JPRB,&
&1.2561E-01_JPRB,1.2397E-01_JPRB,5.9856E-01_JPRB/)
KAO( :, 1,12,14) = (/&
&4.5286E-02_JPRB,4.0194E-02_JPRB,3.7498E-02_JPRB,3.5426E-02_JPRB,3.4720E-02_JPRB,3.4064E-02_JPRB,&
&3.2556E-02_JPRB,2.9605E-02_JPRB,1.0899E+00_JPRB/)
KAO( :, 2,12,14) = (/&
&6.4484E-02_JPRB,5.7256E-02_JPRB,5.3321E-02_JPRB,5.1760E-02_JPRB,5.1954E-02_JPRB,5.1386E-02_JPRB,&
&4.9166E-02_JPRB,4.5588E-02_JPRB,1.0909E+00_JPRB/)
KAO( :, 3,12,14) = (/&
&8.7239E-02_JPRB,7.7409E-02_JPRB,7.3021E-02_JPRB,7.2641E-02_JPRB,7.3363E-02_JPRB,7.2923E-02_JPRB,&
&7.0510E-02_JPRB,6.6538E-02_JPRB,1.0837E+00_JPRB/)
KAO( :, 4,12,14) = (/&
&1.1325E-01_JPRB,1.0044E-01_JPRB,9.6532E-02_JPRB,9.7960E-02_JPRB,9.9715E-02_JPRB,1.0061E-01_JPRB,&
&9.8953E-02_JPRB,9.5070E-02_JPRB,1.0714E+00_JPRB/)
KAO( :, 5,12,14) = (/&
&1.4215E-01_JPRB,1.2620E-01_JPRB,1.2476E-01_JPRB,1.2858E-01_JPRB,1.3345E-01_JPRB,1.3645E-01_JPRB,&
&1.3637E-01_JPRB,1.3374E-01_JPRB,1.0563E+00_JPRB/)
KAO( :, 1,13,14) = (/&
&4.6570E-02_JPRB,4.1678E-02_JPRB,3.8725E-02_JPRB,3.6717E-02_JPRB,3.6394E-02_JPRB,3.5946E-02_JPRB,&
&3.4376E-02_JPRB,3.1454E-02_JPRB,1.5895E+00_JPRB/)
KAO( :, 2,13,14) = (/&
&6.6498E-02_JPRB,5.9462E-02_JPRB,5.5660E-02_JPRB,5.4101E-02_JPRB,5.4467E-02_JPRB,5.3788E-02_JPRB,&
&5.1648E-02_JPRB,4.8046E-02_JPRB,1.5849E+00_JPRB/)
KAO( :, 3,13,14) = (/&
&9.0364E-02_JPRB,8.0700E-02_JPRB,7.6577E-02_JPRB,7.6135E-02_JPRB,7.6849E-02_JPRB,7.6753E-02_JPRB,&
&7.4630E-02_JPRB,7.0420E-02_JPRB,1.5698E+00_JPRB/)
KAO( :, 4,13,14) = (/&
&1.1790E-01_JPRB,1.0519E-01_JPRB,1.0195E-01_JPRB,1.0248E-01_JPRB,1.0532E-01_JPRB,1.0714E-01_JPRB,&
&1.0603E-01_JPRB,1.0171E-01_JPRB,1.5492E+00_JPRB/)
KAO( :, 5,13,14) = (/&
&1.4874E-01_JPRB,1.3321E-01_JPRB,1.3189E-01_JPRB,1.3520E-01_JPRB,1.4175E-01_JPRB,1.4629E-01_JPRB,&
&1.4735E-01_JPRB,1.4395E-01_JPRB,1.5228E+00_JPRB/)
KAO( :, 1, 1,15) = (/&
&1.1131E-01_JPRB,9.7434E-02_JPRB,8.3539E-02_JPRB,6.9673E-02_JPRB,6.4542E-02_JPRB,7.4907E-02_JPRB,&
&8.0610E-02_JPRB,7.4592E-02_JPRB,1.2983E-01_JPRB/)
KAO( :, 2, 1,15) = (/&
&1.2948E-01_JPRB,1.1334E-01_JPRB,9.7201E-02_JPRB,8.1647E-02_JPRB,9.0214E-02_JPRB,1.0535E-01_JPRB,&
&1.1308E-01_JPRB,1.0399E-01_JPRB,1.8473E-01_JPRB/)
KAO( :, 3, 1,15) = (/&
&1.4765E-01_JPRB,1.2925E-01_JPRB,1.1103E-01_JPRB,1.0059E-01_JPRB,1.2467E-01_JPRB,1.4566E-01_JPRB,&
&1.5615E-01_JPRB,1.4358E-01_JPRB,2.5548E-01_JPRB/)
KAO( :, 4, 1,15) = (/&
&1.6551E-01_JPRB,1.4490E-01_JPRB,1.2421E-01_JPRB,1.3376E-01_JPRB,1.6988E-01_JPRB,1.9836E-01_JPRB,&
&2.1296E-01_JPRB,1.9754E-01_JPRB,3.4830E-01_JPRB/)
KAO( :, 5, 1,15) = (/&
&1.8295E-01_JPRB,1.6015E-01_JPRB,1.4430E-01_JPRB,1.8250E-01_JPRB,2.3252E-01_JPRB,2.7304E-01_JPRB,&
&2.9658E-01_JPRB,2.7983E-01_JPRB,4.7759E-01_JPRB/)
KAO( :, 1, 2,15) = (/&
&1.2229E-01_JPRB,1.0698E-01_JPRB,9.1752E-02_JPRB,7.6480E-02_JPRB,6.8179E-02_JPRB,7.6324E-02_JPRB,&
&8.2595E-02_JPRB,7.6957E-02_JPRB,1.3490E-01_JPRB/)
KAO( :, 2, 2,15) = (/&
&1.4324E-01_JPRB,1.2538E-01_JPRB,1.0747E-01_JPRB,9.0191E-02_JPRB,9.3013E-02_JPRB,1.0900E-01_JPRB,&
&1.1749E-01_JPRB,1.0918E-01_JPRB,1.9459E-01_JPRB/)
KAO( :, 3, 2,15) = (/&
&1.6466E-01_JPRB,1.4413E-01_JPRB,1.2359E-01_JPRB,1.1001E-01_JPRB,1.3054E-01_JPRB,1.5305E-01_JPRB,&
&1.6497E-01_JPRB,1.5263E-01_JPRB,2.7373E-01_JPRB/)
KAO( :, 4, 2,15) = (/&
&1.8622E-01_JPRB,1.6296E-01_JPRB,1.3975E-01_JPRB,1.4019E-01_JPRB,1.7799E-01_JPRB,2.0816E-01_JPRB,&
&2.2421E-01_JPRB,2.0784E-01_JPRB,3.7366E-01_JPRB/)
KAO( :, 5, 2,15) = (/&
&2.0755E-01_JPRB,1.8167E-01_JPRB,1.5934E-01_JPRB,1.9033E-01_JPRB,2.4247E-01_JPRB,2.8472E-01_JPRB,&
&3.0675E-01_JPRB,2.8798E-01_JPRB,5.0930E-01_JPRB/)
KAO( :, 1, 3,15) = (/&
&1.2835E-01_JPRB,1.1233E-01_JPRB,9.6332E-02_JPRB,8.0294E-02_JPRB,6.8892E-02_JPRB,7.2388E-02_JPRB,&
&7.7841E-02_JPRB,7.2996E-02_JPRB,1.3009E-01_JPRB/)
KAO( :, 2, 3,15) = (/&
&1.5296E-01_JPRB,1.3385E-01_JPRB,1.1480E-01_JPRB,9.5678E-02_JPRB,9.1260E-02_JPRB,1.0384E-01_JPRB,&
&1.1265E-01_JPRB,1.0600E-01_JPRB,1.8774E-01_JPRB/)
KAO( :, 3, 3,15) = (/&
&1.7841E-01_JPRB,1.5614E-01_JPRB,1.3387E-01_JPRB,1.1551E-01_JPRB,1.2609E-01_JPRB,1.4839E-01_JPRB,&
&1.6074E-01_JPRB,1.4978E-01_JPRB,2.6916E-01_JPRB/)
KAO( :, 4, 3,15) = (/&
&2.0421E-01_JPRB,1.7872E-01_JPRB,1.5328E-01_JPRB,1.4514E-01_JPRB,1.7532E-01_JPRB,2.0570E-01_JPRB,&
&2.2217E-01_JPRB,2.0725E-01_JPRB,3.7502E-01_JPRB/)
KAO( :, 5, 3,15) = (/&
&2.2993E-01_JPRB,2.0124E-01_JPRB,1.7291E-01_JPRB,1.8782E-01_JPRB,2.3935E-01_JPRB,2.8099E-01_JPRB,&
&3.0349E-01_JPRB,2.8229E-01_JPRB,5.1274E-01_JPRB/)
KAO( :, 1, 4,15) = (/&
&1.3220E-01_JPRB,1.1572E-01_JPRB,9.9179E-02_JPRB,8.2676E-02_JPRB,6.8587E-02_JPRB,6.9929E-02_JPRB,&
&7.4555E-02_JPRB,6.8313E-02_JPRB,1.2618E-01_JPRB/)
KAO( :, 2, 4,15) = (/&
&1.6060E-01_JPRB,1.4053E-01_JPRB,1.2046E-01_JPRB,1.0042E-01_JPRB,9.1232E-02_JPRB,9.6578E-02_JPRB,&
&1.0443E-01_JPRB,9.9068E-02_JPRB,1.7466E-01_JPRB/)
KAO( :, 3, 4,15) = (/&
&1.9027E-01_JPRB,1.6651E-01_JPRB,1.4275E-01_JPRB,1.1998E-01_JPRB,1.2056E-01_JPRB,1.3873E-01_JPRB,&
&1.5129E-01_JPRB,1.4272E-01_JPRB,2.5148E-01_JPRB/)
KAO( :, 4, 4,15) = (/&
&2.2066E-01_JPRB,1.9311E-01_JPRB,1.6558E-01_JPRB,1.4877E-01_JPRB,1.6676E-01_JPRB,1.9681E-01_JPRB,&
&2.1452E-01_JPRB,2.0223E-01_JPRB,3.5884E-01_JPRB/)
KAO( :, 5, 4,15) = (/&
&2.5122E-01_JPRB,2.1983E-01_JPRB,1.8845E-01_JPRB,1.8829E-01_JPRB,2.3159E-01_JPRB,2.7258E-01_JPRB,&
&2.9545E-01_JPRB,2.7646E-01_JPRB,4.9974E-01_JPRB/)
KAO( :, 1, 5,15) = (/&
&1.3465E-01_JPRB,1.1783E-01_JPRB,1.0104E-01_JPRB,8.4191E-02_JPRB,7.0181E-02_JPRB,6.7764E-02_JPRB,&
&7.2349E-02_JPRB,6.6738E-02_JPRB,1.2182E-01_JPRB/)
KAO( :, 2, 5,15) = (/&
&1.6678E-01_JPRB,1.4597E-01_JPRB,1.2512E-01_JPRB,1.0428E-01_JPRB,9.0356E-02_JPRB,9.3548E-02_JPRB,&
&1.0047E-01_JPRB,9.3395E-02_JPRB,1.6838E-01_JPRB/)
KAO( :, 3, 5,15) = (/&
&2.0080E-01_JPRB,1.7573E-01_JPRB,1.5067E-01_JPRB,1.2564E-01_JPRB,1.1939E-01_JPRB,1.2897E-01_JPRB,&
&1.4021E-01_JPRB,1.3389E-01_JPRB,2.3367E-01_JPRB/)
KAO( :, 4, 5,15) = (/&
&2.3601E-01_JPRB,2.0651E-01_JPRB,1.7705E-01_JPRB,1.5299E-01_JPRB,1.5971E-01_JPRB,1.8409E-01_JPRB,&
&2.0223E-01_JPRB,1.9297E-01_JPRB,3.3364E-01_JPRB/)
KAO( :, 5, 5,15) = (/&
&2.7164E-01_JPRB,2.3767E-01_JPRB,2.0377E-01_JPRB,1.9351E-01_JPRB,2.2099E-01_JPRB,2.6145E-01_JPRB,&
&2.8569E-01_JPRB,2.7068E-01_JPRB,4.7598E-01_JPRB/)
KAO( :, 1, 6,15) = (/&
&1.3406E-01_JPRB,1.1731E-01_JPRB,1.0056E-01_JPRB,8.3806E-02_JPRB,7.0762E-02_JPRB,6.6238E-02_JPRB,&
&6.8971E-02_JPRB,6.4722E-02_JPRB,1.1369E-01_JPRB/)
KAO( :, 2, 6,15) = (/&
&1.6963E-01_JPRB,1.4845E-01_JPRB,1.2729E-01_JPRB,1.0606E-01_JPRB,9.0231E-02_JPRB,9.0723E-02_JPRB,&
&9.7199E-02_JPRB,9.0437E-02_JPRB,1.6138E-01_JPRB/)
KAO( :, 3, 6,15) = (/&
&2.0786E-01_JPRB,1.8191E-01_JPRB,1.5592E-01_JPRB,1.2995E-01_JPRB,1.1861E-01_JPRB,1.2279E-01_JPRB,&
&1.3287E-01_JPRB,1.2524E-01_JPRB,2.2069E-01_JPRB/)
KAO( :, 4, 6,15) = (/&
&2.4779E-01_JPRB,2.1681E-01_JPRB,1.8585E-01_JPRB,1.5823E-01_JPRB,1.5558E-01_JPRB,1.7012E-01_JPRB,&
&1.8594E-01_JPRB,1.7956E-01_JPRB,3.0607E-01_JPRB/)
KAO( :, 5, 6,15) = (/&
&2.8850E-01_JPRB,2.5250E-01_JPRB,2.1644E-01_JPRB,1.9593E-01_JPRB,2.0861E-01_JPRB,2.4203E-01_JPRB,&
&2.6660E-01_JPRB,2.5670E-01_JPRB,4.3563E-01_JPRB/)
KAO( :, 1, 7,15) = (/&
&1.3101E-01_JPRB,1.1464E-01_JPRB,9.8272E-02_JPRB,8.1907E-02_JPRB,7.0350E-02_JPRB,6.5243E-02_JPRB,&
&6.4994E-02_JPRB,6.2397E-02_JPRB,1.0427E-01_JPRB/)
KAO( :, 2, 7,15) = (/&
&1.6960E-01_JPRB,1.4841E-01_JPRB,1.2720E-01_JPRB,1.0602E-01_JPRB,9.1007E-02_JPRB,8.8046E-02_JPRB,&
&9.1985E-02_JPRB,8.6734E-02_JPRB,1.5008E-01_JPRB/)
KAO( :, 3, 7,15) = (/&
&2.1159E-01_JPRB,1.8512E-01_JPRB,1.5869E-01_JPRB,1.3227E-01_JPRB,1.1799E-01_JPRB,1.2016E-01_JPRB,&
&1.2848E-01_JPRB,1.2123E-01_JPRB,2.0928E-01_JPRB/)
KAO( :, 4, 7,15) = (/&
&2.5591E-01_JPRB,2.2393E-01_JPRB,1.9196E-01_JPRB,1.6246E-01_JPRB,1.5474E-01_JPRB,1.6150E-01_JPRB,&
&1.7579E-01_JPRB,1.6710E-01_JPRB,2.8812E-01_JPRB/)
KAO( :, 5, 7,15) = (/&
&3.0213E-01_JPRB,2.6429E-01_JPRB,2.2656E-01_JPRB,2.0075E-01_JPRB,2.0206E-01_JPRB,2.2299E-01_JPRB,&
&2.4482E-01_JPRB,2.3852E-01_JPRB,4.0014E-01_JPRB/)
KAO( :, 1, 8,15) = (/&
&1.2571E-01_JPRB,1.1002E-01_JPRB,9.4301E-02_JPRB,7.8660E-02_JPRB,6.9028E-02_JPRB,6.3512E-02_JPRB,&
&6.0386E-02_JPRB,5.9283E-02_JPRB,9.4594E-02_JPRB/)
KAO( :, 2, 8,15) = (/&
&1.6658E-01_JPRB,1.4578E-01_JPRB,1.2499E-01_JPRB,1.0438E-01_JPRB,9.1618E-02_JPRB,8.5835E-02_JPRB,&
&8.6312E-02_JPRB,8.2954E-02_JPRB,1.3781E-01_JPRB/)
KAO( :, 3, 8,15) = (/&
&2.1185E-01_JPRB,1.8540E-01_JPRB,1.5894E-01_JPRB,1.3292E-01_JPRB,1.1859E-01_JPRB,1.1793E-01_JPRB,&
&1.2293E-01_JPRB,1.1767E-01_JPRB,1.9732E-01_JPRB/)
KAO( :, 4, 8,15) = (/&
&2.6124E-01_JPRB,2.2860E-01_JPRB,1.9595E-01_JPRB,1.6484E-01_JPRB,1.5535E-01_JPRB,1.5770E-01_JPRB,&
&1.6881E-01_JPRB,1.6159E-01_JPRB,2.7186E-01_JPRB/)
KAO( :, 5, 8,15) = (/&
&3.1377E-01_JPRB,2.7455E-01_JPRB,2.3536E-01_JPRB,2.0526E-01_JPRB,2.0139E-01_JPRB,2.1210E-01_JPRB,&
&2.3209E-01_JPRB,2.2418E-01_JPRB,3.7448E-01_JPRB/)
KAO( :, 1, 9,15) = (/&
&1.1779E-01_JPRB,1.0307E-01_JPRB,8.8332E-02_JPRB,7.4504E-02_JPRB,6.6446E-02_JPRB,6.0468E-02_JPRB,&
&5.6136E-02_JPRB,5.4947E-02_JPRB,8.6169E-02_JPRB/)
KAO( :, 2, 9,15) = (/&
&1.6035E-01_JPRB,1.4031E-01_JPRB,1.2024E-01_JPRB,1.0163E-01_JPRB,9.0617E-02_JPRB,8.2714E-02_JPRB,&
&7.9922E-02_JPRB,7.8110E-02_JPRB,1.2654E-01_JPRB/)
KAO( :, 3, 9,15) = (/&
&2.0927E-01_JPRB,1.8312E-01_JPRB,1.5698E-01_JPRB,1.3222E-01_JPRB,1.1873E-01_JPRB,1.1424E-01_JPRB,&
&1.1454E-01_JPRB,1.1174E-01_JPRB,1.8302E-01_JPRB/)
KAO( :, 4, 9,15) = (/&
&2.6349E-01_JPRB,2.3054E-01_JPRB,1.9763E-01_JPRB,1.6626E-01_JPRB,1.5598E-01_JPRB,1.5598E-01_JPRB,&
&1.6166E-01_JPRB,1.5736E-01_JPRB,2.5852E-01_JPRB/)
KAO( :, 5, 9,15) = (/&
&3.2165E-01_JPRB,2.8148E-01_JPRB,2.4130E-01_JPRB,2.0798E-01_JPRB,2.0349E-01_JPRB,2.0671E-01_JPRB,&
&2.2142E-01_JPRB,2.1528E-01_JPRB,3.5292E-01_JPRB/)
KAO( :, 1,10,15) = (/&
&1.1095E-01_JPRB,9.7087E-02_JPRB,8.3232E-02_JPRB,7.1375E-02_JPRB,6.4431E-02_JPRB,5.8222E-02_JPRB,&
&5.3438E-02_JPRB,5.1856E-02_JPRB,2.8234E-01_JPRB/)
KAO( :, 2,10,15) = (/&
&1.5568E-01_JPRB,1.3623E-01_JPRB,1.1675E-01_JPRB,9.9778E-02_JPRB,9.0053E-02_JPRB,8.1186E-02_JPRB,&
&7.6199E-02_JPRB,7.4185E-02_JPRB,2.7084E-01_JPRB/)
KAO( :, 3,10,15) = (/&
&2.0787E-01_JPRB,1.8189E-01_JPRB,1.5590E-01_JPRB,1.3290E-01_JPRB,1.2001E-01_JPRB,1.1270E-01_JPRB,&
&1.0975E-01_JPRB,1.0759E-01_JPRB,2.7158E-01_JPRB/)
KAO( :, 4,10,15) = (/&
&2.6636E-01_JPRB,2.3306E-01_JPRB,1.9979E-01_JPRB,1.7021E-01_JPRB,1.5900E-01_JPRB,1.5510E-01_JPRB,&
&1.5611E-01_JPRB,1.5403E-01_JPRB,2.9598E-01_JPRB/)
KAO( :, 5,10,15) = (/&
&3.2972E-01_JPRB,2.8850E-01_JPRB,2.4729E-01_JPRB,2.1458E-01_JPRB,2.0828E-01_JPRB,2.0718E-01_JPRB,&
&2.1605E-01_JPRB,2.1269E-01_JPRB,3.5425E-01_JPRB/)
KAO( :, 1,11,15) = (/&
&1.2309E-01_JPRB,1.0770E-01_JPRB,9.2318E-02_JPRB,8.0169E-02_JPRB,7.2987E-02_JPRB,6.5556E-02_JPRB,&
&5.9599E-02_JPRB,5.7207E-02_JPRB,7.8086E-01_JPRB/)
KAO( :, 2,11,15) = (/&
&1.7300E-01_JPRB,1.5138E-01_JPRB,1.2976E-01_JPRB,1.1252E-01_JPRB,1.0172E-01_JPRB,9.2390E-02_JPRB,&
&8.6481E-02_JPRB,8.3441E-02_JPRB,7.5756E-01_JPRB/)
KAO( :, 3,11,15) = (/&
&2.3096E-01_JPRB,2.0210E-01_JPRB,1.7324E-01_JPRB,1.5024E-01_JPRB,1.3705E-01_JPRB,1.2915E-01_JPRB,&
&1.2474E-01_JPRB,1.2191E-01_JPRB,7.4457E-01_JPRB/)
KAO( :, 4,11,15) = (/&
&2.9558E-01_JPRB,2.5867E-01_JPRB,2.2168E-01_JPRB,1.9321E-01_JPRB,1.8253E-01_JPRB,1.7759E-01_JPRB,&
&1.7734E-01_JPRB,1.7484E-01_JPRB,7.3821E-01_JPRB/)
KAO( :, 5,11,15) = (/&
&3.6617E-01_JPRB,3.2039E-01_JPRB,2.7464E-01_JPRB,2.4544E-01_JPRB,2.3942E-01_JPRB,2.3664E-01_JPRB,&
&2.4480E-01_JPRB,2.4186E-01_JPRB,7.3136E-01_JPRB/)
KAO( :, 1,12,15) = (/&
&1.3535E-01_JPRB,1.1843E-01_JPRB,1.0165E-01_JPRB,8.9837E-02_JPRB,8.1690E-02_JPRB,7.3571E-02_JPRB,&
&6.6791E-02_JPRB,6.3661E-02_JPRB,1.3757E+00_JPRB/)
KAO( :, 2,12,15) = (/&
&1.8999E-01_JPRB,1.6623E-01_JPRB,1.4287E-01_JPRB,1.2620E-01_JPRB,1.1425E-01_JPRB,1.0484E-01_JPRB,&
&9.8183E-02_JPRB,9.4523E-02_JPRB,1.3459E+00_JPRB/)
KAO( :, 3,12,15) = (/&
&2.5368E-01_JPRB,2.2195E-01_JPRB,1.9057E-01_JPRB,1.6840E-01_JPRB,1.5584E-01_JPRB,1.4733E-01_JPRB,&
&1.4186E-01_JPRB,1.3807E-01_JPRB,1.3315E+00_JPRB/)
KAO( :, 4,12,15) = (/&
&3.2577E-01_JPRB,2.8506E-01_JPRB,2.4459E-01_JPRB,2.1851E-01_JPRB,2.0824E-01_JPRB,2.0259E-01_JPRB,&
&2.0145E-01_JPRB,1.9850E-01_JPRB,1.3194E+00_JPRB/)
KAO( :, 5,12,15) = (/&
&4.0459E-01_JPRB,3.5405E-01_JPRB,3.0385E-01_JPRB,2.7860E-01_JPRB,2.7319E-01_JPRB,2.7033E-01_JPRB,&
&2.7684E-01_JPRB,2.7490E-01_JPRB,1.2999E+00_JPRB/)
KAO( :, 1,13,15) = (/&
&1.4666E-01_JPRB,1.2832E-01_JPRB,1.1128E-01_JPRB,9.9675E-02_JPRB,9.0808E-02_JPRB,8.2287E-02_JPRB,&
&7.4732E-02_JPRB,7.0894E-02_JPRB,1.9726E+00_JPRB/)
KAO( :, 2,13,15) = (/&
&2.0655E-01_JPRB,1.8072E-01_JPRB,1.5634E-01_JPRB,1.3981E-01_JPRB,1.2800E-01_JPRB,1.1883E-01_JPRB,&
&1.1080E-01_JPRB,1.0633E-01_JPRB,1.9427E+00_JPRB/)
KAO( :, 3,13,15) = (/&
&2.7678E-01_JPRB,2.4218E-01_JPRB,2.0938E-01_JPRB,1.8714E-01_JPRB,1.7583E-01_JPRB,1.6736E-01_JPRB,&
&1.6095E-01_JPRB,1.5626E-01_JPRB,1.9257E+00_JPRB/)
KAO( :, 4,13,15) = (/&
&3.5575E-01_JPRB,3.1133E-01_JPRB,2.6913E-01_JPRB,2.4484E-01_JPRB,2.3543E-01_JPRB,2.2998E-01_JPRB,&
&2.2795E-01_JPRB,2.2454E-01_JPRB,1.9087E+00_JPRB/)
KAO( :, 5,13,15) = (/&
&4.4176E-01_JPRB,3.8657E-01_JPRB,3.3600E-01_JPRB,3.1312E-01_JPRB,3.0900E-01_JPRB,3.0654E-01_JPRB,&
&3.1167E-01_JPRB,3.1059E-01_JPRB,1.8847E+00_JPRB/)
KAO( :, 1, 1,16) = (/&
&1.2027E-01_JPRB,1.0526E-01_JPRB,9.0268E-02_JPRB,7.5271E-02_JPRB,6.8242E-02_JPRB,7.9946E-02_JPRB,&
&8.4979E-02_JPRB,7.6217E-02_JPRB,1.4103E-01_JPRB/)
KAO( :, 2, 1,16) = (/&
&1.4080E-01_JPRB,1.2324E-01_JPRB,1.0567E-01_JPRB,8.8126E-02_JPRB,9.6089E-02_JPRB,1.1140E-01_JPRB,&
&1.1849E-01_JPRB,1.0627E-01_JPRB,1.9684E-01_JPRB/)
KAO( :, 3, 1,16) = (/&
&1.6158E-01_JPRB,1.4144E-01_JPRB,1.1993E-01_JPRB,1.0577E-01_JPRB,1.3446E-01_JPRB,1.5713E-01_JPRB,&
&1.6954E-01_JPRB,1.5459E-01_JPRB,2.8205E-01_JPRB/)
KAO( :, 4, 1,16) = (/&
&1.8229E-01_JPRB,1.5953E-01_JPRB,1.3683E-01_JPRB,1.5400E-01_JPRB,1.9491E-01_JPRB,2.2859E-01_JPRB,&
&2.4701E-01_JPRB,2.2397E-01_JPRB,4.1109E-01_JPRB/)
KAO( :, 5, 1,16) = (/&
&2.0257E-01_JPRB,1.7732E-01_JPRB,1.5205E-01_JPRB,2.1653E-01_JPRB,2.7743E-01_JPRB,3.2485E-01_JPRB,&
&3.4587E-01_JPRB,3.1685E-01_JPRB,5.7776E-01_JPRB/)
KAO( :, 1, 2,16) = (/&
&1.3618E-01_JPRB,1.1918E-01_JPRB,1.0218E-01_JPRB,8.5185E-02_JPRB,7.2061E-02_JPRB,8.3641E-02_JPRB,&
&8.9007E-02_JPRB,8.0776E-02_JPRB,1.5158E-01_JPRB/)
KAO( :, 2, 2,16) = (/&
&1.6091E-01_JPRB,1.4083E-01_JPRB,1.2073E-01_JPRB,1.0065E-01_JPRB,1.0215E-01_JPRB,1.1864E-01_JPRB,&
&1.2628E-01_JPRB,1.1335E-01_JPRB,2.1521E-01_JPRB/)
KAO( :, 3, 2,16) = (/&
&1.8613E-01_JPRB,1.6291E-01_JPRB,1.3967E-01_JPRB,1.1644E-01_JPRB,1.3974E-01_JPRB,1.6244E-01_JPRB,&
&1.7346E-01_JPRB,1.5531E-01_JPRB,2.9678E-01_JPRB/)
KAO( :, 4, 2,16) = (/&
&2.1139E-01_JPRB,1.8501E-01_JPRB,1.5862E-01_JPRB,1.6081E-01_JPRB,2.0532E-01_JPRB,2.4099E-01_JPRB,&
&2.5759E-01_JPRB,2.3243E-01_JPRB,4.4014E-01_JPRB/)
KAO( :, 5, 2,16) = (/&
&2.3633E-01_JPRB,2.0681E-01_JPRB,1.7734E-01_JPRB,2.3037E-01_JPRB,2.9357E-01_JPRB,3.4250E-01_JPRB,&
&3.6944E-01_JPRB,3.3497E-01_JPRB,6.2683E-01_JPRB/)
KAO( :, 1, 3,16) = (/&
&1.4816E-01_JPRB,1.2967E-01_JPRB,1.1115E-01_JPRB,9.2659E-02_JPRB,7.4159E-02_JPRB,8.0583E-02_JPRB,&
&8.5826E-02_JPRB,7.7925E-02_JPRB,1.4987E-01_JPRB/)
KAO( :, 2, 3,16) = (/&
&1.7766E-01_JPRB,1.5547E-01_JPRB,1.3328E-01_JPRB,1.1109E-01_JPRB,1.0104E-01_JPRB,1.1748E-01_JPRB,&
&1.2514E-01_JPRB,1.1367E-01_JPRB,2.1867E-01_JPRB/)
KAO( :, 3, 3,16) = (/&
&2.0806E-01_JPRB,1.8208E-01_JPRB,1.5612E-01_JPRB,1.3012E-01_JPRB,1.4100E-01_JPRB,1.6398E-01_JPRB,&
&1.7474E-01_JPRB,1.5873E-01_JPRB,3.0539E-01_JPRB/)
KAO( :, 4, 3,16) = (/&
&2.3885E-01_JPRB,2.0905E-01_JPRB,1.7920E-01_JPRB,1.5462E-01_JPRB,1.9704E-01_JPRB,2.3104E-01_JPRB,&
&2.4836E-01_JPRB,2.2742E-01_JPRB,4.3187E-01_JPRB/)
KAO( :, 5, 3,16) = (/&
&2.6947E-01_JPRB,2.3583E-01_JPRB,2.0218E-01_JPRB,2.2565E-01_JPRB,2.8814E-01_JPRB,3.3769E-01_JPRB,&
&3.6257E-01_JPRB,3.3019E-01_JPRB,6.3080E-01_JPRB/)
KAO( :, 1, 4,16) = (/&
&1.5818E-01_JPRB,1.3843E-01_JPRB,1.1868E-01_JPRB,9.8906E-02_JPRB,7.9147E-02_JPRB,7.4782E-02_JPRB,&
&7.9730E-02_JPRB,7.2448E-02_JPRB,1.4101E-01_JPRB/)
KAO( :, 2, 4,16) = (/&
&1.9302E-01_JPRB,1.6890E-01_JPRB,1.4479E-01_JPRB,1.2067E-01_JPRB,9.6946E-02_JPRB,1.1266E-01_JPRB,&
&1.2012E-01_JPRB,1.0916E-01_JPRB,2.1249E-01_JPRB/)
KAO( :, 3, 4,16) = (/&
&2.2940E-01_JPRB,2.0076E-01_JPRB,1.7206E-01_JPRB,1.4345E-01_JPRB,1.3883E-01_JPRB,1.6162E-01_JPRB,&
&1.7237E-01_JPRB,1.5669E-01_JPRB,3.0501E-01_JPRB/)
KAO( :, 4, 4,16) = (/&
&2.6665E-01_JPRB,2.3335E-01_JPRB,2.0002E-01_JPRB,1.6674E-01_JPRB,1.9115E-01_JPRB,2.2258E-01_JPRB,&
&2.3743E-01_JPRB,2.1581E-01_JPRB,4.2004E-01_JPRB/)
KAO( :, 5, 4,16) = (/&
&3.0410E-01_JPRB,2.6615E-01_JPRB,2.2811E-01_JPRB,2.1285E-01_JPRB,2.7372E-01_JPRB,3.2083E-01_JPRB,&
&3.4541E-01_JPRB,3.1599E-01_JPRB,6.0405E-01_JPRB/)
KAO( :, 1, 5,16) = (/&
&1.6744E-01_JPRB,1.4653E-01_JPRB,1.2561E-01_JPRB,1.0468E-01_JPRB,8.3763E-02_JPRB,7.6430E-02_JPRB,&
&8.0078E-02_JPRB,7.1821E-02_JPRB,1.3817E-01_JPRB/)
KAO( :, 2, 5,16) = (/&
&2.0817E-01_JPRB,1.8217E-01_JPRB,1.5617E-01_JPRB,1.3014E-01_JPRB,1.0413E-01_JPRB,1.0666E-01_JPRB,&
&1.1380E-01_JPRB,1.0350E-01_JPRB,2.0245E-01_JPRB/)
KAO( :, 3, 5,16) = (/&
&2.5135E-01_JPRB,2.1998E-01_JPRB,1.8857E-01_JPRB,1.5714E-01_JPRB,1.3525E-01_JPRB,1.5761E-01_JPRB,&
&1.6824E-01_JPRB,1.5302E-01_JPRB,2.9921E-01_JPRB/)
KAO( :, 4, 5,16) = (/&
&2.9614E-01_JPRB,2.5913E-01_JPRB,2.2214E-01_JPRB,1.8514E-01_JPRB,1.9095E-01_JPRB,2.2256E-01_JPRB,&
&2.3757E-01_JPRB,2.1609E-01_JPRB,4.2253E-01_JPRB/)
KAO( :, 5, 5,16) = (/&
&3.4165E-01_JPRB,2.9890E-01_JPRB,2.5626E-01_JPRB,2.1358E-01_JPRB,2.6276E-01_JPRB,3.0710E-01_JPRB,&
&3.2753E-01_JPRB,2.9875E-01_JPRB,5.8403E-01_JPRB/)
KAO( :, 1, 6,16) = (/&
&1.7406E-01_JPRB,1.5231E-01_JPRB,1.3056E-01_JPRB,1.0879E-01_JPRB,8.7033E-02_JPRB,7.9557E-02_JPRB,&
&8.3495E-02_JPRB,7.4970E-02_JPRB,1.4461E-01_JPRB/)
KAO( :, 2, 6,16) = (/&
&2.2115E-01_JPRB,1.9353E-01_JPRB,1.6587E-01_JPRB,1.3825E-01_JPRB,1.1058E-01_JPRB,1.0079E-01_JPRB,&
&1.0571E-01_JPRB,9.5354E-02_JPRB,1.8669E-01_JPRB/)
KAO( :, 3, 6,16) = (/&
&2.7185E-01_JPRB,2.3789E-01_JPRB,2.0389E-01_JPRB,1.6994E-01_JPRB,1.3598E-01_JPRB,1.4993E-01_JPRB,&
&1.6017E-01_JPRB,1.4582E-01_JPRB,2.8546E-01_JPRB/)
KAO( :, 4, 6,16) = (/&
&3.2519E-01_JPRB,2.8454E-01_JPRB,2.4391E-01_JPRB,2.0327E-01_JPRB,1.8667E-01_JPRB,2.1780E-01_JPRB,&
&2.3273E-01_JPRB,2.1193E-01_JPRB,4.1454E-01_JPRB/)
KAO( :, 5, 6,16) = (/&
&3.7997E-01_JPRB,3.3252E-01_JPRB,2.8502E-01_JPRB,2.3749E-01_JPRB,2.5973E-01_JPRB,3.0308E-01_JPRB,&
&3.2386E-01_JPRB,2.9502E-01_JPRB,5.7680E-01_JPRB/)
KAO( :, 1, 7,16) = (/&
&1.7875E-01_JPRB,1.5642E-01_JPRB,1.3408E-01_JPRB,1.1175E-01_JPRB,8.9415E-02_JPRB,8.1831E-02_JPRB,&
&8.6005E-02_JPRB,7.7323E-02_JPRB,1.4922E-01_JPRB/)
KAO( :, 2, 7,16) = (/&
&2.3257E-01_JPRB,2.0349E-01_JPRB,1.7445E-01_JPRB,1.4538E-01_JPRB,1.1631E-01_JPRB,1.0616E-01_JPRB,&
&1.1147E-01_JPRB,1.0017E-01_JPRB,1.9290E-01_JPRB/)
KAO( :, 3, 7,16) = (/&
&2.9155E-01_JPRB,2.5511E-01_JPRB,2.1872E-01_JPRB,1.8226E-01_JPRB,1.4581E-01_JPRB,1.4057E-01_JPRB,&
&1.5032E-01_JPRB,1.3703E-01_JPRB,2.6795E-01_JPRB/)
KAO( :, 4, 7,16) = (/&
&3.5453E-01_JPRB,3.1018E-01_JPRB,2.6586E-01_JPRB,2.2158E-01_JPRB,1.8072E-01_JPRB,2.1059E-01_JPRB,&
&2.2528E-01_JPRB,2.0539E-01_JPRB,4.0134E-01_JPRB/)
KAO( :, 5, 7,16) = (/&
&4.2001E-01_JPRB,3.6750E-01_JPRB,3.1500E-01_JPRB,2.6252E-01_JPRB,2.5742E-01_JPRB,3.0072E-01_JPRB,&
&3.2172E-01_JPRB,2.9345E-01_JPRB,5.7279E-01_JPRB/)
KAO( :, 1, 8,16) = (/&
&1.8184E-01_JPRB,1.5912E-01_JPRB,1.3638E-01_JPRB,1.1367E-01_JPRB,9.0918E-02_JPRB,8.3330E-02_JPRB,&
&8.7708E-02_JPRB,7.9039E-02_JPRB,1.5236E-01_JPRB/)
KAO( :, 2, 8,16) = (/&
&2.4266E-01_JPRB,2.1231E-01_JPRB,1.8198E-01_JPRB,1.5168E-01_JPRB,1.2132E-01_JPRB,1.1090E-01_JPRB,&
&1.1664E-01_JPRB,1.0501E-01_JPRB,2.0199E-01_JPRB/)
KAO( :, 3, 8,16) = (/&
&3.1060E-01_JPRB,2.7177E-01_JPRB,2.3297E-01_JPRB,1.9411E-01_JPRB,1.5532E-01_JPRB,1.4153E-01_JPRB,&
&1.4874E-01_JPRB,1.3387E-01_JPRB,2.5753E-01_JPRB/)
KAO( :, 4, 8,16) = (/&
&3.8422E-01_JPRB,3.3618E-01_JPRB,2.8820E-01_JPRB,2.4017E-01_JPRB,1.9212E-01_JPRB,2.0191E-01_JPRB,&
&2.1622E-01_JPRB,1.9751E-01_JPRB,3.8483E-01_JPRB/)
KAO( :, 5, 8,16) = (/&
&4.6183E-01_JPRB,4.0412E-01_JPRB,3.4637E-01_JPRB,2.8861E-01_JPRB,2.5332E-01_JPRB,2.9628E-01_JPRB,&
&3.1743E-01_JPRB,2.9007E-01_JPRB,5.6429E-01_JPRB/)
KAO( :, 1, 9,16) = (/&
&1.8242E-01_JPRB,1.5964E-01_JPRB,1.3685E-01_JPRB,1.1403E-01_JPRB,9.1238E-02_JPRB,8.3650E-02_JPRB,&
&8.8221E-02_JPRB,7.9647E-02_JPRB,1.5343E-01_JPRB/)
KAO( :, 2, 9,16) = (/&
&2.5031E-01_JPRB,2.1903E-01_JPRB,1.8774E-01_JPRB,1.5645E-01_JPRB,1.2518E-01_JPRB,1.1450E-01_JPRB,&
&1.2069E-01_JPRB,1.0894E-01_JPRB,2.0909E-01_JPRB/)
KAO( :, 3, 9,16) = (/&
&3.2780E-01_JPRB,2.8681E-01_JPRB,2.4582E-01_JPRB,2.0484E-01_JPRB,1.6390E-01_JPRB,1.4947E-01_JPRB,&
&1.5744E-01_JPRB,1.4207E-01_JPRB,2.7178E-01_JPRB/)
KAO( :, 4, 9,16) = (/&
&4.1288E-01_JPRB,3.6136E-01_JPRB,3.0972E-01_JPRB,2.5810E-01_JPRB,2.0648E-01_JPRB,1.9240E-01_JPRB,&
&2.0499E-01_JPRB,1.8750E-01_JPRB,3.6520E-01_JPRB/)
KAO( :, 5, 9,16) = (/&
&5.0401E-01_JPRB,4.4105E-01_JPRB,3.7793E-01_JPRB,3.1504E-01_JPRB,2.5430E-01_JPRB,2.8859E-01_JPRB,&
&3.0964E-01_JPRB,2.8367E-01_JPRB,5.5002E-01_JPRB/)
KAO( :, 1,10,16) = (/&
&1.8581E-01_JPRB,1.6259E-01_JPRB,1.3934E-01_JPRB,1.1613E-01_JPRB,9.2903E-02_JPRB,8.5148E-02_JPRB,&
&9.0034E-02_JPRB,8.1540E-02_JPRB,3.4590E-01_JPRB/)
KAO( :, 2,10,16) = (/&
&2.6163E-01_JPRB,2.2890E-01_JPRB,1.9618E-01_JPRB,1.6349E-01_JPRB,1.3077E-01_JPRB,1.1965E-01_JPRB,&
&1.2644E-01_JPRB,1.1450E-01_JPRB,3.2865E-01_JPRB/)
KAO( :, 3,10,16) = (/&
&3.4958E-01_JPRB,3.0586E-01_JPRB,2.6220E-01_JPRB,2.1849E-01_JPRB,1.7478E-01_JPRB,1.5951E-01_JPRB,&
&1.6845E-01_JPRB,1.5252E-01_JPRB,3.1204E-01_JPRB/)
KAO( :, 4,10,16) = (/&
&4.4787E-01_JPRB,3.9191E-01_JPRB,3.3594E-01_JPRB,2.7989E-01_JPRB,2.2397E-01_JPRB,2.0376E-01_JPRB,&
&2.1506E-01_JPRB,1.9478E-01_JPRB,3.7906E-01_JPRB/)
KAO( :, 5,10,16) = (/&
&5.5414E-01_JPRB,4.8494E-01_JPRB,4.1561E-01_JPRB,3.4636E-01_JPRB,2.7711E-01_JPRB,2.8690E-01_JPRB,&
&3.0857E-01_JPRB,2.8362E-01_JPRB,5.5736E-01_JPRB/)
KAO( :, 1,11,16) = (/&
&2.2387E-01_JPRB,1.9590E-01_JPRB,1.6793E-01_JPRB,1.3995E-01_JPRB,1.1196E-01_JPRB,1.0248E-01_JPRB,&
&1.0866E-01_JPRB,9.8759E-02_JPRB,9.7232E-01_JPRB/)
KAO( :, 2,11,16) = (/&
&3.1487E-01_JPRB,2.7553E-01_JPRB,2.3616E-01_JPRB,1.9682E-01_JPRB,1.5747E-01_JPRB,1.4389E-01_JPRB,&
&1.5251E-01_JPRB,1.3868E-01_JPRB,9.2352E-01_JPRB/)
KAO( :, 3,11,16) = (/&
&4.2034E-01_JPRB,3.6781E-01_JPRB,3.1526E-01_JPRB,2.6274E-01_JPRB,2.1020E-01_JPRB,1.9156E-01_JPRB,&
&2.0295E-01_JPRB,1.8465E-01_JPRB,8.7619E-01_JPRB/)
KAO( :, 4,11,16) = (/&
&5.3783E-01_JPRB,4.7062E-01_JPRB,4.0338E-01_JPRB,3.3619E-01_JPRB,2.6900E-01_JPRB,2.4463E-01_JPRB,&
&2.5910E-01_JPRB,2.3556E-01_JPRB,8.3528E-01_JPRB/)
KAO( :, 5,11,16) = (/&
&6.6465E-01_JPRB,5.8160E-01_JPRB,4.9850E-01_JPRB,4.1545E-01_JPRB,3.3262E-01_JPRB,3.4381E-01_JPRB,&
&3.7087E-01_JPRB,3.4266E-01_JPRB,8.3608E-01_JPRB/)
KAO( :, 1,12,16) = (/&
&2.6898E-01_JPRB,2.3539E-01_JPRB,2.0175E-01_JPRB,1.6812E-01_JPRB,1.3451E-01_JPRB,1.2295E-01_JPRB,&
&1.3082E-01_JPRB,1.1955E-01_JPRB,1.7254E+00_JPRB/)
KAO( :, 2,12,16) = (/&
&3.7759E-01_JPRB,3.3035E-01_JPRB,2.8322E-01_JPRB,2.3602E-01_JPRB,1.8879E-01_JPRB,1.7231E-01_JPRB,&
&1.8335E-01_JPRB,1.6769E-01_JPRB,1.6364E+00_JPRB/)
KAO( :, 3,12,16) = (/&
&5.0302E-01_JPRB,4.4026E-01_JPRB,3.7736E-01_JPRB,3.1440E-01_JPRB,2.5155E-01_JPRB,2.2898E-01_JPRB,&
&2.4369E-01_JPRB,2.2307E-01_JPRB,1.5678E+00_JPRB/)
KAO( :, 4,12,16) = (/&
&6.4249E-01_JPRB,5.6214E-01_JPRB,4.8190E-01_JPRB,4.0154E-01_JPRB,3.2127E-01_JPRB,2.9402E-01_JPRB,&
&3.1247E-01_JPRB,2.8485E-01_JPRB,1.5255E+00_JPRB/)
KAO( :, 5,12,16) = (/&
&7.9248E-01_JPRB,6.9340E-01_JPRB,5.9438E-01_JPRB,4.9520E-01_JPRB,3.9963E-01_JPRB,4.1148E-01_JPRB,&
&4.4433E-01_JPRB,4.1322E-01_JPRB,1.5412E+00_JPRB/)
KAO( :, 1,13,16) = (/&
&3.2111E-01_JPRB,2.8086E-01_JPRB,2.4080E-01_JPRB,2.0063E-01_JPRB,1.6053E-01_JPRB,1.4645E-01_JPRB,&
&1.5663E-01_JPRB,1.4415E-01_JPRB,2.4681E+00_JPRB/)
KAO( :, 2,13,16) = (/&
&4.4952E-01_JPRB,3.9337E-01_JPRB,3.3709E-01_JPRB,2.8095E-01_JPRB,2.2474E-01_JPRB,2.0495E-01_JPRB,&
&2.1909E-01_JPRB,2.0198E-01_JPRB,2.3822E+00_JPRB/)
KAO( :, 3,13,16) = (/&
&5.9739E-01_JPRB,5.2281E-01_JPRB,4.4809E-01_JPRB,3.7333E-01_JPRB,2.9881E-01_JPRB,2.7217E-01_JPRB,&
&2.9063E-01_JPRB,2.6832E-01_JPRB,2.3232E+00_JPRB/)
KAO( :, 4,13,16) = (/&
&7.6112E-01_JPRB,6.6586E-01_JPRB,5.7079E-01_JPRB,4.7570E-01_JPRB,3.8102E-01_JPRB,3.5288E-01_JPRB,&
&3.7640E-01_JPRB,3.4431E-01_JPRB,2.2950E+00_JPRB/)
KAO( :, 5,13,16) = (/&
&9.3631E-01_JPRB,8.1920E-01_JPRB,7.0224E-01_JPRB,5.8508E-01_JPRB,4.7927E-01_JPRB,4.9193E-01_JPRB,&
&5.3062E-01_JPRB,4.9592E-01_JPRB,2.3135E+00_JPRB/)

!     -----------------------------------------------------------------
RETURN
END SUBROUTINE RRTM_KGB5_A
