!
!========================================================================
!
! The following species appear on the left hand side of a reaction,
! but they are not in the list of prognostic variables. Make sure that
! they are defined elsewhere (in begin_module as TPK%something):
! H2
! O1D
! W_O2
! O3P
! H2O
! CO2
! N2
! O2
!
!========================================================================
!
! The following species appear on the right hand side of a reaction,
! but they are not in the list of prognostic variables. Make sure that
! they are really final products or defined elsewhere:
! H2
! O1D
! O3P
! H2O
! CO2
! N2
! O2
!
!========================================================================
!
! END of preprocessor comments
!
!========================================================================
!
! the chemical reactions implemented are the following ...
!
! K001=!ZRATES(:,001)::NO2-->O3P+NO
! K002=!ZRATES(:,002)::O3-->O1D+O2
! K003=!ZRATES(:,003)::O3-->O3P+O2
! K004=!ZRATES(:,004)::HONO-->OH+NO
! K005=!ZRATES(:,005)::HNO3-->OH+NO2
! K006=!ZRATES(:,006)::HNO4-->0.65*HO2+0.65*NO2+0.35*OH+0.35*NO3
! K007=!ZRATES(:,007)::NO3-->NO+O2
! K008=!ZRATES(:,008)::NO3-->NO2+O3P
! K009=!ZRATES(:,009)::H2O2-->OH+OH
! K010=!ZRATES(:,010)::HCHO-->H2+CO
! K011=!ZRATES(:,011)::HCHO-->HO2+HO2+CO
! K012=!ZRATES(:,012)::ALD-->MO2+HO2+CO
! K013=!ZRATES(:,013)::OP1-->HCHO+HO2+OH
! K014=!ZRATES(:,014)::OP2-->0.96205*ALD+0.96205*HO2+0.03795*MO2+OH
! K015=!ZRATES(:,015)::KET-->1.00000*CARBOP+1.00000*ALKAP
! K016=!ZRATES(:,016)::CARBO-->0.06517*HCHO+0.69622*CARBOP+0.75830*HO2+0.91924*CO+0.20842*H2
! K017=!ZRATES(:,017)::ONIT-->0.20*ALD+0.80*KET+HO2+NO2
! K018=TPK%M*6.00E-34*(TPK%T/300)**(-2.3)::O3P+O2-->O3
! K019=8.00E-12*exp(-(2060.0/TPK%T))::O3P+O3-->2.0*O2
! K020=1.80E-11*exp(-(-110.0/TPK%T))::O1D+N2-->O3P+N2
! K021=3.20E-11*exp(-(-70.0/TPK%T))::O1D+O2-->O3P+O2
! K022=2.20E-10::O1D+H2O-->OH+OH
! K023=1.60E-12*exp(-(940.0/TPK%T))::O3+OH-->HO2+O2
! K024=1.10E-14*exp(-(500.0/TPK%T))::O3+HO2-->OH+2.0*O2
! K025=4.80E-11*exp(-(-250.0/TPK%T))::OH+HO2-->H2O+O2
! K026=2.90E-12*exp(-(160.0/TPK%T))::H2O2+OH-->HO2+H2O
! K027=2.3E-13*EXP(600./TPK%T)+1.7E-33*TPK%M*EXP(1000./TPK%T)::HO2+HO2-->H2O2+O2
! K028=3.22E-34*EXP(2800./TPK%T)+2.38E-54*TPK%M*EXP(3200./TPK%T)::HO2+HO2+H2O-->H2O2+H2O+O2
! K029=@TROE(1.,9.00E-32,1.5,3.00E-11,0.0,TPK%M,TPK%T,KVECNPT)::O3P+NO-->NO2
! K030=6.50E-12*exp(-(-120.0/TPK%T))::O3P+NO2-->NO+O2
! K031=@TROE(1.,9.00E-32,2.0,2.20E-11,0.0,TPK%M,TPK%T,KVECNPT)::O3P+NO2-->NO3
! K032=@TROE(1.,7.00E-31,2.6,1.50E-11,0.5,TPK%M,TPK%T,KVECNPT)::OH+NO-->HONO
! K033=@TROE(1.,2.60E-30,3.2,2.40E-11,1.3,TPK%M,TPK%T,KVECNPT)::OH+NO2-->HNO3
! K034=2.20E-11::OH+NO3-->NO2+HO2
! K035=3.70E-12*exp(-(-250.0/TPK%T))::HO2+NO-->NO2+OH
! K036=@TROE(1.,1.80E-31,3.2,4.70E-12,1.4,TPK%M,TPK%T,KVECNPT)::HO2+NO2-->HNO4
! K037=@TROE_EQUIL(1.80E-31,3.2,4.70E-12,1.4,4.76E+26,10900.,TPK%M,TPK%T,KVECNPT)::HNO4-->HO2+NO2
! K038=3.50E-12::HO2+NO3-->0.3*HNO3+0.7*NO2+0.7*OH
! K039=1.80E-11*exp(-(390.0/TPK%T))::OH+HONO-->H2O+NO2
! K040=(7.2E-15*EXP(785/TPK%T))+(1.9E-33*EXP(725/TPK%T)*TPK%M)/(1+(1.9E-33*EXP(725/TPK%T)*TPK%M)/(4.1E-16*EXP(1440/TPK%T)))::OH+HNO3-->NO3+H2O
! K041=1.30E-12*exp(-(-380.0/TPK%T))::OH+HNO4-->NO2+H2O+O2
! K042=2.00E-12*exp(-(1400.0/TPK%T))::O3+NO-->NO2+O2
! K043=1.20E-13*exp(-(2450.0/TPK%T))::O3+NO2-->NO3+O2
! K044=3.30E-39*exp(-(-530.0/TPK%T))::NO+NO+O2-->NO2+NO2
! K045=1.50E-11*exp(-(-170.0/TPK%T))::NO3+NO-->NO2+NO2
! K046=4.50E-14*exp(-(1260.0/TPK%T))::NO3+NO2-->NO+NO2+O2
! K047=@TROE(1.,2.20E-30,3.9,1.50E-12,0.7,TPK%M,TPK%T,KVECNPT)::NO3+NO2-->N2O5
! K048=@TROE_EQUIL(2.20E-30,3.9,1.50E-12,0.7,3.70E+26,11000.0,TPK%M,TPK%T,KVECNPT)::N2O5-->NO2+NO3
! K049=8.50E-13*exp(-(2450.0/TPK%T))::NO3+NO3-->NO2+NO2+O2
! K050=3.30E-12*exp(-(900.0/TPK%T))::NH3+OH-->
! K051=5.50E-12*exp(-(2000.0/TPK%T))::OH+H2-->H2O+HO2
! K052=@TROE(1.,3.00E-31,3.3,1.50E-12,0.0,TPK%M,TPK%T,KVECNPT)::OH+SO2-->SULF+HO2
! K053=1.5E-13*(1.+2.439E-20*TPK%M)::CO+OH-->HO2+CO2
! K054=6.00E-11::BIO+O3P-->0.91868*ALKE+0.05*HCHO+0.02*OH+0.01*CO+0.13255*CARBO+0.28*HO2+0.15*XO2
! K055=0.00E-01*exp(-(-13.0/TPK%T))::CARBO+O3P-->ALD
! K056=TPK%T*TPK%T*7.44E-18*exp(-(1361./TPK%T))::CH4+OH-->MO2+H2O
! K057=1.51E-17*TPK%T*TPK%T*exp(-(492./TPK%T))::ETH+OH-->ALKAP
! K058=3.76E-12*exp(-(260.0/TPK%T))+1.70E-12*exp(-(155.0/TPK%T))+1.21E-12*exp(-(125.0/TPK%T))::ALKA+OH-->0.87811*ALKAP+0.12793*HO2+0.08173*ALD+0.03498*KET+0.00835*CARBO+0.00140*HCHO+0.00878*ORA1+0.00878*CO+0.00878*OH+H2O
! K059=1.78E-12*exp(-(-438.0/TPK%T))+6.07E-13*exp(-(-500.0/TPK%T))+0.00E-01*exp(-(-448.0/TPK%T))::ALKE+OH-->1.02529*ALKEP+0.00000*BIOP
! K060=2.54E-11*exp(-(-410.0/TPK%T))+0.00E-01*exp(-(-444.0/TPK%T))+0.00E-01::BIO+OH-->1.00000*BIOP
! K061=3.31E-12*exp(-(-355.0/TPK%T))+3.45E-13::ARO+OH-->0.93968*ADD+0.10318*XO2+0.10318*HO2+0.00276*PHO
! K062=1.00E-11::HCHO+OH-->HO2+CO+H2O
! K063=5.55E-12*exp(-(-331.0/TPK%T))::ALD+OH-->1.00000*CARBOP+H2O
! K064=TPK%T*TPK%T*5.68E-18*exp(-(-92.0/TPK%T))::KET+OH-->1.00000*CARBOP+H2O
! K065=1.32E-11+1.88E-12*exp(-(-175.0/TPK%T))::CARBO+OH-->0.51419*CARBOP+0.16919*CARBO+1.01732*CO+0.51208*HO2+0.00000*HCHO+0.06253*ALD+0.00853*KET+0.10162*XO2+0.75196*H2O
! K066=4.50E-13::ORA1+OH-->HO2+CO2+H2O
! K067=6.00E-13::ORA2+OH-->
! K068=2.93E-12*exp(-(-190.0/TPK%T))::OP1+OH-->0.65*MO2+0.35*HCHO+0.35*OH
! K069=3.36E-12*exp(-(-190.0/TPK%T))::OP2+OH-->0.40341*ALKAP+0.05413*CARBOP+0.07335*ALD+0.37591*KET+0.09333*XO2+0.02915*HO2+0.02915*HCHO+0.44925*OH
! K070=3.80E-14+1.59E-14*exp(-(-500.0/TPK%T))::PAN+OH-->0.57839*HCHO+0.21863*CARBO+0.71893*NO3+0.28107*PAN+0.28107*HO2+0.29733*H2O+XO2
! K071=5.31E-12*exp(-(260.0/TPK%T))::ONIT+OH-->1.00000*ALKAP+NO2+H2O
! K072=3.40E-13*exp(-(1900.0/TPK%T))::HCHO+NO3-->HO2+HNO3+CO
! K073=1.40E-12*exp(-(1900.0/TPK%T))::ALD+NO3-->1.00000*CARBOP+HNO3
! K074=1.62E-12*exp(-(1900.0/TPK%T))+0.00E-01*exp(-(150.0/TPK%T))+1.94E-14*exp(-(1000.0/TPK%T))::CARBO+NO3-->0.91567*HNO3+0.38881*CARBOP+0.10530*CARBO+0.05265*ALD+0.00632*KET+0.10530*NO2+0.10530*XO2+0.63217*HO2+1.33723*CO+0.00000*OLN
! K075=4.92E-16::ARO+NO3-->HNO3+PHO
! K076=4.35E-18*TPK%T*TPK%T*exp(-(2282.0/TPK%T))+1.91E-14*exp(-(450.0/TPK%T))+1.08E-15*exp(-(-450.0/TPK%T))+0.00E-01::ALKE+NO3-->0.00000*CARBO+0.93768*OLN
! K077=4.00E-12*exp(-(446.0/TPK%T))+0.00E-01*exp(-(-490.0/TPK%T))+0.00E-01::BIO+NO3-->0.91741*CARBO+1.00000*OLN
! K078=3.76E-16*exp(-(500.0/TPK%T))::PAN+NO3-->0.60*ONIT+0.60*NO3+0.40000*PAN+0.40*HCHO+0.40*NO2+XO2
! K079=8.17E-15*exp(-(2580.0/TPK%T))+4.32E-16*exp(-(1800.0/TPK%T))+2.87E-17*exp(-(845.0/TPK%T))+0.00E-01*exp(-(2283.0/TPK%T))::ALKE+O3-->0.48290*HCHO+0.51468*ALD+0.07377*KET+0.00000*CARBO+0.35120*CO+0.15343*ORA1+0.08143*ORA2+0.23451*HO2+0.39435*OH+0.05705*CARBOP+0.03196*ETH+0.00000*ALKE+0.04300*CH4+0.13966*MO2+0.09815*ALKAP+0.01833*H2O2+0.00000*XO2+0.05409*H2+0.00000*O3P
! K080=7.86E-15*exp(-(1913.0/TPK%T))+0.00E-01*exp(-(732.0/TPK%T))+0.00E-01::BIO+O3-->0.90000*HCHO+0.00000*ALD+0.00000*KET+0.39754*CARBO+0.36000*CO+0.37388*ALKE+0.00000*ALKAP+0.17000*CARBOP+0.03000*MO2+0.15000*ORA1+0.00000*ORA2+0.28000*OH+0.30000*HO2+0.00100*H2O2+0.05000*H2+0.13000*XO2+0.09000*O3P
! K081=0.00E-01*exp(-(2112.0/TPK%T))+1.38E-19::CARBO+O3-->0.00000*HCHO+1.07583*CARBO+0.15692*ALD+0.10788*ORA1+0.20595*ORA2+0.27460*CARBOP+0.10149*OP2+0.64728*CO+0.28441*HO2+0.20595*OH+0.00000*H2
! K082=7.20E-17*exp(-(1700.0/TPK%T))::PAN+O3-->0.70*HCHO+0.30000*PAN+0.70*NO2+0.13*CO+0.04*H2+0.11*ORA1+0.08*HO2+0.036*OH+0.70000*CARBOP
! K083=2.00E-11::PHO+NO2-->0.10670*ARO+ONIT
! K084=1.00E-11::PHO+HO2-->1.06698*ARO
! K085=3.60E-11::ADD+NO2-->ARO+HONO
! K086=1.66E-17*exp(-(-1044.0/TPK%T))::ADD+O2-->0.98*AROP+0.02*ARO+0.02*HO2
! K087=2.80E-11::ADD+O3-->ARO+OH
! K088=@TROE(5.86E-01,9.70E-29,5.6,9.30E-12,1.5,TPK%M,TPK%T,KVECNPT)::CARBOP+NO2-->1.00000*PAN
! K089=@TROE_EQUIL(9.70E-29,5.6,9.30E-12,1.5,1.16E+28,13954.,TPK%M,TPK%T,KVECNPT)::PAN-->1.00000*CARBOP+NO2
! K090=4.20E-12*exp(-(-180.0/TPK%T))::MO2+NO-->HCHO+HO2+NO2
! K091=4.36E-12::ALKAP+NO-->0.33144*ALD+0.03002*HCHO+0.54531*KET+0.03407*CARBO+0.74265*HO2+0.09016*MO2+0.08187*ALKAP+0.13007*XO2+0.08459*ONIT+0.91541*NO2
! K092=6.93E-12::ALKEP+NO-->1.39870*HCHO+0.42125*ALD+0.05220*KET+HO2+NO2
! K093=4.00E-12::BIOP+NO-->0.45463*CARBO+0.60600*HCHO+0.00000*ALD+0.00000*KET+0.37815*ALKE+0.84700*HO2+0.84700*NO2+0.15300*ONIT
! K094=4.00E-12::AROP+NO-->0.95115*NO2+0.95115*HO2+2.06993*CARBO+0.04885*ONIT
! K095=1.22E-11::CARBOP+NO-->0.78134*MO2+0.09532*CARBOP+0.05848*HCHO+0.07368*ALD+0.08670*CARBO+0.12334*HO2+0.02563*XO2+NO2
! K096=4.00E-12::OLN+NO-->0.18401*ONIT+1.81599*NO2+0.18401*HO2+0.23419*HCHO+1.01182*ALD+0.37862*KET
! K097=3.80E-13*exp(-(-800.0/TPK%T))::MO2+HO2-->OP1
! K098=6.16E-14*exp(-(-700.0/TPK%T))+1.52E-13*exp(-(-1300.0/TPK%T))::ALKAP+HO2-->1.00524*OP2
! K099=1.81E-13*exp(-(-1300.0/TPK%T))::ALKEP+HO2-->1.00524*OP2
! K0100=1.28E-13*exp(-(-1300.0/TPK%T))+0.00E-01::BIOP+HO2-->1.00524*OP2
! K0101=3.75E-13*exp(-(-980.0/TPK%T))::AROP+HO2-->1.00524*OP2
! K0102=5.94E-13*exp(-(-550.0/TPK%T))+1.99E-16*exp(-(-2640.0/TPK%T))+5.56E-14*exp(-(-1300.0/TPK%T))::CARBOP+HO2-->0.80904*OP2+0.17307*ORA2+0.17307*O3
! K103=1.66E-13*exp(-(-1300.0/TPK%T))::OLN+HO2-->ONIT
! K104=9.10E-14*exp(-(-416.0/TPK%T))::MO2+MO2-->1.33*HCHO+0.66*HO2
! K105=1.03E-14*exp(-(-158.0/TPK%T))+6.24E-14*exp(-(-431.0/TPK%T))+1.53E-14*exp(-(-467.0/TPK%T))+4.34E-15*exp(-(-633.0/TPK%T))::ALKAP+MO2-->0.80556*HCHO+0.98383*HO2+0.56070*ALD+0.09673*KET+0.01390*MO2+0.07976*CARBO+0.13370*XO2+0.00385*ALKAP
! K106=1.57E-13*exp(-(-708.0/TPK%T))::ALKEP+MO2-->1.42894*HCHO+0.46413*ALD+0.03814*KET+HO2
! K107=1.36E-13*exp(-(-708.0/TPK%T))::BIOP+MO2-->0.56064*CARBO+0.48074*ALKE+1.00000*HO2+1.09000*HCHO+0.00000*ALD+0.00000*KET
! K108=3.56E-14*exp(-(-708.0/TPK%T))::AROP+MO2-->HCHO+1.02767*HO2+1.99461*CARBO
! K109=1.77E-11*exp(-(440.0/TPK%T))+1.48E-16*exp(-(-2510.0/TPK%T))+3.10E-13*exp(-(-508.0/TPK%T))::CARBOP+MO2-->0.95723*HCHO+0.82998*HO2+0.56031*MO2+0.13684*ORA2+0.05954*CARBOP+0.15387*CARBO+0.08295*ALD+0.02212*XO2
! K110=1.12E-13*exp(-(-708.0/TPK%T))::OLN+MO2-->0.88625*HCHO+0.67560*HO2+0.67560*ONIT+0.41524*ALD+0.09667*KET+0.32440*NO2
! K111=4.44E-14*exp(-(-211.0/TPK%T))+2.23E-13*exp(-(-460.0/TPK%T))+4.10E-14*exp(-(-522.0/TPK%T))+1.17E-14*exp(-(-683.0/TPK%T))::ALKAP+CARBOP-->0.71461*ALD+0.48079*HO2+0.51480*MO2+0.49810*ORA2+0.18819*KET+0.07600*HCHO+0.00828*ALKAP+0.11306*XO2+0.06954*CARBO
! K112=4.36E-13*exp(-(-765.0/TPK%T))::ALKEP+CARBOP-->0.68192*HCHO+0.68374*ALD+0.50078*HO2+0.50078*MO2+0.49922*ORA2+0.06579*KET
! K113=7.60E-13*exp(-(-765.0/TPK%T))::BIOP+CARBOP-->0.78591*CARBO+0.24463*ALKE+0.50600*HO2+0.49400*ORA2+0.34000*HCHO+0.50600*MO2+0.00000*ALD+0.00000*KET
! K114=3.63E-13*exp(-(-765.0/TPK%T))::AROP+CARBOP-->MO2+HO2+1.99455*CARBO
! K115=7.73E-13*exp(-(-530.0/TPK%T))+1.70E-13*exp(-(-565.0/TPK%T))::CARBOP+CARBOP-->1.66702*MO2+0.05821*CARBOP+0.03432*HCHO+0.10777*CARBO+0.06969*ALD+0.02190*KET+0.07566*HO2+0.01593*XO2+0.09955*ORA2
! K116=4.85E-13*exp(-(-765.0/TPK%T))::OLN+CARBOP-->0.66562*ONIT+0.51037*MO2+0.48963*ORA2+0.17599*HO2+0.13414*HCHO+0.42122*ALD+0.10822*KET+0.00000*NO2
! K117=4.19E-15*exp(-(-1000.0/TPK%T))::OLN+OLN-->2.00*ONIT+HO2
! K118=2.48E-14*exp(-(-1000.0/TPK%T))::OLN+OLN-->0.00000*HCHO+0.00000*ALD+0.00000*KET+0.00000*HO2+0.00000*NO2+0.00000*ONIT
! K119=1.20E-12::MO2+NO3-->HCHO+HO2+NO2
! K120=1.20E-12::ALKAP+NO3-->0.33743*ALD+0.81290*HO2+0.03142*HCHO+0.62978*KET+0.03531*CARBO+0.09731*MO2+0.08994*ALKAP+0.16271*XO2+NO2
! K121=1.20E-12::ALKEP+NO3-->1.40909*HCHO+0.43039*ALD+0.02051*KET+HO2+NO2
! K122=1.20E-12::BIOP+NO3-->0.61160*CARBO+0.42729*ALKE+0.68600*HCHO+0.00000*ALD+0.00000*KET+HO2+NO2
! K123=1.20E-12::AROP+NO3-->2.81904*CARBO+HO2+NO2
! K124=3.48E-12::CARBOP+NO3-->0.91910*MO2+0.03175*CARBOP+0.03175*HCHO+0.03455*CARBO+0.02936*ALD+0.04915*HO2+0.01021*XO2+NO2
! K125=1.20E-12::OLN+NO3-->0.25928*ONIT+1.74072*NO2+0.25928*HO2+0.20740*HCHO+0.91850*ALD+0.34740*KET
! K126=1.66E-13*exp(-(-1300.0/TPK%T))::XO2+HO2-->1.00524*OP2
! K127=5.99E-15*exp(-(-1510.0/TPK%T))::XO2+MO2-->HCHO+HO2
! K128=1.69E-14*exp(-(-1560.0/TPK%T))::XO2+CARBOP-->MO2
! K129=7.13E-17*exp(-(-2950.0/TPK%T))::XO2+XO2-->
! K130=4.00E-12::XO2+NO-->NO2
! K131=1.20E-12::XO2+NO3-->NO2
! K132=1.00E-40::SULF-->
! KTC1=@KT(0.05,48.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::O3-->WC_O3
! KTC2=@KT(0.11,34.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::H2O2-->WC_H2O2
! KTC3=@KT(0.0001,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NO-->WC_NO
! KTC4=@KT(0.0015,46.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NO2-->WC_NO2
! KTC5=@KT(0.05,62.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NO3-->WC_NO3
! KTC6=@KT(0.0037,108.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::N2O5-->WC_N2O5
! KTC7=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HONO-->WC_HONO
! KTC8=@KT(0.054,63.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HNO3-->WC_HNO3
! KTC9=@KT(0.05,79.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HNO4-->WC_HNO4
! KTC10=@KT(0.04,17.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NH3-->WC_NH3
! KTC11=@KT(0.05,17.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::OH-->WC_OH
! KTC12=@KT(0.2,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HO2-->WC_HO2
! KTC13=@KT(0.0002,44.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::CO2-->WC_CO2
! KTC14=@KT(0.11,64.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::SO2-->WC_SO2
! KTC15=@KT(0.07,98.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::SULF-->WC_SULF
! KTC16=@KT(0.04,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HCHO-->WC_HCHO
! KTC17=@KT(0.012,46.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::ORA1-->WC_ORA1
! KTC18=@KT(0.03,60.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::ORA2-->WC_ORA2
! KTC19=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::MO2-->WC_MO2
! KTC20=@KT(0.007,48.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::OP1-->WC_OP1
! KTC21=@KT(0.05,48.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(1.1e-2,-2830.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_O3-->O3
! KTC22=@KT(0.11,34.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(7.73e4,-7310.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_H2O2-->H2O2
! KTC23=@KT(0.0001,30.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(1.92e-3,-1790.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NO-->NO
! KTC24=@KT(0.0015,46.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(1.4e-2,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NO2-->NO2
! KTC25=@KT(0.05,62.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.8e-2,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NO3-->NO3
! KTC26=@KT(0.0037,108.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(2.1,-3400.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_N2O5-->N2O5
! KTC27=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(5.0e1,-4880.,1.6e-3,1760.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HONO-->HONO
! KTC28=@KT(0.054,63.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(2.1e5,-8700.,2.2e1,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HNO3-->HNO3
! KTC29=@KT(0.05,79.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(1.2e4,-6900.,1.26e-6,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HNO4-->HNO4
! KTC30=@KT(0.04,17.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFB(6.02e1,-4160.,1.7e-5,4350.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NH3-->NH3
! KTC31=@KT(0.05,17.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.9e1,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_OH-->OH
! KTC32=@KT(0.2,30.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(6.9e2,0.,1.6e-5,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HO2-->HO2
! KTC33=@KT(0.0002,44.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(3.4e-2,-2710.,4.3e-7,920.,4.7e-11,1780.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_CO2-->CO2
! KTC34=@KT(0.11,64.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(1.36,-2930.,1.3e-2,-1965.,6.4e-8,-1430.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_SO2-->SO2
! KTC35=@KT(0.07,98.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(2.1e5,-8700.,1.0e3,0.,1.0e-2,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_SULF-->SULF
! KTC36=@KT(0.04,30.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.23e3,-7100.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HCHO-->HCHO
! KTC37=@KT(0.012,46.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(8.9e3,-6100.,1.8e-4,150.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_ORA1-->ORA1
! KTC38=@KT(0.03,60.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(4.1e3,-6200.,1.74e-5,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_ORA2-->ORA2
! KTC39=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(2.7e0,-2030.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_MO2-->MO2
! KTC40=@KT(0.007,48.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.e2,-5280.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_OP1-->OP1
! KTR1=@KT(0.05,48.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::O3-->WR_O3
! KTR2=@KT(0.11,34.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::H2O2-->WR_H2O2
! KTR3=@KT(0.0001,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NO-->WR_NO
! KTR4=@KT(0.0015,46.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NO2-->WR_NO2
! KTR5=@KT(0.05,62.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NO3-->WR_NO3
! KTR6=@KT(0.0037,108.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::N2O5-->WR_N2O5
! KTR7=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HONO-->WR_HONO
! KTR8=@KT(0.054,63.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HNO3-->WR_HNO3
! KTR9=@KT(0.05,79.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HNO4-->WR_HNO4
! KTR10=@KT(0.04,17.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NH3-->WR_NH3
! KTR11=@KT(0.05,17.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::OH-->WR_OH
! KTR12=@KT(0.2,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HO2-->WR_HO2
! KTR13=@KT(0.0002,44.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::CO2-->WR_CO2
! KTR14=@KT(0.11,64.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::SO2-->WR_SO2
! KTR15=@KT(0.07,98.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::SULF-->WR_SULF
! KTR16=@KT(0.04,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HCHO-->WR_HCHO
! KTR17=@KT(0.012,46.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::ORA1-->WR_ORA1
! KTR18=@KT(0.03,60.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::ORA2-->WR_ORA2
! KTR19=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::MO2-->WR_MO2
! KTR20=@KT(0.007,48.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::OP1-->WR_OP1
! KTR21=@KT(0.05,48.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(1.1e-2,-2830.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_O3-->O3
! KTR22=@KT(0.11,34.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(7.73e4,-7310.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_H2O2-->H2O2
! KTR23=@KT(0.0001,30.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(1.92e-3,-1790.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NO-->NO
! KTR24=@KT(0.0015,46.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(1.4e-2,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NO2-->NO2
! KTR25=@KT(0.05,62.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.8e-2,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NO3-->NO3
! KTR26=@KT(0.0037,108.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(2.1,-3400.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_N2O5-->N2O5
! KTR27=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(5.0e1,-4880.,1.6e-3,1760.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HONO-->HONO
! KTR28=@KT(0.054,63.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(2.1e5,-8700.,2.2e1,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HNO3-->HNO3
! KTR29=@KT(0.05,79.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(1.2e4,-6900.,1.26e-6,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HNO4-->HNO4
! KTR30=@KT(0.04,17.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFB(6.02e1,-4160.,1.7e-5,4350.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NH3-->NH3
! KTR31=@KT(0.05,17.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.9e1,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_OH-->OH
! KTR32=@KT(0.2,30.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(6.9e2,0.,1.6e-5,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HO2-->HO2
! KTR33=@KT(0.0002,44.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(3.4e-2,-2710.,4.3e-7,920.,4.7e-11,1780.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_CO2-->CO2
! KTR34=@KT(0.11,64.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(1.36,-2930.,1.3e-2,-1965.,6.4e-8,-1430.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_SO2-->SO2
! KTR35=@KT(0.07,98.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(2.1e5,-8700.,1.0e3,0.,1.0e-2,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_SULF-->SULF
! KTR36=@KT(0.04,30.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.23e3,-7100.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HCHO-->HCHO
! KTR37=@KT(0.012,46.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(8.9e3,-6100.,1.8e-4,150.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_ORA1-->ORA1
! KTR38=@KT(0.03,60.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(4.1e3,-6200.,1.74e-5,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_ORA2-->ORA2
! KTR39=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(2.7e0,-2030.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_MO2-->MO2
! KTR40=@KT(0.007,48.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.e2,-5280.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_OP1-->OP1
! KC1=!ZRATES(:,018)::WC_H2O2-->WC_OH+WC_OH
! KC2=(3.6E+9*exp(-930.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD::WC_OH+WC_OH-->WC_H2O2
! KC3=((2.8E+10*10.**(-TPK%PHC)+3.5E+10*exp(-720.*(1./TPK%T-1./298.15))*1.6e-5)/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_OH+WC_HO2-->
! KC4=(3.2E+7*exp(-1700.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD::WC_H2O2+WC_OH-->WC_HO2
! KC5=((8.3E+5*exp(-2700.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHC))**2.+9.6E+7*exp(-910.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*1.6e-5)/(1.6e-5+10.**(-TPK%PHC))**2.)/TPK%MOL2MOLECCLOUD::WC_HO2+WC_HO2-->WC_H2O2
! KC6=(1.5E+9*exp(-1500.*(1./TPK%T-1./298.15))*1.6e-5/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_O3+WC_HO2-->WC_OH
! KC7=(2.7E+9*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_OH+WC_SO2-->WC_ASO3
! KC8=(1.0E+10*10.**(-TPK%PHC)/(1.6e-3*exp(-1760.*(1./TPK%T-1./298.15))+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_HONO+WC_OH-->WC_NO2
! KC9=((1.8E+9*10.**(-TPK%PHC)+4.5E+9*1.6e-5)/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_NO2+WC_HO2-->WC_HNO4
! KC10=2.6E-2*10.**(-TPK%PHC)/(1.26e-6+10.**(-TPK%PHC))::WC_HNO4-->WC_HO2+WC_NO2
! KC11=1.1E0*1.26e-6/(1.26e-6+10.**(-TPK%PHC))::WC_HNO4-->WC_HONO
! KC12=(3.3E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHC))**2./((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.)*(1.26e-6+10.**(-TPK%PHC))))/TPK%MOL2MOLECCLOUD::WC_HNO4+WC_SO2-->WC_SULF+WC_HNO3
! KC13=!ZRATES(:,019)*2.2e+1/(2.2e+1+10.**(-TPK%PHC))::WC_HNO3-->WC_NO2+WC_OH
! KC14=1.0E+10::WC_N2O5-->WC_HNO3+WC_HNO3
! KC15=(1.0E+5*1.0e+3*1.0e-2/(1.0e+3*1.0e-2+1.0e+3*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_NO3+WC_SULF-->WC_HNO3+WC_ASO4
! KC16=(1.3E+9*exp(-2200.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_NO3+WC_SO2-->WC_HNO3+WC_ASO3
! KC17=(1.7E+8*exp(-2200.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD::WC_MO2+WC_MO2-->2.00*WC_HCHO+2.00*WC_HO2
! KC18=(5.0E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_MO2+WC_SO2-->WC_OP1+WC_ASO3
! KC19=(7.8E+8*exp(-1000.*(1./TPK%T-1./298.15))*2.5e3*exp(4030.*(1./TPK%T-1./298.15))/(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15))))/TPK%MOL2MOLECCLOUD::WC_HCHO+WC_OH-->WC_ORA1+WC_HO2
! KC20=((1.0E+8*exp(-1000.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+3.4E+9*exp(-1200.*(1./TPK%T-1./298.15))*1.8e-4*exp(150.*(1./TPK%T-1./298.15)))/(1.8e-4*exp(150.*(1./TPK%T-1./298.15))+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_ORA1+WC_OH-->WC_CO2+WC_HO2
! KC21=((7.9E+2*exp(-2900.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+2.5E+7*exp(-2450.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.)*(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15)))))/TPK%MOL2MOLECCLOUD::WC_SO2+WC_HCHO-->WC_AHMS
! KC22=7.7E-3*exp(-9200.*(1./TPK%T-1./298.15))+3.7E+3*1.e-14*EXP(-6716*(1./TPK%T-1./298.15))/10.**(-TPK%PHC)::WC_AHMS-->WC_SO2+WC_HCHO
! KC23=3.0E+8/TPK%MOL2MOLECCLOUD::WC_AHMS+WC_OH-->WC_HO2+WC_ORA1+WC_SO2
! KC24=1.1E+9::WC_ASO3+W_O2-->WC_ASO5
! KC25=(1.7E+9*10.**(-TPK%PHC)/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_ASO5+WC_HO2-->WC_AHSO5
! KC26=(2.2E+8*exp(-2600.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD::WC_ASO5+WC_ASO5-->WC_ASO4+WC_ASO4
! KC27=(7.1E+6*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_AHSO5+WC_SO2-->2.00*WC_SULF
! KC28=4.6E+2*exp(-1100.*(1./TPK%T-1./298.15))::WC_ASO4-->WC_SULF+WC_OH
! KC29=((3.7E+5*exp(-5500.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+1.5E+9*exp(-5300.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_SO2+WC_O3-->WC_SULF
! KC30=(9.1E+7*exp(-3600.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_SO2+WC_H2O2-->WC_SULF
! KR1=!ZRATES(:,018)::WR_H2O2-->WR_OH+WR_OH
! KR2=(3.6E+9*exp(-930.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN::WR_OH+WR_OH-->WR_H2O2
! KR3=((2.8E+10*10.**(-TPK%PHR)+3.5E+10*exp(-720.*(1./TPK%T-1./298.15))*1.6e-5)/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_OH+WR_HO2-->
! KR4=(3.2E+7*exp(-1700.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN::WR_H2O2+WR_OH-->WR_HO2
! KR5=((8.3E+5*exp(-2700.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHR))**2.+9.6E+7*exp(-910.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*1.6e-5)/(1.6e-5+10.**(-TPK%PHR))**2.)/TPK%MOL2MOLECRAIN::WR_HO2+WR_HO2-->WR_H2O2
! KR6=(1.5E+9*exp(-1500.*(1./TPK%T-1./298.15))*1.6e-5/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_O3+WR_HO2-->WR_OH
! KR7=(2.7E+9*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_OH+WR_SO2-->WR_ASO3
! KR8=(1.0E+10*10.**(-TPK%PHR)/(1.6e-3*exp(-1760.*(1./TPK%T-1./298.15))+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_HONO+WR_OH-->WR_NO2
! KR9=((1.8E+9*10.**(-TPK%PHR)+4.5E+9*1.6e-5)/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_NO2+WR_HO2-->WR_HNO4
! KR10=2.6E-2*10.**(-TPK%PHR)/(1.26e-6+10.**(-TPK%PHR))::WR_HNO4-->WR_HO2+WR_NO2
! KR11=1.1E0*1.26e-6/(1.26e-6+10.**(-TPK%PHR))::WR_HNO4-->WR_HONO
! KR12=(3.3E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHR))**2./((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.)*(1.26e-6+10.**(-TPK%PHR))))/TPK%MOL2MOLECRAIN::WR_HNO4+WR_SO2-->WR_SULF+WR_HNO3
! KR13=!ZRATES(:,019)*2.2e+1/(2.2e+1+10.**(-TPK%PHR))::WR_HNO3-->WR_NO2+WR_OH
! KR14=1.0E+10::WR_N2O5-->WR_HNO3+WR_HNO3
! KR15=(1.0E+5*1.0e+3*1.0e-2/(1.0e+3*1.0e-2+1.0e+3*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_NO3+WR_SULF-->WR_HNO3+WR_ASO4
! KR16=(1.3E+9*exp(-2200.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_NO3+WR_SO2-->WR_HNO3+WR_ASO3
! KR17=(1.7E+8*exp(-2200.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN::WR_MO2+WR_MO2-->2.00*WR_HCHO+2.00*WR_HO2
! KR18=(5.0E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_MO2+WR_SO2-->WR_OP1+WR_ASO3
! KR19=(7.8E+8*exp(-1000.*(1./TPK%T-1./298.15))*2.5e3*exp(4030.*(1./TPK%T-1./298.15))/(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15))))/TPK%MOL2MOLECRAIN::WR_HCHO+WR_OH-->WR_ORA1+WR_HO2
! KR20=((1.0E+8*exp(-1000.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+3.4E+9*exp(-1200.*(1./TPK%T-1./298.15))*1.8e-4*exp(150.*(1./TPK%T-1./298.15)))/(1.8e-4*exp(150.*(1./TPK%T-1./298.15))+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_ORA1+WR_OH-->WR_CO2+WR_HO2
! KR21=((7.9E+2*exp(-2900.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+2.5E+7*exp(-2450.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.)*(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15)))))/TPK%MOL2MOLECRAIN::WR_SO2+WR_HCHO-->WR_AHMS
! KR22=7.7E-3*exp(-9200.*(1./TPK%T-1./298.15))+3.7E+3*1.e-14*EXP(-6716*(1./TPK%T-1./298.15))/10.**(-TPK%PHR)::WR_AHMS-->WR_SO2+WR_HCHO
! KR23=3.0E+8/TPK%MOL2MOLECRAIN::WR_AHMS+WR_OH-->WR_HO2+WR_ORA1+WR_SO2
! KR24=1.1E+9::WR_ASO3+W_O2-->WR_ASO5
! KR25=(1.7E+9*10.**(-TPK%PHR)/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_ASO5+WR_HO2-->WR_AHSO5
! KR26=(2.2E+8*exp(-2600.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN::WR_ASO5+WR_ASO5-->WR_ASO4+WR_ASO4
! KR27=(7.1E+6*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_AHSO5+WR_SO2-->2.00*WR_SULF
! KR28=4.6E+2*exp(-1100.*(1./TPK%T-1./298.15))::WR_ASO4-->WR_SULF+WR_OH
! KR29=((3.7E+5*exp(-5500.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+1.5E+9*exp(-5300.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_SO2+WR_O3-->WR_SULF
! KR30=(9.1E+7*exp(-3600.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_SO2+WR_H2O2-->WR_SULF
!
!========================================================================
!
! the prognostic chemical species are the following ...
!
! 1.	O3	PCONC(:,1)
! 2.	H2O2	PCONC(:,2)
! 3.	NO	PCONC(:,3)
! 4.	NO2	PCONC(:,4)
! 5.	NO3	PCONC(:,5)
! 6.	N2O5	PCONC(:,6)
! 7.	HONO	PCONC(:,7)
! 8.	HNO3	PCONC(:,8)
! 9.	HNO4	PCONC(:,9)
! 10.	NH3	PCONC(:,10)
! 11.	SO2	PCONC(:,11)
! 12.	SULF	PCONC(:,12)
! 13.	CO	PCONC(:,13)
! 14.	OH	PCONC(:,14)
! 15.	HO2	PCONC(:,15)
! 16.	CH4	PCONC(:,16)
! 17.	ETH	PCONC(:,17)
! 18.	ALKA	PCONC(:,18)
! 19.	ALKE	PCONC(:,19)
! 20.	BIO	PCONC(:,20)
! 21.	ARO	PCONC(:,21)
! 22.	HCHO	PCONC(:,22)
! 23.	ALD	PCONC(:,23)
! 24.	KET	PCONC(:,24)
! 25.	CARBO	PCONC(:,25)
! 26.	ONIT	PCONC(:,26)
! 27.	PAN	PCONC(:,27)
! 28.	OP1	PCONC(:,28)
! 29.	OP2	PCONC(:,29)
! 30.	ORA1	PCONC(:,30)
! 31.	ORA2	PCONC(:,31)
! 32.	MO2	PCONC(:,32)
! 33.	ALKAP	PCONC(:,33)
! 34.	ALKEP	PCONC(:,34)
! 35.	BIOP	PCONC(:,35)
! 36.	PHO	PCONC(:,36)
! 37.	ADD	PCONC(:,37)
! 38.	AROP	PCONC(:,38)
! 39.	CARBOP	PCONC(:,39)
! 40.	OLN	PCONC(:,40)
! 41.	XO2	PCONC(:,41)
! 42.	WC_O3	PCONC(:,42)
! 43.	WC_H2O2	PCONC(:,43)
! 44.	WC_NO	PCONC(:,44)
! 45.	WC_NO2	PCONC(:,45)
! 46.	WC_NO3	PCONC(:,46)
! 47.	WC_N2O5	PCONC(:,47)
! 48.	WC_HONO	PCONC(:,48)
! 49.	WC_HNO3	PCONC(:,49)
! 50.	WC_HNO4	PCONC(:,50)
! 51.	WC_NH3	PCONC(:,51)
! 52.	WC_OH	PCONC(:,52)
! 53.	WC_HO2	PCONC(:,53)
! 54.	WC_CO2	PCONC(:,54)
! 55.	WC_SO2	PCONC(:,55)
! 56.	WC_SULF	PCONC(:,56)
! 57.	WC_HCHO	PCONC(:,57)
! 58.	WC_ORA1	PCONC(:,58)
! 59.	WC_ORA2	PCONC(:,59)
! 60.	WC_MO2	PCONC(:,60)
! 61.	WC_OP1	PCONC(:,61)
! 62.	WC_ASO3	PCONC(:,62)
! 63.	WC_ASO4	PCONC(:,63)
! 64.	WC_ASO5	PCONC(:,64)
! 65.	WC_AHSO5	PCONC(:,65)
! 66.	WC_AHMS	PCONC(:,66)
! 67.	WR_O3	PCONC(:,67)
! 68.	WR_H2O2	PCONC(:,68)
! 69.	WR_NO	PCONC(:,69)
! 70.	WR_NO2	PCONC(:,70)
! 71.	WR_NO3	PCONC(:,71)
! 72.	WR_N2O5	PCONC(:,72)
! 73.	WR_HONO	PCONC(:,73)
! 74.	WR_HNO3	PCONC(:,74)
! 75.	WR_HNO4	PCONC(:,75)
! 76.	WR_NH3	PCONC(:,76)
! 77.	WR_OH	PCONC(:,77)
! 78.	WR_HO2	PCONC(:,78)
! 79.	WR_CO2	PCONC(:,79)
! 80.	WR_SO2	PCONC(:,80)
! 81.	WR_SULF	PCONC(:,81)
! 82.	WR_HCHO	PCONC(:,82)
! 83.	WR_ORA1	PCONC(:,83)
! 84.	WR_ORA2	PCONC(:,84)
! 85.	WR_MO2	PCONC(:,85)
! 86.	WR_OP1	PCONC(:,86)
! 87.	WR_ASO3	PCONC(:,87)
! 88.	WR_ASO4	PCONC(:,88)
! 89.	WR_ASO5	PCONC(:,89)
! 90.	WR_AHSO5	PCONC(:,90)
! 91.	WR_AHMS	PCONC(:,91)
!
!========================================================================
!
! the individual chemical terms are the following ...
!
! terms for O3:
!   + K018*<O3P>*<O2>
!   + 0.17307*K0102*<CARBOP>*<HO2>
!   + KTC21*<WC_O3>
!   + KTR21*<WR_O3>
!   - K002*<O3>
!   - K003*<O3>
!   - K019*<O3P>*<O3>
!   - K023*<O3>*<OH>
!   - K024*<O3>*<HO2>
!   - K042*<O3>*<NO>
!   - K043*<O3>*<NO2>
!   - K079*<ALKE>*<O3>
!   - K080*<BIO>*<O3>
!   - K081*<CARBO>*<O3>
!   - K082*<PAN>*<O3>
!   - K087*<ADD>*<O3>
!   - KTC1*<O3>
!   - KTR1*<O3>
! terms for H2O2:
!   + K027*<HO2>*<HO2>
!   + K028*<HO2>*<HO2>*<H2O>
!   + 0.01833*K079*<ALKE>*<O3>
!   + 0.00100*K080*<BIO>*<O3>
!   + KTC22*<WC_H2O2>
!   + KTR22*<WR_H2O2>
!   - K009*<H2O2>
!   - K026*<H2O2>*<OH>
!   - KTC2*<H2O2>
!   - KTR2*<H2O2>
! terms for NO:
!   + K001*<NO2>
!   + K004*<HONO>
!   + K007*<NO3>
!   + K030*<O3P>*<NO2>
!   + K046*<NO3>*<NO2>
!   + KTC23*<WC_NO>
!   + KTR23*<WR_NO>
!   - K029*<O3P>*<NO>
!   - K032*<OH>*<NO>
!   - K035*<HO2>*<NO>
!   - K042*<O3>*<NO>
!   - K044*<NO>*<NO>*<O2>
!   - K044*<NO>*<NO>*<O2>
!   - K045*<NO3>*<NO>
!   - K090*<MO2>*<NO>
!   - K091*<ALKAP>*<NO>
!   - K092*<ALKEP>*<NO>
!   - K093*<BIOP>*<NO>
!   - K094*<AROP>*<NO>
!   - K095*<CARBOP>*<NO>
!   - K096*<OLN>*<NO>
!   - K130*<XO2>*<NO>
!   - KTC3*<NO>
!   - KTR3*<NO>
! terms for NO2:
!   + K005*<HNO3>
!   + 0.65*K006*<HNO4>
!   + K008*<NO3>
!   + K017*<ONIT>
!   + K029*<O3P>*<NO>
!   + K034*<OH>*<NO3>
!   + K035*<HO2>*<NO>
!   + K037*<HNO4>
!   + 0.7*K038*<HO2>*<NO3>
!   + K039*<OH>*<HONO>
!   + K041*<OH>*<HNO4>
!   + K042*<O3>*<NO>
!   + K044*<NO>*<NO>*<O2>
!   + K044*<NO>*<NO>*<O2>
!   + K045*<NO3>*<NO>
!   + K045*<NO3>*<NO>
!   + K046*<NO3>*<NO2>
!   + K048*<N2O5>
!   + K049*<NO3>*<NO3>
!   + K049*<NO3>*<NO3>
!   + K071*<ONIT>*<OH>
!   + 0.10530*K074*<CARBO>*<NO3>
!   + 0.40*K078*<PAN>*<NO3>
!   + 0.70*K082*<PAN>*<O3>
!   + K089*<PAN>
!   + K090*<MO2>*<NO>
!   + 0.91541*K091*<ALKAP>*<NO>
!   + K092*<ALKEP>*<NO>
!   + 0.84700*K093*<BIOP>*<NO>
!   + 0.95115*K094*<AROP>*<NO>
!   + K095*<CARBOP>*<NO>
!   + 1.81599*K096*<OLN>*<NO>
!   + 0.32440*K110*<OLN>*<MO2>
!   + 0.00000*K116*<OLN>*<CARBOP>
!   + 0.00000*K118*<OLN>*<OLN>
!   + K119*<MO2>*<NO3>
!   + K120*<ALKAP>*<NO3>
!   + K121*<ALKEP>*<NO3>
!   + K122*<BIOP>*<NO3>
!   + K123*<AROP>*<NO3>
!   + K124*<CARBOP>*<NO3>
!   + 1.74072*K125*<OLN>*<NO3>
!   + K130*<XO2>*<NO>
!   + K131*<XO2>*<NO3>
!   + KTC24*<WC_NO2>
!   + KTR24*<WR_NO2>
!   - K001*<NO2>
!   - K030*<O3P>*<NO2>
!   - K031*<O3P>*<NO2>
!   - K033*<OH>*<NO2>
!   - K036*<HO2>*<NO2>
!   - K043*<O3>*<NO2>
!   - K046*<NO3>*<NO2>
!   - K047*<NO3>*<NO2>
!   - K083*<PHO>*<NO2>
!   - K085*<ADD>*<NO2>
!   - K088*<CARBOP>*<NO2>
!   - KTC4*<NO2>
!   - KTR4*<NO2>
! terms for NO3:
!   + 0.35*K006*<HNO4>
!   + K031*<O3P>*<NO2>
!   + K040*<OH>*<HNO3>
!   + K043*<O3>*<NO2>
!   + K048*<N2O5>
!   + 0.71893*K070*<PAN>*<OH>
!   + 0.60*K078*<PAN>*<NO3>
!   + KTC25*<WC_NO3>
!   + KTR25*<WR_NO3>
!   - K007*<NO3>
!   - K008*<NO3>
!   - K034*<OH>*<NO3>
!   - K038*<HO2>*<NO3>
!   - K045*<NO3>*<NO>
!   - K046*<NO3>*<NO2>
!   - K047*<NO3>*<NO2>
!   - K049*<NO3>*<NO3>
!   - K049*<NO3>*<NO3>
!   - K072*<HCHO>*<NO3>
!   - K073*<ALD>*<NO3>
!   - K074*<CARBO>*<NO3>
!   - K075*<ARO>*<NO3>
!   - K076*<ALKE>*<NO3>
!   - K077*<BIO>*<NO3>
!   - K078*<PAN>*<NO3>
!   - K119*<MO2>*<NO3>
!   - K120*<ALKAP>*<NO3>
!   - K121*<ALKEP>*<NO3>
!   - K122*<BIOP>*<NO3>
!   - K123*<AROP>*<NO3>
!   - K124*<CARBOP>*<NO3>
!   - K125*<OLN>*<NO3>
!   - K131*<XO2>*<NO3>
!   - KTC5*<NO3>
!   - KTR5*<NO3>
! terms for N2O5:
!   + K047*<NO3>*<NO2>
!   + KTC26*<WC_N2O5>
!   + KTR26*<WR_N2O5>
!   - K048*<N2O5>
!   - KTC6*<N2O5>
!   - KTR6*<N2O5>
! terms for HONO:
!   + K032*<OH>*<NO>
!   + K085*<ADD>*<NO2>
!   + KTC27*<WC_HONO>
!   + KTR27*<WR_HONO>
!   - K004*<HONO>
!   - K039*<OH>*<HONO>
!   - KTC7*<HONO>
!   - KTR7*<HONO>
! terms for HNO3:
!   + K033*<OH>*<NO2>
!   + 0.3*K038*<HO2>*<NO3>
!   + K072*<HCHO>*<NO3>
!   + K073*<ALD>*<NO3>
!   + 0.91567*K074*<CARBO>*<NO3>
!   + K075*<ARO>*<NO3>
!   + KTC28*<WC_HNO3>
!   + KTR28*<WR_HNO3>
!   - K005*<HNO3>
!   - K040*<OH>*<HNO3>
!   - KTC8*<HNO3>
!   - KTR8*<HNO3>
! terms for HNO4:
!   + K036*<HO2>*<NO2>
!   + KTC29*<WC_HNO4>
!   + KTR29*<WR_HNO4>
!   - K006*<HNO4>
!   - K037*<HNO4>
!   - K041*<OH>*<HNO4>
!   - KTC9*<HNO4>
!   - KTR9*<HNO4>
! terms for NH3:
!   + KTC30*<WC_NH3>
!   + KTR30*<WR_NH3>
!   - K050*<NH3>*<OH>
!   - KTC10*<NH3>
!   - KTR10*<NH3>
! terms for SO2:
!   + KTC34*<WC_SO2>
!   + KTR34*<WR_SO2>
!   - K052*<OH>*<SO2>
!   - KTC14*<SO2>
!   - KTR14*<SO2>
! terms for SULF:
!   + K052*<OH>*<SO2>
!   + KTC35*<WC_SULF>
!   + KTR35*<WR_SULF>
!   - K132*<SULF>
!   - KTC15*<SULF>
!   - KTR15*<SULF>
! terms for CO:
!   + K010*<HCHO>
!   + K011*<HCHO>
!   + K012*<ALD>
!   + 0.91924*K016*<CARBO>
!   + 0.01*K054*<BIO>*<O3P>
!   + 0.00878*K058*<ALKA>*<OH>
!   + K062*<HCHO>*<OH>
!   + 1.01732*K065*<CARBO>*<OH>
!   + K072*<HCHO>*<NO3>
!   + 1.33723*K074*<CARBO>*<NO3>
!   + 0.35120*K079*<ALKE>*<O3>
!   + 0.36000*K080*<BIO>*<O3>
!   + 0.64728*K081*<CARBO>*<O3>
!   + 0.13*K082*<PAN>*<O3>
!   - K053*<CO>*<OH>
! terms for OH:
!   + K004*<HONO>
!   + K005*<HNO3>
!   + 0.35*K006*<HNO4>
!   + K009*<H2O2>
!   + K009*<H2O2>
!   + K013*<OP1>
!   + K014*<OP2>
!   + K022*<O1D>*<H2O>
!   + K022*<O1D>*<H2O>
!   + K024*<O3>*<HO2>
!   + K035*<HO2>*<NO>
!   + 0.7*K038*<HO2>*<NO3>
!   + 0.02*K054*<BIO>*<O3P>
!   + 0.00878*K058*<ALKA>*<OH>
!   + 0.35*K068*<OP1>*<OH>
!   + 0.44925*K069*<OP2>*<OH>
!   + 0.39435*K079*<ALKE>*<O3>
!   + 0.28000*K080*<BIO>*<O3>
!   + 0.20595*K081*<CARBO>*<O3>
!   + 0.036*K082*<PAN>*<O3>
!   + K087*<ADD>*<O3>
!   + KTC31*<WC_OH>
!   + KTR31*<WR_OH>
!   - K023*<O3>*<OH>
!   - K025*<OH>*<HO2>
!   - K026*<H2O2>*<OH>
!   - K032*<OH>*<NO>
!   - K033*<OH>*<NO2>
!   - K034*<OH>*<NO3>
!   - K039*<OH>*<HONO>
!   - K040*<OH>*<HNO3>
!   - K041*<OH>*<HNO4>
!   - K050*<NH3>*<OH>
!   - K051*<OH>*<H2>
!   - K052*<OH>*<SO2>
!   - K053*<CO>*<OH>
!   - K056*<CH4>*<OH>
!   - K057*<ETH>*<OH>
!   - K058*<ALKA>*<OH>
!   - K059*<ALKE>*<OH>
!   - K060*<BIO>*<OH>
!   - K061*<ARO>*<OH>
!   - K062*<HCHO>*<OH>
!   - K063*<ALD>*<OH>
!   - K064*<KET>*<OH>
!   - K065*<CARBO>*<OH>
!   - K066*<ORA1>*<OH>
!   - K067*<ORA2>*<OH>
!   - K068*<OP1>*<OH>
!   - K069*<OP2>*<OH>
!   - K070*<PAN>*<OH>
!   - K071*<ONIT>*<OH>
!   - KTC11*<OH>
!   - KTR11*<OH>
! terms for HO2:
!   + 0.65*K006*<HNO4>
!   + K011*<HCHO>
!   + K011*<HCHO>
!   + K012*<ALD>
!   + K013*<OP1>
!   + 0.96205*K014*<OP2>
!   + 0.75830*K016*<CARBO>
!   + K017*<ONIT>
!   + K023*<O3>*<OH>
!   + K026*<H2O2>*<OH>
!   + K034*<OH>*<NO3>
!   + K037*<HNO4>
!   + K051*<OH>*<H2>
!   + K052*<OH>*<SO2>
!   + K053*<CO>*<OH>
!   + 0.28*K054*<BIO>*<O3P>
!   + 0.12793*K058*<ALKA>*<OH>
!   + 0.10318*K061*<ARO>*<OH>
!   + K062*<HCHO>*<OH>
!   + 0.51208*K065*<CARBO>*<OH>
!   + K066*<ORA1>*<OH>
!   + 0.02915*K069*<OP2>*<OH>
!   + 0.28107*K070*<PAN>*<OH>
!   + K072*<HCHO>*<NO3>
!   + 0.63217*K074*<CARBO>*<NO3>
!   + 0.23451*K079*<ALKE>*<O3>
!   + 0.30000*K080*<BIO>*<O3>
!   + 0.28441*K081*<CARBO>*<O3>
!   + 0.08*K082*<PAN>*<O3>
!   + 0.02*K086*<ADD>*<O2>
!   + K090*<MO2>*<NO>
!   + 0.74265*K091*<ALKAP>*<NO>
!   + K092*<ALKEP>*<NO>
!   + 0.84700*K093*<BIOP>*<NO>
!   + 0.95115*K094*<AROP>*<NO>
!   + 0.12334*K095*<CARBOP>*<NO>
!   + 0.18401*K096*<OLN>*<NO>
!   + 0.66*K104*<MO2>*<MO2>
!   + 0.98383*K105*<ALKAP>*<MO2>
!   + K106*<ALKEP>*<MO2>
!   + 1.00000*K107*<BIOP>*<MO2>
!   + 1.02767*K108*<AROP>*<MO2>
!   + 0.82998*K109*<CARBOP>*<MO2>
!   + 0.67560*K110*<OLN>*<MO2>
!   + 0.48079*K111*<ALKAP>*<CARBOP>
!   + 0.50078*K112*<ALKEP>*<CARBOP>
!   + 0.50600*K113*<BIOP>*<CARBOP>
!   + K114*<AROP>*<CARBOP>
!   + 0.07566*K115*<CARBOP>*<CARBOP>
!   + 0.17599*K116*<OLN>*<CARBOP>
!   + K117*<OLN>*<OLN>
!   + 0.00000*K118*<OLN>*<OLN>
!   + K119*<MO2>*<NO3>
!   + 0.81290*K120*<ALKAP>*<NO3>
!   + K121*<ALKEP>*<NO3>
!   + K122*<BIOP>*<NO3>
!   + K123*<AROP>*<NO3>
!   + 0.04915*K124*<CARBOP>*<NO3>
!   + 0.25928*K125*<OLN>*<NO3>
!   + K127*<XO2>*<MO2>
!   + KTC32*<WC_HO2>
!   + KTR32*<WR_HO2>
!   - K024*<O3>*<HO2>
!   - K025*<OH>*<HO2>
!   - K027*<HO2>*<HO2>
!   - K027*<HO2>*<HO2>
!   - K028*<HO2>*<HO2>*<H2O>
!   - K028*<HO2>*<HO2>*<H2O>
!   - K035*<HO2>*<NO>
!   - K036*<HO2>*<NO2>
!   - K038*<HO2>*<NO3>
!   - K084*<PHO>*<HO2>
!   - K097*<MO2>*<HO2>
!   - K098*<ALKAP>*<HO2>
!   - K099*<ALKEP>*<HO2>
!   - K0100*<BIOP>*<HO2>
!   - K0101*<AROP>*<HO2>
!   - K0102*<CARBOP>*<HO2>
!   - K103*<OLN>*<HO2>
!   - K126*<XO2>*<HO2>
!   - KTC12*<HO2>
!   - KTR12*<HO2>
! terms for CH4:
!   + 0.04300*K079*<ALKE>*<O3>
!   - K056*<CH4>*<OH>
! terms for ETH:
!   + 0.03196*K079*<ALKE>*<O3>
!   - K057*<ETH>*<OH>
! terms for ALKA:
!   + 0.0
!   - K058*<ALKA>*<OH>
! terms for ALKE:
!   + 0.91868*K054*<BIO>*<O3P>
!   + 0.00000*K079*<ALKE>*<O3>
!   + 0.37388*K080*<BIO>*<O3>
!   + 0.37815*K093*<BIOP>*<NO>
!   + 0.48074*K107*<BIOP>*<MO2>
!   + 0.24463*K113*<BIOP>*<CARBOP>
!   + 0.42729*K122*<BIOP>*<NO3>
!   - K059*<ALKE>*<OH>
!   - K076*<ALKE>*<NO3>
!   - K079*<ALKE>*<O3>
! terms for BIO:
!   + 0.0
!   - K054*<BIO>*<O3P>
!   - K060*<BIO>*<OH>
!   - K077*<BIO>*<NO3>
!   - K080*<BIO>*<O3>
! terms for ARO:
!   + 0.10670*K083*<PHO>*<NO2>
!   + 1.06698*K084*<PHO>*<HO2>
!   + K085*<ADD>*<NO2>
!   + 0.02*K086*<ADD>*<O2>
!   + K087*<ADD>*<O3>
!   - K061*<ARO>*<OH>
!   - K075*<ARO>*<NO3>
! terms for HCHO:
!   + K013*<OP1>
!   + 0.06517*K016*<CARBO>
!   + 0.05*K054*<BIO>*<O3P>
!   + 0.00140*K058*<ALKA>*<OH>
!   + 0.00000*K065*<CARBO>*<OH>
!   + 0.35*K068*<OP1>*<OH>
!   + 0.02915*K069*<OP2>*<OH>
!   + 0.57839*K070*<PAN>*<OH>
!   + 0.40*K078*<PAN>*<NO3>
!   + 0.48290*K079*<ALKE>*<O3>
!   + 0.90000*K080*<BIO>*<O3>
!   + 0.00000*K081*<CARBO>*<O3>
!   + 0.70*K082*<PAN>*<O3>
!   + K090*<MO2>*<NO>
!   + 0.03002*K091*<ALKAP>*<NO>
!   + 1.39870*K092*<ALKEP>*<NO>
!   + 0.60600*K093*<BIOP>*<NO>
!   + 0.05848*K095*<CARBOP>*<NO>
!   + 0.23419*K096*<OLN>*<NO>
!   + 1.33*K104*<MO2>*<MO2>
!   + 0.80556*K105*<ALKAP>*<MO2>
!   + 1.42894*K106*<ALKEP>*<MO2>
!   + 1.09000*K107*<BIOP>*<MO2>
!   + K108*<AROP>*<MO2>
!   + 0.95723*K109*<CARBOP>*<MO2>
!   + 0.88625*K110*<OLN>*<MO2>
!   + 0.07600*K111*<ALKAP>*<CARBOP>
!   + 0.68192*K112*<ALKEP>*<CARBOP>
!   + 0.34000*K113*<BIOP>*<CARBOP>
!   + 0.03432*K115*<CARBOP>*<CARBOP>
!   + 0.13414*K116*<OLN>*<CARBOP>
!   + 0.00000*K118*<OLN>*<OLN>
!   + K119*<MO2>*<NO3>
!   + 0.03142*K120*<ALKAP>*<NO3>
!   + 1.40909*K121*<ALKEP>*<NO3>
!   + 0.68600*K122*<BIOP>*<NO3>
!   + 0.03175*K124*<CARBOP>*<NO3>
!   + 0.20740*K125*<OLN>*<NO3>
!   + K127*<XO2>*<MO2>
!   + KTC36*<WC_HCHO>
!   + KTR36*<WR_HCHO>
!   - K010*<HCHO>
!   - K011*<HCHO>
!   - K062*<HCHO>*<OH>
!   - K072*<HCHO>*<NO3>
!   - KTC16*<HCHO>
!   - KTR16*<HCHO>
! terms for ALD:
!   + 0.96205*K014*<OP2>
!   + 0.20*K017*<ONIT>
!   + K055*<CARBO>*<O3P>
!   + 0.08173*K058*<ALKA>*<OH>
!   + 0.06253*K065*<CARBO>*<OH>
!   + 0.07335*K069*<OP2>*<OH>
!   + 0.05265*K074*<CARBO>*<NO3>
!   + 0.51468*K079*<ALKE>*<O3>
!   + 0.00000*K080*<BIO>*<O3>
!   + 0.15692*K081*<CARBO>*<O3>
!   + 0.33144*K091*<ALKAP>*<NO>
!   + 0.42125*K092*<ALKEP>*<NO>
!   + 0.00000*K093*<BIOP>*<NO>
!   + 0.07368*K095*<CARBOP>*<NO>
!   + 1.01182*K096*<OLN>*<NO>
!   + 0.56070*K105*<ALKAP>*<MO2>
!   + 0.46413*K106*<ALKEP>*<MO2>
!   + 0.00000*K107*<BIOP>*<MO2>
!   + 0.08295*K109*<CARBOP>*<MO2>
!   + 0.41524*K110*<OLN>*<MO2>
!   + 0.71461*K111*<ALKAP>*<CARBOP>
!   + 0.68374*K112*<ALKEP>*<CARBOP>
!   + 0.00000*K113*<BIOP>*<CARBOP>
!   + 0.06969*K115*<CARBOP>*<CARBOP>
!   + 0.42122*K116*<OLN>*<CARBOP>
!   + 0.00000*K118*<OLN>*<OLN>
!   + 0.33743*K120*<ALKAP>*<NO3>
!   + 0.43039*K121*<ALKEP>*<NO3>
!   + 0.00000*K122*<BIOP>*<NO3>
!   + 0.02936*K124*<CARBOP>*<NO3>
!   + 0.91850*K125*<OLN>*<NO3>
!   - K012*<ALD>
!   - K063*<ALD>*<OH>
!   - K073*<ALD>*<NO3>
! terms for KET:
!   + 0.80*K017*<ONIT>
!   + 0.03498*K058*<ALKA>*<OH>
!   + 0.00853*K065*<CARBO>*<OH>
!   + 0.37591*K069*<OP2>*<OH>
!   + 0.00632*K074*<CARBO>*<NO3>
!   + 0.07377*K079*<ALKE>*<O3>
!   + 0.00000*K080*<BIO>*<O3>
!   + 0.54531*K091*<ALKAP>*<NO>
!   + 0.05220*K092*<ALKEP>*<NO>
!   + 0.00000*K093*<BIOP>*<NO>
!   + 0.37862*K096*<OLN>*<NO>
!   + 0.09673*K105*<ALKAP>*<MO2>
!   + 0.03814*K106*<ALKEP>*<MO2>
!   + 0.00000*K107*<BIOP>*<MO2>
!   + 0.09667*K110*<OLN>*<MO2>
!   + 0.18819*K111*<ALKAP>*<CARBOP>
!   + 0.06579*K112*<ALKEP>*<CARBOP>
!   + 0.00000*K113*<BIOP>*<CARBOP>
!   + 0.02190*K115*<CARBOP>*<CARBOP>
!   + 0.10822*K116*<OLN>*<CARBOP>
!   + 0.00000*K118*<OLN>*<OLN>
!   + 0.62978*K120*<ALKAP>*<NO3>
!   + 0.02051*K121*<ALKEP>*<NO3>
!   + 0.00000*K122*<BIOP>*<NO3>
!   + 0.34740*K125*<OLN>*<NO3>
!   - K015*<KET>
!   - K064*<KET>*<OH>
! terms for CARBO:
!   + 0.13255*K054*<BIO>*<O3P>
!   + 0.00835*K058*<ALKA>*<OH>
!   + 0.16919*K065*<CARBO>*<OH>
!   + 0.21863*K070*<PAN>*<OH>
!   + 0.10530*K074*<CARBO>*<NO3>
!   + 0.00000*K076*<ALKE>*<NO3>
!   + 0.91741*K077*<BIO>*<NO3>
!   + 0.00000*K079*<ALKE>*<O3>
!   + 0.39754*K080*<BIO>*<O3>
!   + 1.07583*K081*<CARBO>*<O3>
!   + 0.03407*K091*<ALKAP>*<NO>
!   + 0.45463*K093*<BIOP>*<NO>
!   + 2.06993*K094*<AROP>*<NO>
!   + 0.08670*K095*<CARBOP>*<NO>
!   + 0.07976*K105*<ALKAP>*<MO2>
!   + 0.56064*K107*<BIOP>*<MO2>
!   + 1.99461*K108*<AROP>*<MO2>
!   + 0.15387*K109*<CARBOP>*<MO2>
!   + 0.06954*K111*<ALKAP>*<CARBOP>
!   + 0.78591*K113*<BIOP>*<CARBOP>
!   + 1.99455*K114*<AROP>*<CARBOP>
!   + 0.10777*K115*<CARBOP>*<CARBOP>
!   + 0.03531*K120*<ALKAP>*<NO3>
!   + 0.61160*K122*<BIOP>*<NO3>
!   + 2.81904*K123*<AROP>*<NO3>
!   + 0.03455*K124*<CARBOP>*<NO3>
!   - K016*<CARBO>
!   - K055*<CARBO>*<O3P>
!   - K065*<CARBO>*<OH>
!   - K074*<CARBO>*<NO3>
!   - K081*<CARBO>*<O3>
! terms for ONIT:
!   + 0.60*K078*<PAN>*<NO3>
!   + K083*<PHO>*<NO2>
!   + 0.08459*K091*<ALKAP>*<NO>
!   + 0.15300*K093*<BIOP>*<NO>
!   + 0.04885*K094*<AROP>*<NO>
!   + 0.18401*K096*<OLN>*<NO>
!   + K103*<OLN>*<HO2>
!   + 0.67560*K110*<OLN>*<MO2>
!   + 0.66562*K116*<OLN>*<CARBOP>
!   + 2.00*K117*<OLN>*<OLN>
!   + 0.00000*K118*<OLN>*<OLN>
!   + 0.25928*K125*<OLN>*<NO3>
!   - K017*<ONIT>
!   - K071*<ONIT>*<OH>
! terms for PAN:
!   + 0.28107*K070*<PAN>*<OH>
!   + 0.40000*K078*<PAN>*<NO3>
!   + 0.30000*K082*<PAN>*<O3>
!   + 1.00000*K088*<CARBOP>*<NO2>
!   - K070*<PAN>*<OH>
!   - K078*<PAN>*<NO3>
!   - K082*<PAN>*<O3>
!   - K089*<PAN>
! terms for OP1:
!   + K097*<MO2>*<HO2>
!   + KTC40*<WC_OP1>
!   + KTR40*<WR_OP1>
!   - K013*<OP1>
!   - K068*<OP1>*<OH>
!   - KTC20*<OP1>
!   - KTR20*<OP1>
! terms for OP2:
!   + 0.10149*K081*<CARBO>*<O3>
!   + 1.00524*K098*<ALKAP>*<HO2>
!   + 1.00524*K099*<ALKEP>*<HO2>
!   + 1.00524*K0100*<BIOP>*<HO2>
!   + 1.00524*K0101*<AROP>*<HO2>
!   + 0.80904*K0102*<CARBOP>*<HO2>
!   + 1.00524*K126*<XO2>*<HO2>
!   - K014*<OP2>
!   - K069*<OP2>*<OH>
! terms for ORA1:
!   + 0.00878*K058*<ALKA>*<OH>
!   + 0.15343*K079*<ALKE>*<O3>
!   + 0.15000*K080*<BIO>*<O3>
!   + 0.10788*K081*<CARBO>*<O3>
!   + 0.11*K082*<PAN>*<O3>
!   + KTC37*<WC_ORA1>
!   + KTR37*<WR_ORA1>
!   - K066*<ORA1>*<OH>
!   - KTC17*<ORA1>
!   - KTR17*<ORA1>
! terms for ORA2:
!   + 0.08143*K079*<ALKE>*<O3>
!   + 0.00000*K080*<BIO>*<O3>
!   + 0.20595*K081*<CARBO>*<O3>
!   + 0.17307*K0102*<CARBOP>*<HO2>
!   + 0.13684*K109*<CARBOP>*<MO2>
!   + 0.49810*K111*<ALKAP>*<CARBOP>
!   + 0.49922*K112*<ALKEP>*<CARBOP>
!   + 0.49400*K113*<BIOP>*<CARBOP>
!   + 0.09955*K115*<CARBOP>*<CARBOP>
!   + 0.48963*K116*<OLN>*<CARBOP>
!   + KTC38*<WC_ORA2>
!   + KTR38*<WR_ORA2>
!   - K067*<ORA2>*<OH>
!   - KTC18*<ORA2>
!   - KTR18*<ORA2>
! terms for MO2:
!   + K012*<ALD>
!   + 0.03795*K014*<OP2>
!   + K056*<CH4>*<OH>
!   + 0.65*K068*<OP1>*<OH>
!   + 0.13966*K079*<ALKE>*<O3>
!   + 0.03000*K080*<BIO>*<O3>
!   + 0.09016*K091*<ALKAP>*<NO>
!   + 0.78134*K095*<CARBOP>*<NO>
!   + 0.01390*K105*<ALKAP>*<MO2>
!   + 0.56031*K109*<CARBOP>*<MO2>
!   + 0.51480*K111*<ALKAP>*<CARBOP>
!   + 0.50078*K112*<ALKEP>*<CARBOP>
!   + 0.50600*K113*<BIOP>*<CARBOP>
!   + K114*<AROP>*<CARBOP>
!   + 1.66702*K115*<CARBOP>*<CARBOP>
!   + 0.51037*K116*<OLN>*<CARBOP>
!   + 0.09731*K120*<ALKAP>*<NO3>
!   + 0.91910*K124*<CARBOP>*<NO3>
!   + K128*<XO2>*<CARBOP>
!   + KTC39*<WC_MO2>
!   + KTR39*<WR_MO2>
!   - K090*<MO2>*<NO>
!   - K097*<MO2>*<HO2>
!   - K104*<MO2>*<MO2>
!   - K104*<MO2>*<MO2>
!   - K105*<ALKAP>*<MO2>
!   - K106*<ALKEP>*<MO2>
!   - K107*<BIOP>*<MO2>
!   - K108*<AROP>*<MO2>
!   - K109*<CARBOP>*<MO2>
!   - K110*<OLN>*<MO2>
!   - K119*<MO2>*<NO3>
!   - K127*<XO2>*<MO2>
!   - KTC19*<MO2>
!   - KTR19*<MO2>
! terms for ALKAP:
!   + 1.00000*K015*<KET>
!   + K057*<ETH>*<OH>
!   + 0.87811*K058*<ALKA>*<OH>
!   + 0.40341*K069*<OP2>*<OH>
!   + 1.00000*K071*<ONIT>*<OH>
!   + 0.09815*K079*<ALKE>*<O3>
!   + 0.00000*K080*<BIO>*<O3>
!   + 0.08187*K091*<ALKAP>*<NO>
!   + 0.00385*K105*<ALKAP>*<MO2>
!   + 0.00828*K111*<ALKAP>*<CARBOP>
!   + 0.08994*K120*<ALKAP>*<NO3>
!   - K091*<ALKAP>*<NO>
!   - K098*<ALKAP>*<HO2>
!   - K105*<ALKAP>*<MO2>
!   - K111*<ALKAP>*<CARBOP>
!   - K120*<ALKAP>*<NO3>
! terms for ALKEP:
!   + 1.02529*K059*<ALKE>*<OH>
!   - K092*<ALKEP>*<NO>
!   - K099*<ALKEP>*<HO2>
!   - K106*<ALKEP>*<MO2>
!   - K112*<ALKEP>*<CARBOP>
!   - K121*<ALKEP>*<NO3>
! terms for BIOP:
!   + 0.00000*K059*<ALKE>*<OH>
!   + 1.00000*K060*<BIO>*<OH>
!   - K093*<BIOP>*<NO>
!   - K0100*<BIOP>*<HO2>
!   - K107*<BIOP>*<MO2>
!   - K113*<BIOP>*<CARBOP>
!   - K122*<BIOP>*<NO3>
! terms for PHO:
!   + 0.00276*K061*<ARO>*<OH>
!   + K075*<ARO>*<NO3>
!   - K083*<PHO>*<NO2>
!   - K084*<PHO>*<HO2>
! terms for ADD:
!   + 0.93968*K061*<ARO>*<OH>
!   - K085*<ADD>*<NO2>
!   - K086*<ADD>*<O2>
!   - K087*<ADD>*<O3>
! terms for AROP:
!   + 0.98*K086*<ADD>*<O2>
!   - K094*<AROP>*<NO>
!   - K0101*<AROP>*<HO2>
!   - K108*<AROP>*<MO2>
!   - K114*<AROP>*<CARBOP>
!   - K123*<AROP>*<NO3>
! terms for CARBOP:
!   + 1.00000*K015*<KET>
!   + 0.69622*K016*<CARBO>
!   + 1.00000*K063*<ALD>*<OH>
!   + 1.00000*K064*<KET>*<OH>
!   + 0.51419*K065*<CARBO>*<OH>
!   + 0.05413*K069*<OP2>*<OH>
!   + 1.00000*K073*<ALD>*<NO3>
!   + 0.38881*K074*<CARBO>*<NO3>
!   + 0.05705*K079*<ALKE>*<O3>
!   + 0.17000*K080*<BIO>*<O3>
!   + 0.27460*K081*<CARBO>*<O3>
!   + 0.70000*K082*<PAN>*<O3>
!   + 1.00000*K089*<PAN>
!   + 0.09532*K095*<CARBOP>*<NO>
!   + 0.05954*K109*<CARBOP>*<MO2>
!   + 0.05821*K115*<CARBOP>*<CARBOP>
!   + 0.03175*K124*<CARBOP>*<NO3>
!   - K088*<CARBOP>*<NO2>
!   - K095*<CARBOP>*<NO>
!   - K0102*<CARBOP>*<HO2>
!   - K109*<CARBOP>*<MO2>
!   - K111*<ALKAP>*<CARBOP>
!   - K112*<ALKEP>*<CARBOP>
!   - K113*<BIOP>*<CARBOP>
!   - K114*<AROP>*<CARBOP>
!   - K115*<CARBOP>*<CARBOP>
!   - K115*<CARBOP>*<CARBOP>
!   - K116*<OLN>*<CARBOP>
!   - K124*<CARBOP>*<NO3>
!   - K128*<XO2>*<CARBOP>
! terms for OLN:
!   + 0.00000*K074*<CARBO>*<NO3>
!   + 0.93768*K076*<ALKE>*<NO3>
!   + 1.00000*K077*<BIO>*<NO3>
!   - K096*<OLN>*<NO>
!   - K103*<OLN>*<HO2>
!   - K110*<OLN>*<MO2>
!   - K116*<OLN>*<CARBOP>
!   - K117*<OLN>*<OLN>
!   - K117*<OLN>*<OLN>
!   - K118*<OLN>*<OLN>
!   - K118*<OLN>*<OLN>
!   - K125*<OLN>*<NO3>
! terms for XO2:
!   + 0.15*K054*<BIO>*<O3P>
!   + 0.10318*K061*<ARO>*<OH>
!   + 0.10162*K065*<CARBO>*<OH>
!   + 0.09333*K069*<OP2>*<OH>
!   + K070*<PAN>*<OH>
!   + 0.10530*K074*<CARBO>*<NO3>
!   + K078*<PAN>*<NO3>
!   + 0.00000*K079*<ALKE>*<O3>
!   + 0.13000*K080*<BIO>*<O3>
!   + 0.13007*K091*<ALKAP>*<NO>
!   + 0.02563*K095*<CARBOP>*<NO>
!   + 0.13370*K105*<ALKAP>*<MO2>
!   + 0.02212*K109*<CARBOP>*<MO2>
!   + 0.11306*K111*<ALKAP>*<CARBOP>
!   + 0.01593*K115*<CARBOP>*<CARBOP>
!   + 0.16271*K120*<ALKAP>*<NO3>
!   + 0.01021*K124*<CARBOP>*<NO3>
!   - K126*<XO2>*<HO2>
!   - K127*<XO2>*<MO2>
!   - K128*<XO2>*<CARBOP>
!   - K129*<XO2>*<XO2>
!   - K129*<XO2>*<XO2>
!   - K130*<XO2>*<NO>
!   - K131*<XO2>*<NO3>
! terms for WC_O3:
!   + KTC1*<O3>
!   - KTC21*<WC_O3>
!   - KC6*<WC_O3>*<WC_HO2>
!   - KC29*<WC_SO2>*<WC_O3>
! terms for WC_H2O2:
!   + KTC2*<H2O2>
!   + KC2*<WC_OH>*<WC_OH>
!   + KC5*<WC_HO2>*<WC_HO2>
!   - KTC22*<WC_H2O2>
!   - KC1*<WC_H2O2>
!   - KC4*<WC_H2O2>*<WC_OH>
!   - KC30*<WC_SO2>*<WC_H2O2>
! terms for WC_NO:
!   + KTC3*<NO>
!   - KTC23*<WC_NO>
! terms for WC_NO2:
!   + KTC4*<NO2>
!   + KC8*<WC_HONO>*<WC_OH>
!   + KC10*<WC_HNO4>
!   + KC13*<WC_HNO3>
!   - KTC24*<WC_NO2>
!   - KC9*<WC_NO2>*<WC_HO2>
! terms for WC_NO3:
!   + KTC5*<NO3>
!   - KTC25*<WC_NO3>
!   - KC15*<WC_NO3>*<WC_SULF>
!   - KC16*<WC_NO3>*<WC_SO2>
! terms for WC_N2O5:
!   + KTC6*<N2O5>
!   - KTC26*<WC_N2O5>
!   - KC14*<WC_N2O5>
! terms for WC_HONO:
!   + KTC7*<HONO>
!   + KC11*<WC_HNO4>
!   - KTC27*<WC_HONO>
!   - KC8*<WC_HONO>*<WC_OH>
! terms for WC_HNO3:
!   + KTC8*<HNO3>
!   + KC12*<WC_HNO4>*<WC_SO2>
!   + KC14*<WC_N2O5>
!   + KC14*<WC_N2O5>
!   + KC15*<WC_NO3>*<WC_SULF>
!   + KC16*<WC_NO3>*<WC_SO2>
!   - KTC28*<WC_HNO3>
!   - KC13*<WC_HNO3>
! terms for WC_HNO4:
!   + KTC9*<HNO4>
!   + KC9*<WC_NO2>*<WC_HO2>
!   - KTC29*<WC_HNO4>
!   - KC10*<WC_HNO4>
!   - KC11*<WC_HNO4>
!   - KC12*<WC_HNO4>*<WC_SO2>
! terms for WC_NH3:
!   + KTC10*<NH3>
!   - KTC30*<WC_NH3>
! terms for WC_OH:
!   + KTC11*<OH>
!   + KC1*<WC_H2O2>
!   + KC1*<WC_H2O2>
!   + KC6*<WC_O3>*<WC_HO2>
!   + KC13*<WC_HNO3>
!   + KC28*<WC_ASO4>
!   - KTC31*<WC_OH>
!   - KC2*<WC_OH>*<WC_OH>
!   - KC2*<WC_OH>*<WC_OH>
!   - KC3*<WC_OH>*<WC_HO2>
!   - KC4*<WC_H2O2>*<WC_OH>
!   - KC7*<WC_OH>*<WC_SO2>
!   - KC8*<WC_HONO>*<WC_OH>
!   - KC19*<WC_HCHO>*<WC_OH>
!   - KC20*<WC_ORA1>*<WC_OH>
!   - KC23*<WC_AHMS>*<WC_OH>
! terms for WC_HO2:
!   + KTC12*<HO2>
!   + KC4*<WC_H2O2>*<WC_OH>
!   + KC10*<WC_HNO4>
!   + 2.00*KC17*<WC_MO2>*<WC_MO2>
!   + KC19*<WC_HCHO>*<WC_OH>
!   + KC20*<WC_ORA1>*<WC_OH>
!   + KC23*<WC_AHMS>*<WC_OH>
!   - KTC32*<WC_HO2>
!   - KC3*<WC_OH>*<WC_HO2>
!   - KC5*<WC_HO2>*<WC_HO2>
!   - KC5*<WC_HO2>*<WC_HO2>
!   - KC6*<WC_O3>*<WC_HO2>
!   - KC9*<WC_NO2>*<WC_HO2>
!   - KC25*<WC_ASO5>*<WC_HO2>
! terms for WC_CO2:
!   + KTC13*<CO2>
!   + KC20*<WC_ORA1>*<WC_OH>
!   - KTC33*<WC_CO2>
! terms for WC_SO2:
!   + KTC14*<SO2>
!   + KC22*<WC_AHMS>
!   + KC23*<WC_AHMS>*<WC_OH>
!   - KTC34*<WC_SO2>
!   - KC7*<WC_OH>*<WC_SO2>
!   - KC12*<WC_HNO4>*<WC_SO2>
!   - KC16*<WC_NO3>*<WC_SO2>
!   - KC18*<WC_MO2>*<WC_SO2>
!   - KC21*<WC_SO2>*<WC_HCHO>
!   - KC27*<WC_AHSO5>*<WC_SO2>
!   - KC29*<WC_SO2>*<WC_O3>
!   - KC30*<WC_SO2>*<WC_H2O2>
! terms for WC_SULF:
!   + KTC15*<SULF>
!   + KC12*<WC_HNO4>*<WC_SO2>
!   + 2.00*KC27*<WC_AHSO5>*<WC_SO2>
!   + KC28*<WC_ASO4>
!   + KC29*<WC_SO2>*<WC_O3>
!   + KC30*<WC_SO2>*<WC_H2O2>
!   - KTC35*<WC_SULF>
!   - KC15*<WC_NO3>*<WC_SULF>
! terms for WC_HCHO:
!   + KTC16*<HCHO>
!   + 2.00*KC17*<WC_MO2>*<WC_MO2>
!   + KC22*<WC_AHMS>
!   - KTC36*<WC_HCHO>
!   - KC19*<WC_HCHO>*<WC_OH>
!   - KC21*<WC_SO2>*<WC_HCHO>
! terms for WC_ORA1:
!   + KTC17*<ORA1>
!   + KC19*<WC_HCHO>*<WC_OH>
!   + KC23*<WC_AHMS>*<WC_OH>
!   - KTC37*<WC_ORA1>
!   - KC20*<WC_ORA1>*<WC_OH>
! terms for WC_ORA2:
!   + KTC18*<ORA2>
!   - KTC38*<WC_ORA2>
! terms for WC_MO2:
!   + KTC19*<MO2>
!   - KTC39*<WC_MO2>
!   - KC17*<WC_MO2>*<WC_MO2>
!   - KC17*<WC_MO2>*<WC_MO2>
!   - KC18*<WC_MO2>*<WC_SO2>
! terms for WC_OP1:
!   + KTC20*<OP1>
!   + KC18*<WC_MO2>*<WC_SO2>
!   - KTC40*<WC_OP1>
! terms for WC_ASO3:
!   + KC7*<WC_OH>*<WC_SO2>
!   + KC16*<WC_NO3>*<WC_SO2>
!   + KC18*<WC_MO2>*<WC_SO2>
!   - KC24*<WC_ASO3>*<W_O2>
! terms for WC_ASO4:
!   + KC15*<WC_NO3>*<WC_SULF>
!   + KC26*<WC_ASO5>*<WC_ASO5>
!   + KC26*<WC_ASO5>*<WC_ASO5>
!   - KC28*<WC_ASO4>
! terms for WC_ASO5:
!   + KC24*<WC_ASO3>*<W_O2>
!   - KC25*<WC_ASO5>*<WC_HO2>
!   - KC26*<WC_ASO5>*<WC_ASO5>
!   - KC26*<WC_ASO5>*<WC_ASO5>
! terms for WC_AHSO5:
!   + KC25*<WC_ASO5>*<WC_HO2>
!   - KC27*<WC_AHSO5>*<WC_SO2>
! terms for WC_AHMS:
!   + KC21*<WC_SO2>*<WC_HCHO>
!   - KC22*<WC_AHMS>
!   - KC23*<WC_AHMS>*<WC_OH>
! terms for WR_O3:
!   + KTR1*<O3>
!   - KTR21*<WR_O3>
!   - KR6*<WR_O3>*<WR_HO2>
!   - KR29*<WR_SO2>*<WR_O3>
! terms for WR_H2O2:
!   + KTR2*<H2O2>
!   + KR2*<WR_OH>*<WR_OH>
!   + KR5*<WR_HO2>*<WR_HO2>
!   - KTR22*<WR_H2O2>
!   - KR1*<WR_H2O2>
!   - KR4*<WR_H2O2>*<WR_OH>
!   - KR30*<WR_SO2>*<WR_H2O2>
! terms for WR_NO:
!   + KTR3*<NO>
!   - KTR23*<WR_NO>
! terms for WR_NO2:
!   + KTR4*<NO2>
!   + KR8*<WR_HONO>*<WR_OH>
!   + KR10*<WR_HNO4>
!   + KR13*<WR_HNO3>
!   - KTR24*<WR_NO2>
!   - KR9*<WR_NO2>*<WR_HO2>
! terms for WR_NO3:
!   + KTR5*<NO3>
!   - KTR25*<WR_NO3>
!   - KR15*<WR_NO3>*<WR_SULF>
!   - KR16*<WR_NO3>*<WR_SO2>
! terms for WR_N2O5:
!   + KTR6*<N2O5>
!   - KTR26*<WR_N2O5>
!   - KR14*<WR_N2O5>
! terms for WR_HONO:
!   + KTR7*<HONO>
!   + KR11*<WR_HNO4>
!   - KTR27*<WR_HONO>
!   - KR8*<WR_HONO>*<WR_OH>
! terms for WR_HNO3:
!   + KTR8*<HNO3>
!   + KR12*<WR_HNO4>*<WR_SO2>
!   + KR14*<WR_N2O5>
!   + KR14*<WR_N2O5>
!   + KR15*<WR_NO3>*<WR_SULF>
!   + KR16*<WR_NO3>*<WR_SO2>
!   - KTR28*<WR_HNO3>
!   - KR13*<WR_HNO3>
! terms for WR_HNO4:
!   + KTR9*<HNO4>
!   + KR9*<WR_NO2>*<WR_HO2>
!   - KTR29*<WR_HNO4>
!   - KR10*<WR_HNO4>
!   - KR11*<WR_HNO4>
!   - KR12*<WR_HNO4>*<WR_SO2>
! terms for WR_NH3:
!   + KTR10*<NH3>
!   - KTR30*<WR_NH3>
! terms for WR_OH:
!   + KTR11*<OH>
!   + KR1*<WR_H2O2>
!   + KR1*<WR_H2O2>
!   + KR6*<WR_O3>*<WR_HO2>
!   + KR13*<WR_HNO3>
!   + KR28*<WR_ASO4>
!   - KTR31*<WR_OH>
!   - KR2*<WR_OH>*<WR_OH>
!   - KR2*<WR_OH>*<WR_OH>
!   - KR3*<WR_OH>*<WR_HO2>
!   - KR4*<WR_H2O2>*<WR_OH>
!   - KR7*<WR_OH>*<WR_SO2>
!   - KR8*<WR_HONO>*<WR_OH>
!   - KR19*<WR_HCHO>*<WR_OH>
!   - KR20*<WR_ORA1>*<WR_OH>
!   - KR23*<WR_AHMS>*<WR_OH>
! terms for WR_HO2:
!   + KTR12*<HO2>
!   + KR4*<WR_H2O2>*<WR_OH>
!   + KR10*<WR_HNO4>
!   + 2.00*KR17*<WR_MO2>*<WR_MO2>
!   + KR19*<WR_HCHO>*<WR_OH>
!   + KR20*<WR_ORA1>*<WR_OH>
!   + KR23*<WR_AHMS>*<WR_OH>
!   - KTR32*<WR_HO2>
!   - KR3*<WR_OH>*<WR_HO2>
!   - KR5*<WR_HO2>*<WR_HO2>
!   - KR5*<WR_HO2>*<WR_HO2>
!   - KR6*<WR_O3>*<WR_HO2>
!   - KR9*<WR_NO2>*<WR_HO2>
!   - KR25*<WR_ASO5>*<WR_HO2>
! terms for WR_CO2:
!   + KTR13*<CO2>
!   + KR20*<WR_ORA1>*<WR_OH>
!   - KTR33*<WR_CO2>
! terms for WR_SO2:
!   + KTR14*<SO2>
!   + KR22*<WR_AHMS>
!   + KR23*<WR_AHMS>*<WR_OH>
!   - KTR34*<WR_SO2>
!   - KR7*<WR_OH>*<WR_SO2>
!   - KR12*<WR_HNO4>*<WR_SO2>
!   - KR16*<WR_NO3>*<WR_SO2>
!   - KR18*<WR_MO2>*<WR_SO2>
!   - KR21*<WR_SO2>*<WR_HCHO>
!   - KR27*<WR_AHSO5>*<WR_SO2>
!   - KR29*<WR_SO2>*<WR_O3>
!   - KR30*<WR_SO2>*<WR_H2O2>
! terms for WR_SULF:
!   + KTR15*<SULF>
!   + KR12*<WR_HNO4>*<WR_SO2>
!   + 2.00*KR27*<WR_AHSO5>*<WR_SO2>
!   + KR28*<WR_ASO4>
!   + KR29*<WR_SO2>*<WR_O3>
!   + KR30*<WR_SO2>*<WR_H2O2>
!   - KTR35*<WR_SULF>
!   - KR15*<WR_NO3>*<WR_SULF>
! terms for WR_HCHO:
!   + KTR16*<HCHO>
!   + 2.00*KR17*<WR_MO2>*<WR_MO2>
!   + KR22*<WR_AHMS>
!   - KTR36*<WR_HCHO>
!   - KR19*<WR_HCHO>*<WR_OH>
!   - KR21*<WR_SO2>*<WR_HCHO>
! terms for WR_ORA1:
!   + KTR17*<ORA1>
!   + KR19*<WR_HCHO>*<WR_OH>
!   + KR23*<WR_AHMS>*<WR_OH>
!   - KTR37*<WR_ORA1>
!   - KR20*<WR_ORA1>*<WR_OH>
! terms for WR_ORA2:
!   + KTR18*<ORA2>
!   - KTR38*<WR_ORA2>
! terms for WR_MO2:
!   + KTR19*<MO2>
!   - KTR39*<WR_MO2>
!   - KR17*<WR_MO2>*<WR_MO2>
!   - KR17*<WR_MO2>*<WR_MO2>
!   - KR18*<WR_MO2>*<WR_SO2>
! terms for WR_OP1:
!   + KTR20*<OP1>
!   + KR18*<WR_MO2>*<WR_SO2>
!   - KTR40*<WR_OP1>
! terms for WR_ASO3:
!   + KR7*<WR_OH>*<WR_SO2>
!   + KR16*<WR_NO3>*<WR_SO2>
!   + KR18*<WR_MO2>*<WR_SO2>
!   - KR24*<WR_ASO3>*<W_O2>
! terms for WR_ASO4:
!   + KR15*<WR_NO3>*<WR_SULF>
!   + KR26*<WR_ASO5>*<WR_ASO5>
!   + KR26*<WR_ASO5>*<WR_ASO5>
!   - KR28*<WR_ASO4>
! terms for WR_ASO5:
!   + KR24*<WR_ASO3>*<W_O2>
!   - KR25*<WR_ASO5>*<WR_HO2>
!   - KR26*<WR_ASO5>*<WR_ASO5>
!   - KR26*<WR_ASO5>*<WR_ASO5>
! terms for WR_AHSO5:
!   + KR25*<WR_ASO5>*<WR_HO2>
!   - KR27*<WR_AHSO5>*<WR_SO2>
! terms for WR_AHMS:
!   + KR21*<WR_SO2>*<WR_HCHO>
!   - KR22*<WR_AHMS>
!   - KR23*<WR_AHMS>*<WR_OH>
!
!========================================================================
!
!!    ########################
      MODULE MODD_CH_M9_SCHEME
!!    ########################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_M9_SCHEME*
!!
!!    PURPOSE
!!    -------
!     definition of variables and types for the chemical core system
!!
!!**  METHOD
!!    ------
!!      All constants and auxiliary variables are stored in one common
!!    data type (CCSTYPE). This allows to pass them all as one single
!!    variable in the argument lists of the CCS.
!!    The constants NEQ, NEQAQ and NREAC are duplicated here in order 
!!    to avoid decouple the CCS from the other modules of MNHC.
!!    Variables to be transfered from the meteorological part are stored
!!    in the data type METEOTRANSTYPE (number, value and name).
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!    DECLARATIONS
!!    ------------
IMPLICIT NONE
INTEGER, DIMENSION(2), PARAMETER :: JPNEQ           = (/41,91/) ! number of prognostic chemical species
INTEGER, DIMENSION(2), PARAMETER :: JPNEQAQ         = (/0,50/) ! number of prognostic aqueous phase chemical species
INTEGER, DIMENSION(2), PARAMETER :: JPNREAC         = (/132,272/) ! number of chemical reactions
INTEGER, DIMENSION(2), PARAMETER :: JPNMETEOVARS    = (/13,13/) ! number of meteorological variables
INTEGER, DIMENSION(2), PARAMETER :: JPNNONZEROTERMS = (/606,942/) ! number of non-zero terms returned by CH_TERMS
!
CHARACTER(LEN=32),  DIMENSION(JPNEQ(2)),   TARGET :: CNAMES ! names of the species
CHARACTER(LEN=32),  DIMENSION(JPNREAC(2)), TARGET :: CREACS ! the reaction rate names
CHARACTER(LEN=256), DIMENSION(JPNREAC(2)), TARGET :: CFULLREACS ! the full reactions
!
TYPE CCSTYPE ! reaction rates and auxiliary variables
 LOGICAL :: LUSECHAQ
 LOGICAL :: LCH_PH
 INTEGER :: NEQ            ! number of prognostic chemical species
 INTEGER :: NEQAQ          ! number of prognostic aqueous phase chemical species
 INTEGER :: NREAC          ! number of chemical reactions
 INTEGER :: NMETEOVARS     ! number of meteorological variables
 INTEGER :: NNONZEROTERMS  ! number of non-zero terms returned by CH_TE
REAL,DIMENSION(:),POINTER :: K001=>NULL()
REAL,DIMENSION(:),POINTER :: K002=>NULL()
REAL,DIMENSION(:),POINTER :: K003=>NULL()
REAL,DIMENSION(:),POINTER :: K004=>NULL()
REAL,DIMENSION(:),POINTER :: K005=>NULL()
REAL,DIMENSION(:),POINTER :: K006=>NULL()
REAL,DIMENSION(:),POINTER :: K007=>NULL()
REAL,DIMENSION(:),POINTER :: K008=>NULL()
REAL,DIMENSION(:),POINTER :: K009=>NULL()
REAL,DIMENSION(:),POINTER :: K010=>NULL()
REAL,DIMENSION(:),POINTER :: K011=>NULL()
REAL,DIMENSION(:),POINTER :: K012=>NULL()
REAL,DIMENSION(:),POINTER :: K013=>NULL()
REAL,DIMENSION(:),POINTER :: K014=>NULL()
REAL,DIMENSION(:),POINTER :: K015=>NULL()
REAL,DIMENSION(:),POINTER :: K016=>NULL()
REAL,DIMENSION(:),POINTER :: K017=>NULL()
REAL,DIMENSION(:),POINTER :: K018=>NULL()
REAL,DIMENSION(:),POINTER :: K019=>NULL()
REAL,DIMENSION(:),POINTER :: K020=>NULL()
REAL,DIMENSION(:),POINTER :: K021=>NULL()
REAL,DIMENSION(:),POINTER :: K022=>NULL()
REAL,DIMENSION(:),POINTER :: K023=>NULL()
REAL,DIMENSION(:),POINTER :: K024=>NULL()
REAL,DIMENSION(:),POINTER :: K025=>NULL()
REAL,DIMENSION(:),POINTER :: K026=>NULL()
REAL,DIMENSION(:),POINTER :: K027=>NULL()
REAL,DIMENSION(:),POINTER :: K028=>NULL()
REAL,DIMENSION(:),POINTER :: K029=>NULL()
REAL,DIMENSION(:),POINTER :: K030=>NULL()
REAL,DIMENSION(:),POINTER :: K031=>NULL()
REAL,DIMENSION(:),POINTER :: K032=>NULL()
REAL,DIMENSION(:),POINTER :: K033=>NULL()
REAL,DIMENSION(:),POINTER :: K034=>NULL()
REAL,DIMENSION(:),POINTER :: K035=>NULL()
REAL,DIMENSION(:),POINTER :: K036=>NULL()
REAL,DIMENSION(:),POINTER :: K037=>NULL()
REAL,DIMENSION(:),POINTER :: K038=>NULL()
REAL,DIMENSION(:),POINTER :: K039=>NULL()
REAL,DIMENSION(:),POINTER :: K040=>NULL()
REAL,DIMENSION(:),POINTER :: K041=>NULL()
REAL,DIMENSION(:),POINTER :: K042=>NULL()
REAL,DIMENSION(:),POINTER :: K043=>NULL()
REAL,DIMENSION(:),POINTER :: K044=>NULL()
REAL,DIMENSION(:),POINTER :: K045=>NULL()
REAL,DIMENSION(:),POINTER :: K046=>NULL()
REAL,DIMENSION(:),POINTER :: K047=>NULL()
REAL,DIMENSION(:),POINTER :: K048=>NULL()
REAL,DIMENSION(:),POINTER :: K049=>NULL()
REAL,DIMENSION(:),POINTER :: K050=>NULL()
REAL,DIMENSION(:),POINTER :: K051=>NULL()
REAL,DIMENSION(:),POINTER :: K052=>NULL()
REAL,DIMENSION(:),POINTER :: K053=>NULL()
REAL,DIMENSION(:),POINTER :: K054=>NULL()
REAL,DIMENSION(:),POINTER :: K055=>NULL()
REAL,DIMENSION(:),POINTER :: K056=>NULL()
REAL,DIMENSION(:),POINTER :: K057=>NULL()
REAL,DIMENSION(:),POINTER :: K058=>NULL()
REAL,DIMENSION(:),POINTER :: K059=>NULL()
REAL,DIMENSION(:),POINTER :: K060=>NULL()
REAL,DIMENSION(:),POINTER :: K061=>NULL()
REAL,DIMENSION(:),POINTER :: K062=>NULL()
REAL,DIMENSION(:),POINTER :: K063=>NULL()
REAL,DIMENSION(:),POINTER :: K064=>NULL()
REAL,DIMENSION(:),POINTER :: K065=>NULL()
REAL,DIMENSION(:),POINTER :: K066=>NULL()
REAL,DIMENSION(:),POINTER :: K067=>NULL()
REAL,DIMENSION(:),POINTER :: K068=>NULL()
REAL,DIMENSION(:),POINTER :: K069=>NULL()
REAL,DIMENSION(:),POINTER :: K070=>NULL()
REAL,DIMENSION(:),POINTER :: K071=>NULL()
REAL,DIMENSION(:),POINTER :: K072=>NULL()
REAL,DIMENSION(:),POINTER :: K073=>NULL()
REAL,DIMENSION(:),POINTER :: K074=>NULL()
REAL,DIMENSION(:),POINTER :: K075=>NULL()
REAL,DIMENSION(:),POINTER :: K076=>NULL()
REAL,DIMENSION(:),POINTER :: K077=>NULL()
REAL,DIMENSION(:),POINTER :: K078=>NULL()
REAL,DIMENSION(:),POINTER :: K079=>NULL()
REAL,DIMENSION(:),POINTER :: K080=>NULL()
REAL,DIMENSION(:),POINTER :: K081=>NULL()
REAL,DIMENSION(:),POINTER :: K082=>NULL()
REAL,DIMENSION(:),POINTER :: K083=>NULL()
REAL,DIMENSION(:),POINTER :: K084=>NULL()
REAL,DIMENSION(:),POINTER :: K085=>NULL()
REAL,DIMENSION(:),POINTER :: K086=>NULL()
REAL,DIMENSION(:),POINTER :: K087=>NULL()
REAL,DIMENSION(:),POINTER :: K088=>NULL()
REAL,DIMENSION(:),POINTER :: K089=>NULL()
REAL,DIMENSION(:),POINTER :: K090=>NULL()
REAL,DIMENSION(:),POINTER :: K091=>NULL()
REAL,DIMENSION(:),POINTER :: K092=>NULL()
REAL,DIMENSION(:),POINTER :: K093=>NULL()
REAL,DIMENSION(:),POINTER :: K094=>NULL()
REAL,DIMENSION(:),POINTER :: K095=>NULL()
REAL,DIMENSION(:),POINTER :: K096=>NULL()
REAL,DIMENSION(:),POINTER :: K097=>NULL()
REAL,DIMENSION(:),POINTER :: K098=>NULL()
REAL,DIMENSION(:),POINTER :: K099=>NULL()
REAL,DIMENSION(:),POINTER :: K0100=>NULL()
REAL,DIMENSION(:),POINTER :: K0101=>NULL()
REAL,DIMENSION(:),POINTER :: K0102=>NULL()
REAL,DIMENSION(:),POINTER :: K103=>NULL()
REAL,DIMENSION(:),POINTER :: K104=>NULL()
REAL,DIMENSION(:),POINTER :: K105=>NULL()
REAL,DIMENSION(:),POINTER :: K106=>NULL()
REAL,DIMENSION(:),POINTER :: K107=>NULL()
REAL,DIMENSION(:),POINTER :: K108=>NULL()
REAL,DIMENSION(:),POINTER :: K109=>NULL()
REAL,DIMENSION(:),POINTER :: K110=>NULL()
REAL,DIMENSION(:),POINTER :: K111=>NULL()
REAL,DIMENSION(:),POINTER :: K112=>NULL()
REAL,DIMENSION(:),POINTER :: K113=>NULL()
REAL,DIMENSION(:),POINTER :: K114=>NULL()
REAL,DIMENSION(:),POINTER :: K115=>NULL()
REAL,DIMENSION(:),POINTER :: K116=>NULL()
REAL,DIMENSION(:),POINTER :: K117=>NULL()
REAL,DIMENSION(:),POINTER :: K118=>NULL()
REAL,DIMENSION(:),POINTER :: K119=>NULL()
REAL,DIMENSION(:),POINTER :: K120=>NULL()
REAL,DIMENSION(:),POINTER :: K121=>NULL()
REAL,DIMENSION(:),POINTER :: K122=>NULL()
REAL,DIMENSION(:),POINTER :: K123=>NULL()
REAL,DIMENSION(:),POINTER :: K124=>NULL()
REAL,DIMENSION(:),POINTER :: K125=>NULL()
REAL,DIMENSION(:),POINTER :: K126=>NULL()
REAL,DIMENSION(:),POINTER :: K127=>NULL()
REAL,DIMENSION(:),POINTER :: K128=>NULL()
REAL,DIMENSION(:),POINTER :: K129=>NULL()
REAL,DIMENSION(:),POINTER :: K130=>NULL()
REAL,DIMENSION(:),POINTER :: K131=>NULL()
REAL,DIMENSION(:),POINTER :: K132=>NULL()
REAL,DIMENSION(:),POINTER :: KTC1=>NULL()
REAL,DIMENSION(:),POINTER :: KTC2=>NULL()
REAL,DIMENSION(:),POINTER :: KTC3=>NULL()
REAL,DIMENSION(:),POINTER :: KTC4=>NULL()
REAL,DIMENSION(:),POINTER :: KTC5=>NULL()
REAL,DIMENSION(:),POINTER :: KTC6=>NULL()
REAL,DIMENSION(:),POINTER :: KTC7=>NULL()
REAL,DIMENSION(:),POINTER :: KTC8=>NULL()
REAL,DIMENSION(:),POINTER :: KTC9=>NULL()
REAL,DIMENSION(:),POINTER :: KTC10=>NULL()
REAL,DIMENSION(:),POINTER :: KTC11=>NULL()
REAL,DIMENSION(:),POINTER :: KTC12=>NULL()
REAL,DIMENSION(:),POINTER :: KTC13=>NULL()
REAL,DIMENSION(:),POINTER :: KTC14=>NULL()
REAL,DIMENSION(:),POINTER :: KTC15=>NULL()
REAL,DIMENSION(:),POINTER :: KTC16=>NULL()
REAL,DIMENSION(:),POINTER :: KTC17=>NULL()
REAL,DIMENSION(:),POINTER :: KTC18=>NULL()
REAL,DIMENSION(:),POINTER :: KTC19=>NULL()
REAL,DIMENSION(:),POINTER :: KTC20=>NULL()
REAL,DIMENSION(:),POINTER :: KTC21=>NULL()
REAL,DIMENSION(:),POINTER :: KTC22=>NULL()
REAL,DIMENSION(:),POINTER :: KTC23=>NULL()
REAL,DIMENSION(:),POINTER :: KTC24=>NULL()
REAL,DIMENSION(:),POINTER :: KTC25=>NULL()
REAL,DIMENSION(:),POINTER :: KTC26=>NULL()
REAL,DIMENSION(:),POINTER :: KTC27=>NULL()
REAL,DIMENSION(:),POINTER :: KTC28=>NULL()
REAL,DIMENSION(:),POINTER :: KTC29=>NULL()
REAL,DIMENSION(:),POINTER :: KTC30=>NULL()
REAL,DIMENSION(:),POINTER :: KTC31=>NULL()
REAL,DIMENSION(:),POINTER :: KTC32=>NULL()
REAL,DIMENSION(:),POINTER :: KTC33=>NULL()
REAL,DIMENSION(:),POINTER :: KTC34=>NULL()
REAL,DIMENSION(:),POINTER :: KTC35=>NULL()
REAL,DIMENSION(:),POINTER :: KTC36=>NULL()
REAL,DIMENSION(:),POINTER :: KTC37=>NULL()
REAL,DIMENSION(:),POINTER :: KTC38=>NULL()
REAL,DIMENSION(:),POINTER :: KTC39=>NULL()
REAL,DIMENSION(:),POINTER :: KTC40=>NULL()
REAL,DIMENSION(:),POINTER :: KTR1=>NULL()
REAL,DIMENSION(:),POINTER :: KTR2=>NULL()
REAL,DIMENSION(:),POINTER :: KTR3=>NULL()
REAL,DIMENSION(:),POINTER :: KTR4=>NULL()
REAL,DIMENSION(:),POINTER :: KTR5=>NULL()
REAL,DIMENSION(:),POINTER :: KTR6=>NULL()
REAL,DIMENSION(:),POINTER :: KTR7=>NULL()
REAL,DIMENSION(:),POINTER :: KTR8=>NULL()
REAL,DIMENSION(:),POINTER :: KTR9=>NULL()
REAL,DIMENSION(:),POINTER :: KTR10=>NULL()
REAL,DIMENSION(:),POINTER :: KTR11=>NULL()
REAL,DIMENSION(:),POINTER :: KTR12=>NULL()
REAL,DIMENSION(:),POINTER :: KTR13=>NULL()
REAL,DIMENSION(:),POINTER :: KTR14=>NULL()
REAL,DIMENSION(:),POINTER :: KTR15=>NULL()
REAL,DIMENSION(:),POINTER :: KTR16=>NULL()
REAL,DIMENSION(:),POINTER :: KTR17=>NULL()
REAL,DIMENSION(:),POINTER :: KTR18=>NULL()
REAL,DIMENSION(:),POINTER :: KTR19=>NULL()
REAL,DIMENSION(:),POINTER :: KTR20=>NULL()
REAL,DIMENSION(:),POINTER :: KTR21=>NULL()
REAL,DIMENSION(:),POINTER :: KTR22=>NULL()
REAL,DIMENSION(:),POINTER :: KTR23=>NULL()
REAL,DIMENSION(:),POINTER :: KTR24=>NULL()
REAL,DIMENSION(:),POINTER :: KTR25=>NULL()
REAL,DIMENSION(:),POINTER :: KTR26=>NULL()
REAL,DIMENSION(:),POINTER :: KTR27=>NULL()
REAL,DIMENSION(:),POINTER :: KTR28=>NULL()
REAL,DIMENSION(:),POINTER :: KTR29=>NULL()
REAL,DIMENSION(:),POINTER :: KTR30=>NULL()
REAL,DIMENSION(:),POINTER :: KTR31=>NULL()
REAL,DIMENSION(:),POINTER :: KTR32=>NULL()
REAL,DIMENSION(:),POINTER :: KTR33=>NULL()
REAL,DIMENSION(:),POINTER :: KTR34=>NULL()
REAL,DIMENSION(:),POINTER :: KTR35=>NULL()
REAL,DIMENSION(:),POINTER :: KTR36=>NULL()
REAL,DIMENSION(:),POINTER :: KTR37=>NULL()
REAL,DIMENSION(:),POINTER :: KTR38=>NULL()
REAL,DIMENSION(:),POINTER :: KTR39=>NULL()
REAL,DIMENSION(:),POINTER :: KTR40=>NULL()
REAL,DIMENSION(:),POINTER :: KC1=>NULL()
REAL,DIMENSION(:),POINTER :: KC2=>NULL()
REAL,DIMENSION(:),POINTER :: KC3=>NULL()
REAL,DIMENSION(:),POINTER :: KC4=>NULL()
REAL,DIMENSION(:),POINTER :: KC5=>NULL()
REAL,DIMENSION(:),POINTER :: KC6=>NULL()
REAL,DIMENSION(:),POINTER :: KC7=>NULL()
REAL,DIMENSION(:),POINTER :: KC8=>NULL()
REAL,DIMENSION(:),POINTER :: KC9=>NULL()
REAL,DIMENSION(:),POINTER :: KC10=>NULL()
REAL,DIMENSION(:),POINTER :: KC11=>NULL()
REAL,DIMENSION(:),POINTER :: KC12=>NULL()
REAL,DIMENSION(:),POINTER :: KC13=>NULL()
REAL,DIMENSION(:),POINTER :: KC14=>NULL()
REAL,DIMENSION(:),POINTER :: KC15=>NULL()
REAL,DIMENSION(:),POINTER :: KC16=>NULL()
REAL,DIMENSION(:),POINTER :: KC17=>NULL()
REAL,DIMENSION(:),POINTER :: KC18=>NULL()
REAL,DIMENSION(:),POINTER :: KC19=>NULL()
REAL,DIMENSION(:),POINTER :: KC20=>NULL()
REAL,DIMENSION(:),POINTER :: KC21=>NULL()
REAL,DIMENSION(:),POINTER :: KC22=>NULL()
REAL,DIMENSION(:),POINTER :: KC23=>NULL()
REAL,DIMENSION(:),POINTER :: KC24=>NULL()
REAL,DIMENSION(:),POINTER :: KC25=>NULL()
REAL,DIMENSION(:),POINTER :: KC26=>NULL()
REAL,DIMENSION(:),POINTER :: KC27=>NULL()
REAL,DIMENSION(:),POINTER :: KC28=>NULL()
REAL,DIMENSION(:),POINTER :: KC29=>NULL()
REAL,DIMENSION(:),POINTER :: KC30=>NULL()
REAL,DIMENSION(:),POINTER :: KR1=>NULL()
REAL,DIMENSION(:),POINTER :: KR2=>NULL()
REAL,DIMENSION(:),POINTER :: KR3=>NULL()
REAL,DIMENSION(:),POINTER :: KR4=>NULL()
REAL,DIMENSION(:),POINTER :: KR5=>NULL()
REAL,DIMENSION(:),POINTER :: KR6=>NULL()
REAL,DIMENSION(:),POINTER :: KR7=>NULL()
REAL,DIMENSION(:),POINTER :: KR8=>NULL()
REAL,DIMENSION(:),POINTER :: KR9=>NULL()
REAL,DIMENSION(:),POINTER :: KR10=>NULL()
REAL,DIMENSION(:),POINTER :: KR11=>NULL()
REAL,DIMENSION(:),POINTER :: KR12=>NULL()
REAL,DIMENSION(:),POINTER :: KR13=>NULL()
REAL,DIMENSION(:),POINTER :: KR14=>NULL()
REAL,DIMENSION(:),POINTER :: KR15=>NULL()
REAL,DIMENSION(:),POINTER :: KR16=>NULL()
REAL,DIMENSION(:),POINTER :: KR17=>NULL()
REAL,DIMENSION(:),POINTER :: KR18=>NULL()
REAL,DIMENSION(:),POINTER :: KR19=>NULL()
REAL,DIMENSION(:),POINTER :: KR20=>NULL()
REAL,DIMENSION(:),POINTER :: KR21=>NULL()
REAL,DIMENSION(:),POINTER :: KR22=>NULL()
REAL,DIMENSION(:),POINTER :: KR23=>NULL()
REAL,DIMENSION(:),POINTER :: KR24=>NULL()
REAL,DIMENSION(:),POINTER :: KR25=>NULL()
REAL,DIMENSION(:),POINTER :: KR26=>NULL()
REAL,DIMENSION(:),POINTER :: KR27=>NULL()
REAL,DIMENSION(:),POINTER :: KR28=>NULL()
REAL,DIMENSION(:),POINTER :: KR29=>NULL()
REAL,DIMENSION(:),POINTER :: KR30=>NULL()
! output channel (NOUT) and verbosity level (NVERB)
 INTEGER :: NOUT
INTEGER,DIMENSION(:),POINTER :: NVERB=>NULL()
! auxiliary variables defined by the user, if any (e.g. O2, N2, H2O)
! /BEGIN_MODULE/
!
! supplementary variables of the CCS that are to be placed into
! the TYPE definition of TPK (to be addressed e.g. as TPK%O2):
!
INTEGER,DIMENSION(:),POINTER :: MODELLEVEL       ! index of the model level (1 for box model)
REAL,DIMENSION(:),POINTER    :: T,              &! temperature (K)
    PRESSURE,       &! pressure (atm)
    M,              &! air density (molec/cm3)
    H2O,            &! conc. of water molecules (molec/cm3)
    CLOUDWATER,     &! cloud water (kg/kg)
    RAINWATER,      &! rain water (kg/kg)
    RHODREF,        &! ref dry air density (kg/m3)
    O2, N2, H2,     &! conc. of oxigen nitrogen, hydrogen (molec/cm3)
    OH, O1D, O3P,   &! (molec/cm3) at equilibrium (fast species)
    LON,            &! longitude of curtrent grid point (degree)
    LAT              ! latitude of curtrent grid point (degree)
INTEGER,DIMENSION(:),POINTER :: YEAR, MONTH, DAY ! starting date of experiment (~DTEXP)
REAL,DIMENSION(:),POINTER    :: LWC,            &! cloud liquid water content (vol/vol)
            MOL2MOLECCLOUD, &! conversion factor mole/L to molec/cm3 in cloud
            RADC,           &! mean radius of cloud droplet (µm)
            PHC,            &! pH value of cloud water
            LWR,            &! rain liquid water content (vol/vol)
            MOL2MOLECRAIN,  &! conversion factor mole/L to molec/cm3 in rain
            RADR,           &! mean radius of rain drops (µm)
            PHR,            &! pH value of rain water
            CO2,            &! conc. of CO2 (molec/cm3)
            RCH,            &! perfect gases constant
            W_O2             ! conc. of O2 in aqueous phase at equilibrium (M)
!
! /END_MODULE/
END TYPE CCSTYPE
!
! Use array of CCSTYPE to handle the 8 possible models :
! TACCS(i) refers to the CCSTYPE variable of the ith model
! You should declare a TYPE(CCSTYPE) pointer variable TZK to point to
! TACCS(i) in each subroutine that deals with CCSTYPE variables :
!
! TYPE(CCSTYPE),POINTER :: TZK
!
! TZK=>TACCS(KMI)
!
TYPE(CCSTYPE), DIMENSION(8), TARGET, SAVE :: TACCS ! 8 models 
!
! list of chemical species indices
INTEGER, PARAMETER :: JP_O3 = 1
INTEGER, PARAMETER :: JP_H2O2 = 2
INTEGER, PARAMETER :: JP_NO = 3
INTEGER, PARAMETER :: JP_NO2 = 4
INTEGER, PARAMETER :: JP_NO3 = 5
INTEGER, PARAMETER :: JP_N2O5 = 6
INTEGER, PARAMETER :: JP_HONO = 7
INTEGER, PARAMETER :: JP_HNO3 = 8
INTEGER, PARAMETER :: JP_HNO4 = 9
INTEGER, PARAMETER :: JP_NH3 = 10
INTEGER, PARAMETER :: JP_SO2 = 11
INTEGER, PARAMETER :: JP_SULF = 12
INTEGER, PARAMETER :: JP_CO = 13
INTEGER, PARAMETER :: JP_OH = 14
INTEGER, PARAMETER :: JP_HO2 = 15
INTEGER, PARAMETER :: JP_CH4 = 16
INTEGER, PARAMETER :: JP_ETH = 17
INTEGER, PARAMETER :: JP_ALKA = 18
INTEGER, PARAMETER :: JP_ALKE = 19
INTEGER, PARAMETER :: JP_BIO = 20
INTEGER, PARAMETER :: JP_ARO = 21
INTEGER, PARAMETER :: JP_HCHO = 22
INTEGER, PARAMETER :: JP_ALD = 23
INTEGER, PARAMETER :: JP_KET = 24
INTEGER, PARAMETER :: JP_CARBO = 25
INTEGER, PARAMETER :: JP_ONIT = 26
INTEGER, PARAMETER :: JP_PAN = 27
INTEGER, PARAMETER :: JP_OP1 = 28
INTEGER, PARAMETER :: JP_OP2 = 29
INTEGER, PARAMETER :: JP_ORA1 = 30
INTEGER, PARAMETER :: JP_ORA2 = 31
INTEGER, PARAMETER :: JP_MO2 = 32
INTEGER, PARAMETER :: JP_ALKAP = 33
INTEGER, PARAMETER :: JP_ALKEP = 34
INTEGER, PARAMETER :: JP_BIOP = 35
INTEGER, PARAMETER :: JP_PHO = 36
INTEGER, PARAMETER :: JP_ADD = 37
INTEGER, PARAMETER :: JP_AROP = 38
INTEGER, PARAMETER :: JP_CARBOP = 39
INTEGER, PARAMETER :: JP_OLN = 40
INTEGER, PARAMETER :: JP_XO2 = 41
INTEGER, PARAMETER :: JP_WC_O3 = 42
INTEGER, PARAMETER :: JP_WC_H2O2 = 43
INTEGER, PARAMETER :: JP_WC_NO = 44
INTEGER, PARAMETER :: JP_WC_NO2 = 45
INTEGER, PARAMETER :: JP_WC_NO3 = 46
INTEGER, PARAMETER :: JP_WC_N2O5 = 47
INTEGER, PARAMETER :: JP_WC_HONO = 48
INTEGER, PARAMETER :: JP_WC_HNO3 = 49
INTEGER, PARAMETER :: JP_WC_HNO4 = 50
INTEGER, PARAMETER :: JP_WC_NH3 = 51
INTEGER, PARAMETER :: JP_WC_OH = 52
INTEGER, PARAMETER :: JP_WC_HO2 = 53
INTEGER, PARAMETER :: JP_WC_CO2 = 54
INTEGER, PARAMETER :: JP_WC_SO2 = 55
INTEGER, PARAMETER :: JP_WC_SULF = 56
INTEGER, PARAMETER :: JP_WC_HCHO = 57
INTEGER, PARAMETER :: JP_WC_ORA1 = 58
INTEGER, PARAMETER :: JP_WC_ORA2 = 59
INTEGER, PARAMETER :: JP_WC_MO2 = 60
INTEGER, PARAMETER :: JP_WC_OP1 = 61
INTEGER, PARAMETER :: JP_WC_ASO3 = 62
INTEGER, PARAMETER :: JP_WC_ASO4 = 63
INTEGER, PARAMETER :: JP_WC_ASO5 = 64
INTEGER, PARAMETER :: JP_WC_AHSO5 = 65
INTEGER, PARAMETER :: JP_WC_AHMS = 66
INTEGER, PARAMETER :: JP_WR_O3 = 67
INTEGER, PARAMETER :: JP_WR_H2O2 = 68
INTEGER, PARAMETER :: JP_WR_NO = 69
INTEGER, PARAMETER :: JP_WR_NO2 = 70
INTEGER, PARAMETER :: JP_WR_NO3 = 71
INTEGER, PARAMETER :: JP_WR_N2O5 = 72
INTEGER, PARAMETER :: JP_WR_HONO = 73
INTEGER, PARAMETER :: JP_WR_HNO3 = 74
INTEGER, PARAMETER :: JP_WR_HNO4 = 75
INTEGER, PARAMETER :: JP_WR_NH3 = 76
INTEGER, PARAMETER :: JP_WR_OH = 77
INTEGER, PARAMETER :: JP_WR_HO2 = 78
INTEGER, PARAMETER :: JP_WR_CO2 = 79
INTEGER, PARAMETER :: JP_WR_SO2 = 80
INTEGER, PARAMETER :: JP_WR_SULF = 81
INTEGER, PARAMETER :: JP_WR_HCHO = 82
INTEGER, PARAMETER :: JP_WR_ORA1 = 83
INTEGER, PARAMETER :: JP_WR_ORA2 = 84
INTEGER, PARAMETER :: JP_WR_MO2 = 85
INTEGER, PARAMETER :: JP_WR_OP1 = 86
INTEGER, PARAMETER :: JP_WR_ASO3 = 87
INTEGER, PARAMETER :: JP_WR_ASO4 = 88
INTEGER, PARAMETER :: JP_WR_ASO5 = 89
INTEGER, PARAMETER :: JP_WR_AHSO5 = 90
INTEGER, PARAMETER :: JP_WR_AHMS = 91
!
END MODULE MODD_CH_M9_SCHEME
!
!========================================================================
!
!     ##########################
      MODULE MODI_CH_ALLOCATE_TACCS
!     ##########################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_ALLOCATE_TACCS(KMI,KVECNPT)
IMPLICIT NONE
INTEGER, INTENT(IN)  :: KMI    ! model index
INTEGER, INTENT(IN)  :: KVECNPT
END SUBROUTINE CH_ALLOCATE_TACCS
END INTERFACE
END MODULE MODI_CH_ALLOCATE_TACCS
!
!========================================================================
!
!     ######################################
      SUBROUTINE CH_ALLOCATE_TACCS(KMI,KVECNPT)
!     ######################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_ALLOCATE_TACCS*
!!
!!    PURPOSE
!!    -------
!       Allocation of all CCSTYPE variables for model KMI
!!
!!**  METHOD
!!    ------
!!
!!   
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Gazen Didier (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 21/06/2005
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
INTEGER, INTENT(IN)  :: KMI    ! model index
INTEGER, INTENT(IN)  :: KVECNPT
!!
!!----------------------------------------------------------------------
! /BEGIN_INITIAL/
! /END_INITIAL/
! initialisation of the names of the chemical species
ALLOCATE(TACCS(KMI)%K001(KVECNPT))
ALLOCATE(TACCS(KMI)%K002(KVECNPT))
ALLOCATE(TACCS(KMI)%K003(KVECNPT))
ALLOCATE(TACCS(KMI)%K004(KVECNPT))
ALLOCATE(TACCS(KMI)%K005(KVECNPT))
ALLOCATE(TACCS(KMI)%K006(KVECNPT))
ALLOCATE(TACCS(KMI)%K007(KVECNPT))
ALLOCATE(TACCS(KMI)%K008(KVECNPT))
ALLOCATE(TACCS(KMI)%K009(KVECNPT))
ALLOCATE(TACCS(KMI)%K010(KVECNPT))
ALLOCATE(TACCS(KMI)%K011(KVECNPT))
ALLOCATE(TACCS(KMI)%K012(KVECNPT))
ALLOCATE(TACCS(KMI)%K013(KVECNPT))
ALLOCATE(TACCS(KMI)%K014(KVECNPT))
ALLOCATE(TACCS(KMI)%K015(KVECNPT))
ALLOCATE(TACCS(KMI)%K016(KVECNPT))
ALLOCATE(TACCS(KMI)%K017(KVECNPT))
ALLOCATE(TACCS(KMI)%K018(KVECNPT))
ALLOCATE(TACCS(KMI)%K019(KVECNPT))
ALLOCATE(TACCS(KMI)%K020(KVECNPT))
ALLOCATE(TACCS(KMI)%K021(KVECNPT))
ALLOCATE(TACCS(KMI)%K022(KVECNPT))
ALLOCATE(TACCS(KMI)%K023(KVECNPT))
ALLOCATE(TACCS(KMI)%K024(KVECNPT))
ALLOCATE(TACCS(KMI)%K025(KVECNPT))
ALLOCATE(TACCS(KMI)%K026(KVECNPT))
ALLOCATE(TACCS(KMI)%K027(KVECNPT))
ALLOCATE(TACCS(KMI)%K028(KVECNPT))
ALLOCATE(TACCS(KMI)%K029(KVECNPT))
ALLOCATE(TACCS(KMI)%K030(KVECNPT))
ALLOCATE(TACCS(KMI)%K031(KVECNPT))
ALLOCATE(TACCS(KMI)%K032(KVECNPT))
ALLOCATE(TACCS(KMI)%K033(KVECNPT))
ALLOCATE(TACCS(KMI)%K034(KVECNPT))
ALLOCATE(TACCS(KMI)%K035(KVECNPT))
ALLOCATE(TACCS(KMI)%K036(KVECNPT))
ALLOCATE(TACCS(KMI)%K037(KVECNPT))
ALLOCATE(TACCS(KMI)%K038(KVECNPT))
ALLOCATE(TACCS(KMI)%K039(KVECNPT))
ALLOCATE(TACCS(KMI)%K040(KVECNPT))
ALLOCATE(TACCS(KMI)%K041(KVECNPT))
ALLOCATE(TACCS(KMI)%K042(KVECNPT))
ALLOCATE(TACCS(KMI)%K043(KVECNPT))
ALLOCATE(TACCS(KMI)%K044(KVECNPT))
ALLOCATE(TACCS(KMI)%K045(KVECNPT))
ALLOCATE(TACCS(KMI)%K046(KVECNPT))
ALLOCATE(TACCS(KMI)%K047(KVECNPT))
ALLOCATE(TACCS(KMI)%K048(KVECNPT))
ALLOCATE(TACCS(KMI)%K049(KVECNPT))
ALLOCATE(TACCS(KMI)%K050(KVECNPT))
ALLOCATE(TACCS(KMI)%K051(KVECNPT))
ALLOCATE(TACCS(KMI)%K052(KVECNPT))
ALLOCATE(TACCS(KMI)%K053(KVECNPT))
ALLOCATE(TACCS(KMI)%K054(KVECNPT))
ALLOCATE(TACCS(KMI)%K055(KVECNPT))
ALLOCATE(TACCS(KMI)%K056(KVECNPT))
ALLOCATE(TACCS(KMI)%K057(KVECNPT))
ALLOCATE(TACCS(KMI)%K058(KVECNPT))
ALLOCATE(TACCS(KMI)%K059(KVECNPT))
ALLOCATE(TACCS(KMI)%K060(KVECNPT))
ALLOCATE(TACCS(KMI)%K061(KVECNPT))
ALLOCATE(TACCS(KMI)%K062(KVECNPT))
ALLOCATE(TACCS(KMI)%K063(KVECNPT))
ALLOCATE(TACCS(KMI)%K064(KVECNPT))
ALLOCATE(TACCS(KMI)%K065(KVECNPT))
ALLOCATE(TACCS(KMI)%K066(KVECNPT))
ALLOCATE(TACCS(KMI)%K067(KVECNPT))
ALLOCATE(TACCS(KMI)%K068(KVECNPT))
ALLOCATE(TACCS(KMI)%K069(KVECNPT))
ALLOCATE(TACCS(KMI)%K070(KVECNPT))
ALLOCATE(TACCS(KMI)%K071(KVECNPT))
ALLOCATE(TACCS(KMI)%K072(KVECNPT))
ALLOCATE(TACCS(KMI)%K073(KVECNPT))
ALLOCATE(TACCS(KMI)%K074(KVECNPT))
ALLOCATE(TACCS(KMI)%K075(KVECNPT))
ALLOCATE(TACCS(KMI)%K076(KVECNPT))
ALLOCATE(TACCS(KMI)%K077(KVECNPT))
ALLOCATE(TACCS(KMI)%K078(KVECNPT))
ALLOCATE(TACCS(KMI)%K079(KVECNPT))
ALLOCATE(TACCS(KMI)%K080(KVECNPT))
ALLOCATE(TACCS(KMI)%K081(KVECNPT))
ALLOCATE(TACCS(KMI)%K082(KVECNPT))
ALLOCATE(TACCS(KMI)%K083(KVECNPT))
ALLOCATE(TACCS(KMI)%K084(KVECNPT))
ALLOCATE(TACCS(KMI)%K085(KVECNPT))
ALLOCATE(TACCS(KMI)%K086(KVECNPT))
ALLOCATE(TACCS(KMI)%K087(KVECNPT))
ALLOCATE(TACCS(KMI)%K088(KVECNPT))
ALLOCATE(TACCS(KMI)%K089(KVECNPT))
ALLOCATE(TACCS(KMI)%K090(KVECNPT))
ALLOCATE(TACCS(KMI)%K091(KVECNPT))
ALLOCATE(TACCS(KMI)%K092(KVECNPT))
ALLOCATE(TACCS(KMI)%K093(KVECNPT))
ALLOCATE(TACCS(KMI)%K094(KVECNPT))
ALLOCATE(TACCS(KMI)%K095(KVECNPT))
ALLOCATE(TACCS(KMI)%K096(KVECNPT))
ALLOCATE(TACCS(KMI)%K097(KVECNPT))
ALLOCATE(TACCS(KMI)%K098(KVECNPT))
ALLOCATE(TACCS(KMI)%K099(KVECNPT))
ALLOCATE(TACCS(KMI)%K0100(KVECNPT))
ALLOCATE(TACCS(KMI)%K0101(KVECNPT))
ALLOCATE(TACCS(KMI)%K0102(KVECNPT))
ALLOCATE(TACCS(KMI)%K103(KVECNPT))
ALLOCATE(TACCS(KMI)%K104(KVECNPT))
ALLOCATE(TACCS(KMI)%K105(KVECNPT))
ALLOCATE(TACCS(KMI)%K106(KVECNPT))
ALLOCATE(TACCS(KMI)%K107(KVECNPT))
ALLOCATE(TACCS(KMI)%K108(KVECNPT))
ALLOCATE(TACCS(KMI)%K109(KVECNPT))
ALLOCATE(TACCS(KMI)%K110(KVECNPT))
ALLOCATE(TACCS(KMI)%K111(KVECNPT))
ALLOCATE(TACCS(KMI)%K112(KVECNPT))
ALLOCATE(TACCS(KMI)%K113(KVECNPT))
ALLOCATE(TACCS(KMI)%K114(KVECNPT))
ALLOCATE(TACCS(KMI)%K115(KVECNPT))
ALLOCATE(TACCS(KMI)%K116(KVECNPT))
ALLOCATE(TACCS(KMI)%K117(KVECNPT))
ALLOCATE(TACCS(KMI)%K118(KVECNPT))
ALLOCATE(TACCS(KMI)%K119(KVECNPT))
ALLOCATE(TACCS(KMI)%K120(KVECNPT))
ALLOCATE(TACCS(KMI)%K121(KVECNPT))
ALLOCATE(TACCS(KMI)%K122(KVECNPT))
ALLOCATE(TACCS(KMI)%K123(KVECNPT))
ALLOCATE(TACCS(KMI)%K124(KVECNPT))
ALLOCATE(TACCS(KMI)%K125(KVECNPT))
ALLOCATE(TACCS(KMI)%K126(KVECNPT))
ALLOCATE(TACCS(KMI)%K127(KVECNPT))
ALLOCATE(TACCS(KMI)%K128(KVECNPT))
ALLOCATE(TACCS(KMI)%K129(KVECNPT))
ALLOCATE(TACCS(KMI)%K130(KVECNPT))
ALLOCATE(TACCS(KMI)%K131(KVECNPT))
ALLOCATE(TACCS(KMI)%K132(KVECNPT))
IF (TACCS(KMI)%LUSECHAQ) THEN
  ALLOCATE(TACCS(KMI)%KTC1(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC2(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC3(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC4(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC5(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC6(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC7(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC8(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC9(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC10(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC11(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC12(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC13(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC14(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC15(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC16(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC17(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC18(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC19(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC20(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC21(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC22(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC23(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC24(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC25(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC26(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC27(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC28(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC29(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC30(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC31(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC32(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC33(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC34(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC35(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC36(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC37(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC38(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC39(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTC40(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR1(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR2(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR3(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR4(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR5(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR6(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR7(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR8(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR9(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR10(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR11(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR12(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR13(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR14(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR15(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR16(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR17(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR18(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR19(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR20(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR21(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR22(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR23(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR24(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR25(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR26(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR27(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR28(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR29(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR30(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR31(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR32(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR33(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR34(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR35(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR36(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR37(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR38(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR39(KVECNPT))
  ALLOCATE(TACCS(KMI)%KTR40(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC1(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC2(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC3(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC4(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC5(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC6(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC7(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC8(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC9(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC10(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC11(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC12(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC13(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC14(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC15(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC16(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC17(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC18(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC19(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC20(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC21(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC22(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC23(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC24(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC25(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC26(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC27(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC28(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC29(KVECNPT))
  ALLOCATE(TACCS(KMI)%KC30(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR1(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR2(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR3(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR4(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR5(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR6(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR7(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR8(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR9(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR10(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR11(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR12(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR13(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR14(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR15(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR16(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR17(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR18(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR19(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR20(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR21(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR22(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR23(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR24(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR25(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR26(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR27(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR28(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR29(KVECNPT))
  ALLOCATE(TACCS(KMI)%KR30(KVECNPT))
END IF
ALLOCATE(TACCS(KMI)%NVERB(KVECNPT))
ALLOCATE(TACCS(KMI)%MODELLEVEL(KVECNPT))
ALLOCATE(TACCS(KMI)%T(KVECNPT))
ALLOCATE(TACCS(KMI)%PRESSURE(KVECNPT))
ALLOCATE(TACCS(KMI)%M(KVECNPT))
ALLOCATE(TACCS(KMI)%H2O(KVECNPT))
ALLOCATE(TACCS(KMI)%CLOUDWATER(KVECNPT))
ALLOCATE(TACCS(KMI)%RAINWATER(KVECNPT))
ALLOCATE(TACCS(KMI)%RHODREF(KVECNPT))
ALLOCATE(TACCS(KMI)%O2(KVECNPT))
ALLOCATE(TACCS(KMI)%N2(KVECNPT))
ALLOCATE(TACCS(KMI)%H2(KVECNPT))
ALLOCATE(TACCS(KMI)%OH(KVECNPT))
ALLOCATE(TACCS(KMI)%O1D(KVECNPT))
ALLOCATE(TACCS(KMI)%O3P(KVECNPT))
ALLOCATE(TACCS(KMI)%LAT(KVECNPT))
ALLOCATE(TACCS(KMI)%LON(KVECNPT))
ALLOCATE(TACCS(KMI)%YEAR(KVECNPT))
ALLOCATE(TACCS(KMI)%MONTH(KVECNPT))
ALLOCATE(TACCS(KMI)%DAY(KVECNPT))
ALLOCATE(TACCS(KMI)%LWC(KVECNPT))
ALLOCATE(TACCS(KMI)%MOL2MOLECCLOUD(KVECNPT))
ALLOCATE(TACCS(KMI)%RADC(KVECNPT))
ALLOCATE(TACCS(KMI)%PHC(KVECNPT))
ALLOCATE(TACCS(KMI)%LWR(KVECNPT))
ALLOCATE(TACCS(KMI)%MOL2MOLECRAIN(KVECNPT))
ALLOCATE(TACCS(KMI)%RADR(KVECNPT))
ALLOCATE(TACCS(KMI)%PHR(KVECNPT))
ALLOCATE(TACCS(KMI)%CO2(KVECNPT))
ALLOCATE(TACCS(KMI)%RCH(KVECNPT))
ALLOCATE(TACCS(KMI)%W_O2(KVECNPT))
END SUBROUTINE CH_ALLOCATE_TACCS
!
!========================================================================
!
!     ##########################
      MODULE MODI_CH_DEALLOCATE_TACCS
!     ##########################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_DEALLOCATE_TACCS(KMI)
IMPLICIT NONE
INTEGER, INTENT(IN)  :: KMI    ! model index
END SUBROUTINE CH_DEALLOCATE_TACCS
END INTERFACE
END MODULE MODI_CH_DEALLOCATE_TACCS
!
!========================================================================
!
!     ###################################
      SUBROUTINE CH_DEALLOCATE_TACCS(KMI)
!     ###################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_DEALLOCATE_TACCS*
!!
!!    PURPOSE
!!    -------
!       Deallocation of all CCSTYPE variables for model KMI
!!
!!**  METHOD
!!    ------
!!
!!   
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Gazen Didier (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 21/06/2005
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
INTEGER, INTENT(IN)  :: KMI    ! model index
!!
!!----------------------------------------------------------------------
! /BEGIN_INITIAL/
! /END_INITIAL/
! initialisation of the names of the chemical species
IF (ASSOCIATED(TACCS(KMI)%K001))  DEALLOCATE(TACCS(KMI)%K001)
IF (ASSOCIATED(TACCS(KMI)%K002))  DEALLOCATE(TACCS(KMI)%K002)
IF (ASSOCIATED(TACCS(KMI)%K003))  DEALLOCATE(TACCS(KMI)%K003)
IF (ASSOCIATED(TACCS(KMI)%K004))  DEALLOCATE(TACCS(KMI)%K004)
IF (ASSOCIATED(TACCS(KMI)%K005))  DEALLOCATE(TACCS(KMI)%K005)
IF (ASSOCIATED(TACCS(KMI)%K006))  DEALLOCATE(TACCS(KMI)%K006)
IF (ASSOCIATED(TACCS(KMI)%K007))  DEALLOCATE(TACCS(KMI)%K007)
IF (ASSOCIATED(TACCS(KMI)%K008))  DEALLOCATE(TACCS(KMI)%K008)
IF (ASSOCIATED(TACCS(KMI)%K009))  DEALLOCATE(TACCS(KMI)%K009)
IF (ASSOCIATED(TACCS(KMI)%K010))  DEALLOCATE(TACCS(KMI)%K010)
IF (ASSOCIATED(TACCS(KMI)%K011))  DEALLOCATE(TACCS(KMI)%K011)
IF (ASSOCIATED(TACCS(KMI)%K012))  DEALLOCATE(TACCS(KMI)%K012)
IF (ASSOCIATED(TACCS(KMI)%K013))  DEALLOCATE(TACCS(KMI)%K013)
IF (ASSOCIATED(TACCS(KMI)%K014))  DEALLOCATE(TACCS(KMI)%K014)
IF (ASSOCIATED(TACCS(KMI)%K015))  DEALLOCATE(TACCS(KMI)%K015)
IF (ASSOCIATED(TACCS(KMI)%K016))  DEALLOCATE(TACCS(KMI)%K016)
IF (ASSOCIATED(TACCS(KMI)%K017))  DEALLOCATE(TACCS(KMI)%K017)
IF (ASSOCIATED(TACCS(KMI)%K018))  DEALLOCATE(TACCS(KMI)%K018)
IF (ASSOCIATED(TACCS(KMI)%K019))  DEALLOCATE(TACCS(KMI)%K019)
IF (ASSOCIATED(TACCS(KMI)%K020))  DEALLOCATE(TACCS(KMI)%K020)
IF (ASSOCIATED(TACCS(KMI)%K021))  DEALLOCATE(TACCS(KMI)%K021)
IF (ASSOCIATED(TACCS(KMI)%K022))  DEALLOCATE(TACCS(KMI)%K022)
IF (ASSOCIATED(TACCS(KMI)%K023))  DEALLOCATE(TACCS(KMI)%K023)
IF (ASSOCIATED(TACCS(KMI)%K024))  DEALLOCATE(TACCS(KMI)%K024)
IF (ASSOCIATED(TACCS(KMI)%K025))  DEALLOCATE(TACCS(KMI)%K025)
IF (ASSOCIATED(TACCS(KMI)%K026))  DEALLOCATE(TACCS(KMI)%K026)
IF (ASSOCIATED(TACCS(KMI)%K027))  DEALLOCATE(TACCS(KMI)%K027)
IF (ASSOCIATED(TACCS(KMI)%K028))  DEALLOCATE(TACCS(KMI)%K028)
IF (ASSOCIATED(TACCS(KMI)%K029))  DEALLOCATE(TACCS(KMI)%K029)
IF (ASSOCIATED(TACCS(KMI)%K030))  DEALLOCATE(TACCS(KMI)%K030)
IF (ASSOCIATED(TACCS(KMI)%K031))  DEALLOCATE(TACCS(KMI)%K031)
IF (ASSOCIATED(TACCS(KMI)%K032))  DEALLOCATE(TACCS(KMI)%K032)
IF (ASSOCIATED(TACCS(KMI)%K033))  DEALLOCATE(TACCS(KMI)%K033)
IF (ASSOCIATED(TACCS(KMI)%K034))  DEALLOCATE(TACCS(KMI)%K034)
IF (ASSOCIATED(TACCS(KMI)%K035))  DEALLOCATE(TACCS(KMI)%K035)
IF (ASSOCIATED(TACCS(KMI)%K036))  DEALLOCATE(TACCS(KMI)%K036)
IF (ASSOCIATED(TACCS(KMI)%K037))  DEALLOCATE(TACCS(KMI)%K037)
IF (ASSOCIATED(TACCS(KMI)%K038))  DEALLOCATE(TACCS(KMI)%K038)
IF (ASSOCIATED(TACCS(KMI)%K039))  DEALLOCATE(TACCS(KMI)%K039)
IF (ASSOCIATED(TACCS(KMI)%K040))  DEALLOCATE(TACCS(KMI)%K040)
IF (ASSOCIATED(TACCS(KMI)%K041))  DEALLOCATE(TACCS(KMI)%K041)
IF (ASSOCIATED(TACCS(KMI)%K042))  DEALLOCATE(TACCS(KMI)%K042)
IF (ASSOCIATED(TACCS(KMI)%K043))  DEALLOCATE(TACCS(KMI)%K043)
IF (ASSOCIATED(TACCS(KMI)%K044))  DEALLOCATE(TACCS(KMI)%K044)
IF (ASSOCIATED(TACCS(KMI)%K045))  DEALLOCATE(TACCS(KMI)%K045)
IF (ASSOCIATED(TACCS(KMI)%K046))  DEALLOCATE(TACCS(KMI)%K046)
IF (ASSOCIATED(TACCS(KMI)%K047))  DEALLOCATE(TACCS(KMI)%K047)
IF (ASSOCIATED(TACCS(KMI)%K048))  DEALLOCATE(TACCS(KMI)%K048)
IF (ASSOCIATED(TACCS(KMI)%K049))  DEALLOCATE(TACCS(KMI)%K049)
IF (ASSOCIATED(TACCS(KMI)%K050))  DEALLOCATE(TACCS(KMI)%K050)
IF (ASSOCIATED(TACCS(KMI)%K051))  DEALLOCATE(TACCS(KMI)%K051)
IF (ASSOCIATED(TACCS(KMI)%K052))  DEALLOCATE(TACCS(KMI)%K052)
IF (ASSOCIATED(TACCS(KMI)%K053))  DEALLOCATE(TACCS(KMI)%K053)
IF (ASSOCIATED(TACCS(KMI)%K054))  DEALLOCATE(TACCS(KMI)%K054)
IF (ASSOCIATED(TACCS(KMI)%K055))  DEALLOCATE(TACCS(KMI)%K055)
IF (ASSOCIATED(TACCS(KMI)%K056))  DEALLOCATE(TACCS(KMI)%K056)
IF (ASSOCIATED(TACCS(KMI)%K057))  DEALLOCATE(TACCS(KMI)%K057)
IF (ASSOCIATED(TACCS(KMI)%K058))  DEALLOCATE(TACCS(KMI)%K058)
IF (ASSOCIATED(TACCS(KMI)%K059))  DEALLOCATE(TACCS(KMI)%K059)
IF (ASSOCIATED(TACCS(KMI)%K060))  DEALLOCATE(TACCS(KMI)%K060)
IF (ASSOCIATED(TACCS(KMI)%K061))  DEALLOCATE(TACCS(KMI)%K061)
IF (ASSOCIATED(TACCS(KMI)%K062))  DEALLOCATE(TACCS(KMI)%K062)
IF (ASSOCIATED(TACCS(KMI)%K063))  DEALLOCATE(TACCS(KMI)%K063)
IF (ASSOCIATED(TACCS(KMI)%K064))  DEALLOCATE(TACCS(KMI)%K064)
IF (ASSOCIATED(TACCS(KMI)%K065))  DEALLOCATE(TACCS(KMI)%K065)
IF (ASSOCIATED(TACCS(KMI)%K066))  DEALLOCATE(TACCS(KMI)%K066)
IF (ASSOCIATED(TACCS(KMI)%K067))  DEALLOCATE(TACCS(KMI)%K067)
IF (ASSOCIATED(TACCS(KMI)%K068))  DEALLOCATE(TACCS(KMI)%K068)
IF (ASSOCIATED(TACCS(KMI)%K069))  DEALLOCATE(TACCS(KMI)%K069)
IF (ASSOCIATED(TACCS(KMI)%K070))  DEALLOCATE(TACCS(KMI)%K070)
IF (ASSOCIATED(TACCS(KMI)%K071))  DEALLOCATE(TACCS(KMI)%K071)
IF (ASSOCIATED(TACCS(KMI)%K072))  DEALLOCATE(TACCS(KMI)%K072)
IF (ASSOCIATED(TACCS(KMI)%K073))  DEALLOCATE(TACCS(KMI)%K073)
IF (ASSOCIATED(TACCS(KMI)%K074))  DEALLOCATE(TACCS(KMI)%K074)
IF (ASSOCIATED(TACCS(KMI)%K075))  DEALLOCATE(TACCS(KMI)%K075)
IF (ASSOCIATED(TACCS(KMI)%K076))  DEALLOCATE(TACCS(KMI)%K076)
IF (ASSOCIATED(TACCS(KMI)%K077))  DEALLOCATE(TACCS(KMI)%K077)
IF (ASSOCIATED(TACCS(KMI)%K078))  DEALLOCATE(TACCS(KMI)%K078)
IF (ASSOCIATED(TACCS(KMI)%K079))  DEALLOCATE(TACCS(KMI)%K079)
IF (ASSOCIATED(TACCS(KMI)%K080))  DEALLOCATE(TACCS(KMI)%K080)
IF (ASSOCIATED(TACCS(KMI)%K081))  DEALLOCATE(TACCS(KMI)%K081)
IF (ASSOCIATED(TACCS(KMI)%K082))  DEALLOCATE(TACCS(KMI)%K082)
IF (ASSOCIATED(TACCS(KMI)%K083))  DEALLOCATE(TACCS(KMI)%K083)
IF (ASSOCIATED(TACCS(KMI)%K084))  DEALLOCATE(TACCS(KMI)%K084)
IF (ASSOCIATED(TACCS(KMI)%K085))  DEALLOCATE(TACCS(KMI)%K085)
IF (ASSOCIATED(TACCS(KMI)%K086))  DEALLOCATE(TACCS(KMI)%K086)
IF (ASSOCIATED(TACCS(KMI)%K087))  DEALLOCATE(TACCS(KMI)%K087)
IF (ASSOCIATED(TACCS(KMI)%K088))  DEALLOCATE(TACCS(KMI)%K088)
IF (ASSOCIATED(TACCS(KMI)%K089))  DEALLOCATE(TACCS(KMI)%K089)
IF (ASSOCIATED(TACCS(KMI)%K090))  DEALLOCATE(TACCS(KMI)%K090)
IF (ASSOCIATED(TACCS(KMI)%K091))  DEALLOCATE(TACCS(KMI)%K091)
IF (ASSOCIATED(TACCS(KMI)%K092))  DEALLOCATE(TACCS(KMI)%K092)
IF (ASSOCIATED(TACCS(KMI)%K093))  DEALLOCATE(TACCS(KMI)%K093)
IF (ASSOCIATED(TACCS(KMI)%K094))  DEALLOCATE(TACCS(KMI)%K094)
IF (ASSOCIATED(TACCS(KMI)%K095))  DEALLOCATE(TACCS(KMI)%K095)
IF (ASSOCIATED(TACCS(KMI)%K096))  DEALLOCATE(TACCS(KMI)%K096)
IF (ASSOCIATED(TACCS(KMI)%K097))  DEALLOCATE(TACCS(KMI)%K097)
IF (ASSOCIATED(TACCS(KMI)%K098))  DEALLOCATE(TACCS(KMI)%K098)
IF (ASSOCIATED(TACCS(KMI)%K099))  DEALLOCATE(TACCS(KMI)%K099)
IF (ASSOCIATED(TACCS(KMI)%K0100))  DEALLOCATE(TACCS(KMI)%K0100)
IF (ASSOCIATED(TACCS(KMI)%K0101))  DEALLOCATE(TACCS(KMI)%K0101)
IF (ASSOCIATED(TACCS(KMI)%K0102))  DEALLOCATE(TACCS(KMI)%K0102)
IF (ASSOCIATED(TACCS(KMI)%K103))  DEALLOCATE(TACCS(KMI)%K103)
IF (ASSOCIATED(TACCS(KMI)%K104))  DEALLOCATE(TACCS(KMI)%K104)
IF (ASSOCIATED(TACCS(KMI)%K105))  DEALLOCATE(TACCS(KMI)%K105)
IF (ASSOCIATED(TACCS(KMI)%K106))  DEALLOCATE(TACCS(KMI)%K106)
IF (ASSOCIATED(TACCS(KMI)%K107))  DEALLOCATE(TACCS(KMI)%K107)
IF (ASSOCIATED(TACCS(KMI)%K108))  DEALLOCATE(TACCS(KMI)%K108)
IF (ASSOCIATED(TACCS(KMI)%K109))  DEALLOCATE(TACCS(KMI)%K109)
IF (ASSOCIATED(TACCS(KMI)%K110))  DEALLOCATE(TACCS(KMI)%K110)
IF (ASSOCIATED(TACCS(KMI)%K111))  DEALLOCATE(TACCS(KMI)%K111)
IF (ASSOCIATED(TACCS(KMI)%K112))  DEALLOCATE(TACCS(KMI)%K112)
IF (ASSOCIATED(TACCS(KMI)%K113))  DEALLOCATE(TACCS(KMI)%K113)
IF (ASSOCIATED(TACCS(KMI)%K114))  DEALLOCATE(TACCS(KMI)%K114)
IF (ASSOCIATED(TACCS(KMI)%K115))  DEALLOCATE(TACCS(KMI)%K115)
IF (ASSOCIATED(TACCS(KMI)%K116))  DEALLOCATE(TACCS(KMI)%K116)
IF (ASSOCIATED(TACCS(KMI)%K117))  DEALLOCATE(TACCS(KMI)%K117)
IF (ASSOCIATED(TACCS(KMI)%K118))  DEALLOCATE(TACCS(KMI)%K118)
IF (ASSOCIATED(TACCS(KMI)%K119))  DEALLOCATE(TACCS(KMI)%K119)
IF (ASSOCIATED(TACCS(KMI)%K120))  DEALLOCATE(TACCS(KMI)%K120)
IF (ASSOCIATED(TACCS(KMI)%K121))  DEALLOCATE(TACCS(KMI)%K121)
IF (ASSOCIATED(TACCS(KMI)%K122))  DEALLOCATE(TACCS(KMI)%K122)
IF (ASSOCIATED(TACCS(KMI)%K123))  DEALLOCATE(TACCS(KMI)%K123)
IF (ASSOCIATED(TACCS(KMI)%K124))  DEALLOCATE(TACCS(KMI)%K124)
IF (ASSOCIATED(TACCS(KMI)%K125))  DEALLOCATE(TACCS(KMI)%K125)
IF (ASSOCIATED(TACCS(KMI)%K126))  DEALLOCATE(TACCS(KMI)%K126)
IF (ASSOCIATED(TACCS(KMI)%K127))  DEALLOCATE(TACCS(KMI)%K127)
IF (ASSOCIATED(TACCS(KMI)%K128))  DEALLOCATE(TACCS(KMI)%K128)
IF (ASSOCIATED(TACCS(KMI)%K129))  DEALLOCATE(TACCS(KMI)%K129)
IF (ASSOCIATED(TACCS(KMI)%K130))  DEALLOCATE(TACCS(KMI)%K130)
IF (ASSOCIATED(TACCS(KMI)%K131))  DEALLOCATE(TACCS(KMI)%K131)
IF (ASSOCIATED(TACCS(KMI)%K132))  DEALLOCATE(TACCS(KMI)%K132)
IF (ASSOCIATED(TACCS(KMI)%KTC1))  DEALLOCATE(TACCS(KMI)%KTC1)
IF (ASSOCIATED(TACCS(KMI)%KTC2))  DEALLOCATE(TACCS(KMI)%KTC2)
IF (ASSOCIATED(TACCS(KMI)%KTC3))  DEALLOCATE(TACCS(KMI)%KTC3)
IF (ASSOCIATED(TACCS(KMI)%KTC4))  DEALLOCATE(TACCS(KMI)%KTC4)
IF (ASSOCIATED(TACCS(KMI)%KTC5))  DEALLOCATE(TACCS(KMI)%KTC5)
IF (ASSOCIATED(TACCS(KMI)%KTC6))  DEALLOCATE(TACCS(KMI)%KTC6)
IF (ASSOCIATED(TACCS(KMI)%KTC7))  DEALLOCATE(TACCS(KMI)%KTC7)
IF (ASSOCIATED(TACCS(KMI)%KTC8))  DEALLOCATE(TACCS(KMI)%KTC8)
IF (ASSOCIATED(TACCS(KMI)%KTC9))  DEALLOCATE(TACCS(KMI)%KTC9)
IF (ASSOCIATED(TACCS(KMI)%KTC10))  DEALLOCATE(TACCS(KMI)%KTC10)
IF (ASSOCIATED(TACCS(KMI)%KTC11))  DEALLOCATE(TACCS(KMI)%KTC11)
IF (ASSOCIATED(TACCS(KMI)%KTC12))  DEALLOCATE(TACCS(KMI)%KTC12)
IF (ASSOCIATED(TACCS(KMI)%KTC13))  DEALLOCATE(TACCS(KMI)%KTC13)
IF (ASSOCIATED(TACCS(KMI)%KTC14))  DEALLOCATE(TACCS(KMI)%KTC14)
IF (ASSOCIATED(TACCS(KMI)%KTC15))  DEALLOCATE(TACCS(KMI)%KTC15)
IF (ASSOCIATED(TACCS(KMI)%KTC16))  DEALLOCATE(TACCS(KMI)%KTC16)
IF (ASSOCIATED(TACCS(KMI)%KTC17))  DEALLOCATE(TACCS(KMI)%KTC17)
IF (ASSOCIATED(TACCS(KMI)%KTC18))  DEALLOCATE(TACCS(KMI)%KTC18)
IF (ASSOCIATED(TACCS(KMI)%KTC19))  DEALLOCATE(TACCS(KMI)%KTC19)
IF (ASSOCIATED(TACCS(KMI)%KTC20))  DEALLOCATE(TACCS(KMI)%KTC20)
IF (ASSOCIATED(TACCS(KMI)%KTC21))  DEALLOCATE(TACCS(KMI)%KTC21)
IF (ASSOCIATED(TACCS(KMI)%KTC22))  DEALLOCATE(TACCS(KMI)%KTC22)
IF (ASSOCIATED(TACCS(KMI)%KTC23))  DEALLOCATE(TACCS(KMI)%KTC23)
IF (ASSOCIATED(TACCS(KMI)%KTC24))  DEALLOCATE(TACCS(KMI)%KTC24)
IF (ASSOCIATED(TACCS(KMI)%KTC25))  DEALLOCATE(TACCS(KMI)%KTC25)
IF (ASSOCIATED(TACCS(KMI)%KTC26))  DEALLOCATE(TACCS(KMI)%KTC26)
IF (ASSOCIATED(TACCS(KMI)%KTC27))  DEALLOCATE(TACCS(KMI)%KTC27)
IF (ASSOCIATED(TACCS(KMI)%KTC28))  DEALLOCATE(TACCS(KMI)%KTC28)
IF (ASSOCIATED(TACCS(KMI)%KTC29))  DEALLOCATE(TACCS(KMI)%KTC29)
IF (ASSOCIATED(TACCS(KMI)%KTC30))  DEALLOCATE(TACCS(KMI)%KTC30)
IF (ASSOCIATED(TACCS(KMI)%KTC31))  DEALLOCATE(TACCS(KMI)%KTC31)
IF (ASSOCIATED(TACCS(KMI)%KTC32))  DEALLOCATE(TACCS(KMI)%KTC32)
IF (ASSOCIATED(TACCS(KMI)%KTC33))  DEALLOCATE(TACCS(KMI)%KTC33)
IF (ASSOCIATED(TACCS(KMI)%KTC34))  DEALLOCATE(TACCS(KMI)%KTC34)
IF (ASSOCIATED(TACCS(KMI)%KTC35))  DEALLOCATE(TACCS(KMI)%KTC35)
IF (ASSOCIATED(TACCS(KMI)%KTC36))  DEALLOCATE(TACCS(KMI)%KTC36)
IF (ASSOCIATED(TACCS(KMI)%KTC37))  DEALLOCATE(TACCS(KMI)%KTC37)
IF (ASSOCIATED(TACCS(KMI)%KTC38))  DEALLOCATE(TACCS(KMI)%KTC38)
IF (ASSOCIATED(TACCS(KMI)%KTC39))  DEALLOCATE(TACCS(KMI)%KTC39)
IF (ASSOCIATED(TACCS(KMI)%KTC40))  DEALLOCATE(TACCS(KMI)%KTC40)
IF (ASSOCIATED(TACCS(KMI)%KTR1))  DEALLOCATE(TACCS(KMI)%KTR1)
IF (ASSOCIATED(TACCS(KMI)%KTR2))  DEALLOCATE(TACCS(KMI)%KTR2)
IF (ASSOCIATED(TACCS(KMI)%KTR3))  DEALLOCATE(TACCS(KMI)%KTR3)
IF (ASSOCIATED(TACCS(KMI)%KTR4))  DEALLOCATE(TACCS(KMI)%KTR4)
IF (ASSOCIATED(TACCS(KMI)%KTR5))  DEALLOCATE(TACCS(KMI)%KTR5)
IF (ASSOCIATED(TACCS(KMI)%KTR6))  DEALLOCATE(TACCS(KMI)%KTR6)
IF (ASSOCIATED(TACCS(KMI)%KTR7))  DEALLOCATE(TACCS(KMI)%KTR7)
IF (ASSOCIATED(TACCS(KMI)%KTR8))  DEALLOCATE(TACCS(KMI)%KTR8)
IF (ASSOCIATED(TACCS(KMI)%KTR9))  DEALLOCATE(TACCS(KMI)%KTR9)
IF (ASSOCIATED(TACCS(KMI)%KTR10))  DEALLOCATE(TACCS(KMI)%KTR10)
IF (ASSOCIATED(TACCS(KMI)%KTR11))  DEALLOCATE(TACCS(KMI)%KTR11)
IF (ASSOCIATED(TACCS(KMI)%KTR12))  DEALLOCATE(TACCS(KMI)%KTR12)
IF (ASSOCIATED(TACCS(KMI)%KTR13))  DEALLOCATE(TACCS(KMI)%KTR13)
IF (ASSOCIATED(TACCS(KMI)%KTR14))  DEALLOCATE(TACCS(KMI)%KTR14)
IF (ASSOCIATED(TACCS(KMI)%KTR15))  DEALLOCATE(TACCS(KMI)%KTR15)
IF (ASSOCIATED(TACCS(KMI)%KTR16))  DEALLOCATE(TACCS(KMI)%KTR16)
IF (ASSOCIATED(TACCS(KMI)%KTR17))  DEALLOCATE(TACCS(KMI)%KTR17)
IF (ASSOCIATED(TACCS(KMI)%KTR18))  DEALLOCATE(TACCS(KMI)%KTR18)
IF (ASSOCIATED(TACCS(KMI)%KTR19))  DEALLOCATE(TACCS(KMI)%KTR19)
IF (ASSOCIATED(TACCS(KMI)%KTR20))  DEALLOCATE(TACCS(KMI)%KTR20)
IF (ASSOCIATED(TACCS(KMI)%KTR21))  DEALLOCATE(TACCS(KMI)%KTR21)
IF (ASSOCIATED(TACCS(KMI)%KTR22))  DEALLOCATE(TACCS(KMI)%KTR22)
IF (ASSOCIATED(TACCS(KMI)%KTR23))  DEALLOCATE(TACCS(KMI)%KTR23)
IF (ASSOCIATED(TACCS(KMI)%KTR24))  DEALLOCATE(TACCS(KMI)%KTR24)
IF (ASSOCIATED(TACCS(KMI)%KTR25))  DEALLOCATE(TACCS(KMI)%KTR25)
IF (ASSOCIATED(TACCS(KMI)%KTR26))  DEALLOCATE(TACCS(KMI)%KTR26)
IF (ASSOCIATED(TACCS(KMI)%KTR27))  DEALLOCATE(TACCS(KMI)%KTR27)
IF (ASSOCIATED(TACCS(KMI)%KTR28))  DEALLOCATE(TACCS(KMI)%KTR28)
IF (ASSOCIATED(TACCS(KMI)%KTR29))  DEALLOCATE(TACCS(KMI)%KTR29)
IF (ASSOCIATED(TACCS(KMI)%KTR30))  DEALLOCATE(TACCS(KMI)%KTR30)
IF (ASSOCIATED(TACCS(KMI)%KTR31))  DEALLOCATE(TACCS(KMI)%KTR31)
IF (ASSOCIATED(TACCS(KMI)%KTR32))  DEALLOCATE(TACCS(KMI)%KTR32)
IF (ASSOCIATED(TACCS(KMI)%KTR33))  DEALLOCATE(TACCS(KMI)%KTR33)
IF (ASSOCIATED(TACCS(KMI)%KTR34))  DEALLOCATE(TACCS(KMI)%KTR34)
IF (ASSOCIATED(TACCS(KMI)%KTR35))  DEALLOCATE(TACCS(KMI)%KTR35)
IF (ASSOCIATED(TACCS(KMI)%KTR36))  DEALLOCATE(TACCS(KMI)%KTR36)
IF (ASSOCIATED(TACCS(KMI)%KTR37))  DEALLOCATE(TACCS(KMI)%KTR37)
IF (ASSOCIATED(TACCS(KMI)%KTR38))  DEALLOCATE(TACCS(KMI)%KTR38)
IF (ASSOCIATED(TACCS(KMI)%KTR39))  DEALLOCATE(TACCS(KMI)%KTR39)
IF (ASSOCIATED(TACCS(KMI)%KTR40))  DEALLOCATE(TACCS(KMI)%KTR40)
IF (ASSOCIATED(TACCS(KMI)%KC1))  DEALLOCATE(TACCS(KMI)%KC1)
IF (ASSOCIATED(TACCS(KMI)%KC2))  DEALLOCATE(TACCS(KMI)%KC2)
IF (ASSOCIATED(TACCS(KMI)%KC3))  DEALLOCATE(TACCS(KMI)%KC3)
IF (ASSOCIATED(TACCS(KMI)%KC4))  DEALLOCATE(TACCS(KMI)%KC4)
IF (ASSOCIATED(TACCS(KMI)%KC5))  DEALLOCATE(TACCS(KMI)%KC5)
IF (ASSOCIATED(TACCS(KMI)%KC6))  DEALLOCATE(TACCS(KMI)%KC6)
IF (ASSOCIATED(TACCS(KMI)%KC7))  DEALLOCATE(TACCS(KMI)%KC7)
IF (ASSOCIATED(TACCS(KMI)%KC8))  DEALLOCATE(TACCS(KMI)%KC8)
IF (ASSOCIATED(TACCS(KMI)%KC9))  DEALLOCATE(TACCS(KMI)%KC9)
IF (ASSOCIATED(TACCS(KMI)%KC10))  DEALLOCATE(TACCS(KMI)%KC10)
IF (ASSOCIATED(TACCS(KMI)%KC11))  DEALLOCATE(TACCS(KMI)%KC11)
IF (ASSOCIATED(TACCS(KMI)%KC12))  DEALLOCATE(TACCS(KMI)%KC12)
IF (ASSOCIATED(TACCS(KMI)%KC13))  DEALLOCATE(TACCS(KMI)%KC13)
IF (ASSOCIATED(TACCS(KMI)%KC14))  DEALLOCATE(TACCS(KMI)%KC14)
IF (ASSOCIATED(TACCS(KMI)%KC15))  DEALLOCATE(TACCS(KMI)%KC15)
IF (ASSOCIATED(TACCS(KMI)%KC16))  DEALLOCATE(TACCS(KMI)%KC16)
IF (ASSOCIATED(TACCS(KMI)%KC17))  DEALLOCATE(TACCS(KMI)%KC17)
IF (ASSOCIATED(TACCS(KMI)%KC18))  DEALLOCATE(TACCS(KMI)%KC18)
IF (ASSOCIATED(TACCS(KMI)%KC19))  DEALLOCATE(TACCS(KMI)%KC19)
IF (ASSOCIATED(TACCS(KMI)%KC20))  DEALLOCATE(TACCS(KMI)%KC20)
IF (ASSOCIATED(TACCS(KMI)%KC21))  DEALLOCATE(TACCS(KMI)%KC21)
IF (ASSOCIATED(TACCS(KMI)%KC22))  DEALLOCATE(TACCS(KMI)%KC22)
IF (ASSOCIATED(TACCS(KMI)%KC23))  DEALLOCATE(TACCS(KMI)%KC23)
IF (ASSOCIATED(TACCS(KMI)%KC24))  DEALLOCATE(TACCS(KMI)%KC24)
IF (ASSOCIATED(TACCS(KMI)%KC25))  DEALLOCATE(TACCS(KMI)%KC25)
IF (ASSOCIATED(TACCS(KMI)%KC26))  DEALLOCATE(TACCS(KMI)%KC26)
IF (ASSOCIATED(TACCS(KMI)%KC27))  DEALLOCATE(TACCS(KMI)%KC27)
IF (ASSOCIATED(TACCS(KMI)%KC28))  DEALLOCATE(TACCS(KMI)%KC28)
IF (ASSOCIATED(TACCS(KMI)%KC29))  DEALLOCATE(TACCS(KMI)%KC29)
IF (ASSOCIATED(TACCS(KMI)%KC30))  DEALLOCATE(TACCS(KMI)%KC30)
IF (ASSOCIATED(TACCS(KMI)%KR1))  DEALLOCATE(TACCS(KMI)%KR1)
IF (ASSOCIATED(TACCS(KMI)%KR2))  DEALLOCATE(TACCS(KMI)%KR2)
IF (ASSOCIATED(TACCS(KMI)%KR3))  DEALLOCATE(TACCS(KMI)%KR3)
IF (ASSOCIATED(TACCS(KMI)%KR4))  DEALLOCATE(TACCS(KMI)%KR4)
IF (ASSOCIATED(TACCS(KMI)%KR5))  DEALLOCATE(TACCS(KMI)%KR5)
IF (ASSOCIATED(TACCS(KMI)%KR6))  DEALLOCATE(TACCS(KMI)%KR6)
IF (ASSOCIATED(TACCS(KMI)%KR7))  DEALLOCATE(TACCS(KMI)%KR7)
IF (ASSOCIATED(TACCS(KMI)%KR8))  DEALLOCATE(TACCS(KMI)%KR8)
IF (ASSOCIATED(TACCS(KMI)%KR9))  DEALLOCATE(TACCS(KMI)%KR9)
IF (ASSOCIATED(TACCS(KMI)%KR10))  DEALLOCATE(TACCS(KMI)%KR10)
IF (ASSOCIATED(TACCS(KMI)%KR11))  DEALLOCATE(TACCS(KMI)%KR11)
IF (ASSOCIATED(TACCS(KMI)%KR12))  DEALLOCATE(TACCS(KMI)%KR12)
IF (ASSOCIATED(TACCS(KMI)%KR13))  DEALLOCATE(TACCS(KMI)%KR13)
IF (ASSOCIATED(TACCS(KMI)%KR14))  DEALLOCATE(TACCS(KMI)%KR14)
IF (ASSOCIATED(TACCS(KMI)%KR15))  DEALLOCATE(TACCS(KMI)%KR15)
IF (ASSOCIATED(TACCS(KMI)%KR16))  DEALLOCATE(TACCS(KMI)%KR16)
IF (ASSOCIATED(TACCS(KMI)%KR17))  DEALLOCATE(TACCS(KMI)%KR17)
IF (ASSOCIATED(TACCS(KMI)%KR18))  DEALLOCATE(TACCS(KMI)%KR18)
IF (ASSOCIATED(TACCS(KMI)%KR19))  DEALLOCATE(TACCS(KMI)%KR19)
IF (ASSOCIATED(TACCS(KMI)%KR20))  DEALLOCATE(TACCS(KMI)%KR20)
IF (ASSOCIATED(TACCS(KMI)%KR21))  DEALLOCATE(TACCS(KMI)%KR21)
IF (ASSOCIATED(TACCS(KMI)%KR22))  DEALLOCATE(TACCS(KMI)%KR22)
IF (ASSOCIATED(TACCS(KMI)%KR23))  DEALLOCATE(TACCS(KMI)%KR23)
IF (ASSOCIATED(TACCS(KMI)%KR24))  DEALLOCATE(TACCS(KMI)%KR24)
IF (ASSOCIATED(TACCS(KMI)%KR25))  DEALLOCATE(TACCS(KMI)%KR25)
IF (ASSOCIATED(TACCS(KMI)%KR26))  DEALLOCATE(TACCS(KMI)%KR26)
IF (ASSOCIATED(TACCS(KMI)%KR27))  DEALLOCATE(TACCS(KMI)%KR27)
IF (ASSOCIATED(TACCS(KMI)%KR28))  DEALLOCATE(TACCS(KMI)%KR28)
IF (ASSOCIATED(TACCS(KMI)%KR29))  DEALLOCATE(TACCS(KMI)%KR29)
IF (ASSOCIATED(TACCS(KMI)%KR30))  DEALLOCATE(TACCS(KMI)%KR30)
IF (ASSOCIATED(TACCS(KMI)%NVERB)) DEALLOCATE(TACCS(KMI)%NVERB)
IF (ASSOCIATED(TACCS(KMI)%MODELLEVEL)) DEALLOCATE(TACCS(KMI)%MODELLEVEL)
IF (ASSOCIATED(TACCS(KMI)%T)) DEALLOCATE(TACCS(KMI)%T)
IF (ASSOCIATED(TACCS(KMI)%PRESSURE)) DEALLOCATE(TACCS(KMI)%PRESSURE)
IF (ASSOCIATED(TACCS(KMI)%M)) DEALLOCATE(TACCS(KMI)%M)
IF (ASSOCIATED(TACCS(KMI)%H2O)) DEALLOCATE(TACCS(KMI)%H2O)
IF (ASSOCIATED(TACCS(KMI)%CLOUDWATER)) DEALLOCATE(TACCS(KMI)%CLOUDWATER)
IF (ASSOCIATED(TACCS(KMI)%RAINWATER)) DEALLOCATE(TACCS(KMI)%RAINWATER)
IF (ASSOCIATED(TACCS(KMI)%RHODREF)) DEALLOCATE(TACCS(KMI)%RHODREF)
IF (ASSOCIATED(TACCS(KMI)%O2)) DEALLOCATE(TACCS(KMI)%O2)
IF (ASSOCIATED(TACCS(KMI)%N2)) DEALLOCATE(TACCS(KMI)%N2)
IF (ASSOCIATED(TACCS(KMI)%H2)) DEALLOCATE(TACCS(KMI)%H2)
IF (ASSOCIATED(TACCS(KMI)%OH)) DEALLOCATE(TACCS(KMI)%OH)
IF (ASSOCIATED(TACCS(KMI)%O1D)) DEALLOCATE(TACCS(KMI)%O1D)
IF (ASSOCIATED(TACCS(KMI)%O3P)) DEALLOCATE(TACCS(KMI)%O3P)
IF (ASSOCIATED(TACCS(KMI)%LAT)) DEALLOCATE(TACCS(KMI)%LAT)
IF (ASSOCIATED(TACCS(KMI)%LON)) DEALLOCATE(TACCS(KMI)%LON)
IF (ASSOCIATED(TACCS(KMI)%YEAR)) DEALLOCATE(TACCS(KMI)%YEAR)
IF (ASSOCIATED(TACCS(KMI)%MONTH)) DEALLOCATE(TACCS(KMI)%MONTH)
IF (ASSOCIATED(TACCS(KMI)%DAY)) DEALLOCATE(TACCS(KMI)%DAY)
IF (ASSOCIATED(TACCS(KMI)%LWC)) DEALLOCATE(TACCS(KMI)%LWC)
IF (ASSOCIATED(TACCS(KMI)%MOL2MOLECCLOUD)) DEALLOCATE(TACCS(KMI)%MOL2MOLECCLOUD)
IF (ASSOCIATED(TACCS(KMI)%RADC)) DEALLOCATE(TACCS(KMI)%RADC)
IF (ASSOCIATED(TACCS(KMI)%PHC)) DEALLOCATE(TACCS(KMI)%PHC)
IF (ASSOCIATED(TACCS(KMI)%LWR)) DEALLOCATE(TACCS(KMI)%LWR)
IF (ASSOCIATED(TACCS(KMI)%MOL2MOLECRAIN)) DEALLOCATE(TACCS(KMI)%MOL2MOLECRAIN)
IF (ASSOCIATED(TACCS(KMI)%RADR)) DEALLOCATE(TACCS(KMI)%RADR)
IF (ASSOCIATED(TACCS(KMI)%PHR)) DEALLOCATE(TACCS(KMI)%PHR)
IF (ASSOCIATED(TACCS(KMI)%CO2)) DEALLOCATE(TACCS(KMI)%CO2)
IF (ASSOCIATED(TACCS(KMI)%RCH)) DEALLOCATE(TACCS(KMI)%RCH)
IF (ASSOCIATED(TACCS(KMI)%W_O2)) DEALLOCATE(TACCS(KMI)%W_O2)
END SUBROUTINE CH_DEALLOCATE_TACCS
!
!========================================================================
!
!     #######################
      MODULE MODI_CH_INIT_CCS
!     #######################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_INIT_CCS(KMI,OUSECHAQ,OCH_PH,KOUT,KVERB)
IMPLICIT NONE
INTEGER, INTENT(IN)  :: KMI         ! model number
LOGICAL, INTENT(IN)  :: OUSECHAQ
LOGICAL, INTENT(IN)  :: OCH_PH
INTEGER, INTENT(IN)  :: KOUT, KVERB ! stdout output, verbosity level 
END SUBROUTINE CH_INIT_CCS
END INTERFACE
END MODULE MODI_CH_INIT_CCS
!
!========================================================================
!
!     ######################################################
      SUBROUTINE CH_INIT_CCS(KMI,OUSECHAQ,OCH_PH,KOUT,KVERB)
!     ######################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_INIT_CCS*
!!
!!    PURPOSE
!!    -------
!       initialization of the chemical reaction mechanism
!!
!!**  METHOD
!!    ------
!!
!!      The variables CNAMES and CREACS of MODD_CH_M9_SCHEME are defined here.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
INTEGER, INTENT(IN)  :: KMI         ! model number
LOGICAL, INTENT(IN)  :: OUSECHAQ
LOGICAL, INTENT(IN)  :: OCH_PH
INTEGER, INTENT(IN)  :: KOUT, KVERB ! stdout output, verbosity level 
!!
!!    LOCAL VARIABLES
!!    ---------------
LOGICAL, SAVE :: GFIRSTCALL = .TRUE.
INTEGER :: JII ! loop control
INTEGER :: INDX
!!
!!----------------------------------------------------------------------
! /BEGIN_INITIAL/
! /END_INITIAL/
INDX = 1
IF (OUSECHAQ) INDX = 2
TACCS(KMI)%NEQ    = JPNEQ(INDX)
TACCS(KMI)%NEQAQ  = JPNEQAQ(INDX)
TACCS(KMI)%NREAC  = JPNREAC(INDX)
TACCS(KMI)%NMETEOVARS  = JPNMETEOVARS(INDX)
TACCS(KMI)%NNONZEROTERMS  = JPNNONZEROTERMS(INDX)
!
TACCS(KMI)%LUSECHAQ = OUSECHAQ
TACCS(KMI)%LCH_PH   = OCH_PH
TACCS(KMI)%NOUT     = KOUT
!
IF (GFIRSTCALL) THEN
   GFIRSTCALL = .FALSE.
! initialisation of the names of the chemical species
  CNAMES(1) = 'O3'
  CNAMES(2) = 'H2O2'
  CNAMES(3) = 'NO'
  CNAMES(4) = 'NO2'
  CNAMES(5) = 'NO3'
  CNAMES(6) = 'N2O5'
  CNAMES(7) = 'HONO'
  CNAMES(8) = 'HNO3'
  CNAMES(9) = 'HNO4'
  CNAMES(10) = 'NH3'
  CNAMES(11) = 'SO2'
  CNAMES(12) = 'SULF'
  CNAMES(13) = 'CO'
  CNAMES(14) = 'OH'
  CNAMES(15) = 'HO2'
  CNAMES(16) = 'CH4'
  CNAMES(17) = 'ETH'
  CNAMES(18) = 'ALKA'
  CNAMES(19) = 'ALKE'
  CNAMES(20) = 'BIO'
  CNAMES(21) = 'ARO'
  CNAMES(22) = 'HCHO'
  CNAMES(23) = 'ALD'
  CNAMES(24) = 'KET'
  CNAMES(25) = 'CARBO'
  CNAMES(26) = 'ONIT'
  CNAMES(27) = 'PAN'
  CNAMES(28) = 'OP1'
  CNAMES(29) = 'OP2'
  CNAMES(30) = 'ORA1'
  CNAMES(31) = 'ORA2'
  CNAMES(32) = 'MO2'
  CNAMES(33) = 'ALKAP'
  CNAMES(34) = 'ALKEP'
  CNAMES(35) = 'BIOP'
  CNAMES(36) = 'PHO'
  CNAMES(37) = 'ADD'
  CNAMES(38) = 'AROP'
  CNAMES(39) = 'CARBOP'
  CNAMES(40) = 'OLN'
  CNAMES(41) = 'XO2'
  CNAMES(42) = 'WC_O3'
  CNAMES(43) = 'WC_H2O2'
  CNAMES(44) = 'WC_NO'
  CNAMES(45) = 'WC_NO2'
  CNAMES(46) = 'WC_NO3'
  CNAMES(47) = 'WC_N2O5'
  CNAMES(48) = 'WC_HONO'
  CNAMES(49) = 'WC_HNO3'
  CNAMES(50) = 'WC_HNO4'
  CNAMES(51) = 'WC_NH3'
  CNAMES(52) = 'WC_OH'
  CNAMES(53) = 'WC_HO2'
  CNAMES(54) = 'WC_CO2'
  CNAMES(55) = 'WC_SO2'
  CNAMES(56) = 'WC_SULF'
  CNAMES(57) = 'WC_HCHO'
  CNAMES(58) = 'WC_ORA1'
  CNAMES(59) = 'WC_ORA2'
  CNAMES(60) = 'WC_MO2'
  CNAMES(61) = 'WC_OP1'
  CNAMES(62) = 'WC_ASO3'
  CNAMES(63) = 'WC_ASO4'
  CNAMES(64) = 'WC_ASO5'
  CNAMES(65) = 'WC_AHSO5'
  CNAMES(66) = 'WC_AHMS'
  CNAMES(67) = 'WR_O3'
  CNAMES(68) = 'WR_H2O2'
  CNAMES(69) = 'WR_NO'
  CNAMES(70) = 'WR_NO2'
  CNAMES(71) = 'WR_NO3'
  CNAMES(72) = 'WR_N2O5'
  CNAMES(73) = 'WR_HONO'
  CNAMES(74) = 'WR_HNO3'
  CNAMES(75) = 'WR_HNO4'
  CNAMES(76) = 'WR_NH3'
  CNAMES(77) = 'WR_OH'
  CNAMES(78) = 'WR_HO2'
  CNAMES(79) = 'WR_CO2'
  CNAMES(80) = 'WR_SO2'
  CNAMES(81) = 'WR_SULF'
  CNAMES(82) = 'WR_HCHO'
  CNAMES(83) = 'WR_ORA1'
  CNAMES(84) = 'WR_ORA2'
  CNAMES(85) = 'WR_MO2'
  CNAMES(86) = 'WR_OP1'
  CNAMES(87) = 'WR_ASO3'
  CNAMES(88) = 'WR_ASO4'
  CNAMES(89) = 'WR_ASO5'
  CNAMES(90) = 'WR_AHSO5'
  CNAMES(91) = 'WR_AHMS'
! initialisation of the names of the reactions
 CREACS(1) = 'K001'
 CREACS(2) = 'K002'
 CREACS(3) = 'K003'
 CREACS(4) = 'K004'
 CREACS(5) = 'K005'
 CREACS(6) = 'K006'
 CREACS(7) = 'K007'
 CREACS(8) = 'K008'
 CREACS(9) = 'K009'
 CREACS(10) = 'K010'
 CREACS(11) = 'K011'
 CREACS(12) = 'K012'
 CREACS(13) = 'K013'
 CREACS(14) = 'K014'
 CREACS(15) = 'K015'
 CREACS(16) = 'K016'
 CREACS(17) = 'K017'
 CREACS(18) = 'K018'
 CREACS(19) = 'K019'
 CREACS(20) = 'K020'
 CREACS(21) = 'K021'
 CREACS(22) = 'K022'
 CREACS(23) = 'K023'
 CREACS(24) = 'K024'
 CREACS(25) = 'K025'
 CREACS(26) = 'K026'
 CREACS(27) = 'K027'
 CREACS(28) = 'K028'
 CREACS(29) = 'K029'
 CREACS(30) = 'K030'
 CREACS(31) = 'K031'
 CREACS(32) = 'K032'
 CREACS(33) = 'K033'
 CREACS(34) = 'K034'
 CREACS(35) = 'K035'
 CREACS(36) = 'K036'
 CREACS(37) = 'K037'
 CREACS(38) = 'K038'
 CREACS(39) = 'K039'
 CREACS(40) = 'K040'
 CREACS(41) = 'K041'
 CREACS(42) = 'K042'
 CREACS(43) = 'K043'
 CREACS(44) = 'K044'
 CREACS(45) = 'K045'
 CREACS(46) = 'K046'
 CREACS(47) = 'K047'
 CREACS(48) = 'K048'
 CREACS(49) = 'K049'
 CREACS(50) = 'K050'
 CREACS(51) = 'K051'
 CREACS(52) = 'K052'
 CREACS(53) = 'K053'
 CREACS(54) = 'K054'
 CREACS(55) = 'K055'
 CREACS(56) = 'K056'
 CREACS(57) = 'K057'
 CREACS(58) = 'K058'
 CREACS(59) = 'K059'
 CREACS(60) = 'K060'
 CREACS(61) = 'K061'
 CREACS(62) = 'K062'
 CREACS(63) = 'K063'
 CREACS(64) = 'K064'
 CREACS(65) = 'K065'
 CREACS(66) = 'K066'
 CREACS(67) = 'K067'
 CREACS(68) = 'K068'
 CREACS(69) = 'K069'
 CREACS(70) = 'K070'
 CREACS(71) = 'K071'
 CREACS(72) = 'K072'
 CREACS(73) = 'K073'
 CREACS(74) = 'K074'
 CREACS(75) = 'K075'
 CREACS(76) = 'K076'
 CREACS(77) = 'K077'
 CREACS(78) = 'K078'
 CREACS(79) = 'K079'
 CREACS(80) = 'K080'
 CREACS(81) = 'K081'
 CREACS(82) = 'K082'
 CREACS(83) = 'K083'
 CREACS(84) = 'K084'
 CREACS(85) = 'K085'
 CREACS(86) = 'K086'
 CREACS(87) = 'K087'
 CREACS(88) = 'K088'
 CREACS(89) = 'K089'
 CREACS(90) = 'K090'
 CREACS(91) = 'K091'
 CREACS(92) = 'K092'
 CREACS(93) = 'K093'
 CREACS(94) = 'K094'
 CREACS(95) = 'K095'
 CREACS(96) = 'K096'
 CREACS(97) = 'K097'
 CREACS(98) = 'K098'
 CREACS(99) = 'K099'
 CREACS(100) = 'K0100'
 CREACS(101) = 'K0101'
 CREACS(102) = 'K0102'
 CREACS(103) = 'K103'
 CREACS(104) = 'K104'
 CREACS(105) = 'K105'
 CREACS(106) = 'K106'
 CREACS(107) = 'K107'
 CREACS(108) = 'K108'
 CREACS(109) = 'K109'
 CREACS(110) = 'K110'
 CREACS(111) = 'K111'
 CREACS(112) = 'K112'
 CREACS(113) = 'K113'
 CREACS(114) = 'K114'
 CREACS(115) = 'K115'
 CREACS(116) = 'K116'
 CREACS(117) = 'K117'
 CREACS(118) = 'K118'
 CREACS(119) = 'K119'
 CREACS(120) = 'K120'
 CREACS(121) = 'K121'
 CREACS(122) = 'K122'
 CREACS(123) = 'K123'
 CREACS(124) = 'K124'
 CREACS(125) = 'K125'
 CREACS(126) = 'K126'
 CREACS(127) = 'K127'
 CREACS(128) = 'K128'
 CREACS(129) = 'K129'
 CREACS(130) = 'K130'
 CREACS(131) = 'K131'
 CREACS(132) = 'K132'
 CREACS(133) = 'KTC1'
 CREACS(134) = 'KTC2'
 CREACS(135) = 'KTC3'
 CREACS(136) = 'KTC4'
 CREACS(137) = 'KTC5'
 CREACS(138) = 'KTC6'
 CREACS(139) = 'KTC7'
 CREACS(140) = 'KTC8'
 CREACS(141) = 'KTC9'
 CREACS(142) = 'KTC10'
 CREACS(143) = 'KTC11'
 CREACS(144) = 'KTC12'
 CREACS(145) = 'KTC13'
 CREACS(146) = 'KTC14'
 CREACS(147) = 'KTC15'
 CREACS(148) = 'KTC16'
 CREACS(149) = 'KTC17'
 CREACS(150) = 'KTC18'
 CREACS(151) = 'KTC19'
 CREACS(152) = 'KTC20'
 CREACS(153) = 'KTC21'
 CREACS(154) = 'KTC22'
 CREACS(155) = 'KTC23'
 CREACS(156) = 'KTC24'
 CREACS(157) = 'KTC25'
 CREACS(158) = 'KTC26'
 CREACS(159) = 'KTC27'
 CREACS(160) = 'KTC28'
 CREACS(161) = 'KTC29'
 CREACS(162) = 'KTC30'
 CREACS(163) = 'KTC31'
 CREACS(164) = 'KTC32'
 CREACS(165) = 'KTC33'
 CREACS(166) = 'KTC34'
 CREACS(167) = 'KTC35'
 CREACS(168) = 'KTC36'
 CREACS(169) = 'KTC37'
 CREACS(170) = 'KTC38'
 CREACS(171) = 'KTC39'
 CREACS(172) = 'KTC40'
 CREACS(173) = 'KTR1'
 CREACS(174) = 'KTR2'
 CREACS(175) = 'KTR3'
 CREACS(176) = 'KTR4'
 CREACS(177) = 'KTR5'
 CREACS(178) = 'KTR6'
 CREACS(179) = 'KTR7'
 CREACS(180) = 'KTR8'
 CREACS(181) = 'KTR9'
 CREACS(182) = 'KTR10'
 CREACS(183) = 'KTR11'
 CREACS(184) = 'KTR12'
 CREACS(185) = 'KTR13'
 CREACS(186) = 'KTR14'
 CREACS(187) = 'KTR15'
 CREACS(188) = 'KTR16'
 CREACS(189) = 'KTR17'
 CREACS(190) = 'KTR18'
 CREACS(191) = 'KTR19'
 CREACS(192) = 'KTR20'
 CREACS(193) = 'KTR21'
 CREACS(194) = 'KTR22'
 CREACS(195) = 'KTR23'
 CREACS(196) = 'KTR24'
 CREACS(197) = 'KTR25'
 CREACS(198) = 'KTR26'
 CREACS(199) = 'KTR27'
 CREACS(200) = 'KTR28'
 CREACS(201) = 'KTR29'
 CREACS(202) = 'KTR30'
 CREACS(203) = 'KTR31'
 CREACS(204) = 'KTR32'
 CREACS(205) = 'KTR33'
 CREACS(206) = 'KTR34'
 CREACS(207) = 'KTR35'
 CREACS(208) = 'KTR36'
 CREACS(209) = 'KTR37'
 CREACS(210) = 'KTR38'
 CREACS(211) = 'KTR39'
 CREACS(212) = 'KTR40'
 CREACS(213) = 'KC1'
 CREACS(214) = 'KC2'
 CREACS(215) = 'KC3'
 CREACS(216) = 'KC4'
 CREACS(217) = 'KC5'
 CREACS(218) = 'KC6'
 CREACS(219) = 'KC7'
 CREACS(220) = 'KC8'
 CREACS(221) = 'KC9'
 CREACS(222) = 'KC10'
 CREACS(223) = 'KC11'
 CREACS(224) = 'KC12'
 CREACS(225) = 'KC13'
 CREACS(226) = 'KC14'
 CREACS(227) = 'KC15'
 CREACS(228) = 'KC16'
 CREACS(229) = 'KC17'
 CREACS(230) = 'KC18'
 CREACS(231) = 'KC19'
 CREACS(232) = 'KC20'
 CREACS(233) = 'KC21'
 CREACS(234) = 'KC22'
 CREACS(235) = 'KC23'
 CREACS(236) = 'KC24'
 CREACS(237) = 'KC25'
 CREACS(238) = 'KC26'
 CREACS(239) = 'KC27'
 CREACS(240) = 'KC28'
 CREACS(241) = 'KC29'
 CREACS(242) = 'KC30'
 CREACS(243) = 'KR1'
 CREACS(244) = 'KR2'
 CREACS(245) = 'KR3'
 CREACS(246) = 'KR4'
 CREACS(247) = 'KR5'
 CREACS(248) = 'KR6'
 CREACS(249) = 'KR7'
 CREACS(250) = 'KR8'
 CREACS(251) = 'KR9'
 CREACS(252) = 'KR10'
 CREACS(253) = 'KR11'
 CREACS(254) = 'KR12'
 CREACS(255) = 'KR13'
 CREACS(256) = 'KR14'
 CREACS(257) = 'KR15'
 CREACS(258) = 'KR16'
 CREACS(259) = 'KR17'
 CREACS(260) = 'KR18'
 CREACS(261) = 'KR19'
 CREACS(262) = 'KR20'
 CREACS(263) = 'KR21'
 CREACS(264) = 'KR22'
 CREACS(265) = 'KR23'
 CREACS(266) = 'KR24'
 CREACS(267) = 'KR25'
 CREACS(268) = 'KR26'
 CREACS(269) = 'KR27'
 CREACS(270) = 'KR28'
 CREACS(271) = 'KR29'
 CREACS(272) = 'KR30'
! initialisation of the full reactions
 CFULLREACS(1) = 'K001=!ZRATES(:,001)::NO2-->O3P+NO'
 CFULLREACS(2) = 'K002=!ZRATES(:,002)::O3-->O1D+O2'
 CFULLREACS(3) = 'K003=!ZRATES(:,003)::O3-->O3P+O2'
 CFULLREACS(4) = 'K004=!ZRATES(:,004)::HONO-->OH+NO'
 CFULLREACS(5) = 'K005=!ZRATES(:,005)::HNO3-->OH+NO2'
 CFULLREACS(6) = 'K006=!ZRATES(:,006)::HNO4-->0.65*HO2+0.65*NO2+0.35*OH+0.35*NO&
&3'
 CFULLREACS(7) = 'K007=!ZRATES(:,007)::NO3-->NO+O2'
 CFULLREACS(8) = 'K008=!ZRATES(:,008)::NO3-->NO2+O3P'
 CFULLREACS(9) = 'K009=!ZRATES(:,009)::H2O2-->OH+OH'
 CFULLREACS(10) = 'K010=!ZRATES(:,010)::HCHO-->H2+CO'
 CFULLREACS(11) = 'K011=!ZRATES(:,011)::HCHO-->HO2+HO2+CO'
 CFULLREACS(12) = 'K012=!ZRATES(:,012)::ALD-->MO2+HO2+CO'
 CFULLREACS(13) = 'K013=!ZRATES(:,013)::OP1-->HCHO+HO2+OH'
 CFULLREACS(14) = 'K014=!ZRATES(:,014)::OP2-->0.96205*ALD+0.96205*HO2+0.03795*M&
&O2+OH'
 CFULLREACS(15) = 'K015=!ZRATES(:,015)::KET-->1.00000*CARBOP+1.00000*ALKAP'
 CFULLREACS(16) = 'K016=!ZRATES(:,016)::CARBO-->0.06517*HCHO+0.69622*CARBOP+0.7&
&5830*HO2+0.91924*CO+0.20842*H2'
 CFULLREACS(17) = 'K017=!ZRATES(:,017)::ONIT-->0.20*ALD+0.80*KET+HO2+NO2'
 CFULLREACS(18) = 'K018=TPK%M*6.00E-34*(TPK%T/300)**(-2.3)::O3P+O2-->O3'
 CFULLREACS(19) = 'K019=8.00E-12*exp(-(2060.0/TPK%T))::O3P+O3-->2.0*O2'
 CFULLREACS(20) = 'K020=1.80E-11*exp(-(-110.0/TPK%T))::O1D+N2-->O3P+N2'
 CFULLREACS(21) = 'K021=3.20E-11*exp(-(-70.0/TPK%T))::O1D+O2-->O3P+O2'
 CFULLREACS(22) = 'K022=2.20E-10::O1D+H2O-->OH+OH'
 CFULLREACS(23) = 'K023=1.60E-12*exp(-(940.0/TPK%T))::O3+OH-->HO2+O2'
 CFULLREACS(24) = 'K024=1.10E-14*exp(-(500.0/TPK%T))::O3+HO2-->OH+2.0*O2'
 CFULLREACS(25) = 'K025=4.80E-11*exp(-(-250.0/TPK%T))::OH+HO2-->H2O+O2'
 CFULLREACS(26) = 'K026=2.90E-12*exp(-(160.0/TPK%T))::H2O2+OH-->HO2+H2O'
 CFULLREACS(27) = 'K027=2.3E-13*EXP(600./TPK%T)+1.7E-33*TPK%M*EXP(1000./TPK%T):&
&:HO2+HO2-->H2O2+O2'
 CFULLREACS(28) = 'K028=3.22E-34*EXP(2800./TPK%T)+2.38E-54*TPK%M*EXP(3200./TPK%&
&T)::HO2+HO2+H2O-->H2O2+H2O+O2'
 CFULLREACS(29) = 'K029=@TROE(1.,9.00E-32,1.5,3.00E-11,0.0,TPK%M,TPK%T,KVECNPT)&
&::O3P+NO-->NO2'
 CFULLREACS(30) = 'K030=6.50E-12*exp(-(-120.0/TPK%T))::O3P+NO2-->NO+O2'
 CFULLREACS(31) = 'K031=@TROE(1.,9.00E-32,2.0,2.20E-11,0.0,TPK%M,TPK%T,KVECNPT)&
&::O3P+NO2-->NO3'
 CFULLREACS(32) = 'K032=@TROE(1.,7.00E-31,2.6,1.50E-11,0.5,TPK%M,TPK%T,KVECNPT)&
&::OH+NO-->HONO'
 CFULLREACS(33) = 'K033=@TROE(1.,2.60E-30,3.2,2.40E-11,1.3,TPK%M,TPK%T,KVECNPT)&
&::OH+NO2-->HNO3'
 CFULLREACS(34) = 'K034=2.20E-11::OH+NO3-->NO2+HO2'
 CFULLREACS(35) = 'K035=3.70E-12*exp(-(-250.0/TPK%T))::HO2+NO-->NO2+OH'
 CFULLREACS(36) = 'K036=@TROE(1.,1.80E-31,3.2,4.70E-12,1.4,TPK%M,TPK%T,KVECNPT)&
&::HO2+NO2-->HNO4'
 CFULLREACS(37) = 'K037=@TROE_EQUIL(1.80E-31,3.2,4.70E-12,1.4,4.76E+26,10900.,T&
&PK%M,TPK%T,KVECNPT)::HNO4-->HO2+NO2'
 CFULLREACS(38) = 'K038=3.50E-12::HO2+NO3-->0.3*HNO3+0.7*NO2+0.7*OH'
 CFULLREACS(39) = 'K039=1.80E-11*exp(-(390.0/TPK%T))::OH+HONO-->H2O+NO2'
 CFULLREACS(40) = 'K040=(7.2E-15*EXP(785/TPK%T))+(1.9E-33*EXP(725/TPK%T)*TPK%M)&
&/(1+(1.9E-33*EXP(725/TPK%T)*TPK%M)/(4.1E-16*EXP(1440/TPK%T)))::OH+HNO3-->NO3+H&
&2O'
 CFULLREACS(41) = 'K041=1.30E-12*exp(-(-380.0/TPK%T))::OH+HNO4-->NO2+H2O+O2'
 CFULLREACS(42) = 'K042=2.00E-12*exp(-(1400.0/TPK%T))::O3+NO-->NO2+O2'
 CFULLREACS(43) = 'K043=1.20E-13*exp(-(2450.0/TPK%T))::O3+NO2-->NO3+O2'
 CFULLREACS(44) = 'K044=3.30E-39*exp(-(-530.0/TPK%T))::NO+NO+O2-->NO2+NO2'
 CFULLREACS(45) = 'K045=1.50E-11*exp(-(-170.0/TPK%T))::NO3+NO-->NO2+NO2'
 CFULLREACS(46) = 'K046=4.50E-14*exp(-(1260.0/TPK%T))::NO3+NO2-->NO+NO2+O2'
 CFULLREACS(47) = 'K047=@TROE(1.,2.20E-30,3.9,1.50E-12,0.7,TPK%M,TPK%T,KVECNPT)&
&::NO3+NO2-->N2O5'
 CFULLREACS(48) = 'K048=@TROE_EQUIL(2.20E-30,3.9,1.50E-12,0.7,3.70E+26,11000.0,&
&TPK%M,TPK%T,KVECNPT)::N2O5-->NO2+NO3'
 CFULLREACS(49) = 'K049=8.50E-13*exp(-(2450.0/TPK%T))::NO3+NO3-->NO2+NO2+O2'
 CFULLREACS(50) = 'K050=3.30E-12*exp(-(900.0/TPK%T))::NH3+OH-->'
 CFULLREACS(51) = 'K051=5.50E-12*exp(-(2000.0/TPK%T))::OH+H2-->H2O+HO2'
 CFULLREACS(52) = 'K052=@TROE(1.,3.00E-31,3.3,1.50E-12,0.0,TPK%M,TPK%T,KVECNPT)&
&::OH+SO2-->SULF+HO2'
 CFULLREACS(53) = 'K053=1.5E-13*(1.+2.439E-20*TPK%M)::CO+OH-->HO2+CO2'
 CFULLREACS(54) = 'K054=6.00E-11::BIO+O3P-->0.91868*ALKE+0.05*HCHO+0.02*OH+0.01&
&*CO+0.13255*CARBO+0.28*HO2+0.15*XO2'
 CFULLREACS(55) = 'K055=0.00E-01*exp(-(-13.0/TPK%T))::CARBO+O3P-->ALD'
 CFULLREACS(56) = 'K056=TPK%T*TPK%T*7.44E-18*exp(-(1361./TPK%T))::CH4+OH-->MO2+&
&H2O'
 CFULLREACS(57) = 'K057=1.51E-17*TPK%T*TPK%T*exp(-(492./TPK%T))::ETH+OH-->ALKAP&
&'
 CFULLREACS(58) = 'K058=3.76E-12*exp(-(260.0/TPK%T))+1.70E-12*exp(-(155.0/TPK%T&
&))+1.21E-12*exp(-(125.0/TPK%T))::ALKA+OH-->0.87811*ALKAP+0.12793*HO2+0.08173*A&
&LD+0.03498*KET+0.00835*CARBO+0.00140*HCHO+0.00878*ORA1+0.00878*CO+0.00878*OH+H&
&2O'
 CFULLREACS(59) = 'K059=1.78E-12*exp(-(-438.0/TPK%T))+6.07E-13*exp(-(-500.0/TPK&
&%T))+0.00E-01*exp(-(-448.0/TPK%T))::ALKE+OH-->1.02529*ALKEP+0.00000*BIOP'
 CFULLREACS(60) = 'K060=2.54E-11*exp(-(-410.0/TPK%T))+0.00E-01*exp(-(-444.0/TPK&
&%T))+0.00E-01::BIO+OH-->1.00000*BIOP'
 CFULLREACS(61) = 'K061=3.31E-12*exp(-(-355.0/TPK%T))+3.45E-13::ARO+OH-->0.9396&
&8*ADD+0.10318*XO2+0.10318*HO2+0.00276*PHO'
 CFULLREACS(62) = 'K062=1.00E-11::HCHO+OH-->HO2+CO+H2O'
 CFULLREACS(63) = 'K063=5.55E-12*exp(-(-331.0/TPK%T))::ALD+OH-->1.00000*CARBOP+&
&H2O'
 CFULLREACS(64) = 'K064=TPK%T*TPK%T*5.68E-18*exp(-(-92.0/TPK%T))::KET+OH-->1.00&
&000*CARBOP+H2O'
 CFULLREACS(65) = 'K065=1.32E-11+1.88E-12*exp(-(-175.0/TPK%T))::CARBO+OH-->0.51&
&419*CARBOP+0.16919*CARBO+1.01732*CO+0.51208*HO2+0.00000*HCHO+0.06253*ALD+0.008&
&53*KET+0.10162*XO2+0.75196*H2O'
 CFULLREACS(66) = 'K066=4.50E-13::ORA1+OH-->HO2+CO2+H2O'
 CFULLREACS(67) = 'K067=6.00E-13::ORA2+OH-->'
 CFULLREACS(68) = 'K068=2.93E-12*exp(-(-190.0/TPK%T))::OP1+OH-->0.65*MO2+0.35*H&
&CHO+0.35*OH'
 CFULLREACS(69) = 'K069=3.36E-12*exp(-(-190.0/TPK%T))::OP2+OH-->0.40341*ALKAP+0&
&.05413*CARBOP+0.07335*ALD+0.37591*KET+0.09333*XO2+0.02915*HO2+0.02915*HCHO+0.4&
&4925*OH'
 CFULLREACS(70) = 'K070=3.80E-14+1.59E-14*exp(-(-500.0/TPK%T))::PAN+OH-->0.5783&
&9*HCHO+0.21863*CARBO+0.71893*NO3+0.28107*PAN+0.28107*HO2+0.29733*H2O+XO2'
 CFULLREACS(71) = 'K071=5.31E-12*exp(-(260.0/TPK%T))::ONIT+OH-->1.00000*ALKAP+N&
&O2+H2O'
 CFULLREACS(72) = 'K072=3.40E-13*exp(-(1900.0/TPK%T))::HCHO+NO3-->HO2+HNO3+CO'
 CFULLREACS(73) = 'K073=1.40E-12*exp(-(1900.0/TPK%T))::ALD+NO3-->1.00000*CARBOP&
&+HNO3'
 CFULLREACS(74) = 'K074=1.62E-12*exp(-(1900.0/TPK%T))+0.00E-01*exp(-(150.0/TPK%&
&T))+1.94E-14*exp(-(1000.0/TPK%T))::CARBO+NO3-->0.91567*HNO3+0.38881*CARBOP+0.1&
&0530*CARBO+0.05265*ALD+0.00632*KET+0.10530*NO2+0.10530*XO2+0.63217*HO2+1.33723&
&*CO+0.00000*OLN'
 CFULLREACS(75) = 'K075=4.92E-16::ARO+NO3-->HNO3+PHO'
 CFULLREACS(76) = 'K076=4.35E-18*TPK%T*TPK%T*exp(-(2282.0/TPK%T))+1.91E-14*exp(&
&-(450.0/TPK%T))+1.08E-15*exp(-(-450.0/TPK%T))+0.00E-01::ALKE+NO3-->0.00000*CAR&
&BO+0.93768*OLN'
 CFULLREACS(77) = 'K077=4.00E-12*exp(-(446.0/TPK%T))+0.00E-01*exp(-(-490.0/TPK%&
&T))+0.00E-01::BIO+NO3-->0.91741*CARBO+1.00000*OLN'
 CFULLREACS(78) = 'K078=3.76E-16*exp(-(500.0/TPK%T))::PAN+NO3-->0.60*ONIT+0.60*&
&NO3+0.40000*PAN+0.40*HCHO+0.40*NO2+XO2'
 CFULLREACS(79) = 'K079=8.17E-15*exp(-(2580.0/TPK%T))+4.32E-16*exp(-(1800.0/TPK&
&%T))+2.87E-17*exp(-(845.0/TPK%T))+0.00E-01*exp(-(2283.0/TPK%T))::ALKE+O3-->0.4&
&8290*HCHO+0.51468*ALD+0.07377*KET+0.00000*CARBO+0.35120*CO+0.15343*ORA1+0.0814&
&3*ORA2+0.23451*HO2+0.39435*OH+0.05705*CARBOP+0.03196*ETH+0.00000*ALKE+0.04300*&
&CH4+0.13966*MO2+0.09815*ALKAP+0.01833*H2O2+0.00000*XO2+0.05409*H2+0.00000*O3P'
 CFULLREACS(80) = 'K080=7.86E-15*exp(-(1913.0/TPK%T))+0.00E-01*exp(-(732.0/TPK%&
&T))+0.00E-01::BIO+O3-->0.90000*HCHO+0.00000*ALD+0.00000*KET+0.39754*CARBO+0.36&
&000*CO+0.37388*ALKE+0.00000*ALKAP+0.17000*CARBOP+0.03000*MO2+0.15000*ORA1+0.00&
&000*ORA2+0.28000*OH+0.30000*HO2+0.00100*H2O2+0.05000*H2+0.13000*XO2+0.09000*O3&
&P'
 CFULLREACS(81) = 'K081=0.00E-01*exp(-(2112.0/TPK%T))+1.38E-19::CARBO+O3-->0.00&
&000*HCHO+1.07583*CARBO+0.15692*ALD+0.10788*ORA1+0.20595*ORA2+0.27460*CARBOP+0.&
&10149*OP2+0.64728*CO+0.28441*HO2+0.20595*OH+0.00000*H2'
 CFULLREACS(82) = 'K082=7.20E-17*exp(-(1700.0/TPK%T))::PAN+O3-->0.70*HCHO+0.300&
&00*PAN+0.70*NO2+0.13*CO+0.04*H2+0.11*ORA1+0.08*HO2+0.036*OH+0.70000*CARBOP'
 CFULLREACS(83) = 'K083=2.00E-11::PHO+NO2-->0.10670*ARO+ONIT'
 CFULLREACS(84) = 'K084=1.00E-11::PHO+HO2-->1.06698*ARO'
 CFULLREACS(85) = 'K085=3.60E-11::ADD+NO2-->ARO+HONO'
 CFULLREACS(86) = 'K086=1.66E-17*exp(-(-1044.0/TPK%T))::ADD+O2-->0.98*AROP+0.02&
&*ARO+0.02*HO2'
 CFULLREACS(87) = 'K087=2.80E-11::ADD+O3-->ARO+OH'
 CFULLREACS(88) = 'K088=@TROE(5.86E-01,9.70E-29,5.6,9.30E-12,1.5,TPK%M,TPK%T,KV&
&ECNPT)::CARBOP+NO2-->1.00000*PAN'
 CFULLREACS(89) = 'K089=@TROE_EQUIL(9.70E-29,5.6,9.30E-12,1.5,1.16E+28,13954.,T&
&PK%M,TPK%T,KVECNPT)::PAN-->1.00000*CARBOP+NO2'
 CFULLREACS(90) = 'K090=4.20E-12*exp(-(-180.0/TPK%T))::MO2+NO-->HCHO+HO2+NO2'
 CFULLREACS(91) = 'K091=4.36E-12::ALKAP+NO-->0.33144*ALD+0.03002*HCHO+0.54531*K&
&ET+0.03407*CARBO+0.74265*HO2+0.09016*MO2+0.08187*ALKAP+0.13007*XO2+0.08459*ONI&
&T+0.91541*NO2'
 CFULLREACS(92) = 'K092=6.93E-12::ALKEP+NO-->1.39870*HCHO+0.42125*ALD+0.05220*K&
&ET+HO2+NO2'
 CFULLREACS(93) = 'K093=4.00E-12::BIOP+NO-->0.45463*CARBO+0.60600*HCHO+0.00000*&
&ALD+0.00000*KET+0.37815*ALKE+0.84700*HO2+0.84700*NO2+0.15300*ONIT'
 CFULLREACS(94) = 'K094=4.00E-12::AROP+NO-->0.95115*NO2+0.95115*HO2+2.06993*CAR&
&BO+0.04885*ONIT'
 CFULLREACS(95) = 'K095=1.22E-11::CARBOP+NO-->0.78134*MO2+0.09532*CARBOP+0.0584&
&8*HCHO+0.07368*ALD+0.08670*CARBO+0.12334*HO2+0.02563*XO2+NO2'
 CFULLREACS(96) = 'K096=4.00E-12::OLN+NO-->0.18401*ONIT+1.81599*NO2+0.18401*HO2&
&+0.23419*HCHO+1.01182*ALD+0.37862*KET'
 CFULLREACS(97) = 'K097=3.80E-13*exp(-(-800.0/TPK%T))::MO2+HO2-->OP1'
 CFULLREACS(98) = 'K098=6.16E-14*exp(-(-700.0/TPK%T))+1.52E-13*exp(-(-1300.0/TP&
&K%T))::ALKAP+HO2-->1.00524*OP2'
 CFULLREACS(99) = 'K099=1.81E-13*exp(-(-1300.0/TPK%T))::ALKEP+HO2-->1.00524*OP2&
&'
 CFULLREACS(100) = 'K0100=1.28E-13*exp(-(-1300.0/TPK%T))+0.00E-01::BIOP+HO2-->1&
&.00524*OP2'
 CFULLREACS(101) = 'K0101=3.75E-13*exp(-(-980.0/TPK%T))::AROP+HO2-->1.00524*OP2&
&'
 CFULLREACS(102) = 'K0102=5.94E-13*exp(-(-550.0/TPK%T))+1.99E-16*exp(-(-2640.0/&
&TPK%T))+5.56E-14*exp(-(-1300.0/TPK%T))::CARBOP+HO2-->0.80904*OP2+0.17307*ORA2+&
&0.17307*O3'
 CFULLREACS(103) = 'K103=1.66E-13*exp(-(-1300.0/TPK%T))::OLN+HO2-->ONIT'
 CFULLREACS(104) = 'K104=9.10E-14*exp(-(-416.0/TPK%T))::MO2+MO2-->1.33*HCHO+0.6&
&6*HO2'
 CFULLREACS(105) = 'K105=1.03E-14*exp(-(-158.0/TPK%T))+6.24E-14*exp(-(-431.0/TP&
&K%T))+1.53E-14*exp(-(-467.0/TPK%T))+4.34E-15*exp(-(-633.0/TPK%T))::ALKAP+MO2--&
&>0.80556*HCHO+0.98383*HO2+0.56070*ALD+0.09673*KET+0.01390*MO2+0.07976*CARBO+0.&
&13370*XO2+0.00385*ALKAP'
 CFULLREACS(106) = 'K106=1.57E-13*exp(-(-708.0/TPK%T))::ALKEP+MO2-->1.42894*HCH&
&O+0.46413*ALD+0.03814*KET+HO2'
 CFULLREACS(107) = 'K107=1.36E-13*exp(-(-708.0/TPK%T))::BIOP+MO2-->0.56064*CARB&
&O+0.48074*ALKE+1.00000*HO2+1.09000*HCHO+0.00000*ALD+0.00000*KET'
 CFULLREACS(108) = 'K108=3.56E-14*exp(-(-708.0/TPK%T))::AROP+MO2-->HCHO+1.02767&
&*HO2+1.99461*CARBO'
 CFULLREACS(109) = 'K109=1.77E-11*exp(-(440.0/TPK%T))+1.48E-16*exp(-(-2510.0/TP&
&K%T))+3.10E-13*exp(-(-508.0/TPK%T))::CARBOP+MO2-->0.95723*HCHO+0.82998*HO2+0.5&
&6031*MO2+0.13684*ORA2+0.05954*CARBOP+0.15387*CARBO+0.08295*ALD+0.02212*XO2'
 CFULLREACS(110) = 'K110=1.12E-13*exp(-(-708.0/TPK%T))::OLN+MO2-->0.88625*HCHO+&
&0.67560*HO2+0.67560*ONIT+0.41524*ALD+0.09667*KET+0.32440*NO2'
 CFULLREACS(111) = 'K111=4.44E-14*exp(-(-211.0/TPK%T))+2.23E-13*exp(-(-460.0/TP&
&K%T))+4.10E-14*exp(-(-522.0/TPK%T))+1.17E-14*exp(-(-683.0/TPK%T))::ALKAP+CARBO&
&P-->0.71461*ALD+0.48079*HO2+0.51480*MO2+0.49810*ORA2+0.18819*KET+0.07600*HCHO+&
&0.00828*ALKAP+0.11306*XO2+0.06954*CARBO'
 CFULLREACS(112) = 'K112=4.36E-13*exp(-(-765.0/TPK%T))::ALKEP+CARBOP-->0.68192*&
&HCHO+0.68374*ALD+0.50078*HO2+0.50078*MO2+0.49922*ORA2+0.06579*KET'
 CFULLREACS(113) = 'K113=7.60E-13*exp(-(-765.0/TPK%T))::BIOP+CARBOP-->0.78591*C&
&ARBO+0.24463*ALKE+0.50600*HO2+0.49400*ORA2+0.34000*HCHO+0.50600*MO2+0.00000*AL&
&D+0.00000*KET'
 CFULLREACS(114) = 'K114=3.63E-13*exp(-(-765.0/TPK%T))::AROP+CARBOP-->MO2+HO2+1&
&.99455*CARBO'
 CFULLREACS(115) = 'K115=7.73E-13*exp(-(-530.0/TPK%T))+1.70E-13*exp(-(-565.0/TP&
&K%T))::CARBOP+CARBOP-->1.66702*MO2+0.05821*CARBOP+0.03432*HCHO+0.10777*CARBO+0&
&.06969*ALD+0.02190*KET+0.07566*HO2+0.01593*XO2+0.09955*ORA2'
 CFULLREACS(116) = 'K116=4.85E-13*exp(-(-765.0/TPK%T))::OLN+CARBOP-->0.66562*ON&
&IT+0.51037*MO2+0.48963*ORA2+0.17599*HO2+0.13414*HCHO+0.42122*ALD+0.10822*KET+0&
&.00000*NO2'
 CFULLREACS(117) = 'K117=4.19E-15*exp(-(-1000.0/TPK%T))::OLN+OLN-->2.00*ONIT+HO&
&2'
 CFULLREACS(118) = 'K118=2.48E-14*exp(-(-1000.0/TPK%T))::OLN+OLN-->0.00000*HCHO&
&+0.00000*ALD+0.00000*KET+0.00000*HO2+0.00000*NO2+0.00000*ONIT'
 CFULLREACS(119) = 'K119=1.20E-12::MO2+NO3-->HCHO+HO2+NO2'
 CFULLREACS(120) = 'K120=1.20E-12::ALKAP+NO3-->0.33743*ALD+0.81290*HO2+0.03142*&
&HCHO+0.62978*KET+0.03531*CARBO+0.09731*MO2+0.08994*ALKAP+0.16271*XO2+NO2'
 CFULLREACS(121) = 'K121=1.20E-12::ALKEP+NO3-->1.40909*HCHO+0.43039*ALD+0.02051&
&*KET+HO2+NO2'
 CFULLREACS(122) = 'K122=1.20E-12::BIOP+NO3-->0.61160*CARBO+0.42729*ALKE+0.6860&
&0*HCHO+0.00000*ALD+0.00000*KET+HO2+NO2'
 CFULLREACS(123) = 'K123=1.20E-12::AROP+NO3-->2.81904*CARBO+HO2+NO2'
 CFULLREACS(124) = 'K124=3.48E-12::CARBOP+NO3-->0.91910*MO2+0.03175*CARBOP+0.03&
&175*HCHO+0.03455*CARBO+0.02936*ALD+0.04915*HO2+0.01021*XO2+NO2'
 CFULLREACS(125) = 'K125=1.20E-12::OLN+NO3-->0.25928*ONIT+1.74072*NO2+0.25928*H&
&O2+0.20740*HCHO+0.91850*ALD+0.34740*KET'
 CFULLREACS(126) = 'K126=1.66E-13*exp(-(-1300.0/TPK%T))::XO2+HO2-->1.00524*OP2'
 CFULLREACS(127) = 'K127=5.99E-15*exp(-(-1510.0/TPK%T))::XO2+MO2-->HCHO+HO2'
 CFULLREACS(128) = 'K128=1.69E-14*exp(-(-1560.0/TPK%T))::XO2+CARBOP-->MO2'
 CFULLREACS(129) = 'K129=7.13E-17*exp(-(-2950.0/TPK%T))::XO2+XO2-->'
 CFULLREACS(130) = 'K130=4.00E-12::XO2+NO-->NO2'
 CFULLREACS(131) = 'K131=1.20E-12::XO2+NO3-->NO2'
 CFULLREACS(132) = 'K132=1.00E-40::SULF-->'
 CFULLREACS(133) = 'KTC1=@KT(0.05,48.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::O3-->WC_&
&O3'
 CFULLREACS(134) = 'KTC2=@KT(0.11,34.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::H2O2-->W&
&C_H2O2'
 CFULLREACS(135) = 'KTC3=@KT(0.0001,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NO-->W&
&C_NO'
 CFULLREACS(136) = 'KTC4=@KT(0.0015,46.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NO2-->&
&WC_NO2'
 CFULLREACS(137) = 'KTC5=@KT(0.05,62.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NO3-->WC&
&_NO3'
 CFULLREACS(138) = 'KTC6=@KT(0.0037,108.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::N2O5-&
&->WC_N2O5'
 CFULLREACS(139) = 'KTC7=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HONO-->W&
&C_HONO'
 CFULLREACS(140) = 'KTC8=@KT(0.054,63.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HNO3-->&
&WC_HNO3'
 CFULLREACS(141) = 'KTC9=@KT(0.05,79.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HNO4-->W&
&C_HNO4'
 CFULLREACS(142) = 'KTC10=@KT(0.04,17.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::NH3-->W&
&C_NH3'
 CFULLREACS(143) = 'KTC11=@KT(0.05,17.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::OH-->WC&
&_OH'
 CFULLREACS(144) = 'KTC12=@KT(0.2,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HO2-->WC&
&_HO2'
 CFULLREACS(145) = 'KTC13=@KT(0.0002,44.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::CO2--&
&>WC_CO2'
 CFULLREACS(146) = 'KTC14=@KT(0.11,64.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::SO2-->W&
&C_SO2'
 CFULLREACS(147) = 'KTC15=@KT(0.07,98.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::SULF-->&
&WC_SULF'
 CFULLREACS(148) = 'KTC16=@KT(0.04,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::HCHO-->&
&WC_HCHO'
 CFULLREACS(149) = 'KTC17=@KT(0.012,46.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::ORA1--&
&>WC_ORA1'
 CFULLREACS(150) = 'KTC18=@KT(0.03,60.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::ORA2-->&
&WC_ORA2'
 CFULLREACS(151) = 'KTC19=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::MO2-->W&
&C_MO2'
 CFULLREACS(152) = 'KTC20=@KT(0.007,48.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC::OP1-->&
&WC_OP1'
 CFULLREACS(153) = 'KTC21=@KT(0.05,48.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(1.1e-2,-&
&2830.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_O3-->O3'
 CFULLREACS(154) = 'KTC22=@KT(0.11,34.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(7.73e4,-&
&7310.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_H2O2-->H2O2'
 CFULLREACS(155) = 'KTC23=@KT(0.0001,30.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(1.92e-&
&3,-1790.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NO-->NO'
 CFULLREACS(156) = 'KTC24=@KT(0.0015,46.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(1.4e-2&
&,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NO2-->NO2'
 CFULLREACS(157) = 'KTC25=@KT(0.05,62.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.8e-2,0&
&.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NO3-->NO3'
 CFULLREACS(158) = 'KTC26=@KT(0.0037,108.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(2.1,-&
&3400.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_N2O5-->N2O5'
 CFULLREACS(159) = 'KTC27=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(5.0e1,-4&
&880.,1.6e-3,1760.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HONO-->HONO'
 CFULLREACS(160) = 'KTC28=@KT(0.054,63.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(2.1e5,-&
&8700.,2.2e1,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HNO3-->HNO3'
 CFULLREACS(161) = 'KTC29=@KT(0.05,79.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(1.2e4,-6&
&900.,1.26e-6,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HNO4-->HNO4'
 CFULLREACS(162) = 'KTC30=@KT(0.04,17.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFB(6.02e1,-&
&4160.,1.7e-5,4350.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_NH3-->NH3'
 CFULLREACS(163) = 'KTC31=@KT(0.05,17.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.9e1,0.&
&,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_OH-->OH'
 CFULLREACS(164) = 'KTC32=@KT(0.2,30.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(6.9e2,0.,&
&1.6e-5,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HO2-->HO2'
 CFULLREACS(165) = 'KTC33=@KT(0.0002,44.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(3.4e-2&
&,-2710.,4.3e-7,920.,4.7e-11,1780.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_CO&
&2-->CO2'
 CFULLREACS(166) = 'KTC34=@KT(0.11,64.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(1.36,-29&
&30.,1.3e-2,-1965.,6.4e-8,-1430.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_SO2-&
&->SO2'
 CFULLREACS(167) = 'KTC35=@KT(0.07,98.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(2.1e5,-8&
&700.,1.0e3,0.,1.0e-2,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_SULF-->SULF'
 CFULLREACS(168) = 'KTC36=@KT(0.04,30.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.23e3,-&
&7100.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_HCHO-->HCHO'
 CFULLREACS(169) = 'KTC37=@KT(0.012,46.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(8.9e3,-&
&6100.,1.8e-4,150.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_ORA1-->ORA1'
 CFULLREACS(170) = 'KTC38=@KT(0.03,60.,TPK%T,TPK%RADC,KVECNPT)/(@HEFFA(4.1e3,-6&
&200.,1.74e-5,0.,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_ORA2-->ORA2'
 CFULLREACS(171) = 'KTC39=@KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(2.7e0,-2&
&030.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_MO2-->MO2'
 CFULLREACS(172) = 'KTC40=@KT(0.007,48.,TPK%T,TPK%RADC,KVECNPT)/(@HENRY(3.e2,-5&
&280.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WC_OP1-->OP1'
 CFULLREACS(173) = 'KTR1=@KT(0.05,48.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::O3-->WR_&
&O3'
 CFULLREACS(174) = 'KTR2=@KT(0.11,34.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::H2O2-->W&
&R_H2O2'
 CFULLREACS(175) = 'KTR3=@KT(0.0001,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NO-->W&
&R_NO'
 CFULLREACS(176) = 'KTR4=@KT(0.0015,46.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NO2-->&
&WR_NO2'
 CFULLREACS(177) = 'KTR5=@KT(0.05,62.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NO3-->WR&
&_NO3'
 CFULLREACS(178) = 'KTR6=@KT(0.0037,108.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::N2O5-&
&->WR_N2O5'
 CFULLREACS(179) = 'KTR7=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HONO-->W&
&R_HONO'
 CFULLREACS(180) = 'KTR8=@KT(0.054,63.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HNO3-->&
&WR_HNO3'
 CFULLREACS(181) = 'KTR9=@KT(0.05,79.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HNO4-->W&
&R_HNO4'
 CFULLREACS(182) = 'KTR10=@KT(0.04,17.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::NH3-->W&
&R_NH3'
 CFULLREACS(183) = 'KTR11=@KT(0.05,17.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::OH-->WR&
&_OH'
 CFULLREACS(184) = 'KTR12=@KT(0.2,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HO2-->WR&
&_HO2'
 CFULLREACS(185) = 'KTR13=@KT(0.0002,44.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::CO2--&
&>WR_CO2'
 CFULLREACS(186) = 'KTR14=@KT(0.11,64.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::SO2-->W&
&R_SO2'
 CFULLREACS(187) = 'KTR15=@KT(0.07,98.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::SULF-->&
&WR_SULF'
 CFULLREACS(188) = 'KTR16=@KT(0.04,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::HCHO-->&
&WR_HCHO'
 CFULLREACS(189) = 'KTR17=@KT(0.012,46.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::ORA1--&
&>WR_ORA1'
 CFULLREACS(190) = 'KTR18=@KT(0.03,60.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::ORA2-->&
&WR_ORA2'
 CFULLREACS(191) = 'KTR19=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::MO2-->W&
&R_MO2'
 CFULLREACS(192) = 'KTR20=@KT(0.007,48.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR::OP1-->&
&WR_OP1'
 CFULLREACS(193) = 'KTR21=@KT(0.05,48.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(1.1e-2,-&
&2830.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_O3-->O3'
 CFULLREACS(194) = 'KTR22=@KT(0.11,34.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(7.73e4,-&
&7310.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_H2O2-->H2O2'
 CFULLREACS(195) = 'KTR23=@KT(0.0001,30.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(1.92e-&
&3,-1790.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NO-->NO'
 CFULLREACS(196) = 'KTR24=@KT(0.0015,46.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(1.4e-2&
&,0.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NO2-->NO2'
 CFULLREACS(197) = 'KTR25=@KT(0.05,62.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.8e-2,0&
&.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NO3-->NO3'
 CFULLREACS(198) = 'KTR26=@KT(0.0037,108.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(2.1,-&
&3400.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_N2O5-->N2O5'
 CFULLREACS(199) = 'KTR27=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(5.0e1,-4&
&880.,1.6e-3,1760.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HONO-->HONO'
 CFULLREACS(200) = 'KTR28=@KT(0.054,63.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(2.1e5,-&
&8700.,2.2e1,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HNO3-->HNO3'
 CFULLREACS(201) = 'KTR29=@KT(0.05,79.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(1.2e4,-6&
&900.,1.26e-6,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HNO4-->HNO4'
 CFULLREACS(202) = 'KTR30=@KT(0.04,17.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFB(6.02e1,-&
&4160.,1.7e-5,4350.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_NH3-->NH3'
 CFULLREACS(203) = 'KTR31=@KT(0.05,17.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.9e1,0.&
&,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_OH-->OH'
 CFULLREACS(204) = 'KTR32=@KT(0.2,30.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(6.9e2,0.,&
&1.6e-5,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HO2-->HO2'
 CFULLREACS(205) = 'KTR33=@KT(0.0002,44.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(3.4e-2&
&,-2710.,4.3e-7,920.,4.7e-11,1780.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_CO&
&2-->CO2'
 CFULLREACS(206) = 'KTR34=@KT(0.11,64.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(1.36,-29&
&30.,1.3e-2,-1965.,6.4e-8,-1430.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_SO2-&
&->SO2'
 CFULLREACS(207) = 'KTR35=@KT(0.07,98.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(2.1e5,-8&
&700.,1.0e3,0.,1.0e-2,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_SULF-->SULF'
 CFULLREACS(208) = 'KTR36=@KT(0.04,30.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.23e3,-&
&7100.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_HCHO-->HCHO'
 CFULLREACS(209) = 'KTR37=@KT(0.012,46.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(8.9e3,-&
&6100.,1.8e-4,150.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_ORA1-->ORA1'
 CFULLREACS(210) = 'KTR38=@KT(0.03,60.,TPK%T,TPK%RADR,KVECNPT)/(@HEFFA(4.1e3,-6&
&200.,1.74e-5,0.,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_ORA2-->ORA2'
 CFULLREACS(211) = 'KTR39=@KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(2.7e0,-2&
&030.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_MO2-->MO2'
 CFULLREACS(212) = 'KTR40=@KT(0.007,48.,TPK%T,TPK%RADR,KVECNPT)/(@HENRY(3.e2,-5&
&280.,TPK%T,KVECNPT)*TPK%RCH*TPK%T)::WR_OP1-->OP1'
 CFULLREACS(213) = 'KC1=!ZRATES(:,018)::WC_H2O2-->WC_OH+WC_OH'
 CFULLREACS(214) = 'KC2=(3.6E+9*exp(-930.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECC&
&LOUD::WC_OH+WC_OH-->WC_H2O2'
 CFULLREACS(215) = 'KC3=((2.8E+10*10.**(-TPK%PHC)+3.5E+10*exp(-720.*(1./TPK%T-1&
&./298.15))*1.6e-5)/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_OH+WC_HO2-&
&->'
 CFULLREACS(216) = 'KC4=(3.2E+7*exp(-1700.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLEC&
&CLOUD::WC_H2O2+WC_OH-->WC_HO2'
 CFULLREACS(217) = 'KC5=((8.3E+5*exp(-2700.*(1./TPK%T-1./298.15))*(10.**(-TPK%P&
&HC))**2.+9.6E+7*exp(-910.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*1.6e-5)/(1.6e-&
&5+10.**(-TPK%PHC))**2.)/TPK%MOL2MOLECCLOUD::WC_HO2+WC_HO2-->WC_H2O2'
 CFULLREACS(218) = 'KC6=(1.5E+9*exp(-1500.*(1./TPK%T-1./298.15))*1.6e-5/(1.6e-5&
&+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_O3+WC_HO2-->WC_OH'
 CFULLREACS(219) = 'KC7=(2.7E+9*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-T&
&PK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./&
&298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PH&
&C))**2.))/TPK%MOL2MOLECCLOUD::WC_OH+WC_SO2-->WC_ASO3'
 CFULLREACS(220) = 'KC8=(1.0E+10*10.**(-TPK%PHC)/(1.6e-3*exp(-1760.*(1./TPK%T-1&
&./298.15))+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_HONO+WC_OH-->WC_NO2'
 CFULLREACS(221) = 'KC9=((1.8E+9*10.**(-TPK%PHC)+4.5E+9*1.6e-5)/(1.6e-5+10.**(-&
&TPK%PHC)))/TPK%MOL2MOLECCLOUD::WC_NO2+WC_HO2-->WC_HNO4'
 CFULLREACS(222) = 'KC10=2.6E-2*10.**(-TPK%PHC)/(1.26e-6+10.**(-TPK%PHC))::WC_H&
&NO4-->WC_HO2+WC_NO2'
 CFULLREACS(223) = 'KC11=1.1E0*1.26e-6/(1.26e-6+10.**(-TPK%PHC))::WC_HNO4-->WC_&
&HONO'
 CFULLREACS(224) = 'KC12=(3.3E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*(10.**(&
&-TPK%PHC))**2./((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./T&
&PK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**&
&(-TPK%PHC))**2.)*(1.26e-6+10.**(-TPK%PHC))))/TPK%MOL2MOLECCLOUD::WC_HNO4+WC_SO&
&2-->WC_SULF+WC_HNO3'
 CFULLREACS(225) = 'KC13=!ZRATES(:,019)*2.2e+1/(2.2e+1+10.**(-TPK%PHC))::WC_HNO&
&3-->WC_NO2+WC_OH'
 CFULLREACS(226) = 'KC14=1.0E+10::WC_N2O5-->WC_HNO3+WC_HNO3'
 CFULLREACS(227) = 'KC15=(1.0E+5*1.0e+3*1.0e-2/(1.0e+3*1.0e-2+1.0e+3*10.**(-TPK&
&%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_NO3+WC_SULF-->WC_HNO3+WC_&
&ASO4'
 CFULLREACS(228) = 'KC16=(1.3E+9*exp(-2200.*(1./TPK%T-1./298.15))*1.3e-2*exp(19&
&65.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.1&
&5))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.1&
&5))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_NO3+WC_SO2-&
&->WC_HNO3+WC_ASO3'
 CFULLREACS(229) = 'KC17=(1.7E+8*exp(-2200.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLE&
&CCLOUD::WC_MO2+WC_MO2-->2.00*WC_HCHO+2.00*WC_HO2'
 CFULLREACS(230) = 'KC18=(5.0E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-&
&TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1.&
&/298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%P&
&HC))**2.))/TPK%MOL2MOLECCLOUD::WC_MO2+WC_SO2-->WC_OP1+WC_ASO3'
 CFULLREACS(231) = 'KC19=(7.8E+8*exp(-1000.*(1./TPK%T-1./298.15))*2.5e3*exp(403&
&0.*(1./TPK%T-1./298.15))/(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15))))/TPK%MOL2M&
&OLECCLOUD::WC_HCHO+WC_OH-->WC_ORA1+WC_HO2'
 CFULLREACS(232) = 'KC20=((1.0E+8*exp(-1000.*(1./TPK%T-1./298.15))*10.**(-TPK%P&
&HC)+3.4E+9*exp(-1200.*(1./TPK%T-1./298.15))*1.8e-4*exp(150.*(1./TPK%T-1./298.1&
&5)))/(1.8e-4*exp(150.*(1./TPK%T-1./298.15))+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLO&
&UD::WC_ORA1+WC_OH-->WC_CO2+WC_HO2'
 CFULLREACS(233) = 'KC21=((7.9E+2*exp(-2900.*(1./TPK%T-1./298.15))*1.3e-2*exp(1&
&965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+2.5E+7*exp(-2450.*(1./TPK%T-1./298.&
&15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.&
&15)))/((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./2&
&98.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC&
&))**2.)*(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15)))))/TPK%MOL2MOLECCLOUD::WC_SO&
&2+WC_HCHO-->WC_AHMS'
 CFULLREACS(234) = 'KC22=7.7E-3*exp(-9200.*(1./TPK%T-1./298.15))+3.7E+3*1.e-14*&
&EXP(-6716*(1./TPK%T-1./298.15))/10.**(-TPK%PHC)::WC_AHMS-->WC_SO2+WC_HCHO'
 CFULLREACS(235) = 'KC23=3.0E+8/TPK%MOL2MOLECCLOUD::WC_AHMS+WC_OH-->WC_HO2+WC_O&
&RA1+WC_SO2'
 CFULLREACS(236) = 'KC24=1.1E+9::WC_ASO3+W_O2-->WC_ASO5'
 CFULLREACS(237) = 'KC25=(1.7E+9*10.**(-TPK%PHC)/(1.6e-5+10.**(-TPK%PHC)))/TPK%&
&MOL2MOLECCLOUD::WC_ASO5+WC_HO2-->WC_AHSO5'
 CFULLREACS(238) = 'KC26=(2.2E+8*exp(-2600.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLE&
&CCLOUD::WC_ASO5+WC_ASO5-->WC_ASO4+WC_ASO4'
 CFULLREACS(239) = 'KC27=(7.1E+6*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-&
&TPK%PHC)*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(14&
&30.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PH&
&C)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD::WC_AHSO5+WC_SO2-->2.00*WC_SULF'
 CFULLREACS(240) = 'KC28=4.6E+2*exp(-1100.*(1./TPK%T-1./298.15))::WC_ASO4-->WC_&
&SULF+WC_OH'
 CFULLREACS(241) = 'KC29=((3.7E+5*exp(-5500.*(1./TPK%T-1./298.15))*1.3e-2*exp(1&
&965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+1.5E+9*exp(-5300.*(1./TPK%T-1./298.&
&15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.&
&15)))/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./29&
&8.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC)&
&)**2.))/TPK%MOL2MOLECCLOUD::WC_SO2+WC_O3-->WC_SULF'
 CFULLREACS(242) = 'KC30=(9.1E+7*exp(-3600.*(1./TPK%T-1./298.15))*1.3e-2*exp(19&
&65.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1&
&./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1&
&./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD&
&::WC_SO2+WC_H2O2-->WC_SULF'
 CFULLREACS(243) = 'KR1=!ZRATES(:,018)::WR_H2O2-->WR_OH+WR_OH'
 CFULLREACS(244) = 'KR2=(3.6E+9*exp(-930.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECR&
&AIN::WR_OH+WR_OH-->WR_H2O2'
 CFULLREACS(245) = 'KR3=((2.8E+10*10.**(-TPK%PHR)+3.5E+10*exp(-720.*(1./TPK%T-1&
&./298.15))*1.6e-5)/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_OH+WR_HO2--&
&>'
 CFULLREACS(246) = 'KR4=(3.2E+7*exp(-1700.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLEC&
&RAIN::WR_H2O2+WR_OH-->WR_HO2'
 CFULLREACS(247) = 'KR5=((8.3E+5*exp(-2700.*(1./TPK%T-1./298.15))*(10.**(-TPK%P&
&HR))**2.+9.6E+7*exp(-910.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*1.6e-5)/(1.6e-&
&5+10.**(-TPK%PHR))**2.)/TPK%MOL2MOLECRAIN::WR_HO2+WR_HO2-->WR_H2O2'
 CFULLREACS(248) = 'KR6=(1.5E+9*exp(-1500.*(1./TPK%T-1./298.15))*1.6e-5/(1.6e-5&
&+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_O3+WR_HO2-->WR_OH'
 CFULLREACS(249) = 'KR7=(2.7E+9*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-T&
&PK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./&
&298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PH&
&R))**2.))/TPK%MOL2MOLECRAIN::WR_OH+WR_SO2-->WR_ASO3'
 CFULLREACS(250) = 'KR8=(1.0E+10*10.**(-TPK%PHR)/(1.6e-3*exp(-1760.*(1./TPK%T-1&
&./298.15))+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_HONO+WR_OH-->WR_NO2'
 CFULLREACS(251) = 'KR9=((1.8E+9*10.**(-TPK%PHR)+4.5E+9*1.6e-5)/(1.6e-5+10.**(-&
&TPK%PHR)))/TPK%MOL2MOLECRAIN::WR_NO2+WR_HO2-->WR_HNO4'
 CFULLREACS(252) = 'KR10=2.6E-2*10.**(-TPK%PHR)/(1.26e-6+10.**(-TPK%PHR))::WR_H&
&NO4-->WR_HO2+WR_NO2'
 CFULLREACS(253) = 'KR11=1.1E0*1.26e-6/(1.26e-6+10.**(-TPK%PHR))::WR_HNO4-->WR_&
&HONO'
 CFULLREACS(254) = 'KR12=(3.3E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*(10.**(&
&-TPK%PHR))**2./((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./T&
&PK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**&
&(-TPK%PHR))**2.)*(1.26e-6+10.**(-TPK%PHR))))/TPK%MOL2MOLECRAIN::WR_HNO4+WR_SO2&
&-->WR_SULF+WR_HNO3'
 CFULLREACS(255) = 'KR13=!ZRATES(:,019)*2.2e+1/(2.2e+1+10.**(-TPK%PHR))::WR_HNO&
&3-->WR_NO2+WR_OH'
 CFULLREACS(256) = 'KR14=1.0E+10::WR_N2O5-->WR_HNO3+WR_HNO3'
 CFULLREACS(257) = 'KR15=(1.0E+5*1.0e+3*1.0e-2/(1.0e+3*1.0e-2+1.0e+3*10.**(-TPK&
&%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_NO3+WR_SULF-->WR_HNO3+WR_A&
&SO4'
 CFULLREACS(258) = 'KR16=(1.3E+9*exp(-2200.*(1./TPK%T-1./298.15))*1.3e-2*exp(19&
&65.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.1&
&5))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.1&
&5))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_NO3+WR_SO2--&
&>WR_HNO3+WR_ASO3'
 CFULLREACS(259) = 'KR17=(1.7E+8*exp(-2200.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLE&
&CRAIN::WR_MO2+WR_MO2-->2.00*WR_HCHO+2.00*WR_HO2'
 CFULLREACS(260) = 'KR18=(5.0E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-&
&TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1.&
&/298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%P&
&HR))**2.))/TPK%MOL2MOLECRAIN::WR_MO2+WR_SO2-->WR_OP1+WR_ASO3'
 CFULLREACS(261) = 'KR19=(7.8E+8*exp(-1000.*(1./TPK%T-1./298.15))*2.5e3*exp(403&
&0.*(1./TPK%T-1./298.15))/(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15))))/TPK%MOL2M&
&OLECRAIN::WR_HCHO+WR_OH-->WR_ORA1+WR_HO2'
 CFULLREACS(262) = 'KR20=((1.0E+8*exp(-1000.*(1./TPK%T-1./298.15))*10.**(-TPK%P&
&HR)+3.4E+9*exp(-1200.*(1./TPK%T-1./298.15))*1.8e-4*exp(150.*(1./TPK%T-1./298.1&
&5)))/(1.8e-4*exp(150.*(1./TPK%T-1./298.15))+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAI&
&N::WR_ORA1+WR_OH-->WR_CO2+WR_HO2'
 CFULLREACS(263) = 'KR21=((7.9E+2*exp(-2900.*(1./TPK%T-1./298.15))*1.3e-2*exp(1&
&965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+2.5E+7*exp(-2450.*(1./TPK%T-1./298.&
&15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.&
&15)))/((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./2&
&98.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR&
&))**2.)*(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15)))))/TPK%MOL2MOLECRAIN::WR_SO2&
&+WR_HCHO-->WR_AHMS'
 CFULLREACS(264) = 'KR22=7.7E-3*exp(-9200.*(1./TPK%T-1./298.15))+3.7E+3*1.e-14*&
&EXP(-6716*(1./TPK%T-1./298.15))/10.**(-TPK%PHR)::WR_AHMS-->WR_SO2+WR_HCHO'
 CFULLREACS(265) = 'KR23=3.0E+8/TPK%MOL2MOLECRAIN::WR_AHMS+WR_OH-->WR_HO2+WR_OR&
&A1+WR_SO2'
 CFULLREACS(266) = 'KR24=1.1E+9::WR_ASO3+W_O2-->WR_ASO5'
 CFULLREACS(267) = 'KR25=(1.7E+9*10.**(-TPK%PHR)/(1.6e-5+10.**(-TPK%PHR)))/TPK%&
&MOL2MOLECRAIN::WR_ASO5+WR_HO2-->WR_AHSO5'
 CFULLREACS(268) = 'KR26=(2.2E+8*exp(-2600.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLE&
&CRAIN::WR_ASO5+WR_ASO5-->WR_ASO4+WR_ASO4'
 CFULLREACS(269) = 'KR27=(7.1E+6*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-&
&TPK%PHR)*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(14&
&30.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PH&
&R)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN::WR_AHSO5+WR_SO2-->2.00*WR_SULF'
 CFULLREACS(270) = 'KR28=4.6E+2*exp(-1100.*(1./TPK%T-1./298.15))::WR_ASO4-->WR_&
&SULF+WR_OH'
 CFULLREACS(271) = 'KR29=((3.7E+5*exp(-5500.*(1./TPK%T-1./298.15))*1.3e-2*exp(1&
&965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+1.5E+9*exp(-5300.*(1./TPK%T-1./298.&
&15))*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.&
&15)))/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./29&
&8.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR)&
&)**2.))/TPK%MOL2MOLECRAIN::WR_SO2+WR_O3-->WR_SULF'
 CFULLREACS(272) = 'KR30=(9.1E+7*exp(-3600.*(1./TPK%T-1./298.15))*1.3e-2*exp(19&
&65.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1&
&./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1&
&./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN:&
&:WR_SO2+WR_H2O2-->WR_SULF'
END IF
IF (KVERB >= 5) THEN
! print information to KOUT
  WRITE(KOUT,*) 'CH_INIT_CCS: prognostic variables for model ',KMI
  DO JII = 1, TACCS(KMI)%NEQ
    WRITE(KOUT,'(I4,2A)') JII, '. ', TRIM(CNAMES(JII))
  END DO
  WRITE(KOUT,*) 'CH_INIT_CCS: implemented reactions for model ',KMI
  DO JII = 1, TACCS(KMI)%NREAC
    WRITE(KOUT,'(I4,2A)') JII, '. ', TRIM(CFULLREACS(JII))
  END DO
END IF
RETURN
END SUBROUTINE CH_INIT_CCS
!
!========================================================================
!
!!    ##########################
      MODULE MODI_CH_GET_CNAMES
!!    ##########################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_GET_CNAMES(HNAMES)
IMPLICIT NONE
CHARACTER(LEN=32), DIMENSION(:), INTENT(OUT) :: HNAMES
END SUBROUTINE CH_GET_CNAMES
END INTERFACE
END MODULE MODI_CH_GET_CNAMES
!
!========================================================================
!
!!    #################################
      SUBROUTINE CH_GET_CNAMES(HNAMES)
!!    #################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *CH_GET_CNAMES*
!!
!!    PURPOSE
!!    -------
!       return the names for the chemical species in HNAMES
!!
!!**  METHOD
!!    ------
!!      simple
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
!!
!!    LOCAL VARIABLES
!!    ---------------
CHARACTER(LEN=32), DIMENSION(:), INTENT(OUT) :: HNAMES
INTEGER :: ISIZE
!!
!!----------------------------------------------------------------------
!!
! copy the names of the chemical species into HNAMES
ISIZE = SIZE(HNAMES)
HNAMES = CNAMES(1:ISIZE)
RETURN
END SUBROUTINE CH_GET_CNAMES
!
!========================================================================
!
!!    #######################
      MODULE MODI_CH_PRODLOSS
!!    #######################
INTERFACE
SUBROUTINE CH_PRODLOSS(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                          :: PTIME
INTEGER, INTENT(IN)                          :: KVECNPT
INTEGER, INTENT(IN)                          :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ) :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ) :: PPROD, PLOSS
INTEGER, INTENT(IN)                          :: KMI
END SUBROUTINE CH_PRODLOSS
END INTERFACE
END MODULE MODI_CH_PRODLOSS
!
!========================================================================
!
!!    ###################################################
      SUBROUTINE CH_PRODLOSS(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
!!    ###################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_PRODLOSS*
!!
!!    PURPOSE
!!    -------
!       calculation of production and loss terms for diagnostics
!!
!!**  METHOD
!!    ------
!!      The terms of temporal derivative of the chemical species,
!!    written as:
!!    d/dt PCONC = CH_FCN = PPROD - PCONC*PLOSS,
!!    are calculated for diagnostic purposes.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
USE MODI_CH_PRODLOSS_AQ
USE MODI_CH_PRODLOSS_GAZ
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                      :: PTIME
INTEGER, INTENT(IN)                      :: KVECNPT
INTEGER, INTENT(IN)                      :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ)     :: PPROD, PLOSS
INTEGER, INTENT(IN)                          :: KMI
TYPE(CCSTYPE), POINTER         :: TPK
TPK=>TACCS(KMI)
IF (TPK%LUSECHAQ) THEN
   CALL CH_PRODLOSS_AQ(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
ELSE
   CALL CH_PRODLOSS_GAZ(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
END IF
END SUBROUTINE CH_PRODLOSS
!
!========================================================================
!
!!    ##########################
      MODULE MODI_CH_PRODLOSS_AQ
!!    ##########################
INTERFACE
SUBROUTINE CH_PRODLOSS_AQ(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                          :: PTIME
INTEGER, INTENT(IN)                          :: KVECNPT
INTEGER, INTENT(IN)                          :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ) :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ) :: PPROD, PLOSS
INTEGER, INTENT(IN)                          :: KMI
END SUBROUTINE CH_PRODLOSS_AQ
END INTERFACE
END MODULE MODI_CH_PRODLOSS_AQ
!
!========================================================================
!
!!    ##################################################################
      SUBROUTINE CH_PRODLOSS_AQ(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
!!    ##################################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_PRODLOSS*
!!
!!    PURPOSE
!!    -------
!       calculation of production and loss terms for diagnostics
!!
!!**  METHOD
!!    ------
!!      The terms of temporal derivative of the chemical species,
!!    written as:
!!    d/dt PCONC = CH_FCN = PPROD - PCONC*PLOSS,
!!    are calculated for diagnostic purposes.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                      :: PTIME
INTEGER, INTENT(IN)                      :: KVECNPT
INTEGER, INTENT(IN)                      :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ)     :: PPROD, PLOSS
INTEGER, INTENT(IN)                          :: KMI
TYPE(CCSTYPE), POINTER         :: TPK
TPK=>TACCS(KMI)
! /BEGIN_CODE/
TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
   &TPK%K022(:)*TPK%H2O(:))
TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
    &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
    &0.00000*TPK%K079(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
    &0.09000*TPK%K080(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
   &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
   &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K054(:)*PCONC(:,JP_BIO)+&
   &TPK%K055(:)*PCONC(:,JP_CARBO))
! /END_CODE/
CALL SUB0
CALL SUB1
CALL SUB2
CALL SUB3
CALL SUB4
CALL SUB5
CALL SUB6
CALL SUB7
CALL SUB8
CALL SUB9

CONTAINS

SUBROUTINE SUB0
!
!Indices 1 a 10
!
!
!PPROD(O3) = +K018*<O3P>*<O2>+0.17307*K0102*<CARBOP>*<HO2>+KTC21*<WC_O3>+KTR21*
!<WR_O3>
 PPROD(:,1) = +TPK%K018(:)*TPK%O3P(:)*TPK%O2(:)+0.17307*TPK%K0102(:)*PCONC(:,39&
&)*PCONC(:,15)+TPK%KTC21(:)*PCONC(:,42)+TPK%KTR21(:)*PCONC(:,67)
!PLOSS(O3) = +K002+K003+K019*<O3P>+K023*<OH>+K024*<HO2>+K042*<NO>+K043*<NO2>+K0
!79*<ALKE>+K080*<BIO>+K081*<CARBO>+K082*<PAN>+K087*<ADD>+KTC1+KTR1
 PLOSS(:,1) = +TPK%K002(:)+TPK%K003(:)+TPK%K019(:)*TPK%O3P(:)+TPK%K023(:)*PCONC&
&(:,14)+TPK%K024(:)*PCONC(:,15)+TPK%K042(:)*PCONC(:,3)+TPK%K043(:)*PCONC(:,4)+T&
&PK%K079(:)*PCONC(:,19)+TPK%K080(:)*PCONC(:,20)+TPK%K081(:)*PCONC(:,25)+TPK%K08&
&2(:)*PCONC(:,27)+TPK%K087(:)*PCONC(:,37)+TPK%KTC1(:)+TPK%KTR1(:)
!
!PPROD(H2O2) = +K027*<HO2>*<HO2>+K028*<HO2>*<HO2>*<H2O>+0.01833*K079*<ALKE>*<O3
!>+0.00100*K080*<BIO>*<O3>+KTC22*<WC_H2O2>+KTR22*<WR_H2O2>
 PPROD(:,2) = +TPK%K027(:)*PCONC(:,15)*PCONC(:,15)+TPK%K028(:)*PCONC(:,15)*PCON&
&C(:,15)*TPK%H2O(:)+0.01833*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.00100*TPK%K080&
&(:)*PCONC(:,20)*PCONC(:,1)+TPK%KTC22(:)*PCONC(:,43)+TPK%KTR22(:)*PCONC(:,68)
!PLOSS(H2O2) = +K009+K026*<OH>+KTC2+KTR2
 PLOSS(:,2) = +TPK%K009(:)+TPK%K026(:)*PCONC(:,14)+TPK%KTC2(:)+TPK%KTR2(:)
!
!PPROD(NO) = +K001*<NO2>+K004*<HONO>+K007*<NO3>+K030*<O3P>*<NO2>+K046*<NO3>*<NO
!2>+KTC23*<WC_NO>+KTR23*<WR_NO>
 PPROD(:,3) = +TPK%K001(:)*PCONC(:,4)+TPK%K004(:)*PCONC(:,7)+TPK%K007(:)*PCONC(&
&:,5)+TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)+TPK%K046(:)*PCONC(:,5)*PCONC(:,4)+TPK%K&
&TC23(:)*PCONC(:,44)+TPK%KTR23(:)*PCONC(:,69)
!PLOSS(NO) = +K029*<O3P>+K032*<OH>+K035*<HO2>+K042*<O3>+K044*<NO>*<O2>+K044*<NO
!>*<O2>+K045*<NO3>+K090*<MO2>+K091*<ALKAP>+K092*<ALKEP>+K093*<BIOP>+K094*<AROP>
!+K095*<CARBOP>+K096*<OLN>+K130*<XO2>+KTC3+KTR3
 PLOSS(:,3) = +TPK%K029(:)*TPK%O3P(:)+TPK%K032(:)*PCONC(:,14)+TPK%K035(:)*PCONC&
&(:,15)+TPK%K042(:)*PCONC(:,1)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCO&
&NC(:,3)*TPK%O2(:)+TPK%K045(:)*PCONC(:,5)+TPK%K090(:)*PCONC(:,32)+TPK%K091(:)*P&
&CONC(:,33)+TPK%K092(:)*PCONC(:,34)+TPK%K093(:)*PCONC(:,35)+TPK%K094(:)*PCONC(:&
&,38)+TPK%K095(:)*PCONC(:,39)+TPK%K096(:)*PCONC(:,40)+TPK%K130(:)*PCONC(:,41)+T&
&PK%KTC3(:)+TPK%KTR3(:)
!
!PPROD(NO2) = +K005*<HNO3>+0.65*K006*<HNO4>+K008*<NO3>+K017*<ONIT>+K029*<O3P>*<
!NO>+K034*<OH>*<NO3>+K035*<HO2>*<NO>+K037*<HNO4>+0.7*K038*<HO2>*<NO3>+K039*<OH>
!*<HONO>+K041*<OH>*<HNO4>+K042*<O3>*<NO>+K044*<NO>*<NO>*<O2>+K044*<NO>*<NO>*<O2
!>+K045*<NO3>*<NO>+K045*<NO3>*<NO>+K046*<NO3>*<NO2>+K048*<N2O5>+K049*<NO3>*<NO3
!>+K049*<NO3>*<NO3>+K071*<ONIT>*<OH>+0.10530*K074*<CARBO>*<NO3>+0.40*K078*<PAN>
!*<NO3>+0.70*K082*<PAN>*<O3>+K089*<PAN>+K090*<MO2>*<NO>+0.91541*K091*<ALKAP>*<N
!O>+K092*<ALKEP>*<NO>+0.84700*K093*<BIOP>*<NO>+0.95115*K094*<AROP>*<NO>+K095*<C
!ARBOP>*<NO>+1.81599*K096*<OLN>*<NO>+0.32440*K110*<OLN>*<MO2>+0.00000*K116*<OLN
!>*<CARBOP>+0.00000*K118*<OLN>*<OLN>+K119*<MO2>*<NO3>+K120*<ALKAP>*<NO3>+K121*<
!ALKEP>*<NO3>+K122*<BIOP>*<NO3>+K123*<AROP>*<NO3>+K124*<CARBOP>*<NO3>+1.74072*K
!125*<OLN>*<NO3>+K130*<XO2>*<NO>+K131*<XO2>*<NO3>+KTC24*<WC_NO2>+KTR24*<WR_NO2>
 PPROD(:,4) = +TPK%K005(:)*PCONC(:,8)+0.65*TPK%K006(:)*PCONC(:,9)+TPK%K008(:)*P&
&CONC(:,5)+TPK%K017(:)*PCONC(:,26)+TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)+TPK%K034(:&
&)*PCONC(:,14)*PCONC(:,5)+TPK%K035(:)*PCONC(:,15)*PCONC(:,3)+TPK%K037(:)*PCONC(&
&:,9)+0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)+TPK%K039(:)*PCONC(:,14)*PCONC(:,7)&
&+TPK%K041(:)*PCONC(:,14)*PCONC(:,9)+TPK%K042(:)*PCONC(:,1)*PCONC(:,3)+TPK%K044&
&(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:&
&)+TPK%K045(:)*PCONC(:,5)*PCONC(:,3)+TPK%K045(:)*PCONC(:,5)*PCONC(:,3)+TPK%K046&
&(:)*PCONC(:,5)*PCONC(:,4)+TPK%K048(:)*PCONC(:,6)+TPK%K049(:)*PCONC(:,5)*PCONC(&
&:,5)+TPK%K049(:)*PCONC(:,5)*PCONC(:,5)+TPK%K071(:)*PCONC(:,26)*PCONC(:,14)+0.1&
&0530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5&
&)+0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK%K089(:)*PCONC(:,27)+TPK%K090(:)*&
&PCONC(:,32)*PCONC(:,3)+0.91541*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+TPK%K092(:)*&
&PCONC(:,34)*PCONC(:,3)+0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.95115*TPK%&
&K094(:)*PCONC(:,38)*PCONC(:,3)+TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+1.81599*TPK%&
&K096(:)*PCONC(:,40)*PCONC(:,3)+0.32440*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)+0.0&
&0000*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC&
&(:,40)+TPK%K119(:)*PCONC(:,32)*PCONC(:,5)+TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+T&
&PK%K121(:)*PCONC(:,34)*PCONC(:,5)+TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+TPK%K123(&
&:)*PCONC(:,38)*PCONC(:,5)+TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+1.74072*TPK%K125(&
&:)*PCONC(:,40)*PCONC(:,5)+TPK%K130(:)*PCONC(:,41)*PCONC(:,3)+TPK%K131(:)*PCONC&
&(:,41)*PCONC(:,5)+TPK%KTC24(:)*PCONC(:,45)+TPK%KTR24(:)*PCONC(:,70)
!PLOSS(NO2) = +K001+K030*<O3P>+K031*<O3P>+K033*<OH>+K036*<HO2>+K043*<O3>+K046*<
!NO3>+K047*<NO3>+K083*<PHO>+K085*<ADD>+K088*<CARBOP>+KTC4+KTR4
 PLOSS(:,4) = +TPK%K001(:)+TPK%K030(:)*TPK%O3P(:)+TPK%K031(:)*TPK%O3P(:)+TPK%K0&
&33(:)*PCONC(:,14)+TPK%K036(:)*PCONC(:,15)+TPK%K043(:)*PCONC(:,1)+TPK%K046(:)*P&
&CONC(:,5)+TPK%K047(:)*PCONC(:,5)+TPK%K083(:)*PCONC(:,36)+TPK%K085(:)*PCONC(:,3&
&7)+TPK%K088(:)*PCONC(:,39)+TPK%KTC4(:)+TPK%KTR4(:)
!
!PPROD(NO3) = +0.35*K006*<HNO4>+K031*<O3P>*<NO2>+K040*<OH>*<HNO3>+K043*<O3>*<NO
!2>+K048*<N2O5>+0.71893*K070*<PAN>*<OH>+0.60*K078*<PAN>*<NO3>+KTC25*<WC_NO3>+KT
!R25*<WR_NO3>
 PPROD(:,5) = +0.35*TPK%K006(:)*PCONC(:,9)+TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)+TP&
&K%K040(:)*PCONC(:,14)*PCONC(:,8)+TPK%K043(:)*PCONC(:,1)*PCONC(:,4)+TPK%K048(:)&
&*PCONC(:,6)+0.71893*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)+0.60*TPK%K078(:)*PCONC&
&(:,27)*PCONC(:,5)+TPK%KTC25(:)*PCONC(:,46)+TPK%KTR25(:)*PCONC(:,71)
!PLOSS(NO3) = +K007+K008+K034*<OH>+K038*<HO2>+K045*<NO>+K046*<NO2>+K047*<NO2>+K
!049*<NO3>+K049*<NO3>+K072*<HCHO>+K073*<ALD>+K074*<CARBO>+K075*<ARO>+K076*<ALKE
!>+K077*<BIO>+K078*<PAN>+K119*<MO2>+K120*<ALKAP>+K121*<ALKEP>+K122*<BIOP>+K123*
!<AROP>+K124*<CARBOP>+K125*<OLN>+K131*<XO2>+KTC5+KTR5
 PLOSS(:,5) = +TPK%K007(:)+TPK%K008(:)+TPK%K034(:)*PCONC(:,14)+TPK%K038(:)*PCON&
&C(:,15)+TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)+TPK%K047(:)*PCONC(:,4)+T&
&PK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:,5)+TPK%K072(:)*PCONC(:,22)+TPK%K073(&
&:)*PCONC(:,23)+TPK%K074(:)*PCONC(:,25)+TPK%K075(:)*PCONC(:,21)+TPK%K076(:)*PCO&
&NC(:,19)+TPK%K077(:)*PCONC(:,20)+TPK%K078(:)*PCONC(:,27)+TPK%K119(:)*PCONC(:,3&
&2)+TPK%K120(:)*PCONC(:,33)+TPK%K121(:)*PCONC(:,34)+TPK%K122(:)*PCONC(:,35)+TPK&
&%K123(:)*PCONC(:,38)+TPK%K124(:)*PCONC(:,39)+TPK%K125(:)*PCONC(:,40)+TPK%K131(&
&:)*PCONC(:,41)+TPK%KTC5(:)+TPK%KTR5(:)
!
!PPROD(N2O5) = +K047*<NO3>*<NO2>+KTC26*<WC_N2O5>+KTR26*<WR_N2O5>
 PPROD(:,6) = +TPK%K047(:)*PCONC(:,5)*PCONC(:,4)+TPK%KTC26(:)*PCONC(:,47)+TPK%K&
&TR26(:)*PCONC(:,72)
!PLOSS(N2O5) = +K048+KTC6+KTR6
 PLOSS(:,6) = +TPK%K048(:)+TPK%KTC6(:)+TPK%KTR6(:)
!
!PPROD(HONO) = +K032*<OH>*<NO>+K085*<ADD>*<NO2>+KTC27*<WC_HONO>+KTR27*<WR_HONO>
 PPROD(:,7) = +TPK%K032(:)*PCONC(:,14)*PCONC(:,3)+TPK%K085(:)*PCONC(:,37)*PCONC&
&(:,4)+TPK%KTC27(:)*PCONC(:,48)+TPK%KTR27(:)*PCONC(:,73)
!PLOSS(HONO) = +K004+K039*<OH>+KTC7+KTR7
 PLOSS(:,7) = +TPK%K004(:)+TPK%K039(:)*PCONC(:,14)+TPK%KTC7(:)+TPK%KTR7(:)
!
!PPROD(HNO3) = +K033*<OH>*<NO2>+0.3*K038*<HO2>*<NO3>+K072*<HCHO>*<NO3>+K073*<AL
!D>*<NO3>+0.91567*K074*<CARBO>*<NO3>+K075*<ARO>*<NO3>+KTC28*<WC_HNO3>+KTR28*<WR
!_HNO3>
 PPROD(:,8) = +TPK%K033(:)*PCONC(:,14)*PCONC(:,4)+0.3*TPK%K038(:)*PCONC(:,15)*P&
&CONC(:,5)+TPK%K072(:)*PCONC(:,22)*PCONC(:,5)+TPK%K073(:)*PCONC(:,23)*PCONC(:,5&
&)+0.91567*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+TPK%K075(:)*PCONC(:,21)*PCONC(:,5&
&)+TPK%KTC28(:)*PCONC(:,49)+TPK%KTR28(:)*PCONC(:,74)
!PLOSS(HNO3) = +K005+K040*<OH>+KTC8+KTR8
 PLOSS(:,8) = +TPK%K005(:)+TPK%K040(:)*PCONC(:,14)+TPK%KTC8(:)+TPK%KTR8(:)
!
!PPROD(HNO4) = +K036*<HO2>*<NO2>+KTC29*<WC_HNO4>+KTR29*<WR_HNO4>
 PPROD(:,9) = +TPK%K036(:)*PCONC(:,15)*PCONC(:,4)+TPK%KTC29(:)*PCONC(:,50)+TPK%&
&KTR29(:)*PCONC(:,75)
!PLOSS(HNO4) = +K006+K037+K041*<OH>+KTC9+KTR9
 PLOSS(:,9) = +TPK%K006(:)+TPK%K037(:)+TPK%K041(:)*PCONC(:,14)+TPK%KTC9(:)+TPK%&
&KTR9(:)
!
!PPROD(NH3) = +KTC30*<WC_NH3>+KTR30*<WR_NH3>
 PPROD(:,10) = +TPK%KTC30(:)*PCONC(:,51)+TPK%KTR30(:)*PCONC(:,76)
!PLOSS(NH3) = +K050*<OH>+KTC10+KTR10
 PLOSS(:,10) = +TPK%K050(:)*PCONC(:,14)+TPK%KTC10(:)+TPK%KTR10(:)
!
RETURN
END SUBROUTINE SUB0
!
SUBROUTINE SUB1
!
!Indices 11 a 20
!
!
!PPROD(SO2) = +KTC34*<WC_SO2>+KTR34*<WR_SO2>
 PPROD(:,11) = +TPK%KTC34(:)*PCONC(:,55)+TPK%KTR34(:)*PCONC(:,80)
!PLOSS(SO2) = +K052*<OH>+KTC14+KTR14
 PLOSS(:,11) = +TPK%K052(:)*PCONC(:,14)+TPK%KTC14(:)+TPK%KTR14(:)
!
!PPROD(SULF) = +K052*<OH>*<SO2>+KTC35*<WC_SULF>+KTR35*<WR_SULF>
 PPROD(:,12) = +TPK%K052(:)*PCONC(:,14)*PCONC(:,11)+TPK%KTC35(:)*PCONC(:,56)+TP&
&K%KTR35(:)*PCONC(:,81)
!PLOSS(SULF) = +K132+KTC15+KTR15
 PLOSS(:,12) = +TPK%K132(:)+TPK%KTC15(:)+TPK%KTR15(:)
!
!PPROD(CO) = +K010*<HCHO>+K011*<HCHO>+K012*<ALD>+0.91924*K016*<CARBO>+0.01*K054
!*<BIO>*<O3P>+0.00878*K058*<ALKA>*<OH>+K062*<HCHO>*<OH>+1.01732*K065*<CARBO>*<O
!H>+K072*<HCHO>*<NO3>+1.33723*K074*<CARBO>*<NO3>+0.35120*K079*<ALKE>*<O3>+0.360
!00*K080*<BIO>*<O3>+0.64728*K081*<CARBO>*<O3>+0.13*K082*<PAN>*<O3>
 PPROD(:,13) = +TPK%K010(:)*PCONC(:,22)+TPK%K011(:)*PCONC(:,22)+TPK%K012(:)*PCO&
&NC(:,23)+0.91924*TPK%K016(:)*PCONC(:,25)+0.01*TPK%K054(:)*PCONC(:,20)*TPK%O3P(&
&:)+0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+TPK%K062(:)*PCONC(:,22)*PCONC(:&
&,14)+1.01732*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+TPK%K072(:)*PCONC(:,22)*PCONC&
&(:,5)+1.33723*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.35120*TPK%K079(:)*PCONC(:,1&
&9)*PCONC(:,1)+0.36000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.64728*TPK%K081(:)*P&
&CONC(:,25)*PCONC(:,1)+0.13*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!PLOSS(CO) = +K053*<OH>
 PLOSS(:,13) = +TPK%K053(:)*PCONC(:,14)
!
!PPROD(OH) = +K004*<HONO>+K005*<HNO3>+0.35*K006*<HNO4>+K009*<H2O2>+K009*<H2O2>+
!K013*<OP1>+K014*<OP2>+K022*<O1D>*<H2O>+K022*<O1D>*<H2O>+K024*<O3>*<HO2>+K035*<
!HO2>*<NO>+0.7*K038*<HO2>*<NO3>+0.02*K054*<BIO>*<O3P>+0.00878*K058*<ALKA>*<OH>+
!0.35*K068*<OP1>*<OH>+0.44925*K069*<OP2>*<OH>+0.39435*K079*<ALKE>*<O3>+0.28000*
!K080*<BIO>*<O3>+0.20595*K081*<CARBO>*<O3>+0.036*K082*<PAN>*<O3>+K087*<ADD>*<O3
!>+KTC31*<WC_OH>+KTR31*<WR_OH>
 PPROD(:,14) = +TPK%K004(:)*PCONC(:,7)+TPK%K005(:)*PCONC(:,8)+0.35*TPK%K006(:)*&
&PCONC(:,9)+TPK%K009(:)*PCONC(:,2)+TPK%K009(:)*PCONC(:,2)+TPK%K013(:)*PCONC(:,2&
&8)+TPK%K014(:)*PCONC(:,29)+TPK%K022(:)*TPK%O1D(:)*TPK%H2O(:)+TPK%K022(:)*TPK%O&
&1D(:)*TPK%H2O(:)+TPK%K024(:)*PCONC(:,1)*PCONC(:,15)+TPK%K035(:)*PCONC(:,15)*PC&
&ONC(:,3)+0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)+0.02*TPK%K054(:)*PCONC(:,20)*T&
&PK%O3P(:)+0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0.35*TPK%K068(:)*PCONC(:&
&,28)*PCONC(:,14)+0.44925*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)+0.39435*TPK%K079(&
&:)*PCONC(:,19)*PCONC(:,1)+0.28000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.20595*T&
&PK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.036*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK&
&%K087(:)*PCONC(:,37)*PCONC(:,1)+TPK%KTC31(:)*PCONC(:,52)+TPK%KTR31(:)*PCONC(:,&
&77)
!PLOSS(OH) = +K023*<O3>+K025*<HO2>+K026*<H2O2>+K032*<NO>+K033*<NO2>+K034*<NO3>+
!K039*<HONO>+K040*<HNO3>+K041*<HNO4>+K050*<NH3>+K051*<H2>+K052*<SO2>+K053*<CO>+
!K056*<CH4>+K057*<ETH>+K058*<ALKA>+K059*<ALKE>+K060*<BIO>+K061*<ARO>+K062*<HCHO
!>+K063*<ALD>+K064*<KET>+K065*<CARBO>+K066*<ORA1>+K067*<ORA2>+K068*<OP1>+K069*<
!OP2>+K070*<PAN>+K071*<ONIT>+KTC11+KTR11
 PLOSS(:,14) = +TPK%K023(:)*PCONC(:,1)+TPK%K025(:)*PCONC(:,15)+TPK%K026(:)*PCON&
&C(:,2)+TPK%K032(:)*PCONC(:,3)+TPK%K033(:)*PCONC(:,4)+TPK%K034(:)*PCONC(:,5)+TP&
&K%K039(:)*PCONC(:,7)+TPK%K040(:)*PCONC(:,8)+TPK%K041(:)*PCONC(:,9)+TPK%K050(:)&
&*PCONC(:,10)+TPK%K051(:)*TPK%H2(:)+TPK%K052(:)*PCONC(:,11)+TPK%K053(:)*PCONC(:&
&,13)+TPK%K056(:)*PCONC(:,16)+TPK%K057(:)*PCONC(:,17)+TPK%K058(:)*PCONC(:,18)+T&
&PK%K059(:)*PCONC(:,19)+TPK%K060(:)*PCONC(:,20)+TPK%K061(:)*PCONC(:,21)+TPK%K06&
&2(:)*PCONC(:,22)+TPK%K063(:)*PCONC(:,23)+TPK%K064(:)*PCONC(:,24)+TPK%K065(:)*P&
&CONC(:,25)+TPK%K066(:)*PCONC(:,30)+TPK%K067(:)*PCONC(:,31)+TPK%K068(:)*PCONC(:&
&,28)+TPK%K069(:)*PCONC(:,29)+TPK%K070(:)*PCONC(:,27)+TPK%K071(:)*PCONC(:,26)+T&
&PK%KTC11(:)+TPK%KTR11(:)
!
!PPROD(HO2) = +0.65*K006*<HNO4>+K011*<HCHO>+K011*<HCHO>+K012*<ALD>+K013*<OP1>+0
!.96205*K014*<OP2>+0.75830*K016*<CARBO>+K017*<ONIT>+K023*<O3>*<OH>+K026*<H2O2>*
!<OH>+K034*<OH>*<NO3>+K037*<HNO4>+K051*<OH>*<H2>+K052*<OH>*<SO2>+K053*<CO>*<OH>
!+0.28*K054*<BIO>*<O3P>+0.12793*K058*<ALKA>*<OH>+0.10318*K061*<ARO>*<OH>+K062*<
!HCHO>*<OH>+0.51208*K065*<CARBO>*<OH>+K066*<ORA1>*<OH>+0.02915*K069*<OP2>*<OH>+
!0.28107*K070*<PAN>*<OH>+K072*<HCHO>*<NO3>+0.63217*K074*<CARBO>*<NO3>+0.23451*K
!079*<ALKE>*<O3>+0.30000*K080*<BIO>*<O3>+0.28441*K081*<CARBO>*<O3>+0.08*K082*<P
!AN>*<O3>+0.02*K086*<ADD>*<O2>+K090*<MO2>*<NO>+0.74265*K091*<ALKAP>*<NO>+K092*<
!ALKEP>*<NO>+0.84700*K093*<BIOP>*<NO>+0.95115*K094*<AROP>*<NO>+0.12334*K095*<CA
!RBOP>*<NO>+0.18401*K096*<OLN>*<NO>+0.66*K104*<MO2>*<MO2>+0.98383*K105*<ALKAP>*
!<MO2>+K106*<ALKEP>*<MO2>+1.00000*K107*<BIOP>*<MO2>+1.02767*K108*<AROP>*<MO2>+0
!.82998*K109*<CARBOP>*<MO2>+0.67560*K110*<OLN>*<MO2>+0.48079*K111*<ALKAP>*<CARB
!OP>+0.50078*K112*<ALKEP>*<CARBOP>+0.50600*K113*<BIOP>*<CARBOP>+K114*<AROP>*<CA
!RBOP>+0.07566*K115*<CARBOP>*<CARBOP>+0.17599*K116*<OLN>*<CARBOP>+K117*<OLN>*<O
!LN>+0.00000*K118*<OLN>*<OLN>+K119*<MO2>*<NO3>+0.81290*K120*<ALKAP>*<NO3>+K121*
!<ALKEP>*<NO3>+K122*<BIOP>*<NO3>+K123*<AROP>*<NO3>+0.04915*K124*<CARBOP>*<NO3>+
!0.25928*K125*<OLN>*<NO3>+K127*<XO2>*<MO2>+KTC32*<WC_HO2>+KTR32*<WR_HO2>
 PPROD(:,15) = +0.65*TPK%K006(:)*PCONC(:,9)+TPK%K011(:)*PCONC(:,22)+TPK%K011(:)&
&*PCONC(:,22)+TPK%K012(:)*PCONC(:,23)+TPK%K013(:)*PCONC(:,28)+0.96205*TPK%K014(&
&:)*PCONC(:,29)+0.75830*TPK%K016(:)*PCONC(:,25)+TPK%K017(:)*PCONC(:,26)+TPK%K02&
&3(:)*PCONC(:,1)*PCONC(:,14)+TPK%K026(:)*PCONC(:,2)*PCONC(:,14)+TPK%K034(:)*PCO&
&NC(:,14)*PCONC(:,5)+TPK%K037(:)*PCONC(:,9)+TPK%K051(:)*PCONC(:,14)*TPK%H2(:)+T&
&PK%K052(:)*PCONC(:,14)*PCONC(:,11)+TPK%K053(:)*PCONC(:,13)*PCONC(:,14)+0.28*TP&
&K%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.12793*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0&
&.10318*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)+TPK%K062(:)*PCONC(:,22)*PCONC(:,14)&
&+0.51208*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+TPK%K066(:)*PCONC(:,30)*PCONC(:,1&
&4)+0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)+0.28107*TPK%K070(:)*PCONC(:,27)&
&*PCONC(:,14)+TPK%K072(:)*PCONC(:,22)*PCONC(:,5)+0.63217*TPK%K074(:)*PCONC(:,25&
&)*PCONC(:,5)+0.23451*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.30000*TPK%K080(:)*PC&
&ONC(:,20)*PCONC(:,1)+0.28441*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.08*TPK%K082(&
&:)*PCONC(:,27)*PCONC(:,1)+0.02*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)+TPK%K090(:)*P&
&CONC(:,32)*PCONC(:,3)+0.74265*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+TPK%K092(:)*P&
&CONC(:,34)*PCONC(:,3)+0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.95115*TPK%K&
&094(:)*PCONC(:,38)*PCONC(:,3)+0.12334*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.184&
&01*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)+0.66*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)&
&+0.98383*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+TPK%K106(:)*PCONC(:,34)*PCONC(:,3&
&2)+1.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+1.02767*TPK%K108(:)*PCONC(:,38)&
&*PCONC(:,32)+0.82998*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)+0.67560*TPK%K110(:)*P&
&CONC(:,40)*PCONC(:,32)+0.48079*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.50078*TPK&
&%K112(:)*PCONC(:,34)*PCONC(:,39)+0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+T&
&PK%K114(:)*PCONC(:,38)*PCONC(:,39)+0.07566*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)&
&+0.17599*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+TPK%K117(:)*PCONC(:,40)*PCONC(:,4&
&0)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)+TPK%K119(:)*PCONC(:,32)*PCONC(:&
&,5)+0.81290*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+TPK%K121(:)*PCONC(:,34)*PCONC(:&
&,5)+TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+TPK%K123(:)*PCONC(:,38)*PCONC(:,5)+0.04&
&915*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:&
&,5)+TPK%K127(:)*PCONC(:,41)*PCONC(:,32)+TPK%KTC32(:)*PCONC(:,53)+TPK%KTR32(:)*&
&PCONC(:,78)
!PLOSS(HO2) = +K024*<O3>+K025*<OH>+K027*<HO2>+K027*<HO2>+K028*<HO2>*<H2O>+K028*
!<HO2>*<H2O>+K035*<NO>+K036*<NO2>+K038*<NO3>+K084*<PHO>+K097*<MO2>+K098*<ALKAP>
!+K099*<ALKEP>+K0100*<BIOP>+K0101*<AROP>+K0102*<CARBOP>+K103*<OLN>+K126*<XO2>+K
!TC12+KTR12
 PLOSS(:,15) = +TPK%K024(:)*PCONC(:,1)+TPK%K025(:)*PCONC(:,14)+TPK%K027(:)*PCON&
&C(:,15)+TPK%K027(:)*PCONC(:,15)+TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)+TPK%K028(:)&
&*PCONC(:,15)*TPK%H2O(:)+TPK%K035(:)*PCONC(:,3)+TPK%K036(:)*PCONC(:,4)+TPK%K038&
&(:)*PCONC(:,5)+TPK%K084(:)*PCONC(:,36)+TPK%K097(:)*PCONC(:,32)+TPK%K098(:)*PCO&
&NC(:,33)+TPK%K099(:)*PCONC(:,34)+TPK%K0100(:)*PCONC(:,35)+TPK%K0101(:)*PCONC(:&
&,38)+TPK%K0102(:)*PCONC(:,39)+TPK%K103(:)*PCONC(:,40)+TPK%K126(:)*PCONC(:,41)+&
&TPK%KTC12(:)+TPK%KTR12(:)
!
!PPROD(CH4) = +0.04300*K079*<ALKE>*<O3>
 PPROD(:,16) = +0.04300*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!PLOSS(CH4) = +K056*<OH>
 PLOSS(:,16) = +TPK%K056(:)*PCONC(:,14)
!
!PPROD(ETH) = +0.03196*K079*<ALKE>*<O3>
 PPROD(:,17) = +0.03196*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!PLOSS(ETH) = +K057*<OH>
 PLOSS(:,17) = +TPK%K057(:)*PCONC(:,14)
!
!PPROD(ALKA) = 0.0
 PPROD(:,18) = 0.0
!PLOSS(ALKA) = +K058*<OH>
 PLOSS(:,18) = +TPK%K058(:)*PCONC(:,14)
!
!PPROD(ALKE) = +0.91868*K054*<BIO>*<O3P>+0.00000*K079*<ALKE>*<O3>+0.37388*K080*
!<BIO>*<O3>+0.37815*K093*<BIOP>*<NO>+0.48074*K107*<BIOP>*<MO2>+0.24463*K113*<BI
!OP>*<CARBOP>+0.42729*K122*<BIOP>*<NO3>
 PPROD(:,19) = +0.91868*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.00000*TPK%K079(:)*&
&PCONC(:,19)*PCONC(:,1)+0.37388*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.37815*TPK%&
&K093(:)*PCONC(:,35)*PCONC(:,3)+0.48074*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+0.2&
&4463*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.42729*TPK%K122(:)*PCONC(:,35)*PCONC&
&(:,5)
!PLOSS(ALKE) = +K059*<OH>+K076*<NO3>+K079*<O3>
 PLOSS(:,19) = +TPK%K059(:)*PCONC(:,14)+TPK%K076(:)*PCONC(:,5)+TPK%K079(:)*PCON&
&C(:,1)
!
!PPROD(BIO) = 0.0
 PPROD(:,20) = 0.0
!PLOSS(BIO) = +K054*<O3P>+K060*<OH>+K077*<NO3>+K080*<O3>
 PLOSS(:,20) = +TPK%K054(:)*TPK%O3P(:)+TPK%K060(:)*PCONC(:,14)+TPK%K077(:)*PCON&
&C(:,5)+TPK%K080(:)*PCONC(:,1)
!
RETURN
END SUBROUTINE SUB1
!
SUBROUTINE SUB2
!
!Indices 21 a 30
!
!
!PPROD(ARO) = +0.10670*K083*<PHO>*<NO2>+1.06698*K084*<PHO>*<HO2>+K085*<ADD>*<NO
!2>+0.02*K086*<ADD>*<O2>+K087*<ADD>*<O3>
 PPROD(:,21) = +0.10670*TPK%K083(:)*PCONC(:,36)*PCONC(:,4)+1.06698*TPK%K084(:)*&
&PCONC(:,36)*PCONC(:,15)+TPK%K085(:)*PCONC(:,37)*PCONC(:,4)+0.02*TPK%K086(:)*PC&
&ONC(:,37)*TPK%O2(:)+TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!PLOSS(ARO) = +K061*<OH>+K075*<NO3>
 PLOSS(:,21) = +TPK%K061(:)*PCONC(:,14)+TPK%K075(:)*PCONC(:,5)
!
!PPROD(HCHO) = +K013*<OP1>+0.06517*K016*<CARBO>+0.05*K054*<BIO>*<O3P>+0.00140*K
!058*<ALKA>*<OH>+0.00000*K065*<CARBO>*<OH>+0.35*K068*<OP1>*<OH>+0.02915*K069*<O
!P2>*<OH>+0.57839*K070*<PAN>*<OH>+0.40*K078*<PAN>*<NO3>+0.48290*K079*<ALKE>*<O3
!>+0.90000*K080*<BIO>*<O3>+0.00000*K081*<CARBO>*<O3>+0.70*K082*<PAN>*<O3>+K090*
!<MO2>*<NO>+0.03002*K091*<ALKAP>*<NO>+1.39870*K092*<ALKEP>*<NO>+0.60600*K093*<B
!IOP>*<NO>+0.05848*K095*<CARBOP>*<NO>+0.23419*K096*<OLN>*<NO>+1.33*K104*<MO2>*<
!MO2>+0.80556*K105*<ALKAP>*<MO2>+1.42894*K106*<ALKEP>*<MO2>+1.09000*K107*<BIOP>
!*<MO2>+K108*<AROP>*<MO2>+0.95723*K109*<CARBOP>*<MO2>+0.88625*K110*<OLN>*<MO2>+
!0.07600*K111*<ALKAP>*<CARBOP>+0.68192*K112*<ALKEP>*<CARBOP>+0.34000*K113*<BIOP
!>*<CARBOP>+0.03432*K115*<CARBOP>*<CARBOP>+0.13414*K116*<OLN>*<CARBOP>+0.00000*
!K118*<OLN>*<OLN>+K119*<MO2>*<NO3>+0.03142*K120*<ALKAP>*<NO3>+1.40909*K121*<ALK
!EP>*<NO3>+0.68600*K122*<BIOP>*<NO3>+0.03175*K124*<CARBOP>*<NO3>+0.20740*K125*<
!OLN>*<NO3>+K127*<XO2>*<MO2>+KTC36*<WC_HCHO>+KTR36*<WR_HCHO>
 PPROD(:,22) = +TPK%K013(:)*PCONC(:,28)+0.06517*TPK%K016(:)*PCONC(:,25)+0.05*TP&
&K%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.00140*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0&
&.00000*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.35*TPK%K068(:)*PCONC(:,28)*PCONC(&
&:,14)+0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)+0.57839*TPK%K070(:)*PCONC(:,&
&27)*PCONC(:,14)+0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)+0.48290*TPK%K079(:)*PC&
&ONC(:,19)*PCONC(:,1)+0.90000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.00000*TPK%K0&
&81(:)*PCONC(:,25)*PCONC(:,1)+0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK%K090(&
&:)*PCONC(:,32)*PCONC(:,3)+0.03002*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+1.39870*T&
&PK%K092(:)*PCONC(:,34)*PCONC(:,3)+0.60600*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0&
&.05848*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.23419*TPK%K096(:)*PCONC(:,40)*PCON&
&C(:,3)+1.33*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)+0.80556*TPK%K105(:)*PCONC(:,33&
&)*PCONC(:,32)+1.42894*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)+1.09000*TPK%K107(:)*&
&PCONC(:,35)*PCONC(:,32)+TPK%K108(:)*PCONC(:,38)*PCONC(:,32)+0.95723*TPK%K109(:&
&)*PCONC(:,39)*PCONC(:,32)+0.88625*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)+0.07600*&
&TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.68192*TPK%K112(:)*PCONC(:,34)*PCONC(:,39&
&)+0.34000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.03432*TPK%K115(:)*PCONC(:,39)*&
&PCONC(:,39)+0.13414*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.00000*TPK%K118(:)*PC&
&ONC(:,40)*PCONC(:,40)+TPK%K119(:)*PCONC(:,32)*PCONC(:,5)+0.03142*TPK%K120(:)*P&
&CONC(:,33)*PCONC(:,5)+1.40909*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)+0.68600*TPK%K&
&122(:)*PCONC(:,35)*PCONC(:,5)+0.03175*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+0.207&
&40*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)+TPK%K127(:)*PCONC(:,41)*PCONC(:,32)+TPK%&
&KTC36(:)*PCONC(:,57)+TPK%KTR36(:)*PCONC(:,82)
!PLOSS(HCHO) = +K010+K011+K062*<OH>+K072*<NO3>+KTC16+KTR16
 PLOSS(:,22) = +TPK%K010(:)+TPK%K011(:)+TPK%K062(:)*PCONC(:,14)+TPK%K072(:)*PCO&
&NC(:,5)+TPK%KTC16(:)+TPK%KTR16(:)
!
!PPROD(ALD) = +0.96205*K014*<OP2>+0.20*K017*<ONIT>+K055*<CARBO>*<O3P>+0.08173*K
!058*<ALKA>*<OH>+0.06253*K065*<CARBO>*<OH>+0.07335*K069*<OP2>*<OH>+0.05265*K074
!*<CARBO>*<NO3>+0.51468*K079*<ALKE>*<O3>+0.00000*K080*<BIO>*<O3>+0.15692*K081*<
!CARBO>*<O3>+0.33144*K091*<ALKAP>*<NO>+0.42125*K092*<ALKEP>*<NO>+0.00000*K093*<
!BIOP>*<NO>+0.07368*K095*<CARBOP>*<NO>+1.01182*K096*<OLN>*<NO>+0.56070*K105*<AL
!KAP>*<MO2>+0.46413*K106*<ALKEP>*<MO2>+0.00000*K107*<BIOP>*<MO2>+0.08295*K109*<
!CARBOP>*<MO2>+0.41524*K110*<OLN>*<MO2>+0.71461*K111*<ALKAP>*<CARBOP>+0.68374*K
!112*<ALKEP>*<CARBOP>+0.00000*K113*<BIOP>*<CARBOP>+0.06969*K115*<CARBOP>*<CARBO
!P>+0.42122*K116*<OLN>*<CARBOP>+0.00000*K118*<OLN>*<OLN>+0.33743*K120*<ALKAP>*<
!NO3>+0.43039*K121*<ALKEP>*<NO3>+0.00000*K122*<BIOP>*<NO3>+0.02936*K124*<CARBOP
!>*<NO3>+0.91850*K125*<OLN>*<NO3>
 PPROD(:,23) = +0.96205*TPK%K014(:)*PCONC(:,29)+0.20*TPK%K017(:)*PCONC(:,26)+TP&
&K%K055(:)*PCONC(:,25)*TPK%O3P(:)+0.08173*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0&
&.06253*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.07335*TPK%K069(:)*PCONC(:,29)*PCO&
&NC(:,14)+0.05265*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.51468*TPK%K079(:)*PCONC(&
&:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.15692*TPK%K081(:&
&)*PCONC(:,25)*PCONC(:,1)+0.33144*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.42125*TP&
&K%K092(:)*PCONC(:,34)*PCONC(:,3)+0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.&
&07368*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+1.01182*TPK%K096(:)*PCONC(:,40)*PCONC&
&(:,3)+0.56070*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.46413*TPK%K106(:)*PCONC(:,&
&34)*PCONC(:,32)+0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+0.08295*TPK%K109(:&
&)*PCONC(:,39)*PCONC(:,32)+0.41524*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)+0.71461*&
&TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.68374*TPK%K112(:)*PCONC(:,34)*PCONC(:,39&
&)+0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.06969*TPK%K115(:)*PCONC(:,39)*&
&PCONC(:,39)+0.42122*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.00000*TPK%K118(:)*PC&
&ONC(:,40)*PCONC(:,40)+0.33743*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+0.43039*TPK%K&
&121(:)*PCONC(:,34)*PCONC(:,5)+0.00000*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+0.029&
&36*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+0.91850*TPK%K125(:)*PCONC(:,40)*PCONC(:,&
&5)
!PLOSS(ALD) = +K012+K063*<OH>+K073*<NO3>
 PLOSS(:,23) = +TPK%K012(:)+TPK%K063(:)*PCONC(:,14)+TPK%K073(:)*PCONC(:,5)
!
!PPROD(KET) = +0.80*K017*<ONIT>+0.03498*K058*<ALKA>*<OH>+0.00853*K065*<CARBO>*<
!OH>+0.37591*K069*<OP2>*<OH>+0.00632*K074*<CARBO>*<NO3>+0.07377*K079*<ALKE>*<O3
!>+0.00000*K080*<BIO>*<O3>+0.54531*K091*<ALKAP>*<NO>+0.05220*K092*<ALKEP>*<NO>+
!0.00000*K093*<BIOP>*<NO>+0.37862*K096*<OLN>*<NO>+0.09673*K105*<ALKAP>*<MO2>+0.
!03814*K106*<ALKEP>*<MO2>+0.00000*K107*<BIOP>*<MO2>+0.09667*K110*<OLN>*<MO2>+0.
!18819*K111*<ALKAP>*<CARBOP>+0.06579*K112*<ALKEP>*<CARBOP>+0.00000*K113*<BIOP>*
!<CARBOP>+0.02190*K115*<CARBOP>*<CARBOP>+0.10822*K116*<OLN>*<CARBOP>+0.00000*K1
!18*<OLN>*<OLN>+0.62978*K120*<ALKAP>*<NO3>+0.02051*K121*<ALKEP>*<NO3>+0.00000*K
!122*<BIOP>*<NO3>+0.34740*K125*<OLN>*<NO3>
 PPROD(:,24) = +0.80*TPK%K017(:)*PCONC(:,26)+0.03498*TPK%K058(:)*PCONC(:,18)*PC&
&ONC(:,14)+0.00853*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.37591*TPK%K069(:)*PCON&
&C(:,29)*PCONC(:,14)+0.00632*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.07377*TPK%K07&
&9(:)*PCONC(:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.54531&
&*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.05220*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)&
&+0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.37862*TPK%K096(:)*PCONC(:,40)*PC&
&ONC(:,3)+0.09673*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.03814*TPK%K106(:)*PCONC&
&(:,34)*PCONC(:,32)+0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+0.09667*TPK%K11&
&0(:)*PCONC(:,40)*PCONC(:,32)+0.18819*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.065&
&79*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)+0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:&
&,39)+0.02190*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.10822*TPK%K116(:)*PCONC(:,4&
&0)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)+0.62978*TPK%K120(:)&
&*PCONC(:,33)*PCONC(:,5)+0.02051*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)+0.00000*TPK&
&%K122(:)*PCONC(:,35)*PCONC(:,5)+0.34740*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!PLOSS(KET) = +K015+K064*<OH>
 PLOSS(:,24) = +TPK%K015(:)+TPK%K064(:)*PCONC(:,14)
!
!PPROD(CARBO) = +0.13255*K054*<BIO>*<O3P>+0.00835*K058*<ALKA>*<OH>+0.16919*K065
!*<CARBO>*<OH>+0.21863*K070*<PAN>*<OH>+0.10530*K074*<CARBO>*<NO3>+0.00000*K076*
!<ALKE>*<NO3>+0.91741*K077*<BIO>*<NO3>+0.00000*K079*<ALKE>*<O3>+0.39754*K080*<B
!IO>*<O3>+1.07583*K081*<CARBO>*<O3>+0.03407*K091*<ALKAP>*<NO>+0.45463*K093*<BIO
!P>*<NO>+2.06993*K094*<AROP>*<NO>+0.08670*K095*<CARBOP>*<NO>+0.07976*K105*<ALKA
!P>*<MO2>+0.56064*K107*<BIOP>*<MO2>+1.99461*K108*<AROP>*<MO2>+0.15387*K109*<CAR
!BOP>*<MO2>+0.06954*K111*<ALKAP>*<CARBOP>+0.78591*K113*<BIOP>*<CARBOP>+1.99455*
!K114*<AROP>*<CARBOP>+0.10777*K115*<CARBOP>*<CARBOP>+0.03531*K120*<ALKAP>*<NO3>
!+0.61160*K122*<BIOP>*<NO3>+2.81904*K123*<AROP>*<NO3>+0.03455*K124*<CARBOP>*<NO
!3>
 PPROD(:,25) = +0.13255*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.00835*TPK%K058(:)*&
&PCONC(:,18)*PCONC(:,14)+0.16919*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.21863*TP&
&K%K070(:)*PCONC(:,27)*PCONC(:,14)+0.10530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0&
&.00000*TPK%K076(:)*PCONC(:,19)*PCONC(:,5)+0.91741*TPK%K077(:)*PCONC(:,20)*PCON&
&C(:,5)+0.00000*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.39754*TPK%K080(:)*PCONC(:,&
&20)*PCONC(:,1)+1.07583*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.03407*TPK%K091(:)*&
&PCONC(:,33)*PCONC(:,3)+0.45463*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+2.06993*TPK%&
&K094(:)*PCONC(:,38)*PCONC(:,3)+0.08670*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.07&
&976*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.56064*TPK%K107(:)*PCONC(:,35)*PCONC(&
&:,32)+1.99461*TPK%K108(:)*PCONC(:,38)*PCONC(:,32)+0.15387*TPK%K109(:)*PCONC(:,&
&39)*PCONC(:,32)+0.06954*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.78591*TPK%K113(:&
&)*PCONC(:,35)*PCONC(:,39)+1.99455*TPK%K114(:)*PCONC(:,38)*PCONC(:,39)+0.10777*&
&TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.03531*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)&
&+0.61160*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+2.81904*TPK%K123(:)*PCONC(:,38)*PC&
&ONC(:,5)+0.03455*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!PLOSS(CARBO) = +K016+K055*<O3P>+K065*<OH>+K074*<NO3>+K081*<O3>
 PLOSS(:,25) = +TPK%K016(:)+TPK%K055(:)*TPK%O3P(:)+TPK%K065(:)*PCONC(:,14)+TPK%&
&K074(:)*PCONC(:,5)+TPK%K081(:)*PCONC(:,1)
!
!PPROD(ONIT) = +0.60*K078*<PAN>*<NO3>+K083*<PHO>*<NO2>+0.08459*K091*<ALKAP>*<NO
!>+0.15300*K093*<BIOP>*<NO>+0.04885*K094*<AROP>*<NO>+0.18401*K096*<OLN>*<NO>+K1
!03*<OLN>*<HO2>+0.67560*K110*<OLN>*<MO2>+0.66562*K116*<OLN>*<CARBOP>+2.00*K117*
!<OLN>*<OLN>+0.00000*K118*<OLN>*<OLN>+0.25928*K125*<OLN>*<NO3>
 PPROD(:,26) = +0.60*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)+TPK%K083(:)*PCONC(:,36)&
&*PCONC(:,4)+0.08459*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.15300*TPK%K093(:)*PCO&
&NC(:,35)*PCONC(:,3)+0.04885*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)+0.18401*TPK%K09&
&6(:)*PCONC(:,40)*PCONC(:,3)+TPK%K103(:)*PCONC(:,40)*PCONC(:,15)+0.67560*TPK%K1&
&10(:)*PCONC(:,40)*PCONC(:,32)+0.66562*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+2.00&
&*TPK%K117(:)*PCONC(:,40)*PCONC(:,40)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,4&
&0)+0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!PLOSS(ONIT) = +K017+K071*<OH>
 PLOSS(:,26) = +TPK%K017(:)+TPK%K071(:)*PCONC(:,14)
!
!PPROD(PAN) = +0.28107*K070*<PAN>*<OH>+0.40000*K078*<PAN>*<NO3>+0.30000*K082*<P
!AN>*<O3>+1.00000*K088*<CARBOP>*<NO2>
 PPROD(:,27) = +0.28107*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)+0.40000*TPK%K078(:)&
&*PCONC(:,27)*PCONC(:,5)+0.30000*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+1.00000*TPK&
&%K088(:)*PCONC(:,39)*PCONC(:,4)
!PLOSS(PAN) = +K070*<OH>+K078*<NO3>+K082*<O3>+K089
 PLOSS(:,27) = +TPK%K070(:)*PCONC(:,14)+TPK%K078(:)*PCONC(:,5)+TPK%K082(:)*PCON&
&C(:,1)+TPK%K089(:)
!
!PPROD(OP1) = +K097*<MO2>*<HO2>+KTC40*<WC_OP1>+KTR40*<WR_OP1>
 PPROD(:,28) = +TPK%K097(:)*PCONC(:,32)*PCONC(:,15)+TPK%KTC40(:)*PCONC(:,61)+TP&
&K%KTR40(:)*PCONC(:,86)
!PLOSS(OP1) = +K013+K068*<OH>+KTC20+KTR20
 PLOSS(:,28) = +TPK%K013(:)+TPK%K068(:)*PCONC(:,14)+TPK%KTC20(:)+TPK%KTR20(:)
!
!PPROD(OP2) = +0.10149*K081*<CARBO>*<O3>+1.00524*K098*<ALKAP>*<HO2>+1.00524*K09
!9*<ALKEP>*<HO2>+1.00524*K0100*<BIOP>*<HO2>+1.00524*K0101*<AROP>*<HO2>+0.80904*
!K0102*<CARBOP>*<HO2>+1.00524*K126*<XO2>*<HO2>
 PPROD(:,29) = +0.10149*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+1.00524*TPK%K098(:)*&
&PCONC(:,33)*PCONC(:,15)+1.00524*TPK%K099(:)*PCONC(:,34)*PCONC(:,15)+1.00524*TP&
&K%K0100(:)*PCONC(:,35)*PCONC(:,15)+1.00524*TPK%K0101(:)*PCONC(:,38)*PCONC(:,15&
&)+0.80904*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)+1.00524*TPK%K126(:)*PCONC(:,41)&
&*PCONC(:,15)
!PLOSS(OP2) = +K014+K069*<OH>
 PLOSS(:,29) = +TPK%K014(:)+TPK%K069(:)*PCONC(:,14)
!
!PPROD(ORA1) = +0.00878*K058*<ALKA>*<OH>+0.15343*K079*<ALKE>*<O3>+0.15000*K080*
!<BIO>*<O3>+0.10788*K081*<CARBO>*<O3>+0.11*K082*<PAN>*<O3>+KTC37*<WC_ORA1>+KTR3
!7*<WR_ORA1>
 PPROD(:,30) = +0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0.15343*TPK%K079(:)&
&*PCONC(:,19)*PCONC(:,1)+0.15000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.10788*TPK&
&%K081(:)*PCONC(:,25)*PCONC(:,1)+0.11*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK%KT&
&C37(:)*PCONC(:,58)+TPK%KTR37(:)*PCONC(:,83)
!PLOSS(ORA1) = +K066*<OH>+KTC17+KTR17
 PLOSS(:,30) = +TPK%K066(:)*PCONC(:,14)+TPK%KTC17(:)+TPK%KTR17(:)
!
RETURN
END SUBROUTINE SUB2
!
SUBROUTINE SUB3
!
!Indices 31 a 40
!
!
!PPROD(ORA2) = +0.08143*K079*<ALKE>*<O3>+0.00000*K080*<BIO>*<O3>+0.20595*K081*<
!CARBO>*<O3>+0.17307*K0102*<CARBOP>*<HO2>+0.13684*K109*<CARBOP>*<MO2>+0.49810*K
!111*<ALKAP>*<CARBOP>+0.49922*K112*<ALKEP>*<CARBOP>+0.49400*K113*<BIOP>*<CARBOP
!>+0.09955*K115*<CARBOP>*<CARBOP>+0.48963*K116*<OLN>*<CARBOP>+KTC38*<WC_ORA2>+K
!TR38*<WR_ORA2>
 PPROD(:,31) = +0.08143*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*&
&PCONC(:,20)*PCONC(:,1)+0.20595*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.17307*TPK%&
&K0102(:)*PCONC(:,39)*PCONC(:,15)+0.13684*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)+0&
&.49810*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.49922*TPK%K112(:)*PCONC(:,34)*PCO&
&NC(:,39)+0.49400*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.09955*TPK%K115(:)*PCONC&
&(:,39)*PCONC(:,39)+0.48963*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+TPK%KTC38(:)*PC&
&ONC(:,59)+TPK%KTR38(:)*PCONC(:,84)
!PLOSS(ORA2) = +K067*<OH>+KTC18+KTR18
 PLOSS(:,31) = +TPK%K067(:)*PCONC(:,14)+TPK%KTC18(:)+TPK%KTR18(:)
!
!PPROD(MO2) = +K012*<ALD>+0.03795*K014*<OP2>+K056*<CH4>*<OH>+0.65*K068*<OP1>*<O
!H>+0.13966*K079*<ALKE>*<O3>+0.03000*K080*<BIO>*<O3>+0.09016*K091*<ALKAP>*<NO>+
!0.78134*K095*<CARBOP>*<NO>+0.01390*K105*<ALKAP>*<MO2>+0.56031*K109*<CARBOP>*<M
!O2>+0.51480*K111*<ALKAP>*<CARBOP>+0.50078*K112*<ALKEP>*<CARBOP>+0.50600*K113*<
!BIOP>*<CARBOP>+K114*<AROP>*<CARBOP>+1.66702*K115*<CARBOP>*<CARBOP>+0.51037*K11
!6*<OLN>*<CARBOP>+0.09731*K120*<ALKAP>*<NO3>+0.91910*K124*<CARBOP>*<NO3>+K128*<
!XO2>*<CARBOP>+KTC39*<WC_MO2>+KTR39*<WR_MO2>
 PPROD(:,32) = +TPK%K012(:)*PCONC(:,23)+0.03795*TPK%K014(:)*PCONC(:,29)+TPK%K05&
&6(:)*PCONC(:,16)*PCONC(:,14)+0.65*TPK%K068(:)*PCONC(:,28)*PCONC(:,14)+0.13966*&
&TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.03000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+&
&0.09016*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.78134*TPK%K095(:)*PCONC(:,39)*PCO&
&NC(:,3)+0.01390*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.56031*TPK%K109(:)*PCONC(&
&:,39)*PCONC(:,32)+0.51480*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.50078*TPK%K112&
&(:)*PCONC(:,34)*PCONC(:,39)+0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+TPK%K1&
&14(:)*PCONC(:,38)*PCONC(:,39)+1.66702*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.51&
&037*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.09731*TPK%K120(:)*PCONC(:,33)*PCONC(&
&:,5)+0.91910*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+TPK%K128(:)*PCONC(:,41)*PCONC(&
&:,39)+TPK%KTC39(:)*PCONC(:,60)+TPK%KTR39(:)*PCONC(:,85)
!PLOSS(MO2) = +K090*<NO>+K097*<HO2>+K104*<MO2>+K104*<MO2>+K105*<ALKAP>+K106*<AL
!KEP>+K107*<BIOP>+K108*<AROP>+K109*<CARBOP>+K110*<OLN>+K119*<NO3>+K127*<XO2>+KT
!C19+KTR19
 PLOSS(:,32) = +TPK%K090(:)*PCONC(:,3)+TPK%K097(:)*PCONC(:,15)+TPK%K104(:)*PCON&
&C(:,32)+TPK%K104(:)*PCONC(:,32)+TPK%K105(:)*PCONC(:,33)+TPK%K106(:)*PCONC(:,34&
&)+TPK%K107(:)*PCONC(:,35)+TPK%K108(:)*PCONC(:,38)+TPK%K109(:)*PCONC(:,39)+TPK%&
&K110(:)*PCONC(:,40)+TPK%K119(:)*PCONC(:,5)+TPK%K127(:)*PCONC(:,41)+TPK%KTC19(:&
&)+TPK%KTR19(:)
!
!PPROD(ALKAP) = +1.00000*K015*<KET>+K057*<ETH>*<OH>+0.87811*K058*<ALKA>*<OH>+0.
!40341*K069*<OP2>*<OH>+1.00000*K071*<ONIT>*<OH>+0.09815*K079*<ALKE>*<O3>+0.0000
!0*K080*<BIO>*<O3>+0.08187*K091*<ALKAP>*<NO>+0.00385*K105*<ALKAP>*<MO2>+0.00828
!*K111*<ALKAP>*<CARBOP>+0.08994*K120*<ALKAP>*<NO3>
 PPROD(:,33) = +1.00000*TPK%K015(:)*PCONC(:,24)+TPK%K057(:)*PCONC(:,17)*PCONC(:&
&,14)+0.87811*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0.40341*TPK%K069(:)*PCONC(:,2&
&9)*PCONC(:,14)+1.00000*TPK%K071(:)*PCONC(:,26)*PCONC(:,14)+0.09815*TPK%K079(:)&
&*PCONC(:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.08187*TPK&
&%K091(:)*PCONC(:,33)*PCONC(:,3)+0.00385*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.&
&00828*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.08994*TPK%K120(:)*PCONC(:,33)*PCON&
&C(:,5)
!PLOSS(ALKAP) = +K091*<NO>+K098*<HO2>+K105*<MO2>+K111*<CARBOP>+K120*<NO3>
 PLOSS(:,33) = +TPK%K091(:)*PCONC(:,3)+TPK%K098(:)*PCONC(:,15)+TPK%K105(:)*PCON&
&C(:,32)+TPK%K111(:)*PCONC(:,39)+TPK%K120(:)*PCONC(:,5)
!
!PPROD(ALKEP) = +1.02529*K059*<ALKE>*<OH>
 PPROD(:,34) = +1.02529*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!PLOSS(ALKEP) = +K092*<NO>+K099*<HO2>+K106*<MO2>+K112*<CARBOP>+K121*<NO3>
 PLOSS(:,34) = +TPK%K092(:)*PCONC(:,3)+TPK%K099(:)*PCONC(:,15)+TPK%K106(:)*PCON&
&C(:,32)+TPK%K112(:)*PCONC(:,39)+TPK%K121(:)*PCONC(:,5)
!
!PPROD(BIOP) = +0.00000*K059*<ALKE>*<OH>+1.00000*K060*<BIO>*<OH>
 PPROD(:,35) = +0.00000*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)+1.00000*TPK%K060(:)&
&*PCONC(:,20)*PCONC(:,14)
!PLOSS(BIOP) = +K093*<NO>+K0100*<HO2>+K107*<MO2>+K113*<CARBOP>+K122*<NO3>
 PLOSS(:,35) = +TPK%K093(:)*PCONC(:,3)+TPK%K0100(:)*PCONC(:,15)+TPK%K107(:)*PCO&
&NC(:,32)+TPK%K113(:)*PCONC(:,39)+TPK%K122(:)*PCONC(:,5)
!
!PPROD(PHO) = +0.00276*K061*<ARO>*<OH>+K075*<ARO>*<NO3>
 PPROD(:,36) = +0.00276*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)+TPK%K075(:)*PCONC(:&
&,21)*PCONC(:,5)
!PLOSS(PHO) = +K083*<NO2>+K084*<HO2>
 PLOSS(:,36) = +TPK%K083(:)*PCONC(:,4)+TPK%K084(:)*PCONC(:,15)
!
!PPROD(ADD) = +0.93968*K061*<ARO>*<OH>
 PPROD(:,37) = +0.93968*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!PLOSS(ADD) = +K085*<NO2>+K086*<O2>+K087*<O3>
 PLOSS(:,37) = +TPK%K085(:)*PCONC(:,4)+TPK%K086(:)*TPK%O2(:)+TPK%K087(:)*PCONC(&
&:,1)
!
!PPROD(AROP) = +0.98*K086*<ADD>*<O2>
 PPROD(:,38) = +0.98*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!PLOSS(AROP) = +K094*<NO>+K0101*<HO2>+K108*<MO2>+K114*<CARBOP>+K123*<NO3>
 PLOSS(:,38) = +TPK%K094(:)*PCONC(:,3)+TPK%K0101(:)*PCONC(:,15)+TPK%K108(:)*PCO&
&NC(:,32)+TPK%K114(:)*PCONC(:,39)+TPK%K123(:)*PCONC(:,5)
!
!PPROD(CARBOP) = +1.00000*K015*<KET>+0.69622*K016*<CARBO>+1.00000*K063*<ALD>*<O
!H>+1.00000*K064*<KET>*<OH>+0.51419*K065*<CARBO>*<OH>+0.05413*K069*<OP2>*<OH>+1
!.00000*K073*<ALD>*<NO3>+0.38881*K074*<CARBO>*<NO3>+0.05705*K079*<ALKE>*<O3>+0.
!17000*K080*<BIO>*<O3>+0.27460*K081*<CARBO>*<O3>+0.70000*K082*<PAN>*<O3>+1.0000
!0*K089*<PAN>+0.09532*K095*<CARBOP>*<NO>+0.05954*K109*<CARBOP>*<MO2>+0.05821*K1
!15*<CARBOP>*<CARBOP>+0.03175*K124*<CARBOP>*<NO3>
 PPROD(:,39) = +1.00000*TPK%K015(:)*PCONC(:,24)+0.69622*TPK%K016(:)*PCONC(:,25)&
&+1.00000*TPK%K063(:)*PCONC(:,23)*PCONC(:,14)+1.00000*TPK%K064(:)*PCONC(:,24)*P&
&CONC(:,14)+0.51419*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.05413*TPK%K069(:)*PCO&
&NC(:,29)*PCONC(:,14)+1.00000*TPK%K073(:)*PCONC(:,23)*PCONC(:,5)+0.38881*TPK%K0&
&74(:)*PCONC(:,25)*PCONC(:,5)+0.05705*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.1700&
&0*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.27460*TPK%K081(:)*PCONC(:,25)*PCONC(:,1&
&)+0.70000*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+1.00000*TPK%K089(:)*PCONC(:,27)+0&
&.09532*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.05954*TPK%K109(:)*PCONC(:,39)*PCON&
&C(:,32)+0.05821*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.03175*TPK%K124(:)*PCONC(&
&:,39)*PCONC(:,5)
!PLOSS(CARBOP) = +K088*<NO2>+K095*<NO>+K0102*<HO2>+K109*<MO2>+K111*<ALKAP>+K112
!*<ALKEP>+K113*<BIOP>+K114*<AROP>+K115*<CARBOP>+K115*<CARBOP>+K116*<OLN>+K124*<
!NO3>+K128*<XO2>
 PLOSS(:,39) = +TPK%K088(:)*PCONC(:,4)+TPK%K095(:)*PCONC(:,3)+TPK%K0102(:)*PCON&
&C(:,15)+TPK%K109(:)*PCONC(:,32)+TPK%K111(:)*PCONC(:,33)+TPK%K112(:)*PCONC(:,34&
&)+TPK%K113(:)*PCONC(:,35)+TPK%K114(:)*PCONC(:,38)+TPK%K115(:)*PCONC(:,39)+TPK%&
&K115(:)*PCONC(:,39)+TPK%K116(:)*PCONC(:,40)+TPK%K124(:)*PCONC(:,5)+TPK%K128(:)&
&*PCONC(:,41)
!
!PPROD(OLN) = +0.00000*K074*<CARBO>*<NO3>+0.93768*K076*<ALKE>*<NO3>+1.00000*K07
!7*<BIO>*<NO3>
 PPROD(:,40) = +0.00000*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.93768*TPK%K076(:)*&
&PCONC(:,19)*PCONC(:,5)+1.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!PLOSS(OLN) = +K096*<NO>+K103*<HO2>+K110*<MO2>+K116*<CARBOP>+K117*<OLN>+K117*<O
!LN>+K118*<OLN>+K118*<OLN>+K125*<NO3>
 PLOSS(:,40) = +TPK%K096(:)*PCONC(:,3)+TPK%K103(:)*PCONC(:,15)+TPK%K110(:)*PCON&
&C(:,32)+TPK%K116(:)*PCONC(:,39)+TPK%K117(:)*PCONC(:,40)+TPK%K117(:)*PCONC(:,40&
&)+TPK%K118(:)*PCONC(:,40)+TPK%K118(:)*PCONC(:,40)+TPK%K125(:)*PCONC(:,5)
!
RETURN
END SUBROUTINE SUB3
!
SUBROUTINE SUB4
!
!Indices 41 a 50
!
!
!PPROD(XO2) = +0.15*K054*<BIO>*<O3P>+0.10318*K061*<ARO>*<OH>+0.10162*K065*<CARB
!O>*<OH>+0.09333*K069*<OP2>*<OH>+K070*<PAN>*<OH>+0.10530*K074*<CARBO>*<NO3>+K07
!8*<PAN>*<NO3>+0.00000*K079*<ALKE>*<O3>+0.13000*K080*<BIO>*<O3>+0.13007*K091*<A
!LKAP>*<NO>+0.02563*K095*<CARBOP>*<NO>+0.13370*K105*<ALKAP>*<MO2>+0.02212*K109*
!<CARBOP>*<MO2>+0.11306*K111*<ALKAP>*<CARBOP>+0.01593*K115*<CARBOP>*<CARBOP>+0.
!16271*K120*<ALKAP>*<NO3>+0.01021*K124*<CARBOP>*<NO3>
 PPROD(:,41) = +0.15*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.10318*TPK%K061(:)*PCO&
&NC(:,21)*PCONC(:,14)+0.10162*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.09333*TPK%K&
&069(:)*PCONC(:,29)*PCONC(:,14)+TPK%K070(:)*PCONC(:,27)*PCONC(:,14)+0.10530*TPK&
&%K074(:)*PCONC(:,25)*PCONC(:,5)+TPK%K078(:)*PCONC(:,27)*PCONC(:,5)+0.00000*TPK&
&%K079(:)*PCONC(:,19)*PCONC(:,1)+0.13000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.1&
&3007*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.02563*TPK%K095(:)*PCONC(:,39)*PCONC(&
&:,3)+0.13370*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.02212*TPK%K109(:)*PCONC(:,3&
&9)*PCONC(:,32)+0.11306*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.01593*TPK%K115(:)&
&*PCONC(:,39)*PCONC(:,39)+0.16271*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+0.01021*TP&
&K%K124(:)*PCONC(:,39)*PCONC(:,5)
!PLOSS(XO2) = +K126*<HO2>+K127*<MO2>+K128*<CARBOP>+K129*<XO2>+K129*<XO2>+K130*<
!NO>+K131*<NO3>
 PLOSS(:,41) = +TPK%K126(:)*PCONC(:,15)+TPK%K127(:)*PCONC(:,32)+TPK%K128(:)*PCO&
&NC(:,39)+TPK%K129(:)*PCONC(:,41)+TPK%K129(:)*PCONC(:,41)+TPK%K130(:)*PCONC(:,3&
&)+TPK%K131(:)*PCONC(:,5)
!
!PPROD(WC_O3) = +KTC1*<O3>
 PPROD(:,42) = +TPK%KTC1(:)*PCONC(:,1)
!PLOSS(WC_O3) = +KTC21+KC6*<WC_HO2>+KC29*<WC_SO2>
 PLOSS(:,42) = +TPK%KTC21(:)+TPK%KC6(:)*PCONC(:,53)+TPK%KC29(:)*PCONC(:,55)
!
!PPROD(WC_H2O2) = +KTC2*<H2O2>+KC2*<WC_OH>*<WC_OH>+KC5*<WC_HO2>*<WC_HO2>
 PPROD(:,43) = +TPK%KTC2(:)*PCONC(:,2)+TPK%KC2(:)*PCONC(:,52)*PCONC(:,52)+TPK%K&
&C5(:)*PCONC(:,53)*PCONC(:,53)
!PLOSS(WC_H2O2) = +KTC22+KC1+KC4*<WC_OH>+KC30*<WC_SO2>
 PLOSS(:,43) = +TPK%KTC22(:)+TPK%KC1(:)+TPK%KC4(:)*PCONC(:,52)+TPK%KC30(:)*PCON&
&C(:,55)
!
!PPROD(WC_NO) = +KTC3*<NO>
 PPROD(:,44) = +TPK%KTC3(:)*PCONC(:,3)
!PLOSS(WC_NO) = +KTC23
 PLOSS(:,44) = +TPK%KTC23(:)
!
!PPROD(WC_NO2) = +KTC4*<NO2>+KC8*<WC_HONO>*<WC_OH>+KC10*<WC_HNO4>+KC13*<WC_HNO3
!>
 PPROD(:,45) = +TPK%KTC4(:)*PCONC(:,4)+TPK%KC8(:)*PCONC(:,48)*PCONC(:,52)+TPK%K&
&C10(:)*PCONC(:,50)+TPK%KC13(:)*PCONC(:,49)
!PLOSS(WC_NO2) = +KTC24+KC9*<WC_HO2>
 PLOSS(:,45) = +TPK%KTC24(:)+TPK%KC9(:)*PCONC(:,53)
!
!PPROD(WC_NO3) = +KTC5*<NO3>
 PPROD(:,46) = +TPK%KTC5(:)*PCONC(:,5)
!PLOSS(WC_NO3) = +KTC25+KC15*<WC_SULF>+KC16*<WC_SO2>
 PLOSS(:,46) = +TPK%KTC25(:)+TPK%KC15(:)*PCONC(:,56)+TPK%KC16(:)*PCONC(:,55)
!
!PPROD(WC_N2O5) = +KTC6*<N2O5>
 PPROD(:,47) = +TPK%KTC6(:)*PCONC(:,6)
!PLOSS(WC_N2O5) = +KTC26+KC14
 PLOSS(:,47) = +TPK%KTC26(:)+TPK%KC14(:)
!
!PPROD(WC_HONO) = +KTC7*<HONO>+KC11*<WC_HNO4>
 PPROD(:,48) = +TPK%KTC7(:)*PCONC(:,7)+TPK%KC11(:)*PCONC(:,50)
!PLOSS(WC_HONO) = +KTC27+KC8*<WC_OH>
 PLOSS(:,48) = +TPK%KTC27(:)+TPK%KC8(:)*PCONC(:,52)
!
!PPROD(WC_HNO3) = +KTC8*<HNO3>+KC12*<WC_HNO4>*<WC_SO2>+KC14*<WC_N2O5>+KC14*<WC_
!N2O5>+KC15*<WC_NO3>*<WC_SULF>+KC16*<WC_NO3>*<WC_SO2>
 PPROD(:,49) = +TPK%KTC8(:)*PCONC(:,8)+TPK%KC12(:)*PCONC(:,50)*PCONC(:,55)+TPK%&
&KC14(:)*PCONC(:,47)+TPK%KC14(:)*PCONC(:,47)+TPK%KC15(:)*PCONC(:,46)*PCONC(:,56&
&)+TPK%KC16(:)*PCONC(:,46)*PCONC(:,55)
!PLOSS(WC_HNO3) = +KTC28+KC13
 PLOSS(:,49) = +TPK%KTC28(:)+TPK%KC13(:)
!
!PPROD(WC_HNO4) = +KTC9*<HNO4>+KC9*<WC_NO2>*<WC_HO2>
 PPROD(:,50) = +TPK%KTC9(:)*PCONC(:,9)+TPK%KC9(:)*PCONC(:,45)*PCONC(:,53)
!PLOSS(WC_HNO4) = +KTC29+KC10+KC11+KC12*<WC_SO2>
 PLOSS(:,50) = +TPK%KTC29(:)+TPK%KC10(:)+TPK%KC11(:)+TPK%KC12(:)*PCONC(:,55)
!
RETURN
END SUBROUTINE SUB4
!
SUBROUTINE SUB5
!
!Indices 51 a 60
!
!
!PPROD(WC_NH3) = +KTC10*<NH3>
 PPROD(:,51) = +TPK%KTC10(:)*PCONC(:,10)
!PLOSS(WC_NH3) = +KTC30
 PLOSS(:,51) = +TPK%KTC30(:)
!
!PPROD(WC_OH) = +KTC11*<OH>+KC1*<WC_H2O2>+KC1*<WC_H2O2>+KC6*<WC_O3>*<WC_HO2>+KC
!13*<WC_HNO3>+KC28*<WC_ASO4>
 PPROD(:,52) = +TPK%KTC11(:)*PCONC(:,14)+TPK%KC1(:)*PCONC(:,43)+TPK%KC1(:)*PCON&
&C(:,43)+TPK%KC6(:)*PCONC(:,42)*PCONC(:,53)+TPK%KC13(:)*PCONC(:,49)+TPK%KC28(:)&
&*PCONC(:,63)
!PLOSS(WC_OH) = +KTC31+KC2*<WC_OH>+KC2*<WC_OH>+KC3*<WC_HO2>+KC4*<WC_H2O2>+KC7*<
!WC_SO2>+KC8*<WC_HONO>+KC19*<WC_HCHO>+KC20*<WC_ORA1>+KC23*<WC_AHMS>
 PLOSS(:,52) = +TPK%KTC31(:)+TPK%KC2(:)*PCONC(:,52)+TPK%KC2(:)*PCONC(:,52)+TPK%&
&KC3(:)*PCONC(:,53)+TPK%KC4(:)*PCONC(:,43)+TPK%KC7(:)*PCONC(:,55)+TPK%KC8(:)*PC&
&ONC(:,48)+TPK%KC19(:)*PCONC(:,57)+TPK%KC20(:)*PCONC(:,58)+TPK%KC23(:)*PCONC(:,&
&66)
!
!PPROD(WC_HO2) = +KTC12*<HO2>+KC4*<WC_H2O2>*<WC_OH>+KC10*<WC_HNO4>+2.00*KC17*<W
!C_MO2>*<WC_MO2>+KC19*<WC_HCHO>*<WC_OH>+KC20*<WC_ORA1>*<WC_OH>+KC23*<WC_AHMS>*<
!WC_OH>
 PPROD(:,53) = +TPK%KTC12(:)*PCONC(:,15)+TPK%KC4(:)*PCONC(:,43)*PCONC(:,52)+TPK&
&%KC10(:)*PCONC(:,50)+2.00*TPK%KC17(:)*PCONC(:,60)*PCONC(:,60)+TPK%KC19(:)*PCON&
&C(:,57)*PCONC(:,52)+TPK%KC20(:)*PCONC(:,58)*PCONC(:,52)+TPK%KC23(:)*PCONC(:,66&
&)*PCONC(:,52)
!PLOSS(WC_HO2) = +KTC32+KC3*<WC_OH>+KC5*<WC_HO2>+KC5*<WC_HO2>+KC6*<WC_O3>+KC9*<
!WC_NO2>+KC25*<WC_ASO5>
 PLOSS(:,53) = +TPK%KTC32(:)+TPK%KC3(:)*PCONC(:,52)+TPK%KC5(:)*PCONC(:,53)+TPK%&
&KC5(:)*PCONC(:,53)+TPK%KC6(:)*PCONC(:,42)+TPK%KC9(:)*PCONC(:,45)+TPK%KC25(:)*P&
&CONC(:,64)
!
!PPROD(WC_CO2) = +KTC13*<CO2>+KC20*<WC_ORA1>*<WC_OH>
 PPROD(:,54) = +TPK%KTC13(:)*TPK%CO2(:)+TPK%KC20(:)*PCONC(:,58)*PCONC(:,52)
!PLOSS(WC_CO2) = +KTC33
 PLOSS(:,54) = +TPK%KTC33(:)
!
!PPROD(WC_SO2) = +KTC14*<SO2>+KC22*<WC_AHMS>+KC23*<WC_AHMS>*<WC_OH>
 PPROD(:,55) = +TPK%KTC14(:)*PCONC(:,11)+TPK%KC22(:)*PCONC(:,66)+TPK%KC23(:)*PC&
&ONC(:,66)*PCONC(:,52)
!PLOSS(WC_SO2) = +KTC34+KC7*<WC_OH>+KC12*<WC_HNO4>+KC16*<WC_NO3>+KC18*<WC_MO2>+
!KC21*<WC_HCHO>+KC27*<WC_AHSO5>+KC29*<WC_O3>+KC30*<WC_H2O2>
 PLOSS(:,55) = +TPK%KTC34(:)+TPK%KC7(:)*PCONC(:,52)+TPK%KC12(:)*PCONC(:,50)+TPK&
&%KC16(:)*PCONC(:,46)+TPK%KC18(:)*PCONC(:,60)+TPK%KC21(:)*PCONC(:,57)+TPK%KC27(&
&:)*PCONC(:,65)+TPK%KC29(:)*PCONC(:,42)+TPK%KC30(:)*PCONC(:,43)
!
!PPROD(WC_SULF) = +KTC15*<SULF>+KC12*<WC_HNO4>*<WC_SO2>+2.00*KC27*<WC_AHSO5>*<W
!C_SO2>+KC28*<WC_ASO4>+KC29*<WC_SO2>*<WC_O3>+KC30*<WC_SO2>*<WC_H2O2>
 PPROD(:,56) = +TPK%KTC15(:)*PCONC(:,12)+TPK%KC12(:)*PCONC(:,50)*PCONC(:,55)+2.&
&00*TPK%KC27(:)*PCONC(:,65)*PCONC(:,55)+TPK%KC28(:)*PCONC(:,63)+TPK%KC29(:)*PCO&
&NC(:,55)*PCONC(:,42)+TPK%KC30(:)*PCONC(:,55)*PCONC(:,43)
!PLOSS(WC_SULF) = +KTC35+KC15*<WC_NO3>
 PLOSS(:,56) = +TPK%KTC35(:)+TPK%KC15(:)*PCONC(:,46)
!
!PPROD(WC_HCHO) = +KTC16*<HCHO>+2.00*KC17*<WC_MO2>*<WC_MO2>+KC22*<WC_AHMS>
 PPROD(:,57) = +TPK%KTC16(:)*PCONC(:,22)+2.00*TPK%KC17(:)*PCONC(:,60)*PCONC(:,6&
&0)+TPK%KC22(:)*PCONC(:,66)
!PLOSS(WC_HCHO) = +KTC36+KC19*<WC_OH>+KC21*<WC_SO2>
 PLOSS(:,57) = +TPK%KTC36(:)+TPK%KC19(:)*PCONC(:,52)+TPK%KC21(:)*PCONC(:,55)
!
!PPROD(WC_ORA1) = +KTC17*<ORA1>+KC19*<WC_HCHO>*<WC_OH>+KC23*<WC_AHMS>*<WC_OH>
 PPROD(:,58) = +TPK%KTC17(:)*PCONC(:,30)+TPK%KC19(:)*PCONC(:,57)*PCONC(:,52)+TP&
&K%KC23(:)*PCONC(:,66)*PCONC(:,52)
!PLOSS(WC_ORA1) = +KTC37+KC20*<WC_OH>
 PLOSS(:,58) = +TPK%KTC37(:)+TPK%KC20(:)*PCONC(:,52)
!
!PPROD(WC_ORA2) = +KTC18*<ORA2>
 PPROD(:,59) = +TPK%KTC18(:)*PCONC(:,31)
!PLOSS(WC_ORA2) = +KTC38
 PLOSS(:,59) = +TPK%KTC38(:)
!
!PPROD(WC_MO2) = +KTC19*<MO2>
 PPROD(:,60) = +TPK%KTC19(:)*PCONC(:,32)
!PLOSS(WC_MO2) = +KTC39+KC17*<WC_MO2>+KC17*<WC_MO2>+KC18*<WC_SO2>
 PLOSS(:,60) = +TPK%KTC39(:)+TPK%KC17(:)*PCONC(:,60)+TPK%KC17(:)*PCONC(:,60)+TP&
&K%KC18(:)*PCONC(:,55)
!
RETURN
END SUBROUTINE SUB5
!
SUBROUTINE SUB6
!
!Indices 61 a 70
!
!
!PPROD(WC_OP1) = +KTC20*<OP1>+KC18*<WC_MO2>*<WC_SO2>
 PPROD(:,61) = +TPK%KTC20(:)*PCONC(:,28)+TPK%KC18(:)*PCONC(:,60)*PCONC(:,55)
!PLOSS(WC_OP1) = +KTC40
 PLOSS(:,61) = +TPK%KTC40(:)
!
!PPROD(WC_ASO3) = +KC7*<WC_OH>*<WC_SO2>+KC16*<WC_NO3>*<WC_SO2>+KC18*<WC_MO2>*<W
!C_SO2>
 PPROD(:,62) = +TPK%KC7(:)*PCONC(:,52)*PCONC(:,55)+TPK%KC16(:)*PCONC(:,46)*PCON&
&C(:,55)+TPK%KC18(:)*PCONC(:,60)*PCONC(:,55)
!PLOSS(WC_ASO3) = +KC24*<W_O2>
 PLOSS(:,62) = +TPK%KC24(:)*TPK%W_O2(:)
!
!PPROD(WC_ASO4) = +KC15*<WC_NO3>*<WC_SULF>+KC26*<WC_ASO5>*<WC_ASO5>+KC26*<WC_AS
!O5>*<WC_ASO5>
 PPROD(:,63) = +TPK%KC15(:)*PCONC(:,46)*PCONC(:,56)+TPK%KC26(:)*PCONC(:,64)*PCO&
&NC(:,64)+TPK%KC26(:)*PCONC(:,64)*PCONC(:,64)
!PLOSS(WC_ASO4) = +KC28
 PLOSS(:,63) = +TPK%KC28(:)
!
!PPROD(WC_ASO5) = +KC24*<WC_ASO3>*<W_O2>
 PPROD(:,64) = +TPK%KC24(:)*PCONC(:,62)*TPK%W_O2(:)
!PLOSS(WC_ASO5) = +KC25*<WC_HO2>+KC26*<WC_ASO5>+KC26*<WC_ASO5>
 PLOSS(:,64) = +TPK%KC25(:)*PCONC(:,53)+TPK%KC26(:)*PCONC(:,64)+TPK%KC26(:)*PCO&
&NC(:,64)
!
!PPROD(WC_AHSO5) = +KC25*<WC_ASO5>*<WC_HO2>
 PPROD(:,65) = +TPK%KC25(:)*PCONC(:,64)*PCONC(:,53)
!PLOSS(WC_AHSO5) = +KC27*<WC_SO2>
 PLOSS(:,65) = +TPK%KC27(:)*PCONC(:,55)
!
!PPROD(WC_AHMS) = +KC21*<WC_SO2>*<WC_HCHO>
 PPROD(:,66) = +TPK%KC21(:)*PCONC(:,55)*PCONC(:,57)
!PLOSS(WC_AHMS) = +KC22+KC23*<WC_OH>
 PLOSS(:,66) = +TPK%KC22(:)+TPK%KC23(:)*PCONC(:,52)
!
!PPROD(WR_O3) = +KTR1*<O3>
 PPROD(:,67) = +TPK%KTR1(:)*PCONC(:,1)
!PLOSS(WR_O3) = +KTR21+KR6*<WR_HO2>+KR29*<WR_SO2>
 PLOSS(:,67) = +TPK%KTR21(:)+TPK%KR6(:)*PCONC(:,78)+TPK%KR29(:)*PCONC(:,80)
!
!PPROD(WR_H2O2) = +KTR2*<H2O2>+KR2*<WR_OH>*<WR_OH>+KR5*<WR_HO2>*<WR_HO2>
 PPROD(:,68) = +TPK%KTR2(:)*PCONC(:,2)+TPK%KR2(:)*PCONC(:,77)*PCONC(:,77)+TPK%K&
&R5(:)*PCONC(:,78)*PCONC(:,78)
!PLOSS(WR_H2O2) = +KTR22+KR1+KR4*<WR_OH>+KR30*<WR_SO2>
 PLOSS(:,68) = +TPK%KTR22(:)+TPK%KR1(:)+TPK%KR4(:)*PCONC(:,77)+TPK%KR30(:)*PCON&
&C(:,80)
!
!PPROD(WR_NO) = +KTR3*<NO>
 PPROD(:,69) = +TPK%KTR3(:)*PCONC(:,3)
!PLOSS(WR_NO) = +KTR23
 PLOSS(:,69) = +TPK%KTR23(:)
!
!PPROD(WR_NO2) = +KTR4*<NO2>+KR8*<WR_HONO>*<WR_OH>+KR10*<WR_HNO4>+KR13*<WR_HNO3
!>
 PPROD(:,70) = +TPK%KTR4(:)*PCONC(:,4)+TPK%KR8(:)*PCONC(:,73)*PCONC(:,77)+TPK%K&
&R10(:)*PCONC(:,75)+TPK%KR13(:)*PCONC(:,74)
!PLOSS(WR_NO2) = +KTR24+KR9*<WR_HO2>
 PLOSS(:,70) = +TPK%KTR24(:)+TPK%KR9(:)*PCONC(:,78)
!
RETURN
END SUBROUTINE SUB6
!
SUBROUTINE SUB7
!
!Indices 71 a 80
!
!
!PPROD(WR_NO3) = +KTR5*<NO3>
 PPROD(:,71) = +TPK%KTR5(:)*PCONC(:,5)
!PLOSS(WR_NO3) = +KTR25+KR15*<WR_SULF>+KR16*<WR_SO2>
 PLOSS(:,71) = +TPK%KTR25(:)+TPK%KR15(:)*PCONC(:,81)+TPK%KR16(:)*PCONC(:,80)
!
!PPROD(WR_N2O5) = +KTR6*<N2O5>
 PPROD(:,72) = +TPK%KTR6(:)*PCONC(:,6)
!PLOSS(WR_N2O5) = +KTR26+KR14
 PLOSS(:,72) = +TPK%KTR26(:)+TPK%KR14(:)
!
!PPROD(WR_HONO) = +KTR7*<HONO>+KR11*<WR_HNO4>
 PPROD(:,73) = +TPK%KTR7(:)*PCONC(:,7)+TPK%KR11(:)*PCONC(:,75)
!PLOSS(WR_HONO) = +KTR27+KR8*<WR_OH>
 PLOSS(:,73) = +TPK%KTR27(:)+TPK%KR8(:)*PCONC(:,77)
!
!PPROD(WR_HNO3) = +KTR8*<HNO3>+KR12*<WR_HNO4>*<WR_SO2>+KR14*<WR_N2O5>+KR14*<WR_
!N2O5>+KR15*<WR_NO3>*<WR_SULF>+KR16*<WR_NO3>*<WR_SO2>
 PPROD(:,74) = +TPK%KTR8(:)*PCONC(:,8)+TPK%KR12(:)*PCONC(:,75)*PCONC(:,80)+TPK%&
&KR14(:)*PCONC(:,72)+TPK%KR14(:)*PCONC(:,72)+TPK%KR15(:)*PCONC(:,71)*PCONC(:,81&
&)+TPK%KR16(:)*PCONC(:,71)*PCONC(:,80)
!PLOSS(WR_HNO3) = +KTR28+KR13
 PLOSS(:,74) = +TPK%KTR28(:)+TPK%KR13(:)
!
!PPROD(WR_HNO4) = +KTR9*<HNO4>+KR9*<WR_NO2>*<WR_HO2>
 PPROD(:,75) = +TPK%KTR9(:)*PCONC(:,9)+TPK%KR9(:)*PCONC(:,70)*PCONC(:,78)
!PLOSS(WR_HNO4) = +KTR29+KR10+KR11+KR12*<WR_SO2>
 PLOSS(:,75) = +TPK%KTR29(:)+TPK%KR10(:)+TPK%KR11(:)+TPK%KR12(:)*PCONC(:,80)
!
!PPROD(WR_NH3) = +KTR10*<NH3>
 PPROD(:,76) = +TPK%KTR10(:)*PCONC(:,10)
!PLOSS(WR_NH3) = +KTR30
 PLOSS(:,76) = +TPK%KTR30(:)
!
!PPROD(WR_OH) = +KTR11*<OH>+KR1*<WR_H2O2>+KR1*<WR_H2O2>+KR6*<WR_O3>*<WR_HO2>+KR
!13*<WR_HNO3>+KR28*<WR_ASO4>
 PPROD(:,77) = +TPK%KTR11(:)*PCONC(:,14)+TPK%KR1(:)*PCONC(:,68)+TPK%KR1(:)*PCON&
&C(:,68)+TPK%KR6(:)*PCONC(:,67)*PCONC(:,78)+TPK%KR13(:)*PCONC(:,74)+TPK%KR28(:)&
&*PCONC(:,88)
!PLOSS(WR_OH) = +KTR31+KR2*<WR_OH>+KR2*<WR_OH>+KR3*<WR_HO2>+KR4*<WR_H2O2>+KR7*<
!WR_SO2>+KR8*<WR_HONO>+KR19*<WR_HCHO>+KR20*<WR_ORA1>+KR23*<WR_AHMS>
 PLOSS(:,77) = +TPK%KTR31(:)+TPK%KR2(:)*PCONC(:,77)+TPK%KR2(:)*PCONC(:,77)+TPK%&
&KR3(:)*PCONC(:,78)+TPK%KR4(:)*PCONC(:,68)+TPK%KR7(:)*PCONC(:,80)+TPK%KR8(:)*PC&
&ONC(:,73)+TPK%KR19(:)*PCONC(:,82)+TPK%KR20(:)*PCONC(:,83)+TPK%KR23(:)*PCONC(:,&
&91)
!
!PPROD(WR_HO2) = +KTR12*<HO2>+KR4*<WR_H2O2>*<WR_OH>+KR10*<WR_HNO4>+2.00*KR17*<W
!R_MO2>*<WR_MO2>+KR19*<WR_HCHO>*<WR_OH>+KR20*<WR_ORA1>*<WR_OH>+KR23*<WR_AHMS>*<
!WR_OH>
 PPROD(:,78) = +TPK%KTR12(:)*PCONC(:,15)+TPK%KR4(:)*PCONC(:,68)*PCONC(:,77)+TPK&
&%KR10(:)*PCONC(:,75)+2.00*TPK%KR17(:)*PCONC(:,85)*PCONC(:,85)+TPK%KR19(:)*PCON&
&C(:,82)*PCONC(:,77)+TPK%KR20(:)*PCONC(:,83)*PCONC(:,77)+TPK%KR23(:)*PCONC(:,91&
&)*PCONC(:,77)
!PLOSS(WR_HO2) = +KTR32+KR3*<WR_OH>+KR5*<WR_HO2>+KR5*<WR_HO2>+KR6*<WR_O3>+KR9*<
!WR_NO2>+KR25*<WR_ASO5>
 PLOSS(:,78) = +TPK%KTR32(:)+TPK%KR3(:)*PCONC(:,77)+TPK%KR5(:)*PCONC(:,78)+TPK%&
&KR5(:)*PCONC(:,78)+TPK%KR6(:)*PCONC(:,67)+TPK%KR9(:)*PCONC(:,70)+TPK%KR25(:)*P&
&CONC(:,89)
!
!PPROD(WR_CO2) = +KTR13*<CO2>+KR20*<WR_ORA1>*<WR_OH>
 PPROD(:,79) = +TPK%KTR13(:)*TPK%CO2(:)+TPK%KR20(:)*PCONC(:,83)*PCONC(:,77)
!PLOSS(WR_CO2) = +KTR33
 PLOSS(:,79) = +TPK%KTR33(:)
!
!PPROD(WR_SO2) = +KTR14*<SO2>+KR22*<WR_AHMS>+KR23*<WR_AHMS>*<WR_OH>
 PPROD(:,80) = +TPK%KTR14(:)*PCONC(:,11)+TPK%KR22(:)*PCONC(:,91)+TPK%KR23(:)*PC&
&ONC(:,91)*PCONC(:,77)
!PLOSS(WR_SO2) = +KTR34+KR7*<WR_OH>+KR12*<WR_HNO4>+KR16*<WR_NO3>+KR18*<WR_MO2>+
!KR21*<WR_HCHO>+KR27*<WR_AHSO5>+KR29*<WR_O3>+KR30*<WR_H2O2>
 PLOSS(:,80) = +TPK%KTR34(:)+TPK%KR7(:)*PCONC(:,77)+TPK%KR12(:)*PCONC(:,75)+TPK&
&%KR16(:)*PCONC(:,71)+TPK%KR18(:)*PCONC(:,85)+TPK%KR21(:)*PCONC(:,82)+TPK%KR27(&
&:)*PCONC(:,90)+TPK%KR29(:)*PCONC(:,67)+TPK%KR30(:)*PCONC(:,68)
!
RETURN
END SUBROUTINE SUB7
!
SUBROUTINE SUB8
!
!Indices 81 a 90
!
!
!PPROD(WR_SULF) = +KTR15*<SULF>+KR12*<WR_HNO4>*<WR_SO2>+2.00*KR27*<WR_AHSO5>*<W
!R_SO2>+KR28*<WR_ASO4>+KR29*<WR_SO2>*<WR_O3>+KR30*<WR_SO2>*<WR_H2O2>
 PPROD(:,81) = +TPK%KTR15(:)*PCONC(:,12)+TPK%KR12(:)*PCONC(:,75)*PCONC(:,80)+2.&
&00*TPK%KR27(:)*PCONC(:,90)*PCONC(:,80)+TPK%KR28(:)*PCONC(:,88)+TPK%KR29(:)*PCO&
&NC(:,80)*PCONC(:,67)+TPK%KR30(:)*PCONC(:,80)*PCONC(:,68)
!PLOSS(WR_SULF) = +KTR35+KR15*<WR_NO3>
 PLOSS(:,81) = +TPK%KTR35(:)+TPK%KR15(:)*PCONC(:,71)
!
!PPROD(WR_HCHO) = +KTR16*<HCHO>+2.00*KR17*<WR_MO2>*<WR_MO2>+KR22*<WR_AHMS>
 PPROD(:,82) = +TPK%KTR16(:)*PCONC(:,22)+2.00*TPK%KR17(:)*PCONC(:,85)*PCONC(:,8&
&5)+TPK%KR22(:)*PCONC(:,91)
!PLOSS(WR_HCHO) = +KTR36+KR19*<WR_OH>+KR21*<WR_SO2>
 PLOSS(:,82) = +TPK%KTR36(:)+TPK%KR19(:)*PCONC(:,77)+TPK%KR21(:)*PCONC(:,80)
!
!PPROD(WR_ORA1) = +KTR17*<ORA1>+KR19*<WR_HCHO>*<WR_OH>+KR23*<WR_AHMS>*<WR_OH>
 PPROD(:,83) = +TPK%KTR17(:)*PCONC(:,30)+TPK%KR19(:)*PCONC(:,82)*PCONC(:,77)+TP&
&K%KR23(:)*PCONC(:,91)*PCONC(:,77)
!PLOSS(WR_ORA1) = +KTR37+KR20*<WR_OH>
 PLOSS(:,83) = +TPK%KTR37(:)+TPK%KR20(:)*PCONC(:,77)
!
!PPROD(WR_ORA2) = +KTR18*<ORA2>
 PPROD(:,84) = +TPK%KTR18(:)*PCONC(:,31)
!PLOSS(WR_ORA2) = +KTR38
 PLOSS(:,84) = +TPK%KTR38(:)
!
!PPROD(WR_MO2) = +KTR19*<MO2>
 PPROD(:,85) = +TPK%KTR19(:)*PCONC(:,32)
!PLOSS(WR_MO2) = +KTR39+KR17*<WR_MO2>+KR17*<WR_MO2>+KR18*<WR_SO2>
 PLOSS(:,85) = +TPK%KTR39(:)+TPK%KR17(:)*PCONC(:,85)+TPK%KR17(:)*PCONC(:,85)+TP&
&K%KR18(:)*PCONC(:,80)
!
!PPROD(WR_OP1) = +KTR20*<OP1>+KR18*<WR_MO2>*<WR_SO2>
 PPROD(:,86) = +TPK%KTR20(:)*PCONC(:,28)+TPK%KR18(:)*PCONC(:,85)*PCONC(:,80)
!PLOSS(WR_OP1) = +KTR40
 PLOSS(:,86) = +TPK%KTR40(:)
!
!PPROD(WR_ASO3) = +KR7*<WR_OH>*<WR_SO2>+KR16*<WR_NO3>*<WR_SO2>+KR18*<WR_MO2>*<W
!R_SO2>
 PPROD(:,87) = +TPK%KR7(:)*PCONC(:,77)*PCONC(:,80)+TPK%KR16(:)*PCONC(:,71)*PCON&
&C(:,80)+TPK%KR18(:)*PCONC(:,85)*PCONC(:,80)
!PLOSS(WR_ASO3) = +KR24*<W_O2>
 PLOSS(:,87) = +TPK%KR24(:)*TPK%W_O2(:)
!
!PPROD(WR_ASO4) = +KR15*<WR_NO3>*<WR_SULF>+KR26*<WR_ASO5>*<WR_ASO5>+KR26*<WR_AS
!O5>*<WR_ASO5>
 PPROD(:,88) = +TPK%KR15(:)*PCONC(:,71)*PCONC(:,81)+TPK%KR26(:)*PCONC(:,89)*PCO&
&NC(:,89)+TPK%KR26(:)*PCONC(:,89)*PCONC(:,89)
!PLOSS(WR_ASO4) = +KR28
 PLOSS(:,88) = +TPK%KR28(:)
!
!PPROD(WR_ASO5) = +KR24*<WR_ASO3>*<W_O2>
 PPROD(:,89) = +TPK%KR24(:)*PCONC(:,87)*TPK%W_O2(:)
!PLOSS(WR_ASO5) = +KR25*<WR_HO2>+KR26*<WR_ASO5>+KR26*<WR_ASO5>
 PLOSS(:,89) = +TPK%KR25(:)*PCONC(:,78)+TPK%KR26(:)*PCONC(:,89)+TPK%KR26(:)*PCO&
&NC(:,89)
!
!PPROD(WR_AHSO5) = +KR25*<WR_ASO5>*<WR_HO2>
 PPROD(:,90) = +TPK%KR25(:)*PCONC(:,89)*PCONC(:,78)
!PLOSS(WR_AHSO5) = +KR27*<WR_SO2>
 PLOSS(:,90) = +TPK%KR27(:)*PCONC(:,80)
!
RETURN
END SUBROUTINE SUB8
!
SUBROUTINE SUB9
!
!Indices 91 a 91
!
!
!PPROD(WR_AHMS) = +KR21*<WR_SO2>*<WR_HCHO>
 PPROD(:,91) = +TPK%KR21(:)*PCONC(:,80)*PCONC(:,82)
!PLOSS(WR_AHMS) = +KR22+KR23*<WR_OH>
 PLOSS(:,91) = +TPK%KR22(:)+TPK%KR23(:)*PCONC(:,77)
!
RETURN
END SUBROUTINE SUB9
!
END SUBROUTINE CH_PRODLOSS_AQ
!
!
!========================================================================
!
!!    ##########################
      MODULE MODI_CH_PRODLOSS_GAZ
!!    ##########################
INTERFACE
SUBROUTINE CH_PRODLOSS_GAZ(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                          :: PTIME
INTEGER, INTENT(IN)                          :: KVECNPT
INTEGER, INTENT(IN)                          :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ) :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ) :: PPROD, PLOSS
INTEGER, INTENT(IN)                          :: KMI
END SUBROUTINE CH_PRODLOSS_GAZ
END INTERFACE
END MODULE MODI_CH_PRODLOSS_GAZ
!
!========================================================================
!
!!    ##################################################################
      SUBROUTINE CH_PRODLOSS_GAZ(PTIME,PCONC,PPROD,PLOSS,KMI,KVECNPT,KEQ)
!!    ##################################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_PRODLOSS*
!!
!!    PURPOSE
!!    -------
!       calculation of production and loss terms for diagnostics
!!
!!**  METHOD
!!    ------
!!      The terms of temporal derivative of the chemical species,
!!    written as:
!!    d/dt PCONC = CH_FCN = PPROD - PCONC*PLOSS,
!!    are calculated for diagnostic purposes.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                      :: PTIME
INTEGER, INTENT(IN)                      :: KVECNPT
INTEGER, INTENT(IN)                      :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ)     :: PPROD, PLOSS
INTEGER, INTENT(IN)                          :: KMI
TYPE(CCSTYPE), POINTER         :: TPK
TPK=>TACCS(KMI)
! /BEGIN_CODE/
TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
   &TPK%K022(:)*TPK%H2O(:))
TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
    &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
    &0.00000*TPK%K079(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
    &0.09000*TPK%K080(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
   &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
   &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K054(:)*PCONC(:,JP_BIO)+&
   &TPK%K055(:)*PCONC(:,JP_CARBO))
! /END_CODE/
CALL SUB0
CALL SUB1
CALL SUB2
CALL SUB3
CALL SUB4

CONTAINS

SUBROUTINE SUB0
!
!Indices 1 a 10
!
!
!PPROD(O3) = +K018*<O3P>*<O2>+0.17307*K0102*<CARBOP>*<HO2>
 PPROD(:,1) = +TPK%K018(:)*TPK%O3P(:)*TPK%O2(:)+0.17307*TPK%K0102(:)*PCONC(:,39&
&)*PCONC(:,15)
!PLOSS(O3) = +K002+K003+K019*<O3P>+K023*<OH>+K024*<HO2>+K042*<NO>+K043*<NO2>+K0
!79*<ALKE>+K080*<BIO>+K081*<CARBO>+K082*<PAN>+K087*<ADD>
 PLOSS(:,1) = +TPK%K002(:)+TPK%K003(:)+TPK%K019(:)*TPK%O3P(:)+TPK%K023(:)*PCONC&
&(:,14)+TPK%K024(:)*PCONC(:,15)+TPK%K042(:)*PCONC(:,3)+TPK%K043(:)*PCONC(:,4)+T&
&PK%K079(:)*PCONC(:,19)+TPK%K080(:)*PCONC(:,20)+TPK%K081(:)*PCONC(:,25)+TPK%K08&
&2(:)*PCONC(:,27)+TPK%K087(:)*PCONC(:,37)
!
!PPROD(H2O2) = +K027*<HO2>*<HO2>+K028*<HO2>*<HO2>*<H2O>+0.01833*K079*<ALKE>*<O3
!>+0.00100*K080*<BIO>*<O3>
 PPROD(:,2) = +TPK%K027(:)*PCONC(:,15)*PCONC(:,15)+TPK%K028(:)*PCONC(:,15)*PCON&
&C(:,15)*TPK%H2O(:)+0.01833*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.00100*TPK%K080&
&(:)*PCONC(:,20)*PCONC(:,1)
!PLOSS(H2O2) = +K009+K026*<OH>
 PLOSS(:,2) = +TPK%K009(:)+TPK%K026(:)*PCONC(:,14)
!
!PPROD(NO) = +K001*<NO2>+K004*<HONO>+K007*<NO3>+K030*<O3P>*<NO2>+K046*<NO3>*<NO
!2>
 PPROD(:,3) = +TPK%K001(:)*PCONC(:,4)+TPK%K004(:)*PCONC(:,7)+TPK%K007(:)*PCONC(&
&:,5)+TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)+TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!PLOSS(NO) = +K029*<O3P>+K032*<OH>+K035*<HO2>+K042*<O3>+K044*<NO>*<O2>+K044*<NO
!>*<O2>+K045*<NO3>+K090*<MO2>+K091*<ALKAP>+K092*<ALKEP>+K093*<BIOP>+K094*<AROP>
!+K095*<CARBOP>+K096*<OLN>+K130*<XO2>
 PLOSS(:,3) = +TPK%K029(:)*TPK%O3P(:)+TPK%K032(:)*PCONC(:,14)+TPK%K035(:)*PCONC&
&(:,15)+TPK%K042(:)*PCONC(:,1)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCO&
&NC(:,3)*TPK%O2(:)+TPK%K045(:)*PCONC(:,5)+TPK%K090(:)*PCONC(:,32)+TPK%K091(:)*P&
&CONC(:,33)+TPK%K092(:)*PCONC(:,34)+TPK%K093(:)*PCONC(:,35)+TPK%K094(:)*PCONC(:&
&,38)+TPK%K095(:)*PCONC(:,39)+TPK%K096(:)*PCONC(:,40)+TPK%K130(:)*PCONC(:,41)
!
!PPROD(NO2) = +K005*<HNO3>+0.65*K006*<HNO4>+K008*<NO3>+K017*<ONIT>+K029*<O3P>*<
!NO>+K034*<OH>*<NO3>+K035*<HO2>*<NO>+K037*<HNO4>+0.7*K038*<HO2>*<NO3>+K039*<OH>
!*<HONO>+K041*<OH>*<HNO4>+K042*<O3>*<NO>+K044*<NO>*<NO>*<O2>+K044*<NO>*<NO>*<O2
!>+K045*<NO3>*<NO>+K045*<NO3>*<NO>+K046*<NO3>*<NO2>+K048*<N2O5>+K049*<NO3>*<NO3
!>+K049*<NO3>*<NO3>+K071*<ONIT>*<OH>+0.10530*K074*<CARBO>*<NO3>+0.40*K078*<PAN>
!*<NO3>+0.70*K082*<PAN>*<O3>+K089*<PAN>+K090*<MO2>*<NO>+0.91541*K091*<ALKAP>*<N
!O>+K092*<ALKEP>*<NO>+0.84700*K093*<BIOP>*<NO>+0.95115*K094*<AROP>*<NO>+K095*<C
!ARBOP>*<NO>+1.81599*K096*<OLN>*<NO>+0.32440*K110*<OLN>*<MO2>+0.00000*K116*<OLN
!>*<CARBOP>+0.00000*K118*<OLN>*<OLN>+K119*<MO2>*<NO3>+K120*<ALKAP>*<NO3>+K121*<
!ALKEP>*<NO3>+K122*<BIOP>*<NO3>+K123*<AROP>*<NO3>+K124*<CARBOP>*<NO3>+1.74072*K
!125*<OLN>*<NO3>+K130*<XO2>*<NO>+K131*<XO2>*<NO3>
 PPROD(:,4) = +TPK%K005(:)*PCONC(:,8)+0.65*TPK%K006(:)*PCONC(:,9)+TPK%K008(:)*P&
&CONC(:,5)+TPK%K017(:)*PCONC(:,26)+TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)+TPK%K034(:&
&)*PCONC(:,14)*PCONC(:,5)+TPK%K035(:)*PCONC(:,15)*PCONC(:,3)+TPK%K037(:)*PCONC(&
&:,9)+0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)+TPK%K039(:)*PCONC(:,14)*PCONC(:,7)&
&+TPK%K041(:)*PCONC(:,14)*PCONC(:,9)+TPK%K042(:)*PCONC(:,1)*PCONC(:,3)+TPK%K044&
&(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:&
&)+TPK%K045(:)*PCONC(:,5)*PCONC(:,3)+TPK%K045(:)*PCONC(:,5)*PCONC(:,3)+TPK%K046&
&(:)*PCONC(:,5)*PCONC(:,4)+TPK%K048(:)*PCONC(:,6)+TPK%K049(:)*PCONC(:,5)*PCONC(&
&:,5)+TPK%K049(:)*PCONC(:,5)*PCONC(:,5)+TPK%K071(:)*PCONC(:,26)*PCONC(:,14)+0.1&
&0530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5&
&)+0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK%K089(:)*PCONC(:,27)+TPK%K090(:)*&
&PCONC(:,32)*PCONC(:,3)+0.91541*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+TPK%K092(:)*&
&PCONC(:,34)*PCONC(:,3)+0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.95115*TPK%&
&K094(:)*PCONC(:,38)*PCONC(:,3)+TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+1.81599*TPK%&
&K096(:)*PCONC(:,40)*PCONC(:,3)+0.32440*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)+0.0&
&0000*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC&
&(:,40)+TPK%K119(:)*PCONC(:,32)*PCONC(:,5)+TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+T&
&PK%K121(:)*PCONC(:,34)*PCONC(:,5)+TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+TPK%K123(&
&:)*PCONC(:,38)*PCONC(:,5)+TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+1.74072*TPK%K125(&
&:)*PCONC(:,40)*PCONC(:,5)+TPK%K130(:)*PCONC(:,41)*PCONC(:,3)+TPK%K131(:)*PCONC&
&(:,41)*PCONC(:,5)
!PLOSS(NO2) = +K001+K030*<O3P>+K031*<O3P>+K033*<OH>+K036*<HO2>+K043*<O3>+K046*<
!NO3>+K047*<NO3>+K083*<PHO>+K085*<ADD>+K088*<CARBOP>
 PLOSS(:,4) = +TPK%K001(:)+TPK%K030(:)*TPK%O3P(:)+TPK%K031(:)*TPK%O3P(:)+TPK%K0&
&33(:)*PCONC(:,14)+TPK%K036(:)*PCONC(:,15)+TPK%K043(:)*PCONC(:,1)+TPK%K046(:)*P&
&CONC(:,5)+TPK%K047(:)*PCONC(:,5)+TPK%K083(:)*PCONC(:,36)+TPK%K085(:)*PCONC(:,3&
&7)+TPK%K088(:)*PCONC(:,39)
!
!PPROD(NO3) = +0.35*K006*<HNO4>+K031*<O3P>*<NO2>+K040*<OH>*<HNO3>+K043*<O3>*<NO
!2>+K048*<N2O5>+0.71893*K070*<PAN>*<OH>+0.60*K078*<PAN>*<NO3>
 PPROD(:,5) = +0.35*TPK%K006(:)*PCONC(:,9)+TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)+TP&
&K%K040(:)*PCONC(:,14)*PCONC(:,8)+TPK%K043(:)*PCONC(:,1)*PCONC(:,4)+TPK%K048(:)&
&*PCONC(:,6)+0.71893*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)+0.60*TPK%K078(:)*PCONC&
&(:,27)*PCONC(:,5)
!PLOSS(NO3) = +K007+K008+K034*<OH>+K038*<HO2>+K045*<NO>+K046*<NO2>+K047*<NO2>+K
!049*<NO3>+K049*<NO3>+K072*<HCHO>+K073*<ALD>+K074*<CARBO>+K075*<ARO>+K076*<ALKE
!>+K077*<BIO>+K078*<PAN>+K119*<MO2>+K120*<ALKAP>+K121*<ALKEP>+K122*<BIOP>+K123*
!<AROP>+K124*<CARBOP>+K125*<OLN>+K131*<XO2>
 PLOSS(:,5) = +TPK%K007(:)+TPK%K008(:)+TPK%K034(:)*PCONC(:,14)+TPK%K038(:)*PCON&
&C(:,15)+TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)+TPK%K047(:)*PCONC(:,4)+T&
&PK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:,5)+TPK%K072(:)*PCONC(:,22)+TPK%K073(&
&:)*PCONC(:,23)+TPK%K074(:)*PCONC(:,25)+TPK%K075(:)*PCONC(:,21)+TPK%K076(:)*PCO&
&NC(:,19)+TPK%K077(:)*PCONC(:,20)+TPK%K078(:)*PCONC(:,27)+TPK%K119(:)*PCONC(:,3&
&2)+TPK%K120(:)*PCONC(:,33)+TPK%K121(:)*PCONC(:,34)+TPK%K122(:)*PCONC(:,35)+TPK&
&%K123(:)*PCONC(:,38)+TPK%K124(:)*PCONC(:,39)+TPK%K125(:)*PCONC(:,40)+TPK%K131(&
&:)*PCONC(:,41)
!
!PPROD(N2O5) = +K047*<NO3>*<NO2>
 PPROD(:,6) = +TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!PLOSS(N2O5) = +K048
 PLOSS(:,6) = +TPK%K048(:)
!
!PPROD(HONO) = +K032*<OH>*<NO>+K085*<ADD>*<NO2>
 PPROD(:,7) = +TPK%K032(:)*PCONC(:,14)*PCONC(:,3)+TPK%K085(:)*PCONC(:,37)*PCONC&
&(:,4)
!PLOSS(HONO) = +K004+K039*<OH>
 PLOSS(:,7) = +TPK%K004(:)+TPK%K039(:)*PCONC(:,14)
!
!PPROD(HNO3) = +K033*<OH>*<NO2>+0.3*K038*<HO2>*<NO3>+K072*<HCHO>*<NO3>+K073*<AL
!D>*<NO3>+0.91567*K074*<CARBO>*<NO3>+K075*<ARO>*<NO3>
 PPROD(:,8) = +TPK%K033(:)*PCONC(:,14)*PCONC(:,4)+0.3*TPK%K038(:)*PCONC(:,15)*P&
&CONC(:,5)+TPK%K072(:)*PCONC(:,22)*PCONC(:,5)+TPK%K073(:)*PCONC(:,23)*PCONC(:,5&
&)+0.91567*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+TPK%K075(:)*PCONC(:,21)*PCONC(:,5&
&)
!PLOSS(HNO3) = +K005+K040*<OH>
 PLOSS(:,8) = +TPK%K005(:)+TPK%K040(:)*PCONC(:,14)
!
!PPROD(HNO4) = +K036*<HO2>*<NO2>
 PPROD(:,9) = +TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!PLOSS(HNO4) = +K006+K037+K041*<OH>
 PLOSS(:,9) = +TPK%K006(:)+TPK%K037(:)+TPK%K041(:)*PCONC(:,14)
!
!PPROD(NH3) = 0.0
 PPROD(:,10) = 0.0
!PLOSS(NH3) = +K050*<OH>
 PLOSS(:,10) = +TPK%K050(:)*PCONC(:,14)
!
RETURN
END SUBROUTINE SUB0
!
SUBROUTINE SUB1
!
!Indices 11 a 20
!
!
!PPROD(SO2) = 0.0
 PPROD(:,11) = 0.0
!PLOSS(SO2) = +K052*<OH>
 PLOSS(:,11) = +TPK%K052(:)*PCONC(:,14)
!
!PPROD(SULF) = +K052*<OH>*<SO2>
 PPROD(:,12) = +TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!PLOSS(SULF) = +K132
 PLOSS(:,12) = +TPK%K132(:)
!
!PPROD(CO) = +K010*<HCHO>+K011*<HCHO>+K012*<ALD>+0.91924*K016*<CARBO>+0.01*K054
!*<BIO>*<O3P>+0.00878*K058*<ALKA>*<OH>+K062*<HCHO>*<OH>+1.01732*K065*<CARBO>*<O
!H>+K072*<HCHO>*<NO3>+1.33723*K074*<CARBO>*<NO3>+0.35120*K079*<ALKE>*<O3>+0.360
!00*K080*<BIO>*<O3>+0.64728*K081*<CARBO>*<O3>+0.13*K082*<PAN>*<O3>
 PPROD(:,13) = +TPK%K010(:)*PCONC(:,22)+TPK%K011(:)*PCONC(:,22)+TPK%K012(:)*PCO&
&NC(:,23)+0.91924*TPK%K016(:)*PCONC(:,25)+0.01*TPK%K054(:)*PCONC(:,20)*TPK%O3P(&
&:)+0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+TPK%K062(:)*PCONC(:,22)*PCONC(:&
&,14)+1.01732*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+TPK%K072(:)*PCONC(:,22)*PCONC&
&(:,5)+1.33723*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.35120*TPK%K079(:)*PCONC(:,1&
&9)*PCONC(:,1)+0.36000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.64728*TPK%K081(:)*P&
&CONC(:,25)*PCONC(:,1)+0.13*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!PLOSS(CO) = +K053*<OH>
 PLOSS(:,13) = +TPK%K053(:)*PCONC(:,14)
!
!PPROD(OH) = +K004*<HONO>+K005*<HNO3>+0.35*K006*<HNO4>+K009*<H2O2>+K009*<H2O2>+
!K013*<OP1>+K014*<OP2>+K022*<O1D>*<H2O>+K022*<O1D>*<H2O>+K024*<O3>*<HO2>+K035*<
!HO2>*<NO>+0.7*K038*<HO2>*<NO3>+0.02*K054*<BIO>*<O3P>+0.00878*K058*<ALKA>*<OH>+
!0.35*K068*<OP1>*<OH>+0.44925*K069*<OP2>*<OH>+0.39435*K079*<ALKE>*<O3>+0.28000*
!K080*<BIO>*<O3>+0.20595*K081*<CARBO>*<O3>+0.036*K082*<PAN>*<O3>+K087*<ADD>*<O3
!>
 PPROD(:,14) = +TPK%K004(:)*PCONC(:,7)+TPK%K005(:)*PCONC(:,8)+0.35*TPK%K006(:)*&
&PCONC(:,9)+TPK%K009(:)*PCONC(:,2)+TPK%K009(:)*PCONC(:,2)+TPK%K013(:)*PCONC(:,2&
&8)+TPK%K014(:)*PCONC(:,29)+TPK%K022(:)*TPK%O1D(:)*TPK%H2O(:)+TPK%K022(:)*TPK%O&
&1D(:)*TPK%H2O(:)+TPK%K024(:)*PCONC(:,1)*PCONC(:,15)+TPK%K035(:)*PCONC(:,15)*PC&
&ONC(:,3)+0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)+0.02*TPK%K054(:)*PCONC(:,20)*T&
&PK%O3P(:)+0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0.35*TPK%K068(:)*PCONC(:&
&,28)*PCONC(:,14)+0.44925*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)+0.39435*TPK%K079(&
&:)*PCONC(:,19)*PCONC(:,1)+0.28000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.20595*T&
&PK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.036*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK&
&%K087(:)*PCONC(:,37)*PCONC(:,1)
!PLOSS(OH) = +K023*<O3>+K025*<HO2>+K026*<H2O2>+K032*<NO>+K033*<NO2>+K034*<NO3>+
!K039*<HONO>+K040*<HNO3>+K041*<HNO4>+K050*<NH3>+K051*<H2>+K052*<SO2>+K053*<CO>+
!K056*<CH4>+K057*<ETH>+K058*<ALKA>+K059*<ALKE>+K060*<BIO>+K061*<ARO>+K062*<HCHO
!>+K063*<ALD>+K064*<KET>+K065*<CARBO>+K066*<ORA1>+K067*<ORA2>+K068*<OP1>+K069*<
!OP2>+K070*<PAN>+K071*<ONIT>
 PLOSS(:,14) = +TPK%K023(:)*PCONC(:,1)+TPK%K025(:)*PCONC(:,15)+TPK%K026(:)*PCON&
&C(:,2)+TPK%K032(:)*PCONC(:,3)+TPK%K033(:)*PCONC(:,4)+TPK%K034(:)*PCONC(:,5)+TP&
&K%K039(:)*PCONC(:,7)+TPK%K040(:)*PCONC(:,8)+TPK%K041(:)*PCONC(:,9)+TPK%K050(:)&
&*PCONC(:,10)+TPK%K051(:)*TPK%H2(:)+TPK%K052(:)*PCONC(:,11)+TPK%K053(:)*PCONC(:&
&,13)+TPK%K056(:)*PCONC(:,16)+TPK%K057(:)*PCONC(:,17)+TPK%K058(:)*PCONC(:,18)+T&
&PK%K059(:)*PCONC(:,19)+TPK%K060(:)*PCONC(:,20)+TPK%K061(:)*PCONC(:,21)+TPK%K06&
&2(:)*PCONC(:,22)+TPK%K063(:)*PCONC(:,23)+TPK%K064(:)*PCONC(:,24)+TPK%K065(:)*P&
&CONC(:,25)+TPK%K066(:)*PCONC(:,30)+TPK%K067(:)*PCONC(:,31)+TPK%K068(:)*PCONC(:&
&,28)+TPK%K069(:)*PCONC(:,29)+TPK%K070(:)*PCONC(:,27)+TPK%K071(:)*PCONC(:,26)
!
!PPROD(HO2) = +0.65*K006*<HNO4>+K011*<HCHO>+K011*<HCHO>+K012*<ALD>+K013*<OP1>+0
!.96205*K014*<OP2>+0.75830*K016*<CARBO>+K017*<ONIT>+K023*<O3>*<OH>+K026*<H2O2>*
!<OH>+K034*<OH>*<NO3>+K037*<HNO4>+K051*<OH>*<H2>+K052*<OH>*<SO2>+K053*<CO>*<OH>
!+0.28*K054*<BIO>*<O3P>+0.12793*K058*<ALKA>*<OH>+0.10318*K061*<ARO>*<OH>+K062*<
!HCHO>*<OH>+0.51208*K065*<CARBO>*<OH>+K066*<ORA1>*<OH>+0.02915*K069*<OP2>*<OH>+
!0.28107*K070*<PAN>*<OH>+K072*<HCHO>*<NO3>+0.63217*K074*<CARBO>*<NO3>+0.23451*K
!079*<ALKE>*<O3>+0.30000*K080*<BIO>*<O3>+0.28441*K081*<CARBO>*<O3>+0.08*K082*<P
!AN>*<O3>+0.02*K086*<ADD>*<O2>+K090*<MO2>*<NO>+0.74265*K091*<ALKAP>*<NO>+K092*<
!ALKEP>*<NO>+0.84700*K093*<BIOP>*<NO>+0.95115*K094*<AROP>*<NO>+0.12334*K095*<CA
!RBOP>*<NO>+0.18401*K096*<OLN>*<NO>+0.66*K104*<MO2>*<MO2>+0.98383*K105*<ALKAP>*
!<MO2>+K106*<ALKEP>*<MO2>+1.00000*K107*<BIOP>*<MO2>+1.02767*K108*<AROP>*<MO2>+0
!.82998*K109*<CARBOP>*<MO2>+0.67560*K110*<OLN>*<MO2>+0.48079*K111*<ALKAP>*<CARB
!OP>+0.50078*K112*<ALKEP>*<CARBOP>+0.50600*K113*<BIOP>*<CARBOP>+K114*<AROP>*<CA
!RBOP>+0.07566*K115*<CARBOP>*<CARBOP>+0.17599*K116*<OLN>*<CARBOP>+K117*<OLN>*<O
!LN>+0.00000*K118*<OLN>*<OLN>+K119*<MO2>*<NO3>+0.81290*K120*<ALKAP>*<NO3>+K121*
!<ALKEP>*<NO3>+K122*<BIOP>*<NO3>+K123*<AROP>*<NO3>+0.04915*K124*<CARBOP>*<NO3>+
!0.25928*K125*<OLN>*<NO3>+K127*<XO2>*<MO2>
 PPROD(:,15) = +0.65*TPK%K006(:)*PCONC(:,9)+TPK%K011(:)*PCONC(:,22)+TPK%K011(:)&
&*PCONC(:,22)+TPK%K012(:)*PCONC(:,23)+TPK%K013(:)*PCONC(:,28)+0.96205*TPK%K014(&
&:)*PCONC(:,29)+0.75830*TPK%K016(:)*PCONC(:,25)+TPK%K017(:)*PCONC(:,26)+TPK%K02&
&3(:)*PCONC(:,1)*PCONC(:,14)+TPK%K026(:)*PCONC(:,2)*PCONC(:,14)+TPK%K034(:)*PCO&
&NC(:,14)*PCONC(:,5)+TPK%K037(:)*PCONC(:,9)+TPK%K051(:)*PCONC(:,14)*TPK%H2(:)+T&
&PK%K052(:)*PCONC(:,14)*PCONC(:,11)+TPK%K053(:)*PCONC(:,13)*PCONC(:,14)+0.28*TP&
&K%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.12793*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0&
&.10318*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)+TPK%K062(:)*PCONC(:,22)*PCONC(:,14)&
&+0.51208*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+TPK%K066(:)*PCONC(:,30)*PCONC(:,1&
&4)+0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)+0.28107*TPK%K070(:)*PCONC(:,27)&
&*PCONC(:,14)+TPK%K072(:)*PCONC(:,22)*PCONC(:,5)+0.63217*TPK%K074(:)*PCONC(:,25&
&)*PCONC(:,5)+0.23451*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.30000*TPK%K080(:)*PC&
&ONC(:,20)*PCONC(:,1)+0.28441*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.08*TPK%K082(&
&:)*PCONC(:,27)*PCONC(:,1)+0.02*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)+TPK%K090(:)*P&
&CONC(:,32)*PCONC(:,3)+0.74265*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+TPK%K092(:)*P&
&CONC(:,34)*PCONC(:,3)+0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.95115*TPK%K&
&094(:)*PCONC(:,38)*PCONC(:,3)+0.12334*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.184&
&01*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)+0.66*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)&
&+0.98383*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+TPK%K106(:)*PCONC(:,34)*PCONC(:,3&
&2)+1.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+1.02767*TPK%K108(:)*PCONC(:,38)&
&*PCONC(:,32)+0.82998*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)+0.67560*TPK%K110(:)*P&
&CONC(:,40)*PCONC(:,32)+0.48079*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.50078*TPK&
&%K112(:)*PCONC(:,34)*PCONC(:,39)+0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+T&
&PK%K114(:)*PCONC(:,38)*PCONC(:,39)+0.07566*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)&
&+0.17599*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+TPK%K117(:)*PCONC(:,40)*PCONC(:,4&
&0)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)+TPK%K119(:)*PCONC(:,32)*PCONC(:&
&,5)+0.81290*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+TPK%K121(:)*PCONC(:,34)*PCONC(:&
&,5)+TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+TPK%K123(:)*PCONC(:,38)*PCONC(:,5)+0.04&
&915*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:&
&,5)+TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!PLOSS(HO2) = +K024*<O3>+K025*<OH>+K027*<HO2>+K027*<HO2>+K028*<HO2>*<H2O>+K028*
!<HO2>*<H2O>+K035*<NO>+K036*<NO2>+K038*<NO3>+K084*<PHO>+K097*<MO2>+K098*<ALKAP>
!+K099*<ALKEP>+K0100*<BIOP>+K0101*<AROP>+K0102*<CARBOP>+K103*<OLN>+K126*<XO2>
 PLOSS(:,15) = +TPK%K024(:)*PCONC(:,1)+TPK%K025(:)*PCONC(:,14)+TPK%K027(:)*PCON&
&C(:,15)+TPK%K027(:)*PCONC(:,15)+TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)+TPK%K028(:)&
&*PCONC(:,15)*TPK%H2O(:)+TPK%K035(:)*PCONC(:,3)+TPK%K036(:)*PCONC(:,4)+TPK%K038&
&(:)*PCONC(:,5)+TPK%K084(:)*PCONC(:,36)+TPK%K097(:)*PCONC(:,32)+TPK%K098(:)*PCO&
&NC(:,33)+TPK%K099(:)*PCONC(:,34)+TPK%K0100(:)*PCONC(:,35)+TPK%K0101(:)*PCONC(:&
&,38)+TPK%K0102(:)*PCONC(:,39)+TPK%K103(:)*PCONC(:,40)+TPK%K126(:)*PCONC(:,41)
!
!PPROD(CH4) = +0.04300*K079*<ALKE>*<O3>
 PPROD(:,16) = +0.04300*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!PLOSS(CH4) = +K056*<OH>
 PLOSS(:,16) = +TPK%K056(:)*PCONC(:,14)
!
!PPROD(ETH) = +0.03196*K079*<ALKE>*<O3>
 PPROD(:,17) = +0.03196*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!PLOSS(ETH) = +K057*<OH>
 PLOSS(:,17) = +TPK%K057(:)*PCONC(:,14)
!
!PPROD(ALKA) = 0.0
 PPROD(:,18) = 0.0
!PLOSS(ALKA) = +K058*<OH>
 PLOSS(:,18) = +TPK%K058(:)*PCONC(:,14)
!
!PPROD(ALKE) = +0.91868*K054*<BIO>*<O3P>+0.00000*K079*<ALKE>*<O3>+0.37388*K080*
!<BIO>*<O3>+0.37815*K093*<BIOP>*<NO>+0.48074*K107*<BIOP>*<MO2>+0.24463*K113*<BI
!OP>*<CARBOP>+0.42729*K122*<BIOP>*<NO3>
 PPROD(:,19) = +0.91868*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.00000*TPK%K079(:)*&
&PCONC(:,19)*PCONC(:,1)+0.37388*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.37815*TPK%&
&K093(:)*PCONC(:,35)*PCONC(:,3)+0.48074*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+0.2&
&4463*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.42729*TPK%K122(:)*PCONC(:,35)*PCONC&
&(:,5)
!PLOSS(ALKE) = +K059*<OH>+K076*<NO3>+K079*<O3>
 PLOSS(:,19) = +TPK%K059(:)*PCONC(:,14)+TPK%K076(:)*PCONC(:,5)+TPK%K079(:)*PCON&
&C(:,1)
!
!PPROD(BIO) = 0.0
 PPROD(:,20) = 0.0
!PLOSS(BIO) = +K054*<O3P>+K060*<OH>+K077*<NO3>+K080*<O3>
 PLOSS(:,20) = +TPK%K054(:)*TPK%O3P(:)+TPK%K060(:)*PCONC(:,14)+TPK%K077(:)*PCON&
&C(:,5)+TPK%K080(:)*PCONC(:,1)
!
RETURN
END SUBROUTINE SUB1
!
SUBROUTINE SUB2
!
!Indices 21 a 30
!
!
!PPROD(ARO) = +0.10670*K083*<PHO>*<NO2>+1.06698*K084*<PHO>*<HO2>+K085*<ADD>*<NO
!2>+0.02*K086*<ADD>*<O2>+K087*<ADD>*<O3>
 PPROD(:,21) = +0.10670*TPK%K083(:)*PCONC(:,36)*PCONC(:,4)+1.06698*TPK%K084(:)*&
&PCONC(:,36)*PCONC(:,15)+TPK%K085(:)*PCONC(:,37)*PCONC(:,4)+0.02*TPK%K086(:)*PC&
&ONC(:,37)*TPK%O2(:)+TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!PLOSS(ARO) = +K061*<OH>+K075*<NO3>
 PLOSS(:,21) = +TPK%K061(:)*PCONC(:,14)+TPK%K075(:)*PCONC(:,5)
!
!PPROD(HCHO) = +K013*<OP1>+0.06517*K016*<CARBO>+0.05*K054*<BIO>*<O3P>+0.00140*K
!058*<ALKA>*<OH>+0.00000*K065*<CARBO>*<OH>+0.35*K068*<OP1>*<OH>+0.02915*K069*<O
!P2>*<OH>+0.57839*K070*<PAN>*<OH>+0.40*K078*<PAN>*<NO3>+0.48290*K079*<ALKE>*<O3
!>+0.90000*K080*<BIO>*<O3>+0.00000*K081*<CARBO>*<O3>+0.70*K082*<PAN>*<O3>+K090*
!<MO2>*<NO>+0.03002*K091*<ALKAP>*<NO>+1.39870*K092*<ALKEP>*<NO>+0.60600*K093*<B
!IOP>*<NO>+0.05848*K095*<CARBOP>*<NO>+0.23419*K096*<OLN>*<NO>+1.33*K104*<MO2>*<
!MO2>+0.80556*K105*<ALKAP>*<MO2>+1.42894*K106*<ALKEP>*<MO2>+1.09000*K107*<BIOP>
!*<MO2>+K108*<AROP>*<MO2>+0.95723*K109*<CARBOP>*<MO2>+0.88625*K110*<OLN>*<MO2>+
!0.07600*K111*<ALKAP>*<CARBOP>+0.68192*K112*<ALKEP>*<CARBOP>+0.34000*K113*<BIOP
!>*<CARBOP>+0.03432*K115*<CARBOP>*<CARBOP>+0.13414*K116*<OLN>*<CARBOP>+0.00000*
!K118*<OLN>*<OLN>+K119*<MO2>*<NO3>+0.03142*K120*<ALKAP>*<NO3>+1.40909*K121*<ALK
!EP>*<NO3>+0.68600*K122*<BIOP>*<NO3>+0.03175*K124*<CARBOP>*<NO3>+0.20740*K125*<
!OLN>*<NO3>+K127*<XO2>*<MO2>
 PPROD(:,22) = +TPK%K013(:)*PCONC(:,28)+0.06517*TPK%K016(:)*PCONC(:,25)+0.05*TP&
&K%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.00140*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0&
&.00000*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.35*TPK%K068(:)*PCONC(:,28)*PCONC(&
&:,14)+0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)+0.57839*TPK%K070(:)*PCONC(:,&
&27)*PCONC(:,14)+0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)+0.48290*TPK%K079(:)*PC&
&ONC(:,19)*PCONC(:,1)+0.90000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.00000*TPK%K0&
&81(:)*PCONC(:,25)*PCONC(:,1)+0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+TPK%K090(&
&:)*PCONC(:,32)*PCONC(:,3)+0.03002*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+1.39870*T&
&PK%K092(:)*PCONC(:,34)*PCONC(:,3)+0.60600*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0&
&.05848*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.23419*TPK%K096(:)*PCONC(:,40)*PCON&
&C(:,3)+1.33*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)+0.80556*TPK%K105(:)*PCONC(:,33&
&)*PCONC(:,32)+1.42894*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)+1.09000*TPK%K107(:)*&
&PCONC(:,35)*PCONC(:,32)+TPK%K108(:)*PCONC(:,38)*PCONC(:,32)+0.95723*TPK%K109(:&
&)*PCONC(:,39)*PCONC(:,32)+0.88625*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)+0.07600*&
&TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.68192*TPK%K112(:)*PCONC(:,34)*PCONC(:,39&
&)+0.34000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.03432*TPK%K115(:)*PCONC(:,39)*&
&PCONC(:,39)+0.13414*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.00000*TPK%K118(:)*PC&
&ONC(:,40)*PCONC(:,40)+TPK%K119(:)*PCONC(:,32)*PCONC(:,5)+0.03142*TPK%K120(:)*P&
&CONC(:,33)*PCONC(:,5)+1.40909*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)+0.68600*TPK%K&
&122(:)*PCONC(:,35)*PCONC(:,5)+0.03175*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+0.207&
&40*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)+TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!PLOSS(HCHO) = +K010+K011+K062*<OH>+K072*<NO3>
 PLOSS(:,22) = +TPK%K010(:)+TPK%K011(:)+TPK%K062(:)*PCONC(:,14)+TPK%K072(:)*PCO&
&NC(:,5)
!
!PPROD(ALD) = +0.96205*K014*<OP2>+0.20*K017*<ONIT>+K055*<CARBO>*<O3P>+0.08173*K
!058*<ALKA>*<OH>+0.06253*K065*<CARBO>*<OH>+0.07335*K069*<OP2>*<OH>+0.05265*K074
!*<CARBO>*<NO3>+0.51468*K079*<ALKE>*<O3>+0.00000*K080*<BIO>*<O3>+0.15692*K081*<
!CARBO>*<O3>+0.33144*K091*<ALKAP>*<NO>+0.42125*K092*<ALKEP>*<NO>+0.00000*K093*<
!BIOP>*<NO>+0.07368*K095*<CARBOP>*<NO>+1.01182*K096*<OLN>*<NO>+0.56070*K105*<AL
!KAP>*<MO2>+0.46413*K106*<ALKEP>*<MO2>+0.00000*K107*<BIOP>*<MO2>+0.08295*K109*<
!CARBOP>*<MO2>+0.41524*K110*<OLN>*<MO2>+0.71461*K111*<ALKAP>*<CARBOP>+0.68374*K
!112*<ALKEP>*<CARBOP>+0.00000*K113*<BIOP>*<CARBOP>+0.06969*K115*<CARBOP>*<CARBO
!P>+0.42122*K116*<OLN>*<CARBOP>+0.00000*K118*<OLN>*<OLN>+0.33743*K120*<ALKAP>*<
!NO3>+0.43039*K121*<ALKEP>*<NO3>+0.00000*K122*<BIOP>*<NO3>+0.02936*K124*<CARBOP
!>*<NO3>+0.91850*K125*<OLN>*<NO3>
 PPROD(:,23) = +0.96205*TPK%K014(:)*PCONC(:,29)+0.20*TPK%K017(:)*PCONC(:,26)+TP&
&K%K055(:)*PCONC(:,25)*TPK%O3P(:)+0.08173*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0&
&.06253*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.07335*TPK%K069(:)*PCONC(:,29)*PCO&
&NC(:,14)+0.05265*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.51468*TPK%K079(:)*PCONC(&
&:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.15692*TPK%K081(:&
&)*PCONC(:,25)*PCONC(:,1)+0.33144*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.42125*TP&
&K%K092(:)*PCONC(:,34)*PCONC(:,3)+0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.&
&07368*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+1.01182*TPK%K096(:)*PCONC(:,40)*PCONC&
&(:,3)+0.56070*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.46413*TPK%K106(:)*PCONC(:,&
&34)*PCONC(:,32)+0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+0.08295*TPK%K109(:&
&)*PCONC(:,39)*PCONC(:,32)+0.41524*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)+0.71461*&
&TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.68374*TPK%K112(:)*PCONC(:,34)*PCONC(:,39&
&)+0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.06969*TPK%K115(:)*PCONC(:,39)*&
&PCONC(:,39)+0.42122*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.00000*TPK%K118(:)*PC&
&ONC(:,40)*PCONC(:,40)+0.33743*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+0.43039*TPK%K&
&121(:)*PCONC(:,34)*PCONC(:,5)+0.00000*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+0.029&
&36*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+0.91850*TPK%K125(:)*PCONC(:,40)*PCONC(:,&
&5)
!PLOSS(ALD) = +K012+K063*<OH>+K073*<NO3>
 PLOSS(:,23) = +TPK%K012(:)+TPK%K063(:)*PCONC(:,14)+TPK%K073(:)*PCONC(:,5)
!
!PPROD(KET) = +0.80*K017*<ONIT>+0.03498*K058*<ALKA>*<OH>+0.00853*K065*<CARBO>*<
!OH>+0.37591*K069*<OP2>*<OH>+0.00632*K074*<CARBO>*<NO3>+0.07377*K079*<ALKE>*<O3
!>+0.00000*K080*<BIO>*<O3>+0.54531*K091*<ALKAP>*<NO>+0.05220*K092*<ALKEP>*<NO>+
!0.00000*K093*<BIOP>*<NO>+0.37862*K096*<OLN>*<NO>+0.09673*K105*<ALKAP>*<MO2>+0.
!03814*K106*<ALKEP>*<MO2>+0.00000*K107*<BIOP>*<MO2>+0.09667*K110*<OLN>*<MO2>+0.
!18819*K111*<ALKAP>*<CARBOP>+0.06579*K112*<ALKEP>*<CARBOP>+0.00000*K113*<BIOP>*
!<CARBOP>+0.02190*K115*<CARBOP>*<CARBOP>+0.10822*K116*<OLN>*<CARBOP>+0.00000*K1
!18*<OLN>*<OLN>+0.62978*K120*<ALKAP>*<NO3>+0.02051*K121*<ALKEP>*<NO3>+0.00000*K
!122*<BIOP>*<NO3>+0.34740*K125*<OLN>*<NO3>
 PPROD(:,24) = +0.80*TPK%K017(:)*PCONC(:,26)+0.03498*TPK%K058(:)*PCONC(:,18)*PC&
&ONC(:,14)+0.00853*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.37591*TPK%K069(:)*PCON&
&C(:,29)*PCONC(:,14)+0.00632*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.07377*TPK%K07&
&9(:)*PCONC(:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.54531&
&*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.05220*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)&
&+0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+0.37862*TPK%K096(:)*PCONC(:,40)*PC&
&ONC(:,3)+0.09673*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.03814*TPK%K106(:)*PCONC&
&(:,34)*PCONC(:,32)+0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)+0.09667*TPK%K11&
&0(:)*PCONC(:,40)*PCONC(:,32)+0.18819*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.065&
&79*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)+0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:&
&,39)+0.02190*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.10822*TPK%K116(:)*PCONC(:,4&
&0)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)+0.62978*TPK%K120(:)&
&*PCONC(:,33)*PCONC(:,5)+0.02051*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)+0.00000*TPK&
&%K122(:)*PCONC(:,35)*PCONC(:,5)+0.34740*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!PLOSS(KET) = +K015+K064*<OH>
 PLOSS(:,24) = +TPK%K015(:)+TPK%K064(:)*PCONC(:,14)
!
!PPROD(CARBO) = +0.13255*K054*<BIO>*<O3P>+0.00835*K058*<ALKA>*<OH>+0.16919*K065
!*<CARBO>*<OH>+0.21863*K070*<PAN>*<OH>+0.10530*K074*<CARBO>*<NO3>+0.00000*K076*
!<ALKE>*<NO3>+0.91741*K077*<BIO>*<NO3>+0.00000*K079*<ALKE>*<O3>+0.39754*K080*<B
!IO>*<O3>+1.07583*K081*<CARBO>*<O3>+0.03407*K091*<ALKAP>*<NO>+0.45463*K093*<BIO
!P>*<NO>+2.06993*K094*<AROP>*<NO>+0.08670*K095*<CARBOP>*<NO>+0.07976*K105*<ALKA
!P>*<MO2>+0.56064*K107*<BIOP>*<MO2>+1.99461*K108*<AROP>*<MO2>+0.15387*K109*<CAR
!BOP>*<MO2>+0.06954*K111*<ALKAP>*<CARBOP>+0.78591*K113*<BIOP>*<CARBOP>+1.99455*
!K114*<AROP>*<CARBOP>+0.10777*K115*<CARBOP>*<CARBOP>+0.03531*K120*<ALKAP>*<NO3>
!+0.61160*K122*<BIOP>*<NO3>+2.81904*K123*<AROP>*<NO3>+0.03455*K124*<CARBOP>*<NO
!3>
 PPROD(:,25) = +0.13255*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.00835*TPK%K058(:)*&
&PCONC(:,18)*PCONC(:,14)+0.16919*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.21863*TP&
&K%K070(:)*PCONC(:,27)*PCONC(:,14)+0.10530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0&
&.00000*TPK%K076(:)*PCONC(:,19)*PCONC(:,5)+0.91741*TPK%K077(:)*PCONC(:,20)*PCON&
&C(:,5)+0.00000*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.39754*TPK%K080(:)*PCONC(:,&
&20)*PCONC(:,1)+1.07583*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.03407*TPK%K091(:)*&
&PCONC(:,33)*PCONC(:,3)+0.45463*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)+2.06993*TPK%&
&K094(:)*PCONC(:,38)*PCONC(:,3)+0.08670*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.07&
&976*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.56064*TPK%K107(:)*PCONC(:,35)*PCONC(&
&:,32)+1.99461*TPK%K108(:)*PCONC(:,38)*PCONC(:,32)+0.15387*TPK%K109(:)*PCONC(:,&
&39)*PCONC(:,32)+0.06954*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.78591*TPK%K113(:&
&)*PCONC(:,35)*PCONC(:,39)+1.99455*TPK%K114(:)*PCONC(:,38)*PCONC(:,39)+0.10777*&
&TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.03531*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)&
&+0.61160*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)+2.81904*TPK%K123(:)*PCONC(:,38)*PC&
&ONC(:,5)+0.03455*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!PLOSS(CARBO) = +K016+K055*<O3P>+K065*<OH>+K074*<NO3>+K081*<O3>
 PLOSS(:,25) = +TPK%K016(:)+TPK%K055(:)*TPK%O3P(:)+TPK%K065(:)*PCONC(:,14)+TPK%&
&K074(:)*PCONC(:,5)+TPK%K081(:)*PCONC(:,1)
!
!PPROD(ONIT) = +0.60*K078*<PAN>*<NO3>+K083*<PHO>*<NO2>+0.08459*K091*<ALKAP>*<NO
!>+0.15300*K093*<BIOP>*<NO>+0.04885*K094*<AROP>*<NO>+0.18401*K096*<OLN>*<NO>+K1
!03*<OLN>*<HO2>+0.67560*K110*<OLN>*<MO2>+0.66562*K116*<OLN>*<CARBOP>+2.00*K117*
!<OLN>*<OLN>+0.00000*K118*<OLN>*<OLN>+0.25928*K125*<OLN>*<NO3>
 PPROD(:,26) = +0.60*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)+TPK%K083(:)*PCONC(:,36)&
&*PCONC(:,4)+0.08459*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.15300*TPK%K093(:)*PCO&
&NC(:,35)*PCONC(:,3)+0.04885*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)+0.18401*TPK%K09&
&6(:)*PCONC(:,40)*PCONC(:,3)+TPK%K103(:)*PCONC(:,40)*PCONC(:,15)+0.67560*TPK%K1&
&10(:)*PCONC(:,40)*PCONC(:,32)+0.66562*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+2.00&
&*TPK%K117(:)*PCONC(:,40)*PCONC(:,40)+0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,4&
&0)+0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!PLOSS(ONIT) = +K017+K071*<OH>
 PLOSS(:,26) = +TPK%K017(:)+TPK%K071(:)*PCONC(:,14)
!
!PPROD(PAN) = +0.28107*K070*<PAN>*<OH>+0.40000*K078*<PAN>*<NO3>+0.30000*K082*<P
!AN>*<O3>+1.00000*K088*<CARBOP>*<NO2>
 PPROD(:,27) = +0.28107*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)+0.40000*TPK%K078(:)&
&*PCONC(:,27)*PCONC(:,5)+0.30000*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+1.00000*TPK&
&%K088(:)*PCONC(:,39)*PCONC(:,4)
!PLOSS(PAN) = +K070*<OH>+K078*<NO3>+K082*<O3>+K089
 PLOSS(:,27) = +TPK%K070(:)*PCONC(:,14)+TPK%K078(:)*PCONC(:,5)+TPK%K082(:)*PCON&
&C(:,1)+TPK%K089(:)
!
!PPROD(OP1) = +K097*<MO2>*<HO2>
 PPROD(:,28) = +TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!PLOSS(OP1) = +K013+K068*<OH>
 PLOSS(:,28) = +TPK%K013(:)+TPK%K068(:)*PCONC(:,14)
!
!PPROD(OP2) = +0.10149*K081*<CARBO>*<O3>+1.00524*K098*<ALKAP>*<HO2>+1.00524*K09
!9*<ALKEP>*<HO2>+1.00524*K0100*<BIOP>*<HO2>+1.00524*K0101*<AROP>*<HO2>+0.80904*
!K0102*<CARBOP>*<HO2>+1.00524*K126*<XO2>*<HO2>
 PPROD(:,29) = +0.10149*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+1.00524*TPK%K098(:)*&
&PCONC(:,33)*PCONC(:,15)+1.00524*TPK%K099(:)*PCONC(:,34)*PCONC(:,15)+1.00524*TP&
&K%K0100(:)*PCONC(:,35)*PCONC(:,15)+1.00524*TPK%K0101(:)*PCONC(:,38)*PCONC(:,15&
&)+0.80904*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)+1.00524*TPK%K126(:)*PCONC(:,41)&
&*PCONC(:,15)
!PLOSS(OP2) = +K014+K069*<OH>
 PLOSS(:,29) = +TPK%K014(:)+TPK%K069(:)*PCONC(:,14)
!
!PPROD(ORA1) = +0.00878*K058*<ALKA>*<OH>+0.15343*K079*<ALKE>*<O3>+0.15000*K080*
!<BIO>*<O3>+0.10788*K081*<CARBO>*<O3>+0.11*K082*<PAN>*<O3>
 PPROD(:,30) = +0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0.15343*TPK%K079(:)&
&*PCONC(:,19)*PCONC(:,1)+0.15000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.10788*TPK&
&%K081(:)*PCONC(:,25)*PCONC(:,1)+0.11*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!PLOSS(ORA1) = +K066*<OH>
 PLOSS(:,30) = +TPK%K066(:)*PCONC(:,14)
!
RETURN
END SUBROUTINE SUB2
!
SUBROUTINE SUB3
!
!Indices 31 a 40
!
!
!PPROD(ORA2) = +0.08143*K079*<ALKE>*<O3>+0.00000*K080*<BIO>*<O3>+0.20595*K081*<
!CARBO>*<O3>+0.17307*K0102*<CARBOP>*<HO2>+0.13684*K109*<CARBOP>*<MO2>+0.49810*K
!111*<ALKAP>*<CARBOP>+0.49922*K112*<ALKEP>*<CARBOP>+0.49400*K113*<BIOP>*<CARBOP
!>+0.09955*K115*<CARBOP>*<CARBOP>+0.48963*K116*<OLN>*<CARBOP>
 PPROD(:,31) = +0.08143*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*&
&PCONC(:,20)*PCONC(:,1)+0.20595*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)+0.17307*TPK%&
&K0102(:)*PCONC(:,39)*PCONC(:,15)+0.13684*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)+0&
&.49810*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.49922*TPK%K112(:)*PCONC(:,34)*PCO&
&NC(:,39)+0.49400*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+0.09955*TPK%K115(:)*PCONC&
&(:,39)*PCONC(:,39)+0.48963*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!PLOSS(ORA2) = +K067*<OH>
 PLOSS(:,31) = +TPK%K067(:)*PCONC(:,14)
!
!PPROD(MO2) = +K012*<ALD>+0.03795*K014*<OP2>+K056*<CH4>*<OH>+0.65*K068*<OP1>*<O
!H>+0.13966*K079*<ALKE>*<O3>+0.03000*K080*<BIO>*<O3>+0.09016*K091*<ALKAP>*<NO>+
!0.78134*K095*<CARBOP>*<NO>+0.01390*K105*<ALKAP>*<MO2>+0.56031*K109*<CARBOP>*<M
!O2>+0.51480*K111*<ALKAP>*<CARBOP>+0.50078*K112*<ALKEP>*<CARBOP>+0.50600*K113*<
!BIOP>*<CARBOP>+K114*<AROP>*<CARBOP>+1.66702*K115*<CARBOP>*<CARBOP>+0.51037*K11
!6*<OLN>*<CARBOP>+0.09731*K120*<ALKAP>*<NO3>+0.91910*K124*<CARBOP>*<NO3>+K128*<
!XO2>*<CARBOP>
 PPROD(:,32) = +TPK%K012(:)*PCONC(:,23)+0.03795*TPK%K014(:)*PCONC(:,29)+TPK%K05&
&6(:)*PCONC(:,16)*PCONC(:,14)+0.65*TPK%K068(:)*PCONC(:,28)*PCONC(:,14)+0.13966*&
&TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.03000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+&
&0.09016*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.78134*TPK%K095(:)*PCONC(:,39)*PCO&
&NC(:,3)+0.01390*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.56031*TPK%K109(:)*PCONC(&
&:,39)*PCONC(:,32)+0.51480*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.50078*TPK%K112&
&(:)*PCONC(:,34)*PCONC(:,39)+0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)+TPK%K1&
&14(:)*PCONC(:,38)*PCONC(:,39)+1.66702*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.51&
&037*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)+0.09731*TPK%K120(:)*PCONC(:,33)*PCONC(&
&:,5)+0.91910*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)+TPK%K128(:)*PCONC(:,41)*PCONC(&
&:,39)
!PLOSS(MO2) = +K090*<NO>+K097*<HO2>+K104*<MO2>+K104*<MO2>+K105*<ALKAP>+K106*<AL
!KEP>+K107*<BIOP>+K108*<AROP>+K109*<CARBOP>+K110*<OLN>+K119*<NO3>+K127*<XO2>
 PLOSS(:,32) = +TPK%K090(:)*PCONC(:,3)+TPK%K097(:)*PCONC(:,15)+TPK%K104(:)*PCON&
&C(:,32)+TPK%K104(:)*PCONC(:,32)+TPK%K105(:)*PCONC(:,33)+TPK%K106(:)*PCONC(:,34&
&)+TPK%K107(:)*PCONC(:,35)+TPK%K108(:)*PCONC(:,38)+TPK%K109(:)*PCONC(:,39)+TPK%&
&K110(:)*PCONC(:,40)+TPK%K119(:)*PCONC(:,5)+TPK%K127(:)*PCONC(:,41)
!
!PPROD(ALKAP) = +1.00000*K015*<KET>+K057*<ETH>*<OH>+0.87811*K058*<ALKA>*<OH>+0.
!40341*K069*<OP2>*<OH>+1.00000*K071*<ONIT>*<OH>+0.09815*K079*<ALKE>*<O3>+0.0000
!0*K080*<BIO>*<O3>+0.08187*K091*<ALKAP>*<NO>+0.00385*K105*<ALKAP>*<MO2>+0.00828
!*K111*<ALKAP>*<CARBOP>+0.08994*K120*<ALKAP>*<NO3>
 PPROD(:,33) = +1.00000*TPK%K015(:)*PCONC(:,24)+TPK%K057(:)*PCONC(:,17)*PCONC(:&
&,14)+0.87811*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)+0.40341*TPK%K069(:)*PCONC(:,2&
&9)*PCONC(:,14)+1.00000*TPK%K071(:)*PCONC(:,26)*PCONC(:,14)+0.09815*TPK%K079(:)&
&*PCONC(:,19)*PCONC(:,1)+0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.08187*TPK&
&%K091(:)*PCONC(:,33)*PCONC(:,3)+0.00385*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.&
&00828*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.08994*TPK%K120(:)*PCONC(:,33)*PCON&
&C(:,5)
!PLOSS(ALKAP) = +K091*<NO>+K098*<HO2>+K105*<MO2>+K111*<CARBOP>+K120*<NO3>
 PLOSS(:,33) = +TPK%K091(:)*PCONC(:,3)+TPK%K098(:)*PCONC(:,15)+TPK%K105(:)*PCON&
&C(:,32)+TPK%K111(:)*PCONC(:,39)+TPK%K120(:)*PCONC(:,5)
!
!PPROD(ALKEP) = +1.02529*K059*<ALKE>*<OH>
 PPROD(:,34) = +1.02529*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!PLOSS(ALKEP) = +K092*<NO>+K099*<HO2>+K106*<MO2>+K112*<CARBOP>+K121*<NO3>
 PLOSS(:,34) = +TPK%K092(:)*PCONC(:,3)+TPK%K099(:)*PCONC(:,15)+TPK%K106(:)*PCON&
&C(:,32)+TPK%K112(:)*PCONC(:,39)+TPK%K121(:)*PCONC(:,5)
!
!PPROD(BIOP) = +0.00000*K059*<ALKE>*<OH>+1.00000*K060*<BIO>*<OH>
 PPROD(:,35) = +0.00000*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)+1.00000*TPK%K060(:)&
&*PCONC(:,20)*PCONC(:,14)
!PLOSS(BIOP) = +K093*<NO>+K0100*<HO2>+K107*<MO2>+K113*<CARBOP>+K122*<NO3>
 PLOSS(:,35) = +TPK%K093(:)*PCONC(:,3)+TPK%K0100(:)*PCONC(:,15)+TPK%K107(:)*PCO&
&NC(:,32)+TPK%K113(:)*PCONC(:,39)+TPK%K122(:)*PCONC(:,5)
!
!PPROD(PHO) = +0.00276*K061*<ARO>*<OH>+K075*<ARO>*<NO3>
 PPROD(:,36) = +0.00276*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)+TPK%K075(:)*PCONC(:&
&,21)*PCONC(:,5)
!PLOSS(PHO) = +K083*<NO2>+K084*<HO2>
 PLOSS(:,36) = +TPK%K083(:)*PCONC(:,4)+TPK%K084(:)*PCONC(:,15)
!
!PPROD(ADD) = +0.93968*K061*<ARO>*<OH>
 PPROD(:,37) = +0.93968*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!PLOSS(ADD) = +K085*<NO2>+K086*<O2>+K087*<O3>
 PLOSS(:,37) = +TPK%K085(:)*PCONC(:,4)+TPK%K086(:)*TPK%O2(:)+TPK%K087(:)*PCONC(&
&:,1)
!
!PPROD(AROP) = +0.98*K086*<ADD>*<O2>
 PPROD(:,38) = +0.98*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!PLOSS(AROP) = +K094*<NO>+K0101*<HO2>+K108*<MO2>+K114*<CARBOP>+K123*<NO3>
 PLOSS(:,38) = +TPK%K094(:)*PCONC(:,3)+TPK%K0101(:)*PCONC(:,15)+TPK%K108(:)*PCO&
&NC(:,32)+TPK%K114(:)*PCONC(:,39)+TPK%K123(:)*PCONC(:,5)
!
!PPROD(CARBOP) = +1.00000*K015*<KET>+0.69622*K016*<CARBO>+1.00000*K063*<ALD>*<O
!H>+1.00000*K064*<KET>*<OH>+0.51419*K065*<CARBO>*<OH>+0.05413*K069*<OP2>*<OH>+1
!.00000*K073*<ALD>*<NO3>+0.38881*K074*<CARBO>*<NO3>+0.05705*K079*<ALKE>*<O3>+0.
!17000*K080*<BIO>*<O3>+0.27460*K081*<CARBO>*<O3>+0.70000*K082*<PAN>*<O3>+1.0000
!0*K089*<PAN>+0.09532*K095*<CARBOP>*<NO>+0.05954*K109*<CARBOP>*<MO2>+0.05821*K1
!15*<CARBOP>*<CARBOP>+0.03175*K124*<CARBOP>*<NO3>
 PPROD(:,39) = +1.00000*TPK%K015(:)*PCONC(:,24)+0.69622*TPK%K016(:)*PCONC(:,25)&
&+1.00000*TPK%K063(:)*PCONC(:,23)*PCONC(:,14)+1.00000*TPK%K064(:)*PCONC(:,24)*P&
&CONC(:,14)+0.51419*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.05413*TPK%K069(:)*PCO&
&NC(:,29)*PCONC(:,14)+1.00000*TPK%K073(:)*PCONC(:,23)*PCONC(:,5)+0.38881*TPK%K0&
&74(:)*PCONC(:,25)*PCONC(:,5)+0.05705*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)+0.1700&
&0*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.27460*TPK%K081(:)*PCONC(:,25)*PCONC(:,1&
&)+0.70000*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)+1.00000*TPK%K089(:)*PCONC(:,27)+0&
&.09532*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)+0.05954*TPK%K109(:)*PCONC(:,39)*PCON&
&C(:,32)+0.05821*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)+0.03175*TPK%K124(:)*PCONC(&
&:,39)*PCONC(:,5)
!PLOSS(CARBOP) = +K088*<NO2>+K095*<NO>+K0102*<HO2>+K109*<MO2>+K111*<ALKAP>+K112
!*<ALKEP>+K113*<BIOP>+K114*<AROP>+K115*<CARBOP>+K115*<CARBOP>+K116*<OLN>+K124*<
!NO3>+K128*<XO2>
 PLOSS(:,39) = +TPK%K088(:)*PCONC(:,4)+TPK%K095(:)*PCONC(:,3)+TPK%K0102(:)*PCON&
&C(:,15)+TPK%K109(:)*PCONC(:,32)+TPK%K111(:)*PCONC(:,33)+TPK%K112(:)*PCONC(:,34&
&)+TPK%K113(:)*PCONC(:,35)+TPK%K114(:)*PCONC(:,38)+TPK%K115(:)*PCONC(:,39)+TPK%&
&K115(:)*PCONC(:,39)+TPK%K116(:)*PCONC(:,40)+TPK%K124(:)*PCONC(:,5)+TPK%K128(:)&
&*PCONC(:,41)
!
!PPROD(OLN) = +0.00000*K074*<CARBO>*<NO3>+0.93768*K076*<ALKE>*<NO3>+1.00000*K07
!7*<BIO>*<NO3>
 PPROD(:,40) = +0.00000*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)+0.93768*TPK%K076(:)*&
&PCONC(:,19)*PCONC(:,5)+1.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!PLOSS(OLN) = +K096*<NO>+K103*<HO2>+K110*<MO2>+K116*<CARBOP>+K117*<OLN>+K117*<O
!LN>+K118*<OLN>+K118*<OLN>+K125*<NO3>
 PLOSS(:,40) = +TPK%K096(:)*PCONC(:,3)+TPK%K103(:)*PCONC(:,15)+TPK%K110(:)*PCON&
&C(:,32)+TPK%K116(:)*PCONC(:,39)+TPK%K117(:)*PCONC(:,40)+TPK%K117(:)*PCONC(:,40&
&)+TPK%K118(:)*PCONC(:,40)+TPK%K118(:)*PCONC(:,40)+TPK%K125(:)*PCONC(:,5)
!
RETURN
END SUBROUTINE SUB3
!
SUBROUTINE SUB4
!
!Indices 41 a 41
!
!
!PPROD(XO2) = +0.15*K054*<BIO>*<O3P>+0.10318*K061*<ARO>*<OH>+0.10162*K065*<CARB
!O>*<OH>+0.09333*K069*<OP2>*<OH>+K070*<PAN>*<OH>+0.10530*K074*<CARBO>*<NO3>+K07
!8*<PAN>*<NO3>+0.00000*K079*<ALKE>*<O3>+0.13000*K080*<BIO>*<O3>+0.13007*K091*<A
!LKAP>*<NO>+0.02563*K095*<CARBOP>*<NO>+0.13370*K105*<ALKAP>*<MO2>+0.02212*K109*
!<CARBOP>*<MO2>+0.11306*K111*<ALKAP>*<CARBOP>+0.01593*K115*<CARBOP>*<CARBOP>+0.
!16271*K120*<ALKAP>*<NO3>+0.01021*K124*<CARBOP>*<NO3>
 PPROD(:,41) = +0.15*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)+0.10318*TPK%K061(:)*PCO&
&NC(:,21)*PCONC(:,14)+0.10162*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)+0.09333*TPK%K&
&069(:)*PCONC(:,29)*PCONC(:,14)+TPK%K070(:)*PCONC(:,27)*PCONC(:,14)+0.10530*TPK&
&%K074(:)*PCONC(:,25)*PCONC(:,5)+TPK%K078(:)*PCONC(:,27)*PCONC(:,5)+0.00000*TPK&
&%K079(:)*PCONC(:,19)*PCONC(:,1)+0.13000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)+0.1&
&3007*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)+0.02563*TPK%K095(:)*PCONC(:,39)*PCONC(&
&:,3)+0.13370*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)+0.02212*TPK%K109(:)*PCONC(:,3&
&9)*PCONC(:,32)+0.11306*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)+0.01593*TPK%K115(:)&
&*PCONC(:,39)*PCONC(:,39)+0.16271*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)+0.01021*TP&
&K%K124(:)*PCONC(:,39)*PCONC(:,5)
!PLOSS(XO2) = +K126*<HO2>+K127*<MO2>+K128*<CARBOP>+K129*<XO2>+K129*<XO2>+K130*<
!NO>+K131*<NO3>
 PLOSS(:,41) = +TPK%K126(:)*PCONC(:,15)+TPK%K127(:)*PCONC(:,32)+TPK%K128(:)*PCO&
&NC(:,39)+TPK%K129(:)*PCONC(:,41)+TPK%K129(:)*PCONC(:,41)+TPK%K130(:)*PCONC(:,3&
&)+TPK%K131(:)*PCONC(:,5)
!
RETURN
END SUBROUTINE SUB4
!
END SUBROUTINE CH_PRODLOSS_GAZ
!
!
!========================================================================
!
!!    ##################
      MODULE MODI_CH_FCN
!!    ##################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_FCN(PTIME,PCONC,PDCDT,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                          :: PTIME
INTEGER, INTENT(IN)                          :: KVECNPT
INTEGER, INTENT(IN)                          :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ) :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ) :: PDCDT
INTEGER, INTENT(IN)                          :: KMI
!!
END SUBROUTINE CH_FCN
END INTERFACE
END MODULE MODI_CH_FCN
!
!========================================================================
!
!!    ########################################
      SUBROUTINE CH_FCN(PTIME,PCONC,PDCDT,KMI,KVECNPT,KEQ)
!!    ########################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_FCN*
!!
!!    PURPOSE
!!    -------
!       calculation of first derivative for the chemical reaction mechanism
!!
!!**  METHOD
!!    ------
!!      For each prognostic chemical species the first derivative is
!!    calculated as defined by the chemical reaction mechanism.
!!    The reaction rates and other user-defined auxiliary variables are
!!    transfered in the TYPE(CCSTYPE) variable TPK%.
!!    The subroutine PRODLOSS is called in order to calculate P and L
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
USE MODI_CH_PRODLOSS
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!    none
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                          :: PTIME
INTEGER, INTENT(IN)                          :: KVECNPT
INTEGER, INTENT(IN)                          :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ) :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ) :: PDCDT
INTEGER, INTENT(IN)                          :: KMI
!!
!!    LOCAL VARIABLES
!!    ---------------
REAL, DIMENSION(KVECNPT,KEQ)       :: ZPROD, ZLOSS
!!
!!----------------------------------------------------------------------
!!
CALL CH_PRODLOSS(PTIME,PCONC,ZPROD,ZLOSS,KMI,KVECNPT,KEQ)
PDCDT(:,:) = ZPROD(:,:) - PCONC(:,:) * ZLOSS(:,:)
RETURN
END SUBROUTINE CH_FCN
!
!
!========================================================================
!
!!    ##################
      MODULE MODI_CH_JAC
!!    ##################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_JAC(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
END SUBROUTINE CH_JAC
END INTERFACE
END MODULE MODI_CH_JAC
!
!========================================================================
!
!!    #######################################
      SUBROUTINE CH_JAC(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
!!    #######################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_JAC*
!!
!!    PURPOSE
!!    -------
!       calculation of the JACOBIAN matrix
!!
!!**  METHOD
!!    ------
!!      The Jacobian matrix J is calculated as defined by the chemical
!!    reaction mechanism.
!!    The reaction rates and other user-defined auxiliary variables are
!!    transfered in the TYPE(CCSTYPE) variable TPK%.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
USE MODI_CH_JAC_AQ
USE MODI_CH_JAC_GAZ
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
!
TYPE(CCSTYPE),                    POINTER        :: TPK
!!
!!----------------------------------------------------------------------
!!
TPK=>TACCS(KMI)
IF (TPK%LUSECHAQ) THEN
  CALL CH_JAC_AQ(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
ELSE
  CALL CH_JAC_GAZ(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
END IF
END SUBROUTINE CH_JAC
!
!========================================================================
!
!!    ##################
      MODULE MODI_CH_JAC_AQ
!!    ##################
INTERFACE
SUBROUTINE CH_JAC_AQ(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
END SUBROUTINE CH_JAC_AQ
END INTERFACE
END MODULE MODI_CH_JAC_AQ
!
!========================================================================
!
!!    ####################
      SUBROUTINE CH_JAC_AQ(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
!!    ####################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_JAC*
!!
!!    PURPOSE
!!    -------
!       calculation of the JACOBIAN matrix
!!
!!**  METHOD
!!    ------
!!      The Jacobian matrix J is calculated as defined by the chemical
!!    reaction mechanism.
!!    The reaction rates and other user-defined auxiliary variables are
!!    transfered in the TYPE(CCSTYPE) variable TPK%.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
!
TYPE(CCSTYPE),                    POINTER        :: TPK
TPK=>TACCS(KMI)
!
! /BEGIN_CODE/
TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
   &TPK%K022(:)*TPK%H2O(:))
TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
    &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
    &0.00000*TPK%K079(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
    &0.09000*TPK%K080(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
   &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
   &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K054(:)*PCONC(:,JP_BIO)+&
   &TPK%K055(:)*PCONC(:,JP_CARBO))
! /END_CODE/
PJAC(:,:,:) = 0.0
CALL SUBJ0
CALL SUBJ1
CALL SUBJ2
CALL SUBJ3
CALL SUBJ4
CALL SUBJ5
CALL SUBJ6
CALL SUBJ7
CALL SUBJ8
CALL SUBJ9
CALL SUBJ10
CALL SUBJ11
CALL SUBJ12
CALL SUBJ13
CALL SUBJ14
CALL SUBJ15
CALL SUBJ16
CALL SUBJ17
CALL SUBJ18
!

CONTAINS

SUBROUTINE SUBJ0
!
!Indices 1 a 5
!
!
!O3/O3=-K002-K003-K019*<O3P>-K023*<OH>-K024*<HO2>-K042*<NO>-K043*<NO2>-K079*<AL
!KE>-K080*<BIO>-K081*<CARBO>-K082*<PAN>-K087*<ADD>-KTC1-KTR1
 PJAC(:,1,1)=-TPK%K002(:)-TPK%K003(:)-TPK%K019(:)*TPK%O3P(:)-TPK%K023(:)*PCONC(&
&:,14)-TPK%K024(:)*PCONC(:,15)-TPK%K042(:)*PCONC(:,3)-TPK%K043(:)*PCONC(:,4)-TP&
&K%K079(:)*PCONC(:,19)-TPK%K080(:)*PCONC(:,20)-TPK%K081(:)*PCONC(:,25)-TPK%K082&
&(:)*PCONC(:,27)-TPK%K087(:)*PCONC(:,37)-TPK%KTC1(:)-TPK%KTR1(:)
!
!O3/H2O2=0.0
!
!O3/NO=-K042*<O3>
 PJAC(:,1,3)=-TPK%K042(:)*PCONC(:,1)
!
!O3/NO2=-K043*<O3>
 PJAC(:,1,4)=-TPK%K043(:)*PCONC(:,1)
!
!O3/NO3=0.0
!
!O3/N2O5=0.0
!
!O3/HONO=0.0
!
!O3/HNO3=0.0
!
!O3/HNO4=0.0
!
!O3/NH3=0.0
!
!O3/SO2=0.0
!
!O3/SULF=0.0
!
!O3/CO=0.0
!
!O3/OH=-K023*<O3>
 PJAC(:,1,14)=-TPK%K023(:)*PCONC(:,1)
!
!O3/HO2=-K024*<O3>+0.17307*K0102*<CARBOP>
 PJAC(:,1,15)=-TPK%K024(:)*PCONC(:,1)+0.17307*TPK%K0102(:)*PCONC(:,39)
!
!O3/CH4=0.0
!
!O3/ETH=0.0
!
!O3/ALKA=0.0
!
!O3/ALKE=-K079*<O3>
 PJAC(:,1,19)=-TPK%K079(:)*PCONC(:,1)
!
!O3/BIO=-K080*<O3>
 PJAC(:,1,20)=-TPK%K080(:)*PCONC(:,1)
!
!O3/ARO=0.0
!
!O3/HCHO=0.0
!
!O3/ALD=0.0
!
!O3/KET=0.0
!
!O3/CARBO=-K081*<O3>
 PJAC(:,1,25)=-TPK%K081(:)*PCONC(:,1)
!
!O3/ONIT=0.0
!
!O3/PAN=-K082*<O3>
 PJAC(:,1,27)=-TPK%K082(:)*PCONC(:,1)
!
!O3/OP1=0.0
!
!O3/OP2=0.0
!
!O3/ORA1=0.0
!
!O3/ORA2=0.0
!
!O3/MO2=0.0
!
!O3/ALKAP=0.0
!
!O3/ALKEP=0.0
!
!O3/BIOP=0.0
!
!O3/PHO=0.0
!
!O3/ADD=-K087*<O3>
 PJAC(:,1,37)=-TPK%K087(:)*PCONC(:,1)
!
!O3/AROP=0.0
!
!O3/CARBOP=+0.17307*K0102*<HO2>
 PJAC(:,1,39)=+0.17307*TPK%K0102(:)*PCONC(:,15)
!
!O3/OLN=0.0
!
!O3/XO2=0.0
!
!O3/WC_O3=+KTC21
 PJAC(:,1,42)=+TPK%KTC21(:)
!
!O3/WC_H2O2=0.0
!
!O3/WC_NO=0.0
!
!O3/WC_NO2=0.0
!
!O3/WC_NO3=0.0
!
!O3/WC_N2O5=0.0
!
!O3/WC_HONO=0.0
!
!O3/WC_HNO3=0.0
!
!O3/WC_HNO4=0.0
!
!O3/WC_NH3=0.0
!
!O3/WC_OH=0.0
!
!O3/WC_HO2=0.0
!
!O3/WC_CO2=0.0
!
!O3/WC_SO2=0.0
!
!O3/WC_SULF=0.0
!
!O3/WC_HCHO=0.0
!
!O3/WC_ORA1=0.0
!
!O3/WC_ORA2=0.0
!
!O3/WC_MO2=0.0
!
!O3/WC_OP1=0.0
!
!O3/WC_ASO3=0.0
!
!O3/WC_ASO4=0.0
!
!O3/WC_ASO5=0.0
!
!O3/WC_AHSO5=0.0
!
!O3/WC_AHMS=0.0
!
!O3/WR_O3=+KTR21
 PJAC(:,1,67)=+TPK%KTR21(:)
!
!O3/WR_H2O2=0.0
!
!O3/WR_NO=0.0
!
!O3/WR_NO2=0.0
!
!O3/WR_NO3=0.0
!
!O3/WR_N2O5=0.0
!
!O3/WR_HONO=0.0
!
!O3/WR_HNO3=0.0
!
!O3/WR_HNO4=0.0
!
!O3/WR_NH3=0.0
!
!O3/WR_OH=0.0
!
!O3/WR_HO2=0.0
!
!O3/WR_CO2=0.0
!
!O3/WR_SO2=0.0
!
!O3/WR_SULF=0.0
!
!O3/WR_HCHO=0.0
!
!O3/WR_ORA1=0.0
!
!O3/WR_ORA2=0.0
!
!O3/WR_MO2=0.0
!
!O3/WR_OP1=0.0
!
!O3/WR_ASO3=0.0
!
!O3/WR_ASO4=0.0
!
!O3/WR_ASO5=0.0
!
!O3/WR_AHSO5=0.0
!
!O3/WR_AHMS=0.0
!
!H2O2/O3=+0.01833*K079*<ALKE>+0.00100*K080*<BIO>
 PJAC(:,2,1)=+0.01833*TPK%K079(:)*PCONC(:,19)+0.00100*TPK%K080(:)*PCONC(:,20)
!
!H2O2/H2O2=-K009-K026*<OH>-KTC2-KTR2
 PJAC(:,2,2)=-TPK%K009(:)-TPK%K026(:)*PCONC(:,14)-TPK%KTC2(:)-TPK%KTR2(:)
!
!H2O2/NO=0.0
!
!H2O2/NO2=0.0
!
!H2O2/NO3=0.0
!
!H2O2/N2O5=0.0
!
!H2O2/HONO=0.0
!
!H2O2/HNO3=0.0
!
!H2O2/HNO4=0.0
!
!H2O2/NH3=0.0
!
!H2O2/SO2=0.0
!
!H2O2/SULF=0.0
!
!H2O2/CO=0.0
!
!H2O2/OH=-K026*<H2O2>
 PJAC(:,2,14)=-TPK%K026(:)*PCONC(:,2)
!
!H2O2/HO2=+K027*<HO2>+K027*<HO2>+K028*<HO2>*<H2O>+K028*<HO2>*<H2O>
 PJAC(:,2,15)=+TPK%K027(:)*PCONC(:,15)+TPK%K027(:)*PCONC(:,15)+TPK%K028(:)*PCON&
&C(:,15)*TPK%H2O(:)+TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)
!
!H2O2/CH4=0.0
!
!H2O2/ETH=0.0
!
!H2O2/ALKA=0.0
!
!H2O2/ALKE=+0.01833*K079*<O3>
 PJAC(:,2,19)=+0.01833*TPK%K079(:)*PCONC(:,1)
!
!H2O2/BIO=+0.00100*K080*<O3>
 PJAC(:,2,20)=+0.00100*TPK%K080(:)*PCONC(:,1)
!
!H2O2/ARO=0.0
!
!H2O2/HCHO=0.0
!
!H2O2/ALD=0.0
!
!H2O2/KET=0.0
!
!H2O2/CARBO=0.0
!
!H2O2/ONIT=0.0
!
!H2O2/PAN=0.0
!
!H2O2/OP1=0.0
!
!H2O2/OP2=0.0
!
!H2O2/ORA1=0.0
!
!H2O2/ORA2=0.0
!
!H2O2/MO2=0.0
!
!H2O2/ALKAP=0.0
!
!H2O2/ALKEP=0.0
!
!H2O2/BIOP=0.0
!
!H2O2/PHO=0.0
!
!H2O2/ADD=0.0
!
!H2O2/AROP=0.0
!
!H2O2/CARBOP=0.0
!
!H2O2/OLN=0.0
!
!H2O2/XO2=0.0
!
!H2O2/WC_O3=0.0
!
!H2O2/WC_H2O2=+KTC22
 PJAC(:,2,43)=+TPK%KTC22(:)
!
!H2O2/WC_NO=0.0
!
!H2O2/WC_NO2=0.0
!
!H2O2/WC_NO3=0.0
!
!H2O2/WC_N2O5=0.0
!
!H2O2/WC_HONO=0.0
!
!H2O2/WC_HNO3=0.0
!
!H2O2/WC_HNO4=0.0
!
!H2O2/WC_NH3=0.0
!
!H2O2/WC_OH=0.0
!
!H2O2/WC_HO2=0.0
!
!H2O2/WC_CO2=0.0
!
!H2O2/WC_SO2=0.0
!
!H2O2/WC_SULF=0.0
!
!H2O2/WC_HCHO=0.0
!
!H2O2/WC_ORA1=0.0
!
!H2O2/WC_ORA2=0.0
!
!H2O2/WC_MO2=0.0
!
!H2O2/WC_OP1=0.0
!
!H2O2/WC_ASO3=0.0
!
!H2O2/WC_ASO4=0.0
!
!H2O2/WC_ASO5=0.0
!
!H2O2/WC_AHSO5=0.0
!
!H2O2/WC_AHMS=0.0
!
!H2O2/WR_O3=0.0
!
!H2O2/WR_H2O2=+KTR22
 PJAC(:,2,68)=+TPK%KTR22(:)
!
!H2O2/WR_NO=0.0
!
!H2O2/WR_NO2=0.0
!
!H2O2/WR_NO3=0.0
!
!H2O2/WR_N2O5=0.0
!
!H2O2/WR_HONO=0.0
!
!H2O2/WR_HNO3=0.0
!
!H2O2/WR_HNO4=0.0
!
!H2O2/WR_NH3=0.0
!
!H2O2/WR_OH=0.0
!
!H2O2/WR_HO2=0.0
!
!H2O2/WR_CO2=0.0
!
!H2O2/WR_SO2=0.0
!
!H2O2/WR_SULF=0.0
!
!H2O2/WR_HCHO=0.0
!
!H2O2/WR_ORA1=0.0
!
!H2O2/WR_ORA2=0.0
!
!H2O2/WR_MO2=0.0
!
!H2O2/WR_OP1=0.0
!
!H2O2/WR_ASO3=0.0
!
!H2O2/WR_ASO4=0.0
!
!H2O2/WR_ASO5=0.0
!
!H2O2/WR_AHSO5=0.0
!
!H2O2/WR_AHMS=0.0
!
!NO/O3=-K042*<NO>
 PJAC(:,3,1)=-TPK%K042(:)*PCONC(:,3)
!
!NO/H2O2=0.0
!
!NO/NO=-K029*<O3P>-K032*<OH>-K035*<HO2>-K042*<O3>-K044*<NO>*<O2>-K044*<NO>*<O2>
!-K044*<NO>*<O2>-K044*<NO>*<O2>-K045*<NO3>-K090*<MO2>-K091*<ALKAP>-K092*<ALKEP>
!-K093*<BIOP>-K094*<AROP>-K095*<CARBOP>-K096*<OLN>-K130*<XO2>-KTC3-KTR3
 PJAC(:,3,3)=-TPK%K029(:)*TPK%O3P(:)-TPK%K032(:)*PCONC(:,14)-TPK%K035(:)*PCONC(&
&:,15)-TPK%K042(:)*PCONC(:,1)-TPK%K044(:)*PCONC(:,3)*TPK%O2(:)-TPK%K044(:)*PCON&
&C(:,3)*TPK%O2(:)-TPK%K044(:)*PCONC(:,3)*TPK%O2(:)-TPK%K044(:)*PCONC(:,3)*TPK%O&
&2(:)-TPK%K045(:)*PCONC(:,5)-TPK%K090(:)*PCONC(:,32)-TPK%K091(:)*PCONC(:,33)-TP&
&K%K092(:)*PCONC(:,34)-TPK%K093(:)*PCONC(:,35)-TPK%K094(:)*PCONC(:,38)-TPK%K095&
&(:)*PCONC(:,39)-TPK%K096(:)*PCONC(:,40)-TPK%K130(:)*PCONC(:,41)-TPK%KTC3(:)-TP&
&K%KTR3(:)
!
!NO/NO2=+K001+K030*<O3P>+K046*<NO3>
 PJAC(:,3,4)=+TPK%K001(:)+TPK%K030(:)*TPK%O3P(:)+TPK%K046(:)*PCONC(:,5)
!
!NO/NO3=+K007-K045*<NO>+K046*<NO2>
 PJAC(:,3,5)=+TPK%K007(:)-TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)
!
!NO/N2O5=0.0
!
!NO/HONO=+K004
 PJAC(:,3,7)=+TPK%K004(:)
!
!NO/HNO3=0.0
!
!NO/HNO4=0.0
!
!NO/NH3=0.0
!
!NO/SO2=0.0
!
!NO/SULF=0.0
!
!NO/CO=0.0
!
!NO/OH=-K032*<NO>
 PJAC(:,3,14)=-TPK%K032(:)*PCONC(:,3)
!
!NO/HO2=-K035*<NO>
 PJAC(:,3,15)=-TPK%K035(:)*PCONC(:,3)
!
!NO/CH4=0.0
!
!NO/ETH=0.0
!
!NO/ALKA=0.0
!
!NO/ALKE=0.0
!
!NO/BIO=0.0
!
!NO/ARO=0.0
!
!NO/HCHO=0.0
!
!NO/ALD=0.0
!
!NO/KET=0.0
!
!NO/CARBO=0.0
!
!NO/ONIT=0.0
!
!NO/PAN=0.0
!
!NO/OP1=0.0
!
!NO/OP2=0.0
!
!NO/ORA1=0.0
!
!NO/ORA2=0.0
!
!NO/MO2=-K090*<NO>
 PJAC(:,3,32)=-TPK%K090(:)*PCONC(:,3)
!
!NO/ALKAP=-K091*<NO>
 PJAC(:,3,33)=-TPK%K091(:)*PCONC(:,3)
!
!NO/ALKEP=-K092*<NO>
 PJAC(:,3,34)=-TPK%K092(:)*PCONC(:,3)
!
!NO/BIOP=-K093*<NO>
 PJAC(:,3,35)=-TPK%K093(:)*PCONC(:,3)
!
!NO/PHO=0.0
!
!NO/ADD=0.0
!
!NO/AROP=-K094*<NO>
 PJAC(:,3,38)=-TPK%K094(:)*PCONC(:,3)
!
!NO/CARBOP=-K095*<NO>
 PJAC(:,3,39)=-TPK%K095(:)*PCONC(:,3)
!
!NO/OLN=-K096*<NO>
 PJAC(:,3,40)=-TPK%K096(:)*PCONC(:,3)
!
!NO/XO2=-K130*<NO>
 PJAC(:,3,41)=-TPK%K130(:)*PCONC(:,3)
!
!NO/WC_O3=0.0
!
!NO/WC_H2O2=0.0
!
!NO/WC_NO=+KTC23
 PJAC(:,3,44)=+TPK%KTC23(:)
!
!NO/WC_NO2=0.0
!
!NO/WC_NO3=0.0
!
!NO/WC_N2O5=0.0
!
!NO/WC_HONO=0.0
!
!NO/WC_HNO3=0.0
!
!NO/WC_HNO4=0.0
!
!NO/WC_NH3=0.0
!
!NO/WC_OH=0.0
!
!NO/WC_HO2=0.0
!
!NO/WC_CO2=0.0
!
!NO/WC_SO2=0.0
!
!NO/WC_SULF=0.0
!
!NO/WC_HCHO=0.0
!
!NO/WC_ORA1=0.0
!
!NO/WC_ORA2=0.0
!
!NO/WC_MO2=0.0
!
!NO/WC_OP1=0.0
!
!NO/WC_ASO3=0.0
!
!NO/WC_ASO4=0.0
!
!NO/WC_ASO5=0.0
!
!NO/WC_AHSO5=0.0
!
!NO/WC_AHMS=0.0
!
!NO/WR_O3=0.0
!
!NO/WR_H2O2=0.0
!
!NO/WR_NO=+KTR23
 PJAC(:,3,69)=+TPK%KTR23(:)
!
!NO/WR_NO2=0.0
!
!NO/WR_NO3=0.0
!
!NO/WR_N2O5=0.0
!
!NO/WR_HONO=0.0
!
!NO/WR_HNO3=0.0
!
!NO/WR_HNO4=0.0
!
!NO/WR_NH3=0.0
!
!NO/WR_OH=0.0
!
!NO/WR_HO2=0.0
!
!NO/WR_CO2=0.0
!
!NO/WR_SO2=0.0
!
!NO/WR_SULF=0.0
!
!NO/WR_HCHO=0.0
!
!NO/WR_ORA1=0.0
!
!NO/WR_ORA2=0.0
!
!NO/WR_MO2=0.0
!
!NO/WR_OP1=0.0
!
!NO/WR_ASO3=0.0
!
!NO/WR_ASO4=0.0
!
!NO/WR_ASO5=0.0
!
!NO/WR_AHSO5=0.0
!
!NO/WR_AHMS=0.0
!
!NO2/O3=+K042*<NO>-K043*<NO2>+0.70*K082*<PAN>
 PJAC(:,4,1)=+TPK%K042(:)*PCONC(:,3)-TPK%K043(:)*PCONC(:,4)+0.70*TPK%K082(:)*PC&
&ONC(:,27)
!
!NO2/H2O2=0.0
!
!NO2/NO=+K029*<O3P>+K035*<HO2>+K042*<O3>+K044*<NO>*<O2>+K044*<NO>*<O2>+K044*<NO
!>*<O2>+K044*<NO>*<O2>+K045*<NO3>+K045*<NO3>+K090*<MO2>+0.91541*K091*<ALKAP>+K0
!92*<ALKEP>+0.84700*K093*<BIOP>+0.95115*K094*<AROP>+K095*<CARBOP>+1.81599*K096*
!<OLN>+K130*<XO2>
 PJAC(:,4,3)=+TPK%K029(:)*TPK%O3P(:)+TPK%K035(:)*PCONC(:,15)+TPK%K042(:)*PCONC(&
&:,1)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K04&
&4(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K045(:)*PCONC(:&
&,5)+TPK%K045(:)*PCONC(:,5)+TPK%K090(:)*PCONC(:,32)+0.91541*TPK%K091(:)*PCONC(:&
&,33)+TPK%K092(:)*PCONC(:,34)+0.84700*TPK%K093(:)*PCONC(:,35)+0.95115*TPK%K094(&
&:)*PCONC(:,38)+TPK%K095(:)*PCONC(:,39)+1.81599*TPK%K096(:)*PCONC(:,40)+TPK%K13&
&0(:)*PCONC(:,41)
!
!NO2/NO2=-K001-K030*<O3P>-K031*<O3P>-K033*<OH>-K036*<HO2>-K043*<O3>+K046*<NO3>-
!K046*<NO3>-K047*<NO3>-K083*<PHO>-K085*<ADD>-K088*<CARBOP>-KTC4-KTR4
 PJAC(:,4,4)=-TPK%K001(:)-TPK%K030(:)*TPK%O3P(:)-TPK%K031(:)*TPK%O3P(:)-TPK%K03&
&3(:)*PCONC(:,14)-TPK%K036(:)*PCONC(:,15)-TPK%K043(:)*PCONC(:,1)+TPK%K046(:)*PC&
&ONC(:,5)-TPK%K046(:)*PCONC(:,5)-TPK%K047(:)*PCONC(:,5)-TPK%K083(:)*PCONC(:,36)&
&-TPK%K085(:)*PCONC(:,37)-TPK%K088(:)*PCONC(:,39)-TPK%KTC4(:)-TPK%KTR4(:)
!
!NO2/NO3=+K008+K034*<OH>+0.7*K038*<HO2>+K045*<NO>+K045*<NO>+K046*<NO2>-K046*<NO
!2>-K047*<NO2>+K049*<NO3>+K049*<NO3>+K049*<NO3>+K049*<NO3>+0.10530*K074*<CARBO>
!+0.40*K078*<PAN>+K119*<MO2>+K120*<ALKAP>+K121*<ALKEP>+K122*<BIOP>+K123*<AROP>+
!K124*<CARBOP>+1.74072*K125*<OLN>+K131*<XO2>
 PJAC(:,4,5)=+TPK%K008(:)+TPK%K034(:)*PCONC(:,14)+0.7*TPK%K038(:)*PCONC(:,15)+T&
&PK%K045(:)*PCONC(:,3)+TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)-TPK%K046(:&
&)*PCONC(:,4)-TPK%K047(:)*PCONC(:,4)+TPK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:&
&,5)+TPK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:,5)+0.10530*TPK%K074(:)*PCONC(:,&
&25)+0.40*TPK%K078(:)*PCONC(:,27)+TPK%K119(:)*PCONC(:,32)+TPK%K120(:)*PCONC(:,3&
&3)+TPK%K121(:)*PCONC(:,34)+TPK%K122(:)*PCONC(:,35)+TPK%K123(:)*PCONC(:,38)+TPK&
&%K124(:)*PCONC(:,39)+1.74072*TPK%K125(:)*PCONC(:,40)+TPK%K131(:)*PCONC(:,41)
!
!NO2/N2O5=+K048
 PJAC(:,4,6)=+TPK%K048(:)
!
!NO2/HONO=+K039*<OH>
 PJAC(:,4,7)=+TPK%K039(:)*PCONC(:,14)
!
!NO2/HNO3=+K005
 PJAC(:,4,8)=+TPK%K005(:)
!
!NO2/HNO4=+0.65*K006+K037+K041*<OH>
 PJAC(:,4,9)=+0.65*TPK%K006(:)+TPK%K037(:)+TPK%K041(:)*PCONC(:,14)
!
!NO2/NH3=0.0
!
!NO2/SO2=0.0
!
!NO2/SULF=0.0
!
!NO2/CO=0.0
!
!NO2/OH=-K033*<NO2>+K034*<NO3>+K039*<HONO>+K041*<HNO4>+K071*<ONIT>
 PJAC(:,4,14)=-TPK%K033(:)*PCONC(:,4)+TPK%K034(:)*PCONC(:,5)+TPK%K039(:)*PCONC(&
&:,7)+TPK%K041(:)*PCONC(:,9)+TPK%K071(:)*PCONC(:,26)
!
!NO2/HO2=+K035*<NO>-K036*<NO2>+0.7*K038*<NO3>
 PJAC(:,4,15)=+TPK%K035(:)*PCONC(:,3)-TPK%K036(:)*PCONC(:,4)+0.7*TPK%K038(:)*PC&
&ONC(:,5)
!
!NO2/CH4=0.0
!
!NO2/ETH=0.0
!
!NO2/ALKA=0.0
!
!NO2/ALKE=0.0
!
!NO2/BIO=0.0
!
!NO2/ARO=0.0
!
!NO2/HCHO=0.0
!
!NO2/ALD=0.0
!
!NO2/KET=0.0
!
!NO2/CARBO=+0.10530*K074*<NO3>
 PJAC(:,4,25)=+0.10530*TPK%K074(:)*PCONC(:,5)
!
!NO2/ONIT=+K017+K071*<OH>
 PJAC(:,4,26)=+TPK%K017(:)+TPK%K071(:)*PCONC(:,14)
!
!NO2/PAN=+0.40*K078*<NO3>+0.70*K082*<O3>+K089
 PJAC(:,4,27)=+0.40*TPK%K078(:)*PCONC(:,5)+0.70*TPK%K082(:)*PCONC(:,1)+TPK%K089&
&(:)
!
!NO2/OP1=0.0
!
!NO2/OP2=0.0
!
!NO2/ORA1=0.0
!
!NO2/ORA2=0.0
!
!NO2/MO2=+K090*<NO>+0.32440*K110*<OLN>+K119*<NO3>
 PJAC(:,4,32)=+TPK%K090(:)*PCONC(:,3)+0.32440*TPK%K110(:)*PCONC(:,40)+TPK%K119(&
&:)*PCONC(:,5)
!
!NO2/ALKAP=+0.91541*K091*<NO>+K120*<NO3>
 PJAC(:,4,33)=+0.91541*TPK%K091(:)*PCONC(:,3)+TPK%K120(:)*PCONC(:,5)
!
!NO2/ALKEP=+K092*<NO>+K121*<NO3>
 PJAC(:,4,34)=+TPK%K092(:)*PCONC(:,3)+TPK%K121(:)*PCONC(:,5)
!
!NO2/BIOP=+0.84700*K093*<NO>+K122*<NO3>
 PJAC(:,4,35)=+0.84700*TPK%K093(:)*PCONC(:,3)+TPK%K122(:)*PCONC(:,5)
!
!NO2/PHO=-K083*<NO2>
 PJAC(:,4,36)=-TPK%K083(:)*PCONC(:,4)
!
!NO2/ADD=-K085*<NO2>
 PJAC(:,4,37)=-TPK%K085(:)*PCONC(:,4)
!
!NO2/AROP=+0.95115*K094*<NO>+K123*<NO3>
 PJAC(:,4,38)=+0.95115*TPK%K094(:)*PCONC(:,3)+TPK%K123(:)*PCONC(:,5)
!
!NO2/CARBOP=-K088*<NO2>+K095*<NO>+0.00000*K116*<OLN>+K124*<NO3>
 PJAC(:,4,39)=-TPK%K088(:)*PCONC(:,4)+TPK%K095(:)*PCONC(:,3)+0.00000*TPK%K116(:&
&)*PCONC(:,40)+TPK%K124(:)*PCONC(:,5)
!
!NO2/OLN=+1.81599*K096*<NO>+0.32440*K110*<MO2>+0.00000*K116*<CARBOP>+0.00000*K1
!18*<OLN>+0.00000*K118*<OLN>+1.74072*K125*<NO3>
 PJAC(:,4,40)=+1.81599*TPK%K096(:)*PCONC(:,3)+0.32440*TPK%K110(:)*PCONC(:,32)+0&
&.00000*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K11&
&8(:)*PCONC(:,40)+1.74072*TPK%K125(:)*PCONC(:,5)
!
!NO2/XO2=+K130*<NO>+K131*<NO3>
 PJAC(:,4,41)=+TPK%K130(:)*PCONC(:,3)+TPK%K131(:)*PCONC(:,5)
!
!NO2/WC_O3=0.0
!
!NO2/WC_H2O2=0.0
!
!NO2/WC_NO=0.0
!
!NO2/WC_NO2=+KTC24
 PJAC(:,4,45)=+TPK%KTC24(:)
!
!NO2/WC_NO3=0.0
!
!NO2/WC_N2O5=0.0
!
!NO2/WC_HONO=0.0
!
!NO2/WC_HNO3=0.0
!
!NO2/WC_HNO4=0.0
!
!NO2/WC_NH3=0.0
!
!NO2/WC_OH=0.0
!
!NO2/WC_HO2=0.0
!
!NO2/WC_CO2=0.0
!
!NO2/WC_SO2=0.0
!
!NO2/WC_SULF=0.0
!
!NO2/WC_HCHO=0.0
!
!NO2/WC_ORA1=0.0
!
!NO2/WC_ORA2=0.0
!
!NO2/WC_MO2=0.0
!
!NO2/WC_OP1=0.0
!
!NO2/WC_ASO3=0.0
!
!NO2/WC_ASO4=0.0
!
!NO2/WC_ASO5=0.0
!
!NO2/WC_AHSO5=0.0
!
!NO2/WC_AHMS=0.0
!
!NO2/WR_O3=0.0
!
!NO2/WR_H2O2=0.0
!
!NO2/WR_NO=0.0
!
!NO2/WR_NO2=+KTR24
 PJAC(:,4,70)=+TPK%KTR24(:)
!
!NO2/WR_NO3=0.0
!
!NO2/WR_N2O5=0.0
!
!NO2/WR_HONO=0.0
!
!NO2/WR_HNO3=0.0
!
!NO2/WR_HNO4=0.0
!
!NO2/WR_NH3=0.0
!
!NO2/WR_OH=0.0
!
!NO2/WR_HO2=0.0
!
!NO2/WR_CO2=0.0
!
!NO2/WR_SO2=0.0
!
!NO2/WR_SULF=0.0
!
!NO2/WR_HCHO=0.0
!
!NO2/WR_ORA1=0.0
!
!NO2/WR_ORA2=0.0
!
!NO2/WR_MO2=0.0
!
!NO2/WR_OP1=0.0
!
!NO2/WR_ASO3=0.0
!
!NO2/WR_ASO4=0.0
!
!NO2/WR_ASO5=0.0
!
!NO2/WR_AHSO5=0.0
!
!NO2/WR_AHMS=0.0
!
!NO3/O3=+K043*<NO2>
 PJAC(:,5,1)=+TPK%K043(:)*PCONC(:,4)
!
!NO3/H2O2=0.0
!
!NO3/NO=-K045*<NO3>
 PJAC(:,5,3)=-TPK%K045(:)*PCONC(:,5)
!
!NO3/NO2=+K031*<O3P>+K043*<O3>-K046*<NO3>-K047*<NO3>
 PJAC(:,5,4)=+TPK%K031(:)*TPK%O3P(:)+TPK%K043(:)*PCONC(:,1)-TPK%K046(:)*PCONC(:&
&,5)-TPK%K047(:)*PCONC(:,5)
!
!NO3/NO3=-K007-K008-K034*<OH>-K038*<HO2>-K045*<NO>-K046*<NO2>-K047*<NO2>-K049*<
!NO3>-K049*<NO3>-K049*<NO3>-K049*<NO3>-K072*<HCHO>-K073*<ALD>-K074*<CARBO>-K075
!*<ARO>-K076*<ALKE>-K077*<BIO>+0.60*K078*<PAN>-K078*<PAN>-K119*<MO2>-K120*<ALKA
!P>-K121*<ALKEP>-K122*<BIOP>-K123*<AROP>-K124*<CARBOP>-K125*<OLN>-K131*<XO2>-KT
!C5-KTR5
 PJAC(:,5,5)=-TPK%K007(:)-TPK%K008(:)-TPK%K034(:)*PCONC(:,14)-TPK%K038(:)*PCONC&
&(:,15)-TPK%K045(:)*PCONC(:,3)-TPK%K046(:)*PCONC(:,4)-TPK%K047(:)*PCONC(:,4)-TP&
&K%K049(:)*PCONC(:,5)-TPK%K049(:)*PCONC(:,5)-TPK%K049(:)*PCONC(:,5)-TPK%K049(:)&
&*PCONC(:,5)-TPK%K072(:)*PCONC(:,22)-TPK%K073(:)*PCONC(:,23)-TPK%K074(:)*PCONC(&
&:,25)-TPK%K075(:)*PCONC(:,21)-TPK%K076(:)*PCONC(:,19)-TPK%K077(:)*PCONC(:,20)+&
&0.60*TPK%K078(:)*PCONC(:,27)-TPK%K078(:)*PCONC(:,27)-TPK%K119(:)*PCONC(:,32)-T&
&PK%K120(:)*PCONC(:,33)-TPK%K121(:)*PCONC(:,34)-TPK%K122(:)*PCONC(:,35)-TPK%K12&
&3(:)*PCONC(:,38)-TPK%K124(:)*PCONC(:,39)-TPK%K125(:)*PCONC(:,40)-TPK%K131(:)*P&
&CONC(:,41)-TPK%KTC5(:)-TPK%KTR5(:)
!
!NO3/N2O5=+K048
 PJAC(:,5,6)=+TPK%K048(:)
!
!NO3/HONO=0.0
!
!NO3/HNO3=+K040*<OH>
 PJAC(:,5,8)=+TPK%K040(:)*PCONC(:,14)
!
!NO3/HNO4=+0.35*K006
 PJAC(:,5,9)=+0.35*TPK%K006(:)
!
!NO3/NH3=0.0
!
!NO3/SO2=0.0
!
!NO3/SULF=0.0
!
!NO3/CO=0.0
!
!NO3/OH=-K034*<NO3>+K040*<HNO3>+0.71893*K070*<PAN>
 PJAC(:,5,14)=-TPK%K034(:)*PCONC(:,5)+TPK%K040(:)*PCONC(:,8)+0.71893*TPK%K070(:&
&)*PCONC(:,27)
!
!NO3/HO2=-K038*<NO3>
 PJAC(:,5,15)=-TPK%K038(:)*PCONC(:,5)
!
!NO3/CH4=0.0
!
!NO3/ETH=0.0
!
!NO3/ALKA=0.0
!
!NO3/ALKE=-K076*<NO3>
 PJAC(:,5,19)=-TPK%K076(:)*PCONC(:,5)
!
!NO3/BIO=-K077*<NO3>
 PJAC(:,5,20)=-TPK%K077(:)*PCONC(:,5)
!
!NO3/ARO=-K075*<NO3>
 PJAC(:,5,21)=-TPK%K075(:)*PCONC(:,5)
!
!NO3/HCHO=-K072*<NO3>
 PJAC(:,5,22)=-TPK%K072(:)*PCONC(:,5)
!
!NO3/ALD=-K073*<NO3>
 PJAC(:,5,23)=-TPK%K073(:)*PCONC(:,5)
!
!NO3/KET=0.0
!
!NO3/CARBO=-K074*<NO3>
 PJAC(:,5,25)=-TPK%K074(:)*PCONC(:,5)
!
!NO3/ONIT=0.0
!
!NO3/PAN=+0.71893*K070*<OH>+0.60*K078*<NO3>-K078*<NO3>
 PJAC(:,5,27)=+0.71893*TPK%K070(:)*PCONC(:,14)+0.60*TPK%K078(:)*PCONC(:,5)-TPK%&
&K078(:)*PCONC(:,5)
!
!NO3/OP1=0.0
!
!NO3/OP2=0.0
!
!NO3/ORA1=0.0
!
!NO3/ORA2=0.0
!
!NO3/MO2=-K119*<NO3>
 PJAC(:,5,32)=-TPK%K119(:)*PCONC(:,5)
!
!NO3/ALKAP=-K120*<NO3>
 PJAC(:,5,33)=-TPK%K120(:)*PCONC(:,5)
!
!NO3/ALKEP=-K121*<NO3>
 PJAC(:,5,34)=-TPK%K121(:)*PCONC(:,5)
!
!NO3/BIOP=-K122*<NO3>
 PJAC(:,5,35)=-TPK%K122(:)*PCONC(:,5)
!
!NO3/PHO=0.0
!
!NO3/ADD=0.0
!
!NO3/AROP=-K123*<NO3>
 PJAC(:,5,38)=-TPK%K123(:)*PCONC(:,5)
!
!NO3/CARBOP=-K124*<NO3>
 PJAC(:,5,39)=-TPK%K124(:)*PCONC(:,5)
!
!NO3/OLN=-K125*<NO3>
 PJAC(:,5,40)=-TPK%K125(:)*PCONC(:,5)
!
!NO3/XO2=-K131*<NO3>
 PJAC(:,5,41)=-TPK%K131(:)*PCONC(:,5)
!
!NO3/WC_O3=0.0
!
!NO3/WC_H2O2=0.0
!
!NO3/WC_NO=0.0
!
!NO3/WC_NO2=0.0
!
!NO3/WC_NO3=+KTC25
 PJAC(:,5,46)=+TPK%KTC25(:)
!
!NO3/WC_N2O5=0.0
!
!NO3/WC_HONO=0.0
!
!NO3/WC_HNO3=0.0
!
!NO3/WC_HNO4=0.0
!
!NO3/WC_NH3=0.0
!
!NO3/WC_OH=0.0
!
!NO3/WC_HO2=0.0
!
!NO3/WC_CO2=0.0
!
!NO3/WC_SO2=0.0
!
!NO3/WC_SULF=0.0
!
!NO3/WC_HCHO=0.0
!
!NO3/WC_ORA1=0.0
!
!NO3/WC_ORA2=0.0
!
!NO3/WC_MO2=0.0
!
!NO3/WC_OP1=0.0
!
!NO3/WC_ASO3=0.0
!
!NO3/WC_ASO4=0.0
!
!NO3/WC_ASO5=0.0
!
!NO3/WC_AHSO5=0.0
!
!NO3/WC_AHMS=0.0
!
!NO3/WR_O3=0.0
!
!NO3/WR_H2O2=0.0
!
!NO3/WR_NO=0.0
!
!NO3/WR_NO2=0.0
!
!NO3/WR_NO3=+KTR25
 PJAC(:,5,71)=+TPK%KTR25(:)
!
!NO3/WR_N2O5=0.0
!
!NO3/WR_HONO=0.0
!
!NO3/WR_HNO3=0.0
!
!NO3/WR_HNO4=0.0
!
!NO3/WR_NH3=0.0
!
!NO3/WR_OH=0.0
!
!NO3/WR_HO2=0.0
!
!NO3/WR_CO2=0.0
!
!NO3/WR_SO2=0.0
!
!NO3/WR_SULF=0.0
!
!NO3/WR_HCHO=0.0
!
!NO3/WR_ORA1=0.0
!
!NO3/WR_ORA2=0.0
!
!NO3/WR_MO2=0.0
!
!NO3/WR_OP1=0.0
!
!NO3/WR_ASO3=0.0
!
!NO3/WR_ASO4=0.0
!
!NO3/WR_ASO5=0.0
!
!NO3/WR_AHSO5=0.0
!
!NO3/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ0
!
SUBROUTINE SUBJ1
!
!Indices 6 a 10
!
!
!N2O5/O3=0.0
!
!N2O5/H2O2=0.0
!
!N2O5/NO=0.0
!
!N2O5/NO2=+K047*<NO3>
 PJAC(:,6,4)=+TPK%K047(:)*PCONC(:,5)
!
!N2O5/NO3=+K047*<NO2>
 PJAC(:,6,5)=+TPK%K047(:)*PCONC(:,4)
!
!N2O5/N2O5=-K048-KTC6-KTR6
 PJAC(:,6,6)=-TPK%K048(:)-TPK%KTC6(:)-TPK%KTR6(:)
!
!N2O5/HONO=0.0
!
!N2O5/HNO3=0.0
!
!N2O5/HNO4=0.0
!
!N2O5/NH3=0.0
!
!N2O5/SO2=0.0
!
!N2O5/SULF=0.0
!
!N2O5/CO=0.0
!
!N2O5/OH=0.0
!
!N2O5/HO2=0.0
!
!N2O5/CH4=0.0
!
!N2O5/ETH=0.0
!
!N2O5/ALKA=0.0
!
!N2O5/ALKE=0.0
!
!N2O5/BIO=0.0
!
!N2O5/ARO=0.0
!
!N2O5/HCHO=0.0
!
!N2O5/ALD=0.0
!
!N2O5/KET=0.0
!
!N2O5/CARBO=0.0
!
!N2O5/ONIT=0.0
!
!N2O5/PAN=0.0
!
!N2O5/OP1=0.0
!
!N2O5/OP2=0.0
!
!N2O5/ORA1=0.0
!
!N2O5/ORA2=0.0
!
!N2O5/MO2=0.0
!
!N2O5/ALKAP=0.0
!
!N2O5/ALKEP=0.0
!
!N2O5/BIOP=0.0
!
!N2O5/PHO=0.0
!
!N2O5/ADD=0.0
!
!N2O5/AROP=0.0
!
!N2O5/CARBOP=0.0
!
!N2O5/OLN=0.0
!
!N2O5/XO2=0.0
!
!N2O5/WC_O3=0.0
!
!N2O5/WC_H2O2=0.0
!
!N2O5/WC_NO=0.0
!
!N2O5/WC_NO2=0.0
!
!N2O5/WC_NO3=0.0
!
!N2O5/WC_N2O5=+KTC26
 PJAC(:,6,47)=+TPK%KTC26(:)
!
!N2O5/WC_HONO=0.0
!
!N2O5/WC_HNO3=0.0
!
!N2O5/WC_HNO4=0.0
!
!N2O5/WC_NH3=0.0
!
!N2O5/WC_OH=0.0
!
!N2O5/WC_HO2=0.0
!
!N2O5/WC_CO2=0.0
!
!N2O5/WC_SO2=0.0
!
!N2O5/WC_SULF=0.0
!
!N2O5/WC_HCHO=0.0
!
!N2O5/WC_ORA1=0.0
!
!N2O5/WC_ORA2=0.0
!
!N2O5/WC_MO2=0.0
!
!N2O5/WC_OP1=0.0
!
!N2O5/WC_ASO3=0.0
!
!N2O5/WC_ASO4=0.0
!
!N2O5/WC_ASO5=0.0
!
!N2O5/WC_AHSO5=0.0
!
!N2O5/WC_AHMS=0.0
!
!N2O5/WR_O3=0.0
!
!N2O5/WR_H2O2=0.0
!
!N2O5/WR_NO=0.0
!
!N2O5/WR_NO2=0.0
!
!N2O5/WR_NO3=0.0
!
!N2O5/WR_N2O5=+KTR26
 PJAC(:,6,72)=+TPK%KTR26(:)
!
!N2O5/WR_HONO=0.0
!
!N2O5/WR_HNO3=0.0
!
!N2O5/WR_HNO4=0.0
!
!N2O5/WR_NH3=0.0
!
!N2O5/WR_OH=0.0
!
!N2O5/WR_HO2=0.0
!
!N2O5/WR_CO2=0.0
!
!N2O5/WR_SO2=0.0
!
!N2O5/WR_SULF=0.0
!
!N2O5/WR_HCHO=0.0
!
!N2O5/WR_ORA1=0.0
!
!N2O5/WR_ORA2=0.0
!
!N2O5/WR_MO2=0.0
!
!N2O5/WR_OP1=0.0
!
!N2O5/WR_ASO3=0.0
!
!N2O5/WR_ASO4=0.0
!
!N2O5/WR_ASO5=0.0
!
!N2O5/WR_AHSO5=0.0
!
!N2O5/WR_AHMS=0.0
!
!HONO/O3=0.0
!
!HONO/H2O2=0.0
!
!HONO/NO=+K032*<OH>
 PJAC(:,7,3)=+TPK%K032(:)*PCONC(:,14)
!
!HONO/NO2=+K085*<ADD>
 PJAC(:,7,4)=+TPK%K085(:)*PCONC(:,37)
!
!HONO/NO3=0.0
!
!HONO/N2O5=0.0
!
!HONO/HONO=-K004-K039*<OH>-KTC7-KTR7
 PJAC(:,7,7)=-TPK%K004(:)-TPK%K039(:)*PCONC(:,14)-TPK%KTC7(:)-TPK%KTR7(:)
!
!HONO/HNO3=0.0
!
!HONO/HNO4=0.0
!
!HONO/NH3=0.0
!
!HONO/SO2=0.0
!
!HONO/SULF=0.0
!
!HONO/CO=0.0
!
!HONO/OH=+K032*<NO>-K039*<HONO>
 PJAC(:,7,14)=+TPK%K032(:)*PCONC(:,3)-TPK%K039(:)*PCONC(:,7)
!
!HONO/HO2=0.0
!
!HONO/CH4=0.0
!
!HONO/ETH=0.0
!
!HONO/ALKA=0.0
!
!HONO/ALKE=0.0
!
!HONO/BIO=0.0
!
!HONO/ARO=0.0
!
!HONO/HCHO=0.0
!
!HONO/ALD=0.0
!
!HONO/KET=0.0
!
!HONO/CARBO=0.0
!
!HONO/ONIT=0.0
!
!HONO/PAN=0.0
!
!HONO/OP1=0.0
!
!HONO/OP2=0.0
!
!HONO/ORA1=0.0
!
!HONO/ORA2=0.0
!
!HONO/MO2=0.0
!
!HONO/ALKAP=0.0
!
!HONO/ALKEP=0.0
!
!HONO/BIOP=0.0
!
!HONO/PHO=0.0
!
!HONO/ADD=+K085*<NO2>
 PJAC(:,7,37)=+TPK%K085(:)*PCONC(:,4)
!
!HONO/AROP=0.0
!
!HONO/CARBOP=0.0
!
!HONO/OLN=0.0
!
!HONO/XO2=0.0
!
!HONO/WC_O3=0.0
!
!HONO/WC_H2O2=0.0
!
!HONO/WC_NO=0.0
!
!HONO/WC_NO2=0.0
!
!HONO/WC_NO3=0.0
!
!HONO/WC_N2O5=0.0
!
!HONO/WC_HONO=+KTC27
 PJAC(:,7,48)=+TPK%KTC27(:)
!
!HONO/WC_HNO3=0.0
!
!HONO/WC_HNO4=0.0
!
!HONO/WC_NH3=0.0
!
!HONO/WC_OH=0.0
!
!HONO/WC_HO2=0.0
!
!HONO/WC_CO2=0.0
!
!HONO/WC_SO2=0.0
!
!HONO/WC_SULF=0.0
!
!HONO/WC_HCHO=0.0
!
!HONO/WC_ORA1=0.0
!
!HONO/WC_ORA2=0.0
!
!HONO/WC_MO2=0.0
!
!HONO/WC_OP1=0.0
!
!HONO/WC_ASO3=0.0
!
!HONO/WC_ASO4=0.0
!
!HONO/WC_ASO5=0.0
!
!HONO/WC_AHSO5=0.0
!
!HONO/WC_AHMS=0.0
!
!HONO/WR_O3=0.0
!
!HONO/WR_H2O2=0.0
!
!HONO/WR_NO=0.0
!
!HONO/WR_NO2=0.0
!
!HONO/WR_NO3=0.0
!
!HONO/WR_N2O5=0.0
!
!HONO/WR_HONO=+KTR27
 PJAC(:,7,73)=+TPK%KTR27(:)
!
!HONO/WR_HNO3=0.0
!
!HONO/WR_HNO4=0.0
!
!HONO/WR_NH3=0.0
!
!HONO/WR_OH=0.0
!
!HONO/WR_HO2=0.0
!
!HONO/WR_CO2=0.0
!
!HONO/WR_SO2=0.0
!
!HONO/WR_SULF=0.0
!
!HONO/WR_HCHO=0.0
!
!HONO/WR_ORA1=0.0
!
!HONO/WR_ORA2=0.0
!
!HONO/WR_MO2=0.0
!
!HONO/WR_OP1=0.0
!
!HONO/WR_ASO3=0.0
!
!HONO/WR_ASO4=0.0
!
!HONO/WR_ASO5=0.0
!
!HONO/WR_AHSO5=0.0
!
!HONO/WR_AHMS=0.0
!
!HNO3/O3=0.0
!
!HNO3/H2O2=0.0
!
!HNO3/NO=0.0
!
!HNO3/NO2=+K033*<OH>
 PJAC(:,8,4)=+TPK%K033(:)*PCONC(:,14)
!
!HNO3/NO3=+0.3*K038*<HO2>+K072*<HCHO>+K073*<ALD>+0.91567*K074*<CARBO>+K075*<ARO
!>
 PJAC(:,8,5)=+0.3*TPK%K038(:)*PCONC(:,15)+TPK%K072(:)*PCONC(:,22)+TPK%K073(:)*P&
&CONC(:,23)+0.91567*TPK%K074(:)*PCONC(:,25)+TPK%K075(:)*PCONC(:,21)
!
!HNO3/N2O5=0.0
!
!HNO3/HONO=0.0
!
!HNO3/HNO3=-K005-K040*<OH>-KTC8-KTR8
 PJAC(:,8,8)=-TPK%K005(:)-TPK%K040(:)*PCONC(:,14)-TPK%KTC8(:)-TPK%KTR8(:)
!
!HNO3/HNO4=0.0
!
!HNO3/NH3=0.0
!
!HNO3/SO2=0.0
!
!HNO3/SULF=0.0
!
!HNO3/CO=0.0
!
!HNO3/OH=+K033*<NO2>-K040*<HNO3>
 PJAC(:,8,14)=+TPK%K033(:)*PCONC(:,4)-TPK%K040(:)*PCONC(:,8)
!
!HNO3/HO2=+0.3*K038*<NO3>
 PJAC(:,8,15)=+0.3*TPK%K038(:)*PCONC(:,5)
!
!HNO3/CH4=0.0
!
!HNO3/ETH=0.0
!
!HNO3/ALKA=0.0
!
!HNO3/ALKE=0.0
!
!HNO3/BIO=0.0
!
!HNO3/ARO=+K075*<NO3>
 PJAC(:,8,21)=+TPK%K075(:)*PCONC(:,5)
!
!HNO3/HCHO=+K072*<NO3>
 PJAC(:,8,22)=+TPK%K072(:)*PCONC(:,5)
!
!HNO3/ALD=+K073*<NO3>
 PJAC(:,8,23)=+TPK%K073(:)*PCONC(:,5)
!
!HNO3/KET=0.0
!
!HNO3/CARBO=+0.91567*K074*<NO3>
 PJAC(:,8,25)=+0.91567*TPK%K074(:)*PCONC(:,5)
!
!HNO3/ONIT=0.0
!
!HNO3/PAN=0.0
!
!HNO3/OP1=0.0
!
!HNO3/OP2=0.0
!
!HNO3/ORA1=0.0
!
!HNO3/ORA2=0.0
!
!HNO3/MO2=0.0
!
!HNO3/ALKAP=0.0
!
!HNO3/ALKEP=0.0
!
!HNO3/BIOP=0.0
!
!HNO3/PHO=0.0
!
!HNO3/ADD=0.0
!
!HNO3/AROP=0.0
!
!HNO3/CARBOP=0.0
!
!HNO3/OLN=0.0
!
!HNO3/XO2=0.0
!
!HNO3/WC_O3=0.0
!
!HNO3/WC_H2O2=0.0
!
!HNO3/WC_NO=0.0
!
!HNO3/WC_NO2=0.0
!
!HNO3/WC_NO3=0.0
!
!HNO3/WC_N2O5=0.0
!
!HNO3/WC_HONO=0.0
!
!HNO3/WC_HNO3=+KTC28
 PJAC(:,8,49)=+TPK%KTC28(:)
!
!HNO3/WC_HNO4=0.0
!
!HNO3/WC_NH3=0.0
!
!HNO3/WC_OH=0.0
!
!HNO3/WC_HO2=0.0
!
!HNO3/WC_CO2=0.0
!
!HNO3/WC_SO2=0.0
!
!HNO3/WC_SULF=0.0
!
!HNO3/WC_HCHO=0.0
!
!HNO3/WC_ORA1=0.0
!
!HNO3/WC_ORA2=0.0
!
!HNO3/WC_MO2=0.0
!
!HNO3/WC_OP1=0.0
!
!HNO3/WC_ASO3=0.0
!
!HNO3/WC_ASO4=0.0
!
!HNO3/WC_ASO5=0.0
!
!HNO3/WC_AHSO5=0.0
!
!HNO3/WC_AHMS=0.0
!
!HNO3/WR_O3=0.0
!
!HNO3/WR_H2O2=0.0
!
!HNO3/WR_NO=0.0
!
!HNO3/WR_NO2=0.0
!
!HNO3/WR_NO3=0.0
!
!HNO3/WR_N2O5=0.0
!
!HNO3/WR_HONO=0.0
!
!HNO3/WR_HNO3=+KTR28
 PJAC(:,8,74)=+TPK%KTR28(:)
!
!HNO3/WR_HNO4=0.0
!
!HNO3/WR_NH3=0.0
!
!HNO3/WR_OH=0.0
!
!HNO3/WR_HO2=0.0
!
!HNO3/WR_CO2=0.0
!
!HNO3/WR_SO2=0.0
!
!HNO3/WR_SULF=0.0
!
!HNO3/WR_HCHO=0.0
!
!HNO3/WR_ORA1=0.0
!
!HNO3/WR_ORA2=0.0
!
!HNO3/WR_MO2=0.0
!
!HNO3/WR_OP1=0.0
!
!HNO3/WR_ASO3=0.0
!
!HNO3/WR_ASO4=0.0
!
!HNO3/WR_ASO5=0.0
!
!HNO3/WR_AHSO5=0.0
!
!HNO3/WR_AHMS=0.0
!
!HNO4/O3=0.0
!
!HNO4/H2O2=0.0
!
!HNO4/NO=0.0
!
!HNO4/NO2=+K036*<HO2>
 PJAC(:,9,4)=+TPK%K036(:)*PCONC(:,15)
!
!HNO4/NO3=0.0
!
!HNO4/N2O5=0.0
!
!HNO4/HONO=0.0
!
!HNO4/HNO3=0.0
!
!HNO4/HNO4=-K006-K037-K041*<OH>-KTC9-KTR9
 PJAC(:,9,9)=-TPK%K006(:)-TPK%K037(:)-TPK%K041(:)*PCONC(:,14)-TPK%KTC9(:)-TPK%K&
&TR9(:)
!
!HNO4/NH3=0.0
!
!HNO4/SO2=0.0
!
!HNO4/SULF=0.0
!
!HNO4/CO=0.0
!
!HNO4/OH=-K041*<HNO4>
 PJAC(:,9,14)=-TPK%K041(:)*PCONC(:,9)
!
!HNO4/HO2=+K036*<NO2>
 PJAC(:,9,15)=+TPK%K036(:)*PCONC(:,4)
!
!HNO4/CH4=0.0
!
!HNO4/ETH=0.0
!
!HNO4/ALKA=0.0
!
!HNO4/ALKE=0.0
!
!HNO4/BIO=0.0
!
!HNO4/ARO=0.0
!
!HNO4/HCHO=0.0
!
!HNO4/ALD=0.0
!
!HNO4/KET=0.0
!
!HNO4/CARBO=0.0
!
!HNO4/ONIT=0.0
!
!HNO4/PAN=0.0
!
!HNO4/OP1=0.0
!
!HNO4/OP2=0.0
!
!HNO4/ORA1=0.0
!
!HNO4/ORA2=0.0
!
!HNO4/MO2=0.0
!
!HNO4/ALKAP=0.0
!
!HNO4/ALKEP=0.0
!
!HNO4/BIOP=0.0
!
!HNO4/PHO=0.0
!
!HNO4/ADD=0.0
!
!HNO4/AROP=0.0
!
!HNO4/CARBOP=0.0
!
!HNO4/OLN=0.0
!
!HNO4/XO2=0.0
!
!HNO4/WC_O3=0.0
!
!HNO4/WC_H2O2=0.0
!
!HNO4/WC_NO=0.0
!
!HNO4/WC_NO2=0.0
!
!HNO4/WC_NO3=0.0
!
!HNO4/WC_N2O5=0.0
!
!HNO4/WC_HONO=0.0
!
!HNO4/WC_HNO3=0.0
!
!HNO4/WC_HNO4=+KTC29
 PJAC(:,9,50)=+TPK%KTC29(:)
!
!HNO4/WC_NH3=0.0
!
!HNO4/WC_OH=0.0
!
!HNO4/WC_HO2=0.0
!
!HNO4/WC_CO2=0.0
!
!HNO4/WC_SO2=0.0
!
!HNO4/WC_SULF=0.0
!
!HNO4/WC_HCHO=0.0
!
!HNO4/WC_ORA1=0.0
!
!HNO4/WC_ORA2=0.0
!
!HNO4/WC_MO2=0.0
!
!HNO4/WC_OP1=0.0
!
!HNO4/WC_ASO3=0.0
!
!HNO4/WC_ASO4=0.0
!
!HNO4/WC_ASO5=0.0
!
!HNO4/WC_AHSO5=0.0
!
!HNO4/WC_AHMS=0.0
!
!HNO4/WR_O3=0.0
!
!HNO4/WR_H2O2=0.0
!
!HNO4/WR_NO=0.0
!
!HNO4/WR_NO2=0.0
!
!HNO4/WR_NO3=0.0
!
!HNO4/WR_N2O5=0.0
!
!HNO4/WR_HONO=0.0
!
!HNO4/WR_HNO3=0.0
!
!HNO4/WR_HNO4=+KTR29
 PJAC(:,9,75)=+TPK%KTR29(:)
!
!HNO4/WR_NH3=0.0
!
!HNO4/WR_OH=0.0
!
!HNO4/WR_HO2=0.0
!
!HNO4/WR_CO2=0.0
!
!HNO4/WR_SO2=0.0
!
!HNO4/WR_SULF=0.0
!
!HNO4/WR_HCHO=0.0
!
!HNO4/WR_ORA1=0.0
!
!HNO4/WR_ORA2=0.0
!
!HNO4/WR_MO2=0.0
!
!HNO4/WR_OP1=0.0
!
!HNO4/WR_ASO3=0.0
!
!HNO4/WR_ASO4=0.0
!
!HNO4/WR_ASO5=0.0
!
!HNO4/WR_AHSO5=0.0
!
!HNO4/WR_AHMS=0.0
!
!NH3/O3=0.0
!
!NH3/H2O2=0.0
!
!NH3/NO=0.0
!
!NH3/NO2=0.0
!
!NH3/NO3=0.0
!
!NH3/N2O5=0.0
!
!NH3/HONO=0.0
!
!NH3/HNO3=0.0
!
!NH3/HNO4=0.0
!
!NH3/NH3=-K050*<OH>-KTC10-KTR10
 PJAC(:,10,10)=-TPK%K050(:)*PCONC(:,14)-TPK%KTC10(:)-TPK%KTR10(:)
!
!NH3/SO2=0.0
!
!NH3/SULF=0.0
!
!NH3/CO=0.0
!
!NH3/OH=-K050*<NH3>
 PJAC(:,10,14)=-TPK%K050(:)*PCONC(:,10)
!
!NH3/HO2=0.0
!
!NH3/CH4=0.0
!
!NH3/ETH=0.0
!
!NH3/ALKA=0.0
!
!NH3/ALKE=0.0
!
!NH3/BIO=0.0
!
!NH3/ARO=0.0
!
!NH3/HCHO=0.0
!
!NH3/ALD=0.0
!
!NH3/KET=0.0
!
!NH3/CARBO=0.0
!
!NH3/ONIT=0.0
!
!NH3/PAN=0.0
!
!NH3/OP1=0.0
!
!NH3/OP2=0.0
!
!NH3/ORA1=0.0
!
!NH3/ORA2=0.0
!
!NH3/MO2=0.0
!
!NH3/ALKAP=0.0
!
!NH3/ALKEP=0.0
!
!NH3/BIOP=0.0
!
!NH3/PHO=0.0
!
!NH3/ADD=0.0
!
!NH3/AROP=0.0
!
!NH3/CARBOP=0.0
!
!NH3/OLN=0.0
!
!NH3/XO2=0.0
!
!NH3/WC_O3=0.0
!
!NH3/WC_H2O2=0.0
!
!NH3/WC_NO=0.0
!
!NH3/WC_NO2=0.0
!
!NH3/WC_NO3=0.0
!
!NH3/WC_N2O5=0.0
!
!NH3/WC_HONO=0.0
!
!NH3/WC_HNO3=0.0
!
!NH3/WC_HNO4=0.0
!
!NH3/WC_NH3=+KTC30
 PJAC(:,10,51)=+TPK%KTC30(:)
!
!NH3/WC_OH=0.0
!
!NH3/WC_HO2=0.0
!
!NH3/WC_CO2=0.0
!
!NH3/WC_SO2=0.0
!
!NH3/WC_SULF=0.0
!
!NH3/WC_HCHO=0.0
!
!NH3/WC_ORA1=0.0
!
!NH3/WC_ORA2=0.0
!
!NH3/WC_MO2=0.0
!
!NH3/WC_OP1=0.0
!
!NH3/WC_ASO3=0.0
!
!NH3/WC_ASO4=0.0
!
!NH3/WC_ASO5=0.0
!
!NH3/WC_AHSO5=0.0
!
!NH3/WC_AHMS=0.0
!
!NH3/WR_O3=0.0
!
!NH3/WR_H2O2=0.0
!
!NH3/WR_NO=0.0
!
!NH3/WR_NO2=0.0
!
!NH3/WR_NO3=0.0
!
!NH3/WR_N2O5=0.0
!
!NH3/WR_HONO=0.0
!
!NH3/WR_HNO3=0.0
!
!NH3/WR_HNO4=0.0
!
!NH3/WR_NH3=+KTR30
 PJAC(:,10,76)=+TPK%KTR30(:)
!
!NH3/WR_OH=0.0
!
!NH3/WR_HO2=0.0
!
!NH3/WR_CO2=0.0
!
!NH3/WR_SO2=0.0
!
!NH3/WR_SULF=0.0
!
!NH3/WR_HCHO=0.0
!
!NH3/WR_ORA1=0.0
!
!NH3/WR_ORA2=0.0
!
!NH3/WR_MO2=0.0
!
!NH3/WR_OP1=0.0
!
!NH3/WR_ASO3=0.0
!
!NH3/WR_ASO4=0.0
!
!NH3/WR_ASO5=0.0
!
!NH3/WR_AHSO5=0.0
!
!NH3/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ1
!
SUBROUTINE SUBJ2
!
!Indices 11 a 15
!
!
!SO2/O3=0.0
!
!SO2/H2O2=0.0
!
!SO2/NO=0.0
!
!SO2/NO2=0.0
!
!SO2/NO3=0.0
!
!SO2/N2O5=0.0
!
!SO2/HONO=0.0
!
!SO2/HNO3=0.0
!
!SO2/HNO4=0.0
!
!SO2/NH3=0.0
!
!SO2/SO2=-K052*<OH>-KTC14-KTR14
 PJAC(:,11,11)=-TPK%K052(:)*PCONC(:,14)-TPK%KTC14(:)-TPK%KTR14(:)
!
!SO2/SULF=0.0
!
!SO2/CO=0.0
!
!SO2/OH=-K052*<SO2>
 PJAC(:,11,14)=-TPK%K052(:)*PCONC(:,11)
!
!SO2/HO2=0.0
!
!SO2/CH4=0.0
!
!SO2/ETH=0.0
!
!SO2/ALKA=0.0
!
!SO2/ALKE=0.0
!
!SO2/BIO=0.0
!
!SO2/ARO=0.0
!
!SO2/HCHO=0.0
!
!SO2/ALD=0.0
!
!SO2/KET=0.0
!
!SO2/CARBO=0.0
!
!SO2/ONIT=0.0
!
!SO2/PAN=0.0
!
!SO2/OP1=0.0
!
!SO2/OP2=0.0
!
!SO2/ORA1=0.0
!
!SO2/ORA2=0.0
!
!SO2/MO2=0.0
!
!SO2/ALKAP=0.0
!
!SO2/ALKEP=0.0
!
!SO2/BIOP=0.0
!
!SO2/PHO=0.0
!
!SO2/ADD=0.0
!
!SO2/AROP=0.0
!
!SO2/CARBOP=0.0
!
!SO2/OLN=0.0
!
!SO2/XO2=0.0
!
!SO2/WC_O3=0.0
!
!SO2/WC_H2O2=0.0
!
!SO2/WC_NO=0.0
!
!SO2/WC_NO2=0.0
!
!SO2/WC_NO3=0.0
!
!SO2/WC_N2O5=0.0
!
!SO2/WC_HONO=0.0
!
!SO2/WC_HNO3=0.0
!
!SO2/WC_HNO4=0.0
!
!SO2/WC_NH3=0.0
!
!SO2/WC_OH=0.0
!
!SO2/WC_HO2=0.0
!
!SO2/WC_CO2=0.0
!
!SO2/WC_SO2=+KTC34
 PJAC(:,11,55)=+TPK%KTC34(:)
!
!SO2/WC_SULF=0.0
!
!SO2/WC_HCHO=0.0
!
!SO2/WC_ORA1=0.0
!
!SO2/WC_ORA2=0.0
!
!SO2/WC_MO2=0.0
!
!SO2/WC_OP1=0.0
!
!SO2/WC_ASO3=0.0
!
!SO2/WC_ASO4=0.0
!
!SO2/WC_ASO5=0.0
!
!SO2/WC_AHSO5=0.0
!
!SO2/WC_AHMS=0.0
!
!SO2/WR_O3=0.0
!
!SO2/WR_H2O2=0.0
!
!SO2/WR_NO=0.0
!
!SO2/WR_NO2=0.0
!
!SO2/WR_NO3=0.0
!
!SO2/WR_N2O5=0.0
!
!SO2/WR_HONO=0.0
!
!SO2/WR_HNO3=0.0
!
!SO2/WR_HNO4=0.0
!
!SO2/WR_NH3=0.0
!
!SO2/WR_OH=0.0
!
!SO2/WR_HO2=0.0
!
!SO2/WR_CO2=0.0
!
!SO2/WR_SO2=+KTR34
 PJAC(:,11,80)=+TPK%KTR34(:)
!
!SO2/WR_SULF=0.0
!
!SO2/WR_HCHO=0.0
!
!SO2/WR_ORA1=0.0
!
!SO2/WR_ORA2=0.0
!
!SO2/WR_MO2=0.0
!
!SO2/WR_OP1=0.0
!
!SO2/WR_ASO3=0.0
!
!SO2/WR_ASO4=0.0
!
!SO2/WR_ASO5=0.0
!
!SO2/WR_AHSO5=0.0
!
!SO2/WR_AHMS=0.0
!
!SULF/O3=0.0
!
!SULF/H2O2=0.0
!
!SULF/NO=0.0
!
!SULF/NO2=0.0
!
!SULF/NO3=0.0
!
!SULF/N2O5=0.0
!
!SULF/HONO=0.0
!
!SULF/HNO3=0.0
!
!SULF/HNO4=0.0
!
!SULF/NH3=0.0
!
!SULF/SO2=+K052*<OH>
 PJAC(:,12,11)=+TPK%K052(:)*PCONC(:,14)
!
!SULF/SULF=-K132-KTC15-KTR15
 PJAC(:,12,12)=-TPK%K132(:)-TPK%KTC15(:)-TPK%KTR15(:)
!
!SULF/CO=0.0
!
!SULF/OH=+K052*<SO2>
 PJAC(:,12,14)=+TPK%K052(:)*PCONC(:,11)
!
!SULF/HO2=0.0
!
!SULF/CH4=0.0
!
!SULF/ETH=0.0
!
!SULF/ALKA=0.0
!
!SULF/ALKE=0.0
!
!SULF/BIO=0.0
!
!SULF/ARO=0.0
!
!SULF/HCHO=0.0
!
!SULF/ALD=0.0
!
!SULF/KET=0.0
!
!SULF/CARBO=0.0
!
!SULF/ONIT=0.0
!
!SULF/PAN=0.0
!
!SULF/OP1=0.0
!
!SULF/OP2=0.0
!
!SULF/ORA1=0.0
!
!SULF/ORA2=0.0
!
!SULF/MO2=0.0
!
!SULF/ALKAP=0.0
!
!SULF/ALKEP=0.0
!
!SULF/BIOP=0.0
!
!SULF/PHO=0.0
!
!SULF/ADD=0.0
!
!SULF/AROP=0.0
!
!SULF/CARBOP=0.0
!
!SULF/OLN=0.0
!
!SULF/XO2=0.0
!
!SULF/WC_O3=0.0
!
!SULF/WC_H2O2=0.0
!
!SULF/WC_NO=0.0
!
!SULF/WC_NO2=0.0
!
!SULF/WC_NO3=0.0
!
!SULF/WC_N2O5=0.0
!
!SULF/WC_HONO=0.0
!
!SULF/WC_HNO3=0.0
!
!SULF/WC_HNO4=0.0
!
!SULF/WC_NH3=0.0
!
!SULF/WC_OH=0.0
!
!SULF/WC_HO2=0.0
!
!SULF/WC_CO2=0.0
!
!SULF/WC_SO2=0.0
!
!SULF/WC_SULF=+KTC35
 PJAC(:,12,56)=+TPK%KTC35(:)
!
!SULF/WC_HCHO=0.0
!
!SULF/WC_ORA1=0.0
!
!SULF/WC_ORA2=0.0
!
!SULF/WC_MO2=0.0
!
!SULF/WC_OP1=0.0
!
!SULF/WC_ASO3=0.0
!
!SULF/WC_ASO4=0.0
!
!SULF/WC_ASO5=0.0
!
!SULF/WC_AHSO5=0.0
!
!SULF/WC_AHMS=0.0
!
!SULF/WR_O3=0.0
!
!SULF/WR_H2O2=0.0
!
!SULF/WR_NO=0.0
!
!SULF/WR_NO2=0.0
!
!SULF/WR_NO3=0.0
!
!SULF/WR_N2O5=0.0
!
!SULF/WR_HONO=0.0
!
!SULF/WR_HNO3=0.0
!
!SULF/WR_HNO4=0.0
!
!SULF/WR_NH3=0.0
!
!SULF/WR_OH=0.0
!
!SULF/WR_HO2=0.0
!
!SULF/WR_CO2=0.0
!
!SULF/WR_SO2=0.0
!
!SULF/WR_SULF=+KTR35
 PJAC(:,12,81)=+TPK%KTR35(:)
!
!SULF/WR_HCHO=0.0
!
!SULF/WR_ORA1=0.0
!
!SULF/WR_ORA2=0.0
!
!SULF/WR_MO2=0.0
!
!SULF/WR_OP1=0.0
!
!SULF/WR_ASO3=0.0
!
!SULF/WR_ASO4=0.0
!
!SULF/WR_ASO5=0.0
!
!SULF/WR_AHSO5=0.0
!
!SULF/WR_AHMS=0.0
!
!CO/O3=+0.35120*K079*<ALKE>+0.36000*K080*<BIO>+0.64728*K081*<CARBO>+0.13*K082*<
!PAN>
 PJAC(:,13,1)=+0.35120*TPK%K079(:)*PCONC(:,19)+0.36000*TPK%K080(:)*PCONC(:,20)+&
&0.64728*TPK%K081(:)*PCONC(:,25)+0.13*TPK%K082(:)*PCONC(:,27)
!
!CO/H2O2=0.0
!
!CO/NO=0.0
!
!CO/NO2=0.0
!
!CO/NO3=+K072*<HCHO>+1.33723*K074*<CARBO>
 PJAC(:,13,5)=+TPK%K072(:)*PCONC(:,22)+1.33723*TPK%K074(:)*PCONC(:,25)
!
!CO/N2O5=0.0
!
!CO/HONO=0.0
!
!CO/HNO3=0.0
!
!CO/HNO4=0.0
!
!CO/NH3=0.0
!
!CO/SO2=0.0
!
!CO/SULF=0.0
!
!CO/CO=-K053*<OH>
 PJAC(:,13,13)=-TPK%K053(:)*PCONC(:,14)
!
!CO/OH=-K053*<CO>+0.00878*K058*<ALKA>+K062*<HCHO>+1.01732*K065*<CARBO>
 PJAC(:,13,14)=-TPK%K053(:)*PCONC(:,13)+0.00878*TPK%K058(:)*PCONC(:,18)+TPK%K06&
&2(:)*PCONC(:,22)+1.01732*TPK%K065(:)*PCONC(:,25)
!
!CO/HO2=0.0
!
!CO/CH4=0.0
!
!CO/ETH=0.0
!
!CO/ALKA=+0.00878*K058*<OH>
 PJAC(:,13,18)=+0.00878*TPK%K058(:)*PCONC(:,14)
!
!CO/ALKE=+0.35120*K079*<O3>
 PJAC(:,13,19)=+0.35120*TPK%K079(:)*PCONC(:,1)
!
!CO/BIO=+0.01*K054*<O3P>+0.36000*K080*<O3>
 PJAC(:,13,20)=+0.01*TPK%K054(:)*TPK%O3P(:)+0.36000*TPK%K080(:)*PCONC(:,1)
!
!CO/ARO=0.0
!
!CO/HCHO=+K010+K011+K062*<OH>+K072*<NO3>
 PJAC(:,13,22)=+TPK%K010(:)+TPK%K011(:)+TPK%K062(:)*PCONC(:,14)+TPK%K072(:)*PCO&
&NC(:,5)
!
!CO/ALD=+K012
 PJAC(:,13,23)=+TPK%K012(:)
!
!CO/KET=0.0
!
!CO/CARBO=+0.91924*K016+1.01732*K065*<OH>+1.33723*K074*<NO3>+0.64728*K081*<O3>
 PJAC(:,13,25)=+0.91924*TPK%K016(:)+1.01732*TPK%K065(:)*PCONC(:,14)+1.33723*TPK&
&%K074(:)*PCONC(:,5)+0.64728*TPK%K081(:)*PCONC(:,1)
!
!CO/ONIT=0.0
!
!CO/PAN=+0.13*K082*<O3>
 PJAC(:,13,27)=+0.13*TPK%K082(:)*PCONC(:,1)
!
!CO/OP1=0.0
!
!CO/OP2=0.0
!
!CO/ORA1=0.0
!
!CO/ORA2=0.0
!
!CO/MO2=0.0
!
!CO/ALKAP=0.0
!
!CO/ALKEP=0.0
!
!CO/BIOP=0.0
!
!CO/PHO=0.0
!
!CO/ADD=0.0
!
!CO/AROP=0.0
!
!CO/CARBOP=0.0
!
!CO/OLN=0.0
!
!CO/XO2=0.0
!
!CO/WC_O3=0.0
!
!CO/WC_H2O2=0.0
!
!CO/WC_NO=0.0
!
!CO/WC_NO2=0.0
!
!CO/WC_NO3=0.0
!
!CO/WC_N2O5=0.0
!
!CO/WC_HONO=0.0
!
!CO/WC_HNO3=0.0
!
!CO/WC_HNO4=0.0
!
!CO/WC_NH3=0.0
!
!CO/WC_OH=0.0
!
!CO/WC_HO2=0.0
!
!CO/WC_CO2=0.0
!
!CO/WC_SO2=0.0
!
!CO/WC_SULF=0.0
!
!CO/WC_HCHO=0.0
!
!CO/WC_ORA1=0.0
!
!CO/WC_ORA2=0.0
!
!CO/WC_MO2=0.0
!
!CO/WC_OP1=0.0
!
!CO/WC_ASO3=0.0
!
!CO/WC_ASO4=0.0
!
!CO/WC_ASO5=0.0
!
!CO/WC_AHSO5=0.0
!
!CO/WC_AHMS=0.0
!
!CO/WR_O3=0.0
!
!CO/WR_H2O2=0.0
!
!CO/WR_NO=0.0
!
!CO/WR_NO2=0.0
!
!CO/WR_NO3=0.0
!
!CO/WR_N2O5=0.0
!
!CO/WR_HONO=0.0
!
!CO/WR_HNO3=0.0
!
!CO/WR_HNO4=0.0
!
!CO/WR_NH3=0.0
!
!CO/WR_OH=0.0
!
!CO/WR_HO2=0.0
!
!CO/WR_CO2=0.0
!
!CO/WR_SO2=0.0
!
!CO/WR_SULF=0.0
!
!CO/WR_HCHO=0.0
!
!CO/WR_ORA1=0.0
!
!CO/WR_ORA2=0.0
!
!CO/WR_MO2=0.0
!
!CO/WR_OP1=0.0
!
!CO/WR_ASO3=0.0
!
!CO/WR_ASO4=0.0
!
!CO/WR_ASO5=0.0
!
!CO/WR_AHSO5=0.0
!
!CO/WR_AHMS=0.0
!
!OH/O3=-K023*<OH>+K024*<HO2>+0.39435*K079*<ALKE>+0.28000*K080*<BIO>+0.20595*K08
!1*<CARBO>+0.036*K082*<PAN>+K087*<ADD>
 PJAC(:,14,1)=-TPK%K023(:)*PCONC(:,14)+TPK%K024(:)*PCONC(:,15)+0.39435*TPK%K079&
&(:)*PCONC(:,19)+0.28000*TPK%K080(:)*PCONC(:,20)+0.20595*TPK%K081(:)*PCONC(:,25&
&)+0.036*TPK%K082(:)*PCONC(:,27)+TPK%K087(:)*PCONC(:,37)
!
!OH/H2O2=+K009+K009-K026*<OH>
 PJAC(:,14,2)=+TPK%K009(:)+TPK%K009(:)-TPK%K026(:)*PCONC(:,14)
!
!OH/NO=-K032*<OH>+K035*<HO2>
 PJAC(:,14,3)=-TPK%K032(:)*PCONC(:,14)+TPK%K035(:)*PCONC(:,15)
!
!OH/NO2=-K033*<OH>
 PJAC(:,14,4)=-TPK%K033(:)*PCONC(:,14)
!
!OH/NO3=-K034*<OH>+0.7*K038*<HO2>
 PJAC(:,14,5)=-TPK%K034(:)*PCONC(:,14)+0.7*TPK%K038(:)*PCONC(:,15)
!
!OH/N2O5=0.0
!
!OH/HONO=+K004-K039*<OH>
 PJAC(:,14,7)=+TPK%K004(:)-TPK%K039(:)*PCONC(:,14)
!
!OH/HNO3=+K005-K040*<OH>
 PJAC(:,14,8)=+TPK%K005(:)-TPK%K040(:)*PCONC(:,14)
!
!OH/HNO4=+0.35*K006-K041*<OH>
 PJAC(:,14,9)=+0.35*TPK%K006(:)-TPK%K041(:)*PCONC(:,14)
!
!OH/NH3=-K050*<OH>
 PJAC(:,14,10)=-TPK%K050(:)*PCONC(:,14)
!
!OH/SO2=-K052*<OH>
 PJAC(:,14,11)=-TPK%K052(:)*PCONC(:,14)
!
!OH/SULF=0.0
!
!OH/CO=-K053*<OH>
 PJAC(:,14,13)=-TPK%K053(:)*PCONC(:,14)
!
!OH/OH=-K023*<O3>-K025*<HO2>-K026*<H2O2>-K032*<NO>-K033*<NO2>-K034*<NO3>-K039*<
!HONO>-K040*<HNO3>-K041*<HNO4>-K050*<NH3>-K051*<H2>-K052*<SO2>-K053*<CO>-K056*<
!CH4>-K057*<ETH>+0.00878*K058*<ALKA>-K058*<ALKA>-K059*<ALKE>-K060*<BIO>-K061*<A
!RO>-K062*<HCHO>-K063*<ALD>-K064*<KET>-K065*<CARBO>-K066*<ORA1>-K067*<ORA2>+0.3
!5*K068*<OP1>-K068*<OP1>+0.44925*K069*<OP2>-K069*<OP2>-K070*<PAN>-K071*<ONIT>-K
!TC11-KTR11
 PJAC(:,14,14)=-TPK%K023(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,15)-TPK%K026(:)*PCON&
&C(:,2)-TPK%K032(:)*PCONC(:,3)-TPK%K033(:)*PCONC(:,4)-TPK%K034(:)*PCONC(:,5)-TP&
&K%K039(:)*PCONC(:,7)-TPK%K040(:)*PCONC(:,8)-TPK%K041(:)*PCONC(:,9)-TPK%K050(:)&
&*PCONC(:,10)-TPK%K051(:)*TPK%H2(:)-TPK%K052(:)*PCONC(:,11)-TPK%K053(:)*PCONC(:&
&,13)-TPK%K056(:)*PCONC(:,16)-TPK%K057(:)*PCONC(:,17)+0.00878*TPK%K058(:)*PCONC&
&(:,18)-TPK%K058(:)*PCONC(:,18)-TPK%K059(:)*PCONC(:,19)-TPK%K060(:)*PCONC(:,20)&
&-TPK%K061(:)*PCONC(:,21)-TPK%K062(:)*PCONC(:,22)-TPK%K063(:)*PCONC(:,23)-TPK%K&
&064(:)*PCONC(:,24)-TPK%K065(:)*PCONC(:,25)-TPK%K066(:)*PCONC(:,30)-TPK%K067(:)&
&*PCONC(:,31)+0.35*TPK%K068(:)*PCONC(:,28)-TPK%K068(:)*PCONC(:,28)+0.44925*TPK%&
&K069(:)*PCONC(:,29)-TPK%K069(:)*PCONC(:,29)-TPK%K070(:)*PCONC(:,27)-TPK%K071(:&
&)*PCONC(:,26)-TPK%KTC11(:)-TPK%KTR11(:)
!
!OH/HO2=+K024*<O3>-K025*<OH>+K035*<NO>+0.7*K038*<NO3>
 PJAC(:,14,15)=+TPK%K024(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,14)+TPK%K035(:)*PCON&
&C(:,3)+0.7*TPK%K038(:)*PCONC(:,5)
!
!OH/CH4=-K056*<OH>
 PJAC(:,14,16)=-TPK%K056(:)*PCONC(:,14)
!
!OH/ETH=-K057*<OH>
 PJAC(:,14,17)=-TPK%K057(:)*PCONC(:,14)
!
!OH/ALKA=+0.00878*K058*<OH>-K058*<OH>
 PJAC(:,14,18)=+0.00878*TPK%K058(:)*PCONC(:,14)-TPK%K058(:)*PCONC(:,14)
!
!OH/ALKE=-K059*<OH>+0.39435*K079*<O3>
 PJAC(:,14,19)=-TPK%K059(:)*PCONC(:,14)+0.39435*TPK%K079(:)*PCONC(:,1)
!
!OH/BIO=+0.02*K054*<O3P>-K060*<OH>+0.28000*K080*<O3>
 PJAC(:,14,20)=+0.02*TPK%K054(:)*TPK%O3P(:)-TPK%K060(:)*PCONC(:,14)+0.28000*TPK&
&%K080(:)*PCONC(:,1)
!
!OH/ARO=-K061*<OH>
 PJAC(:,14,21)=-TPK%K061(:)*PCONC(:,14)
!
!OH/HCHO=-K062*<OH>
 PJAC(:,14,22)=-TPK%K062(:)*PCONC(:,14)
!
!OH/ALD=-K063*<OH>
 PJAC(:,14,23)=-TPK%K063(:)*PCONC(:,14)
!
!OH/KET=-K064*<OH>
 PJAC(:,14,24)=-TPK%K064(:)*PCONC(:,14)
!
!OH/CARBO=-K065*<OH>+0.20595*K081*<O3>
 PJAC(:,14,25)=-TPK%K065(:)*PCONC(:,14)+0.20595*TPK%K081(:)*PCONC(:,1)
!
!OH/ONIT=-K071*<OH>
 PJAC(:,14,26)=-TPK%K071(:)*PCONC(:,14)
!
!OH/PAN=-K070*<OH>+0.036*K082*<O3>
 PJAC(:,14,27)=-TPK%K070(:)*PCONC(:,14)+0.036*TPK%K082(:)*PCONC(:,1)
!
!OH/OP1=+K013+0.35*K068*<OH>-K068*<OH>
 PJAC(:,14,28)=+TPK%K013(:)+0.35*TPK%K068(:)*PCONC(:,14)-TPK%K068(:)*PCONC(:,14&
&)
!
!OH/OP2=+K014+0.44925*K069*<OH>-K069*<OH>
 PJAC(:,14,29)=+TPK%K014(:)+0.44925*TPK%K069(:)*PCONC(:,14)-TPK%K069(:)*PCONC(:&
&,14)
!
!OH/ORA1=-K066*<OH>
 PJAC(:,14,30)=-TPK%K066(:)*PCONC(:,14)
!
!OH/ORA2=-K067*<OH>
 PJAC(:,14,31)=-TPK%K067(:)*PCONC(:,14)
!
!OH/MO2=0.0
!
!OH/ALKAP=0.0
!
!OH/ALKEP=0.0
!
!OH/BIOP=0.0
!
!OH/PHO=0.0
!
!OH/ADD=+K087*<O3>
 PJAC(:,14,37)=+TPK%K087(:)*PCONC(:,1)
!
!OH/AROP=0.0
!
!OH/CARBOP=0.0
!
!OH/OLN=0.0
!
!OH/XO2=0.0
!
!OH/WC_O3=0.0
!
!OH/WC_H2O2=0.0
!
!OH/WC_NO=0.0
!
!OH/WC_NO2=0.0
!
!OH/WC_NO3=0.0
!
!OH/WC_N2O5=0.0
!
!OH/WC_HONO=0.0
!
!OH/WC_HNO3=0.0
!
!OH/WC_HNO4=0.0
!
!OH/WC_NH3=0.0
!
!OH/WC_OH=+KTC31
 PJAC(:,14,52)=+TPK%KTC31(:)
!
!OH/WC_HO2=0.0
!
!OH/WC_CO2=0.0
!
!OH/WC_SO2=0.0
!
!OH/WC_SULF=0.0
!
!OH/WC_HCHO=0.0
!
!OH/WC_ORA1=0.0
!
!OH/WC_ORA2=0.0
!
!OH/WC_MO2=0.0
!
!OH/WC_OP1=0.0
!
!OH/WC_ASO3=0.0
!
!OH/WC_ASO4=0.0
!
!OH/WC_ASO5=0.0
!
!OH/WC_AHSO5=0.0
!
!OH/WC_AHMS=0.0
!
!OH/WR_O3=0.0
!
!OH/WR_H2O2=0.0
!
!OH/WR_NO=0.0
!
!OH/WR_NO2=0.0
!
!OH/WR_NO3=0.0
!
!OH/WR_N2O5=0.0
!
!OH/WR_HONO=0.0
!
!OH/WR_HNO3=0.0
!
!OH/WR_HNO4=0.0
!
!OH/WR_NH3=0.0
!
!OH/WR_OH=+KTR31
 PJAC(:,14,77)=+TPK%KTR31(:)
!
!OH/WR_HO2=0.0
!
!OH/WR_CO2=0.0
!
!OH/WR_SO2=0.0
!
!OH/WR_SULF=0.0
!
!OH/WR_HCHO=0.0
!
!OH/WR_ORA1=0.0
!
!OH/WR_ORA2=0.0
!
!OH/WR_MO2=0.0
!
!OH/WR_OP1=0.0
!
!OH/WR_ASO3=0.0
!
!OH/WR_ASO4=0.0
!
!OH/WR_ASO5=0.0
!
!OH/WR_AHSO5=0.0
!
!OH/WR_AHMS=0.0
!
!HO2/O3=+K023*<OH>-K024*<HO2>+0.23451*K079*<ALKE>+0.30000*K080*<BIO>+0.28441*K0
!81*<CARBO>+0.08*K082*<PAN>
 PJAC(:,15,1)=+TPK%K023(:)*PCONC(:,14)-TPK%K024(:)*PCONC(:,15)+0.23451*TPK%K079&
&(:)*PCONC(:,19)+0.30000*TPK%K080(:)*PCONC(:,20)+0.28441*TPK%K081(:)*PCONC(:,25&
&)+0.08*TPK%K082(:)*PCONC(:,27)
!
!HO2/H2O2=+K026*<OH>
 PJAC(:,15,2)=+TPK%K026(:)*PCONC(:,14)
!
!HO2/NO=-K035*<HO2>+K090*<MO2>+0.74265*K091*<ALKAP>+K092*<ALKEP>+0.84700*K093*<
!BIOP>+0.95115*K094*<AROP>+0.12334*K095*<CARBOP>+0.18401*K096*<OLN>
 PJAC(:,15,3)=-TPK%K035(:)*PCONC(:,15)+TPK%K090(:)*PCONC(:,32)+0.74265*TPK%K091&
&(:)*PCONC(:,33)+TPK%K092(:)*PCONC(:,34)+0.84700*TPK%K093(:)*PCONC(:,35)+0.9511&
&5*TPK%K094(:)*PCONC(:,38)+0.12334*TPK%K095(:)*PCONC(:,39)+0.18401*TPK%K096(:)*&
&PCONC(:,40)
!
!HO2/NO2=-K036*<HO2>
 PJAC(:,15,4)=-TPK%K036(:)*PCONC(:,15)
!
!HO2/NO3=+K034*<OH>-K038*<HO2>+K072*<HCHO>+0.63217*K074*<CARBO>+K119*<MO2>+0.81
!290*K120*<ALKAP>+K121*<ALKEP>+K122*<BIOP>+K123*<AROP>+0.04915*K124*<CARBOP>+0.
!25928*K125*<OLN>
 PJAC(:,15,5)=+TPK%K034(:)*PCONC(:,14)-TPK%K038(:)*PCONC(:,15)+TPK%K072(:)*PCON&
&C(:,22)+0.63217*TPK%K074(:)*PCONC(:,25)+TPK%K119(:)*PCONC(:,32)+0.81290*TPK%K1&
&20(:)*PCONC(:,33)+TPK%K121(:)*PCONC(:,34)+TPK%K122(:)*PCONC(:,35)+TPK%K123(:)*&
&PCONC(:,38)+0.04915*TPK%K124(:)*PCONC(:,39)+0.25928*TPK%K125(:)*PCONC(:,40)
!
!HO2/N2O5=0.0
!
!HO2/HONO=0.0
!
!HO2/HNO3=0.0
!
!HO2/HNO4=+0.65*K006+K037
 PJAC(:,15,9)=+0.65*TPK%K006(:)+TPK%K037(:)
!
!HO2/NH3=0.0
!
!HO2/SO2=+K052*<OH>
 PJAC(:,15,11)=+TPK%K052(:)*PCONC(:,14)
!
!HO2/SULF=0.0
!
!HO2/CO=+K053*<OH>
 PJAC(:,15,13)=+TPK%K053(:)*PCONC(:,14)
!
!HO2/OH=+K023*<O3>-K025*<HO2>+K026*<H2O2>+K034*<NO3>+K051*<H2>+K052*<SO2>+K053*
!<CO>+0.12793*K058*<ALKA>+0.10318*K061*<ARO>+K062*<HCHO>+0.51208*K065*<CARBO>+K
!066*<ORA1>+0.02915*K069*<OP2>+0.28107*K070*<PAN>
 PJAC(:,15,14)=+TPK%K023(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,15)+TPK%K026(:)*PCON&
&C(:,2)+TPK%K034(:)*PCONC(:,5)+TPK%K051(:)*TPK%H2(:)+TPK%K052(:)*PCONC(:,11)+TP&
&K%K053(:)*PCONC(:,13)+0.12793*TPK%K058(:)*PCONC(:,18)+0.10318*TPK%K061(:)*PCON&
&C(:,21)+TPK%K062(:)*PCONC(:,22)+0.51208*TPK%K065(:)*PCONC(:,25)+TPK%K066(:)*PC&
&ONC(:,30)+0.02915*TPK%K069(:)*PCONC(:,29)+0.28107*TPK%K070(:)*PCONC(:,27)
!
!HO2/HO2=-K024*<O3>-K025*<OH>-K027*<HO2>-K027*<HO2>-K027*<HO2>-K027*<HO2>-K028*
!<HO2>*<H2O>-K028*<HO2>*<H2O>-K028*<HO2>*<H2O>-K028*<HO2>*<H2O>-K035*<NO>-K036*
!<NO2>-K038*<NO3>-K084*<PHO>-K097*<MO2>-K098*<ALKAP>-K099*<ALKEP>-K0100*<BIOP>-
!K0101*<AROP>-K0102*<CARBOP>-K103*<OLN>-K126*<XO2>-KTC12-KTR12
 PJAC(:,15,15)=-TPK%K024(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,14)-TPK%K027(:)*PCON&
&C(:,15)-TPK%K027(:)*PCONC(:,15)-TPK%K027(:)*PCONC(:,15)-TPK%K027(:)*PCONC(:,15&
&)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K0&
&28(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K035(:)*PC&
&ONC(:,3)-TPK%K036(:)*PCONC(:,4)-TPK%K038(:)*PCONC(:,5)-TPK%K084(:)*PCONC(:,36)&
&-TPK%K097(:)*PCONC(:,32)-TPK%K098(:)*PCONC(:,33)-TPK%K099(:)*PCONC(:,34)-TPK%K&
&0100(:)*PCONC(:,35)-TPK%K0101(:)*PCONC(:,38)-TPK%K0102(:)*PCONC(:,39)-TPK%K103&
&(:)*PCONC(:,40)-TPK%K126(:)*PCONC(:,41)-TPK%KTC12(:)-TPK%KTR12(:)
!
!HO2/CH4=0.0
!
!HO2/ETH=0.0
!
!HO2/ALKA=+0.12793*K058*<OH>
 PJAC(:,15,18)=+0.12793*TPK%K058(:)*PCONC(:,14)
!
!HO2/ALKE=+0.23451*K079*<O3>
 PJAC(:,15,19)=+0.23451*TPK%K079(:)*PCONC(:,1)
!
!HO2/BIO=+0.28*K054*<O3P>+0.30000*K080*<O3>
 PJAC(:,15,20)=+0.28*TPK%K054(:)*TPK%O3P(:)+0.30000*TPK%K080(:)*PCONC(:,1)
!
!HO2/ARO=+0.10318*K061*<OH>
 PJAC(:,15,21)=+0.10318*TPK%K061(:)*PCONC(:,14)
!
!HO2/HCHO=+K011+K011+K062*<OH>+K072*<NO3>
 PJAC(:,15,22)=+TPK%K011(:)+TPK%K011(:)+TPK%K062(:)*PCONC(:,14)+TPK%K072(:)*PCO&
&NC(:,5)
!
!HO2/ALD=+K012
 PJAC(:,15,23)=+TPK%K012(:)
!
!HO2/KET=0.0
!
!HO2/CARBO=+0.75830*K016+0.51208*K065*<OH>+0.63217*K074*<NO3>+0.28441*K081*<O3>
 PJAC(:,15,25)=+0.75830*TPK%K016(:)+0.51208*TPK%K065(:)*PCONC(:,14)+0.63217*TPK&
&%K074(:)*PCONC(:,5)+0.28441*TPK%K081(:)*PCONC(:,1)
!
!HO2/ONIT=+K017
 PJAC(:,15,26)=+TPK%K017(:)
!
!HO2/PAN=+0.28107*K070*<OH>+0.08*K082*<O3>
 PJAC(:,15,27)=+0.28107*TPK%K070(:)*PCONC(:,14)+0.08*TPK%K082(:)*PCONC(:,1)
!
!HO2/OP1=+K013
 PJAC(:,15,28)=+TPK%K013(:)
!
!HO2/OP2=+0.96205*K014+0.02915*K069*<OH>
 PJAC(:,15,29)=+0.96205*TPK%K014(:)+0.02915*TPK%K069(:)*PCONC(:,14)
!
!HO2/ORA1=+K066*<OH>
 PJAC(:,15,30)=+TPK%K066(:)*PCONC(:,14)
!
!HO2/ORA2=0.0
!
!HO2/MO2=+K090*<NO>-K097*<HO2>+0.66*K104*<MO2>+0.66*K104*<MO2>+0.98383*K105*<AL
!KAP>+K106*<ALKEP>+1.00000*K107*<BIOP>+1.02767*K108*<AROP>+0.82998*K109*<CARBOP
!>+0.67560*K110*<OLN>+K119*<NO3>+K127*<XO2>
 PJAC(:,15,32)=+TPK%K090(:)*PCONC(:,3)-TPK%K097(:)*PCONC(:,15)+0.66*TPK%K104(:)&
&*PCONC(:,32)+0.66*TPK%K104(:)*PCONC(:,32)+0.98383*TPK%K105(:)*PCONC(:,33)+TPK%&
&K106(:)*PCONC(:,34)+1.00000*TPK%K107(:)*PCONC(:,35)+1.02767*TPK%K108(:)*PCONC(&
&:,38)+0.82998*TPK%K109(:)*PCONC(:,39)+0.67560*TPK%K110(:)*PCONC(:,40)+TPK%K119&
&(:)*PCONC(:,5)+TPK%K127(:)*PCONC(:,41)
!
!HO2/ALKAP=+0.74265*K091*<NO>-K098*<HO2>+0.98383*K105*<MO2>+0.48079*K111*<CARBO
!P>+0.81290*K120*<NO3>
 PJAC(:,15,33)=+0.74265*TPK%K091(:)*PCONC(:,3)-TPK%K098(:)*PCONC(:,15)+0.98383*&
&TPK%K105(:)*PCONC(:,32)+0.48079*TPK%K111(:)*PCONC(:,39)+0.81290*TPK%K120(:)*PC&
&ONC(:,5)
!
!HO2/ALKEP=+K092*<NO>-K099*<HO2>+K106*<MO2>+0.50078*K112*<CARBOP>+K121*<NO3>
 PJAC(:,15,34)=+TPK%K092(:)*PCONC(:,3)-TPK%K099(:)*PCONC(:,15)+TPK%K106(:)*PCON&
&C(:,32)+0.50078*TPK%K112(:)*PCONC(:,39)+TPK%K121(:)*PCONC(:,5)
!
!HO2/BIOP=+0.84700*K093*<NO>-K0100*<HO2>+1.00000*K107*<MO2>+0.50600*K113*<CARBO
!P>+K122*<NO3>
 PJAC(:,15,35)=+0.84700*TPK%K093(:)*PCONC(:,3)-TPK%K0100(:)*PCONC(:,15)+1.00000&
&*TPK%K107(:)*PCONC(:,32)+0.50600*TPK%K113(:)*PCONC(:,39)+TPK%K122(:)*PCONC(:,5&
&)
!
!HO2/PHO=-K084*<HO2>
 PJAC(:,15,36)=-TPK%K084(:)*PCONC(:,15)
!
!HO2/ADD=+0.02*K086*<O2>
 PJAC(:,15,37)=+0.02*TPK%K086(:)*TPK%O2(:)
!
!HO2/AROP=+0.95115*K094*<NO>-K0101*<HO2>+1.02767*K108*<MO2>+K114*<CARBOP>+K123*
!<NO3>
 PJAC(:,15,38)=+0.95115*TPK%K094(:)*PCONC(:,3)-TPK%K0101(:)*PCONC(:,15)+1.02767&
&*TPK%K108(:)*PCONC(:,32)+TPK%K114(:)*PCONC(:,39)+TPK%K123(:)*PCONC(:,5)
!
!HO2/CARBOP=+0.12334*K095*<NO>-K0102*<HO2>+0.82998*K109*<MO2>+0.48079*K111*<ALK
!AP>+0.50078*K112*<ALKEP>+0.50600*K113*<BIOP>+K114*<AROP>+0.07566*K115*<CARBOP>
!+0.07566*K115*<CARBOP>+0.17599*K116*<OLN>+0.04915*K124*<NO3>
 PJAC(:,15,39)=+0.12334*TPK%K095(:)*PCONC(:,3)-TPK%K0102(:)*PCONC(:,15)+0.82998&
&*TPK%K109(:)*PCONC(:,32)+0.48079*TPK%K111(:)*PCONC(:,33)+0.50078*TPK%K112(:)*P&
&CONC(:,34)+0.50600*TPK%K113(:)*PCONC(:,35)+TPK%K114(:)*PCONC(:,38)+0.07566*TPK&
&%K115(:)*PCONC(:,39)+0.07566*TPK%K115(:)*PCONC(:,39)+0.17599*TPK%K116(:)*PCONC&
&(:,40)+0.04915*TPK%K124(:)*PCONC(:,5)
!
!HO2/OLN=+0.18401*K096*<NO>-K103*<HO2>+0.67560*K110*<MO2>+0.17599*K116*<CARBOP>
!+K117*<OLN>+K117*<OLN>+0.00000*K118*<OLN>+0.00000*K118*<OLN>+0.25928*K125*<NO3
!>
 PJAC(:,15,40)=+0.18401*TPK%K096(:)*PCONC(:,3)-TPK%K103(:)*PCONC(:,15)+0.67560*&
&TPK%K110(:)*PCONC(:,32)+0.17599*TPK%K116(:)*PCONC(:,39)+TPK%K117(:)*PCONC(:,40&
&)+TPK%K117(:)*PCONC(:,40)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K118(:)*&
&PCONC(:,40)+0.25928*TPK%K125(:)*PCONC(:,5)
!
!HO2/XO2=-K126*<HO2>+K127*<MO2>
 PJAC(:,15,41)=-TPK%K126(:)*PCONC(:,15)+TPK%K127(:)*PCONC(:,32)
!
!HO2/WC_O3=0.0
!
!HO2/WC_H2O2=0.0
!
!HO2/WC_NO=0.0
!
!HO2/WC_NO2=0.0
!
!HO2/WC_NO3=0.0
!
!HO2/WC_N2O5=0.0
!
!HO2/WC_HONO=0.0
!
!HO2/WC_HNO3=0.0
!
!HO2/WC_HNO4=0.0
!
!HO2/WC_NH3=0.0
!
!HO2/WC_OH=0.0
!
!HO2/WC_HO2=+KTC32
 PJAC(:,15,53)=+TPK%KTC32(:)
!
!HO2/WC_CO2=0.0
!
!HO2/WC_SO2=0.0
!
!HO2/WC_SULF=0.0
!
!HO2/WC_HCHO=0.0
!
!HO2/WC_ORA1=0.0
!
!HO2/WC_ORA2=0.0
!
!HO2/WC_MO2=0.0
!
!HO2/WC_OP1=0.0
!
!HO2/WC_ASO3=0.0
!
!HO2/WC_ASO4=0.0
!
!HO2/WC_ASO5=0.0
!
!HO2/WC_AHSO5=0.0
!
!HO2/WC_AHMS=0.0
!
!HO2/WR_O3=0.0
!
!HO2/WR_H2O2=0.0
!
!HO2/WR_NO=0.0
!
!HO2/WR_NO2=0.0
!
!HO2/WR_NO3=0.0
!
!HO2/WR_N2O5=0.0
!
!HO2/WR_HONO=0.0
!
!HO2/WR_HNO3=0.0
!
!HO2/WR_HNO4=0.0
!
!HO2/WR_NH3=0.0
!
!HO2/WR_OH=0.0
!
!HO2/WR_HO2=+KTR32
 PJAC(:,15,78)=+TPK%KTR32(:)
!
!HO2/WR_CO2=0.0
!
!HO2/WR_SO2=0.0
!
!HO2/WR_SULF=0.0
!
!HO2/WR_HCHO=0.0
!
!HO2/WR_ORA1=0.0
!
!HO2/WR_ORA2=0.0
!
!HO2/WR_MO2=0.0
!
!HO2/WR_OP1=0.0
!
!HO2/WR_ASO3=0.0
!
!HO2/WR_ASO4=0.0
!
!HO2/WR_ASO5=0.0
!
!HO2/WR_AHSO5=0.0
!
!HO2/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ2
!
SUBROUTINE SUBJ3
!
!Indices 16 a 20
!
!
!CH4/O3=+0.04300*K079*<ALKE>
 PJAC(:,16,1)=+0.04300*TPK%K079(:)*PCONC(:,19)
!
!CH4/H2O2=0.0
!
!CH4/NO=0.0
!
!CH4/NO2=0.0
!
!CH4/NO3=0.0
!
!CH4/N2O5=0.0
!
!CH4/HONO=0.0
!
!CH4/HNO3=0.0
!
!CH4/HNO4=0.0
!
!CH4/NH3=0.0
!
!CH4/SO2=0.0
!
!CH4/SULF=0.0
!
!CH4/CO=0.0
!
!CH4/OH=-K056*<CH4>
 PJAC(:,16,14)=-TPK%K056(:)*PCONC(:,16)
!
!CH4/HO2=0.0
!
!CH4/CH4=-K056*<OH>
 PJAC(:,16,16)=-TPK%K056(:)*PCONC(:,14)
!
!CH4/ETH=0.0
!
!CH4/ALKA=0.0
!
!CH4/ALKE=+0.04300*K079*<O3>
 PJAC(:,16,19)=+0.04300*TPK%K079(:)*PCONC(:,1)
!
!CH4/BIO=0.0
!
!CH4/ARO=0.0
!
!CH4/HCHO=0.0
!
!CH4/ALD=0.0
!
!CH4/KET=0.0
!
!CH4/CARBO=0.0
!
!CH4/ONIT=0.0
!
!CH4/PAN=0.0
!
!CH4/OP1=0.0
!
!CH4/OP2=0.0
!
!CH4/ORA1=0.0
!
!CH4/ORA2=0.0
!
!CH4/MO2=0.0
!
!CH4/ALKAP=0.0
!
!CH4/ALKEP=0.0
!
!CH4/BIOP=0.0
!
!CH4/PHO=0.0
!
!CH4/ADD=0.0
!
!CH4/AROP=0.0
!
!CH4/CARBOP=0.0
!
!CH4/OLN=0.0
!
!CH4/XO2=0.0
!
!CH4/WC_O3=0.0
!
!CH4/WC_H2O2=0.0
!
!CH4/WC_NO=0.0
!
!CH4/WC_NO2=0.0
!
!CH4/WC_NO3=0.0
!
!CH4/WC_N2O5=0.0
!
!CH4/WC_HONO=0.0
!
!CH4/WC_HNO3=0.0
!
!CH4/WC_HNO4=0.0
!
!CH4/WC_NH3=0.0
!
!CH4/WC_OH=0.0
!
!CH4/WC_HO2=0.0
!
!CH4/WC_CO2=0.0
!
!CH4/WC_SO2=0.0
!
!CH4/WC_SULF=0.0
!
!CH4/WC_HCHO=0.0
!
!CH4/WC_ORA1=0.0
!
!CH4/WC_ORA2=0.0
!
!CH4/WC_MO2=0.0
!
!CH4/WC_OP1=0.0
!
!CH4/WC_ASO3=0.0
!
!CH4/WC_ASO4=0.0
!
!CH4/WC_ASO5=0.0
!
!CH4/WC_AHSO5=0.0
!
!CH4/WC_AHMS=0.0
!
!CH4/WR_O3=0.0
!
!CH4/WR_H2O2=0.0
!
!CH4/WR_NO=0.0
!
!CH4/WR_NO2=0.0
!
!CH4/WR_NO3=0.0
!
!CH4/WR_N2O5=0.0
!
!CH4/WR_HONO=0.0
!
!CH4/WR_HNO3=0.0
!
!CH4/WR_HNO4=0.0
!
!CH4/WR_NH3=0.0
!
!CH4/WR_OH=0.0
!
!CH4/WR_HO2=0.0
!
!CH4/WR_CO2=0.0
!
!CH4/WR_SO2=0.0
!
!CH4/WR_SULF=0.0
!
!CH4/WR_HCHO=0.0
!
!CH4/WR_ORA1=0.0
!
!CH4/WR_ORA2=0.0
!
!CH4/WR_MO2=0.0
!
!CH4/WR_OP1=0.0
!
!CH4/WR_ASO3=0.0
!
!CH4/WR_ASO4=0.0
!
!CH4/WR_ASO5=0.0
!
!CH4/WR_AHSO5=0.0
!
!CH4/WR_AHMS=0.0
!
!ETH/O3=+0.03196*K079*<ALKE>
 PJAC(:,17,1)=+0.03196*TPK%K079(:)*PCONC(:,19)
!
!ETH/H2O2=0.0
!
!ETH/NO=0.0
!
!ETH/NO2=0.0
!
!ETH/NO3=0.0
!
!ETH/N2O5=0.0
!
!ETH/HONO=0.0
!
!ETH/HNO3=0.0
!
!ETH/HNO4=0.0
!
!ETH/NH3=0.0
!
!ETH/SO2=0.0
!
!ETH/SULF=0.0
!
!ETH/CO=0.0
!
!ETH/OH=-K057*<ETH>
 PJAC(:,17,14)=-TPK%K057(:)*PCONC(:,17)
!
!ETH/HO2=0.0
!
!ETH/CH4=0.0
!
!ETH/ETH=-K057*<OH>
 PJAC(:,17,17)=-TPK%K057(:)*PCONC(:,14)
!
!ETH/ALKA=0.0
!
!ETH/ALKE=+0.03196*K079*<O3>
 PJAC(:,17,19)=+0.03196*TPK%K079(:)*PCONC(:,1)
!
!ETH/BIO=0.0
!
!ETH/ARO=0.0
!
!ETH/HCHO=0.0
!
!ETH/ALD=0.0
!
!ETH/KET=0.0
!
!ETH/CARBO=0.0
!
!ETH/ONIT=0.0
!
!ETH/PAN=0.0
!
!ETH/OP1=0.0
!
!ETH/OP2=0.0
!
!ETH/ORA1=0.0
!
!ETH/ORA2=0.0
!
!ETH/MO2=0.0
!
!ETH/ALKAP=0.0
!
!ETH/ALKEP=0.0
!
!ETH/BIOP=0.0
!
!ETH/PHO=0.0
!
!ETH/ADD=0.0
!
!ETH/AROP=0.0
!
!ETH/CARBOP=0.0
!
!ETH/OLN=0.0
!
!ETH/XO2=0.0
!
!ETH/WC_O3=0.0
!
!ETH/WC_H2O2=0.0
!
!ETH/WC_NO=0.0
!
!ETH/WC_NO2=0.0
!
!ETH/WC_NO3=0.0
!
!ETH/WC_N2O5=0.0
!
!ETH/WC_HONO=0.0
!
!ETH/WC_HNO3=0.0
!
!ETH/WC_HNO4=0.0
!
!ETH/WC_NH3=0.0
!
!ETH/WC_OH=0.0
!
!ETH/WC_HO2=0.0
!
!ETH/WC_CO2=0.0
!
!ETH/WC_SO2=0.0
!
!ETH/WC_SULF=0.0
!
!ETH/WC_HCHO=0.0
!
!ETH/WC_ORA1=0.0
!
!ETH/WC_ORA2=0.0
!
!ETH/WC_MO2=0.0
!
!ETH/WC_OP1=0.0
!
!ETH/WC_ASO3=0.0
!
!ETH/WC_ASO4=0.0
!
!ETH/WC_ASO5=0.0
!
!ETH/WC_AHSO5=0.0
!
!ETH/WC_AHMS=0.0
!
!ETH/WR_O3=0.0
!
!ETH/WR_H2O2=0.0
!
!ETH/WR_NO=0.0
!
!ETH/WR_NO2=0.0
!
!ETH/WR_NO3=0.0
!
!ETH/WR_N2O5=0.0
!
!ETH/WR_HONO=0.0
!
!ETH/WR_HNO3=0.0
!
!ETH/WR_HNO4=0.0
!
!ETH/WR_NH3=0.0
!
!ETH/WR_OH=0.0
!
!ETH/WR_HO2=0.0
!
!ETH/WR_CO2=0.0
!
!ETH/WR_SO2=0.0
!
!ETH/WR_SULF=0.0
!
!ETH/WR_HCHO=0.0
!
!ETH/WR_ORA1=0.0
!
!ETH/WR_ORA2=0.0
!
!ETH/WR_MO2=0.0
!
!ETH/WR_OP1=0.0
!
!ETH/WR_ASO3=0.0
!
!ETH/WR_ASO4=0.0
!
!ETH/WR_ASO5=0.0
!
!ETH/WR_AHSO5=0.0
!
!ETH/WR_AHMS=0.0
!
!ALKA/O3=0.0
!
!ALKA/H2O2=0.0
!
!ALKA/NO=0.0
!
!ALKA/NO2=0.0
!
!ALKA/NO3=0.0
!
!ALKA/N2O5=0.0
!
!ALKA/HONO=0.0
!
!ALKA/HNO3=0.0
!
!ALKA/HNO4=0.0
!
!ALKA/NH3=0.0
!
!ALKA/SO2=0.0
!
!ALKA/SULF=0.0
!
!ALKA/CO=0.0
!
!ALKA/OH=-K058*<ALKA>
 PJAC(:,18,14)=-TPK%K058(:)*PCONC(:,18)
!
!ALKA/HO2=0.0
!
!ALKA/CH4=0.0
!
!ALKA/ETH=0.0
!
!ALKA/ALKA=-K058*<OH>
 PJAC(:,18,18)=-TPK%K058(:)*PCONC(:,14)
!
!ALKA/ALKE=0.0
!
!ALKA/BIO=0.0
!
!ALKA/ARO=0.0
!
!ALKA/HCHO=0.0
!
!ALKA/ALD=0.0
!
!ALKA/KET=0.0
!
!ALKA/CARBO=0.0
!
!ALKA/ONIT=0.0
!
!ALKA/PAN=0.0
!
!ALKA/OP1=0.0
!
!ALKA/OP2=0.0
!
!ALKA/ORA1=0.0
!
!ALKA/ORA2=0.0
!
!ALKA/MO2=0.0
!
!ALKA/ALKAP=0.0
!
!ALKA/ALKEP=0.0
!
!ALKA/BIOP=0.0
!
!ALKA/PHO=0.0
!
!ALKA/ADD=0.0
!
!ALKA/AROP=0.0
!
!ALKA/CARBOP=0.0
!
!ALKA/OLN=0.0
!
!ALKA/XO2=0.0
!
!ALKA/WC_O3=0.0
!
!ALKA/WC_H2O2=0.0
!
!ALKA/WC_NO=0.0
!
!ALKA/WC_NO2=0.0
!
!ALKA/WC_NO3=0.0
!
!ALKA/WC_N2O5=0.0
!
!ALKA/WC_HONO=0.0
!
!ALKA/WC_HNO3=0.0
!
!ALKA/WC_HNO4=0.0
!
!ALKA/WC_NH3=0.0
!
!ALKA/WC_OH=0.0
!
!ALKA/WC_HO2=0.0
!
!ALKA/WC_CO2=0.0
!
!ALKA/WC_SO2=0.0
!
!ALKA/WC_SULF=0.0
!
!ALKA/WC_HCHO=0.0
!
!ALKA/WC_ORA1=0.0
!
!ALKA/WC_ORA2=0.0
!
!ALKA/WC_MO2=0.0
!
!ALKA/WC_OP1=0.0
!
!ALKA/WC_ASO3=0.0
!
!ALKA/WC_ASO4=0.0
!
!ALKA/WC_ASO5=0.0
!
!ALKA/WC_AHSO5=0.0
!
!ALKA/WC_AHMS=0.0
!
!ALKA/WR_O3=0.0
!
!ALKA/WR_H2O2=0.0
!
!ALKA/WR_NO=0.0
!
!ALKA/WR_NO2=0.0
!
!ALKA/WR_NO3=0.0
!
!ALKA/WR_N2O5=0.0
!
!ALKA/WR_HONO=0.0
!
!ALKA/WR_HNO3=0.0
!
!ALKA/WR_HNO4=0.0
!
!ALKA/WR_NH3=0.0
!
!ALKA/WR_OH=0.0
!
!ALKA/WR_HO2=0.0
!
!ALKA/WR_CO2=0.0
!
!ALKA/WR_SO2=0.0
!
!ALKA/WR_SULF=0.0
!
!ALKA/WR_HCHO=0.0
!
!ALKA/WR_ORA1=0.0
!
!ALKA/WR_ORA2=0.0
!
!ALKA/WR_MO2=0.0
!
!ALKA/WR_OP1=0.0
!
!ALKA/WR_ASO3=0.0
!
!ALKA/WR_ASO4=0.0
!
!ALKA/WR_ASO5=0.0
!
!ALKA/WR_AHSO5=0.0
!
!ALKA/WR_AHMS=0.0
!
!ALKE/O3=+0.00000*K079*<ALKE>-K079*<ALKE>+0.37388*K080*<BIO>
 PJAC(:,19,1)=+0.00000*TPK%K079(:)*PCONC(:,19)-TPK%K079(:)*PCONC(:,19)+0.37388*&
&TPK%K080(:)*PCONC(:,20)
!
!ALKE/H2O2=0.0
!
!ALKE/NO=+0.37815*K093*<BIOP>
 PJAC(:,19,3)=+0.37815*TPK%K093(:)*PCONC(:,35)
!
!ALKE/NO2=0.0
!
!ALKE/NO3=-K076*<ALKE>+0.42729*K122*<BIOP>
 PJAC(:,19,5)=-TPK%K076(:)*PCONC(:,19)+0.42729*TPK%K122(:)*PCONC(:,35)
!
!ALKE/N2O5=0.0
!
!ALKE/HONO=0.0
!
!ALKE/HNO3=0.0
!
!ALKE/HNO4=0.0
!
!ALKE/NH3=0.0
!
!ALKE/SO2=0.0
!
!ALKE/SULF=0.0
!
!ALKE/CO=0.0
!
!ALKE/OH=-K059*<ALKE>
 PJAC(:,19,14)=-TPK%K059(:)*PCONC(:,19)
!
!ALKE/HO2=0.0
!
!ALKE/CH4=0.0
!
!ALKE/ETH=0.0
!
!ALKE/ALKA=0.0
!
!ALKE/ALKE=-K059*<OH>-K076*<NO3>+0.00000*K079*<O3>-K079*<O3>
 PJAC(:,19,19)=-TPK%K059(:)*PCONC(:,14)-TPK%K076(:)*PCONC(:,5)+0.00000*TPK%K079&
&(:)*PCONC(:,1)-TPK%K079(:)*PCONC(:,1)
!
!ALKE/BIO=+0.91868*K054*<O3P>+0.37388*K080*<O3>
 PJAC(:,19,20)=+0.91868*TPK%K054(:)*TPK%O3P(:)+0.37388*TPK%K080(:)*PCONC(:,1)
!
!ALKE/ARO=0.0
!
!ALKE/HCHO=0.0
!
!ALKE/ALD=0.0
!
!ALKE/KET=0.0
!
!ALKE/CARBO=0.0
!
!ALKE/ONIT=0.0
!
!ALKE/PAN=0.0
!
!ALKE/OP1=0.0
!
!ALKE/OP2=0.0
!
!ALKE/ORA1=0.0
!
!ALKE/ORA2=0.0
!
!ALKE/MO2=+0.48074*K107*<BIOP>
 PJAC(:,19,32)=+0.48074*TPK%K107(:)*PCONC(:,35)
!
!ALKE/ALKAP=0.0
!
!ALKE/ALKEP=0.0
!
!ALKE/BIOP=+0.37815*K093*<NO>+0.48074*K107*<MO2>+0.24463*K113*<CARBOP>+0.42729*
!K122*<NO3>
 PJAC(:,19,35)=+0.37815*TPK%K093(:)*PCONC(:,3)+0.48074*TPK%K107(:)*PCONC(:,32)+&
&0.24463*TPK%K113(:)*PCONC(:,39)+0.42729*TPK%K122(:)*PCONC(:,5)
!
!ALKE/PHO=0.0
!
!ALKE/ADD=0.0
!
!ALKE/AROP=0.0
!
!ALKE/CARBOP=+0.24463*K113*<BIOP>
 PJAC(:,19,39)=+0.24463*TPK%K113(:)*PCONC(:,35)
!
!ALKE/OLN=0.0
!
!ALKE/XO2=0.0
!
!ALKE/WC_O3=0.0
!
!ALKE/WC_H2O2=0.0
!
!ALKE/WC_NO=0.0
!
!ALKE/WC_NO2=0.0
!
!ALKE/WC_NO3=0.0
!
!ALKE/WC_N2O5=0.0
!
!ALKE/WC_HONO=0.0
!
!ALKE/WC_HNO3=0.0
!
!ALKE/WC_HNO4=0.0
!
!ALKE/WC_NH3=0.0
!
!ALKE/WC_OH=0.0
!
!ALKE/WC_HO2=0.0
!
!ALKE/WC_CO2=0.0
!
!ALKE/WC_SO2=0.0
!
!ALKE/WC_SULF=0.0
!
!ALKE/WC_HCHO=0.0
!
!ALKE/WC_ORA1=0.0
!
!ALKE/WC_ORA2=0.0
!
!ALKE/WC_MO2=0.0
!
!ALKE/WC_OP1=0.0
!
!ALKE/WC_ASO3=0.0
!
!ALKE/WC_ASO4=0.0
!
!ALKE/WC_ASO5=0.0
!
!ALKE/WC_AHSO5=0.0
!
!ALKE/WC_AHMS=0.0
!
!ALKE/WR_O3=0.0
!
!ALKE/WR_H2O2=0.0
!
!ALKE/WR_NO=0.0
!
!ALKE/WR_NO2=0.0
!
!ALKE/WR_NO3=0.0
!
!ALKE/WR_N2O5=0.0
!
!ALKE/WR_HONO=0.0
!
!ALKE/WR_HNO3=0.0
!
!ALKE/WR_HNO4=0.0
!
!ALKE/WR_NH3=0.0
!
!ALKE/WR_OH=0.0
!
!ALKE/WR_HO2=0.0
!
!ALKE/WR_CO2=0.0
!
!ALKE/WR_SO2=0.0
!
!ALKE/WR_SULF=0.0
!
!ALKE/WR_HCHO=0.0
!
!ALKE/WR_ORA1=0.0
!
!ALKE/WR_ORA2=0.0
!
!ALKE/WR_MO2=0.0
!
!ALKE/WR_OP1=0.0
!
!ALKE/WR_ASO3=0.0
!
!ALKE/WR_ASO4=0.0
!
!ALKE/WR_ASO5=0.0
!
!ALKE/WR_AHSO5=0.0
!
!ALKE/WR_AHMS=0.0
!
!BIO/O3=-K080*<BIO>
 PJAC(:,20,1)=-TPK%K080(:)*PCONC(:,20)
!
!BIO/H2O2=0.0
!
!BIO/NO=0.0
!
!BIO/NO2=0.0
!
!BIO/NO3=-K077*<BIO>
 PJAC(:,20,5)=-TPK%K077(:)*PCONC(:,20)
!
!BIO/N2O5=0.0
!
!BIO/HONO=0.0
!
!BIO/HNO3=0.0
!
!BIO/HNO4=0.0
!
!BIO/NH3=0.0
!
!BIO/SO2=0.0
!
!BIO/SULF=0.0
!
!BIO/CO=0.0
!
!BIO/OH=-K060*<BIO>
 PJAC(:,20,14)=-TPK%K060(:)*PCONC(:,20)
!
!BIO/HO2=0.0
!
!BIO/CH4=0.0
!
!BIO/ETH=0.0
!
!BIO/ALKA=0.0
!
!BIO/ALKE=0.0
!
!BIO/BIO=-K054*<O3P>-K060*<OH>-K077*<NO3>-K080*<O3>
 PJAC(:,20,20)=-TPK%K054(:)*TPK%O3P(:)-TPK%K060(:)*PCONC(:,14)-TPK%K077(:)*PCON&
&C(:,5)-TPK%K080(:)*PCONC(:,1)
!
!BIO/ARO=0.0
!
!BIO/HCHO=0.0
!
!BIO/ALD=0.0
!
!BIO/KET=0.0
!
!BIO/CARBO=0.0
!
!BIO/ONIT=0.0
!
!BIO/PAN=0.0
!
!BIO/OP1=0.0
!
!BIO/OP2=0.0
!
!BIO/ORA1=0.0
!
!BIO/ORA2=0.0
!
!BIO/MO2=0.0
!
!BIO/ALKAP=0.0
!
!BIO/ALKEP=0.0
!
!BIO/BIOP=0.0
!
!BIO/PHO=0.0
!
!BIO/ADD=0.0
!
!BIO/AROP=0.0
!
!BIO/CARBOP=0.0
!
!BIO/OLN=0.0
!
!BIO/XO2=0.0
!
!BIO/WC_O3=0.0
!
!BIO/WC_H2O2=0.0
!
!BIO/WC_NO=0.0
!
!BIO/WC_NO2=0.0
!
!BIO/WC_NO3=0.0
!
!BIO/WC_N2O5=0.0
!
!BIO/WC_HONO=0.0
!
!BIO/WC_HNO3=0.0
!
!BIO/WC_HNO4=0.0
!
!BIO/WC_NH3=0.0
!
!BIO/WC_OH=0.0
!
!BIO/WC_HO2=0.0
!
!BIO/WC_CO2=0.0
!
!BIO/WC_SO2=0.0
!
!BIO/WC_SULF=0.0
!
!BIO/WC_HCHO=0.0
!
!BIO/WC_ORA1=0.0
!
!BIO/WC_ORA2=0.0
!
!BIO/WC_MO2=0.0
!
!BIO/WC_OP1=0.0
!
!BIO/WC_ASO3=0.0
!
!BIO/WC_ASO4=0.0
!
!BIO/WC_ASO5=0.0
!
!BIO/WC_AHSO5=0.0
!
!BIO/WC_AHMS=0.0
!
!BIO/WR_O3=0.0
!
!BIO/WR_H2O2=0.0
!
!BIO/WR_NO=0.0
!
!BIO/WR_NO2=0.0
!
!BIO/WR_NO3=0.0
!
!BIO/WR_N2O5=0.0
!
!BIO/WR_HONO=0.0
!
!BIO/WR_HNO3=0.0
!
!BIO/WR_HNO4=0.0
!
!BIO/WR_NH3=0.0
!
!BIO/WR_OH=0.0
!
!BIO/WR_HO2=0.0
!
!BIO/WR_CO2=0.0
!
!BIO/WR_SO2=0.0
!
!BIO/WR_SULF=0.0
!
!BIO/WR_HCHO=0.0
!
!BIO/WR_ORA1=0.0
!
!BIO/WR_ORA2=0.0
!
!BIO/WR_MO2=0.0
!
!BIO/WR_OP1=0.0
!
!BIO/WR_ASO3=0.0
!
!BIO/WR_ASO4=0.0
!
!BIO/WR_ASO5=0.0
!
!BIO/WR_AHSO5=0.0
!
!BIO/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ3
!
SUBROUTINE SUBJ4
!
!Indices 21 a 25
!
!
!ARO/O3=+K087*<ADD>
 PJAC(:,21,1)=+TPK%K087(:)*PCONC(:,37)
!
!ARO/H2O2=0.0
!
!ARO/NO=0.0
!
!ARO/NO2=+0.10670*K083*<PHO>+K085*<ADD>
 PJAC(:,21,4)=+0.10670*TPK%K083(:)*PCONC(:,36)+TPK%K085(:)*PCONC(:,37)
!
!ARO/NO3=-K075*<ARO>
 PJAC(:,21,5)=-TPK%K075(:)*PCONC(:,21)
!
!ARO/N2O5=0.0
!
!ARO/HONO=0.0
!
!ARO/HNO3=0.0
!
!ARO/HNO4=0.0
!
!ARO/NH3=0.0
!
!ARO/SO2=0.0
!
!ARO/SULF=0.0
!
!ARO/CO=0.0
!
!ARO/OH=-K061*<ARO>
 PJAC(:,21,14)=-TPK%K061(:)*PCONC(:,21)
!
!ARO/HO2=+1.06698*K084*<PHO>
 PJAC(:,21,15)=+1.06698*TPK%K084(:)*PCONC(:,36)
!
!ARO/CH4=0.0
!
!ARO/ETH=0.0
!
!ARO/ALKA=0.0
!
!ARO/ALKE=0.0
!
!ARO/BIO=0.0
!
!ARO/ARO=-K061*<OH>-K075*<NO3>
 PJAC(:,21,21)=-TPK%K061(:)*PCONC(:,14)-TPK%K075(:)*PCONC(:,5)
!
!ARO/HCHO=0.0
!
!ARO/ALD=0.0
!
!ARO/KET=0.0
!
!ARO/CARBO=0.0
!
!ARO/ONIT=0.0
!
!ARO/PAN=0.0
!
!ARO/OP1=0.0
!
!ARO/OP2=0.0
!
!ARO/ORA1=0.0
!
!ARO/ORA2=0.0
!
!ARO/MO2=0.0
!
!ARO/ALKAP=0.0
!
!ARO/ALKEP=0.0
!
!ARO/BIOP=0.0
!
!ARO/PHO=+0.10670*K083*<NO2>+1.06698*K084*<HO2>
 PJAC(:,21,36)=+0.10670*TPK%K083(:)*PCONC(:,4)+1.06698*TPK%K084(:)*PCONC(:,15)
!
!ARO/ADD=+K085*<NO2>+0.02*K086*<O2>+K087*<O3>
 PJAC(:,21,37)=+TPK%K085(:)*PCONC(:,4)+0.02*TPK%K086(:)*TPK%O2(:)+TPK%K087(:)*P&
&CONC(:,1)
!
!ARO/AROP=0.0
!
!ARO/CARBOP=0.0
!
!ARO/OLN=0.0
!
!ARO/XO2=0.0
!
!ARO/WC_O3=0.0
!
!ARO/WC_H2O2=0.0
!
!ARO/WC_NO=0.0
!
!ARO/WC_NO2=0.0
!
!ARO/WC_NO3=0.0
!
!ARO/WC_N2O5=0.0
!
!ARO/WC_HONO=0.0
!
!ARO/WC_HNO3=0.0
!
!ARO/WC_HNO4=0.0
!
!ARO/WC_NH3=0.0
!
!ARO/WC_OH=0.0
!
!ARO/WC_HO2=0.0
!
!ARO/WC_CO2=0.0
!
!ARO/WC_SO2=0.0
!
!ARO/WC_SULF=0.0
!
!ARO/WC_HCHO=0.0
!
!ARO/WC_ORA1=0.0
!
!ARO/WC_ORA2=0.0
!
!ARO/WC_MO2=0.0
!
!ARO/WC_OP1=0.0
!
!ARO/WC_ASO3=0.0
!
!ARO/WC_ASO4=0.0
!
!ARO/WC_ASO5=0.0
!
!ARO/WC_AHSO5=0.0
!
!ARO/WC_AHMS=0.0
!
!ARO/WR_O3=0.0
!
!ARO/WR_H2O2=0.0
!
!ARO/WR_NO=0.0
!
!ARO/WR_NO2=0.0
!
!ARO/WR_NO3=0.0
!
!ARO/WR_N2O5=0.0
!
!ARO/WR_HONO=0.0
!
!ARO/WR_HNO3=0.0
!
!ARO/WR_HNO4=0.0
!
!ARO/WR_NH3=0.0
!
!ARO/WR_OH=0.0
!
!ARO/WR_HO2=0.0
!
!ARO/WR_CO2=0.0
!
!ARO/WR_SO2=0.0
!
!ARO/WR_SULF=0.0
!
!ARO/WR_HCHO=0.0
!
!ARO/WR_ORA1=0.0
!
!ARO/WR_ORA2=0.0
!
!ARO/WR_MO2=0.0
!
!ARO/WR_OP1=0.0
!
!ARO/WR_ASO3=0.0
!
!ARO/WR_ASO4=0.0
!
!ARO/WR_ASO5=0.0
!
!ARO/WR_AHSO5=0.0
!
!ARO/WR_AHMS=0.0
!
!HCHO/O3=+0.48290*K079*<ALKE>+0.90000*K080*<BIO>+0.00000*K081*<CARBO>+0.70*K082
!*<PAN>
 PJAC(:,22,1)=+0.48290*TPK%K079(:)*PCONC(:,19)+0.90000*TPK%K080(:)*PCONC(:,20)+&
&0.00000*TPK%K081(:)*PCONC(:,25)+0.70*TPK%K082(:)*PCONC(:,27)
!
!HCHO/H2O2=0.0
!
!HCHO/NO=+K090*<MO2>+0.03002*K091*<ALKAP>+1.39870*K092*<ALKEP>+0.60600*K093*<BI
!OP>+0.05848*K095*<CARBOP>+0.23419*K096*<OLN>
 PJAC(:,22,3)=+TPK%K090(:)*PCONC(:,32)+0.03002*TPK%K091(:)*PCONC(:,33)+1.39870*&
&TPK%K092(:)*PCONC(:,34)+0.60600*TPK%K093(:)*PCONC(:,35)+0.05848*TPK%K095(:)*PC&
&ONC(:,39)+0.23419*TPK%K096(:)*PCONC(:,40)
!
!HCHO/NO2=0.0
!
!HCHO/NO3=-K072*<HCHO>+0.40*K078*<PAN>+K119*<MO2>+0.03142*K120*<ALKAP>+1.40909*
!K121*<ALKEP>+0.68600*K122*<BIOP>+0.03175*K124*<CARBOP>+0.20740*K125*<OLN>
 PJAC(:,22,5)=-TPK%K072(:)*PCONC(:,22)+0.40*TPK%K078(:)*PCONC(:,27)+TPK%K119(:)&
&*PCONC(:,32)+0.03142*TPK%K120(:)*PCONC(:,33)+1.40909*TPK%K121(:)*PCONC(:,34)+0&
&.68600*TPK%K122(:)*PCONC(:,35)+0.03175*TPK%K124(:)*PCONC(:,39)+0.20740*TPK%K12&
&5(:)*PCONC(:,40)
!
!HCHO/N2O5=0.0
!
!HCHO/HONO=0.0
!
!HCHO/HNO3=0.0
!
!HCHO/HNO4=0.0
!
!HCHO/NH3=0.0
!
!HCHO/SO2=0.0
!
!HCHO/SULF=0.0
!
!HCHO/CO=0.0
!
!HCHO/OH=+0.00140*K058*<ALKA>-K062*<HCHO>+0.00000*K065*<CARBO>+0.35*K068*<OP1>+
!0.02915*K069*<OP2>+0.57839*K070*<PAN>
 PJAC(:,22,14)=+0.00140*TPK%K058(:)*PCONC(:,18)-TPK%K062(:)*PCONC(:,22)+0.00000&
&*TPK%K065(:)*PCONC(:,25)+0.35*TPK%K068(:)*PCONC(:,28)+0.02915*TPK%K069(:)*PCON&
&C(:,29)+0.57839*TPK%K070(:)*PCONC(:,27)
!
!HCHO/HO2=0.0
!
!HCHO/CH4=0.0
!
!HCHO/ETH=0.0
!
!HCHO/ALKA=+0.00140*K058*<OH>
 PJAC(:,22,18)=+0.00140*TPK%K058(:)*PCONC(:,14)
!
!HCHO/ALKE=+0.48290*K079*<O3>
 PJAC(:,22,19)=+0.48290*TPK%K079(:)*PCONC(:,1)
!
!HCHO/BIO=+0.05*K054*<O3P>+0.90000*K080*<O3>
 PJAC(:,22,20)=+0.05*TPK%K054(:)*TPK%O3P(:)+0.90000*TPK%K080(:)*PCONC(:,1)
!
!HCHO/ARO=0.0
!
!HCHO/HCHO=-K010-K011-K062*<OH>-K072*<NO3>-KTC16-KTR16
 PJAC(:,22,22)=-TPK%K010(:)-TPK%K011(:)-TPK%K062(:)*PCONC(:,14)-TPK%K072(:)*PCO&
&NC(:,5)-TPK%KTC16(:)-TPK%KTR16(:)
!
!HCHO/ALD=0.0
!
!HCHO/KET=0.0
!
!HCHO/CARBO=+0.06517*K016+0.00000*K065*<OH>+0.00000*K081*<O3>
 PJAC(:,22,25)=+0.06517*TPK%K016(:)+0.00000*TPK%K065(:)*PCONC(:,14)+0.00000*TPK&
&%K081(:)*PCONC(:,1)
!
!HCHO/ONIT=0.0
!
!HCHO/PAN=+0.57839*K070*<OH>+0.40*K078*<NO3>+0.70*K082*<O3>
 PJAC(:,22,27)=+0.57839*TPK%K070(:)*PCONC(:,14)+0.40*TPK%K078(:)*PCONC(:,5)+0.7&
&0*TPK%K082(:)*PCONC(:,1)
!
!HCHO/OP1=+K013+0.35*K068*<OH>
 PJAC(:,22,28)=+TPK%K013(:)+0.35*TPK%K068(:)*PCONC(:,14)
!
!HCHO/OP2=+0.02915*K069*<OH>
 PJAC(:,22,29)=+0.02915*TPK%K069(:)*PCONC(:,14)
!
!HCHO/ORA1=0.0
!
!HCHO/ORA2=0.0
!
!HCHO/MO2=+K090*<NO>+1.33*K104*<MO2>+1.33*K104*<MO2>+0.80556*K105*<ALKAP>+1.428
!94*K106*<ALKEP>+1.09000*K107*<BIOP>+K108*<AROP>+0.95723*K109*<CARBOP>+0.88625*
!K110*<OLN>+K119*<NO3>+K127*<XO2>
 PJAC(:,22,32)=+TPK%K090(:)*PCONC(:,3)+1.33*TPK%K104(:)*PCONC(:,32)+1.33*TPK%K1&
&04(:)*PCONC(:,32)+0.80556*TPK%K105(:)*PCONC(:,33)+1.42894*TPK%K106(:)*PCONC(:,&
&34)+1.09000*TPK%K107(:)*PCONC(:,35)+TPK%K108(:)*PCONC(:,38)+0.95723*TPK%K109(:&
&)*PCONC(:,39)+0.88625*TPK%K110(:)*PCONC(:,40)+TPK%K119(:)*PCONC(:,5)+TPK%K127(&
&:)*PCONC(:,41)
!
!HCHO/ALKAP=+0.03002*K091*<NO>+0.80556*K105*<MO2>+0.07600*K111*<CARBOP>+0.03142
!*K120*<NO3>
 PJAC(:,22,33)=+0.03002*TPK%K091(:)*PCONC(:,3)+0.80556*TPK%K105(:)*PCONC(:,32)+&
&0.07600*TPK%K111(:)*PCONC(:,39)+0.03142*TPK%K120(:)*PCONC(:,5)
!
!HCHO/ALKEP=+1.39870*K092*<NO>+1.42894*K106*<MO2>+0.68192*K112*<CARBOP>+1.40909
!*K121*<NO3>
 PJAC(:,22,34)=+1.39870*TPK%K092(:)*PCONC(:,3)+1.42894*TPK%K106(:)*PCONC(:,32)+&
&0.68192*TPK%K112(:)*PCONC(:,39)+1.40909*TPK%K121(:)*PCONC(:,5)
!
!HCHO/BIOP=+0.60600*K093*<NO>+1.09000*K107*<MO2>+0.34000*K113*<CARBOP>+0.68600*
!K122*<NO3>
 PJAC(:,22,35)=+0.60600*TPK%K093(:)*PCONC(:,3)+1.09000*TPK%K107(:)*PCONC(:,32)+&
&0.34000*TPK%K113(:)*PCONC(:,39)+0.68600*TPK%K122(:)*PCONC(:,5)
!
!HCHO/PHO=0.0
!
!HCHO/ADD=0.0
!
!HCHO/AROP=+K108*<MO2>
 PJAC(:,22,38)=+TPK%K108(:)*PCONC(:,32)
!
!HCHO/CARBOP=+0.05848*K095*<NO>+0.95723*K109*<MO2>+0.07600*K111*<ALKAP>+0.68192
!*K112*<ALKEP>+0.34000*K113*<BIOP>+0.03432*K115*<CARBOP>+0.03432*K115*<CARBOP>+
!0.13414*K116*<OLN>+0.03175*K124*<NO3>
 PJAC(:,22,39)=+0.05848*TPK%K095(:)*PCONC(:,3)+0.95723*TPK%K109(:)*PCONC(:,32)+&
&0.07600*TPK%K111(:)*PCONC(:,33)+0.68192*TPK%K112(:)*PCONC(:,34)+0.34000*TPK%K1&
&13(:)*PCONC(:,35)+0.03432*TPK%K115(:)*PCONC(:,39)+0.03432*TPK%K115(:)*PCONC(:,&
&39)+0.13414*TPK%K116(:)*PCONC(:,40)+0.03175*TPK%K124(:)*PCONC(:,5)
!
!HCHO/OLN=+0.23419*K096*<NO>+0.88625*K110*<MO2>+0.13414*K116*<CARBOP>+0.00000*K
!118*<OLN>+0.00000*K118*<OLN>+0.20740*K125*<NO3>
 PJAC(:,22,40)=+0.23419*TPK%K096(:)*PCONC(:,3)+0.88625*TPK%K110(:)*PCONC(:,32)+&
&0.13414*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K1&
&18(:)*PCONC(:,40)+0.20740*TPK%K125(:)*PCONC(:,5)
!
!HCHO/XO2=+K127*<MO2>
 PJAC(:,22,41)=+TPK%K127(:)*PCONC(:,32)
!
!HCHO/WC_O3=0.0
!
!HCHO/WC_H2O2=0.0
!
!HCHO/WC_NO=0.0
!
!HCHO/WC_NO2=0.0
!
!HCHO/WC_NO3=0.0
!
!HCHO/WC_N2O5=0.0
!
!HCHO/WC_HONO=0.0
!
!HCHO/WC_HNO3=0.0
!
!HCHO/WC_HNO4=0.0
!
!HCHO/WC_NH3=0.0
!
!HCHO/WC_OH=0.0
!
!HCHO/WC_HO2=0.0
!
!HCHO/WC_CO2=0.0
!
!HCHO/WC_SO2=0.0
!
!HCHO/WC_SULF=0.0
!
!HCHO/WC_HCHO=+KTC36
 PJAC(:,22,57)=+TPK%KTC36(:)
!
!HCHO/WC_ORA1=0.0
!
!HCHO/WC_ORA2=0.0
!
!HCHO/WC_MO2=0.0
!
!HCHO/WC_OP1=0.0
!
!HCHO/WC_ASO3=0.0
!
!HCHO/WC_ASO4=0.0
!
!HCHO/WC_ASO5=0.0
!
!HCHO/WC_AHSO5=0.0
!
!HCHO/WC_AHMS=0.0
!
!HCHO/WR_O3=0.0
!
!HCHO/WR_H2O2=0.0
!
!HCHO/WR_NO=0.0
!
!HCHO/WR_NO2=0.0
!
!HCHO/WR_NO3=0.0
!
!HCHO/WR_N2O5=0.0
!
!HCHO/WR_HONO=0.0
!
!HCHO/WR_HNO3=0.0
!
!HCHO/WR_HNO4=0.0
!
!HCHO/WR_NH3=0.0
!
!HCHO/WR_OH=0.0
!
!HCHO/WR_HO2=0.0
!
!HCHO/WR_CO2=0.0
!
!HCHO/WR_SO2=0.0
!
!HCHO/WR_SULF=0.0
!
!HCHO/WR_HCHO=+KTR36
 PJAC(:,22,82)=+TPK%KTR36(:)
!
!HCHO/WR_ORA1=0.0
!
!HCHO/WR_ORA2=0.0
!
!HCHO/WR_MO2=0.0
!
!HCHO/WR_OP1=0.0
!
!HCHO/WR_ASO3=0.0
!
!HCHO/WR_ASO4=0.0
!
!HCHO/WR_ASO5=0.0
!
!HCHO/WR_AHSO5=0.0
!
!HCHO/WR_AHMS=0.0
!
!ALD/O3=+0.51468*K079*<ALKE>+0.00000*K080*<BIO>+0.15692*K081*<CARBO>
 PJAC(:,23,1)=+0.51468*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)+&
&0.15692*TPK%K081(:)*PCONC(:,25)
!
!ALD/H2O2=0.0
!
!ALD/NO=+0.33144*K091*<ALKAP>+0.42125*K092*<ALKEP>+0.00000*K093*<BIOP>+0.07368*
!K095*<CARBOP>+1.01182*K096*<OLN>
 PJAC(:,23,3)=+0.33144*TPK%K091(:)*PCONC(:,33)+0.42125*TPK%K092(:)*PCONC(:,34)+&
&0.00000*TPK%K093(:)*PCONC(:,35)+0.07368*TPK%K095(:)*PCONC(:,39)+1.01182*TPK%K0&
&96(:)*PCONC(:,40)
!
!ALD/NO2=0.0
!
!ALD/NO3=-K073*<ALD>+0.05265*K074*<CARBO>+0.33743*K120*<ALKAP>+0.43039*K121*<AL
!KEP>+0.00000*K122*<BIOP>+0.02936*K124*<CARBOP>+0.91850*K125*<OLN>
 PJAC(:,23,5)=-TPK%K073(:)*PCONC(:,23)+0.05265*TPK%K074(:)*PCONC(:,25)+0.33743*&
&TPK%K120(:)*PCONC(:,33)+0.43039*TPK%K121(:)*PCONC(:,34)+0.00000*TPK%K122(:)*PC&
&ONC(:,35)+0.02936*TPK%K124(:)*PCONC(:,39)+0.91850*TPK%K125(:)*PCONC(:,40)
!
!ALD/N2O5=0.0
!
!ALD/HONO=0.0
!
!ALD/HNO3=0.0
!
!ALD/HNO4=0.0
!
!ALD/NH3=0.0
!
!ALD/SO2=0.0
!
!ALD/SULF=0.0
!
!ALD/CO=0.0
!
!ALD/OH=+0.08173*K058*<ALKA>-K063*<ALD>+0.06253*K065*<CARBO>+0.07335*K069*<OP2>
 PJAC(:,23,14)=+0.08173*TPK%K058(:)*PCONC(:,18)-TPK%K063(:)*PCONC(:,23)+0.06253&
&*TPK%K065(:)*PCONC(:,25)+0.07335*TPK%K069(:)*PCONC(:,29)
!
!ALD/HO2=0.0
!
!ALD/CH4=0.0
!
!ALD/ETH=0.0
!
!ALD/ALKA=+0.08173*K058*<OH>
 PJAC(:,23,18)=+0.08173*TPK%K058(:)*PCONC(:,14)
!
!ALD/ALKE=+0.51468*K079*<O3>
 PJAC(:,23,19)=+0.51468*TPK%K079(:)*PCONC(:,1)
!
!ALD/BIO=+0.00000*K080*<O3>
 PJAC(:,23,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!ALD/ARO=0.0
!
!ALD/HCHO=0.0
!
!ALD/ALD=-K012-K063*<OH>-K073*<NO3>
 PJAC(:,23,23)=-TPK%K012(:)-TPK%K063(:)*PCONC(:,14)-TPK%K073(:)*PCONC(:,5)
!
!ALD/KET=0.0
!
!ALD/CARBO=+K055*<O3P>+0.06253*K065*<OH>+0.05265*K074*<NO3>+0.15692*K081*<O3>
 PJAC(:,23,25)=+TPK%K055(:)*TPK%O3P(:)+0.06253*TPK%K065(:)*PCONC(:,14)+0.05265*&
&TPK%K074(:)*PCONC(:,5)+0.15692*TPK%K081(:)*PCONC(:,1)
!
!ALD/ONIT=+0.20*K017
 PJAC(:,23,26)=+0.20*TPK%K017(:)
!
!ALD/PAN=0.0
!
!ALD/OP1=0.0
!
!ALD/OP2=+0.96205*K014+0.07335*K069*<OH>
 PJAC(:,23,29)=+0.96205*TPK%K014(:)+0.07335*TPK%K069(:)*PCONC(:,14)
!
!ALD/ORA1=0.0
!
!ALD/ORA2=0.0
!
!ALD/MO2=+0.56070*K105*<ALKAP>+0.46413*K106*<ALKEP>+0.00000*K107*<BIOP>+0.08295
!*K109*<CARBOP>+0.41524*K110*<OLN>
 PJAC(:,23,32)=+0.56070*TPK%K105(:)*PCONC(:,33)+0.46413*TPK%K106(:)*PCONC(:,34)&
&+0.00000*TPK%K107(:)*PCONC(:,35)+0.08295*TPK%K109(:)*PCONC(:,39)+0.41524*TPK%K&
&110(:)*PCONC(:,40)
!
!ALD/ALKAP=+0.33144*K091*<NO>+0.56070*K105*<MO2>+0.71461*K111*<CARBOP>+0.33743*
!K120*<NO3>
 PJAC(:,23,33)=+0.33144*TPK%K091(:)*PCONC(:,3)+0.56070*TPK%K105(:)*PCONC(:,32)+&
&0.71461*TPK%K111(:)*PCONC(:,39)+0.33743*TPK%K120(:)*PCONC(:,5)
!
!ALD/ALKEP=+0.42125*K092*<NO>+0.46413*K106*<MO2>+0.68374*K112*<CARBOP>+0.43039*
!K121*<NO3>
 PJAC(:,23,34)=+0.42125*TPK%K092(:)*PCONC(:,3)+0.46413*TPK%K106(:)*PCONC(:,32)+&
&0.68374*TPK%K112(:)*PCONC(:,39)+0.43039*TPK%K121(:)*PCONC(:,5)
!
!ALD/BIOP=+0.00000*K093*<NO>+0.00000*K107*<MO2>+0.00000*K113*<CARBOP>+0.00000*K
!122*<NO3>
 PJAC(:,23,35)=+0.00000*TPK%K093(:)*PCONC(:,3)+0.00000*TPK%K107(:)*PCONC(:,32)+&
&0.00000*TPK%K113(:)*PCONC(:,39)+0.00000*TPK%K122(:)*PCONC(:,5)
!
!ALD/PHO=0.0
!
!ALD/ADD=0.0
!
!ALD/AROP=0.0
!
!ALD/CARBOP=+0.07368*K095*<NO>+0.08295*K109*<MO2>+0.71461*K111*<ALKAP>+0.68374*
!K112*<ALKEP>+0.00000*K113*<BIOP>+0.06969*K115*<CARBOP>+0.06969*K115*<CARBOP>+0
!.42122*K116*<OLN>+0.02936*K124*<NO3>
 PJAC(:,23,39)=+0.07368*TPK%K095(:)*PCONC(:,3)+0.08295*TPK%K109(:)*PCONC(:,32)+&
&0.71461*TPK%K111(:)*PCONC(:,33)+0.68374*TPK%K112(:)*PCONC(:,34)+0.00000*TPK%K1&
&13(:)*PCONC(:,35)+0.06969*TPK%K115(:)*PCONC(:,39)+0.06969*TPK%K115(:)*PCONC(:,&
&39)+0.42122*TPK%K116(:)*PCONC(:,40)+0.02936*TPK%K124(:)*PCONC(:,5)
!
!ALD/OLN=+1.01182*K096*<NO>+0.41524*K110*<MO2>+0.42122*K116*<CARBOP>+0.00000*K1
!18*<OLN>+0.00000*K118*<OLN>+0.91850*K125*<NO3>
 PJAC(:,23,40)=+1.01182*TPK%K096(:)*PCONC(:,3)+0.41524*TPK%K110(:)*PCONC(:,32)+&
&0.42122*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K1&
&18(:)*PCONC(:,40)+0.91850*TPK%K125(:)*PCONC(:,5)
!
!ALD/XO2=0.0
!
!ALD/WC_O3=0.0
!
!ALD/WC_H2O2=0.0
!
!ALD/WC_NO=0.0
!
!ALD/WC_NO2=0.0
!
!ALD/WC_NO3=0.0
!
!ALD/WC_N2O5=0.0
!
!ALD/WC_HONO=0.0
!
!ALD/WC_HNO3=0.0
!
!ALD/WC_HNO4=0.0
!
!ALD/WC_NH3=0.0
!
!ALD/WC_OH=0.0
!
!ALD/WC_HO2=0.0
!
!ALD/WC_CO2=0.0
!
!ALD/WC_SO2=0.0
!
!ALD/WC_SULF=0.0
!
!ALD/WC_HCHO=0.0
!
!ALD/WC_ORA1=0.0
!
!ALD/WC_ORA2=0.0
!
!ALD/WC_MO2=0.0
!
!ALD/WC_OP1=0.0
!
!ALD/WC_ASO3=0.0
!
!ALD/WC_ASO4=0.0
!
!ALD/WC_ASO5=0.0
!
!ALD/WC_AHSO5=0.0
!
!ALD/WC_AHMS=0.0
!
!ALD/WR_O3=0.0
!
!ALD/WR_H2O2=0.0
!
!ALD/WR_NO=0.0
!
!ALD/WR_NO2=0.0
!
!ALD/WR_NO3=0.0
!
!ALD/WR_N2O5=0.0
!
!ALD/WR_HONO=0.0
!
!ALD/WR_HNO3=0.0
!
!ALD/WR_HNO4=0.0
!
!ALD/WR_NH3=0.0
!
!ALD/WR_OH=0.0
!
!ALD/WR_HO2=0.0
!
!ALD/WR_CO2=0.0
!
!ALD/WR_SO2=0.0
!
!ALD/WR_SULF=0.0
!
!ALD/WR_HCHO=0.0
!
!ALD/WR_ORA1=0.0
!
!ALD/WR_ORA2=0.0
!
!ALD/WR_MO2=0.0
!
!ALD/WR_OP1=0.0
!
!ALD/WR_ASO3=0.0
!
!ALD/WR_ASO4=0.0
!
!ALD/WR_ASO5=0.0
!
!ALD/WR_AHSO5=0.0
!
!ALD/WR_AHMS=0.0
!
!KET/O3=+0.07377*K079*<ALKE>+0.00000*K080*<BIO>
 PJAC(:,24,1)=+0.07377*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)
!
!KET/H2O2=0.0
!
!KET/NO=+0.54531*K091*<ALKAP>+0.05220*K092*<ALKEP>+0.00000*K093*<BIOP>+0.37862*
!K096*<OLN>
 PJAC(:,24,3)=+0.54531*TPK%K091(:)*PCONC(:,33)+0.05220*TPK%K092(:)*PCONC(:,34)+&
&0.00000*TPK%K093(:)*PCONC(:,35)+0.37862*TPK%K096(:)*PCONC(:,40)
!
!KET/NO2=0.0
!
!KET/NO3=+0.00632*K074*<CARBO>+0.62978*K120*<ALKAP>+0.02051*K121*<ALKEP>+0.0000
!0*K122*<BIOP>+0.34740*K125*<OLN>
 PJAC(:,24,5)=+0.00632*TPK%K074(:)*PCONC(:,25)+0.62978*TPK%K120(:)*PCONC(:,33)+&
&0.02051*TPK%K121(:)*PCONC(:,34)+0.00000*TPK%K122(:)*PCONC(:,35)+0.34740*TPK%K1&
&25(:)*PCONC(:,40)
!
!KET/N2O5=0.0
!
!KET/HONO=0.0
!
!KET/HNO3=0.0
!
!KET/HNO4=0.0
!
!KET/NH3=0.0
!
!KET/SO2=0.0
!
!KET/SULF=0.0
!
!KET/CO=0.0
!
!KET/OH=+0.03498*K058*<ALKA>-K064*<KET>+0.00853*K065*<CARBO>+0.37591*K069*<OP2>
 PJAC(:,24,14)=+0.03498*TPK%K058(:)*PCONC(:,18)-TPK%K064(:)*PCONC(:,24)+0.00853&
&*TPK%K065(:)*PCONC(:,25)+0.37591*TPK%K069(:)*PCONC(:,29)
!
!KET/HO2=0.0
!
!KET/CH4=0.0
!
!KET/ETH=0.0
!
!KET/ALKA=+0.03498*K058*<OH>
 PJAC(:,24,18)=+0.03498*TPK%K058(:)*PCONC(:,14)
!
!KET/ALKE=+0.07377*K079*<O3>
 PJAC(:,24,19)=+0.07377*TPK%K079(:)*PCONC(:,1)
!
!KET/BIO=+0.00000*K080*<O3>
 PJAC(:,24,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!KET/ARO=0.0
!
!KET/HCHO=0.0
!
!KET/ALD=0.0
!
!KET/KET=-K015-K064*<OH>
 PJAC(:,24,24)=-TPK%K015(:)-TPK%K064(:)*PCONC(:,14)
!
!KET/CARBO=+0.00853*K065*<OH>+0.00632*K074*<NO3>
 PJAC(:,24,25)=+0.00853*TPK%K065(:)*PCONC(:,14)+0.00632*TPK%K074(:)*PCONC(:,5)
!
!KET/ONIT=+0.80*K017
 PJAC(:,24,26)=+0.80*TPK%K017(:)
!
!KET/PAN=0.0
!
!KET/OP1=0.0
!
!KET/OP2=+0.37591*K069*<OH>
 PJAC(:,24,29)=+0.37591*TPK%K069(:)*PCONC(:,14)
!
!KET/ORA1=0.0
!
!KET/ORA2=0.0
!
!KET/MO2=+0.09673*K105*<ALKAP>+0.03814*K106*<ALKEP>+0.00000*K107*<BIOP>+0.09667
!*K110*<OLN>
 PJAC(:,24,32)=+0.09673*TPK%K105(:)*PCONC(:,33)+0.03814*TPK%K106(:)*PCONC(:,34)&
&+0.00000*TPK%K107(:)*PCONC(:,35)+0.09667*TPK%K110(:)*PCONC(:,40)
!
!KET/ALKAP=+0.54531*K091*<NO>+0.09673*K105*<MO2>+0.18819*K111*<CARBOP>+0.62978*
!K120*<NO3>
 PJAC(:,24,33)=+0.54531*TPK%K091(:)*PCONC(:,3)+0.09673*TPK%K105(:)*PCONC(:,32)+&
&0.18819*TPK%K111(:)*PCONC(:,39)+0.62978*TPK%K120(:)*PCONC(:,5)
!
!KET/ALKEP=+0.05220*K092*<NO>+0.03814*K106*<MO2>+0.06579*K112*<CARBOP>+0.02051*
!K121*<NO3>
 PJAC(:,24,34)=+0.05220*TPK%K092(:)*PCONC(:,3)+0.03814*TPK%K106(:)*PCONC(:,32)+&
&0.06579*TPK%K112(:)*PCONC(:,39)+0.02051*TPK%K121(:)*PCONC(:,5)
!
!KET/BIOP=+0.00000*K093*<NO>+0.00000*K107*<MO2>+0.00000*K113*<CARBOP>+0.00000*K
!122*<NO3>
 PJAC(:,24,35)=+0.00000*TPK%K093(:)*PCONC(:,3)+0.00000*TPK%K107(:)*PCONC(:,32)+&
&0.00000*TPK%K113(:)*PCONC(:,39)+0.00000*TPK%K122(:)*PCONC(:,5)
!
!KET/PHO=0.0
!
!KET/ADD=0.0
!
!KET/AROP=0.0
!
!KET/CARBOP=+0.18819*K111*<ALKAP>+0.06579*K112*<ALKEP>+0.00000*K113*<BIOP>+0.02
!190*K115*<CARBOP>+0.02190*K115*<CARBOP>+0.10822*K116*<OLN>
 PJAC(:,24,39)=+0.18819*TPK%K111(:)*PCONC(:,33)+0.06579*TPK%K112(:)*PCONC(:,34)&
&+0.00000*TPK%K113(:)*PCONC(:,35)+0.02190*TPK%K115(:)*PCONC(:,39)+0.02190*TPK%K&
&115(:)*PCONC(:,39)+0.10822*TPK%K116(:)*PCONC(:,40)
!
!KET/OLN=+0.37862*K096*<NO>+0.09667*K110*<MO2>+0.10822*K116*<CARBOP>+0.00000*K1
!18*<OLN>+0.00000*K118*<OLN>+0.34740*K125*<NO3>
 PJAC(:,24,40)=+0.37862*TPK%K096(:)*PCONC(:,3)+0.09667*TPK%K110(:)*PCONC(:,32)+&
&0.10822*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K1&
&18(:)*PCONC(:,40)+0.34740*TPK%K125(:)*PCONC(:,5)
!
!KET/XO2=0.0
!
!KET/WC_O3=0.0
!
!KET/WC_H2O2=0.0
!
!KET/WC_NO=0.0
!
!KET/WC_NO2=0.0
!
!KET/WC_NO3=0.0
!
!KET/WC_N2O5=0.0
!
!KET/WC_HONO=0.0
!
!KET/WC_HNO3=0.0
!
!KET/WC_HNO4=0.0
!
!KET/WC_NH3=0.0
!
!KET/WC_OH=0.0
!
!KET/WC_HO2=0.0
!
!KET/WC_CO2=0.0
!
!KET/WC_SO2=0.0
!
!KET/WC_SULF=0.0
!
!KET/WC_HCHO=0.0
!
!KET/WC_ORA1=0.0
!
!KET/WC_ORA2=0.0
!
!KET/WC_MO2=0.0
!
!KET/WC_OP1=0.0
!
!KET/WC_ASO3=0.0
!
!KET/WC_ASO4=0.0
!
!KET/WC_ASO5=0.0
!
!KET/WC_AHSO5=0.0
!
!KET/WC_AHMS=0.0
!
!KET/WR_O3=0.0
!
!KET/WR_H2O2=0.0
!
!KET/WR_NO=0.0
!
!KET/WR_NO2=0.0
!
!KET/WR_NO3=0.0
!
!KET/WR_N2O5=0.0
!
!KET/WR_HONO=0.0
!
!KET/WR_HNO3=0.0
!
!KET/WR_HNO4=0.0
!
!KET/WR_NH3=0.0
!
!KET/WR_OH=0.0
!
!KET/WR_HO2=0.0
!
!KET/WR_CO2=0.0
!
!KET/WR_SO2=0.0
!
!KET/WR_SULF=0.0
!
!KET/WR_HCHO=0.0
!
!KET/WR_ORA1=0.0
!
!KET/WR_ORA2=0.0
!
!KET/WR_MO2=0.0
!
!KET/WR_OP1=0.0
!
!KET/WR_ASO3=0.0
!
!KET/WR_ASO4=0.0
!
!KET/WR_ASO5=0.0
!
!KET/WR_AHSO5=0.0
!
!KET/WR_AHMS=0.0
!
!CARBO/O3=+0.00000*K079*<ALKE>+0.39754*K080*<BIO>+1.07583*K081*<CARBO>-K081*<CA
!RBO>
 PJAC(:,25,1)=+0.00000*TPK%K079(:)*PCONC(:,19)+0.39754*TPK%K080(:)*PCONC(:,20)+&
&1.07583*TPK%K081(:)*PCONC(:,25)-TPK%K081(:)*PCONC(:,25)
!
!CARBO/H2O2=0.0
!
!CARBO/NO=+0.03407*K091*<ALKAP>+0.45463*K093*<BIOP>+2.06993*K094*<AROP>+0.08670
!*K095*<CARBOP>
 PJAC(:,25,3)=+0.03407*TPK%K091(:)*PCONC(:,33)+0.45463*TPK%K093(:)*PCONC(:,35)+&
&2.06993*TPK%K094(:)*PCONC(:,38)+0.08670*TPK%K095(:)*PCONC(:,39)
!
!CARBO/NO2=0.0
!
!CARBO/NO3=+0.10530*K074*<CARBO>-K074*<CARBO>+0.00000*K076*<ALKE>+0.91741*K077*
!<BIO>+0.03531*K120*<ALKAP>+0.61160*K122*<BIOP>+2.81904*K123*<AROP>+0.03455*K12
!4*<CARBOP>
 PJAC(:,25,5)=+0.10530*TPK%K074(:)*PCONC(:,25)-TPK%K074(:)*PCONC(:,25)+0.00000*&
&TPK%K076(:)*PCONC(:,19)+0.91741*TPK%K077(:)*PCONC(:,20)+0.03531*TPK%K120(:)*PC&
&ONC(:,33)+0.61160*TPK%K122(:)*PCONC(:,35)+2.81904*TPK%K123(:)*PCONC(:,38)+0.03&
&455*TPK%K124(:)*PCONC(:,39)
!
!CARBO/N2O5=0.0
!
!CARBO/HONO=0.0
!
!CARBO/HNO3=0.0
!
!CARBO/HNO4=0.0
!
!CARBO/NH3=0.0
!
!CARBO/SO2=0.0
!
!CARBO/SULF=0.0
!
!CARBO/CO=0.0
!
!CARBO/OH=+0.00835*K058*<ALKA>+0.16919*K065*<CARBO>-K065*<CARBO>+0.21863*K070*<
!PAN>
 PJAC(:,25,14)=+0.00835*TPK%K058(:)*PCONC(:,18)+0.16919*TPK%K065(:)*PCONC(:,25)&
&-TPK%K065(:)*PCONC(:,25)+0.21863*TPK%K070(:)*PCONC(:,27)
!
!CARBO/HO2=0.0
!
!CARBO/CH4=0.0
!
!CARBO/ETH=0.0
!
!CARBO/ALKA=+0.00835*K058*<OH>
 PJAC(:,25,18)=+0.00835*TPK%K058(:)*PCONC(:,14)
!
!CARBO/ALKE=+0.00000*K076*<NO3>+0.00000*K079*<O3>
 PJAC(:,25,19)=+0.00000*TPK%K076(:)*PCONC(:,5)+0.00000*TPK%K079(:)*PCONC(:,1)
!
!CARBO/BIO=+0.13255*K054*<O3P>+0.91741*K077*<NO3>+0.39754*K080*<O3>
 PJAC(:,25,20)=+0.13255*TPK%K054(:)*TPK%O3P(:)+0.91741*TPK%K077(:)*PCONC(:,5)+0&
&.39754*TPK%K080(:)*PCONC(:,1)
!
!CARBO/ARO=0.0
!
!CARBO/HCHO=0.0
!
!CARBO/ALD=0.0
!
!CARBO/KET=0.0
!
!CARBO/CARBO=-K016-K055*<O3P>+0.16919*K065*<OH>-K065*<OH>+0.10530*K074*<NO3>-K0
!74*<NO3>+1.07583*K081*<O3>-K081*<O3>
 PJAC(:,25,25)=-TPK%K016(:)-TPK%K055(:)*TPK%O3P(:)+0.16919*TPK%K065(:)*PCONC(:,&
&14)-TPK%K065(:)*PCONC(:,14)+0.10530*TPK%K074(:)*PCONC(:,5)-TPK%K074(:)*PCONC(:&
&,5)+1.07583*TPK%K081(:)*PCONC(:,1)-TPK%K081(:)*PCONC(:,1)
!
!CARBO/ONIT=0.0
!
!CARBO/PAN=+0.21863*K070*<OH>
 PJAC(:,25,27)=+0.21863*TPK%K070(:)*PCONC(:,14)
!
!CARBO/OP1=0.0
!
!CARBO/OP2=0.0
!
!CARBO/ORA1=0.0
!
!CARBO/ORA2=0.0
!
!CARBO/MO2=+0.07976*K105*<ALKAP>+0.56064*K107*<BIOP>+1.99461*K108*<AROP>+0.1538
!7*K109*<CARBOP>
 PJAC(:,25,32)=+0.07976*TPK%K105(:)*PCONC(:,33)+0.56064*TPK%K107(:)*PCONC(:,35)&
&+1.99461*TPK%K108(:)*PCONC(:,38)+0.15387*TPK%K109(:)*PCONC(:,39)
!
!CARBO/ALKAP=+0.03407*K091*<NO>+0.07976*K105*<MO2>+0.06954*K111*<CARBOP>+0.0353
!1*K120*<NO3>
 PJAC(:,25,33)=+0.03407*TPK%K091(:)*PCONC(:,3)+0.07976*TPK%K105(:)*PCONC(:,32)+&
&0.06954*TPK%K111(:)*PCONC(:,39)+0.03531*TPK%K120(:)*PCONC(:,5)
!
!CARBO/ALKEP=0.0
!
!CARBO/BIOP=+0.45463*K093*<NO>+0.56064*K107*<MO2>+0.78591*K113*<CARBOP>+0.61160
!*K122*<NO3>
 PJAC(:,25,35)=+0.45463*TPK%K093(:)*PCONC(:,3)+0.56064*TPK%K107(:)*PCONC(:,32)+&
&0.78591*TPK%K113(:)*PCONC(:,39)+0.61160*TPK%K122(:)*PCONC(:,5)
!
!CARBO/PHO=0.0
!
!CARBO/ADD=0.0
!
!CARBO/AROP=+2.06993*K094*<NO>+1.99461*K108*<MO2>+1.99455*K114*<CARBOP>+2.81904
!*K123*<NO3>
 PJAC(:,25,38)=+2.06993*TPK%K094(:)*PCONC(:,3)+1.99461*TPK%K108(:)*PCONC(:,32)+&
&1.99455*TPK%K114(:)*PCONC(:,39)+2.81904*TPK%K123(:)*PCONC(:,5)
!
!CARBO/CARBOP=+0.08670*K095*<NO>+0.15387*K109*<MO2>+0.06954*K111*<ALKAP>+0.7859
!1*K113*<BIOP>+1.99455*K114*<AROP>+0.10777*K115*<CARBOP>+0.10777*K115*<CARBOP>+
!0.03455*K124*<NO3>
 PJAC(:,25,39)=+0.08670*TPK%K095(:)*PCONC(:,3)+0.15387*TPK%K109(:)*PCONC(:,32)+&
&0.06954*TPK%K111(:)*PCONC(:,33)+0.78591*TPK%K113(:)*PCONC(:,35)+1.99455*TPK%K1&
&14(:)*PCONC(:,38)+0.10777*TPK%K115(:)*PCONC(:,39)+0.10777*TPK%K115(:)*PCONC(:,&
&39)+0.03455*TPK%K124(:)*PCONC(:,5)
!
!CARBO/OLN=0.0
!
!CARBO/XO2=0.0
!
!CARBO/WC_O3=0.0
!
!CARBO/WC_H2O2=0.0
!
!CARBO/WC_NO=0.0
!
!CARBO/WC_NO2=0.0
!
!CARBO/WC_NO3=0.0
!
!CARBO/WC_N2O5=0.0
!
!CARBO/WC_HONO=0.0
!
!CARBO/WC_HNO3=0.0
!
!CARBO/WC_HNO4=0.0
!
!CARBO/WC_NH3=0.0
!
!CARBO/WC_OH=0.0
!
!CARBO/WC_HO2=0.0
!
!CARBO/WC_CO2=0.0
!
!CARBO/WC_SO2=0.0
!
!CARBO/WC_SULF=0.0
!
!CARBO/WC_HCHO=0.0
!
!CARBO/WC_ORA1=0.0
!
!CARBO/WC_ORA2=0.0
!
!CARBO/WC_MO2=0.0
!
!CARBO/WC_OP1=0.0
!
!CARBO/WC_ASO3=0.0
!
!CARBO/WC_ASO4=0.0
!
!CARBO/WC_ASO5=0.0
!
!CARBO/WC_AHSO5=0.0
!
!CARBO/WC_AHMS=0.0
!
!CARBO/WR_O3=0.0
!
!CARBO/WR_H2O2=0.0
!
!CARBO/WR_NO=0.0
!
!CARBO/WR_NO2=0.0
!
!CARBO/WR_NO3=0.0
!
!CARBO/WR_N2O5=0.0
!
!CARBO/WR_HONO=0.0
!
!CARBO/WR_HNO3=0.0
!
!CARBO/WR_HNO4=0.0
!
!CARBO/WR_NH3=0.0
!
!CARBO/WR_OH=0.0
!
!CARBO/WR_HO2=0.0
!
!CARBO/WR_CO2=0.0
!
!CARBO/WR_SO2=0.0
!
!CARBO/WR_SULF=0.0
!
!CARBO/WR_HCHO=0.0
!
!CARBO/WR_ORA1=0.0
!
!CARBO/WR_ORA2=0.0
!
!CARBO/WR_MO2=0.0
!
!CARBO/WR_OP1=0.0
!
!CARBO/WR_ASO3=0.0
!
!CARBO/WR_ASO4=0.0
!
!CARBO/WR_ASO5=0.0
!
!CARBO/WR_AHSO5=0.0
!
!CARBO/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ4
!
SUBROUTINE SUBJ5
!
!Indices 26 a 30
!
!
!ONIT/O3=0.0
!
!ONIT/H2O2=0.0
!
!ONIT/NO=+0.08459*K091*<ALKAP>+0.15300*K093*<BIOP>+0.04885*K094*<AROP>+0.18401*
!K096*<OLN>
 PJAC(:,26,3)=+0.08459*TPK%K091(:)*PCONC(:,33)+0.15300*TPK%K093(:)*PCONC(:,35)+&
&0.04885*TPK%K094(:)*PCONC(:,38)+0.18401*TPK%K096(:)*PCONC(:,40)
!
!ONIT/NO2=+K083*<PHO>
 PJAC(:,26,4)=+TPK%K083(:)*PCONC(:,36)
!
!ONIT/NO3=+0.60*K078*<PAN>+0.25928*K125*<OLN>
 PJAC(:,26,5)=+0.60*TPK%K078(:)*PCONC(:,27)+0.25928*TPK%K125(:)*PCONC(:,40)
!
!ONIT/N2O5=0.0
!
!ONIT/HONO=0.0
!
!ONIT/HNO3=0.0
!
!ONIT/HNO4=0.0
!
!ONIT/NH3=0.0
!
!ONIT/SO2=0.0
!
!ONIT/SULF=0.0
!
!ONIT/CO=0.0
!
!ONIT/OH=-K071*<ONIT>
 PJAC(:,26,14)=-TPK%K071(:)*PCONC(:,26)
!
!ONIT/HO2=+K103*<OLN>
 PJAC(:,26,15)=+TPK%K103(:)*PCONC(:,40)
!
!ONIT/CH4=0.0
!
!ONIT/ETH=0.0
!
!ONIT/ALKA=0.0
!
!ONIT/ALKE=0.0
!
!ONIT/BIO=0.0
!
!ONIT/ARO=0.0
!
!ONIT/HCHO=0.0
!
!ONIT/ALD=0.0
!
!ONIT/KET=0.0
!
!ONIT/CARBO=0.0
!
!ONIT/ONIT=-K017-K071*<OH>
 PJAC(:,26,26)=-TPK%K017(:)-TPK%K071(:)*PCONC(:,14)
!
!ONIT/PAN=+0.60*K078*<NO3>
 PJAC(:,26,27)=+0.60*TPK%K078(:)*PCONC(:,5)
!
!ONIT/OP1=0.0
!
!ONIT/OP2=0.0
!
!ONIT/ORA1=0.0
!
!ONIT/ORA2=0.0
!
!ONIT/MO2=+0.67560*K110*<OLN>
 PJAC(:,26,32)=+0.67560*TPK%K110(:)*PCONC(:,40)
!
!ONIT/ALKAP=+0.08459*K091*<NO>
 PJAC(:,26,33)=+0.08459*TPK%K091(:)*PCONC(:,3)
!
!ONIT/ALKEP=0.0
!
!ONIT/BIOP=+0.15300*K093*<NO>
 PJAC(:,26,35)=+0.15300*TPK%K093(:)*PCONC(:,3)
!
!ONIT/PHO=+K083*<NO2>
 PJAC(:,26,36)=+TPK%K083(:)*PCONC(:,4)
!
!ONIT/ADD=0.0
!
!ONIT/AROP=+0.04885*K094*<NO>
 PJAC(:,26,38)=+0.04885*TPK%K094(:)*PCONC(:,3)
!
!ONIT/CARBOP=+0.66562*K116*<OLN>
 PJAC(:,26,39)=+0.66562*TPK%K116(:)*PCONC(:,40)
!
!ONIT/OLN=+0.18401*K096*<NO>+K103*<HO2>+0.67560*K110*<MO2>+0.66562*K116*<CARBOP
!>+2.00*K117*<OLN>+2.00*K117*<OLN>+0.00000*K118*<OLN>+0.00000*K118*<OLN>+0.2592
!8*K125*<NO3>
 PJAC(:,26,40)=+0.18401*TPK%K096(:)*PCONC(:,3)+TPK%K103(:)*PCONC(:,15)+0.67560*&
&TPK%K110(:)*PCONC(:,32)+0.66562*TPK%K116(:)*PCONC(:,39)+2.00*TPK%K117(:)*PCONC&
&(:,40)+2.00*TPK%K117(:)*PCONC(:,40)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TP&
&K%K118(:)*PCONC(:,40)+0.25928*TPK%K125(:)*PCONC(:,5)
!
!ONIT/XO2=0.0
!
!ONIT/WC_O3=0.0
!
!ONIT/WC_H2O2=0.0
!
!ONIT/WC_NO=0.0
!
!ONIT/WC_NO2=0.0
!
!ONIT/WC_NO3=0.0
!
!ONIT/WC_N2O5=0.0
!
!ONIT/WC_HONO=0.0
!
!ONIT/WC_HNO3=0.0
!
!ONIT/WC_HNO4=0.0
!
!ONIT/WC_NH3=0.0
!
!ONIT/WC_OH=0.0
!
!ONIT/WC_HO2=0.0
!
!ONIT/WC_CO2=0.0
!
!ONIT/WC_SO2=0.0
!
!ONIT/WC_SULF=0.0
!
!ONIT/WC_HCHO=0.0
!
!ONIT/WC_ORA1=0.0
!
!ONIT/WC_ORA2=0.0
!
!ONIT/WC_MO2=0.0
!
!ONIT/WC_OP1=0.0
!
!ONIT/WC_ASO3=0.0
!
!ONIT/WC_ASO4=0.0
!
!ONIT/WC_ASO5=0.0
!
!ONIT/WC_AHSO5=0.0
!
!ONIT/WC_AHMS=0.0
!
!ONIT/WR_O3=0.0
!
!ONIT/WR_H2O2=0.0
!
!ONIT/WR_NO=0.0
!
!ONIT/WR_NO2=0.0
!
!ONIT/WR_NO3=0.0
!
!ONIT/WR_N2O5=0.0
!
!ONIT/WR_HONO=0.0
!
!ONIT/WR_HNO3=0.0
!
!ONIT/WR_HNO4=0.0
!
!ONIT/WR_NH3=0.0
!
!ONIT/WR_OH=0.0
!
!ONIT/WR_HO2=0.0
!
!ONIT/WR_CO2=0.0
!
!ONIT/WR_SO2=0.0
!
!ONIT/WR_SULF=0.0
!
!ONIT/WR_HCHO=0.0
!
!ONIT/WR_ORA1=0.0
!
!ONIT/WR_ORA2=0.0
!
!ONIT/WR_MO2=0.0
!
!ONIT/WR_OP1=0.0
!
!ONIT/WR_ASO3=0.0
!
!ONIT/WR_ASO4=0.0
!
!ONIT/WR_ASO5=0.0
!
!ONIT/WR_AHSO5=0.0
!
!ONIT/WR_AHMS=0.0
!
!PAN/O3=+0.30000*K082*<PAN>-K082*<PAN>
 PJAC(:,27,1)=+0.30000*TPK%K082(:)*PCONC(:,27)-TPK%K082(:)*PCONC(:,27)
!
!PAN/H2O2=0.0
!
!PAN/NO=0.0
!
!PAN/NO2=+1.00000*K088*<CARBOP>
 PJAC(:,27,4)=+1.00000*TPK%K088(:)*PCONC(:,39)
!
!PAN/NO3=+0.40000*K078*<PAN>-K078*<PAN>
 PJAC(:,27,5)=+0.40000*TPK%K078(:)*PCONC(:,27)-TPK%K078(:)*PCONC(:,27)
!
!PAN/N2O5=0.0
!
!PAN/HONO=0.0
!
!PAN/HNO3=0.0
!
!PAN/HNO4=0.0
!
!PAN/NH3=0.0
!
!PAN/SO2=0.0
!
!PAN/SULF=0.0
!
!PAN/CO=0.0
!
!PAN/OH=+0.28107*K070*<PAN>-K070*<PAN>
 PJAC(:,27,14)=+0.28107*TPK%K070(:)*PCONC(:,27)-TPK%K070(:)*PCONC(:,27)
!
!PAN/HO2=0.0
!
!PAN/CH4=0.0
!
!PAN/ETH=0.0
!
!PAN/ALKA=0.0
!
!PAN/ALKE=0.0
!
!PAN/BIO=0.0
!
!PAN/ARO=0.0
!
!PAN/HCHO=0.0
!
!PAN/ALD=0.0
!
!PAN/KET=0.0
!
!PAN/CARBO=0.0
!
!PAN/ONIT=0.0
!
!PAN/PAN=+0.28107*K070*<OH>-K070*<OH>+0.40000*K078*<NO3>-K078*<NO3>+0.30000*K08
!2*<O3>-K082*<O3>-K089
 PJAC(:,27,27)=+0.28107*TPK%K070(:)*PCONC(:,14)-TPK%K070(:)*PCONC(:,14)+0.40000&
&*TPK%K078(:)*PCONC(:,5)-TPK%K078(:)*PCONC(:,5)+0.30000*TPK%K082(:)*PCONC(:,1)-&
&TPK%K082(:)*PCONC(:,1)-TPK%K089(:)
!
!PAN/OP1=0.0
!
!PAN/OP2=0.0
!
!PAN/ORA1=0.0
!
!PAN/ORA2=0.0
!
!PAN/MO2=0.0
!
!PAN/ALKAP=0.0
!
!PAN/ALKEP=0.0
!
!PAN/BIOP=0.0
!
!PAN/PHO=0.0
!
!PAN/ADD=0.0
!
!PAN/AROP=0.0
!
!PAN/CARBOP=+1.00000*K088*<NO2>
 PJAC(:,27,39)=+1.00000*TPK%K088(:)*PCONC(:,4)
!
!PAN/OLN=0.0
!
!PAN/XO2=0.0
!
!PAN/WC_O3=0.0
!
!PAN/WC_H2O2=0.0
!
!PAN/WC_NO=0.0
!
!PAN/WC_NO2=0.0
!
!PAN/WC_NO3=0.0
!
!PAN/WC_N2O5=0.0
!
!PAN/WC_HONO=0.0
!
!PAN/WC_HNO3=0.0
!
!PAN/WC_HNO4=0.0
!
!PAN/WC_NH3=0.0
!
!PAN/WC_OH=0.0
!
!PAN/WC_HO2=0.0
!
!PAN/WC_CO2=0.0
!
!PAN/WC_SO2=0.0
!
!PAN/WC_SULF=0.0
!
!PAN/WC_HCHO=0.0
!
!PAN/WC_ORA1=0.0
!
!PAN/WC_ORA2=0.0
!
!PAN/WC_MO2=0.0
!
!PAN/WC_OP1=0.0
!
!PAN/WC_ASO3=0.0
!
!PAN/WC_ASO4=0.0
!
!PAN/WC_ASO5=0.0
!
!PAN/WC_AHSO5=0.0
!
!PAN/WC_AHMS=0.0
!
!PAN/WR_O3=0.0
!
!PAN/WR_H2O2=0.0
!
!PAN/WR_NO=0.0
!
!PAN/WR_NO2=0.0
!
!PAN/WR_NO3=0.0
!
!PAN/WR_N2O5=0.0
!
!PAN/WR_HONO=0.0
!
!PAN/WR_HNO3=0.0
!
!PAN/WR_HNO4=0.0
!
!PAN/WR_NH3=0.0
!
!PAN/WR_OH=0.0
!
!PAN/WR_HO2=0.0
!
!PAN/WR_CO2=0.0
!
!PAN/WR_SO2=0.0
!
!PAN/WR_SULF=0.0
!
!PAN/WR_HCHO=0.0
!
!PAN/WR_ORA1=0.0
!
!PAN/WR_ORA2=0.0
!
!PAN/WR_MO2=0.0
!
!PAN/WR_OP1=0.0
!
!PAN/WR_ASO3=0.0
!
!PAN/WR_ASO4=0.0
!
!PAN/WR_ASO5=0.0
!
!PAN/WR_AHSO5=0.0
!
!PAN/WR_AHMS=0.0
!
!OP1/O3=0.0
!
!OP1/H2O2=0.0
!
!OP1/NO=0.0
!
!OP1/NO2=0.0
!
!OP1/NO3=0.0
!
!OP1/N2O5=0.0
!
!OP1/HONO=0.0
!
!OP1/HNO3=0.0
!
!OP1/HNO4=0.0
!
!OP1/NH3=0.0
!
!OP1/SO2=0.0
!
!OP1/SULF=0.0
!
!OP1/CO=0.0
!
!OP1/OH=-K068*<OP1>
 PJAC(:,28,14)=-TPK%K068(:)*PCONC(:,28)
!
!OP1/HO2=+K097*<MO2>
 PJAC(:,28,15)=+TPK%K097(:)*PCONC(:,32)
!
!OP1/CH4=0.0
!
!OP1/ETH=0.0
!
!OP1/ALKA=0.0
!
!OP1/ALKE=0.0
!
!OP1/BIO=0.0
!
!OP1/ARO=0.0
!
!OP1/HCHO=0.0
!
!OP1/ALD=0.0
!
!OP1/KET=0.0
!
!OP1/CARBO=0.0
!
!OP1/ONIT=0.0
!
!OP1/PAN=0.0
!
!OP1/OP1=-K013-K068*<OH>-KTC20-KTR20
 PJAC(:,28,28)=-TPK%K013(:)-TPK%K068(:)*PCONC(:,14)-TPK%KTC20(:)-TPK%KTR20(:)
!
!OP1/OP2=0.0
!
!OP1/ORA1=0.0
!
!OP1/ORA2=0.0
!
!OP1/MO2=+K097*<HO2>
 PJAC(:,28,32)=+TPK%K097(:)*PCONC(:,15)
!
!OP1/ALKAP=0.0
!
!OP1/ALKEP=0.0
!
!OP1/BIOP=0.0
!
!OP1/PHO=0.0
!
!OP1/ADD=0.0
!
!OP1/AROP=0.0
!
!OP1/CARBOP=0.0
!
!OP1/OLN=0.0
!
!OP1/XO2=0.0
!
!OP1/WC_O3=0.0
!
!OP1/WC_H2O2=0.0
!
!OP1/WC_NO=0.0
!
!OP1/WC_NO2=0.0
!
!OP1/WC_NO3=0.0
!
!OP1/WC_N2O5=0.0
!
!OP1/WC_HONO=0.0
!
!OP1/WC_HNO3=0.0
!
!OP1/WC_HNO4=0.0
!
!OP1/WC_NH3=0.0
!
!OP1/WC_OH=0.0
!
!OP1/WC_HO2=0.0
!
!OP1/WC_CO2=0.0
!
!OP1/WC_SO2=0.0
!
!OP1/WC_SULF=0.0
!
!OP1/WC_HCHO=0.0
!
!OP1/WC_ORA1=0.0
!
!OP1/WC_ORA2=0.0
!
!OP1/WC_MO2=0.0
!
!OP1/WC_OP1=+KTC40
 PJAC(:,28,61)=+TPK%KTC40(:)
!
!OP1/WC_ASO3=0.0
!
!OP1/WC_ASO4=0.0
!
!OP1/WC_ASO5=0.0
!
!OP1/WC_AHSO5=0.0
!
!OP1/WC_AHMS=0.0
!
!OP1/WR_O3=0.0
!
!OP1/WR_H2O2=0.0
!
!OP1/WR_NO=0.0
!
!OP1/WR_NO2=0.0
!
!OP1/WR_NO3=0.0
!
!OP1/WR_N2O5=0.0
!
!OP1/WR_HONO=0.0
!
!OP1/WR_HNO3=0.0
!
!OP1/WR_HNO4=0.0
!
!OP1/WR_NH3=0.0
!
!OP1/WR_OH=0.0
!
!OP1/WR_HO2=0.0
!
!OP1/WR_CO2=0.0
!
!OP1/WR_SO2=0.0
!
!OP1/WR_SULF=0.0
!
!OP1/WR_HCHO=0.0
!
!OP1/WR_ORA1=0.0
!
!OP1/WR_ORA2=0.0
!
!OP1/WR_MO2=0.0
!
!OP1/WR_OP1=+KTR40
 PJAC(:,28,86)=+TPK%KTR40(:)
!
!OP1/WR_ASO3=0.0
!
!OP1/WR_ASO4=0.0
!
!OP1/WR_ASO5=0.0
!
!OP1/WR_AHSO5=0.0
!
!OP1/WR_AHMS=0.0
!
!OP2/O3=+0.10149*K081*<CARBO>
 PJAC(:,29,1)=+0.10149*TPK%K081(:)*PCONC(:,25)
!
!OP2/H2O2=0.0
!
!OP2/NO=0.0
!
!OP2/NO2=0.0
!
!OP2/NO3=0.0
!
!OP2/N2O5=0.0
!
!OP2/HONO=0.0
!
!OP2/HNO3=0.0
!
!OP2/HNO4=0.0
!
!OP2/NH3=0.0
!
!OP2/SO2=0.0
!
!OP2/SULF=0.0
!
!OP2/CO=0.0
!
!OP2/OH=-K069*<OP2>
 PJAC(:,29,14)=-TPK%K069(:)*PCONC(:,29)
!
!OP2/HO2=+1.00524*K098*<ALKAP>+1.00524*K099*<ALKEP>+1.00524*K0100*<BIOP>+1.0052
!4*K0101*<AROP>+0.80904*K0102*<CARBOP>+1.00524*K126*<XO2>
 PJAC(:,29,15)=+1.00524*TPK%K098(:)*PCONC(:,33)+1.00524*TPK%K099(:)*PCONC(:,34)&
&+1.00524*TPK%K0100(:)*PCONC(:,35)+1.00524*TPK%K0101(:)*PCONC(:,38)+0.80904*TPK&
&%K0102(:)*PCONC(:,39)+1.00524*TPK%K126(:)*PCONC(:,41)
!
!OP2/CH4=0.0
!
!OP2/ETH=0.0
!
!OP2/ALKA=0.0
!
!OP2/ALKE=0.0
!
!OP2/BIO=0.0
!
!OP2/ARO=0.0
!
!OP2/HCHO=0.0
!
!OP2/ALD=0.0
!
!OP2/KET=0.0
!
!OP2/CARBO=+0.10149*K081*<O3>
 PJAC(:,29,25)=+0.10149*TPK%K081(:)*PCONC(:,1)
!
!OP2/ONIT=0.0
!
!OP2/PAN=0.0
!
!OP2/OP1=0.0
!
!OP2/OP2=-K014-K069*<OH>
 PJAC(:,29,29)=-TPK%K014(:)-TPK%K069(:)*PCONC(:,14)
!
!OP2/ORA1=0.0
!
!OP2/ORA2=0.0
!
!OP2/MO2=0.0
!
!OP2/ALKAP=+1.00524*K098*<HO2>
 PJAC(:,29,33)=+1.00524*TPK%K098(:)*PCONC(:,15)
!
!OP2/ALKEP=+1.00524*K099*<HO2>
 PJAC(:,29,34)=+1.00524*TPK%K099(:)*PCONC(:,15)
!
!OP2/BIOP=+1.00524*K0100*<HO2>
 PJAC(:,29,35)=+1.00524*TPK%K0100(:)*PCONC(:,15)
!
!OP2/PHO=0.0
!
!OP2/ADD=0.0
!
!OP2/AROP=+1.00524*K0101*<HO2>
 PJAC(:,29,38)=+1.00524*TPK%K0101(:)*PCONC(:,15)
!
!OP2/CARBOP=+0.80904*K0102*<HO2>
 PJAC(:,29,39)=+0.80904*TPK%K0102(:)*PCONC(:,15)
!
!OP2/OLN=0.0
!
!OP2/XO2=+1.00524*K126*<HO2>
 PJAC(:,29,41)=+1.00524*TPK%K126(:)*PCONC(:,15)
!
!OP2/WC_O3=0.0
!
!OP2/WC_H2O2=0.0
!
!OP2/WC_NO=0.0
!
!OP2/WC_NO2=0.0
!
!OP2/WC_NO3=0.0
!
!OP2/WC_N2O5=0.0
!
!OP2/WC_HONO=0.0
!
!OP2/WC_HNO3=0.0
!
!OP2/WC_HNO4=0.0
!
!OP2/WC_NH3=0.0
!
!OP2/WC_OH=0.0
!
!OP2/WC_HO2=0.0
!
!OP2/WC_CO2=0.0
!
!OP2/WC_SO2=0.0
!
!OP2/WC_SULF=0.0
!
!OP2/WC_HCHO=0.0
!
!OP2/WC_ORA1=0.0
!
!OP2/WC_ORA2=0.0
!
!OP2/WC_MO2=0.0
!
!OP2/WC_OP1=0.0
!
!OP2/WC_ASO3=0.0
!
!OP2/WC_ASO4=0.0
!
!OP2/WC_ASO5=0.0
!
!OP2/WC_AHSO5=0.0
!
!OP2/WC_AHMS=0.0
!
!OP2/WR_O3=0.0
!
!OP2/WR_H2O2=0.0
!
!OP2/WR_NO=0.0
!
!OP2/WR_NO2=0.0
!
!OP2/WR_NO3=0.0
!
!OP2/WR_N2O5=0.0
!
!OP2/WR_HONO=0.0
!
!OP2/WR_HNO3=0.0
!
!OP2/WR_HNO4=0.0
!
!OP2/WR_NH3=0.0
!
!OP2/WR_OH=0.0
!
!OP2/WR_HO2=0.0
!
!OP2/WR_CO2=0.0
!
!OP2/WR_SO2=0.0
!
!OP2/WR_SULF=0.0
!
!OP2/WR_HCHO=0.0
!
!OP2/WR_ORA1=0.0
!
!OP2/WR_ORA2=0.0
!
!OP2/WR_MO2=0.0
!
!OP2/WR_OP1=0.0
!
!OP2/WR_ASO3=0.0
!
!OP2/WR_ASO4=0.0
!
!OP2/WR_ASO5=0.0
!
!OP2/WR_AHSO5=0.0
!
!OP2/WR_AHMS=0.0
!
!ORA1/O3=+0.15343*K079*<ALKE>+0.15000*K080*<BIO>+0.10788*K081*<CARBO>+0.11*K082
!*<PAN>
 PJAC(:,30,1)=+0.15343*TPK%K079(:)*PCONC(:,19)+0.15000*TPK%K080(:)*PCONC(:,20)+&
&0.10788*TPK%K081(:)*PCONC(:,25)+0.11*TPK%K082(:)*PCONC(:,27)
!
!ORA1/H2O2=0.0
!
!ORA1/NO=0.0
!
!ORA1/NO2=0.0
!
!ORA1/NO3=0.0
!
!ORA1/N2O5=0.0
!
!ORA1/HONO=0.0
!
!ORA1/HNO3=0.0
!
!ORA1/HNO4=0.0
!
!ORA1/NH3=0.0
!
!ORA1/SO2=0.0
!
!ORA1/SULF=0.0
!
!ORA1/CO=0.0
!
!ORA1/OH=+0.00878*K058*<ALKA>-K066*<ORA1>
 PJAC(:,30,14)=+0.00878*TPK%K058(:)*PCONC(:,18)-TPK%K066(:)*PCONC(:,30)
!
!ORA1/HO2=0.0
!
!ORA1/CH4=0.0
!
!ORA1/ETH=0.0
!
!ORA1/ALKA=+0.00878*K058*<OH>
 PJAC(:,30,18)=+0.00878*TPK%K058(:)*PCONC(:,14)
!
!ORA1/ALKE=+0.15343*K079*<O3>
 PJAC(:,30,19)=+0.15343*TPK%K079(:)*PCONC(:,1)
!
!ORA1/BIO=+0.15000*K080*<O3>
 PJAC(:,30,20)=+0.15000*TPK%K080(:)*PCONC(:,1)
!
!ORA1/ARO=0.0
!
!ORA1/HCHO=0.0
!
!ORA1/ALD=0.0
!
!ORA1/KET=0.0
!
!ORA1/CARBO=+0.10788*K081*<O3>
 PJAC(:,30,25)=+0.10788*TPK%K081(:)*PCONC(:,1)
!
!ORA1/ONIT=0.0
!
!ORA1/PAN=+0.11*K082*<O3>
 PJAC(:,30,27)=+0.11*TPK%K082(:)*PCONC(:,1)
!
!ORA1/OP1=0.0
!
!ORA1/OP2=0.0
!
!ORA1/ORA1=-K066*<OH>-KTC17-KTR17
 PJAC(:,30,30)=-TPK%K066(:)*PCONC(:,14)-TPK%KTC17(:)-TPK%KTR17(:)
!
!ORA1/ORA2=0.0
!
!ORA1/MO2=0.0
!
!ORA1/ALKAP=0.0
!
!ORA1/ALKEP=0.0
!
!ORA1/BIOP=0.0
!
!ORA1/PHO=0.0
!
!ORA1/ADD=0.0
!
!ORA1/AROP=0.0
!
!ORA1/CARBOP=0.0
!
!ORA1/OLN=0.0
!
!ORA1/XO2=0.0
!
!ORA1/WC_O3=0.0
!
!ORA1/WC_H2O2=0.0
!
!ORA1/WC_NO=0.0
!
!ORA1/WC_NO2=0.0
!
!ORA1/WC_NO3=0.0
!
!ORA1/WC_N2O5=0.0
!
!ORA1/WC_HONO=0.0
!
!ORA1/WC_HNO3=0.0
!
!ORA1/WC_HNO4=0.0
!
!ORA1/WC_NH3=0.0
!
!ORA1/WC_OH=0.0
!
!ORA1/WC_HO2=0.0
!
!ORA1/WC_CO2=0.0
!
!ORA1/WC_SO2=0.0
!
!ORA1/WC_SULF=0.0
!
!ORA1/WC_HCHO=0.0
!
!ORA1/WC_ORA1=+KTC37
 PJAC(:,30,58)=+TPK%KTC37(:)
!
!ORA1/WC_ORA2=0.0
!
!ORA1/WC_MO2=0.0
!
!ORA1/WC_OP1=0.0
!
!ORA1/WC_ASO3=0.0
!
!ORA1/WC_ASO4=0.0
!
!ORA1/WC_ASO5=0.0
!
!ORA1/WC_AHSO5=0.0
!
!ORA1/WC_AHMS=0.0
!
!ORA1/WR_O3=0.0
!
!ORA1/WR_H2O2=0.0
!
!ORA1/WR_NO=0.0
!
!ORA1/WR_NO2=0.0
!
!ORA1/WR_NO3=0.0
!
!ORA1/WR_N2O5=0.0
!
!ORA1/WR_HONO=0.0
!
!ORA1/WR_HNO3=0.0
!
!ORA1/WR_HNO4=0.0
!
!ORA1/WR_NH3=0.0
!
!ORA1/WR_OH=0.0
!
!ORA1/WR_HO2=0.0
!
!ORA1/WR_CO2=0.0
!
!ORA1/WR_SO2=0.0
!
!ORA1/WR_SULF=0.0
!
!ORA1/WR_HCHO=0.0
!
!ORA1/WR_ORA1=+KTR37
 PJAC(:,30,83)=+TPK%KTR37(:)
!
!ORA1/WR_ORA2=0.0
!
!ORA1/WR_MO2=0.0
!
!ORA1/WR_OP1=0.0
!
!ORA1/WR_ASO3=0.0
!
!ORA1/WR_ASO4=0.0
!
!ORA1/WR_ASO5=0.0
!
!ORA1/WR_AHSO5=0.0
!
!ORA1/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ5
!
SUBROUTINE SUBJ6
!
!Indices 31 a 35
!
!
!ORA2/O3=+0.08143*K079*<ALKE>+0.00000*K080*<BIO>+0.20595*K081*<CARBO>
 PJAC(:,31,1)=+0.08143*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)+&
&0.20595*TPK%K081(:)*PCONC(:,25)
!
!ORA2/H2O2=0.0
!
!ORA2/NO=0.0
!
!ORA2/NO2=0.0
!
!ORA2/NO3=0.0
!
!ORA2/N2O5=0.0
!
!ORA2/HONO=0.0
!
!ORA2/HNO3=0.0
!
!ORA2/HNO4=0.0
!
!ORA2/NH3=0.0
!
!ORA2/SO2=0.0
!
!ORA2/SULF=0.0
!
!ORA2/CO=0.0
!
!ORA2/OH=-K067*<ORA2>
 PJAC(:,31,14)=-TPK%K067(:)*PCONC(:,31)
!
!ORA2/HO2=+0.17307*K0102*<CARBOP>
 PJAC(:,31,15)=+0.17307*TPK%K0102(:)*PCONC(:,39)
!
!ORA2/CH4=0.0
!
!ORA2/ETH=0.0
!
!ORA2/ALKA=0.0
!
!ORA2/ALKE=+0.08143*K079*<O3>
 PJAC(:,31,19)=+0.08143*TPK%K079(:)*PCONC(:,1)
!
!ORA2/BIO=+0.00000*K080*<O3>
 PJAC(:,31,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!ORA2/ARO=0.0
!
!ORA2/HCHO=0.0
!
!ORA2/ALD=0.0
!
!ORA2/KET=0.0
!
!ORA2/CARBO=+0.20595*K081*<O3>
 PJAC(:,31,25)=+0.20595*TPK%K081(:)*PCONC(:,1)
!
!ORA2/ONIT=0.0
!
!ORA2/PAN=0.0
!
!ORA2/OP1=0.0
!
!ORA2/OP2=0.0
!
!ORA2/ORA1=0.0
!
!ORA2/ORA2=-K067*<OH>-KTC18-KTR18
 PJAC(:,31,31)=-TPK%K067(:)*PCONC(:,14)-TPK%KTC18(:)-TPK%KTR18(:)
!
!ORA2/MO2=+0.13684*K109*<CARBOP>
 PJAC(:,31,32)=+0.13684*TPK%K109(:)*PCONC(:,39)
!
!ORA2/ALKAP=+0.49810*K111*<CARBOP>
 PJAC(:,31,33)=+0.49810*TPK%K111(:)*PCONC(:,39)
!
!ORA2/ALKEP=+0.49922*K112*<CARBOP>
 PJAC(:,31,34)=+0.49922*TPK%K112(:)*PCONC(:,39)
!
!ORA2/BIOP=+0.49400*K113*<CARBOP>
 PJAC(:,31,35)=+0.49400*TPK%K113(:)*PCONC(:,39)
!
!ORA2/PHO=0.0
!
!ORA2/ADD=0.0
!
!ORA2/AROP=0.0
!
!ORA2/CARBOP=+0.17307*K0102*<HO2>+0.13684*K109*<MO2>+0.49810*K111*<ALKAP>+0.499
!22*K112*<ALKEP>+0.49400*K113*<BIOP>+0.09955*K115*<CARBOP>+0.09955*K115*<CARBOP
!>+0.48963*K116*<OLN>
 PJAC(:,31,39)=+0.17307*TPK%K0102(:)*PCONC(:,15)+0.13684*TPK%K109(:)*PCONC(:,32&
&)+0.49810*TPK%K111(:)*PCONC(:,33)+0.49922*TPK%K112(:)*PCONC(:,34)+0.49400*TPK%&
&K113(:)*PCONC(:,35)+0.09955*TPK%K115(:)*PCONC(:,39)+0.09955*TPK%K115(:)*PCONC(&
&:,39)+0.48963*TPK%K116(:)*PCONC(:,40)
!
!ORA2/OLN=+0.48963*K116*<CARBOP>
 PJAC(:,31,40)=+0.48963*TPK%K116(:)*PCONC(:,39)
!
!ORA2/XO2=0.0
!
!ORA2/WC_O3=0.0
!
!ORA2/WC_H2O2=0.0
!
!ORA2/WC_NO=0.0
!
!ORA2/WC_NO2=0.0
!
!ORA2/WC_NO3=0.0
!
!ORA2/WC_N2O5=0.0
!
!ORA2/WC_HONO=0.0
!
!ORA2/WC_HNO3=0.0
!
!ORA2/WC_HNO4=0.0
!
!ORA2/WC_NH3=0.0
!
!ORA2/WC_OH=0.0
!
!ORA2/WC_HO2=0.0
!
!ORA2/WC_CO2=0.0
!
!ORA2/WC_SO2=0.0
!
!ORA2/WC_SULF=0.0
!
!ORA2/WC_HCHO=0.0
!
!ORA2/WC_ORA1=0.0
!
!ORA2/WC_ORA2=+KTC38
 PJAC(:,31,59)=+TPK%KTC38(:)
!
!ORA2/WC_MO2=0.0
!
!ORA2/WC_OP1=0.0
!
!ORA2/WC_ASO3=0.0
!
!ORA2/WC_ASO4=0.0
!
!ORA2/WC_ASO5=0.0
!
!ORA2/WC_AHSO5=0.0
!
!ORA2/WC_AHMS=0.0
!
!ORA2/WR_O3=0.0
!
!ORA2/WR_H2O2=0.0
!
!ORA2/WR_NO=0.0
!
!ORA2/WR_NO2=0.0
!
!ORA2/WR_NO3=0.0
!
!ORA2/WR_N2O5=0.0
!
!ORA2/WR_HONO=0.0
!
!ORA2/WR_HNO3=0.0
!
!ORA2/WR_HNO4=0.0
!
!ORA2/WR_NH3=0.0
!
!ORA2/WR_OH=0.0
!
!ORA2/WR_HO2=0.0
!
!ORA2/WR_CO2=0.0
!
!ORA2/WR_SO2=0.0
!
!ORA2/WR_SULF=0.0
!
!ORA2/WR_HCHO=0.0
!
!ORA2/WR_ORA1=0.0
!
!ORA2/WR_ORA2=+KTR38
 PJAC(:,31,84)=+TPK%KTR38(:)
!
!ORA2/WR_MO2=0.0
!
!ORA2/WR_OP1=0.0
!
!ORA2/WR_ASO3=0.0
!
!ORA2/WR_ASO4=0.0
!
!ORA2/WR_ASO5=0.0
!
!ORA2/WR_AHSO5=0.0
!
!ORA2/WR_AHMS=0.0
!
!MO2/O3=+0.13966*K079*<ALKE>+0.03000*K080*<BIO>
 PJAC(:,32,1)=+0.13966*TPK%K079(:)*PCONC(:,19)+0.03000*TPK%K080(:)*PCONC(:,20)
!
!MO2/H2O2=0.0
!
!MO2/NO=-K090*<MO2>+0.09016*K091*<ALKAP>+0.78134*K095*<CARBOP>
 PJAC(:,32,3)=-TPK%K090(:)*PCONC(:,32)+0.09016*TPK%K091(:)*PCONC(:,33)+0.78134*&
&TPK%K095(:)*PCONC(:,39)
!
!MO2/NO2=0.0
!
!MO2/NO3=-K119*<MO2>+0.09731*K120*<ALKAP>+0.91910*K124*<CARBOP>
 PJAC(:,32,5)=-TPK%K119(:)*PCONC(:,32)+0.09731*TPK%K120(:)*PCONC(:,33)+0.91910*&
&TPK%K124(:)*PCONC(:,39)
!
!MO2/N2O5=0.0
!
!MO2/HONO=0.0
!
!MO2/HNO3=0.0
!
!MO2/HNO4=0.0
!
!MO2/NH3=0.0
!
!MO2/SO2=0.0
!
!MO2/SULF=0.0
!
!MO2/CO=0.0
!
!MO2/OH=+K056*<CH4>+0.65*K068*<OP1>
 PJAC(:,32,14)=+TPK%K056(:)*PCONC(:,16)+0.65*TPK%K068(:)*PCONC(:,28)
!
!MO2/HO2=-K097*<MO2>
 PJAC(:,32,15)=-TPK%K097(:)*PCONC(:,32)
!
!MO2/CH4=+K056*<OH>
 PJAC(:,32,16)=+TPK%K056(:)*PCONC(:,14)
!
!MO2/ETH=0.0
!
!MO2/ALKA=0.0
!
!MO2/ALKE=+0.13966*K079*<O3>
 PJAC(:,32,19)=+0.13966*TPK%K079(:)*PCONC(:,1)
!
!MO2/BIO=+0.03000*K080*<O3>
 PJAC(:,32,20)=+0.03000*TPK%K080(:)*PCONC(:,1)
!
!MO2/ARO=0.0
!
!MO2/HCHO=0.0
!
!MO2/ALD=+K012
 PJAC(:,32,23)=+TPK%K012(:)
!
!MO2/KET=0.0
!
!MO2/CARBO=0.0
!
!MO2/ONIT=0.0
!
!MO2/PAN=0.0
!
!MO2/OP1=+0.65*K068*<OH>
 PJAC(:,32,28)=+0.65*TPK%K068(:)*PCONC(:,14)
!
!MO2/OP2=+0.03795*K014
 PJAC(:,32,29)=+0.03795*TPK%K014(:)
!
!MO2/ORA1=0.0
!
!MO2/ORA2=0.0
!
!MO2/MO2=-K090*<NO>-K097*<HO2>-K104*<MO2>-K104*<MO2>-K104*<MO2>-K104*<MO2>+0.01
!390*K105*<ALKAP>-K105*<ALKAP>-K106*<ALKEP>-K107*<BIOP>-K108*<AROP>+0.56031*K10
!9*<CARBOP>-K109*<CARBOP>-K110*<OLN>-K119*<NO3>-K127*<XO2>-KTC19-KTR19
 PJAC(:,32,32)=-TPK%K090(:)*PCONC(:,3)-TPK%K097(:)*PCONC(:,15)-TPK%K104(:)*PCON&
&C(:,32)-TPK%K104(:)*PCONC(:,32)-TPK%K104(:)*PCONC(:,32)-TPK%K104(:)*PCONC(:,32&
&)+0.01390*TPK%K105(:)*PCONC(:,33)-TPK%K105(:)*PCONC(:,33)-TPK%K106(:)*PCONC(:,&
&34)-TPK%K107(:)*PCONC(:,35)-TPK%K108(:)*PCONC(:,38)+0.56031*TPK%K109(:)*PCONC(&
&:,39)-TPK%K109(:)*PCONC(:,39)-TPK%K110(:)*PCONC(:,40)-TPK%K119(:)*PCONC(:,5)-T&
&PK%K127(:)*PCONC(:,41)-TPK%KTC19(:)-TPK%KTR19(:)
!
!MO2/ALKAP=+0.09016*K091*<NO>+0.01390*K105*<MO2>-K105*<MO2>+0.51480*K111*<CARBO
!P>+0.09731*K120*<NO3>
 PJAC(:,32,33)=+0.09016*TPK%K091(:)*PCONC(:,3)+0.01390*TPK%K105(:)*PCONC(:,32)-&
&TPK%K105(:)*PCONC(:,32)+0.51480*TPK%K111(:)*PCONC(:,39)+0.09731*TPK%K120(:)*PC&
&ONC(:,5)
!
!MO2/ALKEP=-K106*<MO2>+0.50078*K112*<CARBOP>
 PJAC(:,32,34)=-TPK%K106(:)*PCONC(:,32)+0.50078*TPK%K112(:)*PCONC(:,39)
!
!MO2/BIOP=-K107*<MO2>+0.50600*K113*<CARBOP>
 PJAC(:,32,35)=-TPK%K107(:)*PCONC(:,32)+0.50600*TPK%K113(:)*PCONC(:,39)
!
!MO2/PHO=0.0
!
!MO2/ADD=0.0
!
!MO2/AROP=-K108*<MO2>+K114*<CARBOP>
 PJAC(:,32,38)=-TPK%K108(:)*PCONC(:,32)+TPK%K114(:)*PCONC(:,39)
!
!MO2/CARBOP=+0.78134*K095*<NO>+0.56031*K109*<MO2>-K109*<MO2>+0.51480*K111*<ALKA
!P>+0.50078*K112*<ALKEP>+0.50600*K113*<BIOP>+K114*<AROP>+1.66702*K115*<CARBOP>+
!1.66702*K115*<CARBOP>+0.51037*K116*<OLN>+0.91910*K124*<NO3>+K128*<XO2>
 PJAC(:,32,39)=+0.78134*TPK%K095(:)*PCONC(:,3)+0.56031*TPK%K109(:)*PCONC(:,32)-&
&TPK%K109(:)*PCONC(:,32)+0.51480*TPK%K111(:)*PCONC(:,33)+0.50078*TPK%K112(:)*PC&
&ONC(:,34)+0.50600*TPK%K113(:)*PCONC(:,35)+TPK%K114(:)*PCONC(:,38)+1.66702*TPK%&
&K115(:)*PCONC(:,39)+1.66702*TPK%K115(:)*PCONC(:,39)+0.51037*TPK%K116(:)*PCONC(&
&:,40)+0.91910*TPK%K124(:)*PCONC(:,5)+TPK%K128(:)*PCONC(:,41)
!
!MO2/OLN=-K110*<MO2>+0.51037*K116*<CARBOP>
 PJAC(:,32,40)=-TPK%K110(:)*PCONC(:,32)+0.51037*TPK%K116(:)*PCONC(:,39)
!
!MO2/XO2=-K127*<MO2>+K128*<CARBOP>
 PJAC(:,32,41)=-TPK%K127(:)*PCONC(:,32)+TPK%K128(:)*PCONC(:,39)
!
!MO2/WC_O3=0.0
!
!MO2/WC_H2O2=0.0
!
!MO2/WC_NO=0.0
!
!MO2/WC_NO2=0.0
!
!MO2/WC_NO3=0.0
!
!MO2/WC_N2O5=0.0
!
!MO2/WC_HONO=0.0
!
!MO2/WC_HNO3=0.0
!
!MO2/WC_HNO4=0.0
!
!MO2/WC_NH3=0.0
!
!MO2/WC_OH=0.0
!
!MO2/WC_HO2=0.0
!
!MO2/WC_CO2=0.0
!
!MO2/WC_SO2=0.0
!
!MO2/WC_SULF=0.0
!
!MO2/WC_HCHO=0.0
!
!MO2/WC_ORA1=0.0
!
!MO2/WC_ORA2=0.0
!
!MO2/WC_MO2=+KTC39
 PJAC(:,32,60)=+TPK%KTC39(:)
!
!MO2/WC_OP1=0.0
!
!MO2/WC_ASO3=0.0
!
!MO2/WC_ASO4=0.0
!
!MO2/WC_ASO5=0.0
!
!MO2/WC_AHSO5=0.0
!
!MO2/WC_AHMS=0.0
!
!MO2/WR_O3=0.0
!
!MO2/WR_H2O2=0.0
!
!MO2/WR_NO=0.0
!
!MO2/WR_NO2=0.0
!
!MO2/WR_NO3=0.0
!
!MO2/WR_N2O5=0.0
!
!MO2/WR_HONO=0.0
!
!MO2/WR_HNO3=0.0
!
!MO2/WR_HNO4=0.0
!
!MO2/WR_NH3=0.0
!
!MO2/WR_OH=0.0
!
!MO2/WR_HO2=0.0
!
!MO2/WR_CO2=0.0
!
!MO2/WR_SO2=0.0
!
!MO2/WR_SULF=0.0
!
!MO2/WR_HCHO=0.0
!
!MO2/WR_ORA1=0.0
!
!MO2/WR_ORA2=0.0
!
!MO2/WR_MO2=+KTR39
 PJAC(:,32,85)=+TPK%KTR39(:)
!
!MO2/WR_OP1=0.0
!
!MO2/WR_ASO3=0.0
!
!MO2/WR_ASO4=0.0
!
!MO2/WR_ASO5=0.0
!
!MO2/WR_AHSO5=0.0
!
!MO2/WR_AHMS=0.0
!
!ALKAP/O3=+0.09815*K079*<ALKE>+0.00000*K080*<BIO>
 PJAC(:,33,1)=+0.09815*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)
!
!ALKAP/H2O2=0.0
!
!ALKAP/NO=+0.08187*K091*<ALKAP>-K091*<ALKAP>
 PJAC(:,33,3)=+0.08187*TPK%K091(:)*PCONC(:,33)-TPK%K091(:)*PCONC(:,33)
!
!ALKAP/NO2=0.0
!
!ALKAP/NO3=+0.08994*K120*<ALKAP>-K120*<ALKAP>
 PJAC(:,33,5)=+0.08994*TPK%K120(:)*PCONC(:,33)-TPK%K120(:)*PCONC(:,33)
!
!ALKAP/N2O5=0.0
!
!ALKAP/HONO=0.0
!
!ALKAP/HNO3=0.0
!
!ALKAP/HNO4=0.0
!
!ALKAP/NH3=0.0
!
!ALKAP/SO2=0.0
!
!ALKAP/SULF=0.0
!
!ALKAP/CO=0.0
!
!ALKAP/OH=+K057*<ETH>+0.87811*K058*<ALKA>+0.40341*K069*<OP2>+1.00000*K071*<ONIT
!>
 PJAC(:,33,14)=+TPK%K057(:)*PCONC(:,17)+0.87811*TPK%K058(:)*PCONC(:,18)+0.40341&
&*TPK%K069(:)*PCONC(:,29)+1.00000*TPK%K071(:)*PCONC(:,26)
!
!ALKAP/HO2=-K098*<ALKAP>
 PJAC(:,33,15)=-TPK%K098(:)*PCONC(:,33)
!
!ALKAP/CH4=0.0
!
!ALKAP/ETH=+K057*<OH>
 PJAC(:,33,17)=+TPK%K057(:)*PCONC(:,14)
!
!ALKAP/ALKA=+0.87811*K058*<OH>
 PJAC(:,33,18)=+0.87811*TPK%K058(:)*PCONC(:,14)
!
!ALKAP/ALKE=+0.09815*K079*<O3>
 PJAC(:,33,19)=+0.09815*TPK%K079(:)*PCONC(:,1)
!
!ALKAP/BIO=+0.00000*K080*<O3>
 PJAC(:,33,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!ALKAP/ARO=0.0
!
!ALKAP/HCHO=0.0
!
!ALKAP/ALD=0.0
!
!ALKAP/KET=+1.00000*K015
 PJAC(:,33,24)=+1.00000*TPK%K015(:)
!
!ALKAP/CARBO=0.0
!
!ALKAP/ONIT=+1.00000*K071*<OH>
 PJAC(:,33,26)=+1.00000*TPK%K071(:)*PCONC(:,14)
!
!ALKAP/PAN=0.0
!
!ALKAP/OP1=0.0
!
!ALKAP/OP2=+0.40341*K069*<OH>
 PJAC(:,33,29)=+0.40341*TPK%K069(:)*PCONC(:,14)
!
!ALKAP/ORA1=0.0
!
!ALKAP/ORA2=0.0
!
!ALKAP/MO2=+0.00385*K105*<ALKAP>-K105*<ALKAP>
 PJAC(:,33,32)=+0.00385*TPK%K105(:)*PCONC(:,33)-TPK%K105(:)*PCONC(:,33)
!
!ALKAP/ALKAP=+0.08187*K091*<NO>-K091*<NO>-K098*<HO2>+0.00385*K105*<MO2>-K105*<M
!O2>+0.00828*K111*<CARBOP>-K111*<CARBOP>+0.08994*K120*<NO3>-K120*<NO3>
 PJAC(:,33,33)=+0.08187*TPK%K091(:)*PCONC(:,3)-TPK%K091(:)*PCONC(:,3)-TPK%K098(&
&:)*PCONC(:,15)+0.00385*TPK%K105(:)*PCONC(:,32)-TPK%K105(:)*PCONC(:,32)+0.00828&
&*TPK%K111(:)*PCONC(:,39)-TPK%K111(:)*PCONC(:,39)+0.08994*TPK%K120(:)*PCONC(:,5&
&)-TPK%K120(:)*PCONC(:,5)
!
!ALKAP/ALKEP=0.0
!
!ALKAP/BIOP=0.0
!
!ALKAP/PHO=0.0
!
!ALKAP/ADD=0.0
!
!ALKAP/AROP=0.0
!
!ALKAP/CARBOP=+0.00828*K111*<ALKAP>-K111*<ALKAP>
 PJAC(:,33,39)=+0.00828*TPK%K111(:)*PCONC(:,33)-TPK%K111(:)*PCONC(:,33)
!
!ALKAP/OLN=0.0
!
!ALKAP/XO2=0.0
!
!ALKAP/WC_O3=0.0
!
!ALKAP/WC_H2O2=0.0
!
!ALKAP/WC_NO=0.0
!
!ALKAP/WC_NO2=0.0
!
!ALKAP/WC_NO3=0.0
!
!ALKAP/WC_N2O5=0.0
!
!ALKAP/WC_HONO=0.0
!
!ALKAP/WC_HNO3=0.0
!
!ALKAP/WC_HNO4=0.0
!
!ALKAP/WC_NH3=0.0
!
!ALKAP/WC_OH=0.0
!
!ALKAP/WC_HO2=0.0
!
!ALKAP/WC_CO2=0.0
!
!ALKAP/WC_SO2=0.0
!
!ALKAP/WC_SULF=0.0
!
!ALKAP/WC_HCHO=0.0
!
!ALKAP/WC_ORA1=0.0
!
!ALKAP/WC_ORA2=0.0
!
!ALKAP/WC_MO2=0.0
!
!ALKAP/WC_OP1=0.0
!
!ALKAP/WC_ASO3=0.0
!
!ALKAP/WC_ASO4=0.0
!
!ALKAP/WC_ASO5=0.0
!
!ALKAP/WC_AHSO5=0.0
!
!ALKAP/WC_AHMS=0.0
!
!ALKAP/WR_O3=0.0
!
!ALKAP/WR_H2O2=0.0
!
!ALKAP/WR_NO=0.0
!
!ALKAP/WR_NO2=0.0
!
!ALKAP/WR_NO3=0.0
!
!ALKAP/WR_N2O5=0.0
!
!ALKAP/WR_HONO=0.0
!
!ALKAP/WR_HNO3=0.0
!
!ALKAP/WR_HNO4=0.0
!
!ALKAP/WR_NH3=0.0
!
!ALKAP/WR_OH=0.0
!
!ALKAP/WR_HO2=0.0
!
!ALKAP/WR_CO2=0.0
!
!ALKAP/WR_SO2=0.0
!
!ALKAP/WR_SULF=0.0
!
!ALKAP/WR_HCHO=0.0
!
!ALKAP/WR_ORA1=0.0
!
!ALKAP/WR_ORA2=0.0
!
!ALKAP/WR_MO2=0.0
!
!ALKAP/WR_OP1=0.0
!
!ALKAP/WR_ASO3=0.0
!
!ALKAP/WR_ASO4=0.0
!
!ALKAP/WR_ASO5=0.0
!
!ALKAP/WR_AHSO5=0.0
!
!ALKAP/WR_AHMS=0.0
!
!ALKEP/O3=0.0
!
!ALKEP/H2O2=0.0
!
!ALKEP/NO=-K092*<ALKEP>
 PJAC(:,34,3)=-TPK%K092(:)*PCONC(:,34)
!
!ALKEP/NO2=0.0
!
!ALKEP/NO3=-K121*<ALKEP>
 PJAC(:,34,5)=-TPK%K121(:)*PCONC(:,34)
!
!ALKEP/N2O5=0.0
!
!ALKEP/HONO=0.0
!
!ALKEP/HNO3=0.0
!
!ALKEP/HNO4=0.0
!
!ALKEP/NH3=0.0
!
!ALKEP/SO2=0.0
!
!ALKEP/SULF=0.0
!
!ALKEP/CO=0.0
!
!ALKEP/OH=+1.02529*K059*<ALKE>
 PJAC(:,34,14)=+1.02529*TPK%K059(:)*PCONC(:,19)
!
!ALKEP/HO2=-K099*<ALKEP>
 PJAC(:,34,15)=-TPK%K099(:)*PCONC(:,34)
!
!ALKEP/CH4=0.0
!
!ALKEP/ETH=0.0
!
!ALKEP/ALKA=0.0
!
!ALKEP/ALKE=+1.02529*K059*<OH>
 PJAC(:,34,19)=+1.02529*TPK%K059(:)*PCONC(:,14)
!
!ALKEP/BIO=0.0
!
!ALKEP/ARO=0.0
!
!ALKEP/HCHO=0.0
!
!ALKEP/ALD=0.0
!
!ALKEP/KET=0.0
!
!ALKEP/CARBO=0.0
!
!ALKEP/ONIT=0.0
!
!ALKEP/PAN=0.0
!
!ALKEP/OP1=0.0
!
!ALKEP/OP2=0.0
!
!ALKEP/ORA1=0.0
!
!ALKEP/ORA2=0.0
!
!ALKEP/MO2=-K106*<ALKEP>
 PJAC(:,34,32)=-TPK%K106(:)*PCONC(:,34)
!
!ALKEP/ALKAP=0.0
!
!ALKEP/ALKEP=-K092*<NO>-K099*<HO2>-K106*<MO2>-K112*<CARBOP>-K121*<NO3>
 PJAC(:,34,34)=-TPK%K092(:)*PCONC(:,3)-TPK%K099(:)*PCONC(:,15)-TPK%K106(:)*PCON&
&C(:,32)-TPK%K112(:)*PCONC(:,39)-TPK%K121(:)*PCONC(:,5)
!
!ALKEP/BIOP=0.0
!
!ALKEP/PHO=0.0
!
!ALKEP/ADD=0.0
!
!ALKEP/AROP=0.0
!
!ALKEP/CARBOP=-K112*<ALKEP>
 PJAC(:,34,39)=-TPK%K112(:)*PCONC(:,34)
!
!ALKEP/OLN=0.0
!
!ALKEP/XO2=0.0
!
!ALKEP/WC_O3=0.0
!
!ALKEP/WC_H2O2=0.0
!
!ALKEP/WC_NO=0.0
!
!ALKEP/WC_NO2=0.0
!
!ALKEP/WC_NO3=0.0
!
!ALKEP/WC_N2O5=0.0
!
!ALKEP/WC_HONO=0.0
!
!ALKEP/WC_HNO3=0.0
!
!ALKEP/WC_HNO4=0.0
!
!ALKEP/WC_NH3=0.0
!
!ALKEP/WC_OH=0.0
!
!ALKEP/WC_HO2=0.0
!
!ALKEP/WC_CO2=0.0
!
!ALKEP/WC_SO2=0.0
!
!ALKEP/WC_SULF=0.0
!
!ALKEP/WC_HCHO=0.0
!
!ALKEP/WC_ORA1=0.0
!
!ALKEP/WC_ORA2=0.0
!
!ALKEP/WC_MO2=0.0
!
!ALKEP/WC_OP1=0.0
!
!ALKEP/WC_ASO3=0.0
!
!ALKEP/WC_ASO4=0.0
!
!ALKEP/WC_ASO5=0.0
!
!ALKEP/WC_AHSO5=0.0
!
!ALKEP/WC_AHMS=0.0
!
!ALKEP/WR_O3=0.0
!
!ALKEP/WR_H2O2=0.0
!
!ALKEP/WR_NO=0.0
!
!ALKEP/WR_NO2=0.0
!
!ALKEP/WR_NO3=0.0
!
!ALKEP/WR_N2O5=0.0
!
!ALKEP/WR_HONO=0.0
!
!ALKEP/WR_HNO3=0.0
!
!ALKEP/WR_HNO4=0.0
!
!ALKEP/WR_NH3=0.0
!
!ALKEP/WR_OH=0.0
!
!ALKEP/WR_HO2=0.0
!
!ALKEP/WR_CO2=0.0
!
!ALKEP/WR_SO2=0.0
!
!ALKEP/WR_SULF=0.0
!
!ALKEP/WR_HCHO=0.0
!
!ALKEP/WR_ORA1=0.0
!
!ALKEP/WR_ORA2=0.0
!
!ALKEP/WR_MO2=0.0
!
!ALKEP/WR_OP1=0.0
!
!ALKEP/WR_ASO3=0.0
!
!ALKEP/WR_ASO4=0.0
!
!ALKEP/WR_ASO5=0.0
!
!ALKEP/WR_AHSO5=0.0
!
!ALKEP/WR_AHMS=0.0
!
!BIOP/O3=0.0
!
!BIOP/H2O2=0.0
!
!BIOP/NO=-K093*<BIOP>
 PJAC(:,35,3)=-TPK%K093(:)*PCONC(:,35)
!
!BIOP/NO2=0.0
!
!BIOP/NO3=-K122*<BIOP>
 PJAC(:,35,5)=-TPK%K122(:)*PCONC(:,35)
!
!BIOP/N2O5=0.0
!
!BIOP/HONO=0.0
!
!BIOP/HNO3=0.0
!
!BIOP/HNO4=0.0
!
!BIOP/NH3=0.0
!
!BIOP/SO2=0.0
!
!BIOP/SULF=0.0
!
!BIOP/CO=0.0
!
!BIOP/OH=+0.00000*K059*<ALKE>+1.00000*K060*<BIO>
 PJAC(:,35,14)=+0.00000*TPK%K059(:)*PCONC(:,19)+1.00000*TPK%K060(:)*PCONC(:,20)
!
!BIOP/HO2=-K0100*<BIOP>
 PJAC(:,35,15)=-TPK%K0100(:)*PCONC(:,35)
!
!BIOP/CH4=0.0
!
!BIOP/ETH=0.0
!
!BIOP/ALKA=0.0
!
!BIOP/ALKE=+0.00000*K059*<OH>
 PJAC(:,35,19)=+0.00000*TPK%K059(:)*PCONC(:,14)
!
!BIOP/BIO=+1.00000*K060*<OH>
 PJAC(:,35,20)=+1.00000*TPK%K060(:)*PCONC(:,14)
!
!BIOP/ARO=0.0
!
!BIOP/HCHO=0.0
!
!BIOP/ALD=0.0
!
!BIOP/KET=0.0
!
!BIOP/CARBO=0.0
!
!BIOP/ONIT=0.0
!
!BIOP/PAN=0.0
!
!BIOP/OP1=0.0
!
!BIOP/OP2=0.0
!
!BIOP/ORA1=0.0
!
!BIOP/ORA2=0.0
!
!BIOP/MO2=-K107*<BIOP>
 PJAC(:,35,32)=-TPK%K107(:)*PCONC(:,35)
!
!BIOP/ALKAP=0.0
!
!BIOP/ALKEP=0.0
!
!BIOP/BIOP=-K093*<NO>-K0100*<HO2>-K107*<MO2>-K113*<CARBOP>-K122*<NO3>
 PJAC(:,35,35)=-TPK%K093(:)*PCONC(:,3)-TPK%K0100(:)*PCONC(:,15)-TPK%K107(:)*PCO&
&NC(:,32)-TPK%K113(:)*PCONC(:,39)-TPK%K122(:)*PCONC(:,5)
!
!BIOP/PHO=0.0
!
!BIOP/ADD=0.0
!
!BIOP/AROP=0.0
!
!BIOP/CARBOP=-K113*<BIOP>
 PJAC(:,35,39)=-TPK%K113(:)*PCONC(:,35)
!
!BIOP/OLN=0.0
!
!BIOP/XO2=0.0
!
!BIOP/WC_O3=0.0
!
!BIOP/WC_H2O2=0.0
!
!BIOP/WC_NO=0.0
!
!BIOP/WC_NO2=0.0
!
!BIOP/WC_NO3=0.0
!
!BIOP/WC_N2O5=0.0
!
!BIOP/WC_HONO=0.0
!
!BIOP/WC_HNO3=0.0
!
!BIOP/WC_HNO4=0.0
!
!BIOP/WC_NH3=0.0
!
!BIOP/WC_OH=0.0
!
!BIOP/WC_HO2=0.0
!
!BIOP/WC_CO2=0.0
!
!BIOP/WC_SO2=0.0
!
!BIOP/WC_SULF=0.0
!
!BIOP/WC_HCHO=0.0
!
!BIOP/WC_ORA1=0.0
!
!BIOP/WC_ORA2=0.0
!
!BIOP/WC_MO2=0.0
!
!BIOP/WC_OP1=0.0
!
!BIOP/WC_ASO3=0.0
!
!BIOP/WC_ASO4=0.0
!
!BIOP/WC_ASO5=0.0
!
!BIOP/WC_AHSO5=0.0
!
!BIOP/WC_AHMS=0.0
!
!BIOP/WR_O3=0.0
!
!BIOP/WR_H2O2=0.0
!
!BIOP/WR_NO=0.0
!
!BIOP/WR_NO2=0.0
!
!BIOP/WR_NO3=0.0
!
!BIOP/WR_N2O5=0.0
!
!BIOP/WR_HONO=0.0
!
!BIOP/WR_HNO3=0.0
!
!BIOP/WR_HNO4=0.0
!
!BIOP/WR_NH3=0.0
!
!BIOP/WR_OH=0.0
!
!BIOP/WR_HO2=0.0
!
!BIOP/WR_CO2=0.0
!
!BIOP/WR_SO2=0.0
!
!BIOP/WR_SULF=0.0
!
!BIOP/WR_HCHO=0.0
!
!BIOP/WR_ORA1=0.0
!
!BIOP/WR_ORA2=0.0
!
!BIOP/WR_MO2=0.0
!
!BIOP/WR_OP1=0.0
!
!BIOP/WR_ASO3=0.0
!
!BIOP/WR_ASO4=0.0
!
!BIOP/WR_ASO5=0.0
!
!BIOP/WR_AHSO5=0.0
!
!BIOP/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ6
!
SUBROUTINE SUBJ7
!
!Indices 36 a 40
!
!
!PHO/O3=0.0
!
!PHO/H2O2=0.0
!
!PHO/NO=0.0
!
!PHO/NO2=-K083*<PHO>
 PJAC(:,36,4)=-TPK%K083(:)*PCONC(:,36)
!
!PHO/NO3=+K075*<ARO>
 PJAC(:,36,5)=+TPK%K075(:)*PCONC(:,21)
!
!PHO/N2O5=0.0
!
!PHO/HONO=0.0
!
!PHO/HNO3=0.0
!
!PHO/HNO4=0.0
!
!PHO/NH3=0.0
!
!PHO/SO2=0.0
!
!PHO/SULF=0.0
!
!PHO/CO=0.0
!
!PHO/OH=+0.00276*K061*<ARO>
 PJAC(:,36,14)=+0.00276*TPK%K061(:)*PCONC(:,21)
!
!PHO/HO2=-K084*<PHO>
 PJAC(:,36,15)=-TPK%K084(:)*PCONC(:,36)
!
!PHO/CH4=0.0
!
!PHO/ETH=0.0
!
!PHO/ALKA=0.0
!
!PHO/ALKE=0.0
!
!PHO/BIO=0.0
!
!PHO/ARO=+0.00276*K061*<OH>+K075*<NO3>
 PJAC(:,36,21)=+0.00276*TPK%K061(:)*PCONC(:,14)+TPK%K075(:)*PCONC(:,5)
!
!PHO/HCHO=0.0
!
!PHO/ALD=0.0
!
!PHO/KET=0.0
!
!PHO/CARBO=0.0
!
!PHO/ONIT=0.0
!
!PHO/PAN=0.0
!
!PHO/OP1=0.0
!
!PHO/OP2=0.0
!
!PHO/ORA1=0.0
!
!PHO/ORA2=0.0
!
!PHO/MO2=0.0
!
!PHO/ALKAP=0.0
!
!PHO/ALKEP=0.0
!
!PHO/BIOP=0.0
!
!PHO/PHO=-K083*<NO2>-K084*<HO2>
 PJAC(:,36,36)=-TPK%K083(:)*PCONC(:,4)-TPK%K084(:)*PCONC(:,15)
!
!PHO/ADD=0.0
!
!PHO/AROP=0.0
!
!PHO/CARBOP=0.0
!
!PHO/OLN=0.0
!
!PHO/XO2=0.0
!
!PHO/WC_O3=0.0
!
!PHO/WC_H2O2=0.0
!
!PHO/WC_NO=0.0
!
!PHO/WC_NO2=0.0
!
!PHO/WC_NO3=0.0
!
!PHO/WC_N2O5=0.0
!
!PHO/WC_HONO=0.0
!
!PHO/WC_HNO3=0.0
!
!PHO/WC_HNO4=0.0
!
!PHO/WC_NH3=0.0
!
!PHO/WC_OH=0.0
!
!PHO/WC_HO2=0.0
!
!PHO/WC_CO2=0.0
!
!PHO/WC_SO2=0.0
!
!PHO/WC_SULF=0.0
!
!PHO/WC_HCHO=0.0
!
!PHO/WC_ORA1=0.0
!
!PHO/WC_ORA2=0.0
!
!PHO/WC_MO2=0.0
!
!PHO/WC_OP1=0.0
!
!PHO/WC_ASO3=0.0
!
!PHO/WC_ASO4=0.0
!
!PHO/WC_ASO5=0.0
!
!PHO/WC_AHSO5=0.0
!
!PHO/WC_AHMS=0.0
!
!PHO/WR_O3=0.0
!
!PHO/WR_H2O2=0.0
!
!PHO/WR_NO=0.0
!
!PHO/WR_NO2=0.0
!
!PHO/WR_NO3=0.0
!
!PHO/WR_N2O5=0.0
!
!PHO/WR_HONO=0.0
!
!PHO/WR_HNO3=0.0
!
!PHO/WR_HNO4=0.0
!
!PHO/WR_NH3=0.0
!
!PHO/WR_OH=0.0
!
!PHO/WR_HO2=0.0
!
!PHO/WR_CO2=0.0
!
!PHO/WR_SO2=0.0
!
!PHO/WR_SULF=0.0
!
!PHO/WR_HCHO=0.0
!
!PHO/WR_ORA1=0.0
!
!PHO/WR_ORA2=0.0
!
!PHO/WR_MO2=0.0
!
!PHO/WR_OP1=0.0
!
!PHO/WR_ASO3=0.0
!
!PHO/WR_ASO4=0.0
!
!PHO/WR_ASO5=0.0
!
!PHO/WR_AHSO5=0.0
!
!PHO/WR_AHMS=0.0
!
!ADD/O3=-K087*<ADD>
 PJAC(:,37,1)=-TPK%K087(:)*PCONC(:,37)
!
!ADD/H2O2=0.0
!
!ADD/NO=0.0
!
!ADD/NO2=-K085*<ADD>
 PJAC(:,37,4)=-TPK%K085(:)*PCONC(:,37)
!
!ADD/NO3=0.0
!
!ADD/N2O5=0.0
!
!ADD/HONO=0.0
!
!ADD/HNO3=0.0
!
!ADD/HNO4=0.0
!
!ADD/NH3=0.0
!
!ADD/SO2=0.0
!
!ADD/SULF=0.0
!
!ADD/CO=0.0
!
!ADD/OH=+0.93968*K061*<ARO>
 PJAC(:,37,14)=+0.93968*TPK%K061(:)*PCONC(:,21)
!
!ADD/HO2=0.0
!
!ADD/CH4=0.0
!
!ADD/ETH=0.0
!
!ADD/ALKA=0.0
!
!ADD/ALKE=0.0
!
!ADD/BIO=0.0
!
!ADD/ARO=+0.93968*K061*<OH>
 PJAC(:,37,21)=+0.93968*TPK%K061(:)*PCONC(:,14)
!
!ADD/HCHO=0.0
!
!ADD/ALD=0.0
!
!ADD/KET=0.0
!
!ADD/CARBO=0.0
!
!ADD/ONIT=0.0
!
!ADD/PAN=0.0
!
!ADD/OP1=0.0
!
!ADD/OP2=0.0
!
!ADD/ORA1=0.0
!
!ADD/ORA2=0.0
!
!ADD/MO2=0.0
!
!ADD/ALKAP=0.0
!
!ADD/ALKEP=0.0
!
!ADD/BIOP=0.0
!
!ADD/PHO=0.0
!
!ADD/ADD=-K085*<NO2>-K086*<O2>-K087*<O3>
 PJAC(:,37,37)=-TPK%K085(:)*PCONC(:,4)-TPK%K086(:)*TPK%O2(:)-TPK%K087(:)*PCONC(&
&:,1)
!
!ADD/AROP=0.0
!
!ADD/CARBOP=0.0
!
!ADD/OLN=0.0
!
!ADD/XO2=0.0
!
!ADD/WC_O3=0.0
!
!ADD/WC_H2O2=0.0
!
!ADD/WC_NO=0.0
!
!ADD/WC_NO2=0.0
!
!ADD/WC_NO3=0.0
!
!ADD/WC_N2O5=0.0
!
!ADD/WC_HONO=0.0
!
!ADD/WC_HNO3=0.0
!
!ADD/WC_HNO4=0.0
!
!ADD/WC_NH3=0.0
!
!ADD/WC_OH=0.0
!
!ADD/WC_HO2=0.0
!
!ADD/WC_CO2=0.0
!
!ADD/WC_SO2=0.0
!
!ADD/WC_SULF=0.0
!
!ADD/WC_HCHO=0.0
!
!ADD/WC_ORA1=0.0
!
!ADD/WC_ORA2=0.0
!
!ADD/WC_MO2=0.0
!
!ADD/WC_OP1=0.0
!
!ADD/WC_ASO3=0.0
!
!ADD/WC_ASO4=0.0
!
!ADD/WC_ASO5=0.0
!
!ADD/WC_AHSO5=0.0
!
!ADD/WC_AHMS=0.0
!
!ADD/WR_O3=0.0
!
!ADD/WR_H2O2=0.0
!
!ADD/WR_NO=0.0
!
!ADD/WR_NO2=0.0
!
!ADD/WR_NO3=0.0
!
!ADD/WR_N2O5=0.0
!
!ADD/WR_HONO=0.0
!
!ADD/WR_HNO3=0.0
!
!ADD/WR_HNO4=0.0
!
!ADD/WR_NH3=0.0
!
!ADD/WR_OH=0.0
!
!ADD/WR_HO2=0.0
!
!ADD/WR_CO2=0.0
!
!ADD/WR_SO2=0.0
!
!ADD/WR_SULF=0.0
!
!ADD/WR_HCHO=0.0
!
!ADD/WR_ORA1=0.0
!
!ADD/WR_ORA2=0.0
!
!ADD/WR_MO2=0.0
!
!ADD/WR_OP1=0.0
!
!ADD/WR_ASO3=0.0
!
!ADD/WR_ASO4=0.0
!
!ADD/WR_ASO5=0.0
!
!ADD/WR_AHSO5=0.0
!
!ADD/WR_AHMS=0.0
!
!AROP/O3=0.0
!
!AROP/H2O2=0.0
!
!AROP/NO=-K094*<AROP>
 PJAC(:,38,3)=-TPK%K094(:)*PCONC(:,38)
!
!AROP/NO2=0.0
!
!AROP/NO3=-K123*<AROP>
 PJAC(:,38,5)=-TPK%K123(:)*PCONC(:,38)
!
!AROP/N2O5=0.0
!
!AROP/HONO=0.0
!
!AROP/HNO3=0.0
!
!AROP/HNO4=0.0
!
!AROP/NH3=0.0
!
!AROP/SO2=0.0
!
!AROP/SULF=0.0
!
!AROP/CO=0.0
!
!AROP/OH=0.0
!
!AROP/HO2=-K0101*<AROP>
 PJAC(:,38,15)=-TPK%K0101(:)*PCONC(:,38)
!
!AROP/CH4=0.0
!
!AROP/ETH=0.0
!
!AROP/ALKA=0.0
!
!AROP/ALKE=0.0
!
!AROP/BIO=0.0
!
!AROP/ARO=0.0
!
!AROP/HCHO=0.0
!
!AROP/ALD=0.0
!
!AROP/KET=0.0
!
!AROP/CARBO=0.0
!
!AROP/ONIT=0.0
!
!AROP/PAN=0.0
!
!AROP/OP1=0.0
!
!AROP/OP2=0.0
!
!AROP/ORA1=0.0
!
!AROP/ORA2=0.0
!
!AROP/MO2=-K108*<AROP>
 PJAC(:,38,32)=-TPK%K108(:)*PCONC(:,38)
!
!AROP/ALKAP=0.0
!
!AROP/ALKEP=0.0
!
!AROP/BIOP=0.0
!
!AROP/PHO=0.0
!
!AROP/ADD=+0.98*K086*<O2>
 PJAC(:,38,37)=+0.98*TPK%K086(:)*TPK%O2(:)
!
!AROP/AROP=-K094*<NO>-K0101*<HO2>-K108*<MO2>-K114*<CARBOP>-K123*<NO3>
 PJAC(:,38,38)=-TPK%K094(:)*PCONC(:,3)-TPK%K0101(:)*PCONC(:,15)-TPK%K108(:)*PCO&
&NC(:,32)-TPK%K114(:)*PCONC(:,39)-TPK%K123(:)*PCONC(:,5)
!
!AROP/CARBOP=-K114*<AROP>
 PJAC(:,38,39)=-TPK%K114(:)*PCONC(:,38)
!
!AROP/OLN=0.0
!
!AROP/XO2=0.0
!
!AROP/WC_O3=0.0
!
!AROP/WC_H2O2=0.0
!
!AROP/WC_NO=0.0
!
!AROP/WC_NO2=0.0
!
!AROP/WC_NO3=0.0
!
!AROP/WC_N2O5=0.0
!
!AROP/WC_HONO=0.0
!
!AROP/WC_HNO3=0.0
!
!AROP/WC_HNO4=0.0
!
!AROP/WC_NH3=0.0
!
!AROP/WC_OH=0.0
!
!AROP/WC_HO2=0.0
!
!AROP/WC_CO2=0.0
!
!AROP/WC_SO2=0.0
!
!AROP/WC_SULF=0.0
!
!AROP/WC_HCHO=0.0
!
!AROP/WC_ORA1=0.0
!
!AROP/WC_ORA2=0.0
!
!AROP/WC_MO2=0.0
!
!AROP/WC_OP1=0.0
!
!AROP/WC_ASO3=0.0
!
!AROP/WC_ASO4=0.0
!
!AROP/WC_ASO5=0.0
!
!AROP/WC_AHSO5=0.0
!
!AROP/WC_AHMS=0.0
!
!AROP/WR_O3=0.0
!
!AROP/WR_H2O2=0.0
!
!AROP/WR_NO=0.0
!
!AROP/WR_NO2=0.0
!
!AROP/WR_NO3=0.0
!
!AROP/WR_N2O5=0.0
!
!AROP/WR_HONO=0.0
!
!AROP/WR_HNO3=0.0
!
!AROP/WR_HNO4=0.0
!
!AROP/WR_NH3=0.0
!
!AROP/WR_OH=0.0
!
!AROP/WR_HO2=0.0
!
!AROP/WR_CO2=0.0
!
!AROP/WR_SO2=0.0
!
!AROP/WR_SULF=0.0
!
!AROP/WR_HCHO=0.0
!
!AROP/WR_ORA1=0.0
!
!AROP/WR_ORA2=0.0
!
!AROP/WR_MO2=0.0
!
!AROP/WR_OP1=0.0
!
!AROP/WR_ASO3=0.0
!
!AROP/WR_ASO4=0.0
!
!AROP/WR_ASO5=0.0
!
!AROP/WR_AHSO5=0.0
!
!AROP/WR_AHMS=0.0
!
!CARBOP/O3=+0.05705*K079*<ALKE>+0.17000*K080*<BIO>+0.27460*K081*<CARBO>+0.70000
!*K082*<PAN>
 PJAC(:,39,1)=+0.05705*TPK%K079(:)*PCONC(:,19)+0.17000*TPK%K080(:)*PCONC(:,20)+&
&0.27460*TPK%K081(:)*PCONC(:,25)+0.70000*TPK%K082(:)*PCONC(:,27)
!
!CARBOP/H2O2=0.0
!
!CARBOP/NO=+0.09532*K095*<CARBOP>-K095*<CARBOP>
 PJAC(:,39,3)=+0.09532*TPK%K095(:)*PCONC(:,39)-TPK%K095(:)*PCONC(:,39)
!
!CARBOP/NO2=-K088*<CARBOP>
 PJAC(:,39,4)=-TPK%K088(:)*PCONC(:,39)
!
!CARBOP/NO3=+1.00000*K073*<ALD>+0.38881*K074*<CARBO>+0.03175*K124*<CARBOP>-K124
!*<CARBOP>
 PJAC(:,39,5)=+1.00000*TPK%K073(:)*PCONC(:,23)+0.38881*TPK%K074(:)*PCONC(:,25)+&
&0.03175*TPK%K124(:)*PCONC(:,39)-TPK%K124(:)*PCONC(:,39)
!
!CARBOP/N2O5=0.0
!
!CARBOP/HONO=0.0
!
!CARBOP/HNO3=0.0
!
!CARBOP/HNO4=0.0
!
!CARBOP/NH3=0.0
!
!CARBOP/SO2=0.0
!
!CARBOP/SULF=0.0
!
!CARBOP/CO=0.0
!
!CARBOP/OH=+1.00000*K063*<ALD>+1.00000*K064*<KET>+0.51419*K065*<CARBO>+0.05413*
!K069*<OP2>
 PJAC(:,39,14)=+1.00000*TPK%K063(:)*PCONC(:,23)+1.00000*TPK%K064(:)*PCONC(:,24)&
&+0.51419*TPK%K065(:)*PCONC(:,25)+0.05413*TPK%K069(:)*PCONC(:,29)
!
!CARBOP/HO2=-K0102*<CARBOP>
 PJAC(:,39,15)=-TPK%K0102(:)*PCONC(:,39)
!
!CARBOP/CH4=0.0
!
!CARBOP/ETH=0.0
!
!CARBOP/ALKA=0.0
!
!CARBOP/ALKE=+0.05705*K079*<O3>
 PJAC(:,39,19)=+0.05705*TPK%K079(:)*PCONC(:,1)
!
!CARBOP/BIO=+0.17000*K080*<O3>
 PJAC(:,39,20)=+0.17000*TPK%K080(:)*PCONC(:,1)
!
!CARBOP/ARO=0.0
!
!CARBOP/HCHO=0.0
!
!CARBOP/ALD=+1.00000*K063*<OH>+1.00000*K073*<NO3>
 PJAC(:,39,23)=+1.00000*TPK%K063(:)*PCONC(:,14)+1.00000*TPK%K073(:)*PCONC(:,5)
!
!CARBOP/KET=+1.00000*K015+1.00000*K064*<OH>
 PJAC(:,39,24)=+1.00000*TPK%K015(:)+1.00000*TPK%K064(:)*PCONC(:,14)
!
!CARBOP/CARBO=+0.69622*K016+0.51419*K065*<OH>+0.38881*K074*<NO3>+0.27460*K081*<
!O3>
 PJAC(:,39,25)=+0.69622*TPK%K016(:)+0.51419*TPK%K065(:)*PCONC(:,14)+0.38881*TPK&
&%K074(:)*PCONC(:,5)+0.27460*TPK%K081(:)*PCONC(:,1)
!
!CARBOP/ONIT=0.0
!
!CARBOP/PAN=+0.70000*K082*<O3>+1.00000*K089
 PJAC(:,39,27)=+0.70000*TPK%K082(:)*PCONC(:,1)+1.00000*TPK%K089(:)
!
!CARBOP/OP1=0.0
!
!CARBOP/OP2=+0.05413*K069*<OH>
 PJAC(:,39,29)=+0.05413*TPK%K069(:)*PCONC(:,14)
!
!CARBOP/ORA1=0.0
!
!CARBOP/ORA2=0.0
!
!CARBOP/MO2=+0.05954*K109*<CARBOP>-K109*<CARBOP>
 PJAC(:,39,32)=+0.05954*TPK%K109(:)*PCONC(:,39)-TPK%K109(:)*PCONC(:,39)
!
!CARBOP/ALKAP=-K111*<CARBOP>
 PJAC(:,39,33)=-TPK%K111(:)*PCONC(:,39)
!
!CARBOP/ALKEP=-K112*<CARBOP>
 PJAC(:,39,34)=-TPK%K112(:)*PCONC(:,39)
!
!CARBOP/BIOP=-K113*<CARBOP>
 PJAC(:,39,35)=-TPK%K113(:)*PCONC(:,39)
!
!CARBOP/PHO=0.0
!
!CARBOP/ADD=0.0
!
!CARBOP/AROP=-K114*<CARBOP>
 PJAC(:,39,38)=-TPK%K114(:)*PCONC(:,39)
!
!CARBOP/CARBOP=-K088*<NO2>+0.09532*K095*<NO>-K095*<NO>-K0102*<HO2>+0.05954*K109
!*<MO2>-K109*<MO2>-K111*<ALKAP>-K112*<ALKEP>-K113*<BIOP>-K114*<AROP>+0.05821*K1
!15*<CARBOP>+0.05821*K115*<CARBOP>-K115*<CARBOP>-K115*<CARBOP>-K115*<CARBOP>-K1
!15*<CARBOP>-K116*<OLN>+0.03175*K124*<NO3>-K124*<NO3>-K128*<XO2>
 PJAC(:,39,39)=-TPK%K088(:)*PCONC(:,4)+0.09532*TPK%K095(:)*PCONC(:,3)-TPK%K095(&
&:)*PCONC(:,3)-TPK%K0102(:)*PCONC(:,15)+0.05954*TPK%K109(:)*PCONC(:,32)-TPK%K10&
&9(:)*PCONC(:,32)-TPK%K111(:)*PCONC(:,33)-TPK%K112(:)*PCONC(:,34)-TPK%K113(:)*P&
&CONC(:,35)-TPK%K114(:)*PCONC(:,38)+0.05821*TPK%K115(:)*PCONC(:,39)+0.05821*TPK&
&%K115(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K115(&
&:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K116(:)*PCONC(:,40)+0.03175*TPK%K12&
&4(:)*PCONC(:,5)-TPK%K124(:)*PCONC(:,5)-TPK%K128(:)*PCONC(:,41)
!
!CARBOP/OLN=-K116*<CARBOP>
 PJAC(:,39,40)=-TPK%K116(:)*PCONC(:,39)
!
!CARBOP/XO2=-K128*<CARBOP>
 PJAC(:,39,41)=-TPK%K128(:)*PCONC(:,39)
!
!CARBOP/WC_O3=0.0
!
!CARBOP/WC_H2O2=0.0
!
!CARBOP/WC_NO=0.0
!
!CARBOP/WC_NO2=0.0
!
!CARBOP/WC_NO3=0.0
!
!CARBOP/WC_N2O5=0.0
!
!CARBOP/WC_HONO=0.0
!
!CARBOP/WC_HNO3=0.0
!
!CARBOP/WC_HNO4=0.0
!
!CARBOP/WC_NH3=0.0
!
!CARBOP/WC_OH=0.0
!
!CARBOP/WC_HO2=0.0
!
!CARBOP/WC_CO2=0.0
!
!CARBOP/WC_SO2=0.0
!
!CARBOP/WC_SULF=0.0
!
!CARBOP/WC_HCHO=0.0
!
!CARBOP/WC_ORA1=0.0
!
!CARBOP/WC_ORA2=0.0
!
!CARBOP/WC_MO2=0.0
!
!CARBOP/WC_OP1=0.0
!
!CARBOP/WC_ASO3=0.0
!
!CARBOP/WC_ASO4=0.0
!
!CARBOP/WC_ASO5=0.0
!
!CARBOP/WC_AHSO5=0.0
!
!CARBOP/WC_AHMS=0.0
!
!CARBOP/WR_O3=0.0
!
!CARBOP/WR_H2O2=0.0
!
!CARBOP/WR_NO=0.0
!
!CARBOP/WR_NO2=0.0
!
!CARBOP/WR_NO3=0.0
!
!CARBOP/WR_N2O5=0.0
!
!CARBOP/WR_HONO=0.0
!
!CARBOP/WR_HNO3=0.0
!
!CARBOP/WR_HNO4=0.0
!
!CARBOP/WR_NH3=0.0
!
!CARBOP/WR_OH=0.0
!
!CARBOP/WR_HO2=0.0
!
!CARBOP/WR_CO2=0.0
!
!CARBOP/WR_SO2=0.0
!
!CARBOP/WR_SULF=0.0
!
!CARBOP/WR_HCHO=0.0
!
!CARBOP/WR_ORA1=0.0
!
!CARBOP/WR_ORA2=0.0
!
!CARBOP/WR_MO2=0.0
!
!CARBOP/WR_OP1=0.0
!
!CARBOP/WR_ASO3=0.0
!
!CARBOP/WR_ASO4=0.0
!
!CARBOP/WR_ASO5=0.0
!
!CARBOP/WR_AHSO5=0.0
!
!CARBOP/WR_AHMS=0.0
!
!OLN/O3=0.0
!
!OLN/H2O2=0.0
!
!OLN/NO=-K096*<OLN>
 PJAC(:,40,3)=-TPK%K096(:)*PCONC(:,40)
!
!OLN/NO2=0.0
!
!OLN/NO3=+0.00000*K074*<CARBO>+0.93768*K076*<ALKE>+1.00000*K077*<BIO>-K125*<OLN
!>
 PJAC(:,40,5)=+0.00000*TPK%K074(:)*PCONC(:,25)+0.93768*TPK%K076(:)*PCONC(:,19)+&
&1.00000*TPK%K077(:)*PCONC(:,20)-TPK%K125(:)*PCONC(:,40)
!
!OLN/N2O5=0.0
!
!OLN/HONO=0.0
!
!OLN/HNO3=0.0
!
!OLN/HNO4=0.0
!
!OLN/NH3=0.0
!
!OLN/SO2=0.0
!
!OLN/SULF=0.0
!
!OLN/CO=0.0
!
!OLN/OH=0.0
!
!OLN/HO2=-K103*<OLN>
 PJAC(:,40,15)=-TPK%K103(:)*PCONC(:,40)
!
!OLN/CH4=0.0
!
!OLN/ETH=0.0
!
!OLN/ALKA=0.0
!
!OLN/ALKE=+0.93768*K076*<NO3>
 PJAC(:,40,19)=+0.93768*TPK%K076(:)*PCONC(:,5)
!
!OLN/BIO=+1.00000*K077*<NO3>
 PJAC(:,40,20)=+1.00000*TPK%K077(:)*PCONC(:,5)
!
!OLN/ARO=0.0
!
!OLN/HCHO=0.0
!
!OLN/ALD=0.0
!
!OLN/KET=0.0
!
!OLN/CARBO=+0.00000*K074*<NO3>
 PJAC(:,40,25)=+0.00000*TPK%K074(:)*PCONC(:,5)
!
!OLN/ONIT=0.0
!
!OLN/PAN=0.0
!
!OLN/OP1=0.0
!
!OLN/OP2=0.0
!
!OLN/ORA1=0.0
!
!OLN/ORA2=0.0
!
!OLN/MO2=-K110*<OLN>
 PJAC(:,40,32)=-TPK%K110(:)*PCONC(:,40)
!
!OLN/ALKAP=0.0
!
!OLN/ALKEP=0.0
!
!OLN/BIOP=0.0
!
!OLN/PHO=0.0
!
!OLN/ADD=0.0
!
!OLN/AROP=0.0
!
!OLN/CARBOP=-K116*<OLN>
 PJAC(:,40,39)=-TPK%K116(:)*PCONC(:,40)
!
!OLN/OLN=-K096*<NO>-K103*<HO2>-K110*<MO2>-K116*<CARBOP>-K117*<OLN>-K117*<OLN>-K
!117*<OLN>-K117*<OLN>-K118*<OLN>-K118*<OLN>-K118*<OLN>-K118*<OLN>-K125*<NO3>
 PJAC(:,40,40)=-TPK%K096(:)*PCONC(:,3)-TPK%K103(:)*PCONC(:,15)-TPK%K110(:)*PCON&
&C(:,32)-TPK%K116(:)*PCONC(:,39)-TPK%K117(:)*PCONC(:,40)-TPK%K117(:)*PCONC(:,40&
&)-TPK%K117(:)*PCONC(:,40)-TPK%K117(:)*PCONC(:,40)-TPK%K118(:)*PCONC(:,40)-TPK%&
&K118(:)*PCONC(:,40)-TPK%K118(:)*PCONC(:,40)-TPK%K118(:)*PCONC(:,40)-TPK%K125(:&
&)*PCONC(:,5)
!
!OLN/XO2=0.0
!
!OLN/WC_O3=0.0
!
!OLN/WC_H2O2=0.0
!
!OLN/WC_NO=0.0
!
!OLN/WC_NO2=0.0
!
!OLN/WC_NO3=0.0
!
!OLN/WC_N2O5=0.0
!
!OLN/WC_HONO=0.0
!
!OLN/WC_HNO3=0.0
!
!OLN/WC_HNO4=0.0
!
!OLN/WC_NH3=0.0
!
!OLN/WC_OH=0.0
!
!OLN/WC_HO2=0.0
!
!OLN/WC_CO2=0.0
!
!OLN/WC_SO2=0.0
!
!OLN/WC_SULF=0.0
!
!OLN/WC_HCHO=0.0
!
!OLN/WC_ORA1=0.0
!
!OLN/WC_ORA2=0.0
!
!OLN/WC_MO2=0.0
!
!OLN/WC_OP1=0.0
!
!OLN/WC_ASO3=0.0
!
!OLN/WC_ASO4=0.0
!
!OLN/WC_ASO5=0.0
!
!OLN/WC_AHSO5=0.0
!
!OLN/WC_AHMS=0.0
!
!OLN/WR_O3=0.0
!
!OLN/WR_H2O2=0.0
!
!OLN/WR_NO=0.0
!
!OLN/WR_NO2=0.0
!
!OLN/WR_NO3=0.0
!
!OLN/WR_N2O5=0.0
!
!OLN/WR_HONO=0.0
!
!OLN/WR_HNO3=0.0
!
!OLN/WR_HNO4=0.0
!
!OLN/WR_NH3=0.0
!
!OLN/WR_OH=0.0
!
!OLN/WR_HO2=0.0
!
!OLN/WR_CO2=0.0
!
!OLN/WR_SO2=0.0
!
!OLN/WR_SULF=0.0
!
!OLN/WR_HCHO=0.0
!
!OLN/WR_ORA1=0.0
!
!OLN/WR_ORA2=0.0
!
!OLN/WR_MO2=0.0
!
!OLN/WR_OP1=0.0
!
!OLN/WR_ASO3=0.0
!
!OLN/WR_ASO4=0.0
!
!OLN/WR_ASO5=0.0
!
!OLN/WR_AHSO5=0.0
!
!OLN/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ7
!
SUBROUTINE SUBJ8
!
!Indices 41 a 45
!
!
!XO2/O3=+0.00000*K079*<ALKE>+0.13000*K080*<BIO>
 PJAC(:,41,1)=+0.00000*TPK%K079(:)*PCONC(:,19)+0.13000*TPK%K080(:)*PCONC(:,20)
!
!XO2/H2O2=0.0
!
!XO2/NO=+0.13007*K091*<ALKAP>+0.02563*K095*<CARBOP>-K130*<XO2>
 PJAC(:,41,3)=+0.13007*TPK%K091(:)*PCONC(:,33)+0.02563*TPK%K095(:)*PCONC(:,39)-&
&TPK%K130(:)*PCONC(:,41)
!
!XO2/NO2=0.0
!
!XO2/NO3=+0.10530*K074*<CARBO>+K078*<PAN>+0.16271*K120*<ALKAP>+0.01021*K124*<CA
!RBOP>-K131*<XO2>
 PJAC(:,41,5)=+0.10530*TPK%K074(:)*PCONC(:,25)+TPK%K078(:)*PCONC(:,27)+0.16271*&
&TPK%K120(:)*PCONC(:,33)+0.01021*TPK%K124(:)*PCONC(:,39)-TPK%K131(:)*PCONC(:,41&
&)
!
!XO2/N2O5=0.0
!
!XO2/HONO=0.0
!
!XO2/HNO3=0.0
!
!XO2/HNO4=0.0
!
!XO2/NH3=0.0
!
!XO2/SO2=0.0
!
!XO2/SULF=0.0
!
!XO2/CO=0.0
!
!XO2/OH=+0.10318*K061*<ARO>+0.10162*K065*<CARBO>+0.09333*K069*<OP2>+K070*<PAN>
 PJAC(:,41,14)=+0.10318*TPK%K061(:)*PCONC(:,21)+0.10162*TPK%K065(:)*PCONC(:,25)&
&+0.09333*TPK%K069(:)*PCONC(:,29)+TPK%K070(:)*PCONC(:,27)
!
!XO2/HO2=-K126*<XO2>
 PJAC(:,41,15)=-TPK%K126(:)*PCONC(:,41)
!
!XO2/CH4=0.0
!
!XO2/ETH=0.0
!
!XO2/ALKA=0.0
!
!XO2/ALKE=+0.00000*K079*<O3>
 PJAC(:,41,19)=+0.00000*TPK%K079(:)*PCONC(:,1)
!
!XO2/BIO=+0.15*K054*<O3P>+0.13000*K080*<O3>
 PJAC(:,41,20)=+0.15*TPK%K054(:)*TPK%O3P(:)+0.13000*TPK%K080(:)*PCONC(:,1)
!
!XO2/ARO=+0.10318*K061*<OH>
 PJAC(:,41,21)=+0.10318*TPK%K061(:)*PCONC(:,14)
!
!XO2/HCHO=0.0
!
!XO2/ALD=0.0
!
!XO2/KET=0.0
!
!XO2/CARBO=+0.10162*K065*<OH>+0.10530*K074*<NO3>
 PJAC(:,41,25)=+0.10162*TPK%K065(:)*PCONC(:,14)+0.10530*TPK%K074(:)*PCONC(:,5)
!
!XO2/ONIT=0.0
!
!XO2/PAN=+K070*<OH>+K078*<NO3>
 PJAC(:,41,27)=+TPK%K070(:)*PCONC(:,14)+TPK%K078(:)*PCONC(:,5)
!
!XO2/OP1=0.0
!
!XO2/OP2=+0.09333*K069*<OH>
 PJAC(:,41,29)=+0.09333*TPK%K069(:)*PCONC(:,14)
!
!XO2/ORA1=0.0
!
!XO2/ORA2=0.0
!
!XO2/MO2=+0.13370*K105*<ALKAP>+0.02212*K109*<CARBOP>-K127*<XO2>
 PJAC(:,41,32)=+0.13370*TPK%K105(:)*PCONC(:,33)+0.02212*TPK%K109(:)*PCONC(:,39)&
&-TPK%K127(:)*PCONC(:,41)
!
!XO2/ALKAP=+0.13007*K091*<NO>+0.13370*K105*<MO2>+0.11306*K111*<CARBOP>+0.16271*
!K120*<NO3>
 PJAC(:,41,33)=+0.13007*TPK%K091(:)*PCONC(:,3)+0.13370*TPK%K105(:)*PCONC(:,32)+&
&0.11306*TPK%K111(:)*PCONC(:,39)+0.16271*TPK%K120(:)*PCONC(:,5)
!
!XO2/ALKEP=0.0
!
!XO2/BIOP=0.0
!
!XO2/PHO=0.0
!
!XO2/ADD=0.0
!
!XO2/AROP=0.0
!
!XO2/CARBOP=+0.02563*K095*<NO>+0.02212*K109*<MO2>+0.11306*K111*<ALKAP>+0.01593*
!K115*<CARBOP>+0.01593*K115*<CARBOP>+0.01021*K124*<NO3>-K128*<XO2>
 PJAC(:,41,39)=+0.02563*TPK%K095(:)*PCONC(:,3)+0.02212*TPK%K109(:)*PCONC(:,32)+&
&0.11306*TPK%K111(:)*PCONC(:,33)+0.01593*TPK%K115(:)*PCONC(:,39)+0.01593*TPK%K1&
&15(:)*PCONC(:,39)+0.01021*TPK%K124(:)*PCONC(:,5)-TPK%K128(:)*PCONC(:,41)
!
!XO2/OLN=0.0
!
!XO2/XO2=-K126*<HO2>-K127*<MO2>-K128*<CARBOP>-K129*<XO2>-K129*<XO2>-K129*<XO2>-
!K129*<XO2>-K130*<NO>-K131*<NO3>
 PJAC(:,41,41)=-TPK%K126(:)*PCONC(:,15)-TPK%K127(:)*PCONC(:,32)-TPK%K128(:)*PCO&
&NC(:,39)-TPK%K129(:)*PCONC(:,41)-TPK%K129(:)*PCONC(:,41)-TPK%K129(:)*PCONC(:,4&
&1)-TPK%K129(:)*PCONC(:,41)-TPK%K130(:)*PCONC(:,3)-TPK%K131(:)*PCONC(:,5)
!
!XO2/WC_O3=0.0
!
!XO2/WC_H2O2=0.0
!
!XO2/WC_NO=0.0
!
!XO2/WC_NO2=0.0
!
!XO2/WC_NO3=0.0
!
!XO2/WC_N2O5=0.0
!
!XO2/WC_HONO=0.0
!
!XO2/WC_HNO3=0.0
!
!XO2/WC_HNO4=0.0
!
!XO2/WC_NH3=0.0
!
!XO2/WC_OH=0.0
!
!XO2/WC_HO2=0.0
!
!XO2/WC_CO2=0.0
!
!XO2/WC_SO2=0.0
!
!XO2/WC_SULF=0.0
!
!XO2/WC_HCHO=0.0
!
!XO2/WC_ORA1=0.0
!
!XO2/WC_ORA2=0.0
!
!XO2/WC_MO2=0.0
!
!XO2/WC_OP1=0.0
!
!XO2/WC_ASO3=0.0
!
!XO2/WC_ASO4=0.0
!
!XO2/WC_ASO5=0.0
!
!XO2/WC_AHSO5=0.0
!
!XO2/WC_AHMS=0.0
!
!XO2/WR_O3=0.0
!
!XO2/WR_H2O2=0.0
!
!XO2/WR_NO=0.0
!
!XO2/WR_NO2=0.0
!
!XO2/WR_NO3=0.0
!
!XO2/WR_N2O5=0.0
!
!XO2/WR_HONO=0.0
!
!XO2/WR_HNO3=0.0
!
!XO2/WR_HNO4=0.0
!
!XO2/WR_NH3=0.0
!
!XO2/WR_OH=0.0
!
!XO2/WR_HO2=0.0
!
!XO2/WR_CO2=0.0
!
!XO2/WR_SO2=0.0
!
!XO2/WR_SULF=0.0
!
!XO2/WR_HCHO=0.0
!
!XO2/WR_ORA1=0.0
!
!XO2/WR_ORA2=0.0
!
!XO2/WR_MO2=0.0
!
!XO2/WR_OP1=0.0
!
!XO2/WR_ASO3=0.0
!
!XO2/WR_ASO4=0.0
!
!XO2/WR_ASO5=0.0
!
!XO2/WR_AHSO5=0.0
!
!XO2/WR_AHMS=0.0
!
!WC_O3/O3=+KTC1
 PJAC(:,42,1)=+TPK%KTC1(:)
!
!WC_O3/H2O2=0.0
!
!WC_O3/NO=0.0
!
!WC_O3/NO2=0.0
!
!WC_O3/NO3=0.0
!
!WC_O3/N2O5=0.0
!
!WC_O3/HONO=0.0
!
!WC_O3/HNO3=0.0
!
!WC_O3/HNO4=0.0
!
!WC_O3/NH3=0.0
!
!WC_O3/SO2=0.0
!
!WC_O3/SULF=0.0
!
!WC_O3/CO=0.0
!
!WC_O3/OH=0.0
!
!WC_O3/HO2=0.0
!
!WC_O3/CH4=0.0
!
!WC_O3/ETH=0.0
!
!WC_O3/ALKA=0.0
!
!WC_O3/ALKE=0.0
!
!WC_O3/BIO=0.0
!
!WC_O3/ARO=0.0
!
!WC_O3/HCHO=0.0
!
!WC_O3/ALD=0.0
!
!WC_O3/KET=0.0
!
!WC_O3/CARBO=0.0
!
!WC_O3/ONIT=0.0
!
!WC_O3/PAN=0.0
!
!WC_O3/OP1=0.0
!
!WC_O3/OP2=0.0
!
!WC_O3/ORA1=0.0
!
!WC_O3/ORA2=0.0
!
!WC_O3/MO2=0.0
!
!WC_O3/ALKAP=0.0
!
!WC_O3/ALKEP=0.0
!
!WC_O3/BIOP=0.0
!
!WC_O3/PHO=0.0
!
!WC_O3/ADD=0.0
!
!WC_O3/AROP=0.0
!
!WC_O3/CARBOP=0.0
!
!WC_O3/OLN=0.0
!
!WC_O3/XO2=0.0
!
!WC_O3/WC_O3=-KTC21-KC6*<WC_HO2>-KC29*<WC_SO2>
 PJAC(:,42,42)=-TPK%KTC21(:)-TPK%KC6(:)*PCONC(:,53)-TPK%KC29(:)*PCONC(:,55)
!
!WC_O3/WC_H2O2=0.0
!
!WC_O3/WC_NO=0.0
!
!WC_O3/WC_NO2=0.0
!
!WC_O3/WC_NO3=0.0
!
!WC_O3/WC_N2O5=0.0
!
!WC_O3/WC_HONO=0.0
!
!WC_O3/WC_HNO3=0.0
!
!WC_O3/WC_HNO4=0.0
!
!WC_O3/WC_NH3=0.0
!
!WC_O3/WC_OH=0.0
!
!WC_O3/WC_HO2=-KC6*<WC_O3>
 PJAC(:,42,53)=-TPK%KC6(:)*PCONC(:,42)
!
!WC_O3/WC_CO2=0.0
!
!WC_O3/WC_SO2=-KC29*<WC_O3>
 PJAC(:,42,55)=-TPK%KC29(:)*PCONC(:,42)
!
!WC_O3/WC_SULF=0.0
!
!WC_O3/WC_HCHO=0.0
!
!WC_O3/WC_ORA1=0.0
!
!WC_O3/WC_ORA2=0.0
!
!WC_O3/WC_MO2=0.0
!
!WC_O3/WC_OP1=0.0
!
!WC_O3/WC_ASO3=0.0
!
!WC_O3/WC_ASO4=0.0
!
!WC_O3/WC_ASO5=0.0
!
!WC_O3/WC_AHSO5=0.0
!
!WC_O3/WC_AHMS=0.0
!
!WC_O3/WR_O3=0.0
!
!WC_O3/WR_H2O2=0.0
!
!WC_O3/WR_NO=0.0
!
!WC_O3/WR_NO2=0.0
!
!WC_O3/WR_NO3=0.0
!
!WC_O3/WR_N2O5=0.0
!
!WC_O3/WR_HONO=0.0
!
!WC_O3/WR_HNO3=0.0
!
!WC_O3/WR_HNO4=0.0
!
!WC_O3/WR_NH3=0.0
!
!WC_O3/WR_OH=0.0
!
!WC_O3/WR_HO2=0.0
!
!WC_O3/WR_CO2=0.0
!
!WC_O3/WR_SO2=0.0
!
!WC_O3/WR_SULF=0.0
!
!WC_O3/WR_HCHO=0.0
!
!WC_O3/WR_ORA1=0.0
!
!WC_O3/WR_ORA2=0.0
!
!WC_O3/WR_MO2=0.0
!
!WC_O3/WR_OP1=0.0
!
!WC_O3/WR_ASO3=0.0
!
!WC_O3/WR_ASO4=0.0
!
!WC_O3/WR_ASO5=0.0
!
!WC_O3/WR_AHSO5=0.0
!
!WC_O3/WR_AHMS=0.0
!
!WC_H2O2/O3=0.0
!
!WC_H2O2/H2O2=+KTC2
 PJAC(:,43,2)=+TPK%KTC2(:)
!
!WC_H2O2/NO=0.0
!
!WC_H2O2/NO2=0.0
!
!WC_H2O2/NO3=0.0
!
!WC_H2O2/N2O5=0.0
!
!WC_H2O2/HONO=0.0
!
!WC_H2O2/HNO3=0.0
!
!WC_H2O2/HNO4=0.0
!
!WC_H2O2/NH3=0.0
!
!WC_H2O2/SO2=0.0
!
!WC_H2O2/SULF=0.0
!
!WC_H2O2/CO=0.0
!
!WC_H2O2/OH=0.0
!
!WC_H2O2/HO2=0.0
!
!WC_H2O2/CH4=0.0
!
!WC_H2O2/ETH=0.0
!
!WC_H2O2/ALKA=0.0
!
!WC_H2O2/ALKE=0.0
!
!WC_H2O2/BIO=0.0
!
!WC_H2O2/ARO=0.0
!
!WC_H2O2/HCHO=0.0
!
!WC_H2O2/ALD=0.0
!
!WC_H2O2/KET=0.0
!
!WC_H2O2/CARBO=0.0
!
!WC_H2O2/ONIT=0.0
!
!WC_H2O2/PAN=0.0
!
!WC_H2O2/OP1=0.0
!
!WC_H2O2/OP2=0.0
!
!WC_H2O2/ORA1=0.0
!
!WC_H2O2/ORA2=0.0
!
!WC_H2O2/MO2=0.0
!
!WC_H2O2/ALKAP=0.0
!
!WC_H2O2/ALKEP=0.0
!
!WC_H2O2/BIOP=0.0
!
!WC_H2O2/PHO=0.0
!
!WC_H2O2/ADD=0.0
!
!WC_H2O2/AROP=0.0
!
!WC_H2O2/CARBOP=0.0
!
!WC_H2O2/OLN=0.0
!
!WC_H2O2/XO2=0.0
!
!WC_H2O2/WC_O3=0.0
!
!WC_H2O2/WC_H2O2=-KTC22-KC1-KC4*<WC_OH>-KC30*<WC_SO2>
 PJAC(:,43,43)=-TPK%KTC22(:)-TPK%KC1(:)-TPK%KC4(:)*PCONC(:,52)-TPK%KC30(:)*PCON&
&C(:,55)
!
!WC_H2O2/WC_NO=0.0
!
!WC_H2O2/WC_NO2=0.0
!
!WC_H2O2/WC_NO3=0.0
!
!WC_H2O2/WC_N2O5=0.0
!
!WC_H2O2/WC_HONO=0.0
!
!WC_H2O2/WC_HNO3=0.0
!
!WC_H2O2/WC_HNO4=0.0
!
!WC_H2O2/WC_NH3=0.0
!
!WC_H2O2/WC_OH=+KC2*<WC_OH>+KC2*<WC_OH>-KC4*<WC_H2O2>
 PJAC(:,43,52)=+TPK%KC2(:)*PCONC(:,52)+TPK%KC2(:)*PCONC(:,52)-TPK%KC4(:)*PCONC(&
&:,43)
!
!WC_H2O2/WC_HO2=+KC5*<WC_HO2>+KC5*<WC_HO2>
 PJAC(:,43,53)=+TPK%KC5(:)*PCONC(:,53)+TPK%KC5(:)*PCONC(:,53)
!
!WC_H2O2/WC_CO2=0.0
!
!WC_H2O2/WC_SO2=-KC30*<WC_H2O2>
 PJAC(:,43,55)=-TPK%KC30(:)*PCONC(:,43)
!
!WC_H2O2/WC_SULF=0.0
!
!WC_H2O2/WC_HCHO=0.0
!
!WC_H2O2/WC_ORA1=0.0
!
!WC_H2O2/WC_ORA2=0.0
!
!WC_H2O2/WC_MO2=0.0
!
!WC_H2O2/WC_OP1=0.0
!
!WC_H2O2/WC_ASO3=0.0
!
!WC_H2O2/WC_ASO4=0.0
!
!WC_H2O2/WC_ASO5=0.0
!
!WC_H2O2/WC_AHSO5=0.0
!
!WC_H2O2/WC_AHMS=0.0
!
!WC_H2O2/WR_O3=0.0
!
!WC_H2O2/WR_H2O2=0.0
!
!WC_H2O2/WR_NO=0.0
!
!WC_H2O2/WR_NO2=0.0
!
!WC_H2O2/WR_NO3=0.0
!
!WC_H2O2/WR_N2O5=0.0
!
!WC_H2O2/WR_HONO=0.0
!
!WC_H2O2/WR_HNO3=0.0
!
!WC_H2O2/WR_HNO4=0.0
!
!WC_H2O2/WR_NH3=0.0
!
!WC_H2O2/WR_OH=0.0
!
!WC_H2O2/WR_HO2=0.0
!
!WC_H2O2/WR_CO2=0.0
!
!WC_H2O2/WR_SO2=0.0
!
!WC_H2O2/WR_SULF=0.0
!
!WC_H2O2/WR_HCHO=0.0
!
!WC_H2O2/WR_ORA1=0.0
!
!WC_H2O2/WR_ORA2=0.0
!
!WC_H2O2/WR_MO2=0.0
!
!WC_H2O2/WR_OP1=0.0
!
!WC_H2O2/WR_ASO3=0.0
!
!WC_H2O2/WR_ASO4=0.0
!
!WC_H2O2/WR_ASO5=0.0
!
!WC_H2O2/WR_AHSO5=0.0
!
!WC_H2O2/WR_AHMS=0.0
!
!WC_NO/O3=0.0
!
!WC_NO/H2O2=0.0
!
!WC_NO/NO=+KTC3
 PJAC(:,44,3)=+TPK%KTC3(:)
!
!WC_NO/NO2=0.0
!
!WC_NO/NO3=0.0
!
!WC_NO/N2O5=0.0
!
!WC_NO/HONO=0.0
!
!WC_NO/HNO3=0.0
!
!WC_NO/HNO4=0.0
!
!WC_NO/NH3=0.0
!
!WC_NO/SO2=0.0
!
!WC_NO/SULF=0.0
!
!WC_NO/CO=0.0
!
!WC_NO/OH=0.0
!
!WC_NO/HO2=0.0
!
!WC_NO/CH4=0.0
!
!WC_NO/ETH=0.0
!
!WC_NO/ALKA=0.0
!
!WC_NO/ALKE=0.0
!
!WC_NO/BIO=0.0
!
!WC_NO/ARO=0.0
!
!WC_NO/HCHO=0.0
!
!WC_NO/ALD=0.0
!
!WC_NO/KET=0.0
!
!WC_NO/CARBO=0.0
!
!WC_NO/ONIT=0.0
!
!WC_NO/PAN=0.0
!
!WC_NO/OP1=0.0
!
!WC_NO/OP2=0.0
!
!WC_NO/ORA1=0.0
!
!WC_NO/ORA2=0.0
!
!WC_NO/MO2=0.0
!
!WC_NO/ALKAP=0.0
!
!WC_NO/ALKEP=0.0
!
!WC_NO/BIOP=0.0
!
!WC_NO/PHO=0.0
!
!WC_NO/ADD=0.0
!
!WC_NO/AROP=0.0
!
!WC_NO/CARBOP=0.0
!
!WC_NO/OLN=0.0
!
!WC_NO/XO2=0.0
!
!WC_NO/WC_O3=0.0
!
!WC_NO/WC_H2O2=0.0
!
!WC_NO/WC_NO=-KTC23
 PJAC(:,44,44)=-TPK%KTC23(:)
!
!WC_NO/WC_NO2=0.0
!
!WC_NO/WC_NO3=0.0
!
!WC_NO/WC_N2O5=0.0
!
!WC_NO/WC_HONO=0.0
!
!WC_NO/WC_HNO3=0.0
!
!WC_NO/WC_HNO4=0.0
!
!WC_NO/WC_NH3=0.0
!
!WC_NO/WC_OH=0.0
!
!WC_NO/WC_HO2=0.0
!
!WC_NO/WC_CO2=0.0
!
!WC_NO/WC_SO2=0.0
!
!WC_NO/WC_SULF=0.0
!
!WC_NO/WC_HCHO=0.0
!
!WC_NO/WC_ORA1=0.0
!
!WC_NO/WC_ORA2=0.0
!
!WC_NO/WC_MO2=0.0
!
!WC_NO/WC_OP1=0.0
!
!WC_NO/WC_ASO3=0.0
!
!WC_NO/WC_ASO4=0.0
!
!WC_NO/WC_ASO5=0.0
!
!WC_NO/WC_AHSO5=0.0
!
!WC_NO/WC_AHMS=0.0
!
!WC_NO/WR_O3=0.0
!
!WC_NO/WR_H2O2=0.0
!
!WC_NO/WR_NO=0.0
!
!WC_NO/WR_NO2=0.0
!
!WC_NO/WR_NO3=0.0
!
!WC_NO/WR_N2O5=0.0
!
!WC_NO/WR_HONO=0.0
!
!WC_NO/WR_HNO3=0.0
!
!WC_NO/WR_HNO4=0.0
!
!WC_NO/WR_NH3=0.0
!
!WC_NO/WR_OH=0.0
!
!WC_NO/WR_HO2=0.0
!
!WC_NO/WR_CO2=0.0
!
!WC_NO/WR_SO2=0.0
!
!WC_NO/WR_SULF=0.0
!
!WC_NO/WR_HCHO=0.0
!
!WC_NO/WR_ORA1=0.0
!
!WC_NO/WR_ORA2=0.0
!
!WC_NO/WR_MO2=0.0
!
!WC_NO/WR_OP1=0.0
!
!WC_NO/WR_ASO3=0.0
!
!WC_NO/WR_ASO4=0.0
!
!WC_NO/WR_ASO5=0.0
!
!WC_NO/WR_AHSO5=0.0
!
!WC_NO/WR_AHMS=0.0
!
!WC_NO2/O3=0.0
!
!WC_NO2/H2O2=0.0
!
!WC_NO2/NO=0.0
!
!WC_NO2/NO2=+KTC4
 PJAC(:,45,4)=+TPK%KTC4(:)
!
!WC_NO2/NO3=0.0
!
!WC_NO2/N2O5=0.0
!
!WC_NO2/HONO=0.0
!
!WC_NO2/HNO3=0.0
!
!WC_NO2/HNO4=0.0
!
!WC_NO2/NH3=0.0
!
!WC_NO2/SO2=0.0
!
!WC_NO2/SULF=0.0
!
!WC_NO2/CO=0.0
!
!WC_NO2/OH=0.0
!
!WC_NO2/HO2=0.0
!
!WC_NO2/CH4=0.0
!
!WC_NO2/ETH=0.0
!
!WC_NO2/ALKA=0.0
!
!WC_NO2/ALKE=0.0
!
!WC_NO2/BIO=0.0
!
!WC_NO2/ARO=0.0
!
!WC_NO2/HCHO=0.0
!
!WC_NO2/ALD=0.0
!
!WC_NO2/KET=0.0
!
!WC_NO2/CARBO=0.0
!
!WC_NO2/ONIT=0.0
!
!WC_NO2/PAN=0.0
!
!WC_NO2/OP1=0.0
!
!WC_NO2/OP2=0.0
!
!WC_NO2/ORA1=0.0
!
!WC_NO2/ORA2=0.0
!
!WC_NO2/MO2=0.0
!
!WC_NO2/ALKAP=0.0
!
!WC_NO2/ALKEP=0.0
!
!WC_NO2/BIOP=0.0
!
!WC_NO2/PHO=0.0
!
!WC_NO2/ADD=0.0
!
!WC_NO2/AROP=0.0
!
!WC_NO2/CARBOP=0.0
!
!WC_NO2/OLN=0.0
!
!WC_NO2/XO2=0.0
!
!WC_NO2/WC_O3=0.0
!
!WC_NO2/WC_H2O2=0.0
!
!WC_NO2/WC_NO=0.0
!
!WC_NO2/WC_NO2=-KTC24-KC9*<WC_HO2>
 PJAC(:,45,45)=-TPK%KTC24(:)-TPK%KC9(:)*PCONC(:,53)
!
!WC_NO2/WC_NO3=0.0
!
!WC_NO2/WC_N2O5=0.0
!
!WC_NO2/WC_HONO=+KC8*<WC_OH>
 PJAC(:,45,48)=+TPK%KC8(:)*PCONC(:,52)
!
!WC_NO2/WC_HNO3=+KC13
 PJAC(:,45,49)=+TPK%KC13(:)
!
!WC_NO2/WC_HNO4=+KC10
 PJAC(:,45,50)=+TPK%KC10(:)
!
!WC_NO2/WC_NH3=0.0
!
!WC_NO2/WC_OH=+KC8*<WC_HONO>
 PJAC(:,45,52)=+TPK%KC8(:)*PCONC(:,48)
!
!WC_NO2/WC_HO2=-KC9*<WC_NO2>
 PJAC(:,45,53)=-TPK%KC9(:)*PCONC(:,45)
!
!WC_NO2/WC_CO2=0.0
!
!WC_NO2/WC_SO2=0.0
!
!WC_NO2/WC_SULF=0.0
!
!WC_NO2/WC_HCHO=0.0
!
!WC_NO2/WC_ORA1=0.0
!
!WC_NO2/WC_ORA2=0.0
!
!WC_NO2/WC_MO2=0.0
!
!WC_NO2/WC_OP1=0.0
!
!WC_NO2/WC_ASO3=0.0
!
!WC_NO2/WC_ASO4=0.0
!
!WC_NO2/WC_ASO5=0.0
!
!WC_NO2/WC_AHSO5=0.0
!
!WC_NO2/WC_AHMS=0.0
!
!WC_NO2/WR_O3=0.0
!
!WC_NO2/WR_H2O2=0.0
!
!WC_NO2/WR_NO=0.0
!
!WC_NO2/WR_NO2=0.0
!
!WC_NO2/WR_NO3=0.0
!
!WC_NO2/WR_N2O5=0.0
!
!WC_NO2/WR_HONO=0.0
!
!WC_NO2/WR_HNO3=0.0
!
!WC_NO2/WR_HNO4=0.0
!
!WC_NO2/WR_NH3=0.0
!
!WC_NO2/WR_OH=0.0
!
!WC_NO2/WR_HO2=0.0
!
!WC_NO2/WR_CO2=0.0
!
!WC_NO2/WR_SO2=0.0
!
!WC_NO2/WR_SULF=0.0
!
!WC_NO2/WR_HCHO=0.0
!
!WC_NO2/WR_ORA1=0.0
!
!WC_NO2/WR_ORA2=0.0
!
!WC_NO2/WR_MO2=0.0
!
!WC_NO2/WR_OP1=0.0
!
!WC_NO2/WR_ASO3=0.0
!
!WC_NO2/WR_ASO4=0.0
!
!WC_NO2/WR_ASO5=0.0
!
!WC_NO2/WR_AHSO5=0.0
!
!WC_NO2/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ8
!
SUBROUTINE SUBJ9
!
!Indices 46 a 50
!
!
!WC_NO3/O3=0.0
!
!WC_NO3/H2O2=0.0
!
!WC_NO3/NO=0.0
!
!WC_NO3/NO2=0.0
!
!WC_NO3/NO3=+KTC5
 PJAC(:,46,5)=+TPK%KTC5(:)
!
!WC_NO3/N2O5=0.0
!
!WC_NO3/HONO=0.0
!
!WC_NO3/HNO3=0.0
!
!WC_NO3/HNO4=0.0
!
!WC_NO3/NH3=0.0
!
!WC_NO3/SO2=0.0
!
!WC_NO3/SULF=0.0
!
!WC_NO3/CO=0.0
!
!WC_NO3/OH=0.0
!
!WC_NO3/HO2=0.0
!
!WC_NO3/CH4=0.0
!
!WC_NO3/ETH=0.0
!
!WC_NO3/ALKA=0.0
!
!WC_NO3/ALKE=0.0
!
!WC_NO3/BIO=0.0
!
!WC_NO3/ARO=0.0
!
!WC_NO3/HCHO=0.0
!
!WC_NO3/ALD=0.0
!
!WC_NO3/KET=0.0
!
!WC_NO3/CARBO=0.0
!
!WC_NO3/ONIT=0.0
!
!WC_NO3/PAN=0.0
!
!WC_NO3/OP1=0.0
!
!WC_NO3/OP2=0.0
!
!WC_NO3/ORA1=0.0
!
!WC_NO3/ORA2=0.0
!
!WC_NO3/MO2=0.0
!
!WC_NO3/ALKAP=0.0
!
!WC_NO3/ALKEP=0.0
!
!WC_NO3/BIOP=0.0
!
!WC_NO3/PHO=0.0
!
!WC_NO3/ADD=0.0
!
!WC_NO3/AROP=0.0
!
!WC_NO3/CARBOP=0.0
!
!WC_NO3/OLN=0.0
!
!WC_NO3/XO2=0.0
!
!WC_NO3/WC_O3=0.0
!
!WC_NO3/WC_H2O2=0.0
!
!WC_NO3/WC_NO=0.0
!
!WC_NO3/WC_NO2=0.0
!
!WC_NO3/WC_NO3=-KTC25-KC15*<WC_SULF>-KC16*<WC_SO2>
 PJAC(:,46,46)=-TPK%KTC25(:)-TPK%KC15(:)*PCONC(:,56)-TPK%KC16(:)*PCONC(:,55)
!
!WC_NO3/WC_N2O5=0.0
!
!WC_NO3/WC_HONO=0.0
!
!WC_NO3/WC_HNO3=0.0
!
!WC_NO3/WC_HNO4=0.0
!
!WC_NO3/WC_NH3=0.0
!
!WC_NO3/WC_OH=0.0
!
!WC_NO3/WC_HO2=0.0
!
!WC_NO3/WC_CO2=0.0
!
!WC_NO3/WC_SO2=-KC16*<WC_NO3>
 PJAC(:,46,55)=-TPK%KC16(:)*PCONC(:,46)
!
!WC_NO3/WC_SULF=-KC15*<WC_NO3>
 PJAC(:,46,56)=-TPK%KC15(:)*PCONC(:,46)
!
!WC_NO3/WC_HCHO=0.0
!
!WC_NO3/WC_ORA1=0.0
!
!WC_NO3/WC_ORA2=0.0
!
!WC_NO3/WC_MO2=0.0
!
!WC_NO3/WC_OP1=0.0
!
!WC_NO3/WC_ASO3=0.0
!
!WC_NO3/WC_ASO4=0.0
!
!WC_NO3/WC_ASO5=0.0
!
!WC_NO3/WC_AHSO5=0.0
!
!WC_NO3/WC_AHMS=0.0
!
!WC_NO3/WR_O3=0.0
!
!WC_NO3/WR_H2O2=0.0
!
!WC_NO3/WR_NO=0.0
!
!WC_NO3/WR_NO2=0.0
!
!WC_NO3/WR_NO3=0.0
!
!WC_NO3/WR_N2O5=0.0
!
!WC_NO3/WR_HONO=0.0
!
!WC_NO3/WR_HNO3=0.0
!
!WC_NO3/WR_HNO4=0.0
!
!WC_NO3/WR_NH3=0.0
!
!WC_NO3/WR_OH=0.0
!
!WC_NO3/WR_HO2=0.0
!
!WC_NO3/WR_CO2=0.0
!
!WC_NO3/WR_SO2=0.0
!
!WC_NO3/WR_SULF=0.0
!
!WC_NO3/WR_HCHO=0.0
!
!WC_NO3/WR_ORA1=0.0
!
!WC_NO3/WR_ORA2=0.0
!
!WC_NO3/WR_MO2=0.0
!
!WC_NO3/WR_OP1=0.0
!
!WC_NO3/WR_ASO3=0.0
!
!WC_NO3/WR_ASO4=0.0
!
!WC_NO3/WR_ASO5=0.0
!
!WC_NO3/WR_AHSO5=0.0
!
!WC_NO3/WR_AHMS=0.0
!
!WC_N2O5/O3=0.0
!
!WC_N2O5/H2O2=0.0
!
!WC_N2O5/NO=0.0
!
!WC_N2O5/NO2=0.0
!
!WC_N2O5/NO3=0.0
!
!WC_N2O5/N2O5=+KTC6
 PJAC(:,47,6)=+TPK%KTC6(:)
!
!WC_N2O5/HONO=0.0
!
!WC_N2O5/HNO3=0.0
!
!WC_N2O5/HNO4=0.0
!
!WC_N2O5/NH3=0.0
!
!WC_N2O5/SO2=0.0
!
!WC_N2O5/SULF=0.0
!
!WC_N2O5/CO=0.0
!
!WC_N2O5/OH=0.0
!
!WC_N2O5/HO2=0.0
!
!WC_N2O5/CH4=0.0
!
!WC_N2O5/ETH=0.0
!
!WC_N2O5/ALKA=0.0
!
!WC_N2O5/ALKE=0.0
!
!WC_N2O5/BIO=0.0
!
!WC_N2O5/ARO=0.0
!
!WC_N2O5/HCHO=0.0
!
!WC_N2O5/ALD=0.0
!
!WC_N2O5/KET=0.0
!
!WC_N2O5/CARBO=0.0
!
!WC_N2O5/ONIT=0.0
!
!WC_N2O5/PAN=0.0
!
!WC_N2O5/OP1=0.0
!
!WC_N2O5/OP2=0.0
!
!WC_N2O5/ORA1=0.0
!
!WC_N2O5/ORA2=0.0
!
!WC_N2O5/MO2=0.0
!
!WC_N2O5/ALKAP=0.0
!
!WC_N2O5/ALKEP=0.0
!
!WC_N2O5/BIOP=0.0
!
!WC_N2O5/PHO=0.0
!
!WC_N2O5/ADD=0.0
!
!WC_N2O5/AROP=0.0
!
!WC_N2O5/CARBOP=0.0
!
!WC_N2O5/OLN=0.0
!
!WC_N2O5/XO2=0.0
!
!WC_N2O5/WC_O3=0.0
!
!WC_N2O5/WC_H2O2=0.0
!
!WC_N2O5/WC_NO=0.0
!
!WC_N2O5/WC_NO2=0.0
!
!WC_N2O5/WC_NO3=0.0
!
!WC_N2O5/WC_N2O5=-KTC26-KC14
 PJAC(:,47,47)=-TPK%KTC26(:)-TPK%KC14(:)
!
!WC_N2O5/WC_HONO=0.0
!
!WC_N2O5/WC_HNO3=0.0
!
!WC_N2O5/WC_HNO4=0.0
!
!WC_N2O5/WC_NH3=0.0
!
!WC_N2O5/WC_OH=0.0
!
!WC_N2O5/WC_HO2=0.0
!
!WC_N2O5/WC_CO2=0.0
!
!WC_N2O5/WC_SO2=0.0
!
!WC_N2O5/WC_SULF=0.0
!
!WC_N2O5/WC_HCHO=0.0
!
!WC_N2O5/WC_ORA1=0.0
!
!WC_N2O5/WC_ORA2=0.0
!
!WC_N2O5/WC_MO2=0.0
!
!WC_N2O5/WC_OP1=0.0
!
!WC_N2O5/WC_ASO3=0.0
!
!WC_N2O5/WC_ASO4=0.0
!
!WC_N2O5/WC_ASO5=0.0
!
!WC_N2O5/WC_AHSO5=0.0
!
!WC_N2O5/WC_AHMS=0.0
!
!WC_N2O5/WR_O3=0.0
!
!WC_N2O5/WR_H2O2=0.0
!
!WC_N2O5/WR_NO=0.0
!
!WC_N2O5/WR_NO2=0.0
!
!WC_N2O5/WR_NO3=0.0
!
!WC_N2O5/WR_N2O5=0.0
!
!WC_N2O5/WR_HONO=0.0
!
!WC_N2O5/WR_HNO3=0.0
!
!WC_N2O5/WR_HNO4=0.0
!
!WC_N2O5/WR_NH3=0.0
!
!WC_N2O5/WR_OH=0.0
!
!WC_N2O5/WR_HO2=0.0
!
!WC_N2O5/WR_CO2=0.0
!
!WC_N2O5/WR_SO2=0.0
!
!WC_N2O5/WR_SULF=0.0
!
!WC_N2O5/WR_HCHO=0.0
!
!WC_N2O5/WR_ORA1=0.0
!
!WC_N2O5/WR_ORA2=0.0
!
!WC_N2O5/WR_MO2=0.0
!
!WC_N2O5/WR_OP1=0.0
!
!WC_N2O5/WR_ASO3=0.0
!
!WC_N2O5/WR_ASO4=0.0
!
!WC_N2O5/WR_ASO5=0.0
!
!WC_N2O5/WR_AHSO5=0.0
!
!WC_N2O5/WR_AHMS=0.0
!
!WC_HONO/O3=0.0
!
!WC_HONO/H2O2=0.0
!
!WC_HONO/NO=0.0
!
!WC_HONO/NO2=0.0
!
!WC_HONO/NO3=0.0
!
!WC_HONO/N2O5=0.0
!
!WC_HONO/HONO=+KTC7
 PJAC(:,48,7)=+TPK%KTC7(:)
!
!WC_HONO/HNO3=0.0
!
!WC_HONO/HNO4=0.0
!
!WC_HONO/NH3=0.0
!
!WC_HONO/SO2=0.0
!
!WC_HONO/SULF=0.0
!
!WC_HONO/CO=0.0
!
!WC_HONO/OH=0.0
!
!WC_HONO/HO2=0.0
!
!WC_HONO/CH4=0.0
!
!WC_HONO/ETH=0.0
!
!WC_HONO/ALKA=0.0
!
!WC_HONO/ALKE=0.0
!
!WC_HONO/BIO=0.0
!
!WC_HONO/ARO=0.0
!
!WC_HONO/HCHO=0.0
!
!WC_HONO/ALD=0.0
!
!WC_HONO/KET=0.0
!
!WC_HONO/CARBO=0.0
!
!WC_HONO/ONIT=0.0
!
!WC_HONO/PAN=0.0
!
!WC_HONO/OP1=0.0
!
!WC_HONO/OP2=0.0
!
!WC_HONO/ORA1=0.0
!
!WC_HONO/ORA2=0.0
!
!WC_HONO/MO2=0.0
!
!WC_HONO/ALKAP=0.0
!
!WC_HONO/ALKEP=0.0
!
!WC_HONO/BIOP=0.0
!
!WC_HONO/PHO=0.0
!
!WC_HONO/ADD=0.0
!
!WC_HONO/AROP=0.0
!
!WC_HONO/CARBOP=0.0
!
!WC_HONO/OLN=0.0
!
!WC_HONO/XO2=0.0
!
!WC_HONO/WC_O3=0.0
!
!WC_HONO/WC_H2O2=0.0
!
!WC_HONO/WC_NO=0.0
!
!WC_HONO/WC_NO2=0.0
!
!WC_HONO/WC_NO3=0.0
!
!WC_HONO/WC_N2O5=0.0
!
!WC_HONO/WC_HONO=-KTC27-KC8*<WC_OH>
 PJAC(:,48,48)=-TPK%KTC27(:)-TPK%KC8(:)*PCONC(:,52)
!
!WC_HONO/WC_HNO3=0.0
!
!WC_HONO/WC_HNO4=+KC11
 PJAC(:,48,50)=+TPK%KC11(:)
!
!WC_HONO/WC_NH3=0.0
!
!WC_HONO/WC_OH=-KC8*<WC_HONO>
 PJAC(:,48,52)=-TPK%KC8(:)*PCONC(:,48)
!
!WC_HONO/WC_HO2=0.0
!
!WC_HONO/WC_CO2=0.0
!
!WC_HONO/WC_SO2=0.0
!
!WC_HONO/WC_SULF=0.0
!
!WC_HONO/WC_HCHO=0.0
!
!WC_HONO/WC_ORA1=0.0
!
!WC_HONO/WC_ORA2=0.0
!
!WC_HONO/WC_MO2=0.0
!
!WC_HONO/WC_OP1=0.0
!
!WC_HONO/WC_ASO3=0.0
!
!WC_HONO/WC_ASO4=0.0
!
!WC_HONO/WC_ASO5=0.0
!
!WC_HONO/WC_AHSO5=0.0
!
!WC_HONO/WC_AHMS=0.0
!
!WC_HONO/WR_O3=0.0
!
!WC_HONO/WR_H2O2=0.0
!
!WC_HONO/WR_NO=0.0
!
!WC_HONO/WR_NO2=0.0
!
!WC_HONO/WR_NO3=0.0
!
!WC_HONO/WR_N2O5=0.0
!
!WC_HONO/WR_HONO=0.0
!
!WC_HONO/WR_HNO3=0.0
!
!WC_HONO/WR_HNO4=0.0
!
!WC_HONO/WR_NH3=0.0
!
!WC_HONO/WR_OH=0.0
!
!WC_HONO/WR_HO2=0.0
!
!WC_HONO/WR_CO2=0.0
!
!WC_HONO/WR_SO2=0.0
!
!WC_HONO/WR_SULF=0.0
!
!WC_HONO/WR_HCHO=0.0
!
!WC_HONO/WR_ORA1=0.0
!
!WC_HONO/WR_ORA2=0.0
!
!WC_HONO/WR_MO2=0.0
!
!WC_HONO/WR_OP1=0.0
!
!WC_HONO/WR_ASO3=0.0
!
!WC_HONO/WR_ASO4=0.0
!
!WC_HONO/WR_ASO5=0.0
!
!WC_HONO/WR_AHSO5=0.0
!
!WC_HONO/WR_AHMS=0.0
!
!WC_HNO3/O3=0.0
!
!WC_HNO3/H2O2=0.0
!
!WC_HNO3/NO=0.0
!
!WC_HNO3/NO2=0.0
!
!WC_HNO3/NO3=0.0
!
!WC_HNO3/N2O5=0.0
!
!WC_HNO3/HONO=0.0
!
!WC_HNO3/HNO3=+KTC8
 PJAC(:,49,8)=+TPK%KTC8(:)
!
!WC_HNO3/HNO4=0.0
!
!WC_HNO3/NH3=0.0
!
!WC_HNO3/SO2=0.0
!
!WC_HNO3/SULF=0.0
!
!WC_HNO3/CO=0.0
!
!WC_HNO3/OH=0.0
!
!WC_HNO3/HO2=0.0
!
!WC_HNO3/CH4=0.0
!
!WC_HNO3/ETH=0.0
!
!WC_HNO3/ALKA=0.0
!
!WC_HNO3/ALKE=0.0
!
!WC_HNO3/BIO=0.0
!
!WC_HNO3/ARO=0.0
!
!WC_HNO3/HCHO=0.0
!
!WC_HNO3/ALD=0.0
!
!WC_HNO3/KET=0.0
!
!WC_HNO3/CARBO=0.0
!
!WC_HNO3/ONIT=0.0
!
!WC_HNO3/PAN=0.0
!
!WC_HNO3/OP1=0.0
!
!WC_HNO3/OP2=0.0
!
!WC_HNO3/ORA1=0.0
!
!WC_HNO3/ORA2=0.0
!
!WC_HNO3/MO2=0.0
!
!WC_HNO3/ALKAP=0.0
!
!WC_HNO3/ALKEP=0.0
!
!WC_HNO3/BIOP=0.0
!
!WC_HNO3/PHO=0.0
!
!WC_HNO3/ADD=0.0
!
!WC_HNO3/AROP=0.0
!
!WC_HNO3/CARBOP=0.0
!
!WC_HNO3/OLN=0.0
!
!WC_HNO3/XO2=0.0
!
!WC_HNO3/WC_O3=0.0
!
!WC_HNO3/WC_H2O2=0.0
!
!WC_HNO3/WC_NO=0.0
!
!WC_HNO3/WC_NO2=0.0
!
!WC_HNO3/WC_NO3=+KC15*<WC_SULF>+KC16*<WC_SO2>
 PJAC(:,49,46)=+TPK%KC15(:)*PCONC(:,56)+TPK%KC16(:)*PCONC(:,55)
!
!WC_HNO3/WC_N2O5=+KC14+KC14
 PJAC(:,49,47)=+TPK%KC14(:)+TPK%KC14(:)
!
!WC_HNO3/WC_HONO=0.0
!
!WC_HNO3/WC_HNO3=-KTC28-KC13
 PJAC(:,49,49)=-TPK%KTC28(:)-TPK%KC13(:)
!
!WC_HNO3/WC_HNO4=+KC12*<WC_SO2>
 PJAC(:,49,50)=+TPK%KC12(:)*PCONC(:,55)
!
!WC_HNO3/WC_NH3=0.0
!
!WC_HNO3/WC_OH=0.0
!
!WC_HNO3/WC_HO2=0.0
!
!WC_HNO3/WC_CO2=0.0
!
!WC_HNO3/WC_SO2=+KC12*<WC_HNO4>+KC16*<WC_NO3>
 PJAC(:,49,55)=+TPK%KC12(:)*PCONC(:,50)+TPK%KC16(:)*PCONC(:,46)
!
!WC_HNO3/WC_SULF=+KC15*<WC_NO3>
 PJAC(:,49,56)=+TPK%KC15(:)*PCONC(:,46)
!
!WC_HNO3/WC_HCHO=0.0
!
!WC_HNO3/WC_ORA1=0.0
!
!WC_HNO3/WC_ORA2=0.0
!
!WC_HNO3/WC_MO2=0.0
!
!WC_HNO3/WC_OP1=0.0
!
!WC_HNO3/WC_ASO3=0.0
!
!WC_HNO3/WC_ASO4=0.0
!
!WC_HNO3/WC_ASO5=0.0
!
!WC_HNO3/WC_AHSO5=0.0
!
!WC_HNO3/WC_AHMS=0.0
!
!WC_HNO3/WR_O3=0.0
!
!WC_HNO3/WR_H2O2=0.0
!
!WC_HNO3/WR_NO=0.0
!
!WC_HNO3/WR_NO2=0.0
!
!WC_HNO3/WR_NO3=0.0
!
!WC_HNO3/WR_N2O5=0.0
!
!WC_HNO3/WR_HONO=0.0
!
!WC_HNO3/WR_HNO3=0.0
!
!WC_HNO3/WR_HNO4=0.0
!
!WC_HNO3/WR_NH3=0.0
!
!WC_HNO3/WR_OH=0.0
!
!WC_HNO3/WR_HO2=0.0
!
!WC_HNO3/WR_CO2=0.0
!
!WC_HNO3/WR_SO2=0.0
!
!WC_HNO3/WR_SULF=0.0
!
!WC_HNO3/WR_HCHO=0.0
!
!WC_HNO3/WR_ORA1=0.0
!
!WC_HNO3/WR_ORA2=0.0
!
!WC_HNO3/WR_MO2=0.0
!
!WC_HNO3/WR_OP1=0.0
!
!WC_HNO3/WR_ASO3=0.0
!
!WC_HNO3/WR_ASO4=0.0
!
!WC_HNO3/WR_ASO5=0.0
!
!WC_HNO3/WR_AHSO5=0.0
!
!WC_HNO3/WR_AHMS=0.0
!
!WC_HNO4/O3=0.0
!
!WC_HNO4/H2O2=0.0
!
!WC_HNO4/NO=0.0
!
!WC_HNO4/NO2=0.0
!
!WC_HNO4/NO3=0.0
!
!WC_HNO4/N2O5=0.0
!
!WC_HNO4/HONO=0.0
!
!WC_HNO4/HNO3=0.0
!
!WC_HNO4/HNO4=+KTC9
 PJAC(:,50,9)=+TPK%KTC9(:)
!
!WC_HNO4/NH3=0.0
!
!WC_HNO4/SO2=0.0
!
!WC_HNO4/SULF=0.0
!
!WC_HNO4/CO=0.0
!
!WC_HNO4/OH=0.0
!
!WC_HNO4/HO2=0.0
!
!WC_HNO4/CH4=0.0
!
!WC_HNO4/ETH=0.0
!
!WC_HNO4/ALKA=0.0
!
!WC_HNO4/ALKE=0.0
!
!WC_HNO4/BIO=0.0
!
!WC_HNO4/ARO=0.0
!
!WC_HNO4/HCHO=0.0
!
!WC_HNO4/ALD=0.0
!
!WC_HNO4/KET=0.0
!
!WC_HNO4/CARBO=0.0
!
!WC_HNO4/ONIT=0.0
!
!WC_HNO4/PAN=0.0
!
!WC_HNO4/OP1=0.0
!
!WC_HNO4/OP2=0.0
!
!WC_HNO4/ORA1=0.0
!
!WC_HNO4/ORA2=0.0
!
!WC_HNO4/MO2=0.0
!
!WC_HNO4/ALKAP=0.0
!
!WC_HNO4/ALKEP=0.0
!
!WC_HNO4/BIOP=0.0
!
!WC_HNO4/PHO=0.0
!
!WC_HNO4/ADD=0.0
!
!WC_HNO4/AROP=0.0
!
!WC_HNO4/CARBOP=0.0
!
!WC_HNO4/OLN=0.0
!
!WC_HNO4/XO2=0.0
!
!WC_HNO4/WC_O3=0.0
!
!WC_HNO4/WC_H2O2=0.0
!
!WC_HNO4/WC_NO=0.0
!
!WC_HNO4/WC_NO2=+KC9*<WC_HO2>
 PJAC(:,50,45)=+TPK%KC9(:)*PCONC(:,53)
!
!WC_HNO4/WC_NO3=0.0
!
!WC_HNO4/WC_N2O5=0.0
!
!WC_HNO4/WC_HONO=0.0
!
!WC_HNO4/WC_HNO3=0.0
!
!WC_HNO4/WC_HNO4=-KTC29-KC10-KC11-KC12*<WC_SO2>
 PJAC(:,50,50)=-TPK%KTC29(:)-TPK%KC10(:)-TPK%KC11(:)-TPK%KC12(:)*PCONC(:,55)
!
!WC_HNO4/WC_NH3=0.0
!
!WC_HNO4/WC_OH=0.0
!
!WC_HNO4/WC_HO2=+KC9*<WC_NO2>
 PJAC(:,50,53)=+TPK%KC9(:)*PCONC(:,45)
!
!WC_HNO4/WC_CO2=0.0
!
!WC_HNO4/WC_SO2=-KC12*<WC_HNO4>
 PJAC(:,50,55)=-TPK%KC12(:)*PCONC(:,50)
!
!WC_HNO4/WC_SULF=0.0
!
!WC_HNO4/WC_HCHO=0.0
!
!WC_HNO4/WC_ORA1=0.0
!
!WC_HNO4/WC_ORA2=0.0
!
!WC_HNO4/WC_MO2=0.0
!
!WC_HNO4/WC_OP1=0.0
!
!WC_HNO4/WC_ASO3=0.0
!
!WC_HNO4/WC_ASO4=0.0
!
!WC_HNO4/WC_ASO5=0.0
!
!WC_HNO4/WC_AHSO5=0.0
!
!WC_HNO4/WC_AHMS=0.0
!
!WC_HNO4/WR_O3=0.0
!
!WC_HNO4/WR_H2O2=0.0
!
!WC_HNO4/WR_NO=0.0
!
!WC_HNO4/WR_NO2=0.0
!
!WC_HNO4/WR_NO3=0.0
!
!WC_HNO4/WR_N2O5=0.0
!
!WC_HNO4/WR_HONO=0.0
!
!WC_HNO4/WR_HNO3=0.0
!
!WC_HNO4/WR_HNO4=0.0
!
!WC_HNO4/WR_NH3=0.0
!
!WC_HNO4/WR_OH=0.0
!
!WC_HNO4/WR_HO2=0.0
!
!WC_HNO4/WR_CO2=0.0
!
!WC_HNO4/WR_SO2=0.0
!
!WC_HNO4/WR_SULF=0.0
!
!WC_HNO4/WR_HCHO=0.0
!
!WC_HNO4/WR_ORA1=0.0
!
!WC_HNO4/WR_ORA2=0.0
!
!WC_HNO4/WR_MO2=0.0
!
!WC_HNO4/WR_OP1=0.0
!
!WC_HNO4/WR_ASO3=0.0
!
!WC_HNO4/WR_ASO4=0.0
!
!WC_HNO4/WR_ASO5=0.0
!
!WC_HNO4/WR_AHSO5=0.0
!
!WC_HNO4/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ9
!
SUBROUTINE SUBJ10
!
!Indices 51 a 55
!
!
!WC_NH3/O3=0.0
!
!WC_NH3/H2O2=0.0
!
!WC_NH3/NO=0.0
!
!WC_NH3/NO2=0.0
!
!WC_NH3/NO3=0.0
!
!WC_NH3/N2O5=0.0
!
!WC_NH3/HONO=0.0
!
!WC_NH3/HNO3=0.0
!
!WC_NH3/HNO4=0.0
!
!WC_NH3/NH3=+KTC10
 PJAC(:,51,10)=+TPK%KTC10(:)
!
!WC_NH3/SO2=0.0
!
!WC_NH3/SULF=0.0
!
!WC_NH3/CO=0.0
!
!WC_NH3/OH=0.0
!
!WC_NH3/HO2=0.0
!
!WC_NH3/CH4=0.0
!
!WC_NH3/ETH=0.0
!
!WC_NH3/ALKA=0.0
!
!WC_NH3/ALKE=0.0
!
!WC_NH3/BIO=0.0
!
!WC_NH3/ARO=0.0
!
!WC_NH3/HCHO=0.0
!
!WC_NH3/ALD=0.0
!
!WC_NH3/KET=0.0
!
!WC_NH3/CARBO=0.0
!
!WC_NH3/ONIT=0.0
!
!WC_NH3/PAN=0.0
!
!WC_NH3/OP1=0.0
!
!WC_NH3/OP2=0.0
!
!WC_NH3/ORA1=0.0
!
!WC_NH3/ORA2=0.0
!
!WC_NH3/MO2=0.0
!
!WC_NH3/ALKAP=0.0
!
!WC_NH3/ALKEP=0.0
!
!WC_NH3/BIOP=0.0
!
!WC_NH3/PHO=0.0
!
!WC_NH3/ADD=0.0
!
!WC_NH3/AROP=0.0
!
!WC_NH3/CARBOP=0.0
!
!WC_NH3/OLN=0.0
!
!WC_NH3/XO2=0.0
!
!WC_NH3/WC_O3=0.0
!
!WC_NH3/WC_H2O2=0.0
!
!WC_NH3/WC_NO=0.0
!
!WC_NH3/WC_NO2=0.0
!
!WC_NH3/WC_NO3=0.0
!
!WC_NH3/WC_N2O5=0.0
!
!WC_NH3/WC_HONO=0.0
!
!WC_NH3/WC_HNO3=0.0
!
!WC_NH3/WC_HNO4=0.0
!
!WC_NH3/WC_NH3=-KTC30
 PJAC(:,51,51)=-TPK%KTC30(:)
!
!WC_NH3/WC_OH=0.0
!
!WC_NH3/WC_HO2=0.0
!
!WC_NH3/WC_CO2=0.0
!
!WC_NH3/WC_SO2=0.0
!
!WC_NH3/WC_SULF=0.0
!
!WC_NH3/WC_HCHO=0.0
!
!WC_NH3/WC_ORA1=0.0
!
!WC_NH3/WC_ORA2=0.0
!
!WC_NH3/WC_MO2=0.0
!
!WC_NH3/WC_OP1=0.0
!
!WC_NH3/WC_ASO3=0.0
!
!WC_NH3/WC_ASO4=0.0
!
!WC_NH3/WC_ASO5=0.0
!
!WC_NH3/WC_AHSO5=0.0
!
!WC_NH3/WC_AHMS=0.0
!
!WC_NH3/WR_O3=0.0
!
!WC_NH3/WR_H2O2=0.0
!
!WC_NH3/WR_NO=0.0
!
!WC_NH3/WR_NO2=0.0
!
!WC_NH3/WR_NO3=0.0
!
!WC_NH3/WR_N2O5=0.0
!
!WC_NH3/WR_HONO=0.0
!
!WC_NH3/WR_HNO3=0.0
!
!WC_NH3/WR_HNO4=0.0
!
!WC_NH3/WR_NH3=0.0
!
!WC_NH3/WR_OH=0.0
!
!WC_NH3/WR_HO2=0.0
!
!WC_NH3/WR_CO2=0.0
!
!WC_NH3/WR_SO2=0.0
!
!WC_NH3/WR_SULF=0.0
!
!WC_NH3/WR_HCHO=0.0
!
!WC_NH3/WR_ORA1=0.0
!
!WC_NH3/WR_ORA2=0.0
!
!WC_NH3/WR_MO2=0.0
!
!WC_NH3/WR_OP1=0.0
!
!WC_NH3/WR_ASO3=0.0
!
!WC_NH3/WR_ASO4=0.0
!
!WC_NH3/WR_ASO5=0.0
!
!WC_NH3/WR_AHSO5=0.0
!
!WC_NH3/WR_AHMS=0.0
!
!WC_OH/O3=0.0
!
!WC_OH/H2O2=0.0
!
!WC_OH/NO=0.0
!
!WC_OH/NO2=0.0
!
!WC_OH/NO3=0.0
!
!WC_OH/N2O5=0.0
!
!WC_OH/HONO=0.0
!
!WC_OH/HNO3=0.0
!
!WC_OH/HNO4=0.0
!
!WC_OH/NH3=0.0
!
!WC_OH/SO2=0.0
!
!WC_OH/SULF=0.0
!
!WC_OH/CO=0.0
!
!WC_OH/OH=+KTC11
 PJAC(:,52,14)=+TPK%KTC11(:)
!
!WC_OH/HO2=0.0
!
!WC_OH/CH4=0.0
!
!WC_OH/ETH=0.0
!
!WC_OH/ALKA=0.0
!
!WC_OH/ALKE=0.0
!
!WC_OH/BIO=0.0
!
!WC_OH/ARO=0.0
!
!WC_OH/HCHO=0.0
!
!WC_OH/ALD=0.0
!
!WC_OH/KET=0.0
!
!WC_OH/CARBO=0.0
!
!WC_OH/ONIT=0.0
!
!WC_OH/PAN=0.0
!
!WC_OH/OP1=0.0
!
!WC_OH/OP2=0.0
!
!WC_OH/ORA1=0.0
!
!WC_OH/ORA2=0.0
!
!WC_OH/MO2=0.0
!
!WC_OH/ALKAP=0.0
!
!WC_OH/ALKEP=0.0
!
!WC_OH/BIOP=0.0
!
!WC_OH/PHO=0.0
!
!WC_OH/ADD=0.0
!
!WC_OH/AROP=0.0
!
!WC_OH/CARBOP=0.0
!
!WC_OH/OLN=0.0
!
!WC_OH/XO2=0.0
!
!WC_OH/WC_O3=+KC6*<WC_HO2>
 PJAC(:,52,42)=+TPK%KC6(:)*PCONC(:,53)
!
!WC_OH/WC_H2O2=+KC1+KC1-KC4*<WC_OH>
 PJAC(:,52,43)=+TPK%KC1(:)+TPK%KC1(:)-TPK%KC4(:)*PCONC(:,52)
!
!WC_OH/WC_NO=0.0
!
!WC_OH/WC_NO2=0.0
!
!WC_OH/WC_NO3=0.0
!
!WC_OH/WC_N2O5=0.0
!
!WC_OH/WC_HONO=-KC8*<WC_OH>
 PJAC(:,52,48)=-TPK%KC8(:)*PCONC(:,52)
!
!WC_OH/WC_HNO3=+KC13
 PJAC(:,52,49)=+TPK%KC13(:)
!
!WC_OH/WC_HNO4=0.0
!
!WC_OH/WC_NH3=0.0
!
!WC_OH/WC_OH=-KTC31-KC2*<WC_OH>-KC2*<WC_OH>-KC2*<WC_OH>-KC2*<WC_OH>-KC3*<WC_HO2
!>-KC4*<WC_H2O2>-KC7*<WC_SO2>-KC8*<WC_HONO>-KC19*<WC_HCHO>-KC20*<WC_ORA1>-KC23*
!<WC_AHMS>
 PJAC(:,52,52)=-TPK%KTC31(:)-TPK%KC2(:)*PCONC(:,52)-TPK%KC2(:)*PCONC(:,52)-TPK%&
&KC2(:)*PCONC(:,52)-TPK%KC2(:)*PCONC(:,52)-TPK%KC3(:)*PCONC(:,53)-TPK%KC4(:)*PC&
&ONC(:,43)-TPK%KC7(:)*PCONC(:,55)-TPK%KC8(:)*PCONC(:,48)-TPK%KC19(:)*PCONC(:,57&
&)-TPK%KC20(:)*PCONC(:,58)-TPK%KC23(:)*PCONC(:,66)
!
!WC_OH/WC_HO2=-KC3*<WC_OH>+KC6*<WC_O3>
 PJAC(:,52,53)=-TPK%KC3(:)*PCONC(:,52)+TPK%KC6(:)*PCONC(:,42)
!
!WC_OH/WC_CO2=0.0
!
!WC_OH/WC_SO2=-KC7*<WC_OH>
 PJAC(:,52,55)=-TPK%KC7(:)*PCONC(:,52)
!
!WC_OH/WC_SULF=0.0
!
!WC_OH/WC_HCHO=-KC19*<WC_OH>
 PJAC(:,52,57)=-TPK%KC19(:)*PCONC(:,52)
!
!WC_OH/WC_ORA1=-KC20*<WC_OH>
 PJAC(:,52,58)=-TPK%KC20(:)*PCONC(:,52)
!
!WC_OH/WC_ORA2=0.0
!
!WC_OH/WC_MO2=0.0
!
!WC_OH/WC_OP1=0.0
!
!WC_OH/WC_ASO3=0.0
!
!WC_OH/WC_ASO4=+KC28
 PJAC(:,52,63)=+TPK%KC28(:)
!
!WC_OH/WC_ASO5=0.0
!
!WC_OH/WC_AHSO5=0.0
!
!WC_OH/WC_AHMS=-KC23*<WC_OH>
 PJAC(:,52,66)=-TPK%KC23(:)*PCONC(:,52)
!
!WC_OH/WR_O3=0.0
!
!WC_OH/WR_H2O2=0.0
!
!WC_OH/WR_NO=0.0
!
!WC_OH/WR_NO2=0.0
!
!WC_OH/WR_NO3=0.0
!
!WC_OH/WR_N2O5=0.0
!
!WC_OH/WR_HONO=0.0
!
!WC_OH/WR_HNO3=0.0
!
!WC_OH/WR_HNO4=0.0
!
!WC_OH/WR_NH3=0.0
!
!WC_OH/WR_OH=0.0
!
!WC_OH/WR_HO2=0.0
!
!WC_OH/WR_CO2=0.0
!
!WC_OH/WR_SO2=0.0
!
!WC_OH/WR_SULF=0.0
!
!WC_OH/WR_HCHO=0.0
!
!WC_OH/WR_ORA1=0.0
!
!WC_OH/WR_ORA2=0.0
!
!WC_OH/WR_MO2=0.0
!
!WC_OH/WR_OP1=0.0
!
!WC_OH/WR_ASO3=0.0
!
!WC_OH/WR_ASO4=0.0
!
!WC_OH/WR_ASO5=0.0
!
!WC_OH/WR_AHSO5=0.0
!
!WC_OH/WR_AHMS=0.0
!
!WC_HO2/O3=0.0
!
!WC_HO2/H2O2=0.0
!
!WC_HO2/NO=0.0
!
!WC_HO2/NO2=0.0
!
!WC_HO2/NO3=0.0
!
!WC_HO2/N2O5=0.0
!
!WC_HO2/HONO=0.0
!
!WC_HO2/HNO3=0.0
!
!WC_HO2/HNO4=0.0
!
!WC_HO2/NH3=0.0
!
!WC_HO2/SO2=0.0
!
!WC_HO2/SULF=0.0
!
!WC_HO2/CO=0.0
!
!WC_HO2/OH=0.0
!
!WC_HO2/HO2=+KTC12
 PJAC(:,53,15)=+TPK%KTC12(:)
!
!WC_HO2/CH4=0.0
!
!WC_HO2/ETH=0.0
!
!WC_HO2/ALKA=0.0
!
!WC_HO2/ALKE=0.0
!
!WC_HO2/BIO=0.0
!
!WC_HO2/ARO=0.0
!
!WC_HO2/HCHO=0.0
!
!WC_HO2/ALD=0.0
!
!WC_HO2/KET=0.0
!
!WC_HO2/CARBO=0.0
!
!WC_HO2/ONIT=0.0
!
!WC_HO2/PAN=0.0
!
!WC_HO2/OP1=0.0
!
!WC_HO2/OP2=0.0
!
!WC_HO2/ORA1=0.0
!
!WC_HO2/ORA2=0.0
!
!WC_HO2/MO2=0.0
!
!WC_HO2/ALKAP=0.0
!
!WC_HO2/ALKEP=0.0
!
!WC_HO2/BIOP=0.0
!
!WC_HO2/PHO=0.0
!
!WC_HO2/ADD=0.0
!
!WC_HO2/AROP=0.0
!
!WC_HO2/CARBOP=0.0
!
!WC_HO2/OLN=0.0
!
!WC_HO2/XO2=0.0
!
!WC_HO2/WC_O3=-KC6*<WC_HO2>
 PJAC(:,53,42)=-TPK%KC6(:)*PCONC(:,53)
!
!WC_HO2/WC_H2O2=+KC4*<WC_OH>
 PJAC(:,53,43)=+TPK%KC4(:)*PCONC(:,52)
!
!WC_HO2/WC_NO=0.0
!
!WC_HO2/WC_NO2=-KC9*<WC_HO2>
 PJAC(:,53,45)=-TPK%KC9(:)*PCONC(:,53)
!
!WC_HO2/WC_NO3=0.0
!
!WC_HO2/WC_N2O5=0.0
!
!WC_HO2/WC_HONO=0.0
!
!WC_HO2/WC_HNO3=0.0
!
!WC_HO2/WC_HNO4=+KC10
 PJAC(:,53,50)=+TPK%KC10(:)
!
!WC_HO2/WC_NH3=0.0
!
!WC_HO2/WC_OH=-KC3*<WC_HO2>+KC4*<WC_H2O2>+KC19*<WC_HCHO>+KC20*<WC_ORA1>+KC23*<W
!C_AHMS>
 PJAC(:,53,52)=-TPK%KC3(:)*PCONC(:,53)+TPK%KC4(:)*PCONC(:,43)+TPK%KC19(:)*PCONC&
&(:,57)+TPK%KC20(:)*PCONC(:,58)+TPK%KC23(:)*PCONC(:,66)
!
!WC_HO2/WC_HO2=-KTC32-KC3*<WC_OH>-KC5*<WC_HO2>-KC5*<WC_HO2>-KC5*<WC_HO2>-KC5*<W
!C_HO2>-KC6*<WC_O3>-KC9*<WC_NO2>-KC25*<WC_ASO5>
 PJAC(:,53,53)=-TPK%KTC32(:)-TPK%KC3(:)*PCONC(:,52)-TPK%KC5(:)*PCONC(:,53)-TPK%&
&KC5(:)*PCONC(:,53)-TPK%KC5(:)*PCONC(:,53)-TPK%KC5(:)*PCONC(:,53)-TPK%KC6(:)*PC&
&ONC(:,42)-TPK%KC9(:)*PCONC(:,45)-TPK%KC25(:)*PCONC(:,64)
!
!WC_HO2/WC_CO2=0.0
!
!WC_HO2/WC_SO2=0.0
!
!WC_HO2/WC_SULF=0.0
!
!WC_HO2/WC_HCHO=+KC19*<WC_OH>
 PJAC(:,53,57)=+TPK%KC19(:)*PCONC(:,52)
!
!WC_HO2/WC_ORA1=+KC20*<WC_OH>
 PJAC(:,53,58)=+TPK%KC20(:)*PCONC(:,52)
!
!WC_HO2/WC_ORA2=0.0
!
!WC_HO2/WC_MO2=+2.00*KC17*<WC_MO2>+2.00*KC17*<WC_MO2>
 PJAC(:,53,60)=+2.00*TPK%KC17(:)*PCONC(:,60)+2.00*TPK%KC17(:)*PCONC(:,60)
!
!WC_HO2/WC_OP1=0.0
!
!WC_HO2/WC_ASO3=0.0
!
!WC_HO2/WC_ASO4=0.0
!
!WC_HO2/WC_ASO5=-KC25*<WC_HO2>
 PJAC(:,53,64)=-TPK%KC25(:)*PCONC(:,53)
!
!WC_HO2/WC_AHSO5=0.0
!
!WC_HO2/WC_AHMS=+KC23*<WC_OH>
 PJAC(:,53,66)=+TPK%KC23(:)*PCONC(:,52)
!
!WC_HO2/WR_O3=0.0
!
!WC_HO2/WR_H2O2=0.0
!
!WC_HO2/WR_NO=0.0
!
!WC_HO2/WR_NO2=0.0
!
!WC_HO2/WR_NO3=0.0
!
!WC_HO2/WR_N2O5=0.0
!
!WC_HO2/WR_HONO=0.0
!
!WC_HO2/WR_HNO3=0.0
!
!WC_HO2/WR_HNO4=0.0
!
!WC_HO2/WR_NH3=0.0
!
!WC_HO2/WR_OH=0.0
!
!WC_HO2/WR_HO2=0.0
!
!WC_HO2/WR_CO2=0.0
!
!WC_HO2/WR_SO2=0.0
!
!WC_HO2/WR_SULF=0.0
!
!WC_HO2/WR_HCHO=0.0
!
!WC_HO2/WR_ORA1=0.0
!
!WC_HO2/WR_ORA2=0.0
!
!WC_HO2/WR_MO2=0.0
!
!WC_HO2/WR_OP1=0.0
!
!WC_HO2/WR_ASO3=0.0
!
!WC_HO2/WR_ASO4=0.0
!
!WC_HO2/WR_ASO5=0.0
!
!WC_HO2/WR_AHSO5=0.0
!
!WC_HO2/WR_AHMS=0.0
!
!WC_CO2/O3=0.0
!
!WC_CO2/H2O2=0.0
!
!WC_CO2/NO=0.0
!
!WC_CO2/NO2=0.0
!
!WC_CO2/NO3=0.0
!
!WC_CO2/N2O5=0.0
!
!WC_CO2/HONO=0.0
!
!WC_CO2/HNO3=0.0
!
!WC_CO2/HNO4=0.0
!
!WC_CO2/NH3=0.0
!
!WC_CO2/SO2=0.0
!
!WC_CO2/SULF=0.0
!
!WC_CO2/CO=0.0
!
!WC_CO2/OH=0.0
!
!WC_CO2/HO2=0.0
!
!WC_CO2/CH4=0.0
!
!WC_CO2/ETH=0.0
!
!WC_CO2/ALKA=0.0
!
!WC_CO2/ALKE=0.0
!
!WC_CO2/BIO=0.0
!
!WC_CO2/ARO=0.0
!
!WC_CO2/HCHO=0.0
!
!WC_CO2/ALD=0.0
!
!WC_CO2/KET=0.0
!
!WC_CO2/CARBO=0.0
!
!WC_CO2/ONIT=0.0
!
!WC_CO2/PAN=0.0
!
!WC_CO2/OP1=0.0
!
!WC_CO2/OP2=0.0
!
!WC_CO2/ORA1=0.0
!
!WC_CO2/ORA2=0.0
!
!WC_CO2/MO2=0.0
!
!WC_CO2/ALKAP=0.0
!
!WC_CO2/ALKEP=0.0
!
!WC_CO2/BIOP=0.0
!
!WC_CO2/PHO=0.0
!
!WC_CO2/ADD=0.0
!
!WC_CO2/AROP=0.0
!
!WC_CO2/CARBOP=0.0
!
!WC_CO2/OLN=0.0
!
!WC_CO2/XO2=0.0
!
!WC_CO2/WC_O3=0.0
!
!WC_CO2/WC_H2O2=0.0
!
!WC_CO2/WC_NO=0.0
!
!WC_CO2/WC_NO2=0.0
!
!WC_CO2/WC_NO3=0.0
!
!WC_CO2/WC_N2O5=0.0
!
!WC_CO2/WC_HONO=0.0
!
!WC_CO2/WC_HNO3=0.0
!
!WC_CO2/WC_HNO4=0.0
!
!WC_CO2/WC_NH3=0.0
!
!WC_CO2/WC_OH=+KC20*<WC_ORA1>
 PJAC(:,54,52)=+TPK%KC20(:)*PCONC(:,58)
!
!WC_CO2/WC_HO2=0.0
!
!WC_CO2/WC_CO2=-KTC33
 PJAC(:,54,54)=-TPK%KTC33(:)
!
!WC_CO2/WC_SO2=0.0
!
!WC_CO2/WC_SULF=0.0
!
!WC_CO2/WC_HCHO=0.0
!
!WC_CO2/WC_ORA1=+KC20*<WC_OH>
 PJAC(:,54,58)=+TPK%KC20(:)*PCONC(:,52)
!
!WC_CO2/WC_ORA2=0.0
!
!WC_CO2/WC_MO2=0.0
!
!WC_CO2/WC_OP1=0.0
!
!WC_CO2/WC_ASO3=0.0
!
!WC_CO2/WC_ASO4=0.0
!
!WC_CO2/WC_ASO5=0.0
!
!WC_CO2/WC_AHSO5=0.0
!
!WC_CO2/WC_AHMS=0.0
!
!WC_CO2/WR_O3=0.0
!
!WC_CO2/WR_H2O2=0.0
!
!WC_CO2/WR_NO=0.0
!
!WC_CO2/WR_NO2=0.0
!
!WC_CO2/WR_NO3=0.0
!
!WC_CO2/WR_N2O5=0.0
!
!WC_CO2/WR_HONO=0.0
!
!WC_CO2/WR_HNO3=0.0
!
!WC_CO2/WR_HNO4=0.0
!
!WC_CO2/WR_NH3=0.0
!
!WC_CO2/WR_OH=0.0
!
!WC_CO2/WR_HO2=0.0
!
!WC_CO2/WR_CO2=0.0
!
!WC_CO2/WR_SO2=0.0
!
!WC_CO2/WR_SULF=0.0
!
!WC_CO2/WR_HCHO=0.0
!
!WC_CO2/WR_ORA1=0.0
!
!WC_CO2/WR_ORA2=0.0
!
!WC_CO2/WR_MO2=0.0
!
!WC_CO2/WR_OP1=0.0
!
!WC_CO2/WR_ASO3=0.0
!
!WC_CO2/WR_ASO4=0.0
!
!WC_CO2/WR_ASO5=0.0
!
!WC_CO2/WR_AHSO5=0.0
!
!WC_CO2/WR_AHMS=0.0
!
!WC_SO2/O3=0.0
!
!WC_SO2/H2O2=0.0
!
!WC_SO2/NO=0.0
!
!WC_SO2/NO2=0.0
!
!WC_SO2/NO3=0.0
!
!WC_SO2/N2O5=0.0
!
!WC_SO2/HONO=0.0
!
!WC_SO2/HNO3=0.0
!
!WC_SO2/HNO4=0.0
!
!WC_SO2/NH3=0.0
!
!WC_SO2/SO2=+KTC14
 PJAC(:,55,11)=+TPK%KTC14(:)
!
!WC_SO2/SULF=0.0
!
!WC_SO2/CO=0.0
!
!WC_SO2/OH=0.0
!
!WC_SO2/HO2=0.0
!
!WC_SO2/CH4=0.0
!
!WC_SO2/ETH=0.0
!
!WC_SO2/ALKA=0.0
!
!WC_SO2/ALKE=0.0
!
!WC_SO2/BIO=0.0
!
!WC_SO2/ARO=0.0
!
!WC_SO2/HCHO=0.0
!
!WC_SO2/ALD=0.0
!
!WC_SO2/KET=0.0
!
!WC_SO2/CARBO=0.0
!
!WC_SO2/ONIT=0.0
!
!WC_SO2/PAN=0.0
!
!WC_SO2/OP1=0.0
!
!WC_SO2/OP2=0.0
!
!WC_SO2/ORA1=0.0
!
!WC_SO2/ORA2=0.0
!
!WC_SO2/MO2=0.0
!
!WC_SO2/ALKAP=0.0
!
!WC_SO2/ALKEP=0.0
!
!WC_SO2/BIOP=0.0
!
!WC_SO2/PHO=0.0
!
!WC_SO2/ADD=0.0
!
!WC_SO2/AROP=0.0
!
!WC_SO2/CARBOP=0.0
!
!WC_SO2/OLN=0.0
!
!WC_SO2/XO2=0.0
!
!WC_SO2/WC_O3=-KC29*<WC_SO2>
 PJAC(:,55,42)=-TPK%KC29(:)*PCONC(:,55)
!
!WC_SO2/WC_H2O2=-KC30*<WC_SO2>
 PJAC(:,55,43)=-TPK%KC30(:)*PCONC(:,55)
!
!WC_SO2/WC_NO=0.0
!
!WC_SO2/WC_NO2=0.0
!
!WC_SO2/WC_NO3=-KC16*<WC_SO2>
 PJAC(:,55,46)=-TPK%KC16(:)*PCONC(:,55)
!
!WC_SO2/WC_N2O5=0.0
!
!WC_SO2/WC_HONO=0.0
!
!WC_SO2/WC_HNO3=0.0
!
!WC_SO2/WC_HNO4=-KC12*<WC_SO2>
 PJAC(:,55,50)=-TPK%KC12(:)*PCONC(:,55)
!
!WC_SO2/WC_NH3=0.0
!
!WC_SO2/WC_OH=-KC7*<WC_SO2>+KC23*<WC_AHMS>
 PJAC(:,55,52)=-TPK%KC7(:)*PCONC(:,55)+TPK%KC23(:)*PCONC(:,66)
!
!WC_SO2/WC_HO2=0.0
!
!WC_SO2/WC_CO2=0.0
!
!WC_SO2/WC_SO2=-KTC34-KC7*<WC_OH>-KC12*<WC_HNO4>-KC16*<WC_NO3>-KC18*<WC_MO2>-KC
!21*<WC_HCHO>-KC27*<WC_AHSO5>-KC29*<WC_O3>-KC30*<WC_H2O2>
 PJAC(:,55,55)=-TPK%KTC34(:)-TPK%KC7(:)*PCONC(:,52)-TPK%KC12(:)*PCONC(:,50)-TPK&
&%KC16(:)*PCONC(:,46)-TPK%KC18(:)*PCONC(:,60)-TPK%KC21(:)*PCONC(:,57)-TPK%KC27(&
&:)*PCONC(:,65)-TPK%KC29(:)*PCONC(:,42)-TPK%KC30(:)*PCONC(:,43)
!
!WC_SO2/WC_SULF=0.0
!
!WC_SO2/WC_HCHO=-KC21*<WC_SO2>
 PJAC(:,55,57)=-TPK%KC21(:)*PCONC(:,55)
!
!WC_SO2/WC_ORA1=0.0
!
!WC_SO2/WC_ORA2=0.0
!
!WC_SO2/WC_MO2=-KC18*<WC_SO2>
 PJAC(:,55,60)=-TPK%KC18(:)*PCONC(:,55)
!
!WC_SO2/WC_OP1=0.0
!
!WC_SO2/WC_ASO3=0.0
!
!WC_SO2/WC_ASO4=0.0
!
!WC_SO2/WC_ASO5=0.0
!
!WC_SO2/WC_AHSO5=-KC27*<WC_SO2>
 PJAC(:,55,65)=-TPK%KC27(:)*PCONC(:,55)
!
!WC_SO2/WC_AHMS=+KC22+KC23*<WC_OH>
 PJAC(:,55,66)=+TPK%KC22(:)+TPK%KC23(:)*PCONC(:,52)
!
!WC_SO2/WR_O3=0.0
!
!WC_SO2/WR_H2O2=0.0
!
!WC_SO2/WR_NO=0.0
!
!WC_SO2/WR_NO2=0.0
!
!WC_SO2/WR_NO3=0.0
!
!WC_SO2/WR_N2O5=0.0
!
!WC_SO2/WR_HONO=0.0
!
!WC_SO2/WR_HNO3=0.0
!
!WC_SO2/WR_HNO4=0.0
!
!WC_SO2/WR_NH3=0.0
!
!WC_SO2/WR_OH=0.0
!
!WC_SO2/WR_HO2=0.0
!
!WC_SO2/WR_CO2=0.0
!
!WC_SO2/WR_SO2=0.0
!
!WC_SO2/WR_SULF=0.0
!
!WC_SO2/WR_HCHO=0.0
!
!WC_SO2/WR_ORA1=0.0
!
!WC_SO2/WR_ORA2=0.0
!
!WC_SO2/WR_MO2=0.0
!
!WC_SO2/WR_OP1=0.0
!
!WC_SO2/WR_ASO3=0.0
!
!WC_SO2/WR_ASO4=0.0
!
!WC_SO2/WR_ASO5=0.0
!
!WC_SO2/WR_AHSO5=0.0
!
!WC_SO2/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ10
!
SUBROUTINE SUBJ11
!
!Indices 56 a 60
!
!
!WC_SULF/O3=0.0
!
!WC_SULF/H2O2=0.0
!
!WC_SULF/NO=0.0
!
!WC_SULF/NO2=0.0
!
!WC_SULF/NO3=0.0
!
!WC_SULF/N2O5=0.0
!
!WC_SULF/HONO=0.0
!
!WC_SULF/HNO3=0.0
!
!WC_SULF/HNO4=0.0
!
!WC_SULF/NH3=0.0
!
!WC_SULF/SO2=0.0
!
!WC_SULF/SULF=+KTC15
 PJAC(:,56,12)=+TPK%KTC15(:)
!
!WC_SULF/CO=0.0
!
!WC_SULF/OH=0.0
!
!WC_SULF/HO2=0.0
!
!WC_SULF/CH4=0.0
!
!WC_SULF/ETH=0.0
!
!WC_SULF/ALKA=0.0
!
!WC_SULF/ALKE=0.0
!
!WC_SULF/BIO=0.0
!
!WC_SULF/ARO=0.0
!
!WC_SULF/HCHO=0.0
!
!WC_SULF/ALD=0.0
!
!WC_SULF/KET=0.0
!
!WC_SULF/CARBO=0.0
!
!WC_SULF/ONIT=0.0
!
!WC_SULF/PAN=0.0
!
!WC_SULF/OP1=0.0
!
!WC_SULF/OP2=0.0
!
!WC_SULF/ORA1=0.0
!
!WC_SULF/ORA2=0.0
!
!WC_SULF/MO2=0.0
!
!WC_SULF/ALKAP=0.0
!
!WC_SULF/ALKEP=0.0
!
!WC_SULF/BIOP=0.0
!
!WC_SULF/PHO=0.0
!
!WC_SULF/ADD=0.0
!
!WC_SULF/AROP=0.0
!
!WC_SULF/CARBOP=0.0
!
!WC_SULF/OLN=0.0
!
!WC_SULF/XO2=0.0
!
!WC_SULF/WC_O3=+KC29*<WC_SO2>
 PJAC(:,56,42)=+TPK%KC29(:)*PCONC(:,55)
!
!WC_SULF/WC_H2O2=+KC30*<WC_SO2>
 PJAC(:,56,43)=+TPK%KC30(:)*PCONC(:,55)
!
!WC_SULF/WC_NO=0.0
!
!WC_SULF/WC_NO2=0.0
!
!WC_SULF/WC_NO3=-KC15*<WC_SULF>
 PJAC(:,56,46)=-TPK%KC15(:)*PCONC(:,56)
!
!WC_SULF/WC_N2O5=0.0
!
!WC_SULF/WC_HONO=0.0
!
!WC_SULF/WC_HNO3=0.0
!
!WC_SULF/WC_HNO4=+KC12*<WC_SO2>
 PJAC(:,56,50)=+TPK%KC12(:)*PCONC(:,55)
!
!WC_SULF/WC_NH3=0.0
!
!WC_SULF/WC_OH=0.0
!
!WC_SULF/WC_HO2=0.0
!
!WC_SULF/WC_CO2=0.0
!
!WC_SULF/WC_SO2=+KC12*<WC_HNO4>+2.00*KC27*<WC_AHSO5>+KC29*<WC_O3>+KC30*<WC_H2O2
!>
 PJAC(:,56,55)=+TPK%KC12(:)*PCONC(:,50)+2.00*TPK%KC27(:)*PCONC(:,65)+TPK%KC29(:&
&)*PCONC(:,42)+TPK%KC30(:)*PCONC(:,43)
!
!WC_SULF/WC_SULF=-KTC35-KC15*<WC_NO3>
 PJAC(:,56,56)=-TPK%KTC35(:)-TPK%KC15(:)*PCONC(:,46)
!
!WC_SULF/WC_HCHO=0.0
!
!WC_SULF/WC_ORA1=0.0
!
!WC_SULF/WC_ORA2=0.0
!
!WC_SULF/WC_MO2=0.0
!
!WC_SULF/WC_OP1=0.0
!
!WC_SULF/WC_ASO3=0.0
!
!WC_SULF/WC_ASO4=+KC28
 PJAC(:,56,63)=+TPK%KC28(:)
!
!WC_SULF/WC_ASO5=0.0
!
!WC_SULF/WC_AHSO5=+2.00*KC27*<WC_SO2>
 PJAC(:,56,65)=+2.00*TPK%KC27(:)*PCONC(:,55)
!
!WC_SULF/WC_AHMS=0.0
!
!WC_SULF/WR_O3=0.0
!
!WC_SULF/WR_H2O2=0.0
!
!WC_SULF/WR_NO=0.0
!
!WC_SULF/WR_NO2=0.0
!
!WC_SULF/WR_NO3=0.0
!
!WC_SULF/WR_N2O5=0.0
!
!WC_SULF/WR_HONO=0.0
!
!WC_SULF/WR_HNO3=0.0
!
!WC_SULF/WR_HNO4=0.0
!
!WC_SULF/WR_NH3=0.0
!
!WC_SULF/WR_OH=0.0
!
!WC_SULF/WR_HO2=0.0
!
!WC_SULF/WR_CO2=0.0
!
!WC_SULF/WR_SO2=0.0
!
!WC_SULF/WR_SULF=0.0
!
!WC_SULF/WR_HCHO=0.0
!
!WC_SULF/WR_ORA1=0.0
!
!WC_SULF/WR_ORA2=0.0
!
!WC_SULF/WR_MO2=0.0
!
!WC_SULF/WR_OP1=0.0
!
!WC_SULF/WR_ASO3=0.0
!
!WC_SULF/WR_ASO4=0.0
!
!WC_SULF/WR_ASO5=0.0
!
!WC_SULF/WR_AHSO5=0.0
!
!WC_SULF/WR_AHMS=0.0
!
!WC_HCHO/O3=0.0
!
!WC_HCHO/H2O2=0.0
!
!WC_HCHO/NO=0.0
!
!WC_HCHO/NO2=0.0
!
!WC_HCHO/NO3=0.0
!
!WC_HCHO/N2O5=0.0
!
!WC_HCHO/HONO=0.0
!
!WC_HCHO/HNO3=0.0
!
!WC_HCHO/HNO4=0.0
!
!WC_HCHO/NH3=0.0
!
!WC_HCHO/SO2=0.0
!
!WC_HCHO/SULF=0.0
!
!WC_HCHO/CO=0.0
!
!WC_HCHO/OH=0.0
!
!WC_HCHO/HO2=0.0
!
!WC_HCHO/CH4=0.0
!
!WC_HCHO/ETH=0.0
!
!WC_HCHO/ALKA=0.0
!
!WC_HCHO/ALKE=0.0
!
!WC_HCHO/BIO=0.0
!
!WC_HCHO/ARO=0.0
!
!WC_HCHO/HCHO=+KTC16
 PJAC(:,57,22)=+TPK%KTC16(:)
!
!WC_HCHO/ALD=0.0
!
!WC_HCHO/KET=0.0
!
!WC_HCHO/CARBO=0.0
!
!WC_HCHO/ONIT=0.0
!
!WC_HCHO/PAN=0.0
!
!WC_HCHO/OP1=0.0
!
!WC_HCHO/OP2=0.0
!
!WC_HCHO/ORA1=0.0
!
!WC_HCHO/ORA2=0.0
!
!WC_HCHO/MO2=0.0
!
!WC_HCHO/ALKAP=0.0
!
!WC_HCHO/ALKEP=0.0
!
!WC_HCHO/BIOP=0.0
!
!WC_HCHO/PHO=0.0
!
!WC_HCHO/ADD=0.0
!
!WC_HCHO/AROP=0.0
!
!WC_HCHO/CARBOP=0.0
!
!WC_HCHO/OLN=0.0
!
!WC_HCHO/XO2=0.0
!
!WC_HCHO/WC_O3=0.0
!
!WC_HCHO/WC_H2O2=0.0
!
!WC_HCHO/WC_NO=0.0
!
!WC_HCHO/WC_NO2=0.0
!
!WC_HCHO/WC_NO3=0.0
!
!WC_HCHO/WC_N2O5=0.0
!
!WC_HCHO/WC_HONO=0.0
!
!WC_HCHO/WC_HNO3=0.0
!
!WC_HCHO/WC_HNO4=0.0
!
!WC_HCHO/WC_NH3=0.0
!
!WC_HCHO/WC_OH=-KC19*<WC_HCHO>
 PJAC(:,57,52)=-TPK%KC19(:)*PCONC(:,57)
!
!WC_HCHO/WC_HO2=0.0
!
!WC_HCHO/WC_CO2=0.0
!
!WC_HCHO/WC_SO2=-KC21*<WC_HCHO>
 PJAC(:,57,55)=-TPK%KC21(:)*PCONC(:,57)
!
!WC_HCHO/WC_SULF=0.0
!
!WC_HCHO/WC_HCHO=-KTC36-KC19*<WC_OH>-KC21*<WC_SO2>
 PJAC(:,57,57)=-TPK%KTC36(:)-TPK%KC19(:)*PCONC(:,52)-TPK%KC21(:)*PCONC(:,55)
!
!WC_HCHO/WC_ORA1=0.0
!
!WC_HCHO/WC_ORA2=0.0
!
!WC_HCHO/WC_MO2=+2.00*KC17*<WC_MO2>+2.00*KC17*<WC_MO2>
 PJAC(:,57,60)=+2.00*TPK%KC17(:)*PCONC(:,60)+2.00*TPK%KC17(:)*PCONC(:,60)
!
!WC_HCHO/WC_OP1=0.0
!
!WC_HCHO/WC_ASO3=0.0
!
!WC_HCHO/WC_ASO4=0.0
!
!WC_HCHO/WC_ASO5=0.0
!
!WC_HCHO/WC_AHSO5=0.0
!
!WC_HCHO/WC_AHMS=+KC22
 PJAC(:,57,66)=+TPK%KC22(:)
!
!WC_HCHO/WR_O3=0.0
!
!WC_HCHO/WR_H2O2=0.0
!
!WC_HCHO/WR_NO=0.0
!
!WC_HCHO/WR_NO2=0.0
!
!WC_HCHO/WR_NO3=0.0
!
!WC_HCHO/WR_N2O5=0.0
!
!WC_HCHO/WR_HONO=0.0
!
!WC_HCHO/WR_HNO3=0.0
!
!WC_HCHO/WR_HNO4=0.0
!
!WC_HCHO/WR_NH3=0.0
!
!WC_HCHO/WR_OH=0.0
!
!WC_HCHO/WR_HO2=0.0
!
!WC_HCHO/WR_CO2=0.0
!
!WC_HCHO/WR_SO2=0.0
!
!WC_HCHO/WR_SULF=0.0
!
!WC_HCHO/WR_HCHO=0.0
!
!WC_HCHO/WR_ORA1=0.0
!
!WC_HCHO/WR_ORA2=0.0
!
!WC_HCHO/WR_MO2=0.0
!
!WC_HCHO/WR_OP1=0.0
!
!WC_HCHO/WR_ASO3=0.0
!
!WC_HCHO/WR_ASO4=0.0
!
!WC_HCHO/WR_ASO5=0.0
!
!WC_HCHO/WR_AHSO5=0.0
!
!WC_HCHO/WR_AHMS=0.0
!
!WC_ORA1/O3=0.0
!
!WC_ORA1/H2O2=0.0
!
!WC_ORA1/NO=0.0
!
!WC_ORA1/NO2=0.0
!
!WC_ORA1/NO3=0.0
!
!WC_ORA1/N2O5=0.0
!
!WC_ORA1/HONO=0.0
!
!WC_ORA1/HNO3=0.0
!
!WC_ORA1/HNO4=0.0
!
!WC_ORA1/NH3=0.0
!
!WC_ORA1/SO2=0.0
!
!WC_ORA1/SULF=0.0
!
!WC_ORA1/CO=0.0
!
!WC_ORA1/OH=0.0
!
!WC_ORA1/HO2=0.0
!
!WC_ORA1/CH4=0.0
!
!WC_ORA1/ETH=0.0
!
!WC_ORA1/ALKA=0.0
!
!WC_ORA1/ALKE=0.0
!
!WC_ORA1/BIO=0.0
!
!WC_ORA1/ARO=0.0
!
!WC_ORA1/HCHO=0.0
!
!WC_ORA1/ALD=0.0
!
!WC_ORA1/KET=0.0
!
!WC_ORA1/CARBO=0.0
!
!WC_ORA1/ONIT=0.0
!
!WC_ORA1/PAN=0.0
!
!WC_ORA1/OP1=0.0
!
!WC_ORA1/OP2=0.0
!
!WC_ORA1/ORA1=+KTC17
 PJAC(:,58,30)=+TPK%KTC17(:)
!
!WC_ORA1/ORA2=0.0
!
!WC_ORA1/MO2=0.0
!
!WC_ORA1/ALKAP=0.0
!
!WC_ORA1/ALKEP=0.0
!
!WC_ORA1/BIOP=0.0
!
!WC_ORA1/PHO=0.0
!
!WC_ORA1/ADD=0.0
!
!WC_ORA1/AROP=0.0
!
!WC_ORA1/CARBOP=0.0
!
!WC_ORA1/OLN=0.0
!
!WC_ORA1/XO2=0.0
!
!WC_ORA1/WC_O3=0.0
!
!WC_ORA1/WC_H2O2=0.0
!
!WC_ORA1/WC_NO=0.0
!
!WC_ORA1/WC_NO2=0.0
!
!WC_ORA1/WC_NO3=0.0
!
!WC_ORA1/WC_N2O5=0.0
!
!WC_ORA1/WC_HONO=0.0
!
!WC_ORA1/WC_HNO3=0.0
!
!WC_ORA1/WC_HNO4=0.0
!
!WC_ORA1/WC_NH3=0.0
!
!WC_ORA1/WC_OH=+KC19*<WC_HCHO>-KC20*<WC_ORA1>+KC23*<WC_AHMS>
 PJAC(:,58,52)=+TPK%KC19(:)*PCONC(:,57)-TPK%KC20(:)*PCONC(:,58)+TPK%KC23(:)*PCO&
&NC(:,66)
!
!WC_ORA1/WC_HO2=0.0
!
!WC_ORA1/WC_CO2=0.0
!
!WC_ORA1/WC_SO2=0.0
!
!WC_ORA1/WC_SULF=0.0
!
!WC_ORA1/WC_HCHO=+KC19*<WC_OH>
 PJAC(:,58,57)=+TPK%KC19(:)*PCONC(:,52)
!
!WC_ORA1/WC_ORA1=-KTC37-KC20*<WC_OH>
 PJAC(:,58,58)=-TPK%KTC37(:)-TPK%KC20(:)*PCONC(:,52)
!
!WC_ORA1/WC_ORA2=0.0
!
!WC_ORA1/WC_MO2=0.0
!
!WC_ORA1/WC_OP1=0.0
!
!WC_ORA1/WC_ASO3=0.0
!
!WC_ORA1/WC_ASO4=0.0
!
!WC_ORA1/WC_ASO5=0.0
!
!WC_ORA1/WC_AHSO5=0.0
!
!WC_ORA1/WC_AHMS=+KC23*<WC_OH>
 PJAC(:,58,66)=+TPK%KC23(:)*PCONC(:,52)
!
!WC_ORA1/WR_O3=0.0
!
!WC_ORA1/WR_H2O2=0.0
!
!WC_ORA1/WR_NO=0.0
!
!WC_ORA1/WR_NO2=0.0
!
!WC_ORA1/WR_NO3=0.0
!
!WC_ORA1/WR_N2O5=0.0
!
!WC_ORA1/WR_HONO=0.0
!
!WC_ORA1/WR_HNO3=0.0
!
!WC_ORA1/WR_HNO4=0.0
!
!WC_ORA1/WR_NH3=0.0
!
!WC_ORA1/WR_OH=0.0
!
!WC_ORA1/WR_HO2=0.0
!
!WC_ORA1/WR_CO2=0.0
!
!WC_ORA1/WR_SO2=0.0
!
!WC_ORA1/WR_SULF=0.0
!
!WC_ORA1/WR_HCHO=0.0
!
!WC_ORA1/WR_ORA1=0.0
!
!WC_ORA1/WR_ORA2=0.0
!
!WC_ORA1/WR_MO2=0.0
!
!WC_ORA1/WR_OP1=0.0
!
!WC_ORA1/WR_ASO3=0.0
!
!WC_ORA1/WR_ASO4=0.0
!
!WC_ORA1/WR_ASO5=0.0
!
!WC_ORA1/WR_AHSO5=0.0
!
!WC_ORA1/WR_AHMS=0.0
!
!WC_ORA2/O3=0.0
!
!WC_ORA2/H2O2=0.0
!
!WC_ORA2/NO=0.0
!
!WC_ORA2/NO2=0.0
!
!WC_ORA2/NO3=0.0
!
!WC_ORA2/N2O5=0.0
!
!WC_ORA2/HONO=0.0
!
!WC_ORA2/HNO3=0.0
!
!WC_ORA2/HNO4=0.0
!
!WC_ORA2/NH3=0.0
!
!WC_ORA2/SO2=0.0
!
!WC_ORA2/SULF=0.0
!
!WC_ORA2/CO=0.0
!
!WC_ORA2/OH=0.0
!
!WC_ORA2/HO2=0.0
!
!WC_ORA2/CH4=0.0
!
!WC_ORA2/ETH=0.0
!
!WC_ORA2/ALKA=0.0
!
!WC_ORA2/ALKE=0.0
!
!WC_ORA2/BIO=0.0
!
!WC_ORA2/ARO=0.0
!
!WC_ORA2/HCHO=0.0
!
!WC_ORA2/ALD=0.0
!
!WC_ORA2/KET=0.0
!
!WC_ORA2/CARBO=0.0
!
!WC_ORA2/ONIT=0.0
!
!WC_ORA2/PAN=0.0
!
!WC_ORA2/OP1=0.0
!
!WC_ORA2/OP2=0.0
!
!WC_ORA2/ORA1=0.0
!
!WC_ORA2/ORA2=+KTC18
 PJAC(:,59,31)=+TPK%KTC18(:)
!
!WC_ORA2/MO2=0.0
!
!WC_ORA2/ALKAP=0.0
!
!WC_ORA2/ALKEP=0.0
!
!WC_ORA2/BIOP=0.0
!
!WC_ORA2/PHO=0.0
!
!WC_ORA2/ADD=0.0
!
!WC_ORA2/AROP=0.0
!
!WC_ORA2/CARBOP=0.0
!
!WC_ORA2/OLN=0.0
!
!WC_ORA2/XO2=0.0
!
!WC_ORA2/WC_O3=0.0
!
!WC_ORA2/WC_H2O2=0.0
!
!WC_ORA2/WC_NO=0.0
!
!WC_ORA2/WC_NO2=0.0
!
!WC_ORA2/WC_NO3=0.0
!
!WC_ORA2/WC_N2O5=0.0
!
!WC_ORA2/WC_HONO=0.0
!
!WC_ORA2/WC_HNO3=0.0
!
!WC_ORA2/WC_HNO4=0.0
!
!WC_ORA2/WC_NH3=0.0
!
!WC_ORA2/WC_OH=0.0
!
!WC_ORA2/WC_HO2=0.0
!
!WC_ORA2/WC_CO2=0.0
!
!WC_ORA2/WC_SO2=0.0
!
!WC_ORA2/WC_SULF=0.0
!
!WC_ORA2/WC_HCHO=0.0
!
!WC_ORA2/WC_ORA1=0.0
!
!WC_ORA2/WC_ORA2=-KTC38
 PJAC(:,59,59)=-TPK%KTC38(:)
!
!WC_ORA2/WC_MO2=0.0
!
!WC_ORA2/WC_OP1=0.0
!
!WC_ORA2/WC_ASO3=0.0
!
!WC_ORA2/WC_ASO4=0.0
!
!WC_ORA2/WC_ASO5=0.0
!
!WC_ORA2/WC_AHSO5=0.0
!
!WC_ORA2/WC_AHMS=0.0
!
!WC_ORA2/WR_O3=0.0
!
!WC_ORA2/WR_H2O2=0.0
!
!WC_ORA2/WR_NO=0.0
!
!WC_ORA2/WR_NO2=0.0
!
!WC_ORA2/WR_NO3=0.0
!
!WC_ORA2/WR_N2O5=0.0
!
!WC_ORA2/WR_HONO=0.0
!
!WC_ORA2/WR_HNO3=0.0
!
!WC_ORA2/WR_HNO4=0.0
!
!WC_ORA2/WR_NH3=0.0
!
!WC_ORA2/WR_OH=0.0
!
!WC_ORA2/WR_HO2=0.0
!
!WC_ORA2/WR_CO2=0.0
!
!WC_ORA2/WR_SO2=0.0
!
!WC_ORA2/WR_SULF=0.0
!
!WC_ORA2/WR_HCHO=0.0
!
!WC_ORA2/WR_ORA1=0.0
!
!WC_ORA2/WR_ORA2=0.0
!
!WC_ORA2/WR_MO2=0.0
!
!WC_ORA2/WR_OP1=0.0
!
!WC_ORA2/WR_ASO3=0.0
!
!WC_ORA2/WR_ASO4=0.0
!
!WC_ORA2/WR_ASO5=0.0
!
!WC_ORA2/WR_AHSO5=0.0
!
!WC_ORA2/WR_AHMS=0.0
!
!WC_MO2/O3=0.0
!
!WC_MO2/H2O2=0.0
!
!WC_MO2/NO=0.0
!
!WC_MO2/NO2=0.0
!
!WC_MO2/NO3=0.0
!
!WC_MO2/N2O5=0.0
!
!WC_MO2/HONO=0.0
!
!WC_MO2/HNO3=0.0
!
!WC_MO2/HNO4=0.0
!
!WC_MO2/NH3=0.0
!
!WC_MO2/SO2=0.0
!
!WC_MO2/SULF=0.0
!
!WC_MO2/CO=0.0
!
!WC_MO2/OH=0.0
!
!WC_MO2/HO2=0.0
!
!WC_MO2/CH4=0.0
!
!WC_MO2/ETH=0.0
!
!WC_MO2/ALKA=0.0
!
!WC_MO2/ALKE=0.0
!
!WC_MO2/BIO=0.0
!
!WC_MO2/ARO=0.0
!
!WC_MO2/HCHO=0.0
!
!WC_MO2/ALD=0.0
!
!WC_MO2/KET=0.0
!
!WC_MO2/CARBO=0.0
!
!WC_MO2/ONIT=0.0
!
!WC_MO2/PAN=0.0
!
!WC_MO2/OP1=0.0
!
!WC_MO2/OP2=0.0
!
!WC_MO2/ORA1=0.0
!
!WC_MO2/ORA2=0.0
!
!WC_MO2/MO2=+KTC19
 PJAC(:,60,32)=+TPK%KTC19(:)
!
!WC_MO2/ALKAP=0.0
!
!WC_MO2/ALKEP=0.0
!
!WC_MO2/BIOP=0.0
!
!WC_MO2/PHO=0.0
!
!WC_MO2/ADD=0.0
!
!WC_MO2/AROP=0.0
!
!WC_MO2/CARBOP=0.0
!
!WC_MO2/OLN=0.0
!
!WC_MO2/XO2=0.0
!
!WC_MO2/WC_O3=0.0
!
!WC_MO2/WC_H2O2=0.0
!
!WC_MO2/WC_NO=0.0
!
!WC_MO2/WC_NO2=0.0
!
!WC_MO2/WC_NO3=0.0
!
!WC_MO2/WC_N2O5=0.0
!
!WC_MO2/WC_HONO=0.0
!
!WC_MO2/WC_HNO3=0.0
!
!WC_MO2/WC_HNO4=0.0
!
!WC_MO2/WC_NH3=0.0
!
!WC_MO2/WC_OH=0.0
!
!WC_MO2/WC_HO2=0.0
!
!WC_MO2/WC_CO2=0.0
!
!WC_MO2/WC_SO2=-KC18*<WC_MO2>
 PJAC(:,60,55)=-TPK%KC18(:)*PCONC(:,60)
!
!WC_MO2/WC_SULF=0.0
!
!WC_MO2/WC_HCHO=0.0
!
!WC_MO2/WC_ORA1=0.0
!
!WC_MO2/WC_ORA2=0.0
!
!WC_MO2/WC_MO2=-KTC39-KC17*<WC_MO2>-KC17*<WC_MO2>-KC17*<WC_MO2>-KC17*<WC_MO2>-K
!C18*<WC_SO2>
 PJAC(:,60,60)=-TPK%KTC39(:)-TPK%KC17(:)*PCONC(:,60)-TPK%KC17(:)*PCONC(:,60)-TP&
&K%KC17(:)*PCONC(:,60)-TPK%KC17(:)*PCONC(:,60)-TPK%KC18(:)*PCONC(:,55)
!
!WC_MO2/WC_OP1=0.0
!
!WC_MO2/WC_ASO3=0.0
!
!WC_MO2/WC_ASO4=0.0
!
!WC_MO2/WC_ASO5=0.0
!
!WC_MO2/WC_AHSO5=0.0
!
!WC_MO2/WC_AHMS=0.0
!
!WC_MO2/WR_O3=0.0
!
!WC_MO2/WR_H2O2=0.0
!
!WC_MO2/WR_NO=0.0
!
!WC_MO2/WR_NO2=0.0
!
!WC_MO2/WR_NO3=0.0
!
!WC_MO2/WR_N2O5=0.0
!
!WC_MO2/WR_HONO=0.0
!
!WC_MO2/WR_HNO3=0.0
!
!WC_MO2/WR_HNO4=0.0
!
!WC_MO2/WR_NH3=0.0
!
!WC_MO2/WR_OH=0.0
!
!WC_MO2/WR_HO2=0.0
!
!WC_MO2/WR_CO2=0.0
!
!WC_MO2/WR_SO2=0.0
!
!WC_MO2/WR_SULF=0.0
!
!WC_MO2/WR_HCHO=0.0
!
!WC_MO2/WR_ORA1=0.0
!
!WC_MO2/WR_ORA2=0.0
!
!WC_MO2/WR_MO2=0.0
!
!WC_MO2/WR_OP1=0.0
!
!WC_MO2/WR_ASO3=0.0
!
!WC_MO2/WR_ASO4=0.0
!
!WC_MO2/WR_ASO5=0.0
!
!WC_MO2/WR_AHSO5=0.0
!
!WC_MO2/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ11
!
SUBROUTINE SUBJ12
!
!Indices 61 a 65
!
!
!WC_OP1/O3=0.0
!
!WC_OP1/H2O2=0.0
!
!WC_OP1/NO=0.0
!
!WC_OP1/NO2=0.0
!
!WC_OP1/NO3=0.0
!
!WC_OP1/N2O5=0.0
!
!WC_OP1/HONO=0.0
!
!WC_OP1/HNO3=0.0
!
!WC_OP1/HNO4=0.0
!
!WC_OP1/NH3=0.0
!
!WC_OP1/SO2=0.0
!
!WC_OP1/SULF=0.0
!
!WC_OP1/CO=0.0
!
!WC_OP1/OH=0.0
!
!WC_OP1/HO2=0.0
!
!WC_OP1/CH4=0.0
!
!WC_OP1/ETH=0.0
!
!WC_OP1/ALKA=0.0
!
!WC_OP1/ALKE=0.0
!
!WC_OP1/BIO=0.0
!
!WC_OP1/ARO=0.0
!
!WC_OP1/HCHO=0.0
!
!WC_OP1/ALD=0.0
!
!WC_OP1/KET=0.0
!
!WC_OP1/CARBO=0.0
!
!WC_OP1/ONIT=0.0
!
!WC_OP1/PAN=0.0
!
!WC_OP1/OP1=+KTC20
 PJAC(:,61,28)=+TPK%KTC20(:)
!
!WC_OP1/OP2=0.0
!
!WC_OP1/ORA1=0.0
!
!WC_OP1/ORA2=0.0
!
!WC_OP1/MO2=0.0
!
!WC_OP1/ALKAP=0.0
!
!WC_OP1/ALKEP=0.0
!
!WC_OP1/BIOP=0.0
!
!WC_OP1/PHO=0.0
!
!WC_OP1/ADD=0.0
!
!WC_OP1/AROP=0.0
!
!WC_OP1/CARBOP=0.0
!
!WC_OP1/OLN=0.0
!
!WC_OP1/XO2=0.0
!
!WC_OP1/WC_O3=0.0
!
!WC_OP1/WC_H2O2=0.0
!
!WC_OP1/WC_NO=0.0
!
!WC_OP1/WC_NO2=0.0
!
!WC_OP1/WC_NO3=0.0
!
!WC_OP1/WC_N2O5=0.0
!
!WC_OP1/WC_HONO=0.0
!
!WC_OP1/WC_HNO3=0.0
!
!WC_OP1/WC_HNO4=0.0
!
!WC_OP1/WC_NH3=0.0
!
!WC_OP1/WC_OH=0.0
!
!WC_OP1/WC_HO2=0.0
!
!WC_OP1/WC_CO2=0.0
!
!WC_OP1/WC_SO2=+KC18*<WC_MO2>
 PJAC(:,61,55)=+TPK%KC18(:)*PCONC(:,60)
!
!WC_OP1/WC_SULF=0.0
!
!WC_OP1/WC_HCHO=0.0
!
!WC_OP1/WC_ORA1=0.0
!
!WC_OP1/WC_ORA2=0.0
!
!WC_OP1/WC_MO2=+KC18*<WC_SO2>
 PJAC(:,61,60)=+TPK%KC18(:)*PCONC(:,55)
!
!WC_OP1/WC_OP1=-KTC40
 PJAC(:,61,61)=-TPK%KTC40(:)
!
!WC_OP1/WC_ASO3=0.0
!
!WC_OP1/WC_ASO4=0.0
!
!WC_OP1/WC_ASO5=0.0
!
!WC_OP1/WC_AHSO5=0.0
!
!WC_OP1/WC_AHMS=0.0
!
!WC_OP1/WR_O3=0.0
!
!WC_OP1/WR_H2O2=0.0
!
!WC_OP1/WR_NO=0.0
!
!WC_OP1/WR_NO2=0.0
!
!WC_OP1/WR_NO3=0.0
!
!WC_OP1/WR_N2O5=0.0
!
!WC_OP1/WR_HONO=0.0
!
!WC_OP1/WR_HNO3=0.0
!
!WC_OP1/WR_HNO4=0.0
!
!WC_OP1/WR_NH3=0.0
!
!WC_OP1/WR_OH=0.0
!
!WC_OP1/WR_HO2=0.0
!
!WC_OP1/WR_CO2=0.0
!
!WC_OP1/WR_SO2=0.0
!
!WC_OP1/WR_SULF=0.0
!
!WC_OP1/WR_HCHO=0.0
!
!WC_OP1/WR_ORA1=0.0
!
!WC_OP1/WR_ORA2=0.0
!
!WC_OP1/WR_MO2=0.0
!
!WC_OP1/WR_OP1=0.0
!
!WC_OP1/WR_ASO3=0.0
!
!WC_OP1/WR_ASO4=0.0
!
!WC_OP1/WR_ASO5=0.0
!
!WC_OP1/WR_AHSO5=0.0
!
!WC_OP1/WR_AHMS=0.0
!
!WC_ASO3/O3=0.0
!
!WC_ASO3/H2O2=0.0
!
!WC_ASO3/NO=0.0
!
!WC_ASO3/NO2=0.0
!
!WC_ASO3/NO3=0.0
!
!WC_ASO3/N2O5=0.0
!
!WC_ASO3/HONO=0.0
!
!WC_ASO3/HNO3=0.0
!
!WC_ASO3/HNO4=0.0
!
!WC_ASO3/NH3=0.0
!
!WC_ASO3/SO2=0.0
!
!WC_ASO3/SULF=0.0
!
!WC_ASO3/CO=0.0
!
!WC_ASO3/OH=0.0
!
!WC_ASO3/HO2=0.0
!
!WC_ASO3/CH4=0.0
!
!WC_ASO3/ETH=0.0
!
!WC_ASO3/ALKA=0.0
!
!WC_ASO3/ALKE=0.0
!
!WC_ASO3/BIO=0.0
!
!WC_ASO3/ARO=0.0
!
!WC_ASO3/HCHO=0.0
!
!WC_ASO3/ALD=0.0
!
!WC_ASO3/KET=0.0
!
!WC_ASO3/CARBO=0.0
!
!WC_ASO3/ONIT=0.0
!
!WC_ASO3/PAN=0.0
!
!WC_ASO3/OP1=0.0
!
!WC_ASO3/OP2=0.0
!
!WC_ASO3/ORA1=0.0
!
!WC_ASO3/ORA2=0.0
!
!WC_ASO3/MO2=0.0
!
!WC_ASO3/ALKAP=0.0
!
!WC_ASO3/ALKEP=0.0
!
!WC_ASO3/BIOP=0.0
!
!WC_ASO3/PHO=0.0
!
!WC_ASO3/ADD=0.0
!
!WC_ASO3/AROP=0.0
!
!WC_ASO3/CARBOP=0.0
!
!WC_ASO3/OLN=0.0
!
!WC_ASO3/XO2=0.0
!
!WC_ASO3/WC_O3=0.0
!
!WC_ASO3/WC_H2O2=0.0
!
!WC_ASO3/WC_NO=0.0
!
!WC_ASO3/WC_NO2=0.0
!
!WC_ASO3/WC_NO3=+KC16*<WC_SO2>
 PJAC(:,62,46)=+TPK%KC16(:)*PCONC(:,55)
!
!WC_ASO3/WC_N2O5=0.0
!
!WC_ASO3/WC_HONO=0.0
!
!WC_ASO3/WC_HNO3=0.0
!
!WC_ASO3/WC_HNO4=0.0
!
!WC_ASO3/WC_NH3=0.0
!
!WC_ASO3/WC_OH=+KC7*<WC_SO2>
 PJAC(:,62,52)=+TPK%KC7(:)*PCONC(:,55)
!
!WC_ASO3/WC_HO2=0.0
!
!WC_ASO3/WC_CO2=0.0
!
!WC_ASO3/WC_SO2=+KC7*<WC_OH>+KC16*<WC_NO3>+KC18*<WC_MO2>
 PJAC(:,62,55)=+TPK%KC7(:)*PCONC(:,52)+TPK%KC16(:)*PCONC(:,46)+TPK%KC18(:)*PCON&
&C(:,60)
!
!WC_ASO3/WC_SULF=0.0
!
!WC_ASO3/WC_HCHO=0.0
!
!WC_ASO3/WC_ORA1=0.0
!
!WC_ASO3/WC_ORA2=0.0
!
!WC_ASO3/WC_MO2=+KC18*<WC_SO2>
 PJAC(:,62,60)=+TPK%KC18(:)*PCONC(:,55)
!
!WC_ASO3/WC_OP1=0.0
!
!WC_ASO3/WC_ASO3=-KC24*<W_O2>
 PJAC(:,62,62)=-TPK%KC24(:)*TPK%W_O2(:)
!
!WC_ASO3/WC_ASO4=0.0
!
!WC_ASO3/WC_ASO5=0.0
!
!WC_ASO3/WC_AHSO5=0.0
!
!WC_ASO3/WC_AHMS=0.0
!
!WC_ASO3/WR_O3=0.0
!
!WC_ASO3/WR_H2O2=0.0
!
!WC_ASO3/WR_NO=0.0
!
!WC_ASO3/WR_NO2=0.0
!
!WC_ASO3/WR_NO3=0.0
!
!WC_ASO3/WR_N2O5=0.0
!
!WC_ASO3/WR_HONO=0.0
!
!WC_ASO3/WR_HNO3=0.0
!
!WC_ASO3/WR_HNO4=0.0
!
!WC_ASO3/WR_NH3=0.0
!
!WC_ASO3/WR_OH=0.0
!
!WC_ASO3/WR_HO2=0.0
!
!WC_ASO3/WR_CO2=0.0
!
!WC_ASO3/WR_SO2=0.0
!
!WC_ASO3/WR_SULF=0.0
!
!WC_ASO3/WR_HCHO=0.0
!
!WC_ASO3/WR_ORA1=0.0
!
!WC_ASO3/WR_ORA2=0.0
!
!WC_ASO3/WR_MO2=0.0
!
!WC_ASO3/WR_OP1=0.0
!
!WC_ASO3/WR_ASO3=0.0
!
!WC_ASO3/WR_ASO4=0.0
!
!WC_ASO3/WR_ASO5=0.0
!
!WC_ASO3/WR_AHSO5=0.0
!
!WC_ASO3/WR_AHMS=0.0
!
!WC_ASO4/O3=0.0
!
!WC_ASO4/H2O2=0.0
!
!WC_ASO4/NO=0.0
!
!WC_ASO4/NO2=0.0
!
!WC_ASO4/NO3=0.0
!
!WC_ASO4/N2O5=0.0
!
!WC_ASO4/HONO=0.0
!
!WC_ASO4/HNO3=0.0
!
!WC_ASO4/HNO4=0.0
!
!WC_ASO4/NH3=0.0
!
!WC_ASO4/SO2=0.0
!
!WC_ASO4/SULF=0.0
!
!WC_ASO4/CO=0.0
!
!WC_ASO4/OH=0.0
!
!WC_ASO4/HO2=0.0
!
!WC_ASO4/CH4=0.0
!
!WC_ASO4/ETH=0.0
!
!WC_ASO4/ALKA=0.0
!
!WC_ASO4/ALKE=0.0
!
!WC_ASO4/BIO=0.0
!
!WC_ASO4/ARO=0.0
!
!WC_ASO4/HCHO=0.0
!
!WC_ASO4/ALD=0.0
!
!WC_ASO4/KET=0.0
!
!WC_ASO4/CARBO=0.0
!
!WC_ASO4/ONIT=0.0
!
!WC_ASO4/PAN=0.0
!
!WC_ASO4/OP1=0.0
!
!WC_ASO4/OP2=0.0
!
!WC_ASO4/ORA1=0.0
!
!WC_ASO4/ORA2=0.0
!
!WC_ASO4/MO2=0.0
!
!WC_ASO4/ALKAP=0.0
!
!WC_ASO4/ALKEP=0.0
!
!WC_ASO4/BIOP=0.0
!
!WC_ASO4/PHO=0.0
!
!WC_ASO4/ADD=0.0
!
!WC_ASO4/AROP=0.0
!
!WC_ASO4/CARBOP=0.0
!
!WC_ASO4/OLN=0.0
!
!WC_ASO4/XO2=0.0
!
!WC_ASO4/WC_O3=0.0
!
!WC_ASO4/WC_H2O2=0.0
!
!WC_ASO4/WC_NO=0.0
!
!WC_ASO4/WC_NO2=0.0
!
!WC_ASO4/WC_NO3=+KC15*<WC_SULF>
 PJAC(:,63,46)=+TPK%KC15(:)*PCONC(:,56)
!
!WC_ASO4/WC_N2O5=0.0
!
!WC_ASO4/WC_HONO=0.0
!
!WC_ASO4/WC_HNO3=0.0
!
!WC_ASO4/WC_HNO4=0.0
!
!WC_ASO4/WC_NH3=0.0
!
!WC_ASO4/WC_OH=0.0
!
!WC_ASO4/WC_HO2=0.0
!
!WC_ASO4/WC_CO2=0.0
!
!WC_ASO4/WC_SO2=0.0
!
!WC_ASO4/WC_SULF=+KC15*<WC_NO3>
 PJAC(:,63,56)=+TPK%KC15(:)*PCONC(:,46)
!
!WC_ASO4/WC_HCHO=0.0
!
!WC_ASO4/WC_ORA1=0.0
!
!WC_ASO4/WC_ORA2=0.0
!
!WC_ASO4/WC_MO2=0.0
!
!WC_ASO4/WC_OP1=0.0
!
!WC_ASO4/WC_ASO3=0.0
!
!WC_ASO4/WC_ASO4=-KC28
 PJAC(:,63,63)=-TPK%KC28(:)
!
!WC_ASO4/WC_ASO5=+KC26*<WC_ASO5>+KC26*<WC_ASO5>+KC26*<WC_ASO5>+KC26*<WC_ASO5>
 PJAC(:,63,64)=+TPK%KC26(:)*PCONC(:,64)+TPK%KC26(:)*PCONC(:,64)+TPK%KC26(:)*PCO&
&NC(:,64)+TPK%KC26(:)*PCONC(:,64)
!
!WC_ASO4/WC_AHSO5=0.0
!
!WC_ASO4/WC_AHMS=0.0
!
!WC_ASO4/WR_O3=0.0
!
!WC_ASO4/WR_H2O2=0.0
!
!WC_ASO4/WR_NO=0.0
!
!WC_ASO4/WR_NO2=0.0
!
!WC_ASO4/WR_NO3=0.0
!
!WC_ASO4/WR_N2O5=0.0
!
!WC_ASO4/WR_HONO=0.0
!
!WC_ASO4/WR_HNO3=0.0
!
!WC_ASO4/WR_HNO4=0.0
!
!WC_ASO4/WR_NH3=0.0
!
!WC_ASO4/WR_OH=0.0
!
!WC_ASO4/WR_HO2=0.0
!
!WC_ASO4/WR_CO2=0.0
!
!WC_ASO4/WR_SO2=0.0
!
!WC_ASO4/WR_SULF=0.0
!
!WC_ASO4/WR_HCHO=0.0
!
!WC_ASO4/WR_ORA1=0.0
!
!WC_ASO4/WR_ORA2=0.0
!
!WC_ASO4/WR_MO2=0.0
!
!WC_ASO4/WR_OP1=0.0
!
!WC_ASO4/WR_ASO3=0.0
!
!WC_ASO4/WR_ASO4=0.0
!
!WC_ASO4/WR_ASO5=0.0
!
!WC_ASO4/WR_AHSO5=0.0
!
!WC_ASO4/WR_AHMS=0.0
!
!WC_ASO5/O3=0.0
!
!WC_ASO5/H2O2=0.0
!
!WC_ASO5/NO=0.0
!
!WC_ASO5/NO2=0.0
!
!WC_ASO5/NO3=0.0
!
!WC_ASO5/N2O5=0.0
!
!WC_ASO5/HONO=0.0
!
!WC_ASO5/HNO3=0.0
!
!WC_ASO5/HNO4=0.0
!
!WC_ASO5/NH3=0.0
!
!WC_ASO5/SO2=0.0
!
!WC_ASO5/SULF=0.0
!
!WC_ASO5/CO=0.0
!
!WC_ASO5/OH=0.0
!
!WC_ASO5/HO2=0.0
!
!WC_ASO5/CH4=0.0
!
!WC_ASO5/ETH=0.0
!
!WC_ASO5/ALKA=0.0
!
!WC_ASO5/ALKE=0.0
!
!WC_ASO5/BIO=0.0
!
!WC_ASO5/ARO=0.0
!
!WC_ASO5/HCHO=0.0
!
!WC_ASO5/ALD=0.0
!
!WC_ASO5/KET=0.0
!
!WC_ASO5/CARBO=0.0
!
!WC_ASO5/ONIT=0.0
!
!WC_ASO5/PAN=0.0
!
!WC_ASO5/OP1=0.0
!
!WC_ASO5/OP2=0.0
!
!WC_ASO5/ORA1=0.0
!
!WC_ASO5/ORA2=0.0
!
!WC_ASO5/MO2=0.0
!
!WC_ASO5/ALKAP=0.0
!
!WC_ASO5/ALKEP=0.0
!
!WC_ASO5/BIOP=0.0
!
!WC_ASO5/PHO=0.0
!
!WC_ASO5/ADD=0.0
!
!WC_ASO5/AROP=0.0
!
!WC_ASO5/CARBOP=0.0
!
!WC_ASO5/OLN=0.0
!
!WC_ASO5/XO2=0.0
!
!WC_ASO5/WC_O3=0.0
!
!WC_ASO5/WC_H2O2=0.0
!
!WC_ASO5/WC_NO=0.0
!
!WC_ASO5/WC_NO2=0.0
!
!WC_ASO5/WC_NO3=0.0
!
!WC_ASO5/WC_N2O5=0.0
!
!WC_ASO5/WC_HONO=0.0
!
!WC_ASO5/WC_HNO3=0.0
!
!WC_ASO5/WC_HNO4=0.0
!
!WC_ASO5/WC_NH3=0.0
!
!WC_ASO5/WC_OH=0.0
!
!WC_ASO5/WC_HO2=-KC25*<WC_ASO5>
 PJAC(:,64,53)=-TPK%KC25(:)*PCONC(:,64)
!
!WC_ASO5/WC_CO2=0.0
!
!WC_ASO5/WC_SO2=0.0
!
!WC_ASO5/WC_SULF=0.0
!
!WC_ASO5/WC_HCHO=0.0
!
!WC_ASO5/WC_ORA1=0.0
!
!WC_ASO5/WC_ORA2=0.0
!
!WC_ASO5/WC_MO2=0.0
!
!WC_ASO5/WC_OP1=0.0
!
!WC_ASO5/WC_ASO3=+KC24*<W_O2>
 PJAC(:,64,62)=+TPK%KC24(:)*TPK%W_O2(:)
!
!WC_ASO5/WC_ASO4=0.0
!
!WC_ASO5/WC_ASO5=-KC25*<WC_HO2>-KC26*<WC_ASO5>-KC26*<WC_ASO5>-KC26*<WC_ASO5>-KC
!26*<WC_ASO5>
 PJAC(:,64,64)=-TPK%KC25(:)*PCONC(:,53)-TPK%KC26(:)*PCONC(:,64)-TPK%KC26(:)*PCO&
&NC(:,64)-TPK%KC26(:)*PCONC(:,64)-TPK%KC26(:)*PCONC(:,64)
!
!WC_ASO5/WC_AHSO5=0.0
!
!WC_ASO5/WC_AHMS=0.0
!
!WC_ASO5/WR_O3=0.0
!
!WC_ASO5/WR_H2O2=0.0
!
!WC_ASO5/WR_NO=0.0
!
!WC_ASO5/WR_NO2=0.0
!
!WC_ASO5/WR_NO3=0.0
!
!WC_ASO5/WR_N2O5=0.0
!
!WC_ASO5/WR_HONO=0.0
!
!WC_ASO5/WR_HNO3=0.0
!
!WC_ASO5/WR_HNO4=0.0
!
!WC_ASO5/WR_NH3=0.0
!
!WC_ASO5/WR_OH=0.0
!
!WC_ASO5/WR_HO2=0.0
!
!WC_ASO5/WR_CO2=0.0
!
!WC_ASO5/WR_SO2=0.0
!
!WC_ASO5/WR_SULF=0.0
!
!WC_ASO5/WR_HCHO=0.0
!
!WC_ASO5/WR_ORA1=0.0
!
!WC_ASO5/WR_ORA2=0.0
!
!WC_ASO5/WR_MO2=0.0
!
!WC_ASO5/WR_OP1=0.0
!
!WC_ASO5/WR_ASO3=0.0
!
!WC_ASO5/WR_ASO4=0.0
!
!WC_ASO5/WR_ASO5=0.0
!
!WC_ASO5/WR_AHSO5=0.0
!
!WC_ASO5/WR_AHMS=0.0
!
!WC_AHSO5/O3=0.0
!
!WC_AHSO5/H2O2=0.0
!
!WC_AHSO5/NO=0.0
!
!WC_AHSO5/NO2=0.0
!
!WC_AHSO5/NO3=0.0
!
!WC_AHSO5/N2O5=0.0
!
!WC_AHSO5/HONO=0.0
!
!WC_AHSO5/HNO3=0.0
!
!WC_AHSO5/HNO4=0.0
!
!WC_AHSO5/NH3=0.0
!
!WC_AHSO5/SO2=0.0
!
!WC_AHSO5/SULF=0.0
!
!WC_AHSO5/CO=0.0
!
!WC_AHSO5/OH=0.0
!
!WC_AHSO5/HO2=0.0
!
!WC_AHSO5/CH4=0.0
!
!WC_AHSO5/ETH=0.0
!
!WC_AHSO5/ALKA=0.0
!
!WC_AHSO5/ALKE=0.0
!
!WC_AHSO5/BIO=0.0
!
!WC_AHSO5/ARO=0.0
!
!WC_AHSO5/HCHO=0.0
!
!WC_AHSO5/ALD=0.0
!
!WC_AHSO5/KET=0.0
!
!WC_AHSO5/CARBO=0.0
!
!WC_AHSO5/ONIT=0.0
!
!WC_AHSO5/PAN=0.0
!
!WC_AHSO5/OP1=0.0
!
!WC_AHSO5/OP2=0.0
!
!WC_AHSO5/ORA1=0.0
!
!WC_AHSO5/ORA2=0.0
!
!WC_AHSO5/MO2=0.0
!
!WC_AHSO5/ALKAP=0.0
!
!WC_AHSO5/ALKEP=0.0
!
!WC_AHSO5/BIOP=0.0
!
!WC_AHSO5/PHO=0.0
!
!WC_AHSO5/ADD=0.0
!
!WC_AHSO5/AROP=0.0
!
!WC_AHSO5/CARBOP=0.0
!
!WC_AHSO5/OLN=0.0
!
!WC_AHSO5/XO2=0.0
!
!WC_AHSO5/WC_O3=0.0
!
!WC_AHSO5/WC_H2O2=0.0
!
!WC_AHSO5/WC_NO=0.0
!
!WC_AHSO5/WC_NO2=0.0
!
!WC_AHSO5/WC_NO3=0.0
!
!WC_AHSO5/WC_N2O5=0.0
!
!WC_AHSO5/WC_HONO=0.0
!
!WC_AHSO5/WC_HNO3=0.0
!
!WC_AHSO5/WC_HNO4=0.0
!
!WC_AHSO5/WC_NH3=0.0
!
!WC_AHSO5/WC_OH=0.0
!
!WC_AHSO5/WC_HO2=+KC25*<WC_ASO5>
 PJAC(:,65,53)=+TPK%KC25(:)*PCONC(:,64)
!
!WC_AHSO5/WC_CO2=0.0
!
!WC_AHSO5/WC_SO2=-KC27*<WC_AHSO5>
 PJAC(:,65,55)=-TPK%KC27(:)*PCONC(:,65)
!
!WC_AHSO5/WC_SULF=0.0
!
!WC_AHSO5/WC_HCHO=0.0
!
!WC_AHSO5/WC_ORA1=0.0
!
!WC_AHSO5/WC_ORA2=0.0
!
!WC_AHSO5/WC_MO2=0.0
!
!WC_AHSO5/WC_OP1=0.0
!
!WC_AHSO5/WC_ASO3=0.0
!
!WC_AHSO5/WC_ASO4=0.0
!
!WC_AHSO5/WC_ASO5=+KC25*<WC_HO2>
 PJAC(:,65,64)=+TPK%KC25(:)*PCONC(:,53)
!
!WC_AHSO5/WC_AHSO5=-KC27*<WC_SO2>
 PJAC(:,65,65)=-TPK%KC27(:)*PCONC(:,55)
!
!WC_AHSO5/WC_AHMS=0.0
!
!WC_AHSO5/WR_O3=0.0
!
!WC_AHSO5/WR_H2O2=0.0
!
!WC_AHSO5/WR_NO=0.0
!
!WC_AHSO5/WR_NO2=0.0
!
!WC_AHSO5/WR_NO3=0.0
!
!WC_AHSO5/WR_N2O5=0.0
!
!WC_AHSO5/WR_HONO=0.0
!
!WC_AHSO5/WR_HNO3=0.0
!
!WC_AHSO5/WR_HNO4=0.0
!
!WC_AHSO5/WR_NH3=0.0
!
!WC_AHSO5/WR_OH=0.0
!
!WC_AHSO5/WR_HO2=0.0
!
!WC_AHSO5/WR_CO2=0.0
!
!WC_AHSO5/WR_SO2=0.0
!
!WC_AHSO5/WR_SULF=0.0
!
!WC_AHSO5/WR_HCHO=0.0
!
!WC_AHSO5/WR_ORA1=0.0
!
!WC_AHSO5/WR_ORA2=0.0
!
!WC_AHSO5/WR_MO2=0.0
!
!WC_AHSO5/WR_OP1=0.0
!
!WC_AHSO5/WR_ASO3=0.0
!
!WC_AHSO5/WR_ASO4=0.0
!
!WC_AHSO5/WR_ASO5=0.0
!
!WC_AHSO5/WR_AHSO5=0.0
!
!WC_AHSO5/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ12
!
SUBROUTINE SUBJ13
!
!Indices 66 a 70
!
!
!WC_AHMS/O3=0.0
!
!WC_AHMS/H2O2=0.0
!
!WC_AHMS/NO=0.0
!
!WC_AHMS/NO2=0.0
!
!WC_AHMS/NO3=0.0
!
!WC_AHMS/N2O5=0.0
!
!WC_AHMS/HONO=0.0
!
!WC_AHMS/HNO3=0.0
!
!WC_AHMS/HNO4=0.0
!
!WC_AHMS/NH3=0.0
!
!WC_AHMS/SO2=0.0
!
!WC_AHMS/SULF=0.0
!
!WC_AHMS/CO=0.0
!
!WC_AHMS/OH=0.0
!
!WC_AHMS/HO2=0.0
!
!WC_AHMS/CH4=0.0
!
!WC_AHMS/ETH=0.0
!
!WC_AHMS/ALKA=0.0
!
!WC_AHMS/ALKE=0.0
!
!WC_AHMS/BIO=0.0
!
!WC_AHMS/ARO=0.0
!
!WC_AHMS/HCHO=0.0
!
!WC_AHMS/ALD=0.0
!
!WC_AHMS/KET=0.0
!
!WC_AHMS/CARBO=0.0
!
!WC_AHMS/ONIT=0.0
!
!WC_AHMS/PAN=0.0
!
!WC_AHMS/OP1=0.0
!
!WC_AHMS/OP2=0.0
!
!WC_AHMS/ORA1=0.0
!
!WC_AHMS/ORA2=0.0
!
!WC_AHMS/MO2=0.0
!
!WC_AHMS/ALKAP=0.0
!
!WC_AHMS/ALKEP=0.0
!
!WC_AHMS/BIOP=0.0
!
!WC_AHMS/PHO=0.0
!
!WC_AHMS/ADD=0.0
!
!WC_AHMS/AROP=0.0
!
!WC_AHMS/CARBOP=0.0
!
!WC_AHMS/OLN=0.0
!
!WC_AHMS/XO2=0.0
!
!WC_AHMS/WC_O3=0.0
!
!WC_AHMS/WC_H2O2=0.0
!
!WC_AHMS/WC_NO=0.0
!
!WC_AHMS/WC_NO2=0.0
!
!WC_AHMS/WC_NO3=0.0
!
!WC_AHMS/WC_N2O5=0.0
!
!WC_AHMS/WC_HONO=0.0
!
!WC_AHMS/WC_HNO3=0.0
!
!WC_AHMS/WC_HNO4=0.0
!
!WC_AHMS/WC_NH3=0.0
!
!WC_AHMS/WC_OH=-KC23*<WC_AHMS>
 PJAC(:,66,52)=-TPK%KC23(:)*PCONC(:,66)
!
!WC_AHMS/WC_HO2=0.0
!
!WC_AHMS/WC_CO2=0.0
!
!WC_AHMS/WC_SO2=+KC21*<WC_HCHO>
 PJAC(:,66,55)=+TPK%KC21(:)*PCONC(:,57)
!
!WC_AHMS/WC_SULF=0.0
!
!WC_AHMS/WC_HCHO=+KC21*<WC_SO2>
 PJAC(:,66,57)=+TPK%KC21(:)*PCONC(:,55)
!
!WC_AHMS/WC_ORA1=0.0
!
!WC_AHMS/WC_ORA2=0.0
!
!WC_AHMS/WC_MO2=0.0
!
!WC_AHMS/WC_OP1=0.0
!
!WC_AHMS/WC_ASO3=0.0
!
!WC_AHMS/WC_ASO4=0.0
!
!WC_AHMS/WC_ASO5=0.0
!
!WC_AHMS/WC_AHSO5=0.0
!
!WC_AHMS/WC_AHMS=-KC22-KC23*<WC_OH>
 PJAC(:,66,66)=-TPK%KC22(:)-TPK%KC23(:)*PCONC(:,52)
!
!WC_AHMS/WR_O3=0.0
!
!WC_AHMS/WR_H2O2=0.0
!
!WC_AHMS/WR_NO=0.0
!
!WC_AHMS/WR_NO2=0.0
!
!WC_AHMS/WR_NO3=0.0
!
!WC_AHMS/WR_N2O5=0.0
!
!WC_AHMS/WR_HONO=0.0
!
!WC_AHMS/WR_HNO3=0.0
!
!WC_AHMS/WR_HNO4=0.0
!
!WC_AHMS/WR_NH3=0.0
!
!WC_AHMS/WR_OH=0.0
!
!WC_AHMS/WR_HO2=0.0
!
!WC_AHMS/WR_CO2=0.0
!
!WC_AHMS/WR_SO2=0.0
!
!WC_AHMS/WR_SULF=0.0
!
!WC_AHMS/WR_HCHO=0.0
!
!WC_AHMS/WR_ORA1=0.0
!
!WC_AHMS/WR_ORA2=0.0
!
!WC_AHMS/WR_MO2=0.0
!
!WC_AHMS/WR_OP1=0.0
!
!WC_AHMS/WR_ASO3=0.0
!
!WC_AHMS/WR_ASO4=0.0
!
!WC_AHMS/WR_ASO5=0.0
!
!WC_AHMS/WR_AHSO5=0.0
!
!WC_AHMS/WR_AHMS=0.0
!
!WR_O3/O3=+KTR1
 PJAC(:,67,1)=+TPK%KTR1(:)
!
!WR_O3/H2O2=0.0
!
!WR_O3/NO=0.0
!
!WR_O3/NO2=0.0
!
!WR_O3/NO3=0.0
!
!WR_O3/N2O5=0.0
!
!WR_O3/HONO=0.0
!
!WR_O3/HNO3=0.0
!
!WR_O3/HNO4=0.0
!
!WR_O3/NH3=0.0
!
!WR_O3/SO2=0.0
!
!WR_O3/SULF=0.0
!
!WR_O3/CO=0.0
!
!WR_O3/OH=0.0
!
!WR_O3/HO2=0.0
!
!WR_O3/CH4=0.0
!
!WR_O3/ETH=0.0
!
!WR_O3/ALKA=0.0
!
!WR_O3/ALKE=0.0
!
!WR_O3/BIO=0.0
!
!WR_O3/ARO=0.0
!
!WR_O3/HCHO=0.0
!
!WR_O3/ALD=0.0
!
!WR_O3/KET=0.0
!
!WR_O3/CARBO=0.0
!
!WR_O3/ONIT=0.0
!
!WR_O3/PAN=0.0
!
!WR_O3/OP1=0.0
!
!WR_O3/OP2=0.0
!
!WR_O3/ORA1=0.0
!
!WR_O3/ORA2=0.0
!
!WR_O3/MO2=0.0
!
!WR_O3/ALKAP=0.0
!
!WR_O3/ALKEP=0.0
!
!WR_O3/BIOP=0.0
!
!WR_O3/PHO=0.0
!
!WR_O3/ADD=0.0
!
!WR_O3/AROP=0.0
!
!WR_O3/CARBOP=0.0
!
!WR_O3/OLN=0.0
!
!WR_O3/XO2=0.0
!
!WR_O3/WC_O3=0.0
!
!WR_O3/WC_H2O2=0.0
!
!WR_O3/WC_NO=0.0
!
!WR_O3/WC_NO2=0.0
!
!WR_O3/WC_NO3=0.0
!
!WR_O3/WC_N2O5=0.0
!
!WR_O3/WC_HONO=0.0
!
!WR_O3/WC_HNO3=0.0
!
!WR_O3/WC_HNO4=0.0
!
!WR_O3/WC_NH3=0.0
!
!WR_O3/WC_OH=0.0
!
!WR_O3/WC_HO2=0.0
!
!WR_O3/WC_CO2=0.0
!
!WR_O3/WC_SO2=0.0
!
!WR_O3/WC_SULF=0.0
!
!WR_O3/WC_HCHO=0.0
!
!WR_O3/WC_ORA1=0.0
!
!WR_O3/WC_ORA2=0.0
!
!WR_O3/WC_MO2=0.0
!
!WR_O3/WC_OP1=0.0
!
!WR_O3/WC_ASO3=0.0
!
!WR_O3/WC_ASO4=0.0
!
!WR_O3/WC_ASO5=0.0
!
!WR_O3/WC_AHSO5=0.0
!
!WR_O3/WC_AHMS=0.0
!
!WR_O3/WR_O3=-KTR21-KR6*<WR_HO2>-KR29*<WR_SO2>
 PJAC(:,67,67)=-TPK%KTR21(:)-TPK%KR6(:)*PCONC(:,78)-TPK%KR29(:)*PCONC(:,80)
!
!WR_O3/WR_H2O2=0.0
!
!WR_O3/WR_NO=0.0
!
!WR_O3/WR_NO2=0.0
!
!WR_O3/WR_NO3=0.0
!
!WR_O3/WR_N2O5=0.0
!
!WR_O3/WR_HONO=0.0
!
!WR_O3/WR_HNO3=0.0
!
!WR_O3/WR_HNO4=0.0
!
!WR_O3/WR_NH3=0.0
!
!WR_O3/WR_OH=0.0
!
!WR_O3/WR_HO2=-KR6*<WR_O3>
 PJAC(:,67,78)=-TPK%KR6(:)*PCONC(:,67)
!
!WR_O3/WR_CO2=0.0
!
!WR_O3/WR_SO2=-KR29*<WR_O3>
 PJAC(:,67,80)=-TPK%KR29(:)*PCONC(:,67)
!
!WR_O3/WR_SULF=0.0
!
!WR_O3/WR_HCHO=0.0
!
!WR_O3/WR_ORA1=0.0
!
!WR_O3/WR_ORA2=0.0
!
!WR_O3/WR_MO2=0.0
!
!WR_O3/WR_OP1=0.0
!
!WR_O3/WR_ASO3=0.0
!
!WR_O3/WR_ASO4=0.0
!
!WR_O3/WR_ASO5=0.0
!
!WR_O3/WR_AHSO5=0.0
!
!WR_O3/WR_AHMS=0.0
!
!WR_H2O2/O3=0.0
!
!WR_H2O2/H2O2=+KTR2
 PJAC(:,68,2)=+TPK%KTR2(:)
!
!WR_H2O2/NO=0.0
!
!WR_H2O2/NO2=0.0
!
!WR_H2O2/NO3=0.0
!
!WR_H2O2/N2O5=0.0
!
!WR_H2O2/HONO=0.0
!
!WR_H2O2/HNO3=0.0
!
!WR_H2O2/HNO4=0.0
!
!WR_H2O2/NH3=0.0
!
!WR_H2O2/SO2=0.0
!
!WR_H2O2/SULF=0.0
!
!WR_H2O2/CO=0.0
!
!WR_H2O2/OH=0.0
!
!WR_H2O2/HO2=0.0
!
!WR_H2O2/CH4=0.0
!
!WR_H2O2/ETH=0.0
!
!WR_H2O2/ALKA=0.0
!
!WR_H2O2/ALKE=0.0
!
!WR_H2O2/BIO=0.0
!
!WR_H2O2/ARO=0.0
!
!WR_H2O2/HCHO=0.0
!
!WR_H2O2/ALD=0.0
!
!WR_H2O2/KET=0.0
!
!WR_H2O2/CARBO=0.0
!
!WR_H2O2/ONIT=0.0
!
!WR_H2O2/PAN=0.0
!
!WR_H2O2/OP1=0.0
!
!WR_H2O2/OP2=0.0
!
!WR_H2O2/ORA1=0.0
!
!WR_H2O2/ORA2=0.0
!
!WR_H2O2/MO2=0.0
!
!WR_H2O2/ALKAP=0.0
!
!WR_H2O2/ALKEP=0.0
!
!WR_H2O2/BIOP=0.0
!
!WR_H2O2/PHO=0.0
!
!WR_H2O2/ADD=0.0
!
!WR_H2O2/AROP=0.0
!
!WR_H2O2/CARBOP=0.0
!
!WR_H2O2/OLN=0.0
!
!WR_H2O2/XO2=0.0
!
!WR_H2O2/WC_O3=0.0
!
!WR_H2O2/WC_H2O2=0.0
!
!WR_H2O2/WC_NO=0.0
!
!WR_H2O2/WC_NO2=0.0
!
!WR_H2O2/WC_NO3=0.0
!
!WR_H2O2/WC_N2O5=0.0
!
!WR_H2O2/WC_HONO=0.0
!
!WR_H2O2/WC_HNO3=0.0
!
!WR_H2O2/WC_HNO4=0.0
!
!WR_H2O2/WC_NH3=0.0
!
!WR_H2O2/WC_OH=0.0
!
!WR_H2O2/WC_HO2=0.0
!
!WR_H2O2/WC_CO2=0.0
!
!WR_H2O2/WC_SO2=0.0
!
!WR_H2O2/WC_SULF=0.0
!
!WR_H2O2/WC_HCHO=0.0
!
!WR_H2O2/WC_ORA1=0.0
!
!WR_H2O2/WC_ORA2=0.0
!
!WR_H2O2/WC_MO2=0.0
!
!WR_H2O2/WC_OP1=0.0
!
!WR_H2O2/WC_ASO3=0.0
!
!WR_H2O2/WC_ASO4=0.0
!
!WR_H2O2/WC_ASO5=0.0
!
!WR_H2O2/WC_AHSO5=0.0
!
!WR_H2O2/WC_AHMS=0.0
!
!WR_H2O2/WR_O3=0.0
!
!WR_H2O2/WR_H2O2=-KTR22-KR1-KR4*<WR_OH>-KR30*<WR_SO2>
 PJAC(:,68,68)=-TPK%KTR22(:)-TPK%KR1(:)-TPK%KR4(:)*PCONC(:,77)-TPK%KR30(:)*PCON&
&C(:,80)
!
!WR_H2O2/WR_NO=0.0
!
!WR_H2O2/WR_NO2=0.0
!
!WR_H2O2/WR_NO3=0.0
!
!WR_H2O2/WR_N2O5=0.0
!
!WR_H2O2/WR_HONO=0.0
!
!WR_H2O2/WR_HNO3=0.0
!
!WR_H2O2/WR_HNO4=0.0
!
!WR_H2O2/WR_NH3=0.0
!
!WR_H2O2/WR_OH=+KR2*<WR_OH>+KR2*<WR_OH>-KR4*<WR_H2O2>
 PJAC(:,68,77)=+TPK%KR2(:)*PCONC(:,77)+TPK%KR2(:)*PCONC(:,77)-TPK%KR4(:)*PCONC(&
&:,68)
!
!WR_H2O2/WR_HO2=+KR5*<WR_HO2>+KR5*<WR_HO2>
 PJAC(:,68,78)=+TPK%KR5(:)*PCONC(:,78)+TPK%KR5(:)*PCONC(:,78)
!
!WR_H2O2/WR_CO2=0.0
!
!WR_H2O2/WR_SO2=-KR30*<WR_H2O2>
 PJAC(:,68,80)=-TPK%KR30(:)*PCONC(:,68)
!
!WR_H2O2/WR_SULF=0.0
!
!WR_H2O2/WR_HCHO=0.0
!
!WR_H2O2/WR_ORA1=0.0
!
!WR_H2O2/WR_ORA2=0.0
!
!WR_H2O2/WR_MO2=0.0
!
!WR_H2O2/WR_OP1=0.0
!
!WR_H2O2/WR_ASO3=0.0
!
!WR_H2O2/WR_ASO4=0.0
!
!WR_H2O2/WR_ASO5=0.0
!
!WR_H2O2/WR_AHSO5=0.0
!
!WR_H2O2/WR_AHMS=0.0
!
!WR_NO/O3=0.0
!
!WR_NO/H2O2=0.0
!
!WR_NO/NO=+KTR3
 PJAC(:,69,3)=+TPK%KTR3(:)
!
!WR_NO/NO2=0.0
!
!WR_NO/NO3=0.0
!
!WR_NO/N2O5=0.0
!
!WR_NO/HONO=0.0
!
!WR_NO/HNO3=0.0
!
!WR_NO/HNO4=0.0
!
!WR_NO/NH3=0.0
!
!WR_NO/SO2=0.0
!
!WR_NO/SULF=0.0
!
!WR_NO/CO=0.0
!
!WR_NO/OH=0.0
!
!WR_NO/HO2=0.0
!
!WR_NO/CH4=0.0
!
!WR_NO/ETH=0.0
!
!WR_NO/ALKA=0.0
!
!WR_NO/ALKE=0.0
!
!WR_NO/BIO=0.0
!
!WR_NO/ARO=0.0
!
!WR_NO/HCHO=0.0
!
!WR_NO/ALD=0.0
!
!WR_NO/KET=0.0
!
!WR_NO/CARBO=0.0
!
!WR_NO/ONIT=0.0
!
!WR_NO/PAN=0.0
!
!WR_NO/OP1=0.0
!
!WR_NO/OP2=0.0
!
!WR_NO/ORA1=0.0
!
!WR_NO/ORA2=0.0
!
!WR_NO/MO2=0.0
!
!WR_NO/ALKAP=0.0
!
!WR_NO/ALKEP=0.0
!
!WR_NO/BIOP=0.0
!
!WR_NO/PHO=0.0
!
!WR_NO/ADD=0.0
!
!WR_NO/AROP=0.0
!
!WR_NO/CARBOP=0.0
!
!WR_NO/OLN=0.0
!
!WR_NO/XO2=0.0
!
!WR_NO/WC_O3=0.0
!
!WR_NO/WC_H2O2=0.0
!
!WR_NO/WC_NO=0.0
!
!WR_NO/WC_NO2=0.0
!
!WR_NO/WC_NO3=0.0
!
!WR_NO/WC_N2O5=0.0
!
!WR_NO/WC_HONO=0.0
!
!WR_NO/WC_HNO3=0.0
!
!WR_NO/WC_HNO4=0.0
!
!WR_NO/WC_NH3=0.0
!
!WR_NO/WC_OH=0.0
!
!WR_NO/WC_HO2=0.0
!
!WR_NO/WC_CO2=0.0
!
!WR_NO/WC_SO2=0.0
!
!WR_NO/WC_SULF=0.0
!
!WR_NO/WC_HCHO=0.0
!
!WR_NO/WC_ORA1=0.0
!
!WR_NO/WC_ORA2=0.0
!
!WR_NO/WC_MO2=0.0
!
!WR_NO/WC_OP1=0.0
!
!WR_NO/WC_ASO3=0.0
!
!WR_NO/WC_ASO4=0.0
!
!WR_NO/WC_ASO5=0.0
!
!WR_NO/WC_AHSO5=0.0
!
!WR_NO/WC_AHMS=0.0
!
!WR_NO/WR_O3=0.0
!
!WR_NO/WR_H2O2=0.0
!
!WR_NO/WR_NO=-KTR23
 PJAC(:,69,69)=-TPK%KTR23(:)
!
!WR_NO/WR_NO2=0.0
!
!WR_NO/WR_NO3=0.0
!
!WR_NO/WR_N2O5=0.0
!
!WR_NO/WR_HONO=0.0
!
!WR_NO/WR_HNO3=0.0
!
!WR_NO/WR_HNO4=0.0
!
!WR_NO/WR_NH3=0.0
!
!WR_NO/WR_OH=0.0
!
!WR_NO/WR_HO2=0.0
!
!WR_NO/WR_CO2=0.0
!
!WR_NO/WR_SO2=0.0
!
!WR_NO/WR_SULF=0.0
!
!WR_NO/WR_HCHO=0.0
!
!WR_NO/WR_ORA1=0.0
!
!WR_NO/WR_ORA2=0.0
!
!WR_NO/WR_MO2=0.0
!
!WR_NO/WR_OP1=0.0
!
!WR_NO/WR_ASO3=0.0
!
!WR_NO/WR_ASO4=0.0
!
!WR_NO/WR_ASO5=0.0
!
!WR_NO/WR_AHSO5=0.0
!
!WR_NO/WR_AHMS=0.0
!
!WR_NO2/O3=0.0
!
!WR_NO2/H2O2=0.0
!
!WR_NO2/NO=0.0
!
!WR_NO2/NO2=+KTR4
 PJAC(:,70,4)=+TPK%KTR4(:)
!
!WR_NO2/NO3=0.0
!
!WR_NO2/N2O5=0.0
!
!WR_NO2/HONO=0.0
!
!WR_NO2/HNO3=0.0
!
!WR_NO2/HNO4=0.0
!
!WR_NO2/NH3=0.0
!
!WR_NO2/SO2=0.0
!
!WR_NO2/SULF=0.0
!
!WR_NO2/CO=0.0
!
!WR_NO2/OH=0.0
!
!WR_NO2/HO2=0.0
!
!WR_NO2/CH4=0.0
!
!WR_NO2/ETH=0.0
!
!WR_NO2/ALKA=0.0
!
!WR_NO2/ALKE=0.0
!
!WR_NO2/BIO=0.0
!
!WR_NO2/ARO=0.0
!
!WR_NO2/HCHO=0.0
!
!WR_NO2/ALD=0.0
!
!WR_NO2/KET=0.0
!
!WR_NO2/CARBO=0.0
!
!WR_NO2/ONIT=0.0
!
!WR_NO2/PAN=0.0
!
!WR_NO2/OP1=0.0
!
!WR_NO2/OP2=0.0
!
!WR_NO2/ORA1=0.0
!
!WR_NO2/ORA2=0.0
!
!WR_NO2/MO2=0.0
!
!WR_NO2/ALKAP=0.0
!
!WR_NO2/ALKEP=0.0
!
!WR_NO2/BIOP=0.0
!
!WR_NO2/PHO=0.0
!
!WR_NO2/ADD=0.0
!
!WR_NO2/AROP=0.0
!
!WR_NO2/CARBOP=0.0
!
!WR_NO2/OLN=0.0
!
!WR_NO2/XO2=0.0
!
!WR_NO2/WC_O3=0.0
!
!WR_NO2/WC_H2O2=0.0
!
!WR_NO2/WC_NO=0.0
!
!WR_NO2/WC_NO2=0.0
!
!WR_NO2/WC_NO3=0.0
!
!WR_NO2/WC_N2O5=0.0
!
!WR_NO2/WC_HONO=0.0
!
!WR_NO2/WC_HNO3=0.0
!
!WR_NO2/WC_HNO4=0.0
!
!WR_NO2/WC_NH3=0.0
!
!WR_NO2/WC_OH=0.0
!
!WR_NO2/WC_HO2=0.0
!
!WR_NO2/WC_CO2=0.0
!
!WR_NO2/WC_SO2=0.0
!
!WR_NO2/WC_SULF=0.0
!
!WR_NO2/WC_HCHO=0.0
!
!WR_NO2/WC_ORA1=0.0
!
!WR_NO2/WC_ORA2=0.0
!
!WR_NO2/WC_MO2=0.0
!
!WR_NO2/WC_OP1=0.0
!
!WR_NO2/WC_ASO3=0.0
!
!WR_NO2/WC_ASO4=0.0
!
!WR_NO2/WC_ASO5=0.0
!
!WR_NO2/WC_AHSO5=0.0
!
!WR_NO2/WC_AHMS=0.0
!
!WR_NO2/WR_O3=0.0
!
!WR_NO2/WR_H2O2=0.0
!
!WR_NO2/WR_NO=0.0
!
!WR_NO2/WR_NO2=-KTR24-KR9*<WR_HO2>
 PJAC(:,70,70)=-TPK%KTR24(:)-TPK%KR9(:)*PCONC(:,78)
!
!WR_NO2/WR_NO3=0.0
!
!WR_NO2/WR_N2O5=0.0
!
!WR_NO2/WR_HONO=+KR8*<WR_OH>
 PJAC(:,70,73)=+TPK%KR8(:)*PCONC(:,77)
!
!WR_NO2/WR_HNO3=+KR13
 PJAC(:,70,74)=+TPK%KR13(:)
!
!WR_NO2/WR_HNO4=+KR10
 PJAC(:,70,75)=+TPK%KR10(:)
!
!WR_NO2/WR_NH3=0.0
!
!WR_NO2/WR_OH=+KR8*<WR_HONO>
 PJAC(:,70,77)=+TPK%KR8(:)*PCONC(:,73)
!
!WR_NO2/WR_HO2=-KR9*<WR_NO2>
 PJAC(:,70,78)=-TPK%KR9(:)*PCONC(:,70)
!
!WR_NO2/WR_CO2=0.0
!
!WR_NO2/WR_SO2=0.0
!
!WR_NO2/WR_SULF=0.0
!
!WR_NO2/WR_HCHO=0.0
!
!WR_NO2/WR_ORA1=0.0
!
!WR_NO2/WR_ORA2=0.0
!
!WR_NO2/WR_MO2=0.0
!
!WR_NO2/WR_OP1=0.0
!
!WR_NO2/WR_ASO3=0.0
!
!WR_NO2/WR_ASO4=0.0
!
!WR_NO2/WR_ASO5=0.0
!
!WR_NO2/WR_AHSO5=0.0
!
!WR_NO2/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ13
!
SUBROUTINE SUBJ14
!
!Indices 71 a 75
!
!
!WR_NO3/O3=0.0
!
!WR_NO3/H2O2=0.0
!
!WR_NO3/NO=0.0
!
!WR_NO3/NO2=0.0
!
!WR_NO3/NO3=+KTR5
 PJAC(:,71,5)=+TPK%KTR5(:)
!
!WR_NO3/N2O5=0.0
!
!WR_NO3/HONO=0.0
!
!WR_NO3/HNO3=0.0
!
!WR_NO3/HNO4=0.0
!
!WR_NO3/NH3=0.0
!
!WR_NO3/SO2=0.0
!
!WR_NO3/SULF=0.0
!
!WR_NO3/CO=0.0
!
!WR_NO3/OH=0.0
!
!WR_NO3/HO2=0.0
!
!WR_NO3/CH4=0.0
!
!WR_NO3/ETH=0.0
!
!WR_NO3/ALKA=0.0
!
!WR_NO3/ALKE=0.0
!
!WR_NO3/BIO=0.0
!
!WR_NO3/ARO=0.0
!
!WR_NO3/HCHO=0.0
!
!WR_NO3/ALD=0.0
!
!WR_NO3/KET=0.0
!
!WR_NO3/CARBO=0.0
!
!WR_NO3/ONIT=0.0
!
!WR_NO3/PAN=0.0
!
!WR_NO3/OP1=0.0
!
!WR_NO3/OP2=0.0
!
!WR_NO3/ORA1=0.0
!
!WR_NO3/ORA2=0.0
!
!WR_NO3/MO2=0.0
!
!WR_NO3/ALKAP=0.0
!
!WR_NO3/ALKEP=0.0
!
!WR_NO3/BIOP=0.0
!
!WR_NO3/PHO=0.0
!
!WR_NO3/ADD=0.0
!
!WR_NO3/AROP=0.0
!
!WR_NO3/CARBOP=0.0
!
!WR_NO3/OLN=0.0
!
!WR_NO3/XO2=0.0
!
!WR_NO3/WC_O3=0.0
!
!WR_NO3/WC_H2O2=0.0
!
!WR_NO3/WC_NO=0.0
!
!WR_NO3/WC_NO2=0.0
!
!WR_NO3/WC_NO3=0.0
!
!WR_NO3/WC_N2O5=0.0
!
!WR_NO3/WC_HONO=0.0
!
!WR_NO3/WC_HNO3=0.0
!
!WR_NO3/WC_HNO4=0.0
!
!WR_NO3/WC_NH3=0.0
!
!WR_NO3/WC_OH=0.0
!
!WR_NO3/WC_HO2=0.0
!
!WR_NO3/WC_CO2=0.0
!
!WR_NO3/WC_SO2=0.0
!
!WR_NO3/WC_SULF=0.0
!
!WR_NO3/WC_HCHO=0.0
!
!WR_NO3/WC_ORA1=0.0
!
!WR_NO3/WC_ORA2=0.0
!
!WR_NO3/WC_MO2=0.0
!
!WR_NO3/WC_OP1=0.0
!
!WR_NO3/WC_ASO3=0.0
!
!WR_NO3/WC_ASO4=0.0
!
!WR_NO3/WC_ASO5=0.0
!
!WR_NO3/WC_AHSO5=0.0
!
!WR_NO3/WC_AHMS=0.0
!
!WR_NO3/WR_O3=0.0
!
!WR_NO3/WR_H2O2=0.0
!
!WR_NO3/WR_NO=0.0
!
!WR_NO3/WR_NO2=0.0
!
!WR_NO3/WR_NO3=-KTR25-KR15*<WR_SULF>-KR16*<WR_SO2>
 PJAC(:,71,71)=-TPK%KTR25(:)-TPK%KR15(:)*PCONC(:,81)-TPK%KR16(:)*PCONC(:,80)
!
!WR_NO3/WR_N2O5=0.0
!
!WR_NO3/WR_HONO=0.0
!
!WR_NO3/WR_HNO3=0.0
!
!WR_NO3/WR_HNO4=0.0
!
!WR_NO3/WR_NH3=0.0
!
!WR_NO3/WR_OH=0.0
!
!WR_NO3/WR_HO2=0.0
!
!WR_NO3/WR_CO2=0.0
!
!WR_NO3/WR_SO2=-KR16*<WR_NO3>
 PJAC(:,71,80)=-TPK%KR16(:)*PCONC(:,71)
!
!WR_NO3/WR_SULF=-KR15*<WR_NO3>
 PJAC(:,71,81)=-TPK%KR15(:)*PCONC(:,71)
!
!WR_NO3/WR_HCHO=0.0
!
!WR_NO3/WR_ORA1=0.0
!
!WR_NO3/WR_ORA2=0.0
!
!WR_NO3/WR_MO2=0.0
!
!WR_NO3/WR_OP1=0.0
!
!WR_NO3/WR_ASO3=0.0
!
!WR_NO3/WR_ASO4=0.0
!
!WR_NO3/WR_ASO5=0.0
!
!WR_NO3/WR_AHSO5=0.0
!
!WR_NO3/WR_AHMS=0.0
!
!WR_N2O5/O3=0.0
!
!WR_N2O5/H2O2=0.0
!
!WR_N2O5/NO=0.0
!
!WR_N2O5/NO2=0.0
!
!WR_N2O5/NO3=0.0
!
!WR_N2O5/N2O5=+KTR6
 PJAC(:,72,6)=+TPK%KTR6(:)
!
!WR_N2O5/HONO=0.0
!
!WR_N2O5/HNO3=0.0
!
!WR_N2O5/HNO4=0.0
!
!WR_N2O5/NH3=0.0
!
!WR_N2O5/SO2=0.0
!
!WR_N2O5/SULF=0.0
!
!WR_N2O5/CO=0.0
!
!WR_N2O5/OH=0.0
!
!WR_N2O5/HO2=0.0
!
!WR_N2O5/CH4=0.0
!
!WR_N2O5/ETH=0.0
!
!WR_N2O5/ALKA=0.0
!
!WR_N2O5/ALKE=0.0
!
!WR_N2O5/BIO=0.0
!
!WR_N2O5/ARO=0.0
!
!WR_N2O5/HCHO=0.0
!
!WR_N2O5/ALD=0.0
!
!WR_N2O5/KET=0.0
!
!WR_N2O5/CARBO=0.0
!
!WR_N2O5/ONIT=0.0
!
!WR_N2O5/PAN=0.0
!
!WR_N2O5/OP1=0.0
!
!WR_N2O5/OP2=0.0
!
!WR_N2O5/ORA1=0.0
!
!WR_N2O5/ORA2=0.0
!
!WR_N2O5/MO2=0.0
!
!WR_N2O5/ALKAP=0.0
!
!WR_N2O5/ALKEP=0.0
!
!WR_N2O5/BIOP=0.0
!
!WR_N2O5/PHO=0.0
!
!WR_N2O5/ADD=0.0
!
!WR_N2O5/AROP=0.0
!
!WR_N2O5/CARBOP=0.0
!
!WR_N2O5/OLN=0.0
!
!WR_N2O5/XO2=0.0
!
!WR_N2O5/WC_O3=0.0
!
!WR_N2O5/WC_H2O2=0.0
!
!WR_N2O5/WC_NO=0.0
!
!WR_N2O5/WC_NO2=0.0
!
!WR_N2O5/WC_NO3=0.0
!
!WR_N2O5/WC_N2O5=0.0
!
!WR_N2O5/WC_HONO=0.0
!
!WR_N2O5/WC_HNO3=0.0
!
!WR_N2O5/WC_HNO4=0.0
!
!WR_N2O5/WC_NH3=0.0
!
!WR_N2O5/WC_OH=0.0
!
!WR_N2O5/WC_HO2=0.0
!
!WR_N2O5/WC_CO2=0.0
!
!WR_N2O5/WC_SO2=0.0
!
!WR_N2O5/WC_SULF=0.0
!
!WR_N2O5/WC_HCHO=0.0
!
!WR_N2O5/WC_ORA1=0.0
!
!WR_N2O5/WC_ORA2=0.0
!
!WR_N2O5/WC_MO2=0.0
!
!WR_N2O5/WC_OP1=0.0
!
!WR_N2O5/WC_ASO3=0.0
!
!WR_N2O5/WC_ASO4=0.0
!
!WR_N2O5/WC_ASO5=0.0
!
!WR_N2O5/WC_AHSO5=0.0
!
!WR_N2O5/WC_AHMS=0.0
!
!WR_N2O5/WR_O3=0.0
!
!WR_N2O5/WR_H2O2=0.0
!
!WR_N2O5/WR_NO=0.0
!
!WR_N2O5/WR_NO2=0.0
!
!WR_N2O5/WR_NO3=0.0
!
!WR_N2O5/WR_N2O5=-KTR26-KR14
 PJAC(:,72,72)=-TPK%KTR26(:)-TPK%KR14(:)
!
!WR_N2O5/WR_HONO=0.0
!
!WR_N2O5/WR_HNO3=0.0
!
!WR_N2O5/WR_HNO4=0.0
!
!WR_N2O5/WR_NH3=0.0
!
!WR_N2O5/WR_OH=0.0
!
!WR_N2O5/WR_HO2=0.0
!
!WR_N2O5/WR_CO2=0.0
!
!WR_N2O5/WR_SO2=0.0
!
!WR_N2O5/WR_SULF=0.0
!
!WR_N2O5/WR_HCHO=0.0
!
!WR_N2O5/WR_ORA1=0.0
!
!WR_N2O5/WR_ORA2=0.0
!
!WR_N2O5/WR_MO2=0.0
!
!WR_N2O5/WR_OP1=0.0
!
!WR_N2O5/WR_ASO3=0.0
!
!WR_N2O5/WR_ASO4=0.0
!
!WR_N2O5/WR_ASO5=0.0
!
!WR_N2O5/WR_AHSO5=0.0
!
!WR_N2O5/WR_AHMS=0.0
!
!WR_HONO/O3=0.0
!
!WR_HONO/H2O2=0.0
!
!WR_HONO/NO=0.0
!
!WR_HONO/NO2=0.0
!
!WR_HONO/NO3=0.0
!
!WR_HONO/N2O5=0.0
!
!WR_HONO/HONO=+KTR7
 PJAC(:,73,7)=+TPK%KTR7(:)
!
!WR_HONO/HNO3=0.0
!
!WR_HONO/HNO4=0.0
!
!WR_HONO/NH3=0.0
!
!WR_HONO/SO2=0.0
!
!WR_HONO/SULF=0.0
!
!WR_HONO/CO=0.0
!
!WR_HONO/OH=0.0
!
!WR_HONO/HO2=0.0
!
!WR_HONO/CH4=0.0
!
!WR_HONO/ETH=0.0
!
!WR_HONO/ALKA=0.0
!
!WR_HONO/ALKE=0.0
!
!WR_HONO/BIO=0.0
!
!WR_HONO/ARO=0.0
!
!WR_HONO/HCHO=0.0
!
!WR_HONO/ALD=0.0
!
!WR_HONO/KET=0.0
!
!WR_HONO/CARBO=0.0
!
!WR_HONO/ONIT=0.0
!
!WR_HONO/PAN=0.0
!
!WR_HONO/OP1=0.0
!
!WR_HONO/OP2=0.0
!
!WR_HONO/ORA1=0.0
!
!WR_HONO/ORA2=0.0
!
!WR_HONO/MO2=0.0
!
!WR_HONO/ALKAP=0.0
!
!WR_HONO/ALKEP=0.0
!
!WR_HONO/BIOP=0.0
!
!WR_HONO/PHO=0.0
!
!WR_HONO/ADD=0.0
!
!WR_HONO/AROP=0.0
!
!WR_HONO/CARBOP=0.0
!
!WR_HONO/OLN=0.0
!
!WR_HONO/XO2=0.0
!
!WR_HONO/WC_O3=0.0
!
!WR_HONO/WC_H2O2=0.0
!
!WR_HONO/WC_NO=0.0
!
!WR_HONO/WC_NO2=0.0
!
!WR_HONO/WC_NO3=0.0
!
!WR_HONO/WC_N2O5=0.0
!
!WR_HONO/WC_HONO=0.0
!
!WR_HONO/WC_HNO3=0.0
!
!WR_HONO/WC_HNO4=0.0
!
!WR_HONO/WC_NH3=0.0
!
!WR_HONO/WC_OH=0.0
!
!WR_HONO/WC_HO2=0.0
!
!WR_HONO/WC_CO2=0.0
!
!WR_HONO/WC_SO2=0.0
!
!WR_HONO/WC_SULF=0.0
!
!WR_HONO/WC_HCHO=0.0
!
!WR_HONO/WC_ORA1=0.0
!
!WR_HONO/WC_ORA2=0.0
!
!WR_HONO/WC_MO2=0.0
!
!WR_HONO/WC_OP1=0.0
!
!WR_HONO/WC_ASO3=0.0
!
!WR_HONO/WC_ASO4=0.0
!
!WR_HONO/WC_ASO5=0.0
!
!WR_HONO/WC_AHSO5=0.0
!
!WR_HONO/WC_AHMS=0.0
!
!WR_HONO/WR_O3=0.0
!
!WR_HONO/WR_H2O2=0.0
!
!WR_HONO/WR_NO=0.0
!
!WR_HONO/WR_NO2=0.0
!
!WR_HONO/WR_NO3=0.0
!
!WR_HONO/WR_N2O5=0.0
!
!WR_HONO/WR_HONO=-KTR27-KR8*<WR_OH>
 PJAC(:,73,73)=-TPK%KTR27(:)-TPK%KR8(:)*PCONC(:,77)
!
!WR_HONO/WR_HNO3=0.0
!
!WR_HONO/WR_HNO4=+KR11
 PJAC(:,73,75)=+TPK%KR11(:)
!
!WR_HONO/WR_NH3=0.0
!
!WR_HONO/WR_OH=-KR8*<WR_HONO>
 PJAC(:,73,77)=-TPK%KR8(:)*PCONC(:,73)
!
!WR_HONO/WR_HO2=0.0
!
!WR_HONO/WR_CO2=0.0
!
!WR_HONO/WR_SO2=0.0
!
!WR_HONO/WR_SULF=0.0
!
!WR_HONO/WR_HCHO=0.0
!
!WR_HONO/WR_ORA1=0.0
!
!WR_HONO/WR_ORA2=0.0
!
!WR_HONO/WR_MO2=0.0
!
!WR_HONO/WR_OP1=0.0
!
!WR_HONO/WR_ASO3=0.0
!
!WR_HONO/WR_ASO4=0.0
!
!WR_HONO/WR_ASO5=0.0
!
!WR_HONO/WR_AHSO5=0.0
!
!WR_HONO/WR_AHMS=0.0
!
!WR_HNO3/O3=0.0
!
!WR_HNO3/H2O2=0.0
!
!WR_HNO3/NO=0.0
!
!WR_HNO3/NO2=0.0
!
!WR_HNO3/NO3=0.0
!
!WR_HNO3/N2O5=0.0
!
!WR_HNO3/HONO=0.0
!
!WR_HNO3/HNO3=+KTR8
 PJAC(:,74,8)=+TPK%KTR8(:)
!
!WR_HNO3/HNO4=0.0
!
!WR_HNO3/NH3=0.0
!
!WR_HNO3/SO2=0.0
!
!WR_HNO3/SULF=0.0
!
!WR_HNO3/CO=0.0
!
!WR_HNO3/OH=0.0
!
!WR_HNO3/HO2=0.0
!
!WR_HNO3/CH4=0.0
!
!WR_HNO3/ETH=0.0
!
!WR_HNO3/ALKA=0.0
!
!WR_HNO3/ALKE=0.0
!
!WR_HNO3/BIO=0.0
!
!WR_HNO3/ARO=0.0
!
!WR_HNO3/HCHO=0.0
!
!WR_HNO3/ALD=0.0
!
!WR_HNO3/KET=0.0
!
!WR_HNO3/CARBO=0.0
!
!WR_HNO3/ONIT=0.0
!
!WR_HNO3/PAN=0.0
!
!WR_HNO3/OP1=0.0
!
!WR_HNO3/OP2=0.0
!
!WR_HNO3/ORA1=0.0
!
!WR_HNO3/ORA2=0.0
!
!WR_HNO3/MO2=0.0
!
!WR_HNO3/ALKAP=0.0
!
!WR_HNO3/ALKEP=0.0
!
!WR_HNO3/BIOP=0.0
!
!WR_HNO3/PHO=0.0
!
!WR_HNO3/ADD=0.0
!
!WR_HNO3/AROP=0.0
!
!WR_HNO3/CARBOP=0.0
!
!WR_HNO3/OLN=0.0
!
!WR_HNO3/XO2=0.0
!
!WR_HNO3/WC_O3=0.0
!
!WR_HNO3/WC_H2O2=0.0
!
!WR_HNO3/WC_NO=0.0
!
!WR_HNO3/WC_NO2=0.0
!
!WR_HNO3/WC_NO3=0.0
!
!WR_HNO3/WC_N2O5=0.0
!
!WR_HNO3/WC_HONO=0.0
!
!WR_HNO3/WC_HNO3=0.0
!
!WR_HNO3/WC_HNO4=0.0
!
!WR_HNO3/WC_NH3=0.0
!
!WR_HNO3/WC_OH=0.0
!
!WR_HNO3/WC_HO2=0.0
!
!WR_HNO3/WC_CO2=0.0
!
!WR_HNO3/WC_SO2=0.0
!
!WR_HNO3/WC_SULF=0.0
!
!WR_HNO3/WC_HCHO=0.0
!
!WR_HNO3/WC_ORA1=0.0
!
!WR_HNO3/WC_ORA2=0.0
!
!WR_HNO3/WC_MO2=0.0
!
!WR_HNO3/WC_OP1=0.0
!
!WR_HNO3/WC_ASO3=0.0
!
!WR_HNO3/WC_ASO4=0.0
!
!WR_HNO3/WC_ASO5=0.0
!
!WR_HNO3/WC_AHSO5=0.0
!
!WR_HNO3/WC_AHMS=0.0
!
!WR_HNO3/WR_O3=0.0
!
!WR_HNO3/WR_H2O2=0.0
!
!WR_HNO3/WR_NO=0.0
!
!WR_HNO3/WR_NO2=0.0
!
!WR_HNO3/WR_NO3=+KR15*<WR_SULF>+KR16*<WR_SO2>
 PJAC(:,74,71)=+TPK%KR15(:)*PCONC(:,81)+TPK%KR16(:)*PCONC(:,80)
!
!WR_HNO3/WR_N2O5=+KR14+KR14
 PJAC(:,74,72)=+TPK%KR14(:)+TPK%KR14(:)
!
!WR_HNO3/WR_HONO=0.0
!
!WR_HNO3/WR_HNO3=-KTR28-KR13
 PJAC(:,74,74)=-TPK%KTR28(:)-TPK%KR13(:)
!
!WR_HNO3/WR_HNO4=+KR12*<WR_SO2>
 PJAC(:,74,75)=+TPK%KR12(:)*PCONC(:,80)
!
!WR_HNO3/WR_NH3=0.0
!
!WR_HNO3/WR_OH=0.0
!
!WR_HNO3/WR_HO2=0.0
!
!WR_HNO3/WR_CO2=0.0
!
!WR_HNO3/WR_SO2=+KR12*<WR_HNO4>+KR16*<WR_NO3>
 PJAC(:,74,80)=+TPK%KR12(:)*PCONC(:,75)+TPK%KR16(:)*PCONC(:,71)
!
!WR_HNO3/WR_SULF=+KR15*<WR_NO3>
 PJAC(:,74,81)=+TPK%KR15(:)*PCONC(:,71)
!
!WR_HNO3/WR_HCHO=0.0
!
!WR_HNO3/WR_ORA1=0.0
!
!WR_HNO3/WR_ORA2=0.0
!
!WR_HNO3/WR_MO2=0.0
!
!WR_HNO3/WR_OP1=0.0
!
!WR_HNO3/WR_ASO3=0.0
!
!WR_HNO3/WR_ASO4=0.0
!
!WR_HNO3/WR_ASO5=0.0
!
!WR_HNO3/WR_AHSO5=0.0
!
!WR_HNO3/WR_AHMS=0.0
!
!WR_HNO4/O3=0.0
!
!WR_HNO4/H2O2=0.0
!
!WR_HNO4/NO=0.0
!
!WR_HNO4/NO2=0.0
!
!WR_HNO4/NO3=0.0
!
!WR_HNO4/N2O5=0.0
!
!WR_HNO4/HONO=0.0
!
!WR_HNO4/HNO3=0.0
!
!WR_HNO4/HNO4=+KTR9
 PJAC(:,75,9)=+TPK%KTR9(:)
!
!WR_HNO4/NH3=0.0
!
!WR_HNO4/SO2=0.0
!
!WR_HNO4/SULF=0.0
!
!WR_HNO4/CO=0.0
!
!WR_HNO4/OH=0.0
!
!WR_HNO4/HO2=0.0
!
!WR_HNO4/CH4=0.0
!
!WR_HNO4/ETH=0.0
!
!WR_HNO4/ALKA=0.0
!
!WR_HNO4/ALKE=0.0
!
!WR_HNO4/BIO=0.0
!
!WR_HNO4/ARO=0.0
!
!WR_HNO4/HCHO=0.0
!
!WR_HNO4/ALD=0.0
!
!WR_HNO4/KET=0.0
!
!WR_HNO4/CARBO=0.0
!
!WR_HNO4/ONIT=0.0
!
!WR_HNO4/PAN=0.0
!
!WR_HNO4/OP1=0.0
!
!WR_HNO4/OP2=0.0
!
!WR_HNO4/ORA1=0.0
!
!WR_HNO4/ORA2=0.0
!
!WR_HNO4/MO2=0.0
!
!WR_HNO4/ALKAP=0.0
!
!WR_HNO4/ALKEP=0.0
!
!WR_HNO4/BIOP=0.0
!
!WR_HNO4/PHO=0.0
!
!WR_HNO4/ADD=0.0
!
!WR_HNO4/AROP=0.0
!
!WR_HNO4/CARBOP=0.0
!
!WR_HNO4/OLN=0.0
!
!WR_HNO4/XO2=0.0
!
!WR_HNO4/WC_O3=0.0
!
!WR_HNO4/WC_H2O2=0.0
!
!WR_HNO4/WC_NO=0.0
!
!WR_HNO4/WC_NO2=0.0
!
!WR_HNO4/WC_NO3=0.0
!
!WR_HNO4/WC_N2O5=0.0
!
!WR_HNO4/WC_HONO=0.0
!
!WR_HNO4/WC_HNO3=0.0
!
!WR_HNO4/WC_HNO4=0.0
!
!WR_HNO4/WC_NH3=0.0
!
!WR_HNO4/WC_OH=0.0
!
!WR_HNO4/WC_HO2=0.0
!
!WR_HNO4/WC_CO2=0.0
!
!WR_HNO4/WC_SO2=0.0
!
!WR_HNO4/WC_SULF=0.0
!
!WR_HNO4/WC_HCHO=0.0
!
!WR_HNO4/WC_ORA1=0.0
!
!WR_HNO4/WC_ORA2=0.0
!
!WR_HNO4/WC_MO2=0.0
!
!WR_HNO4/WC_OP1=0.0
!
!WR_HNO4/WC_ASO3=0.0
!
!WR_HNO4/WC_ASO4=0.0
!
!WR_HNO4/WC_ASO5=0.0
!
!WR_HNO4/WC_AHSO5=0.0
!
!WR_HNO4/WC_AHMS=0.0
!
!WR_HNO4/WR_O3=0.0
!
!WR_HNO4/WR_H2O2=0.0
!
!WR_HNO4/WR_NO=0.0
!
!WR_HNO4/WR_NO2=+KR9*<WR_HO2>
 PJAC(:,75,70)=+TPK%KR9(:)*PCONC(:,78)
!
!WR_HNO4/WR_NO3=0.0
!
!WR_HNO4/WR_N2O5=0.0
!
!WR_HNO4/WR_HONO=0.0
!
!WR_HNO4/WR_HNO3=0.0
!
!WR_HNO4/WR_HNO4=-KTR29-KR10-KR11-KR12*<WR_SO2>
 PJAC(:,75,75)=-TPK%KTR29(:)-TPK%KR10(:)-TPK%KR11(:)-TPK%KR12(:)*PCONC(:,80)
!
!WR_HNO4/WR_NH3=0.0
!
!WR_HNO4/WR_OH=0.0
!
!WR_HNO4/WR_HO2=+KR9*<WR_NO2>
 PJAC(:,75,78)=+TPK%KR9(:)*PCONC(:,70)
!
!WR_HNO4/WR_CO2=0.0
!
!WR_HNO4/WR_SO2=-KR12*<WR_HNO4>
 PJAC(:,75,80)=-TPK%KR12(:)*PCONC(:,75)
!
!WR_HNO4/WR_SULF=0.0
!
!WR_HNO4/WR_HCHO=0.0
!
!WR_HNO4/WR_ORA1=0.0
!
!WR_HNO4/WR_ORA2=0.0
!
!WR_HNO4/WR_MO2=0.0
!
!WR_HNO4/WR_OP1=0.0
!
!WR_HNO4/WR_ASO3=0.0
!
!WR_HNO4/WR_ASO4=0.0
!
!WR_HNO4/WR_ASO5=0.0
!
!WR_HNO4/WR_AHSO5=0.0
!
!WR_HNO4/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ14
!
SUBROUTINE SUBJ15
!
!Indices 76 a 80
!
!
!WR_NH3/O3=0.0
!
!WR_NH3/H2O2=0.0
!
!WR_NH3/NO=0.0
!
!WR_NH3/NO2=0.0
!
!WR_NH3/NO3=0.0
!
!WR_NH3/N2O5=0.0
!
!WR_NH3/HONO=0.0
!
!WR_NH3/HNO3=0.0
!
!WR_NH3/HNO4=0.0
!
!WR_NH3/NH3=+KTR10
 PJAC(:,76,10)=+TPK%KTR10(:)
!
!WR_NH3/SO2=0.0
!
!WR_NH3/SULF=0.0
!
!WR_NH3/CO=0.0
!
!WR_NH3/OH=0.0
!
!WR_NH3/HO2=0.0
!
!WR_NH3/CH4=0.0
!
!WR_NH3/ETH=0.0
!
!WR_NH3/ALKA=0.0
!
!WR_NH3/ALKE=0.0
!
!WR_NH3/BIO=0.0
!
!WR_NH3/ARO=0.0
!
!WR_NH3/HCHO=0.0
!
!WR_NH3/ALD=0.0
!
!WR_NH3/KET=0.0
!
!WR_NH3/CARBO=0.0
!
!WR_NH3/ONIT=0.0
!
!WR_NH3/PAN=0.0
!
!WR_NH3/OP1=0.0
!
!WR_NH3/OP2=0.0
!
!WR_NH3/ORA1=0.0
!
!WR_NH3/ORA2=0.0
!
!WR_NH3/MO2=0.0
!
!WR_NH3/ALKAP=0.0
!
!WR_NH3/ALKEP=0.0
!
!WR_NH3/BIOP=0.0
!
!WR_NH3/PHO=0.0
!
!WR_NH3/ADD=0.0
!
!WR_NH3/AROP=0.0
!
!WR_NH3/CARBOP=0.0
!
!WR_NH3/OLN=0.0
!
!WR_NH3/XO2=0.0
!
!WR_NH3/WC_O3=0.0
!
!WR_NH3/WC_H2O2=0.0
!
!WR_NH3/WC_NO=0.0
!
!WR_NH3/WC_NO2=0.0
!
!WR_NH3/WC_NO3=0.0
!
!WR_NH3/WC_N2O5=0.0
!
!WR_NH3/WC_HONO=0.0
!
!WR_NH3/WC_HNO3=0.0
!
!WR_NH3/WC_HNO4=0.0
!
!WR_NH3/WC_NH3=0.0
!
!WR_NH3/WC_OH=0.0
!
!WR_NH3/WC_HO2=0.0
!
!WR_NH3/WC_CO2=0.0
!
!WR_NH3/WC_SO2=0.0
!
!WR_NH3/WC_SULF=0.0
!
!WR_NH3/WC_HCHO=0.0
!
!WR_NH3/WC_ORA1=0.0
!
!WR_NH3/WC_ORA2=0.0
!
!WR_NH3/WC_MO2=0.0
!
!WR_NH3/WC_OP1=0.0
!
!WR_NH3/WC_ASO3=0.0
!
!WR_NH3/WC_ASO4=0.0
!
!WR_NH3/WC_ASO5=0.0
!
!WR_NH3/WC_AHSO5=0.0
!
!WR_NH3/WC_AHMS=0.0
!
!WR_NH3/WR_O3=0.0
!
!WR_NH3/WR_H2O2=0.0
!
!WR_NH3/WR_NO=0.0
!
!WR_NH3/WR_NO2=0.0
!
!WR_NH3/WR_NO3=0.0
!
!WR_NH3/WR_N2O5=0.0
!
!WR_NH3/WR_HONO=0.0
!
!WR_NH3/WR_HNO3=0.0
!
!WR_NH3/WR_HNO4=0.0
!
!WR_NH3/WR_NH3=-KTR30
 PJAC(:,76,76)=-TPK%KTR30(:)
!
!WR_NH3/WR_OH=0.0
!
!WR_NH3/WR_HO2=0.0
!
!WR_NH3/WR_CO2=0.0
!
!WR_NH3/WR_SO2=0.0
!
!WR_NH3/WR_SULF=0.0
!
!WR_NH3/WR_HCHO=0.0
!
!WR_NH3/WR_ORA1=0.0
!
!WR_NH3/WR_ORA2=0.0
!
!WR_NH3/WR_MO2=0.0
!
!WR_NH3/WR_OP1=0.0
!
!WR_NH3/WR_ASO3=0.0
!
!WR_NH3/WR_ASO4=0.0
!
!WR_NH3/WR_ASO5=0.0
!
!WR_NH3/WR_AHSO5=0.0
!
!WR_NH3/WR_AHMS=0.0
!
!WR_OH/O3=0.0
!
!WR_OH/H2O2=0.0
!
!WR_OH/NO=0.0
!
!WR_OH/NO2=0.0
!
!WR_OH/NO3=0.0
!
!WR_OH/N2O5=0.0
!
!WR_OH/HONO=0.0
!
!WR_OH/HNO3=0.0
!
!WR_OH/HNO4=0.0
!
!WR_OH/NH3=0.0
!
!WR_OH/SO2=0.0
!
!WR_OH/SULF=0.0
!
!WR_OH/CO=0.0
!
!WR_OH/OH=+KTR11
 PJAC(:,77,14)=+TPK%KTR11(:)
!
!WR_OH/HO2=0.0
!
!WR_OH/CH4=0.0
!
!WR_OH/ETH=0.0
!
!WR_OH/ALKA=0.0
!
!WR_OH/ALKE=0.0
!
!WR_OH/BIO=0.0
!
!WR_OH/ARO=0.0
!
!WR_OH/HCHO=0.0
!
!WR_OH/ALD=0.0
!
!WR_OH/KET=0.0
!
!WR_OH/CARBO=0.0
!
!WR_OH/ONIT=0.0
!
!WR_OH/PAN=0.0
!
!WR_OH/OP1=0.0
!
!WR_OH/OP2=0.0
!
!WR_OH/ORA1=0.0
!
!WR_OH/ORA2=0.0
!
!WR_OH/MO2=0.0
!
!WR_OH/ALKAP=0.0
!
!WR_OH/ALKEP=0.0
!
!WR_OH/BIOP=0.0
!
!WR_OH/PHO=0.0
!
!WR_OH/ADD=0.0
!
!WR_OH/AROP=0.0
!
!WR_OH/CARBOP=0.0
!
!WR_OH/OLN=0.0
!
!WR_OH/XO2=0.0
!
!WR_OH/WC_O3=0.0
!
!WR_OH/WC_H2O2=0.0
!
!WR_OH/WC_NO=0.0
!
!WR_OH/WC_NO2=0.0
!
!WR_OH/WC_NO3=0.0
!
!WR_OH/WC_N2O5=0.0
!
!WR_OH/WC_HONO=0.0
!
!WR_OH/WC_HNO3=0.0
!
!WR_OH/WC_HNO4=0.0
!
!WR_OH/WC_NH3=0.0
!
!WR_OH/WC_OH=0.0
!
!WR_OH/WC_HO2=0.0
!
!WR_OH/WC_CO2=0.0
!
!WR_OH/WC_SO2=0.0
!
!WR_OH/WC_SULF=0.0
!
!WR_OH/WC_HCHO=0.0
!
!WR_OH/WC_ORA1=0.0
!
!WR_OH/WC_ORA2=0.0
!
!WR_OH/WC_MO2=0.0
!
!WR_OH/WC_OP1=0.0
!
!WR_OH/WC_ASO3=0.0
!
!WR_OH/WC_ASO4=0.0
!
!WR_OH/WC_ASO5=0.0
!
!WR_OH/WC_AHSO5=0.0
!
!WR_OH/WC_AHMS=0.0
!
!WR_OH/WR_O3=+KR6*<WR_HO2>
 PJAC(:,77,67)=+TPK%KR6(:)*PCONC(:,78)
!
!WR_OH/WR_H2O2=+KR1+KR1-KR4*<WR_OH>
 PJAC(:,77,68)=+TPK%KR1(:)+TPK%KR1(:)-TPK%KR4(:)*PCONC(:,77)
!
!WR_OH/WR_NO=0.0
!
!WR_OH/WR_NO2=0.0
!
!WR_OH/WR_NO3=0.0
!
!WR_OH/WR_N2O5=0.0
!
!WR_OH/WR_HONO=-KR8*<WR_OH>
 PJAC(:,77,73)=-TPK%KR8(:)*PCONC(:,77)
!
!WR_OH/WR_HNO3=+KR13
 PJAC(:,77,74)=+TPK%KR13(:)
!
!WR_OH/WR_HNO4=0.0
!
!WR_OH/WR_NH3=0.0
!
!WR_OH/WR_OH=-KTR31-KR2*<WR_OH>-KR2*<WR_OH>-KR2*<WR_OH>-KR2*<WR_OH>-KR3*<WR_HO2
!>-KR4*<WR_H2O2>-KR7*<WR_SO2>-KR8*<WR_HONO>-KR19*<WR_HCHO>-KR20*<WR_ORA1>-KR23*
!<WR_AHMS>
 PJAC(:,77,77)=-TPK%KTR31(:)-TPK%KR2(:)*PCONC(:,77)-TPK%KR2(:)*PCONC(:,77)-TPK%&
&KR2(:)*PCONC(:,77)-TPK%KR2(:)*PCONC(:,77)-TPK%KR3(:)*PCONC(:,78)-TPK%KR4(:)*PC&
&ONC(:,68)-TPK%KR7(:)*PCONC(:,80)-TPK%KR8(:)*PCONC(:,73)-TPK%KR19(:)*PCONC(:,82&
&)-TPK%KR20(:)*PCONC(:,83)-TPK%KR23(:)*PCONC(:,91)
!
!WR_OH/WR_HO2=-KR3*<WR_OH>+KR6*<WR_O3>
 PJAC(:,77,78)=-TPK%KR3(:)*PCONC(:,77)+TPK%KR6(:)*PCONC(:,67)
!
!WR_OH/WR_CO2=0.0
!
!WR_OH/WR_SO2=-KR7*<WR_OH>
 PJAC(:,77,80)=-TPK%KR7(:)*PCONC(:,77)
!
!WR_OH/WR_SULF=0.0
!
!WR_OH/WR_HCHO=-KR19*<WR_OH>
 PJAC(:,77,82)=-TPK%KR19(:)*PCONC(:,77)
!
!WR_OH/WR_ORA1=-KR20*<WR_OH>
 PJAC(:,77,83)=-TPK%KR20(:)*PCONC(:,77)
!
!WR_OH/WR_ORA2=0.0
!
!WR_OH/WR_MO2=0.0
!
!WR_OH/WR_OP1=0.0
!
!WR_OH/WR_ASO3=0.0
!
!WR_OH/WR_ASO4=+KR28
 PJAC(:,77,88)=+TPK%KR28(:)
!
!WR_OH/WR_ASO5=0.0
!
!WR_OH/WR_AHSO5=0.0
!
!WR_OH/WR_AHMS=-KR23*<WR_OH>
 PJAC(:,77,91)=-TPK%KR23(:)*PCONC(:,77)
!
!WR_HO2/O3=0.0
!
!WR_HO2/H2O2=0.0
!
!WR_HO2/NO=0.0
!
!WR_HO2/NO2=0.0
!
!WR_HO2/NO3=0.0
!
!WR_HO2/N2O5=0.0
!
!WR_HO2/HONO=0.0
!
!WR_HO2/HNO3=0.0
!
!WR_HO2/HNO4=0.0
!
!WR_HO2/NH3=0.0
!
!WR_HO2/SO2=0.0
!
!WR_HO2/SULF=0.0
!
!WR_HO2/CO=0.0
!
!WR_HO2/OH=0.0
!
!WR_HO2/HO2=+KTR12
 PJAC(:,78,15)=+TPK%KTR12(:)
!
!WR_HO2/CH4=0.0
!
!WR_HO2/ETH=0.0
!
!WR_HO2/ALKA=0.0
!
!WR_HO2/ALKE=0.0
!
!WR_HO2/BIO=0.0
!
!WR_HO2/ARO=0.0
!
!WR_HO2/HCHO=0.0
!
!WR_HO2/ALD=0.0
!
!WR_HO2/KET=0.0
!
!WR_HO2/CARBO=0.0
!
!WR_HO2/ONIT=0.0
!
!WR_HO2/PAN=0.0
!
!WR_HO2/OP1=0.0
!
!WR_HO2/OP2=0.0
!
!WR_HO2/ORA1=0.0
!
!WR_HO2/ORA2=0.0
!
!WR_HO2/MO2=0.0
!
!WR_HO2/ALKAP=0.0
!
!WR_HO2/ALKEP=0.0
!
!WR_HO2/BIOP=0.0
!
!WR_HO2/PHO=0.0
!
!WR_HO2/ADD=0.0
!
!WR_HO2/AROP=0.0
!
!WR_HO2/CARBOP=0.0
!
!WR_HO2/OLN=0.0
!
!WR_HO2/XO2=0.0
!
!WR_HO2/WC_O3=0.0
!
!WR_HO2/WC_H2O2=0.0
!
!WR_HO2/WC_NO=0.0
!
!WR_HO2/WC_NO2=0.0
!
!WR_HO2/WC_NO3=0.0
!
!WR_HO2/WC_N2O5=0.0
!
!WR_HO2/WC_HONO=0.0
!
!WR_HO2/WC_HNO3=0.0
!
!WR_HO2/WC_HNO4=0.0
!
!WR_HO2/WC_NH3=0.0
!
!WR_HO2/WC_OH=0.0
!
!WR_HO2/WC_HO2=0.0
!
!WR_HO2/WC_CO2=0.0
!
!WR_HO2/WC_SO2=0.0
!
!WR_HO2/WC_SULF=0.0
!
!WR_HO2/WC_HCHO=0.0
!
!WR_HO2/WC_ORA1=0.0
!
!WR_HO2/WC_ORA2=0.0
!
!WR_HO2/WC_MO2=0.0
!
!WR_HO2/WC_OP1=0.0
!
!WR_HO2/WC_ASO3=0.0
!
!WR_HO2/WC_ASO4=0.0
!
!WR_HO2/WC_ASO5=0.0
!
!WR_HO2/WC_AHSO5=0.0
!
!WR_HO2/WC_AHMS=0.0
!
!WR_HO2/WR_O3=-KR6*<WR_HO2>
 PJAC(:,78,67)=-TPK%KR6(:)*PCONC(:,78)
!
!WR_HO2/WR_H2O2=+KR4*<WR_OH>
 PJAC(:,78,68)=+TPK%KR4(:)*PCONC(:,77)
!
!WR_HO2/WR_NO=0.0
!
!WR_HO2/WR_NO2=-KR9*<WR_HO2>
 PJAC(:,78,70)=-TPK%KR9(:)*PCONC(:,78)
!
!WR_HO2/WR_NO3=0.0
!
!WR_HO2/WR_N2O5=0.0
!
!WR_HO2/WR_HONO=0.0
!
!WR_HO2/WR_HNO3=0.0
!
!WR_HO2/WR_HNO4=+KR10
 PJAC(:,78,75)=+TPK%KR10(:)
!
!WR_HO2/WR_NH3=0.0
!
!WR_HO2/WR_OH=-KR3*<WR_HO2>+KR4*<WR_H2O2>+KR19*<WR_HCHO>+KR20*<WR_ORA1>+KR23*<W
!R_AHMS>
 PJAC(:,78,77)=-TPK%KR3(:)*PCONC(:,78)+TPK%KR4(:)*PCONC(:,68)+TPK%KR19(:)*PCONC&
&(:,82)+TPK%KR20(:)*PCONC(:,83)+TPK%KR23(:)*PCONC(:,91)
!
!WR_HO2/WR_HO2=-KTR32-KR3*<WR_OH>-KR5*<WR_HO2>-KR5*<WR_HO2>-KR5*<WR_HO2>-KR5*<W
!R_HO2>-KR6*<WR_O3>-KR9*<WR_NO2>-KR25*<WR_ASO5>
 PJAC(:,78,78)=-TPK%KTR32(:)-TPK%KR3(:)*PCONC(:,77)-TPK%KR5(:)*PCONC(:,78)-TPK%&
&KR5(:)*PCONC(:,78)-TPK%KR5(:)*PCONC(:,78)-TPK%KR5(:)*PCONC(:,78)-TPK%KR6(:)*PC&
&ONC(:,67)-TPK%KR9(:)*PCONC(:,70)-TPK%KR25(:)*PCONC(:,89)
!
!WR_HO2/WR_CO2=0.0
!
!WR_HO2/WR_SO2=0.0
!
!WR_HO2/WR_SULF=0.0
!
!WR_HO2/WR_HCHO=+KR19*<WR_OH>
 PJAC(:,78,82)=+TPK%KR19(:)*PCONC(:,77)
!
!WR_HO2/WR_ORA1=+KR20*<WR_OH>
 PJAC(:,78,83)=+TPK%KR20(:)*PCONC(:,77)
!
!WR_HO2/WR_ORA2=0.0
!
!WR_HO2/WR_MO2=+2.00*KR17*<WR_MO2>+2.00*KR17*<WR_MO2>
 PJAC(:,78,85)=+2.00*TPK%KR17(:)*PCONC(:,85)+2.00*TPK%KR17(:)*PCONC(:,85)
!
!WR_HO2/WR_OP1=0.0
!
!WR_HO2/WR_ASO3=0.0
!
!WR_HO2/WR_ASO4=0.0
!
!WR_HO2/WR_ASO5=-KR25*<WR_HO2>
 PJAC(:,78,89)=-TPK%KR25(:)*PCONC(:,78)
!
!WR_HO2/WR_AHSO5=0.0
!
!WR_HO2/WR_AHMS=+KR23*<WR_OH>
 PJAC(:,78,91)=+TPK%KR23(:)*PCONC(:,77)
!
!WR_CO2/O3=0.0
!
!WR_CO2/H2O2=0.0
!
!WR_CO2/NO=0.0
!
!WR_CO2/NO2=0.0
!
!WR_CO2/NO3=0.0
!
!WR_CO2/N2O5=0.0
!
!WR_CO2/HONO=0.0
!
!WR_CO2/HNO3=0.0
!
!WR_CO2/HNO4=0.0
!
!WR_CO2/NH3=0.0
!
!WR_CO2/SO2=0.0
!
!WR_CO2/SULF=0.0
!
!WR_CO2/CO=0.0
!
!WR_CO2/OH=0.0
!
!WR_CO2/HO2=0.0
!
!WR_CO2/CH4=0.0
!
!WR_CO2/ETH=0.0
!
!WR_CO2/ALKA=0.0
!
!WR_CO2/ALKE=0.0
!
!WR_CO2/BIO=0.0
!
!WR_CO2/ARO=0.0
!
!WR_CO2/HCHO=0.0
!
!WR_CO2/ALD=0.0
!
!WR_CO2/KET=0.0
!
!WR_CO2/CARBO=0.0
!
!WR_CO2/ONIT=0.0
!
!WR_CO2/PAN=0.0
!
!WR_CO2/OP1=0.0
!
!WR_CO2/OP2=0.0
!
!WR_CO2/ORA1=0.0
!
!WR_CO2/ORA2=0.0
!
!WR_CO2/MO2=0.0
!
!WR_CO2/ALKAP=0.0
!
!WR_CO2/ALKEP=0.0
!
!WR_CO2/BIOP=0.0
!
!WR_CO2/PHO=0.0
!
!WR_CO2/ADD=0.0
!
!WR_CO2/AROP=0.0
!
!WR_CO2/CARBOP=0.0
!
!WR_CO2/OLN=0.0
!
!WR_CO2/XO2=0.0
!
!WR_CO2/WC_O3=0.0
!
!WR_CO2/WC_H2O2=0.0
!
!WR_CO2/WC_NO=0.0
!
!WR_CO2/WC_NO2=0.0
!
!WR_CO2/WC_NO3=0.0
!
!WR_CO2/WC_N2O5=0.0
!
!WR_CO2/WC_HONO=0.0
!
!WR_CO2/WC_HNO3=0.0
!
!WR_CO2/WC_HNO4=0.0
!
!WR_CO2/WC_NH3=0.0
!
!WR_CO2/WC_OH=0.0
!
!WR_CO2/WC_HO2=0.0
!
!WR_CO2/WC_CO2=0.0
!
!WR_CO2/WC_SO2=0.0
!
!WR_CO2/WC_SULF=0.0
!
!WR_CO2/WC_HCHO=0.0
!
!WR_CO2/WC_ORA1=0.0
!
!WR_CO2/WC_ORA2=0.0
!
!WR_CO2/WC_MO2=0.0
!
!WR_CO2/WC_OP1=0.0
!
!WR_CO2/WC_ASO3=0.0
!
!WR_CO2/WC_ASO4=0.0
!
!WR_CO2/WC_ASO5=0.0
!
!WR_CO2/WC_AHSO5=0.0
!
!WR_CO2/WC_AHMS=0.0
!
!WR_CO2/WR_O3=0.0
!
!WR_CO2/WR_H2O2=0.0
!
!WR_CO2/WR_NO=0.0
!
!WR_CO2/WR_NO2=0.0
!
!WR_CO2/WR_NO3=0.0
!
!WR_CO2/WR_N2O5=0.0
!
!WR_CO2/WR_HONO=0.0
!
!WR_CO2/WR_HNO3=0.0
!
!WR_CO2/WR_HNO4=0.0
!
!WR_CO2/WR_NH3=0.0
!
!WR_CO2/WR_OH=+KR20*<WR_ORA1>
 PJAC(:,79,77)=+TPK%KR20(:)*PCONC(:,83)
!
!WR_CO2/WR_HO2=0.0
!
!WR_CO2/WR_CO2=-KTR33
 PJAC(:,79,79)=-TPK%KTR33(:)
!
!WR_CO2/WR_SO2=0.0
!
!WR_CO2/WR_SULF=0.0
!
!WR_CO2/WR_HCHO=0.0
!
!WR_CO2/WR_ORA1=+KR20*<WR_OH>
 PJAC(:,79,83)=+TPK%KR20(:)*PCONC(:,77)
!
!WR_CO2/WR_ORA2=0.0
!
!WR_CO2/WR_MO2=0.0
!
!WR_CO2/WR_OP1=0.0
!
!WR_CO2/WR_ASO3=0.0
!
!WR_CO2/WR_ASO4=0.0
!
!WR_CO2/WR_ASO5=0.0
!
!WR_CO2/WR_AHSO5=0.0
!
!WR_CO2/WR_AHMS=0.0
!
!WR_SO2/O3=0.0
!
!WR_SO2/H2O2=0.0
!
!WR_SO2/NO=0.0
!
!WR_SO2/NO2=0.0
!
!WR_SO2/NO3=0.0
!
!WR_SO2/N2O5=0.0
!
!WR_SO2/HONO=0.0
!
!WR_SO2/HNO3=0.0
!
!WR_SO2/HNO4=0.0
!
!WR_SO2/NH3=0.0
!
!WR_SO2/SO2=+KTR14
 PJAC(:,80,11)=+TPK%KTR14(:)
!
!WR_SO2/SULF=0.0
!
!WR_SO2/CO=0.0
!
!WR_SO2/OH=0.0
!
!WR_SO2/HO2=0.0
!
!WR_SO2/CH4=0.0
!
!WR_SO2/ETH=0.0
!
!WR_SO2/ALKA=0.0
!
!WR_SO2/ALKE=0.0
!
!WR_SO2/BIO=0.0
!
!WR_SO2/ARO=0.0
!
!WR_SO2/HCHO=0.0
!
!WR_SO2/ALD=0.0
!
!WR_SO2/KET=0.0
!
!WR_SO2/CARBO=0.0
!
!WR_SO2/ONIT=0.0
!
!WR_SO2/PAN=0.0
!
!WR_SO2/OP1=0.0
!
!WR_SO2/OP2=0.0
!
!WR_SO2/ORA1=0.0
!
!WR_SO2/ORA2=0.0
!
!WR_SO2/MO2=0.0
!
!WR_SO2/ALKAP=0.0
!
!WR_SO2/ALKEP=0.0
!
!WR_SO2/BIOP=0.0
!
!WR_SO2/PHO=0.0
!
!WR_SO2/ADD=0.0
!
!WR_SO2/AROP=0.0
!
!WR_SO2/CARBOP=0.0
!
!WR_SO2/OLN=0.0
!
!WR_SO2/XO2=0.0
!
!WR_SO2/WC_O3=0.0
!
!WR_SO2/WC_H2O2=0.0
!
!WR_SO2/WC_NO=0.0
!
!WR_SO2/WC_NO2=0.0
!
!WR_SO2/WC_NO3=0.0
!
!WR_SO2/WC_N2O5=0.0
!
!WR_SO2/WC_HONO=0.0
!
!WR_SO2/WC_HNO3=0.0
!
!WR_SO2/WC_HNO4=0.0
!
!WR_SO2/WC_NH3=0.0
!
!WR_SO2/WC_OH=0.0
!
!WR_SO2/WC_HO2=0.0
!
!WR_SO2/WC_CO2=0.0
!
!WR_SO2/WC_SO2=0.0
!
!WR_SO2/WC_SULF=0.0
!
!WR_SO2/WC_HCHO=0.0
!
!WR_SO2/WC_ORA1=0.0
!
!WR_SO2/WC_ORA2=0.0
!
!WR_SO2/WC_MO2=0.0
!
!WR_SO2/WC_OP1=0.0
!
!WR_SO2/WC_ASO3=0.0
!
!WR_SO2/WC_ASO4=0.0
!
!WR_SO2/WC_ASO5=0.0
!
!WR_SO2/WC_AHSO5=0.0
!
!WR_SO2/WC_AHMS=0.0
!
!WR_SO2/WR_O3=-KR29*<WR_SO2>
 PJAC(:,80,67)=-TPK%KR29(:)*PCONC(:,80)
!
!WR_SO2/WR_H2O2=-KR30*<WR_SO2>
 PJAC(:,80,68)=-TPK%KR30(:)*PCONC(:,80)
!
!WR_SO2/WR_NO=0.0
!
!WR_SO2/WR_NO2=0.0
!
!WR_SO2/WR_NO3=-KR16*<WR_SO2>
 PJAC(:,80,71)=-TPK%KR16(:)*PCONC(:,80)
!
!WR_SO2/WR_N2O5=0.0
!
!WR_SO2/WR_HONO=0.0
!
!WR_SO2/WR_HNO3=0.0
!
!WR_SO2/WR_HNO4=-KR12*<WR_SO2>
 PJAC(:,80,75)=-TPK%KR12(:)*PCONC(:,80)
!
!WR_SO2/WR_NH3=0.0
!
!WR_SO2/WR_OH=-KR7*<WR_SO2>+KR23*<WR_AHMS>
 PJAC(:,80,77)=-TPK%KR7(:)*PCONC(:,80)+TPK%KR23(:)*PCONC(:,91)
!
!WR_SO2/WR_HO2=0.0
!
!WR_SO2/WR_CO2=0.0
!
!WR_SO2/WR_SO2=-KTR34-KR7*<WR_OH>-KR12*<WR_HNO4>-KR16*<WR_NO3>-KR18*<WR_MO2>-KR
!21*<WR_HCHO>-KR27*<WR_AHSO5>-KR29*<WR_O3>-KR30*<WR_H2O2>
 PJAC(:,80,80)=-TPK%KTR34(:)-TPK%KR7(:)*PCONC(:,77)-TPK%KR12(:)*PCONC(:,75)-TPK&
&%KR16(:)*PCONC(:,71)-TPK%KR18(:)*PCONC(:,85)-TPK%KR21(:)*PCONC(:,82)-TPK%KR27(&
&:)*PCONC(:,90)-TPK%KR29(:)*PCONC(:,67)-TPK%KR30(:)*PCONC(:,68)
!
!WR_SO2/WR_SULF=0.0
!
!WR_SO2/WR_HCHO=-KR21*<WR_SO2>
 PJAC(:,80,82)=-TPK%KR21(:)*PCONC(:,80)
!
!WR_SO2/WR_ORA1=0.0
!
!WR_SO2/WR_ORA2=0.0
!
!WR_SO2/WR_MO2=-KR18*<WR_SO2>
 PJAC(:,80,85)=-TPK%KR18(:)*PCONC(:,80)
!
!WR_SO2/WR_OP1=0.0
!
!WR_SO2/WR_ASO3=0.0
!
!WR_SO2/WR_ASO4=0.0
!
!WR_SO2/WR_ASO5=0.0
!
!WR_SO2/WR_AHSO5=-KR27*<WR_SO2>
 PJAC(:,80,90)=-TPK%KR27(:)*PCONC(:,80)
!
!WR_SO2/WR_AHMS=+KR22+KR23*<WR_OH>
 PJAC(:,80,91)=+TPK%KR22(:)+TPK%KR23(:)*PCONC(:,77)
!
RETURN
END SUBROUTINE SUBJ15
!
SUBROUTINE SUBJ16
!
!Indices 81 a 85
!
!
!WR_SULF/O3=0.0
!
!WR_SULF/H2O2=0.0
!
!WR_SULF/NO=0.0
!
!WR_SULF/NO2=0.0
!
!WR_SULF/NO3=0.0
!
!WR_SULF/N2O5=0.0
!
!WR_SULF/HONO=0.0
!
!WR_SULF/HNO3=0.0
!
!WR_SULF/HNO4=0.0
!
!WR_SULF/NH3=0.0
!
!WR_SULF/SO2=0.0
!
!WR_SULF/SULF=+KTR15
 PJAC(:,81,12)=+TPK%KTR15(:)
!
!WR_SULF/CO=0.0
!
!WR_SULF/OH=0.0
!
!WR_SULF/HO2=0.0
!
!WR_SULF/CH4=0.0
!
!WR_SULF/ETH=0.0
!
!WR_SULF/ALKA=0.0
!
!WR_SULF/ALKE=0.0
!
!WR_SULF/BIO=0.0
!
!WR_SULF/ARO=0.0
!
!WR_SULF/HCHO=0.0
!
!WR_SULF/ALD=0.0
!
!WR_SULF/KET=0.0
!
!WR_SULF/CARBO=0.0
!
!WR_SULF/ONIT=0.0
!
!WR_SULF/PAN=0.0
!
!WR_SULF/OP1=0.0
!
!WR_SULF/OP2=0.0
!
!WR_SULF/ORA1=0.0
!
!WR_SULF/ORA2=0.0
!
!WR_SULF/MO2=0.0
!
!WR_SULF/ALKAP=0.0
!
!WR_SULF/ALKEP=0.0
!
!WR_SULF/BIOP=0.0
!
!WR_SULF/PHO=0.0
!
!WR_SULF/ADD=0.0
!
!WR_SULF/AROP=0.0
!
!WR_SULF/CARBOP=0.0
!
!WR_SULF/OLN=0.0
!
!WR_SULF/XO2=0.0
!
!WR_SULF/WC_O3=0.0
!
!WR_SULF/WC_H2O2=0.0
!
!WR_SULF/WC_NO=0.0
!
!WR_SULF/WC_NO2=0.0
!
!WR_SULF/WC_NO3=0.0
!
!WR_SULF/WC_N2O5=0.0
!
!WR_SULF/WC_HONO=0.0
!
!WR_SULF/WC_HNO3=0.0
!
!WR_SULF/WC_HNO4=0.0
!
!WR_SULF/WC_NH3=0.0
!
!WR_SULF/WC_OH=0.0
!
!WR_SULF/WC_HO2=0.0
!
!WR_SULF/WC_CO2=0.0
!
!WR_SULF/WC_SO2=0.0
!
!WR_SULF/WC_SULF=0.0
!
!WR_SULF/WC_HCHO=0.0
!
!WR_SULF/WC_ORA1=0.0
!
!WR_SULF/WC_ORA2=0.0
!
!WR_SULF/WC_MO2=0.0
!
!WR_SULF/WC_OP1=0.0
!
!WR_SULF/WC_ASO3=0.0
!
!WR_SULF/WC_ASO4=0.0
!
!WR_SULF/WC_ASO5=0.0
!
!WR_SULF/WC_AHSO5=0.0
!
!WR_SULF/WC_AHMS=0.0
!
!WR_SULF/WR_O3=+KR29*<WR_SO2>
 PJAC(:,81,67)=+TPK%KR29(:)*PCONC(:,80)
!
!WR_SULF/WR_H2O2=+KR30*<WR_SO2>
 PJAC(:,81,68)=+TPK%KR30(:)*PCONC(:,80)
!
!WR_SULF/WR_NO=0.0
!
!WR_SULF/WR_NO2=0.0
!
!WR_SULF/WR_NO3=-KR15*<WR_SULF>
 PJAC(:,81,71)=-TPK%KR15(:)*PCONC(:,81)
!
!WR_SULF/WR_N2O5=0.0
!
!WR_SULF/WR_HONO=0.0
!
!WR_SULF/WR_HNO3=0.0
!
!WR_SULF/WR_HNO4=+KR12*<WR_SO2>
 PJAC(:,81,75)=+TPK%KR12(:)*PCONC(:,80)
!
!WR_SULF/WR_NH3=0.0
!
!WR_SULF/WR_OH=0.0
!
!WR_SULF/WR_HO2=0.0
!
!WR_SULF/WR_CO2=0.0
!
!WR_SULF/WR_SO2=+KR12*<WR_HNO4>+2.00*KR27*<WR_AHSO5>+KR29*<WR_O3>+KR30*<WR_H2O2
!>
 PJAC(:,81,80)=+TPK%KR12(:)*PCONC(:,75)+2.00*TPK%KR27(:)*PCONC(:,90)+TPK%KR29(:&
&)*PCONC(:,67)+TPK%KR30(:)*PCONC(:,68)
!
!WR_SULF/WR_SULF=-KTR35-KR15*<WR_NO3>
 PJAC(:,81,81)=-TPK%KTR35(:)-TPK%KR15(:)*PCONC(:,71)
!
!WR_SULF/WR_HCHO=0.0
!
!WR_SULF/WR_ORA1=0.0
!
!WR_SULF/WR_ORA2=0.0
!
!WR_SULF/WR_MO2=0.0
!
!WR_SULF/WR_OP1=0.0
!
!WR_SULF/WR_ASO3=0.0
!
!WR_SULF/WR_ASO4=+KR28
 PJAC(:,81,88)=+TPK%KR28(:)
!
!WR_SULF/WR_ASO5=0.0
!
!WR_SULF/WR_AHSO5=+2.00*KR27*<WR_SO2>
 PJAC(:,81,90)=+2.00*TPK%KR27(:)*PCONC(:,80)
!
!WR_SULF/WR_AHMS=0.0
!
!WR_HCHO/O3=0.0
!
!WR_HCHO/H2O2=0.0
!
!WR_HCHO/NO=0.0
!
!WR_HCHO/NO2=0.0
!
!WR_HCHO/NO3=0.0
!
!WR_HCHO/N2O5=0.0
!
!WR_HCHO/HONO=0.0
!
!WR_HCHO/HNO3=0.0
!
!WR_HCHO/HNO4=0.0
!
!WR_HCHO/NH3=0.0
!
!WR_HCHO/SO2=0.0
!
!WR_HCHO/SULF=0.0
!
!WR_HCHO/CO=0.0
!
!WR_HCHO/OH=0.0
!
!WR_HCHO/HO2=0.0
!
!WR_HCHO/CH4=0.0
!
!WR_HCHO/ETH=0.0
!
!WR_HCHO/ALKA=0.0
!
!WR_HCHO/ALKE=0.0
!
!WR_HCHO/BIO=0.0
!
!WR_HCHO/ARO=0.0
!
!WR_HCHO/HCHO=+KTR16
 PJAC(:,82,22)=+TPK%KTR16(:)
!
!WR_HCHO/ALD=0.0
!
!WR_HCHO/KET=0.0
!
!WR_HCHO/CARBO=0.0
!
!WR_HCHO/ONIT=0.0
!
!WR_HCHO/PAN=0.0
!
!WR_HCHO/OP1=0.0
!
!WR_HCHO/OP2=0.0
!
!WR_HCHO/ORA1=0.0
!
!WR_HCHO/ORA2=0.0
!
!WR_HCHO/MO2=0.0
!
!WR_HCHO/ALKAP=0.0
!
!WR_HCHO/ALKEP=0.0
!
!WR_HCHO/BIOP=0.0
!
!WR_HCHO/PHO=0.0
!
!WR_HCHO/ADD=0.0
!
!WR_HCHO/AROP=0.0
!
!WR_HCHO/CARBOP=0.0
!
!WR_HCHO/OLN=0.0
!
!WR_HCHO/XO2=0.0
!
!WR_HCHO/WC_O3=0.0
!
!WR_HCHO/WC_H2O2=0.0
!
!WR_HCHO/WC_NO=0.0
!
!WR_HCHO/WC_NO2=0.0
!
!WR_HCHO/WC_NO3=0.0
!
!WR_HCHO/WC_N2O5=0.0
!
!WR_HCHO/WC_HONO=0.0
!
!WR_HCHO/WC_HNO3=0.0
!
!WR_HCHO/WC_HNO4=0.0
!
!WR_HCHO/WC_NH3=0.0
!
!WR_HCHO/WC_OH=0.0
!
!WR_HCHO/WC_HO2=0.0
!
!WR_HCHO/WC_CO2=0.0
!
!WR_HCHO/WC_SO2=0.0
!
!WR_HCHO/WC_SULF=0.0
!
!WR_HCHO/WC_HCHO=0.0
!
!WR_HCHO/WC_ORA1=0.0
!
!WR_HCHO/WC_ORA2=0.0
!
!WR_HCHO/WC_MO2=0.0
!
!WR_HCHO/WC_OP1=0.0
!
!WR_HCHO/WC_ASO3=0.0
!
!WR_HCHO/WC_ASO4=0.0
!
!WR_HCHO/WC_ASO5=0.0
!
!WR_HCHO/WC_AHSO5=0.0
!
!WR_HCHO/WC_AHMS=0.0
!
!WR_HCHO/WR_O3=0.0
!
!WR_HCHO/WR_H2O2=0.0
!
!WR_HCHO/WR_NO=0.0
!
!WR_HCHO/WR_NO2=0.0
!
!WR_HCHO/WR_NO3=0.0
!
!WR_HCHO/WR_N2O5=0.0
!
!WR_HCHO/WR_HONO=0.0
!
!WR_HCHO/WR_HNO3=0.0
!
!WR_HCHO/WR_HNO4=0.0
!
!WR_HCHO/WR_NH3=0.0
!
!WR_HCHO/WR_OH=-KR19*<WR_HCHO>
 PJAC(:,82,77)=-TPK%KR19(:)*PCONC(:,82)
!
!WR_HCHO/WR_HO2=0.0
!
!WR_HCHO/WR_CO2=0.0
!
!WR_HCHO/WR_SO2=-KR21*<WR_HCHO>
 PJAC(:,82,80)=-TPK%KR21(:)*PCONC(:,82)
!
!WR_HCHO/WR_SULF=0.0
!
!WR_HCHO/WR_HCHO=-KTR36-KR19*<WR_OH>-KR21*<WR_SO2>
 PJAC(:,82,82)=-TPK%KTR36(:)-TPK%KR19(:)*PCONC(:,77)-TPK%KR21(:)*PCONC(:,80)
!
!WR_HCHO/WR_ORA1=0.0
!
!WR_HCHO/WR_ORA2=0.0
!
!WR_HCHO/WR_MO2=+2.00*KR17*<WR_MO2>+2.00*KR17*<WR_MO2>
 PJAC(:,82,85)=+2.00*TPK%KR17(:)*PCONC(:,85)+2.00*TPK%KR17(:)*PCONC(:,85)
!
!WR_HCHO/WR_OP1=0.0
!
!WR_HCHO/WR_ASO3=0.0
!
!WR_HCHO/WR_ASO4=0.0
!
!WR_HCHO/WR_ASO5=0.0
!
!WR_HCHO/WR_AHSO5=0.0
!
!WR_HCHO/WR_AHMS=+KR22
 PJAC(:,82,91)=+TPK%KR22(:)
!
!WR_ORA1/O3=0.0
!
!WR_ORA1/H2O2=0.0
!
!WR_ORA1/NO=0.0
!
!WR_ORA1/NO2=0.0
!
!WR_ORA1/NO3=0.0
!
!WR_ORA1/N2O5=0.0
!
!WR_ORA1/HONO=0.0
!
!WR_ORA1/HNO3=0.0
!
!WR_ORA1/HNO4=0.0
!
!WR_ORA1/NH3=0.0
!
!WR_ORA1/SO2=0.0
!
!WR_ORA1/SULF=0.0
!
!WR_ORA1/CO=0.0
!
!WR_ORA1/OH=0.0
!
!WR_ORA1/HO2=0.0
!
!WR_ORA1/CH4=0.0
!
!WR_ORA1/ETH=0.0
!
!WR_ORA1/ALKA=0.0
!
!WR_ORA1/ALKE=0.0
!
!WR_ORA1/BIO=0.0
!
!WR_ORA1/ARO=0.0
!
!WR_ORA1/HCHO=0.0
!
!WR_ORA1/ALD=0.0
!
!WR_ORA1/KET=0.0
!
!WR_ORA1/CARBO=0.0
!
!WR_ORA1/ONIT=0.0
!
!WR_ORA1/PAN=0.0
!
!WR_ORA1/OP1=0.0
!
!WR_ORA1/OP2=0.0
!
!WR_ORA1/ORA1=+KTR17
 PJAC(:,83,30)=+TPK%KTR17(:)
!
!WR_ORA1/ORA2=0.0
!
!WR_ORA1/MO2=0.0
!
!WR_ORA1/ALKAP=0.0
!
!WR_ORA1/ALKEP=0.0
!
!WR_ORA1/BIOP=0.0
!
!WR_ORA1/PHO=0.0
!
!WR_ORA1/ADD=0.0
!
!WR_ORA1/AROP=0.0
!
!WR_ORA1/CARBOP=0.0
!
!WR_ORA1/OLN=0.0
!
!WR_ORA1/XO2=0.0
!
!WR_ORA1/WC_O3=0.0
!
!WR_ORA1/WC_H2O2=0.0
!
!WR_ORA1/WC_NO=0.0
!
!WR_ORA1/WC_NO2=0.0
!
!WR_ORA1/WC_NO3=0.0
!
!WR_ORA1/WC_N2O5=0.0
!
!WR_ORA1/WC_HONO=0.0
!
!WR_ORA1/WC_HNO3=0.0
!
!WR_ORA1/WC_HNO4=0.0
!
!WR_ORA1/WC_NH3=0.0
!
!WR_ORA1/WC_OH=0.0
!
!WR_ORA1/WC_HO2=0.0
!
!WR_ORA1/WC_CO2=0.0
!
!WR_ORA1/WC_SO2=0.0
!
!WR_ORA1/WC_SULF=0.0
!
!WR_ORA1/WC_HCHO=0.0
!
!WR_ORA1/WC_ORA1=0.0
!
!WR_ORA1/WC_ORA2=0.0
!
!WR_ORA1/WC_MO2=0.0
!
!WR_ORA1/WC_OP1=0.0
!
!WR_ORA1/WC_ASO3=0.0
!
!WR_ORA1/WC_ASO4=0.0
!
!WR_ORA1/WC_ASO5=0.0
!
!WR_ORA1/WC_AHSO5=0.0
!
!WR_ORA1/WC_AHMS=0.0
!
!WR_ORA1/WR_O3=0.0
!
!WR_ORA1/WR_H2O2=0.0
!
!WR_ORA1/WR_NO=0.0
!
!WR_ORA1/WR_NO2=0.0
!
!WR_ORA1/WR_NO3=0.0
!
!WR_ORA1/WR_N2O5=0.0
!
!WR_ORA1/WR_HONO=0.0
!
!WR_ORA1/WR_HNO3=0.0
!
!WR_ORA1/WR_HNO4=0.0
!
!WR_ORA1/WR_NH3=0.0
!
!WR_ORA1/WR_OH=+KR19*<WR_HCHO>-KR20*<WR_ORA1>+KR23*<WR_AHMS>
 PJAC(:,83,77)=+TPK%KR19(:)*PCONC(:,82)-TPK%KR20(:)*PCONC(:,83)+TPK%KR23(:)*PCO&
&NC(:,91)
!
!WR_ORA1/WR_HO2=0.0
!
!WR_ORA1/WR_CO2=0.0
!
!WR_ORA1/WR_SO2=0.0
!
!WR_ORA1/WR_SULF=0.0
!
!WR_ORA1/WR_HCHO=+KR19*<WR_OH>
 PJAC(:,83,82)=+TPK%KR19(:)*PCONC(:,77)
!
!WR_ORA1/WR_ORA1=-KTR37-KR20*<WR_OH>
 PJAC(:,83,83)=-TPK%KTR37(:)-TPK%KR20(:)*PCONC(:,77)
!
!WR_ORA1/WR_ORA2=0.0
!
!WR_ORA1/WR_MO2=0.0
!
!WR_ORA1/WR_OP1=0.0
!
!WR_ORA1/WR_ASO3=0.0
!
!WR_ORA1/WR_ASO4=0.0
!
!WR_ORA1/WR_ASO5=0.0
!
!WR_ORA1/WR_AHSO5=0.0
!
!WR_ORA1/WR_AHMS=+KR23*<WR_OH>
 PJAC(:,83,91)=+TPK%KR23(:)*PCONC(:,77)
!
!WR_ORA2/O3=0.0
!
!WR_ORA2/H2O2=0.0
!
!WR_ORA2/NO=0.0
!
!WR_ORA2/NO2=0.0
!
!WR_ORA2/NO3=0.0
!
!WR_ORA2/N2O5=0.0
!
!WR_ORA2/HONO=0.0
!
!WR_ORA2/HNO3=0.0
!
!WR_ORA2/HNO4=0.0
!
!WR_ORA2/NH3=0.0
!
!WR_ORA2/SO2=0.0
!
!WR_ORA2/SULF=0.0
!
!WR_ORA2/CO=0.0
!
!WR_ORA2/OH=0.0
!
!WR_ORA2/HO2=0.0
!
!WR_ORA2/CH4=0.0
!
!WR_ORA2/ETH=0.0
!
!WR_ORA2/ALKA=0.0
!
!WR_ORA2/ALKE=0.0
!
!WR_ORA2/BIO=0.0
!
!WR_ORA2/ARO=0.0
!
!WR_ORA2/HCHO=0.0
!
!WR_ORA2/ALD=0.0
!
!WR_ORA2/KET=0.0
!
!WR_ORA2/CARBO=0.0
!
!WR_ORA2/ONIT=0.0
!
!WR_ORA2/PAN=0.0
!
!WR_ORA2/OP1=0.0
!
!WR_ORA2/OP2=0.0
!
!WR_ORA2/ORA1=0.0
!
!WR_ORA2/ORA2=+KTR18
 PJAC(:,84,31)=+TPK%KTR18(:)
!
!WR_ORA2/MO2=0.0
!
!WR_ORA2/ALKAP=0.0
!
!WR_ORA2/ALKEP=0.0
!
!WR_ORA2/BIOP=0.0
!
!WR_ORA2/PHO=0.0
!
!WR_ORA2/ADD=0.0
!
!WR_ORA2/AROP=0.0
!
!WR_ORA2/CARBOP=0.0
!
!WR_ORA2/OLN=0.0
!
!WR_ORA2/XO2=0.0
!
!WR_ORA2/WC_O3=0.0
!
!WR_ORA2/WC_H2O2=0.0
!
!WR_ORA2/WC_NO=0.0
!
!WR_ORA2/WC_NO2=0.0
!
!WR_ORA2/WC_NO3=0.0
!
!WR_ORA2/WC_N2O5=0.0
!
!WR_ORA2/WC_HONO=0.0
!
!WR_ORA2/WC_HNO3=0.0
!
!WR_ORA2/WC_HNO4=0.0
!
!WR_ORA2/WC_NH3=0.0
!
!WR_ORA2/WC_OH=0.0
!
!WR_ORA2/WC_HO2=0.0
!
!WR_ORA2/WC_CO2=0.0
!
!WR_ORA2/WC_SO2=0.0
!
!WR_ORA2/WC_SULF=0.0
!
!WR_ORA2/WC_HCHO=0.0
!
!WR_ORA2/WC_ORA1=0.0
!
!WR_ORA2/WC_ORA2=0.0
!
!WR_ORA2/WC_MO2=0.0
!
!WR_ORA2/WC_OP1=0.0
!
!WR_ORA2/WC_ASO3=0.0
!
!WR_ORA2/WC_ASO4=0.0
!
!WR_ORA2/WC_ASO5=0.0
!
!WR_ORA2/WC_AHSO5=0.0
!
!WR_ORA2/WC_AHMS=0.0
!
!WR_ORA2/WR_O3=0.0
!
!WR_ORA2/WR_H2O2=0.0
!
!WR_ORA2/WR_NO=0.0
!
!WR_ORA2/WR_NO2=0.0
!
!WR_ORA2/WR_NO3=0.0
!
!WR_ORA2/WR_N2O5=0.0
!
!WR_ORA2/WR_HONO=0.0
!
!WR_ORA2/WR_HNO3=0.0
!
!WR_ORA2/WR_HNO4=0.0
!
!WR_ORA2/WR_NH3=0.0
!
!WR_ORA2/WR_OH=0.0
!
!WR_ORA2/WR_HO2=0.0
!
!WR_ORA2/WR_CO2=0.0
!
!WR_ORA2/WR_SO2=0.0
!
!WR_ORA2/WR_SULF=0.0
!
!WR_ORA2/WR_HCHO=0.0
!
!WR_ORA2/WR_ORA1=0.0
!
!WR_ORA2/WR_ORA2=-KTR38
 PJAC(:,84,84)=-TPK%KTR38(:)
!
!WR_ORA2/WR_MO2=0.0
!
!WR_ORA2/WR_OP1=0.0
!
!WR_ORA2/WR_ASO3=0.0
!
!WR_ORA2/WR_ASO4=0.0
!
!WR_ORA2/WR_ASO5=0.0
!
!WR_ORA2/WR_AHSO5=0.0
!
!WR_ORA2/WR_AHMS=0.0
!
!WR_MO2/O3=0.0
!
!WR_MO2/H2O2=0.0
!
!WR_MO2/NO=0.0
!
!WR_MO2/NO2=0.0
!
!WR_MO2/NO3=0.0
!
!WR_MO2/N2O5=0.0
!
!WR_MO2/HONO=0.0
!
!WR_MO2/HNO3=0.0
!
!WR_MO2/HNO4=0.0
!
!WR_MO2/NH3=0.0
!
!WR_MO2/SO2=0.0
!
!WR_MO2/SULF=0.0
!
!WR_MO2/CO=0.0
!
!WR_MO2/OH=0.0
!
!WR_MO2/HO2=0.0
!
!WR_MO2/CH4=0.0
!
!WR_MO2/ETH=0.0
!
!WR_MO2/ALKA=0.0
!
!WR_MO2/ALKE=0.0
!
!WR_MO2/BIO=0.0
!
!WR_MO2/ARO=0.0
!
!WR_MO2/HCHO=0.0
!
!WR_MO2/ALD=0.0
!
!WR_MO2/KET=0.0
!
!WR_MO2/CARBO=0.0
!
!WR_MO2/ONIT=0.0
!
!WR_MO2/PAN=0.0
!
!WR_MO2/OP1=0.0
!
!WR_MO2/OP2=0.0
!
!WR_MO2/ORA1=0.0
!
!WR_MO2/ORA2=0.0
!
!WR_MO2/MO2=+KTR19
 PJAC(:,85,32)=+TPK%KTR19(:)
!
!WR_MO2/ALKAP=0.0
!
!WR_MO2/ALKEP=0.0
!
!WR_MO2/BIOP=0.0
!
!WR_MO2/PHO=0.0
!
!WR_MO2/ADD=0.0
!
!WR_MO2/AROP=0.0
!
!WR_MO2/CARBOP=0.0
!
!WR_MO2/OLN=0.0
!
!WR_MO2/XO2=0.0
!
!WR_MO2/WC_O3=0.0
!
!WR_MO2/WC_H2O2=0.0
!
!WR_MO2/WC_NO=0.0
!
!WR_MO2/WC_NO2=0.0
!
!WR_MO2/WC_NO3=0.0
!
!WR_MO2/WC_N2O5=0.0
!
!WR_MO2/WC_HONO=0.0
!
!WR_MO2/WC_HNO3=0.0
!
!WR_MO2/WC_HNO4=0.0
!
!WR_MO2/WC_NH3=0.0
!
!WR_MO2/WC_OH=0.0
!
!WR_MO2/WC_HO2=0.0
!
!WR_MO2/WC_CO2=0.0
!
!WR_MO2/WC_SO2=0.0
!
!WR_MO2/WC_SULF=0.0
!
!WR_MO2/WC_HCHO=0.0
!
!WR_MO2/WC_ORA1=0.0
!
!WR_MO2/WC_ORA2=0.0
!
!WR_MO2/WC_MO2=0.0
!
!WR_MO2/WC_OP1=0.0
!
!WR_MO2/WC_ASO3=0.0
!
!WR_MO2/WC_ASO4=0.0
!
!WR_MO2/WC_ASO5=0.0
!
!WR_MO2/WC_AHSO5=0.0
!
!WR_MO2/WC_AHMS=0.0
!
!WR_MO2/WR_O3=0.0
!
!WR_MO2/WR_H2O2=0.0
!
!WR_MO2/WR_NO=0.0
!
!WR_MO2/WR_NO2=0.0
!
!WR_MO2/WR_NO3=0.0
!
!WR_MO2/WR_N2O5=0.0
!
!WR_MO2/WR_HONO=0.0
!
!WR_MO2/WR_HNO3=0.0
!
!WR_MO2/WR_HNO4=0.0
!
!WR_MO2/WR_NH3=0.0
!
!WR_MO2/WR_OH=0.0
!
!WR_MO2/WR_HO2=0.0
!
!WR_MO2/WR_CO2=0.0
!
!WR_MO2/WR_SO2=-KR18*<WR_MO2>
 PJAC(:,85,80)=-TPK%KR18(:)*PCONC(:,85)
!
!WR_MO2/WR_SULF=0.0
!
!WR_MO2/WR_HCHO=0.0
!
!WR_MO2/WR_ORA1=0.0
!
!WR_MO2/WR_ORA2=0.0
!
!WR_MO2/WR_MO2=-KTR39-KR17*<WR_MO2>-KR17*<WR_MO2>-KR17*<WR_MO2>-KR17*<WR_MO2>-K
!R18*<WR_SO2>
 PJAC(:,85,85)=-TPK%KTR39(:)-TPK%KR17(:)*PCONC(:,85)-TPK%KR17(:)*PCONC(:,85)-TP&
&K%KR17(:)*PCONC(:,85)-TPK%KR17(:)*PCONC(:,85)-TPK%KR18(:)*PCONC(:,80)
!
!WR_MO2/WR_OP1=0.0
!
!WR_MO2/WR_ASO3=0.0
!
!WR_MO2/WR_ASO4=0.0
!
!WR_MO2/WR_ASO5=0.0
!
!WR_MO2/WR_AHSO5=0.0
!
!WR_MO2/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ16
!
SUBROUTINE SUBJ17
!
!Indices 86 a 90
!
!
!WR_OP1/O3=0.0
!
!WR_OP1/H2O2=0.0
!
!WR_OP1/NO=0.0
!
!WR_OP1/NO2=0.0
!
!WR_OP1/NO3=0.0
!
!WR_OP1/N2O5=0.0
!
!WR_OP1/HONO=0.0
!
!WR_OP1/HNO3=0.0
!
!WR_OP1/HNO4=0.0
!
!WR_OP1/NH3=0.0
!
!WR_OP1/SO2=0.0
!
!WR_OP1/SULF=0.0
!
!WR_OP1/CO=0.0
!
!WR_OP1/OH=0.0
!
!WR_OP1/HO2=0.0
!
!WR_OP1/CH4=0.0
!
!WR_OP1/ETH=0.0
!
!WR_OP1/ALKA=0.0
!
!WR_OP1/ALKE=0.0
!
!WR_OP1/BIO=0.0
!
!WR_OP1/ARO=0.0
!
!WR_OP1/HCHO=0.0
!
!WR_OP1/ALD=0.0
!
!WR_OP1/KET=0.0
!
!WR_OP1/CARBO=0.0
!
!WR_OP1/ONIT=0.0
!
!WR_OP1/PAN=0.0
!
!WR_OP1/OP1=+KTR20
 PJAC(:,86,28)=+TPK%KTR20(:)
!
!WR_OP1/OP2=0.0
!
!WR_OP1/ORA1=0.0
!
!WR_OP1/ORA2=0.0
!
!WR_OP1/MO2=0.0
!
!WR_OP1/ALKAP=0.0
!
!WR_OP1/ALKEP=0.0
!
!WR_OP1/BIOP=0.0
!
!WR_OP1/PHO=0.0
!
!WR_OP1/ADD=0.0
!
!WR_OP1/AROP=0.0
!
!WR_OP1/CARBOP=0.0
!
!WR_OP1/OLN=0.0
!
!WR_OP1/XO2=0.0
!
!WR_OP1/WC_O3=0.0
!
!WR_OP1/WC_H2O2=0.0
!
!WR_OP1/WC_NO=0.0
!
!WR_OP1/WC_NO2=0.0
!
!WR_OP1/WC_NO3=0.0
!
!WR_OP1/WC_N2O5=0.0
!
!WR_OP1/WC_HONO=0.0
!
!WR_OP1/WC_HNO3=0.0
!
!WR_OP1/WC_HNO4=0.0
!
!WR_OP1/WC_NH3=0.0
!
!WR_OP1/WC_OH=0.0
!
!WR_OP1/WC_HO2=0.0
!
!WR_OP1/WC_CO2=0.0
!
!WR_OP1/WC_SO2=0.0
!
!WR_OP1/WC_SULF=0.0
!
!WR_OP1/WC_HCHO=0.0
!
!WR_OP1/WC_ORA1=0.0
!
!WR_OP1/WC_ORA2=0.0
!
!WR_OP1/WC_MO2=0.0
!
!WR_OP1/WC_OP1=0.0
!
!WR_OP1/WC_ASO3=0.0
!
!WR_OP1/WC_ASO4=0.0
!
!WR_OP1/WC_ASO5=0.0
!
!WR_OP1/WC_AHSO5=0.0
!
!WR_OP1/WC_AHMS=0.0
!
!WR_OP1/WR_O3=0.0
!
!WR_OP1/WR_H2O2=0.0
!
!WR_OP1/WR_NO=0.0
!
!WR_OP1/WR_NO2=0.0
!
!WR_OP1/WR_NO3=0.0
!
!WR_OP1/WR_N2O5=0.0
!
!WR_OP1/WR_HONO=0.0
!
!WR_OP1/WR_HNO3=0.0
!
!WR_OP1/WR_HNO4=0.0
!
!WR_OP1/WR_NH3=0.0
!
!WR_OP1/WR_OH=0.0
!
!WR_OP1/WR_HO2=0.0
!
!WR_OP1/WR_CO2=0.0
!
!WR_OP1/WR_SO2=+KR18*<WR_MO2>
 PJAC(:,86,80)=+TPK%KR18(:)*PCONC(:,85)
!
!WR_OP1/WR_SULF=0.0
!
!WR_OP1/WR_HCHO=0.0
!
!WR_OP1/WR_ORA1=0.0
!
!WR_OP1/WR_ORA2=0.0
!
!WR_OP1/WR_MO2=+KR18*<WR_SO2>
 PJAC(:,86,85)=+TPK%KR18(:)*PCONC(:,80)
!
!WR_OP1/WR_OP1=-KTR40
 PJAC(:,86,86)=-TPK%KTR40(:)
!
!WR_OP1/WR_ASO3=0.0
!
!WR_OP1/WR_ASO4=0.0
!
!WR_OP1/WR_ASO5=0.0
!
!WR_OP1/WR_AHSO5=0.0
!
!WR_OP1/WR_AHMS=0.0
!
!WR_ASO3/O3=0.0
!
!WR_ASO3/H2O2=0.0
!
!WR_ASO3/NO=0.0
!
!WR_ASO3/NO2=0.0
!
!WR_ASO3/NO3=0.0
!
!WR_ASO3/N2O5=0.0
!
!WR_ASO3/HONO=0.0
!
!WR_ASO3/HNO3=0.0
!
!WR_ASO3/HNO4=0.0
!
!WR_ASO3/NH3=0.0
!
!WR_ASO3/SO2=0.0
!
!WR_ASO3/SULF=0.0
!
!WR_ASO3/CO=0.0
!
!WR_ASO3/OH=0.0
!
!WR_ASO3/HO2=0.0
!
!WR_ASO3/CH4=0.0
!
!WR_ASO3/ETH=0.0
!
!WR_ASO3/ALKA=0.0
!
!WR_ASO3/ALKE=0.0
!
!WR_ASO3/BIO=0.0
!
!WR_ASO3/ARO=0.0
!
!WR_ASO3/HCHO=0.0
!
!WR_ASO3/ALD=0.0
!
!WR_ASO3/KET=0.0
!
!WR_ASO3/CARBO=0.0
!
!WR_ASO3/ONIT=0.0
!
!WR_ASO3/PAN=0.0
!
!WR_ASO3/OP1=0.0
!
!WR_ASO3/OP2=0.0
!
!WR_ASO3/ORA1=0.0
!
!WR_ASO3/ORA2=0.0
!
!WR_ASO3/MO2=0.0
!
!WR_ASO3/ALKAP=0.0
!
!WR_ASO3/ALKEP=0.0
!
!WR_ASO3/BIOP=0.0
!
!WR_ASO3/PHO=0.0
!
!WR_ASO3/ADD=0.0
!
!WR_ASO3/AROP=0.0
!
!WR_ASO3/CARBOP=0.0
!
!WR_ASO3/OLN=0.0
!
!WR_ASO3/XO2=0.0
!
!WR_ASO3/WC_O3=0.0
!
!WR_ASO3/WC_H2O2=0.0
!
!WR_ASO3/WC_NO=0.0
!
!WR_ASO3/WC_NO2=0.0
!
!WR_ASO3/WC_NO3=0.0
!
!WR_ASO3/WC_N2O5=0.0
!
!WR_ASO3/WC_HONO=0.0
!
!WR_ASO3/WC_HNO3=0.0
!
!WR_ASO3/WC_HNO4=0.0
!
!WR_ASO3/WC_NH3=0.0
!
!WR_ASO3/WC_OH=0.0
!
!WR_ASO3/WC_HO2=0.0
!
!WR_ASO3/WC_CO2=0.0
!
!WR_ASO3/WC_SO2=0.0
!
!WR_ASO3/WC_SULF=0.0
!
!WR_ASO3/WC_HCHO=0.0
!
!WR_ASO3/WC_ORA1=0.0
!
!WR_ASO3/WC_ORA2=0.0
!
!WR_ASO3/WC_MO2=0.0
!
!WR_ASO3/WC_OP1=0.0
!
!WR_ASO3/WC_ASO3=0.0
!
!WR_ASO3/WC_ASO4=0.0
!
!WR_ASO3/WC_ASO5=0.0
!
!WR_ASO3/WC_AHSO5=0.0
!
!WR_ASO3/WC_AHMS=0.0
!
!WR_ASO3/WR_O3=0.0
!
!WR_ASO3/WR_H2O2=0.0
!
!WR_ASO3/WR_NO=0.0
!
!WR_ASO3/WR_NO2=0.0
!
!WR_ASO3/WR_NO3=+KR16*<WR_SO2>
 PJAC(:,87,71)=+TPK%KR16(:)*PCONC(:,80)
!
!WR_ASO3/WR_N2O5=0.0
!
!WR_ASO3/WR_HONO=0.0
!
!WR_ASO3/WR_HNO3=0.0
!
!WR_ASO3/WR_HNO4=0.0
!
!WR_ASO3/WR_NH3=0.0
!
!WR_ASO3/WR_OH=+KR7*<WR_SO2>
 PJAC(:,87,77)=+TPK%KR7(:)*PCONC(:,80)
!
!WR_ASO3/WR_HO2=0.0
!
!WR_ASO3/WR_CO2=0.0
!
!WR_ASO3/WR_SO2=+KR7*<WR_OH>+KR16*<WR_NO3>+KR18*<WR_MO2>
 PJAC(:,87,80)=+TPK%KR7(:)*PCONC(:,77)+TPK%KR16(:)*PCONC(:,71)+TPK%KR18(:)*PCON&
&C(:,85)
!
!WR_ASO3/WR_SULF=0.0
!
!WR_ASO3/WR_HCHO=0.0
!
!WR_ASO3/WR_ORA1=0.0
!
!WR_ASO3/WR_ORA2=0.0
!
!WR_ASO3/WR_MO2=+KR18*<WR_SO2>
 PJAC(:,87,85)=+TPK%KR18(:)*PCONC(:,80)
!
!WR_ASO3/WR_OP1=0.0
!
!WR_ASO3/WR_ASO3=-KR24*<W_O2>
 PJAC(:,87,87)=-TPK%KR24(:)*TPK%W_O2(:)
!
!WR_ASO3/WR_ASO4=0.0
!
!WR_ASO3/WR_ASO5=0.0
!
!WR_ASO3/WR_AHSO5=0.0
!
!WR_ASO3/WR_AHMS=0.0
!
!WR_ASO4/O3=0.0
!
!WR_ASO4/H2O2=0.0
!
!WR_ASO4/NO=0.0
!
!WR_ASO4/NO2=0.0
!
!WR_ASO4/NO3=0.0
!
!WR_ASO4/N2O5=0.0
!
!WR_ASO4/HONO=0.0
!
!WR_ASO4/HNO3=0.0
!
!WR_ASO4/HNO4=0.0
!
!WR_ASO4/NH3=0.0
!
!WR_ASO4/SO2=0.0
!
!WR_ASO4/SULF=0.0
!
!WR_ASO4/CO=0.0
!
!WR_ASO4/OH=0.0
!
!WR_ASO4/HO2=0.0
!
!WR_ASO4/CH4=0.0
!
!WR_ASO4/ETH=0.0
!
!WR_ASO4/ALKA=0.0
!
!WR_ASO4/ALKE=0.0
!
!WR_ASO4/BIO=0.0
!
!WR_ASO4/ARO=0.0
!
!WR_ASO4/HCHO=0.0
!
!WR_ASO4/ALD=0.0
!
!WR_ASO4/KET=0.0
!
!WR_ASO4/CARBO=0.0
!
!WR_ASO4/ONIT=0.0
!
!WR_ASO4/PAN=0.0
!
!WR_ASO4/OP1=0.0
!
!WR_ASO4/OP2=0.0
!
!WR_ASO4/ORA1=0.0
!
!WR_ASO4/ORA2=0.0
!
!WR_ASO4/MO2=0.0
!
!WR_ASO4/ALKAP=0.0
!
!WR_ASO4/ALKEP=0.0
!
!WR_ASO4/BIOP=0.0
!
!WR_ASO4/PHO=0.0
!
!WR_ASO4/ADD=0.0
!
!WR_ASO4/AROP=0.0
!
!WR_ASO4/CARBOP=0.0
!
!WR_ASO4/OLN=0.0
!
!WR_ASO4/XO2=0.0
!
!WR_ASO4/WC_O3=0.0
!
!WR_ASO4/WC_H2O2=0.0
!
!WR_ASO4/WC_NO=0.0
!
!WR_ASO4/WC_NO2=0.0
!
!WR_ASO4/WC_NO3=0.0
!
!WR_ASO4/WC_N2O5=0.0
!
!WR_ASO4/WC_HONO=0.0
!
!WR_ASO4/WC_HNO3=0.0
!
!WR_ASO4/WC_HNO4=0.0
!
!WR_ASO4/WC_NH3=0.0
!
!WR_ASO4/WC_OH=0.0
!
!WR_ASO4/WC_HO2=0.0
!
!WR_ASO4/WC_CO2=0.0
!
!WR_ASO4/WC_SO2=0.0
!
!WR_ASO4/WC_SULF=0.0
!
!WR_ASO4/WC_HCHO=0.0
!
!WR_ASO4/WC_ORA1=0.0
!
!WR_ASO4/WC_ORA2=0.0
!
!WR_ASO4/WC_MO2=0.0
!
!WR_ASO4/WC_OP1=0.0
!
!WR_ASO4/WC_ASO3=0.0
!
!WR_ASO4/WC_ASO4=0.0
!
!WR_ASO4/WC_ASO5=0.0
!
!WR_ASO4/WC_AHSO5=0.0
!
!WR_ASO4/WC_AHMS=0.0
!
!WR_ASO4/WR_O3=0.0
!
!WR_ASO4/WR_H2O2=0.0
!
!WR_ASO4/WR_NO=0.0
!
!WR_ASO4/WR_NO2=0.0
!
!WR_ASO4/WR_NO3=+KR15*<WR_SULF>
 PJAC(:,88,71)=+TPK%KR15(:)*PCONC(:,81)
!
!WR_ASO4/WR_N2O5=0.0
!
!WR_ASO4/WR_HONO=0.0
!
!WR_ASO4/WR_HNO3=0.0
!
!WR_ASO4/WR_HNO4=0.0
!
!WR_ASO4/WR_NH3=0.0
!
!WR_ASO4/WR_OH=0.0
!
!WR_ASO4/WR_HO2=0.0
!
!WR_ASO4/WR_CO2=0.0
!
!WR_ASO4/WR_SO2=0.0
!
!WR_ASO4/WR_SULF=+KR15*<WR_NO3>
 PJAC(:,88,81)=+TPK%KR15(:)*PCONC(:,71)
!
!WR_ASO4/WR_HCHO=0.0
!
!WR_ASO4/WR_ORA1=0.0
!
!WR_ASO4/WR_ORA2=0.0
!
!WR_ASO4/WR_MO2=0.0
!
!WR_ASO4/WR_OP1=0.0
!
!WR_ASO4/WR_ASO3=0.0
!
!WR_ASO4/WR_ASO4=-KR28
 PJAC(:,88,88)=-TPK%KR28(:)
!
!WR_ASO4/WR_ASO5=+KR26*<WR_ASO5>+KR26*<WR_ASO5>+KR26*<WR_ASO5>+KR26*<WR_ASO5>
 PJAC(:,88,89)=+TPK%KR26(:)*PCONC(:,89)+TPK%KR26(:)*PCONC(:,89)+TPK%KR26(:)*PCO&
&NC(:,89)+TPK%KR26(:)*PCONC(:,89)
!
!WR_ASO4/WR_AHSO5=0.0
!
!WR_ASO4/WR_AHMS=0.0
!
!WR_ASO5/O3=0.0
!
!WR_ASO5/H2O2=0.0
!
!WR_ASO5/NO=0.0
!
!WR_ASO5/NO2=0.0
!
!WR_ASO5/NO3=0.0
!
!WR_ASO5/N2O5=0.0
!
!WR_ASO5/HONO=0.0
!
!WR_ASO5/HNO3=0.0
!
!WR_ASO5/HNO4=0.0
!
!WR_ASO5/NH3=0.0
!
!WR_ASO5/SO2=0.0
!
!WR_ASO5/SULF=0.0
!
!WR_ASO5/CO=0.0
!
!WR_ASO5/OH=0.0
!
!WR_ASO5/HO2=0.0
!
!WR_ASO5/CH4=0.0
!
!WR_ASO5/ETH=0.0
!
!WR_ASO5/ALKA=0.0
!
!WR_ASO5/ALKE=0.0
!
!WR_ASO5/BIO=0.0
!
!WR_ASO5/ARO=0.0
!
!WR_ASO5/HCHO=0.0
!
!WR_ASO5/ALD=0.0
!
!WR_ASO5/KET=0.0
!
!WR_ASO5/CARBO=0.0
!
!WR_ASO5/ONIT=0.0
!
!WR_ASO5/PAN=0.0
!
!WR_ASO5/OP1=0.0
!
!WR_ASO5/OP2=0.0
!
!WR_ASO5/ORA1=0.0
!
!WR_ASO5/ORA2=0.0
!
!WR_ASO5/MO2=0.0
!
!WR_ASO5/ALKAP=0.0
!
!WR_ASO5/ALKEP=0.0
!
!WR_ASO5/BIOP=0.0
!
!WR_ASO5/PHO=0.0
!
!WR_ASO5/ADD=0.0
!
!WR_ASO5/AROP=0.0
!
!WR_ASO5/CARBOP=0.0
!
!WR_ASO5/OLN=0.0
!
!WR_ASO5/XO2=0.0
!
!WR_ASO5/WC_O3=0.0
!
!WR_ASO5/WC_H2O2=0.0
!
!WR_ASO5/WC_NO=0.0
!
!WR_ASO5/WC_NO2=0.0
!
!WR_ASO5/WC_NO3=0.0
!
!WR_ASO5/WC_N2O5=0.0
!
!WR_ASO5/WC_HONO=0.0
!
!WR_ASO5/WC_HNO3=0.0
!
!WR_ASO5/WC_HNO4=0.0
!
!WR_ASO5/WC_NH3=0.0
!
!WR_ASO5/WC_OH=0.0
!
!WR_ASO5/WC_HO2=0.0
!
!WR_ASO5/WC_CO2=0.0
!
!WR_ASO5/WC_SO2=0.0
!
!WR_ASO5/WC_SULF=0.0
!
!WR_ASO5/WC_HCHO=0.0
!
!WR_ASO5/WC_ORA1=0.0
!
!WR_ASO5/WC_ORA2=0.0
!
!WR_ASO5/WC_MO2=0.0
!
!WR_ASO5/WC_OP1=0.0
!
!WR_ASO5/WC_ASO3=0.0
!
!WR_ASO5/WC_ASO4=0.0
!
!WR_ASO5/WC_ASO5=0.0
!
!WR_ASO5/WC_AHSO5=0.0
!
!WR_ASO5/WC_AHMS=0.0
!
!WR_ASO5/WR_O3=0.0
!
!WR_ASO5/WR_H2O2=0.0
!
!WR_ASO5/WR_NO=0.0
!
!WR_ASO5/WR_NO2=0.0
!
!WR_ASO5/WR_NO3=0.0
!
!WR_ASO5/WR_N2O5=0.0
!
!WR_ASO5/WR_HONO=0.0
!
!WR_ASO5/WR_HNO3=0.0
!
!WR_ASO5/WR_HNO4=0.0
!
!WR_ASO5/WR_NH3=0.0
!
!WR_ASO5/WR_OH=0.0
!
!WR_ASO5/WR_HO2=-KR25*<WR_ASO5>
 PJAC(:,89,78)=-TPK%KR25(:)*PCONC(:,89)
!
!WR_ASO5/WR_CO2=0.0
!
!WR_ASO5/WR_SO2=0.0
!
!WR_ASO5/WR_SULF=0.0
!
!WR_ASO5/WR_HCHO=0.0
!
!WR_ASO5/WR_ORA1=0.0
!
!WR_ASO5/WR_ORA2=0.0
!
!WR_ASO5/WR_MO2=0.0
!
!WR_ASO5/WR_OP1=0.0
!
!WR_ASO5/WR_ASO3=+KR24*<W_O2>
 PJAC(:,89,87)=+TPK%KR24(:)*TPK%W_O2(:)
!
!WR_ASO5/WR_ASO4=0.0
!
!WR_ASO5/WR_ASO5=-KR25*<WR_HO2>-KR26*<WR_ASO5>-KR26*<WR_ASO5>-KR26*<WR_ASO5>-KR
!26*<WR_ASO5>
 PJAC(:,89,89)=-TPK%KR25(:)*PCONC(:,78)-TPK%KR26(:)*PCONC(:,89)-TPK%KR26(:)*PCO&
&NC(:,89)-TPK%KR26(:)*PCONC(:,89)-TPK%KR26(:)*PCONC(:,89)
!
!WR_ASO5/WR_AHSO5=0.0
!
!WR_ASO5/WR_AHMS=0.0
!
!WR_AHSO5/O3=0.0
!
!WR_AHSO5/H2O2=0.0
!
!WR_AHSO5/NO=0.0
!
!WR_AHSO5/NO2=0.0
!
!WR_AHSO5/NO3=0.0
!
!WR_AHSO5/N2O5=0.0
!
!WR_AHSO5/HONO=0.0
!
!WR_AHSO5/HNO3=0.0
!
!WR_AHSO5/HNO4=0.0
!
!WR_AHSO5/NH3=0.0
!
!WR_AHSO5/SO2=0.0
!
!WR_AHSO5/SULF=0.0
!
!WR_AHSO5/CO=0.0
!
!WR_AHSO5/OH=0.0
!
!WR_AHSO5/HO2=0.0
!
!WR_AHSO5/CH4=0.0
!
!WR_AHSO5/ETH=0.0
!
!WR_AHSO5/ALKA=0.0
!
!WR_AHSO5/ALKE=0.0
!
!WR_AHSO5/BIO=0.0
!
!WR_AHSO5/ARO=0.0
!
!WR_AHSO5/HCHO=0.0
!
!WR_AHSO5/ALD=0.0
!
!WR_AHSO5/KET=0.0
!
!WR_AHSO5/CARBO=0.0
!
!WR_AHSO5/ONIT=0.0
!
!WR_AHSO5/PAN=0.0
!
!WR_AHSO5/OP1=0.0
!
!WR_AHSO5/OP2=0.0
!
!WR_AHSO5/ORA1=0.0
!
!WR_AHSO5/ORA2=0.0
!
!WR_AHSO5/MO2=0.0
!
!WR_AHSO5/ALKAP=0.0
!
!WR_AHSO5/ALKEP=0.0
!
!WR_AHSO5/BIOP=0.0
!
!WR_AHSO5/PHO=0.0
!
!WR_AHSO5/ADD=0.0
!
!WR_AHSO5/AROP=0.0
!
!WR_AHSO5/CARBOP=0.0
!
!WR_AHSO5/OLN=0.0
!
!WR_AHSO5/XO2=0.0
!
!WR_AHSO5/WC_O3=0.0
!
!WR_AHSO5/WC_H2O2=0.0
!
!WR_AHSO5/WC_NO=0.0
!
!WR_AHSO5/WC_NO2=0.0
!
!WR_AHSO5/WC_NO3=0.0
!
!WR_AHSO5/WC_N2O5=0.0
!
!WR_AHSO5/WC_HONO=0.0
!
!WR_AHSO5/WC_HNO3=0.0
!
!WR_AHSO5/WC_HNO4=0.0
!
!WR_AHSO5/WC_NH3=0.0
!
!WR_AHSO5/WC_OH=0.0
!
!WR_AHSO5/WC_HO2=0.0
!
!WR_AHSO5/WC_CO2=0.0
!
!WR_AHSO5/WC_SO2=0.0
!
!WR_AHSO5/WC_SULF=0.0
!
!WR_AHSO5/WC_HCHO=0.0
!
!WR_AHSO5/WC_ORA1=0.0
!
!WR_AHSO5/WC_ORA2=0.0
!
!WR_AHSO5/WC_MO2=0.0
!
!WR_AHSO5/WC_OP1=0.0
!
!WR_AHSO5/WC_ASO3=0.0
!
!WR_AHSO5/WC_ASO4=0.0
!
!WR_AHSO5/WC_ASO5=0.0
!
!WR_AHSO5/WC_AHSO5=0.0
!
!WR_AHSO5/WC_AHMS=0.0
!
!WR_AHSO5/WR_O3=0.0
!
!WR_AHSO5/WR_H2O2=0.0
!
!WR_AHSO5/WR_NO=0.0
!
!WR_AHSO5/WR_NO2=0.0
!
!WR_AHSO5/WR_NO3=0.0
!
!WR_AHSO5/WR_N2O5=0.0
!
!WR_AHSO5/WR_HONO=0.0
!
!WR_AHSO5/WR_HNO3=0.0
!
!WR_AHSO5/WR_HNO4=0.0
!
!WR_AHSO5/WR_NH3=0.0
!
!WR_AHSO5/WR_OH=0.0
!
!WR_AHSO5/WR_HO2=+KR25*<WR_ASO5>
 PJAC(:,90,78)=+TPK%KR25(:)*PCONC(:,89)
!
!WR_AHSO5/WR_CO2=0.0
!
!WR_AHSO5/WR_SO2=-KR27*<WR_AHSO5>
 PJAC(:,90,80)=-TPK%KR27(:)*PCONC(:,90)
!
!WR_AHSO5/WR_SULF=0.0
!
!WR_AHSO5/WR_HCHO=0.0
!
!WR_AHSO5/WR_ORA1=0.0
!
!WR_AHSO5/WR_ORA2=0.0
!
!WR_AHSO5/WR_MO2=0.0
!
!WR_AHSO5/WR_OP1=0.0
!
!WR_AHSO5/WR_ASO3=0.0
!
!WR_AHSO5/WR_ASO4=0.0
!
!WR_AHSO5/WR_ASO5=+KR25*<WR_HO2>
 PJAC(:,90,89)=+TPK%KR25(:)*PCONC(:,78)
!
!WR_AHSO5/WR_AHSO5=-KR27*<WR_SO2>
 PJAC(:,90,90)=-TPK%KR27(:)*PCONC(:,80)
!
!WR_AHSO5/WR_AHMS=0.0
!
RETURN
END SUBROUTINE SUBJ17
!
SUBROUTINE SUBJ18
!
!Indices 91 a 91
!
!
!WR_AHMS/O3=0.0
!
!WR_AHMS/H2O2=0.0
!
!WR_AHMS/NO=0.0
!
!WR_AHMS/NO2=0.0
!
!WR_AHMS/NO3=0.0
!
!WR_AHMS/N2O5=0.0
!
!WR_AHMS/HONO=0.0
!
!WR_AHMS/HNO3=0.0
!
!WR_AHMS/HNO4=0.0
!
!WR_AHMS/NH3=0.0
!
!WR_AHMS/SO2=0.0
!
!WR_AHMS/SULF=0.0
!
!WR_AHMS/CO=0.0
!
!WR_AHMS/OH=0.0
!
!WR_AHMS/HO2=0.0
!
!WR_AHMS/CH4=0.0
!
!WR_AHMS/ETH=0.0
!
!WR_AHMS/ALKA=0.0
!
!WR_AHMS/ALKE=0.0
!
!WR_AHMS/BIO=0.0
!
!WR_AHMS/ARO=0.0
!
!WR_AHMS/HCHO=0.0
!
!WR_AHMS/ALD=0.0
!
!WR_AHMS/KET=0.0
!
!WR_AHMS/CARBO=0.0
!
!WR_AHMS/ONIT=0.0
!
!WR_AHMS/PAN=0.0
!
!WR_AHMS/OP1=0.0
!
!WR_AHMS/OP2=0.0
!
!WR_AHMS/ORA1=0.0
!
!WR_AHMS/ORA2=0.0
!
!WR_AHMS/MO2=0.0
!
!WR_AHMS/ALKAP=0.0
!
!WR_AHMS/ALKEP=0.0
!
!WR_AHMS/BIOP=0.0
!
!WR_AHMS/PHO=0.0
!
!WR_AHMS/ADD=0.0
!
!WR_AHMS/AROP=0.0
!
!WR_AHMS/CARBOP=0.0
!
!WR_AHMS/OLN=0.0
!
!WR_AHMS/XO2=0.0
!
!WR_AHMS/WC_O3=0.0
!
!WR_AHMS/WC_H2O2=0.0
!
!WR_AHMS/WC_NO=0.0
!
!WR_AHMS/WC_NO2=0.0
!
!WR_AHMS/WC_NO3=0.0
!
!WR_AHMS/WC_N2O5=0.0
!
!WR_AHMS/WC_HONO=0.0
!
!WR_AHMS/WC_HNO3=0.0
!
!WR_AHMS/WC_HNO4=0.0
!
!WR_AHMS/WC_NH3=0.0
!
!WR_AHMS/WC_OH=0.0
!
!WR_AHMS/WC_HO2=0.0
!
!WR_AHMS/WC_CO2=0.0
!
!WR_AHMS/WC_SO2=0.0
!
!WR_AHMS/WC_SULF=0.0
!
!WR_AHMS/WC_HCHO=0.0
!
!WR_AHMS/WC_ORA1=0.0
!
!WR_AHMS/WC_ORA2=0.0
!
!WR_AHMS/WC_MO2=0.0
!
!WR_AHMS/WC_OP1=0.0
!
!WR_AHMS/WC_ASO3=0.0
!
!WR_AHMS/WC_ASO4=0.0
!
!WR_AHMS/WC_ASO5=0.0
!
!WR_AHMS/WC_AHSO5=0.0
!
!WR_AHMS/WC_AHMS=0.0
!
!WR_AHMS/WR_O3=0.0
!
!WR_AHMS/WR_H2O2=0.0
!
!WR_AHMS/WR_NO=0.0
!
!WR_AHMS/WR_NO2=0.0
!
!WR_AHMS/WR_NO3=0.0
!
!WR_AHMS/WR_N2O5=0.0
!
!WR_AHMS/WR_HONO=0.0
!
!WR_AHMS/WR_HNO3=0.0
!
!WR_AHMS/WR_HNO4=0.0
!
!WR_AHMS/WR_NH3=0.0
!
!WR_AHMS/WR_OH=-KR23*<WR_AHMS>
 PJAC(:,91,77)=-TPK%KR23(:)*PCONC(:,91)
!
!WR_AHMS/WR_HO2=0.0
!
!WR_AHMS/WR_CO2=0.0
!
!WR_AHMS/WR_SO2=+KR21*<WR_HCHO>
 PJAC(:,91,80)=+TPK%KR21(:)*PCONC(:,82)
!
!WR_AHMS/WR_SULF=0.0
!
!WR_AHMS/WR_HCHO=+KR21*<WR_SO2>
 PJAC(:,91,82)=+TPK%KR21(:)*PCONC(:,80)
!
!WR_AHMS/WR_ORA1=0.0
!
!WR_AHMS/WR_ORA2=0.0
!
!WR_AHMS/WR_MO2=0.0
!
!WR_AHMS/WR_OP1=0.0
!
!WR_AHMS/WR_ASO3=0.0
!
!WR_AHMS/WR_ASO4=0.0
!
!WR_AHMS/WR_ASO5=0.0
!
!WR_AHMS/WR_AHSO5=0.0
!
!WR_AHMS/WR_AHMS=-KR22-KR23*<WR_OH>
 PJAC(:,91,91)=-TPK%KR22(:)-TPK%KR23(:)*PCONC(:,77)
!
RETURN
END SUBROUTINE SUBJ18
!
END SUBROUTINE CH_JAC_AQ
!
!
!========================================================================
!
!!    ##################
      MODULE MODI_CH_JAC_GAZ
!!    ##################
INTERFACE
SUBROUTINE CH_JAC_GAZ(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
END SUBROUTINE CH_JAC_GAZ
END INTERFACE
END MODULE MODI_CH_JAC_GAZ
!
!========================================================================
!
!!    ####################
      SUBROUTINE CH_JAC_GAZ(PTIME,PCONC,PJAC,KMI,KVECNPT,KEQ)
!!    ####################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *CH_JAC*
!!
!!    PURPOSE
!!    -------
!       calculation of the JACOBIAN matrix
!!
!!**  METHOD
!!    ------
!!      The Jacobian matrix J is calculated as defined by the chemical
!!    reaction mechanism.
!!    The reaction rates and other user-defined auxiliary variables are
!!    transfered in the TYPE(CCSTYPE) variable TPK%.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT
INTEGER, INTENT(IN)                              :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KEQ) :: PJAC
INTEGER, INTENT(IN)                              :: KMI
!
TYPE(CCSTYPE),                    POINTER        :: TPK
TPK=>TACCS(KMI)
!
! /BEGIN_CODE/
TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
   &TPK%K022(:)*TPK%H2O(:))
TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
    &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
    &0.00000*TPK%K079(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
    &0.09000*TPK%K080(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
   &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
   &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K054(:)*PCONC(:,JP_BIO)+&
   &TPK%K055(:)*PCONC(:,JP_CARBO))
! /END_CODE/
PJAC(:,:,:) = 0.0
CALL SUBJ0
CALL SUBJ1
CALL SUBJ2
CALL SUBJ3
CALL SUBJ4
CALL SUBJ5
CALL SUBJ6
CALL SUBJ7
CALL SUBJ8
!

CONTAINS

SUBROUTINE SUBJ0
!
!Indices 1 a 5
!
!
!O3/O3=-K002-K003-K019*<O3P>-K023*<OH>-K024*<HO2>-K042*<NO>-K043*<NO2>-K079*<AL
!KE>-K080*<BIO>-K081*<CARBO>-K082*<PAN>-K087*<ADD>
 PJAC(:,1,1)=-TPK%K002(:)-TPK%K003(:)-TPK%K019(:)*TPK%O3P(:)-TPK%K023(:)*PCONC(&
&:,14)-TPK%K024(:)*PCONC(:,15)-TPK%K042(:)*PCONC(:,3)-TPK%K043(:)*PCONC(:,4)-TP&
&K%K079(:)*PCONC(:,19)-TPK%K080(:)*PCONC(:,20)-TPK%K081(:)*PCONC(:,25)-TPK%K082&
&(:)*PCONC(:,27)-TPK%K087(:)*PCONC(:,37)
!
!O3/H2O2=0.0
!
!O3/NO=-K042*<O3>
 PJAC(:,1,3)=-TPK%K042(:)*PCONC(:,1)
!
!O3/NO2=-K043*<O3>
 PJAC(:,1,4)=-TPK%K043(:)*PCONC(:,1)
!
!O3/NO3=0.0
!
!O3/N2O5=0.0
!
!O3/HONO=0.0
!
!O3/HNO3=0.0
!
!O3/HNO4=0.0
!
!O3/NH3=0.0
!
!O3/SO2=0.0
!
!O3/SULF=0.0
!
!O3/CO=0.0
!
!O3/OH=-K023*<O3>
 PJAC(:,1,14)=-TPK%K023(:)*PCONC(:,1)
!
!O3/HO2=-K024*<O3>+0.17307*K0102*<CARBOP>
 PJAC(:,1,15)=-TPK%K024(:)*PCONC(:,1)+0.17307*TPK%K0102(:)*PCONC(:,39)
!
!O3/CH4=0.0
!
!O3/ETH=0.0
!
!O3/ALKA=0.0
!
!O3/ALKE=-K079*<O3>
 PJAC(:,1,19)=-TPK%K079(:)*PCONC(:,1)
!
!O3/BIO=-K080*<O3>
 PJAC(:,1,20)=-TPK%K080(:)*PCONC(:,1)
!
!O3/ARO=0.0
!
!O3/HCHO=0.0
!
!O3/ALD=0.0
!
!O3/KET=0.0
!
!O3/CARBO=-K081*<O3>
 PJAC(:,1,25)=-TPK%K081(:)*PCONC(:,1)
!
!O3/ONIT=0.0
!
!O3/PAN=-K082*<O3>
 PJAC(:,1,27)=-TPK%K082(:)*PCONC(:,1)
!
!O3/OP1=0.0
!
!O3/OP2=0.0
!
!O3/ORA1=0.0
!
!O3/ORA2=0.0
!
!O3/MO2=0.0
!
!O3/ALKAP=0.0
!
!O3/ALKEP=0.0
!
!O3/BIOP=0.0
!
!O3/PHO=0.0
!
!O3/ADD=-K087*<O3>
 PJAC(:,1,37)=-TPK%K087(:)*PCONC(:,1)
!
!O3/AROP=0.0
!
!O3/CARBOP=+0.17307*K0102*<HO2>
 PJAC(:,1,39)=+0.17307*TPK%K0102(:)*PCONC(:,15)
!
!O3/OLN=0.0
!
!O3/XO2=0.0
!
!H2O2/O3=+0.01833*K079*<ALKE>+0.00100*K080*<BIO>
 PJAC(:,2,1)=+0.01833*TPK%K079(:)*PCONC(:,19)+0.00100*TPK%K080(:)*PCONC(:,20)
!
!H2O2/H2O2=-K009-K026*<OH>
 PJAC(:,2,2)=-TPK%K009(:)-TPK%K026(:)*PCONC(:,14)
!
!H2O2/NO=0.0
!
!H2O2/NO2=0.0
!
!H2O2/NO3=0.0
!
!H2O2/N2O5=0.0
!
!H2O2/HONO=0.0
!
!H2O2/HNO3=0.0
!
!H2O2/HNO4=0.0
!
!H2O2/NH3=0.0
!
!H2O2/SO2=0.0
!
!H2O2/SULF=0.0
!
!H2O2/CO=0.0
!
!H2O2/OH=-K026*<H2O2>
 PJAC(:,2,14)=-TPK%K026(:)*PCONC(:,2)
!
!H2O2/HO2=+K027*<HO2>+K027*<HO2>+K028*<HO2>*<H2O>+K028*<HO2>*<H2O>
 PJAC(:,2,15)=+TPK%K027(:)*PCONC(:,15)+TPK%K027(:)*PCONC(:,15)+TPK%K028(:)*PCON&
&C(:,15)*TPK%H2O(:)+TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)
!
!H2O2/CH4=0.0
!
!H2O2/ETH=0.0
!
!H2O2/ALKA=0.0
!
!H2O2/ALKE=+0.01833*K079*<O3>
 PJAC(:,2,19)=+0.01833*TPK%K079(:)*PCONC(:,1)
!
!H2O2/BIO=+0.00100*K080*<O3>
 PJAC(:,2,20)=+0.00100*TPK%K080(:)*PCONC(:,1)
!
!H2O2/ARO=0.0
!
!H2O2/HCHO=0.0
!
!H2O2/ALD=0.0
!
!H2O2/KET=0.0
!
!H2O2/CARBO=0.0
!
!H2O2/ONIT=0.0
!
!H2O2/PAN=0.0
!
!H2O2/OP1=0.0
!
!H2O2/OP2=0.0
!
!H2O2/ORA1=0.0
!
!H2O2/ORA2=0.0
!
!H2O2/MO2=0.0
!
!H2O2/ALKAP=0.0
!
!H2O2/ALKEP=0.0
!
!H2O2/BIOP=0.0
!
!H2O2/PHO=0.0
!
!H2O2/ADD=0.0
!
!H2O2/AROP=0.0
!
!H2O2/CARBOP=0.0
!
!H2O2/OLN=0.0
!
!H2O2/XO2=0.0
!
!NO/O3=-K042*<NO>
 PJAC(:,3,1)=-TPK%K042(:)*PCONC(:,3)
!
!NO/H2O2=0.0
!
!NO/NO=-K029*<O3P>-K032*<OH>-K035*<HO2>-K042*<O3>-K044*<NO>*<O2>-K044*<NO>*<O2>
!-K044*<NO>*<O2>-K044*<NO>*<O2>-K045*<NO3>-K090*<MO2>-K091*<ALKAP>-K092*<ALKEP>
!-K093*<BIOP>-K094*<AROP>-K095*<CARBOP>-K096*<OLN>-K130*<XO2>
 PJAC(:,3,3)=-TPK%K029(:)*TPK%O3P(:)-TPK%K032(:)*PCONC(:,14)-TPK%K035(:)*PCONC(&
&:,15)-TPK%K042(:)*PCONC(:,1)-TPK%K044(:)*PCONC(:,3)*TPK%O2(:)-TPK%K044(:)*PCON&
&C(:,3)*TPK%O2(:)-TPK%K044(:)*PCONC(:,3)*TPK%O2(:)-TPK%K044(:)*PCONC(:,3)*TPK%O&
&2(:)-TPK%K045(:)*PCONC(:,5)-TPK%K090(:)*PCONC(:,32)-TPK%K091(:)*PCONC(:,33)-TP&
&K%K092(:)*PCONC(:,34)-TPK%K093(:)*PCONC(:,35)-TPK%K094(:)*PCONC(:,38)-TPK%K095&
&(:)*PCONC(:,39)-TPK%K096(:)*PCONC(:,40)-TPK%K130(:)*PCONC(:,41)
!
!NO/NO2=+K001+K030*<O3P>+K046*<NO3>
 PJAC(:,3,4)=+TPK%K001(:)+TPK%K030(:)*TPK%O3P(:)+TPK%K046(:)*PCONC(:,5)
!
!NO/NO3=+K007-K045*<NO>+K046*<NO2>
 PJAC(:,3,5)=+TPK%K007(:)-TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)
!
!NO/N2O5=0.0
!
!NO/HONO=+K004
 PJAC(:,3,7)=+TPK%K004(:)
!
!NO/HNO3=0.0
!
!NO/HNO4=0.0
!
!NO/NH3=0.0
!
!NO/SO2=0.0
!
!NO/SULF=0.0
!
!NO/CO=0.0
!
!NO/OH=-K032*<NO>
 PJAC(:,3,14)=-TPK%K032(:)*PCONC(:,3)
!
!NO/HO2=-K035*<NO>
 PJAC(:,3,15)=-TPK%K035(:)*PCONC(:,3)
!
!NO/CH4=0.0
!
!NO/ETH=0.0
!
!NO/ALKA=0.0
!
!NO/ALKE=0.0
!
!NO/BIO=0.0
!
!NO/ARO=0.0
!
!NO/HCHO=0.0
!
!NO/ALD=0.0
!
!NO/KET=0.0
!
!NO/CARBO=0.0
!
!NO/ONIT=0.0
!
!NO/PAN=0.0
!
!NO/OP1=0.0
!
!NO/OP2=0.0
!
!NO/ORA1=0.0
!
!NO/ORA2=0.0
!
!NO/MO2=-K090*<NO>
 PJAC(:,3,32)=-TPK%K090(:)*PCONC(:,3)
!
!NO/ALKAP=-K091*<NO>
 PJAC(:,3,33)=-TPK%K091(:)*PCONC(:,3)
!
!NO/ALKEP=-K092*<NO>
 PJAC(:,3,34)=-TPK%K092(:)*PCONC(:,3)
!
!NO/BIOP=-K093*<NO>
 PJAC(:,3,35)=-TPK%K093(:)*PCONC(:,3)
!
!NO/PHO=0.0
!
!NO/ADD=0.0
!
!NO/AROP=-K094*<NO>
 PJAC(:,3,38)=-TPK%K094(:)*PCONC(:,3)
!
!NO/CARBOP=-K095*<NO>
 PJAC(:,3,39)=-TPK%K095(:)*PCONC(:,3)
!
!NO/OLN=-K096*<NO>
 PJAC(:,3,40)=-TPK%K096(:)*PCONC(:,3)
!
!NO/XO2=-K130*<NO>
 PJAC(:,3,41)=-TPK%K130(:)*PCONC(:,3)
!
!NO2/O3=+K042*<NO>-K043*<NO2>+0.70*K082*<PAN>
 PJAC(:,4,1)=+TPK%K042(:)*PCONC(:,3)-TPK%K043(:)*PCONC(:,4)+0.70*TPK%K082(:)*PC&
&ONC(:,27)
!
!NO2/H2O2=0.0
!
!NO2/NO=+K029*<O3P>+K035*<HO2>+K042*<O3>+K044*<NO>*<O2>+K044*<NO>*<O2>+K044*<NO
!>*<O2>+K044*<NO>*<O2>+K045*<NO3>+K045*<NO3>+K090*<MO2>+0.91541*K091*<ALKAP>+K0
!92*<ALKEP>+0.84700*K093*<BIOP>+0.95115*K094*<AROP>+K095*<CARBOP>+1.81599*K096*
!<OLN>+K130*<XO2>
 PJAC(:,4,3)=+TPK%K029(:)*TPK%O3P(:)+TPK%K035(:)*PCONC(:,15)+TPK%K042(:)*PCONC(&
&:,1)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K04&
&4(:)*PCONC(:,3)*TPK%O2(:)+TPK%K044(:)*PCONC(:,3)*TPK%O2(:)+TPK%K045(:)*PCONC(:&
&,5)+TPK%K045(:)*PCONC(:,5)+TPK%K090(:)*PCONC(:,32)+0.91541*TPK%K091(:)*PCONC(:&
&,33)+TPK%K092(:)*PCONC(:,34)+0.84700*TPK%K093(:)*PCONC(:,35)+0.95115*TPK%K094(&
&:)*PCONC(:,38)+TPK%K095(:)*PCONC(:,39)+1.81599*TPK%K096(:)*PCONC(:,40)+TPK%K13&
&0(:)*PCONC(:,41)
!
!NO2/NO2=-K001-K030*<O3P>-K031*<O3P>-K033*<OH>-K036*<HO2>-K043*<O3>+K046*<NO3>-
!K046*<NO3>-K047*<NO3>-K083*<PHO>-K085*<ADD>-K088*<CARBOP>
 PJAC(:,4,4)=-TPK%K001(:)-TPK%K030(:)*TPK%O3P(:)-TPK%K031(:)*TPK%O3P(:)-TPK%K03&
&3(:)*PCONC(:,14)-TPK%K036(:)*PCONC(:,15)-TPK%K043(:)*PCONC(:,1)+TPK%K046(:)*PC&
&ONC(:,5)-TPK%K046(:)*PCONC(:,5)-TPK%K047(:)*PCONC(:,5)-TPK%K083(:)*PCONC(:,36)&
&-TPK%K085(:)*PCONC(:,37)-TPK%K088(:)*PCONC(:,39)
!
!NO2/NO3=+K008+K034*<OH>+0.7*K038*<HO2>+K045*<NO>+K045*<NO>+K046*<NO2>-K046*<NO
!2>-K047*<NO2>+K049*<NO3>+K049*<NO3>+K049*<NO3>+K049*<NO3>+0.10530*K074*<CARBO>
!+0.40*K078*<PAN>+K119*<MO2>+K120*<ALKAP>+K121*<ALKEP>+K122*<BIOP>+K123*<AROP>+
!K124*<CARBOP>+1.74072*K125*<OLN>+K131*<XO2>
 PJAC(:,4,5)=+TPK%K008(:)+TPK%K034(:)*PCONC(:,14)+0.7*TPK%K038(:)*PCONC(:,15)+T&
&PK%K045(:)*PCONC(:,3)+TPK%K045(:)*PCONC(:,3)+TPK%K046(:)*PCONC(:,4)-TPK%K046(:&
&)*PCONC(:,4)-TPK%K047(:)*PCONC(:,4)+TPK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:&
&,5)+TPK%K049(:)*PCONC(:,5)+TPK%K049(:)*PCONC(:,5)+0.10530*TPK%K074(:)*PCONC(:,&
&25)+0.40*TPK%K078(:)*PCONC(:,27)+TPK%K119(:)*PCONC(:,32)+TPK%K120(:)*PCONC(:,3&
&3)+TPK%K121(:)*PCONC(:,34)+TPK%K122(:)*PCONC(:,35)+TPK%K123(:)*PCONC(:,38)+TPK&
&%K124(:)*PCONC(:,39)+1.74072*TPK%K125(:)*PCONC(:,40)+TPK%K131(:)*PCONC(:,41)
!
!NO2/N2O5=+K048
 PJAC(:,4,6)=+TPK%K048(:)
!
!NO2/HONO=+K039*<OH>
 PJAC(:,4,7)=+TPK%K039(:)*PCONC(:,14)
!
!NO2/HNO3=+K005
 PJAC(:,4,8)=+TPK%K005(:)
!
!NO2/HNO4=+0.65*K006+K037+K041*<OH>
 PJAC(:,4,9)=+0.65*TPK%K006(:)+TPK%K037(:)+TPK%K041(:)*PCONC(:,14)
!
!NO2/NH3=0.0
!
!NO2/SO2=0.0
!
!NO2/SULF=0.0
!
!NO2/CO=0.0
!
!NO2/OH=-K033*<NO2>+K034*<NO3>+K039*<HONO>+K041*<HNO4>+K071*<ONIT>
 PJAC(:,4,14)=-TPK%K033(:)*PCONC(:,4)+TPK%K034(:)*PCONC(:,5)+TPK%K039(:)*PCONC(&
&:,7)+TPK%K041(:)*PCONC(:,9)+TPK%K071(:)*PCONC(:,26)
!
!NO2/HO2=+K035*<NO>-K036*<NO2>+0.7*K038*<NO3>
 PJAC(:,4,15)=+TPK%K035(:)*PCONC(:,3)-TPK%K036(:)*PCONC(:,4)+0.7*TPK%K038(:)*PC&
&ONC(:,5)
!
!NO2/CH4=0.0
!
!NO2/ETH=0.0
!
!NO2/ALKA=0.0
!
!NO2/ALKE=0.0
!
!NO2/BIO=0.0
!
!NO2/ARO=0.0
!
!NO2/HCHO=0.0
!
!NO2/ALD=0.0
!
!NO2/KET=0.0
!
!NO2/CARBO=+0.10530*K074*<NO3>
 PJAC(:,4,25)=+0.10530*TPK%K074(:)*PCONC(:,5)
!
!NO2/ONIT=+K017+K071*<OH>
 PJAC(:,4,26)=+TPK%K017(:)+TPK%K071(:)*PCONC(:,14)
!
!NO2/PAN=+0.40*K078*<NO3>+0.70*K082*<O3>+K089
 PJAC(:,4,27)=+0.40*TPK%K078(:)*PCONC(:,5)+0.70*TPK%K082(:)*PCONC(:,1)+TPK%K089&
&(:)
!
!NO2/OP1=0.0
!
!NO2/OP2=0.0
!
!NO2/ORA1=0.0
!
!NO2/ORA2=0.0
!
!NO2/MO2=+K090*<NO>+0.32440*K110*<OLN>+K119*<NO3>
 PJAC(:,4,32)=+TPK%K090(:)*PCONC(:,3)+0.32440*TPK%K110(:)*PCONC(:,40)+TPK%K119(&
&:)*PCONC(:,5)
!
!NO2/ALKAP=+0.91541*K091*<NO>+K120*<NO3>
 PJAC(:,4,33)=+0.91541*TPK%K091(:)*PCONC(:,3)+TPK%K120(:)*PCONC(:,5)
!
!NO2/ALKEP=+K092*<NO>+K121*<NO3>
 PJAC(:,4,34)=+TPK%K092(:)*PCONC(:,3)+TPK%K121(:)*PCONC(:,5)
!
!NO2/BIOP=+0.84700*K093*<NO>+K122*<NO3>
 PJAC(:,4,35)=+0.84700*TPK%K093(:)*PCONC(:,3)+TPK%K122(:)*PCONC(:,5)
!
!NO2/PHO=-K083*<NO2>
 PJAC(:,4,36)=-TPK%K083(:)*PCONC(:,4)
!
!NO2/ADD=-K085*<NO2>
 PJAC(:,4,37)=-TPK%K085(:)*PCONC(:,4)
!
!NO2/AROP=+0.95115*K094*<NO>+K123*<NO3>
 PJAC(:,4,38)=+0.95115*TPK%K094(:)*PCONC(:,3)+TPK%K123(:)*PCONC(:,5)
!
!NO2/CARBOP=-K088*<NO2>+K095*<NO>+0.00000*K116*<OLN>+K124*<NO3>
 PJAC(:,4,39)=-TPK%K088(:)*PCONC(:,4)+TPK%K095(:)*PCONC(:,3)+0.00000*TPK%K116(:&
&)*PCONC(:,40)+TPK%K124(:)*PCONC(:,5)
!
!NO2/OLN=+1.81599*K096*<NO>+0.32440*K110*<MO2>+0.00000*K116*<CARBOP>+0.00000*K1
!18*<OLN>+0.00000*K118*<OLN>+1.74072*K125*<NO3>
 PJAC(:,4,40)=+1.81599*TPK%K096(:)*PCONC(:,3)+0.32440*TPK%K110(:)*PCONC(:,32)+0&
&.00000*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K11&
&8(:)*PCONC(:,40)+1.74072*TPK%K125(:)*PCONC(:,5)
!
!NO2/XO2=+K130*<NO>+K131*<NO3>
 PJAC(:,4,41)=+TPK%K130(:)*PCONC(:,3)+TPK%K131(:)*PCONC(:,5)
!
!NO3/O3=+K043*<NO2>
 PJAC(:,5,1)=+TPK%K043(:)*PCONC(:,4)
!
!NO3/H2O2=0.0
!
!NO3/NO=-K045*<NO3>
 PJAC(:,5,3)=-TPK%K045(:)*PCONC(:,5)
!
!NO3/NO2=+K031*<O3P>+K043*<O3>-K046*<NO3>-K047*<NO3>
 PJAC(:,5,4)=+TPK%K031(:)*TPK%O3P(:)+TPK%K043(:)*PCONC(:,1)-TPK%K046(:)*PCONC(:&
&,5)-TPK%K047(:)*PCONC(:,5)
!
!NO3/NO3=-K007-K008-K034*<OH>-K038*<HO2>-K045*<NO>-K046*<NO2>-K047*<NO2>-K049*<
!NO3>-K049*<NO3>-K049*<NO3>-K049*<NO3>-K072*<HCHO>-K073*<ALD>-K074*<CARBO>-K075
!*<ARO>-K076*<ALKE>-K077*<BIO>+0.60*K078*<PAN>-K078*<PAN>-K119*<MO2>-K120*<ALKA
!P>-K121*<ALKEP>-K122*<BIOP>-K123*<AROP>-K124*<CARBOP>-K125*<OLN>-K131*<XO2>
 PJAC(:,5,5)=-TPK%K007(:)-TPK%K008(:)-TPK%K034(:)*PCONC(:,14)-TPK%K038(:)*PCONC&
&(:,15)-TPK%K045(:)*PCONC(:,3)-TPK%K046(:)*PCONC(:,4)-TPK%K047(:)*PCONC(:,4)-TP&
&K%K049(:)*PCONC(:,5)-TPK%K049(:)*PCONC(:,5)-TPK%K049(:)*PCONC(:,5)-TPK%K049(:)&
&*PCONC(:,5)-TPK%K072(:)*PCONC(:,22)-TPK%K073(:)*PCONC(:,23)-TPK%K074(:)*PCONC(&
&:,25)-TPK%K075(:)*PCONC(:,21)-TPK%K076(:)*PCONC(:,19)-TPK%K077(:)*PCONC(:,20)+&
&0.60*TPK%K078(:)*PCONC(:,27)-TPK%K078(:)*PCONC(:,27)-TPK%K119(:)*PCONC(:,32)-T&
&PK%K120(:)*PCONC(:,33)-TPK%K121(:)*PCONC(:,34)-TPK%K122(:)*PCONC(:,35)-TPK%K12&
&3(:)*PCONC(:,38)-TPK%K124(:)*PCONC(:,39)-TPK%K125(:)*PCONC(:,40)-TPK%K131(:)*P&
&CONC(:,41)
!
!NO3/N2O5=+K048
 PJAC(:,5,6)=+TPK%K048(:)
!
!NO3/HONO=0.0
!
!NO3/HNO3=+K040*<OH>
 PJAC(:,5,8)=+TPK%K040(:)*PCONC(:,14)
!
!NO3/HNO4=+0.35*K006
 PJAC(:,5,9)=+0.35*TPK%K006(:)
!
!NO3/NH3=0.0
!
!NO3/SO2=0.0
!
!NO3/SULF=0.0
!
!NO3/CO=0.0
!
!NO3/OH=-K034*<NO3>+K040*<HNO3>+0.71893*K070*<PAN>
 PJAC(:,5,14)=-TPK%K034(:)*PCONC(:,5)+TPK%K040(:)*PCONC(:,8)+0.71893*TPK%K070(:&
&)*PCONC(:,27)
!
!NO3/HO2=-K038*<NO3>
 PJAC(:,5,15)=-TPK%K038(:)*PCONC(:,5)
!
!NO3/CH4=0.0
!
!NO3/ETH=0.0
!
!NO3/ALKA=0.0
!
!NO3/ALKE=-K076*<NO3>
 PJAC(:,5,19)=-TPK%K076(:)*PCONC(:,5)
!
!NO3/BIO=-K077*<NO3>
 PJAC(:,5,20)=-TPK%K077(:)*PCONC(:,5)
!
!NO3/ARO=-K075*<NO3>
 PJAC(:,5,21)=-TPK%K075(:)*PCONC(:,5)
!
!NO3/HCHO=-K072*<NO3>
 PJAC(:,5,22)=-TPK%K072(:)*PCONC(:,5)
!
!NO3/ALD=-K073*<NO3>
 PJAC(:,5,23)=-TPK%K073(:)*PCONC(:,5)
!
!NO3/KET=0.0
!
!NO3/CARBO=-K074*<NO3>
 PJAC(:,5,25)=-TPK%K074(:)*PCONC(:,5)
!
!NO3/ONIT=0.0
!
!NO3/PAN=+0.71893*K070*<OH>+0.60*K078*<NO3>-K078*<NO3>
 PJAC(:,5,27)=+0.71893*TPK%K070(:)*PCONC(:,14)+0.60*TPK%K078(:)*PCONC(:,5)-TPK%&
&K078(:)*PCONC(:,5)
!
!NO3/OP1=0.0
!
!NO3/OP2=0.0
!
!NO3/ORA1=0.0
!
!NO3/ORA2=0.0
!
!NO3/MO2=-K119*<NO3>
 PJAC(:,5,32)=-TPK%K119(:)*PCONC(:,5)
!
!NO3/ALKAP=-K120*<NO3>
 PJAC(:,5,33)=-TPK%K120(:)*PCONC(:,5)
!
!NO3/ALKEP=-K121*<NO3>
 PJAC(:,5,34)=-TPK%K121(:)*PCONC(:,5)
!
!NO3/BIOP=-K122*<NO3>
 PJAC(:,5,35)=-TPK%K122(:)*PCONC(:,5)
!
!NO3/PHO=0.0
!
!NO3/ADD=0.0
!
!NO3/AROP=-K123*<NO3>
 PJAC(:,5,38)=-TPK%K123(:)*PCONC(:,5)
!
!NO3/CARBOP=-K124*<NO3>
 PJAC(:,5,39)=-TPK%K124(:)*PCONC(:,5)
!
!NO3/OLN=-K125*<NO3>
 PJAC(:,5,40)=-TPK%K125(:)*PCONC(:,5)
!
!NO3/XO2=-K131*<NO3>
 PJAC(:,5,41)=-TPK%K131(:)*PCONC(:,5)
!
RETURN
END SUBROUTINE SUBJ0
!
SUBROUTINE SUBJ1
!
!Indices 6 a 10
!
!
!N2O5/O3=0.0
!
!N2O5/H2O2=0.0
!
!N2O5/NO=0.0
!
!N2O5/NO2=+K047*<NO3>
 PJAC(:,6,4)=+TPK%K047(:)*PCONC(:,5)
!
!N2O5/NO3=+K047*<NO2>
 PJAC(:,6,5)=+TPK%K047(:)*PCONC(:,4)
!
!N2O5/N2O5=-K048
 PJAC(:,6,6)=-TPK%K048(:)
!
!N2O5/HONO=0.0
!
!N2O5/HNO3=0.0
!
!N2O5/HNO4=0.0
!
!N2O5/NH3=0.0
!
!N2O5/SO2=0.0
!
!N2O5/SULF=0.0
!
!N2O5/CO=0.0
!
!N2O5/OH=0.0
!
!N2O5/HO2=0.0
!
!N2O5/CH4=0.0
!
!N2O5/ETH=0.0
!
!N2O5/ALKA=0.0
!
!N2O5/ALKE=0.0
!
!N2O5/BIO=0.0
!
!N2O5/ARO=0.0
!
!N2O5/HCHO=0.0
!
!N2O5/ALD=0.0
!
!N2O5/KET=0.0
!
!N2O5/CARBO=0.0
!
!N2O5/ONIT=0.0
!
!N2O5/PAN=0.0
!
!N2O5/OP1=0.0
!
!N2O5/OP2=0.0
!
!N2O5/ORA1=0.0
!
!N2O5/ORA2=0.0
!
!N2O5/MO2=0.0
!
!N2O5/ALKAP=0.0
!
!N2O5/ALKEP=0.0
!
!N2O5/BIOP=0.0
!
!N2O5/PHO=0.0
!
!N2O5/ADD=0.0
!
!N2O5/AROP=0.0
!
!N2O5/CARBOP=0.0
!
!N2O5/OLN=0.0
!
!N2O5/XO2=0.0
!
!HONO/O3=0.0
!
!HONO/H2O2=0.0
!
!HONO/NO=+K032*<OH>
 PJAC(:,7,3)=+TPK%K032(:)*PCONC(:,14)
!
!HONO/NO2=+K085*<ADD>
 PJAC(:,7,4)=+TPK%K085(:)*PCONC(:,37)
!
!HONO/NO3=0.0
!
!HONO/N2O5=0.0
!
!HONO/HONO=-K004-K039*<OH>
 PJAC(:,7,7)=-TPK%K004(:)-TPK%K039(:)*PCONC(:,14)
!
!HONO/HNO3=0.0
!
!HONO/HNO4=0.0
!
!HONO/NH3=0.0
!
!HONO/SO2=0.0
!
!HONO/SULF=0.0
!
!HONO/CO=0.0
!
!HONO/OH=+K032*<NO>-K039*<HONO>
 PJAC(:,7,14)=+TPK%K032(:)*PCONC(:,3)-TPK%K039(:)*PCONC(:,7)
!
!HONO/HO2=0.0
!
!HONO/CH4=0.0
!
!HONO/ETH=0.0
!
!HONO/ALKA=0.0
!
!HONO/ALKE=0.0
!
!HONO/BIO=0.0
!
!HONO/ARO=0.0
!
!HONO/HCHO=0.0
!
!HONO/ALD=0.0
!
!HONO/KET=0.0
!
!HONO/CARBO=0.0
!
!HONO/ONIT=0.0
!
!HONO/PAN=0.0
!
!HONO/OP1=0.0
!
!HONO/OP2=0.0
!
!HONO/ORA1=0.0
!
!HONO/ORA2=0.0
!
!HONO/MO2=0.0
!
!HONO/ALKAP=0.0
!
!HONO/ALKEP=0.0
!
!HONO/BIOP=0.0
!
!HONO/PHO=0.0
!
!HONO/ADD=+K085*<NO2>
 PJAC(:,7,37)=+TPK%K085(:)*PCONC(:,4)
!
!HONO/AROP=0.0
!
!HONO/CARBOP=0.0
!
!HONO/OLN=0.0
!
!HONO/XO2=0.0
!
!HNO3/O3=0.0
!
!HNO3/H2O2=0.0
!
!HNO3/NO=0.0
!
!HNO3/NO2=+K033*<OH>
 PJAC(:,8,4)=+TPK%K033(:)*PCONC(:,14)
!
!HNO3/NO3=+0.3*K038*<HO2>+K072*<HCHO>+K073*<ALD>+0.91567*K074*<CARBO>+K075*<ARO
!>
 PJAC(:,8,5)=+0.3*TPK%K038(:)*PCONC(:,15)+TPK%K072(:)*PCONC(:,22)+TPK%K073(:)*P&
&CONC(:,23)+0.91567*TPK%K074(:)*PCONC(:,25)+TPK%K075(:)*PCONC(:,21)
!
!HNO3/N2O5=0.0
!
!HNO3/HONO=0.0
!
!HNO3/HNO3=-K005-K040*<OH>
 PJAC(:,8,8)=-TPK%K005(:)-TPK%K040(:)*PCONC(:,14)
!
!HNO3/HNO4=0.0
!
!HNO3/NH3=0.0
!
!HNO3/SO2=0.0
!
!HNO3/SULF=0.0
!
!HNO3/CO=0.0
!
!HNO3/OH=+K033*<NO2>-K040*<HNO3>
 PJAC(:,8,14)=+TPK%K033(:)*PCONC(:,4)-TPK%K040(:)*PCONC(:,8)
!
!HNO3/HO2=+0.3*K038*<NO3>
 PJAC(:,8,15)=+0.3*TPK%K038(:)*PCONC(:,5)
!
!HNO3/CH4=0.0
!
!HNO3/ETH=0.0
!
!HNO3/ALKA=0.0
!
!HNO3/ALKE=0.0
!
!HNO3/BIO=0.0
!
!HNO3/ARO=+K075*<NO3>
 PJAC(:,8,21)=+TPK%K075(:)*PCONC(:,5)
!
!HNO3/HCHO=+K072*<NO3>
 PJAC(:,8,22)=+TPK%K072(:)*PCONC(:,5)
!
!HNO3/ALD=+K073*<NO3>
 PJAC(:,8,23)=+TPK%K073(:)*PCONC(:,5)
!
!HNO3/KET=0.0
!
!HNO3/CARBO=+0.91567*K074*<NO3>
 PJAC(:,8,25)=+0.91567*TPK%K074(:)*PCONC(:,5)
!
!HNO3/ONIT=0.0
!
!HNO3/PAN=0.0
!
!HNO3/OP1=0.0
!
!HNO3/OP2=0.0
!
!HNO3/ORA1=0.0
!
!HNO3/ORA2=0.0
!
!HNO3/MO2=0.0
!
!HNO3/ALKAP=0.0
!
!HNO3/ALKEP=0.0
!
!HNO3/BIOP=0.0
!
!HNO3/PHO=0.0
!
!HNO3/ADD=0.0
!
!HNO3/AROP=0.0
!
!HNO3/CARBOP=0.0
!
!HNO3/OLN=0.0
!
!HNO3/XO2=0.0
!
!HNO4/O3=0.0
!
!HNO4/H2O2=0.0
!
!HNO4/NO=0.0
!
!HNO4/NO2=+K036*<HO2>
 PJAC(:,9,4)=+TPK%K036(:)*PCONC(:,15)
!
!HNO4/NO3=0.0
!
!HNO4/N2O5=0.0
!
!HNO4/HONO=0.0
!
!HNO4/HNO3=0.0
!
!HNO4/HNO4=-K006-K037-K041*<OH>
 PJAC(:,9,9)=-TPK%K006(:)-TPK%K037(:)-TPK%K041(:)*PCONC(:,14)
!
!HNO4/NH3=0.0
!
!HNO4/SO2=0.0
!
!HNO4/SULF=0.0
!
!HNO4/CO=0.0
!
!HNO4/OH=-K041*<HNO4>
 PJAC(:,9,14)=-TPK%K041(:)*PCONC(:,9)
!
!HNO4/HO2=+K036*<NO2>
 PJAC(:,9,15)=+TPK%K036(:)*PCONC(:,4)
!
!HNO4/CH4=0.0
!
!HNO4/ETH=0.0
!
!HNO4/ALKA=0.0
!
!HNO4/ALKE=0.0
!
!HNO4/BIO=0.0
!
!HNO4/ARO=0.0
!
!HNO4/HCHO=0.0
!
!HNO4/ALD=0.0
!
!HNO4/KET=0.0
!
!HNO4/CARBO=0.0
!
!HNO4/ONIT=0.0
!
!HNO4/PAN=0.0
!
!HNO4/OP1=0.0
!
!HNO4/OP2=0.0
!
!HNO4/ORA1=0.0
!
!HNO4/ORA2=0.0
!
!HNO4/MO2=0.0
!
!HNO4/ALKAP=0.0
!
!HNO4/ALKEP=0.0
!
!HNO4/BIOP=0.0
!
!HNO4/PHO=0.0
!
!HNO4/ADD=0.0
!
!HNO4/AROP=0.0
!
!HNO4/CARBOP=0.0
!
!HNO4/OLN=0.0
!
!HNO4/XO2=0.0
!
!NH3/O3=0.0
!
!NH3/H2O2=0.0
!
!NH3/NO=0.0
!
!NH3/NO2=0.0
!
!NH3/NO3=0.0
!
!NH3/N2O5=0.0
!
!NH3/HONO=0.0
!
!NH3/HNO3=0.0
!
!NH3/HNO4=0.0
!
!NH3/NH3=-K050*<OH>
 PJAC(:,10,10)=-TPK%K050(:)*PCONC(:,14)
!
!NH3/SO2=0.0
!
!NH3/SULF=0.0
!
!NH3/CO=0.0
!
!NH3/OH=-K050*<NH3>
 PJAC(:,10,14)=-TPK%K050(:)*PCONC(:,10)
!
!NH3/HO2=0.0
!
!NH3/CH4=0.0
!
!NH3/ETH=0.0
!
!NH3/ALKA=0.0
!
!NH3/ALKE=0.0
!
!NH3/BIO=0.0
!
!NH3/ARO=0.0
!
!NH3/HCHO=0.0
!
!NH3/ALD=0.0
!
!NH3/KET=0.0
!
!NH3/CARBO=0.0
!
!NH3/ONIT=0.0
!
!NH3/PAN=0.0
!
!NH3/OP1=0.0
!
!NH3/OP2=0.0
!
!NH3/ORA1=0.0
!
!NH3/ORA2=0.0
!
!NH3/MO2=0.0
!
!NH3/ALKAP=0.0
!
!NH3/ALKEP=0.0
!
!NH3/BIOP=0.0
!
!NH3/PHO=0.0
!
!NH3/ADD=0.0
!
!NH3/AROP=0.0
!
!NH3/CARBOP=0.0
!
!NH3/OLN=0.0
!
!NH3/XO2=0.0
!
RETURN
END SUBROUTINE SUBJ1
!
SUBROUTINE SUBJ2
!
!Indices 11 a 15
!
!
!SO2/O3=0.0
!
!SO2/H2O2=0.0
!
!SO2/NO=0.0
!
!SO2/NO2=0.0
!
!SO2/NO3=0.0
!
!SO2/N2O5=0.0
!
!SO2/HONO=0.0
!
!SO2/HNO3=0.0
!
!SO2/HNO4=0.0
!
!SO2/NH3=0.0
!
!SO2/SO2=-K052*<OH>
 PJAC(:,11,11)=-TPK%K052(:)*PCONC(:,14)
!
!SO2/SULF=0.0
!
!SO2/CO=0.0
!
!SO2/OH=-K052*<SO2>
 PJAC(:,11,14)=-TPK%K052(:)*PCONC(:,11)
!
!SO2/HO2=0.0
!
!SO2/CH4=0.0
!
!SO2/ETH=0.0
!
!SO2/ALKA=0.0
!
!SO2/ALKE=0.0
!
!SO2/BIO=0.0
!
!SO2/ARO=0.0
!
!SO2/HCHO=0.0
!
!SO2/ALD=0.0
!
!SO2/KET=0.0
!
!SO2/CARBO=0.0
!
!SO2/ONIT=0.0
!
!SO2/PAN=0.0
!
!SO2/OP1=0.0
!
!SO2/OP2=0.0
!
!SO2/ORA1=0.0
!
!SO2/ORA2=0.0
!
!SO2/MO2=0.0
!
!SO2/ALKAP=0.0
!
!SO2/ALKEP=0.0
!
!SO2/BIOP=0.0
!
!SO2/PHO=0.0
!
!SO2/ADD=0.0
!
!SO2/AROP=0.0
!
!SO2/CARBOP=0.0
!
!SO2/OLN=0.0
!
!SO2/XO2=0.0
!
!SULF/O3=0.0
!
!SULF/H2O2=0.0
!
!SULF/NO=0.0
!
!SULF/NO2=0.0
!
!SULF/NO3=0.0
!
!SULF/N2O5=0.0
!
!SULF/HONO=0.0
!
!SULF/HNO3=0.0
!
!SULF/HNO4=0.0
!
!SULF/NH3=0.0
!
!SULF/SO2=+K052*<OH>
 PJAC(:,12,11)=+TPK%K052(:)*PCONC(:,14)
!
!SULF/SULF=-K132
 PJAC(:,12,12)=-TPK%K132(:)
!
!SULF/CO=0.0
!
!SULF/OH=+K052*<SO2>
 PJAC(:,12,14)=+TPK%K052(:)*PCONC(:,11)
!
!SULF/HO2=0.0
!
!SULF/CH4=0.0
!
!SULF/ETH=0.0
!
!SULF/ALKA=0.0
!
!SULF/ALKE=0.0
!
!SULF/BIO=0.0
!
!SULF/ARO=0.0
!
!SULF/HCHO=0.0
!
!SULF/ALD=0.0
!
!SULF/KET=0.0
!
!SULF/CARBO=0.0
!
!SULF/ONIT=0.0
!
!SULF/PAN=0.0
!
!SULF/OP1=0.0
!
!SULF/OP2=0.0
!
!SULF/ORA1=0.0
!
!SULF/ORA2=0.0
!
!SULF/MO2=0.0
!
!SULF/ALKAP=0.0
!
!SULF/ALKEP=0.0
!
!SULF/BIOP=0.0
!
!SULF/PHO=0.0
!
!SULF/ADD=0.0
!
!SULF/AROP=0.0
!
!SULF/CARBOP=0.0
!
!SULF/OLN=0.0
!
!SULF/XO2=0.0
!
!CO/O3=+0.35120*K079*<ALKE>+0.36000*K080*<BIO>+0.64728*K081*<CARBO>+0.13*K082*<
!PAN>
 PJAC(:,13,1)=+0.35120*TPK%K079(:)*PCONC(:,19)+0.36000*TPK%K080(:)*PCONC(:,20)+&
&0.64728*TPK%K081(:)*PCONC(:,25)+0.13*TPK%K082(:)*PCONC(:,27)
!
!CO/H2O2=0.0
!
!CO/NO=0.0
!
!CO/NO2=0.0
!
!CO/NO3=+K072*<HCHO>+1.33723*K074*<CARBO>
 PJAC(:,13,5)=+TPK%K072(:)*PCONC(:,22)+1.33723*TPK%K074(:)*PCONC(:,25)
!
!CO/N2O5=0.0
!
!CO/HONO=0.0
!
!CO/HNO3=0.0
!
!CO/HNO4=0.0
!
!CO/NH3=0.0
!
!CO/SO2=0.0
!
!CO/SULF=0.0
!
!CO/CO=-K053*<OH>
 PJAC(:,13,13)=-TPK%K053(:)*PCONC(:,14)
!
!CO/OH=-K053*<CO>+0.00878*K058*<ALKA>+K062*<HCHO>+1.01732*K065*<CARBO>
 PJAC(:,13,14)=-TPK%K053(:)*PCONC(:,13)+0.00878*TPK%K058(:)*PCONC(:,18)+TPK%K06&
&2(:)*PCONC(:,22)+1.01732*TPK%K065(:)*PCONC(:,25)
!
!CO/HO2=0.0
!
!CO/CH4=0.0
!
!CO/ETH=0.0
!
!CO/ALKA=+0.00878*K058*<OH>
 PJAC(:,13,18)=+0.00878*TPK%K058(:)*PCONC(:,14)
!
!CO/ALKE=+0.35120*K079*<O3>
 PJAC(:,13,19)=+0.35120*TPK%K079(:)*PCONC(:,1)
!
!CO/BIO=+0.01*K054*<O3P>+0.36000*K080*<O3>
 PJAC(:,13,20)=+0.01*TPK%K054(:)*TPK%O3P(:)+0.36000*TPK%K080(:)*PCONC(:,1)
!
!CO/ARO=0.0
!
!CO/HCHO=+K010+K011+K062*<OH>+K072*<NO3>
 PJAC(:,13,22)=+TPK%K010(:)+TPK%K011(:)+TPK%K062(:)*PCONC(:,14)+TPK%K072(:)*PCO&
&NC(:,5)
!
!CO/ALD=+K012
 PJAC(:,13,23)=+TPK%K012(:)
!
!CO/KET=0.0
!
!CO/CARBO=+0.91924*K016+1.01732*K065*<OH>+1.33723*K074*<NO3>+0.64728*K081*<O3>
 PJAC(:,13,25)=+0.91924*TPK%K016(:)+1.01732*TPK%K065(:)*PCONC(:,14)+1.33723*TPK&
&%K074(:)*PCONC(:,5)+0.64728*TPK%K081(:)*PCONC(:,1)
!
!CO/ONIT=0.0
!
!CO/PAN=+0.13*K082*<O3>
 PJAC(:,13,27)=+0.13*TPK%K082(:)*PCONC(:,1)
!
!CO/OP1=0.0
!
!CO/OP2=0.0
!
!CO/ORA1=0.0
!
!CO/ORA2=0.0
!
!CO/MO2=0.0
!
!CO/ALKAP=0.0
!
!CO/ALKEP=0.0
!
!CO/BIOP=0.0
!
!CO/PHO=0.0
!
!CO/ADD=0.0
!
!CO/AROP=0.0
!
!CO/CARBOP=0.0
!
!CO/OLN=0.0
!
!CO/XO2=0.0
!
!OH/O3=-K023*<OH>+K024*<HO2>+0.39435*K079*<ALKE>+0.28000*K080*<BIO>+0.20595*K08
!1*<CARBO>+0.036*K082*<PAN>+K087*<ADD>
 PJAC(:,14,1)=-TPK%K023(:)*PCONC(:,14)+TPK%K024(:)*PCONC(:,15)+0.39435*TPK%K079&
&(:)*PCONC(:,19)+0.28000*TPK%K080(:)*PCONC(:,20)+0.20595*TPK%K081(:)*PCONC(:,25&
&)+0.036*TPK%K082(:)*PCONC(:,27)+TPK%K087(:)*PCONC(:,37)
!
!OH/H2O2=+K009+K009-K026*<OH>
 PJAC(:,14,2)=+TPK%K009(:)+TPK%K009(:)-TPK%K026(:)*PCONC(:,14)
!
!OH/NO=-K032*<OH>+K035*<HO2>
 PJAC(:,14,3)=-TPK%K032(:)*PCONC(:,14)+TPK%K035(:)*PCONC(:,15)
!
!OH/NO2=-K033*<OH>
 PJAC(:,14,4)=-TPK%K033(:)*PCONC(:,14)
!
!OH/NO3=-K034*<OH>+0.7*K038*<HO2>
 PJAC(:,14,5)=-TPK%K034(:)*PCONC(:,14)+0.7*TPK%K038(:)*PCONC(:,15)
!
!OH/N2O5=0.0
!
!OH/HONO=+K004-K039*<OH>
 PJAC(:,14,7)=+TPK%K004(:)-TPK%K039(:)*PCONC(:,14)
!
!OH/HNO3=+K005-K040*<OH>
 PJAC(:,14,8)=+TPK%K005(:)-TPK%K040(:)*PCONC(:,14)
!
!OH/HNO4=+0.35*K006-K041*<OH>
 PJAC(:,14,9)=+0.35*TPK%K006(:)-TPK%K041(:)*PCONC(:,14)
!
!OH/NH3=-K050*<OH>
 PJAC(:,14,10)=-TPK%K050(:)*PCONC(:,14)
!
!OH/SO2=-K052*<OH>
 PJAC(:,14,11)=-TPK%K052(:)*PCONC(:,14)
!
!OH/SULF=0.0
!
!OH/CO=-K053*<OH>
 PJAC(:,14,13)=-TPK%K053(:)*PCONC(:,14)
!
!OH/OH=-K023*<O3>-K025*<HO2>-K026*<H2O2>-K032*<NO>-K033*<NO2>-K034*<NO3>-K039*<
!HONO>-K040*<HNO3>-K041*<HNO4>-K050*<NH3>-K051*<H2>-K052*<SO2>-K053*<CO>-K056*<
!CH4>-K057*<ETH>+0.00878*K058*<ALKA>-K058*<ALKA>-K059*<ALKE>-K060*<BIO>-K061*<A
!RO>-K062*<HCHO>-K063*<ALD>-K064*<KET>-K065*<CARBO>-K066*<ORA1>-K067*<ORA2>+0.3
!5*K068*<OP1>-K068*<OP1>+0.44925*K069*<OP2>-K069*<OP2>-K070*<PAN>-K071*<ONIT>
 PJAC(:,14,14)=-TPK%K023(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,15)-TPK%K026(:)*PCON&
&C(:,2)-TPK%K032(:)*PCONC(:,3)-TPK%K033(:)*PCONC(:,4)-TPK%K034(:)*PCONC(:,5)-TP&
&K%K039(:)*PCONC(:,7)-TPK%K040(:)*PCONC(:,8)-TPK%K041(:)*PCONC(:,9)-TPK%K050(:)&
&*PCONC(:,10)-TPK%K051(:)*TPK%H2(:)-TPK%K052(:)*PCONC(:,11)-TPK%K053(:)*PCONC(:&
&,13)-TPK%K056(:)*PCONC(:,16)-TPK%K057(:)*PCONC(:,17)+0.00878*TPK%K058(:)*PCONC&
&(:,18)-TPK%K058(:)*PCONC(:,18)-TPK%K059(:)*PCONC(:,19)-TPK%K060(:)*PCONC(:,20)&
&-TPK%K061(:)*PCONC(:,21)-TPK%K062(:)*PCONC(:,22)-TPK%K063(:)*PCONC(:,23)-TPK%K&
&064(:)*PCONC(:,24)-TPK%K065(:)*PCONC(:,25)-TPK%K066(:)*PCONC(:,30)-TPK%K067(:)&
&*PCONC(:,31)+0.35*TPK%K068(:)*PCONC(:,28)-TPK%K068(:)*PCONC(:,28)+0.44925*TPK%&
&K069(:)*PCONC(:,29)-TPK%K069(:)*PCONC(:,29)-TPK%K070(:)*PCONC(:,27)-TPK%K071(:&
&)*PCONC(:,26)
!
!OH/HO2=+K024*<O3>-K025*<OH>+K035*<NO>+0.7*K038*<NO3>
 PJAC(:,14,15)=+TPK%K024(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,14)+TPK%K035(:)*PCON&
&C(:,3)+0.7*TPK%K038(:)*PCONC(:,5)
!
!OH/CH4=-K056*<OH>
 PJAC(:,14,16)=-TPK%K056(:)*PCONC(:,14)
!
!OH/ETH=-K057*<OH>
 PJAC(:,14,17)=-TPK%K057(:)*PCONC(:,14)
!
!OH/ALKA=+0.00878*K058*<OH>-K058*<OH>
 PJAC(:,14,18)=+0.00878*TPK%K058(:)*PCONC(:,14)-TPK%K058(:)*PCONC(:,14)
!
!OH/ALKE=-K059*<OH>+0.39435*K079*<O3>
 PJAC(:,14,19)=-TPK%K059(:)*PCONC(:,14)+0.39435*TPK%K079(:)*PCONC(:,1)
!
!OH/BIO=+0.02*K054*<O3P>-K060*<OH>+0.28000*K080*<O3>
 PJAC(:,14,20)=+0.02*TPK%K054(:)*TPK%O3P(:)-TPK%K060(:)*PCONC(:,14)+0.28000*TPK&
&%K080(:)*PCONC(:,1)
!
!OH/ARO=-K061*<OH>
 PJAC(:,14,21)=-TPK%K061(:)*PCONC(:,14)
!
!OH/HCHO=-K062*<OH>
 PJAC(:,14,22)=-TPK%K062(:)*PCONC(:,14)
!
!OH/ALD=-K063*<OH>
 PJAC(:,14,23)=-TPK%K063(:)*PCONC(:,14)
!
!OH/KET=-K064*<OH>
 PJAC(:,14,24)=-TPK%K064(:)*PCONC(:,14)
!
!OH/CARBO=-K065*<OH>+0.20595*K081*<O3>
 PJAC(:,14,25)=-TPK%K065(:)*PCONC(:,14)+0.20595*TPK%K081(:)*PCONC(:,1)
!
!OH/ONIT=-K071*<OH>
 PJAC(:,14,26)=-TPK%K071(:)*PCONC(:,14)
!
!OH/PAN=-K070*<OH>+0.036*K082*<O3>
 PJAC(:,14,27)=-TPK%K070(:)*PCONC(:,14)+0.036*TPK%K082(:)*PCONC(:,1)
!
!OH/OP1=+K013+0.35*K068*<OH>-K068*<OH>
 PJAC(:,14,28)=+TPK%K013(:)+0.35*TPK%K068(:)*PCONC(:,14)-TPK%K068(:)*PCONC(:,14&
&)
!
!OH/OP2=+K014+0.44925*K069*<OH>-K069*<OH>
 PJAC(:,14,29)=+TPK%K014(:)+0.44925*TPK%K069(:)*PCONC(:,14)-TPK%K069(:)*PCONC(:&
&,14)
!
!OH/ORA1=-K066*<OH>
 PJAC(:,14,30)=-TPK%K066(:)*PCONC(:,14)
!
!OH/ORA2=-K067*<OH>
 PJAC(:,14,31)=-TPK%K067(:)*PCONC(:,14)
!
!OH/MO2=0.0
!
!OH/ALKAP=0.0
!
!OH/ALKEP=0.0
!
!OH/BIOP=0.0
!
!OH/PHO=0.0
!
!OH/ADD=+K087*<O3>
 PJAC(:,14,37)=+TPK%K087(:)*PCONC(:,1)
!
!OH/AROP=0.0
!
!OH/CARBOP=0.0
!
!OH/OLN=0.0
!
!OH/XO2=0.0
!
!HO2/O3=+K023*<OH>-K024*<HO2>+0.23451*K079*<ALKE>+0.30000*K080*<BIO>+0.28441*K0
!81*<CARBO>+0.08*K082*<PAN>
 PJAC(:,15,1)=+TPK%K023(:)*PCONC(:,14)-TPK%K024(:)*PCONC(:,15)+0.23451*TPK%K079&
&(:)*PCONC(:,19)+0.30000*TPK%K080(:)*PCONC(:,20)+0.28441*TPK%K081(:)*PCONC(:,25&
&)+0.08*TPK%K082(:)*PCONC(:,27)
!
!HO2/H2O2=+K026*<OH>
 PJAC(:,15,2)=+TPK%K026(:)*PCONC(:,14)
!
!HO2/NO=-K035*<HO2>+K090*<MO2>+0.74265*K091*<ALKAP>+K092*<ALKEP>+0.84700*K093*<
!BIOP>+0.95115*K094*<AROP>+0.12334*K095*<CARBOP>+0.18401*K096*<OLN>
 PJAC(:,15,3)=-TPK%K035(:)*PCONC(:,15)+TPK%K090(:)*PCONC(:,32)+0.74265*TPK%K091&
&(:)*PCONC(:,33)+TPK%K092(:)*PCONC(:,34)+0.84700*TPK%K093(:)*PCONC(:,35)+0.9511&
&5*TPK%K094(:)*PCONC(:,38)+0.12334*TPK%K095(:)*PCONC(:,39)+0.18401*TPK%K096(:)*&
&PCONC(:,40)
!
!HO2/NO2=-K036*<HO2>
 PJAC(:,15,4)=-TPK%K036(:)*PCONC(:,15)
!
!HO2/NO3=+K034*<OH>-K038*<HO2>+K072*<HCHO>+0.63217*K074*<CARBO>+K119*<MO2>+0.81
!290*K120*<ALKAP>+K121*<ALKEP>+K122*<BIOP>+K123*<AROP>+0.04915*K124*<CARBOP>+0.
!25928*K125*<OLN>
 PJAC(:,15,5)=+TPK%K034(:)*PCONC(:,14)-TPK%K038(:)*PCONC(:,15)+TPK%K072(:)*PCON&
&C(:,22)+0.63217*TPK%K074(:)*PCONC(:,25)+TPK%K119(:)*PCONC(:,32)+0.81290*TPK%K1&
&20(:)*PCONC(:,33)+TPK%K121(:)*PCONC(:,34)+TPK%K122(:)*PCONC(:,35)+TPK%K123(:)*&
&PCONC(:,38)+0.04915*TPK%K124(:)*PCONC(:,39)+0.25928*TPK%K125(:)*PCONC(:,40)
!
!HO2/N2O5=0.0
!
!HO2/HONO=0.0
!
!HO2/HNO3=0.0
!
!HO2/HNO4=+0.65*K006+K037
 PJAC(:,15,9)=+0.65*TPK%K006(:)+TPK%K037(:)
!
!HO2/NH3=0.0
!
!HO2/SO2=+K052*<OH>
 PJAC(:,15,11)=+TPK%K052(:)*PCONC(:,14)
!
!HO2/SULF=0.0
!
!HO2/CO=+K053*<OH>
 PJAC(:,15,13)=+TPK%K053(:)*PCONC(:,14)
!
!HO2/OH=+K023*<O3>-K025*<HO2>+K026*<H2O2>+K034*<NO3>+K051*<H2>+K052*<SO2>+K053*
!<CO>+0.12793*K058*<ALKA>+0.10318*K061*<ARO>+K062*<HCHO>+0.51208*K065*<CARBO>+K
!066*<ORA1>+0.02915*K069*<OP2>+0.28107*K070*<PAN>
 PJAC(:,15,14)=+TPK%K023(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,15)+TPK%K026(:)*PCON&
&C(:,2)+TPK%K034(:)*PCONC(:,5)+TPK%K051(:)*TPK%H2(:)+TPK%K052(:)*PCONC(:,11)+TP&
&K%K053(:)*PCONC(:,13)+0.12793*TPK%K058(:)*PCONC(:,18)+0.10318*TPK%K061(:)*PCON&
&C(:,21)+TPK%K062(:)*PCONC(:,22)+0.51208*TPK%K065(:)*PCONC(:,25)+TPK%K066(:)*PC&
&ONC(:,30)+0.02915*TPK%K069(:)*PCONC(:,29)+0.28107*TPK%K070(:)*PCONC(:,27)
!
!HO2/HO2=-K024*<O3>-K025*<OH>-K027*<HO2>-K027*<HO2>-K027*<HO2>-K027*<HO2>-K028*
!<HO2>*<H2O>-K028*<HO2>*<H2O>-K028*<HO2>*<H2O>-K028*<HO2>*<H2O>-K035*<NO>-K036*
!<NO2>-K038*<NO3>-K084*<PHO>-K097*<MO2>-K098*<ALKAP>-K099*<ALKEP>-K0100*<BIOP>-
!K0101*<AROP>-K0102*<CARBOP>-K103*<OLN>-K126*<XO2>
 PJAC(:,15,15)=-TPK%K024(:)*PCONC(:,1)-TPK%K025(:)*PCONC(:,14)-TPK%K027(:)*PCON&
&C(:,15)-TPK%K027(:)*PCONC(:,15)-TPK%K027(:)*PCONC(:,15)-TPK%K027(:)*PCONC(:,15&
&)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K0&
&28(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K028(:)*PCONC(:,15)*TPK%H2O(:)-TPK%K035(:)*PC&
&ONC(:,3)-TPK%K036(:)*PCONC(:,4)-TPK%K038(:)*PCONC(:,5)-TPK%K084(:)*PCONC(:,36)&
&-TPK%K097(:)*PCONC(:,32)-TPK%K098(:)*PCONC(:,33)-TPK%K099(:)*PCONC(:,34)-TPK%K&
&0100(:)*PCONC(:,35)-TPK%K0101(:)*PCONC(:,38)-TPK%K0102(:)*PCONC(:,39)-TPK%K103&
&(:)*PCONC(:,40)-TPK%K126(:)*PCONC(:,41)
!
!HO2/CH4=0.0
!
!HO2/ETH=0.0
!
!HO2/ALKA=+0.12793*K058*<OH>
 PJAC(:,15,18)=+0.12793*TPK%K058(:)*PCONC(:,14)
!
!HO2/ALKE=+0.23451*K079*<O3>
 PJAC(:,15,19)=+0.23451*TPK%K079(:)*PCONC(:,1)
!
!HO2/BIO=+0.28*K054*<O3P>+0.30000*K080*<O3>
 PJAC(:,15,20)=+0.28*TPK%K054(:)*TPK%O3P(:)+0.30000*TPK%K080(:)*PCONC(:,1)
!
!HO2/ARO=+0.10318*K061*<OH>
 PJAC(:,15,21)=+0.10318*TPK%K061(:)*PCONC(:,14)
!
!HO2/HCHO=+K011+K011+K062*<OH>+K072*<NO3>
 PJAC(:,15,22)=+TPK%K011(:)+TPK%K011(:)+TPK%K062(:)*PCONC(:,14)+TPK%K072(:)*PCO&
&NC(:,5)
!
!HO2/ALD=+K012
 PJAC(:,15,23)=+TPK%K012(:)
!
!HO2/KET=0.0
!
!HO2/CARBO=+0.75830*K016+0.51208*K065*<OH>+0.63217*K074*<NO3>+0.28441*K081*<O3>
 PJAC(:,15,25)=+0.75830*TPK%K016(:)+0.51208*TPK%K065(:)*PCONC(:,14)+0.63217*TPK&
&%K074(:)*PCONC(:,5)+0.28441*TPK%K081(:)*PCONC(:,1)
!
!HO2/ONIT=+K017
 PJAC(:,15,26)=+TPK%K017(:)
!
!HO2/PAN=+0.28107*K070*<OH>+0.08*K082*<O3>
 PJAC(:,15,27)=+0.28107*TPK%K070(:)*PCONC(:,14)+0.08*TPK%K082(:)*PCONC(:,1)
!
!HO2/OP1=+K013
 PJAC(:,15,28)=+TPK%K013(:)
!
!HO2/OP2=+0.96205*K014+0.02915*K069*<OH>
 PJAC(:,15,29)=+0.96205*TPK%K014(:)+0.02915*TPK%K069(:)*PCONC(:,14)
!
!HO2/ORA1=+K066*<OH>
 PJAC(:,15,30)=+TPK%K066(:)*PCONC(:,14)
!
!HO2/ORA2=0.0
!
!HO2/MO2=+K090*<NO>-K097*<HO2>+0.66*K104*<MO2>+0.66*K104*<MO2>+0.98383*K105*<AL
!KAP>+K106*<ALKEP>+1.00000*K107*<BIOP>+1.02767*K108*<AROP>+0.82998*K109*<CARBOP
!>+0.67560*K110*<OLN>+K119*<NO3>+K127*<XO2>
 PJAC(:,15,32)=+TPK%K090(:)*PCONC(:,3)-TPK%K097(:)*PCONC(:,15)+0.66*TPK%K104(:)&
&*PCONC(:,32)+0.66*TPK%K104(:)*PCONC(:,32)+0.98383*TPK%K105(:)*PCONC(:,33)+TPK%&
&K106(:)*PCONC(:,34)+1.00000*TPK%K107(:)*PCONC(:,35)+1.02767*TPK%K108(:)*PCONC(&
&:,38)+0.82998*TPK%K109(:)*PCONC(:,39)+0.67560*TPK%K110(:)*PCONC(:,40)+TPK%K119&
&(:)*PCONC(:,5)+TPK%K127(:)*PCONC(:,41)
!
!HO2/ALKAP=+0.74265*K091*<NO>-K098*<HO2>+0.98383*K105*<MO2>+0.48079*K111*<CARBO
!P>+0.81290*K120*<NO3>
 PJAC(:,15,33)=+0.74265*TPK%K091(:)*PCONC(:,3)-TPK%K098(:)*PCONC(:,15)+0.98383*&
&TPK%K105(:)*PCONC(:,32)+0.48079*TPK%K111(:)*PCONC(:,39)+0.81290*TPK%K120(:)*PC&
&ONC(:,5)
!
!HO2/ALKEP=+K092*<NO>-K099*<HO2>+K106*<MO2>+0.50078*K112*<CARBOP>+K121*<NO3>
 PJAC(:,15,34)=+TPK%K092(:)*PCONC(:,3)-TPK%K099(:)*PCONC(:,15)+TPK%K106(:)*PCON&
&C(:,32)+0.50078*TPK%K112(:)*PCONC(:,39)+TPK%K121(:)*PCONC(:,5)
!
!HO2/BIOP=+0.84700*K093*<NO>-K0100*<HO2>+1.00000*K107*<MO2>+0.50600*K113*<CARBO
!P>+K122*<NO3>
 PJAC(:,15,35)=+0.84700*TPK%K093(:)*PCONC(:,3)-TPK%K0100(:)*PCONC(:,15)+1.00000&
&*TPK%K107(:)*PCONC(:,32)+0.50600*TPK%K113(:)*PCONC(:,39)+TPK%K122(:)*PCONC(:,5&
&)
!
!HO2/PHO=-K084*<HO2>
 PJAC(:,15,36)=-TPK%K084(:)*PCONC(:,15)
!
!HO2/ADD=+0.02*K086*<O2>
 PJAC(:,15,37)=+0.02*TPK%K086(:)*TPK%O2(:)
!
!HO2/AROP=+0.95115*K094*<NO>-K0101*<HO2>+1.02767*K108*<MO2>+K114*<CARBOP>+K123*
!<NO3>
 PJAC(:,15,38)=+0.95115*TPK%K094(:)*PCONC(:,3)-TPK%K0101(:)*PCONC(:,15)+1.02767&
&*TPK%K108(:)*PCONC(:,32)+TPK%K114(:)*PCONC(:,39)+TPK%K123(:)*PCONC(:,5)
!
!HO2/CARBOP=+0.12334*K095*<NO>-K0102*<HO2>+0.82998*K109*<MO2>+0.48079*K111*<ALK
!AP>+0.50078*K112*<ALKEP>+0.50600*K113*<BIOP>+K114*<AROP>+0.07566*K115*<CARBOP>
!+0.07566*K115*<CARBOP>+0.17599*K116*<OLN>+0.04915*K124*<NO3>
 PJAC(:,15,39)=+0.12334*TPK%K095(:)*PCONC(:,3)-TPK%K0102(:)*PCONC(:,15)+0.82998&
&*TPK%K109(:)*PCONC(:,32)+0.48079*TPK%K111(:)*PCONC(:,33)+0.50078*TPK%K112(:)*P&
&CONC(:,34)+0.50600*TPK%K113(:)*PCONC(:,35)+TPK%K114(:)*PCONC(:,38)+0.07566*TPK&
&%K115(:)*PCONC(:,39)+0.07566*TPK%K115(:)*PCONC(:,39)+0.17599*TPK%K116(:)*PCONC&
&(:,40)+0.04915*TPK%K124(:)*PCONC(:,5)
!
!HO2/OLN=+0.18401*K096*<NO>-K103*<HO2>+0.67560*K110*<MO2>+0.17599*K116*<CARBOP>
!+K117*<OLN>+K117*<OLN>+0.00000*K118*<OLN>+0.00000*K118*<OLN>+0.25928*K125*<NO3
!>
 PJAC(:,15,40)=+0.18401*TPK%K096(:)*PCONC(:,3)-TPK%K103(:)*PCONC(:,15)+0.67560*&
&TPK%K110(:)*PCONC(:,32)+0.17599*TPK%K116(:)*PCONC(:,39)+TPK%K117(:)*PCONC(:,40&
&)+TPK%K117(:)*PCONC(:,40)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K118(:)*&
&PCONC(:,40)+0.25928*TPK%K125(:)*PCONC(:,5)
!
!HO2/XO2=-K126*<HO2>+K127*<MO2>
 PJAC(:,15,41)=-TPK%K126(:)*PCONC(:,15)+TPK%K127(:)*PCONC(:,32)
!
RETURN
END SUBROUTINE SUBJ2
!
SUBROUTINE SUBJ3
!
!Indices 16 a 20
!
!
!CH4/O3=+0.04300*K079*<ALKE>
 PJAC(:,16,1)=+0.04300*TPK%K079(:)*PCONC(:,19)
!
!CH4/H2O2=0.0
!
!CH4/NO=0.0
!
!CH4/NO2=0.0
!
!CH4/NO3=0.0
!
!CH4/N2O5=0.0
!
!CH4/HONO=0.0
!
!CH4/HNO3=0.0
!
!CH4/HNO4=0.0
!
!CH4/NH3=0.0
!
!CH4/SO2=0.0
!
!CH4/SULF=0.0
!
!CH4/CO=0.0
!
!CH4/OH=-K056*<CH4>
 PJAC(:,16,14)=-TPK%K056(:)*PCONC(:,16)
!
!CH4/HO2=0.0
!
!CH4/CH4=-K056*<OH>
 PJAC(:,16,16)=-TPK%K056(:)*PCONC(:,14)
!
!CH4/ETH=0.0
!
!CH4/ALKA=0.0
!
!CH4/ALKE=+0.04300*K079*<O3>
 PJAC(:,16,19)=+0.04300*TPK%K079(:)*PCONC(:,1)
!
!CH4/BIO=0.0
!
!CH4/ARO=0.0
!
!CH4/HCHO=0.0
!
!CH4/ALD=0.0
!
!CH4/KET=0.0
!
!CH4/CARBO=0.0
!
!CH4/ONIT=0.0
!
!CH4/PAN=0.0
!
!CH4/OP1=0.0
!
!CH4/OP2=0.0
!
!CH4/ORA1=0.0
!
!CH4/ORA2=0.0
!
!CH4/MO2=0.0
!
!CH4/ALKAP=0.0
!
!CH4/ALKEP=0.0
!
!CH4/BIOP=0.0
!
!CH4/PHO=0.0
!
!CH4/ADD=0.0
!
!CH4/AROP=0.0
!
!CH4/CARBOP=0.0
!
!CH4/OLN=0.0
!
!CH4/XO2=0.0
!
!ETH/O3=+0.03196*K079*<ALKE>
 PJAC(:,17,1)=+0.03196*TPK%K079(:)*PCONC(:,19)
!
!ETH/H2O2=0.0
!
!ETH/NO=0.0
!
!ETH/NO2=0.0
!
!ETH/NO3=0.0
!
!ETH/N2O5=0.0
!
!ETH/HONO=0.0
!
!ETH/HNO3=0.0
!
!ETH/HNO4=0.0
!
!ETH/NH3=0.0
!
!ETH/SO2=0.0
!
!ETH/SULF=0.0
!
!ETH/CO=0.0
!
!ETH/OH=-K057*<ETH>
 PJAC(:,17,14)=-TPK%K057(:)*PCONC(:,17)
!
!ETH/HO2=0.0
!
!ETH/CH4=0.0
!
!ETH/ETH=-K057*<OH>
 PJAC(:,17,17)=-TPK%K057(:)*PCONC(:,14)
!
!ETH/ALKA=0.0
!
!ETH/ALKE=+0.03196*K079*<O3>
 PJAC(:,17,19)=+0.03196*TPK%K079(:)*PCONC(:,1)
!
!ETH/BIO=0.0
!
!ETH/ARO=0.0
!
!ETH/HCHO=0.0
!
!ETH/ALD=0.0
!
!ETH/KET=0.0
!
!ETH/CARBO=0.0
!
!ETH/ONIT=0.0
!
!ETH/PAN=0.0
!
!ETH/OP1=0.0
!
!ETH/OP2=0.0
!
!ETH/ORA1=0.0
!
!ETH/ORA2=0.0
!
!ETH/MO2=0.0
!
!ETH/ALKAP=0.0
!
!ETH/ALKEP=0.0
!
!ETH/BIOP=0.0
!
!ETH/PHO=0.0
!
!ETH/ADD=0.0
!
!ETH/AROP=0.0
!
!ETH/CARBOP=0.0
!
!ETH/OLN=0.0
!
!ETH/XO2=0.0
!
!ALKA/O3=0.0
!
!ALKA/H2O2=0.0
!
!ALKA/NO=0.0
!
!ALKA/NO2=0.0
!
!ALKA/NO3=0.0
!
!ALKA/N2O5=0.0
!
!ALKA/HONO=0.0
!
!ALKA/HNO3=0.0
!
!ALKA/HNO4=0.0
!
!ALKA/NH3=0.0
!
!ALKA/SO2=0.0
!
!ALKA/SULF=0.0
!
!ALKA/CO=0.0
!
!ALKA/OH=-K058*<ALKA>
 PJAC(:,18,14)=-TPK%K058(:)*PCONC(:,18)
!
!ALKA/HO2=0.0
!
!ALKA/CH4=0.0
!
!ALKA/ETH=0.0
!
!ALKA/ALKA=-K058*<OH>
 PJAC(:,18,18)=-TPK%K058(:)*PCONC(:,14)
!
!ALKA/ALKE=0.0
!
!ALKA/BIO=0.0
!
!ALKA/ARO=0.0
!
!ALKA/HCHO=0.0
!
!ALKA/ALD=0.0
!
!ALKA/KET=0.0
!
!ALKA/CARBO=0.0
!
!ALKA/ONIT=0.0
!
!ALKA/PAN=0.0
!
!ALKA/OP1=0.0
!
!ALKA/OP2=0.0
!
!ALKA/ORA1=0.0
!
!ALKA/ORA2=0.0
!
!ALKA/MO2=0.0
!
!ALKA/ALKAP=0.0
!
!ALKA/ALKEP=0.0
!
!ALKA/BIOP=0.0
!
!ALKA/PHO=0.0
!
!ALKA/ADD=0.0
!
!ALKA/AROP=0.0
!
!ALKA/CARBOP=0.0
!
!ALKA/OLN=0.0
!
!ALKA/XO2=0.0
!
!ALKE/O3=+0.00000*K079*<ALKE>-K079*<ALKE>+0.37388*K080*<BIO>
 PJAC(:,19,1)=+0.00000*TPK%K079(:)*PCONC(:,19)-TPK%K079(:)*PCONC(:,19)+0.37388*&
&TPK%K080(:)*PCONC(:,20)
!
!ALKE/H2O2=0.0
!
!ALKE/NO=+0.37815*K093*<BIOP>
 PJAC(:,19,3)=+0.37815*TPK%K093(:)*PCONC(:,35)
!
!ALKE/NO2=0.0
!
!ALKE/NO3=-K076*<ALKE>+0.42729*K122*<BIOP>
 PJAC(:,19,5)=-TPK%K076(:)*PCONC(:,19)+0.42729*TPK%K122(:)*PCONC(:,35)
!
!ALKE/N2O5=0.0
!
!ALKE/HONO=0.0
!
!ALKE/HNO3=0.0
!
!ALKE/HNO4=0.0
!
!ALKE/NH3=0.0
!
!ALKE/SO2=0.0
!
!ALKE/SULF=0.0
!
!ALKE/CO=0.0
!
!ALKE/OH=-K059*<ALKE>
 PJAC(:,19,14)=-TPK%K059(:)*PCONC(:,19)
!
!ALKE/HO2=0.0
!
!ALKE/CH4=0.0
!
!ALKE/ETH=0.0
!
!ALKE/ALKA=0.0
!
!ALKE/ALKE=-K059*<OH>-K076*<NO3>+0.00000*K079*<O3>-K079*<O3>
 PJAC(:,19,19)=-TPK%K059(:)*PCONC(:,14)-TPK%K076(:)*PCONC(:,5)+0.00000*TPK%K079&
&(:)*PCONC(:,1)-TPK%K079(:)*PCONC(:,1)
!
!ALKE/BIO=+0.91868*K054*<O3P>+0.37388*K080*<O3>
 PJAC(:,19,20)=+0.91868*TPK%K054(:)*TPK%O3P(:)+0.37388*TPK%K080(:)*PCONC(:,1)
!
!ALKE/ARO=0.0
!
!ALKE/HCHO=0.0
!
!ALKE/ALD=0.0
!
!ALKE/KET=0.0
!
!ALKE/CARBO=0.0
!
!ALKE/ONIT=0.0
!
!ALKE/PAN=0.0
!
!ALKE/OP1=0.0
!
!ALKE/OP2=0.0
!
!ALKE/ORA1=0.0
!
!ALKE/ORA2=0.0
!
!ALKE/MO2=+0.48074*K107*<BIOP>
 PJAC(:,19,32)=+0.48074*TPK%K107(:)*PCONC(:,35)
!
!ALKE/ALKAP=0.0
!
!ALKE/ALKEP=0.0
!
!ALKE/BIOP=+0.37815*K093*<NO>+0.48074*K107*<MO2>+0.24463*K113*<CARBOP>+0.42729*
!K122*<NO3>
 PJAC(:,19,35)=+0.37815*TPK%K093(:)*PCONC(:,3)+0.48074*TPK%K107(:)*PCONC(:,32)+&
&0.24463*TPK%K113(:)*PCONC(:,39)+0.42729*TPK%K122(:)*PCONC(:,5)
!
!ALKE/PHO=0.0
!
!ALKE/ADD=0.0
!
!ALKE/AROP=0.0
!
!ALKE/CARBOP=+0.24463*K113*<BIOP>
 PJAC(:,19,39)=+0.24463*TPK%K113(:)*PCONC(:,35)
!
!ALKE/OLN=0.0
!
!ALKE/XO2=0.0
!
!BIO/O3=-K080*<BIO>
 PJAC(:,20,1)=-TPK%K080(:)*PCONC(:,20)
!
!BIO/H2O2=0.0
!
!BIO/NO=0.0
!
!BIO/NO2=0.0
!
!BIO/NO3=-K077*<BIO>
 PJAC(:,20,5)=-TPK%K077(:)*PCONC(:,20)
!
!BIO/N2O5=0.0
!
!BIO/HONO=0.0
!
!BIO/HNO3=0.0
!
!BIO/HNO4=0.0
!
!BIO/NH3=0.0
!
!BIO/SO2=0.0
!
!BIO/SULF=0.0
!
!BIO/CO=0.0
!
!BIO/OH=-K060*<BIO>
 PJAC(:,20,14)=-TPK%K060(:)*PCONC(:,20)
!
!BIO/HO2=0.0
!
!BIO/CH4=0.0
!
!BIO/ETH=0.0
!
!BIO/ALKA=0.0
!
!BIO/ALKE=0.0
!
!BIO/BIO=-K054*<O3P>-K060*<OH>-K077*<NO3>-K080*<O3>
 PJAC(:,20,20)=-TPK%K054(:)*TPK%O3P(:)-TPK%K060(:)*PCONC(:,14)-TPK%K077(:)*PCON&
&C(:,5)-TPK%K080(:)*PCONC(:,1)
!
!BIO/ARO=0.0
!
!BIO/HCHO=0.0
!
!BIO/ALD=0.0
!
!BIO/KET=0.0
!
!BIO/CARBO=0.0
!
!BIO/ONIT=0.0
!
!BIO/PAN=0.0
!
!BIO/OP1=0.0
!
!BIO/OP2=0.0
!
!BIO/ORA1=0.0
!
!BIO/ORA2=0.0
!
!BIO/MO2=0.0
!
!BIO/ALKAP=0.0
!
!BIO/ALKEP=0.0
!
!BIO/BIOP=0.0
!
!BIO/PHO=0.0
!
!BIO/ADD=0.0
!
!BIO/AROP=0.0
!
!BIO/CARBOP=0.0
!
!BIO/OLN=0.0
!
!BIO/XO2=0.0
!
RETURN
END SUBROUTINE SUBJ3
!
SUBROUTINE SUBJ4
!
!Indices 21 a 25
!
!
!ARO/O3=+K087*<ADD>
 PJAC(:,21,1)=+TPK%K087(:)*PCONC(:,37)
!
!ARO/H2O2=0.0
!
!ARO/NO=0.0
!
!ARO/NO2=+0.10670*K083*<PHO>+K085*<ADD>
 PJAC(:,21,4)=+0.10670*TPK%K083(:)*PCONC(:,36)+TPK%K085(:)*PCONC(:,37)
!
!ARO/NO3=-K075*<ARO>
 PJAC(:,21,5)=-TPK%K075(:)*PCONC(:,21)
!
!ARO/N2O5=0.0
!
!ARO/HONO=0.0
!
!ARO/HNO3=0.0
!
!ARO/HNO4=0.0
!
!ARO/NH3=0.0
!
!ARO/SO2=0.0
!
!ARO/SULF=0.0
!
!ARO/CO=0.0
!
!ARO/OH=-K061*<ARO>
 PJAC(:,21,14)=-TPK%K061(:)*PCONC(:,21)
!
!ARO/HO2=+1.06698*K084*<PHO>
 PJAC(:,21,15)=+1.06698*TPK%K084(:)*PCONC(:,36)
!
!ARO/CH4=0.0
!
!ARO/ETH=0.0
!
!ARO/ALKA=0.0
!
!ARO/ALKE=0.0
!
!ARO/BIO=0.0
!
!ARO/ARO=-K061*<OH>-K075*<NO3>
 PJAC(:,21,21)=-TPK%K061(:)*PCONC(:,14)-TPK%K075(:)*PCONC(:,5)
!
!ARO/HCHO=0.0
!
!ARO/ALD=0.0
!
!ARO/KET=0.0
!
!ARO/CARBO=0.0
!
!ARO/ONIT=0.0
!
!ARO/PAN=0.0
!
!ARO/OP1=0.0
!
!ARO/OP2=0.0
!
!ARO/ORA1=0.0
!
!ARO/ORA2=0.0
!
!ARO/MO2=0.0
!
!ARO/ALKAP=0.0
!
!ARO/ALKEP=0.0
!
!ARO/BIOP=0.0
!
!ARO/PHO=+0.10670*K083*<NO2>+1.06698*K084*<HO2>
 PJAC(:,21,36)=+0.10670*TPK%K083(:)*PCONC(:,4)+1.06698*TPK%K084(:)*PCONC(:,15)
!
!ARO/ADD=+K085*<NO2>+0.02*K086*<O2>+K087*<O3>
 PJAC(:,21,37)=+TPK%K085(:)*PCONC(:,4)+0.02*TPK%K086(:)*TPK%O2(:)+TPK%K087(:)*P&
&CONC(:,1)
!
!ARO/AROP=0.0
!
!ARO/CARBOP=0.0
!
!ARO/OLN=0.0
!
!ARO/XO2=0.0
!
!HCHO/O3=+0.48290*K079*<ALKE>+0.90000*K080*<BIO>+0.00000*K081*<CARBO>+0.70*K082
!*<PAN>
 PJAC(:,22,1)=+0.48290*TPK%K079(:)*PCONC(:,19)+0.90000*TPK%K080(:)*PCONC(:,20)+&
&0.00000*TPK%K081(:)*PCONC(:,25)+0.70*TPK%K082(:)*PCONC(:,27)
!
!HCHO/H2O2=0.0
!
!HCHO/NO=+K090*<MO2>+0.03002*K091*<ALKAP>+1.39870*K092*<ALKEP>+0.60600*K093*<BI
!OP>+0.05848*K095*<CARBOP>+0.23419*K096*<OLN>
 PJAC(:,22,3)=+TPK%K090(:)*PCONC(:,32)+0.03002*TPK%K091(:)*PCONC(:,33)+1.39870*&
&TPK%K092(:)*PCONC(:,34)+0.60600*TPK%K093(:)*PCONC(:,35)+0.05848*TPK%K095(:)*PC&
&ONC(:,39)+0.23419*TPK%K096(:)*PCONC(:,40)
!
!HCHO/NO2=0.0
!
!HCHO/NO3=-K072*<HCHO>+0.40*K078*<PAN>+K119*<MO2>+0.03142*K120*<ALKAP>+1.40909*
!K121*<ALKEP>+0.68600*K122*<BIOP>+0.03175*K124*<CARBOP>+0.20740*K125*<OLN>
 PJAC(:,22,5)=-TPK%K072(:)*PCONC(:,22)+0.40*TPK%K078(:)*PCONC(:,27)+TPK%K119(:)&
&*PCONC(:,32)+0.03142*TPK%K120(:)*PCONC(:,33)+1.40909*TPK%K121(:)*PCONC(:,34)+0&
&.68600*TPK%K122(:)*PCONC(:,35)+0.03175*TPK%K124(:)*PCONC(:,39)+0.20740*TPK%K12&
&5(:)*PCONC(:,40)
!
!HCHO/N2O5=0.0
!
!HCHO/HONO=0.0
!
!HCHO/HNO3=0.0
!
!HCHO/HNO4=0.0
!
!HCHO/NH3=0.0
!
!HCHO/SO2=0.0
!
!HCHO/SULF=0.0
!
!HCHO/CO=0.0
!
!HCHO/OH=+0.00140*K058*<ALKA>-K062*<HCHO>+0.00000*K065*<CARBO>+0.35*K068*<OP1>+
!0.02915*K069*<OP2>+0.57839*K070*<PAN>
 PJAC(:,22,14)=+0.00140*TPK%K058(:)*PCONC(:,18)-TPK%K062(:)*PCONC(:,22)+0.00000&
&*TPK%K065(:)*PCONC(:,25)+0.35*TPK%K068(:)*PCONC(:,28)+0.02915*TPK%K069(:)*PCON&
&C(:,29)+0.57839*TPK%K070(:)*PCONC(:,27)
!
!HCHO/HO2=0.0
!
!HCHO/CH4=0.0
!
!HCHO/ETH=0.0
!
!HCHO/ALKA=+0.00140*K058*<OH>
 PJAC(:,22,18)=+0.00140*TPK%K058(:)*PCONC(:,14)
!
!HCHO/ALKE=+0.48290*K079*<O3>
 PJAC(:,22,19)=+0.48290*TPK%K079(:)*PCONC(:,1)
!
!HCHO/BIO=+0.05*K054*<O3P>+0.90000*K080*<O3>
 PJAC(:,22,20)=+0.05*TPK%K054(:)*TPK%O3P(:)+0.90000*TPK%K080(:)*PCONC(:,1)
!
!HCHO/ARO=0.0
!
!HCHO/HCHO=-K010-K011-K062*<OH>-K072*<NO3>
 PJAC(:,22,22)=-TPK%K010(:)-TPK%K011(:)-TPK%K062(:)*PCONC(:,14)-TPK%K072(:)*PCO&
&NC(:,5)
!
!HCHO/ALD=0.0
!
!HCHO/KET=0.0
!
!HCHO/CARBO=+0.06517*K016+0.00000*K065*<OH>+0.00000*K081*<O3>
 PJAC(:,22,25)=+0.06517*TPK%K016(:)+0.00000*TPK%K065(:)*PCONC(:,14)+0.00000*TPK&
&%K081(:)*PCONC(:,1)
!
!HCHO/ONIT=0.0
!
!HCHO/PAN=+0.57839*K070*<OH>+0.40*K078*<NO3>+0.70*K082*<O3>
 PJAC(:,22,27)=+0.57839*TPK%K070(:)*PCONC(:,14)+0.40*TPK%K078(:)*PCONC(:,5)+0.7&
&0*TPK%K082(:)*PCONC(:,1)
!
!HCHO/OP1=+K013+0.35*K068*<OH>
 PJAC(:,22,28)=+TPK%K013(:)+0.35*TPK%K068(:)*PCONC(:,14)
!
!HCHO/OP2=+0.02915*K069*<OH>
 PJAC(:,22,29)=+0.02915*TPK%K069(:)*PCONC(:,14)
!
!HCHO/ORA1=0.0
!
!HCHO/ORA2=0.0
!
!HCHO/MO2=+K090*<NO>+1.33*K104*<MO2>+1.33*K104*<MO2>+0.80556*K105*<ALKAP>+1.428
!94*K106*<ALKEP>+1.09000*K107*<BIOP>+K108*<AROP>+0.95723*K109*<CARBOP>+0.88625*
!K110*<OLN>+K119*<NO3>+K127*<XO2>
 PJAC(:,22,32)=+TPK%K090(:)*PCONC(:,3)+1.33*TPK%K104(:)*PCONC(:,32)+1.33*TPK%K1&
&04(:)*PCONC(:,32)+0.80556*TPK%K105(:)*PCONC(:,33)+1.42894*TPK%K106(:)*PCONC(:,&
&34)+1.09000*TPK%K107(:)*PCONC(:,35)+TPK%K108(:)*PCONC(:,38)+0.95723*TPK%K109(:&
&)*PCONC(:,39)+0.88625*TPK%K110(:)*PCONC(:,40)+TPK%K119(:)*PCONC(:,5)+TPK%K127(&
&:)*PCONC(:,41)
!
!HCHO/ALKAP=+0.03002*K091*<NO>+0.80556*K105*<MO2>+0.07600*K111*<CARBOP>+0.03142
!*K120*<NO3>
 PJAC(:,22,33)=+0.03002*TPK%K091(:)*PCONC(:,3)+0.80556*TPK%K105(:)*PCONC(:,32)+&
&0.07600*TPK%K111(:)*PCONC(:,39)+0.03142*TPK%K120(:)*PCONC(:,5)
!
!HCHO/ALKEP=+1.39870*K092*<NO>+1.42894*K106*<MO2>+0.68192*K112*<CARBOP>+1.40909
!*K121*<NO3>
 PJAC(:,22,34)=+1.39870*TPK%K092(:)*PCONC(:,3)+1.42894*TPK%K106(:)*PCONC(:,32)+&
&0.68192*TPK%K112(:)*PCONC(:,39)+1.40909*TPK%K121(:)*PCONC(:,5)
!
!HCHO/BIOP=+0.60600*K093*<NO>+1.09000*K107*<MO2>+0.34000*K113*<CARBOP>+0.68600*
!K122*<NO3>
 PJAC(:,22,35)=+0.60600*TPK%K093(:)*PCONC(:,3)+1.09000*TPK%K107(:)*PCONC(:,32)+&
&0.34000*TPK%K113(:)*PCONC(:,39)+0.68600*TPK%K122(:)*PCONC(:,5)
!
!HCHO/PHO=0.0
!
!HCHO/ADD=0.0
!
!HCHO/AROP=+K108*<MO2>
 PJAC(:,22,38)=+TPK%K108(:)*PCONC(:,32)
!
!HCHO/CARBOP=+0.05848*K095*<NO>+0.95723*K109*<MO2>+0.07600*K111*<ALKAP>+0.68192
!*K112*<ALKEP>+0.34000*K113*<BIOP>+0.03432*K115*<CARBOP>+0.03432*K115*<CARBOP>+
!0.13414*K116*<OLN>+0.03175*K124*<NO3>
 PJAC(:,22,39)=+0.05848*TPK%K095(:)*PCONC(:,3)+0.95723*TPK%K109(:)*PCONC(:,32)+&
&0.07600*TPK%K111(:)*PCONC(:,33)+0.68192*TPK%K112(:)*PCONC(:,34)+0.34000*TPK%K1&
&13(:)*PCONC(:,35)+0.03432*TPK%K115(:)*PCONC(:,39)+0.03432*TPK%K115(:)*PCONC(:,&
&39)+0.13414*TPK%K116(:)*PCONC(:,40)+0.03175*TPK%K124(:)*PCONC(:,5)
!
!HCHO/OLN=+0.23419*K096*<NO>+0.88625*K110*<MO2>+0.13414*K116*<CARBOP>+0.00000*K
!118*<OLN>+0.00000*K118*<OLN>+0.20740*K125*<NO3>
 PJAC(:,22,40)=+0.23419*TPK%K096(:)*PCONC(:,3)+0.88625*TPK%K110(:)*PCONC(:,32)+&
&0.13414*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K1&
&18(:)*PCONC(:,40)+0.20740*TPK%K125(:)*PCONC(:,5)
!
!HCHO/XO2=+K127*<MO2>
 PJAC(:,22,41)=+TPK%K127(:)*PCONC(:,32)
!
!ALD/O3=+0.51468*K079*<ALKE>+0.00000*K080*<BIO>+0.15692*K081*<CARBO>
 PJAC(:,23,1)=+0.51468*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)+&
&0.15692*TPK%K081(:)*PCONC(:,25)
!
!ALD/H2O2=0.0
!
!ALD/NO=+0.33144*K091*<ALKAP>+0.42125*K092*<ALKEP>+0.00000*K093*<BIOP>+0.07368*
!K095*<CARBOP>+1.01182*K096*<OLN>
 PJAC(:,23,3)=+0.33144*TPK%K091(:)*PCONC(:,33)+0.42125*TPK%K092(:)*PCONC(:,34)+&
&0.00000*TPK%K093(:)*PCONC(:,35)+0.07368*TPK%K095(:)*PCONC(:,39)+1.01182*TPK%K0&
&96(:)*PCONC(:,40)
!
!ALD/NO2=0.0
!
!ALD/NO3=-K073*<ALD>+0.05265*K074*<CARBO>+0.33743*K120*<ALKAP>+0.43039*K121*<AL
!KEP>+0.00000*K122*<BIOP>+0.02936*K124*<CARBOP>+0.91850*K125*<OLN>
 PJAC(:,23,5)=-TPK%K073(:)*PCONC(:,23)+0.05265*TPK%K074(:)*PCONC(:,25)+0.33743*&
&TPK%K120(:)*PCONC(:,33)+0.43039*TPK%K121(:)*PCONC(:,34)+0.00000*TPK%K122(:)*PC&
&ONC(:,35)+0.02936*TPK%K124(:)*PCONC(:,39)+0.91850*TPK%K125(:)*PCONC(:,40)
!
!ALD/N2O5=0.0
!
!ALD/HONO=0.0
!
!ALD/HNO3=0.0
!
!ALD/HNO4=0.0
!
!ALD/NH3=0.0
!
!ALD/SO2=0.0
!
!ALD/SULF=0.0
!
!ALD/CO=0.0
!
!ALD/OH=+0.08173*K058*<ALKA>-K063*<ALD>+0.06253*K065*<CARBO>+0.07335*K069*<OP2>
 PJAC(:,23,14)=+0.08173*TPK%K058(:)*PCONC(:,18)-TPK%K063(:)*PCONC(:,23)+0.06253&
&*TPK%K065(:)*PCONC(:,25)+0.07335*TPK%K069(:)*PCONC(:,29)
!
!ALD/HO2=0.0
!
!ALD/CH4=0.0
!
!ALD/ETH=0.0
!
!ALD/ALKA=+0.08173*K058*<OH>
 PJAC(:,23,18)=+0.08173*TPK%K058(:)*PCONC(:,14)
!
!ALD/ALKE=+0.51468*K079*<O3>
 PJAC(:,23,19)=+0.51468*TPK%K079(:)*PCONC(:,1)
!
!ALD/BIO=+0.00000*K080*<O3>
 PJAC(:,23,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!ALD/ARO=0.0
!
!ALD/HCHO=0.0
!
!ALD/ALD=-K012-K063*<OH>-K073*<NO3>
 PJAC(:,23,23)=-TPK%K012(:)-TPK%K063(:)*PCONC(:,14)-TPK%K073(:)*PCONC(:,5)
!
!ALD/KET=0.0
!
!ALD/CARBO=+K055*<O3P>+0.06253*K065*<OH>+0.05265*K074*<NO3>+0.15692*K081*<O3>
 PJAC(:,23,25)=+TPK%K055(:)*TPK%O3P(:)+0.06253*TPK%K065(:)*PCONC(:,14)+0.05265*&
&TPK%K074(:)*PCONC(:,5)+0.15692*TPK%K081(:)*PCONC(:,1)
!
!ALD/ONIT=+0.20*K017
 PJAC(:,23,26)=+0.20*TPK%K017(:)
!
!ALD/PAN=0.0
!
!ALD/OP1=0.0
!
!ALD/OP2=+0.96205*K014+0.07335*K069*<OH>
 PJAC(:,23,29)=+0.96205*TPK%K014(:)+0.07335*TPK%K069(:)*PCONC(:,14)
!
!ALD/ORA1=0.0
!
!ALD/ORA2=0.0
!
!ALD/MO2=+0.56070*K105*<ALKAP>+0.46413*K106*<ALKEP>+0.00000*K107*<BIOP>+0.08295
!*K109*<CARBOP>+0.41524*K110*<OLN>
 PJAC(:,23,32)=+0.56070*TPK%K105(:)*PCONC(:,33)+0.46413*TPK%K106(:)*PCONC(:,34)&
&+0.00000*TPK%K107(:)*PCONC(:,35)+0.08295*TPK%K109(:)*PCONC(:,39)+0.41524*TPK%K&
&110(:)*PCONC(:,40)
!
!ALD/ALKAP=+0.33144*K091*<NO>+0.56070*K105*<MO2>+0.71461*K111*<CARBOP>+0.33743*
!K120*<NO3>
 PJAC(:,23,33)=+0.33144*TPK%K091(:)*PCONC(:,3)+0.56070*TPK%K105(:)*PCONC(:,32)+&
&0.71461*TPK%K111(:)*PCONC(:,39)+0.33743*TPK%K120(:)*PCONC(:,5)
!
!ALD/ALKEP=+0.42125*K092*<NO>+0.46413*K106*<MO2>+0.68374*K112*<CARBOP>+0.43039*
!K121*<NO3>
 PJAC(:,23,34)=+0.42125*TPK%K092(:)*PCONC(:,3)+0.46413*TPK%K106(:)*PCONC(:,32)+&
&0.68374*TPK%K112(:)*PCONC(:,39)+0.43039*TPK%K121(:)*PCONC(:,5)
!
!ALD/BIOP=+0.00000*K093*<NO>+0.00000*K107*<MO2>+0.00000*K113*<CARBOP>+0.00000*K
!122*<NO3>
 PJAC(:,23,35)=+0.00000*TPK%K093(:)*PCONC(:,3)+0.00000*TPK%K107(:)*PCONC(:,32)+&
&0.00000*TPK%K113(:)*PCONC(:,39)+0.00000*TPK%K122(:)*PCONC(:,5)
!
!ALD/PHO=0.0
!
!ALD/ADD=0.0
!
!ALD/AROP=0.0
!
!ALD/CARBOP=+0.07368*K095*<NO>+0.08295*K109*<MO2>+0.71461*K111*<ALKAP>+0.68374*
!K112*<ALKEP>+0.00000*K113*<BIOP>+0.06969*K115*<CARBOP>+0.06969*K115*<CARBOP>+0
!.42122*K116*<OLN>+0.02936*K124*<NO3>
 PJAC(:,23,39)=+0.07368*TPK%K095(:)*PCONC(:,3)+0.08295*TPK%K109(:)*PCONC(:,32)+&
&0.71461*TPK%K111(:)*PCONC(:,33)+0.68374*TPK%K112(:)*PCONC(:,34)+0.00000*TPK%K1&
&13(:)*PCONC(:,35)+0.06969*TPK%K115(:)*PCONC(:,39)+0.06969*TPK%K115(:)*PCONC(:,&
&39)+0.42122*TPK%K116(:)*PCONC(:,40)+0.02936*TPK%K124(:)*PCONC(:,5)
!
!ALD/OLN=+1.01182*K096*<NO>+0.41524*K110*<MO2>+0.42122*K116*<CARBOP>+0.00000*K1
!18*<OLN>+0.00000*K118*<OLN>+0.91850*K125*<NO3>
 PJAC(:,23,40)=+1.01182*TPK%K096(:)*PCONC(:,3)+0.41524*TPK%K110(:)*PCONC(:,32)+&
&0.42122*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K1&
&18(:)*PCONC(:,40)+0.91850*TPK%K125(:)*PCONC(:,5)
!
!ALD/XO2=0.0
!
!KET/O3=+0.07377*K079*<ALKE>+0.00000*K080*<BIO>
 PJAC(:,24,1)=+0.07377*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)
!
!KET/H2O2=0.0
!
!KET/NO=+0.54531*K091*<ALKAP>+0.05220*K092*<ALKEP>+0.00000*K093*<BIOP>+0.37862*
!K096*<OLN>
 PJAC(:,24,3)=+0.54531*TPK%K091(:)*PCONC(:,33)+0.05220*TPK%K092(:)*PCONC(:,34)+&
&0.00000*TPK%K093(:)*PCONC(:,35)+0.37862*TPK%K096(:)*PCONC(:,40)
!
!KET/NO2=0.0
!
!KET/NO3=+0.00632*K074*<CARBO>+0.62978*K120*<ALKAP>+0.02051*K121*<ALKEP>+0.0000
!0*K122*<BIOP>+0.34740*K125*<OLN>
 PJAC(:,24,5)=+0.00632*TPK%K074(:)*PCONC(:,25)+0.62978*TPK%K120(:)*PCONC(:,33)+&
&0.02051*TPK%K121(:)*PCONC(:,34)+0.00000*TPK%K122(:)*PCONC(:,35)+0.34740*TPK%K1&
&25(:)*PCONC(:,40)
!
!KET/N2O5=0.0
!
!KET/HONO=0.0
!
!KET/HNO3=0.0
!
!KET/HNO4=0.0
!
!KET/NH3=0.0
!
!KET/SO2=0.0
!
!KET/SULF=0.0
!
!KET/CO=0.0
!
!KET/OH=+0.03498*K058*<ALKA>-K064*<KET>+0.00853*K065*<CARBO>+0.37591*K069*<OP2>
 PJAC(:,24,14)=+0.03498*TPK%K058(:)*PCONC(:,18)-TPK%K064(:)*PCONC(:,24)+0.00853&
&*TPK%K065(:)*PCONC(:,25)+0.37591*TPK%K069(:)*PCONC(:,29)
!
!KET/HO2=0.0
!
!KET/CH4=0.0
!
!KET/ETH=0.0
!
!KET/ALKA=+0.03498*K058*<OH>
 PJAC(:,24,18)=+0.03498*TPK%K058(:)*PCONC(:,14)
!
!KET/ALKE=+0.07377*K079*<O3>
 PJAC(:,24,19)=+0.07377*TPK%K079(:)*PCONC(:,1)
!
!KET/BIO=+0.00000*K080*<O3>
 PJAC(:,24,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!KET/ARO=0.0
!
!KET/HCHO=0.0
!
!KET/ALD=0.0
!
!KET/KET=-K015-K064*<OH>
 PJAC(:,24,24)=-TPK%K015(:)-TPK%K064(:)*PCONC(:,14)
!
!KET/CARBO=+0.00853*K065*<OH>+0.00632*K074*<NO3>
 PJAC(:,24,25)=+0.00853*TPK%K065(:)*PCONC(:,14)+0.00632*TPK%K074(:)*PCONC(:,5)
!
!KET/ONIT=+0.80*K017
 PJAC(:,24,26)=+0.80*TPK%K017(:)
!
!KET/PAN=0.0
!
!KET/OP1=0.0
!
!KET/OP2=+0.37591*K069*<OH>
 PJAC(:,24,29)=+0.37591*TPK%K069(:)*PCONC(:,14)
!
!KET/ORA1=0.0
!
!KET/ORA2=0.0
!
!KET/MO2=+0.09673*K105*<ALKAP>+0.03814*K106*<ALKEP>+0.00000*K107*<BIOP>+0.09667
!*K110*<OLN>
 PJAC(:,24,32)=+0.09673*TPK%K105(:)*PCONC(:,33)+0.03814*TPK%K106(:)*PCONC(:,34)&
&+0.00000*TPK%K107(:)*PCONC(:,35)+0.09667*TPK%K110(:)*PCONC(:,40)
!
!KET/ALKAP=+0.54531*K091*<NO>+0.09673*K105*<MO2>+0.18819*K111*<CARBOP>+0.62978*
!K120*<NO3>
 PJAC(:,24,33)=+0.54531*TPK%K091(:)*PCONC(:,3)+0.09673*TPK%K105(:)*PCONC(:,32)+&
&0.18819*TPK%K111(:)*PCONC(:,39)+0.62978*TPK%K120(:)*PCONC(:,5)
!
!KET/ALKEP=+0.05220*K092*<NO>+0.03814*K106*<MO2>+0.06579*K112*<CARBOP>+0.02051*
!K121*<NO3>
 PJAC(:,24,34)=+0.05220*TPK%K092(:)*PCONC(:,3)+0.03814*TPK%K106(:)*PCONC(:,32)+&
&0.06579*TPK%K112(:)*PCONC(:,39)+0.02051*TPK%K121(:)*PCONC(:,5)
!
!KET/BIOP=+0.00000*K093*<NO>+0.00000*K107*<MO2>+0.00000*K113*<CARBOP>+0.00000*K
!122*<NO3>
 PJAC(:,24,35)=+0.00000*TPK%K093(:)*PCONC(:,3)+0.00000*TPK%K107(:)*PCONC(:,32)+&
&0.00000*TPK%K113(:)*PCONC(:,39)+0.00000*TPK%K122(:)*PCONC(:,5)
!
!KET/PHO=0.0
!
!KET/ADD=0.0
!
!KET/AROP=0.0
!
!KET/CARBOP=+0.18819*K111*<ALKAP>+0.06579*K112*<ALKEP>+0.00000*K113*<BIOP>+0.02
!190*K115*<CARBOP>+0.02190*K115*<CARBOP>+0.10822*K116*<OLN>
 PJAC(:,24,39)=+0.18819*TPK%K111(:)*PCONC(:,33)+0.06579*TPK%K112(:)*PCONC(:,34)&
&+0.00000*TPK%K113(:)*PCONC(:,35)+0.02190*TPK%K115(:)*PCONC(:,39)+0.02190*TPK%K&
&115(:)*PCONC(:,39)+0.10822*TPK%K116(:)*PCONC(:,40)
!
!KET/OLN=+0.37862*K096*<NO>+0.09667*K110*<MO2>+0.10822*K116*<CARBOP>+0.00000*K1
!18*<OLN>+0.00000*K118*<OLN>+0.34740*K125*<NO3>
 PJAC(:,24,40)=+0.37862*TPK%K096(:)*PCONC(:,3)+0.09667*TPK%K110(:)*PCONC(:,32)+&
&0.10822*TPK%K116(:)*PCONC(:,39)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TPK%K1&
&18(:)*PCONC(:,40)+0.34740*TPK%K125(:)*PCONC(:,5)
!
!KET/XO2=0.0
!
!CARBO/O3=+0.00000*K079*<ALKE>+0.39754*K080*<BIO>+1.07583*K081*<CARBO>-K081*<CA
!RBO>
 PJAC(:,25,1)=+0.00000*TPK%K079(:)*PCONC(:,19)+0.39754*TPK%K080(:)*PCONC(:,20)+&
&1.07583*TPK%K081(:)*PCONC(:,25)-TPK%K081(:)*PCONC(:,25)
!
!CARBO/H2O2=0.0
!
!CARBO/NO=+0.03407*K091*<ALKAP>+0.45463*K093*<BIOP>+2.06993*K094*<AROP>+0.08670
!*K095*<CARBOP>
 PJAC(:,25,3)=+0.03407*TPK%K091(:)*PCONC(:,33)+0.45463*TPK%K093(:)*PCONC(:,35)+&
&2.06993*TPK%K094(:)*PCONC(:,38)+0.08670*TPK%K095(:)*PCONC(:,39)
!
!CARBO/NO2=0.0
!
!CARBO/NO3=+0.10530*K074*<CARBO>-K074*<CARBO>+0.00000*K076*<ALKE>+0.91741*K077*
!<BIO>+0.03531*K120*<ALKAP>+0.61160*K122*<BIOP>+2.81904*K123*<AROP>+0.03455*K12
!4*<CARBOP>
 PJAC(:,25,5)=+0.10530*TPK%K074(:)*PCONC(:,25)-TPK%K074(:)*PCONC(:,25)+0.00000*&
&TPK%K076(:)*PCONC(:,19)+0.91741*TPK%K077(:)*PCONC(:,20)+0.03531*TPK%K120(:)*PC&
&ONC(:,33)+0.61160*TPK%K122(:)*PCONC(:,35)+2.81904*TPK%K123(:)*PCONC(:,38)+0.03&
&455*TPK%K124(:)*PCONC(:,39)
!
!CARBO/N2O5=0.0
!
!CARBO/HONO=0.0
!
!CARBO/HNO3=0.0
!
!CARBO/HNO4=0.0
!
!CARBO/NH3=0.0
!
!CARBO/SO2=0.0
!
!CARBO/SULF=0.0
!
!CARBO/CO=0.0
!
!CARBO/OH=+0.00835*K058*<ALKA>+0.16919*K065*<CARBO>-K065*<CARBO>+0.21863*K070*<
!PAN>
 PJAC(:,25,14)=+0.00835*TPK%K058(:)*PCONC(:,18)+0.16919*TPK%K065(:)*PCONC(:,25)&
&-TPK%K065(:)*PCONC(:,25)+0.21863*TPK%K070(:)*PCONC(:,27)
!
!CARBO/HO2=0.0
!
!CARBO/CH4=0.0
!
!CARBO/ETH=0.0
!
!CARBO/ALKA=+0.00835*K058*<OH>
 PJAC(:,25,18)=+0.00835*TPK%K058(:)*PCONC(:,14)
!
!CARBO/ALKE=+0.00000*K076*<NO3>+0.00000*K079*<O3>
 PJAC(:,25,19)=+0.00000*TPK%K076(:)*PCONC(:,5)+0.00000*TPK%K079(:)*PCONC(:,1)
!
!CARBO/BIO=+0.13255*K054*<O3P>+0.91741*K077*<NO3>+0.39754*K080*<O3>
 PJAC(:,25,20)=+0.13255*TPK%K054(:)*TPK%O3P(:)+0.91741*TPK%K077(:)*PCONC(:,5)+0&
&.39754*TPK%K080(:)*PCONC(:,1)
!
!CARBO/ARO=0.0
!
!CARBO/HCHO=0.0
!
!CARBO/ALD=0.0
!
!CARBO/KET=0.0
!
!CARBO/CARBO=-K016-K055*<O3P>+0.16919*K065*<OH>-K065*<OH>+0.10530*K074*<NO3>-K0
!74*<NO3>+1.07583*K081*<O3>-K081*<O3>
 PJAC(:,25,25)=-TPK%K016(:)-TPK%K055(:)*TPK%O3P(:)+0.16919*TPK%K065(:)*PCONC(:,&
&14)-TPK%K065(:)*PCONC(:,14)+0.10530*TPK%K074(:)*PCONC(:,5)-TPK%K074(:)*PCONC(:&
&,5)+1.07583*TPK%K081(:)*PCONC(:,1)-TPK%K081(:)*PCONC(:,1)
!
!CARBO/ONIT=0.0
!
!CARBO/PAN=+0.21863*K070*<OH>
 PJAC(:,25,27)=+0.21863*TPK%K070(:)*PCONC(:,14)
!
!CARBO/OP1=0.0
!
!CARBO/OP2=0.0
!
!CARBO/ORA1=0.0
!
!CARBO/ORA2=0.0
!
!CARBO/MO2=+0.07976*K105*<ALKAP>+0.56064*K107*<BIOP>+1.99461*K108*<AROP>+0.1538
!7*K109*<CARBOP>
 PJAC(:,25,32)=+0.07976*TPK%K105(:)*PCONC(:,33)+0.56064*TPK%K107(:)*PCONC(:,35)&
&+1.99461*TPK%K108(:)*PCONC(:,38)+0.15387*TPK%K109(:)*PCONC(:,39)
!
!CARBO/ALKAP=+0.03407*K091*<NO>+0.07976*K105*<MO2>+0.06954*K111*<CARBOP>+0.0353
!1*K120*<NO3>
 PJAC(:,25,33)=+0.03407*TPK%K091(:)*PCONC(:,3)+0.07976*TPK%K105(:)*PCONC(:,32)+&
&0.06954*TPK%K111(:)*PCONC(:,39)+0.03531*TPK%K120(:)*PCONC(:,5)
!
!CARBO/ALKEP=0.0
!
!CARBO/BIOP=+0.45463*K093*<NO>+0.56064*K107*<MO2>+0.78591*K113*<CARBOP>+0.61160
!*K122*<NO3>
 PJAC(:,25,35)=+0.45463*TPK%K093(:)*PCONC(:,3)+0.56064*TPK%K107(:)*PCONC(:,32)+&
&0.78591*TPK%K113(:)*PCONC(:,39)+0.61160*TPK%K122(:)*PCONC(:,5)
!
!CARBO/PHO=0.0
!
!CARBO/ADD=0.0
!
!CARBO/AROP=+2.06993*K094*<NO>+1.99461*K108*<MO2>+1.99455*K114*<CARBOP>+2.81904
!*K123*<NO3>
 PJAC(:,25,38)=+2.06993*TPK%K094(:)*PCONC(:,3)+1.99461*TPK%K108(:)*PCONC(:,32)+&
&1.99455*TPK%K114(:)*PCONC(:,39)+2.81904*TPK%K123(:)*PCONC(:,5)
!
!CARBO/CARBOP=+0.08670*K095*<NO>+0.15387*K109*<MO2>+0.06954*K111*<ALKAP>+0.7859
!1*K113*<BIOP>+1.99455*K114*<AROP>+0.10777*K115*<CARBOP>+0.10777*K115*<CARBOP>+
!0.03455*K124*<NO3>
 PJAC(:,25,39)=+0.08670*TPK%K095(:)*PCONC(:,3)+0.15387*TPK%K109(:)*PCONC(:,32)+&
&0.06954*TPK%K111(:)*PCONC(:,33)+0.78591*TPK%K113(:)*PCONC(:,35)+1.99455*TPK%K1&
&14(:)*PCONC(:,38)+0.10777*TPK%K115(:)*PCONC(:,39)+0.10777*TPK%K115(:)*PCONC(:,&
&39)+0.03455*TPK%K124(:)*PCONC(:,5)
!
!CARBO/OLN=0.0
!
!CARBO/XO2=0.0
!
RETURN
END SUBROUTINE SUBJ4
!
SUBROUTINE SUBJ5
!
!Indices 26 a 30
!
!
!ONIT/O3=0.0
!
!ONIT/H2O2=0.0
!
!ONIT/NO=+0.08459*K091*<ALKAP>+0.15300*K093*<BIOP>+0.04885*K094*<AROP>+0.18401*
!K096*<OLN>
 PJAC(:,26,3)=+0.08459*TPK%K091(:)*PCONC(:,33)+0.15300*TPK%K093(:)*PCONC(:,35)+&
&0.04885*TPK%K094(:)*PCONC(:,38)+0.18401*TPK%K096(:)*PCONC(:,40)
!
!ONIT/NO2=+K083*<PHO>
 PJAC(:,26,4)=+TPK%K083(:)*PCONC(:,36)
!
!ONIT/NO3=+0.60*K078*<PAN>+0.25928*K125*<OLN>
 PJAC(:,26,5)=+0.60*TPK%K078(:)*PCONC(:,27)+0.25928*TPK%K125(:)*PCONC(:,40)
!
!ONIT/N2O5=0.0
!
!ONIT/HONO=0.0
!
!ONIT/HNO3=0.0
!
!ONIT/HNO4=0.0
!
!ONIT/NH3=0.0
!
!ONIT/SO2=0.0
!
!ONIT/SULF=0.0
!
!ONIT/CO=0.0
!
!ONIT/OH=-K071*<ONIT>
 PJAC(:,26,14)=-TPK%K071(:)*PCONC(:,26)
!
!ONIT/HO2=+K103*<OLN>
 PJAC(:,26,15)=+TPK%K103(:)*PCONC(:,40)
!
!ONIT/CH4=0.0
!
!ONIT/ETH=0.0
!
!ONIT/ALKA=0.0
!
!ONIT/ALKE=0.0
!
!ONIT/BIO=0.0
!
!ONIT/ARO=0.0
!
!ONIT/HCHO=0.0
!
!ONIT/ALD=0.0
!
!ONIT/KET=0.0
!
!ONIT/CARBO=0.0
!
!ONIT/ONIT=-K017-K071*<OH>
 PJAC(:,26,26)=-TPK%K017(:)-TPK%K071(:)*PCONC(:,14)
!
!ONIT/PAN=+0.60*K078*<NO3>
 PJAC(:,26,27)=+0.60*TPK%K078(:)*PCONC(:,5)
!
!ONIT/OP1=0.0
!
!ONIT/OP2=0.0
!
!ONIT/ORA1=0.0
!
!ONIT/ORA2=0.0
!
!ONIT/MO2=+0.67560*K110*<OLN>
 PJAC(:,26,32)=+0.67560*TPK%K110(:)*PCONC(:,40)
!
!ONIT/ALKAP=+0.08459*K091*<NO>
 PJAC(:,26,33)=+0.08459*TPK%K091(:)*PCONC(:,3)
!
!ONIT/ALKEP=0.0
!
!ONIT/BIOP=+0.15300*K093*<NO>
 PJAC(:,26,35)=+0.15300*TPK%K093(:)*PCONC(:,3)
!
!ONIT/PHO=+K083*<NO2>
 PJAC(:,26,36)=+TPK%K083(:)*PCONC(:,4)
!
!ONIT/ADD=0.0
!
!ONIT/AROP=+0.04885*K094*<NO>
 PJAC(:,26,38)=+0.04885*TPK%K094(:)*PCONC(:,3)
!
!ONIT/CARBOP=+0.66562*K116*<OLN>
 PJAC(:,26,39)=+0.66562*TPK%K116(:)*PCONC(:,40)
!
!ONIT/OLN=+0.18401*K096*<NO>+K103*<HO2>+0.67560*K110*<MO2>+0.66562*K116*<CARBOP
!>+2.00*K117*<OLN>+2.00*K117*<OLN>+0.00000*K118*<OLN>+0.00000*K118*<OLN>+0.2592
!8*K125*<NO3>
 PJAC(:,26,40)=+0.18401*TPK%K096(:)*PCONC(:,3)+TPK%K103(:)*PCONC(:,15)+0.67560*&
&TPK%K110(:)*PCONC(:,32)+0.66562*TPK%K116(:)*PCONC(:,39)+2.00*TPK%K117(:)*PCONC&
&(:,40)+2.00*TPK%K117(:)*PCONC(:,40)+0.00000*TPK%K118(:)*PCONC(:,40)+0.00000*TP&
&K%K118(:)*PCONC(:,40)+0.25928*TPK%K125(:)*PCONC(:,5)
!
!ONIT/XO2=0.0
!
!PAN/O3=+0.30000*K082*<PAN>-K082*<PAN>
 PJAC(:,27,1)=+0.30000*TPK%K082(:)*PCONC(:,27)-TPK%K082(:)*PCONC(:,27)
!
!PAN/H2O2=0.0
!
!PAN/NO=0.0
!
!PAN/NO2=+1.00000*K088*<CARBOP>
 PJAC(:,27,4)=+1.00000*TPK%K088(:)*PCONC(:,39)
!
!PAN/NO3=+0.40000*K078*<PAN>-K078*<PAN>
 PJAC(:,27,5)=+0.40000*TPK%K078(:)*PCONC(:,27)-TPK%K078(:)*PCONC(:,27)
!
!PAN/N2O5=0.0
!
!PAN/HONO=0.0
!
!PAN/HNO3=0.0
!
!PAN/HNO4=0.0
!
!PAN/NH3=0.0
!
!PAN/SO2=0.0
!
!PAN/SULF=0.0
!
!PAN/CO=0.0
!
!PAN/OH=+0.28107*K070*<PAN>-K070*<PAN>
 PJAC(:,27,14)=+0.28107*TPK%K070(:)*PCONC(:,27)-TPK%K070(:)*PCONC(:,27)
!
!PAN/HO2=0.0
!
!PAN/CH4=0.0
!
!PAN/ETH=0.0
!
!PAN/ALKA=0.0
!
!PAN/ALKE=0.0
!
!PAN/BIO=0.0
!
!PAN/ARO=0.0
!
!PAN/HCHO=0.0
!
!PAN/ALD=0.0
!
!PAN/KET=0.0
!
!PAN/CARBO=0.0
!
!PAN/ONIT=0.0
!
!PAN/PAN=+0.28107*K070*<OH>-K070*<OH>+0.40000*K078*<NO3>-K078*<NO3>+0.30000*K08
!2*<O3>-K082*<O3>-K089
 PJAC(:,27,27)=+0.28107*TPK%K070(:)*PCONC(:,14)-TPK%K070(:)*PCONC(:,14)+0.40000&
&*TPK%K078(:)*PCONC(:,5)-TPK%K078(:)*PCONC(:,5)+0.30000*TPK%K082(:)*PCONC(:,1)-&
&TPK%K082(:)*PCONC(:,1)-TPK%K089(:)
!
!PAN/OP1=0.0
!
!PAN/OP2=0.0
!
!PAN/ORA1=0.0
!
!PAN/ORA2=0.0
!
!PAN/MO2=0.0
!
!PAN/ALKAP=0.0
!
!PAN/ALKEP=0.0
!
!PAN/BIOP=0.0
!
!PAN/PHO=0.0
!
!PAN/ADD=0.0
!
!PAN/AROP=0.0
!
!PAN/CARBOP=+1.00000*K088*<NO2>
 PJAC(:,27,39)=+1.00000*TPK%K088(:)*PCONC(:,4)
!
!PAN/OLN=0.0
!
!PAN/XO2=0.0
!
!OP1/O3=0.0
!
!OP1/H2O2=0.0
!
!OP1/NO=0.0
!
!OP1/NO2=0.0
!
!OP1/NO3=0.0
!
!OP1/N2O5=0.0
!
!OP1/HONO=0.0
!
!OP1/HNO3=0.0
!
!OP1/HNO4=0.0
!
!OP1/NH3=0.0
!
!OP1/SO2=0.0
!
!OP1/SULF=0.0
!
!OP1/CO=0.0
!
!OP1/OH=-K068*<OP1>
 PJAC(:,28,14)=-TPK%K068(:)*PCONC(:,28)
!
!OP1/HO2=+K097*<MO2>
 PJAC(:,28,15)=+TPK%K097(:)*PCONC(:,32)
!
!OP1/CH4=0.0
!
!OP1/ETH=0.0
!
!OP1/ALKA=0.0
!
!OP1/ALKE=0.0
!
!OP1/BIO=0.0
!
!OP1/ARO=0.0
!
!OP1/HCHO=0.0
!
!OP1/ALD=0.0
!
!OP1/KET=0.0
!
!OP1/CARBO=0.0
!
!OP1/ONIT=0.0
!
!OP1/PAN=0.0
!
!OP1/OP1=-K013-K068*<OH>
 PJAC(:,28,28)=-TPK%K013(:)-TPK%K068(:)*PCONC(:,14)
!
!OP1/OP2=0.0
!
!OP1/ORA1=0.0
!
!OP1/ORA2=0.0
!
!OP1/MO2=+K097*<HO2>
 PJAC(:,28,32)=+TPK%K097(:)*PCONC(:,15)
!
!OP1/ALKAP=0.0
!
!OP1/ALKEP=0.0
!
!OP1/BIOP=0.0
!
!OP1/PHO=0.0
!
!OP1/ADD=0.0
!
!OP1/AROP=0.0
!
!OP1/CARBOP=0.0
!
!OP1/OLN=0.0
!
!OP1/XO2=0.0
!
!OP2/O3=+0.10149*K081*<CARBO>
 PJAC(:,29,1)=+0.10149*TPK%K081(:)*PCONC(:,25)
!
!OP2/H2O2=0.0
!
!OP2/NO=0.0
!
!OP2/NO2=0.0
!
!OP2/NO3=0.0
!
!OP2/N2O5=0.0
!
!OP2/HONO=0.0
!
!OP2/HNO3=0.0
!
!OP2/HNO4=0.0
!
!OP2/NH3=0.0
!
!OP2/SO2=0.0
!
!OP2/SULF=0.0
!
!OP2/CO=0.0
!
!OP2/OH=-K069*<OP2>
 PJAC(:,29,14)=-TPK%K069(:)*PCONC(:,29)
!
!OP2/HO2=+1.00524*K098*<ALKAP>+1.00524*K099*<ALKEP>+1.00524*K0100*<BIOP>+1.0052
!4*K0101*<AROP>+0.80904*K0102*<CARBOP>+1.00524*K126*<XO2>
 PJAC(:,29,15)=+1.00524*TPK%K098(:)*PCONC(:,33)+1.00524*TPK%K099(:)*PCONC(:,34)&
&+1.00524*TPK%K0100(:)*PCONC(:,35)+1.00524*TPK%K0101(:)*PCONC(:,38)+0.80904*TPK&
&%K0102(:)*PCONC(:,39)+1.00524*TPK%K126(:)*PCONC(:,41)
!
!OP2/CH4=0.0
!
!OP2/ETH=0.0
!
!OP2/ALKA=0.0
!
!OP2/ALKE=0.0
!
!OP2/BIO=0.0
!
!OP2/ARO=0.0
!
!OP2/HCHO=0.0
!
!OP2/ALD=0.0
!
!OP2/KET=0.0
!
!OP2/CARBO=+0.10149*K081*<O3>
 PJAC(:,29,25)=+0.10149*TPK%K081(:)*PCONC(:,1)
!
!OP2/ONIT=0.0
!
!OP2/PAN=0.0
!
!OP2/OP1=0.0
!
!OP2/OP2=-K014-K069*<OH>
 PJAC(:,29,29)=-TPK%K014(:)-TPK%K069(:)*PCONC(:,14)
!
!OP2/ORA1=0.0
!
!OP2/ORA2=0.0
!
!OP2/MO2=0.0
!
!OP2/ALKAP=+1.00524*K098*<HO2>
 PJAC(:,29,33)=+1.00524*TPK%K098(:)*PCONC(:,15)
!
!OP2/ALKEP=+1.00524*K099*<HO2>
 PJAC(:,29,34)=+1.00524*TPK%K099(:)*PCONC(:,15)
!
!OP2/BIOP=+1.00524*K0100*<HO2>
 PJAC(:,29,35)=+1.00524*TPK%K0100(:)*PCONC(:,15)
!
!OP2/PHO=0.0
!
!OP2/ADD=0.0
!
!OP2/AROP=+1.00524*K0101*<HO2>
 PJAC(:,29,38)=+1.00524*TPK%K0101(:)*PCONC(:,15)
!
!OP2/CARBOP=+0.80904*K0102*<HO2>
 PJAC(:,29,39)=+0.80904*TPK%K0102(:)*PCONC(:,15)
!
!OP2/OLN=0.0
!
!OP2/XO2=+1.00524*K126*<HO2>
 PJAC(:,29,41)=+1.00524*TPK%K126(:)*PCONC(:,15)
!
!ORA1/O3=+0.15343*K079*<ALKE>+0.15000*K080*<BIO>+0.10788*K081*<CARBO>+0.11*K082
!*<PAN>
 PJAC(:,30,1)=+0.15343*TPK%K079(:)*PCONC(:,19)+0.15000*TPK%K080(:)*PCONC(:,20)+&
&0.10788*TPK%K081(:)*PCONC(:,25)+0.11*TPK%K082(:)*PCONC(:,27)
!
!ORA1/H2O2=0.0
!
!ORA1/NO=0.0
!
!ORA1/NO2=0.0
!
!ORA1/NO3=0.0
!
!ORA1/N2O5=0.0
!
!ORA1/HONO=0.0
!
!ORA1/HNO3=0.0
!
!ORA1/HNO4=0.0
!
!ORA1/NH3=0.0
!
!ORA1/SO2=0.0
!
!ORA1/SULF=0.0
!
!ORA1/CO=0.0
!
!ORA1/OH=+0.00878*K058*<ALKA>-K066*<ORA1>
 PJAC(:,30,14)=+0.00878*TPK%K058(:)*PCONC(:,18)-TPK%K066(:)*PCONC(:,30)
!
!ORA1/HO2=0.0
!
!ORA1/CH4=0.0
!
!ORA1/ETH=0.0
!
!ORA1/ALKA=+0.00878*K058*<OH>
 PJAC(:,30,18)=+0.00878*TPK%K058(:)*PCONC(:,14)
!
!ORA1/ALKE=+0.15343*K079*<O3>
 PJAC(:,30,19)=+0.15343*TPK%K079(:)*PCONC(:,1)
!
!ORA1/BIO=+0.15000*K080*<O3>
 PJAC(:,30,20)=+0.15000*TPK%K080(:)*PCONC(:,1)
!
!ORA1/ARO=0.0
!
!ORA1/HCHO=0.0
!
!ORA1/ALD=0.0
!
!ORA1/KET=0.0
!
!ORA1/CARBO=+0.10788*K081*<O3>
 PJAC(:,30,25)=+0.10788*TPK%K081(:)*PCONC(:,1)
!
!ORA1/ONIT=0.0
!
!ORA1/PAN=+0.11*K082*<O3>
 PJAC(:,30,27)=+0.11*TPK%K082(:)*PCONC(:,1)
!
!ORA1/OP1=0.0
!
!ORA1/OP2=0.0
!
!ORA1/ORA1=-K066*<OH>
 PJAC(:,30,30)=-TPK%K066(:)*PCONC(:,14)
!
!ORA1/ORA2=0.0
!
!ORA1/MO2=0.0
!
!ORA1/ALKAP=0.0
!
!ORA1/ALKEP=0.0
!
!ORA1/BIOP=0.0
!
!ORA1/PHO=0.0
!
!ORA1/ADD=0.0
!
!ORA1/AROP=0.0
!
!ORA1/CARBOP=0.0
!
!ORA1/OLN=0.0
!
!ORA1/XO2=0.0
!
RETURN
END SUBROUTINE SUBJ5
!
SUBROUTINE SUBJ6
!
!Indices 31 a 35
!
!
!ORA2/O3=+0.08143*K079*<ALKE>+0.00000*K080*<BIO>+0.20595*K081*<CARBO>
 PJAC(:,31,1)=+0.08143*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)+&
&0.20595*TPK%K081(:)*PCONC(:,25)
!
!ORA2/H2O2=0.0
!
!ORA2/NO=0.0
!
!ORA2/NO2=0.0
!
!ORA2/NO3=0.0
!
!ORA2/N2O5=0.0
!
!ORA2/HONO=0.0
!
!ORA2/HNO3=0.0
!
!ORA2/HNO4=0.0
!
!ORA2/NH3=0.0
!
!ORA2/SO2=0.0
!
!ORA2/SULF=0.0
!
!ORA2/CO=0.0
!
!ORA2/OH=-K067*<ORA2>
 PJAC(:,31,14)=-TPK%K067(:)*PCONC(:,31)
!
!ORA2/HO2=+0.17307*K0102*<CARBOP>
 PJAC(:,31,15)=+0.17307*TPK%K0102(:)*PCONC(:,39)
!
!ORA2/CH4=0.0
!
!ORA2/ETH=0.0
!
!ORA2/ALKA=0.0
!
!ORA2/ALKE=+0.08143*K079*<O3>
 PJAC(:,31,19)=+0.08143*TPK%K079(:)*PCONC(:,1)
!
!ORA2/BIO=+0.00000*K080*<O3>
 PJAC(:,31,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!ORA2/ARO=0.0
!
!ORA2/HCHO=0.0
!
!ORA2/ALD=0.0
!
!ORA2/KET=0.0
!
!ORA2/CARBO=+0.20595*K081*<O3>
 PJAC(:,31,25)=+0.20595*TPK%K081(:)*PCONC(:,1)
!
!ORA2/ONIT=0.0
!
!ORA2/PAN=0.0
!
!ORA2/OP1=0.0
!
!ORA2/OP2=0.0
!
!ORA2/ORA1=0.0
!
!ORA2/ORA2=-K067*<OH>
 PJAC(:,31,31)=-TPK%K067(:)*PCONC(:,14)
!
!ORA2/MO2=+0.13684*K109*<CARBOP>
 PJAC(:,31,32)=+0.13684*TPK%K109(:)*PCONC(:,39)
!
!ORA2/ALKAP=+0.49810*K111*<CARBOP>
 PJAC(:,31,33)=+0.49810*TPK%K111(:)*PCONC(:,39)
!
!ORA2/ALKEP=+0.49922*K112*<CARBOP>
 PJAC(:,31,34)=+0.49922*TPK%K112(:)*PCONC(:,39)
!
!ORA2/BIOP=+0.49400*K113*<CARBOP>
 PJAC(:,31,35)=+0.49400*TPK%K113(:)*PCONC(:,39)
!
!ORA2/PHO=0.0
!
!ORA2/ADD=0.0
!
!ORA2/AROP=0.0
!
!ORA2/CARBOP=+0.17307*K0102*<HO2>+0.13684*K109*<MO2>+0.49810*K111*<ALKAP>+0.499
!22*K112*<ALKEP>+0.49400*K113*<BIOP>+0.09955*K115*<CARBOP>+0.09955*K115*<CARBOP
!>+0.48963*K116*<OLN>
 PJAC(:,31,39)=+0.17307*TPK%K0102(:)*PCONC(:,15)+0.13684*TPK%K109(:)*PCONC(:,32&
&)+0.49810*TPK%K111(:)*PCONC(:,33)+0.49922*TPK%K112(:)*PCONC(:,34)+0.49400*TPK%&
&K113(:)*PCONC(:,35)+0.09955*TPK%K115(:)*PCONC(:,39)+0.09955*TPK%K115(:)*PCONC(&
&:,39)+0.48963*TPK%K116(:)*PCONC(:,40)
!
!ORA2/OLN=+0.48963*K116*<CARBOP>
 PJAC(:,31,40)=+0.48963*TPK%K116(:)*PCONC(:,39)
!
!ORA2/XO2=0.0
!
!MO2/O3=+0.13966*K079*<ALKE>+0.03000*K080*<BIO>
 PJAC(:,32,1)=+0.13966*TPK%K079(:)*PCONC(:,19)+0.03000*TPK%K080(:)*PCONC(:,20)
!
!MO2/H2O2=0.0
!
!MO2/NO=-K090*<MO2>+0.09016*K091*<ALKAP>+0.78134*K095*<CARBOP>
 PJAC(:,32,3)=-TPK%K090(:)*PCONC(:,32)+0.09016*TPK%K091(:)*PCONC(:,33)+0.78134*&
&TPK%K095(:)*PCONC(:,39)
!
!MO2/NO2=0.0
!
!MO2/NO3=-K119*<MO2>+0.09731*K120*<ALKAP>+0.91910*K124*<CARBOP>
 PJAC(:,32,5)=-TPK%K119(:)*PCONC(:,32)+0.09731*TPK%K120(:)*PCONC(:,33)+0.91910*&
&TPK%K124(:)*PCONC(:,39)
!
!MO2/N2O5=0.0
!
!MO2/HONO=0.0
!
!MO2/HNO3=0.0
!
!MO2/HNO4=0.0
!
!MO2/NH3=0.0
!
!MO2/SO2=0.0
!
!MO2/SULF=0.0
!
!MO2/CO=0.0
!
!MO2/OH=+K056*<CH4>+0.65*K068*<OP1>
 PJAC(:,32,14)=+TPK%K056(:)*PCONC(:,16)+0.65*TPK%K068(:)*PCONC(:,28)
!
!MO2/HO2=-K097*<MO2>
 PJAC(:,32,15)=-TPK%K097(:)*PCONC(:,32)
!
!MO2/CH4=+K056*<OH>
 PJAC(:,32,16)=+TPK%K056(:)*PCONC(:,14)
!
!MO2/ETH=0.0
!
!MO2/ALKA=0.0
!
!MO2/ALKE=+0.13966*K079*<O3>
 PJAC(:,32,19)=+0.13966*TPK%K079(:)*PCONC(:,1)
!
!MO2/BIO=+0.03000*K080*<O3>
 PJAC(:,32,20)=+0.03000*TPK%K080(:)*PCONC(:,1)
!
!MO2/ARO=0.0
!
!MO2/HCHO=0.0
!
!MO2/ALD=+K012
 PJAC(:,32,23)=+TPK%K012(:)
!
!MO2/KET=0.0
!
!MO2/CARBO=0.0
!
!MO2/ONIT=0.0
!
!MO2/PAN=0.0
!
!MO2/OP1=+0.65*K068*<OH>
 PJAC(:,32,28)=+0.65*TPK%K068(:)*PCONC(:,14)
!
!MO2/OP2=+0.03795*K014
 PJAC(:,32,29)=+0.03795*TPK%K014(:)
!
!MO2/ORA1=0.0
!
!MO2/ORA2=0.0
!
!MO2/MO2=-K090*<NO>-K097*<HO2>-K104*<MO2>-K104*<MO2>-K104*<MO2>-K104*<MO2>+0.01
!390*K105*<ALKAP>-K105*<ALKAP>-K106*<ALKEP>-K107*<BIOP>-K108*<AROP>+0.56031*K10
!9*<CARBOP>-K109*<CARBOP>-K110*<OLN>-K119*<NO3>-K127*<XO2>
 PJAC(:,32,32)=-TPK%K090(:)*PCONC(:,3)-TPK%K097(:)*PCONC(:,15)-TPK%K104(:)*PCON&
&C(:,32)-TPK%K104(:)*PCONC(:,32)-TPK%K104(:)*PCONC(:,32)-TPK%K104(:)*PCONC(:,32&
&)+0.01390*TPK%K105(:)*PCONC(:,33)-TPK%K105(:)*PCONC(:,33)-TPK%K106(:)*PCONC(:,&
&34)-TPK%K107(:)*PCONC(:,35)-TPK%K108(:)*PCONC(:,38)+0.56031*TPK%K109(:)*PCONC(&
&:,39)-TPK%K109(:)*PCONC(:,39)-TPK%K110(:)*PCONC(:,40)-TPK%K119(:)*PCONC(:,5)-T&
&PK%K127(:)*PCONC(:,41)
!
!MO2/ALKAP=+0.09016*K091*<NO>+0.01390*K105*<MO2>-K105*<MO2>+0.51480*K111*<CARBO
!P>+0.09731*K120*<NO3>
 PJAC(:,32,33)=+0.09016*TPK%K091(:)*PCONC(:,3)+0.01390*TPK%K105(:)*PCONC(:,32)-&
&TPK%K105(:)*PCONC(:,32)+0.51480*TPK%K111(:)*PCONC(:,39)+0.09731*TPK%K120(:)*PC&
&ONC(:,5)
!
!MO2/ALKEP=-K106*<MO2>+0.50078*K112*<CARBOP>
 PJAC(:,32,34)=-TPK%K106(:)*PCONC(:,32)+0.50078*TPK%K112(:)*PCONC(:,39)
!
!MO2/BIOP=-K107*<MO2>+0.50600*K113*<CARBOP>
 PJAC(:,32,35)=-TPK%K107(:)*PCONC(:,32)+0.50600*TPK%K113(:)*PCONC(:,39)
!
!MO2/PHO=0.0
!
!MO2/ADD=0.0
!
!MO2/AROP=-K108*<MO2>+K114*<CARBOP>
 PJAC(:,32,38)=-TPK%K108(:)*PCONC(:,32)+TPK%K114(:)*PCONC(:,39)
!
!MO2/CARBOP=+0.78134*K095*<NO>+0.56031*K109*<MO2>-K109*<MO2>+0.51480*K111*<ALKA
!P>+0.50078*K112*<ALKEP>+0.50600*K113*<BIOP>+K114*<AROP>+1.66702*K115*<CARBOP>+
!1.66702*K115*<CARBOP>+0.51037*K116*<OLN>+0.91910*K124*<NO3>+K128*<XO2>
 PJAC(:,32,39)=+0.78134*TPK%K095(:)*PCONC(:,3)+0.56031*TPK%K109(:)*PCONC(:,32)-&
&TPK%K109(:)*PCONC(:,32)+0.51480*TPK%K111(:)*PCONC(:,33)+0.50078*TPK%K112(:)*PC&
&ONC(:,34)+0.50600*TPK%K113(:)*PCONC(:,35)+TPK%K114(:)*PCONC(:,38)+1.66702*TPK%&
&K115(:)*PCONC(:,39)+1.66702*TPK%K115(:)*PCONC(:,39)+0.51037*TPK%K116(:)*PCONC(&
&:,40)+0.91910*TPK%K124(:)*PCONC(:,5)+TPK%K128(:)*PCONC(:,41)
!
!MO2/OLN=-K110*<MO2>+0.51037*K116*<CARBOP>
 PJAC(:,32,40)=-TPK%K110(:)*PCONC(:,32)+0.51037*TPK%K116(:)*PCONC(:,39)
!
!MO2/XO2=-K127*<MO2>+K128*<CARBOP>
 PJAC(:,32,41)=-TPK%K127(:)*PCONC(:,32)+TPK%K128(:)*PCONC(:,39)
!
!ALKAP/O3=+0.09815*K079*<ALKE>+0.00000*K080*<BIO>
 PJAC(:,33,1)=+0.09815*TPK%K079(:)*PCONC(:,19)+0.00000*TPK%K080(:)*PCONC(:,20)
!
!ALKAP/H2O2=0.0
!
!ALKAP/NO=+0.08187*K091*<ALKAP>-K091*<ALKAP>
 PJAC(:,33,3)=+0.08187*TPK%K091(:)*PCONC(:,33)-TPK%K091(:)*PCONC(:,33)
!
!ALKAP/NO2=0.0
!
!ALKAP/NO3=+0.08994*K120*<ALKAP>-K120*<ALKAP>
 PJAC(:,33,5)=+0.08994*TPK%K120(:)*PCONC(:,33)-TPK%K120(:)*PCONC(:,33)
!
!ALKAP/N2O5=0.0
!
!ALKAP/HONO=0.0
!
!ALKAP/HNO3=0.0
!
!ALKAP/HNO4=0.0
!
!ALKAP/NH3=0.0
!
!ALKAP/SO2=0.0
!
!ALKAP/SULF=0.0
!
!ALKAP/CO=0.0
!
!ALKAP/OH=+K057*<ETH>+0.87811*K058*<ALKA>+0.40341*K069*<OP2>+1.00000*K071*<ONIT
!>
 PJAC(:,33,14)=+TPK%K057(:)*PCONC(:,17)+0.87811*TPK%K058(:)*PCONC(:,18)+0.40341&
&*TPK%K069(:)*PCONC(:,29)+1.00000*TPK%K071(:)*PCONC(:,26)
!
!ALKAP/HO2=-K098*<ALKAP>
 PJAC(:,33,15)=-TPK%K098(:)*PCONC(:,33)
!
!ALKAP/CH4=0.0
!
!ALKAP/ETH=+K057*<OH>
 PJAC(:,33,17)=+TPK%K057(:)*PCONC(:,14)
!
!ALKAP/ALKA=+0.87811*K058*<OH>
 PJAC(:,33,18)=+0.87811*TPK%K058(:)*PCONC(:,14)
!
!ALKAP/ALKE=+0.09815*K079*<O3>
 PJAC(:,33,19)=+0.09815*TPK%K079(:)*PCONC(:,1)
!
!ALKAP/BIO=+0.00000*K080*<O3>
 PJAC(:,33,20)=+0.00000*TPK%K080(:)*PCONC(:,1)
!
!ALKAP/ARO=0.0
!
!ALKAP/HCHO=0.0
!
!ALKAP/ALD=0.0
!
!ALKAP/KET=+1.00000*K015
 PJAC(:,33,24)=+1.00000*TPK%K015(:)
!
!ALKAP/CARBO=0.0
!
!ALKAP/ONIT=+1.00000*K071*<OH>
 PJAC(:,33,26)=+1.00000*TPK%K071(:)*PCONC(:,14)
!
!ALKAP/PAN=0.0
!
!ALKAP/OP1=0.0
!
!ALKAP/OP2=+0.40341*K069*<OH>
 PJAC(:,33,29)=+0.40341*TPK%K069(:)*PCONC(:,14)
!
!ALKAP/ORA1=0.0
!
!ALKAP/ORA2=0.0
!
!ALKAP/MO2=+0.00385*K105*<ALKAP>-K105*<ALKAP>
 PJAC(:,33,32)=+0.00385*TPK%K105(:)*PCONC(:,33)-TPK%K105(:)*PCONC(:,33)
!
!ALKAP/ALKAP=+0.08187*K091*<NO>-K091*<NO>-K098*<HO2>+0.00385*K105*<MO2>-K105*<M
!O2>+0.00828*K111*<CARBOP>-K111*<CARBOP>+0.08994*K120*<NO3>-K120*<NO3>
 PJAC(:,33,33)=+0.08187*TPK%K091(:)*PCONC(:,3)-TPK%K091(:)*PCONC(:,3)-TPK%K098(&
&:)*PCONC(:,15)+0.00385*TPK%K105(:)*PCONC(:,32)-TPK%K105(:)*PCONC(:,32)+0.00828&
&*TPK%K111(:)*PCONC(:,39)-TPK%K111(:)*PCONC(:,39)+0.08994*TPK%K120(:)*PCONC(:,5&
&)-TPK%K120(:)*PCONC(:,5)
!
!ALKAP/ALKEP=0.0
!
!ALKAP/BIOP=0.0
!
!ALKAP/PHO=0.0
!
!ALKAP/ADD=0.0
!
!ALKAP/AROP=0.0
!
!ALKAP/CARBOP=+0.00828*K111*<ALKAP>-K111*<ALKAP>
 PJAC(:,33,39)=+0.00828*TPK%K111(:)*PCONC(:,33)-TPK%K111(:)*PCONC(:,33)
!
!ALKAP/OLN=0.0
!
!ALKAP/XO2=0.0
!
!ALKEP/O3=0.0
!
!ALKEP/H2O2=0.0
!
!ALKEP/NO=-K092*<ALKEP>
 PJAC(:,34,3)=-TPK%K092(:)*PCONC(:,34)
!
!ALKEP/NO2=0.0
!
!ALKEP/NO3=-K121*<ALKEP>
 PJAC(:,34,5)=-TPK%K121(:)*PCONC(:,34)
!
!ALKEP/N2O5=0.0
!
!ALKEP/HONO=0.0
!
!ALKEP/HNO3=0.0
!
!ALKEP/HNO4=0.0
!
!ALKEP/NH3=0.0
!
!ALKEP/SO2=0.0
!
!ALKEP/SULF=0.0
!
!ALKEP/CO=0.0
!
!ALKEP/OH=+1.02529*K059*<ALKE>
 PJAC(:,34,14)=+1.02529*TPK%K059(:)*PCONC(:,19)
!
!ALKEP/HO2=-K099*<ALKEP>
 PJAC(:,34,15)=-TPK%K099(:)*PCONC(:,34)
!
!ALKEP/CH4=0.0
!
!ALKEP/ETH=0.0
!
!ALKEP/ALKA=0.0
!
!ALKEP/ALKE=+1.02529*K059*<OH>
 PJAC(:,34,19)=+1.02529*TPK%K059(:)*PCONC(:,14)
!
!ALKEP/BIO=0.0
!
!ALKEP/ARO=0.0
!
!ALKEP/HCHO=0.0
!
!ALKEP/ALD=0.0
!
!ALKEP/KET=0.0
!
!ALKEP/CARBO=0.0
!
!ALKEP/ONIT=0.0
!
!ALKEP/PAN=0.0
!
!ALKEP/OP1=0.0
!
!ALKEP/OP2=0.0
!
!ALKEP/ORA1=0.0
!
!ALKEP/ORA2=0.0
!
!ALKEP/MO2=-K106*<ALKEP>
 PJAC(:,34,32)=-TPK%K106(:)*PCONC(:,34)
!
!ALKEP/ALKAP=0.0
!
!ALKEP/ALKEP=-K092*<NO>-K099*<HO2>-K106*<MO2>-K112*<CARBOP>-K121*<NO3>
 PJAC(:,34,34)=-TPK%K092(:)*PCONC(:,3)-TPK%K099(:)*PCONC(:,15)-TPK%K106(:)*PCON&
&C(:,32)-TPK%K112(:)*PCONC(:,39)-TPK%K121(:)*PCONC(:,5)
!
!ALKEP/BIOP=0.0
!
!ALKEP/PHO=0.0
!
!ALKEP/ADD=0.0
!
!ALKEP/AROP=0.0
!
!ALKEP/CARBOP=-K112*<ALKEP>
 PJAC(:,34,39)=-TPK%K112(:)*PCONC(:,34)
!
!ALKEP/OLN=0.0
!
!ALKEP/XO2=0.0
!
!BIOP/O3=0.0
!
!BIOP/H2O2=0.0
!
!BIOP/NO=-K093*<BIOP>
 PJAC(:,35,3)=-TPK%K093(:)*PCONC(:,35)
!
!BIOP/NO2=0.0
!
!BIOP/NO3=-K122*<BIOP>
 PJAC(:,35,5)=-TPK%K122(:)*PCONC(:,35)
!
!BIOP/N2O5=0.0
!
!BIOP/HONO=0.0
!
!BIOP/HNO3=0.0
!
!BIOP/HNO4=0.0
!
!BIOP/NH3=0.0
!
!BIOP/SO2=0.0
!
!BIOP/SULF=0.0
!
!BIOP/CO=0.0
!
!BIOP/OH=+0.00000*K059*<ALKE>+1.00000*K060*<BIO>
 PJAC(:,35,14)=+0.00000*TPK%K059(:)*PCONC(:,19)+1.00000*TPK%K060(:)*PCONC(:,20)
!
!BIOP/HO2=-K0100*<BIOP>
 PJAC(:,35,15)=-TPK%K0100(:)*PCONC(:,35)
!
!BIOP/CH4=0.0
!
!BIOP/ETH=0.0
!
!BIOP/ALKA=0.0
!
!BIOP/ALKE=+0.00000*K059*<OH>
 PJAC(:,35,19)=+0.00000*TPK%K059(:)*PCONC(:,14)
!
!BIOP/BIO=+1.00000*K060*<OH>
 PJAC(:,35,20)=+1.00000*TPK%K060(:)*PCONC(:,14)
!
!BIOP/ARO=0.0
!
!BIOP/HCHO=0.0
!
!BIOP/ALD=0.0
!
!BIOP/KET=0.0
!
!BIOP/CARBO=0.0
!
!BIOP/ONIT=0.0
!
!BIOP/PAN=0.0
!
!BIOP/OP1=0.0
!
!BIOP/OP2=0.0
!
!BIOP/ORA1=0.0
!
!BIOP/ORA2=0.0
!
!BIOP/MO2=-K107*<BIOP>
 PJAC(:,35,32)=-TPK%K107(:)*PCONC(:,35)
!
!BIOP/ALKAP=0.0
!
!BIOP/ALKEP=0.0
!
!BIOP/BIOP=-K093*<NO>-K0100*<HO2>-K107*<MO2>-K113*<CARBOP>-K122*<NO3>
 PJAC(:,35,35)=-TPK%K093(:)*PCONC(:,3)-TPK%K0100(:)*PCONC(:,15)-TPK%K107(:)*PCO&
&NC(:,32)-TPK%K113(:)*PCONC(:,39)-TPK%K122(:)*PCONC(:,5)
!
!BIOP/PHO=0.0
!
!BIOP/ADD=0.0
!
!BIOP/AROP=0.0
!
!BIOP/CARBOP=-K113*<BIOP>
 PJAC(:,35,39)=-TPK%K113(:)*PCONC(:,35)
!
!BIOP/OLN=0.0
!
!BIOP/XO2=0.0
!
RETURN
END SUBROUTINE SUBJ6
!
SUBROUTINE SUBJ7
!
!Indices 36 a 40
!
!
!PHO/O3=0.0
!
!PHO/H2O2=0.0
!
!PHO/NO=0.0
!
!PHO/NO2=-K083*<PHO>
 PJAC(:,36,4)=-TPK%K083(:)*PCONC(:,36)
!
!PHO/NO3=+K075*<ARO>
 PJAC(:,36,5)=+TPK%K075(:)*PCONC(:,21)
!
!PHO/N2O5=0.0
!
!PHO/HONO=0.0
!
!PHO/HNO3=0.0
!
!PHO/HNO4=0.0
!
!PHO/NH3=0.0
!
!PHO/SO2=0.0
!
!PHO/SULF=0.0
!
!PHO/CO=0.0
!
!PHO/OH=+0.00276*K061*<ARO>
 PJAC(:,36,14)=+0.00276*TPK%K061(:)*PCONC(:,21)
!
!PHO/HO2=-K084*<PHO>
 PJAC(:,36,15)=-TPK%K084(:)*PCONC(:,36)
!
!PHO/CH4=0.0
!
!PHO/ETH=0.0
!
!PHO/ALKA=0.0
!
!PHO/ALKE=0.0
!
!PHO/BIO=0.0
!
!PHO/ARO=+0.00276*K061*<OH>+K075*<NO3>
 PJAC(:,36,21)=+0.00276*TPK%K061(:)*PCONC(:,14)+TPK%K075(:)*PCONC(:,5)
!
!PHO/HCHO=0.0
!
!PHO/ALD=0.0
!
!PHO/KET=0.0
!
!PHO/CARBO=0.0
!
!PHO/ONIT=0.0
!
!PHO/PAN=0.0
!
!PHO/OP1=0.0
!
!PHO/OP2=0.0
!
!PHO/ORA1=0.0
!
!PHO/ORA2=0.0
!
!PHO/MO2=0.0
!
!PHO/ALKAP=0.0
!
!PHO/ALKEP=0.0
!
!PHO/BIOP=0.0
!
!PHO/PHO=-K083*<NO2>-K084*<HO2>
 PJAC(:,36,36)=-TPK%K083(:)*PCONC(:,4)-TPK%K084(:)*PCONC(:,15)
!
!PHO/ADD=0.0
!
!PHO/AROP=0.0
!
!PHO/CARBOP=0.0
!
!PHO/OLN=0.0
!
!PHO/XO2=0.0
!
!ADD/O3=-K087*<ADD>
 PJAC(:,37,1)=-TPK%K087(:)*PCONC(:,37)
!
!ADD/H2O2=0.0
!
!ADD/NO=0.0
!
!ADD/NO2=-K085*<ADD>
 PJAC(:,37,4)=-TPK%K085(:)*PCONC(:,37)
!
!ADD/NO3=0.0
!
!ADD/N2O5=0.0
!
!ADD/HONO=0.0
!
!ADD/HNO3=0.0
!
!ADD/HNO4=0.0
!
!ADD/NH3=0.0
!
!ADD/SO2=0.0
!
!ADD/SULF=0.0
!
!ADD/CO=0.0
!
!ADD/OH=+0.93968*K061*<ARO>
 PJAC(:,37,14)=+0.93968*TPK%K061(:)*PCONC(:,21)
!
!ADD/HO2=0.0
!
!ADD/CH4=0.0
!
!ADD/ETH=0.0
!
!ADD/ALKA=0.0
!
!ADD/ALKE=0.0
!
!ADD/BIO=0.0
!
!ADD/ARO=+0.93968*K061*<OH>
 PJAC(:,37,21)=+0.93968*TPK%K061(:)*PCONC(:,14)
!
!ADD/HCHO=0.0
!
!ADD/ALD=0.0
!
!ADD/KET=0.0
!
!ADD/CARBO=0.0
!
!ADD/ONIT=0.0
!
!ADD/PAN=0.0
!
!ADD/OP1=0.0
!
!ADD/OP2=0.0
!
!ADD/ORA1=0.0
!
!ADD/ORA2=0.0
!
!ADD/MO2=0.0
!
!ADD/ALKAP=0.0
!
!ADD/ALKEP=0.0
!
!ADD/BIOP=0.0
!
!ADD/PHO=0.0
!
!ADD/ADD=-K085*<NO2>-K086*<O2>-K087*<O3>
 PJAC(:,37,37)=-TPK%K085(:)*PCONC(:,4)-TPK%K086(:)*TPK%O2(:)-TPK%K087(:)*PCONC(&
&:,1)
!
!ADD/AROP=0.0
!
!ADD/CARBOP=0.0
!
!ADD/OLN=0.0
!
!ADD/XO2=0.0
!
!AROP/O3=0.0
!
!AROP/H2O2=0.0
!
!AROP/NO=-K094*<AROP>
 PJAC(:,38,3)=-TPK%K094(:)*PCONC(:,38)
!
!AROP/NO2=0.0
!
!AROP/NO3=-K123*<AROP>
 PJAC(:,38,5)=-TPK%K123(:)*PCONC(:,38)
!
!AROP/N2O5=0.0
!
!AROP/HONO=0.0
!
!AROP/HNO3=0.0
!
!AROP/HNO4=0.0
!
!AROP/NH3=0.0
!
!AROP/SO2=0.0
!
!AROP/SULF=0.0
!
!AROP/CO=0.0
!
!AROP/OH=0.0
!
!AROP/HO2=-K0101*<AROP>
 PJAC(:,38,15)=-TPK%K0101(:)*PCONC(:,38)
!
!AROP/CH4=0.0
!
!AROP/ETH=0.0
!
!AROP/ALKA=0.0
!
!AROP/ALKE=0.0
!
!AROP/BIO=0.0
!
!AROP/ARO=0.0
!
!AROP/HCHO=0.0
!
!AROP/ALD=0.0
!
!AROP/KET=0.0
!
!AROP/CARBO=0.0
!
!AROP/ONIT=0.0
!
!AROP/PAN=0.0
!
!AROP/OP1=0.0
!
!AROP/OP2=0.0
!
!AROP/ORA1=0.0
!
!AROP/ORA2=0.0
!
!AROP/MO2=-K108*<AROP>
 PJAC(:,38,32)=-TPK%K108(:)*PCONC(:,38)
!
!AROP/ALKAP=0.0
!
!AROP/ALKEP=0.0
!
!AROP/BIOP=0.0
!
!AROP/PHO=0.0
!
!AROP/ADD=+0.98*K086*<O2>
 PJAC(:,38,37)=+0.98*TPK%K086(:)*TPK%O2(:)
!
!AROP/AROP=-K094*<NO>-K0101*<HO2>-K108*<MO2>-K114*<CARBOP>-K123*<NO3>
 PJAC(:,38,38)=-TPK%K094(:)*PCONC(:,3)-TPK%K0101(:)*PCONC(:,15)-TPK%K108(:)*PCO&
&NC(:,32)-TPK%K114(:)*PCONC(:,39)-TPK%K123(:)*PCONC(:,5)
!
!AROP/CARBOP=-K114*<AROP>
 PJAC(:,38,39)=-TPK%K114(:)*PCONC(:,38)
!
!AROP/OLN=0.0
!
!AROP/XO2=0.0
!
!CARBOP/O3=+0.05705*K079*<ALKE>+0.17000*K080*<BIO>+0.27460*K081*<CARBO>+0.70000
!*K082*<PAN>
 PJAC(:,39,1)=+0.05705*TPK%K079(:)*PCONC(:,19)+0.17000*TPK%K080(:)*PCONC(:,20)+&
&0.27460*TPK%K081(:)*PCONC(:,25)+0.70000*TPK%K082(:)*PCONC(:,27)
!
!CARBOP/H2O2=0.0
!
!CARBOP/NO=+0.09532*K095*<CARBOP>-K095*<CARBOP>
 PJAC(:,39,3)=+0.09532*TPK%K095(:)*PCONC(:,39)-TPK%K095(:)*PCONC(:,39)
!
!CARBOP/NO2=-K088*<CARBOP>
 PJAC(:,39,4)=-TPK%K088(:)*PCONC(:,39)
!
!CARBOP/NO3=+1.00000*K073*<ALD>+0.38881*K074*<CARBO>+0.03175*K124*<CARBOP>-K124
!*<CARBOP>
 PJAC(:,39,5)=+1.00000*TPK%K073(:)*PCONC(:,23)+0.38881*TPK%K074(:)*PCONC(:,25)+&
&0.03175*TPK%K124(:)*PCONC(:,39)-TPK%K124(:)*PCONC(:,39)
!
!CARBOP/N2O5=0.0
!
!CARBOP/HONO=0.0
!
!CARBOP/HNO3=0.0
!
!CARBOP/HNO4=0.0
!
!CARBOP/NH3=0.0
!
!CARBOP/SO2=0.0
!
!CARBOP/SULF=0.0
!
!CARBOP/CO=0.0
!
!CARBOP/OH=+1.00000*K063*<ALD>+1.00000*K064*<KET>+0.51419*K065*<CARBO>+0.05413*
!K069*<OP2>
 PJAC(:,39,14)=+1.00000*TPK%K063(:)*PCONC(:,23)+1.00000*TPK%K064(:)*PCONC(:,24)&
&+0.51419*TPK%K065(:)*PCONC(:,25)+0.05413*TPK%K069(:)*PCONC(:,29)
!
!CARBOP/HO2=-K0102*<CARBOP>
 PJAC(:,39,15)=-TPK%K0102(:)*PCONC(:,39)
!
!CARBOP/CH4=0.0
!
!CARBOP/ETH=0.0
!
!CARBOP/ALKA=0.0
!
!CARBOP/ALKE=+0.05705*K079*<O3>
 PJAC(:,39,19)=+0.05705*TPK%K079(:)*PCONC(:,1)
!
!CARBOP/BIO=+0.17000*K080*<O3>
 PJAC(:,39,20)=+0.17000*TPK%K080(:)*PCONC(:,1)
!
!CARBOP/ARO=0.0
!
!CARBOP/HCHO=0.0
!
!CARBOP/ALD=+1.00000*K063*<OH>+1.00000*K073*<NO3>
 PJAC(:,39,23)=+1.00000*TPK%K063(:)*PCONC(:,14)+1.00000*TPK%K073(:)*PCONC(:,5)
!
!CARBOP/KET=+1.00000*K015+1.00000*K064*<OH>
 PJAC(:,39,24)=+1.00000*TPK%K015(:)+1.00000*TPK%K064(:)*PCONC(:,14)
!
!CARBOP/CARBO=+0.69622*K016+0.51419*K065*<OH>+0.38881*K074*<NO3>+0.27460*K081*<
!O3>
 PJAC(:,39,25)=+0.69622*TPK%K016(:)+0.51419*TPK%K065(:)*PCONC(:,14)+0.38881*TPK&
&%K074(:)*PCONC(:,5)+0.27460*TPK%K081(:)*PCONC(:,1)
!
!CARBOP/ONIT=0.0
!
!CARBOP/PAN=+0.70000*K082*<O3>+1.00000*K089
 PJAC(:,39,27)=+0.70000*TPK%K082(:)*PCONC(:,1)+1.00000*TPK%K089(:)
!
!CARBOP/OP1=0.0
!
!CARBOP/OP2=+0.05413*K069*<OH>
 PJAC(:,39,29)=+0.05413*TPK%K069(:)*PCONC(:,14)
!
!CARBOP/ORA1=0.0
!
!CARBOP/ORA2=0.0
!
!CARBOP/MO2=+0.05954*K109*<CARBOP>-K109*<CARBOP>
 PJAC(:,39,32)=+0.05954*TPK%K109(:)*PCONC(:,39)-TPK%K109(:)*PCONC(:,39)
!
!CARBOP/ALKAP=-K111*<CARBOP>
 PJAC(:,39,33)=-TPK%K111(:)*PCONC(:,39)
!
!CARBOP/ALKEP=-K112*<CARBOP>
 PJAC(:,39,34)=-TPK%K112(:)*PCONC(:,39)
!
!CARBOP/BIOP=-K113*<CARBOP>
 PJAC(:,39,35)=-TPK%K113(:)*PCONC(:,39)
!
!CARBOP/PHO=0.0
!
!CARBOP/ADD=0.0
!
!CARBOP/AROP=-K114*<CARBOP>
 PJAC(:,39,38)=-TPK%K114(:)*PCONC(:,39)
!
!CARBOP/CARBOP=-K088*<NO2>+0.09532*K095*<NO>-K095*<NO>-K0102*<HO2>+0.05954*K109
!*<MO2>-K109*<MO2>-K111*<ALKAP>-K112*<ALKEP>-K113*<BIOP>-K114*<AROP>+0.05821*K1
!15*<CARBOP>+0.05821*K115*<CARBOP>-K115*<CARBOP>-K115*<CARBOP>-K115*<CARBOP>-K1
!15*<CARBOP>-K116*<OLN>+0.03175*K124*<NO3>-K124*<NO3>-K128*<XO2>
 PJAC(:,39,39)=-TPK%K088(:)*PCONC(:,4)+0.09532*TPK%K095(:)*PCONC(:,3)-TPK%K095(&
&:)*PCONC(:,3)-TPK%K0102(:)*PCONC(:,15)+0.05954*TPK%K109(:)*PCONC(:,32)-TPK%K10&
&9(:)*PCONC(:,32)-TPK%K111(:)*PCONC(:,33)-TPK%K112(:)*PCONC(:,34)-TPK%K113(:)*P&
&CONC(:,35)-TPK%K114(:)*PCONC(:,38)+0.05821*TPK%K115(:)*PCONC(:,39)+0.05821*TPK&
&%K115(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K115(&
&:)*PCONC(:,39)-TPK%K115(:)*PCONC(:,39)-TPK%K116(:)*PCONC(:,40)+0.03175*TPK%K12&
&4(:)*PCONC(:,5)-TPK%K124(:)*PCONC(:,5)-TPK%K128(:)*PCONC(:,41)
!
!CARBOP/OLN=-K116*<CARBOP>
 PJAC(:,39,40)=-TPK%K116(:)*PCONC(:,39)
!
!CARBOP/XO2=-K128*<CARBOP>
 PJAC(:,39,41)=-TPK%K128(:)*PCONC(:,39)
!
!OLN/O3=0.0
!
!OLN/H2O2=0.0
!
!OLN/NO=-K096*<OLN>
 PJAC(:,40,3)=-TPK%K096(:)*PCONC(:,40)
!
!OLN/NO2=0.0
!
!OLN/NO3=+0.00000*K074*<CARBO>+0.93768*K076*<ALKE>+1.00000*K077*<BIO>-K125*<OLN
!>
 PJAC(:,40,5)=+0.00000*TPK%K074(:)*PCONC(:,25)+0.93768*TPK%K076(:)*PCONC(:,19)+&
&1.00000*TPK%K077(:)*PCONC(:,20)-TPK%K125(:)*PCONC(:,40)
!
!OLN/N2O5=0.0
!
!OLN/HONO=0.0
!
!OLN/HNO3=0.0
!
!OLN/HNO4=0.0
!
!OLN/NH3=0.0
!
!OLN/SO2=0.0
!
!OLN/SULF=0.0
!
!OLN/CO=0.0
!
!OLN/OH=0.0
!
!OLN/HO2=-K103*<OLN>
 PJAC(:,40,15)=-TPK%K103(:)*PCONC(:,40)
!
!OLN/CH4=0.0
!
!OLN/ETH=0.0
!
!OLN/ALKA=0.0
!
!OLN/ALKE=+0.93768*K076*<NO3>
 PJAC(:,40,19)=+0.93768*TPK%K076(:)*PCONC(:,5)
!
!OLN/BIO=+1.00000*K077*<NO3>
 PJAC(:,40,20)=+1.00000*TPK%K077(:)*PCONC(:,5)
!
!OLN/ARO=0.0
!
!OLN/HCHO=0.0
!
!OLN/ALD=0.0
!
!OLN/KET=0.0
!
!OLN/CARBO=+0.00000*K074*<NO3>
 PJAC(:,40,25)=+0.00000*TPK%K074(:)*PCONC(:,5)
!
!OLN/ONIT=0.0
!
!OLN/PAN=0.0
!
!OLN/OP1=0.0
!
!OLN/OP2=0.0
!
!OLN/ORA1=0.0
!
!OLN/ORA2=0.0
!
!OLN/MO2=-K110*<OLN>
 PJAC(:,40,32)=-TPK%K110(:)*PCONC(:,40)
!
!OLN/ALKAP=0.0
!
!OLN/ALKEP=0.0
!
!OLN/BIOP=0.0
!
!OLN/PHO=0.0
!
!OLN/ADD=0.0
!
!OLN/AROP=0.0
!
!OLN/CARBOP=-K116*<OLN>
 PJAC(:,40,39)=-TPK%K116(:)*PCONC(:,40)
!
!OLN/OLN=-K096*<NO>-K103*<HO2>-K110*<MO2>-K116*<CARBOP>-K117*<OLN>-K117*<OLN>-K
!117*<OLN>-K117*<OLN>-K118*<OLN>-K118*<OLN>-K118*<OLN>-K118*<OLN>-K125*<NO3>
 PJAC(:,40,40)=-TPK%K096(:)*PCONC(:,3)-TPK%K103(:)*PCONC(:,15)-TPK%K110(:)*PCON&
&C(:,32)-TPK%K116(:)*PCONC(:,39)-TPK%K117(:)*PCONC(:,40)-TPK%K117(:)*PCONC(:,40&
&)-TPK%K117(:)*PCONC(:,40)-TPK%K117(:)*PCONC(:,40)-TPK%K118(:)*PCONC(:,40)-TPK%&
&K118(:)*PCONC(:,40)-TPK%K118(:)*PCONC(:,40)-TPK%K118(:)*PCONC(:,40)-TPK%K125(:&
&)*PCONC(:,5)
!
!OLN/XO2=0.0
!
RETURN
END SUBROUTINE SUBJ7
!
SUBROUTINE SUBJ8
!
!Indices 41 a 41
!
!
!XO2/O3=+0.00000*K079*<ALKE>+0.13000*K080*<BIO>
 PJAC(:,41,1)=+0.00000*TPK%K079(:)*PCONC(:,19)+0.13000*TPK%K080(:)*PCONC(:,20)
!
!XO2/H2O2=0.0
!
!XO2/NO=+0.13007*K091*<ALKAP>+0.02563*K095*<CARBOP>-K130*<XO2>
 PJAC(:,41,3)=+0.13007*TPK%K091(:)*PCONC(:,33)+0.02563*TPK%K095(:)*PCONC(:,39)-&
&TPK%K130(:)*PCONC(:,41)
!
!XO2/NO2=0.0
!
!XO2/NO3=+0.10530*K074*<CARBO>+K078*<PAN>+0.16271*K120*<ALKAP>+0.01021*K124*<CA
!RBOP>-K131*<XO2>
 PJAC(:,41,5)=+0.10530*TPK%K074(:)*PCONC(:,25)+TPK%K078(:)*PCONC(:,27)+0.16271*&
&TPK%K120(:)*PCONC(:,33)+0.01021*TPK%K124(:)*PCONC(:,39)-TPK%K131(:)*PCONC(:,41&
&)
!
!XO2/N2O5=0.0
!
!XO2/HONO=0.0
!
!XO2/HNO3=0.0
!
!XO2/HNO4=0.0
!
!XO2/NH3=0.0
!
!XO2/SO2=0.0
!
!XO2/SULF=0.0
!
!XO2/CO=0.0
!
!XO2/OH=+0.10318*K061*<ARO>+0.10162*K065*<CARBO>+0.09333*K069*<OP2>+K070*<PAN>
 PJAC(:,41,14)=+0.10318*TPK%K061(:)*PCONC(:,21)+0.10162*TPK%K065(:)*PCONC(:,25)&
&+0.09333*TPK%K069(:)*PCONC(:,29)+TPK%K070(:)*PCONC(:,27)
!
!XO2/HO2=-K126*<XO2>
 PJAC(:,41,15)=-TPK%K126(:)*PCONC(:,41)
!
!XO2/CH4=0.0
!
!XO2/ETH=0.0
!
!XO2/ALKA=0.0
!
!XO2/ALKE=+0.00000*K079*<O3>
 PJAC(:,41,19)=+0.00000*TPK%K079(:)*PCONC(:,1)
!
!XO2/BIO=+0.15*K054*<O3P>+0.13000*K080*<O3>
 PJAC(:,41,20)=+0.15*TPK%K054(:)*TPK%O3P(:)+0.13000*TPK%K080(:)*PCONC(:,1)
!
!XO2/ARO=+0.10318*K061*<OH>
 PJAC(:,41,21)=+0.10318*TPK%K061(:)*PCONC(:,14)
!
!XO2/HCHO=0.0
!
!XO2/ALD=0.0
!
!XO2/KET=0.0
!
!XO2/CARBO=+0.10162*K065*<OH>+0.10530*K074*<NO3>
 PJAC(:,41,25)=+0.10162*TPK%K065(:)*PCONC(:,14)+0.10530*TPK%K074(:)*PCONC(:,5)
!
!XO2/ONIT=0.0
!
!XO2/PAN=+K070*<OH>+K078*<NO3>
 PJAC(:,41,27)=+TPK%K070(:)*PCONC(:,14)+TPK%K078(:)*PCONC(:,5)
!
!XO2/OP1=0.0
!
!XO2/OP2=+0.09333*K069*<OH>
 PJAC(:,41,29)=+0.09333*TPK%K069(:)*PCONC(:,14)
!
!XO2/ORA1=0.0
!
!XO2/ORA2=0.0
!
!XO2/MO2=+0.13370*K105*<ALKAP>+0.02212*K109*<CARBOP>-K127*<XO2>
 PJAC(:,41,32)=+0.13370*TPK%K105(:)*PCONC(:,33)+0.02212*TPK%K109(:)*PCONC(:,39)&
&-TPK%K127(:)*PCONC(:,41)
!
!XO2/ALKAP=+0.13007*K091*<NO>+0.13370*K105*<MO2>+0.11306*K111*<CARBOP>+0.16271*
!K120*<NO3>
 PJAC(:,41,33)=+0.13007*TPK%K091(:)*PCONC(:,3)+0.13370*TPK%K105(:)*PCONC(:,32)+&
&0.11306*TPK%K111(:)*PCONC(:,39)+0.16271*TPK%K120(:)*PCONC(:,5)
!
!XO2/ALKEP=0.0
!
!XO2/BIOP=0.0
!
!XO2/PHO=0.0
!
!XO2/ADD=0.0
!
!XO2/AROP=0.0
!
!XO2/CARBOP=+0.02563*K095*<NO>+0.02212*K109*<MO2>+0.11306*K111*<ALKAP>+0.01593*
!K115*<CARBOP>+0.01593*K115*<CARBOP>+0.01021*K124*<NO3>-K128*<XO2>
 PJAC(:,41,39)=+0.02563*TPK%K095(:)*PCONC(:,3)+0.02212*TPK%K109(:)*PCONC(:,32)+&
&0.11306*TPK%K111(:)*PCONC(:,33)+0.01593*TPK%K115(:)*PCONC(:,39)+0.01593*TPK%K1&
&15(:)*PCONC(:,39)+0.01021*TPK%K124(:)*PCONC(:,5)-TPK%K128(:)*PCONC(:,41)
!
!XO2/OLN=0.0
!
!XO2/XO2=-K126*<HO2>-K127*<MO2>-K128*<CARBOP>-K129*<XO2>-K129*<XO2>-K129*<XO2>-
!K129*<XO2>-K130*<NO>-K131*<NO3>
 PJAC(:,41,41)=-TPK%K126(:)*PCONC(:,15)-TPK%K127(:)*PCONC(:,32)-TPK%K128(:)*PCO&
&NC(:,39)-TPK%K129(:)*PCONC(:,41)-TPK%K129(:)*PCONC(:,41)-TPK%K129(:)*PCONC(:,4&
&1)-TPK%K129(:)*PCONC(:,41)-TPK%K130(:)*PCONC(:,3)-TPK%K131(:)*PCONC(:,5)
!
RETURN
END SUBROUTINE SUBJ8
!
END SUBROUTINE CH_JAC_GAZ
!
!
!========================================================================
!
!!    ########################
      MODULE MODI_CH_SET_RATES
!!    ########################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_SET_RATES(PTIME,PCONC,TPM,KMI,KOUT,KVERB,KVECNPT,KEQ,KRRL,PPH)
USE MODD_CH_M9_n, ONLY: METEOTRANSTYPE
IMPLICIT NONE
REAL,    INTENT(IN)                      :: PTIME
INTEGER, INTENT(IN)                      :: KVECNPT
INTEGER, INTENT(IN)                      :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)        :: PCONC
TYPE(METEOTRANSTYPE), DIMENSION(KVECNPT), INTENT(IN):: TPM
INTEGER, INTENT(IN)                      :: KMI
INTEGER, INTENT(IN)                      :: KOUT,KVERB
INTEGER, INTENT(INOUT)                   :: KRRL
REAL,    INTENT(INOUT), DIMENSION(:,:), OPTIONAL :: PPH
END SUBROUTINE CH_SET_RATES
END INTERFACE
END MODULE MODI_CH_SET_RATES
!
!========================================================================
!
!!    ############################################################################
      SUBROUTINE CH_SET_RATES(PTIME,PCONC,TPM,KMI,KOUT,KVERB,KVECNPT,KEQ,KRRL,PPH)
!!    ############################################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *MODD_CH_SET_RATES*
!!
!!    PURPOSE
!!    -------
!       set or calculate reaction rates
!!
!!**  METHOD
!!    ------
!!      simple
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 01/06/07: Add pH calculation (M. Leriche & JP Pinty)
!!    Modified 01/06/08: Add reaction constant in cloud/rain (M. Leriche)
!!    Modified 14/11/08: Put LWC and LWR to zero where <XRTMIN_AQ
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!
USE MODI_CH_ALLOCATE_TACCS
USE MODI_CH_DEALLOCATE_TACCS
USE MODI_CH_SET_PH
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
USE MODD_CH_M9_SCHEME
USE MODD_CH_M9_n,        ONLY : METEOTRANSTYPE
USE MODD_CH_MNHC_n,      ONLY : XRTMIN_AQ, XCH_PHINIT
!     USER DEFINED FUNCTIONS
USE MODI_KT
USE MODI_TROE
USE MODI_HENRY
USE MODI_HEFFA
USE MODI_TROE_EQUIL
USE MODI_HEFFB
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                      :: PTIME
INTEGER, INTENT(IN)                      :: KVECNPT
INTEGER, INTENT(IN)                      :: KEQ
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)        :: PCONC
TYPE(METEOTRANSTYPE), DIMENSION(KVECNPT), INTENT(IN):: TPM
INTEGER, INTENT(IN)                      :: KMI
INTEGER, INTENT(IN)                      :: KOUT,KVERB
INTEGER, INTENT(INOUT)                   :: KRRL
REAL,    INTENT(INOUT), DIMENSION(:,:), OPTIONAL :: PPH
!!
!!----------------------------------------------------------------------
! /BEGIN_SET_RATES/
!
! transfer of meteo-variables into variables used by the 
! chemical core system (and some unit conversion):
!
!   molecular weight of air:   m_mol^air = 28.8 g/mol
!   molecular weight of H2O:   m_mol^H2O = 18.0 g/mol
!                        ==>   m_mol^air / m_mol^H2O = 1.6
!   density conversion factor: 1 g/cm3 = 1E+3 kg/m3
!   n_molec (moelc./cm3):      M = 1E-3*RHO(kg/m3) * Navo / m_mol
!   n_water:                   H2O = M * 1.6 * Rv
!   pressure = RHO * T * R * 1E-5 (in atm)
!   assuming 20.95 vol% O2
!
TYPE(CCSTYPE),  POINTER     :: TPK
!
!----------------------------------------------------------------------
!
IF (.NOT. ASSOCIATED(TACCS(KMI)%NVERB)) THEN
  CALL CH_ALLOCATE_TACCS(KMI,KVECNPT)
END IF
!
IF (SIZE(TACCS(KMI)%NVERB) .NE. KVECNPT) THEN
  CALL CH_DEALLOCATE_TACCS(KMI)
  CALL CH_ALLOCATE_TACCS(KMI,KVECNPT)
END IF
!
TPK=>TACCS(KMI)
!
TPK%MODELLEVEL = TPM%XMETEOVAR(1)
TPK%M          = 1E-3*TPM%XMETEOVAR(2) * 6.0221367E+23 / 28.9644
TPK%T          = TPM%XMETEOVAR(3)
TPK%H2O        = TPK%M*1.6077*TPM%XMETEOVAR(4)
TPK%CLOUDWATER = TPM%XMETEOVAR(5)
TPK%LAT        = TPM%XMETEOVAR(6)
TPK%LON        = TPM%XMETEOVAR(7)
TPK%YEAR       = INT(TPM%XMETEOVAR(8))
TPK%MONTH      = INT(TPM%XMETEOVAR(9))
TPK%DAY        = INT(TPM%XMETEOVAR(10))
TPK%RAINWATER  = TPM%XMETEOVAR(11)
TPK%RHODREF    = TPM%XMETEOVAR(2)
! derived variables
TPK%PRESSURE   = TPM%XMETEOVAR(2) * TPK%T * 288.290947 * 1E-5
TPK%O2         = 0.2095 * TPK%M
TPK%N2         = TPK%M - TPK%O2
TPK%H2         = 1.23e13
! fixed concentration of CO2 
TPK%CO2 =  330. * 1.E-6 * TPK%M
! for chemistry in aqueous phase, kinetic mass transfer
!   cloud lwc (vol/vol) = cloud m.r.(kg/kg) * rho_air(kg/m3) / rho_eau(kg/m3)
TPK%LWC =  TPM%XMETEOVAR(5)*TPM%XMETEOVAR(2) / 1.E3
WHERE ( TPK%LWC < XRTMIN_AQ ) !to get reaction rate for mass transfer = 0
  TPK%LWC = 0.
ENDWHERE
TPK%RADC = TPM%XMETEOVAR(12)
! conversion factor for reaction constant in cloud
! give minimum value to avoir division by zero
TPK%MOL2MOLECCLOUD = 6.023e+23*1.e-3*XRTMIN_AQ
WHERE (TPK%LWC >= XRTMIN_AQ)
  TPK%MOL2MOLECCLOUD = 6.023e+23*1.e-3*TPK%LWC
END WHERE
!
TPK%LWR =  TPM%XMETEOVAR(11)*TPM%XMETEOVAR(2) / 1.E3
WHERE ( TPK%LWR < XRTMIN_AQ ) !to get reaction rate for mass transfer = 0
  TPK%LWR = 0.
ENDWHERE
TPK%RADR = TPM%XMETEOVAR(13)
! conversion factor for reaction constant in rain
! give minimum value to avoir division by zero
TPK%MOL2MOLECRAIN = 6.023e+23*1.e-3*XRTMIN_AQ
WHERE (TPK%LWR >= XRTMIN_AQ)
  TPK%MOL2MOLECRAIN = 6.023e+23*1.e-3*TPK%LWR
END WHERE
!pH calculation if required
IF (PRESENT(PPH)) THEN
  TPK%PHC(:)=PPH(:,1)
  CALL CH_SET_PH(KOUT,KMI,KVECNPT,PCONC,TPK%PHC(:),KVERB,2) ! pH cloud water
!  TPK%PHC(:) = 0.01*TPK%PHC(:) + 0.99*PPH(:,1) ! apply a strong filter
  PPH(:,1) = TPK%PHC(:)
  IF (KRRL>=2) THEN
    TPK%PHR(:)=PPH(:,2)
    CALL CH_SET_PH(KOUT,KMI,KVECNPT,PCONC,TPK%PHR(:),KVERB,3) ! pH rain water
!    TPK%PHR(:) = 0.01*TPK%PHR(:) + 0.99*PPH(:,2) ! apply a strong filter
    PPH(:,2) = TPK%PHR(:)
  ENDIF
ELSE
  IF (.NOT.TPK%LCH_PH) TPK%PHC = XCH_PHINIT
  IF (KRRL>=2) THEN
    IF (.NOT.TPK%LCH_PH) TPK%PHR = XCH_PHINIT
  ENDIF
ENDIF
!
TPK%RCH = 0.08206 ! R in atm M-1 K-1
TPK%W_O2 = 1.3E-3*exp(-1500.*(1./TPK%T-1./298.15))*TPK%RCH*TPK%T*TPK%O2*1.e3/6.023e+23
!
! the following prints will be erased
IF (KVERB >= 15) THEN
  WRITE(KOUT,*) "CH_SET_RATES: the following variables have been updated"
  WRITE(KOUT,*) "MODELLEVEL:   ", TPK%MODELLEVEL(1)
  WRITE(KOUT,*) "M:            ", TPK%M(1)          , "molec/cm3"
  WRITE(KOUT,*) "T:            ", TPK%T(1)          , "K"
  WRITE(KOUT,*) "H2O           ", TPK%H2O(1)        , "molec/cm3"
  WRITE(KOUT,*) "CLOUDWATER:   ", TPK%CLOUDWATER(1) , "kg/kg"
  WRITE(KOUT,*) "LATITUDE:     ", TPK%LAT(1)        , "degree"
  WRITE(KOUT,*) "LONGITUDE:    ", TPK%LON(1)        , "degree"
  WRITE(KOUT,*) "YEAR:         ", TPK%YEAR(1)
  WRITE(KOUT,*) "MONTH:        ", TPK%MONTH(1)
  WRITE(KOUT,*) "DAY:          ", TPK%DAY(1)
  WRITE(KOUT,*) "RAINWATER:    ", TPK%RAINWATER(1)  , "kg/kg"
  WRITE(KOUT,*) "RHODREF:      ", TPK%RHODREF(1)    , "kg/m3"
  WRITE(KOUT,*) "PRESSURE:     ", TPK%PRESSURE(1)   , "atm"
  WRITE(KOUT,*) "O2:           ", TPK%O2(1)         , "molec/cm3"
  WRITE(KOUT,*) "N2:           ", TPK%N2(1)         , "molec/cm3"
  WRITE(KOUT,*) "H2:           ", TPK%H2(1)         , "molec/cm3"
  WRITE(KOUT,*) "CO2:          ", TPK%CO2(1)        , "molec/cm3"
  WRITE(KOUT,*) "LWC:          ", TPK%LWC(1)        , "m3/m3"
  WRITE(KOUT,*) "RADC:         ", TPK%RADC(1)       , "m"
  WRITE(KOUT,*) "PHC:          ", TPK%PHC(1)
  WRITE(KOUT,*) "LWR:          ", TPK%LWR(1)        , "m3/m3"
  WRITE(KOUT,*) "RADR:         ", TPK%RADR(1)       , "m"
  WRITE(KOUT,*) "PHR:          ", TPK%PHR(1)
  WRITE(KOUT,*) "W_O2:         ", TPK%W_O2(1)       , "M"
END IF
!
! /END_SET_RATES/
CALL SUBSRG0
CALL SUBSRG1
CALL SUBSRG2
CALL SUBSRG3
CALL SUBSRG4
CALL SUBSRG5
CALL SUBSRG6
CALL SUBSRG7
CALL SUBSRG8
CALL SUBSRG9
CALL SUBSRG10
CALL SUBSRG11
CALL SUBSRG12
CALL SUBSRG13
IF (TPK%LUSECHAQ) THEN
  CALL SUBSRW0
  CALL SUBSRW1
  CALL SUBSRW2
  CALL SUBSRW3
  CALL SUBSRW4
  CALL SUBSRW5
  CALL SUBSRW6
  CALL SUBSRW7
  CALL SUBSRW8
  CALL SUBSRW9
  CALL SUBSRW10
  CALL SUBSRW11
  CALL SUBSRW12
  CALL SUBSRW13
END IF
TPK%NOUT     = KOUT
TPK%NVERB(:) = KVERB
RETURN

CONTAINS

SUBROUTINE SUBSRG0
!
!Indices 1 a 10
!
!
RETURN
END SUBROUTINE SUBSRG0
!
SUBROUTINE SUBSRG1
!
!Indices 11 a 20
!
 TPK%K018=TPK%M*6.00E-34*(TPK%T/300)**(-2.3)
 TPK%K019=8.00E-12*exp(-(2060.0/TPK%T))
 TPK%K020=1.80E-11*exp(-(-110.0/TPK%T))
!
RETURN
END SUBROUTINE SUBSRG1
!
SUBROUTINE SUBSRG2
!
!Indices 21 a 30
!
 TPK%K021=3.20E-11*exp(-(-70.0/TPK%T))
 TPK%K022=2.20E-10
 TPK%K023=1.60E-12*exp(-(940.0/TPK%T))
 TPK%K024=1.10E-14*exp(-(500.0/TPK%T))
 TPK%K025=4.80E-11*exp(-(-250.0/TPK%T))
 TPK%K026=2.90E-12*exp(-(160.0/TPK%T))
 TPK%K027=2.3E-13*EXP(600./TPK%T)+1.7E-33*TPK%M*EXP(1000./TPK%T)
 TPK%K028=3.22E-34*EXP(2800./TPK%T)+2.38E-54*TPK%M*EXP(3200./TPK%T)
 TPK%K029=TROE(1.,9.00E-32,1.5,3.00E-11,0.0,TPK%M,TPK%T,KVECNPT)
 TPK%K030=6.50E-12*exp(-(-120.0/TPK%T))
!
RETURN
END SUBROUTINE SUBSRG2
!
SUBROUTINE SUBSRG3
!
!Indices 31 a 40
!
 TPK%K031=TROE(1.,9.00E-32,2.0,2.20E-11,0.0,TPK%M,TPK%T,KVECNPT)
 TPK%K032=TROE(1.,7.00E-31,2.6,1.50E-11,0.5,TPK%M,TPK%T,KVECNPT)
 TPK%K033=TROE(1.,2.60E-30,3.2,2.40E-11,1.3,TPK%M,TPK%T,KVECNPT)
 TPK%K034=2.20E-11
 TPK%K035=3.70E-12*exp(-(-250.0/TPK%T))
 TPK%K036=TROE(1.,1.80E-31,3.2,4.70E-12,1.4,TPK%M,TPK%T,KVECNPT)
 TPK%K037=TROE_EQUIL(1.80E-31,3.2,4.70E-12,1.4,4.76E+26,10900.,TPK%M,TPK%T,KVEC&
&NPT)
 TPK%K038=3.50E-12
 TPK%K039=1.80E-11*exp(-(390.0/TPK%T))
 TPK%K040=(7.2E-15*EXP(785/TPK%T))+(1.9E-33*EXP(725/TPK%T)*TPK%M)/(1+(1.9E-33*E&
&XP(725/TPK%T)*TPK%M)/(4.1E-16*EXP(1440/TPK%T)))
!
RETURN
END SUBROUTINE SUBSRG3
!
SUBROUTINE SUBSRG4
!
!Indices 41 a 50
!
 TPK%K041=1.30E-12*exp(-(-380.0/TPK%T))
 TPK%K042=2.00E-12*exp(-(1400.0/TPK%T))
 TPK%K043=1.20E-13*exp(-(2450.0/TPK%T))
 TPK%K044=3.30E-39*exp(-(-530.0/TPK%T))
 TPK%K045=1.50E-11*exp(-(-170.0/TPK%T))
 TPK%K046=4.50E-14*exp(-(1260.0/TPK%T))
 TPK%K047=TROE(1.,2.20E-30,3.9,1.50E-12,0.7,TPK%M,TPK%T,KVECNPT)
 TPK%K048=TROE_EQUIL(2.20E-30,3.9,1.50E-12,0.7,3.70E+26,11000.0,TPK%M,TPK%T,KVE&
&CNPT)
 TPK%K049=8.50E-13*exp(-(2450.0/TPK%T))
 TPK%K050=3.30E-12*exp(-(900.0/TPK%T))
!
RETURN
END SUBROUTINE SUBSRG4
!
SUBROUTINE SUBSRG5
!
!Indices 51 a 60
!
 TPK%K051=5.50E-12*exp(-(2000.0/TPK%T))
 TPK%K052=TROE(1.,3.00E-31,3.3,1.50E-12,0.0,TPK%M,TPK%T,KVECNPT)
 TPK%K053=1.5E-13*(1.+2.439E-20*TPK%M)
 TPK%K054=6.00E-11
 TPK%K055=0.00E-01*exp(-(-13.0/TPK%T))
 TPK%K056=TPK%T*TPK%T*7.44E-18*exp(-(1361./TPK%T))
 TPK%K057=1.51E-17*TPK%T*TPK%T*exp(-(492./TPK%T))
 TPK%K058=3.76E-12*exp(-(260.0/TPK%T))+1.70E-12*exp(-(155.0/TPK%T))+1.21E-12*ex&
&p(-(125.0/TPK%T))
 TPK%K059=1.78E-12*exp(-(-438.0/TPK%T))+6.07E-13*exp(-(-500.0/TPK%T))+0.00E-01*&
&exp(-(-448.0/TPK%T))
 TPK%K060=2.54E-11*exp(-(-410.0/TPK%T))+0.00E-01*exp(-(-444.0/TPK%T))+0.00E-01
!
RETURN
END SUBROUTINE SUBSRG5
!
SUBROUTINE SUBSRG6
!
!Indices 61 a 70
!
 TPK%K061=3.31E-12*exp(-(-355.0/TPK%T))+3.45E-13
 TPK%K062=1.00E-11
 TPK%K063=5.55E-12*exp(-(-331.0/TPK%T))
 TPK%K064=TPK%T*TPK%T*5.68E-18*exp(-(-92.0/TPK%T))
 TPK%K065=1.32E-11+1.88E-12*exp(-(-175.0/TPK%T))
 TPK%K066=4.50E-13
 TPK%K067=6.00E-13
 TPK%K068=2.93E-12*exp(-(-190.0/TPK%T))
 TPK%K069=3.36E-12*exp(-(-190.0/TPK%T))
 TPK%K070=3.80E-14+1.59E-14*exp(-(-500.0/TPK%T))
!
RETURN
END SUBROUTINE SUBSRG6
!
SUBROUTINE SUBSRG7
!
!Indices 71 a 80
!
 TPK%K071=5.31E-12*exp(-(260.0/TPK%T))
 TPK%K072=3.40E-13*exp(-(1900.0/TPK%T))
 TPK%K073=1.40E-12*exp(-(1900.0/TPK%T))
 TPK%K074=1.62E-12*exp(-(1900.0/TPK%T))+0.00E-01*exp(-(150.0/TPK%T))+1.94E-14*e&
&xp(-(1000.0/TPK%T))
 TPK%K075=4.92E-16
 TPK%K076=4.35E-18*TPK%T*TPK%T*exp(-(2282.0/TPK%T))+1.91E-14*exp(-(450.0/TPK%T)&
&)+1.08E-15*exp(-(-450.0/TPK%T))+0.00E-01
 TPK%K077=4.00E-12*exp(-(446.0/TPK%T))+0.00E-01*exp(-(-490.0/TPK%T))+0.00E-01
 TPK%K078=3.76E-16*exp(-(500.0/TPK%T))
 TPK%K079=8.17E-15*exp(-(2580.0/TPK%T))+4.32E-16*exp(-(1800.0/TPK%T))+2.87E-17*&
&exp(-(845.0/TPK%T))+0.00E-01*exp(-(2283.0/TPK%T))
 TPK%K080=7.86E-15*exp(-(1913.0/TPK%T))+0.00E-01*exp(-(732.0/TPK%T))+0.00E-01
!
RETURN
END SUBROUTINE SUBSRG7
!
SUBROUTINE SUBSRG8
!
!Indices 81 a 90
!
 TPK%K081=0.00E-01*exp(-(2112.0/TPK%T))+1.38E-19
 TPK%K082=7.20E-17*exp(-(1700.0/TPK%T))
 TPK%K083=2.00E-11
 TPK%K084=1.00E-11
 TPK%K085=3.60E-11
 TPK%K086=1.66E-17*exp(-(-1044.0/TPK%T))
 TPK%K087=2.80E-11
 TPK%K088=TROE(5.86E-01,9.70E-29,5.6,9.30E-12,1.5,TPK%M,TPK%T,KVECNPT)
 TPK%K089=TROE_EQUIL(9.70E-29,5.6,9.30E-12,1.5,1.16E+28,13954.,TPK%M,TPK%T,KVEC&
&NPT)
 TPK%K090=4.20E-12*exp(-(-180.0/TPK%T))
!
RETURN
END SUBROUTINE SUBSRG8
!
SUBROUTINE SUBSRG9
!
!Indices 91 a 100
!
 TPK%K091=4.36E-12
 TPK%K092=6.93E-12
 TPK%K093=4.00E-12
 TPK%K094=4.00E-12
 TPK%K095=1.22E-11
 TPK%K096=4.00E-12
 TPK%K097=3.80E-13*exp(-(-800.0/TPK%T))
 TPK%K098=6.16E-14*exp(-(-700.0/TPK%T))+1.52E-13*exp(-(-1300.0/TPK%T))
 TPK%K099=1.81E-13*exp(-(-1300.0/TPK%T))
 TPK%K0100=1.28E-13*exp(-(-1300.0/TPK%T))+0.00E-01
!
RETURN
END SUBROUTINE SUBSRG9
!
SUBROUTINE SUBSRG10
!
!Indices 101 a 110
!
 TPK%K0101=3.75E-13*exp(-(-980.0/TPK%T))
 TPK%K0102=5.94E-13*exp(-(-550.0/TPK%T))+1.99E-16*exp(-(-2640.0/TPK%T))+5.56E-1&
&4*exp(-(-1300.0/TPK%T))
 TPK%K103=1.66E-13*exp(-(-1300.0/TPK%T))
 TPK%K104=9.10E-14*exp(-(-416.0/TPK%T))
 TPK%K105=1.03E-14*exp(-(-158.0/TPK%T))+6.24E-14*exp(-(-431.0/TPK%T))+1.53E-14*&
&exp(-(-467.0/TPK%T))+4.34E-15*exp(-(-633.0/TPK%T))
 TPK%K106=1.57E-13*exp(-(-708.0/TPK%T))
 TPK%K107=1.36E-13*exp(-(-708.0/TPK%T))
 TPK%K108=3.56E-14*exp(-(-708.0/TPK%T))
 TPK%K109=1.77E-11*exp(-(440.0/TPK%T))+1.48E-16*exp(-(-2510.0/TPK%T))+3.10E-13*&
&exp(-(-508.0/TPK%T))
 TPK%K110=1.12E-13*exp(-(-708.0/TPK%T))
!
RETURN
END SUBROUTINE SUBSRG10
!
SUBROUTINE SUBSRG11
!
!Indices 111 a 120
!
 TPK%K111=4.44E-14*exp(-(-211.0/TPK%T))+2.23E-13*exp(-(-460.0/TPK%T))+4.10E-14*&
&exp(-(-522.0/TPK%T))+1.17E-14*exp(-(-683.0/TPK%T))
 TPK%K112=4.36E-13*exp(-(-765.0/TPK%T))
 TPK%K113=7.60E-13*exp(-(-765.0/TPK%T))
 TPK%K114=3.63E-13*exp(-(-765.0/TPK%T))
 TPK%K115=7.73E-13*exp(-(-530.0/TPK%T))+1.70E-13*exp(-(-565.0/TPK%T))
 TPK%K116=4.85E-13*exp(-(-765.0/TPK%T))
 TPK%K117=4.19E-15*exp(-(-1000.0/TPK%T))
 TPK%K118=2.48E-14*exp(-(-1000.0/TPK%T))
 TPK%K119=1.20E-12
 TPK%K120=1.20E-12
!
RETURN
END SUBROUTINE SUBSRG11
!
SUBROUTINE SUBSRG12
!
!Indices 121 a 130
!
 TPK%K121=1.20E-12
 TPK%K122=1.20E-12
 TPK%K123=1.20E-12
 TPK%K124=3.48E-12
 TPK%K125=1.20E-12
 TPK%K126=1.66E-13*exp(-(-1300.0/TPK%T))
 TPK%K127=5.99E-15*exp(-(-1510.0/TPK%T))
 TPK%K128=1.69E-14*exp(-(-1560.0/TPK%T))
 TPK%K129=7.13E-17*exp(-(-2950.0/TPK%T))
 TPK%K130=4.00E-12
!
RETURN
END SUBROUTINE SUBSRG12
!
SUBROUTINE SUBSRG13
!
!Indices 131 a 132
!
 TPK%K131=1.20E-12
 TPK%K132=1.00E-40
!
RETURN
END SUBROUTINE SUBSRG13
!
SUBROUTINE SUBSRW0
!
!Indices 133 a 142
!
 TPK%KTC1=KT(0.05,48.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC2=KT(0.11,34.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC3=KT(0.0001,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC4=KT(0.0015,46.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC5=KT(0.05,62.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC6=KT(0.0037,108.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC7=KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC8=KT(0.054,63.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC9=KT(0.05,79.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC10=KT(0.04,17.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
!
RETURN
END SUBROUTINE SUBSRW0
!
SUBROUTINE SUBSRW1
!
!Indices 143 a 152
!
 TPK%KTC11=KT(0.05,17.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC12=KT(0.2,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC13=KT(0.0002,44.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC14=KT(0.11,64.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC15=KT(0.07,98.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC16=KT(0.04,30.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC17=KT(0.012,46.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC18=KT(0.03,60.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC19=KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
 TPK%KTC20=KT(0.007,48.,TPK%T,TPK%RADC,KVECNPT)*TPK%LWC
!
RETURN
END SUBROUTINE SUBSRW1
!
SUBROUTINE SUBSRW2
!
!Indices 153 a 162
!
 TPK%KTC21=KT(0.05,48.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(1.1e-2,-2830.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTC22=KT(0.11,34.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(7.73e4,-7310.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTC23=KT(0.0001,30.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(1.92e-3,-1790.,TPK%T,KV&
&ECNPT)*TPK%RCH*TPK%T)
 TPK%KTC24=KT(0.0015,46.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(1.4e-2,0.,TPK%T,KVECNPT&
&)*TPK%RCH*TPK%T)
 TPK%KTC25=KT(0.05,62.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(3.8e-2,0.,TPK%T,KVECNPT)*&
&TPK%RCH*TPK%T)
 TPK%KTC26=KT(0.0037,108.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(2.1,-3400.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTC27=KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(5.0e1,-4880.,1.6e-3,1760.&
&,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC28=KT(0.054,63.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(2.1e5,-8700.,2.2e1,0.,0.&
&,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC29=KT(0.05,79.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(1.2e4,-6900.,1.26e-6,0.,0&
&.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC30=KT(0.04,17.,TPK%T,TPK%RADC,KVECNPT)/(HEFFB(6.02e1,-4160.,1.7e-5,4350&
&.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
!
RETURN
END SUBROUTINE SUBSRW2
!
SUBROUTINE SUBSRW3
!
!Indices 163 a 172
!
 TPK%KTC31=KT(0.05,17.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(3.9e1,0.,TPK%T,KVECNPT)*T&
&PK%RCH*TPK%T)
 TPK%KTC32=KT(0.2,30.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(6.9e2,0.,1.6e-5,0.,0.,0.,T&
&PK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC33=KT(0.0002,44.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(3.4e-2,-2710.,4.3e-7,92&
&0.,4.7e-11,1780.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC34=KT(0.11,64.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(1.36,-2930.,1.3e-2,-1965.&
&,6.4e-8,-1430.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC35=KT(0.07,98.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(2.1e5,-8700.,1.0e3,0.,1.0&
&e-2,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC36=KT(0.04,30.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(3.23e3,-7100.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTC37=KT(0.012,46.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(8.9e3,-6100.,1.8e-4,150.&
&,0.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC38=KT(0.03,60.,TPK%T,TPK%RADC,KVECNPT)/(HEFFA(4.1e3,-6200.,1.74e-5,0.,0&
&.,0.,TPK%PHC,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTC39=KT(0.05,47.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(2.7e0,-2030.,TPK%T,KVECNP&
&T)*TPK%RCH*TPK%T)
 TPK%KTC40=KT(0.007,48.,TPK%T,TPK%RADC,KVECNPT)/(HENRY(3.e2,-5280.,TPK%T,KVECNP&
&T)*TPK%RCH*TPK%T)
!
RETURN
END SUBROUTINE SUBSRW3
!
SUBROUTINE SUBSRW4
!
!Indices 173 a 182
!
 TPK%KTR1=KT(0.05,48.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR2=KT(0.11,34.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR3=KT(0.0001,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR4=KT(0.0015,46.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR5=KT(0.05,62.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR6=KT(0.0037,108.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR7=KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR8=KT(0.054,63.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR9=KT(0.05,79.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR10=KT(0.04,17.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
!
RETURN
END SUBROUTINE SUBSRW4
!
SUBROUTINE SUBSRW5
!
!Indices 183 a 192
!
 TPK%KTR11=KT(0.05,17.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR12=KT(0.2,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR13=KT(0.0002,44.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR14=KT(0.11,64.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR15=KT(0.07,98.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR16=KT(0.04,30.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR17=KT(0.012,46.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR18=KT(0.03,60.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR19=KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
 TPK%KTR20=KT(0.007,48.,TPK%T,TPK%RADR,KVECNPT)*TPK%LWR
!
RETURN
END SUBROUTINE SUBSRW5
!
SUBROUTINE SUBSRW6
!
!Indices 193 a 202
!
 TPK%KTR21=KT(0.05,48.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(1.1e-2,-2830.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTR22=KT(0.11,34.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(7.73e4,-7310.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTR23=KT(0.0001,30.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(1.92e-3,-1790.,TPK%T,KV&
&ECNPT)*TPK%RCH*TPK%T)
 TPK%KTR24=KT(0.0015,46.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(1.4e-2,0.,TPK%T,KVECNPT&
&)*TPK%RCH*TPK%T)
 TPK%KTR25=KT(0.05,62.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(3.8e-2,0.,TPK%T,KVECNPT)*&
&TPK%RCH*TPK%T)
 TPK%KTR26=KT(0.0037,108.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(2.1,-3400.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTR27=KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(5.0e1,-4880.,1.6e-3,1760.&
&,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR28=KT(0.054,63.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(2.1e5,-8700.,2.2e1,0.,0.&
&,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR29=KT(0.05,79.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(1.2e4,-6900.,1.26e-6,0.,0&
&.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR30=KT(0.04,17.,TPK%T,TPK%RADR,KVECNPT)/(HEFFB(6.02e1,-4160.,1.7e-5,4350&
&.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
!
RETURN
END SUBROUTINE SUBSRW6
!
SUBROUTINE SUBSRW7
!
!Indices 203 a 212
!
 TPK%KTR31=KT(0.05,17.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(3.9e1,0.,TPK%T,KVECNPT)*T&
&PK%RCH*TPK%T)
 TPK%KTR32=KT(0.2,30.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(6.9e2,0.,1.6e-5,0.,0.,0.,T&
&PK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR33=KT(0.0002,44.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(3.4e-2,-2710.,4.3e-7,92&
&0.,4.7e-11,1780.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR34=KT(0.11,64.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(1.36,-2930.,1.3e-2,-1965.&
&,6.4e-8,-1430.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR35=KT(0.07,98.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(2.1e5,-8700.,1.0e3,0.,1.0&
&e-2,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR36=KT(0.04,30.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(3.23e3,-7100.,TPK%T,KVECN&
&PT)*TPK%RCH*TPK%T)
 TPK%KTR37=KT(0.012,46.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(8.9e3,-6100.,1.8e-4,150.&
&,0.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR38=KT(0.03,60.,TPK%T,TPK%RADR,KVECNPT)/(HEFFA(4.1e3,-6200.,1.74e-5,0.,0&
&.,0.,TPK%PHR,TPK%T,KVECNPT)*TPK%RCH*TPK%T)
 TPK%KTR39=KT(0.05,47.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(2.7e0,-2030.,TPK%T,KVECNP&
&T)*TPK%RCH*TPK%T)
 TPK%KTR40=KT(0.007,48.,TPK%T,TPK%RADR,KVECNPT)/(HENRY(3.e2,-5280.,TPK%T,KVECNP&
&T)*TPK%RCH*TPK%T)
!
RETURN
END SUBROUTINE SUBSRW7
!
SUBROUTINE SUBSRW8
!
!Indices 213 a 222
!
 TPK%KC2=(3.6E+9*exp(-930.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD
 TPK%KC3=((2.8E+10*10.**(-TPK%PHC)+3.5E+10*exp(-720.*(1./TPK%T-1./298.15))*1.6e&
&-5)/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD
 TPK%KC4=(3.2E+7*exp(-1700.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD
 TPK%KC5=((8.3E+5*exp(-2700.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHC))**2.+9.6E+7&
&*exp(-910.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*1.6e-5)/(1.6e-5+10.**(-TPK%PH&
&C))**2.)/TPK%MOL2MOLECCLOUD
 TPK%KC6=(1.5E+9*exp(-1500.*(1./TPK%T-1./298.15))*1.6e-5/(1.6e-5+10.**(-TPK%PHC&
&)))/TPK%MOL2MOLECCLOUD
 TPK%KC7=(2.7E+9*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)/(1.3e-2&
&*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2&
&*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%M&
&OL2MOLECCLOUD
 TPK%KC8=(1.0E+10*10.**(-TPK%PHC)/(1.6e-3*exp(-1760.*(1./TPK%T-1./298.15))+10.*&
&*(-TPK%PHC)))/TPK%MOL2MOLECCLOUD
 TPK%KC9=((1.8E+9*10.**(-TPK%PHC)+4.5E+9*1.6e-5)/(1.6e-5+10.**(-TPK%PHC)))/TPK%&
&MOL2MOLECCLOUD
 TPK%KC10=2.6E-2*10.**(-TPK%PHC)/(1.26e-6+10.**(-TPK%PHC))
!
RETURN
END SUBROUTINE SUBSRW8
!
SUBROUTINE SUBSRW9
!
!Indices 223 a 232
!
 TPK%KC11=1.1E0*1.26e-6/(1.26e-6+10.**(-TPK%PHC))
 TPK%KC12=(3.3E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHC))**2./&
&((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)&
&)+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.&
&)*(1.26e-6+10.**(-TPK%PHC))))/TPK%MOL2MOLECCLOUD
 TPK%KC14=1.0E+10
 TPK%KC15=(1.0E+5*1.0e+3*1.0e-2/(1.0e+3*1.0e-2+1.0e+3*10.**(-TPK%PHC)+(10.**(-T&
&PK%PHC))**2.))/TPK%MOL2MOLECCLOUD
 TPK%KC16=(1.3E+9*exp(-2200.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1&
&./298.15))*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(&
&1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%&
&PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD
 TPK%KC17=(1.7E+8*exp(-2200.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD
 TPK%KC18=(5.0E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)/(1.3e-&
&2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-&
&2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%&
&MOL2MOLECCLOUD
 TPK%KC19=(7.8E+8*exp(-1000.*(1./TPK%T-1./298.15))*2.5e3*exp(4030.*(1./TPK%T-1.&
&/298.15))/(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15))))/TPK%MOL2MOLECCLOUD
 TPK%KC20=((1.0E+8*exp(-1000.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+3.4E+9*exp(&
&-1200.*(1./TPK%T-1./298.15))*1.8e-4*exp(150.*(1./TPK%T-1./298.15)))/(1.8e-4*ex&
&p(150.*(1./TPK%T-1./298.15))+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD
!
RETURN
END SUBROUTINE SUBSRW9
!
SUBROUTINE SUBSRW10
!
!Indices 233 a 242
!
 TPK%KC21=((7.9E+2*exp(-2900.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-&
&1./298.15))*10.**(-TPK%PHC)+2.5E+7*exp(-2450.*(1./TPK%T-1./298.15))*1.3e-2*exp&
&(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/((1.3e-2*&
&exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*&
&exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.)*(1.+2.5&
&e3*exp(4030.*(1./TPK%T-1./298.15)))))/TPK%MOL2MOLECCLOUD
 TPK%KC22=7.7E-3*exp(-9200.*(1./TPK%T-1./298.15))+3.7E+3*1.e-14*EXP(-6716*(1./T&
&PK%T-1./298.15))/10.**(-TPK%PHC)
 TPK%KC23=3.0E+8/TPK%MOL2MOLECCLOUD
 TPK%KC24=1.1E+9
 TPK%KC25=(1.7E+9*10.**(-TPK%PHC)/(1.6e-5+10.**(-TPK%PHC)))/TPK%MOL2MOLECCLOUD
 TPK%KC26=(2.2E+8*exp(-2600.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECCLOUD
 TPK%KC27=(7.1E+6*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)*10.**(&
&-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1&
&./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%&
&PHC))**2.))/TPK%MOL2MOLECCLOUD
 TPK%KC28=4.6E+2*exp(-1100.*(1./TPK%T-1./298.15))
 TPK%KC29=((3.7E+5*exp(-5500.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-&
&1./298.15))*10.**(-TPK%PHC)+1.5E+9*exp(-5300.*(1./TPK%T-1./298.15))*1.3e-2*exp&
&(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/(1.3e-2*e&
&xp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*e&
&xp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL&
&2MOLECCLOUD
 TPK%KC30=(9.1E+7*exp(-3600.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1&
&./298.15))*10.**(-TPK%PHC)*10.**(-TPK%PHC)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.&
&15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.&
&15))*10.**(-TPK%PHC)+(10.**(-TPK%PHC))**2.))/TPK%MOL2MOLECCLOUD
!
RETURN
END SUBROUTINE SUBSRW10
!
SUBROUTINE SUBSRW11
!
!Indices 243 a 252
!
 TPK%KR2=(3.6E+9*exp(-930.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN
 TPK%KR3=((2.8E+10*10.**(-TPK%PHR)+3.5E+10*exp(-720.*(1./TPK%T-1./298.15))*1.6e&
&-5)/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN
 TPK%KR4=(3.2E+7*exp(-1700.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN
 TPK%KR5=((8.3E+5*exp(-2700.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHR))**2.+9.6E+7&
&*exp(-910.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*1.6e-5)/(1.6e-5+10.**(-TPK%PH&
&R))**2.)/TPK%MOL2MOLECRAIN
 TPK%KR6=(1.5E+9*exp(-1500.*(1./TPK%T-1./298.15))*1.6e-5/(1.6e-5+10.**(-TPK%PHR&
&)))/TPK%MOL2MOLECRAIN
 TPK%KR7=(2.7E+9*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)/(1.3e-2&
&*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2&
&*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%M&
&OL2MOLECRAIN
 TPK%KR8=(1.0E+10*10.**(-TPK%PHR)/(1.6e-3*exp(-1760.*(1./TPK%T-1./298.15))+10.*&
&*(-TPK%PHR)))/TPK%MOL2MOLECRAIN
 TPK%KR9=((1.8E+9*10.**(-TPK%PHR)+4.5E+9*1.6e-5)/(1.6e-5+10.**(-TPK%PHR)))/TPK%&
&MOL2MOLECRAIN
 TPK%KR10=2.6E-2*10.**(-TPK%PHR)/(1.26e-6+10.**(-TPK%PHR))
!
RETURN
END SUBROUTINE SUBSRW11
!
SUBROUTINE SUBSRW12
!
!Indices 253 a 262
!
 TPK%KR11=1.1E0*1.26e-6/(1.26e-6+10.**(-TPK%PHR))
 TPK%KR12=(3.3E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*(10.**(-TPK%PHR))**2./&
&((1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)&
&)+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.&
&)*(1.26e-6+10.**(-TPK%PHR))))/TPK%MOL2MOLECRAIN
 TPK%KR14=1.0E+10
 TPK%KR15=(1.0E+5*1.0e+3*1.0e-2/(1.0e+3*1.0e-2+1.0e+3*10.**(-TPK%PHR)+(10.**(-T&
&PK%PHR))**2.))/TPK%MOL2MOLECRAIN
 TPK%KR16=(1.3E+9*exp(-2200.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1&
&./298.15))*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(&
&1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%&
&PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN
 TPK%KR17=(1.7E+8*exp(-2200.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN
 TPK%KR18=(5.0E+5*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)/(1.3e-&
&2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-&
&2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%&
&MOL2MOLECRAIN
 TPK%KR19=(7.8E+8*exp(-1000.*(1./TPK%T-1./298.15))*2.5e3*exp(4030.*(1./TPK%T-1.&
&/298.15))/(1.+2.5e3*exp(4030.*(1./TPK%T-1./298.15))))/TPK%MOL2MOLECRAIN
 TPK%KR20=((1.0E+8*exp(-1000.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+3.4E+9*exp(&
&-1200.*(1./TPK%T-1./298.15))*1.8e-4*exp(150.*(1./TPK%T-1./298.15)))/(1.8e-4*ex&
&p(150.*(1./TPK%T-1./298.15))+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN
!
RETURN
END SUBROUTINE SUBSRW12
!
SUBROUTINE SUBSRW13
!
!Indices 263 a 272
!
 TPK%KR21=((7.9E+2*exp(-2900.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-&
&1./298.15))*10.**(-TPK%PHR)+2.5E+7*exp(-2450.*(1./TPK%T-1./298.15))*1.3e-2*exp&
&(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/((1.3e-2*&
&exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*&
&exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.)*(1.+2.5&
&e3*exp(4030.*(1./TPK%T-1./298.15)))))/TPK%MOL2MOLECRAIN
 TPK%KR22=7.7E-3*exp(-9200.*(1./TPK%T-1./298.15))+3.7E+3*1.e-14*EXP(-6716*(1./T&
&PK%T-1./298.15))/10.**(-TPK%PHR)
 TPK%KR23=3.0E+8/TPK%MOL2MOLECRAIN
 TPK%KR24=1.1E+9
 TPK%KR25=(1.7E+9*10.**(-TPK%PHR)/(1.6e-5+10.**(-TPK%PHR)))/TPK%MOL2MOLECRAIN
 TPK%KR26=(2.2E+8*exp(-2600.*(1./TPK%T-1./298.15)))/TPK%MOL2MOLECRAIN
 TPK%KR27=(7.1E+6*1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)*10.**(&
&-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1&
&./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%&
&PHR))**2.))/TPK%MOL2MOLECRAIN
 TPK%KR28=4.6E+2*exp(-1100.*(1./TPK%T-1./298.15))
 TPK%KR29=((3.7E+5*exp(-5500.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-&
&1./298.15))*10.**(-TPK%PHR)+1.5E+9*exp(-5300.*(1./TPK%T-1./298.15))*1.3e-2*exp&
&(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15)))/(1.3e-2*e&
&xp(1965.*(1./TPK%T-1./298.15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*e&
&xp(1965.*(1./TPK%T-1./298.15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL&
&2MOLECRAIN
 TPK%KR30=(9.1E+7*exp(-3600.*(1./TPK%T-1./298.15))*1.3e-2*exp(1965.*(1./TPK%T-1&
&./298.15))*10.**(-TPK%PHR)*10.**(-TPK%PHR)/(1.3e-2*exp(1965.*(1./TPK%T-1./298.&
&15))*6.4e-8*exp(1430.*(1./TPK%T-1./298.15))+1.3e-2*exp(1965.*(1./TPK%T-1./298.&
&15))*10.**(-TPK%PHR)+(10.**(-TPK%PHR))**2.))/TPK%MOL2MOLECRAIN
!
RETURN
END SUBROUTINE SUBSRW13
!
END SUBROUTINE CH_SET_RATES
!
!
!========================================================================
!
!!    ##############################
      MODULE MODI_CH_SET_PHOTO_RATES
!!    ##############################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_SET_PHOTO_RATES(PTIME,PCONC,KL,TPM,KMI,KOUT,KVERB,KVECNPT,KVECMASK,KEQ,PJVALUES)
USE MODD_CH_M9_n, ONLY: METEOTRANSTYPE
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT,KL,KEQ,KMI
INTEGER, DIMENSION(:,:), INTENT(IN)              :: KVECMASK
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
TYPE(METEOTRANSTYPE), DIMENSION(KVECNPT), INTENT(IN) :: TPM
INTEGER, INTENT(IN)                              :: KOUT,KVERB
REAL,DIMENSION(:,:,:,:), INTENT(IN) :: PJVALUES    ! Tuv coefficient
END SUBROUTINE CH_SET_PHOTO_RATES
END INTERFACE
END MODULE MODI_CH_SET_PHOTO_RATES
!
!========================================================================
!
!!    #############################################################
      SUBROUTINE CH_SET_PHOTO_RATES(PTIME,PCONC,KL,TPM,KMI,KOUT,KVERB,KVECNPT,KVECMASK,KEQ,PJVALUES)
!!    #############################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!*** *MODD_CH_SET_PHOTO_RATES*
!!
!!    PURPOSE
!!    -------
!       set or calculate photolysis rates
!!
!!**  METHOD
!!    ------
!!      simple
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 29/03/01: Vectorization + nesting (C. Mari)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
USE MODD_CH_M9_n,        ONLY : METEOTRANSTYPE
USE MODI_CH_ALLOCATE_TACCS
!     USER DEFINED FUNCTIONS
USE MODI_KT
USE MODI_TROE
USE MODI_HENRY
USE MODI_HEFFA
USE MODI_TROE_EQUIL
USE MODI_HEFFB
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                              :: PTIME
INTEGER, INTENT(IN)                              :: KVECNPT,KL,KEQ,KMI
INTEGER, DIMENSION(:,:), INTENT(IN)              :: KVECMASK
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)     :: PCONC
TYPE(METEOTRANSTYPE), DIMENSION(KVECNPT), INTENT(IN) :: TPM
INTEGER, INTENT(IN)                              :: KOUT,KVERB
REAL,DIMENSION(:,:,:,:), INTENT(IN) :: PJVALUES    ! Tuv coefficient
!!
! /BEGIN_SET_PHOTO_RATES/
! parameter for use by subroutine JVALUES,
! contains the actual photolysis rates
REAL, DIMENSION(KVECNPT,42) :: ZRATESIO ! TUV photolysis rates at one level
REAL, DIMENSION(KVECNPT,19) :: ZRATES   ! photolysis rates of RACM (vector)
INTEGER                     :: JITPK    ! loop counter for J-Value transfer
INTEGER                     :: IDTI,IDTJ
INTEGER                     :: JITPKPLUS
INTEGER, DIMENSION(KVECNPT) :: ITABI, ITABJ
INTEGER, DIMENSION(KVECNPT) :: IMODELLEVEL
TYPE(CCSTYPE), POINTER      :: TPK
!
! Normally allocated in CH_SET_RATES but who knows ?
IF (.NOT. ASSOCIATED(TACCS(KMI)%NVERB)) THEN
  CALL CH_ALLOCATE_TACCS(KMI, KVECNPT)
END IF
!
! TPK is set for current model 
TPK=>TACCS(KMI)
!
! calculation of photolysis rates and transfer into local variables
!
IDTI=KVECMASK(2,KL)-KVECMASK(1,KL)+1
IDTJ=KVECMASK(4,KL)-KVECMASK(3,KL)+1
DO JITPK = 0, KVECNPT-1
!
  JITPKPLUS=JITPK+1
  ITABI(JITPKPLUS)=JITPK-IDTI*(JITPK/IDTI)+KVECMASK(1,KL)
  ITABJ(JITPKPLUS)=JITPK/IDTI-IDTJ*(JITPK/(IDTI*IDTJ))+KVECMASK(3,KL)
!
  ZRATESIO(JITPKPLUS,:) = PJVALUES(ITABI(JITPKPLUS),ITABJ(JITPKPLUS),TPK%MODELLEVEL(JITPKPLUS),:)
!
ENDDO
!
!
DO JITPK = 0, KVECNPT-1
!
! associate TUV J-Values to ReLACS J-Values
!  
! change according to original coefficients and modified RACM
!
  ZRATES(JITPK+1, 1) = ZRATESIO(JITPK+1,5)
  ZRATES(JITPK+1, 2) = ZRATESIO(JITPK+1,2)
  ZRATES(JITPK+1, 3) = ZRATESIO(JITPK+1,3)
  ZRATES(JITPK+1, 4) = ZRATESIO(JITPK+1,8)
  ZRATES(JITPK+1, 5) = ZRATESIO(JITPK+1,9)
  ZRATES(JITPK+1, 6) = ZRATESIO(JITPK+1,10)
  ZRATES(JITPK+1, 7) = ZRATESIO(JITPK+1,6)
  ZRATES(JITPK+1, 8) = ZRATESIO(JITPK+1,7)
  ZRATES(JITPK+1, 9) = ZRATESIO(JITPK+1,4)
  ZRATES(JITPK+1, 10) = ZRATESIO(JITPK+1,12)
  ZRATES(JITPK+1, 11) = ZRATESIO(JITPK+1,11)
  ZRATES(JITPK+1, 12) = ZRATESIO(JITPK+1,13)
  ZRATES(JITPK+1, 13) = ZRATESIO(JITPK+1,17)
  ZRATES(JITPK+1, 14) =  0.962055 *ZRATESIO(JITPK+1,17)+&
                    &  3.79454E-02 *ZRATESIO(JITPK+1,38)
  ZRATES(JITPK+1, 15) =  ZRATESIO(JITPK+1,33)
  ZRATES(JITPK+1, 16) =  0.20842 *ZRATESIO(JITPK+1,35)&
                    &+ 6.43207E-02 *ZRATESIO(JITPK+1,36)&
                    &+ 3.10372E-02 *ZRATESIO(JITPK+1,34)&
                    &+ 0.376 *ZRATESIO(JITPK+1,37)&
                    &+ 0.31937 *ZRATESIO(JITPK+1,26)
  ZRATES(JITPK+1, 17) = 0.20*ZRATESIO(JITPK+1,20)&
                    &+ 0.80*ZRATESIO(JITPK+1,21)
! aqueous phase photolysis
  ZRATES(JITPK+1, 18) = ZRATESIO(JITPK+1,41)
  ZRATES(JITPK+1, 19) = ZRATESIO(JITPK+1,42)
!
END DO
!
! /END_SET_PHOTO_RATES/
 TPK%K001=ZRATES(:,001)
 TPK%K002=ZRATES(:,002)
 TPK%K003=ZRATES(:,003)
 TPK%K004=ZRATES(:,004)
 TPK%K005=ZRATES(:,005)
 TPK%K006=ZRATES(:,006)
 TPK%K007=ZRATES(:,007)
 TPK%K008=ZRATES(:,008)
 TPK%K009=ZRATES(:,009)
 TPK%K010=ZRATES(:,010)
 TPK%K011=ZRATES(:,011)
 TPK%K012=ZRATES(:,012)
 TPK%K013=ZRATES(:,013)
 TPK%K014=ZRATES(:,014)
 TPK%K015=ZRATES(:,015)
 TPK%K016=ZRATES(:,016)
 TPK%K017=ZRATES(:,017)
IF (TPK%LUSECHAQ) THEN
 TPK%KC1=ZRATES(:,018)
 TPK%KC13=ZRATES(:,019)*2.2e+1/(2.2e+1+10.**(-TPK%PHC))
 TPK%KR1=ZRATES(:,018)
 TPK%KR13=ZRATES(:,019)*2.2e+1/(2.2e+1+10.**(-TPK%PHR))
END IF
TPK%NOUT  = KOUT
TPK%NVERB = KVERB
RETURN
END SUBROUTINE CH_SET_PHOTO_RATES
!
!
!========================================================================
!
!!    ########################
      MODULE MODI_CH_GET_RATES
!!    ########################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
INTERFACE
SUBROUTINE CH_GET_RATES(PRATE,KMI,KVECNPT,KREAC)
IMPLICIT NONE
INTEGER, INTENT(IN)                         :: KVECNPT
INTEGER, INTENT(IN)                         :: KREAC
REAL, INTENT(OUT), DIMENSION(KVECNPT,KREAC) :: PRATE
INTEGER, INTENT(IN)                         :: KMI
END SUBROUTINE CH_GET_RATES
END INTERFACE
END MODULE MODI_CH_GET_RATES
!
!========================================================================
!
!!    ############################################
      SUBROUTINE CH_GET_RATES(PRATE,KMI,KVECNPT,KREAC)
!!    ############################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_GETRATES*
!!
!!    PURPOSE
!!    -------
!       retrieve reaction rates from TPK in an array
!!
!!**  METHOD
!!    ------
!!      simple
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
INTEGER, INTENT(IN)                         :: KVECNPT
INTEGER, INTENT(IN)                         :: KREAC
REAL, INTENT(OUT), DIMENSION(KVECNPT,KREAC) :: PRATE
INTEGER, INTENT(IN)                         :: KMI
!!
!!    LOCAL VARIABLES
!!    ---------------
TYPE(CCSTYPE), POINTER                      :: TPK
!!----------------------------------------------------------------------
!!
!!    EXECUTABLE STATEMENTS
!!    ---------------------
TPK=>TACCS(KMI)
!!
PRATE(:,1) = TPK%K001(:)
PRATE(:,2) = TPK%K002(:)
PRATE(:,3) = TPK%K003(:)
PRATE(:,4) = TPK%K004(:)
PRATE(:,5) = TPK%K005(:)
PRATE(:,6) = TPK%K006(:)
PRATE(:,7) = TPK%K007(:)
PRATE(:,8) = TPK%K008(:)
PRATE(:,9) = TPK%K009(:)
PRATE(:,10) = TPK%K010(:)
PRATE(:,11) = TPK%K011(:)
PRATE(:,12) = TPK%K012(:)
PRATE(:,13) = TPK%K013(:)
PRATE(:,14) = TPK%K014(:)
PRATE(:,15) = TPK%K015(:)
PRATE(:,16) = TPK%K016(:)
PRATE(:,17) = TPK%K017(:)
PRATE(:,18) = TPK%K018(:)
PRATE(:,19) = TPK%K019(:)
PRATE(:,20) = TPK%K020(:)
PRATE(:,21) = TPK%K021(:)
PRATE(:,22) = TPK%K022(:)
PRATE(:,23) = TPK%K023(:)
PRATE(:,24) = TPK%K024(:)
PRATE(:,25) = TPK%K025(:)
PRATE(:,26) = TPK%K026(:)
PRATE(:,27) = TPK%K027(:)
PRATE(:,28) = TPK%K028(:)
PRATE(:,29) = TPK%K029(:)
PRATE(:,30) = TPK%K030(:)
PRATE(:,31) = TPK%K031(:)
PRATE(:,32) = TPK%K032(:)
PRATE(:,33) = TPK%K033(:)
PRATE(:,34) = TPK%K034(:)
PRATE(:,35) = TPK%K035(:)
PRATE(:,36) = TPK%K036(:)
PRATE(:,37) = TPK%K037(:)
PRATE(:,38) = TPK%K038(:)
PRATE(:,39) = TPK%K039(:)
PRATE(:,40) = TPK%K040(:)
PRATE(:,41) = TPK%K041(:)
PRATE(:,42) = TPK%K042(:)
PRATE(:,43) = TPK%K043(:)
PRATE(:,44) = TPK%K044(:)
PRATE(:,45) = TPK%K045(:)
PRATE(:,46) = TPK%K046(:)
PRATE(:,47) = TPK%K047(:)
PRATE(:,48) = TPK%K048(:)
PRATE(:,49) = TPK%K049(:)
PRATE(:,50) = TPK%K050(:)
PRATE(:,51) = TPK%K051(:)
PRATE(:,52) = TPK%K052(:)
PRATE(:,53) = TPK%K053(:)
PRATE(:,54) = TPK%K054(:)
PRATE(:,55) = TPK%K055(:)
PRATE(:,56) = TPK%K056(:)
PRATE(:,57) = TPK%K057(:)
PRATE(:,58) = TPK%K058(:)
PRATE(:,59) = TPK%K059(:)
PRATE(:,60) = TPK%K060(:)
PRATE(:,61) = TPK%K061(:)
PRATE(:,62) = TPK%K062(:)
PRATE(:,63) = TPK%K063(:)
PRATE(:,64) = TPK%K064(:)
PRATE(:,65) = TPK%K065(:)
PRATE(:,66) = TPK%K066(:)
PRATE(:,67) = TPK%K067(:)
PRATE(:,68) = TPK%K068(:)
PRATE(:,69) = TPK%K069(:)
PRATE(:,70) = TPK%K070(:)
PRATE(:,71) = TPK%K071(:)
PRATE(:,72) = TPK%K072(:)
PRATE(:,73) = TPK%K073(:)
PRATE(:,74) = TPK%K074(:)
PRATE(:,75) = TPK%K075(:)
PRATE(:,76) = TPK%K076(:)
PRATE(:,77) = TPK%K077(:)
PRATE(:,78) = TPK%K078(:)
PRATE(:,79) = TPK%K079(:)
PRATE(:,80) = TPK%K080(:)
PRATE(:,81) = TPK%K081(:)
PRATE(:,82) = TPK%K082(:)
PRATE(:,83) = TPK%K083(:)
PRATE(:,84) = TPK%K084(:)
PRATE(:,85) = TPK%K085(:)
PRATE(:,86) = TPK%K086(:)
PRATE(:,87) = TPK%K087(:)
PRATE(:,88) = TPK%K088(:)
PRATE(:,89) = TPK%K089(:)
PRATE(:,90) = TPK%K090(:)
PRATE(:,91) = TPK%K091(:)
PRATE(:,92) = TPK%K092(:)
PRATE(:,93) = TPK%K093(:)
PRATE(:,94) = TPK%K094(:)
PRATE(:,95) = TPK%K095(:)
PRATE(:,96) = TPK%K096(:)
PRATE(:,97) = TPK%K097(:)
PRATE(:,98) = TPK%K098(:)
PRATE(:,99) = TPK%K099(:)
PRATE(:,100) = TPK%K0100(:)
PRATE(:,101) = TPK%K0101(:)
PRATE(:,102) = TPK%K0102(:)
PRATE(:,103) = TPK%K103(:)
PRATE(:,104) = TPK%K104(:)
PRATE(:,105) = TPK%K105(:)
PRATE(:,106) = TPK%K106(:)
PRATE(:,107) = TPK%K107(:)
PRATE(:,108) = TPK%K108(:)
PRATE(:,109) = TPK%K109(:)
PRATE(:,110) = TPK%K110(:)
PRATE(:,111) = TPK%K111(:)
PRATE(:,112) = TPK%K112(:)
PRATE(:,113) = TPK%K113(:)
PRATE(:,114) = TPK%K114(:)
PRATE(:,115) = TPK%K115(:)
PRATE(:,116) = TPK%K116(:)
PRATE(:,117) = TPK%K117(:)
PRATE(:,118) = TPK%K118(:)
PRATE(:,119) = TPK%K119(:)
PRATE(:,120) = TPK%K120(:)
PRATE(:,121) = TPK%K121(:)
PRATE(:,122) = TPK%K122(:)
PRATE(:,123) = TPK%K123(:)
PRATE(:,124) = TPK%K124(:)
PRATE(:,125) = TPK%K125(:)
PRATE(:,126) = TPK%K126(:)
PRATE(:,127) = TPK%K127(:)
PRATE(:,128) = TPK%K128(:)
PRATE(:,129) = TPK%K129(:)
PRATE(:,130) = TPK%K130(:)
PRATE(:,131) = TPK%K131(:)
PRATE(:,132) = TPK%K132(:)
IF (TPK%LUSECHAQ) THEN
  PRATE(:,133) = TPK%KTC1(:)
  PRATE(:,134) = TPK%KTC2(:)
  PRATE(:,135) = TPK%KTC3(:)
  PRATE(:,136) = TPK%KTC4(:)
  PRATE(:,137) = TPK%KTC5(:)
  PRATE(:,138) = TPK%KTC6(:)
  PRATE(:,139) = TPK%KTC7(:)
  PRATE(:,140) = TPK%KTC8(:)
  PRATE(:,141) = TPK%KTC9(:)
  PRATE(:,142) = TPK%KTC10(:)
  PRATE(:,143) = TPK%KTC11(:)
  PRATE(:,144) = TPK%KTC12(:)
  PRATE(:,145) = TPK%KTC13(:)
  PRATE(:,146) = TPK%KTC14(:)
  PRATE(:,147) = TPK%KTC15(:)
  PRATE(:,148) = TPK%KTC16(:)
  PRATE(:,149) = TPK%KTC17(:)
  PRATE(:,150) = TPK%KTC18(:)
  PRATE(:,151) = TPK%KTC19(:)
  PRATE(:,152) = TPK%KTC20(:)
  PRATE(:,153) = TPK%KTC21(:)
  PRATE(:,154) = TPK%KTC22(:)
  PRATE(:,155) = TPK%KTC23(:)
  PRATE(:,156) = TPK%KTC24(:)
  PRATE(:,157) = TPK%KTC25(:)
  PRATE(:,158) = TPK%KTC26(:)
  PRATE(:,159) = TPK%KTC27(:)
  PRATE(:,160) = TPK%KTC28(:)
  PRATE(:,161) = TPK%KTC29(:)
  PRATE(:,162) = TPK%KTC30(:)
  PRATE(:,163) = TPK%KTC31(:)
  PRATE(:,164) = TPK%KTC32(:)
  PRATE(:,165) = TPK%KTC33(:)
  PRATE(:,166) = TPK%KTC34(:)
  PRATE(:,167) = TPK%KTC35(:)
  PRATE(:,168) = TPK%KTC36(:)
  PRATE(:,169) = TPK%KTC37(:)
  PRATE(:,170) = TPK%KTC38(:)
  PRATE(:,171) = TPK%KTC39(:)
  PRATE(:,172) = TPK%KTC40(:)
  PRATE(:,173) = TPK%KTR1(:)
  PRATE(:,174) = TPK%KTR2(:)
  PRATE(:,175) = TPK%KTR3(:)
  PRATE(:,176) = TPK%KTR4(:)
  PRATE(:,177) = TPK%KTR5(:)
  PRATE(:,178) = TPK%KTR6(:)
  PRATE(:,179) = TPK%KTR7(:)
  PRATE(:,180) = TPK%KTR8(:)
  PRATE(:,181) = TPK%KTR9(:)
  PRATE(:,182) = TPK%KTR10(:)
  PRATE(:,183) = TPK%KTR11(:)
  PRATE(:,184) = TPK%KTR12(:)
  PRATE(:,185) = TPK%KTR13(:)
  PRATE(:,186) = TPK%KTR14(:)
  PRATE(:,187) = TPK%KTR15(:)
  PRATE(:,188) = TPK%KTR16(:)
  PRATE(:,189) = TPK%KTR17(:)
  PRATE(:,190) = TPK%KTR18(:)
  PRATE(:,191) = TPK%KTR19(:)
  PRATE(:,192) = TPK%KTR20(:)
  PRATE(:,193) = TPK%KTR21(:)
  PRATE(:,194) = TPK%KTR22(:)
  PRATE(:,195) = TPK%KTR23(:)
  PRATE(:,196) = TPK%KTR24(:)
  PRATE(:,197) = TPK%KTR25(:)
  PRATE(:,198) = TPK%KTR26(:)
  PRATE(:,199) = TPK%KTR27(:)
  PRATE(:,200) = TPK%KTR28(:)
  PRATE(:,201) = TPK%KTR29(:)
  PRATE(:,202) = TPK%KTR30(:)
  PRATE(:,203) = TPK%KTR31(:)
  PRATE(:,204) = TPK%KTR32(:)
  PRATE(:,205) = TPK%KTR33(:)
  PRATE(:,206) = TPK%KTR34(:)
  PRATE(:,207) = TPK%KTR35(:)
  PRATE(:,208) = TPK%KTR36(:)
  PRATE(:,209) = TPK%KTR37(:)
  PRATE(:,210) = TPK%KTR38(:)
  PRATE(:,211) = TPK%KTR39(:)
  PRATE(:,212) = TPK%KTR40(:)
  PRATE(:,213) = TPK%KC1(:)
  PRATE(:,214) = TPK%KC2(:)
  PRATE(:,215) = TPK%KC3(:)
  PRATE(:,216) = TPK%KC4(:)
  PRATE(:,217) = TPK%KC5(:)
  PRATE(:,218) = TPK%KC6(:)
  PRATE(:,219) = TPK%KC7(:)
  PRATE(:,220) = TPK%KC8(:)
  PRATE(:,221) = TPK%KC9(:)
  PRATE(:,222) = TPK%KC10(:)
  PRATE(:,223) = TPK%KC11(:)
  PRATE(:,224) = TPK%KC12(:)
  PRATE(:,225) = TPK%KC13(:)
  PRATE(:,226) = TPK%KC14(:)
  PRATE(:,227) = TPK%KC15(:)
  PRATE(:,228) = TPK%KC16(:)
  PRATE(:,229) = TPK%KC17(:)
  PRATE(:,230) = TPK%KC18(:)
  PRATE(:,231) = TPK%KC19(:)
  PRATE(:,232) = TPK%KC20(:)
  PRATE(:,233) = TPK%KC21(:)
  PRATE(:,234) = TPK%KC22(:)
  PRATE(:,235) = TPK%KC23(:)
  PRATE(:,236) = TPK%KC24(:)
  PRATE(:,237) = TPK%KC25(:)
  PRATE(:,238) = TPK%KC26(:)
  PRATE(:,239) = TPK%KC27(:)
  PRATE(:,240) = TPK%KC28(:)
  PRATE(:,241) = TPK%KC29(:)
  PRATE(:,242) = TPK%KC30(:)
  PRATE(:,243) = TPK%KR1(:)
  PRATE(:,244) = TPK%KR2(:)
  PRATE(:,245) = TPK%KR3(:)
  PRATE(:,246) = TPK%KR4(:)
  PRATE(:,247) = TPK%KR5(:)
  PRATE(:,248) = TPK%KR6(:)
  PRATE(:,249) = TPK%KR7(:)
  PRATE(:,250) = TPK%KR8(:)
  PRATE(:,251) = TPK%KR9(:)
  PRATE(:,252) = TPK%KR10(:)
  PRATE(:,253) = TPK%KR11(:)
  PRATE(:,254) = TPK%KR12(:)
  PRATE(:,255) = TPK%KR13(:)
  PRATE(:,256) = TPK%KR14(:)
  PRATE(:,257) = TPK%KR15(:)
  PRATE(:,258) = TPK%KR16(:)
  PRATE(:,259) = TPK%KR17(:)
  PRATE(:,260) = TPK%KR18(:)
  PRATE(:,261) = TPK%KR19(:)
  PRATE(:,262) = TPK%KR20(:)
  PRATE(:,263) = TPK%KR21(:)
  PRATE(:,264) = TPK%KR22(:)
  PRATE(:,265) = TPK%KR23(:)
  PRATE(:,266) = TPK%KR24(:)
  PRATE(:,267) = TPK%KR25(:)
  PRATE(:,268) = TPK%KR26(:)
  PRATE(:,269) = TPK%KR27(:)
  PRATE(:,270) = TPK%KR28(:)
  PRATE(:,271) = TPK%KR29(:)
  PRATE(:,272) = TPK%KR30(:)
END IF
RETURN
END SUBROUTINE CH_GET_RATES
!
!
!========================================================================
!
!!    ####################
      MODULE MODI_CH_TERMS
!!    ####################
INTERFACE
SUBROUTINE CH_TERMS(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
END SUBROUTINE CH_TERMS
END INTERFACE
END MODULE MODI_CH_TERMS
!
!========================================================================
!
!!    #############################################################
      SUBROUTINE CH_TERMS(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
!!    #############################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_TERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS. 
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
USE MODI_CH_TERMS_AQ
USE MODI_CH_TERMS_GAZ
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
!!
TYPE(CCSTYPE), POINTER                            :: TPK
TPK=>TACCS(KMI)
IF (TPK%LUSECHAQ) THEN
   CALL CH_TERMS_AQ(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
ELSE
   CALL CH_TERMS_GAZ(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
END IF
END SUBROUTINE CH_TERMS
!
!========================================================================
!
!!    ####################
      MODULE MODI_CH_TERMS_AQ
!!    ####################
INTERFACE
SUBROUTINE CH_TERMS_AQ(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
END SUBROUTINE CH_TERMS_AQ
END INTERFACE
END MODULE MODI_CH_TERMS_AQ
!
!========================================================================
!
!!
!!    ######################
      SUBROUTINE CH_TERMS_AQ(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
!!    ######################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_TERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS. 
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
!!
TYPE(CCSTYPE), POINTER                            :: TPK
TPK=>TACCS(KMI)
! /BEGIN_CODE/
TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
   &TPK%K022(:)*TPK%H2O(:))
TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
    &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
    &0.00000*TPK%K079(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
    &0.09000*TPK%K080(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
   &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
   &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K054(:)*PCONC(:,JP_BIO)+&
   &TPK%K055(:)*PCONC(:,JP_CARBO))
! /END_CODE/
PTERMS(:,:,:) = 0.0
CALL SUBT0
CALL SUBT1
CALL SUBT2
CALL SUBT3
CALL SUBT4
CALL SUBT5
CALL SUBT6
CALL SUBT7
CALL SUBT8
CALL SUBT9
CALL SUBT10
CALL SUBT11
CALL SUBT12
CALL SUBT13
CALL SUBT14
CALL SUBT15
CALL SUBT16
CALL SUBT17
CALL SUBT18
CALL SUBT19
CALL SUBT20
CALL SUBT21
CALL SUBT22
CALL SUBT23
CALL SUBT24
CALL SUBT25
CALL SUBT26
CALL SUBT27
CALL SUBT28
CALL SUBT29
CALL SUBT30
CALL SUBT31
CALL SUBT32
CALL SUBT33
CALL SUBT34
CALL SUBT35
CALL SUBT36
CALL SUBT37
CALL SUBT38
CALL SUBT39
CALL SUBT40
CALL SUBT41
CALL SUBT42
CALL SUBT43
CALL SUBT44
CALL SUBT45
CALL SUBT46
CALL SUBT47
!

CONTAINS

SUBROUTINE SUBT0
!
!Indices 1 a 20
!
!PTERMS(NO,K001) = +K001*<NO2>
 PTERMS(:,3,1) = +TPK%K001(:)*PCONC(:,4)
!
!PTERMS(NO2,K001) = -K001*<NO2>
 PTERMS(:,4,1) = -TPK%K001(:)*PCONC(:,4)
!
!PTERMS(O3,K002) = -K002*<O3>
 PTERMS(:,1,2) = -TPK%K002(:)*PCONC(:,1)
!
!PTERMS(O3,K003) = -K003*<O3>
 PTERMS(:,1,3) = -TPK%K003(:)*PCONC(:,1)
!
!PTERMS(NO,K004) = +K004*<HONO>
 PTERMS(:,3,4) = +TPK%K004(:)*PCONC(:,7)
!
!PTERMS(HONO,K004) = -K004*<HONO>
 PTERMS(:,7,4) = -TPK%K004(:)*PCONC(:,7)
!
!PTERMS(OH,K004) = +K004*<HONO>
 PTERMS(:,14,4) = +TPK%K004(:)*PCONC(:,7)
!
!PTERMS(NO2,K005) = +K005*<HNO3>
 PTERMS(:,4,5) = +TPK%K005(:)*PCONC(:,8)
!
!PTERMS(HNO3,K005) = -K005*<HNO3>
 PTERMS(:,8,5) = -TPK%K005(:)*PCONC(:,8)
!
!PTERMS(OH,K005) = +K005*<HNO3>
 PTERMS(:,14,5) = +TPK%K005(:)*PCONC(:,8)
!
!PTERMS(NO2,K006) = +0.65*K006*<HNO4>
 PTERMS(:,4,6) = +0.65*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(NO3,K006) = +0.35*K006*<HNO4>
 PTERMS(:,5,6) = +0.35*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(HNO4,K006) = -K006*<HNO4>
 PTERMS(:,9,6) = -TPK%K006(:)*PCONC(:,9)
!
!PTERMS(OH,K006) = +0.35*K006*<HNO4>
 PTERMS(:,14,6) = +0.35*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(HO2,K006) = +0.65*K006*<HNO4>
 PTERMS(:,15,6) = +0.65*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(NO,K007) = +K007*<NO3>
 PTERMS(:,3,7) = +TPK%K007(:)*PCONC(:,5)
!
!PTERMS(NO3,K007) = -K007*<NO3>
 PTERMS(:,5,7) = -TPK%K007(:)*PCONC(:,5)
!
!PTERMS(NO2,K008) = +K008*<NO3>
 PTERMS(:,4,8) = +TPK%K008(:)*PCONC(:,5)
!
!PTERMS(NO3,K008) = -K008*<NO3>
 PTERMS(:,5,8) = -TPK%K008(:)*PCONC(:,5)
!
!PTERMS(H2O2,K009) = -K009*<H2O2>
 PTERMS(:,2,9) = -TPK%K009(:)*PCONC(:,2)
!
!
RETURN
END SUBROUTINE SUBT0
!
SUBROUTINE SUBT1
!
!Indices 21 a 40
!
!PTERMS(OH,K009) = +K009*<H2O2>
 PTERMS(:,14,9) = +TPK%K009(:)*PCONC(:,2)
!
!PTERMS(CO,K010) = +K010*<HCHO>
 PTERMS(:,13,10) = +TPK%K010(:)*PCONC(:,22)
!
!PTERMS(HCHO,K010) = -K010*<HCHO>
 PTERMS(:,22,10) = -TPK%K010(:)*PCONC(:,22)
!
!PTERMS(CO,K011) = +K011*<HCHO>
 PTERMS(:,13,11) = +TPK%K011(:)*PCONC(:,22)
!
!PTERMS(HO2,K011) = +K011*<HCHO>
 PTERMS(:,15,11) = +TPK%K011(:)*PCONC(:,22)
!
!PTERMS(HCHO,K011) = -K011*<HCHO>
 PTERMS(:,22,11) = -TPK%K011(:)*PCONC(:,22)
!
!PTERMS(CO,K012) = +K012*<ALD>
 PTERMS(:,13,12) = +TPK%K012(:)*PCONC(:,23)
!
!PTERMS(HO2,K012) = +K012*<ALD>
 PTERMS(:,15,12) = +TPK%K012(:)*PCONC(:,23)
!
!PTERMS(ALD,K012) = -K012*<ALD>
 PTERMS(:,23,12) = -TPK%K012(:)*PCONC(:,23)
!
!PTERMS(MO2,K012) = +K012*<ALD>
 PTERMS(:,32,12) = +TPK%K012(:)*PCONC(:,23)
!
!PTERMS(OH,K013) = +K013*<OP1>
 PTERMS(:,14,13) = +TPK%K013(:)*PCONC(:,28)
!
!PTERMS(HO2,K013) = +K013*<OP1>
 PTERMS(:,15,13) = +TPK%K013(:)*PCONC(:,28)
!
!PTERMS(HCHO,K013) = +K013*<OP1>
 PTERMS(:,22,13) = +TPK%K013(:)*PCONC(:,28)
!
!PTERMS(OP1,K013) = -K013*<OP1>
 PTERMS(:,28,13) = -TPK%K013(:)*PCONC(:,28)
!
!PTERMS(OH,K014) = +K014*<OP2>
 PTERMS(:,14,14) = +TPK%K014(:)*PCONC(:,29)
!
!PTERMS(HO2,K014) = +0.96205*K014*<OP2>
 PTERMS(:,15,14) = +0.96205*TPK%K014(:)*PCONC(:,29)
!
!PTERMS(ALD,K014) = +0.96205*K014*<OP2>
 PTERMS(:,23,14) = +0.96205*TPK%K014(:)*PCONC(:,29)
!
!PTERMS(OP2,K014) = -K014*<OP2>
 PTERMS(:,29,14) = -TPK%K014(:)*PCONC(:,29)
!
!PTERMS(MO2,K014) = +0.03795*K014*<OP2>
 PTERMS(:,32,14) = +0.03795*TPK%K014(:)*PCONC(:,29)
!
!PTERMS(KET,K015) = -K015*<KET>
 PTERMS(:,24,15) = -TPK%K015(:)*PCONC(:,24)
!
!
RETURN
END SUBROUTINE SUBT1
!
SUBROUTINE SUBT2
!
!Indices 41 a 60
!
!PTERMS(ALKAP,K015) = +1.00000*K015*<KET>
 PTERMS(:,33,15) = +1.00000*TPK%K015(:)*PCONC(:,24)
!
!PTERMS(CARBOP,K015) = +1.00000*K015*<KET>
 PTERMS(:,39,15) = +1.00000*TPK%K015(:)*PCONC(:,24)
!
!PTERMS(CO,K016) = +0.91924*K016*<CARBO>
 PTERMS(:,13,16) = +0.91924*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(HO2,K016) = +0.75830*K016*<CARBO>
 PTERMS(:,15,16) = +0.75830*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(HCHO,K016) = +0.06517*K016*<CARBO>
 PTERMS(:,22,16) = +0.06517*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(CARBO,K016) = -K016*<CARBO>
 PTERMS(:,25,16) = -TPK%K016(:)*PCONC(:,25)
!
!PTERMS(CARBOP,K016) = +0.69622*K016*<CARBO>
 PTERMS(:,39,16) = +0.69622*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(NO2,K017) = +K017*<ONIT>
 PTERMS(:,4,17) = +TPK%K017(:)*PCONC(:,26)
!
!PTERMS(HO2,K017) = +K017*<ONIT>
 PTERMS(:,15,17) = +TPK%K017(:)*PCONC(:,26)
!
!PTERMS(ALD,K017) = +0.20*K017*<ONIT>
 PTERMS(:,23,17) = +0.20*TPK%K017(:)*PCONC(:,26)
!
!PTERMS(KET,K017) = +0.80*K017*<ONIT>
 PTERMS(:,24,17) = +0.80*TPK%K017(:)*PCONC(:,26)
!
!PTERMS(ONIT,K017) = -K017*<ONIT>
 PTERMS(:,26,17) = -TPK%K017(:)*PCONC(:,26)
!
!PTERMS(O3,K018) = +K018*<O3P>*<O2>
 PTERMS(:,1,18) = +TPK%K018(:)*TPK%O3P(:)*TPK%O2(:)
!
!PTERMS(O3,K019) = -K019*<O3P>*<O3>
 PTERMS(:,1,19) = -TPK%K019(:)*TPK%O3P(:)*PCONC(:,1)
!
!PTERMS(OH,K022) = +K022*<O1D>*<H2O>
 PTERMS(:,14,22) = +TPK%K022(:)*TPK%O1D(:)*TPK%H2O(:)
!
!PTERMS(O3,K023) = -K023*<O3>*<OH>
 PTERMS(:,1,23) = -TPK%K023(:)*PCONC(:,1)*PCONC(:,14)
!
!PTERMS(OH,K023) = -K023*<O3>*<OH>
 PTERMS(:,14,23) = -TPK%K023(:)*PCONC(:,1)*PCONC(:,14)
!
!PTERMS(HO2,K023) = +K023*<O3>*<OH>
 PTERMS(:,15,23) = +TPK%K023(:)*PCONC(:,1)*PCONC(:,14)
!
!PTERMS(O3,K024) = -K024*<O3>*<HO2>
 PTERMS(:,1,24) = -TPK%K024(:)*PCONC(:,1)*PCONC(:,15)
!
!PTERMS(OH,K024) = +K024*<O3>*<HO2>
 PTERMS(:,14,24) = +TPK%K024(:)*PCONC(:,1)*PCONC(:,15)
!
!
RETURN
END SUBROUTINE SUBT2
!
SUBROUTINE SUBT3
!
!Indices 61 a 80
!
!PTERMS(HO2,K024) = -K024*<O3>*<HO2>
 PTERMS(:,15,24) = -TPK%K024(:)*PCONC(:,1)*PCONC(:,15)
!
!PTERMS(OH,K025) = -K025*<OH>*<HO2>
 PTERMS(:,14,25) = -TPK%K025(:)*PCONC(:,14)*PCONC(:,15)
!
!PTERMS(HO2,K025) = -K025*<OH>*<HO2>
 PTERMS(:,15,25) = -TPK%K025(:)*PCONC(:,14)*PCONC(:,15)
!
!PTERMS(H2O2,K026) = -K026*<H2O2>*<OH>
 PTERMS(:,2,26) = -TPK%K026(:)*PCONC(:,2)*PCONC(:,14)
!
!PTERMS(OH,K026) = -K026*<H2O2>*<OH>
 PTERMS(:,14,26) = -TPK%K026(:)*PCONC(:,2)*PCONC(:,14)
!
!PTERMS(HO2,K026) = +K026*<H2O2>*<OH>
 PTERMS(:,15,26) = +TPK%K026(:)*PCONC(:,2)*PCONC(:,14)
!
!PTERMS(H2O2,K027) = +K027*<HO2>*<HO2>
 PTERMS(:,2,27) = +TPK%K027(:)*PCONC(:,15)*PCONC(:,15)
!
!PTERMS(HO2,K027) = -K027*<HO2>*<HO2>
 PTERMS(:,15,27) = -TPK%K027(:)*PCONC(:,15)*PCONC(:,15)
!
!PTERMS(H2O2,K028) = +K028*<HO2>*<HO2>*<H2O>
 PTERMS(:,2,28) = +TPK%K028(:)*PCONC(:,15)*PCONC(:,15)*TPK%H2O(:)
!
!PTERMS(HO2,K028) = -K028*<HO2>*<HO2>*<H2O>
 PTERMS(:,15,28) = -TPK%K028(:)*PCONC(:,15)*PCONC(:,15)*TPK%H2O(:)
!
!PTERMS(NO,K029) = -K029*<O3P>*<NO>
 PTERMS(:,3,29) = -TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)
!
!PTERMS(NO2,K029) = +K029*<O3P>*<NO>
 PTERMS(:,4,29) = +TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)
!
!PTERMS(NO,K030) = +K030*<O3P>*<NO2>
 PTERMS(:,3,30) = +TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO2,K030) = -K030*<O3P>*<NO2>
 PTERMS(:,4,30) = -TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO2,K031) = -K031*<O3P>*<NO2>
 PTERMS(:,4,31) = -TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO3,K031) = +K031*<O3P>*<NO2>
 PTERMS(:,5,31) = +TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO,K032) = -K032*<OH>*<NO>
 PTERMS(:,3,32) = -TPK%K032(:)*PCONC(:,14)*PCONC(:,3)
!
!PTERMS(HONO,K032) = +K032*<OH>*<NO>
 PTERMS(:,7,32) = +TPK%K032(:)*PCONC(:,14)*PCONC(:,3)
!
!PTERMS(OH,K032) = -K032*<OH>*<NO>
 PTERMS(:,14,32) = -TPK%K032(:)*PCONC(:,14)*PCONC(:,3)
!
!PTERMS(NO2,K033) = -K033*<OH>*<NO2>
 PTERMS(:,4,33) = -TPK%K033(:)*PCONC(:,14)*PCONC(:,4)
!
!
RETURN
END SUBROUTINE SUBT3
!
SUBROUTINE SUBT4
!
!Indices 81 a 100
!
!PTERMS(HNO3,K033) = +K033*<OH>*<NO2>
 PTERMS(:,8,33) = +TPK%K033(:)*PCONC(:,14)*PCONC(:,4)
!
!PTERMS(OH,K033) = -K033*<OH>*<NO2>
 PTERMS(:,14,33) = -TPK%K033(:)*PCONC(:,14)*PCONC(:,4)
!
!PTERMS(NO2,K034) = +K034*<OH>*<NO3>
 PTERMS(:,4,34) = +TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(NO3,K034) = -K034*<OH>*<NO3>
 PTERMS(:,5,34) = -TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(OH,K034) = -K034*<OH>*<NO3>
 PTERMS(:,14,34) = -TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(HO2,K034) = +K034*<OH>*<NO3>
 PTERMS(:,15,34) = +TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(NO,K035) = -K035*<HO2>*<NO>
 PTERMS(:,3,35) = -TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(NO2,K035) = +K035*<HO2>*<NO>
 PTERMS(:,4,35) = +TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(OH,K035) = +K035*<HO2>*<NO>
 PTERMS(:,14,35) = +TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(HO2,K035) = -K035*<HO2>*<NO>
 PTERMS(:,15,35) = -TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(NO2,K036) = -K036*<HO2>*<NO2>
 PTERMS(:,4,36) = -TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!
!PTERMS(HNO4,K036) = +K036*<HO2>*<NO2>
 PTERMS(:,9,36) = +TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!
!PTERMS(HO2,K036) = -K036*<HO2>*<NO2>
 PTERMS(:,15,36) = -TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!
!PTERMS(NO2,K037) = +K037*<HNO4>
 PTERMS(:,4,37) = +TPK%K037(:)*PCONC(:,9)
!
!PTERMS(HNO4,K037) = -K037*<HNO4>
 PTERMS(:,9,37) = -TPK%K037(:)*PCONC(:,9)
!
!PTERMS(HO2,K037) = +K037*<HNO4>
 PTERMS(:,15,37) = +TPK%K037(:)*PCONC(:,9)
!
!PTERMS(NO2,K038) = +0.7*K038*<HO2>*<NO3>
 PTERMS(:,4,38) = +0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(NO3,K038) = -K038*<HO2>*<NO3>
 PTERMS(:,5,38) = -TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(HNO3,K038) = +0.3*K038*<HO2>*<NO3>
 PTERMS(:,8,38) = +0.3*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(OH,K038) = +0.7*K038*<HO2>*<NO3>
 PTERMS(:,14,38) = +0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT4
!
SUBROUTINE SUBT5
!
!Indices 101 a 120
!
!PTERMS(HO2,K038) = -K038*<HO2>*<NO3>
 PTERMS(:,15,38) = -TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(NO2,K039) = +K039*<OH>*<HONO>
 PTERMS(:,4,39) = +TPK%K039(:)*PCONC(:,14)*PCONC(:,7)
!
!PTERMS(HONO,K039) = -K039*<OH>*<HONO>
 PTERMS(:,7,39) = -TPK%K039(:)*PCONC(:,14)*PCONC(:,7)
!
!PTERMS(OH,K039) = -K039*<OH>*<HONO>
 PTERMS(:,14,39) = -TPK%K039(:)*PCONC(:,14)*PCONC(:,7)
!
!PTERMS(NO3,K040) = +K040*<OH>*<HNO3>
 PTERMS(:,5,40) = +TPK%K040(:)*PCONC(:,14)*PCONC(:,8)
!
!PTERMS(HNO3,K040) = -K040*<OH>*<HNO3>
 PTERMS(:,8,40) = -TPK%K040(:)*PCONC(:,14)*PCONC(:,8)
!
!PTERMS(OH,K040) = -K040*<OH>*<HNO3>
 PTERMS(:,14,40) = -TPK%K040(:)*PCONC(:,14)*PCONC(:,8)
!
!PTERMS(NO2,K041) = +K041*<OH>*<HNO4>
 PTERMS(:,4,41) = +TPK%K041(:)*PCONC(:,14)*PCONC(:,9)
!
!PTERMS(HNO4,K041) = -K041*<OH>*<HNO4>
 PTERMS(:,9,41) = -TPK%K041(:)*PCONC(:,14)*PCONC(:,9)
!
!PTERMS(OH,K041) = -K041*<OH>*<HNO4>
 PTERMS(:,14,41) = -TPK%K041(:)*PCONC(:,14)*PCONC(:,9)
!
!PTERMS(O3,K042) = -K042*<O3>*<NO>
 PTERMS(:,1,42) = -TPK%K042(:)*PCONC(:,1)*PCONC(:,3)
!
!PTERMS(NO,K042) = -K042*<O3>*<NO>
 PTERMS(:,3,42) = -TPK%K042(:)*PCONC(:,1)*PCONC(:,3)
!
!PTERMS(NO2,K042) = +K042*<O3>*<NO>
 PTERMS(:,4,42) = +TPK%K042(:)*PCONC(:,1)*PCONC(:,3)
!
!PTERMS(O3,K043) = -K043*<O3>*<NO2>
 PTERMS(:,1,43) = -TPK%K043(:)*PCONC(:,1)*PCONC(:,4)
!
!PTERMS(NO2,K043) = -K043*<O3>*<NO2>
 PTERMS(:,4,43) = -TPK%K043(:)*PCONC(:,1)*PCONC(:,4)
!
!PTERMS(NO3,K043) = +K043*<O3>*<NO2>
 PTERMS(:,5,43) = +TPK%K043(:)*PCONC(:,1)*PCONC(:,4)
!
!PTERMS(NO,K044) = -K044*<NO>*<NO>*<O2>
 PTERMS(:,3,44) = -TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)
!
!PTERMS(NO2,K044) = +K044*<NO>*<NO>*<O2>
 PTERMS(:,4,44) = +TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)
!
!PTERMS(NO,K045) = -K045*<NO3>*<NO>
 PTERMS(:,3,45) = -TPK%K045(:)*PCONC(:,5)*PCONC(:,3)
!
!PTERMS(NO2,K045) = +K045*<NO3>*<NO>
 PTERMS(:,4,45) = +TPK%K045(:)*PCONC(:,5)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT5
!
SUBROUTINE SUBT6
!
!Indices 121 a 140
!
!PTERMS(NO3,K045) = -K045*<NO3>*<NO>
 PTERMS(:,5,45) = -TPK%K045(:)*PCONC(:,5)*PCONC(:,3)
!
!PTERMS(NO,K046) = +K046*<NO3>*<NO2>
 PTERMS(:,3,46) = +TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO2,K046) = -K046*<NO3>*<NO2>
 PTERMS(:,4,46) = -TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO3,K046) = -K046*<NO3>*<NO2>
 PTERMS(:,5,46) = -TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO2,K047) = -K047*<NO3>*<NO2>
 PTERMS(:,4,47) = -TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO3,K047) = -K047*<NO3>*<NO2>
 PTERMS(:,5,47) = -TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(N2O5,K047) = +K047*<NO3>*<NO2>
 PTERMS(:,6,47) = +TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO2,K048) = +K048*<N2O5>
 PTERMS(:,4,48) = +TPK%K048(:)*PCONC(:,6)
!
!PTERMS(NO3,K048) = +K048*<N2O5>
 PTERMS(:,5,48) = +TPK%K048(:)*PCONC(:,6)
!
!PTERMS(N2O5,K048) = -K048*<N2O5>
 PTERMS(:,6,48) = -TPK%K048(:)*PCONC(:,6)
!
!PTERMS(NO2,K049) = +K049*<NO3>*<NO3>
 PTERMS(:,4,49) = +TPK%K049(:)*PCONC(:,5)*PCONC(:,5)
!
!PTERMS(NO3,K049) = -K049*<NO3>*<NO3>
 PTERMS(:,5,49) = -TPK%K049(:)*PCONC(:,5)*PCONC(:,5)
!
!PTERMS(NH3,K050) = -K050*<NH3>*<OH>
 PTERMS(:,10,50) = -TPK%K050(:)*PCONC(:,10)*PCONC(:,14)
!
!PTERMS(OH,K050) = -K050*<NH3>*<OH>
 PTERMS(:,14,50) = -TPK%K050(:)*PCONC(:,10)*PCONC(:,14)
!
!PTERMS(OH,K051) = -K051*<OH>*<H2>
 PTERMS(:,14,51) = -TPK%K051(:)*PCONC(:,14)*TPK%H2(:)
!
!PTERMS(HO2,K051) = +K051*<OH>*<H2>
 PTERMS(:,15,51) = +TPK%K051(:)*PCONC(:,14)*TPK%H2(:)
!
!PTERMS(SO2,K052) = -K052*<OH>*<SO2>
 PTERMS(:,11,52) = -TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!PTERMS(SULF,K052) = +K052*<OH>*<SO2>
 PTERMS(:,12,52) = +TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!PTERMS(OH,K052) = -K052*<OH>*<SO2>
 PTERMS(:,14,52) = -TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!PTERMS(HO2,K052) = +K052*<OH>*<SO2>
 PTERMS(:,15,52) = +TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!
RETURN
END SUBROUTINE SUBT6
!
SUBROUTINE SUBT7
!
!Indices 141 a 160
!
!PTERMS(CO,K053) = -K053*<CO>*<OH>
 PTERMS(:,13,53) = -TPK%K053(:)*PCONC(:,13)*PCONC(:,14)
!
!PTERMS(OH,K053) = -K053*<CO>*<OH>
 PTERMS(:,14,53) = -TPK%K053(:)*PCONC(:,13)*PCONC(:,14)
!
!PTERMS(HO2,K053) = +K053*<CO>*<OH>
 PTERMS(:,15,53) = +TPK%K053(:)*PCONC(:,13)*PCONC(:,14)
!
!PTERMS(CO,K054) = +0.01*K054*<BIO>*<O3P>
 PTERMS(:,13,54) = +0.01*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(OH,K054) = +0.02*K054*<BIO>*<O3P>
 PTERMS(:,14,54) = +0.02*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(HO2,K054) = +0.28*K054*<BIO>*<O3P>
 PTERMS(:,15,54) = +0.28*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(ALKE,K054) = +0.91868*K054*<BIO>*<O3P>
 PTERMS(:,19,54) = +0.91868*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(BIO,K054) = -K054*<BIO>*<O3P>
 PTERMS(:,20,54) = -TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(HCHO,K054) = +0.05*K054*<BIO>*<O3P>
 PTERMS(:,22,54) = +0.05*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(CARBO,K054) = +0.13255*K054*<BIO>*<O3P>
 PTERMS(:,25,54) = +0.13255*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(XO2,K054) = +0.15*K054*<BIO>*<O3P>
 PTERMS(:,41,54) = +0.15*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(ALD,K055) = +K055*<CARBO>*<O3P>
 PTERMS(:,23,55) = +TPK%K055(:)*PCONC(:,25)*TPK%O3P(:)
!
!PTERMS(CARBO,K055) = -K055*<CARBO>*<O3P>
 PTERMS(:,25,55) = -TPK%K055(:)*PCONC(:,25)*TPK%O3P(:)
!
!PTERMS(OH,K056) = -K056*<CH4>*<OH>
 PTERMS(:,14,56) = -TPK%K056(:)*PCONC(:,16)*PCONC(:,14)
!
!PTERMS(CH4,K056) = -K056*<CH4>*<OH>
 PTERMS(:,16,56) = -TPK%K056(:)*PCONC(:,16)*PCONC(:,14)
!
!PTERMS(MO2,K056) = +K056*<CH4>*<OH>
 PTERMS(:,32,56) = +TPK%K056(:)*PCONC(:,16)*PCONC(:,14)
!
!PTERMS(OH,K057) = -K057*<ETH>*<OH>
 PTERMS(:,14,57) = -TPK%K057(:)*PCONC(:,17)*PCONC(:,14)
!
!PTERMS(ETH,K057) = -K057*<ETH>*<OH>
 PTERMS(:,17,57) = -TPK%K057(:)*PCONC(:,17)*PCONC(:,14)
!
!PTERMS(ALKAP,K057) = +K057*<ETH>*<OH>
 PTERMS(:,33,57) = +TPK%K057(:)*PCONC(:,17)*PCONC(:,14)
!
!PTERMS(CO,K058) = +0.00878*K058*<ALKA>*<OH>
 PTERMS(:,13,58) = +0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT7
!
SUBROUTINE SUBT8
!
!Indices 161 a 180
!
!PTERMS(OH,K058) = -K058*<ALKA>*<OH>
 PTERMS(:,14,58) = -TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(HO2,K058) = +0.12793*K058*<ALKA>*<OH>
 PTERMS(:,15,58) = +0.12793*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ALKA,K058) = -K058*<ALKA>*<OH>
 PTERMS(:,18,58) = -TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(HCHO,K058) = +0.00140*K058*<ALKA>*<OH>
 PTERMS(:,22,58) = +0.00140*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ALD,K058) = +0.08173*K058*<ALKA>*<OH>
 PTERMS(:,23,58) = +0.08173*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(KET,K058) = +0.03498*K058*<ALKA>*<OH>
 PTERMS(:,24,58) = +0.03498*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(CARBO,K058) = +0.00835*K058*<ALKA>*<OH>
 PTERMS(:,25,58) = +0.00835*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ORA1,K058) = +0.00878*K058*<ALKA>*<OH>
 PTERMS(:,30,58) = +0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ALKAP,K058) = +0.87811*K058*<ALKA>*<OH>
 PTERMS(:,33,58) = +0.87811*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(OH,K059) = -K059*<ALKE>*<OH>
 PTERMS(:,14,59) = -TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(ALKE,K059) = -K059*<ALKE>*<OH>
 PTERMS(:,19,59) = -TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(ALKEP,K059) = +1.02529*K059*<ALKE>*<OH>
 PTERMS(:,34,59) = +1.02529*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(BIOP,K059) = +0.00000*K059*<ALKE>*<OH>
 PTERMS(:,35,59) = +0.00000*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(OH,K060) = -K060*<BIO>*<OH>
 PTERMS(:,14,60) = -TPK%K060(:)*PCONC(:,20)*PCONC(:,14)
!
!PTERMS(BIO,K060) = -K060*<BIO>*<OH>
 PTERMS(:,20,60) = -TPK%K060(:)*PCONC(:,20)*PCONC(:,14)
!
!PTERMS(BIOP,K060) = +1.00000*K060*<BIO>*<OH>
 PTERMS(:,35,60) = +1.00000*TPK%K060(:)*PCONC(:,20)*PCONC(:,14)
!
!PTERMS(OH,K061) = -K061*<ARO>*<OH>
 PTERMS(:,14,61) = -TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(HO2,K061) = +0.10318*K061*<ARO>*<OH>
 PTERMS(:,15,61) = +0.10318*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(ARO,K061) = -K061*<ARO>*<OH>
 PTERMS(:,21,61) = -TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(PHO,K061) = +0.00276*K061*<ARO>*<OH>
 PTERMS(:,36,61) = +0.00276*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT8
!
SUBROUTINE SUBT9
!
!Indices 181 a 200
!
!PTERMS(ADD,K061) = +0.93968*K061*<ARO>*<OH>
 PTERMS(:,37,61) = +0.93968*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(XO2,K061) = +0.10318*K061*<ARO>*<OH>
 PTERMS(:,41,61) = +0.10318*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(CO,K062) = +K062*<HCHO>*<OH>
 PTERMS(:,13,62) = +TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(OH,K062) = -K062*<HCHO>*<OH>
 PTERMS(:,14,62) = -TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(HO2,K062) = +K062*<HCHO>*<OH>
 PTERMS(:,15,62) = +TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(HCHO,K062) = -K062*<HCHO>*<OH>
 PTERMS(:,22,62) = -TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(OH,K063) = -K063*<ALD>*<OH>
 PTERMS(:,14,63) = -TPK%K063(:)*PCONC(:,23)*PCONC(:,14)
!
!PTERMS(ALD,K063) = -K063*<ALD>*<OH>
 PTERMS(:,23,63) = -TPK%K063(:)*PCONC(:,23)*PCONC(:,14)
!
!PTERMS(CARBOP,K063) = +1.00000*K063*<ALD>*<OH>
 PTERMS(:,39,63) = +1.00000*TPK%K063(:)*PCONC(:,23)*PCONC(:,14)
!
!PTERMS(OH,K064) = -K064*<KET>*<OH>
 PTERMS(:,14,64) = -TPK%K064(:)*PCONC(:,24)*PCONC(:,14)
!
!PTERMS(KET,K064) = -K064*<KET>*<OH>
 PTERMS(:,24,64) = -TPK%K064(:)*PCONC(:,24)*PCONC(:,14)
!
!PTERMS(CARBOP,K064) = +1.00000*K064*<KET>*<OH>
 PTERMS(:,39,64) = +1.00000*TPK%K064(:)*PCONC(:,24)*PCONC(:,14)
!
!PTERMS(CO,K065) = +1.01732*K065*<CARBO>*<OH>
 PTERMS(:,13,65) = +1.01732*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(OH,K065) = -K065*<CARBO>*<OH>
 PTERMS(:,14,65) = -TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(HO2,K065) = +0.51208*K065*<CARBO>*<OH>
 PTERMS(:,15,65) = +0.51208*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(HCHO,K065) = +0.00000*K065*<CARBO>*<OH>
 PTERMS(:,22,65) = +0.00000*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(ALD,K065) = +0.06253*K065*<CARBO>*<OH>
 PTERMS(:,23,65) = +0.06253*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(KET,K065) = +0.00853*K065*<CARBO>*<OH>
 PTERMS(:,24,65) = +0.00853*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(CARBO,K065) = -K065*<CARBO>*<OH>
 PTERMS(:,25,65) = -TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(CARBOP,K065) = +0.51419*K065*<CARBO>*<OH>
 PTERMS(:,39,65) = +0.51419*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT9
!
SUBROUTINE SUBT10
!
!Indices 201 a 220
!
!PTERMS(XO2,K065) = +0.10162*K065*<CARBO>*<OH>
 PTERMS(:,41,65) = +0.10162*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(OH,K066) = -K066*<ORA1>*<OH>
 PTERMS(:,14,66) = -TPK%K066(:)*PCONC(:,30)*PCONC(:,14)
!
!PTERMS(HO2,K066) = +K066*<ORA1>*<OH>
 PTERMS(:,15,66) = +TPK%K066(:)*PCONC(:,30)*PCONC(:,14)
!
!PTERMS(ORA1,K066) = -K066*<ORA1>*<OH>
 PTERMS(:,30,66) = -TPK%K066(:)*PCONC(:,30)*PCONC(:,14)
!
!PTERMS(OH,K067) = -K067*<ORA2>*<OH>
 PTERMS(:,14,67) = -TPK%K067(:)*PCONC(:,31)*PCONC(:,14)
!
!PTERMS(ORA2,K067) = -K067*<ORA2>*<OH>
 PTERMS(:,31,67) = -TPK%K067(:)*PCONC(:,31)*PCONC(:,14)
!
!PTERMS(OH,K068) = -K068*<OP1>*<OH>
 PTERMS(:,14,68) = -TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(HCHO,K068) = +0.35*K068*<OP1>*<OH>
 PTERMS(:,22,68) = +0.35*TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(OP1,K068) = -K068*<OP1>*<OH>
 PTERMS(:,28,68) = -TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(MO2,K068) = +0.65*K068*<OP1>*<OH>
 PTERMS(:,32,68) = +0.65*TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(OH,K069) = -K069*<OP2>*<OH>
 PTERMS(:,14,69) = -TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(HO2,K069) = +0.02915*K069*<OP2>*<OH>
 PTERMS(:,15,69) = +0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(HCHO,K069) = +0.02915*K069*<OP2>*<OH>
 PTERMS(:,22,69) = +0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(ALD,K069) = +0.07335*K069*<OP2>*<OH>
 PTERMS(:,23,69) = +0.07335*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(KET,K069) = +0.37591*K069*<OP2>*<OH>
 PTERMS(:,24,69) = +0.37591*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(OP2,K069) = -K069*<OP2>*<OH>
 PTERMS(:,29,69) = -TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(ALKAP,K069) = +0.40341*K069*<OP2>*<OH>
 PTERMS(:,33,69) = +0.40341*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(CARBOP,K069) = +0.05413*K069*<OP2>*<OH>
 PTERMS(:,39,69) = +0.05413*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(XO2,K069) = +0.09333*K069*<OP2>*<OH>
 PTERMS(:,41,69) = +0.09333*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(NO3,K070) = +0.71893*K070*<PAN>*<OH>
 PTERMS(:,5,70) = +0.71893*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT10
!
SUBROUTINE SUBT11
!
!Indices 221 a 240
!
!PTERMS(OH,K070) = -K070*<PAN>*<OH>
 PTERMS(:,14,70) = -TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(HO2,K070) = +0.28107*K070*<PAN>*<OH>
 PTERMS(:,15,70) = +0.28107*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(HCHO,K070) = +0.57839*K070*<PAN>*<OH>
 PTERMS(:,22,70) = +0.57839*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(CARBO,K070) = +0.21863*K070*<PAN>*<OH>
 PTERMS(:,25,70) = +0.21863*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(PAN,K070) = -K070*<PAN>*<OH>
 PTERMS(:,27,70) = -TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(XO2,K070) = +K070*<PAN>*<OH>
 PTERMS(:,41,70) = +TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(NO2,K071) = +K071*<ONIT>*<OH>
 PTERMS(:,4,71) = +TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(OH,K071) = -K071*<ONIT>*<OH>
 PTERMS(:,14,71) = -TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(ONIT,K071) = -K071*<ONIT>*<OH>
 PTERMS(:,26,71) = -TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(ALKAP,K071) = +1.00000*K071*<ONIT>*<OH>
 PTERMS(:,33,71) = +1.00000*TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(NO3,K072) = -K072*<HCHO>*<NO3>
 PTERMS(:,5,72) = -TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(HNO3,K072) = +K072*<HCHO>*<NO3>
 PTERMS(:,8,72) = +TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(CO,K072) = +K072*<HCHO>*<NO3>
 PTERMS(:,13,72) = +TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(HO2,K072) = +K072*<HCHO>*<NO3>
 PTERMS(:,15,72) = +TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(HCHO,K072) = -K072*<HCHO>*<NO3>
 PTERMS(:,22,72) = -TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(NO3,K073) = -K073*<ALD>*<NO3>
 PTERMS(:,5,73) = -TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(HNO3,K073) = +K073*<ALD>*<NO3>
 PTERMS(:,8,73) = +TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(ALD,K073) = -K073*<ALD>*<NO3>
 PTERMS(:,23,73) = -TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(CARBOP,K073) = +1.00000*K073*<ALD>*<NO3>
 PTERMS(:,39,73) = +1.00000*TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(NO2,K074) = +0.10530*K074*<CARBO>*<NO3>
 PTERMS(:,4,74) = +0.10530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT11
!
SUBROUTINE SUBT12
!
!Indices 241 a 260
!
!PTERMS(NO3,K074) = -K074*<CARBO>*<NO3>
 PTERMS(:,5,74) = -TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(HNO3,K074) = +0.91567*K074*<CARBO>*<NO3>
 PTERMS(:,8,74) = +0.91567*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(CO,K074) = +1.33723*K074*<CARBO>*<NO3>
 PTERMS(:,13,74) = +1.33723*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(HO2,K074) = +0.63217*K074*<CARBO>*<NO3>
 PTERMS(:,15,74) = +0.63217*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(ALD,K074) = +0.05265*K074*<CARBO>*<NO3>
 PTERMS(:,23,74) = +0.05265*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(KET,K074) = +0.00632*K074*<CARBO>*<NO3>
 PTERMS(:,24,74) = +0.00632*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(CARBO,K074) = -K074*<CARBO>*<NO3>
 PTERMS(:,25,74) = -TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(CARBOP,K074) = +0.38881*K074*<CARBO>*<NO3>
 PTERMS(:,39,74) = +0.38881*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(OLN,K074) = +0.00000*K074*<CARBO>*<NO3>
 PTERMS(:,40,74) = +0.00000*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(XO2,K074) = +0.10530*K074*<CARBO>*<NO3>
 PTERMS(:,41,74) = +0.10530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(NO3,K075) = -K075*<ARO>*<NO3>
 PTERMS(:,5,75) = -TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(HNO3,K075) = +K075*<ARO>*<NO3>
 PTERMS(:,8,75) = +TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(ARO,K075) = -K075*<ARO>*<NO3>
 PTERMS(:,21,75) = -TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(PHO,K075) = +K075*<ARO>*<NO3>
 PTERMS(:,36,75) = +TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(NO3,K076) = -K076*<ALKE>*<NO3>
 PTERMS(:,5,76) = -TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(ALKE,K076) = -K076*<ALKE>*<NO3>
 PTERMS(:,19,76) = -TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(CARBO,K076) = +0.00000*K076*<ALKE>*<NO3>
 PTERMS(:,25,76) = +0.00000*TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(OLN,K076) = +0.93768*K076*<ALKE>*<NO3>
 PTERMS(:,40,76) = +0.93768*TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(NO3,K077) = -K077*<BIO>*<NO3>
 PTERMS(:,5,77) = -TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!PTERMS(BIO,K077) = -K077*<BIO>*<NO3>
 PTERMS(:,20,77) = -TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT12
!
SUBROUTINE SUBT13
!
!Indices 261 a 280
!
!PTERMS(CARBO,K077) = +0.91741*K077*<BIO>*<NO3>
 PTERMS(:,25,77) = +0.91741*TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!PTERMS(OLN,K077) = +1.00000*K077*<BIO>*<NO3>
 PTERMS(:,40,77) = +1.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!PTERMS(NO2,K078) = +0.40*K078*<PAN>*<NO3>
 PTERMS(:,4,78) = +0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(NO3,K078) = -K078*<PAN>*<NO3>
 PTERMS(:,5,78) = -TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(HCHO,K078) = +0.40*K078*<PAN>*<NO3>
 PTERMS(:,22,78) = +0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(ONIT,K078) = +0.60*K078*<PAN>*<NO3>
 PTERMS(:,26,78) = +0.60*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(PAN,K078) = -K078*<PAN>*<NO3>
 PTERMS(:,27,78) = -TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(XO2,K078) = +K078*<PAN>*<NO3>
 PTERMS(:,41,78) = +TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(O3,K079) = -K079*<ALKE>*<O3>
 PTERMS(:,1,79) = -TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(H2O2,K079) = +0.01833*K079*<ALKE>*<O3>
 PTERMS(:,2,79) = +0.01833*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CO,K079) = +0.35120*K079*<ALKE>*<O3>
 PTERMS(:,13,79) = +0.35120*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(OH,K079) = +0.39435*K079*<ALKE>*<O3>
 PTERMS(:,14,79) = +0.39435*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(HO2,K079) = +0.23451*K079*<ALKE>*<O3>
 PTERMS(:,15,79) = +0.23451*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CH4,K079) = +0.04300*K079*<ALKE>*<O3>
 PTERMS(:,16,79) = +0.04300*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ETH,K079) = +0.03196*K079*<ALKE>*<O3>
 PTERMS(:,17,79) = +0.03196*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ALKE,K079) = -K079*<ALKE>*<O3>
 PTERMS(:,19,79) = -TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(HCHO,K079) = +0.48290*K079*<ALKE>*<O3>
 PTERMS(:,22,79) = +0.48290*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ALD,K079) = +0.51468*K079*<ALKE>*<O3>
 PTERMS(:,23,79) = +0.51468*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(KET,K079) = +0.07377*K079*<ALKE>*<O3>
 PTERMS(:,24,79) = +0.07377*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CARBO,K079) = +0.00000*K079*<ALKE>*<O3>
 PTERMS(:,25,79) = +0.00000*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT13
!
SUBROUTINE SUBT14
!
!Indices 281 a 300
!
!PTERMS(ORA1,K079) = +0.15343*K079*<ALKE>*<O3>
 PTERMS(:,30,79) = +0.15343*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ORA2,K079) = +0.08143*K079*<ALKE>*<O3>
 PTERMS(:,31,79) = +0.08143*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(MO2,K079) = +0.13966*K079*<ALKE>*<O3>
 PTERMS(:,32,79) = +0.13966*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ALKAP,K079) = +0.09815*K079*<ALKE>*<O3>
 PTERMS(:,33,79) = +0.09815*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CARBOP,K079) = +0.05705*K079*<ALKE>*<O3>
 PTERMS(:,39,79) = +0.05705*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(XO2,K079) = +0.00000*K079*<ALKE>*<O3>
 PTERMS(:,41,79) = +0.00000*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(O3,K080) = -K080*<BIO>*<O3>
 PTERMS(:,1,80) = -TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(H2O2,K080) = +0.00100*K080*<BIO>*<O3>
 PTERMS(:,2,80) = +0.00100*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(CO,K080) = +0.36000*K080*<BIO>*<O3>
 PTERMS(:,13,80) = +0.36000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(OH,K080) = +0.28000*K080*<BIO>*<O3>
 PTERMS(:,14,80) = +0.28000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(HO2,K080) = +0.30000*K080*<BIO>*<O3>
 PTERMS(:,15,80) = +0.30000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ALKE,K080) = +0.37388*K080*<BIO>*<O3>
 PTERMS(:,19,80) = +0.37388*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(BIO,K080) = -K080*<BIO>*<O3>
 PTERMS(:,20,80) = -TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(HCHO,K080) = +0.90000*K080*<BIO>*<O3>
 PTERMS(:,22,80) = +0.90000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ALD,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,23,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(KET,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,24,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(CARBO,K080) = +0.39754*K080*<BIO>*<O3>
 PTERMS(:,25,80) = +0.39754*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ORA1,K080) = +0.15000*K080*<BIO>*<O3>
 PTERMS(:,30,80) = +0.15000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ORA2,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,31,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(MO2,K080) = +0.03000*K080*<BIO>*<O3>
 PTERMS(:,32,80) = +0.03000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT14
!
SUBROUTINE SUBT15
!
!Indices 301 a 320
!
!PTERMS(ALKAP,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,33,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(CARBOP,K080) = +0.17000*K080*<BIO>*<O3>
 PTERMS(:,39,80) = +0.17000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(XO2,K080) = +0.13000*K080*<BIO>*<O3>
 PTERMS(:,41,80) = +0.13000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(O3,K081) = -K081*<CARBO>*<O3>
 PTERMS(:,1,81) = -TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(CO,K081) = +0.64728*K081*<CARBO>*<O3>
 PTERMS(:,13,81) = +0.64728*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(OH,K081) = +0.20595*K081*<CARBO>*<O3>
 PTERMS(:,14,81) = +0.20595*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(HO2,K081) = +0.28441*K081*<CARBO>*<O3>
 PTERMS(:,15,81) = +0.28441*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(HCHO,K081) = +0.00000*K081*<CARBO>*<O3>
 PTERMS(:,22,81) = +0.00000*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(ALD,K081) = +0.15692*K081*<CARBO>*<O3>
 PTERMS(:,23,81) = +0.15692*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(CARBO,K081) = -K081*<CARBO>*<O3>
 PTERMS(:,25,81) = -TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(OP2,K081) = +0.10149*K081*<CARBO>*<O3>
 PTERMS(:,29,81) = +0.10149*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(ORA1,K081) = +0.10788*K081*<CARBO>*<O3>
 PTERMS(:,30,81) = +0.10788*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(ORA2,K081) = +0.20595*K081*<CARBO>*<O3>
 PTERMS(:,31,81) = +0.20595*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(CARBOP,K081) = +0.27460*K081*<CARBO>*<O3>
 PTERMS(:,39,81) = +0.27460*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(O3,K082) = -K082*<PAN>*<O3>
 PTERMS(:,1,82) = -TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(NO2,K082) = +0.70*K082*<PAN>*<O3>
 PTERMS(:,4,82) = +0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(CO,K082) = +0.13*K082*<PAN>*<O3>
 PTERMS(:,13,82) = +0.13*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(OH,K082) = +0.036*K082*<PAN>*<O3>
 PTERMS(:,14,82) = +0.036*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(HO2,K082) = +0.08*K082*<PAN>*<O3>
 PTERMS(:,15,82) = +0.08*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(HCHO,K082) = +0.70*K082*<PAN>*<O3>
 PTERMS(:,22,82) = +0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT15
!
SUBROUTINE SUBT16
!
!Indices 321 a 340
!
!PTERMS(PAN,K082) = -K082*<PAN>*<O3>
 PTERMS(:,27,82) = -TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(ORA1,K082) = +0.11*K082*<PAN>*<O3>
 PTERMS(:,30,82) = +0.11*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(CARBOP,K082) = +0.70000*K082*<PAN>*<O3>
 PTERMS(:,39,82) = +0.70000*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(NO2,K083) = -K083*<PHO>*<NO2>
 PTERMS(:,4,83) = -TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(ARO,K083) = +0.10670*K083*<PHO>*<NO2>
 PTERMS(:,21,83) = +0.10670*TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(ONIT,K083) = +K083*<PHO>*<NO2>
 PTERMS(:,26,83) = +TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(PHO,K083) = -K083*<PHO>*<NO2>
 PTERMS(:,36,83) = -TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(HO2,K084) = -K084*<PHO>*<HO2>
 PTERMS(:,15,84) = -TPK%K084(:)*PCONC(:,36)*PCONC(:,15)
!
!PTERMS(ARO,K084) = +1.06698*K084*<PHO>*<HO2>
 PTERMS(:,21,84) = +1.06698*TPK%K084(:)*PCONC(:,36)*PCONC(:,15)
!
!PTERMS(PHO,K084) = -K084*<PHO>*<HO2>
 PTERMS(:,36,84) = -TPK%K084(:)*PCONC(:,36)*PCONC(:,15)
!
!PTERMS(NO2,K085) = -K085*<ADD>*<NO2>
 PTERMS(:,4,85) = -TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(HONO,K085) = +K085*<ADD>*<NO2>
 PTERMS(:,7,85) = +TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(ARO,K085) = +K085*<ADD>*<NO2>
 PTERMS(:,21,85) = +TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(ADD,K085) = -K085*<ADD>*<NO2>
 PTERMS(:,37,85) = -TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(HO2,K086) = +0.02*K086*<ADD>*<O2>
 PTERMS(:,15,86) = +0.02*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(ARO,K086) = +0.02*K086*<ADD>*<O2>
 PTERMS(:,21,86) = +0.02*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(ADD,K086) = -K086*<ADD>*<O2>
 PTERMS(:,37,86) = -TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(AROP,K086) = +0.98*K086*<ADD>*<O2>
 PTERMS(:,38,86) = +0.98*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(O3,K087) = -K087*<ADD>*<O3>
 PTERMS(:,1,87) = -TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!PTERMS(OH,K087) = +K087*<ADD>*<O3>
 PTERMS(:,14,87) = +TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT16
!
SUBROUTINE SUBT17
!
!Indices 341 a 360
!
!PTERMS(ARO,K087) = +K087*<ADD>*<O3>
 PTERMS(:,21,87) = +TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!PTERMS(ADD,K087) = -K087*<ADD>*<O3>
 PTERMS(:,37,87) = -TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!PTERMS(NO2,K088) = -K088*<CARBOP>*<NO2>
 PTERMS(:,4,88) = -TPK%K088(:)*PCONC(:,39)*PCONC(:,4)
!
!PTERMS(PAN,K088) = +1.00000*K088*<CARBOP>*<NO2>
 PTERMS(:,27,88) = +1.00000*TPK%K088(:)*PCONC(:,39)*PCONC(:,4)
!
!PTERMS(CARBOP,K088) = -K088*<CARBOP>*<NO2>
 PTERMS(:,39,88) = -TPK%K088(:)*PCONC(:,39)*PCONC(:,4)
!
!PTERMS(NO2,K089) = +K089*<PAN>
 PTERMS(:,4,89) = +TPK%K089(:)*PCONC(:,27)
!
!PTERMS(PAN,K089) = -K089*<PAN>
 PTERMS(:,27,89) = -TPK%K089(:)*PCONC(:,27)
!
!PTERMS(CARBOP,K089) = +1.00000*K089*<PAN>
 PTERMS(:,39,89) = +1.00000*TPK%K089(:)*PCONC(:,27)
!
!PTERMS(NO,K090) = -K090*<MO2>*<NO>
 PTERMS(:,3,90) = -TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(NO2,K090) = +K090*<MO2>*<NO>
 PTERMS(:,4,90) = +TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(HO2,K090) = +K090*<MO2>*<NO>
 PTERMS(:,15,90) = +TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(HCHO,K090) = +K090*<MO2>*<NO>
 PTERMS(:,22,90) = +TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(MO2,K090) = -K090*<MO2>*<NO>
 PTERMS(:,32,90) = -TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(NO,K091) = -K091*<ALKAP>*<NO>
 PTERMS(:,3,91) = -TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(NO2,K091) = +0.91541*K091*<ALKAP>*<NO>
 PTERMS(:,4,91) = +0.91541*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(HO2,K091) = +0.74265*K091*<ALKAP>*<NO>
 PTERMS(:,15,91) = +0.74265*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(HCHO,K091) = +0.03002*K091*<ALKAP>*<NO>
 PTERMS(:,22,91) = +0.03002*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(ALD,K091) = +0.33144*K091*<ALKAP>*<NO>
 PTERMS(:,23,91) = +0.33144*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(KET,K091) = +0.54531*K091*<ALKAP>*<NO>
 PTERMS(:,24,91) = +0.54531*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(CARBO,K091) = +0.03407*K091*<ALKAP>*<NO>
 PTERMS(:,25,91) = +0.03407*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT17
!
SUBROUTINE SUBT18
!
!Indices 361 a 380
!
!PTERMS(ONIT,K091) = +0.08459*K091*<ALKAP>*<NO>
 PTERMS(:,26,91) = +0.08459*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(MO2,K091) = +0.09016*K091*<ALKAP>*<NO>
 PTERMS(:,32,91) = +0.09016*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(ALKAP,K091) = -K091*<ALKAP>*<NO>
 PTERMS(:,33,91) = -TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(XO2,K091) = +0.13007*K091*<ALKAP>*<NO>
 PTERMS(:,41,91) = +0.13007*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(NO,K092) = -K092*<ALKEP>*<NO>
 PTERMS(:,3,92) = -TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(NO2,K092) = +K092*<ALKEP>*<NO>
 PTERMS(:,4,92) = +TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(HO2,K092) = +K092*<ALKEP>*<NO>
 PTERMS(:,15,92) = +TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(HCHO,K092) = +1.39870*K092*<ALKEP>*<NO>
 PTERMS(:,22,92) = +1.39870*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(ALD,K092) = +0.42125*K092*<ALKEP>*<NO>
 PTERMS(:,23,92) = +0.42125*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(KET,K092) = +0.05220*K092*<ALKEP>*<NO>
 PTERMS(:,24,92) = +0.05220*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(ALKEP,K092) = -K092*<ALKEP>*<NO>
 PTERMS(:,34,92) = -TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(NO,K093) = -K093*<BIOP>*<NO>
 PTERMS(:,3,93) = -TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(NO2,K093) = +0.84700*K093*<BIOP>*<NO>
 PTERMS(:,4,93) = +0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(HO2,K093) = +0.84700*K093*<BIOP>*<NO>
 PTERMS(:,15,93) = +0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(ALKE,K093) = +0.37815*K093*<BIOP>*<NO>
 PTERMS(:,19,93) = +0.37815*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(HCHO,K093) = +0.60600*K093*<BIOP>*<NO>
 PTERMS(:,22,93) = +0.60600*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(ALD,K093) = +0.00000*K093*<BIOP>*<NO>
 PTERMS(:,23,93) = +0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(KET,K093) = +0.00000*K093*<BIOP>*<NO>
 PTERMS(:,24,93) = +0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(CARBO,K093) = +0.45463*K093*<BIOP>*<NO>
 PTERMS(:,25,93) = +0.45463*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(ONIT,K093) = +0.15300*K093*<BIOP>*<NO>
 PTERMS(:,26,93) = +0.15300*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT18
!
SUBROUTINE SUBT19
!
!Indices 381 a 400
!
!PTERMS(BIOP,K093) = -K093*<BIOP>*<NO>
 PTERMS(:,35,93) = -TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(NO,K094) = -K094*<AROP>*<NO>
 PTERMS(:,3,94) = -TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(NO2,K094) = +0.95115*K094*<AROP>*<NO>
 PTERMS(:,4,94) = +0.95115*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(HO2,K094) = +0.95115*K094*<AROP>*<NO>
 PTERMS(:,15,94) = +0.95115*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(CARBO,K094) = +2.06993*K094*<AROP>*<NO>
 PTERMS(:,25,94) = +2.06993*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(ONIT,K094) = +0.04885*K094*<AROP>*<NO>
 PTERMS(:,26,94) = +0.04885*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(AROP,K094) = -K094*<AROP>*<NO>
 PTERMS(:,38,94) = -TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(NO,K095) = -K095*<CARBOP>*<NO>
 PTERMS(:,3,95) = -TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(NO2,K095) = +K095*<CARBOP>*<NO>
 PTERMS(:,4,95) = +TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(HO2,K095) = +0.12334*K095*<CARBOP>*<NO>
 PTERMS(:,15,95) = +0.12334*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(HCHO,K095) = +0.05848*K095*<CARBOP>*<NO>
 PTERMS(:,22,95) = +0.05848*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(ALD,K095) = +0.07368*K095*<CARBOP>*<NO>
 PTERMS(:,23,95) = +0.07368*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(CARBO,K095) = +0.08670*K095*<CARBOP>*<NO>
 PTERMS(:,25,95) = +0.08670*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(MO2,K095) = +0.78134*K095*<CARBOP>*<NO>
 PTERMS(:,32,95) = +0.78134*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(CARBOP,K095) = -K095*<CARBOP>*<NO>
 PTERMS(:,39,95) = -TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(XO2,K095) = +0.02563*K095*<CARBOP>*<NO>
 PTERMS(:,41,95) = +0.02563*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(NO,K096) = -K096*<OLN>*<NO>
 PTERMS(:,3,96) = -TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(NO2,K096) = +1.81599*K096*<OLN>*<NO>
 PTERMS(:,4,96) = +1.81599*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(HO2,K096) = +0.18401*K096*<OLN>*<NO>
 PTERMS(:,15,96) = +0.18401*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(HCHO,K096) = +0.23419*K096*<OLN>*<NO>
 PTERMS(:,22,96) = +0.23419*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT19
!
SUBROUTINE SUBT20
!
!Indices 401 a 420
!
!PTERMS(ALD,K096) = +1.01182*K096*<OLN>*<NO>
 PTERMS(:,23,96) = +1.01182*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(KET,K096) = +0.37862*K096*<OLN>*<NO>
 PTERMS(:,24,96) = +0.37862*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(ONIT,K096) = +0.18401*K096*<OLN>*<NO>
 PTERMS(:,26,96) = +0.18401*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(OLN,K096) = -K096*<OLN>*<NO>
 PTERMS(:,40,96) = -TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(HO2,K097) = -K097*<MO2>*<HO2>
 PTERMS(:,15,97) = -TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!
!PTERMS(OP1,K097) = +K097*<MO2>*<HO2>
 PTERMS(:,28,97) = +TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!
!PTERMS(MO2,K097) = -K097*<MO2>*<HO2>
 PTERMS(:,32,97) = -TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!
!PTERMS(HO2,K098) = -K098*<ALKAP>*<HO2>
 PTERMS(:,15,98) = -TPK%K098(:)*PCONC(:,33)*PCONC(:,15)
!
!PTERMS(OP2,K098) = +1.00524*K098*<ALKAP>*<HO2>
 PTERMS(:,29,98) = +1.00524*TPK%K098(:)*PCONC(:,33)*PCONC(:,15)
!
!PTERMS(ALKAP,K098) = -K098*<ALKAP>*<HO2>
 PTERMS(:,33,98) = -TPK%K098(:)*PCONC(:,33)*PCONC(:,15)
!
!PTERMS(HO2,K099) = -K099*<ALKEP>*<HO2>
 PTERMS(:,15,99) = -TPK%K099(:)*PCONC(:,34)*PCONC(:,15)
!
!PTERMS(OP2,K099) = +1.00524*K099*<ALKEP>*<HO2>
 PTERMS(:,29,99) = +1.00524*TPK%K099(:)*PCONC(:,34)*PCONC(:,15)
!
!PTERMS(ALKEP,K099) = -K099*<ALKEP>*<HO2>
 PTERMS(:,34,99) = -TPK%K099(:)*PCONC(:,34)*PCONC(:,15)
!
!PTERMS(HO2,K0100) = -K0100*<BIOP>*<HO2>
 PTERMS(:,15,100) = -TPK%K0100(:)*PCONC(:,35)*PCONC(:,15)
!
!PTERMS(OP2,K0100) = +1.00524*K0100*<BIOP>*<HO2>
 PTERMS(:,29,100) = +1.00524*TPK%K0100(:)*PCONC(:,35)*PCONC(:,15)
!
!PTERMS(BIOP,K0100) = -K0100*<BIOP>*<HO2>
 PTERMS(:,35,100) = -TPK%K0100(:)*PCONC(:,35)*PCONC(:,15)
!
!PTERMS(HO2,K0101) = -K0101*<AROP>*<HO2>
 PTERMS(:,15,101) = -TPK%K0101(:)*PCONC(:,38)*PCONC(:,15)
!
!PTERMS(OP2,K0101) = +1.00524*K0101*<AROP>*<HO2>
 PTERMS(:,29,101) = +1.00524*TPK%K0101(:)*PCONC(:,38)*PCONC(:,15)
!
!PTERMS(AROP,K0101) = -K0101*<AROP>*<HO2>
 PTERMS(:,38,101) = -TPK%K0101(:)*PCONC(:,38)*PCONC(:,15)
!
!PTERMS(O3,K0102) = +0.17307*K0102*<CARBOP>*<HO2>
 PTERMS(:,1,102) = +0.17307*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!
RETURN
END SUBROUTINE SUBT20
!
SUBROUTINE SUBT21
!
!Indices 421 a 440
!
!PTERMS(HO2,K0102) = -K0102*<CARBOP>*<HO2>
 PTERMS(:,15,102) = -TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(OP2,K0102) = +0.80904*K0102*<CARBOP>*<HO2>
 PTERMS(:,29,102) = +0.80904*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(ORA2,K0102) = +0.17307*K0102*<CARBOP>*<HO2>
 PTERMS(:,31,102) = +0.17307*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(CARBOP,K0102) = -K0102*<CARBOP>*<HO2>
 PTERMS(:,39,102) = -TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(HO2,K103) = -K103*<OLN>*<HO2>
 PTERMS(:,15,103) = -TPK%K103(:)*PCONC(:,40)*PCONC(:,15)
!
!PTERMS(ONIT,K103) = +K103*<OLN>*<HO2>
 PTERMS(:,26,103) = +TPK%K103(:)*PCONC(:,40)*PCONC(:,15)
!
!PTERMS(OLN,K103) = -K103*<OLN>*<HO2>
 PTERMS(:,40,103) = -TPK%K103(:)*PCONC(:,40)*PCONC(:,15)
!
!PTERMS(HO2,K104) = +0.66*K104*<MO2>*<MO2>
 PTERMS(:,15,104) = +0.66*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)
!
!PTERMS(HCHO,K104) = +1.33*K104*<MO2>*<MO2>
 PTERMS(:,22,104) = +1.33*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)
!
!PTERMS(MO2,K104) = -K104*<MO2>*<MO2>
 PTERMS(:,32,104) = -TPK%K104(:)*PCONC(:,32)*PCONC(:,32)
!
!PTERMS(HO2,K105) = +0.98383*K105*<ALKAP>*<MO2>
 PTERMS(:,15,105) = +0.98383*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(HCHO,K105) = +0.80556*K105*<ALKAP>*<MO2>
 PTERMS(:,22,105) = +0.80556*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(ALD,K105) = +0.56070*K105*<ALKAP>*<MO2>
 PTERMS(:,23,105) = +0.56070*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(KET,K105) = +0.09673*K105*<ALKAP>*<MO2>
 PTERMS(:,24,105) = +0.09673*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(CARBO,K105) = +0.07976*K105*<ALKAP>*<MO2>
 PTERMS(:,25,105) = +0.07976*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(MO2,K105) = -K105*<ALKAP>*<MO2>
 PTERMS(:,32,105) = -TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(ALKAP,K105) = -K105*<ALKAP>*<MO2>
 PTERMS(:,33,105) = -TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(XO2,K105) = +0.13370*K105*<ALKAP>*<MO2>
 PTERMS(:,41,105) = +0.13370*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(HO2,K106) = +K106*<ALKEP>*<MO2>
 PTERMS(:,15,106) = +TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(HCHO,K106) = +1.42894*K106*<ALKEP>*<MO2>
 PTERMS(:,22,106) = +1.42894*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!
RETURN
END SUBROUTINE SUBT21
!
SUBROUTINE SUBT22
!
!Indices 441 a 460
!
!PTERMS(ALD,K106) = +0.46413*K106*<ALKEP>*<MO2>
 PTERMS(:,23,106) = +0.46413*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(KET,K106) = +0.03814*K106*<ALKEP>*<MO2>
 PTERMS(:,24,106) = +0.03814*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(MO2,K106) = -K106*<ALKEP>*<MO2>
 PTERMS(:,32,106) = -TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(ALKEP,K106) = -K106*<ALKEP>*<MO2>
 PTERMS(:,34,106) = -TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(HO2,K107) = +1.00000*K107*<BIOP>*<MO2>
 PTERMS(:,15,107) = +1.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(ALKE,K107) = +0.48074*K107*<BIOP>*<MO2>
 PTERMS(:,19,107) = +0.48074*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(HCHO,K107) = +1.09000*K107*<BIOP>*<MO2>
 PTERMS(:,22,107) = +1.09000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(ALD,K107) = +0.00000*K107*<BIOP>*<MO2>
 PTERMS(:,23,107) = +0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(KET,K107) = +0.00000*K107*<BIOP>*<MO2>
 PTERMS(:,24,107) = +0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(CARBO,K107) = +0.56064*K107*<BIOP>*<MO2>
 PTERMS(:,25,107) = +0.56064*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(MO2,K107) = -K107*<BIOP>*<MO2>
 PTERMS(:,32,107) = -TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(BIOP,K107) = -K107*<BIOP>*<MO2>
 PTERMS(:,35,107) = -TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(HO2,K108) = +1.02767*K108*<AROP>*<MO2>
 PTERMS(:,15,108) = +1.02767*TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(HCHO,K108) = +K108*<AROP>*<MO2>
 PTERMS(:,22,108) = +TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(CARBO,K108) = +1.99461*K108*<AROP>*<MO2>
 PTERMS(:,25,108) = +1.99461*TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(MO2,K108) = -K108*<AROP>*<MO2>
 PTERMS(:,32,108) = -TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(AROP,K108) = -K108*<AROP>*<MO2>
 PTERMS(:,38,108) = -TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(HO2,K109) = +0.82998*K109*<CARBOP>*<MO2>
 PTERMS(:,15,109) = +0.82998*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(HCHO,K109) = +0.95723*K109*<CARBOP>*<MO2>
 PTERMS(:,22,109) = +0.95723*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(ALD,K109) = +0.08295*K109*<CARBOP>*<MO2>
 PTERMS(:,23,109) = +0.08295*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!
RETURN
END SUBROUTINE SUBT22
!
SUBROUTINE SUBT23
!
!Indices 461 a 480
!
!PTERMS(CARBO,K109) = +0.15387*K109*<CARBOP>*<MO2>
 PTERMS(:,25,109) = +0.15387*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(ORA2,K109) = +0.13684*K109*<CARBOP>*<MO2>
 PTERMS(:,31,109) = +0.13684*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(MO2,K109) = -K109*<CARBOP>*<MO2>
 PTERMS(:,32,109) = -TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(CARBOP,K109) = -K109*<CARBOP>*<MO2>
 PTERMS(:,39,109) = -TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(XO2,K109) = +0.02212*K109*<CARBOP>*<MO2>
 PTERMS(:,41,109) = +0.02212*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(NO2,K110) = +0.32440*K110*<OLN>*<MO2>
 PTERMS(:,4,110) = +0.32440*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(HO2,K110) = +0.67560*K110*<OLN>*<MO2>
 PTERMS(:,15,110) = +0.67560*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(HCHO,K110) = +0.88625*K110*<OLN>*<MO2>
 PTERMS(:,22,110) = +0.88625*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(ALD,K110) = +0.41524*K110*<OLN>*<MO2>
 PTERMS(:,23,110) = +0.41524*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(KET,K110) = +0.09667*K110*<OLN>*<MO2>
 PTERMS(:,24,110) = +0.09667*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(ONIT,K110) = +0.67560*K110*<OLN>*<MO2>
 PTERMS(:,26,110) = +0.67560*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(MO2,K110) = -K110*<OLN>*<MO2>
 PTERMS(:,32,110) = -TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(OLN,K110) = -K110*<OLN>*<MO2>
 PTERMS(:,40,110) = -TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(HO2,K111) = +0.48079*K111*<ALKAP>*<CARBOP>
 PTERMS(:,15,111) = +0.48079*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(HCHO,K111) = +0.07600*K111*<ALKAP>*<CARBOP>
 PTERMS(:,22,111) = +0.07600*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(ALD,K111) = +0.71461*K111*<ALKAP>*<CARBOP>
 PTERMS(:,23,111) = +0.71461*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(KET,K111) = +0.18819*K111*<ALKAP>*<CARBOP>
 PTERMS(:,24,111) = +0.18819*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(CARBO,K111) = +0.06954*K111*<ALKAP>*<CARBOP>
 PTERMS(:,25,111) = +0.06954*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(ORA2,K111) = +0.49810*K111*<ALKAP>*<CARBOP>
 PTERMS(:,31,111) = +0.49810*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(MO2,K111) = +0.51480*K111*<ALKAP>*<CARBOP>
 PTERMS(:,32,111) = +0.51480*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!
RETURN
END SUBROUTINE SUBT23
!
SUBROUTINE SUBT24
!
!Indices 481 a 500
!
!PTERMS(ALKAP,K111) = -K111*<ALKAP>*<CARBOP>
 PTERMS(:,33,111) = -TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(CARBOP,K111) = -K111*<ALKAP>*<CARBOP>
 PTERMS(:,39,111) = -TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(XO2,K111) = +0.11306*K111*<ALKAP>*<CARBOP>
 PTERMS(:,41,111) = +0.11306*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(HO2,K112) = +0.50078*K112*<ALKEP>*<CARBOP>
 PTERMS(:,15,112) = +0.50078*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(HCHO,K112) = +0.68192*K112*<ALKEP>*<CARBOP>
 PTERMS(:,22,112) = +0.68192*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(ALD,K112) = +0.68374*K112*<ALKEP>*<CARBOP>
 PTERMS(:,23,112) = +0.68374*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(KET,K112) = +0.06579*K112*<ALKEP>*<CARBOP>
 PTERMS(:,24,112) = +0.06579*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(ORA2,K112) = +0.49922*K112*<ALKEP>*<CARBOP>
 PTERMS(:,31,112) = +0.49922*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(MO2,K112) = +0.50078*K112*<ALKEP>*<CARBOP>
 PTERMS(:,32,112) = +0.50078*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(ALKEP,K112) = -K112*<ALKEP>*<CARBOP>
 PTERMS(:,34,112) = -TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(CARBOP,K112) = -K112*<ALKEP>*<CARBOP>
 PTERMS(:,39,112) = -TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(HO2,K113) = +0.50600*K113*<BIOP>*<CARBOP>
 PTERMS(:,15,113) = +0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(ALKE,K113) = +0.24463*K113*<BIOP>*<CARBOP>
 PTERMS(:,19,113) = +0.24463*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(HCHO,K113) = +0.34000*K113*<BIOP>*<CARBOP>
 PTERMS(:,22,113) = +0.34000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(ALD,K113) = +0.00000*K113*<BIOP>*<CARBOP>
 PTERMS(:,23,113) = +0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(KET,K113) = +0.00000*K113*<BIOP>*<CARBOP>
 PTERMS(:,24,113) = +0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(CARBO,K113) = +0.78591*K113*<BIOP>*<CARBOP>
 PTERMS(:,25,113) = +0.78591*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(ORA2,K113) = +0.49400*K113*<BIOP>*<CARBOP>
 PTERMS(:,31,113) = +0.49400*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(MO2,K113) = +0.50600*K113*<BIOP>*<CARBOP>
 PTERMS(:,32,113) = +0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(BIOP,K113) = -K113*<BIOP>*<CARBOP>
 PTERMS(:,35,113) = -TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!
RETURN
END SUBROUTINE SUBT24
!
SUBROUTINE SUBT25
!
!Indices 501 a 520
!
!PTERMS(CARBOP,K113) = -K113*<BIOP>*<CARBOP>
 PTERMS(:,39,113) = -TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(HO2,K114) = +K114*<AROP>*<CARBOP>
 PTERMS(:,15,114) = +TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(CARBO,K114) = +1.99455*K114*<AROP>*<CARBOP>
 PTERMS(:,25,114) = +1.99455*TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(MO2,K114) = +K114*<AROP>*<CARBOP>
 PTERMS(:,32,114) = +TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(AROP,K114) = -K114*<AROP>*<CARBOP>
 PTERMS(:,38,114) = -TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(CARBOP,K114) = -K114*<AROP>*<CARBOP>
 PTERMS(:,39,114) = -TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(HO2,K115) = +0.07566*K115*<CARBOP>*<CARBOP>
 PTERMS(:,15,115) = +0.07566*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(HCHO,K115) = +0.03432*K115*<CARBOP>*<CARBOP>
 PTERMS(:,22,115) = +0.03432*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(ALD,K115) = +0.06969*K115*<CARBOP>*<CARBOP>
 PTERMS(:,23,115) = +0.06969*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(KET,K115) = +0.02190*K115*<CARBOP>*<CARBOP>
 PTERMS(:,24,115) = +0.02190*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(CARBO,K115) = +0.10777*K115*<CARBOP>*<CARBOP>
 PTERMS(:,25,115) = +0.10777*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(ORA2,K115) = +0.09955*K115*<CARBOP>*<CARBOP>
 PTERMS(:,31,115) = +0.09955*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(MO2,K115) = +1.66702*K115*<CARBOP>*<CARBOP>
 PTERMS(:,32,115) = +1.66702*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(CARBOP,K115) = -K115*<CARBOP>*<CARBOP>
 PTERMS(:,39,115) = -TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(XO2,K115) = +0.01593*K115*<CARBOP>*<CARBOP>
 PTERMS(:,41,115) = +0.01593*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(NO2,K116) = +0.00000*K116*<OLN>*<CARBOP>
 PTERMS(:,4,116) = +0.00000*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(HO2,K116) = +0.17599*K116*<OLN>*<CARBOP>
 PTERMS(:,15,116) = +0.17599*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(HCHO,K116) = +0.13414*K116*<OLN>*<CARBOP>
 PTERMS(:,22,116) = +0.13414*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(ALD,K116) = +0.42122*K116*<OLN>*<CARBOP>
 PTERMS(:,23,116) = +0.42122*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(KET,K116) = +0.10822*K116*<OLN>*<CARBOP>
 PTERMS(:,24,116) = +0.10822*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!
RETURN
END SUBROUTINE SUBT25
!
SUBROUTINE SUBT26
!
!Indices 521 a 540
!
!PTERMS(ONIT,K116) = +0.66562*K116*<OLN>*<CARBOP>
 PTERMS(:,26,116) = +0.66562*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(ORA2,K116) = +0.48963*K116*<OLN>*<CARBOP>
 PTERMS(:,31,116) = +0.48963*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(MO2,K116) = +0.51037*K116*<OLN>*<CARBOP>
 PTERMS(:,32,116) = +0.51037*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(CARBOP,K116) = -K116*<OLN>*<CARBOP>
 PTERMS(:,39,116) = -TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(OLN,K116) = -K116*<OLN>*<CARBOP>
 PTERMS(:,40,116) = -TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(HO2,K117) = +K117*<OLN>*<OLN>
 PTERMS(:,15,117) = +TPK%K117(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(ONIT,K117) = +2.00*K117*<OLN>*<OLN>
 PTERMS(:,26,117) = +2.00*TPK%K117(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(OLN,K117) = -K117*<OLN>*<OLN>
 PTERMS(:,40,117) = -TPK%K117(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(NO2,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,4,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(HO2,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,15,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(HCHO,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,22,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(ALD,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,23,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(KET,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,24,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(ONIT,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,26,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(OLN,K118) = -K118*<OLN>*<OLN>
 PTERMS(:,40,118) = -TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(NO2,K119) = +K119*<MO2>*<NO3>
 PTERMS(:,4,119) = +TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(NO3,K119) = -K119*<MO2>*<NO3>
 PTERMS(:,5,119) = -TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(HO2,K119) = +K119*<MO2>*<NO3>
 PTERMS(:,15,119) = +TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(HCHO,K119) = +K119*<MO2>*<NO3>
 PTERMS(:,22,119) = +TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(MO2,K119) = -K119*<MO2>*<NO3>
 PTERMS(:,32,119) = -TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT26
!
SUBROUTINE SUBT27
!
!Indices 541 a 560
!
!PTERMS(NO2,K120) = +K120*<ALKAP>*<NO3>
 PTERMS(:,4,120) = +TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(NO3,K120) = -K120*<ALKAP>*<NO3>
 PTERMS(:,5,120) = -TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(HO2,K120) = +0.81290*K120*<ALKAP>*<NO3>
 PTERMS(:,15,120) = +0.81290*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(HCHO,K120) = +0.03142*K120*<ALKAP>*<NO3>
 PTERMS(:,22,120) = +0.03142*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(ALD,K120) = +0.33743*K120*<ALKAP>*<NO3>
 PTERMS(:,23,120) = +0.33743*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(KET,K120) = +0.62978*K120*<ALKAP>*<NO3>
 PTERMS(:,24,120) = +0.62978*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(CARBO,K120) = +0.03531*K120*<ALKAP>*<NO3>
 PTERMS(:,25,120) = +0.03531*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(MO2,K120) = +0.09731*K120*<ALKAP>*<NO3>
 PTERMS(:,32,120) = +0.09731*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(ALKAP,K120) = -K120*<ALKAP>*<NO3>
 PTERMS(:,33,120) = -TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(XO2,K120) = +0.16271*K120*<ALKAP>*<NO3>
 PTERMS(:,41,120) = +0.16271*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(NO2,K121) = +K121*<ALKEP>*<NO3>
 PTERMS(:,4,121) = +TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(NO3,K121) = -K121*<ALKEP>*<NO3>
 PTERMS(:,5,121) = -TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(HO2,K121) = +K121*<ALKEP>*<NO3>
 PTERMS(:,15,121) = +TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(HCHO,K121) = +1.40909*K121*<ALKEP>*<NO3>
 PTERMS(:,22,121) = +1.40909*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(ALD,K121) = +0.43039*K121*<ALKEP>*<NO3>
 PTERMS(:,23,121) = +0.43039*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(KET,K121) = +0.02051*K121*<ALKEP>*<NO3>
 PTERMS(:,24,121) = +0.02051*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(ALKEP,K121) = -K121*<ALKEP>*<NO3>
 PTERMS(:,34,121) = -TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(NO2,K122) = +K122*<BIOP>*<NO3>
 PTERMS(:,4,122) = +TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(NO3,K122) = -K122*<BIOP>*<NO3>
 PTERMS(:,5,122) = -TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(HO2,K122) = +K122*<BIOP>*<NO3>
 PTERMS(:,15,122) = +TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT27
!
SUBROUTINE SUBT28
!
!Indices 561 a 580
!
!PTERMS(ALKE,K122) = +0.42729*K122*<BIOP>*<NO3>
 PTERMS(:,19,122) = +0.42729*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(HCHO,K122) = +0.68600*K122*<BIOP>*<NO3>
 PTERMS(:,22,122) = +0.68600*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(ALD,K122) = +0.00000*K122*<BIOP>*<NO3>
 PTERMS(:,23,122) = +0.00000*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(KET,K122) = +0.00000*K122*<BIOP>*<NO3>
 PTERMS(:,24,122) = +0.00000*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(CARBO,K122) = +0.61160*K122*<BIOP>*<NO3>
 PTERMS(:,25,122) = +0.61160*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(BIOP,K122) = -K122*<BIOP>*<NO3>
 PTERMS(:,35,122) = -TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(NO2,K123) = +K123*<AROP>*<NO3>
 PTERMS(:,4,123) = +TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(NO3,K123) = -K123*<AROP>*<NO3>
 PTERMS(:,5,123) = -TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(HO2,K123) = +K123*<AROP>*<NO3>
 PTERMS(:,15,123) = +TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(CARBO,K123) = +2.81904*K123*<AROP>*<NO3>
 PTERMS(:,25,123) = +2.81904*TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(AROP,K123) = -K123*<AROP>*<NO3>
 PTERMS(:,38,123) = -TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(NO2,K124) = +K124*<CARBOP>*<NO3>
 PTERMS(:,4,124) = +TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(NO3,K124) = -K124*<CARBOP>*<NO3>
 PTERMS(:,5,124) = -TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(HO2,K124) = +0.04915*K124*<CARBOP>*<NO3>
 PTERMS(:,15,124) = +0.04915*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(HCHO,K124) = +0.03175*K124*<CARBOP>*<NO3>
 PTERMS(:,22,124) = +0.03175*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(ALD,K124) = +0.02936*K124*<CARBOP>*<NO3>
 PTERMS(:,23,124) = +0.02936*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(CARBO,K124) = +0.03455*K124*<CARBOP>*<NO3>
 PTERMS(:,25,124) = +0.03455*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(MO2,K124) = +0.91910*K124*<CARBOP>*<NO3>
 PTERMS(:,32,124) = +0.91910*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(CARBOP,K124) = -K124*<CARBOP>*<NO3>
 PTERMS(:,39,124) = -TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(XO2,K124) = +0.01021*K124*<CARBOP>*<NO3>
 PTERMS(:,41,124) = +0.01021*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT28
!
SUBROUTINE SUBT29
!
!Indices 581 a 600
!
!PTERMS(NO2,K125) = +1.74072*K125*<OLN>*<NO3>
 PTERMS(:,4,125) = +1.74072*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(NO3,K125) = -K125*<OLN>*<NO3>
 PTERMS(:,5,125) = -TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(HO2,K125) = +0.25928*K125*<OLN>*<NO3>
 PTERMS(:,15,125) = +0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(HCHO,K125) = +0.20740*K125*<OLN>*<NO3>
 PTERMS(:,22,125) = +0.20740*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(ALD,K125) = +0.91850*K125*<OLN>*<NO3>
 PTERMS(:,23,125) = +0.91850*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(KET,K125) = +0.34740*K125*<OLN>*<NO3>
 PTERMS(:,24,125) = +0.34740*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(ONIT,K125) = +0.25928*K125*<OLN>*<NO3>
 PTERMS(:,26,125) = +0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(OLN,K125) = -K125*<OLN>*<NO3>
 PTERMS(:,40,125) = -TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(HO2,K126) = -K126*<XO2>*<HO2>
 PTERMS(:,15,126) = -TPK%K126(:)*PCONC(:,41)*PCONC(:,15)
!
!PTERMS(OP2,K126) = +1.00524*K126*<XO2>*<HO2>
 PTERMS(:,29,126) = +1.00524*TPK%K126(:)*PCONC(:,41)*PCONC(:,15)
!
!PTERMS(XO2,K126) = -K126*<XO2>*<HO2>
 PTERMS(:,41,126) = -TPK%K126(:)*PCONC(:,41)*PCONC(:,15)
!
!PTERMS(HO2,K127) = +K127*<XO2>*<MO2>
 PTERMS(:,15,127) = +TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(HCHO,K127) = +K127*<XO2>*<MO2>
 PTERMS(:,22,127) = +TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(MO2,K127) = -K127*<XO2>*<MO2>
 PTERMS(:,32,127) = -TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(XO2,K127) = -K127*<XO2>*<MO2>
 PTERMS(:,41,127) = -TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(MO2,K128) = +K128*<XO2>*<CARBOP>
 PTERMS(:,32,128) = +TPK%K128(:)*PCONC(:,41)*PCONC(:,39)
!
!PTERMS(CARBOP,K128) = -K128*<XO2>*<CARBOP>
 PTERMS(:,39,128) = -TPK%K128(:)*PCONC(:,41)*PCONC(:,39)
!
!PTERMS(XO2,K128) = -K128*<XO2>*<CARBOP>
 PTERMS(:,41,128) = -TPK%K128(:)*PCONC(:,41)*PCONC(:,39)
!
!PTERMS(XO2,K129) = -K129*<XO2>*<XO2>
 PTERMS(:,41,129) = -TPK%K129(:)*PCONC(:,41)*PCONC(:,41)
!
!PTERMS(NO,K130) = -K130*<XO2>*<NO>
 PTERMS(:,3,130) = -TPK%K130(:)*PCONC(:,41)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT29
!
SUBROUTINE SUBT30
!
!Indices 601 a 620
!
!PTERMS(NO2,K130) = +K130*<XO2>*<NO>
 PTERMS(:,4,130) = +TPK%K130(:)*PCONC(:,41)*PCONC(:,3)
!
!PTERMS(XO2,K130) = -K130*<XO2>*<NO>
 PTERMS(:,41,130) = -TPK%K130(:)*PCONC(:,41)*PCONC(:,3)
!
!PTERMS(NO2,K131) = +K131*<XO2>*<NO3>
 PTERMS(:,4,131) = +TPK%K131(:)*PCONC(:,41)*PCONC(:,5)
!
!PTERMS(NO3,K131) = -K131*<XO2>*<NO3>
 PTERMS(:,5,131) = -TPK%K131(:)*PCONC(:,41)*PCONC(:,5)
!
!PTERMS(XO2,K131) = -K131*<XO2>*<NO3>
 PTERMS(:,41,131) = -TPK%K131(:)*PCONC(:,41)*PCONC(:,5)
!
!PTERMS(SULF,K132) = -K132*<SULF>
 PTERMS(:,12,132) = -TPK%K132(:)*PCONC(:,12)
!
!PTERMS(O3,KTC1) = -KTC1*<O3>
 PTERMS(:,1,133) = -TPK%KTC1(:)*PCONC(:,1)
!
!PTERMS(WC_O3,KTC1) = +KTC1*<O3>
 PTERMS(:,42,133) = +TPK%KTC1(:)*PCONC(:,1)
!
!PTERMS(H2O2,KTC2) = -KTC2*<H2O2>
 PTERMS(:,2,134) = -TPK%KTC2(:)*PCONC(:,2)
!
!PTERMS(WC_H2O2,KTC2) = +KTC2*<H2O2>
 PTERMS(:,43,134) = +TPK%KTC2(:)*PCONC(:,2)
!
!PTERMS(NO,KTC3) = -KTC3*<NO>
 PTERMS(:,3,135) = -TPK%KTC3(:)*PCONC(:,3)
!
!PTERMS(WC_NO,KTC3) = +KTC3*<NO>
 PTERMS(:,44,135) = +TPK%KTC3(:)*PCONC(:,3)
!
!PTERMS(NO2,KTC4) = -KTC4*<NO2>
 PTERMS(:,4,136) = -TPK%KTC4(:)*PCONC(:,4)
!
!PTERMS(WC_NO2,KTC4) = +KTC4*<NO2>
 PTERMS(:,45,136) = +TPK%KTC4(:)*PCONC(:,4)
!
!PTERMS(NO3,KTC5) = -KTC5*<NO3>
 PTERMS(:,5,137) = -TPK%KTC5(:)*PCONC(:,5)
!
!PTERMS(WC_NO3,KTC5) = +KTC5*<NO3>
 PTERMS(:,46,137) = +TPK%KTC5(:)*PCONC(:,5)
!
!PTERMS(N2O5,KTC6) = -KTC6*<N2O5>
 PTERMS(:,6,138) = -TPK%KTC6(:)*PCONC(:,6)
!
!PTERMS(WC_N2O5,KTC6) = +KTC6*<N2O5>
 PTERMS(:,47,138) = +TPK%KTC6(:)*PCONC(:,6)
!
!PTERMS(HONO,KTC7) = -KTC7*<HONO>
 PTERMS(:,7,139) = -TPK%KTC7(:)*PCONC(:,7)
!
!PTERMS(WC_HONO,KTC7) = +KTC7*<HONO>
 PTERMS(:,48,139) = +TPK%KTC7(:)*PCONC(:,7)
!
!
RETURN
END SUBROUTINE SUBT30
!
SUBROUTINE SUBT31
!
!Indices 621 a 640
!
!PTERMS(HNO3,KTC8) = -KTC8*<HNO3>
 PTERMS(:,8,140) = -TPK%KTC8(:)*PCONC(:,8)
!
!PTERMS(WC_HNO3,KTC8) = +KTC8*<HNO3>
 PTERMS(:,49,140) = +TPK%KTC8(:)*PCONC(:,8)
!
!PTERMS(HNO4,KTC9) = -KTC9*<HNO4>
 PTERMS(:,9,141) = -TPK%KTC9(:)*PCONC(:,9)
!
!PTERMS(WC_HNO4,KTC9) = +KTC9*<HNO4>
 PTERMS(:,50,141) = +TPK%KTC9(:)*PCONC(:,9)
!
!PTERMS(NH3,KTC10) = -KTC10*<NH3>
 PTERMS(:,10,142) = -TPK%KTC10(:)*PCONC(:,10)
!
!PTERMS(WC_NH3,KTC10) = +KTC10*<NH3>
 PTERMS(:,51,142) = +TPK%KTC10(:)*PCONC(:,10)
!
!PTERMS(OH,KTC11) = -KTC11*<OH>
 PTERMS(:,14,143) = -TPK%KTC11(:)*PCONC(:,14)
!
!PTERMS(WC_OH,KTC11) = +KTC11*<OH>
 PTERMS(:,52,143) = +TPK%KTC11(:)*PCONC(:,14)
!
!PTERMS(HO2,KTC12) = -KTC12*<HO2>
 PTERMS(:,15,144) = -TPK%KTC12(:)*PCONC(:,15)
!
!PTERMS(WC_HO2,KTC12) = +KTC12*<HO2>
 PTERMS(:,53,144) = +TPK%KTC12(:)*PCONC(:,15)
!
!PTERMS(WC_CO2,KTC13) = +KTC13*<CO2>
 PTERMS(:,54,145) = +TPK%KTC13(:)*TPK%CO2(:)
!
!PTERMS(SO2,KTC14) = -KTC14*<SO2>
 PTERMS(:,11,146) = -TPK%KTC14(:)*PCONC(:,11)
!
!PTERMS(WC_SO2,KTC14) = +KTC14*<SO2>
 PTERMS(:,55,146) = +TPK%KTC14(:)*PCONC(:,11)
!
!PTERMS(SULF,KTC15) = -KTC15*<SULF>
 PTERMS(:,12,147) = -TPK%KTC15(:)*PCONC(:,12)
!
!PTERMS(WC_SULF,KTC15) = +KTC15*<SULF>
 PTERMS(:,56,147) = +TPK%KTC15(:)*PCONC(:,12)
!
!PTERMS(HCHO,KTC16) = -KTC16*<HCHO>
 PTERMS(:,22,148) = -TPK%KTC16(:)*PCONC(:,22)
!
!PTERMS(WC_HCHO,KTC16) = +KTC16*<HCHO>
 PTERMS(:,57,148) = +TPK%KTC16(:)*PCONC(:,22)
!
!PTERMS(ORA1,KTC17) = -KTC17*<ORA1>
 PTERMS(:,30,149) = -TPK%KTC17(:)*PCONC(:,30)
!
!PTERMS(WC_ORA1,KTC17) = +KTC17*<ORA1>
 PTERMS(:,58,149) = +TPK%KTC17(:)*PCONC(:,30)
!
!PTERMS(ORA2,KTC18) = -KTC18*<ORA2>
 PTERMS(:,31,150) = -TPK%KTC18(:)*PCONC(:,31)
!
!
RETURN
END SUBROUTINE SUBT31
!
SUBROUTINE SUBT32
!
!Indices 641 a 660
!
!PTERMS(WC_ORA2,KTC18) = +KTC18*<ORA2>
 PTERMS(:,59,150) = +TPK%KTC18(:)*PCONC(:,31)
!
!PTERMS(MO2,KTC19) = -KTC19*<MO2>
 PTERMS(:,32,151) = -TPK%KTC19(:)*PCONC(:,32)
!
!PTERMS(WC_MO2,KTC19) = +KTC19*<MO2>
 PTERMS(:,60,151) = +TPK%KTC19(:)*PCONC(:,32)
!
!PTERMS(OP1,KTC20) = -KTC20*<OP1>
 PTERMS(:,28,152) = -TPK%KTC20(:)*PCONC(:,28)
!
!PTERMS(WC_OP1,KTC20) = +KTC20*<OP1>
 PTERMS(:,61,152) = +TPK%KTC20(:)*PCONC(:,28)
!
!PTERMS(O3,KTC21) = +KTC21*<WC_O3>
 PTERMS(:,1,153) = +TPK%KTC21(:)*PCONC(:,42)
!
!PTERMS(WC_O3,KTC21) = -KTC21*<WC_O3>
 PTERMS(:,42,153) = -TPK%KTC21(:)*PCONC(:,42)
!
!PTERMS(H2O2,KTC22) = +KTC22*<WC_H2O2>
 PTERMS(:,2,154) = +TPK%KTC22(:)*PCONC(:,43)
!
!PTERMS(WC_H2O2,KTC22) = -KTC22*<WC_H2O2>
 PTERMS(:,43,154) = -TPK%KTC22(:)*PCONC(:,43)
!
!PTERMS(NO,KTC23) = +KTC23*<WC_NO>
 PTERMS(:,3,155) = +TPK%KTC23(:)*PCONC(:,44)
!
!PTERMS(WC_NO,KTC23) = -KTC23*<WC_NO>
 PTERMS(:,44,155) = -TPK%KTC23(:)*PCONC(:,44)
!
!PTERMS(NO2,KTC24) = +KTC24*<WC_NO2>
 PTERMS(:,4,156) = +TPK%KTC24(:)*PCONC(:,45)
!
!PTERMS(WC_NO2,KTC24) = -KTC24*<WC_NO2>
 PTERMS(:,45,156) = -TPK%KTC24(:)*PCONC(:,45)
!
!PTERMS(NO3,KTC25) = +KTC25*<WC_NO3>
 PTERMS(:,5,157) = +TPK%KTC25(:)*PCONC(:,46)
!
!PTERMS(WC_NO3,KTC25) = -KTC25*<WC_NO3>
 PTERMS(:,46,157) = -TPK%KTC25(:)*PCONC(:,46)
!
!PTERMS(N2O5,KTC26) = +KTC26*<WC_N2O5>
 PTERMS(:,6,158) = +TPK%KTC26(:)*PCONC(:,47)
!
!PTERMS(WC_N2O5,KTC26) = -KTC26*<WC_N2O5>
 PTERMS(:,47,158) = -TPK%KTC26(:)*PCONC(:,47)
!
!PTERMS(HONO,KTC27) = +KTC27*<WC_HONO>
 PTERMS(:,7,159) = +TPK%KTC27(:)*PCONC(:,48)
!
!PTERMS(WC_HONO,KTC27) = -KTC27*<WC_HONO>
 PTERMS(:,48,159) = -TPK%KTC27(:)*PCONC(:,48)
!
!PTERMS(HNO3,KTC28) = +KTC28*<WC_HNO3>
 PTERMS(:,8,160) = +TPK%KTC28(:)*PCONC(:,49)
!
!
RETURN
END SUBROUTINE SUBT32
!
SUBROUTINE SUBT33
!
!Indices 661 a 680
!
!PTERMS(WC_HNO3,KTC28) = -KTC28*<WC_HNO3>
 PTERMS(:,49,160) = -TPK%KTC28(:)*PCONC(:,49)
!
!PTERMS(HNO4,KTC29) = +KTC29*<WC_HNO4>
 PTERMS(:,9,161) = +TPK%KTC29(:)*PCONC(:,50)
!
!PTERMS(WC_HNO4,KTC29) = -KTC29*<WC_HNO4>
 PTERMS(:,50,161) = -TPK%KTC29(:)*PCONC(:,50)
!
!PTERMS(NH3,KTC30) = +KTC30*<WC_NH3>
 PTERMS(:,10,162) = +TPK%KTC30(:)*PCONC(:,51)
!
!PTERMS(WC_NH3,KTC30) = -KTC30*<WC_NH3>
 PTERMS(:,51,162) = -TPK%KTC30(:)*PCONC(:,51)
!
!PTERMS(OH,KTC31) = +KTC31*<WC_OH>
 PTERMS(:,14,163) = +TPK%KTC31(:)*PCONC(:,52)
!
!PTERMS(WC_OH,KTC31) = -KTC31*<WC_OH>
 PTERMS(:,52,163) = -TPK%KTC31(:)*PCONC(:,52)
!
!PTERMS(HO2,KTC32) = +KTC32*<WC_HO2>
 PTERMS(:,15,164) = +TPK%KTC32(:)*PCONC(:,53)
!
!PTERMS(WC_HO2,KTC32) = -KTC32*<WC_HO2>
 PTERMS(:,53,164) = -TPK%KTC32(:)*PCONC(:,53)
!
!PTERMS(WC_CO2,KTC33) = -KTC33*<WC_CO2>
 PTERMS(:,54,165) = -TPK%KTC33(:)*PCONC(:,54)
!
!PTERMS(SO2,KTC34) = +KTC34*<WC_SO2>
 PTERMS(:,11,166) = +TPK%KTC34(:)*PCONC(:,55)
!
!PTERMS(WC_SO2,KTC34) = -KTC34*<WC_SO2>
 PTERMS(:,55,166) = -TPK%KTC34(:)*PCONC(:,55)
!
!PTERMS(SULF,KTC35) = +KTC35*<WC_SULF>
 PTERMS(:,12,167) = +TPK%KTC35(:)*PCONC(:,56)
!
!PTERMS(WC_SULF,KTC35) = -KTC35*<WC_SULF>
 PTERMS(:,56,167) = -TPK%KTC35(:)*PCONC(:,56)
!
!PTERMS(HCHO,KTC36) = +KTC36*<WC_HCHO>
 PTERMS(:,22,168) = +TPK%KTC36(:)*PCONC(:,57)
!
!PTERMS(WC_HCHO,KTC36) = -KTC36*<WC_HCHO>
 PTERMS(:,57,168) = -TPK%KTC36(:)*PCONC(:,57)
!
!PTERMS(ORA1,KTC37) = +KTC37*<WC_ORA1>
 PTERMS(:,30,169) = +TPK%KTC37(:)*PCONC(:,58)
!
!PTERMS(WC_ORA1,KTC37) = -KTC37*<WC_ORA1>
 PTERMS(:,58,169) = -TPK%KTC37(:)*PCONC(:,58)
!
!PTERMS(ORA2,KTC38) = +KTC38*<WC_ORA2>
 PTERMS(:,31,170) = +TPK%KTC38(:)*PCONC(:,59)
!
!PTERMS(WC_ORA2,KTC38) = -KTC38*<WC_ORA2>
 PTERMS(:,59,170) = -TPK%KTC38(:)*PCONC(:,59)
!
!
RETURN
END SUBROUTINE SUBT33
!
SUBROUTINE SUBT34
!
!Indices 681 a 700
!
!PTERMS(MO2,KTC39) = +KTC39*<WC_MO2>
 PTERMS(:,32,171) = +TPK%KTC39(:)*PCONC(:,60)
!
!PTERMS(WC_MO2,KTC39) = -KTC39*<WC_MO2>
 PTERMS(:,60,171) = -TPK%KTC39(:)*PCONC(:,60)
!
!PTERMS(OP1,KTC40) = +KTC40*<WC_OP1>
 PTERMS(:,28,172) = +TPK%KTC40(:)*PCONC(:,61)
!
!PTERMS(WC_OP1,KTC40) = -KTC40*<WC_OP1>
 PTERMS(:,61,172) = -TPK%KTC40(:)*PCONC(:,61)
!
!PTERMS(O3,KTR1) = -KTR1*<O3>
 PTERMS(:,1,173) = -TPK%KTR1(:)*PCONC(:,1)
!
!PTERMS(WR_O3,KTR1) = +KTR1*<O3>
 PTERMS(:,67,173) = +TPK%KTR1(:)*PCONC(:,1)
!
!PTERMS(H2O2,KTR2) = -KTR2*<H2O2>
 PTERMS(:,2,174) = -TPK%KTR2(:)*PCONC(:,2)
!
!PTERMS(WR_H2O2,KTR2) = +KTR2*<H2O2>
 PTERMS(:,68,174) = +TPK%KTR2(:)*PCONC(:,2)
!
!PTERMS(NO,KTR3) = -KTR3*<NO>
 PTERMS(:,3,175) = -TPK%KTR3(:)*PCONC(:,3)
!
!PTERMS(WR_NO,KTR3) = +KTR3*<NO>
 PTERMS(:,69,175) = +TPK%KTR3(:)*PCONC(:,3)
!
!PTERMS(NO2,KTR4) = -KTR4*<NO2>
 PTERMS(:,4,176) = -TPK%KTR4(:)*PCONC(:,4)
!
!PTERMS(WR_NO2,KTR4) = +KTR4*<NO2>
 PTERMS(:,70,176) = +TPK%KTR4(:)*PCONC(:,4)
!
!PTERMS(NO3,KTR5) = -KTR5*<NO3>
 PTERMS(:,5,177) = -TPK%KTR5(:)*PCONC(:,5)
!
!PTERMS(WR_NO3,KTR5) = +KTR5*<NO3>
 PTERMS(:,71,177) = +TPK%KTR5(:)*PCONC(:,5)
!
!PTERMS(N2O5,KTR6) = -KTR6*<N2O5>
 PTERMS(:,6,178) = -TPK%KTR6(:)*PCONC(:,6)
!
!PTERMS(WR_N2O5,KTR6) = +KTR6*<N2O5>
 PTERMS(:,72,178) = +TPK%KTR6(:)*PCONC(:,6)
!
!PTERMS(HONO,KTR7) = -KTR7*<HONO>
 PTERMS(:,7,179) = -TPK%KTR7(:)*PCONC(:,7)
!
!PTERMS(WR_HONO,KTR7) = +KTR7*<HONO>
 PTERMS(:,73,179) = +TPK%KTR7(:)*PCONC(:,7)
!
!PTERMS(HNO3,KTR8) = -KTR8*<HNO3>
 PTERMS(:,8,180) = -TPK%KTR8(:)*PCONC(:,8)
!
!PTERMS(WR_HNO3,KTR8) = +KTR8*<HNO3>
 PTERMS(:,74,180) = +TPK%KTR8(:)*PCONC(:,8)
!
!
RETURN
END SUBROUTINE SUBT34
!
SUBROUTINE SUBT35
!
!Indices 701 a 720
!
!PTERMS(HNO4,KTR9) = -KTR9*<HNO4>
 PTERMS(:,9,181) = -TPK%KTR9(:)*PCONC(:,9)
!
!PTERMS(WR_HNO4,KTR9) = +KTR9*<HNO4>
 PTERMS(:,75,181) = +TPK%KTR9(:)*PCONC(:,9)
!
!PTERMS(NH3,KTR10) = -KTR10*<NH3>
 PTERMS(:,10,182) = -TPK%KTR10(:)*PCONC(:,10)
!
!PTERMS(WR_NH3,KTR10) = +KTR10*<NH3>
 PTERMS(:,76,182) = +TPK%KTR10(:)*PCONC(:,10)
!
!PTERMS(OH,KTR11) = -KTR11*<OH>
 PTERMS(:,14,183) = -TPK%KTR11(:)*PCONC(:,14)
!
!PTERMS(WR_OH,KTR11) = +KTR11*<OH>
 PTERMS(:,77,183) = +TPK%KTR11(:)*PCONC(:,14)
!
!PTERMS(HO2,KTR12) = -KTR12*<HO2>
 PTERMS(:,15,184) = -TPK%KTR12(:)*PCONC(:,15)
!
!PTERMS(WR_HO2,KTR12) = +KTR12*<HO2>
 PTERMS(:,78,184) = +TPK%KTR12(:)*PCONC(:,15)
!
!PTERMS(WR_CO2,KTR13) = +KTR13*<CO2>
 PTERMS(:,79,185) = +TPK%KTR13(:)*TPK%CO2(:)
!
!PTERMS(SO2,KTR14) = -KTR14*<SO2>
 PTERMS(:,11,186) = -TPK%KTR14(:)*PCONC(:,11)
!
!PTERMS(WR_SO2,KTR14) = +KTR14*<SO2>
 PTERMS(:,80,186) = +TPK%KTR14(:)*PCONC(:,11)
!
!PTERMS(SULF,KTR15) = -KTR15*<SULF>
 PTERMS(:,12,187) = -TPK%KTR15(:)*PCONC(:,12)
!
!PTERMS(WR_SULF,KTR15) = +KTR15*<SULF>
 PTERMS(:,81,187) = +TPK%KTR15(:)*PCONC(:,12)
!
!PTERMS(HCHO,KTR16) = -KTR16*<HCHO>
 PTERMS(:,22,188) = -TPK%KTR16(:)*PCONC(:,22)
!
!PTERMS(WR_HCHO,KTR16) = +KTR16*<HCHO>
 PTERMS(:,82,188) = +TPK%KTR16(:)*PCONC(:,22)
!
!PTERMS(ORA1,KTR17) = -KTR17*<ORA1>
 PTERMS(:,30,189) = -TPK%KTR17(:)*PCONC(:,30)
!
!PTERMS(WR_ORA1,KTR17) = +KTR17*<ORA1>
 PTERMS(:,83,189) = +TPK%KTR17(:)*PCONC(:,30)
!
!PTERMS(ORA2,KTR18) = -KTR18*<ORA2>
 PTERMS(:,31,190) = -TPK%KTR18(:)*PCONC(:,31)
!
!PTERMS(WR_ORA2,KTR18) = +KTR18*<ORA2>
 PTERMS(:,84,190) = +TPK%KTR18(:)*PCONC(:,31)
!
!PTERMS(MO2,KTR19) = -KTR19*<MO2>
 PTERMS(:,32,191) = -TPK%KTR19(:)*PCONC(:,32)
!
!
RETURN
END SUBROUTINE SUBT35
!
SUBROUTINE SUBT36
!
!Indices 721 a 740
!
!PTERMS(WR_MO2,KTR19) = +KTR19*<MO2>
 PTERMS(:,85,191) = +TPK%KTR19(:)*PCONC(:,32)
!
!PTERMS(OP1,KTR20) = -KTR20*<OP1>
 PTERMS(:,28,192) = -TPK%KTR20(:)*PCONC(:,28)
!
!PTERMS(WR_OP1,KTR20) = +KTR20*<OP1>
 PTERMS(:,86,192) = +TPK%KTR20(:)*PCONC(:,28)
!
!PTERMS(O3,KTR21) = +KTR21*<WR_O3>
 PTERMS(:,1,193) = +TPK%KTR21(:)*PCONC(:,67)
!
!PTERMS(WR_O3,KTR21) = -KTR21*<WR_O3>
 PTERMS(:,67,193) = -TPK%KTR21(:)*PCONC(:,67)
!
!PTERMS(H2O2,KTR22) = +KTR22*<WR_H2O2>
 PTERMS(:,2,194) = +TPK%KTR22(:)*PCONC(:,68)
!
!PTERMS(WR_H2O2,KTR22) = -KTR22*<WR_H2O2>
 PTERMS(:,68,194) = -TPK%KTR22(:)*PCONC(:,68)
!
!PTERMS(NO,KTR23) = +KTR23*<WR_NO>
 PTERMS(:,3,195) = +TPK%KTR23(:)*PCONC(:,69)
!
!PTERMS(WR_NO,KTR23) = -KTR23*<WR_NO>
 PTERMS(:,69,195) = -TPK%KTR23(:)*PCONC(:,69)
!
!PTERMS(NO2,KTR24) = +KTR24*<WR_NO2>
 PTERMS(:,4,196) = +TPK%KTR24(:)*PCONC(:,70)
!
!PTERMS(WR_NO2,KTR24) = -KTR24*<WR_NO2>
 PTERMS(:,70,196) = -TPK%KTR24(:)*PCONC(:,70)
!
!PTERMS(NO3,KTR25) = +KTR25*<WR_NO3>
 PTERMS(:,5,197) = +TPK%KTR25(:)*PCONC(:,71)
!
!PTERMS(WR_NO3,KTR25) = -KTR25*<WR_NO3>
 PTERMS(:,71,197) = -TPK%KTR25(:)*PCONC(:,71)
!
!PTERMS(N2O5,KTR26) = +KTR26*<WR_N2O5>
 PTERMS(:,6,198) = +TPK%KTR26(:)*PCONC(:,72)
!
!PTERMS(WR_N2O5,KTR26) = -KTR26*<WR_N2O5>
 PTERMS(:,72,198) = -TPK%KTR26(:)*PCONC(:,72)
!
!PTERMS(HONO,KTR27) = +KTR27*<WR_HONO>
 PTERMS(:,7,199) = +TPK%KTR27(:)*PCONC(:,73)
!
!PTERMS(WR_HONO,KTR27) = -KTR27*<WR_HONO>
 PTERMS(:,73,199) = -TPK%KTR27(:)*PCONC(:,73)
!
!PTERMS(HNO3,KTR28) = +KTR28*<WR_HNO3>
 PTERMS(:,8,200) = +TPK%KTR28(:)*PCONC(:,74)
!
!PTERMS(WR_HNO3,KTR28) = -KTR28*<WR_HNO3>
 PTERMS(:,74,200) = -TPK%KTR28(:)*PCONC(:,74)
!
!PTERMS(HNO4,KTR29) = +KTR29*<WR_HNO4>
 PTERMS(:,9,201) = +TPK%KTR29(:)*PCONC(:,75)
!
!
RETURN
END SUBROUTINE SUBT36
!
SUBROUTINE SUBT37
!
!Indices 741 a 760
!
!PTERMS(WR_HNO4,KTR29) = -KTR29*<WR_HNO4>
 PTERMS(:,75,201) = -TPK%KTR29(:)*PCONC(:,75)
!
!PTERMS(NH3,KTR30) = +KTR30*<WR_NH3>
 PTERMS(:,10,202) = +TPK%KTR30(:)*PCONC(:,76)
!
!PTERMS(WR_NH3,KTR30) = -KTR30*<WR_NH3>
 PTERMS(:,76,202) = -TPK%KTR30(:)*PCONC(:,76)
!
!PTERMS(OH,KTR31) = +KTR31*<WR_OH>
 PTERMS(:,14,203) = +TPK%KTR31(:)*PCONC(:,77)
!
!PTERMS(WR_OH,KTR31) = -KTR31*<WR_OH>
 PTERMS(:,77,203) = -TPK%KTR31(:)*PCONC(:,77)
!
!PTERMS(HO2,KTR32) = +KTR32*<WR_HO2>
 PTERMS(:,15,204) = +TPK%KTR32(:)*PCONC(:,78)
!
!PTERMS(WR_HO2,KTR32) = -KTR32*<WR_HO2>
 PTERMS(:,78,204) = -TPK%KTR32(:)*PCONC(:,78)
!
!PTERMS(WR_CO2,KTR33) = -KTR33*<WR_CO2>
 PTERMS(:,79,205) = -TPK%KTR33(:)*PCONC(:,79)
!
!PTERMS(SO2,KTR34) = +KTR34*<WR_SO2>
 PTERMS(:,11,206) = +TPK%KTR34(:)*PCONC(:,80)
!
!PTERMS(WR_SO2,KTR34) = -KTR34*<WR_SO2>
 PTERMS(:,80,206) = -TPK%KTR34(:)*PCONC(:,80)
!
!PTERMS(SULF,KTR35) = +KTR35*<WR_SULF>
 PTERMS(:,12,207) = +TPK%KTR35(:)*PCONC(:,81)
!
!PTERMS(WR_SULF,KTR35) = -KTR35*<WR_SULF>
 PTERMS(:,81,207) = -TPK%KTR35(:)*PCONC(:,81)
!
!PTERMS(HCHO,KTR36) = +KTR36*<WR_HCHO>
 PTERMS(:,22,208) = +TPK%KTR36(:)*PCONC(:,82)
!
!PTERMS(WR_HCHO,KTR36) = -KTR36*<WR_HCHO>
 PTERMS(:,82,208) = -TPK%KTR36(:)*PCONC(:,82)
!
!PTERMS(ORA1,KTR37) = +KTR37*<WR_ORA1>
 PTERMS(:,30,209) = +TPK%KTR37(:)*PCONC(:,83)
!
!PTERMS(WR_ORA1,KTR37) = -KTR37*<WR_ORA1>
 PTERMS(:,83,209) = -TPK%KTR37(:)*PCONC(:,83)
!
!PTERMS(ORA2,KTR38) = +KTR38*<WR_ORA2>
 PTERMS(:,31,210) = +TPK%KTR38(:)*PCONC(:,84)
!
!PTERMS(WR_ORA2,KTR38) = -KTR38*<WR_ORA2>
 PTERMS(:,84,210) = -TPK%KTR38(:)*PCONC(:,84)
!
!PTERMS(MO2,KTR39) = +KTR39*<WR_MO2>
 PTERMS(:,32,211) = +TPK%KTR39(:)*PCONC(:,85)
!
!PTERMS(WR_MO2,KTR39) = -KTR39*<WR_MO2>
 PTERMS(:,85,211) = -TPK%KTR39(:)*PCONC(:,85)
!
!
RETURN
END SUBROUTINE SUBT37
!
SUBROUTINE SUBT38
!
!Indices 761 a 780
!
!PTERMS(OP1,KTR40) = +KTR40*<WR_OP1>
 PTERMS(:,28,212) = +TPK%KTR40(:)*PCONC(:,86)
!
!PTERMS(WR_OP1,KTR40) = -KTR40*<WR_OP1>
 PTERMS(:,86,212) = -TPK%KTR40(:)*PCONC(:,86)
!
!PTERMS(WC_H2O2,KC1) = -KC1*<WC_H2O2>
 PTERMS(:,43,213) = -TPK%KC1(:)*PCONC(:,43)
!
!PTERMS(WC_OH,KC1) = +KC1*<WC_H2O2>
 PTERMS(:,52,213) = +TPK%KC1(:)*PCONC(:,43)
!
!PTERMS(WC_H2O2,KC2) = +KC2*<WC_OH>*<WC_OH>
 PTERMS(:,43,214) = +TPK%KC2(:)*PCONC(:,52)*PCONC(:,52)
!
!PTERMS(WC_OH,KC2) = -KC2*<WC_OH>*<WC_OH>
 PTERMS(:,52,214) = -TPK%KC2(:)*PCONC(:,52)*PCONC(:,52)
!
!PTERMS(WC_OH,KC3) = -KC3*<WC_OH>*<WC_HO2>
 PTERMS(:,52,215) = -TPK%KC3(:)*PCONC(:,52)*PCONC(:,53)
!
!PTERMS(WC_HO2,KC3) = -KC3*<WC_OH>*<WC_HO2>
 PTERMS(:,53,215) = -TPK%KC3(:)*PCONC(:,52)*PCONC(:,53)
!
!PTERMS(WC_H2O2,KC4) = -KC4*<WC_H2O2>*<WC_OH>
 PTERMS(:,43,216) = -TPK%KC4(:)*PCONC(:,43)*PCONC(:,52)
!
!PTERMS(WC_OH,KC4) = -KC4*<WC_H2O2>*<WC_OH>
 PTERMS(:,52,216) = -TPK%KC4(:)*PCONC(:,43)*PCONC(:,52)
!
!PTERMS(WC_HO2,KC4) = +KC4*<WC_H2O2>*<WC_OH>
 PTERMS(:,53,216) = +TPK%KC4(:)*PCONC(:,43)*PCONC(:,52)
!
!PTERMS(WC_H2O2,KC5) = +KC5*<WC_HO2>*<WC_HO2>
 PTERMS(:,43,217) = +TPK%KC5(:)*PCONC(:,53)*PCONC(:,53)
!
!PTERMS(WC_HO2,KC5) = -KC5*<WC_HO2>*<WC_HO2>
 PTERMS(:,53,217) = -TPK%KC5(:)*PCONC(:,53)*PCONC(:,53)
!
!PTERMS(WC_O3,KC6) = -KC6*<WC_O3>*<WC_HO2>
 PTERMS(:,42,218) = -TPK%KC6(:)*PCONC(:,42)*PCONC(:,53)
!
!PTERMS(WC_OH,KC6) = +KC6*<WC_O3>*<WC_HO2>
 PTERMS(:,52,218) = +TPK%KC6(:)*PCONC(:,42)*PCONC(:,53)
!
!PTERMS(WC_HO2,KC6) = -KC6*<WC_O3>*<WC_HO2>
 PTERMS(:,53,218) = -TPK%KC6(:)*PCONC(:,42)*PCONC(:,53)
!
!PTERMS(WC_OH,KC7) = -KC7*<WC_OH>*<WC_SO2>
 PTERMS(:,52,219) = -TPK%KC7(:)*PCONC(:,52)*PCONC(:,55)
!
!PTERMS(WC_SO2,KC7) = -KC7*<WC_OH>*<WC_SO2>
 PTERMS(:,55,219) = -TPK%KC7(:)*PCONC(:,52)*PCONC(:,55)
!
!PTERMS(WC_ASO3,KC7) = +KC7*<WC_OH>*<WC_SO2>
 PTERMS(:,62,219) = +TPK%KC7(:)*PCONC(:,52)*PCONC(:,55)
!
!PTERMS(WC_NO2,KC8) = +KC8*<WC_HONO>*<WC_OH>
 PTERMS(:,45,220) = +TPK%KC8(:)*PCONC(:,48)*PCONC(:,52)
!
!
RETURN
END SUBROUTINE SUBT38
!
SUBROUTINE SUBT39
!
!Indices 781 a 800
!
!PTERMS(WC_HONO,KC8) = -KC8*<WC_HONO>*<WC_OH>
 PTERMS(:,48,220) = -TPK%KC8(:)*PCONC(:,48)*PCONC(:,52)
!
!PTERMS(WC_OH,KC8) = -KC8*<WC_HONO>*<WC_OH>
 PTERMS(:,52,220) = -TPK%KC8(:)*PCONC(:,48)*PCONC(:,52)
!
!PTERMS(WC_NO2,KC9) = -KC9*<WC_NO2>*<WC_HO2>
 PTERMS(:,45,221) = -TPK%KC9(:)*PCONC(:,45)*PCONC(:,53)
!
!PTERMS(WC_HNO4,KC9) = +KC9*<WC_NO2>*<WC_HO2>
 PTERMS(:,50,221) = +TPK%KC9(:)*PCONC(:,45)*PCONC(:,53)
!
!PTERMS(WC_HO2,KC9) = -KC9*<WC_NO2>*<WC_HO2>
 PTERMS(:,53,221) = -TPK%KC9(:)*PCONC(:,45)*PCONC(:,53)
!
!PTERMS(WC_NO2,KC10) = +KC10*<WC_HNO4>
 PTERMS(:,45,222) = +TPK%KC10(:)*PCONC(:,50)
!
!PTERMS(WC_HNO4,KC10) = -KC10*<WC_HNO4>
 PTERMS(:,50,222) = -TPK%KC10(:)*PCONC(:,50)
!
!PTERMS(WC_HO2,KC10) = +KC10*<WC_HNO4>
 PTERMS(:,53,222) = +TPK%KC10(:)*PCONC(:,50)
!
!PTERMS(WC_HONO,KC11) = +KC11*<WC_HNO4>
 PTERMS(:,48,223) = +TPK%KC11(:)*PCONC(:,50)
!
!PTERMS(WC_HNO4,KC11) = -KC11*<WC_HNO4>
 PTERMS(:,50,223) = -TPK%KC11(:)*PCONC(:,50)
!
!PTERMS(WC_HNO3,KC12) = +KC12*<WC_HNO4>*<WC_SO2>
 PTERMS(:,49,224) = +TPK%KC12(:)*PCONC(:,50)*PCONC(:,55)
!
!PTERMS(WC_HNO4,KC12) = -KC12*<WC_HNO4>*<WC_SO2>
 PTERMS(:,50,224) = -TPK%KC12(:)*PCONC(:,50)*PCONC(:,55)
!
!PTERMS(WC_SO2,KC12) = -KC12*<WC_HNO4>*<WC_SO2>
 PTERMS(:,55,224) = -TPK%KC12(:)*PCONC(:,50)*PCONC(:,55)
!
!PTERMS(WC_SULF,KC12) = +KC12*<WC_HNO4>*<WC_SO2>
 PTERMS(:,56,224) = +TPK%KC12(:)*PCONC(:,50)*PCONC(:,55)
!
!PTERMS(WC_NO2,KC13) = +KC13*<WC_HNO3>
 PTERMS(:,45,225) = +TPK%KC13(:)*PCONC(:,49)
!
!PTERMS(WC_HNO3,KC13) = -KC13*<WC_HNO3>
 PTERMS(:,49,225) = -TPK%KC13(:)*PCONC(:,49)
!
!PTERMS(WC_OH,KC13) = +KC13*<WC_HNO3>
 PTERMS(:,52,225) = +TPK%KC13(:)*PCONC(:,49)
!
!PTERMS(WC_N2O5,KC14) = -KC14*<WC_N2O5>
 PTERMS(:,47,226) = -TPK%KC14(:)*PCONC(:,47)
!
!PTERMS(WC_HNO3,KC14) = +KC14*<WC_N2O5>
 PTERMS(:,49,226) = +TPK%KC14(:)*PCONC(:,47)
!
!PTERMS(WC_NO3,KC15) = -KC15*<WC_NO3>*<WC_SULF>
 PTERMS(:,46,227) = -TPK%KC15(:)*PCONC(:,46)*PCONC(:,56)
!
!
RETURN
END SUBROUTINE SUBT39
!
SUBROUTINE SUBT40
!
!Indices 801 a 820
!
!PTERMS(WC_HNO3,KC15) = +KC15*<WC_NO3>*<WC_SULF>
 PTERMS(:,49,227) = +TPK%KC15(:)*PCONC(:,46)*PCONC(:,56)
!
!PTERMS(WC_SULF,KC15) = -KC15*<WC_NO3>*<WC_SULF>
 PTERMS(:,56,227) = -TPK%KC15(:)*PCONC(:,46)*PCONC(:,56)
!
!PTERMS(WC_ASO4,KC15) = +KC15*<WC_NO3>*<WC_SULF>
 PTERMS(:,63,227) = +TPK%KC15(:)*PCONC(:,46)*PCONC(:,56)
!
!PTERMS(WC_NO3,KC16) = -KC16*<WC_NO3>*<WC_SO2>
 PTERMS(:,46,228) = -TPK%KC16(:)*PCONC(:,46)*PCONC(:,55)
!
!PTERMS(WC_HNO3,KC16) = +KC16*<WC_NO3>*<WC_SO2>
 PTERMS(:,49,228) = +TPK%KC16(:)*PCONC(:,46)*PCONC(:,55)
!
!PTERMS(WC_SO2,KC16) = -KC16*<WC_NO3>*<WC_SO2>
 PTERMS(:,55,228) = -TPK%KC16(:)*PCONC(:,46)*PCONC(:,55)
!
!PTERMS(WC_ASO3,KC16) = +KC16*<WC_NO3>*<WC_SO2>
 PTERMS(:,62,228) = +TPK%KC16(:)*PCONC(:,46)*PCONC(:,55)
!
!PTERMS(WC_HO2,KC17) = +2.00*KC17*<WC_MO2>*<WC_MO2>
 PTERMS(:,53,229) = +2.00*TPK%KC17(:)*PCONC(:,60)*PCONC(:,60)
!
!PTERMS(WC_HCHO,KC17) = +2.00*KC17*<WC_MO2>*<WC_MO2>
 PTERMS(:,57,229) = +2.00*TPK%KC17(:)*PCONC(:,60)*PCONC(:,60)
!
!PTERMS(WC_MO2,KC17) = -KC17*<WC_MO2>*<WC_MO2>
 PTERMS(:,60,229) = -TPK%KC17(:)*PCONC(:,60)*PCONC(:,60)
!
!PTERMS(WC_SO2,KC18) = -KC18*<WC_MO2>*<WC_SO2>
 PTERMS(:,55,230) = -TPK%KC18(:)*PCONC(:,60)*PCONC(:,55)
!
!PTERMS(WC_MO2,KC18) = -KC18*<WC_MO2>*<WC_SO2>
 PTERMS(:,60,230) = -TPK%KC18(:)*PCONC(:,60)*PCONC(:,55)
!
!PTERMS(WC_OP1,KC18) = +KC18*<WC_MO2>*<WC_SO2>
 PTERMS(:,61,230) = +TPK%KC18(:)*PCONC(:,60)*PCONC(:,55)
!
!PTERMS(WC_ASO3,KC18) = +KC18*<WC_MO2>*<WC_SO2>
 PTERMS(:,62,230) = +TPK%KC18(:)*PCONC(:,60)*PCONC(:,55)
!
!PTERMS(WC_OH,KC19) = -KC19*<WC_HCHO>*<WC_OH>
 PTERMS(:,52,231) = -TPK%KC19(:)*PCONC(:,57)*PCONC(:,52)
!
!PTERMS(WC_HO2,KC19) = +KC19*<WC_HCHO>*<WC_OH>
 PTERMS(:,53,231) = +TPK%KC19(:)*PCONC(:,57)*PCONC(:,52)
!
!PTERMS(WC_HCHO,KC19) = -KC19*<WC_HCHO>*<WC_OH>
 PTERMS(:,57,231) = -TPK%KC19(:)*PCONC(:,57)*PCONC(:,52)
!
!PTERMS(WC_ORA1,KC19) = +KC19*<WC_HCHO>*<WC_OH>
 PTERMS(:,58,231) = +TPK%KC19(:)*PCONC(:,57)*PCONC(:,52)
!
!PTERMS(WC_OH,KC20) = -KC20*<WC_ORA1>*<WC_OH>
 PTERMS(:,52,232) = -TPK%KC20(:)*PCONC(:,58)*PCONC(:,52)
!
!PTERMS(WC_HO2,KC20) = +KC20*<WC_ORA1>*<WC_OH>
 PTERMS(:,53,232) = +TPK%KC20(:)*PCONC(:,58)*PCONC(:,52)
!
!
RETURN
END SUBROUTINE SUBT40
!
SUBROUTINE SUBT41
!
!Indices 821 a 840
!
!PTERMS(WC_CO2,KC20) = +KC20*<WC_ORA1>*<WC_OH>
 PTERMS(:,54,232) = +TPK%KC20(:)*PCONC(:,58)*PCONC(:,52)
!
!PTERMS(WC_ORA1,KC20) = -KC20*<WC_ORA1>*<WC_OH>
 PTERMS(:,58,232) = -TPK%KC20(:)*PCONC(:,58)*PCONC(:,52)
!
!PTERMS(WC_SO2,KC21) = -KC21*<WC_SO2>*<WC_HCHO>
 PTERMS(:,55,233) = -TPK%KC21(:)*PCONC(:,55)*PCONC(:,57)
!
!PTERMS(WC_HCHO,KC21) = -KC21*<WC_SO2>*<WC_HCHO>
 PTERMS(:,57,233) = -TPK%KC21(:)*PCONC(:,55)*PCONC(:,57)
!
!PTERMS(WC_AHMS,KC21) = +KC21*<WC_SO2>*<WC_HCHO>
 PTERMS(:,66,233) = +TPK%KC21(:)*PCONC(:,55)*PCONC(:,57)
!
!PTERMS(WC_SO2,KC22) = +KC22*<WC_AHMS>
 PTERMS(:,55,234) = +TPK%KC22(:)*PCONC(:,66)
!
!PTERMS(WC_HCHO,KC22) = +KC22*<WC_AHMS>
 PTERMS(:,57,234) = +TPK%KC22(:)*PCONC(:,66)
!
!PTERMS(WC_AHMS,KC22) = -KC22*<WC_AHMS>
 PTERMS(:,66,234) = -TPK%KC22(:)*PCONC(:,66)
!
!PTERMS(WC_OH,KC23) = -KC23*<WC_AHMS>*<WC_OH>
 PTERMS(:,52,235) = -TPK%KC23(:)*PCONC(:,66)*PCONC(:,52)
!
!PTERMS(WC_HO2,KC23) = +KC23*<WC_AHMS>*<WC_OH>
 PTERMS(:,53,235) = +TPK%KC23(:)*PCONC(:,66)*PCONC(:,52)
!
!PTERMS(WC_SO2,KC23) = +KC23*<WC_AHMS>*<WC_OH>
 PTERMS(:,55,235) = +TPK%KC23(:)*PCONC(:,66)*PCONC(:,52)
!
!PTERMS(WC_ORA1,KC23) = +KC23*<WC_AHMS>*<WC_OH>
 PTERMS(:,58,235) = +TPK%KC23(:)*PCONC(:,66)*PCONC(:,52)
!
!PTERMS(WC_AHMS,KC23) = -KC23*<WC_AHMS>*<WC_OH>
 PTERMS(:,66,235) = -TPK%KC23(:)*PCONC(:,66)*PCONC(:,52)
!
!PTERMS(WC_ASO3,KC24) = -KC24*<WC_ASO3>*<W_O2>
 PTERMS(:,62,236) = -TPK%KC24(:)*PCONC(:,62)*TPK%W_O2(:)
!
!PTERMS(WC_ASO5,KC24) = +KC24*<WC_ASO3>*<W_O2>
 PTERMS(:,64,236) = +TPK%KC24(:)*PCONC(:,62)*TPK%W_O2(:)
!
!PTERMS(WC_HO2,KC25) = -KC25*<WC_ASO5>*<WC_HO2>
 PTERMS(:,53,237) = -TPK%KC25(:)*PCONC(:,64)*PCONC(:,53)
!
!PTERMS(WC_ASO5,KC25) = -KC25*<WC_ASO5>*<WC_HO2>
 PTERMS(:,64,237) = -TPK%KC25(:)*PCONC(:,64)*PCONC(:,53)
!
!PTERMS(WC_AHSO5,KC25) = +KC25*<WC_ASO5>*<WC_HO2>
 PTERMS(:,65,237) = +TPK%KC25(:)*PCONC(:,64)*PCONC(:,53)
!
!PTERMS(WC_ASO4,KC26) = +KC26*<WC_ASO5>*<WC_ASO5>
 PTERMS(:,63,238) = +TPK%KC26(:)*PCONC(:,64)*PCONC(:,64)
!
!PTERMS(WC_ASO5,KC26) = -KC26*<WC_ASO5>*<WC_ASO5>
 PTERMS(:,64,238) = -TPK%KC26(:)*PCONC(:,64)*PCONC(:,64)
!
!
RETURN
END SUBROUTINE SUBT41
!
SUBROUTINE SUBT42
!
!Indices 841 a 860
!
!PTERMS(WC_SO2,KC27) = -KC27*<WC_AHSO5>*<WC_SO2>
 PTERMS(:,55,239) = -TPK%KC27(:)*PCONC(:,65)*PCONC(:,55)
!
!PTERMS(WC_SULF,KC27) = +2.00*KC27*<WC_AHSO5>*<WC_SO2>
 PTERMS(:,56,239) = +2.00*TPK%KC27(:)*PCONC(:,65)*PCONC(:,55)
!
!PTERMS(WC_AHSO5,KC27) = -KC27*<WC_AHSO5>*<WC_SO2>
 PTERMS(:,65,239) = -TPK%KC27(:)*PCONC(:,65)*PCONC(:,55)
!
!PTERMS(WC_OH,KC28) = +KC28*<WC_ASO4>
 PTERMS(:,52,240) = +TPK%KC28(:)*PCONC(:,63)
!
!PTERMS(WC_SULF,KC28) = +KC28*<WC_ASO4>
 PTERMS(:,56,240) = +TPK%KC28(:)*PCONC(:,63)
!
!PTERMS(WC_ASO4,KC28) = -KC28*<WC_ASO4>
 PTERMS(:,63,240) = -TPK%KC28(:)*PCONC(:,63)
!
!PTERMS(WC_O3,KC29) = -KC29*<WC_SO2>*<WC_O3>
 PTERMS(:,42,241) = -TPK%KC29(:)*PCONC(:,55)*PCONC(:,42)
!
!PTERMS(WC_SO2,KC29) = -KC29*<WC_SO2>*<WC_O3>
 PTERMS(:,55,241) = -TPK%KC29(:)*PCONC(:,55)*PCONC(:,42)
!
!PTERMS(WC_SULF,KC29) = +KC29*<WC_SO2>*<WC_O3>
 PTERMS(:,56,241) = +TPK%KC29(:)*PCONC(:,55)*PCONC(:,42)
!
!PTERMS(WC_H2O2,KC30) = -KC30*<WC_SO2>*<WC_H2O2>
 PTERMS(:,43,242) = -TPK%KC30(:)*PCONC(:,55)*PCONC(:,43)
!
!PTERMS(WC_SO2,KC30) = -KC30*<WC_SO2>*<WC_H2O2>
 PTERMS(:,55,242) = -TPK%KC30(:)*PCONC(:,55)*PCONC(:,43)
!
!PTERMS(WC_SULF,KC30) = +KC30*<WC_SO2>*<WC_H2O2>
 PTERMS(:,56,242) = +TPK%KC30(:)*PCONC(:,55)*PCONC(:,43)
!
!PTERMS(WR_H2O2,KR1) = -KR1*<WR_H2O2>
 PTERMS(:,68,243) = -TPK%KR1(:)*PCONC(:,68)
!
!PTERMS(WR_OH,KR1) = +KR1*<WR_H2O2>
 PTERMS(:,77,243) = +TPK%KR1(:)*PCONC(:,68)
!
!PTERMS(WR_H2O2,KR2) = +KR2*<WR_OH>*<WR_OH>
 PTERMS(:,68,244) = +TPK%KR2(:)*PCONC(:,77)*PCONC(:,77)
!
!PTERMS(WR_OH,KR2) = -KR2*<WR_OH>*<WR_OH>
 PTERMS(:,77,244) = -TPK%KR2(:)*PCONC(:,77)*PCONC(:,77)
!
!PTERMS(WR_OH,KR3) = -KR3*<WR_OH>*<WR_HO2>
 PTERMS(:,77,245) = -TPK%KR3(:)*PCONC(:,77)*PCONC(:,78)
!
!PTERMS(WR_HO2,KR3) = -KR3*<WR_OH>*<WR_HO2>
 PTERMS(:,78,245) = -TPK%KR3(:)*PCONC(:,77)*PCONC(:,78)
!
!PTERMS(WR_H2O2,KR4) = -KR4*<WR_H2O2>*<WR_OH>
 PTERMS(:,68,246) = -TPK%KR4(:)*PCONC(:,68)*PCONC(:,77)
!
!PTERMS(WR_OH,KR4) = -KR4*<WR_H2O2>*<WR_OH>
 PTERMS(:,77,246) = -TPK%KR4(:)*PCONC(:,68)*PCONC(:,77)
!
!
RETURN
END SUBROUTINE SUBT42
!
SUBROUTINE SUBT43
!
!Indices 861 a 880
!
!PTERMS(WR_HO2,KR4) = +KR4*<WR_H2O2>*<WR_OH>
 PTERMS(:,78,246) = +TPK%KR4(:)*PCONC(:,68)*PCONC(:,77)
!
!PTERMS(WR_H2O2,KR5) = +KR5*<WR_HO2>*<WR_HO2>
 PTERMS(:,68,247) = +TPK%KR5(:)*PCONC(:,78)*PCONC(:,78)
!
!PTERMS(WR_HO2,KR5) = -KR5*<WR_HO2>*<WR_HO2>
 PTERMS(:,78,247) = -TPK%KR5(:)*PCONC(:,78)*PCONC(:,78)
!
!PTERMS(WR_O3,KR6) = -KR6*<WR_O3>*<WR_HO2>
 PTERMS(:,67,248) = -TPK%KR6(:)*PCONC(:,67)*PCONC(:,78)
!
!PTERMS(WR_OH,KR6) = +KR6*<WR_O3>*<WR_HO2>
 PTERMS(:,77,248) = +TPK%KR6(:)*PCONC(:,67)*PCONC(:,78)
!
!PTERMS(WR_HO2,KR6) = -KR6*<WR_O3>*<WR_HO2>
 PTERMS(:,78,248) = -TPK%KR6(:)*PCONC(:,67)*PCONC(:,78)
!
!PTERMS(WR_OH,KR7) = -KR7*<WR_OH>*<WR_SO2>
 PTERMS(:,77,249) = -TPK%KR7(:)*PCONC(:,77)*PCONC(:,80)
!
!PTERMS(WR_SO2,KR7) = -KR7*<WR_OH>*<WR_SO2>
 PTERMS(:,80,249) = -TPK%KR7(:)*PCONC(:,77)*PCONC(:,80)
!
!PTERMS(WR_ASO3,KR7) = +KR7*<WR_OH>*<WR_SO2>
 PTERMS(:,87,249) = +TPK%KR7(:)*PCONC(:,77)*PCONC(:,80)
!
!PTERMS(WR_NO2,KR8) = +KR8*<WR_HONO>*<WR_OH>
 PTERMS(:,70,250) = +TPK%KR8(:)*PCONC(:,73)*PCONC(:,77)
!
!PTERMS(WR_HONO,KR8) = -KR8*<WR_HONO>*<WR_OH>
 PTERMS(:,73,250) = -TPK%KR8(:)*PCONC(:,73)*PCONC(:,77)
!
!PTERMS(WR_OH,KR8) = -KR8*<WR_HONO>*<WR_OH>
 PTERMS(:,77,250) = -TPK%KR8(:)*PCONC(:,73)*PCONC(:,77)
!
!PTERMS(WR_NO2,KR9) = -KR9*<WR_NO2>*<WR_HO2>
 PTERMS(:,70,251) = -TPK%KR9(:)*PCONC(:,70)*PCONC(:,78)
!
!PTERMS(WR_HNO4,KR9) = +KR9*<WR_NO2>*<WR_HO2>
 PTERMS(:,75,251) = +TPK%KR9(:)*PCONC(:,70)*PCONC(:,78)
!
!PTERMS(WR_HO2,KR9) = -KR9*<WR_NO2>*<WR_HO2>
 PTERMS(:,78,251) = -TPK%KR9(:)*PCONC(:,70)*PCONC(:,78)
!
!PTERMS(WR_NO2,KR10) = +KR10*<WR_HNO4>
 PTERMS(:,70,252) = +TPK%KR10(:)*PCONC(:,75)
!
!PTERMS(WR_HNO4,KR10) = -KR10*<WR_HNO4>
 PTERMS(:,75,252) = -TPK%KR10(:)*PCONC(:,75)
!
!PTERMS(WR_HO2,KR10) = +KR10*<WR_HNO4>
 PTERMS(:,78,252) = +TPK%KR10(:)*PCONC(:,75)
!
!PTERMS(WR_HONO,KR11) = +KR11*<WR_HNO4>
 PTERMS(:,73,253) = +TPK%KR11(:)*PCONC(:,75)
!
!PTERMS(WR_HNO4,KR11) = -KR11*<WR_HNO4>
 PTERMS(:,75,253) = -TPK%KR11(:)*PCONC(:,75)
!
!
RETURN
END SUBROUTINE SUBT43
!
SUBROUTINE SUBT44
!
!Indices 881 a 900
!
!PTERMS(WR_HNO3,KR12) = +KR12*<WR_HNO4>*<WR_SO2>
 PTERMS(:,74,254) = +TPK%KR12(:)*PCONC(:,75)*PCONC(:,80)
!
!PTERMS(WR_HNO4,KR12) = -KR12*<WR_HNO4>*<WR_SO2>
 PTERMS(:,75,254) = -TPK%KR12(:)*PCONC(:,75)*PCONC(:,80)
!
!PTERMS(WR_SO2,KR12) = -KR12*<WR_HNO4>*<WR_SO2>
 PTERMS(:,80,254) = -TPK%KR12(:)*PCONC(:,75)*PCONC(:,80)
!
!PTERMS(WR_SULF,KR12) = +KR12*<WR_HNO4>*<WR_SO2>
 PTERMS(:,81,254) = +TPK%KR12(:)*PCONC(:,75)*PCONC(:,80)
!
!PTERMS(WR_NO2,KR13) = +KR13*<WR_HNO3>
 PTERMS(:,70,255) = +TPK%KR13(:)*PCONC(:,74)
!
!PTERMS(WR_HNO3,KR13) = -KR13*<WR_HNO3>
 PTERMS(:,74,255) = -TPK%KR13(:)*PCONC(:,74)
!
!PTERMS(WR_OH,KR13) = +KR13*<WR_HNO3>
 PTERMS(:,77,255) = +TPK%KR13(:)*PCONC(:,74)
!
!PTERMS(WR_N2O5,KR14) = -KR14*<WR_N2O5>
 PTERMS(:,72,256) = -TPK%KR14(:)*PCONC(:,72)
!
!PTERMS(WR_HNO3,KR14) = +KR14*<WR_N2O5>
 PTERMS(:,74,256) = +TPK%KR14(:)*PCONC(:,72)
!
!PTERMS(WR_NO3,KR15) = -KR15*<WR_NO3>*<WR_SULF>
 PTERMS(:,71,257) = -TPK%KR15(:)*PCONC(:,71)*PCONC(:,81)
!
!PTERMS(WR_HNO3,KR15) = +KR15*<WR_NO3>*<WR_SULF>
 PTERMS(:,74,257) = +TPK%KR15(:)*PCONC(:,71)*PCONC(:,81)
!
!PTERMS(WR_SULF,KR15) = -KR15*<WR_NO3>*<WR_SULF>
 PTERMS(:,81,257) = -TPK%KR15(:)*PCONC(:,71)*PCONC(:,81)
!
!PTERMS(WR_ASO4,KR15) = +KR15*<WR_NO3>*<WR_SULF>
 PTERMS(:,88,257) = +TPK%KR15(:)*PCONC(:,71)*PCONC(:,81)
!
!PTERMS(WR_NO3,KR16) = -KR16*<WR_NO3>*<WR_SO2>
 PTERMS(:,71,258) = -TPK%KR16(:)*PCONC(:,71)*PCONC(:,80)
!
!PTERMS(WR_HNO3,KR16) = +KR16*<WR_NO3>*<WR_SO2>
 PTERMS(:,74,258) = +TPK%KR16(:)*PCONC(:,71)*PCONC(:,80)
!
!PTERMS(WR_SO2,KR16) = -KR16*<WR_NO3>*<WR_SO2>
 PTERMS(:,80,258) = -TPK%KR16(:)*PCONC(:,71)*PCONC(:,80)
!
!PTERMS(WR_ASO3,KR16) = +KR16*<WR_NO3>*<WR_SO2>
 PTERMS(:,87,258) = +TPK%KR16(:)*PCONC(:,71)*PCONC(:,80)
!
!PTERMS(WR_HO2,KR17) = +2.00*KR17*<WR_MO2>*<WR_MO2>
 PTERMS(:,78,259) = +2.00*TPK%KR17(:)*PCONC(:,85)*PCONC(:,85)
!
!PTERMS(WR_HCHO,KR17) = +2.00*KR17*<WR_MO2>*<WR_MO2>
 PTERMS(:,82,259) = +2.00*TPK%KR17(:)*PCONC(:,85)*PCONC(:,85)
!
!PTERMS(WR_MO2,KR17) = -KR17*<WR_MO2>*<WR_MO2>
 PTERMS(:,85,259) = -TPK%KR17(:)*PCONC(:,85)*PCONC(:,85)
!
!
RETURN
END SUBROUTINE SUBT44
!
SUBROUTINE SUBT45
!
!Indices 901 a 920
!
!PTERMS(WR_SO2,KR18) = -KR18*<WR_MO2>*<WR_SO2>
 PTERMS(:,80,260) = -TPK%KR18(:)*PCONC(:,85)*PCONC(:,80)
!
!PTERMS(WR_MO2,KR18) = -KR18*<WR_MO2>*<WR_SO2>
 PTERMS(:,85,260) = -TPK%KR18(:)*PCONC(:,85)*PCONC(:,80)
!
!PTERMS(WR_OP1,KR18) = +KR18*<WR_MO2>*<WR_SO2>
 PTERMS(:,86,260) = +TPK%KR18(:)*PCONC(:,85)*PCONC(:,80)
!
!PTERMS(WR_ASO3,KR18) = +KR18*<WR_MO2>*<WR_SO2>
 PTERMS(:,87,260) = +TPK%KR18(:)*PCONC(:,85)*PCONC(:,80)
!
!PTERMS(WR_OH,KR19) = -KR19*<WR_HCHO>*<WR_OH>
 PTERMS(:,77,261) = -TPK%KR19(:)*PCONC(:,82)*PCONC(:,77)
!
!PTERMS(WR_HO2,KR19) = +KR19*<WR_HCHO>*<WR_OH>
 PTERMS(:,78,261) = +TPK%KR19(:)*PCONC(:,82)*PCONC(:,77)
!
!PTERMS(WR_HCHO,KR19) = -KR19*<WR_HCHO>*<WR_OH>
 PTERMS(:,82,261) = -TPK%KR19(:)*PCONC(:,82)*PCONC(:,77)
!
!PTERMS(WR_ORA1,KR19) = +KR19*<WR_HCHO>*<WR_OH>
 PTERMS(:,83,261) = +TPK%KR19(:)*PCONC(:,82)*PCONC(:,77)
!
!PTERMS(WR_OH,KR20) = -KR20*<WR_ORA1>*<WR_OH>
 PTERMS(:,77,262) = -TPK%KR20(:)*PCONC(:,83)*PCONC(:,77)
!
!PTERMS(WR_HO2,KR20) = +KR20*<WR_ORA1>*<WR_OH>
 PTERMS(:,78,262) = +TPK%KR20(:)*PCONC(:,83)*PCONC(:,77)
!
!PTERMS(WR_CO2,KR20) = +KR20*<WR_ORA1>*<WR_OH>
 PTERMS(:,79,262) = +TPK%KR20(:)*PCONC(:,83)*PCONC(:,77)
!
!PTERMS(WR_ORA1,KR20) = -KR20*<WR_ORA1>*<WR_OH>
 PTERMS(:,83,262) = -TPK%KR20(:)*PCONC(:,83)*PCONC(:,77)
!
!PTERMS(WR_SO2,KR21) = -KR21*<WR_SO2>*<WR_HCHO>
 PTERMS(:,80,263) = -TPK%KR21(:)*PCONC(:,80)*PCONC(:,82)
!
!PTERMS(WR_HCHO,KR21) = -KR21*<WR_SO2>*<WR_HCHO>
 PTERMS(:,82,263) = -TPK%KR21(:)*PCONC(:,80)*PCONC(:,82)
!
!PTERMS(WR_AHMS,KR21) = +KR21*<WR_SO2>*<WR_HCHO>
 PTERMS(:,91,263) = +TPK%KR21(:)*PCONC(:,80)*PCONC(:,82)
!
!PTERMS(WR_SO2,KR22) = +KR22*<WR_AHMS>
 PTERMS(:,80,264) = +TPK%KR22(:)*PCONC(:,91)
!
!PTERMS(WR_HCHO,KR22) = +KR22*<WR_AHMS>
 PTERMS(:,82,264) = +TPK%KR22(:)*PCONC(:,91)
!
!PTERMS(WR_AHMS,KR22) = -KR22*<WR_AHMS>
 PTERMS(:,91,264) = -TPK%KR22(:)*PCONC(:,91)
!
!PTERMS(WR_OH,KR23) = -KR23*<WR_AHMS>*<WR_OH>
 PTERMS(:,77,265) = -TPK%KR23(:)*PCONC(:,91)*PCONC(:,77)
!
!PTERMS(WR_HO2,KR23) = +KR23*<WR_AHMS>*<WR_OH>
 PTERMS(:,78,265) = +TPK%KR23(:)*PCONC(:,91)*PCONC(:,77)
!
!
RETURN
END SUBROUTINE SUBT45
!
SUBROUTINE SUBT46
!
!Indices 921 a 940
!
!PTERMS(WR_SO2,KR23) = +KR23*<WR_AHMS>*<WR_OH>
 PTERMS(:,80,265) = +TPK%KR23(:)*PCONC(:,91)*PCONC(:,77)
!
!PTERMS(WR_ORA1,KR23) = +KR23*<WR_AHMS>*<WR_OH>
 PTERMS(:,83,265) = +TPK%KR23(:)*PCONC(:,91)*PCONC(:,77)
!
!PTERMS(WR_AHMS,KR23) = -KR23*<WR_AHMS>*<WR_OH>
 PTERMS(:,91,265) = -TPK%KR23(:)*PCONC(:,91)*PCONC(:,77)
!
!PTERMS(WR_ASO3,KR24) = -KR24*<WR_ASO3>*<W_O2>
 PTERMS(:,87,266) = -TPK%KR24(:)*PCONC(:,87)*TPK%W_O2(:)
!
!PTERMS(WR_ASO5,KR24) = +KR24*<WR_ASO3>*<W_O2>
 PTERMS(:,89,266) = +TPK%KR24(:)*PCONC(:,87)*TPK%W_O2(:)
!
!PTERMS(WR_HO2,KR25) = -KR25*<WR_ASO5>*<WR_HO2>
 PTERMS(:,78,267) = -TPK%KR25(:)*PCONC(:,89)*PCONC(:,78)
!
!PTERMS(WR_ASO5,KR25) = -KR25*<WR_ASO5>*<WR_HO2>
 PTERMS(:,89,267) = -TPK%KR25(:)*PCONC(:,89)*PCONC(:,78)
!
!PTERMS(WR_AHSO5,KR25) = +KR25*<WR_ASO5>*<WR_HO2>
 PTERMS(:,90,267) = +TPK%KR25(:)*PCONC(:,89)*PCONC(:,78)
!
!PTERMS(WR_ASO4,KR26) = +KR26*<WR_ASO5>*<WR_ASO5>
 PTERMS(:,88,268) = +TPK%KR26(:)*PCONC(:,89)*PCONC(:,89)
!
!PTERMS(WR_ASO5,KR26) = -KR26*<WR_ASO5>*<WR_ASO5>
 PTERMS(:,89,268) = -TPK%KR26(:)*PCONC(:,89)*PCONC(:,89)
!
!PTERMS(WR_SO2,KR27) = -KR27*<WR_AHSO5>*<WR_SO2>
 PTERMS(:,80,269) = -TPK%KR27(:)*PCONC(:,90)*PCONC(:,80)
!
!PTERMS(WR_SULF,KR27) = +2.00*KR27*<WR_AHSO5>*<WR_SO2>
 PTERMS(:,81,269) = +2.00*TPK%KR27(:)*PCONC(:,90)*PCONC(:,80)
!
!PTERMS(WR_AHSO5,KR27) = -KR27*<WR_AHSO5>*<WR_SO2>
 PTERMS(:,90,269) = -TPK%KR27(:)*PCONC(:,90)*PCONC(:,80)
!
!PTERMS(WR_OH,KR28) = +KR28*<WR_ASO4>
 PTERMS(:,77,270) = +TPK%KR28(:)*PCONC(:,88)
!
!PTERMS(WR_SULF,KR28) = +KR28*<WR_ASO4>
 PTERMS(:,81,270) = +TPK%KR28(:)*PCONC(:,88)
!
!PTERMS(WR_ASO4,KR28) = -KR28*<WR_ASO4>
 PTERMS(:,88,270) = -TPK%KR28(:)*PCONC(:,88)
!
!PTERMS(WR_O3,KR29) = -KR29*<WR_SO2>*<WR_O3>
 PTERMS(:,67,271) = -TPK%KR29(:)*PCONC(:,80)*PCONC(:,67)
!
!PTERMS(WR_SO2,KR29) = -KR29*<WR_SO2>*<WR_O3>
 PTERMS(:,80,271) = -TPK%KR29(:)*PCONC(:,80)*PCONC(:,67)
!
!PTERMS(WR_SULF,KR29) = +KR29*<WR_SO2>*<WR_O3>
 PTERMS(:,81,271) = +TPK%KR29(:)*PCONC(:,80)*PCONC(:,67)
!
!PTERMS(WR_H2O2,KR30) = -KR30*<WR_SO2>*<WR_H2O2>
 PTERMS(:,68,272) = -TPK%KR30(:)*PCONC(:,80)*PCONC(:,68)
!
!
RETURN
END SUBROUTINE SUBT46
!
SUBROUTINE SUBT47
!
!Indices 941 a 942
!
!PTERMS(WR_SO2,KR30) = -KR30*<WR_SO2>*<WR_H2O2>
 PTERMS(:,80,272) = -TPK%KR30(:)*PCONC(:,80)*PCONC(:,68)
!
!PTERMS(WR_SULF,KR30) = +KR30*<WR_SO2>*<WR_H2O2>
 PTERMS(:,81,272) = +TPK%KR30(:)*PCONC(:,80)*PCONC(:,68)
!
!
RETURN
END SUBROUTINE SUBT47
!
END SUBROUTINE CH_TERMS_AQ
!
!========================================================================
!
!!    ####################
      MODULE MODI_CH_TERMS_GAZ
!!    ####################
INTERFACE
SUBROUTINE CH_TERMS_GAZ(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
END SUBROUTINE CH_TERMS_GAZ
END INTERFACE
END MODULE MODI_CH_TERMS_GAZ
!
!========================================================================
!
!!
!!    ######################
      SUBROUTINE CH_TERMS_GAZ(PTIME,PCONC,PTERMS,KMI,KVECNPT,KEQ,KREAC)
!!    ######################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_TERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS. 
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!    Modified 31/10/03: New interface for better MesoNH compilation (D. Gazen)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
REAL,    INTENT(IN)                               :: PTIME
INTEGER, INTENT(IN)                               :: KVECNPT
INTEGER, INTENT(IN)                               :: KEQ, KREAC
REAL,    INTENT(IN),  DIMENSION(KVECNPT,KEQ)      :: PCONC
REAL,    INTENT(OUT), DIMENSION(KVECNPT,KEQ,KREAC):: PTERMS
INTEGER, INTENT(IN)                               :: KMI
!!
TYPE(CCSTYPE), POINTER                            :: TPK
TPK=>TACCS(KMI)
! /BEGIN_CODE/
TPK%O1D(:)=(TPK%K002(:)*PCONC(:,JP_O3))/(TPK%K020(:)*TPK%N2(:)+TPK%K021(:)*TPK%O2(:)+&
   &TPK%K022(:)*TPK%H2O(:))
TPK%O3P(:)=(TPK%K001(:)*PCONC(:,JP_NO2)+TPK%K003(:)*PCONC(:,JP_O3)+TPK%K008(:)*PCONC(:,JP_NO3)+&
    &TPK%K020(:)*TPK%O1D(:)*TPK%N2(:)+TPK%K021(:)*TPK%O1D(:)*TPK%O2(:)+&
    &0.00000*TPK%K079(:)*PCONC(:,JP_ALKE)*PCONC(:,JP_O3)+&
    &0.09000*TPK%K080(:)*PCONC(:,JP_BIO)*PCONC(:,JP_O3))/&
   &(TPK%K018(:)*TPK%O2(:)+TPK%K019(:)*PCONC(:,JP_O3)+TPK%K029(:)*PCONC(:,JP_NO)+&
   &TPK%K030(:)*PCONC(:,JP_NO2)+TPK%K031(:)*PCONC(:,JP_NO2)+TPK%K054(:)*PCONC(:,JP_BIO)+&
   &TPK%K055(:)*PCONC(:,JP_CARBO))
! /END_CODE/
PTERMS(:,:,:) = 0.0
CALL SUBT0
CALL SUBT1
CALL SUBT2
CALL SUBT3
CALL SUBT4
CALL SUBT5
CALL SUBT6
CALL SUBT7
CALL SUBT8
CALL SUBT9
CALL SUBT10
CALL SUBT11
CALL SUBT12
CALL SUBT13
CALL SUBT14
CALL SUBT15
CALL SUBT16
CALL SUBT17
CALL SUBT18
CALL SUBT19
CALL SUBT20
CALL SUBT21
CALL SUBT22
CALL SUBT23
CALL SUBT24
CALL SUBT25
CALL SUBT26
CALL SUBT27
CALL SUBT28
CALL SUBT29
CALL SUBT30
!

CONTAINS

SUBROUTINE SUBT0
!
!Indices 1 a 20
!
!PTERMS(NO,K001) = +K001*<NO2>
 PTERMS(:,3,1) = +TPK%K001(:)*PCONC(:,4)
!
!PTERMS(NO2,K001) = -K001*<NO2>
 PTERMS(:,4,1) = -TPK%K001(:)*PCONC(:,4)
!
!PTERMS(O3,K002) = -K002*<O3>
 PTERMS(:,1,2) = -TPK%K002(:)*PCONC(:,1)
!
!PTERMS(O3,K003) = -K003*<O3>
 PTERMS(:,1,3) = -TPK%K003(:)*PCONC(:,1)
!
!PTERMS(NO,K004) = +K004*<HONO>
 PTERMS(:,3,4) = +TPK%K004(:)*PCONC(:,7)
!
!PTERMS(HONO,K004) = -K004*<HONO>
 PTERMS(:,7,4) = -TPK%K004(:)*PCONC(:,7)
!
!PTERMS(OH,K004) = +K004*<HONO>
 PTERMS(:,14,4) = +TPK%K004(:)*PCONC(:,7)
!
!PTERMS(NO2,K005) = +K005*<HNO3>
 PTERMS(:,4,5) = +TPK%K005(:)*PCONC(:,8)
!
!PTERMS(HNO3,K005) = -K005*<HNO3>
 PTERMS(:,8,5) = -TPK%K005(:)*PCONC(:,8)
!
!PTERMS(OH,K005) = +K005*<HNO3>
 PTERMS(:,14,5) = +TPK%K005(:)*PCONC(:,8)
!
!PTERMS(NO2,K006) = +0.65*K006*<HNO4>
 PTERMS(:,4,6) = +0.65*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(NO3,K006) = +0.35*K006*<HNO4>
 PTERMS(:,5,6) = +0.35*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(HNO4,K006) = -K006*<HNO4>
 PTERMS(:,9,6) = -TPK%K006(:)*PCONC(:,9)
!
!PTERMS(OH,K006) = +0.35*K006*<HNO4>
 PTERMS(:,14,6) = +0.35*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(HO2,K006) = +0.65*K006*<HNO4>
 PTERMS(:,15,6) = +0.65*TPK%K006(:)*PCONC(:,9)
!
!PTERMS(NO,K007) = +K007*<NO3>
 PTERMS(:,3,7) = +TPK%K007(:)*PCONC(:,5)
!
!PTERMS(NO3,K007) = -K007*<NO3>
 PTERMS(:,5,7) = -TPK%K007(:)*PCONC(:,5)
!
!PTERMS(NO2,K008) = +K008*<NO3>
 PTERMS(:,4,8) = +TPK%K008(:)*PCONC(:,5)
!
!PTERMS(NO3,K008) = -K008*<NO3>
 PTERMS(:,5,8) = -TPK%K008(:)*PCONC(:,5)
!
!PTERMS(H2O2,K009) = -K009*<H2O2>
 PTERMS(:,2,9) = -TPK%K009(:)*PCONC(:,2)
!
!
RETURN
END SUBROUTINE SUBT0
!
SUBROUTINE SUBT1
!
!Indices 21 a 40
!
!PTERMS(OH,K009) = +K009*<H2O2>
 PTERMS(:,14,9) = +TPK%K009(:)*PCONC(:,2)
!
!PTERMS(CO,K010) = +K010*<HCHO>
 PTERMS(:,13,10) = +TPK%K010(:)*PCONC(:,22)
!
!PTERMS(HCHO,K010) = -K010*<HCHO>
 PTERMS(:,22,10) = -TPK%K010(:)*PCONC(:,22)
!
!PTERMS(CO,K011) = +K011*<HCHO>
 PTERMS(:,13,11) = +TPK%K011(:)*PCONC(:,22)
!
!PTERMS(HO2,K011) = +K011*<HCHO>
 PTERMS(:,15,11) = +TPK%K011(:)*PCONC(:,22)
!
!PTERMS(HCHO,K011) = -K011*<HCHO>
 PTERMS(:,22,11) = -TPK%K011(:)*PCONC(:,22)
!
!PTERMS(CO,K012) = +K012*<ALD>
 PTERMS(:,13,12) = +TPK%K012(:)*PCONC(:,23)
!
!PTERMS(HO2,K012) = +K012*<ALD>
 PTERMS(:,15,12) = +TPK%K012(:)*PCONC(:,23)
!
!PTERMS(ALD,K012) = -K012*<ALD>
 PTERMS(:,23,12) = -TPK%K012(:)*PCONC(:,23)
!
!PTERMS(MO2,K012) = +K012*<ALD>
 PTERMS(:,32,12) = +TPK%K012(:)*PCONC(:,23)
!
!PTERMS(OH,K013) = +K013*<OP1>
 PTERMS(:,14,13) = +TPK%K013(:)*PCONC(:,28)
!
!PTERMS(HO2,K013) = +K013*<OP1>
 PTERMS(:,15,13) = +TPK%K013(:)*PCONC(:,28)
!
!PTERMS(HCHO,K013) = +K013*<OP1>
 PTERMS(:,22,13) = +TPK%K013(:)*PCONC(:,28)
!
!PTERMS(OP1,K013) = -K013*<OP1>
 PTERMS(:,28,13) = -TPK%K013(:)*PCONC(:,28)
!
!PTERMS(OH,K014) = +K014*<OP2>
 PTERMS(:,14,14) = +TPK%K014(:)*PCONC(:,29)
!
!PTERMS(HO2,K014) = +0.96205*K014*<OP2>
 PTERMS(:,15,14) = +0.96205*TPK%K014(:)*PCONC(:,29)
!
!PTERMS(ALD,K014) = +0.96205*K014*<OP2>
 PTERMS(:,23,14) = +0.96205*TPK%K014(:)*PCONC(:,29)
!
!PTERMS(OP2,K014) = -K014*<OP2>
 PTERMS(:,29,14) = -TPK%K014(:)*PCONC(:,29)
!
!PTERMS(MO2,K014) = +0.03795*K014*<OP2>
 PTERMS(:,32,14) = +0.03795*TPK%K014(:)*PCONC(:,29)
!
!PTERMS(KET,K015) = -K015*<KET>
 PTERMS(:,24,15) = -TPK%K015(:)*PCONC(:,24)
!
!
RETURN
END SUBROUTINE SUBT1
!
SUBROUTINE SUBT2
!
!Indices 41 a 60
!
!PTERMS(ALKAP,K015) = +1.00000*K015*<KET>
 PTERMS(:,33,15) = +1.00000*TPK%K015(:)*PCONC(:,24)
!
!PTERMS(CARBOP,K015) = +1.00000*K015*<KET>
 PTERMS(:,39,15) = +1.00000*TPK%K015(:)*PCONC(:,24)
!
!PTERMS(CO,K016) = +0.91924*K016*<CARBO>
 PTERMS(:,13,16) = +0.91924*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(HO2,K016) = +0.75830*K016*<CARBO>
 PTERMS(:,15,16) = +0.75830*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(HCHO,K016) = +0.06517*K016*<CARBO>
 PTERMS(:,22,16) = +0.06517*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(CARBO,K016) = -K016*<CARBO>
 PTERMS(:,25,16) = -TPK%K016(:)*PCONC(:,25)
!
!PTERMS(CARBOP,K016) = +0.69622*K016*<CARBO>
 PTERMS(:,39,16) = +0.69622*TPK%K016(:)*PCONC(:,25)
!
!PTERMS(NO2,K017) = +K017*<ONIT>
 PTERMS(:,4,17) = +TPK%K017(:)*PCONC(:,26)
!
!PTERMS(HO2,K017) = +K017*<ONIT>
 PTERMS(:,15,17) = +TPK%K017(:)*PCONC(:,26)
!
!PTERMS(ALD,K017) = +0.20*K017*<ONIT>
 PTERMS(:,23,17) = +0.20*TPK%K017(:)*PCONC(:,26)
!
!PTERMS(KET,K017) = +0.80*K017*<ONIT>
 PTERMS(:,24,17) = +0.80*TPK%K017(:)*PCONC(:,26)
!
!PTERMS(ONIT,K017) = -K017*<ONIT>
 PTERMS(:,26,17) = -TPK%K017(:)*PCONC(:,26)
!
!PTERMS(O3,K018) = +K018*<O3P>*<O2>
 PTERMS(:,1,18) = +TPK%K018(:)*TPK%O3P(:)*TPK%O2(:)
!
!PTERMS(O3,K019) = -K019*<O3P>*<O3>
 PTERMS(:,1,19) = -TPK%K019(:)*TPK%O3P(:)*PCONC(:,1)
!
!PTERMS(OH,K022) = +K022*<O1D>*<H2O>
 PTERMS(:,14,22) = +TPK%K022(:)*TPK%O1D(:)*TPK%H2O(:)
!
!PTERMS(O3,K023) = -K023*<O3>*<OH>
 PTERMS(:,1,23) = -TPK%K023(:)*PCONC(:,1)*PCONC(:,14)
!
!PTERMS(OH,K023) = -K023*<O3>*<OH>
 PTERMS(:,14,23) = -TPK%K023(:)*PCONC(:,1)*PCONC(:,14)
!
!PTERMS(HO2,K023) = +K023*<O3>*<OH>
 PTERMS(:,15,23) = +TPK%K023(:)*PCONC(:,1)*PCONC(:,14)
!
!PTERMS(O3,K024) = -K024*<O3>*<HO2>
 PTERMS(:,1,24) = -TPK%K024(:)*PCONC(:,1)*PCONC(:,15)
!
!PTERMS(OH,K024) = +K024*<O3>*<HO2>
 PTERMS(:,14,24) = +TPK%K024(:)*PCONC(:,1)*PCONC(:,15)
!
!
RETURN
END SUBROUTINE SUBT2
!
SUBROUTINE SUBT3
!
!Indices 61 a 80
!
!PTERMS(HO2,K024) = -K024*<O3>*<HO2>
 PTERMS(:,15,24) = -TPK%K024(:)*PCONC(:,1)*PCONC(:,15)
!
!PTERMS(OH,K025) = -K025*<OH>*<HO2>
 PTERMS(:,14,25) = -TPK%K025(:)*PCONC(:,14)*PCONC(:,15)
!
!PTERMS(HO2,K025) = -K025*<OH>*<HO2>
 PTERMS(:,15,25) = -TPK%K025(:)*PCONC(:,14)*PCONC(:,15)
!
!PTERMS(H2O2,K026) = -K026*<H2O2>*<OH>
 PTERMS(:,2,26) = -TPK%K026(:)*PCONC(:,2)*PCONC(:,14)
!
!PTERMS(OH,K026) = -K026*<H2O2>*<OH>
 PTERMS(:,14,26) = -TPK%K026(:)*PCONC(:,2)*PCONC(:,14)
!
!PTERMS(HO2,K026) = +K026*<H2O2>*<OH>
 PTERMS(:,15,26) = +TPK%K026(:)*PCONC(:,2)*PCONC(:,14)
!
!PTERMS(H2O2,K027) = +K027*<HO2>*<HO2>
 PTERMS(:,2,27) = +TPK%K027(:)*PCONC(:,15)*PCONC(:,15)
!
!PTERMS(HO2,K027) = -K027*<HO2>*<HO2>
 PTERMS(:,15,27) = -TPK%K027(:)*PCONC(:,15)*PCONC(:,15)
!
!PTERMS(H2O2,K028) = +K028*<HO2>*<HO2>*<H2O>
 PTERMS(:,2,28) = +TPK%K028(:)*PCONC(:,15)*PCONC(:,15)*TPK%H2O(:)
!
!PTERMS(HO2,K028) = -K028*<HO2>*<HO2>*<H2O>
 PTERMS(:,15,28) = -TPK%K028(:)*PCONC(:,15)*PCONC(:,15)*TPK%H2O(:)
!
!PTERMS(NO,K029) = -K029*<O3P>*<NO>
 PTERMS(:,3,29) = -TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)
!
!PTERMS(NO2,K029) = +K029*<O3P>*<NO>
 PTERMS(:,4,29) = +TPK%K029(:)*TPK%O3P(:)*PCONC(:,3)
!
!PTERMS(NO,K030) = +K030*<O3P>*<NO2>
 PTERMS(:,3,30) = +TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO2,K030) = -K030*<O3P>*<NO2>
 PTERMS(:,4,30) = -TPK%K030(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO2,K031) = -K031*<O3P>*<NO2>
 PTERMS(:,4,31) = -TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO3,K031) = +K031*<O3P>*<NO2>
 PTERMS(:,5,31) = +TPK%K031(:)*TPK%O3P(:)*PCONC(:,4)
!
!PTERMS(NO,K032) = -K032*<OH>*<NO>
 PTERMS(:,3,32) = -TPK%K032(:)*PCONC(:,14)*PCONC(:,3)
!
!PTERMS(HONO,K032) = +K032*<OH>*<NO>
 PTERMS(:,7,32) = +TPK%K032(:)*PCONC(:,14)*PCONC(:,3)
!
!PTERMS(OH,K032) = -K032*<OH>*<NO>
 PTERMS(:,14,32) = -TPK%K032(:)*PCONC(:,14)*PCONC(:,3)
!
!PTERMS(NO2,K033) = -K033*<OH>*<NO2>
 PTERMS(:,4,33) = -TPK%K033(:)*PCONC(:,14)*PCONC(:,4)
!
!
RETURN
END SUBROUTINE SUBT3
!
SUBROUTINE SUBT4
!
!Indices 81 a 100
!
!PTERMS(HNO3,K033) = +K033*<OH>*<NO2>
 PTERMS(:,8,33) = +TPK%K033(:)*PCONC(:,14)*PCONC(:,4)
!
!PTERMS(OH,K033) = -K033*<OH>*<NO2>
 PTERMS(:,14,33) = -TPK%K033(:)*PCONC(:,14)*PCONC(:,4)
!
!PTERMS(NO2,K034) = +K034*<OH>*<NO3>
 PTERMS(:,4,34) = +TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(NO3,K034) = -K034*<OH>*<NO3>
 PTERMS(:,5,34) = -TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(OH,K034) = -K034*<OH>*<NO3>
 PTERMS(:,14,34) = -TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(HO2,K034) = +K034*<OH>*<NO3>
 PTERMS(:,15,34) = +TPK%K034(:)*PCONC(:,14)*PCONC(:,5)
!
!PTERMS(NO,K035) = -K035*<HO2>*<NO>
 PTERMS(:,3,35) = -TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(NO2,K035) = +K035*<HO2>*<NO>
 PTERMS(:,4,35) = +TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(OH,K035) = +K035*<HO2>*<NO>
 PTERMS(:,14,35) = +TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(HO2,K035) = -K035*<HO2>*<NO>
 PTERMS(:,15,35) = -TPK%K035(:)*PCONC(:,15)*PCONC(:,3)
!
!PTERMS(NO2,K036) = -K036*<HO2>*<NO2>
 PTERMS(:,4,36) = -TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!
!PTERMS(HNO4,K036) = +K036*<HO2>*<NO2>
 PTERMS(:,9,36) = +TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!
!PTERMS(HO2,K036) = -K036*<HO2>*<NO2>
 PTERMS(:,15,36) = -TPK%K036(:)*PCONC(:,15)*PCONC(:,4)
!
!PTERMS(NO2,K037) = +K037*<HNO4>
 PTERMS(:,4,37) = +TPK%K037(:)*PCONC(:,9)
!
!PTERMS(HNO4,K037) = -K037*<HNO4>
 PTERMS(:,9,37) = -TPK%K037(:)*PCONC(:,9)
!
!PTERMS(HO2,K037) = +K037*<HNO4>
 PTERMS(:,15,37) = +TPK%K037(:)*PCONC(:,9)
!
!PTERMS(NO2,K038) = +0.7*K038*<HO2>*<NO3>
 PTERMS(:,4,38) = +0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(NO3,K038) = -K038*<HO2>*<NO3>
 PTERMS(:,5,38) = -TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(HNO3,K038) = +0.3*K038*<HO2>*<NO3>
 PTERMS(:,8,38) = +0.3*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(OH,K038) = +0.7*K038*<HO2>*<NO3>
 PTERMS(:,14,38) = +0.7*TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT4
!
SUBROUTINE SUBT5
!
!Indices 101 a 120
!
!PTERMS(HO2,K038) = -K038*<HO2>*<NO3>
 PTERMS(:,15,38) = -TPK%K038(:)*PCONC(:,15)*PCONC(:,5)
!
!PTERMS(NO2,K039) = +K039*<OH>*<HONO>
 PTERMS(:,4,39) = +TPK%K039(:)*PCONC(:,14)*PCONC(:,7)
!
!PTERMS(HONO,K039) = -K039*<OH>*<HONO>
 PTERMS(:,7,39) = -TPK%K039(:)*PCONC(:,14)*PCONC(:,7)
!
!PTERMS(OH,K039) = -K039*<OH>*<HONO>
 PTERMS(:,14,39) = -TPK%K039(:)*PCONC(:,14)*PCONC(:,7)
!
!PTERMS(NO3,K040) = +K040*<OH>*<HNO3>
 PTERMS(:,5,40) = +TPK%K040(:)*PCONC(:,14)*PCONC(:,8)
!
!PTERMS(HNO3,K040) = -K040*<OH>*<HNO3>
 PTERMS(:,8,40) = -TPK%K040(:)*PCONC(:,14)*PCONC(:,8)
!
!PTERMS(OH,K040) = -K040*<OH>*<HNO3>
 PTERMS(:,14,40) = -TPK%K040(:)*PCONC(:,14)*PCONC(:,8)
!
!PTERMS(NO2,K041) = +K041*<OH>*<HNO4>
 PTERMS(:,4,41) = +TPK%K041(:)*PCONC(:,14)*PCONC(:,9)
!
!PTERMS(HNO4,K041) = -K041*<OH>*<HNO4>
 PTERMS(:,9,41) = -TPK%K041(:)*PCONC(:,14)*PCONC(:,9)
!
!PTERMS(OH,K041) = -K041*<OH>*<HNO4>
 PTERMS(:,14,41) = -TPK%K041(:)*PCONC(:,14)*PCONC(:,9)
!
!PTERMS(O3,K042) = -K042*<O3>*<NO>
 PTERMS(:,1,42) = -TPK%K042(:)*PCONC(:,1)*PCONC(:,3)
!
!PTERMS(NO,K042) = -K042*<O3>*<NO>
 PTERMS(:,3,42) = -TPK%K042(:)*PCONC(:,1)*PCONC(:,3)
!
!PTERMS(NO2,K042) = +K042*<O3>*<NO>
 PTERMS(:,4,42) = +TPK%K042(:)*PCONC(:,1)*PCONC(:,3)
!
!PTERMS(O3,K043) = -K043*<O3>*<NO2>
 PTERMS(:,1,43) = -TPK%K043(:)*PCONC(:,1)*PCONC(:,4)
!
!PTERMS(NO2,K043) = -K043*<O3>*<NO2>
 PTERMS(:,4,43) = -TPK%K043(:)*PCONC(:,1)*PCONC(:,4)
!
!PTERMS(NO3,K043) = +K043*<O3>*<NO2>
 PTERMS(:,5,43) = +TPK%K043(:)*PCONC(:,1)*PCONC(:,4)
!
!PTERMS(NO,K044) = -K044*<NO>*<NO>*<O2>
 PTERMS(:,3,44) = -TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)
!
!PTERMS(NO2,K044) = +K044*<NO>*<NO>*<O2>
 PTERMS(:,4,44) = +TPK%K044(:)*PCONC(:,3)*PCONC(:,3)*TPK%O2(:)
!
!PTERMS(NO,K045) = -K045*<NO3>*<NO>
 PTERMS(:,3,45) = -TPK%K045(:)*PCONC(:,5)*PCONC(:,3)
!
!PTERMS(NO2,K045) = +K045*<NO3>*<NO>
 PTERMS(:,4,45) = +TPK%K045(:)*PCONC(:,5)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT5
!
SUBROUTINE SUBT6
!
!Indices 121 a 140
!
!PTERMS(NO3,K045) = -K045*<NO3>*<NO>
 PTERMS(:,5,45) = -TPK%K045(:)*PCONC(:,5)*PCONC(:,3)
!
!PTERMS(NO,K046) = +K046*<NO3>*<NO2>
 PTERMS(:,3,46) = +TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO2,K046) = -K046*<NO3>*<NO2>
 PTERMS(:,4,46) = -TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO3,K046) = -K046*<NO3>*<NO2>
 PTERMS(:,5,46) = -TPK%K046(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO2,K047) = -K047*<NO3>*<NO2>
 PTERMS(:,4,47) = -TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO3,K047) = -K047*<NO3>*<NO2>
 PTERMS(:,5,47) = -TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(N2O5,K047) = +K047*<NO3>*<NO2>
 PTERMS(:,6,47) = +TPK%K047(:)*PCONC(:,5)*PCONC(:,4)
!
!PTERMS(NO2,K048) = +K048*<N2O5>
 PTERMS(:,4,48) = +TPK%K048(:)*PCONC(:,6)
!
!PTERMS(NO3,K048) = +K048*<N2O5>
 PTERMS(:,5,48) = +TPK%K048(:)*PCONC(:,6)
!
!PTERMS(N2O5,K048) = -K048*<N2O5>
 PTERMS(:,6,48) = -TPK%K048(:)*PCONC(:,6)
!
!PTERMS(NO2,K049) = +K049*<NO3>*<NO3>
 PTERMS(:,4,49) = +TPK%K049(:)*PCONC(:,5)*PCONC(:,5)
!
!PTERMS(NO3,K049) = -K049*<NO3>*<NO3>
 PTERMS(:,5,49) = -TPK%K049(:)*PCONC(:,5)*PCONC(:,5)
!
!PTERMS(NH3,K050) = -K050*<NH3>*<OH>
 PTERMS(:,10,50) = -TPK%K050(:)*PCONC(:,10)*PCONC(:,14)
!
!PTERMS(OH,K050) = -K050*<NH3>*<OH>
 PTERMS(:,14,50) = -TPK%K050(:)*PCONC(:,10)*PCONC(:,14)
!
!PTERMS(OH,K051) = -K051*<OH>*<H2>
 PTERMS(:,14,51) = -TPK%K051(:)*PCONC(:,14)*TPK%H2(:)
!
!PTERMS(HO2,K051) = +K051*<OH>*<H2>
 PTERMS(:,15,51) = +TPK%K051(:)*PCONC(:,14)*TPK%H2(:)
!
!PTERMS(SO2,K052) = -K052*<OH>*<SO2>
 PTERMS(:,11,52) = -TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!PTERMS(SULF,K052) = +K052*<OH>*<SO2>
 PTERMS(:,12,52) = +TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!PTERMS(OH,K052) = -K052*<OH>*<SO2>
 PTERMS(:,14,52) = -TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!PTERMS(HO2,K052) = +K052*<OH>*<SO2>
 PTERMS(:,15,52) = +TPK%K052(:)*PCONC(:,14)*PCONC(:,11)
!
!
RETURN
END SUBROUTINE SUBT6
!
SUBROUTINE SUBT7
!
!Indices 141 a 160
!
!PTERMS(CO,K053) = -K053*<CO>*<OH>
 PTERMS(:,13,53) = -TPK%K053(:)*PCONC(:,13)*PCONC(:,14)
!
!PTERMS(OH,K053) = -K053*<CO>*<OH>
 PTERMS(:,14,53) = -TPK%K053(:)*PCONC(:,13)*PCONC(:,14)
!
!PTERMS(HO2,K053) = +K053*<CO>*<OH>
 PTERMS(:,15,53) = +TPK%K053(:)*PCONC(:,13)*PCONC(:,14)
!
!PTERMS(CO,K054) = +0.01*K054*<BIO>*<O3P>
 PTERMS(:,13,54) = +0.01*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(OH,K054) = +0.02*K054*<BIO>*<O3P>
 PTERMS(:,14,54) = +0.02*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(HO2,K054) = +0.28*K054*<BIO>*<O3P>
 PTERMS(:,15,54) = +0.28*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(ALKE,K054) = +0.91868*K054*<BIO>*<O3P>
 PTERMS(:,19,54) = +0.91868*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(BIO,K054) = -K054*<BIO>*<O3P>
 PTERMS(:,20,54) = -TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(HCHO,K054) = +0.05*K054*<BIO>*<O3P>
 PTERMS(:,22,54) = +0.05*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(CARBO,K054) = +0.13255*K054*<BIO>*<O3P>
 PTERMS(:,25,54) = +0.13255*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(XO2,K054) = +0.15*K054*<BIO>*<O3P>
 PTERMS(:,41,54) = +0.15*TPK%K054(:)*PCONC(:,20)*TPK%O3P(:)
!
!PTERMS(ALD,K055) = +K055*<CARBO>*<O3P>
 PTERMS(:,23,55) = +TPK%K055(:)*PCONC(:,25)*TPK%O3P(:)
!
!PTERMS(CARBO,K055) = -K055*<CARBO>*<O3P>
 PTERMS(:,25,55) = -TPK%K055(:)*PCONC(:,25)*TPK%O3P(:)
!
!PTERMS(OH,K056) = -K056*<CH4>*<OH>
 PTERMS(:,14,56) = -TPK%K056(:)*PCONC(:,16)*PCONC(:,14)
!
!PTERMS(CH4,K056) = -K056*<CH4>*<OH>
 PTERMS(:,16,56) = -TPK%K056(:)*PCONC(:,16)*PCONC(:,14)
!
!PTERMS(MO2,K056) = +K056*<CH4>*<OH>
 PTERMS(:,32,56) = +TPK%K056(:)*PCONC(:,16)*PCONC(:,14)
!
!PTERMS(OH,K057) = -K057*<ETH>*<OH>
 PTERMS(:,14,57) = -TPK%K057(:)*PCONC(:,17)*PCONC(:,14)
!
!PTERMS(ETH,K057) = -K057*<ETH>*<OH>
 PTERMS(:,17,57) = -TPK%K057(:)*PCONC(:,17)*PCONC(:,14)
!
!PTERMS(ALKAP,K057) = +K057*<ETH>*<OH>
 PTERMS(:,33,57) = +TPK%K057(:)*PCONC(:,17)*PCONC(:,14)
!
!PTERMS(CO,K058) = +0.00878*K058*<ALKA>*<OH>
 PTERMS(:,13,58) = +0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT7
!
SUBROUTINE SUBT8
!
!Indices 161 a 180
!
!PTERMS(OH,K058) = -K058*<ALKA>*<OH>
 PTERMS(:,14,58) = -TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(HO2,K058) = +0.12793*K058*<ALKA>*<OH>
 PTERMS(:,15,58) = +0.12793*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ALKA,K058) = -K058*<ALKA>*<OH>
 PTERMS(:,18,58) = -TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(HCHO,K058) = +0.00140*K058*<ALKA>*<OH>
 PTERMS(:,22,58) = +0.00140*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ALD,K058) = +0.08173*K058*<ALKA>*<OH>
 PTERMS(:,23,58) = +0.08173*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(KET,K058) = +0.03498*K058*<ALKA>*<OH>
 PTERMS(:,24,58) = +0.03498*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(CARBO,K058) = +0.00835*K058*<ALKA>*<OH>
 PTERMS(:,25,58) = +0.00835*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ORA1,K058) = +0.00878*K058*<ALKA>*<OH>
 PTERMS(:,30,58) = +0.00878*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(ALKAP,K058) = +0.87811*K058*<ALKA>*<OH>
 PTERMS(:,33,58) = +0.87811*TPK%K058(:)*PCONC(:,18)*PCONC(:,14)
!
!PTERMS(OH,K059) = -K059*<ALKE>*<OH>
 PTERMS(:,14,59) = -TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(ALKE,K059) = -K059*<ALKE>*<OH>
 PTERMS(:,19,59) = -TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(ALKEP,K059) = +1.02529*K059*<ALKE>*<OH>
 PTERMS(:,34,59) = +1.02529*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(BIOP,K059) = +0.00000*K059*<ALKE>*<OH>
 PTERMS(:,35,59) = +0.00000*TPK%K059(:)*PCONC(:,19)*PCONC(:,14)
!
!PTERMS(OH,K060) = -K060*<BIO>*<OH>
 PTERMS(:,14,60) = -TPK%K060(:)*PCONC(:,20)*PCONC(:,14)
!
!PTERMS(BIO,K060) = -K060*<BIO>*<OH>
 PTERMS(:,20,60) = -TPK%K060(:)*PCONC(:,20)*PCONC(:,14)
!
!PTERMS(BIOP,K060) = +1.00000*K060*<BIO>*<OH>
 PTERMS(:,35,60) = +1.00000*TPK%K060(:)*PCONC(:,20)*PCONC(:,14)
!
!PTERMS(OH,K061) = -K061*<ARO>*<OH>
 PTERMS(:,14,61) = -TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(HO2,K061) = +0.10318*K061*<ARO>*<OH>
 PTERMS(:,15,61) = +0.10318*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(ARO,K061) = -K061*<ARO>*<OH>
 PTERMS(:,21,61) = -TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(PHO,K061) = +0.00276*K061*<ARO>*<OH>
 PTERMS(:,36,61) = +0.00276*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT8
!
SUBROUTINE SUBT9
!
!Indices 181 a 200
!
!PTERMS(ADD,K061) = +0.93968*K061*<ARO>*<OH>
 PTERMS(:,37,61) = +0.93968*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(XO2,K061) = +0.10318*K061*<ARO>*<OH>
 PTERMS(:,41,61) = +0.10318*TPK%K061(:)*PCONC(:,21)*PCONC(:,14)
!
!PTERMS(CO,K062) = +K062*<HCHO>*<OH>
 PTERMS(:,13,62) = +TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(OH,K062) = -K062*<HCHO>*<OH>
 PTERMS(:,14,62) = -TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(HO2,K062) = +K062*<HCHO>*<OH>
 PTERMS(:,15,62) = +TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(HCHO,K062) = -K062*<HCHO>*<OH>
 PTERMS(:,22,62) = -TPK%K062(:)*PCONC(:,22)*PCONC(:,14)
!
!PTERMS(OH,K063) = -K063*<ALD>*<OH>
 PTERMS(:,14,63) = -TPK%K063(:)*PCONC(:,23)*PCONC(:,14)
!
!PTERMS(ALD,K063) = -K063*<ALD>*<OH>
 PTERMS(:,23,63) = -TPK%K063(:)*PCONC(:,23)*PCONC(:,14)
!
!PTERMS(CARBOP,K063) = +1.00000*K063*<ALD>*<OH>
 PTERMS(:,39,63) = +1.00000*TPK%K063(:)*PCONC(:,23)*PCONC(:,14)
!
!PTERMS(OH,K064) = -K064*<KET>*<OH>
 PTERMS(:,14,64) = -TPK%K064(:)*PCONC(:,24)*PCONC(:,14)
!
!PTERMS(KET,K064) = -K064*<KET>*<OH>
 PTERMS(:,24,64) = -TPK%K064(:)*PCONC(:,24)*PCONC(:,14)
!
!PTERMS(CARBOP,K064) = +1.00000*K064*<KET>*<OH>
 PTERMS(:,39,64) = +1.00000*TPK%K064(:)*PCONC(:,24)*PCONC(:,14)
!
!PTERMS(CO,K065) = +1.01732*K065*<CARBO>*<OH>
 PTERMS(:,13,65) = +1.01732*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(OH,K065) = -K065*<CARBO>*<OH>
 PTERMS(:,14,65) = -TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(HO2,K065) = +0.51208*K065*<CARBO>*<OH>
 PTERMS(:,15,65) = +0.51208*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(HCHO,K065) = +0.00000*K065*<CARBO>*<OH>
 PTERMS(:,22,65) = +0.00000*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(ALD,K065) = +0.06253*K065*<CARBO>*<OH>
 PTERMS(:,23,65) = +0.06253*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(KET,K065) = +0.00853*K065*<CARBO>*<OH>
 PTERMS(:,24,65) = +0.00853*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(CARBO,K065) = -K065*<CARBO>*<OH>
 PTERMS(:,25,65) = -TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(CARBOP,K065) = +0.51419*K065*<CARBO>*<OH>
 PTERMS(:,39,65) = +0.51419*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT9
!
SUBROUTINE SUBT10
!
!Indices 201 a 220
!
!PTERMS(XO2,K065) = +0.10162*K065*<CARBO>*<OH>
 PTERMS(:,41,65) = +0.10162*TPK%K065(:)*PCONC(:,25)*PCONC(:,14)
!
!PTERMS(OH,K066) = -K066*<ORA1>*<OH>
 PTERMS(:,14,66) = -TPK%K066(:)*PCONC(:,30)*PCONC(:,14)
!
!PTERMS(HO2,K066) = +K066*<ORA1>*<OH>
 PTERMS(:,15,66) = +TPK%K066(:)*PCONC(:,30)*PCONC(:,14)
!
!PTERMS(ORA1,K066) = -K066*<ORA1>*<OH>
 PTERMS(:,30,66) = -TPK%K066(:)*PCONC(:,30)*PCONC(:,14)
!
!PTERMS(OH,K067) = -K067*<ORA2>*<OH>
 PTERMS(:,14,67) = -TPK%K067(:)*PCONC(:,31)*PCONC(:,14)
!
!PTERMS(ORA2,K067) = -K067*<ORA2>*<OH>
 PTERMS(:,31,67) = -TPK%K067(:)*PCONC(:,31)*PCONC(:,14)
!
!PTERMS(OH,K068) = -K068*<OP1>*<OH>
 PTERMS(:,14,68) = -TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(HCHO,K068) = +0.35*K068*<OP1>*<OH>
 PTERMS(:,22,68) = +0.35*TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(OP1,K068) = -K068*<OP1>*<OH>
 PTERMS(:,28,68) = -TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(MO2,K068) = +0.65*K068*<OP1>*<OH>
 PTERMS(:,32,68) = +0.65*TPK%K068(:)*PCONC(:,28)*PCONC(:,14)
!
!PTERMS(OH,K069) = -K069*<OP2>*<OH>
 PTERMS(:,14,69) = -TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(HO2,K069) = +0.02915*K069*<OP2>*<OH>
 PTERMS(:,15,69) = +0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(HCHO,K069) = +0.02915*K069*<OP2>*<OH>
 PTERMS(:,22,69) = +0.02915*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(ALD,K069) = +0.07335*K069*<OP2>*<OH>
 PTERMS(:,23,69) = +0.07335*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(KET,K069) = +0.37591*K069*<OP2>*<OH>
 PTERMS(:,24,69) = +0.37591*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(OP2,K069) = -K069*<OP2>*<OH>
 PTERMS(:,29,69) = -TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(ALKAP,K069) = +0.40341*K069*<OP2>*<OH>
 PTERMS(:,33,69) = +0.40341*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(CARBOP,K069) = +0.05413*K069*<OP2>*<OH>
 PTERMS(:,39,69) = +0.05413*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(XO2,K069) = +0.09333*K069*<OP2>*<OH>
 PTERMS(:,41,69) = +0.09333*TPK%K069(:)*PCONC(:,29)*PCONC(:,14)
!
!PTERMS(NO3,K070) = +0.71893*K070*<PAN>*<OH>
 PTERMS(:,5,70) = +0.71893*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!
RETURN
END SUBROUTINE SUBT10
!
SUBROUTINE SUBT11
!
!Indices 221 a 240
!
!PTERMS(OH,K070) = -K070*<PAN>*<OH>
 PTERMS(:,14,70) = -TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(HO2,K070) = +0.28107*K070*<PAN>*<OH>
 PTERMS(:,15,70) = +0.28107*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(HCHO,K070) = +0.57839*K070*<PAN>*<OH>
 PTERMS(:,22,70) = +0.57839*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(CARBO,K070) = +0.21863*K070*<PAN>*<OH>
 PTERMS(:,25,70) = +0.21863*TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(PAN,K070) = -K070*<PAN>*<OH>
 PTERMS(:,27,70) = -TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(XO2,K070) = +K070*<PAN>*<OH>
 PTERMS(:,41,70) = +TPK%K070(:)*PCONC(:,27)*PCONC(:,14)
!
!PTERMS(NO2,K071) = +K071*<ONIT>*<OH>
 PTERMS(:,4,71) = +TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(OH,K071) = -K071*<ONIT>*<OH>
 PTERMS(:,14,71) = -TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(ONIT,K071) = -K071*<ONIT>*<OH>
 PTERMS(:,26,71) = -TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(ALKAP,K071) = +1.00000*K071*<ONIT>*<OH>
 PTERMS(:,33,71) = +1.00000*TPK%K071(:)*PCONC(:,26)*PCONC(:,14)
!
!PTERMS(NO3,K072) = -K072*<HCHO>*<NO3>
 PTERMS(:,5,72) = -TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(HNO3,K072) = +K072*<HCHO>*<NO3>
 PTERMS(:,8,72) = +TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(CO,K072) = +K072*<HCHO>*<NO3>
 PTERMS(:,13,72) = +TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(HO2,K072) = +K072*<HCHO>*<NO3>
 PTERMS(:,15,72) = +TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(HCHO,K072) = -K072*<HCHO>*<NO3>
 PTERMS(:,22,72) = -TPK%K072(:)*PCONC(:,22)*PCONC(:,5)
!
!PTERMS(NO3,K073) = -K073*<ALD>*<NO3>
 PTERMS(:,5,73) = -TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(HNO3,K073) = +K073*<ALD>*<NO3>
 PTERMS(:,8,73) = +TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(ALD,K073) = -K073*<ALD>*<NO3>
 PTERMS(:,23,73) = -TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(CARBOP,K073) = +1.00000*K073*<ALD>*<NO3>
 PTERMS(:,39,73) = +1.00000*TPK%K073(:)*PCONC(:,23)*PCONC(:,5)
!
!PTERMS(NO2,K074) = +0.10530*K074*<CARBO>*<NO3>
 PTERMS(:,4,74) = +0.10530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT11
!
SUBROUTINE SUBT12
!
!Indices 241 a 260
!
!PTERMS(NO3,K074) = -K074*<CARBO>*<NO3>
 PTERMS(:,5,74) = -TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(HNO3,K074) = +0.91567*K074*<CARBO>*<NO3>
 PTERMS(:,8,74) = +0.91567*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(CO,K074) = +1.33723*K074*<CARBO>*<NO3>
 PTERMS(:,13,74) = +1.33723*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(HO2,K074) = +0.63217*K074*<CARBO>*<NO3>
 PTERMS(:,15,74) = +0.63217*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(ALD,K074) = +0.05265*K074*<CARBO>*<NO3>
 PTERMS(:,23,74) = +0.05265*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(KET,K074) = +0.00632*K074*<CARBO>*<NO3>
 PTERMS(:,24,74) = +0.00632*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(CARBO,K074) = -K074*<CARBO>*<NO3>
 PTERMS(:,25,74) = -TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(CARBOP,K074) = +0.38881*K074*<CARBO>*<NO3>
 PTERMS(:,39,74) = +0.38881*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(OLN,K074) = +0.00000*K074*<CARBO>*<NO3>
 PTERMS(:,40,74) = +0.00000*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(XO2,K074) = +0.10530*K074*<CARBO>*<NO3>
 PTERMS(:,41,74) = +0.10530*TPK%K074(:)*PCONC(:,25)*PCONC(:,5)
!
!PTERMS(NO3,K075) = -K075*<ARO>*<NO3>
 PTERMS(:,5,75) = -TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(HNO3,K075) = +K075*<ARO>*<NO3>
 PTERMS(:,8,75) = +TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(ARO,K075) = -K075*<ARO>*<NO3>
 PTERMS(:,21,75) = -TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(PHO,K075) = +K075*<ARO>*<NO3>
 PTERMS(:,36,75) = +TPK%K075(:)*PCONC(:,21)*PCONC(:,5)
!
!PTERMS(NO3,K076) = -K076*<ALKE>*<NO3>
 PTERMS(:,5,76) = -TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(ALKE,K076) = -K076*<ALKE>*<NO3>
 PTERMS(:,19,76) = -TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(CARBO,K076) = +0.00000*K076*<ALKE>*<NO3>
 PTERMS(:,25,76) = +0.00000*TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(OLN,K076) = +0.93768*K076*<ALKE>*<NO3>
 PTERMS(:,40,76) = +0.93768*TPK%K076(:)*PCONC(:,19)*PCONC(:,5)
!
!PTERMS(NO3,K077) = -K077*<BIO>*<NO3>
 PTERMS(:,5,77) = -TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!PTERMS(BIO,K077) = -K077*<BIO>*<NO3>
 PTERMS(:,20,77) = -TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT12
!
SUBROUTINE SUBT13
!
!Indices 261 a 280
!
!PTERMS(CARBO,K077) = +0.91741*K077*<BIO>*<NO3>
 PTERMS(:,25,77) = +0.91741*TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!PTERMS(OLN,K077) = +1.00000*K077*<BIO>*<NO3>
 PTERMS(:,40,77) = +1.00000*TPK%K077(:)*PCONC(:,20)*PCONC(:,5)
!
!PTERMS(NO2,K078) = +0.40*K078*<PAN>*<NO3>
 PTERMS(:,4,78) = +0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(NO3,K078) = -K078*<PAN>*<NO3>
 PTERMS(:,5,78) = -TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(HCHO,K078) = +0.40*K078*<PAN>*<NO3>
 PTERMS(:,22,78) = +0.40*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(ONIT,K078) = +0.60*K078*<PAN>*<NO3>
 PTERMS(:,26,78) = +0.60*TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(PAN,K078) = -K078*<PAN>*<NO3>
 PTERMS(:,27,78) = -TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(XO2,K078) = +K078*<PAN>*<NO3>
 PTERMS(:,41,78) = +TPK%K078(:)*PCONC(:,27)*PCONC(:,5)
!
!PTERMS(O3,K079) = -K079*<ALKE>*<O3>
 PTERMS(:,1,79) = -TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(H2O2,K079) = +0.01833*K079*<ALKE>*<O3>
 PTERMS(:,2,79) = +0.01833*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CO,K079) = +0.35120*K079*<ALKE>*<O3>
 PTERMS(:,13,79) = +0.35120*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(OH,K079) = +0.39435*K079*<ALKE>*<O3>
 PTERMS(:,14,79) = +0.39435*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(HO2,K079) = +0.23451*K079*<ALKE>*<O3>
 PTERMS(:,15,79) = +0.23451*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CH4,K079) = +0.04300*K079*<ALKE>*<O3>
 PTERMS(:,16,79) = +0.04300*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ETH,K079) = +0.03196*K079*<ALKE>*<O3>
 PTERMS(:,17,79) = +0.03196*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ALKE,K079) = -K079*<ALKE>*<O3>
 PTERMS(:,19,79) = -TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(HCHO,K079) = +0.48290*K079*<ALKE>*<O3>
 PTERMS(:,22,79) = +0.48290*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ALD,K079) = +0.51468*K079*<ALKE>*<O3>
 PTERMS(:,23,79) = +0.51468*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(KET,K079) = +0.07377*K079*<ALKE>*<O3>
 PTERMS(:,24,79) = +0.07377*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CARBO,K079) = +0.00000*K079*<ALKE>*<O3>
 PTERMS(:,25,79) = +0.00000*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT13
!
SUBROUTINE SUBT14
!
!Indices 281 a 300
!
!PTERMS(ORA1,K079) = +0.15343*K079*<ALKE>*<O3>
 PTERMS(:,30,79) = +0.15343*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ORA2,K079) = +0.08143*K079*<ALKE>*<O3>
 PTERMS(:,31,79) = +0.08143*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(MO2,K079) = +0.13966*K079*<ALKE>*<O3>
 PTERMS(:,32,79) = +0.13966*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(ALKAP,K079) = +0.09815*K079*<ALKE>*<O3>
 PTERMS(:,33,79) = +0.09815*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(CARBOP,K079) = +0.05705*K079*<ALKE>*<O3>
 PTERMS(:,39,79) = +0.05705*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(XO2,K079) = +0.00000*K079*<ALKE>*<O3>
 PTERMS(:,41,79) = +0.00000*TPK%K079(:)*PCONC(:,19)*PCONC(:,1)
!
!PTERMS(O3,K080) = -K080*<BIO>*<O3>
 PTERMS(:,1,80) = -TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(H2O2,K080) = +0.00100*K080*<BIO>*<O3>
 PTERMS(:,2,80) = +0.00100*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(CO,K080) = +0.36000*K080*<BIO>*<O3>
 PTERMS(:,13,80) = +0.36000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(OH,K080) = +0.28000*K080*<BIO>*<O3>
 PTERMS(:,14,80) = +0.28000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(HO2,K080) = +0.30000*K080*<BIO>*<O3>
 PTERMS(:,15,80) = +0.30000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ALKE,K080) = +0.37388*K080*<BIO>*<O3>
 PTERMS(:,19,80) = +0.37388*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(BIO,K080) = -K080*<BIO>*<O3>
 PTERMS(:,20,80) = -TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(HCHO,K080) = +0.90000*K080*<BIO>*<O3>
 PTERMS(:,22,80) = +0.90000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ALD,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,23,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(KET,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,24,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(CARBO,K080) = +0.39754*K080*<BIO>*<O3>
 PTERMS(:,25,80) = +0.39754*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ORA1,K080) = +0.15000*K080*<BIO>*<O3>
 PTERMS(:,30,80) = +0.15000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(ORA2,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,31,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(MO2,K080) = +0.03000*K080*<BIO>*<O3>
 PTERMS(:,32,80) = +0.03000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT14
!
SUBROUTINE SUBT15
!
!Indices 301 a 320
!
!PTERMS(ALKAP,K080) = +0.00000*K080*<BIO>*<O3>
 PTERMS(:,33,80) = +0.00000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(CARBOP,K080) = +0.17000*K080*<BIO>*<O3>
 PTERMS(:,39,80) = +0.17000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(XO2,K080) = +0.13000*K080*<BIO>*<O3>
 PTERMS(:,41,80) = +0.13000*TPK%K080(:)*PCONC(:,20)*PCONC(:,1)
!
!PTERMS(O3,K081) = -K081*<CARBO>*<O3>
 PTERMS(:,1,81) = -TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(CO,K081) = +0.64728*K081*<CARBO>*<O3>
 PTERMS(:,13,81) = +0.64728*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(OH,K081) = +0.20595*K081*<CARBO>*<O3>
 PTERMS(:,14,81) = +0.20595*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(HO2,K081) = +0.28441*K081*<CARBO>*<O3>
 PTERMS(:,15,81) = +0.28441*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(HCHO,K081) = +0.00000*K081*<CARBO>*<O3>
 PTERMS(:,22,81) = +0.00000*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(ALD,K081) = +0.15692*K081*<CARBO>*<O3>
 PTERMS(:,23,81) = +0.15692*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(CARBO,K081) = -K081*<CARBO>*<O3>
 PTERMS(:,25,81) = -TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(OP2,K081) = +0.10149*K081*<CARBO>*<O3>
 PTERMS(:,29,81) = +0.10149*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(ORA1,K081) = +0.10788*K081*<CARBO>*<O3>
 PTERMS(:,30,81) = +0.10788*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(ORA2,K081) = +0.20595*K081*<CARBO>*<O3>
 PTERMS(:,31,81) = +0.20595*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(CARBOP,K081) = +0.27460*K081*<CARBO>*<O3>
 PTERMS(:,39,81) = +0.27460*TPK%K081(:)*PCONC(:,25)*PCONC(:,1)
!
!PTERMS(O3,K082) = -K082*<PAN>*<O3>
 PTERMS(:,1,82) = -TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(NO2,K082) = +0.70*K082*<PAN>*<O3>
 PTERMS(:,4,82) = +0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(CO,K082) = +0.13*K082*<PAN>*<O3>
 PTERMS(:,13,82) = +0.13*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(OH,K082) = +0.036*K082*<PAN>*<O3>
 PTERMS(:,14,82) = +0.036*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(HO2,K082) = +0.08*K082*<PAN>*<O3>
 PTERMS(:,15,82) = +0.08*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(HCHO,K082) = +0.70*K082*<PAN>*<O3>
 PTERMS(:,22,82) = +0.70*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT15
!
SUBROUTINE SUBT16
!
!Indices 321 a 340
!
!PTERMS(PAN,K082) = -K082*<PAN>*<O3>
 PTERMS(:,27,82) = -TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(ORA1,K082) = +0.11*K082*<PAN>*<O3>
 PTERMS(:,30,82) = +0.11*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(CARBOP,K082) = +0.70000*K082*<PAN>*<O3>
 PTERMS(:,39,82) = +0.70000*TPK%K082(:)*PCONC(:,27)*PCONC(:,1)
!
!PTERMS(NO2,K083) = -K083*<PHO>*<NO2>
 PTERMS(:,4,83) = -TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(ARO,K083) = +0.10670*K083*<PHO>*<NO2>
 PTERMS(:,21,83) = +0.10670*TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(ONIT,K083) = +K083*<PHO>*<NO2>
 PTERMS(:,26,83) = +TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(PHO,K083) = -K083*<PHO>*<NO2>
 PTERMS(:,36,83) = -TPK%K083(:)*PCONC(:,36)*PCONC(:,4)
!
!PTERMS(HO2,K084) = -K084*<PHO>*<HO2>
 PTERMS(:,15,84) = -TPK%K084(:)*PCONC(:,36)*PCONC(:,15)
!
!PTERMS(ARO,K084) = +1.06698*K084*<PHO>*<HO2>
 PTERMS(:,21,84) = +1.06698*TPK%K084(:)*PCONC(:,36)*PCONC(:,15)
!
!PTERMS(PHO,K084) = -K084*<PHO>*<HO2>
 PTERMS(:,36,84) = -TPK%K084(:)*PCONC(:,36)*PCONC(:,15)
!
!PTERMS(NO2,K085) = -K085*<ADD>*<NO2>
 PTERMS(:,4,85) = -TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(HONO,K085) = +K085*<ADD>*<NO2>
 PTERMS(:,7,85) = +TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(ARO,K085) = +K085*<ADD>*<NO2>
 PTERMS(:,21,85) = +TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(ADD,K085) = -K085*<ADD>*<NO2>
 PTERMS(:,37,85) = -TPK%K085(:)*PCONC(:,37)*PCONC(:,4)
!
!PTERMS(HO2,K086) = +0.02*K086*<ADD>*<O2>
 PTERMS(:,15,86) = +0.02*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(ARO,K086) = +0.02*K086*<ADD>*<O2>
 PTERMS(:,21,86) = +0.02*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(ADD,K086) = -K086*<ADD>*<O2>
 PTERMS(:,37,86) = -TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(AROP,K086) = +0.98*K086*<ADD>*<O2>
 PTERMS(:,38,86) = +0.98*TPK%K086(:)*PCONC(:,37)*TPK%O2(:)
!
!PTERMS(O3,K087) = -K087*<ADD>*<O3>
 PTERMS(:,1,87) = -TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!PTERMS(OH,K087) = +K087*<ADD>*<O3>
 PTERMS(:,14,87) = +TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!
RETURN
END SUBROUTINE SUBT16
!
SUBROUTINE SUBT17
!
!Indices 341 a 360
!
!PTERMS(ARO,K087) = +K087*<ADD>*<O3>
 PTERMS(:,21,87) = +TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!PTERMS(ADD,K087) = -K087*<ADD>*<O3>
 PTERMS(:,37,87) = -TPK%K087(:)*PCONC(:,37)*PCONC(:,1)
!
!PTERMS(NO2,K088) = -K088*<CARBOP>*<NO2>
 PTERMS(:,4,88) = -TPK%K088(:)*PCONC(:,39)*PCONC(:,4)
!
!PTERMS(PAN,K088) = +1.00000*K088*<CARBOP>*<NO2>
 PTERMS(:,27,88) = +1.00000*TPK%K088(:)*PCONC(:,39)*PCONC(:,4)
!
!PTERMS(CARBOP,K088) = -K088*<CARBOP>*<NO2>
 PTERMS(:,39,88) = -TPK%K088(:)*PCONC(:,39)*PCONC(:,4)
!
!PTERMS(NO2,K089) = +K089*<PAN>
 PTERMS(:,4,89) = +TPK%K089(:)*PCONC(:,27)
!
!PTERMS(PAN,K089) = -K089*<PAN>
 PTERMS(:,27,89) = -TPK%K089(:)*PCONC(:,27)
!
!PTERMS(CARBOP,K089) = +1.00000*K089*<PAN>
 PTERMS(:,39,89) = +1.00000*TPK%K089(:)*PCONC(:,27)
!
!PTERMS(NO,K090) = -K090*<MO2>*<NO>
 PTERMS(:,3,90) = -TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(NO2,K090) = +K090*<MO2>*<NO>
 PTERMS(:,4,90) = +TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(HO2,K090) = +K090*<MO2>*<NO>
 PTERMS(:,15,90) = +TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(HCHO,K090) = +K090*<MO2>*<NO>
 PTERMS(:,22,90) = +TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(MO2,K090) = -K090*<MO2>*<NO>
 PTERMS(:,32,90) = -TPK%K090(:)*PCONC(:,32)*PCONC(:,3)
!
!PTERMS(NO,K091) = -K091*<ALKAP>*<NO>
 PTERMS(:,3,91) = -TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(NO2,K091) = +0.91541*K091*<ALKAP>*<NO>
 PTERMS(:,4,91) = +0.91541*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(HO2,K091) = +0.74265*K091*<ALKAP>*<NO>
 PTERMS(:,15,91) = +0.74265*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(HCHO,K091) = +0.03002*K091*<ALKAP>*<NO>
 PTERMS(:,22,91) = +0.03002*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(ALD,K091) = +0.33144*K091*<ALKAP>*<NO>
 PTERMS(:,23,91) = +0.33144*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(KET,K091) = +0.54531*K091*<ALKAP>*<NO>
 PTERMS(:,24,91) = +0.54531*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(CARBO,K091) = +0.03407*K091*<ALKAP>*<NO>
 PTERMS(:,25,91) = +0.03407*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT17
!
SUBROUTINE SUBT18
!
!Indices 361 a 380
!
!PTERMS(ONIT,K091) = +0.08459*K091*<ALKAP>*<NO>
 PTERMS(:,26,91) = +0.08459*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(MO2,K091) = +0.09016*K091*<ALKAP>*<NO>
 PTERMS(:,32,91) = +0.09016*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(ALKAP,K091) = -K091*<ALKAP>*<NO>
 PTERMS(:,33,91) = -TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(XO2,K091) = +0.13007*K091*<ALKAP>*<NO>
 PTERMS(:,41,91) = +0.13007*TPK%K091(:)*PCONC(:,33)*PCONC(:,3)
!
!PTERMS(NO,K092) = -K092*<ALKEP>*<NO>
 PTERMS(:,3,92) = -TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(NO2,K092) = +K092*<ALKEP>*<NO>
 PTERMS(:,4,92) = +TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(HO2,K092) = +K092*<ALKEP>*<NO>
 PTERMS(:,15,92) = +TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(HCHO,K092) = +1.39870*K092*<ALKEP>*<NO>
 PTERMS(:,22,92) = +1.39870*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(ALD,K092) = +0.42125*K092*<ALKEP>*<NO>
 PTERMS(:,23,92) = +0.42125*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(KET,K092) = +0.05220*K092*<ALKEP>*<NO>
 PTERMS(:,24,92) = +0.05220*TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(ALKEP,K092) = -K092*<ALKEP>*<NO>
 PTERMS(:,34,92) = -TPK%K092(:)*PCONC(:,34)*PCONC(:,3)
!
!PTERMS(NO,K093) = -K093*<BIOP>*<NO>
 PTERMS(:,3,93) = -TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(NO2,K093) = +0.84700*K093*<BIOP>*<NO>
 PTERMS(:,4,93) = +0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(HO2,K093) = +0.84700*K093*<BIOP>*<NO>
 PTERMS(:,15,93) = +0.84700*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(ALKE,K093) = +0.37815*K093*<BIOP>*<NO>
 PTERMS(:,19,93) = +0.37815*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(HCHO,K093) = +0.60600*K093*<BIOP>*<NO>
 PTERMS(:,22,93) = +0.60600*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(ALD,K093) = +0.00000*K093*<BIOP>*<NO>
 PTERMS(:,23,93) = +0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(KET,K093) = +0.00000*K093*<BIOP>*<NO>
 PTERMS(:,24,93) = +0.00000*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(CARBO,K093) = +0.45463*K093*<BIOP>*<NO>
 PTERMS(:,25,93) = +0.45463*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(ONIT,K093) = +0.15300*K093*<BIOP>*<NO>
 PTERMS(:,26,93) = +0.15300*TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT18
!
SUBROUTINE SUBT19
!
!Indices 381 a 400
!
!PTERMS(BIOP,K093) = -K093*<BIOP>*<NO>
 PTERMS(:,35,93) = -TPK%K093(:)*PCONC(:,35)*PCONC(:,3)
!
!PTERMS(NO,K094) = -K094*<AROP>*<NO>
 PTERMS(:,3,94) = -TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(NO2,K094) = +0.95115*K094*<AROP>*<NO>
 PTERMS(:,4,94) = +0.95115*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(HO2,K094) = +0.95115*K094*<AROP>*<NO>
 PTERMS(:,15,94) = +0.95115*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(CARBO,K094) = +2.06993*K094*<AROP>*<NO>
 PTERMS(:,25,94) = +2.06993*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(ONIT,K094) = +0.04885*K094*<AROP>*<NO>
 PTERMS(:,26,94) = +0.04885*TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(AROP,K094) = -K094*<AROP>*<NO>
 PTERMS(:,38,94) = -TPK%K094(:)*PCONC(:,38)*PCONC(:,3)
!
!PTERMS(NO,K095) = -K095*<CARBOP>*<NO>
 PTERMS(:,3,95) = -TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(NO2,K095) = +K095*<CARBOP>*<NO>
 PTERMS(:,4,95) = +TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(HO2,K095) = +0.12334*K095*<CARBOP>*<NO>
 PTERMS(:,15,95) = +0.12334*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(HCHO,K095) = +0.05848*K095*<CARBOP>*<NO>
 PTERMS(:,22,95) = +0.05848*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(ALD,K095) = +0.07368*K095*<CARBOP>*<NO>
 PTERMS(:,23,95) = +0.07368*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(CARBO,K095) = +0.08670*K095*<CARBOP>*<NO>
 PTERMS(:,25,95) = +0.08670*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(MO2,K095) = +0.78134*K095*<CARBOP>*<NO>
 PTERMS(:,32,95) = +0.78134*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(CARBOP,K095) = -K095*<CARBOP>*<NO>
 PTERMS(:,39,95) = -TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(XO2,K095) = +0.02563*K095*<CARBOP>*<NO>
 PTERMS(:,41,95) = +0.02563*TPK%K095(:)*PCONC(:,39)*PCONC(:,3)
!
!PTERMS(NO,K096) = -K096*<OLN>*<NO>
 PTERMS(:,3,96) = -TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(NO2,K096) = +1.81599*K096*<OLN>*<NO>
 PTERMS(:,4,96) = +1.81599*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(HO2,K096) = +0.18401*K096*<OLN>*<NO>
 PTERMS(:,15,96) = +0.18401*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(HCHO,K096) = +0.23419*K096*<OLN>*<NO>
 PTERMS(:,22,96) = +0.23419*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT19
!
SUBROUTINE SUBT20
!
!Indices 401 a 420
!
!PTERMS(ALD,K096) = +1.01182*K096*<OLN>*<NO>
 PTERMS(:,23,96) = +1.01182*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(KET,K096) = +0.37862*K096*<OLN>*<NO>
 PTERMS(:,24,96) = +0.37862*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(ONIT,K096) = +0.18401*K096*<OLN>*<NO>
 PTERMS(:,26,96) = +0.18401*TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(OLN,K096) = -K096*<OLN>*<NO>
 PTERMS(:,40,96) = -TPK%K096(:)*PCONC(:,40)*PCONC(:,3)
!
!PTERMS(HO2,K097) = -K097*<MO2>*<HO2>
 PTERMS(:,15,97) = -TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!
!PTERMS(OP1,K097) = +K097*<MO2>*<HO2>
 PTERMS(:,28,97) = +TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!
!PTERMS(MO2,K097) = -K097*<MO2>*<HO2>
 PTERMS(:,32,97) = -TPK%K097(:)*PCONC(:,32)*PCONC(:,15)
!
!PTERMS(HO2,K098) = -K098*<ALKAP>*<HO2>
 PTERMS(:,15,98) = -TPK%K098(:)*PCONC(:,33)*PCONC(:,15)
!
!PTERMS(OP2,K098) = +1.00524*K098*<ALKAP>*<HO2>
 PTERMS(:,29,98) = +1.00524*TPK%K098(:)*PCONC(:,33)*PCONC(:,15)
!
!PTERMS(ALKAP,K098) = -K098*<ALKAP>*<HO2>
 PTERMS(:,33,98) = -TPK%K098(:)*PCONC(:,33)*PCONC(:,15)
!
!PTERMS(HO2,K099) = -K099*<ALKEP>*<HO2>
 PTERMS(:,15,99) = -TPK%K099(:)*PCONC(:,34)*PCONC(:,15)
!
!PTERMS(OP2,K099) = +1.00524*K099*<ALKEP>*<HO2>
 PTERMS(:,29,99) = +1.00524*TPK%K099(:)*PCONC(:,34)*PCONC(:,15)
!
!PTERMS(ALKEP,K099) = -K099*<ALKEP>*<HO2>
 PTERMS(:,34,99) = -TPK%K099(:)*PCONC(:,34)*PCONC(:,15)
!
!PTERMS(HO2,K0100) = -K0100*<BIOP>*<HO2>
 PTERMS(:,15,100) = -TPK%K0100(:)*PCONC(:,35)*PCONC(:,15)
!
!PTERMS(OP2,K0100) = +1.00524*K0100*<BIOP>*<HO2>
 PTERMS(:,29,100) = +1.00524*TPK%K0100(:)*PCONC(:,35)*PCONC(:,15)
!
!PTERMS(BIOP,K0100) = -K0100*<BIOP>*<HO2>
 PTERMS(:,35,100) = -TPK%K0100(:)*PCONC(:,35)*PCONC(:,15)
!
!PTERMS(HO2,K0101) = -K0101*<AROP>*<HO2>
 PTERMS(:,15,101) = -TPK%K0101(:)*PCONC(:,38)*PCONC(:,15)
!
!PTERMS(OP2,K0101) = +1.00524*K0101*<AROP>*<HO2>
 PTERMS(:,29,101) = +1.00524*TPK%K0101(:)*PCONC(:,38)*PCONC(:,15)
!
!PTERMS(AROP,K0101) = -K0101*<AROP>*<HO2>
 PTERMS(:,38,101) = -TPK%K0101(:)*PCONC(:,38)*PCONC(:,15)
!
!PTERMS(O3,K0102) = +0.17307*K0102*<CARBOP>*<HO2>
 PTERMS(:,1,102) = +0.17307*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!
RETURN
END SUBROUTINE SUBT20
!
SUBROUTINE SUBT21
!
!Indices 421 a 440
!
!PTERMS(HO2,K0102) = -K0102*<CARBOP>*<HO2>
 PTERMS(:,15,102) = -TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(OP2,K0102) = +0.80904*K0102*<CARBOP>*<HO2>
 PTERMS(:,29,102) = +0.80904*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(ORA2,K0102) = +0.17307*K0102*<CARBOP>*<HO2>
 PTERMS(:,31,102) = +0.17307*TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(CARBOP,K0102) = -K0102*<CARBOP>*<HO2>
 PTERMS(:,39,102) = -TPK%K0102(:)*PCONC(:,39)*PCONC(:,15)
!
!PTERMS(HO2,K103) = -K103*<OLN>*<HO2>
 PTERMS(:,15,103) = -TPK%K103(:)*PCONC(:,40)*PCONC(:,15)
!
!PTERMS(ONIT,K103) = +K103*<OLN>*<HO2>
 PTERMS(:,26,103) = +TPK%K103(:)*PCONC(:,40)*PCONC(:,15)
!
!PTERMS(OLN,K103) = -K103*<OLN>*<HO2>
 PTERMS(:,40,103) = -TPK%K103(:)*PCONC(:,40)*PCONC(:,15)
!
!PTERMS(HO2,K104) = +0.66*K104*<MO2>*<MO2>
 PTERMS(:,15,104) = +0.66*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)
!
!PTERMS(HCHO,K104) = +1.33*K104*<MO2>*<MO2>
 PTERMS(:,22,104) = +1.33*TPK%K104(:)*PCONC(:,32)*PCONC(:,32)
!
!PTERMS(MO2,K104) = -K104*<MO2>*<MO2>
 PTERMS(:,32,104) = -TPK%K104(:)*PCONC(:,32)*PCONC(:,32)
!
!PTERMS(HO2,K105) = +0.98383*K105*<ALKAP>*<MO2>
 PTERMS(:,15,105) = +0.98383*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(HCHO,K105) = +0.80556*K105*<ALKAP>*<MO2>
 PTERMS(:,22,105) = +0.80556*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(ALD,K105) = +0.56070*K105*<ALKAP>*<MO2>
 PTERMS(:,23,105) = +0.56070*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(KET,K105) = +0.09673*K105*<ALKAP>*<MO2>
 PTERMS(:,24,105) = +0.09673*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(CARBO,K105) = +0.07976*K105*<ALKAP>*<MO2>
 PTERMS(:,25,105) = +0.07976*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(MO2,K105) = -K105*<ALKAP>*<MO2>
 PTERMS(:,32,105) = -TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(ALKAP,K105) = -K105*<ALKAP>*<MO2>
 PTERMS(:,33,105) = -TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(XO2,K105) = +0.13370*K105*<ALKAP>*<MO2>
 PTERMS(:,41,105) = +0.13370*TPK%K105(:)*PCONC(:,33)*PCONC(:,32)
!
!PTERMS(HO2,K106) = +K106*<ALKEP>*<MO2>
 PTERMS(:,15,106) = +TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(HCHO,K106) = +1.42894*K106*<ALKEP>*<MO2>
 PTERMS(:,22,106) = +1.42894*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!
RETURN
END SUBROUTINE SUBT21
!
SUBROUTINE SUBT22
!
!Indices 441 a 460
!
!PTERMS(ALD,K106) = +0.46413*K106*<ALKEP>*<MO2>
 PTERMS(:,23,106) = +0.46413*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(KET,K106) = +0.03814*K106*<ALKEP>*<MO2>
 PTERMS(:,24,106) = +0.03814*TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(MO2,K106) = -K106*<ALKEP>*<MO2>
 PTERMS(:,32,106) = -TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(ALKEP,K106) = -K106*<ALKEP>*<MO2>
 PTERMS(:,34,106) = -TPK%K106(:)*PCONC(:,34)*PCONC(:,32)
!
!PTERMS(HO2,K107) = +1.00000*K107*<BIOP>*<MO2>
 PTERMS(:,15,107) = +1.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(ALKE,K107) = +0.48074*K107*<BIOP>*<MO2>
 PTERMS(:,19,107) = +0.48074*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(HCHO,K107) = +1.09000*K107*<BIOP>*<MO2>
 PTERMS(:,22,107) = +1.09000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(ALD,K107) = +0.00000*K107*<BIOP>*<MO2>
 PTERMS(:,23,107) = +0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(KET,K107) = +0.00000*K107*<BIOP>*<MO2>
 PTERMS(:,24,107) = +0.00000*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(CARBO,K107) = +0.56064*K107*<BIOP>*<MO2>
 PTERMS(:,25,107) = +0.56064*TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(MO2,K107) = -K107*<BIOP>*<MO2>
 PTERMS(:,32,107) = -TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(BIOP,K107) = -K107*<BIOP>*<MO2>
 PTERMS(:,35,107) = -TPK%K107(:)*PCONC(:,35)*PCONC(:,32)
!
!PTERMS(HO2,K108) = +1.02767*K108*<AROP>*<MO2>
 PTERMS(:,15,108) = +1.02767*TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(HCHO,K108) = +K108*<AROP>*<MO2>
 PTERMS(:,22,108) = +TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(CARBO,K108) = +1.99461*K108*<AROP>*<MO2>
 PTERMS(:,25,108) = +1.99461*TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(MO2,K108) = -K108*<AROP>*<MO2>
 PTERMS(:,32,108) = -TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(AROP,K108) = -K108*<AROP>*<MO2>
 PTERMS(:,38,108) = -TPK%K108(:)*PCONC(:,38)*PCONC(:,32)
!
!PTERMS(HO2,K109) = +0.82998*K109*<CARBOP>*<MO2>
 PTERMS(:,15,109) = +0.82998*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(HCHO,K109) = +0.95723*K109*<CARBOP>*<MO2>
 PTERMS(:,22,109) = +0.95723*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(ALD,K109) = +0.08295*K109*<CARBOP>*<MO2>
 PTERMS(:,23,109) = +0.08295*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!
RETURN
END SUBROUTINE SUBT22
!
SUBROUTINE SUBT23
!
!Indices 461 a 480
!
!PTERMS(CARBO,K109) = +0.15387*K109*<CARBOP>*<MO2>
 PTERMS(:,25,109) = +0.15387*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(ORA2,K109) = +0.13684*K109*<CARBOP>*<MO2>
 PTERMS(:,31,109) = +0.13684*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(MO2,K109) = -K109*<CARBOP>*<MO2>
 PTERMS(:,32,109) = -TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(CARBOP,K109) = -K109*<CARBOP>*<MO2>
 PTERMS(:,39,109) = -TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(XO2,K109) = +0.02212*K109*<CARBOP>*<MO2>
 PTERMS(:,41,109) = +0.02212*TPK%K109(:)*PCONC(:,39)*PCONC(:,32)
!
!PTERMS(NO2,K110) = +0.32440*K110*<OLN>*<MO2>
 PTERMS(:,4,110) = +0.32440*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(HO2,K110) = +0.67560*K110*<OLN>*<MO2>
 PTERMS(:,15,110) = +0.67560*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(HCHO,K110) = +0.88625*K110*<OLN>*<MO2>
 PTERMS(:,22,110) = +0.88625*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(ALD,K110) = +0.41524*K110*<OLN>*<MO2>
 PTERMS(:,23,110) = +0.41524*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(KET,K110) = +0.09667*K110*<OLN>*<MO2>
 PTERMS(:,24,110) = +0.09667*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(ONIT,K110) = +0.67560*K110*<OLN>*<MO2>
 PTERMS(:,26,110) = +0.67560*TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(MO2,K110) = -K110*<OLN>*<MO2>
 PTERMS(:,32,110) = -TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(OLN,K110) = -K110*<OLN>*<MO2>
 PTERMS(:,40,110) = -TPK%K110(:)*PCONC(:,40)*PCONC(:,32)
!
!PTERMS(HO2,K111) = +0.48079*K111*<ALKAP>*<CARBOP>
 PTERMS(:,15,111) = +0.48079*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(HCHO,K111) = +0.07600*K111*<ALKAP>*<CARBOP>
 PTERMS(:,22,111) = +0.07600*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(ALD,K111) = +0.71461*K111*<ALKAP>*<CARBOP>
 PTERMS(:,23,111) = +0.71461*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(KET,K111) = +0.18819*K111*<ALKAP>*<CARBOP>
 PTERMS(:,24,111) = +0.18819*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(CARBO,K111) = +0.06954*K111*<ALKAP>*<CARBOP>
 PTERMS(:,25,111) = +0.06954*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(ORA2,K111) = +0.49810*K111*<ALKAP>*<CARBOP>
 PTERMS(:,31,111) = +0.49810*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(MO2,K111) = +0.51480*K111*<ALKAP>*<CARBOP>
 PTERMS(:,32,111) = +0.51480*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!
RETURN
END SUBROUTINE SUBT23
!
SUBROUTINE SUBT24
!
!Indices 481 a 500
!
!PTERMS(ALKAP,K111) = -K111*<ALKAP>*<CARBOP>
 PTERMS(:,33,111) = -TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(CARBOP,K111) = -K111*<ALKAP>*<CARBOP>
 PTERMS(:,39,111) = -TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(XO2,K111) = +0.11306*K111*<ALKAP>*<CARBOP>
 PTERMS(:,41,111) = +0.11306*TPK%K111(:)*PCONC(:,33)*PCONC(:,39)
!
!PTERMS(HO2,K112) = +0.50078*K112*<ALKEP>*<CARBOP>
 PTERMS(:,15,112) = +0.50078*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(HCHO,K112) = +0.68192*K112*<ALKEP>*<CARBOP>
 PTERMS(:,22,112) = +0.68192*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(ALD,K112) = +0.68374*K112*<ALKEP>*<CARBOP>
 PTERMS(:,23,112) = +0.68374*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(KET,K112) = +0.06579*K112*<ALKEP>*<CARBOP>
 PTERMS(:,24,112) = +0.06579*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(ORA2,K112) = +0.49922*K112*<ALKEP>*<CARBOP>
 PTERMS(:,31,112) = +0.49922*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(MO2,K112) = +0.50078*K112*<ALKEP>*<CARBOP>
 PTERMS(:,32,112) = +0.50078*TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(ALKEP,K112) = -K112*<ALKEP>*<CARBOP>
 PTERMS(:,34,112) = -TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(CARBOP,K112) = -K112*<ALKEP>*<CARBOP>
 PTERMS(:,39,112) = -TPK%K112(:)*PCONC(:,34)*PCONC(:,39)
!
!PTERMS(HO2,K113) = +0.50600*K113*<BIOP>*<CARBOP>
 PTERMS(:,15,113) = +0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(ALKE,K113) = +0.24463*K113*<BIOP>*<CARBOP>
 PTERMS(:,19,113) = +0.24463*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(HCHO,K113) = +0.34000*K113*<BIOP>*<CARBOP>
 PTERMS(:,22,113) = +0.34000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(ALD,K113) = +0.00000*K113*<BIOP>*<CARBOP>
 PTERMS(:,23,113) = +0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(KET,K113) = +0.00000*K113*<BIOP>*<CARBOP>
 PTERMS(:,24,113) = +0.00000*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(CARBO,K113) = +0.78591*K113*<BIOP>*<CARBOP>
 PTERMS(:,25,113) = +0.78591*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(ORA2,K113) = +0.49400*K113*<BIOP>*<CARBOP>
 PTERMS(:,31,113) = +0.49400*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(MO2,K113) = +0.50600*K113*<BIOP>*<CARBOP>
 PTERMS(:,32,113) = +0.50600*TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(BIOP,K113) = -K113*<BIOP>*<CARBOP>
 PTERMS(:,35,113) = -TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!
RETURN
END SUBROUTINE SUBT24
!
SUBROUTINE SUBT25
!
!Indices 501 a 520
!
!PTERMS(CARBOP,K113) = -K113*<BIOP>*<CARBOP>
 PTERMS(:,39,113) = -TPK%K113(:)*PCONC(:,35)*PCONC(:,39)
!
!PTERMS(HO2,K114) = +K114*<AROP>*<CARBOP>
 PTERMS(:,15,114) = +TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(CARBO,K114) = +1.99455*K114*<AROP>*<CARBOP>
 PTERMS(:,25,114) = +1.99455*TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(MO2,K114) = +K114*<AROP>*<CARBOP>
 PTERMS(:,32,114) = +TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(AROP,K114) = -K114*<AROP>*<CARBOP>
 PTERMS(:,38,114) = -TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(CARBOP,K114) = -K114*<AROP>*<CARBOP>
 PTERMS(:,39,114) = -TPK%K114(:)*PCONC(:,38)*PCONC(:,39)
!
!PTERMS(HO2,K115) = +0.07566*K115*<CARBOP>*<CARBOP>
 PTERMS(:,15,115) = +0.07566*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(HCHO,K115) = +0.03432*K115*<CARBOP>*<CARBOP>
 PTERMS(:,22,115) = +0.03432*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(ALD,K115) = +0.06969*K115*<CARBOP>*<CARBOP>
 PTERMS(:,23,115) = +0.06969*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(KET,K115) = +0.02190*K115*<CARBOP>*<CARBOP>
 PTERMS(:,24,115) = +0.02190*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(CARBO,K115) = +0.10777*K115*<CARBOP>*<CARBOP>
 PTERMS(:,25,115) = +0.10777*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(ORA2,K115) = +0.09955*K115*<CARBOP>*<CARBOP>
 PTERMS(:,31,115) = +0.09955*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(MO2,K115) = +1.66702*K115*<CARBOP>*<CARBOP>
 PTERMS(:,32,115) = +1.66702*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(CARBOP,K115) = -K115*<CARBOP>*<CARBOP>
 PTERMS(:,39,115) = -TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(XO2,K115) = +0.01593*K115*<CARBOP>*<CARBOP>
 PTERMS(:,41,115) = +0.01593*TPK%K115(:)*PCONC(:,39)*PCONC(:,39)
!
!PTERMS(NO2,K116) = +0.00000*K116*<OLN>*<CARBOP>
 PTERMS(:,4,116) = +0.00000*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(HO2,K116) = +0.17599*K116*<OLN>*<CARBOP>
 PTERMS(:,15,116) = +0.17599*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(HCHO,K116) = +0.13414*K116*<OLN>*<CARBOP>
 PTERMS(:,22,116) = +0.13414*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(ALD,K116) = +0.42122*K116*<OLN>*<CARBOP>
 PTERMS(:,23,116) = +0.42122*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(KET,K116) = +0.10822*K116*<OLN>*<CARBOP>
 PTERMS(:,24,116) = +0.10822*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!
RETURN
END SUBROUTINE SUBT25
!
SUBROUTINE SUBT26
!
!Indices 521 a 540
!
!PTERMS(ONIT,K116) = +0.66562*K116*<OLN>*<CARBOP>
 PTERMS(:,26,116) = +0.66562*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(ORA2,K116) = +0.48963*K116*<OLN>*<CARBOP>
 PTERMS(:,31,116) = +0.48963*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(MO2,K116) = +0.51037*K116*<OLN>*<CARBOP>
 PTERMS(:,32,116) = +0.51037*TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(CARBOP,K116) = -K116*<OLN>*<CARBOP>
 PTERMS(:,39,116) = -TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(OLN,K116) = -K116*<OLN>*<CARBOP>
 PTERMS(:,40,116) = -TPK%K116(:)*PCONC(:,40)*PCONC(:,39)
!
!PTERMS(HO2,K117) = +K117*<OLN>*<OLN>
 PTERMS(:,15,117) = +TPK%K117(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(ONIT,K117) = +2.00*K117*<OLN>*<OLN>
 PTERMS(:,26,117) = +2.00*TPK%K117(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(OLN,K117) = -K117*<OLN>*<OLN>
 PTERMS(:,40,117) = -TPK%K117(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(NO2,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,4,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(HO2,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,15,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(HCHO,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,22,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(ALD,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,23,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(KET,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,24,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(ONIT,K118) = +0.00000*K118*<OLN>*<OLN>
 PTERMS(:,26,118) = +0.00000*TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(OLN,K118) = -K118*<OLN>*<OLN>
 PTERMS(:,40,118) = -TPK%K118(:)*PCONC(:,40)*PCONC(:,40)
!
!PTERMS(NO2,K119) = +K119*<MO2>*<NO3>
 PTERMS(:,4,119) = +TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(NO3,K119) = -K119*<MO2>*<NO3>
 PTERMS(:,5,119) = -TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(HO2,K119) = +K119*<MO2>*<NO3>
 PTERMS(:,15,119) = +TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(HCHO,K119) = +K119*<MO2>*<NO3>
 PTERMS(:,22,119) = +TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!PTERMS(MO2,K119) = -K119*<MO2>*<NO3>
 PTERMS(:,32,119) = -TPK%K119(:)*PCONC(:,32)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT26
!
SUBROUTINE SUBT27
!
!Indices 541 a 560
!
!PTERMS(NO2,K120) = +K120*<ALKAP>*<NO3>
 PTERMS(:,4,120) = +TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(NO3,K120) = -K120*<ALKAP>*<NO3>
 PTERMS(:,5,120) = -TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(HO2,K120) = +0.81290*K120*<ALKAP>*<NO3>
 PTERMS(:,15,120) = +0.81290*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(HCHO,K120) = +0.03142*K120*<ALKAP>*<NO3>
 PTERMS(:,22,120) = +0.03142*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(ALD,K120) = +0.33743*K120*<ALKAP>*<NO3>
 PTERMS(:,23,120) = +0.33743*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(KET,K120) = +0.62978*K120*<ALKAP>*<NO3>
 PTERMS(:,24,120) = +0.62978*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(CARBO,K120) = +0.03531*K120*<ALKAP>*<NO3>
 PTERMS(:,25,120) = +0.03531*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(MO2,K120) = +0.09731*K120*<ALKAP>*<NO3>
 PTERMS(:,32,120) = +0.09731*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(ALKAP,K120) = -K120*<ALKAP>*<NO3>
 PTERMS(:,33,120) = -TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(XO2,K120) = +0.16271*K120*<ALKAP>*<NO3>
 PTERMS(:,41,120) = +0.16271*TPK%K120(:)*PCONC(:,33)*PCONC(:,5)
!
!PTERMS(NO2,K121) = +K121*<ALKEP>*<NO3>
 PTERMS(:,4,121) = +TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(NO3,K121) = -K121*<ALKEP>*<NO3>
 PTERMS(:,5,121) = -TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(HO2,K121) = +K121*<ALKEP>*<NO3>
 PTERMS(:,15,121) = +TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(HCHO,K121) = +1.40909*K121*<ALKEP>*<NO3>
 PTERMS(:,22,121) = +1.40909*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(ALD,K121) = +0.43039*K121*<ALKEP>*<NO3>
 PTERMS(:,23,121) = +0.43039*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(KET,K121) = +0.02051*K121*<ALKEP>*<NO3>
 PTERMS(:,24,121) = +0.02051*TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(ALKEP,K121) = -K121*<ALKEP>*<NO3>
 PTERMS(:,34,121) = -TPK%K121(:)*PCONC(:,34)*PCONC(:,5)
!
!PTERMS(NO2,K122) = +K122*<BIOP>*<NO3>
 PTERMS(:,4,122) = +TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(NO3,K122) = -K122*<BIOP>*<NO3>
 PTERMS(:,5,122) = -TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(HO2,K122) = +K122*<BIOP>*<NO3>
 PTERMS(:,15,122) = +TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT27
!
SUBROUTINE SUBT28
!
!Indices 561 a 580
!
!PTERMS(ALKE,K122) = +0.42729*K122*<BIOP>*<NO3>
 PTERMS(:,19,122) = +0.42729*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(HCHO,K122) = +0.68600*K122*<BIOP>*<NO3>
 PTERMS(:,22,122) = +0.68600*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(ALD,K122) = +0.00000*K122*<BIOP>*<NO3>
 PTERMS(:,23,122) = +0.00000*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(KET,K122) = +0.00000*K122*<BIOP>*<NO3>
 PTERMS(:,24,122) = +0.00000*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(CARBO,K122) = +0.61160*K122*<BIOP>*<NO3>
 PTERMS(:,25,122) = +0.61160*TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(BIOP,K122) = -K122*<BIOP>*<NO3>
 PTERMS(:,35,122) = -TPK%K122(:)*PCONC(:,35)*PCONC(:,5)
!
!PTERMS(NO2,K123) = +K123*<AROP>*<NO3>
 PTERMS(:,4,123) = +TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(NO3,K123) = -K123*<AROP>*<NO3>
 PTERMS(:,5,123) = -TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(HO2,K123) = +K123*<AROP>*<NO3>
 PTERMS(:,15,123) = +TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(CARBO,K123) = +2.81904*K123*<AROP>*<NO3>
 PTERMS(:,25,123) = +2.81904*TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(AROP,K123) = -K123*<AROP>*<NO3>
 PTERMS(:,38,123) = -TPK%K123(:)*PCONC(:,38)*PCONC(:,5)
!
!PTERMS(NO2,K124) = +K124*<CARBOP>*<NO3>
 PTERMS(:,4,124) = +TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(NO3,K124) = -K124*<CARBOP>*<NO3>
 PTERMS(:,5,124) = -TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(HO2,K124) = +0.04915*K124*<CARBOP>*<NO3>
 PTERMS(:,15,124) = +0.04915*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(HCHO,K124) = +0.03175*K124*<CARBOP>*<NO3>
 PTERMS(:,22,124) = +0.03175*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(ALD,K124) = +0.02936*K124*<CARBOP>*<NO3>
 PTERMS(:,23,124) = +0.02936*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(CARBO,K124) = +0.03455*K124*<CARBOP>*<NO3>
 PTERMS(:,25,124) = +0.03455*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(MO2,K124) = +0.91910*K124*<CARBOP>*<NO3>
 PTERMS(:,32,124) = +0.91910*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(CARBOP,K124) = -K124*<CARBOP>*<NO3>
 PTERMS(:,39,124) = -TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!PTERMS(XO2,K124) = +0.01021*K124*<CARBOP>*<NO3>
 PTERMS(:,41,124) = +0.01021*TPK%K124(:)*PCONC(:,39)*PCONC(:,5)
!
!
RETURN
END SUBROUTINE SUBT28
!
SUBROUTINE SUBT29
!
!Indices 581 a 600
!
!PTERMS(NO2,K125) = +1.74072*K125*<OLN>*<NO3>
 PTERMS(:,4,125) = +1.74072*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(NO3,K125) = -K125*<OLN>*<NO3>
 PTERMS(:,5,125) = -TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(HO2,K125) = +0.25928*K125*<OLN>*<NO3>
 PTERMS(:,15,125) = +0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(HCHO,K125) = +0.20740*K125*<OLN>*<NO3>
 PTERMS(:,22,125) = +0.20740*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(ALD,K125) = +0.91850*K125*<OLN>*<NO3>
 PTERMS(:,23,125) = +0.91850*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(KET,K125) = +0.34740*K125*<OLN>*<NO3>
 PTERMS(:,24,125) = +0.34740*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(ONIT,K125) = +0.25928*K125*<OLN>*<NO3>
 PTERMS(:,26,125) = +0.25928*TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(OLN,K125) = -K125*<OLN>*<NO3>
 PTERMS(:,40,125) = -TPK%K125(:)*PCONC(:,40)*PCONC(:,5)
!
!PTERMS(HO2,K126) = -K126*<XO2>*<HO2>
 PTERMS(:,15,126) = -TPK%K126(:)*PCONC(:,41)*PCONC(:,15)
!
!PTERMS(OP2,K126) = +1.00524*K126*<XO2>*<HO2>
 PTERMS(:,29,126) = +1.00524*TPK%K126(:)*PCONC(:,41)*PCONC(:,15)
!
!PTERMS(XO2,K126) = -K126*<XO2>*<HO2>
 PTERMS(:,41,126) = -TPK%K126(:)*PCONC(:,41)*PCONC(:,15)
!
!PTERMS(HO2,K127) = +K127*<XO2>*<MO2>
 PTERMS(:,15,127) = +TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(HCHO,K127) = +K127*<XO2>*<MO2>
 PTERMS(:,22,127) = +TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(MO2,K127) = -K127*<XO2>*<MO2>
 PTERMS(:,32,127) = -TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(XO2,K127) = -K127*<XO2>*<MO2>
 PTERMS(:,41,127) = -TPK%K127(:)*PCONC(:,41)*PCONC(:,32)
!
!PTERMS(MO2,K128) = +K128*<XO2>*<CARBOP>
 PTERMS(:,32,128) = +TPK%K128(:)*PCONC(:,41)*PCONC(:,39)
!
!PTERMS(CARBOP,K128) = -K128*<XO2>*<CARBOP>
 PTERMS(:,39,128) = -TPK%K128(:)*PCONC(:,41)*PCONC(:,39)
!
!PTERMS(XO2,K128) = -K128*<XO2>*<CARBOP>
 PTERMS(:,41,128) = -TPK%K128(:)*PCONC(:,41)*PCONC(:,39)
!
!PTERMS(XO2,K129) = -K129*<XO2>*<XO2>
 PTERMS(:,41,129) = -TPK%K129(:)*PCONC(:,41)*PCONC(:,41)
!
!PTERMS(NO,K130) = -K130*<XO2>*<NO>
 PTERMS(:,3,130) = -TPK%K130(:)*PCONC(:,41)*PCONC(:,3)
!
!
RETURN
END SUBROUTINE SUBT29
!
SUBROUTINE SUBT30
!
!Indices 601 a 606
!
!PTERMS(NO2,K130) = +K130*<XO2>*<NO>
 PTERMS(:,4,130) = +TPK%K130(:)*PCONC(:,41)*PCONC(:,3)
!
!PTERMS(XO2,K130) = -K130*<XO2>*<NO>
 PTERMS(:,41,130) = -TPK%K130(:)*PCONC(:,41)*PCONC(:,3)
!
!PTERMS(NO2,K131) = +K131*<XO2>*<NO3>
 PTERMS(:,4,131) = +TPK%K131(:)*PCONC(:,41)*PCONC(:,5)
!
!PTERMS(NO3,K131) = -K131*<XO2>*<NO3>
 PTERMS(:,5,131) = -TPK%K131(:)*PCONC(:,41)*PCONC(:,5)
!
!PTERMS(XO2,K131) = -K131*<XO2>*<NO3>
 PTERMS(:,41,131) = -TPK%K131(:)*PCONC(:,41)*PCONC(:,5)
!
!PTERMS(SULF,K132) = -K132*<SULF>
 PTERMS(:,12,132) = -TPK%K132(:)*PCONC(:,12)
!
!
RETURN
END SUBROUTINE SUBT30
!
END SUBROUTINE CH_TERMS_GAZ
!
!========================================================================
!
!!    ###########################
      MODULE MODI_CH_NONZEROTERMS
!!    ###########################
INTERFACE
SUBROUTINE CH_NONZEROTERMS(KMI, KINDEX, KINDEXDIM)
IMPLICIT NONE
INTEGER, INTENT(IN)                          :: KMI
INTEGER, INTENT(IN)                          :: KINDEXDIM
INTEGER, INTENT(OUT), DIMENSION(2,KINDEXDIM) :: KINDEX
END SUBROUTINE CH_NONZEROTERMS
END INTERFACE
END MODULE MODI_CH_NONZEROTERMS
!
!========================================================================
!
!!    ##################################################
      SUBROUTINE CH_NONZEROTERMS(KMI, KINDEX, KINDEXDIM)
!!    ##################################################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_NONZEROTERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS. 
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME, ONLY : TACCS
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
INTEGER, INTENT(IN)                          :: KMI
INTEGER, INTENT(IN)                          :: KINDEXDIM
INTEGER, INTENT(OUT), DIMENSION(2,KINDEXDIM) :: KINDEX
IF (TACCS(KMI)%LUSECHAQ) THEN
   CALL CH_NONZEROTERMS_AQ
ELSE
   CALL CH_NONZEROTERMS_GAZ
END IF
CONTAINS
!!
!!    #############################
      SUBROUTINE CH_NONZEROTERMS_AQ
!!    #############################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_NONZEROTERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS. 
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!    none
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
! check if output array is large enough
IF (KINDEXDIM.LT.942) THEN
  STOP 'CH_NONZEROTERMS ERROR: array KINDEX is too small!'
END IF
 KINDEX(1, 1)=3
 KINDEX(2, 1)=1
 KINDEX(1, 2)=4
 KINDEX(2, 2)=1
 KINDEX(1, 3)=1
 KINDEX(2, 3)=2
 KINDEX(1, 4)=1
 KINDEX(2, 4)=3
 KINDEX(1, 5)=3
 KINDEX(2, 5)=4
 KINDEX(1, 6)=7
 KINDEX(2, 6)=4
 KINDEX(1, 7)=14
 KINDEX(2, 7)=4
 KINDEX(1, 8)=4
 KINDEX(2, 8)=5
 KINDEX(1, 9)=8
 KINDEX(2, 9)=5
 KINDEX(1, 10)=14
 KINDEX(2, 10)=5
 KINDEX(1, 11)=4
 KINDEX(2, 11)=6
 KINDEX(1, 12)=5
 KINDEX(2, 12)=6
 KINDEX(1, 13)=9
 KINDEX(2, 13)=6
 KINDEX(1, 14)=14
 KINDEX(2, 14)=6
 KINDEX(1, 15)=15
 KINDEX(2, 15)=6
 KINDEX(1, 16)=3
 KINDEX(2, 16)=7
 KINDEX(1, 17)=5
 KINDEX(2, 17)=7
 KINDEX(1, 18)=4
 KINDEX(2, 18)=8
 KINDEX(1, 19)=5
 KINDEX(2, 19)=8
 KINDEX(1, 20)=2
 KINDEX(2, 20)=9
 KINDEX(1, 21)=14
 KINDEX(2, 21)=9
 KINDEX(1, 22)=13
 KINDEX(2, 22)=10
 KINDEX(1, 23)=22
 KINDEX(2, 23)=10
 KINDEX(1, 24)=13
 KINDEX(2, 24)=11
 KINDEX(1, 25)=15
 KINDEX(2, 25)=11
 KINDEX(1, 26)=22
 KINDEX(2, 26)=11
 KINDEX(1, 27)=13
 KINDEX(2, 27)=12
 KINDEX(1, 28)=15
 KINDEX(2, 28)=12
 KINDEX(1, 29)=23
 KINDEX(2, 29)=12
 KINDEX(1, 30)=32
 KINDEX(2, 30)=12
 KINDEX(1, 31)=14
 KINDEX(2, 31)=13
 KINDEX(1, 32)=15
 KINDEX(2, 32)=13
 KINDEX(1, 33)=22
 KINDEX(2, 33)=13
 KINDEX(1, 34)=28
 KINDEX(2, 34)=13
 KINDEX(1, 35)=14
 KINDEX(2, 35)=14
 KINDEX(1, 36)=15
 KINDEX(2, 36)=14
 KINDEX(1, 37)=23
 KINDEX(2, 37)=14
 KINDEX(1, 38)=29
 KINDEX(2, 38)=14
 KINDEX(1, 39)=32
 KINDEX(2, 39)=14
 KINDEX(1, 40)=24
 KINDEX(2, 40)=15
 KINDEX(1, 41)=33
 KINDEX(2, 41)=15
 KINDEX(1, 42)=39
 KINDEX(2, 42)=15
 KINDEX(1, 43)=13
 KINDEX(2, 43)=16
 KINDEX(1, 44)=15
 KINDEX(2, 44)=16
 KINDEX(1, 45)=22
 KINDEX(2, 45)=16
 KINDEX(1, 46)=25
 KINDEX(2, 46)=16
 KINDEX(1, 47)=39
 KINDEX(2, 47)=16
 KINDEX(1, 48)=4
 KINDEX(2, 48)=17
 KINDEX(1, 49)=15
 KINDEX(2, 49)=17
 KINDEX(1, 50)=23
 KINDEX(2, 50)=17
 KINDEX(1, 51)=24
 KINDEX(2, 51)=17
 KINDEX(1, 52)=26
 KINDEX(2, 52)=17
 KINDEX(1, 53)=1
 KINDEX(2, 53)=18
 KINDEX(1, 54)=1
 KINDEX(2, 54)=19
 KINDEX(1, 55)=14
 KINDEX(2, 55)=22
 KINDEX(1, 56)=1
 KINDEX(2, 56)=23
 KINDEX(1, 57)=14
 KINDEX(2, 57)=23
 KINDEX(1, 58)=15
 KINDEX(2, 58)=23
 KINDEX(1, 59)=1
 KINDEX(2, 59)=24
 KINDEX(1, 60)=14
 KINDEX(2, 60)=24
 KINDEX(1, 61)=15
 KINDEX(2, 61)=24
 KINDEX(1, 62)=14
 KINDEX(2, 62)=25
 KINDEX(1, 63)=15
 KINDEX(2, 63)=25
 KINDEX(1, 64)=2
 KINDEX(2, 64)=26
 KINDEX(1, 65)=14
 KINDEX(2, 65)=26
 KINDEX(1, 66)=15
 KINDEX(2, 66)=26
 KINDEX(1, 67)=2
 KINDEX(2, 67)=27
 KINDEX(1, 68)=15
 KINDEX(2, 68)=27
 KINDEX(1, 69)=2
 KINDEX(2, 69)=28
 KINDEX(1, 70)=15
 KINDEX(2, 70)=28
 KINDEX(1, 71)=3
 KINDEX(2, 71)=29
 KINDEX(1, 72)=4
 KINDEX(2, 72)=29
 KINDEX(1, 73)=3
 KINDEX(2, 73)=30
 KINDEX(1, 74)=4
 KINDEX(2, 74)=30
 KINDEX(1, 75)=4
 KINDEX(2, 75)=31
 KINDEX(1, 76)=5
 KINDEX(2, 76)=31
 KINDEX(1, 77)=3
 KINDEX(2, 77)=32
 KINDEX(1, 78)=7
 KINDEX(2, 78)=32
 KINDEX(1, 79)=14
 KINDEX(2, 79)=32
 KINDEX(1, 80)=4
 KINDEX(2, 80)=33
 KINDEX(1, 81)=8
 KINDEX(2, 81)=33
 KINDEX(1, 82)=14
 KINDEX(2, 82)=33
 KINDEX(1, 83)=4
 KINDEX(2, 83)=34
 KINDEX(1, 84)=5
 KINDEX(2, 84)=34
 KINDEX(1, 85)=14
 KINDEX(2, 85)=34
 KINDEX(1, 86)=15
 KINDEX(2, 86)=34
 KINDEX(1, 87)=3
 KINDEX(2, 87)=35
 KINDEX(1, 88)=4
 KINDEX(2, 88)=35
 KINDEX(1, 89)=14
 KINDEX(2, 89)=35
 KINDEX(1, 90)=15
 KINDEX(2, 90)=35
 KINDEX(1, 91)=4
 KINDEX(2, 91)=36
 KINDEX(1, 92)=9
 KINDEX(2, 92)=36
 KINDEX(1, 93)=15
 KINDEX(2, 93)=36
 KINDEX(1, 94)=4
 KINDEX(2, 94)=37
 KINDEX(1, 95)=9
 KINDEX(2, 95)=37
 KINDEX(1, 96)=15
 KINDEX(2, 96)=37
 KINDEX(1, 97)=4
 KINDEX(2, 97)=38
 KINDEX(1, 98)=5
 KINDEX(2, 98)=38
 KINDEX(1, 99)=8
 KINDEX(2, 99)=38
 KINDEX(1, 100)=14
 KINDEX(2, 100)=38
 KINDEX(1, 101)=15
 KINDEX(2, 101)=38
 KINDEX(1, 102)=4
 KINDEX(2, 102)=39
 KINDEX(1, 103)=7
 KINDEX(2, 103)=39
 KINDEX(1, 104)=14
 KINDEX(2, 104)=39
 KINDEX(1, 105)=5
 KINDEX(2, 105)=40
 KINDEX(1, 106)=8
 KINDEX(2, 106)=40
 KINDEX(1, 107)=14
 KINDEX(2, 107)=40
 KINDEX(1, 108)=4
 KINDEX(2, 108)=41
 KINDEX(1, 109)=9
 KINDEX(2, 109)=41
 KINDEX(1, 110)=14
 KINDEX(2, 110)=41
 KINDEX(1, 111)=1
 KINDEX(2, 111)=42
 KINDEX(1, 112)=3
 KINDEX(2, 112)=42
 KINDEX(1, 113)=4
 KINDEX(2, 113)=42
 KINDEX(1, 114)=1
 KINDEX(2, 114)=43
 KINDEX(1, 115)=4
 KINDEX(2, 115)=43
 KINDEX(1, 116)=5
 KINDEX(2, 116)=43
 KINDEX(1, 117)=3
 KINDEX(2, 117)=44
 KINDEX(1, 118)=4
 KINDEX(2, 118)=44
 KINDEX(1, 119)=3
 KINDEX(2, 119)=45
 KINDEX(1, 120)=4
 KINDEX(2, 120)=45
 KINDEX(1, 121)=5
 KINDEX(2, 121)=45
 KINDEX(1, 122)=3
 KINDEX(2, 122)=46
 KINDEX(1, 123)=4
 KINDEX(2, 123)=46
 KINDEX(1, 124)=5
 KINDEX(2, 124)=46
 KINDEX(1, 125)=4
 KINDEX(2, 125)=47
 KINDEX(1, 126)=5
 KINDEX(2, 126)=47
 KINDEX(1, 127)=6
 KINDEX(2, 127)=47
 KINDEX(1, 128)=4
 KINDEX(2, 128)=48
 KINDEX(1, 129)=5
 KINDEX(2, 129)=48
 KINDEX(1, 130)=6
 KINDEX(2, 130)=48
 KINDEX(1, 131)=4
 KINDEX(2, 131)=49
 KINDEX(1, 132)=5
 KINDEX(2, 132)=49
 KINDEX(1, 133)=10
 KINDEX(2, 133)=50
 KINDEX(1, 134)=14
 KINDEX(2, 134)=50
 KINDEX(1, 135)=14
 KINDEX(2, 135)=51
 KINDEX(1, 136)=15
 KINDEX(2, 136)=51
 KINDEX(1, 137)=11
 KINDEX(2, 137)=52
 KINDEX(1, 138)=12
 KINDEX(2, 138)=52
 KINDEX(1, 139)=14
 KINDEX(2, 139)=52
 KINDEX(1, 140)=15
 KINDEX(2, 140)=52
 KINDEX(1, 141)=13
 KINDEX(2, 141)=53
 KINDEX(1, 142)=14
 KINDEX(2, 142)=53
 KINDEX(1, 143)=15
 KINDEX(2, 143)=53
 KINDEX(1, 144)=13
 KINDEX(2, 144)=54
 KINDEX(1, 145)=14
 KINDEX(2, 145)=54
 KINDEX(1, 146)=15
 KINDEX(2, 146)=54
 KINDEX(1, 147)=19
 KINDEX(2, 147)=54
 KINDEX(1, 148)=20
 KINDEX(2, 148)=54
 KINDEX(1, 149)=22
 KINDEX(2, 149)=54
 KINDEX(1, 150)=25
 KINDEX(2, 150)=54
 KINDEX(1, 151)=41
 KINDEX(2, 151)=54
 KINDEX(1, 152)=23
 KINDEX(2, 152)=55
 KINDEX(1, 153)=25
 KINDEX(2, 153)=55
 KINDEX(1, 154)=14
 KINDEX(2, 154)=56
 KINDEX(1, 155)=16
 KINDEX(2, 155)=56
 KINDEX(1, 156)=32
 KINDEX(2, 156)=56
 KINDEX(1, 157)=14
 KINDEX(2, 157)=57
 KINDEX(1, 158)=17
 KINDEX(2, 158)=57
 KINDEX(1, 159)=33
 KINDEX(2, 159)=57
 KINDEX(1, 160)=13
 KINDEX(2, 160)=58
 KINDEX(1, 161)=14
 KINDEX(2, 161)=58
 KINDEX(1, 162)=15
 KINDEX(2, 162)=58
 KINDEX(1, 163)=18
 KINDEX(2, 163)=58
 KINDEX(1, 164)=22
 KINDEX(2, 164)=58
 KINDEX(1, 165)=23
 KINDEX(2, 165)=58
 KINDEX(1, 166)=24
 KINDEX(2, 166)=58
 KINDEX(1, 167)=25
 KINDEX(2, 167)=58
 KINDEX(1, 168)=30
 KINDEX(2, 168)=58
 KINDEX(1, 169)=33
 KINDEX(2, 169)=58
 KINDEX(1, 170)=14
 KINDEX(2, 170)=59
 KINDEX(1, 171)=19
 KINDEX(2, 171)=59
 KINDEX(1, 172)=34
 KINDEX(2, 172)=59
 KINDEX(1, 173)=35
 KINDEX(2, 173)=59
 KINDEX(1, 174)=14
 KINDEX(2, 174)=60
 KINDEX(1, 175)=20
 KINDEX(2, 175)=60
 KINDEX(1, 176)=35
 KINDEX(2, 176)=60
 KINDEX(1, 177)=14
 KINDEX(2, 177)=61
 KINDEX(1, 178)=15
 KINDEX(2, 178)=61
 KINDEX(1, 179)=21
 KINDEX(2, 179)=61
 KINDEX(1, 180)=36
 KINDEX(2, 180)=61
 KINDEX(1, 181)=37
 KINDEX(2, 181)=61
 KINDEX(1, 182)=41
 KINDEX(2, 182)=61
 KINDEX(1, 183)=13
 KINDEX(2, 183)=62
 KINDEX(1, 184)=14
 KINDEX(2, 184)=62
 KINDEX(1, 185)=15
 KINDEX(2, 185)=62
 KINDEX(1, 186)=22
 KINDEX(2, 186)=62
 KINDEX(1, 187)=14
 KINDEX(2, 187)=63
 KINDEX(1, 188)=23
 KINDEX(2, 188)=63
 KINDEX(1, 189)=39
 KINDEX(2, 189)=63
 KINDEX(1, 190)=14
 KINDEX(2, 190)=64
 KINDEX(1, 191)=24
 KINDEX(2, 191)=64
 KINDEX(1, 192)=39
 KINDEX(2, 192)=64
 KINDEX(1, 193)=13
 KINDEX(2, 193)=65
 KINDEX(1, 194)=14
 KINDEX(2, 194)=65
 KINDEX(1, 195)=15
 KINDEX(2, 195)=65
 KINDEX(1, 196)=22
 KINDEX(2, 196)=65
 KINDEX(1, 197)=23
 KINDEX(2, 197)=65
 KINDEX(1, 198)=24
 KINDEX(2, 198)=65
 KINDEX(1, 199)=25
 KINDEX(2, 199)=65
 KINDEX(1, 200)=39
 KINDEX(2, 200)=65
 KINDEX(1, 201)=41
 KINDEX(2, 201)=65
 KINDEX(1, 202)=14
 KINDEX(2, 202)=66
 KINDEX(1, 203)=15
 KINDEX(2, 203)=66
 KINDEX(1, 204)=30
 KINDEX(2, 204)=66
 KINDEX(1, 205)=14
 KINDEX(2, 205)=67
 KINDEX(1, 206)=31
 KINDEX(2, 206)=67
 KINDEX(1, 207)=14
 KINDEX(2, 207)=68
 KINDEX(1, 208)=22
 KINDEX(2, 208)=68
 KINDEX(1, 209)=28
 KINDEX(2, 209)=68
 KINDEX(1, 210)=32
 KINDEX(2, 210)=68
 KINDEX(1, 211)=14
 KINDEX(2, 211)=69
 KINDEX(1, 212)=15
 KINDEX(2, 212)=69
 KINDEX(1, 213)=22
 KINDEX(2, 213)=69
 KINDEX(1, 214)=23
 KINDEX(2, 214)=69
 KINDEX(1, 215)=24
 KINDEX(2, 215)=69
 KINDEX(1, 216)=29
 KINDEX(2, 216)=69
 KINDEX(1, 217)=33
 KINDEX(2, 217)=69
 KINDEX(1, 218)=39
 KINDEX(2, 218)=69
 KINDEX(1, 219)=41
 KINDEX(2, 219)=69
 KINDEX(1, 220)=5
 KINDEX(2, 220)=70
 KINDEX(1, 221)=14
 KINDEX(2, 221)=70
 KINDEX(1, 222)=15
 KINDEX(2, 222)=70
 KINDEX(1, 223)=22
 KINDEX(2, 223)=70
 KINDEX(1, 224)=25
 KINDEX(2, 224)=70
 KINDEX(1, 225)=27
 KINDEX(2, 225)=70
 KINDEX(1, 226)=41
 KINDEX(2, 226)=70
 KINDEX(1, 227)=4
 KINDEX(2, 227)=71
 KINDEX(1, 228)=14
 KINDEX(2, 228)=71
 KINDEX(1, 229)=26
 KINDEX(2, 229)=71
 KINDEX(1, 230)=33
 KINDEX(2, 230)=71
 KINDEX(1, 231)=5
 KINDEX(2, 231)=72
 KINDEX(1, 232)=8
 KINDEX(2, 232)=72
 KINDEX(1, 233)=13
 KINDEX(2, 233)=72
 KINDEX(1, 234)=15
 KINDEX(2, 234)=72
 KINDEX(1, 235)=22
 KINDEX(2, 235)=72
 KINDEX(1, 236)=5
 KINDEX(2, 236)=73
 KINDEX(1, 237)=8
 KINDEX(2, 237)=73
 KINDEX(1, 238)=23
 KINDEX(2, 238)=73
 KINDEX(1, 239)=39
 KINDEX(2, 239)=73
 KINDEX(1, 240)=4
 KINDEX(2, 240)=74
 KINDEX(1, 241)=5
 KINDEX(2, 241)=74
 KINDEX(1, 242)=8
 KINDEX(2, 242)=74
 KINDEX(1, 243)=13
 KINDEX(2, 243)=74
 KINDEX(1, 244)=15
 KINDEX(2, 244)=74
 KINDEX(1, 245)=23
 KINDEX(2, 245)=74
 KINDEX(1, 246)=24
 KINDEX(2, 246)=74
 KINDEX(1, 247)=25
 KINDEX(2, 247)=74
 KINDEX(1, 248)=39
 KINDEX(2, 248)=74
 KINDEX(1, 249)=40
 KINDEX(2, 249)=74
 KINDEX(1, 250)=41
 KINDEX(2, 250)=74
 KINDEX(1, 251)=5
 KINDEX(2, 251)=75
 KINDEX(1, 252)=8
 KINDEX(2, 252)=75
 KINDEX(1, 253)=21
 KINDEX(2, 253)=75
 KINDEX(1, 254)=36
 KINDEX(2, 254)=75
 KINDEX(1, 255)=5
 KINDEX(2, 255)=76
 KINDEX(1, 256)=19
 KINDEX(2, 256)=76
 KINDEX(1, 257)=25
 KINDEX(2, 257)=76
 KINDEX(1, 258)=40
 KINDEX(2, 258)=76
 KINDEX(1, 259)=5
 KINDEX(2, 259)=77
 KINDEX(1, 260)=20
 KINDEX(2, 260)=77
 KINDEX(1, 261)=25
 KINDEX(2, 261)=77
 KINDEX(1, 262)=40
 KINDEX(2, 262)=77
 KINDEX(1, 263)=4
 KINDEX(2, 263)=78
 KINDEX(1, 264)=5
 KINDEX(2, 264)=78
 KINDEX(1, 265)=22
 KINDEX(2, 265)=78
 KINDEX(1, 266)=26
 KINDEX(2, 266)=78
 KINDEX(1, 267)=27
 KINDEX(2, 267)=78
 KINDEX(1, 268)=41
 KINDEX(2, 268)=78
 KINDEX(1, 269)=1
 KINDEX(2, 269)=79
 KINDEX(1, 270)=2
 KINDEX(2, 270)=79
 KINDEX(1, 271)=13
 KINDEX(2, 271)=79
 KINDEX(1, 272)=14
 KINDEX(2, 272)=79
 KINDEX(1, 273)=15
 KINDEX(2, 273)=79
 KINDEX(1, 274)=16
 KINDEX(2, 274)=79
 KINDEX(1, 275)=17
 KINDEX(2, 275)=79
 KINDEX(1, 276)=19
 KINDEX(2, 276)=79
 KINDEX(1, 277)=22
 KINDEX(2, 277)=79
 KINDEX(1, 278)=23
 KINDEX(2, 278)=79
 KINDEX(1, 279)=24
 KINDEX(2, 279)=79
 KINDEX(1, 280)=25
 KINDEX(2, 280)=79
 KINDEX(1, 281)=30
 KINDEX(2, 281)=79
 KINDEX(1, 282)=31
 KINDEX(2, 282)=79
 KINDEX(1, 283)=32
 KINDEX(2, 283)=79
 KINDEX(1, 284)=33
 KINDEX(2, 284)=79
 KINDEX(1, 285)=39
 KINDEX(2, 285)=79
 KINDEX(1, 286)=41
 KINDEX(2, 286)=79
 KINDEX(1, 287)=1
 KINDEX(2, 287)=80
 KINDEX(1, 288)=2
 KINDEX(2, 288)=80
 KINDEX(1, 289)=13
 KINDEX(2, 289)=80
 KINDEX(1, 290)=14
 KINDEX(2, 290)=80
 KINDEX(1, 291)=15
 KINDEX(2, 291)=80
 KINDEX(1, 292)=19
 KINDEX(2, 292)=80
 KINDEX(1, 293)=20
 KINDEX(2, 293)=80
 KINDEX(1, 294)=22
 KINDEX(2, 294)=80
 KINDEX(1, 295)=23
 KINDEX(2, 295)=80
 KINDEX(1, 296)=24
 KINDEX(2, 296)=80
 KINDEX(1, 297)=25
 KINDEX(2, 297)=80
 KINDEX(1, 298)=30
 KINDEX(2, 298)=80
 KINDEX(1, 299)=31
 KINDEX(2, 299)=80
 KINDEX(1, 300)=32
 KINDEX(2, 300)=80
 KINDEX(1, 301)=33
 KINDEX(2, 301)=80
 KINDEX(1, 302)=39
 KINDEX(2, 302)=80
 KINDEX(1, 303)=41
 KINDEX(2, 303)=80
 KINDEX(1, 304)=1
 KINDEX(2, 304)=81
 KINDEX(1, 305)=13
 KINDEX(2, 305)=81
 KINDEX(1, 306)=14
 KINDEX(2, 306)=81
 KINDEX(1, 307)=15
 KINDEX(2, 307)=81
 KINDEX(1, 308)=22
 KINDEX(2, 308)=81
 KINDEX(1, 309)=23
 KINDEX(2, 309)=81
 KINDEX(1, 310)=25
 KINDEX(2, 310)=81
 KINDEX(1, 311)=29
 KINDEX(2, 311)=81
 KINDEX(1, 312)=30
 KINDEX(2, 312)=81
 KINDEX(1, 313)=31
 KINDEX(2, 313)=81
 KINDEX(1, 314)=39
 KINDEX(2, 314)=81
 KINDEX(1, 315)=1
 KINDEX(2, 315)=82
 KINDEX(1, 316)=4
 KINDEX(2, 316)=82
 KINDEX(1, 317)=13
 KINDEX(2, 317)=82
 KINDEX(1, 318)=14
 KINDEX(2, 318)=82
 KINDEX(1, 319)=15
 KINDEX(2, 319)=82
 KINDEX(1, 320)=22
 KINDEX(2, 320)=82
 KINDEX(1, 321)=27
 KINDEX(2, 321)=82
 KINDEX(1, 322)=30
 KINDEX(2, 322)=82
 KINDEX(1, 323)=39
 KINDEX(2, 323)=82
 KINDEX(1, 324)=4
 KINDEX(2, 324)=83
 KINDEX(1, 325)=21
 KINDEX(2, 325)=83
 KINDEX(1, 326)=26
 KINDEX(2, 326)=83
 KINDEX(1, 327)=36
 KINDEX(2, 327)=83
 KINDEX(1, 328)=15
 KINDEX(2, 328)=84
 KINDEX(1, 329)=21
 KINDEX(2, 329)=84
 KINDEX(1, 330)=36
 KINDEX(2, 330)=84
 KINDEX(1, 331)=4
 KINDEX(2, 331)=85
 KINDEX(1, 332)=7
 KINDEX(2, 332)=85
 KINDEX(1, 333)=21
 KINDEX(2, 333)=85
 KINDEX(1, 334)=37
 KINDEX(2, 334)=85
 KINDEX(1, 335)=15
 KINDEX(2, 335)=86
 KINDEX(1, 336)=21
 KINDEX(2, 336)=86
 KINDEX(1, 337)=37
 KINDEX(2, 337)=86
 KINDEX(1, 338)=38
 KINDEX(2, 338)=86
 KINDEX(1, 339)=1
 KINDEX(2, 339)=87
 KINDEX(1, 340)=14
 KINDEX(2, 340)=87
 KINDEX(1, 341)=21
 KINDEX(2, 341)=87
 KINDEX(1, 342)=37
 KINDEX(2, 342)=87
 KINDEX(1, 343)=4
 KINDEX(2, 343)=88
 KINDEX(1, 344)=27
 KINDEX(2, 344)=88
 KINDEX(1, 345)=39
 KINDEX(2, 345)=88
 KINDEX(1, 346)=4
 KINDEX(2, 346)=89
 KINDEX(1, 347)=27
 KINDEX(2, 347)=89
 KINDEX(1, 348)=39
 KINDEX(2, 348)=89
 KINDEX(1, 349)=3
 KINDEX(2, 349)=90
 KINDEX(1, 350)=4
 KINDEX(2, 350)=90
 KINDEX(1, 351)=15
 KINDEX(2, 351)=90
 KINDEX(1, 352)=22
 KINDEX(2, 352)=90
 KINDEX(1, 353)=32
 KINDEX(2, 353)=90
 KINDEX(1, 354)=3
 KINDEX(2, 354)=91
 KINDEX(1, 355)=4
 KINDEX(2, 355)=91
 KINDEX(1, 356)=15
 KINDEX(2, 356)=91
 KINDEX(1, 357)=22
 KINDEX(2, 357)=91
 KINDEX(1, 358)=23
 KINDEX(2, 358)=91
 KINDEX(1, 359)=24
 KINDEX(2, 359)=91
 KINDEX(1, 360)=25
 KINDEX(2, 360)=91
 KINDEX(1, 361)=26
 KINDEX(2, 361)=91
 KINDEX(1, 362)=32
 KINDEX(2, 362)=91
 KINDEX(1, 363)=33
 KINDEX(2, 363)=91
 KINDEX(1, 364)=41
 KINDEX(2, 364)=91
 KINDEX(1, 365)=3
 KINDEX(2, 365)=92
 KINDEX(1, 366)=4
 KINDEX(2, 366)=92
 KINDEX(1, 367)=15
 KINDEX(2, 367)=92
 KINDEX(1, 368)=22
 KINDEX(2, 368)=92
 KINDEX(1, 369)=23
 KINDEX(2, 369)=92
 KINDEX(1, 370)=24
 KINDEX(2, 370)=92
 KINDEX(1, 371)=34
 KINDEX(2, 371)=92
 KINDEX(1, 372)=3
 KINDEX(2, 372)=93
 KINDEX(1, 373)=4
 KINDEX(2, 373)=93
 KINDEX(1, 374)=15
 KINDEX(2, 374)=93
 KINDEX(1, 375)=19
 KINDEX(2, 375)=93
 KINDEX(1, 376)=22
 KINDEX(2, 376)=93
 KINDEX(1, 377)=23
 KINDEX(2, 377)=93
 KINDEX(1, 378)=24
 KINDEX(2, 378)=93
 KINDEX(1, 379)=25
 KINDEX(2, 379)=93
 KINDEX(1, 380)=26
 KINDEX(2, 380)=93
 KINDEX(1, 381)=35
 KINDEX(2, 381)=93
 KINDEX(1, 382)=3
 KINDEX(2, 382)=94
 KINDEX(1, 383)=4
 KINDEX(2, 383)=94
 KINDEX(1, 384)=15
 KINDEX(2, 384)=94
 KINDEX(1, 385)=25
 KINDEX(2, 385)=94
 KINDEX(1, 386)=26
 KINDEX(2, 386)=94
 KINDEX(1, 387)=38
 KINDEX(2, 387)=94
 KINDEX(1, 388)=3
 KINDEX(2, 388)=95
 KINDEX(1, 389)=4
 KINDEX(2, 389)=95
 KINDEX(1, 390)=15
 KINDEX(2, 390)=95
 KINDEX(1, 391)=22
 KINDEX(2, 391)=95
 KINDEX(1, 392)=23
 KINDEX(2, 392)=95
 KINDEX(1, 393)=25
 KINDEX(2, 393)=95
 KINDEX(1, 394)=32
 KINDEX(2, 394)=95
 KINDEX(1, 395)=39
 KINDEX(2, 395)=95
 KINDEX(1, 396)=41
 KINDEX(2, 396)=95
 KINDEX(1, 397)=3
 KINDEX(2, 397)=96
 KINDEX(1, 398)=4
 KINDEX(2, 398)=96
 KINDEX(1, 399)=15
 KINDEX(2, 399)=96
 KINDEX(1, 400)=22
 KINDEX(2, 400)=96
 KINDEX(1, 401)=23
 KINDEX(2, 401)=96
 KINDEX(1, 402)=24
 KINDEX(2, 402)=96
 KINDEX(1, 403)=26
 KINDEX(2, 403)=96
 KINDEX(1, 404)=40
 KINDEX(2, 404)=96
 KINDEX(1, 405)=15
 KINDEX(2, 405)=97
 KINDEX(1, 406)=28
 KINDEX(2, 406)=97
 KINDEX(1, 407)=32
 KINDEX(2, 407)=97
 KINDEX(1, 408)=15
 KINDEX(2, 408)=98
 KINDEX(1, 409)=29
 KINDEX(2, 409)=98
 KINDEX(1, 410)=33
 KINDEX(2, 410)=98
 KINDEX(1, 411)=15
 KINDEX(2, 411)=99
 KINDEX(1, 412)=29
 KINDEX(2, 412)=99
 KINDEX(1, 413)=34
 KINDEX(2, 413)=99
 KINDEX(1, 414)=15
 KINDEX(2, 414)=100
 KINDEX(1, 415)=29
 KINDEX(2, 415)=100
 KINDEX(1, 416)=35
 KINDEX(2, 416)=100
 KINDEX(1, 417)=15
 KINDEX(2, 417)=101
 KINDEX(1, 418)=29
 KINDEX(2, 418)=101
 KINDEX(1, 419)=38
 KINDEX(2, 419)=101
 KINDEX(1, 420)=1
 KINDEX(2, 420)=102
 KINDEX(1, 421)=15
 KINDEX(2, 421)=102
 KINDEX(1, 422)=29
 KINDEX(2, 422)=102
 KINDEX(1, 423)=31
 KINDEX(2, 423)=102
 KINDEX(1, 424)=39
 KINDEX(2, 424)=102
 KINDEX(1, 425)=15
 KINDEX(2, 425)=103
 KINDEX(1, 426)=26
 KINDEX(2, 426)=103
 KINDEX(1, 427)=40
 KINDEX(2, 427)=103
 KINDEX(1, 428)=15
 KINDEX(2, 428)=104
 KINDEX(1, 429)=22
 KINDEX(2, 429)=104
 KINDEX(1, 430)=32
 KINDEX(2, 430)=104
 KINDEX(1, 431)=15
 KINDEX(2, 431)=105
 KINDEX(1, 432)=22
 KINDEX(2, 432)=105
 KINDEX(1, 433)=23
 KINDEX(2, 433)=105
 KINDEX(1, 434)=24
 KINDEX(2, 434)=105
 KINDEX(1, 435)=25
 KINDEX(2, 435)=105
 KINDEX(1, 436)=32
 KINDEX(2, 436)=105
 KINDEX(1, 437)=33
 KINDEX(2, 437)=105
 KINDEX(1, 438)=41
 KINDEX(2, 438)=105
 KINDEX(1, 439)=15
 KINDEX(2, 439)=106
 KINDEX(1, 440)=22
 KINDEX(2, 440)=106
 KINDEX(1, 441)=23
 KINDEX(2, 441)=106
 KINDEX(1, 442)=24
 KINDEX(2, 442)=106
 KINDEX(1, 443)=32
 KINDEX(2, 443)=106
 KINDEX(1, 444)=34
 KINDEX(2, 444)=106
 KINDEX(1, 445)=15
 KINDEX(2, 445)=107
 KINDEX(1, 446)=19
 KINDEX(2, 446)=107
 KINDEX(1, 447)=22
 KINDEX(2, 447)=107
 KINDEX(1, 448)=23
 KINDEX(2, 448)=107
 KINDEX(1, 449)=24
 KINDEX(2, 449)=107
 KINDEX(1, 450)=25
 KINDEX(2, 450)=107
 KINDEX(1, 451)=32
 KINDEX(2, 451)=107
 KINDEX(1, 452)=35
 KINDEX(2, 452)=107
 KINDEX(1, 453)=15
 KINDEX(2, 453)=108
 KINDEX(1, 454)=22
 KINDEX(2, 454)=108
 KINDEX(1, 455)=25
 KINDEX(2, 455)=108
 KINDEX(1, 456)=32
 KINDEX(2, 456)=108
 KINDEX(1, 457)=38
 KINDEX(2, 457)=108
 KINDEX(1, 458)=15
 KINDEX(2, 458)=109
 KINDEX(1, 459)=22
 KINDEX(2, 459)=109
 KINDEX(1, 460)=23
 KINDEX(2, 460)=109
 KINDEX(1, 461)=25
 KINDEX(2, 461)=109
 KINDEX(1, 462)=31
 KINDEX(2, 462)=109
 KINDEX(1, 463)=32
 KINDEX(2, 463)=109
 KINDEX(1, 464)=39
 KINDEX(2, 464)=109
 KINDEX(1, 465)=41
 KINDEX(2, 465)=109
 KINDEX(1, 466)=4
 KINDEX(2, 466)=110
 KINDEX(1, 467)=15
 KINDEX(2, 467)=110
 KINDEX(1, 468)=22
 KINDEX(2, 468)=110
 KINDEX(1, 469)=23
 KINDEX(2, 469)=110
 KINDEX(1, 470)=24
 KINDEX(2, 470)=110
 KINDEX(1, 471)=26
 KINDEX(2, 471)=110
 KINDEX(1, 472)=32
 KINDEX(2, 472)=110
 KINDEX(1, 473)=40
 KINDEX(2, 473)=110
 KINDEX(1, 474)=15
 KINDEX(2, 474)=111
 KINDEX(1, 475)=22
 KINDEX(2, 475)=111
 KINDEX(1, 476)=23
 KINDEX(2, 476)=111
 KINDEX(1, 477)=24
 KINDEX(2, 477)=111
 KINDEX(1, 478)=25
 KINDEX(2, 478)=111
 KINDEX(1, 479)=31
 KINDEX(2, 479)=111
 KINDEX(1, 480)=32
 KINDEX(2, 480)=111
 KINDEX(1, 481)=33
 KINDEX(2, 481)=111
 KINDEX(1, 482)=39
 KINDEX(2, 482)=111
 KINDEX(1, 483)=41
 KINDEX(2, 483)=111
 KINDEX(1, 484)=15
 KINDEX(2, 484)=112
 KINDEX(1, 485)=22
 KINDEX(2, 485)=112
 KINDEX(1, 486)=23
 KINDEX(2, 486)=112
 KINDEX(1, 487)=24
 KINDEX(2, 487)=112
 KINDEX(1, 488)=31
 KINDEX(2, 488)=112
 KINDEX(1, 489)=32
 KINDEX(2, 489)=112
 KINDEX(1, 490)=34
 KINDEX(2, 490)=112
 KINDEX(1, 491)=39
 KINDEX(2, 491)=112
 KINDEX(1, 492)=15
 KINDEX(2, 492)=113
 KINDEX(1, 493)=19
 KINDEX(2, 493)=113
 KINDEX(1, 494)=22
 KINDEX(2, 494)=113
 KINDEX(1, 495)=23
 KINDEX(2, 495)=113
 KINDEX(1, 496)=24
 KINDEX(2, 496)=113
 KINDEX(1, 497)=25
 KINDEX(2, 497)=113
 KINDEX(1, 498)=31
 KINDEX(2, 498)=113
 KINDEX(1, 499)=32
 KINDEX(2, 499)=113
 KINDEX(1, 500)=35
 KINDEX(2, 500)=113
 KINDEX(1, 501)=39
 KINDEX(2, 501)=113
 KINDEX(1, 502)=15
 KINDEX(2, 502)=114
 KINDEX(1, 503)=25
 KINDEX(2, 503)=114
 KINDEX(1, 504)=32
 KINDEX(2, 504)=114
 KINDEX(1, 505)=38
 KINDEX(2, 505)=114
 KINDEX(1, 506)=39
 KINDEX(2, 506)=114
 KINDEX(1, 507)=15
 KINDEX(2, 507)=115
 KINDEX(1, 508)=22
 KINDEX(2, 508)=115
 KINDEX(1, 509)=23
 KINDEX(2, 509)=115
 KINDEX(1, 510)=24
 KINDEX(2, 510)=115
 KINDEX(1, 511)=25
 KINDEX(2, 511)=115
 KINDEX(1, 512)=31
 KINDEX(2, 512)=115
 KINDEX(1, 513)=32
 KINDEX(2, 513)=115
 KINDEX(1, 514)=39
 KINDEX(2, 514)=115
 KINDEX(1, 515)=41
 KINDEX(2, 515)=115
 KINDEX(1, 516)=4
 KINDEX(2, 516)=116
 KINDEX(1, 517)=15
 KINDEX(2, 517)=116
 KINDEX(1, 518)=22
 KINDEX(2, 518)=116
 KINDEX(1, 519)=23
 KINDEX(2, 519)=116
 KINDEX(1, 520)=24
 KINDEX(2, 520)=116
 KINDEX(1, 521)=26
 KINDEX(2, 521)=116
 KINDEX(1, 522)=31
 KINDEX(2, 522)=116
 KINDEX(1, 523)=32
 KINDEX(2, 523)=116
 KINDEX(1, 524)=39
 KINDEX(2, 524)=116
 KINDEX(1, 525)=40
 KINDEX(2, 525)=116
 KINDEX(1, 526)=15
 KINDEX(2, 526)=117
 KINDEX(1, 527)=26
 KINDEX(2, 527)=117
 KINDEX(1, 528)=40
 KINDEX(2, 528)=117
 KINDEX(1, 529)=4
 KINDEX(2, 529)=118
 KINDEX(1, 530)=15
 KINDEX(2, 530)=118
 KINDEX(1, 531)=22
 KINDEX(2, 531)=118
 KINDEX(1, 532)=23
 KINDEX(2, 532)=118
 KINDEX(1, 533)=24
 KINDEX(2, 533)=118
 KINDEX(1, 534)=26
 KINDEX(2, 534)=118
 KINDEX(1, 535)=40
 KINDEX(2, 535)=118
 KINDEX(1, 536)=4
 KINDEX(2, 536)=119
 KINDEX(1, 537)=5
 KINDEX(2, 537)=119
 KINDEX(1, 538)=15
 KINDEX(2, 538)=119
 KINDEX(1, 539)=22
 KINDEX(2, 539)=119
 KINDEX(1, 540)=32
 KINDEX(2, 540)=119
 KINDEX(1, 541)=4
 KINDEX(2, 541)=120
 KINDEX(1, 542)=5
 KINDEX(2, 542)=120
 KINDEX(1, 543)=15
 KINDEX(2, 543)=120
 KINDEX(1, 544)=22
 KINDEX(2, 544)=120
 KINDEX(1, 545)=23
 KINDEX(2, 545)=120
 KINDEX(1, 546)=24
 KINDEX(2, 546)=120
 KINDEX(1, 547)=25
 KINDEX(2, 547)=120
 KINDEX(1, 548)=32
 KINDEX(2, 548)=120
 KINDEX(1, 549)=33
 KINDEX(2, 549)=120
 KINDEX(1, 550)=41
 KINDEX(2, 550)=120
 KINDEX(1, 551)=4
 KINDEX(2, 551)=121
 KINDEX(1, 552)=5
 KINDEX(2, 552)=121
 KINDEX(1, 553)=15
 KINDEX(2, 553)=121
 KINDEX(1, 554)=22
 KINDEX(2, 554)=121
 KINDEX(1, 555)=23
 KINDEX(2, 555)=121
 KINDEX(1, 556)=24
 KINDEX(2, 556)=121
 KINDEX(1, 557)=34
 KINDEX(2, 557)=121
 KINDEX(1, 558)=4
 KINDEX(2, 558)=122
 KINDEX(1, 559)=5
 KINDEX(2, 559)=122
 KINDEX(1, 560)=15
 KINDEX(2, 560)=122
 KINDEX(1, 561)=19
 KINDEX(2, 561)=122
 KINDEX(1, 562)=22
 KINDEX(2, 562)=122
 KINDEX(1, 563)=23
 KINDEX(2, 563)=122
 KINDEX(1, 564)=24
 KINDEX(2, 564)=122
 KINDEX(1, 565)=25
 KINDEX(2, 565)=122
 KINDEX(1, 566)=35
 KINDEX(2, 566)=122
 KINDEX(1, 567)=4
 KINDEX(2, 567)=123
 KINDEX(1, 568)=5
 KINDEX(2, 568)=123
 KINDEX(1, 569)=15
 KINDEX(2, 569)=123
 KINDEX(1, 570)=25
 KINDEX(2, 570)=123
 KINDEX(1, 571)=38
 KINDEX(2, 571)=123
 KINDEX(1, 572)=4
 KINDEX(2, 572)=124
 KINDEX(1, 573)=5
 KINDEX(2, 573)=124
 KINDEX(1, 574)=15
 KINDEX(2, 574)=124
 KINDEX(1, 575)=22
 KINDEX(2, 575)=124
 KINDEX(1, 576)=23
 KINDEX(2, 576)=124
 KINDEX(1, 577)=25
 KINDEX(2, 577)=124
 KINDEX(1, 578)=32
 KINDEX(2, 578)=124
 KINDEX(1, 579)=39
 KINDEX(2, 579)=124
 KINDEX(1, 580)=41
 KINDEX(2, 580)=124
 KINDEX(1, 581)=4
 KINDEX(2, 581)=125
 KINDEX(1, 582)=5
 KINDEX(2, 582)=125
 KINDEX(1, 583)=15
 KINDEX(2, 583)=125
 KINDEX(1, 584)=22
 KINDEX(2, 584)=125
 KINDEX(1, 585)=23
 KINDEX(2, 585)=125
 KINDEX(1, 586)=24
 KINDEX(2, 586)=125
 KINDEX(1, 587)=26
 KINDEX(2, 587)=125
 KINDEX(1, 588)=40
 KINDEX(2, 588)=125
 KINDEX(1, 589)=15
 KINDEX(2, 589)=126
 KINDEX(1, 590)=29
 KINDEX(2, 590)=126
 KINDEX(1, 591)=41
 KINDEX(2, 591)=126
 KINDEX(1, 592)=15
 KINDEX(2, 592)=127
 KINDEX(1, 593)=22
 KINDEX(2, 593)=127
 KINDEX(1, 594)=32
 KINDEX(2, 594)=127
 KINDEX(1, 595)=41
 KINDEX(2, 595)=127
 KINDEX(1, 596)=32
 KINDEX(2, 596)=128
 KINDEX(1, 597)=39
 KINDEX(2, 597)=128
 KINDEX(1, 598)=41
 KINDEX(2, 598)=128
 KINDEX(1, 599)=41
 KINDEX(2, 599)=129
 KINDEX(1, 600)=3
 KINDEX(2, 600)=130
 KINDEX(1, 601)=4
 KINDEX(2, 601)=130
 KINDEX(1, 602)=41
 KINDEX(2, 602)=130
 KINDEX(1, 603)=4
 KINDEX(2, 603)=131
 KINDEX(1, 604)=5
 KINDEX(2, 604)=131
 KINDEX(1, 605)=41
 KINDEX(2, 605)=131
 KINDEX(1, 606)=12
 KINDEX(2, 606)=132
 KINDEX(1, 607)=1
 KINDEX(2, 607)=133
 KINDEX(1, 608)=42
 KINDEX(2, 608)=133
 KINDEX(1, 609)=2
 KINDEX(2, 609)=134
 KINDEX(1, 610)=43
 KINDEX(2, 610)=134
 KINDEX(1, 611)=3
 KINDEX(2, 611)=135
 KINDEX(1, 612)=44
 KINDEX(2, 612)=135
 KINDEX(1, 613)=4
 KINDEX(2, 613)=136
 KINDEX(1, 614)=45
 KINDEX(2, 614)=136
 KINDEX(1, 615)=5
 KINDEX(2, 615)=137
 KINDEX(1, 616)=46
 KINDEX(2, 616)=137
 KINDEX(1, 617)=6
 KINDEX(2, 617)=138
 KINDEX(1, 618)=47
 KINDEX(2, 618)=138
 KINDEX(1, 619)=7
 KINDEX(2, 619)=139
 KINDEX(1, 620)=48
 KINDEX(2, 620)=139
 KINDEX(1, 621)=8
 KINDEX(2, 621)=140
 KINDEX(1, 622)=49
 KINDEX(2, 622)=140
 KINDEX(1, 623)=9
 KINDEX(2, 623)=141
 KINDEX(1, 624)=50
 KINDEX(2, 624)=141
 KINDEX(1, 625)=10
 KINDEX(2, 625)=142
 KINDEX(1, 626)=51
 KINDEX(2, 626)=142
 KINDEX(1, 627)=14
 KINDEX(2, 627)=143
 KINDEX(1, 628)=52
 KINDEX(2, 628)=143
 KINDEX(1, 629)=15
 KINDEX(2, 629)=144
 KINDEX(1, 630)=53
 KINDEX(2, 630)=144
 KINDEX(1, 631)=54
 KINDEX(2, 631)=145
 KINDEX(1, 632)=11
 KINDEX(2, 632)=146
 KINDEX(1, 633)=55
 KINDEX(2, 633)=146
 KINDEX(1, 634)=12
 KINDEX(2, 634)=147
 KINDEX(1, 635)=56
 KINDEX(2, 635)=147
 KINDEX(1, 636)=22
 KINDEX(2, 636)=148
 KINDEX(1, 637)=57
 KINDEX(2, 637)=148
 KINDEX(1, 638)=30
 KINDEX(2, 638)=149
 KINDEX(1, 639)=58
 KINDEX(2, 639)=149
 KINDEX(1, 640)=31
 KINDEX(2, 640)=150
 KINDEX(1, 641)=59
 KINDEX(2, 641)=150
 KINDEX(1, 642)=32
 KINDEX(2, 642)=151
 KINDEX(1, 643)=60
 KINDEX(2, 643)=151
 KINDEX(1, 644)=28
 KINDEX(2, 644)=152
 KINDEX(1, 645)=61
 KINDEX(2, 645)=152
 KINDEX(1, 646)=1
 KINDEX(2, 646)=153
 KINDEX(1, 647)=42
 KINDEX(2, 647)=153
 KINDEX(1, 648)=2
 KINDEX(2, 648)=154
 KINDEX(1, 649)=43
 KINDEX(2, 649)=154
 KINDEX(1, 650)=3
 KINDEX(2, 650)=155
 KINDEX(1, 651)=44
 KINDEX(2, 651)=155
 KINDEX(1, 652)=4
 KINDEX(2, 652)=156
 KINDEX(1, 653)=45
 KINDEX(2, 653)=156
 KINDEX(1, 654)=5
 KINDEX(2, 654)=157
 KINDEX(1, 655)=46
 KINDEX(2, 655)=157
 KINDEX(1, 656)=6
 KINDEX(2, 656)=158
 KINDEX(1, 657)=47
 KINDEX(2, 657)=158
 KINDEX(1, 658)=7
 KINDEX(2, 658)=159
 KINDEX(1, 659)=48
 KINDEX(2, 659)=159
 KINDEX(1, 660)=8
 KINDEX(2, 660)=160
 KINDEX(1, 661)=49
 KINDEX(2, 661)=160
 KINDEX(1, 662)=9
 KINDEX(2, 662)=161
 KINDEX(1, 663)=50
 KINDEX(2, 663)=161
 KINDEX(1, 664)=10
 KINDEX(2, 664)=162
 KINDEX(1, 665)=51
 KINDEX(2, 665)=162
 KINDEX(1, 666)=14
 KINDEX(2, 666)=163
 KINDEX(1, 667)=52
 KINDEX(2, 667)=163
 KINDEX(1, 668)=15
 KINDEX(2, 668)=164
 KINDEX(1, 669)=53
 KINDEX(2, 669)=164
 KINDEX(1, 670)=54
 KINDEX(2, 670)=165
 KINDEX(1, 671)=11
 KINDEX(2, 671)=166
 KINDEX(1, 672)=55
 KINDEX(2, 672)=166
 KINDEX(1, 673)=12
 KINDEX(2, 673)=167
 KINDEX(1, 674)=56
 KINDEX(2, 674)=167
 KINDEX(1, 675)=22
 KINDEX(2, 675)=168
 KINDEX(1, 676)=57
 KINDEX(2, 676)=168
 KINDEX(1, 677)=30
 KINDEX(2, 677)=169
 KINDEX(1, 678)=58
 KINDEX(2, 678)=169
 KINDEX(1, 679)=31
 KINDEX(2, 679)=170
 KINDEX(1, 680)=59
 KINDEX(2, 680)=170
 KINDEX(1, 681)=32
 KINDEX(2, 681)=171
 KINDEX(1, 682)=60
 KINDEX(2, 682)=171
 KINDEX(1, 683)=28
 KINDEX(2, 683)=172
 KINDEX(1, 684)=61
 KINDEX(2, 684)=172
 KINDEX(1, 685)=1
 KINDEX(2, 685)=173
 KINDEX(1, 686)=67
 KINDEX(2, 686)=173
 KINDEX(1, 687)=2
 KINDEX(2, 687)=174
 KINDEX(1, 688)=68
 KINDEX(2, 688)=174
 KINDEX(1, 689)=3
 KINDEX(2, 689)=175
 KINDEX(1, 690)=69
 KINDEX(2, 690)=175
 KINDEX(1, 691)=4
 KINDEX(2, 691)=176
 KINDEX(1, 692)=70
 KINDEX(2, 692)=176
 KINDEX(1, 693)=5
 KINDEX(2, 693)=177
 KINDEX(1, 694)=71
 KINDEX(2, 694)=177
 KINDEX(1, 695)=6
 KINDEX(2, 695)=178
 KINDEX(1, 696)=72
 KINDEX(2, 696)=178
 KINDEX(1, 697)=7
 KINDEX(2, 697)=179
 KINDEX(1, 698)=73
 KINDEX(2, 698)=179
 KINDEX(1, 699)=8
 KINDEX(2, 699)=180
 KINDEX(1, 700)=74
 KINDEX(2, 700)=180
 KINDEX(1, 701)=9
 KINDEX(2, 701)=181
 KINDEX(1, 702)=75
 KINDEX(2, 702)=181
 KINDEX(1, 703)=10
 KINDEX(2, 703)=182
 KINDEX(1, 704)=76
 KINDEX(2, 704)=182
 KINDEX(1, 705)=14
 KINDEX(2, 705)=183
 KINDEX(1, 706)=77
 KINDEX(2, 706)=183
 KINDEX(1, 707)=15
 KINDEX(2, 707)=184
 KINDEX(1, 708)=78
 KINDEX(2, 708)=184
 KINDEX(1, 709)=79
 KINDEX(2, 709)=185
 KINDEX(1, 710)=11
 KINDEX(2, 710)=186
 KINDEX(1, 711)=80
 KINDEX(2, 711)=186
 KINDEX(1, 712)=12
 KINDEX(2, 712)=187
 KINDEX(1, 713)=81
 KINDEX(2, 713)=187
 KINDEX(1, 714)=22
 KINDEX(2, 714)=188
 KINDEX(1, 715)=82
 KINDEX(2, 715)=188
 KINDEX(1, 716)=30
 KINDEX(2, 716)=189
 KINDEX(1, 717)=83
 KINDEX(2, 717)=189
 KINDEX(1, 718)=31
 KINDEX(2, 718)=190
 KINDEX(1, 719)=84
 KINDEX(2, 719)=190
 KINDEX(1, 720)=32
 KINDEX(2, 720)=191
 KINDEX(1, 721)=85
 KINDEX(2, 721)=191
 KINDEX(1, 722)=28
 KINDEX(2, 722)=192
 KINDEX(1, 723)=86
 KINDEX(2, 723)=192
 KINDEX(1, 724)=1
 KINDEX(2, 724)=193
 KINDEX(1, 725)=67
 KINDEX(2, 725)=193
 KINDEX(1, 726)=2
 KINDEX(2, 726)=194
 KINDEX(1, 727)=68
 KINDEX(2, 727)=194
 KINDEX(1, 728)=3
 KINDEX(2, 728)=195
 KINDEX(1, 729)=69
 KINDEX(2, 729)=195
 KINDEX(1, 730)=4
 KINDEX(2, 730)=196
 KINDEX(1, 731)=70
 KINDEX(2, 731)=196
 KINDEX(1, 732)=5
 KINDEX(2, 732)=197
 KINDEX(1, 733)=71
 KINDEX(2, 733)=197
 KINDEX(1, 734)=6
 KINDEX(2, 734)=198
 KINDEX(1, 735)=72
 KINDEX(2, 735)=198
 KINDEX(1, 736)=7
 KINDEX(2, 736)=199
 KINDEX(1, 737)=73
 KINDEX(2, 737)=199
 KINDEX(1, 738)=8
 KINDEX(2, 738)=200
 KINDEX(1, 739)=74
 KINDEX(2, 739)=200
 KINDEX(1, 740)=9
 KINDEX(2, 740)=201
 KINDEX(1, 741)=75
 KINDEX(2, 741)=201
 KINDEX(1, 742)=10
 KINDEX(2, 742)=202
 KINDEX(1, 743)=76
 KINDEX(2, 743)=202
 KINDEX(1, 744)=14
 KINDEX(2, 744)=203
 KINDEX(1, 745)=77
 KINDEX(2, 745)=203
 KINDEX(1, 746)=15
 KINDEX(2, 746)=204
 KINDEX(1, 747)=78
 KINDEX(2, 747)=204
 KINDEX(1, 748)=79
 KINDEX(2, 748)=205
 KINDEX(1, 749)=11
 KINDEX(2, 749)=206
 KINDEX(1, 750)=80
 KINDEX(2, 750)=206
 KINDEX(1, 751)=12
 KINDEX(2, 751)=207
 KINDEX(1, 752)=81
 KINDEX(2, 752)=207
 KINDEX(1, 753)=22
 KINDEX(2, 753)=208
 KINDEX(1, 754)=82
 KINDEX(2, 754)=208
 KINDEX(1, 755)=30
 KINDEX(2, 755)=209
 KINDEX(1, 756)=83
 KINDEX(2, 756)=209
 KINDEX(1, 757)=31
 KINDEX(2, 757)=210
 KINDEX(1, 758)=84
 KINDEX(2, 758)=210
 KINDEX(1, 759)=32
 KINDEX(2, 759)=211
 KINDEX(1, 760)=85
 KINDEX(2, 760)=211
 KINDEX(1, 761)=28
 KINDEX(2, 761)=212
 KINDEX(1, 762)=86
 KINDEX(2, 762)=212
 KINDEX(1, 763)=43
 KINDEX(2, 763)=213
 KINDEX(1, 764)=52
 KINDEX(2, 764)=213
 KINDEX(1, 765)=43
 KINDEX(2, 765)=214
 KINDEX(1, 766)=52
 KINDEX(2, 766)=214
 KINDEX(1, 767)=52
 KINDEX(2, 767)=215
 KINDEX(1, 768)=53
 KINDEX(2, 768)=215
 KINDEX(1, 769)=43
 KINDEX(2, 769)=216
 KINDEX(1, 770)=52
 KINDEX(2, 770)=216
 KINDEX(1, 771)=53
 KINDEX(2, 771)=216
 KINDEX(1, 772)=43
 KINDEX(2, 772)=217
 KINDEX(1, 773)=53
 KINDEX(2, 773)=217
 KINDEX(1, 774)=42
 KINDEX(2, 774)=218
 KINDEX(1, 775)=52
 KINDEX(2, 775)=218
 KINDEX(1, 776)=53
 KINDEX(2, 776)=218
 KINDEX(1, 777)=52
 KINDEX(2, 777)=219
 KINDEX(1, 778)=55
 KINDEX(2, 778)=219
 KINDEX(1, 779)=62
 KINDEX(2, 779)=219
 KINDEX(1, 780)=45
 KINDEX(2, 780)=220
 KINDEX(1, 781)=48
 KINDEX(2, 781)=220
 KINDEX(1, 782)=52
 KINDEX(2, 782)=220
 KINDEX(1, 783)=45
 KINDEX(2, 783)=221
 KINDEX(1, 784)=50
 KINDEX(2, 784)=221
 KINDEX(1, 785)=53
 KINDEX(2, 785)=221
 KINDEX(1, 786)=45
 KINDEX(2, 786)=222
 KINDEX(1, 787)=50
 KINDEX(2, 787)=222
 KINDEX(1, 788)=53
 KINDEX(2, 788)=222
 KINDEX(1, 789)=48
 KINDEX(2, 789)=223
 KINDEX(1, 790)=50
 KINDEX(2, 790)=223
 KINDEX(1, 791)=49
 KINDEX(2, 791)=224
 KINDEX(1, 792)=50
 KINDEX(2, 792)=224
 KINDEX(1, 793)=55
 KINDEX(2, 793)=224
 KINDEX(1, 794)=56
 KINDEX(2, 794)=224
 KINDEX(1, 795)=45
 KINDEX(2, 795)=225
 KINDEX(1, 796)=49
 KINDEX(2, 796)=225
 KINDEX(1, 797)=52
 KINDEX(2, 797)=225
 KINDEX(1, 798)=47
 KINDEX(2, 798)=226
 KINDEX(1, 799)=49
 KINDEX(2, 799)=226
 KINDEX(1, 800)=46
 KINDEX(2, 800)=227
 KINDEX(1, 801)=49
 KINDEX(2, 801)=227
 KINDEX(1, 802)=56
 KINDEX(2, 802)=227
 KINDEX(1, 803)=63
 KINDEX(2, 803)=227
 KINDEX(1, 804)=46
 KINDEX(2, 804)=228
 KINDEX(1, 805)=49
 KINDEX(2, 805)=228
 KINDEX(1, 806)=55
 KINDEX(2, 806)=228
 KINDEX(1, 807)=62
 KINDEX(2, 807)=228
 KINDEX(1, 808)=53
 KINDEX(2, 808)=229
 KINDEX(1, 809)=57
 KINDEX(2, 809)=229
 KINDEX(1, 810)=60
 KINDEX(2, 810)=229
 KINDEX(1, 811)=55
 KINDEX(2, 811)=230
 KINDEX(1, 812)=60
 KINDEX(2, 812)=230
 KINDEX(1, 813)=61
 KINDEX(2, 813)=230
 KINDEX(1, 814)=62
 KINDEX(2, 814)=230
 KINDEX(1, 815)=52
 KINDEX(2, 815)=231
 KINDEX(1, 816)=53
 KINDEX(2, 816)=231
 KINDEX(1, 817)=57
 KINDEX(2, 817)=231
 KINDEX(1, 818)=58
 KINDEX(2, 818)=231
 KINDEX(1, 819)=52
 KINDEX(2, 819)=232
 KINDEX(1, 820)=53
 KINDEX(2, 820)=232
 KINDEX(1, 821)=54
 KINDEX(2, 821)=232
 KINDEX(1, 822)=58
 KINDEX(2, 822)=232
 KINDEX(1, 823)=55
 KINDEX(2, 823)=233
 KINDEX(1, 824)=57
 KINDEX(2, 824)=233
 KINDEX(1, 825)=66
 KINDEX(2, 825)=233
 KINDEX(1, 826)=55
 KINDEX(2, 826)=234
 KINDEX(1, 827)=57
 KINDEX(2, 827)=234
 KINDEX(1, 828)=66
 KINDEX(2, 828)=234
 KINDEX(1, 829)=52
 KINDEX(2, 829)=235
 KINDEX(1, 830)=53
 KINDEX(2, 830)=235
 KINDEX(1, 831)=55
 KINDEX(2, 831)=235
 KINDEX(1, 832)=58
 KINDEX(2, 832)=235
 KINDEX(1, 833)=66
 KINDEX(2, 833)=235
 KINDEX(1, 834)=62
 KINDEX(2, 834)=236
 KINDEX(1, 835)=64
 KINDEX(2, 835)=236
 KINDEX(1, 836)=53
 KINDEX(2, 836)=237
 KINDEX(1, 837)=64
 KINDEX(2, 837)=237
 KINDEX(1, 838)=65
 KINDEX(2, 838)=237
 KINDEX(1, 839)=63
 KINDEX(2, 839)=238
 KINDEX(1, 840)=64
 KINDEX(2, 840)=238
 KINDEX(1, 841)=55
 KINDEX(2, 841)=239
 KINDEX(1, 842)=56
 KINDEX(2, 842)=239
 KINDEX(1, 843)=65
 KINDEX(2, 843)=239
 KINDEX(1, 844)=52
 KINDEX(2, 844)=240
 KINDEX(1, 845)=56
 KINDEX(2, 845)=240
 KINDEX(1, 846)=63
 KINDEX(2, 846)=240
 KINDEX(1, 847)=42
 KINDEX(2, 847)=241
 KINDEX(1, 848)=55
 KINDEX(2, 848)=241
 KINDEX(1, 849)=56
 KINDEX(2, 849)=241
 KINDEX(1, 850)=43
 KINDEX(2, 850)=242
 KINDEX(1, 851)=55
 KINDEX(2, 851)=242
 KINDEX(1, 852)=56
 KINDEX(2, 852)=242
 KINDEX(1, 853)=68
 KINDEX(2, 853)=243
 KINDEX(1, 854)=77
 KINDEX(2, 854)=243
 KINDEX(1, 855)=68
 KINDEX(2, 855)=244
 KINDEX(1, 856)=77
 KINDEX(2, 856)=244
 KINDEX(1, 857)=77
 KINDEX(2, 857)=245
 KINDEX(1, 858)=78
 KINDEX(2, 858)=245
 KINDEX(1, 859)=68
 KINDEX(2, 859)=246
 KINDEX(1, 860)=77
 KINDEX(2, 860)=246
 KINDEX(1, 861)=78
 KINDEX(2, 861)=246
 KINDEX(1, 862)=68
 KINDEX(2, 862)=247
 KINDEX(1, 863)=78
 KINDEX(2, 863)=247
 KINDEX(1, 864)=67
 KINDEX(2, 864)=248
 KINDEX(1, 865)=77
 KINDEX(2, 865)=248
 KINDEX(1, 866)=78
 KINDEX(2, 866)=248
 KINDEX(1, 867)=77
 KINDEX(2, 867)=249
 KINDEX(1, 868)=80
 KINDEX(2, 868)=249
 KINDEX(1, 869)=87
 KINDEX(2, 869)=249
 KINDEX(1, 870)=70
 KINDEX(2, 870)=250
 KINDEX(1, 871)=73
 KINDEX(2, 871)=250
 KINDEX(1, 872)=77
 KINDEX(2, 872)=250
 KINDEX(1, 873)=70
 KINDEX(2, 873)=251
 KINDEX(1, 874)=75
 KINDEX(2, 874)=251
 KINDEX(1, 875)=78
 KINDEX(2, 875)=251
 KINDEX(1, 876)=70
 KINDEX(2, 876)=252
 KINDEX(1, 877)=75
 KINDEX(2, 877)=252
 KINDEX(1, 878)=78
 KINDEX(2, 878)=252
 KINDEX(1, 879)=73
 KINDEX(2, 879)=253
 KINDEX(1, 880)=75
 KINDEX(2, 880)=253
 KINDEX(1, 881)=74
 KINDEX(2, 881)=254
 KINDEX(1, 882)=75
 KINDEX(2, 882)=254
 KINDEX(1, 883)=80
 KINDEX(2, 883)=254
 KINDEX(1, 884)=81
 KINDEX(2, 884)=254
 KINDEX(1, 885)=70
 KINDEX(2, 885)=255
 KINDEX(1, 886)=74
 KINDEX(2, 886)=255
 KINDEX(1, 887)=77
 KINDEX(2, 887)=255
 KINDEX(1, 888)=72
 KINDEX(2, 888)=256
 KINDEX(1, 889)=74
 KINDEX(2, 889)=256
 KINDEX(1, 890)=71
 KINDEX(2, 890)=257
 KINDEX(1, 891)=74
 KINDEX(2, 891)=257
 KINDEX(1, 892)=81
 KINDEX(2, 892)=257
 KINDEX(1, 893)=88
 KINDEX(2, 893)=257
 KINDEX(1, 894)=71
 KINDEX(2, 894)=258
 KINDEX(1, 895)=74
 KINDEX(2, 895)=258
 KINDEX(1, 896)=80
 KINDEX(2, 896)=258
 KINDEX(1, 897)=87
 KINDEX(2, 897)=258
 KINDEX(1, 898)=78
 KINDEX(2, 898)=259
 KINDEX(1, 899)=82
 KINDEX(2, 899)=259
 KINDEX(1, 900)=85
 KINDEX(2, 900)=259
 KINDEX(1, 901)=80
 KINDEX(2, 901)=260
 KINDEX(1, 902)=85
 KINDEX(2, 902)=260
 KINDEX(1, 903)=86
 KINDEX(2, 903)=260
 KINDEX(1, 904)=87
 KINDEX(2, 904)=260
 KINDEX(1, 905)=77
 KINDEX(2, 905)=261
 KINDEX(1, 906)=78
 KINDEX(2, 906)=261
 KINDEX(1, 907)=82
 KINDEX(2, 907)=261
 KINDEX(1, 908)=83
 KINDEX(2, 908)=261
 KINDEX(1, 909)=77
 KINDEX(2, 909)=262
 KINDEX(1, 910)=78
 KINDEX(2, 910)=262
 KINDEX(1, 911)=79
 KINDEX(2, 911)=262
 KINDEX(1, 912)=83
 KINDEX(2, 912)=262
 KINDEX(1, 913)=80
 KINDEX(2, 913)=263
 KINDEX(1, 914)=82
 KINDEX(2, 914)=263
 KINDEX(1, 915)=91
 KINDEX(2, 915)=263
 KINDEX(1, 916)=80
 KINDEX(2, 916)=264
 KINDEX(1, 917)=82
 KINDEX(2, 917)=264
 KINDEX(1, 918)=91
 KINDEX(2, 918)=264
 KINDEX(1, 919)=77
 KINDEX(2, 919)=265
 KINDEX(1, 920)=78
 KINDEX(2, 920)=265
 KINDEX(1, 921)=80
 KINDEX(2, 921)=265
 KINDEX(1, 922)=83
 KINDEX(2, 922)=265
 KINDEX(1, 923)=91
 KINDEX(2, 923)=265
 KINDEX(1, 924)=87
 KINDEX(2, 924)=266
 KINDEX(1, 925)=89
 KINDEX(2, 925)=266
 KINDEX(1, 926)=78
 KINDEX(2, 926)=267
 KINDEX(1, 927)=89
 KINDEX(2, 927)=267
 KINDEX(1, 928)=90
 KINDEX(2, 928)=267
 KINDEX(1, 929)=88
 KINDEX(2, 929)=268
 KINDEX(1, 930)=89
 KINDEX(2, 930)=268
 KINDEX(1, 931)=80
 KINDEX(2, 931)=269
 KINDEX(1, 932)=81
 KINDEX(2, 932)=269
 KINDEX(1, 933)=90
 KINDEX(2, 933)=269
 KINDEX(1, 934)=77
 KINDEX(2, 934)=270
 KINDEX(1, 935)=81
 KINDEX(2, 935)=270
 KINDEX(1, 936)=88
 KINDEX(2, 936)=270
 KINDEX(1, 937)=67
 KINDEX(2, 937)=271
 KINDEX(1, 938)=80
 KINDEX(2, 938)=271
 KINDEX(1, 939)=81
 KINDEX(2, 939)=271
 KINDEX(1, 940)=68
 KINDEX(2, 940)=272
 KINDEX(1, 941)=80
 KINDEX(2, 941)=272
 KINDEX(1, 942)=81
 KINDEX(2, 942)=272
RETURN
END SUBROUTINE CH_NONZEROTERMS_AQ
!!
!!
!!    #############################
      SUBROUTINE CH_NONZEROTERMS_GAZ
!!    #############################
!! This code has been created automatically by preprocessor m10,
!! version: 9.7, copyright 1995-1999 by Meteo France/Universite Paul Sabatier.
!! Please report all bugs to K. Suhre (Lab. d'Aerologie UPS/CNRS).
!!
!!*** *MODD_CH_NONZEROTERMS*
!!
!!    PURPOSE
!!    -------
!       calculation of the contribution of each term in each reaction
!!
!!**  METHOD
!!    ------
!!      The contribution of reaction i to the evolution of species j
!!    is returned in PTERMS. 
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!    none
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
! check if output array is large enough
IF (KINDEXDIM.LT.606) THEN
  STOP 'CH_NONZEROTERMS ERROR: array KINDEX is too small!'
END IF
 KINDEX(1, 1)=3
 KINDEX(2, 1)=1
 KINDEX(1, 2)=4
 KINDEX(2, 2)=1
 KINDEX(1, 3)=1
 KINDEX(2, 3)=2
 KINDEX(1, 4)=1
 KINDEX(2, 4)=3
 KINDEX(1, 5)=3
 KINDEX(2, 5)=4
 KINDEX(1, 6)=7
 KINDEX(2, 6)=4
 KINDEX(1, 7)=14
 KINDEX(2, 7)=4
 KINDEX(1, 8)=4
 KINDEX(2, 8)=5
 KINDEX(1, 9)=8
 KINDEX(2, 9)=5
 KINDEX(1, 10)=14
 KINDEX(2, 10)=5
 KINDEX(1, 11)=4
 KINDEX(2, 11)=6
 KINDEX(1, 12)=5
 KINDEX(2, 12)=6
 KINDEX(1, 13)=9
 KINDEX(2, 13)=6
 KINDEX(1, 14)=14
 KINDEX(2, 14)=6
 KINDEX(1, 15)=15
 KINDEX(2, 15)=6
 KINDEX(1, 16)=3
 KINDEX(2, 16)=7
 KINDEX(1, 17)=5
 KINDEX(2, 17)=7
 KINDEX(1, 18)=4
 KINDEX(2, 18)=8
 KINDEX(1, 19)=5
 KINDEX(2, 19)=8
 KINDEX(1, 20)=2
 KINDEX(2, 20)=9
 KINDEX(1, 21)=14
 KINDEX(2, 21)=9
 KINDEX(1, 22)=13
 KINDEX(2, 22)=10
 KINDEX(1, 23)=22
 KINDEX(2, 23)=10
 KINDEX(1, 24)=13
 KINDEX(2, 24)=11
 KINDEX(1, 25)=15
 KINDEX(2, 25)=11
 KINDEX(1, 26)=22
 KINDEX(2, 26)=11
 KINDEX(1, 27)=13
 KINDEX(2, 27)=12
 KINDEX(1, 28)=15
 KINDEX(2, 28)=12
 KINDEX(1, 29)=23
 KINDEX(2, 29)=12
 KINDEX(1, 30)=32
 KINDEX(2, 30)=12
 KINDEX(1, 31)=14
 KINDEX(2, 31)=13
 KINDEX(1, 32)=15
 KINDEX(2, 32)=13
 KINDEX(1, 33)=22
 KINDEX(2, 33)=13
 KINDEX(1, 34)=28
 KINDEX(2, 34)=13
 KINDEX(1, 35)=14
 KINDEX(2, 35)=14
 KINDEX(1, 36)=15
 KINDEX(2, 36)=14
 KINDEX(1, 37)=23
 KINDEX(2, 37)=14
 KINDEX(1, 38)=29
 KINDEX(2, 38)=14
 KINDEX(1, 39)=32
 KINDEX(2, 39)=14
 KINDEX(1, 40)=24
 KINDEX(2, 40)=15
 KINDEX(1, 41)=33
 KINDEX(2, 41)=15
 KINDEX(1, 42)=39
 KINDEX(2, 42)=15
 KINDEX(1, 43)=13
 KINDEX(2, 43)=16
 KINDEX(1, 44)=15
 KINDEX(2, 44)=16
 KINDEX(1, 45)=22
 KINDEX(2, 45)=16
 KINDEX(1, 46)=25
 KINDEX(2, 46)=16
 KINDEX(1, 47)=39
 KINDEX(2, 47)=16
 KINDEX(1, 48)=4
 KINDEX(2, 48)=17
 KINDEX(1, 49)=15
 KINDEX(2, 49)=17
 KINDEX(1, 50)=23
 KINDEX(2, 50)=17
 KINDEX(1, 51)=24
 KINDEX(2, 51)=17
 KINDEX(1, 52)=26
 KINDEX(2, 52)=17
 KINDEX(1, 53)=1
 KINDEX(2, 53)=18
 KINDEX(1, 54)=1
 KINDEX(2, 54)=19
 KINDEX(1, 55)=14
 KINDEX(2, 55)=22
 KINDEX(1, 56)=1
 KINDEX(2, 56)=23
 KINDEX(1, 57)=14
 KINDEX(2, 57)=23
 KINDEX(1, 58)=15
 KINDEX(2, 58)=23
 KINDEX(1, 59)=1
 KINDEX(2, 59)=24
 KINDEX(1, 60)=14
 KINDEX(2, 60)=24
 KINDEX(1, 61)=15
 KINDEX(2, 61)=24
 KINDEX(1, 62)=14
 KINDEX(2, 62)=25
 KINDEX(1, 63)=15
 KINDEX(2, 63)=25
 KINDEX(1, 64)=2
 KINDEX(2, 64)=26
 KINDEX(1, 65)=14
 KINDEX(2, 65)=26
 KINDEX(1, 66)=15
 KINDEX(2, 66)=26
 KINDEX(1, 67)=2
 KINDEX(2, 67)=27
 KINDEX(1, 68)=15
 KINDEX(2, 68)=27
 KINDEX(1, 69)=2
 KINDEX(2, 69)=28
 KINDEX(1, 70)=15
 KINDEX(2, 70)=28
 KINDEX(1, 71)=3
 KINDEX(2, 71)=29
 KINDEX(1, 72)=4
 KINDEX(2, 72)=29
 KINDEX(1, 73)=3
 KINDEX(2, 73)=30
 KINDEX(1, 74)=4
 KINDEX(2, 74)=30
 KINDEX(1, 75)=4
 KINDEX(2, 75)=31
 KINDEX(1, 76)=5
 KINDEX(2, 76)=31
 KINDEX(1, 77)=3
 KINDEX(2, 77)=32
 KINDEX(1, 78)=7
 KINDEX(2, 78)=32
 KINDEX(1, 79)=14
 KINDEX(2, 79)=32
 KINDEX(1, 80)=4
 KINDEX(2, 80)=33
 KINDEX(1, 81)=8
 KINDEX(2, 81)=33
 KINDEX(1, 82)=14
 KINDEX(2, 82)=33
 KINDEX(1, 83)=4
 KINDEX(2, 83)=34
 KINDEX(1, 84)=5
 KINDEX(2, 84)=34
 KINDEX(1, 85)=14
 KINDEX(2, 85)=34
 KINDEX(1, 86)=15
 KINDEX(2, 86)=34
 KINDEX(1, 87)=3
 KINDEX(2, 87)=35
 KINDEX(1, 88)=4
 KINDEX(2, 88)=35
 KINDEX(1, 89)=14
 KINDEX(2, 89)=35
 KINDEX(1, 90)=15
 KINDEX(2, 90)=35
 KINDEX(1, 91)=4
 KINDEX(2, 91)=36
 KINDEX(1, 92)=9
 KINDEX(2, 92)=36
 KINDEX(1, 93)=15
 KINDEX(2, 93)=36
 KINDEX(1, 94)=4
 KINDEX(2, 94)=37
 KINDEX(1, 95)=9
 KINDEX(2, 95)=37
 KINDEX(1, 96)=15
 KINDEX(2, 96)=37
 KINDEX(1, 97)=4
 KINDEX(2, 97)=38
 KINDEX(1, 98)=5
 KINDEX(2, 98)=38
 KINDEX(1, 99)=8
 KINDEX(2, 99)=38
 KINDEX(1, 100)=14
 KINDEX(2, 100)=38
 KINDEX(1, 101)=15
 KINDEX(2, 101)=38
 KINDEX(1, 102)=4
 KINDEX(2, 102)=39
 KINDEX(1, 103)=7
 KINDEX(2, 103)=39
 KINDEX(1, 104)=14
 KINDEX(2, 104)=39
 KINDEX(1, 105)=5
 KINDEX(2, 105)=40
 KINDEX(1, 106)=8
 KINDEX(2, 106)=40
 KINDEX(1, 107)=14
 KINDEX(2, 107)=40
 KINDEX(1, 108)=4
 KINDEX(2, 108)=41
 KINDEX(1, 109)=9
 KINDEX(2, 109)=41
 KINDEX(1, 110)=14
 KINDEX(2, 110)=41
 KINDEX(1, 111)=1
 KINDEX(2, 111)=42
 KINDEX(1, 112)=3
 KINDEX(2, 112)=42
 KINDEX(1, 113)=4
 KINDEX(2, 113)=42
 KINDEX(1, 114)=1
 KINDEX(2, 114)=43
 KINDEX(1, 115)=4
 KINDEX(2, 115)=43
 KINDEX(1, 116)=5
 KINDEX(2, 116)=43
 KINDEX(1, 117)=3
 KINDEX(2, 117)=44
 KINDEX(1, 118)=4
 KINDEX(2, 118)=44
 KINDEX(1, 119)=3
 KINDEX(2, 119)=45
 KINDEX(1, 120)=4
 KINDEX(2, 120)=45
 KINDEX(1, 121)=5
 KINDEX(2, 121)=45
 KINDEX(1, 122)=3
 KINDEX(2, 122)=46
 KINDEX(1, 123)=4
 KINDEX(2, 123)=46
 KINDEX(1, 124)=5
 KINDEX(2, 124)=46
 KINDEX(1, 125)=4
 KINDEX(2, 125)=47
 KINDEX(1, 126)=5
 KINDEX(2, 126)=47
 KINDEX(1, 127)=6
 KINDEX(2, 127)=47
 KINDEX(1, 128)=4
 KINDEX(2, 128)=48
 KINDEX(1, 129)=5
 KINDEX(2, 129)=48
 KINDEX(1, 130)=6
 KINDEX(2, 130)=48
 KINDEX(1, 131)=4
 KINDEX(2, 131)=49
 KINDEX(1, 132)=5
 KINDEX(2, 132)=49
 KINDEX(1, 133)=10
 KINDEX(2, 133)=50
 KINDEX(1, 134)=14
 KINDEX(2, 134)=50
 KINDEX(1, 135)=14
 KINDEX(2, 135)=51
 KINDEX(1, 136)=15
 KINDEX(2, 136)=51
 KINDEX(1, 137)=11
 KINDEX(2, 137)=52
 KINDEX(1, 138)=12
 KINDEX(2, 138)=52
 KINDEX(1, 139)=14
 KINDEX(2, 139)=52
 KINDEX(1, 140)=15
 KINDEX(2, 140)=52
 KINDEX(1, 141)=13
 KINDEX(2, 141)=53
 KINDEX(1, 142)=14
 KINDEX(2, 142)=53
 KINDEX(1, 143)=15
 KINDEX(2, 143)=53
 KINDEX(1, 144)=13
 KINDEX(2, 144)=54
 KINDEX(1, 145)=14
 KINDEX(2, 145)=54
 KINDEX(1, 146)=15
 KINDEX(2, 146)=54
 KINDEX(1, 147)=19
 KINDEX(2, 147)=54
 KINDEX(1, 148)=20
 KINDEX(2, 148)=54
 KINDEX(1, 149)=22
 KINDEX(2, 149)=54
 KINDEX(1, 150)=25
 KINDEX(2, 150)=54
 KINDEX(1, 151)=41
 KINDEX(2, 151)=54
 KINDEX(1, 152)=23
 KINDEX(2, 152)=55
 KINDEX(1, 153)=25
 KINDEX(2, 153)=55
 KINDEX(1, 154)=14
 KINDEX(2, 154)=56
 KINDEX(1, 155)=16
 KINDEX(2, 155)=56
 KINDEX(1, 156)=32
 KINDEX(2, 156)=56
 KINDEX(1, 157)=14
 KINDEX(2, 157)=57
 KINDEX(1, 158)=17
 KINDEX(2, 158)=57
 KINDEX(1, 159)=33
 KINDEX(2, 159)=57
 KINDEX(1, 160)=13
 KINDEX(2, 160)=58
 KINDEX(1, 161)=14
 KINDEX(2, 161)=58
 KINDEX(1, 162)=15
 KINDEX(2, 162)=58
 KINDEX(1, 163)=18
 KINDEX(2, 163)=58
 KINDEX(1, 164)=22
 KINDEX(2, 164)=58
 KINDEX(1, 165)=23
 KINDEX(2, 165)=58
 KINDEX(1, 166)=24
 KINDEX(2, 166)=58
 KINDEX(1, 167)=25
 KINDEX(2, 167)=58
 KINDEX(1, 168)=30
 KINDEX(2, 168)=58
 KINDEX(1, 169)=33
 KINDEX(2, 169)=58
 KINDEX(1, 170)=14
 KINDEX(2, 170)=59
 KINDEX(1, 171)=19
 KINDEX(2, 171)=59
 KINDEX(1, 172)=34
 KINDEX(2, 172)=59
 KINDEX(1, 173)=35
 KINDEX(2, 173)=59
 KINDEX(1, 174)=14
 KINDEX(2, 174)=60
 KINDEX(1, 175)=20
 KINDEX(2, 175)=60
 KINDEX(1, 176)=35
 KINDEX(2, 176)=60
 KINDEX(1, 177)=14
 KINDEX(2, 177)=61
 KINDEX(1, 178)=15
 KINDEX(2, 178)=61
 KINDEX(1, 179)=21
 KINDEX(2, 179)=61
 KINDEX(1, 180)=36
 KINDEX(2, 180)=61
 KINDEX(1, 181)=37
 KINDEX(2, 181)=61
 KINDEX(1, 182)=41
 KINDEX(2, 182)=61
 KINDEX(1, 183)=13
 KINDEX(2, 183)=62
 KINDEX(1, 184)=14
 KINDEX(2, 184)=62
 KINDEX(1, 185)=15
 KINDEX(2, 185)=62
 KINDEX(1, 186)=22
 KINDEX(2, 186)=62
 KINDEX(1, 187)=14
 KINDEX(2, 187)=63
 KINDEX(1, 188)=23
 KINDEX(2, 188)=63
 KINDEX(1, 189)=39
 KINDEX(2, 189)=63
 KINDEX(1, 190)=14
 KINDEX(2, 190)=64
 KINDEX(1, 191)=24
 KINDEX(2, 191)=64
 KINDEX(1, 192)=39
 KINDEX(2, 192)=64
 KINDEX(1, 193)=13
 KINDEX(2, 193)=65
 KINDEX(1, 194)=14
 KINDEX(2, 194)=65
 KINDEX(1, 195)=15
 KINDEX(2, 195)=65
 KINDEX(1, 196)=22
 KINDEX(2, 196)=65
 KINDEX(1, 197)=23
 KINDEX(2, 197)=65
 KINDEX(1, 198)=24
 KINDEX(2, 198)=65
 KINDEX(1, 199)=25
 KINDEX(2, 199)=65
 KINDEX(1, 200)=39
 KINDEX(2, 200)=65
 KINDEX(1, 201)=41
 KINDEX(2, 201)=65
 KINDEX(1, 202)=14
 KINDEX(2, 202)=66
 KINDEX(1, 203)=15
 KINDEX(2, 203)=66
 KINDEX(1, 204)=30
 KINDEX(2, 204)=66
 KINDEX(1, 205)=14
 KINDEX(2, 205)=67
 KINDEX(1, 206)=31
 KINDEX(2, 206)=67
 KINDEX(1, 207)=14
 KINDEX(2, 207)=68
 KINDEX(1, 208)=22
 KINDEX(2, 208)=68
 KINDEX(1, 209)=28
 KINDEX(2, 209)=68
 KINDEX(1, 210)=32
 KINDEX(2, 210)=68
 KINDEX(1, 211)=14
 KINDEX(2, 211)=69
 KINDEX(1, 212)=15
 KINDEX(2, 212)=69
 KINDEX(1, 213)=22
 KINDEX(2, 213)=69
 KINDEX(1, 214)=23
 KINDEX(2, 214)=69
 KINDEX(1, 215)=24
 KINDEX(2, 215)=69
 KINDEX(1, 216)=29
 KINDEX(2, 216)=69
 KINDEX(1, 217)=33
 KINDEX(2, 217)=69
 KINDEX(1, 218)=39
 KINDEX(2, 218)=69
 KINDEX(1, 219)=41
 KINDEX(2, 219)=69
 KINDEX(1, 220)=5
 KINDEX(2, 220)=70
 KINDEX(1, 221)=14
 KINDEX(2, 221)=70
 KINDEX(1, 222)=15
 KINDEX(2, 222)=70
 KINDEX(1, 223)=22
 KINDEX(2, 223)=70
 KINDEX(1, 224)=25
 KINDEX(2, 224)=70
 KINDEX(1, 225)=27
 KINDEX(2, 225)=70
 KINDEX(1, 226)=41
 KINDEX(2, 226)=70
 KINDEX(1, 227)=4
 KINDEX(2, 227)=71
 KINDEX(1, 228)=14
 KINDEX(2, 228)=71
 KINDEX(1, 229)=26
 KINDEX(2, 229)=71
 KINDEX(1, 230)=33
 KINDEX(2, 230)=71
 KINDEX(1, 231)=5
 KINDEX(2, 231)=72
 KINDEX(1, 232)=8
 KINDEX(2, 232)=72
 KINDEX(1, 233)=13
 KINDEX(2, 233)=72
 KINDEX(1, 234)=15
 KINDEX(2, 234)=72
 KINDEX(1, 235)=22
 KINDEX(2, 235)=72
 KINDEX(1, 236)=5
 KINDEX(2, 236)=73
 KINDEX(1, 237)=8
 KINDEX(2, 237)=73
 KINDEX(1, 238)=23
 KINDEX(2, 238)=73
 KINDEX(1, 239)=39
 KINDEX(2, 239)=73
 KINDEX(1, 240)=4
 KINDEX(2, 240)=74
 KINDEX(1, 241)=5
 KINDEX(2, 241)=74
 KINDEX(1, 242)=8
 KINDEX(2, 242)=74
 KINDEX(1, 243)=13
 KINDEX(2, 243)=74
 KINDEX(1, 244)=15
 KINDEX(2, 244)=74
 KINDEX(1, 245)=23
 KINDEX(2, 245)=74
 KINDEX(1, 246)=24
 KINDEX(2, 246)=74
 KINDEX(1, 247)=25
 KINDEX(2, 247)=74
 KINDEX(1, 248)=39
 KINDEX(2, 248)=74
 KINDEX(1, 249)=40
 KINDEX(2, 249)=74
 KINDEX(1, 250)=41
 KINDEX(2, 250)=74
 KINDEX(1, 251)=5
 KINDEX(2, 251)=75
 KINDEX(1, 252)=8
 KINDEX(2, 252)=75
 KINDEX(1, 253)=21
 KINDEX(2, 253)=75
 KINDEX(1, 254)=36
 KINDEX(2, 254)=75
 KINDEX(1, 255)=5
 KINDEX(2, 255)=76
 KINDEX(1, 256)=19
 KINDEX(2, 256)=76
 KINDEX(1, 257)=25
 KINDEX(2, 257)=76
 KINDEX(1, 258)=40
 KINDEX(2, 258)=76
 KINDEX(1, 259)=5
 KINDEX(2, 259)=77
 KINDEX(1, 260)=20
 KINDEX(2, 260)=77
 KINDEX(1, 261)=25
 KINDEX(2, 261)=77
 KINDEX(1, 262)=40
 KINDEX(2, 262)=77
 KINDEX(1, 263)=4
 KINDEX(2, 263)=78
 KINDEX(1, 264)=5
 KINDEX(2, 264)=78
 KINDEX(1, 265)=22
 KINDEX(2, 265)=78
 KINDEX(1, 266)=26
 KINDEX(2, 266)=78
 KINDEX(1, 267)=27
 KINDEX(2, 267)=78
 KINDEX(1, 268)=41
 KINDEX(2, 268)=78
 KINDEX(1, 269)=1
 KINDEX(2, 269)=79
 KINDEX(1, 270)=2
 KINDEX(2, 270)=79
 KINDEX(1, 271)=13
 KINDEX(2, 271)=79
 KINDEX(1, 272)=14
 KINDEX(2, 272)=79
 KINDEX(1, 273)=15
 KINDEX(2, 273)=79
 KINDEX(1, 274)=16
 KINDEX(2, 274)=79
 KINDEX(1, 275)=17
 KINDEX(2, 275)=79
 KINDEX(1, 276)=19
 KINDEX(2, 276)=79
 KINDEX(1, 277)=22
 KINDEX(2, 277)=79
 KINDEX(1, 278)=23
 KINDEX(2, 278)=79
 KINDEX(1, 279)=24
 KINDEX(2, 279)=79
 KINDEX(1, 280)=25
 KINDEX(2, 280)=79
 KINDEX(1, 281)=30
 KINDEX(2, 281)=79
 KINDEX(1, 282)=31
 KINDEX(2, 282)=79
 KINDEX(1, 283)=32
 KINDEX(2, 283)=79
 KINDEX(1, 284)=33
 KINDEX(2, 284)=79
 KINDEX(1, 285)=39
 KINDEX(2, 285)=79
 KINDEX(1, 286)=41
 KINDEX(2, 286)=79
 KINDEX(1, 287)=1
 KINDEX(2, 287)=80
 KINDEX(1, 288)=2
 KINDEX(2, 288)=80
 KINDEX(1, 289)=13
 KINDEX(2, 289)=80
 KINDEX(1, 290)=14
 KINDEX(2, 290)=80
 KINDEX(1, 291)=15
 KINDEX(2, 291)=80
 KINDEX(1, 292)=19
 KINDEX(2, 292)=80
 KINDEX(1, 293)=20
 KINDEX(2, 293)=80
 KINDEX(1, 294)=22
 KINDEX(2, 294)=80
 KINDEX(1, 295)=23
 KINDEX(2, 295)=80
 KINDEX(1, 296)=24
 KINDEX(2, 296)=80
 KINDEX(1, 297)=25
 KINDEX(2, 297)=80
 KINDEX(1, 298)=30
 KINDEX(2, 298)=80
 KINDEX(1, 299)=31
 KINDEX(2, 299)=80
 KINDEX(1, 300)=32
 KINDEX(2, 300)=80
 KINDEX(1, 301)=33
 KINDEX(2, 301)=80
 KINDEX(1, 302)=39
 KINDEX(2, 302)=80
 KINDEX(1, 303)=41
 KINDEX(2, 303)=80
 KINDEX(1, 304)=1
 KINDEX(2, 304)=81
 KINDEX(1, 305)=13
 KINDEX(2, 305)=81
 KINDEX(1, 306)=14
 KINDEX(2, 306)=81
 KINDEX(1, 307)=15
 KINDEX(2, 307)=81
 KINDEX(1, 308)=22
 KINDEX(2, 308)=81
 KINDEX(1, 309)=23
 KINDEX(2, 309)=81
 KINDEX(1, 310)=25
 KINDEX(2, 310)=81
 KINDEX(1, 311)=29
 KINDEX(2, 311)=81
 KINDEX(1, 312)=30
 KINDEX(2, 312)=81
 KINDEX(1, 313)=31
 KINDEX(2, 313)=81
 KINDEX(1, 314)=39
 KINDEX(2, 314)=81
 KINDEX(1, 315)=1
 KINDEX(2, 315)=82
 KINDEX(1, 316)=4
 KINDEX(2, 316)=82
 KINDEX(1, 317)=13
 KINDEX(2, 317)=82
 KINDEX(1, 318)=14
 KINDEX(2, 318)=82
 KINDEX(1, 319)=15
 KINDEX(2, 319)=82
 KINDEX(1, 320)=22
 KINDEX(2, 320)=82
 KINDEX(1, 321)=27
 KINDEX(2, 321)=82
 KINDEX(1, 322)=30
 KINDEX(2, 322)=82
 KINDEX(1, 323)=39
 KINDEX(2, 323)=82
 KINDEX(1, 324)=4
 KINDEX(2, 324)=83
 KINDEX(1, 325)=21
 KINDEX(2, 325)=83
 KINDEX(1, 326)=26
 KINDEX(2, 326)=83
 KINDEX(1, 327)=36
 KINDEX(2, 327)=83
 KINDEX(1, 328)=15
 KINDEX(2, 328)=84
 KINDEX(1, 329)=21
 KINDEX(2, 329)=84
 KINDEX(1, 330)=36
 KINDEX(2, 330)=84
 KINDEX(1, 331)=4
 KINDEX(2, 331)=85
 KINDEX(1, 332)=7
 KINDEX(2, 332)=85
 KINDEX(1, 333)=21
 KINDEX(2, 333)=85
 KINDEX(1, 334)=37
 KINDEX(2, 334)=85
 KINDEX(1, 335)=15
 KINDEX(2, 335)=86
 KINDEX(1, 336)=21
 KINDEX(2, 336)=86
 KINDEX(1, 337)=37
 KINDEX(2, 337)=86
 KINDEX(1, 338)=38
 KINDEX(2, 338)=86
 KINDEX(1, 339)=1
 KINDEX(2, 339)=87
 KINDEX(1, 340)=14
 KINDEX(2, 340)=87
 KINDEX(1, 341)=21
 KINDEX(2, 341)=87
 KINDEX(1, 342)=37
 KINDEX(2, 342)=87
 KINDEX(1, 343)=4
 KINDEX(2, 343)=88
 KINDEX(1, 344)=27
 KINDEX(2, 344)=88
 KINDEX(1, 345)=39
 KINDEX(2, 345)=88
 KINDEX(1, 346)=4
 KINDEX(2, 346)=89
 KINDEX(1, 347)=27
 KINDEX(2, 347)=89
 KINDEX(1, 348)=39
 KINDEX(2, 348)=89
 KINDEX(1, 349)=3
 KINDEX(2, 349)=90
 KINDEX(1, 350)=4
 KINDEX(2, 350)=90
 KINDEX(1, 351)=15
 KINDEX(2, 351)=90
 KINDEX(1, 352)=22
 KINDEX(2, 352)=90
 KINDEX(1, 353)=32
 KINDEX(2, 353)=90
 KINDEX(1, 354)=3
 KINDEX(2, 354)=91
 KINDEX(1, 355)=4
 KINDEX(2, 355)=91
 KINDEX(1, 356)=15
 KINDEX(2, 356)=91
 KINDEX(1, 357)=22
 KINDEX(2, 357)=91
 KINDEX(1, 358)=23
 KINDEX(2, 358)=91
 KINDEX(1, 359)=24
 KINDEX(2, 359)=91
 KINDEX(1, 360)=25
 KINDEX(2, 360)=91
 KINDEX(1, 361)=26
 KINDEX(2, 361)=91
 KINDEX(1, 362)=32
 KINDEX(2, 362)=91
 KINDEX(1, 363)=33
 KINDEX(2, 363)=91
 KINDEX(1, 364)=41
 KINDEX(2, 364)=91
 KINDEX(1, 365)=3
 KINDEX(2, 365)=92
 KINDEX(1, 366)=4
 KINDEX(2, 366)=92
 KINDEX(1, 367)=15
 KINDEX(2, 367)=92
 KINDEX(1, 368)=22
 KINDEX(2, 368)=92
 KINDEX(1, 369)=23
 KINDEX(2, 369)=92
 KINDEX(1, 370)=24
 KINDEX(2, 370)=92
 KINDEX(1, 371)=34
 KINDEX(2, 371)=92
 KINDEX(1, 372)=3
 KINDEX(2, 372)=93
 KINDEX(1, 373)=4
 KINDEX(2, 373)=93
 KINDEX(1, 374)=15
 KINDEX(2, 374)=93
 KINDEX(1, 375)=19
 KINDEX(2, 375)=93
 KINDEX(1, 376)=22
 KINDEX(2, 376)=93
 KINDEX(1, 377)=23
 KINDEX(2, 377)=93
 KINDEX(1, 378)=24
 KINDEX(2, 378)=93
 KINDEX(1, 379)=25
 KINDEX(2, 379)=93
 KINDEX(1, 380)=26
 KINDEX(2, 380)=93
 KINDEX(1, 381)=35
 KINDEX(2, 381)=93
 KINDEX(1, 382)=3
 KINDEX(2, 382)=94
 KINDEX(1, 383)=4
 KINDEX(2, 383)=94
 KINDEX(1, 384)=15
 KINDEX(2, 384)=94
 KINDEX(1, 385)=25
 KINDEX(2, 385)=94
 KINDEX(1, 386)=26
 KINDEX(2, 386)=94
 KINDEX(1, 387)=38
 KINDEX(2, 387)=94
 KINDEX(1, 388)=3
 KINDEX(2, 388)=95
 KINDEX(1, 389)=4
 KINDEX(2, 389)=95
 KINDEX(1, 390)=15
 KINDEX(2, 390)=95
 KINDEX(1, 391)=22
 KINDEX(2, 391)=95
 KINDEX(1, 392)=23
 KINDEX(2, 392)=95
 KINDEX(1, 393)=25
 KINDEX(2, 393)=95
 KINDEX(1, 394)=32
 KINDEX(2, 394)=95
 KINDEX(1, 395)=39
 KINDEX(2, 395)=95
 KINDEX(1, 396)=41
 KINDEX(2, 396)=95
 KINDEX(1, 397)=3
 KINDEX(2, 397)=96
 KINDEX(1, 398)=4
 KINDEX(2, 398)=96
 KINDEX(1, 399)=15
 KINDEX(2, 399)=96
 KINDEX(1, 400)=22
 KINDEX(2, 400)=96
 KINDEX(1, 401)=23
 KINDEX(2, 401)=96
 KINDEX(1, 402)=24
 KINDEX(2, 402)=96
 KINDEX(1, 403)=26
 KINDEX(2, 403)=96
 KINDEX(1, 404)=40
 KINDEX(2, 404)=96
 KINDEX(1, 405)=15
 KINDEX(2, 405)=97
 KINDEX(1, 406)=28
 KINDEX(2, 406)=97
 KINDEX(1, 407)=32
 KINDEX(2, 407)=97
 KINDEX(1, 408)=15
 KINDEX(2, 408)=98
 KINDEX(1, 409)=29
 KINDEX(2, 409)=98
 KINDEX(1, 410)=33
 KINDEX(2, 410)=98
 KINDEX(1, 411)=15
 KINDEX(2, 411)=99
 KINDEX(1, 412)=29
 KINDEX(2, 412)=99
 KINDEX(1, 413)=34
 KINDEX(2, 413)=99
 KINDEX(1, 414)=15
 KINDEX(2, 414)=100
 KINDEX(1, 415)=29
 KINDEX(2, 415)=100
 KINDEX(1, 416)=35
 KINDEX(2, 416)=100
 KINDEX(1, 417)=15
 KINDEX(2, 417)=101
 KINDEX(1, 418)=29
 KINDEX(2, 418)=101
 KINDEX(1, 419)=38
 KINDEX(2, 419)=101
 KINDEX(1, 420)=1
 KINDEX(2, 420)=102
 KINDEX(1, 421)=15
 KINDEX(2, 421)=102
 KINDEX(1, 422)=29
 KINDEX(2, 422)=102
 KINDEX(1, 423)=31
 KINDEX(2, 423)=102
 KINDEX(1, 424)=39
 KINDEX(2, 424)=102
 KINDEX(1, 425)=15
 KINDEX(2, 425)=103
 KINDEX(1, 426)=26
 KINDEX(2, 426)=103
 KINDEX(1, 427)=40
 KINDEX(2, 427)=103
 KINDEX(1, 428)=15
 KINDEX(2, 428)=104
 KINDEX(1, 429)=22
 KINDEX(2, 429)=104
 KINDEX(1, 430)=32
 KINDEX(2, 430)=104
 KINDEX(1, 431)=15
 KINDEX(2, 431)=105
 KINDEX(1, 432)=22
 KINDEX(2, 432)=105
 KINDEX(1, 433)=23
 KINDEX(2, 433)=105
 KINDEX(1, 434)=24
 KINDEX(2, 434)=105
 KINDEX(1, 435)=25
 KINDEX(2, 435)=105
 KINDEX(1, 436)=32
 KINDEX(2, 436)=105
 KINDEX(1, 437)=33
 KINDEX(2, 437)=105
 KINDEX(1, 438)=41
 KINDEX(2, 438)=105
 KINDEX(1, 439)=15
 KINDEX(2, 439)=106
 KINDEX(1, 440)=22
 KINDEX(2, 440)=106
 KINDEX(1, 441)=23
 KINDEX(2, 441)=106
 KINDEX(1, 442)=24
 KINDEX(2, 442)=106
 KINDEX(1, 443)=32
 KINDEX(2, 443)=106
 KINDEX(1, 444)=34
 KINDEX(2, 444)=106
 KINDEX(1, 445)=15
 KINDEX(2, 445)=107
 KINDEX(1, 446)=19
 KINDEX(2, 446)=107
 KINDEX(1, 447)=22
 KINDEX(2, 447)=107
 KINDEX(1, 448)=23
 KINDEX(2, 448)=107
 KINDEX(1, 449)=24
 KINDEX(2, 449)=107
 KINDEX(1, 450)=25
 KINDEX(2, 450)=107
 KINDEX(1, 451)=32
 KINDEX(2, 451)=107
 KINDEX(1, 452)=35
 KINDEX(2, 452)=107
 KINDEX(1, 453)=15
 KINDEX(2, 453)=108
 KINDEX(1, 454)=22
 KINDEX(2, 454)=108
 KINDEX(1, 455)=25
 KINDEX(2, 455)=108
 KINDEX(1, 456)=32
 KINDEX(2, 456)=108
 KINDEX(1, 457)=38
 KINDEX(2, 457)=108
 KINDEX(1, 458)=15
 KINDEX(2, 458)=109
 KINDEX(1, 459)=22
 KINDEX(2, 459)=109
 KINDEX(1, 460)=23
 KINDEX(2, 460)=109
 KINDEX(1, 461)=25
 KINDEX(2, 461)=109
 KINDEX(1, 462)=31
 KINDEX(2, 462)=109
 KINDEX(1, 463)=32
 KINDEX(2, 463)=109
 KINDEX(1, 464)=39
 KINDEX(2, 464)=109
 KINDEX(1, 465)=41
 KINDEX(2, 465)=109
 KINDEX(1, 466)=4
 KINDEX(2, 466)=110
 KINDEX(1, 467)=15
 KINDEX(2, 467)=110
 KINDEX(1, 468)=22
 KINDEX(2, 468)=110
 KINDEX(1, 469)=23
 KINDEX(2, 469)=110
 KINDEX(1, 470)=24
 KINDEX(2, 470)=110
 KINDEX(1, 471)=26
 KINDEX(2, 471)=110
 KINDEX(1, 472)=32
 KINDEX(2, 472)=110
 KINDEX(1, 473)=40
 KINDEX(2, 473)=110
 KINDEX(1, 474)=15
 KINDEX(2, 474)=111
 KINDEX(1, 475)=22
 KINDEX(2, 475)=111
 KINDEX(1, 476)=23
 KINDEX(2, 476)=111
 KINDEX(1, 477)=24
 KINDEX(2, 477)=111
 KINDEX(1, 478)=25
 KINDEX(2, 478)=111
 KINDEX(1, 479)=31
 KINDEX(2, 479)=111
 KINDEX(1, 480)=32
 KINDEX(2, 480)=111
 KINDEX(1, 481)=33
 KINDEX(2, 481)=111
 KINDEX(1, 482)=39
 KINDEX(2, 482)=111
 KINDEX(1, 483)=41
 KINDEX(2, 483)=111
 KINDEX(1, 484)=15
 KINDEX(2, 484)=112
 KINDEX(1, 485)=22
 KINDEX(2, 485)=112
 KINDEX(1, 486)=23
 KINDEX(2, 486)=112
 KINDEX(1, 487)=24
 KINDEX(2, 487)=112
 KINDEX(1, 488)=31
 KINDEX(2, 488)=112
 KINDEX(1, 489)=32
 KINDEX(2, 489)=112
 KINDEX(1, 490)=34
 KINDEX(2, 490)=112
 KINDEX(1, 491)=39
 KINDEX(2, 491)=112
 KINDEX(1, 492)=15
 KINDEX(2, 492)=113
 KINDEX(1, 493)=19
 KINDEX(2, 493)=113
 KINDEX(1, 494)=22
 KINDEX(2, 494)=113
 KINDEX(1, 495)=23
 KINDEX(2, 495)=113
 KINDEX(1, 496)=24
 KINDEX(2, 496)=113
 KINDEX(1, 497)=25
 KINDEX(2, 497)=113
 KINDEX(1, 498)=31
 KINDEX(2, 498)=113
 KINDEX(1, 499)=32
 KINDEX(2, 499)=113
 KINDEX(1, 500)=35
 KINDEX(2, 500)=113
 KINDEX(1, 501)=39
 KINDEX(2, 501)=113
 KINDEX(1, 502)=15
 KINDEX(2, 502)=114
 KINDEX(1, 503)=25
 KINDEX(2, 503)=114
 KINDEX(1, 504)=32
 KINDEX(2, 504)=114
 KINDEX(1, 505)=38
 KINDEX(2, 505)=114
 KINDEX(1, 506)=39
 KINDEX(2, 506)=114
 KINDEX(1, 507)=15
 KINDEX(2, 507)=115
 KINDEX(1, 508)=22
 KINDEX(2, 508)=115
 KINDEX(1, 509)=23
 KINDEX(2, 509)=115
 KINDEX(1, 510)=24
 KINDEX(2, 510)=115
 KINDEX(1, 511)=25
 KINDEX(2, 511)=115
 KINDEX(1, 512)=31
 KINDEX(2, 512)=115
 KINDEX(1, 513)=32
 KINDEX(2, 513)=115
 KINDEX(1, 514)=39
 KINDEX(2, 514)=115
 KINDEX(1, 515)=41
 KINDEX(2, 515)=115
 KINDEX(1, 516)=4
 KINDEX(2, 516)=116
 KINDEX(1, 517)=15
 KINDEX(2, 517)=116
 KINDEX(1, 518)=22
 KINDEX(2, 518)=116
 KINDEX(1, 519)=23
 KINDEX(2, 519)=116
 KINDEX(1, 520)=24
 KINDEX(2, 520)=116
 KINDEX(1, 521)=26
 KINDEX(2, 521)=116
 KINDEX(1, 522)=31
 KINDEX(2, 522)=116
 KINDEX(1, 523)=32
 KINDEX(2, 523)=116
 KINDEX(1, 524)=39
 KINDEX(2, 524)=116
 KINDEX(1, 525)=40
 KINDEX(2, 525)=116
 KINDEX(1, 526)=15
 KINDEX(2, 526)=117
 KINDEX(1, 527)=26
 KINDEX(2, 527)=117
 KINDEX(1, 528)=40
 KINDEX(2, 528)=117
 KINDEX(1, 529)=4
 KINDEX(2, 529)=118
 KINDEX(1, 530)=15
 KINDEX(2, 530)=118
 KINDEX(1, 531)=22
 KINDEX(2, 531)=118
 KINDEX(1, 532)=23
 KINDEX(2, 532)=118
 KINDEX(1, 533)=24
 KINDEX(2, 533)=118
 KINDEX(1, 534)=26
 KINDEX(2, 534)=118
 KINDEX(1, 535)=40
 KINDEX(2, 535)=118
 KINDEX(1, 536)=4
 KINDEX(2, 536)=119
 KINDEX(1, 537)=5
 KINDEX(2, 537)=119
 KINDEX(1, 538)=15
 KINDEX(2, 538)=119
 KINDEX(1, 539)=22
 KINDEX(2, 539)=119
 KINDEX(1, 540)=32
 KINDEX(2, 540)=119
 KINDEX(1, 541)=4
 KINDEX(2, 541)=120
 KINDEX(1, 542)=5
 KINDEX(2, 542)=120
 KINDEX(1, 543)=15
 KINDEX(2, 543)=120
 KINDEX(1, 544)=22
 KINDEX(2, 544)=120
 KINDEX(1, 545)=23
 KINDEX(2, 545)=120
 KINDEX(1, 546)=24
 KINDEX(2, 546)=120
 KINDEX(1, 547)=25
 KINDEX(2, 547)=120
 KINDEX(1, 548)=32
 KINDEX(2, 548)=120
 KINDEX(1, 549)=33
 KINDEX(2, 549)=120
 KINDEX(1, 550)=41
 KINDEX(2, 550)=120
 KINDEX(1, 551)=4
 KINDEX(2, 551)=121
 KINDEX(1, 552)=5
 KINDEX(2, 552)=121
 KINDEX(1, 553)=15
 KINDEX(2, 553)=121
 KINDEX(1, 554)=22
 KINDEX(2, 554)=121
 KINDEX(1, 555)=23
 KINDEX(2, 555)=121
 KINDEX(1, 556)=24
 KINDEX(2, 556)=121
 KINDEX(1, 557)=34
 KINDEX(2, 557)=121
 KINDEX(1, 558)=4
 KINDEX(2, 558)=122
 KINDEX(1, 559)=5
 KINDEX(2, 559)=122
 KINDEX(1, 560)=15
 KINDEX(2, 560)=122
 KINDEX(1, 561)=19
 KINDEX(2, 561)=122
 KINDEX(1, 562)=22
 KINDEX(2, 562)=122
 KINDEX(1, 563)=23
 KINDEX(2, 563)=122
 KINDEX(1, 564)=24
 KINDEX(2, 564)=122
 KINDEX(1, 565)=25
 KINDEX(2, 565)=122
 KINDEX(1, 566)=35
 KINDEX(2, 566)=122
 KINDEX(1, 567)=4
 KINDEX(2, 567)=123
 KINDEX(1, 568)=5
 KINDEX(2, 568)=123
 KINDEX(1, 569)=15
 KINDEX(2, 569)=123
 KINDEX(1, 570)=25
 KINDEX(2, 570)=123
 KINDEX(1, 571)=38
 KINDEX(2, 571)=123
 KINDEX(1, 572)=4
 KINDEX(2, 572)=124
 KINDEX(1, 573)=5
 KINDEX(2, 573)=124
 KINDEX(1, 574)=15
 KINDEX(2, 574)=124
 KINDEX(1, 575)=22
 KINDEX(2, 575)=124
 KINDEX(1, 576)=23
 KINDEX(2, 576)=124
 KINDEX(1, 577)=25
 KINDEX(2, 577)=124
 KINDEX(1, 578)=32
 KINDEX(2, 578)=124
 KINDEX(1, 579)=39
 KINDEX(2, 579)=124
 KINDEX(1, 580)=41
 KINDEX(2, 580)=124
 KINDEX(1, 581)=4
 KINDEX(2, 581)=125
 KINDEX(1, 582)=5
 KINDEX(2, 582)=125
 KINDEX(1, 583)=15
 KINDEX(2, 583)=125
 KINDEX(1, 584)=22
 KINDEX(2, 584)=125
 KINDEX(1, 585)=23
 KINDEX(2, 585)=125
 KINDEX(1, 586)=24
 KINDEX(2, 586)=125
 KINDEX(1, 587)=26
 KINDEX(2, 587)=125
 KINDEX(1, 588)=40
 KINDEX(2, 588)=125
 KINDEX(1, 589)=15
 KINDEX(2, 589)=126
 KINDEX(1, 590)=29
 KINDEX(2, 590)=126
 KINDEX(1, 591)=41
 KINDEX(2, 591)=126
 KINDEX(1, 592)=15
 KINDEX(2, 592)=127
 KINDEX(1, 593)=22
 KINDEX(2, 593)=127
 KINDEX(1, 594)=32
 KINDEX(2, 594)=127
 KINDEX(1, 595)=41
 KINDEX(2, 595)=127
 KINDEX(1, 596)=32
 KINDEX(2, 596)=128
 KINDEX(1, 597)=39
 KINDEX(2, 597)=128
 KINDEX(1, 598)=41
 KINDEX(2, 598)=128
 KINDEX(1, 599)=41
 KINDEX(2, 599)=129
 KINDEX(1, 600)=3
 KINDEX(2, 600)=130
 KINDEX(1, 601)=4
 KINDEX(2, 601)=130
 KINDEX(1, 602)=41
 KINDEX(2, 602)=130
 KINDEX(1, 603)=4
 KINDEX(2, 603)=131
 KINDEX(1, 604)=5
 KINDEX(2, 604)=131
 KINDEX(1, 605)=41
 KINDEX(2, 605)=131
 KINDEX(1, 606)=12
 KINDEX(2, 606)=132
RETURN
END SUBROUTINE CH_NONZEROTERMS_GAZ
!!
END SUBROUTINE CH_NONZEROTERMS
!
!========================================================================
!
!!    #####################
      MODULE MODI_CH_SPARSE
!!    #####################
INTERFACE
SUBROUTINE CH_SPARSE(KMI, KSPARSE, KSPARSEDIM)
IMPLICIT NONE
INTEGER, INTENT(IN)                           :: KMI
INTEGER, INTENT(INOUT)                        :: KSPARSEDIM
INTEGER, INTENT(OUT), DIMENSION(2,KSPARSEDIM) :: KSPARSE
END SUBROUTINE CH_SPARSE
END INTERFACE
END MODULE MODI_CH_SPARSE
!
!========================================================================
!
!!    ##############################################
      SUBROUTINE CH_SPARSE(KMI, KSPARSE, KSPARSEDIM)
!!    ##############################################
!!
!!*** *MODD_CH_SPARSE*
!!
!!    PURPOSE
!!    -------
!       calculation of the non-zero matrix elements in the Jacobian
!!
!!**  METHOD
!!    ------
!!      A 2D array KSPARSE of DIMESNSION(2,*) is returned, containing 
!!    the indices of the non-zero matrix elements in the Jacobian.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
USE MODD_CH_M9_SCHEME, ONLY : TACCS
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
INTEGER, INTENT(IN)                           :: KMI
INTEGER, INTENT(INOUT)                        :: KSPARSEDIM
INTEGER, INTENT(OUT), DIMENSION(2,KSPARSEDIM) :: KSPARSE
!!
!!    LOCAL VARIABLES
!!    ---------------
!!    none
!!----------------------------------------------------------------------
!!
!!    EXECUTABLE STATEMENTS
!!    ---------------------
IF (TACCS(KMI)%LUSECHAQ) THEN
   CALL CH_SPARSE_AQ
ELSE
   CALL CH_SPARSE_GAZ
END IF
CONTAINS
!!
!!    #######################
      SUBROUTINE CH_SPARSE_AQ
!!    #######################
!!
!!*** *MODD_CH_SPARSE*
!!
!!    PURPOSE
!!    -------
!       calculation of the non-zero matrix elements in the Jacobian
!!
!!**  METHOD
!!    ------
!!      A 2D array KSPARSE of DIMESNSION(2,*) is returned, containing 
!!    the indices of the non-zero matrix elements in the Jacobian.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!    none
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
!!
!!    LOCAL VARIABLES
!!    ---------------
!!    none
!!----------------------------------------------------------------------
!!
!!    EXECUTABLE STATEMENTS
!!    ---------------------
! check if output array is large enough
IF (KSPARSEDIM.LT.745) THEN
  STOP 'CH_SPARSE ERROR: array KSPARSE is too small!'
END IF
!O3/O3
 KSPARSE(1, 1)=1
 KSPARSE(2, 1)=1
!O3/NO
 KSPARSE(1, 2)=1
 KSPARSE(2, 2)=3
!O3/NO2
 KSPARSE(1, 3)=1
 KSPARSE(2, 3)=4
!O3/OH
 KSPARSE(1, 4)=1
 KSPARSE(2, 4)=14
!O3/HO2
 KSPARSE(1, 5)=1
 KSPARSE(2, 5)=15
!O3/ALKE
 KSPARSE(1, 6)=1
 KSPARSE(2, 6)=19
!O3/BIO
 KSPARSE(1, 7)=1
 KSPARSE(2, 7)=20
!O3/CARBO
 KSPARSE(1, 8)=1
 KSPARSE(2, 8)=25
!O3/PAN
 KSPARSE(1, 9)=1
 KSPARSE(2, 9)=27
!O3/ADD
 KSPARSE(1, 10)=1
 KSPARSE(2, 10)=37
!O3/CARBOP
 KSPARSE(1, 11)=1
 KSPARSE(2, 11)=39
!O3/WC_O3
 KSPARSE(1, 12)=1
 KSPARSE(2, 12)=42
!O3/WR_O3
 KSPARSE(1, 13)=1
 KSPARSE(2, 13)=67
!H2O2/O3
 KSPARSE(1, 14)=2
 KSPARSE(2, 14)=1
!H2O2/H2O2
 KSPARSE(1, 15)=2
 KSPARSE(2, 15)=2
!H2O2/OH
 KSPARSE(1, 16)=2
 KSPARSE(2, 16)=14
!H2O2/HO2
 KSPARSE(1, 17)=2
 KSPARSE(2, 17)=15
!H2O2/ALKE
 KSPARSE(1, 18)=2
 KSPARSE(2, 18)=19
!H2O2/BIO
 KSPARSE(1, 19)=2
 KSPARSE(2, 19)=20
!H2O2/WC_H2O2
 KSPARSE(1, 20)=2
 KSPARSE(2, 20)=43
!H2O2/WR_H2O2
 KSPARSE(1, 21)=2
 KSPARSE(2, 21)=68
!NO/O3
 KSPARSE(1, 22)=3
 KSPARSE(2, 22)=1
!NO/NO
 KSPARSE(1, 23)=3
 KSPARSE(2, 23)=3
!NO/NO2
 KSPARSE(1, 24)=3
 KSPARSE(2, 24)=4
!NO/NO3
 KSPARSE(1, 25)=3
 KSPARSE(2, 25)=5
!NO/HONO
 KSPARSE(1, 26)=3
 KSPARSE(2, 26)=7
!NO/OH
 KSPARSE(1, 27)=3
 KSPARSE(2, 27)=14
!NO/HO2
 KSPARSE(1, 28)=3
 KSPARSE(2, 28)=15
!NO/MO2
 KSPARSE(1, 29)=3
 KSPARSE(2, 29)=32
!NO/ALKAP
 KSPARSE(1, 30)=3
 KSPARSE(2, 30)=33
!NO/ALKEP
 KSPARSE(1, 31)=3
 KSPARSE(2, 31)=34
!NO/BIOP
 KSPARSE(1, 32)=3
 KSPARSE(2, 32)=35
!NO/AROP
 KSPARSE(1, 33)=3
 KSPARSE(2, 33)=38
!NO/CARBOP
 KSPARSE(1, 34)=3
 KSPARSE(2, 34)=39
!NO/OLN
 KSPARSE(1, 35)=3
 KSPARSE(2, 35)=40
!NO/XO2
 KSPARSE(1, 36)=3
 KSPARSE(2, 36)=41
!NO/WC_NO
 KSPARSE(1, 37)=3
 KSPARSE(2, 37)=44
!NO/WR_NO
 KSPARSE(1, 38)=3
 KSPARSE(2, 38)=69
!NO2/O3
 KSPARSE(1, 39)=4
 KSPARSE(2, 39)=1
!NO2/NO
 KSPARSE(1, 40)=4
 KSPARSE(2, 40)=3
!NO2/NO2
 KSPARSE(1, 41)=4
 KSPARSE(2, 41)=4
!NO2/NO3
 KSPARSE(1, 42)=4
 KSPARSE(2, 42)=5
!NO2/N2O5
 KSPARSE(1, 43)=4
 KSPARSE(2, 43)=6
!NO2/HONO
 KSPARSE(1, 44)=4
 KSPARSE(2, 44)=7
!NO2/HNO3
 KSPARSE(1, 45)=4
 KSPARSE(2, 45)=8
!NO2/HNO4
 KSPARSE(1, 46)=4
 KSPARSE(2, 46)=9
!NO2/OH
 KSPARSE(1, 47)=4
 KSPARSE(2, 47)=14
!NO2/HO2
 KSPARSE(1, 48)=4
 KSPARSE(2, 48)=15
!NO2/CARBO
 KSPARSE(1, 49)=4
 KSPARSE(2, 49)=25
!NO2/ONIT
 KSPARSE(1, 50)=4
 KSPARSE(2, 50)=26
!NO2/PAN
 KSPARSE(1, 51)=4
 KSPARSE(2, 51)=27
!NO2/MO2
 KSPARSE(1, 52)=4
 KSPARSE(2, 52)=32
!NO2/ALKAP
 KSPARSE(1, 53)=4
 KSPARSE(2, 53)=33
!NO2/ALKEP
 KSPARSE(1, 54)=4
 KSPARSE(2, 54)=34
!NO2/BIOP
 KSPARSE(1, 55)=4
 KSPARSE(2, 55)=35
!NO2/PHO
 KSPARSE(1, 56)=4
 KSPARSE(2, 56)=36
!NO2/ADD
 KSPARSE(1, 57)=4
 KSPARSE(2, 57)=37
!NO2/AROP
 KSPARSE(1, 58)=4
 KSPARSE(2, 58)=38
!NO2/CARBOP
 KSPARSE(1, 59)=4
 KSPARSE(2, 59)=39
!NO2/OLN
 KSPARSE(1, 60)=4
 KSPARSE(2, 60)=40
!NO2/XO2
 KSPARSE(1, 61)=4
 KSPARSE(2, 61)=41
!NO2/WC_NO2
 KSPARSE(1, 62)=4
 KSPARSE(2, 62)=45
!NO2/WR_NO2
 KSPARSE(1, 63)=4
 KSPARSE(2, 63)=70
!NO3/O3
 KSPARSE(1, 64)=5
 KSPARSE(2, 64)=1
!NO3/NO
 KSPARSE(1, 65)=5
 KSPARSE(2, 65)=3
!NO3/NO2
 KSPARSE(1, 66)=5
 KSPARSE(2, 66)=4
!NO3/NO3
 KSPARSE(1, 67)=5
 KSPARSE(2, 67)=5
!NO3/N2O5
 KSPARSE(1, 68)=5
 KSPARSE(2, 68)=6
!NO3/HNO3
 KSPARSE(1, 69)=5
 KSPARSE(2, 69)=8
!NO3/HNO4
 KSPARSE(1, 70)=5
 KSPARSE(2, 70)=9
!NO3/OH
 KSPARSE(1, 71)=5
 KSPARSE(2, 71)=14
!NO3/HO2
 KSPARSE(1, 72)=5
 KSPARSE(2, 72)=15
!NO3/ALKE
 KSPARSE(1, 73)=5
 KSPARSE(2, 73)=19
!NO3/BIO
 KSPARSE(1, 74)=5
 KSPARSE(2, 74)=20
!NO3/ARO
 KSPARSE(1, 75)=5
 KSPARSE(2, 75)=21
!NO3/HCHO
 KSPARSE(1, 76)=5
 KSPARSE(2, 76)=22
!NO3/ALD
 KSPARSE(1, 77)=5
 KSPARSE(2, 77)=23
!NO3/CARBO
 KSPARSE(1, 78)=5
 KSPARSE(2, 78)=25
!NO3/PAN
 KSPARSE(1, 79)=5
 KSPARSE(2, 79)=27
!NO3/MO2
 KSPARSE(1, 80)=5
 KSPARSE(2, 80)=32
!NO3/ALKAP
 KSPARSE(1, 81)=5
 KSPARSE(2, 81)=33
!NO3/ALKEP
 KSPARSE(1, 82)=5
 KSPARSE(2, 82)=34
!NO3/BIOP
 KSPARSE(1, 83)=5
 KSPARSE(2, 83)=35
!NO3/AROP
 KSPARSE(1, 84)=5
 KSPARSE(2, 84)=38
!NO3/CARBOP
 KSPARSE(1, 85)=5
 KSPARSE(2, 85)=39
!NO3/OLN
 KSPARSE(1, 86)=5
 KSPARSE(2, 86)=40
!NO3/XO2
 KSPARSE(1, 87)=5
 KSPARSE(2, 87)=41
!NO3/WC_NO3
 KSPARSE(1, 88)=5
 KSPARSE(2, 88)=46
!NO3/WR_NO3
 KSPARSE(1, 89)=5
 KSPARSE(2, 89)=71
!N2O5/NO2
 KSPARSE(1, 90)=6
 KSPARSE(2, 90)=4
!N2O5/NO3
 KSPARSE(1, 91)=6
 KSPARSE(2, 91)=5
!N2O5/N2O5
 KSPARSE(1, 92)=6
 KSPARSE(2, 92)=6
!N2O5/WC_N2O5
 KSPARSE(1, 93)=6
 KSPARSE(2, 93)=47
!N2O5/WR_N2O5
 KSPARSE(1, 94)=6
 KSPARSE(2, 94)=72
!HONO/NO
 KSPARSE(1, 95)=7
 KSPARSE(2, 95)=3
!HONO/NO2
 KSPARSE(1, 96)=7
 KSPARSE(2, 96)=4
!HONO/HONO
 KSPARSE(1, 97)=7
 KSPARSE(2, 97)=7
!HONO/OH
 KSPARSE(1, 98)=7
 KSPARSE(2, 98)=14
!HONO/ADD
 KSPARSE(1, 99)=7
 KSPARSE(2, 99)=37
!HONO/WC_HONO
 KSPARSE(1, 100)=7
 KSPARSE(2, 100)=48
!HONO/WR_HONO
 KSPARSE(1, 101)=7
 KSPARSE(2, 101)=73
!HNO3/NO2
 KSPARSE(1, 102)=8
 KSPARSE(2, 102)=4
!HNO3/NO3
 KSPARSE(1, 103)=8
 KSPARSE(2, 103)=5
!HNO3/HNO3
 KSPARSE(1, 104)=8
 KSPARSE(2, 104)=8
!HNO3/OH
 KSPARSE(1, 105)=8
 KSPARSE(2, 105)=14
!HNO3/HO2
 KSPARSE(1, 106)=8
 KSPARSE(2, 106)=15
!HNO3/ARO
 KSPARSE(1, 107)=8
 KSPARSE(2, 107)=21
!HNO3/HCHO
 KSPARSE(1, 108)=8
 KSPARSE(2, 108)=22
!HNO3/ALD
 KSPARSE(1, 109)=8
 KSPARSE(2, 109)=23
!HNO3/CARBO
 KSPARSE(1, 110)=8
 KSPARSE(2, 110)=25
!HNO3/WC_HNO3
 KSPARSE(1, 111)=8
 KSPARSE(2, 111)=49
!HNO3/WR_HNO3
 KSPARSE(1, 112)=8
 KSPARSE(2, 112)=74
!HNO4/NO2
 KSPARSE(1, 113)=9
 KSPARSE(2, 113)=4
!HNO4/HNO4
 KSPARSE(1, 114)=9
 KSPARSE(2, 114)=9
!HNO4/OH
 KSPARSE(1, 115)=9
 KSPARSE(2, 115)=14
!HNO4/HO2
 KSPARSE(1, 116)=9
 KSPARSE(2, 116)=15
!HNO4/WC_HNO4
 KSPARSE(1, 117)=9
 KSPARSE(2, 117)=50
!HNO4/WR_HNO4
 KSPARSE(1, 118)=9
 KSPARSE(2, 118)=75
!NH3/NH3
 KSPARSE(1, 119)=10
 KSPARSE(2, 119)=10
!NH3/OH
 KSPARSE(1, 120)=10
 KSPARSE(2, 120)=14
!NH3/WC_NH3
 KSPARSE(1, 121)=10
 KSPARSE(2, 121)=51
!NH3/WR_NH3
 KSPARSE(1, 122)=10
 KSPARSE(2, 122)=76
!SO2/SO2
 KSPARSE(1, 123)=11
 KSPARSE(2, 123)=11
!SO2/OH
 KSPARSE(1, 124)=11
 KSPARSE(2, 124)=14
!SO2/WC_SO2
 KSPARSE(1, 125)=11
 KSPARSE(2, 125)=55
!SO2/WR_SO2
 KSPARSE(1, 126)=11
 KSPARSE(2, 126)=80
!SULF/SO2
 KSPARSE(1, 127)=12
 KSPARSE(2, 127)=11
!SULF/SULF
 KSPARSE(1, 128)=12
 KSPARSE(2, 128)=12
!SULF/OH
 KSPARSE(1, 129)=12
 KSPARSE(2, 129)=14
!SULF/WC_SULF
 KSPARSE(1, 130)=12
 KSPARSE(2, 130)=56
!SULF/WR_SULF
 KSPARSE(1, 131)=12
 KSPARSE(2, 131)=81
!CO/O3
 KSPARSE(1, 132)=13
 KSPARSE(2, 132)=1
!CO/NO3
 KSPARSE(1, 133)=13
 KSPARSE(2, 133)=5
!CO/CO
 KSPARSE(1, 134)=13
 KSPARSE(2, 134)=13
!CO/OH
 KSPARSE(1, 135)=13
 KSPARSE(2, 135)=14
!CO/ALKA
 KSPARSE(1, 136)=13
 KSPARSE(2, 136)=18
!CO/ALKE
 KSPARSE(1, 137)=13
 KSPARSE(2, 137)=19
!CO/BIO
 KSPARSE(1, 138)=13
 KSPARSE(2, 138)=20
!CO/HCHO
 KSPARSE(1, 139)=13
 KSPARSE(2, 139)=22
!CO/ALD
 KSPARSE(1, 140)=13
 KSPARSE(2, 140)=23
!CO/CARBO
 KSPARSE(1, 141)=13
 KSPARSE(2, 141)=25
!CO/PAN
 KSPARSE(1, 142)=13
 KSPARSE(2, 142)=27
!OH/O3
 KSPARSE(1, 143)=14
 KSPARSE(2, 143)=1
!OH/H2O2
 KSPARSE(1, 144)=14
 KSPARSE(2, 144)=2
!OH/NO
 KSPARSE(1, 145)=14
 KSPARSE(2, 145)=3
!OH/NO2
 KSPARSE(1, 146)=14
 KSPARSE(2, 146)=4
!OH/NO3
 KSPARSE(1, 147)=14
 KSPARSE(2, 147)=5
!OH/HONO
 KSPARSE(1, 148)=14
 KSPARSE(2, 148)=7
!OH/HNO3
 KSPARSE(1, 149)=14
 KSPARSE(2, 149)=8
!OH/HNO4
 KSPARSE(1, 150)=14
 KSPARSE(2, 150)=9
!OH/NH3
 KSPARSE(1, 151)=14
 KSPARSE(2, 151)=10
!OH/SO2
 KSPARSE(1, 152)=14
 KSPARSE(2, 152)=11
!OH/CO
 KSPARSE(1, 153)=14
 KSPARSE(2, 153)=13
!OH/OH
 KSPARSE(1, 154)=14
 KSPARSE(2, 154)=14
!OH/HO2
 KSPARSE(1, 155)=14
 KSPARSE(2, 155)=15
!OH/CH4
 KSPARSE(1, 156)=14
 KSPARSE(2, 156)=16
!OH/ETH
 KSPARSE(1, 157)=14
 KSPARSE(2, 157)=17
!OH/ALKA
 KSPARSE(1, 158)=14
 KSPARSE(2, 158)=18
!OH/ALKE
 KSPARSE(1, 159)=14
 KSPARSE(2, 159)=19
!OH/BIO
 KSPARSE(1, 160)=14
 KSPARSE(2, 160)=20
!OH/ARO
 KSPARSE(1, 161)=14
 KSPARSE(2, 161)=21
!OH/HCHO
 KSPARSE(1, 162)=14
 KSPARSE(2, 162)=22
!OH/ALD
 KSPARSE(1, 163)=14
 KSPARSE(2, 163)=23
!OH/KET
 KSPARSE(1, 164)=14
 KSPARSE(2, 164)=24
!OH/CARBO
 KSPARSE(1, 165)=14
 KSPARSE(2, 165)=25
!OH/ONIT
 KSPARSE(1, 166)=14
 KSPARSE(2, 166)=26
!OH/PAN
 KSPARSE(1, 167)=14
 KSPARSE(2, 167)=27
!OH/OP1
 KSPARSE(1, 168)=14
 KSPARSE(2, 168)=28
!OH/OP2
 KSPARSE(1, 169)=14
 KSPARSE(2, 169)=29
!OH/ORA1
 KSPARSE(1, 170)=14
 KSPARSE(2, 170)=30
!OH/ORA2
 KSPARSE(1, 171)=14
 KSPARSE(2, 171)=31
!OH/ADD
 KSPARSE(1, 172)=14
 KSPARSE(2, 172)=37
!OH/WC_OH
 KSPARSE(1, 173)=14
 KSPARSE(2, 173)=52
!OH/WR_OH
 KSPARSE(1, 174)=14
 KSPARSE(2, 174)=77
!HO2/O3
 KSPARSE(1, 175)=15
 KSPARSE(2, 175)=1
!HO2/H2O2
 KSPARSE(1, 176)=15
 KSPARSE(2, 176)=2
!HO2/NO
 KSPARSE(1, 177)=15
 KSPARSE(2, 177)=3
!HO2/NO2
 KSPARSE(1, 178)=15
 KSPARSE(2, 178)=4
!HO2/NO3
 KSPARSE(1, 179)=15
 KSPARSE(2, 179)=5
!HO2/HNO4
 KSPARSE(1, 180)=15
 KSPARSE(2, 180)=9
!HO2/SO2
 KSPARSE(1, 181)=15
 KSPARSE(2, 181)=11
!HO2/CO
 KSPARSE(1, 182)=15
 KSPARSE(2, 182)=13
!HO2/OH
 KSPARSE(1, 183)=15
 KSPARSE(2, 183)=14
!HO2/HO2
 KSPARSE(1, 184)=15
 KSPARSE(2, 184)=15
!HO2/ALKA
 KSPARSE(1, 185)=15
 KSPARSE(2, 185)=18
!HO2/ALKE
 KSPARSE(1, 186)=15
 KSPARSE(2, 186)=19
!HO2/BIO
 KSPARSE(1, 187)=15
 KSPARSE(2, 187)=20
!HO2/ARO
 KSPARSE(1, 188)=15
 KSPARSE(2, 188)=21
!HO2/HCHO
 KSPARSE(1, 189)=15
 KSPARSE(2, 189)=22
!HO2/ALD
 KSPARSE(1, 190)=15
 KSPARSE(2, 190)=23
!HO2/CARBO
 KSPARSE(1, 191)=15
 KSPARSE(2, 191)=25
!HO2/ONIT
 KSPARSE(1, 192)=15
 KSPARSE(2, 192)=26
!HO2/PAN
 KSPARSE(1, 193)=15
 KSPARSE(2, 193)=27
!HO2/OP1
 KSPARSE(1, 194)=15
 KSPARSE(2, 194)=28
!HO2/OP2
 KSPARSE(1, 195)=15
 KSPARSE(2, 195)=29
!HO2/ORA1
 KSPARSE(1, 196)=15
 KSPARSE(2, 196)=30
!HO2/MO2
 KSPARSE(1, 197)=15
 KSPARSE(2, 197)=32
!HO2/ALKAP
 KSPARSE(1, 198)=15
 KSPARSE(2, 198)=33
!HO2/ALKEP
 KSPARSE(1, 199)=15
 KSPARSE(2, 199)=34
!HO2/BIOP
 KSPARSE(1, 200)=15
 KSPARSE(2, 200)=35
!HO2/PHO
 KSPARSE(1, 201)=15
 KSPARSE(2, 201)=36
!HO2/ADD
 KSPARSE(1, 202)=15
 KSPARSE(2, 202)=37
!HO2/AROP
 KSPARSE(1, 203)=15
 KSPARSE(2, 203)=38
!HO2/CARBOP
 KSPARSE(1, 204)=15
 KSPARSE(2, 204)=39
!HO2/OLN
 KSPARSE(1, 205)=15
 KSPARSE(2, 205)=40
!HO2/XO2
 KSPARSE(1, 206)=15
 KSPARSE(2, 206)=41
!HO2/WC_HO2
 KSPARSE(1, 207)=15
 KSPARSE(2, 207)=53
!HO2/WR_HO2
 KSPARSE(1, 208)=15
 KSPARSE(2, 208)=78
!CH4/O3
 KSPARSE(1, 209)=16
 KSPARSE(2, 209)=1
!CH4/OH
 KSPARSE(1, 210)=16
 KSPARSE(2, 210)=14
!CH4/CH4
 KSPARSE(1, 211)=16
 KSPARSE(2, 211)=16
!CH4/ALKE
 KSPARSE(1, 212)=16
 KSPARSE(2, 212)=19
!ETH/O3
 KSPARSE(1, 213)=17
 KSPARSE(2, 213)=1
!ETH/OH
 KSPARSE(1, 214)=17
 KSPARSE(2, 214)=14
!ETH/ETH
 KSPARSE(1, 215)=17
 KSPARSE(2, 215)=17
!ETH/ALKE
 KSPARSE(1, 216)=17
 KSPARSE(2, 216)=19
!ALKA/OH
 KSPARSE(1, 217)=18
 KSPARSE(2, 217)=14
!ALKA/ALKA
 KSPARSE(1, 218)=18
 KSPARSE(2, 218)=18
!ALKE/O3
 KSPARSE(1, 219)=19
 KSPARSE(2, 219)=1
!ALKE/NO
 KSPARSE(1, 220)=19
 KSPARSE(2, 220)=3
!ALKE/NO3
 KSPARSE(1, 221)=19
 KSPARSE(2, 221)=5
!ALKE/OH
 KSPARSE(1, 222)=19
 KSPARSE(2, 222)=14
!ALKE/ALKE
 KSPARSE(1, 223)=19
 KSPARSE(2, 223)=19
!ALKE/BIO
 KSPARSE(1, 224)=19
 KSPARSE(2, 224)=20
!ALKE/MO2
 KSPARSE(1, 225)=19
 KSPARSE(2, 225)=32
!ALKE/BIOP
 KSPARSE(1, 226)=19
 KSPARSE(2, 226)=35
!ALKE/CARBOP
 KSPARSE(1, 227)=19
 KSPARSE(2, 227)=39
!BIO/O3
 KSPARSE(1, 228)=20
 KSPARSE(2, 228)=1
!BIO/NO3
 KSPARSE(1, 229)=20
 KSPARSE(2, 229)=5
!BIO/OH
 KSPARSE(1, 230)=20
 KSPARSE(2, 230)=14
!BIO/BIO
 KSPARSE(1, 231)=20
 KSPARSE(2, 231)=20
!ARO/O3
 KSPARSE(1, 232)=21
 KSPARSE(2, 232)=1
!ARO/NO2
 KSPARSE(1, 233)=21
 KSPARSE(2, 233)=4
!ARO/NO3
 KSPARSE(1, 234)=21
 KSPARSE(2, 234)=5
!ARO/OH
 KSPARSE(1, 235)=21
 KSPARSE(2, 235)=14
!ARO/HO2
 KSPARSE(1, 236)=21
 KSPARSE(2, 236)=15
!ARO/ARO
 KSPARSE(1, 237)=21
 KSPARSE(2, 237)=21
!ARO/PHO
 KSPARSE(1, 238)=21
 KSPARSE(2, 238)=36
!ARO/ADD
 KSPARSE(1, 239)=21
 KSPARSE(2, 239)=37
!HCHO/O3
 KSPARSE(1, 240)=22
 KSPARSE(2, 240)=1
!HCHO/NO
 KSPARSE(1, 241)=22
 KSPARSE(2, 241)=3
!HCHO/NO3
 KSPARSE(1, 242)=22
 KSPARSE(2, 242)=5
!HCHO/OH
 KSPARSE(1, 243)=22
 KSPARSE(2, 243)=14
!HCHO/ALKA
 KSPARSE(1, 244)=22
 KSPARSE(2, 244)=18
!HCHO/ALKE
 KSPARSE(1, 245)=22
 KSPARSE(2, 245)=19
!HCHO/BIO
 KSPARSE(1, 246)=22
 KSPARSE(2, 246)=20
!HCHO/HCHO
 KSPARSE(1, 247)=22
 KSPARSE(2, 247)=22
!HCHO/CARBO
 KSPARSE(1, 248)=22
 KSPARSE(2, 248)=25
!HCHO/PAN
 KSPARSE(1, 249)=22
 KSPARSE(2, 249)=27
!HCHO/OP1
 KSPARSE(1, 250)=22
 KSPARSE(2, 250)=28
!HCHO/OP2
 KSPARSE(1, 251)=22
 KSPARSE(2, 251)=29
!HCHO/MO2
 KSPARSE(1, 252)=22
 KSPARSE(2, 252)=32
!HCHO/ALKAP
 KSPARSE(1, 253)=22
 KSPARSE(2, 253)=33
!HCHO/ALKEP
 KSPARSE(1, 254)=22
 KSPARSE(2, 254)=34
!HCHO/BIOP
 KSPARSE(1, 255)=22
 KSPARSE(2, 255)=35
!HCHO/AROP
 KSPARSE(1, 256)=22
 KSPARSE(2, 256)=38
!HCHO/CARBOP
 KSPARSE(1, 257)=22
 KSPARSE(2, 257)=39
!HCHO/OLN
 KSPARSE(1, 258)=22
 KSPARSE(2, 258)=40
!HCHO/XO2
 KSPARSE(1, 259)=22
 KSPARSE(2, 259)=41
!HCHO/WC_HCHO
 KSPARSE(1, 260)=22
 KSPARSE(2, 260)=57
!HCHO/WR_HCHO
 KSPARSE(1, 261)=22
 KSPARSE(2, 261)=82
!ALD/O3
 KSPARSE(1, 262)=23
 KSPARSE(2, 262)=1
!ALD/NO
 KSPARSE(1, 263)=23
 KSPARSE(2, 263)=3
!ALD/NO3
 KSPARSE(1, 264)=23
 KSPARSE(2, 264)=5
!ALD/OH
 KSPARSE(1, 265)=23
 KSPARSE(2, 265)=14
!ALD/ALKA
 KSPARSE(1, 266)=23
 KSPARSE(2, 266)=18
!ALD/ALKE
 KSPARSE(1, 267)=23
 KSPARSE(2, 267)=19
!ALD/BIO
 KSPARSE(1, 268)=23
 KSPARSE(2, 268)=20
!ALD/ALD
 KSPARSE(1, 269)=23
 KSPARSE(2, 269)=23
!ALD/CARBO
 KSPARSE(1, 270)=23
 KSPARSE(2, 270)=25
!ALD/ONIT
 KSPARSE(1, 271)=23
 KSPARSE(2, 271)=26
!ALD/OP2
 KSPARSE(1, 272)=23
 KSPARSE(2, 272)=29
!ALD/MO2
 KSPARSE(1, 273)=23
 KSPARSE(2, 273)=32
!ALD/ALKAP
 KSPARSE(1, 274)=23
 KSPARSE(2, 274)=33
!ALD/ALKEP
 KSPARSE(1, 275)=23
 KSPARSE(2, 275)=34
!ALD/BIOP
 KSPARSE(1, 276)=23
 KSPARSE(2, 276)=35
!ALD/CARBOP
 KSPARSE(1, 277)=23
 KSPARSE(2, 277)=39
!ALD/OLN
 KSPARSE(1, 278)=23
 KSPARSE(2, 278)=40
!KET/O3
 KSPARSE(1, 279)=24
 KSPARSE(2, 279)=1
!KET/NO
 KSPARSE(1, 280)=24
 KSPARSE(2, 280)=3
!KET/NO3
 KSPARSE(1, 281)=24
 KSPARSE(2, 281)=5
!KET/OH
 KSPARSE(1, 282)=24
 KSPARSE(2, 282)=14
!KET/ALKA
 KSPARSE(1, 283)=24
 KSPARSE(2, 283)=18
!KET/ALKE
 KSPARSE(1, 284)=24
 KSPARSE(2, 284)=19
!KET/BIO
 KSPARSE(1, 285)=24
 KSPARSE(2, 285)=20
!KET/KET
 KSPARSE(1, 286)=24
 KSPARSE(2, 286)=24
!KET/CARBO
 KSPARSE(1, 287)=24
 KSPARSE(2, 287)=25
!KET/ONIT
 KSPARSE(1, 288)=24
 KSPARSE(2, 288)=26
!KET/OP2
 KSPARSE(1, 289)=24
 KSPARSE(2, 289)=29
!KET/MO2
 KSPARSE(1, 290)=24
 KSPARSE(2, 290)=32
!KET/ALKAP
 KSPARSE(1, 291)=24
 KSPARSE(2, 291)=33
!KET/ALKEP
 KSPARSE(1, 292)=24
 KSPARSE(2, 292)=34
!KET/BIOP
 KSPARSE(1, 293)=24
 KSPARSE(2, 293)=35
!KET/CARBOP
 KSPARSE(1, 294)=24
 KSPARSE(2, 294)=39
!KET/OLN
 KSPARSE(1, 295)=24
 KSPARSE(2, 295)=40
!CARBO/O3
 KSPARSE(1, 296)=25
 KSPARSE(2, 296)=1
!CARBO/NO
 KSPARSE(1, 297)=25
 KSPARSE(2, 297)=3
!CARBO/NO3
 KSPARSE(1, 298)=25
 KSPARSE(2, 298)=5
!CARBO/OH
 KSPARSE(1, 299)=25
 KSPARSE(2, 299)=14
!CARBO/ALKA
 KSPARSE(1, 300)=25
 KSPARSE(2, 300)=18
!CARBO/ALKE
 KSPARSE(1, 301)=25
 KSPARSE(2, 301)=19
!CARBO/BIO
 KSPARSE(1, 302)=25
 KSPARSE(2, 302)=20
!CARBO/CARBO
 KSPARSE(1, 303)=25
 KSPARSE(2, 303)=25
!CARBO/PAN
 KSPARSE(1, 304)=25
 KSPARSE(2, 304)=27
!CARBO/MO2
 KSPARSE(1, 305)=25
 KSPARSE(2, 305)=32
!CARBO/ALKAP
 KSPARSE(1, 306)=25
 KSPARSE(2, 306)=33
!CARBO/BIOP
 KSPARSE(1, 307)=25
 KSPARSE(2, 307)=35
!CARBO/AROP
 KSPARSE(1, 308)=25
 KSPARSE(2, 308)=38
!CARBO/CARBOP
 KSPARSE(1, 309)=25
 KSPARSE(2, 309)=39
!ONIT/NO
 KSPARSE(1, 310)=26
 KSPARSE(2, 310)=3
!ONIT/NO2
 KSPARSE(1, 311)=26
 KSPARSE(2, 311)=4
!ONIT/NO3
 KSPARSE(1, 312)=26
 KSPARSE(2, 312)=5
!ONIT/OH
 KSPARSE(1, 313)=26
 KSPARSE(2, 313)=14
!ONIT/HO2
 KSPARSE(1, 314)=26
 KSPARSE(2, 314)=15
!ONIT/ONIT
 KSPARSE(1, 315)=26
 KSPARSE(2, 315)=26
!ONIT/PAN
 KSPARSE(1, 316)=26
 KSPARSE(2, 316)=27
!ONIT/MO2
 KSPARSE(1, 317)=26
 KSPARSE(2, 317)=32
!ONIT/ALKAP
 KSPARSE(1, 318)=26
 KSPARSE(2, 318)=33
!ONIT/BIOP
 KSPARSE(1, 319)=26
 KSPARSE(2, 319)=35
!ONIT/PHO
 KSPARSE(1, 320)=26
 KSPARSE(2, 320)=36
!ONIT/AROP
 KSPARSE(1, 321)=26
 KSPARSE(2, 321)=38
!ONIT/CARBOP
 KSPARSE(1, 322)=26
 KSPARSE(2, 322)=39
!ONIT/OLN
 KSPARSE(1, 323)=26
 KSPARSE(2, 323)=40
!PAN/O3
 KSPARSE(1, 324)=27
 KSPARSE(2, 324)=1
!PAN/NO2
 KSPARSE(1, 325)=27
 KSPARSE(2, 325)=4
!PAN/NO3
 KSPARSE(1, 326)=27
 KSPARSE(2, 326)=5
!PAN/OH
 KSPARSE(1, 327)=27
 KSPARSE(2, 327)=14
!PAN/PAN
 KSPARSE(1, 328)=27
 KSPARSE(2, 328)=27
!PAN/CARBOP
 KSPARSE(1, 329)=27
 KSPARSE(2, 329)=39
!OP1/OH
 KSPARSE(1, 330)=28
 KSPARSE(2, 330)=14
!OP1/HO2
 KSPARSE(1, 331)=28
 KSPARSE(2, 331)=15
!OP1/OP1
 KSPARSE(1, 332)=28
 KSPARSE(2, 332)=28
!OP1/MO2
 KSPARSE(1, 333)=28
 KSPARSE(2, 333)=32
!OP1/WC_OP1
 KSPARSE(1, 334)=28
 KSPARSE(2, 334)=61
!OP1/WR_OP1
 KSPARSE(1, 335)=28
 KSPARSE(2, 335)=86
!OP2/O3
 KSPARSE(1, 336)=29
 KSPARSE(2, 336)=1
!OP2/OH
 KSPARSE(1, 337)=29
 KSPARSE(2, 337)=14
!OP2/HO2
 KSPARSE(1, 338)=29
 KSPARSE(2, 338)=15
!OP2/CARBO
 KSPARSE(1, 339)=29
 KSPARSE(2, 339)=25
!OP2/OP2
 KSPARSE(1, 340)=29
 KSPARSE(2, 340)=29
!OP2/ALKAP
 KSPARSE(1, 341)=29
 KSPARSE(2, 341)=33
!OP2/ALKEP
 KSPARSE(1, 342)=29
 KSPARSE(2, 342)=34
!OP2/BIOP
 KSPARSE(1, 343)=29
 KSPARSE(2, 343)=35
!OP2/AROP
 KSPARSE(1, 344)=29
 KSPARSE(2, 344)=38
!OP2/CARBOP
 KSPARSE(1, 345)=29
 KSPARSE(2, 345)=39
!OP2/XO2
 KSPARSE(1, 346)=29
 KSPARSE(2, 346)=41
!ORA1/O3
 KSPARSE(1, 347)=30
 KSPARSE(2, 347)=1
!ORA1/OH
 KSPARSE(1, 348)=30
 KSPARSE(2, 348)=14
!ORA1/ALKA
 KSPARSE(1, 349)=30
 KSPARSE(2, 349)=18
!ORA1/ALKE
 KSPARSE(1, 350)=30
 KSPARSE(2, 350)=19
!ORA1/BIO
 KSPARSE(1, 351)=30
 KSPARSE(2, 351)=20
!ORA1/CARBO
 KSPARSE(1, 352)=30
 KSPARSE(2, 352)=25
!ORA1/PAN
 KSPARSE(1, 353)=30
 KSPARSE(2, 353)=27
!ORA1/ORA1
 KSPARSE(1, 354)=30
 KSPARSE(2, 354)=30
!ORA1/WC_ORA1
 KSPARSE(1, 355)=30
 KSPARSE(2, 355)=58
!ORA1/WR_ORA1
 KSPARSE(1, 356)=30
 KSPARSE(2, 356)=83
!ORA2/O3
 KSPARSE(1, 357)=31
 KSPARSE(2, 357)=1
!ORA2/OH
 KSPARSE(1, 358)=31
 KSPARSE(2, 358)=14
!ORA2/HO2
 KSPARSE(1, 359)=31
 KSPARSE(2, 359)=15
!ORA2/ALKE
 KSPARSE(1, 360)=31
 KSPARSE(2, 360)=19
!ORA2/BIO
 KSPARSE(1, 361)=31
 KSPARSE(2, 361)=20
!ORA2/CARBO
 KSPARSE(1, 362)=31
 KSPARSE(2, 362)=25
!ORA2/ORA2
 KSPARSE(1, 363)=31
 KSPARSE(2, 363)=31
!ORA2/MO2
 KSPARSE(1, 364)=31
 KSPARSE(2, 364)=32
!ORA2/ALKAP
 KSPARSE(1, 365)=31
 KSPARSE(2, 365)=33
!ORA2/ALKEP
 KSPARSE(1, 366)=31
 KSPARSE(2, 366)=34
!ORA2/BIOP
 KSPARSE(1, 367)=31
 KSPARSE(2, 367)=35
!ORA2/CARBOP
 KSPARSE(1, 368)=31
 KSPARSE(2, 368)=39
!ORA2/OLN
 KSPARSE(1, 369)=31
 KSPARSE(2, 369)=40
!ORA2/WC_ORA2
 KSPARSE(1, 370)=31
 KSPARSE(2, 370)=59
!ORA2/WR_ORA2
 KSPARSE(1, 371)=31
 KSPARSE(2, 371)=84
!MO2/O3
 KSPARSE(1, 372)=32
 KSPARSE(2, 372)=1
!MO2/NO
 KSPARSE(1, 373)=32
 KSPARSE(2, 373)=3
!MO2/NO3
 KSPARSE(1, 374)=32
 KSPARSE(2, 374)=5
!MO2/OH
 KSPARSE(1, 375)=32
 KSPARSE(2, 375)=14
!MO2/HO2
 KSPARSE(1, 376)=32
 KSPARSE(2, 376)=15
!MO2/CH4
 KSPARSE(1, 377)=32
 KSPARSE(2, 377)=16
!MO2/ALKE
 KSPARSE(1, 378)=32
 KSPARSE(2, 378)=19
!MO2/BIO
 KSPARSE(1, 379)=32
 KSPARSE(2, 379)=20
!MO2/ALD
 KSPARSE(1, 380)=32
 KSPARSE(2, 380)=23
!MO2/OP1
 KSPARSE(1, 381)=32
 KSPARSE(2, 381)=28
!MO2/OP2
 KSPARSE(1, 382)=32
 KSPARSE(2, 382)=29
!MO2/MO2
 KSPARSE(1, 383)=32
 KSPARSE(2, 383)=32
!MO2/ALKAP
 KSPARSE(1, 384)=32
 KSPARSE(2, 384)=33
!MO2/ALKEP
 KSPARSE(1, 385)=32
 KSPARSE(2, 385)=34
!MO2/BIOP
 KSPARSE(1, 386)=32
 KSPARSE(2, 386)=35
!MO2/AROP
 KSPARSE(1, 387)=32
 KSPARSE(2, 387)=38
!MO2/CARBOP
 KSPARSE(1, 388)=32
 KSPARSE(2, 388)=39
!MO2/OLN
 KSPARSE(1, 389)=32
 KSPARSE(2, 389)=40
!MO2/XO2
 KSPARSE(1, 390)=32
 KSPARSE(2, 390)=41
!MO2/WC_MO2
 KSPARSE(1, 391)=32
 KSPARSE(2, 391)=60
!MO2/WR_MO2
 KSPARSE(1, 392)=32
 KSPARSE(2, 392)=85
!ALKAP/O3
 KSPARSE(1, 393)=33
 KSPARSE(2, 393)=1
!ALKAP/NO
 KSPARSE(1, 394)=33
 KSPARSE(2, 394)=3
!ALKAP/NO3
 KSPARSE(1, 395)=33
 KSPARSE(2, 395)=5
!ALKAP/OH
 KSPARSE(1, 396)=33
 KSPARSE(2, 396)=14
!ALKAP/HO2
 KSPARSE(1, 397)=33
 KSPARSE(2, 397)=15
!ALKAP/ETH
 KSPARSE(1, 398)=33
 KSPARSE(2, 398)=17
!ALKAP/ALKA
 KSPARSE(1, 399)=33
 KSPARSE(2, 399)=18
!ALKAP/ALKE
 KSPARSE(1, 400)=33
 KSPARSE(2, 400)=19
!ALKAP/BIO
 KSPARSE(1, 401)=33
 KSPARSE(2, 401)=20
!ALKAP/KET
 KSPARSE(1, 402)=33
 KSPARSE(2, 402)=24
!ALKAP/ONIT
 KSPARSE(1, 403)=33
 KSPARSE(2, 403)=26
!ALKAP/OP2
 KSPARSE(1, 404)=33
 KSPARSE(2, 404)=29
!ALKAP/MO2
 KSPARSE(1, 405)=33
 KSPARSE(2, 405)=32
!ALKAP/ALKAP
 KSPARSE(1, 406)=33
 KSPARSE(2, 406)=33
!ALKAP/CARBOP
 KSPARSE(1, 407)=33
 KSPARSE(2, 407)=39
!ALKEP/NO
 KSPARSE(1, 408)=34
 KSPARSE(2, 408)=3
!ALKEP/NO3
 KSPARSE(1, 409)=34
 KSPARSE(2, 409)=5
!ALKEP/OH
 KSPARSE(1, 410)=34
 KSPARSE(2, 410)=14
!ALKEP/HO2
 KSPARSE(1, 411)=34
 KSPARSE(2, 411)=15
!ALKEP/ALKE
 KSPARSE(1, 412)=34
 KSPARSE(2, 412)=19
!ALKEP/MO2
 KSPARSE(1, 413)=34
 KSPARSE(2, 413)=32
!ALKEP/ALKEP
 KSPARSE(1, 414)=34
 KSPARSE(2, 414)=34
!ALKEP/CARBOP
 KSPARSE(1, 415)=34
 KSPARSE(2, 415)=39
!BIOP/NO
 KSPARSE(1, 416)=35
 KSPARSE(2, 416)=3
!BIOP/NO3
 KSPARSE(1, 417)=35
 KSPARSE(2, 417)=5
!BIOP/OH
 KSPARSE(1, 418)=35
 KSPARSE(2, 418)=14
!BIOP/HO2
 KSPARSE(1, 419)=35
 KSPARSE(2, 419)=15
!BIOP/ALKE
 KSPARSE(1, 420)=35
 KSPARSE(2, 420)=19
!BIOP/BIO
 KSPARSE(1, 421)=35
 KSPARSE(2, 421)=20
!BIOP/MO2
 KSPARSE(1, 422)=35
 KSPARSE(2, 422)=32
!BIOP/BIOP
 KSPARSE(1, 423)=35
 KSPARSE(2, 423)=35
!BIOP/CARBOP
 KSPARSE(1, 424)=35
 KSPARSE(2, 424)=39
!PHO/NO2
 KSPARSE(1, 425)=36
 KSPARSE(2, 425)=4
!PHO/NO3
 KSPARSE(1, 426)=36
 KSPARSE(2, 426)=5
!PHO/OH
 KSPARSE(1, 427)=36
 KSPARSE(2, 427)=14
!PHO/HO2
 KSPARSE(1, 428)=36
 KSPARSE(2, 428)=15
!PHO/ARO
 KSPARSE(1, 429)=36
 KSPARSE(2, 429)=21
!PHO/PHO
 KSPARSE(1, 430)=36
 KSPARSE(2, 430)=36
!ADD/O3
 KSPARSE(1, 431)=37
 KSPARSE(2, 431)=1
!ADD/NO2
 KSPARSE(1, 432)=37
 KSPARSE(2, 432)=4
!ADD/OH
 KSPARSE(1, 433)=37
 KSPARSE(2, 433)=14
!ADD/ARO
 KSPARSE(1, 434)=37
 KSPARSE(2, 434)=21
!ADD/ADD
 KSPARSE(1, 435)=37
 KSPARSE(2, 435)=37
!AROP/NO
 KSPARSE(1, 436)=38
 KSPARSE(2, 436)=3
!AROP/NO3
 KSPARSE(1, 437)=38
 KSPARSE(2, 437)=5
!AROP/HO2
 KSPARSE(1, 438)=38
 KSPARSE(2, 438)=15
!AROP/MO2
 KSPARSE(1, 439)=38
 KSPARSE(2, 439)=32
!AROP/ADD
 KSPARSE(1, 440)=38
 KSPARSE(2, 440)=37
!AROP/AROP
 KSPARSE(1, 441)=38
 KSPARSE(2, 441)=38
!AROP/CARBOP
 KSPARSE(1, 442)=38
 KSPARSE(2, 442)=39
!CARBOP/O3
 KSPARSE(1, 443)=39
 KSPARSE(2, 443)=1
!CARBOP/NO
 KSPARSE(1, 444)=39
 KSPARSE(2, 444)=3
!CARBOP/NO2
 KSPARSE(1, 445)=39
 KSPARSE(2, 445)=4
!CARBOP/NO3
 KSPARSE(1, 446)=39
 KSPARSE(2, 446)=5
!CARBOP/OH
 KSPARSE(1, 447)=39
 KSPARSE(2, 447)=14
!CARBOP/HO2
 KSPARSE(1, 448)=39
 KSPARSE(2, 448)=15
!CARBOP/ALKE
 KSPARSE(1, 449)=39
 KSPARSE(2, 449)=19
!CARBOP/BIO
 KSPARSE(1, 450)=39
 KSPARSE(2, 450)=20
!CARBOP/ALD
 KSPARSE(1, 451)=39
 KSPARSE(2, 451)=23
!CARBOP/KET
 KSPARSE(1, 452)=39
 KSPARSE(2, 452)=24
!CARBOP/CARBO
 KSPARSE(1, 453)=39
 KSPARSE(2, 453)=25
!CARBOP/PAN
 KSPARSE(1, 454)=39
 KSPARSE(2, 454)=27
!CARBOP/OP2
 KSPARSE(1, 455)=39
 KSPARSE(2, 455)=29
!CARBOP/MO2
 KSPARSE(1, 456)=39
 KSPARSE(2, 456)=32
!CARBOP/ALKAP
 KSPARSE(1, 457)=39
 KSPARSE(2, 457)=33
!CARBOP/ALKEP
 KSPARSE(1, 458)=39
 KSPARSE(2, 458)=34
!CARBOP/BIOP
 KSPARSE(1, 459)=39
 KSPARSE(2, 459)=35
!CARBOP/AROP
 KSPARSE(1, 460)=39
 KSPARSE(2, 460)=38
!CARBOP/CARBOP
 KSPARSE(1, 461)=39
 KSPARSE(2, 461)=39
!CARBOP/OLN
 KSPARSE(1, 462)=39
 KSPARSE(2, 462)=40
!CARBOP/XO2
 KSPARSE(1, 463)=39
 KSPARSE(2, 463)=41
!OLN/NO
 KSPARSE(1, 464)=40
 KSPARSE(2, 464)=3
!OLN/NO3
 KSPARSE(1, 465)=40
 KSPARSE(2, 465)=5
!OLN/HO2
 KSPARSE(1, 466)=40
 KSPARSE(2, 466)=15
!OLN/ALKE
 KSPARSE(1, 467)=40
 KSPARSE(2, 467)=19
!OLN/BIO
 KSPARSE(1, 468)=40
 KSPARSE(2, 468)=20
!OLN/CARBO
 KSPARSE(1, 469)=40
 KSPARSE(2, 469)=25
!OLN/MO2
 KSPARSE(1, 470)=40
 KSPARSE(2, 470)=32
!OLN/CARBOP
 KSPARSE(1, 471)=40
 KSPARSE(2, 471)=39
!OLN/OLN
 KSPARSE(1, 472)=40
 KSPARSE(2, 472)=40
!XO2/O3
 KSPARSE(1, 473)=41
 KSPARSE(2, 473)=1
!XO2/NO
 KSPARSE(1, 474)=41
 KSPARSE(2, 474)=3
!XO2/NO3
 KSPARSE(1, 475)=41
 KSPARSE(2, 475)=5
!XO2/OH
 KSPARSE(1, 476)=41
 KSPARSE(2, 476)=14
!XO2/HO2
 KSPARSE(1, 477)=41
 KSPARSE(2, 477)=15
!XO2/ALKE
 KSPARSE(1, 478)=41
 KSPARSE(2, 478)=19
!XO2/BIO
 KSPARSE(1, 479)=41
 KSPARSE(2, 479)=20
!XO2/ARO
 KSPARSE(1, 480)=41
 KSPARSE(2, 480)=21
!XO2/CARBO
 KSPARSE(1, 481)=41
 KSPARSE(2, 481)=25
!XO2/PAN
 KSPARSE(1, 482)=41
 KSPARSE(2, 482)=27
!XO2/OP2
 KSPARSE(1, 483)=41
 KSPARSE(2, 483)=29
!XO2/MO2
 KSPARSE(1, 484)=41
 KSPARSE(2, 484)=32
!XO2/ALKAP
 KSPARSE(1, 485)=41
 KSPARSE(2, 485)=33
!XO2/CARBOP
 KSPARSE(1, 486)=41
 KSPARSE(2, 486)=39
!XO2/XO2
 KSPARSE(1, 487)=41
 KSPARSE(2, 487)=41
!WC_O3/O3
 KSPARSE(1, 488)=42
 KSPARSE(2, 488)=1
!WC_O3/WC_O3
 KSPARSE(1, 489)=42
 KSPARSE(2, 489)=42
!WC_O3/WC_HO2
 KSPARSE(1, 490)=42
 KSPARSE(2, 490)=53
!WC_O3/WC_SO2
 KSPARSE(1, 491)=42
 KSPARSE(2, 491)=55
!WC_H2O2/H2O2
 KSPARSE(1, 492)=43
 KSPARSE(2, 492)=2
!WC_H2O2/WC_H2O2
 KSPARSE(1, 493)=43
 KSPARSE(2, 493)=43
!WC_H2O2/WC_OH
 KSPARSE(1, 494)=43
 KSPARSE(2, 494)=52
!WC_H2O2/WC_HO2
 KSPARSE(1, 495)=43
 KSPARSE(2, 495)=53
!WC_H2O2/WC_SO2
 KSPARSE(1, 496)=43
 KSPARSE(2, 496)=55
!WC_NO/NO
 KSPARSE(1, 497)=44
 KSPARSE(2, 497)=3
!WC_NO/WC_NO
 KSPARSE(1, 498)=44
 KSPARSE(2, 498)=44
!WC_NO2/NO2
 KSPARSE(1, 499)=45
 KSPARSE(2, 499)=4
!WC_NO2/WC_NO2
 KSPARSE(1, 500)=45
 KSPARSE(2, 500)=45
!WC_NO2/WC_HONO
 KSPARSE(1, 501)=45
 KSPARSE(2, 501)=48
!WC_NO2/WC_HNO3
 KSPARSE(1, 502)=45
 KSPARSE(2, 502)=49
!WC_NO2/WC_HNO4
 KSPARSE(1, 503)=45
 KSPARSE(2, 503)=50
!WC_NO2/WC_OH
 KSPARSE(1, 504)=45
 KSPARSE(2, 504)=52
!WC_NO2/WC_HO2
 KSPARSE(1, 505)=45
 KSPARSE(2, 505)=53
!WC_NO3/NO3
 KSPARSE(1, 506)=46
 KSPARSE(2, 506)=5
!WC_NO3/WC_NO3
 KSPARSE(1, 507)=46
 KSPARSE(2, 507)=46
!WC_NO3/WC_SO2
 KSPARSE(1, 508)=46
 KSPARSE(2, 508)=55
!WC_NO3/WC_SULF
 KSPARSE(1, 509)=46
 KSPARSE(2, 509)=56
!WC_N2O5/N2O5
 KSPARSE(1, 510)=47
 KSPARSE(2, 510)=6
!WC_N2O5/WC_N2O5
 KSPARSE(1, 511)=47
 KSPARSE(2, 511)=47
!WC_HONO/HONO
 KSPARSE(1, 512)=48
 KSPARSE(2, 512)=7
!WC_HONO/WC_HONO
 KSPARSE(1, 513)=48
 KSPARSE(2, 513)=48
!WC_HONO/WC_HNO4
 KSPARSE(1, 514)=48
 KSPARSE(2, 514)=50
!WC_HONO/WC_OH
 KSPARSE(1, 515)=48
 KSPARSE(2, 515)=52
!WC_HNO3/HNO3
 KSPARSE(1, 516)=49
 KSPARSE(2, 516)=8
!WC_HNO3/WC_NO3
 KSPARSE(1, 517)=49
 KSPARSE(2, 517)=46
!WC_HNO3/WC_N2O5
 KSPARSE(1, 518)=49
 KSPARSE(2, 518)=47
!WC_HNO3/WC_HNO3
 KSPARSE(1, 519)=49
 KSPARSE(2, 519)=49
!WC_HNO3/WC_HNO4
 KSPARSE(1, 520)=49
 KSPARSE(2, 520)=50
!WC_HNO3/WC_SO2
 KSPARSE(1, 521)=49
 KSPARSE(2, 521)=55
!WC_HNO3/WC_SULF
 KSPARSE(1, 522)=49
 KSPARSE(2, 522)=56
!WC_HNO4/HNO4
 KSPARSE(1, 523)=50
 KSPARSE(2, 523)=9
!WC_HNO4/WC_NO2
 KSPARSE(1, 524)=50
 KSPARSE(2, 524)=45
!WC_HNO4/WC_HNO4
 KSPARSE(1, 525)=50
 KSPARSE(2, 525)=50
!WC_HNO4/WC_HO2
 KSPARSE(1, 526)=50
 KSPARSE(2, 526)=53
!WC_HNO4/WC_SO2
 KSPARSE(1, 527)=50
 KSPARSE(2, 527)=55
!WC_NH3/NH3
 KSPARSE(1, 528)=51
 KSPARSE(2, 528)=10
!WC_NH3/WC_NH3
 KSPARSE(1, 529)=51
 KSPARSE(2, 529)=51
!WC_OH/OH
 KSPARSE(1, 530)=52
 KSPARSE(2, 530)=14
!WC_OH/WC_O3
 KSPARSE(1, 531)=52
 KSPARSE(2, 531)=42
!WC_OH/WC_H2O2
 KSPARSE(1, 532)=52
 KSPARSE(2, 532)=43
!WC_OH/WC_HONO
 KSPARSE(1, 533)=52
 KSPARSE(2, 533)=48
!WC_OH/WC_HNO3
 KSPARSE(1, 534)=52
 KSPARSE(2, 534)=49
!WC_OH/WC_OH
 KSPARSE(1, 535)=52
 KSPARSE(2, 535)=52
!WC_OH/WC_HO2
 KSPARSE(1, 536)=52
 KSPARSE(2, 536)=53
!WC_OH/WC_SO2
 KSPARSE(1, 537)=52
 KSPARSE(2, 537)=55
!WC_OH/WC_HCHO
 KSPARSE(1, 538)=52
 KSPARSE(2, 538)=57
!WC_OH/WC_ORA1
 KSPARSE(1, 539)=52
 KSPARSE(2, 539)=58
!WC_OH/WC_ASO4
 KSPARSE(1, 540)=52
 KSPARSE(2, 540)=63
!WC_OH/WC_AHMS
 KSPARSE(1, 541)=52
 KSPARSE(2, 541)=66
!WC_HO2/HO2
 KSPARSE(1, 542)=53
 KSPARSE(2, 542)=15
!WC_HO2/WC_O3
 KSPARSE(1, 543)=53
 KSPARSE(2, 543)=42
!WC_HO2/WC_H2O2
 KSPARSE(1, 544)=53
 KSPARSE(2, 544)=43
!WC_HO2/WC_NO2
 KSPARSE(1, 545)=53
 KSPARSE(2, 545)=45
!WC_HO2/WC_HNO4
 KSPARSE(1, 546)=53
 KSPARSE(2, 546)=50
!WC_HO2/WC_OH
 KSPARSE(1, 547)=53
 KSPARSE(2, 547)=52
!WC_HO2/WC_HO2
 KSPARSE(1, 548)=53
 KSPARSE(2, 548)=53
!WC_HO2/WC_HCHO
 KSPARSE(1, 549)=53
 KSPARSE(2, 549)=57
!WC_HO2/WC_ORA1
 KSPARSE(1, 550)=53
 KSPARSE(2, 550)=58
!WC_HO2/WC_MO2
 KSPARSE(1, 551)=53
 KSPARSE(2, 551)=60
!WC_HO2/WC_ASO5
 KSPARSE(1, 552)=53
 KSPARSE(2, 552)=64
!WC_HO2/WC_AHMS
 KSPARSE(1, 553)=53
 KSPARSE(2, 553)=66
!WC_CO2/WC_OH
 KSPARSE(1, 554)=54
 KSPARSE(2, 554)=52
!WC_CO2/WC_CO2
 KSPARSE(1, 555)=54
 KSPARSE(2, 555)=54
!WC_CO2/WC_ORA1
 KSPARSE(1, 556)=54
 KSPARSE(2, 556)=58
!WC_SO2/SO2
 KSPARSE(1, 557)=55
 KSPARSE(2, 557)=11
!WC_SO2/WC_O3
 KSPARSE(1, 558)=55
 KSPARSE(2, 558)=42
!WC_SO2/WC_H2O2
 KSPARSE(1, 559)=55
 KSPARSE(2, 559)=43
!WC_SO2/WC_NO3
 KSPARSE(1, 560)=55
 KSPARSE(2, 560)=46
!WC_SO2/WC_HNO4
 KSPARSE(1, 561)=55
 KSPARSE(2, 561)=50
!WC_SO2/WC_OH
 KSPARSE(1, 562)=55
 KSPARSE(2, 562)=52
!WC_SO2/WC_SO2
 KSPARSE(1, 563)=55
 KSPARSE(2, 563)=55
!WC_SO2/WC_HCHO
 KSPARSE(1, 564)=55
 KSPARSE(2, 564)=57
!WC_SO2/WC_MO2
 KSPARSE(1, 565)=55
 KSPARSE(2, 565)=60
!WC_SO2/WC_AHSO5
 KSPARSE(1, 566)=55
 KSPARSE(2, 566)=65
!WC_SO2/WC_AHMS
 KSPARSE(1, 567)=55
 KSPARSE(2, 567)=66
!WC_SULF/SULF
 KSPARSE(1, 568)=56
 KSPARSE(2, 568)=12
!WC_SULF/WC_O3
 KSPARSE(1, 569)=56
 KSPARSE(2, 569)=42
!WC_SULF/WC_H2O2
 KSPARSE(1, 570)=56
 KSPARSE(2, 570)=43
!WC_SULF/WC_NO3
 KSPARSE(1, 571)=56
 KSPARSE(2, 571)=46
!WC_SULF/WC_HNO4
 KSPARSE(1, 572)=56
 KSPARSE(2, 572)=50
!WC_SULF/WC_SO2
 KSPARSE(1, 573)=56
 KSPARSE(2, 573)=55
!WC_SULF/WC_SULF
 KSPARSE(1, 574)=56
 KSPARSE(2, 574)=56
!WC_SULF/WC_ASO4
 KSPARSE(1, 575)=56
 KSPARSE(2, 575)=63
!WC_SULF/WC_AHSO5
 KSPARSE(1, 576)=56
 KSPARSE(2, 576)=65
!WC_HCHO/HCHO
 KSPARSE(1, 577)=57
 KSPARSE(2, 577)=22
!WC_HCHO/WC_OH
 KSPARSE(1, 578)=57
 KSPARSE(2, 578)=52
!WC_HCHO/WC_SO2
 KSPARSE(1, 579)=57
 KSPARSE(2, 579)=55
!WC_HCHO/WC_HCHO
 KSPARSE(1, 580)=57
 KSPARSE(2, 580)=57
!WC_HCHO/WC_MO2
 KSPARSE(1, 581)=57
 KSPARSE(2, 581)=60
!WC_HCHO/WC_AHMS
 KSPARSE(1, 582)=57
 KSPARSE(2, 582)=66
!WC_ORA1/ORA1
 KSPARSE(1, 583)=58
 KSPARSE(2, 583)=30
!WC_ORA1/WC_OH
 KSPARSE(1, 584)=58
 KSPARSE(2, 584)=52
!WC_ORA1/WC_HCHO
 KSPARSE(1, 585)=58
 KSPARSE(2, 585)=57
!WC_ORA1/WC_ORA1
 KSPARSE(1, 586)=58
 KSPARSE(2, 586)=58
!WC_ORA1/WC_AHMS
 KSPARSE(1, 587)=58
 KSPARSE(2, 587)=66
!WC_ORA2/ORA2
 KSPARSE(1, 588)=59
 KSPARSE(2, 588)=31
!WC_ORA2/WC_ORA2
 KSPARSE(1, 589)=59
 KSPARSE(2, 589)=59
!WC_MO2/MO2
 KSPARSE(1, 590)=60
 KSPARSE(2, 590)=32
!WC_MO2/WC_SO2
 KSPARSE(1, 591)=60
 KSPARSE(2, 591)=55
!WC_MO2/WC_MO2
 KSPARSE(1, 592)=60
 KSPARSE(2, 592)=60
!WC_OP1/OP1
 KSPARSE(1, 593)=61
 KSPARSE(2, 593)=28
!WC_OP1/WC_SO2
 KSPARSE(1, 594)=61
 KSPARSE(2, 594)=55
!WC_OP1/WC_MO2
 KSPARSE(1, 595)=61
 KSPARSE(2, 595)=60
!WC_OP1/WC_OP1
 KSPARSE(1, 596)=61
 KSPARSE(2, 596)=61
!WC_ASO3/WC_NO3
 KSPARSE(1, 597)=62
 KSPARSE(2, 597)=46
!WC_ASO3/WC_OH
 KSPARSE(1, 598)=62
 KSPARSE(2, 598)=52
!WC_ASO3/WC_SO2
 KSPARSE(1, 599)=62
 KSPARSE(2, 599)=55
!WC_ASO3/WC_MO2
 KSPARSE(1, 600)=62
 KSPARSE(2, 600)=60
!WC_ASO3/WC_ASO3
 KSPARSE(1, 601)=62
 KSPARSE(2, 601)=62
!WC_ASO4/WC_NO3
 KSPARSE(1, 602)=63
 KSPARSE(2, 602)=46
!WC_ASO4/WC_SULF
 KSPARSE(1, 603)=63
 KSPARSE(2, 603)=56
!WC_ASO4/WC_ASO4
 KSPARSE(1, 604)=63
 KSPARSE(2, 604)=63
!WC_ASO4/WC_ASO5
 KSPARSE(1, 605)=63
 KSPARSE(2, 605)=64
!WC_ASO5/WC_HO2
 KSPARSE(1, 606)=64
 KSPARSE(2, 606)=53
!WC_ASO5/WC_ASO3
 KSPARSE(1, 607)=64
 KSPARSE(2, 607)=62
!WC_ASO5/WC_ASO5
 KSPARSE(1, 608)=64
 KSPARSE(2, 608)=64
!WC_AHSO5/WC_HO2
 KSPARSE(1, 609)=65
 KSPARSE(2, 609)=53
!WC_AHSO5/WC_SO2
 KSPARSE(1, 610)=65
 KSPARSE(2, 610)=55
!WC_AHSO5/WC_ASO5
 KSPARSE(1, 611)=65
 KSPARSE(2, 611)=64
!WC_AHSO5/WC_AHSO5
 KSPARSE(1, 612)=65
 KSPARSE(2, 612)=65
!WC_AHMS/WC_OH
 KSPARSE(1, 613)=66
 KSPARSE(2, 613)=52
!WC_AHMS/WC_SO2
 KSPARSE(1, 614)=66
 KSPARSE(2, 614)=55
!WC_AHMS/WC_HCHO
 KSPARSE(1, 615)=66
 KSPARSE(2, 615)=57
!WC_AHMS/WC_AHMS
 KSPARSE(1, 616)=66
 KSPARSE(2, 616)=66
!WR_O3/O3
 KSPARSE(1, 617)=67
 KSPARSE(2, 617)=1
!WR_O3/WR_O3
 KSPARSE(1, 618)=67
 KSPARSE(2, 618)=67
!WR_O3/WR_HO2
 KSPARSE(1, 619)=67
 KSPARSE(2, 619)=78
!WR_O3/WR_SO2
 KSPARSE(1, 620)=67
 KSPARSE(2, 620)=80
!WR_H2O2/H2O2
 KSPARSE(1, 621)=68
 KSPARSE(2, 621)=2
!WR_H2O2/WR_H2O2
 KSPARSE(1, 622)=68
 KSPARSE(2, 622)=68
!WR_H2O2/WR_OH
 KSPARSE(1, 623)=68
 KSPARSE(2, 623)=77
!WR_H2O2/WR_HO2
 KSPARSE(1, 624)=68
 KSPARSE(2, 624)=78
!WR_H2O2/WR_SO2
 KSPARSE(1, 625)=68
 KSPARSE(2, 625)=80
!WR_NO/NO
 KSPARSE(1, 626)=69
 KSPARSE(2, 626)=3
!WR_NO/WR_NO
 KSPARSE(1, 627)=69
 KSPARSE(2, 627)=69
!WR_NO2/NO2
 KSPARSE(1, 628)=70
 KSPARSE(2, 628)=4
!WR_NO2/WR_NO2
 KSPARSE(1, 629)=70
 KSPARSE(2, 629)=70
!WR_NO2/WR_HONO
 KSPARSE(1, 630)=70
 KSPARSE(2, 630)=73
!WR_NO2/WR_HNO3
 KSPARSE(1, 631)=70
 KSPARSE(2, 631)=74
!WR_NO2/WR_HNO4
 KSPARSE(1, 632)=70
 KSPARSE(2, 632)=75
!WR_NO2/WR_OH
 KSPARSE(1, 633)=70
 KSPARSE(2, 633)=77
!WR_NO2/WR_HO2
 KSPARSE(1, 634)=70
 KSPARSE(2, 634)=78
!WR_NO3/NO3
 KSPARSE(1, 635)=71
 KSPARSE(2, 635)=5
!WR_NO3/WR_NO3
 KSPARSE(1, 636)=71
 KSPARSE(2, 636)=71
!WR_NO3/WR_SO2
 KSPARSE(1, 637)=71
 KSPARSE(2, 637)=80
!WR_NO3/WR_SULF
 KSPARSE(1, 638)=71
 KSPARSE(2, 638)=81
!WR_N2O5/N2O5
 KSPARSE(1, 639)=72
 KSPARSE(2, 639)=6
!WR_N2O5/WR_N2O5
 KSPARSE(1, 640)=72
 KSPARSE(2, 640)=72
!WR_HONO/HONO
 KSPARSE(1, 641)=73
 KSPARSE(2, 641)=7
!WR_HONO/WR_HONO
 KSPARSE(1, 642)=73
 KSPARSE(2, 642)=73
!WR_HONO/WR_HNO4
 KSPARSE(1, 643)=73
 KSPARSE(2, 643)=75
!WR_HONO/WR_OH
 KSPARSE(1, 644)=73
 KSPARSE(2, 644)=77
!WR_HNO3/HNO3
 KSPARSE(1, 645)=74
 KSPARSE(2, 645)=8
!WR_HNO3/WR_NO3
 KSPARSE(1, 646)=74
 KSPARSE(2, 646)=71
!WR_HNO3/WR_N2O5
 KSPARSE(1, 647)=74
 KSPARSE(2, 647)=72
!WR_HNO3/WR_HNO3
 KSPARSE(1, 648)=74
 KSPARSE(2, 648)=74
!WR_HNO3/WR_HNO4
 KSPARSE(1, 649)=74
 KSPARSE(2, 649)=75
!WR_HNO3/WR_SO2
 KSPARSE(1, 650)=74
 KSPARSE(2, 650)=80
!WR_HNO3/WR_SULF
 KSPARSE(1, 651)=74
 KSPARSE(2, 651)=81
!WR_HNO4/HNO4
 KSPARSE(1, 652)=75
 KSPARSE(2, 652)=9
!WR_HNO4/WR_NO2
 KSPARSE(1, 653)=75
 KSPARSE(2, 653)=70
!WR_HNO4/WR_HNO4
 KSPARSE(1, 654)=75
 KSPARSE(2, 654)=75
!WR_HNO4/WR_HO2
 KSPARSE(1, 655)=75
 KSPARSE(2, 655)=78
!WR_HNO4/WR_SO2
 KSPARSE(1, 656)=75
 KSPARSE(2, 656)=80
!WR_NH3/NH3
 KSPARSE(1, 657)=76
 KSPARSE(2, 657)=10
!WR_NH3/WR_NH3
 KSPARSE(1, 658)=76
 KSPARSE(2, 658)=76
!WR_OH/OH
 KSPARSE(1, 659)=77
 KSPARSE(2, 659)=14
!WR_OH/WR_O3
 KSPARSE(1, 660)=77
 KSPARSE(2, 660)=67
!WR_OH/WR_H2O2
 KSPARSE(1, 661)=77
 KSPARSE(2, 661)=68
!WR_OH/WR_HONO
 KSPARSE(1, 662)=77
 KSPARSE(2, 662)=73
!WR_OH/WR_HNO3
 KSPARSE(1, 663)=77
 KSPARSE(2, 663)=74
!WR_OH/WR_OH
 KSPARSE(1, 664)=77
 KSPARSE(2, 664)=77
!WR_OH/WR_HO2
 KSPARSE(1, 665)=77
 KSPARSE(2, 665)=78
!WR_OH/WR_SO2
 KSPARSE(1, 666)=77
 KSPARSE(2, 666)=80
!WR_OH/WR_HCHO
 KSPARSE(1, 667)=77
 KSPARSE(2, 667)=82
!WR_OH/WR_ORA1
 KSPARSE(1, 668)=77
 KSPARSE(2, 668)=83
!WR_OH/WR_ASO4
 KSPARSE(1, 669)=77
 KSPARSE(2, 669)=88
!WR_OH/WR_AHMS
 KSPARSE(1, 670)=77
 KSPARSE(2, 670)=91
!WR_HO2/HO2
 KSPARSE(1, 671)=78
 KSPARSE(2, 671)=15
!WR_HO2/WR_O3
 KSPARSE(1, 672)=78
 KSPARSE(2, 672)=67
!WR_HO2/WR_H2O2
 KSPARSE(1, 673)=78
 KSPARSE(2, 673)=68
!WR_HO2/WR_NO2
 KSPARSE(1, 674)=78
 KSPARSE(2, 674)=70
!WR_HO2/WR_HNO4
 KSPARSE(1, 675)=78
 KSPARSE(2, 675)=75
!WR_HO2/WR_OH
 KSPARSE(1, 676)=78
 KSPARSE(2, 676)=77
!WR_HO2/WR_HO2
 KSPARSE(1, 677)=78
 KSPARSE(2, 677)=78
!WR_HO2/WR_HCHO
 KSPARSE(1, 678)=78
 KSPARSE(2, 678)=82
!WR_HO2/WR_ORA1
 KSPARSE(1, 679)=78
 KSPARSE(2, 679)=83
!WR_HO2/WR_MO2
 KSPARSE(1, 680)=78
 KSPARSE(2, 680)=85
!WR_HO2/WR_ASO5
 KSPARSE(1, 681)=78
 KSPARSE(2, 681)=89
!WR_HO2/WR_AHMS
 KSPARSE(1, 682)=78
 KSPARSE(2, 682)=91
!WR_CO2/WR_OH
 KSPARSE(1, 683)=79
 KSPARSE(2, 683)=77
!WR_CO2/WR_CO2
 KSPARSE(1, 684)=79
 KSPARSE(2, 684)=79
!WR_CO2/WR_ORA1
 KSPARSE(1, 685)=79
 KSPARSE(2, 685)=83
!WR_SO2/SO2
 KSPARSE(1, 686)=80
 KSPARSE(2, 686)=11
!WR_SO2/WR_O3
 KSPARSE(1, 687)=80
 KSPARSE(2, 687)=67
!WR_SO2/WR_H2O2
 KSPARSE(1, 688)=80
 KSPARSE(2, 688)=68
!WR_SO2/WR_NO3
 KSPARSE(1, 689)=80
 KSPARSE(2, 689)=71
!WR_SO2/WR_HNO4
 KSPARSE(1, 690)=80
 KSPARSE(2, 690)=75
!WR_SO2/WR_OH
 KSPARSE(1, 691)=80
 KSPARSE(2, 691)=77
!WR_SO2/WR_SO2
 KSPARSE(1, 692)=80
 KSPARSE(2, 692)=80
!WR_SO2/WR_HCHO
 KSPARSE(1, 693)=80
 KSPARSE(2, 693)=82
!WR_SO2/WR_MO2
 KSPARSE(1, 694)=80
 KSPARSE(2, 694)=85
!WR_SO2/WR_AHSO5
 KSPARSE(1, 695)=80
 KSPARSE(2, 695)=90
!WR_SO2/WR_AHMS
 KSPARSE(1, 696)=80
 KSPARSE(2, 696)=91
!WR_SULF/SULF
 KSPARSE(1, 697)=81
 KSPARSE(2, 697)=12
!WR_SULF/WR_O3
 KSPARSE(1, 698)=81
 KSPARSE(2, 698)=67
!WR_SULF/WR_H2O2
 KSPARSE(1, 699)=81
 KSPARSE(2, 699)=68
!WR_SULF/WR_NO3
 KSPARSE(1, 700)=81
 KSPARSE(2, 700)=71
!WR_SULF/WR_HNO4
 KSPARSE(1, 701)=81
 KSPARSE(2, 701)=75
!WR_SULF/WR_SO2
 KSPARSE(1, 702)=81
 KSPARSE(2, 702)=80
!WR_SULF/WR_SULF
 KSPARSE(1, 703)=81
 KSPARSE(2, 703)=81
!WR_SULF/WR_ASO4
 KSPARSE(1, 704)=81
 KSPARSE(2, 704)=88
!WR_SULF/WR_AHSO5
 KSPARSE(1, 705)=81
 KSPARSE(2, 705)=90
!WR_HCHO/HCHO
 KSPARSE(1, 706)=82
 KSPARSE(2, 706)=22
!WR_HCHO/WR_OH
 KSPARSE(1, 707)=82
 KSPARSE(2, 707)=77
!WR_HCHO/WR_SO2
 KSPARSE(1, 708)=82
 KSPARSE(2, 708)=80
!WR_HCHO/WR_HCHO
 KSPARSE(1, 709)=82
 KSPARSE(2, 709)=82
!WR_HCHO/WR_MO2
 KSPARSE(1, 710)=82
 KSPARSE(2, 710)=85
!WR_HCHO/WR_AHMS
 KSPARSE(1, 711)=82
 KSPARSE(2, 711)=91
!WR_ORA1/ORA1
 KSPARSE(1, 712)=83
 KSPARSE(2, 712)=30
!WR_ORA1/WR_OH
 KSPARSE(1, 713)=83
 KSPARSE(2, 713)=77
!WR_ORA1/WR_HCHO
 KSPARSE(1, 714)=83
 KSPARSE(2, 714)=82
!WR_ORA1/WR_ORA1
 KSPARSE(1, 715)=83
 KSPARSE(2, 715)=83
!WR_ORA1/WR_AHMS
 KSPARSE(1, 716)=83
 KSPARSE(2, 716)=91
!WR_ORA2/ORA2
 KSPARSE(1, 717)=84
 KSPARSE(2, 717)=31
!WR_ORA2/WR_ORA2
 KSPARSE(1, 718)=84
 KSPARSE(2, 718)=84
!WR_MO2/MO2
 KSPARSE(1, 719)=85
 KSPARSE(2, 719)=32
!WR_MO2/WR_SO2
 KSPARSE(1, 720)=85
 KSPARSE(2, 720)=80
!WR_MO2/WR_MO2
 KSPARSE(1, 721)=85
 KSPARSE(2, 721)=85
!WR_OP1/OP1
 KSPARSE(1, 722)=86
 KSPARSE(2, 722)=28
!WR_OP1/WR_SO2
 KSPARSE(1, 723)=86
 KSPARSE(2, 723)=80
!WR_OP1/WR_MO2
 KSPARSE(1, 724)=86
 KSPARSE(2, 724)=85
!WR_OP1/WR_OP1
 KSPARSE(1, 725)=86
 KSPARSE(2, 725)=86
!WR_ASO3/WR_NO3
 KSPARSE(1, 726)=87
 KSPARSE(2, 726)=71
!WR_ASO3/WR_OH
 KSPARSE(1, 727)=87
 KSPARSE(2, 727)=77
!WR_ASO3/WR_SO2
 KSPARSE(1, 728)=87
 KSPARSE(2, 728)=80
!WR_ASO3/WR_MO2
 KSPARSE(1, 729)=87
 KSPARSE(2, 729)=85
!WR_ASO3/WR_ASO3
 KSPARSE(1, 730)=87
 KSPARSE(2, 730)=87
!WR_ASO4/WR_NO3
 KSPARSE(1, 731)=88
 KSPARSE(2, 731)=71
!WR_ASO4/WR_SULF
 KSPARSE(1, 732)=88
 KSPARSE(2, 732)=81
!WR_ASO4/WR_ASO4
 KSPARSE(1, 733)=88
 KSPARSE(2, 733)=88
!WR_ASO4/WR_ASO5
 KSPARSE(1, 734)=88
 KSPARSE(2, 734)=89
!WR_ASO5/WR_HO2
 KSPARSE(1, 735)=89
 KSPARSE(2, 735)=78
!WR_ASO5/WR_ASO3
 KSPARSE(1, 736)=89
 KSPARSE(2, 736)=87
!WR_ASO5/WR_ASO5
 KSPARSE(1, 737)=89
 KSPARSE(2, 737)=89
!WR_AHSO5/WR_HO2
 KSPARSE(1, 738)=90
 KSPARSE(2, 738)=78
!WR_AHSO5/WR_SO2
 KSPARSE(1, 739)=90
 KSPARSE(2, 739)=80
!WR_AHSO5/WR_ASO5
 KSPARSE(1, 740)=90
 KSPARSE(2, 740)=89
!WR_AHSO5/WR_AHSO5
 KSPARSE(1, 741)=90
 KSPARSE(2, 741)=90
!WR_AHMS/WR_OH
 KSPARSE(1, 742)=91
 KSPARSE(2, 742)=77
!WR_AHMS/WR_SO2
 KSPARSE(1, 743)=91
 KSPARSE(2, 743)=80
!WR_AHMS/WR_HCHO
 KSPARSE(1, 744)=91
 KSPARSE(2, 744)=82
!WR_AHMS/WR_AHMS
 KSPARSE(1, 745)=91
 KSPARSE(2, 745)=91
KSPARSEDIM = 745
RETURN
END SUBROUTINE CH_SPARSE_AQ
!!
!!    #######################
      SUBROUTINE CH_SPARSE_GAZ
!!    #######################
!!
!!*** *MODD_CH_SPARSE*
!!
!!    PURPOSE
!!    -------
!       calculation of the non-zero matrix elements in the Jacobian
!!
!!**  METHOD
!!    ------
!!      A 2D array KSPARSE of DIMESNSION(2,*) is returned, containing 
!!    the indices of the non-zero matrix elements in the Jacobian.
!!
!!    REFERENCE
!!    ---------
!!    none
!!
!!    AUTHOR
!!    ------
!!    Karsten Suhre (LA)
!!
!!    MODIFICATIONS
!!    -------------
!!    Original 26/07/96
!!    Modified 05/05/98: Vectorization (Vincent Crassier & KS)
!!
!!----------------------------------------------------------------------
!!
!!    EXTERNAL
!!    --------
!!    none
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!    none
!!
!!    EXPLICIT ARGUMENTS
!!    ------------------
IMPLICIT NONE
!!
!!    LOCAL VARIABLES
!!    ---------------
!!    none
!!----------------------------------------------------------------------
!!
!!    EXECUTABLE STATEMENTS
!!    ---------------------
! check if output array is large enough
IF (KSPARSEDIM.LT.449) THEN
  STOP 'CH_SPARSE ERROR: array KSPARSE is too small!'
END IF
!O3/O3
 KSPARSE(1, 1)=1
 KSPARSE(2, 1)=1
!O3/NO
 KSPARSE(1, 2)=1
 KSPARSE(2, 2)=3
!O3/NO2
 KSPARSE(1, 3)=1
 KSPARSE(2, 3)=4
!O3/OH
 KSPARSE(1, 4)=1
 KSPARSE(2, 4)=14
!O3/HO2
 KSPARSE(1, 5)=1
 KSPARSE(2, 5)=15
!O3/ALKE
 KSPARSE(1, 6)=1
 KSPARSE(2, 6)=19
!O3/BIO
 KSPARSE(1, 7)=1
 KSPARSE(2, 7)=20
!O3/CARBO
 KSPARSE(1, 8)=1
 KSPARSE(2, 8)=25
!O3/PAN
 KSPARSE(1, 9)=1
 KSPARSE(2, 9)=27
!O3/ADD
 KSPARSE(1, 10)=1
 KSPARSE(2, 10)=37
!O3/CARBOP
 KSPARSE(1, 11)=1
 KSPARSE(2, 11)=39
!H2O2/O3
 KSPARSE(1, 12)=2
 KSPARSE(2, 12)=1
!H2O2/H2O2
 KSPARSE(1, 13)=2
 KSPARSE(2, 13)=2
!H2O2/OH
 KSPARSE(1, 14)=2
 KSPARSE(2, 14)=14
!H2O2/HO2
 KSPARSE(1, 15)=2
 KSPARSE(2, 15)=15
!H2O2/ALKE
 KSPARSE(1, 16)=2
 KSPARSE(2, 16)=19
!H2O2/BIO
 KSPARSE(1, 17)=2
 KSPARSE(2, 17)=20
!NO/O3
 KSPARSE(1, 18)=3
 KSPARSE(2, 18)=1
!NO/NO
 KSPARSE(1, 19)=3
 KSPARSE(2, 19)=3
!NO/NO2
 KSPARSE(1, 20)=3
 KSPARSE(2, 20)=4
!NO/NO3
 KSPARSE(1, 21)=3
 KSPARSE(2, 21)=5
!NO/HONO
 KSPARSE(1, 22)=3
 KSPARSE(2, 22)=7
!NO/OH
 KSPARSE(1, 23)=3
 KSPARSE(2, 23)=14
!NO/HO2
 KSPARSE(1, 24)=3
 KSPARSE(2, 24)=15
!NO/MO2
 KSPARSE(1, 25)=3
 KSPARSE(2, 25)=32
!NO/ALKAP
 KSPARSE(1, 26)=3
 KSPARSE(2, 26)=33
!NO/ALKEP
 KSPARSE(1, 27)=3
 KSPARSE(2, 27)=34
!NO/BIOP
 KSPARSE(1, 28)=3
 KSPARSE(2, 28)=35
!NO/AROP
 KSPARSE(1, 29)=3
 KSPARSE(2, 29)=38
!NO/CARBOP
 KSPARSE(1, 30)=3
 KSPARSE(2, 30)=39
!NO/OLN
 KSPARSE(1, 31)=3
 KSPARSE(2, 31)=40
!NO/XO2
 KSPARSE(1, 32)=3
 KSPARSE(2, 32)=41
!NO2/O3
 KSPARSE(1, 33)=4
 KSPARSE(2, 33)=1
!NO2/NO
 KSPARSE(1, 34)=4
 KSPARSE(2, 34)=3
!NO2/NO2
 KSPARSE(1, 35)=4
 KSPARSE(2, 35)=4
!NO2/NO3
 KSPARSE(1, 36)=4
 KSPARSE(2, 36)=5
!NO2/N2O5
 KSPARSE(1, 37)=4
 KSPARSE(2, 37)=6
!NO2/HONO
 KSPARSE(1, 38)=4
 KSPARSE(2, 38)=7
!NO2/HNO3
 KSPARSE(1, 39)=4
 KSPARSE(2, 39)=8
!NO2/HNO4
 KSPARSE(1, 40)=4
 KSPARSE(2, 40)=9
!NO2/OH
 KSPARSE(1, 41)=4
 KSPARSE(2, 41)=14
!NO2/HO2
 KSPARSE(1, 42)=4
 KSPARSE(2, 42)=15
!NO2/CARBO
 KSPARSE(1, 43)=4
 KSPARSE(2, 43)=25
!NO2/ONIT
 KSPARSE(1, 44)=4
 KSPARSE(2, 44)=26
!NO2/PAN
 KSPARSE(1, 45)=4
 KSPARSE(2, 45)=27
!NO2/MO2
 KSPARSE(1, 46)=4
 KSPARSE(2, 46)=32
!NO2/ALKAP
 KSPARSE(1, 47)=4
 KSPARSE(2, 47)=33
!NO2/ALKEP
 KSPARSE(1, 48)=4
 KSPARSE(2, 48)=34
!NO2/BIOP
 KSPARSE(1, 49)=4
 KSPARSE(2, 49)=35
!NO2/PHO
 KSPARSE(1, 50)=4
 KSPARSE(2, 50)=36
!NO2/ADD
 KSPARSE(1, 51)=4
 KSPARSE(2, 51)=37
!NO2/AROP
 KSPARSE(1, 52)=4
 KSPARSE(2, 52)=38
!NO2/CARBOP
 KSPARSE(1, 53)=4
 KSPARSE(2, 53)=39
!NO2/OLN
 KSPARSE(1, 54)=4
 KSPARSE(2, 54)=40
!NO2/XO2
 KSPARSE(1, 55)=4
 KSPARSE(2, 55)=41
!NO3/O3
 KSPARSE(1, 56)=5
 KSPARSE(2, 56)=1
!NO3/NO
 KSPARSE(1, 57)=5
 KSPARSE(2, 57)=3
!NO3/NO2
 KSPARSE(1, 58)=5
 KSPARSE(2, 58)=4
!NO3/NO3
 KSPARSE(1, 59)=5
 KSPARSE(2, 59)=5
!NO3/N2O5
 KSPARSE(1, 60)=5
 KSPARSE(2, 60)=6
!NO3/HNO3
 KSPARSE(1, 61)=5
 KSPARSE(2, 61)=8
!NO3/HNO4
 KSPARSE(1, 62)=5
 KSPARSE(2, 62)=9
!NO3/OH
 KSPARSE(1, 63)=5
 KSPARSE(2, 63)=14
!NO3/HO2
 KSPARSE(1, 64)=5
 KSPARSE(2, 64)=15
!NO3/ALKE
 KSPARSE(1, 65)=5
 KSPARSE(2, 65)=19
!NO3/BIO
 KSPARSE(1, 66)=5
 KSPARSE(2, 66)=20
!NO3/ARO
 KSPARSE(1, 67)=5
 KSPARSE(2, 67)=21
!NO3/HCHO
 KSPARSE(1, 68)=5
 KSPARSE(2, 68)=22
!NO3/ALD
 KSPARSE(1, 69)=5
 KSPARSE(2, 69)=23
!NO3/CARBO
 KSPARSE(1, 70)=5
 KSPARSE(2, 70)=25
!NO3/PAN
 KSPARSE(1, 71)=5
 KSPARSE(2, 71)=27
!NO3/MO2
 KSPARSE(1, 72)=5
 KSPARSE(2, 72)=32
!NO3/ALKAP
 KSPARSE(1, 73)=5
 KSPARSE(2, 73)=33
!NO3/ALKEP
 KSPARSE(1, 74)=5
 KSPARSE(2, 74)=34
!NO3/BIOP
 KSPARSE(1, 75)=5
 KSPARSE(2, 75)=35
!NO3/AROP
 KSPARSE(1, 76)=5
 KSPARSE(2, 76)=38
!NO3/CARBOP
 KSPARSE(1, 77)=5
 KSPARSE(2, 77)=39
!NO3/OLN
 KSPARSE(1, 78)=5
 KSPARSE(2, 78)=40
!NO3/XO2
 KSPARSE(1, 79)=5
 KSPARSE(2, 79)=41
!N2O5/NO2
 KSPARSE(1, 80)=6
 KSPARSE(2, 80)=4
!N2O5/NO3
 KSPARSE(1, 81)=6
 KSPARSE(2, 81)=5
!N2O5/N2O5
 KSPARSE(1, 82)=6
 KSPARSE(2, 82)=6
!HONO/NO
 KSPARSE(1, 83)=7
 KSPARSE(2, 83)=3
!HONO/NO2
 KSPARSE(1, 84)=7
 KSPARSE(2, 84)=4
!HONO/HONO
 KSPARSE(1, 85)=7
 KSPARSE(2, 85)=7
!HONO/OH
 KSPARSE(1, 86)=7
 KSPARSE(2, 86)=14
!HONO/ADD
 KSPARSE(1, 87)=7
 KSPARSE(2, 87)=37
!HNO3/NO2
 KSPARSE(1, 88)=8
 KSPARSE(2, 88)=4
!HNO3/NO3
 KSPARSE(1, 89)=8
 KSPARSE(2, 89)=5
!HNO3/HNO3
 KSPARSE(1, 90)=8
 KSPARSE(2, 90)=8
!HNO3/OH
 KSPARSE(1, 91)=8
 KSPARSE(2, 91)=14
!HNO3/HO2
 KSPARSE(1, 92)=8
 KSPARSE(2, 92)=15
!HNO3/ARO
 KSPARSE(1, 93)=8
 KSPARSE(2, 93)=21
!HNO3/HCHO
 KSPARSE(1, 94)=8
 KSPARSE(2, 94)=22
!HNO3/ALD
 KSPARSE(1, 95)=8
 KSPARSE(2, 95)=23
!HNO3/CARBO
 KSPARSE(1, 96)=8
 KSPARSE(2, 96)=25
!HNO4/NO2
 KSPARSE(1, 97)=9
 KSPARSE(2, 97)=4
!HNO4/HNO4
 KSPARSE(1, 98)=9
 KSPARSE(2, 98)=9
!HNO4/OH
 KSPARSE(1, 99)=9
 KSPARSE(2, 99)=14
!HNO4/HO2
 KSPARSE(1, 100)=9
 KSPARSE(2, 100)=15
!NH3/NH3
 KSPARSE(1, 101)=10
 KSPARSE(2, 101)=10
!NH3/OH
 KSPARSE(1, 102)=10
 KSPARSE(2, 102)=14
!SO2/SO2
 KSPARSE(1, 103)=11
 KSPARSE(2, 103)=11
!SO2/OH
 KSPARSE(1, 104)=11
 KSPARSE(2, 104)=14
!SULF/SO2
 KSPARSE(1, 105)=12
 KSPARSE(2, 105)=11
!SULF/SULF
 KSPARSE(1, 106)=12
 KSPARSE(2, 106)=12
!SULF/OH
 KSPARSE(1, 107)=12
 KSPARSE(2, 107)=14
!CO/O3
 KSPARSE(1, 108)=13
 KSPARSE(2, 108)=1
!CO/NO3
 KSPARSE(1, 109)=13
 KSPARSE(2, 109)=5
!CO/CO
 KSPARSE(1, 110)=13
 KSPARSE(2, 110)=13
!CO/OH
 KSPARSE(1, 111)=13
 KSPARSE(2, 111)=14
!CO/ALKA
 KSPARSE(1, 112)=13
 KSPARSE(2, 112)=18
!CO/ALKE
 KSPARSE(1, 113)=13
 KSPARSE(2, 113)=19
!CO/BIO
 KSPARSE(1, 114)=13
 KSPARSE(2, 114)=20
!CO/HCHO
 KSPARSE(1, 115)=13
 KSPARSE(2, 115)=22
!CO/ALD
 KSPARSE(1, 116)=13
 KSPARSE(2, 116)=23
!CO/CARBO
 KSPARSE(1, 117)=13
 KSPARSE(2, 117)=25
!CO/PAN
 KSPARSE(1, 118)=13
 KSPARSE(2, 118)=27
!OH/O3
 KSPARSE(1, 119)=14
 KSPARSE(2, 119)=1
!OH/H2O2
 KSPARSE(1, 120)=14
 KSPARSE(2, 120)=2
!OH/NO
 KSPARSE(1, 121)=14
 KSPARSE(2, 121)=3
!OH/NO2
 KSPARSE(1, 122)=14
 KSPARSE(2, 122)=4
!OH/NO3
 KSPARSE(1, 123)=14
 KSPARSE(2, 123)=5
!OH/HONO
 KSPARSE(1, 124)=14
 KSPARSE(2, 124)=7
!OH/HNO3
 KSPARSE(1, 125)=14
 KSPARSE(2, 125)=8
!OH/HNO4
 KSPARSE(1, 126)=14
 KSPARSE(2, 126)=9
!OH/NH3
 KSPARSE(1, 127)=14
 KSPARSE(2, 127)=10
!OH/SO2
 KSPARSE(1, 128)=14
 KSPARSE(2, 128)=11
!OH/CO
 KSPARSE(1, 129)=14
 KSPARSE(2, 129)=13
!OH/OH
 KSPARSE(1, 130)=14
 KSPARSE(2, 130)=14
!OH/HO2
 KSPARSE(1, 131)=14
 KSPARSE(2, 131)=15
!OH/CH4
 KSPARSE(1, 132)=14
 KSPARSE(2, 132)=16
!OH/ETH
 KSPARSE(1, 133)=14
 KSPARSE(2, 133)=17
!OH/ALKA
 KSPARSE(1, 134)=14
 KSPARSE(2, 134)=18
!OH/ALKE
 KSPARSE(1, 135)=14
 KSPARSE(2, 135)=19
!OH/BIO
 KSPARSE(1, 136)=14
 KSPARSE(2, 136)=20
!OH/ARO
 KSPARSE(1, 137)=14
 KSPARSE(2, 137)=21
!OH/HCHO
 KSPARSE(1, 138)=14
 KSPARSE(2, 138)=22
!OH/ALD
 KSPARSE(1, 139)=14
 KSPARSE(2, 139)=23
!OH/KET
 KSPARSE(1, 140)=14
 KSPARSE(2, 140)=24
!OH/CARBO
 KSPARSE(1, 141)=14
 KSPARSE(2, 141)=25
!OH/ONIT
 KSPARSE(1, 142)=14
 KSPARSE(2, 142)=26
!OH/PAN
 KSPARSE(1, 143)=14
 KSPARSE(2, 143)=27
!OH/OP1
 KSPARSE(1, 144)=14
 KSPARSE(2, 144)=28
!OH/OP2
 KSPARSE(1, 145)=14
 KSPARSE(2, 145)=29
!OH/ORA1
 KSPARSE(1, 146)=14
 KSPARSE(2, 146)=30
!OH/ORA2
 KSPARSE(1, 147)=14
 KSPARSE(2, 147)=31
!OH/ADD
 KSPARSE(1, 148)=14
 KSPARSE(2, 148)=37
!HO2/O3
 KSPARSE(1, 149)=15
 KSPARSE(2, 149)=1
!HO2/H2O2
 KSPARSE(1, 150)=15
 KSPARSE(2, 150)=2
!HO2/NO
 KSPARSE(1, 151)=15
 KSPARSE(2, 151)=3
!HO2/NO2
 KSPARSE(1, 152)=15
 KSPARSE(2, 152)=4
!HO2/NO3
 KSPARSE(1, 153)=15
 KSPARSE(2, 153)=5
!HO2/HNO4
 KSPARSE(1, 154)=15
 KSPARSE(2, 154)=9
!HO2/SO2
 KSPARSE(1, 155)=15
 KSPARSE(2, 155)=11
!HO2/CO
 KSPARSE(1, 156)=15
 KSPARSE(2, 156)=13
!HO2/OH
 KSPARSE(1, 157)=15
 KSPARSE(2, 157)=14
!HO2/HO2
 KSPARSE(1, 158)=15
 KSPARSE(2, 158)=15
!HO2/ALKA
 KSPARSE(1, 159)=15
 KSPARSE(2, 159)=18
!HO2/ALKE
 KSPARSE(1, 160)=15
 KSPARSE(2, 160)=19
!HO2/BIO
 KSPARSE(1, 161)=15
 KSPARSE(2, 161)=20
!HO2/ARO
 KSPARSE(1, 162)=15
 KSPARSE(2, 162)=21
!HO2/HCHO
 KSPARSE(1, 163)=15
 KSPARSE(2, 163)=22
!HO2/ALD
 KSPARSE(1, 164)=15
 KSPARSE(2, 164)=23
!HO2/CARBO
 KSPARSE(1, 165)=15
 KSPARSE(2, 165)=25
!HO2/ONIT
 KSPARSE(1, 166)=15
 KSPARSE(2, 166)=26
!HO2/PAN
 KSPARSE(1, 167)=15
 KSPARSE(2, 167)=27
!HO2/OP1
 KSPARSE(1, 168)=15
 KSPARSE(2, 168)=28
!HO2/OP2
 KSPARSE(1, 169)=15
 KSPARSE(2, 169)=29
!HO2/ORA1
 KSPARSE(1, 170)=15
 KSPARSE(2, 170)=30
!HO2/MO2
 KSPARSE(1, 171)=15
 KSPARSE(2, 171)=32
!HO2/ALKAP
 KSPARSE(1, 172)=15
 KSPARSE(2, 172)=33
!HO2/ALKEP
 KSPARSE(1, 173)=15
 KSPARSE(2, 173)=34
!HO2/BIOP
 KSPARSE(1, 174)=15
 KSPARSE(2, 174)=35
!HO2/PHO
 KSPARSE(1, 175)=15
 KSPARSE(2, 175)=36
!HO2/ADD
 KSPARSE(1, 176)=15
 KSPARSE(2, 176)=37
!HO2/AROP
 KSPARSE(1, 177)=15
 KSPARSE(2, 177)=38
!HO2/CARBOP
 KSPARSE(1, 178)=15
 KSPARSE(2, 178)=39
!HO2/OLN
 KSPARSE(1, 179)=15
 KSPARSE(2, 179)=40
!HO2/XO2
 KSPARSE(1, 180)=15
 KSPARSE(2, 180)=41
!CH4/O3
 KSPARSE(1, 181)=16
 KSPARSE(2, 181)=1
!CH4/OH
 KSPARSE(1, 182)=16
 KSPARSE(2, 182)=14
!CH4/CH4
 KSPARSE(1, 183)=16
 KSPARSE(2, 183)=16
!CH4/ALKE
 KSPARSE(1, 184)=16
 KSPARSE(2, 184)=19
!ETH/O3
 KSPARSE(1, 185)=17
 KSPARSE(2, 185)=1
!ETH/OH
 KSPARSE(1, 186)=17
 KSPARSE(2, 186)=14
!ETH/ETH
 KSPARSE(1, 187)=17
 KSPARSE(2, 187)=17
!ETH/ALKE
 KSPARSE(1, 188)=17
 KSPARSE(2, 188)=19
!ALKA/OH
 KSPARSE(1, 189)=18
 KSPARSE(2, 189)=14
!ALKA/ALKA
 KSPARSE(1, 190)=18
 KSPARSE(2, 190)=18
!ALKE/O3
 KSPARSE(1, 191)=19
 KSPARSE(2, 191)=1
!ALKE/NO
 KSPARSE(1, 192)=19
 KSPARSE(2, 192)=3
!ALKE/NO3
 KSPARSE(1, 193)=19
 KSPARSE(2, 193)=5
!ALKE/OH
 KSPARSE(1, 194)=19
 KSPARSE(2, 194)=14
!ALKE/ALKE
 KSPARSE(1, 195)=19
 KSPARSE(2, 195)=19
!ALKE/BIO
 KSPARSE(1, 196)=19
 KSPARSE(2, 196)=20
!ALKE/MO2
 KSPARSE(1, 197)=19
 KSPARSE(2, 197)=32
!ALKE/BIOP
 KSPARSE(1, 198)=19
 KSPARSE(2, 198)=35
!ALKE/CARBOP
 KSPARSE(1, 199)=19
 KSPARSE(2, 199)=39
!BIO/O3
 KSPARSE(1, 200)=20
 KSPARSE(2, 200)=1
!BIO/NO3
 KSPARSE(1, 201)=20
 KSPARSE(2, 201)=5
!BIO/OH
 KSPARSE(1, 202)=20
 KSPARSE(2, 202)=14
!BIO/BIO
 KSPARSE(1, 203)=20
 KSPARSE(2, 203)=20
!ARO/O3
 KSPARSE(1, 204)=21
 KSPARSE(2, 204)=1
!ARO/NO2
 KSPARSE(1, 205)=21
 KSPARSE(2, 205)=4
!ARO/NO3
 KSPARSE(1, 206)=21
 KSPARSE(2, 206)=5
!ARO/OH
 KSPARSE(1, 207)=21
 KSPARSE(2, 207)=14
!ARO/HO2
 KSPARSE(1, 208)=21
 KSPARSE(2, 208)=15
!ARO/ARO
 KSPARSE(1, 209)=21
 KSPARSE(2, 209)=21
!ARO/PHO
 KSPARSE(1, 210)=21
 KSPARSE(2, 210)=36
!ARO/ADD
 KSPARSE(1, 211)=21
 KSPARSE(2, 211)=37
!HCHO/O3
 KSPARSE(1, 212)=22
 KSPARSE(2, 212)=1
!HCHO/NO
 KSPARSE(1, 213)=22
 KSPARSE(2, 213)=3
!HCHO/NO3
 KSPARSE(1, 214)=22
 KSPARSE(2, 214)=5
!HCHO/OH
 KSPARSE(1, 215)=22
 KSPARSE(2, 215)=14
!HCHO/ALKA
 KSPARSE(1, 216)=22
 KSPARSE(2, 216)=18
!HCHO/ALKE
 KSPARSE(1, 217)=22
 KSPARSE(2, 217)=19
!HCHO/BIO
 KSPARSE(1, 218)=22
 KSPARSE(2, 218)=20
!HCHO/HCHO
 KSPARSE(1, 219)=22
 KSPARSE(2, 219)=22
!HCHO/CARBO
 KSPARSE(1, 220)=22
 KSPARSE(2, 220)=25
!HCHO/PAN
 KSPARSE(1, 221)=22
 KSPARSE(2, 221)=27
!HCHO/OP1
 KSPARSE(1, 222)=22
 KSPARSE(2, 222)=28
!HCHO/OP2
 KSPARSE(1, 223)=22
 KSPARSE(2, 223)=29
!HCHO/MO2
 KSPARSE(1, 224)=22
 KSPARSE(2, 224)=32
!HCHO/ALKAP
 KSPARSE(1, 225)=22
 KSPARSE(2, 225)=33
!HCHO/ALKEP
 KSPARSE(1, 226)=22
 KSPARSE(2, 226)=34
!HCHO/BIOP
 KSPARSE(1, 227)=22
 KSPARSE(2, 227)=35
!HCHO/AROP
 KSPARSE(1, 228)=22
 KSPARSE(2, 228)=38
!HCHO/CARBOP
 KSPARSE(1, 229)=22
 KSPARSE(2, 229)=39
!HCHO/OLN
 KSPARSE(1, 230)=22
 KSPARSE(2, 230)=40
!HCHO/XO2
 KSPARSE(1, 231)=22
 KSPARSE(2, 231)=41
!ALD/O3
 KSPARSE(1, 232)=23
 KSPARSE(2, 232)=1
!ALD/NO
 KSPARSE(1, 233)=23
 KSPARSE(2, 233)=3
!ALD/NO3
 KSPARSE(1, 234)=23
 KSPARSE(2, 234)=5
!ALD/OH
 KSPARSE(1, 235)=23
 KSPARSE(2, 235)=14
!ALD/ALKA
 KSPARSE(1, 236)=23
 KSPARSE(2, 236)=18
!ALD/ALKE
 KSPARSE(1, 237)=23
 KSPARSE(2, 237)=19
!ALD/BIO
 KSPARSE(1, 238)=23
 KSPARSE(2, 238)=20
!ALD/ALD
 KSPARSE(1, 239)=23
 KSPARSE(2, 239)=23
!ALD/CARBO
 KSPARSE(1, 240)=23
 KSPARSE(2, 240)=25
!ALD/ONIT
 KSPARSE(1, 241)=23
 KSPARSE(2, 241)=26
!ALD/OP2
 KSPARSE(1, 242)=23
 KSPARSE(2, 242)=29
!ALD/MO2
 KSPARSE(1, 243)=23
 KSPARSE(2, 243)=32
!ALD/ALKAP
 KSPARSE(1, 244)=23
 KSPARSE(2, 244)=33
!ALD/ALKEP
 KSPARSE(1, 245)=23
 KSPARSE(2, 245)=34
!ALD/BIOP
 KSPARSE(1, 246)=23
 KSPARSE(2, 246)=35
!ALD/CARBOP
 KSPARSE(1, 247)=23
 KSPARSE(2, 247)=39
!ALD/OLN
 KSPARSE(1, 248)=23
 KSPARSE(2, 248)=40
!KET/O3
 KSPARSE(1, 249)=24
 KSPARSE(2, 249)=1
!KET/NO
 KSPARSE(1, 250)=24
 KSPARSE(2, 250)=3
!KET/NO3
 KSPARSE(1, 251)=24
 KSPARSE(2, 251)=5
!KET/OH
 KSPARSE(1, 252)=24
 KSPARSE(2, 252)=14
!KET/ALKA
 KSPARSE(1, 253)=24
 KSPARSE(2, 253)=18
!KET/ALKE
 KSPARSE(1, 254)=24
 KSPARSE(2, 254)=19
!KET/BIO
 KSPARSE(1, 255)=24
 KSPARSE(2, 255)=20
!KET/KET
 KSPARSE(1, 256)=24
 KSPARSE(2, 256)=24
!KET/CARBO
 KSPARSE(1, 257)=24
 KSPARSE(2, 257)=25
!KET/ONIT
 KSPARSE(1, 258)=24
 KSPARSE(2, 258)=26
!KET/OP2
 KSPARSE(1, 259)=24
 KSPARSE(2, 259)=29
!KET/MO2
 KSPARSE(1, 260)=24
 KSPARSE(2, 260)=32
!KET/ALKAP
 KSPARSE(1, 261)=24
 KSPARSE(2, 261)=33
!KET/ALKEP
 KSPARSE(1, 262)=24
 KSPARSE(2, 262)=34
!KET/BIOP
 KSPARSE(1, 263)=24
 KSPARSE(2, 263)=35
!KET/CARBOP
 KSPARSE(1, 264)=24
 KSPARSE(2, 264)=39
!KET/OLN
 KSPARSE(1, 265)=24
 KSPARSE(2, 265)=40
!CARBO/O3
 KSPARSE(1, 266)=25
 KSPARSE(2, 266)=1
!CARBO/NO
 KSPARSE(1, 267)=25
 KSPARSE(2, 267)=3
!CARBO/NO3
 KSPARSE(1, 268)=25
 KSPARSE(2, 268)=5
!CARBO/OH
 KSPARSE(1, 269)=25
 KSPARSE(2, 269)=14
!CARBO/ALKA
 KSPARSE(1, 270)=25
 KSPARSE(2, 270)=18
!CARBO/ALKE
 KSPARSE(1, 271)=25
 KSPARSE(2, 271)=19
!CARBO/BIO
 KSPARSE(1, 272)=25
 KSPARSE(2, 272)=20
!CARBO/CARBO
 KSPARSE(1, 273)=25
 KSPARSE(2, 273)=25
!CARBO/PAN
 KSPARSE(1, 274)=25
 KSPARSE(2, 274)=27
!CARBO/MO2
 KSPARSE(1, 275)=25
 KSPARSE(2, 275)=32
!CARBO/ALKAP
 KSPARSE(1, 276)=25
 KSPARSE(2, 276)=33
!CARBO/BIOP
 KSPARSE(1, 277)=25
 KSPARSE(2, 277)=35
!CARBO/AROP
 KSPARSE(1, 278)=25
 KSPARSE(2, 278)=38
!CARBO/CARBOP
 KSPARSE(1, 279)=25
 KSPARSE(2, 279)=39
!ONIT/NO
 KSPARSE(1, 280)=26
 KSPARSE(2, 280)=3
!ONIT/NO2
 KSPARSE(1, 281)=26
 KSPARSE(2, 281)=4
!ONIT/NO3
 KSPARSE(1, 282)=26
 KSPARSE(2, 282)=5
!ONIT/OH
 KSPARSE(1, 283)=26
 KSPARSE(2, 283)=14
!ONIT/HO2
 KSPARSE(1, 284)=26
 KSPARSE(2, 284)=15
!ONIT/ONIT
 KSPARSE(1, 285)=26
 KSPARSE(2, 285)=26
!ONIT/PAN
 KSPARSE(1, 286)=26
 KSPARSE(2, 286)=27
!ONIT/MO2
 KSPARSE(1, 287)=26
 KSPARSE(2, 287)=32
!ONIT/ALKAP
 KSPARSE(1, 288)=26
 KSPARSE(2, 288)=33
!ONIT/BIOP
 KSPARSE(1, 289)=26
 KSPARSE(2, 289)=35
!ONIT/PHO
 KSPARSE(1, 290)=26
 KSPARSE(2, 290)=36
!ONIT/AROP
 KSPARSE(1, 291)=26
 KSPARSE(2, 291)=38
!ONIT/CARBOP
 KSPARSE(1, 292)=26
 KSPARSE(2, 292)=39
!ONIT/OLN
 KSPARSE(1, 293)=26
 KSPARSE(2, 293)=40
!PAN/O3
 KSPARSE(1, 294)=27
 KSPARSE(2, 294)=1
!PAN/NO2
 KSPARSE(1, 295)=27
 KSPARSE(2, 295)=4
!PAN/NO3
 KSPARSE(1, 296)=27
 KSPARSE(2, 296)=5
!PAN/OH
 KSPARSE(1, 297)=27
 KSPARSE(2, 297)=14
!PAN/PAN
 KSPARSE(1, 298)=27
 KSPARSE(2, 298)=27
!PAN/CARBOP
 KSPARSE(1, 299)=27
 KSPARSE(2, 299)=39
!OP1/OH
 KSPARSE(1, 300)=28
 KSPARSE(2, 300)=14
!OP1/HO2
 KSPARSE(1, 301)=28
 KSPARSE(2, 301)=15
!OP1/OP1
 KSPARSE(1, 302)=28
 KSPARSE(2, 302)=28
!OP1/MO2
 KSPARSE(1, 303)=28
 KSPARSE(2, 303)=32
!OP2/O3
 KSPARSE(1, 304)=29
 KSPARSE(2, 304)=1
!OP2/OH
 KSPARSE(1, 305)=29
 KSPARSE(2, 305)=14
!OP2/HO2
 KSPARSE(1, 306)=29
 KSPARSE(2, 306)=15
!OP2/CARBO
 KSPARSE(1, 307)=29
 KSPARSE(2, 307)=25
!OP2/OP2
 KSPARSE(1, 308)=29
 KSPARSE(2, 308)=29
!OP2/ALKAP
 KSPARSE(1, 309)=29
 KSPARSE(2, 309)=33
!OP2/ALKEP
 KSPARSE(1, 310)=29
 KSPARSE(2, 310)=34
!OP2/BIOP
 KSPARSE(1, 311)=29
 KSPARSE(2, 311)=35
!OP2/AROP
 KSPARSE(1, 312)=29
 KSPARSE(2, 312)=38
!OP2/CARBOP
 KSPARSE(1, 313)=29
 KSPARSE(2, 313)=39
!OP2/XO2
 KSPARSE(1, 314)=29
 KSPARSE(2, 314)=41
!ORA1/O3
 KSPARSE(1, 315)=30
 KSPARSE(2, 315)=1
!ORA1/OH
 KSPARSE(1, 316)=30
 KSPARSE(2, 316)=14
!ORA1/ALKA
 KSPARSE(1, 317)=30
 KSPARSE(2, 317)=18
!ORA1/ALKE
 KSPARSE(1, 318)=30
 KSPARSE(2, 318)=19
!ORA1/BIO
 KSPARSE(1, 319)=30
 KSPARSE(2, 319)=20
!ORA1/CARBO
 KSPARSE(1, 320)=30
 KSPARSE(2, 320)=25
!ORA1/PAN
 KSPARSE(1, 321)=30
 KSPARSE(2, 321)=27
!ORA1/ORA1
 KSPARSE(1, 322)=30
 KSPARSE(2, 322)=30
!ORA2/O3
 KSPARSE(1, 323)=31
 KSPARSE(2, 323)=1
!ORA2/OH
 KSPARSE(1, 324)=31
 KSPARSE(2, 324)=14
!ORA2/HO2
 KSPARSE(1, 325)=31
 KSPARSE(2, 325)=15
!ORA2/ALKE
 KSPARSE(1, 326)=31
 KSPARSE(2, 326)=19
!ORA2/BIO
 KSPARSE(1, 327)=31
 KSPARSE(2, 327)=20
!ORA2/CARBO
 KSPARSE(1, 328)=31
 KSPARSE(2, 328)=25
!ORA2/ORA2
 KSPARSE(1, 329)=31
 KSPARSE(2, 329)=31
!ORA2/MO2
 KSPARSE(1, 330)=31
 KSPARSE(2, 330)=32
!ORA2/ALKAP
 KSPARSE(1, 331)=31
 KSPARSE(2, 331)=33
!ORA2/ALKEP
 KSPARSE(1, 332)=31
 KSPARSE(2, 332)=34
!ORA2/BIOP
 KSPARSE(1, 333)=31
 KSPARSE(2, 333)=35
!ORA2/CARBOP
 KSPARSE(1, 334)=31
 KSPARSE(2, 334)=39
!ORA2/OLN
 KSPARSE(1, 335)=31
 KSPARSE(2, 335)=40
!MO2/O3
 KSPARSE(1, 336)=32
 KSPARSE(2, 336)=1
!MO2/NO
 KSPARSE(1, 337)=32
 KSPARSE(2, 337)=3
!MO2/NO3
 KSPARSE(1, 338)=32
 KSPARSE(2, 338)=5
!MO2/OH
 KSPARSE(1, 339)=32
 KSPARSE(2, 339)=14
!MO2/HO2
 KSPARSE(1, 340)=32
 KSPARSE(2, 340)=15
!MO2/CH4
 KSPARSE(1, 341)=32
 KSPARSE(2, 341)=16
!MO2/ALKE
 KSPARSE(1, 342)=32
 KSPARSE(2, 342)=19
!MO2/BIO
 KSPARSE(1, 343)=32
 KSPARSE(2, 343)=20
!MO2/ALD
 KSPARSE(1, 344)=32
 KSPARSE(2, 344)=23
!MO2/OP1
 KSPARSE(1, 345)=32
 KSPARSE(2, 345)=28
!MO2/OP2
 KSPARSE(1, 346)=32
 KSPARSE(2, 346)=29
!MO2/MO2
 KSPARSE(1, 347)=32
 KSPARSE(2, 347)=32
!MO2/ALKAP
 KSPARSE(1, 348)=32
 KSPARSE(2, 348)=33
!MO2/ALKEP
 KSPARSE(1, 349)=32
 KSPARSE(2, 349)=34
!MO2/BIOP
 KSPARSE(1, 350)=32
 KSPARSE(2, 350)=35
!MO2/AROP
 KSPARSE(1, 351)=32
 KSPARSE(2, 351)=38
!MO2/CARBOP
 KSPARSE(1, 352)=32
 KSPARSE(2, 352)=39
!MO2/OLN
 KSPARSE(1, 353)=32
 KSPARSE(2, 353)=40
!MO2/XO2
 KSPARSE(1, 354)=32
 KSPARSE(2, 354)=41
!ALKAP/O3
 KSPARSE(1, 355)=33
 KSPARSE(2, 355)=1
!ALKAP/NO
 KSPARSE(1, 356)=33
 KSPARSE(2, 356)=3
!ALKAP/NO3
 KSPARSE(1, 357)=33
 KSPARSE(2, 357)=5
!ALKAP/OH
 KSPARSE(1, 358)=33
 KSPARSE(2, 358)=14
!ALKAP/HO2
 KSPARSE(1, 359)=33
 KSPARSE(2, 359)=15
!ALKAP/ETH
 KSPARSE(1, 360)=33
 KSPARSE(2, 360)=17
!ALKAP/ALKA
 KSPARSE(1, 361)=33
 KSPARSE(2, 361)=18
!ALKAP/ALKE
 KSPARSE(1, 362)=33
 KSPARSE(2, 362)=19
!ALKAP/BIO
 KSPARSE(1, 363)=33
 KSPARSE(2, 363)=20
!ALKAP/KET
 KSPARSE(1, 364)=33
 KSPARSE(2, 364)=24
!ALKAP/ONIT
 KSPARSE(1, 365)=33
 KSPARSE(2, 365)=26
!ALKAP/OP2
 KSPARSE(1, 366)=33
 KSPARSE(2, 366)=29
!ALKAP/MO2
 KSPARSE(1, 367)=33
 KSPARSE(2, 367)=32
!ALKAP/ALKAP
 KSPARSE(1, 368)=33
 KSPARSE(2, 368)=33
!ALKAP/CARBOP
 KSPARSE(1, 369)=33
 KSPARSE(2, 369)=39
!ALKEP/NO
 KSPARSE(1, 370)=34
 KSPARSE(2, 370)=3
!ALKEP/NO3
 KSPARSE(1, 371)=34
 KSPARSE(2, 371)=5
!ALKEP/OH
 KSPARSE(1, 372)=34
 KSPARSE(2, 372)=14
!ALKEP/HO2
 KSPARSE(1, 373)=34
 KSPARSE(2, 373)=15
!ALKEP/ALKE
 KSPARSE(1, 374)=34
 KSPARSE(2, 374)=19
!ALKEP/MO2
 KSPARSE(1, 375)=34
 KSPARSE(2, 375)=32
!ALKEP/ALKEP
 KSPARSE(1, 376)=34
 KSPARSE(2, 376)=34
!ALKEP/CARBOP
 KSPARSE(1, 377)=34
 KSPARSE(2, 377)=39
!BIOP/NO
 KSPARSE(1, 378)=35
 KSPARSE(2, 378)=3
!BIOP/NO3
 KSPARSE(1, 379)=35
 KSPARSE(2, 379)=5
!BIOP/OH
 KSPARSE(1, 380)=35
 KSPARSE(2, 380)=14
!BIOP/HO2
 KSPARSE(1, 381)=35
 KSPARSE(2, 381)=15
!BIOP/ALKE
 KSPARSE(1, 382)=35
 KSPARSE(2, 382)=19
!BIOP/BIO
 KSPARSE(1, 383)=35
 KSPARSE(2, 383)=20
!BIOP/MO2
 KSPARSE(1, 384)=35
 KSPARSE(2, 384)=32
!BIOP/BIOP
 KSPARSE(1, 385)=35
 KSPARSE(2, 385)=35
!BIOP/CARBOP
 KSPARSE(1, 386)=35
 KSPARSE(2, 386)=39
!PHO/NO2
 KSPARSE(1, 387)=36
 KSPARSE(2, 387)=4
!PHO/NO3
 KSPARSE(1, 388)=36
 KSPARSE(2, 388)=5
!PHO/OH
 KSPARSE(1, 389)=36
 KSPARSE(2, 389)=14
!PHO/HO2
 KSPARSE(1, 390)=36
 KSPARSE(2, 390)=15
!PHO/ARO
 KSPARSE(1, 391)=36
 KSPARSE(2, 391)=21
!PHO/PHO
 KSPARSE(1, 392)=36
 KSPARSE(2, 392)=36
!ADD/O3
 KSPARSE(1, 393)=37
 KSPARSE(2, 393)=1
!ADD/NO2
 KSPARSE(1, 394)=37
 KSPARSE(2, 394)=4
!ADD/OH
 KSPARSE(1, 395)=37
 KSPARSE(2, 395)=14
!ADD/ARO
 KSPARSE(1, 396)=37
 KSPARSE(2, 396)=21
!ADD/ADD
 KSPARSE(1, 397)=37
 KSPARSE(2, 397)=37
!AROP/NO
 KSPARSE(1, 398)=38
 KSPARSE(2, 398)=3
!AROP/NO3
 KSPARSE(1, 399)=38
 KSPARSE(2, 399)=5
!AROP/HO2
 KSPARSE(1, 400)=38
 KSPARSE(2, 400)=15
!AROP/MO2
 KSPARSE(1, 401)=38
 KSPARSE(2, 401)=32
!AROP/ADD
 KSPARSE(1, 402)=38
 KSPARSE(2, 402)=37
!AROP/AROP
 KSPARSE(1, 403)=38
 KSPARSE(2, 403)=38
!AROP/CARBOP
 KSPARSE(1, 404)=38
 KSPARSE(2, 404)=39
!CARBOP/O3
 KSPARSE(1, 405)=39
 KSPARSE(2, 405)=1
!CARBOP/NO
 KSPARSE(1, 406)=39
 KSPARSE(2, 406)=3
!CARBOP/NO2
 KSPARSE(1, 407)=39
 KSPARSE(2, 407)=4
!CARBOP/NO3
 KSPARSE(1, 408)=39
 KSPARSE(2, 408)=5
!CARBOP/OH
 KSPARSE(1, 409)=39
 KSPARSE(2, 409)=14
!CARBOP/HO2
 KSPARSE(1, 410)=39
 KSPARSE(2, 410)=15
!CARBOP/ALKE
 KSPARSE(1, 411)=39
 KSPARSE(2, 411)=19
!CARBOP/BIO
 KSPARSE(1, 412)=39
 KSPARSE(2, 412)=20
!CARBOP/ALD
 KSPARSE(1, 413)=39
 KSPARSE(2, 413)=23
!CARBOP/KET
 KSPARSE(1, 414)=39
 KSPARSE(2, 414)=24
!CARBOP/CARBO
 KSPARSE(1, 415)=39
 KSPARSE(2, 415)=25
!CARBOP/PAN
 KSPARSE(1, 416)=39
 KSPARSE(2, 416)=27
!CARBOP/OP2
 KSPARSE(1, 417)=39
 KSPARSE(2, 417)=29
!CARBOP/MO2
 KSPARSE(1, 418)=39
 KSPARSE(2, 418)=32
!CARBOP/ALKAP
 KSPARSE(1, 419)=39
 KSPARSE(2, 419)=33
!CARBOP/ALKEP
 KSPARSE(1, 420)=39
 KSPARSE(2, 420)=34
!CARBOP/BIOP
 KSPARSE(1, 421)=39
 KSPARSE(2, 421)=35
!CARBOP/AROP
 KSPARSE(1, 422)=39
 KSPARSE(2, 422)=38
!CARBOP/CARBOP
 KSPARSE(1, 423)=39
 KSPARSE(2, 423)=39
!CARBOP/OLN
 KSPARSE(1, 424)=39
 KSPARSE(2, 424)=40
!CARBOP/XO2
 KSPARSE(1, 425)=39
 KSPARSE(2, 425)=41
!OLN/NO
 KSPARSE(1, 426)=40
 KSPARSE(2, 426)=3
!OLN/NO3
 KSPARSE(1, 427)=40
 KSPARSE(2, 427)=5
!OLN/HO2
 KSPARSE(1, 428)=40
 KSPARSE(2, 428)=15
!OLN/ALKE
 KSPARSE(1, 429)=40
 KSPARSE(2, 429)=19
!OLN/BIO
 KSPARSE(1, 430)=40
 KSPARSE(2, 430)=20
!OLN/CARBO
 KSPARSE(1, 431)=40
 KSPARSE(2, 431)=25
!OLN/MO2
 KSPARSE(1, 432)=40
 KSPARSE(2, 432)=32
!OLN/CARBOP
 KSPARSE(1, 433)=40
 KSPARSE(2, 433)=39
!OLN/OLN
 KSPARSE(1, 434)=40
 KSPARSE(2, 434)=40
!XO2/O3
 KSPARSE(1, 435)=41
 KSPARSE(2, 435)=1
!XO2/NO
 KSPARSE(1, 436)=41
 KSPARSE(2, 436)=3
!XO2/NO3
 KSPARSE(1, 437)=41
 KSPARSE(2, 437)=5
!XO2/OH
 KSPARSE(1, 438)=41
 KSPARSE(2, 438)=14
!XO2/HO2
 KSPARSE(1, 439)=41
 KSPARSE(2, 439)=15
!XO2/ALKE
 KSPARSE(1, 440)=41
 KSPARSE(2, 440)=19
!XO2/BIO
 KSPARSE(1, 441)=41
 KSPARSE(2, 441)=20
!XO2/ARO
 KSPARSE(1, 442)=41
 KSPARSE(2, 442)=21
!XO2/CARBO
 KSPARSE(1, 443)=41
 KSPARSE(2, 443)=25
!XO2/PAN
 KSPARSE(1, 444)=41
 KSPARSE(2, 444)=27
!XO2/OP2
 KSPARSE(1, 445)=41
 KSPARSE(2, 445)=29
!XO2/MO2
 KSPARSE(1, 446)=41
 KSPARSE(2, 446)=32
!XO2/ALKAP
 KSPARSE(1, 447)=41
 KSPARSE(2, 447)=33
!XO2/CARBOP
 KSPARSE(1, 448)=41
 KSPARSE(2, 448)=39
!XO2/XO2
 KSPARSE(1, 449)=41
 KSPARSE(2, 449)=41
KSPARSEDIM = 449
RETURN
END SUBROUTINE CH_SPARSE_GAZ
!
END SUBROUTINE CH_SPARSE
!
