!MNH_LIC Copyright 1994-2014 CNRS, Meteo-France and Universite Paul Sabatier
!MNH_LIC This is part of the Meso-NH software governed by the CeCILL-C licence
!MNH_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt  
!MNH_LIC for details. version 1.
!-----------------------------------------------------------------
!--------------- special set of characters for RCS information
!-----------------------------------------------------------------
! $Source$ $Revision$
! MASDEV4_7 init 2006/05/18 13:07:25
!-----------------------------------------------------------------
!     ###########################
      MODULE MODI_LIMA_READ_XKER_RACCS 
!     ###########################
!
INTERFACE
      SUBROUTINE LIMA_READ_XKER_RACCS (KACCLBDAS,KACCLBDAR,KND,                     &
                      PALPHAS,PNUS,PALPHAR,PNUR,PESR,PBS,PBR,PCS,PDS,PCR,PDR,  &
                      PACCLBDAS_MAX,PACCLBDAR_MAX,PACCLBDAS_MIN,PACCLBDAR_MIN, &
                      PFDINFTY,PKER_RACCSS,PKER_RACCS,PKER_SACCRG              )
!
INTEGER, INTENT(OUT) :: KND,KACCLBDAS,KACCLBDAR
REAL,    INTENT(OUT) :: PALPHAS
REAL,    INTENT(OUT) :: PNUS
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PESR
REAL,    INTENT(OUT) :: PBS
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCS
REAL,    INTENT(OUT) :: PDS
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PACCLBDAS_MAX
REAL,    INTENT(OUT) :: PACCLBDAR_MAX
REAL,    INTENT(OUT) :: PACCLBDAS_MIN
REAL,    INTENT(OUT) :: PACCLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RACCSS
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RACCS 
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_SACCRG
!
END SUBROUTINE LIMA_READ_XKER_RACCS
!
END INTERFACE
!
END MODULE MODI_LIMA_READ_XKER_RACCS
!     ##########################################################################
      SUBROUTINE LIMA_READ_XKER_RACCS (KACCLBDAS,KACCLBDAR,KND,                     &
                      PALPHAS,PNUS,PALPHAR,PNUR,PESR,PBS,PBR,PCS,PDS,PCR,PDR,  &
                      PACCLBDAS_MAX,PACCLBDAR_MAX,PACCLBDAS_MIN,PACCLBDAR_MIN, &
                      PFDINFTY,PKER_RACCSS,PKER_RACCS,PKER_SACCRG              )
!     ##########################################################################
!
!!****  * * - initialize the kernels for the rain-snow accretion process
!!
!!    PURPOSE
!!    -------
!!      The purpose of this routine is to initialize the kernels PKER_RACCSS,
!!    PKER_RACCS and PKER_SACCRG prepared from a previous run of the routine
!!    INI_RAIN_ICE. The reading of the kernels is optional after checking for
!!    the dimensions of the arrays.
!!
!!**  METHOD
!!    ------
!!      
!!
!!    EXTERNAL
!!    --------
!!      None
!!     
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!      None
!!
!!    REFERENCE
!!    ---------
!!      Book2 of documentation ( routine READ_XKER_RACCS )
!!
!!    AUTHOR
!!    ------
!!      J.-P. Pinty      * Laboratoire d'Aerologie*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    09/04/96
!!
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
!*       0.2   Declarations of local variables :
!
!  
INTEGER, INTENT(OUT) :: KND,KACCLBDAS,KACCLBDAR
REAL,    INTENT(OUT) :: PALPHAS
REAL,    INTENT(OUT) :: PNUS
REAL,    INTENT(OUT) :: PALPHAR
REAL,    INTENT(OUT) :: PNUR
REAL,    INTENT(OUT) :: PESR
REAL,    INTENT(OUT) :: PBS
REAL,    INTENT(OUT) :: PBR
REAL,    INTENT(OUT) :: PCS
REAL,    INTENT(OUT) :: PDS
REAL,    INTENT(OUT) :: PCR
REAL,    INTENT(OUT) :: PDR
REAL,    INTENT(OUT) :: PACCLBDAS_MAX
REAL,    INTENT(OUT) :: PACCLBDAR_MAX
REAL,    INTENT(OUT) :: PACCLBDAS_MIN
REAL,    INTENT(OUT) :: PACCLBDAR_MIN
REAL,    INTENT(OUT) :: PFDINFTY
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RACCSS
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_RACCS 
REAL, DIMENSION(:,:), INTENT(OUT), OPTIONAL :: PKER_SACCRG
!
! ###################################################################
! #INSERT HERE THE OUTPUT OF INI_RAIN_ICE IF THE KERNELS ARE UPDATED#
! ###################################################################
!
KND= 50
KACCLBDAS= 40
KACCLBDAR= 40
PALPHAS= 0.100000E+01
PNUS= 0.100000E+01
PALPHAR= 0.100000E+01
PNUR= 0.200000E+01
PESR= 0.100000E+01
PBS= 0.190000E+01
PBR= 0.300000E+01
PCS= 0.500000E+01
PDS= 0.270000E+00
PCR= 0.842000E+03
PDR= 0.800000E+00
PACCLBDAS_MAX= 0.500000E+06
PACCLBDAR_MAX= 0.100000E+08
PACCLBDAS_MIN= 0.500000E+02
PACCLBDAR_MIN= 0.100000E+04
PFDINFTY= 0.200000E+02
!
IF( PRESENT(PKER_RACCSS) ) THEN
  PKER_RACCSS(  1,  1) =  0.814109E+01
  PKER_RACCSS(  1,  2) =  0.692586E+01
  PKER_RACCSS(  1,  3) =  0.565192E+01
  PKER_RACCSS(  1,  4) =  0.444434E+01
  PKER_RACCSS(  1,  5) =  0.337172E+01
  PKER_RACCSS(  1,  6) =  0.246569E+01
  PKER_RACCSS(  1,  7) =  0.173757E+01
  PKER_RACCSS(  1,  8) =  0.119489E+01
  PKER_RACCSS(  1,  9) =  0.847828E+00
  PKER_RACCSS(  1, 10) =  0.697256E+00
  PKER_RACCSS(  1, 11) =  0.717816E+00
  PKER_RACCSS(  1, 12) =  0.854882E+00
  PKER_RACCSS(  1, 13) =  0.104470E+01
  PKER_RACCSS(  1, 14) =  0.123807E+01
  PKER_RACCSS(  1, 15) =  0.141081E+01
  PKER_RACCSS(  1, 16) =  0.155700E+01
  PKER_RACCSS(  1, 17) =  0.167856E+01
  PKER_RACCSS(  1, 18) =  0.177921E+01
  PKER_RACCSS(  1, 19) =  0.186250E+01
  PKER_RACCSS(  1, 20) =  0.193142E+01
  PKER_RACCSS(  1, 21) =  0.198845E+01
  PKER_RACCSS(  1, 22) =  0.203565E+01
  PKER_RACCSS(  1, 23) =  0.207472E+01
  PKER_RACCSS(  1, 24) =  0.210705E+01
  PKER_RACCSS(  1, 25) =  0.213381E+01
  PKER_RACCSS(  1, 26) =  0.215596E+01
  PKER_RACCSS(  1, 27) =  0.217429E+01
  PKER_RACCSS(  1, 28) =  0.218947E+01
  PKER_RACCSS(  1, 29) =  0.220203E+01
  PKER_RACCSS(  1, 30) =  0.221243E+01
  PKER_RACCSS(  1, 31) =  0.222103E+01
  PKER_RACCSS(  1, 32) =  0.222816E+01
  PKER_RACCSS(  1, 33) =  0.223406E+01
  PKER_RACCSS(  1, 34) =  0.223894E+01
  PKER_RACCSS(  1, 35) =  0.224298E+01
  PKER_RACCSS(  1, 36) =  0.224632E+01
  PKER_RACCSS(  1, 37) =  0.224909E+01
  PKER_RACCSS(  1, 38) =  0.225138E+01
  PKER_RACCSS(  1, 39) =  0.225328E+01
  PKER_RACCSS(  1, 40) =  0.225485E+01
  PKER_RACCSS(  2,  1) =  0.731793E+01
  PKER_RACCSS(  2,  2) =  0.650784E+01
  PKER_RACCSS(  2,  3) =  0.549484E+01
  PKER_RACCSS(  2,  4) =  0.443777E+01
  PKER_RACCSS(  2,  5) =  0.344045E+01
  PKER_RACCSS(  2,  6) =  0.256167E+01
  PKER_RACCSS(  2,  7) =  0.183252E+01
  PKER_RACCSS(  2,  8) =  0.126978E+01
  PKER_RACCSS(  2,  9) =  0.884187E+00
  PKER_RACCSS(  2, 10) =  0.682228E+00
  PKER_RACCSS(  2, 11) =  0.651607E+00
  PKER_RACCSS(  2, 12) =  0.749498E+00
  PKER_RACCSS(  2, 13) =  0.917050E+00
  PKER_RACCSS(  2, 14) =  0.110111E+01
  PKER_RACCSS(  2, 15) =  0.127111E+01
  PKER_RACCSS(  2, 16) =  0.141681E+01
  PKER_RACCSS(  2, 17) =  0.153841E+01
  PKER_RACCSS(  2, 18) =  0.163915E+01
  PKER_RACCSS(  2, 19) =  0.172252E+01
  PKER_RACCSS(  2, 20) =  0.179149E+01
  PKER_RACCSS(  2, 21) =  0.184857E+01
  PKER_RACCSS(  2, 22) =  0.189580E+01
  PKER_RACCSS(  2, 23) =  0.193488E+01
  PKER_RACCSS(  2, 24) =  0.196723E+01
  PKER_RACCSS(  2, 25) =  0.199401E+01
  PKER_RACCSS(  2, 26) =  0.201617E+01
  PKER_RACCSS(  2, 27) =  0.203451E+01
  PKER_RACCSS(  2, 28) =  0.204969E+01
  PKER_RACCSS(  2, 29) =  0.206226E+01
  PKER_RACCSS(  2, 30) =  0.207266E+01
  PKER_RACCSS(  2, 31) =  0.208127E+01
  PKER_RACCSS(  2, 32) =  0.208839E+01
  PKER_RACCSS(  2, 33) =  0.209429E+01
  PKER_RACCSS(  2, 34) =  0.209918E+01
  PKER_RACCSS(  2, 35) =  0.210322E+01
  PKER_RACCSS(  2, 36) =  0.210656E+01
  PKER_RACCSS(  2, 37) =  0.210933E+01
  PKER_RACCSS(  2, 38) =  0.211163E+01
  PKER_RACCSS(  2, 39) =  0.211352E+01
  PKER_RACCSS(  2, 40) =  0.211509E+01
  PKER_RACCSS(  3,  1) =  0.620923E+01
  PKER_RACCSS(  3,  2) =  0.585074E+01
  PKER_RACCSS(  3,  3) =  0.516881E+01
  PKER_RACCSS(  3,  4) =  0.432464E+01
  PKER_RACCSS(  3,  5) =  0.344908E+01
  PKER_RACCSS(  3,  6) =  0.262906E+01
  PKER_RACCSS(  3,  7) =  0.191653E+01
  PKER_RACCSS(  3,  8) =  0.134324E+01
  PKER_RACCSS(  3,  9) =  0.929224E+00
  PKER_RACCSS(  3, 10) =  0.684394E+00
  PKER_RACCSS(  3, 11) =  0.605038E+00
  PKER_RACCSS(  3, 12) =  0.661387E+00
  PKER_RACCSS(  3, 13) =  0.802622E+00
  PKER_RACCSS(  3, 14) =  0.974479E+00
  PKER_RACCSS(  3, 15) =  0.114040E+01
  PKER_RACCSS(  3, 16) =  0.128524E+01
  PKER_RACCSS(  3, 17) =  0.140682E+01
  PKER_RACCSS(  3, 18) =  0.150766E+01
  PKER_RACCSS(  3, 19) =  0.159112E+01
  PKER_RACCSS(  3, 20) =  0.166016E+01
  PKER_RACCSS(  3, 21) =  0.171729E+01
  PKER_RACCSS(  3, 22) =  0.176455E+01
  PKER_RACCSS(  3, 23) =  0.180367E+01
  PKER_RACCSS(  3, 24) =  0.183604E+01
  PKER_RACCSS(  3, 25) =  0.186283E+01
  PKER_RACCSS(  3, 26) =  0.188500E+01
  PKER_RACCSS(  3, 27) =  0.190335E+01
  PKER_RACCSS(  3, 28) =  0.191854E+01
  PKER_RACCSS(  3, 29) =  0.193111E+01
  PKER_RACCSS(  3, 30) =  0.194152E+01
  PKER_RACCSS(  3, 31) =  0.195013E+01
  PKER_RACCSS(  3, 32) =  0.195726E+01
  PKER_RACCSS(  3, 33) =  0.196316E+01
  PKER_RACCSS(  3, 34) =  0.196805E+01
  PKER_RACCSS(  3, 35) =  0.197209E+01
  PKER_RACCSS(  3, 36) =  0.197544E+01
  PKER_RACCSS(  3, 37) =  0.197821E+01
  PKER_RACCSS(  3, 38) =  0.198050E+01
  PKER_RACCSS(  3, 39) =  0.198240E+01
  PKER_RACCSS(  3, 40) =  0.198397E+01
  PKER_RACCSS(  4,  1) =  0.489412E+01
  PKER_RACCSS(  4,  2) =  0.496003E+01
  PKER_RACCSS(  4,  3) =  0.464691E+01
  PKER_RACCSS(  4,  4) =  0.407266E+01
  PKER_RACCSS(  4,  5) =  0.337005E+01
  PKER_RACCSS(  4,  6) =  0.264746E+01
  PKER_RACCSS(  4,  7) =  0.197888E+01
  PKER_RACCSS(  4,  8) =  0.141145E+01
  PKER_RACCSS(  4,  9) =  0.977676E+00
  PKER_RACCSS(  4, 10) =  0.697624E+00
  PKER_RACCSS(  4, 11) =  0.574725E+00
  PKER_RACCSS(  4, 12) =  0.590243E+00
  PKER_RACCSS(  4, 13) =  0.701865E+00
  PKER_RACCSS(  4, 14) =  0.858232E+00
  PKER_RACCSS(  4, 15) =  0.101841E+01
  PKER_RACCSS(  4, 16) =  0.116181E+01
  PKER_RACCSS(  4, 17) =  0.128324E+01
  PKER_RACCSS(  4, 18) =  0.138420E+01
  PKER_RACCSS(  4, 19) =  0.146776E+01
  PKER_RACCSS(  4, 20) =  0.153689E+01
  PKER_RACCSS(  4, 21) =  0.159407E+01
  PKER_RACCSS(  4, 22) =  0.164139E+01
  PKER_RACCSS(  4, 23) =  0.168054E+01
  PKER_RACCSS(  4, 24) =  0.171293E+01
  PKER_RACCSS(  4, 25) =  0.173974E+01
  PKER_RACCSS(  4, 26) =  0.176193E+01
  PKER_RACCSS(  4, 27) =  0.178029E+01
  PKER_RACCSS(  4, 28) =  0.179549E+01
  PKER_RACCSS(  4, 29) =  0.180807E+01
  PKER_RACCSS(  4, 30) =  0.181848E+01
  PKER_RACCSS(  4, 31) =  0.182709E+01
  PKER_RACCSS(  4, 32) =  0.183423E+01
  PKER_RACCSS(  4, 33) =  0.184013E+01
  PKER_RACCSS(  4, 34) =  0.184502E+01
  PKER_RACCSS(  4, 35) =  0.184906E+01
  PKER_RACCSS(  4, 36) =  0.185241E+01
  PKER_RACCSS(  4, 37) =  0.185518E+01
  PKER_RACCSS(  4, 38) =  0.185747E+01
  PKER_RACCSS(  4, 39) =  0.185937E+01
  PKER_RACCSS(  4, 40) =  0.186094E+01
  PKER_RACCSS(  5,  1) =  0.352472E+01
  PKER_RACCSS(  5,  2) =  0.390184E+01
  PKER_RACCSS(  5,  3) =  0.393452E+01
  PKER_RACCSS(  5,  4) =  0.366051E+01
  PKER_RACCSS(  5,  5) =  0.317719E+01
  PKER_RACCSS(  5,  6) =  0.259404E+01
  PKER_RACCSS(  5,  7) =  0.200191E+01
  PKER_RACCSS(  5,  8) =  0.146469E+01
  PKER_RACCSS(  5,  9) =  0.102673E+01
  PKER_RACCSS(  5, 10) =  0.718755E+00
  PKER_RACCSS(  5, 11) =  0.556693E+00
  PKER_RACCSS(  5, 12) =  0.533409E+00
  PKER_RACCSS(  5, 13) =  0.614372E+00
  PKER_RACCSS(  5, 14) =  0.752546E+00
  PKER_RACCSS(  5, 15) =  0.904981E+00
  PKER_RACCSS(  5, 16) =  0.104611E+01
  PKER_RACCSS(  5, 17) =  0.116720E+01
  PKER_RACCSS(  5, 18) =  0.126824E+01
  PKER_RACCSS(  5, 19) =  0.135194E+01
  PKER_RACCSS(  5, 20) =  0.142116E+01
  PKER_RACCSS(  5, 21) =  0.147842E+01
  PKER_RACCSS(  5, 22) =  0.152579E+01
  PKER_RACCSS(  5, 23) =  0.156498E+01
  PKER_RACCSS(  5, 24) =  0.159741E+01
  PKER_RACCSS(  5, 25) =  0.162424E+01
  PKER_RACCSS(  5, 26) =  0.164644E+01
  PKER_RACCSS(  5, 27) =  0.166482E+01
  PKER_RACCSS(  5, 28) =  0.168003E+01
  PKER_RACCSS(  5, 29) =  0.169261E+01
  PKER_RACCSS(  5, 30) =  0.170303E+01
  PKER_RACCSS(  5, 31) =  0.171165E+01
  PKER_RACCSS(  5, 32) =  0.171879E+01
  PKER_RACCSS(  5, 33) =  0.172469E+01
  PKER_RACCSS(  5, 34) =  0.172958E+01
  PKER_RACCSS(  5, 35) =  0.173363E+01
  PKER_RACCSS(  5, 36) =  0.173698E+01
  PKER_RACCSS(  5, 37) =  0.173975E+01
  PKER_RACCSS(  5, 38) =  0.174205E+01
  PKER_RACCSS(  5, 39) =  0.174395E+01
  PKER_RACCSS(  5, 40) =  0.174552E+01
  PKER_RACCSS(  6,  1) =  0.228210E+01
  PKER_RACCSS(  6,  2) =  0.280066E+01
  PKER_RACCSS(  6,  3) =  0.308657E+01
  PKER_RACCSS(  6,  4) =  0.309355E+01
  PKER_RACCSS(  6,  5) =  0.285370E+01
  PKER_RACCSS(  6,  6) =  0.244776E+01
  PKER_RACCSS(  6,  7) =  0.196661E+01
  PKER_RACCSS(  6,  8) =  0.148740E+01
  PKER_RACCSS(  6,  9) =  0.106708E+01
  PKER_RACCSS(  6, 10) =  0.746205E+00
  PKER_RACCSS(  6, 11) =  0.551114E+00
  PKER_RACCSS(  6, 12) =  0.488949E+00
  PKER_RACCSS(  6, 13) =  0.538117E+00
  PKER_RACCSS(  6, 14) =  0.656577E+00
  PKER_RACCSS(  6, 15) =  0.799740E+00
  PKER_RACCSS(  6, 16) =  0.937749E+00
  PKER_RACCSS(  6, 17) =  0.105821E+01
  PKER_RACCSS(  6, 18) =  0.115932E+01
  PKER_RACCSS(  6, 19) =  0.124316E+01
  PKER_RACCSS(  6, 20) =  0.131250E+01
  PKER_RACCSS(  6, 21) =  0.136985E+01
  PKER_RACCSS(  6, 22) =  0.141729E+01
  PKER_RACCSS(  6, 23) =  0.145653E+01
  PKER_RACCSS(  6, 24) =  0.148899E+01
  PKER_RACCSS(  6, 25) =  0.151585E+01
  PKER_RACCSS(  6, 26) =  0.153808E+01
  PKER_RACCSS(  6, 27) =  0.155647E+01
  PKER_RACCSS(  6, 28) =  0.157169E+01
  PKER_RACCSS(  6, 29) =  0.158429E+01
  PKER_RACCSS(  6, 30) =  0.159471E+01
  PKER_RACCSS(  6, 31) =  0.160334E+01
  PKER_RACCSS(  6, 32) =  0.161048E+01
  PKER_RACCSS(  6, 33) =  0.161639E+01
  PKER_RACCSS(  6, 34) =  0.162128E+01
  PKER_RACCSS(  6, 35) =  0.162533E+01
  PKER_RACCSS(  6, 36) =  0.162868E+01
  PKER_RACCSS(  6, 37) =  0.163145E+01
  PKER_RACCSS(  6, 38) =  0.163375E+01
  PKER_RACCSS(  6, 39) =  0.163565E+01
  PKER_RACCSS(  6, 40) =  0.163722E+01
  PKER_RACCSS(  7,  1) =  0.148782E+01
  PKER_RACCSS(  7,  2) =  0.200771E+01
  PKER_RACCSS(  7,  3) =  0.220555E+01
  PKER_RACCSS(  7,  4) =  0.241780E+01
  PKER_RACCSS(  7,  5) =  0.240508E+01
  PKER_RACCSS(  7,  6) =  0.219547E+01
  PKER_RACCSS(  7,  7) =  0.185621E+01
  PKER_RACCSS(  7,  8) =  0.146365E+01
  PKER_RACCSS(  7,  9) =  0.108448E+01
  PKER_RACCSS(  7, 10) =  0.770204E+00
  PKER_RACCSS(  7, 11) =  0.556115E+00
  PKER_RACCSS(  7, 12) =  0.459612E+00
  PKER_RACCSS(  7, 13) =  0.474417E+00
  PKER_RACCSS(  7, 14) =  0.568754E+00
  PKER_RACCSS(  7, 15) =  0.700250E+00
  PKER_RACCSS(  7, 16) =  0.834630E+00
  PKER_RACCSS(  7, 17) =  0.954778E+00
  PKER_RACCSS(  7, 18) =  0.105642E+01
  PKER_RACCSS(  7, 19) =  0.114078E+01
  PKER_RACCSS(  7, 20) =  0.121042E+01
  PKER_RACCSS(  7, 21) =  0.126792E+01
  PKER_RACCSS(  7, 22) =  0.131544E+01
  PKER_RACCSS(  7, 23) =  0.135474E+01
  PKER_RACCSS(  7, 24) =  0.138724E+01
  PKER_RACCSS(  7, 25) =  0.141414E+01
  PKER_RACCSS(  7, 26) =  0.143639E+01
  PKER_RACCSS(  7, 27) =  0.145480E+01
  PKER_RACCSS(  7, 28) =  0.147003E+01
  PKER_RACCSS(  7, 29) =  0.148264E+01
  PKER_RACCSS(  7, 30) =  0.149307E+01
  PKER_RACCSS(  7, 31) =  0.150171E+01
  PKER_RACCSS(  7, 32) =  0.150885E+01
  PKER_RACCSS(  7, 33) =  0.151477E+01
  PKER_RACCSS(  7, 34) =  0.151966E+01
  PKER_RACCSS(  7, 35) =  0.152372E+01
  PKER_RACCSS(  7, 36) =  0.152707E+01
  PKER_RACCSS(  7, 37) =  0.152984E+01
  PKER_RACCSS(  7, 38) =  0.153214E+01
  PKER_RACCSS(  7, 39) =  0.153404E+01
  PKER_RACCSS(  7, 40) =  0.153562E+01
  PKER_RACCSS(  8,  1) =  0.262435E+01
  PKER_RACCSS(  8,  2) =  0.238666E+01
  PKER_RACCSS(  8,  3) =  0.233673E+01
  PKER_RACCSS(  8,  4) =  0.234057E+01
  PKER_RACCSS(  8,  5) =  0.228742E+01
  PKER_RACCSS(  8,  6) =  0.212164E+01
  PKER_RACCSS(  8,  7) =  0.184665E+01
  PKER_RACCSS(  8,  8) =  0.150391E+01
  PKER_RACCSS(  8,  9) =  0.114827E+01
  PKER_RACCSS(  8, 10) =  0.831674E+00
  PKER_RACCSS(  8, 11) =  0.595148E+00
  PKER_RACCSS(  8, 12) =  0.463804E+00
  PKER_RACCSS(  8, 13) =  0.440716E+00
  PKER_RACCSS(  8, 14) =  0.503716E+00
  PKER_RACCSS(  8, 15) =  0.616434E+00
  PKER_RACCSS(  8, 16) =  0.742493E+00
  PKER_RACCSS(  8, 17) =  0.859895E+00
  PKER_RACCSS(  8, 18) =  0.960763E+00
  PKER_RACCSS(  8, 19) =  0.104493E+01
  PKER_RACCSS(  8, 20) =  0.111460E+01
  PKER_RACCSS(  8, 21) =  0.117219E+01
  PKER_RACCSS(  8, 22) =  0.121981E+01
  PKER_RACCSS(  8, 23) =  0.125918E+01
  PKER_RACCSS(  8, 24) =  0.129174E+01
  PKER_RACCSS(  8, 25) =  0.131868E+01
  PKER_RACCSS(  8, 26) =  0.134096E+01
  PKER_RACCSS(  8, 27) =  0.135939E+01
  PKER_RACCSS(  8, 28) =  0.137465E+01
  PKER_RACCSS(  8, 29) =  0.138727E+01
  PKER_RACCSS(  8, 30) =  0.139771E+01
  PKER_RACCSS(  8, 31) =  0.140635E+01
  PKER_RACCSS(  8, 32) =  0.141350E+01
  PKER_RACCSS(  8, 33) =  0.141942E+01
  PKER_RACCSS(  8, 34) =  0.142432E+01
  PKER_RACCSS(  8, 35) =  0.142838E+01
  PKER_RACCSS(  8, 36) =  0.143173E+01
  PKER_RACCSS(  8, 37) =  0.143451E+01
  PKER_RACCSS(  8, 38) =  0.143681E+01
  PKER_RACCSS(  8, 39) =  0.143871E+01
  PKER_RACCSS(  8, 40) =  0.144029E+01
  PKER_RACCSS(  9,  1) =  0.258564E+01
  PKER_RACCSS(  9,  2) =  0.212607E+01
  PKER_RACCSS(  9,  3) =  0.191008E+01
  PKER_RACCSS(  9,  4) =  0.184553E+01
  PKER_RACCSS(  9,  5) =  0.182496E+01
  PKER_RACCSS(  9,  6) =  0.176067E+01
  PKER_RACCSS(  9,  7) =  0.160989E+01
  PKER_RACCSS(  9,  8) =  0.137709E+01
  PKER_RACCSS(  9,  9) =  0.109833E+01
  PKER_RACCSS(  9, 10) =  0.821651E+00
  PKER_RACCSS(  9, 11) =  0.593004E+00
  PKER_RACCSS(  9, 12) =  0.447502E+00
  PKER_RACCSS(  9, 13) =  0.400378E+00
  PKER_RACCSS(  9, 14) =  0.440619E+00
  PKER_RACCSS(  9, 15) =  0.537296E+00
  PKER_RACCSS(  9, 16) =  0.655296E+00
  PKER_RACCSS(  9, 17) =  0.769925E+00
  PKER_RACCSS(  9, 18) =  0.870332E+00
  PKER_RACCSS(  9, 19) =  0.954640E+00
  PKER_RACCSS(  9, 20) =  0.102452E+01
  PKER_RACCSS(  9, 21) =  0.108227E+01
  PKER_RACCSS(  9, 22) =  0.113001E+01
  PKER_RACCSS(  9, 23) =  0.116947E+01
  PKER_RACCSS(  9, 24) =  0.120209E+01
  PKER_RACCSS(  9, 25) =  0.122908E+01
  PKER_RACCSS(  9, 26) =  0.125140E+01
  PKER_RACCSS(  9, 27) =  0.126986E+01
  PKER_RACCSS(  9, 28) =  0.128513E+01
  PKER_RACCSS(  9, 29) =  0.129777E+01
  PKER_RACCSS(  9, 30) =  0.130823E+01
  PKER_RACCSS(  9, 31) =  0.131688E+01
  PKER_RACCSS(  9, 32) =  0.132404E+01
  PKER_RACCSS(  9, 33) =  0.132996E+01
  PKER_RACCSS(  9, 34) =  0.133487E+01
  PKER_RACCSS(  9, 35) =  0.133892E+01
  PKER_RACCSS(  9, 36) =  0.134228E+01
  PKER_RACCSS(  9, 37) =  0.134506E+01
  PKER_RACCSS(  9, 38) =  0.134736E+01
  PKER_RACCSS(  9, 39) =  0.134927E+01
  PKER_RACCSS(  9, 40) =  0.135084E+01
  PKER_RACCSS( 10,  1) =  0.326941E+01
  PKER_RACCSS( 10,  2) =  0.247738E+01
  PKER_RACCSS( 10,  3) =  0.198894E+01
  PKER_RACCSS( 10,  4) =  0.173769E+01
  PKER_RACCSS( 10,  5) =  0.163096E+01
  PKER_RACCSS( 10,  6) =  0.156919E+01
  PKER_RACCSS( 10,  7) =  0.147478E+01
  PKER_RACCSS( 10,  8) =  0.119527E+01
  PKER_RACCSS( 10,  9) =  0.100108E+01
  PKER_RACCSS( 10, 10) =  0.781320E+00
  PKER_RACCSS( 10, 11) =  0.578296E+00
  PKER_RACCSS( 10, 12) =  0.430609E+00
  PKER_RACCSS( 10, 13) =  0.363116E+00
  PKER_RACCSS( 10, 14) =  0.377933E+00
  PKER_RACCSS( 10, 15) =  0.453999E+00
  PKER_RACCSS( 10, 16) =  0.559195E+00
  PKER_RACCSS( 10, 17) =  0.666791E+00
  PKER_RACCSS( 10, 18) =  0.764030E+00
  PKER_RACCSS( 10, 19) =  0.848611E+00
  PKER_RACCSS( 10, 20) =  0.922036E+00
  PKER_RACCSS( 10, 21) =  0.985589E+00
  PKER_RACCSS( 10, 22) =  0.103929E+01
  PKER_RACCSS( 10, 23) =  0.108289E+01
  PKER_RACCSS( 10, 24) =  0.111739E+01
  PKER_RACCSS( 10, 25) =  0.114490E+01
  PKER_RACCSS( 10, 26) =  0.116733E+01
  PKER_RACCSS( 10, 27) =  0.118583E+01
  PKER_RACCSS( 10, 28) =  0.120113E+01
  PKER_RACCSS( 10, 29) =  0.121379E+01
  PKER_RACCSS( 10, 30) =  0.122426E+01
  PKER_RACCSS( 10, 31) =  0.123292E+01
  PKER_RACCSS( 10, 32) =  0.124009E+01
  PKER_RACCSS( 10, 33) =  0.124602E+01
  PKER_RACCSS( 10, 34) =  0.125093E+01
  PKER_RACCSS( 10, 35) =  0.125500E+01
  PKER_RACCSS( 10, 36) =  0.125836E+01
  PKER_RACCSS( 10, 37) =  0.126114E+01
  PKER_RACCSS( 10, 38) =  0.126344E+01
  PKER_RACCSS( 10, 39) =  0.126535E+01
  PKER_RACCSS( 10, 40) =  0.126692E+01
  PKER_RACCSS( 11,  1) =  0.540047E+01
  PKER_RACCSS( 11,  2) =  0.406788E+01
  PKER_RACCSS( 11,  3) =  0.307616E+01
  PKER_RACCSS( 11,  4) =  0.238233E+01
  PKER_RACCSS( 11,  5) =  0.192893E+01
  PKER_RACCSS( 11,  6) =  0.164024E+01
  PKER_RACCSS( 11,  7) =  0.143525E+01
  PKER_RACCSS( 11,  8) =  0.124898E+01
  PKER_RACCSS( 11,  9) =  0.104781E+01
  PKER_RACCSS( 11, 10) =  0.832136E+00
  PKER_RACCSS( 11, 11) =  0.625559E+00
  PKER_RACCSS( 11, 12) =  0.461096E+00
  PKER_RACCSS( 11, 13) =  0.367093E+00
  PKER_RACCSS( 11, 14) =  0.353793E+00
  PKER_RACCSS( 11, 15) =  0.408329E+00
  PKER_RACCSS( 11, 16) =  0.502430E+00
  PKER_RACCSS( 11, 17) =  0.607438E+00
  PKER_RACCSS( 11, 18) =  0.705454E+00
  PKER_RACCSS( 11, 19) =  0.789792E+00
  PKER_RACCSS( 11, 20) =  0.860149E+00
  PKER_RACCSS( 11, 21) =  0.918336E+00
  PKER_RACCSS( 11, 22) =  0.966393E+00
  PKER_RACCSS( 11, 23) =  0.100609E+01
  PKER_RACCSS( 11, 24) =  0.103890E+01
  PKER_RACCSS( 11, 25) =  0.106601E+01
  PKER_RACCSS( 11, 26) =  0.108843E+01
  PKER_RACCSS( 11, 27) =  0.110696E+01
  PKER_RACCSS( 11, 28) =  0.112230E+01
  PKER_RACCSS( 11, 29) =  0.113498E+01
  PKER_RACCSS( 11, 30) =  0.114547E+01
  PKER_RACCSS( 11, 31) =  0.115414E+01
  PKER_RACCSS( 11, 32) =  0.116132E+01
  PKER_RACCSS( 11, 33) =  0.116726E+01
  PKER_RACCSS( 11, 34) =  0.117218E+01
  PKER_RACCSS( 11, 35) =  0.117625E+01
  PKER_RACCSS( 11, 36) =  0.117961E+01
  PKER_RACCSS( 11, 37) =  0.118240E+01
  PKER_RACCSS( 11, 38) =  0.118470E+01
  PKER_RACCSS( 11, 39) =  0.118661E+01
  PKER_RACCSS( 11, 40) =  0.118819E+01
  PKER_RACCSS( 12,  1) =  0.782212E+01
  PKER_RACCSS( 12,  2) =  0.599420E+01
  PKER_RACCSS( 12,  3) =  0.455236E+01
  PKER_RACCSS( 12,  4) =  0.345125E+01
  PKER_RACCSS( 12,  5) =  0.264475E+01
  PKER_RACCSS( 12,  6) =  0.207701E+01
  PKER_RACCSS( 12,  7) =  0.168031E+01
  PKER_RACCSS( 12,  8) =  0.138445E+01
  PKER_RACCSS( 12,  9) =  0.113395E+01
  PKER_RACCSS( 12, 10) =  0.900399E+00
  PKER_RACCSS( 12, 11) =  0.683291E+00
  PKER_RACCSS( 12, 12) =  0.501952E+00
  PKER_RACCSS( 12, 13) =  0.380903E+00
  PKER_RACCSS( 12, 14) =  0.335581E+00
  PKER_RACCSS( 12, 15) =  0.362162E+00
  PKER_RACCSS( 12, 16) =  0.438221E+00
  PKER_RACCSS( 12, 17) =  0.534996E+00
  PKER_RACCSS( 12, 18) =  0.630498E+00
  PKER_RACCSS( 12, 19) =  0.714544E+00
  PKER_RACCSS( 12, 20) =  0.785149E+00
  PKER_RACCSS( 12, 21) =  0.843614E+00
  PKER_RACCSS( 12, 22) =  0.891886E+00
  PKER_RACCSS( 12, 23) =  0.931743E+00
  PKER_RACCSS( 12, 24) =  0.964664E+00
  PKER_RACCSS( 12, 25) =  0.991866E+00
  PKER_RACCSS( 12, 26) =  0.101435E+01
  PKER_RACCSS( 12, 27) =  0.103293E+01
  PKER_RACCSS( 12, 28) =  0.104830E+01
  PKER_RACCSS( 12, 29) =  0.106101E+01
  PKER_RACCSS( 12, 30) =  0.107152E+01
  PKER_RACCSS( 12, 31) =  0.108022E+01
  PKER_RACCSS( 12, 32) =  0.108741E+01
  PKER_RACCSS( 12, 33) =  0.109336E+01
  PKER_RACCSS( 12, 34) =  0.109828E+01
  PKER_RACCSS( 12, 35) =  0.110236E+01
  PKER_RACCSS( 12, 36) =  0.110573E+01
  PKER_RACCSS( 12, 37) =  0.110852E+01
  PKER_RACCSS( 12, 38) =  0.111082E+01
  PKER_RACCSS( 12, 39) =  0.111273E+01
  PKER_RACCSS( 12, 40) =  0.111431E+01
  PKER_RACCSS( 13,  1) =  0.981788E+01
  PKER_RACCSS( 13,  2) =  0.766217E+01
  PKER_RACCSS( 13,  3) =  0.591544E+01
  PKER_RACCSS( 13,  4) =  0.452414E+01
  PKER_RACCSS( 13,  5) =  0.344339E+01
  PKER_RACCSS( 13,  6) =  0.262943E+01
  PKER_RACCSS( 13,  7) =  0.203218E+01
  PKER_RACCSS( 13,  8) =  0.159445E+01
  PKER_RACCSS( 13,  9) =  0.125920E+01
  PKER_RACCSS( 13, 10) =  0.982700E+00
  PKER_RACCSS( 13, 11) =  0.743668E+00
  PKER_RACCSS( 13, 12) =  0.544085E+00
  PKER_RACCSS( 13, 13) =  0.399552E+00
  PKER_RACCSS( 13, 14) =  0.325874E+00
  PKER_RACCSS( 13, 15) =  0.325287E+00
  PKER_RACCSS( 13, 16) =  0.381940E+00
  PKER_RACCSS( 13, 17) =  0.468486E+00
  PKER_RACCSS( 13, 18) =  0.560310E+00
  PKER_RACCSS( 13, 19) =  0.643677E+00
  PKER_RACCSS( 13, 20) =  0.714489E+00
  PKER_RACCSS( 13, 21) =  0.773275E+00
  PKER_RACCSS( 13, 22) =  0.821809E+00
  PKER_RACCSS( 13, 23) =  0.861858E+00
  PKER_RACCSS( 13, 24) =  0.894921E+00
  PKER_RACCSS( 13, 25) =  0.922229E+00
  PKER_RACCSS( 13, 26) =  0.944790E+00
  PKER_RACCSS( 13, 27) =  0.963435E+00
  PKER_RACCSS( 13, 28) =  0.978848E+00
  PKER_RACCSS( 13, 29) =  0.991591E+00
  PKER_RACCSS( 13, 30) =  0.100213E+01
  PKER_RACCSS( 13, 31) =  0.101084E+01
  PKER_RACCSS( 13, 32) =  0.101805E+01
  PKER_RACCSS( 13, 33) =  0.102401E+01
  PKER_RACCSS( 13, 34) =  0.102895E+01
  PKER_RACCSS( 13, 35) =  0.103303E+01
  PKER_RACCSS( 13, 36) =  0.103640E+01
  PKER_RACCSS( 13, 37) =  0.103920E+01
  PKER_RACCSS( 13, 38) =  0.104151E+01
  PKER_RACCSS( 13, 39) =  0.104342E+01
  PKER_RACCSS( 13, 40) =  0.104500E+01
  PKER_RACCSS( 14,  1) =  0.113567E+02
  PKER_RACCSS( 14,  2) =  0.899336E+01
  PKER_RACCSS( 14,  3) =  0.705312E+01
  PKER_RACCSS( 14,  4) =  0.547412E+01
  PKER_RACCSS( 14,  5) =  0.420687E+01
  PKER_RACCSS( 14,  6) =  0.320973E+01
  PKER_RACCSS( 14,  7) =  0.244303E+01
  PKER_RACCSS( 14,  8) =  0.186415E+01
  PKER_RACCSS( 14,  9) =  0.142646E+01
  PKER_RACCSS( 14, 10) =  0.108627E+01
  PKER_RACCSS( 14, 11) =  0.811450E+00
  PKER_RACCSS( 14, 12) =  0.588974E+00
  PKER_RACCSS( 14, 13) =  0.422701E+00
  PKER_RACCSS( 14, 14) =  0.323861E+00
  PKER_RACCSS( 14, 15) =  0.298012E+00
  PKER_RACCSS( 14, 16) =  0.334007E+00
  PKER_RACCSS( 14, 17) =  0.408204E+00
  PKER_RACCSS( 14, 18) =  0.494846E+00
  PKER_RACCSS( 14, 19) =  0.576947E+00
  PKER_RACCSS( 14, 20) =  0.647860E+00
  PKER_RACCSS( 14, 21) =  0.707002E+00
  PKER_RACCSS( 14, 22) =  0.755849E+00
  PKER_RACCSS( 14, 23) =  0.796134E+00
  PKER_RACCSS( 14, 24) =  0.829370E+00
  PKER_RACCSS( 14, 25) =  0.856805E+00
  PKER_RACCSS( 14, 26) =  0.879461E+00
  PKER_RACCSS( 14, 27) =  0.898178E+00
  PKER_RACCSS( 14, 28) =  0.913645E+00
  PKER_RACCSS( 14, 29) =  0.926429E+00
  PKER_RACCSS( 14, 30) =  0.936998E+00
  PKER_RACCSS( 14, 31) =  0.945737E+00
  PKER_RACCSS( 14, 32) =  0.952964E+00
  PKER_RACCSS( 14, 33) =  0.958941E+00
  PKER_RACCSS( 14, 34) =  0.963884E+00
  PKER_RACCSS( 14, 35) =  0.967974E+00
  PKER_RACCSS( 14, 36) =  0.971357E+00
  PKER_RACCSS( 14, 37) =  0.974155E+00
  PKER_RACCSS( 14, 38) =  0.976471E+00
  PKER_RACCSS( 14, 39) =  0.978386E+00
  PKER_RACCSS( 14, 40) =  0.979971E+00
  PKER_RACCSS( 15,  1) =  0.124924E+02
  PKER_RACCSS( 15,  2) =  0.100003E+02
  PKER_RACCSS( 15,  3) =  0.794169E+01
  PKER_RACCSS( 15,  4) =  0.624828E+01
  PKER_RACCSS( 15,  5) =  0.486528E+01
  PKER_RACCSS( 15,  6) =  0.374844E+01
  PKER_RACCSS( 15,  7) =  0.286039E+01
  PKER_RACCSS( 15,  8) =  0.216647E+01
  PKER_RACCSS( 15,  9) =  0.163111E+01
  PKER_RACCSS( 15, 10) =  0.121825E+01
  PKER_RACCSS( 15, 11) =  0.895737E+00
  PKER_RACCSS( 15, 12) =  0.642706E+00
  PKER_RACCSS( 15, 13) =  0.452742E+00
  PKER_RACCSS( 15, 14) =  0.330032E+00
  PKER_RACCSS( 15, 15) =  0.279351E+00
  PKER_RACCSS( 15, 16) =  0.294228E+00
  PKER_RACCSS( 15, 17) =  0.354314E+00
  PKER_RACCSS( 15, 18) =  0.434176E+00
  PKER_RACCSS( 15, 19) =  0.514178E+00
  PKER_RACCSS( 15, 20) =  0.584975E+00
  PKER_RACCSS( 15, 21) =  0.644491E+00
  PKER_RACCSS( 15, 22) =  0.693710E+00
  PKER_RACCSS( 15, 23) =  0.734280E+00
  PKER_RACCSS( 15, 24) =  0.767726E+00
  PKER_RACCSS( 15, 25) =  0.795316E+00
  PKER_RACCSS( 15, 26) =  0.818088E+00
  PKER_RACCSS( 15, 27) =  0.836891E+00
  PKER_RACCSS( 15, 28) =  0.852423E+00
  PKER_RACCSS( 15, 29) =  0.865256E+00
  PKER_RACCSS( 15, 30) =  0.875863E+00
  PKER_RACCSS( 15, 31) =  0.884631E+00
  PKER_RACCSS( 15, 32) =  0.891880E+00
  PKER_RACCSS( 15, 33) =  0.897874E+00
  PKER_RACCSS( 15, 34) =  0.902831E+00
  PKER_RACCSS( 15, 35) =  0.906930E+00
  PKER_RACCSS( 15, 36) =  0.910321E+00
  PKER_RACCSS( 15, 37) =  0.913126E+00
  PKER_RACCSS( 15, 38) =  0.915447E+00
  PKER_RACCSS( 15, 39) =  0.917366E+00
  PKER_RACCSS( 15, 40) =  0.918954E+00
  PKER_RACCSS( 16,  1) =  0.136907E+02
  PKER_RACCSS( 16,  2) =  0.110657E+02
  PKER_RACCSS( 16,  3) =  0.889092E+01
  PKER_RACCSS( 16,  4) =  0.709169E+01
  PKER_RACCSS( 16,  5) =  0.560750E+01
  PKER_RACCSS( 16,  6) =  0.438940E+01
  PKER_RACCSS( 16,  7) =  0.339760E+01
  PKER_RACCSS( 16,  8) =  0.259872E+01
  PKER_RACCSS( 16,  9) =  0.196266E+01
  PKER_RACCSS( 16, 10) =  0.146081E+01
  PKER_RACCSS( 16, 11) =  0.106641E+01
  PKER_RACCSS( 16, 12) =  0.758348E+00
  PKER_RACCSS( 16, 13) =  0.524888E+00
  PKER_RACCSS( 16, 14) =  0.364964E+00
  PKER_RACCSS( 16, 15) =  0.280630E+00
  PKER_RACCSS( 16, 16) =  0.267498E+00
  PKER_RACCSS( 16, 17) =  0.308591E+00
  PKER_RACCSS( 16, 18) =  0.378682E+00
  PKER_RACCSS( 16, 19) =  0.455284E+00
  PKER_RACCSS( 16, 20) =  0.525585E+00
  PKER_RACCSS( 16, 21) =  0.585451E+00
  PKER_RACCSS( 16, 22) =  0.635103E+00
  PKER_RACCSS( 16, 23) =  0.676018E+00
  PKER_RACCSS( 16, 24) =  0.709719E+00
  PKER_RACCSS( 16, 25) =  0.737497E+00
  PKER_RACCSS( 16, 26) =  0.760408E+00
  PKER_RACCSS( 16, 27) =  0.779316E+00
  PKER_RACCSS( 16, 28) =  0.794926E+00
  PKER_RACCSS( 16, 29) =  0.807819E+00
  PKER_RACCSS( 16, 30) =  0.818471E+00
  PKER_RACCSS( 16, 31) =  0.827273E+00
  PKER_RACCSS( 16, 32) =  0.834549E+00
  PKER_RACCSS( 16, 33) =  0.840564E+00
  PKER_RACCSS( 16, 34) =  0.845537E+00
  PKER_RACCSS( 16, 35) =  0.849649E+00
  PKER_RACCSS( 16, 36) =  0.853049E+00
  PKER_RACCSS( 16, 37) =  0.855862E+00
  PKER_RACCSS( 16, 38) =  0.858188E+00
  PKER_RACCSS( 16, 39) =  0.860112E+00
  PKER_RACCSS( 16, 40) =  0.861704E+00
  PKER_RACCSS( 17,  1) =  0.143219E+02
  PKER_RACCSS( 17,  2) =  0.116425E+02
  PKER_RACCSS( 17,  3) =  0.942087E+01
  PKER_RACCSS( 17,  4) =  0.757943E+01
  PKER_RACCSS( 17,  5) =  0.605456E+01
  PKER_RACCSS( 17,  6) =  0.479437E+01
  PKER_RACCSS( 17,  7) =  0.375669E+01
  PKER_RACCSS( 17,  8) =  0.290705E+01
  PKER_RACCSS( 17,  9) =  0.221663E+01
  PKER_RACCSS( 17, 10) =  0.166050E+01
  PKER_RACCSS( 17, 11) =  0.121648E+01
  PKER_RACCSS( 17, 12) =  0.866211E+00
  PKER_RACCSS( 17, 13) =  0.597261E+00
  PKER_RACCSS( 17, 14) =  0.405300E+00
  PKER_RACCSS( 17, 15) =  0.290505E+00
  PKER_RACCSS( 17, 16) =  0.250047E+00
  PKER_RACCSS( 17, 17) =  0.270435E+00
  PKER_RACCSS( 17, 18) =  0.328579E+00
  PKER_RACCSS( 17, 19) =  0.400271E+00
  PKER_RACCSS( 17, 20) =  0.469487E+00
  PKER_RACCSS( 17, 21) =  0.529608E+00
  PKER_RACCSS( 17, 22) =  0.579747E+00
  PKER_RACCSS( 17, 23) =  0.621077E+00
  PKER_RACCSS( 17, 24) =  0.655088E+00
  PKER_RACCSS( 17, 25) =  0.683095E+00
  PKER_RACCSS( 17, 26) =  0.706175E+00
  PKER_RACCSS( 17, 27) =  0.725209E+00
  PKER_RACCSS( 17, 28) =  0.740914E+00
  PKER_RACCSS( 17, 29) =  0.753878E+00
  PKER_RACCSS( 17, 30) =  0.764585E+00
  PKER_RACCSS( 17, 31) =  0.773429E+00
  PKER_RACCSS( 17, 32) =  0.780736E+00
  PKER_RACCSS( 17, 33) =  0.786775E+00
  PKER_RACCSS( 17, 34) =  0.791767E+00
  PKER_RACCSS( 17, 35) =  0.795894E+00
  PKER_RACCSS( 17, 36) =  0.799306E+00
  PKER_RACCSS( 17, 37) =  0.802128E+00
  PKER_RACCSS( 17, 38) =  0.804461E+00
  PKER_RACCSS( 17, 39) =  0.806391E+00
  PKER_RACCSS( 17, 40) =  0.807987E+00
  PKER_RACCSS( 18,  1) =  0.147209E+02
  PKER_RACCSS( 18,  2) =  0.120131E+02
  PKER_RACCSS( 18,  3) =  0.976801E+01
  PKER_RACCSS( 18,  4) =  0.790632E+01
  PKER_RACCSS( 18,  5) =  0.636267E+01
  PKER_RACCSS( 18,  6) =  0.508334E+01
  PKER_RACCSS( 18,  7) =  0.402439E+01
  PKER_RACCSS( 18,  8) =  0.314991E+01
  PKER_RACCSS( 18,  9) =  0.243053E+01
  PKER_RACCSS( 18, 10) =  0.184200E+01
  PKER_RACCSS( 18, 11) =  0.136420E+01
  PKER_RACCSS( 18, 12) =  0.980889E+00
  PKER_RACCSS( 18, 13) =  0.680705E+00
  PKER_RACCSS( 18, 14) =  0.458391E+00
  PKER_RACCSS( 18, 15) =  0.313204E+00
  PKER_RACCSS( 18, 16) =  0.244163E+00
  PKER_RACCSS( 18, 17) =  0.241397E+00
  PKER_RACCSS( 18, 18) =  0.284627E+00
  PKER_RACCSS( 18, 19) =  0.349372E+00
  PKER_RACCSS( 18, 20) =  0.416570E+00
  PKER_RACCSS( 18, 21) =  0.476717E+00
  PKER_RACCSS( 18, 22) =  0.527374E+00
  PKER_RACCSS( 18, 23) =  0.569195E+00
  PKER_RACCSS( 18, 24) =  0.603582E+00
  PKER_RACCSS( 18, 25) =  0.631866E+00
  PKER_RACCSS( 18, 26) =  0.655151E+00
  PKER_RACCSS( 18, 27) =  0.674337E+00
  PKER_RACCSS( 18, 28) =  0.690157E+00
  PKER_RACCSS( 18, 29) =  0.703207E+00
  PKER_RACCSS( 18, 30) =  0.713979E+00
  PKER_RACCSS( 18, 31) =  0.722873E+00
  PKER_RACCSS( 18, 32) =  0.730219E+00
  PKER_RACCSS( 18, 33) =  0.736287E+00
  PKER_RACCSS( 18, 34) =  0.741302E+00
  PKER_RACCSS( 18, 35) =  0.745447E+00
  PKER_RACCSS( 18, 36) =  0.748872E+00
  PKER_RACCSS( 18, 37) =  0.751705E+00
  PKER_RACCSS( 18, 38) =  0.754046E+00
  PKER_RACCSS( 18, 39) =  0.755982E+00
  PKER_RACCSS( 18, 40) =  0.757584E+00
  PKER_RACCSS( 19,  1) =  0.149183E+02
  PKER_RACCSS( 19,  2) =  0.122030E+02
  PKER_RACCSS( 19,  3) =  0.994164E+01
  PKER_RACCSS( 19,  4) =  0.807634E+01
  PKER_RACCSS( 19,  5) =  0.652942E+01
  PKER_RACCSS( 19,  6) =  0.524643E+01
  PKER_RACCSS( 19,  7) =  0.418260E+01
  PKER_RACCSS( 19,  8) =  0.330120E+01
  PKER_RACCSS( 19,  9) =  0.257220E+01
  PKER_RACCSS( 19, 10) =  0.197109E+01
  PKER_RACCSS( 19, 11) =  0.147799E+01
  PKER_RACCSS( 19, 12) =  0.107723E+01
  PKER_RACCSS( 19, 13) =  0.757647E+00
  PKER_RACCSS( 19, 14) =  0.513325E+00
  PKER_RACCSS( 19, 15) =  0.343389E+00
  PKER_RACCSS( 19, 16) =  0.247854E+00
  PKER_RACCSS( 19, 17) =  0.221083E+00
  PKER_RACCSS( 19, 18) =  0.247150E+00
  PKER_RACCSS( 19, 19) =  0.302778E+00
  PKER_RACCSS( 19, 20) =  0.366775E+00
  PKER_RACCSS( 19, 21) =  0.426568E+00
  PKER_RACCSS( 19, 22) =  0.477725E+00
  PKER_RACCSS( 19, 23) =  0.520116E+00
  PKER_RACCSS( 19, 24) =  0.554956E+00
  PKER_RACCSS( 19, 25) =  0.583576E+00
  PKER_RACCSS( 19, 26) =  0.607109E+00
  PKER_RACCSS( 19, 27) =  0.626480E+00
  PKER_RACCSS( 19, 28) =  0.642437E+00
  PKER_RACCSS( 19, 29) =  0.655592E+00
  PKER_RACCSS( 19, 30) =  0.666442E+00
  PKER_RACCSS( 19, 31) =  0.675396E+00
  PKER_RACCSS( 19, 32) =  0.682788E+00
  PKER_RACCSS( 19, 33) =  0.688892E+00
  PKER_RACCSS( 19, 34) =  0.693934E+00
  PKER_RACCSS( 19, 35) =  0.698099E+00
  PKER_RACCSS( 19, 36) =  0.701541E+00
  PKER_RACCSS( 19, 37) =  0.704386E+00
  PKER_RACCSS( 19, 38) =  0.706738E+00
  PKER_RACCSS( 19, 39) =  0.708682E+00
  PKER_RACCSS( 19, 40) =  0.710289E+00
  PKER_RACCSS( 20,  1) =  0.149148E+02
  PKER_RACCSS( 20,  2) =  0.121968E+02
  PKER_RACCSS( 20,  3) =  0.994688E+01
  PKER_RACCSS( 20,  4) =  0.808241E+01
  PKER_RACCSS( 20,  5) =  0.653732E+01
  PKER_RACCSS( 20,  6) =  0.525704E+01
  PKER_RACCSS( 20,  7) =  0.419660E+01
  PKER_RACCSS( 20,  8) =  0.331897E+01
  PKER_RACCSS( 20,  9) =  0.259370E+01
  PKER_RACCSS( 20, 10) =  0.199579E+01
  PKER_RACCSS( 20, 11) =  0.150482E+01
  PKER_RACCSS( 20, 12) =  0.110452E+01
  PKER_RACCSS( 20, 13) =  0.783023E+00
  PKER_RACCSS( 20, 14) =  0.533371E+00
  PKER_RACCSS( 20, 15) =  0.353809E+00
  PKER_RACCSS( 20, 16) =  0.245035E+00
  PKER_RACCSS( 20, 17) =  0.204243E+00
  PKER_RACCSS( 20, 18) =  0.219182E+00
  PKER_RACCSS( 20, 19) =  0.268663E+00
  PKER_RACCSS( 20, 20) =  0.330431E+00
  PKER_RACCSS( 20, 21) =  0.389684E+00
  PKER_RACCSS( 20, 22) =  0.440619E+00
  PKER_RACCSS( 20, 23) =  0.482783E+00
  PKER_RACCSS( 20, 24) =  0.517411E+00
  PKER_RACCSS( 20, 25) =  0.545855E+00
  PKER_RACCSS( 20, 26) =  0.569246E+00
  PKER_RACCSS( 20, 27) =  0.588502E+00
  PKER_RACCSS( 20, 28) =  0.604366E+00
  PKER_RACCSS( 20, 29) =  0.617445E+00
  PKER_RACCSS( 20, 30) =  0.628235E+00
  PKER_RACCSS( 20, 31) =  0.637140E+00
  PKER_RACCSS( 20, 32) =  0.644493E+00
  PKER_RACCSS( 20, 33) =  0.650566E+00
  PKER_RACCSS( 20, 34) =  0.655583E+00
  PKER_RACCSS( 20, 35) =  0.659729E+00
  PKER_RACCSS( 20, 36) =  0.663155E+00
  PKER_RACCSS( 20, 37) =  0.665988E+00
  PKER_RACCSS( 20, 38) =  0.668329E+00
  PKER_RACCSS( 20, 39) =  0.670265E+00
  PKER_RACCSS( 20, 40) =  0.671867E+00
  PKER_RACCSS( 21,  1) =  0.150013E+02
  PKER_RACCSS( 21,  2) =  0.122869E+02
  PKER_RACCSS( 21,  3) =  0.100382E+02
  PKER_RACCSS( 21,  4) =  0.817497E+01
  PKER_RACCSS( 21,  5) =  0.663057E+01
  PKER_RACCSS( 21,  6) =  0.535086E+01
  PKER_RACCSS( 21,  7) =  0.429034E+01
  PKER_RACCSS( 21,  8) =  0.341176E+01
  PKER_RACCSS( 21,  9) =  0.268444E+01
  PKER_RACCSS( 21, 10) =  0.208320E+01
  PKER_RACCSS( 21, 11) =  0.158747E+01
  PKER_RACCSS( 21, 12) =  0.118074E+01
  PKER_RACCSS( 21, 13) =  0.850535E+00
  PKER_RACCSS( 21, 14) =  0.588897E+00
  PKER_RACCSS( 21, 15) =  0.392828E+00
  PKER_RACCSS( 21, 16) =  0.262954E+00
  PKER_RACCSS( 21, 17) =  0.199389E+00
  PKER_RACCSS( 21, 18) =  0.194569E+00
  PKER_RACCSS( 21, 19) =  0.231063E+00
  PKER_RACCSS( 21, 20) =  0.286983E+00
  PKER_RACCSS( 21, 21) =  0.344860E+00
  PKER_RACCSS( 21, 22) =  0.396111E+00
  PKER_RACCSS( 21, 23) =  0.438868E+00
  PKER_RACCSS( 21, 24) =  0.473989E+00
  PKER_RACCSS( 21, 25) =  0.502799E+00
  PKER_RACCSS( 21, 26) =  0.526459E+00
  PKER_RACCSS( 21, 27) =  0.545913E+00
  PKER_RACCSS( 21, 28) =  0.561925E+00
  PKER_RACCSS( 21, 29) =  0.575114E+00
  PKER_RACCSS( 21, 30) =  0.585987E+00
  PKER_RACCSS( 21, 31) =  0.594955E+00
  PKER_RACCSS( 21, 32) =  0.602355E+00
  PKER_RACCSS( 21, 33) =  0.608464E+00
  PKER_RACCSS( 21, 34) =  0.613509E+00
  PKER_RACCSS( 21, 35) =  0.617676E+00
  PKER_RACCSS( 21, 36) =  0.621119E+00
  PKER_RACCSS( 21, 37) =  0.623965E+00
  PKER_RACCSS( 21, 38) =  0.626316E+00
  PKER_RACCSS( 21, 39) =  0.628260E+00
  PKER_RACCSS( 21, 40) =  0.629867E+00
  PKER_RACCSS( 22,  1) =  0.150720E+02
  PKER_RACCSS( 22,  2) =  0.123594E+02
  PKER_RACCSS( 22,  3) =  0.101123E+02
  PKER_RACCSS( 22,  4) =  0.825051E+01
  PKER_RACCSS( 22,  5) =  0.670778E+01
  PKER_RACCSS( 22,  6) =  0.542920E+01
  PKER_RACCSS( 22,  7) =  0.436946E+01
  PKER_RACCSS( 22,  8) =  0.349113E+01
  PKER_RACCSS( 22,  9) =  0.276334E+01
  PKER_RACCSS( 22, 10) =  0.216073E+01
  PKER_RACCSS( 22, 11) =  0.166252E+01
  PKER_RACCSS( 22, 12) =  0.125192E+01
  PKER_RACCSS( 22, 13) =  0.915920E+00
  PKER_RACCSS( 22, 14) =  0.645535E+00
  PKER_RACCSS( 22, 15) =  0.436397E+00
  PKER_RACCSS( 22, 16) =  0.288654E+00
  PKER_RACCSS( 22, 17) =  0.203659E+00
  PKER_RACCSS( 22, 18) =  0.178071E+00
  PKER_RACCSS( 22, 19) =  0.199311E+00
  PKER_RACCSS( 22, 20) =  0.247192E+00
  PKER_RACCSS( 22, 21) =  0.302537E+00
  PKER_RACCSS( 22, 22) =  0.353781E+00
  PKER_RACCSS( 22, 23) =  0.397157E+00
  PKER_RACCSS( 22, 24) =  0.432857E+00
  PKER_RACCSS( 22, 25) =  0.462108E+00
  PKER_RACCSS( 22, 26) =  0.486096E+00
  PKER_RACCSS( 22, 27) =  0.505793E+00
  PKER_RACCSS( 22, 28) =  0.521983E+00
  PKER_RACCSS( 22, 29) =  0.535306E+00
  PKER_RACCSS( 22, 30) =  0.546278E+00
  PKER_RACCSS( 22, 31) =  0.555321E+00
  PKER_RACCSS( 22, 32) =  0.562778E+00
  PKER_RACCSS( 22, 33) =  0.568931E+00
  PKER_RACCSS( 22, 34) =  0.574009E+00
  PKER_RACCSS( 22, 35) =  0.578202E+00
  PKER_RACCSS( 22, 36) =  0.581665E+00
  PKER_RACCSS( 22, 37) =  0.584526E+00
  PKER_RACCSS( 22, 38) =  0.586889E+00
  PKER_RACCSS( 22, 39) =  0.588843E+00
  PKER_RACCSS( 22, 40) =  0.590457E+00
  PKER_RACCSS( 23,  1) =  0.150726E+02
  PKER_RACCSS( 23,  2) =  0.123607E+02
  PKER_RACCSS( 23,  3) =  0.101143E+02
  PKER_RACCSS( 23,  4) =  0.825344E+01
  PKER_RACCSS( 23,  5) =  0.671177E+01
  PKER_RACCSS( 23,  6) =  0.543448E+01
  PKER_RACCSS( 23,  7) =  0.437621E+01
  PKER_RACCSS( 23,  8) =  0.349956E+01
  PKER_RACCSS( 23,  9) =  0.277362E+01
  PKER_RACCSS( 23, 10) =  0.217295E+01
  PKER_RACCSS( 23, 11) =  0.167667E+01
  PKER_RACCSS( 23, 12) =  0.126773E+01
  PKER_RACCSS( 23, 13) =  0.932718E+00
  PKER_RACCSS( 23, 14) =  0.661907E+00
  PKER_RACCSS( 23, 15) =  0.449897E+00
  PKER_RACCSS( 23, 16) =  0.295961E+00
  PKER_RACCSS( 23, 17) =  0.201862E+00
  PKER_RACCSS( 23, 18) =  0.166501E+00
  PKER_RACCSS( 23, 19) =  0.180054E+00
  PKER_RACCSS( 23, 20) =  0.223817E+00
  PKER_RACCSS( 23, 21) =  0.277646E+00
  PKER_RACCSS( 23, 22) =  0.328410E+00
  PKER_RACCSS( 23, 23) =  0.371512E+00
  PKER_RACCSS( 23, 24) =  0.406971E+00
  PKER_RACCSS( 23, 25) =  0.436013E+00
  PKER_RACCSS( 23, 26) =  0.459823E+00
  PKER_RACCSS( 23, 27) =  0.479372E+00
  PKER_RACCSS( 23, 28) =  0.495442E+00
  PKER_RACCSS( 23, 29) =  0.508667E+00
  PKER_RACCSS( 23, 30) =  0.519559E+00
  PKER_RACCSS( 23, 31) =  0.528537E+00
  PKER_RACCSS( 23, 32) =  0.535942E+00
  PKER_RACCSS( 23, 33) =  0.542053E+00
  PKER_RACCSS( 23, 34) =  0.547098E+00
  PKER_RACCSS( 23, 35) =  0.551263E+00
  PKER_RACCSS( 23, 36) =  0.554705E+00
  PKER_RACCSS( 23, 37) =  0.557548E+00
  PKER_RACCSS( 23, 38) =  0.559898E+00
  PKER_RACCSS( 23, 39) =  0.561840E+00
  PKER_RACCSS( 23, 40) =  0.563446E+00
  PKER_RACCSS( 24,  1) =  0.151324E+02
  PKER_RACCSS( 24,  2) =  0.124216E+02
  PKER_RACCSS( 24,  3) =  0.101765E+02
  PKER_RACCSS( 24,  4) =  0.831675E+01
  PKER_RACCSS( 24,  5) =  0.677615E+01
  PKER_RACCSS( 24,  6) =  0.549978E+01
  PKER_RACCSS( 24,  7) =  0.444223E+01
  PKER_RACCSS( 24,  8) =  0.356597E+01
  PKER_RACCSS( 24,  9) =  0.284002E+01
  PKER_RACCSS( 24, 10) =  0.223881E+01
  PKER_RACCSS( 24, 11) =  0.174131E+01
  PKER_RACCSS( 24, 12) =  0.133030E+01
  PKER_RACCSS( 24, 13) =  0.992011E+00
  PKER_RACCSS( 24, 14) =  0.716009E+00
  PKER_RACCSS( 24, 15) =  0.495767E+00
  PKER_RACCSS( 24, 16) =  0.329155E+00
  PKER_RACCSS( 24, 17) =  0.217613E+00
  PKER_RACCSS( 24, 18) =  0.162580E+00
  PKER_RACCSS( 24, 19) =  0.158691E+00
  PKER_RACCSS( 24, 20) =  0.191157E+00
  PKER_RACCSS( 24, 21) =  0.240223E+00
  PKER_RACCSS( 24, 22) =  0.290187E+00
  PKER_RACCSS( 24, 23) =  0.333776E+00
  PKER_RACCSS( 24, 24) =  0.369843E+00
  PKER_RACCSS( 24, 25) =  0.399359E+00
  PKER_RACCSS( 24, 26) =  0.423520E+00
  PKER_RACCSS( 24, 27) =  0.443327E+00
  PKER_RACCSS( 24, 28) =  0.459588E+00
  PKER_RACCSS( 24, 29) =  0.472953E+00
  PKER_RACCSS( 24, 30) =  0.483950E+00
  PKER_RACCSS( 24, 31) =  0.493007E+00
  PKER_RACCSS( 24, 32) =  0.500470E+00
  PKER_RACCSS( 24, 33) =  0.506625E+00
  PKER_RACCSS( 24, 34) =  0.511703E+00
  PKER_RACCSS( 24, 35) =  0.515895E+00
  PKER_RACCSS( 24, 36) =  0.519356E+00
  PKER_RACCSS( 24, 37) =  0.522215E+00
  PKER_RACCSS( 24, 38) =  0.524576E+00
  PKER_RACCSS( 24, 39) =  0.526528E+00
  PKER_RACCSS( 24, 40) =  0.528140E+00
  PKER_RACCSS( 25,  1) =  0.151432E+02
  PKER_RACCSS( 25,  2) =  0.124328E+02
  PKER_RACCSS( 25,  3) =  0.101882E+02
  PKER_RACCSS( 25,  4) =  0.832899E+01
  PKER_RACCSS( 25,  5) =  0.678899E+01
  PKER_RACCSS( 25,  6) =  0.551328E+01
  PKER_RACCSS( 25,  7) =  0.445646E+01
  PKER_RACCSS( 25,  8) =  0.358099E+01
  PKER_RACCSS( 25,  9) =  0.285587E+01
  PKER_RACCSS( 25, 10) =  0.225550E+01
  PKER_RACCSS( 25, 11) =  0.175879E+01
  PKER_RACCSS( 25, 12) =  0.134845E+01
  PKER_RACCSS( 25, 13) =  0.101050E+01
  PKER_RACCSS( 25, 14) =  0.734111E+00
  PKER_RACCSS( 25, 15) =  0.512093E+00
  PKER_RACCSS( 25, 16) =  0.341419E+00
  PKER_RACCSS( 25, 17) =  0.223087E+00
  PKER_RACCSS( 25, 18) =  0.159345E+00
  PKER_RACCSS( 25, 19) =  0.147102E+00
  PKER_RACCSS( 25, 20) =  0.173839E+00
  PKER_RACCSS( 25, 21) =  0.220264E+00
  PKER_RACCSS( 25, 22) =  0.269389E+00
  PKER_RACCSS( 25, 23) =  0.312757E+00
  PKER_RACCSS( 25, 24) =  0.348700E+00
  PKER_RACCSS( 25, 25) =  0.378105E+00
  PKER_RACCSS( 25, 26) =  0.402161E+00
  PKER_RACCSS( 25, 27) =  0.421874E+00
  PKER_RACCSS( 25, 28) =  0.438052E+00
  PKER_RACCSS( 25, 29) =  0.451345E+00
  PKER_RACCSS( 25, 30) =  0.462282E+00
  PKER_RACCSS( 25, 31) =  0.471288E+00
  PKER_RACCSS( 25, 32) =  0.478709E+00
  PKER_RACCSS( 25, 33) =  0.484830E+00
  PKER_RACCSS( 25, 34) =  0.489880E+00
  PKER_RACCSS( 25, 35) =  0.494049E+00
  PKER_RACCSS( 25, 36) =  0.497492E+00
  PKER_RACCSS( 25, 37) =  0.500336E+00
  PKER_RACCSS( 25, 38) =  0.502685E+00
  PKER_RACCSS( 25, 39) =  0.504627E+00
  PKER_RACCSS( 25, 40) =  0.506233E+00
  PKER_RACCSS( 26,  1) =  0.151604E+02
  PKER_RACCSS( 26,  2) =  0.124505E+02
  PKER_RACCSS( 26,  3) =  0.102063E+02
  PKER_RACCSS( 26,  4) =  0.834759E+01
  PKER_RACCSS( 26,  5) =  0.680810E+01
  PKER_RACCSS( 26,  6) =  0.553290E+01
  PKER_RACCSS( 26,  7) =  0.447661E+01
  PKER_RACCSS( 26,  8) =  0.360165E+01
  PKER_RACCSS( 26,  9) =  0.287702E+01
  PKER_RACCSS( 26, 10) =  0.227707E+01
  PKER_RACCSS( 26, 11) =  0.178069E+01
  PKER_RACCSS( 26, 12) =  0.137049E+01
  PKER_RACCSS( 26, 13) =  0.103238E+01
  PKER_RACCSS( 26, 14) =  0.755232E+00
  PKER_RACCSS( 26, 15) =  0.531299E+00
  PKER_RACCSS( 26, 16) =  0.356723E+00
  PKER_RACCSS( 26, 17) =  0.231969E+00
  PKER_RACCSS( 26, 18) =  0.159466E+00
  PKER_RACCSS( 26, 19) =  0.138275E+00
  PKER_RACCSS( 26, 20) =  0.158408E+00
  PKER_RACCSS( 26, 21) =  0.201507E+00
  PKER_RACCSS( 26, 22) =  0.249601E+00
  PKER_RACCSS( 26, 23) =  0.292817E+00
  PKER_RACCSS( 26, 24) =  0.328766E+00
  PKER_RACCSS( 26, 25) =  0.358167E+00
  PKER_RACCSS( 26, 26) =  0.382203E+00
  PKER_RACCSS( 26, 27) =  0.401886E+00
  PKER_RACCSS( 26, 28) =  0.418030E+00
  PKER_RACCSS( 26, 29) =  0.431290E+00
  PKER_RACCSS( 26, 30) =  0.442195E+00
  PKER_RACCSS( 26, 31) =  0.451173E+00
  PKER_RACCSS( 26, 32) =  0.458570E+00
  PKER_RACCSS( 26, 33) =  0.464669E+00
  PKER_RACCSS( 26, 34) =  0.469702E+00
  PKER_RACCSS( 26, 35) =  0.473856E+00
  PKER_RACCSS( 26, 36) =  0.477287E+00
  PKER_RACCSS( 26, 37) =  0.480121E+00
  PKER_RACCSS( 26, 38) =  0.482463E+00
  PKER_RACCSS( 26, 39) =  0.484399E+00
  PKER_RACCSS( 26, 40) =  0.485999E+00
  PKER_RACCSS( 27,  1) =  0.151814E+02
  PKER_RACCSS( 27,  2) =  0.124719E+02
  PKER_RACCSS( 27,  3) =  0.102281E+02
  PKER_RACCSS( 27,  4) =  0.836990E+01
  PKER_RACCSS( 27,  5) =  0.683086E+01
  PKER_RACCSS( 27,  6) =  0.555611E+01
  PKER_RACCSS( 27,  7) =  0.450023E+01
  PKER_RACCSS( 27,  8) =  0.362567E+01
  PKER_RACCSS( 27,  9) =  0.290135E+01
  PKER_RACCSS( 27, 10) =  0.230164E+01
  PKER_RACCSS( 27, 11) =  0.180536E+01
  PKER_RACCSS( 27, 12) =  0.139509E+01
  PKER_RACCSS( 27, 13) =  0.105660E+01
  PKER_RACCSS( 27, 14) =  0.778555E+00
  PKER_RACCSS( 27, 15) =  0.552744E+00
  PKER_RACCSS( 27, 16) =  0.374600E+00
  PKER_RACCSS( 27, 17) =  0.243637E+00
  PKER_RACCSS( 27, 18) =  0.162579E+00
  PKER_RACCSS( 27, 19) =  0.131954E+00
  PKER_RACCSS( 27, 20) =  0.144584E+00
  PKER_RACCSS( 27, 21) =  0.183443E+00
  PKER_RACCSS( 27, 22) =  0.230184E+00
  PKER_RACCSS( 27, 23) =  0.273243E+00
  PKER_RACCSS( 27, 24) =  0.309289E+00
  PKER_RACCSS( 27, 25) =  0.338774E+00
  PKER_RACCSS( 27, 26) =  0.362856E+00
  PKER_RACCSS( 27, 27) =  0.382560E+00
  PKER_RACCSS( 27, 28) =  0.398710E+00
  PKER_RACCSS( 27, 29) =  0.411966E+00
  PKER_RACCSS( 27, 30) =  0.422862E+00
  PKER_RACCSS( 27, 31) =  0.431828E+00
  PKER_RACCSS( 27, 32) =  0.439214E+00
  PKER_RACCSS( 27, 33) =  0.445302E+00
  PKER_RACCSS( 27, 34) =  0.450325E+00
  PKER_RACCSS( 27, 35) =  0.454471E+00
  PKER_RACCSS( 27, 36) =  0.457894E+00
  PKER_RACCSS( 27, 37) =  0.460722E+00
  PKER_RACCSS( 27, 38) =  0.463059E+00
  PKER_RACCSS( 27, 39) =  0.464990E+00
  PKER_RACCSS( 27, 40) =  0.466587E+00
  PKER_RACCSS( 28,  1) =  0.151833E+02
  PKER_RACCSS( 28,  2) =  0.124739E+02
  PKER_RACCSS( 28,  3) =  0.102303E+02
  PKER_RACCSS( 28,  4) =  0.837216E+01
  PKER_RACCSS( 28,  5) =  0.683329E+01
  PKER_RACCSS( 28,  6) =  0.555874E+01
  PKER_RACCSS( 28,  7) =  0.450309E+01
  PKER_RACCSS( 28,  8) =  0.362879E+01
  PKER_RACCSS( 28,  9) =  0.290477E+01
  PKER_RACCSS( 28, 10) =  0.230538E+01
  PKER_RACCSS( 28, 11) =  0.180946E+01
  PKER_RACCSS( 28, 12) =  0.139955E+01
  PKER_RACCSS( 28, 13) =  0.106140E+01
  PKER_RACCSS( 28, 14) =  0.783576E+00
  PKER_RACCSS( 28, 15) =  0.557673E+00
  PKER_RACCSS( 28, 16) =  0.378779E+00
  PKER_RACCSS( 28, 17) =  0.246210E+00
  PKER_RACCSS( 28, 18) =  0.162452E+00
  PKER_RACCSS( 28, 19) =  0.128861E+00
  PKER_RACCSS( 28, 20) =  0.138936E+00
  PKER_RACCSS( 28, 21) =  0.176459E+00
  PKER_RACCSS( 28, 22) =  0.222625E+00
  PKER_RACCSS( 28, 23) =  0.265456E+00
  PKER_RACCSS( 28, 24) =  0.301332E+00
  PKER_RACCSS( 28, 25) =  0.330667E+00
  PKER_RACCSS( 28, 26) =  0.354619E+00
  PKER_RACCSS( 28, 27) =  0.374211E+00
  PKER_RACCSS( 28, 28) =  0.390266E+00
  PKER_RACCSS( 28, 29) =  0.403443E+00
  PKER_RACCSS( 28, 30) =  0.414273E+00
  PKER_RACCSS( 28, 31) =  0.423185E+00
  PKER_RACCSS( 28, 32) =  0.430527E+00
  PKER_RACCSS( 28, 33) =  0.436580E+00
  PKER_RACCSS( 28, 34) =  0.441573E+00
  PKER_RACCSS( 28, 35) =  0.445696E+00
  PKER_RACCSS( 28, 36) =  0.449101E+00
  PKER_RACCSS( 28, 37) =  0.451914E+00
  PKER_RACCSS( 28, 38) =  0.454239E+00
  PKER_RACCSS( 28, 39) =  0.456161E+00
  PKER_RACCSS( 28, 40) =  0.457750E+00
  PKER_RACCSS( 29,  1) =  0.151936E+02
  PKER_RACCSS( 29,  2) =  0.124845E+02
  PKER_RACCSS( 29,  3) =  0.102410E+02
  PKER_RACCSS( 29,  4) =  0.838316E+01
  PKER_RACCSS( 29,  5) =  0.684451E+01
  PKER_RACCSS( 29,  6) =  0.557018E+01
  PKER_RACCSS( 29,  7) =  0.451475E+01
  PKER_RACCSS( 29,  8) =  0.364064E+01
  PKER_RACCSS( 29,  9) =  0.291680E+01
  PKER_RACCSS( 29, 10) =  0.231756E+01
  PKER_RACCSS( 29, 11) =  0.182172E+01
  PKER_RACCSS( 29, 12) =  0.141183E+01
  PKER_RACCSS( 29, 13) =  0.107359E+01
  PKER_RACCSS( 29, 14) =  0.795449E+00
  PKER_RACCSS( 29, 15) =  0.568820E+00
  PKER_RACCSS( 29, 16) =  0.388406E+00
  PKER_RACCSS( 29, 17) =  0.253055E+00
  PKER_RACCSS( 29, 18) =  0.165100E+00
  PKER_RACCSS( 29, 19) =  0.126486E+00
  PKER_RACCSS( 29, 20) =  0.132218E+00
  PKER_RACCSS( 29, 21) =  0.167127E+00
  PKER_RACCSS( 29, 22) =  0.212335E+00
  PKER_RACCSS( 29, 23) =  0.254984E+00
  PKER_RACCSS( 29, 24) =  0.290865E+00
  PKER_RACCSS( 29, 25) =  0.320207E+00
  PKER_RACCSS( 29, 26) =  0.344152E+00
  PKER_RACCSS( 29, 27) =  0.363727E+00
  PKER_RACCSS( 29, 28) =  0.379760E+00
  PKER_RACCSS( 29, 29) =  0.392914E+00
  PKER_RACCSS( 29, 30) =  0.403723E+00
  PKER_RACCSS( 29, 31) =  0.412615E+00
  PKER_RACCSS( 29, 32) =  0.419938E+00
  PKER_RACCSS( 29, 33) =  0.425976E+00
  PKER_RACCSS( 29, 34) =  0.430956E+00
  PKER_RACCSS( 29, 35) =  0.435068E+00
  PKER_RACCSS( 29, 36) =  0.438464E+00
  PKER_RACCSS( 29, 37) =  0.441269E+00
  PKER_RACCSS( 29, 38) =  0.443588E+00
  PKER_RACCSS( 29, 39) =  0.445506E+00
  PKER_RACCSS( 29, 40) =  0.447091E+00
  PKER_RACCSS( 30,  1) =  0.152092E+02
  PKER_RACCSS( 30,  2) =  0.125003E+02
  PKER_RACCSS( 30,  3) =  0.102571E+02
  PKER_RACCSS( 30,  4) =  0.839954E+01
  PKER_RACCSS( 30,  5) =  0.686114E+01
  PKER_RACCSS( 30,  6) =  0.558706E+01
  PKER_RACCSS( 30,  7) =  0.453184E+01
  PKER_RACCSS( 30,  8) =  0.365791E+01
  PKER_RACCSS( 30,  9) =  0.293420E+01
  PKER_RACCSS( 30, 10) =  0.233502E+01
  PKER_RACCSS( 30, 11) =  0.183917E+01
  PKER_RACCSS( 30, 12) =  0.142914E+01
  PKER_RACCSS( 30, 13) =  0.109060E+01
  PKER_RACCSS( 30, 14) =  0.811894E+00
  PKER_RACCSS( 30, 15) =  0.584240E+00
  PKER_RACCSS( 30, 16) =  0.401963E+00
  PKER_RACCSS( 30, 17) =  0.263204E+00
  PKER_RACCSS( 30, 18) =  0.170121E+00
  PKER_RACCSS( 30, 19) =  0.125069E+00
  PKER_RACCSS( 30, 20) =  0.124997E+00
  PKER_RACCSS( 30, 21) =  0.156156E+00
  PKER_RACCSS( 30, 22) =  0.199916E+00
  PKER_RACCSS( 30, 23) =  0.242350E+00
  PKER_RACCSS( 30, 24) =  0.278332E+00
  PKER_RACCSS( 30, 25) =  0.307780E+00
  PKER_RACCSS( 30, 26) =  0.331793E+00
  PKER_RACCSS( 30, 27) =  0.351410E+00
  PKER_RACCSS( 30, 28) =  0.367466E+00
  PKER_RACCSS( 30, 29) =  0.380631E+00
  PKER_RACCSS( 30, 30) =  0.391442E+00
  PKER_RACCSS( 30, 31) =  0.400333E+00
  PKER_RACCSS( 30, 32) =  0.407654E+00
  PKER_RACCSS( 30, 33) =  0.413687E+00
  PKER_RACCSS( 30, 34) =  0.418663E+00
  PKER_RACCSS( 30, 35) =  0.422770E+00
  PKER_RACCSS( 30, 36) =  0.426162E+00
  PKER_RACCSS( 30, 37) =  0.428964E+00
  PKER_RACCSS( 30, 38) =  0.431280E+00
  PKER_RACCSS( 30, 39) =  0.433195E+00
  PKER_RACCSS( 30, 40) =  0.434778E+00
  PKER_RACCSS( 31,  1) =  0.152168E+02
  PKER_RACCSS( 31,  2) =  0.125081E+02
  PKER_RACCSS( 31,  3) =  0.102650E+02
  PKER_RACCSS( 31,  4) =  0.840757E+01
  PKER_RACCSS( 31,  5) =  0.686932E+01
  PKER_RACCSS( 31,  6) =  0.559536E+01
  PKER_RACCSS( 31,  7) =  0.454028E+01
  PKER_RACCSS( 31,  8) =  0.366647E+01
  PKER_RACCSS( 31,  9) =  0.294286E+01
  PKER_RACCSS( 31, 10) =  0.234375E+01
  PKER_RACCSS( 31, 11) =  0.184793E+01
  PKER_RACCSS( 31, 12) =  0.143790E+01
  PKER_RACCSS( 31, 13) =  0.109928E+01
  PKER_RACCSS( 31, 14) =  0.820370E+00
  PKER_RACCSS( 31, 15) =  0.592284E+00
  PKER_RACCSS( 31, 16) =  0.409147E+00
  PKER_RACCSS( 31, 17) =  0.268707E+00
  PKER_RACCSS( 31, 18) =  0.172988E+00
  PKER_RACCSS( 31, 19) =  0.124548E+00
  PKER_RACCSS( 31, 20) =  0.121193E+00
  PKER_RACCSS( 31, 21) =  0.150187E+00
  PKER_RACCSS( 31, 22) =  0.193042E+00
  PKER_RACCSS( 31, 23) =  0.235298E+00
  PKER_RACCSS( 31, 24) =  0.271298E+00
  PKER_RACCSS( 31, 25) =  0.300774E+00
  PKER_RACCSS( 31, 26) =  0.324800E+00
  PKER_RACCSS( 31, 27) =  0.344418E+00
  PKER_RACCSS( 31, 28) =  0.360469E+00
  PKER_RACCSS( 31, 29) =  0.373626E+00
  PKER_RACCSS( 31, 30) =  0.384427E+00
  PKER_RACCSS( 31, 31) =  0.393308E+00
  PKER_RACCSS( 31, 32) =  0.400619E+00
  PKER_RACCSS( 31, 33) =  0.406643E+00
  PKER_RACCSS( 31, 34) =  0.411612E+00
  PKER_RACCSS( 31, 35) =  0.415713E+00
  PKER_RACCSS( 31, 36) =  0.419099E+00
  PKER_RACCSS( 31, 37) =  0.421897E+00
  PKER_RACCSS( 31, 38) =  0.424209E+00
  PKER_RACCSS( 31, 39) =  0.426121E+00
  PKER_RACCSS( 31, 40) =  0.427702E+00
  PKER_RACCSS( 32,  1) =  0.152212E+02
  PKER_RACCSS( 32,  2) =  0.125125E+02
  PKER_RACCSS( 32,  3) =  0.102696E+02
  PKER_RACCSS( 32,  4) =  0.841222E+01
  PKER_RACCSS( 32,  5) =  0.687405E+01
  PKER_RACCSS( 32,  6) =  0.560018E+01
  PKER_RACCSS( 32,  7) =  0.454517E+01
  PKER_RACCSS( 32,  8) =  0.367144E+01
  PKER_RACCSS( 32,  9) =  0.294789E+01
  PKER_RACCSS( 32, 10) =  0.234884E+01
  PKER_RACCSS( 32, 11) =  0.185306E+01
  PKER_RACCSS( 32, 12) =  0.144305E+01
  PKER_RACCSS( 32, 13) =  0.110439E+01
  PKER_RACCSS( 32, 14) =  0.825390E+00
  PKER_RACCSS( 32, 15) =  0.597084E+00
  PKER_RACCSS( 32, 16) =  0.413476E+00
  PKER_RACCSS( 32, 17) =  0.272077E+00
  PKER_RACCSS( 32, 18) =  0.174803E+00
  PKER_RACCSS( 32, 19) =  0.124293E+00
  PKER_RACCSS( 32, 20) =  0.118931E+00
  PKER_RACCSS( 32, 21) =  0.146554E+00
  PKER_RACCSS( 32, 22) =  0.188828E+00
  PKER_RACCSS( 32, 23) =  0.230954E+00
  PKER_RACCSS( 32, 24) =  0.266952E+00
  PKER_RACCSS( 32, 25) =  0.296435E+00
  PKER_RACCSS( 32, 26) =  0.320462E+00
  PKER_RACCSS( 32, 27) =  0.340075E+00
  PKER_RACCSS( 32, 28) =  0.356117E+00
  PKER_RACCSS( 32, 29) =  0.369263E+00
  PKER_RACCSS( 32, 30) =  0.380055E+00
  PKER_RACCSS( 32, 31) =  0.388926E+00
  PKER_RACCSS( 32, 32) =  0.396228E+00
  PKER_RACCSS( 32, 33) =  0.402245E+00
  PKER_RACCSS( 32, 34) =  0.407208E+00
  PKER_RACCSS( 32, 35) =  0.411303E+00
  PKER_RACCSS( 32, 36) =  0.414685E+00
  PKER_RACCSS( 32, 37) =  0.417479E+00
  PKER_RACCSS( 32, 38) =  0.419788E+00
  PKER_RACCSS( 32, 39) =  0.421697E+00
  PKER_RACCSS( 32, 40) =  0.423276E+00
  PKER_RACCSS( 33,  1) =  0.152252E+02
  PKER_RACCSS( 33,  2) =  0.125166E+02
  PKER_RACCSS( 33,  3) =  0.102737E+02
  PKER_RACCSS( 33,  4) =  0.841642E+01
  PKER_RACCSS( 33,  5) =  0.687832E+01
  PKER_RACCSS( 33,  6) =  0.560452E+01
  PKER_RACCSS( 33,  7) =  0.454958E+01
  PKER_RACCSS( 33,  8) =  0.367590E+01
  PKER_RACCSS( 33,  9) =  0.295241E+01
  PKER_RACCSS( 33, 10) =  0.235339E+01
  PKER_RACCSS( 33, 11) =  0.185763E+01
  PKER_RACCSS( 33, 12) =  0.144761E+01
  PKER_RACCSS( 33, 13) =  0.110891E+01
  PKER_RACCSS( 33, 14) =  0.829809E+00
  PKER_RACCSS( 33, 15) =  0.601298E+00
  PKER_RACCSS( 33, 16) =  0.417299E+00
  PKER_RACCSS( 33, 17) =  0.275084E+00
  PKER_RACCSS( 33, 18) =  0.176517E+00
  PKER_RACCSS( 33, 19) =  0.124255E+00
  PKER_RACCSS( 33, 20) =  0.117165E+00
  PKER_RACCSS( 33, 21) =  0.143564E+00
  PKER_RACCSS( 33, 22) =  0.185315E+00
  PKER_RACCSS( 33, 23) =  0.227330E+00
  PKER_RACCSS( 33, 24) =  0.263338E+00
  PKER_RACCSS( 33, 25) =  0.292840E+00
  PKER_RACCSS( 33, 26) =  0.316875E+00
  PKER_RACCSS( 33, 27) =  0.336491E+00
  PKER_RACCSS( 33, 28) =  0.352533E+00
  PKER_RACCSS( 33, 29) =  0.365676E+00
  PKER_RACCSS( 33, 30) =  0.376463E+00
  PKER_RACCSS( 33, 31) =  0.385329E+00
  PKER_RACCSS( 33, 32) =  0.392627E+00
  PKER_RACCSS( 33, 33) =  0.398639E+00
  PKER_RACCSS( 33, 34) =  0.403598E+00
  PKER_RACCSS( 33, 35) =  0.407690E+00
  PKER_RACCSS( 33, 36) =  0.411069E+00
  PKER_RACCSS( 33, 37) =  0.413860E+00
  PKER_RACCSS( 33, 38) =  0.416168E+00
  PKER_RACCSS( 33, 39) =  0.418075E+00
  PKER_RACCSS( 33, 40) =  0.419653E+00
  PKER_RACCSS( 34,  1) =  0.152248E+02
  PKER_RACCSS( 34,  2) =  0.125162E+02
  PKER_RACCSS( 34,  3) =  0.102733E+02
  PKER_RACCSS( 34,  4) =  0.841600E+01
  PKER_RACCSS( 34,  5) =  0.687791E+01
  PKER_RACCSS( 34,  6) =  0.560412E+01
  PKER_RACCSS( 34,  7) =  0.454919E+01
  PKER_RACCSS( 34,  8) =  0.367553E+01
  PKER_RACCSS( 34,  9) =  0.295206E+01
  PKER_RACCSS( 34, 10) =  0.235307E+01
  PKER_RACCSS( 34, 11) =  0.185734E+01
  PKER_RACCSS( 34, 12) =  0.144736E+01
  PKER_RACCSS( 34, 13) =  0.110872E+01
  PKER_RACCSS( 34, 14) =  0.829656E+00
  PKER_RACCSS( 34, 15) =  0.601205E+00
  PKER_RACCSS( 34, 16) =  0.417236E+00
  PKER_RACCSS( 34, 17) =  0.275045E+00
  PKER_RACCSS( 34, 18) =  0.176424E+00
  PKER_RACCSS( 34, 19) =  0.124044E+00
  PKER_RACCSS( 34, 20) =  0.116894E+00
  PKER_RACCSS( 34, 21) =  0.143258E+00
  PKER_RACCSS( 34, 22) =  0.184999E+00
  PKER_RACCSS( 34, 23) =  0.226991E+00
  PKER_RACCSS( 34, 24) =  0.262972E+00
  PKER_RACCSS( 34, 25) =  0.292447E+00
  PKER_RACCSS( 34, 26) =  0.316461E+00
  PKER_RACCSS( 34, 27) =  0.336058E+00
  PKER_RACCSS( 34, 28) =  0.352084E+00
  PKER_RACCSS( 34, 29) =  0.365214E+00
  PKER_RACCSS( 34, 30) =  0.375991E+00
  PKER_RACCSS( 34, 31) =  0.384849E+00
  PKER_RACCSS( 34, 32) =  0.392140E+00
  PKER_RACCSS( 34, 33) =  0.398147E+00
  PKER_RACCSS( 34, 34) =  0.403101E+00
  PKER_RACCSS( 34, 35) =  0.407190E+00
  PKER_RACCSS( 34, 36) =  0.410566E+00
  PKER_RACCSS( 34, 37) =  0.413355E+00
  PKER_RACCSS( 34, 38) =  0.415661E+00
  PKER_RACCSS( 34, 39) =  0.417567E+00
  PKER_RACCSS( 34, 40) =  0.419144E+00
  PKER_RACCSS( 35,  1) =  0.152287E+02
  PKER_RACCSS( 35,  2) =  0.125202E+02
  PKER_RACCSS( 35,  3) =  0.102773E+02
  PKER_RACCSS( 35,  4) =  0.842010E+01
  PKER_RACCSS( 35,  5) =  0.688207E+01
  PKER_RACCSS( 35,  6) =  0.560834E+01
  PKER_RACCSS( 35,  7) =  0.455346E+01
  PKER_RACCSS( 35,  8) =  0.367984E+01
  PKER_RACCSS( 35,  9) =  0.295641E+01
  PKER_RACCSS( 35, 10) =  0.235744E+01
  PKER_RACCSS( 35, 11) =  0.186171E+01
  PKER_RACCSS( 35, 12) =  0.145171E+01
  PKER_RACCSS( 35, 13) =  0.111300E+01
  PKER_RACCSS( 35, 14) =  0.833823E+00
  PKER_RACCSS( 35, 15) =  0.605161E+00
  PKER_RACCSS( 35, 16) =  0.420842E+00
  PKER_RACCSS( 35, 17) =  0.277903E+00
  PKER_RACCSS( 35, 18) =  0.178147E+00
  PKER_RACCSS( 35, 19) =  0.124171E+00
  PKER_RACCSS( 35, 20) =  0.115464E+00
  PKER_RACCSS( 35, 21) =  0.140674E+00
  PKER_RACCSS( 35, 22) =  0.181919E+00
  PKER_RACCSS( 35, 23) =  0.223809E+00
  PKER_RACCSS( 35, 24) =  0.259812E+00
  PKER_RACCSS( 35, 25) =  0.289318E+00
  PKER_RACCSS( 35, 26) =  0.313352E+00
  PKER_RACCSS( 35, 27) =  0.332962E+00
  PKER_RACCSS( 35, 28) =  0.348995E+00
  PKER_RACCSS( 35, 29) =  0.362129E+00
  PKER_RACCSS( 35, 30) =  0.372907E+00
  PKER_RACCSS( 35, 31) =  0.381764E+00
  PKER_RACCSS( 35, 32) =  0.389054E+00
  PKER_RACCSS( 35, 33) =  0.395060E+00
  PKER_RACCSS( 35, 34) =  0.400012E+00
  PKER_RACCSS( 35, 35) =  0.404099E+00
  PKER_RACCSS( 35, 36) =  0.407474E+00
  PKER_RACCSS( 35, 37) =  0.410263E+00
  PKER_RACCSS( 35, 38) =  0.412567E+00
  PKER_RACCSS( 35, 39) =  0.414473E+00
  PKER_RACCSS( 35, 40) =  0.416049E+00
  PKER_RACCSS( 36,  1) =  0.152383E+02
  PKER_RACCSS( 36,  2) =  0.125299E+02
  PKER_RACCSS( 36,  3) =  0.102873E+02
  PKER_RACCSS( 36,  4) =  0.843016E+01
  PKER_RACCSS( 36,  5) =  0.689226E+01
  PKER_RACCSS( 36,  6) =  0.561865E+01
  PKER_RACCSS( 36,  7) =  0.456388E+01
  PKER_RACCSS( 36,  8) =  0.369036E+01
  PKER_RACCSS( 36,  9) =  0.296698E+01
  PKER_RACCSS( 36, 10) =  0.236804E+01
  PKER_RACCSS( 36, 11) =  0.187228E+01
  PKER_RACCSS( 36, 12) =  0.146219E+01
  PKER_RACCSS( 36, 13) =  0.112330E+01
  PKER_RACCSS( 36, 14) =  0.843833E+00
  PKER_RACCSS( 36, 15) =  0.614630E+00
  PKER_RACCSS( 36, 16) =  0.429489E+00
  PKER_RACCSS( 36, 17) =  0.284782E+00
  PKER_RACCSS( 36, 18) =  0.182494E+00
  PKER_RACCSS( 36, 19) =  0.124882E+00
  PKER_RACCSS( 36, 20) =  0.112591E+00
  PKER_RACCSS( 36, 21) =  0.135019E+00
  PKER_RACCSS( 36, 22) =  0.174978E+00
  PKER_RACCSS( 36, 23) =  0.216615E+00
  PKER_RACCSS( 36, 24) =  0.252695E+00
  PKER_RACCSS( 36, 25) =  0.282303E+00
  PKER_RACCSS( 36, 26) =  0.306412E+00
  PKER_RACCSS( 36, 27) =  0.326073E+00
  PKER_RACCSS( 36, 28) =  0.342140E+00
  PKER_RACCSS( 36, 29) =  0.355295E+00
  PKER_RACCSS( 36, 30) =  0.366087E+00
  PKER_RACCSS( 36, 31) =  0.374952E+00
  PKER_RACCSS( 36, 32) =  0.382247E+00
  PKER_RACCSS( 36, 33) =  0.388255E+00
  PKER_RACCSS( 36, 34) =  0.393208E+00
  PKER_RACCSS( 36, 35) =  0.397296E+00
  PKER_RACCSS( 36, 36) =  0.400670E+00
  PKER_RACCSS( 36, 37) =  0.403458E+00
  PKER_RACCSS( 36, 38) =  0.405763E+00
  PKER_RACCSS( 36, 39) =  0.407668E+00
  PKER_RACCSS( 36, 40) =  0.409243E+00
  PKER_RACCSS( 37,  1) =  0.000000E+00
  PKER_RACCSS( 37,  2) =  0.000000E+00
  PKER_RACCSS( 37,  3) =  0.000000E+00
  PKER_RACCSS( 37,  4) =  0.000000E+00
  PKER_RACCSS( 37,  5) =  0.000000E+00
  PKER_RACCSS( 37,  6) =  0.000000E+00
  PKER_RACCSS( 37,  7) =  0.000000E+00
  PKER_RACCSS( 37,  8) =  0.000000E+00
  PKER_RACCSS( 37,  9) =  0.000000E+00
  PKER_RACCSS( 37, 10) =  0.000000E+00
  PKER_RACCSS( 37, 11) =  0.000000E+00
  PKER_RACCSS( 37, 12) =  0.000000E+00
  PKER_RACCSS( 37, 13) =  0.000000E+00
  PKER_RACCSS( 37, 14) =  0.000000E+00
  PKER_RACCSS( 37, 15) =  0.000000E+00
  PKER_RACCSS( 37, 16) =  0.000000E+00
  PKER_RACCSS( 37, 17) =  0.000000E+00
  PKER_RACCSS( 37, 18) =  0.000000E+00
  PKER_RACCSS( 37, 19) =  0.000000E+00
  PKER_RACCSS( 37, 20) =  0.000000E+00
  PKER_RACCSS( 37, 21) =  0.000000E+00
  PKER_RACCSS( 37, 22) =  0.000000E+00
  PKER_RACCSS( 37, 23) =  0.000000E+00
  PKER_RACCSS( 37, 24) =  0.000000E+00
  PKER_RACCSS( 37, 25) =  0.000000E+00
  PKER_RACCSS( 37, 26) =  0.000000E+00
  PKER_RACCSS( 37, 27) =  0.000000E+00
  PKER_RACCSS( 37, 28) =  0.000000E+00
  PKER_RACCSS( 37, 29) =  0.000000E+00
  PKER_RACCSS( 37, 30) =  0.000000E+00
  PKER_RACCSS( 37, 31) =  0.000000E+00
  PKER_RACCSS( 37, 32) =  0.000000E+00
  PKER_RACCSS( 37, 33) =  0.000000E+00
  PKER_RACCSS( 37, 34) =  0.000000E+00
  PKER_RACCSS( 37, 35) =  0.000000E+00
  PKER_RACCSS( 37, 36) =  0.000000E+00
  PKER_RACCSS( 37, 37) =  0.000000E+00
  PKER_RACCSS( 37, 38) =  0.000000E+00
  PKER_RACCSS( 37, 39) =  0.000000E+00
  PKER_RACCSS( 37, 40) =  0.000000E+00
  PKER_RACCSS( 38,  1) =  0.000000E+00
  PKER_RACCSS( 38,  2) =  0.000000E+00
  PKER_RACCSS( 38,  3) =  0.000000E+00
  PKER_RACCSS( 38,  4) =  0.000000E+00
  PKER_RACCSS( 38,  5) =  0.000000E+00
  PKER_RACCSS( 38,  6) =  0.000000E+00
  PKER_RACCSS( 38,  7) =  0.000000E+00
  PKER_RACCSS( 38,  8) =  0.000000E+00
  PKER_RACCSS( 38,  9) =  0.000000E+00
  PKER_RACCSS( 38, 10) =  0.000000E+00
  PKER_RACCSS( 38, 11) =  0.000000E+00
  PKER_RACCSS( 38, 12) =  0.000000E+00
  PKER_RACCSS( 38, 13) =  0.000000E+00
  PKER_RACCSS( 38, 14) =  0.000000E+00
  PKER_RACCSS( 38, 15) =  0.000000E+00
  PKER_RACCSS( 38, 16) =  0.000000E+00
  PKER_RACCSS( 38, 17) =  0.000000E+00
  PKER_RACCSS( 38, 18) =  0.000000E+00
  PKER_RACCSS( 38, 19) =  0.000000E+00
  PKER_RACCSS( 38, 20) =  0.000000E+00
  PKER_RACCSS( 38, 21) =  0.000000E+00
  PKER_RACCSS( 38, 22) =  0.000000E+00
  PKER_RACCSS( 38, 23) =  0.000000E+00
  PKER_RACCSS( 38, 24) =  0.000000E+00
  PKER_RACCSS( 38, 25) =  0.000000E+00
  PKER_RACCSS( 38, 26) =  0.000000E+00
  PKER_RACCSS( 38, 27) =  0.000000E+00
  PKER_RACCSS( 38, 28) =  0.000000E+00
  PKER_RACCSS( 38, 29) =  0.000000E+00
  PKER_RACCSS( 38, 30) =  0.000000E+00
  PKER_RACCSS( 38, 31) =  0.000000E+00
  PKER_RACCSS( 38, 32) =  0.000000E+00
  PKER_RACCSS( 38, 33) =  0.000000E+00
  PKER_RACCSS( 38, 34) =  0.000000E+00
  PKER_RACCSS( 38, 35) =  0.000000E+00
  PKER_RACCSS( 38, 36) =  0.000000E+00
  PKER_RACCSS( 38, 37) =  0.000000E+00
  PKER_RACCSS( 38, 38) =  0.000000E+00
  PKER_RACCSS( 38, 39) =  0.000000E+00
  PKER_RACCSS( 38, 40) =  0.000000E+00
  PKER_RACCSS( 39,  1) =  0.000000E+00
  PKER_RACCSS( 39,  2) =  0.000000E+00
  PKER_RACCSS( 39,  3) =  0.000000E+00
  PKER_RACCSS( 39,  4) =  0.000000E+00
  PKER_RACCSS( 39,  5) =  0.000000E+00
  PKER_RACCSS( 39,  6) =  0.000000E+00
  PKER_RACCSS( 39,  7) =  0.000000E+00
  PKER_RACCSS( 39,  8) =  0.000000E+00
  PKER_RACCSS( 39,  9) =  0.000000E+00
  PKER_RACCSS( 39, 10) =  0.000000E+00
  PKER_RACCSS( 39, 11) =  0.000000E+00
  PKER_RACCSS( 39, 12) =  0.000000E+00
  PKER_RACCSS( 39, 13) =  0.000000E+00
  PKER_RACCSS( 39, 14) =  0.000000E+00
  PKER_RACCSS( 39, 15) =  0.000000E+00
  PKER_RACCSS( 39, 16) =  0.000000E+00
  PKER_RACCSS( 39, 17) =  0.000000E+00
  PKER_RACCSS( 39, 18) =  0.000000E+00
  PKER_RACCSS( 39, 19) =  0.000000E+00
  PKER_RACCSS( 39, 20) =  0.000000E+00
  PKER_RACCSS( 39, 21) =  0.000000E+00
  PKER_RACCSS( 39, 22) =  0.000000E+00
  PKER_RACCSS( 39, 23) =  0.000000E+00
  PKER_RACCSS( 39, 24) =  0.000000E+00
  PKER_RACCSS( 39, 25) =  0.000000E+00
  PKER_RACCSS( 39, 26) =  0.000000E+00
  PKER_RACCSS( 39, 27) =  0.000000E+00
  PKER_RACCSS( 39, 28) =  0.000000E+00
  PKER_RACCSS( 39, 29) =  0.000000E+00
  PKER_RACCSS( 39, 30) =  0.000000E+00
  PKER_RACCSS( 39, 31) =  0.000000E+00
  PKER_RACCSS( 39, 32) =  0.000000E+00
  PKER_RACCSS( 39, 33) =  0.000000E+00
  PKER_RACCSS( 39, 34) =  0.000000E+00
  PKER_RACCSS( 39, 35) =  0.000000E+00
  PKER_RACCSS( 39, 36) =  0.000000E+00
  PKER_RACCSS( 39, 37) =  0.000000E+00
  PKER_RACCSS( 39, 38) =  0.000000E+00
  PKER_RACCSS( 39, 39) =  0.000000E+00
  PKER_RACCSS( 39, 40) =  0.000000E+00
  PKER_RACCSS( 40,  1) =  0.000000E+00
  PKER_RACCSS( 40,  2) =  0.000000E+00
  PKER_RACCSS( 40,  3) =  0.000000E+00
  PKER_RACCSS( 40,  4) =  0.000000E+00
  PKER_RACCSS( 40,  5) =  0.000000E+00
  PKER_RACCSS( 40,  6) =  0.000000E+00
  PKER_RACCSS( 40,  7) =  0.000000E+00
  PKER_RACCSS( 40,  8) =  0.000000E+00
  PKER_RACCSS( 40,  9) =  0.000000E+00
  PKER_RACCSS( 40, 10) =  0.000000E+00
  PKER_RACCSS( 40, 11) =  0.000000E+00
  PKER_RACCSS( 40, 12) =  0.000000E+00
  PKER_RACCSS( 40, 13) =  0.000000E+00
  PKER_RACCSS( 40, 14) =  0.000000E+00
  PKER_RACCSS( 40, 15) =  0.000000E+00
  PKER_RACCSS( 40, 16) =  0.000000E+00
  PKER_RACCSS( 40, 17) =  0.000000E+00
  PKER_RACCSS( 40, 18) =  0.000000E+00
  PKER_RACCSS( 40, 19) =  0.000000E+00
  PKER_RACCSS( 40, 20) =  0.000000E+00
  PKER_RACCSS( 40, 21) =  0.000000E+00
  PKER_RACCSS( 40, 22) =  0.000000E+00
  PKER_RACCSS( 40, 23) =  0.000000E+00
  PKER_RACCSS( 40, 24) =  0.000000E+00
  PKER_RACCSS( 40, 25) =  0.000000E+00
  PKER_RACCSS( 40, 26) =  0.000000E+00
  PKER_RACCSS( 40, 27) =  0.000000E+00
  PKER_RACCSS( 40, 28) =  0.000000E+00
  PKER_RACCSS( 40, 29) =  0.000000E+00
  PKER_RACCSS( 40, 30) =  0.000000E+00
  PKER_RACCSS( 40, 31) =  0.000000E+00
  PKER_RACCSS( 40, 32) =  0.000000E+00
  PKER_RACCSS( 40, 33) =  0.000000E+00
  PKER_RACCSS( 40, 34) =  0.000000E+00
  PKER_RACCSS( 40, 35) =  0.000000E+00
  PKER_RACCSS( 40, 36) =  0.000000E+00
  PKER_RACCSS( 40, 37) =  0.000000E+00
  PKER_RACCSS( 40, 38) =  0.000000E+00
  PKER_RACCSS( 40, 39) =  0.000000E+00
  PKER_RACCSS( 40, 40) =  0.000000E+00
END IF
!
IF( PRESENT(PKER_RACCS ) ) THEN
  PKER_RACCS (  1,  1) =  0.102167E+02
  PKER_RACCS (  1,  2) =  0.798984E+01
  PKER_RACCS (  1,  3) =  0.617380E+01
  PKER_RACCS (  1,  4) =  0.469167E+01
  PKER_RACCS (  1,  5) =  0.348534E+01
  PKER_RACCS (  1,  6) =  0.251422E+01
  PKER_RACCS (  1,  7) =  0.175460E+01
  PKER_RACCS (  1,  8) =  0.119906E+01
  PKER_RACCS (  1,  9) =  0.848431E+00
  PKER_RACCS (  1, 10) =  0.697315E+00
  PKER_RACCS (  1, 11) =  0.717816E+00
  PKER_RACCS (  1, 12) =  0.854882E+00
  PKER_RACCS (  1, 13) =  0.104470E+01
  PKER_RACCS (  1, 14) =  0.123807E+01
  PKER_RACCS (  1, 15) =  0.141081E+01
  PKER_RACCS (  1, 16) =  0.155700E+01
  PKER_RACCS (  1, 17) =  0.167856E+01
  PKER_RACCS (  1, 18) =  0.177921E+01
  PKER_RACCS (  1, 19) =  0.186250E+01
  PKER_RACCS (  1, 20) =  0.193142E+01
  PKER_RACCS (  1, 21) =  0.198845E+01
  PKER_RACCS (  1, 22) =  0.203565E+01
  PKER_RACCS (  1, 23) =  0.207472E+01
  PKER_RACCS (  1, 24) =  0.210705E+01
  PKER_RACCS (  1, 25) =  0.213381E+01
  PKER_RACCS (  1, 26) =  0.215596E+01
  PKER_RACCS (  1, 27) =  0.217429E+01
  PKER_RACCS (  1, 28) =  0.218947E+01
  PKER_RACCS (  1, 29) =  0.220203E+01
  PKER_RACCS (  1, 30) =  0.221243E+01
  PKER_RACCS (  1, 31) =  0.222103E+01
  PKER_RACCS (  1, 32) =  0.222816E+01
  PKER_RACCS (  1, 33) =  0.223406E+01
  PKER_RACCS (  1, 34) =  0.223894E+01
  PKER_RACCS (  1, 35) =  0.224298E+01
  PKER_RACCS (  1, 36) =  0.224632E+01
  PKER_RACCS (  1, 37) =  0.224909E+01
  PKER_RACCS (  1, 38) =  0.225138E+01
  PKER_RACCS (  1, 39) =  0.225328E+01
  PKER_RACCS (  1, 40) =  0.225485E+01
  PKER_RACCS (  2,  1) =  0.104818E+02
  PKER_RACCS (  2,  2) =  0.821523E+01
  PKER_RACCS (  2,  3) =  0.637111E+01
  PKER_RACCS (  2,  4) =  0.486846E+01
  PKER_RACCS (  2,  5) =  0.364524E+01
  PKER_RACCS (  2,  6) =  0.265651E+01
  PKER_RACCS (  2,  7) =  0.187379E+01
  PKER_RACCS (  2,  8) =  0.128476E+01
  PKER_RACCS (  2,  9) =  0.888040E+00
  PKER_RACCS (  2, 10) =  0.682820E+00
  PKER_RACCS (  2, 11) =  0.651649E+00
  PKER_RACCS (  2, 12) =  0.749498E+00
  PKER_RACCS (  2, 13) =  0.917050E+00
  PKER_RACCS (  2, 14) =  0.110111E+01
  PKER_RACCS (  2, 15) =  0.127111E+01
  PKER_RACCS (  2, 16) =  0.141681E+01
  PKER_RACCS (  2, 17) =  0.153841E+01
  PKER_RACCS (  2, 18) =  0.163915E+01
  PKER_RACCS (  2, 19) =  0.172252E+01
  PKER_RACCS (  2, 20) =  0.179149E+01
  PKER_RACCS (  2, 21) =  0.184857E+01
  PKER_RACCS (  2, 22) =  0.189580E+01
  PKER_RACCS (  2, 23) =  0.193488E+01
  PKER_RACCS (  2, 24) =  0.196723E+01
  PKER_RACCS (  2, 25) =  0.199401E+01
  PKER_RACCS (  2, 26) =  0.201617E+01
  PKER_RACCS (  2, 27) =  0.203451E+01
  PKER_RACCS (  2, 28) =  0.204969E+01
  PKER_RACCS (  2, 29) =  0.206226E+01
  PKER_RACCS (  2, 30) =  0.207266E+01
  PKER_RACCS (  2, 31) =  0.208127E+01
  PKER_RACCS (  2, 32) =  0.208839E+01
  PKER_RACCS (  2, 33) =  0.209429E+01
  PKER_RACCS (  2, 34) =  0.209918E+01
  PKER_RACCS (  2, 35) =  0.210322E+01
  PKER_RACCS (  2, 36) =  0.210656E+01
  PKER_RACCS (  2, 37) =  0.210933E+01
  PKER_RACCS (  2, 38) =  0.211163E+01
  PKER_RACCS (  2, 39) =  0.211352E+01
  PKER_RACCS (  2, 40) =  0.211509E+01
  PKER_RACCS (  3,  1) =  0.107644E+02
  PKER_RACCS (  3,  2) =  0.845121E+01
  PKER_RACCS (  3,  3) =  0.657371E+01
  PKER_RACCS (  3,  4) =  0.504697E+01
  PKER_RACCS (  3,  5) =  0.380515E+01
  PKER_RACCS (  3,  6) =  0.279922E+01
  PKER_RACCS (  3,  7) =  0.199615E+01
  PKER_RACCS (  3,  8) =  0.137873E+01
  PKER_RACCS (  3,  9) =  0.942712E+00
  PKER_RACCS (  3, 10) =  0.688122E+00
  PKER_RACCS (  3, 11) =  0.605662E+00
  PKER_RACCS (  3, 12) =  0.661434E+00
  PKER_RACCS (  3, 13) =  0.802624E+00
  PKER_RACCS (  3, 14) =  0.974479E+00
  PKER_RACCS (  3, 15) =  0.114040E+01
  PKER_RACCS (  3, 16) =  0.128524E+01
  PKER_RACCS (  3, 17) =  0.140682E+01
  PKER_RACCS (  3, 18) =  0.150766E+01
  PKER_RACCS (  3, 19) =  0.159112E+01
  PKER_RACCS (  3, 20) =  0.166016E+01
  PKER_RACCS (  3, 21) =  0.171729E+01
  PKER_RACCS (  3, 22) =  0.176455E+01
  PKER_RACCS (  3, 23) =  0.180367E+01
  PKER_RACCS (  3, 24) =  0.183604E+01
  PKER_RACCS (  3, 25) =  0.186283E+01
  PKER_RACCS (  3, 26) =  0.188500E+01
  PKER_RACCS (  3, 27) =  0.190335E+01
  PKER_RACCS (  3, 28) =  0.191854E+01
  PKER_RACCS (  3, 29) =  0.193111E+01
  PKER_RACCS (  3, 30) =  0.194152E+01
  PKER_RACCS (  3, 31) =  0.195013E+01
  PKER_RACCS (  3, 32) =  0.195726E+01
  PKER_RACCS (  3, 33) =  0.196316E+01
  PKER_RACCS (  3, 34) =  0.196805E+01
  PKER_RACCS (  3, 35) =  0.197209E+01
  PKER_RACCS (  3, 36) =  0.197544E+01
  PKER_RACCS (  3, 37) =  0.197821E+01
  PKER_RACCS (  3, 38) =  0.198050E+01
  PKER_RACCS (  3, 39) =  0.198240E+01
  PKER_RACCS (  3, 40) =  0.198397E+01
  PKER_RACCS (  4,  1) =  0.110672E+02
  PKER_RACCS (  4,  2) =  0.870087E+01
  PKER_RACCS (  4,  3) =  0.678439E+01
  PKER_RACCS (  4,  4) =  0.522941E+01
  PKER_RACCS (  4,  5) =  0.396642E+01
  PKER_RACCS (  4,  6) =  0.294262E+01
  PKER_RACCS (  4,  7) =  0.212084E+01
  PKER_RACCS (  4,  8) =  0.147885E+01
  PKER_RACCS (  4,  9) =  0.100866E+01
  PKER_RACCS (  4, 10) =  0.710145E+00
  PKER_RACCS (  4, 11) =  0.578505E+00
  PKER_RACCS (  4, 12) =  0.590976E+00
  PKER_RACCS (  4, 13) =  0.701961E+00
  PKER_RACCS (  4, 14) =  0.858251E+00
  PKER_RACCS (  4, 15) =  0.101841E+01
  PKER_RACCS (  4, 16) =  0.116181E+01
  PKER_RACCS (  4, 17) =  0.128324E+01
  PKER_RACCS (  4, 18) =  0.138420E+01
  PKER_RACCS (  4, 19) =  0.146776E+01
  PKER_RACCS (  4, 20) =  0.153689E+01
  PKER_RACCS (  4, 21) =  0.159407E+01
  PKER_RACCS (  4, 22) =  0.164139E+01
  PKER_RACCS (  4, 23) =  0.168054E+01
  PKER_RACCS (  4, 24) =  0.171293E+01
  PKER_RACCS (  4, 25) =  0.173974E+01
  PKER_RACCS (  4, 26) =  0.176193E+01
  PKER_RACCS (  4, 27) =  0.178029E+01
  PKER_RACCS (  4, 28) =  0.179549E+01
  PKER_RACCS (  4, 29) =  0.180807E+01
  PKER_RACCS (  4, 30) =  0.181848E+01
  PKER_RACCS (  4, 31) =  0.182709E+01
  PKER_RACCS (  4, 32) =  0.183423E+01
  PKER_RACCS (  4, 33) =  0.184013E+01
  PKER_RACCS (  4, 34) =  0.184502E+01
  PKER_RACCS (  4, 35) =  0.184906E+01
  PKER_RACCS (  4, 36) =  0.185241E+01
  PKER_RACCS (  4, 37) =  0.185518E+01
  PKER_RACCS (  4, 38) =  0.185747E+01
  PKER_RACCS (  4, 39) =  0.185937E+01
  PKER_RACCS (  4, 40) =  0.186094E+01
  PKER_RACCS (  5,  1) =  0.113912E+02
  PKER_RACCS (  5,  2) =  0.896656E+01
  PKER_RACCS (  5,  3) =  0.700573E+01
  PKER_RACCS (  5,  4) =  0.541800E+01
  PKER_RACCS (  5,  5) =  0.413072E+01
  PKER_RACCS (  5,  6) =  0.308761E+01
  PKER_RACCS (  5,  7) =  0.224753E+01
  PKER_RACCS (  5,  8) =  0.158389E+01
  PKER_RACCS (  5,  9) =  0.108428E+01
  PKER_RACCS (  5, 10) =  0.746312E+00
  PKER_RACCS (  5, 11) =  0.568858E+00
  PKER_RACCS (  5, 12) =  0.537607E+00
  PKER_RACCS (  5, 13) =  0.615320E+00
  PKER_RACCS (  5, 14) =  0.752699E+00
  PKER_RACCS (  5, 15) =  0.904977E+00
  PKER_RACCS (  5, 16) =  0.104611E+01
  PKER_RACCS (  5, 17) =  0.116720E+01
  PKER_RACCS (  5, 18) =  0.126824E+01
  PKER_RACCS (  5, 19) =  0.135194E+01
  PKER_RACCS (  5, 20) =  0.142116E+01
  PKER_RACCS (  5, 21) =  0.147842E+01
  PKER_RACCS (  5, 22) =  0.152579E+01
  PKER_RACCS (  5, 23) =  0.156498E+01
  PKER_RACCS (  5, 24) =  0.159741E+01
  PKER_RACCS (  5, 25) =  0.162424E+01
  PKER_RACCS (  5, 26) =  0.164644E+01
  PKER_RACCS (  5, 27) =  0.166482E+01
  PKER_RACCS (  5, 28) =  0.168003E+01
  PKER_RACCS (  5, 29) =  0.169261E+01
  PKER_RACCS (  5, 30) =  0.170303E+01
  PKER_RACCS (  5, 31) =  0.171165E+01
  PKER_RACCS (  5, 32) =  0.171879E+01
  PKER_RACCS (  5, 33) =  0.172469E+01
  PKER_RACCS (  5, 34) =  0.172958E+01
  PKER_RACCS (  5, 35) =  0.173363E+01
  PKER_RACCS (  5, 36) =  0.173698E+01
  PKER_RACCS (  5, 37) =  0.173975E+01
  PKER_RACCS (  5, 38) =  0.174205E+01
  PKER_RACCS (  5, 39) =  0.174395E+01
  PKER_RACCS (  5, 40) =  0.174552E+01
  PKER_RACCS (  6,  1) =  0.117349E+02
  PKER_RACCS (  6,  2) =  0.924914E+01
  PKER_RACCS (  6,  3) =  0.723971E+01
  PKER_RACCS (  6,  4) =  0.561487E+01
  PKER_RACCS (  6,  5) =  0.429976E+01
  PKER_RACCS (  6,  6) =  0.323520E+01
  PKER_RACCS (  6,  7) =  0.237647E+01
  PKER_RACCS (  6,  8) =  0.169289E+01
  PKER_RACCS (  6,  9) =  0.116768E+01
  PKER_RACCS (  6, 10) =  0.795704E+00
  PKER_RACCS (  6, 11) =  0.576137E+00
  PKER_RACCS (  6, 12) =  0.501314E+00
  PKER_RACCS (  6, 13) =  0.543341E+00
  PKER_RACCS (  6, 14) =  0.658228E+00
  PKER_RACCS (  6, 15) =  0.800085E+00
  PKER_RACCS (  6, 16) =  0.937788E+00
  PKER_RACCS (  6, 17) =  0.105821E+01
  PKER_RACCS (  6, 18) =  0.115932E+01
  PKER_RACCS (  6, 19) =  0.124316E+01
  PKER_RACCS (  6, 20) =  0.131250E+01
  PKER_RACCS (  6, 21) =  0.136985E+01
  PKER_RACCS (  6, 22) =  0.141729E+01
  PKER_RACCS (  6, 23) =  0.145653E+01
  PKER_RACCS (  6, 24) =  0.148899E+01
  PKER_RACCS (  6, 25) =  0.151585E+01
  PKER_RACCS (  6, 26) =  0.153808E+01
  PKER_RACCS (  6, 27) =  0.155647E+01
  PKER_RACCS (  6, 28) =  0.157169E+01
  PKER_RACCS (  6, 29) =  0.158429E+01
  PKER_RACCS (  6, 30) =  0.159471E+01
  PKER_RACCS (  6, 31) =  0.160334E+01
  PKER_RACCS (  6, 32) =  0.161048E+01
  PKER_RACCS (  6, 33) =  0.161639E+01
  PKER_RACCS (  6, 34) =  0.162128E+01
  PKER_RACCS (  6, 35) =  0.162533E+01
  PKER_RACCS (  6, 36) =  0.162868E+01
  PKER_RACCS (  6, 37) =  0.163145E+01
  PKER_RACCS (  6, 38) =  0.163375E+01
  PKER_RACCS (  6, 39) =  0.163565E+01
  PKER_RACCS (  6, 40) =  0.163722E+01
  PKER_RACCS (  7,  1) =  0.120933E+02
  PKER_RACCS (  7,  2) =  0.954726E+01
  PKER_RACCS (  7,  3) =  0.748704E+01
  PKER_RACCS (  7,  4) =  0.582164E+01
  PKER_RACCS (  7,  5) =  0.447529E+01
  PKER_RACCS (  7,  6) =  0.338667E+01
  PKER_RACCS (  7,  7) =  0.250813E+01
  PKER_RACCS (  7,  8) =  0.180540E+01
  PKER_RACCS (  7,  9) =  0.125732E+01
  PKER_RACCS (  7, 10) =  0.855207E+00
  PKER_RACCS (  7, 11) =  0.597925E+00
  PKER_RACCS (  7, 12) =  0.481149E+00
  PKER_RACCS (  7, 13) =  0.486186E+00
  PKER_RACCS (  7, 14) =  0.575287E+00
  PKER_RACCS (  7, 15) =  0.703816E+00
  PKER_RACCS (  7, 16) =  0.836624E+00
  PKER_RACCS (  7, 17) =  0.955895E+00
  PKER_RACCS (  7, 18) =  0.105696E+01
  PKER_RACCS (  7, 19) =  0.114096E+01
  PKER_RACCS (  7, 20) =  0.121046E+01
  PKER_RACCS (  7, 21) =  0.126792E+01
  PKER_RACCS (  7, 22) =  0.131544E+01
  PKER_RACCS (  7, 23) =  0.135474E+01
  PKER_RACCS (  7, 24) =  0.138724E+01
  PKER_RACCS (  7, 25) =  0.141414E+01
  PKER_RACCS (  7, 26) =  0.143639E+01
  PKER_RACCS (  7, 27) =  0.145480E+01
  PKER_RACCS (  7, 28) =  0.147003E+01
  PKER_RACCS (  7, 29) =  0.148264E+01
  PKER_RACCS (  7, 30) =  0.149307E+01
  PKER_RACCS (  7, 31) =  0.150171E+01
  PKER_RACCS (  7, 32) =  0.150885E+01
  PKER_RACCS (  7, 33) =  0.151477E+01
  PKER_RACCS (  7, 34) =  0.151966E+01
  PKER_RACCS (  7, 35) =  0.152372E+01
  PKER_RACCS (  7, 36) =  0.152707E+01
  PKER_RACCS (  7, 37) =  0.152984E+01
  PKER_RACCS (  7, 38) =  0.153214E+01
  PKER_RACCS (  7, 39) =  0.153404E+01
  PKER_RACCS (  7, 40) =  0.153562E+01
  PKER_RACCS (  8,  1) =  0.124583E+02
  PKER_RACCS (  8,  2) =  0.985684E+01
  PKER_RACCS (  8,  3) =  0.774660E+01
  PKER_RACCS (  8,  4) =  0.603889E+01
  PKER_RACCS (  8,  5) =  0.465857E+01
  PKER_RACCS (  8,  6) =  0.354333E+01
  PKER_RACCS (  8,  7) =  0.264340E+01
  PKER_RACCS (  8,  8) =  0.192140E+01
  PKER_RACCS (  8,  9) =  0.135239E+01
  PKER_RACCS (  8, 10) =  0.923762E+00
  PKER_RACCS (  8, 11) =  0.632168E+00
  PKER_RACCS (  8, 12) =  0.476040E+00
  PKER_RACCS (  8, 13) =  0.443617E+00
  PKER_RACCS (  8, 14) =  0.504159E+00
  PKER_RACCS (  8, 15) =  0.616439E+00
  PKER_RACCS (  8, 16) =  0.742493E+00
  PKER_RACCS (  8, 17) =  0.859895E+00
  PKER_RACCS (  8, 18) =  0.960763E+00
  PKER_RACCS (  8, 19) =  0.104493E+01
  PKER_RACCS (  8, 20) =  0.111460E+01
  PKER_RACCS (  8, 21) =  0.117219E+01
  PKER_RACCS (  8, 22) =  0.121981E+01
  PKER_RACCS (  8, 23) =  0.125918E+01
  PKER_RACCS (  8, 24) =  0.129174E+01
  PKER_RACCS (  8, 25) =  0.131868E+01
  PKER_RACCS (  8, 26) =  0.134096E+01
  PKER_RACCS (  8, 27) =  0.135939E+01
  PKER_RACCS (  8, 28) =  0.137465E+01
  PKER_RACCS (  8, 29) =  0.138727E+01
  PKER_RACCS (  8, 30) =  0.139771E+01
  PKER_RACCS (  8, 31) =  0.140635E+01
  PKER_RACCS (  8, 32) =  0.141350E+01
  PKER_RACCS (  8, 33) =  0.141942E+01
  PKER_RACCS (  8, 34) =  0.142432E+01
  PKER_RACCS (  8, 35) =  0.142838E+01
  PKER_RACCS (  8, 36) =  0.143173E+01
  PKER_RACCS (  8, 37) =  0.143451E+01
  PKER_RACCS (  8, 38) =  0.143681E+01
  PKER_RACCS (  8, 39) =  0.143871E+01
  PKER_RACCS (  8, 40) =  0.144029E+01
  PKER_RACCS (  9,  1) =  0.128193E+02
  PKER_RACCS (  9,  2) =  0.101710E+02
  PKER_RACCS (  9,  3) =  0.801494E+01
  PKER_RACCS (  9,  4) =  0.626567E+01
  PKER_RACCS (  9,  5) =  0.485005E+01
  PKER_RACCS (  9,  6) =  0.370613E+01
  PKER_RACCS (  9,  7) =  0.278307E+01
  PKER_RACCS (  9,  8) =  0.204116E+01
  PKER_RACCS (  9,  9) =  0.145223E+01
  PKER_RACCS (  9, 10) =  0.999910E+00
  PKER_RACCS (  9, 11) =  0.678225E+00
  PKER_RACCS (  9, 12) =  0.485619E+00
  PKER_RACCS (  9, 13) =  0.415703E+00
  PKER_RACCS (  9, 14) =  0.445551E+00
  PKER_RACCS (  9, 15) =  0.538377E+00
  PKER_RACCS (  9, 16) =  0.655431E+00
  PKER_RACCS (  9, 17) =  0.769934E+00
  PKER_RACCS (  9, 18) =  0.870332E+00
  PKER_RACCS (  9, 19) =  0.954640E+00
  PKER_RACCS (  9, 20) =  0.102452E+01
  PKER_RACCS (  9, 21) =  0.108227E+01
  PKER_RACCS (  9, 22) =  0.113001E+01
  PKER_RACCS (  9, 23) =  0.116947E+01
  PKER_RACCS (  9, 24) =  0.120209E+01
  PKER_RACCS (  9, 25) =  0.122908E+01
  PKER_RACCS (  9, 26) =  0.125140E+01
  PKER_RACCS (  9, 27) =  0.126986E+01
  PKER_RACCS (  9, 28) =  0.128513E+01
  PKER_RACCS (  9, 29) =  0.129777E+01
  PKER_RACCS (  9, 30) =  0.130823E+01
  PKER_RACCS (  9, 31) =  0.131688E+01
  PKER_RACCS (  9, 32) =  0.132404E+01
  PKER_RACCS (  9, 33) =  0.132996E+01
  PKER_RACCS (  9, 34) =  0.133487E+01
  PKER_RACCS (  9, 35) =  0.133892E+01
  PKER_RACCS (  9, 36) =  0.134228E+01
  PKER_RACCS (  9, 37) =  0.134506E+01
  PKER_RACCS (  9, 38) =  0.134736E+01
  PKER_RACCS (  9, 39) =  0.134927E+01
  PKER_RACCS (  9, 40) =  0.135084E+01
  PKER_RACCS ( 10,  1) =  0.131653E+02
  PKER_RACCS ( 10,  2) =  0.104811E+02
  PKER_RACCS ( 10,  3) =  0.828636E+01
  PKER_RACCS ( 10,  4) =  0.649911E+01
  PKER_RACCS ( 10,  5) =  0.504891E+01
  PKER_RACCS ( 10,  6) =  0.387538E+01
  PKER_RACCS ( 10,  7) =  0.292777E+01
  PKER_RACCS ( 10,  8) =  0.216507E+01
  PKER_RACCS ( 10,  9) =  0.155660E+01
  PKER_RACCS ( 10, 10) =  0.108253E+01
  PKER_RACCS ( 10, 11) =  0.733699E+00
  PKER_RACCS ( 10, 12) =  0.508107E+00
  PKER_RACCS ( 10, 13) =  0.401864E+00
  PKER_RACCS ( 10, 14) =  0.399605E+00
  PKER_RACCS ( 10, 15) =  0.470066E+00
  PKER_RACCS ( 10, 16) =  0.575534E+00
  PKER_RACCS ( 10, 17) =  0.685829E+00
  PKER_RACCS ( 10, 18) =  0.785326E+00
  PKER_RACCS ( 10, 19) =  0.869715E+00
  PKER_RACCS ( 10, 20) =  0.939821E+00
  PKER_RACCS ( 10, 21) =  0.997773E+00
  PKER_RACCS ( 10, 22) =  0.104565E+01
  PKER_RACCS ( 10, 23) =  0.108522E+01
  PKER_RACCS ( 10, 24) =  0.111793E+01
  PKER_RACCS ( 10, 25) =  0.114497E+01
  PKER_RACCS ( 10, 26) =  0.116733E+01
  PKER_RACCS ( 10, 27) =  0.118583E+01
  PKER_RACCS ( 10, 28) =  0.120113E+01
  PKER_RACCS ( 10, 29) =  0.121379E+01
  PKER_RACCS ( 10, 30) =  0.122426E+01
  PKER_RACCS ( 10, 31) =  0.123292E+01
  PKER_RACCS ( 10, 32) =  0.124009E+01
  PKER_RACCS ( 10, 33) =  0.124602E+01
  PKER_RACCS ( 10, 34) =  0.125093E+01
  PKER_RACCS ( 10, 35) =  0.125500E+01
  PKER_RACCS ( 10, 36) =  0.125836E+01
  PKER_RACCS ( 10, 37) =  0.126114E+01
  PKER_RACCS ( 10, 38) =  0.126344E+01
  PKER_RACCS ( 10, 39) =  0.126535E+01
  PKER_RACCS ( 10, 40) =  0.126692E+01
  PKER_RACCS ( 11,  1) =  0.134866E+02
  PKER_RACCS ( 11,  2) =  0.107778E+02
  PKER_RACCS ( 11,  3) =  0.855355E+01
  PKER_RACCS ( 11,  4) =  0.673440E+01
  PKER_RACCS ( 11,  5) =  0.525269E+01
  PKER_RACCS ( 11,  6) =  0.405032E+01
  PKER_RACCS ( 11,  7) =  0.307764E+01
  PKER_RACCS ( 11,  8) =  0.229345E+01
  PKER_RACCS ( 11,  9) =  0.166544E+01
  PKER_RACCS ( 11, 10) =  0.117103E+01
  PKER_RACCS ( 11, 11) =  0.797857E+00
  PKER_RACCS ( 11, 12) =  0.541886E+00
  PKER_RACCS ( 11, 13) =  0.401262E+00
  PKER_RACCS ( 11, 14) =  0.366324E+00
  PKER_RACCS ( 11, 15) =  0.411835E+00
  PKER_RACCS ( 11, 16) =  0.503075E+00
  PKER_RACCS ( 11, 17) =  0.607497E+00
  PKER_RACCS ( 11, 18) =  0.705455E+00
  PKER_RACCS ( 11, 19) =  0.789792E+00
  PKER_RACCS ( 11, 20) =  0.860149E+00
  PKER_RACCS ( 11, 21) =  0.918336E+00
  PKER_RACCS ( 11, 22) =  0.966393E+00
  PKER_RACCS ( 11, 23) =  0.100609E+01
  PKER_RACCS ( 11, 24) =  0.103890E+01
  PKER_RACCS ( 11, 25) =  0.106601E+01
  PKER_RACCS ( 11, 26) =  0.108843E+01
  PKER_RACCS ( 11, 27) =  0.110696E+01
  PKER_RACCS ( 11, 28) =  0.112229E+01
  PKER_RACCS ( 11, 29) =  0.113498E+01
  PKER_RACCS ( 11, 30) =  0.114547E+01
  PKER_RACCS ( 11, 31) =  0.115414E+01
  PKER_RACCS ( 11, 32) =  0.116132E+01
  PKER_RACCS ( 11, 33) =  0.116726E+01
  PKER_RACCS ( 11, 34) =  0.117218E+01
  PKER_RACCS ( 11, 35) =  0.117625E+01
  PKER_RACCS ( 11, 36) =  0.117961E+01
  PKER_RACCS ( 11, 37) =  0.118240E+01
  PKER_RACCS ( 11, 38) =  0.118470E+01
  PKER_RACCS ( 11, 39) =  0.118661E+01
  PKER_RACCS ( 11, 40) =  0.118819E+01
  PKER_RACCS ( 12,  1) =  0.137765E+02
  PKER_RACCS ( 12,  2) =  0.110532E+02
  PKER_RACCS ( 12,  3) =  0.880887E+01
  PKER_RACCS ( 12,  4) =  0.696546E+01
  PKER_RACCS ( 12,  5) =  0.545739E+01
  PKER_RACCS ( 12,  6) =  0.422884E+01
  PKER_RACCS ( 12,  7) =  0.323193E+01
  PKER_RACCS ( 12,  8) =  0.242617E+01
  PKER_RACCS ( 12,  9) =  0.177863E+01
  PKER_RACCS ( 12, 10) =  0.126480E+01
  PKER_RACCS ( 12, 11) =  0.869502E+00
  PKER_RACCS ( 12, 12) =  0.586444E+00
  PKER_RACCS ( 12, 13) =  0.413638E+00
  PKER_RACCS ( 12, 14) =  0.345906E+00
  PKER_RACCS ( 12, 15) =  0.364471E+00
  PKER_RACCS ( 12, 16) =  0.438529E+00
  PKER_RACCS ( 12, 17) =  0.535017E+00
  PKER_RACCS ( 12, 18) =  0.630497E+00
  PKER_RACCS ( 12, 19) =  0.714544E+00
  PKER_RACCS ( 12, 20) =  0.785149E+00
  PKER_RACCS ( 12, 21) =  0.843614E+00
  PKER_RACCS ( 12, 22) =  0.891886E+00
  PKER_RACCS ( 12, 23) =  0.931743E+00
  PKER_RACCS ( 12, 24) =  0.964664E+00
  PKER_RACCS ( 12, 25) =  0.991866E+00
  PKER_RACCS ( 12, 26) =  0.101435E+01
  PKER_RACCS ( 12, 27) =  0.103293E+01
  PKER_RACCS ( 12, 28) =  0.104830E+01
  PKER_RACCS ( 12, 29) =  0.106101E+01
  PKER_RACCS ( 12, 30) =  0.107152E+01
  PKER_RACCS ( 12, 31) =  0.108022E+01
  PKER_RACCS ( 12, 32) =  0.108741E+01
  PKER_RACCS ( 12, 33) =  0.109336E+01
  PKER_RACCS ( 12, 34) =  0.109828E+01
  PKER_RACCS ( 12, 35) =  0.110236E+01
  PKER_RACCS ( 12, 36) =  0.110573E+01
  PKER_RACCS ( 12, 37) =  0.110852E+01
  PKER_RACCS ( 12, 38) =  0.111082E+01
  PKER_RACCS ( 12, 39) =  0.111273E+01
  PKER_RACCS ( 12, 40) =  0.111431E+01
  PKER_RACCS ( 13,  1) =  0.140319E+02
  PKER_RACCS ( 13,  2) =  0.113018E+02
  PKER_RACCS ( 13,  3) =  0.904571E+01
  PKER_RACCS ( 13,  4) =  0.718591E+01
  PKER_RACCS ( 13,  5) =  0.565791E+01
  PKER_RACCS ( 13,  6) =  0.440756E+01
  PKER_RACCS ( 13,  7) =  0.338881E+01
  PKER_RACCS ( 13,  8) =  0.256245E+01
  PKER_RACCS ( 13,  9) =  0.189581E+01
  PKER_RACCS ( 13, 10) =  0.136334E+01
  PKER_RACCS ( 13, 11) =  0.947657E+00
  PKER_RACCS ( 13, 12) =  0.639932E+00
  PKER_RACCS ( 13, 13) =  0.437803E+00
  PKER_RACCS ( 13, 14) =  0.338008E+00
  PKER_RACCS ( 13, 15) =  0.328139E+00
  PKER_RACCS ( 13, 16) =  0.382351E+00
  PKER_RACCS ( 13, 17) =  0.468516E+00
  PKER_RACCS ( 13, 18) =  0.560309E+00
  PKER_RACCS ( 13, 19) =  0.643677E+00
  PKER_RACCS ( 13, 20) =  0.714489E+00
  PKER_RACCS ( 13, 21) =  0.773275E+00
  PKER_RACCS ( 13, 22) =  0.821808E+00
  PKER_RACCS ( 13, 23) =  0.861858E+00
  PKER_RACCS ( 13, 24) =  0.894921E+00
  PKER_RACCS ( 13, 25) =  0.922228E+00
  PKER_RACCS ( 13, 26) =  0.944789E+00
  PKER_RACCS ( 13, 27) =  0.963435E+00
  PKER_RACCS ( 13, 28) =  0.978847E+00
  PKER_RACCS ( 13, 29) =  0.991591E+00
  PKER_RACCS ( 13, 30) =  0.100213E+01
  PKER_RACCS ( 13, 31) =  0.101084E+01
  PKER_RACCS ( 13, 32) =  0.101805E+01
  PKER_RACCS ( 13, 33) =  0.102401E+01
  PKER_RACCS ( 13, 34) =  0.102895E+01
  PKER_RACCS ( 13, 35) =  0.103303E+01
  PKER_RACCS ( 13, 36) =  0.103640E+01
  PKER_RACCS ( 13, 37) =  0.103920E+01
  PKER_RACCS ( 13, 38) =  0.104151E+01
  PKER_RACCS ( 13, 39) =  0.104342E+01
  PKER_RACCS ( 13, 40) =  0.104500E+01
  PKER_RACCS ( 14,  1) =  0.142526E+02
  PKER_RACCS ( 14,  2) =  0.115209E+02
  PKER_RACCS ( 14,  3) =  0.925951E+01
  PKER_RACCS ( 14,  4) =  0.739026E+01
  PKER_RACCS ( 14,  5) =  0.584892E+01
  PKER_RACCS ( 14,  6) =  0.458219E+01
  PKER_RACCS ( 14,  7) =  0.354538E+01
  PKER_RACCS ( 14,  8) =  0.270063E+01
  PKER_RACCS ( 14,  9) =  0.201611E+01
  PKER_RACCS ( 14, 10) =  0.146603E+01
  PKER_RACCS ( 14, 11) =  0.103157E+01
  PKER_RACCS ( 14, 12) =  0.701686E+00
  PKER_RACCS ( 14, 13) =  0.472410E+00
  PKER_RACCS ( 14, 14) =  0.342083E+00
  PKER_RACCS ( 14, 15) =  0.303081E+00
  PKER_RACCS ( 14, 16) =  0.334956E+00
  PKER_RACCS ( 14, 17) =  0.408312E+00
  PKER_RACCS ( 14, 18) =  0.494848E+00
  PKER_RACCS ( 14, 19) =  0.576946E+00
  PKER_RACCS ( 14, 20) =  0.647859E+00
  PKER_RACCS ( 14, 21) =  0.707002E+00
  PKER_RACCS ( 14, 22) =  0.755849E+00
  PKER_RACCS ( 14, 23) =  0.796134E+00
  PKER_RACCS ( 14, 24) =  0.829370E+00
  PKER_RACCS ( 14, 25) =  0.856804E+00
  PKER_RACCS ( 14, 26) =  0.879461E+00
  PKER_RACCS ( 14, 27) =  0.898177E+00
  PKER_RACCS ( 14, 28) =  0.913644E+00
  PKER_RACCS ( 14, 29) =  0.926428E+00
  PKER_RACCS ( 14, 30) =  0.936997E+00
  PKER_RACCS ( 14, 31) =  0.945736E+00
  PKER_RACCS ( 14, 32) =  0.952963E+00
  PKER_RACCS ( 14, 33) =  0.958940E+00
  PKER_RACCS ( 14, 34) =  0.963884E+00
  PKER_RACCS ( 14, 35) =  0.967973E+00
  PKER_RACCS ( 14, 36) =  0.971356E+00
  PKER_RACCS ( 14, 37) =  0.974154E+00
  PKER_RACCS ( 14, 38) =  0.976470E+00
  PKER_RACCS ( 14, 39) =  0.978385E+00
  PKER_RACCS ( 14, 40) =  0.979971E+00
  PKER_RACCS ( 15,  1) =  0.144408E+02
  PKER_RACCS ( 15,  2) =  0.117106E+02
  PKER_RACCS ( 15,  3) =  0.944817E+01
  PKER_RACCS ( 15,  4) =  0.757478E+01
  PKER_RACCS ( 15,  5) =  0.602588E+01
  PKER_RACCS ( 15,  6) =  0.474829E+01
  PKER_RACCS ( 15,  7) =  0.369801E+01
  PKER_RACCS ( 15,  8) =  0.283819E+01
  PKER_RACCS ( 15,  9) =  0.213794E+01
  PKER_RACCS ( 15, 10) =  0.157180E+01
  PKER_RACCS ( 15, 11) =  0.112020E+01
  PKER_RACCS ( 15, 12) =  0.770447E+00
  PKER_RACCS ( 15, 13) =  0.516893E+00
  PKER_RACCS ( 15, 14) =  0.357861E+00
  PKER_RACCS ( 15, 15) =  0.289607E+00
  PKER_RACCS ( 15, 16) =  0.297216E+00
  PKER_RACCS ( 15, 17) =  0.354956E+00
  PKER_RACCS ( 15, 18) =  0.434258E+00
  PKER_RACCS ( 15, 19) =  0.514182E+00
  PKER_RACCS ( 15, 20) =  0.584974E+00
  PKER_RACCS ( 15, 21) =  0.644491E+00
  PKER_RACCS ( 15, 22) =  0.693710E+00
  PKER_RACCS ( 15, 23) =  0.734280E+00
  PKER_RACCS ( 15, 24) =  0.767726E+00
  PKER_RACCS ( 15, 25) =  0.795315E+00
  PKER_RACCS ( 15, 26) =  0.818087E+00
  PKER_RACCS ( 15, 27) =  0.836890E+00
  PKER_RACCS ( 15, 28) =  0.852422E+00
  PKER_RACCS ( 15, 29) =  0.865255E+00
  PKER_RACCS ( 15, 30) =  0.875862E+00
  PKER_RACCS ( 15, 31) =  0.884630E+00
  PKER_RACCS ( 15, 32) =  0.891879E+00
  PKER_RACCS ( 15, 33) =  0.897873E+00
  PKER_RACCS ( 15, 34) =  0.902830E+00
  PKER_RACCS ( 15, 35) =  0.906929E+00
  PKER_RACCS ( 15, 36) =  0.910320E+00
  PKER_RACCS ( 15, 37) =  0.913125E+00
  PKER_RACCS ( 15, 38) =  0.915446E+00
  PKER_RACCS ( 15, 39) =  0.917365E+00
  PKER_RACCS ( 15, 40) =  0.918953E+00
  PKER_RACCS ( 16,  1) =  0.146000E+02
  PKER_RACCS ( 16,  2) =  0.118728E+02
  PKER_RACCS ( 16,  3) =  0.961176E+01
  PKER_RACCS ( 16,  4) =  0.773776E+01
  PKER_RACCS ( 16,  5) =  0.618568E+01
  PKER_RACCS ( 16,  6) =  0.490207E+01
  PKER_RACCS ( 16,  7) =  0.384296E+01
  PKER_RACCS ( 16,  8) =  0.297203E+01
  PKER_RACCS ( 16,  9) =  0.225904E+01
  PKER_RACCS ( 16, 10) =  0.167906E+01
  PKER_RACCS ( 16, 11) =  0.121230E+01
  PKER_RACCS ( 16, 12) =  0.844921E+00
  PKER_RACCS ( 16, 13) =  0.569587E+00
  PKER_RACCS ( 16, 14) =  0.384481E+00
  PKER_RACCS ( 16, 15) =  0.287547E+00
  PKER_RACCS ( 16, 16) =  0.269381E+00
  PKER_RACCS ( 16, 17) =  0.308942E+00
  PKER_RACCS ( 16, 18) =  0.378718E+00
  PKER_RACCS ( 16, 19) =  0.455285E+00
  PKER_RACCS ( 16, 20) =  0.525584E+00
  PKER_RACCS ( 16, 21) =  0.585450E+00
  PKER_RACCS ( 16, 22) =  0.635102E+00
  PKER_RACCS ( 16, 23) =  0.676017E+00
  PKER_RACCS ( 16, 24) =  0.709718E+00
  PKER_RACCS ( 16, 25) =  0.737496E+00
  PKER_RACCS ( 16, 26) =  0.760407E+00
  PKER_RACCS ( 16, 27) =  0.779315E+00
  PKER_RACCS ( 16, 28) =  0.794925E+00
  PKER_RACCS ( 16, 29) =  0.807818E+00
  PKER_RACCS ( 16, 30) =  0.818470E+00
  PKER_RACCS ( 16, 31) =  0.827272E+00
  PKER_RACCS ( 16, 32) =  0.834548E+00
  PKER_RACCS ( 16, 33) =  0.840562E+00
  PKER_RACCS ( 16, 34) =  0.845535E+00
  PKER_RACCS ( 16, 35) =  0.849647E+00
  PKER_RACCS ( 16, 36) =  0.853048E+00
  PKER_RACCS ( 16, 37) =  0.855860E+00
  PKER_RACCS ( 16, 38) =  0.858187E+00
  PKER_RACCS ( 16, 39) =  0.860111E+00
  PKER_RACCS ( 16, 40) =  0.861703E+00
  PKER_RACCS ( 17,  1) =  0.147341E+02
  PKER_RACCS ( 17,  2) =  0.120103E+02
  PKER_RACCS ( 17,  3) =  0.975189E+01
  PKER_RACCS ( 17,  4) =  0.787932E+01
  PKER_RACCS ( 17,  5) =  0.632699E+01
  PKER_RACCS ( 17,  6) =  0.504099E+01
  PKER_RACCS ( 17,  7) =  0.397709E+01
  PKER_RACCS ( 17,  8) =  0.309897E+01
  PKER_RACCS ( 17,  9) =  0.237672E+01
  PKER_RACCS ( 17, 10) =  0.178573E+01
  PKER_RACCS ( 17, 11) =  0.130626E+01
  PKER_RACCS ( 17, 12) =  0.923760E+00
  PKER_RACCS ( 17, 13) =  0.629526E+00
  PKER_RACCS ( 17, 14) =  0.420645E+00
  PKER_RACCS ( 17, 15) =  0.296483E+00
  PKER_RACCS ( 17, 16) =  0.251869E+00
  PKER_RACCS ( 17, 17) =  0.270840E+00
  PKER_RACCS ( 17, 18) =  0.328636E+00
  PKER_RACCS ( 17, 19) =  0.400275E+00
  PKER_RACCS ( 17, 20) =  0.469486E+00
  PKER_RACCS ( 17, 21) =  0.529608E+00
  PKER_RACCS ( 17, 22) =  0.579747E+00
  PKER_RACCS ( 17, 23) =  0.621076E+00
  PKER_RACCS ( 17, 24) =  0.655088E+00
  PKER_RACCS ( 17, 25) =  0.683094E+00
  PKER_RACCS ( 17, 26) =  0.706174E+00
  PKER_RACCS ( 17, 27) =  0.725208E+00
  PKER_RACCS ( 17, 28) =  0.740913E+00
  PKER_RACCS ( 17, 29) =  0.753877E+00
  PKER_RACCS ( 17, 30) =  0.764583E+00
  PKER_RACCS ( 17, 31) =  0.773427E+00
  PKER_RACCS ( 17, 32) =  0.780735E+00
  PKER_RACCS ( 17, 33) =  0.786774E+00
  PKER_RACCS ( 17, 34) =  0.791766E+00
  PKER_RACCS ( 17, 35) =  0.795893E+00
  PKER_RACCS ( 17, 36) =  0.799305E+00
  PKER_RACCS ( 17, 37) =  0.802126E+00
  PKER_RACCS ( 17, 38) =  0.804459E+00
  PKER_RACCS ( 17, 39) =  0.806389E+00
  PKER_RACCS ( 17, 40) =  0.807985E+00
  PKER_RACCS ( 18,  1) =  0.148471E+02
  PKER_RACCS ( 18,  2) =  0.121265E+02
  PKER_RACCS ( 18,  3) =  0.987110E+01
  PKER_RACCS ( 18,  4) =  0.800089E+01
  PKER_RACCS ( 18,  5) =  0.644994E+01
  PKER_RACCS ( 18,  6) =  0.516395E+01
  PKER_RACCS ( 18,  7) =  0.409829E+01
  PKER_RACCS ( 18,  8) =  0.321639E+01
  PKER_RACCS ( 18,  9) =  0.248825E+01
  PKER_RACCS ( 18, 10) =  0.188937E+01
  PKER_RACCS ( 18, 11) =  0.140001E+01
  PKER_RACCS ( 18, 12) =  0.100512E+01
  PKER_RACCS ( 18, 13) =  0.694965E+00
  PKER_RACCS ( 18, 14) =  0.465425E+00
  PKER_RACCS ( 18, 15) =  0.316022E+00
  PKER_RACCS ( 18, 16) =  0.245025E+00
  PKER_RACCS ( 18, 17) =  0.241586E+00
  PKER_RACCS ( 18, 18) =  0.284650E+00
  PKER_RACCS ( 18, 19) =  0.349371E+00
  PKER_RACCS ( 18, 20) =  0.416569E+00
  PKER_RACCS ( 18, 21) =  0.476716E+00
  PKER_RACCS ( 18, 22) =  0.527374E+00
  PKER_RACCS ( 18, 23) =  0.569195E+00
  PKER_RACCS ( 18, 24) =  0.603581E+00
  PKER_RACCS ( 18, 25) =  0.631865E+00
  PKER_RACCS ( 18, 26) =  0.655150E+00
  PKER_RACCS ( 18, 27) =  0.674336E+00
  PKER_RACCS ( 18, 28) =  0.690155E+00
  PKER_RACCS ( 18, 29) =  0.703206E+00
  PKER_RACCS ( 18, 30) =  0.713977E+00
  PKER_RACCS ( 18, 31) =  0.722871E+00
  PKER_RACCS ( 18, 32) =  0.730217E+00
  PKER_RACCS ( 18, 33) =  0.736286E+00
  PKER_RACCS ( 18, 34) =  0.741300E+00
  PKER_RACCS ( 18, 35) =  0.745445E+00
  PKER_RACCS ( 18, 36) =  0.748871E+00
  PKER_RACCS ( 18, 37) =  0.751703E+00
  PKER_RACCS ( 18, 38) =  0.754044E+00
  PKER_RACCS ( 18, 39) =  0.755981E+00
  PKER_RACCS ( 18, 40) =  0.757582E+00
  PKER_RACCS ( 19,  1) =  0.149424E+02
  PKER_RACCS ( 19,  2) =  0.122248E+02
  PKER_RACCS ( 19,  3) =  0.997223E+01
  PKER_RACCS ( 19,  4) =  0.810461E+01
  PKER_RACCS ( 19,  5) =  0.655579E+01
  PKER_RACCS ( 19,  6) =  0.527114E+01
  PKER_RACCS ( 19,  7) =  0.420569E+01
  PKER_RACCS ( 19,  8) =  0.332252E+01
  PKER_RACCS ( 19,  9) =  0.259139E+01
  PKER_RACCS ( 19, 10) =  0.198760E+01
  PKER_RACCS ( 19, 11) =  0.149127E+01
  PKER_RACCS ( 19, 12) =  0.108695E+01
  PKER_RACCS ( 19, 13) =  0.763957E+00
  PKER_RACCS ( 19, 14) =  0.516893E+00
  PKER_RACCS ( 19, 15) =  0.345184E+00
  PKER_RACCS ( 19, 16) =  0.248721E+00
  PKER_RACCS ( 19, 17) =  0.221527E+00
  PKER_RACCS ( 19, 18) =  0.247368E+00
  PKER_RACCS ( 19, 19) =  0.302857E+00
  PKER_RACCS ( 19, 20) =  0.366792E+00
  PKER_RACCS ( 19, 21) =  0.426569E+00
  PKER_RACCS ( 19, 22) =  0.477725E+00
  PKER_RACCS ( 19, 23) =  0.520116E+00
  PKER_RACCS ( 19, 24) =  0.554955E+00
  PKER_RACCS ( 19, 25) =  0.583575E+00
  PKER_RACCS ( 19, 26) =  0.607108E+00
  PKER_RACCS ( 19, 27) =  0.626479E+00
  PKER_RACCS ( 19, 28) =  0.642436E+00
  PKER_RACCS ( 19, 29) =  0.655590E+00
  PKER_RACCS ( 19, 30) =  0.666441E+00
  PKER_RACCS ( 19, 31) =  0.675394E+00
  PKER_RACCS ( 19, 32) =  0.682786E+00
  PKER_RACCS ( 19, 33) =  0.688890E+00
  PKER_RACCS ( 19, 34) =  0.693932E+00
  PKER_RACCS ( 19, 35) =  0.698097E+00
  PKER_RACCS ( 19, 36) =  0.701540E+00
  PKER_RACCS ( 19, 37) =  0.704385E+00
  PKER_RACCS ( 19, 38) =  0.706736E+00
  PKER_RACCS ( 19, 39) =  0.708680E+00
  PKER_RACCS ( 19, 40) =  0.710287E+00
  PKER_RACCS ( 20,  1) =  0.150233E+02
  PKER_RACCS ( 20,  2) =  0.123081E+02
  PKER_RACCS ( 20,  3) =  0.100581E+02
  PKER_RACCS ( 20,  4) =  0.819292E+01
  PKER_RACCS ( 20,  5) =  0.664638E+01
  PKER_RACCS ( 20,  6) =  0.536365E+01
  PKER_RACCS ( 20,  7) =  0.429950E+01
  PKER_RACCS ( 20,  8) =  0.341669E+01
  PKER_RACCS ( 20,  9) =  0.268467E+01
  PKER_RACCS ( 20, 10) =  0.207848E+01
  PKER_RACCS ( 20, 11) =  0.157790E+01
  PKER_RACCS ( 20, 12) =  0.116706E+01
  PKER_RACCS ( 20, 13) =  0.834456E+00
  PKER_RACCS ( 20, 14) =  0.573438E+00
  PKER_RACCS ( 20, 15) =  0.382407E+00
  PKER_RACCS ( 20, 16) =  0.262345E+00
  PKER_RACCS ( 20, 17) =  0.211120E+00
  PKER_RACCS ( 20, 18) =  0.217516E+00
  PKER_RACCS ( 20, 19) =  0.261278E+00
  PKER_RACCS ( 20, 20) =  0.320279E+00
  PKER_RACCS ( 20, 21) =  0.379014E+00
  PKER_RACCS ( 20, 22) =  0.430562E+00
  PKER_RACCS ( 20, 23) =  0.473590E+00
  PKER_RACCS ( 20, 24) =  0.508970E+00
  PKER_RACCS ( 20, 25) =  0.537995E+00
  PKER_RACCS ( 20, 26) =  0.561829E+00
  PKER_RACCS ( 20, 27) =  0.581423E+00
  PKER_RACCS ( 20, 28) =  0.597547E+00
  PKER_RACCS ( 20, 29) =  0.610827E+00
  PKER_RACCS ( 20, 30) =  0.621772E+00
  PKER_RACCS ( 20, 31) =  0.630798E+00
  PKER_RACCS ( 20, 32) =  0.638244E+00
  PKER_RACCS ( 20, 33) =  0.644390E+00
  PKER_RACCS ( 20, 34) =  0.649465E+00
  PKER_RACCS ( 20, 35) =  0.653656E+00
  PKER_RACCS ( 20, 36) =  0.657117E+00
  PKER_RACCS ( 20, 37) =  0.659978E+00
  PKER_RACCS ( 20, 38) =  0.662341E+00
  PKER_RACCS ( 20, 39) =  0.664294E+00
  PKER_RACCS ( 20, 40) =  0.665909E+00
  PKER_RACCS ( 21,  1) =  0.150922E+02
  PKER_RACCS ( 21,  2) =  0.123791E+02
  PKER_RACCS ( 21,  3) =  0.101311E+02
  PKER_RACCS ( 21,  4) =  0.826818E+01
  PKER_RACCS ( 21,  5) =  0.672379E+01
  PKER_RACCS ( 21,  6) =  0.544309E+01
  PKER_RACCS ( 21,  7) =  0.438067E+01
  PKER_RACCS ( 21,  8) =  0.349910E+01
  PKER_RACCS ( 21,  9) =  0.276755E+01
  PKER_RACCS ( 21, 10) =  0.216074E+01
  PKER_RACCS ( 21, 11) =  0.165815E+01
  PKER_RACCS ( 21, 12) =  0.124340E+01
  PKER_RACCS ( 21, 13) =  0.904204E+00
  PKER_RACCS ( 21, 14) =  0.632746E+00
  PKER_RACCS ( 21, 15) =  0.426104E+00
  PKER_RACCS ( 21, 16) =  0.285124E+00
  PKER_RACCS ( 21, 17) =  0.210547E+00
  PKER_RACCS ( 21, 18) =  0.196012E+00
  PKER_RACCS ( 21, 19) =  0.225390E+00
  PKER_RACCS ( 21, 20) =  0.277352E+00
  PKER_RACCS ( 21, 21) =  0.334022E+00
  PKER_RACCS ( 21, 22) =  0.385682E+00
  PKER_RACCS ( 21, 23) =  0.429377E+00
  PKER_RACCS ( 21, 24) =  0.465390E+00
  PKER_RACCS ( 21, 25) =  0.494904E+00
  PKER_RACCS ( 21, 26) =  0.519101E+00
  PKER_RACCS ( 21, 27) =  0.538964E+00
  PKER_RACCS ( 21, 28) =  0.555290E+00
  PKER_RACCS ( 21, 29) =  0.568721E+00
  PKER_RACCS ( 21, 30) =  0.579780E+00
  PKER_RACCS ( 21, 31) =  0.588892E+00
  PKER_RACCS ( 21, 32) =  0.596405E+00
  PKER_RACCS ( 21, 33) =  0.602602E+00
  PKER_RACCS ( 21, 34) =  0.607715E+00
  PKER_RACCS ( 21, 35) =  0.611936E+00
  PKER_RACCS ( 21, 36) =  0.615421E+00
  PKER_RACCS ( 21, 37) =  0.618300E+00
  PKER_RACCS ( 21, 38) =  0.620677E+00
  PKER_RACCS ( 21, 39) =  0.622642E+00
  PKER_RACCS ( 21, 40) =  0.624265E+00
  PKER_RACCS ( 22,  1) =  0.151514E+02
  PKER_RACCS ( 22,  2) =  0.124399E+02
  PKER_RACCS ( 22,  3) =  0.101937E+02
  PKER_RACCS ( 22,  4) =  0.833253E+01
  PKER_RACCS ( 22,  5) =  0.679003E+01
  PKER_RACCS ( 22,  6) =  0.551121E+01
  PKER_RACCS ( 22,  7) =  0.445059E+01
  PKER_RACCS ( 22,  8) =  0.357060E+01
  PKER_RACCS ( 22,  9) =  0.284022E+01
  PKER_RACCS ( 22, 10) =  0.223394E+01
  PKER_RACCS ( 22, 11) =  0.173091E+01
  PKER_RACCS ( 22, 12) =  0.131432E+01
  PKER_RACCS ( 22, 13) =  0.971179E+00
  PKER_RACCS ( 22, 14) =  0.692512E+00
  PKER_RACCS ( 22, 15) =  0.473921E+00
  PKER_RACCS ( 22, 16) =  0.315613E+00
  PKER_RACCS ( 22, 17) =  0.219438E+00
  PKER_RACCS ( 22, 18) =  0.183228E+00
  PKER_RACCS ( 22, 19) =  0.195928E+00
  PKER_RACCS ( 22, 20) =  0.238467E+00
  PKER_RACCS ( 22, 21) =  0.291650E+00
  PKER_RACCS ( 22, 22) =  0.342933E+00
  PKER_RACCS ( 22, 23) =  0.387253E+00
  PKER_RACCS ( 22, 24) =  0.423987E+00
  PKER_RACCS ( 22, 25) =  0.454083E+00
  PKER_RACCS ( 22, 26) =  0.478717E+00
  PKER_RACCS ( 22, 27) =  0.498906E+00
  PKER_RACCS ( 22, 28) =  0.515474E+00
  PKER_RACCS ( 22, 29) =  0.529087E+00
  PKER_RACCS ( 22, 30) =  0.540283E+00
  PKER_RACCS ( 22, 31) =  0.549500E+00
  PKER_RACCS ( 22, 32) =  0.557092E+00
  PKER_RACCS ( 22, 33) =  0.563350E+00
  PKER_RACCS ( 22, 34) =  0.568510E+00
  PKER_RACCS ( 22, 35) =  0.572767E+00
  PKER_RACCS ( 22, 36) =  0.576280E+00
  PKER_RACCS ( 22, 37) =  0.579180E+00
  PKER_RACCS ( 22, 38) =  0.581575E+00
  PKER_RACCS ( 22, 39) =  0.583552E+00
  PKER_RACCS ( 22, 40) =  0.585186E+00
  PKER_RACCS ( 23,  1) =  0.152025E+02
  PKER_RACCS ( 23,  2) =  0.124923E+02
  PKER_RACCS ( 23,  3) =  0.102475E+02
  PKER_RACCS ( 23,  4) =  0.838786E+01
  PKER_RACCS ( 23,  5) =  0.684693E+01
  PKER_RACCS ( 23,  6) =  0.556974E+01
  PKER_RACCS ( 23,  7) =  0.451078E+01
  PKER_RACCS ( 23,  8) =  0.363239E+01
  PKER_RACCS ( 23,  9) =  0.290344E+01
  PKER_RACCS ( 23, 10) =  0.229827E+01
  PKER_RACCS ( 23, 11) =  0.179578E+01
  PKER_RACCS ( 23, 12) =  0.137880E+01
  PKER_RACCS ( 23, 13) =  0.103376E+01
  PKER_RACCS ( 23, 14) =  0.750698E+00
  PKER_RACCS ( 23, 15) =  0.523775E+00
  PKER_RACCS ( 23, 16) =  0.351748E+00
  PKER_RACCS ( 23, 17) =  0.236670E+00
  PKER_RACCS ( 23, 18) =  0.179378E+00
  PKER_RACCS ( 23, 19) =  0.173687E+00
  PKER_RACCS ( 23, 20) =  0.204334E+00
  PKER_RACCS ( 23, 21) =  0.252182E+00
  PKER_RACCS ( 23, 22) =  0.302250E+00
  PKER_RACCS ( 23, 23) =  0.347024E+00
  PKER_RACCS ( 23, 24) =  0.384540E+00
  PKER_RACCS ( 23, 25) =  0.415319E+00
  PKER_RACCS ( 23, 26) =  0.440475E+00
  PKER_RACCS ( 23, 27) =  0.461054E+00
  PKER_RACCS ( 23, 28) =  0.477914E+00
  PKER_RACCS ( 23, 29) =  0.491746E+00
  PKER_RACCS ( 23, 30) =  0.503108E+00
  PKER_RACCS ( 23, 31) =  0.512450E+00
  PKER_RACCS ( 23, 32) =  0.520137E+00
  PKER_RACCS ( 23, 33) =  0.526468E+00
  PKER_RACCS ( 23, 34) =  0.531684E+00
  PKER_RACCS ( 23, 35) =  0.535984E+00
  PKER_RACCS ( 23, 36) =  0.539531E+00
  PKER_RACCS ( 23, 37) =  0.542457E+00
  PKER_RACCS ( 23, 38) =  0.544872E+00
  PKER_RACCS ( 23, 39) =  0.546865E+00
  PKER_RACCS ( 23, 40) =  0.548511E+00
  PKER_RACCS ( 24,  1) =  0.152471E+02
  PKER_RACCS ( 24,  2) =  0.125379E+02
  PKER_RACCS ( 24,  3) =  0.102942E+02
  PKER_RACCS ( 24,  4) =  0.843571E+01
  PKER_RACCS ( 24,  5) =  0.689606E+01
  PKER_RACCS ( 24,  6) =  0.562023E+01
  PKER_RACCS ( 24,  7) =  0.456270E+01
  PKER_RACCS ( 24,  8) =  0.368577E+01
  PKER_RACCS ( 24,  9) =  0.295826E+01
  PKER_RACCS ( 24, 10) =  0.235439E+01
  PKER_RACCS ( 24, 11) =  0.185292E+01
  PKER_RACCS ( 24, 12) =  0.143643E+01
  PKER_RACCS ( 24, 13) =  0.109091E+01
  PKER_RACCS ( 24, 14) =  0.805605E+00
  PKER_RACCS ( 24, 15) =  0.573417E+00
  PKER_RACCS ( 24, 16) =  0.391471E+00
  PKER_RACCS ( 24, 17) =  0.260876E+00
  PKER_RACCS ( 24, 18) =  0.184180E+00
  PKER_RACCS ( 24, 19) =  0.159396E+00
  PKER_RACCS ( 24, 20) =  0.175814E+00
  PKER_RACCS ( 24, 21) =  0.216094E+00
  PKER_RACCS ( 24, 22) =  0.263726E+00
  PKER_RACCS ( 24, 23) =  0.308551E+00
  PKER_RACCS ( 24, 24) =  0.346845E+00
  PKER_RACCS ( 24, 25) =  0.378402E+00
  PKER_RACCS ( 24, 26) =  0.404175E+00
  PKER_RACCS ( 24, 27) =  0.425220E+00
  PKER_RACCS ( 24, 28) =  0.442431E+00
  PKER_RACCS ( 24, 29) =  0.456527E+00
  PKER_RACCS ( 24, 30) =  0.468088E+00
  PKER_RACCS ( 24, 31) =  0.477580E+00
  PKER_RACCS ( 24, 32) =  0.485382E+00
  PKER_RACCS ( 24, 33) =  0.491800E+00
  PKER_RACCS ( 24, 34) =  0.497083E+00
  PKER_RACCS ( 24, 35) =  0.501435E+00
  PKER_RACCS ( 24, 36) =  0.505022E+00
  PKER_RACCS ( 24, 37) =  0.507979E+00
  PKER_RACCS ( 24, 38) =  0.510418E+00
  PKER_RACCS ( 24, 39) =  0.512430E+00
  PKER_RACCS ( 24, 40) =  0.514090E+00
  PKER_RACCS ( 25,  1) =  0.152861E+02
  PKER_RACCS ( 25,  2) =  0.125778E+02
  PKER_RACCS ( 25,  3) =  0.103349E+02
  PKER_RACCS ( 25,  4) =  0.847739E+01
  PKER_RACCS ( 25,  5) =  0.693876E+01
  PKER_RACCS ( 25,  6) =  0.566404E+01
  PKER_RACCS ( 25,  7) =  0.460768E+01
  PKER_RACCS ( 25,  8) =  0.373200E+01
  PKER_RACCS ( 25,  9) =  0.300578E+01
  PKER_RACCS ( 25, 10) =  0.240320E+01
  PKER_RACCS ( 25, 11) =  0.190291E+01
  PKER_RACCS ( 25, 12) =  0.148735E+01
  PKER_RACCS ( 25, 13) =  0.114219E+01
  PKER_RACCS ( 25, 14) =  0.856136E+00
  PKER_RACCS ( 25, 15) =  0.621029E+00
  PKER_RACCS ( 25, 16) =  0.432440E+00
  PKER_RACCS ( 25, 17) =  0.290169E+00
  PKER_RACCS ( 25, 18) =  0.196768E+00
  PKER_RACCS ( 25, 19) =  0.153201E+00
  PKER_RACCS ( 25, 20) =  0.153672E+00
  PKER_RACCS ( 25, 21) =  0.184048E+00
  PKER_RACCS ( 25, 22) =  0.227585E+00
  PKER_RACCS ( 25, 23) =  0.271783E+00
  PKER_RACCS ( 25, 24) =  0.310728E+00
  PKER_RACCS ( 25, 25) =  0.343135E+00
  PKER_RACCS ( 25, 26) =  0.369625E+00
  PKER_RACCS ( 25, 27) =  0.391222E+00
  PKER_RACCS ( 25, 28) =  0.408850E+00
  PKER_RACCS ( 25, 29) =  0.423262E+00
  PKER_RACCS ( 25, 30) =  0.435061E+00
  PKER_RACCS ( 25, 31) =  0.444734E+00
  PKER_RACCS ( 25, 32) =  0.452673E+00
  PKER_RACCS ( 25, 33) =  0.459196E+00
  PKER_RACCS ( 25, 34) =  0.464560E+00
  PKER_RACCS ( 25, 35) =  0.468974E+00
  PKER_RACCS ( 25, 36) =  0.472608E+00
  PKER_RACCS ( 25, 37) =  0.475602E+00
  PKER_RACCS ( 25, 38) =  0.478070E+00
  PKER_RACCS ( 25, 39) =  0.480104E+00
  PKER_RACCS ( 25, 40) =  0.481782E+00
  PKER_RACCS ( 26,  1) =  0.153206E+02
  PKER_RACCS ( 26,  2) =  0.126129E+02
  PKER_RACCS ( 26,  3) =  0.103707E+02
  PKER_RACCS ( 26,  4) =  0.851394E+01
  PKER_RACCS ( 26,  5) =  0.697612E+01
  PKER_RACCS ( 26,  6) =  0.570228E+01
  PKER_RACCS ( 26,  7) =  0.464688E+01
  PKER_RACCS ( 26,  8) =  0.377223E+01
  PKER_RACCS ( 26,  9) =  0.304711E+01
  PKER_RACCS ( 26, 10) =  0.244567E+01
  PKER_RACCS ( 26, 11) =  0.194653E+01
  PKER_RACCS ( 26, 12) =  0.153202E+01
  PKER_RACCS ( 26, 13) =  0.118766E+01
  PKER_RACCS ( 26, 14) =  0.901746E+00
  PKER_RACCS ( 26, 15) =  0.665390E+00
  PKER_RACCS ( 26, 16) =  0.472866E+00
  PKER_RACCS ( 26, 17) =  0.322299E+00
  PKER_RACCS ( 26, 18) =  0.215438E+00
  PKER_RACCS ( 26, 19) =  0.154776E+00
  PKER_RACCS ( 26, 20) =  0.138541E+00
  PKER_RACCS ( 26, 21) =  0.156867E+00
  PKER_RACCS ( 26, 22) =  0.194320E+00
  PKER_RACCS ( 26, 23) =  0.236800E+00
  PKER_RACCS ( 26, 24) =  0.276076E+00
  PKER_RACCS ( 26, 25) =  0.309341E+00
  PKER_RACCS ( 26, 26) =  0.336639E+00
  PKER_RACCS ( 26, 27) =  0.358880E+00
  PKER_RACCS ( 26, 28) =  0.377001E+00
  PKER_RACCS ( 26, 29) =  0.391788E+00
  PKER_RACCS ( 26, 30) =  0.403872E+00
  PKER_RACCS ( 26, 31) =  0.413761E+00
  PKER_RACCS ( 26, 32) =  0.421865E+00
  PKER_RACCS ( 26, 33) =  0.428514E+00
  PKER_RACCS ( 26, 34) =  0.433974E+00
  PKER_RACCS ( 26, 35) =  0.438462E+00
  PKER_RACCS ( 26, 36) =  0.442154E+00
  PKER_RACCS ( 26, 37) =  0.445192E+00
  PKER_RACCS ( 26, 38) =  0.447694E+00
  PKER_RACCS ( 26, 39) =  0.449755E+00
  PKER_RACCS ( 26, 40) =  0.451454E+00
  PKER_RACCS ( 27,  1) =  0.153513E+02
  PKER_RACCS ( 27,  2) =  0.126440E+02
  PKER_RACCS ( 27,  3) =  0.104024E+02
  PKER_RACCS ( 27,  4) =  0.854622E+01
  PKER_RACCS ( 27,  5) =  0.700904E+01
  PKER_RACCS ( 27,  6) =  0.573589E+01
  PKER_RACCS ( 27,  7) =  0.468125E+01
  PKER_RACCS ( 27,  8) =  0.380743E+01
  PKER_RACCS ( 27,  9) =  0.308321E+01
  PKER_RACCS ( 27, 10) =  0.248274E+01
  PKER_RACCS ( 27, 11) =  0.198462E+01
  PKER_RACCS ( 27, 12) =  0.157114E+01
  PKER_RACCS ( 27, 13) =  0.122770E+01
  PKER_RACCS ( 27, 14) =  0.942392E+00
  PKER_RACCS ( 27, 15) =  0.705810E+00
  PKER_RACCS ( 27, 16) =  0.511279E+00
  PKER_RACCS ( 27, 17) =  0.355415E+00
  PKER_RACCS ( 27, 18) =  0.238463E+00
  PKER_RACCS ( 27, 19) =  0.163223E+00
  PKER_RACCS ( 27, 20) =  0.130700E+00
  PKER_RACCS ( 27, 21) =  0.135369E+00
  PKER_RACCS ( 27, 22) =  0.164571E+00
  PKER_RACCS ( 27, 23) =  0.203879E+00
  PKER_RACCS ( 27, 24) =  0.242868E+00
  PKER_RACCS ( 27, 25) =  0.276880E+00
  PKER_RACCS ( 27, 26) =  0.305049E+00
  PKER_RACCS ( 27, 27) =  0.328022E+00
  PKER_RACCS ( 27, 28) =  0.346718E+00
  PKER_RACCS ( 27, 29) =  0.361946E+00
  PKER_RACCS ( 27, 30) =  0.374368E+00
  PKER_RACCS ( 27, 31) =  0.384516E+00
  PKER_RACCS ( 27, 32) =  0.392817E+00
  PKER_RACCS ( 27, 33) =  0.399617E+00
  PKER_RACCS ( 27, 34) =  0.405192E+00
  PKER_RACCS ( 27, 35) =  0.409769E+00
  PKER_RACCS ( 27, 36) =  0.413529E+00
  PKER_RACCS ( 27, 37) =  0.416620E+00
  PKER_RACCS ( 27, 38) =  0.419163E+00
  PKER_RACCS ( 27, 39) =  0.421256E+00
  PKER_RACCS ( 27, 40) =  0.422980E+00
  PKER_RACCS ( 28,  1) =  0.153787E+02
  PKER_RACCS ( 28,  2) =  0.126718E+02
  PKER_RACCS ( 28,  3) =  0.104307E+02
  PKER_RACCS ( 28,  4) =  0.857492E+01
  PKER_RACCS ( 28,  5) =  0.703823E+01
  PKER_RACCS ( 28,  6) =  0.576563E+01
  PKER_RACCS ( 28,  7) =  0.471159E+01
  PKER_RACCS ( 28,  8) =  0.383843E+01
  PKER_RACCS ( 28,  9) =  0.311494E+01
  PKER_RACCS ( 28, 10) =  0.251526E+01
  PKER_RACCS ( 28, 11) =  0.201799E+01
  PKER_RACCS ( 28, 12) =  0.160542E+01
  PKER_RACCS ( 28, 13) =  0.126288E+01
  PKER_RACCS ( 28, 14) =  0.978347E+00
  PKER_RACCS ( 28, 15) =  0.742102E+00
  PKER_RACCS ( 28, 16) =  0.546792E+00
  PKER_RACCS ( 28, 17) =  0.387821E+00
  PKER_RACCS ( 28, 18) =  0.264011E+00
  PKER_RACCS ( 28, 19) =  0.177228E+00
  PKER_RACCS ( 28, 20) =  0.129810E+00
  PKER_RACCS ( 28, 21) =  0.120099E+00
  PKER_RACCS ( 28, 22) =  0.139117E+00
  PKER_RACCS ( 28, 23) =  0.173453E+00
  PKER_RACCS ( 28, 24) =  0.211216E+00
  PKER_RACCS ( 28, 25) =  0.245678E+00
  PKER_RACCS ( 28, 26) =  0.274712E+00
  PKER_RACCS ( 28, 27) =  0.298492E+00
  PKER_RACCS ( 28, 28) =  0.317842E+00
  PKER_RACCS ( 28, 29) =  0.333584E+00
  PKER_RACCS ( 28, 30) =  0.346404E+00
  PKER_RACCS ( 28, 31) =  0.356858E+00
  PKER_RACCS ( 28, 32) =  0.365393E+00
  PKER_RACCS ( 28, 33) =  0.372373E+00
  PKER_RACCS ( 28, 34) =  0.378086E+00
  PKER_RACCS ( 28, 35) =  0.382769E+00
  PKER_RACCS ( 28, 36) =  0.386611E+00
  PKER_RACCS ( 28, 37) =  0.389765E+00
  PKER_RACCS ( 28, 38) =  0.392357E+00
  PKER_RACCS ( 28, 39) =  0.394489E+00
  PKER_RACCS ( 28, 40) =  0.396242E+00
  PKER_RACCS ( 29,  1) =  0.154034E+02
  PKER_RACCS ( 29,  2) =  0.126968E+02
  PKER_RACCS ( 29,  3) =  0.104560E+02
  PKER_RACCS ( 29,  4) =  0.860059E+01
  PKER_RACCS ( 29,  5) =  0.706430E+01
  PKER_RACCS ( 29,  6) =  0.579212E+01
  PKER_RACCS ( 29,  7) =  0.473855E+01
  PKER_RACCS ( 29,  8) =  0.386591E+01
  PKER_RACCS ( 29,  9) =  0.314299E+01
  PKER_RACCS ( 29, 10) =  0.254395E+01
  PKER_RACCS ( 29, 11) =  0.204738E+01
  PKER_RACCS ( 29, 12) =  0.163556E+01
  PKER_RACCS ( 29, 13) =  0.129383E+01
  PKER_RACCS ( 29, 14) =  0.101007E+01
  PKER_RACCS ( 29, 15) =  0.774394E+00
  PKER_RACCS ( 29, 16) =  0.579032E+00
  PKER_RACCS ( 29, 17) =  0.418516E+00
  PKER_RACCS ( 29, 18) =  0.290262E+00
  PKER_RACCS ( 29, 19) =  0.194914E+00
  PKER_RACCS ( 29, 20) =  0.134958E+00
  PKER_RACCS ( 29, 21) =  0.111247E+00
  PKER_RACCS ( 29, 22) =  0.118691E+00
  PKER_RACCS ( 29, 23) =  0.146181E+00
  PKER_RACCS ( 29, 24) =  0.181396E+00
  PKER_RACCS ( 29, 25) =  0.215756E+00
  PKER_RACCS ( 29, 26) =  0.245535E+00
  PKER_RACCS ( 29, 27) =  0.270155E+00
  PKER_RACCS ( 29, 28) =  0.290229E+00
  PKER_RACCS ( 29, 29) =  0.306555E+00
  PKER_RACCS ( 29, 30) =  0.319836E+00
  PKER_RACCS ( 29, 31) =  0.330648E+00
  PKER_RACCS ( 29, 32) =  0.339462E+00
  PKER_RACCS ( 29, 33) =  0.346655E+00
  PKER_RACCS ( 29, 34) =  0.352533E+00
  PKER_RACCS ( 29, 35) =  0.357343E+00
  PKER_RACCS ( 29, 36) =  0.361282E+00
  PKER_RACCS ( 29, 37) =  0.364512E+00
  PKER_RACCS ( 29, 38) =  0.367163E+00
  PKER_RACCS ( 29, 39) =  0.369340E+00
  PKER_RACCS ( 29, 40) =  0.371129E+00
  PKER_RACCS ( 30,  1) =  0.154257E+02
  PKER_RACCS ( 30,  2) =  0.127194E+02
  PKER_RACCS ( 30,  3) =  0.104788E+02
  PKER_RACCS ( 30,  4) =  0.862370E+01
  PKER_RACCS ( 30,  5) =  0.708771E+01
  PKER_RACCS ( 30,  6) =  0.581587E+01
  PKER_RACCS ( 30,  7) =  0.476266E+01
  PKER_RACCS ( 30,  8) =  0.389043E+01
  PKER_RACCS ( 30,  9) =  0.316795E+01
  PKER_RACCS ( 30, 10) =  0.256941E+01
  PKER_RACCS ( 30, 11) =  0.207340E+01
  PKER_RACCS ( 30, 12) =  0.166220E+01
  PKER_RACCS ( 30, 13) =  0.132114E+01
  PKER_RACCS ( 30, 14) =  0.103807E+01
  PKER_RACCS ( 30, 15) =  0.803030E+00
  PKER_RACCS ( 30, 16) =  0.607970E+00
  PKER_RACCS ( 30, 17) =  0.446859E+00
  PKER_RACCS ( 30, 18) =  0.316050E+00
  PKER_RACCS ( 30, 19) =  0.214747E+00
  PKER_RACCS ( 30, 20) =  0.144869E+00
  PKER_RACCS ( 30, 21) =  0.108490E+00
  PKER_RACCS ( 30, 22) =  0.103788E+00
  PKER_RACCS ( 30, 23) =  0.122733E+00
  PKER_RACCS ( 30, 24) =  0.153869E+00
  PKER_RACCS ( 30, 25) =  0.187267E+00
  PKER_RACCS ( 30, 26) =  0.217494E+00
  PKER_RACCS ( 30, 27) =  0.242915E+00
  PKER_RACCS ( 30, 28) =  0.263753E+00
  PKER_RACCS ( 30, 29) =  0.280725E+00
  PKER_RACCS ( 30, 30) =  0.294528E+00
  PKER_RACCS ( 30, 31) =  0.305756E+00
  PKER_RACCS ( 30, 32) =  0.314894E+00
  PKER_RACCS ( 30, 33) =  0.322340E+00
  PKER_RACCS ( 30, 34) =  0.328414E+00
  PKER_RACCS ( 30, 35) =  0.333374E+00
  PKER_RACCS ( 30, 36) =  0.337431E+00
  PKER_RACCS ( 30, 37) =  0.340751E+00
  PKER_RACCS ( 30, 38) =  0.343472E+00
  PKER_RACCS ( 30, 39) =  0.345703E+00
  PKER_RACCS ( 30, 40) =  0.347534E+00
  PKER_RACCS ( 31,  1) =  0.154460E+02
  PKER_RACCS ( 31,  2) =  0.127399E+02
  PKER_RACCS ( 31,  3) =  0.104995E+02
  PKER_RACCS ( 31,  4) =  0.864461E+01
  PKER_RACCS ( 31,  5) =  0.710885E+01
  PKER_RACCS ( 31,  6) =  0.583727E+01
  PKER_RACCS ( 31,  7) =  0.478435E+01
  PKER_RACCS ( 31,  8) =  0.391243E+01
  PKER_RACCS ( 31,  9) =  0.319031E+01
  PKER_RACCS ( 31, 10) =  0.259216E+01
  PKER_RACCS ( 31, 11) =  0.209658E+01
  PKER_RACCS ( 31, 12) =  0.168588E+01
  PKER_RACCS ( 31, 13) =  0.134536E+01
  PKER_RACCS ( 31, 14) =  0.106288E+01
  PKER_RACCS ( 31, 15) =  0.828426E+00
  PKER_RACCS ( 31, 16) =  0.633811E+00
  PKER_RACCS ( 31, 17) =  0.472627E+00
  PKER_RACCS ( 31, 18) =  0.340455E+00
  PKER_RACCS ( 31, 19) =  0.235395E+00
  PKER_RACCS ( 31, 20) =  0.158197E+00
  PKER_RACCS ( 31, 21) =  0.111047E+00
  PKER_RACCS ( 31, 22) =  0.944902E-01
  PKER_RACCS ( 31, 23) =  0.103740E+00
  PKER_RACCS ( 31, 24) =  0.129188E+00
  PKER_RACCS ( 31, 25) =  0.160505E+00
  PKER_RACCS ( 31, 26) =  0.190663E+00
  PKER_RACCS ( 31, 27) =  0.216732E+00
  PKER_RACCS ( 31, 28) =  0.238325E+00
  PKER_RACCS ( 31, 29) =  0.255978E+00
  PKER_RACCS ( 31, 30) =  0.270357E+00
  PKER_RACCS ( 31, 31) =  0.282055E+00
  PKER_RACCS ( 31, 32) =  0.291568E+00
  PKER_RACCS ( 31, 33) =  0.299310E+00
  PKER_RACCS ( 31, 34) =  0.305614E+00
  PKER_RACCS ( 31, 35) =  0.310754E+00
  PKER_RACCS ( 31, 36) =  0.314949E+00
  PKER_RACCS ( 31, 37) =  0.318377E+00
  PKER_RACCS ( 31, 38) =  0.321181E+00
  PKER_RACCS ( 31, 39) =  0.323477E+00
  PKER_RACCS ( 31, 40) =  0.325358E+00
  PKER_RACCS ( 32,  1) =  0.154645E+02
  PKER_RACCS ( 32,  2) =  0.127586E+02
  PKER_RACCS ( 32,  3) =  0.105183E+02
  PKER_RACCS ( 32,  4) =  0.866361E+01
  PKER_RACCS ( 32,  5) =  0.712804E+01
  PKER_RACCS ( 32,  6) =  0.585666E+01
  PKER_RACCS ( 32,  7) =  0.480396E+01
  PKER_RACCS ( 32,  8) =  0.393229E+01
  PKER_RACCS ( 32,  9) =  0.321044E+01
  PKER_RACCS ( 32, 10) =  0.261259E+01
  PKER_RACCS ( 32, 11) =  0.211736E+01
  PKER_RACCS ( 32, 12) =  0.170704E+01
  PKER_RACCS ( 32, 13) =  0.136696E+01
  PKER_RACCS ( 32, 14) =  0.108496E+01
  PKER_RACCS ( 32, 15) =  0.851011E+00
  PKER_RACCS ( 32, 16) =  0.656851E+00
  PKER_RACCS ( 32, 17) =  0.495858E+00
  PKER_RACCS ( 32, 18) =  0.363104E+00
  PKER_RACCS ( 32, 19) =  0.255729E+00
  PKER_RACCS ( 32, 20) =  0.173391E+00
  PKER_RACCS ( 32, 21) =  0.117751E+00
  PKER_RACCS ( 32, 22) =  0.904719E-01
  PKER_RACCS ( 32, 23) =  0.895825E-01
  PKER_RACCS ( 32, 24) =  0.107971E+00
  PKER_RACCS ( 32, 25) =  0.135888E+00
  PKER_RACCS ( 32, 26) =  0.165226E+00
  PKER_RACCS ( 32, 27) =  0.191642E+00
  PKER_RACCS ( 32, 28) =  0.213902E+00
  PKER_RACCS ( 32, 29) =  0.232232E+00
  PKER_RACCS ( 32, 30) =  0.247217E+00
  PKER_RACCS ( 32, 31) =  0.259430E+00
  PKER_RACCS ( 32, 32) =  0.269367E+00
  PKER_RACCS ( 32, 33) =  0.277448E+00
  PKER_RACCS ( 32, 34) =  0.284022E+00
  PKER_RACCS ( 32, 35) =  0.289372E+00
  PKER_RACCS ( 32, 36) =  0.293732E+00
  PKER_RACCS ( 32, 37) =  0.297288E+00
  PKER_RACCS ( 32, 38) =  0.300191E+00
  PKER_RACCS ( 32, 39) =  0.302565E+00
  PKER_RACCS ( 32, 40) =  0.304507E+00
  PKER_RACCS ( 33,  1) =  0.154815E+02
  PKER_RACCS ( 33,  2) =  0.127757E+02
  PKER_RACCS ( 33,  3) =  0.105355E+02
  PKER_RACCS ( 33,  4) =  0.868096E+01
  PKER_RACCS ( 33,  5) =  0.714554E+01
  PKER_RACCS ( 33,  6) =  0.587431E+01
  PKER_RACCS ( 33,  7) =  0.482179E+01
  PKER_RACCS ( 33,  8) =  0.395030E+01
  PKER_RACCS ( 33,  9) =  0.322867E+01
  PKER_RACCS ( 33, 10) =  0.263106E+01
  PKER_RACCS ( 33, 11) =  0.213609E+01
  PKER_RACCS ( 33, 12) =  0.172607E+01
  PKER_RACCS ( 33, 13) =  0.138633E+01
  PKER_RACCS ( 33, 14) =  0.110471E+01
  PKER_RACCS ( 33, 15) =  0.871183E+00
  PKER_RACCS ( 33, 16) =  0.677438E+00
  PKER_RACCS ( 33, 17) =  0.516731E+00
  PKER_RACCS ( 33, 18) =  0.383819E+00
  PKER_RACCS ( 33, 19) =  0.275185E+00
  PKER_RACCS ( 33, 20) =  0.189408E+00
  PKER_RACCS ( 33, 21) =  0.127387E+00
  PKER_RACCS ( 33, 22) =  0.909968E-01
  PKER_RACCS ( 33, 23) =  0.802651E-01
  PKER_RACCS ( 33, 24) =  0.906465E-01
  PKER_RACCS ( 33, 25) =  0.113901E+00
  PKER_RACCS ( 33, 26) =  0.141477E+00
  PKER_RACCS ( 33, 27) =  0.167764E+00
  PKER_RACCS ( 33, 28) =  0.190502E+00
  PKER_RACCS ( 33, 29) =  0.209445E+00
  PKER_RACCS ( 33, 30) =  0.225030E+00
  PKER_RACCS ( 33, 31) =  0.237783E+00
  PKER_RACCS ( 33, 32) =  0.248183E+00
  PKER_RACCS ( 33, 33) =  0.256648E+00
  PKER_RACCS ( 33, 34) =  0.263530E+00
  PKER_RACCS ( 33, 35) =  0.269127E+00
  PKER_RACCS ( 33, 36) =  0.273680E+00
  PKER_RACCS ( 33, 37) =  0.277387E+00
  PKER_RACCS ( 33, 38) =  0.280409E+00
  PKER_RACCS ( 33, 39) =  0.282874E+00
  PKER_RACCS ( 33, 40) =  0.284888E+00
  PKER_RACCS ( 34,  1) =  0.154971E+02
  PKER_RACCS ( 34,  2) =  0.127914E+02
  PKER_RACCS ( 34,  3) =  0.105513E+02
  PKER_RACCS ( 34,  4) =  0.869687E+01
  PKER_RACCS ( 34,  5) =  0.716155E+01
  PKER_RACCS ( 34,  6) =  0.589045E+01
  PKER_RACCS ( 34,  7) =  0.483806E+01
  PKER_RACCS ( 34,  8) =  0.396672E+01
  PKER_RACCS ( 34,  9) =  0.324525E+01
  PKER_RACCS ( 34, 10) =  0.264782E+01
  PKER_RACCS ( 34, 11) =  0.215307E+01
  PKER_RACCS ( 34, 12) =  0.174328E+01
  PKER_RACCS ( 34, 13) =  0.140380E+01
  PKER_RACCS ( 34, 14) =  0.112249E+01
  PKER_RACCS ( 34, 15) =  0.889288E+00
  PKER_RACCS ( 34, 16) =  0.695896E+00
  PKER_RACCS ( 34, 17) =  0.535492E+00
  PKER_RACCS ( 34, 18) =  0.402635E+00
  PKER_RACCS ( 34, 19) =  0.293345E+00
  PKER_RACCS ( 34, 20) =  0.205473E+00
  PKER_RACCS ( 34, 21) =  0.138918E+00
  PKER_RACCS ( 34, 22) =  0.951741E-01
  PKER_RACCS ( 34, 23) =  0.754374E-01
  PKER_RACCS ( 34, 24) =  0.774875E-01
  PKER_RACCS ( 34, 25) =  0.949890E-01
  PKER_RACCS ( 34, 26) =  0.119774E+00
  PKER_RACCS ( 34, 27) =  0.145296E+00
  PKER_RACCS ( 34, 28) =  0.168211E+00
  PKER_RACCS ( 34, 29) =  0.187630E+00
  PKER_RACCS ( 34, 30) =  0.203759E+00
  PKER_RACCS ( 34, 31) =  0.217043E+00
  PKER_RACCS ( 34, 32) =  0.227927E+00
  PKER_RACCS ( 34, 33) =  0.236809E+00
  PKER_RACCS ( 34, 34) =  0.244039E+00
  PKER_RACCS ( 34, 35) =  0.249918E+00
  PKER_RACCS ( 34, 36) =  0.254696E+00
  PKER_RACCS ( 34, 37) =  0.258581E+00
  PKER_RACCS ( 34, 38) =  0.261742E+00
  PKER_RACCS ( 34, 39) =  0.264317E+00
  PKER_RACCS ( 34, 40) =  0.266416E+00
  PKER_RACCS ( 35,  1) =  0.155115E+02
  PKER_RACCS ( 35,  2) =  0.128058E+02
  PKER_RACCS ( 35,  3) =  0.105659E+02
  PKER_RACCS ( 35,  4) =  0.871149E+01
  PKER_RACCS ( 35,  5) =  0.717627E+01
  PKER_RACCS ( 35,  6) =  0.590526E+01
  PKER_RACCS ( 35,  7) =  0.485298E+01
  PKER_RACCS ( 35,  8) =  0.398175E+01
  PKER_RACCS ( 35,  9) =  0.326040E+01
  PKER_RACCS ( 35, 10) =  0.266312E+01
  PKER_RACCS ( 35, 11) =  0.216852E+01
  PKER_RACCS ( 35, 12) =  0.175891E+01
  PKER_RACCS ( 35, 13) =  0.141964E+01
  PKER_RACCS ( 35, 14) =  0.113856E+01
  PKER_RACCS ( 35, 15) =  0.905624E+00
  PKER_RACCS ( 35, 16) =  0.712519E+00
  PKER_RACCS ( 35, 17) =  0.552390E+00
  PKER_RACCS ( 35, 18) =  0.419682E+00
  PKER_RACCS ( 35, 19) =  0.310127E+00
  PKER_RACCS ( 35, 20) =  0.220956E+00
  PKER_RACCS ( 35, 21) =  0.151287E+00
  PKER_RACCS ( 35, 22) =  0.101963E+00
  PKER_RACCS ( 35, 23) =  0.745072E-01
  PKER_RACCS ( 35, 24) =  0.684396E-01
  PKER_RACCS ( 35, 25) =  0.794810E-01
  PKER_RACCS ( 35, 26) =  0.100476E+00
  PKER_RACCS ( 35, 27) =  0.124496E+00
  PKER_RACCS ( 35, 28) =  0.147175E+00
  PKER_RACCS ( 35, 29) =  0.166857E+00
  PKER_RACCS ( 35, 30) =  0.183413E+00
  PKER_RACCS ( 35, 31) =  0.197175E+00
  PKER_RACCS ( 35, 32) =  0.208532E+00
  PKER_RACCS ( 35, 33) =  0.217848E+00
  PKER_RACCS ( 35, 34) =  0.225456E+00
  PKER_RACCS ( 35, 35) =  0.231651E+00
  PKER_RACCS ( 35, 36) =  0.236687E+00
  PKER_RACCS ( 35, 37) =  0.240779E+00
  PKER_RACCS ( 35, 38) =  0.244104E+00
  PKER_RACCS ( 35, 39) =  0.246808E+00
  PKER_RACCS ( 35, 40) =  0.249007E+00
  PKER_RACCS ( 36,  1) =  0.155248E+02
  PKER_RACCS ( 36,  2) =  0.128192E+02
  PKER_RACCS ( 36,  3) =  0.105793E+02
  PKER_RACCS ( 36,  4) =  0.872498E+01
  PKER_RACCS ( 36,  5) =  0.718982E+01
  PKER_RACCS ( 36,  6) =  0.591889E+01
  PKER_RACCS ( 36,  7) =  0.486669E+01
  PKER_RACCS ( 36,  8) =  0.399555E+01
  PKER_RACCS ( 36,  9) =  0.327430E+01
  PKER_RACCS ( 36, 10) =  0.267713E+01
  PKER_RACCS ( 36, 11) =  0.218265E+01
  PKER_RACCS ( 36, 12) =  0.177318E+01
  PKER_RACCS ( 36, 13) =  0.143407E+01
  PKER_RACCS ( 36, 14) =  0.115317E+01
  PKER_RACCS ( 36, 15) =  0.920438E+00
  PKER_RACCS ( 36, 16) =  0.727562E+00
  PKER_RACCS ( 36, 17) =  0.567668E+00
  PKER_RACCS ( 36, 18) =  0.435133E+00
  PKER_RACCS ( 36, 19) =  0.325510E+00
  PKER_RACCS ( 36, 20) =  0.235636E+00
  PKER_RACCS ( 36, 21) =  0.163886E+00
  PKER_RACCS ( 36, 22) =  0.110458E+00
  PKER_RACCS ( 36, 23) =  0.766826E-01
  PKER_RACCS ( 36, 24) =  0.631683E-01
  PKER_RACCS ( 36, 25) =  0.674487E-01
  PKER_RACCS ( 36, 26) =  0.838666E-01
  PKER_RACCS ( 36, 27) =  0.105624E+00
  PKER_RACCS ( 36, 28) =  0.127576E+00
  PKER_RACCS ( 36, 29) =  0.147242E+00
  PKER_RACCS ( 36, 30) =  0.164054E+00
  PKER_RACCS ( 36, 31) =  0.178188E+00
  PKER_RACCS ( 36, 32) =  0.189965E+00
  PKER_RACCS ( 36, 33) =  0.199703E+00
  PKER_RACCS ( 36, 34) =  0.207702E+00
  PKER_RACCS ( 36, 35) =  0.214240E+00
  PKER_RACCS ( 36, 36) =  0.219565E+00
  PKER_RACCS ( 36, 37) =  0.223893E+00
  PKER_RACCS ( 36, 38) =  0.227409E+00
  PKER_RACCS ( 36, 39) =  0.230264E+00
  PKER_RACCS ( 36, 40) =  0.232583E+00
  PKER_RACCS ( 37,  1) =  0.155372E+02
  PKER_RACCS ( 37,  2) =  0.128316E+02
  PKER_RACCS ( 37,  3) =  0.105917E+02
  PKER_RACCS ( 37,  4) =  0.873745E+01
  PKER_RACCS ( 37,  5) =  0.720235E+01
  PKER_RACCS ( 37,  6) =  0.593147E+01
  PKER_RACCS ( 37,  7) =  0.487933E+01
  PKER_RACCS ( 37,  8) =  0.400827E+01
  PKER_RACCS ( 37,  9) =  0.328710E+01
  PKER_RACCS ( 37, 10) =  0.269001E+01
  PKER_RACCS ( 37, 11) =  0.219563E+01
  PKER_RACCS ( 37, 12) =  0.178626E+01
  PKER_RACCS ( 37, 13) =  0.144727E+01
  PKER_RACCS ( 37, 14) =  0.116651E+01
  PKER_RACCS ( 37, 15) =  0.933935E+00
  PKER_RACCS ( 37, 16) =  0.741238E+00
  PKER_RACCS ( 37, 17) =  0.581536E+00
  PKER_RACCS ( 37, 18) =  0.449170E+00
  PKER_RACCS ( 37, 19) =  0.339580E+00
  PKER_RACCS ( 37, 20) =  0.249319E+00
  PKER_RACCS ( 37, 21) =  0.176301E+00
  PKER_RACCS ( 37, 22) =  0.119980E+00
  PKER_RACCS ( 37, 23) =  0.812228E-01
  PKER_RACCS ( 37, 24) =  0.611617E-01
  PKER_RACCS ( 37, 25) =  0.588377E-01
  PKER_RACCS ( 37, 26) =  0.701370E-01
  PKER_RACCS ( 37, 27) =  0.889143E-01
  PKER_RACCS ( 37, 28) =  0.109599E+00
  PKER_RACCS ( 37, 29) =  0.128927E+00
  PKER_RACCS ( 37, 30) =  0.145782E+00
  PKER_RACCS ( 37, 31) =  0.160136E+00
  PKER_RACCS ( 37, 32) =  0.172235E+00
  PKER_RACCS ( 37, 33) =  0.182345E+00
  PKER_RACCS ( 37, 34) =  0.190722E+00
  PKER_RACCS ( 37, 35) =  0.197614E+00
  PKER_RACCS ( 37, 36) =  0.203250E+00
  PKER_RACCS ( 37, 37) =  0.207843E+00
  PKER_RACCS ( 37, 38) =  0.211576E+00
  PKER_RACCS ( 37, 39) =  0.214606E+00
  PKER_RACCS ( 37, 40) =  0.217065E+00
  PKER_RACCS ( 38,  1) =  0.155486E+02
  PKER_RACCS ( 38,  2) =  0.128431E+02
  PKER_RACCS ( 38,  3) =  0.106033E+02
  PKER_RACCS ( 38,  4) =  0.874901E+01
  PKER_RACCS ( 38,  5) =  0.721394E+01
  PKER_RACCS ( 38,  6) =  0.594312E+01
  PKER_RACCS ( 38,  7) =  0.489103E+01
  PKER_RACCS ( 38,  8) =  0.402001E+01
  PKER_RACCS ( 38,  9) =  0.329890E+01
  PKER_RACCS ( 38, 10) =  0.270188E+01
  PKER_RACCS ( 38, 11) =  0.220757E+01
  PKER_RACCS ( 38, 12) =  0.179829E+01
  PKER_RACCS ( 38, 13) =  0.145939E+01
  PKER_RACCS ( 38, 14) =  0.117873E+01
  PKER_RACCS ( 38, 15) =  0.946284E+00
  PKER_RACCS ( 38, 16) =  0.753726E+00
  PKER_RACCS ( 38, 17) =  0.594177E+00
  PKER_RACCS ( 38, 18) =  0.461958E+00
  PKER_RACCS ( 38, 19) =  0.352443E+00
  PKER_RACCS ( 38, 20) =  0.262014E+00
  PKER_RACCS ( 38, 21) =  0.188177E+00
  PKER_RACCS ( 38, 22) =  0.129859E+00
  PKER_RACCS ( 38, 23) =  0.873684E-01
  PKER_RACCS ( 38, 24) =  0.618482E-01
  PKER_RACCS ( 38, 25) =  0.533670E-01
  PKER_RACCS ( 38, 26) =  0.593061E-01
  PKER_RACCS ( 38, 27) =  0.745116E-01
  PKER_RACCS ( 38, 28) =  0.934019E-01
  PKER_RACCS ( 38, 29) =  0.112045E+00
  PKER_RACCS ( 38, 30) =  0.128716E+00
  PKER_RACCS ( 38, 31) =  0.143109E+00
  PKER_RACCS ( 38, 32) =  0.155390E+00
  PKER_RACCS ( 38, 33) =  0.165779E+00
  PKER_RACCS ( 38, 34) =  0.174487E+00
  PKER_RACCS ( 38, 35) =  0.181718E+00
  PKER_RACCS ( 38, 36) =  0.187676E+00
  PKER_RACCS ( 38, 37) =  0.192553E+00
  PKER_RACCS ( 38, 38) =  0.196528E+00
  PKER_RACCS ( 38, 39) =  0.199758E+00
  PKER_RACCS ( 38, 40) =  0.202379E+00
  PKER_RACCS ( 39,  1) =  0.155593E+02
  PKER_RACCS ( 39,  2) =  0.128537E+02
  PKER_RACCS ( 39,  3) =  0.106139E+02
  PKER_RACCS ( 39,  4) =  0.875973E+01
  PKER_RACCS ( 39,  5) =  0.722471E+01
  PKER_RACCS ( 39,  6) =  0.595391E+01
  PKER_RACCS ( 39,  7) =  0.490186E+01
  PKER_RACCS ( 39,  8) =  0.403089E+01
  PKER_RACCS ( 39,  9) =  0.330982E+01
  PKER_RACCS ( 39, 10) =  0.271285E+01
  PKER_RACCS ( 39, 11) =  0.221860E+01
  PKER_RACCS ( 39, 12) =  0.180938E+01
  PKER_RACCS ( 39, 13) =  0.147055E+01
  PKER_RACCS ( 39, 14) =  0.118998E+01
  PKER_RACCS ( 39, 15) =  0.957626E+00
  PKER_RACCS ( 39, 16) =  0.765175E+00
  PKER_RACCS ( 39, 17) =  0.605746E+00
  PKER_RACCS ( 39, 18) =  0.473650E+00
  PKER_RACCS ( 39, 19) =  0.364221E+00
  PKER_RACCS ( 39, 20) =  0.273730E+00
  PKER_RACCS ( 39, 21) =  0.199436E+00
  PKER_RACCS ( 39, 22) =  0.139756E+00
  PKER_RACCS ( 39, 23) =  0.945196E-01
  PKER_RACCS ( 39, 24) =  0.645897E-01
  PKER_RACCS ( 39, 25) =  0.506197E-01
  PKER_RACCS ( 39, 26) =  0.512198E-01
  PKER_RACCS ( 39, 27) =  0.624590E-01
  PKER_RACCS ( 39, 28) =  0.790782E-01
  PKER_RACCS ( 39, 29) =  0.966942E-01
  PKER_RACCS ( 39, 30) =  0.112959E+00
  PKER_RACCS ( 39, 31) =  0.127212E+00
  PKER_RACCS ( 39, 32) =  0.139513E+00
  PKER_RACCS ( 39, 33) =  0.150051E+00
  PKER_RACCS ( 39, 34) =  0.159002E+00
  PKER_RACCS ( 39, 35) =  0.166528E+00
  PKER_RACCS ( 39, 36) =  0.172792E+00
  PKER_RACCS ( 39, 37) =  0.177962E+00
  PKER_RACCS ( 39, 38) =  0.182197E+00
  PKER_RACCS ( 39, 39) =  0.185650E+00
  PKER_RACCS ( 39, 40) =  0.188455E+00
  PKER_RACCS ( 40,  1) =  0.155692E+02
  PKER_RACCS ( 40,  2) =  0.128637E+02
  PKER_RACCS ( 40,  3) =  0.106239E+02
  PKER_RACCS ( 40,  4) =  0.876971E+01
  PKER_RACCS ( 40,  5) =  0.723471E+01
  PKER_RACCS ( 40,  6) =  0.596394E+01
  PKER_RACCS ( 40,  7) =  0.491192E+01
  PKER_RACCS ( 40,  8) =  0.404098E+01
  PKER_RACCS ( 40,  9) =  0.331995E+01
  PKER_RACCS ( 40, 10) =  0.272302E+01
  PKER_RACCS ( 40, 11) =  0.222881E+01
  PKER_RACCS ( 40, 12) =  0.181964E+01
  PKER_RACCS ( 40, 13) =  0.148087E+01
  PKER_RACCS ( 40, 14) =  0.120036E+01
  PKER_RACCS ( 40, 15) =  0.968076E+00
  PKER_RACCS ( 40, 16) =  0.775708E+00
  PKER_RACCS ( 40, 17) =  0.616371E+00
  PKER_RACCS ( 40, 18) =  0.484375E+00
  PKER_RACCS ( 40, 19) =  0.375030E+00
  PKER_RACCS ( 40, 20) =  0.284536E+00
  PKER_RACCS ( 40, 21) =  0.209971E+00
  PKER_RACCS ( 40, 22) =  0.149448E+00
  PKER_RACCS ( 40, 23) =  0.102257E+00
  PKER_RACCS ( 40, 24) =  0.688589E-01
  PKER_RACCS ( 40, 25) =  0.501439E-01
  PKER_RACCS ( 40, 26) =  0.457017E-01
  PKER_RACCS ( 40, 27) =  0.527560E-01
  PKER_RACCS ( 40, 28) =  0.666825E-01
  PKER_RACCS ( 40, 29) =  0.829271E-01
  PKER_RACCS ( 40, 30) =  0.985768E-01
  PKER_RACCS ( 40, 31) =  0.112531E+00
  PKER_RACCS ( 40, 32) =  0.124696E+00
  PKER_RACCS ( 40, 33) =  0.135236E+00
  PKER_RACCS ( 40, 34) =  0.144309E+00
  PKER_RACCS ( 40, 35) =  0.152047E+00
  PKER_RACCS ( 40, 36) =  0.158575E+00
  PKER_RACCS ( 40, 37) =  0.164022E+00
  PKER_RACCS ( 40, 38) =  0.168524E+00
  PKER_RACCS ( 40, 39) =  0.172216E+00
  PKER_RACCS ( 40, 40) =  0.175226E+00
END IF
!
IF( PRESENT(PKER_SACCRG) ) THEN
  PKER_SACCRG(  1,  1) =  0.403346E-01
  PKER_SACCRG(  1,  2) =  0.679214E-01
  PKER_SACCRG(  1,  3) =  0.105303E+00
  PKER_SACCRG(  1,  4) =  0.191884E+00
  PKER_SACCRG(  1,  5) =  0.356499E+00
  PKER_SACCRG(  1,  6) =  0.645361E+00
  PKER_SACCRG(  1,  7) =  0.109656E+01
  PKER_SACCRG(  1,  8) =  0.172233E+01
  PKER_SACCRG(  1,  9) =  0.249565E+01
  PKER_SACCRG(  1, 10) =  0.335221E+01
  PKER_SACCRG(  1, 11) =  0.421020E+01
  PKER_SACCRG(  1, 12) =  0.500014E+01
  PKER_SACCRG(  1, 13) =  0.568528E+01
  PKER_SACCRG(  1, 14) =  0.626334E+01
  PKER_SACCRG(  1, 15) =  0.675253E+01
  PKER_SACCRG(  1, 16) =  0.717505E+01
  PKER_SACCRG(  1, 17) =  0.754648E+01
  PKER_SACCRG(  1, 18) =  0.787497E+01
  PKER_SACCRG(  1, 19) =  0.816359E+01
  PKER_SACCRG(  1, 20) =  0.839531E+01
  PKER_SACCRG(  1, 21) =  0.861132E+01
  PKER_SACCRG(  1, 22) =  0.879448E+01
  PKER_SACCRG(  1, 23) =  0.891918E+01
  PKER_SACCRG(  1, 24) =  0.905216E+01
  PKER_SACCRG(  1, 25) =  0.913347E+01
  PKER_SACCRG(  1, 26) =  0.920118E+01
  PKER_SACCRG(  1, 27) =  0.926006E+01
  PKER_SACCRG(  1, 28) =  0.928744E+01
  PKER_SACCRG(  1, 29) =  0.931698E+01
  PKER_SACCRG(  1, 30) =  0.934860E+01
  PKER_SACCRG(  1, 31) =  0.936637E+01
  PKER_SACCRG(  1, 32) =  0.937727E+01
  PKER_SACCRG(  1, 33) =  0.938596E+01
  PKER_SACCRG(  1, 34) =  0.938735E+01
  PKER_SACCRG(  1, 35) =  0.939455E+01
  PKER_SACCRG(  1, 36) =  0.940989E+01
  PKER_SACCRG(  1, 37) =  0.000000E+00
  PKER_SACCRG(  1, 38) =  0.000000E+00
  PKER_SACCRG(  1, 39) =  0.000000E+00
  PKER_SACCRG(  1, 40) =  0.000000E+00
  PKER_SACCRG(  2,  1) =  0.232705E-01
  PKER_SACCRG(  2,  2) =  0.335875E-01
  PKER_SACCRG(  2,  3) =  0.565187E-01
  PKER_SACCRG(  2,  4) =  0.875474E-01
  PKER_SACCRG(  2,  5) =  0.159343E+00
  PKER_SACCRG(  2,  6) =  0.295630E+00
  PKER_SACCRG(  2,  7) =  0.534289E+00
  PKER_SACCRG(  2,  8) =  0.906069E+00
  PKER_SACCRG(  2,  9) =  0.141997E+01
  PKER_SACCRG(  2, 10) =  0.205255E+01
  PKER_SACCRG(  2, 11) =  0.274997E+01
  PKER_SACCRG(  2, 12) =  0.344544E+01
  PKER_SACCRG(  2, 13) =  0.408314E+01
  PKER_SACCRG(  2, 14) =  0.463534E+01
  PKER_SACCRG(  2, 15) =  0.510239E+01
  PKER_SACCRG(  2, 16) =  0.550069E+01
  PKER_SACCRG(  2, 17) =  0.584817E+01
  PKER_SACCRG(  2, 18) =  0.615710E+01
  PKER_SACCRG(  2, 19) =  0.643286E+01
  PKER_SACCRG(  2, 20) =  0.665945E+01
  PKER_SACCRG(  2, 21) =  0.687323E+01
  PKER_SACCRG(  2, 22) =  0.705716E+01
  PKER_SACCRG(  2, 23) =  0.718460E+01
  PKER_SACCRG(  2, 24) =  0.732011E+01
  PKER_SACCRG(  2, 25) =  0.740395E+01
  PKER_SACCRG(  2, 26) =  0.747372E+01
  PKER_SACCRG(  2, 27) =  0.753430E+01
  PKER_SACCRG(  2, 28) =  0.756268E+01
  PKER_SACCRG(  2, 29) =  0.759307E+01
  PKER_SACCRG(  2, 30) =  0.762550E+01
  PKER_SACCRG(  2, 31) =  0.764373E+01
  PKER_SACCRG(  2, 32) =  0.765493E+01
  PKER_SACCRG(  2, 33) =  0.766384E+01
  PKER_SACCRG(  2, 34) =  0.766528E+01
  PKER_SACCRG(  2, 35) =  0.767265E+01
  PKER_SACCRG(  2, 36) =  0.768832E+01
  PKER_SACCRG(  2, 37) =  0.000000E+00
  PKER_SACCRG(  2, 38) =  0.000000E+00
  PKER_SACCRG(  2, 39) =  0.000000E+00
  PKER_SACCRG(  2, 40) =  0.000000E+00
  PKER_SACCRG(  3,  1) =  0.183931E-01
  PKER_SACCRG(  3,  2) =  0.194765E-01
  PKER_SACCRG(  3,  3) =  0.280964E-01
  PKER_SACCRG(  3,  4) =  0.472341E-01
  PKER_SACCRG(  3,  5) =  0.730819E-01
  PKER_SACCRG(  3,  6) =  0.132827E+00
  PKER_SACCRG(  3,  7) =  0.245992E+00
  PKER_SACCRG(  3,  8) =  0.443632E+00
  PKER_SACCRG(  3,  9) =  0.750424E+00
  PKER_SACCRG(  3, 10) =  0.117268E+01
  PKER_SACCRG(  3, 11) =  0.168954E+01
  PKER_SACCRG(  3, 12) =  0.225593E+01
  PKER_SACCRG(  3, 13) =  0.281701E+01
  PKER_SACCRG(  3, 14) =  0.332851E+01
  PKER_SACCRG(  3, 15) =  0.377021E+01
  PKER_SACCRG(  3, 16) =  0.414495E+01
  PKER_SACCRG(  3, 17) =  0.446759E+01
  PKER_SACCRG(  3, 18) =  0.475325E+01
  PKER_SACCRG(  3, 19) =  0.501103E+01
  PKER_SACCRG(  3, 20) =  0.522794E+01
  PKER_SACCRG(  3, 21) =  0.543570E+01
  PKER_SACCRG(  3, 22) =  0.561785E+01
  PKER_SACCRG(  3, 23) =  0.574685E+01
  PKER_SACCRG(  3, 24) =  0.588391E+01
  PKER_SACCRG(  3, 25) =  0.597001E+01
  PKER_SACCRG(  3, 26) =  0.604169E+01
  PKER_SACCRG(  3, 27) =  0.610387E+01
  PKER_SACCRG(  3, 28) =  0.613328E+01
  PKER_SACCRG(  3, 29) =  0.616451E+01
  PKER_SACCRG(  3, 30) =  0.619771E+01
  PKER_SACCRG(  3, 31) =  0.621641E+01
  PKER_SACCRG(  3, 32) =  0.622789E+01
  PKER_SACCRG(  3, 33) =  0.623702E+01
  PKER_SACCRG(  3, 34) =  0.623852E+01
  PKER_SACCRG(  3, 35) =  0.624605E+01
  PKER_SACCRG(  3, 36) =  0.626204E+01
  PKER_SACCRG(  3, 37) =  0.000000E+00
  PKER_SACCRG(  3, 38) =  0.000000E+00
  PKER_SACCRG(  3, 39) =  0.000000E+00
  PKER_SACCRG(  3, 40) =  0.000000E+00
  PKER_SACCRG(  4,  1) =  0.114393E-01
  PKER_SACCRG(  4,  2) =  0.155094E-01
  PKER_SACCRG(  4,  3) =  0.164106E-01
  PKER_SACCRG(  4,  4) =  0.236526E-01
  PKER_SACCRG(  4,  5) =  0.397213E-01
  PKER_SACCRG(  4,  6) =  0.613666E-01
  PKER_SACCRG(  4,  7) =  0.111326E+00
  PKER_SACCRG(  4,  8) =  0.205685E+00
  PKER_SACCRG(  4,  9) =  0.369928E+00
  PKER_SACCRG(  4, 10) =  0.623698E+00
  PKER_SACCRG(  4, 11) =  0.970783E+00
  PKER_SACCRG(  4, 12) =  0.139255E+01
  PKER_SACCRG(  4, 13) =  0.185072E+01
  PKER_SACCRG(  4, 14) =  0.230015E+01
  PKER_SACCRG(  4, 15) =  0.270627E+01
  PKER_SACCRG(  4, 16) =  0.305559E+01
  PKER_SACCRG(  4, 17) =  0.335340E+01
  PKER_SACCRG(  4, 18) =  0.361392E+01
  PKER_SACCRG(  4, 19) =  0.384970E+01
  PKER_SACCRG(  4, 20) =  0.405246E+01
  PKER_SACCRG(  4, 21) =  0.425002E+01
  PKER_SACCRG(  4, 22) =  0.442724E+01
  PKER_SACCRG(  4, 23) =  0.455616E+01
  PKER_SACCRG(  4, 24) =  0.469337E+01
  PKER_SACCRG(  4, 25) =  0.478122E+01
  PKER_SACCRG(  4, 26) =  0.485452E+01
  PKER_SACCRG(  4, 27) =  0.491813E+01
  PKER_SACCRG(  4, 28) =  0.494855E+01
  PKER_SACCRG(  4, 29) =  0.498058E+01
  PKER_SACCRG(  4, 30) =  0.501450E+01
  PKER_SACCRG(  4, 31) =  0.503365E+01
  PKER_SACCRG(  4, 32) =  0.504542E+01
  PKER_SACCRG(  4, 33) =  0.505475E+01
  PKER_SACCRG(  4, 34) =  0.505631E+01
  PKER_SACCRG(  4, 35) =  0.506399E+01
  PKER_SACCRG(  4, 36) =  0.508029E+01
  PKER_SACCRG(  4, 37) =  0.000000E+00
  PKER_SACCRG(  4, 38) =  0.000000E+00
  PKER_SACCRG(  4, 39) =  0.000000E+00
  PKER_SACCRG(  4, 40) =  0.000000E+00
  PKER_SACCRG(  5,  1) =  0.885989E-02
  PKER_SACCRG(  5,  2) =  0.975839E-02
  PKER_SACCRG(  5,  3) =  0.132035E-01
  PKER_SACCRG(  5,  4) =  0.139558E-01
  PKER_SACCRG(  5,  5) =  0.200916E-01
  PKER_SACCRG(  5,  6) =  0.296110E-01
  PKER_SACCRG(  5,  7) =  0.519536E-01
  PKER_SACCRG(  5,  8) =  0.940172E-01
  PKER_SACCRG(  5,  9) =  0.173205E+00
  PKER_SACCRG(  5, 10) =  0.310322E+00
  PKER_SACCRG(  5, 11) =  0.520780E+00
  PKER_SACCRG(  5, 12) =  0.806566E+00
  PKER_SACCRG(  5, 13) =  0.115020E+01
  PKER_SACCRG(  5, 14) =  0.151872E+01
  PKER_SACCRG(  5, 15) =  0.187497E+01
  PKER_SACCRG(  5, 16) =  0.219377E+01
  PKER_SACCRG(  5, 17) =  0.246641E+01
  PKER_SACCRG(  5, 18) =  0.270162E+01
  PKER_SACCRG(  5, 19) =  0.291200E+01
  PKER_SACCRG(  5, 20) =  0.309558E+01
  PKER_SACCRG(  5, 21) =  0.327751E+01
  PKER_SACCRG(  5, 22) =  0.344551E+01
  PKER_SACCRG(  5, 23) =  0.357190E+01
  PKER_SACCRG(  5, 24) =  0.370734E+01
  PKER_SACCRG(  5, 25) =  0.379614E+01
  PKER_SACCRG(  5, 26) =  0.387059E+01
  PKER_SACCRG(  5, 27) =  0.393531E+01
  PKER_SACCRG(  5, 28) =  0.396669E+01
  PKER_SACCRG(  5, 29) =  0.399944E+01
  PKER_SACCRG(  5, 30) =  0.403397E+01
  PKER_SACCRG(  5, 31) =  0.405353E+01
  PKER_SACCRG(  5, 32) =  0.406555E+01
  PKER_SACCRG(  5, 33) =  0.407508E+01
  PKER_SACCRG(  5, 34) =  0.407671E+01
  PKER_SACCRG(  5, 35) =  0.408453E+01
  PKER_SACCRG(  5, 36) =  0.410107E+01
  PKER_SACCRG(  5, 37) =  0.000000E+00
  PKER_SACCRG(  5, 38) =  0.000000E+00
  PKER_SACCRG(  5, 39) =  0.000000E+00
  PKER_SACCRG(  5, 40) =  0.000000E+00
  PKER_SACCRG(  6,  1) =  0.939278E-02
  PKER_SACCRG(  6,  2) =  0.770370E-02
  PKER_SACCRG(  6,  3) =  0.844219E-02
  PKER_SACCRG(  6,  4) =  0.113902E-01
  PKER_SACCRG(  6,  5) =  0.120225E-01
  PKER_SACCRG(  6,  6) =  0.172828E-01
  PKER_SACCRG(  6,  7) =  0.254190E-01
  PKER_SACCRG(  6,  8) =  0.444876E-01
  PKER_SACCRG(  6,  9) =  0.802697E-01
  PKER_SACCRG(  6, 10) =  0.147308E+00
  PKER_SACCRG(  6, 11) =  0.262153E+00
  PKER_SACCRG(  6, 12) =  0.437891E+00
  PKER_SACCRG(  6, 13) =  0.673319E+00
  PKER_SACCRG(  6, 14) =  0.951922E+00
  PKER_SACCRG(  6, 15) =  0.124486E+01
  PKER_SACCRG(  6, 16) =  0.152378E+01
  PKER_SACCRG(  6, 17) =  0.176859E+01
  PKER_SACCRG(  6, 18) =  0.197911E+01
  PKER_SACCRG(  6, 19) =  0.216406E+01
  PKER_SACCRG(  6, 20) =  0.232602E+01
  PKER_SACCRG(  6, 21) =  0.248802E+01
  PKER_SACCRG(  6, 22) =  0.264189E+01
  PKER_SACCRG(  6, 23) =  0.276205E+01
  PKER_SACCRG(  6, 24) =  0.289262E+01
  PKER_SACCRG(  6, 25) =  0.298091E+01
  PKER_SACCRG(  6, 26) =  0.305566E+01
  PKER_SACCRG(  6, 27) =  0.312099E+01
  PKER_SACCRG(  6, 28) =  0.315321E+01
  PKER_SACCRG(  6, 29) =  0.318651E+01
  PKER_SACCRG(  6, 30) =  0.322151E+01
  PKER_SACCRG(  6, 31) =  0.324141E+01
  PKER_SACCRG(  6, 32) =  0.325366E+01
  PKER_SACCRG(  6, 33) =  0.326335E+01
  PKER_SACCRG(  6, 34) =  0.326504E+01
  PKER_SACCRG(  6, 35) =  0.327297E+01
  PKER_SACCRG(  6, 36) =  0.328972E+01
  PKER_SACCRG(  6, 37) =  0.000000E+00
  PKER_SACCRG(  6, 38) =  0.000000E+00
  PKER_SACCRG(  6, 39) =  0.000000E+00
  PKER_SACCRG(  6, 40) =  0.000000E+00
  PKER_SACCRG(  7,  1) =  0.197193E-02
  PKER_SACCRG(  7,  2) =  0.840926E-02
  PKER_SACCRG(  7,  3) =  0.684203E-02
  PKER_SACCRG(  7,  4) =  0.744934E-02
  PKER_SACCRG(  7,  5) =  0.100142E-01
  PKER_SACCRG(  7,  6) =  0.105435E-01
  PKER_SACCRG(  7,  7) =  0.151114E-01
  PKER_SACCRG(  7,  8) =  0.221799E-01
  PKER_SACCRG(  7,  9) =  0.387273E-01
  PKER_SACCRG(  7, 10) =  0.696342E-01
  PKER_SACCRG(  7, 11) =  0.126786E+00
  PKER_SACCRG(  7, 12) =  0.224173E+00
  PKER_SACCRG(  7, 13) =  0.371284E+00
  PKER_SACCRG(  7, 14) =  0.564401E+00
  PKER_SACCRG(  7, 15) =  0.787177E+00
  PKER_SACCRG(  7, 16) =  0.101687E+01
  PKER_SACCRG(  7, 17) =  0.122807E+01
  PKER_SACCRG(  7, 18) =  0.141258E+01
  PKER_SACCRG(  7, 19) =  0.157270E+01
  PKER_SACCRG(  7, 20) =  0.171283E+01
  PKER_SACCRG(  7, 21) =  0.185341E+01
  PKER_SACCRG(  7, 22) =  0.199032E+01
  PKER_SACCRG(  7, 23) =  0.210129E+01
  PKER_SACCRG(  7, 24) =  0.222356E+01
  PKER_SACCRG(  7, 25) =  0.230903E+01
  PKER_SACCRG(  7, 26) =  0.238240E+01
  PKER_SACCRG(  7, 27) =  0.244719E+01
  PKER_SACCRG(  7, 28) =  0.247983E+01
  PKER_SACCRG(  7, 29) =  0.251337E+01
  PKER_SACCRG(  7, 30) =  0.254858E+01
  PKER_SACCRG(  7, 31) =  0.256871E+01
  PKER_SACCRG(  7, 32) =  0.258114E+01
  PKER_SACCRG(  7, 33) =  0.259094E+01
  PKER_SACCRG(  7, 34) =  0.259270E+01
  PKER_SACCRG(  7, 35) =  0.260070E+01
  PKER_SACCRG(  7, 36) =  0.261756E+01
  PKER_SACCRG(  7, 37) =  0.000000E+00
  PKER_SACCRG(  7, 38) =  0.000000E+00
  PKER_SACCRG(  7, 39) =  0.000000E+00
  PKER_SACCRG(  7, 40) =  0.000000E+00
  PKER_SACCRG(  8,  1) =  0.287028E-02
  PKER_SACCRG(  8,  2) =  0.183962E-02
  PKER_SACCRG(  8,  3) =  0.778156E-02
  PKER_SACCRG(  8,  4) =  0.626956E-02
  PKER_SACCRG(  8,  5) =  0.676623E-02
  PKER_SACCRG(  8,  6) =  0.546166E-02
  PKER_SACCRG(  8,  7) =  0.943103E-02
  PKER_SACCRG(  8,  8) =  0.135380E-01
  PKER_SACCRG(  8,  9) =  0.198532E-01
  PKER_SACCRG(  8, 10) =  0.345712E-01
  PKER_SACCRG(  8, 11) =  0.614306E-01
  PKER_SACCRG(  8, 12) =  0.111431E+00
  PKER_SACCRG(  8, 13) =  0.195294E+00
  PKER_SACCRG(  8, 14) =  0.318747E+00
  PKER_SACCRG(  8, 15) =  0.475607E+00
  PKER_SACCRG(  8, 16) =  0.653793E+00
  PKER_SACCRG(  8, 17) =  0.827434E+00
  PKER_SACCRG(  8, 18) =  0.984457E+00
  PKER_SACCRG(  8, 19) =  0.111823E+01
  PKER_SACCRG(  8, 20) =  0.123445E+01
  PKER_SACCRG(  8, 21) =  0.135038E+01
  PKER_SACCRG(  8, 22) =  0.146703E+01
  PKER_SACCRG(  8, 23) =  0.156617E+01
  PKER_SACCRG(  8, 24) =  0.167765E+01
  PKER_SACCRG(  8, 25) =  0.175863E+01
  PKER_SACCRG(  8, 26) =  0.182918E+01
  PKER_SACCRG(  8, 27) =  0.189212E+01
  PKER_SACCRG(  8, 28) =  0.192450E+01
  PKER_SACCRG(  8, 29) =  0.195757E+01
  PKER_SACCRG(  8, 30) =  0.199227E+01
  PKER_SACCRG(  8, 31) =  0.201226E+01
  PKER_SACCRG(  8, 32) =  0.202464E+01
  PKER_SACCRG(  8, 33) =  0.203441E+01
  PKER_SACCRG(  8, 34) =  0.203619E+01
  PKER_SACCRG(  8, 35) =  0.204416E+01
  PKER_SACCRG(  8, 36) =  0.206100E+01
  PKER_SACCRG(  8, 37) =  0.000000E+00
  PKER_SACCRG(  8, 38) =  0.000000E+00
  PKER_SACCRG(  8, 39) =  0.000000E+00
  PKER_SACCRG(  8, 40) =  0.000000E+00
  PKER_SACCRG(  9,  1) =  0.227973E-03
  PKER_SACCRG(  9,  2) =  0.282707E-02
  PKER_SACCRG(  9,  3) =  0.180146E-02
  PKER_SACCRG(  9,  4) =  0.195291E-02
  PKER_SACCRG(  9,  5) =  0.601462E-02
  PKER_SACCRG(  9,  6) =  0.639847E-02
  PKER_SACCRG(  9,  7) =  0.503409E-02
  PKER_SACCRG(  9,  8) =  0.874760E-02
  PKER_SACCRG(  9,  9) =  0.125924E-01
  PKER_SACCRG(  9, 10) =  0.187098E-01
  PKER_SACCRG(  9, 11) =  0.315437E-01
  PKER_SACCRG(  9, 12) =  0.563136E-01
  PKER_SACCRG(  9, 13) =  0.100517E+00
  PKER_SACCRG(  9, 14) =  0.173643E+00
  PKER_SACCRG(  9, 15) =  0.275822E+00
  PKER_SACCRG(  9, 16) =  0.405835E+00
  PKER_SACCRG(  9, 17) =  0.540959E+00
  PKER_SACCRG(  9, 18) =  0.670349E+00
  PKER_SACCRG(  9, 19) =  0.779801E+00
  PKER_SACCRG(  9, 20) =  0.873659E+00
  PKER_SACCRG(  9, 21) =  0.964651E+00
  PKER_SACCRG(  9, 22) =  0.105792E+01
  PKER_SACCRG(  9, 23) =  0.114069E+01
  PKER_SACCRG(  9, 24) =  0.123707E+01
  PKER_SACCRG(  9, 25) =  0.131072E+01
  PKER_SACCRG(  9, 26) =  0.137674E+01
  PKER_SACCRG(  9, 27) =  0.143675E+01
  PKER_SACCRG(  9, 28) =  0.146856E+01
  PKER_SACCRG(  9, 29) =  0.150083E+01
  PKER_SACCRG(  9, 30) =  0.153465E+01
  PKER_SACCRG(  9, 31) =  0.155430E+01
  PKER_SACCRG(  9, 32) =  0.156652E+01
  PKER_SACCRG(  9, 33) =  0.157614E+01
  PKER_SACCRG(  9, 34) =  0.157797E+01
  PKER_SACCRG(  9, 35) =  0.158578E+01
  PKER_SACCRG(  9, 36) =  0.160221E+01
  PKER_SACCRG(  9, 37) =  0.000000E+00
  PKER_SACCRG(  9, 38) =  0.000000E+00
  PKER_SACCRG(  9, 39) =  0.000000E+00
  PKER_SACCRG(  9, 40) =  0.000000E+00
  PKER_SACCRG( 10,  1) =  0.836884E-05
  PKER_SACCRG( 10,  2) =  0.241023E-03
  PKER_SACCRG( 10,  3) =  0.298555E-02
  PKER_SACCRG( 10,  4) =  0.189539E-02
  PKER_SACCRG( 10,  5) =  0.204013E-02
  PKER_SACCRG( 10,  6) =  0.618434E-02
  PKER_SACCRG( 10,  7) =  0.624911E-02
  PKER_SACCRG( 10,  8) =  0.493580E-02
  PKER_SACCRG( 10,  9) =  0.859150E-02
  PKER_SACCRG( 10, 10) =  0.132122E-01
  PKER_SACCRG( 10, 11) =  0.178104E-01
  PKER_SACCRG( 10, 12) =  0.313842E-01
  PKER_SACCRG( 10, 13) =  0.543137E-01
  PKER_SACCRG( 10, 14) =  0.957524E-01
  PKER_SACCRG( 10, 15) =  0.158366E+00
  PKER_SACCRG( 10, 16) =  0.250247E+00
  PKER_SACCRG( 10, 17) =  0.351339E+00
  PKER_SACCRG( 10, 18) =  0.455229E+00
  PKER_SACCRG( 10, 19) =  0.541376E+00
  PKER_SACCRG( 10, 20) =  0.613508E+00
  PKER_SACCRG( 10, 21) =  0.679512E+00
  PKER_SACCRG( 10, 22) =  0.748499E+00
  PKER_SACCRG( 10, 23) =  0.812917E+00
  PKER_SACCRG( 10, 24) =  0.891097E+00
  PKER_SACCRG( 10, 25) =  0.953782E+00
  PKER_SACCRG( 10, 26) =  0.101178E+01
  PKER_SACCRG( 10, 27) =  0.106610E+01
  PKER_SACCRG( 10, 28) =  0.109586E+01
  PKER_SACCRG( 10, 29) =  0.112638E+01
  PKER_SACCRG( 10, 30) =  0.115867E+01
  PKER_SACCRG( 10, 31) =  0.117769E+01
  PKER_SACCRG( 10, 32) =  0.118959E+01
  PKER_SACCRG( 10, 33) =  0.119896E+01
  PKER_SACCRG( 10, 34) =  0.120079E+01
  PKER_SACCRG( 10, 35) =  0.120838E+01
  PKER_SACCRG( 10, 36) =  0.122431E+01
  PKER_SACCRG( 10, 37) =  0.000000E+00
  PKER_SACCRG( 10, 38) =  0.000000E+00
  PKER_SACCRG( 10, 39) =  0.000000E+00
  PKER_SACCRG( 10, 40) =  0.000000E+00
  PKER_SACCRG( 11,  1) =  0.000000E+00
  PKER_SACCRG( 11,  2) =  0.984489E-05
  PKER_SACCRG( 11,  3) =  0.280498E-03
  PKER_SACCRG( 11,  4) =  0.349195E-02
  PKER_SACCRG( 11,  5) =  0.223140E-02
  PKER_SACCRG( 11,  6) =  0.240058E-02
  PKER_SACCRG( 11,  7) =  0.683543E-02
  PKER_SACCRG( 11,  8) =  0.692007E-02
  PKER_SACCRG( 11,  9) =  0.514199E-02
  PKER_SACCRG( 11, 10) =  0.114977E-01
  PKER_SACCRG( 11, 11) =  0.109728E-01
  PKER_SACCRG( 11, 12) =  0.211442E-01
  PKER_SACCRG( 11, 13) =  0.346586E-01
  PKER_SACCRG( 11, 14) =  0.591042E-01
  PKER_SACCRG( 11, 15) =  0.961841E-01
  PKER_SACCRG( 11, 16) =  0.162562E+00
  PKER_SACCRG( 11, 17) =  0.237843E+00
  PKER_SACCRG( 11, 18) =  0.321714E+00
  PKER_SACCRG( 11, 19) =  0.387542E+00
  PKER_SACCRG( 11, 20) =  0.440755E+00
  PKER_SACCRG( 11, 21) =  0.483048E+00
  PKER_SACCRG( 11, 22) =  0.527421E+00
  PKER_SACCRG( 11, 23) =  0.571319E+00
  PKER_SACCRG( 11, 24) =  0.628617E+00
  PKER_SACCRG( 11, 25) =  0.677728E+00
  PKER_SACCRG( 11, 26) =  0.725464E+00
  PKER_SACCRG( 11, 27) =  0.771793E+00
  PKER_SACCRG( 11, 28) =  0.798056E+00
  PKER_SACCRG( 11, 29) =  0.825035E+00
  PKER_SACCRG( 11, 30) =  0.853830E+00
  PKER_SACCRG( 11, 31) =  0.871001E+00
  PKER_SACCRG( 11, 32) =  0.881834E+00
  PKER_SACCRG( 11, 33) =  0.890401E+00
  PKER_SACCRG( 11, 34) =  0.892044E+00
  PKER_SACCRG( 11, 35) =  0.899026E+00
  PKER_SACCRG( 11, 36) =  0.913978E+00
  PKER_SACCRG( 11, 37) =  0.000000E+00
  PKER_SACCRG( 11, 38) =  0.000000E+00
  PKER_SACCRG( 11, 39) =  0.000000E+00
  PKER_SACCRG( 11, 40) =  0.000000E+00
  PKER_SACCRG( 12,  1) =  0.000000E+00
  PKER_SACCRG( 12,  2) =  0.000000E+00
  PKER_SACCRG( 12,  3) =  0.131525E-04
  PKER_SACCRG( 12,  4) =  0.376734E-03
  PKER_SACCRG( 12,  5) =  0.481352E-02
  PKER_SACCRG( 12,  6) =  0.318057E-02
  PKER_SACCRG( 12,  7) =  0.345470E-02
  PKER_SACCRG( 12,  8) =  0.420666E-02
  PKER_SACCRG( 12,  9) =  0.383001E-02
  PKER_SACCRG( 12, 10) =  0.110848E-01
  PKER_SACCRG( 12, 11) =  0.934829E-02
  PKER_SACCRG( 12, 12) =  0.183949E-01
  PKER_SACCRG( 12, 13) =  0.295675E-01
  PKER_SACCRG( 12, 14) =  0.470543E-01
  PKER_SACCRG( 12, 15) =  0.695886E-01
  PKER_SACCRG( 12, 16) =  0.122527E+00
  PKER_SACCRG( 12, 17) =  0.181754E+00
  PKER_SACCRG( 12, 18) =  0.253508E+00
  PKER_SACCRG( 12, 19) =  0.304324E+00
  PKER_SACCRG( 12, 20) =  0.342444E+00
  PKER_SACCRG( 12, 21) =  0.363399E+00
  PKER_SACCRG( 12, 22) =  0.384221E+00
  PKER_SACCRG( 12, 23) =  0.406941E+00
  PKER_SACCRG( 12, 24) =  0.441951E+00
  PKER_SACCRG( 12, 25) =  0.474892E+00
  PKER_SACCRG( 12, 26) =  0.509393E+00
  PKER_SACCRG( 12, 27) =  0.545053E+00
  PKER_SACCRG( 12, 28) =  0.566107E+00
  PKER_SACCRG( 12, 29) =  0.588592E+00
  PKER_SACCRG( 12, 30) =  0.613355E+00
  PKER_SACCRG( 12, 31) =  0.628544E+00
  PKER_SACCRG( 12, 32) =  0.638273E+00
  PKER_SACCRG( 12, 33) =  0.646003E+00
  PKER_SACCRG( 12, 34) =  0.647602E+00
  PKER_SACCRG( 12, 35) =  0.653888E+00
  PKER_SACCRG( 12, 36) =  0.667119E+00
  PKER_SACCRG( 12, 37) =  0.000000E+00
  PKER_SACCRG( 12, 38) =  0.000000E+00
  PKER_SACCRG( 12, 39) =  0.000000E+00
  PKER_SACCRG( 12, 40) =  0.000000E+00
  PKER_SACCRG( 13,  1) =  0.000000E+00
  PKER_SACCRG( 13,  2) =  0.000000E+00
  PKER_SACCRG( 13,  3) =  0.715754E-07
  PKER_SACCRG( 13,  4) =  0.213213E-04
  PKER_SACCRG( 13,  5) =  0.638125E-03
  PKER_SACCRG( 13,  6) =  0.842445E-03
  PKER_SACCRG( 13,  7) =  0.719221E-02
  PKER_SACCRG( 13,  8) =  0.932081E-02
  PKER_SACCRG( 13,  9) =  0.442957E-02
  PKER_SACCRG( 13, 10) =  0.154869E-01
  PKER_SACCRG( 13, 11) =  0.137909E-01
  PKER_SACCRG( 13, 12) =  0.248513E-01
  PKER_SACCRG( 13, 13) =  0.394496E-01
  PKER_SACCRG( 13, 14) =  0.513911E-01
  PKER_SACCRG( 13, 15) =  0.661668E-01
  PKER_SACCRG( 13, 16) =  0.115529E+00
  PKER_SACCRG( 13, 17) =  0.166381E+00
  PKER_SACCRG( 13, 18) =  0.234091E+00
  PKER_SACCRG( 13, 19) =  0.276281E+00
  PKER_SACCRG( 13, 20) =  0.304686E+00
  PKER_SACCRG( 13, 21) =  0.307989E+00
  PKER_SACCRG( 13, 22) =  0.307891E+00
  PKER_SACCRG( 13, 23) =  0.310412E+00
  PKER_SACCRG( 13, 24) =  0.323293E+00
  PKER_SACCRG( 13, 25) =  0.338766E+00
  PKER_SACCRG( 13, 26) =  0.358236E+00
  PKER_SACCRG( 13, 27) =  0.380952E+00
  PKER_SACCRG( 13, 28) =  0.395254E+00
  PKER_SACCRG( 13, 29) =  0.411396E+00
  PKER_SACCRG( 13, 30) =  0.429868E+00
  PKER_SACCRG( 13, 31) =  0.441480E+00
  PKER_SACCRG( 13, 32) =  0.449014E+00
  PKER_SACCRG( 13, 33) =  0.455042E+00
  PKER_SACCRG( 13, 34) =  0.456301E+00
  PKER_SACCRG( 13, 35) =  0.461238E+00
  PKER_SACCRG( 13, 36) =  0.471725E+00
  PKER_SACCRG( 13, 37) =  0.000000E+00
  PKER_SACCRG( 13, 38) =  0.000000E+00
  PKER_SACCRG( 13, 39) =  0.000000E+00
  PKER_SACCRG( 13, 40) =  0.000000E+00
  PKER_SACCRG( 14,  1) =  0.000000E+00
  PKER_SACCRG( 14,  2) =  0.000000E+00
  PKER_SACCRG( 14,  3) =  0.000000E+00
  PKER_SACCRG( 14,  4) =  0.381946E-06
  PKER_SACCRG( 14,  5) =  0.473573E-04
  PKER_SACCRG( 14,  6) =  0.165120E-02
  PKER_SACCRG( 14,  7) =  0.389733E-02
  PKER_SACCRG( 14,  8) =  0.389488E-01
  PKER_SACCRG( 14,  9) =  0.960356E-02
  PKER_SACCRG( 14, 10) =  0.289006E-01
  PKER_SACCRG( 14, 11) =  0.219911E-01
  PKER_SACCRG( 14, 12) =  0.526837E-01
  PKER_SACCRG( 14, 13) =  0.654887E-01
  PKER_SACCRG( 14, 14) =  0.683643E-01
  PKER_SACCRG( 14, 15) =  0.802145E-01
  PKER_SACCRG( 14, 16) =  0.134652E+00
  PKER_SACCRG( 14, 17) =  0.180678E+00
  PKER_SACCRG( 14, 18) =  0.248857E+00
  PKER_SACCRG( 14, 19) =  0.287693E+00
  PKER_SACCRG( 14, 20) =  0.311977E+00
  PKER_SACCRG( 14, 21) =  0.302501E+00
  PKER_SACCRG( 14, 22) =  0.285666E+00
  PKER_SACCRG( 14, 23) =  0.270663E+00
  PKER_SACCRG( 14, 24) =  0.263508E+00
  PKER_SACCRG( 14, 25) =  0.261858E+00
  PKER_SACCRG( 14, 26) =  0.265704E+00
  PKER_SACCRG( 14, 27) =  0.274260E+00
  PKER_SACCRG( 14, 28) =  0.280343E+00
  PKER_SACCRG( 14, 29) =  0.288745E+00
  PKER_SACCRG( 14, 30) =  0.299555E+00
  PKER_SACCRG( 14, 31) =  0.306742E+00
  PKER_SACCRG( 14, 32) =  0.311519E+00
  PKER_SACCRG( 14, 33) =  0.315446E+00
  PKER_SACCRG( 14, 34) =  0.316143E+00
  PKER_SACCRG( 14, 35) =  0.319453E+00
  PKER_SACCRG( 14, 36) =  0.326846E+00
  PKER_SACCRG( 14, 37) =  0.000000E+00
  PKER_SACCRG( 14, 38) =  0.000000E+00
  PKER_SACCRG( 14, 39) =  0.000000E+00
  PKER_SACCRG( 14, 40) =  0.000000E+00
  PKER_SACCRG( 15,  1) =  0.000000E+00
  PKER_SACCRG( 15,  2) =  0.000000E+00
  PKER_SACCRG( 15,  3) =  0.000000E+00
  PKER_SACCRG( 15,  4) =  0.000000E+00
  PKER_SACCRG( 15,  5) =  0.156840E-05
  PKER_SACCRG( 15,  6) =  0.190758E-03
  PKER_SACCRG( 15,  7) =  0.213304E-01
  PKER_SACCRG( 15,  8) =  0.441574E-01
  PKER_SACCRG( 15,  9) =  0.400468E-01
  PKER_SACCRG( 15, 10) =  0.704682E-01
  PKER_SACCRG( 15, 11) =  0.469944E-01
  PKER_SACCRG( 15, 12) =  0.981183E-01
  PKER_SACCRG( 15, 13) =  0.100527E+00
  PKER_SACCRG( 15, 14) =  0.109911E+00
  PKER_SACCRG( 15, 15) =  0.122766E+00
  PKER_SACCRG( 15, 16) =  0.166781E+00
  PKER_SACCRG( 15, 17) =  0.213821E+00
  PKER_SACCRG( 15, 18) =  0.285192E+00
  PKER_SACCRG( 15, 19) =  0.323590E+00
  PKER_SACCRG( 15, 20) =  0.348069E+00
  PKER_SACCRG( 15, 21) =  0.330921E+00
  PKER_SACCRG( 15, 22) =  0.302486E+00
  PKER_SACCRG( 15, 23) =  0.274134E+00
  PKER_SACCRG( 15, 24) =  0.250992E+00
  PKER_SACCRG( 15, 25) =  0.234616E+00
  PKER_SACCRG( 15, 26) =  0.224211E+00
  PKER_SACCRG( 15, 27) =  0.219091E+00
  PKER_SACCRG( 15, 28) =  0.216667E+00
  PKER_SACCRG( 15, 29) =  0.216954E+00
  PKER_SACCRG( 15, 30) =  0.219635E+00
  PKER_SACCRG( 15, 31) =  0.221903E+00
  PKER_SACCRG( 15, 32) =  0.223652E+00
  PKER_SACCRG( 15, 33) =  0.225260E+00
  PKER_SACCRG( 15, 34) =  0.225539E+00
  PKER_SACCRG( 15, 35) =  0.227017E+00
  PKER_SACCRG( 15, 36) =  0.230425E+00
  PKER_SACCRG( 15, 37) =  0.000000E+00
  PKER_SACCRG( 15, 38) =  0.000000E+00
  PKER_SACCRG( 15, 39) =  0.000000E+00
  PKER_SACCRG( 15, 40) =  0.000000E+00
  PKER_SACCRG( 16,  1) =  0.000000E+00
  PKER_SACCRG( 16,  2) =  0.000000E+00
  PKER_SACCRG( 16,  3) =  0.000000E+00
  PKER_SACCRG( 16,  4) =  0.000000E+00
  PKER_SACCRG( 16,  5) =  0.000000E+00
  PKER_SACCRG( 16,  6) =  0.119071E-04
  PKER_SACCRG( 16,  7) =  0.989929E-02
  PKER_SACCRG( 16,  8) =  0.528890E+00
  PKER_SACCRG( 16,  9) =  0.450696E-01
  PKER_SACCRG( 16, 10) =  0.655297E-01
  PKER_SACCRG( 16, 11) =  0.132187E+00
  PKER_SACCRG( 16, 12) =  0.215348E+00
  PKER_SACCRG( 16, 13) =  0.167588E+00
  PKER_SACCRG( 16, 14) =  0.216205E+00
  PKER_SACCRG( 16, 15) =  0.162196E+00
  PKER_SACCRG( 16, 16) =  0.244005E+00
  PKER_SACCRG( 16, 17) =  0.269648E+00
  PKER_SACCRG( 16, 18) =  0.340900E+00
  PKER_SACCRG( 16, 19) =  0.372264E+00
  PKER_SACCRG( 16, 20) =  0.398617E+00
  PKER_SACCRG( 16, 21) =  0.377733E+00
  PKER_SACCRG( 16, 22) =  0.342874E+00
  PKER_SACCRG( 16, 23) =  0.305984E+00
  PKER_SACCRG( 16, 24) =  0.271888E+00
  PKER_SACCRG( 16, 25) =  0.244614E+00
  PKER_SACCRG( 16, 26) =  0.222952E+00
  PKER_SACCRG( 16, 27) =  0.206393E+00
  PKER_SACCRG( 16, 28) =  0.196281E+00
  PKER_SACCRG( 16, 29) =  0.189043E+00
  PKER_SACCRG( 16, 30) =  0.183996E+00
  PKER_SACCRG( 16, 31) =  0.181421E+00
  PKER_SACCRG( 16, 32) =  0.180072E+00
  PKER_SACCRG( 16, 33) =  0.179344E+00
  PKER_SACCRG( 16, 34) =  0.178990E+00
  PKER_SACCRG( 16, 35) =  0.178753E+00
  PKER_SACCRG( 16, 36) =  0.178876E+00
  PKER_SACCRG( 16, 37) =  0.000000E+00
  PKER_SACCRG( 16, 38) =  0.000000E+00
  PKER_SACCRG( 16, 39) =  0.000000E+00
  PKER_SACCRG( 16, 40) =  0.000000E+00
  PKER_SACCRG( 17,  1) =  0.000000E+00
  PKER_SACCRG( 17,  2) =  0.000000E+00
  PKER_SACCRG( 17,  3) =  0.000000E+00
  PKER_SACCRG( 17,  4) =  0.000000E+00
  PKER_SACCRG( 17,  5) =  0.000000E+00
  PKER_SACCRG( 17,  6) =  0.284464E-06
  PKER_SACCRG( 17,  7) =  0.376463E-02
  PKER_SACCRG( 17,  8) =  0.586668E+00
  PKER_SACCRG( 17,  9) =  0.500034E-01
  PKER_SACCRG( 17, 10) =  0.220639E+00
  PKER_SACCRG( 17, 11) =  0.146258E+00
  PKER_SACCRG( 17, 12) =  0.237708E+00
  PKER_SACCRG( 17, 13) =  0.306782E+00
  PKER_SACCRG( 17, 14) =  0.354063E+00
  PKER_SACCRG( 17, 15) =  0.280860E+00
  PKER_SACCRG( 17, 16) =  0.308089E+00
  PKER_SACCRG( 17, 17) =  0.339505E+00
  PKER_SACCRG( 17, 18) =  0.414880E+00
  PKER_SACCRG( 17, 19) =  0.430629E+00
  PKER_SACCRG( 17, 20) =  0.452781E+00
  PKER_SACCRG( 17, 21) =  0.429564E+00
  PKER_SACCRG( 17, 22) =  0.392080E+00
  PKER_SACCRG( 17, 23) =  0.351048E+00
  PKER_SACCRG( 17, 24) =  0.310955E+00
  PKER_SACCRG( 17, 25) =  0.277207E+00
  PKER_SACCRG( 17, 26) =  0.248275E+00
  PKER_SACCRG( 17, 27) =  0.223790E+00
  PKER_SACCRG( 17, 28) =  0.208062E+00
  PKER_SACCRG( 17, 29) =  0.195017E+00
  PKER_SACCRG( 17, 30) =  0.183624E+00
  PKER_SACCRG( 17, 31) =  0.176886E+00
  PKER_SACCRG( 17, 32) =  0.172790E+00
  PKER_SACCRG( 17, 33) =  0.169882E+00
  PKER_SACCRG( 17, 34) =  0.169010E+00
  PKER_SACCRG( 17, 35) =  0.166994E+00
  PKER_SACCRG( 17, 36) =  0.163299E+00
  PKER_SACCRG( 17, 37) =  0.000000E+00
  PKER_SACCRG( 17, 38) =  0.000000E+00
  PKER_SACCRG( 17, 39) =  0.000000E+00
  PKER_SACCRG( 17, 40) =  0.000000E+00
  PKER_SACCRG( 18,  1) =  0.000000E+00
  PKER_SACCRG( 18,  2) =  0.000000E+00
  PKER_SACCRG( 18,  3) =  0.000000E+00
  PKER_SACCRG( 18,  4) =  0.000000E+00
  PKER_SACCRG( 18,  5) =  0.000000E+00
  PKER_SACCRG( 18,  6) =  0.000000E+00
  PKER_SACCRG( 18,  7) =  0.105382E-02
  PKER_SACCRG( 18,  8) =  0.635938E+00
  PKER_SACCRG( 18,  9) =  0.581236E+00
  PKER_SACCRG( 18, 10) =  0.175918E+00
  PKER_SACCRG( 18, 11) =  0.158333E+00
  PKER_SACCRG( 18, 12) =  0.645276E+00
  PKER_SACCRG( 18, 13) =  0.647795E+00
  PKER_SACCRG( 18, 14) =  0.383206E+00
  PKER_SACCRG( 18, 15) =  0.415829E+00
  PKER_SACCRG( 18, 16) =  0.392871E+00
  PKER_SACCRG( 18, 17) =  0.447385E+00
  PKER_SACCRG( 18, 18) =  0.473465E+00
  PKER_SACCRG( 18, 19) =  0.487585E+00
  PKER_SACCRG( 18, 20) =  0.505825E+00
  PKER_SACCRG( 18, 21) =  0.478975E+00
  PKER_SACCRG( 18, 22) =  0.440594E+00
  PKER_SACCRG( 18, 23) =  0.398291E+00
  PKER_SACCRG( 18, 24) =  0.355953E+00
  PKER_SACCRG( 18, 25) =  0.319332E+00
  PKER_SACCRG( 18, 26) =  0.286857E+00
  PKER_SACCRG( 18, 27) =  0.258053E+00
  PKER_SACCRG( 18, 28) =  0.239021E+00
  PKER_SACCRG( 18, 29) =  0.222386E+00
  PKER_SACCRG( 18, 30) =  0.206903E+00
  PKER_SACCRG( 18, 31) =  0.197361E+00
  PKER_SACCRG( 18, 32) =  0.191347E+00
  PKER_SACCRG( 18, 33) =  0.186901E+00
  PKER_SACCRG( 18, 34) =  0.185599E+00
  PKER_SACCRG( 18, 35) =  0.182341E+00
  PKER_SACCRG( 18, 36) =  0.176179E+00
  PKER_SACCRG( 18, 37) =  0.000000E+00
  PKER_SACCRG( 18, 38) =  0.000000E+00
  PKER_SACCRG( 18, 39) =  0.000000E+00
  PKER_SACCRG( 18, 40) =  0.000000E+00
  PKER_SACCRG( 19,  1) =  0.000000E+00
  PKER_SACCRG( 19,  2) =  0.000000E+00
  PKER_SACCRG( 19,  3) =  0.000000E+00
  PKER_SACCRG( 19,  4) =  0.000000E+00
  PKER_SACCRG( 19,  5) =  0.000000E+00
  PKER_SACCRG( 19,  6) =  0.000000E+00
  PKER_SACCRG( 19,  7) =  0.194865E-03
  PKER_SACCRG( 19,  8) =  0.676347E+00
  PKER_SACCRG( 19,  9) =  0.621969E+00
  PKER_SACCRG( 19, 10) =  0.131032E+00
  PKER_SACCRG( 19, 11) =  0.658583E+00
  PKER_SACCRG( 19, 12) =  0.685804E+00
  PKER_SACCRG( 19, 13) =  0.688335E+00
  PKER_SACCRG( 19, 14) =  0.677066E+00
  PKER_SACCRG( 19, 15) =  0.442768E+00
  PKER_SACCRG( 19, 16) =  0.511298E+00
  PKER_SACCRG( 19, 17) =  0.544390E+00
  PKER_SACCRG( 19, 18) =  0.574263E+00
  PKER_SACCRG( 19, 19) =  0.551361E+00
  PKER_SACCRG( 19, 20) =  0.554396E+00
  PKER_SACCRG( 19, 21) =  0.521768E+00
  PKER_SACCRG( 19, 22) =  0.483164E+00
  PKER_SACCRG( 19, 23) =  0.440915E+00
  PKER_SACCRG( 19, 24) =  0.398417E+00
  PKER_SACCRG( 19, 25) =  0.361201E+00
  PKER_SACCRG( 19, 26) =  0.327700E+00
  PKER_SACCRG( 19, 27) =  0.297381E+00
  PKER_SACCRG( 19, 28) =  0.276977E+00
  PKER_SACCRG( 19, 29) =  0.258775E+00
  PKER_SACCRG( 19, 30) =  0.241338E+00
  PKER_SACCRG( 19, 31) =  0.230370E+00
  PKER_SACCRG( 19, 32) =  0.223349E+00
  PKER_SACCRG( 19, 33) =  0.218072E+00
  PKER_SACCRG( 19, 34) =  0.216544E+00
  PKER_SACCRG( 19, 35) =  0.212586E+00
  PKER_SACCRG( 19, 36) =  0.204880E+00
  PKER_SACCRG( 19, 37) =  0.000000E+00
  PKER_SACCRG( 19, 38) =  0.000000E+00
  PKER_SACCRG( 19, 39) =  0.000000E+00
  PKER_SACCRG( 19, 40) =  0.000000E+00
  PKER_SACCRG( 20,  1) =  0.000000E+00
  PKER_SACCRG( 20,  2) =  0.000000E+00
  PKER_SACCRG( 20,  3) =  0.000000E+00
  PKER_SACCRG( 20,  4) =  0.000000E+00
  PKER_SACCRG( 20,  5) =  0.000000E+00
  PKER_SACCRG( 20,  6) =  0.000000E+00
  PKER_SACCRG( 20,  7) =  0.210974E-04
  PKER_SACCRG( 20,  8) =  0.709956E+00
  PKER_SACCRG( 20,  9) =  0.655815E+00
  PKER_SACCRG( 20, 10) =  0.956725E-01
  PKER_SACCRG( 20, 11) =  0.692386E+00
  PKER_SACCRG( 20, 12) =  0.719525E+00
  PKER_SACCRG( 20, 13) =  0.722068E+00
  PKER_SACCRG( 20, 14) =  0.710869E+00
  PKER_SACCRG( 20, 15) =  0.691117E+00
  PKER_SACCRG( 20, 16) =  0.690018E+00
  PKER_SACCRG( 20, 17) =  0.573065E+00
  PKER_SACCRG( 20, 18) =  0.605475E+00
  PKER_SACCRG( 20, 19) =  0.604580E+00
  PKER_SACCRG( 20, 20) =  0.595016E+00
  PKER_SACCRG( 20, 21) =  0.559020E+00
  PKER_SACCRG( 20, 22) =  0.519154E+00
  PKER_SACCRG( 20, 23) =  0.477263E+00
  PKER_SACCRG( 20, 24) =  0.435286E+00
  PKER_SACCRG( 20, 25) =  0.398364E+00
  PKER_SACCRG( 20, 26) =  0.364991E+00
  PKER_SACCRG( 20, 27) =  0.334611E+00
  PKER_SACCRG( 20, 28) =  0.313905E+00
  PKER_SACCRG( 20, 29) =  0.295342E+00
  PKER_SACCRG( 20, 30) =  0.277428E+00
  PKER_SACCRG( 20, 31) =  0.266023E+00
  PKER_SACCRG( 20, 32) =  0.258671E+00
  PKER_SACCRG( 20, 33) =  0.253118E+00
  PKER_SACCRG( 20, 34) =  0.251504E+00
  PKER_SACCRG( 20, 35) =  0.247323E+00
  PKER_SACCRG( 20, 36) =  0.239150E+00
  PKER_SACCRG( 20, 37) =  0.000000E+00
  PKER_SACCRG( 20, 38) =  0.000000E+00
  PKER_SACCRG( 20, 39) =  0.000000E+00
  PKER_SACCRG( 20, 40) =  0.000000E+00
  PKER_SACCRG( 21,  1) =  0.000000E+00
  PKER_SACCRG( 21,  2) =  0.000000E+00
  PKER_SACCRG( 21,  3) =  0.000000E+00
  PKER_SACCRG( 21,  4) =  0.000000E+00
  PKER_SACCRG( 21,  5) =  0.000000E+00
  PKER_SACCRG( 21,  6) =  0.000000E+00
  PKER_SACCRG( 21,  7) =  0.115787E-05
  PKER_SACCRG( 21,  8) =  0.737622E+00
  PKER_SACCRG( 21,  9) =  0.683641E+00
  PKER_SACCRG( 21, 10) =  0.742791E-01
  PKER_SACCRG( 21, 11) =  0.720196E+00
  PKER_SACCRG( 21, 12) =  0.747281E+00
  PKER_SACCRG( 21, 13) =  0.749836E+00
  PKER_SACCRG( 21, 14) =  0.738685E+00
  PKER_SACCRG( 21, 15) =  0.719015E+00
  PKER_SACCRG( 21, 16) =  0.717958E+00
  PKER_SACCRG( 21, 17) =  0.702249E+00
  PKER_SACCRG( 21, 18) =  0.688360E+00
  PKER_SACCRG( 21, 19) =  0.631563E+00
  PKER_SACCRG( 21, 20) =  0.632341E+00
  PKER_SACCRG( 21, 21) =  0.589665E+00
  PKER_SACCRG( 21, 22) =  0.548711E+00
  PKER_SACCRG( 21, 23) =  0.507170E+00
  PKER_SACCRG( 21, 24) =  0.465784E+00
  PKER_SACCRG( 21, 25) =  0.429322E+00
  PKER_SACCRG( 21, 26) =  0.396378E+00
  PKER_SACCRG( 21, 27) =  0.366391E+00
  PKER_SACCRG( 21, 28) =  0.345783E+00
  PKER_SACCRG( 21, 29) =  0.327346E+00
  PKER_SACCRG( 21, 30) =  0.309575E+00
  PKER_SACCRG( 21, 31) =  0.298199E+00
  PKER_SACCRG( 21, 32) =  0.290842E+00
  PKER_SACCRG( 21, 33) =  0.285284E+00
  PKER_SACCRG( 21, 34) =  0.283648E+00
  PKER_SACCRG( 21, 35) =  0.279467E+00
  PKER_SACCRG( 21, 36) =  0.271303E+00
  PKER_SACCRG( 21, 37) =  0.000000E+00
  PKER_SACCRG( 21, 38) =  0.000000E+00
  PKER_SACCRG( 21, 39) =  0.000000E+00
  PKER_SACCRG( 21, 40) =  0.000000E+00
  PKER_SACCRG( 22,  1) =  0.000000E+00
  PKER_SACCRG( 22,  2) =  0.000000E+00
  PKER_SACCRG( 22,  3) =  0.000000E+00
  PKER_SACCRG( 22,  4) =  0.000000E+00
  PKER_SACCRG( 22,  5) =  0.000000E+00
  PKER_SACCRG( 22,  6) =  0.000000E+00
  PKER_SACCRG( 22,  7) =  0.153493E-07
  PKER_SACCRG( 22,  8) =  0.760420E+00
  PKER_SACCRG( 22,  9) =  0.706545E+00
  PKER_SACCRG( 22, 10) =  0.650587E-01
  PKER_SACCRG( 22, 11) =  0.743098E+00
  PKER_SACCRG( 22, 12) =  0.770151E+00
  PKER_SACCRG( 22, 13) =  0.772714E+00
  PKER_SACCRG( 22, 14) =  0.761598E+00
  PKER_SACCRG( 22, 15) =  0.741985E+00
  PKER_SACCRG( 22, 16) =  0.740959E+00
  PKER_SACCRG( 22, 17) =  0.725323E+00
  PKER_SACCRG( 22, 18) =  0.711529E+00
  PKER_SACCRG( 22, 19) =  0.653730E+00
  PKER_SACCRG( 22, 20) =  0.655849E+00
  PKER_SACCRG( 22, 21) =  0.613326E+00
  PKER_SACCRG( 22, 22) =  0.573001E+00
  PKER_SACCRG( 22, 23) =  0.531612E+00
  PKER_SACCRG( 22, 24) =  0.490679E+00
  PKER_SACCRG( 22, 25) =  0.454592E+00
  PKER_SACCRG( 22, 26) =  0.422026E+00
  PKER_SACCRG( 22, 27) =  0.392436E+00
  PKER_SACCRG( 22, 28) =  0.371968E+00
  PKER_SACCRG( 22, 29) =  0.353731E+00
  PKER_SACCRG( 22, 30) =  0.336228E+00
  PKER_SACCRG( 22, 31) =  0.324990E+00
  PKER_SACCRG( 22, 32) =  0.317714E+00
  PKER_SACCRG( 22, 33) =  0.312229E+00
  PKER_SACCRG( 22, 34) =  0.310590E+00
  PKER_SACCRG( 22, 35) =  0.306480E+00
  PKER_SACCRG( 22, 36) =  0.298487E+00
  PKER_SACCRG( 22, 37) =  0.000000E+00
  PKER_SACCRG( 22, 38) =  0.000000E+00
  PKER_SACCRG( 22, 39) =  0.000000E+00
  PKER_SACCRG( 22, 40) =  0.000000E+00
  PKER_SACCRG( 23,  1) =  0.000000E+00
  PKER_SACCRG( 23,  2) =  0.000000E+00
  PKER_SACCRG( 23,  3) =  0.000000E+00
  PKER_SACCRG( 23,  4) =  0.000000E+00
  PKER_SACCRG( 23,  5) =  0.000000E+00
  PKER_SACCRG( 23,  6) =  0.000000E+00
  PKER_SACCRG( 23,  7) =  0.000000E+00
  PKER_SACCRG( 23,  8) =  0.779223E+00
  PKER_SACCRG( 23,  9) =  0.725418E+00
  PKER_SACCRG( 23, 10) =  0.629066E-01
  PKER_SACCRG( 23, 11) =  0.761978E+00
  PKER_SACCRG( 23, 12) =  0.789011E+00
  PKER_SACCRG( 23, 13) =  0.791581E+00
  PKER_SACCRG( 23, 14) =  0.780490E+00
  PKER_SACCRG( 23, 15) =  0.760916E+00
  PKER_SACCRG( 23, 16) =  0.759915E+00
  PKER_SACCRG( 23, 17) =  0.744331E+00
  PKER_SACCRG( 23, 18) =  0.730605E+00
  PKER_SACCRG( 23, 19) =  0.703564E+00
  PKER_SACCRG( 23, 20) =  0.675170E+00
  PKER_SACCRG( 23, 21) =  0.632741E+00
  PKER_SACCRG( 23, 22) =  0.592686E+00
  PKER_SACCRG( 23, 23) =  0.551579E+00
  PKER_SACCRG( 23, 24) =  0.510978E+00
  PKER_SACCRG( 23, 25) =  0.475153E+00
  PKER_SACCRG( 23, 26) =  0.442855E+00
  PKER_SACCRG( 23, 27) =  0.413554E+00
  PKER_SACCRG( 23, 28) =  0.393180E+00
  PKER_SACCRG( 23, 29) =  0.375093E+00
  PKER_SACCRG( 23, 30) =  0.357805E+00
  PKER_SACCRG( 23, 31) =  0.346682E+00
  PKER_SACCRG( 23, 32) =  0.339475E+00
  PKER_SACCRG( 23, 33) =  0.334055E+00
  PKER_SACCRG( 23, 34) =  0.332413E+00
  PKER_SACCRG( 23, 35) =  0.328367E+00
  PKER_SACCRG( 23, 36) =  0.320537E+00
  PKER_SACCRG( 23, 37) =  0.000000E+00
  PKER_SACCRG( 23, 38) =  0.000000E+00
  PKER_SACCRG( 23, 39) =  0.000000E+00
  PKER_SACCRG( 23, 40) =  0.000000E+00
  PKER_SACCRG( 24,  1) =  0.000000E+00
  PKER_SACCRG( 24,  2) =  0.000000E+00
  PKER_SACCRG( 24,  3) =  0.000000E+00
  PKER_SACCRG( 24,  4) =  0.000000E+00
  PKER_SACCRG( 24,  5) =  0.000000E+00
  PKER_SACCRG( 24,  6) =  0.000000E+00
  PKER_SACCRG( 24,  7) =  0.000000E+00
  PKER_SACCRG( 24,  8) =  0.794744E+00
  PKER_SACCRG( 24,  9) =  0.740984E+00
  PKER_SACCRG( 24, 10) =  0.633801E-01
  PKER_SACCRG( 24, 11) =  0.777556E+00
  PKER_SACCRG( 24, 12) =  0.804576E+00
  PKER_SACCRG( 24, 13) =  0.807152E+00
  PKER_SACCRG( 24, 14) =  0.796079E+00
  PKER_SACCRG( 24, 15) =  0.776533E+00
  PKER_SACCRG( 24, 16) =  0.775550E+00
  PKER_SACCRG( 24, 17) =  0.760004E+00
  PKER_SACCRG( 24, 18) =  0.746329E+00
  PKER_SACCRG( 24, 19) =  0.719365E+00
  PKER_SACCRG( 24, 20) =  0.691070E+00
  PKER_SACCRG( 24, 21) =  0.651450E+00
  PKER_SACCRG( 24, 22) =  0.608840E+00
  PKER_SACCRG( 24, 23) =  0.567932E+00
  PKER_SACCRG( 24, 24) =  0.527565E+00
  PKER_SACCRG( 24, 25) =  0.491917E+00
  PKER_SACCRG( 24, 26) =  0.459798E+00
  PKER_SACCRG( 24, 27) =  0.430691E+00
  PKER_SACCRG( 24, 28) =  0.410367E+00
  PKER_SACCRG( 24, 29) =  0.392372E+00
  PKER_SACCRG( 24, 30) =  0.375227E+00
  PKER_SACCRG( 24, 31) =  0.364178E+00
  PKER_SACCRG( 24, 32) =  0.357015E+00
  PKER_SACCRG( 24, 33) =  0.351637E+00
  PKER_SACCRG( 24, 34) =  0.349989E+00
  PKER_SACCRG( 24, 35) =  0.345989E+00
  PKER_SACCRG( 24, 36) =  0.338276E+00
  PKER_SACCRG( 24, 37) =  0.000000E+00
  PKER_SACCRG( 24, 38) =  0.000000E+00
  PKER_SACCRG( 24, 39) =  0.000000E+00
  PKER_SACCRG( 24, 40) =  0.000000E+00
  PKER_SACCRG( 25,  1) =  0.000000E+00
  PKER_SACCRG( 25,  2) =  0.000000E+00
  PKER_SACCRG( 25,  3) =  0.000000E+00
  PKER_SACCRG( 25,  4) =  0.000000E+00
  PKER_SACCRG( 25,  5) =  0.000000E+00
  PKER_SACCRG( 25,  6) =  0.000000E+00
  PKER_SACCRG( 25,  7) =  0.000000E+00
  PKER_SACCRG( 25,  8) =  0.807563E+00
  PKER_SACCRG( 25,  9) =  0.753833E+00
  PKER_SACCRG( 25, 10) =  0.643394E-01
  PKER_SACCRG( 25, 11) =  0.790417E+00
  PKER_SACCRG( 25, 12) =  0.817430E+00
  PKER_SACCRG( 25, 13) =  0.820012E+00
  PKER_SACCRG( 25, 14) =  0.808951E+00
  PKER_SACCRG( 25, 15) =  0.789425E+00
  PKER_SACCRG( 25, 16) =  0.788455E+00
  PKER_SACCRG( 25, 17) =  0.772937E+00
  PKER_SACCRG( 25, 18) =  0.759299E+00
  PKER_SACCRG( 25, 19) =  0.732392E+00
  PKER_SACCRG( 25, 20) =  0.704169E+00
  PKER_SACCRG( 25, 21) =  0.664647E+00
  PKER_SACCRG( 25, 22) =  0.622123E+00
  PKER_SACCRG( 25, 23) =  0.581352E+00
  PKER_SACCRG( 25, 24) =  0.541148E+00
  PKER_SACCRG( 25, 25) =  0.505619E+00
  PKER_SACCRG( 25, 26) =  0.473619E+00
  PKER_SACCRG( 25, 27) =  0.444639E+00
  PKER_SACCRG( 25, 28) =  0.424336E+00
  PKER_SACCRG( 25, 29) =  0.406394E+00
  PKER_SACCRG( 25, 30) =  0.389340E+00
  PKER_SACCRG( 25, 31) =  0.378332E+00
  PKER_SACCRG( 25, 32) =  0.371193E+00
  PKER_SACCRG( 25, 33) =  0.365840E+00
  PKER_SACCRG( 25, 34) =  0.364185E+00
  PKER_SACCRG( 25, 35) =  0.360213E+00
  PKER_SACCRG( 25, 36) =  0.352580E+00
  PKER_SACCRG( 25, 37) =  0.000000E+00
  PKER_SACCRG( 25, 38) =  0.000000E+00
  PKER_SACCRG( 25, 39) =  0.000000E+00
  PKER_SACCRG( 25, 40) =  0.000000E+00
  PKER_SACCRG( 26,  1) =  0.000000E+00
  PKER_SACCRG( 26,  2) =  0.000000E+00
  PKER_SACCRG( 26,  3) =  0.000000E+00
  PKER_SACCRG( 26,  4) =  0.000000E+00
  PKER_SACCRG( 26,  5) =  0.000000E+00
  PKER_SACCRG( 26,  6) =  0.000000E+00
  PKER_SACCRG( 26,  7) =  0.000000E+00
  PKER_SACCRG( 26,  8) =  0.818155E+00
  PKER_SACCRG( 26,  9) =  0.764445E+00
  PKER_SACCRG( 26, 10) =  0.652138E-01
  PKER_SACCRG( 26, 11) =  0.801042E+00
  PKER_SACCRG( 26, 12) =  0.828051E+00
  PKER_SACCRG( 26, 13) =  0.830636E+00
  PKER_SACCRG( 26, 14) =  0.819585E+00
  PKER_SACCRG( 26, 15) =  0.800072E+00
  PKER_SACCRG( 26, 16) =  0.799113E+00
  PKER_SACCRG( 26, 17) =  0.783616E+00
  PKER_SACCRG( 26, 18) =  0.770006E+00
  PKER_SACCRG( 26, 19) =  0.743140E+00
  PKER_SACCRG( 26, 20) =  0.714971E+00
  PKER_SACCRG( 26, 21) =  0.675519E+00
  PKER_SACCRG( 26, 22) =  0.633061E+00
  PKER_SACCRG( 26, 23) =  0.592381E+00
  PKER_SACCRG( 26, 24) =  0.552293E+00
  PKER_SACCRG( 26, 25) =  0.516845E+00
  PKER_SACCRG( 26, 26) =  0.484922E+00
  PKER_SACCRG( 26, 27) =  0.456026E+00
  PKER_SACCRG( 26, 28) =  0.435725E+00
  PKER_SACCRG( 26, 29) =  0.417811E+00
  PKER_SACCRG( 26, 30) =  0.400812E+00
  PKER_SACCRG( 26, 31) =  0.389826E+00
  PKER_SACCRG( 26, 32) =  0.382698E+00
  PKER_SACCRG( 26, 33) =  0.377358E+00
  PKER_SACCRG( 26, 34) =  0.375696E+00
  PKER_SACCRG( 26, 35) =  0.371742E+00
  PKER_SACCRG( 26, 36) =  0.364161E+00
  PKER_SACCRG( 26, 37) =  0.000000E+00
  PKER_SACCRG( 26, 38) =  0.000000E+00
  PKER_SACCRG( 26, 39) =  0.000000E+00
  PKER_SACCRG( 26, 40) =  0.000000E+00
  PKER_SACCRG( 27,  1) =  0.000000E+00
  PKER_SACCRG( 27,  2) =  0.000000E+00
  PKER_SACCRG( 27,  3) =  0.000000E+00
  PKER_SACCRG( 27,  4) =  0.000000E+00
  PKER_SACCRG( 27,  5) =  0.000000E+00
  PKER_SACCRG( 27,  6) =  0.000000E+00
  PKER_SACCRG( 27,  7) =  0.000000E+00
  PKER_SACCRG( 27,  8) =  0.826912E+00
  PKER_SACCRG( 27,  9) =  0.773214E+00
  PKER_SACCRG( 27, 10) =  0.722825E+00
  PKER_SACCRG( 27, 11) =  0.809822E+00
  PKER_SACCRG( 27, 12) =  0.836829E+00
  PKER_SACCRG( 27, 13) =  0.839417E+00
  PKER_SACCRG( 27, 14) =  0.828373E+00
  PKER_SACCRG( 27, 15) =  0.808870E+00
  PKER_SACCRG( 27, 16) =  0.807920E+00
  PKER_SACCRG( 27, 17) =  0.792438E+00
  PKER_SACCRG( 27, 18) =  0.778848E+00
  PKER_SACCRG( 27, 19) =  0.752014E+00
  PKER_SACCRG( 27, 20) =  0.723884E+00
  PKER_SACCRG( 27, 21) =  0.684484E+00
  PKER_SACCRG( 27, 22) =  0.642077E+00
  PKER_SACCRG( 27, 23) =  0.601458E+00
  PKER_SACCRG( 27, 24) =  0.561451E+00
  PKER_SACCRG( 27, 25) =  0.526058E+00
  PKER_SACCRG( 27, 26) =  0.494186E+00
  PKER_SACCRG( 27, 27) =  0.465344E+00
  PKER_SACCRG( 27, 28) =  0.445036E+00
  PKER_SACCRG( 27, 29) =  0.427133E+00
  PKER_SACCRG( 27, 30) =  0.410167E+00
  PKER_SACCRG( 27, 31) =  0.399191E+00
  PKER_SACCRG( 27, 32) =  0.392065E+00
  PKER_SACCRG( 27, 33) =  0.386731E+00
  PKER_SACCRG( 27, 34) =  0.385063E+00
  PKER_SACCRG( 27, 35) =  0.381119E+00
  PKER_SACCRG( 27, 36) =  0.373572E+00
  PKER_SACCRG( 27, 37) =  0.000000E+00
  PKER_SACCRG( 27, 38) =  0.000000E+00
  PKER_SACCRG( 27, 39) =  0.000000E+00
  PKER_SACCRG( 27, 40) =  0.000000E+00
  PKER_SACCRG( 28,  1) =  0.000000E+00
  PKER_SACCRG( 28,  2) =  0.000000E+00
  PKER_SACCRG( 28,  3) =  0.000000E+00
  PKER_SACCRG( 28,  4) =  0.000000E+00
  PKER_SACCRG( 28,  5) =  0.000000E+00
  PKER_SACCRG( 28,  6) =  0.000000E+00
  PKER_SACCRG( 28,  7) =  0.000000E+00
  PKER_SACCRG( 28,  8) =  0.834152E+00
  PKER_SACCRG( 28,  9) =  0.780463E+00
  PKER_SACCRG( 28, 10) =  0.730085E+00
  PKER_SACCRG( 28, 11) =  0.817081E+00
  PKER_SACCRG( 28, 12) =  0.844087E+00
  PKER_SACCRG( 28, 13) =  0.846678E+00
  PKER_SACCRG( 28, 14) =  0.835638E+00
  PKER_SACCRG( 28, 15) =  0.816143E+00
  PKER_SACCRG( 28, 16) =  0.815199E+00
  PKER_SACCRG( 28, 17) =  0.799728E+00
  PKER_SACCRG( 28, 18) =  0.786155E+00
  PKER_SACCRG( 28, 19) =  0.759343E+00
  PKER_SACCRG( 28, 20) =  0.731242E+00
  PKER_SACCRG( 28, 21) =  0.691881E+00
  PKER_SACCRG( 28, 22) =  0.649512E+00
  PKER_SACCRG( 28, 23) =  0.608935E+00
  PKER_SACCRG( 28, 24) =  0.568988E+00
  PKER_SACCRG( 28, 25) =  0.533631E+00
  PKER_SACCRG( 28, 26) =  0.501792E+00
  PKER_SACCRG( 28, 27) =  0.472984E+00
  PKER_SACCRG( 28, 28) =  0.452665E+00
  PKER_SACCRG( 28, 29) =  0.434765E+00
  PKER_SACCRG( 28, 30) =  0.417816E+00
  PKER_SACCRG( 28, 31) =  0.406842E+00
  PKER_SACCRG( 28, 32) =  0.399715E+00
  PKER_SACCRG( 28, 33) =  0.394383E+00
  PKER_SACCRG( 28, 34) =  0.392708E+00
  PKER_SACCRG( 28, 35) =  0.388770E+00
  PKER_SACCRG( 28, 36) =  0.381244E+00
  PKER_SACCRG( 28, 37) =  0.000000E+00
  PKER_SACCRG( 28, 38) =  0.000000E+00
  PKER_SACCRG( 28, 39) =  0.000000E+00
  PKER_SACCRG( 28, 40) =  0.000000E+00
  PKER_SACCRG( 29,  1) =  0.000000E+00
  PKER_SACCRG( 29,  2) =  0.000000E+00
  PKER_SACCRG( 29,  3) =  0.000000E+00
  PKER_SACCRG( 29,  4) =  0.000000E+00
  PKER_SACCRG( 29,  5) =  0.000000E+00
  PKER_SACCRG( 29,  6) =  0.000000E+00
  PKER_SACCRG( 29,  7) =  0.000000E+00
  PKER_SACCRG( 29,  8) =  0.840140E+00
  PKER_SACCRG( 29,  9) =  0.786456E+00
  PKER_SACCRG( 29, 10) =  0.736085E+00
  PKER_SACCRG( 29, 11) =  0.823083E+00
  PKER_SACCRG( 29, 12) =  0.850089E+00
  PKER_SACCRG( 29, 13) =  0.852682E+00
  PKER_SACCRG( 29, 14) =  0.841646E+00
  PKER_SACCRG( 29, 15) =  0.822156E+00
  PKER_SACCRG( 29, 16) =  0.821217E+00
  PKER_SACCRG( 29, 17) =  0.805755E+00
  PKER_SACCRG( 29, 18) =  0.792194E+00
  PKER_SACCRG( 29, 19) =  0.765399E+00
  PKER_SACCRG( 29, 20) =  0.737321E+00
  PKER_SACCRG( 29, 21) =  0.697987E+00
  PKER_SACCRG( 29, 22) =  0.655647E+00
  PKER_SACCRG( 29, 23) =  0.615100E+00
  PKER_SACCRG( 29, 24) =  0.575195E+00
  PKER_SACCRG( 29, 25) =  0.539863E+00
  PKER_SACCRG( 29, 26) =  0.508047E+00
  PKER_SACCRG( 29, 27) =  0.479260E+00
  PKER_SACCRG( 29, 28) =  0.458928E+00
  PKER_SACCRG( 29, 29) =  0.441026E+00
  PKER_SACCRG( 29, 30) =  0.424085E+00
  PKER_SACCRG( 29, 31) =  0.413109E+00
  PKER_SACCRG( 29, 32) =  0.405979E+00
  PKER_SACCRG( 29, 33) =  0.400646E+00
  PKER_SACCRG( 29, 34) =  0.398965E+00
  PKER_SACCRG( 29, 35) =  0.395030E+00
  PKER_SACCRG( 29, 36) =  0.387518E+00
  PKER_SACCRG( 29, 37) =  0.000000E+00
  PKER_SACCRG( 29, 38) =  0.000000E+00
  PKER_SACCRG( 29, 39) =  0.000000E+00
  PKER_SACCRG( 29, 40) =  0.000000E+00
  PKER_SACCRG( 30,  1) =  0.000000E+00
  PKER_SACCRG( 30,  2) =  0.000000E+00
  PKER_SACCRG( 30,  3) =  0.000000E+00
  PKER_SACCRG( 30,  4) =  0.000000E+00
  PKER_SACCRG( 30,  5) =  0.000000E+00
  PKER_SACCRG( 30,  6) =  0.000000E+00
  PKER_SACCRG( 30,  7) =  0.000000E+00
  PKER_SACCRG( 30,  8) =  0.845094E+00
  PKER_SACCRG( 30,  9) =  0.791414E+00
  PKER_SACCRG( 30, 10) =  0.741047E+00
  PKER_SACCRG( 30, 11) =  0.828048E+00
  PKER_SACCRG( 30, 12) =  0.855054E+00
  PKER_SACCRG( 30, 13) =  0.857648E+00
  PKER_SACCRG( 30, 14) =  0.846615E+00
  PKER_SACCRG( 30, 15) =  0.827129E+00
  PKER_SACCRG( 30, 16) =  0.826194E+00
  PKER_SACCRG( 30, 17) =  0.810738E+00
  PKER_SACCRG( 30, 18) =  0.797187E+00
  PKER_SACCRG( 30, 19) =  0.770405E+00
  PKER_SACCRG( 30, 20) =  0.742343E+00
  PKER_SACCRG( 30, 21) =  0.703031E+00
  PKER_SACCRG( 30, 22) =  0.660711E+00
  PKER_SACCRG( 30, 23) =  0.620186E+00
  PKER_SACCRG( 30, 24) =  0.580313E+00
  PKER_SACCRG( 30, 25) =  0.544997E+00
  PKER_SACCRG( 30, 26) =  0.513195E+00
  PKER_SACCRG( 30, 27) =  0.484422E+00
  PKER_SACCRG( 30, 28) =  0.464077E+00
  PKER_SACCRG( 30, 29) =  0.446170E+00
  PKER_SACCRG( 30, 30) =  0.429233E+00
  PKER_SACCRG( 30, 31) =  0.418253E+00
  PKER_SACCRG( 30, 32) =  0.411117E+00
  PKER_SACCRG( 30, 33) =  0.405783E+00
  PKER_SACCRG( 30, 34) =  0.404097E+00
  PKER_SACCRG( 30, 35) =  0.400163E+00
  PKER_SACCRG( 30, 36) =  0.392659E+00
  PKER_SACCRG( 30, 37) =  0.000000E+00
  PKER_SACCRG( 30, 38) =  0.000000E+00
  PKER_SACCRG( 30, 39) =  0.000000E+00
  PKER_SACCRG( 30, 40) =  0.000000E+00
  PKER_SACCRG( 31,  1) =  0.000000E+00
  PKER_SACCRG( 31,  2) =  0.000000E+00
  PKER_SACCRG( 31,  3) =  0.000000E+00
  PKER_SACCRG( 31,  4) =  0.000000E+00
  PKER_SACCRG( 31,  5) =  0.000000E+00
  PKER_SACCRG( 31,  6) =  0.000000E+00
  PKER_SACCRG( 31,  7) =  0.000000E+00
  PKER_SACCRG( 31,  8) =  0.849193E+00
  PKER_SACCRG( 31,  9) =  0.795515E+00
  PKER_SACCRG( 31, 10) =  0.745151E+00
  PKER_SACCRG( 31, 11) =  0.832155E+00
  PKER_SACCRG( 31, 12) =  0.859161E+00
  PKER_SACCRG( 31, 13) =  0.861757E+00
  PKER_SACCRG( 31, 14) =  0.850726E+00
  PKER_SACCRG( 31, 15) =  0.831243E+00
  PKER_SACCRG( 31, 16) =  0.830311E+00
  PKER_SACCRG( 31, 17) =  0.814860E+00
  PKER_SACCRG( 31, 18) =  0.801315E+00
  PKER_SACCRG( 31, 19) =  0.774544E+00
  PKER_SACCRG( 31, 20) =  0.746495E+00
  PKER_SACCRG( 31, 21) =  0.707199E+00
  PKER_SACCRG( 31, 22) =  0.665314E+00
  PKER_SACCRG( 31, 23) =  0.624385E+00
  PKER_SACCRG( 31, 24) =  0.584535E+00
  PKER_SACCRG( 31, 25) =  0.549231E+00
  PKER_SACCRG( 31, 26) =  0.517437E+00
  PKER_SACCRG( 31, 27) =  0.488673E+00
  PKER_SACCRG( 31, 28) =  0.468316E+00
  PKER_SACCRG( 31, 29) =  0.450402E+00
  PKER_SACCRG( 31, 30) =  0.433466E+00
  PKER_SACCRG( 31, 31) =  0.422481E+00
  PKER_SACCRG( 31, 32) =  0.415341E+00
  PKER_SACCRG( 31, 33) =  0.410003E+00
  PKER_SACCRG( 31, 34) =  0.408314E+00
  PKER_SACCRG( 31, 35) =  0.404379E+00
  PKER_SACCRG( 31, 36) =  0.396881E+00
  PKER_SACCRG( 31, 37) =  0.000000E+00
  PKER_SACCRG( 31, 38) =  0.000000E+00
  PKER_SACCRG( 31, 39) =  0.000000E+00
  PKER_SACCRG( 31, 40) =  0.000000E+00
  PKER_SACCRG( 32,  1) =  0.000000E+00
  PKER_SACCRG( 32,  2) =  0.000000E+00
  PKER_SACCRG( 32,  3) =  0.000000E+00
  PKER_SACCRG( 32,  4) =  0.000000E+00
  PKER_SACCRG( 32,  5) =  0.000000E+00
  PKER_SACCRG( 32,  6) =  0.000000E+00
  PKER_SACCRG( 32,  7) =  0.000000E+00
  PKER_SACCRG( 32,  8) =  0.852585E+00
  PKER_SACCRG( 32,  9) =  0.798908E+00
  PKER_SACCRG( 32, 10) =  0.748546E+00
  PKER_SACCRG( 32, 11) =  0.835553E+00
  PKER_SACCRG( 32, 12) =  0.862560E+00
  PKER_SACCRG( 32, 13) =  0.865156E+00
  PKER_SACCRG( 32, 14) =  0.854127E+00
  PKER_SACCRG( 32, 15) =  0.834646E+00
  PKER_SACCRG( 32, 16) =  0.833717E+00
  PKER_SACCRG( 32, 17) =  0.818269E+00
  PKER_SACCRG( 32, 18) =  0.804730E+00
  PKER_SACCRG( 32, 19) =  0.777966E+00
  PKER_SACCRG( 32, 20) =  0.749927E+00
  PKER_SACCRG( 32, 21) =  0.710643E+00
  PKER_SACCRG( 32, 22) =  0.668772E+00
  PKER_SACCRG( 32, 23) =  0.627853E+00
  PKER_SACCRG( 32, 24) =  0.588019E+00
  PKER_SACCRG( 32, 25) =  0.552723E+00
  PKER_SACCRG( 32, 26) =  0.520936E+00
  PKER_SACCRG( 32, 27) =  0.492177E+00
  PKER_SACCRG( 32, 28) =  0.471809E+00
  PKER_SACCRG( 32, 29) =  0.453889E+00
  PKER_SACCRG( 32, 30) =  0.436952E+00
  PKER_SACCRG( 32, 31) =  0.425962E+00
  PKER_SACCRG( 32, 32) =  0.418817E+00
  PKER_SACCRG( 32, 33) =  0.413477E+00
  PKER_SACCRG( 32, 34) =  0.411784E+00
  PKER_SACCRG( 32, 35) =  0.407849E+00
  PKER_SACCRG( 32, 36) =  0.400353E+00
  PKER_SACCRG( 32, 37) =  0.000000E+00
  PKER_SACCRG( 32, 38) =  0.000000E+00
  PKER_SACCRG( 32, 39) =  0.000000E+00
  PKER_SACCRG( 32, 40) =  0.000000E+00
  PKER_SACCRG( 33,  1) =  0.000000E+00
  PKER_SACCRG( 33,  2) =  0.000000E+00
  PKER_SACCRG( 33,  3) =  0.000000E+00
  PKER_SACCRG( 33,  4) =  0.000000E+00
  PKER_SACCRG( 33,  5) =  0.000000E+00
  PKER_SACCRG( 33,  6) =  0.000000E+00
  PKER_SACCRG( 33,  7) =  0.000000E+00
  PKER_SACCRG( 33,  8) =  0.855391E+00
  PKER_SACCRG( 33,  9) =  0.801716E+00
  PKER_SACCRG( 33, 10) =  0.751355E+00
  PKER_SACCRG( 33, 11) =  0.838364E+00
  PKER_SACCRG( 33, 12) =  0.865372E+00
  PKER_SACCRG( 33, 13) =  0.867969E+00
  PKER_SACCRG( 33, 14) =  0.856941E+00
  PKER_SACCRG( 33, 15) =  0.837462E+00
  PKER_SACCRG( 33, 16) =  0.836534E+00
  PKER_SACCRG( 33, 17) =  0.821090E+00
  PKER_SACCRG( 33, 18) =  0.807555E+00
  PKER_SACCRG( 33, 19) =  0.780797E+00
  PKER_SACCRG( 33, 20) =  0.752765E+00
  PKER_SACCRG( 33, 21) =  0.713491E+00
  PKER_SACCRG( 33, 22) =  0.671630E+00
  PKER_SACCRG( 33, 23) =  0.630717E+00
  PKER_SACCRG( 33, 24) =  0.590897E+00
  PKER_SACCRG( 33, 25) =  0.555606E+00
  PKER_SACCRG( 33, 26) =  0.523823E+00
  PKER_SACCRG( 33, 27) =  0.495067E+00
  PKER_SACCRG( 33, 28) =  0.474689E+00
  PKER_SACCRG( 33, 29) =  0.456764E+00
  PKER_SACCRG( 33, 30) =  0.439825E+00
  PKER_SACCRG( 33, 31) =  0.428830E+00
  PKER_SACCRG( 33, 32) =  0.421681E+00
  PKER_SACCRG( 33, 33) =  0.416338E+00
  PKER_SACCRG( 33, 34) =  0.414643E+00
  PKER_SACCRG( 33, 35) =  0.410707E+00
  PKER_SACCRG( 33, 36) =  0.403213E+00
  PKER_SACCRG( 33, 37) =  0.000000E+00
  PKER_SACCRG( 33, 38) =  0.000000E+00
  PKER_SACCRG( 33, 39) =  0.000000E+00
  PKER_SACCRG( 33, 40) =  0.000000E+00
  PKER_SACCRG( 34,  1) =  0.000000E+00
  PKER_SACCRG( 34,  2) =  0.000000E+00
  PKER_SACCRG( 34,  3) =  0.000000E+00
  PKER_SACCRG( 34,  4) =  0.000000E+00
  PKER_SACCRG( 34,  5) =  0.000000E+00
  PKER_SACCRG( 34,  6) =  0.000000E+00
  PKER_SACCRG( 34,  7) =  0.000000E+00
  PKER_SACCRG( 34,  8) =  0.857714E+00
  PKER_SACCRG( 34,  9) =  0.804039E+00
  PKER_SACCRG( 34, 10) =  0.753680E+00
  PKER_SACCRG( 34, 11) =  0.840691E+00
  PKER_SACCRG( 34, 12) =  0.867699E+00
  PKER_SACCRG( 34, 13) =  0.870297E+00
  PKER_SACCRG( 34, 14) =  0.859270E+00
  PKER_SACCRG( 34, 15) =  0.839792E+00
  PKER_SACCRG( 34, 16) =  0.838866E+00
  PKER_SACCRG( 34, 17) =  0.823423E+00
  PKER_SACCRG( 34, 18) =  0.809892E+00
  PKER_SACCRG( 34, 19) =  0.783139E+00
  PKER_SACCRG( 34, 20) =  0.755113E+00
  PKER_SACCRG( 34, 21) =  0.715845E+00
  PKER_SACCRG( 34, 22) =  0.673992E+00
  PKER_SACCRG( 34, 23) =  0.633085E+00
  PKER_SACCRG( 34, 24) =  0.593274E+00
  PKER_SACCRG( 34, 25) =  0.557987E+00
  PKER_SACCRG( 34, 26) =  0.526206E+00
  PKER_SACCRG( 34, 27) =  0.497452E+00
  PKER_SACCRG( 34, 28) =  0.477066E+00
  PKER_SACCRG( 34, 29) =  0.459136E+00
  PKER_SACCRG( 34, 30) =  0.442195E+00
  PKER_SACCRG( 34, 31) =  0.431196E+00
  PKER_SACCRG( 34, 32) =  0.424043E+00
  PKER_SACCRG( 34, 33) =  0.418698E+00
  PKER_SACCRG( 34, 34) =  0.417000E+00
  PKER_SACCRG( 34, 35) =  0.413064E+00
  PKER_SACCRG( 34, 36) =  0.405570E+00
  PKER_SACCRG( 34, 37) =  0.000000E+00
  PKER_SACCRG( 34, 38) =  0.000000E+00
  PKER_SACCRG( 34, 39) =  0.000000E+00
  PKER_SACCRG( 34, 40) =  0.000000E+00
  PKER_SACCRG( 35,  1) =  0.000000E+00
  PKER_SACCRG( 35,  2) =  0.000000E+00
  PKER_SACCRG( 35,  3) =  0.000000E+00
  PKER_SACCRG( 35,  4) =  0.000000E+00
  PKER_SACCRG( 35,  5) =  0.000000E+00
  PKER_SACCRG( 35,  6) =  0.000000E+00
  PKER_SACCRG( 35,  7) =  0.000000E+00
  PKER_SACCRG( 35,  8) =  0.859637E+00
  PKER_SACCRG( 35,  9) =  0.805962E+00
  PKER_SACCRG( 35, 10) =  0.755603E+00
  PKER_SACCRG( 35, 11) =  0.842616E+00
  PKER_SACCRG( 35, 12) =  0.869625E+00
  PKER_SACCRG( 35, 13) =  0.872223E+00
  PKER_SACCRG( 35, 14) =  0.861197E+00
  PKER_SACCRG( 35, 15) =  0.841720E+00
  PKER_SACCRG( 35, 16) =  0.840795E+00
  PKER_SACCRG( 35, 17) =  0.825354E+00
  PKER_SACCRG( 35, 18) =  0.811826E+00
  PKER_SACCRG( 35, 19) =  0.785076E+00
  PKER_SACCRG( 35, 20) =  0.757054E+00
  PKER_SACCRG( 35, 21) =  0.717792E+00
  PKER_SACCRG( 35, 22) =  0.675945E+00
  PKER_SACCRG( 35, 23) =  0.635042E+00
  PKER_SACCRG( 35, 24) =  0.595238E+00
  PKER_SACCRG( 35, 25) =  0.559954E+00
  PKER_SACCRG( 35, 26) =  0.528174E+00
  PKER_SACCRG( 35, 27) =  0.499421E+00
  PKER_SACCRG( 35, 28) =  0.479029E+00
  PKER_SACCRG( 35, 29) =  0.461094E+00
  PKER_SACCRG( 35, 30) =  0.444151E+00
  PKER_SACCRG( 35, 31) =  0.433148E+00
  PKER_SACCRG( 35, 32) =  0.425993E+00
  PKER_SACCRG( 35, 33) =  0.420646E+00
  PKER_SACCRG( 35, 34) =  0.418946E+00
  PKER_SACCRG( 35, 35) =  0.415009E+00
  PKER_SACCRG( 35, 36) =  0.407516E+00
  PKER_SACCRG( 35, 37) =  0.000000E+00
  PKER_SACCRG( 35, 38) =  0.000000E+00
  PKER_SACCRG( 35, 39) =  0.000000E+00
  PKER_SACCRG( 35, 40) =  0.000000E+00
  PKER_SACCRG( 36,  1) =  0.000000E+00
  PKER_SACCRG( 36,  2) =  0.000000E+00
  PKER_SACCRG( 36,  3) =  0.000000E+00
  PKER_SACCRG( 36,  4) =  0.000000E+00
  PKER_SACCRG( 36,  5) =  0.000000E+00
  PKER_SACCRG( 36,  6) =  0.000000E+00
  PKER_SACCRG( 36,  7) =  0.000000E+00
  PKER_SACCRG( 36,  8) =  0.861228E+00
  PKER_SACCRG( 36,  9) =  0.807554E+00
  PKER_SACCRG( 36, 10) =  0.757195E+00
  PKER_SACCRG( 36, 11) =  0.844210E+00
  PKER_SACCRG( 36, 12) =  0.871219E+00
  PKER_SACCRG( 36, 13) =  0.873817E+00
  PKER_SACCRG( 36, 14) =  0.862791E+00
  PKER_SACCRG( 36, 15) =  0.843315E+00
  PKER_SACCRG( 36, 16) =  0.842391E+00
  PKER_SACCRG( 36, 17) =  0.826952E+00
  PKER_SACCRG( 36, 18) =  0.813425E+00
  PKER_SACCRG( 36, 19) =  0.786678E+00
  PKER_SACCRG( 36, 20) =  0.758660E+00
  PKER_SACCRG( 36, 21) =  0.719402E+00
  PKER_SACCRG( 36, 22) =  0.677560E+00
  PKER_SACCRG( 36, 23) =  0.636660E+00
  PKER_SACCRG( 36, 24) =  0.596861E+00
  PKER_SACCRG( 36, 25) =  0.561579E+00
  PKER_SACCRG( 36, 26) =  0.529800E+00
  PKER_SACCRG( 36, 27) =  0.501048E+00
  PKER_SACCRG( 36, 28) =  0.480650E+00
  PKER_SACCRG( 36, 29) =  0.462712E+00
  PKER_SACCRG( 36, 30) =  0.445767E+00
  PKER_SACCRG( 36, 31) =  0.434761E+00
  PKER_SACCRG( 36, 32) =  0.427602E+00
  PKER_SACCRG( 36, 33) =  0.422254E+00
  PKER_SACCRG( 36, 34) =  0.420553E+00
  PKER_SACCRG( 36, 35) =  0.416615E+00
  PKER_SACCRG( 36, 36) =  0.409122E+00
  PKER_SACCRG( 36, 37) =  0.000000E+00
  PKER_SACCRG( 36, 38) =  0.000000E+00
  PKER_SACCRG( 36, 39) =  0.000000E+00
  PKER_SACCRG( 36, 40) =  0.000000E+00
  PKER_SACCRG( 37,  1) =  0.000000E+00
  PKER_SACCRG( 37,  2) =  0.000000E+00
  PKER_SACCRG( 37,  3) =  0.000000E+00
  PKER_SACCRG( 37,  4) =  0.000000E+00
  PKER_SACCRG( 37,  5) =  0.000000E+00
  PKER_SACCRG( 37,  6) =  0.000000E+00
  PKER_SACCRG( 37,  7) =  0.000000E+00
  PKER_SACCRG( 37,  8) =  0.862545E+00
  PKER_SACCRG( 37,  9) =  0.808871E+00
  PKER_SACCRG( 37, 10) =  0.758513E+00
  PKER_SACCRG( 37, 11) =  0.845529E+00
  PKER_SACCRG( 37, 12) =  0.872538E+00
  PKER_SACCRG( 37, 13) =  0.875137E+00
  PKER_SACCRG( 37, 14) =  0.864111E+00
  PKER_SACCRG( 37, 15) =  0.844636E+00
  PKER_SACCRG( 37, 16) =  0.843713E+00
  PKER_SACCRG( 37, 17) =  0.828275E+00
  PKER_SACCRG( 37, 18) =  0.814749E+00
  PKER_SACCRG( 37, 19) =  0.788004E+00
  PKER_SACCRG( 37, 20) =  0.759989E+00
  PKER_SACCRG( 37, 21) =  0.720734E+00
  PKER_SACCRG( 37, 22) =  0.678896E+00
  PKER_SACCRG( 37, 23) =  0.637998E+00
  PKER_SACCRG( 37, 24) =  0.598203E+00
  PKER_SACCRG( 37, 25) =  0.562923E+00
  PKER_SACCRG( 37, 26) =  0.531144E+00
  PKER_SACCRG( 37, 27) =  0.502392E+00
  PKER_SACCRG( 37, 28) =  0.481990E+00
  PKER_SACCRG( 37, 29) =  0.464049E+00
  PKER_SACCRG( 37, 30) =  0.447102E+00
  PKER_SACCRG( 37, 31) =  0.436093E+00
  PKER_SACCRG( 37, 32) =  0.428933E+00
  PKER_SACCRG( 37, 33) =  0.423583E+00
  PKER_SACCRG( 37, 34) =  0.421881E+00
  PKER_SACCRG( 37, 35) =  0.417942E+00
  PKER_SACCRG( 37, 36) =  0.410449E+00
  PKER_SACCRG( 37, 37) =  0.000000E+00
  PKER_SACCRG( 37, 38) =  0.000000E+00
  PKER_SACCRG( 37, 39) =  0.000000E+00
  PKER_SACCRG( 37, 40) =  0.000000E+00
  PKER_SACCRG( 38,  1) =  0.000000E+00
  PKER_SACCRG( 38,  2) =  0.000000E+00
  PKER_SACCRG( 38,  3) =  0.000000E+00
  PKER_SACCRG( 38,  4) =  0.000000E+00
  PKER_SACCRG( 38,  5) =  0.000000E+00
  PKER_SACCRG( 38,  6) =  0.000000E+00
  PKER_SACCRG( 38,  7) =  0.000000E+00
  PKER_SACCRG( 38,  8) =  0.864084E+00
  PKER_SACCRG( 38,  9) =  0.810382E+00
  PKER_SACCRG( 38, 10) =  0.759998E+00
  PKER_SACCRG( 38, 11) =  0.847060E+00
  PKER_SACCRG( 38, 12) =  0.874083E+00
  PKER_SACCRG( 38, 13) =  0.876684E+00
  PKER_SACCRG( 38, 14) =  0.865653E+00
  PKER_SACCRG( 38, 15) =  0.846168E+00
  PKER_SACCRG( 38, 16) =  0.845245E+00
  PKER_SACCRG( 38, 17) =  0.829800E+00
  PKER_SACCRG( 38, 18) =  0.816269E+00
  PKER_SACCRG( 38, 19) =  0.789511E+00
  PKER_SACCRG( 38, 20) =  0.761484E+00
  PKER_SACCRG( 38, 21) =  0.722211E+00
  PKER_SACCRG( 38, 22) =  0.680354E+00
  PKER_SACCRG( 38, 23) =  0.639436E+00
  PKER_SACCRG( 38, 24) =  0.599624E+00
  PKER_SACCRG( 38, 25) =  0.564327E+00
  PKER_SACCRG( 38, 26) =  0.532532E+00
  PKER_SACCRG( 38, 27) =  0.503764E+00
  PKER_SACCRG( 38, 28) =  0.483348E+00
  PKER_SACCRG( 38, 29) =  0.465395E+00
  PKER_SACCRG( 38, 30) =  0.448438E+00
  PKER_SACCRG( 38, 31) =  0.437422E+00
  PKER_SACCRG( 38, 32) =  0.430256E+00
  PKER_SACCRG( 38, 33) =  0.424902E+00
  PKER_SACCRG( 38, 34) =  0.423198E+00
  PKER_SACCRG( 38, 35) =  0.419256E+00
  PKER_SACCRG( 38, 36) =  0.411759E+00
  PKER_SACCRG( 38, 37) =  0.000000E+00
  PKER_SACCRG( 38, 38) =  0.000000E+00
  PKER_SACCRG( 38, 39) =  0.000000E+00
  PKER_SACCRG( 38, 40) =  0.000000E+00
  PKER_SACCRG( 39,  1) =  0.000000E+00
  PKER_SACCRG( 39,  2) =  0.000000E+00
  PKER_SACCRG( 39,  3) =  0.000000E+00
  PKER_SACCRG( 39,  4) =  0.000000E+00
  PKER_SACCRG( 39,  5) =  0.000000E+00
  PKER_SACCRG( 39,  6) =  0.000000E+00
  PKER_SACCRG( 39,  7) =  0.000000E+00
  PKER_SACCRG( 39,  8) =  0.864538E+00
  PKER_SACCRG( 39,  9) =  0.810864E+00
  PKER_SACCRG( 39, 10) =  0.760506E+00
  PKER_SACCRG( 39, 11) =  0.847524E+00
  PKER_SACCRG( 39, 12) =  0.874534E+00
  PKER_SACCRG( 39, 13) =  0.877133E+00
  PKER_SACCRG( 39, 14) =  0.866108E+00
  PKER_SACCRG( 39, 15) =  0.846633E+00
  PKER_SACCRG( 39, 16) =  0.845711E+00
  PKER_SACCRG( 39, 17) =  0.830275E+00
  PKER_SACCRG( 39, 18) =  0.816752E+00
  PKER_SACCRG( 39, 19) =  0.790009E+00
  PKER_SACCRG( 39, 20) =  0.761998E+00
  PKER_SACCRG( 39, 21) =  0.722748E+00
  PKER_SACCRG( 39, 22) =  0.680914E+00
  PKER_SACCRG( 39, 23) =  0.640019E+00
  PKER_SACCRG( 39, 24) =  0.600230E+00
  PKER_SACCRG( 39, 25) =  0.564952E+00
  PKER_SACCRG( 39, 26) =  0.533174E+00
  PKER_SACCRG( 39, 27) =  0.504421E+00
  PKER_SACCRG( 39, 28) =  0.484013E+00
  PKER_SACCRG( 39, 29) =  0.466067E+00
  PKER_SACCRG( 39, 30) =  0.449117E+00
  PKER_SACCRG( 39, 31) =  0.438105E+00
  PKER_SACCRG( 39, 32) =  0.430941E+00
  PKER_SACCRG( 39, 33) =  0.425589E+00
  PKER_SACCRG( 39, 34) =  0.423885E+00
  PKER_SACCRG( 39, 35) =  0.419946E+00
  PKER_SACCRG( 39, 36) =  0.412452E+00
  PKER_SACCRG( 39, 37) =  0.000000E+00
  PKER_SACCRG( 39, 38) =  0.000000E+00
  PKER_SACCRG( 39, 39) =  0.000000E+00
  PKER_SACCRG( 39, 40) =  0.000000E+00
  PKER_SACCRG( 40,  1) =  0.000000E+00
  PKER_SACCRG( 40,  2) =  0.000000E+00
  PKER_SACCRG( 40,  3) =  0.000000E+00
  PKER_SACCRG( 40,  4) =  0.000000E+00
  PKER_SACCRG( 40,  5) =  0.000000E+00
  PKER_SACCRG( 40,  6) =  0.000000E+00
  PKER_SACCRG( 40,  7) =  0.000000E+00
  PKER_SACCRG( 40,  8) =  0.865285E+00
  PKER_SACCRG( 40,  9) =  0.811611E+00
  PKER_SACCRG( 40, 10) =  0.761253E+00
  PKER_SACCRG( 40, 11) =  0.848272E+00
  PKER_SACCRG( 40, 12) =  0.875282E+00
  PKER_SACCRG( 40, 13) =  0.877881E+00
  PKER_SACCRG( 40, 14) =  0.866857E+00
  PKER_SACCRG( 40, 15) =  0.847382E+00
  PKER_SACCRG( 40, 16) =  0.846460E+00
  PKER_SACCRG( 40, 17) =  0.831024E+00
  PKER_SACCRG( 40, 18) =  0.817502E+00
  PKER_SACCRG( 40, 19) =  0.790761E+00
  PKER_SACCRG( 40, 20) =  0.762751E+00
  PKER_SACCRG( 40, 21) =  0.723502E+00
  PKER_SACCRG( 40, 22) =  0.681670E+00
  PKER_SACCRG( 40, 23) =  0.640776E+00
  PKER_SACCRG( 40, 24) =  0.600989E+00
  PKER_SACCRG( 40, 25) =  0.565711E+00
  PKER_SACCRG( 40, 26) =  0.533933E+00
  PKER_SACCRG( 40, 27) =  0.505180E+00
  PKER_SACCRG( 40, 28) =  0.484770E+00
  PKER_SACCRG( 40, 29) =  0.466822E+00
  PKER_SACCRG( 40, 30) =  0.449871E+00
  PKER_SACCRG( 40, 31) =  0.438858E+00
  PKER_SACCRG( 40, 32) =  0.431693E+00
  PKER_SACCRG( 40, 33) =  0.426340E+00
  PKER_SACCRG( 40, 34) =  0.424636E+00
  PKER_SACCRG( 40, 35) =  0.420696E+00
  PKER_SACCRG( 40, 36) =  0.413202E+00
  PKER_SACCRG( 40, 37) =  0.000000E+00
  PKER_SACCRG( 40, 38) =  0.000000E+00
  PKER_SACCRG( 40, 39) =  0.000000E+00
  PKER_SACCRG( 40, 40) =  0.000000E+00
END IF

!
END SUBROUTINE LIMA_READ_XKER_RACCS
